e: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2b139def0663f71134312f57d33d187a86175f70109921a7fd1fe7a09ceddb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72bb8d80cd656357cab6c325859c2fafc717cbad9b859f7ed101f1e9b312810d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c6380add704766eb8e2acbb113da488ccf4e305fbd72d52d26b445e7305ee6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9457289617ef8ea70287e5482455b016a8fbd47a63383924c72a974579b88514(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01b8997ccb6cc51ac5d53aae01e71e6299a405e7e9e1761a444019802b09585(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d93c94e1f978a1d7be3be708a92d0493a63bf88865684fda61fb98e7f426dd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94d35db09da6d64378dbecf35eac1f1eac37cbb6e7ca978f9f9b14e3a5c51cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b6907a72104229a6379800500097cd49e2726796c31e52c5121b724ef2dda1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9842864fd0c9a610a0c26b849faa79f41f69e0b1f001acb8151d8f77ca27bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f225e455ec84b6d48fc3d914cfa15a91aec909eb95c19752fb4eb0f409b058d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6937938940c86e870e26a21ae52ff592ce273357f00d7bf438d15819ad86b86e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3a4e372ae599f3ad48b16d6a24ec11c287294e08b07257a9f071669de91ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1687d74f5680f8210c1237ba77be03a97d8715fff3ab8d91687d9dc36759c9e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9582626fc93db338494ceb58c17d5f1084b5e740c0119570dcb14d49bb463a1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3532ba7da2ecb40421361cea6b98895515ba72f30e989b22db83568b78bbf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351bf0baa0a9a0e694326862c74f15239bbb787d8e916c96053d3d1f51dd40fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9406a18f2545eacbc1e395b81fff8965b3ab63f8988cff6dcb81aa7c636f9344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2607c7b9f9dab9b35e305a23d17970e11e48c7b10068d450182bfa211b41d96e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e50edad72591e6033a4a2156bd588cae2b86258feb016b26ed706530e21202c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9b55d972a130c555f543bf5a2bbc89d963f6785f96edef14cbd89c57deb721(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732f2a36d20d9404b5a8e2ad21b2028ca5e68f518d1f9370fcee2594877be245(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80de277efd1c8b600244fb79f76d4402d7f055cbf7a2a5312612ee0b657a63d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2022a0f3182ca0ed1a5522f6586537a094aca9273f82871524b3cf4c7a07a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8470abcb6f660733d31878858c93307c4d895c96e56847ab2687a821fb19d0d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995e73c6dec0dead2421e47df3d8328f7bdfdec27a03c7d523f2640a18e4062d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ebfca2044ac45ff823826b004959eac48377c7ceb610167ebe9653c4c67b88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e664f5fe408dfd11ec195ee49612e371fdfcc24d8c26180b6e71a75fdafc68d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d265651e34f8c05f9f00dfb4b67af41f29f1f9f80400c1e559ffef80069b84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd3abde5a26ad90e6e4701da6b768e81767b5c3dd0827f5bb9e80d83460fc8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a14b51816653a2014b6564e8bc51e075ce2f7eb76522e60fcba9ffcc5cf913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02c70958ea507dcd3384768bed86675d4aa4b084145ba5c6ba1dd5fee76bfbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885e7614bece959460e481fabf45925fd15ef4eda80c719a82de7492c7324870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b03f56c8522116ecf31f9bf19084fe6d5f90843246aaea00a8f226d58412e2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f7f715fe361d3e024fd7fc9d040e13bf21dd144726d7b1535e4507ef33ec10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddc86cd65a328d25d3c18d74caa325d61d8039e60c84950ac2ed56eccd53865(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3245e576c7cb2bc5adf2f625d914a91a1bd60fb3db40be5cc74914554cf3a5fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497b2779678646a1f363b3d933f8645f63b8370c22a0f1e5336caa79f5187c2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c5b6b2589a3e07bfc841b7abf414a72d0a2935f3515bf8982020ef08709da7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f34057e084d631ede7afff5b43b693c41c735c87b7979617c5ad4cdac325c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8eb049957242c5d722da0af73819050b600d705bc8c24df66738bd179888b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a1218ebb5c561fc36dcbcedcc93b08dc9e63f7f68799751e7042e029d38ff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d24ff850b176a70c11b6cb233f57ebfc9b19b41d0e038fa556c61d3f03824600(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f51f30e9eeaacfee9802b91412ebc9878e0c102886d32ce464667240d02f58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a9c7fbd06e80b21b465fa466399cba9a6efeb5cfee0d3e7b0831b079b0cad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41669bbb8f485b861f1c9e6ebe3e4bbda56cf11f2f4fecde4673f8737bc5e381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd753d083489475c7e8569b2b94b9ca5fe01e6378ad12a8ad673b3ce65f806c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1609f6d66d5c70c876cf95017c75488011a064f278bd6b62bcbca6aa4775cca7(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef416a9571346294263bece97626107199de258304bf232880925c52faa691bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b9d24fb4c3337812a004df7114d0683f59b61b60658b8081a92ea011d38812(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1c58e856448926cca491e8c7b8ed2ed7bbfb0edc54a19778e321175d893e2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52943adb56b6cfe20bf8ae9b15e08636151a0e524245d4efe26793a12052f589(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9423dc37ef55c7a6e52093920e377a53248b2234dbeb8126932479d0036b4803(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d169467ecc803cf07969cc64fffa3c14e159e1981770e4bea7220791e9bc8aab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6386527ad88f6cd1459d9bb2121f56146cf13e077e8a575ca972062ad5034239(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e6c79f2d463fa2ba1e9d8b1fc0c75b1f6f791bf25afcd62c889ab49db2ed329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc122843d298480f44f90559ccccd3d23e2f1f708671331fde0b25c4f1ab90a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bf9931ac5e929cb88cdddf8865026d812dc5e9093d260b8bbdf136b95db417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3657e15f2fea444f288c83cd1cd155e42740522840589052106a4d35728a671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c9e067e830eed4940fce971260af10f1ff6022fb88579eae17f1ce67790303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c69713fff72dd90662c7702fc2b096820a07dc5f8773717d6472b82e61de5a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c845ba7cf6dca8b2e4400079401b7bad47c1ea7b198f786bb8a7181618110768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c827e2f4ceda722a3197d59954ee64145672f9f07c216b0ad9133d103ee29853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48926e47a9e93ef9188a3ca25e2872b5c4c38371c9499eb75a3249a604f749a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c884b3071027254c7b3697599d33c69a22854a2bb34449e9906853c43201858d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89b9a2ca6561f4a59a104a753ca9ebd70061338589586b98cc092a979cd3beba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15c06019acf28728de44dc1d905c2caf584d36235c249a2382e69a636e4aaa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b42b69766c9326efffe17ed1f043046d41fe2432cd6f5a3dec64dd37d3397f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000ffde532853eda61f79e8b79bdf542da080b2dd0cc8bdb851d5873c359b8fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add74cef3ee5335e58a5c14f087bc12edd67b5a69de435892e231141ae768414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7154f9b8c8cd3b454316164c516117b9cba13605fcbed8e34bccd64e928a654d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f274785ba54fe02c3db28f436d4d66367744605eb6effab3d2cf7818ec211b31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daea88ad6120485be2c6070862259453daec034111619c13d3201e8e3a12a139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b42ded2b04aaadbdaa30498997372e9090d79d7baa9ed955d08fc084826c2c41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5629b8517d71b5a3ad8f72abcf433b504ed62ed337e7cb36ac3a7b4668344867(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5487182fbf6c8c2c0be9815aec32cd17f218a9d977862b22860e1e09be834254(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3f6c9fa5b73b44eca6d8f53c66c580be6fde2c281345b853a9d70107025e5e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b96d892b038f3dfb53f5a1ed819d157a23733e407eeb60141ec1004dd63c62b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dfac08a51824e20c6e5b27b7ddb699dd7719a7fc8a30fa7efb339692319fb2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df958f4e67754ef0349deccc4941fbb41de7d8be3a5dad1f3bcf688ba5bda11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e80a48e2ecc6b4d1e02b260b50f9b8de201132608fabc3de5309ee85b1f2d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ad5dfc247fc986883178d498e2d689051246a553868adef2478e65bd9e35a6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3cd3ae9307c60fd22077b7eadbbcdcd972420036e6d326958337a6fc6983ab6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1726f05c443991058f67df682e5253c4b71d302a31a0977b56f331f0f7e7c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1edbbc2b8e7843eafd14969f9c1a32ea21c5e3f6dd9b5ac06d35a4ac54af60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ed55e82945ba26472583ea4f3c6c979c6ce00033f66a99b35eab0503c0f5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66eccf95bf4f499303769762bf7a94707d8e0ccfff907af885e05cb09fec61f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a627dab5d502bcea1fdfe8097726a32f8581a1b8f1cb0a108104c04f50ac23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6475cee74ce506b707236ce6372422a6464abc810d29c1dd42dce2ba69fa9b6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce95e85fe64bcf0c675ccbe30841cee3daf9846b3a139f37fbd2fb8a120ec717(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1ca6b561e27cd54c634c4cfc29adbd87b53463e269e5ca070fb920df966b6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a55ed77c16d5f4a09d20b7c21c31c6ffe93226276b3a46e1239a22e01a2cb56(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091023ecc45feee2626108b6360e50fbed32ed77ff3ab8290129feeb0d9b755e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b836638745a5790ae285288b1307fd8dad3804ed477e00644cf26ca9b18cc85f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283c7c123ba1a44d181ec50c751fc45d03e74b024a01360a76cc1d110a18ef8b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb354cd3549b638eeb9b5261029bee9a3485cf5237eda68134abcb4f7fc2576(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5fc19922967dae627bff467cd6cd5f1a2faa53c39a56969d7d2f1e66a62392(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57f6fefbfe984088c7cd63b7dd9fe1b46c056076ed5b6a68d8f512e00f49f10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595789b9ac5a5f5ef65610864ace361539bccaae1d20270b6be180181f952006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab06a81e4596cd7d626c61e4510f3c057ae24f479cec959307a52b85fa43fc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2003ae73e3eeea4efffd13568fd85dea91c498c2f919558d7d143ec7f37b94dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949881f270327d51b4862fe763dacabe91d881725bd0a8e9df733a2f5a87a4e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b92f2679f72ddc4a5cf0c73cf38e2cd6d430d3b642b18d6ab0928ab7e8deea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520ab52c2f0d8ef0104508f238aab604a3e15c1cebf15c3b219f3cfbe7c35af2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a6732dbbed69febd2edfa3212630497ef9a45ebca877533d2e9bf924820fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c5389a74931150eea945ab8570c01a25e8cc4bcdb4132f01062621ebfcbd01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00a27a7215280f26c12c714cd03f81ff6881cec16173822c77c199583540cfd0(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1bc3c1129a980aaf3e4b0477d6450cfdcf8798970d32dc9eb12d2b2a07a99cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6aee213720890364d2b952e9b17825feb39abf93a54000be11fbdf6d6bd8d33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a6f83e6ecc9ae32f58825f76841a8e7dd4f968f88f80f85fb7f4a4fb0a33de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa574f1d2954853c023561489cc8d8e16507b200696fa0f790258802ca7faefa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8fa4c661d9c6055f65988ba6c02bb9d676c183d7ca1f94b964f30854ab12f5d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49475175edbbe78e6915f128c877405086f0805002fd4e8b706f284720937538(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08abb2fab8d0203fca49434a886a47f053e7536ea6b5b7b699740a5cde6bc9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2675ef2d29d824e0b83e07f86ae51a219782cc6be7c807f39cd9b74e03bd8148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f54b1d327d9f49714499be9e52c36789c85fe667b39de9a727b5d5d3bf8698e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0a71e64d7944ce3a90d5a30d3bb3f2b245f90bf3c1c6a0dc1974f8b45306b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8420253d657ff32429b4d2eda0043102e11465a239c834f6d0aaa79ef26b1add(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8f29525bd4be83d9e1548f793638b876e5c1dcfaa302af615ce4ea8b7528ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c893fc759eca96ba37ca01092b0c4b8359124429da03fc5438e734155e2fa4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53b67a62f1ae6f7b2939046de99e715587b5495b81426b10307d0bdd2a3bb8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd09ea2d3ba02ac03655cdfa24e15ce6bea9b134513949561b793bc1dd73450(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902f67dd0e5efed83e4bd21009817b3d41063bfa8217bf0c48762c40b75ed797(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155d2afa8a9dd105b56ed8336f6b13eb809d38bc2e574b6f09da9fbd4f1b2734(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915c2d5f6a3e8b7597fb98274fe9452197f8144da5eaa8282cf34f6d5eb9c690(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20906f3e95193ba7c7db260c2b38e5f5efbe782f7150edb05ff397372e33cef5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697cc3ea309d5fe90070ce5bda3af6d5ca14920af9ed7f85b12aff6c318ed28e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0589bcf270fcc7d7e6dd8c1c76f012ac80ecdbc84b340eede29336967bb1cc4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ced453f8a1426bb41ecaab3f4653ccbfdfeab115068ddf1cca0b5199f601601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6cd588a213114bc1965d70d854fdc2ef844d18f4c06f28f15b2858ecadfe942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d057fa9d8408888cef33e27008120f88a4601841b7d4bc2cd0ed766ec93a9a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b08cafb786279e2ce19d96003a1f07223bc10bd20d5039e8a41362a19f87dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac78cd682803ae860eb87a5716337bec4b5edf2eb62cf7bc11cf3b13b5f167e2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd373181d42c5db9e5de13ee7a5d8d0ee624bbba4467d24b29b001cf221e920d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af872e7a863c6af6f9f2033fe2a98ad3d8f45169a8df23a3e3c684c0e684cda5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903e502baf6c1662e2790dd3b27b332fed4a3160d112dc76cae8fbb6ae3b3bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03869cd7041d57d49f025b46f52ded0f8f583bed88a0ec9561ae9b84b4fe2f5d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52aeb8f6796ce5cdbee7ef4bf72a600131fc32b05e63befc267b26764fbc5f94(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986831f88c4d83447a0723fcaef8670a3f88ad6ee201b904df1464eee757064f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25372970a52d3ad2f5b32a2dd38ff667e76aef0ce2f5b944e52e3cfebea4cdde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ef0042cd36c2bc84fec3c8ccc0b4f1004fdc295ea0ba5aabfd21f15df52d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c924ec3d556e8bdd46b57725f3128e991573bc283e3c1dfca527eaaea9831850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc8b70c386854c6c5721cfac6888a7e40f439d5044dcbe81187a556f790fbe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ed4e3e396c864c6dbee53470b9d632ecf322c980adb1eef2606b82f30120f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29abe5e08b0d1b09a8bccc2c3f6cd65fca33c19a59aa19674599d68b32db159(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b91723275ffedf703861433e91bf4d61b5d083ca2edbdbbdb1805c6e8a4a370(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073f204f4b8363f984699a77e1da2dda618f4dd343c81f3867838487b75f38e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef7dd28a363ae0b7a6eb2e691a001a4a444c0e707ad7ea0b1dfb3136af8f1fb(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075b135bde851a53091cbaf9c681689037e78b3088a6d79d3a39292b829231c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ff85957e0d6485343f2cd7d893e4439f8ffd854c1e52bddc3bc85305812bde(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f07eaf8da0f97a3fbf4e1295ff813b3e0fc812b85531a94447e8e23b621da53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95c15fb293386df93d3387903babf594bdf3e53adf2d84e36b2869fadb8e4e0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e821999f49af4e7b385114233a7984a20e495450922d79ee03d451280ce84a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8c7fa447eb7d613a96b9168eaca3a455439eb78030a6004a3aa313aaa9422b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e90acaf3b2fa29c473a15a28ef889c9d53e2951be7524a2c3fa10966b6973a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcbd107ccbeed9629adf9b45f2c2a6e0bb6ee99f39c018b1d40413bdc33195c5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ffb07b465cf5264d5301456d0816cfd1132a2f551ce6e44e6ca5d0eb8dbda37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090609301452bc96762bf26867b7e22cb69e79a2534fe7a8220149792efc9db5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53b959285b14fd60f6d3e73b8796b152ecde8d87296cd22ceb5e1c68417d74f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b000762fea195640ca8347d2cfa17b88d83de44a0094fc79bb45d14663f5d3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__664de54e864559a80274d4e8a3ba4919b2e108644f23207b37eca1d5c279a611(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75e256e366de9d37e51817a2d9b20d23fc069391094c13e1ab585bd50937f4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b3f73f6d9b069dc51f847e351a1ea4642310bbb1ddb2f626ec4ee87517f646(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b42d622ec4a18d733448b95de807ad78ee7d5ae1b733396ce7d786b7648f5484(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c0c8f6f7649d9e1d0f0cd76736152d7af6893f54e066d24cf06fa331e297b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbda48a035ea5e691246c602c09849afbc85fe6a826d5e34d769c73267ca3b09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6c7fc867d1d2fda289c903d3ad3c875826c41e43bdf7c2ed3d7bf9c0ff990f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e72777fc879f4513612297bde8ee9d60e81c3d5b3b80953f11f7443b668f44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24917377223e6edcd6b9804078e70278ec25434f83a183a87ce6b4ea7a63ba55(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d2f8cfc5ee4ef7f26d75c63e9c1940def70a350aa6ee5fff53a1add22f2a69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1946a0eb35d38889b6c47c45d8a79cc0aefcd927ed2be1712ae5459c8afda14(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4d0bebbfe4c6f7e068bf7edd870875fe759082edcb90087cbcca6d5159e998(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f08bf1f52a64d567003d164eecd69ed691af84aed475b2c85f40f34d0186a57(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10ac27000f96e9e5c6ed9a00e0c047919e6b569ab582ea683c9198475537bc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be56b1646b11ad40e8d5845377c8cb109182955faf8a99dcc884e46093fb52c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb120ad33c2f4123080b304653dd1b376673e18687e6375ae016c9efbcff261(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea895b4b9ee9f553c6fe9f3ef18fdf5f118641a395eb733d87b5f08571231a6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653260d3685dfa71bdc22f4c21065a731bb794f46739952efff83aefeaaca637(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48045dc822e11f857fb6c571dec61b66260a92195f8257f25edae745934e892e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dba0025905336a32cd75bfad4a2d2b36c06ee5e91efa3f09d851b9c171d00af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ebc27a14f98c67cfee081300e403d8d7d19b76bed372b5c03817a7b4df8e92d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb7d40c5bc994f70c386215c0b10fab0151c6a0c75e7910f61f642a95fc90e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1edd09c5a08d0189448de11ec60728823b8f7cba8dd820b10e9d6d710b36c2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632e557529870fffe8c81216d93347a9ac8d66c9cf52081edbb6e08de70ee535(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06fe57f7fc93515288f57d2b8dc877b8381dfc8e9927f070b9056f24752c2ba4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a20eb4773cbbabab5928d1d91b4d75f290b86b7fca0a174008527cbb86090d7(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ebe8c7a65bd5c290a03066e885cc1ff350f78e31518d5bbe8ba22f8e5e0708(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__755c2848e8d544648d1ad40cf9a3aa5e0d4eed1661e79ceda75d0cfc3abf39e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be511ad96a915665e7b0a220dd97adb2df05fa59fb45a14eddd7af1b361ae85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9db0b2ecf864079aee04435f432577b85d1c90335109fa5ac50ac71a5db36e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed934c2653938ec1c1f8a0779ea8b1cb7d694a6fb6017c60a9053be24b4be89(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee7a222711a07c44123a15758b7f388ec2eb73751a4a2e2f4f1ebb147b4ba13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8bc36ae6aac5ec2cfdea34810589983b3e0927c8a71e81ac3169ee48e45bf82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2556c03e3ceb0f0fd1f389603642dc1073210781189f98300129ce305955717(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d345fa179c1b394660855bf0dce310f1741c2283f004136a2f342edbef22ff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0544b387ad2267f27efedcce4939be95b5081d9464b8c802de8b7175599c6763(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__668d7f61f05e4a81b1c6aba96268c65e8aa5b963a9d47f78021916e7ebba874e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6f493e9e2aab120c68d4ffd098e09a11fbb33108bfb9bb7e6168efdb6298cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99247df490a22a7cb02cad21d333dc37eaf7eb0ce4022dbb6c9f1c1d9a4918ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1adf3d8ce6e2cc15084b457fdf4c9f36cfa023f538d8f8616cd7d482406381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c9bd85f63069b702440aa57e9c53f321a4931ffdf81da259d77a657349a4cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd92a4e9dc388147ce435660081edd11711e07cee85425576d662e75373286a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6882ad413f10f6e2fb09dbdbd4c3fab18b678701d7d9483e7317e7eb99a710a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00702b4278f0a60c6b906764fceb398a5597723b042f0bf1e11ceaa23174faa1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6bff8182afc8f43545fa68d35b07e96719ad0bee35eec2febd614ab3e07089(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12832c1bb8fe8d1c29fcc93842a7a11e5a2b8b00753f7f395dc3a0c73deabc19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ad92e730e4a8bfec5ddcc1560a42641c88f6a87a476f80c0f8d12ce812bd0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b485f9684b5407ba365cf837e572d3e87d1f79b0cd9a5d43b5ead455827f46ed(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4efb487620ba8d1025ba1da8b33f643a42abc118bbd6cff5793e2b01b51318(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53811279d515f605d949854b9e31e3e444e93e43a8c5ede98cead3313ea3de03(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7e3378da1c942d63b66cfb50a2664c9866c86b8bc7e3752787b84ab1a381d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08bccf4ccb2fc3b15fddc93daada97411d1ed2f7d4e6f6d1d8ce06596ceb94c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a0b7fefa0e36a499577b1a2f0664e48ae995965e53ecf7d2720d13e70b239d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a853af0537a0f06483680166dd70eb4a2d322a5880c14c2d28c102a0946bbd57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce172ce7ad33b622ecb06844cda9e3b47127bd51f13e32c38409674babd0a90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cbf5707d18d3b0793d225535ed3bcc2ef662d40f3fd837228583896180ddeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c26e33e3c7dfe2c23705daae84bf92b1f38718417edbb595f5cb519f0be11b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec016d055e067eba95f114f1cb603fd6d0ef2f232356d7ec5b885c5782fbf49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc96190e38ac3e4f2135726f273441e1f8a6eac51f2c5e880283fb1a5534085(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1847f08bd202ca19d2dd781efe24c9cd7371f3d83b89ea39f3d753b3567eeb0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8394dbae9dac9640c9b99657f406752b0fc5053a3cc739584ece70dd4980542c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba76f3f9604487948366f8204a2022e98a5ff2e5ce841a61f934ca171efeaaaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bb84f6e263fee6dc6471cd7c25bb43d234785764be8395132d9e4be5dabe5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9079cc57370ad084317179024ec592b590e870cd99a8986f35f0313eb6efb078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4c846270a0d9396b11b1bf892f0f5ccfd7a76f510be5c3556404b734009033(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50f50d356db6af920ab18d68032e4d39b80a6f355d73a6b7d26ffc7415258b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27265987e45563a24fcc8c468cbd4b84125f84ae021cc0e84ba4b4b2335a4542(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad85a295808a86fb52bf2b46c21bda6bcda4e6162f41922680e1237cdec25602(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c904317f5fc6e0cc072eb060f03bcc409a5265b5d66b9b0554fe00fbdd226a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe00566929cf008b306bc88d17284236f1ce9586ffe87722c87260893d5b13a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1081930d96908ba3a4c8bb9e5b917fcd18974ea26447a69b77dec63e1750d0f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86c567f31c6bd6917b1b406f4d26f4c743dda37b6158013317b4d9080d7a5e3(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f696ae27d6ee854e42f941b38fb5e8495ea5c766efe0f380c7b9d153508ab34c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc302e680ef13e6ab62ffa85b2b42d392c72468120624721e343f3d7ca8586d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86ce471af6a38c381fe52e336491f20c1f6c8908fa0ae3892c1818bff105dc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af880586a97c8b20ff5ec0cf522a5fe4a6aad84cecd951d42b788666a824c030(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fdf8bc7a55660898a6986be3a5cbae37db735b724209d4851f63e04636674c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9759f8295f8e27f20c1fd51b3321e1576c57db674224c96820e527fc4d6fb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8697d9b16a6802dae03e9008d74574e641d059507999c2e3b953476c84984df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84064e2bb15d0c0c057702612b6ba092b6123493598abb306bf1e099b4f7293b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a038f7a42e034f1025fc5cf3b665ebee97ea6d98df99fd97b784626395bfaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba0c621d763c2a7587c4f3a4e5327a2f6c32e2edcb80c334f884ae9e941b093(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10a2572d354d782bf062dd9785353293f6c44fb7409d9602f237fb1c65e9e15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d282564d6af7f7bcb52eeec70100019b936b06fb76664171e7518c3289e518d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e23e8803937ef68043ae852167ff6176dc5ed02b5c817baedddb169d7b63ce1e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4315d517c6fc8d5d60c1479ee3b540e01688a83ae946fef47196ff638f0ca45c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f710e942d752c38c329bb4c26ad7805e0ff2b5e66a1ff707563d6acdc8f313(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e707f29775327468c54f9244766c543667e35f83f8b9372ed84f1368e7fc9de2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42685d7574bfb87e2575a296afaea319359531bf7e30d752c8db5495c3382d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62e44942085ac0ab20492b265d2c139bfb5e66cb0103c053f7551d2f8bcc624(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d65029520e6a03ca6dee7dedd82c70454c885a5ec77ef2eb3c684390e15f89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79421a9c2f78154de46f2c0d3241b6ba43e6f6b22d9f3f35c5c9faacd5342a78(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6393875ad3aaf21ec18d147481ca8b8f9cb75a3a38452649d8de34d699864d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2bcb61c8a635652c4e10dd52c69fee4f3b5d4f6214a62669bd2d62a47b32b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7febfac5a056f7ef5bd1fc626bb118de065dd914cebc57cdce34b50117ec3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e582a981463a4281674a2167828b0d8d52210c6f408eee62c1dda28569d3065c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25cebf3de8ad44907f000dd0b6464e6d2bbeeea6e312afbd509abf594af0e62(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f66cc4f4b0152ec9cf1072fbd913d9de152fca8b618b00208cb712a928b5933(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab85109a73b5c98f42be9d24867c798c40d9db82331c097eb453b88f6c103cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0e25bb0009f7367107ad325f1202ab1d3004e24b86f6c39159df75ed145980(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42dd73f7bdde6664ce7b9344fa1e6884bdd9e08409b7cebe587d87e20cb69056(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b5715108d6375fe05ac941c67ecf675f18b382e0830d30a4379c2c3d636fa19(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bff9263d8cfe4d07c083db80c52656bcbf10b7f5e0ef667475eb27c744239b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a130c75543050ecfb504d54f04d689aad71e5ff6e9917a4c2ad704bf46a67bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69774e3c3fc5769600de96295595cfaba7313b8ef7b7ad5bcc4852c5487777cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d651460ac87c6241dde93b0d71f53dd22505eb461f6237d702cb1e40c557655(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ab8855015a21d70fd1cb74b994bd8fa81ae195ed208bf77e77bdfcc56d568c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47d1281f1b41021aee3a85ad331ec8896c8b7ac1971832fff6c58767aa7daf9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1b5e0d23c7cd402c0fb1fe00b4b6dfb1df6781e37b056f60d2dd5730a7c33b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e57cf15d78d32fd623c9ce772ac5fc07fe6c5d0e7bfe922fde3b491c3e6c07(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993d1857cc71ef09123a902039a13eee57c2c115979c4f1a6b969107de0b089c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aacbe6adda1ae4636a44450a476e502b1a5202723c10ac7c89e239dbb128182(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42e601849f67d80a92d94df0020326131b7d977513a0a4ee026e4868e19b4f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c5717eefa3f9a58c3838775cb633c9aa5ef95ac1742e85bcf0fb307bd8362fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0138e953cd19689fceee837e6260a51e93cee87a7f81358e3aa68e1107673bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43b1713ef639ae1573ad56af9159e81228d6100118efed72cb1b80948479980(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f193af7db4fdcc3b6f680dd4476a9b920c8f542d4c2e5322aba74221822d4576(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb4e984964e94a8f7d14321974ca39901ff4aaef2fd8dbb922b9f30ddff3d567(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f71e1a0fef17101ec660a686c7cd2f341f142d81211bb781f9427500e2ce603(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62795e0d04b0885bac799c026c5e0fcc34f8dcbebdf8da9c25850fb46abcc6ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9165bd4b3f017ce33a632bee7dec6b2e2a8d94a5f2a22fd0337ce910c0588bdc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f149dc829bb2dc0fc2a64ce2debf4f90e49979ff216817b3a04b4fb2163b40(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ccd23f4fb38a0ccd279b2f851e40ada198c412af316fe0501cbd9840cd10086(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb90699454cc439dc4d6f1eb2daa3b9068bfef37e7e36d0c4e3ef73cc5b94c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf43a3fd252de207f9eddccc38c9415ae375cda60bcc0d6d5c1a4cc7b8f152c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639d1b6eaf321da08e55b853efc6650b08019c050200fa34046aa997c1acd26d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2fee954db659f782d894f31a722346b773f8b2cccef48bb4c37e4290a801bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8842f89e091b28bbe83ff5befe14a114e42e0a244925fe3a109ceb0256c8bb4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f088f44702afec214c88782b0744860a074094366d0132156729f00a42555c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a005c28c61241f15eb95347e920d51d4cc915bd03294d0459507d92143844df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9e51c33ff792d8c0aff4a4bb51bedf7f34d76297a4708de0f2ba4e60e30087(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ad0ca7051ebf552be9127354ea51678ff0939f0103d3ae5d7650b05b28ca86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a326606edeca7166c1653f6efa2548876110302a79fa4abc4d87f04e50e8441(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5212a0bdd6a2891b2e7185529b23a8c3f14546bc9103c6732d0ae5a95455780(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05fea5020ed4c800c6caa9e4afedf2e1fcef9dfbaa87e8af432ee4bf7bfd3406(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0b9e56e4c8fae859cc4c79d8ec2c77acb35cbfdb54ce3532bc125fd3ee9178(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a50fc1e29ffb16e15793fceb9992e570e2c2ebacfa049a91550ba314a2d080c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b3686fda25ed24998429120afe8b00f748e6727ced14b342234891dcdbd4d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef90d14c58923758bd299ee8e9ce3016c1f776b11de9e6a2d1d796f31eeb3430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fadc7dfdf3fec9d78318fa1da67905fa1a532d929d021b00b8a60fd79c335c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94ee5493c9c7d4ae9314ab79227c33e6243f5d154234ff16fad8db289fc8d60(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f457ebd07a3d57ee4bf38c5f074700ddfeb9111a9a865f4bc2dc08ccfcbcb5f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4230fcbe1648c7c90af99b96a9105bd2387cad150f7d36857474e6018630f419(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9dffd7fd1076b563b4ed5364ab12181880ef7d89e43d7bf75d37d9ecd377a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77cc67e8ff678a3e7ec272d06a0c7e4e4d1db7f1701819035e3c01ff4ef5bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c932ad28ddbf255d470208e55d80d752de3e4956716e5ee20c06628f92bd5f1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569dded4a6c61d496827384098201a4a8a39b6e241c5e8dbd772ad93de4dde46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6714b0cd999abadf1bdccd3ef1304781cc49b99b33d52828d5a58a3e83fce4f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0daf1c210d572101ea30720b91be94afa23084799b268f4525daf6894c416244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c32bc56a169beaf7e65382ccd7bb110bc470ed54ed6b77a55124df9b02b87b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f2f3ed6fbbec94844ae811edfdf2e3cf40fa351fe2a343561c657a819f4051(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ffc49170d83a319f8516ccfb9f1d16eb173e92fb6239ddcdd5ce37ccdbdd10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4bf443ba7685e8e79d145182795c924a4f15448d572317b168d3f420b63402f(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da1a7b3d48e4442951a37b9d2041b2687171db7a41e1ee86465965c7498908b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067e22abd5900f388f22e8fdce8ffcff312cd7467fdbcd87bfc14c651afe1d06(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af606744f52654edd57ec828d71a935570bc12892026af75b094e2b6aa182be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24766d421ce45b4bf47135b7e3cd5cbcb6d2da07e44ee360e29907b1a99e224b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51600a3b1969aec380f9c3245cbd2780244280051adc9a14c98918a8d554bbbe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8420aedf55f0c6a1c32301980ee9182a8a63a55e2e264944e440fb08cf1eb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4da0380fb96e41d44f1a655265530fe17240e36bca76dc1262c24b33fbecd23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5c99b5727adf40c02e4b96c7e844a40a7fe2264da95af69d70a67e3d8e217ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e04951e74e8cf316fdb73dbb3c5492657575cd6b5f92647d20eb0d63f9273b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaccd4e6c66fc93e5410ab7b6da3e76e9040ddf5277251f5d0ef6b348ab0839d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952379bc05cf0f4e42edb91ac8053111f11af090078f69ffee3e4ff5e1f036bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79793739da8e10900f2939689d15c7cd21b3b81da27eb09831ae4fb693ffe1b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9091a75cfc9198bd7c3aadb064a45d375597a9b4ff6f9a7c85f2f269bbbaf51a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f46a93108e9da6d1eeb6e8043364d7524994641895580ec2c777730e49b0f91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94277b9fdba0029b2ff234ce48fee664111302d3a9c37031975298bcffba0ff(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b7a8c50e39c3db0a2bd90655fa88ac248a1eac8d291214554def31ad5b80f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a605478d6bd477cf933dbb870efd8a8a38b9da493d94e0bf987289513b55ffd5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb658f24025392dc64d3524d023f4915ec9530fbda68eec5cdf4bbaf640a0dfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131dceda9d631e063e332d68dae0ab808405037f773a44f71bb0b56785bcc5d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45415c2d3be8c9942cf50b33a1b19f67d301b622075934e3092bf832f08b392(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc46bd2b086dbfba7afb986357205bf0172dc927222fd349bda308193160669(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02119a0576810576f4b9cb873d5a29c7a51545feb7f8ec21600b6ad388cf88d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1342309c81ed0a473920a367f463d565275521f9e5ca1fe1e44ed298bbb088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17947486d59fe52dfa4c1640aabe50e139cf2263be1f2c5fb3764d0e65a5049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b772d3375cd253a10963672f5f94f6136d3c1b62ba76c72c29bbc58cef2fd5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9582e345e2c466ecd78bf5b6f8301786041ec83e95d0905bb8ed9b846063065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aeec0419cd008e36f4acff477612887247b0d2d2ec06701f3a5eeddd68c15e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__494f38d987f0b2cb893990cb29dac3b0c5188b856a28f1a181db664db87698b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079ce9a75179b9aeb23a469c6a24e0cf7d5b4d540c88205c4182fc0d186a5a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db7ce24a39a1342ae82f6967de67ad55856af5131de7b6c5b36da7744d28938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b4e3f5f29f5804c57266b24491ee4db07949d2bab902ccd13b0e11c9a095ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815546a47347f640caf6ffeda80be2b37953bb7a25359315eed0f84131e2cb6a(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d78c5b613d84d33e71d0ddda9ae66de328fa1ac6de119154da12c864d7769e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49127a6a9c5b2b23c8165b7249d0887786810572cd76386b6a9158ddaf84bac1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a8c18d9b890f6ce28af06a0ccedb5b28cfe542346b56630a958135f0a5c34c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c60d3cd00c82d6480e72cd307d143d347d8240a31e2c8d0680f19c0836ddb93(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117b927a2f1b2adefda813c8a7d5d1256546e878a11aec977d9a394d97a91ba9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a726d078de22b86de34b1938785c13f8a04e91b145825d02edfc8a592f12b292(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0034c8044ec09994ab9310d2bec203dd32f7a0c9f38426e242267fcc4bcdbd82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22853267418f91372508677f9eae429a2e57aade5b1c9fa6fca8fbc608cb553f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56691c461c66e3985d6598c80b67094d1688e10fd94ea45f10905c4ffc1ed445(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c95df846755a8b36828472c508f9fb0fd7fb90d582a1ded78f620dbca221ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae6e5e89c0f487fd2f95ee1f28f085ec929707f6cef8f137a085cb4bbf0aad3(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692e94f53f0177ef16bcb0413c63ae2bbf5190a5f2c854261135d0e0e9c0eeda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4e2c6312b920ed8562de92f941c37d585f8f5e062c06f57e9bc8d7d62f7f46(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b4f0e7201a8b4612eb1b3e48f911fea36832d933fd26401436200725806d7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564c0da055dd2b38a90836a978e45432469245652232729bdeada7585cecd3aa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc717bedd6f5c90e22cafe5e98f2b59d5cfa1e348582eae60bf502997e07d06(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7a0d0d6e19bb49f9b66a5c60f75b913d9fe81ba349ea8cafa6d466d0bf99659(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ef9c04338142657f4c824a01d4eda6a84726519d7b5b9ebfa58be0f3fce278(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6003fcf4f338dc2c7ea1e6e9ddb5d775b9ea3a7dd6bc0e89c2fd8cc7110a45b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc7fed0023a741c8bf15a3132fd5bbe92990bc532a46605b3c8ce394f2984f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fb5d09b537e472978129669e461b0853140abf647115c529698d23e4c8f46b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48e0f33d6b60f86b659b15598ea8811ea57447cba825c664205f90ebf12d0a9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04466450e5dbcbfc7b34c021e6d18bdf78de20deabdf88ee25e3ff1113e7ba7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4096e0dd640b45597cc622e3a064e4590ad112f353928ca162c663317d8c97(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9138bb3e4cb197956daeef6644a6b3026519779e72f0d54af395d84482165b9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee4d65cc4e6de3249603a96c810b0b23f6889e9fbc7a835bd49e079a4b66b72a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a3b52278e9514b47548a19dc1a050afcea79bd1687f7c7ed40bf654eb08141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b658d8e16ae75506b6c5ae3e68f45b2470c0012a4fd908d0c54114ef46719e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c845569ed39b263f6e6a3aba02bd21b831dbd46331a7be8e0ecbc9c8ed72b09c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cb6130e55fc35f0fb670e964d16a4445afdd4a87d37d925be254f9b12ea19b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7339a12dfd303f0c806e1af9a7570f1cd753d91de0a677d431301e2751054b84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126084c7b88266e18b1696ac4becb83bd21bac2b9333255861491a60328e4d5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1c5cd43c8b03990c9a425384365e4f2d28818a105570efe2633304fb44215a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff15e5dd5db5d78493da33708765e04f13f5b75382d7dee6e3ab65af060049e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3818795862b9c7952f16471a5cc168c30edc07119af23c4fc20b55001247eef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__165386d4d5e42631aa72b06eb95d047512953b6f18c3914c24cdd37dc65b8099(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0379e13a392b1845cc32ad48b145392e8368ea495f0893bd0e1c059cb5a892a(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a622e985c0e8dc6ac2dc0b669d4a5d6cfe841b5517e0348c6ebeeea3003f7bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c0fe08225528de2b98e14113b4eacacf3749a211e7f748ffb2cf95e68def0e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea2d01fb77ef826e953d3823cdb0fc5ed5832b5ffad3bc2a722470e5e414e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccfd7c86d3db43f868d2f91a3b661e0035d685064efd269ceb9ac0dbf5aba61f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c6520ac03730d6aed7c032b180588366550a18c2ca69631cdd8b73cc0e85df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e853267986175233a745616270f64555ea016cf73c3ef9181df8be3f653e7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96db5bffab2fcccd5cc14b3dff1a0c10878654ce4a8522d62d3e7014d77dce47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b5a0ae37337057041402a76e9a2a5f2248d993b2ca041de2077da8ee9e5521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a56fb797af9fe6b755d07865b899a1b440731f15cbaa479c18d8196267d59d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6d1ca93b9ff5d0ea0c8d31bc1bcb2cecbd72acaf1dac15cc33cbd1b76ba59f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492469adfc7312073b3cb19a57cd2a42f348b4d8ed37a5b515d93e3a91508e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccee434cd5bfad9e9c0a09460089b0e4175f7bec0cc245ce8b9a641c99bd31e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b2e6eb2cf98bfadd0f85d7a3a28dac85769d3926bf4ab820d933a88cdfe0f2(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca6ad1e4458b5d12671af4925f31a5ca32c3218fd2c99cc717d8fd60bb05fe9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b04567ffbc15fac2194e51a6c6fa2377b82f61e37633907dc8734a4c5fa6932(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9328e89d53af9f5b885af31c99391f74c794424fd775c6e90b30fde89fae7504(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2afdd9d0833defbc95578b7a14cfc87eab64fb2412b450742ca73f18eec7f605(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc527105ef3d75fe185a03df8815ce5205e4990f7cc26a618472779860422c3d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2592c0a83152ca123e181191b024571fb102169c70d1782f29be5632ae82b2c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040e0b0f43c82d4339c9b3be620be9d4b1e486f1d017e8f21f579b020a45c6c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c5bddfb7c30c102b72a57fe2b64bf6ce5337b2945d04fc45f5c7bb1cea6de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc4c9dcfb94d24bfbd16225fb88274a033307deb909178659a1bd44e05919d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c827dafb941c47bf65900d4564bf1b9e85be20c1a59da6e86b7a19ed8e9c5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8501c50f8fd8938d61972387f4ecdc2c024f1dd7797dbd26362c2fcd5fbefd7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9748de274431c3893bef49cab4e2ebcfb0c8afddb89801dae609f95b83a89a95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4594f476674ea3baaf71718e45b3f2ea144bada992edf47a7213b5e12369e06f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8573566209d599131444a55f248121f938c956f5e8c24accf1c9be9e226d9b55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fdff205df3f3ade30d2e6e8a6fd17ce3a6052d094da710d9c52f92fae557636(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc07dd0f484c7597f35665d4720ec37b1d6b520292919512f49a0cd052b2bd4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821dd5584781dfe4cc066b8d1a2c4eb357e5465dbafe4b05c86f5e96704599d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1eb1cbb75b582df336a525c34ecc08e5bb42199daefa93f8ae78f0ec5a62670(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9587cb670cbc926e55eb5571260e8d8cc147b73921e48f0bd450d073a918577a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ba5d99708bbe41d3e5e1c39503b2f100f8fe5d572dcdb911f3a8ae885f88ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49dd42bffd617ce247128fd75a6542e9f41ad097b95e4f21a72ee0b7c040e255(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cecb51bf7685ac06e7556e8895c9dda864824859e5e4bbad7ac1b9915854d641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f73f1fd0ff57c5fbca2304edb58c07aa6d58a944b2bf02eb432c9957b13c14a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b593d023505d842b7df136903e554ad066dcca2b5fe07d4b09aa55d4752745a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7244e3b344585b0cb72f2e5dca8f9350a8fc31a3da6a2394e893ae6e5c949b48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ea0e7cb37f165c317133dd9c4d4e00129b975b283d967fab336fe86d2d9002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca45b25c902cad1c973040e2c532ad34d959642c5d5fdf2a4aef4a585050faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47876f995ed003e9bad4c2784d2ebe811e36d12400bbc713d258f990e26719a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd952d57a6d7a15ac8a3b63104f8422471126a0a2a6231381b5a0115604a7d9(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909fd9f81e7f390a46d7842f36f01cac22ab1c4d2cb1eeb76757d7865795f211(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1772bb429cc3416bd8a36d0b1cb81918c7a8ace146a35007958ae4ed3bb65e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__646d592b8d580f8a564ebdf511163a402275feddf1483a41e690ff27e0c2d47d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ae683e43807172d54da3ef3db6edc32384e89d52af7b43cd9ef4465b443f73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__759354895143d03865781cf33a3c5cbfd8f08c3ccc27d42f858f2119a5eae4c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b3660889989b7e3c6cf69c8b32c730f502649eb505163f498d151cc01fccb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2136eff98cf044fffff9259dd461323ca159f8586bc1d960810feb5d1f2f8f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce1fdbab91664554b16f7f9a554bd2d2584ad24e95f50d6124aadd9449ae931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1777c7ee2cb0acea1ac7c8d45228cfd52de37318a545f780d0dd9126a4f6dcd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85baa6cf1faa57aa02bdb588bb13f2029552cde615cda7f4498945957a4b7b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d957310bf225857bdb24fab75115757dba19f681f37abaf2b2157b9e02ebf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5d49730e37e1a66297e78547dc2b43b96dcdb8ebda820974b70e38fd1c0f5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb4568dcbe7d5288993b29117ce5630d66b771aba8d450cd5e3a3b028517250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c585ea88c0fb3ebb58cc1d6791709841a84aa06247578690afb4aac6f9a09b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ffd36853aa2303f9b28e6373348eb165330690de4d2454548f2ef4fb5dd348a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f71ebc5f7a502c8b56bf573bbb5f77545403d2ed49ab3d0c3ee53782ac8f8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f94f3f0689c58aed22a41721aab1bccd25185768f2f5145da0ee4db55eb66599(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0ff0085f091cdfe7071292637354ec1c148c265fc7d2d1bb1ffe66fa8b8a0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2fd85fdfdb81dbda3a24e9df4707146c81d3179c5b24c4a3c86f825052258c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f757e673f05dd002d939cc3be6ee1c4916165bb314e996cfd92d70e92ae5d0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101336cba61caef6b08d746add796a91283d4343e55be0255b2c3e3e8a3bcc76(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bfc0815bccc431987670eda03d2e6ff76232ba5b69fc172d3a61a657a1376a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900e653d545c105336a122a10406d17ea799fed3b770eb3d585edddc675ca667(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6ab2c8fe900e15cdfa420e9706eef90b2097c571807da197c2914328db5989(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd0392c389e1afef0f7d76d84b4bcb030a406a1fc2caab5a7542e1c841357ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76df0dfa6739ffc81cdb8eeb1c9335e380676f8301d8301d5d6cc2029b322895(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61e8a8297ddde4b7c396b5d9a80d899c53c202f7b34cff1cd713838a647bc87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397badf618e12158d27bb7131e86099767bd1e2af5cfafbb8f119108102691ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cf7b1f80d73362bda1e0f7f0a3c2f955b743530d807ff40abc3dc7c849ac2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda77361ff160f0e7b017be871ea3c4c0bbb1788f3c0554b9474d08eceeb9b28(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f3d5ba8a78cf91b743b34ec2e7a33a953b44d88cc8b8b75bd0805c2f788419(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7d4cf1347dc6c703a476cd73269d9f02be3476fb497a02ba34530ee2af3678(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b5381f6e89f170fc9de5ef3c430870d4988983002c77b7c0dd12119cf2ba26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5355cf8126681bb938d134b7bdd4d27ac992455d3c2f17e3abe32b8c2e83067(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1badc82b7fea334877e3eeb60a4c213913de269b3e512d4eef38be23b408a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca85f7f24185cc4b2681bcf97ee40c3fcc920d28624e5bebfbd315d2f5a5a1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234b1cb3a6b739cf9d52711a1420564fb2eb6228576baaa4622ae3947549250f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8137734564a9bd17b17d7471758ebbd330658fd8c82d35c056738ffc2089c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084dac126dc5af4982a67557f79b9d98c736dc70efa5e2331f1999d69d755f06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78db30c13ba4dc7eba4b5acab4d59b726e1badc93b1ca188be3cbb3aa31f6565(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98885f7da124b8e471205ae6f96a87043709946a560535fb8ca86871e558283b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a0d6f1b45bebd2b81d8b4eeba8a5edc93548c9b9dbe05bf780f279b387d2b63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d6de0ca460c87a5f2af5056717acda090814e9912cc92d686c22b39869b563(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63fecd0b18a936bbb187fbd078a38ebf121ecd60838c9619c54a54692f893d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c1c2ee612a8e369ac8711f1679d8a59008f9f603c707e2b310ce0df5fc692e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc9c5839b3c389f74e341d4981914dbef12478962b066bc03c1831988f2b347(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d392589750d590c2285e6ce674cfd518f3231cc51641d1e1a52c10e4a1b6e1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87556385d847f27d96fb095cb3ecb5051a4504509834241b0c97e9864e80638b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce5622bd46b9a25c6c48bf9860f0d7271d780b80e5948ae83cfe610d302b204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d339ac80f2873edde141e62576a0fd24c45cc280eb86670c28b8b6b3a1f137(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb117c0dc4b990ad6479c8efcd915d6ff603924c073fd8f6d0b3a2e38e315572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97607e90371a6325fa892ac97796794ff9f9888fb433638f50c14c483d09c37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c373a582c75a09a7c4d51f1f36051b69e2ad351d675319e201c351ae8e8df3b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57677d28b97a60032dd0359e9740fd22971b66945af93f00fd8b4747e5c4ba70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c250bc68f8abc59d574a70784bbd703ca2ca58399eacd254c99042c27a8b936(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3314cc979f6e91a2fc1963867812990610307dfb75f014f5ea792b5539dcf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9773107e61bfae524db7678ec5c1ccb83a4af50d951594aaa29a1fbebdf65439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229fe4e7d5aaf4016239bee18d10f6608393fc7545478b7cd5d64854d6ddb03e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9402e3159c0b979499e1b22513e3593717999ea49a6bc3b2a3727dfae7f837e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258d335827c267dcef3286ab39e9f9ebbe0ca6b412a37e7116bf3fb9c2cbbd28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5eb549c7a70ea7bc25904bc575e744ee6ff042ae0f6cdedb517841054c6c99f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2bbf8be28495efa7ab02154abf6bce49a7d8e2149e0e7a97a7b79c6778da54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7641264decb01843b68eff6d0522ca1957302bd059778432e91bc8f02cd402ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593593c19968fce59a0f5803f8fdf9d6c73ed10fbc8666bae35086d10b7cf4e9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f40b35f6a30b8acbb02c5c8d12d19fab6e2aff2c1d837b6f094d612050b7feb(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aba99a388f031f6d4dffb59b706690e63d19d759242781b1ad4fba8a239fbcc(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e53077bdcc7daf3d5047b895557079323f410c70bebad1c69b0f4b430a72410(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3d518dfe279e6e3827702a4e0ec17759ac64d08cfd48575ccca16559774357(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36daa76cea4e36166949ff9eaa25ed1a432ddc4c18876245ed9cbf878078f572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c40cdfc9bcd3b2f1a7c968aea52d8af1e7750c4c0d48ec25f45a4cbface36c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d5b78f47dd9299567f969c2448cd6a42b4de2b9fd7c998f2b4f62b2cef7991(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a075b11afd54ec886d587c59cdc2c585a94bb65b10c868add755d1715f3b4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a74910e884ccc9b49ec4d77870c448f0533085c2a3483d88a7827b1f22ef8076(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f7d86c469880a6694f14ad785a824d295a5597939f4ab455284bc229da51c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf518061e29e5b7091def99f23c57ffc016e774e6ce015dc5d69dede824c4bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101796514f2db95489532e2ece3f81b701bc8855d774b895209e825332d93c8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5742ad4f2e009928508838cd68f50b6fcca97dc7bd3cd9e9c75e1c0401c0700a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af46059c0a498c51cdd7ffcf7242841515b4ea3ee518e6acd1de359cdb1622dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e3464af66a88f98ec401cc62bb531685952a6cc738ad28cba6a2297a8bed69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9ce194484bb5e58c2d476b1104c7686091477f0f61aca825fc016e6bdec7f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e180d98105b190150693a46773387f121ceaab59ce2084e3b0511add1502f0(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be3169d07be53b5d6452dd888d5cc30dc933444175568527a05f25290ab1e89(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90a40f9a85b345da5bbc500071a5108e5cd5cb4a55774ffa8078bfd18144cc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d0aa22d9a13f6176fec7598790420858093f90190c43c27e342e7a72ca11f5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f5ccb6c363fa092d07bec0b1e2b6302724e956fb2acb32d7b1b14baf51162c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ed3848564d1d02559170040226030072467fee9a0e5ed43add2a3530db9dbe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d54560680c9fd0129b932bf284ca5119cedd73103260784ea0468a4a17cb24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f055cc68d783bb8aeff66fa24f2975b696b102c1f0da5b0b1055cc7a04a52a40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f8ce9b75b51bb88209945f127cae2705c95e6ffcefad6df832cbf5d0c3fd836(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec311fc5180b536777887059b516318e716bc180b978505bfae071c69f8a8ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95428f3f99fc205861f1971fa64a7cc32b149192e793f2ced531321aa95dcd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df411505704bd4bcbf5268a678df4629c3163110838beecfb0390a28745740b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca81ac1eb9ea053d340f87913250c6e9975c08b6eb8b62064cb806366beb0aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706d9fbb43940e85f6520413cc40d0146f9740c5281541018dfcef3fc9c203f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c0eab79df47777443680c6c53453b28b3eceb8f65795bf4ddd708c9717bd8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa14d7dcfccbacd676896dc6035baf3c01a7295bf2a45833261d9ab5db1daadb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d61e14e06e7a9dc9bebef230c4370e835f3d13629821fe8411a35accfbfd5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c0e9fbd5f08525a413340e8beb707631556a148563b13a9323385ec7b82f41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca551ffe016d5f53b4c3d46e7a9a109eb7e9de93454c0ab12339acbe0f9bf691(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0064981234220fada02ac5a98597625d443cc02634ca88301d169e2c561caa98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76cbd3e4f747877746d20aedefe9b05c4f13170c7935e5f6dd85395249a510e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab377d2d9761638617f5ab2ccadd021608799bb63bce9adae31233ebb8876b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbcd2986e841125b55e2340e8b56d61a80f2ff9242715d2457124711c206f7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bdb54c9d32b1f25c0074ae68d14eabf99a3296a543beb1d686a0a978d9b5dd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2d660206ec1f0706fd24f20716124e6b4161ea7783c043f2c125afea054e6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a616d4a38bff18a898965e047418c6483761e84d3c75d7128da1fffe3d269b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b49e26aaa5bb136b09ab922052edd033e9d89860638aaa2c8c1f395eab17939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4df4ef4605b255c7ab7b552d045cd8f003076ba2684baa77e26abf687eec15e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__852cdc4068a68577ec7d475877e4875d8562b4c2d478df415acc40792fea2854(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3a47d919d95074d83be3e3dbb99b9f5db492d319060a0475afe74f467db521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c14d3083ce9928754bbbd4e4ca576a8975ff69f116cb38d610d2c1a0465a52b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132c802ea3562ce28aff150517a22a2648f48e916fe3cac6bac7578326046aae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d11ddee51d21e3d1c2c816d12343e5d032757e6226d017747a705344c9b03f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86846538d68ed76ced30cd2be9c4866ac26ae90c3423dba74e77139a6eaf307c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d9b76ae76a328c9cd19e7cc9471c7876a2289ae0b84064bf42e10fb1641a61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc59e30c52208e87613170e78a14ee26d85d6fd2fa585b40b04cda73f09ed0fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2991bca5fb40cd7b6ca9f16ba8965f2c85d8e4821b8011140c6b4e4575c8b169(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30c926453702a04e667986569a88910638e1092420faae11e93386a8b5df544(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bdfe41e61ebe530a4f1adbaaf47732269eeb36548fdee853257141aff07f7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6179778e7366471e4877cfab3491408546623c2f270ed82e9618f6c8a7fd9b2e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7798c24f815169874630b8d4d4e0908ff26c3ba3f00f42e3afc8838599e4573d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b8608120e5cadf60ca00d7aa5e79fe9f2c936cfb3d44e1d5798ea84482eb13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499d49973f51ee5a7751e54e9208686f1422e98327d5bcc8830583e114d313ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead2d015f06f634fb811372f26d58c72a79387bdde8c2315dac3ccbc6353451a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552539701e9cfac7379046358997aa1a048c4935842c5285b60a0bce741fa962(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3c38fb20e8edf25e6f45a61d2a880742fdf559d7e5a63a30f5bd52108a29ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c284fb6bc514952f531e9e4ad8cfbb2a6e7533da8b24080f2651ff2c4aa06f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__130828121974a93b1aba86bac4ae1c9473d6bdc7d85d4647c417f76b073b6d78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed0340a76f788415e00cdb2f01a695ca0d0d4d03bd5cc17a7ba34b38da42fcb(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d11681c13717a86e9c9bb112c4b870061e00ce5f060ef5d9f041e94e856ad4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e1b4d8d4662d2e468583077e59960b430a8e02315373dc0b1e93f3447f324ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452ab0d19125dd00db8a683837586f862801ce807252d75071870e33211fa72c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f14c2de2ec0efafdbe17ff0eac4af2cc6f4d43ba5959f7e10b92ea7aa78046(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90f6f8452a52b1c7a1c9c7f3f6b8447baf7c06defbecd39986a9b6e6b8957f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb003e27efb65604bee9918231bbeb70cd3fdf5c324b79c6b619e40761fde3ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc8dc10d8efeb07a9000df3ed763a312aaa820e155e30903ba87b181a390215(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b9ae72285504b52282659a8fefc7eb95aa6cd632888a54c31e45cce52287e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68aa46fe8edd22f8fab648bc4401d3c93ae2fd212201a55b4a8bb0d399b4069d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877f7dbef82674655388127d9cad94abf75bfcda7ad0fc2096a31d7463f69647(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9798b28410099717826ad4bb6961ccd1f398c0f7fb6977b023482064655734c4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771055cce8117a091992eaa1307229392721ccf8b6e62fe6e0c9111148cec6e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f55219163a1a336e448b80be4aac491f972c785c76d76f6840d6fe434a955e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d921e0fecf0ba72dfd42de076b13321aff222abee41f0d0f4961ae695a0f765(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd40742ec7095e9ff7ba93cf71aba2a2d2d8101e120e27840de2df7f9ddb451(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023b90cb821921b4b98ef031e76dbb581f551e8172b26800f492b35087031583(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1e0a2cd5bf653c4d221f3de668e445156b0920aa3353035dfd6e5de7467153(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a268611858de5809c376e28e261e95b901e26c39b1480d941b38401ff5f1d6f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af033d6226734b2fc3004378661132afcf5d32937955e1b36aecc413eabcb253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c590aa6613c6a7d5cdad687c2995311c7639f7869dd3e0e9b0d3fc1cabc7090d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ded2d3871dc993d527f86cad99f357d20bb02417f5fe77ece174d2a8b1cc6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa825ab7f90d5eb2ab232b64eb96eafc0d5762362eafab9bbc6ded75b54e4fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c6bc2c91c69d9c0ca888c0f80457699531d1c4c38ad29e9d9ec14e0e7d13a1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda95611cd30c4146f9edae8519e6ef873a2e79fb5267a55609922716b0c9309(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db596aa9a0ea3122e5a0be983a7343ef1bebbf8dfd5c229f7d9aa961004e222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6fe0c1086aa4147e7be54e84a46d9d837fa3dc2392473e803f05cfa5b5234de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5e2d20522a6d5abc8f9a592794b9ec6d5dec3b6badb5e9d11af824907e0894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b57339089fbee5398b42cce06a8af50821c40c147242a700fb64b153bc93d26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c363e022046e73f4757db6660024cb6cfdf74c488ba32c73a12d610b7edb57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f759fbe369ca1e173c5c9eb433d8e22d1703d6acc42a7a7d80399426a45afd14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcbd4a1a5f24d1cc3560bcf8da6da5cbe1fb017b82d6cab9a71f5c69832f6c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a15b2b2347fcea51c78d237b0e243083ee78d15592b7b8a78b0ed54adfc66a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c49c75d0df5911c2ec1de9fbb6e8caff650cb0cac04c70b4c4ab0902ccef0c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01fb31fb816556273bb82e48d6f5757484b45a708cd9cfa960c4117edbf5c3a0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ca9e3e28c256e72809d02bb0aa1efbe3a80507ef46c8836b84a5d8b875444f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f24b8708a6dd5a325ac1fc6406fb131d381640c8c07718a3352b0961aaa528(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeaf3a05520bfd7e2793392b0671070b98369df7060743e7bd1c82952140ec5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5bf65bd92edd61ee14035ca607965b305643473dc0f6d9dcfdb88d9c241119(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78704aade71a49fd450c75e543ac088dc1ccdbcbd70264314b9b41c595f3fae4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcfc248c78b7c99355351a0c2c565b59cea82853eb9576d3ce320402dc41faf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa2a60cb8e98f4c3f27bcdf65da3b0b35b67305e674565e0a78edb98aa51d91(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88aa370cccec92f4d1cb94552ea73023a77248292aba22c5a1ac6aefcc7d5320(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73412ab8017f13ab5654a69e5353e9fc658f468a1931f8e564565f0735fe75af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcce6e7117473014ad7c0cf238b80e05e71b68deb4aff00fe112b7ee243d4385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3e4b122be9b8b198c820d4e8c41ae61c455c35dbf321c6917125ae596674c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899191ae24674c22cc5e15b4ad42241bccddb2cf60cd866b75bbce363ee980fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a0af52802617c4291cd645c367ee7c417cc2c60d6de5914988f95aa8313ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e8d71b97c9384708b26a19c6ebf4202ee51a0136dfa3cd0ad0803342e844bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d14619a9564fff80c8de4bc4fbed5a0bbd08e542b957c48163c5fbab6956410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8473b7e2376bdf23c1f206ddb5dc5e7d5503d08fa2cccceaef26cac3f87e4b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae7a54ed517c5ce26e71ed86e4640fdd33248800086fde8c017f5947ab4f135(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8f7a8fbcfd2d2778614d89c26ff281c4c93dc2611942f21d5462fb7e64749d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e17cb287a700234184114dbf94f345367368bebde460cedd7c7734fb39fa198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a96bf2b6ab67735fde47f3782b68e11e4c796c807311de027f2dbded980664d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f91547bb68543592ddf31d0bd690ff0927c66dd940f80b6378b4d9b4d39004(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fcf38d518ad4709baa561c845cf9dc0a9026750e3c35d7eb19a0f934754a13a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4378a900669e5630f4c4d82ff2b1bd1c19e91f485093beae62ca4d05da6b5fc5(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b22fcfbcf1b7d6a841c06d35433d2dad76f6d560629dbf16c909ff6d15aa13e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c32b47b26ab9985cfd4a1b7e84839519faecbfcf22ab8a5c18b8264129a4ac2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36e7caee8b35946996bc2a72fc9fe8489d99cc53073803bfa34c4a75ab48cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c72c38fda9c7b72d821ec7283c3444884264ac601f0894024320525d85c8f0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f29c7b51d0e6dd87791dc221fc7112d2ac59eda352032508a450185387c6677(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113fa5ee8aae6df60b55d636408991785f81fe018df3480043f9d28539138ebf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e4ed6dac00f85a0b7560aab7172c6573d2cbf76bf82fdaa45f6cecd7f6f483(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893087ec69b13ce083a3b31b93419b407ea84428d605b937a26d3ae9cb1f63a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3954410ea2d7310c01d0fbe8cee760c06e6c5145e327e45c0cff2392b2e61ab7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7186867f09a9ef88fc7a4eb5acccc19e8877d130a48e993069d684bc7d71b55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e890ba70c2e330f47a5336a7bd4bb7bf3f584427bcbf938e48d4d846ad60a7b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61aeaaa1a42681d9a2d7237c9b7ceab823ab3e3c9b9321c0a31ccb57960c7b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0cddb63468f1c8a9222bef031b3bfb4d98c2c4a8ae292ad52d0a70f7b954f9e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112f7b9eb4087d738cd55856327b90ee30776de7813ea43c39767b40d8f7e6f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60b7ceeafeff6a843da8a61ed0a899d0d402d560a2fc21dda87cdfeba9f70ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5059b19b887e531b6fd325fea4bba8824d1c5dd8869646de7180fd8d5ea62b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f48d50e16ea0bc394da6c2909b9094814371ed81df2f493136869c56b04015(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abec26cd1fd9e75e82acd66fa218f3f81dcd0fddf98baa16b3574ea2352ab8e2(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc78b01e405900dc104d0411bcfad63a97c42e530bc40eee76414d3a8adc08f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd45fd8c01a3d3d6009ca55d1cdd6851f130aab5b8dfb6b514c12f89532ab329(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74953f7f56f88d960bfb099a958ce89112481dd65d43d69a18bcdf201ca0095(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459b47b972f26ee05d2a86cd042468fe6670fbe31a06505cc25da89fd3b71113(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc96d4f4b255421177d4a5f39744e8be708fc54ede4a57f16c5b4ff3b525105(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d237b3fad87389033580c97c0cb066dab2b1422077f1c9da9e87cc99f3e3fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d446ae6294ee614ac008144ebb85f7a4fa9cdfd13a9e39eed6576e2b7069bf69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd80fe2039a7a153b34376c9326fa98a84232aade75a3ddb1aaf0458fdcf6cc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b875f5c0b78495c309dd310ac5f02d8befbf4d90986c99353086ad8e5948bb5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd79bf35413b926f3629d81ed801b404f8c3aa7271f9c5f4c3acc3fb7c5be7a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee1bfd7992fbd7f3941cd9c3e12387ecd6a7cb5b8a842e69f481d040f5bd756(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22346e508b9570501dc02c987d15b5b7f5c23d01f562cd72e7c6ee5875d1591c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c28a3095966d925df68d831a5698a065537fdee53cf150b2b61e6de45dbbbc2(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0320be8d0b589353deb5ebbfa5f648b16d9a9753e71152080646f07d7ecd9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a4f605179562a12ee727e54ee6adca4de06390a3cecea5560dabf065bdba09(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120087d20c49e60db5996cf000ee87415c8f46a416239a5802be6fc5e562a18b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed18e757bc36182e82699503839a19befbdfd018d289e6aedb39e59ef1570875(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ea1f6ae95d0e61091668a15dc4935fbc0c531ab72ac26dc8d46615a9fc40be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fcdc4250373a435bc7a463bf9477969405116439c97a1b08145754ceccf1288(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435020554961c90739dddad5003de74e2316fc40ab1ecfb4990c00b7239e7438(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9605dd68f97183a3bcc176a34730831e98344e22850a8e1c5baddde38a28fa1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735d5129237898d3608212134a4545c5abe40f2c691b1a7d2366d43b7139b6e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64eccd002a68406bbfb0cac8bff57172fb96ca95af881b89b4c6ab0f0dab6ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b187acec606f244f57e9ec21c60b01a0f9d847a6a3aa298e31ae0954de8c8ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ee05a4fb56c1f6bc8d269ef99251d634ccdcbeea5404beb724a66c0ef96c43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4acdc8d76372fa83a7fc473e1a37836813a81a4312e18dcaee6bb1ce629a82a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aadce366974140175a52eb742cfee41ee348959cf1e0948de3d5128b101cb140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db6967e8f18a672921618a073aea15606113a4e59d0176f1b1337caca06c79f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f78c9f8a3f72533d3997bd48b7a7ca587c0ad5c50313a6aa7bf046c92c85ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf41dd88b5b6614ea3382c413b3f099f244f3ef673526f375847b19ef8aefc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d22660eb9a3a661f1cc9bd8507781b0fb6584c29d3de13a2547328f2b17846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b2b08d1c4515f949d0371d4f744a1c0147c7999b05a926704efccd853d5455(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41adc9a6af4eb0f0753b565e01d7aaf28bfc7290991b158794f73d44421d00b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157f2c1676efaad77054e4c88274d332de7a8c7e2ba318dc6f6e572b5a5df7af(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352b514ea795c6480a9a5303037412f4575d738fdf167ff053a59daa96b2de14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__184c69c837a6611b5f13f57434003b735d819bb18ab3d4f2e6e04886510eeff8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2532a7def0a9a4c3f3beaa2ff815a0980ec0ba8e9b3843160952421a8d591204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30470cde576f9bdb653302a07060974e2a657f6b2f1be1710581e5721d3643e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc19ebe5cb27bf629aa336158c2c0fe60bd09ffb293ecb0f899a381485c2d412(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5710e0562bf03531a7ea86964815efd6031c2ad89fed5be4b3a1181a9d945b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f8f4c1748f502f90bf49d9f886cfa1813a0f542c7bfba7d1b114d8b22ddaa2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70627cd8d852579962446605f0417e59d5c200a0c3f0722b539f259277cad689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1bece9bad744bd29edfbbb6072d3503275d9bc62782aa216223a11d2614d9bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38aefdb5631db2222a65f500356a745eba5284e066f235cb28ec1d8ba3d1c39d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd09d2d0af1a1142bebb7d9e2e4e0440caa3006496361ce987714da2d31de89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d1179444281ac636df1ec44d36f22ec9ff4ba740be93d4f2f440f4576c67e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d739645c4fed88321dedbbee9f94d527757783439c93d055ef172ff9842b04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2bac7bae424825224425c910299fbea24bdc121c4c5b6da55a3b16248f3e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11051a1c494bd104cdcf74cd11546043e47463d6de17dfbac5140c3edc1238c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f888147e7c03d1c34a23ec4fc0732ac645c6d1408945e165a2fb9253b536f214(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__672a927dd0f4ca68edce8bd8e0b039ebbaec463ce17c59ae15c6bd0a6664689b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3510796dd42b6bb161f855544e45c1ef1796d0dfc5d5f070aa5c57b0053fffe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81bf7f07b642828d120aa0743720ac8ae267bc5b1950dba9b36c71d8e29f6118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7abdc112dfee165634ed7a3ed6e222f62a0d0380dbfac382bd00ae8a293f5ed3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d202a5ad781b0e1b8479dee24207390a5653ee4c73216d1548413bce7952970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2dcc8b09cdfc6b4c98c91e88062e643e43b642dbdd57b99c2e8c3c82e427e41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f7edebae712e53ca6ed621608b91c3476ad40b8a95e8096cab0e978960ecb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df3249ba931c73a63edbcfed0fa891f529840510580f23d6f7a8fdd01d416b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3df365f62ba8a2681b580d2b38bb05e78623af15d80d4f5dc61a6011b3e4681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff808a13ea1f5f7871727324db70e138c40b4676287aa6dbddaada742503490(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcaa5bd341c9e4d4cdce77559913881cdbab5e9affee5a6e055d8c2d768694e8(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad6e856b69dc84ddd2e94396564d537ba40e8cce6b574839255834a7f786e14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c058e13f3064637dcdb2fe862188f70576b5760bd9f50c8fe4d17b8bafa0a129(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d65ff3640ca9137faa80350cddab778aa573b1e2c6e1be93bf6d5fd0c7c9d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af74ac0ca21f4e994cf88ea2dc064ca54dae62bb1bfb4ca612e6e8396934e1ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380f075ef63533dda5177f92b9577e6027eab3f2661e53b80d88df60415bb809(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6c416eb01dcce4a597e852eb1e9d0ec1c7346ada71f7c06fde32c08d581e81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662e922d7b4f212f9bfa5c4ad75ba89d96436f40b289f2a351e4deb2937ee7d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6292e76d98e7590a5ec2cd92352ff221de3f82119d861d79cc109d84cb641130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b473a63dd72c6b86cfd7b779d3b86d6b281697b63bb22b44728598056451389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37fdda287e04f7c2a95c52563562e2e36ac427510ae0a787d16e1dbdb89dabae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6bec4717253d0af2a8e9a8766b8d73dcbd42ed1acad43450b2b5838fcef0b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4d36a39f4c120e9a5e031bb41bd15403541f3a03e6d20deaa4fc3cff0288b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4acf5cf66f12744febef4021aa290fab362db79cd346d14ed54f7abec2950477(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6017ffa013ce0b05065a6ff829028540fac73a8e36b59cfa8214e71eb47901d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8ab01dc83d1c587943e03bcd6101763068eea865c942e1b1f02e4dc37a6e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5428c48465ba31ff17d00e8565a1d5f033a7273368798387f08c257432590423(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d14ff9c72a7dbd0576bf06734535f8dedf809d6b628a3e2e2fe990e9f8859c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6acfc22d45964cb147a0877c1a9a39d2493638791577d844d8221f317661f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfccf281bcf74d1b834953fcca970bbc29c5088c64a7b2675a7d1baa20df019a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72211b05e76b4db27c4b2403076fa47818fc3877d33120d701b87f0441d562cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ef97eac1a8b5194139ed0bd41772620702e55f64db3ded63271203daaa7a5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b23c39dd480c8781dca0fd702f8a0a6c6c727825ebc252727e67d4be5ed1d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e5b72e45288020b31196c0b79a18f0d813cc5f8713cc29828c1237fe4a274a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2133725e9526475ae4307da791a7eb9437a997bd38739884b3bb86747dfc8ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf728d6f3a4d8e974a1fbe518bcc81c356f07d4d129aefa35bfebe14ba729179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d63e5940f8a291f160c0d1fee42cad5e77a2d8f69dcf9a99cc67ede6e6fc4e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0e775b6505a26b6f8023aee4079d050e302c1b4fcfc5e15a28809314d100be(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9782694de19b16920302ed8d366d284b9914a31f0b2f0871491aa95e134160d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2a858180e90264eb32980cdd4057c5b87a6c1165a29c430ee02e86cdd7951a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0484ffa042f068fe742ad0f8305a7f9fa1bdc1278941890a4570887b4a0d03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589d3af2a7908737cbc24a36fad3598067060307b1a1d427cbb16e668dad9921(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c52fa470bd627c71fdfc60394d947aaa79a2905e825d0b65f1c3efbbc83a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f3772603b2b8aed3d6ad479e83b2e6511f318287e350d1d4fc2adb17a1b85f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa9b14c5a68fb56096ac78e45c4b67ead498d4db488bc0dc441da06f2d85652(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070140141d9ba8159b18ed1ed21c12e70c08e56683b9cbf7cfb63fc94496c228(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f526eb6142d25be7184478c11347a19d425d6b77670e3294e6cbe13a9a8fe4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46dbbce7953577bbda5bdc1275e22e80c9699a5e3c2a7b7ade6ebd8eb14f3193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2fb24caa4047da85daaca810dd865a125e8271e92e78281d2f11b7b5ebeb823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c87a83b96595ddea74825509b9f5d814f0c8130a4fdf0331288b5c3ed50f42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca9e50ccf18104b490a8e8c42171d021f5a7f9e9e1eb21804271014b2c1763b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62656d2f013150797f55021300396aa9711382ded657e61cb77987ff9ce89cb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f93271a58acf2cd78fe582a320fea4d743b7465172bddcfa1d33211343dc7d5(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30033bcfd16fe75c6a858ee36ed7b77f2db99feff067062121d6488552698246(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5e75651792706a90a9bc39f9d0786fdf9cbfa6eb77f7b4c69138bd9d094c03(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__439ce4ab2cb95e38bd6ca38a2a85becc71c2f6d2d6a2fca55b5b9c03ff89d5c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0546dba7e595a5ada98063314f11a0c345ef2b031e83c678ebcbaec06303bf7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3460a488e5366f192d40fb7960358cdbdfe9f1d5a0e08d5774fed222024b7d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c18ffbd3081e8f1c05a6573d751c92f9662f54344caacf0a57d2f1e1ce8ba7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158f077a9e0e9ebbeb741fe1444251ee5918816a9b0007f743fc5b6c2e5d3697(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d84df34a896d55c14df7cd93a29237abd7659577c7ea7ca76a438b3b4a1fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800b517f02624594aedd4eb17cceb8cc752fb6fb9b0d6002eb1d15d65b2a9dd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf53557ed2a83dce34db5c5be26eaf0a886dbcb76fb6bbdd1e4319340024f81c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac786d6bd5ca456486d4e7758e2bc8e7e4a750f63404ea7b18bfa1efc763abb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92680ba46698195816ed61d852b33db3d994d944f78bb0058ece97bf4cda0fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4716532697768d2beee1a490eb9f05e83cbad5c93e8ca37282bff09df3432812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb637998d93cc7debda1439fcf95a170dbf5451c1bc04032b985cefce61c2470(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db974d8e5d26f26510b2e12169552b39a9a856a684852d6da0153bb3a9ac6176(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d315a92ab2d2f85670347d70dcb41ea25438cc11bc39b591e686dbf20388c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad142cda03d5141c4839ae7fa69930e62382a23a2931162b6118d4d0067076ea(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a93e42b0f3c2cc2548d0377b44094b0f548291cc2772189e0026c3636b563b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1041faa273162ed329cf3f1d03137109e34d513c9d104a6e672324f72c3b675(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5170b97e3f93311df7b2865fa1046ffa8696ef028ba7bd0429112ea0c9fdf799(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55cc1a8690f2c9ca744b648c96b00117e935bfb72e5112090f48677de0c16e19(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a9d022f82b49b6639899c4f042d7c21527f0fc4283a35915fbbf7edeb832cf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1992a2ebd581befc1e645e623b0942a9c9e473a8d64d42a51eac34d6b1c564(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37659ee1af2dfbbc991d8b54b08200dbbf6a181463adb8f723656bfeb9a497e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b2358a6dc5ce0e47d08120da944374ce357a626006f67bad2c3f22fc8ce64d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06340bcf8799015f5300f75ea7ce00affe05da72fe2c364a357f71c199fbc288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98247c353adad9dc1259f40ef5f9d88eaff1d4e81be154cb4bc284e1c102f7f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21978b14e27494987099b0c872ce2b440134387e1a8c3054526967e896fff06c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90660fc8f00ed304ee84c997039ce88a79f351bfe419813e0b0485e82ea075c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac54b82f027af678ee9215becc32774b90ad643501db0f5e2023ff36acd67484(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ecabaca63ed8227ff08b46a491559c9611c9620d9c8ed1ec11e03b865cfcb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418aa9049637348a1f8a64ec2b87fa6295d431ecbf3eccfc15499229b0d9d100(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc29b9d17453a5eb30adcdda8189a021fa765fc0f2b4502719f7182e84c7071(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04522e2346f0b8a065931224f90a9fae8654d4d0aeb895f2b883bdbda8ac9549(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7652440e4c5e003fa73239ce82f28a37f155fa1f20eb8ecc75c35c90e0e569e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91be8c03d4207749f163ed34ff73c49ce60f62219c4976ff11fcdd498ab1a488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c8f4d8135554f507900936cd066b26e29827918ec4999fa93a79a5d26320a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a407fdbd510b884b76dc7b5ece554dbbba208528ef464be6c9a63248d6fce705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a53324ba7d4a5dbd992799c4cc6dc7430a3389eb45e9998369f1f05213f4f1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f988ecd3d7a5d50ab8e11e795e6219e144a9c7641b03fddc995c105a3738e6df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ecf0a2286d48b78ca5b865c3da2aadf6c1c26976b68f4fd29f65e4768b61ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d2fb289372aa7a5e6d2e3d2a886fa87ce0e176a609e22166bcd665feb98316e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707237da2f09210ff30fcf9656c9ddde2ba80b2e06f71977347962ded811cf2e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12405fcd70a799ccf8ac274ea5268537e0f2f6f6f00460e9aa3d3712b9aa00f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c10209ac8ee51166bef0bb7d5889a5ca11ffa37020b707d64c2455ea559cdb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6098c052d99e0ec70038acb65064a1d5d633defd52727357565a8e2070834e5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3999a7a3424b8c60fbc79e081965c9fb9be175117e30f3be71adc02542852e27(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da133f69f2367eb38fed117e8a5745a6bc22fb20692472b778591c0d70bade5e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9c2cdd20c40975bddbabc499f84976750af0726a9a685cc4226d273900db41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b585a80f9e1c550631f6000b54dd7bfd4ed1c1d54e5145df6ba1c6318af883(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fadb339dd378392bce539bc691bba81d3ebc4244e5e46a83727474871a5c67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f12bd46e0eef08ea24e0f52e31fe8180ea5abe002f7ae28dc96a14abfcafa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ec5f099ce7a275d0b79e84d67c4f1126c3e4ca3f8785c405919ff6988925f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff6bb90c1112abf5552168a5c5a4d7e77f264dc8eaaffd2a30a03f797128c804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e5b480c6cd94d286b82d2bc4164a59da76fd97911d8151872c9fd9c7b14d77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c2969ed79324c6d5049bf8310b9ca2211230eda83f4f17c33459eff34fbb9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6661d1d71c10c586aa7e70ea899ddc714d5e1b63ba0f77f1bf1078f23d5d5a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e62a7b7afd1d7fd10244eaf92e944fdccdff1d01afb748e6822ced78fb6ca33(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e678b5373dbcc5dea933d84e7476c5b16c6a84be91325f6c795f022b4fc178(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ea3428f0dc2ed74e3d5eca12c32784299d011164bda1b4829f3ebfba7e0dd2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9c564c60c50171985c951281cdca931953725c6db173ddb5d657e68ef2f0e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d733e7e45b96283e82c4f022dc4768a9fee034ca5b0e0468ca584b31ac1deeb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95abdfb8e89c928a8f0d4073a64d7b0974275cd3167359a7d9b4d99aca6d2e04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda4f2c78d31bdbc821a15a965ff982c0dc6fb5952559d33c13e4804656e3547(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2c66bcfd8b792f97d24fd4758681bac301a9be9bb7467095cafddc5b0590e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925ab8a98c391497b6517a05f693936179371c412d94bd4db9f351d896c7cdcd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8848d522a7f42687cbc6b0d56045902a0a9d0adb54e2a24dc4406eaf179eb7f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ada42729633bd364acb67b05b0257bca87c33ee9b0ae2c0f0d152fb4cacd997(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fcd5d30b4095699b72f98aa0e2db91ae659b03b09602d564e0554ee9f797d0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487eb8776a74da88a0de8b7d25c8d8710727b371fea2b1a75d3587e0ca85040d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229966e3cf9d2b6ad16127b434a894ede05801d943121ff76873cfb59a61105f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4912e8b60a54594945035a4f5b95be651a094860412ba80143c9880ea254b2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e964b5b040369f125c35c39fd3c900ca0afb5334376dba190700864e9e7ced(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b1d6e075c12a4c5440bcfdd24e5c72b43291f326ee591fdc52f081a94cb4bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd18cf61b294961f69c0d4ca6a9affb1607113167fe19ffc4800752d67ac24ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd0d7afa94c82b97acf411192b6b566de7732a8a4ab479c95eb513176f0fd34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb9ca7cca899c04eb8b22f48c0c4fe8434fdbd4efd2d95134f9c6cd776e6178(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f4dd436430c0255758c3333d6d6a722bdec6321d3d65d6ecb678ad21594219(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc9c313b7cd435f7a8ea337dbd7882fa8572681acbfb0d1d4ae66b3bb666d85(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0789cff498460f8b0f0a45645807b17bacf82921b6320e8f92a652dfc7ecdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8f2fea940b233920fa05b5c1b7525d0d3b5080e1ee6de892024e07c08713cd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6f270602f8f8e13dca7ead90a098c399afa513b819a4ed093bf8452c1188f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a18694fac429e9f72754edad92dd0cc20a0c6ac73a5a883617a3fb2dba8d024(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8326c465aefe746d3387ad2480e414c57082e4089cf6b40f2d8df1c1bf97291(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece91b2f94c4573e2c8ce14014a39ee14a9e348a4ea0563b797c524d313d3b7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bebb217a11411f2e594a8adcbb9e9d111f46ba1962f185d7595d154a8b7b39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055c661f85ee7f5d859e39c80f0cf024bbbb33a8a02765eb911ea36e2b421f05(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c79359bfda8c6142952fff9d5e4e48e9e1147ba9a547aad3e534ba6bf055fc8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59846f8ffbb2de5f4c5ad011df915b8e757c5ad06dacf0112d8de14aeff3b726(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0866e52b127f6a6069beefffa7b12d8359c563a99df001716fa7d57f48c34dbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd6af7fedfb11b259f4608099f24a0e7020d658ff9f7f8fe8a72c02e617e93a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48730d2c6e52d8bee39f94b30a9609439393d9939aa76bd30f84252be2aa86fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0cb0edb8cfb9613ecf9fe0c8aaf33abaad5754abf9af418584ddd0793cf133(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddd4c64c25e7cf5da4f6cb792948a58c0e7fb31c2ee0049e52bafa0507e47a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc716967f03889f2ebd73bfeb0640dbeddda4c7c2d77868ec7e7dec97acac0c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d019445bb7f1b668e437b4cd29ce3a34da6e8440ab135018abd3e8f66d771657(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782e3e7da8b07f8380df25dcd0ac962ddcda9fc40a84136290ffa355f7140009(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840604fadbc3558f3be80164da9759de9a8f632578f66b5af9c3922dec7c184e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c52ab7b883d396df8ec7916ab33e9fe2f06bc12c1476fc6a149267c8401b9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c87de3bb4b28c7595062939105b329aba13149d680e7082420034aca133ab2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb852f636eefb1e3645c5ad3031a3ed580ef38bd3e1b6ffbb40e87181952b7b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b2ac70f216e7427b3d6cbcd9cfd30adc6b6cadf8b5b52ca3f6cc1797dbd7b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a35771b74dbb0cace5ce0c65f9d173b979aa3d8e6718f0d92fcd7ecc6ceaeb8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ede61e0017e40f4c41a2f9b75dee48d75ccef6f37729a17ce0afa5122e121e5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55139d1128da138ec29b3a1319aaef2308eecbf497da81f851cb8f942c580899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66d78df115260dd599e89e711ecbbf1b58493caaa62f03ab2ee1a167930aa04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b41e1675862357ed6c8f86cb2169d5747812b8e8b94d17b22ff921c24e6183(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec13dad14fe7c3776f930a692bef6be23b1f961b121f231f6fadaf37d6b8f96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136f8e96f092cf20da7ac25e7b4b2cdb728c5b192a41cdaf34075bf9f9248c1a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd29cf58609e4a115763160d60cc4e89436b6da087bd45c6aaaf7dd0645e2049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b9f8a101ba88fe05686c3641ae5600520dafec44a363e03b44ef97a02af025(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb50843749b8c457fbf675186d78c70f52dfc9451e4acdedbdc5953ca241b1c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0413804e010fc17241af3dc5ac33437686464580fe157d1d70a1014a7db00993(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2afa6753dbe28609d7a1d2ddbc89a81ba5da51f26f395343c5f02621e7d2555e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f155dc1ea740705e3fbc4567c7698886a456684e2e8240b63c5ffd60564c9869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9270845468ac6c22a7259d5b15013c7757262f381e5659869790a677ac752d91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b4554894ff6f08064af567e53d3bf0582b4d4d15994d7e84338fa1644d37f5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f46db330f76223edc1d443580fce9def4b43e5f642409533762be1a2ede91e(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b886194829ca9d301179258fa28e078a138d4e479e5870c448658fd261bb6845(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495cd3da4ca41eeb076bc3b5e76073fc59392f7e8d4f996b0caba1df5bf6e99a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5671b5331f761a149297ae0a1ccf85a5cd33a18f4773801bad9e5b30c09fd1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc1bdeadd1c40d08790f9f9f29d28c048ca62b6ad12529cef3e68afc2d1a453(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423f5537a2e0b6a2119bfbd80857474a1c2493c2d000cbdd1a49bf1c46ff5489(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8661e9bb560050a876c2620958d4345964f29cc5df8f1c2f95eb91383f632d40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f20db82713304b98f3d25cff423b5b5cd0d218b3044d1c99ab195be82c5b837(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb82ef875b91d847dd81c1e04c02338a2c076fb501f322f3ae0d6dd8c5d99d82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfecf0a24317d92c54d2177d03a8fc1b1df51cc3545265b33bec9154f7bba428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e14e5e5ce08e80d9212df96030d478eef7a53c38489f9820be3d9346358237c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508b910ce829574a13700ec12dace11a8455c27ed01f5b16362d5bbe0fc757a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003a3b1e89b1360fb167bfa11b23d56ffff1f58157b524f2f8cfc9bbb873c3fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b1db63db4ccb1f2e0099e327668b96e7eccb128fe7a537e477c03acc7d2495(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32adf7da82958c53a2f07104a5b6c431d2be7f0af0734ea0111664e57c6aadfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03fa51a00a74d6dd0b006f9c74e0040a9ead5a817278d5899ce7f6d564d4465b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9953e8533389d0720de6435f2fe31a0c97bce476586b6cc493e86f52d1093787(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da19075e78f9c116048612a60d68a3c41e9c59b6be973bd7a693a0b3f24bce3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d14879d342f12bfd11d5cbaaae04f9ea33c0d64bea704e837988f5e57ad69ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82489f9f88f8fe2874992717cf02c00c4e4ea9cc4ab967ab405e029211c7cf8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c022b4e7440a8bb7e0af33e1e6e26249f3dc1eb394c36d46724867b0a07049(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5debf2d62da4b8070924e9344e672cd2b6bc9d10856c77baaebc51a6da04756d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab954fbf1db6d9c2290198e49ec3bdf477c4e00fce0fe97aff4b291ef2d2d7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1ec93a29a346276422f512f2ddf5456f2ef5c1a5a5ae148725ceb986ffdffc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee68c28326cfe98601f6f0dbef3715f61d9cb773434730d9ba3d81d5117c3a1(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23bc4515d7f2e287a187a265a21b1f6bf595c54dff08e45da7dc995edfe07bd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f878a060b20cc55868536c401fc2120654f2f35c881942f9641b48b244d050(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab666ad817e5d550efd239e05fc61ebfa06870b5289f85c351ae41d05e1f4d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c6970e4f5c9997a0b392a1c7106e59d9405e74d22f1d9014ddea23867e3b32(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f68e90ff7e4d7c4c60a0eea21eecda809f3c99ddf6e1079d9ac2519c99165c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323a393766e44f1aeec4064799e570ad28eb388bcc2babfae215b2427ae8536f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1826e28fdfa41c83d04fe8c17401fcc537735608c654490804947ea3d93787(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9bc9c8028e4cdea183da5b8302ac6b24281777fef6f647ed509ed26eff8c4e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fed5867fe26db40a3152d37234ff058f7e623cf56538e44045f630db934c69f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2677d00f5d0660758b5d1e0c1394ad9e10fc3a91e2f2815d4d3b96cb6bd842f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42df00463af1c3656d83878a7bf035c22d4d8025b3a930a447ddfe5c634593ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28af8954f467138319a22b5b8e3dc4e70f4a9f6e0b8c36fec438c83fd5cdf7ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93bf1bebb87eb6ae19bf971f7e1f314b3ca4753862d814af7866a49d2aae4f02(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e57b2c1a20243f6b54e5138532325cb0e0251d57539270bede73e9bbb5188aac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ee9393456dc12716484bd084faaa99b0127d5e41b9e8535c66b87639ca1cc0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__778f3fd7d1b78b90c28aaf00b31459db0321aac77648aa420f8c0bc7aa7551b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9752e836a67132f01752f4b18d6490435e713f6b2698c941819fa5813108ebb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cef6bcd61f404e751147ed5cbd949761f639bdcca083407b8caac3b4bccbd00(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a35c74d0aff7c6c59694a6abecdcbd7209fb4c2df73bc9ebbc6c65d412bac255(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dcc09b30640eb577d1ced7b3725b66b61de14a3399be6c0ef3473971ee8beee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa05d853568f6e52d0bdf7cc1f0bf01f0cd2f6f2e7a147ba5282e46de19b7766(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08dd1f8178910b7fb9c78770a50db84edd2e8db2d2d4932a3742081941f1ac60(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d480eb07189f0d78656a4ae03f164e5b44940b533ccb64bca57b688915b102(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3da9678351d307e319c3dff95fb0d895a05931904495d39fbce7158bc613d0b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a037e4752f5012911e918f6d7eb2fc7ccac483b6ff943ba0845f83f667bae7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbbbc0e689a43fa30816978855978d122c955300297ad66f1d1932e0b7c3c939(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc9733086c7b3bba6f85f9cef968baed77a3c7db4860a4f080974b617c5067d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9a617911e7f6d85b2cec43a277c4c68e7af49cae76fb09bdf677c8d6afcbc5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddefd0b6fad09f6fdc3bd5934dabfdc99b9cffa3d3be393e7626603e1909e208(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5183142c68702e1e3651f1f18860e370a9abad6e25f98ad22662bf926152c7b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902b226479b145211f42c0307738160a26cb06db0d52856fb1b635382be6b82f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c689ac82d1a3eaa5d5da1fbbe2edd8c51dcaef8b9269838429dd5f5d7ec8db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ef6035d52abb718dc9f04f83ada67746a022515cf34c94e61104e94d52091b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a26eaac34f40b2d75d24bf6a50a5d747a5f025c1f2dd5a2b990a69ef9a49bd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01699537fc379138092bfbd33c19712248e9e30dddc4295a815d3a359438eae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126e3a0aaca97e73ab303d55129f699aca18fe3d42f54a803fdca90a216d463f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb30ebcd5766a023c7f28db3ffe2d1eba2777ed8abe34fd06017d6998451d40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2deda08f1335bcc5f05c395d39c39e69fce4bfb8f29a03c829bcd4be5dbb66c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9f4483c1753fd7856b87bb80a91d3fd292fe147ff72865211814a73ee75439(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c4050ede48c3ff3c3d463132295d847d6eb7666a38fc8cfa4a83dd813ce38e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59332129780e45799e4d4b0f8e8388e5ecd2e81082c21e86c52f4240c9f150b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da03bd0551ee50403e0ccfca39be359fb472a595386f8f593526439b04077ce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1230e91126e9ebad79d323f90184151174a515bf6238ce0324a954395567cc1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43618d05e7b3c612be507675fb0427490a9825460c67027270e1c399c4c69ca0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa668e5665bb0687b08019b571d05cd4c6df2e28d20aa6756b84915e8799a13e(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc5059e084fd6e9e505424ff4d5e3f418d83650d6a150eba222ef5e398e1b07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b39fd234aad4ba0392dd6079c744a2790ba64af6eb285368c711883e97b9a38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540bbf1cf1895b9a7346ebe35f01f3c4f9e7fc0c5e09dfa8bc7fec1a0090f102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643a4898ca7919160386d271dcb31b0a6d61531f46969794adb14a5cb101d79e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a42bdeed477a53e6fc5300ba604691c1aa3031180c6ac985e8c00706b150a50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff5b37a3cf9dc757762e0a628ba3bb7601e2898e2c44d86c123e61661827f03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0072d1f7da5cfb79b79f4a4f528f372248229629d5a75fae276a3ee3c1096b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3627bb97a36c1053a77813019522311fe64f835ab654b5b45914ad6e2aaa31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621f035390b05972dc7f08c5f408159d6a5d707d7c5779eb2d28a20cd552a3a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f58cc66d37a118d64bc5bd666dd6842f060bfc12693b5396d04b86a9fe3bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667444534c24ebdb8ed3606ddc599a073e8598e9e1df91268bdc8c8c0810437b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0fd549bd8e26abb5b48511abd0c8107885621b6022f315eb823497bc16455dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15b90f4e2062fc5ed02ad39fc7411b488e52c2869ac40415365cc637202ab6b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc5de8eefc10ef886e6710e9fa1cfc20cb654115b3536711fb506ea01f13b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7252cdbd0ff12528d7fd0e20337b73dccde4d1bfad0b641733095fc2de20f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0fa4bd84ca5a5c8b2b570b6fe8466141fd5b91e8bab238a944293a79d41eddb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f68e0fcce973094ac892fec8934c9fd086df3e7955a222c5663d598b49db760(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2a2b2b82fe26717a676d21e0ba734f2a418446ab25aa2fafa03a5844e53c4e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f91d769af71843725ed8af3a32f486918f3c4e0d386aaaa989494e79a456c6(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae7c665af977223c71d5b8f5f2c9de51d9883416dcda195b998bdf8fbc882c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ced21acfa3af9d8bea6754a532a48b0c3839a7164ac03d473aa6c42eaaad885(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23bb611bccd2bfb179cf51bae73f1bcf85748c485ada10281e82a4a6c793dcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f133ddc4cf494ec07424a61457e8a8af5972aa97fe4df515347705028f60f34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2767c49d09d59880ca61ad44ad97a8d9b94a5404dc16ac465ae55c87f51439a6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25f2b33d6d4493bfbfd6a68cafbab1e3dd445f3c74699a660ea7ceb08eea45c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2991ba004f51406c716f0d3d51ea0a0dbdc10aabd2c95dbc4d46f70a473f5e58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a43f8c60b78d98ba4865bd80d7c8e0d5826bd79efac3bb92eb7bd72bfde23dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbea39c7fdff8f94f3a8c30c0e25ed68bf1bae48c656fc9e12640d3c217c394f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21a26aafda96a49696738f199e18321aa647d920d7748dc6e4afb74fe896a36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c285280fc6559cf10cf16d976c1e83c9cff95602df6da0c365da0f2939975a9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4ceb7770c9c4ce0167561edb803fc0531528fbe330b5dc134eb165a9eb504d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1161e0f2b6969e77618c737e27eeae04ceccf61f61fc21d4b40aab147529480e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac47b50f9336bb3e945392625925f9d7411ab42990a93e803cef7b9f5a53a72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568c239b19800f07216d29359067802fc5c6d6db730abbd90a22e23364940cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2465f57f98514c369d3b1665c6ecd1f1f647f39882b54e26a5ba2b20f3a71c3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90bb90ed166a351a2090da7d61d87e6e4ba7dc34102257720ccbc0a5279db95(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edcf7caefce271126358839c140dd58f4a84deba7388bee3c42858a50d3dd84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974939e85968c455e4625771486fc39b6c033bc7f2be2f018ec8411ed6ea94b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b111b1aa78f59d52c8f58364986311991b51dcb026dc2261606e021414f699c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5dcb7f3a130958c4ac48858dd6f12b047ed894aa667ed52f4f2ac6a4addb9c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61decd8b44720db4c44f5a05c9baa16a481effbd67772f75061d25cd39c6cfe8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e953491684b54d034d059cfbcd1d1f346204fef7aac3aa3b855be6293fd25786(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e305d5bbd103d76f1ae1ebb2349312a1faf3832152616dc8a1465f41d3136d9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674c413f0ef443698f4d9632f8a9ffea2eb4e13cf725c04ce33fb1acc72c5863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec2a36aaa7bc8163d9dd1f098e620754b935101a45d7947b2395d1ea041170a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b19717dfc183065fd7ff591aa0c97a5a09688a94950574f00e1cb91deed4c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b02ecfa7edbb2d6ec36ae0c1f91bfbc250781718f5762410b0e3230cee4bb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac4ab70a090f46300b7a4760c43fb1c88906d26b050e4c40e2ca34cc92bf1a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4294f2c465f93c56ba35c0fcda563f8c9d8989809a960c0f00e03269d56285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a06aa745f3f13376c1d7c700dc7fcb61e5e6c63c0ee74adf5655138d4481716(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65534ebffc06c71c7d12c3a697be3417b818ebb7a3c4e02e0a0e5fe6b90143f3(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51bc12ac7d4669828524bf659ef0be62f66477932c9784c83cf6d31706004ab9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21d60da17989610ff5cdb5b6e91baf9ef992e56c287d11b825980bf4748cdf4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac96fb0f4eda33a9b1b30db00ac22b7696a3b1aa617c4648bbc5dec48057c384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7971b14c2697aabbfd0b9aabba4bfe1eff0fe0b6f78d82def73ec5ae6b9124dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db52251ab83152bbbfd68b9dc48b78627169b38f68ca9f7c12554402ce1c561(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f47cc35fd1886450e2f76d28fa91169af3321232409d3de5c3e6dd106e801471(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b82a46ba193cc36acfd76be3692b870fe15172d2de38ffd8bb9862d027a525(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b331ba278fd0f9d37a9bacf49d781fd1ff577ac9149a8081e26b05f2e23720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b231256a15dfe6686fec760964ca0c3549cd4a682b5c8cdab2e7439740b4c4b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78462e0d69328c5e6e8aecaaecb12310979798144d89023f478cd50845f982e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a21168ac02fecaad6eecb9ea02d4ecf78a2c8a8afa41459b637b2f93f0791d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3781791c82a2ffe24f0404858be0037dd23a7abd523b9e99e9ae77c2e33d60d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3febe641d0031a9dfb34ebb214f77fa0c7f5254e59ebbfbb60d3f58a63a7881d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb89eeceae31fd55dd4b9b78be4c6c82dbd9e4be8b0741b21418f001557b27c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301c38b7dd29c14760be39a1017ceff7c3124105f9a8ce2ef8a2dad34efbe77c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446bcc55efda30c16dba843f9fe7d2499e70e941326068194978c52135c9bddc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed1b63bc84fec088e8963548caec870e938418fce87676a8427536b1a823a88(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e98b653eeb76472a1c17c6e49db88561f84eafaf0513c0e85c2fd9fe4ca2405(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c25068489ab98df76f018e89be22751ca62ed4377e8311ec9bf4997f7992d31(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bbaeead95db697bee42861a34ef8b2475d9f2aee356ce98faa2c3372ac7822(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c38d95e7f129fba36c31b13eb72703240dfa98970404af351abef71a20c99f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b6dee838470e2474337c47a1b4239cd528adafda7bb67b3cbb83cc9d09c64a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea204b023c2e36bbf2e79cdafed107cf1c0d18aceddce5df79fb285e0626229(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4401c01e734fc7c3e7ecf7d259e9fc73e9c56f10859d069374fc141f77c9c95a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98cc3f71bf75ee8bbc261109d7cab292739d9dda05324c657c810803f9014b5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dccd755a1c27f60c9699ecc1d5cdde657338059174282afab3c27a0ff373284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefbc381bc5f65c57f21e5013d74ada2a357462928c4627c13e40b5f0d55dac8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f298ca7e8485c22964e80f39a2727f639b322f9325227b8c4ff98de4e0ce6b86(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37df1685f7ec9a83fa39676a57ed01f4e56eed6ce7235872c54d688bf4549f6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5343b62aa404b22f0d2bb17e767469006c00c9faa7a4388952136553672c16(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2db01c8cce307a8fe0b063a3a96fa7ebb632a8a2efc12ebe8adcb41b9cf0a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7113bdc77908f1f3ef11a2d99a56c349ba5ba4579763a86fd457f4eec0428088(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415c35adea11ed59913a4db523b8af4b372dc0befdcdb747abe041b05d34343c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890ab07ecec7a1289b4772bc8ca84f4ac9f4d6d1098cfaf32a29657c222e1d0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b45e678531261b05de5f854defd39301d64ee4a30d22e5f1d2138e3a0d722e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea42a0e40ed257f44d3462e0028b980de949c7497bb0c86f69dfb1c6252649f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4dd9176a45cd2c6797f00d2789dc54cdf9ae962f00ab39a474346c38441c18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966dde4de256921363fb0eab82eeda7ff5823dbca1fed81e893ecb0b53a4f542(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986ca57f7d31bbb1d1de9a2eac91780b030e3321697f6e00e3e41f027c62bbcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da9e67f887536f7f34d80a5b71ed0bcd36861fa444ed8e516997178bfe1a9fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e303d17fa5712c5b8e6224e5fbaa772e96b963cb9d875bc76c6c8098665074ff(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792ef99371275bf1d63ae255ee879f7eebcd48f186fcd7f4291ec1ed0db3e4dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de3a3f19812aa9c6ea4311c53cd2a78ea6712af142815b0f076057b6f59de57(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b450bc87ff56da7e5ab22a90b6f4bca9867d48abe4dc5f342ea840c64961c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb080e89f911093411a2251656fa33cdab4cacdde741bd1f3fcd02766bb5db6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc2c8c8cf9a33108e56e2d35d5b9be911b0941f0a19ea4842c104e3fa293467(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2303b39c3bd02fcb70ad8cfdd3db5797b42d9ec0bebdf5b7e5d96ec238d090(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a47b4b5024db5379f7d321a0f34e92acf76cb2009472c23314c894c798e27f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a548aa2511e11611635ca5f0fcde4f8b1c2f64b75ff5741b855a02e52bcbc072(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35eb05cc1bf7f775f07d4a29e90dc254075e8a4d006c5c3ee05bbd4909750325(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208fbd059816d5a6474a903944f324bbf0f487ffa948ba0dedd0e0c2d0df2c50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3a639b763177cc7b58ca32c6894f87f0939d301c075729a3646ce224d00d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b308208a863e672f47128ff6d910010043646f8b02b28e316cbea35a36ca94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb13209de431908566669745e2da15e4d4a3e53d8bf40c627beee6dc351d7cef(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d3d2a5a7601257ffadf28ecf603d4e29d0afb76e5846bb141c67f40dde2cb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df68d55bb6b5c02e8f1d368f80ec4082177c0c10ed61191e08db528897eff336(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca91769d17f42c22ab8b00d66fed904fb9750c8f76f2256445be23841677d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2714fc988bdfecbde79bc1f3add1c263ce7359db741e16711bd040c777fe8a6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44ea4626a4dcb9cfab01cc9d54c8507d3db0193f319a1360627aa598a2877ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5262d9cf1aa88292d5b3778cd30308464254e9e497ce104ccc98501a9a0c0be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828e02f6bda7db542506f8607223f67090eead67ddf868010390da40c0156729(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2febf1377955a0c2e1cf7b56874c1696cce8910e1d7a898317f922df54a16471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15f38d9367b3b7c1f19c7c57177f5125b3190a873a49213707a0f59bf81a866(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92a52a3a4594ed3287d1946185c574e6c8bd85fc6c2523124be233622fb4710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33261721edf28c923b3a9c01088c398f01154ab55705dd1737bc456b7103dc09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f78c4d819089bcf8e7f0618075d9f3c620c062a1f2016ef04223e300776d19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63762bf2f7a9613e410b3cc32ce551e12e11f74b09b9086c3bdad27ab8806cc2(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f21ef5f6519cc804424b69c9efcc4dcd35fb5208ef7074f5b518d989c0d0ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c43d80db547375123c730e7c19c86d6f8db1117db2d3a590f17fe558fb13f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24da9c61dc34f98514cde5ca72bdd2183127d0621d07be75e39f08699c4c3cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40cbd5ab311f56002345f544c824c93cda74f17e5b04ca921a2bb8bea0373ff6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6033c0aea1c769630fb1a0cfc45136f4fe661f6dd1caa6cb9981c113b3939a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9c3c19b8b917f43ebd047f020a9c486075d61fb4c5c4bec97fb0e814f059c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725404a323f7f9d9a86052362a6beb94198802d4374c17d19ea68b43d354c402(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3674389604428ccea4179ef8efa2c84be7a39bc385c1636ddb6f1c04928f7c92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed5eb33c6384c99257e6aab9c5c0e4c25e494c3f4d4aada5905332ab03e4bf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9d0a0ee3b4e4d7287402cba73b27ce84d57636460b47bc7dbe142b25339adb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684a4513ff6d704dfdeb430bf6c716964da3596637e05a240eb56e933bf18b7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a8cba00bff0c13c6bd9cabf68d1cb56657660187961f2ab8f9b1471082253e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5050180b4ee694b1062ef88fa1519c3fb39efee8c12856b82e04b7cafe9bf27b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741367e55a43d2e8816d50e2312c1eab2fa03c516e3b5b73463fe573b147878a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f060fefd765c4db4f8147eb0208e5826616755c9ccab30bef906618e7a55ab7a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055478d6c4b9f6c09e21bfaf56c170b744ef36ae445fa23b38ee7764509aa0f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490901806672f0409c469dc395c87af0367a3467353cce4fe74be468c5b8f1b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1844ba7ac5fa1910fb069219a592b0ab2505e4b45d707af9b1ddfb3cd43738(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc8de3ad526189fe30f1ec180c593f645044f851427aa75925da8047eccec6e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7726675fd3879ada780f02281698d35ddc7f496b46fb722ba7a7c1d5e4fff8b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28db2ec1bb53fca11171af15d756beea94d156ae15b4fb1a0fe3f4a757dceef1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe36306b7d5b995a371a78daeda992e47504f116640afb8f179fe1407835b0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86fc6f06c5b2c64e073efb9eef7af2b83b285d02ea0569d32f0c4344b9970419(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84adc63dc90bdd6eec131331d490774abc94378480e40691cd00e4457a9c4aca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91932ba70929ddf2a7de0bdd3947d95a80eb107dd0d16bdf79b59c13cab48ab4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2266d2ea22d41526f578baa2949101f9f0b1b8b51ff096622bf06bf0673c7d71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd39622c885ffe2449c169f71677c8f872cb04c4cc694a046618847ffb78b60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753552d96b6372e03996990faf9faebeee54500ea8a22ed77e208553f1f2a81f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed009245d48650aa000396e384056c46e92c3f4efbd6fb286cf0530d57fafc11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8450fd2290c8b81a2daa83fd94843380cf00bcd62b5606a05eaea0e6f6f17c20(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdda2c04ab7a350f3ea52e7739f9aaf36ba3c32c62324a5b93940daca1cbe34d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17d4605fd1eea82be494ab53f7c9a562e5ebf3123c4553181423b3dc4698dd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1e28780aeb8fa3cef63570317a930183a00870edbbcb3becf6fc58f99b0d93(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__664283db7f2bed0d64269f33bfb909c8689e2563026e85242ca2c5ecb8b18131(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba4faf9e7bda10674073661c6bcbb863d4eaac5c87975eb6071db90b10ac379a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6368a99e7a7876083d049864f3349fb5fbceef9a67941233819b83ef80d47ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780a5738bd5a3dba134e8cbc396b6d54a654ccc3e261084692e82d9b68b58933(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b468152fc8fbc587c05600d317c0dd394c153253cd97028b874f31eb462d050(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e3c8aa2538a492cc52938c803146de417d3b0933ff5dc06fb45401cbd2835e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db44111b0e4a63ff1356a313e8568ac51771afb879cb3a9dccbc9526b8aba404(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297853da4fbdc66a4dac8e2f4ccc9cca45a168971ef43c0df1c2a8084893c5cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d94c4a11700de36500dc3027b88da9ce1e1d75841233a273dc328afaa3dc100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd557cf184d42f5d93d72bea9b0f0f01e7278a02bfa4c5ec4596a07ba2ba366(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88bc13487457ea98508efe04c8404ff2ef0b0085a76091d7d5d69f1f70a395e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a8236f73caefa3af6359fef04c8cc53711d9037c4275051a98866e5606667f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1031821f1765e41b3012054997b0fa3db7e6968c16a643b678d9478539a95cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558d41bddb482d2c6323d11dce14320a8cd288e4b839df1fee35df9b646dddcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1057cb581e5ac05e21235d996898c09a4afc260783aeda873bcf7697b2d085(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581bfb77f95eb94308f38d87a6153989ba7447365ff44d8baac5542d9ed79a78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb863a72e564d225dc7ebac667fa178b4805a6d6ee1eab12b071bf2f7e07fd2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ad50646083625c7b29479687916b8cd9cfccd1142c7a23f2503fb43389e1ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f9f3a73b3e012957497717d4d406683c7e68243f010330f465da1f68f77c41(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5514ae03a71e4027fee5a867d25ebe237bb0abd0e45e833ca20572fa24744f3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d534055999ebb51e7a2826185a27b7988bc5ddb796afd7532909e508d30e854(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ec00394102da83917fbad2731e3b8edbc5fc8d778dfb1ebde4b581dca1d6eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e90d924dc9f6f0eea831c617fcd8b409a600292c0b12ed73e4dca95866af9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a76d4256741abaa975d6f04882c2012757ba807d8ce5386027777dae4e9198b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d34845329089b1539ac735bdaa643387aa643720ad964f1cc1f90c15d5fcfa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e104b507c23ad829b1110dd48f1ef7511329883391cf6f04c360189ec38e095(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648d137e508e6f6321fc92b8e7864dad486cbc05213427946afa87ac293b0ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370fa1428868fe2019433d639f677a6363021b90510b0e07a400c721a2eb68c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0030553800f7dff23f73894c4c589c9d37b7169a41037cca4cea3238e4791da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30d9fcd809eea9bfbd9088bd28ea3c6a71d14aa09ed622d73f2b12b9acb76401(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f85da28b071b1c2a8497a6c6e00b69daa5c259bf3417e67728a3acdab1b2a8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5892c126d2664f526df47b9e200880e5553946a6c1d8ed6884a307ca45ba03d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc1944f9dc7adaa71c44d62108ebc17ad1cb2aa3b8a7a73c87c29953d1b814f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0ee8ea295d8e9e12ec1b3b43be738063ebe73d9ed8b9c5dd659e215bec3176(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355279d0f74c46a1ff12a859a1a1ccb11987fb917ff0d1b4b96fc8a31a2a1bc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11aa7ed2f0dc76957a5138fb018537eb87cbcb37ea86048ed66bd91d269ec4e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1e2f671a2cf530c405b3b1fd027453cad6cbe42d7eca955fb57dc7a732bc15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c290717a93575e31fc1faa34b15383f339e259e240807f8137b6c93bb7eff73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418410912facf73932a86f85cdc6d29c8bb3070b94776ae94879fc8aa7ba9fb7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f426a157a5582456df7dbca705c2e8bb7086ccdec10de304123d5b248057cc2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9aca2d5612becbd8ccef6478cb4f930b24db17f4e1666a6007c01b516fcc270(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e114bf8cb50fa3928c991998e601159b791b0fc9f2e5922a7ac8f2e1bfaf4635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d60acebeb62d91e87738ba6e76e66e5bb85ef00a433af8224c8a27c8e05050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__051f997345cb707ebd976addb1c5c4ea95840ec39eb8a184fb28287073783628(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae50535d61ffc6391729212d483af6df31d88ff093ba9939c467d10d3f8b2224(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68772f5f2730f76e882be4078cc0501b40ecfe1a669e2fe2c63a51078714112(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779baa1ecd171e88ee802ca4dbd4d7f6186b09e8f6c9cebf6e212c1c5dacc225(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fac221a6e17f3473862247d5e77e0b71359b65e593f33b18ff89ce8a3ec7849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a17d7f0c575fb4254847d0d7b950016d44e0bf3123b0c7a9daf30bd7ea022d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fcaf540a8e01a4194c2cc643d7be85e5c8bb6dc455295c73d43f41f377ddfaf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71f5de337f87c766d8e92ed4cb761fa92969cad4be30e93d643833d1174fcbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626110a2b4dc94f0ae0cb266587b8bb17b4ec212d81c47fc124f1ad03de41313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5100c85516d7bec6a69fa5f45ef36033f954f3eae860aba9df36be8faa2133d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96951a43d1fc30ad164c096e519d33ec31b9ec3ddacfa47f1b187079a24ddf68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a83b1e7e90f61bd22bcd3b95c5101e4bf03ac5ee592d66799aeea46e6b08c34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f4119bbb722364a6217d6b03f5ec992d9835f0f499ef43756eff73b44761bb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7831be13dd7bcf4dba10bc05138cd2400bb82e03933f6cd3e0b0a2fd785596(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b9f6261b7c96db4f72c1098f6c039738811cd12617da2c96cfcf139f5c63e7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c7f6662bb5dadff279bb9c62d50e9865af33a41cfabe4256222603e185d249(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f966098125aa020f94837bd1a030902a2a3240e5230c520a6a736eb42f6ce254(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5d657d71bb0e8a8af7d8b0c14b3237fd7e332c5bdec1948fcf0b47964e624f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6842ee6561b8655148b08e2d83edfcaf0e9455e8ae5b7a6c227430e33347bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__043f2aeb4ed0b614ba27cbe6204d63b09bcf882064add785b61f6f4e9eaab341(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b09010d7a7dc8953f4efa557f244893fbe2b454c8ed47742f33efb3d06a527b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18210b876436d9b73134ff5bb55c585effd2cee8616fa4e4c5f784d3beace02d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a8c4dcba056080a82552122823449db017a503e32b6a3de2e54688c7319e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a843f4d21d427fc4f08b937a3f93c0c717ef05684bc3b4fe80d1570b96af540b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e8e17046bb84feb551b6795a4acce09d89a137f0cf124c9b894323537e20bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6210a1e5677f82fc6d76b8564f6b50d71abfa95f7a886dd0e6733964501140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc04af43b9058a227638b62ff33eafb11824e0b82080875b241787e697ba3476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f35d2cf33d9640d78f9f2ea751628969105188a8cfefb3203d376045aafcd22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad20f5fee9ae00b9c01b59df7704a9aa5d0df989c0b8b11a39fdf758b5f2115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7a77bd48fbd8bcd725f714fccb7ee6e66fcf4ddde37f0e06f9a14706ad270d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f366eaa27087dbfefd825afe88f17009d534ae6ec14c71e67b8bf7be43c33ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c3d14c1ac51e9d5dc4eed1787964377bc881f62ce62ac8cda235bb1d187c18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5240b714b757c517269824394434631b7fcbf68d290cf567472eed094265c864(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf9ae636208ac1456171fdfdb318cff7293ad8ada364218ca0a75e4184ed938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32371fbde6c99b0183b9cc6019f5fae3f4074f67933dcd37f04a98757c84fc00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c054ea468735855bc943fc412b1aed2225b6251d8729a97f87707f93dbad1f64(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927a4c07645b533b3d12bd8a0b0bb9bd7ca26e181be0eba19073cac9f529e3b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c0e9db7f82fd05d0333fb7055b0b8e87fff8d3d8e194db01cbe073ead78e04a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a80d195d5087d42c3c8ba8f5bcc8188176b96a7d9de207783d436c403f0203d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3cd6cc805e07c809b86df0d680a43c656e649b9a35b0d8b6d162b0484eddb9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843d39e747263feaf27f1b8f1f5cb4e631af46f824baf5606b32feb3ba73863b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61247a57a2726200c644ac4b74ece112a02d7d162ffc69b9f31c904df88e03d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b319d0919d60e276e63b391155fe61bc15577afeb267ef663ed7bab0bd95441(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be7709a7a969a030524edd1a08ba344883a90358ba2280355fbb67b6c7f81b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83198f14ab16e7e19b3e5552c15eaf1ae6821f4f0debc7d28f25b0a766605e32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032d6511e759f0c3c1939d24ed048b6985496875dafe1d2f54a41e7eb04e6fc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07b6233489de2264b09b3fea27e05b23e4686a489c54ced0de5cc04d2bdde35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7811c3415767e48322b1ae8317a422a0b9b261d20f538e7557fd42c0d1f22fe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df195c7936328859f227f374a6d7582597226eac38db6ba9db74a6bb76a35cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81a42bf25007e2353f9aa97dbd0111571ec47aba9035a02d5c37777f7a60ddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce82e40f407a1bd37736fea1448b769f4ffe0359d5c4abdc6098ca525685a9cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9232a0682b15c1c8bbda53c68a0535e44d8cb14c0a6a78c51c61c3e1d76886ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31de5aff9abcef091581b1dac38861f68afbd1a193a790a63c2d56dafa2f5483(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1744c22a67937f3e3a1c26b203b34adf8f643ee6a75114e03d2849ecb7872dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0404ef7e176bc2ab232d25c782e46d3b3a79eb41b9267bf552e60e0ca4be177(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a115b75c6180eca3dc32bfbf3d2cdaf879159b82c8f17ce0723f29de72a4147(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b723450175d52955ebc081a071ef34cf1b414f2650489baa03b9e46ec3e174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342bdcae0a930418a08ca1d1c6d9bde9d27fac0052e8e2a398e133b1908589aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507d8777bd614939beab6830fbf3d1b2d1f75ed6c13b0c085cb4acd7333bfc13(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da43d3565e7c217bd8aa6e957bc8d8bc81435121875e034055052942d5b508d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93f490cf27f3c207fb98e1f7feaebda880ee999521882ee8bf30cd3b8075ba5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4ca9a4452deb58cc554f6e80d164ccb146581b796de32dc4f451ef5d1cf0a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833f423ae1d1bb63ff742d1a72aff9adcd6b4cba945f940729e56b8413fbde5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571808d4529141ea7d4707f32db62050265ecf226667b00c78d0397e7d0bb215(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06bdfc90374c0a9a0a3ee7a838a754eb3e0e0f8bb6eee676381f352ce9953119(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207038b89baf29b7908762f0ebe6bbc5131da86afb6f5d47b64ba4b856c7bb27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22bee19a53a6b2c09e959acf999736b277954251bcd5951b9819600ae1b04d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a161682a1934027641bf8c9e6fb9d097604673ac5081390bb8e8ea16751b837(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6312cfd175a17ac418064847a5ae6321345e94cda40e5f0cdaabf2dd1e786c09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beda92af0e9d889d498f9e293cdc31e5a7dfc4006deb1ca75e3b2cce974a4cba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0244e4ea91b08d95cbf46e79870ca2c3cd34f2bf9923a98441b44390f08226cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7996efee52e359b67b5394a755976cba4fff8e8430785b14e2e1b908a9d1b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb20037d36c9dd766af1e8c8ca189b77ea545d0030ffe4208ceb7c5abc24a71(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f18902ddbe2325801d9baeef97cb535760b90df4345b59cb92437fcba628e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ea02ad41d8e9b40468fc3f5e7880b4d5e057799ba799da9a6aa05ae8b04255(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ecc9b38549874b8630f4bddd4de173f238c434a3bf90bd0f39f27ed4a5b175(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77dcef1ee89bf2bcbe35851c4a763161949daad8057058dbbd9cda34e43d47a2(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62282072d5e3053ceb1b05c794818c8bd69d720544807cb24e0c3f15e99d1cf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3256ca4d46102cdc520f530b8389ac9c7d0887d33e0112e24895df6f2c67725c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f4d68feb619db7c5ea7aff954502f77a1f7d3f50f73aa3d17baa5a9358a685(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecdb4048ee57747257d0a0b32bba8e98ce89716dfe617d06dbea03cd02da438d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d7be61ebc305eb0230e446910af6c5b46e4bc53ac5a75c98d056565f16cda6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd6e3617b1aebdf37cce8379e3e82bef3e36df1b7013c8fff4e419dc463eb96f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8c7335ea417dd5cda735f7670895f9744b61afeb1e6426d548082599b91b8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30d51f9064f3a4824dfcd183ccf47f84b1de324b931076949223a1237297f49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e0b1823d88846ab90d5b9be32b9f4c1f436c48e7d5a151805c6062de8fc018(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd2fbddcb440caa9d5e63c2cc7850c62865c7bab11653736f7c6fb9275276de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e47c4e087e10bdf6b33fe18fa081472fb31cbf4e69e2d65a68fad85912bd0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a795264284b569003fa106920554b4c68cc58b9561d0020a2bf645a8f9c68e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa905dc2e20fe92e3ccae49e274027d86f81ec12e755ca5930f9225d66955aa(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335a968bfddc3d0b0325129e8547067019c028717767b8aa90be0bcf21383ced(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad79b07588de8ed17efdfce0f4ae5450ca387e662717b603b9ed8f40b58121b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7fac67d31bc4d3439bda8b0fb67dd8328fed685ad2f79d710d58e0bd5b2cfa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b088970c0048f120acea4b1edd33850cd0e2eeaeed55866bee3008f0d2405d33(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9ab6e333739a3efe56c6def29712e49184ab87c7e7cae004fb632a5cba4be7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac375a99cd4e544a3ec4b56b02bb72aafb18e64327166914521a04677f67d8c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467fe957a36098a7568bd3b106434151c519180026d5866dd462986913bfc2c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceabf7d2251e07346b74d520372371bdeba8dbf6c2d379cd99d1534769eef8f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0d39814479927020b6bf1ac3b932205ff96a93453b86ad3fa4bf7db3a81193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031b8a7c2dfb8efd384fa0f66bd988e658fcbe88f5a6a4042169917b385deb0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f6b5dad56bfd012af711ea01f06214bd44cb9a8eaee95fdc6d8037bde1f2d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f0edf3ec4ffbb7d8a0261c133803f2a51e7008b9eb60464a7005d67d0a1457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3842ec23317c962879740a93d967b4ade78ee684ddef6b132fc516a79837aefc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a432ed5291f22ac204de5715d9a0ef8bf507e2aa276506b37f797703f02a8c45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40fb303c0ecaedb69c3082a6e1fb1e5940e95c840ec010b424d9b13160e75d60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c60b23e0069526324a9cc60b5490c4de6c2c75fc067d0b6ce46a31a0f3dce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d37ce9e97618775aec62d3134e8c38e6029458aac68fcd0dcffa64f660f5ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d495758ca6216ced625e61dbe5c9f969ab9837a680cf3a9b23d30349640d58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326a391723d24f20659f2c0eb99223faba17daaba655f93a8eee950308b686ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e634d90ad1b2e17293187be88eaab32834545b3b46d7376c2d74622748adb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14a4422350c3eac27c35302e80fc918db1cb4cf309482fe8cbb8c0d752e4648(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7fd9dfa49a033fabee2afff698d5874741ba354a9c194641a92a5445c21a30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45dc2c0522fdfb7b717b0a4c0377dbfd0fa78c0ef8e608d30b258c7494092ab6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38ec2227c9858f91d67b92d356659ff33a94b5df227d71e49d9bfb69b2810266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5dd0c7cefb77e3c9a668b22a261c4a6fd9e0e506ae5e6e850792ec2b7a4d5d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857d28af6559b63b831f2aab8b810912d65c211afa8a14ed1bad9e37f6b9bf9c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c0829e3ef88f252f888842779b9df9a319f4d591f76fc54aaee73efa2b5064(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0738944727669837c5b3357d9854b1fbfe676fd7cc19346ef88a01d9c7b5d888(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f921f83d200ff062a71b833b1499352b3a8df020a0aa77fd710f04bc1a3bb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7378ca5e54b56b3ee5318edec2e92ae16f45cf9f4e2045e5720a83c4c74f82f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057946bd71d523f2270016f04b95b0522818cc8831b454e7b3b7610008f749bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7511929ebd2ec40dbb7aa053b6bfb8b2af51b0edb1bc258edcd85d4bf66b870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc0c84f9362f00757fa45cb455428436a863a8a3265b670d4015a6f2fff25bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9c7521ba4a368532339d2920fac6f6e4f28f99ef50eda8805f0f37b1b5f474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__434602c91444a380a38b1bd6b3cc3613484547aba61d823740587b989a40f8bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__641b851dbef8e550ef177e64149eea91749e034795ed549c577b96917901c703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94e0a20c8509c2fe9578db7560f8d09b855219866a3456629e3121f200c82b58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3368f94059ca48105cdd23a8daa20a64b92def9a844a727fa3defd854b021ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6dc73d7dfa03fa87f2a809f0cd89b417ac6b8c92356c2ec45bfbcab29ec129(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b143446725d0df1bc514034ea743deaa3d9eca32d19e10f7be31582f51cc0a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39127cd3bbb5d0efbefff92d456589957a50f392acbef9a15605e322c647486(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67a871b8780b0ae26c068788e4240c15725e8e8e4ad3d29c7aa3ed8f4e8008e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cfccfcb5a3883442476356e827edbf106a3d914dea8e4ec31905954ab0fdc3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17fb1d010b49a976247c39108b81557be5348f2ac2d9345d37eaf735ba260d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a44ed0c5ba1aca261efcb9e1051c54ecbf21148d85aac0c3029cec5b16c9802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc13126f5e8bb021fdffb080e30d63a6e0ea5318259fc640380765c8fd38c3bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729cab8882b01cd716772ce00096cf49849176734edc518ce9a44931545a2e88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c4f763cf9af9ac731372e6591f0bf6551377f7b0460d8e383f6212d509f110(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e32d0a19b8baee4cb9e5f2f5175cfc06f5f4b1ab8376ec8217009fb783ae6ef0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65c5358d18944636881ec35d00e1f96dc1293df1244d1843407244e424c2804(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e41538adf3698e779c49910ef513fda45830f1f9a70226363a44210fe3a315e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14dec77d637ad9c63efe868f3b5b487880928cb4f2147d7d11cf1467fe3efcbd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df01279816b82af7ff76334c63970748ae32d45e3696821f1b9e2f0f1dfc97b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dbfba147f64c8e6813ca531f4e18c30c005c883b2041f3f19d4904c5658001(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8576065e7e349a450b105cc1f78cb11ae5a306a4f60e7e88653f11e1b288eca9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8882a27d0519a994c7045e788dce6b5a87afe6c7cad9548dca94bff94f0bf72d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9726cfb5de5ae87420aa434346c45c94939a830e6fbc47e02007c284b1ce874(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d2904b1ccba1daaee72a95132a6238e6a09ec3da2285273d52b067093e4436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3292780d7103d4d786f9e3d1812b32434c18ebe542b543a83157c0955a43b1e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd50621728e77d65b5bbef4266fa3f7f93d01d55f138452966cba136dc5445c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb8487fcc8b2e6005846d7da3ad86fa7366ecfa9359842a822de8fa31120315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76924d4af43327f9d627bdd9325827508735c38b41568eec0c109ce1b39d489(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38e0d50cc9f6422dcbc4c4dfabd39d95cac491d5fa7ae0596752aeacada59e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8076d0688930b71b2fea28db709bd27f554f13a1d237f3f25f5199c2fd2725b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95387154da2722e24c67f59576ba4ffa8e111d609c9435a51472df48bc2974e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ff247a8402ffb0b96240455c8f86e42703bd2727b19b3250b74ed024efadb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32131e8a6e206be3c8492f33b2acb915d184b7f9816053a869e432a6d704d85a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37287ff292b8607bb25a502d8d3f2d9f1ff9c52b47c3245894f6c38f38bc463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9458594998a9a49d59fb9d4be6de981a706f55f347006ecbc42eb9ae4e6a9a71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692117c07fb206791f5b49ca86def72c710bcaca160913b33d52d5b390697846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23bb8a2c2c88954f750830bf997231d1a9108197721eea00dd1809c2d73f85b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038bb77a8012588da97124691aed7cf6384ed9e0d9a4deba22f9e9d711555bd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ecaf3f565c5eded1a7ec327c87a0dce331d22af2bc6bacfcffc6549178865a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee2adacc04d1920132a90633156c1b3cc23f935ed510d2235114c13a1378271(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438863c2136af3716571296ce2fd8c45de5b4ded4cca3f44829b0557672672e9(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90aafd15fde3029226c834731ad8445313ade01a63177686fe38d13c4fd1d0c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e146bf88508e555bf7ec2da851d10efa867d7e77c36fbcf47bf015891489acc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3244e930de1390a4e1a43a73dbbbcf270792cdebacd32b692377c461f8e11b9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedd9ca71a6e8af876593f7bcbd52abbb204be40de33de1d76f9c830758f01e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4659c636aac146bc7f33a088a58a4550ae8fc390546e270e05055a729a2924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f3d3d809033cec0a616509913f8aa770d9796a78137b39c6c88a1444259413(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3966dab3b893dc7093fd147dbb6477a6edcaaa0f82f32e9b52aad3dbf6f335bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b2d1d404bc729103ad9f5d6698c8922ef78d5be909fe67b83c74ba06423327(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e39ff74314bb9a5b2ae19df7b2a3e01e7ca0b2ce1e7bedb939f1e6d6eee628(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb1d003728020781a91059331f13838069b9fc491a0a0d8a3e9a95220d971997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1ee39012a5f0da502539fcc5d5c7c585f53ac7fa58a16ace8fd4f11e484aa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504838eff4c4efb0957ff0f16d76886d3ef4dbabf7cca1def9b6243f6fa9ef4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0fb90a61d4123d5cae625841c0abea13a01129142376636c30af2cfc89370e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f4aa4b1c6f811ae648623c1d1c61471e1ecb5463d6d011d3daa07c5218dd43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcae865fdf32147b421d7dde8f79e358afc9f03f0836d8e4d5fc4e11ce6f73a8(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d0180a7a234c37eb0c418a6234f7cb1595b7726184639665bdae14dfba5657(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea465c2620fa189c7de28883ada5c7ddd4c45fb2e8b6f9040503bff6e4f3b7e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e496218a963bf48db8fcf3d326953de7a36357c7b42f48f5c8938c2a0e02d57d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd16a84b240a75b1d3904b77abaae77f7f1551dd8d7dcb908a99aae271c229f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071e8d1abf9c0231636f703d10d93124a6a9258d6268ce3057cc8a2864d449ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808a5ebc4f42c75b495fa4eb0e717f287c5c4c84e19aa98819f48ba83655f29d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76639e25325c1b2ec184d1a39824822e26cc2a54588a171450f39f3cd813642c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ca3c04d2feffb9a4edf9e51ddf84323f4aa817d1ce6954022d06f1a45aa1a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90635cf1dd82e4b0f4b9a40fd44a6e7c9e60d78589b65ecd30a11e25d5ec812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad836daac02c6976db30bc481f393876948822db8e0da24d066525ca8c39fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b40a35a6789135c13becbe2c534901964ae1d70ab982d22dd22b1eb807b0bc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0da73b73f136d529d7dc38b29b0b94b292d5790964849f0d96434ed0311acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97902bf6ac0a8d25cac033cb716b180a84f251342714f256fc9ad482b9541546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb5775a048ef5a45f1f7ccff7bc6ca436a3581d0966326d81d61397222cb709(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88957f0fc0dda249cbcabd623d8bb6601abfdc9a070e5f2025e74f21706acc14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee2384c4253db84cb5f49eba09c721d5b10449c4df7f93042cd9b436cb969ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e328a92654de84f3cfe829dc884ace67c871932202ce3b4d81cddea9ed11ed3(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba3b17490754b423b0f74483b7f4828749e5b77403452fe0b0d5f29d5277707(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d5a60cf3ba96c1558fcd03f8443de1144fecad9cb5db3326a97c48db5ea1c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5f662be7d1e6d52e5ac3c7e8749c701e0ba01f722d31fc8bae2e01836a6d81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19e7d46c1d6c730fda9f36cdc11fa996361ff2654e5c998bff94bdb6db7b1eab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6126b62c6f1f78133f836eb3edc33219c8674467e8c7f0ba0612d6a8d0f09ef9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5add1374d34369bf14747e11ab85742da732ffce8fc561c4eae2288826e95a6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4278c3f0c365e048efec1ef62c801990848a133913625794eda468483249e715(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5722bffd613068d7cfa0e34bf945a82262e913a63952965b7f8bbb42548a0bea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2905e0ee039302be555e6408b8d2e81de651fca2afbfed903c61a6328a15026c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e22e47e18cc6ca1f4dfb2af4a0d40e3cc61477cb9c5418cf30b1ef6a8c1f2af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff4265d95c22b67433317b1786bcaf46dff75ecddfe512cb5c2065719c1bc29(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b838b418144f00c9d33587fa09a3eb3615fec504870db0d732e062428293d50e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0553ffb80533305c9c7213ca39461e19a1414d26db16d48cc175f1763e216c70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89aa86ab2b5e804d04b408ac7b03f367c5bf2e67265439490f6b4a44f12e4b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a7e0efc1d5d6b3fd3ba9e18a09b63434bde9d3efc2fea642656471732fe089(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fcdeb1c2e2a6858ac3032c297a85e0d6785aa2d220ac065a3e1ec55f73c342e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07363bfc1ee339b85f6e594f96b7150e5b5ce94a36eaac360fef10fbee483110(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe47d8c6012173504bf32912d4bf2fdbe2062140e0e76565bcbfcac14941dc1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4150cc854d8634d60e9ea90d716969374fc5a7e70a1692b7d837237111fd4686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f40ac70d677e16961e9707555db92a505eeae93df0ee161be9669a5ec228531(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ea94027d19b56bb18cffd9ac64238d608dc416b57b2a0a26c783f0a5c307f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9247345c7d4d3dc87efd6be0f8e2cff366c27d9a989267160a1a92d3f5057988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584220328eeba2b39f0cac8a3085ba8bb738b1e95846bf42c28d50137e2da54d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce645ad244de666d3dd37831844b0a2a3b9872a585dfd58685f670508c48196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be08102d29753ca730583bbb0a3f2f9aa0caf4de8e11009473d3b2d4a9f22c7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e2e3f3dc8bb2c1aaa77885b923a9b96be5a154a2e43f17a351c52e712a0e32(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0139cf157aeb1855f34c619a942c3723b83294b3da5118c51861e68757d65622(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926837c1923811adc29f53c0e11ee6cc222c6aafe4d7c2a0993e53889c6a4ef2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea71c144bfb99994dde8cbb98ca4d1067dc7b99b3c0652b3eb673b9ebcb5ef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a525cde0330c4388be99ed85fe6aa6d67d33dbf76cfcc4a775b20813c0c6ab0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3638ac1bddad7dc384dd7af006555d0f7797138a1625316b9932dda9cb4aa0fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a1f4cfea18fa6bba839549a943fc65a0fc87e325e57eb0a3b7cbd5abd165c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63d3ef3a8a3ca83d54da2a637753a3cd0879a426da0e0bdfb932ec22c8cc8b95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c13341db7c0f140369b1229f4b0fbc273219f4d9f248472f484ede77383f22f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3e4a620ee2cb8b121287e4bfa9f22086f6ef89c50c527753100f815e56283f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ffae2fc1bf450b247e6523bebe1f153bde100294c01d0dfb9bb939bf56e850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d63450de5c8894a4219f0351d97cb0364c3b03d53b004bae91f37aabcb33b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3abab31ee69fd657ddfee082cf5cdb8503d251beaef9a9be44dba68de27d93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279f35fa46e11b1805815659aeea252a88ce4c7eff12018dee3f5b3f040fa8ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6421c05562845eced9e807b056a8a74e7ffcc93919a65d76377bcb34084b427f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0fdb53536910576155de92d88da73b60b6aec37387734892fa982d13f518cd(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635bcfdd7504bf8cf30b135cc369895f455c19ed17600b854c15bb5e0efc9deb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c1bdfca3af0d8841644d32987ff2c66cd4cf2b687e56d2a803d27e78e0df14(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6535490067d1e7912dc8ebafcfda6c5ab08aeb882e2dce9de5e1596544e4af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086e2915e403fb00322b9d5c9077f4dfdae48acc8a0cf9e50d5b1cd425dcf9de(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379441527a9079b560ad43d662db2580453b2d097a841cc203f9f569655729d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca6bbc4b73eed57d6c32eb5ecf06a0d53d9524502d8e939efb9add522285260(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b0d501931644d71ce7e8844d6e839676b7f6e21615f795257cfb314ee0aa9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8410bbced7c2c9a24492c4892945c49e30f7f7b2e8228102b01cbab513d496c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a82fe9051594cf1bfd2c5d5bac1c5fb36b3d02ed0ebb78a02789ae1ad2f953f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a82871fe6c3548f0c8d6160bb8d126154a59d6ab24c04d5655e6ec00a5b818(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2cfc52e6115f9c3a1ebbfad6bda25b9b92f2c81232409000959c47adb8f388(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498c72c9ab908f5342913c02b9252be00b3c9d78e8b25846a646662f1acb565b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197db6e37119270c9e11666b59fd1332d46ae313dc4840bf42ce8093afedd480(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42633ff433c12c79490aa7c508b9aa5bb72b71dfbf1b3e29bcf1f4086c782120(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5522a4256d866d4a873d856f089c06f49d8e7bf5277e922a38053180a8f07f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c7e463c66be79fa5c2b498b61a56ea5a527e8276fe7a7e332c5990ed98371b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ccb00fc92fd0ab9baacf3b4f60ea559bf6fced0280eb044d10d61f4115d1cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f03ee3d22e89345e73400a07d3d95446b823beb6c24e6e141b34831b628d44f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__badd1604e0883159b140f6a8741391993249115f6b626c8357937576c8ee6e3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ec9fe8d7f215f5dfc498e57376b70231986ad30d8aa2f4b870e02268db267a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5198433f1f79aa6187172978e087e63e45c8d319ab8bcbb3d6c2f19e4d26d9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f395f13bd9324a40404add27f2007a763cf09be59efa9d521f38cc53234da40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d901d3bc4e6c979dc755cf70343a29f6693830bd2281b8e82b3aacf7bca3f8c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf496ecd2cb3bb34bf0d2c1cd3f20a6434f7d31a80e897efddb8db8d99cb8e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7090cfe01d13573f648aba52d30f2e95a8b146a50f40d9e653990d156f10a327(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613f6edd313cc1f2463d58c9bedb0ea23b911987f6c7e53192f47790a3e9d108(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0e43f422503cb2308dfb6196d3f1526def8d7347891054f5b07bbe67f631a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e751dfab4d502e744b7ac6c22a372298ee892b25ae71e60bdbb1ce5b9a90fcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c78220cdfd19c8371b5242beee008844993a659dc864d16b169b77c5cf12d97(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813bb2d0757e5115a3a2b367da3e8aab3cd212ddafb36edd986000b017b8b4ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf0d522797384add7f6ff102fd853e1b8401389e261ab9d95ca4a75be7282be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4da559aecdaf0f747f15cfd1b6cb2ec0319dac88596a3ee31d8c1e99ed8f1bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda459c85dd08edeeb14e9ef7118e55d7951ffa80db79ef57e4818c1c29b36f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9faeb80186cecc0ee4d299c5f4f7030fc812e19428a3ac3a2d862d912d630a43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64dde9d48b575b277b7efc1e108982bd21b35891d1eedfe9e1bbbc23bed35401(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df706778e365195020d2084367970a5a713f566cae46bb51db94c1bfadd0ddaf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d875ebae254e3a0b4ad240acd0b50972260c99879cededc031699eda31289d9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c82247372ead848259b66da7cae2cbb6b84073b6137983af352c9ac0c052a8(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c677885897f507d1aca66cd2ea5c9f52593decb8916070d737e3a5023ec6c822(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de44278892128cdf639128a2486de05eeda354839eedfe87b3539fd1c4bdd16(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06a4658ea45889bc7c99de695a5b715420b5493941b54b604cd41d4d2f03a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2bd6bb8ed6b09b95cb6f3c29d8d262e496c76d8d3ac8c2e38b735929cdcea2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9983af3357a3ec666122e69a26ea4e3b44b60cc05b936e998239c9c0e1a917d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960cc929c8c78cbe8255cff241c86b1643a2d0695ff51dea7aa7221cde5dc87c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a36defaec1b7520ff93db11c26d46d69ed51e87f1d4dd6443493228ac2ba58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887aa958307a9416d30352b7d082d3a3a1dc5e98ead6f3e8f71692c46eafef2a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dee3a8a6acc125d1f8ecd9a5c01848271bcf95ba7ac3032025f13af7e3e578d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ffcc348959e64c6003ec1448c36c844ca0fbdc1f3b74db2d695dcf38dbe038b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bbbd37b40d2d9fbb019245a52afa07ab68ec96494e8bb6f9db2648ca6da913(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea1a4f5ffff9d542e648179a855957dd8222562d56484c3992ef9aed6b52ca2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e3c3f47b4f9e7ca03a9a56920e15cb5419a4052779f25f6171307776f703ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997f31608e29156a3d31dfef3e6f2e0a1185a188cff64f33d6dde03429f769ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a01ba4a558973cc85c47e2bbf1a367d31a0ec843d9b0a06fe4c44701a2b8978(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fdb1dd91294623b432fc83ab7b2d5f55f50291aa0ae5c3ac0bfd41347325d9d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541b2de8445bd68755c97c0741e78cd9bf6a1e4ed00783c4ba36ed40ddf8b641(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5a0c01b46f389ee7a6cf0121f912d1b616f5e5ca9f297173add2e7be23bf85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030c40c95fc51305fc3c480cae6da144ac0e93fc12343b66ec726d8426a54a91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4915b02839a2a7804f4abd49cdeffd9b6db0d125abdb2f65d9b5c69ecf24aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5d023de65c1aa2092ca4a82fc27d07cda4a0992dc04cce95dbdf71dd12bb5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5c722a215e9287544c71c76063e22137915bf404049dca6a35db1fd10666af(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7142c131175f76a162291f1574986806e752ddc67ebb35116d824d364ad0e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55b749ac31b994a559f49b126f86d5e6bfc7851fd4edc327d68133a9a51d567(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d01b9d65b8c1bf3f0d196e9743d34fdc7226868c017a49b4e4cbcaedc58eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d769b3265423e7c08aa9d90113672185389c088915e92e0642d51967316eeed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6828312a5800cb18a5d37fcd9c71bcf93de5e431ac037235eb64eb24893b7b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9eaceefcfb2e9b5a6e2a8a9d95389890f96e1d29e8fd9746363c1516c7dfd0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c0f279ca16ca7d3395a652356aedc4fb1f7801eda515384d942f38653c8680(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e548a62293864849a5c021fe38bec46326ddbf759cf5599e90c1efff26b8294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714ca50f05833eaa6302c74412bde3ec2e65bdce64940b28e687031bf29bef8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80273639b07c2d798e4278fc7486520a0c4e2d79e56eb706c424065c9708826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0108cd58f109617c5d741707bd9cc30b133e2b12758423a57ac6cd4ecbcd29b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de0980f95804f3d7f5f15869fd8973f5f65d9912db7725a56d903884b890a16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc5a78d70b34a7906ff3b7587b42e86a7ed000867716613d9e936b3f21b6bc7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f80520e51964fe7525539aa6937fedf5f8c1b55cf8095d470f308829b5f856(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e652542cd536d7d1f8f56bd3ec9d94cdd35015d541c887c82b69d3412fb5015e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d315400a44674928b105d99b72ae23222efbfd28c6023570f8eda8400165346(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87bee1da7814eb63a7299d3de7d834b121de8d07399b0124887b1ddf0550c906(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4b1b87cf459e7435bb2d73966406d52a094f35f47ce8e923dd811cf542afd7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c39709cac5703d236db51937bbfe6f8880abda8c57b7b90256abc24ddbfd20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1e1ebd75f90cc9c7be3ecddc4c95c34c83233abd120cbc30e6e21660e655a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9b952f0870bfc6c97f913b42ed24b84d2105000c94fac68bad7bff0c631d73d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618138a17f9d0fb1c7ade9a3534cade6ee382c8f41b055e49893dfb660e9ec73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ec6ded4563b087be10014faf94df2612d88d551b76a725a9c08455f84bdbeb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f41ffcdb7792d1e09810eeaed3e6d240778d7a429ffc5e68e3e167454dfa2c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8668261472188cb66aff8385d9444f27bc0816bf16a16a668e11be70f5724ccb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d930e9eb114c4a644d9ab9ff58dea1e8681eed4457ee1b8a617c81edfdf3345f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db187683924e1b795cd07dafeebfa7ac089fab83fc4cf8a4c2af71391f2b5650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de87b16a79050d8f898a27c597a92e33ad6d256e17d87896bfe88e5817cdd246(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bbd535e7159a63632a8b73492877c413712d895d3f842f38fb2ac7410ff4b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc3edc3c377cd7ccde201e61e68e3a180157dfe22d5e4b56db91281a6429b34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ff6fbf6d978c6e4dbb31214de43e26ad315552454e18ac020d516e9ec88775(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9c4347052af96d4e93f35aee4331302ded4fe564a4394aa17264fba93947d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1c562cb6d4f7070dbc1654a3205ac125757988c2b974f89e7fd0c97d75d8eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb653041a93bbfbbee4d8fd6cb0829a8c75da3f0e57c5a3eb54e2768085082a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0324e6606e121dd810bebb0109d7cf197b82862035da4e7329e2de169246125(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15fc75f7cd83c861ac4f9bf5065c83877226fff4e59be8d5449266df355bd6b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46817987e58c7c03066065370a5b38158345aa57b78cfdc56a8a10ee6849b174(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b33fe79dce5b0fa6f0f38ead8e3ff7a65dcadd8c48e138a285efcb51a31609(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e80562bdd3f1bdd3ee6dbaf3a29df26cdd9be2ba0ee8abda56d71b4c1ee20f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192b5abf0e901555f9c61d43e1eb07453c85b64a1c54bd21e397a06cbab5171b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34d751fc16bf0fab1f925ea801463e988554e2df8346ba58f4e3d2dbcc5e5b0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a944baa1bb10f04dffa5ab6f7667e1805851c5d24ff96b0bc3409cb01769188(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3434bb98a5e8e2b9796e7ba44276c7b88df2a7233bb1537441af855dc007163a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea44fa7454e74023ea89e06af7ad92efdf9407ef344e27e7dc2ed95afccdbf2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f40cfe3af4d1b70268de5972affc5a1a25c3823f2ad44b45cb7e3c6255493d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd63849227a046c150389c4dc1e8ce55c06e01b3c93e2dcc5da196d7b9e37c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9855ce73b3effcab57be00808c2002f285b6cb4ca1410be1cb67341194db0eb1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceffb18b66a71bf32307046aa48042411a2499349a44e0a858746ee6535c41b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a878a0183e4ec72b16420c58a5f44c8ce75e46ee6464ccf0987bfbd788bf6499(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a19b75fc69eeb878adf81eca10dcad1d758d258d6cc713489d17883b56de25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa41ebadb492c57bb2c36dfa65414f857f9fb3a7a73f8a14eacf0a62f1ddc7b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72466990400b24ae7a9c7fd129dae0d8ff816ae7ec27553da500da82d254f3e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476797a17d554fcac5f2a8d450709612b12d7cb4b69b8434c803eaa76e04c6e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a8aa3cb8406e5c1bde0118382066ed1172e1566352c526b6ab61d692f34f81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c78e0b899d2d2a1ba9c5ab2980f9798293de3093ba5d5c377a6be43bf115f623(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3751a897ee74ba1929d3d72aadd6f8a472251c33c22d330ad061f33211cbf028(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b3ed2b29c134b37e5c7e0008a3909c02470bc5424057bf2c14cf40664838f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e702cd559ed52b4e64afa59fd538ec7ab9b89f32c8d0d2833a62c32052df378(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6a0ec13b552d9b932f0382766820ff57e7e27366e8c4204fa3361275e041ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a15ff19fda98299e61fd0f5bce125e127f5f68e6eec3af8f0507f1566812fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0048b4867e07b43ef34dcce43069cd09f9660090957757d834acf962aa0d5880(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095d3583e465b601c362c8baa8d836fad1e303857da99658f5eeec29615977ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4682889a8389ea2cc900c13db4f118508a043ccba161b5ec320bbb6a826e3153(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff4af670e960163cdb5360a646dcd31f0fbc368ab093ef95bd97cdd51e2568f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe86a761c72f1bdeda2da065e429b077f695cdd33f714b4c0612460f1a40a089(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__243a1d53396c9a598b292b95ba3beb9f88124d1ade3a2b4e80cea98c3cd205df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02844cfe8a541d4c89241e051c1ac8d3467c5ef3680037bd945c6d51aaf0896e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e9078c2f5d97ab2fcadce59757c5cbddc0036336ebfe5be58b377a9744d4f2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6add4f8536c474f617c286723e2218ed68993d878fc4afca8d30b133348ecec3(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707e61f4d155e4fb19d93ae391eae1bad5f4c061c8fa43cd3cbda4124ee1bed0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5e31ebc4b6723a8be318b2cc6a23ce90d4ce700f1cce651a68fb125000ba0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073360fa11952c8b98d08809231d12daf527fdbdf1fc211fc36f0800ea87be52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec156184518ac3f78f4f706ca496bf74d6fd5b89e043ee1d5585056b5f325f32(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e72c99f30381242403505bdbcca010aa01533134e278cd08737e471cdcd7ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ae90b42b76f7576f8f73eb504d0f50d12d218b975b346a54a3f9755c5417c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b834550d6a67e10afb3c2d25b5c7d52c796b06f92f6d751698eb38995dcd33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e964020c16f957b39a986ff5e1be66323628a58f1d86b0bfb32ab0822cea92f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4631533b8b13bb4caa9aac887bf281f9badccf87c286faa202cfbfc6012aa1da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7b06ae36efda623904378beb0fc64de82bf04b27f86d10be5de7d69f679d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c63dd03193ce57293a479aeab5a5945da01bd3145ba2ed7ee86497a2a2e1ef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37792c2428c35d92f39f61baa343c942ed48f1827bbb2847c1618e2aad2cd3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce52b461a1914c9b57459d0d63d7b6b060aabbf9a2b50963015290d5d7cdbea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b567eb4fff9e598371da86196c98abfe3fead54f9c992f93f7d21c153b8f13a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9cbeb137485ee73d5a89630af7cb5f915852d193f714d1e67e720c4b255743(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a046de41ccc872e4ac9d8c50e28c376840ea56a475296d4b137d32bc00b41115(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837c5e522362642af4f8de8fca96af53763495a6c67834cb750f6a1653c06d2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb8cf083d3017eefec1b251337cf34bf839daa4b86e2ee5f9dfa6e660f29f1e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581a1840923a5f26dfaea456daf40f7a6e5c2c8d50ec27c26a30b4a5b805eaf7(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccbb094a5428c447f16126038f6bc1b0d94bbc859bf9e57e55254119fd9cd25b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f829fa31d0e42459dea46d94d8a9ce0253ff06202b5b57a87d8af2d6513bbe7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e969d420bd6587b2d2a1c7dd8c51daad30a09661972a0aa457642959ca58ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e1e8bc2463a60ef5f0ec7dd9e20a29686318fb6295e55ff1fe3d88f1a1c025(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9deb9e02f6407e24e579fa02147a4f6077f11e302808f5bcc1eb044d2fce171(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2623aeefe66d4c0e2c8ac7d0337107ab83644b09d0ae9c796ae4514b65d4328c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb623219aa6ee9b925ae615dfb9e40f1130e4ff0d9d72a48849834a631f6f70d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ddc4e8cc7d0f2cc5643791393d141d9bf7ded387db357f0478458ca0e8ac02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc0d504a9cbfaa72731e8df67512cac11a2774a13678b61979fb109f7c07f89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2edea2b7b2772d13a89a6a57e1a4563f0685c22b466963499c01594c919293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1415ad849a741c4fa89a20c797b59b9ec64e8108566f5a298ea22b732d1f4bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9b32a93ca11e0c0416a986fbe5891d7da149a8709ac86a1db10e0f1b3a4252(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bccc57f8bd521e233c8ee4e2dcbfb5a01fd6329f0290511b4a118240ce194d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745452b0edc6d01876e65d57d67dfed3c5fd361cca86db38af3886d044e4c339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de47af95b8b2592e3d872640d104e91e978d79516c51eeb2d587a98fcd285c51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd2971a369451459d5ff143970aa1a84998182e2ad82f8a7d7baaf8a784e620(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c13a9cd1aed043b450461bc7c0586716d046bd320b2f982731a660462bff0a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210ccf6d52eb108eb6ad87cb8a50fcd7ed3e38c116ca86874a22cdc64e03350a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f689d9ccbe6078503c42d9a9ab5be8086c01e396ee8eb6d311bdafe988e3ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864a3cdc570b9267c6b1c8b7193640aef55a677b927a71e38fbac8ec465f74f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a2e569dd43379d8d36208c05e6318c9cbf78f15d44cc0ae69bce802d3f0d63(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02af8a0bca24eb377a844499b955288b7f22c6f30f21a0d2418eefc1b8c3af89(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d720a0ff17c07b0ce3407035b08ac1c4ebd2bd7e80600f1aece516f9fe80150(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae1ee0ba435d3b3075958a72256d06d0065d68405b07e92c5bb4907aa142c0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14636d01b461ada37320dd78228d462f20001364784ec54b3a7c070471db2295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe0813d46c6de87093d54254f2fa2486b5dd97e79e4819dd24a296a50324817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceeb3839e9dfe51bedee0e0bd5b4c03c6c0d52560acebfc705a18ccd4d4f69dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac71e120a3525284c180ced95ca62c0038217ccc4506642e4849663ddd2f0d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7eb119324a066335bd80cb845142be917ea37bcc41f371ce8c564b74f3b919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b829b93a3485342bf3294801237765a5ffdad869e87375f8feb202fe8c9c35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6d59edc92b8c1d2048c6d14cc40afce2df85c66bb17f00238252e2493c2a12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aafc891ec3cce0111d11df754061d73b67e339cbcf2a01b93e514bd95182e44(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3420c276ad45ff0d75d72c4e2f34bd8e36b4b3c9bddcb85890450aa70cc5f7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee8acb969f4373de212550047217f27d0b7c3b5502adfff6ea724b0eef60aa0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3761bfc4f7a79e3cec068d4caa4ebc79fb47af549b44e194a85ae299f92592(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8cc09b8208ba168e721cbc56328beb7dce6bc8701c4a1789cc3652a9fe4036(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8632927997d645ec37861b86daa740669b3501f81baa11301b6c3667ca00ad8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c86dc83b46223d700ef4b42b8ed92c8a9ff91d585e3fb69ab5c0e98f4448fa7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70d572246b23648cab80b84f498a9b2c95312b7331442ce51a39f0e43154843(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef999d9e816746524409e3b45d642b758fb370a12e7bd95b8a4a19fed26ab72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a95df8adcdae37386df43941fbcdcd15c313d12e9e68f65b2e5acec80218dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026f7fe21e2294dbf5e31631672570be0f0e6208b509a017564966a6bf77441b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c376909f64603d1f73d081efbf9ad8c2229d190085fad7f75640a5fff952902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d693157f686375cbe1a9ddad75fe4c71fe71731f3dae0637bde982cb35742125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1e4793606bc5ceea26f5e332f77f0bc34d3c6cb9403a1ea8ed775e00893af0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ec63755f064bad931a9113ef13cbb4dfda018ccdeabee11b6ad8ef1ca21ded(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844f1329b1e4bf2a87e89d13fa60796176c6a33f21f744b9a8c2d6439781ef65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e9477e0424da697526d2a7ce208d52c1412c731c0c200f5c200eff7e8d38c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be25c36848ab3bbe515fc0a4b44d2980b959cbcd54bf250cd5b2cb9dfd5799b(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1b9f4b5d33cd334811860f6bc6b406709a1625e124038d9c035666c7c96670(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d49146a0e3a5cb117c3cae6166f2cb9f241e4acc6a6c7c3d312d2cadf75e3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad68c51a9da6d8645b7bb5e1e817a043f165514b2f4e97d315aec7c3aa0f29dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26991d4e2e07cf20d7c4f49fbba86aa79f4f75f4cf4f176263c7b9d2642d1983(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a7ee3e8898d33648ea29ca9eb6864c9110c8f69ea09949749d28d2889afe46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7a47d7bb0543eb90cf8552d73c12720c6abf52aaca10dc51921aabb7087a5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0845a7413aa57103e9680af06ebc3033d6f904dab16a02ceaf17697a05f2e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91781db69acec6540b019c5074b6c24f4dfe01587165cc3f7c60cb22b1409bef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b02e20f70e7b5aef934cf10bf4b707db36182b8de1adf3434d6c17482a13f25b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b848b929100bd13642afdb3e802314c3f687875322546c5a80e9d907d2533b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab487b78e225ad457399925ce1203e35699597c452d8bbe8ab1b7eacda0793e3(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7745a38761bcd63771065276cf827ceeaa134a6024ddd98af62b8f6db519ec4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e608c8c9dabc93c5ad91b162442f4b441cbed1efcbe7543d11372c3c1194c8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ce4487ab2402e6aaa7d457204aa60c8b4cdc11c1d4b5961567f98a10126d53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a113f6f3086bca17e880375314069238d6b92e977bdec8c7240398ed2a5803(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c0874ef888312b74f2b274b84a4ba3d7dc6f1e5d79ce28f33e323fa24ab738(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde67af185524a81c34780a80d3e9488d182a9b11580e2b12209662408953884(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a108b8925955fc5323c6dcc22ff9764b38cf989aa28d284877f927c22724b2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc83d9bdc19d0293c91205494a817f760e462911a562582f67f9a517dac2d5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be7c97f975ab138c75fd8cc74e22336bdad1e8ab313b6f53a46c86335a449b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078a9e6f532311e5c0eba655b86c60376c3bc9d705a2ef4818fd09f8bbf3ef7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb84fba3b28f38be685f96dc6e615c8bfdd8ea8bad567c740755e9835b26027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983878a0040acb221623e067ae30400cca8cce12983f924c897f87cdd9c2094d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8196ebe43954063d3a5457cd07371346b91fd211539e7c82c1b642f81a777c93(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c494f5765a57d544944c7534dd1ff3005577c9e1b8187784f207c505d4dc417c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67770287f697774ea0995137a4e13c82ab697151d38393f762fd0526f8024db1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6060581e2fc030bdbf99afdfcfe47ab8288d2b8d1655cb0ef351f1c2c6b3c8d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b710a7227d36ef88a7fb6c4c3e5f0fc17de4f85f51b6d49c8699d71c6cf629a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf6f85e8dcb27281b298b933dc4f15133b84b3aab24431148aca597a6d96cf7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2069282a0442b710c68f823a8be705e559d3ce60ed22fa59d75947503f305d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77298b3a5a7bfbdef7a8ea45e077387ffb722f36c51965794f6de958b474ca7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0f5d0ee1394d0f4f378f2e66f20c262df89790dbd1ca62ac616cc18199f4c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2bcdc1593291069a0b67480fc19d8e22e64a94e38aedf497abd84a2397cb83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ca6c2fd7b0ba411e7b48eb923a9a31d8e14c5c3e3eb4f9310cfbd4348a9558(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f762f84f90c092553450d4c864d2a2003be6135e6b2bdbbe0ef9971d3d620ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5000fadf33c7a41be56263e3f9e71ca66d9fe2edb8f0a3115f333ae2874639(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70190df1987417a52edbec64845110bdba0cad8d86423437bdb8229855dbb351(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0c3ba434de77795f05c7e6327adbcc9f578c53fa67ecb2314d1aa7a1554f74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d932d24201738a2485d13d1a431e09711388cb7287f84f77db16fe91df2caf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557b82afb8e16bcd6f14c3147b4497be738a6641eaccc0f1a1ffaa0aeeddd633(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5db89a872edfef62ec285102bd63932e43a0978453a5a1a2d5dab63f61d2233(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad85ae1d4048ac1dc8cb302ab308463ea586fee36ed669555bff54be1966d241(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4421807b01ad284e196992a0226b01fd5d0004e7b0b948d15ca74a108187821d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a1457c976ad37e049c12de80706b3b11a89940b2fec4acb154f769350ae6de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268cb03514fe689ec621763c095aea9faf7a01d1b42e615954e7a18c9f54369f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f6e0c0a669847d123530a23179eed9a9f92c44e5bf8fda60dc917853cfae2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feff93c57542c55f0e78d1365d2f03831d06e34e29299fdf28011cecefad5002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51c0cc7a21fd86f53ecfe720ef34df4d59dc04849eb6f957a8bda976d0365d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14659543152ebbc2fab09340e0155765afdff279f941a3385cad2b3e696416c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892eb902a26a731b773f8e0078029dd7226868faf9d146c23075deb33681fb7a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d0f7b95b14715db610d380add353c81e4b0b5ee67a8d2e8a6ca7bf73e472a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be3c434990f00b94909d39264a5255a9382f68a8e93a665bf91d7492792bfc8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b112bcb745c24a4d4f7943ef22c264f93600cc2e3964db877bb1be9f2c59c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b05fe403cc108663f2a80e937a74cda0070ab60963ec76d15ea9c8165e6c08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78538c64e04b753c2a07da127e2acf7e8f45e8bd712b50e02674f3c616c4fdf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e485855572c45231d1fcc1eba9b8fce077f0b8f39b86f54048495477f02f1ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaac9456556c7f1593978f3177eaebc06feb6fd978fc8a034533b5f688378cb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d9dfee512b47892899c6163adfd2d61ff1a2fa00a8186986faf0feca7ff82e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145bf57f955a3d186337b9ecb5460366222d37b26aa4211738347b3ad7e0eaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf717115860b53c723e990b437bcd2f1e96f1aff72f298a9e50a4c539238e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4406839aeaaf3fe8a6a90f5c114f46a39ebf47fe4eb1faea8ce8afedcecca10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1ac8b5de5c726a2108642238d26c2e07c2f099436db9b83d104d6f980559fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6f96ce3b9b3048597ed592d8d333c68ea97c8bd3724aa2d1ef4c1797fbb7c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__543a5e30d32a84f98c2a6f822f20babf734e8e18cfa8fd327c98117868b63df5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97cd1fa3c0170fcf874c33d6bdb0832e03a4b08ff8f600059cf9a5cc4fa786fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac558e4128528a73cbc2c08bc6c851e788200d4573a51f0b1bf20cde6f64eac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3959bcb12c1e1f5b37c4753acf5c6fb9fe38463c40fbfd7c9ed5a43eada45ed9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd08d0a870b077c0d301772fa69bd9e6b4960125b7598820b5c5253de786fbf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__880c1c35723218982c2aca348468518371ea8737c1dfd5ca18d2df02b0090568(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3015457c065242637306ce63fa93c397a29d35f1684d25c89d123b7128321c3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435f2530b971e0267a8ae6d76cb939e81c73e9531db440a136a4a0378701c72d(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b445af5e2ae1515988949d5245447b2efb7a0dd1a4d0ded2ff417fc7a151c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117bd174367eb3b949bd9cb883301db11813ffe2a0260ef5005e31f34fd6d674(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d0f218a19075a976f02809fbd52b66d4430814970952bec9ef1d8cf8329f2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94f2b97eb17c41e1c16c9c816868995f72659ef462acbdc31596d0e2d9dfb35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__235c213f0f612bae04b3f16628e1d09f4f3acd737e88b53a17d51ffa33c5d19d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b646118d1f8ae4a3d46768e02442e9d343f79ccc694c18501d05ebad0392a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d405f779db437a340155d2d0e07b13f73cc53922f12b72f65c335fb2d69bdf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef632897b89b10669a22b496ed6f2376f7a86a7d0004334ab7bedf1db2b44b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d6178b23b2db364315155b385ce8e622247e3bfc51ca70d0e7c53d4c5f4090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0acb70dda7cdf933b27f5c77a841754b95206ad2ac07f67648ea6bd5b0893109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f90ac5cdfb92719a6473510ba0ba23fbb674c19b0cb0b908f91ade1bebb097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b909eaf207af2caf5c40b69e76b611c4dea1d2702a0b9293d1c60f4ccb4f77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487e815615d241479506825e74c9182798f7648b34e1325d2a84cfd47f0eb9e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b05864a7bf8299d122cad4f5e6287f105ec19ab554f67abadb22e131a6d15cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b4604496ad724de3baf6ea9d68efb8012ae4d6fa6db6ec4511d0046397396e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5419c369acb8c19da44044f4554f1f072b0416f3bcdd13034a90fa76dbe593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8ff7453b950eb69878ac189486c529d8ac06aa7753aabad5619c87f265d916(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8713eb0b8bea8c5d6b53f9341873fe7dc6357344649e9fab63dde72670f31c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e3b714ce3be328d8fe15de45b36958a5ac3cef89758a2b483f5e6f2a889852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded636fefc7e6ed7b64fb894bdeac2e553d5755237a101adc1e3d55e2113d58a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0db7b9b27a35c242f0fdfa685168d03747fed630753355c1cc8eb723f668510(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7081ba3bbf19adbf55a35c3bcde5d44a863e8bb9b92626c224fc1d8ef8551044(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4026e7f9a0eab990e27f5eec89d79b989848e1d841fb2a85d38ee31e4e26d343(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5440d621e6f91a9e1cf9814b780440e1ccad62f622098f91e9f804835072f0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbbec117532877fade9545ab2a503734b6504672e405e4a9e7c53ba4678e314(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3197dc2c9f1cdc0c6c0d34ed194b69dde561572498bc51df94b5d59dffce7db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743559d5dd71f4c793d959273551b7821fd348c443ca1deddca770cf465945e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fcc15ce64d761a03ec2f400b993df5765cc15bf993e859cfbdaa0a640fc3edc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b201aed27ca8f54f9cd5ee3b8940bc5e031d43c5d33374b0098ba3e45ead838(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3f0f0bb1e2f4f30bd8ccc330e9dbcbb10c73a7931ac88f704a3407a96b6c28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c477c37ffda396709fae307ae52519c374db7425c58ed504ffef55ece5a58f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be803e159dc331d793faf291aa8637c94b02a4363dfcca72fc9898c60f051ca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741c4466166abdacaaf53e67198ae8639c05f31b281927368e98f99a0f41edbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1a7e2635f436a47960f10873511203d6516e2cbe1e40f2603b0ddbd690a7ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58666bef05c0d04c1707ab35d976cd675f78071c4c43f42023c3174d85eb448(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf90fd935c7f2b2ca305ed4b0bd05d7dbc9634a399c8b8246c590e4bcb99208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864b806f5c2e110d351dd79b8595dee134431ddeedee4e8dd87e403ab0b8a650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bdc910c69bdc6bac350ee92d60dae06ef41076cdae0830b05e0711c9039717(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__992423aac26c17e3fbd65b6285b5b0a4581774599e3aec9cb28426ecbce211cb(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b9eb4e48143ae6c048ea76bb327c31f503686d56cfc1ea3f17b33e1ed1cb47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02bc4ecc4574361f4d05045a327231d0edcd0677e38a3934e680614c2b01ee22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a8e939307eec15d8b6cfcde3f2cc1ec9d124024984f6b1024532a7afe5951d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee992d283f53f5082ce36107dd04dd29a978d70ff39a4b302027b88e3beb996(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4904371bfdab3a427f5df8e6c2f77eaa8e0010f332897cd7e4ffffeaa85e94(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__539c1acd14b24563fc14ea4506d771b97843a9d5996eed4d2d6fbc8a62f1ca81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f86c644b48bdb43c9f949486a5a7218c5e8eae892c2289bdd3f3f342bbf6dcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527bd28c880f9e4d5376d0807477494cc719cefc9217f023a75ee8b1a73b57ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f7a42fc220e579042f200be41f8e6bb0970f2f4cd076ebdf5ed8c1a6db2d4d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367411f205e5f7dc739d4bb698b43d29dddd893391f2499560f983ad9d973539(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca302f2d357da5f56e14df20062c2246fdbc58880652405899c294df38367232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614f2905640552cfd4dae585eec266d4024c95ca6c583292c3f195c208f3bffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce98658da4d2dea8f421a99cd4725b76ab41f085323f6b3710217329fd25a6ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e4bb343a830690a890ae2007eff685769e4260057d78a8e1ac89220cd7e5c6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__967d320141f5c3bde534280f6a1b8fdd6c60ab9db3aba1c76563c3e38548066a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c813bb7efcd0b18ee7d6535ec4027c326a9095ac51e88e1963593483422c0be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66493a2ca9af0f0dd0c125682dc361061be27d00556e17cd463fa8583d6ef21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d00d6740be83f483b9ecffe4de14348f7289b9fac28d56b915395fdef93f84(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4866b3534a0a3a104e7c4f39a11c380df9ffc71dea03215731436d9b42324a41(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae806c833cdf2876522492a6ea7486f0c3dce963501e57315f1bbf7844cd6b2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76fc3f7774e958d37bf607280c53ce07c5270ac112fe817ff0b6ba5fcfd76dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fee86f60751d767d78c99077525def4e19cbfcb3bbb0c8022e78141eee4266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90cc62aaf9de8204ca32ccabeb5e860853db7409d35b02af7da1fd957ffaa53(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7f1b0738d414fe2432cf9fa19ed61203237f06262bcc3d559ff0f584344e37(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c46f8fde04b2f31a05686be649ebc4dc4655128612bfd0c918f592219622b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910a0fa9f3a96016288e10d775a1c0cc3d208e6ba22433c1c0d48da8d5ec32fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163a611149741eee3e3eba74095c0fa2301f8d7beea6012f89e19a77e13fec67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9357f72361772363d164da989388905e80754e89c4b014032ee9fe610c714877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0914bffcdd27ff89afb1f66e77edcb65bb4ba14cbafa898dd995c8fed61b1ce8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f0d5c3f9f248b83927c6ea587a2cfbf89d153e7219e2f705377225ba2034e3(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0aad6104fe571fba25eabd73ae59a65af76dd1fe4ac41a2485c7956d7e4f9b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90cf2f98c83c2e715ed59f65f44692a113c5cdfa97c1a64f7998950cfb706cce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda96434e3e19dd2aa316af3b3ea7df2102bf4f6681996578000220db0b5ca6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56a598b6824b3e3c9dae3bffa71280508321e852574d708cc37d3d7e6d65139(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683b21351af230106755951f8e89f72472a12821e2768c19163c42144f3a5449(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6d76fd346a8ada1d690f198db779dc8ad93f1a29b0cd44ac6f7e29c20ebf7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49146d5df2ed96577ca226bdf322fc46be0ce6fe49a22ad3b3e75f429be0f7ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c05b9f1e0fdcbd5ea792447c14da0872514a6f691ff728f042f04ddd0cfddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419cc980b7dc112ed7cfed06229ec574d3844f068bcd66d1529a4675deda61fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a444685b1158e767600a6c0e45a45523bee70441a1a9be9d60a9c72976afc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d14926da8f9be0f0d4bf96b5981426f5f0b50a601ea652379bfc8d65dd9c686(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289027f41a9af3ba1779e9ea119f03c24a180a029727d992681dedcbac947c7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ccf057d76d0b4a4becc8c956400d80dc9331495a0f18e7fd6d9ba74aa73048(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b46e621c9e76a090de2fdad31e5c9a9f9c8924d03fa7a2f3565f4d3d5ae57a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d6ec10b63a601b285d79c2d51739eea15e0062624c3cfb0728cf7281f03579(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5941bef0b51e5dcffcfe0b0723fb0fcb73c4e69c9249f4f27ea42afeee68a300(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8211af55e65e12bcbb1ad6a9e675424f2cc9b5edb200120bd23c7bc189827a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3013121721f1e336b2c8f29021d08017cd5091e693a19d1ffe20e1fb67785e47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74ac4d4b5fd200c4cc8fbc50251487fdae4b8d4cbafe977d8782762fb1a48a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e6199e31e39a69eecfafb3d5251cbe0bfd80e5147236cb82a1f659921bbb07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67190850790fffb101a6040b0d691e22118c19802fbf88098c9ffe6ee97f5710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e43a29c82cbcaf8ba583aa1da77a88606f15a975e9a6c2db9ced92f1c6cc9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cabd04b2a926ef1ffe84c4afca32ed6d1fe78e045a796480632de6cc5c08bd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e62c715da73e3e833d60bd5211657a10b246411668d90fc9305b81f8fffe7205(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d216c530cc2d5ba618df46d5a95b2272b7b47e1e8144c517a1d348079040145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7d9b1cd5ee4945954420ef2befb40729c6a6de703b06e03760bbe4109f5527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde9361e906023ba8cb2fff3f823e19e04e7172c78bdcb296534fb0c8056d39d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f9156b4b8baa439355e5cbc9a822f276b52ed92e93e26d941c117797f847c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63d7038bf2e3e31d1bd4d062bf468dc5146b3ba5926e0012532689ff6ae77ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240fc43a451811d57d736caa1ce2c72185e5bd10a2d98d7870d9fb86aa5df7af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d011fb103635ec4cda3aa3dcdcf590f917afc4021cfa14b397d0ddf650bb30e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ded3d9a3b5a1ab7ad5ed6a88ef723faa07e0b989bbe5e2450adc976a5d0a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47dc862688a293e88b45a24c06249567a97df39f111cb0a6128ef44702a691d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a1acf1ad238384686ac6ff13f3bcdc46026c63192b10aa8bb82f946c99b719(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05bba057444df9b1643fdf8187499c45703ced38ab12c1558a69c1c54c46413(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f769cc5b6c49eb4dc3ddc46f3940d9f260729299ebe09276607baf83c1ec75(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9ffeda97194abff4e889da9389b15f35fba3dff89b6b7552e16820411caf31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9622751b4de91f8bf754a2ff5f977cbd30b8422549d73eb848405f5f326643(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__407de8542918701a901162dc63f7dd4aa0ef45315d7b801242ab8fc1a0c31763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7594c9b032c8cbccd6cd96cd23580896b911117dd450d9e86798dee2061470(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__794d1f04b7c79661eec566e161150d8e9c2c16159b057e62a8ba3e63d07d2ef8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d174606b7dc5418302d66a12735f5e4cc07d7946f22a69bfb0ae558ce74b3b10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae94be9d33daf137f9e992f50a237e6aa4975cf181018d36a1a9162dd16afab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6309352c8491a2aa439fe56234d808cb23a5742fa0aa934d9fb4d3b1af6dee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3796d0d095932454e5844f230ef1447d1090465587dd8efe9917f2ca8ea0a40c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532416950ecdfef9cb280102cb65ced11578e776a1f4aff549d72af9be5b7456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6174a41208273c642d6441228d8a16d2a112c11b91b0e80e0b61c1a2e7f070c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a819519969a113453269f7114832f21ef99bbdf60459bba0e1a9cda0fad9d032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db2c0967f82dc58e817ab41659856293d74e53468df2cc3a03ba3f746205acb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5745acf5f5b5fcc71b40e9db0dd941eae40a5cde7b777aad70228bf99988380b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc16ae30302d0f4c9fee35e5b71bb9c1172b73bf53034325bc96184b2e632232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c48dbb34fa91dc1ff5a33eab55e72ef920ea9fd6a6903f974ac12f4a66b0f6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed92a7041f478c9a7a22dc74be2aec687e66416018132485bb83d0e855a3e86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1eb03762f59d66f9ce3734dbf290c3de338659f74bc9d6c98a1957d0a9f9abf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4bd0d294370d16d68382f76839e68466d44ae51620be7bf619e3fb6a4478ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfef355f0c57ea3eb67685d831571de332c030574075c6dd4f12de0dbfd1af07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5033edfd329837005a79875d1b57898c8c7b7e43b2533a01ff77ad7577e049(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702b43df36a5fb33c41398813e773be12a34fa33ff8dd4d27f28dbb7e4961d74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bdfca86ba44f0513eef516f14f98f9e6772470764ac6b8c60e399649694295d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffff4868212109fc75dbf574633af4fc060341c3d2071034c0c413ca57de015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f42235649cce44942a53345e875e690c6b283c373fc8fc8354270d5740e64c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776ed5b5ea3ab1ba2c76795bb4040b2b3ead4b79e273d37ee54e287ee0b71725(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada21b5fde09ef42171e38297a621389f796280842444fc75ee30e88dfe0a15e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4b8944f6413f6b73f0fd5bf2dee4341db522f39f7dbcccdbcebe28b17d212f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb05c53e740ccd7f21b31e16ebb163029899fabd7b53e713e2f215d8fc6c931(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebca6b3021e60f5565ef58bbb1d0b69623c1b1bf8e36b3e54b5d06ab0f82cab3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788004fde9c44132e6a8365ace685bc823e57eb25499455be46755c1e965343f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff442eaefc7e635111f3f5da14cb8a553e9fed34d24352ac6b0b108a1f270f02(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf36d737832ef297cd726c20609afe2726cfd39971ea30d49077e3f55edfade(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a3c21ea553d6a2d1fcdecec24acc44f8149b5d8424c8b87e4c2f2fdf5cd00a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2376b333f3e6a6e79235a34f2532197cba7c433fb390152b1ee47779421682ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5476982de6031efe83c987740a6aaf1509c0726376aa2985243c30be166bc048(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9787ab085430bce82a9a95805fd17a3a046b2aa717d9d7d62bddc5ac475f3f1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225c145be395ffc4fcedfbf15a3a1d7d7b54b035a344660382cfc0b79424ca87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20736d762eb87e0974c21a473f894b658fe8b0fca5ed3afa51813d6072f57a1c(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd3a9cab631f8a7224ce6a120bfc2eb2dc294efd4a26c38d9e394093b071eb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a27eec7667cffd9d172c7329f80ded383b43b08743493761b590174fc069e74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e390cda25ab14d2e57b4cfa076d340673449790ef1a8328670f280721253d24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa68c894852f9aeb54733731e9c7ab4db58f66f54790ee4830fb228ef808a23(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac83438f79623d83b8da445283a64a3fb6bc1ec44126e4415789e13231efebb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0e79d39ee806e51344dd5bff756fd7fcad2e9458890710f99bc0524bacc695(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15ca523a25567c8cd6e83cc06069ceffdcac02f430ee4b4703876426d421e6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcaf157f7e1706450623f093b24615868685932cb2570e518978780a6fc5fdef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d149eeaca8feeceeba10c0b79a67d7faaafa8dde44316c94c1de7329726ec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58a8be670c0ef2c481846adc7a616e57f5173e76ea91c2241dd6965b20087f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce6f2d81861b948efcb5bc44f92a8ce6c72f43ba6a537befb4520014b4c205a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0248bf9c8193b8c336d64ade05df03f286cbb89bf45bbcc2ac94b2c2a29fb097(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ca28917964df43ac3204e99d93f7f75af7ac575968c66b0a503337ca0152b5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30027e4f41dcfaedc37ad8f4c838aea9074f56d15749e6856255f4636c0ff89d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6e2c3f13ae6f0e80e98dff6c0c6a165fc3b8de34a390eadc86c89c7b283430(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b1a5a91ba5d7ed9b1074278f1dec616b7284f995906d7093dac1a474b1b352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e36a2c4fed98543b33788b4f392b1f8e195bbb7426abfc4cca972310ddab111(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce95f452002e3006c000352a880a51dced28008b082003ec144972b8de2dc49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6725dc170bb31dbd6049156d53e872fa5d4f27407188cd52d62662b683924cf3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c92f9201c0372afeb3a44bbe2ac84e83f6b5da29454ff423d1acbff372e964(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56a2e07ca34fe506585e5812a8b4b18082f89aca5a3b9eb8aca8f2924c935af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1f382d779179fc6612003b262179ec7674fd683c3a05221220f7c6f069e3a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc728149840162dd54dcaedd1d00e2ef2156ba3aca25effd5bf818509f78ffb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2963abd85b52c819cc8526d5f08cfac85f5f3016796c51076e6b7a9b2c858a14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4adf50e2ecde2c299b9dc93ce19b5742427e73688f962140c55bfad32779be09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8b445300ec4c1e2c2c09e0423ddb49ebd3fb5121a0bc7a7148f360517f56df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ade273ad23a2399400190306e3031141e949e2aacd594c8490265e17103f88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20b1326ef6b0168bff1be4d80edebf06788e4c5ec9e01f704aaca30b9bb6c60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2311b8d18bd4e9ccd7aa37e65877a51a021b6b8ed37925062136743893d88196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2d4512db37b7e537735a5a0417b765771d65a7cdbef862c20c7aefe44de9b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82d66de07bb07f97e44d4d0efd4d84160ce8df17a29ebd0deeff003baaacce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ce96c6f7ec9c9bbf07f0fc3e430d8d5afb6688053efc8dd38be0cb31cb9d5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6a67986773ceb296d35ebad8947179a887f7c7be93e7f639c2c84826bd4678(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef6b83f633990a6bad0d30ec828d682e376cec7c658feb3e45ac7a7a242c2f1(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8d96be769c36661f165b661cc46c3b60450999207541418c3ba6e2d3b6a1ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5614a5e5743a79f81d304294789c6357e45037137688423177bb3dbc94c2357(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0a061e1057f04b72f41dd436d9730f5ecfc02bfa376df5c889b2259a7eaa2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea22b51bac1a34b8a15d68cd293938bfa974963cff284f64c9f32e66113e59dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7bbe4417acca8772584daa1a6cc75cc9e957104e3877567db128f355407596(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00e5fef83e05752804bbc8606e80bafec263ba10847ef93b4aa10dc1a6210f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb5d48879603bd75972b31baadac80a3410d5416a6627cac831f4ce5c3897a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b485a53fb47878c135a110582e68be32cf259619e7e54e8b5016a06e67aa5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd52268ee719d0c5a3a47764962b522c8af2168bff027e5d52ac515d017de13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6801e3621409e87863d9a13f318af60ee32bcd1f5760ab691df9a33d7cbfcb48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcc16ac78f10d44498b173524be31644a756358cdd934d5141769e31ef8a840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f7e6894e5a3fc17adafaea125f60590301dd20cb271c8782992c160f6d615c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba03ac700270387ebfd29bf6000e53ddce04a11d3151a634018b55a628eff53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28365a5e8561505b5b250ecd673e482d91bf17d488e79d64b5ed858a4f49bac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bacaacc7043e8fad48137d8c0e67b658f29cb5150471de3df6d4f496ec7c4524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bd7bc3c0d75bbf2eec8fe69501c36e1aeefe763226b51ad629d20246a8198a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51596bebb9c486db155d1102e6caa3a80172651c250cc3e01fcff22801f98232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cf6553f46e18c0355ffa7e91f0f32fcff72aeac91bd7efa4a5fd2c4857aadca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be92fd2972e44e4177f41b2d80fd53f688181b31e471354461ed00997ef3a88b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b556b3c43fd99e351c38df2b01c9a144216f3eaece6f92b8c2bc87cb11296a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370c4134fd7b62f0fdccaf67a9f8288848f8e8a9f44a0d7f14adba6e2b5485f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603b1bddfd16063272ccb088e03e95597de9f4f9cffce487ef509c1353668114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f152730fc9a7a32924fd36037765c3ed5d2083394ac999e64a434bec3ba97f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a764a797a07bac353b4f6b2b9ca30b565300b394129985034ac88a57e2787a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb2ae45634ad1d03846b5eecf9fbc3e3d706773ab0e4a86712be556c4c08a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c62e34599d997384df3b9fcb9272086c73dadaaea8be63e3684f4f38afe1c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2422f96fd3ce0c91b4cc21f10054c9371a335231970a6e4868ae6f5bf4099cd(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fdb6d54efaf040942ca6959bea1bed3e2f5ed2f18fd0c26805054223758d546(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a538e1479e73a029906bbd256bb054c7802b1fb97fafa0bc0d3a3ba623ec7e23(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7873f2014ab3ea411595a903026715e88ab0bf1a2151d89721f655ef6ffa19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0346eb933828d3e1d30ff9f1dc9f33011a4b93714fa56438e93c4fe207c04d19(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261181cfb61f92fdd8e126b4c8b7c0661c868cf0eab6ac36714160a54017b8df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab66c6a658b6954cc8443cb3471ca580b24490be9eced45dab6ae7d48d5b2603(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b733afbdd5c8c7858c6993c821a60a277b2ad23bba60e606cb8960440487028f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d75ecdc9c99ef159e35256175370a0e359274d4ee570724b2d7e988a5b72f20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6ba3cf2d2102426bdcfc0c48ac8c1e93e1d54150ac4703f35a945c117d69bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf65bf9ce6891e2c26752396276f85c69e73dc091e8354dfcd5a52873aa9a1b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f809868e88657f5aec8a85be1dccb61564e36ce33a96d56ea172d52b68fad9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93827421f351afa8c094c2917e61b0cf3533ba4416823ae7c2aa9865fbc58ca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecefddd39b0772b7a87a7fb87d36c5eaec5621d7f935b0355d458f65ea85ce40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d133226c1bfa9d8aa4d8c71c70837e5c45e22209bdbad9c61b4adcd7befe79d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5c01820a521156cebeb062afed51d2f83fe8509fe019c9be2b211b12534772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986705937af7fd041e60e273bb2a0c5c285ce1bf330dc522192a0f6227a2eb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a7933df4ca7039ed7c5a84157c983209dbb50e506284a443816c1a3610fa75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de0eb8bd0083f129a549857a1abb929118eb94c27f9a20d7827a70dac92e3cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7711b549e698c0368d2ce95747133838754d7c6d173369ece75a14e9c92905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce59fab35eaa209482087c63f78074bec0dd2776538bc5bad37075d90e98fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6406fbfda271e37afab98528c53cc2bd9b5aa3f5ed8e0f5cd84841191b17f0d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85df14ab14e9d9524eb7e5d0cbb97cdc5cb5a3a389cdc2a392c2c30fbefcda47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b9e5ba4535d4ce2207ac7d78aa4a3edb6059dbc6ccd909ffba3b8c0e3b1182(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368a244b29b4e4c26f85a20cda6aec5c8dad755ffc3e349bbb643431aeeafc98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a34092495540576663866d1b3a1dea54b509f8c4d8244256477b929715499a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e239f4ecdafdfa7ad744a92834f2740311ab41307a6ec33cf2049987687e2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a180c21cdcae61598cb1bb8e354bd9347ae6a9e8defc952420b1d641d451c8db(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590a62d9c27daf80ee1aca44035588c9a59a25aaa634800548750a33a823f05d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc6b737d14bbeff0727867188b82459fdb0c2b944aea56e36e894ae00f584a9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ba4947bc21dd0e065494007296fd6c80b7581fd423b726e22ec318cbf992db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53e1cb92925897e42bd64b3d9eb74fd27c6dcba099c76b2a464ee6fd67dadefc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0714b5cb97a338cd1f215f23eb503af354253020d210780ad21bff10a4318d96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d286a422ee9f83a8d97d566baf182bdb78ce1f5e5ad08fff9a3094d53d928da0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e60afe0eb20d566adfaf5cd96dbcd0e917f8a41cf1380cb1d2c3f06379e624(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a0c90e4bffc788bf372afa4a8d850bd9eb6fd5d0ecfd90a37215fd789cc427(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2912a65edb6b59f068734fe119e789eab140817e16384c07ce016c6bb235baa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a04e0a78d3c6f943a7536a7023f1964450f58b8cd34533abe911ad8aaa316fe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c84ce9d7425181c4d3916b7f15547229f43f72b6187168012b769a3e83551b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7774256410516c63c6ef226d49493a2b08d7db513fbf5ab334fc4790bbccc3ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6891910a8345ea873e3a8ad8ce1b399ca41718c4329629fc96a76313044055c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67cd52a524f56a7baa607aac9a43599aedfe6f0658600daf2c95946c44ffff6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860b72ef7ec3426320832f5d802e0676c67ddfa70180e3866272231c317d211b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19d2dab6b43dfa7535a6f824d12f7bd69044e35c277cd5409ad50d7c56ed5c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4c014d5ae49bf7aa987a6d973ba3ad8a124f8f319499d1c626a96b54fc3b7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37039975105ccc05fe798941c893636b48d04a957f10e73b2a536a5b8880abee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c9ff021fa81a55927942855a685ae682de4059bf9eafcc4d94a4e0c41c8862(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31a8275e37eaf99bd1c30288309231fb83c797f4347de2e47bc263a073112e41(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d27b2a4ea5ba2c0fcca5b2eefa2ed1bc50afec3581c78c3616f906c65b40154(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003107f77e95ab88b6fb638fab8b4b19879ffcc5f3e6aff1b040ca4636c6e592(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ad044ad6f37b6b0124e8859f6be87f4ae5840c390bcabc4017ee37e90bc39f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691c7c2c05a3b26de5b98887c743ea761698f9e0568bb676e7907f5644c2aec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91db3c161990ab208c00f46028c04ebf4723beb086501fd8541c0f47314f3522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069c607bf36369016b99625455c922e8cfabf380add4c27fa51ea27cd0b521dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acffeb2ecc8958ace6a7eb4fe20cf43e132c50ec415bd5c30bddf7abfc3676ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1212fb50883ab7e9656ccfb99574e09d04c27cfbf27f3f656c8f8e70b09c60af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc6d564135b776f2e868b0d90dddcb36acb6db35b18f3ee812d80a576c5fff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7823c45acfdea6d1947236be945ef9778b22fd4ffee759da6245fba320dd8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee787af850948b9a7b5ec26d9a7e4df36e9428eea7722769c8c0ead3d2adb1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b53d26d3e04477ceea4494cd73178dd762c51cd78d8373293381a4d6fc8d35(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5621adb683e96ba9ea213e4d7e30eb62dd255bdcd3ad83039749143406f2ed5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbee52abeaf6c0d2799e26b351e571d31bfb689d2cbd23e7df060e9f05190ac8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e835085bdc0231d666d2596b2d29f72be444e703940b540e79f8f18b2d57508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62ce495afd7b23301dbf3c62922f61beada217d6681724b282989d06c071540(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6353366c3b86b9b89e9eed88eb3a0ad1a6f9acfd14b6b55142b404fad0fb2da3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2ad0a925503ed8a1c7a71e293e014a57c2ff86160159ec31f4da363be873ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b7f2d02fc27ebb091345402d916dc5df67363f625397f4838d140da94fc2e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fadb7b7604968fa4272053c3edb85e46645abd292d685ffe794c62dcb6afad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15089987858e1980232cc94f74220ce472325dca6204496ac2e5929506366413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49813d8fe5e31702f19fcb3d3d6c0b4e130391a14245244753b8a92cdc57233(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21e2aebe3cbc5b35da0ac76c47b2f3b58a213c65ea77e1a8bbca104f182e843(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b3d77f7498cfe29543dd2955960621e91eea3af26c0214441d40ab1fcb7324(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24973e99efd8609068827687b5f39eabda5cd69f1bd4cf2d16f32d9dfa5ff592(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54e519ea18ac641ae98f1b89ef060b8973e06cc6bb9094f9a35678dfd60b3877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c52e25e87e2c24d1a0ac4371566d0ab457c99e01c0a6bb2c4fe72a9012511e6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4a0d180836eeaba1c6c8ddf1f2635b04a8b546971feb102acc7b11fd684a55(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb1575d2639f833eb732ecc2bec18daecc85afc3c1cc33fd5e7cd74b5a074c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8767ca6487ebedcc562a7e2654d61116d237aa7a6cda62825986ddacb17088d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09048e102db1e12813daee1dca0e7ab096818390d0d64c591591d3b7c8b4743(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986e61ac3d5318664636e97d6b58b0d7f62e586779c2ab5470237eb52b6f0ae2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54fb643b6bfda7849f04b6adc3fb140b3916bdddae525a529909e28a14a37719(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf09b1d082d3d4b9fb0c68190a556f6c406b8cf9148b6fe186d9f463a966b113(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5c8cedaeeb52209ddf9345562789f4fe26abd4aec7d7123f272e267a25fce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6509ff4a7f815cd99a7e01e4f8089686b80f481447c5aa5e20cef6791542b2d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7839119e5701bbc49b8c53cfb45e755a1fcdba49dd83f66336e1d3c8bc2fc860(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fffc04f70ce63c79dba78edb78993739fd58850152c60657636f435a2513e2ae(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc63ea03b86ed6f92bf16790d467718f554e056e9c61b3c167c61a27e4d69f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf2aa4a5e2861d6f7b63ca1e85669da643392cad6986a170f739c8d8105f36d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89287407ceeb4da99a994ec172c7889989af14ee9102f524662b7b6a7f5385e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec1fb7adda63f46bbaef91128ba3f4a504c008af1bf483a85fcdbc981c00b85b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a728c1d6e0ce76f3c9bd1e04f68f1e511281f466f64d3a9f4a99c9a28ba0508(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5797ecbda7574329d27a6ecc368bbbf220e773deba2badd9fe514109b761acdb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406d083174de4427a17dac1b5525484d7119006868e88d9265c45606683542d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54dcf44da095a36e2cd3b2946601edc1caa69f05c5ba364830acd5151d8d43c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18d7c7acd0886699738a807f1a1bd31efed6f16380062d2d26fa06fe1d147d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ed7bfce61832f6efe1703f8be7453eba48b8c4f99e319311c6e5a952fbc7e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86928d4828bb3d0dbfb12f06a91a5aacef872eb042fcf13983a3b2b51cf8aff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44398840065e9054e27a258e4ee8df404818a7fc0683c377edcbc840ca77960c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2dff4caf634021e6247a9b5efd45c7c1eee8c00d902c1e29525eff896c601ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ac3f7059d8c201b12b3fdd287edcd6140e8691a9efb424ee110247c3f2126c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a83d117919a70f80eb25960adf652b7783e27d8ce2d61fe0bbd20a078a9733(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f9c9c3cb3dfba4dc34d68b3c5cfa27bcb324bdd44f0683596bfad1dfa3644c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea32f5bdc6873e18622ea73efc65c9a9088116bd1c8c044e9e3b8f831c23c44d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12529aea5b0ce5a62dc4f7cb03b7292d455330eae8b0550343478cc030b2f281(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bb689823e42283c95f20c618f8de860c67942827a89061dcbb8dd61a8ba8b6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9a64672f13ba4b5501ca0a15bac297bb2bc4ffed41c226eaa363e290ede495(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2cd5f74b862ad2966e5ed271178cb4b70128f72518c4d0578dcb8c3fda7283(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85866914a640635716b2ed56fbccbcd831b2b3dda81677e42187ba6654d1582e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b8304908c3db4c015d8be4539aaa8665bb6eb82cef85374f0afd4abca39f41(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b0884a41870b9ea0272ca04ff0859f128dd7a210e7ea4c1ca5db5a160bfddc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af2b240d95e9c25587811695fc37717274d997dc436c58fa20e46407894292c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7345a3ceabdb1ed1ef00ea82143e77ff713bd3a96a8d6035d7011a975192c79f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7d05de827eab352b6064fc6d888651f70a7c5c6c715e0435eba408a1abf279(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7341fb603fb2126b4de3e03abf2e94eb31730e380108e834913850345089c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904efa3e3e7da235fec8e94fd6ebd65c7481cc70338ca2399a6bb6becfab7563(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920dcbf84e266109c13e14876789a84e667a2b273f34cd093fa6817f2c679512(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebae62761ec15aaabcee3d963ae2e73ac74663f20f7740f8698511e70122a694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f84d17c5c1bee3961c3f4595a7c57c4ba1f4e2781b31e7d00aae10a19c3f80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1775a207fed906738852f8ac516eeb20075e51dc21ec52e69dc4e0b7c9ec2df2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd4032dd954200872738712ad7d5db5dc106ebd91ac6634f4af79673eab0044a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e672249a0703f81d823cc6fbe5349d7cf855b90febfc594eb99613ec7ebac2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c80f798443ea6e5628564df229f27aad0d832fb56fca4f02b461d65953c8cb9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db10a28dedd92af85b6c29f3320568745fbb64f7de67b1a3eaec09b4e6a5e28f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff119e11eac1d45554feda2317b1c8e9de55fd5d3a202130ff91d6dead8b5d0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cf1e8e9cdae331bd32999cb95b1dde82a07ce61543bdb102758b405853316a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bbbb9c0a4ffe6bb7485f2a0bebc40d3fc9e3d7616d0b7721d3039b85b5a72b3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac47c039b35c1b72a6be8a5a43e84daeacd3299a181813f88a60ba7b128cd3f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c55f060c15771a040ed4450c76d2e5ff3034dea8a9bbcddca9401346840ba2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2229b0c63de840e5b3c576a6a3d506b763ea3ba9c1198cbdbdaeceaab3dc6d15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e90c86dac41f6d55d9e81168afa3af225566d4c6128fced6ca0fab4dff0277(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b420b2bd17c13dc2a37c2c81ecd86066ddf62675b886649e0b45e13a25fb936(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ea377bdb7062dfc6d48adb2d877544732732af2419db9eae41fe2c0a713363(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f56b00d84d5fb7d33a5c50998db6e71070626103d8db69c6b55514c1dc1ceef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ddd4cfc0f28549caaf44b0ef193374728966c90ce9c3e656bc58db5dc35b462(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b71a38211f43b452c6c7c689cc807542fc81488d3d1505f7c0fb4ecabe981df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b3c6ab1ebdb7a658d9b270043c723c27da44eee7c59880c7b0859bf379659b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9e22bd82101ba6365005647488e49935ce5ebd1d8e0463082986aca9f7a071b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b92fa4b840e776ef1a29077a1e57679da2de628f2bb4c2855ac60f3ff69653(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0690383a03f9c3f2e5a4a7245d150fff336871f047b349be16a05bc5b5aa6265(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e903d2dd92242b75150bd1b543ae2f5d5fb43f1c1c66f9457f6bcf9cd9e1ea2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa407256ae0a047140b69f1e8216b3074c970380d11ca03d6abf9e5db1ad431(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__586614a695f80c2ebf4def2f5b46c346e719cc37b5e1f6fb5d1db04c44950fa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba75b40bc97e6ce2d1b458885ce0eac7527356d08af56e68d9c3ea8cb5125f6e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438cccb625da945dae1352833c8017e85cb528ef7535e2a79e069cebf81d0ee4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55f29fbfffefd25aa3c2b92e0152903da84e4e89658cbf7408e50f24183b459(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa37dfde7085245436792d2242ef85d633bc905aacee062796337b01af175aab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78133597e687c4eee690f9aa140ca58aaebe0adc525c57e599d2d7c93410f21b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1f83218409fef96490a9fad2e77c535739caf6994b7acd41c840d3bfbf305c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d3b42cf77540c150ec5479ae5216fe2e2955f53ccb29edfcf820304ce29ad2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e5970369494df7c9767a0c61e4cdcbeaee7ad77d47a45ed8c12e17f5ed6393(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a170be55dbb7e5b93753e7683fbcbb0667e14e02832e08fbfb3805d7d53a75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82744589302b55d032f7fd76eaf43b76da1d4cd79a657e5180e5e0b7a67d0c63(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23b7f5849b2e0323e39c30b171c3deccd171d6a04e9c654007a8c1d70322739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__482a0e907c131f863a2a8710d08443cb59537d9d9c0f372da9f6bdab09b44752(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6551743e57e8a894dfaec4ec9bbc63efd8397b5f0ae62c813d2c546bb309e5a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007a4725f5b6d0d00d9a4d2fa16cf6ff64dd65d53aef0c899a2997748ad8ca11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01831af3a427958d4ca1114b125b4db376758f27ce705f822e07b20ea1851f51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25e401732db2f996d1a69ea6d36cd15d41fa86cc9ccb998ced82d92ca5037c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24640630db692fcd3a48001c0ac0193234aae569edf330febd3df80d6153aa70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb425d2f27c79f86a88872b4a6936c22e31e19c2231bf1053fcc9dd5e8fb89b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac51ed2c65bc5b835caafa9df447428b6474277fd483b0c8243ab7a4f7b3d0f(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0cb85fd93b8fc814ff04dad2f1bc5e60e17185f54d5ef5f65ad52f59f98324(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a325f3607f446ade30ae351638fa51b53f76d78eb64a7fc9d59c0f5dce14f4ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d954b9083b7c99f1ad97c43564760ec27ccdf58095b298879b9065e587870b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1defa7825868b681b4299d57fbc5c5931e6319e0687a499ee1da5a8d498f148f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f9fcbe9ab3bf5ddb6297cce2ac118f2522a65088b16c05ad4f68abdb6c1eef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8505e0c02cf3c21b4c52d79629192e9df5456104f3c995b788531ceb21083d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f55c357f66404c53302eae6652fc169ad6c862910b6ac71e24c2e9ac180012(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c495c560c0e11d204e0ec370b43e3f23b604297193bdb9f283db83eae08a7bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5321f21ec818073f8e2762d0d0ec0d4619d6ffdbb56af22926a36dc3c36d146(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e77e1a44f25eae90f455f322a0ae9399f0871ebea4b206be23ae3c1fd856002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741788a3f79e128405d7e362f67000436cd6b7fe7836961480f95d33d98857ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c441c4ba65e4f69f118c112d364dee1d49342439a7044fbd3d809df6b19cd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301afbb677b43b6cf12ddb877db21c1ca42cc6bf5f0d0db2931a80d26fe05bc9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8d1146c16d6edc879c34f768c7f54840d63640b019bf2878ca45d4eba0289f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b51be2cc4ec62637b1594fec2ee0fb4553d706749b00615e84c6e93980975cc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120c11b4f978488aff88a9f8f9894b6e03140b7d4a6c6f93f6c832a780bb4ca3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4686db897bd70c032be6695d2114fa0cdd0465d54be06a7d4ee03ecdc5139e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c504a1b104e253688a786945bc63cbf26026b16cd6abffbb7bdb38916171e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78cc5d6b25e58f4d56948de918a0652ad7790f7b6fde0a8b1bd519b2a6d65c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365d96cc2c8cbba51cc0e80a1961677de39089afb0435b37c1ce175bf17afc81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ab993d0f40c0a79508a4867adc79b84e009d7222019e7fa1ac267d9f3c97d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06fd18cd9c7060d494e04dac0fb7462bfc526fd48f67d2c2f357401b04c12e25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8422f89180dfc6acef614840b6cd260bc07cbff45b8c2f91a1a2f873c40acdfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3c6c16e2ba1e23aa452001cc4a96980a53d347c7559fb16e32567e37db1edc(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa22f066fcdaae3f23370288d0735efbbcbf7f4ab645086fb6bd9e5e5301bace(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5128cc11406f9e2d4e8384869d6f69667333f5f9cd4465b63677f9783c203907(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad8150a0c0fa4d54f20ef67d0fa84e2996cbba0763dd2aa3b937b9d31868b7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4d9d4e6b2ab3bac6a557f2df41022a1130cf6aca8cb8726097d16ecdfed62a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b64d779ca1f122d826d1be9f407392a7319dffa66f26192074a152a2fcf77c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcda6e6d42719660a5f69965de8c8bedacf4b53911d9c7d57a54beb6e845cd8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa827f71d35a538488928df6b814b5266f23373026a8fa7766baac02b0ccd1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d08ea9dfccc3da5280fbe0bcd4161f630b7575c08459ec2b98ee4c27425df2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3d4ef3f163608a85b9d1a36b2e48068c31a2dd49a86f364e948fe68dc2e043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ebcc8deddb65e23d50bf99459c791c57362f38c0fcef6e7b9e7514acb38ef8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1e4242d07af8f78ec3b6a6cddf64dcc94b01cce8b7670e4bead907757b0344(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fbc0202e98173faa4263387cdce1a174497f7abb65bfe032b08cff2062c0e99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b963add25270025864c27cc586bd503979ad02f55d0481674771781157a2de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41adaec54577ed09c0aefbd609d46f7c722bda2dd38eb1825c63457c6928212d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836e6dd380bc427ae7008cd5adb88b80ef0c0bf5eb8e6db200a3f2e537c71d5d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f242647e1ff028b37f9b26a611e3d117fecad92add92b6cba088dc874cc8b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b08d42c9f6d02b9be73c2d41178c149581bc1536415ce4393f08d68721af4c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2549be62099da5a451d40d55786903930c6509373804ef74ab765d1cc8e54d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56eca23c18204da464b7aed5a78a864513e222b95bc9a770dda580b309ade25e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3929279c27be07876b887d027ac4e82568c345cac76a7a902d7a1fd7c739d8b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8c70fdbd0b17b2cac1e1b6c43c488f554cd41af3592876cdede92dd1042ff9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e0ed816368c68467b2d56a5112f90ff595f6f29f0d57891f9f9976c678cf1a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb643e849b43aea8fc40b469857ac9e3066e6ddf71f49c316e3f389da6a367e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f525a681d685d862ace423cd34c2ac09a406a02ba099270e551feab3706cc2c4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d30bf8c5a8452737c55db010d3cd37acc4506562ac7c317b9d37d3ce509011(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7ff1c61c0ae1dd02a58916658eea43065e04a6bff28d735fecb0f2acd6d3a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083766bc6a6f417835302ab4abf977506b89f0544baf60fde889f2aa82e6ac6b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61321fc22c3f5b3dc2ed0690f9eb56e64a87af73eeb554ded3003483d0d3c4b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e559a0d0fab17c100b771ed6a8e9d501b308d7aa3e36240167c5c19a1ef0f0c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d0bc63553b381c01963e744b0b81bad139b0ad18a42157887fa4b66bcee097(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceecf29fcd3abda35c9bd7613108e41cf7d59d5f31a30c01a285e6bbee2b0459(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e8bd3c47a9692bc3cdcfa2565dc3a083f41d970c4c3d39ec166c0d4b6eacb3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfe9c23f755dd52885b2cbee41d8e48e9ed3afa2b346eaa7f9cfe5c34094e28(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75e92abe8ec39ff5982ab52280dc9dc56c7e7a639d528d51b8ceeb9240ce288(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b06ba2959cbe81b566e70063de70d5df7f3f2da2880a2c4e296717c047f172(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c457f42364254a144da4760df24b3dce53beab6bf71571481c537eff9ba8baa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b97b2e41c86f082f7dda02ccce07570a596d0e2ea7333b2c9ead31760401e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3968566d4c216b2fee5c08e87885b726675344864b9429bd8c22d28a69d274(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6f5177227f220136bede16a9aa8fdd2da96d961c8249d6e8c323113af96e14(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834d37502f4601a3caa0816e8b08d507fac11cab6be05b50a700611ecbddfcf2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01c655aa61d663ed47191a7c321320cd7328848a1e3f07f9745ad3bed41d6bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213deb501dcef7729945af5996cbded8f92b2c44dd5a9b99ff0c9c6b33b7f038(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad6c05c7777e0ab14ca53282121c03132516f5fa9808abe56704f434cf393b08(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd547db439946b92342514dd83a5396f864667b4a6b1f17786d154e71ef80934(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5d53e223366fef4ff3f52c91d957cc83948c431ddb0fb86786db46273f256f(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8f05a4798258d4b6cf51cd57f729014f8daef8248aee42ff10719a502d37aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbae698698c8a052fc083913f0458054ef45a2dce5d9dd0f9749424d1aacba33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580296f3a4f844eb430628f164a93c0fca6657bfa8e28da7b90b3b258dd6b717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cde6e0a959b867774cd3f6d6af0c92aaf95aef5ed5b7ff8f54e56615092f1c8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8cde813195b3045eced7a2eae3fef22cd9439649f9bc23b4e72bb7dd5e07af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c21c14590b605f4f465672013dd0114b71d27e9b7718610e42b79dc47fabfe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc90589309c0c402e3c953c4694a83a6062d314eb95ef0055ad921dba1482809(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5414644e52263baa173804d45f5dfc1dc835b316ea6031d504fb3ad981e99435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a9d9eb839eb0e9d05645e1c783c807306767ff70e3d71bc1c29a79caa7ca5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0082e54d0ae123e331fc32a001801886ccd867ad3d8ea7b0df1fab0e9b278350(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e2c1b320c27bb0ad63fcef3d1464b553f52f3574a154b04d55edd5f0280dfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b137a077e9446e6f3b7e8cd0215cc83f3fdb651ae795189d47ee1fff4d4883(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32e29cdee412532639d465844d348d321cc8e4a1e60415cddea250da40822cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f61effa2c29f9e5dfd3f48cb8e8b73eb754949663f1f0eb940ea7e1db1e5b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501b74eb9e681639316205d0b9da101757cbc7da8ce469e6e70e82ba4dc78190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54f47fc2c5d2a5c19cc3b95d6e2d20f6d92ea7fde957936f06c13721f0256edc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc9176643ce292a8a9151925058caa14fe9b866760ed14bbb09353ee047802b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34b5a61060a981203a34c371005d5b0ddad37eedcba6094d093d404233d7d2e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc11630804e206035c40d0955121447d4ebd6723523e9f39976cc1e1ad9b9a9f(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a39c068609f3cb0701ed9800617d5616365975708d4cf100d7439984727274(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e63b9bf4885681f0760bba8195f79457c887ce9a69965d98509f664149c44f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d0383c5b9cfc6af54ece107770ca3bc7d1f521fdc4d70c97f96934e7e85ad3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7dd28b9979fa57600389a05db0d326ba8e3435599cb4163f80cf191b12c973(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4878bd223e2acdf041984411b72c87be436ba38fd5aecf7fe24218c8c88c4db8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f15ac81ed0b45d093585cbc0a3d7c707fac8fc3ed73a5499e21c6f772efc5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03fb81bd3b529fef8707e7a95ee88c15ce46161c5725907ee01dbfe3137dc76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120ad741725972bfaa171a4d38a1bb9bfd8530e004cbcdfc220f66e04fb42881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abdaf8c6f70ee6f09cfdf88536e1b51228fda554aee7e55a835c75775f004811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d2b3a9a8beb11a4ce8e6cebf4eab2e577298625e15a6ab370690050a5cf93b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35bd6eb54afad24ad5e3165205fe112b77ea0617f6df9031dcf3fd96e89806d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__820869d1bccd2edad63ca55ba170b307136a06d8cf4e628685d32e74ae93b6ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b44bee384e4f4ec1cd48f3b30cd35d7247cfc1ad8668d4a2bfccba3067c5db2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8628bd228b8a1a56a029805089f341f40469798a20643799d42bd9980af29e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3072c54c6fd11f53c38963d0d72bf6c11f5f0923a8b6dd56947075dd6b48befc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca430f0cc1c3cfc7bfaba31713b6bb16ed9e7be3f728e3a475303622746b3e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67af28ebbc1a8ba14defbee939b9c72e499e6ec7d93276ac21cc141ae5ddce4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364be25791df8747afc0f8fa73c4d2606a3eb9231f591708995dc1469b249a1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd32b0cf8692c2b4ad0ada66d17b68871fce23c80ac384112b2bbdf0676e4b94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883289501afd98ffc5badca6440f85a95e62a1c694b999cae030b0fc694d5810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75491687bea3c02a94f346b4823fc2c030abbd5ce9803ca7c30a68082e92ba8b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84271ae219ba20e77b33febd730a24e9a5b37be357e8bc934d355bd54b5010d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6339f46c5cddf476e8e89aa80509487874bfc552b90c61c0d8c1d850cdee32c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0582fb30b59f7f575f8a9c74869931f1a8c67bc96c106d0d96b8fcaacd246bed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4455ada3b25f40291c1818bf6f165af3e86c1b6adb36c37738f97ba3966a5b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5c1428dd8f82665f84b0115876edd33671ed4151a3252bbfb9662d92b262af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6991509741cfa570a8d3994cf663522762223df8ffe328035b767f137c33d366(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c17b7ae0a8daf7c1bdf1ee29bd86d884f415d4aad4248f289b97bbd8042f73f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15dd3d42578e9ac4f97a54a45b34a932300add44ada74c03e407b629ee45257e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab26f68310ab53bae916245bde838add578435f3ec09d7be08283f47c82997a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ea5ee1ec07e4c3437e71f1cbf8af7cf6e1c10ac5ce805f52b0ba3e5a13fa1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e4618a91f7e1ca0418b57f6b56e3ec08aae32b71ef584a98d95d3c6ae2be1e(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2022b339288bceb13cea7f7bdfafcbbf91b20a3b9a655d8824de583691c95026(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a270d9cba1a4e9740226ac47443eb326650bb1b8106c152e60e1b1647c6b0ede(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf3eeef21dbb71c21db357dc560c7c0f11ebdbcbc3b0269d6442aad08589e929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ebf4685c9298a2acb1b187373156e9805d22105f83105f544aab1378ae5e9f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f652ca639cf0a2191b0d95992682ffef8a00020e84957ae31f854888c0bbeeea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211e0780193bc748b6981aa1083075ec3ae4f584120e9c243a1b55bf86925245(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb86f3493b1b64ac5a16b4f1f649d02d82e7a4ba2ee504f236a27041693f9071(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80aa62ba61a2237f8ebf7e90878aa5a9f9c8e8bad18314da235383f242fc8c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0deaf46e5b6914c45bc472920e9b7ec7d2f8e3c6ebeceb9a7e17b655e62c284c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36dc39dea66ec581e8bb5a3f4809e97ebc94bcd052bf26421e8f477c05476a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a48048d20bf02e55e2816461708805fe4b0a5bed828a3e978f7ead9a1cf3f8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ebc22b38c42eec2e2372dafbe1c768f8aa377c38350496dfc8ffc31ecd71486(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6fe7edf09be3e1dd0409e8b937eddb5e72d22993900040c3da3caa98cb1006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb78dce24dfaceab5cde3d53a565da12e3f5b8258a48463468e9b81ebd6751e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e59bfd59017a12685ca9a15d693bec9bcc8f0ba3e054535695d42928e642f803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff68d451dc8e2a95fad009d2b7970f2e3f119aa093a56f8ff4c21115d58aad0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569eb6019e071ec797c8bee7487d89b10649130e67573509c4b88a4bd613877c(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c59318a9a1bad36680a79ff9296d7260bd2adc12302a5fd0acfe6518f2984a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efd97dcbfbb08fe6e35fe63a486b709b59f154d7f1c84c8439a724fef733d4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc62d1556b93450f0bc465cf48aab0acc77113d048e856719872f2f77325750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec74eecedb641d984892b447840d5c51526e491dc6fe65157614e7b67e2336e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe00a49feeef11355a6e4862b3a6cb10b522590dfd8df439eb05cb246c77e3f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ffd0434f8d71c1bba89b3c5b3e6f3b49020890541faf38f18bb0f8e9a19120(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0468a3e2e3a4e0a9bc9d367d3b23926fadaa7c43ad39ddd073d1b3e7d379e7a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b92fdfadbb8d9868f9d62244d468176fe028474b5fd308211ec0de0a9ccc24a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe43aa4c57ba9827eb5cac7f4dcae8e601b21dfc8134f3abb78e6d37d0462067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d079eb2044ca875a1b9221e1524807fabbd79531931e0d8424711c10992747a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635336c992d21367cb548fb8b764a221bc80b897ac10cdb9679f1ff86ec1b58e(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0798c032da5032d119b2f39081bfdd5cec9dfe397d1d34922c90761a01e5f1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e2d82eba647460b89e1026759a45490f885fb759e1bfa0384bd8f246783174(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__359376fe1c1e359303caf5cf66315951e8de7a2cc9dacfa16157a64a500c9f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9062dc6741482e06f36c6158f0af77a702994a6285b1d3b3deb96758054f05b1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eaf7cee57f653f5ebe3b72eeb05d9b8e92ae95e7d455612c77d15d713cd5679(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfa26489d6285f6b4e5e9dbf10047708b30c8aa7611c39c86b8e576ad82edc2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4497e6e8f3213a57d2bb27babb4d6b83e526c34d253f0a8cc87a175cf6a781(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730740e459b759dedba8685e05011c2e27f1f68b0c365df1d114a2ffc0139eda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0673198fc85f1e71bf011e4e4800bdf034f4b46980ebc7aa5da5953a79b3ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d849389ce92df08506c6d885d7e3a218d54d349e56007e5d7d3907ccfc952637(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af44f56f32f29230faef496a8e78d129415d400ce96518d1d67e9a19ffde0ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf8a3b9c40318bd4c45ba1c81a34474e6128f71fcff5cff96cc15b8dd23cf50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a74041304c980ac0b46c2866abb85e6326b1c6c4e606dc1f88d1282339197f88(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a37a5e99a633ca8faa97bceba3fca23e2f2ffb4982362b7668c6075044856aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2848a40813a1a9c332cd2e003c7b249500cbb84e6d6ae02ac003ba3c46eac78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2608876798e8e06f453a5e6e2bd70374e0e17d48c2d9c7df96aab58ee8b258c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec63a66df3d8e1a046ae6b93d92481d160e47723f93f86b46f2a237cde1a38ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9def6de1cfd9093d15c68a2c4f3a4b39b361914af393cbd4cca10734bbbc34(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216560f63f9f3ee98c6bbc90ddda2bb1d45dba49c4533b9e08e6c224b4490004(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7af855b37540f601587e00b8325f46201bcc0c7a8f395eb4cb6e7f6d5853b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6253b9a3a341c18753a1d576c624e4a227182035fbf0bbc22f078fee43cc8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8e178fb10292571c4eae2f98818b56232ea9e925d59f716664efe5cfe50cd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343666be889f431c33398c76f7b95a432ba86663836118fb71a6a5a985a8519c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__959953178ef2a91423627f872c2a709f55516084dc6dfbe06a39cb64f252c7a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0fd4bb2a31d0c7bd8b3a920fd27f40b074d9bbbad3359aa09a8f5ffde786ad6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c04ecb5f8c4bc58cd81db80fb48844aeca2fa20c640d39150540d79c4abf222(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe899cfde8db142bd29eb932a97cfd173c1335ae6a316230f6f16ee0acf4524(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e6696fd6a244138ed6723dce2f961ebcf7b6304ae8f575b7b50d896859a3a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd97c33eea9e12b0a7d2884f80a98483257ef8348a0c349445507f7cfdfecd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0c30738caa56993e37d0bd36851215ede2fb96c9099db989beb298e94d3a37(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ee055679bc1eca31cb85623bda4f3b429a0cad2be2d5955a5d2a69c7f4ef50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c967ea88cf620c33bd33d13d32b72845d78a834443bd966f291dda3e1f6428(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3216de0775057e466332f34e91faf7d786ca8e25f3eaefec396936dba934d3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa56cc526fc033ba9cdaae7c544a7b74de2bb407643a6ae91fe1663a67a62a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee6e6452de90144b43cf0c05b79a4f585671ad447c90541818a3660642cc4e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1377514258c04b955c4fabb8621f43e92698a8476df77327353cf34654aecc91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711fef0cad70201e736afed650c76c1f14576a3027bb81b8ef302945307da61f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f957d34cf28aa24595e796135c495405a56d3cf36c10c7c34a71045e00c011(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cec933295365a284bcdf03af71aa3265ca9580ffbab359d90f3007e66f209ba(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__099250d1b38bb26b74d1e59beda7ac681fa6c3d007f227d6bbc0726311621056(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d71ae87c13857ee6036d4153378ad905fc9f77143cc1ba0e8b1b2941a26c5e02(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24fd68da97e21105b7d1088bc312769dd422542ca64572a66d52eee89f38a87d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff45d668d6d65aff1e611166c8594c1474075120d227499bf160cd771e65068(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f03b9e0366d9c62aeac181b76fbffb053b4aaf8d635289baae7712411c462183(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a214298377750e03d697098189a3dea7d7194e98692e21d3528019a743d05c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5a28807d4e82f97dedc73427f3a012def5015ef7e0963745c25214cd7a03a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ddbcae455eb3bc0a285fd54564acac27b566b96a70baaf3733034b2c595a912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a793d9413d9a1eea169d5106152eceeda74520c298f9987a1121abcdc8cd814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bac4ba96485659fe804ea494b36b575b20468935acadecbf5356b66489a1e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__383e14aa7402a6ad1c98a2ab74f42df2a32e4f1006753c11f06cb637d6a52fab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d9991b32ca3d6d9df137fc283a88c773e43a25daf678540f370e7d809b7489(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382524699b458a409b991f0a5e9d7749a8ff4ea3007962e23e0b549f7bb63547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31a488b7e24266399457cb50a91df262f4beba2e56e788b488a4c35ed25a61bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66e3eca7fe860b693bcc427095a0c5d16d8875138ae0edb64b7b7178298568c(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56728eefc4905328f1d504445c2e50c483ed47785d3b27bfd6b42b31a2562405(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7a4e530e1e99c5b059c8224475b524b21c612b53a01221fbc5d1a000e3a327(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e349aff20c1d6796a078f2e88aac9af18b9aff8d3585dc9fabc4ecdf60227f12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dffa9055ea9428b0f0363c26f6a7f5af84d4f59cea4b0e55d9fbb9e268c9e3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__449e499654a4ddec8cea0ee7e8a7118f04a41bbccb003841ea12b59681c7b917(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105795251b088a5a0172e8821037cb5dc825280faa520ac97d18feb571efa4c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5de3558516832109b9b391e299e5b84c75c980f4910a196ccb4a696d927ae3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f781c66fa99955fb8314eb0201e5f4949d95f08488ca0443a7cf081d3a493182(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efaa17cb27888ab95b40a12ef35741fa312606f52bc8be39fdb13917f48d0cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17db799594c5900bd57b1b5b4959b0d5f0f0f3019081d10acdbb1fef55424dc4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46067ed6bf71aac47723539dba1fd774ec17137dc770e8ed93f314247ce0e11(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28327db453dd9304855c66529c972257c68e7ec3a73d08c60be007177ead90dc(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd892860f69c98384a0e0a4ea2e2ee4d024fec22c347c619a6b75b4d1617e2e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0dec10f3f6e3e73dd3fbb2adbe3bbf79e8545a15d38e8e945b12c0eb893eec0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414fd6c6d33c3aa275f8d3f3d53ddfaf9bc89da4d438e34dbeed2a79f19641bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacd53d5d1d4fdd3659ccb7acd86c87ac396421fa1191bbaa858e0adbe4abb7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2387651c2be0e4ca5131c3aae0761b37d94a3d3a82c078b34237915f228e78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f7dcb11d6fe135c7f17ff307d8920e9874e0ee1d2a37d59a4bd470f3eca19f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7698edb6c32a1fc4abda9673afbf70dd978773690dd98dd67372fc5d7147ecd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8740ebf7fc15fba9666ae491c3d6c84c5452132174174141680c82364e80270e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b327581dd22245419c81f14173e4aa2b40a02ecd4635d0de66017fad2eac98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc6a65f020d4e02d73601ca68c7f0ee5c307f5437dd28cb99f2511e15fddab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ac1cbb0d72ae76daf1bbe6c0b0f8fb64d00bed182155db02168c19b0f76ea6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc232dbe0ae1240fe8704cd83a16b43adfe1cb89ae77772e9a482734c6d5691c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f879f9c2237123b416d671b69d6ee2dc9229de7494263a4857e55c2b1dfe2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a29ffaba78728329fc369fd753bbbc0f9bf02862fe637475406d05a3818032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a62c9963725d80ea81f7a6b1dd72f482507121638938f188a9b0da02db7139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b5c2fab175e7bb9826218df2c51aa7b601d94d2df27ce90340c8c5a9b14893(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7dc777fa49aa25dada377f8bfdb9613b8158e0ea2b808f5f692c9a07e635a42(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ff5a2efec3c3e381573f4a889bd016f520a327969ab47f3bc051158e93570d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af1b3087bafc9c775fd228c1092e1cd953a88a0269f799991d47994a909f896(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dac497fe97980e2e422f528d6a4a71b9d81e1873c9222add5cd7c75bbdf1fe2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__951c15111ec6192ccd5758a0f20e58ecbfde3428760d3f34c2895bb7f58ba628(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d178d3b38722ccac5699409f2eb5cc7ed717f9b8d8c503bb0d828264768bf77e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d73c4f92650ee858422953426f190dbae6bda5110525d7a3202b1ebe39687e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4882df6a411ad973ef09d7b482590c30627932e3aa05c843e1ed1f6abbe2c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa7f363405461938dc4e78116ea2339b30c396430ac39e6c8c054b926496009(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafb0e1e83b5213b448e2063dc4178cce1ee99478daf6f7f433144771bf08079(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e8443a521b6b4ebc8f8b05b1e15f58c67509009de4ec53dcc053adbe842a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6d8055034f27ed8b3adc02fd13505ebe190b9f006f241eadd6ef0bd6f83ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd134f189118125802086e2ddfddc0159091b1781e25bf7da0272519151b705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd05be02ee336c4aaeadc36bd0cfe86243263d0f55a89b56d729aff5a07c75d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cdc67d908bf9c68b8a56e22e758501aa98682ed74e765be298e2d65d830f75c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c4775a713182e107d9532f49ee2acc8a0116c992de0d13a49e363774fa0b4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f20f3b936bbaf2ff182f3ed634ee418e09039bce7bee5106f8d94ac59c8fdc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e5766deeae134e6b88df4be02ec5fac9bfcedc53038bb80f290a94ff827e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6657d768b79624937d1f217ab4af0d7028a9e3b9cb85f685c474b4a267afa5e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fac844bbc113f9968cb2bf29f45f33808636b581a1c2e7bd54deb110d0e07b0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d06df67830b0c56fb794af22105e476e4740b45c986283bb94a4a626a1bb65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9987ae7f23c8994fbb930d5803bfdcbff05556ff6bd4b8a79e82e5ff1882ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45cc967c21ce76673ea8e180b4dfcce7b9c278232558aead3b62ab6edf57fc83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a11a25d297881919717fb25f59899b9944cf240a17c81bedaf7c4983e7ee460(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ed49ad36da886ef6ae34bf5f32b19966b342817343b1ce3446c3ff1a9c89a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8ebe9dd4318a8678b969b1966c7b4e2c54be797f157f8372b843d626fd11023(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5a23ac43168325152ea07f3fb4e34b7ba030cfd1ec8fe014fd37dcdccda848(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe6e486f7e9bd911ec9c38e167a1ff010d01fb754648f79fb49083259deecd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36378591e86ba9ad5a32078badfb0b3de760588e060429ea1359f7c05ba5d3fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7c3e8b0e2c498b97039b3b0934a942fff8ee97023d4f76c1fb2893ca64d27c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d329d8a217b5925ada33d89653c8d068d18836f53446b9a9a59a5ebeed013eb(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7b2a9e123d44afbe54e30e74785713c193181fb114600a94c443ec667e120b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa7349d3b24d54fbca302f4115fd2ddee734b5ffa19d4422d6baf27a6365e05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327c637c66e07d4b1f8ed9ee74ca46c5d3f295db3495820ef12d9db6e35dd2e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d1aae28bf79ab98e00372d5b5841df6ea8ad31f828fe5af24057156f551f0d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e5eb1098896d1499524742184a66fa2109d80efb2f35d419797e1e05150e93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d766e26702520552ea404cc228e90e326ad4b13e3bbb3ccedf6faac6e4886d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9130f87a93f53a40f9c02d699ae1e7be6151b918e2a38600ebf75310b4962eda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30cf6f11507445c4a0ec0271ce9aa15b03dddd29ff6b4a769805b8017be51c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892e4aa810d620ba7b7da9142b9d9e491028e3b6a31b50be421eb87038539c69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d619f57d09ef2ecd6a1f0dc2ad2a3f36b6d1fc6f545aad22c26100c885ca2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f86639343269af5b8eaf1d484105242b82dd8b863ab2ee7cbb8cdc2e6a84c0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbde82c4732be4cf26a362eb026bd51c3c7997d0534316a9e98afc0d45507999(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2760b12f71a63e6461a4b69311b2d0ba6bef5a4e32190b2b4725a45fcfd91df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02e654b806c4e0472c45108e992482cb50a9472d4fbf1183fc6064c7c8b29e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d05150a7cd132bb782943b4527883c86c16720df2042bef45cd1380c4dafb85(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2317e36730e8eeb09625eb95a69fea64f3da65add43bd096beaa1ed694594925(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c068d667ee30a5ff9ff54454a84abf2fced7f0b6bdc488ec1039178d7f70873(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c123d54a4183b338a7fe60a57a3bd005e0239d81136812329cf121addbb4fbcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d22984b014fe04458b649c1ddc5d1b26b02ef787d7a093169b0431ac03a629(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f761a0f295302fd346437c1028ee04f5912ac5216f67c09e98cdb52a798d196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d7012f2c00433778004fb9a3989260938fc9c6291bda932f980bd129b21b31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ea2a0f0ddc4b4693159bd6ee63c69ae22cf90f5dc7f3cfff93480d42c95173(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a6338ea0b13a275ca4b8b8a83075746527bbebacb2c5c28051246d8f3b372e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52c1fb3dcc601c6f09c2171e8772644a7d3629abb027396b641b8aa4d1cf72c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__451e015f0926e9eb4558e325b594bd8fcdbe6bd324d8d457938b499c5e14c726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc1b29268d586b88513ec6cf1b75a7f15e94f344a61462a3fbb63315957c8df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa925658837edea073b4507382bb86e4d28515931c02c030195cf2be59d5a5a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c481420a2f97ff62e6eb6f1157f7ec12276b21df142b0fa5ec7cd6c205fe85a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdafff43457e9c52f55a3bdc44d45ab0e9b8e9b5605c7b204d207da759d1bdf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e2618dc5378166889a9e8b6968ef0ddfd421b0c3c464ff67e1615aabf2a88d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe474c3aa050037e1e7a5cf233b4f39dbb203300361b945bec340c8303a01a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f85b6df3a4c478fffc010467a3dcffc188ccabd034c063e23f294e23d75f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487c148d62277c09f48954bfa22e759c337715d63ca0b0af5d8144a948439092(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5597c3cb3a51bf08449bc95978bba54d4f29cdfe6b48d423919a617a392946(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0453a525723378129d006ca843a9cc641eefea23aea66cc904453104438753(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac103ea433a26413d3ef8ac1965485db763446763913bbaf8620e7ab215e2a7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98fcf2782a57864977e8896daae5547cfe491c18f577b31306db120352417f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5be0ddff3830e728e1b56fb5dbc62f9935f06e0e3f5dcb24223fbdf94671ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c5a0ad97399ddd5f7df60baa73c1d2a46215d5432915740a2d5d9017364fce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c9dec57f9e19d4d43750c045ac26b9097ac3606f9b67b9b61f1527196962e3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36dfed5046a2d946e86bd11915eb6999b5b360c40ad74d514545bb7fb258e056(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd2e0e25289d375db25ac6e741ab26e44e9a9b699f4b3a3f98d04de76f77b1b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a666da9de00e389081e80f225dd3f79f0896628f49c0ded0a5eefacef4317e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973b25c9426b2cbfff2607a0d68288988aa58ec153737ac82311708cf8af46bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342f776332d38bbaa5313290da168f52bbf25b01870c755782212cf3337c6c6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6aa0fd79850590bfef67836f59687bd8f18f693a20df1a691ca7d406b4dc6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea69413beda11401f477121620431a17bf9196c384eaabe1cd53a877b33b51ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193de6df164dce638e4a1277da96349d118bb35b755de4bcac56665b37abef41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0a03b58a87828d7bf4f749d7a90be3cc0ed8d8d360235315a6a1f65731f05c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd19b1bdc90ce2bf206022850c483957370ebc5dca788ca075579bea5aa1349(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be709719b9a9f6c7a28d509f7ed0297dbc5a714c635786a05617ba25b3af6cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa37c93d62083c11821154b77faa077a0df805800bbffb4735be32b31b7910c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6505fda8e15004368bcbbd3fcd94e29364b56714f38d560022233c66b91575b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92106bbb3b56f229913f31957aa58d91945f05bf3677c4465e0d2db6254e10b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da58fda8aa597f1ea5bb62d36b0682c013e6391115322c2939953a6a8beb0f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe21517afa9b8d96dc5d6cff96a0e8c3b6773f04eeeea38cfaef44702d033090(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eada07088d35306a589b1159b5ef01ee5da1c43a9df451637f26673f57283f9(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a1b27453da760baa48806ec561ba9d1de15da0293900c39c33ad17fc787d967(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55d446f524f6377fef28285832a9cc1e9943a11972eadda600e60fe26492bf4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c55d8712510d6760df87989be9713dfd780d332872f34dba764beb834a2228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13999884d93c2b1541cdf70e7bad75ff0a8a9c8c6cd2f1dc320708b1b673b1a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8cb3afee6ab338e9a2275d8b89ca4e14cd0df2aea1a787e303269e8e79f227(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f26534518aaa56a1a124a589a26e5b6a6e5a47637ee3b6e6a6dcade7e068b03c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1db51804ffc90883cdab3ed404e3e3356161d953bbb99c467787b1fc2522d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34a1d7c8f6a190db19653d029a4d362315a88679aae84b7916db3033165a24d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319011b9fca4cb392eea32a64837261abfc309d171cfce58e8d17c8d9d1a4b8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227ec50e71fc031b6f5faf59c730be62520516760a6c5419c11351a17e8b8915(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b15e4f5778a53dd049297d748a7b727bf9537f6de48e5cf28288c0d591d8f25(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d97ed55064fd759482159f885723a06fece69e3f430f98a808360cdabdef2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657791624b382cf3f052ffe179851f0966c3c30938ea38be06af5e64b378b930(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab64d4ddb45e360805a83e0a1564808c43407a832d59d4009e43ab46dc527f05(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a47665f88e1c4af6bef9e1a8a81d5a763e5c44723ffe3ef806cd79618e45953(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a475e9496546eb96f00d8e0f077ce76b05d5ff04815cf862f2fbd945ab6fd819(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468535f0a7732438089f19e3b93cad99f52ee93d1be1fe381de2bdf5c5f34d46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41833abcd7040621db7ef57649d8e6c8bdee86f8e58c907099138fdc27ebd266(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc27940e509f1878bccd7db80a5017007e5328ab0562b6d847142c455f085397(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63030a8d4d727146ba56f289bf833a530d6cca4a36a4949ce8a606d257cab929(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__839c18a6da309c1659883260d96088c5e65d2464085a2ac4ce9370afb06e9d5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a6937a4f0b94ae3bc8ead3b201af75d13fa8afb98b1ac8d1f870bd2c98044f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8d14d40df4700275a43b1d52e44eae8cb532aea005b8b7c05b8b1525806333(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1052d59d73b42d69031b32f65f6e31c94ced518bed0237b5d32f3f0fcd0ed423(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc759707c2dcf3691fcbdbeca941fd38dbceaa190c020bdaccc0d546af41defc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeef393b1b0b232bf9d04684aef6c0c351c5afe00d5af8dbf465afb49844f2a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6933017bd4010cb4ac6add043c3a27d994f47d3ee1d27b57fa0ec4e7188686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f2eac099cd5cfc43826df856a21f4d2e4a96666a624e06fba109fce94865ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e09e64866d8cc3708593acb01b1ae8a2ada4d225123551c3fed6160e093279d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7dad27c4d21f93bf5729b73a27ff3127a042ec23c4bc681c6283772f59042e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e964e66fc984544f545c96e556d4a15d9a33861afde7bfbb70bc6ddcedd9d83(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd07a6525815c857d6c37d17f66b2d2c91dbf0f3117b1c268768831837c6a46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f1a1cec5b60f2287b69adbaeafb410c03ab038ad8e43ac385c3365af90a269(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc4f6412f984bded465349d399ddabd5816d0560d88fc73504796b92e8ed3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60386bb8373a5b2d69715d20b440f44c9d09f96c9414fa8091b7bb005af2fbca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167c7df1e758f242c706de5ebac00dfcdee35a73860d50330f09a47356b00804(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad8175d25135481c752753d9d599ce7f76d7872fb0cf4f0251d5cd52ee8f7d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72409de9fcc627191a4df259bba04e3d9df32ab4d0b0bc7c48633faf815931c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2141cf611d45115739ab3f517fc27f5e472e9f0625aef801bdd7bd5d9900185b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fdba869876c6989ab88836a65b31f9cc6229aaf0f7fadf124d660f33fbd6444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7060f703f03a48287b49c6cf01f493ea607c97300468d94c047ff7753414d712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cd3cd7721fdcb6f808b069c975939f31c92125189ac8ccd6ab2c3f488afba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f343bbd217ea83efc557aef75508bb57d455ad6f018df7ec8f00eb889865d84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d0904c0fd23a8b025551f2f7bfa42e5b4428dcc87712757e029c048d718107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f08a887585c39e72f4c235817c3e52c17eff888ee804716f093466bc3507cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58debb9bb2e6ec77651e51ddad963813feced8e63d00df03fc6230f9f2f23f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9612c7e6a345bf13ce2e18d6ac33e7c81420bd74202b4dbbb0d6c59cb64ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcd921bc90f0a04ba5d2543076b239ec530268abb0a63d051f61a486b7db294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a3d00059575bd744711bea4f0c3b94d71ed85b7259a39571d669b5ffcc873f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a622ba33065c61d4ed81c6dcb5feaf6f39ace259db962045c6b9070f988e98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__140df4d6dfd87ec5832e765a70f14b5fe6cd23ffd336f50aa4ebe09556e5191b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a20d094cffc37fb3646340f73c847d5b803ecf967829a4b1498d0a9323e78a(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68b07c51964d053b1a36a90ed36af94fb403b42305ce98517673838400c01e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49421d0911fed6a52dab95a2379ac8f9a67a5f85c34afe63ef8c1473312855b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4939fcc220d1703e0b119623141bc02759ebbbd7b68e69338056175b25ba68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf4e2d6a8ebc455f35a2665e47654d3dff7347a8d9baf2cf6c46d1fe301a425(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443a7245b87aff80b50298c8ddb65061378b4a9f06113c1a8ec43cc7b2f943d9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7775e1092a8d4a338f573013201f4111037bb7834bef7fe97be79b5091b16821(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c467a0042bbcb9428444e12588f0e83aca90c640507dc535dca9464b604a9d73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2654b11708c9b3bb0a2dc6e53919050cc45818e09e5805ccae17377451237d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc52aefd1e5fb6f8af06f209b7eec84e78caa306f4783244d232df9f265f47a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7657352c74138959561bd6526a87ffb628ebf977293f74c6b2e430ad99d38a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd62cced23e307a00d0ca8431c256772889cff21488ffa711c23f658564f6e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e23be6afa2a2a7239cecd4074700e115e9f29f7e7687355aed83c615103f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6623a4699e9d857212369430af94c5c743536c77bb2070426682f85e3e197d13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7c8d4a53547b224db53603a4a5607e95f0469e56b2e0c1e041886824c96600(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c29a24eac1136aea3cb9ce28c5a8ebf464b29953e2c23bcd9f741df26684a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b10cd98c6915b08587868422aea3928c0d0f4a4efe43e8aae73398d7b944a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66296dc35ba15bcc6c0643a7cff416a65a7aeef283b9eddf4ac5e40a786f1223(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca42d52c2213ad2fb8538bdab92d6f7604ebc7f1568f8a9a364a6e99ebd6fab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff28dcc4970b09e1d376104c56f5b7d2a57c6a445f668b1cf8a74b7945e71c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__794ceec1ea7c81278c66284bd634359c02bdd43f9952f61e9292dc6d86437c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d653916137e2bcc820748d3a3ec120f7e435042c83115ed8d6038246ba5d511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c660269c1aac9c909bb418dabf1d3dd6252a8e07ed9c412096807494b64ce768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f325624f200be593f8efff439f5adb32686b7cb60fb0c2538f3e0d25e6afeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26846e0fe2becf22662b6b1a78e22c625bd780736ff4301cb2e793d3d3f63c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1720801724ceeb0473784bc306927c6b9dbab19ce35de4c0b65a782ea3b63250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae01e337bec96df0c63e150728d0c6303f6858d0b254819065e78fbd7520ae8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d2fc9a59d19ceb648a4f7883944a651a710b4e263baa041e4453ce21769d5c(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed36c6c48f7233f94aabced4356245f6cfccb98a080c3d0eb9f3f4ba3cb3a24d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7b3092def76366b24ef736495376bd8978d88ac0439665505f3cfedc134091(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa12ac4f8d55914e7c5cb2cfbea2445a106d3cd20098db8150fde4e612bb565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5983ee89e33c9103b9533b85cf144158fee3b5c0da6805ef9a0b77e8c897cfe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2206dc6147e3291da917783a3a992af0e1e446595154e9b00fee8c9b3f9e9010(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c9a89067a16dedec5911e48bb384c400428c3c8c66d21548ddb62bf7f7c548(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba87b8177f30559aa11f5fd5728013a79d90fd891bcc8caa94206735ffc7601(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa32118968bd878ff7d1ccbe83b48d64b27d146bdb57f58f20968931d4e226c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413c1c3c2c5fd4249053abee924105be7fa0e94ced1e1dcbe0194de2b56e69a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90e037304c8850ee87b45273115fa9bcac0431d117be65e811d0e939408e7827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e114b24c13c5df4dbc3d9e77024b56450df6674a87299dfb296237ac115407(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d440da5d34e320ae80e2dede315d6e0ef95ea412a7dbb7a84c401359e11089b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a5b2c237244fe5eb6fce1f6004b8a6d841995ee6ff10e982fec0f31294dfb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace7f3e3f1781d6f70d419b77c1be0faa87caa92503f2461b0f7a6e5fdce5e44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b33a9c5ebb4ae0546d6354c77a36bede85e0400184139eb3917051546702721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c0a25e9d8e951416286ddff2bc512059089573ff06b5ee08d289d50e0f90a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3654aa15ccb2867ce9546d3d6f2c29db0098d8d0d0ffef8f1b4609e04a32a4da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6201a0fef59f0f5822261e852a1fc92cef43a2b29c87cc6f4742162504c74c6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef45ecd2b59506fe05704dbe0e5b7a4aa061331046befd53df31e187ad04e6be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff1bc42c938494089ed54c42712343c6094e60a8dbd161f69d17ae0de210fa63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac61c2c8f5fc51d7e46375699be92294ca54f7b95c8dca0171edf3ed3b6fad76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67eef7bb4d8db379e4beb5cac4913095bbcc0d84314f4b4a7c1a70d5432fe10c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50e204f1ef3fba4ad087e919077cf5e6ce916968624253cc6a7ecfd886b8a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0714e024eacf8b1902e6a1b6a154393138a292d136b5af732e2590c5d5cd772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ee87452d32a4776f5254c9e50eb36aa798b00a52b3f9a840af984ef6b781fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcce896386e4299b513fcd08c6a226ab9ac63e68dfb6722e160049f579c6eb46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd61d072a94b5b80c8b39966c920bd8e6bdf574c18f480032fa4ca023f49e63(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824700393047dbe66d44330345043e600400b78e26ad3297685fb7f4e7bfc53c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7dc01d9b091e7e88b66020253a366f162d91d39cb342e068f01b5d7a06da0e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da86f122c36ae957ac42a12bfaa0e2c797c1fe4b60188fc6f7e71338d902dec1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41455b5cbc5e9e7e1dd263be09ee401e83733f309f09710a076a411b9be4b6d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6f43b35dab42914e14bac45405e148d466eb25655a93ef63ba86d735cc0593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6fee9e8cbc28d284f4e9f321a07fdff35c646b62cbbd1eac283a7ecfb5957ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df670b4a3c70a522d00096c66f9c472f4740f41a32d2dd16abf8f7449e867eb0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f84d48840785b99b66a85320c8c3a236b5a15de68b7985fa54ab63ee0e3bc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8887671d26e5a251ef4c4f80bdde2340d1a1ec5666b1648e7eb27db436230e87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a9085d7f145c869baa347d7dbd37d90d7c045a0b6c4896fa37c40d96cac40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e673131e66c3415aa19f7da746423c7138eea3d32d526994d1a361d330947cc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e9efb6926297749a18b4dd0d31093938769268864c8aac9208ba390e55b105(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa11c7d26a937e21e82567316bdb7ed16b98736bef24b882a1f670860752ba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6408ff578af0b33fddd2309665cdd27191311c4f1b998c66da9f981b5a263a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d3e178d86d30036a291dcf73c25281aeaffc7d403cfe15b36499602b9a6376(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf8a951bbf1e7fc6e91c20b78a4294dfbaddbcdb0c5f6eabde768ae17a720c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb241bd960a181d4a30e504c177cf137495f4acbb458bde457e6fe80d42fa41(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f63606bcf3919437d666a91de5ef20595faa149af3516819e2b6bb7c40c2faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5a56084c580a349523ea0fb0d0a2aab1ddc410a8c9294dd381c1968835921f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8e7f4cd95f853a19753910edfa7f4ada5627ca343011e5f17d35886133807e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd3d3964d01ec9821ddc72df0d5f81a73c1f72cbd4dff01c5c4760e6ee71ab8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8934f01c5d4e07e89ea37f50bbaf8255c9564f9d2b84c256e0376598f841bf09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15b98e2839870b62aafc3fc412bf9645565ec4be41a402715d3067eef259aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25eb7f71f8bf4a4f69d9ba5bb5441047c0f4a2577ccb011b0db36b75f5ea665(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6682f1c3dde4bc3814b20cc84550b431a144ef3fb319d2ec3c7a37a9856ab14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4846f375edf2f855ff71bc739d0fbdf0d9213dee11a35aae89d459fa5c4dce8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbdc2d6030d245319592bccdf996718ceefc60553027a3fa4f5f04c4c0f4c6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109af45490141fdc798f44182e1d53a6993476f9d5240a54fdb5b503dd52758e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273d6a39306ead474ce833b2daf79f869b9466694ab9f8d82bf8c06e66b62aeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09dbd04125935e97c1cbb42b8c88c947f479973f13b314ac7ad756da2d25062c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69988ef792eb3f6d0d21dbc23916a152eeebe300250ba6d47abe4f4811e784a7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2213d93f7dfb945bae6cc3316ba69966b90a7ca967803b143997ac9b2d72b5(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330c7d9844836f457dcdb731eb57a82bdf59f8c73105d24b881fa289ba27ce5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e85aeef7c218ec11697129335723b7bb47a4929395abbecd3f2e0b7af89156(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c07ffceb82af71072548db14c4195bd97559acc3a91f121d0fe4f222caf912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cdaa1e645b35e6b2e173f72ca5d5090a77c076e829bb0b4496db9a094633fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14881261a3703ed41a8299f2a7520e16a849c7805531358c17caf3a6e15afd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368c404b96360f94ac52fcdd19ccb79d395cfaaca9b5a5636a8eebb934159af6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6defbf45682cb2f4b0bd0564044adad5c551a2210a846a5ad91c81f6a0b9dfb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca1ad6f8896e7755a8d76c177f7e230af7adfaa6aab57335bdbf67a1c197dc25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c46fc2b4f6c3736d36bca15d01a1f826a87d8b7dcedd636003adb1f119417c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f6bfd08b1580a8ffb03a3a531961c657a90884f3ad84f051549876443b4cab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cbbf045f58869bdd1fb6d2220d475906eae3ae39c99f7382894e7498b541da(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8dba43887be59bf7764f7bea9b83a3ccb9091355bdf8d5a98ecc32472cf9e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a108d2e7534ec07f6153d42d09662903d8ff5b55eef3366bdbf8f7989f30f48(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6835d0f4eea6ef5a9fef46ad28a4d15f7f33d1c310cf1e7fc9db0ae95628fe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15291eb4529b6d4062117e09e8543376da1690d0f9565a14dd495bc6d3e34413(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a144525b28dd93dcea619e074626f2a59eeb7244efcfb91ee2c0d40dd6bf4c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70258dc2611adc6ebf0c3776aac5bc9b40b513754757ac13da1cee7b457eb9dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f19fc8bd01153fcd881c360b8ccf7bfe3d4a3d18ba042134b25072bee421de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c307b06f666d47b2c66fb5ddfd540f3b714c56bf92bf51b553746b7215b2526(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5dced2f82db7d7eca9d186c9eab47485b3058fe2be10a0d8869a1d7105b67c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6c330903e2bc810357e62d478456305afb6505f93ae2c929813d705d542515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb948d372197f43532a9b68240886831b261f7af5794439af268750870f3ac4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc9dc92173fc9d0d7b9e3526571bf082fceb964deface052448e61e0ca3730b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d20ea8fd9a12d0a07f2609ceca4f22aa21005e134cad9b2121081e8fcd47f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff0e49d4f8b64de01cdde9c5504ead7ead4d1d71d3e3505d5304bdad5fa3024(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af601b9e714ab0e004f38f0acccb76d8fbf14999e24361da2e511823a7c01be9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25392ec868a7d982596c06a8af678d2e423e1ba01ed500c55e8da06d87368d32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0774d85345fbab2cbba85203eb96f0d9c41fd86af668f4c0a03c01d2a15e5407(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ffe98524e22b0c26bebbbad1bb0138157fa09ed02aa57d6b0ac8f23eb5c60cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a971d50f4d9b0d1003cbc4920b428cb9221d1a8446667804916aa9185c3ace7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a5edccb537bd7f71474b6542b5ffe8e99ae95c80852079a65c20729a1c9dda(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413406f8384c9e19b41df9a90d09aa49fa6973bc47357283c95d1635c5ce696c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11daf8cf8e66ec6fc3c3d40e9ede2acc87ca7bc11933f0bc00665bdaecf2ac87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb038ec578ad615064949c3906ce7fefa229285b62b40044fcf7e9f81ff724a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df89ef7478f73adc5f3d4080609fddcc0f44cd54cb1e1b204b4be8491891b18b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e069d465bd8ffb17cf8481b6b23ab9d9c0798f4c962a6d863e036ced0980adec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76780c6834d22544d3f3bdcacd978e586189a044b5460a2f07f8b7e3ad88dd0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65d2fb09edbd17932d8075307f7657ba37b9cc91bead0d4d14c478a7ca61f83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9c64553ac4daa3f35c7da081e68956a0d917d672e606985e5dce9400a42f3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ab62bd5dc47403feda2f20a8905cc9729b39cbbb5ff4dcc9a757aa52069374(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeba431c2f4dd26b981acac832c22c8d7975178a19602d4dbce229ff30f27b3d(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe581b2a350847b5b132975e08c436f629ab30ec5b1371a9df05294ea2cc4458(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd028d14a688e0997b60df1c23e64d0048f587ac17d92db32cc12b17c05284ab(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d219b5d9002e9d0013a5ede639bc040da7680e1c177dc6cc3eaa15b9bdd15f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1091e897458137ad48873f015396202941c99dea1a6ab1951e3177a643ba1a3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e3b69c8d51befdd6587d330ea94f5066b81a04ed89420340e848b8ecd8565f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f627b283938ff162798369e3035c3fbd07e01fe73624d56d7cfe7bb09492f8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f52b504fc4906a7b7242299eda8f389cca19ec8843e36e4b51239baa30aa743(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3631c0285b32aa26a7964f22c40a043bff71587503d8683a05c7ea5f27243168(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3841ee8816902f083632d9f421025954bbf3a73783cd25aab83f768734a06f53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289bdd355b91d9db98f3c5edc666ccf111e7fd17cc91a3922cec615c90b9b781(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d6a00b7a098a0fddf6e739540f1d8333c68f2ce987eb755680c268cd50ee0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ad45df05a1897568479d49f4ffadcc17c3b4aad8d9a75ef8f34eb4e7c18c01(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28fc574b4fc75ccace2a6efa68b810370521fb0803907bd9e2815d686c019d4f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3fd4e9dc532e04fca1f68df5e0952e3555f2f92d47534ae075c2dc8b3a018ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144cfedecbc012ec614fa07ae8f16a6c8c61eecd1a594a7c6abf0a024efaed3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d20159ed4460fb25db35cc5bb783d4bae33d484d82355ecc2ef75b2cb16a015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bbca99c5c4d00c7050517d4638f81a71a4e03596e80113f7fc33a9d9ecaf5ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead0837f748fb620008c743b53276c289c4dc75899363329e994d80897dec4ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95bdfcec04a036b855b7396d3a8bb216be5eff20ad6f93e1c4910f718ac72903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14b4c87ddb86c0e28bca828afc56f34b99950c659492ab329dcac5aa51e93b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520639e9dbde170aa8995a47e1896ef960566c9b093b4647dd7917b288eee8a4(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f09dc8f7bbfbe3a9b099b645e68a867d2651ce0fcc16b17cbbe0fb0beaea31c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f72d600f0fd8b2483aa0c980c76fbb04dbb8f2159c9325247c5844532e0a1e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6298f01e9a22e39aadb1f0a0a5d83d7b4417356c16bf2a9f070653e9a2d8f51f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ca8bef591c7356daef60c7fa0ed0ec595dc6b06f879e1478214932d9b3b058(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e283227da0c582a6f28debdc8ac3488dbb20208866808497f4fd17aa371bc16e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b935d616b2fc03ef21eead5424cda86330f0c3bc79d034dc54686796f2fd6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ccead64585495b90c14f4d87224e6cf5782db668df2e2a79750bf8660c88933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33647a271b9b604c238eef2e9c4812269523d6beeb78d7b1f2dadd3d020666c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257be52cb99e60c3fce56ff37538699760e5cfc882009f297721037b450aeca2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85797232d75a10806fe6d8aef3859a459ac19bd3e1bed360e07b969ec021fc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34c5b3264049160304e76fa8472c4551dad28cc203c5891f12f1bed7b7988e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd298441c0236cfd78d4bafba16b2f2cbeefc707a23a83bcc584ccd510682426(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281faeeccdb6eca686e907553fbd58613667777845f003d5df280f8ccf45a20a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18379edc1b2bc5a5ed4626c8c35f2aa1bce0fe9599b7e5e16a96851337a39243(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7979ad2fd55b214b0b33b20aebe962f49feb6ceecae04c0979b5654aad335a6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea6c8f0dfd2b0d6dc67294444ee9c0a5d117b5e78e0c2af3bd939b7f190b703(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d22b808254e98e23d7e46cf52e27a72a8a9b565a698903d88ff25df136ea934(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65748e620e0ba9f17722aa5ae3c159cdf61dc0d2a684cd0f10e4c305096e6af4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96fcb92463046cf3dd66f38706ddb5709f5c13e2b7d601b66d744f5a6da38fd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b661306053c7f8f5c7ab918294e308356e04bc312feb3a7297555a10eafe0cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f46d5445a9bd927fedc5222943f15a6ef7e870fb13257dc72456c413869989(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da91d37cfb29ae4976b399d7daee4d19f715e8b2abe33f99a9e41da0f081a945(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69891c5535e5979ce2ac31426fd39bd782eba07dc840d8fdf4a5bc911acf910b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b04646daa01980738c438648306be8049f3c8e5919ed2441340dea66ce8a620(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac54792089ba002e1885716decea43cabcfac3f5216727c11b13d8065b178aaa(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8712839c8ddb9f5c53d04fc9aa983d6ef1063086e7694fe7801aae912a973738(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6384122612b40623889837831fe43ff84fbe3c853a4fa01fe609e98fe7b94c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed837a03896a6f2bdfdaff70b9cc3127ace1c3285f24a8b0eb2fdcfd349afb47(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08809a6ad8c57affc1a6bacfd542acbf5e617a940d4a179f511e155ea0ba106f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968076aabb3e2987482c15defd2f10140148a82429c1242ed4b2633eeda22911(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb1a0a243f2277d67896f959bed0b85bf98e318bf5608f0cd9cd9d8354a892d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b3d8eac2e2998615eea4a34c22fae6dca34101ea8e1cd6bcc8cf6819f2318f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea993f9da9436647b166a8f8c27da36f14cb80eb7fc24d6a9484b4326c94dfd7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9ca72e03b89f5b68309345fe5f022459776b9e9b8f288b66972e89577161c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0053810fe8ed309e5a5ce0defe1bfc1ac6458c93e80616c6423f58e0e3f01e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b8131f87dc03965b538df048bff4f12ad6ce7a6cd5928be462d23e57dabf08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3466b59f25e215d696cedb2317dd4ba3fb591eeaf638bd0e70f5cdfc60c30aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5531db86929b94a4fe9ea9646e1ac71f35356ffcba74068aa063c31fab4be37c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ec9449acaa03526c675c123c0c0388dbe68dcffaf1e4bcfe1a6d3d7536193b(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2295ddf3ef9188590a399e1189f1665982823fc61ebc5f6c4d45579e28ea952e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1561ee99823b1a9a933472118daffb19f51647d5d8a54bc88071e2b34103b538(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950ba05defbf062b910296f2359df168d819c51e44258a1ca9418cf2be07050c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13802e7ed52ab51c7f757ba498f16de6f530f6b72176bead6002785205a30086(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2971e279543d0b66ed8c55f1e7108a0c0a5e09cdffd15ccbcd9a082ec6d0165a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5083700a795359b3511a51ea4de60423f68c2d2c23f3786046c506212c495d63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351358e6e4b225753113a8453a4d0817c8e2e627399341d7c140eb7aa03c819c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f44b6dab6ccd0d9a23581102315d9fc202801326b2686e26a4aba7a18e3358c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21dd50109b75866bbb310bdfd7886a1eff6ae0f05ae446d14a3a128ade873db3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90727c5ea4dad8a061432684cada5965080757297fae2bebd5f3d46c4f71b002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad3156cc9813e8fd206bad1e1a5ef0b22ae613d180f91d60f727c1e4f86b64e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892f23e8630c3dbcaf661c3f964c3fde2e602c348439bd91b14cd1500bb5576e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b37edefb3704cb24f432715594d6cf9d56913910cab524bb1c2608caeb7dd647(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc6c3a6b11e3d1accdd9a83c367cb7bfe8710739ac5728bed1b0bf3ab7ed6ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f6e40900a7be26306dc2b1cf4fd40e2b1bacea0ebaf29b560b5b106a6a8d4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7867a2d102df3aa36e11afb75dad99f583f1282000460bbd091076c6c800e68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c4aa129205c9faa0b8f190ba3419038e78edc6e94ce58db8777a86bcced371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4522f208b140ef906b5b85e731f659cfdbf65a4479d69c3eb0e6beecc52fd102(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857fc849c73a4e83f2f0e36fb394764af0c06db948cfb81409ce211a1f7febfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8228366be639fb0f153848976998b0264a823cf92882bd0586d8cf81f53d0c20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c791fced105821472a2972fccc3b52b2a23914ebe25093dfe32841a6c2500d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc5babd2426b4680cf8e85af20fcf8837ac3753bc971cfad16b854754ff560d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96338e02eeec7cf445955c852446d5663d418e6f00fd97c0b904033d28feab82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ffa79bdaf4924e06b1de5e6d9247bb2cb493c01fb77c52d1c5a4d0107153b9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f7dce1b4b5a2231a626bbe38c049f73f7b52ef48b554dce41ce08360266fa1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c968591aea399656e175bbc3ce4243df056cde512f6cbfae5512458aeb7e91(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80f4dcc9f466449482936d24a8d957d228b6f74877bbd29447b8c7e30be1a69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cf5793ff0c06b86c2539f1e62dd5be7109d63251d17dc1db5b42d80193efa6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04258c0d12df14b74dc8b8cb09cbe15954703699d41e47ae4675727e0307f78(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b95b7c2dafb1d70609db26b885c2dff8f6a32fc2bf4fae0f919d61100080056(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf595163d369f85423f4fe80246aa735f28ce989daeaaedc773fbeb85336a568(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089ad6bb85c4e65cb4c9445079891ecb7598e3b1ec9428a089b09c74d3bb24e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf7127fccbb7a51f31c697861bd6f85e1f94fab0b2e2ebe8f602557c9912c9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58eef98b19415e59ea495b0d4e06637d89efef4ced0c1792831b858cdda05cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0571fa242a336313a463e0fb381f3b6ada806e3f3f2b34ae62ee6ac058f513b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6209a439aa17701dd979be9d931007460d56953b53dd662d6cbfc8bc063b581(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a40834d8c99916b42fed0c83f3a67037ad801dce1925fabe073a8937fb6e32(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842fdc4f21d5e14df3f1628b4cc3373e84cefc3f309c44d8564e3d437c1beee8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c404c17a86240c6f312d484388ae936131eab475c9622f72da6d05ede94f7dd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df136d75c3d5fa1cf797a43ac4e94e61d41c6a44b999b538f8be5880933afcc1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce64ca0fa1fd1897c529db650493ce4bef994b3f0a04dd837c37b9a6a32fbbee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7f6ff54d5aa54f6e283bded08c7f12295e160c9d29a95757e1c7aa3cf57439(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c052ba2a9d4977218a8c770ef5042c384add9f552e97c2f18ad1fcffb07a619b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a7c37308e3bf6e280bdbeaeda379018587de12979a5ba8f34a51aa8ee4f8cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968a0471594420cc1e77585bedca1384e404b48465f470ffbb1d18ef2705cef4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f2f296a92439572e9424163ff5bf346d3792184da99f4e50bfc92257af8a6e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bac135f73f2af3a72342a7eeed77ff27d5c0503fbba69384ee47839e2362ebc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccffab0ff31f9ac9ffff8f25e5491bccd86c12eeaf3a3cacdb7356f9c2b003bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2805cc0d4b93db1e19e095b7b8c228c672316c8631e43cb07203887ddd1088(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c5e9c0169c5a705f5477732c1590625e4b295d718dcb4dbea5304463264849f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e1ec821eebfaf2d135240af9868d8b800ee8a202c9059d06d21726ea76bbe7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e482e3348e33601097a9921a8896d7e44494a00e41fae729dafc7bce1ec98676(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0df359e56ed993f97500d1253a80e42e8abcf8c9b8cb1b86b7e1fac9814a907(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcf405e6d9f5c78b020232387a382a877056681fd7fb77a1f8fc8552b2bd0af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35a5b19875a7a6faa344ad57cc2c147767ad4680b6fe230d80f5484226131a6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529d9f1a44f6b0f24ccde2303330405d7f7f5066b1fdf97f3e4a112ef592125c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1223a8d9b62081a995011fd8d5099bc300e3b35a5b53b502e55f0a14fc5d6b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3393ab32bd8b0901b62e633eca3412f2a052bac3f9918fb4c1fd842b31dbcbd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50731f5b06f3763acaae28cf85c156c31d61f7964abccdfb9d030acc6d6e6192(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2dba51c55169a7a2b95e89f5d48f07d97b54ca968fb68053ab32535ea72281(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41dd6466e6c2d39bb17984ef0d8ccc0e97c4da9224378ab4dfd130c13f603024(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd31d77a7355e88e079efe6485a09b8cb5548dc51f8a98d220805a9a2876315e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2045bb63167549c934d403475624c9cdc4ef07e6d982657639e698a3a20eedac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db95f9fc29423db1943f36384013d661bcd82d1427e6d00e962f014b02dd0c89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6c9b7bd923c4e4570545084b845d965d8bc7a10d30da844f7cd1e5357e1f1b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35800aa7ba898ffd2c51821fef9bf0c25ca1fbb84dcd320a04f2f7387e0ed41(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71039b8ef570e718e04639de12528a072d86d6d12440372ff76c8ccb340e33db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7d6eb981833530da15066447f56c05583941cf4dfa3530563100be69964e07(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f1ab5b390d85a04a865881fbe9eba0fbe34dd065d5c4a8bf0939daaa6941cb(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ababf1a6013e392a388b289cbc3c7e7aca2bd2d1dd835764664b73718a3a10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a7dfd2cbb77de39f36be7d6d0e1a3b1a80ff07960fa08c6f1d3f2e0ff9048f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6b9c69409aeb7ad858e8ea895e2d03611d72ce052445e7d17eaf8225c42f55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ddfa3d04eb3666a6c53524f79ea86d5a61c4c419912056fa41c1867acaa4d82(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22a010dafcd7bafb86775b345c18f2817ddb19848d0d461ff0a6b1a0c3d0adf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e152971a8d1f3dd491b33ff798e6acbdb88faa47501385ef3b94ab291ba620b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141f874edec5ab23d7a834eaca1d32982ee8d603927851d245348b38ee7ba66d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ae2a3c6ead777a8aba4483f355539479ec5c94c5605e6b47e0fe056fecb319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a2b1df38c55f6afeb6f9ab99a44114f0d0c64166592fa3b331dc6898fec372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af6734a43a047cec2a2e53704dc52a591fe9c15af7a50e086e2395012ec0e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e7c1a33abe6e659f03eaf6d35a79c397672205416b303386cdc74231e121d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9d216b415d586c2e663e99d88418f7d288d8c9dfd34d6e24cf523dcf451511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8537e10218a15accbcadc68087baacd101e18c9c4edb80a315b0432c46f93b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15976aff11f463b7d0c4b039c8b2fa7d987938beae4a128f6d98c233f2d6ccf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8830f53bf1282600c7e3482bdcde788e4185516241222f90fac2e7b259255e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026762356511f2dc4860de6910b090a93beaedd3e94dffa861c7ea2b5a321817(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057453f77c92cdee15e460aaa06872fadf16f9c7db481bc2b985f7286b9e06dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf0dee5c14b2599d52723d1b5c15f61479153a3ecbd279a0bf3ffba1970a666(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c9189c4e1984a393e94a5727827d93c251cdad0c1ad9b8f4ecfd57d8fd69b1(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5b27e4b220bc27a206d0b769dc4cf4a9fe64a11c12a10b5ee910f1f5b90d6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af70a3843c269f0d76b6b1b6e34c34c9ba5e667117dece52f5ef147caf710def(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e30298c211660d46cba385984329b2c170dc2f3c9cb28885ca17ec3871085ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4579519c352bce3bdb0e61beed9ef7b642b9788cc63b3509867670a83349f67c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2302ae25ba87b04dd51904dfdd9d0bf2f70f5f377b49466f61013f408eb6d2f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4349b793489615c4b4b9caf1beb651986ed99d6d216dc122ce5bd6d0af27b01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e4444eb6751676f5621e88efe299fc5506d57ae3713d98f80aeddad5040e51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b0dfe31c81680e659f6ec082c0e6464cbe4d0e3732494052dc57cb710c02bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d40885d5484e74299e697045a3c2ab39cfd045cd29d86e2ce83dc86e1084d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1099db70971231ed722b02e6024df603a5142fd961b60dcf2d86fa942f9a315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16108b3a989739f206f2a5b330872fb18c715625e7cf8b85351afd7a71d0637e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48510de7dcd30a3f179de99e12d26cb76f9677c71b557c55896c11861cf379e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d792af03792e92457e2478b020d2f7ed5f10ffb9f0f4ca3d30ae5454c4ba1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873d6493004f4968a13f5e490345660b0cfe1a569791db544a9dfec2dcc9c0ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67dbc8464c1264d8d919995110290fecd3328cb69ac0d142914e7c37680d9db1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f98f4c389d1b8a5da8ee448e0505644e2d9a559f2fa551e9adbda3a7673a2d73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd1513d6f1d3be56aa32fc94bc5c55d55838c308cbdbf2edf96260049dbe571e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891d4dd9b76f7f7e4125d326639bdab55dfe9823e0e92189dcc7c8f842fc860c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf27d01ce307466689007cb5bc1d8439020565284ae8bbd8a495c16a46c63389(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1014296bb6cdd86659d60dcb2e0df712713800c850e8b83b0b43f5e7db3c6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180a098f53258e5f81b7d4029a089fbe27e14ac4dd3bfeea93421b0af72cec83(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866c55a341cc3f7507f932561fd05a08efa88f38ee3e2e9253b459bb4b79110f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e9e7d68e05263a7355eb4bbdc91a9f967e5b78e118d0e3878464ca585e9c7a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d965afcb018cb76b98a2898c6312c54cf99839442ea6ff21a4b16cc861f583(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663ed7fb899dcf6d527af20a8e6ab3530c8b9280eef814b6f9d70800196024f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e0efd04f6606d4dc7952f7cbc94262a3c7505b6a3e150025aea7a201157498b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79ec0e0a72e60f4852d3ec00ee53b7cc4f720240e9b1b62f0d0eb10bd4047ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8cd783b0e5d1807eab2c314d3ecc6b6956e793505ccb934fa534aa8b8c6bb43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f6e8cc307f5dde989e047570d2f00379bc67df0249f2d85ac948d58052c8e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9b1619e8bf6c2417b7629de1a3fdbb86a32ea1cef4cb502a4a4486aac37a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2702bb63b00252aebf4837e4399a98e695b5b36189cce968d3fbdaa557fded(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70dd73d548a15eb467837c09ed240c868e647d53198ebee6e0caa5c214dd2854(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55295017dddfa8c6965b1f61f844e5e110914071e3b4b055beb0fe72b9929a51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed14dbaa271e2afb3e9a6f97dd2f8c67e67a5c94653df4f13128c04fa7f9889(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8638d5ead0fb9c2c5102a6d25fed40022c13585139d47770f8b190492d195f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9230871bbb6b96577e49616945989b99628f1f432c2ac30e394d68c523caf84(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca3b117e76ba2c69646b975b0f07f91f1e54ef19886046094c2d2c639de6ae8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48113c3aed3b96868e96869f6640d42487f3d6ab4aa16f530de7c76a26a6ed35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1c5aafc474fdd6180d72cdfceb98dd32b1cdc4d027bcc31e757ea2a84737f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68677060d49ae5db3dd766e009469c620dd0d253d03edf562c4ba31833fd332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4846d920dd0647d4c34b80b62075a77cd446c83554de9b99e462e4d75c5b708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0a19dfac9ca1c2936be9133b7c9728f192b6c5f7b162406c316185447fa041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b50d5002c71586082e122bc5f995b638af2cfc880d6fe0e69f859eb9a4ef5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c2f692b207b217ffbeced3e4252feb5d32b226a77089cef43a0ab84c957075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecfba1bb227b1e09264c213eb58130ee6c779a279e5a436773dfd6605eb332b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a5f4fe5731e8989e0c12a32b38fb152cac1bc147c46e27a390054f5b6f30ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b22eec492c5e1a6c58f1d5d146d56bd48b95514fea57799482b64f30489a1c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__736ad9d399c876be01610b33bcdb569ac4df8da8df62cb3e80d0edacd800f958(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb05125df563dc399faa178d2aeee9a29c2b3ca6e5d17cd96561225dae72f57b(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca88ece34af24049585cabfa3bcf60b2e150f5d615ff008b8ac68e92eca486a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32dc65742d0cd3cd86ab3ea16e185c4545c529548b51d3561aa4b240930d9c80(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0102e628f8bf1e2be6012403f62502c92bf7e2d6d4434b4f4c59c7d31a1efb85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e85de53f0b1f9ea519b6bb8690606c0874bda956d96622ba431ab0c08ce2ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c596fd13c334ae2e8a0a0721c6ba12570b2f1933a52f07755e05013f56181be4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a510b96c851f293b42e1eab8363f0e7eac3c7901a74789da4b18c4f0dc5ebe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ad24ed7172e074bf0b3fa8d8a408f52e9f20250981220e3df29366fb2ab5db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0e5fb87483967c6c3bed551ca1c5cf8d3b39d7c8c73f969489737b2828a5d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc3dd958cc660c58e9fd5d8f15bbd2f6417c2f82055bd0f74fafe241f4b8b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4468dbfa8e2e2121812656e540daffca80453f224eafb988e6e6956057f19a0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3592b809f908994ffb9699d23ab5f06b12267293b5ff7f5c2baf7078459419cb(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2e65cd772a956f10d15975d589f66f92c4dfe0b03738d0c2020f550ed104ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90e5f9f5875aa03115c25dfdc891f1add3aeb2880c957e79414db765f4f3803(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f650dc8198793d6ab557c1b3711d7c8327b08717646566bc8c938ff368e5fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57072537f8acf8b73946188bb2708fdc0102c2948f23f2f02395ddb24b1591e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c612f932d4df5eacdd380e1f41453bfbeab27c233a66204a743859ce10d1e55f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1a88117e5d511aa40077d2913265875221bd9334074a4a82f5f7569e1de333(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16e5b7e622cb5cb02e546ef48a7b31a897d5bae05b7c6a4f823cf0bf54b74b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bedb3c3330b003544febd62c398d9046792fbe0e5b5a08512eb680d7af0303f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58880fc7c52f55d8ddce931aaebbebe06c296a339a24cc5cb9266323670b5234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be2bc65516966f5b4ed8ebdc7e34ae14f46b761671f594adeb7b2630b9264c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__543b391b6ecfc5ffd275f298f38b8e429378de0207e0b19ac675d0aff7d01d06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ac79bc22a174e0141c6fd9cdda0f5c302818ff4a6a7c418bf6600300e9fcca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efcfcfe0c775c6aaa2b323541bff4439a5117ba0302925bebb07052081d1ca4c(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b13283fc7304895b8179a17e357b03f5958b63118352696c955ee23c08b920(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c6a14b9d34c8d4ae49bc85d224ef5b1944cf78fef0ab8ebf75cd2d3790925a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123fa93977395072c010bdda8a802a7f8d354dde00b4da808bf10c86837de742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677d016f1826800bc6a036842ef94f68e8781345d1bd327d6445c040eaa14d91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5581515e14d7a9ef691f644e4bc0a90a3631b294c367ad8fd20edb63c4f80ad9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2f8a16bd051e17b227d6c561ad473301c5019788a4a165c2b51a39140cce9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42158b99b9fd7d8b4926cbcea9ca80f9d30bd537fa69e1b1a8be2a2165938e99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa15cd2d7a6ad7e59e76eb2900079c499fe0b0d4feede57debc97240d035a553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e45cc51ef30c0f91e6ed9e9373f513e2b0d573a688220cfd053db83d834bfee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a4ab69fc7b0f0422faa1e118c299f5f379d3e8294370af8070ceb1746124d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577790ec9561c51225b093fd75d5cffde41ff4c4191422e5466ecb20ac5d85c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b649330c5599821ad1ff8998f2eac5d432ef1c2934c630848e6e0cdbedfaf3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410c5353b8ad26bbdad27efbc30c18a79ba1fd42baa6717f0f47145cb0a4e178(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95f4b117717e25452ac5e8c57363656a27a268f9be9164ae58b980d3ff3a5f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff734d68c2e7e51df1d57f79f0aa134ec2b493005ede64642fd20371224ba315(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1124131e415ee83f00ac4c8433cd8d454bb1d19f253c00c37b6a71d6ec384f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11974f0b08057b6527d2be3ae1d29759d0bb96cd847703a6cd2038ff50b9f7f3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ada467c256021b33d49cd5a2d917153424c57bf5f19de0d3dc411ca7bcc5144(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5d0b2cd46ab40cfa10bbc43f52645276a0c7db21605bec9d42d991fca281cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12284ec0564722419541edacee81a3f1a7ba4e16dc2ab83550d1de6c3eb8c60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99008527c25171534713759f57087717a25255f4ee06dfa42e97847c7fe1611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ebd9b6ebf3adc85af0a05c82e58b9549e700f504b10c563d85cf4da4c6d6d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58d3412a246ceb6517d99b22bcc95c8f34e8aa2a8fd0e72f0ef4c7bbcfdef1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c598869bca2f96fead2ae120bb6b8940fbf6ac423c81f5169711397c7036c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0667d3bb4257034eb3c9cd439d2860813aa9763b25d0df0ffebf2216634dafc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837c92ab2ff8327d33f3d5faf644b6f1743dbf3923fc253234b874e5f57dbed5(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36562ffba2cf8d1ed218c214bef840bd11087d6a49d35d6f376c9f5af26019dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c594615d6eecf23dfa34d946e3c43d683e9e620e20899b8e7554381c308641(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145d0be0ecd87b1f1186daba57925585286f62e3c56684f5155cb71bb8833006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894f536d649ec0f787af89bf35446b8a2434374e4c35bbd9be8822b24e90ac79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2690211bdc94bfe7621387fe70222f243f58f994c0040b9062fe384241bee4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596e51152ae87b857f2a45a9b51b1755939ab9af6b9db73a843a48c469c126c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d740f9f7784cc1d6dddcce80af33e1714c896668efd5c0fb4fbf9c0a54622b4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261d96b4f776f2a511069b292cf2e9c52bb361e0c1ff32b14d4479e80732009b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e0f0f692d5fdaa69687f9c435f305d1a1143b6c3054be76ef442144177da76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__187bcc225961cee27d0ca500c708922c73fde3091fb5217eb4b3bf9d2327dd34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b854958c47819da705c3ae35f3a1223edaf46eec6a192ed057c743ff09d832be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeaf17901374b116bda4e629c9075a3f739cf4ebd28c847880e5d89a75a5cc4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef93fb0ce15619a03b62e6124a6577c19084328c50d58616af3e29d3eef9111(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ed4cee714898bd77adec06e8c31297b78d46df910e3d72dbdd279484113a82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8942f1399b09eb0659cfd5628f707eaec5398ff2c6d81db0bc3f8e227f43ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a544b1d9ac7faeb24fed5ded39048695094c7b292a7d0df8d8a4b12346d49b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37578b3d0d06489c78bc52b3561ca3fc53e9cb92acafc6d36a1e9dc9abae3d1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7a604990865c81b6086699118b588b04be63f6153a4cc6da59234562b4bf1a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3164405fb9bdcf5eae48d04f58bdace8fe9d4008265576b39e67d901a40f58b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef302a8c33eb5d99db7b1408332568eeaf9b03ffb786785147cb798b3744f9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67edf9f0f90f8cd2009ac9aa75271bc54032f808bf5f7ad661987bc733037fe0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a8383ae430df98c7b90b3079d55f99a4448b16e01639c6aa2fae656b0dbb4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ffd28930bc926eddb86d0c462841232740d5db723eb836825ec9464a25f079a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0308da92be26ae82495f6b0e70d952f59cd714cc34f3d3059143db31cc14e31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741cbf32bed3acdff9228a4b2c4fd2c3484a673005ce103c89fa73143622fea9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d90a298c249c3e4294b9f582ef4801ec92d98b5b529c543d557d29eec687a666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba550b818b2bb516fa0e1ae96e56fc48e7c732033cfd2398f75d572dab30487(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da89058d2b9d0e5b3b4d6c16c1689bf07d4027925870bc4bd8f3fb5a49dc638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f27550ed4c44a6ff474b590b979883b80eec92c3bf94e7f378017bb1fd0505be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6a8cc60d17c759f93e412a556fa15b237e0fa794ee3ac8cad011cc293cf6d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c63eba139ad34f900c5425a5fe59198060eca01287314ade3fa13f318b4213(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0d02cb6b904c1c78c99948fcfe675b841b721d223f71189f47c57da5ab8ede(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12824e2085dc12deff30d78e24249f8c443fb238e6b2269050deb6518143b946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8ef2e98de1c17da4565402995086ebb1ffc9702cdd7bde9cfe220ee6fde2ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a658c3d581b4d91bd987a3792eb64150735dd08a172144a8c7600497bb3fab7(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afb19b2b8c458e69ad2a8e9174cfd09d1d7cb33975390340279ab971600ac52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95e0d186e6f0d139d880d7c934ea904cd6f18fec693fb8c8beb1cb1540dda94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7013debfc49db9a411deb0da79e74d8c7744ce4290a67f625e5e4ab68097b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc4c40529db985e09bae2a82252d0948bdee652fdf76bd6597471ec9b42bbe1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0307bde751d2bae18997f3f9f115933802f71b21405cd0af104cc24012b09f48(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df56fb56d89fd36e1c61cc777ed97227970cbdeea5793703795d2e8d122a991(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2b59b056fdf47cc9495a84680590057cba3cb9466f44ae4415ef2b194b218d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7d6ee1d6ea6165f168b9e504cc4aa08828cad4cfeddab6a9d15a46382b2d18(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a823803f80c70a189d996b37e556f085650236ea51c4a79aa89f7849653649e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dcfbf0281f7330266316f01450c53fffca6309deae8c2bfe3cd2bc172f735a6(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1fa718109d8350c9c050c59d43effe0e8e742d5c58ed23715daaaad53e6b5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f635202644926b2f562316230df48efa367720547a20cb7da036d62bf0cb4552(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1f03b8e09f5028ef1099fb8347de994fdbef64afef4756070310ec7621596d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ddc223f77ac1d8a2c0d2f5aa57622ff60299a1fc0fc43d44b9cb80d170ed30(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7d201a0ac4b02481746541b2012136e2a50144e630edbe38894141fce89b5b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6a0b49361d5ef66af5cfe647bd55bedcc6943920eeff8704f5e455357f6a7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6389be90a7b5533ab8b5cc9ba5595ba783b4f0e6e208cb88194ce7b5e86430(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9587b805b3864e70934bf637c5f9b42441604d0f3b6f797a084b7769460c4151(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3125cedb984150108f3da4c97fcbfd03eacea1f464bd75d919c5009fbbd301d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aeb50d2ddd0683d19f589cd2a3f240b425e5685a525537f66c9661980951be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2d3de6ee898fa300ecea3301456d1af8c24fa4408b2c5ac4d6c42152a31c57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb5e3b91cbb981244beae94c676b78bfc953de258e6f8ccbefe74c929024f4ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df5b93bd868f5987f9c9a981a3b98be4f3097248ee9a688f3fcf1a0e4ce6714(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430e50070eba73461a69d0824f398c921169e420540ffc7524893b357147f022(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1bc11bdfd48aebdfd5e1b0eb2ffd4c750751cf68508c8eda5949c44e02f06d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e959b55e8dbfb8bba1ea586a7513883e99574bda11448b477ed06a7a7b6cbaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4ad3cb64638465c445039180ab88255d60d477314dafc07ca194be6bdf045c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebe4630da07588b361254c4a0a3d92d4641668db4e889222c5a5ca17f2e4e51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f02ff1df01b0f31853c43e507d62bc9d1bcfe0a9f86a86f6bb21966c867b04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97354fe0d3e7afcf85c618fb27912d81bd369fe3de81603b372f5eb14886c5ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873d0c2ecc4108b71c521806c54bdd5fcef63482ec903fb4be62a31600da23c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c12e99b6bc71a9d6a2d66102ad18e957ffd58adfdfb024e12402c43f03874b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4a883a1a2824940d29f19e22afd6232111a3378ed176cde3ca4b9d75e42ce6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3b15621e023cc61454311582965d42ab7b57140956e3d9a4328c8e074b20df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8768a6fac0f14af5b95d50ee290dd609a6413c76a998468855980b8f1e2795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45957c28fa4c5eb7860eea435dc4134bb29755de88ba50f0fac27d89dd891aac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f42c8755adfcc3c528a2b4e1157e70d4b710f1ce5cb0cdfc38fedc61beceda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf442704399bbb1f392d37ef6c80abfd00b7b076429e2cf3a62a0d36841d3871(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ee3264ce4110bc569eb415c7faaa7922d32c23c5d4ebaabef149fed72848d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fba4b263b26f66ee7a6c170664754b078ca5fe7c85bc1eb76dbe3a5bc1b8e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__645dec92b47ec356d59f57e732f140733db62dffb9b014c5a69273794d637497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80791e39521264f4a69274b1e84fa20a291d63744ccd5fe7a30a96a014cc849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afefb025401b1efb735543ee06725d3be68e9d5660fe1ea84e8c17c6586dc90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92b5394eadc23785c752d03917a7692741386d3f20e82442e7d25df17c6928a(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7642e1f3e591b024d9199b1a8bb8d308f73b503f0fc28d02f0cb9ed8dcba869f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf9e46ee20a6651cff599efacb80031b7ad169a233aacf1aa68a092341f3548(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab1d373d2db24d4e454cbd1e3134efd3b7a35a1c738747b61a37ccd67c82f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757c9af8b53bdda3c08f063f2e99688a2cf7542fceab9c666de721f59e426c7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5efd2b9524d7a636d6baabdbd5a32b427d1f66d85ff1bb52d63864fced65294(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe37f1c463e451eda292a07534b70b4e384ed6b58108aa0d6f575dd6bde87b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f12f3c307f2159dbd5c7d175f3c102e4f56d4118bd5050a7b685830451f91e73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ee2251714d1f0fe14f6f938462fd8e64f8a7b266458a043b9d6d2d654af743(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a5126ac6578e7eb8abb37c2e5fa110b3fd6b674056ec661b4faaa6997857cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e5a487090f58673c259e8d15cb8ef5fbabc1f6781f28090c678dd2c2e96a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c186b8be73b66aaf5a5c0a7cb6900fc64ab62534c98b15d5624c4c8237c210a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc7356c2e11cbade8a3f453a2a5d20afd867d42f9318ed9936c9e97ea432ff89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f7e343c84d2d1327aa7106d81ea1692caca6304f3f10e9d72d2503a0b041f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45312c588d736a332bd3a4d53d0cdc97a1c1fabc98f270d1d56f4b059068936d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d2d8c6d42ea847c5507e1baaa6020fa8a2dad070246dbc18919ee43b0f1cee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad07b97b6e0863bd07ae7e05d4fe990b7bcdc88bc761d2b1eb2850ebdf1a4c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba3f87bd4e34a284e1eb0f67b5e0cf82300ba454e43bd96fb557df60b70f3de2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afaf305a1843274c356632fd5c6d8c680359cf86ca29867454e6858c18592b9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00fde12997a5eaea7da5ac44eeddeff73882d9bfed316fe896b1322086208a60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc823a2f2f7ad465fd49507db9b91a920b6757bbf4bc3b9fc1b458b6daba4708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650eb71d1fcd3a7a10f6c2082cd0d76265b1545f18b2b56a69399a164bae896d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb4cf0dd76a78b467efc1cebbed28ac8ddb735b75166d754013201a84942e8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6360f030d3646cc7abed1f2dc68be6f5fed8d1d97332b8406f0c206a7313358e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e583207ce97bab4c4f1b0f2b5ab8e1584c179f03029c4bc60670dc162f821d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ec19bc869f34433079538739a69dd9abf9abbd07468a7f6760701b05d95e53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed67b7f70375181530c6e0fb706d8096ad05a5a2936d3420125fe069825e009(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0bf2e8e633c851d9164c9732fe6c20bc2ca0fb8082457954235dcc39adaf2f(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4e1202b1d4f3f3b1db89026c7ae31c35df905cb753e965fb18a229aabec192(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e058d8edd948da586335e98044542c30cf4dc7e83e82a057ad6283c87a08f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc6a2558e26cce3e4378b299b238fd9d5f08556e8c46fdf1e2051c12eb3a55d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc7aed56f600bedfab0395923391161b6d00f46036b8a6ecc7f40894eb6b1ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd92d7b4f050c8f6541c63be59a268a5effadf163a2545529d1158b13eba123d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9d4ae010ca3e0a904fff0baa028940b4af80a96932d7b7f56806fdf3e2a87d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b9bb9f6f30e0afd5ec94d4498397a337df956250708fb26563b64986ff9e1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4272e0b97db451453e64ac79a094fbf84a394443cb5feb28fadfbea29d405ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa161aaf5cfa85fb7f67486770630b1afed3d63c1590e9bf1013e0ce066f7b4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4182a313cc045a67852c9d9a2ffbb2d703ed8d6381356b3a34fc65bb2da82287(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a9e883fb06b59379448feda70f9cd80e347e7b0671ced18993dab9e619b1a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f856b538bf8a5ad4302017b8b99d6779bfc2a95187c226e43d928c2449bea732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1b0fe5897d42fe8cbe2cefb88392d2588c9e715db896987979fa6ee54c1755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7f13873720e410c81ad76773c56239fb6c8e078805deea40e48281497959a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59f9315b60f78779ccded783b11c7bac9f798dcb4df41b2c4ffe55278db9a18d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ccf88ee5152cb8399154aa6eb97ddec416f1fbcf81bdc7f9c3ee3a577af0a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819beced5213330990f554468d30140129d09327a3afbc914ab29ce2f7922243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630a4846df5702be5f3ef27c72ba0e4493062f0bfcdc055899bbd07e6a977db2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e75ec98391a7c6157a889d3413557919914db3b4741fff2491921396678f4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a60110d2a4b86e6910fda00a5aaf1894f18521755288e9d307ca1b51187426d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d326d55c70064362af5dc243dcba6618d8ff0e396811e50f138164713997288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8ebd4732fb4d3a79ca402be921bb46e095b5904e074ff2e137d9dddb28e68ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5cf6cab2fa24e245015b58e7f60f62193b9e21e6081ca5c07ef2d16d30aaf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0ea01b6b268202b8b43875c7a9dc808546fa826fccaad5d723590525ae8272(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fbee5c4767a7aba042cfe1715e4980632de0ed73cc5d544119dfcc78477274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed53fefc04f067c44ad6e6e2d120db812485c5f91b627ff9d48d030cfb0d879(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd4698f17e3f81b44837da91d32e1f75e7c902968ad70241a2ff0cf1fe760342(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e155b4e2b7fc19c8cb8a2e94521eed20bebbbbb875a526bb3dd25414079051a4(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea1eab7ac35118412e0eac9c37ad336c2c62029acdae7d53da681929a60f4b7(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__586482363e60910c4bc5865f96b2cb5d260b2fd3e2f9f0a17c582a60ab9b1201(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fff82295bc1f8df4de60606c2d9ec832875f9ab2ce81b81d3369bb1c5d38a0d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c2085d30c55f450eccf47e4b3d8ea5092081ae6558c4d60df94dcfb055977e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16caa5f164be2cf9677ba0b346f6905e4ac9b6b380662ac490eb478aec5403c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5ecf4416c1f3865bb34a89d82fedb93eefefa9047023b52f225eda26e38cf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51849c5a886c4afe002f9fcbab0e81f16f19220cc96a6f1d1ddba21b5dd85949(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfe9c125f84a71cda998c91aa1262f9dd21d659224d5106e21e754b30ac1471(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94135298ec406edd35d1fc1c5664040de25afb5e38f1bb8859de5e054bf85b98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb5f9a0a590d28998fe89c77dccb134f69b7b62bdccbec6ebc3a59d8d6183c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc6b9d4b1c98dcd07d2f8c3aa6fee9a09e0c941ee67b7bafca943b0736698d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a7eb7b0f546dd02644d303fa899f1f3e081b2d9f97ed9f0e88a5b390ab35cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c80468ab86f151e0c85836410a6a2887526f1f1338ccce81f0e56d61691ea5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86577cc40adb76312a09df1f3d8278c22e0c268a804e4e48e8e3a86daafb186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee0c72a8c64b36c2f6b68bbf26ccdb32cee961a04e5a387877a35df90c63f54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63905a0d54f422381467546398c55efee7f4cf75c8af351969bf459afd965da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064745402b525f5ebfe6d007f64dc70f3a13513bab3e822232b5145383601b40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee4642369329b5aaf1215a544940a155dab267cb3a1fe96728cdf66ac0ee30c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558d81d447ce22cb9fcb3488a6bb4dbfa5ce23641d2a6fcca83ef64002de4d64(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3873c7fc6da5e138d6ebffffd01df50570505463fc26274ab597b5403b3759(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f03704576d781550cfb9cdb891af7654f0eba27639a2c992f9073549eda1dd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7587a55b64233bba8ec0e2015d093e82c35321d48fa57a588cdd2965f4235969(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daaed866507e7d45264253a4a7ccb72f59b8cfc9dcb0aac1fc49e9366dfbecf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72940616f09c4df44ffdde11a07b603b681e4f7bdf20b917291774e5c1665ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0f2bb3fe3a9392462f7d68f55555956c46d63a15462c3ef9641ed45a82fa51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0ce09a591f701793ba85f6ee21e1c83f22aeed2628058b92b01d8f05d624e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd69fe4dad3b4cc80cec4ccb464f705296d21b3af1ebf352a24ca6503705da0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29a266dd929393abbde1a01177006632683bd3141e0121da6b7a3e21d6c1d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd957f503bcbef36228c664c0c055480e8df4b50fcd78b42af54b8bbe88e8a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a70fc7f35803d143a99d89a46b3ca5a8125cfba744ffa4774e11e742bfc0843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a4a53be109663291911bd8216975727f26018b668d7005a24f0349cd0689b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80bdc5c4023c8bf624894c7d9cab62f0274b9fefc78eec52cd0eda7e98ad1944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8fa1639d6dc919c3395a3b824b2ede9e5ff1b26823226107e3c95c7fb1bcd79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa24879acf62f961c83657fef8dca4d1b54fbac280b977e1deb8f04b06ca899(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6bc80395111f06523ca1f9d488dcdbcc161bea9de51cf37099371d96f77542(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85178196607c70ac9c149cbb4ed623f766dc722e78dc55c60e04260b3bb23a10(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d7f654f045917979436fb04d519859d582320cf45ca1b88ddfe46a15928fdb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c8b66d4d34d7ae1255ed09387bb959c304114155feb5f88be71f4f956764b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6790db96385ad3ec294c38f68518b56fac3b9735a93fd9b040aa9899fe1bfa5f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e65b33ab6765ccde33890bae95421ae5add882a447a49501292be4ae9968656(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3e6f26f8378b79f087e5b3451beb09f9cae6900c89116fec395d8e194dcd94(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dbdb10fe394b69e90b54cd56c456c158f6d891098d357aa0a1a1a387b8c2768(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edec3eea4d77442351be079403e98557df9a5e73a8707b5541604cea1e729cac(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576e57f57df7b72fab87bfc41f1f031a669a1d477e7db7c944b93e59c1f91367(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587c6e33ddf16859570ddf32065073d5980f3af8b00840c393b4f557967bb0b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c720e0a73395c459b7d7040d80ddf6c7963f30c49eba5f5c415fa2e9c0e79b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094f7cd5de50b554bf19965eff33bb5398bd92d2201217aa5e5d6f7e847d03e5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c8519d321fb9f10198312b02db80407797ffc63a4aba828c88c68767c222ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8009e3479839cdc967cc1a2400269d414d04674f9650a6117685e79ba718bad9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b93315c81e79cb7b65d840efbc70c041288fc44f2cbfb9090dc08fb34b7fa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a566ff84fdf3c6aa1d4686b6e64d50956a6da26dab39a19fff3bd53b736df2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2c76937845163c2341b5a6d1c39dd29b71eed29faf61fd7f0b458642d1f234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4da13988451fc478bb573749a75bc1f1685741777d5cf8ff7f68c265b975fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de67995e3812bf53211c75d90b02099292efd50dc6fec4632806f2a789aa9922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b6249884f6caed65280a9697ec899c20569b075b1c859f4210057f27bd485f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57b20b69076b86e5431499534c79392d6c50ee1219846dcc086ce0396e2ed1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061208d73ab2a286bbb75f03dc24e69bdbf355fb925eb949fd53a5a5c67c5481(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0da3d8d3759abcbe9387ba07e85c539443190a1b2e707c2a3830ad9e95955da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b73f53b0e4b41f0d1bd39a601ad2647e1e7d0fa14e5b85ef50c6a1e8677e597(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6eb29b666670e3ff5d0b1ad50e197571f025a90fd835b9d8415cf5f8850c091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597f25f79d216cbf707779e46211dd1a1f68493890edccb331f90c75536106dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6896b1af63a405d6be85b592f13b51173255a986769f77ff1ac19ed82962ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9acb7c2c0e524c763e857250274763b4e0989e686ae9aaa03fe8f74df5eb64fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6210ec8067b9b797e1f60e6eb0ae4b1871b276fb2b55969f2caa6ccd407a3f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819f6665aaeac9005e76979b9bda8d0f35dc8125ff9fbf8fd439325d46c55d25(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49eadab4f1b8a8a5b40ffe0dd08cefc95380ebbd3498ab033d8fc83e8592182(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f523d3ef61182eaaa52de2bccdbcf74a01e45f680c57d0f39015c4b1dee49ce9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad84da71ddf9b446317ee1a34f7714582443e3164f1191a6c7cd0c11ce14a9fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e27cf29fffedcd1110f9804b2a5954f55c1f65fdcc719adc65dfd4d2bd5bc92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094c7ef6ab2241afff8e9f3a0b6b9ef5d5d1d5a272281719c275ba57fe4bbaa9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b86e6930dc02d04f5fa57c368bbc74eba4781f29ca3479c32a9f333238af20c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd2d4b8fc0de168495b9a0969c3a9b6bec71a2abe1d5482307f835e9baafaf2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9712a4554c84a12f4c736926717c830fa5eb01fe1e286120a624ea4f67817a30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255c06a45f61b663ff500a50b1cbbc1d8d961d6ae280ac5c4e129a94cb5f7acc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c3451bb332025a36d0ba5913ed3991f0e68ce45fd4604111153d259bf1b3e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe4a92057d43fc5b0c419f1ef58f0d507981da3f1d8336912071015b53134c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe8186ff453c4edd4d238d0afa8332b358a64ad3f7cc40fcb6993ef251e3931(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0aeed75a42c0612f9d2fb1ac3bf3f076ead3421ccaaf34d1b5048b868c1b658(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323fc62d67846ac7e40e29513ff3d0760a1cf51a724009e92aa6b8bda642c350(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e12a638d037658fccacb91b38961c10b58ac6bc0e695d0e2255dd1bc48de44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d01537d570572faaec089dae5ce92c81a771372b9acc77b577726d9d998ea4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d658028d31c25a335176b7e6e5f22771f824c13c52163f9b616ee38778e56395(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0258863f2972acd58ca4e9df1deb05c88280d10104894e84e302fd54567c3733(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__851f4a04769517247c27fd8d43b2a8b533c17ea723a455192d84019c69b6d9cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6deb34f4de4d2b002c5644fabd47618c4c7b0bfbe1cd0c218d9bbbb5a67755bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d5093095baef6192370aae339298b324059410dd4ce25c469076aa06bd60c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5731d4592229722fef5441084826b7a72bc7aea8c7147cef883016098d6a5bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8cb062b91ac84a531db0070b400d28e5b25284de9647a49aa3794e9aab50b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d9bf9a086f7995ba7afdc4b8820a1ba4f3d70e4b909c0afb1accf797884a179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ffdda05810909b557725eb3ad96eed01dcb55af7b751553c43b35353c47e56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d644586eba9932d9369196c6013e3d60e00fc93238f878f29b0da4942de046d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6a20a94e4818cd09247c29606da133d2eea5c0b13ea4847179dec13e179fc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ab40c1edad3448d56ae79c2d90855460c5ce9fa0cec4c6e771d5f50a01208f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a454ce1e89c02bbd28840f630ebeed4313d13c5f22437b529666f25dcc953440(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6630a68574aaa8608528100946fd61e9291eb462246deadb5a0ef199f6bc8e9f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fa6e4366570b9d82b6a8fc56260b955031fa522925b25778901e1b46afe27e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6d01f9fe4dd20ffa7ee2351748a20acbeb37c7485f2c479703022a0885e6a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97458053e9ea5a35c48d3eaa36dd6c2c2ac0ae82eadf9196bd7cf4f2e5d647c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90802fc5f573cb597d249519ad7da37bb6977d1b12f71ceb804cf4d1936054f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f5b68bfd37cdf920213d488f42282e4615cf27cc370fd037ae5c6c4b4dc4df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90301a36b8cffc19cb6b3b2024a283e123a8886804912b3af29bfa2f44c7b4e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c965952cddb02afb4a1059842660a6eeeceb3a0e3e8960e085716c8088d37234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d39483ea24d247e28e0cf1d893e9683112dff1bfee60b69ac2858c147dd1c6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72d60bb01879e5a7e10424c9f6fee3993c1ec7d52aa4950d7b38c969b953c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c937291a21dd0d3edf2cc1cfa146c16ca9f1c228fc0eedac114c5989ef9abda9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66414fa8f4afdc541f52556545046f42bedad057aaed7ebcb952282f84c0162(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b835cd2e9759c5a6008a171cb5c511efbb6ad5c2d70c9ddeab417cc6ceb86e6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489a4646c7d47a247f0f3b1b058b337deb1944b40fbb0707243a6d010364f44e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ef43b0ce54f1082194ffa65a7f5c03ad25f693fc7087f55284a5d147bc6418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77277ea9989c76295dc22c45cea2ca2344025fd6ba0491c6473cfeeeb00da653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c87963e9d4582a8378eca68783ec7eedde363b378a444c3ee685bba799c98e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4fae8f0b720a4848c4d8cbe7c7ce7d26bed95d24d8927a25b9664d0a2c0e5a5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e47c7e47983448263f9264af063830517d025ae5f8c6e5b36b701064db03505(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edff08b1014d30719f9f91a27e3721d3c4d48fb56b3a3e4ab310e7b793646e9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9418f63f4a4132b1e0c44cb84955c35b5a54b93eaf87e550ac6519071d5fb137(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c32c709216a145dec05657153d5105ced57d43ada17e31d6f0009c2548d2920c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a24ac1813d5ec08961a55041855f5afb883a1d97ec177efc399d8e62ea4a441(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8984fe404f562802a89efa3b7cb4d36e13a5bab463aeea6a1d6271a49f0cf55f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7c976e916d080fe2b19ed4a2845397bfcc08e9fb6aa2560fc9ffd039185b60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e37e8a01a819d778d1b82023dac5878e2759c80a3db944d590978ee59fd9c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25833b6033419d0400bab1ddd21a627e2cdc973a823d3614007fc7df17421af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c3ede8dc0c91754b14a424e471e39b2687adbc8b5becd26ee2638bad872595(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f2f823365e9ce9bfe16d2c264ea1da859f6cb2900962682f7f17b74ac5641fa(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e80bb347ac1c59e2cb92679e155a16f0915fc7c634366f638e832f6bd19057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460cd2b269c429d38af12f181a2476ac722416ff3611de3a166b424f9941e191(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf07657ef4611b6372885a3ff40ce4d74e5cf6f149ca5b2afbf390b0a6b6d9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00aa8e820db5fe5ef5e39baefdca7cbc2817308f2867f060ded6fca5ac2c557b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0f8aae1bf84ca0c129b3466296f2275e8065d25290dba063365427d2de1021(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c269ee39d7833257ab9225d6ebb11f6b4551e8493ce50b6b1771cbdf974c447(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5ca87672661a8a060e94c5f10a887d270c30d97c8a8073e2d06de4b21a4191(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739eff69a138233bb889c46da3b837880c7ca30298bce41d42ec8867eccb7915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade50ad166c45a4c67e1e95f6b0c97d0ca6cb97b0c932c85e44c05a33a1d153c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3188c2ba4fba06f7c5d5a5513e7c31b4b207b123feba19f4ece2a177acb9c0ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4590b6569542b611977d0ab607d8e1f05c8801fd12f951f226bdb783936688c8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1eefd946c8a5a3a430020d558047168e91b9c7b270e1c16fc1b9bf6cc1a933(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8bbb393f92da4f1a5ba2ecb534538521fbfdb43060d6a1862129cc6adc88a43(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3cd8623d87fae14dfdf1b164a6dee82c2c832d6ec683430a23c3d73dadb731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca46a65fd5d760fa9cf58bedbe79fec675b9e9d5a5f721960e3cfa288ebed178(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b101fd4c65d7855ce122cb43ef0d64d3dee40d7867b4b4ba2d4aec9f689d1d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d345e39f1fa6f84dbb1b34e0d5808a645802c179a38d72aad50c4db89bab0543(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676727814bda73d77f36a46593e6839f1ba30159b0d4bc5e7420fbb196a132ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e425992c6ff852b6fc76a623421fad6b22cbad7a2b2c8146aebc42207480b405(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161af6b084bc38159d1c016897271314c23e039581939718b0f13b2fc8fc3fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb84f8deac37f5419f3ce05f9d8faa1a0dff08d251d0d312c7169dd2553a76c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba5956463ef79974779b97458ba7050bca6bb6ee31926c825735fcb2da87612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ad93a24e8ccc20b7c3fc2e05c0c1588a4e2645a6026899453949d93eb5a758(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc61654f839e7173efc7fc07b7a86517a8c02c6b97bab359fc75f94a13e55b24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08cc06acf487ff76a0c5d9d830a123a34098002ef29edb7984f3c271adcf799(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0993af54adb43d3b2f814f46a675b7c67cd81441825ebfd6e1a6f11c9117a4a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc570648382287eb7a3560449420d687ffa82755433b0b16e89363682e4ec72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80a85ea369661a486fbf227c9eb970cfad82123ba40141341f8be04c2a1668a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce71598b83098d755acf62a3acb78e037066210b5a8cb9baf4df541af156142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895aa029c9a185e768b62f141457323631d7f90f110007fb92ab6be863b6ac93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e6e283417555356f0139527ea9eb174ade0436ed2a563be31e3512e0a13066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f222924d570fbbb0bcd675a792c4aa0e46157130d47b6d456fee2581efc400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecf9879fdf927a7efa7887e4b2b792274ae938baafc06e78a1426f0c06a62b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c770f49a4bcf181d01597f1fa036444569c9a8034c4e157311ad8ee43af3d57(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb5ce15b948dc9d0da1731e9e4c8436b8f5fa62c71da72f36a1eed522f18a51(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc770d95f1048f9e26b8f8d8f99e1c3141152ed017956a5dec4fb109394867e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149486a0b2e458ed5ef086458f87806c9392a9fe83ebec65e3e7f11b4e5df221(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f6a7c20c68419fae8de812078b2dee1d340d2a25629aa97231c097aece8aa4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54cbef9058b27e260d0630cabac82dd1ce352012c072c70fad41d7dfb8182ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5264d30de1dcf81e77225a37dac6db460d12162b6f3b38dec7dd7b5cf5a4ee6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4059b1a6ce8e3adc50a4805b20b87e3803306022fcf0de6eda4a4fb4187d8cc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81812cb274f14c9d033b4a37e58cb4f63e413c596d449f10e5d3685025e2d1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d1d4e005946a95cc5621c95e9767f63ee33a19ceed7fb2b5b7e868fb2f6ef8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1db566455f5239ca80b58ea1f2e375afe2154162850d3f408c289d97b9a920(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d94f3b424ca9c8437f75de9c220f07f30a0e605f2ff905fbebcba55d49aadec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1c1ea4ebf0a031f1252324ad15a6fd9ac6cfbd075d1efab52fb92cc8d50e0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a6c7c0dd768356a8003d60f90473ac2e77266dba15495bf473067ef1280c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7888c585013669f7a0578f8a4363ef48cceed4e95e75a47124f0546b2fbea48e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9859c21c4416e7420ad2639e3b9481d764b07d79fb2456d85637faac9be493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cabb7c0af3d508d6e5902daf2e4b0c0f7d0b70e3794daf574f499f555ff5a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eea0f3de75b2030038fda278bb7a5beb1145adfe9a6314f4f2575abe700deeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa3020d2652e7e47988523e78d8902a79999a17fb7efe06fa17256e5659d47a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d569a7bb7080a1e3d1f5f897a74b7b734fe2783e31711bbb2640233299ea6c6b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdfc4afb42b6896b10cdf045587188eda66f72750a5462d8e485f460d3e32e83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e6b17c202a52a5a3ffc03f08258f1d9a27e69731b47684e1178bc1860771e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66bd749e68c4164abe3a7c987a86cd0d8677964d81a6a8add95f0de454bb2a30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f96dadb69a7144480834fdabd685dbfe11e06136d7021d24fe7bd5eaa1416d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d34667a61000c9f3f03de142ecda0bb22bae3c0772f16b3925fc0529fc7a0736(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bdfd6033da07823a0d3ee1bf3cb9e065c76409d65558fb70a9eab1296d70648(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12a44cf0ed0441826e5789ff9657976004193fafa2f73164b890b939a878d036(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9edc615b7637cc0139d03d396500ea9728c4988a2b49cec43341e2cae6d3f4df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51636ffa8b84b0221732facb08984703cae87cf188955aa3f580a47ecea9fdcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee201b75e7d53d2a7fde518f1cad35d6a795f88b549ef8a3342c93056f4d7ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1200e701fc3796c1ae2a3b3bd7e0ba257a499f70a5f20ab10cfe656aa1e1ab7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b82699452fee535d6bbc74bf243b48cd1c269c7e58b8e46bf6c175172c7faae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1e4337979a2fe5b686e0d74f0eaacd296101e99fec4763fa63be76a4f8cb54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06aa358037036267f6cc6dbc165f17195d6af8e8771f1a7e748ca68508a6f800(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df3e9e2077e8074e17be64ee9c4db1c586a9faa03ff621f7c03573fa14b746a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404670fc423fb73c6d905f28feb3d792619044f791bab1f16b1e7d482fdeb6a4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8548df85ea1169b25708266cfa5b51952a7bd8846415e1609c26ad63f276bd17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51de2dbd121b11ba833c3a9890265e284ba605d0509e7e09d7d69cf075dd81b9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0331e723b8e2ad2b6697333f48e86b41d15c09dc8a1b5b563d6c2f342b45d28(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa7c21746de29470ad3060a720c957788a1755b5dcc8480b25f5cf6cfb69f862(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c0a3b5a07b1b7ee02facf69c456e8dfc28e02c1fd179c129361b8f89ce830d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12096ba461442fb0b8eaa18e4afd0ddc8d7c1f5317e70ffc3dc5c20bab0a1421(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5365bd04e8ba90fd525bd245720dad541b71758f2c01f10c1c173c4b88cda73d(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b7dbf4c65233c4cbe85e282bcbf172435594bd4911a977058e4f40c3dddad5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fb2596f899e8c69ca236db8fbdf5f8a333c10c072c9201d67fb076b563865d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b740c6fe7880fb0afa5a38aa85cd0e4b9a06b07d3c4ef3bba0f27d0642fd1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90aa40b72ed27cb53a8e1df4c48d8cf457b0c6363839c3a9af58edc66a1a159a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f03f7d36174aa0e718979915e999f20e41f5e05e6d26cf673ff5ee488ad64452(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3585b2e8ef8e2f28d75008ab4ae69492410f3754f5d87f55820cbece8a88e20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef6dc9eb9b9738c5dba59dbf69f2013904809d47f4d30c231e879173022fe20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e120601bc93253bf52cb8aeb712e3d780ca09368296281119af99da2dc1fbe1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ecc2b63c0693614a803c8c7f40d0af40888d6eed690532fc715a3a1909a138(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2615bcd39de43bb7baed07b44bf0cf7ac5d10a934789f8805409af0d20ded1b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3dd5fc266790c129c87e1598f784ffc0732475f2e767b59290dac24793b143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47efff32d55781ff7cf31263ab6fd2c3c8466486041b4e9e26b237ea801abe49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5451efa605edcb9c7d9701c8849c3e903ef2ab645b6be1bf39e92fb6a6530ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897ccc725ce7d03edefc43f649b280b7479f420e6dd623f8638186dd4cd430d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9734198a1b7b13812a5c4e4d1b5ab2f053d9828abc9a6a31fd1a10deb6c366(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3269872baa5d48a720a90ba985cd508aa2a8acd42fabb1f2803c02572d29db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd5d73c0f113ce18fb2def584a41177fd007ca2e6b7bae8fea5e4bc5dc2d316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d98ac559af6b9d8633fb952ba3f4d6d25b9e9a5592a57eb346327a8ef26f40a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95740f7507d49de7606d72cdca1b06eab5712f6f3901bfebfd12ef146a98f6b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e932a1e8e9cbdf60db2a9a102ff732d2f39e7f0d0ec7dd24bd6319899ed987cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded7a5331399393710c121a0c27195d05633c25000b73050c3f15822baf40ea1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ce960d173371a9c083c7f8c53b09a431e74cb6220008652728369abdbcd9f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51308d948083507ba3c1e036fa5ba81d56d2a70c7a56404b70571fab1d764566(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1553e5199e909a6172879d048e7f03dde01e14036527016ceab6925970d889(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4237985e1a612aa9c013a4fdf9a38366403ee9aa7161d62459ac2cfc120e87(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186d1ce57d342dd1895ee9c3b14cc8d0ca9879cd4e70893c67df654b6fda9a28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a74e21b2ad51c7957e37eae83a7526e12977b30f17483de880a24215df5350(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339099bfb1b8faad7e637c78d7a43c8419d5210fdfb13baeb9ed14508c327415(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec96e556a618ea00f1eda1ad6864ee9a0d7161a2078c51687e26cd85d530bd34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d485b6e7be31f2cb48e95df0908bf016cd819322e5639a021982a3d2109d0a18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48df8becd2e7da4fe0bda92ff92a4a2cb190754b979ba2bcd3eaafc2562b876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a0bac3e4ee1f893bda8bb0a89882e735400269ce13791f6cb890ece890708c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f0d2eceeda7189f8af8451d2fef3df9c0f6f13491564cda230d7d3ddd3da3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6ae89f874ada4a4dd354083a88db02285b11d783616ed496d8105e4e43edab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496b38376f57fe2c3a7d38b0a53f9696fb046bb2215949b0a5fb106542d08134(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e74e31c1fbe4eca14cbef6a0a2e61b9abeaf589e6cbe2a0ead71b7540f9a25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73585bf76f744e9345835b899faba62a1c104335066d29851c86d163bea085b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d790c1a9166fb617fe9c28db7d0ddef6fbf8c491ec6a79a0071e368cadcf7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069b8dd1160e3f5e3deae3b97c193e5748108edcb61b7573c81249fde908b0a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c7348f4c2d9995468857de8dfa99c2745c5cd713a237d6cdb597b2c338bea9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db0fcd08c31a3d59f7b332fcda7a69b907b26b7bc721974600310374bfdfb00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27416cce7ea30503b6aca795a2dbb03cf793d0bb277183f46fd7e797c5729f0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e783e517bb59d13249721044003f5f23222adf0ca0233959ccf58e9dc7dcbcbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4618ddfef15a87321d738c4c0e20819feff5339872137b91d9b4758cbf908f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d9cc2b4e3457abbf821b60db66e1b778dabefb58b084a30e75e7e8ca9bcfbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0312dd0c257a0f6e7f0fbebaac499cbcc1299eaee33ffef65ae5b789fd7b1701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ca8b4e0a6bd7442b1bda337ad6fa877e595f0e868225ac6e163b618ca4cbad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90bc98de90ba6fefcf7bc18140d94f26fb1aeefe986d51c1911402d91a391ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207a1fe4c2340a6c9d88e12d9de9dae3401a39a7a9812c63584224445e4b8d43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__848ee66c095152db5842e3cf97d6531cc54f7665a373a9c48c4c471f1f9416aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde8d807a864d144f84e16981b4ce7c82e84257ed489ca97b549d9ea0d4f6b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aeadee02e98e1b61cdbc203f295d5478e9296ef3abece6da4838ec8ad427c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63be964462c08dde48fc8855c11ea37889b2d6855fc46147cc42767ac9e20d46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fb2b66aeb243017afe071a5e0ab5de64a8a32534545994afa044f021c748d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280d82c6832158a83c1e4b88d7a3f2845072c84f68ca64ba36f0f6621fa2c655(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262db66695d7b3344b5a9cc63d09845ced09eae7198d9bb56213572355e10356(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83cfe45b24f976f809de4a238383c333033cac3f5bc85fb5465bdf9a211f1cca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26bc3321c6636d3b467c0d4c049bd001760b875ae4ee136be62d2019bfdb7977(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde0d215d03e00a1cd3e5b83bf156f67fc61468ba9734195bcff12975386e24d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61eaa4dbd08b86dff66287e128bdfe82b91e02f8fde32539f3b3ed18861da1b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0b6f640d43433e3ba93f706df01242644a6d5fbec64b8aee6b86ee5ca4bf46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b979282183ee2edb71b53848a0af5d1fdab596250074d7c23df83e93754756(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd4c429a3c334833609e82cd4efbfebdafc2c72abe8a75008728bcf83001f0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c851d99d2d4ed99793ede19a7bc91d8e4ff9612eabf2f77e69806cc4eac8f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4bc23b64e1b9a9da066b10069adef71a89a9a1d8b5670d1349f4a2b9c5dc99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89456588fa0db743bc6daf77313e2334ee49feb6c199f21a29c46a8de41d4b2b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f94e84511cb730c7900295625f71d78ed23ba6a98283a0f5ce1f2011c61d30e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a51025017de543d08c63ea301c742bfb75c72f9a29ec8bb24fd191534c5db2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7903879bb1ff9623cbd87c8bd80e7d21526c15a801b06ba9fa4098e490c5ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f85a6b7b8f689d0465f56913b9e3f3f52762ed9617909818b3c70578aa5feb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735f739020c3ebfa43509204afb1ca8a06801df71b290c98592f64cf3da1a767(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c31ea26381bd9ab0e00cc67ddbba1933a61db9296089c408e10543e54a4ae66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ae899372a849a3f5b469ad296365429c198db4726ea8893a18b14ab6bc54a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ec670ed6e33f9ae945004a098d6b7dc7d4f76dfd9456ed51f15efe518dfd68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0560b12033d75c9a31eaf5a3c965deefb74468dc415caa12a79e3897d86fb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0cd4f49a60a261bb5a21d19136e6b8ca6112a490cd61ce128ab66a7da1e8e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea63e25dfeac5a685092527cc610f6fa73060c20f5f302ed0221f09a9d9ee40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d227ba5b814319fa560e29c84a6cb2198b664a1768759bb45980b92e4acf67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03ce83d383b0a76ca8b8ce8847dc957e2dc16ca5f22e18651829a2565ee54d5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf279cbfb06739d1661c5e819007e73967479d74443519eec42eea96c328597a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9a2a20b9ddb780bd06c19ae3e089190cbd283f9063220bf7c4ecbc54d0766d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb574c1dfd6fc796c94c9c470075d9bc0c9f0e673eedcefa294d35a24a0b9e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f09008e404252a99ca2898bc76f1442fb93360b47f5e9e5c2388ef5eab3ed69(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cccf499dbfc29c92941f3c7cd98605ab1cb7fa2c0946e44f90900f3fe5d07d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c455bd2007d4d71d3a266f748396159ec5d01f0f0e3c222198b8e328f7b0a10e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6726b0b569da00deb380ca3ffe489f9185dc5dac9a33a02d80f2a5c0879f435c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa773cc490d63bd69f59ba36d9bfb065db9b13455d0902acaa4d3a538f28660d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204ebef81fbefbf26dcbfb25fb9dce26f8ebb9807823d38cbd6aaa4e3edcb369(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f870192cf4b0e56cd8102e9eb1683989f5d573f0f9b3fd6caa7ef4dbc5c28995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2baf2e40f7633950a253b4773736972c4a2190cbc612c1a899ac3d465a6b399c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c07028fea846bf916dcefede509b65327e12cfced35e872d04e5b1913213733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade69113441b4d773a96b5cf99acfc76e2f25f840482808aa89c9a94cfc9a6d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f939c9c824a9a34e77801517ff373edaf20394296e4d07178bbfebb28d12b67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cecfe5601813d0fd875b3a22613490183177635912f8066abf3fe09b3be8921(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ade23c4c413dc91ef4a2a4d160294e64af77f784efb39546cc238ae33dd5d9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f5367b1da2a648ca9dbb2a50d6727d36e42a9fdd3a3a1269dc0b44432566eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3a4c49b0765d4d999f6cae716ab1ed6cb03b9774b682ed64650eaf368fa71e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d98429c8031a2ecee7453ae9aa1bdd186074e4e9388bbe3aa4e9af8a35aabce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61dc9414529ef7e6a9848823c6e6e66992d733e1707b343b8e4bc3467649958a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34618dd499766904e974732f2d3aa8a77d1e46cdff5afbab30aed77e2590e931(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a0dbfd0228ceef8d19988727bd2005f39f8c7e5a0073ab194b7f61e49755a68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1bbf0d494a33b654a11bce66bd507877c09f99a3bbe2b2df4501b57e1afe1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae807b437c2a00e7b5e42016ffe127288a4b2dfbc3594053c79570c7e98a791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc38c929767d0524ec59118299fedc6cc6228ea317da46a248971735ba10e27b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0de711d7f0b133847e933aa88eb8bd24e93c94e87809e9b08824491870ffef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1f00007948e446b6eacabbb3f33ee68978b8cf06b8833e5918e05ccc0959bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b14b010eae5a92834cba5bcec08789f0aaecd6749a26a88a21678ff112c83a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65287cd34837bfaeb53ae89736dbff6a0ab36bb7b509c787c106a6dc64752aa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3361759629982417bf4b2e3845cd990230eb7e1bc8a2ae7c04538122b80d8bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7c9781ec74b4bafb744fe78741dfd94e0cc449374004d17c24979bc7ee6fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8208dc0b8211d3688a9a3e5de1e3e168e27cb5e87fa299788d417b5367d1e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5963f9612680f803b2a411458184399e3df13fef330448911cbf30c4624e097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01366f3788c9617d86f652d7881d972baec265c269907f392aef7b57dd4e13dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae23f9d9bdb5adeb7b7a86dbfa1a22d2a4ab8a01ffaa37f2f3363ec59e6c2ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b91387e814203c9fe47b857133a43e1a87a9e47da64b2369a75c703d5d1ae607(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a0c28da02fadac7e138e3d4072eede39e44f20e7a1ffcd3d9004121c6260aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8194770bf2ccca7f74fe9080e391378bd68c61e95a37206082ad9b58df592e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e39309e4f0137d4150723dcde8e51731de7fc342cd596ba951e98d7953e706a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69fb511bdd62366b3a5cc9bad764599d1538faad555fc875146d3a3509670b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7dd8202c1082764cd9e5bc62c67b82ce4b9f80dbbabbf80bc742f089582990(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d33eaf3d5474f06a7cc9f6b4a688ab99abed445fff99be4648692a71854d62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b81f19107a6a4f990215cda032994a6403ae3ca4e022eb5afbcda1a9b853582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5520a917d376eaa0d8a08c9236b70f46376786dceacc3aa7d068469bbe8507a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6551112e607c52929a5917309ae1e130147424f0aaa7157dca90c31fef71ebd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3757d509dc4d0581c548bcb407a2a35da980b1a9052b231e4fc5b32071476d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a0c4fa381d4b1337d58fb5d7039f4d283b890cae24aa04db558e42402ed2e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04e1ae3ee116a7161b55bf2984d01401c89e75fddc653a379677ca1a4021951(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b56ff77394fda080f7bb941836573c46847f4865238163a17962269b2fbc514(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7220cf1b973754a8741005f7eee0c842accd61de5e2218ef866d69c70062c8a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db450419d26bb734ea5338ee4cc5742cf5a779fd26441e843b7b633ee9af3061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338b712387ca8255ea30474e3bb92eb69effba1bb886abff8536294117bd82cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d53b65131599b812b63e3a75d0ffb24d0f05a868ba2872ebaa02bd698b5f83(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c691d8d94633d77ea864ede7f6fee981e7e9ea9aa112613c25e9f2507ac9ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9facf087bb5cc0964a636e38d6f1a64df92416cb113e1e0e3cd7997e2c01ec8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8229c0283abf31849f948ea7a43466abf3bc9b040852ae201c3975a34d2735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc86ef11245e9ca6d52b72d6f420b8eb8213f6851a4f304ce29a26c53874316e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec19827094765be381657a0dc39cd3319428c97494f615d0e5c7747dfb5ce9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fb1d3709341ec1de83e9762de3cad9d2e94e6e537fd6d1808f4bd84d18db7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4026f68b6ca663efd2fc03a025a96a2a73aca1bf639a9ffa2922fa2c8d3fdc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c540be024ba3e9e2e05100d2563794a52ea459e2a346ba1bb88175930e5f0109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602922b26a5bcb614a28531fc6f597ef6dda7be6a43ae4b60fc25c812027b414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce22d7db4b3cf61964cca3188bb37ac20018a496df65a922e0d635574378899f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2455679e2b3d4cae4b417df4900b7d81cdc6bad11d070032c35fd0aaeb21e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ce61128d1263299fab1664ba9d86da43a479c78db89baae1e365a6196174b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7dd2673bf29b0fa3975b1770874ff4ca31ad2e0e1819fa31f306dbbff76cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31be5847958fbdc39139cf22e3b38c8fde76c2a920a6a9064c0cc13c6c893d6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e9a044ae10a8e4b6d8d685cb1ef901eb9ece769b54d5a4cfaa27b22e573710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f137c67d20f0601e302631055930b86f40ab9b7789a42bcce86a96de25c015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5578a931510cfdd8b0e6bc1d52c450ccf2e9ca8129624f6c8901b4a9faea31e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab74c53a9cde42a40ac71c81418089124270b7267b5074e388720d5816d22394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df463b35dfe8922743a3de43afe245b6e6196e08440502d2862ab12be2c6c0e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccda4085bc63be779bb0557bc5fbc0ef91143735d80a9dcc616342356887fe02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85301ad657dd06c7a46a28b6fac89787b332bea18e61f312be7b0dcbd339b53e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f1027188af280b87fa5f064efa1039dd48098ac190864dd14a05d8c7f8aa44(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e3b833cafd02ee020f264a22abf333c26b39bfdd7cb757c6e8fa559513561f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b16c2bec0d238e75138dbcd3dfced64b25f0bd269e9c0602588e34608b67bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be46e9b603ebe01f54fac82847f1784b25c72a6431854ce47b5006f1a545c6ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a85c2e05b4f7aac0a2f336e52d46f4a4a9aad5371fbe87f296f3fa71c45f46c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3deaa54c5b6f98501b2a321d548e6ff12b0a909336e99ef4a06181ff5bcad618(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0647e627f939975635401a2465c97042f737dc2af38d5860197227186b8f04e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35443d9da0c26e91f4f9216cbbc2ffafb16d3e1de5cce91e156eb5dfd6cf6a58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a7989e6d1bc7bd257af7348323ac0850a271c4c967db3c295d20a8cd6c9993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda977e1d36402c6c2f4782ed609b6967cdfefa7a19ac22b7ee64eb52a48d54a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b941f7486841eebb063d729a88574984bf3abdcaa1c87a914c17432c78d60504(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6f8d84fa09a991e6c720c5566378ede6d8607a555a47b4b95f0930b71816c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42547fa85a5f1c7c241b15e19cb4119e955b40d85bb580ae56a4f1ad83bd2ddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe61f842d204af4298f485ca8375b25be8d8365657038c797e7fbfe869fd374f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc8ae948dd7fa769fa23e2562924669458a49e89dc9dc513466e6779cd96f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8153bed27390c075aee727182d3ec1b42014e4fa31fe8a098b683ce23b534109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdd1eeb8b3229ed9fd58162be376ea715780fe3ccd64eed2ad73bc31c729db3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e07ab890e86661a9b8dfcfa4cca037537b0073696a0d8e72cdf9bf3d2b4b4c(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f052fdd392d0b9dbe7fb7c0df72d2de94396139d9d2f89f46c506e540f266f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0e8827b21bb5ccfef482a7f9382da860e90ae4de4bc47a3d43eb0fc2cd8d73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3227f86a771d6518270ed58c9b44fd78cae4b71d0e82a88a300a13384d4fc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b7f1820da1bdab6eca2c570d03853f7652c187af68056c4bde38829fa4dc39(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b07da05ef90214f53ceec50f11ad5e3d6077f8000808f636dce7c7fc99053fd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236be774b4e9a41fa9693ec02474c166291f0b49116ef80f7686684939284e88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b3f928980246b1d6d1c781f0dcbebb1282e02182d744b10771a1244662eb5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03303696bbb60e781daca2c1a2129614bc980a8bd8b5d6673e16ce79a28b46f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2dcecef6d14eab3de14a896728a458fd58ea2e7b62388e95871adadd7956f72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b4bd3a99768be661a29a20154683a730af3c2a325942f47786f6e1280c8dec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536821214e42336dfbb6fdb8eee4c9dd2d011d93f301d23a2182741bd713cfa5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531cd55c8f5dc3dd07b2bfe058a084235109c5eab70fff8f7d3d4ec3a6bd583d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fba7eefde874ccba70a7afe378d1d7739950ff4483bfe007b0a87aba82e11bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f4110d4b8d4ad41150aec32ca5c915f8de407225e6a44ad8fc6ef2a4f430196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c158e7811011dcf61fc76cb6a2f2336ca964deea252cec3438ca3ddbe4e565cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1292dc5cbd90c25bb4dfdeb4e1b8e88e46df73053c749698e21ef8cb35ac988c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae92cb2a0417810a5de1aafa15943f3c3caa7b11fb1ce37faa761f7a6dd2c65e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca962067694eae71639608f6d8c846cfc677b3e1d489b93d6922f074e9e8ee9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e30f52dcb3d2a914e8966b6e73b770a20525a1c8715524a8de902de2305615d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21045544f93a996c9b717195a29dea1041ca1d5b5ae69e428af9e9305dabc78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b8dd3f5cfa480d515f3d49b7a16c3e9163d8ac949777326f4b4684c1da679f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd40f98ec28e9f11cafea01a0613f90bf55bf861161e5dba095cddc1a459f99f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847e38be3674076dc800075b16d733e8ba97f0eb42085b2bc3c9999ea2f9a03c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f87917887c4e8c184ee085104637ba97755d42465db3b6aa6b2895753aa459d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__447d7091a0a741b2b8e05e8d1145eabe6a237b8b73dc957fefece4547bc747b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a338508e5ac9bccef9d4ad0fabf8b141f3dea171bbe6b991f7565aefc72218(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e146cd6da706e2d6802e579ace4c5d22995532670cb781b6494ae50b839147c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e6ef209e753d881ad66d287b7085968f110fde45bf0700ef237ed3f2865e51(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c87b477339ad3d96dc16f8f8f1633b5fe5337a15516904647bb4315ba9debfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498372983d721f4b509b5a0ed96574d2da5fe7c82a5463c747fc58681b41524b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c390bf70580f2d9d79ec48dafd76e4deb070bd18db7660636edd37b7e6392cd0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27ae3d6dedcb643e36299489cccf98d7c5aa2fd71077051a95ea2d3f5b77cf4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3bde5a3e4b8d9da9a912a1963607278a8b038fa0fb8f1b972938ded455db60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73e9a6c75a6202f972efe722c36a8f6b3bd391313f056fe8bb3263e708dcb964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf0fc57fd4f419a4841d710c134e371c71f93b2095493b77c76a8cbde513fc2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906e83eba6a8707f17b0af961a02d2b86f5350ebbeb7bd2ac1dc60cd3d231951(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915673857fdd64cd0db1fd7bf0490fe7a3e91577636bda427f3536c587ba8b80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e878390e411890d66303ea3d107ec5d721c8bc28aa9067dd8465a111123d0a73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196cbd0b689485fb8465624d51966ed1e911f216b4009074e3a06c2cc2a493da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c7c23299ba970b60e024cd3dfa0db1ce90c7ab312669948ea9b86efefffa20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b457048284248bc184acba705276128ef0519b763f3b168c129eed816ced20(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbdd53a39d3c7efe40d3cbd954ceaf03e25dfdf8a8719eca0fd3481daa198727(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4044e88d99916e83f046c12b0ff377b5942e89d10ec5b600513bd4b3df69a63(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58884eb0633f493235f2fc9219ea65c5c2719d9432194361e82aa4c72f20913a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a740ca3d4a384f55ed43f6f9efed4f3fc94d68ae335cc7f59813dff3e9c3ea2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be3be03a5dc9f4bdc9ab435caeed42705b20619163db93be010fd0b3c71c3d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec21201b9b18bc9ef5c35f82760f18b2a1f39b300618d9dbf194d1594de9203(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f5d7d99790375c08e41f7e0e78fb5adfdee6f58f756254b542c10c2f95df9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a304e28e8d644db4f41e8a0e478b288c0c2f0f70f3f2bf008d34a5c7d1ec781(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae2ffdd47e1b5341d01bd2e172afbebcbf79f0ba8151b8ae203961548f056f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9eba5dcae6f6b731f03d581691c65d9bb74f1fcd1ade16d5c35c5cbdc7d90c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__629d31798c7277aaec973590662f371ef3d9968f5d1df1d4a760c593ad42d705(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f3b6a9dd73d21deea71f592df86594f230a8709efc58195a8201bb530f9525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aec59e240e34901994c3ba90d7cc15fb5fbc90fd78bacc687f7a9eb6b662a38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4488e44a5fd97444569c5b373821e49afe22bf9f3397f35d65230b1706d294d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3bc3dcaca41a17bf30192f34647851ee27ecdae64279bf3eb869c53a0555389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caccf22186a59b024b9bd25fe8416cf4e4b08cd167cb659d77ca9e93174459e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fa4451c604f68cca39f47264ec4d3d4c93cb8abffcb02bf9829fbd02886ef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f8bd2c45ff43c107a976b4c9592233a561af4cac16eabb19bb327e71140d6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72492375ffbc309b43addc31fd21d44a4ba61cb94c3e04c9e18f265e86376317(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed7a42f152f4b37f6b1021444c64cf650dcb71e992dd2b90faa6753512b9a51f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be561186363e7660bde52a593550bd57fee97598a7438aeb8d4bf28d0e3f8f74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58cc9a06e567a8d0662bac2ffe41e3d985f83031cfcfb0a20d59e0783697a64b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9def5201f6df67b234f6da92f411a8e63a244fe91027bf64c64143ab31d15c14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ec321e0cca3084236459cf4be31f67f05477bfacf76ddbfe9b4feecdf0a260(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1521259012cce01d21bbafef168bb2f352c96e78286c457112d12620ee15cacb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8210e905a9f387d0aacb368ece0b3fcad81e9e16fc037d1399a8fb3e7811e5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062d6ad05081e200d7e568aaf636ca8dde1b93d5c47f22b7ff902219772ccbe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d8c3907b8079f039bb65e7201f180cd6ecd636e1d61f1da9e78bbc8e535f63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3eafaf9d50b4cab77caca64e4c49e2abbc0fb3ed4a00cad417f546ec009e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f83382e9a4305f9096435a3e409f511d6fde7a251152b2092073c0e53bc8a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf08c3f9da3596993aeff47660c214a2c7761ee60faad6b36fd4c7d88a0cd9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6a1b20b90788ab4e36df0f554cffc327d32abdf31eda2b221b30f6c5f3066b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49616f787552a18a932eb20d2d1557e5213f1295f94d317d0a5a3e24809629ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4c2b85cfdb500bf31757de13b9c757cf79c838bc4909ae024d99581e71f302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad243628f03734402757534fe45a46c842461d2b3fdd36cd0de972c9a3c0b065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f7cb0ab980b08d8cc2c7270173729cf9afbaa031bdf2a9d2ce083102fa5251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a188efab9f1f800bf9f2a6929279b116083a0f6402bc7b399f3aef6be526fa4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca9a32c0b4acbccce57939ca8e4d29d1a2042d42c401283f1dff8afad4f36d1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5a773d65c4462a2361c1e81c09f80a12278c5a4eafc0668f954700a45da282(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f56cf3b28b70bc7e4a539bc03261f145efcac0b80377722df77f2f4a3b2e3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea75031583ebdec6a991c8eadbdfc7337cabc6bc2a0da52f3b1a210d570fe4b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17e3e0bb370e34652b86a2b06e3a4ef4beffb2c6e157e72927e5601f7a04071(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd596a90f6326cfb4021a85f7794d68b03de18676b8026d88a481cf654f1eb93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b11936e96076bf767aad54a22d4f74de14ec8df40b67de8546645d1ca4b2c1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2ee119e161515692008dbd92ad3aebe092acf10143ca91be44e8dced9942d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e1075b37d83d3c6f750d5861ec35fa376ab2cbc4bae89a3b9d477123ac8bc37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e001aeb272aaed759afa2437c39cf3c9fa06616738e59be4c49091f53c5281c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01637f0b61accb13d1d17a13a59d89f8ab31f1fb8acf3717bbd672f80b53ca0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5897609b36e39f18dc0e3a5669faffdc7c753f53ba4b1ca8b33f425bade368d6(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74bb3c95d5e8cf70347db422a802eea4c6771cbde879d53a222b33aa5c39bdd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2131ceb12ea7907f8a58d5254e6dceabb3f8f42af5bc9e989f1dfa2a2d24b6c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb3381471839529048ea6cf04fee2ca38d280660c9d403c745b79476c202f40a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c911d7f663adb19587220d8dc00749760f1a25b6dee7d8c3fca22f66f47f1a50(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d644ced76bd9959886959f50b76f626a6454bb6d133e8826e539a4f51382f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3fd89218ec8243dd5c050c909ecc4c58ec4ed7af7e64651ec7d4f810a8a648(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d245f8137d7d0523184ba3511dc6c6071bd7f54f7c893b85941ed3571ecc0aef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b3049ac9da7f62ac8607736763777a038de1f8c6051c8ffa0cb9c65552c199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e5ed4457750e3a13e6f1d866b247f6d96cf473d04866723220625a7e310d41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdce5bf53e55cb47951e76eab8932477d900f534aac201a2fea2e70abb3e87bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4183f937bac1e1f4b0e3b58e483f0b00339d3f4e966399afdd4b16f75c8238b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c500706482a8ccf8e18fdb9f2706f339fe51ea1178c0f87ad6a11d6276c860(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc640f1145b02ad75bf5099e65b52df5402cf473cfd52efd053c3d90e7b5f908(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e54f46e10c749e61ba4436170c841d79ed52ea5fc280326e9180747b1d36746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82eb8eefb692ccde12cf5a8e2b56c62043161251993c3198a8476499a4a2eb18(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec104e4c1589c4cf4584888496181415b9707ffb57c343cb17103563b59db442(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe3567b5629c1f064a6965dc268f5c3786c135568d2d1fc5ffdd424ff05e307a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276947d4ca0bc50382128f92b40b48becab64c8fac5cc9b86a800e2b5af9be9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d733e72378c5e57cf9a53f07a6fe420a31977af80690c782bc82c262f6626e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73041552301b5fbd2c073e992dc617687e541b43a13e82824afeffa3848422ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df07cc77a759f9bdaef53cd6ea99a8e8be710bc7cfa799bdf45575cd5a612cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44aa2a7c19f2a590cb0be33469afacdba961436be4e92877a3e681b00e1abc17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7fb48132808f7df2a240812bfa0eaf72b9fddeb6cdc8302af040f2cf700466c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fda8e29386e8e2e81359def48f9a78ec7c5d4ea55848d90d21d663938260630(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf57d4fe689fb2ae16fdea2b52d93f6b5fe27697a1d38556d26f86525d22ca73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b1b5dbbab252b440e8f4e579429d6fe056c892ed42ec0dfc67d4a13d6354e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e359251f14dd370d3c4de7eaec510a193cef9899bf71231cd331962570ac3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73960425f26d76b82b55112530bc11067867a8675a34e9e4ce6935083c9d5eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a53b21b885fc2689b48b42accb9aa0548a7eebce38a284850862fd8b99f02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0281f509a76910891751d7fb85c59ed56ac344e88f780fc866f97051192aba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665b1a730f38ad6ffffe8c789cb165a6e17a08d439d5096a2198883c004a80f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86fb9c8839a6f9016fbcd0ffd90b4e9f70c4b2c7dd3530cb3955532d66ef94ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4780549b147698cac51d881b2745ff285298d935edc87111d0f6a86f115abf7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b0fd394196625d55275d98c1f9dca75614ef0fbf05023f90a1902cb2332bec(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b7f58a02069123ad7b571452bb2ecd82f862f3109987b63d919cd31a69bdbad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e4459d7d11f3e204b38b89a3d41e8b6693f1f3f3923370136e3343534de54c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de33046174c7a762d9e2d89d8a56f818414eaf9ca953c403784771c4d9f1b03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787a132abfb833745fc36231581da72fdff3da6c2be804d8ba18fa70ea78450b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f708f97e0fd3645fa86c4c464385040c273b05df0d3e5f98eef649a5762b8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7efff6213035683450232f3ecfb2eeaebe68e783780fde738f7c6d15daedda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878864c7fb066a1ab135d5680ff5965e4161de3aedd9b924d15e653e5060db2b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ceb4ca52987437db1ec8c396b204abf59da3301c6b5a65eebdd58f6544e622(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24a046d1fb5bf336212be110b387154e45b56f0d5628a2d4b2c26eddcbcdc62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d405852e91d307acf95697612c400733a42e53be67a48a5d0b1b7829c3af335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbd1465f00e99a73e7eb8d015c79a7338c58aeeac459bc092deafa88a3e10f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1d5483d2bc1a5cd9b9fd3e86df0984e1a059d9d5542f66e89c18ee5fe7bf019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb5d92a57125768acb51820e22f2db2963fa0a96b6288fa925319c8327e9073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d802e777184d93391848f26126d720ff6ed60041d1da1e3423c9745255e27364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9462c3d462c16ec71cb518080b329262faf76b858c24b8c3168e6677512c8e25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224ca66d032d4098a503c8a7c6af4e2a31f265d0262a3ea9eeac3c6bebc0b908(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eedf6f25570d508c1fe2ec8c04fcfe31b1afe75988053fab7876947096f001fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5bf7515b66ab848112c61db1c471aa2518dd421f95eaf0e72aedfbb99b11d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bcdb123c2940764f53185854cc892c9dd566d73af8c01b71365350b2ab1cf20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b11fde89274530e391e25f22f7b61f4167b31cffb73f5dbe0b9b1327a7428fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4aee7a41fc93db552107090bf1a1a5ef830aa1fb00b4fa730f6439b560b9cc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad734f879042048786f6c2f0ddcd70ef1a7d8cdd0b9ba2bcd72a9704f168265(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291775ce4f3b2550120a2f038e817a4dcb5a9aa08d4718f75fc44009a2702155(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a107323773519015d8c13fd39ec507c0a01c4c931fd8ed1676a7414139c3fcde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea8deae4c39e2c849f98273cdb3edc51b43a8acd1bf1d6b4a4696f5e90df155(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d44e051f6db5b75ad9fe2c6b707ca21d7985608df6656fb957e2dd5a2d547d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d9835e572b723c25bb3ef6a9f0a68c1d69c6720e4a91f7b2a298f0d6f492c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6966157c83248d94f56a6fbef001935e51349c8113cd9288a13614e0d3c57c16(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95af5b175bafff0dd3de7c11cab03a06bacbf2ba5a429a6088113529750ad28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c3eded4dea9714e1f49cd9394ceead0a2a4e7fea792beb893f9e870927cd6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb5a96f9918b03a7c4f8175525b5eb1d0f53d8822cf2563b0246a33e819a764(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda8f209b61ebb83b3b41bf93eeca40a8b9b5f7213a57a11a31740b0cf11784f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f913a5343b3bed87e1b8f44cbc30bb16604e0332e99687eab9f6eea405e29c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31e1ea1106f8d661fb8d969a85d74fdfa6e4796c8d8efcbbb418dace7f77ab2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed9b4b5636cf428ea73383da94b6e4a8294250162f1178b81053d60d2d2bc1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338ffa08f32afce7b425718d7e1bf20f90f1950371d34942a75e01774b45f946(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b11f8ebb8c1bb57e42641a3a489116a24341c3fba346d8913ffffffd42842c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c553e812c3b312bf12dbb998a3928ca924167d5a3bf6b8cb165e0d1fc15696e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d861925ed409efca0c2b337dfc22d42c3b37fcb27d0fda53ea9781bb5a2471(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a2829d7e2b95956d5335cd6437b9e980f5335b76588087296a0c6af0e08d8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ff25bf50e2609a069fe8e1650869faf44bcde7a32d76cd59a68650bdafc4af(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a680a1701f7213c0bb528f7974184b705209e65cb91b21beda2c80df73745a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555b991546a9e0aa8dffce4b06eec4471098540e55c333e83abe57751a5a6cda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087f3195031b9c02561dac32ff37a7bb05bc1949f8c0c6e8a04fa7630b71d286(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64579588ad86292d130755e2bd19496e5d5e6dbace145be31eaf2fb19528a56(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bc2f70a5aa2c6d8b858e829177c044ec53aaeab7f965526ed8e3eef4db5e7a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e936697fcf98cab66feb6fc34d95552655b5831cbe940366192a22eb55df5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd0cb10bc20d318b1f59fa520b0763434b70cfeb2d1cf348b4ea179eaead59d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c6c1331ca3e512bf6cace6a812f5304bedbd61006bb28c11d21bb7467a73e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b9d6ad5848be4a20f90eb04a8a813eb82096e550c11b735e96b53565c85891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b6c5224410b57115d75d9352e492b3794515f3e601a5a6c4ee1ed1b3003f2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa8a53581bcf0f2cba9f03370e53859f4d3e717be9529259dc91f5e281a967e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30fddc4ae474386002cd85d16d4cd1983c6b7e3d5e807d2a01c5b7cbb9237bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cbb440aaeed90eb201d7160da921e69a87540b5439291ec75903abf46a950c8(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d7b712d1432be35d759429dd5c611eb9ea353c9c4d76b936ab38e122db2f10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7122258fbf6e1a79219c5e233fbbb3e0822ca0e355b482ac005635586e743d90(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7604b49611f87a6ad712dbd90027e482a7a9cf6b8b9c633729f781b557a1e679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__645961da8b221942410635b6cd1d74df5c31631057dbe56342ce5bc7f21f2056(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8fd77c18340bb1ebd709965987f57c1ff6df441c04e13445358cf90cb724290(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3bdaaaf3c07451d3fdb38a4d13f666aea553bf87ece71d3c70999976f68d7b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4adb6c014bae80590e66b44867361e036b730cc821763d5a8ba4f5d6d02e29d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278a665bd81a360a4110943b0c3adb66e49bba622b236f135e076969c1e43f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70b2dd9ff8d39ba2c799777852e51a109bc8534b1ce78d18c27982fab6e9fc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4502909172557504ebbf22580ee5fcd3e1f632847820a7ad7fbea098126cfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add49f8985c3c524ca6cf2148e6f8476ac9174a5feeeb6b761274f853a7a9cbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1725e7b8b1ea31ec4f9933ef84b00dc8f84cbd5a019fc42f6cf404c86a1543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e15c92a0c3b03b6f09d40028b517cb63b3f88491cba76a87c7be89eae910ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a4fddaeda2af6c8efdd8310ab6bc0d044f4cf630804dbb2dbc28a0f2c1141e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b607c5f92102fe9d2e5d8add83f8285f33f3003d821ca05092dec84cef4fc8cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29b34c5c1c27aaffbd874e73df9727498f35aadcabda904b4546681a2dda063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a94f332aca4e769e7684c1d4a1b18ca74ea5eedce3fb6bc42280fc85c7ae83b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5013464f97205c0d6b0f68a628c47340926987c5ca639e36006b26a98ae2566c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404aba1845806fdd3cd5f7cfa3a3b41a2fe9fddca7c26743060b30b2a4feb6ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce8d9d6df3d0084bec7d524955bd830c97cc334349098da162c85fdaf9b3f76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7684e91c2d3ee219a35e7f17b7d3fb910c94983a1c06f4846ff7ab6680189ee(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75cdb181cb567561e3c48909918a455c990e1511e57069db8cf011db5383aea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f240ffe1f977800b1afac6b1aa850029fd37fce62ae3e66ced80a23bca0744(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a989e1308a9c430ae43838406910ec048ebe42318381059ea58e9829b4bcfc45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a26e77d2a0602fb58339801558b5dbb7f5e95856e254ae636ce30f06963e23a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4271ccc5f1ea9c00de0812f977c53d7a5a7088b11ffe2722bf3a9146ae9d63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7cfd8ec3f4d12f6eea04fe9a0513306b260307d6e8b63fcaa770e7ea48093b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ae53b196e5573f547c05cce73ed2abf2d5348a1b6e2c8f064f2c3d75941e59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b60eb4eb717d2afaf3b881a9e3e721bb56752edfd73b0ca14eac118c9a1e95a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb785b68c864f529e974fc49e68702977b8223d90719733afc8b994a86a814f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b054fb9f0a09197f320d48a6d670b7c8215ecfc72f1b346d4c033fd83a3768d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f773a8a075b4f9f7234347cbdb5e734ca77832a179975e986a7bf60ee877f2e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5eefa2cb04f8592f9b22c1a0615842aae79dea2d24eb8a2a00d6579df311574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48dc79445291e69386407111998dcf08b22d45af39294f35f3913cb8a1bcd9fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e4f9e6ccaccd2974eda590945981fcb6049b65f37c02ebb60f41314df0aa8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1b18787e646c637eac33b0b77663ffe78fb6475538bbf0573e9a820f4b40aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2fa76ffa9aa901d5eacad0b92b07f4c4064a1a8c7620d6abdd4eaba2cf6814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dde6b05daac8b40b40f3e8937c09c8cd107e2e54fb53ed86ccadd81c186dbeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3176705332f5b4bb7c238235c27dfe8e8f5ab20732ddc4fdad522c4218f10f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__758c8fc030f99ae1e2816d2432ce7dcf8e61f6c7eb28123706dc645be5a84684(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94bcf6661b4306f34bafeada04729463c9960ae1f3345a098a5a208fa5f3f378(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0029bcc0df97658d630ddfcf3c4a6082395cbd58227e647b73c3a173d2f8cd23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7ecd8347423ffdd188e918a67e4e4b400f6078620f15411b1f4eb9e3eb1061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53cddf89cac7328b8f75f86dc756ce0fdc021be5c0a9f5ae882abbb49f182209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95b1441a86d1c928e15fd2bdcb89525064c620276d04f492f982fbae93b9f89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff55ee255836ee4134a84a0e77b0a4c73d2b8c1b735e6a705f257c551cd77b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae047569080a9d6b35e055ff954be0b56e0b142c69375239d5ff03dd4272ec28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583c365f4fe0fb4f95fa2fa2ed9d17412cdac76d4a2b06c04171db4350b8a1f6(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b131d3045f5560d44dae4b6be94fa46f00bb251abb04562fc5a45eaadfdd7c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e238154b231220571f1f5c0c3989fb0dac44e2a19d8ebc3261feb2846b400648(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6a65d1bebe022c0daffb5a2e4494040125d348baa46e8bd25a045ae3402f36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c4539d602823bd0555fd2db98b30b95ebefc37534f70c88ba9ac0858fd1a9c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560cbd1d9c925c3ac91f1fa6b59d6e5bea85529039d15b87603f412f9270108d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09bfaf7e342f5ef4f80eab4fcb14872716ddcaf4c5833b5079ad9c9abfb3403c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1afd37a301a2eea2f9c3c63d5f21a8058426c002d77075906c596ac634aa75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e97f02cd2fe2cd3555cb44a5e66d31067cac0732ed543b91cc79f7e70ad4966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16405998e7d8050f5cd03d03f9d9a075556f1984d37fa18cd367ce0a46c80c5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee848a569c2468d860dae6d26c01342646ffb0236b490643cdbc6a8f6a6dfe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295dae3022bbb5fd264be9fd8267163b5f35b675524ac905a9cdc64ca2977218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d826526acbc6444eff82f8867a64440a518f4372ec04de2aa3d7026dfdfc21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9c860e91f3c7e6337aa9f2b0b8f17bcf8a77924462496a001a771666b2bb8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9a9e7b7e92409aaab1d412881c821ce8c1e23571ec001395b5fb80924bfaef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9054ea17c7dfa72f2b91c8afad4a1bc30197eafe119b83a90c08ed1551290f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89810baa66ab43dc4dc4de2b982f3c697379c1f0ba72002576f2a891ee220ff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad89c4d6efe9950e4c5014f4ef400c098da61ff8f77ffab407722bd1fdf52c0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b9af6b843e650c287a0577418cbf9c07afa68aa0820342e50ceec50c1fd247(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd75255a8e8b3d961cc1942ac49b175793a4a0b1059d9408976f7c686e406cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09434cca029409c1ba8165067863d8d0b77bc5d76e6692e9611a565127d5c272(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53ab6d5f57caed0a605d6c6e6e3ed24a23f1ac0681060b4b075bd0df44a2c4b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1627d99e9e9253413e0663fc4820967ccfc8d66ce93900b8043a0971e6ee3c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4326baa35e2f51633e76c599b0c171df2c35fef0454348503ba92c6dfdeff5a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca9e73a1b295e5aee32674ffb0942eb78e7ef898747b5d64b1b0c0bf7a59fd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91de1fb09516aab7d4c7fa242420ba2b397f6aa14bd4e4f88b10f22ae16cc2df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ef0832c526c098aa6e2332410af8acc54781f6f5ca8038add0cbdc9a33c071(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e4519645a039e30079a1c6ac2fa42d10c307ca6f9764718cd89efe9b14bb8f(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12623214d57c54d04a9163db8ea8a2389bdfdf42bc2d2a8f06d60db65b747797(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a8fbf72d1b45bb4a0ed2ff9ecf04e3a6b68a220175551cd951651eff817b01(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e5f89c70b52d4e16ab3734b802e1e3b3da8d26ccc23f2a7d65075ede721045(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18893ad5da321267ff837523f8cadbe58c34070cbd5cb091f2f77644d53329e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21ba0869232e3390a8588282f5be5081a8b2162a45fc71f4f71ae09567569b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3593db540de2d83dde559938190a269686918673a39628e5864ab7e0f1f63ca4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b291d7f3771dc81bb9783b60848c31641ca066aba17605d5820de4295e82ba01(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44dc73cc0339f734b8c54a95a0d1dd860fe3baead9a0f723932142e109b3a471(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ea9ab65b3b996d7b14b59035f509be830c689e8d9830ec201be2137936ec2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd9f60962c004d92fc55fc658dd8b3c56a09bf248cbff079e50947432a9e7d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91420f770a94608a65cdcbb2b1644c2c1dbaeb7d2539ddf23ffea94560cad83a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9264083d67d033a9260687be403a2bc645054f291603d98bee35e09013064ef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0796056f616e09ecef33ca33e3fedd3f70abe00f35662c8167e7246e60e4cec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f509a4a325971de2df94789932ce11d415564e15d46fd7023aee16b49c224c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ad6ddcb7592b31326e391539a8d50f8cd37a3470d0a2ecb3c514119365c89a(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91202aa9b8e78159005f66f0abfb7a93f8e310c80f248e320ea593e880919d8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b9b7781737493598cb4ba0458c4a06d7240de50d69c5a9d5a8d50682180d0f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7a2604ee04b75fa30ee7d8e4acbb493d2d678a685271e13afc9a726323c832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e2341b7d9481f50d2ba7292454a83647f949d2ae21f02d73fd51200dfe43b2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d71c27da1ff38161138762a432f5fa94f42ff6f420d7095f10495d686883595b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564c511d0bbf989743c2ce35778ecbd6589aca7ffd29760636563e02e7c88ff4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57ef963efa467fa11b538c23f671ea2a7e5c9dcf0fd951ed9e08dd057d06e49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff7137e9fb7566b4c2e0b3ce035b9336293755956600d289d7bcaa77a17a249(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9615529b0ce4f9f2272658364684e663b08e2a182b232604370d27c75ce29d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fb58c0afd719e13f856d48247137cdd878628411e2ff6e3d7f32e09a289131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae948698d34d5e499b8f302a3a79a9b14279c0af158e326f3b4b2915bfe0e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7168a000ff916a5bf6c89e1802790ddfc4900d860341213633b9fa6b0f3479c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d87fc91c72a0162af559befdcc3f25a4df5a0e9750c7e5513e8c3227878cec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__482cda509db49abbb5dfaed77d4e4de1f5833f818fc8a2b6a0cd14d2578b409f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86504b1bbd1db8b1fffa5528138326e73558e683134734391d2fb8a52707080(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112fe45bf82f71c71e312a45e9b187506f342cbd626f9431c0fca4eadc1ae437(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9456fee0f7c1f531a6b3b7ddd09683ccd03947b928da33cb277382f282bc2bd6(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e68b56459c9584c34c105ca84a355cb45135aea1f57996c93be6276301006e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d867ff4c8a1fdd0946678f000d8e4ada4d659a1fe6b92cdf589390b35b15a6b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4aa84c79881c66d136274291bad3705b89aa5f092e34662b13f560b872918c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b651629852e7030c6fff9a8d99017baad9b6959ec1f08babee0e6958ae4fcab9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcb72d39408f99e508e6831965672bfce615552b3d9418f20be1b751deef611(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc153df9f2006a4c8d233bf396a2ba053c4c13bdbe50f28f3c6329f03b7f3503(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84b4e90b1fe4cc27950629c65dfcaf9d882bc06988c4f8197a47f96bab96286(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b4da04711dddf32ad6855394b6d4ee322a4c1ee41f52f7e8acc0e6c2f8bb4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a728a9c9d034d7a10ceac99e2d3fdf55c11bab82c343833469270daec7b5b03e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbae0a5d8df24881ffd9f9a9221f804cbc157e13b6fb88b0abcd0a51ec7b9a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b4745f90032bda14b95940e3d1484256a47393e787902be3674c8b05ac9199(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7275089cf152080e40ac037c7cd2415b615adee2b9e46f7a1c11ba56ce5d31d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e045f684f2c78850916bd6519ee41dffb6cb75ed314dffc845b1e8b27fe929c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1dfbda3ea9d2fc587fa619c1de7662ec776a6c85a9b692ea085da53d72cc51d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68094fe6ff79629169ef16758243c21e9d70cb5dff119d88bbeaeee3d82b8f3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4b4d5af78e57e6a7c6ce65f09dc64c109f9b0d169ca6282ac4d10e90eb57cb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352b896b7fb6947e708653d51297cf830fb362cc5951b3c834ae6cc807e5097b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220b9240472a0007519e5188504cd5c58cafd3b76ac466b506a49759bdd031a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23af4718a1f8ef6a68d21eb3303a78096b874d9df91915b4fef4d6e9ab3aedb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea63114efb7de133a22d981ccdfd2b8c6723f88ce907f04d3406e80b6ee89b9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c69a8d5d751dd484560dc847f3843733b916c3f4ec98b5d05c6a07116f198b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1e66bba01e992d2fab60206c2cfd9c8e979fc1fc8fccfd594449f1a50814e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27a17dfce2588ccf68f04115eeae251ea228fb47977ebdbee2663f818bb5f9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e6c4b853f83a29873e5d441e9c7cafbb2add55a7465e36d60a5055c82bf8af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f583cebaf3118f6ea9e46f1dc2a4fe70f7570f21eb52f6019374f607f295bef5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42c0175dc807a7b3098672056e73e7b9e9253d22d02494bcb05ae009deace12(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9531c65d779b7ba2fb25c11ad3312ea6207705fe6ce546f626d31707a383640(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee7705099c6bc80757f856c0e70f0794e122eed1c1db77160ef1dfc75afe26a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d958a2d74e5518a906ac1df68b3352db3dd4f115e8c75406b55adfdf2a1d8300(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056a1dbe2a31b139aade263d516880bc7b423031b5164b0bba5d9657d3d34d9e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7998eb9cc056bc07a8ad302a4cdc42712c598c66267c459032a8a7b104ef055(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9f3b0ab0ae29d959313f97a4c2ee0d445e36d40ca45ae1a4fefcbc9ca4b0d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f38d5591e9b635959f0f20e3933d0e04e9b1b5c18f7457f954fb4e04f4e2b1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ff758ab583b30d7e4bc31246af586a93c8ac003e7832bd26cce4f3b6ed1aac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877428cc0346452d3aeb070c2e1e6d0f17bf45dc697c94864be0c52e70ea1543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f280b8d2dc586b1939d364628a8c577aafeb6472eb9d23e533ba68ed0e57a838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eece13354174cbbd1bdc327072a9adaa175015976421562b4b58793e394c626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77561679c23aa68224347466eef846ef67e89ff00f2addb32e7c666d33a96326(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b609b5745f5605fdcad4b05f76595326503eaedd4fb64e4c19f102f45b65b7ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ab1d943f911ed64fd2beccd0ec864ae941c9956e28ea63c051acfa5c5c57f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13939563a9ab1291600421347930020beacb75bddac4a5580faed42d312b687(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51eb7858f40058764ed6ea185743706d36c7343003bc355231881bfa96c714c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3a1747fa6eb8fe39ebd9583056b68b1ad94960ac672f238c80a9267b988b66(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2dbbc5b7ff7199295ccbe69d1558d2728bd4a1ff1891d3af6db4eb8f5b5080e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4f0b504d074f8ffa6bfb923bee70c320801c89d82cb7342e72232e505b8977(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926403e359fa12a127a167b642560843a05bca412d26f988c2ee24ecd24f993a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15aa9d890f9d2adf45253a266c5ba88a5004fba954cdcc42126d6dceafa1f0f8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f37c471b83c9453ef3e39d8ee1c7c9554c0022a41936de83067b48308cd8d77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b903e38a2d95d25d27f6eed9c1a69abdc89a8e48e073f912f4cc59630374f0eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973aef1ff7f3a2b0ca5d040aecb7af1141ba98fd6cae10d56115adc1eaef5ad6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c31e354ce3d44bcd22f2ec7e608ee45beb99dad083a5f22002a831376060da5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d644cb26fa861b7f0dbbaca7335d1f686712b8b78a945431b2f60980099227f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf97fc4e1db2ffd00450fd33ae26e412c9d56ac81976f6127b9791144d819a05(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946c2f1cc2496b3d081ef2745283660a320556404ad0b19f4aec5d62d4e5081a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d736be2ddaaa6812c6025807edefac4e425fed61ad48bb066e51a6a1bb2f6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4874a1df654cf6c99d34d64bbd96e007ca9b1bbe2c33196efba15f54bfaf863e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__becd82651316008a97503268087724f47862238dc9007a036b7692464dc7803e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5a47f90469acb708c08e39d79566c2f70dc3d78b4e63e73411bfcf1004d075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d96d93070865322860385ceda499083483dbcea74700ddd6a37f4c66f270d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1adf84662a5359f5e5b88af820abdcb4c5c1acecbc93c26d97f1d533e408c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4397cd2974b648cecf220f0a68774cd83347bbc391b21ab328e8b37ca3c9bf6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04748e611acf9fb12372203513a51833a1f475f53a0aa0244e2fcb63a0ef4f79(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95361b529cfcc15ed6cbe2c6fa1634fc381e299618281598095b944f15292e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eefa1018f07688af1cee033b3f7c08eebd125bb1b880e9f3e9752c252eefcdd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cacdeebf2e4aa85acc4c9b26fb3f7b77e979375cff8cbd9e6221f60e1668ffe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5634afa718d9da8abea90d3c7e747c2dace80208f104ba8109f75cd9e44f3fe(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbad04bad6c0d7d7adb149512578c82b5affb528cb966e1da92ed4d55197b560(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2e8426045a40473a08576f8da9dd2c27c10450ac8aede488d4b2a790657cac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1187b1e7bfdc16fb8bc1ba69ab6861ab5f82745fbb6e0c49270fb3238ffe89a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173cf5b42fea28c6ba3cc9dfc14b372b67dae17195dbd86be2af420df92eb146(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5e99e384839ca7c19476f96d37986326f861ed330a3822efc0ff41aed401fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384d6eadd979d9b2d59d42f1a76bc70274223cad94c8fb708a0acd1fb7cc3440(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd6f0bf269cf996696a845eeb4651311319d0f211fedc7b0e0c77724207a351d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea21a2da497318b5d2e94fe817ad09b3d0ee9e51c99ffd056338bc4dbff731c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0709fff8a15afe83e742dde29714f384df0468d98035bbff7d1922247c9cdc68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb337226142a1103f87cb5e2b8d3865744679261f9c2441ed33dc0015dd0835f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab74737c5bc8b27ec7e27b13879d5aa9ff301c357ea8a91f1a48f36b0b8067bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10beb95382fa4b6c9546aa14e84d4ecd324650359072c0e9b9346539ae984d1c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6a7a2011b54b1a71cd3e76a98cd33ba8bbf366446ed808cfe44ae77f80889c(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca529e85e6f48adf443ee18d1997f3278d5f65a12c7c1e437576d4a03e89d15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f58901d1b91323c54cf43ab21e073964e72d430aa10e6e8e6f86eb43db6a865(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515804976118012f1fbeb56b62b503e82a074c44fae6a98a2115a7d02d431eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d75438f9fab6a5a5f88cfceaf2aa72fe73ceeba40bc02ca8cda704bdc18e13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6539e685fe4b0578c37611bcc21afaf8c83bd960b98d8e9a471e773f25591578(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7301a01f0efeaa2e75a6ed24ff6968cedd707ef2da0f81390103c87412faca19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60393e5aa51be64cd34f734195e00b7e001a296d66598f44eb47fee82e2bfc18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903c3e8dba9702c37d0b7b0a4e94ee97bd354050e9cfff1a79e3c62a8076596e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2def0e58014931c3fdcdec1a89c2a45fcbd6548293b1020d7d1791d5a88415a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55dbb34de567def1a5af8c14de7f595eef5d0155d42fca3b9e0258c101dfaf3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276d0f1638ee47ff205fe2e9c12d40d1f78bd64dbd08abf819259712914d7889(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d599aa310e63277533d2ca39926e5af3a0bafef18dd049041cc24ff78cb2acc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b711de11b9556efb59cfb8cf20b12f87db2a1efd45d2b5f42891e0ec144ec90(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7d7319f1d10ed39657065b5d4138cbfdfe484a2a74ec518604af578d6413c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa887483372b3957a9f24d7e2a1d5b084930c4024f04130831a3a0e9da2a3b72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226d26f908839a16d94271412b8178df41d731100f0a51c4e1b9c643a8344222(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867e2a2483df9a05f76e7a191076d00d324743f40c5e3fd2f035490772e9e2c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7517c86037b1a1067a4e04791146b3d7f767b39f4d9d92547652502886cd7dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee781d7f70da1f24f67c4eaacbf097b7e82de939be22b23b1e871bdb1873496(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3524e16a6c6856ddf6dd4dbe571b385a51b52d2609bf450543ef323c758d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c4a6842ed0ff24aa707aad6269a667ceb121abe092c55b3ada7c91a4d88f4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57349b04c2ed7fc01238e7609e1934d254f6c76af90a1ffe907b44c8b2b8963d(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06de189ccc253097241c124de2912135eb6c457cfabad99464d9179d526ab21b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34625f55bd65bf3b4724efcd3e2b9a6646c2df3cb39a4829801b7916982e6f7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50fe301ea02afb4babcf5cb014626f04eb7631ba81c494f315f91e76dfcd4d29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fa4a4734788999a397e3ccb95638e8d4b63297e19eea268131aa1e86d8c6cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8332ace7eb2266860e180b00a1c495a4437e1cd471d47768f4fdd491a44df5f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0548b62ba96a43b8b65c94e9c91bb9384e70d025680eb00305e203fd878bda42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a239dfe42a4d24286db81ed50a2fe42bfe29427205e137e82b23ed29c23fd56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f208bc8f6eada43c297b5bc5909717fbf287b3c68bebbb817b466e6da6d6758(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdeeb6a00778fc5fb2033177d011dabbd959b2bc7a8422855085372f6488ccf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936d2c602a895a3d366b8cb0dad68e0e8056b71b838ed9d93f508ef4340a0a47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f34c70a06bef0edf6241b59b1b6f7882de4c6257d3d131409eb10e4c5eb5d4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bf4991ccb78e3ad93e67b556160cf10415df93044e61446fac4cd847cd4e9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bc4b3b7012006cd44850516a3dbc55344161bc84d7e083b26a628d10b13ae75(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741f4cecdb183b1c9051ed32f496575dd93fcfdafd2f940a5ac94ae7f1939841(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4024a1b9ef61363c62630ecb85c9c3a0d4bf6e7dfa5e029b1569aa8cb168fff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8616a36a6074526427df555bc8793429f8acf93e97b20d7b6f4a52054589abab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61728dcae1bcee78e80db56ff68e087bc5d36f638a900b21312061a44cdd39d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d2fec4150b71d0e821010a29e008c55bd43639c8ec6ebf3b6193e65acf0ba5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9156d80736af7547f908ec37863bff54c983f84f3868a2269f3e2b148af267f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04020f4d1b31fe2eb5e29eaad207339b23f2e5a82cf671d67140a9ca475cffdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb8d15d4cb2fb5178b9577c193fe9b3d6ee1268e561cd664799916f6e768968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41a3df36d447c8d7be815093881f53757b02af061b125c4a3ae45e3359f9aac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2471a32a97d4f226ae809ef31bcd7fc301e28020d88a841573d7d8630ae628(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212e5cfb836b4fe2ed7bb8b389e5f710eca4f2e43dcc8563f116998a571503d2(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af03e4fbc3dd88fbdb20596aab5c6c795e63cbd0241c0902b3b99a121b3fbd9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3aecdd0912eb92ebf1e4392d920adc373633c073251cec0bb327b573c30bf4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b37f4c3a21bdcf761bf6a4af966ab375480112c02aad4e3c606691b69e49cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba18dca3e036ee4f63d8999a92a146cab53c9b90507aef194db34a08bd699266(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb687f4dcbab90ca0ce3ad6ffed38b16be9b581a8c951ad838c929e6ca1b811(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9995c960b17d2883859b162ffb42f02594c35b7aa661363aa282ea689283a338(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5cf71105ab2cbb6de62933a2bbbf3593f0d0e83a03eb565243df797029be78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c617139efd80c962cc64782ba57f5a65e5163d82cec839746f58f881ed4485(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f134bc1c4ed9d47e494737e9fd566eb957cd1dd6c3cae93dea113d30559eda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36f98a2eec93ce3a2bd1464de0c58bc0f0ce806452adf0bb68819d24cc63738(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b50bfb80af825e9b53db19bcb4142188d226437ae994605d0bf0e1b93566c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bfd42634223314a27e837bbc0084d7fd9ac4c4baeee9080e6b4c68f578cec50(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a3b7340f03dda4996bf7b3d362b784e0965f78ba101662641e391376a010f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f011de134caa99ca190f02992d5adc6441998215c8acc066dbd1df3bca99d9f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be17d774e78c2e5723d44b05067f19421956e30c9c007ef3f2d009e0c5a12ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbd3133b8334dee5798e5908cb783b8c7b27c0860ec91fc319241a5f8df8012(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca53c58391a7ebba3c26454ea7be5b26efe62f06f5a8c3d6f036cf6e94f93eb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f46f44d0439a28a7e99058beb94b4e914d35b65a97fd8b6c927b16ab03df9665(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a314fb234c2a7bd61e2c29005921356d1d478dcc1199ba2052d7e6925fb9782(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171fecd27cd35fab6e3eb3ff7e571acebec61ded6733c037b6ca26117a69350f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42e121c830fea98318d821493b10e0fed79db7a4a2296588052ce51497f94c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c754d97092fb45aa6a1d5d37d0d2195f2dfa0781b0e9b19f6809d6b0454507(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c281e8c05322d847db181b00dabed033df98e84f42865060819cda0589eb5d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69221560bc72e65cec968aae9949c8d9e60503e3d68cbee9791494b3cc44c2ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87845b62933040d9c857cbc520b0ad18d9bddb236d04708abb1c4be92da3b4a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ec44e956867b5eb2db4cf3023de9c0a0ed32e31e0457203b37d3501a04d102(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d630f5d3fda68c238f1f1ab90c9ae499e47e9111e0d71c4485999ddafbfe4a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40cba01836578c6a03ea6bd31d1b0f9035dd31a9397a29a74cc1808616a16d1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685f6b000ad6f729319b4f5b40739df136411c204b19a86c3aca3e37c6053375(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44b26ca0611d840c1738017cc76bbd5d3b2a05640808c973f8e758961283794(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cbd4ed882f9f1defe024c43585483258a885a12a960ade73f180299e3838437(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eff0dbf05968d349b9da12ec883b2121602da86f619d43da709b0db467eed3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f739dd89d03a1a086f8ec1ee031bb13b97c8e9eaef2bbbcf7d30511ab74bc9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe534925b04e40422d954d7934af15232165c93d9f18fbc323bf6613a5c69d9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3170852a7a0517405792ee3e4fa6b0469227dbb137b1cb6af6632e216be6ba6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4de5f2ef21f6cba806901dea7cef47ec2ef0c4619bf03648dc1cde7101cc4d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa298973268d0cc1ac148d713667aee2940f62e66582dbb19725e77889fd51f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4078a82b0d6ca9d1b14cde74a4d7a7c830705a0e10edbb9e6f9e04ce3e48ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2685d103f65ccfc9fb15588e1db2bbb0530a1945e7aa91449b88416865ff51bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08663f45544ffabb655dce7a37dec0c00c36c693eae0fd21aab65034bbd6377a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72c28970893dacde483a21260177d7c0f7f4f68779eeb53443001e0ee51c0c4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7ea4f701d4f934c1132ef0d4b233499f0a5b47a319149df06c807914f712e8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544a6bf76b961dec640606b56a54b309f5543557daab8006e91ee0d222a0925c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7daabdb81d0c98befed8667feb585be58d7a9eacdc3f95aae7c80c09bb2d5f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea1336be089e28c5d7be9a6e651c812f194c53a5fa76ff83ebfe9ef36a7c066(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5586c5474fd48f825631afc2575b9bc72f2be5ffe1e74c841329e1f16b84084(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80fc6dc66fcbb5323d0d1789c90b301df4a6a81b50e76aaebb05bf3aac49b4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__119abbe07755287668ae99d788a9c6405f4baa61863fc01fe5e28540cb7fb7ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce915765d1aa3c0c6fbe6e07d95a48db2b34e1951a211c1eae7590669a92b1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6690879ea41c6dc5c982674ea1c1ba10a50c900310242da2d6ad20a66022d7ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28e55d3697c94ca9b700ddbee06acf5347a42edeca2aa027bb4d0152a41c1ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3fe7b34a6b62e474612ebfb3330c8bec1732ca050f1bf526ab9a7be3716b9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b56c6b4d9e026439039ea61e98f09fea4a0dd81b2641e911e5fe532692eea57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3801e667d68308955eb6e41fff7da8110c6c72500fed4818bd443797e1e860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b314ec64cf3cd5a47f6588644f410898da8155be0340c1e81be3b36a9bef18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a9c11c0a2d272ca42e2e0bcc437b571a007a20de07c3c0e45bcfb0e3591105(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e5fd95916eac3d70765af629a3cd274098d9f3e7768d5549e81a02a46143f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e44a95ded625a4c1cf4c3109c7e99ea9f10e62f4f5d0627979681d3988218a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72a31ea541e2fb107ecfc9412891b12e32a04ba6aafb0922e9d47796f482a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d45733f35c35c84a8f4ff0b678fd21575c60ac2a11b5dd14cef92256af91fda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f47c13da72b5785f1c93fa375c935fb1a2f7e9fca9efcc817b78b733815315d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e75b2ccf3fd7e5f05ad76ecf15193fe52096fb06f0bdf37525ecda2144a97d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d256a5e04d4bc6edc89c57cfa7b392fdc9032e884e92944cd3176b76d061227e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e483af8ef16ef9af67fb0b5220865d8486d56a4e2dbd0d56914a198625b92810(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc968c6bc3ac107186edd72ae07b5998e043c62e1db0c914f55780317a1cebd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__971235e4072d374e603e7b3280585dd7dfaff44e29bda0a9e4855dacaf7fb9e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67572d87eb31b493df0b83d3988dc86df0bc75737c1cda75511873cf0ffda820(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__754de9d806ae531a648e1cc4f9995e014ace4fa85e247ff42f2616b9417774fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9b1aa839982c47eeb9cd0b2ce8d874c4d789ba10db5c9d32bc8e6e81610c44(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8bc10ab77a8187c870a9b45fb7c291d29d8549576c1a4a944dd5fca3fcd1ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60c224c3df5bac8fbe60faec4ebb0218a5af060d41a672782994c3a9b72d9ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabac393777681c6ff5a9940cbe12262f6ea25d197da19b0f3f7f452a682a333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee730ce497ac2186c0f46e530400ddedd1165d5006306fe6dcd14bd67bb86ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f008a0c596750d22d2681a59e779eeed69cd9b6fc58e233b6b26ddd1620d0e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9650181642a9034f4a1e65e3b3458d981de1f72a977a451287702d17fb2eab96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c417837adfb1712f34169bf52f61e667c095ab5c6e1e05193be0ffd7577a773b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d11c9324fb5d2b615963a1dcaf83023197fffa03ffbdfbe130b3bcbe513fd06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b268dc4d0d3b27cc018d6ddd0380ae3edc8807a19d939416a99b5c0bd53bd866(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d524974c759922449d15b902cc55c6645dd69f4de30607d4a391f11ea85b4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0110a5dc2bc6d85cab68f12fdc6c1f7574c121caa706f909f5249ebdfd15589f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f218bca3e60ac91dd3514ec3e367ea5f3e18b33ef189a41a43d5f91cc8c11cfc(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0249dd9f197e2cd8868fdc3b2ac0375e6385c87d525446bbf0e1c7c1b8d97c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd5a1f472ea4cf54d8182f652575a13f0331752b4c9c9335be71c14d221e5576(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1543d789ea3c2e21643facd95608851663d34a6836f88f29cf8448faa36023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6430e8fe1294b62f339048123593e9506db755f92866e71dca36284f3e04c4f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c2454123b3f0b910e6774c17d39eaaa4ce25711cfc558eaad95dd87b135e21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37fba9e71c08278b9f2247efc9357ac178e5e8296ea332b60415eaf474851833(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b4ae2db202fbec15d8be45599efae85912efcbacd2307c729802b43b6bccde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99ed0321f279de6ff92be53e2628dcfe26b57b657423979bc2bf1be11fd64dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4409bca9e0b2651f976b7f1810b3b37dc377b7680a9b24a8bd9b37be1384d1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0e9f251a2dd4277aaf3e684e639f6d830c9963e818bbfca79ff266592fc747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470be7b5f0e687c1d4d937ef74ca32caa0684d993908cea04779f0b12e28c1a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26186ad1b3d94140429321af7740d8b362e26aaed657222da04ecef2c0c588b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41fd0b167b287c864d6d9962efb4ed4ddc19af2dbea42c16dafb2ec3ffe0336f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73eb660b914914886bded7b73b22f8012e0a0d42df2988707f4d1ea049103c28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b90baa36d6027d7ca0b51152e199ba53b29ee03b51b5c5321cef00e771c0e3(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b643b3764ad60708d349ca7311b8c46514166c5fc11b6d15d3470a315e698ef1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db8eb3c01c3de1d82ae955b2f48a63d424de98880ff387767794c08f6d4ae92(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30a16f4b7a1c48799f3d1aba27c803bea96e3f6cf202011efaaf342f767a5a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25bf3a386297f69c887cefde3a867d68cf10fcf65cb2bef45e5fb510b5cf736f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ada9cab0ec45f650a03f10075af9ceb54e1a60e79db916fd3e1edeefe117f29(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572cafc541cd468fbf311347c67763ce96e0a9766e56aaf7d7d3e27dd22527fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35aab3ebad4ef34662e7c6775f446d57b1f9961e65c816422abc151ca6e17a12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c17d966dda2b4ed2b403ca238068bf8121f5642190320a16ef8dcb908f5c95b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56acadd9200429e812dd1e45e70641c79f179d609c69cc1ee50aa7f1a7a1733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e554658911cd8f45b8763813f5cabe3493b94ad71409a9f16cc6e5414d4186a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f854450b40a3c69daac71985d698f6a51db11864ae13fcc2dad24d7261b5fa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de2e34cfcd871c7cef82237866c61dd81809c634b2a4f3364c68025c524d1fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063aa9603d7d1a2c1bfaa219268a8015940c8cc026d891f71b65f0f708e75360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464c5bf4e66b0ed23f5d3c07a3de80b81444d3d32e6482fdbe8808a05a884e17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58fc9496909bc278a82e9505f497ee4dd7c99e356dbc3478a587d2eae75f5155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2516f3081de17f8940c20bc67af72f9d0dda7520bd39f77d736b4114724fbe22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c57674ecc25d4d716e62482209bf6dc34de45ebaaf8494f8033d3046fa2ff4(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72761fd8e927dd27c7b81227812a3a94764487768548ad56faf6ac15d3c39c8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66591677e7660d88f9d491082206f64145b11a44be8ae5705c518e8b45961217(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29dccad24d3365e57a39c0d181e7fa1aa2d5fe5c78b5a2b13c55e74c83459f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355eb5c150e741ad761cfb5ad0af5e06458a0852783b5632c6a31f39cf0d8a54(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56bc60e65934ab0af9350e1b73e58063363544c6128c8828d78ff3ed5f55755c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af511c51280dc43d0d463a59640476b96edf000530790ada82ee2a7ead1aaa2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774f6318846ace03c3ad9341a8a05df09133019343d77a22a201721ce53b97a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8999336ddc3396c1a01db0072ae2348646ab57a9f0f2698eccf7d5b0e57b1dd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfce4b04a5232d38feb4bf3e61bfcb9176f889cdf8285adf03b5a7cbb48818c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126cb78bb8db7e92167d3d188c0b24574e3e49fa8d0280c50e718a5673ed0ce1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0c7ea40fdc315e996f45481392f491e4c3971492cf006b1920931e078c04fa(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a55c707e52a591c56b377b2d42df7d4a61292194188aea44650656237573d52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__013244632f0d9e3e25f2951804724dc18e3ac37540bd83c1fafe05a74f1d15b9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c994777fa606e91d64cf9a68ea142e847a0c2178a7814e1a42643be766be5ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d3f457e7049e592adea2c806de7785d4760ad76028c3eb195503eba47ed8d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb8e98f227912a0b8a65d6b12820fda73272dee71fcb4c54ef6479e1afefaae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096b7affaa8bd0c2fb0def8543e2535bdb1ebb9f80f8651cc19d46005cb5c033(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7531277527921c420d221547b021b8c6a475978f49b56b74ac99e72e3b59a4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aace9291f497d110f9bbd9017720502e19da67c9f1e879f1d8a79166fff6dc21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60918896a6b69a110c37b5d7b8b4223772f4f4b8f0177d2c247680c99541e0c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd08c6d3366d8273225704de6794403d4e3dd56033af569b060846ff00cbdac9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb3d4367bced4d29d7439ebed5d31e917bb121b303029ba7024bdc1ba77b894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20867f0b2615ea756e99480705cda32f561464a6d5c7f88f0805361dafc2445(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4adf6472b72eabf1f6c7c26f12168ba68d6db438eec0024381b1f8820ff434a7(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74777d14acbdf075d5e0753a7fbc18f31f44ff38513c2546bbd0280cf08dff80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540479051de744c4785fe818218998e2a2583bdb95c9116819e94021af62e7a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1dd134ed052bcd3b85293088f85b4ff374f07cf29dad9b064bd3c2c0428ef3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8240fecfc206fbfb51cf178992444fcbea541cc0b805480c9ccd42cb3b9f884(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0305496290df2310572626a2ddd0902bedbe70d691e2cb7c8bf9c8d04e11163(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ed73dfde69973ba6fb0d34a41587abc292e4624edb1f341fb196fa7598f31e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6a0a70cecbed79dffbe672ca908c880a81241c5cbf712630eccd673d6637a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416af7b260eb9a8938b8e31a1cb0a73fadb9460e0a8d290715027ca1856c8020(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa83ca970f5309758a0bebf3bb9b03a5b57a14e9afb78ff2056ffc9f0b6344f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46156101422216f0191b6fe2a4652060b82abe85c07136c1aa364c870346e6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5328b2e3097a72db5507e57d063e546c47fd8e1cf186dcacf535cf452b270691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67851ee42126eeee92540323a0cff4d4970fde5076485f81dcd4d5b4aa0a6b44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4a6133167caee8408e0bd5891c2339af426e9a23564ce0ac2d4ac99129ff1f1(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab28d81ccf3c38f2d46d6a8db74ca449fbd451329bc340aa9be1724cf76c43fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35220359ca7c539d49e685a4d51cfd76d73dcac908bb0bb1ee755b2139d32b07(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72935a8bbf3b964fe4f48f2dcc8ea8f0a2c52831a0e4973c3a5749abfe50b050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67d5ecb383ef354bd76debd45fbeb983cc93d2f52a36dee8678f4735c37accd4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11053855276e5fac9beb2bb80bbfee5458edfd27796a6f29831a6bba5cba5470(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39030537a660979aa6b2ec5b83586b004440c47a514e226747adcd068879beb0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fad9cbabf7efac98ed7d383c8bbb8eb0a8fdc39147915c6b7bc58e1b6705e8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fa766a8d3e7748b34a793d97ff7007cd3ff1244f37806b3cc5c8e46e6931be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e171a4d2982c1cac96e4bfa7f2cbced028a93f0bb6bebe7355f673c58af2f583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bdfc5b97f480d9f66f9076c2b157fb2d9c846b2d678fe6db204fffcdbd3492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d70ac0dbbb93a204dafc19df8fcdd3838e5d49ddcdb344dcba694ba76f6ec27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d823fd892ffcae880fb2f2d73e40d55dba8d3892392baec6573d7fbf2e859e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df21951b6e81c85178b83755bc183050a91b1cd6b3c6d50b3e5caa517a184826(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44122011b67f8a07717655292ea998e0039ce3fb7d5f2ebdc0d2c5f5a3b5f401(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e258222bb76181b95379811c853799dc092104f5d3efd05171383e67fc01eeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fbeee5d2fc7e43581f11d2547909eb852c52078dde8ba48242cadac63d147a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3184113f5a612e108d2dc458f77e75bf80365a165ba6f508256013f269cab0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bf33cf56b631aa00a8dceb90dcceee6d248ff7b75f7e03f58b7949ba52e96d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111fc052ac170804cd47b5505f65b60e54a9f8e24fbb79bb97c747cf3c3fb193(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca0afd02ade0a63bb77fda3be0a0cc99f9f0d1692dc638e08ec8dfd59e60cf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c067af8b9b3570939105a51a960907451293f68273de4d4f3e878e77c8b904(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcf9ef75e6bf03c45631cddeec6881ebbc5f62881ce266323f7fd34fadcab84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3005cd651971facb34b1530eed498213683252040b86e7fd609b6b68250fa33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb741df8b50f5173ca12d16426d0a46815a81f23f85bdf7890604b0361b2656a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a8a139c62c5cdb584f2599d0c3ba5aaa365ed32b00ab0c5dc5f9199bde0673(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8866f66eedf45b7ee7befbf4d370f127a13994e57cffce1e4ac825967e1ecd43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff15a77c0f723637cde05ba7b03e58df7c0463d85f3e4232b38b5049ec6eb061(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9dca5fbdc6507184ce8f1dcec668ca3659614a362c918d832f77801320759a(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a179e0e3ff182d5fb9d6a7390d1807eefd6754a61cf19014f1f758d46b5ed53(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1619b817beb076974f35c8d3b977e0299219dc6baae3a09a6ca6658fc2d6dc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e306b5ffed3617dfa39b5fd4ab8a30900c34a7696edec7a78454444b5abd51(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a194ceabb703a6b7c224ff8b97abf0d7debc7932a165737f0812949e609db275(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a719e1d127361a8b5c18fc0d2fc34d0da9b3e7fed907766c14048e9a995f78ca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ec27349025df3155cc1a22c71052ec4be78a467cd2e368f37349e9e2dbca93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15b73cef36a3fcc13075abf219578832e83673594497910e06c5e4b4a6901069(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73608884b106d80dc544e4c8f3725df9d79ae564c26289be13141aa4246ac1eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99baa55c306b0e98be3d7a77c75ced1d670e07e02a4303700041be3584c3f620(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e7bd475350d3c5f5a2254fb2916a6febceee13f41949d6debf0ff48d77b4b52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a3c1ead13fc43d9deaa62f42e64ab7a893e2790e600450d76497ba46f5c92a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10928852513cd5471c4a36c8a8ac6e5967441d1e7d8870f8e685a97b77e3b1c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8735ee1406025b5b30463106b3fe2f5e0da55442720859df5aa1b85971da654a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042bb6e046109ba95a68145fbe6ac8dd136861aa420b39523dd7063d62aae474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab4d28e0c545ee9462a85b0060f17f09638299bf0491cf0c9d4566aa491ae64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f79f877899e0b15b801e4b15749286e038fb847ff6c2e7229d3c30cd73a0edf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28cd01ecc86d9b70905b731ba4f83b0adf37cbfc76842294ff6a0ada0348b30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5247b2c5532697ec219223ad50e2a29178ab215aee8a56eaf744af998b60c93(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598e15af827520481ec5f878250973e74635cec0b463792d6206f957ba168ceb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ba7c93a71e5c1f80f199b3d3e1737c7dd53c153a365d4c9a2bc12ff8a638fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04310102cadebb5a02cfee73f621d6e69927c4921b3324254118d0eb6d171055(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587af4d3ce84889ee38c8a4c32b7759d2ccdccf5e117fa3a722abbf9d7ff7376(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c6b0c0897be36f6a8eb4400ac9285e9aa4b622a708f5d6128f5b06f2f7af7e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__affc1395f2544039464dc393042fc848f268de8920abb0d1685c8b6d66660631(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8843950cd36dbe66898a5f9155fe826898ecf703a1992402a7f9b725f77f0e8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed6d55328952a87c0bc3cc6d3b6b7e377d34b0b8c1ff95e9d7f65cfdcc424f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc574550f8d5c323fa3ed5e1668874713d8eb9599a465b1b50392729ca7f2b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d5ec323917164d888afffaf268a9838ceaceebc4281030cb48d04735c2ceb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2a4186e257299243ebe244036d27722ae31b870b4fc26fceb130a79e4ddb58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2158923a99ca7fb6b99fc62af8d4e2eb85210eb7b3a9b39bd8faba9beab6430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a35c955aa74ce4894610d33aecc5c6113d32974ff83a325e3c22d05c052b13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c05f0abf94a9d5699bd3b57659724d34358bdebc38145cc536a463cc197726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b7cf57d772f62536b91c1e9f458fe0405b4a9f46d377644d094b392e4a183b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873eabb71b9a9485ba8f17f820dcf2471f9ba307e0a63e95931b5b84c4b24b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278e35103064581634dfea42c3174100140e8107dc5fa117bae2c0725f83b68a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170d8d0aed6c1e9409b51d68b7b84e69b036b519dcc77cabd37df5283a97b8e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12fd9f182e0db0e3a11a04491e4db23676f214f582e736c81a3165753f8b8d3(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a121a8282de7f59d3a2ab4751d8e9e15ae6acc864116b5e53932b4cb5d9072ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f8b8d0039491350c5fcf6cf2140a79c70ff39eff4430e6f6575657ba456388(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2c538caf8a7752701f3ca417b0449440eae2625b52aa562a7bda7a4de5b313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64bd5328533e001be62a617656b27482316ad5c2c77f7d497e21caafafa40d87(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43415075afd1516b7a723d9d2b9819234c25986921eda13e9c8ba66555c6e00d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc947e7baa99d7971faed3b75b8097e2c7dc69a3aa81ee9c73768f296b2b48d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350aac2caefa644595e1afef49935259ea2365d908be49b908461e9ec1431fd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83743f8aebc70299bc12ab0aff7d2aa2b5b6391a5da27037a273a67138021b62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b47b7578991c2baa80a8e5f2ef93f99f9771e409685e99c0c57df885b550f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba4a660542666c4fc5f1d42ae6ad7455356c859c7ab3593e7850bb6415ee3392(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f063aacfabd8e6f8a710a519b185c0e91cf8fdc3f7287ef6a53d0272ca8b6e(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e502afe219509eece185ef5df19c4f947952300578b00aea9c36fe30ced7e58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d5fa036359a4df152cfbffe764bd44f2f6baa8e2fc2a7f91e62dba693aacf7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84c585c4809e3dfb98310f48432430cb327e8535e1d001ad56188c901b4617f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b9aae2d737e0e39f0f5f34723328fee90c3b57cb4abcf94b3498d8ffcf93a4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4615c5c3c69fe8fec6ca730c7073a921d96c17396c61389337dcdbde11f96e0d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf488f9929ee36e47d8af9141c5185b5cd56cff9fee8c298910de7a4edc5d0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74203c61c874a21876c2a448aa207e71fa2ce59e367657b172e5d06aa18e585b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cb0b34ef05c20d2058eb6358a099a8106225cea15d9d7259cb9df8cc3d88546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7c943a3a27355722462b232675cc07be00ea547912c998700e962fce18b588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9abb371956bc4783c6378acdd87ad9d37bc0a2087d748fd512313c122a573383(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819a56185cead57e024b2c295965cd917812a243acfdd05002351d4af2d28a19(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72bb2fe62409d92ac20d0be8557c485d5916a933ce5d49f87dc8eaaad0cbfc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e536ad507ea1e9f8c01d8692febaaadb6b09da8170a796bb8ba22c20db99b286(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6037849358f2eacba3ff68e57820541b031aefa854747d77f2611151cbe9f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abe4c32b2c60ede870720949099f2aa132ea28a6d6de4f2d35766248ab78aea2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7812da497a1483926595aa753e4e168f1838a3c060329ef751eb0aaa264bf195(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28272cba9e78c68e58572bb15814aabf7577795fba5745f6f827ba09ea17684(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f6212f7260ce4e283ea99c599c9b15086605594d0e0334cf9880330cd21d92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53289a6288c31ef8bc5c04d3ffa2b99dd4d58ec2104ff7ca26a9396b3f7be87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25f4a015d4195fd95f924de9a4bc198421d00340fe54be728cacd9a27a61699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3e653a100dc28fa675b7e8f3ef3efb67d48c5889fa4c8a3181f599e8a5bd8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38005e8fc347d7207229e92707bf840f464d5176d538423c2527dae6cbeacb29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e974f354ddfd19fe8050a215cbf0aaa0bb78529a81a6310378f89798a4b28bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b3d7b5bd0b943f6f023fa1590c2f515d3195de2c6f03a9c1d0d3d36ed3dba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c574c333d1d7fd90c40e1fe7f52156247c0a8c6e3f68cc3e5b98be0aed4143d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5431f7d3752559e577d948c32b6871a35a57a02ea07d9afcf9f9968bd371452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1411bd4811f43d9972dafd26b470c2ced43d696e3266a7a1eb7908c231902fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fedaa8103d72d78242227266f9651e45433372535a063bb817618f33edf72c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1e0b68608e1b8bc547fcbc6b0b93e5e97951260398f0b74fe8781d8509d9db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1361c60da1773ed5e38b1e2323221412ac6240763800608f083c675b379c2d5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b86ee27e8764d5bd796e939f38a80a20b577e2d1ee3d7a7c38ac6bdc47e9562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8625383e2837b62a0e9542c236684858e7ea988fac90e9e9b4579b02fd2747fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1e30417a428541dcab85b112bc8accdf69dde260e501434ec021dec5a01eb6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f89d2999ef553fd1b0c1e3a93af11dacd4b15782c3059c650685acdf599317(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45305f5d18218d2457c555d2a00ccb875719773e0bcc3ba4b8c198ccebc97072(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6caf4f7618b67a0db3b05199238f37bf8188c30670d0fd02aadd4bdd81c6397(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ff28ab99fd722c11ff57523708529e3029c881bf9b11c9de2b7ff59cde8b42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212552427229e84418ccab95a24f600eaa91420fe7f2f18377179585922f8f38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05000e18d01ed792249944e91b21b8e852717001bba18fee367fcdf25decce4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e314efd260da72c5729b5a7a125c017cb7a93a63275c63900be647f7810820c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d6536d341c774235533bdbbd3e0e0f9b769642dca032b7adaa2596b4a805be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a9e865e05c203bfe1b0b12777d09fd7b554b41066844b13127782f6bbceac8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e65b4bf99e9bc7fd14258d8b3eb79f94dc3bb45a519001d2ac99b82b7ffc7f69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a270db9789efe46cd4577eba978851dcec93e0660ae0e714ba2efa5bff3507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e2f27bd40918cbaff1384d188f5140e410974f57754419e7d3ee0de8c47ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722d5be75c77f03a557817e56bb79a70508491d1d0e0c0ca10080273ef4acd79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1f3ce6e2ca58fc19b47a418c79259ae7b7245341cc46708f84cb5c9e68ddbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e979451f99658c8e96f60321c64a47c425a446aa40b9c462af38bffefbf0fb9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077c1b0b231f5d737b6469c3d7e5276c23c3b40e0c5445a511ee37062e6ddb69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1472175579bbef0d1062c306c41cc57f5e7232a263b154e7e4e14f24f60593cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1479e2028ba5b7b2824ad7e8976b9e7ea957a6f8cee78d412205ca43b4d0e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a01ffc73743d1fb944a2b1bc45c9fe67cc4e9defc8f9c0faa6c5bfc311f200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f3e68749ede62f1b2bcaac3bb52f4f991d31de6127abba5c6c397afc46aedb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566246a9a6e31afe1f5d091c32ed36e865b50825a6855c8f70c245fe828d5d7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a862113cf2cdeab7bae2dd7ce9aa5acfa2ab84410110fc16e06e116bbf897b9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd2015b56b6e8f6b59dfa970fea13dab9c49d45f09f43e533952314823a8e97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a932bbeaeb35f2550d67a5d2a4aa7443d970316879b3d3b622bd8c0a67d18b3(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1748b9bca270da31ee48f89ad04cc92333e8ecd072379b8c2f18517e14541a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1befcd57a780b740aaadb66c2c8e9b714ef8183f578fb4e0d24b1d5cf468fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51c93cc058437c4934a8a27e3a35248098fc3f242dac84786345c2e960d7722(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1f493f2cc69b5f5a7f201a553b8a98aba8dc61e96a32fac937e4909fd1ea3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b491816c7ab4b6f2946b4de119b6bde844f23192da9af1cb77e8f8d07071e297(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73af970a798b0d476b9686c84c59951829c22c39725d2f3f588f5494dfad120b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514055392f0f1a4a28400be41762be638cd0ca79ce6d4077e0df0bb40ec76662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204b8ab74e2e179366cb36c7dd8f1f789b3444bbb15bced78ccd7dc4582ed382(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c064334d15841d94d767ee06e7a8d7f4ac64044dff3aa2fe0b14e0370f50e7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090845c0cb0dac399ca25ef1a442774ea5addc7a84224288a3622988a5d81e92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75de51c7318b93e57a40fa1fd97df3d6da933bed7e69bfd864f8bb7ba60d04de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1ae8e3dc2171d88bdd0592b383e677df3287ba23924ee01d6ba8e81385b385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b31e17ff91df5c1af7f4e30b99a6ce8b9dec7e647849194a3c450dec065bbe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98e67e46aa7c599eee2cff55a0b6b5c4209e42e499d77f0d5c6548c5177b1fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef6729941c9b1524eefd2ed69d58ef1a1886d448f10f468cacec12415f1b844(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5d1988ad1ae379af030c6f3a15580ad1389388bd6401188b2b7721c3a4bda1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a92c05cf4ce21f6229a0c4c829b4954eea5e74c6bb275924761bb38e620d44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952c2ef4dceeccaecaf1247b4ad941c67537ad251bb48edc10c56a93f6b79b6c(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__267d43e17556bd34ad16610799346a63f767f24e6c219e635eb360d4beeafe88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12c3e351d0172e569d3792acb3a8c268b87d826652334c9e525d95e2d6420fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14c8a62c8ce89788e3b5eb1f7cf18b1d57a060174f7f63f9f3aeb3b64ce7bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b0532fd5d91b2b25dbc26325dcfe08db771ea671aa41afe96fc7f4f9ba2f7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9e064d07e92099dda013fe38de8aed9151cdeac385d1ac0fe7300e4d145ce3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b219adc59917fa35034a1ea1f15de9d3d2f5c7396e124c3a0a5ca91f723bd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcaba042380189e74eba2868666998c15aec7b50dfa3c60864e46b35811a6c80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da59185257bbad4a1eb496e8b0876b845f5089554f0bac6085e899b57e9994f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226ed6674372438be584410d384704da19795c3d65a8d50646eba855a792ad15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e9a4257b51abdafd82dbc2474758a0cde1e77e863043081919bfa78fb85172(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d9cbe06496533430e4c48c1403d5f97c8512f984df8a30521c6a5c08b39ffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da10a4820d32e904836c052a715ca280a9feaeea7b51f8f39b9c028fdda07645(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf67001867df5d4241a8572ca691c5c2b9d02c604b24b570191ace0e4066e26(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8e03c17b4b50450dd8b6a5be6ed24662bd64090d34b38e727a2e7986d8241f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db69aa73789194e517dbe3336321f93c5a67d886f7d841c4c9a84cfc6174f22b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f318d0d194deda3f70ac1dea86e20158685fed8c584a8bf3b3e3aa8a16c8ffe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708909c1cfe353e2ee200fbf632a9693019df152516bcb26dde06e094768b119(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24645e28d36eacd544197d5b7e246b8d8c6cb630fe18839ef1d8ae7245eff225(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763c27209ad03826419adfb31d7463c6e3054a6dbe2f7b790e553267aca06a20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__681f7b30288738ccba0466d6557296347e14c03b721fd3a7a7a3407e355f088a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412de0e0aa79e9116f21fac4c490e88694adbd075729f4e7b2ed05f7f26d0d28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6975a586b09aa7b14b0f6a4e1aa20a44deea8c523bb998db3a02cc241cd4a716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c69b5ac73a2deb707adcd9532927b10be92370e093717c53e99ab1c39a42bd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b305689086ba57404415978ca9539b8883845ce6434218427b87250f78d534(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9c9f5c3d6c12091ab81143ffe43f97b6aecb62257f161c00aff8f5945a8412(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3694b1a2fb9a46451971e7f500b7e33c9af34dd1111dfef1c4adcb86307ccb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6188589d41e646bbb63062d48a3b818348fca0cffadcc178ef56b191d20d9d80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac2dfdc7182aee35d35d0cc400317d31c636eea3eba2b9b740fae2cadc61d6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa40c169d864160264c3ec6ff2e595a2288123319ee360b1e5e954f8bf1d8f63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888817f5f1b506ac88c036c18b309c06f1aab8eafd31b199a626adcc06f0d78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7818e030a4d02fc522b981aabc92387a38a4dec2396e83a26c2de244b408668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36befe6ec083d265d59cc06b8ba91c8b9f5c8a5e6188173fb7285e1c70c5914b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e9dabb919097f91afea24017c09fc5bc00fbffa8d6168d77b282cb8d2f6a6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775e5c29d1d3bee846c4891fdb039697860238c003168746e3ee5fcaae6c8b3d(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f258911f6301c912a6b1851a284d0e63a48caf1c75ebec93b350c1b11fa951(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d3ed319dcddd96769022a273304030364a52a5d9526e87eb15fea431ad5b8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c9a74cd9bb0f4d7e4a92849daa51ef536594b642a762e5d5117e19bb8bbc50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be09f37e1399bc757fae2bb43d95acc435ec7552ac67f864920631a02cb8a451(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82940e9eef6f72c3df22aecf7e1231054b4e0ec060b0aec40c76e268b50b1ea1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20a535d9da1a94f3c3626bd5e9a8520fd0bc2272a624e6b6eb4bc9403899b34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50ed553e82cb1f24a953d901b81c1b799b5e90001a1bbf8389d56ec33af6f4d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29408ab086614b226a8d2a6200956e4ab980cb49e122091002c5a731a07baba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3cbeda00d62d7b3194cf016e49f773e28699338e445a6c2d768dbbdc601180d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81dc5e29442eaaa37088b322774d858516a78216e85130fcddbea9726e129baa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acc1fef1467d22b7811ba1020a9cf34d16a4a277cb64d7490c72d549f23a751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab2e5258d3af76199413182533f65b83212ce9bf9e1f784280d8b2deca7ddae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97261f43c8230d9d39356da1f7a6230b6d2c65ae3fe187830fefb8430988e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8794c18093307f3524ff6f919dd6ba47d64a4e026a341f38b2aa491e8df831de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ce4c95866fc7afb19fb188284092de19332f851c3b2cc94949a626131acd49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c1a81cb9a657beff05e5c7158ce39e282b0d5d4ae57330bd19df20f96ac5017(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8035272d0c3cc5e3b49a072e1f42fa032dbaae79cb7b4aa07bc817f47b8e473(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c2c79ca284d2f07be2092be1b66415eb6747f97371ed6f0564f039c3573c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca9dc3d20b883d1e6678c29a5dae07d923bd03c67f2273a49dccc2dd4f62aaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5b7b1a05ea918ca277a460bf9631b210a85000923da9b8ec6bf4a6a686ba55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bbd6922352486ca315806bc08b2bbf8790fd9e5d7ddaa07f1b3060c0c725c55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae403f59e0291c76e5c54d6d74417a168b95b2340681b67a67b0d8dc15587c7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac67c69deeeb0f0f0320f69deca3f65b1729623480dc6e44f96be986aefb346(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c740ea257e2c3e2f7a6ee4fdc9c7ac3159b36ee35e6f9267ddaffd5570ccbd2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a99b586a419cf8b876e2bfbd888a89ade63ac5e6dd96a0d42851372e2f77a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1742bb1192fb07c34b2a7ff6b04a110e564d8238b342babb3f343ffc3a910b32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784c96a8b8084c34a414beb6be64e34c42c11c51a3b292f8eb22f34dd49fbd43(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2758cd213a6dc24327592fd5f26a97f87159d0722df1f5a136bc9e96d89749b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fdf5e018d33646fa778dfbc23ade8090098c5f563a4830e65e8e2be3d323603(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__502a847113f1767fbd08ad2e3869402b2cfd5fe9e30b7ccd7a616ba3f68f3f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af60cfe816025fc6508b0936a80ab575b97505a07184885d092ec7c3d907308f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652516a0cd66a515cd15441a7a13088365c5b8399f67fbbd120dffc379cf8e28(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca44c2bc387623a644809552930eb9e4c4281c59ed0b440058eca0b0f6687e5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600a431d631215458811d2794622b2c736c86959ed77e843febf09dbeeb4d481(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9c640e4778a69284640050ad15a5f4e6888df17dbaf7788c3c1d63071fb8c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27454a30fecdc3938e1e420595d7ad732e8fbd7bcc9afe80ea8e607c48095d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a27f414a239d9589378885f4b6939d9b0eac3083891d3f6c3b3ef505626f57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e341fe7e2a69b81e838530d483b47bdebcdc09d62281d2a392a9d35f8ee2a46b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e096071cc0006b07e4b7247544976a1212ac515b4f3c35b3b15e5c57b93b9a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3c3eea5d9551c3540e7fa494fb89467b2b2600c4845601673b2220a5aa5acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e41af1ca78ea24bfcaa8013a482ed089be631688697708c7088909a318ac92f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a611aae074401a99a16e1abf33aa8b2e9668773809e2c8d4414414a5f0e5b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86665615c891eca7d787b10b30257e710d57dfc84832b6caa41da73c107f3e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ed636ce9b05fd9b57ca6db6dd6b9db5f2915afabf2183a5f5ab21a360b3858(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf68e1b6f52cb0b94590994a9663af0045eed209b315f53f7f91b1ecf3144233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c50cd7887226976459ce25b55da480fbcc09b7977b83ff596e017591ad6764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c05750e1ec2f5ad109b7cd410d2488c7d81b187fe86858823de6692c00319ec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1703865b9da72ea500ee680883e7f5c97f840f9cb9327905096678e1be2a80e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb21ef1925271c4dcbcffb3645c4787d19a7964f9e1080316ddf02ee917937fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3df7a183f5712bcc180f06ab0d308deda0b4d1b6033c44c7af494c282e1305e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9ba4774acf50e673a7146ee232c65fa9a517bdd444d1d539755d01dd39d392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a325c2207fa741f47208244b581a570a1128aa98719231881d2376915644fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82dac5010658200a342e964a56c3d831cf15893a03cf3e0fb43bc5ae4ae8fc3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c6b268d683fac87c251efed31407d918d7a5f37f4f6b5a110197fcaa71350e(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6299d93c7712e9e5b98d4ce8e165751ec17e6154407118526ad4f3d76f8de8f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb77e1525d1d64b9e8b8c2a80b9759813ba061722c720059aa8e048a2e921526(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c835ed8c716db112493f7a27a2eab5a35b8fcf0fd732bb19c18a273b4094d6c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e0b77a9002c75c832543af099fa2382cf938e8974c0eef98bed93e3498cabd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e32a0cc13d054915cb6d25a6a54d4d86fbe917479d476fe5afeb374d85a6339a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52007c87a5325083732ae2a53a0aefa945d31564070aad12f2d9584515e6efd5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae14f75de968ff88b2621e8dca9d7c66ac3a1997288579c2bae251a9d19395f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e973022c1487d5e3118344bc916a475f770c8f21621f6f427283e03f4dbb80ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9febdb809b8be7f091c174e0afe80116b3434bd80733d4b437ea3c215ba97d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a38d5ad6002192dd6a34f624e09fecef661c95674108b83647ee81e77d7f60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c05e55d92b821cdcc84805be2263e96afec225e02753f4eed480c73a3a7e4eeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e24f61e500eca5e49e6d8629d5844c5fad91b410dfa743cd0f73e6ed6aabb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732d3718c34ad66d1ed61391f47f8be3b387685a3d1faf23b4cae3e059184c20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e922a119482bf20f0f0313608e16f0c9505bacc8f563611d0d9ddc6126292291(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e81a9930e38e987a09ed0845c73917a23b72dfcf2e0b3f43d4946d47e937c9(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5127ca5da99f793759cbb3539f2961005c8b9f98d07f4eb0ab2bf2db344a1e60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25960b1119d8f4ef87f13d4d53065a1f99145b09a0250f640186423b46ae706e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcac14ec4643995e4c79ed619eddf8380374061208b49096cbd2d489e8bb8e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c504db7796114184bed92a7281f6f600da80f9768263cad3d9e26820874a9128(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4427f7ec9f7a5e306519760a5cadaf107b5c1c48dafe3dbc36f4ca8342d543c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0cbc933c1200adde0eff6564ae325173fe8ade08386726a0bc668dbeb7e609(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d726ebb6b60102b5580f990be60b3349e9dde25da795274d44086fafe1a3cdac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d842a0edba31d00bdf81e59b6a33f1d03312823d4373638ff0d84301d6f459d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6930ed7122ee228ceb0dad4c2fffc8bbd6a8ffec19a44542b4968200bc66eae2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6fe2120edd3069f3fcb8c1b78af04cd98d3028fb879937fd54b15024f4e0876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88559bb5a1bedc40cae81b8e216a8655f3fa5243344d0bb96d84dc70d0fbc25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2334d4de438e0100cde49f2c44567369b0ff9909ff71db171f1c87330792bb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d940fbf42d0c5f56b010276a325ad8bd0d9e52c6ed015e0977b4dff1fe0171a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f231e7a157128f172f1ce66b8b3e9637d5260016c2a326abfb7013a0519ff75f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374c2464954e75a39ed220107d9d765e84d33c848ffb80a80789a46f2ea998f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28bc53c974a45f2c598a283d23af7313f1b08c081c341fb5047c151ea87e80b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8578aaa24b0bae3121423a424ceff369040176f9cdd8a409d0cdb292b37dc34(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51cbef6224ff7e689787d007e39cb2b0562f1af06d69a4d4550d64486411894(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e59965d626203a955f216153ad03d989dd130d7f6a4645ff264c37ea069270e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2c3d7506f720eda6fdd7405dc1aae79361cb92c0a08ba5e59e5ad011d11e91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c5fa73149423397e413b27428dc2b6bf6c4b2be18c666fb0633ca069d932d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e7d775ca4c0abd445678c2ee6560e2077245fce50bc8b24f906939a42a63fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28fd2582b037a8762060511c9cf5cecd8224be2935996303b155d8ba0c77cc2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39be2b82153f5a800e5aae42e988e30ff6d7ddbb04f3f4f6abe818b22599d3df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579a03ef0de4816387ff336b7918e1cb02193e6db500fb49b01c53cc42336ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8e2dc746f7b0ea3053763848cc122b8bc325fd114a202475bb55f027abe45c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787602d4a5645f4b6003ca62f0dd783b54c6dfbfeb7db729568f02411be2063a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4bae521a4233e5f73d23b612ad21eb561dc4ee5d908ced0ca74f80e12b414f2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ceaa0420daa478f98970cbf16f34a64f91e2bcbb2b6cdf5b747b240964013f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d224b4032b5ddeb0462fc358d9bb6096e652f17667c87a87f2df4a8ea78caf0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770b8b442e3a397c04d0111afc904c725e24546a3e922ca11690746b47918cef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14727f3f6b0cbf60b8b0c5e00adaea1db779dffb6818e02df77c145889c30d95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa0094f8f964f611b22377640b68432a86cb58a943a31e22192503a8bf2334c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19ecca2b4141e073718592e8a7a77a2ce6d6935df13331efe0a0385f925dc9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e58e50c86812ebe9e5de1d49de9c5b0e7a56f592141f799c3fb285597f34408(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c33c542230399e49ea9eff2a067c5bda4a178c0b4cb96cfbc6aada3b63d42f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b8bd73cddd67fffcb38de62a9aabe4857c73c43d40b094a88f0ef4aa7017c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45deb9b48dabc1041c77a1ff045ac5e7a35a0ed6133c3280f83b53b33abb73c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910390ac552eeddc73fe3cb5a1167fcd2e8a96473307be70dc2ff80ad5ab163f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9a032e24bc3ec59b02e4c8ba784f8d7bb3efc93fb331fefe69bd9110dd5cbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077583e0a69f17a9c56be193d479593e4af6b18cfdd5f96f0226376baf51f061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8efb1e6945c7a1ac0160ee8330b9d3eaf336069eb8dac841611c7cd9e09ed638(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2ae85bbdb68afb1352192ffc08be5fc10345fce860ea9a65b1a272911d4c22(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb22882f031b385812e1d4e911e9aad39ad0e09ac0b98a161ee209a56efe9ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088e3beb7c1e4965fa822cfb91b51d7f3dc3f5cbffd6a308b353e8be0a6b8388(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda41b55b62c649b468578754b14be08078e09218472b9c3ef7c29a5f17e9eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b6ffeee9f31eb3b11d32122cb295e39639bb3d49554a171fbcc0e77fc4fc625(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dabe0a65bddf45b7db7ab4ddefceea7607de6fd9bf46a29e04e92eb301c5529(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d39f0c54e94d287c07ae9e43ee76f7ba2eb2ead9d8497d226153b4ad259b6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23cbfe13a61ffb507faa0552bbbbd0ca6d1034c7668e164d69250c9d5ffdfc81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9f90f29bf188fff489106dd19ee8efe757b4fc4cfb11aa31f5fa4e6f3ede90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0882e0346559eaa4ca69d0915c1a17349d51a8c497a1c03743e83dd770a090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5d0a2e9e1f4a9a9c39a77db875c91ce284fdc0947985628f7aac5428f12a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d53acdd7a8448ba01279e3849ca9ac55690f03c5559d6e4e48512d325c53391(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ea8b973ce3f93a0cf949fbda7c65e905e688fde3b6e2ad5de112a77db6813d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6639ea9119c12d966180405332309727f4e933372d0a5725c58c640c3ea268e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b7ae2d9697bce0d70074c9cc558de5b065912457fae18e8e2c6362b0c617923(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292c121facc4aa6c7e485fb849552f28f055f4690fa525b855b8c5c450a81426(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5795cc34f27c66021208f8cf2edc9e5510bb8161e3c56040e4a862752b91542(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef5bb0ae2e835bfbeaba67beae2c5fd9810a818dc2782ab0f53b2610703d5fe(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd1f050fd5d8da79f3c64308789b3bd89de53d13b61f7fb40d254c250b5bd0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7db84b0ee2fac679b9e465d2d1340e2a2f8e8f6b5d163a11e040ffe887c1349(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1236ea3c9fb647f2056d99ddcad7d4508783995e697cbb7b46e91f99e669bdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96fc2bc5f3ada1f9a9b0ca1def0f4609d267564bd040cb3314bd0a94791a759(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d1072c251d40885ebbdf3d3062370a91f3fad234e166010303e09a8410bd0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cdf6b8dd54eb7e266058d3178c81fb7ac1e1348962ae50825342cf2a2a54398(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8fdfe40f60546bd00507fdba2b43abfab39e9e479767962d1376eccd25b6bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f48592f7577875fdb9366c15aaad8df1916038a7e49839682c311821cadcfc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dcbecbe782917831585fb26a5872a4dc9030f5180b766bababb8ff4c0fe8532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12278cf720e5267a525c54f8e4786a62c1bd93a070888178535010f5c0ce0e11(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9cf37883249b1d6a7f3e30a538a6c0bd903cb4c4b55364675425a0d32d1887(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0dca66ddbaa7ade757a1a769d425a4f74890d7319ba59d5536960a509ad0815(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17a6fc1449a466e203cb077cff660e87f92cacff458a601539aa2b649505143(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0b273defab6c3fc80517716e7cd2091fde3d558075603e1ac0fd5eca2fcf4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec7762e382c3d327fa68b3f50d7fdb5961125fa9040610b608645498f4bc72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9539fa904b87487e4e9868dcc02abafb00b7f32075ced1995aee7896f403ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26031a3250e5b23d2191082c7fae47a188f41c7b56055a55495f1f0fc0cfa55c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b0662970a60711155edd657dfc7bdd109d8b8320ab7defa3a2f7f30563756d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48421246f8cec789e6745c489c8b25053d537860b6e2e46c12b673f1912fa1ec(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577a0051f83860fbfb3b55d44fb87d70b5d50c9e7d834fced6472a8bf67e9692(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbc6dcca949ea47a979ebe5ccb96a54620fa3f99b235d08c0eb20819e3784ad(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade2506934127434844799e51172e0e6174ad416cec3ad916f41df91bb154220(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba7631193d68f4eace5c16480e3c37e332b8bd8e32dd4d5662b4850ff012412(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d388afc02a637fa3305d042bc2eb0b0b04496935399b92afff3f742e1c88eef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47770a384568aae2228a32026426807d52880c26779c231eba318aab5808d6b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5faec7e03710df4c53bc6d239f9269ea721eb2b6b9e473456118181aaefdd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db691008719429502efea7688e3d2836d70c378931267f4c2ccb7cfea1d4c390(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a64e3a6fd6500ae2ea297330ce64ad86817401ae35a4b1872519f0a0e7e421(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__641932e67629d069344307994a0ee1c3cf9b9f29394bd63fdafa8c326bb20bc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c737d1f06566bdb88382f70fa5eb130d594ee173b3da8c65fa7ce0d2e285d302(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b265c08f7e7f1e4f757a10773d08f89f50a28e97aacb4f866792f0761ea199(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af24c322fd1a95b39ecc9634051d51fafa77f3afca474a54860a60649ac63af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a087d74727cf52b8eb28b03d5b104051ebb237270247de77d3f9a88156b606(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a1fb68d990f37d47b2653104b90d2de4700170bd2b84df3cee5928d0fc5e51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__896e6a9a42c4f3e7f246a1e7f91ac6c33f11bf43f4aaf09749277ca21019ff14(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f81342e0b2ebef96b472c87be4b9bf7dd5a3d02cb3a34e7e2ce2168b158e9b8(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33247dedeb514903b7e4e55fe7271d39a499435f29e93a1ee7327e1e40cac03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9356667eaefe500641d1c991b888edad637c6607dc1b2f0aafd0697a233f0bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792c279eb7de7cffe795fa76c28199d81e9f2c8e3d405ddbd1d504cf3a5d63e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27058ebfaf164b5a6021ad8ddfc376e65fdf3541ab61585c0d417c555a8763f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__712b7d57219697b2281e7a4f1af504a83be3bef22c8579b586ca3315b2494e6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab0d465907fbc13f7257361c40e646332eacd6e582473cfcf194cbe78f30568(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7228d8ed0e783660b313fd61729bdd460200945b4ec74756475c532db053f07c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350ba57595ff5f2481cff4caec18f1634fe1a6d2d06b3bb8b72b7098c8e49f61(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a91e4792d7fdc4ed33bba519a5420e7e06737720361a9b82358108c79d400b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e0a8fa7b0908e9c93550a4823273735bd77c748ff6492c92ca86a53c3dbdbaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541d9a857866bd9fec8f4a2c05ccdf0f60ca87d0ad96de5c0d57f5d74f582ca6(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d0c3a7ad9e9c88e84c5c3f2d38f62671372835ef0d73fa4088d1b514e738ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2582efcaf618f8ac30b9ff6bbc734930378d2b1e06ce4e3e4e9ea18bf488e3b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f70a4bba1991aac46484f1015ab30af607ecf2daeac33063859a5b2a864c828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ec93aa8347c39772ebbd0b7d6070541f37606d9cec977615222a25e30cefe0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88abccb8d5325e7c9bb128de44bbfc5d72bf190de1ce6665a8333be076b9a6d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c8c75644061c58620aec5dac8886de1cbee2fe775a4b69b983cd31f656ef77d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b834abbf525b554bb5269cb2d23ed18fcc334291ede6e15fc76a3d96a3dde7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8815e0b71ac781ac8764a185e78b5ceb523ee4d2770e45af918512a1ba337dde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0e3ba1619313baec95defb8e67c9fd0a32e6348588f6a201e8ee8d0e001ace(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7421ae7b9a6fe1bc0eb03c1e219d645c673f6c318070da8645d3469226a87c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3059321df5551b673f73684050aec03bc495fd7d177109e65c9d1e847dcaa2(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9682ed6bdb7d9bdcfab963ed494e7f99ca6530fa92d2a6f84b12fc3b6d336f91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6414a73e154dd73b9b79341e2c7cc36703bb68e9bd22ec944910f8843289e2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6004abfa0dd56327be3367be63e79bf814538ef192d90568520755d6c0f15490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5154d9bae529d2fa4e482cfafb27675133a39af0fe43fc581f203b5c8ac638e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5084c89c7fae259bf6399d6d87d53043480564518422133d0175636a64379b08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204aa5d947264e7aa4fb4090ad9d581c3ce7f2dfdafc10b846902848f9d80344(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3468f893ef25f71f25268e150cef756207c0a832faa1008fc19c6755bcc31f03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141dd70795594e22c306f2d99a45e01aba03e1e55e5f1a71c9338b1315cc94cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57445422956f764fc99d39d775c7046cc4c830dc6ff134ebd4d4986ad2f325e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e62a36d86025a2a743d38c93b65496954fb033b23ddecfc242be5f09dbffa667(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66739daebd631b5b79011820a6583dd86d24fbf7255a6eec22d736314633e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b2854c8b28deb92ece411b046956da976a8ade25a07db24dda12478ef39e28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8e3f2cea35e596e9a1c7eeedc8d48e70dd8fa0b4a6aaa68e6b5efb041f7e66(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb9c838d91c815e24c7887ef63f7da8782d96309af4cf78e17f3c0b76654e88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950c0c0a2204d03c8c067da67b4f611a553f968bc0fcabc68144a7ad14267a34(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2997b8bb6c23fdb5034b553fadc6e959fd889455c6dfb7937286270e4128bf8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22c8293079c473ad6eebdf240e555aa7e051d15055ef008eacddb58f371ec42(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b86e4494ba7d8ce033174bc62dfbd663070a3beb98cd7ec82fb4485ebf19f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03978465cfb6704e925024edba613b16c18a66d1d73154ebeb263135b0a3a1ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2669202d1513fabf3707d2a0a10a11a1448d89c9e8bf3bb9c1314b907c5c6a2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9d3aedf8df02b3fd6c5075e40b2e1e5a04718356ca207dd717bb6308bef6c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6094ba7156c4f1ee9a6a283a8375de391c005499225af723b89d6f517999fa7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f393ac45b3e09066e163033e418b5a6b35aaacb454707849c29c0b108a37f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84164f0a00abfb1b443c91c792ee19a4ae655ef823b8da886fe6e72c362976f2(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d16e9aa908674e9baa4150c98de5698d450985d46640f90e03108f0ddf9a9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80dd1eaaca4edced0d4b685b37887f9e118650eb21610ff288d4bb6a5e43d84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b315b11dece8d83f25c9afa66c59e486b4d6734e6c475dea5a5f6e2bce83b94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e0c357849cea9dde6199c553f2a89ebbc5d4c572c25f9e471827a019f2ea48(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3c40ca9a1a49b1ce97bf719e949803cc9fc22e0c2136e52cbe232ba087561b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948d4ccadce24a7fc7bd7eb9a22e2b73d4c5aac8f188327b9655f2a568c0da13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c30efd41671547bede89bf1435422352b7f839b5739c60921312f8073cc9607(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c32beb60c23cd2a48c973db64c0d3d1840986b819084dae9bf4765e5166ad5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d1e179b207aff98391e9595b9af598b72caf3858e8bbd4a2e613cd1de5d5c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc79780b765a1060c75357518414bad7e388ef840c3e4e9569e30edcb58a9979(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10de5862f5ab253b8e97fff9bd7f28834fbd4b98769b868322f23d1f62575bff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a58c4e0f2829ac42d663c84d49ebd316b13140d2bfb3a5d18e273be699d191(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28cb424d0fe75b20ed7cb4d91c12754d4d362e45eaade76db8f1e05404cbb4d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba0b085587b8d720cb6b7df922a7beee1807280f57b19a5b603270cd3146f45(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1323de422a2c16f8e372e0649ce4eb95fc9504797fb15f2289359819484e1c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d0094209cbaa8b35c4e93109ab4b7c7121f22bb5beb558095490236b72fdff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1fdefc3a44881b32f1e5f8c4988cea875c67c9f73e9aa094d48133b62c5d48(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7f4b94ef390ee113be083d713ca08f310a6667a1aee30244ce8f19b293a8a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeaf2ca157c558297a99baaf12e2534563b6771dc8a0e2508dfbefa420119a19(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caff5fe7a24393b7c70aeafd83f6f79bfd0820af9fd40c22e32ee80d8018c08b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4163c6de37dfe3c60ee153b3c1e6315bb1cff114c86ff1a2c8058676334e13f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb7c4bd8a203ae23834e24e25b37eb0992908d3027920fb35334973c624cb48(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7062fb15ea3f6f37ab72ab6e4b4268db6f32c49f6162cd9202cf27125be9e4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5848cdee3ba0c7a135d077ad293374135e929bdfdc1d3eabe3f4fc54a66f8f7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9cbba68136af047df2044780b749fa2feb5096b018701e8efbf42d21e9bd075(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad60a5a00d91b0a96f8b532f0a48eb30ad2f53b675653a5cd52a4a5fd6beb71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80121007df996f7f8e8340a8245c427ebcac143c447ccb0854f1c1217e93106(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0dd9644f824f99f985ebccd6293f51024253a73698756da60a1b7ef41386043(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489dae988b247866abf274d21633db1158119bfe28fe0bb7c4c3dd6ac42fee63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b93149de4f28ac22e3d5eed7171fceb3f5c9983b27a4d074a8f7edcb8b89ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0009b0fd1294b93e7704b5a3e07fb129778df4f2a94e6fa688c06bd3d85610f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0779f0d55537d8239b06cb021fd40547ddb9967b5c5f8b48a15f4cc683e487f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca72c7edd7bf6373568057a77ebf2ee239d6dab81b3f4c2c01da5dc0e9d16d80(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0761f509d3ae06d2b34f62bd766044bb787d14270e9575b112163e54107c0d63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc701b11837a45ef62fc944cae447c3d0fdff40b45648b0c91435a915659805(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a2307429480f9aff9e06afcca3f7cd41c6321f8d0cfa04b5c147f2d94f7e33(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7d13bad738b39abcdd316eeb699099b50756ef7c55c56316daf4409044d61b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257b06c6d0c1d775d35e5265c99c4a8f5b4ade896a5fc785b8fc8230658021e4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193dd1292b273f5162137786cf52e5ac6d01dda6f87aa7c41ccbb23c73b66e4f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052d47eedf26297e03e503f5a2188582e50d43f948f20e327f6595726bd61419(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed7452702037aa2447d10cdce628bee401b36ef7833f760516d54542d4321aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7edc3c0a20fc9011ca68a8177a5c9dd142f4c6f929ad70e8f2b4641b038e0918(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c51b42f950f030bc33890e580faa170b7831a6649b914a7babcd900ce87e986(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5f61743c550f90f35112da24b887cd787cab102ed1882ccab1598f84261527(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a66176fd4f1324b0a4c59def1b11aaf3e17e64ebf1aaab2d6ebef701c5e2420(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dbcb9e8b087bd674734c5accc023e9c396acfd4f5a7b13da512875d43a5ecf1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938bf96e685b5cf64744da3f521906fa752a4666dacdc4342489f7e0782730dd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fe3b520afe8cfad941aeb69d24035d57e47bdb09f15fb05f78398223f34006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe248b60f2d2b6c127eb2da50d7d12334927a8f3d87f66daee041d830e59a95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80074bf1902411f201b0b51f0c959d5002b6fc150abcefa5d984477f1dd15f01(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f52f3d8cc2148c04dd09313464b658e480fbfa344ebf7fb87acb43f6deeb30b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a50eb23784d09e1539b614c63857aa844496d44bbeaddc540dbd8eea16ed551(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1c511b8a55b92f983316fc8fa60209322cbab97cb05e63e6eca20805c11f92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac5ac57bcddfac72fa7045a91bc1a157f204518b51864f8621dadc49c7cbc2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b998872e6afb75bbadfbed7490a929f94f95deb119e6b5a6217afd0a0ba7523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19721673873b74012a3a6f0ab075ec9cabce56359ce65609bf435b1280e7988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908349f6f820889c7275a06b6c018ff6ecd28c3dc718d30f1cd5d0201d1d5d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa7b44c2bb3522b03f2bd01c6d839173a635f3ec0380f367f0e1b17292bb6a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55298060f6bd12ce902e1b2d039407c1cb2b85f1f19f28ddce9174122ed48f64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1de00abe80e93a30f8b68ecce401bd6383f513256703637c45bc8bd0a462d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b5b14a819ac1287f0a375a122463bf3f2ed06b06b95a0d5aefd68eb60c8aa9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7110724bf5da3c123d626b8a35ea07042a0a33c1d30f46d498d6104d994b8f52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dce4017915d35c7e37c0aa522d61af80ccd7ac61cefa84c27868e5f49025586(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef5830ddbdf18718889d959a20d56d0ad7d41de0a3c8cf5ba0788f834791ccb(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b37a09cc19ee110e128dfb117743d8ad593a6af26b2b21b989c2f254e01bf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88763d670328118d453dd64308a737a4837867737a2e93dd364144adfbf7b1d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18bb6e0a1f3af65d06c38a31a110be955a0e33549135d73e6738e207c3e7a85b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c995fad9ed4041a7e35db9545279505438673942aaa1cdb24bd1d289faa70e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42961d76f3232294266194e2ada39982c464b8438ef9400ea16c9c7d5187121c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac5c24fcd2fa878a4fc18f1965b85a9d22dd7819a68b154a7205df17b579aae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3988b991fe673892259393273de1c0d072a95d7e16872e56926a63bd614239ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cebcffd71a7ac1f2dd67b414e10a054966b117dfb2e9cb2f82346a909f7aaa0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e09cbbdfb3922f254b4ddda7c23718385f3ede585a9a38ae3b5390f78288740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab782b99be983de338883ac79da2f7611fa4929703ec487a5968c8e908858a92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340f7113a696a303cbac57cc768e963bf08d73c9600d6990898227d5eb303c2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242e671f68e613d3ee06b2eb2fdc75b2f9d737803dace48069a1bbee2cfb5045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2470d0051b2da447bed8b03bf132068f7526c88f25d9cbc89aff4d4d1232cc77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10bfe7cb394a8b53e316d98e7f4dc01f3712f31d3e7278dd3a958348c1d972ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab81f16fbe8c3df330346a918e42cb1ad456d1b0920e459b4d7bd9761b059c98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1be74b4593dab1aba69539d0c73867b1dfdb2dc9b00267653e342d5d22744c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__846864c6347f06e47263667ef93656dab489647efcaffe1f19ccb20a387b47e4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d1944268f94661e28b46bd8452811485909c073a2a2a57d82733b68e6dfe0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deecea2c09150d530fc67c3e1a1d8d276abaa79d53b3f8f517fe0e80662217bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b306fab99998b5509d7d73ff1308c28f3664209c760773a32c06d567a3ac6f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125a43a60ab4523a31ffc87282970eb63bf530f8151abdeca6684a64488326db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd93cabd74aba608b2ef7cc19a8c81c6d2ef9e7569cb7cf3949e9597444d384(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6f5732947fd95a5882da319887b2283282a4ba23b46875169ba3922c98bf09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07124551b921c13e74df6f3d46f0f4f5b1ebc659342c3909efa63712b2bfced2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4860aaf9c82d6aba85eefce0d063efd7730f52e0c10ee35809454dd5ddc22b0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a342ac8ab032dffe77a06d796a3fbb25af2682edae5363bbf6c7fce43f636592(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ef3c55b57de8c7e7008276372e54d38ba58b6334f750e65e788898db19e250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8f30a27d5b6c7eb57d1caf9f359fbcb856eef83a905d2be617e3d3917dee6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4171e90f865e984616218485ee67f58af586726619765a841d4593f0bfe516bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f5b67fa47dbcd17525dfae5b0004f025d813bfe46b97f8f15f5bafd915beb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bde57c4dd0eb8b13b9ff86089f338f267f9461ec9be416150d1872db1a7f08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96c2a721230c937a289a6b2735481f5308757b3012f4bac1c193f2db0a2d093d(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de8aab45049adaff6f044d94df2cb733e1be62940c910827a6f9e0baba0e25c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a072b6784484b11376fc4cf79959905cf783d4cbb5a5b11c2a98d1fe2bd707bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e732ab0cfb168b7ebd005c3b04b331014a88ed89cd688ffd071cd3fa4435975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3a1ffaecfabd0bcc8c26b108b90fd84755b37f517fcf1726f2bf8d4ed3427b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6619a02ddbe5b1b698e53cd5b26fc96328b8f6cf6165846292e828a22ad52cd9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545ad5fd55f7feb9602fe4ab0be6dc828717be217f26f6afb3e7a6a15d12f6a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9efd3eba6033c4240a203d29249a12c1454664551c3b3653f346c64a6997b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64419f8a033fb3bc1f6ae88e080ffd029220f664dcdc33a34bff8c7ae25ba400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73273fa4ddb37ce2f109e93824f3bfef0539bde198cbc5b89fd369d70ffaff98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0152eb6a487d6b3ebeaecb9fc19f6377a7935724ed2eacf21d2d01de56810701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dbfdcc933df4be89abdda88a386b9d9ccfe0a36c481cb0ee43b7dda4aec66ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90476ee6888d0501e5b9f059f78cc709603237e94edca7d4fc109331e7e78b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f888518815c79ff334a0e3b5b90dd7829284ef700943e9a73e74ec120e1cbc44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__accc79b571d20687dffa13badfafeea60d1e98019cbe09834fa7b1d420662c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c386a011f79a949f85ab35efd155534b696e51d11682e900702985ca0eb1c7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6250ae7ecbaec9f2ca16ded7a207c081d0933a7f2211f7225d30cb12d96e82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a6a85b569c4407b4ae811e703e3c8a979c0b332d7abdc69952c453ba8bf859(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf631a6949d5269730a888e5ca466c338405c39701c67478b52f2f3a2125608(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327ea37bf578f21d768a738e07de1ac6671e550add2c6f97a65d0260ff656327(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b399e462f14f9d94f9fc6a5f47024554b850c8884f006eaa6477fa28d374f7b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c8d02d9c8c2168350180c3828a711df2fb7b425829858a44180b2c811cfc7d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f9a493ece9a5c91c1f6b4c6d5e75e6519a4185669c6563409ceb5a313b54f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d40628babf7a1894d813c03708c3f3d102f08aea413dd038672628d71c9c48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e42ccae32ae5ccea6d601f608b121cdda0d56fae1e7de6a4fdad865f1c7c553c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9637b819ea389b5df79f9f7c4c87f1e384778fecc2ef83ec465107923c27102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc576bafaa8347e7d1b6e3d33c78b8f91996c1c1dae25ef2bf8301b0af3d2ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f84bb87acf81342a78c4ec787a6b7794f2a5f7dd83ecee5070bbfaf65e4e63d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3185cd713f23c8cc3557c87ed21b328c2391ea5b3a8d1f11c1df5d7922ef622(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52308f90a7c858775d356b75e4e92a0871aa6d9287990ade1612de60bde1638b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364965eb3c8584d9e25da4755c51091c0b772d123798ae781fdf059119896d7b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5dbfb1bf1fd98ba9e8a6d6c97fe078f9ee7e838cc9e64e584e93ad2b1668892(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7977e288c24b73cdb1de6284167005441365224fcd28da5773dd29c4456c5db5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcda843a1ca328901d6e59feba4d62d634972c2673e2555bbfdd9918ce5896d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebac0603747e1a4c1346941f150a4f4196dd93eeddc4782d9df09dda3ad37081(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f288034d57dd0bb5c6922ab8bebeea899400319e384a007fe0df37ac9bfe607(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20203cfeb7429d03446a7cc2edd733c9edbd270ce4deabc630372b203ac407db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2442831a8cf42a2815d5f7425ee45d28d556d2b3aec332f6e379adfb558e9eab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a002bffce01691370c1d420fff95252c3e75e1c5c9a3904e8f8c81376e590c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946b122c2304c5d1722e6e61c6e8f0d858c8b37915fce44e4222c5237d80e555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7d5244e6fef2506d0c0e5ecfce173618f58d7663368547d1c674f75e9b35e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e3fca9d55ca0fa67a085bd091d19a7c946c2adce7d195b68a26e511f038888(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c1bf9c6752999b3cb87d1302b0a5699d42974ef5342d7295f3007528063eb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18cecd9f6bbe78705255e2e19940622839f047192db1b3df0e749dc492981ad7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1ceb83599becf5ec1d2b7ba77d3b39f91679216dd871f272a8f5895dc42c61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a9701ec5b331e234ecf5ecaaa60a223dd3d636bb99cc54625ccaef28288bb2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a95d40954758b2bd6c1ee25dd2592f9119a10d685c753efabec05b0d71b209(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__858d2c4ce9f5b5a11f264f99051fdae93a37312e6acdaa142f40a6788de8563f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909477a3f35c3132206801deee79addcbbb9cadc4975675e1ed71eda93814b05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a131a0e0db8f0d6c3556f21e5a59ab88c2653659272c05c92114182e9b1e987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ade812e708820914739fed3f0d8aecc4faa2f10aca91456f251977d3612b8a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169f415db9d63965d0481ad9716ce15983fd16f77adec88a01da22635695c307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43cd6b834607f33f48388eabcdf37f52cd74efaaf45e9aaab9b3b3af86b8f3f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7641ab22748707e16c741892affcfe6f943dbe7eb7d88ac93c6dde7beee5e9e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ebd0adf577240675f04a8acea2999db704943e92e1927a1f48353e3b2b5453(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc91aeffebd8d457c300cff32590378777afc9e7fe7ce97393bf0288b702dcda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29cbbc268c1d6f95142913327713a292f8a590d9791dd0b168ba72e2ee3c7084(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6edfbe2cdabf85f1bd17c55bf3f8355377ae692cc1c972832bb22cea6511ab03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99a1a59b7fd42ede9f2a4c85d5aa70bef51f3e8e940f7afbd342c8909dd0b4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e5a8883744fbb30329b5930cd0a920208bb88ab1b0aa0efa6382dd848c9e1f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0797952251ede46180fc862be75f3dc6bf75a5f310d4258c4c80301b26d6abce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725cad7477638f14d042ada75b8878c7664c14b19e8b4d08f3058344ad341532(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ae5710eb4fd8da8e90175eb8079332b59be2f57d6f91831425d762cd364de7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d6bbab46035426411d6e213aee422212aa20d12676a37977ca750ce66aa3cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086ad9aaa0e9bb54bde389d507bcb3696354223b1faed5f98f547c3125550643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871b27dd4136c46caf0cee0f5bf0ba73bff0f5af33bbeb8aca2533054e68c53c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109078ee7b49a986a2a9f41bd29594f20f443262a3a94fd9df92c6d8cd3c7a13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f325c29d188940a27a9da0995212701cf146da44b19f3bebdc17732ac51484(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__394c44efa685d0b727863be90b86672ce9bdfd883e106361f418980a1c60a86b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc7ce8862391dc41ae9486584164a72a9be1652ebe8d6814850a62fd471b039(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19488313d6c3cb3f2cae5517cf1a276e971188e7c627b015983d44cbfb78db2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bdcd9e15573af25b3ac29b3e757d200b501180ac6210976e6614244264cfd14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__390b2669d5f2c151a86c6d08e5802910bd3f68176bddfb65a90d97079c861041(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facf4099d74a32f3fc7ed4f86c0d4bb6da5edb14de4e7992d34753db3b437d28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a1864e6f60d19b6e59f9ebc6860062798fd546607c1e31f95cd74be61b732e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a43ab91af561775dde0abdeeb3c0ca0082a4bf719bb94e47760e747757e1992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abb7877247ee5ed490d3f4fb7fee351d398bf7009142b41cb9507b455dca201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c48b276fcc0361742eb679a4ef66526ee69e5d166276539009c5d4f880a5129(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86549e45b5e149f20e4cade715914cdf0349d83935adc0c1a309a52d84e5f5e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c086953e4c519e94988668371c930a0ef95fd563d2a856305edb1100b84e576(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4261ba1ec4d4cf73f612d8f634bb65e776b3abd3128f6c37213f692cf5be8881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c210de9925939943f4be59b60d275c4ca5b4ed07ddcf6b39f25ffe1f0326b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94307905fec899e0a57381f9207da840c54795e30e6bd5fef227f9c96869b0e(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__880841aed7e79876cdf497114d61b53a563a77748eaf75cedc597b3fbee545db(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76a449d6f267ca1b139e3d2cf4c6726a29ced5e477dd9ff8811c94bd45fa801(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53356d57d413c5b8b21b154ff33e1f64a88f491d83c62296837466c68334968e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4639d7e780206024a972659901ff503c2229360cfa3d923cac6ba40736d9ea4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604641e372af3edde61f3b605006b5dea180dd90d26387022bdbd36a357af263(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5143f30b425067a480e99190fb7af0bf22ead3668d03d7d6f7df21a5ccf4cbb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c587262af6b2bd216debf805f3bb2b3acb46292a8ef82c124acd794b77952c16(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a12289f1fd1ec1d2d4ee861fba01a4b2a649a0ac7a8b4e29e07c9e72a6f6c7c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385c711136d79628d66aa8b676cc1eeec90b333bb28afbed5c827208d77c9223(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426f6ace2ff34cc538707d5c2d09f0f0eff000fd9d64408cd5a4e24b39892057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b859b5e7752bfc9af943921eacd25f3a9a4511b3bd0c3836ebf832ee554cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96117e455f20af6cc695ff5636bb61a17d136aea78a8cbb8361ddeaed241424(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8b6ac88e25628c3bd56f4060102b8e1dfb28e29fd0b6e9a8ebebf3f590c66d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268385e759a2477fb42d49c9f3bab17b6d5b0a31d50d4d13399712a30b3067ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3314f6ebea4efa4b5eac4bec6de53b0e89adb2e9391092f5448d4e08fe86cf11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b103ec7088bc3aede5de7eb8079963c5a75c9cbf676d7015fe7bd434ed2ece72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfa85dea4aa5005243c0853ddf49c911bc7e9f1b99df436fc50df7ab686baf7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1be89cee83e0c67d42efa085fe04528dfee623535cd5e8b17cd1194acacdf7(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3c21ec8b1d9844d906906c1691348fa8c61b28c9c06ed4f8072a9318f86415(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a575454669482727c50b93fac5e9c160739f09f589e067a3a5ff1a42b42c12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8b7c91f31564c21814d9e7e27496adc3cb3a86efa57ea57fd6ddb2ef1613b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c94d3c0c1e29e1af5cdff1de889124baca44e02a92b58e783025fe82afbb8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e060a029cce3d716c3dab235826761f8a45ee3c874f2c8131d40744d1e3d9601(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cad3f4172570d02942eb7cba473a7f93e97f14f742b86d0b128ebfdfed1a923(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b738e3cf86cf07606737ec5cc8922faea6ce3828757c39262c5acfcf4e1c5b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc223a44bde05ed1421c32565443e8bc90ff054209aec2d7082732e3e0a514b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82413eaee0b56e718cdf8cc13218f4a9fb2ed629a84e656c8afe72c604293761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bf590dc6d3d8fdf323aaab929153cbe7411d77d3cdd59592258aa2a762a773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09324750bd5f70725a36875520f5351b26c45c3326db24c09c8a12187b00967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96044121a50260effa91af4f3f38c3b8071e2b687f7e964432ee66679a28ffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c36a70f5514d61c5e017d805567fdb186d3fc0ff6fe084da4f69b5db95414d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47da6964347e684dcead78dd519897293547a0f82ef66ecc3e7f5800a145e38f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c872a6a0181c0ba5ca4dcd2654a87d5da5c25492eadb715f12ff47f01dc357e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f93c23d4ae54d7844f9f5e07ad556f989ec76c169339c5394606643e42cac67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61886ccd54f5231b990f4068cc38fef03265dd60a3156fc8d762443123d6e739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42faf9d57b4e38630f5f5bd06b96ab41180e9e1264ec074f65719bd3919285b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c25a0f0a6b884ca4dfc209f46e8cce312b0f94f17f7355487825b4cce3013e1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c1332c6f548c31c575d70343e62e6971583842643d57fcd7cb486dd2dde4b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a61b62d6569bc40890cabfcac30b55ec563b41bc79bcc04b3b3dec80de2a7cc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e833f9d03b809ae98ba60cc920a7cc737d89390bb4391a5cba96de46422b8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca793bd58a294261595d84a761d394fb5be2af0076b10a9cadc17af1a6ed1ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c95ca6c5820e3cc3116c27492e4e84e07262ba0760333b2afb31a48301c45a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02d97fdf9201ee3c1a72f01d89c493b9937ad37ffdc4dc91cf30dfe51b53cc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871792e44d7d1d325b778bd7e16d2830b55c2c0e1dc196ab3cecd1a442a0c69d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5059ae992b426753db6fe9f441d5f4f1eae656f0148034ca19d0e63176f6f16c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__896c8d84dc0663147b969ef71572d457942071489677104721637b137066b79f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3821f8d9443ccf091b25b95542e9b2031c1bb450c8743c85c360637088d4945(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92b7653821668292f983993f47d8816631082455bfb492773cc2619f962dee4(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e99f68e1a3c1f5d80459194cc26ba04652e006ee9b10e1f3281c0abe1e834a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32808e089641d7ddb471d75638faca2fe4722efdf939eff2a40b01b6490c560c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199faa0be8c93c5335c2d090a492815c4172004549ee42034905621e561051d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f336f6996052ca2f766df2a0c52e91c295e93338163b830588eb4872e92e50(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd03efab3b689a84eddcaaf1ea04ed44618256e0c127b2d112c76dd1b693e37(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e93927ce3fb49922ad4688880c9ab0ea24296059e895b28e28c90881b89a4e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d003e6a77b273fb743cac574369095b90e019d2743ec7247d31381d81e560cbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588ed85ed0c2e6380bc1301a813ba517fb6dd1146569e741735e30ea5fec5193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cfe74d2d2452cf340c43bbde30ef7aec7ba867c0d4fa9816c834d0f95e6c875(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811b1b658f6e8ef124add96a7575a7ff3420573fa22a66339d49d56fc60ca6a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7eeb2e7621b9509f372b3053d393d970f69a12629404a2d0337cb3add1b9fb9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6a5b85aaebc9ea20d0f21846405b5a0073d5b16528e02d791ab3fd324c5a58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972d8e344c6ae19be228626518c3864bc1021e7d5f1be5428a4a1a7e06f4c3ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__480fba2bf3b5af54aef01c09e9ed3d686820348d086d1f1368ad4925eb08ad4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2396155c32ad3c19d75838c8efb9dcefd2c8d87a3249d0c4d8cc8ac5c774999(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d48425263825ddf01268ff212fea8fd5f5c0a01f617aab4d818ee2ac19297d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ea2f78ce9215d40c259d8470fbe695d72b359f6b0a6b415cb4d60cddbbe24c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87470d2c912824320ef83c3a2ca10937209b35ff9c57fef8c8cf77a05d22586d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f680adea12225ea6c267d86a99740ab5cea720bd17e2223244543ee316fe69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de5b80e40cf6c45f95a9a608243af869724347802368c7104eb22a5404c7721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97686d07b326d03313ed266eea49ee8ee225e6e761bf5a79f71d4c58b38999b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f1991c40842f0b60a6a0d77c2b34cdb1814ff6e724ceddb3ef132f0b133da0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c81cd87fa6f2de799b6fbd56dd479f47316fd23a56fb90337b63e3cc6c495e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99123e770acc706be35796be165b68ac1029739ae7c6e628ae2026e4ff2c1af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aa731c40a7299930f028c527e8624828b4eebc643e9994c130f7cd1889ce213(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca5640fa6c1b13eb0912ed77e31d9ab0d488449ea29c4fcf54f360cfe3951d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0880c8fc463a41a6e0b56bcae00c4383c6fe63fa564044061d352f0ef84139be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1201c69f4007d599bc14ef628ec29768aba2c9dc5cf9c687ac969b77e06bf78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50fb77995f56846ee6d65146481ebcc77d8c8d89962be65a3000891137c30675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff701815190145804c279641179960bd8e1761ec7f0303073c47ad92c5bac09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126b50945348ba8d4ef76db09beebeb27f28e175bba59888fdd207f0ef5c5180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9af95b151fb12d21cf6ea07266f3060ec10e662c7e452541ec768f5b506ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a39f9330ec1fdcd0d64722616f14eb2b5b5fb4d9270023f0fa4e73ce4f43c29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5bcbc58286b7e2b898cb15aa39cdeff1bb5269d7f2e33021fb1f0cdd1af953(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a329e1bd55f5faa64433f45f328f09bdad756ca4e2cf57c3f45dde2b7ed9bb3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3901f2f995b05b4f4f6e9c93a2799c932acdfaa2817d4cff78e9ea157c89d4de(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83daca631ede2936e51730d48cd01d60ca70cf950c21f8de0027c6575a8bcb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7feec19a53ee9452e1326dcd324e1aaffb7457635a0dd5ece6a0861bd4229848(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c116384352ffde0091f8cb5ee45ddae82025aa30233280f2771c0aa8c6e0e5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e59bfdd394a649d049d921d03b77fef785408f2f0558a6c8337626147dfb3a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af82ccfb19049e1b9e6aa6f8da6ec4613ee9f935e8f1d3c56ca6711e2d86dc0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8270d100bc77a70a1d1d516758b949c32d44ef9ed77ba1a11b8028c7be87349c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a8bcccb313742f907d6da11866683de66a5d6394b0e4bf110f5580f559d5eba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612814320d0dbb8d552d25a829070ccf41e55d031be54f2e80f8302bfc899dbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7282b64efc0b35a4d74d7e71881448a4d3fa14e66ab7fa87b23e87b13f7914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289ceec929853bb6fa44b23d29a890a6a7aeac896da8b09c4ef724170350e87b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a66defc0226f52541c59290b86bd658be59501d0632251365940cdf7eb2cd6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f29a004b2b77a6a0cb3d000312ef04a26e4e8957e5c27a0f023d48941ed710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f202ea5e0db9038fb66d16099e07c5b1676c96c96ac4903adb8637c92e5b5435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca00d586b4f5effd6fc3aebc37bdbb8f2dd531ac941ef46567ecde2b47a91e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33076a8407834004082a4c2b12fc17c7735697cc548a566adf2ded0bdd76d854(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__407910acd1a2c869c624f9f416475397e49ddbf660159857c127de2fa057c60f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae925f144e2f2402154c3e7c7d88b89e44f00f435b664487362a49b6d5cbf880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8ef2ead93b5b912afa68a8093f6be54524826c3de6e46effca96d0a55c97a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b06516c07df1ee8776fab74551547273cda2a533b5d09ad169e6382f71ff241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7391f76ea4205bd32ff3f4b5fa37a0e43fc7f4eb131ff8da3386534281abbc98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c284dd66cc735ff2e059973cabd12d0b241daa7bee148d1c3648443bf5a7a9(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5b94ad6bcaf120383ba3df7e5f4778c9e74aa9a84d1b6dbb243e1634458a2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7fe2a6f0f217385ab999d9ba6ecb4a882c2e752083264b051652df4e1735252(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d23fc7ffd09eeae0f6a3930efb74d9d691ecb5bd0af9f912d48819a68ff411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887073d118a11fe282a84b31f6e128b7c2aa256fc5932d2f00f5017f96dc99db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bda9262b8a4f1ac7095e11820cca620e8020714eac10dae12de26cea9dbe2d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b764fab3bf680c2c87eb37ad2fb58b9e8f3be3a29f2a86f86cc816c58b7f60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90cd7b1fb4217b3285a2ff6468f90b7650ef4c09eae375e30055dc75bd5580f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c861abf98bc377c877cd178ecad0ec4ccc718549cb28671abe4c3981fbdbb39(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a9d63102b1a188cdaf8f0bf01754f63ced7cbd0959880aec89eccc291d7989(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bed20ffc0d9f35547ca8d1ce321d47b1268d395bc368437eed9dbd9bf1c46ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d571760ae5a928f656877203203b541bffc5844bacaee95aaa16d9fa47bd80(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f055f3d5347e27898c40fd898b65730070f692b2116347e982209569350920a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d1892e197da0c501d151608e97340691caea04dd759a2d2cae0e2cb46326ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9d9e75656af01494d98461ad3e7005db74d67919bee9f4f482e7e1443c8978(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b2694212ea2a45005d5c96bfeccbaec80fe9d27f87fd073cd4874056c9c3cec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8bb6b7d6e20be53d0a69f8dc365b6825aab00b088eb21cfe6a8dd6bf2c34497(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a9f1407463fcd4ce46028b0156b6bffc0cabae8a397a34b4a48aa5902d81fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e7b478663fda087456d53103bd0bb8c574d742ac10be67db81d5c27b8d67b0(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ec8b139dd0d882494574cde54049e4076189ff3b54de532ff35f99546b12c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af1960530e7bf303c8c6b183014fd2e6280a86eec3f91c16e54d2546260c5fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f0c176d618801672d5d92f95e99b98a7b7abf078f1e9989eda6855a8d38f77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a38d4a7909393ee209976a37463646e179a06e5c63748e8ef0b590a23e771e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831944b61f3d6bad525e6791ff7bc2cd4c2fe497392f156a356c8cbf8da85d2b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3209bee96ad21ca461c2e560bde1f89905e3a15c75d0b0be08aef1b5ffe2da6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1248a2240415f5f8d0da6eb5bb76a6c5b8f2578df889d66e83e5dcde2f4e0299(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19932de95cb2f0c783b541657ddf297634c8546f35c7695a94b511e15a870cc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948cfa161017d105a36cd7a0a632549e488781a6725c193716560a78060bd177(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6ad8583d39e45708dd5e02e2e5b7b6ea952ca2874d0485655709d148c4d09c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b325fb5301c496752db0a3af758f2256fbe915a2da0ebf32113218508319ed7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653ffdbc93807818df06d6d172e7b6e354ca048fff50d41b5bc5ad6eb69a883e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ebb9adeed6847f63a73d6a7c3c5eb44731d66d4f9e3a89504840d4ac40dbfc(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70e40197eeffa56db0e0133e647dbccdb536b920d7cade295f50b34523778cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feed7b0bc05f9df93179837dfb0f7ac7de806ad579a50ee166285ed626ca47df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bfb6bd5002061f99211d47d3c5700da1d3c3b6539af7321463401d6bd249a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afe865318b46c946a8238de8d17c7cc366daf43461a9c8eb0e7cf874e6393f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e75076ee04ec181f9decf820433303bd8220f7ce14df9e95963555d57418e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b55fc20ba55c52056a0ba7a8dbc95fa8dded0958ed049a7779170f06c895e7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c7210e3177922cab4bdbb1f2152bff599ecc8d043388822a5a78e73307d181(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1391a953540a7b4a5bcd5abd5d1fb1a755ffa29207cba83102c510e1b42a90ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40decb4e42eadcea79a59fef342251601f16421d21f82edb742c9764cd39cf1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e4ed1e664b3f9d9f7cbaed2e7c8fc14df516dc07e7c6e214ccf94babdd9cabd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c3dc2538e34a447efef2cc9fd4072f1e6c0a34686bae92df5213708eda2bef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e80441a2566b9dcb4e9eccea28ac6ce6b5ed662605b6a55ec09dcabdd40ab9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9b2667debe978541492431dd5851c956fc98cc5d2712771bcbc003232e0cd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed01c3dbb934df772c2ae7e6f8292e5c2fff2b1296d39569320f44fdd5931d65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d3c86acba95118b15d633fd3adcdcb104d225ef232239e24c389155d2fed77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180b8a69ee618b4f8795e278a740f612b7d0a842e1198ecf5cf7200a7b9c31a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e664f601838841bbc5c92f99ef5b2ee3256661f462d17d8025bfcfd63cd0c2ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2881380c62da6d1905c996712692d60cd97a2326d4bcc3abae0c8120e4c29ea5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f179b4109131b39902da6d0271898f29ad69f5c331cb7a4acc3918a917c7bbd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca96a48af497caf48c0b3d3221baa556328ddbe557a0f203fb39bc46a536242f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e311b8cfc78ca375f7a8ac197b8b434cea97024480df05948415f298f9be8d(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6df1ec1caf16a11f2aa36c70363df28e3db41e52fc5de46d927956433d6004(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72066f16e44367681a90b829c8403b20d40e4955f927237b97ef5ce51d1362b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af512fac57e834ccf5add3a1e9f65d686021bc85f67a63bf442c21d649246f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e3e6e96ce3dd59057463eaed3e1aa8df95e726eb11816ba1f0db7e58c79224(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6316d39d2b894f3baee4085169763c52fb4a45e4c884c00c0e573116b02714fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c61a842296bb9af3a5286841119b837e0212f458954536205b2fabb9e435ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1230a464eaf58ff628c3d6c555ad4e66904942db58577d18939a644f2a8e06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4f37a54be1fd4cdf68e611821e97fba751470aed2c978269bcabc8bac7221d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a5e1dee78278bcee6907c42aa21798009d615eedc62ea0296d7b97cf8d1ef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3413d7b28ad9fe446fa280476d7bf5f3ed2065f0743937ae448fc025cf7b0bf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93dcd8b599abe62c29fe8806cea61fe3c29a47cb56dbfcfdc15929df98528a3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c4eccede132064f10e40fc1d70d6c45607494e5c012b3c6877380c217cb710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f35f9c3bf6aff84f284bcd07c10ff768d5e38c8992002888ab5502e442b9e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52641f3b319b45ca4f13a19878e4f59e36796ca0b21720873d706e5de7c2270d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2fdba64efd8ff45dc933027ae4738b13e314bc6a5c9a69f78431072f099275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56757ad692cbac48a5b3513de7fcebdbc82c1c7250c8a4e790f7ed219c6be060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c840cd4176b36fea86e21667ee9827242f16ef9b3cc19583a84b40696a7c16f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd32e98be4b4547696e1084f226029a0e9374c6b6d47647e7719ad3478137bab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15828a7ce198104f641d9bd81090e50ca1c76f88ae7dcd66484e3ad0d7c2d38d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c89c4ec64dc91eb1bd42459e05933d2035cd5d757e1b258854aa35dc14385f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23b75afeef5aaba670ae5dfd21ecd5a9ab3758aae0c41d6124e5a41225c361c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5038b865a113d0d1a72657303199875111a76de120442ddc6ca0dba125e20427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1ad76240622d73c1e44e073af87bbce829345cd343acb64d1696b0e315212a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379d239497b8ab4744dd690413949a7a5ff54cb4d7a6fe46e0f7776caae8549d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4665a681d7abed0760376b4e67b6708af8b8524df45935cd97c6b29830332269(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe89f11eae0c776a844c39e10c4f654386874b9fa756dbc93c70808264dcb719(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d43d11ea2f0cc99324244f96820311ba2fb818f9a1ecec329a430a8e842e1bf(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92e257278eb4a60123a60f3d379df5ba4f879447b68b5a2e5544800e72ed386(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46b27231152bb093ff6a6431dafc67e874bd3e9faf40c110036e05b0f2b356b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381ce315377210b40228a1c913225e3b4e5aac16d46e4a1a0a84db0ddafc5d5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b98e4942072aab57466c683947e647d5b25a555e4095f37c24327ba3318f534(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b949c94a284ba209d35e90c88de93dceaddef490f3f8ea4aaf14d330cede2293(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1a09a161340cf4214a8d89bab14061b7dd5a3acaffbcab41de9e3ca739a77c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f2e5569188bb65517d36aadae3c93b9c89449b682b9c7e5f8abd9f115b9671(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4c1f35be64df07e31ed01f560dd8b619be975be50967b0942671508075ed1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b5266ae2ca5fc7d9a65536306aa2fe1fda1e14ff784d7b3c0c36b751203f766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfcf4dae153c6552d3965b221281b567f60480de887842e29cf1ed4413338c63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0dcb7ef39c8041769717fd6dd127263a7be6f8896438aa4e01362edf1ea8ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e42ed0bd200ef31fbbee7d455ee65f99312499519785fecacd4f9bea4aa188(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ab2a37152d05c0654d184f3527cc744df3ae0e19d49df2962bf1d82761a852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b113a1e02f12d1f14ee241d6de29c9a626b1145b8a287b3caae19ce0a14400b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0841aaeaf90a3b10499856151578d3eafba26cc5ac19d1b68fcbeb3df93d375(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89dac6dd1d7628ec8a8122972e018d7239f154a609b977e48164d0ad705bd4d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d160987caee2a3054ec5ba7bec1a8b8a133aba4adec36742ff008d8f8a870e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a2784f2901ec0c8c4f0f4e81ad690ce78dd2953631662529ae39cfdb3dfeec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7173278e6cef2491b3a7e3815bea7c61fe5dfb5c70eff8f2a4b66d71cb9f97fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ee09535f6c156dc35f0167a6665839204348e45ddf9038fd0d3ad2d2874ed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2cc51a25b5dface32e4e58d0ef7707905fef475fdcab407efb756f3959fe93c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398acb9740a5d0dfb63a80661c4a2fbcab78cf4a56b6184a2c1f6c2369ff55d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39eb2898ea44405430ba30b4ed55a583dfe94cee8e3ee1faa306950c0c720d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c917d2f6e68dfbde57de0adff869d80212650334bcfe4b9b77ea4876fe97a39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00486384f40e756f3cc0b1789b9fe014b72b565d60fdbe3210b906dd5993d54c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9498548d33044a565dcb64ed30bce4f78bfaecc513ebf6cf83dd5cabc539804(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a1e203153099bb532572dbdf5a2d62401fa3a95441b88d229d19486c7863da4(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd01183664a21bf5793db805906fa985919e64fa77095572ff64bcb928604c09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20bd3e5d3a47804b21fb4b36055df50a5da16763fdc728295388a030ff53866(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7db1bf5e356d7cce49c2a95510967a4b0fb524e638647b1a1ff9c0aa452378(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596d67588cf696ca5a1be8c13aaba4614b330c887774723d0f02545f55514408(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d45a75fd0bced4de573b65063644da2aa2b5d6e546b24fcf44de2918020002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d1561b2b4ac82efe122323d015b039a0ec1d2119b75cbc15d3820204d9e3c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821514b8fa95b07170a2639307e053297ebc984bc50c1f6ae722571af0c50bed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513cfdc95b4bf248713058aaa496add4c3eee02eb938a1017dcbdd2dc58467b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b19f2e79a1a8f4e5deacc9e3ac6eadccbc27883a582991cd942d53ba64e130(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79f54cd80a7b1abc8503bd09fb51de2e8f62678dec425b92e0851516e9c4dd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1f5061316f1a418659ed6ff2c877f22909e46da5aa52c7d0de27280502f41c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61bdb0d3171620dfa9302ac4279805d842aed441c3b35b738fe467cc32092dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f0d6e353a945b2b9eac2d61c14cd844337ab654ad9fb580e073d37ce6ca7fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd99372073fbd152cef1ef5110a8a26ae3ae31fc6d26d8ef44a305573caff75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2dbe9d6edacf7b3e5381b406b041025f0c83b99f6306efe893cf17998ee05b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98322537515961d62c89e53c36089c40914db02f4efc86fcfb892ec178d6a93d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35dcbf7b0acd0cef28b0293706ba81ddec2b25e68ca16af72c7ba6f3ce58a3c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e8973d47bad9310073021f19499b126c88630092e02a3949913079edfeec7b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__528f70f152805d38aa6bb598edc2c5e0020d72cb035fd941ec4669f1de70f029(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2e1b5d79b1afe7c880352b5b2b2107bb60179fa4bcfb9c0f58054be4363bff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3972bf956142fedbfad81157540f6b5b468ff908d67d1a74aa87535fa6e0f58e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab9bc5021c3478a545173bd54ab7dd78c8fa1fb3ef295d93ad216ad34eff2d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4aa73dcca497aa08a01164d4386bd6d60a602e94c047e8d8965de9edc5ecd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabfde7d6c3e388c3fbfc388ab34720038c797c0f6544d2dfe16a0b8de42d31b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774b761e39438d4ce4ea4b9ea7fe24af8a7ab34f92c29f3efa522e97359bc61f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f36b5a99af6ecf1b23a72326c4f853a0588c3e657d4d70624c4de3a545071d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466097365aa2d20abf40de811e10ea144f07abedbda78d801f85139565dd4e21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eac9784bd782b11fbfaf74e71523851b820d4f1e1984b633182fd06c1b06b96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5500cefe8cb288a6a32bbd3721f915acdb66bb21d33eede10adbb527175be96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424e25bc43b23ddc8c3fd10414d41e808a9b3c1c7eec49183eb7460430ab1935(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4955ca123f979a6d01b6b1cddbf8b47ad22c5d692fd86ef0a5d4bb8e22c3fd70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49335cc7c506da5436649b6076f3381722d4bf52f517fef3f932844d26d6da7(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f44b7ac3a29378585a7e5b9a2229097b60d979ccc874fa8bbb1e692dc116fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aee13648d21cd8954c2aea609fc7ef94ba0e3e2c5e159b5e749c9f848a17b59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1c1cac2b3dba2f56acaa86e5b177025d1541ce48471808f101e4770da98c39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf1a6979b4087214365388c2d7082cb921b928954d2955d41cba13958ba08a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3f9e51ab322893729fe8315cc93077e9f1590160eb681b75705778659616d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8077dba452a2bd398923e6826f4103a3335d35d26ff97bf11462a055c97ff53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a353012fb6386b66e2e7c11fb2b58a118e35678afd77522d5d6d49091a8d4692(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b41007697b8d80fd92bb2b528babb0d87e92f3a11f04c35371756e174af4ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa57023c24a8ec1ac60b9af1e890519fe519b7a392933f63c8720d5dba4cdb36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b53061aadc6f3f7f676ac67c5b209d9b4c8b577d03414506ad62b6a22dd6cea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__179c580772f34023ead79af5dd449fadf6c8145bd87c7144829bd1fbf826e1d2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ecd325b5ac1c0178adee7a3a6de9c54fdc489778be76c8250ae5ef430b2bde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44ddcc9a2cbce7f6c18cdfc3a7ed88cd6208921de9a28479630d705ed2523d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e124a317d4c5350736e429b5b811d17924fcba24244481f24a24f44f0fda78f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132f3235a7b7803809e9b6acf83b4d578fb27599c2276c0401b74415b63fe186(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2002cea6713414baa96d651af0d96ec8f767811c92eb372e995b94e9fd8c6019(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb6c78eba50c2f7d636d1f87446c25b81bb996aa5d1e1fe0e9a7eb583fa3efa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e2e59552ea51b68e7fc0cca800c2ac084b9ee593517463658f0da78203374b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4f6db2e18a0a110a747d9d327138b0e740202370dda2f472505f4edcb9a7fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4b8c3a91502ec5bc83e0f2e6b3e27e4d0fb90ecca1be887b15ece2d88f1b3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049a08b8412c566a2081681efcb24d045bc3f64fcb30b8d562190de3afa1a0cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c52cfec416c79906a56227770a4573c745259e90910aa1edc51d3b3e18fdd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ac5e6e687461104b97f017cbc92ed373586d19e40006724e3ca8c6a1c593b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8058950acac4566ea523162218cc2f4b91c30545b8c4071b96745a96d3b680c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1968b2b0857e1b29e1859c1fa5d24ea98583e3488b89d2c3b1c0ec24a41f0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3339a34640da3bcbe34d924ac07a76b32001d8e3e981a20597fc7cac29bb2a4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6ab0ef9836b9a5a2a02eec3fef3dbea19ae379450d48464f7d1d6cc00e3f9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5308a5b11891cd745d01a82b78d91d56766c6cb7e7e528b67497991b85abe5db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48660a067c97a19078a1083046d6b97e74e7d5eb0a38467dbc6d260b818d81a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14eaf6dcaefe552f0654414b83be832761de927d3fd6ac5075396b9a94b3a637(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c598f436643b8eca9401e7a8a28a508fe740da6cd050eeed07685c4f6bd7cc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27aa4e297e158ad4806d6d7f8e499a915803d786df9fc5d817d576d1ff25e771(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0534f92303a095fbb1c4cbbd46c5da7c9e18ba73028126906d113ddc80e50b40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e7fafdb830fdaf063602e5d6da891917a7ae842c3c81dbe1b04d6cd5ca01f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44538069b04f23596c91274579cb8fc5fd5a534cc7ea2594d84cfe4695aa118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ed402b119616a554f7de0e3e29d99b3c516d9fdf574d0116120e2af3f9cbd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518557e3a1f51054e09b274927dd1dcc869f1078f6bf48a6ce247b6b29c78fe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a616dfaa01c8263c2242be94aef5fcc0eeeda47f93206073a77424d064a20a3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3182fd13cbf3f24665634232735aa03e445b84ed33d905f0d9d829cfc4bdcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5e9b900bbf7d545e5031070c0fba4ce821d30e4f8755a5fb1d7fa95c28da8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d82af3719a876ab6394b91130a6a33ef2ccce5191730a593ffd7280ad05b7e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c095b1843af3e572e1a58166d1559e83ee62c54a00f3a6e91c785dd2818cceb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ff7f1fb27811cadadabbfc1eb3542875a0547f29c1b65bb82eaa20d65375d1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c31aa6c44538a58f89d5c63229ffce80a96c39003c65ab272dc4f68fbbc8875f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9841acae3fa986887a3dc2baba046cee91062ce8817dece366ae3c396aa71e3c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc28f34661b48432b24e02bab44102430f76a0a4d1edaddbe83030b6f75b8b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6554540f1b495470fb2dceeefbe68fd5aab0ef94cb1c8b896dfca8f75b9e2e00(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e413b432e1715c359707bc9ec9a67f682093f9d6a2463d6edc51bdf5ba23352b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed63a51f3499bc81c03c771573cd3e2e0ff63282d6feae54d032a26a3c1e04cd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ded44137981db8d1534643af6aceb8dade2900c97ead6ba96e388ec3d3fee19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be798fe7f4473ec2e0b051f29031e6897f7a452198b841ae13a59f0855f932a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b33905b21b44e9ef74397ed96d8d06439dea189750bfda26bbe6346739e43ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816fee3551a8dd3c4ca07679a4be3435ae170cefc866ee98347feaf0447a928c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3462020d4194a9cb7a671abc31b35898f32b8f45bad4e21f4dc28d034bc39de6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4d55320cb464219bb3287934c7027c04be02327c674c8b772e3fecda38be5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3899a3699498c28be961cf3a0d26790e544413616a8ef20c7032bdb6a0f5bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2bf8972d9cec20f84424310c3d464f45cf40fb4dbb805c0a164ec007e2b75d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9197de80342e9f71aec40e99bfba34bd35ed683b3e3c91b8652f77ddb05fb13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a35c3657b6797b19595fa7d461eb4ac5bd65b9198dbda2807beee7b88629f23c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64767de96605b0fe611e2a22c95b52b5c247afbaa3850fa1de48056763c22c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f5293359e7ceb0e3b5e22d84a83f946f5e8f2eede260d0012c8b762e7793bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b67c8fa9d913974f6fae48d66d02d0a188599eef5feaabcda8c6462aec4788(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a271d96670e17f9ed035373d0d71b19f5990d01ba011eb2689bc06a3e3a6e56b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e050da7f28e82f18836b33de05ed21767e6e5ef0b0150275bf8bd01bfb07e4ab(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5ab9b02d7096c956edcd0ea19068e3602d5e61843c9bc9baf93a8df34d01e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b740e6bb8065b3874f9757d70bdcfeb9043aae6a5a322a3931f9f46f7cbbb5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a7f84a56ef4a1901c82373fe89ac8b93144fa771932fb6d393f22404aa6b40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686dd3669695877fad1d525a1b28cb8f92d98f4c0d9d6c2c806dc564b770fee7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff6402b8dc643006f287b0c173cdc73a5e661e1d791b2efb0bd212f4688c084(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82658a070f5bcf71e25c70b8838365ac1c84dae4846d0c730387933e37184c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ac8a0ca381620ebf4d37b4b342366adba0db5e42d71663673c98b2829cad38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4826adc7c7cf24b4660b11a7e7e0fe7e7610c4c3f60e136c39cb3bce8d706608(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323295debf3bbb9dcfd7a3c463648248c7cbbbc2baa757187da50f96db66d2cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8583e944a2ca9cd2dddd1305596e3d7d7b24fd8e945700988f389903960b8d8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d619b6a49a4673bc2799011682ee1cf701e3cba03fefe4d8dea98fa3eaecef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cac9e0efcf7e9ce22231ac96c0c8bd7fe4283f7bb0a5976073ab26caeefb084(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6721d82e6403a9e600bf719dfd161a0562a4c437901ad382cd3eb5c3801e30a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8fcda6e590e9e9b2ccc6866c40b255a5c9c05c8ded8a77d56aeef1f20745fe2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809bfe774d62482e4d5f80b72d8c58f8736a72f47d67cfdcf1bc609ee8c7e39a(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ed00f7aec2942633fe86020cce703c13093c5f48953e93ce30e2f48afdee68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137318c70440d4a8461d0c215b0600602ec7dc27a096d272fa15f0900f9fcab0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40dbbd3e0087cb1dcd2eda6fc7e96bd6c2a7667dbc60b8260b943fe33068c3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4951bf2755e8fc6ec3548c51259a8930b1119471beb89f1d35edd2b9fd71b57f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64bf00e3e78234f451a4c599741d59142c6a7323b60029555bfd02edcab17798(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600af1af2cc1bda115d9e20579af2840a525b138b6ceb5e3bcfb5690124c2862(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9f6b272af46f4f433de6455479cd3f726415203c5a0c8acf1c69531b9e356d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a0048335bafc9284b183c80d28fe48c0a249fbaaed6c6605da13bff76890d3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7b577fdc34fb7fe25f4075f08b3b203fdd372a5a8e9cf6215fce06439fb3df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e449bd7d4d2e9fc159d04731eb331231f232da19b5f193f6bba26abe830e87be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6df07785314338d45c01315f2059913d3305388801df281abe7335d59b334c(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3931dcd3fa65e1462cfe878c3a1d57aa1a0f19092c4f9c5464ab1c0f86712134(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f59d51f1df61b281cb7e7c2eec46bf8d567a2488cdfe127ab18403b99b23ec3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eda68ac5a364c75475c23b8101c773f9b866ea7d728b5adc528c19924dfa9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f6f0b83a1f00287e2d916c8a2e3addb55bee080b3f25a0b0ae3047aa15d7a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c15ea6078cd309642a13930a8b8c1887dfcc24c20af135db337481e7a968a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af322de2c557d390c5bdc3a809e6466f2afca58d08da1ae33e5a3f8546c9b08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd460b1366e1c91c75bd967a2100b671153afb65b046a53b8ca0e16b62403c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e765227e5ae3a724c6e4817c4bede05eb5b2756992ead467890a7cf029d2281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e56354ffd0546761516ab6ef4a07d8677672921e7f2979f4df8334f1482dd70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fac3a154243f32363faf0f7a5bc9507ca0664a8c1e66e85ffd815cab9b31117(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e53e8f6fbbf97186adba0209fbb10bb38807416a7ae9b0e75d8cdb25d2d25e(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae398e6cf89f00fcf3f5780762c8147d4bcf9d11178dae3aa92cc22126f45479(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf294487cc1961fd29276386aed2a98a87a2a02843d0aa5ad4e7d501175c53a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1153d808de6c8ec808c4594d9ba56762f017b43938d635ea075254e50db74d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c07dd7738f18603048efed1c3ce690fc7a36aba9c42d50c6057b5b594632730(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493f44f745c5df9b2d6ecffa66dde992fc7c90bd1577f6693d77820364b15006(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2114ef8fe06b37a69f9952952d9210f843b19ac2dde94b8f3501c80080ed285a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bab061ca1c85af05cb118bf99f5a4999f89c6ca417a33d9db8ed493e64e2e2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d7e598f5cba98a51fbaf64a5a5d18a3ff35688d70e41a19a92b052ae3d07af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a848dc1f69d0d82c8518fee3d173def660016b003c94ba4667ef9dd1265648(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da9e1c602db660e25c4200f3b9bf3175cd074ce0e4e1812f8f928d6c73057b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b311b2c8838ca9e73033e51d6336ad961ec9e498f8917b0ebb1fe5aaad06ae7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748afe4e5c7153e7d4155005bc64428219b06b32b1ac48c0c39ddee18839f6b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5cb0f105026c5f8a1218a073b9f063d91fb3d61387d865795592da9e1cb251(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3211ac1532ebb2c928d3942ddf29e66f7be0d61f5a64b366f58a3558f6f25914(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea6e2120494d50fd0d637412f102a603d703bfe539a66a4a0365d1ce78c729e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bacf3516b76e00e9181d55c770f4c0b9a973d567c652d7536131f2963f3b850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__858402623030602973c50b9606007b29c6ae089cec8e0b9c625c984675f84dd3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99bf4d040ab44eb53129f98653081c6258bd30351285714c86803135b2e7b8d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bce5340c5b33b7101278f713624bedc302f47e1fdac4fd9d1e784042682a3be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68cc04309c2bc734b200689e37bf739f3dd79b03f382a0842f87fdb58b27c75b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9852b159030ed2fd344a20d89e8212910927c7db7cf10275011f42708033ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20b6c5c3b3afeb1670f01599541ff48ae205b5b3a55239af0c14b06c0718be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf170f0eb1d0d6dc0bf5c29d8b060bf1ee06832ed4d5fe141220ed1b4208c7d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bc88899509a4d1704c504b9937ca5b9a3465bad657db05a06e13d70ea1c37c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b30e1a9c0e639ac3aecc69658dc3776c99b37134ea52121b4f691a47594a8b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f32f8bee0c3f9ed0cde4ab95cb6166815da689bbaecda6ae93146c4e4d6b98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0c2a28aaa6ed279708c72e04077ad5071a467e775a5e921cf3b0d9eb9bde7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ac5bf549e24cfc7b7c0a9f17c8e084715decf0107cbeff78df7f66ff850844(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff83d7a66f0c137f4a5424fbfbd706d0bca9766d7f13da3286ef08a8316260b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8dd05a4aec35d3734a7396d98c78f2275e407cc8d8d4098a9d9c0f541e64630(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80285658cdb3d43e3a7f7dbc6193d4495fe53ba753e06788ad67c86c97b2b981(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a79492f2500bbc51d593516b903bec6d040273d7c8aaf11ff0375433ba8dd6f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee42d2a04bc2e67dcc06da700337f55cedf40aa7662b0057447c2621dab60d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936d4370497a5a8a7ecf637b253af0aabcfeacf14dce2c8c76128b974ae1b171(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1547cd85b221c9b61ad8d61a50e4944d03e8ba625a9aa4979ccbb5f4a44fe488(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ea5f20fcf71f33cb990cdc0a979cd97e010e13b026b484d4df5d4d87a734ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d0b3064e369cedbd43be33318639fbd8610bf456e50dcadfcba2eb38604c092(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5942286c95de5a615db5d4d854e11f5127ffc5022f71b68f67edc1e7b1ee30e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce73e22be0a7a431ed4d6cc56d21b6217365bc36a8f4503709a9aa8c34d0078d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882373b1192efea5e82f2cac9f1d7505d46417c8e127dbd51aa0d6f502132e1c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604267032ff7a3a38c3a5e3a78aacf0189e441c78012aedc41d6bcd3efa138e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322305acfc73a3eb8dc5f47f3731bff3fccafdd34a0fbea0cb717b8e2f4bc43e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c4e4ae93fd750f9864b17ac770f409529be848547c1dc092cc71159026b321(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226394661790ca12c1df8de6b2d2eeb0b8e777df71216d09a80d93eae2a9173f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbcd0894a8e27dd07bcf0e873008078bc50098420dc816053fb0d036ea6aeaa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc3f625d860306c746512534fabf679d77283bb610e313b09b63c6241545fac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d11e247f3171139c3475ec868c31848b78232391d7a047bf4546b787c50e8cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3da1600ae8677d2bb3b73ee74a9a33fccbeff49a57d480116559cee1a67645d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b7d13031a5e4d4d7d303ee7a86b27b969c8b33210a96eb426e6fb6dfa2070b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991c01992bbe3542ba33243659814cb7b87e3d42b39f60d112d80e6a73f06952(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce3c7f70d17b176086a4394b5a6f3f6d9d5652ca056cbb9c77cfa6d5d457e6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b510bd0c816b326142a01178bb027a01c7d03516265db39f43c062bf01ddef93(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a88bac6a7a36afae0dd751de8f67762261b2d83147bbe5643b659a882fe746f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1119f891785488537e1680a723efe0df3e117b4053579a379723935759c56a16(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2aca42887796b54dd9badd6cef0f3a4dc31d88b04a2e21cdfa9424933ae493f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba0d49c5f63ada1a783012acf4202748b74f11b285d299163abfda8febed47d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838c04c2ca474a057f7b82234e7bbe8f6ec710a1fcca56a659f4136b81241689(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf164aceda5e900bcc0cd2556807de492b92f4509d3fcb7890f4ff2ee57b6fb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785a8bd459a893d403bf1410857d196de81806b61d3b0addfd1f626d3b83ee21(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7adc80e826faa0f59bffc36a120e78d5719e554b451092fe63fffe92d913080b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20bc34ba53833217b204073abba3c13d78ea463e3af157209fb41c1e7edcdd8a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4effcc101a9bfca1462421f21d4b6c39f2f629209a40ef544ae21962d6c645(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ff1240503bfcdd24a0e0a66d3fbb8957a0da9e768a90d19e23f36f7facfb9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1577e015fc07626e963733675c919d4422c7cb664e8c5617e5fad24235f57bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6861ffa031805828b2674c5d0e995b0f2321197590fa8e558507980929d3ff3b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad489267328aa6e880fbd8467bdbf182e6f79b342654ffaccc5d1a3dafa1c5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772d556bd3d16cecc5da4f147e2a4e2f9d6524bf1da9bc34ebc32a313a38e6c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e1b27df119d34b078bfd86b27b4bdea864c08c9311d9d0f75dadf716fedb1b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19636ac39c7cf2aff16af3d745260eb2a071e9ad1d13330d43de684d67470b30(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd14a2f4f5ee0252c7e84af1b854357b339bec2cf06680757c4c54c79f275cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a22dcce48dba3ea1dc38d2163419ddbe4ed91ddfe14493f30ab6ec5d92a487(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529601bdc082c01f5670018db8bc14d1a3200cd492441f22fb0a282397185812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28371cc0e301dbc83dc77e826572142351d2b4be18ca0aa4188f93374b00add(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aff3f318c5396ce679eaa054e4996008dd9ffcf2c9607d2e1b3e64771e71d4f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a453bbf1cd02326fcf3da1063fd2da3980c1b88feda1e2045ac6ca580874fa8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9053592579e67e20977183dbda08c4f980d9a790293370283c12cbbdd9644006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac63bae213b6446b1b204165aa9ade9f2569aa37c5fa8881e16f8b02ff453170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a04055439cdc582b0a06184a0f4eab9ec26fcb6af3ed7875b23dc61b358924d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66329e4308c3560e791eb534027c3120ee0b20887db34533fc7d66ebe2c386a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd257589a533af26ccc9af646b632e22f8066b0de718cc1a18d01bb42ddbcc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d706ba37d5738b97a27677736c692c1fa2a91b8a758f2e2ce0d9fb8dadafda80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e23f177ed82c852a6c8f637f1d7d7126791429f05e5c857dd9217572309a056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311128e627f9b8cbc3a5f0cea95a8bab3b356c2c0494d61926d718a7dddcf56c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1058406f065432874604ef188b375b3ad49a7ccc6b6f2765f85c9762a2790de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699c98a0387fc6faab520728c296bbc226ef321503153c23029bd4313d2953ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e064806cbf66866de02c7373d870bff257286306274d7ba71caf179f4762e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52bf54a9e26a8d2123ea8ff5d540b6889fedfbd0e4aefd36db4c323e162330d3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170d4ccd793dcbb400fde1b27270bebea248d5fe985becb34641f733fd6cc37e(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e37dfe0c1dddb5fc2b079bfe649f6c71b03bd4ccc39fe99c569b9ef4b4b377d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49f8eb00cc78bf3b3ec89e50fca2231d655ef5b37714e1a05728bdd1a042074(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6c32018578deea1a3795364685984a46bcba6f51da8df1f4189bb5f8d11536(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204bc8697ad8fd08dcc68b7c9e2000ad97d5214ae9a7b59a2534e138c9214475(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9e95beb668f46be377909389b9d7bec7401cfb6d46beb53ecd691f1bf17feb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3267e81240f7da1f25f48bce480ab563fd7579dd080053d7568214c0fdf71d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b157889c0f779b5564aa90df94e7c9cc3ccfe1bf3ab444d4fee3ff16c59c0a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5a6db39fc667cc1875917089891ee7d30ca56f58abd9d056c1c9dfb68309f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376b6d8f8e0f0f23456999433317ab40301234d30a5557c93d54bb01af31dbe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__284b4c74340c253d70c58b4c13b7ed9961bb3295ae79f42020750e3469da3f59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efd3bd99a402a0b807e085c9cf17b06c64a2ffa1f008d4dabfea43f11c8c441(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d452340bc6e5cb6480a9f1c2862b547877ac4214afedbd443753b9a48f9bdbd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599be3713467c7ecd0994de74e0987329fb08a0bcd5fdce59db92469b2c35b9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c5ea519a04d514bab20842e4c67ebe8142399480094f8dc6455305c0b735a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b26290663680e496cad4f3e44e4d5be68aa44eccd469578befbbceca317f817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f4ec9f05aaad6e752ae2f07cbaa0562eee3f76e96d65700e8cd25b722317af3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1a9426631643dda9a81906c61f66adc91a2a18fbbb0b4c2b0d56f1bd136bd4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f89cd69fdbc7ab255d6adf2f8e59a02f5ac44d748c8588d543ace94b148663(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d928777dac0b96cf8c25fb20f2539d0112d329132af32a098c2c5c33b2bb814(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1662195a1bf29cbeebff274cb68cbf94d9622ba90c3cbfee95d21ddeb7613d5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7668c0d8566c28fd3854d89772778029dba62c7ac552fb045289737e1655f30(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1254153b50e727cf23b372ffce66526e060d490ec397ce213c7025c6c31024b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbe563b4ddabce15b0d43d7f6119f0b089de4a8bb953e55a12631ed60bfe461(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58686aff50972269aa9cd9cf097e3e60487d051d051fda033405f72cb43909a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cdd6873fee2866557394f0f1bfdde21113c74704456b11447aac8d0986cd895(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b512b8c47088bb1333c37f377c818fcf428409ccbbf89ce4548b2062d0eaba43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa2ab7e75def65eaf0b63996107cbc0816094c1aa89f5f048dd09780705cd7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52eb89b35753125c1487552c49a248c85302b04ff39bea640ee74b136f035343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95b7331e40f6ec55ce5cf106bc4eb53ed704ab59575f999ba02d01c8f6ffcb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2001d4043613bdb5ee7f09c02737cb1106178260e2b64c7a5f53eab737e77f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1dc847e107a787461863ff6c071b24414a71c8d112be5e886ee9f81347ae714(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209aef9e4dce9bdda79602c107103b2a8f0a378222446b4cf39e3240e008b4ae(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854714ae0a7719c9c17f5a4b535fafea2045e8b0c86926f78485985feea88bb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa5307e1d982853ebc1f7331da4aeb55ff465599f7ff12c3d0e1e2560dc89f6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c63cc168a6e59d102efe72cadd9afb85f5a24200be2214ee6b8d486182834d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8d9cf4c586bb07c313936e9dfebc2b4224381639bd720781286bd8c9fb7684(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fafdc58ab26dd50fcd8c022b0472b39a60332267710e2ba585f89b8e6a62befd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18db3718b9c4e4bf86fbcd204830db73ebeb81dad29308e2a3cd84229984aeac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355621f60a560c522d424eb189e32cc1fbc8d3690a552540684cdd0400cc117f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c610ddebb7f8422c4657f6eca6528b1cc2f546d94eab472ab41b2a3f3f0fc5f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5b421846e38b33d97620616ed85111ff1a3d6c70839b969e19a76204d4c7a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3903994d29b78b53c0a996923b0822839e6ccc388f5fb4093ebb2f8e1715e345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea51ff4c9b5dbff9cfcc94dbeb8f0e7f3e6da2cc07091729b0a6a78ae0d3cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efded6239bde3c0fa79e8694d47e569d6fc20099494e27b8d77081640eccbd61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddf725f0d414e30ba8effa9a04b23ce465d3650dc4cad43a6a2ab146dcbbb43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cb26c475662c3031d6a8f3db4b12f84af9171087e829a19fcba889bf851beeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7673c15cf14cf69537b6c8a8678719c5852ea4abd5ba5bd8cea03eb230721ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d197d4f575503b7c49ac002f0ecb7afcb9188f8215ebf60ef7a8baae47df23cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3055f124c86066ea6cc3bfef62d0daa9cd581637c985280dd85bd320a44c5568(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e069eff8d0f37b172131e4121fe1e477291c087197f2faf62507db2afda849a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2906df8be868ebeb2b06e3c739a8975ee2036d834289f9c49f2fd0d2fda458(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d057bd9c4357fc41fe193a5a8e0732e8a43b85f9cc3bbff9277f9fbc479e71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc21a0b462717b6c599b8b64c60e82638980e6dc7ecc6da63f5a07232a88c5c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba960d79cfe01b850b99ca88a4f7972a64d4709f6af0c0b15d913bdc7f6c352(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a08e3b47750e1d7166b63edc34056661f34e2c3ff1b3efe1b0cbc7474fb0fcba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab68ce7e4b4f354016097d8a6274beed327ec8b799491dc5428bcd8b73b0120(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69838169e67116686fe1a788663e7d5466a671cb15876e84f01fc10c30f6b2fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af4800dcd18ca57157276db417ff62abbd412af12ccec62c22faa50817d05a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7c8137b3a71809342c20bc1cee850adba7ff81b9734d221472d8d034dac00d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b26b66c8d5fdf9672d758b8da7715d502b3393d7c79af789fba1f4b8e776540(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea68ce746e8debcae62ba7a3e350e03d7525d97d87b5f73cfe7c86f0b37e03c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e20ce73dd9ee68fff5c2c08e0d531f2e0a5ac93beacc7d944693ac6125f7fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31395265a27fe3dc0f3d42083486d792125061f4c5a09cd4c304377a0c13d4e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06ac53d79f0ee9ecd455c19eaf7fec641e2784b82333445f6a2e23d65f18e2c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c092eed951ab2b75d6774b4fc24758f5785d26798622ed4f247f64a6e2efe7ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b1efeed869fe863afc03617c09ebdcb41ff736cd94da5efcc8a8cdcc4d52ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32b88ccc00da6b332c1d120ceb0491e1c6316af458f0e83a20bb02b0ef9fc7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2967fecde985a5dda1ec843ce6c69ea16c951ee2328f1bed636cef57e8367e97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4081c97dcb44897585f5f5f661de550d0189ea7e6de8d275ac72039fdc61735a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84fcdd674542cadc936db338252f2a37aa9c23a5cff7bb486ed32c8388a6d0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8baa7925d47314123ebd72ba1cbd85d9c82046849ff300f050a76beb787be40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0cafd3368cabf141a65eae978d36c3e2559a3541beaa7bf162de286dae5f576(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2630101d3ff5911931cbf41ff4704a05a76c9f7c201ff82b475099d80e00dc(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a319636373b3de5812704ae27d2451efe32007bc1e52ea76108b5fffa370ada3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240abd3e041cfbcf3f5f3bd32f758544957acac9e440d2ec165a6355ad78651a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4462ad63bc9549d9eb3ba359c7041bd8cc32b5aeaf9b5d8938fe303d216a2ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31158eb21e5de95a395afab6530eed3585ac737d42cabc435936775f110ee6d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68348257e675a76c8ff99e7737a55db0be981b5003a1af3cb8e46f3dc30804e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17823f7aff4a6e912755cae3d0332905d2a0901822e43f47797eae7aa7a9014(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09861c4b3c35bf72ede24dddcd284f545bfa38c60e662eef22213b1c6a4e0ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c71a195bae354fbc45649740bd3b2b9a5c5f91a7aed9300fc4c8d8e3436a2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a91cee5997035562df5a093d0f423d6430a20d1c902a82201d4d3399fef84d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7afacb4e8c2161b278def81f64753c236d6ae16c3711276137e1e2b470fb2819(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f8fc5330c7549009b4f73c82e90a53e38629c20ecc56062408855f83e3d555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886813e43cdb4b50e21aef1193ee92130ee8a63c486a682fb871f355ff86a3b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708caaccc7577eb46b53b7053f2daad1b0a14ee1f491b60a63003eb08a034af0(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8be44a9608d111e04dc70f6a28ca9414d9e5f459f5d432ab3831b1818d45c67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685490de54e613934065385fbaf4374dbcf87e93bfdecf80514d4487abb86043(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d2a7ef6bcdcc5d83ce285e5a02cbd2dde4103eb575f3566ca25980f07c7ffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddedf345e25c54630de00527f6e5cc798fbbb1d2f3cbcb3b0e20861ddcab9530(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7892db6c052a6d0e6b7f21256acfdb7e45cd48c5eb7fa90992121797832d2b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27cef59dc5f4d3681b8a71ccb8a77e831abe8046d216e6d823a3616640bb3edc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e35b1a20a8a5bd06d5ef98f056922d9ea4c2d774d072b57a10ede92a073e318(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ae625b8baa46f2e313993f8a3d7fcc682be707d9f7d22907a3e6e3ff708e99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a260e7a3bd8826ee88482c8d7d2dcaa31600089733b81849fcc73f1226b2de44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4438c7f666f67a7331571f6b10d512c2ad8534d2f7f996d9e2d57ad4acc075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7138d336650aca1fb30ca613065e5e0b5243a9296dcc181ea20c3e2d5e58881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30bd225893776a2ce9c3ef99f2e4934fe946306e63838caa5fc2ed24a742d1ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3e2500b73bcbee904eaacc0cac468e54cea7915effd273619b0a65f0e45b6c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248d30eec28d4c47a49b191e0690049ebb195258b4f40ad46a22276cb60df4bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37bb8e67fae9be9e67218b295d5be4bf8b97ca75a56cd4f382b4336dba6e7b20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173d6eda003ecaef13a99149fc729542dc63680a377a190e9cfb33bbe4f9e2d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2689c2e958b1ddd4b0e40b64d9599e3253fa25605424138b628b019b10c4d69(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6431aaada434f80b45786dd2064b8a80acae3cc3170f14d8c1d3fee661d0650(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2e00a27f2e221ec42ea22cbbc17ef6d152520cccb8e9cb720688789a1df73a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded4e2d0c1c894edd6c4aa39d3cde7812dddfb8aa588b362eef898b0c75d33e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55533cf56e8ab554f4b2ac4e55b7f067c4d4ece5184b64f8741c1e6124a5368d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55789cd7c95dbeaf2332246f652cd0b6be124fd71c8ec82ba29d0d0e2df0ac04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af811e770648589bc920782857063ec7845248a431b51ca8696b13ac457ef18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f774eadeb8a4382cd6185024567effcad281050c71dc51e5bdafd42a4eefd8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c4242746bd1bb66f9384e71e8e2c39c6d19b378cb89b5b69cdb60cb4edfa7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37e0719fa48ce3bdb99e25fece2067a0a7a55e6fc90376d114d01fff83c2bbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cffd4989e585d3f001e06094457c88a538ad496b4fa64b2aa5b59d31ee50e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e5c1d13386537c87cd8d88efa80bc9b8aca6f00f319a400c96c919a80e98ab(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ab75b084c4b9676f1e5d212033581deac253d5fa1ed87c1e0e1811475babb5(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2a622aab3ce0d21de257178cdca35644ab583f080a3fbb6ec8748046722027(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0581b91a65400913e64dc0ae859fce51270a8cdea1644a9065f66aa1fccac6c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b9752ad6595c76ab00444717ae2faa65f4852d4e0ff3c7029ef96ca760c15c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f41206e9786f9dcc44809e6886605270816b1f405baef72e72c18875d5dc842c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2430d2221d481d07676a7ee2d7e760efefa34c5e08619a7c20a198a9d10e74f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff23d91f1b55647d13259852dbafc48edaa8d217617ac51de97ee7650d6ae649(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6dbb092a9ef4bcdc14f07a9b7358f1ba4894103a496cd53e31a2f5126bde96(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173ca8fb4095fcd63aac7e1a0711e5e3657754d45de19cff21a68c9d77989db8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e13c8a9a9cebddcdc5fd1eff46d44527e7a7b957405f62877531c3c104d42d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cb4247f5cc9cb509741160fe70cef63ddd3f5895c5f75f68bb893837e34cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd0882f8302ddb85f8775dd5d45eec81a9e5b1928414beb17ba012d4d034d35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53bc7b08f51ed6403238b9a017985a6a23abbff54750d9e41e23405cfe8d9d59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36d15ab5d918ef66d8cd24ea96f1799bc5aa79d142e7c77401d2978cb603d46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29751536f9f179984abe177102998a0b45aa15b5ffc575d856ab342e30e227d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d379fa74e52de1a2e495bf7698fcd5e2b5773175211b06d3285d2f3dcf05e31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba0471f31ddde51124c6056a0417d1c85f7a090e08db0c53579a85cf9b60411(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d84b3d472c52a2f7f5be6b9b095e6344f8019b66621f23657ae37804993e090(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10ce806bcfa03fc5faa47ae0ef90af8db4cb8ff320070f01157bb0675f3ddd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee0a0ecbb0691be551ca0e5b8424516cc143f12225944b8ebbd49882bd248ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3892b6957c1910f7e521b891085ec70c493fec9aeef95a79e3b72c455fbdd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbf3d4a795bd04375e565abfce6f0dd12d29086ba4cdf0c23507ff0d836c717(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__575d3169a87047fb0a1786a9e6c261e4043d0f6dea2461fd6ef3d08536e99a1c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b261e698baa990363f869d90d70f8a5b5df92b412e54e88b02b93acf12b3a0a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13df88caf4d8322aacddcf3718d559ffcb6601296b399daf5ea8d8636ca03c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ddb38116f6d91d14f831253bb2a2a3a27c323ac63052305d1a85d96c898a12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab3af35fcc8d108c3886e87cc4e3370f27e7fe1c873458c17d6ddb080113975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f926bd8d74309a11357e89f95565a726e8f1f7b454a835a6c1431fdf51e8669c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986113b2274732942a6e00d062101de7b644cc4645feb844b5722edfb3f8790d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25b3bc6f0c59e6af43e2337ec22dad2b0729584da6e24951dc845a2dd36d7ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb4d4a68ea07c97e24c6eff67babcf3fcadfe6fd9bf08c5ba7f89aa0c59c518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41fb253ea177827d6d53b4810f1aee398810f2cd45c751b0a60dbd61046ce6b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e671b4587dbc0f6582b4c36afae176b456c681405182e0e70b4a1bf0f8164ec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c4d970eb205557c230dd6625a7b7c3ae1ec4da2a036efca1ee7409490665bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81136081ff93cc5dfe5053b2694aaf8f96d0aa83337ba7a8808acea7cfb5f8d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc9a8a3e6bfb099ed5bcb0498580197599fd776ad56571c60f23645a235ce83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3264a5cd0f518882e464bb3203f9666fffd9da46fc3e59facbe716e948f20fb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be6c98d193b42da3437299f52b47f12e1a0c35bf942e52e782d2fc851b25e73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf2e11f44a3cbe6481089cc30499bfce84af91e75f1720a2665a849c7b1fee93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4c7ce8eae9e011ca5c44926194b8cccd61ae70a6256d00d11119eb8e91fce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2196e18a47b3317ca63a98c1e96eb1a30c96fbefdf44915038c6f051da49c86(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb5c5b0e5cb3f656e2700eba29663235a3ca046c9fa49067852202d47f66956(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49eda4fcc0d47784ca7476b12d5f7e1b37ce5f5ec98475533a7ccf950ca58308(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ef91cae0de4f0d489b7d9d7792f0e8ac910eb8289000c122e5fff6962656bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c3bec05190bc3c423b83b0ab6d039bced96d6ed9b9e79120a286f7d2e1ecb4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c6be8203b81e53dd0e18a82e5f886926da12ea7ff796454e753e9d547681dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8d896ae25311d9aac6f65b6c567478d581fc79f1581d6bba51ca31dc383fa1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915f1d5a7af2f09f57c5167e62d799543753b1565b6648f8ce2c57490b3fb417(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30d5673563c84fa83ff47275a1dbf15fc311c9a8f4c860b8c756bda6d99ab9b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895f2f1673e684ad253245ba9f784e7a96d5c64e05e369decd63237b2765b3b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f4b04950ba39ced9c606932712022ac03c39048cc03c4cde9eaa9eaa0466da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda5cb65e5d6bf425f75ceb82b5d4d6d280c4e36d31ff8b0c1a06549883e41fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0977e44d7f75cf0ccdbb3fb7d39f8661e1bb577850e4f8c4c52df94592e9b44d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3dcd679b0cd38de35e4b0a1c8ae73e9c9aa7c8804e88ca66619afc8a33cd53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cdef2350ef2a63a3268fcbb5c477ea34fa986ab9280e959a641bb1a2409cd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5230af26f5f1a0115b27d53495449b11b6a648026a081e3d2f1a95edb19257d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78bd6688d5babfa9237faf64a85c19cc162a05637a0dc5a62c69381890ec6089(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818fb2f068edea55967be59b9fc07e3a1bd92f34bbfae983cb77f5bce27cf1e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea2839e6e12827f66040e2dd23dd01a1cefafa9ca040119b88b0fe4be0849ca(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca7ad5addf32886f5bd6cbbf5f20ee05a9cd95b64ba15ad45d17de046c0ccde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15739d65a092914affeb5885704d5c67ed9aff34d6f0a9544d250810b1633f45(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba3e0af6389bbd5d90f84c7de47df37c419f960e2e8736556ae4b182164bcd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__445a017598c73b15a7f64e6df523b753e8c9e539ac3494f987f35abf13b11975(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d87b834f7a159d2a60a66dcf9e06df249d8d8934a4da7634754b466276790a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a8221030f74c36e87370d862eba0a1b5ab7c77c8068a296b645bf6b7454e99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e995ff78d006d3e804a285e6d4102e8e54884dcf1ce21977acf49cdf1f83f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adca1e427d948876ce6030fde3dd8ed60790f1514f194c4506b1c291a27f83fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4adb6dfbdf733bb11601327182439eda3832c75820c38eb1fa196926a6fef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb31b68d212f2a4a195ae35739560a45c3642a6de4df6a8d54f1421e0e0621a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456c56bbdc20bddef358c544ad6f5a3f43975a3d2f4b41568a38c87ebe9c8cb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26fc9ccb3ffeade3e4f1bdd86c90a9d6a336ccff2e263c2be368b4beb20030e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c931c44ba73c0c5b74d69442867c49a8654a274a006b8af76af91468c514745e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7a29616238374956bb2ff30000aaa109821757579ab4a9f14a1db90df06a6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcad7fd17ae166d42825446fd98e8dbd9bff1f79dfd209c8708b85c9820eb56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7c3f3c1efb5c073aa672b5668e5212c7c3f0eb78ffc5dc6e3f8385bc5732b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e0228e08de21e4f586900c4987e654c994748bb4cbf465756b3f045871cbe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49803f736aafaefb76c4a9d385fceb5351b0af48057e1ef6cf46635ec8800d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d48e917d3fbc26e2b79738d79529bbfa991aa4e01159c32b2cebc795cbb3ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa75a9005a906bbcbbad4fcce8a7b22616f7f5a46c4c915024441e003c2e973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6150683b34e8f730b39c3ed64afb9483e54ddb514eca8388f06da3775ef75b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88de27fc19f591d179bbf4af7265fc4b01af2c0b9ee705e78b2eaeb5bb4b965e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f7beb9c2bc76ed23c5e0fa94e5c4381255642ba6ed0944b0a6c92a79c4cbe0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4812885caeff7088bebb0f34a90274f1c5122c9aa8eae4c24468beb4e2331cbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0578a5c61b38f8130bd4efc4f604239d4e1366939a0491c882b1e2efc80be444(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace84569f277430fc6a7d55e2a647bd7f807c1a0927910748722ea07dc1b66d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d43887526cc8072bc563de918a93fce675739aa6577ac2048507d5d39cc4f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc597665ee1ac1feb85003900a1b8bbf3df8986164df1fd68577fe2b472fff0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79963a8d3e0a4f5a6beb28ab7f6cee635038ce96208b20c19f78c1ae1b806aec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639ad7a3a150007a24438503dd8e5543164fb98e727933f6b6640fd98af2fb49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42887c9ccdedfbffdd379fe6b9a8340260f30833954baec19512f11308276f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb0608ddc10841227a1e1e7dcc8558a50f03c1083b7ac213b52bada253a4a78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc395bd23ac21f661ec3e367dfa827a8a1119f37720a879d3abda15f5ef65b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a62fc61e5b506ae0446f8d0582276bba024c1fa912c3b48f6552bf01b40787(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e32c8d73ea2109b72cbd20c7897c1880a296540265ccf7bc9553c8c742f973d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec1955b6d7d5247206089945fd94945a2c3b15a4472fc17b0a95c4f8db48968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34ae6dbac3b0ea43fa29ecc8668cdf8971e3b7463f43ee631815d0bb02fb3a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd171e77d477fc651f453f390dc3233223872e470511fae4d4869a8f7d7c50a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b73cbb2d07a7adff348c2659f03e9e82ed5f400090ea91b3371c1c18bc2b6bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5538c18160e807e3dd660b3869d299254fd3707e52ab2080ead84bc52b94fef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be67cceb1f5340090e6a0eee4f49c93d4ff01533ed02223948234cc1502c149c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a997a26aac2dedbea530cea3aa6f22287eabc387548e3dded033808a7aa1cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e3ea80dc3284922fdb70289401d05c406d084029b333b4015c08b4111e9760(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597417cfae44fe2760b0a4e6a95c081566420627f27ce032198689895de6ad6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1a260315baf6f317c8bee05e96f3a65bf679abedbfd477aebbb30f759e1fc2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77caad42dff3a51cff7c5c6052ca4351a2381b8637b2bf5f8fe65273b5b52e0(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c65f13146f44cac3c46b1ca9f6bd69ad3354a4a0d899eb41b70e6319ea31ca4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc32943ec8b6994834aec16612627ea2829289a6df891145d22e0ccb4e53aea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baafd2640ba29b2105b2683b369dd98ee38f0da012ae9bcacac6048e5de37f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c7c3020f6e5c0a9ef3934ec6075483fbc63754941b9e00fb55919682d2bbf1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ea1ecae0e5d4a8e51bee63ac8df4e4d572523847d991a812db4d785b4975fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29159134c856a95481413dbedad021d6a7c66bb90071cfce70f2f2b3edf5612(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83bd91a77fec463f55b4be1abae6487f47ec77cd1c86a97a70bc1d5d6a9980c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf83d1fde35cf5387ab499a7b490f06146b31a0c863457c5e235d0c212d061d9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87da6388bc95be25fdc90e09534068b833ea534202d0ff0f7b9c466c2f38eeaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26f556688b4b3abaf0619e4385eb544ff85c764ed1e1fce90c88141165dbca5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57742b0c57fff35e41a2ccf8748324e49efaa2688589f79b98b3cb482da8b1e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19eb6ef7231f229c003a58a0a732559017b5052110053511a26e8c4eb2fcad60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba3eb016b2c0332da23a3b5c7f7172fb1a216661ee2e9ad3d398a09a94f3772e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa11a33fcf7925d4d365a669fda3081b4864ab12a3d5a7bd681013f661594b0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facc73a106fad56eb395c4e7effdf7e3773e37ea30759f2f684fdaf7354ea0ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656933a7573767ca3dd433817a37694f7f97272621b468a5212c42f8d5b80114(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27856ab17208bb6cbbda3ff8a766e142764a3a14249d452feee5ca92bc745b04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b117fb055817daa6c8d8fd545a38c672511f534e21103232101f9df3494d6b3b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40df0366339b22725b1d785e47aed11861a17c45d1db933615ba7c33e404edb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__299b643e97605c666f7b46625a32bf868b2566dfc8d6173e3ae002b1de46cd2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d167dcaa74c6e7919f1f84e787d39916d1c4a123e366a358e30ed3702127e99d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ccca5b2899a9635f76b3856f17685b9e4fc973f00deeaea20b215f5a1978bbf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb27f5aebe8b42a2e08e1440f07207b51dfa6abe9d68c8344c6a2e72b4ab09cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2811fc9b7a069e96045745744ccf7b834e53dd9de235179aefb67b8fb8761e35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf6f7cc689769ceaff5e6300f8c91b232afb5dd3f1ff27238839afbfca3da8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec74287f85f5a892f2055c7a977cf3447e2ed6497c536de235150676a16874d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db0901a5f47434093f48fdc75a99fae8e4fd893513a94b58c263ef9848917e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c224be2886012e0271fc6649be865612774b0b2a6a59fa817e60b2d58273af11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a91667f8c662f868bb2337f42565a7731caac0aebc927f07d42056283bafa5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b3824cd1cadde54556161f891e3a47c15305c9c460d499be9fa31939a11cae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691227af568b49322bac910d7b36522735211e8e69d71af3d48771ac3056ffd8(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8bca07170d1c94a1703bc9844d9c475588d1c0030c2613e1e612e3a53e50da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc49a96fc8672be051f9ccf8b45e569ba0cce50a3875034896afe52cf87aa19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25587112294cd4c49caee32bf87ab078137755a8f47038b94b35de38f447e45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecabc10f257e7ba7fe2e885622cb577fa3ecd6a84b01eec52d8cbb558220ed31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3b970a65658f1675efa0bd7270c4983d81a743771fd3d646453ddb2f17a565(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfeda73b8ddb822fd816be6a994182a4f24d0f27f1c9b099931ee6b643b9f458(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861c1e7e06944ea74bc813208eefc194bd9b9857e661a6327908e8889d918f37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710a0b042d584e4c5c102b857f4fd873581edbed7e6a0f3a4a36b8f904800f37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6165e052e2f31397a6a8676c3b6f6954d59053fca613229d45f9a6057b43e22b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e963b0e3ae889352bd56cc05e4b107843de659bb83f6d1837fe1d76ec641b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121cd91574490f4d72cd6820bc174b6b2faf3c1fd935f3a7b668a8a84c1ad7cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd543670baa9516c997b3c27a8c02bf996a9504ca6ca39c3db8d9b8c09c589c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb1e339c6a90c779f7d3a7ea4a6a0e96bcb425319d4ca6d58f3b4ff13add7aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225dd143095b943be8f4fc7cbf297aa82a30461fbe1be70cb3c07fda67b5f060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41a4703bceb86963ea2fc3aad80620b80a5a2a6e83dd3e7a5c4c840911be989(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f702dc059a92f1dd02b713f3ea36f44be789ad70765f7f4a1b896f7bb8bea76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c8a481fdd70543fe61494d577217bf493fc33bcc0b8e273f2afd38b6244d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c139af8fe97e0064f7876f96dc9f3502c955683fe880f7cd2b69784b2c93da0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534f794a2bb7415a1e896a739661752560859811d800473914059070fb0ae857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2dfe9f8a064a28c05253bfe6373a8b70d576faddaa9576bfe938322a30d29c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d5a46e2047c8d85e2b225c99c2982366c486b28b760ed77253ac93cb781b00(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60444871155754341fa9bac9b77215d12ab577f24ca1ad4ab94b60e2a983d565(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1629d2046d939ad473bba49e1183da3e604c7fc4233891f3e998aadd3276bd8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d69d5891c616fcd43d4be6c2450025fe55d4be8d81356706b6eedaabd73983(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f433e1ef94479dc9c5fee67bc2ecd942eb8a8c1ae34cb8a2f8945d5473b69cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa256144b52e49b33a1825ef884919bd1e78dbfa6dd91993f6bb9d42ec2e1d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec4162cd326c7400632a68e1ccb8397d6ff46f58685948ae4b5a0816a1a2e60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5b2b000ce117cf2b3aeccc1c78bf5b23c5ba468342971e910fefffa5e41a03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85102e30d86eb8377c130c1e7c003940e12d68a55f984c539970e26f384c09bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3beaaeb88844f0976da1203cefcac3731ba52cf7959f2fd79d479925af2eb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb17b76ffa5d6318a44b60b2993deb7f5f6fa302f9d42a0607e866317fe3faf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94e66716a7ec553ce8e5b989c23aacc578081f79fbfe4c5e23ebe61dc35d5119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1978d453f1d387f6c8acfdbb6eaa2b8ea493d11b0c00f83b28cfeb2a926685eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb52de3d067a1736ee8a23a170b52e6d2021578e66671b67f81fd51f0105f88c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c7cf85c0c5de95568f1041e13a4fa6f3c50f3bfcef8e89fd8e541e50d8130f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b93427cffe9248521be4448d59ab32f9e0966b88fbd7710c9382de7bc77a15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eeafd29a10961d80bdbb8801efe026c82fa47cc137804c0149bc25db16d06ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a44efaae612e5594c0eeac77175c79d030dbf253f1a73b541f5dd7fc510d90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ef44453c677a3cf99e708f0fdeef0782b8bdeb0ee967b7ac4d920e2ccb4fb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a6d7eae0d83b6543c7393c937e68e6522c3b3d08070988da3a62234e9bab99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e238253c1a472397235a399502775598e50528c980941613b7f5fbc21fe879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe10a89e028d9cd49c0423ed7c6afda2f0f845e1ab6c14a07c73bebaf826cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d733590ea1f28248db1a58655186aea02aa4a66a655aa4a5f95a865c03070e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c968a655f652bd7f0435f00f448dca000200c315b45decadfe49c954e707322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0b919dfbd306036c942a2cd0f8722bf31798823f118c7c7bd19f44a165ebb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0006a3e273e8d714bd1cb9ae2340e797b7e7d393f43b0cdf65a99c37af79ae9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b687eacb8a06762697a4ac5cde820b248efee5277edfd3021f5ebadd9ae3a16c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9032e005d8f9dd90a67550370f443de81bcce850bf86bd06f5e65ef641e010aa(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3126ab08eb09e3247a4f98eaeb8966d4e29db55f80795e58bee228e729f16d03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2309448d290bae448d798b2fa0b431592cc60e20bfd23523b6aac1dbe6dc7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04516d43ac3e29eb955279732a1f3b19c482c5527ebb409275201785d637e3de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d6d86ffb93d50b88aac1f4ef4c0dfd4ec2be813e710a9411d36b66e0f6bc57(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad8b32ffeb302ec75210abfe4de106cbafddf3802118050cc75cfc63d1add7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac43bf666d34ed0a0ea69d502c1151c79ca952f22b228ba0439c613f23fe41d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca91badc730089a6855488ca37b22790047e650d1c1f0f84d3c5ec0d83cf183(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e380e301045f83c354bf19c5fce64b32994f54a0c697d6101eef5d0e7fbdfe3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a646b71bda7e7815b8b69d904bb5847f2013f05be86c8989e67b5284c0e1aed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90895fea3a64305d1810976ed44edd1bc2f33fc30fca2c6e8db63109df28b5be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42269ec345d7428bcfc71ae4fc0482e753072da6f8b7c8eea70345588a6d796d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8aa7228571016974aff70c84ae52e92b308a30a696874abadc430d651e9897(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a1b0d99a51e0fef26437474ee3f51b5d9c9d29e6647bb06f2fe4ccf8bed386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36495cc99a3974442146518bf75caac1f391312ee54da11a8a9d636336ed4e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08acb0a520c66641c3d9f9b832deea73c82d5cd219831b2909ece25a9c404fc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db31017ff5247c1b63f0e7d1241c507196c24af2df59b4014b3a1365534ff24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b012b79cd97b7c67b80519eb390d825bb35ceedd16e839955e3d00e3fac8765(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc6a5ff78e343a50e00c24b513941d67497d61766197ba8c636ca8b47bab20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749df914645c70917751c6857e2e382f1349288457c00459d0072bc5ae076627(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988e095bddf5a2eb4394d5138f65738cf551403a4046e37005a17728dcb9e97a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d7b8d71562d2dcf4ff073cf50314273fbd2b94e56a2f8d04439c7d3c3274bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6370836a4eee2a2b9dc3cda4677fca107cb314456893c694bf2d69a53200019f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb20e908b8030f958d21689ef742a5ee919a288e92a67f57fffee9772b862b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac1c042272adc22bdedbd17f7d7482fc32d732c96c367679d461eec93c737fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cec1aafa72631d0daa5a11d3b763a05ace48514b715871ef52ffffe68ef5ca9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4692b2335e687199b11c17aff58c693c74e1e0a852b04515e6b29e9f0961d1d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3246681e2b15c5584764c90756da504876bf99da02071f6ef0fa16fef17b899e(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3acc20e694c5b3a6a3bd42ae4c8cbb9e6201c9f6d1721c13c54cbf8a0eb707c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd4dcbf17900fd438a24e529a4c65836cdd6d839a11bd0ed97445d336f65838(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d86f8138faf6ba55704f669d2b3c8d272c39eab9996aa0fb524898e305ba13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40daf404ab98dd839309c6651ff696c00675c8d9fb884aad7c247436f3d899fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1617c3727dd79bdc09667fea349b868253d5c11c585ec846426bbfe6a7b4237(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14acb95c21d93df0fa0ca30cf3322c6b3072cf4fe12ad41208c6218270fcf9cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374ad413b76a2d6a8e44140ce7a7f5bf03663b7d90d6c22b6b3a4e7da58d2bd7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eeb5e6093f92cd5c2ee675923660b709a5aec21a427cd7d38a92aed2453ca6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77150e2279f73eb5f5733c8a69d564c35651c3bfc945998b9f5794cf434eb6e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c2599b7327f5da54ad873d0ba77b9e5975c0c597c5d46c65b5099c86327bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5d3b088f424bdd25f97e4883ee7ebe3473fda73cbfd320dcbdf274b1d12233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54990c1172bac412bf2970d6ecf73e26a99af88d1a10a8dc382f02f6edf48c27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be46741c5a131e285210da76ea9904ccdc86c3e2777656d1525ef16359455818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cf1f36d05cfbfc7bf99e4618e7fe403b58ac723de8ca9fb526e36a9c24c71e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9a758884c949781397a66f102213f030540574c9f13f572f5102687711b4b8(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bf3cdcc4091b3867c595c1155f3157d55b2631f229276d6d1f765c901bc1fec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00fa754545286ebd79c99fce27c3ec219e13b12dfb17f8a56d815e82eed9db8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dcc019899be805ab050666c5fb37d211d6e68eb0f12cb7c8882b33379a3f9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eedce9a028d303b2ac2b53ff70b1bacf71d05b0a0ad5eb8958786988d8b0c60(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ce840fe03a45ae672b5d4dda7a9bd30bd3fa44bbc257747ee4adff9adf3156(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e147b7005508de5651f78e4b354d49eb54a20a4c7f7ccc8c5cd31ccd2c14099f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd69599c9dc980073126195087ca2d8cca981b65a773660c6219d690d0b89a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd3e5d232fdc7848a7c9668ae85b1024c3c232338e5e571e27a2dc16ca1336e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3e9e3e812aa0aa2daa44e2c502d6549f892e7d82027bbe2f6801ca07fb0562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497f68985f814b2551842a049688b659b024eb9d79a79dd954a6ba53491d9242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026888490ce42b0dc037515eaf02a0356057d94a0215530f20f673fb04809341(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee07ef49e292269e9fd59cfdcaef8b4d36a8a788c96f3ac45877ac3b891ab73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06489297165b206a7bf0969938608b83adfeabc267012f2f1e2549a17709138(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5967e4f63e1fee12bb8895091f4a14daca4c215eb6a73c5ab1356ef7a3941f76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa56b985b9a279a4c784b7ae5ad28b2bb3688bb7cc4ab5407cf2c451adeaa5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48be7a2e607be75561ae47dde763519049c3247bf089aba47d34168b2d470232(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c139ea391b0651d9922b5a1aa142402e2befc8d619d61077185e03c4b689c5(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ae5df3c4209027edea1beb762194b9a27696f27a71af885ff5673ce1353194(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06428eb2ad5484f826892c4595905da93ff786fa8698a3a59464f280459ad4cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4b688cd9f513fbcbd9d0f7a6a0547ef9ef36845bab1edcda3d7003731d483d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2109a6a23d14da822cf9ebc458d13c96970886d54efd44a8cf09844537274580(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c452c94f84d577be7900deee890c1ed7c69d3f6aab7d47d81d337569758dc793(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc3b2e407bba05db7cc57e1f8aeb298b9a55dd52ffa28042f94c92fefd2464f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1258671fabeab20084207f1e9916c7ebdd8a730e963a5a34d460d2d98a9fed46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb8b7bf7b6f97dcc11faf8e946803f3e1afc24b0e8250655b2127fcea05478a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6749387458bea8241844c87ec4111beb6ac87e03abfcbfec94ae9de3f012cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872c58fda3d90a262e5c1d8f4d05075546f44fe77bf1ab3b527ea36c0a584079(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16023b07cef806fd52e742195fb88823060130fbc0a1fdda137e21d3178bd0e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab923583894c142f9a65521fb95beb78bc661a81d7a0d01ad7a5e3d354c740d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ab4bcb656757523128fadee7a56526168e3e79814664735dada65b8bf45809(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14dd6a81d3527e9c7f31a058061927dfa8269f3646827ac95e7fcc4ac4498950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2db8d5ce04ceef059a17c598e9b47d1c1cb0bdc4e455ad00012c0635359c35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__349bfabe25bbd6f39b763a1cea50328dc43cd1bb8ccb9cd95b96d7fa15737b5f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65f49f3214213c0c6bd1e575ce12b214b3cb85165c2bcf9fc4f250b5a395efe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ce9871b39ac57398a1ab1881ec94884d2d7cdea33d7e7d09b7390fb067c303(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa16f0d7492a5b067d7376ceb0350708ddb7accfc6129d25b4cceb74fa9a4f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ac1e6a4d25f86eda3043121902e956276c4ee72992639dba69f5e2b6e7a3b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53aace6e95c94128fc7ecd17469a4ab8fb4b291b0e285b1f466fc3629ff339b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c6de769d90175a74cf558593ca25bdca553e27f9a036a8eaabedaa30d97eea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55c4bac29df13c872a2073e93d261806f385b45e66af399386bf54da2799603(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e87bcd9bae34912cf76ff174d0839e71985e869e6524c689f2685126384c92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cc50078d2e8938342cbf7026e90b7ea8b90480a5bca42cdc47a3d48a385dcb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a020bc6dc57c1a85835117acadd0d342c6234c35c0af141ecfd81adc8fa671f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be46a5c4afa5be6737aa9e8713ab0d3f26b1cefac131e41bd1111eb487ab999(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0ec0b3e1119fb4079bac32114256be84975f2087daf7e37cb61192cd421a15(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e242fa28fdb5842a4f657dc53186b3a4c08862b717ba11ccf08ad710d064966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595d354c4ab93842410e852f8d3b532c35bf20a089a7477df4a35bc6a7b4bb76(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3adcb036fcca7a56e21d8d9b422ef01f4df029a55dbd7b9f6bf05132f7590ef8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3bdd78ae8e6288b3c675cb9a5617e38ef6ee1ec7ef98c1b5ae7ca96f287eec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65132c3c1196d5d901c82ef6d36fa5eb93bfb49101ab9237b959e476b8f3b375(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90720ae8a0edb4b9c4c5823a8e398562cfb933841a9fd3fff68b84d52cc06649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18d8438f85acf5185ca72cc1a3373c688bc41ce9706bfeed400b4b94121b6fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19f26a84a3d12b7b2cca8188ab83d2cce119a48828bdc524348acfbbd1bce1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e3808c2329c8c08031516bf4980e513bf06946df6584d1ed1aed8c7faf8603(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01def105b7ca35f38030d3cbe23690b71f282039a9a42b0c1e86e83815bcd52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff378e3505428cdc6c13a06375a8b13cb104bd8422bd2a2888985442be976d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99788f4410e297aa4ec9fdc6285117979ad584a10f3ce0a5a4bef9414aca4180(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7a7afe0ccc0ec4eeaa5f6e78a27d6ef89cbd0fbde532779aeacbbf52078170(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a9b88b3bd1c5537021bce131437b85f5e61be225fc786ba4b964b5d768be15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b021e13b941f25c7473954d7f6525109a604b7827feaa8468748539a0c4a5788(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad1ff931c25738d382710902e74dbe1c915d97daf00e4e2960cd36c8caf39ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2343710b51630ed7c2cb2056f24adc808c01e15ad31a9484782beba7918f3d2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9e8a470b2dd6a259d39b2cd75659757c728b7427a6b11484ba9a1e056afe7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e571efdb43bd84be5088f5d538ddb4835f52af169cc2ecdfcfeeb3bef0facc5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ce9fdc49f36794a5404d8a31f375ab31969bf0988e8ac710234482da73a366(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e5bc89c339d7febd2115cc23878a6c5d0d99a0df903ef338c4ab414a9d7ed48(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ae8f9761d12386dc93aea718b2cbe01e03adf0574c8a056f2d7b5fee5191c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1ac2337ce23e9d1b0bc5fb4da4e9ba5b4efcd07a19ddd91563aa48b103ae66(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963799f5b9eafe0c9099f4d1187e52c48a7a752ceb4435406cde1e3f9a95da68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d03333af2fd559e7146a4f41735e12ba0acf26e6c732625d2adb8b56f5da5f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da474558728de7f43e826ebcac0eebc571757ff11f3be9d77accf1fb4935eb28(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94032105bccb7c418a48fa79b7bc4e0a842405b163dc9c50451b685c2d835ddf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a497a8d4ab13696f3aa8eac303098abbc97f84797b7120b66e2b840a2717df20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eccb6d31b2def405c44fd0110247a65c426ecbd03a8d89eeb80ada72c6cb48cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0270dfaea0c37e0e78bcfc680ee8f915d828460bf1ab026fec37abb31e34c101(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8f9f22045f384abba80dbfe21d14c13d9de722d0421875d7c9a732beb3aab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7994343c2028aa6c5782b8df8b43c7cf931961963c277fd2fcd9a47fda630d7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b7db16e51d45c200a003ddc8fd07a51f8226fd0ede98c50238a956c81c5274(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f90e4d9f75d851b3c94fa281ea543450a46237f59977c8e3cecf4d0768d659(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ac46b3618076645d5ebd69002dc726e2545b082d2b803ea5386bedbe120889(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1085483f7e287ec791492542c1d0cb8dc7ec791e013bc90f372dc921be6da346(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67cbe6e77b49928ae1e418da8507bc2215f73d453531f6138a4c564129bfdc7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0867afc3a12523a16771383d29f5c55471578adf694531d8531dfe7e09ee2ad1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95db5bc5939fdd3ebf678e08354caa9d0c0c052d7f147b44b3371c57ad8114b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03cd5dcc2639b46af708bb731a38f7b7d9b45669f375355c363a330d9237f1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c8b9a18f3f05c8f11a9b7cd1f102f1f3235802687877c2597db23021d0834a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df316c5cb51f9f1758eeaff57c9fa2afd8c012f7ffb1373e8bfaa6d2c8c8686(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8658a19631c07bbf488e0f49fa82ecacbcbe8ba70316568c62bd07028a62ac86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f1e8240b701fa66db670bcbb181dfe96a88fc57ddb94fbbdc1864b975e91f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12fe74b8a7f73fcc542d8bf444c054c144773624fc41606413af2b7884c310af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6f8cbc327ee0b3b4c66ba8977d03a567c58016a3e5658f45084ba558c97249(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79d6e204c192b94e6fe99520245cd3fa39e0ab8a80502c8e009ca598eff9082(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfaf2cb01717833582fe8d012ad99551c6807cf988317477c80f00870937b87(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367fb6fd0a761c08b081b96a054045686f04a64b09636a3977fc07989329ddef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd2cf9eb8b21861d193497b5df77df24b2dfe84604a0456fa8423df48c43f44b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67eed6e19818afd7c64e74129395d6d47a86f6a00dd277310385dd915b2df305(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0456870a1b78c2bdbf28211d216a95c2b0c2ade5a853a18cc4d2116132b1fad7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d13ea839170b708dd828e6151692be961d79f7e8251b19aa3ad0b5c184e8fd9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd6a9b587f662eb62d13ab206a8b2f4a9c070a02460992b669f104a624100b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d767429c8405159216ac4e1358a4f3cca38488eb63cf534f5c07b516af657bf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c5f7d63aaf7872b0788f2f200a92c56cc7fd5716ca5c0026d5254f31f2e850(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae02bc899d89c32959e925348d8c3ab95d9aa9eca0957c7aa3f9f81465495d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7dde8672a4ea24c8b0c67ca3b9918986ba4106ecfdefdc476b2f864ba5d6ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b009d2ce9e9c1fd9bc8f02d5b762f41ff6364ef12f2ddeadb85e2d3047b085(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819d5f59db8a3af847d7bb1cd9ff83b26156cfc1b34ed1e71b0f193f9ab256d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee266953a84df57522840ecb62841c136e80893eb19e4d37d97d96d157ee68c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1704aeb6dcda6e4b31c0ea22ccb798f30e4dec03a395586acd79422cd8d6e6cd(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffa0bcd4dbdc3911aa97917e82d4b062a2981e9a62234e4ee9b99b424f4ac3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c660d40be2614d50e2928714160c40354977b838b2aca69e1c740cc2f27339(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9880b2877193b3757e6e250c5c6c552efc86a0ccbd9e8999522921c8dc5d8d02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f33a122bbf3b7695625890a0ec78375dba9b713b935d427c590632ad32d648(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226613f97031044947f27c21ed410baeed937265de70cb88db0abbeb060e33c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea49e6c9c9699d7473b23e35cab509c5c531a412b8c74041106553fed7276df1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e722ff5be583199178ca66866df57a12a01170b51ca76e175e6e469e5d318f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d25e6f389bef04ac60a79f4f29d1773c1d52a9c979ecf4967164e81dab3f263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd206f4ca4154c385ba1b64e890e4e9a423cd9c3edbeb706517e12e9682b2e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a561699922e14a1b63143db8d627f3c27b234ff5d45c68a5af42395eb533376b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4009b91b91da128d69c770bbe7b64412e3dd57c31f3a62026ff1c1f9a938a43(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a064a178bfc08856130c7165c998e807458501cf529aaec408b2942b320489(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c7462e414b0bf13050718d5028c1d8ea48278a30692384531095013693fb52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4f0df75511f7ee5867004e41d1c8bcefae3a9cdf83410fa690e9e4937f13ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b39729df5c7b337d6a2853be6a6ac54fcef3d2f5fccb7fab5e1c54d85e41a14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac01a855116efc308ef57a3513d10e0ba5e2db129dcf82fec5b4b1a6e25daf5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3504be416718ff0ffb5d7ddd41416bede0e22d7af48e55bdb6a1e730495647f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1afa0329d31d6b4fc37f8bc6b2ab9fb0a2351d0949a617dbfbfd71ace2dafc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ac136079bd29892498d625a08c1567128867b359e9a4e481037c2e4a12d240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d48ccb3eec2a6c8b53b9479e1255501b77dc2534e4fb6647df4129b6e11a05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d60778ee8d0ea61b4c055fe56e31e52751ff1f825528d352dbce9421123a1f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25adc4126209cdb07592931d13c01c15733d1043ff9826be5965aff5ce03a7ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66dd47d48137872b8207d1cb8ebc4b47fc790cf174d5c3c6a08d4eabadd55c59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16c0accd5f275c32e85a61e6f4af2212a6f17094873279be0da319cba3fa382(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__896bb3cdf80b09a2ccb6196654c3a66c8b58a538f2d12fca261093d4c50e1b2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8684e36410655129af9f64478c2bb7c1c1340d2ffc1d4c1096779ed8270472(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af021b8657460996293601e8a75e988a2d1f7e384d0c890e1a556ba4ee8e9f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcf3fd33629e05e016f1b8e6c2dbeba63630df02c81878c1a01b78d2a4d7faf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4c85da2006d12b22780503297073dd911f836318826e4f48cf8af2ac80bfb4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56cfcb3f3029a10c2953feb8436d01c7061d7ad54fcf44bf5e513807346bec9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8caf6c314fa4c92aefb8f3f43b057819f27d7a05dc5f012b50928f664d00d3dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e260c3e028747047458517682aca0559151ec69d5eb226773974c3efcdf20e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50b671914b60b7b336a893e2b76ce47cb8743d879a0723f6f25d72322f4d876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467a65af2d4c6b0e8a597138c50e0c90d044dca60ecde0cda9118fd60cdbd330(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d81f3d9490ac6f70a333a171fedb7e21debb55cb17b9a6e94c7f1c8aa72362c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b612fc9d6ec3be8fd3cbef6f80a5cdba8042610d51e128a1eec29b846c62482c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12aec85595dd340e15ba206841e929dd2f83ea783a169c622f1e198c7267ddd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fed159c9a766e4aa98867753adcdfd02163fd60982273545fe0cfc8e550209a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec4252b1bbc7cf962de99fe08d3e9dd69eee7c26bf9c3b06eecbd650a3c290c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f656aceeff3f47d344193051748c61cd1d95a9d8149b079dc0194fb77fa5ef31(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b2e749e7dad047e834d569eec4f33e7af3c71b80bce721b44ce195f1db6a45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772aa4bb459f8bbc6c767e437ee7a3d2795309ee949743a3382c0fb722d2bfe1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78744e2e99bce67bf00c552c2799ca83358a7c8b3e8dd81eab3a32980b7b88fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a99265c0155b2a108224e5d201397ba29fd44233350cf8dbfcbb2e9311cb8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de990d84f36ec567c759e1b00816732755feed73acdbca64d478f127ea027d7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a3b75a32517a616ce553a93ef8f0d9112c3ce160f8a7069b96085be6ad00fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2b6628fa084727537bb134bda6bcbad1c00c0a1f784c81b6d212db5af95a0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d4ed1b65217005a199351e540838becfb75e71bc986698b166cbec92138b96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb09a590aa25d1c2fabfa042becbf166b8ada20d44df867f9921b3f6443f3d11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9277994a85ee5e149d34bdc8a4899ca0c3234a97cdbee42ab0a26905b4677ca1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ddb2daaf84c6b56d8196bc6e6e56daf6320fd12b4310062ed40cd90b2bbcd74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad284ae52b75956cb64dff64f4ef216abb8b379821b3b1b98f30ba0272e1b8cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6b51cedfc00c6640b89f95020e355d2635a468a534f88053ae3bc2d111839d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30441a58c7c8d3ca21183905464bc9714997c77ae6288179b24c0f3586c09b18(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01c3eb73fa30adbffc7b44fd62dbfdaf06fec6d9d2d42c43f3c7721f922010f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da948ea8ede16eac3bf5b8f48e8ee8b761bd305b1427cce4a3888defa2e2662d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740c1ae5566df5e6c2e98918e5ad140c63b4bce2f6f21ad5e1bbc9ba86f2ecaf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e35e4d634fbe9933d47fefefe6b01fdd30a94be05eacb2a083d78fcdd7131d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbc06f4a1584af0b784b2d4c0baca6183202ad321bb178461704633c1411f25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acec96e8a8deacf66d7648c9be14a86772be2e564856d06e6537a98b724676bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b1a385eef2e534091b779b9433e670c8729a18aab03058fa95976a82ba3b67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d9001af373cb7c5291077d4b38d315ee2a428675a9c818b2000df8eb190b04(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c441c5dc8c9ed5f220af0807b3fc937e64130a1a41a7805cd3a2df2b4b547a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901dd1b8c62264791c6f7d4d9457084dc80df8e3b80641c9718d0af90ac9b7ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193aba2f181da7d27c7db2109fd3b52170d21c1a046a20c0f5c94de6d9a689c6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f6fe51f136864e365b757d9e1c853cd8fa25534f594b8e60f365f8b4b6dc10(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8c57d5a7607b446f22690ba0b22d73a0c081bfadeb1844401f89e8fcb917ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fc45beea0a008a2aaa8ac8b0374425ca0cefef88a2ec84ca24cfd54f492d46(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be278e021c5ab216c4d6f44dc930c8f4ed2ba11267f9819c9135f98f1a8b79f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddba36064a60f442ea397f0d3809c811f7ee68a03c5baf23ad3c242167ec27bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b37bdfd7b76ecb5aa42e16571093b5ebe964bec3ae3e20952366285854b4e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4cf77ab15095e953f2a19d01a0075e00e684d455b255d8885ad7e894d55acf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ecb3d939816f0a7898cf1d95345058135641a44bfcb8587b7718a7aee3987e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f003d2e42423bf27b63d431c0162f32d324e40cf1e6304328c514e107e5960(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af0ac6a1578456b2d01ebd8abb5bce9d5914ac13938e8ca23ae5516464e6f15(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f87ac7de159cdcdfd7a6d5b82c5e2c79f749b0f93f8abc0b4899755aa2ea11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8acb916cb0eb123c7137db80323848e95d54bb9d58415eca3ba0d8389199703a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647647a0d4b70f7d7412ee38b3df4bfc5c78a5de29dfe123ee17c96833e68870(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33af0dd44dd8e241aa33a6151795dce46fda2968eff918f15cb3ec64f15c05eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361c6b782885748a0d031ed6e7771997d6c3baf5283eca0c8f87135aa52d1c05(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50d52a9a913ffd3dda9518b77b3c8ab6be1271128af855dff9f0bd3c3a1e007(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54365f06463d4aca02bc964a9987ce124ba68a9eb835aafaa171cd96d0acb8d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c071193403ccf8bb228357b3ee14dc3e21aa37e2910bdd94e0a7d8de57456df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c94c0a22aaf5e087f2af74f0621e97589a47f99708eb55a342966cc4e9cefe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6114267ede7e5cf1d691da05dd41d5c43417d23849daf322c4d0b8948bafb8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6811fa12d86aa854efbcfa05bcca2d626252399b4c36f8501ebdd6f851c46eb8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519288de18be8ab67e6e590a99b0f4074df2d7f37fcfec79f627d04fead63c19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2afde622c7a6e1af6f06ca12b0f9c58f723223200a3754c164381da91d53b91c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f72a7009339bd364e6259b94380e462853c28f868aa7598c1d13ad3e392f68c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e97b7747272b008071b6da23324301614f84f300f5ff59d320ee76e92e8d802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d2080fc4599be4881304e79298c4e55dba5bdc9099cb7ba65f96921b95db1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaed7fd7487863bdd10265a13d50d3c6c87c2f60b82058a118ba916e10a6ec53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11e9a92313370509e7c02ccaf8a7c093c44ea9a3c8a6dd58770209af2be06b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e474fda5ab97ea0d7047987686ef89dfe79e3b0db4a724789243e252515940(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5218493419289e40226354203ddc9214495ad9894f1d662df307d4cc95543812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5cbef2090da6ddd354d371f7fccc9b8b12b927041d60e7c1c58578952bb3b41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f93783cdd8c2ecb602d1675944346236dca437ef37928768a5835003d3020d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d08b272b783fd448b8a9e2e557833aad23f43a33961fc64e51d845d08a7758d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dabb5a0534ffc728f6344c73d407e0ce971ed8085f1ce240de058d1d1491684(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8115c1f7ec95f4c81c131525ade24f5dfaa30187dd492d910903deb119661b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045c169c04a61912ee64243df0cb087c8218565441de7d09fc9eb33acdee37b1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa53fc76d81af7e2408c1659028dd6ede5079b5d8fd388115a7200dba11634f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905e17801d8cdab6743c1b017acf7e29bf298b20a015a307f4c87db8d4998f0e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b749e2651332f5e6221f50ba6a3146678375cbf221c5cda2a29494b5e812ecfa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900a23e99534758459baa6de4d0990525afefbf690bd27edacec615c271b55f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ddb02700389bc7981c23350d8aee1623552aeb5a5563ea7e155330fd0b5d93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1398ef23db83193509942cf2651668ed370f521f0ea060410f984c2c32602001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339980b383d30f16c25564c5d1546cd04757e97b94aac9ec08316b751d1475ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06cde8c9a77041cbdcf851bbf323614c62ad3b9136dea27a4e344eef2158cc36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719e6899f158c32020cffcc10601560b07b88799c7c7fc2f7b7d969bf6d65d06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97aa4468bba3297c4654a380d45c4bf9e27095cdadf643c2a0612323e6ddd5a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8e5b0fa5dc901e958ed19ad579a691de3b98b240a869b113fc8e6d9e4ae8bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95bf96ce1ea9dcac94cd2907c30ac51d80998a4618f017426fd662ebc1856fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f2ec70877e61f1fdda6e128fe755922191923c5e3f486920c1735d4912bef4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4855239f7e57ee494d3b4827d5e5447a232f4f2073aa455c0dc964b8716d4560(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ac1cfd5672608c0cbcca78864fb38b89bf73d0bc8df61e3a9fcd07fd3fb55e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd746d59b95713d82be07bdef1e140a069fe46c9b8feea7239d3752cda32fde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050f8832b082499e2e47d81ed3123902db93d14da4573832bf35b39e75128dc3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd4369238ca48fba855c1907a523f26e749fe253c5d7ad6b7f733d19f10ab00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218170a7cc9962cf3a3befc5fa240831e018e63d473b2876f5aa84c3972cd23a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51df636b5229dcbcd8b660b0f870a8bf6b806487ccb950b54b05a0ac7611a0a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b0295a61a41c6b4495f821009d3be57e8f175d5cd83ba2741c477367ae06cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3463e3213b437b0b5d362b88db00adf5f281cf60651fc605f2bacaae977cb77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd9d9b4dc7c5c97dcf161c6a74b59e4bdb390ee896aa9436769efaee6212382(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db8f4db7cdba07243cfc9c8e292c5156cc2222fe60b63a9197c9855d661cdfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1b2fb36aeb4d0a1d1d08826709a3a844ec2898f30031e1e8125f899f14d2b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04115752c16956239a4c459c408879944f0dda4c90d954088a0a03409e79419(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5029c07a96d1f1db27e91a6226f798f5860a0981a50dfc17a83a2b48f86a218a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f722eec0508c9d0e25343cb6aec34b7e83cc74b5787654138886db45a72e24b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e026c694fc67ceb8ed21396e19f61f4637da47cc8075f492aa67fb9c3204f08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4feea36482668226f5fd0412cad4f6bb4b059f4ec82ae9a4ea961bada4089dc(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4782aa59791df177e9ca32d9ef21bfb9899129065b1ba856a9c9494d2b3daff6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3033784b9e1874093025050f41fc7b4896ddb1f9e08f904a21afc95e7dce3ab9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7280fadbc3c67f466291b229654bb07a42b256bfe2b0b8bf22c6cc157804ce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a3c2676514fea5d580c241a1d0a6e054f1efc33b56283ccacc6c8a8ed246b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9773d6a9fd204a39f90f890bc5c727ab2b4ff0f5d206b8d6f4b91515b8b90c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a9f01b1f554e14c30ee4b431de8d16e2391c2d848c0ea0f04632ae75cb2889(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5638fc5be1f8797784571fa01e8bd8be16b3b3de677070131402555f815add4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8941cc849a31ff57bd46aac1002ed6c3a14ed8d062ea4d757ab43ba7a9e29ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd287bf6fb594fffcfbc67c8e6a3f1038c00eb59f5a4a49c9a2280c401cf4740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c2414fac5f3bb1bf37378046aeac6cd054d9e3d089e699658dd3b86129765a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b3f3ec0d5034df14857aa273851bae5708c37a6ba2347dc2cf6cc3b072421c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df172159cd0ade8667dee1555c163842fc95e4e71c2484465f298e245b86737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eae2db482cb7a01d8adfcdf54629ef334d67632825a18bf5573ab23d6082ac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b048bc06a5b92d514325a108d17e03b65086a94d438475da721fe6cb115ca64d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148f495e411cc4673395b3612dac023d64c15a5de1e9e56c5392b428926b2d52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d46c94ab25dac0b9362e08d22db7cdb4075c6f35e485b06e4587ea31d792c2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f45aa1dacf56d50ae3545c6469239016ab2ff5a3902ab149dfa759044483b1(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46c4e37686b4a375b03d9adc8ab6f09e69327e204ea81415eda6367f2d97899(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee68940a7174600e7151bd9b4806c901e0c8f9a087511328472b00f229f88b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c735beb40268de3f591e0a5fcf43699d8684f27fe2c739cac7f3ba3736ce4ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e618ef25aee19ac5de1c9cec69921bb7cdbbb553973d3f86b609078be3c9387(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771313f8eddb1e2854a0d649376e17d6b71dd7e73225bc66775771f341219635(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198e1572f7ba281443eda902b38b0f7d99e7c3a7eac5dd4a757ff1135b813819(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6cf104051e7bd48af59148239937a5dec6be1271459a81b9d7d6d146203af5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9400f5079e17c1ef5e96fcdc14fa598eb1da044732ce0b43dab0842726dc1c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702671797aa06af7c765360da8205af0cddaed7d7a4999c0929b0352d8272226(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c74122de9bc3096cfb1336b96263f30ba57f4cc10acbb8627cd7b13739959af2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a58c4b79fd68f66716359ddb1402ac65ce0c5868f432edc09cebe773abd8c22(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d628024f5003422bc47b892881020600e17eb32be728bbbc4290011a803f0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c54a3ab22da014f4bedf203ad0d62245850f7bd4c44970b09782148441238218(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a492e99951aa29e9f4d5c0f06824bf2dbbdeab3e129c4754d589ef84fe8195b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7425962c232b3363eacfb481eaaf5f8f7c363d0abd74a2b388fe939706f054(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e3a47d0339184ff06bb7451816cf1dd4ecb9caba91ef28fd0c86165f0d3089(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a267860fc02f7b1e10bddae1f34dc2186135fa2ec820a414366ebbb0f440b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7839eab6fe081537e5f2a799987c7ad15428a54d12d259fc130fac349ac988d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425e608871e044077f3140b2f4737209fca595426941080a5cbd7b237000c66d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49fd3ea13a685ed942d7671b7978dd0b2175e2df9e4f26ffcf65f7761655773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508ddc6bb69f9521d11b619a841449b1de6daa408f3301d7019e1b6f34593d1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67a02f961ab046a9c99ab19f6e97b233b3eec4369fbcaa13930e4e6e16031aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1a2df60519b9cb8d670dbfe62e6b9282fe639ba2e7f569c4231e51e5c89c58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19f91f492b9f7d700af03f38e4d804f6ed45966f24fcc40cc7852cdcb02d034(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc1d3c3193a4cd1c30aae8c78646d700be1f893009ed13103ef523fad28403d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__758587acb0633b0cc24ca5fea192e50bb264f78d9ebd3e988f2e4781e664c065(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f11528c63e94b80ef0e66cd3eb4a734a60aff390e315c5a4d94fac363eaff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031741f42390efa00b83c4ec6a856a0315b40f53120320278e894b7cf00c7493(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97dabee9ec7eefa9b429be5aa14a41c76c872f2092a2b13dce2dbf24cd029d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df158ed14837ebb7f5b2ac80a632e39ddf5e9a2a1521a2dc865ab5b11a5f3d88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679a96f952e99c9e34a2f43a0822beaea0484ad31976fa59a292dc00b5d8041c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2342eb9c8bd73b528bced3b8ebdbf0be812f4a8b5d835417ba4b3fe5f928777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b008520b85e4a2ede6fb70f67750abbeba27d47d332a75b901166638d574e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2a5d0c8804177d706ce888bde996220243752bc363b92dac83f4639ce22dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8990c5d6758a9c05fe5362c0c1ea339a7daa0a450d22b85bc25fb0b85bfc1a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccdfc9c7ccebcecceb8588b4f36c05634b493b18b5e64ea30483330d94e2ea72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f05ae525a42634be59118adac8b15830a5bceb9945c856742134210b3616f03(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32241e43b34392a25cb9134138e71882954f87adc262a9fee372f33717c2a689(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d508f82051c9d493d48da132f8c2d876085206a0d8a632954d537dcea97930(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bbb13fd96fa7b8e221ec46841695ef5662b316dbfc6126b500c6c8edea3c36c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af610ad5b803911721b584fb6cc62780aa09be2af61cf0b93af82f2ea6c84464(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ce0d9e078913d66a4ebac5aa9077f525e0bf2d99a2875dad9c879cd3527c00(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343fd77bd9cea0abf52d9afd3b014fe8e11dce38bd823b7eaf3732630150b37f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7023ab4844e979bbfdd91df049ef25de2c229064ddab9ebce6a01396c7ada954(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d81ce3f9e89352f8befe47308b3bd7847622ab5eae75609114fe7530b07b58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce6a70ed7d4a39f780eab511e838b77c689c30a548bd707a79c4bfe44340ade(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f2bad1c03db43d0a7b700890ccab814f9fb2c45a2f7296890c7ff5781931d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb748fbadfd42868e174d83f7835eccd1432a185fadb41aa3e2e157657fe1ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d75313e62ff6d0f84e2cd767dd2bd724a8d5d4773505203c8ebe9f40f182f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea94c02933a2bdfd26085f0277ee265eae69f636047d9283af0d81065791644(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32e56d4b8f6e6fb869884ac66b04d4d344b713d3b2fb8858f27be5f61529841(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d1f4483625683015e9d7a753dbb597db12f1c8e94f34e5fa9ae834d0db0f4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937bd63622e92f05b385435196e9e45bf052865bb386125688862f388e272361(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f985419b7102efbefaa8fcb48ec0e7570758f14cb789948f82bfecc522af4a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda1de42c15bce13ef92ef41f4c2157359031a7db9908a596f0571a746d0c113(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976e125cf664e1d544e8b249bc83f90861cd33a6ec86034d8c00096c758cb922(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e83d8e815ef7df1e615a76032cc323c2093087f07d0a44878f09112f8d5d79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8d3a3e7dbf8e9f35e51e81add8006d2a97428e46f4b1b4821ed6fa57acefbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bfde95070624b1ab1f4c0da8bb8f5bbb707e43e2f7a917287ac87480e576f54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d286a6d21191c431d748243a83ec8abce57ddd5aca4c4872ea5c40dbfd0260b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2686b692c49117c11f0f4cfd544ab9736e51da046a436a1994160da98c2bf205(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350aa7710e013209e5e3fda69f26dbf3b4f3c3f18a85fc2d397a25102d62f856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1708f18972e109ef4a0c95e39ffd9a1cfc88fa216181c091fe9463a539b5f547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99611c28095f85786c5336fdab38d891c8ed47296f5bebc328583151a34c60f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e638a5c65e26b3b6356c010f37f9be4a04a54c7c8842407344c5fe2daebe0c84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2683a8e622514b078187a9bf74870a807d2ac336036a94ffd9e517176f9f59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a62b2f3e087028a0c595209daeb6e6ac644630c1240e0668241f9e2512fdc7dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a19064bb9083b40f3384796fc92402e553e415f59f587960d9e7110ad9cae5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12bb6d2eceafe0c2e0996f752f66959a222e8b85622ed57c43c33113d743c082(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd8236eb8abefb4910ad900641696aec3338fe9282ece89838d997eab30fa09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5550b6eaf99f592e04149781952e2010c3e067c2358fe918209468bed7bcfd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7954b959c378c42bf02101c6c818635f0425cc32ded46bbb64c1bfd2932317ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775e1372422e62fcafa7ddab8d46384580be1ccaa71665bb06a1e3767e568547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396aec07e1a275d11b8f064150b897f25ec57290418e7edffa0df1c97ef6cf71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93a29a87bbadd5a40db90d4d2453c1d9a99f674b26ce6a3e3b8a7c3c9b388da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd1b5fc16a6fe67890bcfbe19dae9e3ab91bd782b0ad35f49f2fcd447a207691(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247aaa4471015b42bfc150bdecb0c4109e5bffa6b51cc679cdc8bd84c092a11a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89b322eebbf4fc93c0dedcde8ac8d11ac7c152f37e936d07cb6a04d0ab892fa1(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d1524418710e6528def4d8e88adb7eae0dd6d83c5ba457eed4f9ad22c5b69d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32eaa916725d4f06372b9606127ff451d2f1117ba9073e74743fd9150acbc6df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f500b7cb8e271823855210bcaa916d4ca93c59bbf24622f44b3c01916891e143(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301e18ce31bc21fadf493dbfb5a36cf7e9ca261fc4854b85e8d6aded1bd0a414(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188f4c6e4baf0e231fff85ab8cb83ecb5c72ed0ed26a9d78b91f9493601b5a3c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4d87ce02bba3c5fd498b8efbe1e84636514fa6d1f028781e07c2f50a9f6335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c1c4d9806e20fc81134dbf3c1d4cf0d2aba2254a50dd3e7a979e5abe1f18b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45417a80a1a8ad0abb26087f8acd500e079639481353099487e6ce4d470d5583(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be62c9650999f7135c6be807ec4500c8f722e86fc3e984ba8e2a511a1f5ec091(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e8e732a309bd76a8c6c8fc25bdd77d7d627717e478065606105b3e2eb36483(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3fae59ea8fb943f6535da813fb766e27dc51264c75c795ff8a3e9e9c227e04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84567ef0b769af063d2be9afecbdba72d790338384d0d42abdf13d018221cb76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaea1db1b14398c327e588b8f010417b965ac1fd3c892ce6eedcd5f312171aba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5b19ebfec617b313a3baba5726cfc45e47c06126fc3a990aa2d688c3e2ed34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__829acfb5ca7879d9da34e26322427dfdcfe88b41e11df19ef230aa32e2323548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db65103046842f7f531c8d03851b17abb905a232f15b6c111867e9c3a2a4d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bef3b09bee15621ed46377e53c7d9523f529ab91f2a0b2b402298d18bab848f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5669bb07179247b67c81398128fc459b5031736e32070ac05c975de2495f9d(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0402109fe6330d31035d5dfea062ce2c7f6a8a916a983f0547f11d52555de84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1aefd048aaf0b9531a63eb13620814deacc32cf538468ed4779ecb0a50f91d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c120ff5c18a4b2e97dae62168d00c7f59ac85858005ea6a6f58556eeb28d0ebf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9a9f7586b99a7298422c6c86dfda9f876c5d58bca6303db2a343adb98820f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c963f6b3f024e29c0dccc83d5078b6e89c3d51c7b2b949952ed083490d0c3def(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe874dbc45604a4b635289463b7a903f07822e6c73073138769f8e7a847f790(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5db3fceea05141c74299cc927d9c68de3770d6a48af8d1d2934f322284233b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4654cd7afc237e5d885b1c67fb04b2a4aa3033401fd57b6afb684539362822c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a07ff35cb586362bd5dd08d4ec109a5f42320ef5da010783e69379479476cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ba2a741b60e4fce4845067618b3a30b5e914425cc064c6af1ace817e2ffb75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7455d48824e9ba76b0d8e187592cd59929aa08d982bc7c36f68f43923e8998e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4974944555367ce555521a2916637c540eba9de34974892f93c5fb527350300e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24b73fde1624db92e6d71d33aba5e0900e4c7b23d9d7092e736aeec7913b314(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0f425bb66f7548cbe8c6f9b0ae04d5faa84df64aa77f1c37b326336a2c7a0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1aedb5bff9298c25d4c96f829bff99f8e7280efa9853d414df344eae1561f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfaf4ecfada6a1c898a76784ffd4e2c186a4df863184196cb598cb8fce341f9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1982dc4acdb4d15cc82f1b41b9e9b0202f70f469aa46561bff2a88eaae6f7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ac24386e2ac1d756a666c2142474a2060f5dbadb1b945b90591198f889476a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f76b87d457af49c69c40c309bd939757c0d5ddade555bdab5eaa5ff7034fb0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4f43c70a52f919d4c5681e3f2c1ef9c5ac5af95f80a2e655912c607e3b6da0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53fcaf855c6d88f9c30ced50efeed9ef0a7698354bbdf7c1b60a5ca65a5a302d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4e174198965b544ce16a7ca4a9a48f17d027b6404c8ed94aa06bc350abf01f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50fbcc3e3c48939ed23763813fa86ece4ae528b9c032cda5729c7c967f2bd87b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e0b0380352160caea5fdb7ccd19aec2c0ffbe324bc21e7ea7921474032779a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3710e49c8ed34d1c8decef8d95f6a78c2f0ce17565e5c33da3c28e9b456f0a0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15da3f2afb266bc2ea7d2141eecac3253fcd9dc7cefe8a33c792a09cf2dbc06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159fade000b33128aaf8a352daee4901cc63ad8eb4b110c644b297a77ed50904(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b4ef468e93774cc1613f9e2f8e29264fef2dc00344b1fc56ebf72c3022e24e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55d43f1c5b50ff9e7e5fc1a10751f0ceb0203ca5c7ee4b91e2ae98d723848bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8589a4ba9d78a81b1e6c9f888d3620223e98198a3e9c55662f287bab18b2ffaa(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af06384c34b0279f810a2c71652e27b42e110155b814f6fcd2bc98a45aceaa41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3674d91bb9fb2b121e974606f39828e7f83f7230334e7a8c4260f320aa7b44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ad06da2e32eee51aca03272836f98491d3a5b1da48d7ece7ce599f261d0159(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00207aa6c78acb78d89e828a2c7f94cacf60bde14b03a75ca1a15ef9fc2dc361(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34683ed52a6e4d47dcf0fc7daec6b4f43d1cdf2297de1dcf93fd513a18b413d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58c2e44abe775b5effd8d23b85866197dd58ae8c39fb0f72aced8790c019a48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc4394380bafa94b0b631279c85a19bb56d6762e5ae75c8d3742d424537f339(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44314114ea9915e7006391ec91fa502df200b1f1b6e40396ef5fda0764512d53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34ef1efc95c444d37f84dc5b33d813677b44d2a196785ff7506d8f1355e9df43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4e76c42f6468a67577beb8408d3aa01e52074badd3b84a3bfb668b1c268070(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3088269e92c982a821639c92605dfa4bc00df0776ec6089699807501a061d8f5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8e7c82f75ad0cb94d137c40703411f9a49987b93632d439cc421edfdd8a319(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46375bc076e1dcbe77b943e2a6bfe1a3a5d443d75eb63db97b7dd5000b87a7b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac57ce4bd999df9d7261754f2a231302b3d36128be8c8cb21d5999708e6e43ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f24866c2db3afd4e395cdffe09fdc0b0ef9811721372e1321d9fb484c6a6c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f194b2cc60a26fb7361dc18e1c6d28b23f6be63944a6c0aa465dbbd67c5a04a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e6d2bda4dcfa20b82e4e3a6f1ed02fa6d448654b29d77049fea653a05a8e24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd40e0ecaa972a8aa884ebb0a47dc2da5ddf7fe265b5bd5dc0184e0ead2c277(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a684ed0e5e2b6e64c8eaf7190da3fe92794f189189f7eccf1b6e36c17bc69e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db342f555742a5e5d1e064101d6bca857d8952665a5ac1feec049a70b4e74a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92b3cc5bf1bb5b4ff7f9fa35491bd7bee39ee1dcb31778404ab757f77a87d73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d973f9d491596abe21c16209ba891595f05f805e6c5444cacb4371b2d4f23d34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472fe995e1c6dfae67954c529d6dfd2f51980b3306c7eec6372c53177c703727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c40766d78149098e67299bdb93f1d7a2a002a223dabfb121164dcb8bf74f05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600d23742f2775f86eb842d612cdc352e0e31c7d0d44ac50c8e491a98bbb5099(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e018e1c7584d53f28dc6a444c5a12a91f962b044706acc6644304ccaa41eba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68e47175df7b68c82b1787a7118860ae5dcc572c03f5bcab9dfef85c47107ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d65e2bf4f441df13cff05283aa94d077c4070e664cc6b923bd174b2e34a9de2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f371dbdb7d87c53c2cee11e5034fa8119c71a2b0580e3071231224c8473ed98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0424ed2218470e53c483f1c8f7d7ce8c28d8ae961087456493cf3e21abf6791e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d6d4b4ee0cd2161e5968e1db5c2d2c6c5c1fadd23047f883df995cc1e12e9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67f23696d46a7125f7a83be7334b9216d606ca8c48079d4d9f1ef0c447b6a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea90b7f727e2e6722ac09b7836d2ae0cfeb30c53ee0ea9b98f883bf950ad185(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd53b63bf9a109ebe46717bba98f6d53033f7aeb4a1f57aa6a80fdff4557b72(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc54df1f67132fe9abe345a5ca8c452306d97899973fc44c96531d5f481181a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d4c24eeaef94ba3f612b06c2a2c07aae8bdfedefe1a25391f35ccd52fdf95f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188e86555551d57cf5caca14d2640c8b01ba61fedca48a36c18805401dd489e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c880f19f918022d16392b3325cf866c51693eb98ba3fdf650f150bcc2a5869(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c785f4776da601e3a254f8b3c34525277e9ca231e00069729cb277be73381adf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db13f205921c9b87ac2cd5a3d584008c75acf3da452db49e36885e27fa9d3480(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589b49543be8694b989be833654ae5fc58fbd54b6df923da85dbbd97e2d6acd6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff026a634accfe71d25c45f645dbc07dbca7f20779e9f39667081a5bea2680da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5971f5998b9aba7c8e8a6e036b6b01cebbeb243e820a79afe000ca604c8930da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5320638246d676bc4bae67d45370eb161ec7dc7c87f44399572387391f770c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5044e669b81935dfcbb8c2087449f79134f01f339ec56ac2bd71392cd65681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbb115cedad25086de2bb13a75e4cb87293301f74426b5b373446111cfe2ced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15304b23ccc6840bcb7196c0efc1e1179b799377955e7c0312a2aa1f0837fc29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee5ea4abb1374c29b56a298f608a096644ec63eb1a9d502508bb3f536aef8d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9162a102327e98d7d8bf1ccf8492ed4587f98087e019f3a8d8938f87fb1b40fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90135b3423fb58d1881ca7d971565995345798b40c0d2b7d5f28175ae61ab730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a19936b6905888a7d7ada413fd8d94a32a81f23e8ab6fda4e5db0a7a86cfc92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba5e34d194d35c4d8bc57acca53c58fd4692952ef5ec3dbc7ced103d13aad976(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78a1662a31c32fb0af7d643525a588b8398bd7875e10f5eb473b83ba4cb98df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e5663d7d6e00a07a6c9730c9eee602d184ea5789a4863a8239795e83105eb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7e0c2e90910750407f83b06f6897bf50041cee0ae900d8d77e9a5e9401b2a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a3bb2a7a3a16206f7b25dc23006b0771c4fdb698d2cd553778a82b538bc6d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff2af1338023b329d642240db1b2eb8005138809a8d74e9cd6c385c56ba76c6(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f7288057f700c213e9cd06c2c3cc2f1acbb64ae73d9ffa9c58d36f97d31cce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72cdf1aa097637962b670c073ce75d51194f467ab35769a703f1229331fb8f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f76c28f4378a71b8ab700531f52b60bf89b8732d2cd5a6c6a49bca6ac8f13d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee63a8c640670aa378dc2a1710cfd6d496ce6e9d46fc05091ffe7f2125a79a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae0f7011c7e2be5a1ae588d7f519bd86059cf628bde3b5dfa9226ef8b94860e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc6a3242790dbcddef0c513ea795dde384925a80e16a8649debe088ef3cd00c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7347ebf389cfc03e3a342ae475f436b672052d3ff1d1fc38fd92e02a6bbcb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45307c0c8308283859f063483fe3958b3235ad493fc43692f28b112da8df2c97(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5b182e93bcbde75df68402d5e77ed92e40319a13a15274ed17225eb553e0dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca60e5497cf24d43219ebea9fda4d63ff84f0dfbeb93502c5ff343eceb6f2871(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c485228a3ab26fdc88656c3763deeafd808f9353933b7f80af3acd2278df5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877c6ddefa4280dc01a789471c653b31959637e4e8650316d424ee479fe52ef5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4024fae4920be5f0c8814b6fd3cfe8b9d39ad25476b5313ef5e3790eb11e4432(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ffc621104a53789fdb14e30a43afbdf2d82ea9aedb147c632b5ac82c015428(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e724279026b39d9dd2b581c55ad92629e64d4eef84c0286b5f1318e124c53386(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8b85860d35a5765d085b18665c2c7c1a3183a0ada1b13a2a2506c2f9123a91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f7cbb551207f4e2b9a83b13b7ad72312366ebec7f1718e9caa4c113d2065437(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb5380c4ccab7fa75814239c8e80a3adc0615039f21d612c0f917e0df6ac03b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6e567c1189bb76b26e2c77744a9910bc7234a5d6fd8e9fd7d8915b7c1040b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0449be4d63b315cf4fc5ffe56dd10a63de7c6d7451e9ffe5a0eb2a6bde4d05d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cefe8e598866b38e4a9132b568161170fed1faf78fbf62577f62ed927643a146(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1db105482d341975858f6c55bac65bdb1db2ee89ce2b4cd672c0bd590663a75(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a80513d54e1c15c3bb4bbf75e194382e84de84ce4c9e80b5a3cb68c52a5123(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9010ee42da0c4a1f999a6a9fdb65d39b771fa7a19ba2dee65a74574e177c18b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd28d3183380ed4718c3f68770e40309530dad48b472f46d679245b85568efb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77db00e153652aeea351c24ace8ed4825a2215a837371d86c6a5108dfe2114b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1873b9bc6faefb8953e9460d6c74a75955d68c0fb228e469d156a3e91c8f6c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ea16cca9440fb5a6f190d7cb9ab4ce4a4b0187c35852ab1887f6a5e2c12971(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02821890bbcf41b3a5b45cf5b44267772179ca4f1883d9e76ab97e5f6e51bb97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7060a9c10b47592c4a6c87fdb2d4222792965d639db849004db1e8997ffff9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b65face867b45552b20f144343929fa03ade2eb3509e470ac051068bbcb915(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35811263b6af6ec602bb066589b28d29e207a367de619c94fb9d81b3c1ffa6cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac464dea9e2ca3bd4aab391f3b8ad5cf26b9153fa9778f884780e52f8b7ee222(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ac9c0cac69654b5b94dfc036ff7623623819e8e928e42650c68870f5dc534c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63dd6ae57378b3a9fe35c3de0047125f9273899c6d63ba488d85b8f22d4788d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83232e8cc8266c5a7298db790d1a445ad1d647415f5197c6962c3f1a7a64a6c8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a40dee5c0ee877698d2b17ef2f44073c259e624025919aa8cf06ac8e97c3259(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cca3c4118768af22a19d602510caff2bed60f3af6f728debb3904abf0694563(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da7a06bccf896ebc91fcd282cdae93d69ffca1e26d1dbb4f9eb4d04579fb6e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a980c5cb12c5e987c80c6ee4b63906311959e38b15dec2e84dfde3d5949f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348b4bf3115f77e4649a91cb51363569eb96a792af7a72c58b44d603e21865d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da345499214af3bef4d984e1c0c3e52867f85cae9b89bf7ea45c3c749a0c4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bbe7c4f24cbb337b526b8578c74619f3be5db649a661a6d9c6ea8bd070880f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8fec0eca07c41ad8d22b17a002879bc3173f4012e11415d46651363c3a7ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac421e952b40e1f4dbcce742ba9df7a36c31cc0c8ce111b2f387c78397109da1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8631f1c963776589b9813074558bc2f6f17ee7301e76fdf99023929e749df4e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f036a0c77b507f5dd6cc3acc87c1449d0bcfa343f34fa5bd738fd4db3903d4f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f2dc0ffc60cf02d418aecd95b57f05ba2f260f480f9a79834aa4c7f7bdadfff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080182c3b53496350d36641ac309d89dc526bc43c4804cdb22ea19bc6b02376c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d705f1d1f3dc2ecd819f0b0167357a0a2b95b4251595d6e41aa1fe5655715e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517002caae9009d98badc5f96f0619531a2b86100a07e9c65eeea74c8b76f900(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d68b6c9d4f689294568c3865591a105c82ee3f68efb0c3ffef2d7733c87490(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d26eab299c361cef35cef6f91bedae84827094dad7b286e297431ab0640382(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea454a6e5c824105e9a22d2c91361fe797d420e686ef436afc34a661157cc4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8b8269b61006303dbf475472f86750d66e511868c9ca668141d7aa268b4e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb514e2a5b9d66644622be3a569cf568261d64a9ca7abed31fd14c19eb19a3bb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd8aa6ccc4559d1e0cefea803874545e362ac7fd8500a836f769d4bc93e9b82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501996500b7e88250fd17e08418f8bea6acb08e79e5e2c3d1878e89575050ed5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d163a5c5769582c7532ec76c75c9872796289fcd1b9879178047f609ab2fa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11313ba58bfac992b0ef7bc16c8bbcc3bfb90cab94c057162c16ec7dda99537c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96d52c17a4fc6f7d6d02f954ca6496fea18934a583f84a9662865ebe6289e55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae78f61c18fcd33bd469e9351c353a689e94c28354df14e778a64ba885c51cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f122f7ae05e616f21b36605196089caea4760ba951118304b23d81899ebe3283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b7a66be00c5c2540b9dc22d7dbf3cd4f244f5835d23f178f18359b44261158(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af411be1e28973ea22d409323ea0369ad661e6b30e6e95709dcba081c5a25601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cdd864eb4bf9bd8fa2aef93cb61bd64f11ec87475693861d5363e512d1feb5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de567eb919f6d386a27c53b2de04b3b41c342e9eabfc81fec8bc4f3425c8962f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d2027d57a91a837bc82ab2594adf82666456a2d775f658b50c9c1cf25c3681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__734838013c0af18ac24f77216827b925d0d12a91d49e5c88f6f62e683a8a1386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a502afa0348abf0a87bbbacca24256908d15f1e0459af098c898fe962e4756c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89baa7663e43a9894032fae3a7093ad3100ee00655ec575d0829d23795cc0943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__551b5bef632a8a06c46d891ee4555672cb2cf6abcccef7b19ccddf1f33d44722(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db6b31d67a9f6a37a9998f192f47800449ff97a25a85384b268204a91be4f99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7a346587177ebe4c8390bad8db76c3f4789a5d90a356e5726b61811cf881e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9dc5a7aa70a34c7666ab5cb69434d77c46e681a43355ca275da2a1dd57abba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76597cf2714d9f8cb48bd268b6171402840489ef8e50b1c06ebace1bfd10ad43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3a59d13c9a9c8d016ebf6c13acf9a7b7a17246da8d56ae25b72062b7e7c022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972b9eaab2f899e190c5fbe614ffceaa39bd055965f47cb608721fe3b58f81f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50484cf46b0bed9e4edfcbfaeb7cd1b2739b126de98e784f313c2210893316c2(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505fb0a9b5030970fa67a66657b3b4764a5e076b59064a536cbfb6f7660c7d3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e101ebba0190b366c9264e27ef65d00884195cb617da791fd67012da7cdffb6b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__510f2edcf9271d2d06e30e905b5cdac7eaf24350e0c2b3c78e1cb7ddf0354ae9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58febb3a2814f0aef5bb3760f3b1692c46acacb381b6a512e9f9f677d8353b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13a106b16ed7d3cdfcf73a1c9b1817e3473f92cc6ea9b97c7e7899d9fe9c4d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8039fe3af822b2d05cbc90acf77e26a1a013192e533b13e5e4d9a64addc93a81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d6e7a8f0577d85da1aff265adecd233532be47d102bb0299567e4d2a310386(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6136593b60348e51fbcf8f0d9c64e2bf78bcae853f1b0612a2f135cab9e246(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdfaa067a88ac28f867f8ecd04fce5a401672a06b2154d207373a53fea6e1728(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c2ced9fb9faf2e2d546504b6abd18f98d6e9b9d94e02d29878dbcf86a1897c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2631ed290fccd60b4d412ef0f8840d0ff50612fd6402aaf82db894c103018fde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64bb52579feae80966f9e20cc4c27ab31b07ec8c50cc326063742c2e9a0eba6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c202cff3a31eba690317effcc9e2123dc16f30d5dedddbbccb414957f338829b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf978c38805cd6d848c2c0ddc0997ee262fc42dff3f2baccac00e6ac2dfa6af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7446fc1f49d73170bbca3a69942c391d4b3f61edee21121dcf65d261ef5370f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aab5da5ee5bb5924a1ccc6c7725037b896b20fefedbbf183c22f7481e6dd04d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69ac096f3906cb6ecc98312d10563460736eb30ce6d1159ac131a32890c5881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d800468b177e4d7e83c914526b6ee6a4cde165f558b83477a4e4ff6aef590a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55257249a166d9fe0739231b285124f0b22353521f61744797a1e6365e5e3940(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd1dbafeb1e75637fc27c7ef936de89f9a377cff4f6414a25206f132bfc7c2d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83ce9b63d8f3ac0129b77ba4353d58786232adcd8b68d885f08bab003425b9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba115add5a6c90b2a86eb4d3c95e967917b459e0a83d5ad2aa51ba8de2496b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae28704d66c63d385114c6ea15e87ac5254a06c4d4d2d53aa2e6c87fc641c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4312f8435c6efb5f5c33f2e894134fdeeb1a17a7bc8988ae28ff51b679cd07da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fbfb7499e1e056500dea0fa088c755107bbcdebe5e8c59b1f45cd0ca393d73e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b7db630b37f77f89f831daee5563385bfce37eab137160f5e1f5815c140c14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5b6d6241c2dd06f246041c1f45a9a56b00e039371c254f19426cf053bb7a5c(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707f87b3e36536fdd00b9b277e98f34ee9c7873d3f08a8a6737aa33c69bc6494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3872d89be5c3eeda16317c3659ccaca39afe8d33f18cfd083f9f9a67dbc3ca16(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807ee7a83cce9ea13dbf856435ad953a2e730a17555373fd8e6fc8d0c622dde2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7a43e453ad05fdce0981a33e279663b87d6c6863c85c53610ff4b2978d336a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fe3685029e23579946da728480f5d842114e847d722f217b2804c463a10ae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a6dc467f90d1699c7a583cca9973fefe6a3c5071a4072badd0536ab911d79e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e4ac2026d9dbf9b643b101cf2c5450aac462d026eccd9e2222d33192dfd6a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6bebc8ff1708aaed4f1cb031dc980c72e06a620af796976975d54f8c841d4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1fde279da872f0bca0394f8c2c0f40fd013c85281493943990a77be1257956(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfa45ce4cd1c8f98a6e6c8a35fb3325303d80fa1e265f575bdc6647e7ec9f02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e0850d46ffe2aab699e36e12b5a35e9a1ecd3f8415281fb0747721fb89e15a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158d65f7b96f5382ee3516ccaf0ea4b1dd623888fb234eac4a51369376c1b1e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5ddc271bd6e7a52c0cbc7dac272e343976757b02fb246674c7eafe8734ae80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef644b00ade959f4f9b31f4212c92a690a41f1df26bdaff3e80ab480a1acd39(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785c4e53feeaacd3622dcceac15453b16245c16000da55a099d7dab2cce89a0c(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27779c030ccda607e3b481bdb9a7c89dee5f81eb398d37b14c1d0916f42b5909(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68ebd30a62a522eeff4ef82ab3b291feaaa4e08dea72f6051f35ad93a6cda1d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ef72b8feff784dabf9bc9dc22e26a1ab48776311a484b596976d8a9cfa647e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7980a57288cdc4fda24822ff318ebe5202a1c508cee2c1333767f4ccdcff795(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__651ce0f381161cd56be1890281aa31a7a1ce1d251aedac4301a277a3676b7389(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529a3f7b1fcd4c2a069da0533d251e34a002168148efe3976599e4dd3ba6a622(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29f93ea43ddafffc2d2c5b954b30a492d929e969fcf878e62e0375f28d28f4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619b72ef9d933915ee86a68da0c07d8345c4eb4b57eb0777f16e63e4d732281d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5fad2ae15eb44e76a7acd1671d31a49f49fbfc8ad3cd6fda9829cf939dd4538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68ef7fe1eb931b32ec81fc1ff24e0f23e945f7ae7678e7bbe0a4db01b742a0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224b04f667c99b4aaf7fd16d32263ede34ef66c4cd710b18bed0ffce1339824f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d83abe28b0846502e95a5d0fe534748fa18c9414c9b8b865d357510e2845670(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50142a2c83206d0e893064435df78999c6dd99e5497c672fdfa09054bafe932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0105d886ace44fcbc31fe7e955325f3251a966212a2bc2bba2e13f7005030e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9985ce95ec3e4689ec6231e6633a64bc3f8bda51515c0fdb31590cc8595ee2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8362524f397b99f5a56d0f0e1066179b8fa7537908450d705ba98f03b1ef553(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61aeb1e006ffe3474d01297cfbf45628a3c983e5870eb8725acb4547cea2616a(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60c534524b106bb0cde63ba97a44c698bd4eb8bb2fe572f704111d9536b2db9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980f9ef9bbea1d66a4a62b3be366a1b384f89e0a1586dd469517cdfde16da8eb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc48f4ae7aafee3574f2f25d3931f0bc7660cec23c74a8bbdb9d23a28ab10193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90bb7c32be51b400ae682610ab5b90177277a83963444beee47b1b5d4c3abb9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d43ed7495cf493c58fc422e7d66f7addde43ad7dbb18e84af579ec35a16b82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdc03e5f91ca745140bf9c8a409a5decb152cfcf2a1a91162e7c733d11b81b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68aa362bea81a21454ae23421d1bdc5891797b91cb4d470ff1c0ba54b7b5fc6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4032b5c1d71b32472ded46546ddeb221d899e523f56ca230ed81d3cdd2841f2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97faf400df366cf629bbefd5f0b1b2aa47441f418dbd7cd9f942e155ae2eb97e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a4b5533751864417aedfde670a5264f6be07cf7b7d23201fc509db7537f30b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628749abc3daf20e523f4952cee5e4093026a1be712884750bffd489cc431968(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80779b4677652fc01b064e0e89d26d23e4ea427e81058e3ac47b71e9cabd0248(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6836cd9584e92f10ac3be1d15f96a1fb85393ce3727ec32d4a85b2fd771ad05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b4bf8f3b264b40f4d2c84ccbad55b7582edda72dc1cc1e287218e6eede3049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887b9d728750869c2aee18c087116879ee7dbeec70fb7388e28b60473c274919(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25d712606eefef8fc5f33fc7200152c75f46b8b94302f53db7568b093d0df9c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6028658ab5743df4b180ad59c734b853f2825f754f23fd047a45b63a780ebb5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed341e46341c81d856368acb337631cf3b324c1af7fb8ee3f9c763fdfe0f4961(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14130315c4f10fab56da9fb032566be501d178ee90959edef567192a43a987d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e67ebbaca9ff1fc3fc1813a29efeb8b9a2ddbeaf5f7b279fb3a63d3d1e2780(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c3ee2dd933a43fe0d0942b231281c1a5a4ca7a450ef58afd1c3f70aaebeaa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff2b064b7100c431594deb07d4b9d43b1c6d29c0e73a49c4a6eb05616dcd508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c57f282659a84b0df278480a4cacdb8f83c4e3e7bd4d09e24ca8c2eb3a51a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e32eb9c6afe3abb31868f4cd7f2ef117b0c695a226ecee317f3041c4b0902a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93aaf829baef7f18d8cb5c7455bb04d4b3ddf75d67be36996f54d3d61c86a434(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f48d85524dbef53d121b585e89288067e1d0ba834cf6313c012a036d025c27(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb5b681d033d576e2fcc1bb5298935f5dfbb04cc84db8c8bb1f6757d3966707(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd3441e2a2b66cb3ba8a0e7b81b4d986334b708301ed4e4a24f4deea51f1093(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16ce8df42278b1a7d92aaa1d5849dae543f698666a88822ba7cf19a9e40c9de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3acd6b3bebfd7db5e87d073edb660478cf1075c8d1d3aac6ef6f0695abe3260(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9c1f092a808be600abc4bb05f91df8da356a18b12d8cb0a44c65b3f4617902(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f0f06b29d57b8010212a5b1906a46e66ecc72ca2cbe76ffef612028677b23e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5e4a2a6aa8e124d1130400749cd7e831cab0a341410b75f033c4b7684772f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4539f8fbcf6039a473a2ad06417a220b73c79be0ac8051142854cfd3140e6fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963337c295494be1640234bd4a6cb7bbe919703380707f26bceccd561faa7f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef96118045328d87feb306cda6b45ebfaa998ac42c0932965745b389cdb59574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a84f1ed8fbbff3928c972e5a89d3f05596746d2ed29c176a2336b9c415cc31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a74783e200e784b0ddc6d727eec1580f644b3fc3476d0826d5dbf724743b855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b53ce2345bf251d72c05c02a536c12ec3ef6930464ea6bf0dce422d3394676(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b79f1cdd879b55b071fbc25d60b197cdfcd5c9aa8a7eeefb86e9a7318bc9664(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33fe52d70752278e78cdc6660cf6d8d16d8ab735985824df81a1584629649644(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05b4f19b0ad9c32e4ecaf6b700580f029eb0db2f095e2bf750480ee95ab3670(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c2e739f4565dfb5f70a630956c7374c01b913534906fa8fb8f2f8b195cd4d8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acddf3b8a497fe620322b6bad24d749ae4e5e7d0996d15e4a1b69a04eb6dfe5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ab9e3f001259d64fcd053fe26c94ac495bf37190ee79468e0794ff0f14da9a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8bcf15771c1be811feafce167a5dd4054fb5fa79710af1df2a944e6064857e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b077e11d7d6af0f97074913c958846f5f5864c900d74a662c83586551f8b23b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a03d81e8a0729faf7c36e1133401156ca151caa5d3c1c33ede3d8dfdff0778c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1666a2ec02b90f98c341873cb09c0536ff5af8cfe35210a41ea7a9f674f62a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8fb79151463483eddb37dab174d02854267179330483eb35a044987ce6029c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f60f3df87bb429b74788ee8e00bb707232d918ed154d8a64cdc7884c8c1fd4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad6b385f24e1560fe1e29e795c9a76e0c5e7f0a778aa6c05a16235e624c8d70c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620d5a1373a27ebede27c898c11ff463d3632258c401926f5a87f63e99bb7653(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01525028307ed1a9661dbd3bdf8b2604bf7572d665946d0da5daf877e45026b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b5728a9e372598db8ebffc3106b3c728e00beab40378aa2f987e8c5f14a0ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97dc823dfd465bce54d0685076d6a6748f0aee00445c138741c51eb2e71211ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c384e797a3f96a12bc3dbe10c5283e8f900943980b6e737fe1c42dc36359b3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f15d33cace59c74c345df62e3beb83aaedd450f9aa8d8e87432fba4d0dd37e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5819321c321a70091379803d2cdfa25aa37b3a52a634ec53125a198787448f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e7e7f3ea26d1ec8f4d3d97d5bfea1f47bed642a6259097682a73fd1c411a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31045d354dbb9bf1658dbf3245e17557395e2ef3fc427bc38b9fb3220ad17d42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c828a3a1cd3c2b4ad8b4376c54b27d069bc185228a725e0a745fc6545d8cfa(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3579c503612272b14bc349b440aaea2722c9b3e94bd6cf915a6fa8c0842561(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61746a6618fcd9039263b5b5f6063eca9c917adf2037ca143edca839c5c0628(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4389cbcee4ee6329d6bf24e3b5826170ca60ea9cd6082619b9464ac30faffac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ab1c4cb1d5e563b56482634c64ff46b41d343ec09cfb91f03e948232494bd7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2496510ccc640c018d2907d8cae588e6dd94ba22d828510cc88ed26d36c5aeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f279a850906022fa8dc2ec34ee430c065216949826882e45a86c2d612263f08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc65dff9455147bf5470288f4de71145a0dfb86c7920561915ae5c60f3f37eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49485669283f9ed77baa1770a12e7c4931c257567f741f4514be3ff8782dda48(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c89055a7c6b008cdb8038293d89e57067604379f7aebbdc8e5eb3b65f1b186a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3628be35e9af2d42f921eaab8f106aa3777fc80174117e2ef8700e305a5656d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fe0ddefc7ec9fe5da43bb66c57aa2052e9a226379ac01e875b8fdfb8fa0caf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc571c31f25518869b05d67a9eaaddf290c5c74c05750c860cc40f60fb44938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4906a6f76bff715c02920639c3e7c77bf9b990bfd2f33242dd7107dbba9a520a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd34ebab1cefe99f31fa143b477562844d76bed32e3b0643e0a6474f54be1050(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3978fe4fa5076e941abb0e28e3661afa73e4e7b700ea94b88ff38754ce5c3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d94c320df3f6a28809bc52ece13d6fc84ccfb9ea7812d072cf28151ad93c63f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e9101ae74de7a82710762025575b84b1af6d5fe431208a54b9fbd0580f9c00(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ee9296a206122c80e74f276d4f784ae0eaeb15638c336a35b3e603fc5a39ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71d15b0dc764b7b2413295e4180bd48f9ae0f828256780b99c4b5879286e6f7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab8985e155181fbd7f949ed7bdddd85214eb8b0ec785fe846d6e2998d92c294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__434931066ff256de59990c786530b579e07e6f13bf1d981fe8bc92ec9a67d4ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff21d7f22d1d53c36f0dedd23cabf3b227436b7ddcd3b237004366ce55e7b9ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b6725667e5200d69301170d864ec0646cea0537b8f27a04ce3aa12b4b40ce0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f04ba3ef4e4e7e8a9e5fcc89890b51017fb05952eba4f1cc6b58bfa917290a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a415d19b246e63c77e409eb291c7943d0975df20346c95d5b9207d4675866f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62542ab4796448d9b7a79aab4778e23405328cfcb771452e9e3af03abf734b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77141345696789625a59526b127e216865fe646fd61fa2bfe90d5a2d621934c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad27fdf0542dacbf902a0a18df104a24466d95b8c0c3e3a49c812b664ae190bc(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19639babba45bcae311b4f94aa9a63f1f8ded066e9b607842dd8d66b3fe4d849(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0077fb4c659e019dc0a26f2f2aeaeff344f20e43cda4b68135af4e3f6f01643(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387712735d2e5b726adfbf11a32487f36eb6ef4f3b19654f49b3277714acbf83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d8a17682d3780d50394ec0e89e5b6fe9575e0ba022a126c7b58f810f5552e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a55de527f28a3b675020ec2cf5c460d029e97a32078d12b748673c2d1bdd9f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d785f8d23dcbd1bd178628a71d796afc98dd90fa8853d7bb78b9b0e35c1b42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__846c1dbef0beb439ecc6f2a9215df732bdc26cdb54ed17965a1a197a2589fa95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a6ac0e141afb77a7a3cbdc83feed7fcbfce609adcd2482606c60918812a408(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de146806a806a6cad225d7a397125a7068d3dbf90243b624a8265611726422cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226873bf3bdeef5cdc8fe6219644c97416e7a8b91a7b55966653c8072a4ef3d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8efac7265669889c1655ae65b69630eab4746e17b2a38fc8751b2c3a96fb482d(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85955ad6098e7aa7946ad0d88e468dc630f6e07f09f46a9871879af09bf74fff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ee10ef40b251c1452640598628f694f4496ef16f91ef3d0a36a15fe2aa0a78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c94c7e033d1182a0ad48c45dfde57893498139704266c024252521672719379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b979e37afcaa8b771065f857db5d57626f79d1cd55233a35ac5dea9b7c1ea2cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80259ec7c442dc45b84dc5e01937895842edbc32a67d7f76180ce6faef7f1b7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f83963b9041f5de7dc08305c877d77db2209d6f49c4d914de963a3aa6179e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ab24cfe1272ca26448611ddbafc184c7a88e78907d79e19591da9442e1aede(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5944b152550efc82c105447bb739d9ed499b4c31158105b965742faa8d6187(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659cf4b8ac70feabcd48964379c5f1f7ee14dd932c243f3c96a63e25169405c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0925e37c2efee2c0cd8c36516db916cdd658b264a0bab8c831bff0cc67c8abea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec39c86dd0c82b388549da5066906bfd9a5c08d064985de3af937cd5e3b2a70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426d05a87ffb1c245e9fd73c97a9e8b3a35b89be8421b3f067dc66e6064a650d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cf50c0e5162d4ad5d7a4354bd1db5c5d8e6d93ec3283f66271cf037309d5bc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3710d10506cd3f045415af816b75bc94da9861529e27f420776c88d90a0e2736(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2fe5a074c0d37cefe0582ef346e93edda33856ccd43a069a9e22cabbb203f4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e824d8a4f69407ea6ffd9e18706efd5c3993981ae3be6f4c78d89287c5448b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5265a7b6221237638de946f8631585239fbbde14cd7a88e8e6922d474775152f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__244f2411c102ef4ffb1810b4f47afc5eb4c250bf80608af47e43fdfbe0150951(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0adf0434e3256d4508d14c1b1bcd139edb3b131eec6fd26f6d6a9a51c259c073(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb901abcf9bdb2337df1decbec7f08ffc401a9072a21c4442b0e85aa66f4361(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d25daed1a4dc0178b1e4c8b60df485b22fa6ffba79e2c54c876005b3f26f05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab4e0a10f1f43d18f53f704c283c7e8d3668bc9caa3a4d250c0f4086909b2fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f756c1b6e400246c3973a3936382cfe299bd1534b64dfd54feee3aa84cefc2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50bc575a74f3e85ce69a214c853ea2785ed494a140c42e511aafa4f58544a285(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1116917db000ac8429eb8c50de037831fc48bb68a553b2041e89bf1e64c3c16b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef83d51f27410e5a82a4eb24a823008a3d3837a0e39964d996dda6a1af5b8c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d3720334e3777f15f1e9a0ce8527ee5ac9f79293d8c8e75df259532e96db37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a74bef157341878a9a2e1683ce1a6c54c7cfa63e78d5448bd56a4587ca5795(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de956d873b1e69c12700a3bd6ac8f7b27099a782a8d8569c10855dc59c93772f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0537663e1c6dae11d67cc273c6d53f8efc2fde03ee5d6f96b8d462600bbe3e02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8ca56e7b6799cfe827decd38272eebdbfc2c685da6c57b1e379a6ef7e93567(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde4cc661e350d14a7c68fbf3283c24ab1489f58c68ede82fdbec47ce746afbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c27f09092ffb384c78e6f841519d99af300e55a0e2f6d494950bb712f24044(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee87e94c9a91ae8c6309dd54ed776212bc25d4b9ce8f9248d71914ec6a43fcbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef48d578862d9c33c584e8ca3273f3195ea9a826741301b6e13c6637fc598665(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654f55ff8fc177b5ff3831ecf04cdadfe49eec1a269592f733f305abacb05cd7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eecf2f2a3b6cc70494b61f5725106bbc74f22690c91cc6080bbd9be3f59f1c85(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dd84933f670ad691597fc93a497d98573af1e87a3d52d89db6cf5e130c6dec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2011f5059242266d1cf197aa90cf86867c49ba549bf199521e05e1dcecb012(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a0b685c7eeed004e70121c827937a141f41bb9d92b6ef95efaf51eea3e0f4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffd30eadbbff4c46c51843f3f44246381ffafe9565bc7a90f324433d5ea1efc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06624b8a17e838e98709576580cfa8350a5c90d9d35e249b9b2cf8848ea2de00(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88b85f4c6aac7884507867c3c462713ba5d3fe12a1814c6cfa602b6ebc73aaa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b45ce23a2198995fcfcc908d1a68a120b0233ab40aa7ed9312cd37dadcd579(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7601c8b58652dbcd318cc36a51384e09a6fc07a3f294f75768d89b1ace1bb49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e64619c64790abc7671a9a80a5d45672115007a12528e7be007daa37c84a3e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ca78b84af73f1315e87352177da2e54b0528e2c54aac15f5c3864a3762c477(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b09586fc42f2bb0a488c5fe044e03142864330edf97dafc7640c0f102a77ba8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a861f6d3d2ec918cf639b2894173b3cc5d470442239e5f99ca98c5871eb30634(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88579963db142bfd642803389dd93e87378769a23f9974085bcb733a56a1506a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae8c4ba9abadae91c0ebdb1edde4d2cec9d13181e70f2b096ceff80d4f07138(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be545b770c70a4b8f00a717cecab6fe49f5581d8b1ede458306130f7cd881df4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa136f4ada3a35b7f2fa0e77d49e929874d0b44c91305d00678ac0ca7713f244(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a93fdd22c72791775ce0ccde1381d6c1c34fe066960254fc60554aa84e340b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5ffbcd28dac06441fd957147886725c61e05c452d79d9ea0529df99dafcbe6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3cdcddc7acaf2992fe02e2af5c84f63909981020314190b75ce657dfda93cc1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d95a9440ecf873a4d59f119801fe92ae6a7a298ff56f992f94bce0350799bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ccd31126389a026dd4d9a76f24b3d88189df5f6402e55091bc5e02d47ffa3ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d256de68087dc2d346640fdcec4e1d2d82147f9fafb9cf6a1a7ae15886b957b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d4fb675ff35ff32cefd4bb15feff47c9954152c27db2e75782b9a09305d55d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5276d71a89742880e24fa15320bd69211a086d6e1cec2fd798096e68553a85cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fea1814b85a78008fb015321cfc4f997baaa25b77cae9b96e50eedc14d13eb1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84609253315845d75d922712dcebf4c1337d6b643923cb382c5556cd38d6429(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b40e6609ebd200cde17b07cf0b9e2a072a9da56cfc9a21784ee0279988e7447(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af14c43008dd793b9e33c6eb94907b352673861bf8486ca2515311a3202b607(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d4514f69515c2e22e9cf4dd0e5e97dee17676f5a2c701c95340e2cd14ad438(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a227b1aec01665fa2b445d66049ca50c7bbff7cc3c06bfcb98b1451be68ddb64(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbfb31392d833cc13426cfd76468acaed021bac3d21ebd1fdb5ed122541a8b4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2881f07cc6cfa41e1587b9fe8e7a5f98fda7f50b8ad397ee21312d221fc46868(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca58a59ad27e3af4f7d49d8cb0933a35f56f3e4065d4c6157603eb596980f01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3feafb4212f86486d4f16834fbcfd55431cefa8f0b75a75194c5c7b03539ac9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97279a86eaa2a51683cbc98b620ffb0467c445a71f72a1f14d91c77dc9cac9db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e6c0fb9c795a9fee5bea623d68572b7e7c8a603b6390e46ed6c3cef86e4a46(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac7b7f836c6adb3ac3d38320d9c726e848bd286392776218475cbb0fa5a6144(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee028b9a2cbbcfef7b61a70d03385ebbd5ba3332cc0fad89811a3038616d4ece(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b410563754962439d3dc8ea4fb73bbc2284f9734c97c46cbab935dc9a035c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bce1901d0dbcdcd7b552795abb52a5cf1fe7da9ef9973530986b70a2dc1a11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e46a450ae1a533dbe60931ade7847b652a720341713ec53d01ab0f42c30ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e105b8b2a211bf7550e0911a715ea6e7fff5f3950590360751803425780eb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d915ea8b1c32af1f9df55d7c04b5144b2b74021a3dedd58ce4b6f91f217a54cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a8d9c2c4037b49829deac88c805bc116bd06422f5eb1eec7fbb91ac292fc7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee721e766416a1bfbfe15aa9010fecf9ac5f34115e94ad74aa41f7eb9f547f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7d66b23bda6bfd74f0a9de1c487825f8806449cff9abcfdf17a7e244913aaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aadf9d90b512ffbe4f82d276286acff46a3be3785c6257c610966b2ac9af42d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9021346369ece907de4a7a998c8343359e41c7c4965f4abcd21d8c443d8f0851(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d701a1014d29c167f4a82ff3787b92acb0d98065a06f622bb934d53a2dc7d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e598607b63ea018c5a10d07357d95edef292b8ce051b2536fd025f058c82f280(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82747500fa48070fa1b421d3df2f982f9a98ef5c756b4c8548ca1e42d845c000(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8aa63f638d81a19082b7854b73c6cc692c21984b150c5e21a7fbc8cf31b28f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a33e7d4b61902155e6d763a775163da4dd9097b07ad58c490bd265c0f7692e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d984343567dc4e2c07f3e79f700fecee412d9b5729f71d974d45e7291babe20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532ccec0d4f3f12425491cc749cc09b6db1428ad91b28adf92cc47503fafa979(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69be24a41c882a8f17f91ac956d62ab3835a4067ecb4e035e6d6a8b5c18ebb22(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba385c9bb6152875d3c48a086728cc934aa36868a5dde898c40758bbbbcd5f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6302df0a32bcb3e23d2a8eefc02766a59bdebffe082c35fe7755fe6bc0e1cd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cbcc94cfbd55d37b40476dd37cff98264d4828bec102c15d22b65229427f2cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a83be78293fcc3c0bb117988368c762f8faaba588a79c81d290173756d5fffdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dfedb4e5b51e3cdb2ab448f2a85b6716da61ebe87027859929772e98fb5463a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d454fcc8a50c78e7f45a62347c02313b69277c27fd9fdc1863407ec5b77a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20bd950f73c371d1c60e112a8ae6ee5a763aab344e80f5a5c262eee2451330ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8ff20b377ed27646ce3730f5c1a9da45b08bbaa004555c504f94e5e7afd611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fa41cdcc61dce2eb19740578e3edc267ea9c642027b731d62ad010939ace33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15db1f70153f20e07bb2dd04914eed7a178ca95a12f3cc627f32d777a4f0661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e3ca67c1f097266d27ca6bfb1cdf4c627994fa7fac969e3e58321718ab3cfe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9fa533ecc3bec94a00ad2888607629bf69e31111b9b96833943051b9d065b10(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92803b535b810feb3dfe05afd95eacdb02a0285fcf633695a35f7966aff149f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a659d894493a3b91717db8b36f126078ffbbde503801267ec4389873f5cad93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7694de2f9f9e9d075288d23b1d47641d8d47461ea923b0a7658502158f172943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a242425202c7fdd1c0aa78c194e3630a72840dde4c67e31b3c184acea8e231ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c253dc6af365e9a73b79d7618a21ac8d27df317bdeb54b255ea9871f8d722826(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8298f1eaa71ae6c96c41935df84d97364fdfce2806c600f5b657686f5b7ae90a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08559a08d5bd75eeb5001c696ae6643b25ca4fd0c83f750f6fce9a3a19e98c01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c37b9f3e952988e38c8a2083e1d48d9dca29dd44f66b7ced47d05b5fe92b6f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da20dcb9e51b304e51116bde1bb4eba774057b5d470a6e43a540f99e98acd87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e685e2eab819922e462c952d588747c37e44909389b5c61f8feeab8fe921bee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565cb9e4aab1b0bc45bd1a3c7d702955ba4e7c72a1bad7553c251810b8105ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58460978c538c577bed3efa581832e6ac67eb23f3bfea5b68f69a2a488e159af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda1ac80542f70c676a7339b757e15ca19e888294c5937b0896e5fea774b7053(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa583c9bd67383434899c8300b1065cfe5a7d6fb0760ae6a592c5eb1eb25d4f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ab3d436b73e120d88b18828566cefdafc822398aaf9feac85cce8f0c64286a(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf09660809d7485f601b311939fd9b25de712ff222a7e9346b3bade9616ff2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f309f3de8485471dd5600c94727a3b1b068281990cf5499aaa59c7aebcd304(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26bdb2614bd12c13bf0f1268c3be08e4545101d926847325239fe9fcd3f5f6ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca82ec47df834cf518b32b317b1f62d21e0b13d0e0c7df8c990500deb06ac2b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6922a71ee2f7145ad4da2271dcd33c82e926eee5f6bb8ac20282e600250c21d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658c04865cdea3030617de268985ddbc58f994a4bddf4d9b231f900003c95459(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f09b43f9df0f833b671b421dcbc9ef7d1f3242cb81d5284ece14808dc585e4ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed5e31f3cc62c6507491a35ca0f4c8f7d212c1a911a432bd4c396e7c2b4e66c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08c43302ae67a2a81838eb04072b7266d7106f4482cc804d87301bdc9ca7529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b1d1a1169bbc92872c51bd8770b7396c9eb5b94c21e0d557a4da1ad9e6622e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35721d8608b414eb63ec593583922cf0c051d00edb5512f7a7dc42fc8ada9dbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d46a2b0fd15462a01e3c161024740cb81ebcccbf4643116cdee4299800d274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f00642cd9e0f103aba0fa7ce45421426c5e31a7dceeefa571e3eee7279c55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abea4a59d96d83d0ab0adee0fdb2c3d055083db05f91cb77adf6198aea5459df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e8f594889f45817ea0f1e959a95516893e91170494df621cfc28e276db27171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75264e2d08b7ed907130062fa1d205bc7c9c852d0d91bb0afea619f2153f1a5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb22fba228ca1c06e9b38d7324bb88b934c9ceb8328f6cc08da1e25c40ecc8f(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e127ed4bc3ef332d361e47837db63bfdc5f31444c6263d952ce61cfd6ce083(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02598557e03b7ad1c87a741c7ebb61bfbc1ac2e54e9e5c550e2be2e615c97b09(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ecfb2761bd45fc7c0279d1fe0a06f78b855e0c9a179cb0fa3584230c9cd9d3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347230e50e164e907aa57ad8acf3a90932eeefad5f92e13ce759789c79fa29b1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a619b8d986dd0f4af58aecf878c6684381fd4460409aa1100c85707f30b60016(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7998b14d50597334cb304ab2892387c105ffbcf22d721867761827935596a76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29914b4ccd3f3239bf52a3d8969cecccab28796d1f5c142963a5b912cfa7ad15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ab4210169d0ad69156455b8a35ae8c021ff13d5962517db701fa36398873e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a63af70e65576dcec77b45933715ae7e140e4f649bac867323d36511d805747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62756eeef7a15ace3cadab622c2352a8c0f791b08c66881fdafe698eb16e274(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78aeaace3bf3a0e10d06ad69fd9e658d9add373a149c1be19f6b6301f01f6f6(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa937b0f8cbe6192420ddc7623a26b38d7dcc479a0d161b28df3967620d796b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107bd15ae73d808b75f9b304ac89a87c57d01a71313e61ff9d71d60f0946c238(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93c03925333b57c8b22b094fb3f8c422b80a7be17e8cca794abd566335e6507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45b077f2a0701fb4105226ea9500c778c504959c9e4bed8cf371adb596a581c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2103fd740fbb9c9a074197397cbac92d83936e88850e2a28285abdb8b3f9bf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c05fb55798ca90dc9cfc866f467f7bcad3e8c97fc7bd924cc352ba070cda2eac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076f7b381b26869e567a7d481da1b2f3f602e4b17e57068e1900e05f7328fe2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993dda67dba8e12768aca2121904663b32e51883f83dcc885d93143dbcc5b38e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae53d74a392c5ef58d9772a9e3198b4c2d2542c65efc302c748a37d0681dd3ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b837dd6418281fef92c357ecb721ab0f0f90237531b06fcfcc82e58a5fe59a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca24186c0a076610eaa8c250c7cc7709c7bfa43c644b96acf29b8799a028ee4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61732ca79536effcf145d108f7c186e7ff8a0cf87b16018df64e80ec4250571(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521316b675de66a9329703ab5d2d5a19a078030d754dcd5790880031ca67a3d6(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__020e0d1cfcfe199753c94e6fa55a090a0e08b37b8148e80810e289aa6f8e5526(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c0f37ee65a5b25c49f0f588d71e2e1eb862a8d5da4daa112321381e28ab269c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2327f82b16fe2e77ae206b298a826871b4996885b790b13e0d6154e3de61422e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29b9590a79091e5cf3c22fcad2fe58936c66ed454d32f184fee109c77c2c572(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2b90f130e59f6f819c8990cf845076e362462399e0b093e4493eeae4fb021b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87fe6d0f4a4487e2fb9e387f8bb2d6d596dc440603556798c45a97437cd9340(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3029dda40f59373295c143b0d019867a6f16094fe7aba1c2e3525a23983bf6c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0688b172946ebac9049dbd5ee39ea1eb5e92bff7007f0db340253962386ece4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9710ce40a7151e635bfe4ce5694b4699b28bdc0693508aaf50de9be786a48c69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4cdeb45795e81d89680e1366bf707610cfec562e4b996bcb46dc793e17e77d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a086be156630b6c9bd00322a7b574587f0b01f2d9deb3e6825570946e668b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45da983e388c762b430009d5d91ebaf2364a0f31535a9d7ada74b5c7518a0397(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1bcbc9c96cfa678be389a9b7d50c4b2b4a0eaa1d420cf2bcb4268de726cbf6e(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e591348f0b91f9f3a59e061a36a7d8598c7cd4009551015cb42e4d8d37e4fee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a6f8dddb20c5bd99c4ce3560658a39a08b21e8de2030751704fa117478c564(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6eb62c4c70953d7b9083b56f4e80bb1dfdcca19288cde1509f066d4461f01c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d01789ed68bff71929005b210e4ee7aee07dd176c48baeaf487e2eed1def4ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fcb1b25e96ac5bf0750a3965c11fb05fab0a16a53dfe5a1da06fd8bf45dd59(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc8fb51ed6bb6ace1c5cc20ac973c345af436bf49e068f3cebaeea8be1d6528(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e880cda11ce4e9bb3f69ddbe77c9c2ed56193bc05f1d6d2205e437954180e1b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c2a61894e1c21721a782b92ada411039528cfda21beebc243ff2d78b81c9f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f27a8e3caf6e095c011262ebcf712b6604ff50b35d7ed2751b72f6e78093566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39237ddccc84ee457dd08a14e58413b17c7957e0855548ecac8923ba380f92e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69cafd53de2da738980357663c74ad8fddd007bade7ef790e201f1848b753d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77c3be69378edebd6e4e66f467dad71438e9a605e05e690cb9961e9c387576b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5b10827fc173cf71f80cbe2b0d5724bb809923d4cb2754187d2ffa700b88d9(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6331cfcddf2b41257a5bbe4e56695fb8ec9f6bbf23cec18233a6f4cd8a9a71b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2fa013a525e213f0690b6eb0f04de7affd62bb031b78e595cd55c5dcc2ba1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf46cb455304179af0d29183eb759e4b4aae48edc31f374950869fa0a755744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10fccf99114c728a3e3fe932786db2330fd0b17be21722c5b277332b5e2e4413(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad612bea51636b384cb13cc3971f5ebf90d7e593e149c07e63b52ac45800bb02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9b15c2eb9766444a277455aac3ab801250746288af853dfa1122ff04d157613(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac602bab35203b5de5cd6dac96ad2d286117c72984cb122201600d3461bc5ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3418def8fab98ba8a8660823035e1d0977a0240f377d9611309f0fe33a810bd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6fca20e1bb3d049e1fb09646ab09ca988e66435c3aa7ccd1bb2c45da9bf1d7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e427ddcffccfb053132eead5da5ceca6819aea1e4673a797976a8b8fea0109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bf3203b29aaebd2aadeb5c816a6763bfbe034733d480f5abfd142a360429ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e08c60be393f0a8357e413a833817189b97fd9fdc5e75780a1d1d3a37dd68ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5fc19d3c247f7aedb6619a751b0331e27cdcd8d10a7d4d5eab75ace2aa8635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca34f5bba7563c9e9393bcc824623a4eeda55822c342c44b76640b8d60221165(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb8260a82724bd47c058010b32c175199e023abf8b0f49cf7c109e149477850(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17487d4b1ae5f849d235c865bd9034aff0d8607d04ec668876584cf7cd660328(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac12b782d9351e328851263907cfd4282dbc6ed8800365ad5b7b694fe1838cb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c8446e64f1ccb66dd9d723de9856eedbbb0610f679ebae7700e0b6b0d2d167(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8de52dc1add7c502ab8289e766b00dc20794efb5ad2bb6059737c6358426a79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac6e405b15763a582274240ff1a119713e14108c8346ab58fec4c1f1176c029(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead7b544e4c0d2489deebb8e16ce53f223502e841ccbc6ecb927dcf56545967b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d565ec20af953f5ccce09091f5c7a86bef314f7a52795da226cc222bde1a6f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517ade0c23c39858b8abe09ea3483b7ba5651983fd1d58e18e06b92978a473d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f6134ad8780130f08919e85ded5da9cd2b00af39dbf21d3e8986912ba848a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda6c03805f853bfaa4fc35dbd4bea5427561e34ff3b904b0ed87d03258e7908(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f1ec347fb79fc29cdbd7ed021d20dc838cea9d36cd8a4a40d014755220f3ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e78ea0554366c54a1ad237e0bf5143c6d79fa137ccd704ba67bab438e1fb09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59485cf2dee4465dc031b226c44f357a550eba958dad2246176e01c7fe31ef27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989c01cd88db379007a0d9a36acf5552f1db529c23f3a6ba9b426638c6875e47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e42638ef7382fc80c54f2422fad5922d1ed57822b9848e93c0cc793bc86c03d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80d66a7ff5af34f2146fcd4558b99f8dc519890176cf1179d47cee06848c2bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f03c4b416b93368b1c8bcbff4b0beddfefc04befbdb8d1b6d1e9eaf0a2d86a43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9791d2e34f00e09143d9a6f76fdafcde651299816fdb00d0baf4afbaa8d6b235(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a3023a9b311aed8f85aad8d22f61006f6a74cd2bb0e1f2da604ca5327146d8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1557ce50cbcbbbf48b08c61dfdb81ed9581a512f3be7e3b57454d7d95bcabd80(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65369d8eee766b79e6c5f790c0d587c2290c6a26b8df1be8b6f2b3ae897487c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5726bd4e48076e9ddf3975d2ee3839fa8ffa15e9abdd81e93f002c5abb64663(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737f73c4e1fe45d73ae5dfbe930b8dc863d6151e0547f4c38fe2655aec5a71ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd21f5c8055cd9e7a38119098a2ca2b4c3266217fe5e7dc6f64022645519e470(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee69e4db02b2a8fe1cb0484a62dcb10433b62f38d6a937bde12fc904ce4cfec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639dc177f95da7c1d7118f1e943925eb163fc8a51f916bfdc497c90c3aadefb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd902a1dd2a1c1974c77eb618f081935f548a526eb60c6522c5218b66569ebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e633477095fdb08d0107909cb2c27ab3d83ff52f274433e77ba90385449560de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d8b19baf5fbfcc5cdebd75d34799a6d6afd5773f7505f69aeef84d525a40e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d698224cdfa0c1496e8dafd27e0c627e262631ff082f757fccfb0babb39bb6f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e4a1bbb05c5a3bc6f572646a2c832cc0e04f204dede2c3f046df5d7e0adf21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3261d4d3b14f8c2cf0435b97237b06b72daddcee4b5abb7c1ad05e8b5a6f2f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c725ffe9864e5e27847b6551d5abb2112c864b7dffdfd4a850cbca915c6f6694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd070706b28de687c7566138733f1a08b093007b5ee98f252ee107371acc9e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73b976da79a70332f3861818b1be0428eae90ba083cc7b55f298fef09218657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49bc9258d4c48759990c62c6820b3627b2e1aef42680ea47559fc14047d96fa0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8790fc31fb899658b3f3782429987edf6602cc46d5648b92c26882ecbcdcb41f(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb14f018ec9735b67c5d633ff1dd28efd493cb93c28eb57bdec20eed88ce9ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2ee7f5d13085cb36b2c89d83c8fbc8988f49f29d8fb1957641f4c37dc8925c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f33cad1d0c65b0db21c95a354cd385ea5f0a04be257b5348fa04e5288014051(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd7370157de255ceffab0190b03ee9bfd38980c1856f842bceec88c689aa839(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d786d6ad0c4e723a40a2deb040d8fad3434a5825f2a7f70be0ca13f1ca8702a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e0a924761c155d2ad82125144673e2afaa950a2ef222e21dbfa26982d63eab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec50e39fb0318386c1bc8d6f928240800912f02eb78e60b69127c9934b66aed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dade1b19e2c5bbf9c5b2f7830d8ccc1a86ad6fd79a3978346c4a5c2a8c3aa4eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f8f006348760442bcb39e450eae84c3534a6eedbafa69eec347d7fc6b97c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29a97d093bfe9ab90fcb7571448511fe1cfc004b2c9ece335460fb25130feb8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328b52136053af9e57d81477754cec6e94a95b65050ea0b943f824f2c5a86c44(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7920bfa1734a38067d8a78079112d3473b506fd3b372d2305b7df6eb3013d046(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0aeff4e43adaee3f2921f16bb40deca4a2758ea8dcf6c08e89f628c4713826(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cdd28f0f89bf56c74ddc9bdf4d873bae1548e016c950775383a55b3bd226a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b725666a26bae24635cf939433b229acc1ff1f1529b3bde53c7bcc1a56834922(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643f5fd3b15047bd103f175517bee46c5c7a2574ea2b4dac26bd5db6b28c4cea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b487258cd5c195dfe5ebf4c2b3e33edbcb46f3c85b6520e38ec2632ae57630d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373b36ab632d8afbfcffbdfd1dc350603e0a47a1d29e4929e8cc47fe3a73b9f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f10ef789bca1aa23d59fe038ef14b75a9f187542d42c4e6927837d0c09d8a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4106c91a1903365bbab3d7bd5ab80ff0be0835534de7e7e7f40397c6805744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634b627e6530e7b88334f2349c557ac5ab2aa2475c2733f7a67baa3d221b1a04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4536934f42bda2237e6e7ea5c4226da5abad9c20a9565003c34906854e93888c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f3fe073c776e86648b79631cf8e53a739acb837d0ff3178c2321df96179b185(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0565263880080f6a2b6ae66bd64ad963cac50da182a26db3b5f47f8dcbdaa8f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2599de37f5d0597539e4cc0c458a70b2bc2750d22e2c30592bea7527664e6eb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56aa35a4ddc5384181c9442d43c0ff7f5a0b30858227d79135b5ec52d726896a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709e0d010e9e474a4c6f1ed64629d14dcd468e9e2a7c03ab2c9bc37f213dfb0b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b6d0f02efa327443201d49d1b9a3cfca065857375135540b16d68ea5725e7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5641f5e6ad9f8b50b0cc7622e5f598212adaebdb7abf0f98d5a736aa81a2fe00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1694afa3d60352e7ca06f5989728261637d961470d507fa996b0bac46659ffcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84171b45dfc7944c08ce1a68c546e4fd984c67b0b35910d96f05d236e3fb1589(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7459b607a1119561fa9301f5f7a1ad5140573f216ff38aad928f510c86931747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16455fb4c6ca345613fb045a57af9f710c303a7e0bd10fa9dc10923946bbf6a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf59cd8e181f710f5c3f89f5f183ba8b5e6c0b221490fd78209f24f78a79335a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d44936a9b1aac9252178e9b5a8615d2209b3b9ebd89873a97989c18b423d1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28270a2a38dd7a3a363e80233ce8ec53aa4038f4291d1fd3cd903e8878b2b940(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e48f48ab700b75b87a6a35dee498da7a73c22d37ece0b0f93014cd5fca4d11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e354a71c99a6114e3b3b076f2865c136a06ae7f98f1b9aeae6a3ddd98894ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b084aef4c92e553a53b55644ae0b299a5588260f68efa4305daafc5d352cb48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1804437f35c99f87b243383942ca404a75d148b2ee85f8f894f4a23f9c123ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1621cdc979c24ae4e80a35bb2f18e28c164272c059a97901e8a44fe79a53da01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48aa5d27796c72860bfcf60479d07baa3a24d1ba73302355a6b4c1c9b06396fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a75e2b1560a92f39984da0c9bfd50ad6968fd050c2ec867b08e8b54b5d6dafc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9cf3e3f97c8792bcc0efd9c30df362dfb59315f133cdaf54331bc4ee58c9d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e0ce41557d5dac481af55ab16d59742153e6581f46e587caaf2af5b0e332e8(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5321d47684257dc8017b1b8e780d098432a3480abada2a885e0c9349608535c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1376034f52e76e495097e42286ad58bb4c3082a91a715bce12a3e6190703989(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5383c707ee0d54463986e9550ac46fef0f73dafaccf61bd50a98f58bdefc71dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ba72df3dd89a2fd6722460080cf625cfc14f1c664993d3b63e2e7fdf54ed1f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0a171f527ffa2107dbdaed2880875a812c9127ffa313a675e5b512c0080825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1328cfccfd4116bed357cd63184234724ddb1646a97f8f8cd1d9b8752f77ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49dbd561a8fe51a553e3267128cec1efc742d9e05cf35b60edd8de3132cd8978(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7fd94b4f8f9480dd38b693541da3f82893e9405bb20c306c35f3d02d6753fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761e3d3f12966638d6112e57da806471cbd58e575cba224b44e0994a2cfd7deb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f4b543e836fcc367ec961dfe9b990af439b008917b0c387e639d88dac12d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd2e285d30593d178172a7d099dbb432545bf9ac8e89d7e790d9c52cd3e45ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080f19ca0e24817d2d3a5df6f71afc86335a9156a4ccfbb46c6944ab0f958b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a263538ce45accd960dc60501693831df548c21ac50fe08bdb9f84d81da98683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19265e5d0828104afb736b36cab2a513cf39e2f511c8cb1b53cddfca748c646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bca2a81f5d5eefd1c3f7f4c415d4b5b31cbb5b45fe841d9ba5947c4ce2f99f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4325829327d824f205ef146b119a6bd9e72307e8f0854011ef26e1dcf0b6b96a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41713d2d3e1ae901ea0f4e6d6ce1fa3cef8613b164aa1a708df52199eb6e2a58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e336a53d00cb588027203ebf03d4de0b6d77d97db6d9c994468f7470bce9525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b4e5d07abb33858da4a2eece54ce24d4c114f0408a5ad11025f9ecf949e00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3f85752f7223918320ebb867870b8cdce81b96850dbc9f9cb5a742b4dc6a8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4636563da2fa42dea9210862811f8e5e62ed80c508120fc2289d82bb3def2775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8683af466bda8edeb92e097768a4c93c1ab8c8a40b869a37b91042436ae761(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cab12103a95c8648e77628c2f82d8b54bafec19a0943e2a5875d47595a0c4c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada3ec8662097137e9fa35d4d8ebddeaed89d5f3699240d10177d0988fd84e8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b7a5f16c039958463036dc6ba9893dfff4114b84c44671980e9f88c705fa09(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68d512ce03b1878b15065e392b3815d87349c92a5c0502f87a6a0184fe5d16b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3da986b2aa48c2e9281f46b776bd8af88fe077b7285669997692d9aa9594b9f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6c97e6060366872dd3d375020b8d832ed9f643a8e30951af5db6b955e664b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677ed27463be649c86f0c3a1a0bca7c0ada6b01b4108cef9f797e57d21cc4537(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eabf5b2ba47b9771a97d75191d801a4672273895e52af79499147a68b7c025b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4383b7708e2cd460cf9cf837e86867b8254a365c913cd44d373b3bb5fb8ac775(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c721b394c64dfb1a651fd2c582c4838a4f4de3f796f3e3b22f0fc278e34225d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36cbf9d122423c40fbad337f4567958431ee5c3ce6840f97f95f66b9b8c497b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc13759f6c5ddf6e0cd21fb5e5ef609e82ff2bcd238da29ee0aabd0dfb54d60c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6330dfeb6b8d5ce57713611b8972ab50ad2a5267b57b8826f577c4e7f051a245(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547beca1f96d84b2ffe2fc0e58bf7532d88dbc2f26bed2bb696c77e939fb4833(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f54ff35fb7d7998c5d8fa97feb1b503fd4f844b81d9b843c8ed977d94b9de3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7e5eddb9ae29ae5fda7ab1e291af9df3a0049334d8f05a557c4b69e6dd3564(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ba2a0a03c3ae36916cefd988a9e05b7e2fb3d968910f35d71d97f0757b671e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec23a6c12f4d9d43737cee109751cd73eb450766b4621ed702ec96d6444edb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfdd896997c2f1280b1a2b77dde5000b5b75a0d287c1421b140615e9d4b680bb(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ec04de4c29ee153c4c486daf10636e9ba9e1684aa426253a3fdcf16e013c30a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514e58c24f7b4e67c4a5f8314199d26d26e7db83c1a12cba49ec6eb7a386b0f7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08338394c39405c2f3cd5ae44454c0f67ed03b9e2e5380ec604954cef598bdcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e462b734fd79603dd0da6cbb25f4f0dece25a6e23069bc25877e1e476573997e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a334594f7bb9b6c8b5be0cb55094539e3dda0ee1afa6a6240013cdf6758730(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304029732589d0f02e9fe4a080f88a7116703ea9ecadcaa4c543858327718c59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ce7c19d5cb5e61a817f2432354aca3d706dc1f0831d69aa05ec4c7b5cff0b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cadf328d277975cc4b339b2db58024922b40e1f6f6d6c6bb335639e075e15d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c0fa802ae30dfdde252333623274b69e04978c4fff8a7927df6fc8179ba357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202627c1fd9861e0d58af2ae1db444100041fc8c33ce9a1e1204ec2cb3d92012(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48bbe58671ca2d01d57bf034a94b9ba6c953de6d200d6682170df6b39df15ed4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234bb003f94e13b54d73af6e84b0455d21477ca6efbd6699b72fea2b803b4507(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d71929948367499a5a5d7c9773962b860490cedaf9ce071e19ebd5d00dbca9(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f11efbb44d26b1d104929350a7389d748920110e4bb50e0c57b0051670e353b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2aec5d7d6d807902ff69e3e2f283ac57908eec3ebfebd467bb28b8ce6bf03c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80912d34539defbcae86c67cd0ee31ce92e979ed6797c87c45133eb5cd8cc9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1497c01e4552e096cbd1cc10c141fdac20eea2a34326e73afafa8e226a8ee3d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900f1a7e3a4d9463765af2c676a485f35ce4303fe54edb2ba189d8cefd1ee997(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb7316b2e9255f22a507478234ba71afe0f947ce05deb7b9bb97e179ae1441c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac19ad16a34fbf1e4f202174fcb5eb9122a2dda385f8092f09d127c3ebab935(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0e7a9f778430edc9b5f27075855ba1ca908f32448cd952bbb5291bded66105(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafa69bda6d2246f51616332b3ce8e673eba75528197e298bfc9ffb5fa6f1b21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7306e21c0f8bb5e37f7e3df465f297d3ca15c94586e5585f4359e06f263fe251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f40ccab7910d9975e4d324055ae4db958ace7f20168b63a87ec563ff4edff32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce11c640dd30e0e94f93b146fad2f00d2c344ec35959615ec3459a856640b7a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657362163ca72242c56493334b045df4fae5ba898f0edf84c90d003bcefcb98e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf7b84888f7cb4877a92fc8ace9883a038f0cd991e5f1cd0cb90c89c420bdf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d8eeb0e499c894e89641399282c83e916fef3dead304d3b8dfad74b12f63c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6793383914930684376f748eff6cfaab0b916131b7b84ef521ecb15de3e8c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5c1689181943c4d58b484bcb480b5c18cb1216602f9c3e4755279f24d1f16c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf5552e19644069d01749cd23dda78f1ec1e08956b7c41104e89a9030cbc064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6677759ea2d47d62aa2dd21607dde6eeed05df1631f4aa1baf174d2ca8753c31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e5d889d4918f655cd6a6c81f3ac650f04da2961f3202122a02b3d217ed2caf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9867ad305222e070c97c80a7601f3baf9b9bf6e721a4fd25101ab9c69e21d7ec(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb6bf644c7b65da3e77b0c54efc10fdb0fb6fe9b05fcb11c27516ef472fc678(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ea868e5b43f40370b2275546352a96944c092bf3d31aa605abe726164282a5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__099f4dce34dea297ca7615f28407252dca954b046424f546258eb9c1320744f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3cec1a340b7f6c3237fb511a94a3abcf7f1b6e3f5c1781dc6590c2a370fb2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc84e7279167639c6e63c996ef0a028773f2309295e3b30649379c13342fb372(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60191d96faaec79b235c488df4f2a22a36494ad5fb03e179d2bff68cbd6586d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942b8533144172d77a2fc7ba085231169280dfda3b7a2e9f98e138652fe19f11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e2fcbadde5d3bd2fe7afcbc7d58a82a16d923b87b868de8abc35f5f3eb3f0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87db07b0d85087e6efa3ee1a07b4c2e51ca7ace558a0f7b17fda841548faa82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c341f32cd97660d6b674f548829fde61c341adbaaef888c1cc54cf93664a62d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1afcdc13a041b9f110694e1971e701ae5a5c7b4944a05232b081b4c78bf27b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06779a88edd9befba8f37514e6a898906e0788bc2e649a247df548bf4f757ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efcdd5a65216e47148d9516f3b8eb27225a42c650ef5c02da89168325f74d234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f42d19ef1c2bef1639c0ba7ac978ce9f947a4e84100fa0b274596ad060a1921e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f523285b8bee0c9152addf354338daded2ecd4f48dc6cb654002ba2d3b873b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f51312f74b5ba14ad5c47343bb7d2d0f46019ce0b423169d3a46a123bd6548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb24f55c252fa16fe631e967431151d0e63ff735010a89eeec44dd8744f95c77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3912996339ae7d24376ae9af5e33c1341612a9cafa13f6b315ba674ea66d883f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260cf5e7ebba3677a89d1c9441a373ca6de1f3d8a84f20cd4c8cf041f36d2ef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f312492e7cabd076782c97856e35eb838a20bfb0798e7e10eb8258e3701f71d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3420536baf879ae3ad594fb8b89e2fea8a3d8a60b73fe5623672f3910376a893(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459429201103d1f730c0835cba6f7ecac06a22d91c416923e23d0dc50a6f793b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff59a7b217c5623fd65a38ec3475984ee0c66f6b4a39f499855a14c3bb3de742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce787eb36d46abb69c1e28654d133d96f3694c4896fde2f54d2f44cdf5d8432(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f50cef8b13ccb9d636fe1ad678e2f7645e14ba03f8c04ebabbc199e39d3d79d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b347b18fb3904eb1300b45a7b26602bac0f161b01fb0a0089625486f9d5093(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a07f780ef630d5e60a8b6f7f36a4d675aa5e98c2948652195806a628b9d45d(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7befc87ccbfe006b78664577067001f8b8c1c424c48a3c5f3e1d1656bb04b3ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2aabdadd0926a01ed7080cdd560fb4345a4839a1de5ba7993a0c591a1acd78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6483fb7651bf89d4cb02b0c8acd3fdd74ee5c79f191c1c825bcf4b60a5247bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210fedde525a1827b4f2c7a06ee16f5401727b8a14a366e2daf5258948201c30(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031229299311cc5c8bb8f59bbe4b5909033f815fbe66a1a8fc5025556e8f4807(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e432ae8320825689965dc9dd2cf006c7d4f021d5a0521a7c55b9dfaa219fce10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04abc29602403e354588835b6f519d0eae2e5e9f8c66dae30ed9e67d4beb03db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eeb73810fac43f2f9d304dc15c8b0002912cc418d83a3bcd6c12d1474788f4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878cecceef05e8ec4112b0d19c67c4e461b2d2ce2c352c6da850aece398dc909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf24d7dc6c5129079173cf21122f7fce8148b31335ac3b04a07155bbf7384a67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daccc70d68917c01114367fde2a9436610da18a1392dc46f569fe3ac7b94bb90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3ed309ba05bb4a41434168890827c514ca9c264e93f283750acbefe9df1f21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f39ad1648580720cf37462159c8f7b1795b0255ffc314855763104eb6ff0abc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ec37a6217b3c3cc4b744ded69dba3bade06d2985a13c95e845fcb9d2235363(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95519f47a70a228d0d3da2e519166840cd8f89960b509e638e9162a8e26f0705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43bbd65e61584b2d34c3d20ef3480cd8021d24ee084fdc445a8ea6c7305dcdb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a4d53ecc69aa20c011b5ef1bb79b5126f9e3742345d79719c20333b6c0106b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f4aa848dd61a8a79fcdb288e8f4c3276cab5c9d30081a304e437ef6acd8479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866d3f26a56e3c3e0e9287f5ae9c461b0e4a50aa4bdc05c745b6da46a8be6914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4c0893b772cdaf41e74fa414b596097ef8260868b06f001f54024616b1571b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d14e68ba69f4d7ddc3438196579a73ac2c3ce1eb9a70e718ca29d8bbd8c9a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b91b0fc987888e20b672dd91aaf787689b70717e55a8f7477f4319572e5967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a974f2c16aa0aab932042540737b5d8a559917b31fac668992830d0b7cf3d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10394681cc18f9600eabfe0aff55f4e171298d6d11393e51f16aa8065e2fee7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba0bed608ee7f10e3c63d846ee726ad606b79bb4572d341b7acbd5a89c050e91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d15a4461547e74bc6f1857638bf43191ebf91cea08f3577c68b73253d75e45ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a14f57c2d17e6ee85504b7ac39ca9c09d0b9627f9129b8a27c10a1f2592a9e7a(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7773138e31d1a679e568547ee00545cf1b371a3dd17c8d5e23818269cac604e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9fc5f820e03b78a4bdebefad3ccd7d2a33a44ef704ba1c27f5c87286bf6456(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d25102169153fc3b935c49c6ebd6bce5623ef431da7b2f90ef95138cd6b7419(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f72f6a87177731ab34afcc348fc99259d40cb266de81a9ce6b168053f4fab1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21af6e17536431429a99c3213147acc38eb6334b98dc57778d2428a512a2e573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c749882b1be10a55f02b4f038e513c2d32ce8c6fdbaca8f2c5c9b6b2659b1f7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f529de96ecb515bf212f07b45c7d080b4adc34723311ccccba7e7a11bea2d633(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865afe1aa980c4070b3e57da0390f2e85bfae5bf2f3096e3d1a1190a8cb53a8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc97a3197f112639bb127af36b90746e25f63ef5fff7edf888849155b26c07f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c2980a14cccbcc56f5c1b776ea90933a73452c559bec2b87f40cc5831f833f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29bc538a57a4644f71ef285ecb663c3efd73538a2171666348050716bc706cd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4629a36e5ff01bfec98cdbd076db068f97fb33d47df9e5d9f2e623e1561fe61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea2c968739b4317ccb84424b3c0e19fb77215f8b95b4de690886ff6d1ba1617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ff96a1584ffb3b1400db4445255bdd0f12315212ebb49b91ef09c7b76e0ba1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b38605ff1afd9d27af95a3e289269db239a3a9d23ff337367903f3bf6b32060(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5466ab79312563c74733b90456b56e7c3c5b2d2fedbc7601a709b759e06278fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40ac4bee13d4dc7acb11a4e22a4245f5dc30879126e01ff5f2a6e71097244db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85787e6e56ce97ff6cbbffec64e0a635fcc8a4073eed0c12f6321b92f2d27bcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb585e369d399fc3be41bb4ed82ff787eadbb32b15076e72b4cbfeb38ee28bb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64534272d824a8db1f60fe982924245d7f6b5239903516e6e9952ac5246bd65f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a266c64fc8c695e436c782131700842427beb8fc351c8d3a83823a6aa41edc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131701bde0a8a5f2bed2e26e7cc55aafa0d6a3e3176a4087043b56bb5f847aa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e76e2a2a6c8479e75f41b35e16a8790634402ab7d7c73c911ac7b11d7bee7a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1eaa92b58469c479efefeeea8290a6d776df9af7c1923df3ec0c183f1e28bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f815e0b0146f8252d4581083e0864e516860f1186c61d3ffc1a119406c3465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b13bbabbc260a61033079f1a7aff3bb5b20bfbf699c03b6dcff8ece1bf40d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89681f154fbe4c0c5bca36ffc17ac6e01751ffd22d8d04fd90c08d713b87799f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c4dffcff9649a188497325c5e40302d288ca7c6f081dc579897c3300ebb96c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25b19443d95a5c1230405d41bba0496e576d6827ef82571f08bca2ac4a869d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8051ca308ed6b0624b395e342277baeb3b4b74126aa9fd8a1487a808704dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b5d64edbbf36f505137eb82bd969a36646eab6c48b22a0276f34d2777efb34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deba26bce4c6b703d202e0c1df8c1fc0a2c04ae80e8459b88814fe134a8b3f55(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e40f9814d643439f4694320a4d9a448043a566d8eac30676f990fa3758fc6ff3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53844f259f2fc949b3b5c21673a88bb1cf0c76a0cb050e157cd188e7e257b179(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8ddaffb67e03e24b730514b631f30d15146b9f03712772c9e7ef0312d70358(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__481a0367978c92fdf609bab42ac3680a6bdd4102deb310968b2d4f8aca581674(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3acf4dd9a7578d986433c9c2b9e27aae5f0742e720ac330a13a77f9a92fe4223(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4a0bd184fff7f3ff18d4fd5cdc72e37b8140e11624bf4b7d0084b726887e35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f68bb69e47874974b1fa4b892b45cb754da816264bd789b74a7f5bf92a4e96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e605f3f3ad1e5e12d37c0a2253d4928cad36c178df14b5895f78ad1b02c6245f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ccbfe45895a69d1f0c732c2b74ccf56b8d79876b570ad0fad18258f8e559cf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0612f6940e9c1b84565e9cafd2de3c8e43dec5451be5f1abd9f397316bd9c881(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4a762a987eca321416d1d3375c3313c5bd67481a4b6db737c384fe1b8c81f9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b707ebdeb7e4c7a652a6e72fc68d3e2c6d5a2a1b192efdc3c9f608a92a6c68bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2faf226a626e7ab1189001e54bcd21658d727c2fee9bb72f4f5b6362c220e08c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189646fa621c3885b09ddfc2745d045e095ea6acc80835da8830369a00b075a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b18b8e1783127c06c34c7815fdacf39a6519afbacd20893d146e178180f03d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54725a956da5250aae21da7b9a20445b32794c143551b5b49c0250240af9ff0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728789ae46b3cd6637a98f5bed0cc81f398c4fa4f26310085c862bb01afa8d6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7424226a98cd45798601158f8a2800367982df3b2813660f87b4ca29ac0517e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4265775864d8372e3f812f6bf1ccd729154f36c4da7080ee60a781e1ab9572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aeee33c72dbe5040dff1c121b40b5bbe1ade20814815dd906cfd4653760239c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbde1c293006e102914c3a78b3ff46852e951b4b406245623a7ff708a1c2b351(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc034a5cbbd3453265ba3ed933483fbd07d94ddd2fdc2d0b4ef9b21b70efc7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5633a3214ccad8f521525da548df728273fc5ff96f054b3eacd23369fd6f6ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b977bb5f44dc169859fcd758e000feacfa039c02c5da05f359c0e13a5d261d7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63bcf39a2efd4703f8f6d9e4e3e99e3f50f8bfce2fdd7f51a6f71b5679360291(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8bb614bd9f6cb390dcca1e7af79c54c85300e23b6a67201a15539404664f70a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02490eaba751961bd95c96a57be0cab014c1fba275b56b9700425e900226ee1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b828e639aa3733054863e4a5d20b57ffe25964bf495c4b2649d9dce441e7b6dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e128ccd26fdd4287f545d9cfa6fd3506109ca6837999ff0e1537a6d55978a21b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__574f38113fca0dfee009b4d93065a01df7ef8558a1d9625d3dc7d0f18a1af898(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea2f6d086f65162f37c3c20abb09ffd5aa422b6558b7acce55215451f302212(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849f6e264ebee0febb7ea8e3d77fad1c035c9e6fb722914932e5783e8318efdd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944f50dff9f9adc18a68390f77394d682d2676e0eb769ad587c8533c6289f7e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855dcc1b3944495d669f0941c9a8725e28f59e0039c92b94dd0ea0ff99888a43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fff8a0a572fc96aa9a5d4ffee10be9002ba5e77d97aa8c5453efac89b4e5c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bfbd5a10b2e1fed7c23b5949b8eec2cabd57d792ba6461bbc92b1f048cb36b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0b319c14956dde4e9e219a79d9ee7b1c3c63476f41090f55ac2a5f9233780e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bba6dfa8d37e4f0f18ff9f5999f3225cfa1cd9f043d6766d1058cbe54445ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c6e23b03e698ce0dbcf6d9ccba9a3c6d56a4f5b0cd5a4e33e4c9ae3091e8c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8cdbccb08ab157e7eb8dd20f86a4ad0aaae1da30b2647c2134012099c2cfc7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f9fbff2bc41621fb174a6a0bab94044344e538f81c0608935f826b18d5456f(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3779ee6ad4f4831a5333cbb23e97fca1b3dc596ad57928c91e338988cd7b0782(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e41dea9a75e87b45750d615564fae5617cb101f0a05905dadcd7b56580f9fa2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3e4758809c5f4d57d88460522177c09cc1f64d124d39af0e502e197d4c3a043(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9980003715d749fe6f4623a76337e904026b42af2b072394cfe316b07464acb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c7ca3dc75a13d4cb26964796195693fec42582e55ef0598332669222e8e8a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b0fd5811de919937ad7f8d79c5b5894b1756647dae6cbf5a217743496065c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6457ba2fdb05a35db499b4891ceb8652b533ded3abc37a8af45149bee15279bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49a5354ab740f9cdd06f2c83b9c50d8b189df4f4e2517d20ce15677de409d19(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1609c537966136d26c1afe3456e076a5db734c8a0b3e4ec03beedc16a28e47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0cf4fd8de933337875c4f000e67cbba79bdf0faf4b675732f36c45438b77c6f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbd2273a88e9eff8498b092729475e64e00c685d1d16320bad66a153f908b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da0c2f95a88d6d55c8a03a3bdf911631c47529975c1dccc5e4f4a300a5ffea3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb396a20c5c3a8da2f022fb2671db9a0f656302dc32c63155836264c0c58e08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b866a63c256240ffec7c9d006695dccf5ae6dfe58e39ff9396ae4a379dc44470(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b43039ae087de53b1ac5d8dcfccdc7ec653476a0709a5c6b3ef24e864801f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1489834564ffde1055e9ec2b92f2d2bbbf3ad8931260a4faa4ac19352b3da04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db275410a504345d7cb01192faeedcd817b7876b5ac4142cab657956d28cfc05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93835472dd4e8d4ba58970cfd18af4df5a23354b936a91fa6cade6916d56e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91760db8a4939ef1c458d7a91444651f26dc15eb50575719f968ea8f5d44661f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1d6aa981da10fe8096052b20661c1e5fcd9f5850e7d6c61d2be7a7d7363199(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3efc12582cdf0f5ce29ff2d2df7124fa8266c19b53c9aeb89d9a6d618478b4d8(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62f2f11b66c1678f7a8592ca06bc0c37a54faa84ef5662aefbfe7cf313d6663(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2102c39dacc2886656df765faa8579623b63802925aaa11b20287c588baade5b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac49cf1b5912bf7b58a6841de96254c83c3bf6618950d55e3769e823ea3d7e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9c203b0a760ddcc9d6ded0edaaf5c772d8bca0ec64bbd9256a4fbc3c6b34b4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f066f56d9cecd1b93b28da9b8b226666bdc68c7aefde349cfe791bcce93a1aa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06615c13896b016f1b22c87ce5176a30f178fedeed1da6d4964ff302cbae631b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c7bc6009a070c8f4c76ff56315ca507f2a05a1690915aba3b7edc7c889e169(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7415bc0c8ce90b7e900456525958fcbce47792094ca401a9c4c0c9cf9bd18c29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f3041f5ed8aaffd8449f912e4ab90132a8083c131551964dc16649620f4547(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb453c78d1e0e0722786ad4a312a391ebabdd3ecb608a7b0a8cc43a7446f2ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fd4ac3af7696f4295cea9201de7d9637808a2778df5b551a0c39f3645c98c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6887f9f7439defc96900f96ee4992d3e0b2801c1131ff5b8eb1b1f2ce0b9c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb298353fc2de9beb4209508fcec2f3d9fa72a4fb660cd87585b00605da9e89a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d49f6e088a84355a227f824bc9860621c11d8ce22ca6fecfe9dec7f78e635eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3441fb6930cda6fbbaa1afbc1a40a1c8adf3612b46ff7acfadc5f6ba3d7390a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f857e231e7930e3a4b12b647046f5ee2723d2490f70446d8bca98443c498b99(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5318ea512fc7b5fa76bf56535cda63d8d2e805d28ebe5574f21aa7d977b7b6(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba27d7189140277e4e9b030e3c57d4e7459075d549ab090beb186486c56d1ab9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408efc524abc26940f45aa4b21a17932fd35a645121c0eaa45441718adf9209a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f47420ce29a3ab74a0a1c615a4d36c1ade632a3899caad0a093872c7671113a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768554ce133be54b8f62f81e9326e4ab4dbea42ea47dfc3980243db5be7c4f1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2024bc593726845b4fd0edcafe4940bddd28b2edcf319b2ba284c54688e7bcd5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652574fa0d7acbbdcb1f2011459022d136b54234593558be274a5a7a66b34f81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f507ed2579b330efdc15f88e568f5a0276652fd42323cf940d0eb49e9b7d64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7761c26ad56ffe33f314acfbdfb26762655ce90e5421ae8f8efa7006188408ab(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b83d521825a4cf24d6de56bdf4091ef0fe8c5762b08cee5a9ac9f64d242ceae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab9db9216335465e8d06543b93a844c6a73883befd16ffaa1c6c62ac31117a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2bddb1b7796c6ec8caad46480ca82fa3e6db7becf817f661365706e5b2e3f0(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec9da0dbf93c2d481b923172e297faaa351709c2ac1e04ed942337120e03bcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdbc342616a58729fd21103df8e3d536828662f4e49ba4e2fb5a4c4321b9015a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fea4a836069b6cde2c87399f176859e70f9842e3c067867dc05edad302be6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0275b130297dd4ace9c8a559f8ef93eb2a4c7ec16ae388719542a35a8cb4c295(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d41b9f163edf9af5305a18d478805e434a18adb43b21d25d6b7dde91d3c6fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a381efdb74df567487441862df27922b66b46e504a294fcc9e2642bde697cd4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ef188c1be5c56bc067657a82d47f9251b0198f37d4a3f3de62e4344e5d02dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3937e02b1add592d5758cf088b411de37ad48e51e4d9b43ba48b0f824a3d83c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218a4a33d120017c3c4a13a23c6a27b3b20bdf1423a5ca747df5ebe4990883fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27565ba38816c5cc2aad28d52890aae155a6e23c44bf5d9b902c2e943043c5a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f5018a46c17612ef31c8f0363f84e491b1614060ac95560402525edd20e4d5(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ec9b597237c4b682a2e538a545791b2e7a8e12343803386d8823a34e9a16a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261606b3bd74b35e9e18ff0e41ef8a2b04baa4c54c7cf1432205973d8a7bb1c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e6efd7aef8cb7b0893006e66da521bfe0a8e4c2b4441d3600e18bd2d6caa9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38453f195ffcbb95281c5db55817dc82f7238744c2135b9a318d1af42b3c40c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9feb234451d4c64b4655e5c75cf6a225d7f3fe070c81a96f7f0fe7f204fef27(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e51e05ff5691a029904036fde861ccc8faab37a16b2fa1ffb6f38418611a5e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094a8167f4e6e0a3605fe1fdde159a1d746785457e554525ff33fc0850ec372a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ec3324c061ce03ab55721fe4c6e39667e888e83bc3228ea4f9681e309321aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d99160424cd7125618658b6788b9ba76d139fb5688f654bd456a445c72f8dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__296de67c50e506cc799fb8d684bbbf913ee15ce7e929117be395ae7a29d2abb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4a7cccd1d8ff414e6e80a10f468794567169436cbbf9f49b235b098ed5bca6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a33745e1f38b46483984329af49b7199f10cdae925d62aa0d5b25525d8cf0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc05bed85e427a1f243c2f2f1338bee9b27ba974b3a59a33e9af1575d2dd0e5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ee953b8d4878dad2cfaae9724c3cb5227efb1aa96546277b64567a974dd8cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261af48b0e0cebd2c995b27457cbd119f2b8cb0c7e86da064c30b73ca5e18da9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5455a896ecb6860ea661337e8670ea7d16f2d95813853f2ffdb57319de514439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d1d7633ebb3f8de27e4f77730b406d06ed6e41e679ebc0327b33dcd385dd07(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0572781974c20b6698b9a56f5848457c7172dd2e816f4f49d6b161285d5638d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70bbbf36a1cf428e6a237de7a156168df990d6afe85882ae3aedb0ef9654767(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5825c430b317bc6e41fe694b6ba81c302f5d345c2ba4e4c3540a8570568d0df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1f4d5a8dad1dafcbf6dbdbfb1dd12de0e1a4658ba74b612f1f98e5c35b0c6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a39f1c48971b838187674eca3025aea4b4ccf99f87ebe649603d9cea32e942f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5068bdbd0c3087973cd5d7538d12fda970d360f2f42983eeded55dfaa068a7b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5af81d7b975c55c15ea9cf033365f7e7317ebbf2e6eb5db9dba38c19fa94290(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c70981df4d798d5899e565db210d5b3079043b55ee4e70f3b20fb0156ae775(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9920b522aaa1db95cf86d08205a56ba568b776f237690f47685bcfe25525dad4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9966d1d24877579c28e5628f12c6675a02d7b5387f50d59d2de4de4a0111f8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362b3fc18792071076b91634c54d98800f6a3902331407d598dccd1d120d2a81(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3cf4c6a16575766d469f8d5ccb043737dd4cc3117528bb0c18d84f9d9ed7ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4dedb41927a724f73a340173ffe41ce5c10200766fee962b9e2b2ff941f9edb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9cbfe0768a03048557d96a85cfdc4a838442b0e47dfb61a1beacc4c5c64ea85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935dd3b8691f3d1d7d346ab6bc4d0debeebfb560f6eca32ac55d3ddeffe87b41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96616763e474ee97d7ab5a069bec3f6ae831c108b0d85a2b7d48db59842ffab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3102315f9d13b7d815b8765131008fc7e4e07a6939336a656a91c11de1a3a3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5be480cdd8d4ee970ec64dd27c05e581b326be798c5cc76c7f18850a5bde21d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f8e463f36898d5b3878b6ef96eb32086a1e5ea27194ea741acbb17f8c55436(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdae1710fd0df5591e4e1d7a5bc654269a07cddc0d906580a1ed0d714bb0f6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b98e6b55805453b44d98a5f548a0cd3ae477c3c3952fc90bc9d03fc60c6ed40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db349ab04b9defc9fe900465b333bdb7eeef01ab39dec037866d547f9c104435(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e9c1e870dbadde11693f8b0e56ea4168d58dd7732c76554390f82d73a90aac7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ae48b1baeca46d16fa36b33b11decd41d6d54df831df75350e969578248963(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65deb593270283425f88301582bf1988305839f4dc890beeadeedd90cedeb25f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b729ec7a63b154282fbe339196099b9537fea5f9df2a165923c18ff2444978a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37abfbe9c2fa83e23d9989dfd0ad02e3d3ed6d0cd55880cb0da0a4f9fb46619(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec3e3685fa9389e17686e05cfdf250d3632ba92769fa7085578ac09343dcf61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd0e61de743f0a0f6507b956eed12eaa559cd705f6990effe49ef20fd7f6880(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c7f2f1a3f55cdd28da65a6de918afeb1620db6585038dbb42bd833404a6267(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b00b8b6cf182e0fc82a7b151dfb600bde2766b1b3a7b0442a1ba6c9a8ecee82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7370ac6b0087149d34b42e7aa0f5e0783476d4e47e1e7959092d95d9bc5caa2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869619be5b91b2d36e964d69cab79beb1a5e2da1aec279387a9c1d61e4144bbd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5429ee223ec88b7a7b2a70f328d57db9a10a8c8573ec15d6b37b9a7a613491a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776b1d6e49c730c0891d2e2de74d01927137905f15eb5e8b04866eee39fcf5b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6600034ecfee7dffd2ecd2f60ebbd93f0cfbab7c5474326a870f76477cb518d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757534dc729588718adef0722c9b2c59db4ac6927fa7f803b2a991a075bbe644(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101044b01bb4c8e9e27a6787d332b82d276d82e684c27dbb373db99add596575(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ad51802dd2a4def524ff11a8d4e9af169041e8490d2022f7db525a4e3ae4a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d8fe57a6b4de20d3034420f0cecc8c268b0bc467f1a1693c1ecd9c89cee8eb3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc07ccdfa64253f846f10a0e662d763062205fd544de95a4d47c5e568ba2676(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3bd988a2570b819d2b7f9b58e6cbd35e2ca82406b861b479901fe6479c8b9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f58fa69042efcfcff18ca2a4dd3ee519c68866130525015927f3a25b8b25e2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46582a20f8490aa8f7afc5f65aa739b81e438b24ce7f04e1002f1612e2003f91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7859a1c5c32698c4f9513197ee09a1bfe95b5665a8885d8e7ac5bbd36f61107a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c10881910e56628b170818c784bfc69cc3a7b8576ed5591c0dca3fefcf6aa6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1897cad3366eb8167639c398fdf9f02e7a837cf4d252d98b80a4ed9061250451(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a37230ad00e3efea4863b0283a28910cb7f980dd0fe25ffc00edba3a5413f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8405661b2ab9491c4416abd1f3367fbb891aa5ee7564439291a33e4a4ea8804c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5d7363d9172c8cc213bc43f0f76a9d91cb2b759b643918783340e54656bdbf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c17c66c2d34acfa8a67e920c34bb01a54928d44718eaf2186a3beb15acc35e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ea124cadb7faf409503439c02fa80ef9203d4a7342495276bf950fc7ecc693(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fbf58ed1a9292c2fed300efb72aa3ec2d055896286ba4616eccd197252e2346(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ecbe1094c0de829a8b34c1601f1a817c09b7b70de8c0c029b0ad965225108c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a864965134179ac83377eb4ebc29b10466d5616393926eafd1c6ab31f5a8206f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc23dd82a4bf38c880bb3e957698f2c3f09a4ed2fbbed5b67007b290444b186d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e989a1706a3e6c0a85f4dc04d3e2cc5b9cd1da0dd2dba324dbbfcd9f0d55e359(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a536cdc6204dff1ca149af7c0e3b3097db4122d3af7a98263eec61373e51863(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126bc7c3df0cca8234b69fd78ba518676dc232bfc05294f3852f0fa75b449e5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff6a5b2e95cdacac177c9a11d3eeb705d9ce3029e3767c1039e3e5a852feb66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8346a6f32c01a04473a23be2427c492920e07f996e8ec3f0f7b73eb8567525e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c285413acb71f53a3dd2af1b6f9192b0f5fbf0dc64bf4a0c7ecb39d0a01286ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dafda5efe988004d7f4329196074174b0526c8a68dc9a68e2466d2e572949b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e98543ad92c1a5b83b1e4ee9ee7c1e4659d51259aca28ef3418dcc84a61f6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e4d535260c0367707b7586a9ec10b4dfefd16e3bf9fe5fae7506e7732cb658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4384c9ee6e510b43c6f6a4bbf55c11ebef7a71574cfdceb8cdf28442aecc1810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc96ebea4c406e4279a36e500bcc5dc7a9903c5b1eb64baf627ade0abf35a88a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c460c471bbbdf4f8359eea34efeb5236013f069c0e9554e35745e588e181b4a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906fc98f1e7b9ec0853bc2eca0c95bac36e4d668faf33292762de5e77a6f41d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c13bc8f4cd3b8c4799ed713e5e5195e40f648823d47075b96bb0d1824098a6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a19994b97cbf410d0ef790769095991f42561da144b5e684add94ee5b8452d(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7473dfd8566bb3a71abc03b1c79a840979c5c539eee9f337f0c2203548f5016(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04289ef9b40b724b9e401f7b799acd5e09c1fcf7abf9f63252801b49bfdef748(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb09e99c03aba1f37f5a924b535328ba31b07e3f4353088514a9e2bac461ef00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e3baa2fe1f062c17a17167b7033596fb7978d691503724a04529ed6f6a57d3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d82988e3b4c037e31d94405b0e2b103ec843db5404138b77c0bc9956034dede(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d1f49a8dd10c29bda52516bd196cb3d5c839e2331842f4e9fb32ba6f06e878(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669e54efa8d478fe25de7abdf47190fc521d02e183e7903e2a33a4b857aa0e30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e32c35cb9407adbdb321402d8be08fd0c28af4311095b972d3e0392cef85db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3aea1c94660c13c2dc6f6242d0e6f135698d10e69983f44d4ec7ca44a17f46b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d84f75ee32499616ae87c29cd67c00ef3835a22e05708a44c11d2b5a5c516fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf726eeaffed3ee50fe063c4d0315b1bf6309f31a28092f0cc2b4f3195f60288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5bf6429d652cd4819868c0f78d3ed85036fdea21cff35b1a1e0f56880663c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd3cb5b8315fea54eaa6b8d3e4fd783a6912f418739c23dfd4da27cc2f30ce8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f9ced75535b2a5a4103b1d3caa0db0f8be7e95b529689d2579a067cd631659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee242e76e19e27fddcfb80265701f6b55b53ba3506412ebe264490f3981c224(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a678a87a916e9cd6868b057576627d12033c1cc8d9701ffc67a9cba62ee3c932(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__638d1b8faba0765f7fd3fb3a4c0e59f28a16357fd7a5c92d0ec3c9946180ee90(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ac8b0e921f97e2a76f88443cef64ebd1df69b8ee6459e20b51d33accc3509f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b489b435123c3b2a09bd3574154fb2fa09707d086eb46db9b2f6f4f9d36753(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc9d47fca4463f9b69c10548ff68bc1ee552ba4db3fc359c704d4326a601df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77f035c066f867ac0d975888152aeafecc84af26266feb786df78dec49b4c01(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eeb4d0d213f5fb02cf91aad9ea2440c71fa939dc719eda392616ddaf480ee54(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00185236f7f31125f8660265e5c723461492033e7c8be0162ab6b0be8804d386(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623fb407805ddc3ab497d1b9ec58a008808af3494a7d2501b351ceb9828bfc73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c046ef197ca7c5308805450f7a16febc0780670718d07802de0ed4e117dc0a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419650320df02b4c95bc3f219c3a904c7f5163067f8c3fa29ca0697a0944a661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6045a69b3371d12d0b6ca682883d14f602089315b3436165074c5ca8b1f3ca04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f783d442d8bd13612d3ca4a8695fe82bfd33471936480c3f7cee511c702797(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8555279371fb307a1a3572547f92451c14f0c628a07260ce68a8986e7f000dec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b6bf5dcc499fecca7d8b3e78275c857da3d8ed064455ad2e23a155a28ace5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0fb8e28ff9a1a3f1be70bbab71afa62588e171aff308787e6656d0aac0a43d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1314a9d123b4b43e877f0bb34b37112a200078c6254786473344ca22811d01(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60fbb480ee9cf71b99f0ead5e31f65025b0e85e8c31b7493a835ee15cf57753(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e597114fedb1bad288bc94036feaa6c286684739fbf9e82a0bedb938f8d279(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db46ec4b7f9a3be2595107256a042e8597bece7ba8eb2a5218fa548b77dc2050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee1424604ba299812024f299e7dd7476a4699246c26326ab74679ea99e0b7f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e56d5781966a553ee99e80f0cd1b153cd5dee1130e7ae5e640ebf972efc46be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2bd8c19c20ccdfdf036f341f8a5e9fb9253b9faedd1f65d96e448f8d4b9ea3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecbf9cc24d9b75a0e130e87b8b12fc17916c9a0dd157dbbc1b9895feecc5c63c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36cdf59c3d8ec71f914eb96e634ca9ccbaec5e5832f8e390d766934fc8c672d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7c9cb6161f50017685a1fba7fe998b34fd0e834516b3e843d58d4afcec8e16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969a539e426f3ce4653b80f5bd02f853eef89e495a9fec33634fc9b0b24646b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb80db50b420c1274cfc90154aaf735472f3a856ad116effff12c8539e06049d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2fd428d07706dd7583485218d7f183b38d15d006641698e0d59aa8d94d1646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704aaca82c43e77f710fe24e9343f3c6621dc79d7199e286042b654e08744031(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45299275fa3c6ef8a8b62097059b2177a46372195d8044c5435e822a1da1807(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ce09174e3415e3ec38c6d3bfcd5045e0142e90fde311bb11dceb987b6d61e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d208099cdd20e828ce52277d09a91196e446361674c9fffb45e915d2c3d03e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16cbaf78d358f43d530fb70a886335907532a2161504c79dc020198d5816a746(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4df12227dda09b9113cee6c4486dad532f6d9e835d670d613df69cfbb45587b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__752f5b3348fbb0267867ad62dc9d37d8535f9f1115a2b80788c9f714429a8a2a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b535fb2df4a25029efe93e965605d4f6280ec2dbd6d1923274ebb711c4044d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9854962b9f11c4dfa9606f731fcbcdbd61f16e354dd050f74909021ff3375c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f94dda35232e7c7e6caa3b9d8d3a48bb4a3652b19170116e7d638633c8bd063(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e4cb8395ebf050d01084c968497314a66b7824c76c24dcc780ec9c524bd5af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075295b55cff3bed9d8c669b8d4031f0a306d0c9100dd0c52f07dc33f750d70a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e6066d75dab64b2f6f19ca382d51ce139771f48383103e156a36a6a4ed16d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46a61361828b56b032105f88be1c26dad3e11c979ee2d7a083af3558939b6a35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc14aca690553f7322defc62144fe2592cdf81467c613909f0ea4f7082099334(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e59e7e57dc20c17a37108981b07314af9196d1390cec4fcc11652d3d03a8126(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb3c72448ac9f646048c50753a47b66769463c88f3698703321ed812551c4a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9371dd8bcaa66840d63a23facc090c6c40b94724a9f6774f080e12ba5e8f9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba36b5909cb5cb32c49794a36bf4bf8fbf7481961e71ec2a2d7efd5e7d32afbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c5ee40dd9f9d02f45ab1969090dc7d1f9a8e6058b17e3e05213b9f41ddac7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c457dfebd978d25d60f9627d91e521dc18408f64629a1f40611142ed1b7cc52(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c737d8a6b9f27ce6cc06009ee6381d584832797c3401112cc182471d626433(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd097ca807c785d2135268de29db4ef8f93653ac8e3dd9ade376b3938656a4f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a8af865fbc31a527f6dca35c0c104a0e2428f7fd900a827a560a6231fcda43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc15541bb3f2d3454bdf151085eefaf60451fa4d9f382baf8a147b2955670078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfbfe336838b7feb7323cdff89fdf54c8654da8120f3d6585b815fa5664e606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7ae701fb2a37f6117c73933c5c55182744a230af530c0360195d77ffc0b19e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc1a4124c073b4ec125e4042e425af7a075a027a6168e32663fa39018c1d078(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a1f98b3f109d218519ce91e8ffe206158b5667bb1e2133c62c4757cded304b(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2558b39561f88cb553836d28853f36507d0fa633f7b68b4dcb2eebb0fc6594b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3339b50fda44e49c1f2030754c36f2e7f9643b5b400040939e4e1f4b62e7a577(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178a19df537200a6d7fbb5fe05e0a801b1e51ca479bb410d477e68d8e4cbc02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb30e37707f3f8600cc1d50fc05994f2c2b2d0aa5c42b75b10999fd668416f3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584462ef6e505de31d6b71fc060eefdbc933100b32744502581542013673588d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0d5f66ea0915fa7d9c5a8c23f33031195f3d07d3fa2a0cdbd079171a34aa02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ebab6da4d8613cae8701db38f496fd2cb734c0c03347178e9dc2ec42ddaafc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677afb9e73f07fef409f0aa04ae73ceea130c735acac7141d9d0e6ae4dd0b23e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbccd1804addff3e3c9474ac80fdaa19ae30117b1444565f9a410d73ba3ece1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d821f09374886e132694105945a3a24c756364cb71179533d705f60131da19d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92509e51988173248c75b229535ac7e30f62a7894b6333b5e50092ad80fb51c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89f21959f20b53712f118f5b751cebb3beb8aa81133d30f8ffafc419188e10c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf172805a99b6f5bca1c0825c9439bb7880bd9b3a54fe01c9a71a87225ecdf5(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4240e33920297708e44097bf7b90e9418a1109ded93849e4a33bb73dcf24635(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb05376652bfba01f018fb5f6cb0f80eab6fd58ce0e4141e6dd33ae5906c2f4a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be284246116d32337b24762bbc8ed6767903d40d2f9e1c5271fe3bd8e6a4d0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171edf5454e2c27f63b39d253bc3e1d4e53848aa675a154cae575a4609e5198f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed73d9a698aee7f4976383a518c3f5a7f5eea0d1864c5f7c9733d16d72769db1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eddfe48d706b8939901ecb165cf868bcc9494f8325801d47d98875162468880d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4dc8fa5a17a3ccb0fe440a8d2cb440e18652e9395172c7dbdf42c51ea08978a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae7132e7639c17cfbf50db9ff11a6ee271798efbdc422fd8c78c8ea09be120e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e02c931c30482b1f8e5c53f9eeedb78e8eefd13cfc989e262095d69bc7ba48b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d97ece390a0aec9a2a7e91587be711a4cec2a6f1c44c86e16fa34d50f32e723(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3211281db7c2f698ff60416fec5f3001920599822a3b2f2f488498826a0bf6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced1f1efc1a9337d2e01596c02e223af55f7c981ffce38ff12b5b286a6694adf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38a5e6eac14fbbe57239e7b757918fc90a597194b1a4c9112a4e7d9d67fcf2e5(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc5b4cd0056d9b1c9b5276588d964e0cd5d6ce4a32669ed3ce6e312a88272f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746333a26550ecd876777bd5b0658ad09cc3174bbdb6244522460dacd3b346b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926420af5ca86a0055b3815e60db676f9848222ec4e5ce34866dce456ae3b08a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9010eeb77aa8a1f379f085068bb1dec5ad0a1a6a8f32e23fd2f3499dfd2fd4c8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4564e994cbabcc20c278ecbf588f4f415139cde0446d2266432a4c002c9c6597(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075ec9fe08527448c543f58b2acaec4825897a4d340728577a6e5a28d7e3230b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca0b4f82c37b2ed0f410660bb5bd5121ad8e556bf2ea2d6584573bb1fa77ab0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c89a804ee3bc696bc43d6a295931b076de64440ce40c98e16b6f151189581f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc78996e9c114266736940a46c3d52c86991c0863002998e07d8db05ffe8186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4773b96004f559bdea82ae825fc5244ac4e69f48e7f932be5b796ade5f4acec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192c014e50d04d841a5d864f08113ecde6be4a5f28803c2460a17d6226e8097f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9057a6ace1e97f46348bbcf367cb8a1f78e9b9888974f0c7c0321b15f49855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70ba1b1c1a56d80c14ad1e59b4a1feecfe0fd8bc19b009a6f130d8c91458425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050884423399debd8390094a8599c3076c376917fe1b52f2f2125c5170d2c0cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1f546629545a8825ee8f377380b5fdde662d677352f3a358ab72e512863a61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a773caf89457d82cf7d00b7e77bc05d0127e317227d5b21e9b930ba119135fad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d65a022cef27834003373658bfdbfd9ea21317826729c7123ba7863cddb4ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261f87b679028c4c48f6c4071af99b44a593c8c7ca39c756aad999aee84dba18(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9a9b5504a7b6891c3ab5e85e7fc15f6f01c60230e5ff233dac14d41b70a4d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f633253cc0b8cbcfc707ddb08e5eefa06b5bdb1096744a3567146db33bdaa3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c829e446e3d9889efc29e025945943c0420a0c68d818dbb11c03d2326031a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cecf799279fea3e5fc4a44e29f49e08bc1d7a222516a254c8c6c552ba595a25d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742f0151bb21892a108b6612c16ff154bbd2ff6782e1e43f9dfeb1f82a0c7674(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e65708ea253dd380eb810ece28d322ea5f9a83de711002ac62fb07192b238fe(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a79f8d4157ee0767846847ee9b9ff768d47bb4f30285709ad0d6c36f8f0a7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dcf0754db5c83d3f3b1c8fb47462beca4202c417a7a78213f0d4c4e28e76b1f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5781daf3eae67e84d26576db13e24d5152b18021b6d928364a78220ea606a648(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857200427bc0ce950d3985eefaa4f9e14dab4eca0bd249b4be795e54fea9a7a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1e0a2dfae2c3d0b292bcac338be924af4ed9414f63a79fdf36fb63b87c6884(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a09cdd3e7204cfe2b204cbb202c6fcedb6148cb0379acccd8be3f7d66c0d9c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075ec15c5bd4fd8689740cd5052d40dcd06f8c974acacd846f2daff9dd1f8b46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0909556f0df0ceac4ff4c42f67b3ae64252b8b4390151ba6335679ffbce4f7d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64713a727f3cb2e634479a5766eb103795077efb86ec371a93aca94e565f22a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3369e649100b226e91c15343f9c479a5f88790a661a864b08a2e8441faa00cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f73508b8286e0f630b39a662a0043da92c010eebd8ccd4a1053c98ab6a8e31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf3399ea1371d4839acbcb8d15b76fd207ffb664de663b0c5140159b3d7b71c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34523311a1e2d6357223e45c1e11155573882a75c6b5d91f5f350493bbf740b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54fb9daf5e1feb24f53c4c578b1a96d03bc9f17c9f080d57868c29155959058f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c93044df46424f0204f00a341311dd9e343c55074694137287644811ad876f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d8cb23ec07909b46cf2922d57a3515df72a13b1c57b69e29e5334aa605d78e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb4a065183719209f64fcad19803d82a4fe58b8347208e8de5f66d5953d2cbe(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2659ef4dc1ef246b9aba44bc3fcf6aea831f1bd73489e82f13a9d3466f5aab13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e81bbfcbba888a18a5c8d85e4df225fd1a140b39b5b12b8ce76b1fb2f5c04482(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28e92c7aeff226858d847e779def3f3039d1833ffe523bfbb5982eb98cd7f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217c4d6804a602cb89580bc904fb4b230e2db7a3e19f33d1943ff6f64c82209b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35fc0fbafcccd8dafc28319c1b41b94061bdfbbcd56f3badf7bcf8fe9ba585b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346022acad8629fd6a37f4687987de83d0ff8b9d0433680ab262d1eb5058ddca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fe6aa6711866bd68cdf8b13fd1260a5c602c8710d3a17d463f554616998325(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa15469089426aaada8e74bc26bf2f6b095792e8fbfd5a1843be49b2d6dd8fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb29f6a133f876d42366a4d1e1cdb1fb2d5ff7cbaeae9d57a573b02ae62ce37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456f0ff9c375e252203460595df214980557603d7ba1a5300fb84bec62cfaae4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdb2ac6d00c0ce93d3844423062146f8a36741dc5407fe322d398d7d7bfdc6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__943d3b1d96e59dcd13109023e0b83d2ef36b261118351f7ec4bc189686cfa13b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa0ef04270c1aec2edc6b6ba507045bbfa19c0ff11d18a0b6a872cf40b062c31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd7d61f268d1158ad28a5993ab20082160f9eb89d2d01953011b3da111fb617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2757a794bc580d13668add5d1d0d6334225cbbe7caba67a220ccef1ee7f8d99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76814dc2b53effde786ab8467180d737a10cc863ca000a82e094600f3318da2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a8a78e4b2f48efe3fd1e0903434a77273e2a1596c4f84c91d45bcf4b461059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52629ea4ca8934afbe354ece7c78c218b7154f9604920824f4d256d4edfdd01d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00ffd029f1c126fa28d009f22cb0de33e9ef53e8f0f3bff9fd119f11349a457(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d06ba416966f522a3a049f55d17840c0389f649325f4adac7df8e858910a04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8257d7cafb912782382be5625714e88009416ebda923ea07b588c84efff090(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3252d8d3513703da780084456839cd1161efeb7af39615dad9bfdbbc57525e4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cf6fcff69e5bc66fb4370b7d97b4d0286185740daca6f40f0336e129f93150(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b076529c98cbfb7be7964c202eed79a2fb54abebf5c67d6d12a098fc9e82f0e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef62f936c6793e222b5db4eb2857a3d90cd03397d05fcd8c676654fc41c9ef1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2f4707bb4260de906cc70132afa65a3e449cdd683fa28f3b8c41252c8b58f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e519aa0a11c05a5bef22f9f7457e9093d0c6e405c7d29a0006393ad70bdaaa4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b6bd0f9a4faeeddbba7fa896ab1577a0045c775694f3cb464c369933b7195e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90950257f175766c2c7f2faf0b87dbb91b13c52e6d358c23502720a568702e7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb96f4119b029f2d344397e378f18685fbe15968fc0a4b4346c665953c3ea85(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abcf04495d9c52bf4e092bdcd204f0f61bdf975f88b3a1f72e734a192a634057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d080c3ba77e105531d33924ec0e1e575f88874546007baa8137137b34969d254(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80a894781ae9d1f81d30f9ce3438a8601099e35f977b185acf4b472e9448232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c9e7681c351e204ee0b71b7fdc37dace62b3976153141bdb71b0cae0013624(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d76cf0c80a204ee3305011599063c1dc4a066f5adf1416c822cf762f322dd8be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ababd67634cd3f75e31c9e7b730912996ef65b014ca907de6910d62ed6201e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1878c2ceecb002264c1c424a58441e73d4eec19b9d4455395b3b73e0a50a5102(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9964a2f1905f07994b5daa0339cb5dddac3e5415acd386920b898f1528203aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb95b5c4c18b0f2f0f35212ce83d4f5b9b3f3d01c9d660ef77272a7559a05a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91a65e217194d6d12915061f20bfc78f94d50272190b8439a946d96c3421c74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81519f45650e62cb89854959f580b39674417b8d66afd9b2a9299f9a48661e25(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67594da5da6b46567b80882ff47ba12a27910c178cdbdd60d6893e969df5f956(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf7f22b3cee9e9c0bd9daf1db661b2c04a471dd1e4e3a940df299d24620f509(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24459d42a085b7f4523cb9c0c510e638e1b62f6f00c68aa2e91eb5b21f4b0a4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f311d5b80d740ec79f38f2ad9b7fec0bbc8d162d06657cd878d1208607980f4b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcdd541922afc5a3ae48adf69192e96dc710cb9db802f624c983cdbbbe5b927(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a7b2a3aa59a7f920e1283b3a514e6cbc533cc187dda13531e9f87b53fe1de1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed8fca68e3176c17fbee145539166bc4af731fa5256b54632c38fca78c1df44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98e27204a2a538ea25ec83cf581705b18acae8fe1496d41f4f11069fd1e9bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb7e57bd41a00690617b6e38d100a46702870ed388180abeecd8ff87c4b8934(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313a77b09d9a58591b0c1e0b8f2f905c44341b12abeef882dd3d7fd8ca43fc09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617c7782509b4dda01f33eba37229e4f192e70c90a0172aafeea5faa9527031a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e626455b405ae3d5d60cdac38b8cc92809ad9b2e928548ebe5cd35ef504939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8146bb5710a0e221b6e4c89927aad035c40a54ecbd979f473eee4f0e046c2c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd117a2635ed6258db7c94640f4378f4f016ba9de789454caa3ad0c1c0cd5cc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b685722485968dc19d16cc965bb4d912df0cec4b12f299b5e642ac05d743dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc8ee8a6d39cf6ff60d555399faccac92c6832924b23fb457b8f826ff8636f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee9361970eba2821e10d52bceb8a6adf6cb7f5b5ba0895aa66a3aacdd06caa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180dbe3eaa13136a9a1efb9b7e4536f72118d9a89416a11f2ca90830b7a61a5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81d3f3d07c311315b13eaf768527f383b1cb2aa1f92b2dee8e8bda19e930318(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7e8e8f6c816ac19d4655d97e3fbc281b1535217bc0bbf61d9fb45d19082888(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fca476420597e1a92a8610f375349874f7bb1560bdaaf970a0e4190f5f1293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__439dd6e8fa7fac2d333215ceff3e4091feada210b2a5b8bd8720d7de12bd8b94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfae40bd82cff3700bfecdf72f15b7da7a1fe62ce0b570395c91006f66b13af2(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c907829dda57d942d14d2ce7825434c5a11a792acddaee5af2c3d3f0c7daaad9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b7d51440b8df80206c2d1369dff17a462e3e6a9a9c139c4a7be4ab8a0d09d03(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bec73906aa7ba5941b785c0d7ecce534cc7277e488907135238b8d6f57e5fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70c3e100f95a004968f677d7da71c64ab9c573a2b8cdc45af1f5524134ccb88f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb60d1eaa6574384e81c259e14c2db6c1aedc1f819b2edb0e388442fb9eefc2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1f3b3f70b453b3c37b1490d9fe5365641de3e865a413258a96a39effaf5637(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e628a6ff4ba6ac19d332bd093feb2c59cf237fbbbe98a7308474d3a49b750da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53b06272f6ea9c9bdb576ff9639fc12a881792ebcc3e4992d618c47f4be7953d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2237e78bed385675593d6e846ad437528a4521db501d45eefae3a405458e811c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bc36fad29acba2229e0f7777d44451442937de29aa7898d4952572ef1e6f94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09718a2b6b636426850fdde9cd6ac9c822b09f3b618ca396362685b1f1a69b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef59f0d74af2011e0b918137e9933d4498853fe60dfd0c3f50cbc415436b404a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1535ecb9b3dcb044fd5052400c5e898d902b54f0a607ae251ad6822cdbf07f25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cddb8f6f36fd3bd34006ba539d56718fad388ffa8288f43a4fa307746833bb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2e71934299a71e8505da735b4f97d4c0b6930ef66b546d831096b262504627(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1de36fefff751292dfa067703a39493d854095347c8f262179acf7a30b46e98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ebc7cc427c9dbe587d528a7580897fa7d06e934ba1273026730bf4c99a28bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8859497362369099b77415adc83bcefdef78447b0b2e59c1883d07d6031f40bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e352fb3b5695126e1d7ed264856254016cf95299cef98d39496d7f0bd71ae73d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9b8fdc9338725aab1ac114e8d86b83355eebebd0426afbd2cbb2d13f0ffc93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230ae556250b4f7c13162a2b5f0c57d51ec1fbd09adfe24c7c46c91bd376da9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fbf8fb6ff7cc30d2cddb75f181aa4ed8617bfbb99431d0e73da562a6ceb0563(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6000e1c439d1364df0e28be9577d888b2d37ab3138a825f9cb76dc443ad4f05d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4208301eaf681d07c2b8c46e805fbd2d9d60b9c51e15eb3e5df6cc20ff3bf2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbddf12513e396cdbdb5e680d2d117c819a41269d1f4726daf15ca0d72307dd7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a519db81cc287d33edd0d7bd62603169e90f8694512249066e34f2885071522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995769308c936b6f309b8188fa66435b694084aad420e9bd5744478ad7d194dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7f91eba40833352d235e59d708b7313a2b129c163fd597b8cc50bcaa31b95e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0f48bb8c8dc8debf3cf431da3bd4a9af9caa024cd67f571ecb1d070db5838c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e010423fc93a416e203235a16d16d5f61d4fa8196ef7cd811e771ad42b2c4d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e50d1fcd3b790ff4e3fb16ee845e19c05c5ebf555709216f459c9bb99a2a03(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a15b4fcfbc98d2d337172dbe235396957bd8ec2d22248c27bdd6bd2433e5977(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899755671ab39a327cb5bea06e619daf7f644dbe2295b34da450427bc4f46c8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af07c27dcdf5957159375538a9f43dc903aac9d7baccc27c1af46ebf62a12ec1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e0183d446ad6ede2a05f7799dad251c2b744ba3e4774cdfe06d09ede9245a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbbc8119a83b4330d28acfb622cad505c473fd1a61efd630fb0a867ceecebbc9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4038bc66875ad6c564d98f80c240cf1caf1e5cfae2b5f4f73296c12a3504a607(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540648693810cb0bb0535cc2bd5308e3fa385f80439ac70818e73660acb46a1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb4cc17e8d310b794d78b711f4d9efc1129d49c86e6c9aae52b13b26beec8aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff47bf01416dced8511d2ae78e3588afc88080115f5a84aacb548d507594415d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0233f5463239d853e82e6a9157f6053ff0488a4e1cc6c0d421df5439e6e86e6(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d0846e2fb401f1ecf1c7a7ab1641f389b91a25a0349e15f855c1186a42eeb2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93acfec64743efd63f95875b4cf388bce48855d1c2f0cd005796fc286a7689ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210d8eabb2435686dc24a783156dee200613298d2edbe1158aaec466c9c1deec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9455e456acb8fb02c29cd9e939a1e16eacc42f138a28804a508f7d80a73130e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48f0043c9930aac68da2aefb9dd07e8021fa2868fbd707070a71ca0fa3207a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217ffb38882618b845ed92edc378d09185a6b18db153f90c94aa461d9ed8549b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3fc65145d35dce68752358864b2e854544d38077c2b0b595cbaaa1adfc0331(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c829329e850818b33e4948a41c70f640913dbaf5a796fd944629fda015eb4c57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efddcf16d53fb050f4afdae04f4e3fd46ea9f05498440364802c004e116e209b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269a138ea540153c7b2e3c2be67ef36dde8e2e2f68ea34496f9b02b0b22b6109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2501e030261e1f32fc3abf68db9ac2d7d80fbc1db64c5bdf29529750726a2c96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab326929203d934f71b70641e8287b574b25df6f2901ba3ec63c9dd4ca88e8db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efd71023d9118cc4e650cfeb820549e2cbd2ef6cde8a180d135cbc563bd1779(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1468c6ab8a96de834760bcd9133ba72b459eea9542154565f7ebd100f325a6fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5c2631ac11066009761fc78d4e10997ed198becbbd0326cde20269dbfe7c29(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99897eaafa03f70884b53f1724a34c64938955995052022b23fb4853f94e7dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fd99889c34fff60cb8789c8c75cae8767c7f7120a4d7e4aec649356ce830cc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1948b227e46e42e6c4e879ace75c9c1d7d592130a60616e4b56db980fb1db1e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff99c7e442862c35d92c5f1b5b498b2a993f232da87be6dfa85021ba2e30d5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01f9b33b033f4cd738bc62665f77b9ac0e7fa0f15ae1bb881f1e68cf27377a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0a17c72b03747ab6e8371cee4a68c8d334de85e3630f69ae2598b2afb41992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f744e95fb01aeb9f513596051758c9125b884f5e079538f9cb002a9d74f53da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40a285ff2e90c48d47b87b1bb324d1fae63c791dedb2bd01460e44d07c8e25a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61703e8a51086a67a3868ae659d799b0c02a5da6a806142c3ff0cb8129d3ab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdfece371d5682209f3ea6eb3d5b088653c84936ed1f3824cbb19ae001d868b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74818c2ec1adfc899ee587fafcdc58f1618b7813ee9922dbea1d4402af1828a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b109deb56efbd0fffe5c012ddc05f4d09c9632ad7f0799bc7400e425047b20b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90bbaa8fd0054abeb855a431f1e6bf4cd6e54ac6a991cb2498f3be3bab8dbd1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15926fa5b0186f86d02ec67511e1cca99898fa31c546604b841eb567fa6c0e4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d133764651a3a394957dde27b3ef2b91e241c88769075355687342a19ba8d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bbb352dd06466e8176f5c494bca75c2017ac856a8ac824d1969a16c90056d98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53eb05e339c71f475d8ccbfef6e72930af3c45bc4495d2d7a58a8d0bc123a83b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346ed1117915143e981feb2aeb0584cfe09446917e2feef5c35d77465ce19a7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edbd8395d6de03433187477ba6ef76f40f73cd1785024de1c55bd21f7193d559(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b38fb7b7302a32cc71c7a8d4ddffed62fa2e78180dc2d08f8db10d1d9df72e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae5b1dc5bb79eb9a9c8434c618d288e8bda5b1bdbc7080e6c36590e2dd3037ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dee026189ffd5057667fe16273d9615fcfc4c44f1cecf7ccc8c74681b3b4826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ad060bfcd58ecd2c4c4985d5e718a5f3c044061cc270345fd9e965c8b3b799(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef223b4ecc7d6508ff7bfb3c870ce3d2da57d3d75ad890c5f1a73e5ef7d96ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491182818768268f8c9655dd3f444261079ccfe5ee7f0a1205d6dead16fdf7ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8677b95aa693d5bfafaae537ce755e39f20d2d8febb20f4392cbcadd22a1c297(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498c36308333f7d2f26e3f78325fe1f8ffab1623272960fd30543b5d6cdfaacd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56af37c313fc5b1a4bab71d400babe328bad8d16c5ebef33f14224edabf6d58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8fa5bee160256c31cd59ade40c98332297db1d35a3854d30257b01c0609d902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b11747209e7d7149e27b5b4a37159538057c56655ae15029b03b591b9361a31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2af1f2b23d4bbb01f5c051b2b1a33d7ee603bbcb9a1cc395cd75e395163995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d149e26d6d4c281b73824efab732de8fee795ef372924a7918883589e8aa62d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a17a4b5d501bce4d19a4404b2f40a72a3aea1a4bead18cb5c1c346d7b70faf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e6c4458baff37025fd75f83297d20685ec23cde2c8a11c4332358bd773bd77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c409cf8764c628a1195820d9a083d8e3a206ed4134027314a4edeff27e7d46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86983999f8cd2b973d363b69dade14936b2fb427eef234a5a9d24bb2e5b8b56c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f25ea7678e9fbd035cb29ed5bdeb89b73c602006ade62a5508321cff405978c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d79384589510968ab6def4bd036686ff9693dbc39557d6ed0e51e97243ff1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d17cde3996a36da8572bf35a6069ae0a29d4ddaf60b405261b6a18527b4dfef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09eb55823ad75d61208cba4cfd576832603740ce79eb559ca964c2de5a4c134(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11a36f8eef306456b842ddf0fb2500c19b9599f653bfabb50d81869825cc38c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4efe2d2abc2a65e64b79f32d203f00a556a575955c4bb8ae5aed4392ef59188(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f3d0537893130ff3e8567864000a85907d83410c574a1ee7b024faa65da056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cfa7815380042dcf6d3493e7b7e9275147f6f4a58f3f158dbe1a13ad14c772c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769bdbcb930460f44086c0351bcf4daa82a825a955280c9200a03a76390fc9f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7769e228280ba7302a008b74af1e19e3ffe9f6ded11a364517691c367a04ac(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c6f09225491cef0a195785c1f7c232f60fca270d3a236b0f1ba8cf94a30232(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f92d65af53549f995dd5daa60250c2ab516c07831c559bfa4da80a8fc239f2a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0bddd294f4f8dc21e1aca3c3b15de3eedf9c64c0508c8d0ed5303e837f9f89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19309facc6e56fe1470b7658867955dd5c894efbacb752bc8d3b082c22a01b4b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2dfdc5d7cae9d65c388c6823323b2fb7376a9d8d75c0b5f6a8bc73505809d9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77e05ee791a286df57c6b6cb853eb61057f78b633c08aded482c4d47a2cf635(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203796d0b23f955fff6ec6c1a8801e4e58d72a4f78f4a7e80468930723650148(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffef547ae19d1513df7bc934d88aa74644a08ba0b6fd1fd609d74561e25f07cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc2829bb52908f98c463304b5a35dd2fbecb4cc6a92b8fcbc7a9b1437b6e402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03178d174ba2513400348c3d059aff8920ae8359d8601604c5ce830fb8edfb3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84869ec5a2cdf3aa895ad99de68b1a6f0317a4898a29fc42d7b20dca9182b9df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5fc6ec4e50ff64fc50c398dc184b656d57f5c9871df0ac38d90555e750c6317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d0ee7a06ba586acb85e043b79b0996cd8bbfbd20743c2e5ca01186eecba2ad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f2eef715d920579a5abefb471c5a2809b138d064aa4df3730ca3381dda76552(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b648c5d8a05d83321097a4f62d92a8f8079cacb109be10fa74353ee6004d68d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8fd022734bd1941752a9d559c71cc9ae9ee29de3a57df1db52049720f9e7dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7f989ea08437b918c196bf04f1f346ad85574b0bb8ab577fa66228dfab752b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58fbaf1b559579515465e9b5ad26557125ac7e14ad493d8f98fa9ba3c4cb4ec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ab5aa5f9367b840da18615695bbb6fc4fd948a3f758235a83e80d3fa22869f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d2c615078cf18b7668fe86e24ec51380bd76156813fac9dbfa6d1c40bb1ca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9238cd0eb5a12e3b2fab663355deec9b7acd71b0b2ddb7e6884c29597a72474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c94084a8797186597d4d1fd2fbe91bfbbbfb21542fd2fa77f709a2fe73a7b14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728da9820d59b1a9423a71d92dfa8fd2572d8c7a3fe89a501092b16a875a7efa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d3a3830fc4aba8c6dffa016d83dff81514d9db78fc8710237af47abf6edcdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2245c9c971b2dc62201a22caf40e6c0484e441358ccb46a28a1049369f63b896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6ff2d22b6edea02311e902e1afe78b3c0c75423282fca6dd80173a4d2a6513(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f59ecb4933fe1f0f6a3f0ce143f5b74ccf3c148254bfe032c767687581f4f1d(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6a82a1ecdf09f3f56238be5a71a687e6966170f0797cfffdd717841e42013d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961a252b764d63b44619c243eeb8d595325d58fae0fb7df68bb9fa2eb205ac48(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536750b7b99b65e6e22d4c3141ec319b976a0806d46e6e65dbd50255c602d11f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd567beae22bd9eabb563fca288b5be790a45713182ea0a3ccaad5c12d8a2f9b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af06307618c29c30e2a3c62cb695e33663e7401162f7785efb457130640bafd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b361289f12265d0f30754f014372add24357390177c55288a44e1837ec9bc4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d050689924b6668e18e87a042e9a0fd28fa247d9711a50b771554c56ebfd12(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193f9fc53b3ea7433532b5b2a235bbe37aa727edae016123a85657f3b25a0389(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd1de686743c05e76fcc8b22f2dd76e9b24c8d2bb304d500ca10026908d81ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d53dca32f260d421dd4cae30918881bc911cacb09b579540b256658bcff1cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17cd3f0782d5096c65eb9c578f51c9f8d963915890150d7eaaefcff6aced5fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff142818c62dbf99befd92be15766eb381e8beeef62b2201828f88dc45f9b571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523cba84665b7fd1f7f407894645e4d64fe33b61a11fb561a7eb5a12f3d51e97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a3814899cf76c08a639270e752246f0c6856c21c3bdb48ad68ff6c24d21758(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181022063b1c8da07af9f66d7a06275a73e120236301435f66cf046ce4ebc72f(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656b6e74665dae0f3268c3655c4a273a263145b48958abd53c5fa1b63931e930(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c7573097d9a6c66ef0f3706ce1bfd1c733cbbca5414ff3be526a8a3bb572e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe50544f988b2941f541a2dff2044a18b02855af5522c126e49f5fec2284d0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1095989c027ef1d5585795bc0d644991b92fc36bf789cfc4f758169026e2343(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc62f9b1b1567f9eea992df5036ffa2c1de669161577dc748fefc37fd3e6c85(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089854f949932e866d48e945fe652978d84a63c41910ff16ff48620988e10f22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9994a3ba0417ac5b174b5e15c6f72c6f0b1fc558afd7b8450e5fd8c1704ebb36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ec0242e87f6adbfe53699b9c89b9a596741e573afe7d70de18b9c4f563393a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde0df3181f7574c1ba53c5b65c4b1f6c59da72f24f6079266e5e3aaf753429e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e523595775250990206a4624fd619c5cca3d3fbe87a022d8be89aa879c83ea86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba779d1d0ebea5738ba321b1e3e075963dd76c78fffb68ee09f9348294f1dfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde0716c09c97e2bb7d89d3c1c98484c8698e0c8069230bdf7088ae959fade71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e5f1dcfbb4277728e38272a0dfa38c3e05093bfab3cd43fa80ae1980decff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9851b2b17759bbab9f29bef1a7737780e2cdb7e7e70facc0e12fd2a35988bbc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dee1d6b8e5fc4b3cbf0e3594e2789d28c9fae8b2785bdf366a14f11866f9623(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2109b2900025b1590e1ef51e419b49f34f2a64cb43d65b641e62f0afc04d318b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72a81aab4c04d450a12d68f01e6a5aeeb4b51eb78561df7c00a395086a1a9a0(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431887b9cb904c3e98c9be3ea5c9673ac0eb1af04e7248d83abcffbd9ab2e31d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc1c3928b096edaaac6dc945bdc51972635653279ba927dd85e176745858dce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b557fc827c320129f033ea3a9b6769f0d7bd598a08156c90f58e15d9c5a49baf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1a741ff990812ff61ec7c03cccc7ae9db8c7d43bf0631695c2792e21ec4918(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554838a3445b2f9a3914063c486287f1eee714a829da52e81f2f8147a600e27e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3949154196933cca005b8fd32387286d594c27bdd1f75c54c50a26b989302b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6960319abfc9f183e98246525148146d9b79897bb1cbcf711f5315e9167d114c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec3f23955d6587824318f70bf232bec06e86fed8fbdea969d18f0ffa460cfef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c93e6297fce6b1fd482ea04bb884a5029a8d25b8cc81ca6a6d817aee4c41a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcb568926629c215081d193d98c07f64ab7e2cc07032304520983a64226316d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da70d729049678eac2626fb52f98d8561d009befe44b3d74fd4928f28c32c22(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19624c668424e60d88b39f084d12d2c33d679c83956067d2ce1b5c8f0ad63a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a0c64df81b24e86d4528ddfdde133d57e8581e38a5482f95c74bf9efd4a7de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4cc32b1138aaaa2df3fc24b36934cefe839042b3807a4909c540bdc7fde7ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bcd7e37620d2ca303fa98290476268db480e7bb553558d036e59ec9668e3b0e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa7c1711e496b1c54d8b8fbfad933fd873b7338fd4b5490c0a4d206379fc983e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55638951ac827be06d2b072918eaa66b5a5af50b9eb4a46b5d3532f1faa1e046(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3357a819a614842032ac2a0094a05de4178c97853bf8b59c4779634f7f945609(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe275783e9557b6e85d377408ba1d15f12c26b7dc3e4ae83d700dcc425d9006d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5532d5fd0d9cc3a0bfe92b77d38c30770c883fa36d2b8c11cfe5d846fefeceed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f1e53d8355468a5280d2b66a99522fcaa6f8438eafbcd0cb487eaf932c3f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9c2a157843f24edc5daa24116b7a9112871f91bd136abaf5443ac4064fe40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b282dd7b4557b3eb5fd43f15a273f28b4bfe826df25dd852bc0afc960eeedd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f954d17279eb5dcb9f9a1e7b0f2019bb31747c4a6802fca8ec3bb949e53b2e1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6a516ee7e129bf21e8c2a974a081d5d14b9fae3860aba3a6e7bc762b0fbb5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a851ddd29660f0f36b6cc8c7539069e84b02b1a4100e9059f9e9eb8e4fe11ba0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf403f6544d761a67bf76bbb550bc468a6a69ba39f3c66a49b059ac6a8d6a8e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__243a07dd8b357dc85462d3e9b390f045765d5b223154dce12a9bee212fcded5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fdbf3df9e3d98317405e1e5befb1a7a3d3813490aebbed2779b454609d5c63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096550e009871d3ce0e4592e3e2df4af8ffd1feee8202981ce3e51c9747b877f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3cbcc435990fc31d87b62a1f1d8d11c51e634925a00582077e236d3cb185d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67da8262c0e6d6d3a78beb720bf321ff2a88af249917ccfd975f9aa62fc39e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7fd2f8682cf53afc2eec6dbcf55c9fb013f65feda24f95d0eb15f199f36e9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9334804d65258adc3dea5f1dc50840142fad94d6819e203d3d86ce96cebdc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2cb9d65422fa980a7de0b3c4d91e1c3b6dfb52b21a49ade9f9eabeee32ffe91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ec4cb4b3e0e23cdd5243333dad53a3c39ad6f0281149c9bd4d3c5edcbda72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b68c41899d36104b0fc85255ab5d0bce99b18c8d011a42f97a63261369af882(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444a209bbbcb32cc886d28f34a21f2bd2b0a88744dd77860fa07ad88954de75e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0058bfa9476b562efb079618373715bd9144a44b4e7389f8ee8a437dbc133ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb882aa94ec15cad9450343da8a2f5c65744fbe6ee4279cfe45aff0a1df19c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69cc65dc3a72637835af8e69ba3393ed57509d765b0b2b520e48197f0c67f67e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4951ed8291bc936b7ec362aa6edbd92f7987af7a289ca7232fa86163375a4e37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5c75c320213e45e16b18d7817d034596845cf20a9966fb60d5f5898d18ed78(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9a4e0704e17e2c69522b2acf89b770f2a41866d3e4f683d93943b0564c3db6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6f9787251ecfa41b03ae100c854b733a9ff4688d5967bd107b3812cb59815d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf210898b98c3744b7f753ae187e35430209a8e31fe64169c0b71afffef2ac10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865c8f1d0a212fa2ac5bfa5746fdd0f6b142f213d4517797d069c8681343958c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5de072c305ab46b054ddc5e8f8a887217e2dec44c92dbbb258a9f06828a5fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8501575582f06bca9b67d6d1d45a24284033d2a958a75b8794bb9d276037d4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c7db7100894cc97ee55a5ceef983978efd56bd3c7e046ceda07ba47af45c4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f6e419699da1611c9b0869d71d0e83f09003fd734efd71a1e3463a5b836fda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b76a3de4026b9e19305545de3eedc97cc1bb13b91a2c62c6167c6fd5a818530(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdafda4774e386ba481b7595087f32b88e44e0c83b28b52cfa2f7e2092eb9be5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984a79d24cbf3c65ea1ef4f434ac78065664971e8bd2be228e0658ffde63709c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639cc56a19ccbc6617376b1d2e958092344805d60650e5b59a2fb744ebca22da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242b51e8445e5806c6bac2ad364bde79e76dfd357a03bac740c6fbf457fec266(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276507b1a3f3d6f8d57a271bac2e21a4403bcdd10cf49063ae41ab180500ec2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd1f2da27caa4f85e0f520895ae2ad11f8ea7f4495ac1e21194868eda7ad553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44c0a8e2599bcd95641039245fa6dac9257fef208d208252cdb69b8b1c8670d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dabe34b9a2488832eea3942253f4ed9e0365eb197c596a718236baf87781d37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a6bea1257db38688155c0bb5f8eeb9e3ffaaf5ac1b1cf13d19ed4ebf918cd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa7d5e4e4320f98f57516ed757f25062789abacc3808ca3954def6716fe930a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf497fc50b0b9c744d5996ded1188181cd58abddbda589a2c8192b8d64409b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a48f06839d23942cf514696efe03fb06725c15707d8babdf5860ab76c55164c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea804aa4e6191ecbdbfee88068bf39265b999692fd8b26f9c9294158002d363(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd8177d83ef0b81c8421dad7abd6f7e5d64ba63451e904f4f13410086ddbf99(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d19b303fa3965450c9efa5871a59df31e7558f4df7129184e98a431a1cc161(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfed3d7d1ec64e01a5aa3fbfff67aeb3a0703121c2fa7eb22b996dd65f7699d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23285de4da4607717a46d4be4c9e5bf1269aaff99bb108e945aa682b55ce0962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2b47078c44227b009822e23777687bc8c7e0e150cfa9da90ad5fcc13330e9d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073899d9f0f1a44911a0c5d680d1243c9949425f42f3edb08a5847ff918b57f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a75d5f6b0d3dd2845d94a5f34c14a6e5b2b695860adcda03ef35dc753e49a6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6f9e07797c54f7dad665bf69932d620fbb818bbe7eb81319b6f2da85b7e9e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbae0eed8c320108f4f37378097ba1b053459ed8dbd2d89709b8880f3b0a720(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e222eba8d0f0b51c1cae7b796f6b3e97cf204bf68ad9323465b02c71c30ccc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3281dd69bb11630bf2ae192d93f0376c789ab72eefe83e97aaffcac92eebb634(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e599cc3e1cd7fff5db45ff866cf394e619e740f7003befdd6f69d02ae2e205f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b5749456419e33c4f8e70f5856166f5dfe694d7a4e8fcb266492734bc57a4f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09171b3a0f928e409bdca388da3b6d1ae8b1d34289b16bd8ece0a0562c5b0bb(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__668b434aa40194bcdf0dca4d2f0b127be389f2c1e56c372a407016de51fad937(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1daa7bcc52dd6b81e3daab472fedbfc397cdd6ba0a652f8920e7ff118ba8db6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e2c36962ec0fe9d947c5b0a3a76a313457f002f210db7e1d648ea86f9d9d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13d093c2f272b1cdde27745c195374968650627eb2018d994af93c71ad1f2b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0468b9f48808c1d7202588976876a3357d8fc01bb83063c132bdc249c8df71b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55268848d99e4ac6bfcd7d7a113ea07c273833e0201ed8a180883f4e153687c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8988638ed1e15834a5aebcbd0465daf540ed68a224d2f2edb8f454bb32f1cba2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe057d9c8f28f88125d8408f177c98019df421877979736312bcf402242fcb6e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7107d82786c6fb220a9bcc941b6809eebb1a6897a1fae039e798dd3a6a27f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddd13081201203f770812448414b635335001ccc9747ca2448dc85a493c7772(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a838e62f018d8a4d6b14009f15624fb0a0a3e2e0f6dd5a87eaa947324b8f513(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e7254c0b6137fa4e3b8f4526ea5dfe54d351c1009e3c2159833aed4c170afe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54fe01390315fb13d07dac23d5392bbfba3d02c4ed70948959705938fcc34fd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc473efc9f4e7070e34998e11e96d7aabddda6a26eabfa3f8b638945098214b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf6905eb7aa671a096535791cb3fbd647c87b6cf78728d01048b6041eab7f99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87634ed882169a92f99d65412348b078f8f7232969a8a94d7d61b94ea73f4805(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddcdfb63b70935ef9247a0a9a58278e55bcd825aa974deb3cabb771d9abeddd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423a7da811f76ba0737e7ab6a790f0b7cefa0bc0b2476ea0e3ef3de2430c5f04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ecb24e76acc485a843035fc9d72675f0e062b056241f0e09b2c0936d288a80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450fd722ac6ddc99928181639ca319b813825162c6639af9a3c2da51adc7bee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ebaab1a420a9ceee5d309981651496cc6a06a0873f772b0c8dbfb0ea98630b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a514b085beea7be9077c0169c77616986d3bc08998968bbe2ad4e55257a0dcad(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da0b5bf56841fed3dc50e1b6e0fef62e06939a90e870a58951fd494a4a87a5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985e85a165991233f61e2e611ebd15f1b4f9cd74c2fb9ce93704ef85fb2cb491(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714202ad083ff56fd50b3d7c4e54582852d6ecc52ae7738c62b08ed86d94479b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19d31f47c54cca57f61a3497637552cf260795272e48bdca13930747f038701(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d92cf3a5c63159a4fe6dfeab856e32ee8be49de65169d30709a82a103376b8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed598eb146ed5c3b7b39bbd76bc93c90a3a383b592d71020b1815234780da3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb65e9b9c014adab680273d00abf178af1a0deefa746b2407864b3faaf4c9b7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1289a20d4d4d8c9b5405cc07fc9c0313e8e3fce04234e9aa33b755881c3b57b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5d6a490037c87c0f645bcb14d86db2a49c269ec5676dfd2657e01edbde1fd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415c72714b296b33b11bae7e9d587d69d32481730d647078d2455c3cf2e976ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d76ba8418368da4575faf0964882ab2b208363dc3c1ebe55e9b221597fcbb61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3f945ae71bca6d1d18b57d55298d2f7c77c2a541a2a851696cea50548012f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262cdbed844992343dad320a37de33d271af448b534efab7750dab820885e9c7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e8100bb8a29e8291e3b4742908c8260afbbaf7a974de3e612f49e6f8f405f51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccf2ec7182e7275949fc4ccc16589fcc3868fe8a90a148db5221a52749dffb5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45f8bd1bfd1c91bab90f9587e2e05a7f22c49ff277b85dd90293b7153962a7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ce3dce2e6596335e83050e819c262980e548ef99e982fd1ea2b489c380d737(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab202fc107186b71b4709315259e32881e6cb2ac30e6e658c127891136181ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5a13e5ff8d842183623165d2dde6073a6c8daea909f377630a1fde21604e1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf49f9696ca9ff3069f7cc01f565bdbca2870586aafaf333e24fde7dbb8b846b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8760c6aba778d1b2f478b475a460a5328376535a9977af1aead0818611c82b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3148d6c6b8a23aa3e62658d5ee78b2c18d7d077008112c6e488cc05f5a6e7189(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700a7df8a51b7094713c030f1dc64ce6cefe6d1492d0c17d12dd17df28f249e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff55729e1e9980f2b4a6f9185c4d27789cef7226ce42da2c99cd13b0561ff6d6(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174b3bb93c83f899f74496af71d9a8ed256909ec1e76e4b7efc837becea9f583(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a614360d8cd3d1ae0c41cc19312049edd67522cb4b78015a143a4df2d90422fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a38a9124ac2c12e85aae978a7c5935351360e6d62c703fa9447d6d1f4e9bbe48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d31c80179141331a5eb1a0ad2a71973f6283a06228bfa04dea95db3f27955f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1af09fd9c98a61a74441ff144fae2542cbb32f52630e24dfeb42177eb2646e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__681e19be0864321f24063aeb5f998a4b9a3694b339d560c9908565b0ed4b6f1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042f88c378ff3df144a3a64318915499637e00149415fce5f9c92ef4796dc5e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e0c6ffb42f0be114fcc8cd323ad2504d5d2970138d65072ead1812a0e401e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014f95ed4af622670f95f84d4ddeb88a6a3a3205339224de0cd745184f623659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98110f273734a2316cc0269af5d5591a215e607305ad703ffa4a14832122682(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0255c532a984dfc1d4bb7c73aad88c1377ce3569f40b3043e639a6a68f1cc0d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef1b275a2175a451623f909ef5072b2db6d92a6fcc573cb29cbf58dd6c035a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0269f201d36c013a4828f8b75d37c6b511fa196a351a42826239676b0c035ed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4bcc8d0af0f726555188d00795d471b9cf362239b16f152662670ca6fb1f34b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf9a81425ca3363d6abb819ee994f065ed4ed910d8fc00c6a0e5a0cf23a1299(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91d9a65979b768f21f14ead49b403654d67bebdbf72448de4de6718c0948c7a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b17c7b9268fe3e36f74436718381e9eb0a090ffd52426b6b339ac7c3f3345c4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b2bae73ba3a95bd9e2f6a86068d76a62793d3bae34dcce923120b6db080217(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b58648b8218989fd1ee72f1aff83777155c8af00c4fd6da6fe61a2b59728e92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080c13ac7f4840d0d5be5e44635c7651b7a48e8612c94523fa91fd5ead989938(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff0ec5810f3b7b5a50d63533533636426fed09435368f0677b4feb51ab7559d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1cdb5a5485948acf611adda7da4a2f93cae9bbc3508c3bb5c398f18d0992a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a125efcad3096548fa073ebdfd30d8bd71a5e47f3188f494dc961867da626e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6322af4023ebcbdef8d890b86c856f4d56ea47e13f38a338b6f5a7fefc8b16c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a2c1648fa323cbdb7f46d267acf133ae445f5f5111e21d4bd4da4047fc0e90(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c407856ec26800b1cebf46d70a3539320b4e3698009890f0e42515828da7faf0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1657679af153df11b591b9ac2b69a843b1ed0ca23659ecd95530c0f64c891269(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8420a974162869cc3d6cfa3c0a33fe7c0793cd5a1ae820a4d2a5a36481e164(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21b53904a80187e41a52d7756df789e7a56e4d57caaf53966ad024d341410a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea8cb63f0ad4377a312abe9bebfc5cbbd44f8d6d4631d3d0b0dc5aa30fdb20f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c6b624973f5dd96164fc9574335a1d528c8c4a1f0e201e351cbbab28ed90fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30341379dcb9465340e11057dd28df36110969ecea7cbec42010be862d2ed819(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd60dab1a31c4b3bc52bf83a7f173b3b6a7f6db2a55139178e052bdf3932dda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078cc4925242b0e6e4afc6e8978ab199896c3de1fde554a79ba9f98f478e5d69(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088d7e876974c1463736435928c8c515c6a2b0c92be3265e5f9aba7a07fdf31a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60559d0a2834d9c6f2d540111ccc1585876a52a2341b2558606f1fc21041bf42(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ba926fde7e4ab208b57dd9f7ff67f5f55c9908efe8d737a0f2374c0f756e6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd3a161c2f816a0118010d750ffcf5904471de7192a29c4accf383ac3613d82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff26c86a837fc4edea38f713a1cbf24bf72eb6a4d9a6613c93132489b818d7d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5560c224d22296100b308514cc94d78969d01a87f73f3747cdf0d161b902a413(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09706fcd948c66a6162718f1c4daaf0ce655ed76163426162d58f4a1e7598617(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e617a0bc794da84b0132b4a217f095c3672fe07a8203953819edc6b44326ac91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7268afb982fa6f89e0c653e8bbf340f3ac047b62b25ec051fbca0d097a6902a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c551ea04ebec37c5f525fdf7468d40783d17a68545625a5a585aaf6ec0ae05(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612acd9e79eec1aa1fe1039da7cc89c3a13f8020121ef5136d07ffe71a3af65b(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f839c3787d2d9aee9ea9c02dbac87427223b93a7314d80769128db3795c3feb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d193362c15d0808daa7de34193147e6f7403a0ba5ef072c04383691208b3475c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__febf5391983e2d9c9fa5d78292b9a7073073e9fb2689ed45f79bcb26c5a6ec3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eaef5bd1d443d02f81c1507e7d7f0766ccf2bd29bd6e7ec3148a7bd061afb92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4561dde7b8cccdaf0e18d22ce560d2388078a7a0fa489e57095d04ff2c33a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3fd006d0499722a7deb48975dfdc49e54ca7530643539c7e86e2ca6ecd8210(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844437ee405dc04df58a58b679efb36467f6abfb688eb6f3ca4af2f76cb8d8b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb464e69e3027ccae4e5a072cbc9b2f0a8cf74e4324c77e717877ecb6cbc1c3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d8b9939218949833c63679b705457460dbf9c032a331ca7c68471746d19090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6464044b6056d50a62ede7355d06e06a14a4ab9d22bdc6deba7fa9d37821ba37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eadfbd4492ee4d4c4ff5fede444e5937716c690f332e3c676e418cf5387705b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea334ed917c66a29312e81d8c5bfd4f7e9f371fb1b91885bdfaddd3cb710eba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec8bbfc1d8aee8c32cc0e90b2c730e5dbb216483575adc10491eb81f4baf3bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7528b7039ccf798c1068f9ecf73c944be603ad29226788aa82411a69bfebbd69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c045e04ba16226fe96c09e88072155c15125d8d54ea1f9e28df0398e13fa990a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901f8d75e2889a62ea0402b4fcc2e6e1cf299c0d512cf82383ac19e65695083f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef7741fd69f2f32ca436bf715c73b67b94df98a5e7bc39f33275c5195996387(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167e44cb2ae9d1b5a3eb6a5dd0c6d38531ff7de7d90e824cf06ac240595f1677(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4268d36f16cce9cbac250b39b344a1af22ecd586c4720e88c36a056cd9f60f5(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8431a20b4ead3c59f29fc63b528bf92e21864c3f4c7d9ce4531fbb51709ebdf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e7ac7e6543787294ac12c7bcee072b9e9c513a4ed3abe75f72cb38afc950b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e70e5e6eefd65f8933475c3f8092661099e80e28590d3b264e449dacea8ff35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fa8f7d3191eed0438eccfc53c259ec5e8d572d901221034287f44b8efefba4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce4b32f0dd504c6117e6029ae952bb2e17337c065cf18ccea6fd36294d51091(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c828e9d2ea68738613da4ff5acf0e54d6b198c6057263de3e73d37e05bba44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9a7042e929d070ba39483017c1d0761eb38157c7231f622817c394699fb19b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11184f7231ad109e6ef9d72973666089ae8519ee8efd04b0551205ee5118c60e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfecbee41807d945332ab4b10a3a3b9d1ea9275d0ffce23a650d0502e904caad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b7537dcbb28a05033a8c6831d7ad374858092c0edc756971589f495763c905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e17a84596f83c5378bb5dd9c106763fe0542810bc997fd67cb5f3bfb347154(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa13bdc8d3de35e6d397e62dc644312202d100d7e912ccd87a10c5a224659fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f97534a9cffcdace9608a5f9213710574d5887ac23d68e9504aaeef8f991477c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfdb9d56330ce9f31e015030143d615322b5faa88c89b8177c1ab5c625d406bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b428b96b5800e68fa13d2cabc6104d69139d8813fb4bc541faecba363ab638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e6fae35bd84a1ff18e03e4c13f37621538bca0100b091eab3093b82f778979(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea77cef62741a0e748ba6784a1a7bdb9c97d5f6b7424dcfd66af7b097f9bba1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bb77758cf47006d7127939b070e6f84a0843e13714bd690e59879104473987(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393ff69f77b9808a0516eb7644208593772d4c8c4dbe958b0b8723885ab53d5e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd4a29fd1c9c392cdbb40795ebc7a1c3e0cc8ce5a4301bca1bbfd4752c2b601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6301996a8bb8393fcc66b4e42be8fd5f9ec55fa3b8151d00bb7fbf242885239b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2224527fa5a1677479720f9eb7526a0670dceafa2a18334585ec4b64b9b6b21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccdd0fc97c5ec4ac8f6d611bf1ab8a3c21f2bd9566459a0100ff7cceb3f911e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfb1ccda68fd3c2c2f1a3e01c0d543fa5659af11d29428efba3960fdc2a6dd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2508809e899d550a6ab69318615609eedbb50243a8b6c43ecb3e4205ad29188a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f749868ee933427ed3276238d084408f86d34dc8953f707e3208a555ab6cef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e0b5c5036cd193f6d2a3e135c48fa9901ab45527a64de0b0be3d7b75058337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c7112b00710e655a55344af9aacb089230dff5e54cb65f14f38b2a6efb3aca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f77e30e496ff70e031b1cb0962846e00b9b7af1bfb01f6445343442595b2e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47dbdbe154056a0ff2f636d7b2558151dff2c80abbb91b52a32cb70cd6b6f945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23026570c9405a00abe17b4961fb53f8d5010074e7342486634fb0b6395a7341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f933542d17b815ae3e6bfc567bf448558510c14bee50dd9049ab1b46174c18a2(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77b076acfa964c08a165d6f997d0a3045b8bf56a295ea27309942393ab0e71a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0736ca9a073439a266c1393ffffe1e89ed11d8d156cdd218a7399acefb7f426c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb605042d816425785bb7c6555ba8fe55b71a845c2ce5ad7a3b1276df93e1c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161ff3763f615f43ae0765a6cfc594367597f30861cef9693dac616d94de9418(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22661dde0c08e0a9110712483d6c205cfe25b851b00bb7de8135a78cec022c8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47c6e8e8d645c34c57a7ad9c90b09c4ce0d34f16e3b7afb4577a0620fa18233(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fa2ea0eef072a0de3fb819cb4910d467abb663e8dc224f42691ecf3f73c3d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97660078cb0c6de5b0a2d6ec957da8f5afc3ac2c3d30be345a25a865a28ebe73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d9927e8655aa843164a57904aeae5dfb1e352023e1e50ba05525a2ecf30d3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cbc4fd599a8c4b1063f2262a02adbfa2801f3ec4c58bdb28f37d5aab303850d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aabfdd1aa16f7789c90e530a7af28dfa0272f2da9df5209f9e33fa8de2b050a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9246d833e6897b378842432d84d31cb33a2b95839e7a3aa0efa37bc806209f93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe3c6d3fb6a4d02833eb5630daab0e81e94f45a3143aa3952ce2232cba72302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af77e6b2c3097517641b641efa4d02dccda31d19e79c566fe4db9702b9a4219e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ce3ca326cc998892861bef01a2b784767e9b899528bc3e97b5bef61d355bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776baf1728a0740f63ac693ff4ae71868b66b142672fe30f6e03d7769df9c337(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__300a0b6a0c9b15515b75562c884b743052747dcd02ee9fe14b9ae0637ce374b7(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2455a35bf41cf6903aba8dec7ef18f4e71691c36b58fee292befaf3837ea292(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6798fe6227e96b97640b67d51422ab9c05abd0e543936bdc8da90146065860a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f90af089c57e90ccc852f2c8e77820cf47fe3243b7093fd36bfb6c52006fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de14afcafe0cb5ef0db655460cfd7ff75d9e8a801383908a9aa3d0eceae3785(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fa525ca37010789c680a94430bf184169a75bd73ad049cad423b1b205733de(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fb0420a274d354582624c5465efdd6abc045850e0f8c7380ef5ce70cf01d01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9276ea4b37683ba2cdb47281be4b5e97979c209d57600201e910d7288decf712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebe5d8bd719f0646f6e64490c04d27a56eeee58f9588350622fbff079d8096f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765d1fc45a25a376c280d2d24bfff06eadb5c4ad861fc6c03023e7b94493a67d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1547e2bbf993997ac443ea0ff6964b8dace1d61011ae20dc161a2ccd64da8be1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52b989ceb52ea00ed0edf0ec7433bcc9643441b699b05006618af18f7e43cd9(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ced69a7ed0b1b1b257c80644c33cc28ea698c5e64d26ef8e05062b02da0509e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecce2d298aff8be3162ae3ea044d060a1b9e4129f80c584a15d625ee123e37f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa247443fd76fc06dbb07b0c2fe6f3baf95856316601a233070aa1c035df973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4d1a520afe05191a27eac9f80090119a14ae8644a0e6cf3c856611995f0a38(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30335bfb00a181c3cde9ff099c963bfd769b3e24cc6f769311b18c8324d5a229(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00beab7e1806ca5669ef80ae2e0e0878a6e71c64045df02a8e3d2d1488f4ae9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703c8702787f3ca5b7937c0f2394210717fffc5ea44884a407739bfe77762cb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34307fb8197d5a0eeae105cb5097f8acbec22bbbaf643cd2708d9e23f31ab7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4b55492be21fc32dbc5dc6f309e3c9bf37e286d674a134f28b1cf3c07da469(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db14161e53ade6f2ecda8183a87664448a4bcb1effe9b3425b68e5688c4da8a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc56176b18f764a5651ddff9f7ca6a59e6ec2f016489f3fbd7bf366ef127610(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__951ddeca19a1b5a5e74b0133e2171168807de41bf0c4c1d477681f382c8f600c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c6efc8ce8f4c9a193331b3b9782bde35fccf0406f0de2f6b66568843d88b73(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145a110366c53b02d4d1e6f3132a643ba581a693a886242bfceeeb50206f7c10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3040986e3f977c3188b0ea2524ae6dbce8af09ce19db5cb9e5449787a8d9e2f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff83e84b04ef597be42801fb8f0101dc9268ef84868f1658eaef149306b431e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1e6db0f0b1cb9e99cff6b11b0d3db6f0ca5c71101b5eff4bd3a74fface0505(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ae9d031c80005d04cd5f8d0553e2a6fd3804023ffac02294059bd3a616547e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17aff4832f06454164995a1475ce5980e1634544a76c399a22aee21d80cc9227(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf39e29ebd2bf5b7a90e82d88081da903f67545e56af5f330627831404f3d97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f28b885b699d18d947dd00296267830a5a14cafad1d0c41f4bb13c0dff2531(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84ae3500a0283c9dc724ff04abac8502378f560984fcc7f0c59b7146c0610f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9be164cde162c6b16ce0c7fea36ae6b9775fc553b395d4f0f2de219581fc883(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23f16730ffa9579ba3072dd98db7c44491aad405172655dfa0b40b33504cde1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b163cc32209857bed7a785aa5263bde18a6238fe06124fe55f2755b0bbe7034(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d407c22fa81430e5f9bd0c7b84cb662fa3bb3bc8b1b79f1440bb342243d564e(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3976af3fbd6c456861be9f8db95232e956b5e243c86d5ca49c88296ad2303b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c181f24db32e2b9f1a131b047d3da7110b1ce32dc82f66fc7ac19be7adda4492(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5274930c3077e0e53c2c8b9f093019a64b945814a2c18545a291aceb6fa037b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a83135eb93750706bb9b2c6590a60aee927b5599fd1c977107cd3969a57087f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db6dd8079bbf0e7fda5c8802bd9a24bfb0d657ec95864006fd46bab3d1dcab81(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c6919eabd52dff7886ddedee1cff97ae5d3b7a824443551d48b179a9cc557e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77ca581a7f432baa81fc97f9de7b4f17353630e805825e1dfee147d52c1d3be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071ffae7f677bdaf162d50cd47046fecbbc45f1bc5bf2797737549003764c1e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ca696983c001416b71b5851814077b353d320c0d8e6732e5980c6dc44f38c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f39c79efe40fd23a9ae2d07ca811ce5fd14dcc0d507142a83fb0d4e9b9c59ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89bb6e041d4d9d69227966c367e1fd8a7fe5b983d14242b189bb77bc151c551c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55994da4ecbeedc9e9fe986b0f44988ef395d83444fe697918f75fd61dd9721a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30bcc9c9cfb6dd4394dabc01804ba2d8b25f38a31f06c319c0e7f86d2bf1396(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d9656449c1f3f820372ee96087b3cedf5b68d4b044d61b5c059960c6f11300(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa6dc06ca6782e7ccf8476c6fb4fee0d549a36829f6aee310aee4f61259190c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa46f9e3e021d36dba024c53f46429dfb1ff559e23f2730ef0259a377c43c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cfe3a95b3cbed4bcc3d0d4a926199466d97bdfa75a12efe95b690a1a156ed0b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3864d3c2ce56c22c59eb7d9c7f44328be963516f78b71c8d433db4f7ef000f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22be102443636b72129a1bef781c88f9b7d074550d81c0fd27d1138feac46c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02513e99d562fe87a3641fb5b1b6ed4efa1eecb1a03ffc7c0b31fb962701ec2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d188c1e913a05a9e29706409a3b27868599f299e3c943d9c984f9545ae287ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b14067d2e72d255125c99e8a7a2ff93efe43a7a9ae7e5e80f34fe79b9ac9b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed88195409ea4e4fb89610e3415a5eeacea151c5564620e4a95333eb5f1bf620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edcd419fc0be344abb0234dc43e2793f4cee3790a2ba64bcc522cdcd06ab4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c42f67d4d09bc8fe859339edebb46c6fc12b964bdc03db13f8f34d04c14672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a928177b149b9762247a1e7ed22804b79deafa5f314d8eba7b61335779d300(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a333b641a47755499085abd4a75e5ca3c606e103dc3431473a589285b5757e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc4f2587ea0fcd40a9db68f82297e3da715b968a66d74fa39c12adb4a1d1968(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49387d2a4f8d5e279d96967365f44063a8ff94ddbafe15428098261d9ab2e12(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c41ce725b13267d790bb2278b1422e0335caf7863a923f533fcb9c432adf39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d81bb1656afdd3ac056bd88bc03c960ab450b8e10d7821d0092360457dcc1a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3706ec548bd499e8dc9248faab1c4189ba24ab72a0bd23b2dbd55d5e7b04b28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380b4143209c518a68ad7f6b42b35eed5e2d8260b15a386dfefb5e096ec3dc97(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61b1fe4e2bb2b0dccabfdf211af2c481c0da4f130dd4619073f72af5f8dee96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f86de2d59ef2b87069e01d5c3536b54558977767035591b3eefb21b22dfa4ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93448f25f3b1b8816d1e777f3e600691d5e57ac79e0faaf4fc8473bb038570e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efedd937891437c6b2fe2ac4f56b86666c68b1402ba344676c9ab2e2ff0e0263(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff73aaf303aa2c7ab2d3e1d6efc2c31888ee8e902040d8f95ef651f0c0eb443(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60b647ea8e6670f370e800abfb91c1cb65b5da0ccde0e9684352dede2bba9ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ba57090b674ba86807130b63343d7e0eb0901e5cea44a2920de92cb8b809c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66aa11af1b862de1a40a9b84e7aeb1272499a034625d1622024325c0c598ad55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023ed9ab3be6c609fd2dcc0663f7e69d1e5f4049e3d4ce18ca551febfa525bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__693e22a7ad9cc8446eb525cc9a1ce8527002c3227816adeb597a7bed22e2895e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__668305729dfff406c8ca9c35359093e4dbe9a272179b505694a1357d884f768f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbdcbfca97003bc6fb6e99506d33b125a95b49828c9844882fcdf0a008440183(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf694a26f6ef8a78a344327c0b2916b5b69e3258b8bbb996ce15830a1f1fbaf(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17f076b0c7f659ede53a074550746490dc8d862522d7e7ff07386b3314e21e55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bbb4e3812584a7d16ecb8f9c9d41bc54555e900002bb514b266e18cffad828(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4939e63f29cbeebfdc28b567eac8dc5b3d093627cdf6a5b4a9b99c880b3af8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a3b4ec45d5c915d0277bbda831c6ec32f807f6f932118a1c75c87984ec9db9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfae74a74985a7f73efd2b07f81a76f7c10e5c52c913c54ab39b2d9a4b7383e4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5636d6b7235c30a949d1aafccfad697528ea656cee7801d53d833bf783079165(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c3bacb278a233a7512cbf2bfc716e1f59b0e0492accdae618eecff9009d8585(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69295d6de22fb94c4c99eb68d7cb9c6d3a458a64e17814ceb26fd5f57f08abbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb4efca518f094ba8841cd14e92e15e5c61de7aa8ee46e6c22edfdb578f1a51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d072b8a348160151ce038b8038871a608d1d0959dc86c46b59cb64b4e660643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898097fdc982f6e7e2368ed073efb4082bb080389516f97282ebea577b5c3764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d5ef940cbb1d2caca0bcf6891ea94efaeed8076a9001c813862dd0326d756c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850ae57cc459fb2f35d5428402b0bdfb5281b21937203c2c4a6b15468f2a8d0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8e3e1ebe3125c219ba7c9c8150cedf55f08bf1dfb383d5593484f713f39427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e01892ded3e51a9d6145d1ed67fd452b64bd9facd03a8c98c3c97ce7ee2bc90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346945973b8ecbcd8eb580fc41ece4dfabf5ca08d25e95ecc55026f76bad3afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2453fed01ef5ef86fca7dde0002cc74e305ea86fb0c1717954a2723c65ef39a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48da0d2dabe3ad64ac32e975788b227ed882894b124a80f2f7fd343c42e10bc4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f6e6dc216f823a69d17d3611278e1217210305f99f8e43bb518e971cd59656(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf293765666c503610e49b19c0a1660e6c82bbdb2d1e503a6c8cfb1fd8428bf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa0248f64fd1a565a10d7cf7d7b04fde588e8c9ea7322a3b4aceec110e816373(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d41afbec871187e5904d1c70395066566f2508c27829630ebedfdc001a87d41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f7faf8c0944efac3cb87ad7dc91bf0b7cd41e6b11a4c02b0011219953dd197(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5489baea6e7ea279449818c2f68802822751adf44fed95d61d2cb974a43b18b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08490db2003a9417ac2210e4936847e03ef90e880259c7dcfd7327aed98fd08d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a58a066a901cbf51125e083d050e1db9ad82a84b8a7b61fb42840919396774(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e7cdf84fda1ad51eebd75215cc68fc8dfc11b96b0315a0c4afc249408325cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893b1e9a40b600f0eb5fb97300cb837c7ecdf731ecf6ef830189f6dc8451b53b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3286c5cc7fe820f81049e37c72f596cef3da169a4c7d2bcd42514c7dc4aa08db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925615a5abb47968a1340ae602c73eb9e4460f44ac4c661793a056fedc1d9d60(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98775ba88f8803b81f9c01f3313dbd1d7bfca9af0b10476f3f23d307e903d66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580723b240232c7a3530819b5250f85b2fc8443470a4ecaea9462cb5f2f74e97(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186d7e658a66fa4c9270f597b3823bda2703449603f93affe6f0f7a5970a4a06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70386ca54b8ac38474f72cfb73d5acd8edd54200d092b1a218d8271f88e31a25(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acb6d91ef785fbaa0ef1d48a8ecd2c3964e26126ffcd463b35e5787d68c80fd2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68be6085a5154cf681e14872716b563b6e89a9d204c5b3f2effd240d8efcacf2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03bc7026bf64f3c1d0f28ed8b54939f017cd3f946c42d73791b32b0866fef50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5669f366ebf0a6dc6e357205aee57249bd460fbc829861acf289c252566a106b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e57a96881d211eaf1aeca90983d70c5cd98f1981c34d8f4c77943d880840388d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7baae02f4a0f250cdcb45715e3ef5f140b2b4ad769cd54e4e86d23a724d0df66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b579f88f76370f768724c26ddd5a8de7598198e9edba53903c6dc998909d179(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c281f5433d0eeeabb6760bf692494f38d5e9d55adde1219fdbd5cf5d6ed68c58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1451f67ffc836982beae9dce0cce3728749febb3a9d26a07ed113a753bcfa8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ccafa643350660dae5d04993fee708ef4e976493864d7262cfc00b0fda9fe6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13d97bf6261faa7bf9b1b059d5fb7e307274f77fa48c7922be562b63cfe99763(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777e4b0fc48959e840bbf0051bea49ce4e5bd09e53d322dcbc44718b7cbcb58a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c84a147c657e3519cdc57c4631e493b42026cd896f7db42d2b182d5e804cd9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe84a7d677f3dbb913294e949f36e5669a9ba727f9cff5ecd431f6969c92bfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af4e6b10ba2ca22cad8951f45bd9f243b7059d3405ef74a3cc7b85e27e7232f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edac82432125a54363a1e062bfcaeac8d300ed45b7b6127889143932688213de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313579a603fd473a13a964762770d48d9a462e3fd273bd2e2007a6d1ec9d58f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac2c7d4908d72ba5be62ca93b04870e8fd218070e332bb9f18501702aa852c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884aa47d8e7ee3f7347a08ba4dc85ea5973d3609a405a1f200900534a2b4b60b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3472d9f6935ca496481e7af432e86ca94d4b1c0f94f30d252d7eb511ccc411f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54e2c766abac9080a4324a508d81438eaa3a6e2c4b50f3e48f92210afbccd65b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df86b9ff2c3755a38d685ed7a258975df6126c37187e32d97070345498faafc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c68048e8cd42beaa2e897e542514eea53e3f22ffb2e7e29f05e15d38376862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0350b882d975279ffdf4b72c443783f6e5bb8ba3ec0b76c94745f431a323fb05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014270e51fe0b4d27a5bbd7c1e98dcd281a31014d7f493b204f867082f469f9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbb228b9ef49887bf1918420d3c132b9c033133a310b3f5e94308719f46ea498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80bb182b0428fe36a5fe16c0e2dc9aae5410dfad9acfd2fafd8ac4d7d76f0d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7bfb736f7da1904774504731f1938dbf43720020b8c1fd560e3b276d24c811a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09b83401f6931111920523235abee92bce4046820af353494ae1992a7dc191b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5649053e1dc822b44660e983f5ae33f76dee6dc52eb3b944693b9a3e8a12685(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f999fcfb259ed9227706f0c6cf55ace7f2829adf9f7149858712d60438b61a5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2416b932b79b3439a7c90fc2522382398ba042279245407d43db79ca9dcebfdf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee417d805a786263a7014f60a0de84649ccd6df832c7e381d97f2e9b0083234(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254d4198bc41cdb13d582c6cbd7d42608db3958e7275bed6d0f6c3114dc43d15(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f70b8770715b6f16ff9c247a328030e08546cc76172c5fbc6cc7347616b014(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1187d196f49d3cdfd4cce4f977f1cdd59e92dab6edb070be429e7f0b6339d7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6420c44f3b8ffdfb5b985f3b530d135b5113edc2abff8094ef9463bd274a15(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513bce2fb0535c5f2ac0c0cec84afaebfc5fc652582bfc01e06413bf0ffcaa1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ac2f16cfa7d788ca44d58c20e37bcbb631dee5a73793a943463a083f01d27e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4fa94231eb7035f7515e9ba0a4edf1a6468e9a41f625d696659740629331290(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406ad996958b307885b6bda73df90a6dea65c3fe64378f9d6e20f8b34aef3de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f16c40ac9630833a0c631f3e2fdb605979121ad466744f5744ad7f0154699830(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22566580f65a41821c2ee0ec567a5f8f87932b20bb781f5947d701323fac327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ab564f01f964ab73e983a657d964be7f6e1ac08e86dee489d00d54033183fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa08010bdbc5d918e46d3950b94b2a1b842fcf96776b329a0a69742d14bd5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c17ff8dac1294e96fe22c2d6ed25827f165f1e022890602cfbe1ed2b54429a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7136c6f6023b7feefef88e8cbf28d8e9526de9e6da8e54002f5e08aef504abd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab6e41a7d41cbae1a8451f32b466c05c8b9a72f489679bdd4b75d251c67a5a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__563c0cdae50da5225be9fc7af884efc8e105df4e7e8c99feab8abb9a9f26da0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cfa4dff78f594c7e6404329afbb52daf29efa57e16e0c046127133605dd7f8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7abb78935f229e450425bf9ac4be5b34024d7d221b96f28b1a71724a85ef7e1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99827f4233578659caa32683590a88afa2c7a75ec444124bc899f1aefe1489b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ac70e0539fd9605cf13f30d90b87640289f2a0756a41905fb7ea26f5a426f8(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ebf84077423610b1e900de23e6dbac1fd899780ebc35efa68e8e53c04fe8ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaec468bd705da1a63d858e0c98e6941207bd0e8083b5b90fbd597b8c324fe37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5064c2aa1550b91bf0149d4803940783cbb275220cfbe0148fea93fb2103ee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd452547b2dd82f08393e52e2cf6cf300eb27e2e38fd40d136a86021551847d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85f73680bd6456175454e75f4ac691504d20bc9dad3bb07e082598a479e943d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02fe75b29ebee61892010070c459d333c777ffd705e01e19fd1692dabe67c8e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52e62d0ac95454f497ece9c961fc423631aade1cdde12782e50ca3f3e40693d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0384009c8590d78f023dfcd034ac8483d9f6f542d1cde5fe30f3cca0f8d5ea77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828b3f4afa3cdfce6054cfac055856d06b4ce077037d8a56ad9c15e5668b6cee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4f146c950b96ab57bef1455245f372bc72baededc1ec62b16744430c4d7888(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50621a88c3e85af506f6a55d80ce678ffd79cbe75e101cdbd502f0f12baf896(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648aac43596e09054ff959a79b7cc391538ba9f366157b7bd6f9223facba36a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d156b721e54a724c8f10dede46f076a2ac589baedb676627c4d84e9a3bc8bc8d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45655898027f89afb0fa2b7f7777a8f5077b4e2abd16f06f977dbdb58cb2f7b8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc965970a340aa17503dd0af9692e7e9e0ee85f5bab12c7ece7c7b8768d8361(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc66898158dfb287978072af1531d391f1161cbf6f0ff8a535286bb6a690012(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee499e9b49c30bb085de60ae42de51b47fceaac23ca99c3aea509167578a474c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1068895cbd39a026d3133abb00f58c9c493630d925091880cd3c8428b754015e(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8abc5a5d76046c0d84c6fb80ed5db28b74ba07446bca8326a0606ea0917bfc5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1138564e885ec00195491864284e22c7801f42efab05092c3deb3d08d5effb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0cc5080f75df341744668eb171de8e8ea344688a7c2d606c4aa28b502659939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98a84612225f69ef50a1898bd9da66c7960fcf174aed09ed397ead7ae738446(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b813a766f5c6f6c82c6dd0bedc2ac41804e7469604738fef2cc3e34dd3f01bf4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a682567b6a4d47ea29a352ac167d99ce19bde07a7fc1dc56991c7d0671fadd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2fc7e571a92e4301bb7e8656067f13b9c5c213a6c412a8eb46436be075c614d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16215cb1c6d110b92dfb02be79eb0c2db0c2946b3060a9211cd5a99bc57d79b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__222729e5b3df5ff55c86a90ecd4dee55ab8f0003291320ac9c048f7fd251e5d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355eb4141d0ff38489eaef97607d865d5db2aea1fb53df4679e33a76d361b4ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908cebc61dd974f3c7d44e1da979b24c7d99d155b306e02b9585ab333d946ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2cdf9b178580d4a0f2960f03d982c6fbcff13814ee1e27f8b3c3560049c6cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ee88be39bdbc16197727e6b8f6da52e04e575c525e1b4a661e6ac853f3e8db(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b039115e680ad7468e1335af3eaa3b6b2e5f844e5f4eb904dd6252bac6955fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__812f3bea4ad3e66367914a5992518c8646c607bba4174294c745dcc75d0b0420(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eed2e81289484002b5e5c1d63f0e783791df9044e96ee598797ea1d76de1192(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc3019120a40dc9af2a67203e0db15a7cf88bb507d6ef621b5f2acfcbfc77b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3d5af7c54b73427a2490005a81b0bc3870c374cc438916266bed855e81bdba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3779103764e182cbb5ca2a5a045599ceed09cbb99164e571cbb00a3548c23a3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabe284f71d3a3c7c514b83d88be1083836ba2c22b7a64175c4145d2f530f500(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c27ec2e0072403aacb5faf43896cad2b69b24d3ca54d51f0309bbceb0cfcce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26df3bfc3c6ca58ad7a67f33f2b1edc1bb73cdad551dbe7066cfbfef60fa0bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d9bfeb4b526851c7abd5fbdfc946fd3bff27aab566aacfae06fff047e238cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3b04440e3bba0daecf3bda08cf3048076e0f9864657751369522969312f465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f9600d13f7a534e684c41c889bf450f0732c479d8b001e2f9dd1d9cda064e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571bd95446f4d676f6db711c608af4f7b8ceeb09a79ca177149c6d403f5b249c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ffd2ef1387022a88c71d1ec5345e7ec0ab1de78427ff2066d6b26eeb454c88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb364ae6a899f07231158a5f9b9cebefc14c5a3da04a9b89a0f4182f04343945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824f43bbacd0b108d2c5f8a1dc324c99c7071c43033e359c7a76d26e7c860bcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a000f91d85634ac2fe75faa88372b71507af5c989dde196f68a9a5d8d1cca5d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b628c495d927fcf5bf29fba63c37b5ac953b0cb91243099915c3bb40c1045b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f9880bef6308fbea9054c14d85a166a73376b02efbdb0a1f2e928061c38dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f27aee93f4733f9442469ba511423b5fe7d9f41f1bb3027f88b1fa2281bb7a02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0007d4e21bb2deb724f78b3a5268f444d6a44e64a018febc5672c957418fdf8(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6560ba333a72c4b283caa365577cc73f1b21fce5f859e6f8b38ffcfad52ac8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b101e885fe9562db737b776476f2288159edbfa01b47964c336899fe628e01d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151fa32b284ca7aa0b589d20caec9df9e3e01e1be5ac87ffa0b635efdf9cef7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af37c1c37eba04da47236b0355c0cd0a38f0cc880830d3400694a829211f03ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e2ca2db9f5322e6d44856ff27c8160afdf296d92a796a9baa4a11ad097458a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faffd2686c4a3f2edf9d37784b4bbf97b9e8bd33e503fc8321fd3f38fcee0064(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5765853eb177dc6aa783c01482685340209826d68c5a9de75f69ebe9542761(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a45ce9911296de225758dd04bfadd2e287b1e3652f7db97bc36a47c1d20b720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebafb31a491e29ee56eecea0b5f0ec5f67419835d6b1828278ba83a2bce0cb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6711b4afda257d1f9728449388fbbf0ea3f5e36be72c909cb2659c451ff8d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79b094207398e3c34295ba509f9aa1d9a31728061d3504b90670a34381b37b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09679717438a64220fb91f74607f205a9cc86d69f73ae0724a571b2cf045dffe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c9c63f8d7333940bc18e199def0ada52574a4908e72294d9616a55ec5403e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0beea2bed393e3d591964e6d0fd2ac8db27ca2ed9d0c46e99a980a231bb5703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b6c01fc6a9504fd114e823703ca3667d8274b7a36afe62e68e3d2a4d3eba36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95965b5d11fa70bd8eebfea5d2a9762bea14eee4344e6712a895651894b5f954(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85334a592eecad8171393e693926e83aa319ef6967be74731f968454bb31a1a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6045576257e4a56df5b620563229557a9b99b32dac247a22abda7a670dc1b76c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9e2805909e1b6d43d7c61dc506c22d430ca259f549c0aeb7e652d228dd2bae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f24acd39266a0d43da10ca09542fb05bcb79475e8cfa636a693f82534cefbce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f15ad3edf5f3c3fc5c7bd36ee2cbe982b9e010d5b9c672ff16f4b253f63b107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc96759b875d8be148f01dfce60d68eadbb3dc99aa7cbcd55510c90a83e8a7fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff4ad9983579b809a9087e2b2f7c6f2f7e07938ba0f0c6b7f9e890002409c69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce34c658fa3c554389faf07d13940b0682ee0ef638aa1368dc19286beb6e81f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714cf866d3c1e7c90a11db11d4c3eba7948a1f902f520c3bdfa6a5d304b0fb2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ff89b065b0d743605264b85466a73da346bfab064ebee368b7be3cee09dbb8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3018731bc51f53e250effc2ac7c8ab5406f218d05fa3bc8daa0f65c5eba749e7(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0fce7d80f4aee3e83e0737b603b6719296f18bee314c43ce69ba00607cf429(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090c6890442d27f88200a923d39f34cfba7065aefe529ec89b458ab84c8ff485(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b0e0ec3e45dbfe1432bdf272453367b30d0b250be04d1912a7380217ad7898(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8211b31e761b151c1359dc59673fdd6a26724a38a06bb2a69add92ec2c27c3e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed411f72c760459665154a8dbb7fb16f673516ff63c88164841d707ab7cea5b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c939042c2a168c1df91e099b382b997195655deb1f86fa5b8fa74d3fc501b38c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05cca48afe3545b0bd597fea09d4137e2b8a05b997ec395cfec3e182644405dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c466dbd8ab672e7a5bbc938b52c123939ea00e0743578c523f3c2a1fdb9512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1de5204e5961831c9a8169e91e69955ae58f5ee93ad88385863364d166834b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28a286af4eb4e202b0d3c337e321bbd0c51e789e803b5bb041b7ab70668f427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696d9881fd2b57d81f8bd2688d5ea853b73cb2779ad411d1b4823b699e9d8039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc4993e68c933b520e1b44d60ca59231d82676f0f1cf50ba6d67f1a8f9ad115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bfaef0582bf6047d692bb7a870a36b1290956373d5bf51b5fc094dc9cdd3b2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8743eb29ed42385ca6f463d335af5699fb5c0418afbdf13ab3478945de4d47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf746a831625a690500573c76535d61abb9eb5693604d043072c89f94a5431a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeef9f1da8a98af67d6637617b1fe652ae59e08be4f29aa1a539d6c0252d165b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d8e7f7bf61709617caf124e4d0ad6fb14d5926ad8c91014bcbb87b1b53dc8f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da32c195fdabb240bba073b80b69937c1376896f985f847979937eedd0277ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eeef0cb7d2bdd9697b58c00843f16a270e727e0f85ee70348c99606d5917e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f810b2b68dcff2ef90f96f6ceea21e640f376f628364667d4c473646d446371(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba0f19122cd6570fb1b6352e0155b0c578f87b4c1e36c8eed6a9667ec2305eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f982e6b9e2acba0941c77734eea9253ead89ce66660999730fcdf1a78c3cf6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cb89709c8c86534a9749c0cb32064b4c7213e56de54bd0915a640a2da82f0aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bca14aa91e9b3898c08e8dd0b4f5cdd97634dd60f64a8150deca5252a6bfb51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfb80bfa984aa3eef54ca4abe31df0a49e16d2847422069cf5ca48567734098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916eeafd56d85a05983f89723d853e7296fe6c5ff687e36a354fc291e99c8b50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb8d3bb8581baa1f6ae0b63d5e11cb44e0b5490530fb891536e463208d7fe63(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f25cc9561a132dc04073332390ae37c32d43d600373e39542d8070d4947e9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e1e128733475e1bcedd13750cec961d4e88f87cf0d7f4e3ec888519160eaa0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19dc9808cac1b551836d7c865e4cecb3e220013cbbe3ebd141709cd2facb3637(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815dfcd70ce00ed3ad89ddb039fa1a75d2c9de4166024ec8c0ec89aa87ab3663(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd3ef43180a3583a4f7b46b31fa10032ebe11584ca1a56852e657f5f56c2a5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d55c7a29a5aa43ffda95e687d117a24f443ef43b0a915fcc5a79f66ee5e53c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f2045e9753bd2b1b4769146db6d5e22830ddbd3e1b73e3a43c2a1224db892b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d533ca6fd4b6588e1c1e97ea535914b11181ab3fcfc890953fecb365efcedd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36b899d4fb8996482de2b638911b52cf0c8c9bf43cbebcfbe3c6712f725d148(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e1c7198ab9784e3d8547d5bbabea43bc4c1720b2950478156e76e74330ef21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5c04b814fe17b16de2fc6864a64c10eaa45c7c860d808865954b1f7e6df642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60321a252b357e85c3677815a972060251a9324ce05723f9853c48f7baccec60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350900228546de6ccf6f323033eec9e2653a0afe003f7890ac7dab3f6fc501c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90ee610927056efb6b698dbea30514f67591cc14a85d6ecfe7ecb2d2028d918(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a96c699833db68bfa49989b52d325e28a273197263d7697fea7a8efa37d5cf5(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b70f7d95168ac6dd4e99c7b88a3fd6f58357b195a6a03bf2f080292a64bef2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c04b51691db159a7b00fb098a3301a0d44cd9808df59e71a366f7958bb3a7d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5664b708f68e3d1ded13f4e43d676dab6b06271ff9800b40ef26842803d62f3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e52fc4b07208fed8fcf9e565825b8b6bb873b6b423c91008a4e072f0e8f2d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cefe2086f71c81b09b75c3ffd8c0a707d7298de720207d5f0c1c8ca433db07e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c65879c72c44e8a8a94b498f29ddceb30f3041101b1f5ca0572254f685c3dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8b43ad0b178cf940bb070bc51429667cdeeeff05d0646b7e7f6678b100edaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdcad866e8a0b08c696028f6d0769d99e0785996204ec3a9d34a2f36551763bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2752e08d56a4dfa22b70ba3ba1bce0d211788c23ff70948d95f8df04fd0adf6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8bfa9bae19933a211580394eab247344e47a446e5ef7e6cb3b4af5c3dd4f2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6511962e8dc12466c692adbdb88d34bf764cb61f79e19e7e7866e632b31eef43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56af2e361a6cb13d4ccb1320e998724fb5f5aa7c393a2db0e499e1b0a5aaea8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58cd10da8225a69739852cca751ef3107b383bda548b7d5a685a868d84739ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfc9b1c6110b58f621c2eddf249e1ca3db00fe49cc9127387ef11c50d15f50e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5f589d37e16c8426672beaf85214589303fcd74bd30fc195aceeac22809bbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127da5ad8cef38cad48243fda08a2912f5e163bcfc7b8f7e0ce2a41abeb37ada(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0474aa87430b5ccf49b4fca540c323ade4540f3849889d20b24a42ec478241e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bd5c32a89c5e35f53382c4042a5195bcbcc733b45ce3d4154f42d48a4d93bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b82811e180c637d08e0de2fe8b03a4049b8f513a02ef3312509f5d98f4c1c23c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec28ef63e26f1e02de26e2c48026764d37bd28d48f6d1bafbb1b01bddbdfff1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3702cbc5606ecd24c79c148c06e0eca1ac5680d1a8a230378270ed868ca5038e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203390c9513744a85a60448d3b2f7a639d20cd44cfa44f40f8bfd495c2c648df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea01dc6333abadfde18621ee588de4b12cfdee37e1ec0dd8068ffd764acfa83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e396c69d3c9e77fe1672d7d5881ece69c59f22cfbd3dff15a6827b602e514fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7714cd9acaa44c7edaec6f9354cb7ba9f5cc71af798d8dc19303b9b552239fbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d220c36f04b8bc5e91d7830e2e7cbfa7f007374d9c47687085d7c444dad1a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e173ae8fb0ca720f9a8da9e19d54d45e0780e9fd0d093cca0179fdee0600d81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__698d173474971b49b5e1ae5299bdbe2910cb73094b000f884b77052f4e4f726c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c3a3cd93643e766180188f2ed2a7ba9bee085ae3e9afb57dd46e5102db93ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af719efa0463f1f4aa414319fe4e60953b003de9148c13e0199b77da446a291(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae6bf7b1d0ed95dc742b3f66819bdf8fa65ac5991b2f856d67409c48a962038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57170bb7f053c72952655e5e0e9382fb17e992198ed76247c0316d076764d1e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e23e514ade784267057b2789f669631d1a6d35547e3bdaffc1bc3de77647906(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f3d90ce61e7eb68c30092ee2d237bac521f6b5453d5aa662549e972cd8d501(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18f7a1fecc51f216f2913c6579bcac467d31f21b85eff6b22cb903a5c4f99a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6778a5e2fb7e1ca8376b9cf0abc85648e301f7f7511364a5bc771816bcac55f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed73015c704d69a6f8cd2940d277c6e89926dcd2d25005ed0f850b72a6195273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc10951828dce62e03077efef2b92671e595791885123ff3079ad562c4da67a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8fd42ae39111e40dd0056b8441163b702012729bd8d2c8f59cf870298363908(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4147db5b1f82021ca7eff0858687a3934464fa0126fd5ace6e9c9eabf8f58c60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a51ecf7e10e8fab74b47ef9002190305d292ad24c14c5069b4863d28975baf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89771dd0279e4747d1438f9f35f2b1ef3cd1980e983b272f2f0d45df402edef1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5accab57533c08f200408ca804259b3aec7509be35774b51dc5054cbfb99d737(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1703a36db02214244973e92b96e2783f92af0e04da8f0d33f0f20b361947091d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a1b5b6103d131eb11cf29b0b86a717e1a478066b3fdd23db05a1b2dee7259b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8a01aa73417f178789725b240a51d8c35c88ea54f72f14a9a37b731dd2dd8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faace64ff363141abf5e2c60c42b0054601b73c8b55ee849df156a28646cff13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f7fac4c42dd96521b9f4cbd835e83978262dcb2d42e3688196403432772b0fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc277a89655cd701dbd8fb1c0b75746f90f023458b7871282abf8fc7a95aeeb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160108d0b2afdce9f7bfed7a66d0b7b32e0c758e3c51c80d4196f7c59d888b3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce38c4c3fb6221778677d067367cba54a2d926ef29ae374e82eba82b7288823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3bf19872a329c79a0609bee3d904fc132046b698df86c44c291e9806f589f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d5152f206aa50d57a3f827615425003518f7944a5c389f1b8c69b276838636(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01149e14d2ac7b204907d184fb80840b48ae5fc77bcc2aa412c4b5aa0fa460e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0920bfecd284bb82c4894fb61b91348f23d2ce968c7ab3657f0471cc612d833e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a2663c60058ada77b0b476df121b256c52dae132d068c11c34415b301817c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57bedbc90fff891eac14298b0877b72ca4cb41b550a21b7529837ce3a38853f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebbbbef167625001e771d2170d12045b71321c0f91f52fbc2f36f6fc55372a13(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3daf2045315732633d2cecc7efe271c332ee13a50e7f690123d32d21047f3a3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34193cdc0d3b25b7faa51478a4fa6f60d0cc77e97352d7ad4948c4150ae7bb20(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfff1184984ddd0d26d7cff491187b1524d089825e8b1c674c8477d1b6091afd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740388f862eb523b21bb800080338b1c882b557d13e0ad480e71bdc5c63a9f69(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2835ddaed04ad90067e2beb7bb72562de3ae303605bfd31b8d2bd6f064d2a4fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8169287fcffc2f88ce1135b17a095280a234bd5eb8765920432355f49bc858d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec30d756c45ae948e38619899671dba7f6299a11db986e4aca6cbae6166c2e0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204bf3334751173cf8a789a92b914b16c28a6cc3a3077f83e59954270cd7c231(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1612ac2d9185537f8c98bc5658eee3d27a1cc2076d6d93c72c95b6965120fe99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a693bd23d0586c16001c4a9eeb4e5cb00e3a8e8478dac2bafa9f658781f1774(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e337671496a3b2d6aa4a84378e5bf5d49bd422fc7321e7dc15f62d0eeff21e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7447fc60235efc719f36e7e47de54a704f6b77a777312c1cbca460a2cb77f05e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe37237c1149bf3e00d4bb99ecd7715ebd29706aef29f8ca29b5487de946365c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d038fad15f8d3dd8f17f5a5195de4651176131cbfa52e75353a0e16ba77eab9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16020fd143a61208a5fc6f6b1560e562243e3d730aa1aab981d5e16e9d0fcf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf3309fb6b64aedcfdc1643ee32247ac2229cf7e91c4115d4cf1d8738acd039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6edf7fe273b649181072ef127fb059ed7a7750fbba23cfded19387b02af4245e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c3f6e9c26887e4ef257caa3315abda1478250c96d2a6a408f94b437f8521e5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7723eba47740018528f6395b96663298f8c83441252e9ea0852437b4ab4090d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1051c5caa570bdd9a2a45ee44ac58f495ab0330f5afe7f716ee5d11e1ede093e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3974cbe4d114b6ea78b1e3bd32a59d4722cfed1b8914b8b2a778f55a075bdbed(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db57165d74627d570a12059f07721353c2b19f97cce10d6403e697af3bb475fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0973eb878f8dd64a1511dc80ed038a12810e6a46bc85007106fe7c21a901a16e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1f1ce08d235e733571a2e54dc27f95a7eb573843d13e46da9730f20b549c13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c32a01713e38070cf7f33f0eac091c9bbbb39414b9d4ad3b8ea1db40c1f55490(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6ffad39488561ca20a560ddbf730743a8dfaafa1bf5e3be11af07c4c2004e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d87a11f0ea43b3bd4cba7422a453f922d5b54c105480fb6c2e95d8709f1161(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92119a088ab6ccdf42a5e78505eef3066fbdb98b365f93b480f9c93f74039db3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8e377180c129b3e391db21a410f4a8f94d0c085e1ad098a2fc07829b9f2ce2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aba47c3540a26b09e2b4c5edae7139941c7da001a021f6e2c0f66ba9784ccdd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1319a0a16df8b2e0dec237ecc95c22e23048c6805600e40b299cf76b73604646(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d6a62152e0a46dc6bb052f7d3a2e6ae4efd99ad440e5174d6e1ff0af4d6454(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf8c8902f1be9c972c065fd5d385cffd2e51236bd15d36a893cb88be77fa6f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9f95d1143f3b74b8bfb4d55f57b2fb86d831fec734340b9dccf3e65981a41c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dae74a406f925b87199efbdb1760387f77e4bec917d8830ab8013602212feaa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91be1f0e9added5cb0d3c832ede9e533246fa76793f86016f8dd5331be262f82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a4e924c2c554ab4d558217383d1b98ae28cdb2f3e9b574a0157928e209d459(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e513955aa1d21fc3b505fb221707d97aa8acf1c0a908f3be9b04fe6f138ea9(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d43b0f28245889d56977d2c94c0163a0e6f98286630d9f6e77601e9646b4dd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3641eb2d1846fbd8bd2fa3373ef08a5e6ebb2faf9da1a3cc6094428822364e93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1a5da55ddca53dd413a0f735705b3bafb6646991f656b62b6f2fcfe4278f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd8bea57d71a4712dc9b2a31950e7779734b0fa3ff7a3fe16e63b8127de1dbc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba1645ac6bbd65f6f8f32954b4484f06f4ecacb9867a7d666f1a3c9de202b46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd5ff5bd819aeb246d89c19ebac32bd713ab804f3bfe0c30ff6e5c2e0f4c1cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f74fd720bf5cc710d3ca0f5cc13cb210dc89206d11a9d62f9824224caeaaae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1286eed790542c9b0e329b5b035fadf008aa85e5ab2ae9453a3333fba6609b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0d7f7f546ca83f11a98af972f7e83529cd275450b64efbb2d0ab714649e649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333ee9ce411821911e5bf8ec3096cc7f2b6fa3c41830c348a7da2b5ec2682f6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d01cea4c5b6346f49af85cdc42dffd8c4a0adfb34eab19151e05caba51054f(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420346fcf340212963a1879670e306847c55d3783727f09cae0f1be0530aa2ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7743a7c42693f43e3675f8693c21f6faeb0380ae32ed1f42699cbd95a144fccf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a996febc073c6ccc8425012e019383ab807b1b031a56506f9c5733af07d66d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b856119bff104f158d0fbce6fb398cb7b77e87525fd2c0cc7f758d9cd254d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8854e1cc2f0de6143ae3694c0a2db5ab36848633b0b94d96072bc146051a17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec3a397dbea439ac7ae38878d0715dd8be4a9df2bd68673f8c5a56f1eda27c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__461a88d543a57a15f6494ead9e09d5ce89d85f4f392ece282768a643b4f3b522(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5551677c8a515d02c55e4ba72114e96630d22f2a9e1c8d48bf10e9d7c8f5aa88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec054c8c589bb43de29276768662a5b58e6799881e0e967bedde111c8707afc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330dcb39f6c9d60aa21c3ae36ed7e7de5fdf5eae93e3826b3c1119dcc9d75408(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e3e606cecf84d3ecc19af4594d9d19f568be73d88d9b7c1ab5e4104606b017(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe09c7e69885d38ff90057b2946121ef2a28abdedb01cf283c9b9b0d86b3757(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeac7da84ec49efa7c8a3f4944d7f379d649c8cb526d31f1645e5f6190e9ef9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02f84b9ca9e9ccd9263c0f8b7a69bad0c4bc489d3ec7d734c323cc7bb91ebd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717dd2dd51e7bb0ef1d1e4f10ee941a8fee3dfc001988fa4e79919da796726d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2815fa2f4d4d80875603082976f478fa0a3610ffdc368a7b39fd7435dc5c828(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819405c971a8a57c416c5e58b8247abcd550be6b5ec3bf45146a9099bd53f73d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb00e3db40eca7d393bf0efa5b2b872bad6105c83b8700b2e8a67f996c1feb03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56dde5f5b6cbe7889bcff2696d06fa90d34776cac20739869f793598a1e32823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186462bda4a0f253a849f10b2b7866ac61d8980cd13ea7e5afbd267daa7ee180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65583f723290ddfa95f46bc81a1f44d4653858e80d2573dd36b8ad9ab75f8d25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab1cefef9a658c35134c531d965854bf7828818dd6f1be185138008576fc5a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae84b8289e78d26c5a182b0b7d131752defdbeda27dfdd87435935c1d27d001(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ba9a6801819c004a61a5833770ea92c05dc00df7ceaed95e6eba8fab94857f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840d54fc3effa5b20df1d2376eaa2fdbff74ca638cdb472e6a127cf1d1d211cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b130425cd329e4b53688495ebfbc9fd8f36c61fd10a15a26d70f87275b641e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4440f7c0f07c2c196d334aa66ce2b13fd2f70ac03b797bff065ef0870f4c929f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4b53ada8edc6bd9b12e015892fd95ea91b7214354ff8f34c5486c67f5bf47d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2470e84e2a6e937f1562207db1635671166ce68e72da7c525dbddf9d378dc5b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b083c42065e8fc747595621fbd00c181dcd500d1977538653aa7238dcffd32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627887839233b6410b1613ad0ec1474a7ab5d82e66bf1f30baa2027fc8eae9c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73217e79114de6dca64bacb2d5a7f87e148b942e8ebf96040bd8cebc53ed4fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adcd7c0f3a88fd50d648c3bc6b285034e42f8e9a08434eda6119aaf39b952f35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aecec711672ea2548bca0d37b4aaabd9dc1e28a91b7e1bdea28eca922b0f5c89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8bb86fcd18d84b1cac1359c153905f6645f007f7262aac9a11117d92d31db74(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81244f2f5973e06c558d2c64f2e814493320dff911a7a0d497d1e4c47b6243a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895c88402b0d7ee8359229a0b9bc8568ca100bbf50e0d36d45c924d5289963bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacf2ff10b31331d9522d7b278fc83ad915b08e765ce92c7182a99b06d9841b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccbc2e9ef35dffaab54cfd5894f461e67edcb4d604a1cac13bb39aa7df2cf99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff025192d5f8ffe8f6127ad4a41fce7eabb733ec45d3b176550aa02dd1d2a961(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b749ad537713fc574bcc64a4339969e60d6856d2c39866ff4ccf0a2308926817(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7339f6ff49d9ff686efdabc070513c5a48b94ef0d4cedbba90020c386167ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0c230350532e8c2dc037d1ad139c48ce46d0158ebb926589648d24385a9d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d355760d77e1445b0e122f71621919b54159111f8b845d47db530c2dcc837c6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2d151cde368e371b2b7a96c80928678ea29a9d15379bdd58ce668da6280bdd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d8ae5384d220570ae0d9bdf1612540a33792b194f33b5579ed0232ff85a9c60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df55e4cec038ccb5455c66e1d2ec37a8e290273c4e230d8d4a4524830d4a2c2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e123e09088422923f67e79c2c6bdeaf2995d89e8270dc45ec82e59a5df635a6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d634d7d27f495404e4e4ad057c3495590bf9c600e728cef1ae4f63d7a314bfbe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebdd9fb2e008b129499111f54678891134376dc1d93178908783cc9ad3f3079(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5065f718c2b3ddf9a5defe942369282721cc0782231d695a0dcda488605bc03a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81df579ab931e879bfb6d0f33fb467a5dfa0de6f11bb45045c84f1dab2597fe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f56f22c98cb1d8c291f009eb44e1f78d43241f3d290878e37ba8bdb32b5dc70(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a52b515f7ff99474584d9d27d46714b2073c17ac4c8086e672b180b972cc755(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3caef763ea55b16c81f1693599c63e9ea44fe706341e5de0a4f03d7a6293b46f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0fae8a0879e15aac0b7f09b623170066076078e0c604f455553abfb7ea4bf56(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9b23b92219d6c12f2727e58e062bc35670169af022aff5a6acce309acd9a2d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f738a0c0f4bd45afbc6e21ce6f997e369a6dae07ac829e2165927e1d8be2594(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b0416df71061ddb07cb7d18d21442ffac5cbf90a5841b18218c9f7efee98ef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f240cbb2c90e68c1444484875511b2db238d28d6d989bc4154dd6fd2fb110db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfe61ab9526f97dea88dee87e343367bda370d212f4066037dfa4fc739f0e97(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ba55b2dfac684cef27d8b5bc020f25451d0daa43c283e75e3c5953ce8a4afe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0196f72c3afdd29020c9f098a398af4e0c471020897dd54e72e21f730d8a903(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__004f561aa39ef5bc954557505b9f2713a3db01436292da5a62ec77a17453d677(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd381f3b5628fb88ade6b488446673610faae86d044d3ffcdf5779def337588c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e3e26756cdea416b771523687ee6e05be7098068bc71b37a554716e0844eec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e8021704a7bb199ddb1a298e78662e3fe6857db44522e69c75f11e0d3f44e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032f75d94fec8cce6ff7655eae9697bf1851fc895d534d9aabbefb265117a243(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__353adba1732e7227988dbcfeb81ee09904a37cb0b6c605bde2758085143974c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca67bbc49986ad65911a3401d673009a0408e597921c8b6c9ed0bf242cb2e8a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a101661e57692c1cd46903fb42727385c82ab1451f983c284dc65941c774963(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adcfd7cd86b942b32baa20a30c0db9c8eff6bbe08e9bf4e39d842feb61f29042(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a537195f8465ee050836eea548bfa8b5990c2e93b4a6eed9fdd407556ab714cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79962caf2e0caae826fa479bbff03afa0aa40835124c7af56dae12c05a061a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188677800de4ca18a650efb352e67c36fc3a95f826ca88cd9bda42ab5e41e678(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328765511c74902c7592b599de36d4fe829589e7af40e7195d8abfdec4137dfc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718207e230607cb4d9b5ab5dce1eaf98660ed8d287e983cc7fe24ecaf3b018ab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212ef68474b74e7d759b53b9e981fde333911991f1dcb15ec68dc6c62c1d01ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5eb6113d753e522573e415e45802dc6b9536e013ea6d35ef21896d5ff1a8251(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9361d6cb10506e146587199dabff1b8cc2e6865d383e6b87c837bf0a1479ebd8(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d0b155e2d03776b03a678ccf63c4fabc470e32b92948332dc400a6ae4b8132(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61671386014fa425b55e02ea2459eca1575c4d9ec615a0d2bb9aaf8235c72d9b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f748a6468edb4e694e499c7ec072bfe2e8d1fbb88cac5142fee18498c983e013(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0020a055517f68f67493da11f6e6f325f2afd132fab50ea88b590d6bcb6bf0f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164764e3478e582a8c4f4bd8b8acd6f6f988f733df3431fcdaaf64987b2225be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38df92e4ce2152354cae6c78141ebf7ae4b913e4deaa4e7fb85257ab29b0cbda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fadfc929c3208243b47c681c97c67375295ac1c34411e34270e48614f5adde6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2833ed19de334cee0250907988b1a3420a32361f014d5b3e6f6b93fa126d3ab9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fdc3abd5e04f9bcdfd2ba2a81f0d65a929708bcfa8db43695ed6f23572d9982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e07d7797017f42542b5d52c3a51fce5917ad0d024492224d9ff5726aa5be28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da7e07ae2f5fa4bc17da80b5947310abb91186e61cfade8af5a1c27b2db9c06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5667cfb4b8986344712e2e230af886e95ddd6c145add77425a7350693b8888(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fbeb562cbb1209c39ce412ccfda73be0c29f72fec7d00352c4e9da9e063f18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d5192c456cc31b4a57d9e0151a5efa71615d9ecf6f5fadb986c577af4e4fdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a071e780735f2f30db4143b60701d04816fdce4cb0641ee924781e984a9f10d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d11f05ea815e0ad76be393a1ba9df2889a9ffbfa0a3086e2e346b5beb69833(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c817dc62d8bf9663e527759f20e9cf10737888e8d5861dbaf43353a2865e549b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6dc1421c14a640a1c4a3fb2d9b197703ba3077e4e403e94cbb67ba8364a87b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9e9ccc1efe59942c713ba8d365b7408004e107ad603a917cd23edd02e455c0(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cdbc79fde63aa2af5dc6f32c449d41f1cf74dbbb97535f13ca91d3456eea9e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf5f5e29a44362ba459eb1adc1fed998b063cb51caf62a66d01175d71a302b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5268980ea62177c1972b05e4844de20e349d88d44dea507c0cd678b4ffafdcfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4cb0c695715378170c9667eda6bb08c06951647ae24d4505c6fe6bae2e3fa4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33973d072a0177e912e72ec41ef753d222b6257ddfe85bf49dd60dafa18824b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ee734687451315b2ea49d2db890a27ea47e28cc432631515c93f56ba2f5c2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612becf620b7a2bfefa5b3722a1b68bacff990e44e355322b80904cac231200a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4cd9db5e9e638198bf2f1f50dbade0b33fb919cc88e80a294cfa2d8ac4747c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192a058cc52de230ca35c1fd7e8b3381245e45eff33c61c49b942d69bc8b8f4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0469e71892eac00a0b034c9f3e4c98ba58ac04e5b990ab90a777f8185f91a002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29c26cec0dccfa283f074eb46d27267dbe74ab1e541d4c21a8de056638714a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a06e63474d7a68c261c446faafd25a5c4cd08bd1e83122df52f156fa1cdb649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d700e86762fe108c086dec7ecff3f5cc571412186f5da3e990187c751e26ee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cea7158f9337ba86ea1e58027bbc72b0da0720df873b6fd7111374eaed439c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a183c7984cc5f33efddaa0d58b432b914df9f3d35221245c710f150592a26f64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0301da8b709ff4a567b974b66fe750178e5c9bfaf0ef266a95fb3fa5a06516b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c725b18984f9db83b1b0a1360884423af436fb840f09e6e5ed2f22f5dbdd587(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5f727e135886add37cf9ff4e9f5fa605ec20381030f08656e9271699bb50c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a17d937b90330735d870435bdb61152d60e067e577660a2d2191a93dd5e2068(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c309bd39daf13cc9f7f5ed9d2228bd7d559e71065bdc7f4d46fa428858c434e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582124dde6a204368e567a74fe6161462337ac3373aa0e1c91152bb169528098(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25dad1cc47a7219c4520bc5780ca51ebb3c0183d4c6051de22f2725eb7309631(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ebb212634dfb54b4c5ad3de27026555085381b441bcf42ad32311a08696bf55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8739f62bf78e0725c161a6a1ca5e0d216d1fb0f9dfa735c488f8b9767092cfa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e3cc822ef7444476922f20c597420d4aa1c07563be023a1bba2e942bab7667(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6cd468659308164e281e2d618207b766940b9cba63de7df9a187399b314e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63f7c62221fef60c83bb79d7f6de75a6d7946479760c7c7db1255e5ee8243564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ec613c0859ca2f538fea871f86fbd84ad5339e0de61b8128a283a0668c4004(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5629eebf4dc0d70290faccaf456524db2ce9ee74fc1be8fd3ca863898b40468a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eba0d04ddff7f1385e57ab006927e348e8df5ab6bd977ca7b1cf2f48abc426c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d776d20f00b3000793fc4105dcf7088ee00a6dc7b1bd3f7f92bcd8aac4f674(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b877942d60d6e5bca3ac036380488f59acfa18506719db46ab9de99980e4f2(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98644f222d63ce1545ef28a9c6b77cafc31bbc546549c0c277930f1693506934(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d4107056250db1c10e1b53c979819b3b6df08f278a7d23dc0a7e0f1364b082(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb887a068a92fe87a67b7baffc1cd6bc9ab59c0bd0fc263dbb5a45bf7dfc2b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab810a6840963cc727ae000bb55117ab238705b6cc366fe5d79195fac0b98517(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c951585c1a556adb2ed13d07457dafe1ac10b2344454a6635bf3a574bdc001(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57370e8b1edbc04993f7a79cd7501c39befc18eb68284b726b97a4a54ae64c76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3fb5427e9f5565a8e9038ea734e5f54ed97948e33155d891628a90ea31b879(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba274bd110ed79a112630f9388f6cf085ef992e3b05c5f4a10d443021ce99b3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1f38abbed9d49ecdb02f4ad6eb52b8ed47038d69aa2913be276c5e886db188(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09cb6307109472f43f38dbcaa76c8f236c51a37cf94e7927cab656581c9285c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2fd277edea5cd3b21a21190bfb41767185c7bb4f5e22723e8404e30f8ef9ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68f4a31b9e255e2e772761b52b0b79ccfe266b270355bfcb25c3b35cace8586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7db67acd832e625ce3e4ff6cf08ac4f8646bbd12d61d7ead974d747966a56f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a38a9d01fb6cfc0f19e1c4ee0a9e61103b2714fac76250ce298db6b37c91f916(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bbf082f08401fa9977f44c51ac7592693181ce59d862c322373f7c1456b578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc3213c334fa00b7a0a06dcd183f0272f26f867a67079377a94f7c80c7fc40b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5384904a3479ff1b3f1e355978010f73e9c75e7e94ebc80325cc214c2899bc(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c57fdb69d3cbcf76ffddfcdcbf8ccd90f212abf3c61126f7ee507c287db46e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4164dbbfafb2f3a79f36da889aac10f2f5c9500e6b97a05132dfa0ae454ab78b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40bd08e8dc08ad92d3f6929930fd54a422807a71b2ff512eb9d591bb112c57b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4efa04058db0a64c1483ea1e1bef052a6eed83e8743c0595a847597f3289b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d8a41fe24ff3a9f61b0f0db785cc7f6d6c11a03da2fbb599b127b321b4ec49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615b2e4ca70243646310f2f2d687f0d8d5372c4c4bc7931ac9541f51fffe1dbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44214c3571f9649ed89c2f0dab3acd1b3f3d6a09d7ce2e3e36f9ac154961e2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2028278db8d98ee61840806ee0ac862d1fae9854dd1f5df90646ae1250988044(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704aed1680e573bf064d12052fcacdc4dc20a30b1c73affa11e4ea80d72f51d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00267b54065ddb7edbed45367dac3fa04f56409b6917aec3584f56eed6be0c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47f16f806f3ccac1d576fb0192e7acef15fc28fb322dcae4546e0be6774a0df(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add3d3e7657092be96742af57c34b24781b082e4c3d5af6deaff3b57b3194dac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde576425addc8fa2569e1cfa911840032d2e3ecbfe6db0a6cfc7ba2d157f95b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531037838b8b0f7b3312695d15eb94d3c58f4df862e384f7bf779eec6e015353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b501e1a6f7eb3a23ca7c7248354352632d7a86eb5277aaa6e0249e49e59440(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa31cdd4631cf8b75e843c46cc44cb7eab4f2e35d5580212b56694046927426(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b6010cf1e55efbdc987e2d668d89e9ea610ab891bf37e04ef352e3bd48c6a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e1a71ae1137c02b5c7b6acec5f5cb39208d64541ddeadb2bc9d49c73153e89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c675c01a52f3b6150b4ccffa21962e5a93a65f5f8b51840176b8eaf7e641644(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf4ce37d7808284554cab96a5964e9c07585689700c1a071c56ddea8228e9c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942fa9bbcbf94c68018a8acc85cf3e9718946a7f3d1258757a97160490c01578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287ba72095a7d2ac890e23a0e61fd20bdd97193aec72d6262e64eab128123811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7cb324ecb9b52da5942ed78550fcf22a02d809dc7e23eb08f31df10f028a44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305d3a55b9be062a60cf37bba76ad348b54d79f78699ff2c767b31424c21d9d6(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059013629351badcb095c20db7af15e8382e6d353c7fe1547c3790aade69ae21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9899870e329f2afa6a1d3fdaa5b4aa6e1f6e02e0c90feeac7a77cba4a8938c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d7a6833b015ea2bd90293f07df9b3363af0399f1b9eb2d9a09c1c3a0de8785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66b9d67a18a481f6f884be09d718626175963b012433ce24f9ad9c1425b042d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f46689f7ee552df6d377b84ff4805f3a5418fb7c46ef439e5f21cba5eeec68(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f69400efa88e04b24b230955048471c6d7d68db5857361998814a96cabdf79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12666b6a747148a32aece5df8d932fe8898ad6ecf6a22b3250a5c01f40b687cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9850e837f1352db9c1617386b7fcf67d5ef3d6bc17a96f2159874e9340183f69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c18d2639e259fed2e1127ca3a98fca33efc2f8e146aa6fb4b59927c3c0d46c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f2995c9950e7330c9187ea4ebbb67f99b8bbbfa5b69d1959bde1d5d28c378a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e00ad85e1029e75fd06979ab748ddbec1717b41d2387ae6620b16e3384a26e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50ad77012ab1b4ce4204b1c5969da9b9327cc0316f727e3874790aa98f63553(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c5be9caac310a282524bb24ca22ae8c746c3a93ce55bca160c8e9b0e28c969(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4272133e82e8be1a592f12e97a7db087e583ace6e132d7a253859ba769028282(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b48958da1e5223eb72ef904e7d04034bfe4b79e687ebcdde317cc54b51183d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883217b7ec62bc4abda9e63cf44d16881206dcebefa1cd86ee47342e9db66491(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a9106d24fed2bf208983dc14c40d479aa2083e2f1bee09235d6159cf643284(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c932a9e268930d39d8b12b56bd75fb5e2dd65341f458a9692fca2ef33ed5035(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e760e15d3a1c919a97bb338bcf6d34c376e318354b3b32afbedbc8285d35209f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ca013e4a8139b3bbec38d591975af56e31a7b8814d8d7ca2aaf5e4bd198a56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43944d4cb601e575b3c980f83efddd4604893f44bcf5183e631dff150d7819dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c427a872df29f53e229473d4dbab22ab811f317203c0308636c31ac0c45eff3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15d482e9055831af58dc61a7092df8d7aadf5bd4bb2845d8aea716fef496e11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a096d371d745ad9c7d95820c438f16250df43c21a40aa79a7ef77af5de7cd7b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903d8adb452772f1df6aa0041d7799b51e9ed8d4c14ec99a9f287f5d5fdafb81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350390d9a0584be032b1e23fff153a6f0927a48849f28d50150662eafa31ea85(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f52d478fc0f0e6ca8e7dd7a4b6d5ba7cad65b9047b7e2ba03b0e0b6d5c6ea65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81009f4a4c93f57fcc4cfaf3c6217c1d2b2e4b04e66e61279f1ccce1389b9db1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c4bc68f62a90b93255cd5ace3d99f7d4ed819ae8b9ec6c5713752f9aefa6de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca6ae6fc211ace9dae01f50f10a398b1cdf379160675b4baee40cba48ec5c95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b020d173ccf2ad12e98c5a23666b6cb255d2d78424ba1f0e7435619dcf2aab5a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e9d0100087e331fec394b4bb9b6d573d1e4b87e94412d41439ef39243f4531(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__441019c3cfa023e22a63b6a973cffc246981d6d5090f727479864a193f4dee59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad4565b763861c6f4478976c0e2597fedc96d4e9fb18f607ef6a298ccc3c500f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9545c4e78cf601343f5d381c0859578ba1e9080024ca8ecde493b012971b4b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04fb63c43bfbecd81f335928ae0832b52e70e4c70815b2fff23c9c88c88866a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e46eb8266f5977301f1877ac361971b8f0ab4fb1c26bb72ec60b18af4bfa78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60fbb2e124104b8420ef13b9e5255dd404dff0bf5b3314f6d15fbdb46e4449c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4eeddcf87319896a3056ed15d3b415d6b3d0204ad3901688d3d269eaf0527f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e9f3772bd81f2e5bbb973974f9bfd7ff93cd724470b4bae419d37172abefcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf31ffa73875dfd47174b8d9707d70ee0f7b0497102be19367b0be8a0bf5fac4(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3268657f566ebbcb1187dec7b7cca816c80810865018e455b586734ea068421b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1d39dff11bc72669010608324ceaec9e4c8ed2df353d9b6a4f5ef6bdc96af3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__789571554534475c7abfa7ae30a5967afe2d906d1c6d35034ccced45b4d6d577(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f22ccf0838667b96ad636b1f3c0e4b935c20f4b12ffaf98bf77ec027ca559f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d888cb0791059e454d59d783a3008bb3300af4a262867396f41d275734a189(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e0b13e02e88c01e5a0920e0a6caaec7cb9fbbbe75051fb434b2f48d1977af59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a4257ded635fbb1c44d66f85f29cafc3d8b702aa9cd510945205006c3b6398(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fcb77644df0464567e1277641ccf8efb82153f9645f10f5ef30877f26447229(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329ee7b0063fe89ab297808eee135bbef45f2cb3181671bc6faa3dcbf9a3b56f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef5dfa2c7957635c093045ded809cccb66628652324f81ee6a166fba19b6b76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6270509249ebf33c93f88d74156e277be143f0f8d8f4db4254495dc39981bef4(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08bd7c39f816d6aabb531f3b27326441f9b164a817db295223a3271d88295d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f45a64412670f151a085a734607453ce97481193b9775089f694f9239e6c14e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d05d0c90891cef8e06f89c346bd22db30f9165a8f8784086befab55592e24ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a7711272509fe111617587f83d1006b9cbe3f8fe65d758f034742967a4a9a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783c97d9929fba003acd67385770b706ebe352e72985db5d2a645d2759985406(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff4e0b3396f73840b329607a6673e9d33de9bffb6d59743b8b9363f0b4c2af69(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1232f53844faf96a07c2729943a266ac3ded8007bd4d78e8408ad64385f51393(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7967a7cfc4dfd862c8f2dbcb0b800adf946d3c79634793054ac4ee8b3899276b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bdb0c472aeb428a1c673e48c9d496095c0d26cc6cd5159bc5940d26faab496(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78587ab6281d6783ecc5c61071478fc299a02ade4e649a66de1902c01d0bd24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca5645531b7ed8b61494189e620c49d02aa14796249ceba950bd0982e2cf5b5(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8feadf6a0cb781c3349a74273e53d43d8bc3f8ca3a2c02ba7fff581cb5ad4ee4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eabc76584dd904c500b7ec78195624e1b215b3fb9f4ee4dbaae4b14f1f93fc72(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8097947a178c4ae19bf1e34b576e8176fcbf7c7f20ab90b4e59a90d4536293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3950ac934524de9407a1861120fcb496210c35495c9e54ae54a0c2827f24f338(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835e5ff0f4bbed58fee02388eda77962a38a455a075b264f4d14bde4e2e64259(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06efe94e403afd37b330dd98f8bdb70c4f592acedb8e2f89f9790ab32f80a99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a127a1297a049b2410389351887043d46f2ef665e0204d35323a6a72f9653d12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13385d3019f386f134e3a15fc9006f0f612fe263477894a35dad500e682ed058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc957670378e4583ec6e7bf87cce86e7de5e6d27de34252e9662956790ca42e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6ba4bd52c8824e304bc69b5836c8f01a036e077de0f89adf731dcc312c9bb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61448a3163c5d680f64eb81adc645cff4c35802ec9697e7c6780d155245c7af6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dadfc33e9e8d4aedbc27fa5125dde2535af28ed8019e02c39d69beee3baf096(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b4607160988739353828459d28d3fb33faed99a25df8b7b1faac64872b4290(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6950e3330b3cbcc1e9a64df009c6d520bb3859bc8fd84725b777dcd4250dde8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86eae0d83ca10736609f2bc9012fbfae4b8dc16032e68bddfdf22df54ab5d833(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9292cc1ff345c8b895bfec770db1467d59895e3008deec29849745b54c75c506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0da9361c9ffd353477be726b65413ca719de4d4a96bdac3a5f65aa014732a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f1fd35e95799d9b5e5cdeed455922bcc1c669501a0ae5b5439f6e915717a21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8721159632c9fac7c65e1c329f5adb56a6e6b9cdbd6fb3c050746203363870b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642c4cc6581c12f7a8fa6d1d2b58ff565fa56ce0b08fa16862f4672f37bd8a5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad4c3698e5753b1a8cb7ba0b069354fbbe2586cb5964a648ba6a76bbb3bdf05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202279b80986ec2ece6ba5fd3b5f29984cf3c429a90d427c23918ce07e51e493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c601906fa743b9745bc0e070a8cf37658db0ecc51c0f19ac55b9a76d64c835ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708164c236ac8851567c1b6f208dc08bb2a039e878b69e4f2a7094c4da311bbe(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132139897589af662bf7a6255fe4dc848dee172be10789a512d44508d518f5a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5070de91fb9317d1b2804c9020a7369e75a9846e619b53283dd8c0023da54889(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76849744a138f9dc92793765916e59e5beb6e0a8bb6d2510317f0f9f6ef7fa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1a9c0827fb633c9f6497aef91543847b44f4b54429161260512159a844df7f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6783edb955229df0248254b100efb166230f526f1ce59f821a1a9712ba941489(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da107cf46f4562ad68331416cc5447c68191cbb04efa9b528f03c3599a812392(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f539e44f259874b82e59686b9f35240f14dafe4baa8d405d3c53d1ca11c0dde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8a53e1467b8b03b82e0347747e610c9ea0d7caaf5b03f8a585cafb84c8d15f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0c0c924afaa4f53de7310976a08c6bac7550c204ed5f44d4b6829a80d58ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf45c1320ea53d895a67bcedf24164924a6cf61ebd7e995b9fe6580f84d3cab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e648127a47ffb5f7cb7fd314e909775a7b25a4bc451b3f1c4a4f821036181c07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50e0b2480710fc5d1ea12a8e8f5d6b9c81d65f30a2d68fd52f84678acf9855a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a83a2e2c1a42634f25bde9019ea71ceadbee2aa77bd4dbe50d15b2158153103(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46655e937a09b9d4e9c180cb23c9f2bbfc9924ba8caf0ea8d6d73f0e7066f065(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e815b5fb88f72d1d4bd73e6dcfc86f4c414d342e1f814a713c01494059531c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe97d45d94a09d0aac0024d3299b550278dc123631fc13c7885bab8d8ac3b04(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5dba7c0519881a4bdfaba44c54d875921c9d57ba567479823bdc89077c3897(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45def051af62ac8b3ac1c4b93280f6336646884ce1ffa8e7868609e3af73ab4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a0396fb2e03837cd01c659255909fa07763c70c0bf25d51f78f9cc62444d5f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d771902cc6278371ed3342909fef8190dcb5d43a22e3c48431888bb6e65fca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87a85e1a6d5cb926fed3675211d9142930a33ca413760708f8aa5549fb5e1e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af68cb3bf1327bcf2411cd06444b7f96e7163125c940f7e3b448113e3e0aa91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9164cccecda036b834df163270b00c2cb5f2d700e7869fc079616800b18639a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52337ea8c15da4e51d998eef334cb62aa39dc6be0ecb9782e97b60da396c1304(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c80ffcd780c616a8e601b23fac9564518df068182c91030e5cc7f96340fd0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0ee02302a59f83744f0e74d6e8ff84e0f0095ad0223b5f81ac405f66fae37e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b693fb69bb2ab7a87d45749805d0261b620c7279177121d72b0ce2e84e6cfda6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd53244207a7a3f737d321a41e6033c678f8935a842bee0b58fd214fc082a933(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823ec67bf2e422f4dbf54cd85541715fa88c38705695c4cf426187e39ad5da30(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5106e9e38d0835dce500add17e16ce48c11380c14b7d09c6f1a9d2d77e9f069b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5d64be0f9fa9c254d4124ee17b55bcfa88bbe3ebb80023cdbd4938e62c0fa9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca61e31fcde40dd46e78ef10ddec1ed587b453bcba1dbe339feb8bbb66ac48b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc5b2be66a20858b4691483276dc90cda138c89e8f3dcd51ce35335a9ddf29c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8568ae7857e0c77335823b0ede91af6052a08b0fcb705c6c574325b19a0051(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51756e1b765f8555affb417aeff1a9f2fcd5d092bf7b68caf4d1ac38eaac3b1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f124296a828005a330dd872a31b000020a886c0dae09e0491ad9ba5e996d94(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef34f5150e73404ff920a002a2e9eff98865c319ceeee95f07dc528f7ead806c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0642053752c35ee80bc3040c7797720fc0912fed5be5d8dae91c64372b233cbe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edcfd719a4bcbbd1ee0d5854996e2bc5afb30807c4c6e933db86915de35fe02(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7aeb81e7505c6c7b545e9ea6df750bbb013ea01b6cb9c26ff20aec067862d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c46635d2f6b3d2527e7ac148d6d0ea4986277abce4121ca138a21d88bc0faf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5e43d4c489e27532d43afe04fbc05b5f3f8bcfb8dd8c5205307edbec491c97(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0617aac22826ad5eb78d596064a857b7f1f353e8f3d544b0317164b51bfe1e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4facf4ac93a65c1d95ac176d3e7896d651d93bc28ea6084eb04e0d5b30cfc273(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0be3cff9f91c2952ef19927085aeec3de0a11a8d45375e08809a8769f42e25(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8faf448b0bae196b6a82d64bf94f80eff3db38c4b7a76298b27f0dcd55ec7842(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a50c1a496822a2c593559dcdedb076cecdfa47d1338f31d6fbcc2c8ba3cbe4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ba3ee346f45a7b117b665811ad416ccfa831cd2df4b47f2f7c95db74f08174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7cd8eb2a0fa9f85fcfd878f9ca48ac7abf47623b2207cee03521ac0f140fc03(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc8eed5d2724b6bb4c9366281a24b504407ab0f68cb02902a0fa80a1b8b0028(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb363db36b9fb6e6f9cd595650af97349a188c763fc4a97b1d44562c9b58cb3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c5479048f2dca8c98801ba9b4450d30de6b1d0e4c90f9df4af9707e6ab4bde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220684f352c9dbc057e67d683f2c5f288f361fe3737bc8106d4bb4c27ac4ac7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982decbbb062da40232398d8fca00fad6fd5155865b5a83610589690d53f13cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16563f4da71c57c5b348924cbc8499709e46c6c72ce690f48a8d816b405acf6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16a274a0c6bf4db0544bb6711aaf9ab12d61942adda79c717d1509b3167328e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a439edceb7287d65872626eb437410c8a8a179d5ee345187874dfc24f34ea258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd13bd9254ee5c6492d213dcdadce63dd6c3ccf8a5d7d3b49eb23a7b70ed76f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c2f71b91b6150c1d544e81afb18257f782ccaff010e9c1deb4875d3b494778(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d437491dff02c6f7f779f3b7d9772f75ff1c3d04e5e1f591183441d1b10e1847(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7094afd81e9b542f01e68a97f2a86507e97615a65c6ccbffaddd1906114bcc70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__119baedfe617e33e44a7fa0760645017e9d736d47c7c9c0469e65ec45e8e726f(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2717fc729c5fffedaeb3a3dc7eb69f7c1490d7585bf4cec3559ecbc61575d6a(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23bb52c72e7794387c0d6c7cb9db2ae02e2065f0f2686bc3c74e6b1c015d5a9(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc1e9d8644844314f0aa9cb8554ddb2286a702700e80155c20c79669343dfac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94c2ed2820fd70c67c1b7aec9a8240bd407841eeac7133fc3dde10dc5c3d8c4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1746f24fc8ad0d89df5b3a7bf024e2451184fffea38072e0d2ba86b45f14a21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca81023a3f67f498aa0931205b89c3ac4287479ce3fa62f68906684c0c9f82f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__477ad77cfcdef964cff132639c6a496ea00f67432db91e3eae248f05d9b603a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc27eeae92e407d32ce9b1199913fbfc5088e95b15924312c4b25a25a569a6d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd51c7bf3a1da981862eaab412bce12fade180437c0593001906f0f7886bfbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18dd70970d84f4232d85eb944805d1181954bc4e74a9240adde9ae8d3e841ab2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd8d5d2f626ebe5f4f72327552202ee599125b21d3cef584ba1bf0dc7c09345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4270166190219dd76c8bac85603e188d58ce1d4ded51cf1bef58cb6d09682e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14eb871c283c103f143f587fb6edd078bbce5e8f0993b80e7aea6c62bbb8512d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b733e0a89f99dfee1e81afabd37587f1264021a100cd2338f1302b5c1db8398e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd8b5aeda688e0c6589f63b94eeac4e528d64966f6528b9024dd74c30de09e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3dfc309ce2555bd2802a5827ce4de67b26234ea44f6512d01f5f10b62ee5e46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__979710fa5f37bf6dbe4510a0afd4221793ffd26f64970ad19a3cc7554e2c9201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150a11d50827a40e1bc2b9143aa01863aa2fe71d8309bf2b46f43aa30f41c33d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c52577fb7cb53330f7fdf55c2842b271f6bb5d38104eb8f8792c65d494fac5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d24147204264b82d0c110e8bbf4afea4d57c851f37caf638403b4e8b303f166(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78df3913392d175718d61d31084d4e1236fe744739e3b789151f7046fc8612db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112854f4799cbe96f93571c57336593f1f43dd873135ea0abfd7dba5812e4455(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e8c10829d1cfa8de63a079dcc1d14f4f33fc30e1d4393d6eb25cdfe69c1381(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f9a1d1f9ba3e1ac40e7ca1ec3d0797f2557b2fe640730e818b1c6770a0a1cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9090ef4633b4292536657643fe63ddeaae4faf7fba3a521e9b8b60aa558b04c1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__439af0716a1ffdf1e04cd1f195d66077c8ba682243b9231ee503fd3141515e5e(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da6478692df3342da4a1cd2c957f698619e6697b666ee9d551e268f7b1b7cb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241295580401790a8fa12ae38d2e5b6ca5837237e73889bb0d7adf90abbd535d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2be4ff83f6fcfc3237f8f6a0ff4981173a6efe362b9742a127f33b15551b31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa99d253d2d5e0d3e87ac4ecf5686546333b3111f666a62ee3be18fdf890d5d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac4e202a95c0fbceac8f984527ad851a733123af80e722955a7acb6912dfd2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07bd417f30e28cc4c109d4aac24c1efcfaf52b09ee82a917e929c8224b6cfd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612b858e5f9cc078bde381e98ed44a244f510a7d6a2fc2775792261a7a162c64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c0fc1b30358acf71e92abe8338becc35185f0203941c8b3b747b2202a014df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d18763f6442020eefe26175889328c6042700f7f32dedd2d971279e2b6d3f9fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f251edc362f2e939a67694e71760e046b10475b2cee9fb7b7a214c1dcff92c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd30003a8a8c0caea8946211028fd7496b5e444ed6c3c3e41fa5e3e1360736e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08ba549ea0a4bb7228d584d96ca47dba143fd55b43d73375581b9f59b5714fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cecf1f13252a9ed3d7679fa3ee2b76beece5763daef70f1bae6a41df5680eafa(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3b62fa26938774a40d00d958b93dd8823d5b2db3111c8847e7ffcc6a7be5730(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7a46b71115706192a8370cccaa6ea02e7c34be15ddd9bca43b04cb7382bf63(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b39f27be8591e0a1d6c1c1de5242f198f7260473b586eafed54a52ad09a8191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b6ebb363c77b485f269f4d8f1f50dbbc6ccf5f89ba690009d2a4e92de04315(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6844098e5831cba4c682cc615f5018b16446b00084a53ac7bc15b30f9e5087d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b093c962ea40414026292e823731ac63a087974b52fc4c7dd1c1442bed21353(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d61df490307636cccb19a347925e83971ec8a90fdcae7c5ff3430201372d727(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4107813e3455e0f6a2c85548e2caa124e77247018d4ebc7fe9f376121f960da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beffec9159927bf495416f2306054afbacbd338f5da187d9e42aafb21b31438a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f30fad3e862e9952a8ca96f40763b7a1fc837d130ec8925bc546d775d474c7(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc35960eb4860a8eb2ae8941c720ce860d3282f5a9f0ed3dfeea8fe9b3d1ad75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53c69c6a6557fb1182fca5208640853144194b0f9e0b71db7a70aa6a1efa079(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6f49defae85e6302773aadd2428ad1e2771866cefa6f4b5985ff57a1768bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0579440f6f3902e8ad9349159ab60f0926efc5c3d92eec890396dac0236dd475(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df55888ba31a17e547c306bcbe3561c31a197bb29a3384b3114e327b330f13be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c539bc2e283dbf99cddb76fb1d9ce8bc7cbd4e6c76cec6761c455cad939d9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2f13430d2bc02dfa30c033a008c2da8c4fae90e351f548003ca3c337d9a9fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444014732fa14cde1a4237064575f53325cff0018d09117310f4aa0be147d8b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0146199476089e5736e20c1ec7ecc88894994812948f80870605c5baa45cb810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26872b97f7df504e582a7921c20954c1c56618857853f5d3d81ad0eaefd66f5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25122df00b4b33939ae5efb246518d4726f280a45e03255d69c70cc7961c6f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3d6d2abccec6dfa366a61e57078269aead7adcfba177924046a90ea52c76dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612ea71420f98a158cbadeb92a9821844fa2a5ff8145b23bde8071989d8eb65c(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebda6bd8d950f5f3604682b20bacd36135399997adf0a5b9eec75e303a08c387(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d2da7d7e43aa843b759afc9c1bbeb90bc5359b590b218cfa12d4c9b96d7d5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f629af02e89af35bb32a9aba3dce034c7ad6ffecea2f5196fa7a2d4d8c40063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebd8b7a5a2e5853ab6fb5962cad2cdc0324a71c3dbd990ef0c9dfc2634ecb83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1daf198a9aee7aa81d5d5877cbbcb584de33e5806aaa3e8e2b987f3f33f7150d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebe9e7006e196adab6070ad61766c303bb10b8faa5c51b3eef7a911a6d81b01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b177f2246ba4999d0b92d84d94ff2d5fcc47861c9afea86dc52ccc7da65a27ac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c18d44e450dbf5ef6a2651d33c92f72efc28d0bd45dba2ec9f218f440cc765(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee208d96a408143416a381eeb92a4aaedaa04ea7b7702eba4547779b89262848(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d49462f04e07a5bcfdd120f0680881cf5b400558e282450c20b14a92dacce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ade7abb19d9c2177f360e82640fd79735375c2cc7d307212b0fca1e1da66e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7580fa3473b5ec248e135971911908bab7d5063ea962548c18fdd405276e85(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3facac74e4719c09b3e3d997cbe97a4ac3640599aea7579a5ba2e6d4d8a66dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0490aa205e38db99e0f8d3051894802d1febdb9c5f31f1753a9e07170b59a77b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f16594f9682af22a7f8639744023f99c14fe0667cd6dd7e5820405d462da10e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e332b68fe1e4a9324f7fe7d2e0004cf5bce6a59d29be33951c8fef306186086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75438a2bd922227807385d293638dace84290f550b94d55b7bdc9aa5b411f206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb20deb1023201d2c4d6d7781bd8bbcddb733eb8bb0f2566cded59560fc402bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847a56fb4ae9033b9fcc3397291a4f29120a31f269f7bf46bc8695e38d0044b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daba4e5cc735145aa91412dcafe5dbe867ff7fbff0d63565dd0c7e377457ba68(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916739f2e3187e162dec9504a1d27525a27b2d5f5a16f4553514fafd97e83c88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3080fa9b60dd94d309e1187656a45cd4aa292d5130ea72ab9d4abbe91b32c68f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6664cdea50ebfdd97b7904be30a7d52ebf29f2568ebabef8d7d3d8609887629a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c308846bcae6b953e566e67b72128abadce4109be20ba3472341bd934388a0c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab394d981536d91f85a287f79af7099546746cf0adb2a7e22f84d0ac67dba0c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715f7449852beb27c5359c47e1730c8658d997a8a0c61198650d55cd7fea6a26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1999934b4388f0cd93614584b0aafca07e6cf428f409140d4778a2c3ac85d34a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b67d9da7bdb3b7f9a3e0b3c27af4c4fc0499ebddeeeea079c3259c4a63a62b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c9de023e78112e7a2cb6ef842afb43734a2acb4b041f73fcf3f8c301c0c9bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3dd3bf21ddb097eba8f82ceeadd7b052b8c4aefe99db8e3f9f2570281c0b83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f41236b1f22a1fa2f1bcd720e951ed4f7a7e5b24b0bf04042fe0a837f5ec4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec1e53199f1dd653f5e64841d0b01d9b8fb8a645a6562371071b6aa8da299d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94170e1e99ea9f2a192352eef78913e3b6bf2ce3a1f8fabdcb798d5bfb6631ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452e9a6d75b2b390176a44733fe31f67bab498c8a6427206421dbcccfd83ab92(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29900922f10f713a885c7462360a965f31a84cbc21eef57dce02475b4dde2131(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8f8b79f9ac6abbb03d5ab4453349d41f8d9c5013028b9a385b55917af6f5f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a16cc0da85885f19bb70e5fa84884aceb52d6df8ed1fa9dafc66f37f4e3d6a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431a0deecd8099ae40223b03afddf4f50f0b8bc148aa01844819bc35d02da00e(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e56045d23239761a79d6408484feb1485e05b8e05135d782f3d78397e39f588(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9eeb0eb3ed8b4cf0e5d1e3efc6b807139cafc8a0efa9ee77711b2037d12ccf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10bf284378b960784201af08916893948abc37d52675c18096ebc62acb5a925e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c98f03886acb04e9bbaacd8eeb9be0a4d6521b2cee07be2748f17b62f25cd9d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5bef4a69e391c44c30632b1ebd0ba09698144a2d192d909ddadf2ef3118f89(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba6be429cb55c8a0bb6a5ad76237bd39c71ac66adcc35a0401b19eaf94503ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea75d5d15ef4d21d4c2c5bba3a927c51dcf5edce42360ca50b8b2157825ddd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db4d5e45811dce14ddaee6243902cb4ae5637ccd6da2aed04ab820a9e73db61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ed804cfefcedd3679aa86b468a0553aec18e3f4770809f39efc245ac09971f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f2d6286f6658879f12eadca70aa6de2039de61076ac3cc04a5e9ef2667e8b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bab876493ff1a4fa3f77ef40f489246421e522d12a3bbf8f385f6e156b63334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb659c328283c4974bdaddac595039bc98e18efa541e706fabb58de03a183d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc05cf09631fd0e9d7f7852786b2f59b3d365ecba30722339d63d2061af198f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1915aaf58b0af5c2a5b97a63afc7cb1562584f1b7da48fdaf1607012191395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd641ee54f70fcc7ef09a00aa34418bcf282214df4a1a6112d3338607f97f8ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51525bdbd2944b06e2ae551d4a391c5cb48d183895f27ddd34014ea37b1ed0ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ed4624b399323897ea53284619ec2e13322fe8b27fe6e004ac6e66ffca3625(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c454795ce09b1b50eef945032ac5bbcd170c001b660693a6a7735127543af4d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07d5772d734aa2a1662f3c1f865f53622a94dd53eaf64a305bac363fb164ca2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9b4d9b6696d1b96ba845e021b00f9804ff52b37d1442432f41870fb8468db9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a8bff502241145bd8f9d1f0b661431e1d47b28033a560c1eed39893702acb1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79bc48a7072a27e8254806efcafe489c10553b905323d5f94b19cc044d037be5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c8971465ed8c5be63de808e25c8140646f956c9863c86678b31d5a99c3d708(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e46215850a8aeb02bc63e2f7651b87ced0024baf019692486bdfd4b6f2cc54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32f1f9e19dccc627d1e3378f57ca6d8e143a8b141585154b1a0bf815b3db1c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d09756e6713c7f547fcbba74dd4c5225b03a994ad4ae3be754bd503b52b8d2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab9ce6c0c0305b4623c0cc7a4249e0049a9ec2e841f9f4b4355c2a56ae8c628(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aadcb5ddeccc76f027f329ec02de2a07c28161a175e3d4a13fd30fb72e7e6b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0d9917bc0c7a8b0118d9ecf4638d9a3759ab3b36b4a3e02018d11c572516d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6534d583ea9c6dfa9c7977190a40843e26de7a977052325f0ee7c704b6d122e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7476d3cca83ec059a60f6bb751b9dfe08436b86900fc2cd6d8f7a258689526a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c134db870c76fd3055ffdc17765d3a74ad5052aae3ce75cad56fea817dd1e95(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb4a6917e4fc9ca9772d612b7455acdc1a74a3f24e0e7db26c39cb7f35e3f96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47dba2466dba7ff7593794255e63d59e3a886f9907f1ac272d3eaac77804af01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60ef49dc60fe3f05ebffdba9de0cfd7e56bdc04f333507cb6459e622286eb7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7d95ca10c0e64c02f572842ef49d7dd71c73a553dd300f67066b3f6da52577(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1303bde7ea6f7101a003d3d88bb252007a1c745f2ceafa65f7033e200419b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ff4444e4795cc86da0a812df451384fa36a24841eaeb518649ded0ad70f77c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204ed070c5aec9e0e0edb8d2676d20a66cc8a8f75b0d52026f2b3ba71baef78c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85477db25ec170f80596c1fdeb976850cd0070eb0ef715cb22ea82f293fceb8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa75776429aff9704b4114cbdfd203342b7f56fbce9ae88e1ce3544b4676e48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e4c270f700932efc5de149f34b54c43da19395cdfed9d211a774137520871c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6cb415175361011d8da7f3370c0da76b242d03f37ec8a1fdef925aeb960337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0418b401dc2df382d6b95745bca095dc8328626d4b57c39a3f721f682817d9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6603cf5146730d480d1d72d787d6a712de6cf8c6d1cdafdb3e283c21a0696fe8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833fce7132fd95afeb2ab3a8edea0161cca96b9a9ecd1b0321466513c0a4a20e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c658b1cf38d6c0da1d7769ff498d50d17eeaacd4dd88e2f024ab18162974b7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be1eb5886e99a1412ace0db201ce54223f32b1ec8e53b5f7545be03b24cf0a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb19e92b38083599d1ebb2586ee3e3befb22c66e2c4fbf15e69c6b1fb909cf0d(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7deece1cec1e562e4a6c9ffb463eb24fbcbec3a5a9116bc931e159a3bebf4c0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f05ffe6ae1fc30ec7102964b89aea0de635709416d0e9f42c77ac82356937d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8120b7b5ff8327c46c0450d235d917299c7ecaccec0d38f573be44644d49292b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59632e511afe62e9e616eb8559d83204d543aea160a22b9bcb2728968d35aa24(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f792931ee37b5c7139cc72979a8ccd7b4a004519dbee0600c422069b4a6f7fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403f22ebc5c03010f9fb7eff2852256cfb2181dabc6ecf136ec7f3861a7f4f15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6b838e58da5b36f57fa49ba1e6fa98457eb519043f184cf8837e991fe73ac5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83519acb42803447b1baf1c52563e8a63145a4159466fdf34e9e0f35c4aac43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d4905b068e6bdc09f7b6c39fe660d47cedef878d312a8cfa112251472e8b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f288669488741be195735b872fe801c0fe487ea6fe6903e903b9546f2de7680(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f96c1a361fc4b36f52b84ad79e581d7859f52dbf9d33c740cbbdd6bceb5f24(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16231d23fbc8774e8e3d37ab53a1e9be4794a62a75b6c2739110234045ad07e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c634dd2778f5ac637e000de156b2f9fa14f26f8d15556d70fbb27b320f058aeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2291ff687024df2fc43f2f96e7aaf6036124e6d68dc02e7fa4660270e0a066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be5ac4e936c221d98cb5b0f2904aea9963820d7e215526e7cf9a92322a478ec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4400327b826c16d9439e3b0eda5136fc03559ca39282b32f7dde8afffafe24c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__affaca59428f6073fdb4a8f2991c159b34453117b8f398f23cd5fc4dd5f50ca3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7de7ba6b9dd34926c15c8b5a05869ae478152b51ec7bdf116c7f683e23993c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2a7be06389ee57421c4bc2a40ea6891bb12dde949a9a98ad17290157130a60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fe17e580cc685e59389f89b915008990079407893e289356b55fba34bd6ba9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a034343a488f2a7d28aa742931c131baf1973b2a4a10932fd063fa236cee27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d905d1de7e4ce659c4761950aa0586a2ddee665093345c37c592bd784af310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6636d64fb25d48b7f6db3c40cca818348d71e22779b39b710d655c806f981530(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6b08cc0542468fb338a333c245f4a83d299fb4960ab5baa097d4cf1d0b98bb(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a176dad0e542b836b72427d8ea353316109a5a144e445e919fb4c4efd6188cfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ccd963fa5bc8f199c54cc9f0eaec0611f5f356db228620bca3a1212138b596(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5716d464039e4f55f63f34ec81cde3c6000e1a16241219c875c44166833341(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ee22ac0c158cfdb7b6e7d8e1b77b7cb4e06bf7167fa198354a2b4fec652601(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ce204d08ba9328e1e92af7e0888c1b021b20a64f0e122b7a8881b1d440a91a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f5ea521d0ed01e953a190ae385ad4f07526a2b384beaddbdf955dfde2e8cbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c9a4ef50ff3ccb701c812a1aeac201bb03baa6446331baf9b1fe903fe58f59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55bd47f906eff623d121b05a82e9aa8ed2017ad3e2d72a54c7ae3f2c04eb336d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38d4fa49fed75ff4c28d41493bdeac8ad9ba2010e4433d49f78465db57143ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0534c461fcfa61de2c2e0d8f937edc7dc8696ed614c4318f7db24974b2bc1afc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d2364d4c4f21cef3bcee1ad833f3a289711404543631228b4851090e7da8d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d191bb3922f5a1a0592d154a6510753c25fc7d5e504d5213c96a3cffcff44607(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e006d4b2186db5624f9cf6b316b97748424407be3c1a5fd8fafe24709ab6f3(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c19c5105949411a48f44315fdb57d69c0b3ac650666ef7aa92de3534754f6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78763f2d16018b8984a141f4ec8e1885dcf97103cd5c0e4ebc2d22e6f9b77045(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d00fa516977683eea49f31cdb49d181b9d8dad8cdc7108eb71a2cb5f32fb85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e823ae60ac9b877ba438fd01c05eae96b80e6d3a78e931ea29cf0b722f150f5d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128496bc90b83bca00aba540b9112535550baf1f24283fe601ee4cddbe318a6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5576782c3cbb2c67e3a677957ecc6bf29d93c346f0edde4f679b9279c675436a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e078bcbd59a366c71f4250a8c0f0c28095797d10a0ea452b22d0010a0165fb38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af4bfa45b5af06b0b0a7eef57353f3b22632418933283020ec5bfda65b0cc4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1b3791d3289b424603d96fe512cf9d13dbce4f20352636c41f58483c582d8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a30c8d0283a7b0d70c299d2ba8335c5f0541ac172173d8b1660b16dc1d24f4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333b7c565ad20a50d742d53c9c3b2933d1b3b6b2613b711ee739a551763b06fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__990615a7bd5d9bb52409044ddb5cf07e644b3d49f31265fbf240bb9076b5fa1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2709ed24d3b84091c4a8bd3fab0591105fa048d8da40dd8a155f124cfe3d901(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cebb95f34bcde89e2d1ad0c3b8d7fb2ea2775b8d84b5ab3e578646145c5b2d09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15629047cbccf1a04e234c8257c28f7b6a4c23074debd11f7f034d78aaaafe7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53aa323cf84ef390a66abe3fd7dfd616923f3812c8625f87f8820e608260a037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c321a4a61716e618f4c6d7dec21de0d163da491b096792bc80d92a56810416e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d60751693042418e0566d8b41ab37c2a579d1ff7ebc86ecff7dc13f3c0098d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c2b75d5e1448c1b26c4273918feee7d066066f726c9ab297106c12957b81d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f64079948280e18b294393b1de56f5fcaf348aa0011093782b832ad3efc8505(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1516c28a76041e8501cac1177cc586a55773ba104d18d5c12f31551e7409ba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0173cd1afdf7a31c69bfaa0751fbce520b8ea1a0b96e78e6713eb34966f15133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1fca0f1509239f98159587c79da344b44efe2c6ae9cf48513aeefca968fdfc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ae78605c2b45946591a1118868970690a90acfeff092c12217ae1a49173fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05986e7f8959f16f660ba41ddde7a96fe3c676d3152164c4329db5bbc89f7aa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28e04fde50af1065a7aa62ba5b33fda618b8052fbd50c6cf97fc91642a7fdcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9515faf20156b3724480ba3d67ad5fa3a63c1580b1fdf541d60c43d9a349c11b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b674866246dcf1a07f82ab4aa8fc79b6c2a81fc8cd87a41efe502847e269f48d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9836b48e5a3c60ee03424636c701577d927220cebeaf81258b939de5813635f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963e58687f09b6c46732a876d272d13ff6dc7b0273cff1916e83cfa98649184c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d671400524dca014cf02683d24d88345de1809693f8a5687843c6f104d62ef15(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06572302cf3c5828a42a58166df31adc0dfb74d2855eb4dd73e4754ba18811d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf64887716c6b10566f56a00246048a984148ac4d38af6165a89845ecba4792(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521120925f6a4f76d4fa7caf6870651ba2dd841a9c86e99422b81bc47838712b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a9cd19d48aa87d1f81b757400855109a2ccac964d5e93acade3cc0da2793b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f352cdbf7f272634d2da999bfeb3733d461d5df53eb10dbf33c8b66e011382fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db05bc7a9e7a41e7e3a7ffbcf50161833e0fe13688a6b8821348bc4f0e4613b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7dc96e922078c0ee61a503dc5656de8b184d03fd29ae5b126867e23f470de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0461c5b47a0e19e356bc9ec7bd4141c48b3b8cfd122b81b073a34252be4c4974(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55c851464f895d2671a764fb0cccf5e2d459993e59e3b96f75d9023250ce802(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bde5629c882de9be77e695782381e73e3f15964fdb3e17000d570a265137e45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b340ea7ecd64d5d153334aecd1aaba6e07ad0cfa7878f7882605c204fbcd770c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade181c6969025543af15200f0c6c19b69567794dbc65ec7ef664d8c093194fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f79106261c0f3cc2566608e365ef21e44b8a730e2011cea7277f4ab9122b75a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc7e97dbf01db874e31375dd79dca550ae1bde8ef945caecab9f01873dd2a72(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4367f2f09b55a15d18c88d72a3b583672117c9408444ded4ec6b5b13b0574d08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09829387e0fcd44af49a75efeec284a6c078470a0e0f608d1c2ab762908a514a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a8e053bd43f47b0235568ce9b4034ac87666c4f2e215aa04f1d6176f7a0efd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2b255e468acbfd119a4f9227d1b2f70581e20cba510d27d1583e8dcf5500df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceae7c3931ce03edd7b6fc9dee4d3d949c3cc5bb5e4352e204658e5d353b05ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df8cbea5a7cf550fd8c151a2eabf8ce70adc53c839dbcec1a1edd947a407d544(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1179f82ec40b1efac585da8adcc83fc588a58bd9ddbd055d9e7aa8b11c0fefd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ebe09d939926c376c2debf2c26f30df14b493e38144125af8b7bbd2c55e72e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97cbf591b2063fd5d7fa87e50cc8256b792085d09606b8d9dd589efebdc11e78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a7e9d6c1f551c25813f541e0004fbe7fc6daff74da2edea66b718793abd435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1494d70b89355325a23d07b202f06e6dfef90cf6978a0ca634151600fc25e46e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20c5ce2daadf78f51e85196664614497cbe877d82bafc2d4403900c2fb38e5c(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ea107865bb0d6adb8b3f19908fed18d38e86a0f07b19ad0d9cc1989d2db39c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd52d5637ce6a75ec1e1674f33dc2091acd922322b89d775a5da69c13d0eeb7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1bc7cd9dc8ff882a64782975e40282c0e1d3f6dbb0648824bd3a2935871cc05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84a6c6c5c253dc79769dbd1fd247355f532290238ccacd14f5a2b279621cf99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ebd41e1125d40ca0bcbb7ffc57c20e715285c9d5304151419245ac4021279b1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cbacc1ff2721f841851318b23b22f1c2bcd4d197f75719177ef7a7e57630bb6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8e3c38a0e77bbd56ba25969c8a9508d24b7a08c70e1fbdfe482c03758a3fe6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360ff45fefdc64e0f99f8e954ec5cb04a2e29d8622180f612bfee4fe191f4788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b5bc74ce7580e6692fbb43658d96694d16dfe9d1492c46bfbdc3795e12682f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c037ca9f0316a4d936f4be9ff17a8cc06054ff2661999e5edc3bb92a113306(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac5e7a9485332bf0c626157460db3e26cbd0d13d15fa69dd09531b1716e93a1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e28b3fb296a8eb2a525db8e208842041e693d35374d53e62c66a1fef3938af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d881906a641c1796354b1141e75cba5f60a562be3a7c8e6ddea158ec1b1ac7da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f825d42bd8353b520845b0b945f6843339e62532fcfab5bdaf662e88e8b056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b40e2fb42fb8638a27c6377d7635c670e72a9e69e51e800236211ffb32f3ec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c7a0281e63ad6f2fd63dd59eefe0b126ddf098392191c5884f4adc793e8386(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871cf16056c68fac4c22c4ab1455b3d02dee8a5dd621660c160b9bf7d6de3053(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1743b66665c7157241a4ca684cfc993481f8ec604a0ab16aa07c56f54bcf382e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c341d13e12157b2220909c113d38d2da5d81e106eed65172e97aea4cfde2d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e85bd0fe7c0539b03cedbde61c7f3cf1080f735268accecccae388d9f7a914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742ee1b42625504bb79b1bfcf8c8ef743c5d7586b9103d26ab8e00cb4fe510b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9717d7b8abc43cf46d0e3851126f4fca9d94db1764c8a3c285a98af9b634d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2ddabbf1237dc0e58951967f4520e64f90fdd9454584b52c6ea69dde585b3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c086f78eb2d85775c4d71ef46b6178f478dcc6110d58ed224729bcb1e15c44c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a906deb43041005ad0f8dc0e8b08a1f86a253794079b62e92eb1bb039010ee6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a77881591ee966fd51df966b9b8028d9739372c363920f6f0457914ec404ff(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ba41ba09a9cbe66262a02e5d278dfd7c5d203664945cd988b93bbcbbd653ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__875508e639b600259e063fc983c686b1ffd83460ca9b7a702284d0148b8d4220(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397f03f7752c179ecac870b3c36e3b798d21db89e0d9d53e4ddf4b9f27262d07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292520471b4b238273726c031f8fd3d8167b9d3f42b99554d1be222bf904185b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400e7cf86ccd2cbd84ae358a21898a6902d78d857a044cf83686e359a39c5adb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7cb11049f7bc4c5ae4061f5223a7bdd5e89aa36c27fa9abb8f7b9f693782ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc934de27ad12d540ab4866e879d60d4d4e2dccbabb53d07ccf6eff8d2d363f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2df71b36d088f3a5dc04b30b840d356fd2b8af5410e0d278b76fe0de9282372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f1d4db2ada7c649d745039fbcbbbcadc662eb12f8dc495e29b34af052301cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23aec8091e3a9398493417d7e3b51c23a87b4c4c7f0257eebd231110d578d8fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a262c4386a03a951b5e6be718aece70633c0909413047d02b65cb2d258b5c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fef669e188d7abe9b9597f5e0d0f6faaffa946d8f4a36d762bce1b14ef8eeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5eda77a1d47cd16727b57b8fcf9416a0ad83d7b73d284d3550af390e5f90641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c26cc27ec290574a07601cdbe28252f399eb91afdff7d604529754c707a3e723(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544aca1144c960a653c1ba48b42b135a9d847e6b138098bbd02c1e3e94e9d1ad(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8f255f62a38927421f5d3f220471da6cbcc3b1d1c35d141e1fcc8532c8398e(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8ef67a252e1c2de3eccccebc91bdee81ddb79363cdcc81a4782b34c3e94230(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3737d94df37a6c223f3ce09f5bf1c74cb20695797c2a7302c9fab98c890f797(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86de32da43e4559966cd4bb8d93d9c6e642ef5170273183b7b6230e20bd20669(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2dcf1cbd6f10d0720112393de5d3d862c48024cbf0c0bf86f46e7fbca58d8ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73af5a605dc136fecc1b6c241c47dd754137534d5e1af451c9f134814c617a80(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cd05d3e7ceb5ae7e06fed1a996066f2275009f1be8cdad7c2af680cf786424(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81aecec9dc13d579dbd2b284ddcdf5dbebe8056a9b4a19c92342f27b510bb90(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8237d93460f567b74e74b1a6fc6924acf3322786d970f49e44638be625e43b9f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2416d861e916fee92f8c1cf7c849cdb9016c0b2f450a008eed9c844b07d6d25f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0f335828f3d3df9897fd0248aa78e38d6d65e93000067932fc5d6368bf8fb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a024a34a5918bf2c584e51c817c77b6f39ff5940b2daef4a13a7bab4de65177d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ed42a97e4b12d8ff2ad15fe4a6c6dc778020b4d469439ea5981fcd9a2762b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eec16acf836ced41d2bf23365861c20bd4c74c8bb5b06a4c249984649638833(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aefd6bde119bced2bec6b210f84d151f632d92cd740c0e8a32d23b7aef3596b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cd5749bba10685b44a3e08ec146a51224a664d099baf895227d5f121539963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e287b613bafc20488754de9e6da63cc39d5823a59909fa94e5599bd6ae756f0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc95dcb8dc358a707ed2e7780f1bb1c3f5e2c83e339df17b50174a5d60a89f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70dfa83938c6db4468663439a13984c394a4622d59f806e676b871e71661214(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b484faf7a166ccbe73d88014a43a72846bbacf4da66fdffbc821b2b72333c53(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea2bec4399a924c9a5e135d3697e01522345ee44162ee3039af65a24b2496c2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f2a492cd84a3ce26ca9795b24a91b4107373d14818f2d2a7b79f5e6b86437f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67eb898636c1fd8ce99cbd3abe33af889f17a81523455c0ca6702d32a2571c06(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af52f6d54cc89edb23b0aa322a2532601e4a13430857f828214e6013dfed2497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f78ce5bc0617a5bbcae8662f54325173c3de279bbb4a5b6cfed3e0846d84d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc293e0255cd4420bc6ed7e553fd73494fb19378f1cb97f60d7ed94c5c49d02d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ea577ac6516a9f3b39203fadc0a8e446b0f501ac56ac88540e596200ddef26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c2ef2399244b4ac9dac32dde36a2cd3bc5a7b1b6632259aa7f2b696a5d111d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea421404db3eecf059116962fb355e4a4de215d3a801a7d8a36969602e4253a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c783ec9434b9d70e0b6e1ce4e0c0fd459fbb53991c86b94672e584bf9bed0b26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ec3be4c1d719d9841e6f6df2eb64840ad594a92e414e31e1bb0fb8cd38bdf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b21552b1934a5d15e00a9d11351080b07b599232ea0dbede132b65d84846b1ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c50c8714c15160be080b808b500a9089995959adfe10b12808e521a2f94308e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09135470cccf4b1a935a2323c98998a080f73cf1d8dce4c543f40a1775543493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e2c61605ebbbab555389f70183b055ce6fa2c39ba82c3322808a4a00e08ef1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0601e512067458e3768f71784a7dc521c378fa1692f63e1ba5daf37ae6838100(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9407f905b7ee033358a7d0fe380bab0a69fed44f53d46af7a10b76d8e7b3cb19(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c65a3af37e54950962957f696328edabe47d5977fec9e6a4c4e230937c444fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d470759e534ee36251a19bf80ed2a02945a7a41050e400b275fe444c788c4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e6665dda37a04be0077d5f4eebc5fd36d700ebfdd7e06a81a27f4f8af3fc9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__752561fb6002b255d9e7d6fb10b09e29817259bfb2a0e54800e4fbadfdcf0fc5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e935b717f8351a17f80196f1a2e3ed957bac4fec78ebcc2e3543e0a009a42200(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da06fa8877cdbedd9b2eab77dfd37f53be9763bcbf56e7270b0cbab84fe73f6c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7727416ff69775bef741e9274809ecc1fba401e1a7b84d4d3b83f27b87a39f89(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8aa57ff8cc77af7aba76ceb03748709a0237ec6d414c2bcc15e5fa259b873a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703e46403cccb99145879f74ece09106b0d3bf091ccb0c5af83ced25952053db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790dbefcdacaf6190a7390f06a4fd97a431606d38043adde7fae081af65b0e04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b4d293630db55934fc698422d0f025490ce47fdf4d74048487b58320662329(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76cfb7dc77cb11a71ac65959df73b3ee11ae32e516737bbf7878a8d85e666755(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7f35af54ef1ce6c47f6c1bbbefdd2c994dca794aed7e507b1a96af23f60cda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55f647be44f583308aae778c2b1764f1713efdca40b435b16ccfa30f0077315(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87fe7683a36e4151751c97b4b9d0d1487fe7740fd91941a6b5bd4ecdeaee3c31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e987b30634f7880ceeecb522633ae822f14c774a3bc93f170057da0bdbd6d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d901057dbd057378e95330841c2b1d7c04fc5d2a55e7c9a0a0ef1d30cea964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689b14b6e61319d536689f4e7cc2044bc1bb8e31bcbef8e17d08c44861617f3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad59f554ef88359f01d3bbc256c75a936a2d387341a49ef29afc24f3bb81c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860a62505c7dfd9d7740c4fef537fe0a1a2b60b3a6ea227a6b444653b95b1d21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8234338e3611e8b9ddf2393db4b736aa13054e4c9e968b9b7d9208e5afc5fe21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a848f404a47d26b06de8064a170ab1d17bb14dceed91d066925794efb2638caf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470ebf1f4488fa596d95527fd6a60de5735f03ee372015d6b69cb26381c56e71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b85a64389bf1125801dcf47b4944de73f42dca12930f5cbbf4a4cb17527c5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ba26b26982240d4c5983987aa1f0541bf54b9ba33b90e98de35ecc5ef0216b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfaaaee5e99c6cd39c489d56dff68e7e6dfff2aeeb81e199895cc3a56d8fda6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905102004a40c3e3e48a23875b181fc671db2c2f71bf999c3606a256bfed065e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ac7801e494b9ffdfa1e5a3610ae8b067816cb8670d459212de53b80e144399(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6825d9f1f284e035de3744d7ef967ed0ed6aeab6a7fe03e6aaa0c8b79d22e27c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8f3074fbbafee44a20da231f87288bfc0e89dfdde3232dc1b4eba523b79743(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425b29b51b72b39722ee2ecd3a1f7ceb8a6918aa2ddb668c66c1eae53f23f8ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17c28083cfdcdde907b8a3787b9b68d2be19c1c933344aed757ca2344fa43847(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5167096d77b42606dbc6547aacd549f7203cdb2ea1c08092e3e98448aa9a3042(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048bd55b748f2cf5c231d1f29e8c0dfa2cd23f5deb07968100bb806f5f7a59e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cabdaaa9288e6c232954db1caaea8a46cb1c8ac8a6eff8504b633da7cd64b97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fd474a5bbfcf451e7fa72ef1fe73092bf9a8505216422f3b1dcb43493d98f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc6d3e43d0b47f0bddafd664892ebcca79039c7d3e3ba7b75fb54f61d439d5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba21365756524f08bc98de9f835371ab0d31deda524e59e10071494422933a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7fc90984210978ac3f66e7367a75a95fbeda24d18aed3dcb243923c45cba75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca7d67c172ca5a6886e9c24e1e43b3775c4c9d80bd18de42b971f85f95698c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45dc7cd87cb91e0e7f958d4d8fb515b23922bcd716a6efa620d503f0d235126(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928f7aa38310e69f59f9da817b2070f69edce433c53a77560ef76d7b8fdc8515(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c45467f3160b8bc79fb0e6d64d0c3edc84d763ec6397a989d9ea9364a65366be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a657cca15f4363d19ce77954918818c15f6ffd1c2a15901025b7fc4718006946(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd2c0a34851a1a80067cec1d32bd3756aa4c6d721b68dad5929ecd58ddd00f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1524b45156658b1126fc30b69ce8640e0077f7ca90fa131361613777b1625044(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b27635be36d432029e7e1b11d6631c56d17c5aa3cdd22a92280629910fda24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__794e912b16c28d38403c3c44d2ecec5117bb35d7117191945256c1e4f5b4145e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9a8e52c7b3437f5d46006fa532e948307821df1d484011c027083eb4f50f11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6faa2a079ed8b5a5b30a346b906c7d99aeac9ea9f13ecb86034d53f668332e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1ff785722595554cd9467ffcc84043340206383571cabefc19dfd9554ac032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e4e903cd264c8f38819384372fff681fd18eac883822cc97a16c7dd27221c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39dac0768632984174b1e2078d20b9ad27bda0ddc05f3a31f082854941e2a895(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8231c8d3d963df7fe5b62c4eac1a3b4e23e782161e9a25f321f37c5c16a918db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c084f314f742c033f64f2e60f3d7c87fbf347c34d04f21e3b711d0e85bbfab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34ce4ddc51dc7c9b7216308b07d5b14a22d53be9b4c09aeead6794d60b0a28f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252233160d12023eb844426bc8bbb3348439a7def092ed789c9240688ea5bb94(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f39b65296659ae1fd32747fe51507e0b8c69767031bd57f18afb97ab184c4ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d5d28451f11557174ba8ec19398fde98c7587a9d48c28da24a9b78ea755419(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac33dbe3031aa8fef5def3061ea263fd0f906dc493c5a44c71260694a49ccc9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48749387a733f197aabba30e2eb6d9b8b9f8f1982e1d6ae16fb7afde0f66e76b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c14586c794227249d727355cc23ea04ed1053fbbb8cd7a83e56edf7415e1d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ba1debab9492dd2efab41a2675f3b6ced908e68634152e30f7e988f0068349(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0a8b93b6df5a35defd72d126419dd131ccc7bd48c3d1e2145f3ce55e4a1878(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f724ed0b01d45692322822806ddc3305f198b12443394bab23a0efe1509abc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a8733af1d220fd80962f708e6671fadceea5aca6d9d18623feeb41a994909f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73616282452f2d11117d8bbf8495d3b6e67ad96e38ead1164f7051cec53eb59a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b00aa228e6e1508dc470d7c7b3a52d632e492f902f39a8117ecf029ddb27e50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24cdef171add0ad5c317b495857fd0dfb07927fbe37f300731ee35179e8cd5d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5848bebce829ebc42a36c787667283c4ed1ed684bb9cd90bc1661f742bb6dcee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99fd169f6ab395312d6c696f6b69c1e91f6753e3f0e49a23f6193e9edfd8e887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e64e64518cbb88aac8e7182985fb6d1aabbae4ff07a509878b1f5301b6c7b67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd76b46655ca146f120facd913d5b9b3e6e704c1796d7a8708deb0f048367ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab38906043d9b5228c9ef2b0ffdcc5e57d2727c427941007d3f3f61e19302519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bedeee4c1633d27218f51aa5119e5a717cfa3051229c88cc137299c307dd58a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339b60254dadf299d1a6ca0d9864ee297d5efc5a243ade047ce74eb0f9a9cee7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80663ce56607b52b9d30edcf4806b4c18d3bd25647c0e108e1a736c01bc4c978(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9842bb2ccbcdb573d39aac86f23fdeeb0d41080c1c9eef69d506796db4387863(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6adec3f449154f1c7bd3b0f381b8d6c61e4859187cd2e912712f023064afc25d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea9783f5f0b814143d0a1e990c59a623981c659514c7dca0682887bb9df3e2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61771a4d3a34e360290a43ed7d4ca7e0f7728b0eab706598aead65aeca748ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af2749100c5416aafc875872267ecef901102142886d09f11d72d3cf2fc9a02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5079859fb7d9e86a98a1305ca0001fc2c26b3091281c280801d9ff508d36f56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3fcd14740bf7de985e09c26d66919ce1202be392ae6cb489c7b66dd278a014a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44cc843817fcd8954a7d2518d6e9b2ca7bb6e323cde3e376aa122cce4614112b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef4ceb634e9b64a71f400496b3fc55cfd51198055c5474a5b07431ce3951400(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4481da3460ed481711e8dac82b977770c99f2a97bee1c00b847848818274171(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040775b89e04e8ac534bb7bf87ac3a99e9126b47f7a4e3587c431af77ff0e823(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209f22cb69379ad15c11bd060bda851c4d10ef8d40723171f4c044a5ec04e3c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662fd2646ac226cd1be924fc1d4c839e4585d9aa7f28e78a8151c03139714b1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6983e0c4301f183c96fa04a5acef7b10eb0630c6c5a71db00702b293827b024(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07dbc1c511fb035100d773261d748708e5c6d2f4dc50f93676706c627dd9430(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3161c6624538caa67e3f47396f5f712c244d728549751ed774a2b1201e72e6f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ccd2f295172527decf191fb0ab81f669d4c692cf1465cd5617b865ea7b41859(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d06ff3da8231fd1fa48efbb7d8df2eaaedacf875c954b0902cd75ecea5f0066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac4e8fc34936cf7209e6f538b31491c84375524767e701990492cda80206856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55711bbb8543de1f91e129c31a81d4359390cd8744cd733581fad7e5295bd047(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f07a5b07a593bbb216b53c72dafe46a2938517cd998ef396c30c1f430ba12b7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0fdc6dfa92f9f9c993b3d1389b2ce57ca7130ae5d0507c10f6198008ded5de9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a505994d46dfe0c58d28c2b2e26d941ffe4f43fce58b656cc9eaa9d4b37be35e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbf2a80b0afa1bbcf5c362ce4a38f9fd46a7b966b58a0540fa33d831b24565b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be42eec25de579983be33bb66a41cbd764ed80003266f57e167175a0cbd58c61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9707084e5b2acead32dc7e670b5a5dd372ae62335790a12de1107b78975fa3fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3f878a402d1f04985c1477a12cc343c464245e29ac4d3c27f728adce91c365(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a47f18021e35c03a9f167909edfd6aaaa2b4c1b7c187896ffe2f16f7106a03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adec7e8f20686150d60f27cd7d4811b5773a0e2f52008fcb8c54c172fa1e9df9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c502d1f5877d744d88bcd6fd074ad95f9cf2472b89bc9f95ca0733942561b75a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e685fa33e9a3752d6fe80739b6587445c96e2e6a2735bd3ff4f148fecff1abf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe02cf163e9c2b39addb9170a79337e3c0a371a74846f36671e3f83e4bc7144(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1a60b56c64d0b156c9539da787dcefaf4fe4ff8f670a487bad28d23d9216b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b428c1f0df8b4253b8197f21e9ceac5209cc49030e516a78a84ac3fbf64ad406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f5cc5f8e19943a7c97bf884bcbb4370a6bbe52906ea40eb28ca7d747cc3ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6456176c1dcc65b98cebbafa6911a64fe6666ef658de1e43a1c48fad84d0e86b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0edfba9c34f1df6a9a8d91f96c2081885e83a7f66c136aaa8dc000421492122(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acedc93b833aa0713ad8c6339c42c3e9b1fa95d3c0a6fc2ada9740612ba8b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b5988aa6e685c56a82c37d87ad6a1032cfcd5d8ea9b5a07cee1e8310772281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63aa04d8a6ac5cf29ba90e71140202df26ef1d283b70d385c4aeb5676c1ebd2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bb2fbc46a65119eb9592fceda3f63503a343dbe4c79e33b0d0447deebccc51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2892c1fd474c4ccfb78fb6d105b924aae023283c992d13671a5316dea4df9f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b73bd9b5caba123bfec1da9e24c9fac41ba3e2eeb575331f34da3b0017a8a9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd3e721a4797eae77dae6e1a8be432daeabdb533c51f6812b1443207a9fa171(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c7e9fa61c8692795ea90495cec9fac3a07e38be2e8c244a14937070d569f40(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82718b0bb5df121f50eba3cf9aad8f8645b9e75a5fd7a7c1e955b0719bfc95f(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bf897e466a576d39fb4d7d05846d750664f134e28939656cb27497141addf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa977eece2256dbbbaad1b24928047eea52e43edd7f8ca022c1d8b0a7d51a50e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5052ce1a2a2d6dc973a7c16e0a6b07888488551112f48e4315e89595603e261(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8748215b0937fdfc75c896ae93f80a01eb8045d25c8cc3b3adaddfe35fbc3e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491a3bf2e6001f38c3ae795784000b113963f0c1f1bf9ff2bbaf887eb7a6b2b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108d01045523740c752adef00a4a1a82b51b1a9a9bfac0dad815f4cb263e7878(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae6991423e8503160e3320cab784f42071743509434c188bb66cc8e4738630b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5b836cb7f283f0c375a4a94eb99766cb171c488704e8d11397e14c1a369bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56fc3b0b83a532c7fd72031c6fd94a1f97a939ae1b3d6f130d192ea2dbc78d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd935dc0cea1ee697d42d02cf5dfd34e816eb22943296ae9af9f6436b017cfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38a9195f2bbd8a10618b0b1ffad474254f2a6e449865fda56bfc04d0491da0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7141d15784af29ba3b63626a9994ede3e3803fd1b526d732580c8ce94b8f0fdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abaebd55c7fea74cdebd50fddf6a0188e120a8ebd70a4be69ffa8fa0be74867c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e26dedeaeb915914ceadeda43be333b401c6c429d6ca1d29bc7ea885952f89f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02612c07a5bfe4be97c83db684753fdff4c771b47780f1a4d1f6efd8fbb1ed52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5c62edb083cc404b70473cebbbb09228fa6989f2c1ce985f0bc754e936841c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f16cafa44c3da5a46d499df33e70b05936d68fc5c2dc87f7729d480dbe12a4aa(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f077fa1c04da033c4a0857d68abfefef1231c5aed1248bc7b59bce8ca9562339(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a84401affdbc3a0022e205998294586f38b177ce8c022eb66c48137f0130cc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e61ced35bbfe8a3a7d2ac2f6706780e15201543b6cacae2cf6fd6ed54e8ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6232ee57cb031677d1f8fd2f69f15dcdc65b91762e061a1b6b52a703b1fa1c0f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9723a716ce4737edf80a7fe9d82161f190cb664bb655b10e098ac1d0eb1d94dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3b4febf4536a54217228ec2e7baa8099c0b523f29b7cc5acd1be49d7fa3d19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88677a3ad35971650a2442911fd3de15b530274450196cf02fd3a3426f6ddd9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b41ced31ede73b2f3701dee2fb88e6f716e9db117c3f256eaced24bf3d6def5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5019b6a4a52736765dcd4e5b9edbfccef2517886e4b47bb7aa430515cad28cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7af377b07466d29aea58f85c191a5b74300c378a2b41974fa9ced7230d2a8e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2f09898a270ac09ac2a1eb2133ea92ea7ecb0cffa3caceb40556be10cb9829(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49f564d848045f9cd3b23d58d08b44071aa4b78214600f14620bbbc2bf6d6b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f562b547dca51d7ed38f9b30227db365a9b82f3442a9b717e4628218a4af1ab8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6508d72dc67137c185754e054e2348ed6028e60739622de60318d4baf5b5c028(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084b895df0190668b1f05eac6f02f7fbf5271754f228dd15691cecbb96aa2b8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a2c236a41623095e17c2b569feef6490280d99680ffc28125cd3721e698139(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1e55a0e888d310be6b8d6610692837490d03b19b367c7e4ecd0c49138f2cdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__542ce129bc3974092c3f32510c5a4a4176988e9b90dda369f56bc877f2af9c2e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b74e6893def000ab963c8d89dc94b8cd01a13d675126c9c20c143782ab6d8d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f8802c2e57becb7cedec10abac9f7efd38c47bf1e548a55bc699eaa31253b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a0b34055c60c07f4d400c548d44412dd33902e8d2dffa974166a765761b3b3e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c893340f63073889225fae1c5298f8dcae8f46d354e3de90f66213e7c87a4010(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cbaa1e7116f84e9a723985895d8002d3864d9ed6f3a2831606b0f33d1983942(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f130563c2354d4eedeeddce96c95208cecca5145c1a0b03c7b6a3908613976f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52489acc10d36c48af738d9e1a524d833271d776b56283d8008d2a880826a74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffbf4b6a39755b39bd9ba180309371d055432d05fabb31f50f4408684c8a651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d557139ce10e1730d4771f8c791515a327035708e4fe589709308c5c7b53ad6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0adfb9b2ea148d8be52d0d36e85879b8c40a3a4fd34fd7d16897430363e299(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d9e2773a007a86e54aaedfd02aef36ba2232093167cb2f9a1e4bb7cece0fc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a767f01fd957d74922f3e670e8c669cf661b8f9dd6e40a07b2322e17fe9256(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6725de368198eb9173c3e31025989c939fa8dc2cf189d3faa3814713268204cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8762cc6cc9c1ac295e70ebc245405d4503d25d93ec3e1134ffd83f6a713b4754(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9a0bd879c125503a9b70496c16a49f45406f946b0163dc58f3e6fbc3ab1563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e475144d36e792bf95eb6d747f850779acb53f5a7e9345850e188e08c1bc05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7264865cfa0cbb7cc802e098b66247ac92405c528a0800b287f7116e34b979(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed245440dfdb14478363830b3adbb1a6ef2b4555179a06b33ccdd1cc72ae0a73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ce619150dff5861c5932b85b0c9a5803ff47711b4d8805023cdd467029cd84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b434943aa7aefb413b90d4f10e48fbf3f51ee33c39477c47e1101ed9100536(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71df03848677b9538bcd08f17efa3a72b7622e76818ad81f1902e0b5e148f17d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1c823575ef46dcdd62444423fe1c6b94c8461be65e3acbb3e36ee4d5a48825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95de174178f59ebae23374c356bb7e62176a0f2bf14f49db8da80bc6149b6e24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e275da6e3283772e8ddb48dbc2cebe9ec9e6b370cc3a6ea86a1b6310eb4fcf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b5352817d72f0347fb45b803cf68780e8a163aaf55938060acd6273b26c118(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb793e17e10af42c988f249e2e9364aaa8b3b2ab9bc40f3e00db7e3e3db8dc8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82467be16c72e0eaecdca8cb4bffb4f5f4deba6151484163a50665b0a138c944(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc147c4adcdc9d2f6813fba00297c14f36e5e7a0da9979c2944f72eae498c78a(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573e214a08bf79e04febc3d9d4cef981b9c214f53d8d3322e541972f78f609df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac8a984bf8fb716a4c84bdccc3609e6dfb998e5065acb1e43106b559d842224(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178d522ff8a1f638a549f2150e30374214f4594a735a251529d642817a5ab2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6b3b573f12af3361186b228d4064a86b14bbee9aebf635435766bf1c871537(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44851b23116de36d7ec97cdcdedb3fb8563cb497895d5373b97aad190e5d5fa5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbee3dc97816be20ed8a1066782c28684796501db55370d040d72dcfe5b0d26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d9ce714e11e9887f4ecf67935bf274e78af622711128bcef835edb8b735bf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccefa90e6d1bfb57c63ac133a4edc1d87e7d62ad7bf3c9b18974edf1d713b7e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e17effda694574c3b39bde5f11819122b5e70f1106fa99f029581e014d51ccd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ffc68a9015371419061735dc6f4620cb46853d5f3221a5021a005b0b2c1ff21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ea54ac0666dd6302341b72ef4308188c7694582ad3767721aa4d78c30f177c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5f5dbe9471f2205ff45cc956d9029d7df6277ed8972c719fe39b556b516f94(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763daf3866c23153728333d414cd4fc6ce1c18ecc7d87bcd9e2201403ce2a756(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d5a2bfe7712c84bd1f648acc5d4cd6daa11386642fb42217d6d954df33f973(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ec4101714899e34767e9675471e5db1c04ead5c965db38fdcd9f26bd579666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d0117372007ba615294fef6c22deb421369bef90a930cbd6dc5adb493dea21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef06b50db2a75710481213e9191f8a17012b79c009067d0bf5a9920ad33914ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4199da4eee376b4a4f3c04b1524c87d4bb96d04ef05956c6bf8107d9e6021e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0a3b85cd44c5e5d538acee7f4f0e94a597dd72c6880d347be2930d42465a26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff302060d518207773344e62f3fac4f211d3d1fab95fc86c88f03342b02bbb64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19cf2363b5c5e66aff593cb8ebf97623ac033d6015dec0a3f1593175fab5e27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa3cc3342b740a157d6d2eebea2d10db309874e11174611a38dbf200cbc136e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a171a592d1173c993d8c1ad332fe23216ff7d3b448ed8870cb3e1d82491acbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1477dafa55170d88c648a23809509b888384c0dad3bc7e11478904901dc4ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6dead1eb9dc96b94b5431c76a21aece97356f72262f0818b05772b92d31b55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452201747a73f7a1dcf82d9075ba70934c9039362cce3312910e9bc6204970af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22cb96d0846873019f3c4b6e6a2fd51e0788dc1781cd6500fdb9fca558736210(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0e8c9762e887c3d5be542d6c7589d808432c6ec24d30bccb7b966bc8e9212a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484853c5becba75d7229a0a9af6cc12a9bfdf7517312dc0c3e76adf1b14443a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0142bb479d0ec4ed861f699819cd8730eb1182191bab5c437821d87702afa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b17b975c78afbe11f46af06a98ad56b37ccdf59b35494e663936c4be33b6df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9f06646fee40930ce59b4bfcfa0e627ed00025b29d4d0ade39f13ac349b770(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1ccb2b43631d20d0504674abfb834a2d3fc36cb2ef3d9e4bb53f8c5e9273a9(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b8f30249ac078b9de7981a3d17e412e0ae53e72bd2d1ec84505fddc4b732b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8f3278b0dda9ad710c3f62ce3a3c3b35568bef6013d6e1cbe8b4c57738e92d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ebb5724c2da1dc81f3ebf99114f28887ffc068107dcf9df2fd3b7d8d22a00e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47e3710a9a7afd0260818410c792cafeadb341ab78e935bd67cabc4f439069f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bd773c1dca7e02ecf9da6b9d0bb86e367547e1bc9630ee0025095fe07a76f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8986baad514c25a15926e08e62209a0da8fd5d787a7e44f78663f49a03bdb8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0adb759aee50dadfd13385d06e186c08ea8a762d11e3eff190ae2db2e15ae594(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04d4b595977c079139ff5465bdf8417440f2ee9072a37521e32b5450871d979(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5cc80dc045c30985571638200b45e877ce59c9d54b22df96803834eaaf5238(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b745637c3e1254d32ff4faf9b4d94269b0e158efa3d9376e41c4cd1f761bd289(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c90094ce7fbbbed060ed853f98cdff53b64e95775b7be4b1cc0f5214ff9f0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40cce89f3324539036e8e74bada6cb2039040469b3048e5b6e76de42a954eb7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70be3cab539a6323cbc6fa87a02751ccd6126d53a80215f90fc0686d7c19e1d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b114c97c312ab21b61116ba27cb98f6e24214711c694c8202cc74965105abd04(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8e5def942750f90e09dbf41189744a3e63ad4e4c6abc267801793dfbb957b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1523e8739f437b2089d05f67f2413474cbf76ff3612ccaae6568bc086c16af8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0832c96a873fa40db87e3dc0ff20c2493f3030b2e0c82ffa6dd6a119d5ef2aa1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ee39ea242dfadb88ebf917ee344d81b6f4872a714bfffdc381f9c802a26e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce573e34d42dba328b2be748b1faef826c8422c2efc37165307c7d4d7bb434e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e12af92872b6369a6b01d99d2ab978d7e63c6f3c8ae7ce4375e4bb1f0be6bbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1137c64d5baf520105984e109c38b80487c4fba6f86e753ef7b5c65d4e341dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555bf3e8cff40988ec4bd4075206fe9d007f2bd0a806b15f78779e3d68fab23a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a72f54e36e515b2c6eb6beeccd2b606bd0ae5277032fd6260c381fe80cc4d6(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd68ea4857a7f674a70a092d050f04b9f652b4d896d75c29bc8d79ab6a2767f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718d3f11b0a7977e27ffeaf0be745d19a2b8a2ed5ca11d1167f57df7836eb59b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5ebf1f896da9a5adfd07ce5ceac1753e46dcbfc40ff6a802a6b414e2417e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__592cd472cf05b1ce8fa59be9ff4f0a11128e935c39e3f02b7cd075a6a2d311f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__353ee7e1af6de80f2bc791e8ef2d9b7445b99f19238c7ac0ab7a7a1df903a4f1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad14e05f6823e9ea1ea8c71e63021ebc1e0d4822f3bd0b4f78fe32b8941dad1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216cf666492d3545d78ed03e08107cbc6d3269e798095f227d3146c5b031446e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__611a13d9f001b95f566afbe3fa3e32259805d352efb1d083b9f760b1440d36b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242c64d3a926f9a4da1773170419176e7f2d6ae1e850418347db4375e6e55b6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3369a54db8244879ecd2dd0a24bb4d28e3f4f369801a9c5b9575d7d8880608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9a6015a205c3dfa91f15e23d48b49e36db1ec279b59a2ddd28aedf36a1e9d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f254bd9e569f269c509c45d1984886e5bd835ff095aaf32bbc00ebbe2a4bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c56dffbf222033f1f4b9f7b1a599e2401b9c725933d92756ed27479af6eec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86fb00f4f5f53ac67001bbde2671db6ee8524999354acd0421667236f653345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f63fb5b8848ad81aca9566cd51289bfdc943c3a673fd3ee3fded400cd68b02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00676d25f3288d3da1858659fde5cbea0e56f2db79749f3724343def3eeb6b32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c33b87c830284322cffd279e50c2c5ff3427026b490492b73c4a0986da3ba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af723c57b6e70eba347db6627ecca140b076bb816de356dc8b183c3a933fbb42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c871fae59a46b903a7d1ecd1843d74177b532fc08f292be80b27a55551cfc3db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64a0e938d772a4e71c6210d89acc813dd3942302f2d10bb05d5adb18eed2dae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d799a36bedfaae83573255e19daf5885ed0ed1c1c3bac6b93b8df5535f8d1f32(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72bf4cb1201d9d4f2a96f94751f79040e4f1afa0f1e024eebe9b4ab507d56a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e7b18053a584c48737658c98f693a21430d70bfbce9685f83cf2252544f324(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306d0e9c07d726e5e85ddbfda17fd3eef60b150c61335ee513fbd7ded38fed72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2a89eef0753694b0d5cbfbfa083c93201bdda55b1906287b053b5a05a04163(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861edc15063cb278fdd48bee06c83d616523de411e4f381dcd610cf2a0a4e668(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab27d80b94d85f7be9cf08359af3ba6d5919ceb37c5e9193203ebe6565046be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b017a116919af6ef297743cbbcfafca8827a5fe68a3cd729a7c6e987ab0b566(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e7636f527bdc2e8c4e08ac64a97d511dabb148f3fa3507e82dced73983b5a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad13766b972a429db880d7e71cb9d3b26675f9b03730055a5f11d35ef3c362f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4547e78bdc95d08b80f5f0e75e15c9c45301ba0e4026ca716c957b246058bff9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe3538ab0a6e4e886c5e8d62eaa909cad0bbffd058b245e9e0e6860967cbe5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28799faf924be538cf5563dfc881b0f574ee0d5605299377883c3e3c0f0b230f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4137a380f55a0c78eb51d17cdce5452b02dd823fcd162fbbb1929accb111fe78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f25a1cf18d46cbf0d1d22a1b88102a82953fba5ea643a16a8a349489742b1e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbe8ad9539f8d6c010c0189b6f0b909efac129733bd29a1a39cd8fa0c90d0be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d295cf19486b695ef0165fa1d79c75ec46c3fe8f972f8e684f93d9064ab0edb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79be10d8d7c38c9f9c95e6a50c21779890c13e5f802c8fc26dddaf6b7d16354f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c9f7e18dc8e83a97a63b4f7cb1d5ce975227c2dddb60926c4298c03d8b02e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45964f078d6bc2439d90ccb1a0cf31fbc8f634d5b1ebe6d353793f4ebab5b0d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb82b0884e01b87196ca8632f330c063a7bf71b48620397ceb0db9203da9e98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e618e2ea0db8cbe16130dfda2281681a861bc39e0cbcc69cedc029beedf840c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5889c547c8d5db09dfe4482dd1d26b1ac6ae65341119335debba0cb683853899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183b79c7d676f329e94f57ae4e78712c5d9694d5dc9cf693d53d5e9221f4dec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba665d096042a5fe7af321b2b2cfb4c01d65191396016d83ba80f3378c27abd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76acbc224d0b5311ce7abf724e0ad438101afdc6d707fd400f854d5bc65b9b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce9ca2e649a04dc3f1b4e25176285c26d5db8338ac8a34ae05867330490d491(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc47eae2e713a995a2a045b0b8f932d75e765079a82a4bb218a37ec756229097(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9930cc91f89abc81f28ca98173f0ad7a1191c5b90a20c36e28bf6c0850b10f5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32f2abfe97983f417244ebddc9f59caba763e2a7d61b2e6a90c277880482c04(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428de4de5b6e084e65d748bcd1a1cda15fa87ba9710dcf746bccc9e98ec26264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6500dfd0fe350632da8022e8e09ad78b0b6f693ff35673eefcd857f61877c6c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bfe60bc36bc64f9c12059fa42aac44a5e7d1bd95aaf2df8aa1752073c7f158(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f107393d677237ed38b28178191497e80e60700f86bb70da900beccd8b79512(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca907d3cd075f1c5ab3a90df9e48a13718799b6a18176e9ed18f0acbe4f4919(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccbbc5885211c1899b813e0bcf87f1bf5b27d0aed240b5f5530f0bfd07d3457c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee9f60467160ada590b2096f55f828c33b448e1dd621d8f1ff353896d7ae267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d858e9e6f9ee67d1d2499b1e24499867bf7969d1263c74f57ef9a8f83032aef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd1560a36f4218cc59c0ae064742a0ded319572ca67dde5bfbd5c66930f29da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6073dbc5a02c0186ef174895791932c0dc2eba82aae4b013f6f9420d1611da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485fe6faa543574462d7189466b72e1684c3af6eb1e7901a1995f6b6a1b9ccb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c9518fbd0b84a80802768b1d0c154af649d4e6b240206ec00f1886abbdf65ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b60af1a77f4b5109300fdfa6f63adf4b7f582f1915c5a47f254f6c00244566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb40c7c497c530e84d06f8ce0a6786ded99564f7abf3ddd2eaa131ec11d1ede6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f986d2b5b8f9a24453917c32ca58c13e6f72e65566ee45bbebd2c91e80a202d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a803864283343f4843172513a683f074ac5eb4f6fed5a6c57431500dfc81ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e1dd9985b3030101f2dbb3a07a0006e5f30e1f072df41164f4f21d3de7b0c03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704ea133e396c3782793ee461336b8fa65c04326d5e6f500a6e833178daf9cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760c06098718969b40379f4011f5048e0687e41f16a894694c4ccd7e82692ebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad924b0640088790d990068576a703c01c40439098a95af9e19aa66da826442(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84000cef703a71ddb868f50ae5dda1a8db104e568fd210bd2515511f675475c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f69bacd99d694ea578eebd59f916f11214efe6c7982ad7397e7ac6f97a82d5ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11dd1b4ce7f687d52afa8f8c7b282164823a3af8ca302b51928ddd6e6e18f9a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792150ffa87160bde1c3525f91cc57f0685e354e76258a69317201631baa36e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558c7eef5c25ab0376d891112e3b251447c4b4ec4303755cf8233d92c1528033(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f71749020a6f028db865c538cfad1b05cbb569f9112c22deacb7de0580e01e(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a8412bf8e92506fcd2cba002304ef003d56e035daf79df02ac8190d87c8c91(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__022eba26398ba916c60294be23865b1dc1f1570e9f81aa4a1c1ddc13c3289b7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8adbecc64f2f6fffb69432f5986dafdf0fa04f5997dba2b8f7adaa267699bb1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fdf707a9681e944ab6d098cb8ad1954102ef7c6807a64d40c62d3e3614b352c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4a79fe59340ef06faed46e56913be56e544dc1db55f4ea03e80511cbbb2f19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427f3fad7efa9d6277907e4795d8e28c83667009b7cd2d97eb0afe9be8d0be82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c2a77a4e7f4969690d226f8ea6bc6d60143fb63e8c52cc6d0ce4ac13f0cbda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf266c267efe1e952f00a0525d842abfac8bc429cd29803cdcaa8a9647a7d64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa04086c4a59e6b63ae18099c10cb8a22ef7cd4458952c0378aa84fbbaabeae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4bc9c53d9307680d5ad14d13158e32492735473a09474c1fe644080bbc06cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2d342d6943b914bed64992f7c7053bdbf9e92a3b7839c3a0b9cdfd2b378610(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9ced7df39158f91d35c98252e9759e8cc2d486555fb40bf793d801506d7bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da732ae85426385d727eb69bd00ad15747adfbfef9ff91923d07aeffdea5621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f798422aa8a43416cbfe23113da96c19933c0ecb4c7784776a838594671565ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1032e649305af10b7bf089974a1c3338f262baf1d38b98e02f272e568be126ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c473ea28fc20195c6ab8fae5b44b6b7ab0953e5d23d757d4d1f5d4dd81301f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442f155b5bc2742e1cf214b897131f72d20d2fbea561937708c402bcde25b1cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3e6355e00fa8f35168abcde91c16954c13c99c3001eda006ac1d254361dedf(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde96758b3299a23051e2800e0b9055dea147637aba17003e823b65f9f956cfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d79473c02e5400b396b64b1fccea38ebb1dd3e5e32f1dde587fc96fa06b41e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16807520fea0bcb38dcf8428c7b1263b57f25d1bbc57402d927cc2df961a946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baaf1be037bcf0c6c2af13a9dd4a2b2f11adbdbfa940a3b0570fb35b6c7f8396(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f1b6b6ce320fd1f372338f6de2e1d8b56d982dcd29147895f8fe0494c64b51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32fffa1e3bdb726aca18c48a6d57b349a9b81f491981adf3fed4467ef183975(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72da626d928b59f34fde99b3053b99c9ba57652e226caafc8aa46af46b5ca125(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ace99d0a4f65379bbd44f5a376bba4247b04b9d6b2db6dd0372f2baa4d2a57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caab7981e05f86fafe5637f5e488c1566ab44542a7761c0037f9706eb65f6a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87660be3c4f84089f2217b0362387db711f4149a0194b886736d0f556003f39e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec5ea61186a71742d533cabb351ff21582d9cb9e39b27a2aa550b18350490d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba863fb19f1dc30a816b7a4be538e23466c51159e3f62ca43e0f300aeca96a6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1104fad9e31d8628f033d6b30bfc32660c3498b960d7532b20b357c9599fea7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8590ff3009321500c351aa33df521040e84d35f1ddfa515b3a0239240f73741b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f2e58d3665df3638008e45a247cab8f1008c76cb78f87327e5405bdd2312301(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684c70231fb73518bb4dc1dbc72a1297f550ba5da810189f64e119224c245608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb17000dc123777180880a64a8202a30d109ce8993fb64a59921eb9676bcede4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c5fb81bdbd3e8e95312c38bcaa4505d06ed0da2c925b88ea326b9bc95a0dbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ecd84882dd4907954bd024b5b526f1f1ba12eeb07e10c5d4912d16930ecc87(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d87c45cd1f7fbdba9e55668b9a72c73209cd5c5b3104c4269bf4a9ca84fd26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72bd3f80a7678f42c653797f9523924f1928d9045642db3b894a185fea5b8dd3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd34d02f6c5adb602960a6491aa82d45f51bb7faa98b94b0a78f16a3ac351dcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab967a454492a5116e09feab963de70252d17f4a4dbdae66b1fb65e383461417(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a889335967340e54dbc765111a017a5c98bbecf80824e252da12780f5862912c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a44321a46a8e7416c53051eec6c5af9d04c6923b0d82da59cd5fdcd1093a59e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b75dcf5e4f2fd56c117769cc27606a3536b0b673a32795ed3353b114489eb2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ea3562536719dccffcec7631004b0602cdfcd94a1bfae548d5cb9b24b1868a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f69da8172976c0c690ce6cec7cadb3258ec07cc95e1c99162041b22fa9404cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9029173f47f0ec7595b9b1d99b78ec004f5b70e1cad16032ce4d55901d36b078(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403d3bc9ac2e9f2c8146d7476e1b4b492786d92b8541bbfe37426e159fdd8bf3(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54971ca16f34e37bce42ecf4707f7faafa240c77e4cec6021be69ff07f7212f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1555d70a7437fbccecacae610e42df2b41fa633d13f142ba6ceae63433211b68(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0e63df688cf4c2cba3137da04079aba16be3235de5fa5afab2dc2330eb453b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f34c158bcfe2d63f8fbce26ea3c669ddd8dd369f6e1da24190038a65eb6a31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188c133711cbec383527ae14b7ff226e547fe1913c45a1f7db1b8e993c13cfd9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afd8b37776c65d541c85a653c8c5f733dfb9e200087512c7ce507942c5ce0e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e6dedde78706d74a09135b9b490ccbf3e345aeae2018857959a1fd72d77cfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907e7fd65ada3956b48fb52bd28cbc342830197013cff2cf78e120b5d2673d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef3589a94afcc1c35d54e2e60a8a4504f524c7744ce6bd41d92513d9d34b357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7467045d61acbc2d90d34ff68e04e112657584c38606139cbcfad29e6431c64f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e8ff0e5a66e275c6c7a75633bf47ffd75e52e27a583f60a6f6d292427c8ed6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7098a7f6fa97346a07911ab3aa61ada18742da2d203ea43f6c0e82fb2f007c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb076bd748c8ff4ea9dc624033c54ffa5ceed43ddc375a28ffa0feaf88a21958(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc26e21a927ec6024942c6a9d71137cd39c9f4c9714b0a4fcda27dad45950b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7ca31045bef6c530488361571b3a2196a27ec60911e2420885de72eb701217(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22bf8c8710ea83adddbff06c05a170af075f96880a4e93a95b4d8cb1468495c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b429486502a9b454479b55c5879359a95783a39e428662a4f25235b23afe1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ab0ee91ba9851196dd3e3e4a3be45f09b9039b90ed113bbd9e9159f2406b4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9640b70dbefe17bfb300cf84912d3020b589bb2e9a26722f0c8d64a6aca1e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4724c1715a91833aad2a1e32f9817c2258402dcc410083183e06abdaf6f01b8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__104f74d9300d4579d678a7dc2b66f1b708cc623483480ce775c269c2a0d5bdb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeddb3508dcc0253a0cfeab7a316c9e49599d54ceb654fcfb9a566f661c4fcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4350112baa7adda70cc9ac4e7de4e1a9f563366b1d392ecbacced502ceb635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d8ce85514de2e29bb450405c3da24ae82a66eb937b114f88e5166e4a0f5a904(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a736b64deb2661fb7342260b2f426e1174b1df6b39e2c09562f0e8e140256e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71acf2ed983ff2bcba304c83a574a3453c2f3b6d73390586986962512d4919f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f6edeaa89ca96a33d35b0c1e5fa9a9709bc17cc82185ede31a515884d75091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72451d47c13620c200a0d0fc1446a37a8fc7cb4eb72ed58cdd12be19929e99d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4242d2f7bd235e2ca15633f433a6c686ef43d93c269638f1fdf06f97f9ad6982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55bf558a346c1f4187c44416573d78f92cbf6718cc6a80a51f152765d4db66c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a692e3205980fee0bf07c64994441c0ff72893c840e8159449e05d0cc463eef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723dbdd31e02831b39187a79d2a75471a34a801500c162ded62fdbad7007fbb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e638b55aa342aa963cce3c5bca7a192fea8f9e9a1e1253d1c465a86879e249(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be62c678296ab498f9e2fec7f171134d5b1b37329eb303e76e9f4792720aef23(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8fbba5131a0840e67ba86932c9076873838add5d8f557eada3318d7d058a359(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc363d013f80bd96e56f4f2b9aba9ce42ed82b9a54a2fb27e7b11c7ae048172(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c850887299cba5e027a63b6ed1e174f477e318514f666c053077c7ebd37fdc3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d793cef577b021873dab7e4c3abf91cc0eada42c5ea4acc97781fe25b8a44976(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71644d205c22ddaf99a10959ccbb203b205e83662c8c534eaf8827875476e764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c860e22526317414690667207f5e1b6164496d2400584ebdfa8a502297571be9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621dadc4d414704893fc2dbbeb199afde7725cb0f73ed04f53f23284947e39e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11e1d8dc05a7e8c703dc75a32a2554cf1082f725f0c260d815ab7a3eaa03cb6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63140490e1203f69fa13477e13d801e5a861a123477394c1057ccb7ba99d702(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a1c25318221cf3adce22c0fc57e7ebed76094e13e32ea7efbc8da3e4c9fd6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4782e16843b837ef7f131fa9bdfe9da9225586411618e4179b98be56693446c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d266c345163e1696870aa175bf6f12cbbb886cb4c4326d1dc08bfca78a8864(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c4bc9a917eca7fd9d075798e43b4956be9cf60396addcc13e5c85223d750c74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd52b21b1018988656d0b4b29d408860e7039eed4d83a1d0ee3d3b691ea6fe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169da489aaa8bed11fa3c70170cd303abdb8832ea944fb16ca058682e08f8a88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6f02ddf9d1a75e1f4cf904430f3d9dff25f86a42ce74e7d2f608659f3ebc2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb2937f1d319f94dafe75b57619cd64e87cfe21ab068845533425ab882d0b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297b559a354983cc6e259809b29f19fc33a1672a1dc8bb9be9673457fbffd23f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f4e567a97410b0e934587a5a81bf220bf3af729c4feb5fcb4f3c83d0eb27b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112168f9461e2dc611babad81b641efd6970211115436beab56500b99bc31863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79726e00a810a7153b3fed30ea0b226e9163cf47482636f890ce2b213952b8ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2498f2b808fbce7297326384c5d0a68e1647497244ea01829b8101e7cb3fb7c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b4c9f28eb83553ceebda7da6ba6f9ee34f26a2d4d416d3c80930fedd21928c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8b9ca74e15ccd8929143cc5a820d4495084238ff44149f3c9b8dfc732b1535(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4468ccc8ecfd0ded364c1589463927885ff2d2ea90b0e02ef0f699f04d026bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e73b85bb25493176e6838adb6e5e7f01a44e47a91c009878f3f74ad99dbce29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c333a7b8005f7df65e2127b8038967c7ecff7a2bf006090b211986ce66dae324(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a920bac424fcf097a40e709bf0775fc944999f97f98e5d9b13bf1089f98112a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b870ed6618fe0e1804115073c9fd7e58ce8e2795432e38392c08f2facff21d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b706cc4967b4e4b4f3cc655f3be40dd06facfc71a9d881df1f47427ad21c6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad4099943e9bd1e4e01b72ddb788fa0080ab09abcf82132a7c237cb655b146f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0611893c24a462208e3aea62d97d39204bde31e2d0def12d481724c59cfdf5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207672023d6bf2bece0cad20c9e04a2e0c2e23c80e895bac0458bec2c394f6d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40372cf40b9390d6a9e74e625886315d8e71a8e24e2d533a434fe01e90a0351(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71a38c8ae03b131c6cfb501ae4defe5c7e87c84979d0a7e3cf2232cf222ae3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5ff596474ac5634c30f6f8cd6dafac6da239d64147ac42b6cdd64a4cb7678b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09043ea292972962d6bce56e31608a39ca0bcb92a5f1b13bc3a89a84f936710e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe48e2fc9c0311989f4d0e6e0f2121836e9ee5e4150e2ee6c9da12e2f617a0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95631caebddf6938b97fa305ca6ca3e3a78b9228bc42fe369b988e1e2544a378(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02bac5129a0173db6ccd75f8371383c3c8a37e4eb906f5a848c7605c6a0ed0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad63542e4809d23c975bc9f72d67e948907b90f4baec6563982192c4f41c11b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d79a78e0f9d29dc174d65be1fdede7ebaa348bfaf974da9ddda531a33eb68d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7495f0a6a7bac885e4f60635218c403a0d3b75a451b32ec8bc2430c4aec6b367(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26c73f85ef1105f26bf17ed2ad81f9b33443cd81561ad0736e0b55149042324(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5322b9ea314f62706bf757340e1d696a97083d659f29cabd1af63a93ae42274(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe3de10242c73deae1af920e8ea83ca55a75b78f7aee181865c89ffb01ff481(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a90f6508d12cb8267126056269d09f546129e520ae6bada7cc0833885944102(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__394effa5988a89f9a7371249e06f850992cc7a93dc7463ec461b98d2f6874a79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ebc773718e8b8100ef6b07243e244c348775bc029329075fdaabf704847d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976c45f97ec0781cf53bbdc8d06062371143a8cd23c5f8d868b1f26791b7abf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549673978eb4335d9ca7759d910fbcb8eec5686bdf97735ebf841a95d8dc01a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7f73e26875dc7519d70886c86aa3f957487d0371f4961dcce3f9c7ef2bd8cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e5f9acc145cca225ecd812d579d1ee9aa670efe4396a18926913c3d9b91d67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7bcaacf68550aca09ba4dcb1b82a50c194109f4445f4b502953a2ca49a02a3(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a3a77a08259e15915bce38bbfb7cfd0f065437ae9fe0d9ab3e3750a153d4cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d234b55aa34c2a591d2d35a022247c295b1d23c90b3aef693c8659bd311a7f7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d975ba12a806f520183f1a579575bddd12bfc6a3ee9e296fa59605f8497d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344e611a6bdabe9523041445064c26dc1242f50a25799264cf4029987a94dffb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5d41a099fbf999d3f153b2e304da560adad40d8128495c83f52ddfcd2a249e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde74be4e4043d0c329642fcd386e18b09c0d64e8284cd64ab3a06cb369ea2d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e143d990b03c2e2a95967011b55bc6ef15927c970f33cabf704e4be9eccff05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7770477a5b028f09f299555602784a4d362d7d72991bd5e23d6485656662e357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0728908147b7bbf9f8567c0d4cb2da306288fd9528dc6950eb64ef2a07444e1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76633b129c8c8d0c7d5e3db88595db029b83942330ccf9f7e8c71dbfa755fb35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644366156b43e29b4bdfa45afc2650e9d89e5428503f199693e3e953d6d7b334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9cfd5da22519f1397be4ddd8727a78b0363d7bb65e767d2faf6a040be6fefa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bbc651f660b8a570723e23bc628b80b108a4bc69041d3771d03f725aec45c44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2463af713c1beaafb8a3b247dedcd6327404bd0c8df11cf45819a7b7d44e4c6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348a7a1bcb0aa5bd7d6fefedfb381521ed4f18cebae0422660d02fef5f93e5f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343b17a1f435dcba75acd6d100284ad19ec022934f6418dd023497f088a2d71e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26e141a047af9376dcbdcc6dfa2e9b5e5aa328004bb74d06a23a6849bee921f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6518e45a10433447afe5e98cc57d5f1f695258a39eef638e04b47bd01436a95f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f151133000edfef29b933f2d1567e3b38a39d4fc650ec7d744c215a3327686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b03d7805233b5425fc64b46f6ec3ef7a8bc00635c81d9a734f5df00f38c9f67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83b1858f83a0dca643e862aab72aa120ceb51cfa52081e0f0889715e350f161(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b6ee9a49c61e207baa22a8c893a2e7ab61e1642b1a45b5645aa33e132ed808(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14ed069817a822af53585f16d4e01dd0d94d4329dc6d8a5c780a447f96e465a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c067d033a6a0a12dcf14a9b4cb55e550bfd4d23f47f6d51ee4de530c6e76776b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a2848cb379f7b43fd740ac5c10364b0327b5d2a52329b0df84208d72c18b5d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14eb91633b1a5d2d2f8ef150cd5618bc36eda9d81894c602ae47afb02952004(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a779602589da0d46aebc603951b04e7f6ad68196584f03c1bb75f00087ff74b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f86254dc01acfb671607c9e867662fadcdf53dc8029dadcccfa65bd9f3a89d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0931d4cfaab51a0a1a3e2189847f899eb29117af148f458da168652d84aaeab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411804250136761135d3f7d7f3bd22cb13d0ea93306a92092d5df29de1b8e77f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5d20d30cfec35126189e8d0a7fe06e17ecc845230440d1dce0cfcecd31634b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44f3a9d330f018b3a69c7d6d4e4f1f6d660d8c7be86394788c0c0a35e259bfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7617f39f2c90e2b030b04399b4254bfa0fdd5f9a89d97369c5c9bbace644d097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75a880b6b0913ce282260a51606cba4d48ccb54f5e15ecf85279d6cd638f986(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f15d52fe639a9eb14c124907db703622b673c856f9fd3e7b3dc2d4c9eb3972(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a404db1443e0feb177383cdb96cd6976816267ac1bd023a509f275532fa4064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65682e7818993c57c9cf996407239e7894bc10fdbe55ff58e3aa69a7adb7e107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d78595849b22f5938b9116a62de52c177b65cbd53044d799d2a169bb07f666f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6bb77e4a95ba525a07251e5f4a9fd996fb91bd43dea324d8ada5fb13f1fccfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c06ba1cdc175a43a85ed80822e1a6d8b49f57af1c1a5f096eed3a9b44a3a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb66607ef1b2fe2ad4ded68205a985e07887d116df61fb7a03d6b4909145a029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea91e2a3c258707cc95b953e12cd4359e2ea77e550c16bbccb84b24abe0ec26f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d018b9fc890d5aa0f01b6f5658cf8c2736c50e3e5b21b81ce27dbe7ba11ae8e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84345ec8a747c5016c6b47a6b828679e773209786d02e04bb3d0678120f5cb23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb011513b44017771f781e5c7bbf4236dd8d87a3bc213b2a5845f2052b996d69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f61f891c788122db4a89b00f1fdd9e41d445b25f30e8c9c10b06252b1df1e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8672b802cb1c6a3dc5ed835ad503a1a89d1dc7184ada568c8655e29957ad8c09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8fc67a1e7c7e7a71423a656ae6d3bdc4956082447e0440f6d8ffa1bfc4b9c35(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8171700d532e529d6e944422a2f15219e8504f94f08e9ecf78a4496adaa781d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c17f35efdc50b463fabfb1baedf63870348f76f3db5dc917f9a277f0e6f197(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5fbf7deb79a51ddfbfaaea83a1fea1694b452f9a39ef9b9b9c44df16ad4a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7dece79b66820614ad25b1e080c2e0ac480eced78464590fac7a19badfc133(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bff0d89a7551f7f08e7b3c97ca2ecc8491a5cafdd968bfa4ebc603057329f4b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7868f279369e3d8bfc5edec7fb666bc6c26fcba94abedb8a669321d9534093(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056e325675706b5d045a8c8efa40748df716652e6334942bc18c7a19a88c7f19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029935da01c758654d1c3748635a4915860dcd565ca436340b46b692f6ba6afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346ea6a5688d14020c165a3bc51af75cb1844d8479f55d78806e93ed91e337d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8b4cb7fc658b3e4e5bf9f53470c79d38d1042451abda611261baff114c3ddc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cd5debfacc5ee43995b91837aeadf84b91974286f60da14acfdc9e4f2293d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5799b28981cdad01b0f40ddc422612277cb0c967eb93b8ed9ef698812501b532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a4202e221bd2ab008fa8a454accd9e08533aecf426972424cc6f9390b2e0b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d853941a0914cc96eb8e0bebca4360518d19171f11e055db2fd9626db320f52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df09119d552fa4df548414954ee8dadde15e0190934817ca0e3d8140fa4e3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d13d4cd5dac9f86aeb523fb978d2f61796086de26a0348e7b0f136a0b5c6830(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14dd59bf9e29c6048982ec1ee52a36a8d2f51858efd3d4b9fc5ac54251f73dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5676ccc4cc9237c6b4bdf959353700e0778378758d45171e55aeb0b2f641ef2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5997690b8843a4f6a436848368f28d6dd6df9240016c810fae2bcf12d36f8be0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995523b46e4b61bc5936416e99656480e38d2f98bcbf0220fca2cf1ace153d2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f83bbdab36cd4979a0ac56279da247c4e163bdb97b91f6437597186a5c2f7b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747e8bef019c6affeaefa51533e87d2fac2cf8bdb70e83d0d91407f6a84d644e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c662e3f83d0fef20be8d75b7dd28546f39e3dce67bd4f5b653650250b9ea7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e031e89f3efd927a16521cef9bbed2e4e907dec213c34f5d48937d8d684f08d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98dc6ff4b815c54544cd7d85e3b337c4c715c204d8dc2ac967969091ca9d297c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00141d902b34aa440b25c07d63203fe44e6666b581b71c38dfed038b45338ddc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae9263bc3bff4e4caaa8a72ed3d6c9d1483f9fcbc0d42aa591da6027c6b965a1(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef73b8e3b9108b1a5b365eb45611aea2f0f2aba05e5f1a4ed9ff57a1952180bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71233eca17d14acdef27235cfcde708a494f71c01e8eb24810de79a045ea55f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25e725a1ba69c8b5b9e50c9fff298eb35ae7b38955bb10deab9bb4d3993cb4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57aadf83a3ab4ec7d4eeda817dfc3658ad821e8293d477e86769e6578835a91(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9c82c3a6938e22faf6ad2dddc8525ae96900f401ea0182c72fdf1c1a685e92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee17bb493ce1596b7d2f6fb9b49ef49f8e3278591cf667a504c39c6ba63a24a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e7f915463faedabf6a8a6e33baf2ff7b314200eb527afe3844e55d36805382(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411d6d8134f790b7bbb823a69589cd4eb68c87a5533b1fce1e504447d678e68b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3de01734af749c283bcae0eab3a2745167a6d0a3ad3dfbf035117e07b578398(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0740eb6ee9884c963fc297ef972704e5d74771c608f96ae3da81ba9047907ebc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e80250cb6d7696cb38e39dfdcd16d23a417fed323d5045b1981cae2ad2783b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be8e109dac79485cd377c7f81c68acc4d37c342511cad899e4643465c9482c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3644deaaed7cd7918356c06639fc5fdcd03484886acfaade4fed36a1996be26a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555dbfee635941ae3ca91f57c364b23b75da25a8e759f79969fe8451f4d0867a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58665af33a740b7900bca8f9757776f876ca7c963204e261927470a23d2ba11(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65651412629ac035b5d10a0c84ee7485b86bf7b02b726cecd325bc61df2cc52b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab6099d3a2cc620f633ee306e731baf118316c88f80006791f4c984754b8113(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e9a4a84d572a6c3883e86c59f3b65bc68b0caabcc4f4288670a457ca3ed418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958c0290d5e02f112f97e2b8afb200efb27f66cb66b00f4319a5925259959c1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30d00dfe317d75b406bfa3d861ca2f2f7eedb7e061e76b4a235c5dfd585fd88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a93fa002f0d389c860b6d1be6db690f77994c436962ae7de13c8727815c0bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b8ed4e0769cc3b9b06c1bc9cd6b399ee1f2ab2445b71556cb71887552b13159(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8915b1b6bd276d48425cc6294fffadc7d625ca1e7df81d7b391831e93a6ba913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afd1684d7ab87d487cad13ab788585018732fce3aa787d9b0e593f099d2122a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47680693fe82fb08db66088504b8a48ea06f8cde6244ccc85bad71c4ae032ab8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff52d22c40ea7b1daccf90b12486b6e92cb5b176ebb032e2f8d46c8b1109612f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacb4991760ada894fa61d2461dbe1ed49348bd6fec422136ae0781683e9d53b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d36512f08544ea103b816527b2db186555e8275c6bcb66f0dd92c03b7b1eb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee192a5a1ae80151b7918ec8d4489b8cc1ecb6479aa9244df8512d2bd794c892(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1a556d13c528d862835cb5ac072b9760dfa7eaec2fc0b3e9d874413e0b06c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04af64ef905b33c50d681380165afd7083ec104050ac5d493dfb392cc63b3a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a68f5d564427b28ac60f8fc9469fc432be171ea4b2dfe56ef44e31a4be86e8(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa5939c9e044b17addcdffc961dfffe4602db0318988c4b674aa92640f2ce96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b683fa069df0830c7441ae9562d341368ad76411f38a893ff1cf0b9aac32652(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__300e1995aaf28ccb604bced57c5e9832003ebd6adb801ac7b974ad6d8d2c36c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b321c3cbb66faa75e4181939196c0e3a2968beb5dad97813df18af566a4705(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c88fd49c21d27b9e89de4f7560c7d12e2cc92ed9c9015422955a0789a27c2c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed44ed9dfe5a145b829c4cc6b4521cd04bae7517c845e380c33145f60a874500(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc327e4ee9cf8377a7b1d778e045ec77a1bba3ab3799367f7f1b7b584799d115(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f8df728e0c3a0506007eda155ba1413c94e2d15529855d47f7ab9a1f2bae46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d2280779051a5b9258d974e4c0c8fc11964cff8f56466bc4b220e6037add2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2dc9c814a2ce4144954fea7681533d7fbb9287aae478f55d057a08bf8c5025f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474510534997dc2c8a40978996b975001a614b21b086d7d0eecccc3ae92928d7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccb1aeac5aa87273d902997b9992f8fba308230aa7641899217648535dc1ca0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feff69df099056931e909c67dc58c21c5d15d130ae157d46c15d026e2c365345(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49801bd5b47cd524bca04e968632be937a06ea12117621f9e4fcae34553e3dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f35e2d971afb51f45f7271465f6ac150cf6b856327839160ff80ff9184e454(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71656c64423fa8af609e9bf92d39719e05cd218a6096a4a6e94fa8d406a633d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9fe025f2efcceb9a2e39d5677e049b8e12543c771f0bee8b32dce0b39f92eaa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a898cf255ef0d472350faece4fc0a5bde76f446feeaf5948b70b204a458e4be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dca9248206bbc737a83f9c659c310e8959658136ff39b79264eeb54d6c2c221c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac157812f5102036762f1d84e4fd35a28ca66b93092b185e5bf998c3935f69b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ed39c2ce413fa7fb0dc84961abd36d1625ed22620292f814b4b085fd9a5cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f59a224e28640b67f014ce6a1066c4228190572f371ee9835b39506d72681f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036dbdeaad8e6b04ec86b69acd2cfc3317eef7686f801c40cdd19085a043f975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbcceab3bf4d31b46e489cdf53475cd8bf3b06efdd5a83b4a82017bcbbb9555a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b9b40755f6d299d2ac7cd2e0f9d8b1966bd82aa33a394a78497b0bbd258f43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8365a586ef078f73f5b6ea35f5c54dc3fea30163c9c1c2ae5571d7067a49a369(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d95d30a0257f9794d0b3e354f52ab7bd1f9ee3cd508cf108d34ba2b60c81e4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb6e6178ede644691f728d169d931f93b921445eeb604f3fdd6b8a8f0d2bfca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97990f96b1e0b2ca68f5bec176a52a6dfcaa9fd362ca2ab9983f8b8b5e7eb564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a10031e51e18c4a671784303358526ee3ccff3b31c05149af23c28abe5bc779(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615568a9977e9b27f06b92a505206fdd958ae58a2f0181d27f2680f8de00fc42(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d1c5c2490fe5ea615134f7de918365837742015863022bee59f3374e0fdeb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__100d368f78716d05fb14578464ba316498fe5d06ad0d6d03808bae03ec6717d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d097bb8c3ebd6ddd3937e772b3cd0087bd5293c83b8bb8d58a62f93fa595896e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c620fc3c2ec69e8e8785dceb4d54af9d7a1959c6bf4ce4d61df0c4b57b976bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ebe3078fe1c88f8bc2da3e0c5c84f99b24ce905b717481759c336de634cb49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd57c22dc20df8e18ce98e211c684e10e9aae4a6f2b1a213513f3ea50171102a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847d4c16732d050391bc255705d8e65f350902579135480ddd07b1a0b1014e3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0abedb36cc33f373f1fe9f968612609bec9a9e2399c5e35f6f0632689b5bad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe109b108cc502a8032521eaaca116fe0ac2d89cc92492178786a3913720f16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1c98a9c786e5daaaa05c3098b943562179115bf3ef94ac1203b45431ee6611(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb36a5e08f2f0429f53da4829ca16ed932fe5a791bfadb019680679a23cbf30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bcc029da5a2267b91feeb73653070fc0343eb46c07591baee0f18c87bec4935(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35061b9f2b67d4926f3d48ae8dd06e3133e358d182a0bcc560c976fda2284665(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79106d4bc2908fa5998cd6497fb1cc053815903f3401542b066dd0999349272e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550f2e26196120d68283fc9410eaaa09665ba2b81b5c800c1fcb03090de11844(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fab1abe8894e20f179164a04e2a64bd83c8807403c246f00908a46e83a36590(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc143990500536353d050f86eca05cf69e6cb9500af5e318735bef1979b64b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211b2d3ee66e9b78fb7b7b82ee3f120ebe1b8f64fb285e5839679cb28dcd7c18(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328d30d9c3143aae7b33d8ef1cac31c395b7c403843ebbc295076b0bd8918e60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6638d707cceca1f2e20b8eb2ba216c04a0befddcaef27c9ac511c1188d2ba7e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ceb4149f16b374829b017a896166856b5fb2d79633b4a4c08c18e3854221ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6897850e60c36111a4458f25b50b0bedc11cc959df663ac967471b510df736a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b16a5a25cc452b0577d8212c2a45f16b78ce2148b25ed6fb6f34e1c85e8033(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a34a08eaff4e2bb4bdcb263f61d4bb8749a8f890bc4581d26eab30e7bddf854(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091c0f01f88909f701800790327ccde8eaeaf61dbb55e044d68866607b6eb2d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d461c321d2231ec2c5043eaeb5ca8cfa387acfb29e9372cb6a787964a127e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a69915671fc675c97d8a605dfcc03049bdc4874d13766de523f1e8cee397bf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26235bba39f89973f32ce9ba9aa0e42cc6be26b130f109e3b04ba5f6c6a0240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c78cad7e82d4811e397b922003c99956e8873e82441e329dee5be3751cbf25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78d9f8e327efd9d48926426ea3aa021190642ecfa4c89ddb5003c3eec7935ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8d6fac3a640d2fedbf9e9a6c8e8ff6b8ae1679e56ae595272459a75570adc3(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67cb12232686f7acaf008377a5c2c8b177a84963ee777464691fc954021b5f68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c194f93e2efcaabfd1d55101ae4b5d0ae9ac84c1d162e2e081ef02f2f5ab29(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084f4b93499e37a84c7cbed6ae5c27c9cdc24ce75c147323873c80f9b7257056(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06de45ae050fb7e03b0af8ff86a6197259e7f08550cc8b8f933ba066315f7e1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a8dab751a56fad53e2fc455a8e77bd76c8d0177c928d6405f5d41264e8a086(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6588a4ee93afa55d0f23c7d1bb307ddbad7fdfe4eca58fb78037ef95020a49(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf3bcd0cded5fafe93a81b3d35fce1dce110c68fa7e3ed197fd72ff8bcbbf42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8015a424df188af628b7c5cf10fe1181252eb926654f344002192b7cdfc0eb3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a640156a89513e7cb9968a3d38774f3b741cf32583aac51174564ccbfc0dfb07(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab509527b65e0a980cbb284d36589509b46b8d35dd0c06fd625c527e1dc9de1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c776e1da3dd3dd8cbb2bcf07a005696213adc1b3507956d790aec2180db44b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7815cd74e163a55e665182cf9aabe70c437852418c5bc89d6348c7f7876b02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f81375984888d84f3285ecca8e1ae127a43836ffa4ef0fa97d85c795d7962df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc8fce82d62ca2b3dcf5b3354c949b9ebf3c4eacfab4ff0714917878e9730340(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d436fb9766cafc3a2de86d85f28dffd32f3c20341180dbff453f99557ad45b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c31f393e6106776208d5b2d35abf4612e3061bdcc4d66398ed2d755aa4a6f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280fce246047e05dd657de5f5e053e43cdbb7153f6883d465015421e436dded3(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73503d12891dd0f28896a9d9f9a6d7bc50f5aa6c65946316ed888a3ef0302555(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce4dea899b1f62db26ebb0f35400bfcd31228274a76dfa5c7fd025b2f23270e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e640a057bd064f0b682117980c3792ceb4d6272a207efe8d0b8f1112b8c6ddc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea998aba7407ebaaa8f851630a27f60955b76e504a9e8d3fbef06f17a93440d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d94207ce41b57a0602caa15d5a72d819950be77e298b968fc1be9ada54f1d7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295bb390628f26cec6d5fed63261ced691f09ef76454a3bd829b2787f441c5aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d866bb53679f34aa9406bf3655e140e26aee9146d8b89f1db1b2188a73521d4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777fc6621ad98199b9d847c03a078aa3f65a7b0d3aed8b52af250ccda2fe169f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5589a68bac235c864b1a1a2287f837fef8f078cd67d88bb8e1c91fd62076a2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729d028f0fb8d813a93cf878caa66803066a0d2491e7a2166e1c46e8dca0e42c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ff82ad50f02a5490d9fd70422d44bf960dac64df734bf576e3fd9659c5e6b9(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82b88b86a666ab75bdd2303abda3ac370de259506cc929f8412ef832577ce60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d81d003e50efa1c8f066073a22b9e9c14236456040b15c7cf21b1438f8ffb37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2a24ab1d3a9594b26996a7d185bfe8746401bb73b020eae7b21cb35c8f55ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7f5f823734eb0fa6b65a14546b3d5803c9f52c232dc40df4211d360c25482d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c31abab213f35e8a9f53b09b67639bdc0663a7a3bb6e69863a8f9a02f196ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8653d521959017f10c43d1366426c3aad5508f9e8ecc9fb57ca213f8c84e875a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae05cc9ba817b764212dfc2c11b230d11b6c087d5e31c63e4cf46e4129a68fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04772626fb3beda364d99522f3d7b78f11b1f8aa8daf00b1057bb6d213a971b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad31993e14f9479892099f85b69e797db2b33acb1be3d9a4280d948aba206514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591ff59affecd2b4a3663c26a6793ad560db3aa6556ab0434d5675a83d17d0c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7628c2724bf3d43068cb3a72d933f0ad4badd475bb2367040552b99db4cd4a(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd663614f88987d3782238d31c15a9b537d217551c2bb7461e745bba810b6482(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885085874e9e858550149ecd72272fca4515a8ff3b3b1e799057aba6f11d1bad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b6753e385cdb9c7b27275b269aef8086c7cbe1eaa9f5df56a17dfd1085bebe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df4615d698d2efe6add8872769c7bf01d9f1c2f245360ab2e2a8aabbe908b99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0f4f864c3de6e45a61f0ae1d7a8e3ba1f0edb54eb4dbd628e300d5081a51a5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01527eaf48e5d3e15f70393b3158f5ba09860783a5717884f83d00d35e59a48d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb985c543ca0799a8cb43264229bbff1cade0771b6a2f5974c180d7ab3aebe69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f876fbfda975f99c3348d2551b577a308cdaa7f1ea220f3b6d5b3cff63e56ffe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea5bd58ece476319ee6a8d72de4bf7036bd9a6c4097e8008b91fe8ca4151f25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0ece7333d441d6c6859a9528d19ed5e6381943c19b187442b0b762f6812bf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52cafc881b72c51b600ec9c3989463ab8822bd4740a99968c26568eb117a614(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5561b23cd1a1486cb5819120bb3f5802e6fe77e17809fb547d9aed31ca7fc4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78301b2d0ae5075ed7cb0f5efd522f49e69e0abde069a5fb2c561743d75c3c67(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9294a0bbf9289373e5daad1d5a2b7c55f63fed10e7bc0b231bde45e7cd47c98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5d96731d71daa1319da8a716f565d19abf692e07dba9f493a81a9defbf9a83(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ca564b30fff81853eab6a6280077f6b5e62c19254cc2b66dd6b52b67157fde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91723e214e40b761b45219144b286639199562f2d1041dfb677f9f95e9575dee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a811a130001ea61253f17a24acbd7fb8b47ddecbb024ae9a5ec519eaca1871b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b145dfdaf24f3692bd877eac98110dfc2f0568a6b952bfc8d145676c16e3c141(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650962400342f4f06c06cec5fd49acd365a3395264573aa3d2f634a67249d801(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2113e0051eb421f7beb7ed31aa1aa093c908c03f917a696b619aea0a8805b49a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65038c5e0ae098285530b29b8c94bea9a3806d011bda7ecca9655d6e2db8b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b052334230a5614266d04edf53106c37b1edf87fb0cda4bb92470c65aaca03c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13de42a681f48c54becf7e5fc853f92d1e45e30ad63ed2e590b98ff2762f840d(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03ad6a0d76da3d8a8b1f616660da7803d130e29328995da1af520b94a363db4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2873d60781d34c1a4450bf47667b8f8f6782ff8f440c009e07459b084f2942dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981f811a1ce83471f310ac84e75bdb1f98b867c7eb0389cbcaae770436e8d322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f3adf8cddd4d1c9a27b719e81f49644296f081b4d609c4dfbc7ea4e1cfba87(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5563b98ecae6b496fb717159315b92643dd4f853d44461d4ddf5528e820854(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a4ecb4e87df5e6deccfa08fc364c1d49688593717765aa7d484d19bb466a3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec438a06130e6f01e0d48cee48882fee4e48d16c374370fa4f64969825252e0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9273bb8d5b60ea618df0619782ee7a2748fc6a77ab84c35ea2efd3cfb4cbee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9514043f0d53b456faccd874963b5334597782ddab29e5837db50bdbfd6ba161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007d6c44f4a3f4503dd3bcf6e114197206c61f5baea2acc6ebed1f6240303570(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49935bfafaf73e40b52bdb6b1ba4cc15b86c07fbd0fd812796a1878e443a6279(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8b435f987cde10473a63a150999739054a6670f7a69a7bd31a61fe53772ee0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfde137e24dc1fbe647f8c5f0e3e373452f85af4c02987d4860d7919286923d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe94015866f79c00ca39cab415a8fd07924903b5b49e8a2b159a4052b407599(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13446053308e7ce3611fefe3b3101575be4af8a0eeb1f1d76c0637328f3ccd9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850beaec64d87e25fb8c12633e9c185981220ef00f3d70f7e8fd59a2348f453c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ff06f453daa45d1c47ef94a82611836246e301f40659c75faea1e71ec03fd2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__179e08e82f1cbded566031be040fbd3ff977607349c625ec68d90534468b4f64(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f276f2a179abef0a48d359de8cde59522ff2807fffd7866b1a523eb566bae2ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2af7e224dff0e6e1f2221ef16439ab2614b56e8c122f10dabd01f4e2414eed5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2df20b72f7cbd1eb3edf9f987c9557371bb490ba4fa653be48994ece47d546f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f341830b59d53f9f6c9a5de912c7bec75b693f1a26b33d9767d4370cf648373f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50642ba91ddc4407e776a63a08ebd072847e805c1571d06e90f8ff63e6fef77b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559ee3744c5d104762e426171188d9cf5ff02944e72f3920ec8c05f8a90bd496(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4a034df823af266a21916379c44414bb88bbc4d6a56063a0b977555e6cd34c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd80f2361ef8c1f3b3811da5690d6fc07f277633d53d5999542b4f3fd9ee1d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e9733b37a7599f1384b842a79dd03a8d652721547301df0a5d1ab12b0a8790d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06cef5db2a722d4a422492680f690289ceaa53724ad580700ccbc7da3f7c5196(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b295f469f47b40d9ce0b00a693db5c086f08ed36c2d1d14243bae1bd2c9856c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cede5adf324c7d9513e8daed1661127c43fb5c6c7cb5a834db4f2793a1ec374(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9b4834f8f1eecbebd14675b122dd690ea6e480b4e6ba32e432efbcf34f39f0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9525386012742bc83b0e9ac7df1faefd1e83ceab468d0ef367c010c94d8baea3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c0ca9376bf90890b8b86fa572a513fde79101628493e633bfdbf1c13024540(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9d87024ce93a4dd6161a81f73030c9c177a3cede9fc5153d3bd233d50c3c7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6916f01af1075d7d8dbdff1fe94036f1b6a59cbf5d6506ab5274b699c3efcac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0754815b4951eadd749f2620a0982f948e71bd16c6cbc50fe998cceee16c077c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837cf9304594e7513f08d33268f199f0b7849a64589a2e9ce5bfe175b0a4279a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__018f64e704d6fc44861777faeca77b235fd3b4a6cd4aa8cbaea8d51b765aa333(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1d3704a3deeb9b759e662ffb27648ea366295ee09eefc8aaca48350bebc6e2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa75b8c036039f0f49550ce193d4647cbd915bf0f983a9edaba82b188f5b7dc0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e69c85314a332a47332e3f177eab94a5839f556d2093d21b0df7019cfb8e6e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498269bf48774608117fd180670e9953195c8bd8551216e869d3abbc7dcb6208(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a987b3946a360b9a2dfe6fa16cc39469b2c1acf4c7d78692a51bb8cc4d86754a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c62eb86bfcf4328512ce06e8fbba74d395bf153886ecbe44991ab657415a60a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13473f0d5fc32bc66e07288c9ae7274b0ef4eb3314b93c920ff64ae7f1ad781(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224c1c6858ed7dd527ea74bb03a83e72ae3b06d1bfd63b22e7c4953552535c4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415ed3787ab8981cd484c8056bed6acd234e2dad11d0da52cb966fc83a40333f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665ab458d6f7350cf957d247d8ca61243b2b74c00670df95e12c4600a4d02417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2355b00a707a3ce4c1eeeffc6d0f84e2f364f6a242dc3f329e1249cd553d5f3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e7b4f7824c935257cb3309b9349cb9baddb3279e7922a6a30ea9419dfedd03(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a0ede54ec8ccdac26754f346cb4000ae546a60efe261c57dcb99a8b8cb9ae0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ab9f25153b943d744d3f19d08f8567bc56dddee8bbeb89fc106ddcd5e50712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33aeafc8c70555339091844b1f3c2fa1c431b3ac09501b33e754902d57ad7031(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2aa334001b90a2e01b2b4914cdeccccc968af527e827fbd21140127b1184743(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef404033fbb228e8a587d92b6cf7840782887102e6fe2d7260c8737490ee2150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343e209470a2609ccba06948580fe97651afc758947e9a572551e82a2ead8a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd3fa3d56885dacef636d2542f7b59866435bf9daff789be1621d11d8c75994(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd65e9602d2abd67a5afa0ab1c0a3258d69396dadac8ebf1851602559064664d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a22081817e009cd45373133d30d963746a82cf7a954dfa41212e525c23587cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfcffa01ad76498655a06e0e6318220ab089dd07e1ab6ffe4624e89926626870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7569b0f26644d4bbe8bd11fab6c56bc71c800b64b0d5ba74d74611493934d96e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abea66273660060d2a013952954f2b39d0317e2cf7de01f4142b5660243320d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfffd0164ffe718c48bcbb786c547690a98685d852933eb83b1ea4627b60648(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f91ebadd53ba112d40d232e1dfec3314a5d90db8ed6db203cf4230d6047d5174(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0964bede93cf6b6380b7a35081657f7630f9d8a35cf9100541001982c3277c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9683d958018a5ba252f257e02c07007ce77209678ed9e0df021acb0afac78157(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20261b624a2fe65248bbc19decf390cce368bd43224d13ac3c3f201018a672d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e204c69b31c021009cdaa3ce404ab1ca2b159928db48aaa5657a2faa1d187a94(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f4699706735caedb9fe43de2c4e53ea8ae6b9a61b5a187f8e55ffccd4f224a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df99489da2bb493c993f0d689958ba83f81936da1a2a4f7f00466a62d3cd5fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57746dfe429f068f71cb45c01f728d641ed0110600f26df19e0b7a999fd7a81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee444faa44a79d29c08974a083e7d28f9d96a01758100138b1dc14f7c1f2909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c0a31403bd3c97242e7a9446100b8f4e9d50c901f0306dae5eaabce1945708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801fec4591d46a372a8e8eb40da6d885e60c3cbcdcfa0f2bd005dce4f4c1311f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43b006a63eb0f35cdb3a1a02f3b947e516cce4b11a979af100e43b883a0b96ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5f51ef1e7aaa03208e68c951e4a9546c8e4ac0717c39d5e0a625fc18bcad30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7f7ff887be758f460197ced4dacb0e2c16548b83d81487eff498f84e611d14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4bc24626ef7f36c014d603d4665b018d89a269c94fd60fc1da49d258d35489(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eff2a031ddc50095a1e62478e960e5895df7055ae50b4cbe9867bb0ef6258de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5999aa4bfea2d9c6197ef5c5e48d1ee70b2b39d12ef9fdf2e5f4923e698e5ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da714645fea115fe5e5ec2f0c8659f926701f6d709af5e50ce2db4b00392eace(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ff7e3c1766e62529e7999f171efe9fb6f3fbf037b7d5450bb2b8455efcb4c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786fb746207d53312b803b2558b9949d06a032e0ade59e25588b070c31b4c17a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05a74308e4f791654a8ee9f7a7447affbba81aad98f5c4c435061af8453ccab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a22dfdee88ced5c340b234f2340108e8fa0c6bf0d5cdfb6146ab734abd6ff2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf9cc6a0bab12f6f2632d1be273c97a2c5adc4aeb8611d45966f90259ebec88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d611eeecd487c21d7c6577df3fac6d1cc1928670adb5fc98a77fc2083ecd32e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e7da463ee0a02b1c2eb4691b3beb70f319710f73afeaf223d2cf3c1daf7d4cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd37e190014eb9e5dca56403b8b019a67e3380a1ff7aa478d96b366a3e43386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3bc681e41dab12dab0916ed7f8b15b3b5732c0ab8468ae8e71170348278bbba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db5ee93097470817e571ecacdd99b5a7e273308424003c927640b2951966f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2de05c6a5efc2f52f451d4c71ce4dc38f5aed99848f5c3af3ea4fbf1fe58d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b42f9b026ca89f5a794f2ccf7e1a2513489b0f188f11348f751d3054530bc9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad177c8fcc4650e34176b1d54469072b0814d77841667d065b4ef29af705bf55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b2cf460705cd6380add25feacb5144449845ee414cf6ab076a19d28013c424(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a828e8a38c35c05f517599e22e05c11ba6e96e49ff1e5274cefe6c89e1ca533(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3045fc2970d40da950852a2bc4c326c204ae143bed52b047865707812d681343(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf7aad9e1e83d57052c4d249e6903d6d5f8e6d0830526363d2bece1b2052a78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98811a3b8dc7399310bfcd9849d5c0a381fd256c1a1b0a5c2a1bb19c76cfa53a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127c4c6d4dc741f8ad06e49dac14b24bcdea9402e744d6afe3cb5cac48f513a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c431bd3457038c9887f52897c435e0773fa5bab86f31000d1da169dee3a11d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3b01c09900f5e5028300d5b16265d1156394194d999d3814fbd7edda1f8d28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58be5e624403f9d89c51677269defe56ce85924c364a4d43b7450812791256dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d708a56d2706aaa8e54853d1ada00c0c89f580efe8bcf1058fc43f712a47bad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7055ec0d045e458033e85cccd7e96b1abd23962de6625b759c113c6076481f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e943e26df5c76b43020b68f51eddd2d1999c0c01e6eac9ba3367ab2014d21452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f29c00b710e9a0fa198d1cd923b79202eef87f43adf7328d38969b0946e8950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0ddbbb985b52f041a8ea1e6f6e3b05835a203f6b51eaf01908857df9d793eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e19935f74092d65be1a3fc6a826122fc2a441072484e1bb69453e3b8ff83330(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15bd4abcf2c1bb186c69ff6cdc3ccdfa221ed818233c69ac2f9c30c668cf4a93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__646a2ef05a0170a2c7f8786d41a308126cb6ddeee54fdb6ea5af5cf641f3e627(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965f7e4b82e46913d8f9d3e7f7e9c1fb3959cb4b5ace09e3b31fcb7543150487(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbf97089907aae7b634a54032732271716561a0f340c7b1c00fcc616d9a48f6(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcc31b64013740871e6566411db2c61c6222c3419ff27cdc1a49eb93d9dfb50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6425124c9883be79d4f7d3133eeb773d4125c9d625b752a17fe1c3d9af2154(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb8b5cf4c6ad6afa73ebd44818e6c35fb1afd4a945c7ff1f3ec55dc4b768fd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7b4ec3bafdc67fab270e45035ffab0a1f54623920a9aca3752e2aae8dc8971(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134ffedc21065afef1df369ceeddee77d88b0b8b89ee3616d9cda61ae5cb1205(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f2cc58a9cc6c190eae150b61954a71ad7e800b3a3e326428bed52eaf509356(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac008b1cb09668d3dfd772b190f65ab98a7f0c778565dbe720483d2294e1371(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e333658386d156fc7dd8b906e7194d39be181e166fb40368359c3719dec834f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57a3cfd56dca04a317ddf44638ef8254c6f1b4c6199dfe8475e04618ac1b1c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ceb48b9db91315422e6c721939c5eb22ef26696a341e808a9d0a4fd7e0fe90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936d8ea55411cebe30394e036ae881a3e36596eaba390ff6a05848e7295b21f8(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf5e38bcf05d3fb9966752e262ad3211d2901247220defee9e1dc0d438c905f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5be147606ad19a6a34b6663f0490164e84e9f29486e6e74236a52b1c07e28eb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b92be9658ca558a16ff10b44fa44097d9a33cb32e190a2da349bdb99935130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d436f2dc162d5f0ba1e169489d2be7b6b420ff5aa162f768eb259806ab83c7b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f81bce2b557cd193c39da5c1c4ee7a9859424470c0a966e39978693f5ff710b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7803eb5ec0118375cbd2277438385c66fe540b901ca600845c65d9585809ed11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fab6cb3314bb0b30f1673cc6fad63e71223f1d1066f23926ea5492ad4038d55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a41da2c6e493db9c04a9349d4ba393d72d2ce6821be2a8bca134b49ed98af2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e1a0c7bec2f35a791afe47fb06b9bf55194e16d69ef2efb77b704e77de6819(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b018dcccef4b73a233923002a50f9cbb3a0f68a02a895d69793c2919677817e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19dc2b5255b8beac24b8e42337ba07094e7b40e82f7d13500584474c24d31db1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd8d7c7c180e60075792466fdf248c08488367b1c57afa6a5f2bf8b4e17f31f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513f3e5e0d55aa33e3b274bc82578c6e83cba733a5fa252c5a199d08a19c5787(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67b997b2a6cbdaec7c4c9796a26543dd1fb842f846415145c6268af05469eaa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7584ef65f63d0e11b5f8a7cc590fb4b516e3d917f330f893f8a309c95f39be78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66fb5dc7e648ab0cd9d6aff18bca4eb00bdb863cf229c40fc7688c335a310f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22099e64adeca7ad5c04ce96c84215a1c6c7ad98a00d52d77e46c71210558489(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b888f39e5d087674c38cb91b17ba5581a02aead157e57e72593a72f75d859e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d3bdf6a1565730e19d520848baf38b9643f0374fab4807ae5cf004bc0e0715(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70332c0c586ecc9d5923aa4d5a841c40c13cba33bbdd95b93efb794f8ded8fd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44340f4383c8956fe74d11f9c1b4e18a2ecf30e4f09671d9ac8bf06326a50ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2f305d322ba62bb1ad0f431b154bd2332600129aa09ca584d18784fff6acdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3dae35c5fd20d420bd483688da317408419414aa03a0396ddbf48572dbdf4c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ead5448fdb55ba0c65880df4979b9b5a84f1a6c536d53e742687b7edf5e7c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3361cae8c5154d1c69b48f25fb577fdf4b50db6f9d0d90332a4c218aff63aaa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6fa99f23e1c758e4dfd4c4246f5c5b08e74b3566b27ade9464abdb0cca0092(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569c80cb85106347209fe1df54d2d746b1d3c28c4ea40d9b17ca28a49533ffed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255e0f56f7121d4973947be775911fb6f022814588e3db5851af41e25f6fdd7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6b8cdb6c2d40fc62bb11bb6a9f3d662d2900b00fb8e8a9bdb8ec31e7815712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969cd545b5b81b77bc58f81f7897e17f959d22faf33ee663130595eb49ce0c9a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978d449ed23a7b29def4ef8818ed91e2e8fb4e021acd52ec0a390e0fa2f5738a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a5f712a2f1a12adb77ab35df2bcd684e9a9c3c793f34e34d88e235e2eafd78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9ef8b50d060b8da87c749fada5167e453e0df4182d91cefdffb90034536b7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3334a0050e9245acd59afd142943fc8ed591b730cbe5f7f5b59462f1c5b63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a34402e4a7621535f1f2f9186572b56964250eccc8acb5d5d9e9e9e5728cefd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45df111b087d810f81cc9391ac5decc6fc16b2915a217629f0236e69773c98b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413f94ee68c6df1af2251eb893250a40ba5b39b79bfe02d4ee725aaea49715fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188fd83bf17e73eee8c3f6070a099e0a2292fc6410904c3131e039038d8bac56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4226d4a2a9d08cf8373bb59e746ad4ba784dd6ea059fb8c51606fb523da7ec7(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ff4b1642ca2b08a7ddc1a696f0e8a5ed8a81f9b5646bc665ee2c0cb22ce3a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a0a9dec1dfe6f06ed7138a4d63a446cd3ec5fecd7f28ddbb779b6334251492(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1eae13ceaa38201c4d2163fb17e1b868654aed838d1e2d1cd080f8973a74196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ecb5acbd513e436ba7eb1e3a267cbfc364271277dda568499bdb8040fd1e452(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6e6d266e59580246933087e83100c09cc2626c172cb0de0ac4c26ed2f27fbd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6baf23668ef7f5f32c5763ec985fb40a72775ab5fa7a8923be650d509590d1fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062c015e1c11360c0255d5d769eb09b465a9f972ed23b98d5d7976295d446295(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__806dfe8d2f408dad822acb99962eba5f703cbcb3d9fb3962c51f172a560e85fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442403cf3cd4f9d3651f4eec047d5ecf53501456e456da1f54ae76b5a23f59a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b6eed7c21c1bbe8d6a6b7fe0d978da64b3257d772856e64ec0c5fbf050dac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bded2df90994fe157d84a34f75548df67f548caeda5528eb3be996289782e07c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523e332ebc653383a448bea1d050d9f24221dad8b40f67908f9fe67f6e2004bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac549b54b9e868508d4d67d107504ec568c9953a00e5476ffe71c702b497244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c0bb6efba68e313e2e1071f42560f009bd233e5312808cacee9e17329b4e883(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2d7bb06601a0e0e258f36d62a1ff4ce83641d54e7236309f3158e80c1b45c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f994042cf77acd3f34cd16f7b794e5f0ccb9299a7128e4afc07693fc2c059bde(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602fd2962de9ddfa68c9bdece1be5fa0e597ac21be148ef57340172f8bca2518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd1e96c6109df377ac2e707a6cae54675e7f605e9eaa714296381fecd92f6af(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d8154eaf122c5d30560b27fbcfef37c41bb453475401550ec664a4e3b7f675(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74e507ea4ad71c839c3f1aec025e84a7d63863f3afcf6f8c06cae5b39f4c45c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b4849dba029947f0a259cab403289f670179a35c6765c05d6ec63fcac8a850(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7094c5ce59eb181c3dd3f180ea7b84d1a9c69d4cf91f19d2dafe57db468cc8d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5497c9b868dc8534af55bfe87998a190759c47c7626b66e0d57a9eb4c3bb72d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474064c76c85bf97f4f333cd556ac54f22e4fe6d6a42284588c0c3a98da83a07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f6041efa9d0cca3ea368da10db59cb628e64d26a7894b4ab4d1c4e54ca302b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2875d66142adae8f2629091e0c6fd301ab595de4170ce6968744c26533fdbce0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d249df862660bcdf094fa8c33d2ef0684f7bb6d3d5fa118264d37a512c4370e4(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97467b2d27fb740734e36ab6e0ca08175f0d8984715e1e8358d775c959ba4631(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54578cf7379ecc86936c9a5f9cc872e4eda9bab792d0a24aa14ba172f6142845(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2a0d5ba46177ce0eaafa42585a60e62545876b014b056d27680ebffb33a80d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d7f95bf5d55c48f19f170628dff25d2e2f2e545f23e345815bbe4226fe5e88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf15d2f3eb6adf68c7059ac05f35bdf7ef3168783f170fad68fb0c8c1ff942f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a79058bed4c980a891fc927a54a5511ab9162cfab951c153f48dc8ce7fbcb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f444d564ea764107442ea50c519172263f95852921dfb71f1bb48f650f50cbea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b943a89641a57fb80529e1ec36f4780f85809347609be3307544efee1dc08fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450be9e2d149685c950f85ab94047d75972edcf19b2eb43992264c2b3eeac67e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1752c4c43afcb9c73cd800ce42e12e08ba0db468d29fa42bf778de5a38511465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d19edc202f74c8fc083ac026065f9372661f39318d362019f818520fe69c1d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e583f705aebd742fd0c077f49f52c0dd84a59ed54d2ded163dd00e150cbdb28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09179dd40aff42331bac3e06ab29af2ad1cb8784e53d8e7076754513ce044857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355e3ef8a70570962ad9ffc068b72f07aa29072ec3de93e2d9af92b1a8f36cca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e968621ca44b6504d41d6764663d710201208509205242061d40c57a49c5e7f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27547369164a2a89b37bfc633c5ce280ddee65ecbd812a342801695b0f896e7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b719939b832b36eae4973b0b3b3d71541aabf229ed9315a9b4b450cadfbd37(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe32e047155b86c7056b7b0eeb3590a2b31194c40dc783f177856af64c055272(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22b88b29bdbb199b27ce033d28dffe09a51638c16f421a10a25391c3b0b99f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f856e401c39ec73573504ad8578d56cbd6ad1904a4bfd00b555f6c9a6e3878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6571a28b9cba81be311c649df9d89415ec4088bae4d5066c57d4b4e16081ac43(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7652ef6d8b2159fc3eb2c61f3daef282c6facaf2abe67907274ef3985c2578(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb81d5091a7fddf1a677f76f8efe2603b0046e6853a4d998db7ad2e0c28a6aea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57338ed88701f2ab595aa0241214133ac5374623bb6f8219a05e0d957b190e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3793f921245c6747004aed17f0ecc5da4f4ae4f82694640fe14a3aac98ccd4d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923c014285734d6525ad573b31bd35760996855a71c5bd7718d6b1dd3b5daa99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a062e88897981ed4ee229980e22a733adf4d0fc75a1cfeca07a25694432e38e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3c59a170a6c6c49cf1326f17cf44420ab40bc1e4d3808775b63a79e8ffe25c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc14fc7dde8224d7d84b0f2c3ce1c0c2cfc6acbdb2b6793f593a15479273932b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d093bb8b99263ade271f5085b2a9983554b9b591df0d27d54c9b674aaef0aeff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7d15818b442978a10f56652bb9fbe563bb77699ef9d0dcdb2eb9324dfc1276(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5392944e38fe4bcdb71ac018add276505c3cb1e171fdc4744e24385e59f958da(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ff4790b1f3a0bb161f40e5438134b9726e16e96d5d7836aaeef2c2d151accd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daaeb934ed867aca07436a69a50eb49c8ead23e9f47ffc9acee8f4625c3bad2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6690d11a80b9640612f4f1b3d6cb586a0088ae7e7a29353c4642fd9cebab3f46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1d0ac890ce907a89cec1f27bce70cb57d6b0af0af65d55ba6d012f88bc9ab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b52d219bb40b468bb88546c1fcd9957c180ddda00f851e5e0e55f04e7390744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea6bd8a8080c4f6d3a396acc4182c548051385d84683318f92ffa1317c2d450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f3dcb72216ee84be790828c55accb59e40158ce7727dd8b114dbefd90e7a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a316ce493d793445f5ece2f782e96d6ea69fa9627bc6cecf0760ffc1f5ffbe9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f735010bfbce684802bf8969a495b367ca5c02294e688e32c6bade4f0ab56ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a29d04f050d07da5589a43da50a4c7a016e9ccff67e055cc2b0c2cd30df1f68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c51d86e919326e4f95d3d4be34efa202ff8a51270181096ad7123692a5eed6a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40dca738bdba9ff6bb225632444480e612d3aced6eae309158b507bdab6277a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dcd2395cbe515458a01a3f645d9e89fd74bda2853494a6e4ee8b1658bf53d24(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afe87f9d2455d74d8cf0caebd5ce634ece5f95c616516c0857ab5cff64481e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c36db6f96ffbdc0500fdcbc24b7d1b30183bc16519b46f6a0ee2353dbffa67e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b317abb494b0bf18700afd5df30c21f38fa8107f115e77d8761abc6a199b2ad8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c37e284279da4325ebb796a7f0cf80ffdbc36728044dfa4bde17d5a9691c5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46a901808f13e4362987325a1023cd2da107b7ae8e9c5a956adefe2b06d0640(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c0e7c020f0b47a55eff656b788f298419947a0454a33dd46baf1f675b64e28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b296e64531445c0f97e15863416ac8870e92a2c2a894117b638e0747fedcd7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d08ffa887329145e35e66e344dbdc6b63964beef0d70e889fafd163ad93fd56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ef902fc049b045cc3c9ed1834e93dbcb6ae79c6d9744a8048cb5268e54e585(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__539ea12f794a24f0723c901c8b1f1b2a681998464a6da409ca5eeb045e885ae2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff89d0c90bd8e8aacbbf471fce95f66b5f5957de132e7b36cc0f3cadb2e732f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__462e611598f5cb04588c7e68ec53d6760a732d354edb96a5f00802d78cf2f314(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02200a25a2817021c1ff0078454637b20d056848eb7bbd3abfd34f32d639532(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75765bf535b7e6cfc8ac9485a9539f881152fda882376c985a3bb64f1c512dc7(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c5a6f0b47abf5298e123e37e39a915a6705386cfbffc2c635196d5c9bba1f6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25fd961df1bcae1a79493a4dde76d254cf3495e23cb78bee883f4a11d452d1ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d50285ec750ce5e927802202f3097eb5b244512e44f97d770ca7b8d343d7f0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a685b49f72346de99120a15ce91f424355440cfd63c2b90859569e8243c7cd2e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5287684c7cde9e1ec50b7b7701b7be5fd4ed88fd6397c41ecde09625fd66f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0afd00b0265f1180f37bea814c7e700ccaeadd8bfd27b7d7cae0139122f8b43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__567d42e01fefb8848a35cee3aca7b839c4fedc933c640c1ff0a61bad7935795c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a238fb27edc85f58baf98ef443ea188c5cced539e7beecd0cee7db69372dd91f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e01b49874b17e0f6e096085e89146027882b5f0e6d2a22638ac22ccfeb36366f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feeefcf7a62816a07865bc089dea2aec747b0e1deaf474cad38b296ceff2bcb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50cfc7142d0e839c588c13fb00cc329ff66269791085d241d1baa6424c3b4886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7734fee20a0cde413541e8de12dbd04b36049f3d497c9a5b5034b054291cdb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f3f3631c0e419a2ed075c914042c5c0d26c6daa4bef5fc248091432d2a19fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9efadc5b7e1162575da76450f985d136e77cb50d42155122d75b61693decb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd7eec6771bbd3a956e6effe4153b23a309475e69fc9b9d0082be49371243b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e7a09ed82c501f69044cf0ba30dd9d13a7b8bf3f248b04b14fca3cda144530(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cca1d64f4a3084be0ac82dbfbd5a4ea604e4e82b712551c2f7fc1cac746e441(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd4e3fcf026d6be1fa6ab22dbe5645b13b2aa02010911ef30eb902fd96e777a(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a97bc448488ce23b7971636c0679c15d484c70627ceb3e7a909f8c513f65fc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd86c0b901e5d69a5560d8b2b2f0cb24720d4dc7d58dec2e5fbf46f073534b20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988ed8b46e42a0f7407788974127c1882b2693e02376d4b375af91ea9fe72ce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7339f1bc8ad07d6420e5e1c6efc37f89711dea224061d3ab15b07e56b446d61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4797e0ff0ca16795159eaf124843a2ffeb42316fc5484d1b642190742628bf4c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978bc04e79bbf78a7d9379c2f50130d27e04422f19efeb2e0b9b50b273a8fd0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93b39ebede8ffd305617f7bfb134ffc1db481cfec034dade3f6f73d8f4e58e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843ef8077498732e78afbe1dcd8f86ba8039c59a796e6b2397381b908d47b726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7510307f66e5dce044633cb080c2d1a0414fdd47d03a011fe151ee0f4923c187(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f868c68e64b04f511d1c1ab7b8a209d37a74940a8cf9b4cb26656f560c3d97b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197c36d8e57b6e3665b959bd5483c7dee7ae58886af77556d70c0b5eca0ffb83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e04c19a00bd863aa12fb58dee11a7fc0ab74075536d3641ab66d17438cd0521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5d692a2c88bee78ba75c61629f4947b78a83c4d41b7a7ba4c5c41a5a9dddd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2e63294992c2a9de434549928b8369d789bfd4bec1a806c3f80cefb14898ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f95cdde7ce9a98ce18fc044837f6b68f00be9f3b688fc30212af40f82fecef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41f14834c7e0c48ac80a868863cc9e06b25c9cfa4648c15a506d2dbf29a3725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d527d14b8455724859480c2cc74e90aa88b51d108d6fc6069d580b39fcc2633a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f82b42cf1060062ea14aed0c8ae9389a1b4d1e21afaaadea39bf62b517ca8ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519c90bda4a4964e74260b171f2fc6b4782296a6265bbae526d918981747bba3(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb4f453a680d7c2fd776e8c78edd62043ae42582d9dc904d37ec626571565db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc60f566a261fa15469a447e271783bbb4b67c4e9c99f78851c3f98b5a8956f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce80c029518035a7332cf8325dc9271abd823cb136093f683dceb3e01f96337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1e9c4dba3bf25de30cb076dee71be1ad79f1d989f2ea0e1ce8ae7dad266304(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaca98a79538e011a6cf6a73a59f56c62cd9e94ec14591f521095d48dba6c62c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4bc3f33e18c6a3322d49cb59a3aea8165be684894cde59988218b4f6d4fcb40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3826e65c04e9cc1644b3d790216a7ad407e2be27d22611f5d70b69f56b1c50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4108078bfd88769280a62a9b981929fe513de1b7fffa52acee112d06370aab04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a575aa528076e86d7efd56aa03b5e908057b43e1e4fa91041690fbb84cc5b154(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c07e2467ffb3f1c4a69a802669bace75a45a4063a7fca1a929aef49e18615c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c3a7720e0c74048fc4a42575c5cca3a579723a4594a0b504b9833a0271a2a1(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933d230b95b65dc2551629f5781b3ccdc4fd11c55ad7c559306c9e1a15ef5cc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b1427fc8349a993fc10b64e902a1eacc28fa534b97275d761d36954362ba82(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b8194202108cfccc6baba5a00e47cbdbf8b7d333aa17a6c06bf6590be088bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5725b8e042525262dd05e422b3171121ffa5f398f06ae38954906409c789500a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e2933debe4c1ea473b35991e97af67ed0de0c20f2f69411acedfca63e74803(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f40004ee733018b6dd06de40c3dd2085ecd848c650a0dd0263bd4f22607d81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c119574610ac7f46a8154a5f39fc0d57073e2c29a316a98b018564ddf23c2c15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fb941eec85a82202754d2bc0f47ab85535ab956c2e4d4bf533afea2baf16b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50e9f5417424291a2c7bfa6737d429080443985cba719bcea3e95273985076c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48eeb363c7b63461cfa6b7658b300a34285f60d035a687c21592418d9e684ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40b488c1bfbbb2aef7ffdfba6675d04f66cd17aefb9e49bf0d658084be4dd88(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29fac342fab48740f2654d3cde78387949570b3c8dbcd1bdaebe389e4c8255e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9967c1b45cc4097cc318470fa0b6e67b77a81bf79a247d10137ea6d2c14c021(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6637190408d120ac3d6d88fdc10fa2c5baa9368d89a1036c788fdf08dba065c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced0e354c2246b92d43e57bd4b9720e72f434b8bdf814fa01f5a60607a37212b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fae943b93a0ec996f0329f1ca40e721a3387d09edf65e0ae536a2a7e09a7f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc8598e01100924a05817fce76a6cffcbf04a90859689020007d6f25b0d8f9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b5542a2611f772e103d92aee614dc35d5661a56ddf1dc8ec723c1facf0003b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895dbb76a04afc819d3255f89a172b7da2ee219d21ceb285fd66141638c85d7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e286e3590982105d1c5860ba188ae9bf7ab1e592450c4c549235c596f0657897(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5895f1db13d3c11edf61c8d28a7578ff3a478ddeb7cce2633fdbf92494ed3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e5d04844cb557732107e90b541fe67d942f0a2b447cad739873d32bddb074a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430f8198693ea83bafce2a0c3c3b4a8ccd2194bf90ad6566d4b456d435d884af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1498d3b4fad6bedc1b6e146cda91c7439f27f596e23339d44f87469be79038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be9da019dbdd1853ff173aa4e06c12f25a362bd0d62e1540bd8ff7a33666522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b437f6e21cefdbd923c30eba59f29be515a7de09f32f2ab9d21e8c9e6fce59ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a784580f0623e2cbab35e80f1e8145f1a5a929665aacd1ced4509b19cdbd1ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b301047012bae735d1cee229f6e9e8514ff848e6a48dc69fa9ec7a88b21ec08d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d2179a1957050c40e44a4cc924748a5a5dd59bdb294bc1afcb6d7f37ae34df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66983cb11f7de6199f42d6dcaa8929422fd758ad6b59ff070e94b26141dc163d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf00ad207423aea26943e9dc05b41dc2a98d6e44e4273e0650e43d519d91598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eabd5258eef9eb7f4e19fb792ff9739f5100155a70a5ae74a0aec042de2ec07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4c51a03146a954cd2af6d24a5a10d0977e336d37f7fbcaa69c63e974121569(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3fa13c45391b53e2628b176247f0a1191a5b596962a31fe3f6ad8c6d2233e84(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3bed525be9439a68f41a8027454814ae7458d575a4856581100a85b00fce6e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a866c93e00ddff2c3f27232b8c885d7f083aa968da8842012e94d2fd70268aab(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a9c8546cdfb71c8317dcaa7c8b0edef1563b9c207443e5022399454172e3c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2004f8bb10513c1b2f14617c877f9fd0d21e369bd5c5c258d4cc19b9b0423a87(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd575a018e3b753a19dbcb171d95f5bdde526e1766628feb0b48b16ea76024a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d55f3544d2a231beb7d9a0896ff333c026cbad86c6f3a0ddf5983461063162(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14b3a63c1bf2b3792366be840471845a335eea77b0674b4ddcf352e406e9c2f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f8b14894bc9af9911f13421d7fd873215ac39cf5eec4252b6ba1ddab102625(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367d04ed6635ee1918811f3fe57acf4f3a0051111b6e72f0001a66187a32cc7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e0077bba8b39c0ddb1e295e91588934755d8312d897f034d7d1bd23166cd581(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0d91e928c38c176a19ccfc2ad2ee5332c8c0cb33864ae406e2f93a223da0b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f4324e19b1b5c52be909ca82f5e176d2afa2acb05b5fa869fa61807c40ea29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf57cec3137ac017667018b76712acea6acc34f0935b19df29e10b311e995875(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1e6f8b84f968d99bf59cf1632e29c79e152a104f58b87595c0a4242ee38cbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791b0e47a9c53bb1021ba82a9f48aabd015971e1d100065522a48cd7e18f8edb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20fa9bf5c9ef23f383edf6edceb909ce0058c46cfde3c172b9b7f995672170e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9471ee2bf4632778976fa6c04776b61ef7d35561cf500b010952df6457e09cac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d904f370daa45de40f69c28198e615720cdb9bc644761b614b72db6e5b07bb62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ac239f665eb16640c6ab634fcd090fdf5ca397cc85d501b3cd4c8628172d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d742a2c5069aee0b6913bfca01ac9746630f625f19b2d2e4c3e1938489d60a93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8f083f30f6ba93f01e059a8a353f1aca4633f873d20c0e44c77a25d9e2bffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae0e7d7ea5e7f159ae27cb5c48bd6c01e25a64117d1e01d0be408a42160a28b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2147be3369c6c1ac85141c488d207576bb66df92236c7fa78057247075c2296d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d15117eabb969501382ca1051036fa5dc633337a36681bf774338975398e31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a698cef03f9e0d14aeaf55ae504e7404824eaf5a32083672887e82cacf9b3871(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57349d0ef9708d8037a1f7e5dbe58d9a5e83698a90642369b65d9433bbc5bf36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a00d2c580e23eb0ff879e47e2ce0129f0f074e656a47d9a2d1cf470ee16bcd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9578f2a0454c961ad5924f1dc6069bc5ea9c1a838f3102fa20594c43685260db(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04dc51e6577a62bf19a84044057df14314f25b1472936393b88b99ed30cab423(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b2819de7b55d27b4a121f08d3021c8b47f19f711d1336ba6c7d32e70f243ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d410e9324801debf62033ab3bcf6e4c587cf7b53a8e107870d9d878a3a012727(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf5fa4123d57a9dd171596e30e9d9918776c4c39b8f81e529cbea522765ff05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc8fdbe50887435489ca972ecade3eec3c4aa4dfd4f2e6cc3b06d2ba1e9b43a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f9106c6d346db7af3faa284bd219c11fd8df3af89ca87720634d412e8f0a0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c038477c41ed944a3e66be5b0a758acdcc6101d2259c4a2f7f560f445d0df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b64c0715b2d02d4991f79107465dab6dccc1d0601bb444dd49b526d38d7e15(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa95ce19203c394dfd36e3524a2a1b8e2feecca6d784001635920556be2ac583(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b8dd319f499d31e3ded4ea427cdeeb7a716e293ea517af16c1fc50b6397329(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fcc69747c7f8e057891fa1a0ca2fb7c2525af417895283545cf717015e389cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987dda651a4a5e9df1a3ce01eaaf553eb04e5c0c75cba7dae816a402bd679e3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7cf2387496b560dda4f74e9798929141746f6e0790965ccc68a4d83417e71f0(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0edfd958df7760bd3f3bfe4e3edfe2894e096c6641e992aace0fc4271127da1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0427e97345be388dfd93385d71e31dae60d5b5ccf08a566fffcc38326518d46f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3751b5331541ce5577254dfdf0d52fb4375f665d4c8f71fe50951c65c0c76cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6718cc5af636c4e2b64248fca4af70f74df760200277c5227cc5ab94428b50a6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3851d9f56e822ad4a45f76b58b6799dd5ecee8ed5c1e1a836235ae44f450de4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdefdce32f8d4a59e9677ea9b67c8de308617c2b2bca5881fc2189b55efea49c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ac36d67b1d0e623bb6eaa070ff2d753574e0617c40d5d13f261ba31f7ff42a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beebd69685ba1b0847ea0fd355c934dd6ea6ed73b183d73aff545553046b7cd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4f482a69b1079206a26f215069313b6c32932095510779ddc9c8055717ff37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3561a783f4897632ed80145e0126bb3a9da85875b196f1b3fee5a846f6f47387(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d0abe3b538c62865fa9482ed0b196bb303677cb8b782264a171edc4474888a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef998eaaebe3ef7f63abf041b6715ef6c7bdfaa59e9d3115e6e2dc25e64e0b22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338587722fde0dfd9d2fafb0b6cd079149d6296e4e9ab404b3700d05bbd849e3(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a78b47c45dc8c49067bce274cc8ec2abc8e6151c26b5fcdf29dcebed2f39e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcbcd7dbe957651dbce9355c978ea9a811e3858532236fe44abccb97dd32f25d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcbf81c35ca5b594db4a02c73571ae2e4abc915587f04c617cb19fcce574956e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9688acf08d107cb665cde9471a1d06c802b8782a58dfc54952eb8fd1db98f6f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b53bc2a26a399c47d5ef22dd8b92dce9c38a6a96f8bd24648654ad3820af83d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2aa8a53a1e6a8d258e309597088ae80d12c81e9064bbca9defece23020d68de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a644935ced925b44b2304dade3e130aeda0613bab3c8593189999ba56bf5fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8fcd01496b4fe9cb9c2f51363f0386ab5663ff3d2598dbd1d1ee1e4458333a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258b8bd1a33e69eea6433ad3807d8f2c02b513bb819250fe73a7a03d0e491b36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafeb8c12059657e8514a0c9847db1427173ae7d8c96c3867aa57fd318a00bd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251c9fb340095da5ac4726f088dc33d44d6daf443dca79b2d216a65eacfa267c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2400fac46eb3fa863df74c16c9f050ef35d42697c39309db830ac3b3a51900c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d43ce4bb974ab5dddee055901c21622186315fc0e690731b3d8ffbbcefaa5c6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b90636224c61c14f2abd53381323ac14753c928e45d9f6806150ccad241cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1fe7685fd8955cd92f444ab815836eb427cbc6bff426b62cb82f2b71b7c1ab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54461a9e5569aaef6b60af7cd0a137ddbfaadfe0e1c6983e8bacfcda6ddb189b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1011b8ba4fe03cabada5750fd3572aeeb855f3bfad9c765d9a8daccaa035c0ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13718c56e9681d77751b4756cbae3bd3b7c850ed5ad509cfbad9120471cccb6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef93e04f7d7a87263d075ce5cee194b6452c933f5ce7f4bca9e014a1b709072(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603605e79708c6f034b5225531646e7f920f51b1b1a6b5cf4bde82e0506c4a6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad46789eca460b5d664d499a249d8d89e1e221103dd6bc25188c70c22a4f509f(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811eee1af2ea2643ec360163987f3cd4afd9a7d855ff6e9d37fe026893124fea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3b2d9e06d2ec7675b921a34b1190fbd952d68882d0de0823fa0ec69bf51226(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad148964ffd6edcf5c2ded8503ac3ffa656d0cdca0265e5367264d7495358ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4588ba4d7ee92d6f46f19c1803f2e3d4405cc1f660664b177d76e0b19e2299f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ff4c66ea4a534b7cd15ea14db82d720c1eb9ea7a67004644c49fcc822c1d63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d8a540d547acc641d1c37149640ebebd1f1acae493f50a7d498e8c95c7e8ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c193d1fad21637fbd5010c589b59bb98ab5cc88a255cc1342912a0b8ccafaf37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d005c6c6add1dd5356c4af94999b480fd7c36571f7e2052968ce3276033b0cbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd1061ce48b39b710e4694624abbb2d6ae77c695d6e0b42ce450a5092798c88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60ff17421cdb0ecba1acbbf404346d9dd3084abbe22f0565379ed4f9f16eda8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93a06b5ed3a33e85c742b7fcd5f8bf13e91531b68476fdba2743d3d11fd2123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd811ae200c8372aa24ac76afb02ddb41cfec23b82650746ec13b57aaea49f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd89bcfc94baee07c77ae17ab4f2ce5f54191020485b0915b947b3784b2d9abb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d983b0e3c2aa04423b07c77c60ed97e652a2924f757438fd8736535b9ecd06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85fe23f9088b09d2b2932b771ba97aca5f82df28b8adfc3eb6d256bf38112dea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7f4252f334ce82548d62d888ea6b0cf74644cac1058872e7efa39570a78187(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78bc2c64093be13e9e53a8b88a22358270ec0027b877cf8cce8c16c37eaf6b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab736c3a88d30e8921459037965f11c1f8d90a2c7602ca7dc890fb63bbae3d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba4ead7ec9ac3fc6b45c890eb4f4317fdd076c254b76b48fabffda35cd396a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab7be984cacba150519d0a62ba221029ca1bdb18bc757597cd7d738960a6fe8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fff4b2bbf84219a696fbb13c4c3c4a811b2fd13efdc110ff586045901c0b6ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdd9a0def2a87ab60477b4b2b66d218a3b0bc3df00d2acef6fc3ed6d169beae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe15978faead261a2d1e6c1198d4bdd87464b9d396b44353ff6a5c041a696a6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d57014ae5a0ac552a9e053e34bb0ec3eed75513fb7a45e3a6e88ae0bdd5b123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fbfea1d997fff2eec9090cd00aa9af0a0fd68a14fe2e28c88451500d8dfb54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c399c129564f8a7ee2101a9d3de1caf66a60f468162b4f35a8dacade3072432(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8c8419b9c817aea9d17b4eaa33f7020fe0060e04299aaa43f5e8cd7933b5f7(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b846b9bb40c396b859d29d0d4d851f30af44e2a23b28816294ab72608ce1f420(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f016c54a21a27dd92b7656590b46bafa450c37cfc36bc78f8603bd678eab3edd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8d4bdcde30296388c52cb27585796992cc8ca5681d12693462f2daf5bd5da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec04d889f0d6254633e446bbc1f3584337ea24cdb0bdc9415b08660994f5a7f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51044d2f64330bbc7fd889b3e4fca7fb025b9ca04d09eb3790eb24d8c590ec40(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feccfe104c7bfa3a4ff63da49e6800f432ca6ab551130c6412adc266e8eb61a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f3bb3f687a7a8d2fc21e2beb7de8d396808c83ad99c3245093448437be34653(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3a557371cd45704319074e8ad3f50aa2eed9db723aa56ccff26d6b24e818cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaecb5e86a35595a28758dc9646e9490ee0c7e6084d487dfd5e2aee096c2c64a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409725b20a220b629ca12707baf3ab2a20da81c25a71da6e76b1c2290a78f1b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bedd0af211e27e1d813cb10ee4952c64ca49e4be4ceba3ddcf670a74c911841b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a420e90bea1db0e24730db1cbe991e726919ab9d82fb8b925885ef50db6bcd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec1bb1076c04421e3dfcd2d4c42e04a7663dbb85a2d6065c85a670e40e40b0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fecb8841c9cc1c351cd8e3cd1f14d4ec7082d9d367f2ba5c5300df66ca28ea8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecaf1a6ba13cd587c3556cd51782137bb35adc66a9ba11b47edc1f3658ee088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e99efee7ef681855100fccf3f6104814a693ad7edfecf35efb8895d2424b6ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34a24f3f714e60d735bbf8198d75a031d35e4769bfed1067a56a2c8a53a0826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5baccfcd6af8c9ca8ce200f4968d9585854eeb820cff0ae36488715fed96ffeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312ac062a7a6f5e137bc5965f5d4cecf7897fdb9431d1325561655c64107b760(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b16b5ce5bb95ecec8be047049534f00131254624c15becb4020ccd513f15cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce79256ead2a6eb8020d623943ae38defe523d5078b039f855931433240b9ca9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c899a007b3b07647174c447956a909e22e81748b0e8b3364db094b633db95040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac86f082588118921edd698c280bf841ba609496019c9f3282c62c2ff51105cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc82143c602dd8887cec487fea224ada34ad37791ca04987fd714947aabd04e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0761e7bc13299de785a21ac421cd1fe3d25c8ae5c00f321e27cf2c42c238e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac5c6babbd1428c24913d2796df8f0e514f1b7d4ef29de2a77d4e435129e7f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780c6c52a9479b6cea2cafa7b03f0470eba75c8391e3cca2fc9aa40120b32972(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4537f1564d2122579e054bc50e74748ee675a609a1c65d60e3f2c8ad1fffb46e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d3f6d00b3b35a04474a8451380d1484df84c62d9c648a3f033f2097a619068(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cacfd24f4413f02762cf0a12eb370599d564b0ccde1b34f2b92cb51a56cb2f78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f325b1b9f54265a709f17e70fadc75349fda6af3017bac4acf2de7194f1eb5f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bec8bccb05717f547a50bebe2beb3c584b621c11583972c225478aabf5bcdc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c31847207930ba7f8a4ac579177a2774501c16734abd9dc3c5b41ff8adba2351(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25bf8c24bf24aa00be978779fca86d573abc879aceb0a142eb985a0892b66368(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d69086628a36d7964cdff5157c484ffbffdae6d4cc75aac905670326988198(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80e9066a9bc5bd3680a44024551c415af94d28ea4a9eb5d9b9427cf9a3194dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db0f8387c707262eb3659f9b7cd6d1ea1e164ea9ed41c78a02c1728f3a866e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cbe060c52ff407beede795d28e949b1e164e79fdee15b95d595868bd10547ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86497421fbd0d6afce9225fa6b58fafe53476c9288f536b94b952abde6a20944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f4ad347fcfa623a2ee1c58d14c148b942edda9091b974fdc380bab862e6d50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb2c2d3443fe14077e115bd446929e3f4adbacb0a82a1a4b36dd99b85f9461f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17823615af8cfeeaf9066f33be397a863001250738d9d629b59360a52a5f2c7c(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0684b09de4c989cc737d78f967ca05b899fe796ddfb6ae0d72e99adefd8db6a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e643a04aaf1fe4c3d973042ee75ce7c7544953908e26dd3b3a221ebc52000f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5232ac6080b49a25a8de8d5888aa54119231e8de8d408476301eddf36e3e7b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7d8a379332f25e8d6d4002753648525407b3b07622f05ea0017cd5e6617e9a3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc29e2a15ab02c908c1315bab467c4fdc123506e7d245782f7b5fc91d13703da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2620255e5b64266ea1cb734e038cd1bfb9d93483b53760f745a4956811909fe2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60727c24c510b0777c2e03c9338f593e4f180661719f6be864bd46ab0d9b1ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd2853ad09e97ef028d85315ffb648de832c7f0a0d63ee48a51041cca828468b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cc1f5bd2e03ef65b5519e70ceae5a600fac4dbc8b7e5c9b4b9217d2472667c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd2d53ef31d1cd951099a1477b57b5302239e397c4eaf5721369abd416f97348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b83732e5fb86de42c2ee1ea762f228f2ffb87e3e8208fde0ccb815fb78f82cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55083bb1d0a71777317ce23a8fc9eb69538f21f27909f11ed9879a369057c697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9576de8dfd2faee7367d18a26096afbb8b6f5a1878a0279ff06673ba8f9e2eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1dde2b8c79cc2c8cfbef77eade1e39b5686d71425bc674d279be3bd444e3f4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d43e84f5ab7395d377b72763fc2b8d1ad21faa2f0c951ec911f7c4268ee0b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ba3398b737d0b8c94fa819fca0be1e0cba41f3b3c055d9c1ab3365ff9e2f5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32717e864d59028db7daa1d3eec24193ef1ddeb10b681821f7dd1548928bd03e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c067b2bab3e1d84a598baeeca57340aa614c8cf2a07e3d7ad6a649ba181dd95d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7609b0bec7a36cea75fff5e5d4bde42fa64a1579a6f6dbeec486ad3ff16974(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1972acf437be81d49d3ba9e222d065acc1f3a125b07b9177186215a5a71802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173acb9f4f54d78320dc12a75be33786256268301adc26f1bd2ef12aa20fb180(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77c918ab18132c1f491998b3883fadfd20388d8697b075902a7084574cd63fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb08361bcc6027dc998d27e1d7dc4978ae8dec7414e74f6988ced543b0a3757(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a979bf720c8a97c71171c377b9287d06ec0c24aa85abb77f656cc65e592b8fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7e001846d0ffa505fce6bdd2efe5fec54d0975bd38153c655dd53bf95c8992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00dc844f28e8a4be2128063ef1a68d496d55c5906b605e2764764920b4674da2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb30a3b5b52ebf75cde0a3a80ca3840df57bb0f41013a522ca780ad85416dc08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eaf43e924bd1547ab3b6237bc3f667ef816cb0c622b17e8915ef74fbb98a515(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa67dc60ea4edbdd658cdd4b128beed4b77a72cf17a5f473e6891802f7f697e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e17d30983601132e27dc49930c44816d80e192378a9104601f8de1964552ec9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63b0be66bab03369170c71a581b9e402b42e92767d6874083ef4d9a7b0d9d15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32a43394d6c6a7abf126607b9efa3c48eefc31c5769ab579611156a7f75f5fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659c6a6c07918d13b42c9d0dd05774d424032dcb485de80161d52f4fdeaba110(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e5d7208e7858a2438d39bd7bd468dfceeb9825b08ffa1cc403f4e03b506701(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87fb12777b98a5132eb24474e6e035df0e1124f201c2667f94732561a20e5b52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8408af544ffc49b278e3bad0f7390767b63aa557a36462d16031bea1edb1ef92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8c32306826f984b511e384ce2ca07cb285df0703f94b138a142f936180f6c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838a961a788f11aab76d1399618bd0ed5db3db68a8b8c12ddc707f2ddda59307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50453d3ea9a41aec220d5cf58993f31d8857e823292c8c35b379ea3f7dc44483(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce364bf156cb1998e05f41cd5e0b803c2f2950e1bc205a4b36b15596b71026f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1baa99c8b7b6dc56ae5b70695c1d7ccfbeca4acc4cd10db7b11b6bb0451850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d7b349698d516b75e3394d57c1ac0cc7624f9bfe5bdd20e1e483790e96878d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41acf399519f27e8d98af68dee88891d1fa95c2be54367787f41b43ac4f1ea4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c262a56f638873ef7340dcba469050833abc511fe6092f63fe0c3b11e82f951c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b6ebd1575939c6c55bfc5b88c41999fb56a856c81b58841c7bea8ddd22fdca7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25e488bae6a96d8639988da3e5c98eda5f9f43de11feace668936cecddc31b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__713bfae9fce79821f08aae675800dd32f68c589fed91d718c65596111c2d5678(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb6401f2a9299230f7416463bee3067f6e03517de16a44b7848d6d653e785047(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e821ed09e419ce1266fb2c422ad3f7f9fb4eca18f2b285156c54a1e14cc16ebb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0158c65547bfcf8e34a67077ef5c08f49dd23a4ac9afc9d9279b5f4ccfc7fff8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b497121ed991a319391d36721f3fd25bf1c4d1998696cb031f2689998d5b2a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf718092065996306ca4736d1499d14108a1335deec151d8163deafdb3f7fef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d92b4eb2cc108ebb78b0950eae8abf7692cc1ebc0ca84ec48a3ab600e8b868(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381cbc35b775e4192e6513e45e556ad0ff4d09272b0d1e9aa514951fb9e37869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac00b0e6d9b25a71c0f2cb4c85f03b45a29b00ee519db322e8417009ff206a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e28f91627ef60f213306ba7c06e3d5f7e17e46ca8af20612058cd6da53b0a06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fadb7820db8e2b068f8cb3b39d5d7f1a849931d06eb194b0c691616bfa21b6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a64b8e4abf1fe9fc91154fd5964c5c11017220574846df8c0fbf30fa30f92c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea78019997760d84189f35bcde5aabc723f15f44a02b5e5bf834d4445f88549(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c6df35997665ae10750b1cf8c6d4bbb9f24aef4468f8f46d3d17ed07f8d8cc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c31b125f7912828183c07219d38ed233c0d5759eb1ba5bc59918a1324436608e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7e83e4736604357f0dc6009ea16dc1b76ae3901529af23db0e961805218b37(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094e0013b16fe3dbe4e56d0ea360bf09256963849938ace524ee91ba8a2702b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690168d41e9cdff4d5c36b1be088556809e35191ee69d7dec849ea2dd2eead9b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59899474f4ece4e3e6ff9654da6a9ab952f8a48d778ced7f583ceaa2427499f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9de5731dcfca9c2d39c9d5a8682bcaf1101b0336d2d3e3fbec44de6c2a93ec(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f7ea02c02d47d208ada40ed1fd4788d9643ecc4e303f3c9fc06f4b92719132(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61130c933bbd2efb3189d30c0ac9c61e33762168318d380f3fcf24e0e3bdcf98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d379605efb70e99169ed22bf675e96c87cbf14920e4fe897dcc848aef10ac56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb20643e0a18aa6c663d60a9c7ce6b9a949dfe34edca924c8af30a985a37cb21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92d59fd71b7a0fc39b79d8982068887b449e7d99ac4d5742d5c30d7b41a60dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5cc6bc4fb94b51f3aa1986786e967a43d265bbd48206a3813a04f6f9afbb2b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c91ace392ba90927026e6bbf001fda3665d4a4a01faf2ad09c9b52e24eaeaf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a306baaa921ef50d7142043def990642fae01ff31230eba802dba793d076f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8c367004f4ea7dab59cc6fcc5f959f598fe8f8c1074def2c1265db2f1d1977(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d672a4abbcf669cc562de39bffa752ee50e16ef425c7baaac85514741db85957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239088724e4b0b06819a3dea1ad466c50c88fc8f809a753ab7ca723d3b1c84ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddc424cc9405078f49fafa778e879cbbd8d79aba0f08b9f40f3d89bd2498d4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ab52f1b4f0d1783dcb2b1b4d02fab8fe31f3b83acb0999e39d22948246758d(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccb4dddabd59cc50d0097c45204f6284c539553ba3282481514cdc761e75161(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42aee0da135881327477c607ab1e8449176214736591b4fee8df615ce1d3d467(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36e862ec3b690e76979ceaf4f60677aaeacb368641745d8f527985062a445b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c874decd6c21b83cb72b7863a8da05936d1d5b9375dad8292c0e4b2cd1352308(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a007c3ecd8ae886fd6c3539ee946a948df289fb225942fe29346af266ccc78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8145753129a0d0381023d5d43f602f5cbfb93dddcec617b38acc5734d24d3645(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f04f81a306af9cbeace9286762b16c2d0468509a6b1f00143b4e57994d4bb40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ddfba3486ee71f9da56481b0f3d385564f0f5beab269b613051151e81253f39(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7351569cf3e7634e46e2f125b323ca42b787868b19621257087e3a67edf93a48(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8844a17f8db51560f03212904d3b1542d4320b0a56c14035f98d9f8164a3997(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0209a6c14961c9a4d7cc867068f2f9d45ff03c56a37790e2fa3f73c9da937fcc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2735cbe9a5aaaae426ca0660485de38e8b4dfc891178f9d3a26a46410aefd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c16024ba2b3f927a861193d7babd4fa9588340afbf12b26ea5cb635aea6f940(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7151223683629f78060fbcb94a52cb865ff7cebe80cc61227198b4277b6cb9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__640ae1c48a3f3386de2736770b7fa51f4bb2951320253be1b5710a5a131cc289(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3128c522e2a296b9c73e1d92634439af1833fa85cb40a7331e76dda7ee314d7e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f2d843228246f4c6bdda65482a1630bf0c99290846b6734eab83c6cd10e1fa(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3eaf0d49563dec23d71519be751209e6567f87a91c6f9e8c839af206c924f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e35c95ed18581b070d9b124b00e751a860d44dfc0d9fbe725238bece04737c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d0c0ff433b80eefecc2a77bb208c8dfcbd7fa96079af126a1f534348e52514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572e807746d4690b44c74362a169b637900b7e85683330204bfe728d5aefa9d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4231587d7ef59cc984541336efb1d11c31175d80d94e7a02a7954622469835bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4152ba17b022aa2dbf90f320ccf1caa054df75ab7e190a39b982097c384f92aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f264a7e14efd3239ed188f10dddf3463ba07708b9234cdaa95f71afcc10218(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3557ad8514bf2c1495446bb1de6a7c5b32088dd043f160161306c768036bdd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad601ef06c96c473fd4ca161923ec052b0f05c34b7cc7030d9119b52b8aad58b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f127a3271abe0ecd068c90496cadfca921f442a685c4dffa95a1b0567b5a63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52518211d1b167c16a70b6cd21b55d398034f19c8f1c99f5801d39d894b2f414(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89b150bd5c8b113d21ba0256b33903e3a7a0e0ac264a35d56f64e391a5a01ad4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8951421ccd71fdc58289e4b756816d50d8fb2fb6788508c085f4899a0c52042(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70605eb62c09ef83fadb9863f98d661dec6f33630791e48385c8dbe13b9932c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9535daf93db80a11c0666f3738ed5e0230293a95a919dc13a1d0304aa907090(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ee6fe5c41ced693beda99d90238af009a2e47a66253e421009ff19144030ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff293b21fe942e10df1c499eb760b16d23ba6e84f6e0c33cdd4662d7d94e08c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753ea3e71cce8720df8fabecbe6af2d287dde2898e3f7d4742ea88cb3c0d2b65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0811a5ebbf61dedccceebf6766d28e805daffef53ec6ed2af2a8e7b657ad6def(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8023e38200ee756eff592b6867e9043fc2842974649c5bf15992109dc83870b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ef8574c6bf7a7d1f89046b6ec7ebbc0ae0784dc6d895268906d134f182fa1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5c4661635a4abdbc39b8b60b07e19f0e3f8e18be614d89c274b9afb148e97b(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab6f6a864c0bcccc03601c02953b0fbd43fdfc275a61b5be010813477c8d6a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5cb40407ca0c0fa309a20687c69668b301e10c3253b33e9abd6e2eec6775cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c04c0af6c0dbed2582d754a4a1984b8381d5dc5a8d104bffa422a83c716e59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec657bb1edf408242f91a59d43f02ca2f70213196866237b9ff303557fbabb2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e94b9bc729cd98830fe45ad54e01b24c6ecbd5c0d913ddb8dd576a9e8741c51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da5b867cdcc63717c04b96ea3e43f108848fd866cde90ee44efad4ce4389443(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818cc3535886bbd43c7e610be55629d8bc94f63f6301aa0857eda5cd811720c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be9963058c5163e049f443b41ec54d27724a7c03b2714810b55e5d7bb0e51b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5d9b2883145c57869900d93680f8d1adbc6e9658beb92c2c3cddd1cd23f032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7cc2d45a64e5c8d9cbc63659c62cbc43f5ac10a47060e8c1640c7648e4fcd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327468cef069e71f505ca0952f6e070c15c1e1ce470796d33db176faf41910f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4960881513c55753c923ebc014ff37011c8b1bf37ebf2db647c88d35745e2a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65378c427987e07c8cb35eba98ab054222a8a3575f2b9812d791dbaf75df26cc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec51bf5d50db90ac76692c9f229988aefb9f04b72a8d582dbf7bfeb90b8f41c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac178a255c1a10f61f86fa146a8793208f774bc2d9f9d704a4077a45ad92c2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f39f794b39c9e555ba694c16907eaf931461762f2805a0eaf021326fa3e0a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efaa114b4a0f53e03dcdb0ba22962c352bb4f68fc7023ea459672f36473863f3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ac4936432c54614324f2694ab109e7d86e1f3cacd14369010e12a78b130ace(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d5395e148d88a0f127a3c9ff4f9fbeb2d067de03cb1e6c6535988327138a1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa13fd06551d134a885c92962daaeab3f17439eb80b6fe995e143e64879ea0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7eb81d2b4f63ae37f9861cd03cd5282c41f0f1fa67a43e1bf33d72dbb585100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62beda5e6cadbd5496a37e40a51de4c4f412f23c019a14171ca5db7727e1b44d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae76786522be645085b0d04249d8eabf00d267a63a01e641751a5eeb79eee3ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df001ff3663f68dd32db989137753190271cf7e45ab0a4430de53ba300b7091(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f45152d8038a67c4192f0453c9388703e214e4f47c33908e2679972e9011ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77091d2d810e917c69b7d31d821eb7ccdd8449c69873bfa2321325e4bfa36f7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b8c137116471813abb6415c4474a9e74a43bcd269e6392dd3ea986b4692da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9891c3a629961e11b5309a09781058cd2dfd5ba63e8dad7e7e81a62ce06261(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96dce1e596abd5bf75cd1ed1abad9859c5560baae0cb607142a4372aa2a50ba1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce59711a1c42e2c84a6ee27c24fc105d54ef5ae6e2314aac1cbd856968596ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f403d6bb466314e1ac3eff2364d7c535a40900b8f9359f1c320f5bc3e15c65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ae32e1749fd19d054ada9492e826f4f557ae309b6ca70dad12bb340ab77ace(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121ccf1307195ccc3c46c4578a42ab80f138ae074f96daa108b0c653604df254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af2d2416ef047ae55345ddbef427666e89133f994c6d3c6f7057242db140add(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3edf256d7010275ae5c7b2414f4c60f732148832b96184d5794c8c44c1161b05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17ac64a23698a9775c1864cabd0bddd504c6712e5ab62f471c9cfe159925d34(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad49ccb56cfd7ed7816042692f210c68147f73d12545080f851623fb0735490c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086a2a632b94c68bf3a73218fa3c274083b0dd2a6b5cbef2c69dc0ca1f016cd4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ec9c711593b1e0fef3b81f9d7fe822625b9366d89b08b127e324d5cfd18201(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e90b924c39cfa76d45d7601241830b3cced46fc122f05532d5c323f72d4f476(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3282a61a811f94199d07a02b0101a42a6406c87f38e6eac3418198114994aace(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae832f5acaae3159a50a61d6a25b94e9acba398fff18ed00b642ec8ca3cb077(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc76b4a22035cb26404a44c4e35a6469c29b6faeb7f3e85fc95608794b07292a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1422575a6967b8921327627fbeb4b3e63f893dd0eeafde2cf8e93ccf3249f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a193d50a82ec7ca4d0a8544c07d4e34dd53b4b24f59d7aeca4354d7cc88a7b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f567808ee1d4b972276c584e95f94d7997a5a8c544a60882e98cf8c8713c0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6adf1106f1189d432c1b6b8f6f9449af58dea55ff759ceb7dd8ff8b1e7c5568(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2b34647de1db69e1ff8f0f53213d70fb4b085811964d0f8582ae4a608dc812(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72a09a7489224bae7e8f84c63f2073b4c72e85897a7caff52e3a04e66964444(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81a31846ad1f2c89d3112cf97fd25a946a9f7c8b4f15d799c1e53058305d850(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c86898f87ad3aaec23ddf9799ad695da84da27d69c350059d9af130f6c24cee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec36251ac79f8f5a476bfbdbbfaf8f9ee2a00a9ebfb693ab2e2cd3180337028f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72cabe4b6c31a9c3587b1a521c06183aeb7f864e0878e4e3724b6af15e16e469(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2564d97a4ff59a38d914bfd230ea8874d0b28989845d4702ef35d17528eac9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6981be70bb7088cd08024b4aa5d9edd300eb46904b833eac921f12441cf58d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a93c4aceded282cfca59c3283dc1bbe422033a8dac96e3e183bbfa43efa510b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5cfcf82be44f3e118f00be8711cae3c2bc90db641fac6859885ee61edbca25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9956e522c60cd90271985d99688889a1cec80ea822ca7113eafc5ca907c69d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce348e68dfdf7734a5f0cbcce09feed5fadddef77eaefebd4f59a91b9a0533c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1711e5ac69b09de5d2431257aef7ebd06e45eb857e57c33532303dba59558c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908711e94fdc9ac4c4bcac5363b4c439f97a5d3af6385d8aaa3a2c1aaf143a53(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d74309fbb3692217e0cb091e2e567c2c20a1bf17e3147eeb0b7c4c435b229c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d2360d326c5ca3d06d9fd1f0f3875cbde913c04fd1948eccc466dbbb529c74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3cd9b0305a75f5483b0c0e852507e65972d6486a238e493e0a3e1c44233bb6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90d9038f2a2726c0ab856e753afe105d372a89c62fdd004c9f32716fb46e99b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064a761d69990e67cb0a3e2a0abd9b527f74c51b1931630d2f1d61587e53d351(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23b4470b109f3f88e591883aa6d6a8f4b539f17060ca3d5682c7623f096fc63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14bfa144486c8cd27de97a5718b457b88a010260c8cd3fe5daac763e264bd861(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5087e2bc54d312f806df1f54c4e2f8957df6f805f4c05c6810bdcdbb9d893752(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff536b3f83d311ef4335b81b8fdea13247a294ecead9ff35244a6d98fd55b1db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2334e7586f6b4af3e709059ea1e7e0f8fd5eb37be832109068f6fa7a8ffc0477(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc5ff833bafcd395740adb291dcd5b0c0ebdbe13928e8dd4d46a4e665dd73fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb032439a03588fe0032843851171ab68e331c7f7608e69145ae0f65b6a57ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17c6a214cde63b1ce8e8e3023de5d25cc0ae0bcdd4032c0a118e96e0ee078f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36e21b61bc9455869350ccc5348091eb7ee86fc5e6c77419770bfbc8cec2f25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b3b7d67521c02d20db9899f5c699be2c6caef7cdccb5f3698da99ad47605f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e906b39c5a0966edc891f022e2801c27e7a2eeca23afe8bc34cae7f197961649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea77d8f7b8c6af9794f44f3fc694c133f01b8ae6aa33b8045a0130ce434290b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e933f639c05ab8e0ab9ffabec13f35ea03567b25b87fd1c38204c077f9244570(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0814851c6cc5bbfceb9c05472cb74a7161ffc4f8d75236ab782ac49303622adb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e6ff65320b1918d233e6e686ff0843b1cc036e5eb0a0ea6345a289cb82938a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761afbab7df987431a777c1c75387c0fdc6cab5512ecbb55f8f620ffdfaebec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de6a8b72f87d06988374cfaec9ac21e0f81adad0dc796eb619df439c37ec630e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73f1465e8184a39eb0a5e1b4e0b8bebbfa32bae30e4c74b2c9435a18fc8c921(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc887e884951dcab70e63900c28c999f2a626e1a93c3cc169d56c212952a335(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b08815d136c77fadc02a385edef7997d4956d6367542fa0fd0d253f395cb7ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c6a4a80191381a6c2c7e3688dd19818f749db4dea4f090cb6d54ef7ae859fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4209bc3ec4afb5888698714956ebd080664979b6d8212451315a4a2f6108772(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9ff4b1378456686d63886a75518666722f6b4e241eb6758dc4a2416d0932243(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d5bf14f8cd3c6d30bd1481c62de17244397b655c872ddf4e7dbe8c84dda35a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89bc381fed44f7dc28a09d90c279021e55a52f2f46fb28a262c5548842c1a1b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3781e2f24f0c434198aa6edb1750e1e24dabb9b11f3cf14547da73c51d34760a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2565b57874dd57395956d38345da00fa327ea11204d6542bd10c0acdadedd07(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1f96dde4fcf23bc00f10bf5c460bac8d6deaaffe8b7a0d516b8c73c6fe4c11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c57a601d6929aa57b3ecba0ad53a73866c616807383c2365513378e2e2599ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9f9e4dafa4068c43ee9d91339cbee6c15c12283f38800a99e8f3d3dd65632a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fcd65e2ea0cf3800e6c506b83ab915c0ca83f2f5d9fe70044876f728ad9bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96a3e9082658ab269e9d65490850bfa4adc618bae20a6cfecc6eb06c454fd89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9537ef1b736711a2cc293d07ea73025cf285e39ba4c30b5d6ab728f337003985(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f959e7dbccc14f2fae426a4b9da0472aaec3860e4f147c9ad0241943d4a93d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581ae9d83aae88887d32f4451493165ef700550a741187e12831de89c41b2342(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8faa5dc1c66a248d02ad11374ef0ae22807924ed97bcefbd4e238e18b2806d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d521c7468fa7e2159517b9e6d82d0d81e9031fbafbdaf15f9363a9ede924e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be62bb8d6d3773484f18610c21b0975b89fe636cc67e8ace0d78a6d2e5698c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75f7b51c83cefbd6c9f8b74239f5b5bf9627e15f041ea15b129a80bb4cf5bd13(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc0cb978933ac758e0fbd98f749795390ef47fb62dcfe27041b796e94dc38cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31645d2789440cade2c8752f222765c8f4dff594c510b1856df2eeaeea50b174(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9637782e40e4ac37c24b1fc1908d547a8efa9ec95c12f61908e2a37af3fb1c37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4ec1fa3208fbc40852d7fcada2eae3fb913c30f1634dd4bf8422f7398f8ca2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de89bc202aa18ac0eeefa2278b27a6aaa28ccd3eb6887e8420a44098349baf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afeb861ad06a7c3ff1ba274f1fbf55490ac146f4236734041a03352f5d2edf35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca03ec3199594a36700a91e2c7a243e6664b128e76b9514e9fc6169a6870c916(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a7fe1be814e85d921d2291ed83a9a36105753f2bdc6d8f73e4285053d81fd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db30bd7d987ce651ef88821ab856cc583bfc08776ef09d042200a09f74232b00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6636b9dba750d1e6c9b88ca5ea58ecc3dd2f6ee109ae0dd95dc3cc669434d5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a566b6f270bc12197fee515bf724e24102abd38b44a8a0a1a1d7d68a303afd6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc22dc54c4b2575ab39f4bbd8111e0371f3ac1716036d44c36845da00263359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb25039d5016d726588d4fdc49ae0dd0183564eeb27959dfc8e51a79b471b7e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b693a6b7226332e06b5c393058fb5287ae0e0d9f4c095929161fe91859480e09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604add7c4c5bd57186101c3f729ce5ce788d0ea6e0923c8b521c9fbcae396a7e(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac531f2b6a1286bdb21f89515012fe2e7ca7a4ef2d8f003d7b06eae8efadc1d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2aec0fd2359f860c858fe3426361901fb36c106eaf72c956bb6261d8d8a311(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969950eb169a7699291f10da531cf890463dd88f97e4cdbf01b9485b3c5ee40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6d6b9ef1b11d1e4a1fdeae031715fedf0184eff9174910bfd639970d3eb00e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55fd1c415f7c98cdaba07150334c080e59f1c8d35d7c0474f2079a94e1d85714(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae39060065760819c57534b86aab113d57fb0acc18323e5cf50d3fb5ebaa9a31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b04da04088a59f28cdd44be26e11999055498dd9b4d056a306b6ad7e9b83e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a76b1119271609ddfe3dc3d161f5d25088f273b03dddfe2502b0d5def180b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2734eb77fea86794e7757602bda603e96dd2bdff4fe346115975dca51a18ad04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f0ad8254fb4f590f9d4c15626500091b2e0e7b22dd9726596a568ab5cb158b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143fb4b987ec7868f653706d70a7ea6ae3f0ec03d4b24611a6cce67019634d42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8825cc4b6073b68140a2c9e1ef59fc1d6238fecf9a9a15d038059ec310e84b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e81fe59629944909a511bf199fed400956d1d729e93e9f621007d1128f7e6f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ea3722283267b952e7120d2702a72fac3e48b7a4ed6a9a99aca488d2aa2958(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e36fe7931d3ecdda14f8be703106625fa9df31b619f2977106f981159cba5a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20884a0427cff14b730bbf62b0ebf37f0e6940b397043a8dd16b631f6d94477(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0cbbb3fe677c84bd8a68e3ffad0df8bd78ecfda1aeca2bd64a2e304777a64fb(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226d2c8088fac0e441cea3c81fc46ce8485e245df2d0bd78eb0239364ff79c60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd05b40f3c158921ca4ec824eb2383b4030dd639b813bbf516e93f9b0644360(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b853aff1b8398f2f63ef27a54d95c478df3fe10896136f5464e09bfb164766e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70f94d84c34c7ee745958d1567e253dd35d2e7e54b1f6497b3b3c926153ff13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec983802303b302465a4b71255a687e5e1c34b98f8fb9da24510d311fa89cb6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba4b45688dc9b99b9be51e4774aa8e042ced35783a2b7da2ac8ac4d7c2b4b0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d1318e254ba97f11e1cae4f920ec38460b859dc31cb1a8d43194280aafd2a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740c71b7e8784265e98bfe3664b32469c50ed9eb7de6aea883e198620507327b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c99eb860e72e58a05b2262dc241a7c5505b4e3a771814957f4f75679595ef5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b37385edccdd400a77fc17bfcfd826c4c08b407d222dad78300f57ec830a532b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10053568043ac035908ca5d7255583eadc5acffec9fe5a38b640ad3e86b9a396(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5564a717af3d0b15d11440d98f51e98e748f69e3990b941ea9a063bf92c22d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5638442d688d46191d8e51e0837448c4ab1071b870d879bc7d828ce5ea51b327(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1482c6927e5724f979400c23bf1620db4c43fe9cbfbe6786a5375583854f3624(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3921c3669fa63016e83bee4b7490e64930dd92feb584f5a04bb7768064df7138(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56dfcf7fa3382b0ff81149dad66d96dcea49f6155647f7f64bb3b1340701fce3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a8aba07de1e4706a30a92c0094470425f8d046f36b50628aedff5f645873d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28acc1c569d2555457e7449277c5b3203bea9c2cd387a2c6dfb3bbf1730fedbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c496505b4043340beaf8786ab5c17d3e037e223faa3376c0099aca72d3fa6caa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be4e8415951aa82cb1509cf01eddc8ee0854f97f990e761a9fc91ad4dbc191f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e161642b510bfd6dde283a234969aff839a7d414b31f6cbd5ad88074b08e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065b2a78da73a71220dc746abe83fea456e5a259afd42f5e5a0150c9777020ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d6978dd49efe8735772acadaf3119f86aec9ae1bd895edad1c7586449b963e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdc2eaa1c2822baee8e259b96c45d020b9fe4d12999173083c7a204c895986d(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24986ac22f0a946e0f1fe1a2b427dad89e263b575b62ab4ecac2ea1c6eb1cd07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2464ab0002a94b47b492887f390145f30d2d98f3a51c3ebbfac2991045aa644(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7094fb53bae204b2d42f0073b5ac701f7c00f3f31e7248d07b7b8880e9b876f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b22876071299627e8a04bd15911be745668109a78e5ae26c0fc270df8174d97(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0670c28bbdde7524cf8ccde8a588049653110b37b4c4b2e73b877cd02ebae6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcaa01ed1499e79be7a8533ef2dfd0a91b5e040f34e3e3ef6e317418da0176ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bda9d4912e8086c46b462aec1f4fbafbe83114e627893236a6f95586e4fd2fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2229a6014858b35ac91da15748a4ecb284e6ec61e3546f8ff78f1ea17d49291(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d19918501ea06453f963edd417ea2be5abc8d95e6297eb9d29d2eabb11aaf77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__266aad17f6cc1372cd56a2c94b352869837d7a83288c3c1ff3c22128cc1ed695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd02e1f1b50552abb37d56a68144dda0d4df647b9c2794c7f397b942425ca58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1438265323df3bb1a6bcb37128995f1083557c04f82614d9dd635f6a4eb1be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45419d18af70dd74d343fc1e5c282ff2a1cd296564721ab158aed908ff1dbf10(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0756d5ce29506d7612ad7c22807a7c98de3b1da49d1213168b7cf1c8dff9c699(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd527cabe0e9652114fc0bf36f4a671ac489eda5bf3a6de3b209ec2ed41478a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3426d0aba6097c2b318f8eeb1499c090753275ae459b07266db31e38c32c73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f129b38d31b78a72528f3d8def991c846f6f3169b17c6510dcfccf7ea27d884(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ef1846568ff7f3753bb62503e41ddb04ec7caca9fb70cd0cf5fc5c391679d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9615621641506a657b523d1052e6daa4008146b924f1be99b0639541dca555bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b515bbb808e9dddfa1f9f5d302caa70a1c38731e8f86d44ae01cb72b34e9b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36611cdd27e8271820d9e19f3dbeb8261ef2b04c54cdd1d575087f968e9da45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd6c43a1ad486ff21523b93fb1633adf4960171659cb595b428acb68249effb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1c1c568f164b41c64e7d3093ba41983a0af68498d32b8387e54ec737533191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8333e755c0220ac1a531bc2e360248cf18b1cec111ab8260d8453c7ed8751c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52921bdf66d4fbc175d73a0aad1bb5b20fffb9bb19bd4ab8e065b48a4b65a323(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7cba72ce27e2a1a58a0658cdf6681c518eac31966d1a8fa71afde7825f91e2c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589025b2c7f4d21882801993427403b49e2c99e1fef93a08266bfdb9f1f76a6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8681999ee093e5c929bf041345dedda11b4e761507a6199ebb7d78ec2f061fd0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a436205b5b81680bb08e7eccabec4d52ca7613d69c62996eb17b16bdc794d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901d6fd1d860361c1e0054abb5791b792a8f752e8e85356d77d2d041a39747e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60264b4563eee38e3805021afe1e06cd57e523dc79472901b87ea52010c8038(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63cbb89ebd8d273d81de18f34b70b28736a88992704cbac7d4122764f94b888(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c05f3b7280490c73e41a28f7cb12f79eca92b916b97da73614e9ae657748f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91254d2287bcc9ef983e5fd4647f261cfa7947cc9c9a040b01a855caf688f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d3b7ca6aa0aa90131298b4cfe98c74895c6be5dbfcfaa7020992b3761743c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7897545b48b0f77e3726e5154395575bfc0f4e4aa005e4e156d89620b97c5d46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a5c53d0c3ed40538fda7f0d4fd541a86b25c545b0ea4db3340accd4652ff30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6baad0b14070f54ada7a058869c526103a22832ca3643798cdc906850bf1d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c250e811cb437aef90a433b831a2b76b4f796685a6f31975f60e91fad99137(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb477791d526ea02a89d76e2772bb4b9c9f297bf65216579fc03c06545ba23a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969aa8dfaa2c874266f7f04040d24c53166c73e1eb0eaa7cfd7bff617e89e23b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d9f37947c4a046f791e4d7b276b08eb7e45318301c6ac0aab15cb0aad2c2d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3718060d9305039bf375e22248b1dfbeab8664fcc138afcd536796f323a6669f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57bcd264ed5f86fc079fd705cff101c0aee48d35e308e17a30d03b9e2ef36292(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d03737e94650198c038c07dfee13c1762d758333ee9583321367e7cef2d467d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66928213590319f8ae06e636e836b9adcd298ef18b48100c34ef111c29bd0c87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3b4b56d96bad836ec7ebef3e1e966ae215f3e82bcbb9bd25cf0873ed898605(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c4903c9e1e625a05e8f2cab505a322acce7565d559eb47d39a602090b58c9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58b8df6b1a2e13235f45eca35d738503a4920d6412e3238ae940a867a0a1adf(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b4d538f2e3c95729d37b675c669bacd5b990e9d429156d05c4fdac18fd51a1(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6b1c2c18c9fa1d40deb1706518ba38b42d7669185f95fd590bede37496981e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6e1cd9b61128af5ba9aee29d13472ed8ea2d907347365b98eaca125eabc023(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec8ed946289616db87b4fdefea972ed2857d3c2e2ecd3bb1084512c96160ef6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__447606dcda1d88df45e3b07afc2bb8e41b5f4262b9029a8e70f0e3502aec2f6c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b766a6501345dc324f01ee2a414d365086be676d57e8f008666c10e89dea4f9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5283f6ff2a81064ce08efb45c2987ddd76ed5e426ef48262a6961fb28ed55d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9466d8a5dcf6adaeb21f3d35f621b43f8d75aaa5f675898dbbab145ce3eec37c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198b9cf0bf16f6566bc9df03caa9fc9a53f1a9015c2395ad3fa7daa0e2c1b57b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b98d29af5874e35ba99823c839021b1071984b3629245560f0c9d0a0393746f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed8cf74a4f45e593e4dc4058fdf362c1017f9cd87f4f53480a8e0e512f23007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293cef8bb83b8121a4923e6e91914853bd01042bf8ff378948e27eef867ddd9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7146c44898462b2aaf8d977d66dfebd0688122b0801739eedf871154383de3f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393936fd68d9ccbc29c5c9ac0690536f2f5dd99421aca7c9142916ad43ba58a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f195f67a0f8633f2a7f3e6674ee670acda2c1a570336d7b1bafde967e497a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a021f68d7dbf8e9d7f7eb6a6e3681887bcd832824b2c170db77895e590cd6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ffa0bbc145789ccf56052cb4a6a298a0ac3818201e4a7873691690e0896dc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa108dbb4837313c9162b8d6a5b09bf281dac3499c4fd967591c60f15daa105(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c712a6724c2ddc748d900e2921d6a0ed5a79e96dcc3c8f78e3381b4d58b6858c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a88fb0664182b98710ba91c1271d1ff7f7c8b3dc9a1dbd0b97f1e8e2b9f045(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43bf43d12790339405e809686283ce4ac8f48e691e95aaa7acfc7c49a1754b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c80c548d28065ab5a15cad8dd6b9ec67c9aea27770a9ff6a15cfe1ffe08dda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a642975c022b94340c9ca21ee7265486622564b479a813c6e910263d0ae18f2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427d4395fc1584c679a5c8eda194b9e0660cb4e57f03dcc5597ba13a227eb775(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b7f49b03bddd421d60201ed310a7c4e5f34404ab8d7f8a57d4e35fc6bd0e47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8417f5411466fd9c22d99e3a6dd79b80895f440439f70644fb83f02189ac6b82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e9c21dab8882ee287cc11c95fe7e0f127a95f0e78c22e63c7cabd822979beb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05c08ed553f6be6b4b6db4144a6196349a2b9af53d48745cd02f29db56a2db7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3efa87463cbbd8a2b43aba7677441d914ef9ba4c0c15618b7b6fc654e5b9476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2407ec9b49fd3fb2ac199116cff6a836261dcf824b26b9deabb18182adf55b2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8965e8009508bf06ddfa3d4d0866f5e5cc03e9b221e1fc037dd568f80e46bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2ef1c44708e43b695cabf9d506ac400969e1387529df97107e3b211c10fab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a3ac1a14e478fe3cd50abc6e0e676b62d1d037586a1e180bcf1aeb92c9a0ec1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b196471cfa6f5493a9715007b7a0b1669246b55e6f75d75e5a7a0a9a5c7c0381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7db7d9e2d7bfe44c5babea0c3e334c887c59fa7a9f38f22987b75a296db080(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8043c0fe9e86f7f69d6bdfa9eec63a481764cee09fe14596282dd92a5b2b14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ac90303b611be819ca73e645d75485e2c3cc13047d9495f25701b1999a12f5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9831e98964270bd940674ed4fa5db8072fccf9c0e7d0982d735065ca33f49dd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ee36c2b869debb4b805fbee53dc331d01f45b5d2674c81b59a482b61d49cdf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d2252ed193a8501c83ef854dafedb2ad78af6b3cdfd6fa3fb32bcd1cdf7e71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428b5d032ebbcbb482219d62219adc18cb0539f09034ffdcd4a228681956fd58(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ead7a762fdd094ab2ad6c12c65f14866d789cea3ae393abef637ecf2963a5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af88b812cb1ffa99d6ae22d74bd3196c2fba0713a97a7d18f16698a5663af150(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f445559fea547f2ccccec4a586c28ff1f671cb4ac8cd14f9ff81ff7e9db1eb61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a525f7cc837a22863d362f2a3eff6d187cf6191b882475c72b89f8760b932619(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64fee5c69a7adb379bad943c442769c7c4bd1961eac1aba8382a40af6c24c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807d70a77b2103e78541b5b4c542e0c2173a62e1af98c01265f397607b1694da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d08e353f2546f9f3ed8d5433871a7890e0d6a2de58a4cad6cd6b26f6bb23f2(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3e6e16fa1c3746d284f4f7ce8469c7540aeb9bf323225b5d0eaf06ec85e42b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55356dbfa74db082549eacc4d7b389618123304079c048461d9676bb969650bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de6c0a9ad51997633381565c60dabeaed7d85cb3a3319b59e97bbd04c46e1a8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c56dd9e6185630416b99cf8b78c2bd7f3d30e0e545a6f20b7889ee1a11f5ede(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686b26a303d93ca0afd9d31ca87c32b4d8650f36af09244fa810c5fedbf3ef44(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5019571f3cbbc5a80aee63ededf661ef2a22b42977d66979ff9a7e03420ac0c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4722e1c84321d51ed381fa6dc1d617c2c8e27a933ea489cb4c8b7424ffe02795(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeafb6d622a4782b5994d2bf6f2db0e765af299a1137ad2afbfe08a14b7eda8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97679f14bc8690b16033bbad490aa38b6f181bee3df37a272eb4ddf684355ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__778d658ce0820477f3067d760fcf3f79efc5822c609f84dd37e7346e1cccb632(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5e53331cd7455d09a6ae666bf6b8de4df75dede29382eef9ebcebb776dfad5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18645ec6a1219f241e2ccbaf141e0b4cdc1e138a13ddc97817c7d59275a84ace(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d92a63c43948004ed095b52e3bcf5c87f6f49216989fe8ff5ec6e2f048403c8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69485887124f1da180a19ce84f8021c88670dc17d06f64d0d899be4ad888b8a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce01aa0956cd10768f7ce172de2d08f75cf97138efbad03b1bc6ceb794b05726(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb902f30c8b3a138d277d27609d9615c0f0cd63144a8361eda283c058c284fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eed26929326870151e4687f140f84efa3625cef5cf0cb048204e846cbc4973a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f5e8a5f9b5b6cfb79e4e19aa82820e83e66e8fda3f841ccd048f0648ac031d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e34729072175945477f6c82fa4dabf67bee9e95d85494be1da362bfc8f62f75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d82797d1feb06886d1d2e62d6241835a869b972e0ba79bff2ffaf739c590d03c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b8ee8ba96f952ffeaecc95d04a11ce19a00d7805a1371c592101f413585efc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d148723e11b27484780cd10fc7698259174b2ef2ce51fca7ff898667f5d306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b2657c3f5a40591e1e558846fbbe3fa2002d10aa54568bdf13913fe9ba992d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__852ddba67992956d59fab9d9b04ba037927e9d30b5a756daeffda5f7cb1f45aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a63402e1f8f476b84b836ff322ef291cfd6709e2bf98fdc86ef8510c9318c8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5703925098862e52f707f4057c8ae1672ad094537833d3a3754d91a60332b4df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5f73be7f59053f94a9d6a6e1c123e64de743c631ad57389ef8978c45d64b19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6d1e94bef243194bfd606538ea0cd4f601b2dcc076976b291823cbeb8c28668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9713bb965c2fdbbce8469ea031b9520452941d46145e9a21caa6a6ec7104970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2620b62cdf44885f1b0625867141666d31e5746ef53ccab45b21f446f20fcaba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8d0a93d785de0cca8ec48eafd1868635754ae436b8bbb50ab5f770bd3af6a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6275547150aae726bc34f77341847865f864b37452bb6b784f9f9cc83deaa67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdbd7f31fef4fae6352d8af09687ccb8ac50ee765a1a9d624be05e66c732b3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38629ad9459d4d91d46267b41f255355fc19f61aa17c6f5ac81160246374c9f6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e381525b0f721b850db6ce5d90a4d9f46adc7f6e7982c55ce9febc8907edadbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3522fe9bfecfea3725ed2ba7863e111a96ee776beda1a3b6c9077f7d4efc65ed(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841791096e0ab5da4435247c8985149d9b240b24e67f7b701f9d35fda1e2caf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2373e0511a1fda9b0bff5b6bff4b04db51a2fad6a0fc20bac1fa19406f6dd571(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55957c796acb4932848d200a20ac91e139433ac40ac7e61d7510c1d1bf303c57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff6cd0064831babebe62acdec0bf2c53acf9409cb005f8bb333a68bd65cf0ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce3d5f54801b71ad2d95ffff4d65c275e2382d0e0dcc0e0065fc3e8eb7d4b7b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616e82c54093cd42736f28b28b1f58fe85beb46d21dcf44a76b8ef186255c774(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9c7c520a6c53ace220018c8769c9b81c4e4f883023cc7f9707cdbb9477b932(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc39eacd51c2d42de6f09fb0e817ef0f516b4ef03eba4424e3f7ae7d051e5dbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f4d650049c8e4b249abb4279ab5b55c52e786891b8178efecb6b39fd93abc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7504487d03d865e4c6ee00d8211da94c5ab90712fa3b13a936d0c6bf2fd700(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2f0428e2b437dbb917cef6feee05a5b54f8c1af1061822656f5f985f2f8648(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38279483bb1800716dbf9c6ab83f66f15de35a239a65bd40a97c25eb1aa1eb40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30c4fae8287ff3f9c7ce378fce75d10d369020194583f7cff3ff251d9ad7c479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da3830f7ca4bc739fd73dd8d35fc0211a451f31f75e293c76274bac76553ae3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8bb7b2bf5b9947c4e8c0c4e3e9b6927b7c0ecde4523dd827329bcbe07000910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d614059533071172304e6004b7a1d496cdc3f3b4c232b7270ae20649ed577c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6890c309a8e31bc18e97f035ab44c5bff3323a1fa2a44258e80ea56a51c130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af521fefb0215f8a247695f699872e5227f3a65e5cb322ff9e758090fe55e221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1547b783f252c4e9c4a1b598feac0f7a4af16e6d4ac2899cc75d6b85389e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4295759a2c3a4ec5d29bad38dc7fa184720df75e595ad64a151ad971830032(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34d568eff6be4fd9547b4983d9b4b4bb7042df817cee8ff57119cbfdfe5d287(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__646ae66d95b641d676c048ef72cb9e843b8d171d8451d5e51179f03933c6cabc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a250d5e1e60b73776cfd602d14ab63eca80b819ea2c932cd4cd38ac8deb21f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b16906977fbdf9146016690b1eb94176a7d278e5517ed440c6b56563fa575b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2daaf6768faa95884d2e241d62fcaac4d8988e1883241644b629284887727d9f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7cfe79c416009a0329ff3df09162682189dd8f059c773c11609355bee0efcb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b0588f2c1c2c0daf5c8f92a58a73d1e421a6e6c79a55f529be5544077d5b6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f9929202ad9a211f228554f49dad6eeb35130477752c37cc98becbda2d0218(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7634ce92b57581ee3f80758c7c83b7171fc23e8f2ed693da069eabda2ec01fb1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c40a7a2a2e58a344ff824552f27543c09d85323f17923aaf6660745b6f3c515(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa60ca7edb036cdf3afa19b7d093a248b33671bf865fd185d44f774fd120d7ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ff8436987932d72cc1d5b6aee51d23629a9418c22a110fb1889f7949c51760(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53922fa2bde919c6e3bfe97c3739520546f86f7e94146579f2fe55b7b09571a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae7533330274fc0d64883135d5c30e526eb26bd6bcf82d580cfd83c60f61d10(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d5ee1c77ecfeb97d0b559284b8190a2c64b069c4a962230fe78d7b4a445913(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b968098385a11dcb9f8112f222761ac6c2c501a7d959c89fce7ef2de64e8bdac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709c7b51c57cc63d35333a54a4c1ed6d927690fd394d843b3f100a67af2fa703(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e30b55b44e62809cb58b443daf923b6a33171eac49f6b6056ad67471202af56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6e1066d6e0ce46edde38e4e92229df351a1f93a4f5b667016051259a8a4d5f(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b986c3c4df16a1a702bdc2aa254199a747c2c2bfb3fe9c6f66c667ddffe24d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51eb9a653e106c965381475b577691bf7ac3aeeffdda931bc96b13d7269432ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0569551a823a61d74a4b425189d5c47930b7b32cd756b941e6009d42f24c50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb28e82b067f528d074bbe2dad519ccd070e51e29dc8edf894ea2eba2b1ec52(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6bfbd1894a641a5de1b07bfa548735a1f44f945dd1b7cd9d17d203acfcb85b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e78d38e233bbdf4d77572b4284a63f524a62aed70bcaf9e76b9e7b78a7656c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89bd662ec604af218310febaee481617c729d843b47262f4ace9e47ae5139586(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c96be181f75718213b84beed4ac3e723cda3831645265cf32066efeb0b8dd8be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9ec56bb82cfe54694bcc93d48de6eabda8e08f81ac486a8c8d332cac8a26ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76cd548593d1dcc1c3890ee7494a311434591579a8e1e4f4e237b627149468ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d143561f26b5d99f7bcfb7fd82cdafd97bd24da539692ff19173be9452aed97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59261038a06770dedba08a9bf4c32e86db578cb928fc99b25f6fb2b8106324ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e71d5039d731654b3cb6b2ae0106e5e9620219311500c301c9ec9c8a8ceb5d4(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db1c04cc93fd13241393bd7ba2df56f0abeb7d101177014c0c3ff92071e4424(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50e8f74f7e7407dcd238db5a4b864f34be361a5cdba750afa92f7b681fba3b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162997769c87b0f045c34a397fc425c6d356821ddb0c65da645bb8a2cb1f4dce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf773b5bb9dbb70d12b4677f058bb5c7b0880ac5da951b96b0009bbd7a31743b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f7145c4c673f1d9782c36bbb98e8ca380c783974fda733e64014953e3be987(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d223f78010284ada21f8972e6951b49d6e68a8ee0005eb589b161857bf6020(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d64e5145b79d21d68b8e81047f7b4c31dc858ea7c16ee0a23ce12263d0c72af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6272f0dc2ccd3106a7b7887526187a6b34b023382bad16927f882cf4d4c2e6f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0870946d89c9311317729a093066a1a81415f70c510a21108ee194403e1c23c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73580bf4de39fdd76bbe6913869a85000643c70fd69bbf35eb65693a6874bc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b453d6a891777483e3d42db83861a82f7fc1c5a9543517cc4eeabbf9b4efef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0297d91e340dd479a896aeabd166dabd1869424a386231df06303d920868ead4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f59d19b234b2f7cf2ee1b3b1792d8e8a20d96d7f53372ed98cae8668a7729b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe5e61d905e05d581a0e0419b414f73a9806f1caced84356b4543f14880786d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c7c27d410ed9a1631938496f43fc14d248b0d23501b4f1721ecceb374bc9c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5497f33621d0ea99427535a2afacf6e9434c0d522209e6da6dbe01dc42f1284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b47d67513e46f7014e20af7b26adcfc9f8b9f276405fb7ad8aa568609c4cb5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7002785ee142953d7494bb1d071873bd8a19a53f22142c0420c24196785bec11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8f7bdb34ecdefd049b5c758854f4d0d88ad92e33bba95e68d1cb45f79d435f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cb78160bf77ea6b177ff574dff3587b365b6191175f0ca81efdf969b1b9ff0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfabafd89043c0fed11b43f535db435134f1a8f6df533614a29396a367109ed(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d05bccf0787a3dd18f7cc12e35740135c54fd50e738b4fc1f13cc360744bfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b885fe512fd8a661bce20623ebceb26f79dd56d231b5887c0db241c97451372e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1d20fae44229542685a7bb831f89d53d8d4d873de1ffac3e3a0ab42674b93a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8626ccf1e064a49a2cbc9816fb463aa4a07c89e7634aaccb0ee7a9bb0890eae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94346e2a3f6d6c7c81c52a117e571034ac6f752ac779acc157fd1a87b59a0ee2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0d72410e01163cef826bd59c41ffde20df33b2958807a1d9bc99907b56a0fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37e29022a8e3bc2d448e8ab5c407d782419b6521f7a66751d5678f3b57e1e4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496c826b7f789b3f23c425daee55c70d845dd6035fcdb457c8a08c253e54269e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3c3730ff5998b7b317012578894bb23d85bba1edab060173d3591be71ebf17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a925668793a4e647ec98cef3a88802ac6ae290cca420078a03a2627b23b07135(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74db0073999b9ecc6242c1f314f993b362611cba552c0e7641bd25030d80bde8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45943807ceb213ae6fb420d3dd44ce3e009f8172fc1833b27bd110c0efff7f93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e67c7b1491b77b18e73bbeed7af6c88337041ac51281ef4665c32bb22e5659d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d253c034d9adbf1509d86fedaafbca3e131563efc47f9cebb4eda8f1cde32f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2010b3d626a8d0104dffaf9470d392fdfd015ab9af7ee752942f14f9b03e98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abe74b0c5ddb6a88217df57073bf5db95bb541eb4f3a10d41c98391925b2fdfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e4394360c081517223261bb91236ab1ef7d5789f2869aa457b4c3f8ebe21df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f45c0b5edb4f12f78c39629d1079f96ca7b0e18c9e99d3ee0cc5bf68d047a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c92f2e77fa771c22b60b31425d974d551448fee906794c120089a876fd5b0ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1524a831a9b0a81a5193670d911d1b295dc00ec1e67e0db2f15c0a53b1a9436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c702aceea3067e43e1cc53f0a056907e257c4b0828833bad5401ded42cfff8f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdddc4fe499476973c0142ebf5ec8c89ca0b449a67fd1dcbc8a75bbdca381988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c26d787f774e005cd27e0e77925d26aa21bee2cdd6993bdf9fc4f61b5d6c0161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58782aea60e4defba3aee41588d50a7e1256f1ba3958840b26ed0303ed9d3b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e32f134c895dfc40b5e8c91a6dfc28cf2bdf44f98914e3dc3b7a6b78dacfe9bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a998055cc0703fb7561ddc9dcd622cb8ae5b5d805554020a373fa86d3fdf79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b729a7e48c4f343c8bb40175bfa207db5722185cbcf25047430d198d1d678ef2(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__839212a1a6dee7c12ed1dc9046e2a6e35e0209ea05b0abd8f2aa12e7188805d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21343980614c5595c858a258701f427dffef89b0eab35882fb0f06e8b139ff9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e85ead591bafc85f00a60b6de6d14d5a546101f32215d52596ea06e66565dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56e13e0126cf4603f59144867fcc7bc259d9cdfa895f76a1c9366bbd9cfc02e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d668d7a15de1c9f2e2201628b97914a9b71725764f393f221af6eb4c0bb3fc6b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b28e472c6b1ced6bfe7dc2dfae4aaf26e869f8eb5c1aaede37146f91d034312(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b441bb355616ac5a81c7c2aa64e3a941cbfe320300b2c2724838c27a66b51039(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d825525481494ec8d4e6a069b96692bedf1d25d2727d1fe72da4379f7a32ed75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1783679edc5db5baecfdd5c7cfef913d23010d2b289058ab764ed6652e9fefac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11cd2172773ee8390ebbfd1663b85168bae16d4893eca1e0c283ad8480213f38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495096341808d32f0fb484a3af4132ac691150a88afc5fdd842a561e9f836662(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747f22c95a7ae03482e18c3ee06eef0e9c37c7506dab8cca1d5c2affaf902d1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2178116a82c4f627074df0b2c7b3755ff8ff83d214a28d92cd8e74bc570f1dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c54955303afbdfdd07fce91fe8a6d21d3b05d970468493b62df26857167c4cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad9ef3e4a985fc4a3b684e908e91d311686a6faa0488d257dd74423628bd73e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1e8b9acefa7ec05835409a9e1a692bc023bb6e61fdd55f8684401f915be3aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6160f2e4f176f4634172f363cb1af0bf586a2efb8766984639aea9189ce6b78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeaf336aaf50206c769ab093d6de6e948c6786566dd22c89259ee2dd61ab07b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f00370386091e3b1f296ca04423969277f6870750528cb02fbee284ffa63e12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c184084d9361f73184d79ca3ce03d32f480c58dea5f31f13694a59488ba2f49d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc182947119c70e201d53c735f2501381a726a270e7d22f6a26180c0e284acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7b5d96a6d29677896d7f280fbf7b95e20cc81ea2b0236f87a89ee37a3d0d09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b161de8d09ad8d6e5c5a71c287467515c583972e5ac1c0550f55328196fe7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000afa6b896d8217997dddb5f6af49229f8af7765053d85eca83952b23d8c774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e9e02c70e6c394adc591983b37fe693112f7c3e6e9c41e944dffe9785e5b18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd240bd5b850f59a0be055f930f9399bcb3d2834be0468b9e824c63f6f95791(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f3df2339a61c2e94a88b153dbc2fc25381bbdb1338ee33f4a8eea836649b9b4(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e58006366c8101fef9f626dbb7d8c55b93b3c4a2bf3b5a791aad0c76373a86b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e3fa5c7e80068b899445f172f3c8774229fe3218463f073468d4b9a83b8e4b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf692d664f3276a7a29fd879577a54c35fe87e3dc5f5d923f0ea557b7d629c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab2046b66c0369cefa3226ddebdbb73baf1f2eacfbda09450f6034be7f0aa57(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52e5c80bdfae7893f49c620dff1688eed5429c6b0226a73a838460b4f46cae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec71a4da903f53851a6be72f866d472c415289ad63267e96faf490fe5bca28c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469bb2856ad197fcbfaf9c06fa7a5d5b52a3cd4ccf3ef17e1b4ec90020fc16ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68baf96ef54cb0c06ec99ca3e91c141b5487262e0c58a25a2b523bac98aaf25f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7bdeac4f4874dabb017c0c85ae4b343f62d471b024d429651e61a34e683678(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6efc353561795341cc70eb075960db5f32ca5dea8861f3f3df9c3f8c05680c18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63e208445e37e5912c7590278ce7107fa3c1251f70353be7a48358d9909b8ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7de3b7b268cf572704132198ac14988fe69748807f89305a990681492734842(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f60859d6e596eab1c41c7e9795ced656f9d389aee8d0ae8aaf62f6c0cf63d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb83141e1e9201f071dfd0771e47abd7d8057d62a31deff82ebe2ea4af6125a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c0b8a20f16ed2dbe2d10b77f5ff94cf42ec8dc8091e9c4ca58239368cb9983(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5613955b15075cbe79f439ac6e98e7a1f06fcd5215df38e366e06186e9971442(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3162c17ad8c83fc6d383dd0cc754afa5ef732a7fb2451097df71174f018a25(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8c2a7a99e1d21a02a072d4698b5e6b86126cd201d3cfdd86d4e929894f6200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a753357371037b61c1aaf09b1957819c973b9884695789cf5bd705f90ff4b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a8cea8ae1490acf3d40e058a0bd6cf23b2134a4ee682404cebe07319dfdb8d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a32b43b5fa9b185a6e688083cda89461d3efcb6ccfd6c757c7e6c1ffe408f90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e5f48838e850af5152bb2a8033df84ee45e4f2c63564ced07468416ab4f15c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000c5cdc02a754a7d6c89e5472d6480984de8624ebd32ec48bebf11da18229d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b361d20ba4b07cfab7ca534d97ef9ee2af96c580a24ccf3e1c7f09f0b5786ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa97f0e9fb40c8ae7fb918865a8c07f9f0205c5f7484cd60750c87acd9052e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da05075b09832c1dee55149ebe1f073ad24c86bbe35fd519be499ee745e5c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453b488a2a0fd89da76f510dd2509f714925993b714b40b8ffc0f66d59fbaf59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19cdb59c91cc2966a4bf06a495960ab6b07e66043a2fbdb0c5b95aee3418583f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f0e56608a60b7e9835f3f64a86b594f249e6ca5084f34efae02f289add6340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c29300b85050e7de0790e51bf85c1394eeb8593d90fef6ce3434d53cfee43cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a562d3d7f50021a7381045a602536fdd6448a7fd9e8f8a6cb9bbad09ddfab7de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a530dadd4c862d401939445c0d81ea9cfa617942e8412667cd0429b777013c(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a85fb24837fcc3fa06c7700d5de979b945317c95e4281e564b56e46b3077bfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__018053d88c274d4385070b9b53163beabb96e0d4ccf2a1542c706d1c614cc2e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015e280965881d130f0faa840ff20de7ad5044261bb3dde27ca42b07be58bf5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612bd353200f22bf27a796524f13aac561ef4f5933ac3ce1f764305e9691af88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530f8bb2be6162ae8b506bf03f26c0a19c2005f8ca37cab3b165dccf36e1d4bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb8d2f14ad249dfb811b41d46b9688c3fa1cd1740f55175d5c5afb0031c63ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d38b311ff61f516904eb5c4c73324642d98aaa13ce73a8d1c19e6a9b484f7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444d1db9cf31dad95e4a28775b46bfe8e5d03ac400d36048a110d44d71f9abdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1600cc23645fe9f505c834e67b4019abbfc27c6b0b8964a991a081cf1c1ead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2797e57d99f90efc57e2963371221e46f50b17439efb3200a44ac72b35c50a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9304ce4e627c9237453a6c410a9217d08a037326c713d3f90ebbc01e98656e50(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a918973e11e7655ae343d6cdb6f95095bef8069e86aa9fa812aacae87dfb9b66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add1754418730dece2c616a1e10179b208d6b35478a00ac9a08e7dab465ab1ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4fcda57ebddce459e88bfb4d8f83d178814359ee21271a489e2deb48c70f17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55780526718ef657724fdb8b6c4ddd15dc1a9f6d7d1bd52617517446f4aad9bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce27127f3dbb5671c8492635fb4c4a9470f6653e606b006a198b167a14f14c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d87e4d85880ea74fe787f12486a98a762e815cbf1a307d97e763c62be8e8f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c612b9e99262eb3e5cf22e16f8b9842a897109c6437495ecc69b90dbc5b388(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a075101a1f5792db25f3d1966ca23daf85e1ddf0cc53dae405b2123c02549f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f48a092fa3e1908f49ce229e5151a221a0ae2d921b4b449e4fe07f9d75c9954d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e606777404ba9886ffcd8091302f3b0d14fcf08b1ed7a1a931557a7eba5c10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9326830033668d49fbd0dea771ceee2b2120faaca7c672f1d97ce26b4d3d9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea99c426a39cb835dc488316867740ae22c4b6cd2cba5bef0a312b2ae45b98c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b265f38c270b7ec3299f6d9b68171aaa3e380850cc27ec8bb7480bf93505db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba89ad5a705a2ecf3c86846ff2b25baa6e723812809225591cc0f8eca7530b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea8e899743214bc4ac8085d971cfc8d07d7ddec3e942eb168b92a3c4fd8bb4d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceeca928360e0f30f2aea21e59efc3fbb557fb41785f21140827732486b2ee9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c1ebe10c716be96e80e5e09a77082015d663a84a6a93ef77db5a1bec99d711(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015ad7af6647bea2967d4369993deb7256e25b41bce40fc0c36a4f735122c89b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec4034ead7f723cecc12edb48b6ba94a0d678f46212464266ec34b1e08147b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0777485b79ea3cbca942c907013ef07b343bff74813888570389ab4348fe20ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7de22f24cbb54fa464048e5270b80266dc6e120fcf4d32e43bbb6e7544d37a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0b14b5a1c2bd23d577bc939eea6f7e9ccbfd5a90de8be2ec11c8f9227f5451(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21cdbb32d9382b0c75278f8302213b25695e0cac985d88df3fb83911acce39fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade2104b07223df3edf4566410793a6a08e2ea415d1ca9c46d960622ec6bd194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a65203cd9d8536877d81157fb5c9f89de622ae449c7309b89b6413e9ea988f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d051d1c3abd9ba37fae07ea585e69c213474067e98b8e9c52ab833329297fecc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cadae1dc8ec71a59515fcfd16d5422efe908c62df15f658ce73c518d6c467082(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48cbbb80d8a87338a336fe6ff139fbd52884eb322ceb22e82a9d792f45f5c2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca337f398ee11cd6bfe0ef2204d8d66e2476c4c8a6c8932305fb6c0ed2d18ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d575021b467f1624bc61883c129ca0fabb83d8ee20285bda695d21da45e835(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08159ecdf5d7340e157e8e999fcbc32fc282e30932cb08e87286bf5bda10da97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99318811b98b2e91d676805a7a46a719db303043d9fca3acd7c42b4586f8fe40(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ffe881c0bcf4641f29d22706f57568531c0877e85abfadca5c18c9755d0ebe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e07ed366460b799c069b9c7fdbffcdca87aa23fac4d5699d8fe9f8f15ce484(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b89dd4cd02558e11b6c64b7112c94952bdfd1e0ba5339e304dd452419966687(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7601937413a607e0451f03f54620f7f811e16898cf161f05a6da5a07c8bfc04c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188679332002f0378ab7feb7273930f72df85b1942dcf0405b1965febfbc375f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe8ab0e8b3f10254eb5d5fd9282e9615eb5b97c3effd9a5511d4e3dddbaf268(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f22e251202265410ea736c7f35ffcc040ed074aecb4ef9bf7d69c04b6c447cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf96d899b7fd575f3f22c7d7057241321d773a5b739de3c4051ef0e7651b46c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb8e2317bb50f1d86a18944d8afb492f2c0d5b94396c70732afd40395717023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964403706890bc514655f7bf2862b7bf258f23a045c6ec84cc10c9d797e7c407(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1465ef634b8dbf1489a5c17b45373b718fde8eaced34d1c9114911caac59d53(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a606365af833c7a3bb61754e54c5fab38edcaaae631b1d36177bb4f8eeee00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d8c4049208ff6be8568a0376cf8240e3e287c97a6e72940dbd5b0bb3e2fb43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90f76c73c218612f7eacbe31379740ef887d98c695bde7aa28897cc578b2552(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0065148865e212d7c9595d9117e601f9485456c11fcaf6f2ed7b13202dfa90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b61d6e92b404f9a630a13d1bdabf5a45846641e53ecdd79cddac513d57976e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772dfe112681b83bf18305f82c05045f0c37a734c16ac73a40b3d30058505668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5c8731c3d4294804c7aa95f985982dfe9bbda3aca0a492ec857790e77e1b7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4630a0d51c421653b576046baaf50b2d3d187be9f6918673e289f6e76089cd08(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cfe7bddf8aa2f92fbf80a85911a48b7b534facc9ca9b61e226fbb09eb2d5c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddafa2167bf0ed978ebbd0a6880ac9a8cda7ac7e6e1524191b9b17a87c53fa32(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cef981e2bd55a19d778f8deac1ef5d953127b3181e53dd607af7b025f011233(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7994cdbcca323c14be47ad69caa11a916edd9c0813b2db3b5723b1cd04939f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984bc38f5bcd8a8f71ff29e78072fa579cd73ce555175a2a573325c41ed0f62e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9470a45c57d258b1988ca084e65b05478ee39101bfcb3eb496df2d257616bebd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__449dc0184336598ed31394f5ade3d378400a54e35cfe986be26ac237d5d23163(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e206e80ba45a509fcbd022b6fedbc709d7f792cdbae9be82eeaefdb5ed38034e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221dc181ea03ca2952e15790109528dfcb0e99a6e8b46fc766b7db490278a404(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ad79b5748c5d9657bce94314f3f527e905bdd10be7f4dc5573b2f8d81c2f56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a538fa79e311f43c3df1ee4718ed4ab15ae61d098228284e14cdf85503d7aca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31bef6b3f4438c5fc520a00b2e2ff7fb6359545fe8684328f3ad17ea905d84f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3033c4bcfc84b30d890e11ca15be26f9c1123e29554f8e3e8e2e4f85f6920406(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae38456ddc87dc16b4f75c37ae3aa93cfc66e0ca3cc99f0564453e455df744f2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8019989af1d6015151a49c38262bb4a6be578e688da90d2642434978e59326ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f985aac7a70ee60d8525783190e6f91916a11dfbf1387d3b665509f55933e8c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4cacc3dddfc398f089ad82a749068d34a385729d904b4643537c98f6dcef06d(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037e6c5f0ca60b2a7601ff6b078dbf16fa79e9f6fda59456c657ffe2a47d098a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247c8fd60868f0ff72bc51996db715d1c9602fc23625113c413548d9c0a473a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc160875e6d7b6d22634e91b3772b2fee98b93fa23d857c1fe849b247710be6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__502389cdc2b1d635259034d9ee57b3fb1e7031ef84bb4f6c825c3d0313a88ab6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da67c8691178bd303a55f6af8691d421fea8c7d6323363153d3aef84b86598cc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b8b3533806490c286b0ad02b4d6422750eed364bc6d24cb5515e963303a976(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1afd9c2e29069bd8558452c4e2d5f7f7d411d6333cd6c1484586de7f16643a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33a25bf0074a8c621489a731684f13e40246fffa0a8d0325d1e9514045cab8d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975fe63d18946df5a16a9fb8d14bc8454290354db60610379303d75c8e07f4c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ddae9bf102c0520fbd741d14e30e77024a9153748b0244735d7b274e688762(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ab17e4577b8a1e86f5464bbf5eef7fbe760c73b30f4418721094eaf6dcdbe2(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c2b14865a7a967abe5c8cda7e01ed4efe8c43513de8ebe783cca8377a9f4211(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae5d3fa4eb6e92a9de3e83509de8480f06a91111278600f747bfeaaf1609033(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f27996accb48fd7c4a752e421c5435cae176a3c364c0aef51b6672dba52f2dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f6f11f7c55399fe68b71489f1c784d894bc1b9aef98c4812bf46f7b137357b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb77aef4c08913581a19fd9a8b14ef06a856d289a4d0b24be6da7533ba7c79e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057cd3190e37a78cecde5113c8223898596b087c5affb2143d20412ddc932ae9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3e4d846771b009ba8ff25f16fa0dd53610396c07a3e3f0044d9ce620d67f41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c417d1691c391c8d73a89b456fccf69ad5a12595ae6d69559ce3ba60bbb4111f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0f63b8b053344e56092655562d06018be8949651816cb458f438d945f8729a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bebce72547fd6c57249384fe3358adfe499e6c46899b070397951b111fa5335(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c8ef072103c2c15a472769dbbcfa20cd4692555a33a3f359712d53eb200704(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e59d75f5bd291ad5b9000a110bfa1c21a65ac7078303acb6e548857ae4bb641(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad818e3531f35d410bd7bf13a997a25d31f52f3f94a1316b95e530668b4eaf1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcab7e98d02a8846e8ef6cc921fb04ec3a951ff26bc341251ecea74181aff506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb50c94bc72f329ac2db0eaba4defc53acd7b3b44bdfdb7173681a967ae7670c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36200845cdf27efdbc9fb0b8ae4529d810ecc1741e077f3b8e166f25594c0501(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f220c92cac9016fa073ca1bb91616c596be77ed29d8964b11036befc8bab05c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7807dbe0ee7e360f36cba72bd2f4904f2b46aa8a60096b97c81359b65f5bc8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ff425a6e9273867b2874e18f1ad31d91f0e798abd266c5df9b5f0070b5621a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baac7d898e9756ac01e51072f63e2336c9d7653b8d1e6857487ad6bf7069d972(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fe8363d90da3a439b0974f3bfb1ee9501ff9a976fe3754b8806402b998f9666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d031d180d0e17fa1f303fa226179d3c8b963cdd8e7edc5e9553647a07d76cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c09cab824128698a29517e11f70a6ba768aeda1bdfe32481de901a29cd2595(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed0df59af70639fb6133b6611dd167c8d44c86172b070a73095d115e7bc46a5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0559925b0743049aee287b4e9186dffdedd515339764fef77a1ee37ee5f03362(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68081ff57dd5e0e93c5033a244f037c41fdee5854e1a4a00bc3a080690354ee0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b0c787921b10688b5b33237b831550c75dc26963dd93f74a0cd7499db814cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c7debd22e171b257e5768e967ecc845a006ca2102312ba4fa107972d5a66503(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b6869331dfcdf052898ee08fb9ce2afe0092aec55ce5ac14d192246406a76f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d938de3555cc5ecd7e77935204ac5205993a5fc950c9ed5e2f52b0b130c96d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c54f1914ba92cedb0023e7707d8054ba429704493b71ea77e8661b0b6b13754(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5178c03d1e65444651937fdde76afd0ba98b91bb366df728aa2a1d0b1408aba9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2efae8bf51127dc79223ff100981fbc178e92a0745e7de05fa3dc19c48fcb47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d5cae49cd220b299aab8db41b1b9ca267331f303c53d1eba7ec40e376bcbe0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1928302c09434accf5c0cc38599bf74b0a7c07d89f6d0b669b054e243a4c102b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d98ce7b8f82652e417785eff9c82790b1af07c22c3d45c70a367f6d418a0e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb01572762561b7cf4f95a5282c599c173fdcf9fb00058486a443ffae391c05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e773308fe336558547da082b185b1a7b0f9624406083c433c8e0df88a827df44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041743b8782519b5d1d88fee738c67051175dacd8af77e58523610d8eb32fedd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d364204b445bd9f03403a52c29aa119d290edc7205587640cd705b68cd06f0fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f8b4d4a873feebe5b786dd9b1e32e9eb2c4c763a2917040d1a9d3765df9acb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e8cdd09396d8cfbbd477e9c02d3ba10e89d5819374f2e118c4685fea1f2831(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__324fba30c5e75c99cd70da73acc1cc4d775f15ba3b8b15a4327c96bfa6bc2140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e542313aa504146a75f8dd3c3ea6c5110660fa6c4fae601b6e239d3b692d50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9dda903174e261d3226c54a209141d34e331a336c04772bf7034d70fe41d28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e9e4a71df9b5eade955e3f59e0298e8f97ff66eb2c8eda10ffdf1662cb2daa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e97f789929cc80c648de7128e3438bca0c20ef774f9f690e050ba13efd52b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb9207f5f21c628974ed96865b8cbf5abff94d2f16db1e9fdd6b950b877654b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09422d160c31c364d61dd0a40f93ea928736b3a9508e7d039fe62222d29a2df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b0f3774f743c460f51647621039a723660108115d58368750e823de45c8b3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c1850a039437eb0f6844446a12cfdf7611ce4e2dd7f1498fb7c4f95ca278ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735f8764495b4584775493b8f627cb0b441ab4d8880e870669d483f3a4e1bf66(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258fa8463758088f0c832f37e795a08416e92285bc5441fd1259c3a48cafd093(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea720c99d67df5074fada4b363f9bcae8a4d4fdc340d4b6e84e4ea3f3269c4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4935752bc9094f56a22c0743707766b4b4ea7147c1f3ac2c07e92a72f9ce92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61634b83e7789e4c29b1453985a839b297bf3d60f0eab20841155f35cb2eec83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13079432a10bcdba95d8972bba09b6280761c57332a0df9a0614e61796ad326c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397b64f9b4454bed57c540a5db6d8801feaba345b9bab80ea5cde97faf7ca5b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d2c731a3a1ed031e56f179c34471981e409a5d795fc428ec904a47fe9e501d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639ced1b08e2f0522932db44e5064bc38ad24d472df391dbd9123a8f06a4ab0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d43d4f1f3be9077b7b9daae01ac241e89b75a867854b5b37dbfde7e4dc27d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879df21fde4e8668294aeb62cd23cfcf864fec992eeb62829fa2899b3156f597(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6a2cca8f7c737ddcbf92ab35059056571d2b87af6973e752fee9fa4812ea3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9557616193d4551c183cf3c8021de2e02fdff897536fbbfe2d2d4abddce63fe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ba4eb27f17ed5c6d0fd9aa1229b2a0efae9316b16839f1a19e623076962f4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b242f0ddb1bb9768cce9f849dba1ba9ed2b5474c051e7c8afcaa300720ca02f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715ba0db35711fb1690acc07e141b1080c5870640368beaae3317f12866fb8a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80adc010a3bedd9ca6dfc0a0f0b17ffd1286d804bf31fc1ff9114a30d8a88fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__738ca1e94076b3c139d40a363834f296e2d0355a8b99281f08be684f64cc46ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978c80a7363c48c87e0a9467cb9d6e023d417b8940df049fe38632a95f0060ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fcdf85778a9780679b60665c85139afb622be62ecf7c15eb8f200d09f253bba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059f03d8e9196e74457c0450d27537eda625caf56976d0c2a2184d03d7d7cdf7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529b8265960b03491a9bf25e79d30f96fcee148ba1058fc666d3764ad4820e8a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99147351cff1a96334c46b963d5794de5a3b65efaeaaf9779cb1eff00cdc012(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91020473aa1d6d9a98dcdb656b78215b14808af752ca72bdd315a5b4495b399d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73e8fe3b13b4805d47af42a43e085c2cdabc5bf7b7f41ed3d669b21f634c51b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826c85716aebbb7ae92925dfafd13831fb52b47939a322c32be2a015f79d48a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381dd0291cc86969ba3ee4e0e5e71782a569e0b783e83a8d6612dca5917c12e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2313fa50d01f921e4c2237e2583e853b3a3b4df2c6ec603fc8213ec00599fa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11d7a12b1b6a61beaed348cd1a13e56fca351f4def4a8e6541dc5c6f959f8c5(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4411fdaec0ddfee56344f06e752ff3a072e6bbc410c9b4e817ded3722d37f6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e172a6dc93cb67f1addebc1618aecfb5859883b7bd796c3f6579e4b2385a9947(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ce24a8dd8dbb1b49c2aaf5138e894da2530d1fbd69720494241b8bb28d3f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bdbbc3ab3fdcbce3eabc62fabee51898d5d3ba26e44d990e8e6bd81c106e0ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c74ecb5f72008dd85e533ed40fcc1398394479331719ea7d863ae8fa4a2eb365(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cdfaebeaae94b8ee6c155f250fcfbc0ca32304876dcb0c478959f3025981384(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d61e0b91794e3c917a9e4d9dff57035c2f42494bd27263894a95c09938add3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cb0753c25d9fd63d187484a60fb4d40fe7218589e9cf57fa389de95f038867b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ac218e9fcea9cfca02aac3c05ceb1efd300707792ecbb9a28decca94a64bd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__798f5052397b7550b9ea25cd910284ad0c45c2b75629bf0b275dc483fd45e51d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb12d91756b8207fb4d5e30b140912019170b28f3f628660079554526ee7d11e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4ade7ebca896ae6931b49b28ed60670c7aabe0fffb6bc4f1108677aefb36cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4345eed02385ea902d47023256e87444b062e0dbf9855ac09525a9fccde93464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e8869879831f189f424819368d8c8e8252433520d8090de11423165950eb3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9350dbf8a24ae724eac777bd901c54e7bcc166af1441f42d2bad84f8f6d9300d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526c170a1295bcaf0c69d1c084261b166517d86889bdbb0c66c9a6b75a9fc7e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8c7c069ea06673f6ec701de19a0900528379040d52b4a9a3120f183bd5346d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe0234aa588f14f052c25e829d58021461c90f8b3008e112d7ffb84c0ca03e8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd995c1300c95efe387dc6bfcd5fa62e349e69bd2c6f30010974b30bdba99c9(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd2b7475fddde72dfe03e09218eb126b453d3da863fa998140e8fcab6008694(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f37ec748a1d0b0aa81dd618f6520dfdde7f98490d9aa01c2de1dde20c049f4b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74e0c311baae7f558d428f3cff00b0af579fe9690981fcad199269d68733f36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71c9331a3782e3426aaf4f5eec410acc50e42a01b46b27712f5c3311c414769(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fbb0cb8d70feedd44566febe07e079e52790c354cb202885c6a798491004b93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b838066397d47f3412440803638a72445f9c2663518f612659b2bc2bad51c8ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea075c3971012e8244ea08f45de3287a5164f0547881941573f4b8f65854c150(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84af0ee48b27997d64956ad210dae2fd1e8d640b0bbc497ef9f03e15e12b66d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc0e43c3c9ac3368c8943039c0a9fa4c1bd541842ec998d36c1ab8bfcd940305(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a38450f036e7cf1ca6fb3c02bc6eacf5da155973f78607dbd316a13cb098d104(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88cd0f1861e43ba07e987b70920a724c6dcf8bf10c637c219564687f93d159b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce76e9d40418acad4e2ecf2f47f0f4841940ce94c16c7c4621288cbebe99f9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d9d66b13db71bc47d20df54ad43db3d085df2d314dd53079a6135c488f81b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff488d9344d9c3f42f6d44452b13605e49fadc5369caf11ce78bed0f889effa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e0bf32cdeea43aa76adec8afed18dbe4650f4fdf4afe03263801fbca544a56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0d588fbb76a9ed380ed8926f6375a586e54b8cb55e30e90125310cae91e5e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d55468914bdaf340a5b62e613eb8afaf273028303436ff1b7caf7f19d19aa5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838295d6ed991eb959ed2bd7e1286ecf0d2b9a260d9955840f8553d4d5f2475f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da778a03a5aceea9d5c87c6609326f72945df91a14d6208f676556964471295(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec68ee0d815aab72f189eac168f758d40d68fc9b0e440f81f409991ce4cf9b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b9a463f3edee65e83d344415a56dd76be8c507eaf20a4953400ea6f9aee285(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52002a8b548037f46c991b8c6bca4f8230ee213877978071d870e8a2d078735(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7d67e7fef1f722b95ad88297f0b35a3abeb9de80acb7e48d64fb663f4530e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d312297bd07a41afbe102f76c60c2906a883a5249a32471f1bcc09d2ed0b0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517ecf6a27717e49b302baa34ee49192f25c21262d40aaccbf403a3887d676cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64653a55f64a9893d029f05be44ed9c4724d2569487f214abb7bb2eb51466e40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0f914b35123581197b4913e2cd7b56dac19b5cd0ac92ad81717a7422fc5463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9e54b0e37066ecd93b858b445dffb507d3ad3d0dfd33173af357b3b8ac637d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbd284a2dfa520d172ecee9f18ea174d1226dfd76897918e1b25779b7660e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526650662a5b53d8927d8d2c4d577cc3c32efde7574919d64c38dfc3eba2ad78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df76dc7e9f67cf4f843d04eb987d7f1b00dfb367d08de993b5ef08f67cf6942(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59fc43f7b286d896b7f916d57ca39746c58b41c79b187a137305fa2d8f179fa4(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4a5b4290f9df1296d8a704129193fb18c34d5c5c771d3428d4580772a10b67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb21fd11ccadebdf36f10856fbfafae1469617d9064e39244374d972d1fc57e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a690c50edad0e8a0ae9f44ad45e085330c90ad5adf8e55d5f1dff590338b5cc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0f0782e0bace61dbb19879f912fdfe071008efe5fafa339bca438bcb54dd10(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6206993e8f1b562ed64adf7f18c01aa40e99334c5360ecc2e10cbafda0272bec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae192916e1c15edced5dd5025a685ee50e9330400e26d75c437c7feab3b122e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26f7222a7886ab8f838f1dc41b31f79a46eab498e1650334389148e08fe7eb51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714513a95f739c8947d7f8a8fb41ca7b523c544ae0a6e2a6b8e73b3ce3f4a6f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749a866d309c8f9e177af119037b5e5ebb15e74af9e54a6923934e69cf3911ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6902cb8bef0f5b096b2ec196cedd12e952d3c13dc77ab1f7a9cdb30188f018a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305f8414a1234f19855d934d3c6018df11b48f33ea964de8aabc90a9405821cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a487b110f01db75b0f9a7047188c91d9d76e1f24fdd5b80802ed62af701a81a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b7bac49476d46be9e81ec5d3def0fe6463226693527784e678bb6fe9f6954f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e63dbc26e95f788fce1c00b80220c0977e392e8ebe16a80c0bb56fa94ec742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64ee2102685ebd96528bfbec22cb859baa2b3f1bf759f44e370a6f4b1440eb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d47c75aeaa84690e9613afa491aa605e9e238ff4baf5f7d0e84b554f2604be2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad5e7c7619ec593776ccb13dfad6a494164e3af6b030eb8bea5d1e2f83c74b3(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c37b630dd8d8eb016d2d13aa1fb3449f8f770da559625f81299b4ae9644b50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f0f4943b91934aced78a2bc3a996a5c96eed16ecce7933b4253bf1600a312c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1761f63821ed0fa45180b17af96db1570514ff5eddfe30d218eb74f0ac5caa60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d455e67929950966d40fa11168c38b6f58fc29382c7bf7b8ef5cebb6afd9495e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357209581a697124956db518ea5cb7d579e2090e8bf56b9219244953524b0066(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25909f2401fda171fba0634189e64591fb1b570cd0a13dbe06ff69c0df9a645(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158fe4c9e12782ec1dfda9397b4af1c49802ed27e512dc0ce7a66319d6307a41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efdce39f801d3ce29944a9e13e3c87a77ab6702cf7c8118331a812f77b22f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e5dc95a1b3ff0b6c6bb1697b960efc1c82d18644c5a41eedef26a9bae85abf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7581fa1c7bda884148d8b64098a0684070b225092c6ab45c1d75759a46b519f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276fa11efad00029f7dbbc92acbff2669c3ef3fb51cb34861c8212d3b8cc5dde(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af821a6f0e7a0b02044a74deb13f9793f703a4d23aab5900fedcabaf91ee5d3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10eeaaaa02c47f5c6489294644e347b3e9f3630b5f2b503da9b3415e50534822(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c5113a64ac628b00020365aac4045e41be2deace3ee7df9a80eebdf466c4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aab99a8f58f6c8439387062043c944b749fead665553d026f5bb1d32c6e1a86(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f7fdc8786db0921bbbf50bf4ba7e1ffdceddb85d3e3b26a404b6110a3514dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853c4e46ff758fadf0d516ee99c16264ae44cc2b05c8e5612cbac63b050931c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60df57aff79b90256dded50b72a8b964f72c12272d10eadf4a9bc6325971eacd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017b4a43146e718d7d850c101e636b40007355b1014ad4dd31d9e5dd7e75b60e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d003f1f8f9d202fb82727c178eccae6897c7ed7ae6f617f51ebb97505648e11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96df0464d548f879f03e308d8ee1ff23e6ab710f80f78de9028c3daf762e7130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac61c3061a06b818fa8404a7a2ad9b95586f21917d3932379fc4d35d0e3c8183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa5a910e10d3f3f59ebd948b40921b0763bd990bf68a62151d9dcf17c2f0b10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33fcba8a752a40a0cad8ca86e936e7a32fcc326a164dc24f44a1b35a9cceed86(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e69d0e7c11bb7a53227a69f78f7e8ecafdd4b7167fada3b9cbef0f194ae3676(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50feceb911d507027b36a359497e455cabc41475543a8791812d4bd3bbd2dc90(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbee84f380fbfcdd492e7bba5ca44ef9d603b60df2deb970bdb2f711cfb9a3be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fa87053d66ba670c9624ca3ec51a6f82ac43fb909eabf42d582f01c0133b54(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c842cc4fa134cc06fc55ec65133d90aa4262e3838dcb3ae7abe7269e3864b28(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b9d127ac8d0798b240795746fb479ad02301e5195efbff88fe9f4488e5135b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb0ce78a86ffb96d1a7f211f1bf6a4d57a0edc352fa9ce5728f3934b9a007df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90b3ee055f2d0f3d60af11fdc16698028d3f12f70fea0fa3e0dc01fe68638b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612f7455e3f8bff79c3875d9eee2c1d59c00a82cc087f870b2df232d8cba940a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418ea43411784e15d63996eae3a5f73317284a02d555629f02f53e1d17581eb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b83fc9c1fb69e50c80e6d003db2db65128c9aba1d7d830ffbd15e2b8d1a0c11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8ead9ddc5eb4a171ff6ee76e5733171018d0c355664141766bbce73bdc423a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4eda415114deafcb53ece08de1e577eca37483cbc324ace26ddc9d8f3c8ec1(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e5f39498fdd9e6d0509e88bf21365071c068c8fc9cfea14290d51ce435261e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab32278b88568eb33b55fed9c1f8b1aee8aaa67e201560ce7f8192ffabd161a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010385bf794df51d6706d42c7870c80290fd6d42c11c60ab2eae131865a207a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59286bcb994e80d6c497ab8e9dbd022facd0cfa18af67121625099b963a17e91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617ec5dea9a4e1ca41939854d92ff0d85e2bbf3c8f973a17f148c0d9654fc3ca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512bf7d367333fbe6c8862a3478ae382f13a437a0bb673f6a98d171698ee7d21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a1446aea64aa96108794bfd9a75c964daa63af6e2e03edf1b9b365d79899bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99f57cc3c4a9cfc8e6d409f3677567d10ba567d3d2d2ce318f636f56f5e9612a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262c8e9714c9d08684de1211aec584cbb539e78c4ea14438919087c197387cdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17ed6f284ea6e3d7324f70670c92dcc14c7311d944b55ba79c01853c8fa9933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__712590b65eec48c4dae8ea06bfd0d01673060958fdf4244b010ccf6922334b1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4503b2aaa5f708bbfe06b2fffa5ff0304319df4d04ce978357d045053c885659(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89409d5b123b71c4035a49281c341ac01361296748f192bac2216b0371129c85(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d674eb7973754eb52eb87df4fe5f670b4b17b604f28f8ea5575b9c03ede0f588(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d450fa37a20c74b2da6d1c69c3ceaa1b9a00506fe311f19d2f657c8a0ae14a4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037bddfd58c38c260bcea572136fabd8729be71834c6378af9f79b2800970bbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b4fa04783fb96afc2bcf2353fe0ac1969da50446dadb0d39cc3f2dc55c4bf0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48e8538c3fa47b1f8881d7cd7b63975d58f64f86001e4605530ee77f15aa57c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85022ecf746cb7c986e7fff8c890db5aa5778f0871c199bf8f5ac9ec0830c25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ccd5d46f29e1eec64efc06d89851f923e47d9500454e7bf550551ba441c1f3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e42838269442a69e2667fabe19a37bb1892d2bb2eb457a4550ea6708807e47a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628e660af4bf5a7614329bce876dcdc30ca65b80b8f3e41b3fc93f4af06fe073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39522b0161ebc1fe5a836156fe0e813abc7209124a4707ab54a8afa04adb52e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf727d619df3c070fe2f41d7a828d995b6c57bbf3dda467f2a5c1078f40ca980(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a488b54f568d39b44999a328f0ca1870334f43233db0e6d994c90e4b02ee3ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda51513b8d4483862ffe00a461090e675a822fda27d10b2b6e33f021fdee8ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aace9b45beb236604e09848a3ce322c3e1612559cd720de816649f0b15a99ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559d813fb88ce890e6b254a3c263ab4e5889ab3297033e8d293858a397486f41(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d931805d271f85db322985ad5f6762c1f9b6f5dc59e8d9ee06721c3ed3804b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1770619f76bcfea49ee55b7f285792ca2cc94ac3bcfe2bcd19fafde2e421abd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e256d9b399456e03e6cb9b06c1fe7d8861b080e3ea4ca5745065aaa4e006af1e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53e8548bb1c9dcd07db5b1fed2081a055b125dc7eec0fba4b73b332d3197ce5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e06e0925acead52702a1af867385b8a3dc6e10a1112d0a31b17d31d2ed2bda7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695a7d2e577285144b9776842b5755ae58d14a6b71048716e6914159f4ec29b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75af49bebdf2d79afb103abf1f72f905e970b9cbf6482a420366d73f4d5fc8d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc08797fbb2fde246cdc5bd2316ebe343231178d8130fc1a2a8497435376b6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e1a771aa1cd5354376e7d47eb0fcb7fe4699949f25599d1098de3df34d807a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040c65469ba9172cf7c0ce74d3a879ca83949f2ef172f0fe881358b843c82e96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b95be2ddaa2c2a4d84ab8cf2205210ed88d0c2735fbc4066d335a30bcf49ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c3044726cbe1242f7f4c649a743f1a87000529d19dc8a280493e278a045971f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e874a8dcc68edc22038f1c259fd214bd43c31d7d4dcc5877b92873b1a6d05a34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0136122e4913b4310ebdb17a51c936126de821d4f165d2712b1641007e4e0a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8752f17331825480fe19a12b4c2ddb9f97739710d15a0ef131cec8c8e39d543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d10bcdc027bc86808c5867a831ebb7ad3312c85fd645e3e6a5be3f916f0a48f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb9e4ef1db73da845c586e204ea4b03ead14c706af6bb821bc358b5bca0bf7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e7e84c5ce4d19d692861fe3a796fd599b46122ee7ecbc90fab64f3cba53df5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4da0441bcb31f48d78259ce66e75457ad37f0d204750b286060ed304332405b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0212279d98672ecef4d00e80f90ad8ad1004ef7d42bd0064e22e56a363c462d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495de28ea2337ffa248a513373df67564688915e4dd20f6c414d62eb30183c09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7de27609500414de4a47a8badd577d751f05857db0262178a01223e9806dd4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0447a4fba0bc5f08cb07ca35c1877ef5ccc4dbbc42821a4f7a8507e7ea6fc8e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25103d06298e215204fa47560d65155e6444e25e29594bd4bf2fae63bd9bfa21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e249ab822d20433db2864219ff9e0588ee0b65dcd68a1819922f9ec6f2f9b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797a49a6148ab64bcdf030649ee020b34b9362382e99e25c517d6a00baab0d17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3488b2c4928d1dbf8a64ca61c1a8de1d038272c9982e98a9a73b166595533006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fad6041f8f06e6c0ee4c69f9d8ad88e8b45f7c2e986ea882b0b4f48d4fc4f0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34dc8389543df41b7af6d6737eac03230030bc995922ce4d914e9ca7e0bd239f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427920a4d50d4c9b2fd281616907f8a4edfc28437bad7d35aed4367f95b5f1e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d094d72da18232656eb07bbc546e0c20883293b216cb0031c6a4b7ec2d48fcf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65692588f4aef3afd0d556a9b0437f732de2473858daf05b7ac210880b1de78d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5155ae17ab709ee07f7051619aa59c358783a6d54d66319a9d024b3b4bd5ddca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3499444fc0c01f84ed7ceb1f5945101cd5e0bc671b8e47325c5686bab30331e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946373a454fe6d77ab13a59395c3e2e0dcc535c30d794b2cc02518195bb225f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202d66a639b22b5edfa48a525223b67560e286f21ccf7f2f08afb738b484132c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d866507f40e35b1ef2541d35a8e775f3f821aa753fdd29ac72b2ed92960f80(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eebe8b5244614e1e350d5597c15a9238ad16d0ede71f6fe495e5ec6d379b48d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7e606d8dd450423776f26129edd6c8d3a52667f2485155c73b563950a64dca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a2c5fc6a0dbbc0bf01d14d885a28114f88d26fd7305961fc64d6c017c15aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a7f91fad37555c069179ca8b207ca3593139ed70e98c0a7cfa1f2b36112127(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81957b37f5c605143db9ab1f521110a32781691efa93259d7ca585b49e540b2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3962aab104e5e9be11fa3770908db95d4c6f31a93f049f262790a4df370426(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fdf36d6cc70251e38c960b24c7bce128148f87b1450111c603f81e82364cf9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186fdd7f4b3dd44698a5e86a318cb2eebf918c91c258d6d8290a09eba2a08b3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab2d344fe5359305a4d71b8e98b8e319acb179f3b9560cd559b0a8d79a8565e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5786c521db1a1b8a4f8c5623c8d71ad5ffcbeb5a89af6dd12d4ed2324b968fd2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2102282ace4782ad1c638fad0c2bfe323caa2e395d8b204e5686f285cf1c9e72(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08c202230675011225d64ea0b17131c36be21bc1c28b989a9161ffbe3f777a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5a09272c8a1ffe75212ae0e13a3f60e18d621fb73d5d7e550d19dcc47f7629(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae1449f6ad5efdeba6bba2707160f7dc15edcd835429cf4efaa2d9d68185569(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec10bc39e1431c219d7f0a612cc4dbd1d0b832981085113a6196bbec5bdf4b1b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479aa8d55366b214e5483a428dcbe2c8c2905b1a98523ec876dcfcce6a2cfc93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f4e01d5aa5b90af50d267a180df511fd2add3ca086f7eaf61409960772d52f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99328d82472a2a0ffc2a3d67548cda8e7cb902ecd6c1d7b86908049460bfad48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee250626f157669b9040de9c766c4fcb128f5e78629e84c1a77c78692121263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a010b62d87cea64b542f08986abedd51cfa8f3d943eb12553be4e5124638476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e447e821c352a4929a524855f96724e4ef2ee04692d33b9bd345ef70891616b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966786363417dbd5c362b21556b8022ab4213bf22f0cd80fb3f05b4da3d86452(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f643e086e69795074dec0a4404779072be580edef74c77112f21bfd377ee91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e511424a7522666ad981aa0c449f2b2bd8543f9664affbcbde130b85db2ec98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa696449f7b4a2732044b35e0468939e9314dd2d0a05f45487e564e7ac3ff6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__629bf2c3513ccf174220a5cad2b72a8a25c2331864bfc2d77f095e140f6177a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68401ce50e116908d2af4650afae8c22e2946bdc3a3fead530c0a1469ff3e0ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd412c5561ee24501386b73c708caf5261bb15b4509d8f6ffca866342fc2cfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f21354801dde1ec8dc18e637e5438e1a100a59ebf3f475523461936b3169fb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__401bbb89b4d5767cd632ea549e1cceaf28133fbb3b2dd70572b05f2a8cf0670e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f401f909a6d6172475edd6512e9287e9e8803642f0db76d387511d2ab40bb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644ef49c23b25fe5b85bba311261400a1d34bf1a382f65e218a967fa0b31edf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4142b71d6ed98b687b8f0039767a789a020499f32d15c11f0dfd797e0758918e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f98d9c76c07a368f95809c34a1361cbdbd272a953f146521b6e47eb8ddd306fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ed17c3abe2e291467584f72b65896c0a75c31d8f093f4508c8b601ae96e3e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c375c97f1662357d04429c3388996c556cb2f28b2e3bd239836cb5ae7949a705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b1698a374045d0ff3bda95014b3ca5e0810682e0dca9ecb10636fffff988b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719936e2c7a87f9e7ab69db9799e713f97062a599306675c11ec2f456e415b83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d94ffe6430b827791c30c95e0318f05c9c79d9eabf81aeda296b8b030001399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124af56433ba93c84c19a4b50b2dea76efbb2c507b5edf06f3e92a37c818ed16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2e0465f8f1815c2bd25c5922dced885b12ce1c67486a7c1c296f59a52ca19e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18996fe359b36f45e3beb37c644f3a71151a976fa4025776f21142ba1b0e2303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2a0deceb023469ae597abbefda65c764f3be149385548ab02ffcb062e6922d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c00734aa8950e73cf9160c4ed301306df2de4ba6e88f7de032c18b54e211946(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a87f9948aa24d863788f96e8e34a6ae27cbe4c92f945a6b45ecb9f92590c0a6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba3bc1a234cf01a4251109643ac784607bda833146e35ab37ab5ffc9f5fafcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a67bbb17f16c52d655eb93d8e12325e984693db90fd050043279141abb5cd8ff(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c621226bf6fdf08a7efc13a10144ee8fe77c16d91b4ae0e6c641ded7f5c7389(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b241595b9eb1baa070233028ba46a5a0b3f4ab1337a5424a29c79d289e3a07(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9290a62b497c247a2bbcc0386941e4c6d1d0dd28a9b8826e76171a7663a09f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61254fc181442ad98b93c5440e41b09da88418a5f023880890667d984b4f15c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef01911f94c00de9cc2222c195ef2fc3f636a13b4e59a89bd1371b781fd24c49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dffec34481b54f454dae5702f557c9d6fe8938507927fbe6a203703e1f0a81d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c3771232d32a1fe8a1c42fae397c181ed4235c64503ae2afd969adb16cd379e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5464b53acd47a1e1ff5861ecd952120c3f2b532960b114a5d8c46625f63e12f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854b7e4d1a68876ba8528d9a60a5d73c1f82c9e43e75630b8b214c9770951842(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99f4f450f7dc198a3e3a6c665e8807d39685eeba69f3704e6d7c9ea9294b79c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c1346359ef898b8569d1eeb9f964b10f3bd5408fc44040e4340ef581f29179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbec1ac79f84064bcea809dad78e466734d9513e1e325276d7ef729adfdce074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ecb5a85b9dca81b4e369a08165a6663a2daf87dafbea1ac9a4e8b44ab4a553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1c005f1801da79d1bfd76bc59be72a7ff45b1fa6df2761339a99be887c5116(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ced1959b7d08a2c000ebe645f236972a707523719f8deb56278602abcddbec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b10f91ac709cfffb5fa345a17053b67271e7e7db67c77c2cd6e7f36a895927a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90d507faabe7be4bce74bf8c91e00fed5a1a33f267551dab0f7db8dfae615b16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3986c19c5272beb491f18ae0384a3ab1d1d05993f9621b8c70086499601adcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d621d4b146e768c00b3e69509820fd063a8dc89f5ad47e16858d2218c70abaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95b2f7eab92afa0c5dd2bbc3cfe406fa9811c3c931cb226afa3b70699445a1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a707c84b60ef641c4cd2fe8872a0f074c921d2df3fd6b82ab4e85e528a7a97e1(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6d9520aaa883d9f312b4662b15357e9ac7b8d4e3ecd3e38f6f99fb1b66da3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1363966c7056cda5eb30629f37a339a449bd1905640111d1cd55a82b1a6cd077(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26fc01931986427f511eab3afd30de15de002797b0cf19448a65540c263f7ee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58183d2e20a816451fbd952bef414491216ad0c711e8065a0cd6d2a1963400ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524cc98f16736bd921c592172ec51f8b82213aee513824516b993140f52a776d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c40729978ac3f3829ad7071065d53e8fa7dc168b1e1bec0652a406b71f88b94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737aa92aa0b371fe797b1ddeaea303de534f3e6f20b2bdf61adf22e674690046(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e71b7370aa4400db364105165edcdaeb5b0aa70351c3b39d4c37453638e29f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de7b7a55e34fd9ab7050a0f0bd3d6fb405dc2927ae0e4b1d10bbb4d45389fe9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a4a68b61dbfdcd287c1ba12753733def10f630b9440fd684dcaeef58d005a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1e6e522fd29e46b59b3ec4cbdc1be4e654902c991b4cf38acb962e5b0c044c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78fe5ee7d3cb57ad5d3ff4bea09d202e88a9ec15535d7e8b931bcddbb0843a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89cdcefb415061e7de8f5b531aeb5bcdf586acd7d25a04ba824be2b31ee54537(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b0ab46466c1a89835eace7d5101c337b6be4609743863b3e0686d72070a49b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d45f541c5ddf39463627def4dc58c8aa464614c8b2bf372de9b76a783e6b40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e25fe5cdc51c2d524ad18f93308961fbe4244f9594e4834d3b839ae2c3b3949(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9121bfa77cd411def7373fb7c58a32f2f9cf9b0de387ea4198e7697bec8e68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8cfc22246d60022c5e47ee6d9b0b64e06771f1aa01b37aadd505ebcde36018(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab0041b86f5089c0a0ab2b29009ce0054d614af539cf211e6b55e48523ed43a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2cb232569ec218e86c9eed7c315c4d1397b2bdc5228a37605fd06fdef109c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d5e90309707bb04645850cbc78f3c1806d7234ee994431de6556a42acea61b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6ef12d5ca1e1d4559e8694570deb956a7a911538213159c8814bb305702497(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305665c388af5d860b758a480258a8ace4b6dfe6d96a7a536987c45a0c323e2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8809caf252acafccadaaea9365137780d441fcb864e23fc6540d576d898c47b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__962184110ee435f5354d7611511869f4bc8f4c5452e6d398e5cfcde1b543b2b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0606c989358828e06299f5fdbe923b089e862b1981a1128c798184b4df1d0fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e13a0bec7836a4ada716f8571d3ddb6f9095957d36e3eea11922a9ebcfb2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d8422a0004ec84d1c8dd421298371d30c2f4725d37291d0068028f91d022f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1906affbf3d29a7a6d359458a015e87370e5e683aa9128e31a002bbfbe662fe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14275b7f415a548555fafbbcec657709dd851f9cce6ab279729d52128c2a9765(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9921cc1a6d049f0ce3f755986a6b3cd96d8b9b5c57dc1bb792ee4e229fc95f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c84efdab57b879c50ae4ffded402ca1ee0e0c5aa12755b58dc36afa2e071cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06668ed24eda0e68337c2d8b83e6d1343cf1a3abc0f2f56ff88850e4c1bbfc9a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba0c6b14d09877b4c7c86be0421bbea45127e8be94be74f867e1dd22388731f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42708c7c0022f22e2ad58d8c72850e37d86f38fe3b4f8c0eb6baa8b03270a28b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e88c9660924b3dca71e9e4f82b24b81c137b75f03707588ba01d88ec74aade(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b280cd30ae41a294b60a3f5f3bf570df805633099c7d3d60b8acadc5553a953d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0d5cda2d68d787c4aef03e9b96c00ec6701624175415adf3156f919f272387(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac175655eae69c9bd27a5131969e867993853d44d6cf1ae8401f8025dc087381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c375467d39405592fe3c79bb03c2e19630243e5fab2d605c2b09f439c6e99f9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867ca64e869951c14186dbaba59fa4396639821be5550e6c7fc7e63de8b20914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc42bea81462c0aa18ccde971c05605db3b0a6255783ceeb74f92537375173c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53847167ba8f855e8092fa0aac5592788c58a0dcecd81cc8b10bbe75e464c5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1bb17215dcd6ac10eb3cd05a65f5193525172eccf2552253520be6bd979aa4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d29747ebbf1a16bbd1f1b2debb45975e6ef66aaa256b68a565dcfe753852331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8cb09e72080e9220944608ad731fca7b87ae8e2e5c4768bdb1e5fe4d151c0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a795350eb6147f56f8e3bb057547a81ec18c90ffcd4595ee17e509a977f8ca2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eabf87d9341f83c7383367dfec3b9354309e59a757333484f1b90601f37f049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ed3bb30dcd14e92d59ee16abf76c43c305f1d5035a92eb8209fb6fe06f458b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fd50b8c62f53806d08a489c038b32f96674eaafa87fc4482c7ccab6592f104(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50ad986a4fcdd8f6d01b7a46378c189b930465728f73015f4c1107f95ea2f12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e87564133e64badd611b84c6723ffcff53660ae5ae20c5026923ad794faf319(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2695a08d47a870828679dad2458e22d6b12875a1b00ddd776ab3169fb2c85c24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95d7c2091ca9ae506695630f2b0b5521dc0510f5ba822985f778945e19ee557(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d22812ca547b7559d0fc17bb414f88b997a1bb26df241d7d69bec6d8040ceb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__177f200c5d56a36d2e0165b07523b0651f2b36e66442b5c38acc5531d3e0d324(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1868fc91a071c1f2427f2d04c9b08f984045e2bf89419086104d2e55093a6fe0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ac2abdcabdfe112a0c9ac17c1eb7ae7197f5b800794f9e630e3009fe0da7f05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6379c22f974e63ad16531eecb1b0bfb0d85e0fd3e71ec3ffd03abb20f00d724(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d5f6fcf7e06cd5d58ecfd7cc139bb7e2240f7d1a2a57d30ec1a3f5b972cddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10d1df296032150603fc75204093c4601ef5b133b385304102785a87af0fa9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105473a6352b43c50d0f02885f8fef7e24500e6bd1eeb0904be38ca8ebef7f22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252fdec85173b3283742b401e78663af645eea360f20987ecff73bdde7e02507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__401a8fe9b0e91b8ea36c140c08a2266baec89b59fed46a47a0b3b4bce116534e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f194078ca95b789fba0c3029e25f015786db5f8e6659d543936a5c8a0465014(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3ecf717401f30c71cc45f6b654084df962f3882b99bb547352f0c040260355(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__affb0f8fe0c1e7df2ef2d69784b38a3e3395f0df57906744b3803ec85e2258cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d26970db3f505fe5cece681fa9a8419f397d4cf4c2267888ccafad73de4ee90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28bbddc20e2ccb6b707183ca5ccb4547b8f36d709695567403f9689220082e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a6cfff702c4d3da9109b32d43fef301bf5d04bbee7aaa59cae652ff9f1bb5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b81cf43c06f4272e6063875433df4da565504bc499d7529edb271a0013edb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a03d4aab57235d9f37037a09fe9ef955f2b33b3c4d61ea91b021a674a26947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f08a1a9598db6a0c9d05f59665c8da3d792afdf19fdd6b714f7876870c079b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28ee1fa35a70884d36a7dc42f1c8e26fabcfca713fa5a236ce9a607b19dbf91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03e3bf669fbf2cb300506dd1a56d9b41d9a2f3e69c65bcdb44da453325e7c48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d96808968f25ed3d15cdd439451c61fccbfc9b101e78a8fb800d339081a2e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26e77009ea0df363d275f2b47bd91220221ff91be9fe3fc912ec27ae945936a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50e1f274420f73f9968187fa7647fe50c7d3ab9a4ec9808aad97be2daa911e6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23aa641e68b544029723516a04c7d1a3a087cd056e8f4053772ca649116bbdcf(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f931340dc1ce20fc35018b8ab14559a0b7c240c86155a0c74c24c50f6747642(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0171589b4234cd1dc9c88fd7fefca8bbe6b2d5e7c5e6f03691457b86cd3c41e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db1d8df1a9f7bf0c55ddd1863abbd1a900a7bd710a7b423e86e1c875b1ccdbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a681aecb12826f33812a0497d78c7ad1d37e951cead3d0395cc14e549ee34d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06462f155b903907e5a9c9b0203b1fdbbaf34abc09d77a5e38dc0b47b2e7a2cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8bc379f661929ab12898e5a22d45fca471decbb63d428da0fbbe0668197fc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7d72f387c10d6df6a35e758cf85ca3e60782ff3a4782f4cf9f4d4fb8a37140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0357fd552037eb5d64675e2de941d0eb9b344cd589780b7d04beb6129d57e9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b000b63541c2f935f1e4f0a5bb7a8a9d16e7edaae42d08e7e867575a885108(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de83f8382155b1ec66bb1d48282819cc58beb52b139370bebcf18844d720d3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccedddd53efaecdf0da82bbd14fa62b5e45303ca1ff09e120bcccb940a3a8e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603f84d8604090e44c3eb43c76f35744627a6fd4edd005fd672e32c74e92cbe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb564667c6f4341c5545073edb32b700306c413470366b9ebb076d8ac36b275f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e6df569cd407ac25136af5bd47dc367bd7a5372a29e7798d5b9cd06df10f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ca25ac6943651958d414130d4be2e8df016db49a72a6b6c5e38dbc233651c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f1902736b3c39cb79d73c3f8a7bc92deb9d0c1b2d7dea9f90cf6e0f10d2f0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d7c5b8896f91841693d218af85e1d6124da5261302a440598e6b1039cdb4fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f58fb94216b4714305ec44186517346acfafe270e17fe47332a5129fc43831(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf6fd3c58d6346c63860df084db3cb16b528159e750d34dc3b4b18dccaf9e36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d794b6641ceb97cad2e2a00706d556743276f716d9b27fd342cacc9a562182(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1778c4fdc99ff890fc479b611b5295282e39af35c57db7bce4eb86048626928b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1fd844125d9e12f012f46bf0c3e4f437f6b49e76e8e4031ada099b5e26e165(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4264d5cd5f883b969e1ad2dd11e4aad0b4593926f72b8a6b3724160848eaf9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9036166071af2a37ae4e9330000096181ace3ecc3971d533a248885f0717302a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0bc967830bfbc82edfb4856a3ce5765c8be4002375e9d2a44b5c3d2827821f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258bc6cf6a1dfa640017e39be547e26f5c923d96585dc26d00bf87a6691a6875(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075627c54a783a26eb7d7600a79a417cda47db7e8315d029dcbbb674f032ae58(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59019def119bf297a0a8b681f7b380dfe91f99b4a2983f466bf3bacd0487b49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d376a3409f2660ccf47019614e5d82c3b8400a41a40bd51950ab5bdd586d1b5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dcd92d9a628d526d0516ddb50e54b40fe25efd0fbcd0805c9580d25ca5faf03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03be98bf5f373eccaf214213170ae0a07c629787057939e3bf89828548aa7ada(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ffac9b912a0381c7e9d68e85753d629bc62448f00faec01fb8b29449a6de63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ab2ef4ff49865909a93328822241027471637f32356be54d284bbef696a8f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecd1540aef868d9f3d0e2863d7d3a2c35af41e81da6312e38e7054ee9e4b037(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ed021a4d1f8cf6ce485a1b94d8ac8218c1961a20e6d1bde475ac311d237e3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__794eb04e618ffa9b1c59a6ceae8cdb438eb42eca60dcca8b3451701e1360b3e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695aaea6c2ea0cc2f08fca87c9a37028b05b52c4431295a7b94322e2f431c2c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30b33533f116287a745f91e38d6582c0d314115f32eb91f7b16a60668277df0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe93fb4af87ab9ae11dbdba1f2bcf5af333dd7fca5d0b2db034c5d40f3e4b5d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b287b39e6a84895491b189a28f729ccb95c74b45e9379312d0d55dbd8e09d20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4547106bb0a7bfea28776052b4d00d46aff5e3d0730053373eecb80121bff51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70da9bb5dd6d658dd31b8099ac79095c2ac32423df9abe4bdc0aad48aa8c2aa0(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69950b4c7eb5709933d237591a7a0c7b32d2e6601a5de44c6894ba211fd72714(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0492ef1635845bf27f9c8f506a69779ec55ee39c91de86e92f2453c8148d6a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25cfad9863299422d720d27e4137d2f2107b4cd2e2a49d6003364a6b1e882e74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1cc1ae6e5902d9dfa12bc06f7738e9f06c2cfbaee0926c739e81b07f02b0187(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a54d9fab251da80877fc9012f704e9765c49d49a9579a01ac52605c2a763230(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f13623481549341f1bfeff3b64aeb0dab3fc613538381dad6e3c34ddaf1245a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e71c63277c1fbe77358b2701122590d314bf1932daeacdf8e68dcea933954bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037949aa4251d6951d5333b73e2c4df27c60f854944240aac6a2203a6f8f46f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df21bf1ebc1fb508b72d10be39feaf60127de9c6c8b47d26c86998619df4024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1718370c9a1ea914b3bcc6103b8c02f43a24fe02da52544911f46105e3c2a410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627d6e731d6b4b6175439f4b36ccdec366d8e663efa91b18e2393ea2f4ae68e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56dfe5e0426203f278660dc1da5c86407f4dc3a24d28308ff3493f9e0fda849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e3f4d542fdf5f060aab9643d9b6d5a438289f5e27e070339dcea91708b26b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca3fa4a3bce305d7bac00dbeb95da9aa90f09b9ef136db94b9f2923c83803e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dbb038f26d7d95e7d3119def9a261594fd02af2645b80cab887032714e88ff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91f5510ee9df67989bc954919680df785e48b9a8e5e690dd7b504b0c8fdb72d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8a8e73a1bc63d888f1117bd97e8b7a915485ac0ede098dc359a1d64503b1b5(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa4dd4445d00a0f426711f8bd397d8bf241b9662dcf2c28b54c1a48fcbe2753(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af299051007d9a1dcbde63b1f0a88b1bd9265d79626b0a6b28dfe94eed17a3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19cfd78a4f628e809ec3b04eb3bf6087008bedbefcb045778ea7f267056eefb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fda5679f818a9bdd4dd48ad51f0b24559fd99f67882870f9c01c3c1d3b45761(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a891207310abb0fbb58b22323dbec75d34d79f1a62ed1a94a51803c375ace41(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2835badb939247e8aec7dfc88d138d5cdc04237e9b2464601a3cf7f7ad535ab7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c70dac9bc5cb62a77f591da42c49146a7c8d4321f956566e478847a602c2c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67bd584d20121ce15c719759e8ca4ad6846cc304d96022d08850e1a9a4293ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6799d47c6385ded923ba8168d695b62e65914f32b3f71b8f66a225169cc891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ead7b4a747b697ce00eeb890cd4ee5021100b0a67aeafd7fd3b5b950e6a2f8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c493fb96f01b9fb46fade37a94b3bdf6aef08acbc6d3661eb0aefebe228f876b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a1784f6f79fa6a4a0a8c9d1e0204bbdfec17973e6cc6eb794dab82849f9526(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084ceb725fbacd7aa1c551782c06a5f1e450f1c6095cdbf6315c91c1a089066f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65200199bcd946d4733e4c1e6f199cd052cafa6da84bfaf0b1f0e0958445195c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de86043303e7e7aee5119d66a0d91f073eb1d1c7a7c758cb76c902a20a853b5a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079d802923300e96230b64a6245e1f6b56703ced7fdfc2f1d1bdbd9835c11712(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aad456f3397c8e662e2ae112a17104e63748bfe4f9987bd61859a78c0e6aeaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a977dae8799cce83fe2b22136f6fb90fc3240743c93cd962079a1abfd86f6d09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3dc327ac9ef54f48bd4807e707101889789ce0c939b3d94bbbfbaf38095afcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1a54f0492428e64c17c2976bb0dfb7926df1e19207ee620f90138fdc4c0c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e85c89b2d11d39ef97cf95477b1d24232ea635b53517359adae452d8025ff8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790eb8b7a6bbafae59abd92d162873d3d2efaae3826b9da7efad5157fa992579(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e6bd969cf267e58792e67da20001655a706ae3fbc14fb2b963b82273ead79a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59a00e55e9058c4b964d81df0cb8e60f5b318add74809040623863be33ee75e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9f561f3a628ced8da425ce904e3211c72ef6b1f56fe33b7f6ea7ae716c16aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2e0e92dfbeaeeac085b9f1cd770bfd6b6627664ad9dc167dc9f91195c78ed6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a131f6e42af29a8f41548b4a353e8aca0d0cdde628024d8cea67997bdbb19f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32abf5f97deab00d0329f2e5665f2557c4348d87f88edde82d1cfb738733030(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1574bb7ae46e61058704cf6bfede8f54f55ca4e698f2136998bdb48a6b1ad0f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26eec2f26e98c74f21f4cb2ed9018d420b4c14a226301d01c04f6bb2eff512d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666dbe7cfe6ee54d81b0cf161b76d30b3667f0968dfa4d26bad01e6caa248095(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1577b150bfa48e0d903789c738077b525d09b7d7fffd1ee4229ac19fd45bbc78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27868edc6e336e0b696f7426eac5cfaa40976c505aceea09459cb23dce5f41ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf8c8e4a754dfefd7e4a1c68459ead6e14c877ab42c05a23db39ff2f9293281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed06365dc21afbaad69eedb2a1b909c95bfd2b94cddff6be340be84a575c667(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab12fb067342ef4601c74f32e0ff1326069c93131641be3189173b207993053(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b609178dd0f754679b01da06441b4d21c4e65d95ddc42275fa2f2e53d46cbc68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e2df768903ab25cab7122db04a7634c3f593eb02a66df83333506cc28d3a14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2f80dc574fa1ead473d73a783084b0ad902d0e98c6abb3c5c82b7179603b05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6462a8ee4e098477979732e77df39ff8cc088c1c00af90f1ab8a717bd6dd5a86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c0a8ad9edd69ce8458ef1ef474297905b3516c5a94caeef22d180b650ccdda(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e8f439cc86b5ba17a63493da2c5d9cc249374a569d6bb1c19a204f13de16b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9d1611dbb2143e62aa6ffb75e8388ca6ef05d39f366fcffffde2bf975e5c0c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cff6648c2f3c76334430758dbcd2c9e447e6b0648b312a70f98ba104aa8be30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828851b99a13b1a7e251039029b28e9b7c6b03c4f0f692be78f660f8e1b177cf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5846f36049f79ee15266d50eccd8b9d76d08fe5404f51bef9db22f1700bf4a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72819944360d4ad188d23d651da594b07a6c658671edecc157f07354397112c2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7902bf5c1acbb1db028de570641c6fe871778b7fafbd67805302e1ff2e8a4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078711588c0ffd762a36534c726fc30dfdfb4f48716626f5974293afa27f5b3e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bfc57c1ec8adea701d580e78e22cc4da27e3ec3a545ba18b2b66c42880000c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da6e7d07113450500817bcf1ea546c43771559d107034ebb8664ae294032da0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4558d1471770a32713d2758f3f24bfc17a0923f27102e50d294b5958fd4fe9b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75bdfeb7261faf1e0331982aa94dcd8928962401ef113d5bdaae6fdad0fbf3b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c94d188626b0a71f2e4f3ebf9fabc33ec639245c94da34fed1d421a947b1d16(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bef6495ce7d6564a53901a06b91774617408de0df19345f97947e18beea01e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f987694db19adcb2486c175f82f158b3d0c95bf99d02c12ac92877b8a0727c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68182550d1cfc9c385b4f9219c8d070995d355f28aca38fe79550ba18509ec84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f2fbbe6586e3bb2386767f66e6fa82975a4a28b000eef0bbfba3d1ddf97830(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e7eaa4526c026987e49b5ba7eab5af0352eccaa6b790ac70e3008f779f04cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a756f5b667837bf4ae15ba2f305cc8f82d3218ca0f1d2afacb78e836da915879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc14870d2f5082ba2eb8aaaef9c378bbd707eddc14f6cac049238e582dd58718(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ab72782398252bbfc430adc88b6cc6ce8193392491d219136cd30eb651c822(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c3970d36d553e28358c526733a598dc6e2616ce83c64edd2fc00c23174921c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8214e4c8f936b86b6962c74891d8478b986426ab5e6737c4c38ac3bf5f9e6f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983d370df419d8f99fbcef6366cf07c1a200cb9564271ee6cb3f51ab1c3e46f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295fb6dd4599d7dc76b182769942b75d83654118ed2b15bacb8e99e1e8a8cb2f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ab127f31175a74ebeb0887a140c41361969fdfd6625395de3f8a5701fa7aa2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__022c4169e9896263dedbf30826d512862ff7b8baaaa1638599007fc2e4f5b29b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f293c38dbda6e93690b2686b22f710cafe642a1ca9ad2ec418cf55caf96c2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a67f96804ca26f2ccabb2ba0d77661ac42d72e6d3ee43fa680a7116a214cfed6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd45527e24ff8993bbc1cf00a0feacebd26e4785041447aebff93c9dc5468a01(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13718d7707478987d0b56849a8b7dc1ab72b41993a1046c173d2c612b26497c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bf273b168b4b713bff6194baeaea52506962d399965b0571d17e32a1e0af33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56896b02fa53c3ffa8b3bd7f0f911470bfe7e4a93075445612fe7aeb1e27c7a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b76711f97b11778f0c5d5a0880069af1a0feccf351d43ffe041825269933ee7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b635391d0421d2e443f68f77e5bd136482d1c437c1dbb8c5eb045f7155ea4b8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319a1f9cc9eabce755885af980c257b02d8b260b7f59cd07ed7589822214d698(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d20da8aa1b69365534147c7f7b4414d633c3207dc1ac9dfa80dcb531b4995a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e13ead97d5bf7a2a0b733a95e10f52efa074e0f26d9d63fb299df5c0c633dd3(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2473f35a378efeb9f610ab695dee0a9b59e479431dda600d1113741904a135(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8deb2910367e3bd74c82fbd9e9fdad8f067fc5291196592609770a16894080(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558ae54f398b3be900d3de2d20587a2c7ebccf546081e7df3bfa9322b8f7f24b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ee2c70d9a5724d0b360011955e40bb70b76a8b0b7e7b96921e3e552a74746a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4790329637019f52c2c3a3d2ef92589c939f236842adec956bcf20e6e8f709ed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536595651acc52d61f6492fd45715829733f7d2d9588c8baeba663242740ddce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51da62c5b5d264c85beac85dd0cebefe5ff65dea66b3963620d9117e93017fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a4b456d0309aa0f8a91a8a818fc5985cbbfa7f377a8a77b521424e64224795(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fae39b37a86c52a58d039810381d3c57a27160c9e021ca9ee4adfdb913fe61e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d4ebc4cc6d90c9c70bc5996a5f88b6e47b029009aeaa06c8120a5f58602e8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91e444b0daffc38bd8e102df0412e36c1ef96780053971cc9c41663844fc51c(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2e9872b4564bd503c72c177a88a2d0e082ce274a56d21568cd8c23b6c3bc44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f1342ecd110ffff1d486e119e5c523e4f58238571b4cc2ef8601b42a6dd7d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d9b940a801c8e224a50c1c187ca6f362a156c801710eaf8f8bbcd74a5b233b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae4e9173676d6749074bdee090cd5c7691e88da7f950c732f50b63cf35f90d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065e8feb2e8ad041e46ee85a29bececfb19993443cc68a55a0a23cde1dd503c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b089d5ded6b9ba2fa51b4751e43940372b2541a5f5239c16cd5c2a622825459(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6296d4548b2660a97d1616b683debb8b9a800770ca221408154f67683ec08607(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021b43027cb58f3baaff0811bf25249988185f010c0e51d8773bc246bd4ac2a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7888fb62e9beabb59a1e45ef97f67af670103937eb31283f790e4b31261c76e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa2c89698bec75d01aca0d03de3c12ca370b9e77f9b47d21b0f8718bb0b13ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e8a2132c31bd4ab21d455347259cc5a73756d3b6d3d8f85f5c7c64db46502a(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f032b98c515814ddcc1dfb11cac7ab83befc01a1c9adeb29fa7a64ff9982a1fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc83817157b8f0066a7509d10242033260f7e1d21a0df81f29ee9b2fd45d87e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd6478119ee7c9a79bb42581a15245a733584bc79663eb77f9d80477c90a5ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84528019f99d24b179a8d14dd3358fc0cb28879b90c69f5f869fe458c0700d66(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd57cb90523e26a619a8606d2572c4c91fc751d98a313b7c2de96d7b6c1d838f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c60811ff3fe44e417dd65ed66bede60daac38108a3db1f97a05b33447325799(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402efca99bdb5e5ab1e45764b7631d829813309418af7f511177906725726da4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a09cb7b70645c301d9c2f7eba2c6b65cf8f7726c1f7a7f4c728e6f13873b913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a428038f67ef3391387a7f54a10ac4193dc13a45b90df8f52025d78f64c95f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab83d20c423b81e6a005909de15caf709ed38154f73448e23bac7b7d67848e93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a39ea12a2cec7b75261f7bbb8b1a0073e9b4c1a68b19ef2a19ef2c4bee54ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5e825ab07314b3b385b64aa9f525dc80a2d5264ed2e34598d0f3479db7eccf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4fbf19718f4b444d74d4865c102fb7ff8894a1cd3a5c1a0da44ebd6787448ba(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0376b841cdae8db0a9557e25c929d9f58190633e549895341404687ed7c8710e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc9ab88da1ceb1e37bc1d8aaf4f38218c533e88c157f10f9ac0f6f4fe359ab42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bacfc93c3816415053104eabaebe43261dcb9c4a61da3c7f910b73abde85d81f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb1e0b0337dbc81aeafbb00f5a63a96daf2b1aaca68fdd747042fadd3c41e028(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6e91c0ab291c22fe8dd9f1706bdd8cbffa1368d298c7e02ce5d357d521280e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9e9fadb654783f98849988db3699672efb2f211327ad932fec4d5fc1773945(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25614bd2b727010d2107178a563fe95465238c2411d44388ba7a7d2fa34bc8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27d47ee956c58e56f1671b2a657f75fe28d0f7a2c08b785d1ecb6aa63bc667f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40a26b3e2036c715bf4635351b9a2bd70786f87524210a179fe6325981c2dc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1837f788ee8308f8480c169a749a2645c28b2ff045da5c516af9b093822fd469(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757777c601d06613b8a2f680f63361e482f47ea90541fed72329c8f42843fe16(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6697d3c1a69cc8154661b00cfe256600b9c97365cac6d3c4798459cde6cb4768(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a451e2ac3defe82bee453baa17ecc60ded0ab4149783fd90be2ce5bc148fa90a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf2c31ba665f27858b5f90d73da7fad61934915d4f877e1f78502512e70ae60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50781ef151110d05dbb196c2cd7c06ae90325baec601cacb435650c04805362(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600fb8dda1acfb7cd6568ab7b485c8b821938027b50d4a7f1190cfa5e8e5965c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3388509b9f146e999d2e89b469cc062054742c7b2a03f0c90d9dc338e45205cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8cc14175d45445c5e221a3e9a5d537c37b19662aed94f83e186da0ea8453bf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385fc9bfcf8a7291489212983c3a5d9e33b5c15b9805fa63351ac5cf90f4a53a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7531b4dee4da42949c6848252b11bd8c99e74b84c1551ae154bdf33b92275187(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c880d49ea3bd2a13f7d3a61fd74350a252e5172044991415da3d2df6c1a1dab8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0922bf79185fb255837d5d13fea0de488acafc0bcb068cbe0cbba6f9d689159c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a6f2094efc2783a029766a5e72c2c424211f0bee09dd0d83c3f0b86376da2e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa94b0751af8da8cdaea441b831d72b89fb57dcce0950d952d8ed987838e095b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caca802d5c40562e32b152947987193eb9231d228bfe9c8ac0679828eb75657d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3bd114098e4781055f05855dcf3c1134cfbe8427b696311cecdb8faa6a757a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da85ba79aa719cf7d1050461d54d1817a9829bc51e89e06831a4c6aeeaafbaa8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b64c9bc344e3f1be1ed3891741993fc2c5968deb4a329459d423cf5d80e9ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a9f00dc4b41b0e88536134653c359f90c954c5834c138473288400fbf114e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b459969da9b2cf8d2c8d9b4566ff8bed29c8a3b1e44aae565494e7adab8a979(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2daf28427c6e7a068eb444898f727f6f0709e9bac9cf3c021ef802707d251af6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__317addb51dc5b8f6b1f6546dae69fe021d5e089069f4861bf185896ad37e3178(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493aa64c2ec127d67cac6ed31c7a652d936b0ac0290d27c65bd715d51de4eab1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b596b7d6edb0a17c610bedcf3e7ea4432761a0ecac61cd0191619960d8d6b86(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5468f476559af8b3f4e35c04150ce0d85c96155a2c03de8a62d90e6e8a760d92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5402c0dcca51901c06bd089aeb1643513d7f75819cc62c14ab95b951868bdc8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac513e45d4a29d6804da9ef6661ed2ae7acf07d407bc242dcfb11928ea5c8c5d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8169c29dfe4c42d4b81f073bc39a157d3c39e1f6ab70add04418d72dde9f86(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f60c67ae45bf641b05f1f5842aca499666736aa0729d1af82236532b996dbae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a838f333357b14b3b7041b4d38ab17da430a33e3d7c760f8ae492b056bc4addf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a1dfcbd6b52444ebe3f5a08c8ea2487eef0422184a9de69d80b89cac4ed7fb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677b62cb8ad22cf58265caef3fda3a17fccb9dd7f99e6141a9c94dec06b00c61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffcf2f634609b8464f715a7a2d1865698d8f9a373d2d8722d05cdcc8d072116(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05cba21b4f0d76bb98b39de9d28744e8661b5c2dff560d56ae2911727be28d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e4e2f071369575df75f46bf564c961e47e64e3c29b9e21643af4a6a0d82149(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda3d8ae7ebdd503627ea3da43408caeeb6d4b640bd1075dfe188087addaa9bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93fdae0214e63bbb80cfc973dd3cb7c57de6ca2c66ad58f54cd65a3a2f7bd5a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e373cf1c4d07d3a26163be2c729d5ef329779bbed785444903318ded41bbd0c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c3d9238813d0604c661fec6fb89ec20df8637374c6a26d2957255913abaf8a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20ab15342b45de66068deedc9ced10bdf32031bfaa22124267dab67ec732fe0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6b13eb774f0636e9aba635ba5e22e8454370aedecaae7bffd6b0628d748096(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18b929617faf4b4d5ed07d31206bf9e6b4d3210c13428b2f6786a6cac68f4b9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d2cd93b0196f3f2c5619279cd406cb47a463595cbd12d896a5927b52a8c0fe9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33619631aba6e69256f693212711cbe677af2ada2c55d83e3f451a277a92ce2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ee1dad2de144dc0a3ba7f2c02a1acaef0040850239b810703863e44a9c05a9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6207ea859ca02712a5f916a6e2477e3dda83ef0710edadaebdeb7d4e74279a4e(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7529d6126811fda68429c9d5261fe0769c3546962121756ca04edd0b375b07e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb6dac71d1c5f9a53e1937472ff2bb16d4a4a3be05fc82e278a35a6225895a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ec0af11d924733505f51eefe2e3f8b4934d5dc0a55ac9419458d79f2425a7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06af25b76be6026b655ab0e4981dd22542ebdcb2d3088b4121dad47b3e3e9f17(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5549b12bb945fcf3a8fb8ae7cdf5c8c8c01de8feb46f910ddd22546dce91561(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590f831948849fdffe967004f9a05809996d9577a2046bc704dcc8a203bfb9a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa6e518e1fbdab00b175601c7235f2c6cc39ca12fe3ea172909c44c93ba4cc1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa86c80dfd3f47c35cc047e7c2368c1057af424a531e3f86d7d32e50cd3c08a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a3857c43184c01d12d15b3cee40b166e668a203965174d9e854c5f89abe1d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a232933c4682d4137f3e97888bce97c418657ad439350e56c8f88e9f5986da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d3b5d462173b14021d2b3fc2e45e0cfb0f45befef5d72fd6d316bb37b50c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4807f6b928de400446c8c7fe1ec1dd3684ee186df4200cc5bd99fda54e3249f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bb66e706587fe5123dbbac80d033264326e32bfb56699257dc1ec1d8f3acaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c764fcbb51d5596231482ea7818a0ee1996586934f89bbc5e5d5d4248bd22db0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f256126ad94d30978db9a922fea1f5ebc8036e7218be78b72a0f7e439df7487(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7353a67e981cbeb671dd6b0d26af8bc847a2027e8ddb8268943b73a1f144ad81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3caa532ff2ba6680b9dcd12d32685d93332c87459a64a5e8efcd5e4f636b55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6c7e145a045dddb71ddafb8660548b304792666ba63fdba951f964cd664ca1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737c699a0d50e46d324bcb0b9ef302ad5a1c8624aab0c53c85f29a9852b557fa(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84448d62a137b17af2d04ad7c72e0c63dcd4726ed92784e6f738a6dccc2e3f04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9cbbea6e792c565c10885e7a6505bd69f11ce8340a65ddbf4d80b39fdcf7743(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488e25a763bc6bcccf1da21cf7a87c31a710ee063d1708f5702789cdcbb6f0a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ccb32a4b7809d1b59dbfe492cf387faf6e9be66569d7607f8cebf5e413a15d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a46206639bf24c736b4b09a609a95b1679cbb1d669fd2720b9ccf5cded76dd7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b2f667088582cc06998d5d42c93d1b46f518f7843a3071a84bd2e0065b20b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046448fd889ba360e026c0880d17736a350df44e2847bd3184703bacd418f740(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a64c83a2be89ab8b2baac88eabc5445374e5ea566ab2b30c41677b1188ff86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56816d8c16ab76dda83cdcafa1dc942ebc74d4fa943d9f4d046ef1c9c634c175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665c7144dc05276ad3e04b1a5b697dea27604322527497c4688248abd6b5ae90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2713cc6490a2969e64b3b8aba4360620d992818ab6235b40f455831956e87a88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aa4bf7dbf231f5c4461d93a308c80932d429054464d87d3da3f5e200e1d9c1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e491d729403762592532923f799ace5c3c994f652d029452b132aa0c8686b465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b2a49c8202d8c80f89fcd3dc2ec294dbad615f3bb511482e970cd94cc6c489(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__738372ab914e0c7b5742416bc67e447bdfae3f706daef6ae3cce06ca7aa7137a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4258027049caed494c539b10c3380981504332de4f67fff6bd034886500cd89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb86046ade4d5baac1c348a0b0f09a7102ac40b2f2391dbd61ce24c2307c990d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2582dbf37d889d392acd9a94fcafe9ea77d7e10d4e2b326ad689ebc18c07490(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c771cc9ef40acb14672a7b39c9e247411e7521c0117854770bcd27fb355e10(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe3942a8097a20e42720c84ab1dce1a19a85339e45857ef7c6293a0ea4774c1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2892c42d93ee098b00e521ac7b33fb908027e9c0dcdab23ceb685bc010c3670(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2717b8ba2295e4ddc2fbd020bbd9f04893a23a883ff51e5bac0792dbd5141f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e08ad5521ee96e2bf24aac175885c67cfb3b34bcc05a3723c62798812a1fdf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a0c44a83cf26fc6bad510e19049a930b56e79d72e3d852509f6d9ee0107213(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b672b420781b65cf1a821937fd68cad7c454840c5bfa92ad2863b429e4079664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f76a1ead8b8e65520c599da7151df52bb53c816e2d3c1d72b2081f1787a39b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c466bdd760510426597aeebf3ecbd4a310912aae55fb45ef3538927ff2b7d9f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c902d30e2b81800287eadff72d743f1dbb7f332d4409db87b8e07026d09c77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a217b0f12ab19ecbd601540905eeceb791ed7dd23ebdc8798027fffc212a5933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab43bc1197c793ebfe27ce414b48c8f23d18402864d7fda8ca24cdee649c76e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed23d3061fec9ed229b48e48dc957607d4080913d3e7a36750d60ac79e16bf1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294a38b4611d015c20a5cd4345e7f1f5e9032f560887331067c0be09b3bc7609(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6763b48e363c105fdb50cbc6e2db684298c8546c1594be636afce4358408fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b2b5fff124a86ead6faa7864061641f6a93bb7a6d67ef992cc1cf005b5cd86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9347dc8ed00f42df64e6b30d0813c3263ed71bfb707c2fe39fb188b2f571afe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ffa8160766e5c2528e20c51197c08b387f180e6666340db8f4778e048d27f2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9348a4bd32de26948855bfc0485c72f43105227ac3c84f9e9a08f3fd5d1c61fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__259bb5ccfc0be7f0bfc4a7bf0b350e69041a29a8ba127986071ae1e1733a6c3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab4d9bc61c07262f15dad63cc3ef393af4b8386cc0327c0619e7eddf2ac44d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcae121578ea4884e55849b779133f844ccc6c557dcba16ae0590ca5d0fca785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1a430f52ddd71f559e5122f08b22b55a0df45d90979f01ec60fac580c63b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f438fac8cb3583c688bdeeb7aad4619919e3bb488541b24e66dbab35747399a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c42f495ce7e91ba84f4aab7d6720e0a2c8db66a5fc982efb582050f3f28918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9556cc8547db4ba2bf464c37b3375462677f1b1b35b433b15014d4b58c348ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28af0b3f821e74cf3bdb376d4a12ceade667ff50cabc9b45023abb50e9f88c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef48457a9abee35ad34bf76ff6b5a4495a0c8d8fb311a08c9e5e5e49673b0986(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a448a187f70e21454759f998ec80ac214cc620643cf460c124913d52a9b5fe3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52549d091976d25deaade3171495169449da09ae9475c6422f35dce77438d43a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c88c99906878594bc7b130051197d342b52051f11ca822aee069accf51114c(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb76dc5aa19bf81fbcb860681a0e1e7af6453fa63b6d1d722f1a58ad89d053ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79204f3b84072f48c550205d952a572852933fdde87df62a97df93d70431914(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45f4eac4bc9efe8c40ae4ad9cc011222de1aa60698c79e3e2f8f9332789fb12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1bf042b11979395c1adcdcf9293cde827ca108c5ee1bdc0ecc1609bb2c4a457(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b822311da6350e0c2dc3d5a0cf35d951eb3078f1bcb0401e0a07763e350570(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16199ce3b95a64c88a2b8aa14450e863050f2104f903918ca614b6a4e5642272(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de90009ec760d65ab7771d443dacf2b0e55d98fcd8e46698828a744f840a371(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e56f2b210306f1ceaa57cb98fb4eb028d6111d6d5230798ad6b7b3508af745(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb48bab9a77d6eb6ef306b106c7830f1cca9b9450250432ceab4fe4b07a93dd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee246752cda2cb956942ef1336774b49657e7093ba47766f8f8e3c4e412d9721(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f03a2959faa9d8b8d61b501dd1a6c293633d7d6ec779e01802d16f3eb114d0(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b6d0475b281065f86cfd7172a8250f9603ab8c583170e2f0696999fd065a51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9ae89e7357c5814c04099fbc27856ea9a636bb92a70d9aa0a43731fa5de1c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0c16f4868d7fff3f88c1d3aa3670fa14e48bee8938dc2bedd43e051c2555ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811128d9fa1115759ebf92bc04588c23714265c5815137cb59d6b87cb29a7b2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5756d323fd5568a0677e19187fa7e2606132536cc5d48b08e1fe6dcdb7215e42(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25057d0576b775dd7926d63bf4cde0da3ca641eb0762d4a8b0e665514a1077d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba01b211358b805ede90dded52a561c3ffc8aa39fa8f8895374c10d76a9bb19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae3da4bc644924eb1a00bea73ee8b26229a8aa879ffb12e2c774fc2aeb1d3fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf365b046701649f11a3921d3ef5f812e8f85d5b1b02f165954d8289db5aa39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d805cc6635514b9ce5525e5a99217c82ed43cbf32c9d55891190a1f7681c829a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea63aa91b5f2ee3c63200630caf354ce9e82722ef17f4697812485fd10445c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf49af4e690371cf819878ef8a1595fa4eb4b6f689fb44a5bf929718767f19a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c527fee438a53563de3477aa4bcf05977ecb53f3b468798268e5d0fe97e44a8(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4fd2c74df17557ce81b9508c70901da5a76c4f31b8feab79c13e7e607b86103(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090cff20fb025d3d6defc0af200c243c30db5ffe93cf7d3a9f451b3192c15c74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c6269f3cbe99ab31ed1e5f4aca86e3d6c3fc1cf58637fe10152d623395acf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546a25dd26d61968a226cf1d9f2a0035fb4542a61f6484eb613a8f968fe689bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d230fc1aa62d7a8ef5301e6e41ac7608c57dedae815c7dc09d6159a2471b7b2c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a541858cec62f40caf37b15ce93b69d408ebfd6fe420750502dbda1284a65fd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dda9a6d1ae4ea0d652ac7722a1973e7dd31eed96dfea9defd633731f4af6abd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559c15b893a9a72643ac3f73211e060fbfa05eb5932c8ae8052cfa857646508f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1eb78dbf2d47ee29b2f976b50f6e2c21639329b504395ec7896914dcb7e4db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__624b73c8d93c3704eff84f874fa851f78574c9aaf39749b3d8a2f6327a912985(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed7e14735cae112ccf41433a2c52424ccb87cb6e37dd1fecbe088db08a9bbaf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70abba92496a1beab6de5ee40a289211d40e33bc93268cb4bc0638d108c3e2d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8279fea56bd04499e0b0389c23005d2856052bea996ce8553f31a85c3422b9a6(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17baabc14b97fa1db85a1269951bdd4c67b9090b3ded392cd672d7e0d76bbf0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9fad572e94c8249edf69765a3858072797d5337272315f0ee89e25591b0295(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c70e0c80246efb2cdf9c70fd18e6c8763f32f0823b946b8a564d99347ce174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c5ec2dab11c890426b886ad5d11f5ad8caeb68209036b6194181fa9cdf5150(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38711600a2a205567cab852c19ac323e2be05a6a8b444c917fa53f55a0e4e50f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330ee1cfee6e0a599a86f2cb95efebce31a3329277c0f8f3a6be1bae785a8669(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da71e5740a7b5b06f9da940c6375f5c4690cb49c7aef5302b4fabaedc26de2b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1d8a0513e8c9bf47bb1dfd0cdabc03684de83140fc891eafcfc7dea7b2d4fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5044a2f178357318d21656ba5f68dee59ed2b86e509e7d3f2674ce7d1325cae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b74608ec219066a409bda5b79154c33a96cf8bbd3abd1a018a57fe4b47890739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95598a1850b369da18d8afde341d6bf9a52842e1817d10af3f821ecf03f54705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d15a317e37c986a2f8fe26b7953e27f8c33dbbf56951ff89610dc79d7b25b83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66054391f9ff430ed6082a41d2b1195585216ea753286536abea0de6bdbfbc6(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de8cff8c21201f369778a76b7bbcd46c3ffaf7072351f5a2ca0b5348deb39ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da4bbaf9e6e8fc37a91001c3f9cac514d4b1db43b48d3df60a9d1c6bd6ddef2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55863b7194d368ae40ead87c32b7dbbf5a80bcbc5c31ebbf8a5c15be10f1d643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53fa89a8e94b6123fa9f11df2e56fee35eb7362ea83479d1191372aa2f57845(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63c554f4681d1fa93159c4655f9dded41b2541f21deb6be9473ea65414e256f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efed3d665912efe2a894f5a04da1ac1187edaa3aad883534ac03f7a33f1c9906(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f4d23074f6bb1004fa883fac9bab25fc1757b8bc26aadb67044d38c6615aef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbf3380283b2655dbc285d0ee2f22dcdbc85872e803e92939e9628b33dad46c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155477a3093f4d58b9465191999f059d102e4218c2d571ffb4db7d9b65f51e96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b9ed7c952ff1ccb87897c54de2a9a69be8062fedfc4bf88680dc84ef4c2bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64d64d30073a2624f851d14eed2d89576ecc0de2d405ce2f2a0dbccf669741f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7e8a88c29d29ee95170dea16dd8562e158378b6dbf9bee5003c7f0e3e6c85e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b36890328c4e75dd899517d3d3499ee07d1acc00badd8af5349d971fa06e66e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0178b4b2a2bf80c8368f07c2cff45157a92e6576004b4d0a121a045b645f8655(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3555da39899fdd5d1c06f726e663e27318ab50abddec5cad8ae5caa772ae8f54(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e351131ed9a75b4bf4b4ece22bd009901002cc111cce2b65318ecb002c59d0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722a38328d4addd141445ecd9f4b242008f6a82a63585d5f128ea309febc750c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c9ded8f2d56d58ec52758ef3ca515180e72a6cc6303566724bf29c382c0eeb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b57a41fe84484f3a6ec40f96ad9045b61aa3ecbc519372c4f47a76edbe8d1992(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af4891016e5a7b8b6b0e5e18946ecc1bdb8096a08d1c44a3fb4540024dc1df3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d907dc386a14413919aa114ad889de9a2de0bcd54d7939577a7c30f3936af578(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7dc2f5dc516b862c17e2389b33df366ececfe2b2954050a8abdd17485c75d92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb6355084a81fae4333b71861d8d055529600bc647979f6a77a5b6621fab993(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4d560e05072c9c0bb37b97e5048320925a5177d41d7c6f3b03aa27f450672f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30526aecc73675de8e00f89e1dcf1cfd0ee576c2c05019af6a930dddba6d0d72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b69011c73a026cdb46b729f6a6d629168f261737141cc6a5e31906ca8b5fd53(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62752fb04fb77a74d077b79374cf25814d8ec3bc53b0d62a50badde9b7cf245b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba706a0bdc399d2cc6abe5d7245190693c98b5e899ebe63df9f38ba7d324266(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4b78d105c9fffeab6e44c14c951b7861fef28e14b03368a5cbac5c2c32dc7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff6153a699dd58ec0e983d486547fdb12c156f7b97a3f88ba77f570b0c7101f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a709f9d3dc4769eb38f7f322200d8abec1d9428c956d1e40b2f9d9d74132513a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d6eb65b0f804b70b644cc6bf2f0db9ffb43a49af63b4500d704d30be27f644(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37e8aa14055d3ac02b1a126d91505f985cc05f70048ef786b3014b83e1c3e1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077f7b12b38a8de0041a5fcc3db6170628556c8ab60f25a93a5a746c1bf2f415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5947356d9446d93f5e2e71dd109221af86d8057e7ac69d36b6847c64b2c9c8ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1d9ebaaa730651f6048cb4093200c32d4d10ca6e36f27cfd9ad926e1c3e947(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830a66a539c091b1c087fcf349796dcbaf57ff044a7c8fd31dd98068c020f4c9(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d89d3a8ef5e238ec538a9470aaf7c6a58b108a62086991ec2fa8282b9987f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71debddd93fbead9c5b2a78c2108dc0a0512d67288f2b308a72e653368f327bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06b4ecb06d094a86696fc51996a7b9f5eeccdc82651ce8b82398a89dd8fd1c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2f937f1eac155190d881fdcad133f8667d765cd6d04c2d8362bcf642dd8990(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c24594a7f1cea25776283ce1c9e5cfbd4d852bdaab07fddc29d124ec9d531e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f3aca697de2793f11ab896ed0fc6910d99d4f762bf577b3102ac4494f514b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa1699b3f1a87d39477ed2895162c16f5ec8246e3ac870cbaef9b6ee9c4e5b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4053c403bb81e57cac0ac4daee8a3cfec8780a878f13c5c1a6d0c094987df15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a3246c737b774ca59508b34576261aa7d7a01615a3678fc599e0defff0d76e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04b512a94806019790e3fb8dd44547645df5a708f393a65f7977c6bff577c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fb1e63e146bc15331839a8ae35cc2bf4bf7553cbbe4a56d79cf79651b2237a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c43e4ac843fc233942cf14b55502065b3c45f9e29fb07028479b90b27fe7680(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7b2a3b86ec3401d1010132d47bc6863b3b03c778decdc79208cc115bd66ef9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dac72f559f12b9628afa60d45bb968009d04c1202d0c2c8a51c804e3a4b32e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39445fe74a996bb9500c8bc7eb9ab042836638999c6b3922b70d4d44e874e1a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79de15f464ac75f05fc946ee09a4bb8536a2c569abc3b81117a5a9d4ea6b2b97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfe436f5d79bd770d71937fbcf5e71adc25b268eb9c4e5a18b0c59471fea2c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf73432253aa425c333b111881cef2f1c76e73203c783cb5166d276f0d6903df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cf7113e7a959f63b4131e04b409be53df28b58dbf7cd437e9fbef3c73ab0a60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c19e644e43b42b20a1cacdf295fc868885be221f5c5e8ac63b8c3dfa2d49d2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834930e1b7f02b6818e83b90930e9c7747bfa93a82351f83c433c65d7c28ace6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb5cc28b352f460145449cb5ca191e00138cc18887574702df53ff797bf0d33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340d9411b3d7e8c530a5ded6d508505afb0843093b349f5b39d107405816b71b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f33fa437ea71f916df77de1b45caf346c20a984c422ec179eea119729fd886(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b8949dced7a6413ca85276cd2ec01e816ff6c2a53b5e3de9a138ab9d2a5234(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4399995270c33466947a791a2b60779b9a1e3b4e3f6c395fa8f6154324a4001(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103387c266019d308b09a2edcb1daf84f5fc39fbccdf063ef43c9e9858597696(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fbf5dc386831ff154107897bd6e53a0ce74494a069cab2a3161ba4ce0ae4f3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65bb94cdea2ae26ffaa5da8fab494b0363569822684cd1a943c8887fd999c992(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c29e4799aff5860bee0d764b9e684327afe1ee817fddf3116bf060bea83fcb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09ef90b22a82db54e7f6c5cec5fe20c78b8e488d17a9e34046b4b9896b0f129(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca90670a5021bdc06b9b1b337f0e987d2783600517fe408957591f0c0fa08cff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c86ac1e740ce2e5f0d83e011d78849f17650bed4a8ca43810800ac3498d1edc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b678bd9c6643646f1c07f4ecae7d16b2fb932ddc80f831bbd34f232570e9eca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be38d57d15046dac79c6d6d1a9d95d528f412a8b644220750c3a6421a10201e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff932d9c462dca9e4fe84c3172206d58ab8b7c20d8873117d524c2a059e8f580(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb9f99ad920e8d213b1225bf32f8fe88bc655e176b3e51cd2036bf95fb2c911(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d74d3a97a1c5a4af2f7abacf14e99a490ba42b9996b368f9240e1f6f114d67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe56c4ab8b2a3e2f6d3a9c82811ac8216eec7fe9b321010534f097a95d7f468(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c8d1714d17c18df8e1fca0ec3660c17bd14ca9c9cdb2da85b57b00e41bf485(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3dab5ef7b9c6395dcf81aa3e4ce190019a72adf1ea7c212dc094a2dcb2162a7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63227203b0d796575550e7fc1070f8555a571fce03bf90f1d9e8808d997c2c3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f7f988c73ffe58156aeebcf8e8be36441e5d890dd7db4d6499c9bcb945abc6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946b6d47477ac1c3a47e8a6aeabc20f6204c6f202639f92d43d4371a57921d32(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce11ec2bf15b217c3884658b7bd753890763528da22288aaa7c623eba16798d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8dfdf50eb33c9a46b13013f2a2ca04693bd4e9979d7bc97608622ab7662ec7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1d103682ad4e978a6d05b9885b101707479917d743c457195a03e6706680b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55dec016490f966e5df531f8268de9070b5245aac545a45e4c2b0f488c0bcdf0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8828b17008ad975bf9da72a147ff3d76bbbf9e418a694ddba71729e8984b3a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69012f835fe5240c1cb1e050102e9119f6ad6898c548efe519b39cfc42b9d0e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6156b7843a1a6a287d81fea93c06975619058664ce5cf2fe700d335e7daf8b76(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a4091c26f13ede54b0933cbfafe3e29e1be3b0a6f042b066308086912578cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a510415dd57390f974c17d68b4f29e972fb118409eeb0a16f8757a3b95b60a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346467e29bc14bd716f5029533d347122984627e0357ad4568d10da83fbeedb8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef6ec261841d3415b383e5add609a087c7fe2a10731868f6fd3948afce07394(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbf653051d58c96ebc21e523d2143d0c44752fc729b464ff9c35107808ddf25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1de8b6d835ebd58f58014dd1340ed493ddb95df12cc136e47abc73a0e6c1f2f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2c19032aebf56c8f50a070628ec6475fa1483dcadf07712d162b547367687c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe34154456069df8f4aad1bb87b0481a1e76239c6677a8e1faecb3f51f47e3a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a640a018653689800722f7b80aef3e9d45ba50a2dc2fca236cd4824b89dc636c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb549f65998ac0f86b50d94a7ed4d92b4521513eb872ce0f11116395627ac693(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ec9ce11d76dc50f2029e865fad84d917764570601de23c78f4f192822e7c40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f903a4a626c55510f8522a8e8373f6a296ffee26927c3e4883d10230958f0a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f2a91711cc20c27d30b738a94d3bf22cdbc975dc59afb27723bd68b450a39f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d0d2378c31826ac100642a62b9dc739b901dc4b29ffdb766f9e78dd2fbe6dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9010d9f04371fa4cd5c0b676e182765b87b4bcd6e18a70aac1cb2115df69b576(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf64917848d8c00be822f3e79a2c3016beda6bd71837955e80a90f7440d46a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b580c81a809145e28847628ec0121e5ea2010fd5b1869e359e9aedc3b91804(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c73283cee2a2dd5cde5ee8be0d42efbd23342d7812d7a1495201fe691bacaf9e(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be57e6c7b87aaff767f23060e10004d8d99c8c983374332e648bb9e2fb708caa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa2fe7be463e043e5b5cabc69ddd1243d1c90bd47022c6451ac09a5f487f3a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d71442071a24385f5db3cc9152e95fd145094888d3d51e33ea5bf7e8fccb83e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20340150972c619855ae7fd17239776af35eb3ad269d6ec9517c94a44d289391(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a6a70b65109f3439fb342681334678b550446bc9e9d892d0813a7ac217f1af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf824f69ae01ff98ac6768283b34b18ce2463185329c0e8019ff16c1644c553(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca0a5555c676d2327d90fe27e189f776fe058e25ec9824f8c3a6801df9eb54f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6868cd277dddc7ef97b91c07241b83f1409e4722d4924c358d8d50fa33c25592(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429e66a9398ab0f1f378212a13330993450e477b1ccbf64cc6b455358f0896c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ff88bbe613f6ee46a55792d619fbdc80479c60f8474962c61f8ff12991d4dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c8d9c5c025b3bc59b3f9baad96ad659a32217793a6348acbfdbcd4ee4d60fce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8aca9a9e98d3d4875cddc6484dc9f0786e697c0f02def3f029c7ccd2d886a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e57bad62b7571b6cb451ea7438b804d37b7d3c0497e5b49cf5d5f4c1833a03a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acb61eb40b7af3f26e5e6bce035becf26dc156ffe92b5b7221125c1a401c3a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d15c356d46cec28f5975eb74e6729962336f5d4e43d6beb6e44f51a13f992c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b67990a564c67e283998276f8253f7fb4ec09e516a42de24c0177a65a347ac0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77949a39506e960097a8755a1fcd4ee2235dce5a2cd2b3823d919fb9d8cba098(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec046e66d1cb9fff3ddb2c3a7379b6d29ce22edf6ae662515907dc89fbf5bd5(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ca420c7daec94103918b1378e0f75c7d55f93177f5d41c9056a42cfb607ab4(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fabbde5531a8776501e261e8f9371e7a0527fff6f30e1c0b7144b6395ca593f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c53b55d873a18ade1ebab72296747cee2b214bc3ccf0a73710aaa760b338fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca05ec7a4e489939683aa36ece3856615f8bb34ff9d69f96e02a23877ee677ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2be4debb1d09ffc4262b902a189b14d7574665c441d9e9a6b95397b512ed336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ae0affdfb6d3510148e0f2adbe7be409efa1bdb2bf9d284b8016c4480c59ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc4830cab2b27b6ca85035fef47a954f05fdee3d58dd24472992c0093866c71(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93064c9825443cc1c40b83add0a444c37a2b01a8ab5da329b1b23f8c81f67bca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c6f66f9fc041f71a58d3c05b6944804d117142346e69547967746d9113615d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c0aedc9658355065308ed037b399e083c851e55dafaf95281b567324d00cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb031486a7fc8ffbeb54f80291acd57e7f4cc0c4e870dd3e132dbd3fce34499(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0653db107f481daaa23a23c28626bd31cd5a3bf4630edf9360df0cc006456cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cade5622c0cfb320a76cc9cdca74fb0f434010a06b122c6307550dcddc8eb6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cbac94d8487322f87b2ad30b689e3a492f6606105f220f231a0189e88adf18b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68756c999969890ce0021a921cbb8abc2b8f52d17cd6d2d0311e20aef694db1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3c0e4b31210c067404097e9d4ddae69a3eb0d6cedecd10b54752adf1b92c1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757bc957731fa4eeecb5427d2c69725f7cad52bf86418b0ee45c6d7d007000e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8571139e30c0ea91124c7a2d1ae038c6445feef004a2a882aa87737feca03790(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721fdbef6ec6678e7358eaa38a225bb13c2c5eab949a79539dae73fd37c86638(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6da82adf1d9e86f44c3db96377ea49f0ff16a42dac3a8a6b8da21448d05081(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ada9ab541bc0a2e4e187206209834843ee30f08146e5da2ca1b50de3afbbf27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f306e4df7a30c08e093ea31c4f2656f481749dcf051c3e9e8afc681fb3ae21e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2453980a90e51265649464b058a577f4373ce7dd0d05d53e9afb0f422af33a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2df891fbb9665daaf21af95e480597e062c8acff2abcd35dfa39949aa1751e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f64195ba6326bf5695fc6008489c0cd3fe0cfedf206ccf6e82b40a65b8c3d8b(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a22ef60865fde355d38d25190dc996fe4d7bdbd5f26b6b2535688eb3deccc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ffc3b8c4f26a094fda9daa90d5bc62896fa1760feab9b35a1c11a5efdaa56c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d941292efdf7d9ca8e7293cc877f7c8c7110e49510f5a5f01a8c5f15ed63f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4acfeb846fbd25705d527b19f41c36ff2f6294cbd0c57e00d06c2807c388d206(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c782ca52c282156bd1af37f4c51358ed14fe5e98bb43d311d77204abad95a17b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa607d9e3a00ac2e350695e0869c2ad447e4dd886ab07a0c3157695638bc804a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78168c5e5fc8acf9a174005c9c9ac14351f37f6ab9de8b9ac4655e4d62521bc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a9da1549dfc617d42d5a3d71ebd39d80042bb1bc1ef3e035cc22789d175658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae25c5dee2a7ed1b5f5557b37182ffd35cc2c2394c61cd8a7fac38704b87dc89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732146da0dd80df68a20e490a9a2ff2737875e6ae2383817225c394c115715ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9778014ec32fc58a16c505fece536d0a80d568ef31c10eea1e60b4decbafb3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9324db5f230dbc53feac52f5bacba0629273a638f1a3e649875c9320e8366cdb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca1a4891e66b93e50075624af74f9a696686f3ecd68f417933dcac1e160570d2(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fec4998fc8156148ca747e54c0cfe188c574fea259668a39ea872b4cf339e6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bcaf97e83ae4694d25ed5eb99dd32ee33bb7c4600c6fc9784d6d05816b22f84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f944bdb76bf1900fbdbca623bcf82166d317f2adf8309f9303bc5211241eba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857e6db99c9e3881bfa2ec05bcc09f075e5e5dc3032a17a52826444a4e72a8c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b519bb78d87b764d3e57f4c65768501c6bd6f239e6d7bafb3b378810412ca0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52be9b8def8d984fef4f11cf97f1c3b6fcffd93eb7f02893b2e8db642d33419f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fff22025c2b4dce860ca7bcb6801f5aee003859f4701d3dc9a6678670c2bf17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8013449358258b1431a9165885165ea294674ef542a6db4bbf68d18c7cfadb86(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b4f1815a68e33c51fd9a90eb16c65bb4291b43a0aadff2747cb6279a4eb0d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872fa777196e8453886ebe6a8834ab3c7c9768c1ef4c99202cee9e8bebf18b90(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d50e38ff22b0e25be43f73cfa09f66f1f36d94e3ebc693f261540a5c7fa8250(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f2096231772bb1d27b66883628a150c21db8752c8230779250e98568546e61(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d93ee4dc4934a6a03bff40dc780946ba58e2472849c81cd209aee8a5741c36a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f338ca0b1315c4f6eea9e3072728f2d96c1d643d3d64bbfeea61943ff31967ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9ebc88971eb90cb671150a0513054330fb825343c83f3872689db2688ef0fd2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31231d34904229c3965f176c6a4b3e741d4ce8a10726265da48bc5ab0ac249f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6405e9a12e9af7a708a6aafeed7cd2cfd33979148c1f4aa79d33f5eb560d425(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d86639fefe37ebfd814a6205cad74f828c4618a7842eb0c88bba1eeddb63d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9fecc9737e6db3040d48722ab532a463a78c0b99994395f11207b0288ca8a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b1949615d4eabff2f0788c84d49650b2690ff71d06110bf6b74d72ebace4e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1c930a4f3d20844eef83acb3f5ebf311417e2487b3041f2794346413c19245(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cdb73252c9b31472455accf06e3188cbc7f7274d46e4e58dc6eb6a688259252(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea46f55a588e7f5dbea17915f44e7f05bac651a65bf2f2b32a1090a29d85efe(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b199943a59c0f5c9477594cc4eae480c84d72a26651d7f2ecc995c51f12cdc(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c88194cfb2311d435a1bd0550175079dcee395ae228176c7e5b36956191ca32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866c8cd0d710e6941a4e286f2087a2876a40be12841e6697789244c2a1d96051(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b526f4145c53a8e52c6173d391efd31838b18b138296d9614a55b4798efdfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975c19cce59b1dc04f9bbb5dda887978a4c8e87680b86aa5ce16b462c75c74c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000e1f5342882ebab8b15edf91377e343b4ab0dcade9b00c26ab8b9585de8a0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9e45fb1f4e09bf74cd5b9986392d963b9a35d3dd771ca3afab1f6df0f9be01(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0123c454d6eadc2fe991770c2bb5ec9f6d87271982990800539b4e1f797fd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec7932d4235892616fbecc52f8e14aa2cd84a91973e8d669f25ff0761c3d1158(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c885123ab326ec851d87751c2e49c26fb74f35467c00de651c5de71a2818fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7572063d4dc14a3a4f4e3e82eb46424a085cb1094f82649a0e12776ca805ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1316d14c691f153c05771b03a9998d59c14cb37e588ba6405339156345f2720b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3976ac9d882d71b422a82f7a2c9a8f3bdb3cba04b324e17b553ebe994774c80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077338d0d71a15369bf98b0aa832d2a409d8883888996bb0c64aab89e4a9bb7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e17558aa62058ff216d8c3a38c31b815bbb6085b16d084872e388c143f6754(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c64b467db2fe8721ad35c965d97b0f9515f6107c6eb7eee14827f593cc8c572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a1406b90c199174cea193edfb14818c638f9ec28cfab2a0a8a1d4e3e7f8b6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d9e3f7040a52d186885fa19561fe73c0249ccac835402ab18d6dfc01d79970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa61609c486b7d6e1ad4518505fd9c4353fbd925ac633bd3d93adace367039ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e02882c872ddecf537632e45bc82a3f331eb19a12922a86a6152d93aa157ac(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c959b34a3cd6bb46dafa954c56a36794abe0b21b2eb265f8b601c6bccab141(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f116e81d583ab738f53480d2edd6da9545c02a0cbd95300d376a4879ec57a4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718c4e46753b2aa4d20cd6e1017de019abc98a58e4d6cdfc5a5a7248a55b944a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc724b3b4596840b82f25836752324f7fe5e382602c812ee44eb1a30d316cd16(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1dff561318090fb971652fddba9ba37d950ed54a01463397af410cf90fa22cb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f5e95bb8111492ca330ced9ec99309cc1d310998c6e4df4c237f850f3c3416(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147eacd1d4245d0558f091cb799ea54f380c6866c0994e88f8e181d56a4dddc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89281864f5d0f0491ae4c7855ae98e90a70cfdae955ff6c0b6328b092b5f04c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cddd0f4d398671f05e5a72836fd87530f7346b5dc7efef4673127fd0a340d0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adbd5d2ec6830303436e0132c3ddaaf64134fccaec8f5179ad14bc3b16df123b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6917311c2cc1d59cc93f26116daac8ceb49dfc17ba57b9fc05fad31ffd95009a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0faa6849b1bf5b8d27183af3f7dea51850047b989c7c05d96e7c6ca671b8e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3410d87482181228e615f818e5948e5d14c06257d8576d4bda4a6748d4075e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd765ed90ef2765c550d789446ecc235691c5144e467c3d1d9e94ae22ee6e63f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb428ca2fe43358fcc12bc1de26e5df82b9566f9a63409672d19219bba9c754(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da2886b2c6e88d66e5468b0e32fc351e8f128114d2485e9965d052ef1d21fac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80003233b0b37412993ed08e87ff704f338ec4fece23c8071d42df5179189a21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1367cdd626310e2892f408595a1a22163a481257c5ed5e7099cda4ad532ce5(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f0d6851e77b0bde4211b09d6c5b16da41de2b6814b5c830518932b698cef5d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6de09828a387bfdf057c0b73e038105a4d895714227e78f03698feb24de9beb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa08fc04a4195d90b698e9cacac793a90f117f850d96d4dbec95fea1361f416(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676455d13a1f5fe71b2d1b215c60775fb116da7c9bdf43f9d1622160e1905a87(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920fd7fbbd86ad6f51d83d405c02d88e8d39e009a3be5e842ef43fe3b78575c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b062490429f72b52599afaf5c58e3f701f0b0ec2393fc1dbcd4277abcd0eebc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4636f136d7d0cde487738cf54a796186b2a8066fb98f9c3d276bb40f5ccdc70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f233797331c7329e2b1b49e55e5f7ac7bc0a04763c9f4ab1e4793011bbf3d851(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d14be4d1cd96a68f90cc47917d48759e7a88e1b80dd54934bb830f7ce0f6ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__accb3906ac2d3262628292bfe84df6be491f62006f95aedcda46375d674c63ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c8ba650a64d224180d96cf48e5d6ba5d0bc23bf837d4de9417884b3cfb3340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2589acea56b29017a627a604aeefc4d2bf9b2311d6c8420b0774ca0b95ada90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cdade51ae1c075c5998c43249ec0d5f3ed1eba154600c2b8436632855046b9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd421ba75a7594898ccc4ff910e523285adfccb1c7c50131a785b1b75c7c4a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464238760c38deb35ca8f0592ae88ae7390663bc9d7b67e63184b095d52fd24b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb95fb9d16497d71ef9e65b60336441e89a5bb5fa782a9c4bd5c2515ffbc83b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce4cc03f1d676d3616b0200090cd19d0c809a0cc0824042b478351a76327a2da(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5e1580c555ffbc1dc1c06d5118a29c748aa0327673ffca57057155ace10529(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__629dc99a4bc3f592816b36668e298cf43775446ca7d98d575e0fe2d48f19a3b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed97b7b9878e00808ef7d9b2fe8f12b787a8eb86d17f23e36b388a7dcfc9fdc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18fc3840d304e50d7e349da6931013f751d9e7be37fd5b94ca209698ab7d88b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6668fdee7506c73d92aa755617e1201ba643df4ed558f02f6e318ac1b297b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a51b81a3f1754ff91f85174b7e90bb1c8a8654750ff05b0b8ae3353e9af80d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a8a435d3616a9b4a97fe8626b19e82d9ec97e85741c8612bbe19fc94a4384d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3aa0a0ef7b31490df09d8a3ef24a93af89458f0c3e4eec46aa63a556f55be50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d511e355e5c1845e45c3c7a8b3414a1fd53aae08b88650dc11975fd2530e800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf3390ed404348a39aa72a6f51527ae64a3ec25f8b4313dc5b3fd42cf6218b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9819c04ed9a0d0f2dc81a6af2e6a77009a3e04574e7f3eb606757bde2bb0940b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0430e88b0828fd331d16c5259531f477c743de1fa539d5ccc0969dd43408f41e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f8e04c9a18d0f6a70e3d46d50feaa29aab1c0c58d841bb4964b80d1e5b9fff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e199d4c9c7e116f28799c843fc9e335915066167926ee228cabbc9a5d9853109(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8dbcf32dd5831b6658cf0d03a28c9350cec985459669c0c08e019b4432c19f(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec245061d8b0f8eef8cc7af8910fd7107adc888c0bc5e780ee71991d5144c014(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba110b54faaa52bf44dd958afb8e760714820884890dc0dfb5bc9c8ac834f00(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60205814418e2164e48417b15535055caaf3e8513f0ffe84771c4f303e36e34f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a3ebf32876927d77a4334d06198762e2d818e3352c18ac94c860a32eed93d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62cd1c5278bbe3b1b7059f9b5dfae190d1206e74f85efd37f3f43ede30f0a130(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__372a7d24901bf2bb56c3e3d7955009ae395447d25a30ff2e2f8effddf587108b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d9fb3158bb3beb14743898f06f74660be4db137af64d6d175064281e9ca9b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74272c602051d25171b0cb55b01a8e492b72c92f3cd45ce38db1d21d2e6b8904(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4c9c5f0870703874c3fc62d3d2b05d55d5ac408fb02dcbe4224ee499ed8d89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3686e9b0a03ffb594d9683057f920b0bdd189f0af202ea12d64316128903b3b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb66edd22c1ee37749ebccc3c7594d9f50546cf2513f17311fc750f513f3cc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63a94f54fe66d77de5075486c217ce0b4e936dba8172c7a434498d9e8a1523f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eae71fc5c98f8fd23562beb597fabd80b362e1bb740aa3f6824f346a442f97c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08418c490745ef4dd92c17b87c17e35a4440142bc38992730bfb90d3b1de97fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c2ddb05eabae9de3a5ead98e90832a935ccb4578c09976cc53cf7796ea9f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2786b96f42553165a96ba90496792defa7fb45e5a5c59b25434c2876692679b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed18b9f1de01542d840a35e7de37016f1245b77b295630e9d627832f6673c77(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f013cf94608b0e91d82fe50f452ac2761d8a2baa99fd950ea860c6799aec06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12bedefd5fb9b30d0df2b27ed77884b5300300ccdf1e27a518f6ceaef16eef86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258a281185e383dc09fef61d2a980427f4d5175d08328aef5c42a98d7df65b3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9070e530664b8c21966e824f40087081428ddb8b382fa39524eb2245ddd14d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__795f13ab28bd6be934d3c92589e66ab58b9e4c0d535ab2a55cd126aa41b32926(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67339a40dc966f4dbd109f0f823dd980fd474c8939dd78beac7220076a306aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2a92fa161b707625bc8f80d758cd6e96d4c599d48bfe99511fb4f3f3cf693e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55194fd5940f3b7b172c9dd9e0874614a7e6edcf66a16886803bf3301e19acc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f11447b2c2c3805919f8d83d243db5fdb6824b5ca8efb8b86ab4c09c9ecfe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57961f925b5223b66f93a88311f195a0d30084d53135601b379eda2c4248793d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f585cd1527a702143c69404f2c52adde791d1d97b1197fa6599ba6d12addca2e(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786fffca32cd6a5e4c3a45c1d68637d3e3db7ce29fec4c996e9df8a7805b126a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cbc8ab2db6fa45bcdce5c25ce9b385e69194caf0ccf2ff70dbb945f871a67b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e784cb62b6313ceae1e4231e2e78c10a78fe5c0177b3b62d62c6e2c45ae19f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769bf6cd4709484a42945fdd5637c8f4a03d1941cceb63d2f921918561bc3d3a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2239a1723bbe009edae1452d8ec10ccd06896239b5f71fe775086772d709a8b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f28603a68c36292658e81071462df430dfa18f7e481c00951127d498fcba9e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca233fc5344fe8f17d8d0b145e4ff15185df2a56e7b8c87ed690d281654e57f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1232963c687d75ae7fd94e59ccb1909cab7fbbd2da607524a94735c84391e666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8175ce5520dc5f49f0eb70f56f35ee04de0efdb20315bbd777f953ca01c76ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d91dd8f3449980e7075881d35bb1a9ec594d12f6e475ba30e8676c73cdd948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c10d33221c83cd6257e9b5d73ac30109cd801b6e760ea0ba0a294e2d6a080f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9fd32e0d827bbcf98b5449f75e804bdd9df78c393491b7c46ad07595be079b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7352e0704212ddc6990fd995230265bf36c9d2d1c19056456118467f0bc4c431(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ded284f24f8836413310df9b9f07da65c50c19233b9640f905839633524b856(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef88cf2c17100a83a639c611d8ba1be1b97396918ee5558a64ffdb855ca2e0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e88120ca65214ce625e27b459d0078444e5be790100d32e6fd9adbfcf20c938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55dec73821ee36b9d514e369b284f68279d43169363824e3ea344cc24bfefb4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0e288742d6eb79869e343f7149585da0fa620456fd0e5528d5617342d769cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8118a3d0f30e7984b04746962c5bd676766232a8b45a61bd3a2469defd0c277(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93523e8dea30e2431bbf74a8afd87e9c52a593f235861c3c49acf061157688aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f69efd129074b99ff4ee0b314cbd73415d96e6b25044746d2a79b2ed6c03436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a779fe174cbc45da008457e39aafd7164805f8da694739822e72ecdaab7e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bb65e7977676ddbc1d5c0db478cbe29190f523f0f67b187b080cb7841440e52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea9ac32c8b78ebf31eef4f96a0c37ed5367b41c672b3363e0dc6bd20bca4c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3010d7dca7f0500abd28550f3006781f767d4328a9b8ce10317da84145af1b82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9202d595f90470b4230c794d3d0380cb21e09c4b2c348813b9a2bed950344f2(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86cf5bbad55a5cc575caf9a66119bb93e8c01ddaea2acc9ea9056b42535ea823(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5b8f3ffb575c8eed7e40b351ee18fbbd0791ec8c8ead8a8ebf3dfdf8f197ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c68b51381b27865bd05e7d29a7946c318282b2c1180ff0a18c68cc1f19f1756(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1549f14f2a3247d3198e02715f07b6a5356dbe3e710b2404b1c4d9263775389d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd45196fab56f5838d48cc3dfd65799097cef3b3c39ed40e7940c9dc94c15a35(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706b2ba2556634ea9cdd82db4448975c9436aa119e852bbb896d797c437b18f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d592b9f7ca19fe6d39230f051c567bfb8f6db8087e098205af93d2d1e220c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea945d0e015f25af40c5eb8cf079481c1920cf01c125ec26d1b50ab73fa89d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6150a38c8b5bbaa20c6821794be615713ac021f18a84cee6dcb548378eb371e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77689bc64212e813bb5a4fe595b9d64b597bc30ee7812e4b8b31b3d43f9da6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208069e685b9528f89c632695a94d729b8563e0bd350f1186ebce78255742a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2f2d114e345d25d21719be074ae8b1622a291073c328281ab21b85f407ffef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ed5a20ffd5d42dfdf8a334364c031ba5ca17158ac8e336e6e98fa2afc330a9(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139f588a594b78899c3bfe3d73d9b48510f94d0d39af4dca0c301dfca7cd64bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8711649401a5061b7de7b9154754d78313ef5d807d458e5a3bacc088a00e0f0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1294372362421a1f06f5cb0a6a3d71f9f03d7f625709f37c9c77fcc3680d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96c0a2dc58ea57233e185fc82a47b37e87197d7738f8d2484062fd4564e1ec33(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ad44a9c6b09e261a9500bc40cf198ef10a2ae1abd295c72281d166835ef2d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a74982aabb3b70ff93426edfe41a1d1be4398f8584d4228d751ef5fcd9dad0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b2c8b71b95ac4c25840cac25516509a5b9f85b6e11d4318ed800746bf94aa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae784a8e33df9d08cb3b2a206ad2021d36de20923233b15cd5cf6d7e7e173125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229c42db779a9d4bc1a2d3b7c610e357a61d31ad2b0f8d101614cc2d2cd280bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafbfc1cf136867c31db315803a72d04c5099bd246eda230539a32afb45f13b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32795c917b9f1a0278618e6b9b7c912dcff44b297168647e90d02566ada8ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19023119a459b351a90b36b85914c1e2ccf5393461a8e5bffc64bc5042390a56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5bfc2479a2d2dabbbe9277b006e50e1af1f4af54f16751bdf67cfd785dd539(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa1dd5926fc199c7c4f9de6d7b07a3986e07fb275837041de9b64e1159bff1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9610166f983ff216bcc96091e5d6169c042a5f7f4a284ad2356235f528c3905(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ef7a70c67c2de45f975831ad58be1292d72d5b9cfd12e3fd1e74b442a10994(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496dd66396e6ce69815a11bb2496be0ffa2697698b83a5134a6c230a08c0db9b(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d3931579eaded6c358b50f9cd6677d56e9fdd0308e904e65b8ec5770fe2966(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0843ed6085a5d7fefbb2b6d29ffd9e1c09e393794b48e38f5860bc227d7076(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaad172f572593ce43dd6437da6300aedeeb758146cb91ef2665d3bf086cd800(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8521fa1271f5d32a26305cf5718a241d75ba960c29bcfe9ae3b031647d55fbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ca54e0b9e925319dad5a5246969b65b0c9920d7036d7360310f5cb60612e55(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a0604af6818c253d8e97b1634ffcee088330dc352edeb249d717f12b226da7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45f3f933249f8c7c0bf854598d09482d0e4cbb2f8e2d859e960ab59841cf7bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__863429b966dacf4adbd889290bd4ddd3a4ef7afd84f5fe8df2470b25549f407e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32ff915eaf140213332fbd52c44e2d1bf3605a6b1dfed91441fadda54f4ce63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae251dc7fb4feb32fe3211443c7972d4c1d62eb44d2fb2fc7536d5a9dccf6367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08edc488eebce647e9b7cb98ee43e5da55b9954d2cd88131d327755faba20277(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4627fd664b7cbb0e97c4f57e8a4de6b85338c4610a7ffbf8c47797f1cac5a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6407daa317514db47737978d27c49fe0fcae20f014b6589c80f8504960e065ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e532a4b36594d35022e54fedae6549f22e092de596d3f03478c11d63e97b480a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287040c06b41f73afb28692f5a73ae98c3a2d95bb03c7c1e0fd259573fb01377(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e160f3045f4ceea05fa82479fc86f4c88c7cf3718f0cd078f4db11872360336c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37632d9e9417f6f826aaf9e0b2e0de923b051748dba8c5fae9624620d03b5795(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df31be1a1006ee134318b7375ac9210ecad0c113acb906c8243c167d13bd19a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d622cff2be4170a056c357d82074985dd883d9e37c6744540fe16c66491f43c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e7ed2f8b36b460f6bbee71a4d916bbc4949c64d03ae50af8105bd9fc4d6e27(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b80eaeb6885919865809ebafd79c857b997d90b28273c4ba49b4a18bbf5036(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe929c8f2f5956784b16474a7ea5a24fd2b2b90995f7579ff7224ef94123660(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f0c552b862821901f72ac829e6c833d225cc1827a6f91220dddd0a40eee97b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db83f9ca9bc21293720def1cebd520d23881d9a9b12b9d03434a6e32489f1f6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426ced8f59ef5fd7315fed49a98e314d8db2aba102b27c5a6850c1e2fb4f968d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd92cffd5cd8f18499cf574023d4062ac267bb10c4a9b6be164795a44d2b5bf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c685b8a2e93a46e7d829c8c9ff5b01a5c7d3658bcba1ca9a41882eb2824a0c00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa31c5f4abee7c3dee0aee5ea4ece9a1d273a44da7eb359da998650ba6d141c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e90260a89024f9b847877d4c05ca95ccc4fc3e2ebbadc877421e53574cb71a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc810de0365358ee398fedd3158c73f76564b02c731d9fb1bf95204e3c992b3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb17a5f15f22709eb97d11af09bf632d18a2629c2b116cca350cfead1165805(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3d809d4623c287a6fa9ad1a9d6ed7233eee22358ee699c957eb6bee4528a01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c62e2f3b7a55c104077683297dad4cb0e94b1e9f03d8f72589204de562bd2de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a14aa2690aa5ea6d3c00a054965d9cfae2c9c9253ad8056327b38a38cd4130f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7bbf3163aeb3d20a9a1ebd68fc16af17a1afff1c6d58cf6c8a4b250e49ba8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150723d42ecebb3a4655294f408284934d58e441dae3ba78a811bbf78838ba79(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de01a1c028a40891a7ba356818515f2d0582f4b0df0199ce2bd4c09ff37adb6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7915c81c5a4270690745462e1c072aea076cd4c7efe315b8871ce919471c19f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351b70ea4404f9a3307fe03856eafb0f50a9c00a9fb9574d51854b6347f45a37(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee7954e55cdc6fa6dd6b7ee8c3235621393565845e1d8c3186410f383286fae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8c4d274d1e26be044c6c6aca277b265f57e6af67c975a1bb1691b0c6211f47(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bceda44ca74cd94290de9786654359c55ff43f0134adb3c6faad0eca9944883(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e63ef93576887ddf5b07657a094de87563b65fbac7f47a1faea003b6f4f502(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ab423f6aaace1d96143068dec0f21934e3e0e4827d92f2911d57656ee3552a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb95720abe56c9d828d377683649693f36a1de3407813cf2e2e4db1b72b5811(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ca14888f0999056b710abaa41abc456c4836a94b17121ffe991a29b50b2b89(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ddcca0cc5efa1f39bbfe497f8de720a8601cd153546ae786bbc2322c184c118(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb4cb1417ff37c7c84eaf12c5106abd2e05362d134e6b71a70f16114cbff949(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f2d53d84e503251e2be43640792790e456fc21d349bb43e8d24bc891783b95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669b36eb7b65425090d3969f15e812323989246ea9625caea5c54499608e5564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e627531afe878a527fc6d0bc954a92ddb7e34e6b91c74755e90feb4033c74564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bae7d518e86ad7267405ce38158db715493d5f141d45fa851fc225c6dce68e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8ccfef7ceec781c7980762bb6f39075da20f0fb559241e858cb2d092d64137(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd2448be43450b03c92b97e960d90d6c6041c0d2b770cde9a1909757df446a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12f5c10b878bfc03f2d4b33a322788be7eeaed782f6288831bf8e4d8e8cd4bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d598d6759226208fc848e2d86fcd7e9a77e41d170e99c780fe89d5ff57bfed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2864675835cd3a49371e2b2224414b9cd4e92533666b03c72b2bcc0dc890ba4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d615dabaf51ae60d9d5f73827dad5d1c9e4c10e4b80988a6a4a535073838f27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c6e6247cbae05f38424de90f1c5ca02439dd5ea93e4e7106142fc60914bb4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037caa161aa985c1bc643e9ba554b562f85a3eb8d7a12f1189bbd3c7ba6c340e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8efe9cd2964d5df8d3c94e430a398af259700c69ad7828a89c6e094c63e35a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31950d8b1ccac43654627360aba0442f95c5753b7ce2ab02df8517f22fdb8ea4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6016b3a46e5b6c53c1f3022bbf0e114d9b889cf052dbf4248848c3004738f1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86c376a4f80c98bd821ecc84cdbbc0b30b4eba3d423ec67b1051d71322fb912(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745c53218a73851e6f8c5bb90753f7e846a6969e18b9bd325d1a81e854016dcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f94d85340af75542ef9c4395384d43ededd9f9a22a94ae0d959e0ed0751ba63(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c571b7ae9e11ca5ec1ad88868df843300a90d2a4d6fdfeb200aa11d446a4328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf739d9c30cd6934d218b477e8941ac755fd6b12f66c1a03fb4e5b249ae0b846(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae732a9d25c29c309ebb29b4f51382ab4f8f4e62bb5d995f92436fbef34892bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473db764d9458a9ee99b5fd7454067a6611376e0305820d0443a46aab4e1620d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12783130ee8dca84a437e40622b6146426692bda97b180c905161caef2a3a000(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36f58491d8e1ca7853343cb1a91800696cdacf96f851f196daa5ddf575efe41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b53aaa16d2c322078737d0062d7ac0e160adfd1047ddfa72f21e3e60bd63b19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d7a85598412d4bb548990001db06029d2118f88c88ac2c165f2e806a963115(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70938e910e5f5fbc2a2d058d7287e74f1d99b5cb3bbe9e5961cba4107c8b929f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08cccd3c452781074fe12ee8ab8b798383ea1ff9bb0f3885ab79715572536a4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ac10a6ebadbc972acece3d58236ca245e18f0b84490cb69af0ceae44b9fd46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d57180d469d346e87bbe6ba53afb4b5e0a391c649847246cdff6588e571df84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ecd46b434cceaf45d7ae9c233fadc126486e2beb85e5ff3be54e54abf3db77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5195717602223d1a774285849bae4437234fb2dce6db5d256a3a9bf15c6d11(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee2708cc2f53a0bf7c71b88ae5a1aea9ed94383158afb29bbf7d3df59974a0e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e41c31e513e8f72c362bafc353de500ccccbaba1f7bd466c90a1dac6b157b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3808105c92720fdd695c2cb06c66b04084ded71b781da8b77a1ee6f1a1f80fcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaef68143bfa4f239094e4d0b87cc5a6e54c465b2ae9885c8263f9de6b5fe61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05dac6b5bdcd7a8a0d18bb26411b3320011065bcd23548d6033f188721079eb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e665167b6f9e0cc3af59b8da6e91aca18e711c0f78d935c24a48f03a3f8bbf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711a73c7e3f3c45a1e45cfc2b0d3ac22f6e888cd9468bafbac83c8c5dba955c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792a091dab79dccf3b2845a44c057d180809a165d53260316ad55e630b67e1d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1321f2aea4499e03edb9198f8f1101b1864053008993aeb6e8821b2148d5b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c691adfe294a4247da3b48e48db7e16f08a142df6d9eb08b6cd9fc3e2bb61b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2432039101009040bf50a1179b7177dab55a8d8b8d53da3fc205d89ab39c2bf(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d16c24e0785d9a2bff0157b5b84bb9fe4d3a32bf853a8ea6837277f48d4d0dbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304fea66b976d2cc2192c9e6a43975e96240edd44ba5dc2bebf26f9e98c3b46c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c9240f01944fde66cf6cb155e1c38e7043c074c04a3cb38dcb93c23b3db431f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6aa17ec26f59b253774fe0bd1dab53c17568dde588bc53d56811f26ecda4db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f920d951c6791f6e2ff65d29086e911f15c2f6992785c9ad016d8c9dae6ca5b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ec8475acc67fa6f055c0aa8518bc6cdb409d1fedc2d0d7e52b83c9ba9d17d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be07bda1331737b993d1799c54623d16a317f0cbc35a97f6c904c13feed4b5c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8fe8e3c581c8811273a8f771638b4b3c550bd476c658ae9dfcfc6c6a502d75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505eac300993cb30e8c52390bb71dcd9b620df0a81ee49711317ddcf2a701ae2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17283254310e7c34717387dca23d74550cc841239a087fa1cb438f72c6889bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03caea8083a30efe2a5164c3d45570d11cc098be51679b41165f55a65c3c592f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8abded11d46dc69c123b3c077f2d54df3dc466e3fb8547dc5d6ff5872b45aef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb45dc862253c72ec93910882c72d7b11ca2ff697dedd645bef270db5b1f623b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d686f5e17dd2a671155e1710963540eacdbf4fa9df45fb2063338aca1e2404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ddd610cd47039547975eb661393c0373ac4516b3d048d9f42a7d4a9ce95e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cbb75e9709a3aed5b1c6a716e9b2616eacf43f467659071c98a4d09c83d04e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983deb9bb568f47ccbbbeb2a9ec313a1a08690026466fac01e33e565cff21dfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d4f294dc6a117945c375ecadc3836a45969833102e78ed3f9fa89f5d5fa309(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c046cdc92d58bc1b20d6d27ed19418e8ffc2c10803d810d1c71eb210ada271df(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9877490496df295208a325cf4bbdc28c3fa02e3102ac54dcbe83ec616346390(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5f379811f8e86a49e155907c1d2ffe594151ca231c4e08a459b0368b0316f3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5e8436cbaa2439b4e84c58e2c51a6add69541f6f758fb267f67fbb1a7b200b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc236c7a542d8fb89bc21d77c2878f6cdd7be04b3c1a6d624e6fa420fd796606(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbfa75b419e5392da5e8c306c878e3a57c713ca162fbe20409762c77dbbb0b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813f3e06f2ce62315a74973d3e499ed3e223669f58dab148188b57ab4f535a03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd6b8e0c0267eb2612f85d72be741552480aafdea88b2412bc48b9536385f13a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c6da9575f90327b907192deb92c264993be3ff9f69c6bc9911754faef5e900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4acbb5a2d74cbbfc5f0654a907ab78fbd1158b5a3d948df874a67124392527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57eb2b7d9ece4358f6d2a19c1610a0140964947decce21fb4b52a8fd4d592695(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e63243a32e5d6cb7bb53e6e21bf5811b00283ade97b9c206149392fc54e07c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca29dd4ebe29179ec50be1680086f092a4b511b5d395cee6c23097dc93d247d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a7cd907aafaedf6782bc53aea0257f1a074c14db8eaf3100439bd2aab8190f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65598408fd61813a3dd6197b053560330e6234b894d3ff58b42a9577a99c04a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24628010987e090902b85216df628774fe2fae3ca32da1111aa156bc338f0f09(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b499bf725c52c115da61a4bc9e8403062079b5b52b570435269ad2793cf0845(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__013139a65e775227c71ebb93a2b980b5d6ce56ec773aaf30c46b52f0956f2fe2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7fb571ffe3e796bcc547ea833fc2ed8b301c9438f4f98c204c6741a0ca001c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26ac82e90f12022167deaaa9115095122cfbf681aa76576413205d6f351842c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4168d279887b9ad94fa0daba8db7171b07c543bddee549f4e23ded5d49c93de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e9237914134a12950928c627bda46cbfe873acf42388059b8c1261c2a85b4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c48e05726cf83e84ee7f56ff48dcf58d08c1e70a94606e48201d034b18f876c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c08135af8934f27be78a1e64cac19a34c36fe91b506450b69a47fa2c359e610(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb33a0918f48d9963a7a82fc2621937f53859ffd79df4b6266b20cf061cba0be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8e62f75abff926f1f66d5cd681c6157a327a47067d2fdb36e4f56ac948a07a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d08f06e6e19031b4f68bcb290b1613a4ae244164bf8ae5ca99d4e75ebfaa642(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7253cf4dd5ff3bb6788f902d4edb25b18c8feaca0ce0b817d794cab254107adf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115449508e4be01e71c6e6b140951ecc276e0595d24d742dda775239b5c1d4a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9e48cd0e152a433ca3fa40fe939b7b62b926419015c7835454a99da695f895(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66ef16feaaad087d35aad4e1c1c4de182b965ca36b9ed78762785f805c02bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a42d5237070c12179db7f97d2a2e21dbc37bfdceca0a5f78e620110a35408b0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f3e4d43a53a61da0875f32f7315f5ce7a74cd4d7c867c03cd51d4133c36baf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8df5b5ea723398bcf67c65960492e294e1c4f6f08fec9e1442a27066a508026(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__369f0615c4537a95b6bc8cb983ec153ffb6838c4d00673fe991116505ae766ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e93fb64cc5ba50561447a280c4500cf2ee42a7d1a71bc1ca07c192011b10cced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00c5530c1c4df675f665171f6c16e49c81003b272e20d59317b6427516ecf54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885c6d45915c68eb61dde3cc5c44361e91088d7da7d9822e8d8e17ac43c2f9b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3efb5ba00bfd94a7baaaf8b18ead293def3fe459af080655ebf71bb44cc9c577(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa74df2e3bdb17bc84eee67c5e6a1e68d927f22556c2c4ff72c5c3ae1171a9de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f82c6c73b30631cb19711df6e3f17a73454269e1f7b347b822422e8d08b8359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe9dd5770b985d2ab068f9c6b4cb74ecc58fda2c6bd133bb7cfc6cd56e905b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c2a56a195002ae919c8dca18d9769defee48cf4c8dc75762f1248530a8d6695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba4620158c304627f22ebc7fc4f00eabfdd8670dc67c5fd5a1fdf88f43ee2e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1906ab2d1de8a5518b8249343b92013ce795496accb3568db4f4c512a88e4727(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd382cb39b60d3751caa7ad6695b80b40b6b3d0ff4a68b94e7a0d6f9e38e003f(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8b7ca9577a6723a9d53c380516ed42a5a6d72bea16737682dda835244c64d5(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b2344823762be67f5a545b51dc091b525f0b8331314086c34077366d654fcd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64996a164e98d81123f022530d01f9ce2111e4d4b4e9572a9eff53f7e3a5729d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d9a406fe1d77f43640121f7afb6776c46ec6767d964b338770eecf8c8b192f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b135bb7b52decdbecfbafc3de94df72170bbb0bd16eb71e3aacd5a4c0dccc5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa4500a5c61bf27f812ba26b9cbcdb621382fb758fe06784a4ebeac37724694(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b4aaa06501d12e70def71c3cf08783f4e3c28d0b44de7a4ede8b46543cc1d7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c7a9f014bba5a3318998e657059aee87d197a2de92784006950bfc3816bb73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec052c620798f1d267e3ca0aa32d2bbd44c9a25336da12303ff8fc8f8a1c972(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0723ac71f263be1578ca7861dd7a2826ab39293b4280b4708c284781c59ff31d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b52b72c4d0cccd8a15838512864dca25fc81e9de2c1c918a48cf18353145793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11bb32b2b23ecd68e8e4923733c2650a0f20f03a76e84316e0143cef51c8024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2550e212b3081869003f743055e9ffc650a0eee21e894c1dcf0a8ba34716a334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573014568544495a1ec4ee79b1d84c9c45c5483d3077701a02d8fdaeb3900827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44398dd5ebf8f60555b13e4fea5b610866bc0a71e5ada1d76ba915f0a0f9194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429b98c0afb3c03730abb6c10e9f75296e11f197dd418372d4a477f4e147520b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c17e5fa03da9c8d3e888e1a98199291b4e8a1508d6ccb762afeb447865977a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c4f0a57da9253688463e2c77734e6a443cc7c55566b35f334286441e772bbc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be66f7075152a4fc1b91329a11a354a9adb85a7bfdb018f364816c6024208aa4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d678eccf3694577f54f7837e3960c05d58a4d06a28ca1c19132b71d9e0ab47eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364768f45b586bc432d7c393028d0362eed73f03f2b879228213a2b5b0325034(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b040145a5bf9f113411d3581d5e708bbfb50765c54135bff4a8ceaded3c3db5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d721d18396462795d3a9c66dd1cd41b1507147d17df648ca34180a999b7ef25b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1c01c2441fdd8a3b936e8da3435d1ed3f226aad60fd32c478faa02bcd12e6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac4ad9debd78eb474c5319716de5d669f704a030780bba93a588b49fdd20d4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a292d250f6c90b11eb1f1285c9b32ff6549e63c06f4f0328114b10ec5c23bb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831c4b08d6e7d6006afdee75ecb1e7f3a54d7cf45c931af39cff4e3ac297467f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bcfb2c61daf93bc5826e917eacac8e06b867a5a235484ed4a3aa4709ee4fbbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7579e6a167eb7c30f6d7579c30111e822b3f89bf4597c79bb48f46f254fe30b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049d37f6bc10cb8caf9cdfbf30f945264708bc8875bf8a4499ca19d9e14aedfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1694359143159cbd5b4530c952add256452394c9780724f2d4929e8182571c7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea02669b54b8d64198796c03521bfa4424b3d41d1b1de9b9a829b2e82db341b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3bf67d2285d6f7ba9c0fda6335b8fb7c76d8b9cfeae8db8f0984c5370ace1a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ace6a35980e66a0acc4bdb718e91942c585d5d829f6cd4f5332058f773a4d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91874ea4c6532ee055248627c8a86f661bd598ea7bd55b9bcdd8f094e952531(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__858f60e4743748ae789fa789f704ccb5afeded05bafeaf753270168340e0a78a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2552101bc46d2f6fe27f5bdce5fa7335876349bfa0e7cd38e9e16b4979b27ef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbccc1a12dd95e3d9a1548acbd43e9635d8147b5aedb1900644eef1aeea8ad7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51579f4438b00ed5ce1327f28fe427c21aa56a6511dad7f53ff6e6275cd2bc8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df45f91fa3d1bcbef2979a2de0e65ebb183c0d80c17b8114478841f687217b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1dbd407b22d8b1208770231ab5026827b82489091b8cce8d4fa2f8f56d41ba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab7a1e4ecee5a26ca20a7193ab0f60a7f8d87a8f58ac3b7526ee624c0745f03(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8df7cab5031d23c842cee458ec6e21b41962d72b13bfa5a02a639733008eeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6442c4969949202d576c9a3af69c39e8d1ae4c42b32be1077eaf2d9b3fc831d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1237617acbd74d1e8d08743c5d73ac25e9d4deef55307b6424d8cd1c709a683f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b30f24c7c72110e41da5a1acf905ce97dcb2f514e2dc90656c64469a321396(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efc7aef2fc75151fbc7a32114e70bbeebc4246d31950403ca6feac19e65bd8e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36aebfe5e97bad9d132b4388e4ed6fc0e94b367bac082ae5bed48f5535e9f03e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1582845c2d02925fe20b8c27f09f52a35e776f25b090f2975882fb16861f9b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcef1acd36f4987b1cd0bf909dd1f9dde56d4ecab7bca39bc10042c4c909482e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53504cdc0f2a7b6b2d24ffadb94390e926989322826d42133bbbc5f39a5ff945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9f3d2ea73c22551d10699c63e5ea31f51d14163af0f6d742bed52a9cb369be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a7b2fefc154e891880a616a4c3c096b80da63109c89778954da7dbd99c9bf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e7316a7e3cbd891e10f014992d9d7717b9ee9aabac6316d96c21b9b8803b9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a547dfe778df24336ce154d706e5b143804507af8ec519b66aac47e78a747a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f53f4902c00df5f56aa0fa57f47311a0b4c88b272590fd2c2ece067d613436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e47acf816bdbbb457afd348b8695b1bb0d579443b7d487c277da8ca3c33697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18c4ed2676cc9bdd7a7ffcebf139978dca145febf633437301004133d15f53a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a1c2897a1af70eb3c737e24d73429e6944d0d0bec3c943ba3b610e3e85fd5ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112c04a9a015c888b60d30d5dbdcb04a1a349251ba7c24f3c34d459024aca965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51cad2bb7e7d7c75e100de71cb64dfe4f3ad28463fc299073b921090d723d54b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476561e2e99965eae637d96f2e70a12853584c5234e31fba6b4321d9a210cfdf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2f2ddad32f28e9602628b7a28d71034ff4a53bcaaa3e4c4dc146dcfaa0c699(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3750b8d5b7e79b735f64f461f827ba098f16f9d538eba25f2d0dbb76ccd5a569(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f8d3c086bce697d94763765415d9537429c64e9477e5289c6bf956ee27896f(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f86b0bc00a1a219d15a129f84f131b26c8fafc6c2a03a6e807587010eb3eb42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3d274e1a2000e2a5bbc2fb22fc250733d590225cd139a0bf6004b746131eb9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba24e080162678783bccd15dc51f26946e10aa223c6e743b87b07a67019d096b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7c6fc930a27ac40db41b522915cf9f717b524ae107f5834cc6a93cf7a2819b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f672fde717ec8e974d5682eac1b2c926fe9f53bbe1434952a8e786a92d43b457(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8a127706b9a084f505b52e01ae3001397d3866c5f3c56dfa1a411fbe43cb19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f9ac49147120833ef6b4e246a84b95f9254f05db8b3f1e83f2f6986ea49d6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd2614f18dd2726e744737bcf1ea1e3f4281e852d6bfae8b23526a673f9f7bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd8d4d6498ffe74d1ba0bb1ed1b74d20cc22f5908506600a9c9a43f804748dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd8121ef03b9742eb109a5ea7dc077a5392d509f8b35a215495a7b3ad9477fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4664c4cf6cc3dcaf81f32c3ba14641b2dd0e8ebbff47919a576e9f75bd286916(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b85080e290aff60b038200c31600aa41c88b97c368f01b66818c00056adaaa2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ab37ee08d87cb4b368c31c22b380eeec9f03966fc6d39f2aa2670055600776(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc865d631ec2e93fdee27013366daa6549c85f8cfdfac83e7a196b56b831d8eb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749d87f8aa4ba38931009563d03b68f34fb7cd7ddd1b35e7b4e19769fc4364a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69422b2d9038e0beb152f9dfc9485524599bc5625ce421ebc64efff81fdd05c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9bb7870c764bce5646e0f0e61c0913a07d353436bb799d332339c56efc70a35(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e480e2e5938d343ad37399f5829455b8676aa1a495a45cc8666a36d4667787e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c1a7b54abac46988e04020022c44585526b3b559bcf47b874e56d133082112(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649be815e3e7140e9be20c613f5bc68bcddec6e47738792d262df83cb17b70b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb6153cacbcaa3078b2e5c2f77b979609dac786b0249b7ff231b4c2fa55128c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df8b7cfceac5d450fb4efab077a8c07e01008c2a550dbb31dec8b4a5caa2c5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b569c52b9311b6b00f990cf07dd0728a2d0e2d08a68e1a6690512c5969bdaf6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19786d85534a702a6628ae3f0349a29bddeeffdc4f3e55ea9185b48f5317584(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618b7dc10d544432f8b0586d18be784e8b962bbd43ebaefeb7d0470f23bda9ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc14806dcf0916a2b8b4dfb494581a3060933bb38af0349de83e7bb53c645543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2275c71e149de5ec68eeaea3d7f96f99fb2703a4784170fd00ff3e5f0faf23c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1865b0d21b2b31d68f8c2e293b9d76ec227fa4ac7ab4ad8222d5299847a0602f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e59b1ed189618b50376c097ee01f928f9e3c793e7c5ee8b2882fa5fece12bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2399464fd813cd33f9283fb1397f01d54425fedf4bbb1ce6a13c4667325de44d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5996ef424079219847d21126d935db48703917de8f539f2aa28c6ae1a34ab9ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee550a78060aad39f2a32efb54aeacb905e2cb659e09349c1a07e441df1a36a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fca78c4e6644942404e3cd638565e27a437e952ae9ed6d3841898829d3f8d2c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edae56321cdc2b95c7d53d494b97b089763f31d807a6bf116169d546444f09a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34f2a5aec212c43a9eb2d59b5d9cef25ff1b33814e340b1fc6b42b75d7c5dac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414ac70e92f30fb7c9a2270d397457cef322c07e6f974a41936ad1ca117681b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__405ddb2098f5008a90de749adee0c077a251d215d9ed9b66896a0a23abc570e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba139c3020553805c309b66a031acc87116ed1de66bc82e6a0f2f8221dd9c7f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ca0f8726a0b45c992cf279c11c192be437a38eac0b66470c5baa568862d488(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0896598a706ffa1c369ebddda66b98f213fa58d44d6115e24aad1dcb483f2afd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b34606d595cc9fb72c16511a03da27a9c9735c65e86febd2f898d50eb13cf10(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5baf5700412d0817684b95575441994826b28f004e1eb805c6f5b949704b11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6b01ed64b135eef8d4e131e30ef9289064af14d5a7f2ea2342780dcb007852(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499df652395d8741450bd92eb932325e9e8d138fe3a4fcd305c1d528080edd11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056f799aac82bcfb95a848d8717d21ce08028aa88d93ffb7a24d0a37aa298a05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7810b9fa7c92e7f9f368de40322beeb3e732cadb49b1f5b77e1db2ef83fabd1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ebe6dfdbe2f71e1c1dee32294ada0397bfa7969eab462fdaad906d594a2f093(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e86681cfffaf89266f0bb60ea9db3929363e20342832566270f9b869e385856(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc316bbec3e0669ea758122dc7a45b1d491c4460a11c559dc89b8cdcbb00d936(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e71512710a03afc48acfe26f6aa01a1e338d45462ccd8f06c3e8a91a86b5d5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49199cd308b05fc70ff05a88af90ed4808b930d7ec0fb4341a8e19a35d91c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc93b75c6c7b0f9177b1f15a8d047b1599fe1febb82722c20082b00b225cca6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8239eeaa82826ad1584bf4b86aec9ce5f0c80a2a7f20bd5d2e7b692e351d242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc726bd2d5b446788f71c43e98765beb621f28e0b439987966b58e56a55f004a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97413b9097e748f8445edc6765799f55fdd94eaa4c7e80766eaad5bd195b2754(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41085125756bc85fe639289c5c6b008546751938b522f84ea090881e73d434f5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b69a0701fde8e3eafa5e90168e196ba3163713247edebd38f643c4e1aa04f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3ffc65a14da70a4a27638ab3ab58594b912a1922ef703d66ab072ffc07dc15(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceddee13b256c1a275607005610800170a40f0ff81bd2d59e17411b3c6c18883(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb1fd071626a8f772bf5849ef982534bcceb6fa120793bb210e0cc5fe1b4e72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9470a3c7682983b0cbc5b97ed6ae5bf3dbbf3532e604ee81f0e4faeace38a05(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d250130f5135a02aec990e205d89f7a24ef9c6fab001590ce6d3884b5c170c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01fd444855be93da0fffcc8dfc982f896e42533e10b16a578a7a6dcd107b22a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d199f0f342eaa9ff528075d6cd1928167afd1433d41c3c43dbfad08a5e216ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7564c410fc9cf5929939eb331483da7beb1bde4dfe7e6f42fa3f4d6845516347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e8022cc584d0a06b467dbd8b27fe255d47ef980880fd44ede15fa2087fdf72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ad5250c2d324ee2bb426a1d5e6296759bf0bde88789ad4a32fb428c056b649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd5b94e7fb3dbb58f06f422473e5507e1ef5130f4cef7df184e136cff982be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb9c985218cf3dabd9e04e7df8c78ec36542b1cc12f6a38563f6c850ce2826c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7cf4afc03903c9f464ec2987a292004657840ee817c78b4c6e205430ed987a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b09bef4f6846ede23ea152d47d522df9972ea6044d1eb65b29b914b13897189(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a7f2848c720eb8e8fd7f27dd5eb4df8198212358206fa3b7e333c16ea7fd67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96c2a093ad26748cffb88f223d6fe3e912c3c259dae75f4c29d96aaafe880f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e37b700d59ebbc8a432a8086302b83529935d05fd6d01481f9d0d5fdd50ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed9210b445b29391db88ddd090b72608b12fd8f9374c3f30840a99258959863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11153a138159a2c650516fbc8e0a0a84666e2a5b0b694620a5a4f56d70cf76c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d760aa9b5a84d74ccea2c803f88ee1960b04ccf45e42bd33ff1db61ee1a2e53f(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547dd9f7a3e0380efa3a8a30d3c9c31647d34ad46058c3ac258547c94f416fff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c55117b14a8954aafeb805525797f0d030ea08ca249968a168fbb48d111547(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b7d3a6d85cea2c01a289536b57880870efc6429d5ba7287e40081645e64d3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127a4c79bcbeb3c220aea682e7a7fb86fc3031a767944fbea21be21a954c104a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170a46693948ad0e80d8b4ddf521f5fea25dcd1b99b01d3cc583a3cc84698935(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3e35f40b081a631ef3f15a21762f798db89dbfd94238315cd23be7397f50d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6e8c881a8532c4cb4413e2ac105667c375195b8706b101f4fe7fdc8792170d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c58aaacc7bda424fc2908ef81955b73563d05e1bf3f6c0595cdc04abdf7bb0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09f39a921a5939b46c4b717daa4879f51cde6a850a601193c1815779721c28b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4064419d9162dbd9df6dff51d87c59061cff5fbc6663bce7c5062f55e4193759(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efccc4dff47b8b0534054ee6995f55dd733a60dc6d81cd3c04214357eb1c056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048c5dc820db99465c1c74ffdaaf36c22673054390277c8ff51fd001a856d62e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8402ec6d5796ab629b0485854ae4479d89986e00e99e28a5c543ccd5f3b03f1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bebb8c817e0eaba983c2b382b12e8476a26a6621c59ac2dcd2dda6613db7ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4449da956dced941484bc1f38638120f0b1192ed8d0c69c9ccf48d5de97b12f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afa89e117d5d33263593e9777d16e91965a2313fe1421371bbc7ba7ac2425fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9077114df3e0d76f7f73531214f7f3294278e5efbba47e4b60bd2e319ec394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__789d566ebf1c8eb0c0002bca42503d22e1f75a6cf1e767af8069836a46e46141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d999475d4e4ea1d696ab1d3664be45c72546caff80615ff716f5b2826253fdc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45814a59af3174844b88852b8e33a761ab6a42cc438c08e23a30ddb94693a353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2040229398d1dadf7d8cec3324edc4d8f8dcd9bc2b16073aa9688ec9b419cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e9601d2ef482ef81ff2be16a61444acfecd778d8f70dc8c0338ddbe1bb2967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c76c1c0e49e079bc04a2a8bc519c31fe0f08a27f17188dfa2c205e14a3dd6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52fde9e2b379a54f965ec45333e07caea800fb0298fbebe93baf3bef2e275080(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f97fe4ec04835b9dc5adef6787736acadf56d75cde71c210cda876d129213a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1af62da03338ae8be202ccb296891ae101dba0c381d43280a46e54cbfcea58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22642f6ee9413cb82708cc7ec4be32de2c1df1ed307110f724af0d6ec738e615(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e667e7be34cf6971c87b30d0ad4b2f7a1ea8318b7d1b90eeab2bace43dd7eb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27686500940562d75c3ecca8f79b63a54f736cf1cb5b02dbe74ab9d00eea8957(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a017806e9276c5ecbdff6851f6ed21db8dc46e5176e98b358f03236570b1f91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b455a84e2d72c573fbd554ec96e4d7c9b38df1cab008324a4530e9284886b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a13c3a3e451e7060302eecddaa10a6e37237a5b253aca26f3a4524510c4905e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__308ec060530debfa68bcd83338553dcb84c5f8f622ccf9df7fa1060f2007b682(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fd1e8d99333083a00938f3f33752898719cbc6404a07c52033a8b862741c42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9b72d2a68a4475a1bb9643502e62e0bd33fcd0a1c77123b269a569d0796ebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb5b83af56e284aea6fd41a8911fe1d75d562ca871b813552daf71bc9d14b5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e197a8b1b4620e19d33dfb2f4d46ea54ab615b69d3eed8672c22ede6704ef77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bce70fe9d1b5fe91a3d5102c1269b7f58f24b0bc9241e134e75e7e9f403e30d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f894196d4d2af2421dab312b0854ca8daa431c705ff3e096c57bd4cbeb70c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff6e763e596dfe02d3fe42dfa052fc7cc41bd0aec7c118772c781369c3f1b4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1045bb939a810d29df0135061436811341b27e39dd90b4ebea0bd8ef278b3e95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774460cafa602e9ac4a684f25662bb57e7f6905b793e767c909da51fe6206bcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea161fda399a9998a4b09fa1ea08b085b375135d94dc03563ed06f288335344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e80d195b6436d8ef8d9a9ce35f0aa583fd92292a19342291cf68b0013729a67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85655436879a292b586df2f5fac7c895ab9d1aa41467fea9d4839a6473c53bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bfc6f6fd5e9b746f34addf1f463d14431aec479ce50d2559efca865f37c1a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7bce65cc2c756bfe1cd7811d08d671df51e28d5fe241577aefb68c5bc42a301(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55fc2cdbd0c2804abb6f7af545efd60f2b675ba87c6dd65940872469f76eb6dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9115b364f4d7d3b281511685306917b096da343f7548cb58c9673a859aa0a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d47fce589cb0a8868881fe8cde556da5b731a0fdfc3f254220572848d3f70e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef5a9a874a066b407dec7340eed180e916e855d3bba17abed309804ba62a6c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354addb70b37d2357fe7df78b2d8c2a16e95127ee38adee984b9623e917d3228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924ad50aa08195a0d55383fc280873d17ba7a9bfa1cbbae71ecd00964ba29c8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac4f0432f5d873c161cd807c2c6cbba301356693bc1062b029f39a92f8438fa(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b67698c27a5f68931440aa1dd24c0cc62451bcaf571798a368f86603ff5e6f(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4589d01ae75a28a2134854131326dceb5a0ac650dbdf482ccc6b3825add566e8(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219dbcf35bf7ebf6208c55a31b8d36f03e96193dcc0f78d0deb65c59aa06db46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cec9db8bc640c02eb214fe83f1721297408bec5a8f481f20ecb5ea53a8e4be3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc3c87c4fcdd250e089401d4e960791d0a83101a5ac90b12c7eaf7149e7dc3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ad26354f7a3279ccaa24a0bae9e7d1914ccc905b8f214a0a316822dd912827(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8915aaca36083027da14dd0cd81c907e751d750b663c3f274a51f90502c4aab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84733d5d9eba72eaf22cc4877bdb526c45589e730725fbb04be3c86302ad5d7e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4454353ae59bb6c284b7c9d0ac1e217e5ef8c9a71367264effa5bc400792d7e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4921faae2de111b59562c6639045ad716165d043cb473126b018111fad5fa953(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0835843426d4273c69ed8f0dd71129fb302667994c94a384943d954abdd3d5ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265fb065aa7cd534dde3f4e56e4a9a3b1e6611316df65c6483eb80c774633b53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31133ba098397ab53860d9fd10cf64c7dc867adfac2f3c652e356531c0d3b21b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261ba5bb94b454fedbf0efdbeac42fd30a41fdf0c3e16e5d3ec81a15f7f68aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__967f2360c3ff5b542f40e486202f267fd4f1a8fc5a51ce7b94f4600af11ab523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2ed4d5bb570417914124d02a9bdff1ce0f22bdc4915c842e1ff1e389379bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27dcaf922c748b77df0e9570596dae72b5bfd2dcf3086a4c8b0135950fc957cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc39ad6ff9c0b936d29e21c75096fd4b9f388573e6d8ff7221ac48e1a203b1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2554bcb3eb260d9fcff57a5acc2676849b557c9fba027d01b45b91a0b63f4fb4(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5ec5341d71051b1dcaaf6e3266da02a7d9e39b4ad532a4826943b8bf980c84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d718f4c8fbd9c7e86724205044458101c5c6dcadec75b4e978ee93cebd4a9dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5958014de5b6b79547f7c8073212cab62c23b29a072344a4965c059dd13ad90c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90ced775776202da78dfad1ccc6fc51dd10e4e0524296c35881dbff9ae03fe2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72273409a8510f09859ad85c00b977d29a320a14402c2c26684fab199cb27a4f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf06c18d164a26f634e485939bcc4cd3f343b54432c8729c0138dfaf4b3b952d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0982fdc33ad55f710cb181b8bfff4e73ce180a50d13b6862aa73fc42355618a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9618672817262fd731d29c7038424c38961e01ff5d874b008983f1bc1bccaa6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50904c721eedc5a6dc06b6894be1575201c8598ddca83f1c5b5a3f283a821fdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478314d31ba066321f5c872a752ec88dcdc71241123ff75af963ee758de3200a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc765dc791dc52743a7ab804fcd43a23d9e34905ee2ad4346f3d072724b25c3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c4fda9bd30ddabebf46310a7a1ae584b716041bcc847bda665405816d5d5fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd27e75b15e49dd8515cd0eba9b68ab3478bb40165edc2102f3edae4aefd8c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c650155bc18d1f865f7876d6df21e9ec6be5d08e1fae5e6a0cb360c746ca4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c8b59c94c1e108bb25f9ef171f3cb08732c5d682757143735305bb6fa6f604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5e602cdc70532f3ccdad1662d6982749ff32405a5ebd45be29870cfba32667(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00fa17d390d504ebc23a65d371adff9b7e3fd7c5fc345fc4b4a72a90ebfccc3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375655be7a5ea9228d4b462b833960d5aa98293e58584c1c10a698ddc4205e2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463b5493e2e21526981ec93eb23b56a5a769485013f672ff5be6b29a75c2558e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb59371f5fc844c4298a0df42ad9c867e8a2c7cdf49e29c14a093872c7827efa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97143f72f242e5b49849bf6692ece421b0d3f5e2dea4a5faae21c512149612e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6514d09705f5313ee9c794da4f785a110ba8ff6e21d78fae7d71f01d8d0e17f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d156fb4facd47f38b2c3260310949b4a5cc7687f09bf6b297568cb19b67048e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__624943d87e640167ce807dce215b87f5d69a2704cd419615271890a168caba1d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d1a01601fb5159ca16fe5ffa979292eea7a1018b333ef488b222c64d21701d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbeeadaf4d29b6b0e3f8a58c86944010a80d166b9aec8ae6591248bcc213ef52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e569226e50cddcfeff90e52fb02b9848af10dd750e2c1a0778b7dd2d18c394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b310ac4f97da0a0b43eaf71543a67668faa21ed8a9621f1946fe5392d07734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5daccbdffc662daae0f859118f3c3716f50c5c0c72df3c0b51c56b4608ca881f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3ef45c1621c509980fd572048c3a6d7f45474e70cc9b52f10faffd5d0d920c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06ef3d087b0617ae381aa908885c599db2aa22bb47ad4d07cfbb701105a476a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7515d32a8b2370c3050285641b53bad1474cb3a665bd0b85151d3f4ea299d600(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13dcf94ae7d16812916e5b5b7b6c6b6d6b524445619fc2d58617aafe7e217a80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30029d8f64286789e3423c60648207e47d5711225e6e88a183896316019eabe8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3738a8223d37858539f869a2749d273856372e78c9455733d2cb38d7481a97ae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35883f89b64a08bf4784aeca82c04a497b04a8716dba1462282f3bb9a0297527(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9deba5dde857fd122d348df3dd9f9734a31006b59d316519e7eaf5db80229cb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454836a4bfa43085d59f518a994c58dc5d026b39b70a518265e4d5ab426942d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce9d5665cbe6505924c3ab7648a441acf3538590a95b6a9c87b5e5063a41777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d749a1396edcd9d984611fb3cbe54159a304566da42e84478150703e68fcd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952e1803cc5b7ab692294d4e2e739f4825555d4695b11ad84fc4dbd91ecd9990(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8ed609015dd78f7019d1d448797a29b25c297944b353daa653cea42076af66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728ad502fb789d5019fae4dc7a81c440269ae46997be459204540c64f0958342(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__206b3324e5723ed2e99133f9be1bd4b45b45e8dd36f09e8fdd9366610323de87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9adcc1b0109b10eb9abfb32c25c1220146ba2e176f997542123c004bbd958cb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dab789d6c98ec15ee2b91ecc909c971d5308246358fd8d8e6c8d8d31826d3e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fded866044add5e46121bf0b0ba91a414c806dbc9dfd58fd26e08a3943122b3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b228ea5eac94b953800b7c374101bc5b6a48b115f08f9329ae227ec31a0ec20a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61fdca3156d5b5d618d1d019437585b6ae0d57a4461b21c43c96b225c28fb6aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c536484bf9804636640e333df1f1297726a2e9ef69c160e581f44c51e7a85173(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd407313b317b9fa28b875ad63d97dfb220f3c3834b2ea274c510f857866fa10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a4a0068945098a28cf950f45a61226fb6c4aa57857fedc9ee2b191e3e39dbc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef317251c85175bf0b30523b031afe7661580390383f28cb8792ecf01efcd54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327e82928173ab34833971aef6b7333bf5d24e1db49ee67b4ce7f44674443c95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6efba7d2097345a6980a598a59e6ee691ccb601db7f44d3ed46891c696e401(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c16e18b66429d7b8ef22857d0bb8bff93307a36327feb4254bcb73df4f588b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95897a5b0b1d4e38aa52aed6d13faa22b878f55299923772a1e720e4b978af53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b6902670a0c6fa7b175565c3e12d2dced5f1915016a67669a5261cd6583f93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b46ad959ca58aee4dfcdbacc42692e3d2c0778c5694e7bf8e86f6bae166afc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e3b00972afa26dd8722063a725c573fee88e66c22e5edf931f70cea76e3c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d305b87c43445592bdcea40f8ba4f46baad12e90c523eb63e06c619ce733ea21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8162a2e539ed6518ff70faad35615d7e6f1fe804ef89bb4e9a0f442bf2c6699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23df8b61732e46c33060ba49a5d02b0673a6e3c1ad2ab0d24a560a3f727883e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc50a648c4b64d9d5eeb69ae1f9a8decb9c65e0bd9982abbbf32b2b4aa9a583(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134fa6f3bbfbe01ada9eb7fa9970a0d27cf2cfc641b550066fcd339cd5953bdc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c367315613e54f44d447c7136fcbbe7ca94dcc00cc9663262c88711a19db349(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74672d115dacc34afc05aef8ae14de26d5778c510b811e5888ee5014b84db45d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8711cb03a8e750c75b43e017e73546d727f896b62e16832a40798ddbf6d0a82(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242501d1a69d75d291b35c82e40bb3152174fd9bb46328e5d9e5f653c7d3d8ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99afbfadffc636a26f793f9b863b78c41f882e857c7ffec571c8f64d158085f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f411c7f85e10933456c6544ad1349dd02b5a346b2e8b1713364e7ef3b846d7c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb1ce8354e56ed0cdac0d08f47e5415e3b34aa551117f067100172877debe38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a92ecd8ec449ce5bd65098764365c53cbe7f87ba17ab24a37a926d6c68fa7f2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c31dae0f58076e39575661aa7d8ebb86e2e8c2a80dbefbe3a910a64243ecd7b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da34c0d734f6dec7658f66b58c5721e6a7c6376944e83cda5c29f1c7aeb391f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152e47a55d33850bbb778bd793bcbe5c225a17e633f368ec7023538d2846e041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1f50e51f646a59d6aeaa757329da9a4bc6ff61e79245c099a3db0d47738969(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1482a8e0867bc0e38f1e3a14a85c85cd3c32dd4d4c5e84d16f5efe78b5ae2d32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03409d6c1d918c081574b971d71bd1a653d8cfe8bbbfae6f968c02fbc5bd7987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c102d16b911e7149a5939e3ae56888bfeb0876909256a009b3bd8bc7396ed4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b985a15d2f1a53c9f6f1c0c2cfca520aa79961139e45d57f658266fb4fe168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80a959909d26690ccb9307d53a3098ad49d72508ac127f52cfa648113494594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9226c1317212c04dca032f7fe979495962c9818a452649bb7eda30ab9b9a17f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3183282273159462095f9495c3a522eaf603c826c75cf535053cb4069d2fedcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__553b8f253f85707ac5d6b896987f5f6e142590f55382ba49ff0b21da2c4b28af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83995c12d27d4c63f6a42da51a0f283b91cb2d11ece7c3cbd2903879565d6bd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e3a109dfb3ef91b331d2fa1bcb6af831ab114ca46d4766ad9667230a8c005c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014824bb1490c195b429baa58db1235ab181f6b3fe2e4d58d06d491ef055445e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94930a70ffe86c6dad3330fe59b57033f88e913857c5760b6b07135e184e9103(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6751f68cd546c65ab66f3685d50e44fdb670abbc10bc3e67a3654ff5f0daa48b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3dbee138205a80750dc80da087d19d7ab7a4be5f82d065ea9439beae90781d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00fad4bc3c54a75aa617d8afcc6b551ded0fe999f0e5423d8c96b5045b0c773e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42255988ef2a8986ae37d816d9dd8d45a7ec45cf7176f90ecf5b2d46b9cb1d98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24852093336d4944d2915f7c8ee3691e8bffddd4fcaac841f93c31387f466d47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__510c4cc658bc0eea9427fef9cc0d3f40b6a99f638a78059d38250008891376f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84a686521814e3e939d1acdd84dd90f4114733af95fa84c40de86d112d97d2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87e07907e1a7668dbc5408b393c1b10c7955b74d13132d8f71d9db97011a8c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fdc6b3e05262d3b6dc47973c55e7c511b7315073e3a687cd7c03a4f1e532aed(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ea3dcd614d99d485e664c580e6da6decb5403cd1c1944887aa83d8eea5966f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b70986045953d4ad71314bd397a0cf163f3840dcbad6a632d5e43a157eeefe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db20ce85ac57c75be83042b479c03b1d40c78755fe751cfeeaaefbe9a29ad0d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916170b17b1c875f07fe01755a8ae38683ba36ecc6d19f9433d0c4a87274e2f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c660e8e8a96983e776cf33a191f505c29efeb5cbf9233ef5b9400dd3d62c133(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a66c362791430066569bcdfef07dabea018351d46b566486335994f2f20f9a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe98f4b7b88f4d2cc9907c61059e17d98d44ab29f79a3de23c4595b804d4a75(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa01967dc56daffb85952195450f976c681c0064869a1873d124a1e606937a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cee2219a49a8d9677bcd4dd550a9c54203d8c644332fc758adf52c656b56e79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fad0da2cc179ae3b33ace1dd55f8bc1e663b8ff8ee2a3781b578a4ef5598257(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4872683a01b0bde8631ee4fd9bf82abbb3ad02dc943ced1de0564ad5cb6b297b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__004fee243a6bb9c1181b468f3b96a91445094d80d695cb5f620f0a19604e91d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7cf03b5eefa296918e5af41bb8a351906a4eb10f7563aeb565951b6e65a243b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4cfc67d58600931eaffb9c93b8b207b037df4ecea34d4e46cf89220116c72b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de9f745531d80c91f1b4d970ee9a065433da1079104754c68c26dc3713a25e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc6a7f36f59da1970e8d431e9e248edf24676882ea98f1ae852370122d13360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546ed1a47da94d4f4b24bef7a4df4b945bd3051b77d85318f77e03e9e0652386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4cdfdcbbb29950ed7e6032ff2497d3d5412f3b89246e1abf6220b3c7b78ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c97a66578d2c47fe1024ee4f59bdb1675de5d23174a413fd197e31a631eee3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8343245033a638ae3c3cc1aab14aa1a3c7fd8a921770b32cafe79468b1ce4a(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d1c94563fb24303dbb0320e5c37a5fd24187c3cdad9c270568d3c2e14333c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5115a1b1a1d7683a1ebcf6b36b854c387352d37e571827e4d499eff6ac9ad158(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f31881324ca0f62e197158a3b2a4f0d5252103c1f281e770bcbe05701a4022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8073e660982cece91bb101534d3a96ec2f95c2b0a8b68f38e20e638662653e7e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e5feb0264ff1cbbc0de298c3a6a27b46a1dfdf73db4625f24abba1b334dc0c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2374ed5ea683a9cc7817dc3b9d7abd4d5121e8665f10f29cb1a9d74e8f3ca94a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3bdfbe2f804e1979c9ebfaa82b40b42b61d0dd0215c8862f7a1dc29b6e68b68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f31b337c91389a8541cccea789d26a002db25a6d25a29287ef8ed3500018422f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66bd4f84f12739693257011a49eeead5712afaaba154b644ea1a8755c857a7c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615c58aea73e769b6163fad5e2abe993fc31a75800ccd661d007eb80f318b786(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61aec581531b20823cfa1cca75f2f30be84afd3c8e60e872f1a867e84ba30e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a05dd36d52db433142cad0d11e181dead5c4f90a599feb2fc9d97bd235f53e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4db2c936c2b6120bd8f69281bb39ed0f7133191a6785e47d1a975ea37cb8080(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26423dd5d9179a6f1bf4aa24224f95dbcab2bf415892f57c0ce4e5cbdd216ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c330ab4b6ca3c362f8cbaf5d55418b29bf6f102419d1fc4bdfe5d8e45b31585(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d62017a01da4640755ded27f2845c5943a158082be6b1994b336d24842de1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d36242375bb7299368c2bea6a7c03a0a45fbf7edb590c532f02c565911e774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__299dc202f8755c9169a3baa3ef0e1b65c74a991898f187b00997b6058aece033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acf09061410b5da37006486541a6d301cc40651316e8ac0d81e59e4370a6998(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4703ae6274ecda5f66cf81174c3267ca7c05d3435837445f2abc94efecf6aaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4376399f4e3b2aabb65e2260112cabe3fdd9dad14eab60ad3468aa3c89e6a435(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fa2d6717a39d10126d1a363898f94ee6988746fdc8fa2cf86f082996643e04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a2b58796c158d08a943ec7c60cc8fbbf12786f3d2a4395ec4913cb565d818e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036c0d35a18617df10d557e310004836ce087ab286020643f576393c0287e8f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a033410dcf8cc05b276bcb6f56c3f43c8f0099312f0c520ada50726391d7bd3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12f0db2dc1fae7303e97c45fe9ab99d2378298b7b8ad223c0186b441a2a79dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3704d4cc509f319702b6fcb7ec0e4da1c5f38e0d31e91999d52f7b0b067a1b40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edcf998d2c7e6976b5f741a956e6de7ef0bea38ddebb67154ab5b760efb90cb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ba01acfbc4664a7a6bac36f7c106beb1b71c16d90720ccf5488b07f06a34fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c9da40cead7914bff25db6c8d42edb5835368dd5d3d6ab695a34c39b6167b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d071a4e0c122b6adce09aa81fa377260bc86a124abdeb22166f52f35afd4829a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ea20e4d6248a3412c396dcdb54b934dfbe8db31bb6e6cff4274f70763e64c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03029c371ed1e4881eb9d8ea87ce73d14024c03a48a2ca3de9eb2570c2637ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8afdd94046006cc905262d83f62739c94b4f94b42e81211af867a1c058a44d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717ce34ebbffd0a3242ec7b2a1033183972e9da0fb2425bf4d3fd5d97eee18a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6994b8b889c44fc1671069ba808662e26bb5e6653ceb7493d13dbc420093ccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ca98204e51503aaef7e06997e715c61bfe3a9836790160735a0814eeaa5b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0daea1277cca3f127ced2f297f2cbc7c8b8bfe003d1d1f56bf083d9504b5987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cdcd823b097bbd1d55ebc20d73aea10958e97142bf67c9120d1f5f172cc016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97e2f95ba36bfd876b2fd452059a833744157b153c86c9b603206cea1377d89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b0a3f616c36dd927b4ba4da6cc1aef9d6b57cbab6c993899865ef7230f84cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd09737dda1b07f2a6d720ce753ffadfe7aa24a5d6f9062d2fc839bef5370156(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__585cc59ba3d2a34a1152972c2174e6724a3e410f5b27e3006ed19ddd2cc4d052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a74ef451a18ac042970a624a802b0883c59cf1658533b524b3af70780f5afab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09536d26c239b5a3fffca2f17039e911fcd1e5b11ba09e6cb1ee29b0d1d22f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4efab23058336bd751407fb4370004cdef027d1fac8b5d3de9a0c158e349da1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd13de55174b649e1ea7158f5643bcd0c3cd917181360b3116cd1df9f264dfef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95283774828d5625c7edf0bb34564cc47bf00d57e53a584dc236ba8f063aa03(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d425030acda6592a747bd4dd7125d7f937d5cd8045a446bcf11830a67764f38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0dc253627deb09b3705534f3c173e7b469fa12ff54a7fd4b368efd599663bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fded53316d585f7136265f033f6426c154f3fb10074488a610028fc8029de157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6edb9fdad7c1f0d16c8346ac87a8dda9a87aaadf54d1d435161fa5bbca6f9e52(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea62c43228252a055301961badc283c082a39432337744695d198c5bfde95db(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01531f92aa14b56d22ba4b6edbd7193720d21f75370bdca8bd1cd4f0f5b1a98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b34fcb21b75568b40ff1bd713aaa7556ba7cce2003f302b71f70f933eeb2fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c3088d608630828e9d114e6d7174dfefc640abbbce113a4c8fcbc62e6b643e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d901c78b1afadc8497a20a9fc2cd8fd51413298a2ee0b454d808e404c0f0d707(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a417acfd4675387d426d1e3fdd1df77bd3f0b417ed389331866df4e1a628343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60deef109d1dcea23d225fe5098813b597a02c3a7b3c37586d0c30b56e2d434f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403042b0e72f66bd956048528ef7c7ff186e0e07a2210a75654c7f538a2d5e37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7b7d5fd239ff8dad32f619a2217d0ca81af1425e701b47be021480c81da573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcdf26ba092cf6ff397feb52cb458e8b39b84b146d0d78cc48a8acd89a3e78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210852eb54fc0d68045237fa5e70800deddb5ec6ccba3e1fffada004d7048c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41845d87018858816693caf24a04e37ad19b39a121d57c88dfdbc7865d062c0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b6140abf6646675f474f9d3c5bdf79315152d2d3882a86fb092d5deea02e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59cef965e94a7ed16aca74dbd6a51d1d3a499e2921a7e4d8bb88d34308ee711(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a1d846bc9062f70ea0dbe58bb6900519e46b4d881363e5d27a133d7adf29d1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d505107316960a8c186b03baa077e902b48740c809985ba209879f0758b7b91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ff5d565ec7f394c72388c87972ff39c43f6c513c1679b144f4ca8c0d452894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c92061b04f28e7958c0dcd6d99a35aa55819d9dcd73b0df2738c81004b2bc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53194f2f9088bf896b27525bd19b9e6babf79dde92447096a9975ac144f32cf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a11e335cece40b6a85a79edfdd2b9430f5840549143924bd0359f994c8a25d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28cbda00d93413bef0f9dc9a552bb65e111dd6c0cb738bf9e74d2d53a40f9e92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6e25ebe924f3c534346e22c4f4e0b31dce4d68616b75d23f861483280f3389(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7986373c9dbe89e19aaf9ac3b0d86525d1206c375e9bfe5ab18dc0d81c344a01(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c06487a6c6f0c014df415969f93f917baf658d0968031fe0855a7ba4881a1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a50d8aa44519475c1c1908c0cbed579b07ab4115aa3838e52c64cf86e00770e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5e4538b09def4d2c466afd931d98c9175dcb1450e7abf42b98da5438fa33eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c98675ee0e86bb0c925bd17b7a541b7581704ec40ae4a5add2660fede10e9ca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e708485a4efce111fb63a2f450df3f56442bf647de29ac173a437d1d4bc0e1a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3070ff9d1f32f83ca561ec3669edadc5e325f431411541e996606f61adc9e17c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58e84cc0b54b04b3b48c45a82e14f41ca2d44edc4c5f93fea43dc3d6b8ef5f1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fbf4f4881b8f1922437cc7b5ffaa81f13e19a5b26d93360346be5951643094(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377bcb011c9d7fbf8b28edf95581f2d5eb078b0c1b381adce57291f43acb24e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4949930030adbffcae18d6551bcf0a94dd449f501d29dfca063c34f4c1556f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a906b7a7b13158b04c2d3bf0f54234e1f8c6d8e1f0a1faf0c93b78120e1a3a58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b142d9d99228e41124ade58de85f18d80e6c8abb76d75ebc7ec38f20596e510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1206148d006539e40be83e48e9b56427b0389e8abe076ecd8c71cdd13d12ac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2fb93a672f58cd28ee37d876469a47a7c820524941c52b69fff5fe9a396db03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f563ce6279decd830b874ffb4d0cc16e7ac26b0e1a1eee5a38be27ab8906adb9(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9a5af309b0c787b69084f45b447e69ef78aef134d126b9e8df00691dd40221(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0ec0ba28e755ab0b6aca05186f641fd3c2d89d2a1bacf81a7dbbdbe0c06a99(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e120fd5df0efa04fd2014c5634511a7b8e9ad249d1d101e964625b759c434f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71e2dd04db7aa1f30ffa60f5e0a720b4e698c2119a4fe75a0124e60c95a22cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b59c18ef9fd7d03e624bb725f6f354f57b9f6c8213345e02ef766518567ce6b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2921d87399c5a1876a9a06b94d345512aad7444260ba21a8c9d042dea54a691f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0f5824553b98da5cc81582848bee3ca371eedadb0a9acd76111623c7d7eb78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cfb63ede2bf517e0346220be903444d9a577775ae795cde20f45e3002f91ff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddbc7c0f5ac2ee3cabb0907b18b0d06a99a384ac5a2f42506552b430902b0766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef6181ff8cd24d79997e825aa9dadc19ec3b2a4b2b1a1beddaa96057e104c5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ce8f333ed62f7ce6dfdfa3476dd7034bcc9d16a1cd894103f0e1195b2c8981(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a28e1d55c7beb44533be9cf1594527b075137c01c804d5948f5293f11edca12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8832702a78669efe0f148cf4332f5c0b1a777cfd3ae289879d7e1302c2ae95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee9afb2e161d2a37bc86e1cd425f6db3914a7939ffcb09fecfeabb254049492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97224ba100b19c0669ecf2d54242a8d9b13af7a566ad34401509adf93626e7ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cd0d2722936aaf15b732642a5ec43599d00aa3301d9bca01413624c7ff80e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd638e9021a4c2b0078e5fcb2a8543fb3e6452704abf6879d10494d087c3618c(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0819cccf4688afae1413992eea3b2552250e8bec5d62079355305753839097ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa7476ca43a4e07497989764081f86139b72de048b2c06f946f17a1a4f5639f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3b491ad0d98e89eebcb5776ce3ee778d3dd123983b43b5e824ea18f45c1cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565f8673a8983e3d55d0517e53d68d83f2f52d909a1553d80f7dc43dc17186b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7c3a3c26c698fa6294e59578a0c84e0f1dc8e2b1922b78aef64e0ee15f2235(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb7b468f6f812bf82954c6768a66fda04a70a424b6e906b5d5c987dea2473a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56ea82755d3943879f3c6aa344107ed128a0a0f544b222e9fe8a1bec9c53132(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbde28bc890ca6028df54afe109d7c51c932345979696afaa36db9cfc9150067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a78be88b1464bdbe07bed5af9eb3c187949e64636bfe9dd278d82463039aa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1b13ec42fad652a2956e1844aa91a6b7c3e97c9de1c0c589f660101360583b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90d612381ed592375330b6b0ab49ca6e671128a26db244d1c26a35c0f97e7bf1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ab83f7442b378e95f524b219f9e802df2b1cffe73a76f931a4b9f483046cc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fc5504dc2a6f3143387f036733ae1c6f1614dae20c20415811ff7abba8ab66(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d948d51f1358454f40001de4d0b9f11ec2f3120d2d0fb5e2efeed09429237b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae5329eb339023866695317f0d50b3f64c3b493d6e6f817e9c63d9935a5d371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66241e21d133d72fe80d59f30532d1ab83d5763750b82d82dbcd5a6192bf1f64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a6dd070d7292b4a8ccc105d0c278880edef57a01e92df69d3dbe4aed46452a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd656963ebc330ebe1ab1effedf7a5b950b2c93aa1334a9b2f79ceb093146dc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__698d05fa772e2bc429f2019a75f0a146215fa70df23b3e31b3ad037ba91c4d85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2727b62512c52266afef123b25f5de8a3eb1d228aea45f4442d1dc0108e16eb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459f68b91e3892fb8c441b357419476cc7a5f6ab8995a5369727b9f50537b5c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3227a751406611739024989b89e8c32005ba786c2c39b0e9d714ae0344f2693e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5363b13983101123cb93a558bd8b81dffb22e11ab093ce8086e89da0a5360a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d2d67fdfa5efb5d77b413542294b38e113b7be1a516549b38a6da27feaa5cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d7ddddd3a655a24ad95b186fc97b062432c93f049917090a5e025169f20198(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe5096e143b27f1e1a661c094b9689dd6e826fc2f75fcdfc996ccdd8fcc917d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20d95715f488f0794a97b6a1db7000cdfd64e299fab221fb9a37779f3ae6543(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19043c0be5d29311c4c5045b4f35098fd67438b259257c88b0a1a45c25f99ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fcb6056491143738826d3252e796d19210fbb143fed5f870d8c45692d6b18c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb2dd311e1b28187f1ca12a54a84b1e6682867c91fa41760863b8ad418db2fa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09e0202bc93b5a9df855b92b45a012d36d93a0d1089e10468091fe1288136dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c444bfe6d4a70debd874884c17071dc2a8c00982a9c0be806da756616b86ed05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57dad4f59d3d74c8694305218a610bf50a8d4b637d4bd9b5bf6a45c66c04f24d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f21ed19a554c9d86033807b4b2758cb1ff7b898103765b3ad562c84770c44b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3da4d69e1df710d33b143c6117d31388c4236bdf0907f4cd4a432d0ab3904d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a81e0d5484213ed10e3f4d460d7c6359af154c990c67460d9b65920516633e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188c1e93f036e1597e82d8e9c80f1efb2a5cb2c524701488103e986ccae41306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b5a7e00db02cb890c562804e1e93d48fa8369b75a62136bdd5fa7affbd1e10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860be918bb3a9ddc27ab513505f92ab9dd752cdb92d451e772b860fa4ef5caf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be100c33542b89063485fc7d963f4d2c75163b4b065941fe1aac05e609eee40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58819759185c2dd49e7255d35da0e10ce825baf5203d02e44d87c0ecef21300d(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312bcac7f9a3379ed760bb01ad0812971ecf797d8266938ed143b9384dd9ba0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a15cd393972661921e65dea9cda1ab227c13c8e46004eefbecdc1f70617f9ed(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee158c967ce6556dac3ffaf7f92c805bf7f908eea6fa47670e56ecaed24757a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ef4663f37cc7c3e3c5e59e03fb8e08803acc26bb33d7d3381f0cf3b3fe34bb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92b9ea9622a3efb0e388831360fb381030f09f15f5652332dd036f689267184(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3407b09e6140eb1e42f1176c93c1b70411fb9d996e806c072ba0635f94c4198(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ce4f9883fab94e2e3bb6fdc8cb64e6c700f421964e887809d7ac554436855e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583595842e58746c6aa4219d36b352a4b917d361ac597d72abc6004e27ce26f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a559db3a05acee78160adf6545addb9afd5e2d5b8a693417bc5436a0578148ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f7fb61406023e7e35c4bd670f3b388db08f33f62485effac30c673fc041bb2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ee9366f44a6cfb0fe76aa261cc6698a69a5dafe46f0cebf80f9afa54301ace(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c53f68e49e752bfc1a1c837107230cde523215c9b82d92beeffbe93af8fad83(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2804199d2776d436c33158aac47334c90126b0f23815f153562dcb8c35f9e427(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5af52b9c7accd100686e6785e8d79ef4f498dce0f8ce005dc8ac97a2a704a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4086c233555c42d3e942033f90ac78fb4b0390240a28a3fe101812c4d6f80304(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658b22bc45931785acbf5c5f56f81a97db8d18df7ffb07823ad843b594a3c11e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a736c6d4874df58e59f2758a5c2401f5c37ebd73dd1657352f5edb8cb2ebc4bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc29685226d81469043f1d3479d6ba571130ab7c4867857d6a562b15f42bae4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b520c3e269163fe303d583b00ea331b3a59f2c4cd080a5721ed74d318b24d280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509977350019f49a0f3f7e9adc500627ea497a0879c52c342fc56e7476858eef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438540bc9a23701972a81aaa2f0153ceb38c9270645dbbfa55cf320bc58351d3(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__243cc8b19f8d6a849ef00b649a0a18ba6c6616ed1af4b5d7770f913cec8c8cef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800fb9da6b92e7ab567cf2b97d7732f015b6e63d5b31bc871ce78f4b94b0a75b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32cc4079a62e20a8fc4d78c3ffe7b36d4eaf2eea309ae3f194f542792d795b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75eb45e03fa305af1de4ae8c120d76405fc89c340484f63850ff95efc59d3000(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1679bad1eb7bde9c44adf7fd5027fc3fb90f672c25ba60de524c4723710a07b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25219b397a5057c2c2b72faefbf867d939ca60bbacaf556001016d746a484e33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12871fc464b1f9e60c3cd255264d4c0d8eba3cfc003867a07cd55f84b955a04d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3eae0f59332a4e175f270e001b8420cce5c8e983e06158889146e7de71d9079(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838a89904d1a52bcea47148689c9a47053d2feaa37676e6e84821ddc542ba623(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8f46a33cc125518f066a1652aa1a9c54accd7f7d27c0c030b0ae6798d9d8d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913a7e00a27a1a487e82ac4ed58d98becfff65b74d0482ddf27855038cb9e88c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfd88b722a327063a540ca525158680a3f7fe61b654d9daa9bcb430248db5584(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550a14106d1030338338098df65a3b4dac7601753e46102036817ffcef39c3a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b43fbe7c7da94a780e66bd0b24bb1e661c80a19b11423478ab1d2632518854ac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f810f18c85a4e75de97b547d0d76124ba8c5127b44ae382892e8db93eaf1d627(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a493d84f22d100b677678ce7048705df007a103633c4f64318dcde2c406a27e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8229596cb52c7c5834f5b61b83116a1e24373aa44cb27d534233a4d4f5e35f90(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce49df65923109b450b662f7e493c579cfb641ce6d1508719ac28adddb903d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2db23f6fbbaa2eb637f6792871bfefdc1fe65484439901429f280a0dc686d35(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48cb197314251cf7dde03c4796a18ab5d422f1340add057051b07cb2c2afc278(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df9d26f25ad0b54187794488306a0c862034c6f26884f7ca6f799a631a5e8c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9247fca4ce1d55a569a67a0ee618e4a410039ea2e3d9285becc8553cce989b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9844af6d1c79d2af54c66e881b3e8266074cd250bb209dbfd5bd882e7d788cf2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a877a3682c837d6193a3a1ff81f19c84d71ce8deb91d9b03df26e8e7c051d662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c61ac6ab396bdc1e745cec985eba1cf9a09c3ecddb5910cbaa2bc131e2f1a6cd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa01eba8fa3bd33044523354c8f33604ec29744c19d275557b4b8097a7ce76b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b22e8d948aa581c9182864cca5e59af08bf18dd6ce6e1889cc76af9f5e43f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9693bb3e1541bfdfdef057c5e4d4c69657e825a2fb612e8cbc292b28e210ef84(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d92b02f03ab9d7951e244007e04ffa7580c142e3255bca704b9d431c8abe20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615b12bb794142dcfb5bdf061823753b9626be2271595c706e0ca38004df91cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b7992a3bfa3000189cb3b936d309153003216f5c6d4c9019dcfa119e5b8102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b925fde5999f57f585105199d513f6a2ff3937eccddc413f873f6b5b987481ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bc923c42c8fbd375faa6a2908b1b87a2325be91e90de24734a9bb2e2c5fcb2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8420f729931f8a86dd85b9b64294ce0c87e08db94c94dc9f8bd355c9a190cd2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41033391fac377e625f9d3d0c0313f1b9c4b2f3b1b9ad07dbcb661d0daa8087f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b443b25e95d20a38272e2cd88466fa0c68ad7bd678180c670121e75029ccae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cca139888b503907f1c9e84987db7626ebd18e6f9713df3ea02a556d944fd6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fcb4c9844eb7f1bb31068a64a7c4ec7e9353080a1830964793f670156071956(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f561d9f2b1a06ab972ac197cf24c7921369858283391aaedab84e631fc2ccc4d(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c56598fb73d826b5049d9d60d632e612dcab23846e74f8d081688b1938154b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d50b1292251712080c7bc9ca6cb6666cbaf46ddbfcb69c2c6e788e6b2ade5ee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4ca9e0f035b33f6ad28e1f3ed1fec47bba17ad489585c8c8fa067d16b601d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84091c538cd212dca8b8452abbf41e28e6889c011317fa3c35a02ffa96236f10(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b131170dead02967e52400403bbaa46950e8ccab5045fc30859cff8b4dfc73(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b422f3faf239e0068965547445f0d8fd49a35a765b30f5e56263161cab5c6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d79daaa69153a14ff39edc9c0c5b6612f8ef68ed92d50fa36982b11a62f3140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1258d8bc76542b277a879fe20f41aad557e69d00ba8253efef3bd65d22834a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faae3106b07ece535b41a6f93b8ac3c9bbb5d4d8a38b02d36a9af5b9b909ca1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7c48e1a95ecf9fe3aa6f7271a96e84aee37146f6fb93814d53311f77ea1ba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b7f7c3ac114aba3c02d5f6e090a7226c355853c2c8d4fcc8c9bf9d7c686681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c58c496dcf79bc235e52fb613f905ac13e07b359f9f85af67e6b814f31511d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f77e934421f55a007876966a5a608db014a878dc113919fa4a1b4775fab77ea(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648e89d9cd8f4608d82a56021d9fed82fede9439e68f597249b20c8b568aa88d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbeb5fa9f36bb7412d60e4f0400432187b6961fff3b8e7a77fde789dcae3e6a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8537e3f762603fac046e95c63f287cda0c8ff500a5b630650a6c5e875c3b86c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__851250303630888086c2d017ac09fef1767fd98d8bc9ce3f0af4f3046e35c6a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b5eb3b02e2302babb97d2ac96931cfda44cba1ae4f50f246ab707efdc7e0ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c3c2d4666f35df3008949d840e46f8dfb2f5077b7336e1b42b9d272be4d998(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970ec8cab2723bd5a8d00d0ca777492863a8b4dab47b022d1a388cdd64ada565(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d879b0295cd01d47668c9a9fa5b2331401d21f1a11fa017fa4a04288f4be1c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35fb57b0474a8a323640d041a0e4347b38b36a3e9593a84efa631bb6daf8534(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f20768e3913e8dec3f6c87398fad5ab139c58693e61ba7b0b592b74d4b60c4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4a9cbc05f14cee9d6751f9d2125055fc30a6a07df80c7634b5c21f5ad6541b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5706d828b0736610c0ff9f59f0f18ebccf1dc5c5d9ddb47348e09a212bb5d3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0c14bdba1b48a5cfe4d059181e9125b5c7e7e25b480d9add8cb0f389b34a92(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a87e917bf298b1ba9c28380908c23f5da0cdbd86a5178eedd49468fe6e54d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8f0f287b524eb02584011ab091d9a1bbee21bddd43368d7bfaf6c344aa0eda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c23804df87c62063f1039e6f3bd85533bcf225e363d1398580012d531d5177(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12035f617ebea15a5a5420533b585903b1aacb0f46e05a9b599a8d01f491f284(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba82fdb61b7d067988bf868fa86fa0d81061fe74e12dc0b96851c57990832f3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4153ccc21a811d178b40874a1a87e364f3f579f3ae1d6c2f6401088ea0c17484(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbc056cd47a4ad47630140daecc8b4070b8e3463d41770240e1088cf81b4450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69213ff9f090073eff482ab9953c96747aa407d83e5ff957973102392e255675(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07eba29310eb061d895f4ebdf9e1d5c836c1746cce4a48913c463937e00a37fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dadf6069f69a51b50646d07b5b08bdda6d6ad5921326f1337dcc03dd4c55ff9b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2764266cc2871ea9c3594c6ea2d29a3b2b9697d3eb6227b41f6daa03f84d8948(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809e3eae74dd9a93c296ab2af533fcf9c21c0d7ae9acf5f945f473a06db37e4c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ed3f40c8c20b9895023f66acb6ce3f6460f6a379834d0447aee12bb2b9dc72(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e2a3ef1a6899e5d0093a3309b95e4a7893611c3bd5d23cf8e42e9519d8249ab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094951c72571bcaea01be4d2b743935c2aa9b45b7ac62b9d641ea109b7b412b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388a8b151a26753c7e816504f5f832ef4bf7503b9c005a17a58c54b6b231b2aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a136e5a9d31f897ce56031e3a328f767471cec0c20ca25d200ef100ffbf90bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb68b81ccf44ee37a27aff393bdf56b8471bbf4e8533ede3088cc05ca08b726b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c23c0adebb5a9a587d0b3bcdbfb41f1f42fa5e0f307ab972372aaeecfd5de3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69999b83bf4ab87928ffe3e6eec45dc5d506593ebabb94041592f6eb2aab2c3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__237c0d1addfcf6e871614ebc0361e65298e98a6caa559311619cde042bb43d31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd125625543d011ced957a0c2959cf2ffe35152a3ecc5d75eebf7a4ef32e0f69(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4adfcf1300c813e024e33a28d2a2c8ca8ab9d19cec3aad36a63e1805e314f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a26402cc6f8ba6c8154207c736caaae9ba40efb0b651388edb84fdd6bc2316d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d82dc03e99a7435541217d1c64d310bd6832276d56ebff1418d4d6da54d883(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6dfc9a111b9e3a05c43231639febb2887b1a2a4c0ba7cad83600e67aafdc9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d59d5edee85d800c1f5d56c03fee016d8a535339e0573e4c9c09d13894b7eb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf496178879c654722b5b2d10cbc65ddb1c8b77f9e3891bc22458fac0ec3d021(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56dccc710c5f5e81eb12ed3944fa2fbd842236d3f6499beceeacf0188fb2a24e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca45dd44adf7251e74f18c0653afce79c0e9e42e944db88f0f1cb4a750b3beb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68744da72076b31482752771b57e3834bbbf0116507641aa6b226faeb588015(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8b317b10c7e64c50565fc1481d322307b0fd3d66f6c3fcf029fc357266c5d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__736f443828d77e03313f84b53b749033ccd34ae65593b9be81dd11bfabf21650(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eeb267e32eec2611b6632d3016693f5730fc2b10a94a2435f4a6925437988e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a703b1b95b488c9c6ac0efda243c0ccd444e4ae36065be75d6e2577acbf90381(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2afb0eb9590b12d8ae737d0df71156d50d056fcd31bdd36fc6ac1a5fbfdad2e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf07098d29fccb49e2c4d4f79af7ad101ac7043a37e909ee931b87785a57d0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53c86e5dc4c363a607e00c7bb0d7f90fc4504f844a0d73e2cb6ed9a256ff0ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39f647759e5d747f440b6cf2f23e43748bacc8f9ab1107647ec179c40f7d1f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb493628ecc534cfa85d853865c4e470459fdefacf36ce1b4741b9d178086ef5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb00c44b367bdad91175b97960f8275f6d354af7ee1c6d4698d30c827ad8fd7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1a23c741c09be259867b480f344d382b8b3e3344b05c8df78035ee3007e776(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a952edda8d305ff0cc1ddd2cd21b650135105d8998b9c4d021a70a8897b0e538(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93aa8b5110387fa4f11b1d14820bdb95f839139980d091efa916c76cecb8c89c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cecf2dd6eed02c9abb4f868795392decef280c6d769b9e94f9a260af6876edb4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92802343bb32dca59eb2b23b80364c27f12849f383762db5c6e0f7667051b3cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b722799aa417da854953abec27dc7d3c2870119464e915ad902357e994ad17(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edcda98981cc433facd16515434f4537987fe81209762e11ced83d25c8a92205(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e366b8eb7541cd927a07cb5bd239acd92f94f32e254bb4d88364c779ca7decfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac515b81724e4a43201b90bb849232afc9292cff5924f470d31e2205eab92a97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf118b84be17aa3895cc7bb8c6fd435116ba8d7c48d3435964fad64ca0ad8ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37add6f530a0cfdeabbe2e29047581ca5fb5cfff6b552879a16f98434128fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be40aef1b3271cf89d937d650f07c3c701a0aafa44c6a105959e56e2ecb78f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51994f11549e5345ff88307d21311538c37e60611be839a24de58ce3b8d8128(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a1a7531ad899790311a39227fc26f5eda37e51464d4afc0b7e70bfa1de0abdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ce055f6eaee64fdbddb72cf627b68017685810f01b5a8991f8211ca634b7b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34628081db93003c64a4dd5014f39e7ee3317a1cceee55d6e4c6c7d2b5204d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12236367a34d54293e673ec84a5a4dc2fda90fad3691da47783a035803d04bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e82d93215738ceefb7efa6f236135b9eaf36d2cd03cc0d63ba7adca50ebc9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e3b520e5c9c5bd075bcdfcc46505a7f91dd125c01a5a444f41a43904fd29ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf569606cbf69ec03e144f0829b4e970b4efe0b3d86d09110f990df8a712508(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3392d6692cc1ac0f88095e6bf95efdf2d92c15b72b9b9d1d82257bc9462894(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19ee6cba9054d227bbbe4e860274efd6d4927ec60d6c67678ab54018ac41fb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a291d18d8d5fa4370ed90b63244eace615def5acdae6763768f3a36ae653b6a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b8c01baa5e90a4acbcc0f85a9720bef3790e830af11f05672a55ef12992fc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ac519411fdc8130bbc92131bb2d73f4b66f6b7e14b616d93aa4b1009a34f1e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9355856f007fc586990c013af1a64ab6d6d7247e93301a14ab41a8aea4cc45ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2783343610ba5ec40b9ca0cbdad1b01a25e59771fbd316b6e91ba50107533a1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6fe1476d4cc614739876cba94bec544ea82717c8ef06418b9a8b8f43a652a6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44bf76063071fde597734420a351a9c79920a7e49d61fe97d391371dba729ecd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b87c0b96c210c39e502e2ddf88ffb5c587a11a01f92250b0be3b33a40980b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72af2222fa6deb6b4f7f23d96de231ca58a5ebd67e92a324f19a73370b404bb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfa4e91aa915925f0b7be003656896b39b2eb8d8bd536e3ab24d4968bffb009(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__168b1ea5b526a1be65356e69ff93ac8efcea8c062b08d35c67fbd6ef182b1e1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b6f7fe7cea660917feb0c2cc7df56118d441782f485784a01c36273908c7bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d118453b7e93ca7121d8ad2e00a77cae4844037bc1f3f98b9f6a6405f81c8b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b779bf6d27ad27662c2e82d9bd68a54358ca9dca2a034b58add138ddc8b2c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df54f34e0fe0b85fcd0666e7f7241b4ab557598918e30166338298696246146e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2595ccd92a6fc5304745182ea43541ae97646ecd937b863b497c07036be29d09(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d2252e5acd166effde30215ac57a198e7735c0fd91de16fe70e5cd996fa5dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3491ebd907d05359024b569a82db6e48baf91fac5f25afd931483c38785a29d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70331fa77cb71e9e30a590a870424f80003af577d2cb5e927fa99972639f748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927f5cdc5e55a94661ba7242547f323aee517e47e5b8a542bf9302aa12857e52(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784f3ff1df2936acf29f307a8573e436ac41377337b226e4542d0940600929b8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbed47a062aec92cbcc05be96f253a2b94be6125cab2fa93885ce27b1a3b3849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0240c24efc93278106cb422276f4c82ac2b1fefa0104718885c439dd28f488d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8c6495a5263a0a6d4f287bc0260115cb694eaa68a907697990df12baa00bdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0acb5319a51be256083fde63541627eb863ba380c7a3c20df15bd82f686331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27541ba5b879cb64315bb2affbf2f49e2bd0d2939e0c0c9ec8d185c85c5ebbff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0178cca2f6efb6cb9621e4e566acad8d9c53b7088a4d0b019728ae3ac8a76be4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a5a2864fde605e08b07e38e33a93dc6e5342865b8a0ca4626d494df3b706fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dfd41b54141ff0f49711deeacae2b76dc3a6813cc84ecdcf8f3a075f63bff01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864cb0c224ba5d7881b0f7f349445983ca03c2b0332a32c22250edbe855d12d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a140a2851298893c3dc03d6dd1efa0320ac6ea2c6e91d9bf9aa1d519ec0e28(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ac1c2923227b616aeee067143e237e5bdca1fab196e4ea7d12a44e6e4ecd04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e58bdc0824f519898e8a7fc506c00b87b72f54a17a804a833332b3232b688a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1bc449901c173046ff9988187860c7afadc59542a5a0d843d19e575b0cf3ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2894642bbdd9458ec7c6597afeb57285828f5f2a369b9170d8f93c4f5c6bc818(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec38efee804cfcd8ac6d4e8fdb584f31f40b314778e11f22410476f78fe57a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e05cfb07ce906bd321e9d6437e30a4da12f7e45a9d95386c9b4ad97d8bfe12a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f6ecbe1a15fe2c9b2172f26f82baa521cb23ee023d1ebb1f1afb639e013935(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3d18e3616efc076f3a8ba75e66ae84c8be637d419fe299d3da732852bea48e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4986c381221e0f84952f6dac50535d43c61bd9ffa2f7a16a0e15035a093e3a6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a35cf66bb4a9dcfee21f3baf1afdc32bdeb3d6f03ea4adc3551f6df59ade63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91388528067e9079eeaf5e4a531236986d40bd3eeefde77797fd9bce16d7fa64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d83b9e75cac329a4bcd5ac92249adb3311f89f6d562c95cebedccc3b44a1f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__538e518b7884a0f4c23dd19243b97d433897b459f49e4655538ddd7e8074a23a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16aa4bdccfe6712cc5ae14720eca253d915a6cdcfc0de57d529517561941be1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5bf5f1860abafa5692e2e8328cb6368a0acf8d74bd6d9b948ab7f921f808e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9ad720f9a9cae34f047c825a663ca558228881366b56b56a742b567e3e4d9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ba9b8d4489afe9dac0fb3354e41283ef4746e7147f1f3ca0c684f443ebdfb4(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60afce73aa607d75ecb3d5d63de727dfaf93f0f77647e3236021e70b7531b3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c97abfea8b17a2f204199791978f118db2527e0a9ca7e112368e331cd090374(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df841329a92e6a1470e3cbe5b0de5c1a13119de2ff63736dd5349ff3c8a23fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78bf1782bf90162fd8260eff94d44a9783c7ed89ddbfe22397fe30cab537094(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe249575523ba4beffa11f5bcf4910927ac76b01f28dc31851971039b1184619(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185c57129c9947100e24a3879631efbb06781cca119329842adf60c18daf36fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aaa175f573a85882c6fc3a746b4449053cee4ed04b59a2d6d62d579b7991046(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc7d9234500e1d2e70850b08f219f88d438a27cfe7b4ff5b830e16495ef4dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a83e7963f494a25f801100c922f04845fd0183be5f157cbad65263c0629b2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01fd45b3ff15b3e668ed0ec1ddfcb0eae4961a62fb0b24fb94888cd7a0abee5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c7589c95fd054caa99c7af3f65d12416a1d90071d259c3f0c5156b44f8f649(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1233668529620ed8ed0faa1638e9ab0f0754262a759b6a52001c97c196002f05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766b58da8ae5d1926d6cdff5d8ccd9896cfd4904f94c7ca47b2c3d42b824e02d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b87ff8f31b707e0afe38191f9cd127ef20b2714a6e61eab5fd18d27ccb9bf87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a00399670e16477a68272db9e05c9939373baf738e2191faa6fafdcb50aad8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4bad40f0e3c88532cddf4e386d0ccea86da5bb430618bbeaa42a411308167b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09fbb87e7df2cccd8045b53a7b4a3b7a25594c9e828002c18f5938276c470fee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275867c05e6a8371ce229fc2cb2ab5847c2715afaaabc48068bbc0f2a030ce69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1be46a0381672386ded813b91a28dbb846cce977fec06c008a59f2768ade84a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c22a960ab8dbb22e05e0ddadf828fb52b7d720d265efb8d5c40ad4015b590d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63486e3a7c553368061e8819ae035b4175a82f41f811560000fe807b81974a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4b20e9c39af7aed2d86ad48f7ccba53a2b4972f680f57bacc66094cecc11ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f589f11125c78d6bd53028a07463b0370a88c4ca4741d4f9f5c845eefe2502(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f55cc231e189253bda09bc2832b48743cf7bc69fce0b881cbf2f5400dd31e1e(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925cf6689d68966a8d44adc6b210863a0d2186f4201be2161aa6bec718696355(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7a3026b347aaeeebe5e3401a251af832dacf5cb8364fc89152f121a9aaafca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9923fa975320f92de2b25fb92082177552677ee076f475ac7c126da02a058d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33db35a391c0ed85ccd16a2fd208ecce9816e1e148dff59e22690795a2782e07(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27676ff4b9e6fc5eb2d594a34d1a89aa24f525f1626a23d52612158ff8d25535(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae612d53b8eb71c95408cf0773ffd528b9725da056cd4bd69e64fb66ff417c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7793fffd1ea63a5df3fbecba0c718970ca40aebf5747e0433a4ecd76d34bf265(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd35d191389a4f20dccc6f5d29ed75b3a969226f3ee513b79ff298d440615edf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84d2430b7f42cf261d8d2d69a6e262c87776a1d99072392a9a45c75b89bfe383(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b59f5670c6e1490e8c227fb2bcbcf620d069aa33550a5892c200dc062dcb205(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be01db728ec622e0905e85705e3e44178e94baaa7206245750d3f004c0acfe9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ee8b9048b63cd74fbf3266a53553102ab70c6d36511399d4ee4b8925b9a6a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80740edfabcdb06315c4da900bcf8fb78e83ed5160899dffdb2eb437413be0a0(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55881b28e51c04d22ca05a8874bb26e1c089aa5adbbf24458ba6b0e41732e406(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03902bb04600759c2862ba3fa5320e3e6cea90e6a62a184c134c1367fe265672(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e051607b4110b2e5b2ea9a932fb57b9e29b73f62f55561d2869c673063c96f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea44db21ca8ab34387e1de0b6bd554ee76c3fe0ec6c607ada75b803fa568b2bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3b581a182126f0727678d77d9d35167ba10c58493cbe0dfa097ddb28851a58(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a1fbf85dad0ab18bf48b7c3428abe2969675428d71911a769d733e8780924d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849c717f1e5a02978143307aff9bb9235dcf529d97125e613e8a699c9faa7f1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64be3a634a95a66a61538b9eeeef1487e80c4459c4e48c74c9e6f0caabb3a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe74df0d044a36ab248186497713d59946079aa9c3510e70aef1019df24efe35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefa2dc342463f31b3867cc9fa3f139ea57c6f584ff74b5f230f08c20a8ecf4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1990eff664b06d5cfe3def615e8305152175c0c9d895d87450af8f7c785fb849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410a69da14fee97681047615c9132cf23d4ae30a045d86265484b3c20b06d441(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85613fcf09dad525b6649122eb1028bf8e997d52e9cec8e25e777db2215e67b0(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7bc4b6f80e9f481e97cdb6ada31a982e94b1e7b9dad4d7fe6c7874deda89ca4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24cecda28070d311e04a312f87e9d1235b0e3f053b6f7838212f3e7aba43bef0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf85333e22338b234d197d26918dd071ed09d1aaf6cec2932724f4aac704c78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d56116150080a929626e469c45f309e59e90f446628b52a7750d78720750ce3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80981e7beaacc6ed45125632d6e6436e43f1d03dcdea7a416d8f195e305544a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d2724878046453c519de2c8b65c74ff4b43fc4acad081ffad38104d5e7a68e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85afcd9608ff2be01fcfad605af4c9421ea8adb44a9b59a114ea720fd59582d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5dc368b0c198521ceda6329eb6830ebce52af8b02b800430c145d2903bb5f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1934ad2939aeca0eabdc87a760b4c082c63fac670079c0dd0a40d3278180fcf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc54f97f7935a3fdb252b0352977112eb21ea88e922a73f2a3499a665f199ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d6eda967fb9df4b904ec34aa2064ca5e4cd6ccad2e9a29d946a09de95731a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75faece7f335b7acf616450a440b027c90d94d536d6b95eb10a02a8cca281b04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec9fe5988c553b946a98bf9fb0db6e47184ae488af2ca8f62f97e8ef2d9cbb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b4d982d2da0d238f5dd0c4916d601752bea53480de839bdcf14d3047c8c027(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91354dd04d15c5dcacdd6c4b6b58c9b0a5a581379b9ead6438dd247496cf170d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__243110bb3c23280f78c7395cd880a0507777ef74a8c5343b31d0582a89951256(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10775e3df7eb03b13f0da1d818ea8e19456c92691c924aec1f03662b8bd2128a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedf652072ad21e83e96a3fb65849b7bee606ad89ddd39b8826d752bfbdb816f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091bc960ec9b9327c3320971e195788440a75d8da62f45aad13da18c06dba426(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0016fd3e16c63e2c51be5d4f7205d0eaa9a159015f27990b1add2fac53e68a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca43ebf140e0e7a4cddaa2bbd8179221264a0c8ebf85d4a6d9f7b81cc32f62a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0d51b03debc0806ace7ecacc28e04ccdab041e77ce1faea3006dad417fede8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c74669c707d022c71a8f5b67bb6841ad15d47c220a11d391ac375769b5747c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91129322871f5051301c1e20e12a8b837a0236fb99c44f691120f652944a9c3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f41552b76065e38c552560814e8bc7d8e3c811accdd165890144333787a296a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60d0b88c1055facaa5dfa623fd3c55d22b362ee3c1f450bbd7f1f97dc584403(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5ff26a315ff481848e33366c5e34a9e27bd0022f4498964cddb141510fbe9b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d09ae0f0d03bcfb5f00fbef739094b0138da25c3d68acdcac41050c254062f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ddba1bc25b8b863243c8ad1e34e30f79ef009424ec5e93417690fe65f39f5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3201e5ac768e03640f61edab9be4dcf00439ea2e71e19ae08a1f68441397cf6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__500ebe4c2e5d12caf9f0c93a25a9519a548e1993f0ae00f1582980b068385f53(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa9eeb1c64c573621541cd336e626000bb0bda256b4006c4959617bba152842(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c029261d7d7120f41afff6b36282125bedab8dc9cc8a51bac67675bb354969c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4740c61794d4669aac6dbadd237e879626dd8c6619eeb9e98e1e0849da67d357(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cca990ca6cc025896780ac4ccb37be1cbdf9ddc94f6db2cf8653f1de4861c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c243afda3fc0dd2e874a5942c2d5e3acac4e34f8f70881d000e7a8b86c54810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85702c5d1e511bd0136a384f2446a4fd5f7dfdfae06856752f1a1f5b1f09f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b01f18764bcfa0a6fac818dd2614791e28409d89315f6a62e92da5b78f3b6c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954f2a8769350f63c0ae9a27c5fa60bf722b930035eca2de5329068e0758a99d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df93544de0e045351c9d73911ab341ccb9ff7dbe9e020bc42ddae00e974c2c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6461a55ef2019eacf8d6760b1fd7495a91d0d155ecb160d93e5afda34d5490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb055fa2be958c1df51ba40a5c1f8af2991ccc1096e9798f2a062c4a4e4d11c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6febd05d8b0cc0a38fdc0da696226fb867357d83d726c039914b1fa43d1b2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee583e15677f24391526bbe381c9736e2ecc156a73849bbb10a24a2507b8ff3a(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f75bb8b546f917d32af6f57c79f1c627fa03d530bc4a188cb68d4c2a930b5a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad8d91f42c74afe15a3b282041e7f6c4bdcdd0e3924222a961ad8276980788e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e213fc66a4080fb0f8831861bd06a63202d7c3b5284b10762c9544c0cfa0dbf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc2943c47e0cafa5edb50c62ef35ed2fed013a70eb747b09e0ad7bb2945e8b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3a7e9d1d9568da3f6aa92e6946bf4301d91d8f2383e16b5162246b366262e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f416644d2421832c451aa4fd709d3ed30609fb7f00ad28fe08155940d728bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f042c8e66390146e7bf2575b9849c795225db14d62cbf0f0aafb9d1d956c42f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcd90519583fcf23b2f2eb9c51a5c98090598640b0a1e1d8661d84254f4a7d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b3acf39cdb7edb6af58cb9ffe032540fabc6ffb44db17a5d1b31411b3dbb0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f9baad53fc48fc8e6d35c727f205c90455ea61dd32dbadbed3082c1dc73664(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c78a32c54ab6eb2b662eb747bafe06724f4b468de9757b63acade69d7a4d2e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9795719a6e13a41427182902011dae938a90548a176d2797e7f68b8dcfe010(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07b599021160a24e031af7ee558577945714269f3d52d559b9ecbdc988f035d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca0beadb27d92491558930b505ef53b1f05a10a624291ed99a294939ce4ca195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69dd9867c09f54f4496d327b2d57e34125eed3150c82aa56c7b32139ab2cba6b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e9d7be10b8b92a313af8333049cab608f041efa384c6a04ebfc1cff1fabb87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8742f1a931093d1ed08574d4847cc677db293dad8e8e1cf5467590debe90cea8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f42d12f0c29a38b4a8e4f4a468f1b7cabe95dc0e0ef0f9975dabbef9623c5f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc709a7e6699708529a9924c0b6eff3f0a81bc922b5733c43e4addf77a76ee5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d529844c800c3e0b230c0912958d280d207e607a947fa3beab8eed497865fb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24514c198c2b271d8caca724637e125fe5187812eae6d6d0d8aeb57c3dc3b938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c74a4a6674da948cb2525d3b7b83f2b32f14132060b65dc3162ebe50c0b5ee80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413bc82b83c8a150cbc1f9ce113a0ddb760b0936d60abfdf8753f28bed8b76c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ff90d1ea73289a674408020f2a49019813d4ccb825c3bea51ad2345b14d8a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b567bb3a950a74f1bdae5246f3be32d344746c4a45b2670a10ff2773ba960d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43223fb4db6da0b9d1ff2a68fc55f9e273aa0e530a8c12498af7bc67b1812e5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53756c56eb74d3e07a782f3a8913932d1c40c54df9fd0593e3433a07e5adba80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4571b0497bcaf1b1dbbbe972c4d13c557534065580b8f53088151a35cbb1aac3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f74ce24f388c2ba1b365d66e05d3dbc3ebac70adaec09fb88e1467d3313cf6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ea3c99fa95816951d3b606203e68c928a7b98884a17c02418b1c24c6687f08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55ef5adf4d8024a0a702918b436dc9e2f437a52dcfebb063152c47f1702c6d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d7e9c4c5ef45b9cae3900f3a9de28b0c3c7f441e7130edff5556ef43942fbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f80777b673b2c604dbb9cd0103a260d9f1cbe6cd36d41039fef6b9ab32fa724(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad5288ce6a2bf6dc3f715a333125efc54fd5539cb06676f3e805cd8c154fc3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2980f4622514c872d7fa0761f70148b04022019eb7627923d743b7ca879ce8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47c80e181519e5fc6c6e0bc4970253b3de752274fd846a829ae34f07fc305f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9a4f6e9eaac5a74068761c538a1d613e3735ea555c64bff3fcdeefa7f060db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9939e062632bab0eb112267e0e4769603c268c0e9f75308a24b8b704e419e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae12380104f0cad00a20958fcf02690ce50a01bb51de0f8d835f441fdbe579c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92d36d100e88eb6fbb23845e4b3c651bf162d52e7f29f82c84aa428e980bb4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1b032b49083c4ebde46c8172c90562305e6fe0d3bbc1e84c5487646eef0b8c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a502ed3dc4ce5d9a4fac7592ab9d29dd42dda261a0ae5e99ebbf4cea89e89f85(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25e0d8c737a410ad00ce28450394b644a0543196752b1b68845b9f67298963b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd96583a8dcde5181474ef2da6287891d5a36ff5db39bdf8cb4f243466e2f06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a825709b726586bf8aba55d526beeaa432d6129fb08aefb9305fc7c1fa0926d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565a2e54d842cc8e4216fcb74d2bdc48e54cbf00483dd095219619937ece578d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ba05e90f9ac0faa65c46e97785fc1cab5ffe0bc43ec0b98d02f6b71317917d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57fd2fe3d6df5f27bfd926c7ef3b6cbcac88668090a193488c2cacce6051f5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abee1fcc65b0cf5c7511bc42c3cdcff91efd92d3dee0bdc6b971d35e3d159ed4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c440f917b5140ff9db2e6d747125b286ba63b319f65b818e41889b02e88c696(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f6646f2ed8aa6a80d5ec59bc092c25d2f71cc94d9f78ee89bc072a01e0d711(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce06642455c54b4d600df9c43d8d86e8ff078e7ce355c90ba91a8ddd54b1827(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d18e5ddad0bb0bd802042f99aed4f2cd3ce58bf26a8e6a003f489e0fdea22913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b874ca1308be0908a6038660787608fc9faede54c8352d681ab35bf5ec731d3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348433aab0e10a856aed375ebbcbc89a8b0f5056bdc077dfce0cb61678f7ac25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c9915e7b1b1ac217684fc86065c9b05afd72f1e9a7e6920d53f8b2b64bc750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d55d3f9cf74953906e0f2d61492368048c2cab079c42ad00e4759f55b400b03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce4384ab51b8abd824d35c7986596a6f55a26c78e09db2761bfccf9a169b714a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f4b519329efd911a7b33637f84faafb7cd62b16ba2f37b7902f727cdc3e8e2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5466dd3d1f63d88900fe08f624188663dd1813feda0a1423151d2383119deed(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9db905c5354c5c725a1c31244e978518909b87627cbc5d12c4d5c5c6a7ae19b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1699d68c8a3f48d52bdec16efe5c691765d81ec3d96e4ac3c8bbe8a38f79da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58604c127fd3e53bf984421b2b84fe2fb49ce6ba7e55489180dcf50e8566e786(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53338fc949b38f58accbdb11007bfb89c7c81b54b82687acbdf21af2d4ce7aa7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3d13e13b527c287e422ed0db88f2b583939fd369fd5351d5be09c5e8f4179d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6bfbb7e09874c808575df0baa0f92f219cdfe80d28ab41d691861cc9615f8eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c9ff879d46f4181bc615839317ec615a6a79ba13dc2f157c12104290e2faa9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2bc6475e2cce06631230b19ffc2e73023a7ba4623205d11c6d87b7b9f017e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5376a58d53293826b5f363096b7c242f9d21911c70a8ef30cdd00132451a1fc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d01994aa76a4ce3bfdfb7384d9aae294ec3679b6ee23dc83b0e989a19534a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__081ba389234435e020c11836d174fffdecdf6213117020a1b744ef823bdac5dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82285b98092d5a59a05810adab3d18042c74de3f3c711c784b75f1e1ad125227(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c52cda3f7e10c7aec07503cb848dec9a37246038b49fd8e0109f64a68dcd4d75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1545b9e76d9a7b3e4646949b5a51f45dca187f84b01e76b2a14c699e6e812fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbb541cdff169b5b4cba7e10579043a565e37baa4b7e62d743e0c325e84a5672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1432ce87da481ca906a32beba39939a753381140309ce25561ccbc942e1013b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44283c53aa9383dca49fdb5a074a8c7b368db69a0b79f0c162d5d6f8f8944b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a090009cf6801830bd591f48e0cecd4039f2820ed75ad923acc7127b682d5637(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa07a7c7e0e1e1140250f1ffd3b79b1bf9d0769ef55390b449f87a0bb7d63e7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a42327658dd2ea71c73ab3c92e1f0db1d5b649314398305a585954eb39cffa2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39960b18f1252b49f7c0983f320d53cb88e4b6e5ab09706608efbcdf1ccaa13e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cc005d2e664da7d166792ffeecb4b715f822854a5a921ab848188d43f4f0f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efaab5b1e7589b1fbee3bf7c7fc1be677de1c568602ba585824029b65883213(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7727e93b4768faa99cb227ffdb6ace32798c0cfaad06171d378aa14f2058ca22(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f4c2de0ade8669972a6a8355226eafa3b56d766297b1b83da6fab5e2e503f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06fbc886be258b45ebf7abbb945dcd3d29a746ddf09b2579228fdf54a21e00a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f839af466d1cccd5fd508cd456edcefd6f8c228e0d54f71e7230a069f1d36d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfcf449fc8924eb29ba5e819de5b8591b6b189a3592049cb40009fe6b05c3fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd98941f191ec5ee9d088c7c387bac0c21b2905e5973bf32169ea663a5fa4cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f90110add250006f1986e151f45ed33f4ee3346c40a2fe162bd059d27e6029(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a091ecbeb86d426823e86d48e9698e8c6adf2dbf6d3661cbc692db82c56435(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e32a822ddc77edb1030e9c377c954eb34874a64de081aafec47054ce2eb57a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09fe9cd41ff759397afa4808aca310034d6ff34399d1483a00d21094109f626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a753a335b8d6db65479d8c87cc0681298aef19808b0dfdb8ba15f022fa164e5a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d5cbe59af757dec7e5896e8348f99a54f5c647236b1902b774fb5bf0079fe9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cfe4fd568255060e447b62fb83378752d519a01f082b1ec37f2a1583757455b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d91abb2bfd39ca8eb366e40862e411c2ecb38d74be506066a59c1bd3b786b8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be4fae7e6c23909b0a01dd880f607d09d533688b1852b6f4e1182b74d954d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f881930b3ec6042034d940707856ab9f3a626e5ddff95cd9fd72854cd23ad52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501819551458b9be5a0b40ec82b27f76b101a462a109a5381b462be3ce18c490(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d84ff63689c491a306f184283670c664fc184b4ec55ad17ef07f08cd0f382e2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6162dbc0b9efd39ee70e081c9f492d06223a544521e6f5d3cd1494229563f6e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbaf87191e0f6a83d31a7d0b3cf5344af4f5103480a55a9e3b76d3057a5fcd24(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864fa5ae7fcaf734f53ecb0030680fe464e75676c83990e970aaabd368d5327d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d365dfa9c8d3683c4c5666a4266c97c9819f54d750ecb5816fadd4f0945efd8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a934c3fcecbe23f1ce35009b34bfeebc72e53cbbd101a088ac2ea3866154ae64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d7879f4ad7637a74b96449d2863f5722516afeb424bc2dde97f8afff42d8a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249cd365c23b5df72dc96c162ab9cb53930e7cd993358897ee8d26149ab8a412(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__919b826359fd9a77a02cabfe8305bd48f009b6b520eb97a43b12c22f39a39eb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc9849b19d2f41f59f0ecb4337db2ce6854eac204b078b2431afd35c00bb0ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79acfb0443d68f6acaf835daf5fc191a27ec4238353068e96899ed1aef6cdda1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239601376cb1d85cdddcd00105058824618b63e5909499dae7471bc06932a402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f324fa1d352708b1306ec9e2c5a4a798dcc7ee2ccc7a089a33ac254e9018757f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8797db65970907a11d345077ab76422ac2a85265816afa9df0abeee648bd5f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4d71995e9381f87ad41ff7285a6d586e0bfce0bc6641197b7029660614eed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07066c5e745405a72b31ddcdb5bcafd1780371b016d7dde200cc21ccc0662ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a21302a80fc54ed632f5ec124b8f658ddec82a6ce516b414bc7dc52585b800d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2524d89f2ce45fe3b8de9ea50c289a07b33ad35b506a37067b1d6855e5e203f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c69b193e16209813c40b875d8ab6b710a2d9724db6c1ad138d34e1d976da63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9359dabff3df36e70556fed600a223b107ba3edfd70d0c67fab543bdebf74d65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903c18206e3d77df7489d98da29243e2c81752cd6f1bd6a18b88da3930a24b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269305e7e59d51d48ec34fde3224916ddb4c43568931bc06cb419240c969ea4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be16690ad52a7a1b2b6585261a02f2483210b3860cd48fdefe153762e2ec73ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42689f05177911d9a7dad1f9f9a6d45332e71e34109d1527602c51b149cf486(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0dd546c76ff9ba76107a9c78fd35ae13115df8fe14dacb922be63b71d337bcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b71b7567e4743375e975b4ad9f64e6607e800136b16b9f29fda6c7f908df4e1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8534fbd68c6ea653f3c71d1910d46e7cc0151d000c7163d59c3cf49f917bb91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7214ece1a62e78781ecd722753635efb6fe9e07e187512c385c7aa8ab14d86a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5557006d7c85d52bab99d62ee75fbf109ae7a3680bce99433d92f59a5d1b90a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3fca08f313055af0dd185ddf3b34c9c9fc64c1608366008b22dcbb20005ea59(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272f35e1aa42227c552e9013aebbba1b7891370d664baf061c040c79b4536b93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad244de12005baf059bf183bc1a0216aeb53b84b431c8edaec24477c4540471f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97bae8610cc6399dbf30cc5217e51ec251350ca3311ed677a38c491ed8618429(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a77db58f851cc3528ad4102129a96c790a84c319bc323252c9beb211a628583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e827f04be61b916dd9c9a7bd942669caeab8ebc1b1d7e0e3a763e6bf3ab66b3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb0087276369f8b53851094bc72bdc55360f582c89d9a42e39d8e633ed43a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94e6607cdea6fd86e11d39d96b6f39e6b37c181f198e8401a9226aa8672efb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8839617b8e0734c54f44651cedcc56990153da50489b2cd784ee77d33a5498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc7f639cd6027e1add89f9408fc0b39208329054ec3c73e1fbd4e0b3ccec8a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33be99ebf291d537138681d6001252009e43f1a145f236abbde8334fc22c78d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26754e8a7ea2a2f2c8058603ca5c10713387b3ada43c2a8b23b9c6ccc5fb88af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62eca33a4ce165743e057c64090bdf4245fe2d104ef202b33195fe9cd6e5c5fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f99e2b9fc899fa631acaad9ca498a2de3a9687666faa6547c4147a301803d2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d179065e6dfa35d6a16e2df3d3a081c1911576b2c8598fb3d6fe83f8d9e1407b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab653f4f48faa5f30f542ed572232407b68d841d369c7297a781876b3740178(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cda2bdfc3cf6318b3c41c1e7c878dc3eb14c3d42ca90cdb5e2eef04387fe92b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb56abbe4411e3b14bd09fcad1b3ab78b3f563a141d5c4f8e51abfe75a85e38(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac40e0f49a246adef09fe7341da697c6d10ba61bdac92b1fa21cc74646186ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c8c8b221564089a9c5349f642250680547b120ac0d9efdf807d47934622c59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f368f4536365f1885fb565708dcd3efaead89bd62a04040748bd3042b695fb7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba4f9e6d9c2b52e8e24c2118c4246745cf87bb7dfe9b92c57779c618c8bc4ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0df7cf47c8ef86c1a3c236be1fe42df28ab82be91d4109f21835ef99e66d14f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e180227284a68a0a7367b6868210822d89e9342764f5cdc81b9edb0b358e7dcc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10697ae7d78d76a9f68ec34416fe03c3e92930e7c4d551127f99c996030331f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ac48b3fa5f414aaab6ebb8e90bfd865ed2c0e601db117e745ccf884a725d10(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33010350d1c9663f41c091762f79721309e758c8735cdf43130c024a9d3ac908(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ac169a2a314d36f6b5b98d4319ac904b33f836c34342eb18a5ca7c4a750e8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd213ec20b9559dc7c2ca2ac94bef108f38ae305d3367c6473738d5767ea90ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d267417602e314866c267132f140092585ce31b7df67f538eea21adafe9e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec6818cabf8f97e82473af44a835a9f60dac84233cb9b9da7e4f528fe01ed8d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad423ad855d7a3009953a72189c5f3036381735b21d6772eee559c4017e3b4df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__009a9de77f0f1996c4f6130999ae30357d57ca198f95685933007994735cefb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9788c494ff4ece8f30997b02a43499f8cd7ab82b7ce53513bbf1e44efde6faef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1dec111b20a70fec23e925dc1fc3041ea252fc5e2d620f8de993fb3dfe8d33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9d4ccc6de42fa1154fd732229e978b23e81babf6fc94ea58f2c0dae7c799e5(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__506c5b1f7bc451cf1575946095b5546c7ec12f7621c8e1a73298039e47c4498d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c72ac37aaae4fa064aad81587b73fae0842e7508e04ec09afbaba3c50cef6cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fe81857e0f642afc7469472c815ecdc9ac1d24b7d018112b66c64ae833538e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b2ad82aadce0ff3949ceba01c8bf3c83b441973a0b5bc84e6a543a166f2aad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8b1ca48d71a367d47bd861d24b9863ecc51588ac85ef4798f8371d92ff74ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068ccb2a972d02a953d84c024a9a4417ccaef0af53649eddac981687b9798464(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f61080d00eb00c863c6cd5a7625a7dde09973f4bdffba7e471c7ec051e1efe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c68ea9992130877ab9d8662e8b94855ef2c4819fbf8b715b5e34b4ac7cfbe2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9287795bc60e63034404f0ad6a07d7e4282d8ec88c52727d7e6214a1dacefecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e1fe114a6706b5e477ab468feb93d747eebb833a24226799d2c02018080c7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b6b1e0dc6764c0f14b64c3b62f46a5aa5dbe7a3e35ee999a9ce083138a39ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04bcf17355b36ff3f90d934331ee65fa56b13ec96cd28cf0d72f1ebdd90caf36(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8adf423a63ee4c642c967140f2626284ea989dad45eb9387b51e9b055157ed22(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a39145d5540b81c5525e623b15c1b57ed6ec5df5d1e4db47686f0e186e58e9ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404d0a8c1a1d0ae6e3f1096c503f3747e6bbf7b6f9a3b0c9a552d52c69f996e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49859aa95254f825f6f9fc0a2e2642edff3aee621a4166e0051fea530cb78bcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272ece5678cfdcafa22883b43fccfe9b898938fee04554d14844113740e7d738(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c0dc4ea5415ffd033014d8dfa35f61909b49425e3d38fe64fed44f6972dc89(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bc517ceed310d7703f0f5af18d7ba73dbf4610a2947a3019f9fa96e743075ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4650eefca8f016b0c4234bf5b7e7fce731821f20176ee5db88ff8851e0a296(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b923b6f61fc16a36864a0ebd1ceee05db8662fd3e14a0520e49aadbd7d9ae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02110451e3ac3ec444332f416b0fe6ea27d1cf4735769e3c11137894c362e6db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876dc4eceb4b575c7d78275a3b0b7dd3c8826a2328c2db5c82233d46d071c920(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d08a9337755567886eeda5fcfec2c1ec51328b47ed2c38464c230b89d73f0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc9e9408b5fa84d7406ef0440ce424d20fcfd8b6093deffe49eeb646857cac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49ca1259cbb6988d9bd145c219dc40de537e4d7047b396a136f03c9ccf5e30b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abd0cf35503571cacc02e44c53587ceb0a0e700f7966ab358e9c44451a64d79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e5358fe377588328610727acea22053a488b593b04b3821f467d1d986e18bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1caeb858a0321bba99ad315490c5e1386f6cb842a6edef5fc56c8ba4c9cba91e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9211e8127ad3f1d5e384924383cd014581e5d882c3bffd7bc9ac7a7c2a0ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56894a26a373fbcdfaf9661980e3f040b32caffd9d15eddc37e8a826e678d74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a232bed0c867db13bf9924e25addc131017a29129a0ffe2786e639fccbfca99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9722419a51b919d7bd8053f5c2589fa411844e8a74efef8e4453ce5a8c82d6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782bc417996302f19ec0d65044bf6d3546e321dadab3d2ca3718819c758159f1(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd44976cd32b5010dce1475bba5fb64b90972ba8134d04c6642bcb3db4fda095(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ae8846f6477ab0405397edd7e9972d5aa115f315f69f6e8913af882e65572c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e32b2dca737204d5924208161104fa8ebcbc5e31c06594f6c741c963d5ce46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be901fb8ac99ace6f2e991126ae31d69642af79ebd8d5f6e3d41e102a1dfc1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce0b956ce32d02db7ce7d28cd72669d588a2cc98f8dbc560181867891bd8ba6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3fb8fc4b93a20abb17c663dd5120547aa99e6f748d2b38720e0b061b5c9ebbf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac48e9cd41e91bb974531560c1224e4c466f3a9046e2e291940ef3cc531fb9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d81be1800e9e137e9a9146c75170a8808cc35d6120ccf3498816512b5f88b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4891d304eca6f010cf53f8d258f8d27240abe5ed700cbac993f2509d1fdecd56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d903d5992c1d8b61c34b1170313fdef4976d3a81df22da544ce64b3744170774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f30f033225fccdfc3b74139343e7dbbc7d25c710220aebf3a45ebafdf5bf18c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd710aaa6f82f4a98bdf04e196edb4acd9299f36f60e38a32e768d28de4075e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a4253f470a0a83ec3407c99e3c119c9aac6551104b5151abc5cafd8532282e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981aa295991a61a4673d2b1c3bcf9db6970cd079817c7aa40a08b188ad9007be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ab15fca15f0a3e03f360502eb903178d857a33adcb27e345c7fe903dec94a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d78def70fdbbbed8ea2acb856419d323931239682155ccc2b7f7e0ebd9b24c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fabc72ff7fd95bdda8e9ef5784e4f29130aaa22c5e843648f0748a7d0c1e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be78b7e662d3f9d66a8199904acef0a894104a1250646c998d25fbcadf6182f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5293d74186839dc1bc8b47893b38226d832c49ee4112494f27aee4298eb78366(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3f8413d503ff4728a8ba3f82b0a9d30e669c202301b045ded51bb3dbd5c5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64be151594ab344f531f4a5949bb5e58b20d9e6b54b39e237df2374db4595d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c85312b44ada705ad251765629f7fb29aba44d1f8524c472f3eac2526ea3eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ace4ec9a43318c0084ed0f206ab0f75767bd584c02c94b0c0792c4889a4334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589d2f1fd952a305ede841677e58778ee2d83a1c235154201e8fe6f98e303e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f227af011d91f8a6ecb3ce3a02377b317d4116800d18568d6233ab081f029dc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472a8ab1b3d6e7b0ab06111cf97285a4b5753a6021ff97bd1b3f4dc4b233c995(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f433f1b681c6d46ce0018a2d933cc882b28621f1c5d93a029578b5a2e70558(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb99f052039e75c5c51c94827303a8e464c4209fa3d4a399ee43cffcd4e675a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f75be86ca1ab43cafea8a2df7926fc1b41bd85240a6e3ed7b91b84b75f653f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__267220dbf0e3c50b379e37791e08739bd6f2e3011e9ffb92b4dfd78b6ebfc682(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81389a994cce784c297ec1cf3e27889759d5088cc6b5cee5f391777c2874069d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f92b20c35e9a7fb6b705b8c795f4b8779644500bb24d40fcb7165dfb9acef6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29cb5912d2b4c3bafc6b89ae1ba5e8b75c3c19df1991a5f1f97f0a740ecddf28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34a4ea27235fbb9e4875ad05d31ab11840d45a9fb30d2401570c1dccd413b6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2cc6bb393ba93431b484604f978ed4202ac96fcce1e62e6707481816f667eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634f5ed4aba69bb54f40755997656debbc863d3d04378a95886af73b7d1c4b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97bf1d3570fae9c79713883ac839152767c5e23d9d6832f79fd6ab12a63d20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8caf9da0cd43d768384ad647dd2e645d88611727df95e983b865d44e4396bcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9512bb3b5530df7b0a68a178fbf5ae8add65e9fae68f9825bc91d6175ca38891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c6c4137027b40fe01387434e52f9a4fa302fad91ed39d596f6145544dc6296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8876c550f19e79cae957fe93f19188053af6872a9e5f2941d4f7718c160e0ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b99006cef0e2338aa5db9a6271d2bad8e6a6766fe50295bbab4023f2628c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0fa4311599a6e95ebc5af984429b4fe6d40e2d2a3da19d4c0d2c171cc2811f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14c28490c711e6de5cd41601683cf7608b41b1a8c1fd2bb3064f1cad4b7467c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f3f737e5ce38fe6f3101d0cb656d22b996651a84694b5a7e0356f66e82a7b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b388de368261ed645c6e46377cbf3ba87f93ebbde4fa1bac9e05c3b51999e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576c96fa2a1e10a410d2d0a15a03862b83f30506256025aeda62fc36316f63e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8008417a221d219810c23c0d253e60961b188d150d724b5bf893f71775aa00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a81a61cc9eb638cdf287f5bee3f975285a2e79056e3629f7509c8388650d73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f6a4d469534aaa732b6a9cd3efd55d85a73b1624903d74e00060ee268683c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4272b08e3e4545a0b22324b3832a674475205e8a9da9c20bf4da2705bb8e3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94dfc3732b29424bcab8ef76b054a773a8f9fbde003a2d3b400872eef002fe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e897eac07b8d1f6869bd6229efc31f808ecb8ffbb9241f6a083aa5071415a7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4ad2b8b58b8eb05a792ca85c81c3526c5ce4a206d9acb6674750a62d595175(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f60ac2995a2b0c1f67891241d66ced2d1c9b4631a3dc0be1a86bda868f567f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0b52c5df76a9bbc2e6414e6c48eaed143d714ff34f09f5cd86801bed9140af(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f6ba64010f82b5575da40719573fa3aa199f7104eda0c496a11a26f4008c40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8da504bc6c3df5ffeac428951997beb89bd951cdbe4037a66c0c22e073b85b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0a92abb4e16d4a54e4b401a0b9d6f71b31aada78ee4f77f5f2ece8980d1fbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b6f29e92b2123a8c73175ecafbccd30448fc669a8972df4a04694f2362ca2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56a0e319b04003c9fa19d7e19c833966171146ccb5ff56fbedde36b1cd18a76(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0042413d3d0667f9f8816e4b5ac4880548a516db22bbe7fa46a622ffd9185ae0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e951298f3ee5a7134aee69568765c19cb2e892461dda345bdf5ed40fe52567(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bcc462f913a3321d4f5bb90ca782dd562328f3e39f59d1f892c90fe90bdb258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804a0f69450cdf7de5bf049577e5a6c9813a5c423671d0fdc953740bad50ad16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdd7315a44bb7ffa55e009b56f706eefce518f6d3f6bb18757f7627a5e9a52e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278e45c75e372e737d8498ac4c3058fc4cb9020da6607904e5cc21904d7d76f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1c0a53e551a91efe362eafb49087978ff92086a81494ab769f67432a4d9233(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6a39e7c7c566b020cce494cfd1f543b41c1b664fd47c721d4be940e78db6f3(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d3433c480a5ee5768610c1e9bf60846ccaa8bcccc3a4d1a3e94370a79e7b03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997d0bf7756c406ff0b5245341ae1fc2725b28cad2652ac276ab155a34c2295e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7684d81a5a10cc9bbe9a4ebb5f41f3079bb4d76b414aa3812e0ad65d670b25a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bd7ade3095fbdc8b2eabfde973c651e28a807d169cf322d1f38e6559be5216(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a60bfa39dfe8be2c560a131b153d92a9ede35796e2c1b9bc7ceed0203c779d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3edb662e8f7a162e3054b34aaaaaa6c6bdfc0901d1e2d61af2126052f2f1b170(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf024edb17edeadb31f5da34f38141d9c2a8c8633d8c7bd18e19e327a9bbb82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7244837a70649618e4ab3ca8bb1a6293b1793482ffbab38b222bbed115f97d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02dde66a19c2427f73e6a844ac9d3c079e36d21a7b730b2a101fa2a4aa1fd7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05cc9fc7aeaef608d74c980ee9a4b4882fe561ca3d1ea6da140ae439ae2f1dea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11feedcdba12fa12076f3daabbe68c355c9e68cc2f6c961aadf5838d292525b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807118e33aa9c4571d64b122ab2b6bd51cccceccef79bcf2e38f109c618606a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc3287b623702e522c0dcd1ddeba3885a6b801c83f1d36ff617bcd0ba6d9960(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7fbd0ffc9ae4f25be0827b6cc25f452e50d57e137c4e7e1ea8f6c89338a0ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e121f6cc6e519729c7e026759b28d55b2e980b222a437a3c5922bd15c77426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18e5e9b1dc1c2a35072896795dcf116465edcfb2b2fc61bc4fea5fd8ca0c324(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f503f8f8a7dddb84b56140310d280c69de37569d7b2265bcb51aa0329ecbcf35(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb8a97f651f080cccc128dbb5191a1483d9eea5e253bff7f56dcdc1586436d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0067a02b59e247345826b7ca5d3489abe9897d395a954ba80ecdb970547841fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcb2efc4c4ec2bf16bbc11a87897cba8c17ddf25f69d707e6542e9271220fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02332b09a4c4315956f53b60e566cd77dbb59438a4abe5f52bffffeb9196f141(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e0a7a1bc7dd7ae06858654442fc7d6c6052b65b27f515c0c90056c94f0b967(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128e0b62dad9cb259dce0d3b1eff1fe5da3eb17cec4920a66037fb3444a31cda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8079cdbf25985df7d8a2d8f06b4c7ff70b52a78d81a76bcc53d3f4afd6f9b6d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf05a61b176b0289a8da7e7822dbde1ca5388f660080da5c5f8cccf223bec61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0526c0b029a06f8f85c07faa0df7bed3496e703993c0f65f1a643fc300791f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0f46f7712d94c30db9c9115df6845d1f5fd2644e8a39ba5615ee1a38b2f901(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7691de670fa63d787b120c70a56a709809456803d4d59d80dfe2d54c22b8765a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8f338f38e9e16e66183a15d3735d7e9f6df925f268430b96e58703b9de194d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79988428e7e258e9f1647704403593475456c6e9101421cd5054bc2939d822af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9ca091bc89cb00e3e3ac97407d143c6683777b03ee0eda0cf29407127eb6fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d856997729ce15755dc553e9a03c4afa14103610e1f91b6d3f766581c9d4162(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7b3335f84cc191a822e3ad48147a04bc0fb4d597cafb9401a8b3d1efca0d7f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0baf1b2bf23e393aeb64f1749fddedec00f5f2eb64736f082b86af98bc15f75c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225eec2a88c254f2b6ac18c3af24a993657284511eda8732838445fb15e533ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0c8ed8915561c02ce24abca673eb237e549eec9bd01d65f88dca52e5338876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5c7de2a44730796480725a6339a27f76624db9806a35adf10b8348741ebe91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4ef1bedfefd5c4aec0a84302f9f75428d1f9bd86cd70eb4afa9eec8a23fb84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a50882e3f0cb4628b2a5d208318426b9354a93c3f6573f6c3e21d2c15d03392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c13c7d0657a36ddc8173f5f0272b0225ae84dd37f10797819cc4c24d3b60d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845ecbacd261d4e645bf546867ad663e31fad8a98da81871a4c7cae2b9ed02a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a186aac3426c0c916af7748be8e2c4bd988d2e6d7ac3c1c9d13a23011988612f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c1047021657d77ba4e30d8c34f18b4228dd7ee9d24996c55fbd8aeda537302(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3c3dd14cd70ac771526b4e83f8204fd2186446e683a1d1c7ba751329898163(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7537af6324f420b2a9293e432ca140e519405eeb6b68a243764c8f0953c50cfd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d0e8414cc5cb2f87efba25358bd5ec26d1e91ce97c6236e7d2288c6d8ca616(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb7317e21cded7a32e87143603a620981f9da8224182d71713dcef66d33652e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92c589afe93a475f195b6edb0b07880007190ed8b0e822b0e98e3e6b016f750(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c721c854f1c79e6deebee5a2ae0150582eb6c188e9a52ec52d0481cd7a7df7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c82f06205cf271102d3e719bb1fec457332e26ef5eb6d971f9823c18dd12d54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c6636c69e30b45e751813f68be1b15f479fa7160e51b988d65970bff078a00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248cb90de4d9b07b7bdce0b927dd4eb372d6d505181e34b895f18fa3f9a62d73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415ed686d7af30590946a66ee4873f1eb1cd490d7d81e5f8c70c205fa3443bef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a378911dfd0b9e841658154867bdcc8b679da5269b5024246c18270326e19e4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67cf5a9e1bed1baf14e6073dbc47a4c434d4cec1947b22d940c389f3d8b8e55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f5ea3553b338ec2e13f3edfb03541c1fc0d1bf6e7bb3c5e0602ba4c9b92380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d48ec92ffd2919bf40344796dd8c9977aa15141685f58bca914b119de34a46c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1ebe7de976c7de8f139b0e0c4357074853b66f48e3b7b7ec0ef882da971c10(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944d927fa3b5244d3babc9032e739ff29739ed0ef5a65b3c2733136dee5f3175(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c561cc145c356e0433a6910be9e2c38b0bd396ad83e03afd2f18865a6ed992(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efa3906a3d2bcbcdacfb93e8c1944b897c060415205b36a8fc35876d2a035ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9528f3d6e8f6a3249bd23bfe8e862d75446ea8df226649178cf048fa6cfc7ebf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee792446ed6f47ab5ed7111107bd56ba0c412d1ea54c35f4b7818344af9005b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84effa208aca5d571520db1bd81baed1781f85d3ca8ff2ac541a9a9afa32650(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a3519286afcbfea73e766e5353f867b131f60780a27f29df5e7f3936e5fff0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a1b65af26fce345c4116283945d0c3558abf34f1a7a897f46380eb7cde78a1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d38912778c12a0e9d62d7f46f31f77b542b956b37864c339ce0bb8994dcaa7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000d8a1b54d8dc4fbf79cff2bb4d6df828f5e3f14c9377e1e87ca992a2cb7df4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c722454c1c8d53b45c3e6987d468c504c909bbd3a37615ad6043566ccca9cb9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5f3426d3a1ef098074d164c8783079bfb8049e304eecb119e106f114b82123(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c2e2d99050ee35f4d45aa3bacbdf7f5d853f89c84ce7541b9ce7911b076fc1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ea41c542006f48b2dd2f1456cd225d81deb2a60ebbb06a9727bdb48b5d7853(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45df24b236a4210400ea243c1e77f49e75dd9a37fc73feea5d40f6129147dddc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2f7c64901f19aa8c9f59bcff9fbc833c21e67b4b41b7f496365d388e1fd1ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24afc633b49614f4db3b8a70d51d0ddd6795c899fcd1480aefd239d98ffd42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93780ae4a30adce6b73ce3f65717fa44868458d069e9b15ab0f288695a09089d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__315f9f6a30f6b5d7395acc45794d4eda0d44959db41d64528c10cc80d350ee99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4bcfb89e27282588817bcaa9d27b28051b9e6773580868a101899996b4bb1de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b89165aaaeafdb49f41d7187a04f9909c4010775e7fe6450fb3cb5798b6bf20(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4a311f318ceb14766b550edb530341dd8a4a798cf1b0ca92d1f7fe577ceeac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f90393813c5875a7fb77b13971607934dd7f872da5f42f749ceec2fd23aaddf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34e16074f842e0684919e044b89994fd29e53dd506bdb16c1df727bb7927c02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486ec0ee921c31b4bb06253c5ade761362a75ce5f19836cc2fe929c555bfd6a4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb487c80f10cb3326ec746a112239680e19b252de472b27b807609dd47c49b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30092acd834e9ccbb38fb9f8c8e1c752909c8ec47680b4e97385ef516252cdcf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6041aa80f785c2c2985d2e57a31c7e8b986f1e1870c66e6432e913f92d9d311f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e2112c8913c3d756c7225706bcf190f3ece527b789956ec07bb586bcccff19(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6fabe2f0d684bc734f48e857e471dc2d31a0d1fe38f6a440075897aa4fdf24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718ba72375c51896d407400b1afb77da493a0b10ec474f559a0a2beb7b27b8e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25b45fad327664567151d5b1df41560bf48444651c2e47fe727f53e55aa1d837(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264b3b5757761bf1249c25627ded0118d1429ca49c5ffbaf4c3eff6111628607(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869ff47fc597654f9ba0a32e6bd395a3c5a7eede611dea6ba94367307dc3a388(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26e0c9a1225e3fb87902f879abcda9b6821a642ebc98c96ebb1813b29bc2688(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c63c0554e94c226aa4dd83e2d5b857f2bfd3c189f956bbfdad3e4291c57c3d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a071dad3aabcb9bb24e0bcc4dfb056a9afc89b17ad4c94d372dd00ae0d409af(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe50f71382e309604dd21c3a045f35ae0ad099993ef1a438bd580e4383544000(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5de499917ef11631667cd358344270d46c63fbba734cb0760cd0fb0a825cab0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d088c96ecc3a920bff9bfad1eb6af754cd99ba7d1c5734cbc40d07652eaabb96(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98106dad64a84139ff85787aac53fdf3e43076ccedf22fe45da2202ece50201d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99d1eea98bcf7f3643c1c4131c7dcd54c30a7a78ab1ba7c2d78b3deeb83ea90(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b2def30be85cccc9de4892d5c6e2a5cb1139fa4c7a1aacbee8c68b283e2704(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2693406d45ec46dd36c0152c7e029d640377ba2a4e4daaca3a19873746b1f508(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae4686139ba92d7ddde960f7d8780cac031ca0836c6693b82e8105d8c4e9335(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bfb978e5cc24ba8bf292ad22919c77731d08364065ae1e7d07c10e173661aa1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2812e037cd192cbc4964aef3a986e5001c707773706807e2172ebc49ae0c2c98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d82af6415f80491bed67eb8d386c5147f727db04d17e853402b48054d1f6f95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ffa043547f04788fe4a59a7832b36fc4eab83267d26f637ba418e700f6578b(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffea54229552410a26a434d89d458756039752cab0e5bcdff0384a12bd532de5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb931c65fd17d0955d3d5677570a0f3735a5ef700e4b64bfd3e0f2fc300f4e30(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf505a4fec0a2c68712e067f9b0144eca78ad20b9ea57739f94da6bc2a2a96e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e0018c5bcab4545d9e7efe54529c9d31623f7f54ab271c780a9ff5bf4cfb2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0546cad81e0c47caf2da9ce49f5f569ab1594f082c6c78bdf318f15634cd170(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d71a6e777c205211a6d1040c8ecdfa9067077d5930a53438910e589e30cb12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974696152176d670d7ce4c5c74cbbde29dbd9b800e8023e629bccc51ca0ae349(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368358d51838aa2188c7f56f847456e633ce5e326a5b9afd093d97f19899d76e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d5155a272abe08c26ba54b419a5b236408b12767c90866e8bbadf97439a783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63981a734d7604c8fe6ae8f937edc0ada8ee1d032779147b4aa2b86acf38b570(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7dabbe39868515353c0a465887feaf680998209b2da00eb29f836af52a5466(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589a82dd06254bfad2b18b3de2a485f877cfc433c4328e38b2657afe8e646772(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbfbd0e97c94dae22dcf01442afc8b8940b18f8d045d9d974a3515ad2ab9203(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6454a27b0afeeb2195067734580e4850e4c58ac5e2258efaad556453c1cabcd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76b17781b5afd2e1f062f51086288d6e5555c3b2292c52e3fe653c26cffddb4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0964e10aa870a45c6eac7a458d8970a181ffafad68d748004b10128866896db(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1e91bf9ddbbeef9c1f409e5e0cc75870a6051599871aecc9dec7605046601f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48db27545e00e5048c8542b2aeeeea5a62080c5dd7766a8ee16fe14891e15814(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a356e15173da732f4e818d5a1d9392b7100acebf01dd39c6cb235b946810d8d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2387f7d4d8157694b3e93a611bc971b0ca3ff901e97181cdd53fd770195dd04f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb13dfc787461fa07c49614cd4f49328deb900f213bf8f3b8055fad3ac30d963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37f0956ea53647d63ef226e6a8df845cd23fb8178b993a41441d072b62cbbd59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310889156f6eeea7b5c6437e9cb3dcf182fe58c78e87441a3f9e6a13baa29326(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbab4f6cbe62ad849aff98c30d17b58f28de85cf5ee02e8243e559ff13a136d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d293ff2202913f63683c1c0d6bb37c9f19506412e5640d1b799da640df55b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28ac9eb8b5b623fb47156f6439e68ea1bc93235e1db754b884ea571ecb0a6e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7f1d4db77d7a804420d6c6f48c963607484fa21b8ddec9fdfd57a86b699e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56566a8406c0f9675e70ea8cedfff1a8693b885ba94e1284fcae6671a3fc083(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54aec9431cb5f39be2f433c8de3c8ebed99ca1419f037dcff09869047e658d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80ed24897fa9a39279b4c6c4b87631937a7e9f8d16543f9bc8ec758096b3351(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a7a566400b990558fa071bb3ccdfceb2f7e6e588bcf3c898136fa8caa88921(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975d1e5a09154d62e4a7eb3c5c6868a98d4ace258a86b36581b50df1fdd9934a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9251cb7cacf2fa6e7f9777dab749199011cde52855cc6022dd11f88d46b4c676(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d4429f2eb34b57bee2dc9ee1125f13f622247663e87c0fd8558cc258776e0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a087971b7631fb651a2cf4f19c7b8a562c2cca537eaff5dd77e97e5abf8404(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcbbd0e94c2f956f46d43e40b3f4b695bd39cb4be8d864e81f3ec7335dab193(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b0a663077a7b9cd51effbc91ba64ec24363d40a839dec06a86b306cbc7eb58(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79964fdb7ef33fb65f4eb9753c69b512dad569bee6e9573bae0003eb1ce5be4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9f38dcffd0020e05b7d3db42123dbdb39b1aa331c6d6ff315b8d9b784258a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d645a97b0c35384b0c64a779487857e093a042abc575bca30db314abb1373df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa3c2a75b4fc7f6370b45f21c182e3a64839287626132460db390ecea9e1ee0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db8d365f9a24a355f27e39b6b724f8e1f3125c34f4e0d1f7617dc0f7f0a733a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee6144ada15ae14ce129c91559e2718a80dee871d2d05faf1b4e537beda04b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b90cf13b9a6741c7acf9692eeaab88467c41e218f5aca1830d2868526494a31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fab2901594d6a77f848f44078090962779f0f2abe00f424a337757483cc2094(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c8085c924c7debe73e43c036fa47f205f08530086e00af37e32fc204f0cf073(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b43c55572c0194901d7f4a68c621d65d6b9a683f48184ec4ab933fde8f83e8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdf00e5e7abd4cf718544d83cd39d779094d0bb7bac2d883b1e80613321fa07(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c397d556c8014676bb48dd0483d502fcab29cb49690d13df4f8fb83b122a803(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e732c0f1c8008614f62d8b995cdae88e0700ecf2d31d5f03e0504b22f34efa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86dcc5c1087ff537ba8ea560877241729459bf58b1ec49dc978e1ba31b8e82a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f704b9714c69e62fb23c57043cc273a32f18e2ac47191e4a8bc7284d984cfed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de93e3b1905e615445557138d8ab49c0c4bb3993ef89f29f9a10af41a39f1d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c599fbdfcfc50023d1be727743487534c631bcd529e27090b4c31da8b7a821a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c29e5c9bfd16599f46ae40690b199a32ad6efe0596696702f155603885e998a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8452a9546df1e02da3f944adc9d3183a5e53ce568fac81f1bdaf22511ab75b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9351a92afde4edc22402d64d2c78a54e5ebdeefd185e6992c37e44e3b1ffaeda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92bb450f59af49eb3260418b2318cf13ec361b3cab77cd90f84dceaaa497cbe7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19091315c09c61083810a3c14df41169103d4c82d23d1f79b2d3eaa3d8f5ab8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca84d2a5d2473fb64bcf68b45e929ef5ef754717622284873fdd9d91aceb1cf4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e316e707f2fd3806d1b984e5efcfae794acaa8413671dde64e85f8d2b4fd904(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16dcefd18a05b020714acac0c7c7fad4993ff62cd94a82f3da23db2f407ebb5c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b525166fdc6e4864886882fbba7de28787c30c893d059f90fe2f98ba97fd318(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3a4d2f0dfbe59fad128a809d53938f3ede62867db871e9ea62c26c9562deed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6d73d408e23e9054325937904504b08fd23f6b2145d52e240d2c4d3811df88(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5caa054080fdfd49bb65b6b6a6b39ddc36a78c8c627f8f4a2c935106c5ddc6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d468a168d3a542ece41876286c97c9fab247448bf319db4af56eda973078c148(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb6ec77a03df1c1d312fb376ae6c94b326363ee61430777e0cd60dad162bbea8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcad4e5c76ea5b4523c5893ec2c065f188ae9eafac63b1afe6f03ad215e83bce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a445ea8255a5d84da52e9240edc04e46c75f5a2f1f838552bf872886999509c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25eec169d02e48cceae34b1ff3ffa9962e2f1f0d96cc2d43e9e48a2af7c35ef8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b34f0475e115a24347df8cd579d98b1d1463d15db9d963fc85e116f7b4f6cf7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66069e2ab17dbf340ae3ef8a8ca388050d1c2d734570062dda37144b00727a27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4743a48ff4a9d3100d9753fbd7d9606b4141c82a76442bbd4df51f4894519f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e12c334e13a7700adf1b8bbac61e60245d6d98c8d54aedb4f07c7e4aecd97b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3f4fdc1f30d9a8dad9f3a57eb17dc6a7bccd2067ac3fe15f16a93ee0da6f95(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13fc60fbeb8defd82765e7b328919d135fc093364c718ca3bbbef88654d9c76(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da5ecf3bb87d334e888d5ce129fc291d97a3353293661d219c35e6e4e96cb2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f90e028bf237b6377e1189feacb10cc9b48606474bb33ee91ed239190cc9175(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd53e6755be85f599a76daa7685dd19f61a6702ad2ce920b3befc35049b93419(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c260b0bd53315878d0650be382148034f468e6a1476e9e3f39dbf529f03ad1c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5089e9fc53f99afb849b614aecb14853df8466c9126b2e099f39890fc62ea85(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dad22e8f09e58200542ce17bf9d6b58b370d3a238dc1f0a69b9f321ca9ce855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75aec14b0a355fad9cc44a8cbc5536414a954f64998452e4c9f26be40ccecf44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d41e6e5a8b0e7e80a9c808d207f89e0109463880388024976321836f70d46d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f2da5498b44143b2dc285c2b0b150d7192478ded2bf68b867eb67ccb0680e05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74718e0d4211521c834fc0d0cc69c871487427fdf3c4a08e9aff48a526275d46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674bd44a0d371628c9d83165cfa19311dc3a5f7f7deadf2992f1adc1dc6beb3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb423cab08a77289ba61f091b41caec1b5851e73be7124425d2ae8b412aab9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613bde77c8ffdc626726c1b32911f6d99bc17c756399b37d799857fb3709bed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b314b89dcd652f00aa9b7df9e6470f95f46bd0073b0f8f775f7abd5212723d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849859f1730ca70f6668041d6977b4ff24212b0fb374affbe4f1342619a9de38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4d5f543c60d429c6dd8da9ec85db5381c6e181d7eff79c8da30891d8ad0c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0387e0153c819baff08684ac549776b39c56bb55ed2a790196bf2df25b029eed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452dd01dee750abf8a85d887c14ea13861a5350635a541833041e868ef020291(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c2d1640004473a52078088457375f0458f043d8896fb05d0b56aaa1f5646e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2366a41e8175fa8ef28022ffc2387ee7ad9bdc0a3784cbea6055941fcd84156(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__274742ded4e683638ac6c7ee7e1b6f7365d31fc0135ab4bd8f642397d85a739f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3d6deab0c1534318460b6d24be720e2b8c11d80c77d3eaa28bbcc6c058a78d(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658ea4e65c025a81bdcd91be9784c5aaced7d8eb161f1d285243ddefcf0d1f43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda1d52bd078f4702441b65500cdb8987b5223833dd7c5bc7aac926c50a93542(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a7412bf30d3d019ea966ef4a5f8c0185e8399eb0c4f6f9f62f26a0571aead2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf34e626f353ec11083a6b98f17ce66fcfb4d3a27f95b55cf343efb1906634dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e75399c8f08044d4f492b44998857fa3a14e2ecfcc7a82695a28cf54f22e61de(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ca9d9e0202e126e34ad2f0888697fb00fbae787d069684f052cc812e02a3e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db5f27114817e4d1af6b8faa48e5c60943967b5ac37ebd023a25efcb14dac7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c715a430714a1927095db1e2397b6796710cc15542a12bd58e3fe14dfec54f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905613dd810fa17479ebcb473c2e6297135a9b75493b1c02a08b7b0a79ba1afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860c319fe6f74a9db951d143a0840c32b4454bd1044fc918687bffddca1a753b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240caa97bbbb60f72144e5ae602b1ac4c0d95283a7bb362697565798b9d3f942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd097c0f521e5db8a8da84b74dbd4953c71afa7236f57a65e3551ffc599c54b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad90b539e2bdb085f9ee8326888acc99af813eb568ee2e383a1f3c428a780b85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1790ecfb1a3ddb5ca9abe38d1d9e183b15c983b986a1a2f1fe2eb8d4d3a9a18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c12649bbf21355d833114f9d48cbd48146803d7aed9426699fe2a6108e4b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566c3c5d3b2de36e3d4c2ea9c3b575d6a2735a05a34099c62bb6f364929fa32c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ffe7fa69b4fd6d7fd68bc20f70d601cdf724c1f5dcb2eec1b415ac6b195634(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d8b48f5e98fa7d850e2b6836de151fb2c4ad53a0c21b4cf45a5e429fd6cfc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe08dd72958cb5fc8d4d94e146e97a29affcb07280b21612341fbb188878bd3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181de546865ccfda4ef2ac5b84dba2c45c6ed328ab8437fed34f33e3817f846c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9d4874862cd8b9871a132dde03df28b6aba8493b5105f05969968e89b6b8ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ec19117b7eae66efa3c7a744dbf0496ebc6d8931a55a0950f86e141bbe1cd3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a316327bf97a780d15daf3d02133b1edaa103839d94cbff22028b1765c6900c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67d029f5d2b49df453fd570dff86f113c19d20abb6b4891c1cd965b59151249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb39d2d32a1848b86c089226711b320de1d4363ed20956a334af737c2f1aa65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f216fe7fa68d248eb4bf4e60a6e5dd17dcd578c16308b5bc52030e2888734bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b138e392d1e259a7437128a73cffedac198a44cf542f931dc0ea786bbaa1c523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd1b67b98a9d8395317c8766c848bd35b1de355f56e179c3c8baa68ef41e2c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a0b3aff12953688961c6eac5028c76d6c677c1d2158ac224f81f154860d537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561ba25d2e1b1d25703971a742e22d3b9b2eb0f657a9dcaaa74820f6ce0b70be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08815dba1a52aedbdfeb9ec6933369c2c4490dce896abe2054d60e2f85131b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75495f45c596934978c5d1dffa159b74b7c596be1ee1d2088ef94175fae597e5(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d287a35f23c4d1e6cf15bbf3307306f3a68befae66fe527c8d5cfa95e50ed8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003906d2471813aa254e92d28cd2c1cecba0a60e963881ee3497e67477a92674(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1f7aa831100a87b558ed8ec3b3f33306175e371dbaf7d866db6584671d35ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1ac1bd20c2a10ed18bcbba085ed88ecbdba76de6f13acc681b491a7cfa35ce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3141b3c362974bf9f957d8483318699847abe126a2e332b05a55294381b5d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59303389680cfbc080e18625d09ab28e7df6addb2197d8a3133167063049fc4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__389da6281ae3e578d231f623e978885c8a7cfc7248751744eb8ad48037ace9f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20fc985cb77d96581a18485851fa7dcd5579de597c7d66cf1db4ce119b630896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6093273d32734ea865de0b6a8b276ccca0ad0eb58cbb5784f07bf31bff5f583c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095abb9c7bb88128d10332537e157c62e936b5f1287f861faaf12edd16d9cdf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34f2151cd3198233525c5a075f81b16c4249e68b4f07b2591a8be1533974b94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377b27987b3191906c329b1d217639cde974cbaee56f9434a901734043db48ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0800d63cfa29c5c8306550aca23d8dd430727076960c22d102e803e09515ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad224f60fbe6b98269c027646c224880c8d69aa8af8d0d508f7be95afd87f5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3315cad775cfe1332496fa451846a6d0a753c289d0171380dc4e13f850fd27ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403a280be7bb4ccdab5c00317a83d9197500874f3f61ff1fa1e60983538586e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec38955bb05d0aab91dc9c0b9d7887bbc5582a1711a2c4a553d46878f7fafc4d(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34045e9036e41964421b7c3fa2d5322e2a1d2af524e8f631592f2744f98999e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d1263356082ae8e348f4ad4030f53c17f029e292d2b96e34ec703d5208df8b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c183dc6c1517d9344f5c59d735569d1d8fd72393ffb3136ee61c12b0a8669e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886af4c02c2c4f7fd16d51f1b75ee37baf8c11ee6212caec1490ed0b05dc8b37(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62dcdf51924d301f94c2e7ee509c0d23354ca11248a715f10c25b86ff4076771(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faeff8cda69cbfaa4e29505f4ae6ea4ac12c92418827f1981573ea4b00c0033d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82cb700e2fd0119b368c6e068ff479e8b975ee0a6155ae2c6ba28a02303bd81c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27cf833bf76dacdacd3b85020f78d5f5ae3e47afc96128c764744854bef3909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88500e30aeae14ee4188d47bc071db4d4288dd4d95379ad20babb89cc84403c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173eb762a611f2fcffc8e032e036397f7aaf4ec6f026d9303198e90495ab4a8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c4ffb7737225449fa7b87f063f9d4c1fc15680afe8458cf55c3b86ca8e7c95(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d513cd11758f865b4a489db8bc54c749ecda28e00f50f0836dd027e92d51fded(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139b0d7328b3de8bec3f8d145a1f2dab6e31346e67bbb820599da1bde8eb757f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5539b09c3a155ca0c122639644f1d2afce87a3189a6150ad399ea0bf94c5ade8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0101e7f678d426e5c2b8acef2c96c31bc2d2032f5329295593dd594d8bbcd822(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec59b99d32085fa30c24e9adbd574669b55462b6e8b75c6cbf0a2f7feaba13c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54cb9661d68d2a25b29446fe8ff47dfc7037eec9e400d2db39d485902987153d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb5d825c401edd3462dd345d033a5306bafddfc2c688928d962f838a9b3f997(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c1aee791debb3cd0e9535f016ddc470801a21d470178609dea3d519eed8c35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85f2eca106a4cfeecf09804b1553ed321c8a44237728193e1151bd1c0db6db8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8045af63be1efe768a1e2c54e23c8e36d5f5b4f748ede0fdd97d58a84f71db8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710db0cba61c53aa4905d29b37b6b306689e9de272adbe8b18bcf9a27484234c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da23c1d354ca36d330d3f5af2c0fda7823e5867a0104860130c749be60626c93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966dddfe0a1dc2cf401b3661652bc84b255154e2fcda746457e0ef0f1e8a0ef5(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0fd4639b02722efb8c6153ffcbedafeb3e4a4473ae51dbd3292f06f040dbd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b05984892c96943b5d60eea2234451a7e6bda03c91b593d8eaf8500d3ba7bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0bd1662442d230c8857a965d5f03814a7033f980e587ed0250bb76008b2bd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9af63822f5b94e6c221b604351fc06144be914954f213328b3dfa314563dab5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4742315970302309eb652f2872af14e2db0984a573bf6135a07c26592e67e43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bf6095630472eb24bfd6547dd5ec218b0e3c2b1601e9a430242394d5b9d47e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4660fcb7cd1e77fba7e71a36f835f2962df0c49440c0ab10905371f04e1fdf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874d4603d6dbf23bc698c1f7073c69c6130c543ed8cfcb631401a3fbfedcb6f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779a8b1761b13133937bfaa485b4fbdc00fcec6f362c8872ae1449f34e65f7b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa097d591c204c95f8d82e71678a3def0586cd893780d493c4ec6b1eb5d8f96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b63d7f5e15eeb3445a610ffd27ff0ce239f202574ffe9bb9c4011bbdf3795c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b1bbd19108f7840db8e8bc0ddd4cbe498665fd0a0fa419cafd54e1a0853853(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc2d1927970b2efe97aefeb86ed25c213f4f036de0882220703b3c5dd318d12(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d33397a09f8fd410fb9bb6d5c9194db82fc8f4d655f1b34089087247dbd20d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10da52a9d93324bbcf4e64f34409be462f6a1bd3aa3de50c4ebf2d61f7eb446(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94b5d95796fefb8d4e1b5571d1a333f1a9208776d24b8b75cc815d12fabd74c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6053d5df323ca3ef1c24947af6824ea163870eebaf4de79957dcc1c4e169c971(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3173df0f0c84191e4e01b5c2d713bfcbe773d8d62bd78aa4769b87bcec3760b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb81511b52604a085608cac9e38e727aa49058a1ebecf9e6e6734933517c5e6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c150a09586a26afade291189cd88f4f95953c988411990e5c90580bc20e7decb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ac0f69bee59c292bed5420092f1a4a6d81732aa2ce4cf57f4b590b15f02cf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0868b9e481ea4b13bb150caa0f116492befe7f14d6614026d89da97e03afc62f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c41b403b16d7087bb1dd0545d6fdb0e92f002dc3f6fb8ce75ff493550baee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__562a67ede16349f66f9a680637b91ee6c46906671338b26eb04765ac42d90529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287f7394c5a32271e36a2ffed0272ac48534ff55ece767c10c6968bbb4684544(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eca001484278de9cc950b9cbeeba0606cc5211185675033e4e470c555967344(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3bec16728459fd22606c64fdf24b4e7e7ce066b51eaf728a8284d8463226d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23f0e9ad9fbeeefcb404697068cd3182a853b056e7dfdddc9e6b329e4721798(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519b64e12b1cb4be9ceb7d849ed6c6b32db3dbd962d4d7e82c314967d42e195d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2c7a2fa33471b3d0f40660ad1ffe36df931d33708f102cc91882cf1a345583(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093f5e1f03e5a5b52be158d9c8fe537c4a7a7cb3470d03e2ce5c5d32415b9c10(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8fd4664ee5976981177b1c937f666e7ca055eb3c8c91167f2b6688e6e1eadcb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5091b5e24d291c4ca0168f9ab42b1616bac740b0f510fedc538fcda650ef95b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bafe7db501adf435a61700d02847e09e69c12cc28c87d78b16491444384b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550b9b1327483d8f72bc7cfb3335d7a52ea7acd4c246840612bac7d963483ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0096515e8c5768ff95f7ccdecc653e9a8828e67b73213e54f92734d57ccd0e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d907f1943169acc2b109e9b541a2c5c7ceea78f012a84f763beceff0aec47508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3a3aa95dc19525edd7a03078018d9a0f9a0ca05b91dc69ffcb3de9eda60ca6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10855b43e36c54355e7a88ce092c5a08f1de298363844d333a9056939bf6dc96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e45a728b5f93f8cdb6e26d48d3cfafc687af77545e1e0000a4814614b255555(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea1da60b8411019289a08c7b19af372a379af6aa50e05b96af8a1eab4d7bca1(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7da8e00e83ab26b51e83de15aa9e28ec555be284bad111b4ba86afb423b2f94(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee09e1c18fc0ee351ee21c4317175d054e837ebb5ad04d7b0223cc5c2f3f70b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bead86213996639e75cda5b2371f2a90c8c14f272d7d6147b7ca64dbd6c6e90e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b644e5df532a1d963d893a5f644c486a54b89ced759d84baca44af306329147f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9095731408dfcecb1e1c2af0b0679d60e2f8df5cb9d8abeee845969f64dd77a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d03bf87257fac34357a6ed528b325b5a041bfde9cd3e676363819f9a989b03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b41021a72e37f979cc2aa20f1232c992f366a8fec1b41776f626153f49be77f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48252413223c32b188dcf0e6cd9dbbdbff96b6f56dd759643e1e1a1b99ae96b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d06313cf465b2cb8b3f11edbe94d0398d958fc42a8ccf4836f94eecb45026e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5810319c5349c2449a50689dd26bcea1a5d6e69b0676690ed20ac568347b149(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a5b4188cb32df7af010356f26303521d4cb28dcd4da13c9efb4571d6073d29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff8e10e458e3ebfdc0289ae482c8161636eea7ea9ae4b461a01906116cb08c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4eaa7413cd12308dd312f3f3a02f2507ca2f7dca27c47aa90f1cf6276965a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e532a7e99c1ad6313dc0412a8661bf53eeedd8b9b58ddf44cf0f6085126fab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa26c099082864923ecf5a64d9d72ea040bf0fdbc7ae8208406b28b3d02199d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__562f3335d6f12ddad6a1efd9d160e275ddb548459a7108faaa87e5d53ea81be7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c497afbbe1e2d09f49be8976c7d07e497756964c8255780df01db1d5318299(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__389e53b077a565496b1695aab78c41f51cce3f7ca1422dbdbbd52440e2d13e65(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65faa0b81380f37bd44cbc1bc63d16c0c7ff26fffe31f08bb3843afd2a799c75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f6835f1343127249ff1bd877086b7bf67f4eed09197f214a113581770e2a4b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112fa3c46bc635c19ab1470f496e1253750d4a04b7d205c9495029293fc9450e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc1f2cd726ec56712e17089b0bf05dbdbce512e5865b6dc6e52b7ceb4d7729b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d1368c0667573205e57735cb571f62fd86c925e7fcdfb729db0e791a9466b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da41c019cd1f272f51cd3aba583b0564ec0087e85c5a9a0c2ad12c79fab74a49(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8983ae9c99e1ec13af661f54fe16f3a6becbcbcb8a0bfee992cf056dce4ba475(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a6a2afb9f14a2988383920467ddbf1d58189ae0d358b59d2afe9827b904604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b2440254da28d1b8acfcb3b22843b255680c9619ac197ccc855842f5892d5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d9217a847721f89106149c59197e4eae7c1aaa3874b244a228c138122d6861(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d4b1fd8da0b09392975f64d093ad4330bcaf700ce568b12eaad16be09fafcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335d9b40f369b7329978a3b0ef214ebf13c0db94ae03624322344fe91a1d84df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d00283e3bd9759d04706ac53e2adc040886685206cb298c0b64e803c43d0f8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d070f336c8044b4cdc83af103afb8c414c141b758c4f5bea7c941a5fedfcf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744990a1c9c69b4de3f515fe5a5dd63932034bf667854d6acc64a76c924b6b2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f39f7afa954191cb652420003d4d91374ea23ec91a901c351e6d8ca9eb79b83f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d442cba42708dec5b8f792f951999d78d54220f97ae11311be61fb914eff345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91eabc0c8f87d70952fba7809b3b762d3fe004effd697bf3541af29369d44d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a2fd44e67063ec89889007dc39646199be29407ab290fbf7c2a670779cd8e7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379ff818c53ad376980c99df1faa79a95d23f28677c83417389511db182cb6c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e2cef62c36863d77212305e5296246042ae0b4b787bc5115d7cc8cbc6e2150(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7b8c9f1e5455dbb0f4c805cbfa38e26716215a74f3be260192fc13efcc41aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ed26a763fcea74501e77b83882e15ae9a3253a1ba64dcbdd106b1ac02641cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3e5ae2a980794e020cb47052fe2851dc7b646a4dfdf154271f1ed0b3f8d543(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f360e3691a4036499cfeb4a5b08795712f472740eb7ec33501778110a132348d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944a3ccc52b955ba04c9c088a68dd58686190f40a577d4590369c3ad7e65afe8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c921e67b829c1708a78cb65fdad2adab4b3a6c2eaa53bf57a6ddad9d08432065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256ec3b0acfa8eb5cca7500b73836a0c0be49284d644e9217c29978e0a741e0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d43cccad2763d86d892d2f624899f7de647e5df2e66e777c9732d189664376c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3842ff4d21156beea912ffcf998dcc381f1eaa0fa178c89da8e4825a27f874af(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__177a8ac1596b280b09694255a6dab5aa7d2397a2209f506554f436856bb1927b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78fe5b6826351ec9e5becbd8ef834ca8939bc69e22f59a5fc853de2aeb7bb7d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8232b83ca3c5de45b8ad4e1e04c54b2838327371b713e000846a2d19e5bf1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__395211aafec512b07207e56d9c3f1c23530d350d9e8666355f0428f37c6d7439(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba0f1e7890b25e819349970538a1e25cbaa0106be869125659f8cecce9b87e9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fac83116db676c62915350bac2650f2fcc5f1bb8c1123804cb49fb65e7d1a7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c30d92cc0bdd32d3b4457b23c6bec13e8b6b848b18e111bb796d5e3fd7d5bbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e7cef87fb4b441f214a15c0e9ab11e6768b2e72d3127362b98b0e71439a0af2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4bb55fb9a9d6fc01b184afc39c4f2e85def7dd6ace76a3137e676675e9ef4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f178245a688102304dc9b1387c214ec388e57f1febf6bce1f87bf143f8559a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d3816910579a0ad9b7ffbcae61b5cd73b724f9f96d88a9ba004088e886c7b6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fd08dae9d1a1f69048010447564026a1df9865a9743b84cd61b545f51e4c7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__755196a66193156ca824c6002def3a6217a2411a805a099779003d9fc2b291b1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55699e23a02dcf77842d765b74dfb8e4cb94ad047e590f24763389b9c06e353f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f9a5f4666718a531c61c85caef96254e25a85f900e1f7543d197343dd0441e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c902608b306d68ce7e16f99491c2841d625df6a4692d6428eb7ef7400bedc910(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1508d30338988451eb6899ccc51e95dcb70bc13d9ee23eafd01795d321b8ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30fda8ce94eb234d78c8b6eb11de1f6f888d76d03d0675982a3f213c1eb0cf95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ba867f05ebfd8c0660623ad0cf6d6de371cc43c6405683c581a8b37c68204b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082857ce312246eb68482ba9d66d5fd63f1a8d50b8af73001e53a286ec8d1f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1f66a6eae32b77e81b3c14d0aca8089cfa70dd7c10e70c3d51d19cad05285b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3798556460b0fe37eda71ff386a96bd47de66f1caba6be395199dbeb540d62bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017a50aefca7b5985e358b5293f70d70d1722959dee6068b160845987b6d1b1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88ba8203954395949808ca449971902d61f301f83a61e72113363ed7dddeb31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c56f80d1473ebec12e43d6e47c62440a9122281262f32d065cd4f45507b9ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e03f367fa44a19a0cd12b06759aa6d7f0046cc0f3ec3ddce71bf08ff101b2a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efc56fa5cd31bcef0a013e0b69e65fea582d1a0f94f14f339bb627a68f51d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfa9dc55f066b317ff3fcb5e4a7edbf2bdbce17cec1e6efc512fa64d8ed0652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30df7212e206b0ff02055312f9ee42d8015f8bf811308abdae6f78ff1cd28a9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8bf5da9d17c1d484b08cd6d03bff1837f396232ef4a30e400ce28e32dd2cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f9ebfaec3dacf31e5f56ac45ac47cf588d2cc1f9de053538a3f2f2ba4a6a17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2eee868ddbddd1ee5b06578a54d5e78270b6c30a8a71662d4f2a921c396294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f04e1a735164fb5f175bb92bf0fa1f7402cef651212919744217a2b5ff03f59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc61554d62fa8f05d10df3c15adc047fe7d3e39904036322841c84f25cf2b85e(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d9376ff9cbab74c0a1b5a8ae0ce9154d254295e54f74eca70fa1200c3ca6a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba78cbca59a26fb1cfb825fd68df111ee05894a308777f933e62e542f43f0b6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a451536d89d8a69bacb3340a8a6cc8893bf2a2e24bc3f8f694ff754641e2559(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9d01109b1044396bba9d80a985620bdeb512606e0e646d910f6cc689e8f965(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd844c9b714b8a0ca67f2bed14d2579068c742eb7fb0e15fa03918e8cf36e22c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b3c093c6251ba4b3ede0f884b96a3038ec5e64b4fd92625f7ab8d0119a648c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d96431fd9a3cffe3f569c29bfad5f82cf850ac16cb81b729ef446ad6b0d9f96(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf83d68962f8a98be73c0ada20fbd850e69c5185c53d593e2a18a0b394473997(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7caeddea81cf2fe02ea089bd8860412c7e89eaa70caf31b158cfb0b7faa5eb44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff469cf5b9f9c9cf11f70ed60c7cb2a2b6e742870c44f5511ee7409c8075e78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb995c8f2cb002e5c3d32b6eec7738712f0d35b460aa7ce1f9e03a0570e15b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1660074e76acd8125ffa56a8f3d1ae8886485f2775ef81f9fc114ad2758d54e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40200dbd2710b7b0f08e69bff18f49566e15e3f25a44147d0ba0ff8f1a2a42c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ddf32b200d06a9a2f36a1ecfaf1b186da89962bfc5195c9b3f2c2639a615e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788d44e843e3c9c1c26260ba54a2f56f8e4e4d7cafc78bb95bc23bffd00f2823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7496607baffdb73a7eefb1ee327a3d62ed4d3add41f1fa1e5de8d3b15e607740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d9e09128b63552ad9d5dd09cf353f58ed43ef376676b7c61e4d055d25e8cae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8355f4ad492a301190e348b21ea932e7ed10fa09788ef0e2ce722a150ac7d4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9caab8225e1f3b0a458ea35cbff31aab0c3b28487ed507aa7b8e25137d0692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3def4ea5ecbf34909364f402cfdff0aa23e70fca1dbecfb547b4472bc335577(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7242da3810a7c8d7a9fbf44b51168c6e98a46d74adcfe43cd4caa3fee7bc32c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0bca579a23f9c4d741d5ae8bb130c7e9dc69295a5afce9432970e2b690259f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c980cc25496fbaaf1db162122b5493166dd1687be86a1ea7c104f28ac2d3b408(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4450ee559c7c9d9571c20662a598f8f3288f7d9b3cd38b01f91f5547b8bcb2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b111fd1917cc3c95c3e492e6d511c556471df36870f81c6e784538fe275b428(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e2e9263a6a9dbfd25608e7a9dfc0bd4a6c2ddb069d3ba1328b14c028c767fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce51256e0a7c743a53c8e79280731d1bd4826e28a39483998e2624ff7b3e5e04(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1321e0f3fbdd0c100d54a74bf6344cd850f648ea9b59ab1f1ea3213d7cdbb318(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d770fa9fe73beb3e25008f93614b1cce32e2de48dd21d75d17657dc798aefb7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c322f3633c1f41bccbec8c5547d6e6a63b083190d6bd2ddda6107263422ddb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6695d73585ef7b119375c4e345f29bed472838e8d0347383b552897111d04822(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb913e83c0e38f0063861b720cce380461d5ca6d6cf9f01c089af6d600ce05b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8c6412ebfdd0267e152000e3ad74422044c1f7a50086aeb93329f215e26985(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e9db0a1fd0c23679739791cd7f0c8acb8d14ceb62d2ee50f0fc6245eec8aa17(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc59a35794759381a0b30b9db830dad3b6d3f3afe262d2f91b6679f0f5aa242c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e099cae2ebf8411b6647f4046338ce5d8fff89037d53be80c9aedb1a04213178(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe33947e1a025c41e1a45766bfe2edb015cbd41a24eb62074eb08dc4f802a13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34568d87673dfcf4cc4336d6673c8b982a895a0fb53a7126034badc96dba048d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4f597c37df25f23dad227edc67762916e60138578763801f3a0e160edbddaf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff464ac8c974b0654d552b1e633f599ff86c7af5a17764258f8d7483934936c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bf73b04401cf9259236684f841bce8866cc8e43c93bc279c5c069b18f92ff0(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e17e9c548285437ab8af8ade99756423851a77785b26407399e1924d17ae20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a29454fe2ad93989f2de9d960ceb401d3cc3bb54537445e389dbd27e2602f3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239ef8adffa7e0c2076aa507699fc85d4df87eee842830cf7002bd8dbf7c5e0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7031c4cef29bb7de2e4bb6afeafab03373ac32b0d584bdccadca3c898d44e59a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2279b8f2c01518e223be8abb1e0c276c0b0e5097912f1be656d21ef035c6596a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a714bce559032ea67c611e22257a1479ddabc2a259fb39f7bbf62cc57b8be695(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee3b103ee5b583512119b75c8ca15f1f479d533d78e9c639422e2a11cb85ebf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115a73eeab26facc5715cddc592f1123a9fa1d5b66fbcd5a44d5348132486e5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56de63a1a6ee3b67ed3bee13d0312072bfe787bb79d630d41daecc1feccbf608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069ac3011f55838a5a32fa08b1cfdfeb5455794d2ec90883262b69239d2d4780(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86dccc6ad6ab2d0fa23a27d85648c7925a83a9de85856953892bf1929b4e7c1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ea33c0dfcee73ea1066b6acdfb7e850037e7d473a679488f0dfb926e1519ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3b970af6b77c208d2ba75da5a95069ebf9e9c7b37e7e4cb9e2b3a7d36715f5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ad7837a0d847296d81c976efc6a070100d16988042446e847bf5726b80c253(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad709eb1e1861873d998465dd5c691446aff5d16253b0fe7684ee2a072edb14(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3455bf359f3e012873cbbf9d78e31a18649a0e527f22dd6e8b166c9d9fb061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8a0184acca97917695d9f6d1aad1105ea246a1ce114cc8dc990d167e61f7d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a0eb8fbd3b4745d323543d3d71450dc269f5ee1252c58252151d8b354eace24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5380f61f2474d6dcf974ebda9facc79729c9689d4626ce7c85fc976b8df60b4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807e5b430e8b9a0e9709162e538f6ef7ad2b234655daac186ee3ea8d458385fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de163b885d93762470ba6b83af1d46a6917224952ef74c9a2fa4ef1ee5335f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd26e8abc655660b40bff7e6137eaa6626ad8303330d26bc73eb73c30ef023e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38cb18730e4dbc71e17953b91efa26f31698991e2bebcc38d01254593b0aff3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f6b5fae98b42215315b1b1062b7e8704213ff236580d00652d99fe4cda05eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cadcfde3f2072433188ab2cd153986db8ca433b00bb3c4dd9828495e6406030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6230b88282acf50366ff154068303a339969cf5c9880784bbbd110a69728fc0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d20d15bcd7b3dcbb88cc21f4ad1e0c5db63e7bd00f9519cd722d06936c35816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a277c711f140ee3cace9cf44a2868c986f9d0c42bfad30f5df24604580cfae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b81fd3e8b050f740bd4c2918d3c8b3d9eb34e7e980bd1001a8bf9fabd1b112(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0097f5a74c8b5e9526877592a4d11caf2af52e5036d20679d49652bd9f51eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c5e6e6cde6b86fcab72195105b33cce9dc1c9fc6e1f3bdaa38448a40c7781e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9b9f42793fb914af2c78077b49252289514542ea8a70f27bed96d5a3b618f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d767b7808aeeeaf8b4bfe07975bb430c8ec1edd8c0be17090c1a1e999042c01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a03db72411d7b4f8030fe56c79dbbdf1409ba09356a9e6c1007c6cece6d6208(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d5466048e34253451e7cc2e8fd87ca4b0f100830cb155366cf3464cf4d154b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23ea1d516eba9b63873aa497b4e414b07b73a7b97f726d9d955188b6af8f83c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2316ccb1108fbaecb4adaf7b88ddc1abd414b3dc677e87627663cb9e6ae0ea9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a6963712abc543e9c0cebdc08165abb16b71e85e54de1bbf32c1833ab5c79e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7abe49d61c66d4784094b28662173eb9b4d2d8f5e54c0ef4bea3056938ec2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a08c9c5821b369c27de996225c55b7707eb0122d465775e369ce6f428e77e3c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212ae634d8f9cbd83f41374251438cc25bf2d382b38275975e0c528dc2e9a8d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62af0d78c4dc65a1c1135803f0b01a3b422d45f17627d7b46b20e2532a9e9ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab0bf5743cfc2965f1c7690ff5613dfd9b6d065601f6ab7f60a285eba6ebcdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0472ba389da3c370bc937d8706eaf8af5a1dcc14066bde7ce0895682ea38106a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e64e72c1b80a82d71aa4dcb072435e248e1ebd1e8a2fd89fb5ab7e4821eb3ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac297b8aa99fe9b20fe6039f493716bd5975599ad14d79f3215de8430164c84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eee277091226d88eb905bd5a1e91a5d679b7956c337734a912e47fa6a54a542(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52fbdc8ed0b47fa1d33554abf9cd3acf785fc02a25b4dbabb16d6270be79774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9604de5d17aea848f03c885ee59f59f539148cf411b97303db046ebfd52af51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3565c40eb1c19c0a17e76eb8900717722f260940eaf2be1a1ab9c4a3ca5b3abf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411f175c951686171091c0ae6b80d048ed753aba83fd46cc02612a0a045a11e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bd6f91ce10f06e80445c6cb525ed87b355b927f32122d7c240046238e69596(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d2513243aed4f36738d3c2a0521c1ee85741c652d28aa23b48cbf1886d1208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dd5a2959dacaa347ccfb376c4e104987d68ecb46de38bd7721e7c610af24fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab045afc119ae263c4363f5e740aac7e65da980cc7edf4cd5d0e7419a4ba9e0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6931e855924a7074512cbb71e1d80cf2e2c38a07ef81cf97aba50e180ff241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1308d19463b3f0647fca4f3e31e907261175c2dec08a9a0689660ac3a8f042(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52815017e74f2401c62f626142f3a1f980630315991042455b49b12da64ea787(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be205e564cd9a230f525ab433c0cd74962061598ac56b3b92aa91275e7a65d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367655890b0af027700ed1fdd02341e42325a6b65c5ec32d0821c79ec13eca08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3f1c30e75619626924be57d5985a88dc55b0e8dea33f742bee4b41f03617b6(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b791721b5d07a9f2393b37351d4c5c209c373601e77cf82115831cf82e38f99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561a88138ab1eebd9a7ada4ff05cce94793e3f36b195fbe2002c4560f1cdb43e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba012b4cc6a6448fe20de0671a0db77a79f671f86df7454acf551d0103b317e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d179bef465a4103cbddbafe190957e47c861ab87f2fc4772f3fc5143250884(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a0aa687bedb5cfaff19c582918d2b987b61c01eb0c010c9254116fb9352561(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bec8f24676971dbcdf9585ac8f1f8bd912214e075c70ecbd45b737869f587b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2de871c484073ce66dcf40ae1668af10fbb6c37bb7a12ae635d3c0efa86e73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761585772d70af04b24baa37b15a9dd39afb4ca03a5efba09da8b8b0b871cdee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a523fc7c68d17bf87f7eddd9c612598ed23d3513cd48f7abf3bc3beced5d8d4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1177918dfe7f27d539b887e6a2b454d3f9558f6050b3faa0ab62980790eb43cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0189aab645279bd659be29979520918087a6be1c02adf286e37987fb3db4e2bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f48bdf1e4d3a6895ce662367fabfee5bf68dde9f118b11c02d221591aa5204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d12ec234ad3b5e3d2778c6b44eae29929fae0b4b55424f845568a9bf4a1c56e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce432ca8f72fe948dd8c7af64e969188db0ea286572926d9650a304f905af07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658b7e3ca61a8775213f0d99c15fac116cfaa03c0ae7dea76dfdd2cccf0b221e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38403112c40913d2fae08fbb42eeef428c1186309b1de242248f39f1edbbaf1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92a478096acc4995ad8f03f18ed47ba9e4ed06f2788bc463621b41f05e44d27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c5761a0600c7dedf887d0750207685fd5c93598b63885e7741767ef6c38457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eafe230e228bf6da1edc226374a45745b03adbc04ec208aad8f7889c888e25c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99088bf545c5c8eac947b48dec2c95f6714adb5d933563389f9e5c7079b5cbca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f229fae84bbda44e6e1c47b0e90759bf2073308b141cd2f05a32bfc52a7f85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379bdae60002b93ac524eeb17001b3379abcdfaec5c010b948cac068d3feb4ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2085869b7c2869edc1fd3480a8a2d4affae8c2b2b17d8fa3daa5b39015126251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dafbd1b2a1af36d458bb6f949c4bae89ef692e33b96a2f87afbd389085be057f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00348caca8d5e62fffe9c6662789801bc72ce946199815d74ab880c252ff7d13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245d4bf280a999e2ceb01b0e47537ca27d9ccceba66d9f75b514728af481549c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e53d9888705ceb932255999e20150d5cf7327bcd58092e3ff02f72e1b16b49f2(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfd6dca2d89916ba8013820e1813ed12d3782ab43c51cd9f15bd1cde066fce6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f605091b1957da404cc1e04b0969dc12dd926cf7fd0a98eccf029795db010236(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63844ef0f487b210d73e9d52ba60048f28a8f79d087ae070d34692f9c5dbe4f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3affbe7dc9b75e2c85093496f69d73e444f52e8bc91f4fead08cec5561ef4dff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0679ae97c3538b2158936a13bd13de4ef4c5f587dc43f181c3cce3358b4fffc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d7b42eb1c88b8d010b50cf2cd0f54f4d4255ba39e0e43234cdeedd9653ff67(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ada8e3661008e7ff3d9177299b0e94ab74c6dc3f8387f1a9a318e9218ddd01(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f784e871aa56bbc413088f9fc569952e6d29f09d95efea2df90378979626c4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1ef914f3e49da4316271bbd3376d1b9adb6875dec7286699ea9a75dbb2f98f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3589ebc49a23ddf80622a7051a4bc139138434aa3e038fd3504c7205707d298(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b972dcca1b90d79bc72c8dfea1cbefe79b8251eb616183084b6efca45aa6f5df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22aa2bb1b4af6a399789f774da8c31ed96adc995b41cb11a281d58600e1d674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddd9370c2685c0df71c86c2efb817088a50f33ee287978442399f76ca4bda23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04971c9b047187af234ec9b7bdf69fc73e7e704b17ba061396fd30c765cfe300(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae9c7b3d016a7495effae73acddf3840105f3289ee253264a84d7808de91d96(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9ed73b5b7db5aa4752e67bade9bc9dbec2917743e7548522ca2f5eff211132(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5664ccc74dd0e06d5dee7e97fb578fec3f33fab1e8d169aa36907d20568ee33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d30f985924beaee839dc22ec8a149e34f417481e551d1efdac04dba6f4f91a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9edf5b65ad530d98ca46ba087f4b9b3e8095872723cdd3b8430dfe159676ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8dace419c523325ba77babb24c16572c4a81e6737a6e571a6eb8c092432ed0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327a652d09173c5298f73e0a0357ca15bc12ae00d7d1eb1dacaa87b1acf0a703(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5735989145bb9190193ebbc3e462b4ef13f0f82f3dd7031238b6132fbc8e9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464217cec508a06c046798cf7bf31c24aa477c89c322434650978725b9c0902e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55630f93f7916180c665e957622dc271b41f01318a8247661b02a7d19bcf9041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d3411230b13209b25486ca4988357e913ada8663910516821e46ae5baa2dbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf290d9de0c303059bc594320417ebcba12df26d20d759be5f5b0b379f3b4b54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbdcee1c044d7c6b89c8d704a644f935afcf038a926890b48e6ea881e272602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6fd21c03f0d8897ff7e8ef6198e2ac45ae46e895dbe7e1a88173d1a543fdc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70b15cbf9513dcf11596599b1c9c6d154770cff27209314004d85956848dafd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765e7654b580fe7c74653c8687f884afdce90079f600958b6241bea3f16eee86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70755f13dd4bc51e9f26db46f38e8db54e9fae1c92ffc915d66747464e690e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a20cf1431aee1f959d9325412b6c22e9a8af7eb977bf4743f002a2f8784ab9e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92087cc2d5cef03b637b5ab99632e2b4ffc27c4076b0820e2741278427a6548d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b239c5f6b6b18e4288803031a4e326850c6fc3a8c51fffe2d95d7ab5bad10259(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a736eb1b7eec39e58846bc271eaaa30d562d4a529eb3895ef4b525d455c184f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de5d1951a95c24d7d65ca3017b12b35c4b7759c6e00e41c2b1e198c9cec188d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2472438eeefd3b41f2a6b3019de198fe21d9b4bcc733bd5e0f10345e3ac692f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb07653d2d5a9714a064639f3f2fbb966a2b8d46042a7050c6cf6479c310a2a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc138002ecb891b4740a2dcb61ca049eeb5174e32e6c9f237b2a5a9c819416fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39639deec2ef164ab7053349f4f1866810247ff2f1946215f615e92d14e4b43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f86ea03ad89b23689307d0000fee80027787fae02a7bcca966b41b745fdadc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d41c12c29a4a23712fa09a41218c56f65cbd4a2bb4e372ad2a1a19a31e3f88b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5814cb20e699286d64bb9e51952c308958a6dbe1d3f6be0ce351522e6cc6cef(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f79bbf286e876a14b429926ddc84d950e7d8db3a886bc2627c699542806f16f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af78e7f98437c3ef1466452d2949414afe5802c33eeec0783a1b096e3b542b05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6059ca73529141309c4608924c398cb87f8c1ea9637ad1a48255e7813d00d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63f7ac698e651a04df3c2f33691fbc8aaef9f55b577d405eaadab30efd320347(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc8df1f3c79f3faeb3474637416844d8d5e63fc34b66646f4705d76bbbbf26de(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cdf41e1e5296a8cd103cba056476e5510951b76f18169313d3d5eb91db394e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d1a9e4f4f8d6e091bb74f02af26930aa25a78674718ed64ecf5a196ee8a77d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087ff0daa616764b580437a3248e46e2733adbec3e29679d951f7dd477e5192d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a7dd35dd9d0dda1a5f071a2e4bd56de8343fe530e3c5388c7ec4250ab39e28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459a204e0287e8db7c1607e3f42c420f1d4f850eb113f35f3cab3d619b8c12a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3da526ea3ba37e6debb168e4da736b7b7bf6abfc571a6a72e43fadea8a7713(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae750e1fa6632aa260173ce1265dd943072893a88cc2c80d22f8ed4a3d30db81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e957dea405dea6e3cd2a01e6860ecf512fbdec201470f8204629cc4e709ca37a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45782c6ca694f0b044b1bbc1c4f7c14d9db985dc63df88b41818ffb6724e3fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06491600faf7f63a129cbe1ac11f4c791545e4f66ba6657551861c7cfa9054bc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac309a8abcca4cad0671a65669ffbe50883a358b34a1642b4e1cb7674b1fbd94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f511f20ac6221b129a3678190331ad69909a565d323ad37ccd1791e4cd240c03(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ad2cbee2ad5242356fac0319f7f1fbd6b5acc6033d343212741fb4748e1934(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69193771591e3adc9d395d1117ec4bc7fb5df7c25520008e5eafa83262ef7852(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c6c60c61024dff32585ff7a9cfa6f5a5e60d92a181112b9106c23a950d3771(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc6d7ebdf6b6c5add4af87aefcec29aca79bfae0b578b57a4cf813288950794(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847f5ef4ad0048ecf5acaed7b4c2fdd585c5a80f32828c194a71a2f159bfad4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a12a855f089d2086e31258f11d17bfcc9baf1ad0a42f10d94d5d093ea705f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f145cbf2f452c7ebb1102d160ff06f949862ff46ca4f90a3acc74903327b46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2619eb6d34ec9170b136625b57b9cf518662810b3b940232bb37f03873334621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0c2c0c06b062897c12a4ca3b2b2d2fc8b11f0149c82d9dbcb41d5210a1fe55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ddc14be4197f424ecde40b385d11c2fb8df90035770d36553ceb21f478e13d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5191d0ef6fe54c00d1b9bd11016aef8fc086a2de0bad13f4c7815a125537a5c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fa18f985bae1e2396c5fdf717446111e9ee9f37ec8a1d6ad89a3d1eae22ab3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708e28e1ef161c1d59fcf161d06cb99ae1fc85b8daac893ddb05a231769c095b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988cb483193ce05e0f84b45f6c70ab388e796b9d7cadebdb5bfc0e03e77e2b1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac11c1589935bea29ae0ae54d16cf729d478c0bb24eda808650258b93e387406(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a8f5873abafab59d0c84e3f0b4702e4a8831c34333b32c0dac484908aaa58f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bcdbebce2721efdb9e35a185ee5c42a224148466e85bdf35830bb258b04a59(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f01bd9db2470516404a28862f9cf7eeeae2d7db20158b2ccd2d435d69987e16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adfbb665a5d712065f247491198056ffda2fdc2c1d5e1dbfd20027ef8342fdc4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3936cbf5af65928d7f915290cd52f43b3099897cb61376a330f4d9d9cff7a471(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccb57b94b2170fbd9647974a6e9c47359dfc9347af473de0b5409d9ee10b89f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c694d88a63a23335efcd854e0830a191c979387e6a8e3214024678713f1702b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c8a5ba3622e90b70a6adec9a2d740cfa5ba74939452b69177ebb754f89410a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74afe7a4fe06a3f8bc06adc76bdc9a14ac21cddc9ec3c250b62ebddd6bacb29c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ccca83acf00880fe529731dc211e97ecfc0b4bb02bdd6ec4ce7af9473f8692d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4b561471ab3189998b10b0f0eec0e904f5a6f64e13ce2fde76a8e026beaefe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e4e35a039018a2000465b95c54800e07d43945eedfcf39076a677516e50591(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8978f07dbbcdd30b7471bab96b8145fc1820cc537bc036fa44a12708d5a3d91d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4365f45a2b3e3b5ffe10d9791837baf6f89eb85635beb2ba7db36723ebf27e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abe9378ace4ea4f2e39ba7b9ea4f39766c6f8b005ff9fc7eb1890d2be42c9f2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb32089aa538710c8a912bf978cdf43ee2d8b52a41445bf0d8472c5ee290c744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890c6ada3e680a6bce9761d8f7d2d7fa70167669a4502a937f55b446dd235936(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901f951293558f6aa76ad485ae0b4df6e047c581d9bbe097a861a90a079fadae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4beed0c3f11290096b6b97c14d4091bf93450b72f0f4d2a5566007521868e818(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06cde229ef0236e37ca29e0244e545304d3dec887ee594bd6b2e7b20192d793(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faee977e2fcda3c3870320e734c2328bddb07bc189f11e4173d915bb66ed465d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82d46bf2b536603ba90b1f091996ef1331ce3680880af06087b9a06fb839d65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a82b6bab514a5a50fc4df85c3df416fd6f3495f672f17cf74261e4dcb23e2b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92e4154e4b0ff554a57f384dbe61cd75b43f38a4c2cdb4a897d4592c4c4f4a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a20e86aad3857e568c0bf48cf850a2d79b54b531b597d036c7e92c9b6be6bc4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946f3c12573a854618580f38a2642fda7acae00aa1e997076201512729b97721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a433170325ed5f27111bd5a10f7e62a75e7b7afee727347328d143db01ca686(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99654e0bfb2ce882e25be8c7cde49b9a6186977dd4f56c63f4bdfeec1d1e3f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43b2a0d96fdf0bb688a7a376429e968a6ad461999de5eeeb0f20b611572c8e0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc2442a4bce5427bcb67ad79a0134814bee0edfa9fcd94fbdb1d6b7c113c23b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ac11b19130bce63e4c05a0d1de0b30c35ad3dbac40bc88a429eed2f026acca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__510310ec9a33ddcb9b5d51b7afa30d470d2771d84096eca19a534ef3cbfeba04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326618bd8a11f35d0d7d58bd3f90a0cfe59a1c28dc387113c4e47ca21cbcb256(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e76789b80dabcedf2ba61240077117f8f40b331e4daad78ffcd863cbae3373(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc9bd483114db84f517592c7826cafe717159886008f8afb3ebe2c140fcf6ed(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6e6d6deb9b59bf94fbcd4d3dafea2e3af546647491fd07c15d2fcd79ce6e79(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__011003cb8e319ed694d86ec1e8123c434e03278657b8ca3ab23b06fab40ff60f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd776dadf54cb4336ba49a14fa99c88b2f616089ecdb91555d96aaf9050f9a42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5582dbd39477cc921bc03fc0920daa05299e5c6524d82b374ea7276d65892240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a83c045ef01fe5139545ebc3746107f11b3d7600f8c02a599e8439a00b2963ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5ccdfc2c36afa900a903e7d8b121eddff672042ba68d9347a4b229cae57dc3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26cbc8bd4324bd4bec2e9406a49d84c6b02cba401bdc3d7a3db3d60b6697f543(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b688b5b25dd29b2640c06262a5251d5488f3267874c74072567239808c747c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c944725f25b8d20f6b4c70ab4a8b5e92292e89a580c6bcfdff8f55cfe2a381e4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a843eb6f5ddd12bc91edf519b95438f4fd73452f7a6b1b59ef25965f020b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc96c0c5b7c67f0723a8854563b736e600437f8e3129441aef06fde85d5b77c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0225cb390652951b8f02925e0529ea3b6579bf5779caf927d7c1cf7c29f84d64(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6c2d11ab0870ec1d93e2ac566b68990d6257e22ef25d54b7c5f728d16f2883(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef40de9f1cea558b311fad66948c2bff034d141be35115281e1d260c5f9401de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03be71ed70a39c742d6d7993b2ff69221a81b757697c2daedbb7649ccd6a5d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a9f2b05e704b2001bb6afdba57c507c10866a8b8cd9163a27cddc43f4d17c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e015ed56b564daf49c805f5ba86cad88087cce804184f370de9c5937ccf65431(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304530f6bf4b0d494dfd4bc5a5d067377d4344a658e657aadb18ecaa6e77fe9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf910d649be5b045d2797081adc1a70ba44e4c2ad886543821c4d25fdcfb4d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c03270b6bc388e6e6bc6cfe774fc1923bcb63eb5ed1c960d51f37058ff81f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8acbda0695d1b9ed7e00cc90867f747000a1a7c0462f60f0a2f73aba5204f884(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6b3b518db65d6d231547f3d57cf506c9bb52986d5bf95a6659b715794c1597(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8461777a6506495055fd9d7ec4bd7f50fd34a538aa8041b7c8f89592579dc00a(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b56e0e99063a5192596801a51456070953109d00037207c50cce1ad4ae40882(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834b25110d507f879d992338c0a25a80f668e0d955747f665b1689e66b82747a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb3cb3baccbef2cf64b385e0bbc782b729c10a5d0c84f2c75f2b30e1563c193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c2627d34fa1bc4472014e3a129817344e22ca36e47a7049eeac483b4f9f8162(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b7184c7bbda56c6816dde7ac4a2654252e11631ccb2a2941b368823c0b5309(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d505b5743667826d467d1f03c3fae075613e9319e89e5265ece3eeabb2e5b94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb5847f7374ff2c394f16d1842e1eb63a31ab2a2aa0761fb077c30bbe251815(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f05da4084cb028ce7dc2da5964811c7ca96640bf7a17381081820463965914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097e9127123029369076d1e4b6c83aafe23bdc1e4eeb312f23f8c200268d726c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b7d1d41f5b6900da74b9d5a4bde9ece788db4ffd550789ea0f2919f6691133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0a7c344552204fd5fd3fb374a08094fedb27f66191266a2d2cd88c35c93a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd99817cbb0fc42b42ca198e5c66152af13b5e6a66dded5bf8569e65d4988b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1afad3d6fb06e44bac21c47005bae5c957c1074bbd894851a38dbd64e7e0a3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc92fcedea2a2c3d8f269564d04d111ac9bdd7161fc2278f56f1f61941144ef0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61958491d300cb655b79c227110acd3fb8b46dd86b856adb3ccd86ee72759ec9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326937832b43fb64f6346cb4fca2e232955c0f0c71ab609a3312afe658be3dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed70b6efec4b3e97a6dd89f4fd6a5804e24b5e06ddf4a74cc2026dcbc92c8b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19949c3241a489d7ecf1c6e463144e7511b33e1fc5002302c38da86c74874759(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541cfa8a03a57ea0bdc787fa98ab365a0a6bbeab41cb6b8fb7e29388f782743c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843c504c75b2e8cab0467fe7d03f0b0674b0b84e3e6acc1ee0ef2047a8a1e26d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972c4a6cc75a3f730e92fed79f1189de8d43fd25e0d07eee9dd2428207e61d3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb2a51bf58827c2d737eacd98a075fdf9616eb6c5c01fd48c25579958f09894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bcd14cc75fdf432a75c6cccae166b117025f73dff24158e954e912531b07476(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc32247dfe16965d99b85961aedf4c9db7f64dcb2410a7162840ce1d5affe43(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__259fde2cc4198959baae5ae9749bb2bc35d8719decb08d8dd7f8812f543b4cd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4187e63f4933c94e33991d0899af6654313329a15d0f405c5fe741d2e9e9e14e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a45a0d1212668487a4eefee26ac00479be426db139bf66a984d836be59ecac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27714830119ffee1ec5560678edd0e9ccd8182d84aaa0d998cf96fb7a8a5eaa4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03542f19e792455e2c3f7247f0fa2943c4fdf10d7f1614763eed6342d19ca81(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48fd7d8811b9656e92e5b2a4a1da189c65a8b76f672b870bf753ed4d743a72b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566ea3567c5f7ab449811a5be3e82f19167bd980ffdeca7aa3f73a34e91a5ea4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ca2acffeb45cb7ec3a0d8ecd2591347b413e0c01845614b74034acf5d58db1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc193c7eb71fe1bbcd358f9d4e1953d1aed55a366a671687165f5f10d41e938f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7af86880adaf738c99f550ce2aa6b697f719e2f6a42f318ffa211277e79d4c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1c9677cce70352c3040ee997620a49ad04166cf9cabf412d3e41b87f6516b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a728d669b9fda1baf398f8e4e4d9bbb9e7e4cc2d2ed4ba8fc0dc19eca8a343c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a52164af69ae3965b5510038dd59737ca4645845d889c4484b9a3efced051db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df4573d316264c61487a747562fce1f9f8b1a11872aaa4a3ca6a3295116cd0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987093c4f4028bbd9b2585ffee2219abd73275d1746162778bd7c87279c26359(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4fdfff1c3495ce831dfdf16511675df9b52e871eeeff21466f7e82cc242074(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9124d1a05ea6c9b837e6399d7e7e78e92e26c7dc655b8c148184d2aefc551511(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f481ef257fc28c757c8944274bef6262488dcd4a6d87e1b7d3cd5664d8543c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc1098ce6926da86129866cbc1e7befb22e98937b19af1812143d38b583753a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2a1f9ed99849053abddbee7b34dd49c80ad198c8e8da67e29d7bab9847a92f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c789477b324a73fd69be013f6e42db751225a7feeafa5df06adb72e38cdc99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cd660ec632cd5f5a6a47235a673e10e03948c0973ff3158ed05ce2eb56f5e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8155c4c958119097560aa5ff4942388642aa4bfd91730deb6b077f7420a247b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4495e1c70b4100b1cd2b3593d9cf0909d752620baf96f0e5e54f17031dbe4c80(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35752dcc5b83eaf5eb61705970772424469053e3995bdef5262e69e72e8efa4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f563c44237532304b3be3f9691601b97f88693b067537ba45985ec6dbb32644(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c7450ea73ddad20612d96313984fb913af1d0f8018da6239b449d85d307f27e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5474c4a787ad070a8b2d302eee7381ee748be898646662abc36b76bb6c1f0838(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d831e427426c4e6ec0c363e8c26efc1d2fb6695ccdda1e2f09752ca8742d980(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15a82b8f2d5caa44c9ec7c6683075d171ac9a213925985113bbdb1bbcd33604(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2e0e3dfb497373df11ad918a3d68f056fed3d3b5905fc4723326a55d6e77bd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f191173c50dc54e9c8f734833d16a59a1457468764b98c2f8c82f4c99e5b7863(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6df945124382ab893d0bb937d021ff98fe54a992b4053fe20862e09d7557493(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e845f55dff1d565d79884a955fbc45ed0fddd9d1c93de2adef550cc7627ab5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb7f53d7719efceed0824d93a41434321236a2e2281b7f3309d1bd374ef1a73(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fdf033608d7c79d72250e592ce195e1d6712c7ee208628f2fbbc194ef2d6dae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca2e868758c46645f8a34fa578cc76035d0032106ed54c33cf7b8f35463ae48(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909fbe3b51c90d6463c205f2bac1ec7753478ee3159aebd221eb3f71a3fc1680(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32807de8dd154058b0907dcfc545beec1a4dd02bb8dd97cbcd7f912d0f64bfda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139b178d9f1079f6a4edce857b18f795ed7465d9a98a2a99ca3dbe0ae4a7d1a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c34e1fc11aacd4067c6fd520f601fe75aff1f68f2a9b0f0d4302c6bcb70fff5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be43d8fca5e1318b6b3ead167150bb153d0e6aa6a71d2d7b4056c10b2bde568(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fc26561b2008bccf5517152e55202ab23ee0c62aa7c0fe23911e88186df6d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271324e929a668df7f467e1fbbbb3519e4c4def8c5b104bed39fbdbfae3633b4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8e175842f1149d2f9505bd9b91925e245419854b41b64756618abc72e8f400(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59510dabebce85bff768319618d5ef32ffbf7a19b3534302f4bc266c15ef9267(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935336e4e15cafe74cee32273d052c24e0ee001bd2476a72b325558d47a4f945(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e65c75d83aaeff7c58884397c15fa4347e0bc5dd5d1401f0281bbaa9aac7a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48e20e2977de1ddf5cd421470251268dc736eb55e606711f706061e48241be20(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf61741691d57238f1ff3e4135f8c740cc10a872124bad062d2a5c6b0fd4391a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7e1550ddcabb46528991551fa23125b1d663b2f24d08b3a9b865e4f00d8d0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26763f6e13188ad54e095ba14a17327f24e70aafa9246067fca58f7e33f07a91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8eeaa93bed0d3a95f7993ffd3864c937ddbb5cfcaae22e1b48c992ed8353c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea68158a441c2094763ed34043b263f59017d9c519e0245722266549e60940ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5e98506cb1b4d49c15e69577e6ac2fb030fc3fc6292fdd20a0cfa40e71fc1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7697a669fc505845b4d71f8a8bbfca3bd16aaf7dee81b226d50493246a8a7bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58b48c9dd35d2d9798aea2b9692417661d974ad7e7458f602a6889f7215b626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4dfd1da666808653828d4f96cec58dd120d9d986b92c6bdd81b0f69b568f15e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a01e8c582237bf6c8400d28d4840713e79e3760752bd9200407eb0af93db2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf38cf719918c881a771120218ef0cc47b6b1f700f9b4112b65a7fdab4c99d20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b66ceeb841535bc6f66474a064e115fd9261052b471c7ab9cb388734aa3370(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0cde9442009b08b66579fc3206e4a71894ceaa645be762498d5113e1ca7a764(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5133a12152db4e3a43409d6ca414c07683c606aeeddbd3b3908c44d11ca97bca(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981f975ec26c49cf778c0dd4e8cde199f64d90ddb8f5d14577815039c13d7360(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ff73fea4898f6b804cdfb983619407c63f34082aa033f71685d065ef4de41d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63517f4057968a7110856bf47b21000ecaecb76d00b3417b10dd9abae7832fa0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c03ab30a3806802c01ca03e91cd4daeb240628c2d146ee30024604e7b1fdb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8037da1b58a07f2fa3127d8d3dbd8e0bcb0ee0dbe7220b2073e52a8579b2a9f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec5b74e8f7a75c26957699a67284acaaa9e921da27054e46e6df154d1e286c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21844c27cfe13d8e3d4e101c762edd68a87baa91872c36fd0e9c0d2419cf6789(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957ba3c2fdcf507276cacee96d6938d5c6bc16d110c1f1eb32fe7d28f6b8b225(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d29a3dd9615a1bc701827092e51f1c41e377a962f5e9b3c009ad6b9e64672cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd371b709b43914f4a744763839dceacf0c3dc9e0a2a7194761a13181e90b4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128cca6b941368decc1e9de07073d9800a7009f177e4322c3a3775dc8d733eae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdcea8e2460a42391bad21e2155e7d9f65cf01da7bbc5cb1726479da0ba92b69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ad4195843de852b752414e1495ff6c23886984c0d828bca07b598743d3e0a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8607b71289e705912e5a458894924638781fce04033db0c061097f2c5ec3f00b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9bfea56172c63b10cea473d0b145777b38923503094760af7ec901bf490566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80bb3345a52c09d1f57a3a479ae1c1127ec9cdccfec15c40c159d1d2134d053f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facd15a8bfe618526115ea16ed75fda6a1321be69d274385fde7f672d6564bff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64b2f45ea36544928c9686777ee9722e2ab29108642eb9499ad6dab8698207e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50109c628e5a826d65fd96d6c0f01a3da7c4ace6c366a53d20d9fb732c5a4b63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5c01c6a6ae79c73bb91def59cfe8b6ea99dc5846f55818a6a644759c962762(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad25f429d8c80e0765ad9ba2ef31f2c0b5b35f610343a928e5c1ddb3c9db6d67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e6fa05a40b03c05b46cac3bb387c4d37fc333d5e4ceb5aa7aad5ebc90337f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3043ed0ad6f9e0eddba8e191f917aab96aa6539c7a05a9c375f80ed68a3585(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e5699b9e808ea51569b3d13c3964c7edd594388502dc9a13106ab6efea03b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc8d4dd8394ced61b510b8f5e92331cd19f05f7d613ae0c044fb9273be3e004(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d39babebaca3ade80727c2d6c0bcc638a11aa20c36f97a3f422eb64b2a460c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4781246e9f5d03ae4fc28a48bf710239a34c1e55912f4140e321692425101c6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871e81af90b241e319e4f284ad7b6db961ebc662dcaecd722264102debaad5c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0511341e39d5c7d3b81ee360b7f4d220ff4a17860a7ade52be5b958ca2fa1a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748da040833db5a83b2971f0c5f00011eab47b6628be4cb01170a06abcd2ec59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8b9f00b4ec6588d96325a2ce357c9d5329dc2b1258e126621b93f546980a24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ff821a086c1b674dc237521fc4b9bcc1789012d4d2b1a86f122b2bfd4a42da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8639dac2bbcefb5e19832142d3649b6debb61e975b01dab0f80eb64cf6718196(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a419697becd06fb999a667ac4484f180d5de3a3aa1fe719bf45d71494cd2fa12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c645bf9f3c8d1f968d5df5d5756c2fa55b898708067f8597166d94ac4872d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c187cfa32cb0d27affd0001a8cdf5292856e0a2994d62201e58a5cd025e698(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0bbe6972869791587842e3d8670ab6afa8cda7bafc49c4e33360f461ef3e59c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f96b97911bc38716d92d34245131ea10c625651edbaddd8687aa5e5e777cc09(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c5369b5c10096c20ce2176dfe9f17eb1a1cefe3ea22273db302a1bdafbd7d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d16a724215f87c74b7478f27e88243c1119fad32029194a17b04d85c310355e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d79a7f3269fcacd2348d629b4ac84a7327c296403b87980ad21a4d294328a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a4e9e3a6bb3b8b74caa5c50ea0fd27bc0502ee4170ea08c1227af850fbaaec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b707e1c9221d1a48e298d2bfe3e1e86b45b5a708527bbc5e75f65016ce63c15b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160894ef8b400a5d304f7c78dff8e8f854c8ce0d8cda1caf2190de91af0fbf46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0769c3bfbb90cf8453ff5e1244b038d2ab6b4dbe69d05d175243cbeab63c09c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa17bab160371946411fc1a64e2b63bcd6472b58e5b209a19ef5ff4603cb6e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c15b3d770719775d8aeedf3bb1f1abcdaf604bb4e4078b4f8c9bae84d51320a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2224b60c16d497ba51b810356170531cb673f997d7406aa3937fd8788a3535f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99f4420055c21620e2297bef6235915e03a0505fc4a290f2eb8b5a5657763e1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2590489eb5a60d16fcd53ff320a3ecd4e3f6f2cf989defdaee82870d12e20fd5(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a4c5a1a2dc85dafa1c8b3f75c872baf6c4a0b59e020ad980f322289465a193(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a227335fac0ddfd93461fefee3d8c13b153566b7c2d9ee3c914fbd31b815f0e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49e1958202e2bf52797035ee4f08006289913ab7f87d3a8410e4bfaa7ef5614(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b001752f88ff1119e7f965aaa6004f7124ea6ab1c2541963c594b918dad18714(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a52338d86d109b13b9b6af9f50df5ca903211d423bf6401aaf98fb6ce30d5c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edf6721f1e93053de7400cff28bff54d832fa3c27a8e26bc577706004b2ad95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b5cdd9dfdc2145860ae5636d8d6d9969cdf7139b93eee3a9ed185433c98bd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5dc9e51a4407478f163cdb0938cbdc1b1f0e575b4358fc46d0da6268358f0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2b6be11139f91c9508117cc6cc741dc4f5eb406bae5ec921900696eb972f1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea62804e0f840071866b3230e28680bd420f726259b8d3780073acd4273c779(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c5cf63efcd0d7b63439ba68c653fc84d06b7c2ebe712053c0948d1f44f9b39(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c260147ed1060ac1b60c361b781e9fd8193c3cec50b256a3bffcfa8ff1bbd675(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d738c19321448a11d0669041e7d645019a7191d953fa22fcd16b286f6390f6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4392dc7da99a173c32cbbeec507860dfc944d3b91a0d43976ff2e04fb723c007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5222ae51cad8cba30b3740816d3a56202647dd17799c7b0e077bf86eb3af32ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edee306500b3adc76b092d3edcc9951952ba5795132939fc7e23032b8c0a4967(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089562136cdaab8d9d611a1a8eb12aae931fdab9fd7a8e3c98ca7eca4b6dc9c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c39c852ce0f42c3ceecb5c7339769e4dba7f4be302a2ecad2de766b908384be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40aa0ac6362616dea2a9863d1ce3d320938b178295fa36ffd1b16d60fca89766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e38404af06555a9a2b64f832bfdc8e84fd1f89817f04363fdb8da542252e5336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0eb7a577e84d8148fe353f9ec5e355e0a49bff580634dbf8e368559b112fa3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f05ae0e1c075d86043f75b8f1471f958487ed326a2da893bcfd3961a8e145ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd6d1999fcf18ed8abca37215ab07331321749274cf2f9f724f4fd5a1f12ceb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1df29c7e5beed43f917ac75d51f58cd8b5f90b3b98d9ebfec238e1e97d9890(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2258c0c63c7a85eb454f7527b3beaea4cd0c79de5dfe2781aff40274d6fba4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bbd3d7ec21133df91fc3e055d84eaa020031ec48a5543f78a6e0af5d82133a5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871a82f77218966799179d7bdaddf23ef46f49b942add5f4709477dbc5d7ccfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17e253441a2315a124107f25b84e4734fc3f4ee159254256dfbeea918f27d64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d5a1ea438ff0ecf9adc22daf26f0bbdbaa95a1eb27aa8174d48c6ee527c6bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21b81223a495f6f255deed81aea4e3115aa6081bd5e7e3419886a5216cc98ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e44dc5736da0a756dfaf58596fa7edc2cce860f8cb1e7bf08640b20f69e699ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0860255b935d0086d25150301bc6b081b20a59952be8f61bd63ae425dece4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddccb9b58a5a834ea87fd3b59fcce2ece5eebfd88c159aca826ee689877a27b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42794b7aed59bdf18a994d6ea31e6e0d119123e94ba62fecb5bc00dc20fa58bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a78fd3a0082b2ae83b5b754490f45280c1aaa9fff020a5f08e70c815bcae9c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74b9c5e777618eda64a33f712015c19990e5afd732cb2727bac8fca644506c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a6aa6ae504de29b337effefcc64176bf95aea1aa223b6489b5e4d817663b44(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc47534fb29c3a97eea7f4dd912284349057d761b055ccc001ef588d2fad94d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b99c2bea1bee9150b700ea0cdf0137e7d1c57c57beada414a45deda93d2be8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed86d0413c2c948f385901a0fb3b290258664e9a15df21af773e2f977b1033ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7db66ee23797dda331119dce3bc85f51e166a01714055bcd0b1daca0778b25(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0d977e35b82316fb1b1afd54ef02e9115501620428dcc59eb58ede6bb41e0d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b820bffddcaa80c16a1098d5f2a730e7e5f78965075c9c349e7cd9bc69c74dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa449de9f6f4536fe45cba6bf0fc1b21cbc29b56efeda9a364ef799b15cf3117(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ffa5feb6e3f78422b4339d64ccab83b850c5f733f9efbd54af88940d616cf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a1919c810dd2e1b9c28c2f0068a898047047e6b51030db2979191aeb69c561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d15bbe2a066388b55370c3c51d50ce1cc9a6d00bb690d217b1be036ddf3543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041d921c2361b1690a2dfdefba5e5868b52af89008c963458817ef7001a66c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33615b21c652536f4f72ad7bfe0931a324b86158e8a3b8aac7b7d3e0613c0fff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9da695a3764fe8d9dfc13e380aac2cf285822b404fc2939de8422ccc4394122(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5b109e7d910efa33059643ecba2ea58a72f4acfa00086e60807624d7a8e89d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134cc9b1b98d7bfa6124cf5883e8db45fddaa0cd3998c6ab133328090ef93a39(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375adb0bdbf3535ceeee464e15b5ace5a99c9becf4f5539b1c9790d1ff634f29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b2234e7dac6476132ea5c5129799c4b86cb77d4f56389d678fc4ea44866072(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22419482f93df40d2d7e6e1d85df135d1d7489a1183b237608cc791385a51d3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4867c52e88025fbea2a42b63206d3d0b7fd023660efedd04d689dfbb77f48229(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caeb547ace8bee2059edf3ceb613a313ac76182397be95791e66f61046311453(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81532c46edc6a13c85dbf54864d91164f4eb18767fa04afd1dce8262729c7353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9594ae94518e08767edf30ebb36fbc74981edbc871b0440fb99c26d39d610420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a40cb12ed7bc7954b2af27e5207b986956fef8ca95596106c9a1f5271af2869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db70fdb981b4065965fa66a7179cf5401f977c0d6e00a9ef77925edfa931e0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19904d8d1a24952f652e3ba008b9f51952fc00871dffce72f21bb48c746531b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc30df001ca70a27e365fa7bb2f996fa995dae9f52ea800b05e3a5a9b7cccac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf802dd5c41745d0272d791d4a588f75470e597727ada545ffa536e43325082a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545747a07b0cb849f27aa80d67c9a9680435f526c8345187c8c984722fc1448c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a85277ce9cb45b04eef1baefcbe879cd238a763bd75c176b8c5bc2c324ccdea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c352f05c16d409a8d17c62f3b15238b667d89bd49edc01ca2156b06d10a3f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d966a34a2059d5db453754f30d1036d169117cd743fa4ce0008cfc748e25c092(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea553c4867402d106112bb4fcd9c75824bde02d4d6135e260ffa0ad8704a1b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f18748208e53feae456709bdc162ec2a09c5634f81ce5d72fac3bdcbfc4b78d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f9e7545677928eff10f1246b8c31e176147c7416114903b40e4624a8736602(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19effa7e3be55e54cf0eb53d597ec688453b338841167c34c36755817288035(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5803fba9e8a4b806fd5312628cfd3a53de4a14f4f4a45cb64ee52babaaf19267(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08e752459d410de8611c4447794a51378bef4356d705b999961511da2a88bbe(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f284405a598a36381509677524bd3467ddbff215ce9d38c4d09e8bcde80a5b16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ee86cf2b8bbd02c590356f9940dd1bc002ee45784898373d1cf456c944d515(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1ddee508a1d81835220d07d9b85814cf61276134f4fd1c95ed483f5cc3f747(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049f2de6d38ecb3fbe2c0f27f15c0f9bac60c3df7bace035b01893f09f2b160b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921512722d44fe5824f9157c9081bb331f24dde56e181786a00fb4376cdff08f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86d2e3e07a66d1441960fe33c1896da5c9526fd36fc9ee85446e3ee13f57d96(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b30af7ac236180d97c6368c51010343dd1b543f0fcbfb77b4388864c58f7e3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd46fdc14c10a9b89ffabc1ad9a784b39359d49346fd9335fbabbd9168b223c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65612f5dd57be613597ca8e938a799ab39c5eb853a7f9a8580c287be1d3eedfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd60de2698c4640a0965038a499047a7e513d08522983646baa9631f201053b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c57105fb3cb70579861502ec857f6b7854abfa23059eba3eb2fd0bfc7767392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c86711c74f0df43915fc47569fbff86dbf3f31dcfd277b8bba6ad1ba6d4d85b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33392c0b8522e71a61f36ca8e342d1223f3f1d021b674933b5d0e1a31934ae73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb36c6bafb3914af9ef6e5be9565add2ed2b213e6c2d8bcd7f3cf59b4b4d40ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91b742bf6609140c70cb4916f8cbb773b76b114ed99e3d075d8c2242801c744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb881f561b8de1115569efae11086b638a3d182cb6a784651838f231f2335aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f3fcf14abce9f8ee581e74e6eb7c6e1fbdb92a68a34580d928262a4fdd9495(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc693b414207ec057a5c42aecdbfa8f41623a92de91e37399dfed3cef268352(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714fd5a93f46fc9d5a915364001a14953d90337bb2c432c989ba1f004b167a77(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb698f1aabce8c1971093c49c9f68609b4dec88a4134817bb169ebcb83b3428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e87b2ca40f86dd1965ac7824571df0a7f71161b82826f35cf2025af1ba342a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e53e6706978a26d406cef2870774edf8ae6696cbf5c821b6e07ffd1856ad651(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e78f8a8a5bf2529049ec7c887a3ed96210005861ae9c4fe150f44cf4a39fc63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bee916f468f1043a7185378499fbaa0a80b40dcfc7ab4f9f78cd96a72ff2dda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b8f97eb51ff6bf53f9805c6d188de2db37d4fdde71dee32c75d115b8e8b08a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f426c284e956ae654905d776f5fd671ec81cb68332d6d4979dbe5ceded1abfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bba5508a4197b45d095b82b9abc3c69fe059acd3cfd321890d98af318340803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086fa1c394e02895e9469d53ac36a6bb295853813e8159231fa0de548170ad41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d786dc22c586b61b3a189e87acb03fe9e54d2948d5e38317570ae6f4d02e607a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92099e9a2b346aca44fa3b45e6c31cf9fbb2359a96c1d0e43b41829618bef20d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__235cd306b354115048ce6c35cc37194f5223a5a8d2877855e482cdc2567b85fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573d218ffac066fcdd40c16f2a2fe128837e7dc4766c3decf523632fc63f67e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__405f367005abd453d574657a89884003f4a801a781a9e14528448a5806ef36a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6a9125d35bc304282e142715d71e00539c8672d587c9543f86c710e0b6c6e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9602fe266bdc1fcaf71a8d492ce41b94eeee4c0224919c1bd0b96e6dc08b6fc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185a9e545a7f370580f240dc47c97c3f6482e040e5e0e9a4f92ef2c1aa46e110(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774bc67ba91edc563b380e92634c73bb690a7e4b272198e9d2a2cad724648f58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5eb0104c3c067597685c2a60c5ecead921788e583618781b249f44f1646869f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1980d6a401c184b56ecb18c82c86c755712f7dea6df9123e0ac92bd5d158b122(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91e8f93ea1f0b84174ed966129bd0b6c2a1d0223b6660baaa76036a821da6dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a996bcd5ddf4907d504d5e608fcec009baabc36f8c7a28e0fec6ee1008f23d09(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591beb58791c353cc488e272afaf8f6bda7a9840a6e02fc4fa4c4e884f923d09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97a138d0a530438760865a806a9bdb45a89b6512e8e0f193773d53edf9aab055(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0c33ef4d13319395094805ef82178ad7c88e6ff090167ee9ca2727ccd2ab76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b7d362fe2dbf16aad5d4cfdc8d99d2df7710ffa408d4b4b359909e67ae9d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0246f5f7e19703f8dbaef8763f507c8b83abc2cdbf62f93674eabadf5386c1af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e07f0664fbf4b2864a977d6fd23cb16d7a206362654788c2bd8bdd0987e41cf(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0290fde695a20aa8d6d925e0b6d141c16e4c1ead17d5e1b6a6a27fa78fca76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def151f0a900fae5c4a47d11b37f12efd81c1c5812168b190ac5cd5e727504a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730e0e0e25ee17900f5872f92813654b31e86defb5327485508c6a6f251925fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9366d9db047dcc3f4ff2799369b8c8e290a643692cd31241f4aab3dacfe3e44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3a8b72d87e6c3819aaf20d690d38da62fbe561037218f51f31c3bdc7e26fd4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c06d029116c1e613484697a7cfaf4015c97a479753285d6d71d75af6e57eb4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93f7f2b693158db50ea8f92ef27a136dae0454722f500ef0351bb393cba1f9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bbe21d1185671fce9376b10c8146330db46ed1845c2475c55e3f5dcff19855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3e34441ba855ecc7659aa0850f4b859f07514c91263b328eb0807a87e309bca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b5e60dbbd7236da8b447e429bf0b9a1993f3b05b88e4a1790a85b0f3fd8417(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba760bd7b9ba02badcb77b5f4306d3b588c3ea0619c66adc51db0305643aa378(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe0045963ff1aac986af53e433aedd0ea5ad3016e77ee674fbde4189b6062c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7beaf3480718f7a847f8fc0b2542f0d00cb67fa07ce42f08343a65448b536943(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d32958768bf98604965a7f5805d1412d89d3bd2d91efc39e9e2036f85f71cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0371bb40149a56d27833005a274afa40dd0b59a99a8d80a785728bdb8bc124(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71b3a4b57ab1a42a25a69612802128f393661679d1ca39d2d860678c3c1c333(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf6b8e2df1550ee037223b0ff0f37abc0a40cedc3072b71278c281bd20ed3a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__334df983b1b49865bd683cc2b4226a81a3b2c62a4f54b2b75713f812bb838a90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c99cf33af2ed18340fc04fe0df79c7e5d57682962f89a1e774aa39f3271386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6783eb176c291aca5120a1963ecefbac1135b194817c9c42bc028987c9a686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98aa39a945085c7a3f9237fa93f3d27b0927f1b440bc94aa8d2d19dad5fac9d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733739bc03c8bc889b1168e1928ae22cb8c551f677ae647e39b5db4405b5afdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91942988d932a91bc5711d8da6693dfd5dc8157ec72646bcd2bf4cbc381a2ca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d9087b2e3aed7d1cadea3494638c33750f1769186eaf62dc18b34b4ca3f1f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e133923baf83c04ba0529b655022162f62ba885ad0e1c6f7af850b9b577cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a136a2041fd0787236a29269a3037657cc8490dd3576607c326b486894674d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b43d90d9cbaf0e42ef9c2e95b54918cb0e7d6182ec2f03ff8394820b13017215(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9014dc337d2727e0d904bbba4a7778466aeae71ca2f92c6810fb1216111946d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534092eda5282d171cb24fe35f4dc10afa41059e0e82c314c46392d5c8bacbaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee0149ec0dc760c487c0b4b5a7419fb3d9d8893e34c8f8d6ddcfaf3a2102b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a112ad91fa362ba4bf27b19bc1b1d7d1ccb8884512a52b3ccba07c7cd61564f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4f17878a216420663dae1c6896fdc7c3ae75aaf0b5741fddfcdd3263a79790(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af76bf95420d30a18ae167a3594d796cf464e5f5a651192dc2291fc0e5662b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c95bc09830d1991409bb06e0812b654ceeaa73a38f6cf5c2dd411c919071bda(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e139827f1697b8578ce001ad899e5d42cdde070c2036b0281890a26382df0eef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4054314d4698bf783da650c88dac1e8bbd7d5e998ecd3cf0ef103bb309ca8837(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ebe716e7d15eb7a14bec371b7f7c3c4d4ea96133602626d4e05533b836806a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9cec7b6ab47c389cb13e240a7fc6e0bf7878f8244d46267b052c236218ab448(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69411cf9a989d606dc8ebc505ace7c2157b80a1dfd581e1cc26ec3ac4ed1788c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f3e2e838ce7d561ba206fa03d4092fa154efbb1c53dcc75dee2d4b2a08b2966(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d9745079d1a85561d80f3a872bb55d860e277a0116c5b6aaf5f28f19d45c4b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08fb1edda37cf501dc4b248f82c50d6dad56fab6ce40558987ba501153f1164a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f46fa91a4983cdfdd0a6866197cb1b55f001f1fc60f8ffacaff49fb21ad62ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8d3985f1c63ea7c3784578a167130bff4ed4c1668ec48ae13345769075e3b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396c2f69d9f91235e222537979bd505f11627b96593c44e775b8fbf2a85c6d15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0693a4286b251bac28f6e5a025f1ea38b7cdc31dcc49d9ffdd3c6b07b327a58e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bef783d6add4a97d43dd6f3013f66f4b167d29a1ac3737fab7c83f8cd4fcd7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcef3f2119f5a0e60564089f62c786fc261bfaa5651d53b4b2ac6388a681118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bc9200963b92bd69317e90efa2790ebf8fabd92b3917364027c7dedee50335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d306a1abfda4dcc5700956f53c88cc68ce8871a0059be466a19600c750f576f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b731dbdd7a8af9897ede9ebf8008b72e00f2267a94903de85b3d39b97401907d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4660a6e8406c940446209267a8a9fb89fd9dd14f0c70c5935a8dc183fba8b00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08da77fb4641308ac2ce3ff40cb2b1e76aa8694c9f055a3bfe5c2cda0f14c163(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986336fd64847167619cc3e2e524529822ff2fc48fb8df4b46724e799e013dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95d706c1fc41d6e2148e75f6cc0c4603d3f934d6d3790e911446f2efe1f2650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db234a7fccfaa9136d179b5847c15bc5d166c2bc6df573547b9883b2be5d576(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57bae8c1ab016d22cfe7a417c08c4bd4ea69e769a27bd4267b62a9a3c2ad431(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ab919ab93c1b7ba9feac3d0fd60b0bfa909ef8b4037a2d5b162dcaf270f206(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b340e5e3950d3ab18a7799bbbff564303734854e8cc3eb2a1d1ac9349b850fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32fb6a1b35bc021646c58de602c4b749aeb850c246aec64a98f58a246626930f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a781e9a3d7fdfeb0f0f66762427e5ea86c47fbdda8321f2fa1c12a8198d4db8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf30c7ad1f0d61e4b6636b3c696854659b89171346de34e3867863f39dce227(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c840baa9fdea0942f8f3d96039a46c119613c29532c482cc3772294342c02384(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9079fef1c3d955de784b640174fc6ebf336a7145eff3e7b27107275b2d517439(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402f435400d2fb9043a56e8bbe4709b1854b05fe7a898eb4c54262811cdca1d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec22fc05efbe60307c4694cab6e50a3fc56758ca74f2b2c6a6d6023b0c67715(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d608d209a1bececd525075f7b7d8f03dd2b81c7e3de8826cfc5b80e6e27577(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea9934ed47c32717d3c8045f8346bdd494cb5632529b7f5adcaecd3614a4e3c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7c0cdc72948525486a28a586af98ee55762f70b5e855c227dd7c74d253ba65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee9196cd1471c2b9f66447c1fda3d30f6310a0015cf8ee08b9186868a2372d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea63600cdc3440b4fb8b9c0dc4432cbfb890fd13571acefad92bea8391938f53(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0588fdb4073cbfd38437a594e43e641f741d97177070e4096394dc3841224d1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d8cf29ac7f5a0ee4655b78a495ce7715c601e8cb8adde89f4ce49084869a64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468c1fc05661686673e86422fb551f13eb78cd73d4a432de414aca28b988713d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a8c88aafe56bb2f4a3f671fc7c2ff0e01b51241edbdfd0c502397fefbe7760(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f989e23c0609425a4f28cc4e5edda69f9edd9eda3750ab4b10399100d50203(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58077d1eb47df72fd69ba3ee29f4850fe68f3bd5f7f1e925537e0d9495041675(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e39a689572b89c45806c195938725042944219dc2e0b58e801f1cad24e32af2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c335d4cbe79a8edcbe6bc8fd57a918bb4b4fcd97d4451b52a74874d1660132d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4e2095064cc6f91c8e2b7c0f3b2abb45246f369777a1c4f95ad5b5bb221b72(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1a2b80748cc935536273a6b8ab229187764392beb01192db853c02156b926a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f886cdfd2a400a756fca772ac12307762a03da07fff4dafb19d864b7887bcb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45592a0ba5d1a9b826aaaba44ad1a3e8ffb33fec37562afa4a02f3ca89be1c4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68daf245a48e32d56acd24e0b75852eb7400e1b01be8b19c411ec2a9fcfdbadf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d40e278564f5724b878f8a89810c8a8a354f6df0ef074a2874035b52a5db3d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22baa40d88c01d7dd57bd2b1ab60486b78fccb505a8b2b9d5daf8cfd353dfaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe76df6503c84b5b5a08384c0e1b1baf1ea095c00e0ed178a6b2e375ab6fcbf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aef3165a5f565c1bf221acd83b7619206b8afe5784026141a0c3adc46225f76(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0825b094d49a32afe6bba3dbe38105fc82e744005186ec0ff3de733b025193b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6075bb8fdf28e9cc85be089f6951cbf2cd7203e1378e938900791353876a5339(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7026ab4c1e58585938a9a91039ae1aea809c5bf2d596fc8f9d79a530166d8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e780f52bc26a340d3d5cc12d1cca6150be48b17e980c1cfd6e356fe4521a480(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55a523bea0e448ca7d9cc9958c4ebd28baa5673e7a062be7d4a1e7a2eea746c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ead6474810f3bc0aa121bf99f3c8a309deb75ee74a5ff378fe0407385cad55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a43ce9a76c8fd3646cd1a863b93e3519f91b29fc1a0a2b0bf7e6043daf854b38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c0557047cf96c660bfea43328ad3bba50196868852f3d3eb3dcff77cb8633c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca7ea62b5f403bc06d794de639d645e15626722e78a2561ecbf9236a8a6d6c30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4f0fcbe543e4f8e6f3317e9a0cf10b4912c577d287b84279911f1471d82572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced8c33ef5f9630bacfd6dbbd581ff0453dd028b335ac5b8e44bbfc6a0176304(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06859ea872fdd2078d7a2290c5563920db29372bc8142b20425508f79954128(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7d36f0b9b28fe2d89a08156732f586f9cb75f537984959d68dd2c2e5095e30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70011c8f8b337a83d415027142ca1e785b8506779882e3f2f16aeefc02b3cd3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c931e35561584a4c053b3d04a6fa6bd28d7c93ab509b2c7fc66e444068f640ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ecac83f56c26a387ccb18c3098a06bd9c221fd3a13169015aa4df9d30e8ede(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17ea5e52ef4695f532c5f00db492fde306bc56ad2e5dd9b4f03090924b726d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35248726141ef72510c5e78c3ee118d344aee47a768716808008754a83261de3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e297213135e136f63f37340b8d8ea9c0eef2dd3fadccff0a7c92c90f42e718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d1849dfc5d34e7e1393a814ce8b59836f989917cf14e04e6c14f70a3719ae0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5432420cb35bf2de7f93f7a89751b56d4b10469cf2ba9000989a3994f53f8cc7(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6db8a262c94bf02ef7e43f9b0fb4623862679026c8dcfb40495ae9db4eb88f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f929b76e68c76edbaf058d7ec69c2a9b9e9852859ebf1951a5cec48a59e5201c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca9f8478330e24d43ea148aa0e4c0a34f6792a0c3a1e030081fb6192c83da01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc12040e109edbc9ec0a5341949224ea34e8b4b0f58817ccfefbfedf6342772d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafa45e2f36831e6069eeddb83bc2d608145da8d2887aecd30d7bee228583814(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f411ec1cfa7ead0bd732202f816b2e53aa7c52cac426f7ea238e4aefd9ac599(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b41365776fc8ce14d7c34998b648f5ace04a916c11bbe215af00c0cd4e56c5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1832d9be1ab670f051e7310abba4195387d422869c9a47030062a940c622dee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830199475aca94954c4f1a666b621d32dfe3a2748fb01835ff7f45a17d147643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe4377dd0dbd3e3622259b8d3e8fce59eb8330e5f37d471809d37c3c0ac1c2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f00b193e8cb0c518701efcbfb4938ddb94a50c2abcf0309391c3079f8afc121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72a49b60a3da66e042c7bab322e91eb87d7f61e1d2cd0c5de59ae317addecd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__179c5701781b1eaf1b75f9976b144db26ef4dd2400c0d1cac8135024aac57bca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07299fc95f591ddb93a7e8b5a034df3b9283aba6f6fdb022b233a40f2b2fe81d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9895dc43a42b9311e342affac313514b12d12facaa4966ba5999c6339a5fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f1e3c06dcf2639568d44ccfeb8338be4f9338841eac3cfc4d66584f5e6881e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954016e7855b575fc5e144324fbec183689a78e4b6b9fa03a0746b5796c1c46b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531921adac5547f453bc73ae063ff2e002e2e1f8eb1e5b8add98ac1dd0aab9cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc92ff010ac18a0ad4d0dac32f0fa5e6f3f4e69d4d975a856fe224305cd2eea4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024f33fc3890c31ab89d764f5ddfdd43a5850f1ff6b48d6ec9e99f56465fc03f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4278749726cb6ae9bce102466b49422204ed45ac79824da56ec3c0292bae0b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c952f0c77fb152b1df183901bfc411a74636157390093f1eba0a4c8e329d50be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb35bb9688f9cd2c900b986b84b01fe3c7990fe07df2001dff8ae7d9cecf760(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7f33e491c62ac15e54f859da3b1a8e75d98620f76b8c9aa40b16ec4d108af0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f2ac697f5b312e1c847592e8ec792ecd0362a08102a2204086ac85eae63eb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e3bfcb72bb1aaf71666be154c9003b2502b6c7e69ac8426e70f712fcc4436c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442954502d28f820eea1d69aefe4cad3fccf7df9c1aa339c0f9ee213457d0a8a(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fcb245ee024f9f321e73857fb9312a769bf81e1f2520c1ced51c65a7f45ea0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b816dbede46fa653cae362ae30d815ef7fca69bcc289849e7ff03d1ef2eec2e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c32317e54e60f554da9bf368271f22c183043624c4d8049df9367ed3716acf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7547c441de3c37201868b5731cf60ece0b9d24e52d6947049206a6bfd87263(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04026993284994c1d8b3af678ef9fd319f9bd582e203bd27511f169547638bd2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a815c5891956c2a81d956eaf3324ddedeff218c61c84b8580b739f52567bac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e38b052468914cbd22a616adddef693e47194715b2718fbfbb09bc5d7a94aac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e4534fb46101579cdbeebfcb3127c73fb446e7bd2745df4f7f985ed95a7bc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50914fbb6bc216e77c6771d6d132b0649c65de215cf4e3469faf81b38aee1a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8410958637c790066f1f96355d6a3bdf06afb1a875f980ccfaa65d2b64dfadfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb074e94fe5dc2a0f6a1e5d5a84fc013cb1e21cffe823b7d3f2e86b9a46e660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bf94700d25b5bcabe4b5803648d8d5659a1cd2b756f8381bd6aca480ec2358(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01204596bc510383d65989ad51979a45bfcb76d0bd87d5805059926c8b59c444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa3e24206619cc12bce22c06672825a5f993540ef5e28f463880fb110cd319d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a27a6826a883d7e770b021e45a8f0fa9ed4ebf5a5e1ec1c128135f026cd695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23829001fe8e4cfdfb1d021ed0065b4d05971b9db31878518de2cfbad366966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd597cd18a7010fefc20c52850e33a1638d76eb4a55b0c8cafea88647989672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bae826a04832193c05a2c88f7702e11e8e5bd8f16704dd3af563d9d3c7e5525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bcef8ba1f24c7d8cbb76457c07f39fc013a6439086a5f6d7ac3bb8f6fe95604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac2b5b144c8888e1a67314cb433ae3063f267aa39b41130e72c17b622f51d75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7fb3798001c3de5b711ceaa6727da975145ee0c615ced24752cc7463cf15af4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b032713653b702c23b14d0eb9b22feacfd1829c44bef67eaf2973f688da1e16e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee4677671ecec0a939e999244fb14402c266938d20e47be3075fa800972a06a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230e1e28072f2e34b3299b4c7aa818c89e3e4992983a93bda8a655db1c5898b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f4034f7e37b1a7a16633548239ce0672228f18c8d172c92687d6c3f3755b3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508abaec2aa7e2fce09357944491b523cf7d8b86d041392b880a472be7e1e048(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20845a7f8ac2b937f466a8041a68cc507e765762c1de9feefd52b12d9d7dd5a(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2317de3a9134e75a45ad09bc9d81ee8754df8b8bf411f26b249cc4b2516f9395(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91040ca424c1fe4cc0df7dd19d880e52b416e9955bbf4bc03763cb305f6d2063(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24dfaa65587c32a179bf0a62cb2b0592da985621ee001fe0fe8a1d40f695d23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9412f50859a87b03d3de562ad0d30782ae6ac59360aa4cf3b2d0292de4361927(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b980822ea05d4c33b03ff55384bd0ac0233fa3414c1507ff199969c7365201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5372fc2db279b0a63371a90bbf54a0e69e9c367385f93d0e2620760dc9523c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16c612133a8563c42b787b51a539a32d3df7650c75d1d67b0e2b5bd771e3232(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba106f684bead73af3cfd8c4742471c1c441bbbe7f3abd1a216a32bdb4995548(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3880f9d357787de82dcf830059bd0f5ea671b21a7b2e46fbd5a390eeae9e7aee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f30a8c6496e448a5d89bb065d2f94c2ff182f8bcbdffc7e1e5260baf8c956e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f597951526b14cf152d0e7a202ef4c717ffa89f344acffdb2fe16fa66804c399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71099b787bf4eff679c8d51754971728fd91227e20ecf935118564e479357c0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219f29e3c76486b61f8103b1f4b15af3c09577cbe4eb40ffa74119d1cf03ae6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda2b282a5bad784e963bf86d904b835ac3a2ae18ce000f9c9342ef5ba59ded5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bfe53d4020f00b366c9ee5f2ea658ab4c41b919f20690a84a8cb70cc3453644(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e94f85b4d27d84948bf0537a9542355706f1cc1f701fe23e3ab8f535fdf9df8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f58174880a62e0dfc2556bcd4092849bd8868d3d21ee2869b80be736a91a3c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef00b2d0180ec88d93195545ed38fc22dd5e072d90f28a509ea800f5e1ff8b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4c01edc320950b14f14c8d4042752cbd24d079d458c98e3e256071a6e93877(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7747404fe4f9a333ae19d4fc8055cca91d67b4426a89a20a61c105a76e662942(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bdb9788e86d4d43a36ce9fc1235e35a0b21829e0e9f7114cc72db6699c910f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fffa2365c8a03e0f5e7f563a51abd431c473ba78b15ccf8d3362443dfd1958b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9690cafcc807b1561bd1654439f6b7678d88944e9de5c294391b71780009a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98079cdebe728646e966af574b28a2cb385eb32667841a4511896a2a2823533b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58061beeca0b5db4364b1fb0e0f7568e4b8daa0af6af41eda9efd0e1edecd09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__660c46f9ffcf671a8fc816d394581263c9b94e35948bc61cbf015d5c280eaa0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817a8bd864b9e759841d510398d2e481332fad2004a0eb284d71496288b73c06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46a8454b9e75cc548a3d02ae9a551449597ff942ba04b4baca78b965154d4dcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d64ef4e586e6814b9d49318f291a4932f787e59acc4d474028452b3b325ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d7da58005be47f72f0ca202e6c966e3635dff350a8a3c594571408837449996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b756ede84983f07de718f3c03baf6c0e23ba1684d994b704a25dd7352af15cf9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d6f456cf8dbf4cca15fb44c8d34c9fdf7750c74fce087dc173a2af83810822(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f461540edd10761db0c5898c79fee1dc30c512a09d92f4a1bcd86d95d8989645(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b07b4180f5e896349cefa63e87577192a9ac381d86552e68e95cf39a6f2733(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d6fdfed0c122c39b0748a32cffaaf4becb56364a8245b4f6fb7e31a48f8ba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5d19951fefcf94f6a2c7292ccaf09d65318081937831b0cf9e46b2a4efa5f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac8779a5fbd22f9f85066b0fd45f52d15ca3ee2955e777ecd3dea76fdde59af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee12810d814f27fb376e4bf7c26a1fac89b735b9dac169208fdf3a8de8ac2c20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042648b223786ae653d1b08ce4a89b8741af45fc1913d0dc577b4215ccde0f79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc62f32765e8db823e911db8ac81c12531ca32d5d5704d8e5bdf56d88ceb5879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdfa5c7ba486ff625e04bd2d1943645e4ca2f482fde66a4a5ef78b4820cd0eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0dac323873ce68d6d342cfb2d514ee1b300ee52374362fe5dd5617126a231e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb8f285f0bba2877f4ef05f1703169a737af7b341499b59a872545996cf3d9a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8bc72844b9a55c37e0ad0216f405935551b78636c16f0bf49d9fbf85e182e0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b57e5ec22dd397a0bc3e1254a8c8418a9b50cba054c2749e0547978fd1ac7b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db9d86dfce9c9777e95acb7a5c068da4d072fba52c92a62e11bb0affa60c3d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5640afef1842243611d92c457d7828a6005f5d73854ce32ca52dcbda9f24d525(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6eb4af187e204f1bc2a86a0e80f9efac5a52046fbfdfd4bf06d11604dcb446f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a186637cfedb0085eada6714fafc0d291b134e233035b09cee5e9a2c2cd1da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598374315f47c2042b9192a53533987beb03a8b345068793acb37a83fcaa5d19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010420b5d3435b92789a386039475d54755ac60c569797daaee5b67f8f5059a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce724fd0995e246a3b986862b98c1fd57281254f12bd93755bc7364c7c42ac6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d86389d5537ead3d8c2419445eb6975f6380f272a29b17acf977d562bb87680(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02714b39ad8a0a56ce5307f6ef853c0584afec5c6eefcdb8ad99a034a1a8d6aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84d4eded06ba26e50a17ca0637ecd7dd94b9d099709e57ed9b642d65c93ccab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689449d71626b8fcf51d7bda7f317d715f81c31566e6ffe93693517a07de49b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f40a73dfd1a498a69763de8c127eee228df43a602f0543d993f4863b9e25e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8bb166d44b6940dda4d59bfe246474df84c8bad87eba1113dcc62ce79b3d6e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763ed91e1683cd7b6a889f961e4ee8e8d7be8d8c5765527942c51f0785611bda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6fddbfbc229f8475b587be4f0f1daacd569ebf19f6b68d5b8ca0783f196992(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3334a247a40b54c9a9daaafdd6917b3e84b594972d009a99658412447ab5041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac16843fd3064774d2570af6b876df51dd4f0868c2cbf20fa153016f478a0ec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4d7ba977f8ecfcc139bdb4ed99df6f7e424afaadab67a356701a0ef225468f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff6c764a2dc04345a125c754c3b8b0089d58635e0c927b8911dce072bf7bf74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a439860b04cf1a5489dce42e96b4bb69c13812ffa059a070aee4a27396278e44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb311ebd41c6b57ffba629998829431b5566778411de28c907c63ccac989bb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__734c42d0678b50df182bc2ce43a5de39c5bdbbc251602cdc8e500a086b3ca071(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0920a968c047fa755baaf0e1fd18b1991a9173730142096813f5adf7e86731e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4f8b55864630cbe2fdb7cc6ff83161fe0e212834bc6adf7df061fd05fe72a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de206f70ba6d4475a8001a0f5f21ba27798cd8e7ac617585d8d0e6178c59e66a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dabc6e03c569a58cc67e6e3064d91bc1736e717e89e69e11341e9da40b02c565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634543b05b87fb2b3bfdef5f5f552a9ddb66e019f481880e48f5e4c4fd2d5cbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd28bda8fffd7302340d3d396ee35b85eb35d7d9276dec862e0dc09a5e2f856(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac6d4064fae6ac4a2c0151e348f81a35b198917745b0b9b476623c98fde4d85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413223f77be0f86fdc2ec7019f70895f4d69f24207f37cc4cb0b4527d2b2c5b9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d808103a16975bdd49f385c56f2efb0c8121443f48f41b561ceb0ef593632ff3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd11f450c122ff06ed8c15623abe9857605de6e7cd32e529803c1bf1a180cd7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85a08cb758c122fe08fb26866bfa427699881dda236c81c1d5d2622e9618331(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae737a825b4fe1b88520ce1023a1b9c821b6a1ab3a75cadcc1e06b46ac1d42a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8e9db38a17bccdf768212b6d4c63a5ecf9e1d74b95a8910d7153d50adadc2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afbc6cbd67c5a02f99cc396c7cbae95f53315b41d37792a4b4dd3f21e6a8941(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c3074834c5e7a429256d2624e31c6a702873275c86d37d2d719b87edc629d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956c99dc014aa33a6d817e49fc16a1a230b8e89ae4aafe6dbc6cfca50b3fd078(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c96c21e7377093e87498cd14f6034f63df9c706248609837816e98cd099dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d554dcdf670647ea00ed20bb2344e0405c32fd535db7ff535819060d662e888(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27121c67889b62b22ce79055738d19c85502f550ccb3f8135c3b23f6be2fb43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab13f618dc80c951576362eb64e2164cb3cd996504d1c97b8126a25cbffa297(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748e63dd066c377da338ebb9434b62be0d132ea4bb7283abbc6468701df76081(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e9a51b480a83628c44dde865f772e987fad37627bb5d508f1b82de28bdcb1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857a2287ca91e456213d8b72c1821e97289d503ab4c0c5b840de48000632df23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4d7a1fc49899616068cc10822f6136a557af9e80fb58b21e6e1d501f673f4ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d90357c680eab4428975ffe29b1e9363f5892e1afcc64903a8432ba8507b722(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e012d4c74644cffa539f3093b4b6fa77457804de029f7ec1343518fe1375f207(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff46b4bd9f18069d3e8fc735f7daaf79857a47566b27de01f09f89f045ddf56(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37c998135f2620123fbc3a62c4f8e6b61c7048c34d1b66f0f2475e193fa46ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b8a9703b2c8997871673e35aa9729027fc675631aeed4bec67972d1cce660c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a83b20cf4edf3e37e6bcd90fda7b1fc2a1b434314bb4ac6332876c01eba7b57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2af2d7baefe5501c75c7f2bd40e9b0bde5cc506d924936363432dd9018f284(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44e990eea53c9e1576f39f2336329317137cdf78108231d09770cb36b8cea87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067301fe21b92239aefaf9b38125733a2761e190fc867216ef26da51e42f60a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191c3076ae24359bceca7ede720de1b5853988a90e82144838691d9379669770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9477b1acaba6bbde18dc22965dd37283d0756031fb011d0502451dd614bbc1d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bee6fd361b1e2dd98ed9915ae2e3dfca7def4fe697f72225de3b7e8f17e277c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d5756d585d607754ddc556c67e00d6a415cff891e1b6286320fc62fac62019(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff609e7720de1d4ceda21c298c25bbaeeda74e4747d99bc91df5ea6b3e527799(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d307bc0668dc91f17115e1b5a6512e52425b062237a7013d4ab5ca663ff3e28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29597d59f10dbe49fc510bc41e740471379d94de269d44a33bcd74b4677cec75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac37ac2b9b4070cea6965408a8d4ca1298a775883d010ff9eb5117c8c577e462(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4446adf0447fa3fb9da63053bd2b434e8a733c5f15b594777959c44910cf9b2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfceef05eca8cc061bf201947598d33bb595bac31a1d6989e09238f6a9c130dd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e8519db02fa4a70aebf26f003e7b7a9be13208c388cd98809461fc7b9e4fce(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411fc8c555486f4df24d00c9a2433196c4ae0d344acac3325f403f9e77975cb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddcd0061f31a75803b53be718f39b708f89c514716c5572adf6eca958a177b53(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__008a8a42ecb66ecd8c178cf7ad502230826b7e732fe3a76374da6d3f48faff5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c20f7ba8e55a727c5cfce253d740ee62cbe90608297eb72b9dd5110501acd3d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b073e260e0e3ae234ad1b6b9d91af1ce4280eee4ff43989e50f2accb3f8f9b9a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca47bdfb536253da1b9ae0f9dabc372b5115582f977a2728b0953316d7b43b37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__705caa96c624385361bd251c3e103381d182334ef26406d4e18f4579c6a07466(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a086e8dca655d7084b82fe0a237948ecbe8c1b6cc02dfdc184a5d221aa4fdab0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8bff16d1aded2a04a4760cf2b1bf2fc6ef32be0b2ff6c64c2d275e1ca89d50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4852e6ca6e4ebd9228ff4af111adbd0ed60409622aa01988c0a657c364589b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaebad27b00fe7b79741393c60c6fa3e6b01828177296291b02bce95ab351fab(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc36ae3ce4396c237ce96ffdd39a7ced9508f747ac15e2326b0a4c3eec34318a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fd9a0087564a9d1a38992fa154b510f8fe8ccc123951f066111d2c9cc4cbe6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e066efd3103856357803aa7a6a2fe21203bdf2f96dc26b76c83b920b2ec71e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe03882d309567f69b0f27b54c451fbab334af7066f8cedfe992a335bbd1fefa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec2f9dd682f49b6d2ab17852024d32f296a78706ce0ccfc4641ad60ff38160f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c819cc54ebb519f505fdb7decde4842f961199a1fa82f514bd2129768917ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c17a52eca7e8b82df6669cf1c7c12bfbeeb5afb65820027df0d41ea54e4a083(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3fe07601a3277303f754022570a6ed939bb1213933ff22bf1f88277e29b94d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036b6eb906743b3940bc47f2a8a67152ed88ab48b2ba378f3cbe59e9b66285c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__798be2a632b5b5c0681636e1738228080412c4054eb0e174e6cc3144b9d99592(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03675f09d63a25d05267adda9bde31b8f61bb96df4d365db80429957ed46aeb3(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3437ee8773f1a4c227c7465250eaeaa19821908d17827ee137885981a5e8aee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b97de31a107c3accbe57ab9e7d878009d393131ffdbbf5e9833a15c8037532(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1dc4ca634df1903b0f13ec81c45d95f96aa73be1a394560c989dc45e3894d62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a06dc4c19e35001d7f5c0045ef4b61fff31633f56f47122831d106521684017(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c3e244c7745a2891dc7df10c4cb439b3de7114f3f82c923308c39c8d5a196e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a89cfd4e2e009d99826852572efbb7e53ea89f2d24c5f9188323043c64c5eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5e02d512c99ad1bc2b4d10d428800c17c908cc3d52c038ddce0a79f9c82749(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cebdc97a0fa2f9198fab9dca99cea33257cb47050b199ddabd37ce9db7119cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3623955e684dd2a62e42899a259fc6de8110ca357cc113ded1b0d7958e78b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ecf63d0f7e6793855ceab89b4fb4da5cd9849ff63f2c3c8b5ba57d28d30f75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__919e558f12ca263b6f3881e3e58c1e146baa38fccb03d59001d5f31dd694b133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d70c589f2e737b9a2884dbd331b9f9e4761021457983a6dcd73daf711cbecb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e429253fa018840b5c75440e4303daa791cc7e9e5602fbefbb61ac315cbadd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e8bcdeb6a33532ab4117133c2ed26ea43c7f73bd555b602400d1d45d95ef12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae45d29e4c61dddb069b5bf73872b8d54cd019e02aaf2f67975a7661909220ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09f03dc629a8c395481cf88fd74d322bb667498d2891d181408c5e3a975c399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24eb537d70a9b88a28a16d734f72c8f5af020a23145c3fd91233a5c262b7d21a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8db6c90496a1471fed23750122745f7b05b75c663a3ea4a0a7122727c79b41(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e8601b946482a415d8f191f9b977d922cc183e6b6feb0a54a5a4a88173c17c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db4f389a1f7b723a84f2e1844ca905917b6aaed9c7cb2646898549ca989b8c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d098123fea4a74a32b8211a795d79d125617dcef60a93d4f6f77f417dbd9a79f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce194cd663b107861b63503bf19fd0f078e998be64a978346c695ec098c6deeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631fa6aa7a774b7753fc89f07ec0aaa17567cc593f4d274b059b14c9c9bad570(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ad4d0a511fe7065ffae13ec81de9354c3cda9b585ff1912cf86f0c723fa5d6(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1a6784cafd77b389624f987fc51b23bb323be11be7c9674dac3e7bad081312(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6caa655d637517675cb6f2b82a0e744f0c8086e89ffd78a5de71a0fd14bc2c86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81dae8065f66bc06e401c7f45a4e77ab2676d9273faa77a634cb54df972843f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3720a6a765cefc04482415954b4f21b04068418d1409ad4f0f44b0f31ed001a6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e8159d692f8d4a0696a49d25a17776bf28f1b317ea5263ea28aacbe1a98009(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e76f0329784e762306ce752c13bbbd7c29ea0caed34891cfef3f74bcea5c48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da1247c617be44242032ebb6ae137840e74f54bd498e7978f8f717422befe5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd62dd9ead76f12cf6ae5365a69a9ae6e5ea443031062c7e4831287eacd869d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4186e81c09a645dc80b6de18f1c87cec62f7d7b7379b91868aabb6562c74ec72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92913a7398f910ad3fcb57db19b503b116ddf9279be9de8eec843cdf6e281450(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8328b10642ec4ff622ccb97fbf8a90fbfc8c55a14af36ef54ee86b0d98a7ede5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c14092e532972f0140d376cb7a09cc3867a36de68b0ec54240d0757a335685(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23cc42eec10376d9a2ae04c16b775f66c63438ba276fd523af5fc6889f6f5f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce8f5988001d29a96d3fd9ef2af00dda2d4380732ceabfc5d2828bd029d1d12(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda489d1befccc3da7f5698e8e079b868e334cfdc31ccf6e6aa64aec267d26b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7248178224fb7735a2b7ab2b6a0b1dcce304a89bcda2ee4c03721107398ae2ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__308a5c2e0113c516602fab9eeb9831eac1b12cb1b8fe6b6254fe90b86c03922a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c146194fd662142701bedfb92eea28e6b66f20ab2473ecfea7f983b396e55af6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968685c990a1ef6934a6e094069141e2d769e3f91054f380372023eee6a3f9b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a42c0458fd99dbe13eb92c24e119de86a3100f4dca3223250760ae94b4f810(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661d367f7765379a756d54258951c02294d215c897e111a5c33ad6de1dee23c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78230f9e2cb2d2da11fde5175f48fea3673b2565d911955f1f92222e6e8afe53(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de299306632771dc8775db870062899b30cb7497b05c99833bfb162806b6222(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17f40990e148b8a9761434aaf4d069b968f7cafeede8bf77e0e2071d626a634a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750a5c8c6dd3589693f26ec7f09986a81ce9f9d966007ad916452c8994e1f9f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2e0fc7eb5d5626671cd205610e912fbb4a1a06f0c7f135616a9f6dc1a58c50(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df586770cafb057eceedc228b184ba7e4920c54b0f5f5f1229ab9ee9e25682b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26184b771281db35ab73c8df9c562031d6c933ede8687a6208131b7dd61b1827(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51845716905e864f3d84496655603063ae47fb364d885cb69094cf5f98c24cae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d196da6915092978f39c94960e58225b5940e186dde138aff241b14ce96e2b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb81c33a9fc8d7e2737540103d16fa38d7f0042c908eb8812a11d6548bb8c302(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d349a7cfbc0c3f33537e2fd1d5e03e9b94b7786599e91fade650c58c89b8e636(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3817e88ef03169b31a1f885c5eaecbcf76044a0a8e5001d69ed48cddeeb23c5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503a95d6208d9158e2c6f9c08d6088b4252206013d97db9c4ef149f8caf360f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15184da16069889660c3bc3f43aaa6c9564be6737a16af9ab2fe0975f3fc523(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3db6a02340007baa2fae7893e86ae9a7342eb9bef15ed8945a0f400d39fb303(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84ce2bd63c89dfb0d434b7404d2b220109cb44c94a958ac8a84a0b1c4ff707b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b26bb9537b5a42eafd97c92f432229b587ab8ab32b374423febbdb4a3fdffd6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f3a7053848ac861983c0a1dfdec0c771b1b0bbf23d7bd32392e3658ba1e71b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7101bc69ef1af4e9c1546df14e342e1f0688ea8bf4f32bea62c67f3da328b8c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017a14fb6b9d68c4edc4e31ccf2f21dda3c923a6a02687c4c9f4479e05531c15(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7134b4ddb6bca82455aabb5a9478a6674d2dcc063fbee0d03a8b576b8ea0d187(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24457b04b8a5e78a5ee28338833865a98f0933a92f8e3b822a7c83a6cc6dfb7b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b68c10272b4770bc654f40362b8fc7310f353db8457e77f7b2adc327339d00(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b20cba472a9aea60ca6f056110f8f191716c289f7d2e664de1ccadf122d15fb(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5ef2e57b4408bb6087baa8f1348b253501c894f8ceacbe3cff0800f1fcf6fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f07caf5e6560af1e624ba703bfaeebbd5e252495a2d1012b18ed3bb5abd01e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10db650e3d3aecf87a4f9e8961d15d464a3c013e47ba7fba1828bd501a31bf41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16fc50ec5784517451ece8ba6aad5bcd268262c3a23d9f94b190c9d874b59b21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11db3cc565316ca7696269b0d7ba07dc0b96b4da795db32de49ea7f142d3d311(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5557c65275e202d5467c27c3fdb3fd1eed0ab2687576c510515f1ed34749ea37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efccecebfe6ec4b7996feee0e5e5e7a7f2554e706ba47967c69ba2999413b1bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7233df54c9073a2ad05227d4ede9fda3627ef1b2b9c9bdd616e2c6657c8ed91c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417c6a596a42012136068e35843d6adb8ec75e6da2dd62dd4fd2f56b9e4c4c8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7387de1131fbeed6f2b7a7bcd24332d851748617b12e935a151cfe034bb9bfb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8d00d73333ffaedba24b1665182dd7d1e8a7b4c33e51e56906625b13a2a6d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d7cc4a38052d3348e6022e65a3a54d84f80591f60a390c7dee67d590daca01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__640fe6fb22dcdd83775e36b3441e9b091f74bd439bbcf6b7406a62374b50ee6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aadb069c3e2a03cc7084c44be019c29ed28b2def21a89d9c211a0270c4a475fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07f562a42ac4c56b42d5ba0f2569eb5db6ae8a2a3df1f570b1ee2eecd73b94c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f287dc4f60913ab305b1a83784da762c0bc9bf1823c1948ae90686d036b1c2e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6841a3e6baf37bb04923e0cf76f2d39ad2b6a3cc1cb0149abc30aa48e935213(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36dc4999c66b41e3b7c7ef57480568d5ea18bff9d5756612839116008cbc289(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__930f0f9707221986bd8f5d0a02ece61eee837843fe595a878b50b733bfb9cb63(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8859dcecb8c6f70068948b414f335024aad36f62a4be77b6a98e0d8bc75a3af5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8521c8ff29355397a42649b658f93a48f2880e6383b09d8cc83df47a5df2e9c2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b094ca27e0d745574f22ed5bd554804c37408715a6a0b5dd98d2fb6eefca9200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6401a1db31a941d37661c34f6b8d9d78b64c020ff638d87263f7f2c8ba667a54(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0945338271f71995ef86f8d43ed9eb52e469d06e620b5f4766d840b6237bd9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f10804ecb582b5bb855c28f9040a7487ca0e4f84bf24f8edfe5a8d465465b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f07a52d6620cbac9f71e5d7dca4efde70ecb2c6b98b1b14228ceda51d1a74a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1731dc11a9f2b0a9c03f1fefda2d48cb35d7c3ca162dfe134c3c2e4749bcb3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dec19342d2e4dfdf975e9d50401a3ceaed37479669ec4e2344151e4d2fae032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7517b2b1bfe74c53d4b12c9e7745df1870275783305cf31bb9949b66705ad54b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcae4a63cc7f3c3a16860efdc0f46e49ba502abf3b9181f0b830502c35517d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56bfdd711e80f0aa81d6021e642d32b4231ec347fddf0c3051752e36858668f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80478b356b88059bcc27c172ceac03012364202f9a8bfbf217b67e1038dc8530(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4b59548228c1c216b5a6fc50c6b3f0232574519ff54d3eee2acff54d53e6c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2945e9c21c9e6cb0d7f7d97d8d77b13b9a0488b8a26706f1563667f8005975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d9b797fdfbe97724fe0535409c1b4b887f1bea0f02f1d1dc7ecfc1c354360e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bece44622855b8247f6fec259f90808616c4fc7ef1f0f510c99351577622221b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b21db201379d2cc252ba665fd145ddf91e3a90bf3a308330f1e01e0b3d38ee1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b7ded3bcfe0995169d254bdf9c5e2d39e617c9110f5e918bcd3c60fe8d0c20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70840cfaddb85046837d0e698e608e171136ec9e5f5ed63f6c72db3bd6999d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e5a07fe07291c0e6d07968ee3a950b073edc9fcaf37d5d98e06e79b32a095b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6effdec4c1175cf606e778921184a974e3ec31da9f37aa615f77964773b10c96(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d8a86055b7fa0bd03d9f958ce532fd4d97577eb5f09eec1410b13100bde79e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20a84114af303d8a1081d04562acbc28b01be4061a1d0b6620982c6c3c9a249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa45d7e75ab413eb2694fddbb84633af38631fb6b2344f861ece045b5f578150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b084ae73f08b453eaf8fe5926350ba10671b32a07b7cad8c28ccc972951cb97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e6774491f8d7dc695e4e262703290444ff373f1215df176999e1c1d910a2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6adecaa293f59fd66dd4b2a4b84a2f4a3317f7f462a418079863843fff14544f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6721b3e66a4fd31c46b460bd044ce01376826b27ebe7ae5f224ebf720c8525b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c8129a75a606a13a69250f5f858ebc16439467fabdf6d0288072f118c32af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bceee480e7015fba2caf9630ed9404defd5ee61dea0f0f4b210365a952f73e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce40b09cd0e72d5d46c2f929493a15284a4c22aa21048ddc9e8815c23f472ffd(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dbaf92fb9d69e3b1a7d247f8a9dbd49f42f5ed19fea26b6692cdd9d9290566d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40095e0258791353ee79e45e21728afa1be171668eb10ae62dfa86ca19e56151(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c425cd55b4e58aecc86dfa73448736ff9aa21ec29f0e3a96d63f26b0da6480e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a8a3a8fa085cc96a5e5941c1739ec8019f73c547fbde47aac9e227ade4fa870(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a79b49b7d3bfec106e91829a4e20fc45be01cc27792e1c680c024dbdd8a9c86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fcbff22fc7367d0b2b4b21bb95688b6fa4ecedf9fb55af9ad7aa3917ec35d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f67e4295c20bb808ceba2eb6a9238f43ab13c90757a88a18f02fa5b2a35e80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__decd7f9831a1fbd73bf6f5d5cc2de62402129c27cbbebc42680ffbc8235ab53d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f016a0c0b160a2d6c3f8541cce7ebbda44d2585dbcf5dd0e19f2a30bb109b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ce65f23aa004fe7743b7e07969421468e174c8409c21eefb3a7e7b8aad1a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb4382a31105d7d7a396520b4c6a9f65ef47ac3415ab9fe2886901db68ee686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2c868d13da4d9485f92bc3e493cbfc24c7d221661d4d066ba596210b6eccb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc46e93a979e91eef9c27cf387201c2e87b793f82defe4de0ba06852ebe3d51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c76b19d3562bde230c3033f64c6a22079671b58412b1faab97e9d460ef201b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f791c11b1813b4c4cec49bbe6cdfbd0ff863d324f9d142f4f30b15c931b50b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__405e3c86644029f6d4a0ed76b14f403c8136058c1fb8ca9fd15b33b6b2bb4645(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e07ab36764d6bf270206989ccce8b6c535e8d50cfd5b0724d6b43fe8dd2de1(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1957320f078724f05e3b8dd50f24544ae797ab6e4dcbdc5e006b97354a314887(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1707061e9da630c78feb1c08e87ddd584cbbcc74274db82701e12727d8c60b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41799def3fdfebb06ce4ba21ffd12bf916b40258ca398c1a4ada870a070b35c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd0217a2b8364aba39e97579a86be6d6d9b9afe9a3d6287f8dff99c1c7761b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667a75770b1c7c6581b39365560d03800ae70fbeea147413d454fcd39a8ee31c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686c6430e3115d72d2cc48577fc3c714aa0baa5747e09b61efd54a11816f7385(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f12b3b9f2476cadb17b723ef5a527437cb61fc3c8fd390c4deb4b53d48ebc3c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873981ec9ad1a35e50c0450081b84d809c874091a2af2d9370648ff337c06286(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ee0dddaf88e355dc845edf48cae4efba733da8b22212a79031b85ae2922aa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef726a3fd5d60b20de9aaf42ca2f8fdd9cdba751d875c571162934fb2ba7282a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ade9a84b00de0c8e2cd3d23047048a388ced722c30f4a67c3073636c3189de2(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf348ea318a5343266c9d2e450cbeab66825f7adfd78c089d9849351c28be98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9bd80049bb24fd7b94058863c143341f39bf5d75f3d7bc23b72a634641a8b86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a275828260011ef405d833da52e278a6ecd64404a6fba5d3fc0f0a74ce1d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5d80c9db6f9d5a1a88b81cc3334d9af0fed0ac53bb051890fb6ce70f47078a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0504244e36f56e9c5cb74bdb05a9c74eb32c4951f102e6a904292a50315efa21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca76190f4f7d512253d745ef6cd83ab668d69725f4edc3b84c49c0b586e69688(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a34f1d0c99e0919779ec8028e50e55ed98b211984bd7d965f0b72c3a6c593e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c017cd1b81f7b2c88149525ebe2f3f3d60c177c7d6cb30d4bed23a5938233e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed79af9419d2f194be46c502c5bd0ad91a500dc38d5e2598feb91ac4adfc70d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8036b1f375b3e8cef660439fe3495544daebeb93625502e06bb67ca1e89d59c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2d5d86209a2950e05ac76cbd785bc8efe7382a7a7d73daeef6c241d3ae6299(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d833137d8571a1b15abf64ab492002ec199fd43e290d9a822ad975f51563935(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69339c38d33035a88e15c7322ef4b46ce823d9ff892c8923cf150f766891d27c(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36357762a7124e69520e1f57c1977960a77faed7d42e6ac48ed0b5872a95f1f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30f98e59f467ccb0ee12c059ad359728824bf454cef03776ecee667b65daa2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4a92bcea95a52badf6ac35c2771b233e3a1d9efcb88c6c50980bf8fc7f39a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1b630e5e3e468ead75e1e581c1ad217ac2288505631c6d35b104343188f60a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0513f78166422503e10eac789bb205156240388611a3d6b76b0ed05ddfdd520a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e3e7f07d6133ddb3cd8fb080a8919c389fbbfe4547ed987be95b2876e1be0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc48aec3ee0c8ccac297451bed5b65f98633c7539257b8655e578083609fc6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e1c21b9fb4e8b74691cf1c3077ea8ad5d38bcb7a134e5650d262cf380adf22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a6c5147bd0c0408aadd022a0be215cb144a875d27c9ef03a67f324d02c2212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4632f65101bb6225dd3479d6661eeb8d3a6613fbf0a09e21cb65056ab694ac8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bece789f24399798f0fdd9e6de7b3389993837755b6e16906b0dde8e10ac09e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3152d52a2309d5eb6d46aaf5175b987a77d9527f99bb0882d263ac8365ed12db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8dfbcf48c0106d01f06e53bf557b1f7ba3283ecb2d44a76e090b28360a03552(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bfa824f706b69207d551d7283409c18888d97a1efdcc5088bfbd72c2ba0fa5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50cd360784f19dabb5fdaf61dfa4cbff1f3e6fbf4b58adf420da4860b17200b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df78e72152c0d505115eb45fed27de6fc76ec628eed13df1abe58e4e3e0794fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15b6f626ea7ad56775733ea37dedaab54b666566e06656b15dcaccdab08b0e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7226e2b3998c63a0fe318a5898a004c27381f44c64cba4d365864eb33f3f6a4a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b56929fb265bb28412e64e4c8de91b270f4aec616a939ce920a181055cf929(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdec27939eb753cc60a5f9608b28dc1aa834fe3b8dcb2962169427cb96eff0db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ccb4b2b55de2510e60685decd78227dbb79d3a126a0f66e1eb0f26ef002692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94b14a8d0d786b95240d550b85e6ffb0d1eaec40f934f81d3f0f59984594340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1d342a9427bc29b1e9246531525ada517ad091ff01e1f6c7a6d652d4967b81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614120b02c5650166d112b9db721080e800ed9f718b30926eeffba81b59aa7a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e858d5ae1cf0edd6ac0f300667577cd580d9a694c33766d413cdda143c7804f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9fce2e325074b15ee615efe54d2ccf9448680ed0f55d38e361648faffbc8235(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9a4c1f57c3965722aef84f073bd5132db6f1025b4d3c66ab1ce6edfa9e2e5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f1acae541da6a96fd2a007d722bcc0dfdea044bf4c1d2e312f914412d841f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3ce9f1a433bfeec926538931c9b5bc1cf9ca331ec8310b3d16dc9b1cd92312(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60bee646fa23e1f547100b7c246d9c4ff8dede07fb887b2e1b428c2786bf46ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5d7efca6224a7e23813a69b6c4a975b344f9155179999c5207d55e5f151bd0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14ff97ae458470a1736a4c6c2d99a5ff0a9c043dd6e4f4c6f695b922b217625(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7e32e6905a49711bb9eada0bd51e3a4fc2b3a0e0a100dc6986db04b2b29012(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac611c53327cc2d7e4ef625ddf642faf01b0e0583f6a17b3f170f49ca0149666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2824a3c7ab5e35addec3841fa42ee05f8a24cccc183e28e464d905b185315195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cd887fbd41930855e6f09ac793443b26381f89d1c6fc03625291fc6fe5ba04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8e9e1b48f6f109554302011eb3261e7b346f47e3f937550a239d321424bdb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7477cf8b94a2345b666414c087d137e9ce70ea80559b681dd7659be623a34c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1726a6a3e95dce6925a7814a98c0ac71d12497638e2ae24b3548796f35b9545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c6d4bedd04cb7adabb0e4d7ce865cc9f55b83934a186cbf434f66b0fdd769b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b203722a6dcfabe59e180a10f4041976a3571720d6526b3ee80648b070844ab(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcd0a358a628c236848881945c6171dfb652406911d1740083ff2f89d77b32a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152c82f4f62d545bfd4c3cf4fbdf6fb32fd15e85e95edac8ecd8900f5d7792be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd62b1821b1dce59901451c1b07fd591e7aeabab8c94737d1a33a7967a0707b0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8222e0fa2231dee20e946a68aa891d3033d856d5c4202a9fdcd7d0acec7a03bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02b79e120d97fa22e614a7181287f78d7f716a80f7d5a5cec105e293779a9ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1e46a7f57684a3169ffe4ed93e548efc18fc3b69dd1cb86af18658d01d3e95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d16a14aa0de29820d57b7627f8d5e15b28d0518b6a29b04e7eb175d1aef646(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9e25fa91e251be23414d5f14ad807b56f43993af14668cd084aad22a7b56ca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530904d28a6eecbef04753647645cdb6ccc3e7dab5ef05a1d5569a42c8b7c40a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b763aab317f402b4c3f2d7f646df3cd32ab8f9fa362ad3356e771218c7f75762(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa0c733fd98ac67ffe7e5013a34db047c302874d8fdd550c94883e355b2e4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88e2f91294d5119f9a081045c7dc4c3903858b182dcfbc45ac812dffe5eac09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7abba9f34e2d35bd297120ff0bf829631f8099c6b2e3775fcdbf32b47a0e039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42dcd8de42966e4aaa3688fec84523e74aadc8987db48482d9a4e9a992a186e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c939e0314b961842cf72fd3afa5a05ff5c5cc86e584156a7446f2ee5548c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b11c0c114352fbb2a8fd45184aa72987f299ee7b7861aaa6d0b14ee82b904c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0faceaf9f24bcec4fe5f991fbf64bcc6c072a83753bdc8fdc305944b1b1a1c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e400289b7960bc947642e36b026c191826e9a9793dd7bea5a0cb1640c5d1a1(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181b96669170bf22f89a197a70ea468cecd64f4c54d966e688cdd378d63f6a60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ff75e0c7dd77b5d1d50521c85053b6ecddbc3b01972b3f924b68044d237eba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e61565a5198712c3bd5c4e1b7afbdb1591240efa3e1a353c02deae6c8a2a202(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a78be10b7e3ca15c5cad582bc2d31787e50e575ecd3914bfdc77fa6a73fe4fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d5b77de40dfb423bb437a43df24dd81bf381edfc5e4cab982f7a574c84a910(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5db1e75e651feff6f62a25c17512131c68927b8190272bdfb4a81722f1c3248(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86050060ab40aea51edd28b801c2196a4bf5facd3290aa5381eda40854968909(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8103f661624d6024865bb866190917db0a877a21fa9697ae20ca131b875c0fab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1c5652bdaf53a3d2dc5d6a73cb07dcfe907989362b335c0943af2706c4e9db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c49535b145d8052d967da7278fb1eaf2402dee3355a35322fd78a072a588cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45de806ad236417c314ac553bec895c54a02dc11248bfc483f1a73dc63b3c515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2692f97689a57555ed30a039af2a5b2aa60c0971d22ddc08e57b0f946063317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb60d1f0d647064cf867387a4e41f691c2033c186335be9e25b76400ee5b4dbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6977cfea93edc537d01bd279dd6ca0f9e0066a17557f12bb6dcb2099e5fbe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d7ca353b33dc2c299b617885e4651fcf25569127aee76d57c6e8391824e24b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87991c17b435f6ea375b5c3abb599a6ffb9b6bcf0fffa545bddd8728096f37c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdca809350d62c550b55ec069b5a8e5d8c0b7f2e454391c396f7ce07af28690d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ed96b166692f47ee079631b0bf237610c0c44aff5e426e1a22e2ef5335caae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeeb3f822b162790c7032194f68bb271f343fe79c1ce4179cd791954133417a9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec32439cc99bb0a558d65b867511b3bbfc638e251bad0e67591c13f8c64f4a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c5be44013318289f12e0e20e9d4b80a9e0a06ca9237c8097b7faacf6bb3c96(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be33102889547d701b9d93d31f9a95dff60c14f4041e9ebe15fc11b7adeaeb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327c1d406754b2a5bcf74b73cc666c10c2b75dd39274f45f4d581662e189546c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b51491e02f0358c9f30e384cc10a7dd1859d9c5f6b70a7cf83ee3495681b0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34084010a48525f8428cd75f584d1d41bae04a6495014349db05d381f83242d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07788c831c2ed01314ced784c97994818f56ac177e323f770e08e8549bdbbe33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa353f52d8b442bb233a4a12891ffe853827ce6e8c3ef318a2a69fb4af6dd68f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8856ab07d1710c32a031486991f0ea97d623a4f91a24d88bb2359aa105494c0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d20b884dfea6a95929e636c9bed04dd29f52241ae99d12a2fca5b4a6fcf418(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ccba77454af57cbdb00bdf501af1013c9698b8d05bc1e0b0a18766bf7fb1d7(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468c5600721cab104abbeec1a2777ad35fb821bf1c6477c6dd89ba44eeb27c3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53e382a92ab7cf54456b8dce96afb341cb2607ebc9bc56fcc288da9958bb94ee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135911f2c5ee7a8177b5f1da6f9e111327bc70445da62b1f863a6b5f856d78a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6ba1829745339222a5ca98b3dcd7b5feb5efa938d8320d53e10c542366e040(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c67ee92b0efc684b8b08b111c786cd00e294525322b95067ef928bf352c336(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cbbd52d20d212eb90078031bbd9b8d66ddeff1a5244a7e6a6fea310a2b0bdd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48d88af70e2fb733229e395f279d70f98e58a420e55445fd032f4b9209c6566(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6addd8fb7694e7f251af69cf61731fbcfd15d5637e796f18bbc3d6032b655b4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ff6c3f1aa5cf9190ebb03ac93a548bc3cef1424528a8999e19f9de630035b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f323fb09148a17d583d6840b920276936c848d390bbd42cae6f64ff38b35b429(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9550d0e6144a557791fbaf4b3715868a347dae6f03811810f86b2a61546f729(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c5c51b9eef8b6b251544b7620300745255f04b2553bb30670ad631ae219354(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b21975d7dc721c5c8771b48cf92403ed7e25ee892899c70b8482e4794bded082(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cceb34f2e7fd1e4ce5a797700101c645a818aca21b85053b8a018b57bd471f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c557a78458b9fc6ffd5d950b5036511d3e271c3f34a74f2969a59172bce8628c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4378a88cf01df400cc26f083e6b4ce0545e3f1c986f8a70c22eba6eab5267ce8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4221ac29e5737d7c39335b52318115348894d6db8fb90ab5e7a20a22b355f899(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af5d243ad79e0eff9e94d5076899600b5da3dbe481dc2c47b12d2d7e76c3908c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12544bd7b8d340372412e233d00d0323ff3059b3605367209db4464995582b46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1068bf007e70b5b619d8d7da9de7e57cf4859a902fc94164a484e37008aa9b38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079907732901b20000553d28481521a4826226772e31c6595a2d944236dee463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abe4eb84faffcd3454ae9cdf67b4e73dcbdf91608f79873c62d74c5b467e8f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6eefbdc43688916bbff663fe4c843ac269c60f7bca2169a47a03c7526f16ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18ce75a97c03e8bb4c15de8ef374ba352e4c2bb9507e58928275b76194cbd2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb506bf837638b7f48be81837445f34a30b51bbe3f4578af4230ac6ec25f8d67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb77fd4191a8ac1a78a83f66e586015c877299f378ebe697b047b64d83d7cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928bbcf075f5dde21222847e7bb44885838aa5ac851923e7e005abc4376832c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b56a8722e62e1dcb6efd140f4b1808619f7abc52501cb498b0ee091ef32331e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec89bc70f577c9df0c9b8b756d7ebbd93486d6faf94c49f03d3be431afa6daf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deabef47c311390f4e2537d894662f9d157f72848ee159839a566de45f0fc623(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ed46ab60228450f4ae7568819b2397c1babcf580ec2d4deed900400a2c09dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ceb43f99200930d17ea2ec9c4f4b9675ef26ae8c6c1a28c6b688633e2413b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e459f5feda060b3cdea61266fd8616dc0610a167b700ff77c998347cf572aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcac26eb06e1696cd3bab2cee29ae3cfb83a5f7e6ee453cbbb51aafff32c670f(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f50963826f9532ea2961ffe2499bc08155189364973315187378bf2d4190705(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8877bc6bff5a5f4cac79aa79ae87e1266a07f68fad9c691c87b2bed587a201(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fbb8c057d802d1cafa1878b06ded7c25ee9a82c7d684de319b2bc408560abc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc001313b8d1cf7a7e0e316462eebca2721fb832319d5d7b3097a4e7f6073016(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d3e15031b82327eccb238dc226041a824f23ca2abd52cc5e952ece1624eeab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc4b083a479d10c1ddc14eb87fa126ac0a339632b7c08cf28c294c8f422660d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102d18c2716efe4715e1c6773a26160fde62fcf879144aa09b84112671949c2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e63e6e61a918616e3e58a27c505facaed1f53cb8e844286ebb8b056cd5483c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15389b61da9e22f38307e1a91c571b94c9413eacf9994ecd28507556c16256d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6224930d1c8edd75e864b8006f270757b3548b7ed40e29cd98ceb1bfb5d555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb51a7ae56399f0c5c293c7f69f013c6136c52f6d4af5c103a28273a1a8abcb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05905d7f0030f53ebc1a357f9e3bf34b5a660c50e834ffb576711db20e7d99d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d26cc884971ede37a6abe2f5ab08bca95451f399ac755b2dc0813b148263f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9d9d356b83a9ed957eeb1fa829c46e8c00120e91082ff4c65a3b986580c40a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcf67c6309cdd096c3b657b0da14455a3fa4212cdddc94c23d4565dcda78030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dcc0d2c925dce86cf6b9a39e0cfa37fb4930565895f6c37627f3c8bd1a8d90f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccedede1fcefb14153ae0a4f883ac3b4b844f011113b30dd849fa341e6d1e4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb54a55060aeb89f414f804f3ee5af8bbaddd5d297a177fa44291c866a71e6bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06a10f3a511f4ae550cb26c8e0817c952effe25bd75fffad852267d09083418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82bb3b5a92fac45a6ae32d96d28e8f4750a1954d791cdd93a8fbce3fac86f0f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7daf971a6dc737f0e27873793d4aa6fa9134a3aaa516c45a9b1c15c3003c57ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468fa1d00779d72e96dff8a8b2fd798ac3e1b911972b6b4d546865eedaaf5800(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__395dd6b6ce6c67a2662ddbdcdd780e674902e51e2dd8a2a4b10f570c1db1b5a4(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa9349c4f6b4e27de1631b3909e3a69ae192c30ac1aacd108bcb75dd605cca5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261d1794d3622303403ba4fec793749ed5f9c8f40d2b9225350585932ecd40a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99174a7c6b92d28d32d08791cad37c82e220cbaf3759ea8fa877108270b73ce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c3e2ea3f30bd212573b55cab14f655183380c9b727ae14e673c6695acfd42d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb0b334a42f6015b8ad4d5f96607472693e9d28debbacd11ac767f8801ee6bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b41cda472fbb9e0563a48b0002b78c6a35b82e1cf5674abdf2cc24e592d57f08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920c395bf54ca7c1d78bed589c7f95532b0df71e9f2a4ba532c730d91925967f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101b7c0884a74414a0a430aead42e1e7dbdd397ce879978122212b5d472a0a28(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00aa40a0b26d683d0b74f31ba5ecc08cd3a0f5fb81cf9cc0e0271e7aa33f937d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667d5c57a7906839aafe744beb487fb63d27e6e929a7f4a989f2e204df4fe4e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6880efe0e7f800d3fd6bb4781ce4fbd2e70d5b30bb478576b1903d3a66225ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1205f64f196b98559603c4b48a544a819a55a116f17b51573674d4f846e0a380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4c2eaf563fef361a9f35fb77c8057f90bfbefe0322ed1d0d65dac51388aec6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8863d798fd67919830891a6fb337c5b90578e3c9332fa1c5e69709365aacc4f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578c2998fd014a8ce5a39c39e90793beb40ed1ffdfacc2c59819c99af95a86b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b961bcdf665b4ef654a9d1b6800e152ae15ee47daaee77f08048c161568e08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86604e1e67361729f2b2d617b748ccd94676631f0ba943756086e4dabd62759b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0563f4323968ed101be53cffc0f93690af71d4d012216e160dcf0308425055(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78e0a07728d8bf67d9172057abccd62a0eb6eaa3bd2cdb57c7897e0627bce6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f307d319d2d89a984bd76a19eeda7fd8c8c82cc7b08b6448eef9e82aaa3a98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63d01029a039653a14388df224dd06e879c10016a35b22d9f11fc7935a7f2cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cede54e3e3a90f38fc630ae5a6222f671bf0beca8a7877a149e66768347442bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1aefc7ff42bedf07bc9e4846b2012f46737b40268ff478321fabbbfb178fc0f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6564f11ea55f18bdd683e9bf88a672d437141705ead4536fa14b4a3037247d11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65148cce7bf847fc25192bd79baae742ead50a4fc3eb60cf714e72ac82a81e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ad7a4a2a799729c6e5c4a16ff18e26181a7b5efa74535626565908455dcb71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73897a84641144a96231f5c4182712f34c9d994ca3143c1bec43a54866176bad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9abd28d05c26f78a05caa03ed8e3a1d37c5b13f4431aee4348db6861a0fa62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deffc8b71ac302f1dcb34d9546a34146ffaa01e66b09422a82368e69b98eb711(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a025a8be57a49c72700e940d3f161deb148c9060172b359491594d220fa349b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e142cb93bf9b3c8835442075e060027fdd28032d726bdebb5d1a3aafb0f5ea6(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a274760aed6c0d89a8b6d65671f3942d12700754c66d7d495c22185d486e6983(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ebb210ec8443bde47d585085a5258625aece4ae2cce0965d7d8e9f425329e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5eb2a5ca583d988b9ae49683fb9df315d86a773383a986e61984e3abfa03b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1573c1abb326412d1940ea7a4bba9620679fd8c744a61933e8b1a5d87a89d55b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cd71cd9b6ea038d1162f19958d77f5690d88800d8478e972cbb6b7ef4284459(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff135138e60613856120550bd49129d63920d1ba969b09bf12c24f231ff6c28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d966f8e2745b10b414f197ab83c319fbc7ccea2ab6512d9773cd91ebd6ee6d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4425aae6e35d0779467a054b80d1d6f322d5db6a6c1b51e9795ef9aa295f1d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f5ec7ef78f7ab56450c1b8e79ca4e4d7b71ce3b79b7b7454ab7c24825d3f1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d665af1da371414ed07dc079754d770cc9430309639d4db4649ae165cb96f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19170c8cb3927d62a143fc546932959db18eb44fa93c35d398fc39da713a7da6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a13d7cd07e854e93f91945cc9f7183f11dd30a40027ff2b82b94e408eae46e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808c40b87cc739e0bfae312855e562c4cbfde37ade791d676ddf57be9132ca97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e321d69d52eed4b78229ce9a2e908d9c70d2c46ebe00b33012c33ab81d59a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0173c0f330bd4f3e876550dbd9703adfbe46bf986a177e050f5c36833a3ddcbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba0d88e0e109f02842a6e7c8e74f9061e2457fa2e91143f3245d58e9286fd43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0045eec49192a02e64096ea57c4b82582a4641e7bf324f45a5643a496453763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10c5be4ce3a4d42631910ee2ac3f20cf5b95d5401767b31ebb0b0c826770edbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897ab94ab7f40667e001257d2969f0a9294f088e54f38710f0bd4b4f8e9731f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86202bedf2a2e38e4a0d32b427ab4ea01cfe3200c167733cf36d62e353772cad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf751870095745610d1bed29a7976c1995f575c4e30e146f999a8d5f5d9c44b(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6c8325d245d301e677616f3cf716bfe881130b63bd4796fbd3d85e44fabfd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e952fea13e85f2b2032cab9623a66aedfb58195cf7653c7992c193d3621562(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7e1ae069d0634e75eef48f3f2aaa0482e3b2bd6359a3b861004f105c9185d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df35155b369aed58bedfe7406a13cb41ffe538efe2d5955b94b8c10bb931e53(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a821aa88efcbbb2e90d2d078c67e376b0d93f15e8577243de67b2f23b3fbb8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683957369b74535c269977c49249d35667808e2ae0ff0a2078563f2f6235a9b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3de9fe881faa23b3b304e25983f80784991e11e6d6dccde5f47912c900083f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8bc6ebe1ae044c3bc508215b8f9db2691008c1e4589cb77f29e13eeae3cf4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867ecf65de1a6dd105a8c0f738c4824b28517002855ed672d4a9539b70a5d9fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3a362beb57047ebf56f9c514b4fba38e3ee435e09e1b9aa3cd0403fde06daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbdab29edce1d7b3a7aad7742a6cc292258cd4bca2910974e73f70b4caa0ac10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c37416767d423fcd5e7f76331cc1188aa5cec3a4b7d6a2684e5bf17f97b3153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886892f2d0a76eedaf33021255a25912306161263e08274273afda34b39b317d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a6c90552c8df74f575b6f275f14828390e5f79d51001f1ff57186f6d27a521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__852045479089930172a21699b55655792e953881e917ea8caf633c718c0ae8a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b297ec9c07aa5ab6d38a2198078cad0a542ad7623a37984d3094afd76d30ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ab0fdbfba3b3910657fa54985ad9416c442ad44c5ee12f1134cee36d342533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893df2f6aa42cee9c789769d18786f607ba2f6dda3bede8ba82f10a592747838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c93698fa7d9f3aa7295017f75bd098170087494310a734612c9b4931eb0d38c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251950de8ea5e8aa6bb3730cd9e5bd6802cb00fd2d7365004dcee09cfe6b1251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898c0a7ae7a5551e76637ed4f406e13734edd302db1dc71661d7519957e8b307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14a9ec78b0fd9d890908e974779d47b45f5f6611f577efa6b27f85f4de58b52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f3a080078442f267f7aaee3bbaaf96b75f9ba95c5545553cc9b8ce08d0e644(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42957379db7e7698a5a3109abd5382e309ae1198ca78c7109a48d2a2ec73f09e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d4fa33b469ea992027c9ec208daa3384737f036006f27fce01ac3ab830f965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b3d543067d6245c779b6d5505225985c52be1578e680fa73f3a526b15c65a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec57bd4a03784d8b60ec9907be6d2611a057b3aafcfde9454e8c3ef59a343f12(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f1967ab6495492749a0c679f81134e533abe2d8f62a77bf6d3ca0d79437f34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11fb73c765e8dd961dfbda326285b860b0bbdae82418cb1bc7b32ac2829be298(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419f69148d14169e26d450f2c4ec52f0fd3e315a070906906ff8371b6f5e92e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__153a0ac5bf497821843d204b8632d975890ac099a18528034882c12243707a7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c80463a07ccd6f7d5727c6e7c93b7a18b7637266c344247716cba028b0adf4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb3218ad6bc72212d9285e0407b6a834f28f49da796b73f1bab6dd01e56a231(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030a9296defdc95f8d3687c8d0124fffba6d79f3953d4edeb4cc074e0808ef40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f866bd692f157caf87997633e2179bab354f5c16e0d213d56bc930a6d7df46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777da2b59a83ebfe1941e1637ffebb2ceae2421920d7e2c036f1c9fd2f1d85aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1bc5a5081e8b4c676ff184a75ec93254493ad08aff44c11129f30910b77e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c91ede26fe283d2a8a6ec7afd1d74eb6c53fea24a58960b44f9aea34a3068b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db66a4e9e5a72b39f2481f08bf6b13922f8c87d426f3ce6b6f01232e46014d70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2f929e1e3bc5f0984dabef43d8a92aa29a2212a9d6860b435194afc987963b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a90b064818511f4e6ddf5ab39a87ff2c99431ea8da11821625c446de4b50635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a6fae7fa753dcb60aa1ac673a9301a439d1011d02e52bf680b598408b11eaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf09078b48494c28eb0f56e0e6d7e339d7b888115bf38b7f502b76320d461c2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd345d5758cda4b45f5dcace491c3f64c503fde8bc98959a11f8a0b68dd6400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0161e0a4f4ab0e95cf8fee7961542636a91a0d29e69eb83f1f08be11fd177def(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2175808c50409469ce2ea1545a5ff888c198f0f8fe2256de47045c8fc9f1ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4abb08023d45a306df4ed0fc6a493e838310ae5fec597d8310ab9d1b2e1f48f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae19c4c8bb48b41d10b19d46bc17cc55f19aad3b488c1753f212a2459bfedf1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__829c2401b1402d6225bae6b4837f03447f8b583148ccdb6dc3447618984d1bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552a6ed08ee2d6ac1eb1cb279cbe59d874a5952dcfaa4dcec70df17d2504b74b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffef68fff6f035f1ca9029e0257ac5c76973839e917abd0eb898fe8e241722c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c13b59f1f05ac80982596bccc5c7398cd6ba8d046c9ff3a76fd5c340a28706a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba6f5e269b23130fe04698583759ca8c15e7c4d7b25c870df4ea0761ad22818(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96072031784f0a78800b34e0dc2680d28b9c481dfb4d2c911c77afe49197846a(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033e9a5226cbf1bba169a4f14f3ca557f5d0a5d975dc0e2f7e8abf0ed3cc0351(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a956d7f0f8c15ceb4b53f5bfd97f0e4dd8d08b639efc3bf43ec369de4631539(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d88493969dc7b32b9ee399c8764800cc9f79f4f8773a3e99fc831c77f7723d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fbc37ee6796b4695fe763de883bf01027eced70652127a0856a703302f43a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c37c1d8eb4a43526d21077c59d04ca6e90485a28cb162f7003b9f1706c2ef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181a2bf6ff94976fd0c46ea6f908840649ae4961bbc23c49486a8c5c1f606cb4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a1c9917d9f509741745542c521d0ace3abe4dbe387565873186632fb51baf7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd97e35b66c41cc85799d133d237355c2f95cdfcd2a084b2586e8fb4b6ed4bee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75b04c82d2ed83289790140a9f0d6ddba7459957bc1af8732a70dfe1d395336(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64e2c6043cf185facb7d591c4e448fd270c2577e330d00df84647630015e7da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6781496b1b1e3fbd9378179444cdbaa501e993835662131e88c146b7ab67a44b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2990270afaaec385a5e7adf1a6bf30cd0c4bcc999ae4bd98f23c112d67a42f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec574d0b5bebed117a561cac1b775760b384707ade1642ef980b902ab3a0c4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fff20842e9a14622be25256efcf5603e8aaf61a407fde1aebdc5cc1f4cdb875(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e027870ae93d72a971e115888ceb9e06d32bd14b0b884fcc5a0fa961b35576(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc13d9ca7037947c1a8d8671e1faeee5e1ddc5986645982e55c573e1fe5161de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d98f5e5d92c8170e89addba5ae1101ce6d5aa1766815df3b322fc2f53b51ad1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4e52079fdd7f71856142b12b170dc7c55f9842a2fc7467f5061f27abf7057f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4be0cd3fbd5ec2373946904ce1cd6adfd9385d5745cca3886b2af499155afef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1842134929f928efad2619fcfc7458826bbd67d6648ec02d792794f25049996(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1427288648a949cf49b4125367adab012ddfa7666c2c944351c55ccbfffae4c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0a97fd725e060a810cf1a3c95a20f374922d0073edcd6a4c49e8baaf7c53e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcfec5b64a81832a429218c528b80df4ed2ebc8fc16390c1b9f7256f7243281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc9cade008ebaf5edbdac5cf5ccbebd3ed990452fbb8c513385d6f9c2b9b7c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b762db39f6b42aeef7253af01209d023e2d0eae243b64b5c4de1e8b2265f876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a281f0221a1e171d22a8cf20efb80aefbfd46cecbcf27e1321837b3a59b455a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5000409a355ad0dc114ac4f1c00bb3474260722b51bd7030beb57c939d42ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8ed0e004bb684420a8271b3f651a493bf245e9b06737f30128d028c2c8f1e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80b21b7a9dd5ae8b9a5597e0eca315f055413b73c88f0f5b11ee77d7a635f8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a264f3eb5135648fb53a6b939b4b6f7363ee5caefbc5fdf2e53ad363adbc25bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f3780c0a04f7bf3b833976025c1fb624c4c5e3166d4bb1e89831fc58ee5ab5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e163779cf846e4f6f40db6aae6bd02d992c2d0957deceab17694e42eb73eb677(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8fb19300cee6ac70ad07063524e8a50fca95c432c174b5ede9d696231176a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3e612bb72b5eaeeb2d8377b32324cb20cbc205c41f8103be7032be06026cc1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40ad83cb7bfd214ae6b20044cffa00ef52238808a06e1e06c2bba9373fe2b6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bb689d1ce805b15fd59fd64a8a31ce8efd1abe9d3259e3643b90f116ee629e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee7c9c8a6f9ed2604ac927313e1ea57571f77a1b1c94904e80ecf163df5b0da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278b3c0dfdea03211f823483b20a9463f15369023942b233d0b09f672def5afc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a226483183990cebaae0c544bdeeeab86332d94cb852871939ca400e09e653d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d67faaee9c13f12181a94404675975317301ce6428b4a1ca1a06a476fa158a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaea0f6ef57e0bfcef816550c2e80d0ed50108c667713d2b6963e61aed024d4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add4ca637fdd841e3cce91516a15ab1fd40dbfeb158dff1d7cb0a16bf6e251dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459606150dac3bdb90b7bd43edadfefe83c637cc539d9112cab32c40c1f6561c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff879ad53fb21b78e3db8095c3210f4af86d4a24bd23b32f266776c462cb442a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5995c7a9bdc0d26fc03cfa63be8acc64a218510650b891021446a9771437a8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6996629b053aae7350cb7ab22f4329d862ef19d3f8e62056b0b7725fe0b58e9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d975a5f1b0208968b49cdb6868fdb71b62b3a1ddd794a54ba2619bee0c5cd07e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaec5bb079d2cdf98a2930c0d980ce4387dbbb51c2e0d2a7054ef7c674e830f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7635912ba7916944bcb83bf8f6de9b0be067b4a976227968b8dc707ba0d70a5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7eead1d0cacfdec02770b2ac39b5aa0e12416b76c36fa9d818e4e70d9f4239d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8beddf7075d7c3763e98da8d48a1b478e8690b55330796f14c03767650281e5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dbb616f0380fe6b171e97d97466312c45a845c8cc7f527aa6b92caeaf258b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdcbf5e7d8b99b1a025caf07597be280edfc03bf81953d4ef16c00360f200aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6106b9b8968404861928b3e6c666958b25becfcfaa9fd467f3b380773c3197(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__febdfadeedd0e957d1a09c09c65dd5ab2347686bf13dcb058e18e3c236af150e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4230d692f7cc96c42e62fe6f6fa8b59730239b97d96a505dba5f4e8f2fdb0705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ddc5ae9e67be21d878a5cd4828323ba42ff4b711fbe5a4f91f5318dd7e7bb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329255a12df3fe2e0a219d5215c0daef7dd77491c30c2361d5e3a4040da3e8b2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c04d6e6cf84cbeddbba3acc32578100f18cf40463675f39b4dd437ca9856ce5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e01426e1819918f5d79ef2e9e5797cbd56d9288a39ae502bd9e443ac47b766(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb53e996cd9a2c3ead10adcb8e929eb0748303e70f29ccb7d708d80df498fd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86385bb511a729804b69f21496f85c51664a090c8708a768f83f64ab8924f4d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__affcaf21c8311b7b52e59454bc8c7251039e3d683b15affef0beafa9905a066e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a5b28e29fa4b176993232643e33c042378b04f48ce282900c6af1f05ced833(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91bcc74f5665fea53172535bed34fdcce0f90d393ae642c1695f0cb8ca8338f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfc371b99be9ab6b453f9cbe7bab04cf0de78d19b2cf72d16bb5f7a73c64f82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a33af0d8d2a3854c9870732e97fe9edcd5b31b24d176914ae76c1fb6c5ec32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769247d59e8094399c81d95396db905b205b330f14e7764704b22590e1004847(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974cabfb78f0a5d4f353254a8f9d2f1dca8a732bd22b1e700eb0dd00d4047387(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67bea9aa7c7d304be90577877ce3f3536bae59209f369db5031e184d78a6492f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19aaaa4bcb10e879201394dea620db2dab5e9a71400b76e8d85284ecca6753b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ebb852b48dd3b9fec9e137bfa8254e2eda1e710576138207be1fb70d68540c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68bcb6500b685ac557a5da34565dd720dbd057f0ea2a8e163c818268b8c63e06(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743fa8bc8403c1d7e1c6d4ccd2522f6ef8889a1d9e20ba3fc264f914a5649948(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9312437cdf545af43b7e8391489e5265c6b6f07f9c1bee454e98f4585baed7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7409378fc85074bf69073cf68c2ea96b33f2f17b358bc3c7230cbc466c4be9a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726bc8b9d5d3ae4b41fe4a06dfc96855199da9624a6e5592a13c221290cca596(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c93f54bfd599d4f5f474509074000a164009bb22985f7c0bf524178f18280e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97148a7b34521de481820d03fead325ba76981b2efba57593c4da31010c24fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7e0051e384f836f71161585cf5d3d9e53fbb6187b5d7653f6f3cd9ba109605(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e61ad9ea852730c48be3b5145aac58387be1feaa9212918e51b5b19ab614e3c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c0e6fea847b559c341ad510a98d8fc44287b98f90a3bd3168c1fa1adff42798(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0356e3d0ea7ff85ac17bcaedc154ea903c7d024cd15615e2bd496f91ad9a85cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd7857f88217f58046810303bf4140f3fd2594bbc61ba27451160dcb600ec19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258aed32e7a7e463303fc52c8e85d730662df376458020f1d9074ddb8f0c4434(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e90a51b9e6d84b9bc5227d404e82bdf6840c0e80543483de8cdd492743e2ff8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb3add31852ce61118c240529e7c2d8d4d71d861f40298adeafa2435b2c051c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234d35eb94e3d056856ea41969f9fa0859a355ec00df1a1e62d8cdf70b961f6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6deb4f7e2cd4bc61c05fa4436ef323184a061e4410880ebc12fba0d1e791111b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9275baa9724eadf39caa492948b4859b2952165b31846e4f1a8b06126f24ceb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964e5262584b930679190b203281d30a2fdcedb5bb20a64252da1023d2fd2193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e5a7ecc6d389e4b0202bb06b7b95514589042925c10c4789334e921bfd7637f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41d3123347ca64db2e83b8a87e85925ae316fc9c6a6ff57adf041bad3f6ca30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14255674e118ff0007e8635210e405e9b3639829383244cda16115ab27816a73(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db3b10193aa5aee4f15348d59e830977c51bc951da0982769827d8dbe4a3cfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bbb55fd7fe7b3b59c44a584237e169e9d9003d73984bd2e19d6d92afba14d76(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8737893d2d0a38515918dbf971eb572b1e5f78c902302c80a5f42330da76d6a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f6d45d3e5d6f2606f444f6cc21653c7af01a75d003c2c9670df8624cec30eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d5978d371b2a85df57d6f8d8e2f0f0f0b712a503e551244af2776a4db182eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b18b4a5cedb60877f03be562ca020e4680ffb745e81d9e341f47f03f03235c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f458b22e8fb35552f882df183bafe1dc67ce6e7b26c5d2c70dcd2496eacec3b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c73d6873a8f3293e3d695ef81393a73941175aad55147d6cbed12c411c2b1826(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eeffceb3075a87f6a8630fbeaf03907066f00d61904c74399feae6339f17ace(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9b5b1c6ea39a3387384aab9d9a5cc4ae782e96325fc83ce643a2116a5c1125(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9cb230cab2eabf8df78fbc24a277d0acc05e86b172d8b9ac62557662974fd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f8606ed4519662aaf1a4121d0479c646296b86575236ce8063aa9469d1e352(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38480f22ea0fc04cc16af4094f54d2319de1f12749bd2962c6fca3e8f45d9e5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4649233953ad33679e3ffb6750a55934102c40ae17ca22147b45cd6154e4e4c2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a4d38fc2502f0a9d545c0d7a18c2447ec97f9d1ee8430aeb18bee8a738e292(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a8b3382904dc2518ff3476ade13509b0eb32590e9270ff527523c35624c4c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06dbf502cc0830d2ffc29e15b42d02f6ff529fdc34c38643b404dea6d91db160(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd274e4ffdde4c264824a2a1ac08285728ca2ab91fb0f89ea9f5ac68e302146(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cba4f547b4b9e70393f473f0c0fbbe872cb05a7769f7d6de62ef58df2b5bda9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e462529c68083d13ba0cc68858329e99f6e20dd7092778e1c60320b17f5cc32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1311203c0af297858d872361a6b1d7f154169c457c49eb2886a9d5baa9602914(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6351f2d30b864454a68a22a7257d959668f7d50c3442ac2344a6693adcbcad3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7efcdebe0dd2c6a6a49b3255cbd576262ed074f70e1151c5695965c185014c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce7ed26b816ad79fa3729e65b13669c4ab3158118333fa067a3dd2134f6341e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b319e873837acef6a4d695f21d9d6e9396671198c5603e580695b69a56a7ddf4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe52dad4fdcb12a0640420c70b3849ec3066069f815de8309236264f7f3b1711(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21fa3fc8a3bf320bfb9f6393a94cb0182b798ba646eb93ad0f7e8ef4e212d2ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e09c3e77ad027fe30b53e7fd7bfdeb86de946a6e00333282fb15d214b9436d(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22cf695fb5f942aaa463984a5ad1ed93e30eb157e61f35faa9e71a6297894358(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0b5dfabfbecb682f355906ffab1f860470b34d345c5d28c299e4a67b8a786d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe2b3011b538c68b4467f40e0a54222836e266d192e4c5c4a6827096bd7d439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa181c9ae05b385fea524c0c47c1ca69bf83810f9170604a607e6e9f5b28f41(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c485e5fe61e58a6e232cf0ce69d2baa5f481b3cc3ac96f2dbdbe1b7fe05eae3f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864b2c2f25d59601fe6ee3f3f59897fee4cc5770de99872827b5358011dd28d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a876f35fe8c925e1710ad281340491f8b32b8b64ca9463425685560be2b9048(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0513a223da046c1b3827a76231ac26488780432733062a33847b0db552dcad9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f03e8bfaefcd32b662e499a9a1da5e1726a9f6e76a8b9c9001acb256eec93f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85934676df9473f542c7f0a7f970295cf72254fa62e75b7fa4d8e7fecb888090(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989a276d487d6234224c7d371a207589e9e31cb9c8e8e432314a79385b4cbe17(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a926ec6663486b73b7371a4ebb4a10c7bb32973dc5af796a57a5bd402317404(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704787eb796237bc7f1987b5a1da36753e67d9a6d5dc6ce50f101e30eaf26eec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cb2f6f67976db411853b224261bf3e4736b2d371901a772d46b9144a4700aae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9519bf99ce0a43c5ebf285088eadf87c11b04ca54dcdeb665f70717b8e6f9d2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7137340b0127052d8e5a21e286a77e42e613c0c60cc93ddebf990e2b6a08d87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76ec43d3a669bf9423024fa20cff0cf8bb7ee79d2d88bde7ca208b2cc98eb57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212111c9e1da5b2cfcf47cab30a21df0d9374872bb54d2d64e2b29d5820a2daf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdbe614b81a090080e6501d1942db4e2154fb11f86a29063244415169fe40bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874783236c2fc7b33cb375522f5c00fdb22452410d16d96fc4e4ddeae5f90fdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39399b94a7c86185148941ddefd66030344f8774f0a77e44a3486b108a389412(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b77fc887fe02f6f66b3ce0e2eb3230d38e99b87ab1c96b8f5f37b3a64387ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0863ed28547d338e1c39b7dd86a986c32493cba5be18104bbd3d15c48775a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca3551e3a6afeadc06f273663c2bcb8970dc1deb53dfdd1f91eebbbf3c62e04(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63db07163dbdc9967f9d193a7232acc167971c4bf7b07db8d41cbb4721678292(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51228ba6651caa99e5856a4fefcb31938fea158365f019441ea980e0c54ec32(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b42069909e5c1c67028f39ef802bbf371e9383df9e6d6f6d44e650f9ba3bb62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b04e7d2b4327abaf9a6054434e8de0e0b4ba042ae24c1568b89d4baaca220b2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd90d37f80cf9ef3ac7669b397f726e7a9662e993a2220571412ebbb7a20ba49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a5028f5ae5df1b2340ba121f0c18291057380e7bb50aa9937402bb9cbfb3e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67366d880e0ac77e748f024ecae555b71e307fb5274354b27ff8e92519eeafb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac431390467df9c91f3b7392a603017c02b2498e1fa169d207f930ac16e77db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e97ca2707434410f0bb8d6a3db8796a121af1fb53da3d6726b8b73364f0e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4f533b8a03a542ace2b6946152ce0e8a83c4a042db6e5b8017d15f9c5ee996(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eaee5f3852fdcc09c9093280a7e28c61bd3358396c56657f23f79ad7c3fcbd1(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c84a6ac86c5fe8395f9b7a22a3328669407259af3cb06b17454506dbf0e7ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73af304c6ddb0b15833f7cf6db0748723d3b1399312da3d8f2c9004237576848(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc8893ba085656ff64e1d3c40bffcd45a479231561ec6feebf8d0ad1ac6c8d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d070de0c607dcef3fda01bf3d3e38ac58572cc5c6f8e9c1375ff17cc09400450(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bbb01c5e574a7ff4f64efd9ed192be3fd1fd7f60c305b6379d16593ee2a8a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__802069f9d1906e3d4053e67710be4b6b741ebf928e7609a525fb7365416d1e83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364a4dff9044a213d208b2ee01143200b40e9307d602b0e5d20f77dd84df7171(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0938165c725b5c76640434d86367aac35743c80770892ba8ee66fdcf764eaf09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__462b1ae8566ae347427b8dfb0a44efe80a6d4a388e7b73db0eb319afe56cff6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1dc4ce299522fdc83ab55d904c48ecec01830c1194db122638bd446fcdfd94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a187893349df800c4e6cf36627b9bddc0451c1b22434c14f4b40f8c910284eb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af68af34bf6e8341959c5cfec5757085d6b0373d0907302276e83d428798daf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2129943501366f586f4f209f767814accb8a418bf4b41d948921d97d2e15715f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7a527d258515c19de9c76562347dc8a8b9dab1e74b6fce4fbbdd1582a7b8ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ad21a110ab7cd2a5d06e2c09c4bed03d4279be6accb88908a8f7505a9882c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8663db3b6ea8144e0266f091b94f831250cee32b71f5f689518021b3505de1d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed54e5642291d70f563def8e39fb673127169cb3c975943036993b3c7cc464d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9717311eefa35b497b4a46613b6f24c8c6c95315ca98b17f21741240b7b97c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0855367e3b488ba469c6c48ce8de2e780d51cdad383403a502309005841c097b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1489803e50434176bf9739c30659fcc5088763ee01fb03e0644992f56e2ad1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46f3c1da093fae99d237109021c472ecb9698f82020ac9576a557acfa221cb7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b061cbee555a5e64e778f230ed69d135959639eafddee848875ce1930dfbf5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3b86205c315b676a9bb8d8f287842b872979983866c8d4f270cff4c7afb610(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ecbda62b797831747530f14760224bd14cffc62f07ec88fcc778f928c37263(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dafc58d554e672f6a674c19f170e0732e51a45e4b05ca76fb081b6de04c12656(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2bcbb46101467f0eda820ccf58ad97f4c190da1d09d97a37c464a99783f49a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a231de53086267b50d7dc0cf9cfc22fcb2ed09fc9667aec8ed523f7219819612(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea6448d42bdfe8326b4a7288002969de97519821f269ff8770810b384f4b30a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e875d560667a294068f66a5fdf4e603464b70f413c20c33ae7e75a3c113cedd7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cacbeb5490a45ee3071d23ca631b83e1c4446193a94f05dfaecff28a815d4f21(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92cf1e80a59dc687540a5087e2eac7702429dc766f3bfa31e79f6987955a49ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3a3afd79c8202ecefae6acb788684b30073c00b269e61e608e7505aa6c700b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9025a1a3e876f2b142c596cf779f3eb7cf73ddb1959f414ea76b3b45e5b1ff60(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca24567d998d9309de7ac949b413ae01d683f996fa633dc7cab1ff044962cb21(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d7aa70d9dce8db30b03b33eb236de48945e27a149f7ffc34de91ee7a55fc76(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c544c3a880c65d30c270ff9a0f4289b69392ba06dd794fcaeafc396cf5aee9f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37bd4afa3c52500052daeaa8690b1989d5c7b7442f252ef83d5abf744df608b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ac727ba8155a6e7dfa21a9b1106283cad896d8e03785f9a6cd6d13239ce199(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f090ebf16641fb32b1770188d0fc5a3086a0d5dd043dadcbb5a9dfeecdcda07d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a2426e0ce7a1228346c8ed45e33b48d2853c1cbc0f6417247e6f2d5f0f642c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bff90cb7ddf77add0e9ee7431728ddc5ae32b53c5f5242ad3434d251ccfba9d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a859d1821a50ed82d83864c3ecb46fad157604ab66296a41c7ca41d8ee9d8484(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae4bdcc968e20bc297084042cd5b79e73002a407629cdea8011d25891a6e837(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e29971f8eaea000ca884164bae4eb3143d9752238f81244d44fb1c2910549eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5c9550ec0bd7aa9ee30a6f1307704b554bad9f10c092e3432caa61ab6dd3d9(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732251d8322c5516ca94bc26b8bdeb4b2c5ccc18b369468a9367a1fe0f4bbbd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0870755fd75a3ec378020cdbbd59a582404b536ee205b3883a7fd7321e93577(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e58d6e7c340487d78fd654233eccb70470966f9bf1aa0c2ebc86ced6f624be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5308d1fc55add7db8d2d3e6653a681346e2e123dab6185dd2bb054036c3707f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e914f9b3b4393d9cdcf8192bb2353bbb3ba4d55a922b72adeed3e85df62cbc1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc480edf6d7abb7a10e275a1f00d7144064cbb0728e7838992f54eb84b9c850b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__081dcdc40f72872f6a5c1c81158277e946f6bec2c197defd33def614bc8ef508(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d242ab0591cdda61f227f33d35818773231a08043210627776a5321006d1b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c3fbb2f6c71a681294d53688660abf3225eb528b44c4156d7ff02c751e386c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a5472cba036d48bce16c1bcce8ab194df06014b118339e6985ddf971a01f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b493c1954cc27ff953a8f0377154d2f1ed40d36c1959aec2cd2645fdb6fa69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7125abfd3c173ea5a0f9c728ddbaefc28b5049862c87bea1df54a8fbc07b9905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30837f126202b960a8e71017b5064aaf299dcaaa8feb547ceca0cd52a02e404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a5cb9d2cfe8b9779d7c4f7155405752caa523b6b249ef259e27893753db8a13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60ab2480d4209c2fbf92807bbdb4572d3f41e406090914586216be187eff565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bff23792d4983d6ac2922add147c1e0beff7fe78183b3260b5f75b140ea7b78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34d8202f2e7110af9609f7f2a822978d505f785a2e126f74f61bf942ee0be63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4db3b90b9fa22e1f30fdf9ee0387878e0cac647948e102f5e757faf843a1eaa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7e40d04f6c670bfc21355d80e0a7655016b1c61b3ae4976ab0f77a02ef3e14(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47a9ec19311010982b06f58c92cdcca93ec9cba83339ae39a327252d15bf4e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1554d77f0f90fe54c8fa036e3f0e4bd6beada8012bd0c714e57530b9ca2f5728(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf67589986bfe02bf099a92e0f6ba90a72c3495eb87da1f8584cfb9a7ffc1fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44e6947003e32fe9c59ee98a09fa64913768a6b963e8f534bc977064289f9be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a296d41da3e949a1c69826ed09e079389d8f6ccd62e8a903dc0184d344fadf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e26fb8b0663fe9759f60bb4fdfc743f4c7b7d245d9733592a03bb1e15364d23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1767becc9d6d5b3ef02eb102525198eb37a8e5daa3e930bc2a258b596bc3d98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b3bf13d6d592c49fce14e7d74e81b49a2a115ba800e20e0c2775fb18cd44cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573b9f0654e00a37c8fe6a24b7e04de116ebaa03c99897c26ae8a3ff50e3d1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed838aa21850c8cc4255c21e9dcab524580d06701283442e02d8efaef2362ec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc0e559cfec08916cfbcd880eff4a1274efeecf36407fde7f86989cf878e14ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84387083660bc45e38a6d3ba8feabe8d24b5bb67821e9923363ee26a06471b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2637391ed835151ac8500fe56da9f5bc09aa2c9c21c9adda05321b47974a2d1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d69a8a8f3de647a129087ae65792860cb34eacef02463fd363856de9dcae31f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1fb58f04a0930114fc43d9a2d3a82fc01d71101e9d7a30e3c5e49f59d3fa7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14858dbdebc9193db3c2139e9fdfcd0a80d0c06479030f7c6c3cd950c3a299d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d62cd6d0ef72a64cf4d1482672caf65d042b4963ca35b1de30adc00519ec67a8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d62edb59c152a89b804030278573f6e5eb258205ca1fb123e9882924a8b7ff24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7e4fa953b56547f1a2e5caaa43a297753654d2a3103765b94a4ff51c9df5e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a29b57d90a898af3abd3a250708b22da4e46457d20d1c7f54873677afbfb66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32986e947600323ac9562e68d22f42fbead50f7600d44bcbb69fc79bf7b0457f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f14eb89801a7dcdae3c2f6998147ed33438d60f18ea8dd8af0d4890947147e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591b5da94f41b4b9b053a730286ca8316a2b0d170c5a86f9a061f8581f8a9645(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df2908f4e13847438441faf8572684783134ef903ac2b083c1397b768171c9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6dba28b5efc7e83ce18a05d9c29ec7a21be897ce5a1e9d41e8534e70c9e226(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c671d9ef7f73be44ddfb70de9ce15ac2697de5a652dc738fd1358823caea4cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a96fc10e5ead40d2f13fd5979c10b5563e8788d96a2adc69b26c4b9b1b30133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e571d6ac0ef38c2ca66c9e0829d6c46b5d34e13914479787dffc075b4d3dd50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39b719157034fdb22e7f5e5d811b7900c698eeb864b8259a4d1cbacc6ad61b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d9a4c31a9713f48a23caaf72e5b987254f8ab21ecded4ab3254a2ca6511db7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ac42ea5d8147f54ec914f29c173e2425d5ad8b453365c50d9cf6f13b276098(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4a6edd1ab538b8a7e3ab3516ef2d61d4b28280ef1ca7ef17ca6d5ca41ce9e6(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7d030e0640f22aea0c174cde88ec526ce62cb6b3157b7b3a713be6af7319d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e90468c75cc53c9212926ebc99d84276c93f2eaa5d3fef8a9c7f53a6284c07(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fae7e1f52c602d0ab4d9e8e78207fa5b246b91f5cdad6cf8f1cfa716323168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd6be744011bdbf9bc665d0dc73a36c220335bd555598b9229f6b6583c0d090(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed33adef4235a399526ec38474611fd5fdf76f8aa58e3410dad418683760e74(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e18a74b780557bbd97c4f4ede370d3dbcd4e0841a15e0aea89f144a792e7c05d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7818e623445f6085da1a8aaf6e0e1f263177f555a12332a7b5921a700ef2ffd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22934de58cbdf092dd6ed84667b4a9cc157007bd906f3cf4d2af1d4630b91fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__058ec5eb5a5c3bc04d19f46911081fde54ed13bf0dfacb8e2e5998fb615722fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8290880cc0e2883bd8f85b7cc0f6ff38d39f75c5406b6801016ad401372c9c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2645856801c68943575e325168a0631441f7b9416338937ae65c55c13626e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733d0bdef43b3eb1fe7d88b56d5fbc85dfdaad9fa6382a54e405533f085a22fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654d63d3eb4f4ff666dcfc651fcf0236b07595a51cec3cfc862a57ccc6ba44b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acc6b96d999fcd803122114e7dfe850e7eeba3cc0615094d23cb246aa5b533f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fc39756d9d3ccc55642e50f653a3c4256e3b44701495c61c5b6f8e0e1d7284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908e96163dcadf39146bd314dbd95dad5a36bb4fe46142cac7e29075b80a4153(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e737fb20217f97eae0c3a512a1723b435c87a79413774b3d0aad09a810906b0a(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36ce233fb99aea46b11ed301d364ed41a67b7a61e13df22844817c148485ea5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e62a9e93e583e394766d7a11fb2d748e82e154cc3635f9a1121b1adb8e5f71(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fccc41b6a838ca117d413e4e5012abfb106d5fe9ddc20e9014598961ed18bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abcaafd7b67405548ace9688cd4c0a415debb5b37bf5fe06634475299ed96df0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37322288208349c15695e97dc8c843d863c84c1a2738ab1628bd5381064ebb0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb9a6d85ee8e9a78efa7df8036689b06dadb6cdd641cedef5242ad3905985d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d9eaf82cf2506ae65bee02640a76828323bbfb344da2b23a2bc69a6c45f22c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3275a4c9a63f14766a5fe76f2e82582b35eac9238a3ad7bfe489fcd5c43a2a9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e6ab32a6abb6db417dca1b163631f95dbb189580269ffb84dea0312b2b9ab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6edc457702c59755028a09ee0a283d6286e2809a17a8f3ed735fc4619c0b3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23813af21a49b2478f3e275994027f65db538799a95e80ee4cbdf72c9bb8101(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275e500a5199010ae44296423beb17793f0e43d577e7eb6953e37f215e9cd35c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83444b3f7014eaf7e702d21f34331f37161a26cd324e40cb2d83f257f69f5ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0170c65c45520ae396dcb38baa7a0a57ced6306ea899cfa125881d10ad815678(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dcdab3e89e205bc9fe8460bed7043251abb9f6fe556c1ef96286fb101979571(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78f56fbcef89376579757aad95326551147345f7bb5fe81b0a734dbfdbd74f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b8e4ad8502cf0718b50f2b584ef3477adc5dddccda64edfbdb0cc93aadbb66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1616eac80eb70e457fc19ddf058ad7adef7f49764762b2b323f6c8d0ca1fdc0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4a5c683e9eba1a9e1b12ad44ebe414f6fd9ae615f331cb586cecaaa6b66dbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cef45cc556acacb35d4b157e512756d0fc7b0978cb85b13967f4a10b9227c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09234e5b529f1bfcf8662ae71158488178241145fc9750ef133e827dfd38450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbf29874db7c849141be09bcd22e217eec37c5084612d852c85a30acf53b6d5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878cc69e6d9305564abb5203e5c22da68174d74bbe476e39f58a69b2df16cd33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b66eb6d1731342bf36dd61c52ea48b510f02e5fdc6bdb298538526c941159fa(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56a0f5503ff9622a5144afc9ff92d815ac9857fc17f05306c8a49a8ce4ef85f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46375232899ae74e29522a97d236eadafd9bc40b2a41b3199cff5f23c9763b09(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d994cd9682effc72ee8eaab6e7be213e223ce706fe0821447a4bedfffbd89a2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc60a7fd76c94d74acb13dd062ad6562c067ff9f9ede4f5c4f13e5dde39fcb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7735e8e9c4c8f0352d5d81568314b0f24278b9d5cf0200cac03a89b6f567c35(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5dff934b4be4add64736bed3d8becef2f515b43ae74d9ee788910989026bbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc5df6b504a22e83373a50134a67bf1a34dfc4f81d22ea2d78530fa3768dd9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74909ee3117516bc466234e705f360a7a7f7b16c97a807f05516e0f2218337ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13627d298a3a35e297bbd5b9716d5611f3ff1be99f1ce8b70b7990fa8ddb0277(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e59e81e4adcc9e11a4788ab0704d56e38f9e5d1f36312286529b562e943c3fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac4de92de8fb90b2c1a7dff40078f7e39821c456b8ce6a152869a33a7db6d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e603f51ba58e983686a0b56c0847701d47b93f6441ff9d4961f6a56f69aaf03b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94b78d0518f46a05879830fb598744d11ce0c2b5fbe5f59395fab37db4712ee(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fec35998780a1913dcaddabb87d29d7a91be067fa774d29d3d2b21990ebcbf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8120b033834e5899ddfeb8eece6a0380b686c4787b116c27ff8fc750fe73a610(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9764eb0be1be62924d2f0c55388fe33d5e533054ccc7da389f2fbd544a11a12f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00f9398931587f074e1f317d5cb8dacf1fd9f90ab28dc2b01825aa476751780(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a200cb50b0bb5560e0534c3437658da2e2158fc7cdb690c1effc2d954a9605be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76110b6ba3e4d116684d69c8fd5c731c7ae244bd118d7349a733804a932b1d18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b756a24c2cb3b59502265789445e2bdce56ee0c4bc665747743970a98571b5c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c192530850e140c2fb268caf48c7e17d68a1b958c9e8faa0e6c5b4472c3e572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142172ed34f9817fd71199e15b6a940afe1103c6559c605f06a06fa2f79be7d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc73b063473a5c0976d24d02caa6f8f229c47a834e87718c2e7ec86fa2817f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2516cd5574250c83ef9fca2e7b7569f9bafe281871664b14677a92545435928f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7093d0218e199be0c1a88dda11c1b3e89c54090f2221cc1a24c8ef9a0e0895c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c318803f32d244b9dfbbd6abe464ec2e8c468f7acde7a58e23842e98d55d0f(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8eebfc5c560ef8b0c2910354741a096e012bfe40ffefe0124d3cbd8e005b19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950b94b59d19badf9cbabdaea705efc33697dbe28b506438bb1b8fa5b6e70564(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23453ab80368bbd14016f3d8ceaa2479e4a8413382fcb7933f5e8de4abf041ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb4623ddd56c2d339c8ab2b5377cbd51226bdbb0c889a86686ad3c516dae4b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d05b91dfde0324fafcecf26a7775d648b0e8396eed12eee124816242af34c8c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a269bfdc9aea47200fbdf17778c7438e9d3ffb2f42506e434d91220a91e376(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b1345ac1f6e84acb0b0448d87c3403a05b02f648f931f14216d13cf285f82d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d37917393598896e2cb8672c487d8b33c57c7ec69f5650e1d83558c1c584917(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db5d7ba0aab801c0dbcbf549cd323d7a809f6927795df5aeab5a4547cef2a6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279cd57dd62125d7799dc391aa31ff5e302dd8c270af142fe575d896730ac60c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f5ed38f3558e7ec281beb5c380c98ea0dec8e2864a30b673985c1eac97716c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc81ebdb3108d31755deec4275f1dd88a6cced5a5113995b916ec5e699b8dda2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72e41e64d78d728f54e118e182d5e1a46aaed3f4eb60d9d48028991c15d2fb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe64af8a48c2ee81a9752b3ead51a61dd897e934062957e1b03da0d4d1f2c85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19093720e2aa0e36231f9debabe7943c05ff1edf366b523b8d6190c8f2857dd4(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af10eca322a3a370cabbeb736cd6950b75139989c65feb95abdf73fc84e0ea2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88160733a08c25ec5f1b8135332c3b970a36f6ef85b7bd874e054e798f576fbb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c8df4f2ab5f4642237bffff52acc6cd00a34f606a6aff2a92b60b212efef8b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__494a7da61be4c4aece181df4545338dea572f6fa627f7dbadd14b0948d2a59cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5742c874c46d3fe14955b8d10d39da1056250b2cc917f73a03baa5c93c73afa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775025c9be614c1e44b9588301e24e580cb10df14db415dba186f8f7689a73f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6c4c606c08452780eaeb4da533c7195032714dfc524a09cf54e071fec81899(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b013b8cac8615575b3db7c0d087279925c02107f3fcb1e69618d37693cca3ad9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c308d85997f8e8354f8f36c0f03e5b246d8cb28c76077bef1941881857f2beb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f2ab34917b70501c8adfc140e9b28ece66eb99e06705320b30acb3d77ee867(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d852b1b086d0f91988b09666c29d4256ece720db5985ada379821c304e6e410f(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff4003843baea3da275ddb91b46907c10ca1dd4e365f0dc7fca5fb93fe10c8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d27dca72606330d27452b3e8e5896a090b2226a881278a134612432f3ad25ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13c2fdf5c07484847111b8c6fc5e86011dcd7c70feb61aba564a4eb45c409b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1cff62853a5b69586fdcab2ee208cec718f6d4fa6bb1e5553cdf61427667778(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bdb8059cd97055dfd48e05081ad3e114596747052693dcf47c4cfc0c56d0733(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f9189dd7e02f739a230d4665292e5b4c0d373ea452f0a12c35c86c751ad5f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1444030e810b536bd2163bfcb004074ac21439d5714eb884898b7ab85783e30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b482c1517541b83ad75523897c74b9a91e140fdd587cd500660a434716f85bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__539547e4ce1cd1addaeef0c7fb4eacfafef1f4d4c0d4855fcc7fe65b600dcbb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f88bdc9b92a18330f26990fdd3661521d6ac86dfd69bea4da3a196705f726c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23b804fa35e38ec18cad158b459f2d21bf1d009400b2fee021fecff9ecbea3e(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45825706650855dc7e1dcdb8294177739c5b70d12a74aa114be9a94b225350ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c28206001933d96c3bd899cc393ed326a8edf87cbf6a4530aea7c3ffc33d0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e73cea6a189c196d02856f70dca4b1970ab24fff64cb091094a37dc75cde50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797319edd74f2d334d1a79ed4d092f7074558038c85c688c911915eef2a50a88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884d6f13982d7e31e36ffe927cce7f002df7190d95173923a542add024bb5ee7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ecf36e490d0875a244991f865fa2f3d9f0a99440a7b4e974b65e4af9d3eed85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0ea683f07fd6055cc6f1bedc4705787b76612efee793fcd2e6e776a99b6fd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860be0aa47c5601a9f711866c231ed1f3d63dede5ae36a44425e676c54b35ea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deda14828416839180179393fa40fe21b04a4d7ef09612a320a3f61c772c1184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d7aeb0a1e5e6f2087a94f96061c3c42ed547cc1efd72fd8206040afe20be69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f305cee0835e9091fb926ee1f6614e66eb61d14f8adca1c3f58b56087842b72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3dd089ef56e33f4b7600d787c5538cec40c27069f0d9dd8a64fe1aab5f2ee10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d307c913ddb1c8b8fda833ef21c911d89c1ca66c16ff93780b002848871926(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d45ef24e072cad51f137031f63507a0f88b90c1bc2c83cd809a85d2dfd556a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b004ecae5295b1643d21988cfc202b7e3abec3082eeb868cec5d33af9e445a87(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c60bf6b9196c4bdaf71af9300ccbfd85faa4f2873ab97d22c90962e0018028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b628da7c496b7a2a912723922ff7507cdf04259b8604514df4b3dc4f02445a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b95bc5052d20cc7a95374a35374d2d2b6a5d392b3ba73df9f68fb6e596ae5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bbff87d0e9f016596db5401df6a882be21dad600de9e06689d61042836286ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3658a04f2140f63ce849bd5d3cf5a4652b0b7c9173d5ebbb3236c670053bdf33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73603dc1b49d51f96a02ff4490c9f60ea73164f88079e0f83fa5054358cfe8b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5e94a6616f210d9c8efdeae7f5c4d22cbe73aea668fe70bdf45ed33373a7f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25dd3a669d792edb9fb7610481f88377dc0f5285b647daef246c203fe367e4c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9e640f3fb8ada173ad40abf55798385726e83a93888ce724017d73ae32d057(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7975a76eb522e2e3953f1a20ae9e56e6fc49a1ae70d0fbd32c0c20c505852a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da80bc69256a4b78d751de4da2d9b8a5c0f94ca1026ee4ceefce1a9b31ddb03(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba7424eaf21f91ffeb73d0e118f7fa9021cbfc40faccbe4434357213a3c5bb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b193d1eeb93bd0fba9ad0e344f38104fa9d1e4728d3570b1fc0a16225881b65(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd3ebfe28e368dbdfa75f248e3d1655ed09ddc9ee23ebadab0aa9d64a118a4d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c726c6094c9e732a3aea7771e0163f176e8a3bd481c4bf5ab964f07ed2c691ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1905fd9b136c1acbf9345b7c8ef254ebf40013561060b56e90742b453551524d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dabd21fd3e160fc141c87d1d6d346e9b739a7eef21d93b5185576cfb8e55ee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddf25303f5612e5e3dc878203c8cbfc7c697adcdc228f1e0bb0b0ccadba6b03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b1db74fba238bd9007b827bb6795a492d5b270dd65325ca0a2ec319805ea93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed86efdf0c4155b9e87f05cef8e5f7b8657aff9359ffe046d3f72d6512f287c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1894ef614e8e03cebc5d71a2df67aac913fb72d664f1db2062cb9aad3f6e66a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9627bf7944a6bffcbfd7794ded6d32f61e71c96117d01c509a6bfa75638b1179(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38dc5274fdae0b425a4a01e94df3d593e7c2bae18985184c6909271cae8bafd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f24ba1fc2a7cf93cac65542331ed7f33a96512c6e0732cb78be9f78dba64709(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40cd8d2dce22127c3be6afcd57d048b370445f87322ff6d08341498b0a5367f0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1061bebcd62044b73217423b6f3a126fe51be6722616ec3ed371c138d4406d55(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59470f374119cc5621631b6e5e84495b6ed52f2ad70e1efccaf9c307a98376e6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8729117c95d15c20ab735e0d5a49d4e301e096eb20fb5765b6267b77badb291(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83510e09bdc2d272816a747fae07bc64f2c57f5bce20451ce678db2fc5c466c5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3642b19b0d91089ec73a9b8016868988b7a49d06c85a8ebe9ae89e461a82967(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3556ee20a91ab1d337c495d14774e7ab68cad9627fe23e9aa9592722cdd83f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ddeff3fa9f2bb25362142b3c084a54ae3351890c6d7dbd1bf2fbb5d2cee1c03(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4399ec2e9d49f860415846e2f787a4b8fd953dd1f8f84b5621e9c1835257f63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcfd1d2189658df3a5f05cd89ab5ba39d161c5fae1bf64e4c1778e7d4d455f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b141d2a8897f7cfcc02d3f3c63df37cf6ef6b4c81d89745ea6f3afff656bc048(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ebe3d4661f36c25342fdef8dc764d36d9013f14a1efef0994d29132f8e5bb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9250762c04dfebd2090377342b5616530d5450566842fbf80bbe63461dacc3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993d247d0a265146eb6c6fcea5087e2f3f865f5f29a6486bc4b9a83612f10396(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a875a3ab78aec9041d8912416a749b82f64f2b90072f03df19dfbc9ead52d2e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4316c8b04caa1d631cc0f8f14fa468a827c8f7218f9f36955d34278958621f11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28399fac47dda6a961583729f439e064aa772ddeab59d2dbafe47d99cea4e630(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775e1624d2ea665b09c8b22d28343a058c9a4c0f3b05e472e70f5d240b06ec8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7886aa0307d4bb5dd9e53d4eebcaa75a4ccdcfd9895b2bf4e5811b406577c6ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4346938a298b21f2777cb1989b53c7210f97069e39c765872567ea0830b3ef79(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2128c6015d4436d93cda304620498b5d93d1cf198520b4d3881207b3a28b6678(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b34f88a8e52c3fa7b30b6b497805fd13b8b72585b3a05b440f5437f92adf251(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06ebe2545ff916cb7e56b458d5c5985f8bb84e8cf4aa01419ee31dc45578e5f0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d1b83d6913dccd5884ac800319b83cb71e892d8f88b0324c1b95abc631f867(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3700be24c516f1c49ba38e308dfbcf541dbe058a944e61adcd714dd30c3567(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6251d58146eb44f32c78a24641c1ffd37a5a08c22db6ca1dab3a46eba391a708(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a2559c9a76552a932ca8e3648ee41c6c751058693cf1b6b3018b5cf2b11b12c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf60e3bf61c29a8fb31e20aac66764db6a402316426a53d14c5389dcbaa61c7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55bc868a58d30035d769682afd3bc306e1020c313c1e4ef1b9bffcfcf0c5dd5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbdbb2ddf5af516bf1ccd7cf71152980ec5a915a7ac7ed773d33130fa0d6ae62(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac022cb29f393efc63c8c251a8d5ecb0c8a8cdff7667213fff80735807c0f58a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776c7ab9bb308317b63626a3981c75f9502dd8eb4a2639d106173af95f4a2639(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaedf6976a34eee9895190f783b39a7b7ed94d0e23ec3dac978c17c7940e0a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__962b38131d5657dc3ca590b726191c6b2a2870dd3f4f57c4b4db0cc2409cd41d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a525a277d4b6867618e4bac6f8d0bb0efc98e0314e3026135cafff3c1d89a8d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb60439b3ec8f489be4cf0076a68310d985d09591aa8926f6c5f34aaa82e7f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1388e2db166708d52cff9e32d0d2f9fa911fe0c31cef871276cc769d49a8867b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548928e6e228f0f88d8ecbd1eaac14f3967b6c986140d5789656d53d86817295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70516a93857106e5f86a33b034089d86fcd993dc30101ac3157d3592125d72c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f41fbed307aeb986f5520c38e200442a5569497bff453a71c1a185e524386365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9b9741c587bfdfb5d5e628658c24abdecb3314d151290b137251d75df5ac23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7962ba03846a216f81bfe069c19e97b1bf1f5c05b7db29c21eb88c8d7519ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c45dff11d7ed9b918d4cb9beb8033d28727edad5debc82fd112a42c40794a273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd674fd9c90113b4edf65b4a47e1a0b020e270adf792a8dc7e58f4e4854d219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a43497d9f832c7c4c21053e5221fc1e427f40cf85bfa1871aefd963e90638dce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8171c89cc0121e6befc3a347662336f733d91a7188acf70734b66b1cfb7bc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b73fb5328ec1c7f80eece1a4c71efde3c38bf3cdeff9eba2c0ce7d6c88936385(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0a8e569e3627b941e02e56377d51af500cc600ff903a523cdbcb764ee8fb8a(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a73362cdc0a7b1b171a3eb81d2d90907d4e34dda1b3deb1b0dd444deda19d3(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c172bcd0464df7e63a5d65af3c96e91aedec43f29578b0178a9a57ca9dc2e5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3bd190dca71191ee7695021fdbbe80b2b18b845643622dd494ab70afffa936a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8540bad479051671188fa779394c0c6ea6907df72ca97b9cb0fca4982ea9025e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035725a2927aafc07cec1c4002ff4f7ab0296c9f7d4d3bf3d2f9a47e3ae5cf68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae8875bedf608d52fb387a08f67e203c37d37022107b7d15ccd05387f3099c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2cb7d72243da32aaa10a2111cc4f79d65a57f30158daa0e3ce8c1fea7589b3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26223902411d0ce37fd0c595f56b8155eb6245116052a998703457462932b005(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f07c1e7f9af8ffbe8b3d2891533f80c0e3e3aa0d5b99c31c0344fc6b72b24fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866223590a09c92065e29258cfa0ecb70503a72c7b883c37525fb6ba991c7bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c94ddae00852a87701f54532db4f7d00c5d51186475746667313f502f2d8d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245589f4b4eafbd3575982a19d8d556f3d3fc9c0adf6d9ee3275a73fae090e9c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac71bb932b3588fc540aeac622ae4f264e928f774362c980e8f1ffb80a20444(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f29bde6e22963011d4904bc417d879916c7e9590c11303cc87dc50bcf6bfdfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5f14c8f06ee450247ab7cd05f3a6f836566b2c4ed59f5147adfd0f10c7c673(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c46bcc3704f7478c988f53c4bb93cf8a01e9b58cfc53f0ee6097e252a4568c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f856f92608042d5257589a7ba7e5b7fd2babdb432bac52adb6c6cdd54a5383(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdb5f3ee62a65c8c782806694a92d912257378898f312fa13e39b5f4f9174f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba2b37ade5cf312e0d81c9f31407108622f42e7d4a9932b04a2eca68caec961(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6dc726e407384bb8a98d2e6c467329fed44f06176a3ffea6485433763a2c14a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eba1508ec60c6e6f798b100fecf6c877c5e44a5d4d79e147512282d277a10a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81196781a9c07e46a3c14869047e3e3f34dc5bc80d8d4c37a19579320df9608a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3da170d22400e9d87459e18ca6e7746dd302527a227fd193227bf32b03cb72b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c420884fe945f3336840d13f775c80addeb6b72c7d7578fa41c51232bac1724a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d80988a0d37899a010830f5b7289a57993ad7c28f1c1ab47d310c1ce5deb27e(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f974277963d849d8ae337582ff6282f78345ce02b8fa56e4a416d5ba7116768(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee05a9aac6f9a8c5e7ba7ebc4c0dcad009cb032f3f9dc15041f68a81c4863392(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6958159ef04a54d4f05aebbc0e555b4e23fa37ca5a18867d009000f2cf8879a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7148ea30727cebd9aefd55e398f7be392036ede268b6c79523e69bfe0fc058a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2753d12365818cf6fe43aca0957d3fe96b9d1e7dd7d24ee43ec69035dfafdd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af3f9661d35874f8f99f889bd0f0bb417dbfa770bf2ebc2fcb19c606846e221(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25839a335a90a7a94e14a7eaff8db6196499f0babc45839580f672bf089cd587(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a96d15c6c44cf226452523751ddeaca3281c36d816522beef543d38b59e6be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3854ae6ac8267ff5e2b41253eda09237469e7e44dc846ec554219efbe532c700(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d32b149db7b4d72150de7e0bb45f2cfd61baeeb779524af187050a0fbc9daf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5922fc027bd77dae69fb75dd8e517e5729b25967426cdd10c35dad1732df59fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9acd49dd43fdb69e0d448dfa229d1356f6d81eac3fd0822669ee5f4eb672d09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffff8cb238483d910458629b61658667a735670a6aff8229c3c2fd3be88668a(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d51a66103a3aa01560e2e9814306bc5c8a761670cde9590feb53f3fc22c7740(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a04e4e30141238ff71500949e1c026bb1007b49c01da0df3ca190930ba53870e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0975d1fab8426b67294c6612f605f4c5fa2e2c7fd1e6c2e366ddb93ed9e06baa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e891cae81e404d233937eeaaf068a4a66e23a417b0b83aee0211d2105b850e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23efca4f57abde4f4a21b6720c5ea2a4d9f0fbe09177e7d24701a70e6a2fc9d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28284466869c989ac214548431ad8777eba43999e1c931ed46cf9b3246627227(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62cb4b2f200a3b543828a061132eb86b6da9cc87d101df5332bc4ecb691a3a2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8b141414a009d87976e37c52f508445d8d869de4f4f3883bfb7cadbc995175(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ec31d9d0edcc426775c2d6264de4de8ce6a80c0f50080741051b86799f7c25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9406c2570e043f510f369a7d74fad9ba695b9f6bf47570f53bc327c87ee9755e(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32fc9e4f3666bec7896303e8b09479d759c1feab5099aba1c1c42cdc24e51ccd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b1c7e4f308a2082bd818b7c99877b315c800381a7abf450b9411dc75b05af4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6afb470df62c81d98b80e1c79e329c0e776ffb8affa845cef30719a88e3c1fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c2847d356505718ef724fbf8cc320af0a459de18f54052b8da7806864f71d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee387d7b4d84f315305c7a11b52c3a1c670a1428e165a3f28bc9f4e1c8fef55(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075dff8340ba78a077fd24501830cef44da61b76b4836f564d46a387f486e4c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b97c67ed8e95fc4835f42c365900e6ad5805ef6badc291ffcad8e4062468a95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8654cb0a689b6b7211598da372665ece9e69dafeb5da41d140063c54a091e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7a0d621197a530c6d2eaf4b4ea8009cc43ffde7468ce748b4e3614e94215ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b49313180f3a0e14a5d0b68bdd618b742b2f3d986c375ebb6bbfc4e5d53bb57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2227ce2351ea874033cf88693055dd20cdfd7e033cc8b07577f9bd099cd8e497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ff9a972492b833388b019bd66fcc987951a51e794025759b0cf0ce94894d39(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7529667db2ebb068654100e70760b5090edd6118eb939839e12425382be87d14(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1bb95f7e3f79e00946725537770d03740a92fd70d6acb90bb39e65607fd138f(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb36fe1e4207e728fcd7f1f8f3ddc2adb26e96628d321b6544d9ac9d8e3bbc60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78213c5451a2a6cb9a238892288710c55354a1807db89b7540ff31bf4fcbbe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26d705e23af3d000f930a1436dc5d94ce09ce8781bcda22b25779cf16cb9782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a072166128f79be0d72681f350c4ea67519c2c1cbb4b10182e9331463ea1d1f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfaad3b02090e13893cc8a5d37c69151d918ba2b0f49f041b3e5c2f44349f722(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0680709731bcec7f0c838a18a73d4ae26a1c57779c51097c63f2136390c9145(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63601013234668190394fb6089af8f58e9d9af81248141b30c87a44686661894(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d11dcd3bc6ed2cbbe67f6edcd684e76060a8fcc5bc6791c08310900a772a4fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae547f8aa322befb8d1f9b76933797b94c9d57e5d005cc62bf8236748ff46c26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1902cb0e57f1306d041e303394850bc9b614352ed210bba1e3ee35f8294e6f8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147a0001f6054ec9a77d3219c025eb0795ce2005c15a6ae45bcb1750a096cf4b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d000f85257033afc68bbe3dd0cce135c2a961c21cac6506364a5e77d3f3587b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43133eea8ff3ace51ffb30383364902306221004ce19d477598dc7866dbd7b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aad7f89764f004cc777108c57a36dda8963ed1eaa770084d791601e78b2e258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0fc95945f4ef722d407284856c628ca14d148d9d311bb8b5f7d5ebd7af48da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186ca368809ce755d7ab427926f7c0604bd6698fa7004bfa80f8a4dec973bd3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf3b5a5dd53bb2e2725ded1c0e54a641fef9cca4485d32fb68d94e91e0c28145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2c53c4a5adb51788b238646fab9c0e78ec2db3e27734bdd52771a36230af13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bad1d9ea5e944df55f5f957ae687e18a95c03592e87cdef701b06364cc9467b(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9bc0c0990472c4ec983c52fa8cb5114768b8e77e8f73ba4f2e2899aed4ef2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cccf5ed529303ade36513db3296b74b1de3887d3432c9e04f9d85076926dcfd1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4b1d3fe5ff51a47e63a506642375d01f8547c7bf98f9ced3f3f9c9104f6974(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48871d9702b1edb69b38a91d16a14e1c2c37a0889d87e22be3fe6be1a2b700ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90245e4c5b1895110083e8b1d8efeb8d9cce5e906e195c4dd2e3dc3e6b50187(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649db662bcd8c00d516c56f550828c5efee1f78f0b9a5096f551b327cf4a2401(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b5c7c7f1165f5393f1bfc83be2fc3e547beff68c5c68b6627225256c81fc70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd4a8df30625979de407ff5b53ab4ca79c7a9d5c637e0ca6e58323759441527(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d3b94576e41260c60849410eae792e24cd805e9fb5ec7a8431179fad1f2d99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e707002de48e9f60ec1c8150a5e845033f1542749077026e783df938a1c21ce7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df86758307b126d7fa553fc24d545c89e14ac56ab9dbf83c87e2e02693c2761a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd29a7310bfef469a4f5d47fb4d911b71d6edd46763be5c842190cd3b52ea9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f251c655e8981ced0c3c9ba6f2fe3194d8a0ab8c7dc0b705b90e4312d268ba7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ba26ef612ac2503a8eaba3003e2c5aab1a3851815a2e31b4776a9acd8b865d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436cc19da8e2711e2b10780d3e5718fa36e224616ca67c9de22b9c956f984339(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be29ba4736d2a67505d5823dde531e686d225f19fd16b62559633e563243bcbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9757578a8f790836898c6e1124e2c18f25913529046935e6d7d836d18d9a9acb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610c08221f06dfb6c26fc4f222bf996dffbfaf723f7b669249ef093f4b64a8bf(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f075c0136bbbcb043b4d51a0da46a0e4f2736256f43595065d7997998ed5279e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb7f56609d563e93f0c24b0bbaa9a9cd0263f37b8f22fac8d05cda9c168a774(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff34f6e9adeed40073079a95fa47b29bc4dd6aeef0621a7d61d02ba2c9d2fb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093900ac736a2ebb9c7f1bd7e0cdd7ceedeb5ad3e59a5af4bd903c994599a26c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53320318e8be6e74be0004dfec8affca9724ef68662cb8d8f51a2893c39d8c38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7408baf4baa939385a4e82d64ee5febfe95012216b504af267a443c1b2c30e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ab2ea1b8e5c88323b803db592374e092caecd3305e85072811e4063c5a71e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c926b9630f9a16bb1624c27c367b380f378b36d1df0c10236da5a8f44b81f14b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e915c233e7ca1ac997b743eb4c3033a7f649fad7e7093b255bc843e6e987b936(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24311384752c31ef36ad5676a65880f4afd496013c8ae8b5c8470ac1d1d7d32c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a96a9061447f6ed7510efd5fb070f573154c67eae0c2274034a1939a033f8bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3ced16be2141edc66558329f18913c6f9ee585914134506a209abfba0fbc6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e8f73aa1ee982e01dbff05d54b8b5121ad354eaccc4d71899c2f5585e0e3e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708be54ca477c0b2f3c7cd7a049ee9ddd02196f3aec884d0f5a3bbe24b8fd4f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60fb81c55eae691f94c69fe25f60b8a448bea0f1ba7e91196fa563042312a313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9486c797448d355f24e9ff74aac5ab0c8442c6fda404ca7dcb054142317735b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036973d0d18ab6d8b6f33bb3bd3730fbe5a64911786d0623b305556279f55126(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4d16cc8154fcf2245b277505d40d967c0689920f8ee1524eac5b371e1fb8cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dac4fc36128355c687d100b11384a4c6e35cfe0846a149b8063a40b9cfc670f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c60b52289e941ba2c6bdd775c6713f4ca5d1335276df9588135667dd000094(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c4989fee5a3f6dbdbb3462e93b2a67ca0c78bc6a253eab530b40e53e4c618f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16f50fbfabe439bae5b65e2e2a0197bd66e3bdcc19faf2801427cc65f8a7b54(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e7679694031e0fa6581319e3ea4e8431b11327098f4903f904990a7d9e621f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd8a933c6f2d86c69ba40c4b4442f5e6401741a76cffc137ec3ff531c172173(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdb48d196d2e5faad0cce76efab87904980c038cf4ba4da6b6daccece80f7e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a044de10c54a9bb6f3c6f5451111821f98897b36a630364f370ea71ec94fac1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c60d9c281d5ac6001c3ce82bd46d998d1c013536f61d33f3a4fef704de0dbb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb13021dba21bde98271fa17b85af8fcd06fec65e9655e85b385e190a5754088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b925f9a0f18c4b10f701fe9f75dee05d9f5c422e8652616052fc7deb5a45be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a85df2fa70b899ba0d54f91aa305280dc33fc571f2c70bb04e73769a0a10d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ef42a8314a4858abe48e2c5006ae10e4c0048b1bb6eb6b3717d998bcfecba8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d7d7f1a3fb80aa5210ba1634dee1ad0d04775625aa9710434f059ea8ec74237(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09cf2e2fd1e7dafa66ab90b47cbf8c514f167c7410ae0752934d10938734a19a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1394269ad376a9f849bdfec2139537cc9f3c0b3b88c1054b6df7c45914c5e964(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__655a4ec5edac936e5dcb1f861a97667d13ba8e41f907017b0267ae73523627fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc96adc5cc1ea5119f576410d1d96245afbb0736c89e55a41997c6730f5fa77d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55a2c2d29c8058e35dc07c0b71844a62175daf692ffd4928295497f34c221f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84d779835f9d958e3b9639f3dc5ecb69f0acda7472ec3b28671ee5e0fd46f172(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b073c519ab4ff9e9dadc74613be8456a548bf311a6a213199183fbe6e3b7da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac929d62fb40210299c194d5808d988187438f3b54a6963865941f323bd8115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef175cb4752d5e4c3055011b842da62d04bdefe66ba9303fe36ab5cf18e59bae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e626b333602eeb28a5326897b1e034444f5038db6bb1367a1ce492ba1c3e988b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a1ef4f2599908b94e911b4395731ccae285122fbf8c73faa665ac8de033d0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc76b4c3b492da3e7345f6f72f891a19e1b06a72fb82c37650507dd645f369dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408d3c2d817b0bae82460e632adef0cc7097a741e6633c93d2951febad303924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92b8abf03d5061c545e99e6e760805bdb4ba300796828b234c969422494b7df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d39ef6c843e9c328db485b274b2626595398794984fa16d104568fac3614eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9054d0058351791e792b32eeb5ce805dead13861aa5825edda9cebb0150b56ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47376b4cf5d3f90dd549df6aa72961ed425fec9f31edd87d8fbca239d1558b72(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f825b1554a761cc9927d03a6b8ad9e4ae7df6af27a1ebeeb34bcc86b24b73819(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281a3c7070b811a170ce620a8700fd3b5e9202d4804cb44bffc47ff5d260e98e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abf7e248f3c8af45e54e1c7fb360051cb4c008a5e8f88a5efced9882a0dfb7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9809fe260affdf725f5b605e69bc40057866118a9a11ff232e08357daee0a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be86f7df29fbf915b3e3624e2f6387674d7ad215fb479b4a155615c4b19f83a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8582a6e56daff1ff300f545fe85dab84d2a9c779a8934bb880549a4314ad905a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777ab40d53c15af92d2c0ae45879f1526a090841bec457cecf702381aea3ff9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2635e7600d809247615758bfec1280f2d90d589c5ccdc54e8441bcde2833c379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b9369c7b810832d2bda9a258bc96e3b5b51d5b28aeaad9146fa207a1a21c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdafe6533fb5d05e1b397627c5b100a015349fb9c448cabfaeed2ac99525ea33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea2694b866a2a729cdafcb02b90331b0b6fe122275df198910dff3d01511ced(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__670cdda37c1291f4a9e6dcfd36269ea51bce9a9a05e3720b00a83c7cec172788(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86262af2d8ec618a5d667f9ae25df922cf4d80ef061bc0077fcf797b10baba11(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a835164335daa1f8574c20dbaaf0098b9730a8337b218dc8853525d76275c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080a4b3f76a5c34eea1b4235d37dfa35ce465f7c8866baac1631a6e311fc47ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475c6e0b4bc8e80d9336dafeea2ccbc877f54922dc61cf94cac82366b334aacc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca30ef3d533fe4dda87877e3adf297e67842f82b8cac0a25a5f8af27bb9d8a5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73faf9063e6239ae796787dd41d975826427eabe11f98d36ddda6d6fe068d17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9580f3fa823a36d974737e16b430ecc4cdfe070253882db5d42c0ade70ddcc75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c156e9953a188fb0462e3d1fd0159d083d8c85284bb56d415176d93d804c3fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c1da7a8042517b8ae79d5ef2844e47fccf75cfd37784b8f65fd9f885d79d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14003df6624475d03b7864c40c22450f5f925bf1802ba6708eca6273c2563b88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ddba36d7c41ff28ea8ed9945b9b01b78f85a02c83abe384bca55fa2a4ef303(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd2e9cc2f7ea68d2d2f9c5b6cd23b3af57858f061fd90707a57c1f52c0aabdb(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59393fa94185f7548f1de29cf22159a89ca908fbf490dd9549af8e5a7e863c6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63a1d61b4c9ab74deafe965d1073711ae5351261e30efc5dada5609b4b8c20e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebbe4102ea30296bcee31b88533f6030147822e549946b04649c5e054bd6ca5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58daf6da49461e5800bae8959cba11f1f1d800858df722fdc764d4d23779bb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b405300b658278124f121d773511ec436f5fd697373e709675a27a98f587af1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4855fb194d3ca0855704880b79a1fff1ac27f03f9cd9bc7d1c4029995733e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7815ef05f9708189d3b84e7182ad2e6624c5a63c5019eef1e9cb6cfc45415af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__140c31c0b06dc23034df1b8416d78a962926490e1f342ab929e788eb87dbe043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56841e166d2029e834228eb62ad168a9024062a2b5ef7df563e0c27f41819201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4acc65b1b26a5ea7feef05f84388b2b8ab9eb080db795cd58508195e09879582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c08dfd855814a6b7ec3b6935148165da879aab42bc13d8bca6f5550b521c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c132346f15c2c90e4d1ef7a6796ee5803855f2548b8ab0783e4bf88996d37b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eec113964903655f1638e8a45cf798f47d4392901aab65102e43176ad27e21c(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5df9d292bffab933862617717a029550ed9e41ab0de4e57ed8aef0c2155eb31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f08ad559af8229616ae7e166758368f311a45be3ab681b91d28b8f4894eff9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ccb6b4634ff97097a9d7dc6be1e6da25b7c574846584eabf65d1752f59a5028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c15f651ef2c2f40d2f2d5e8f37eeb09287a6c7d229d1b85ca5193b2af65aab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f36555e033678b95e4136ee51bd37683e587b902ae0ee5e5f21dbe781e87750(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198364f938bea092aa4c18c8e61fba6dde2ec14634e3a745e7f6e86f3d0f9f70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2afad4cb92356ce63de6303f10a1e93869a1654fd5674301bfd4599eae2159f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6bc01599355b21f8be9857a3a10f9c78eee679391cc2011948d6308f8baf07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e24e9d0906c5123cc86f869e93b384905b93b58a70faee240d5c05b646a4fb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0795bd57d3722fc25b7f6deebb9447edc7af42627b369232ac3a3ca2f00a9b2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a91318d1c0ff7faddd5c81f548eed7697511c623f0550185f14d196eb41678(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4086fae2f1108ec5f2f0d90bfb88688d787f69f8420fecdbd79c6a15c66defe0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09579a20179572b6491c65a33c0a47ad80838dd6d59d70211942ecb127963921(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be60f066e361bae9c42606927178ec73719425ada2b188a1ba85a13d4cb0373(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c6516be22b5c5d0a09505e7a344451a00c43c1461ab14583d5be85d5e23d429(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddddbd80ef6bf41bd1d2a91af92bc68821a2b798a6615c3f74593d94f471d4af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769d060f8a43de3f71820b59d4b79e32bb96f78f332d2954ff7bcf0f3ebbed77(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27934ca150e63b89ed754d625cbd774faeccd88904fff838064872e7184b7a30(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e039a71abe28c18a89baf7fd137ad31cdad448104ca3254f97dca60439e141(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__371a9b7dc93fa4cece7b3aaa944c336515465c9d03a835ded9442155cd1c1135(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__953a08368eea4a7e38f70ce86cf34bd25b639e69f77d34f6a790c43d88e059e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a960a61b01b7354bfb55d586816d60f44a6a316de51e7d376d53daa8b4f5e680(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31c862e2167ea7be8d08640a8a4806017a678efe48ad7029a62ff445d86db6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be147840ed106b8f3ee54ed971afa1a48994567e27008ced7eacc615931a4692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e9fdad6cb0ddeef66d48430d285b35c3f1d014b4bb1c1a80591c4a3e616d52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aad903ba39551b7a31337f00a6f52e994e62cc73b5e6c8c542b0c77338703aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95cc5ec9f7f8b7d789079f97ef472173409cdd4211fe72ba6b4b53d4edc3b9e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df1b74984fffba7715c03845cead313492ce7b8523cae59fe381ad231b716f3(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9978052f76fe1e9e269830163d9db343545fe07d1b641e13a858e86db46808f8(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67018b5ebff9d7645ccad0843008d068b6f21f6f4b54e19624a2f6635e873bb4(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f754665d14706422a57db156b50adfb85d825c1e69b5312d4b1ccd825bd2ca8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af871ba671ef85006e107cba602601d2a9b7076844d2884450fc39e492259d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162a23d842e81e93e3d13c23bfef68251d0bef79fcaa835d57a351e13f4afe85(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cb1a306928a0ba5ecb9dfc7f8365cd85379b5b3163f7803702f14f88680fd71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b279189edcda169387b8d0c7ca61b2b2fe3fa3f96627615849d26604bd98457(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015c5d03e5305c7f923bfdff7513a255cf7de99944b26c15f885ccab4d4f8176(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4566ff805f1874c59e6d14d8b5932bcf0764031ccd98e885ceef56c9bf519499(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f8ccfa2c97154147f9e63f68454058e57f6797b6e44564f4c3f77f8025ba71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686e1c7bdff7b276d63cc36bdd8ccae1bf5ecf0a1aa2bcae4f9d22b782a9ff06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb29ea35068827a18e5c5bd03aab8768dda0807d10a7f642f6c0dd6415b6909d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44017f0084eec57a4603eb6c249a67b8097bc3e638e4cfb35e0de757119d10c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44662bdc34e1eba22e908e8672e78ccc90a600a7051cb4c6b38990a268fe8541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8947589822463bff7893cbfa8ac00737bdeac4c9b1257fdf7a2ee5fb974f1121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33c79ba768e47bb8a4a831f07995c32f1f4e8f635668d0a92bb4e7f54d23e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcc2a9f7dad172d84040702f018feab102268c10cd538e8929fe7c78bf6dc5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60e0dc79f7ccb5dd3ab4b39fe51a8a0535b2250d07c624c94db04ae7433f17a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7092eb9a46ecb74c866669c830e32a25650766f29a6a62012b4da8f7b22921ce(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ff3ce947b6e0fc1b750173bacbe61eec13a3b0d833aaf78591667f05b06727(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8b8717a41b2a59b12cd0f5e5fa3c71c7660c30184fb82f78f9f0b04cafa6db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb791574b43d01c8dd255f6f32c48af7d3de1aded2b2d7aa4151277caed8bb4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2036056ef4417915d85d31fb6a80cea5f73426d2f8a122111b3740b7d7f3b1d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1453b80fd29f9ae009ca18d882b8ac0923ffe2720bf389abb9cf85638f879e16(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb56767d730978f134ffb18fd22c91bc1d88d9b444de9db9a8092483e716f59(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06aeaea46d033a486c3b2b74b611150c176a874794d89620f64482f394ec505f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387417730d0f58cb0dc4107748a6fe3df48e102d1d9098b04f5924a52b627c52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21659c6495e17879f75ae64777dbc2f9d01c6a81c3ef79e5911fd1397ac6f4a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9ced955c3ad9db6e6038668e0cb1ddb8e9f43eec3ddd25c647a80aa2df99ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4963e950f8e2775a600969daf2300bef20d1eddd276f2232004ae7b66916ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0342eb122174c4c1681c146e51ba0aaf6f154f6b737c9d1323e47f38e2f2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8478ca0bccb4c0ede372f38e5d6f28a880377b061e8d7f6afb5de75998f5943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf40e65e6f6f4977ffcc4b0664c83ebfb4ab911726095f7b32d713111b7cf5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25743d79e34d84ba6566d777fa447af914734328279d20fd7003da98638aca23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6078da358540c1fa75dd0adb23e1da25804cd91caf2cc8e89d14788fe0d732c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109b8a6a5130060608c04f06a3491c8f141351c44f16626611e43ebc8d6ab3ee(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c107d6416695e2d67c93babea96bad4df8f72ee49f6913fa0b533ed9bd9634(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9f6b4403263fb3ce95fdecb95f2e6bcb3a8f47d8e80454b84d314c02de1617(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9e387618ca75d630775a924c59efe6b4e651c641e82bff22861cf0a1126dcf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55fbdb25e9ac488b9d6c34a243e9953e8518bd9e2fbb70cd00cdcb9a57300573(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f611426fdd24506d8aaa52adf6f7440c9c8b85be7762104c82f781b95cd4b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31cb46047b9b4853d5be49689402d314dffe2a428474f15b687c63915c6f896c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9e9a53059db0568e4d94bc81e3811080d2b81840437092cce5b5bd644ff035(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33218c375629da17ce8c210fd61390a65fd2eaf54a4c5a4c808a8cc3c960a28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bb5551bcd4f1f6d6c9bae19d6b3002a8dbc4cd40ef83e85aa8a882d791cd1f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db4aab7523e612b78834740760491020937dee91b9baf9a4574b39a6dd90c8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97bf1d80f7ec9712a1c7799cc5d2662d96c1a4ae8750541a6878868eb0bc350a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ad3931c475b2b66d9a98e56253ea383d116e6bcf55436682260f636ec3dda7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92608ff385af19719349a74b82b489cb16765c37fddad2e4de436df9f103fc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f813e5d42cbeeb55a0b42aac4442432147226e2048d38f5dd6ccd1b6680e892(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0adf52ad268b7b09edc548deb1abb665340ef8446dafe4d63d8364becb93a236(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ee2a3756c45fbcf3d21927bbf2c8de4ec8005521cff3b79ae8865816325019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d478b1b4f61c9bc9d194af37791483658db9e4e9a7957c99876f67c74eacf85e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3d6865cee15216ddb1fd13d02ad688da61ef1298422bd0e4ce55b321ddf9e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66682727ebac19f8247948be40ff03c8363e0d1315dd2ae5960ab598b671a12d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad1455aaac0416ee08400c5bd3ef0984f00dd7ae8c4b6fbfd0f8de5f15272af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf151f95cc44446a4c94499325da42d824a5ce6258c9bc59c2d58cdc3b7303f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de56c5dad54b99c472487834c05353db93a2343673d997970beef43c329224e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efcdf4d371cc1cf48976a7c04de9db1b71507cc81c6a3dc2a83b7fcc5472390(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad759d56b25c4e495520aef9ec17ace53fc4368bc9588c84a271a4cd95f51d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c005db85bb438c917fe3873c1f18b3aa6ba1b881006f5636f7c891a29feea761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64c4419e2742a4100d736b6a7e890d966ae84b7e6e2a888c1393ba08c47c60c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e65fb1507ce4e4f331e43cd857ee736882c766b1a5a6341e6c0115acdb76a7cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96bfa45dddb3b4a070286923e694853f575e1cd3571383e00361eecba7219c1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa8936bb10a450be3a616af85b08c9775262a88fdec1a1110f4d1fa36227406(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e517970b2aeb29f6766c3b780b5e2874d79281c58793f9226c3faa3261c304(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ce6b90e41f4ad419b1ce05fcd91e991959c915f8142b848de90e7794034cb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a171feaa1ac60537c231872e515615fcd6b81453dfffc72ef29401f076531bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bfcda02b9092db8d1e94b439a33e7f7fe2f108d2e2e3d2194c06681d5309c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15228d8edade5b594a133122feb6b052cc85b2bb43dabde6b4cf5d6ab6fdfc37(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2217b04abc5577041d3be3d71debbe6be7692f00c2f86a579b623762ed9f913a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b307a65d217631af08818de70cd8e3628f771ce73044625de6d534f21c42523(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf9c69c2f83261cf88305a2c8726e2ce8766e8c51a069994c56fcce54939441(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b6eba80ef45f26e82f03cc9eb4443e53a8077a91357327d232c61992f3cca31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67e3635217803c4b72afeb84049e9425d0c4c32b0e22ea9c51a77a36f9de51b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ee104a352e383e938ef2f87bcdadfece90bed2af2f16f7517ff489b1cdd19b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0616debc6ad815f89cdf0cdc863c9f53abd8653f8801ccee073a8b192682ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07fe6321c38a2f3449bd599ed6f432c0ff7383f926a513ca482475e7e391f3bf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b4a13d538532ce92542ef44576ea784c0e7e38cd6520372f921e5f90693fb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2492dcd28ad8c68477bfe239608f5787784ba830eb5685afa3f904456192edd4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4c1613b1d81399563e7e1d1f76834ff4c9c21ceb036b80687ebf714b89deac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77be8a6c9f9c0a103356e555a79d61610b8b1fe27f98b124c339a7e2d1b038c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ec88c2a562f3fdd7ff4f4f770f64a1e8ffb2169cfa28d08e886b5acdf02cc8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d71ee652c49e35f35f7540c4d929bbde3063643e79db546be9be8910caae995(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40601103598d0244a27efdf941081df01a963b708b6907de5f818a0f4826d92d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0a42d186355cc601ac17fd1093053c4c962110f835720b9f24940ea6b98214(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d766bb898ac6f4ac994459f5f0bdc35e2f773d63528b598cb229888398213ad0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a432129628caf296113362176c71ebc98a453af60dd75b20cc7bfe0ebab6ad35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9042eea107e045ea13d4f2bb8434b1b90a6f8072d5dee58d10ce497c8605eb24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a73a2face045b29c41ba8841e83f0daa2801383e679ce5b361694245b36d56e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5d8db7aed98a760907ec76f209cb8fc2c647bbb1196754e90a8ae78c4ed177(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d8c0a3eadd4a1758793f5826f433220a9e54fe23a46b7fc8819469c0c54e97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453c2aab0936625c633757a38a6aa6b7c6d452610df98513b2eb04d0cb201f2c(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba34637879def9260498aa967f199f4e7fa4821ea7cf5abefb55b0ce830942e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2becdd00a4eba52fd4684127947ddb96750f38fda081621087768ff4d14ce22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3507394c626e7429b6b081f6f9bc2e45ef25c4ba4fe84143d3185f1f74f3e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561fa1ab0238f82f93aea942fc011a85c4b710d85cce2bb10af354d93cc59370(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054aad885b28fe8e32bbd39ea12ab5c744982b18c099ab2e3c89126f81f2b0dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab7140dd049b5189ded9e82c0327e587ddddec6d444a9039cee6ad6ee151f08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af7cee8f38484a4760a5211e344679be113f73f5019502d5e7ec6912a43ea7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2698948602d4ace4cf75375733a6079a428e2361f386ff52bed934903f85f681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4b8ac087384024f752a8bc8a200447100a6548dc5c8c6970192573b5a31a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85ebd23f65bdd0c81c8b6a4b8f756558af9cd946c274e605e27457062a41c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f77f667b5067babbf27016179cfa88b07e33d73c926747f54ebbb1833490ef4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88a04c3b060cb34faaaa11d7f62fcede4f6c5efa9f2c8dc92914bd444f634d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957545e633effc653eda3e56f57a1f0c551565e334e0573916dfae06d2db0d60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f5fcf76ef1cd001e6c30fe23bfe0ec2ecc851d51e95e4c72c927afcfdbe7e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c5f5edf9651d6a36f88573bf3a06b0ce406bffaa7e19e6e89bc3ebc93c2ad4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b7a606db5f1c5aab659c46e15d44a0093079568f16ae0f8703173316da63be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b75132306d95572bb917901230b2b68e4dda63537e753c6d2ecaf5ebe37a7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725b2d1bed00cd21054b5607e7da537943a6b8d595fb4920e5a4bfeb93f2c38d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad92520c3d958829627fdf3f85a3cf56c3b042aa596abe270dd038f2b3bed17f(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aeb05ea020bcd4a108d7bf1acaa542b1d745e933bcc477ccd2f963394b1cc98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7f9fc43242c49bf15400fe04a4474ae01e58063930b99973988230007e7850(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9952003e5a3d404045d1d907d28430cb852368cefce654847147e658261316d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860ac4bf5b031ab8cbe85a3b13e4d6bde715e8751f6a0a9604c7c55b7c2fb098(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10eb40b39d7093150c3be5a821bdfda830ff51e020c746b450b4dd09c522c7c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b279d47a7839897ecb0329e22be3884b523ada2c4daf8d61232671a79d1ef5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c87116636b4619cab6bb167c99ae2b490c3785b8937f292d102db31795c82f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241610105aa852aa295bb2f862f040efa8b2ea9481c410dc510cb36ce5ebba5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c2992e5eb5035a0145d37947c2c8b20d81ef0dbcab6b7b40df25a6f407f791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7bacb51bf81953035154bf362c0d9bd74e5a953d864d8b6b36e3e0cfce709f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765ee1420db4181c66e1614c9b4d658240d1263dbf13b500fa5117e0c13266b5(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25665964bea09f31725a25d7ba9e40888a17a86ef82c3e38789cf98d018e47de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3db2964b66a6d600bfad30c31b738c97488826c99ec89ea0babfcc4003b1e6d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea3bcad117b74d9a632522c7a9f3ccb2386df591fd125e73b699af80231e1ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b655026b51833fcc929808dab36327d9aa9270163bd8c0b6240454a1023b6989(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9090343e24d4b1ab263125605fd9129bb0be3fa701a060a1b5435b0317269b26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e21db75d92925974f3d4c6ebc65894308826634b9a86a0e2059c28ea45e3b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bd72b2c189e1f0b3ba2d8fcad63478917620b61683877e62f7f6554eaecf96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7da8650234d8e3c16e11a2ded7e3e8598aacab37708f4af0d6f8d6e035074385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f62d398a6b8ded0642ce13d5eee93c5f75f6df9976d98f9697d7847149d29c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387f2c8c85a359643210792a45ed39a62dc09c4af550e9f8a5bdb435d6216d57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b2cfb86c9a2c78f9f8dc43c7531f942f3e0128df655b7a51f3d884a75512deb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3bd066caa78b9ee9517bbd919dfa37030e3ac6e34521bc1c2b8fb4bfee823e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721dcdd8bf2cf639f8e97220430c12c4b78fe8fc4ebd91219611e2a3cb0e9602(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6bc09666492316fe51b352735aa5715f10d48130ee72142cd034573b1fb0ffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a4268f21e17ba35a46ff64fee214fd1216aa9e4f71fa0e1ada43726c22181b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7c29368721687713f4bf1d98658cac8b8aa4dbbf706f95bde8398b70d3b306(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b106eb1bc8ab38090e8448b53d4efd55d2151d21c19ea59f21a4d309e2a921cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ae3a29e17e3d5c33403055c05f269a1a7c569ef97cf47699d48f4ec6c678a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d665311965f1482e13a954894b20a6499750a24ce4cae1c830b7b76c0737261(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd7535018f5b26d1e7f839b6e5d6140ef14aa97b58f7ea622ac4bc0f8b6369fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155eae6c623bea6952327aa6df13ecf1808d9360e244a17c5490fccb018a0066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45bf9d3585084e279b1685da2ad7e85c98fa09fc52e944d2c7f7b43d2a25997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2f7fd69f2081dc91bfa97e4611618612ac79d17295e11f63527e716ee04b16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2792ba8b7a3e4fc93722f8c314857741730c2399c85bb5461f1fa66b44075e51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__399ab8a95058813b7bbe366b09f30c58563071104263b17d64b4a4644b798aeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c2044cca3de38d80bf39320b21e3c3a42cf69388e1df571f3b0528664da43e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd67f98ca889d2deb09cddf7cda9be6fc3336bf96232e8302f2b4fada78d3cde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42784bc280ebe013bf66d54362a70b0c9d17b3f0a18c7804c445115d6014057d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13b8122268ac2a678d2f9a2beb6d9ca307be432bd834af46a4f1e723ef375cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa66d3b11a69996f614fce53c1ce0c1d2bd31613c023a606e4cc7ecb96df2c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee9251286ffd087d947d4fe707f675644171deabbce012ba042d20dd074c66be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02bd41881225e89337a42d07dda3221762a6fdf47d066525f59515490691198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a428fa18241403ef4a2c59cf313d64dda597b13410987c17fca4066acbab07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e405bd375c34e3279eeb387aecdd13d8247ca63da4b2c8f707302b1b30769b6c(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269961db8470e6d88f97190ae6488fa2e39c63ac470b4ea74ba5c4c70431627d(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96826994dbd31f3a70efbedc33185c6f694c8bd689ef985514d05ab54035270(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc50991a894fc1cfa8695ead363d892faef70bb9e9a272a26eeb26dfc2e526c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b80baf75650e12323d4f1a11762a17bf8746b5f1ea90ba292fce7468e5f7b31(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c538f8984ec70689fae0de0ab9b384f4a970a6c749d616b13112179341436c9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9064cee0d58e343304af32b92322f847931a3fb1491f6c03435d75611e1a0f30(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24b84946b1902cedada007d95a8b124f07cf8775cd2436f471dfbe82182d345(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49494dd680cab6eaa38757b521b7c57279605bbe47329d3c64038215075405e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02267c9a1893df4115f3015376b6cd004ca48598f7c3246d083346ae47102555(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a644cca1f5dab1cf484f8fb6e962c96d22c5024da43e959527ab033d914f1779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397d0cc7f64d4549dbc6f94bc0714dc2f3a1127cc772db9fffa3efe0080eb647(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fcf55fb53a9d378b8442c99d49f847ea81b885270be528cfc5a46ddbe9c4dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d517e418075d4f2e1cb097745a40fb926c9b1d35547c9daed29d68127d83b827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a16a7e80c364cac964f51148ea14c170c9b84716f47f60313ae42621077d3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69781b4d4e0b756e6fa1a0ce21b795ee9faf2e33a8146ae28485c90223da321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12326e5030b5126301a6a61ad2be7dcd2a32ffc12bf230f514991229402cdbb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2d3e5f4bca7cd38f8a3f019ebfde559364c55199da4519f262df2b982697c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80cc0ad4e0f9df00eb80258a6b77e3b8e829b084f8c7924a394f45691504bc36(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73323d42f07c9d43768be14372c7afdf405664974057e664bec6c0e631c190b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de61064ed76eb87360fea00071949c93899200658d74b2715ca960e20ebd7a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f71b6c17a32b8ad20c13041a7c5a9caf3af2a34bca52ac210d934e2290f2f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9bc0ee205eca95e7a2284cff52aab53e782a5c3be1003f8958dcf8c3427cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162cc440e42f34259fa54a66817be6a932ee359c861d9d5e6b56443b16f20d97(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf214a3c03843044a57d860287bac41d4c9bf9c5884e141727cc42c174fdafe6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9dd2093b4e94cf4e47ab3b1b1cc16c28ac79e1ee994707fcba99c1bad45224(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc3183960646194ffed0919c5f96c7e4ef8c8e3bd69a78484188918f7ac5641(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7df9881fb1e9b79367d4ce6d3605b70f71e34fc594ea9ce30e10e9c6923cf7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d948a43c63d464cea558d20e79718e37fa822d58bb8cb233e758ede082cb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4614e7b0ba79c7edef682d8a453c3e07da28cc272c2a50cba7b721baca357a20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4644f8d0b1a0f8402aae14d28a3dc38fb61646fb7b6079b59958f1a7492e3b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69323bc4c71de5208499486b32b37f005de451656bd4bda3d553ee57ba68bd0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5343b4665bd990a23e8dc40fa4fe17e0b5aa55ec2df5cfc86dcd5423ae00faa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b18d8af838032572d9790300153f168bd34f0aba53163b20cf49c14f2ed6859(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c311727ad8343b9a83639ae34266860607f886ea1e49ad9acefe8534e3e45e2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a5d9fe53a5ed2326122e685a9b2ffc4d76273f2e3ad6b8dc50c5824209e83a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11cf22236afce92ffdd8ffb7fb2f1f1ac3322d4158beb2825cfb510969b243e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2265fa7b0114f49503ef49dbacb3e5be0e2e8fb07ecaf4de6a7c8462ea89e8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8d8c1ec444ad998f04fb34ea6ad2a6f28bed4ad69520e3bfe626959ca3e42a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431417ff17a8559a9b4678c5f9ca12ebd4355c14cb7066643c1cf880d2d6f04b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2e0b47ce60e44e10c56b240fb221c5b3dfe3a102faf5f7e51be1ae23e3acfb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e8d2d5d2653a83a8a3d189caaa5ce1ac7359e5fc7e0b2a2086d136a67529ba6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f9a973072d8b3461f6b91ddd2a69fd5713f8126e6c571c984c568116fc677c(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3eb6762a489dc75d9b6b26d713beb516314a4d1dcf3bb0765be70991d76e46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd72bfe6072e57d6668c3d479d44802e720a0633a39f849982da5954f145699(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a29e948a2b5f4a22e8c09a493d05b88b4e140d64a625073df6be0295ca1671c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb9b7174bb127be7452e04cc8c28e140416553c34bb4807637f78dc0ad43d53(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96c83a8a9b710da6f258b55a2631987876576e732cef39bc59128d50d8f5c37(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4ceea15aba7e3558c91eb6c0348b4946fcdb58c60c08db09aa898c81e928d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77927e5ff5e4d6c49d501f42a80981d4447aa7dbc154c4228e92de4ccc47c89b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d7fd59004c601098cfb6b93465674a16f3b2e996d8d3c76122c52883bf46a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be6e636dceff69ae455ac9d94cff9311798faa1f6788ca0c6cb85780776ece0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58abee429d832460632633942a30322f1db06616c50dbff1d3b2e65a23fdcb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6cce16aed43b4ba1c07be72492d87b234555b291c11768fa3d32b5ffa45a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509fc3ff56e64ba47f903023d1d721245c1320c05d89485c6525a1fcfe4fb26a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b8631e7830413d602249b52e8a363fc98158b6b7804b6314998e1a08f197b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f32df4eedaedfb582dd1094e8925b0a06cc3cc1cf68a188850072d84e4780d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3384997fc1feec8505a696c12b1302543fed81018b4c74c4b75cea93978fa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7016d1038962342788334f05b8a4e098e79ed752f1ab74104d10d431a1e1a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b006a2b66bc88e7784321cf3349f7013ffb99a3e3a1681c313e5f69b1616d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f08631aacff10a40946163ffa095eceb357655e200c33675f97655221aa376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3b701c5770bd3809eb43d71fb0f045d946d3eb6aae56c2835d8d43bce49297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3ea251ec3b9764750f2865b0555e18a2242107653e63697e460255f700fd9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafac727d818126e15e8d08166076da69097f49fcdbec089657b9292379e3a94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45501c5b6c1b0c75cdf6d4e2e9b58da22e569c80f7fabf04247c2d51550f5ea5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc33f28ea97478cc6bea4e59b3a9ca6dea76eea43e3a41451b94f5a05d9fe37(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248048ca6dcc3e8b79cabd76563492da1c7c5ed6509c850a021d1d9204fe22d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f645e3a73d7e6816dc3ec5e74ddf7c3e13f7a6e7b14c0d815728e0d00e431439(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51fcfa440027b1eff7d9cb48d26d852acb93100f6370e4adf972c240ef8f638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6bc4a0059b025adfd35d42acd1b6a4ea78b4bffc04b6d8f6387863c00e93e2b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386016b7a4ba2fdb91b7bd1655047f0e3cb5dce50b24fe79e8c3aefa036bf4a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e4ff26b3c7758f3e60288eada3e016fa45b65636d8868b7812d62f2df90223(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b9d7fbe9514c8de6843198a0416a8dff5c1166777da8af5054a4ee3a69d32e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca70e2b6e2b259ff030400267687d58d0be4c8121232ae7cdaac58951cac4ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77680a5c165f318db76245e9e47c688b66ff29e1a976ff8378aca6ef0da122d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c0b9fe47b629676a9fd74b11b3395592f77f3d0d2d6968811b161fe4d468daa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2c175f6005cf7a4dc3e9764756050ff2cbc0ab35b4fab6a106199a4ce6057a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ecfa990cb2dc989fe17eb605f8fe44071d0d3c7f180500c1756c10de9f5e427(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288a7c371ee6d7e79bbdcd307d580417e0d16db2862c3ed4f49e238779202c11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e2edf2ea93ecb524e5e30667b74abc65d072db4d35a5e558710a0685c8f474(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c953862b29a7eae57eaad63961c0b6c4d1aa9d9b02d68db81093ae9a7a632eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9274283cae0c5b44f452e5abf012a6933efdcaa2a779b833b936d870291da1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6479a6e822cf161509ad013fc6a399424fe07a9bf7c54691edc9fd55b6c74ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560a0964f744a2157690849c88e5fa00c06629f4f062cafef1800478346a937c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba3e068d4959499cde4dbd844cef8b3b21c074e7c3ebf34085ee7d5f12fcc39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d9941742efc12f3dd23086ef41bea0b4153bc47381db955df8256f01c1f548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37b95b2b64cb9824b7541aef225eeb5af1b94509b980be39840d9a9d5ea719f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d791faccd8e6c2894fb661ea5a268b8bb136b4d1b0a0a4a272264c430e30d20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1546e194bd8cd542d6b897a929c2bfa85f09b97f99e5d91cdbb46a1331ee31e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08dd5f27e448c0e2720124e00b3835254ab0556af7986d6d60fab947ee710ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2cf58c65c2f5b1caa7889ac06367e44c0c6723248ed7ecd9c1ab765265cd217(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127193147cb40b07543ba50898b3a983b58b07ada682a2ac6dbdc21a7d7e4534(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b0dcbcab7fc3be5bcf12d7b416000327e774cf4e9ddec25e61bd2652ae25d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc62db5b8ab28243dcc430a23206a168995ad32bc786a894474c92cdf071dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37e6ca4abb07f2d9990b1d9073841c377e731c0edef1abb00c0dbc7795667f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afe90ffb1b8728a77aa58ddc28bf4c0de82810eca86a09346455e795b83f29c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1e52f6db88cf900a0ab45c17ccb93080a0a4416b32a289f48f37b4c948dac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f5e014adf4d686b7976f10402aabd644d816da38a2f54794504a4d50f601ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d753a22b2bf555f65c241bbfa27b181c83a204e0d7af97417f2af7c85de6c4ee(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f84f022c8206054058bd02ca86d60144d1f51addc7f047886301f34b6e4fdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e72e5eae42edf5a856ba8c8710f750c19b3dba52eb800352832ab82307ef0fc5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80eb70ca625755cd53f48e55d161ae83732b9e4d6d0bc9de8d059e59039cfb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfee9e72a0c498ea8285406f115cdfbffc11a4851acfaa837981d0ef7d311da0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ea0c457254846f6f7960ee7a344e6dbd4ee1f9f8d213244f5904be20c0b365(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9234bd0478478dfd3aefeb95f33d39437679bb274856fbd549764878cd6c474c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ab49f1fa3d5980d4949ec477435dd19a154eac75b993065086d3bf398f44a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85997e4006c3e668cb587c091247229c6d90a5245792d6801ad1378a5abe7e84(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d25fbdf7aa6467cba2f8e92a87198e6c12e9c631a7bb7f4a9d9c67cb78489c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8baa744d3f660283b8543ef78e0d37cb1077e7c60c9ab274bb23c847503c2f45(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1d1f2790b42b5b373cef54eb412faed0a3cc5f5e4f8b0237d7594bbab5c4cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a79e2c01fe9a9edb8d9ad3079b733ceca6780a1d648a141e303a8c2712fed9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f69e463603adc4b5f15893dffa0d189a2c2295d56b41eb217b7ecd75967fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214c5334f154393c90ac4ec824ba782f4af22b3132234efa8233c1dc1842492b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be3879f59c97aa4c329283d483d416d8f7d161ee550c0943fb94688a618ce3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1c2f9dca9fb6ee5ecbdc7c189ee697b4249382d23024d74f4e0c831e2d5bcc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a73597ad334c701968b39866e8d4d2e0809e2ae6f4554ca503cf1b97c8af5eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd2a8821c5b4b561d7d4e58cfe21b2b1d79a507c8422f0111d92b259fee9316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9a8c80c365dc21abaf21e8b8a9bd23d496aedb29690a6578bc2deaa71ae158(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd509f31e59aed000ae63aaf4e7355ffb1c72895898380743860d3aa18923e99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b8e111d0c8c110bb15e8959ce88c7dd674e15171fa1844333792ec02c33280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246fdd4ad6fba7de6fd8ee2ed5cb7c439e476d1180867751f6f959ba1ccf62bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03825ef66222480db9b42cc6b7a01ef894e3937667e094fec41dc495c3f65ed5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d48a5989dfa3c53273d409d68837e1d0ff72a7a0d63775c4b374446f332533(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd5013cfc6bfa03042585fb133a7aec5370886d7c13dcaa099351dc0da4320f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a78e30304392a4f3ef1228f4b2dc68575b9ab7dbd485f20575a8aec709087f6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989f21d446282e41c5a50fffaa636409401207b9f14caa2f7d9ccd6ebd07317a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c284bc8343c3b7b541dfe685278bb423a77438ecf167115ad56e7c0a5fda31f2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e9572760a9c460fa1cdee698a453eca97addf42ebb4656d1a68119f832779c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db82c2058e44724936543f95f07a5dfd905703ea14682b3fb4ac820c679cd4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef672bd75e384a82a9467139c3456c676a5802a9512afb986439b3c3331f3caa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d14bc92c7b4ccf27fd63cae8222c2361ed079a5ea30170942386f6fd425dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040b3f58b83bb2dcb80e0de3d7f47292097e881ee42eb52c19f69cd8bb52c449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a67e50d8778087d0327b025455ff32bd55ea939643429a62508b96dfa597eeeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25599833646145b481fd9de1b63aa5abfd64794d40eef75dc2d08f33d833fe5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288ed022794d96b7d643bba05485d38fbc0dd19ffa5bcd393aede610e2110dd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0f3c9894cc580fa940c7d30df825194a011be98e3b7f2766f0a01bfa01c0d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54f15248eb106eeadf9cd882eec55c0ca6a07c9ede13edbd4775e4ac76652c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200171fe255270fc1812441fbed61418fbf459362e2fb67d4dd22e144086b03b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c352726cdd54ad8498abd5a698f3ee706bf7d6dc6d4001d1cd0ae2d2678613d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f4295a5878c0e2649369fa4835569f9352c8618c2a9a07e3247bcf247948855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c05d0f6769e0babc4b06a4aa2f9c2a0b8b9a184044657b7a3c36eeaa2cacd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507b8c9a44c7a2edc85edbe03734964471ab4404f083e9bad3b7b7bc07db464e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5cb167dd4f2ce25d4acf439d727e80bd8f14a9aba9d71b9d7374458399ff37(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__539f05145b0c609b3d59433e82ea3727f1c2eb07f957993cbb95ae3071a5d23a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73549aaef9a583d91213fbed1d3065d82a8c1afa4fa67adf56472dba8e8b7732(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb072faad5158e976c567b933bcd5bea95cb09b45242ca94c41196b801a53132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__651da22bafa7d09ffa62472ea4db3ee8d3b1ff684c9148d2bd20630e38a1af2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d21b04bf6911e0f5040f1759ea4b0fb9fd165329439d2defd4018794a1ada12(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9c0d554a2bcfb8ca80e96cafdc242f30fcaf3a3ba8e237835fd9de71100bfe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c345e54e0cad98d26f0a3e3bd25644f8dfb1eca0e06a19559b7f00027ff3789b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a08a42a3625ecac70b59fc28933dda8a8552c1b7542539f4c9b47913466a40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d7995877add8ebaba5ff50a9721bb965210ef43d662cde073d46de3b4c9c0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae74b1a89cc4bcb698acec8bff47c15d89aa3b6dc03f5899d490e7b593eaa25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760343801bf8028a824fb23e1da34d03abcc304979aea84b6bfcffc6dd679706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e7e21d8a4eff8fc7f08a43ab6c7c328988e2954a9acd32aa208fa897cc1d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854023198713cbbd6fca83d48fd8b9bc4ac2aa9912a0361608f099415d5e65f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d511289485d8a462b649bbc48a0dc6d3acb090784bc98c384a24c9d40e2052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5488f23f49ed3cd729dc4b2e32342de8c0fa6eaf1f03b4127bec086dd3aa888f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8737df35414454608847755fb52df09fb2387724821a97ead67436d221bb82b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4ca370166699e33c58b2e81fbf93dd95b134a8cd93c22a7dfcab5a87bca8ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098ddcd61c40f51e76e6cb60eaae4b8c2090fd5f8fc3fe7dafda84a14f2f08c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2caaa85fc5a90e723da1b0bbc6ec5bad96ade73334dacc0564cae3ecc93245b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ff350862dd1b5ae76f064833cb3e457b6588431a77ee090150b6a49cef45a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c90955b734b0544dcbaacc052b95164ccd6bf105db072ae6256a0b23cc49d05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc40b17b032f80cc2d5f8993eae09b43f92b59ad1a69ed5f010d84bd8fea4400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d4a3ebbeffabc13379bcfc97d05223996053f34ad9b62f2f435f0543139fcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d7aa463d0848db46d9c80e595f662d3b7048d1d3d26394ba39efa5338b5402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b8c2c1f8377fe3bb380669198695328a344b42606ec94c7b8af8c28b354ebc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c96ac4250a28a88a07335255f1a7c1528110da69e7baa246a34d098dbcd725c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a72a363f90150d7cded530ed43b426a7dd2b07f10bdd839d3e85d908a9306ba(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a9c34e39cc6df2a41c59f2218e85885389cc2c38bb7595171ab3529a553f99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916d9b124561c60f530627c4da8932ebbfff8acf316b3dbc19b20d5fb18d318e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16766bd143e13b14586cf676b4bed98ad866a47bf24e43d6fae05b4a494c4d68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c6e0175b740df0043a96c17e74c01e36f3da88d0aaa78acac508526c96d11c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33768c83a261e80a0f597b86c10717fec7ae3251163df82ed01c3269ea902c8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89eaa45de187620c75a407ee4bd00f0c4068e0c11ef17b239f30b28d35eb4341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073a47ad4d50ab89a47c8ec774f26875ed6862d2cc6dd40a01fd501db61fa040(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728e505de315616d9a5d53406498bb3c4393b44291679ffa8768f1ea57cc45aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92cd3a5122cd91ce777c6c66eb07c68d83d203be7f862a4c73bbe311783e1730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f43a7e36a1a010681bca759718077e8c9ea5022b1dede9367c44b269019725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2d530e0f4c274791270798724e49daa0efc32577e5de138b52427ef100a05a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d835b5d6a3b6d26b082afc33a8e582f82979fa8a6a886db782a277c46c97d1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442049bfd2f9d05592de36f04c64ec7360d168c9d35651aeef358eea6e746dec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91947f565a10d16c6c194a22ac763391d1476fdf32294acb8fbd8ce759b1806f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd0cd2beceec31a4be9cbb85d99022963c25a72b3a3479e63bad702ac045cee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4422cfcde300f52b8b82259ca9b80b197dd7fbe70d05d6c34009c35251f5b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e8109c444b9e95d2846abb83028c8be94cf126a1cd2330d950ab5bc88cf5c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d03b0d800c3e55c5be9f69cd509e49d1a073e51999990f1f5798731b64c3dde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdafbf70f038289bc47334fc667985b168ff32cf922e8733a14979c4d96c050d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f850a67517979989477dbd2d9aec4c85662aa7f4aa76a9666e82212b60ce25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb515bb100d29d3fdb61651c03fb6b9417f1ff3ed67c3295606991b2bfa983e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e412d7221e8e977340bab073be7510d041f3ed7a80c42b7f4bcb3a6e5d5984fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cccd4c445a2a04783804a436344824d22b9aca298b268107c3241bb48615b160(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d35f1cfa95d74465146dc1ad085e9763c82c646c5d385ce5fa2e431f11b9ca6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af3a6637a6b27d3e0bb01d47a83a497c52b4ee4999e015f04cb5951c806d48a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb7a76fc1b8dce38fea51921c86cd4159f903087969428506de6747cff87840(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd9dc11bf25aa7aed8e85610c23e8747d4efe34d7731e607f0af0e2a73c602e(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d841b8f593857dd7d581408459bcbac3b023a89252329f1a61ec5752492daa(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe6d273285f72ee9c50bcf2b68947a4dcfba4d008526b263fe16d2914521dc1(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981e9ef32b543cc2882ef2a96f86c5dd88714f78377dd61bfefd10ce76dc064c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674761ca697cffe1ca3ac7bf43ffa784855fcdb5cb3de3d6afea7848cf86f748(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e41975b9af90ca6aa0cd8df372a107643da76140979538bc1e90f5e59e63f76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e5e5a98b1acc81a34d8d9d85c475f78358b6911249509d57b680ad750441d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2580ceb7fb04b965cc67334361479cd4e2df0dae08532bafc6292f11d96239e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3509ae135382cd01c64d9b047369397d90e286bcd52cb21fccc65d4504db7508(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15000dc60ad83beff26c1cee639c33f11d5676a37470c444918e7541f4743445(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc4b953a78b81f16172c3f6623975cd81a6b472ebd6d8f7c546fe82a715f027b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70e89e29a7433b0ee7de2e9b6316131a89cee9eb68444626579336b8933b7eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9fb57031044cfe853655a8447e31661a10c34179d08b98d08810bb18b2c31aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5790ef94294bfe3e1a4defc5a7c72c2905ad7f45defff7a7046e68d46ce9372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e750e29521d1835fc3ed3b24b461102b4260d8a903f0e0deac228b94cb3c4fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1c31df74d30eb0e57abbc391419b4963557e5e327bb71127c0a426fa9a7ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edc94ed3dff2b53a7b6786da61cec98a142a10112057707db961ba1ddc3c537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7b501606374e0d690a0742633bf04096d6bce1fd032a61f0ffab00100e1e83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb06ac66b5f7e4c285dca3d2478af318826714c638017d9913f25a4f1321afb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3674449c5101874484a4dcc669f822c49df5e6fdea109652bcfc4617a245ac(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58703c0e0353617abec5425c77a288baeb8ae7d3971dc88d6c110215bf7f7c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63b098793c8867d01e0e9be3b204770a1fe6be82158bfec044487de21af5b44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102cecc83540ecadabe4d34fa42c688315a80a4dfd20cf88563468e8f0d55121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c384fb29cc09c00c55f7c634956d997c26e6183cca36a946747e6acf7000b868(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1f1afb2f59b5c1a11f6e30065f90afc54f10aa7a714e9f059dccf41fe9fed2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e053a6cc6d12be992618f10dd1f40f9409f02025114cd012088fc0bbcb2e21e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e92367be572ff99b33639f7b877d5f24f6f794ce5362bf47fbb1eb256ee3f44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e8a8017a7af8a271e70d861b5ddc58de5c5d6349f6322961990a2631ef2aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219fdabadb457ba1d1edd7aacc1ec442cd7e1c81a53499d70565f1cf2739ceeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c77a24c9c2e02159f7b2fb83ae6a824f158e845744e2bcfb6d7f99ba4e1b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f1184a46818bb7bdc5edde4d71509b4edf9ec547ea41a2da6fcf2173fee0da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d61da3456bd671638ebd739363f4a8003987c090cfe9f3a82d6638c33888b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6733a7f3e0e4f900911b46cea49d2d28d5e51e65cee7ee79c60aa24f06e0ab6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417a8222b8578bd3e6370d5fad3937acb42b28a1b8597473b460bfd5bb4d0f07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9483bc22d2de6b7b6d409ea22fd4840c05c7af71121b47fcdc5170f77e57a9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38fba26fbe1bbfadbaa27fb5b0b8398439d39d543d3598d6497fc7ca2be7b0a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287f80ecbb8bfa4084ac643637d69036f6d6a9f5c96e41660c0198bdc74a3b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4bb0330795f1f7e87685133a9c2c3e2628a8b44fefb24a3093c5b0fcf3d3de3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fe256b1e84ee5b482ee4441ff1303d5672bc2c697bc2c5192f8713b2d4d46f3(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbabc4029c08883b55840c924543685d35aa2c8410e1e060630995d80516e271(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70f37f54856858b9f7e19b376b6ced788586bfb5fa1cc71f7a37d77a1eae584(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4436621921bf4ffa91584e34af1418eed49dfe3806a1a6d4d95d8854526883a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca792045af738a30ec1f9a369519fd960574274857974bf9568c87908689e784(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21121254ca727c594bcf8648e82d46a6ef4cfae5ccbd8839bab50d901a670d9c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376424791f4455a0b53e7ea7abb8a9d229120e89eb2a810df3d5c11d06434f8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e945a0327043cb8bd757ec64dbdb98561ffbbdd9a007ccc70843fdfa8f8c0c73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3332855e75e7bdca07aa01e238bb91bc1eea9b9950385ed3037472fb720d31f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1aa1bfaa0d61fe8fbadec8286c41f907080bf5aafeb19c0d17a91d9f3ca66b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378d365368237ae505488143b509152b6e2d644e1b893c998459092cdb40e8c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413447ab66f2944a127c89370bee2a0f3753bfe44d84ef1e09221dbb873d9ff3(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b59b992576ee0841159ba169a495e6bb38b3c6d23ef86185b7f278e030e32bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9671641b9278e45d662ccb4f072c6f0de235e46e1f63dec190efa79b7738ee0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba40e09d574a42dac35fb042b37b7dac37cad64b7d31055487ce9e97b4c94b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb15f24fda8786689be33a598d464b92072477db2a8f3cb926fa6855d3694c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27e62e81173787faa1301ef9d8200522de28bcf7e9089be57945c7a5eb9dd0e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb1b4bb8a046d0db1df4e068553a67e1581c5750602a88d66b48b2ae205864f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60b9e553107e424612676430098ca22940c2fe71be82dcdd8eec88c81a90140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f498fd35f9d165f1e35b73a0584b3475f5428a6fc1ab89c7bb8f014b5e2d39e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1cf3568a13ecd356dc7253b5ac3621b4f162975b6af32b5a266004e6fbdbdfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8a1b0e63b3f4b805b51dfad4ccc0d67be4db9c4af7bdafca0324657812b927(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43cc09c3a40a9383e402d46c8e503cc505f870658b6cc7ea4a459d10846d99e8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c9810e5809bfd3d4fb407fb025b8eeebc02c3ad6bd10ed9444e8bad4a8a3a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293ded71ef557376370fa36b64f95027eb4acee6fef9481b0e3169f6ffef26e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275841f210195ec33a4fb70126799fefff7554311420c3d66ffa32371f58401c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9a2942a38ff2862c40157f0daed528bb92f8d26872b9a1255abe8ee4d88e233(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b2e3e3dbc62dba372d98006add69670c3dca1a4f22a262146dd149b03a5ec0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871b2b9897ffff91d31e54728a215fe221022a6827a5594b4bee7774b5466bbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925381e31292a383f8cb4601fb879c6802e38ae3db8675d712dcd9e5b3acb322(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1544886931fde90fa718fcd4d1d742826649011e21b55ab2b6a1f0936a9e00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f69fed8d8b8a02431251508e5b391e41e3c6b673e6fae6582060334b83be508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110e4beb0950f9476bc7ee76280d65704625addc6bc7a9268b82a947d4e99f31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c674a507ca603dd2f90a04083c46a0294ea4dfa333e1b737829e00d8013f68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba16c8692f5f3261df6362d5208c4796ba7b9cc3f80cfb2bc5eb81fb05c3c93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45f041833b710fa8bb1df33a915dcd3fc4b234a20318de6ee21785fc61c2356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728f1c585dcd885349687b7d2699c6409eb0b6c881151bcd17a1c103306aba7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5fe457ce4352bfde6de83a00d40eea30d04dc3d5237f3356746a4e5f347880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e684f4de0644ff446501380e4098a112a51ecdf2d5d4b15a6e5044ed3a0b7d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204731300620a1a6790fe57e11e25555c2ab361a3782145a6d36d3c9f9733389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b368310974c180feb2bf9c878bd1ee68cf50f6bc4e4523057c4d43b44dcb08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2fe29c8545e8bad0b36959da57ec4227d9d6589039e50fc875a6e08fede057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4390b80e84ac85d280206abdecf2293d0654d126148c5e164731aa373f5cce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bb9e7ab0a87ab67195b53f047a7938734337b1fd5b745f798cd2729bfc96a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406d01f4715b0a81bf6e8b2828643f355a59dc11d20855d873c8cb7c45e95c0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f613bf587670e55b22528962eac8a9d9d42844fa1c9a0eb7f1a20d9194e97b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6628ce15eadcdd5e05a0f408e513fed53d5d8a669cd1f03e45508a5599738a44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc3bf725314b8fd62950b37e90b54c4cb99910a96f466ef930e9d57bc8992f0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a197d2745453d814c5f3494d59d377a302ec055043b2930a609b195c34d536(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0287ded8194c875ad6a56c1ce728b17b5f2eeaaa8d42eb8ffbbe7febee15d5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38375288778c9958294acdd6d0e00a8a081947ed8981afa680bd11979b5bd083(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41eda1194a491ac4963038c3bdec2520a3cbdbfee1f16e89018a47a70afb9ff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766d571f62d900d4f1843459450e6c85d4e66d396dd476397db765cff620e1ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec4d34ebac04a109abe8ce6ace3316fe3520f120ab252c0694ade8a7aff5f54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ae2b48d95e1f2b2538ffd642034170dcb0a31ad1cb8b353e9948fa3c55ff90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff41ff7afa163ee43c6175388478d771c8fa3d58a5b867924f3f0b979c6f5cbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204114051b38c1e627c1a1d8caf05990082f93e1887a45d15e516dbfab35c932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae0a60a26377abed8ff23bf6f7412dcc7c89716e1ad0aaf1e42114772941153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b3bd9fcb0e566874398224412ddbd3b94145d7b594f3517fe71995bbb505da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__820e4e4a9c8838a179c37621fb2a53e2019e1c72c4690567d308681aa0a30997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e2d7106a7265f88cc418c14d1718e3820ed808f1b88f1daef54dffe07d127f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330e088b10e2e7ded4a43d6b54f85e2133cc666d3d8f16debdb94400afede3cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c3a4e7b2a4652f5ec8be732a9965b6f3b4e7ab2b7f94a118b5a96b43658cdcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c204db1073cd3d82fc0204eae0f1cb7c05d3df671eb30525e85a80e59ebfda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b03e729c89a5f59418d5045a18e54cdfa7efe136e6c38ab2c50bbde51bff124(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c670e1eb3f1d41765c875b54e9e9cc64f3920c391c9dfdf7813b22e209f2cc0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019328bfdb22626be6dd5d4b3ed8cb7e313cf2065254af55c10171b8fb9dae28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1dc2383761ff21dfbc86613b8d945f335faf9f1a14c728a2a3a84286b1c1d64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a730689d609e1c0f5cddc9a23ea026e34e35dd602faf8d1e60225fbab4188eeb(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48402fbc961b1f41a281647580d12415cb21e9d657a9b1ad229b34664ee4de64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c405ecc859ece98f6d130208afbb8b6b1c51c70066f9d3313b379c72cca24512(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9bcbd9e485c32d6361c47aaf1a7c91ad5df3089d218ec83575c0021401b7fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21963e453cca505d5d5cf9b11427e9411e9bcf5c5f173d8bc7503ae9a55513c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757918abb167d41f95dbcce2e85ce3c1119ca4d61b4bb239760632c666370fda(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ead8748aea3722e09d0de18da729ab928e4e9991fe5290626cb915a954ce93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7b1779fcc8a58ecb965b2dc20d19ab559692f092f804a631244ad52b755112(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ff57f252708df9947fcab1dc7c563a630c467d0ab6f8a2bfc141ce984b8c72(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0874f8b4413867a0629d6d395c8139b0b20e6cf28e8a3c628acaa4726257cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f48729034243b0ba264865ef10c227149d2c457a776468fd7beb667db6180de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec2305c345b10838adcd14a4b32eb521d1b4c6507a02e79d4fab398d83bad476(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7f8d3b07d378cc9e2751c27ff0d21e2baa1c1895ce7eabbe75752a90647305(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9fe30902564b85c741f66ef97b50942ed2a5f1d1c5295d584ba7c1b1520538(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420ec1cdb1ea08ee8b823e61f7037d73d029da2aa8415233e6310ecea2b99c45(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8830a4783807a8bad1e8ded6be2c4be1b61a4634d1fba36239b9e2cf8ff1054(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b45d71cb5628ee0e24599fbf388f3778b903ed79dc1bb5645ff0b50cd2d6938(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241f658578d48669772cab98fb4839a4b5c4efde69a269fb53cd4d4f07c5aa25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e49ca7faa2b68a84a47014d0c3dcdb19367f6ce5d55246b95485bde50d4bd2b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f322d5ba0d4d5597fbc1b48df2a9dfdb4d0aa1705ea9399162826b57d722e86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82cc9c53676e31ec81a7c6130a5560437121561217c7e5656563673eef478f9a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411543f8e02ca8206060485de817dac06eeae75a399d1711c6cac6ce3a19864b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1ae7fba953761c3f05e0fbdc05733f230489d417d322fe20256334682506c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94bd9a24770f546b25537447756f8588a256bc9c7df47f0d7d2b5cde68646229(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86deba42f5bbb133a3ac715f932b01954a27e96d8df0f1d3def2ae51816c5b33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e521883e98a156bdcd4b358e0fdd0d9c11252529d7fe8cbdd8aea6e52d0bf4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09cbd7da8e26ac8a27b10ff8effbf4aa205d03536618069f1de067ed8e452ff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc608b3ab9754dcf632a9402a8e5eb95cf3f67758ea5e917f2f7afd2fdc1ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ca572fcf10d9c17aa95d129b88cccbc0b44f5f1609fb9cd7b4261385a4faff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__758a4da6cfef59f277a989a51793220ff2f6125855bae212813f811200247c87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b16cced07b64d632fd2a5126f547b53ac03ebc49908133d93d37b9009c5927c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8cbdb70c60bed1762ec0b4adc6c94a8beb0c61f7f891b163b6e0bd3b477a1c(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892539feeb7ec8d795c59e89f1340dc0d3fb29292028c2be1d7575dd28a64070(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5584f0a3e077fe1715279a1c0b5327b19b491ef88c6ac36162aa83e985b678(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcedd881f8506734973a667cfe273c82b5f384ce7744b4b488a780fa7b8b33e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957cd4bc3321cd90e4987848dea20b5849d4461927cf0d6c11087fa80bb2d361(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15299bf063b73604e92d6a6286abe31fb6ddc06b1ef6026b3efe31ed33048078(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e125dbf63356a2d079019f5980d32294242f12ce345698b06c92b64dacd78eba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb5ccd73c68dcd846e70c7de04a56457ee86690be2c6099b6d636f9cade0627(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4030b48d7540f6b665b1d7a12bd87d775cf04ab35396ab0381b8e09f42005c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612add1ebb1d50402927b788a29cea8a86c92329d86dde4a66c46093b53a6b03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669e11d213272ad5c247b5cef3be8bef4e384cc7521dfc7d12c3fd82d97043f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186697430c81ac6ff3158750ac73953ecbbb1724113e9af9d52e070059792653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0bd901face09b682beee1d830f102667c904eb22a1494689c774c3d151c7176(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7dfd702b6619c0cace75dce227e789dab4ca769d88a8244f019b1b16add6bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdaab32bab2bf6514acfd1b5225d8806d13d176a6d386ca0352f388cc66989b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6adc8f9f2d41286a92057f54a3de8e91950a4b847805f87c18d4ae65f8f43b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8bdc8c06ec68b651172757987463ed33625d156d32d537437be413f1df5471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f0ae4fa7c0aca2224adf5ca31809139bd60d13d6ef29d660a1cd79ea44f34d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb3cb121dc98e04c5ff5be901f1b98706ff21798daa5e35719d82220581aeae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7778f5ad16cbf2431f76d926004d351e5a54ca9f1ad3065087f81841df05d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4f3bef3779692a95689299c428c8b1d9a51fbc8302daf866244a16a2bea92f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d9f11b5b1044aa188328d7f1ff497d31bd3cd9ee5143a0fe6fcf2ba7af3a84(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5654912928e05ec2cbd402e1a227354b4d2da511c39ebc2f8386ccdf7dd54a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd9ccbf0942e1a53db79eef5cc0681544f196a3b10ce615509ee419a74941d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5193b6337785a7c25a84de4c1f58bbe81c2efe4c6767ff58e34b8fef6746519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe0382fc2aaa5526821b5c5b69052b2da80ff95c064cddeef8adc2de4ca6a52(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1a3821d4803305fd1b5458601a163e358eb840ed6f3ee341db2ac9c148c0c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b3307b86f4163d299efe931343d62e41e2b9e49d58c0dc738f8f56d2023ddd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9fc095dabe8e119c4616425c37b25e8ca3436ae1d58ab74542f13dd213a200(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a1c4d8d6266cc19d58fc7e2271965679e0e8287e807b9abcc3f8bed8caee42c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0234162c3eba97623be7bf9a58a90097e66faa689ba60a205b5aea57c7a160c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0bb561540321116cadc3824185940324d4f4b92ec051383b1f9be89bcbf8542(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8a54d7da61d167960d0c5e6f84e062663dc9bcfa2287eb3489107b4245400f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9550211ae9a3efec8d7c64c66871bc95ae706b76277a3b7229680b579ed381c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0f17eb40069827c8959df40cddef11eb47750357604d01e9eeed83de227f22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b741ec893d1c91c53be9ab43538f1a40f045d50fb8b1e062e0040d4b6dc4db17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba38921ebd05a32567ac6f9aef4f88791ccd2fd2cc0ae2aaa0d6f9a47c5cd1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd7bf5bb868141db3198b5a1eac3ee94abc0a5eec53ba5bba48de056ebf85a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536d0122520dc12555bd3cfcbd8196dc800d51327f14836e77d4db809c4cedcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f95606fd0c66392992ce6c9e294c1b24526a9838fd3fb9e389a9fb0f3b0e772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a09681b3ea1011e60b3239a445d86d7d108ee3306ff7c6ea79eeebb1b691bfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a475773881050806b82a090f48e839e1d4839c9ce57a2d507da2e77daac237(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ecc5ac68a8641bf6a2757c6bbc6694881f004bceec2e01a6cae0f1dca925f6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a3aceb8fa39b2d9094f2e3502ef3474ac2e62cbdd9dc066af6bf2603ca5076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0d769ca82c97d9eba5939359121992dc5db7c98da39892fa8bc2b8e43a80167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd230c370b7100aa47385128273d8c095401aa90ba57d47b1fbbcbc7925a1107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0feb8e680eeb6b6f663d6f5664abcfde6fcf87b3b4a1c64c3ad1dbb869b6d561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61999ea5924fd1b627b90bf13b0fb62355e37118bc26133bc5d998588867a905(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70bb4c9c1ff39acf5236e6b6c73239a3ff61fa8897ae7fd5cbe28b1c82822e0(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e4fa4a75d38060cbf1d26297ea9b1755cd114cdc5768b616217b708dbc69c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c9d4208a9d4429b97606ccfcdbb45926e323de2b413c2b9fa3d56a8a227f1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1d3ca84a0d2d72b493a46ba2cd884733c4bb13c799e005003f26ea9beaf7668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2f234bcf5f9ca5c5ac48ec7cf1aa198a32700163fb9824b6dbfa731220a334(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e640e5b959920f891738fa2cf67b6cae0cfbb4a66df874abb58e28be1f0b24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1854bc4573a2e8bd43999934c970b4db11d6c452af1c104f582ace6943a11d62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420bddbb7f97d215dc13b1d58559df214a32fd47deb93045ffaa16e8d7b2afdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683f4446b0e692211676851405db8dd66a422785d68453e23cf34880f6820f88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af8020d9793746684751d48d32fa698827183a2f9b189e63fcfdfa802cb143c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbac775e6ba13fe15a9b38aa00710bcc237c208cfd500e8d6979784f69e9295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e63081879a1e254dd95ea4fac6626d2f1ed1da9e75e5eb4007d6d6438dd71a92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__020d3767448dcc860c7d6f2de0cb7d18d7bb0c20fe0e011bf62b844d479cce39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7202d820bd90027cd9bbadbd4634bcfd1c26e5481e19c4763f138be749b281f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b7853413ccb2ff8c234076a80435b1d00c384a096fa0370c39fea131c2bfc9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfdde96c84e5a5ca9430c803ef1696c4fd86e565f56a76327579fa4b917e6352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361344ceb30c5e7fbb70b2169c309c83b4b13f692348fb44ef4b43f4c87eb945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e416ab09954ba29eaa16238a1d7e6e4d2613a6fa48ac9ad5e45c599abdedae4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00540d3b80080421fcff8fc47cc3df5a020fd98462ac5d302624a62e90186065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab65bcfe1c48d14142823e6c7a098fc8c12c4702fd5b1b15d66e02aa00843be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d10ec8529c7ae48da718cad3922a552e820a03e467ccda98751b88c6d20cd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b878b75e625eb7237d7bfc7125d245fe0f84a03b11598404aec433ad88fc2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfb6bcdb57639395c1a548e87bb7bb58a429cb0d92d875e0f2ed95e29bbebc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d45624c9af1f4ffff6ad95df403af58ad28cd634dce4e714b3e2d47b202d0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd5095351bdb8314d1047b64298463fd76fe8fa817dafc6c279d1049fd6c283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08befbb31fad0cecf594c471c9d8ef0f1cda231033cbfa623dd0fc218984dbfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20078851d77b12dca4327240f142f1e319ce55f64715a7a85d3a082c696404c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1350974dad7613456aa12e26c4f429eb9b8539d3c2d78def2c30a89c3213e62d(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be67ccab2b62c340420fad5fcf60d87c661fb5d40df016edd654021b5721e911(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f7bd80dce9bdec772443126986d156b124e160dda50bf3e84870f7485213e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da00b997502c590ad3646d564df19bb76329607a7fa0f5a5ef211c395e259842(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad3d3ada832dc8e2330f033c34bb9e24affe73d778578d97e54b007a36b884d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ffc0d18a0152ea652f079ad35078d371d536b3f5220bbc5be2102b8f9605603(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484c84c461deb3534a5bb425270c0d6762cece1e1285885f928a986f1de710c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082f4fcb7e5dd6b13217f3faa156313016df2d0e376830a23989f2f055f06d30(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda7001be986f4b11c7f1e55d4a1b37b7a2be4ef463890b13b767771d5510da3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81400ce35b86b35a9e70d160a444b1a8511c8f547b13c1332e51935dee0d8ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9977d2c0ea0d322a1fcd0e223074b9efbfe82553c477872e1b204ae77556f82d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa7725345f3b214c3b15411ac7e665c4467b2c1b9f98bcaf444d6ce354f88075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2c6c0564e3573e63e53bd987dd2968e35422801a4df6092257814dbab82543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6b2c0d08e531360cb238a7959e8951f61db875d0e6535dc79d071bd7ad8ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91262a0a32f34cf23addc771964d70d8aa1b637580c4ffaa09313d18766e30f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f974d60804105ceb3d9a70aa196a2cefa60889264ee00d347308e5d2405df16d(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab66a5077624e40f96cade19c398966371e8bfbcab9176c9081adfdfb9becd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ea72176927d768bc8922523202f772b0b116b50c044d2de7b3674577ef458e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbb4ced5e8df1da7ec28c95f19e59f0638aaef3b68b8388c053d4c351858218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07072c5fdb031020f7e96a46c3ff558ddd6bb35b0bfdf01fc587c427219fdc08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfdf1beda94c537cb870238dbf7b7b704aed283e527a847fd217a52ae89da9e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421be5f75d15d5c4961874a9338a2c87afa27ff84a2211a65b20c2dc815c2a04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e02e2c8a5aea933fde5a0ddb5a2cd4bc9c02bb05bc4998ed55c53f7eae11e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b570d8f3f72a6f67e22af35685f527474ac74fafca928dfea593c213d05720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb55880fee635609c5b4566509b321f85a0a95b0274b76ff33ee30584148e16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef9dbf94d68ce964c661ba23988a0d36e5fe22a2c53c20d74d04db92ce6ee85e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2144246c598b4a4fe6ef4b9af97ad968c01e5d8f04bca81a8aeb300f8be8cd62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7756df242deb8a77af1a69f44c7ec13efd4cd41a0d00339c676b7a2a13e35a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc0705faab63dfaaf584fb300a58cd19652857495f299633d0f775d96641b5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648f29c13a484cb1be13e6959518b67d2112052fe2344f0b06e5b1605092734a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0d798dd56c7a0ef766f7cb90c8ffa912c60611778f90decd1b9672c0f9d02c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1302e3ef80b8675ccf4117f0298da4bce72fb65794e73c29a2db9808aa720fe1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44dc5164c2a0c636568a94c071d26a1566e185f606da17ba201f2c9780d285bd(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c420a41dc2d85902412225f2e021ff2b4e47ef62a9d25ecb4c875bce02c50235(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7454f8e4cc144daee4d9876de1533819768bfc89c694436edb100b92c2c5f73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd11b4037bfb5469ecf35272dd47447de364a25476e560befb9629972b20c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f9bdbe1a9d7ac1312c24da3d43b9a49c77e198f5737886f7f4e76ec43ca1f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7631d914c223bc1e74f643e8fdda5ff8e585082783d99c1f44542185de4a8147(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa0606fbb38a27704698414b6dbc312b56f9c64ae874faf55fee4fb896cfb53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a33d286b6b7b382fe6b725a08c052f20fc8a23f552c990efde207b83aee20e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bce526bb4ef7f876ba7c42c2fcb563d0725236eaf99ea6940b141d173a32bcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e74e66304623ffff668a73ed3414fd9b33b0ae65cb066f5ca1eae66e824199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3d73e771487046ccdad26bcb487a1e3e1619ad6acefa8b18228738563e1cb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a4c0130061a7d275a5cedc3bd78bff9c6a9ee2145992423821d33c26a44ede8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d2cfb9d8cc16b7da871a561693a92d7f639e4ff38285d1c2cc29857fd780bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1cedd908fdb20936576590a47e6f9e5c513f495b4df7b79a738b31a89beef32(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450c3aae36b2dfde4db9f8d4b87908126ece430b6d89b7dac1c722d1e485b77b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7387bd5f6c5b5560d0c5ddb2f4acec322fd0d8ec88865f229a82bca4fa465e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b45bbe286a5d6a626124184f6ea55ee9f1508dbc6b09167a86635fef2cb387(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a3f2b7d9acd0d5693ca67eb7c9a0412100a52ce89f5600cbf959c804d26cd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06832eee4f37294ab6b74ece5489c702c04ab493e77eb4703b8423b6b4e5766a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1695435c44de87c1d9ab184d94d9335d6edd875cb1d28ce3d35ed3f7bbb010a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0930bcd60059bd69f8471747c0c0b81bc289505b72b3c061f16a2643b1d0730a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af51bdc7fc825b4d318d9adf6134409840495656c843775e85a6d4e47984795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ea9b23120f95ee54b88594db4e610953bd01b1c550dfbe856979d76e75fdc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a7c22e399467cce3ece1b1dcdb44d658a35a675f9689e09083e4c8f1007021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7555d00c4ef6286c4c2370e5ad52cad8032041a173def812eb4780a608e23029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5835c6296319e1b6f9fd73d1651904046f47f9e260afb34fb86712959611251e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba90fdff9a93a9068d675feff78163550aca454162d29d47d88db6eb6177d3b4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b6dd119a766b5b5701ec06ad4935c483452b3383476f67c0395d639f6a0b81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8901e1322dc7a6819302f7dbe795cac3e3f10424c6b5f2559e67834e65d34e6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0ce4fa0a5cc069f02fc9dad0cbf3c24143fbf2791df55081e978567ed51d8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3631438ad1a3581b34a7fc5216a2cc1d69277ffc15e5dc4e237b3b5b336f40db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56cf3f14d79a28bf7933f40e29743ce90d674f48a05a89824da8234bf2741613(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797f0b1ce0d484990b76bfbc7275e0948a7ad9ce0a37a81a6472fbe9770ff486(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06355969e3497871cb102eff538c7d3428236e93545cd0112121a9c4ae48abff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9607ad80978d3949b1055dfcd211410ae2a3e4fea64744c9867c2cfc3714e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c130f9bc6f73949c50f78944aac12920258a815cd4a987db0e235def24f36a51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6c2251c3aaca8c9d862c6b15a52f838e768f1203e9e191625c40e4896664b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c83fc43726a29e1deac1af05c439d00826c87373f1a102ed6daae11b67999b83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2f3c04c313b1be011e633bb16cdd4ef5c52393f3b9c46be2e9b34829d19e8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467ec0bcdd454e6f3a1aa4987b09d971df7b71e000e321f78361eedcc87873e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7224fc3b6e75091e34997961b0cbb8a431e068ee36d2a13e074e917177ee54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11052fa04f8661640896a8046e2cafcb17efcfb23028fdd711007536b8f1611(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef6fdb3826017130352033bdb18f0b3f12de36b9b33ceebbf00af0d23bbff7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d99d6512ab8937b4ae8f30350242a838df1ac8d8c44618ee3654e0da1d4247(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a64ce60c1712c5ea85850113e952437e8f9a9e767a40b58444bd5f33c900a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25b8b44b8937b1719640771ea2854d9618d540c9f6aa2c0e7dc5905aa21df523(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8d6e240e2359b04996ae528a9d1c3b70a1ad412c0c596dbf125319fff53b39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56164531cf42b541b6f6bc2b763407942423b1153728f4fe01c8e3615d4fead4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5854989e7fc554925c80d0d3e98c96568f6aa948cb0dc35e59512c4f77bdb2d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e1ccf29249617cf0707981c78b6f052bff0a1b0939b08adee320a6a2a7cd29(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9984d3cccd5896dbf211e88a5a90059e2508d7ce36bb3333ec83043c0d0f0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed760dcfc5a7d6e84890b83e4e83ebbac781eee491946cbeb2754ab58f6b380(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85dd91f9fec63cd6523ba246e95d64372f6c4f59c5c5b0bbf75ad7387adb29a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecef9b8254c5e1c85f1ca55f0b06a3f5e192079d43ccf5df148ef8fbb0be0a64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7a97bb4357257a3d4741bfe0ea4448f6b9fc7a93e148de9466911b329a57c4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19abf967894b403e5c999724b9e0ee78282d5253ef7fe51b81da368677fc0659(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54a6fb3372504ed994730ec69bc85d2da32738ae7bee61c497252116af693c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4513a114deed25d02a668d11076fd09b911d67595b157b8aeba3347b72398c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6d79fef0b57fcf33f2fd147a4868c13aea59613388f0522f5eb331cd6444b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a0cd185b6aa30f6a61cb2ea32af44f5ea770faf0c01a796956da6249f292a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22977e0aa946dc8d569b14130724d87439d5b2c341123cb41343572bbd22315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f57df2ae7098f0231fc0d1887d45d3195057b8ac91dc6e925cc1d79ab30d9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66712df68f5f2a2be627d3149486f08e7aac8446cb288961daf00fef8353064e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc4b5b77ea1288b2b64774b42c066fb3a37b4eb1bb5e60c5487c7c3c840951c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5098fac80b21cf6d1b4956b548e5287265741a8e08263434cd2476e693913d2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0ef77f8857befaf63cbec792a03b374e9b714052fecafe4737d7778e9d888e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed97f33e1be8793784b9255b185762fa7e956b7e055bc9c10f4678930d3d067(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca61e8f17066f2ca3484228ce52e27e972c46b9008cc6b3f89021b5ca4ea100(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b2b8069d3503f117daab43759deccbf68c3b3243f6c3dc2a853dcd7ac32839(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513e848506026f032d4cc47bc23978e2de306267f03a4b30cbd7bc30490b9e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f646c0e3cbcc3c8e4044bd32534944b96c58359c896c04aae1a45b3146be67(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935a857d1c8ef2ae3c87ae45a6f6536cfeb6297b104a28d16725a24797ddd5f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b57056a45500872292a8506021e654d5cf7b8a17b2371ab5433626fc03c8bb3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8178e3cc57a477c5eb241c3b0bcf0f7153ab1f87ec5f90f67059e8277a71b22a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbab29472b26eb53a703733b12de0c3caaec4816fd32a9a865ae8ba782f95be4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae93b3c8d47bd15e87e93529142064718e123d27ee91a257e407a3f994bec572(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c61e16a000ad5de8752a75fa8ef6322f4fea88510a3434798e7b3aff768572f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382735b414ab2745cc15acaec188aa1dc815d79e472feea07eb6f57822d8a233(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b22af0173ab43d6e48caba09ac39d934e85b54b836dca086299ba5bf18d94b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94c0e168680c2f354216d885b79314590ad5ec2459b1582232814734cb3f6cc(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d245dd0b58f95dc7a8d611d4f9e2782be5802acc958eece3ef3d9c335966ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33a25e48827db99a3ac848fe1ddedb1f6fcd1000c010c26b34c423fd1138d5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd306caca62dab1e9cea19f421c94b5c081f87017946de52c90ff10b53930a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81d3c23ba32e8caee48d19e06b98a520edefc44ff9ed405f4973f887de930f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73e96f9cce66b523e8e7748fd9f21c732c5d7ea9c98453fc707e07569f7b3e2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41106556c18b60260a1e0d618df778a2e256456a05881907897d72f053843a62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc32887f6ec1c20f7aa9c97804633c356570377770989647070272391419a9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e523dfbc89b04e9039db9c460bbcdefeb5146a90223ce493176334672229dd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bfd6abccb221182a4edf4dd87c026d03d81c6b53bf0c75122a813eacbf34996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b68792ef88f8d5f9f79cd9f837a297b578d21410d55cca679d76d9ade568d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a240ba9bfbf958e7fce6f7d7a1b7ab1a0728f6f88c3aca245265baf775d9bc(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78972bb9ecd28860a7074799a0b9f863d5bc5adfb6bd3909e88e595799ddc4ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f7249060866dd1e92b242e765d8d0ac0b4b15ad2cc3e7500a3ac58074cf01d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da74ffe1af29abb1c6a2a50d656cfdede1dca287779e9eadece31acbe2361c2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd747deafdccf9d0bbbeb4690b83dd855eaaedb85c9156c401ec032d4b8c52a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aedf3cb9396c6aa49f9e96f22a62981ef9e9a4d0aac2948168650af94443246(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dcbed9560bc7a662659889cea7ebf2330607cc28d2bdcfe6af4bdd66687d891(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ff88c33704bb19bcfcf7c007aa7efa576f466c59d3a82c08dff2a48d895cb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e47ee7fa9865b640309fd6d41cd6e7e98dd7c8cfd609b83e010def28d0ea44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8290868965e254b040157f11f7ba7eb77dd6a2c06939db195d4bfd5212743f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88553eaf5d8de6abcf3ba31a61724be101dbfd641afc7fdafafdc7b53a16b180(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea1a01625702a912ce26120dc71bc75261f35f61d265c729b951b025179ca8b(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ef9df5a1965d297831ddae1dc6ca3d6271d6317e4a47d8cbf500fe3f5f54ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44f82f9156123da5f3cfd9f6dcbe009a4c398ba6d83ea40aacbd5ea47fa80da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e494a358a2f0713e1039d002ebfc1b98dd7c93212b748f7639877eefbd86d9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6a4632621f3c50d368bad40f3bdd079e0a000c12a221a0fa3d6f1b3279d057(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82fca58cc879963eda9d2c87316b4a49a0364a0541a610741719824afa15410(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cde8fc7651176c0dd5bd3cadaa377372f73bdbdcc5853db7ab78eb11121063(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb30fde8f2c6286ec708fb20c7add1277ef4c80d6438877ec95c54fc8daece09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36912c2e9cc8feb5f3199c1e5b00847fd20df15fa4107e44b01abbe5208f66ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4258c06bc34701e6fc736f917f5934e89bddd2226425ee366fe44a28183c8943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1417bcc87415b8b58c4442599d5b7f74b038b1b75e3d80ea641b5cddb9f1d72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eae9b7f0bbe7f934d2980fb7631c62e5c57c0a6c97d532d352b5b3160908595(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895bf9af4f2e97bc5cb16cd6e4d5db1d40422e614a2be39411fb876e471fc31a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c916e437bdb284f7f56902f183b30ccdb77009510fbb56ff9227e9160177c89(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c4053640e948063421ac7250472c406162e9ae377aa7a6c2fc06a47c4c4ef8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__713d2a20fa79ce47fc60bbb83b89875c9ab3fe88713b965a8b0758c7d64db9d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0ce294749da49e790b91a4726d83a32e3e5a089b610f7e28d0e77ba945d050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e6574d13e03dbecf5fa9586e67d62beb171e4ccf21bbd3866393fe82c6796f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4665ffc7d9c5938fe134bc14fe362c80b451729376c8d50b9477a575e5907de0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8608de0bc3e25045deeaf80ec1e74284a39dcb9eafd47815dfd62c43a99592d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29935ae84e0c54748e18a3be3fa9ab0af066d6a0c8756f6dea6b7c4544ea13aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9858b6b5dc853193fbed9d2443262372e3781f3253f9509f7e19c76a6988fdef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96824fda4ea7d48df288471ff09281e2f11500eaa0436007fb1608e20e43c55f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b8246de63ff4956c21db237c69efc8239e82a489b0e64b25877dbd667766e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19024b24f4c72b4a6d63bfc41b74388fcf08a7f19a539d78630a1a38e7e5f575(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd5bd96b36c6249217c77c1da730b213c867ddf4e249c2a8f0ee4c0c12ecd88b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb81c7a9e577f01f296481c8c11281b519e99d83aa98c145abac858acb68e6f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7496720ebeb0cb55dd1862a4ef6f34ac51f0b960aa894f82f5e757d47ad6b64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0034586660ed77c9f0e7dbfc802aa381bac102203fc7c134170b3244dbb4057(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072b9cf7474dd0627664656aa0c9223843c88cad54cd8f3f05f96d164edef0b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090a7b57c558f3b97c9f6f9fbb65f744157fd03733536d61884a5726ce9cf371(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc792d785d617f16494461c105ce8984564abb0ef80f33929178f13925d55641(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97516ce15a342820b419d824b5b5b25dde42e2aa021ef585b72315ed3ebcc8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a7b9f64d585cbfeb9c1e49644a7a63c5427013e59a19931987cca92a6c8bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__586cd2f75dc4016b95cfcc26b096cd0af512df88787268810294b29f50dfd9fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38a68ba5820cecc530c8441c071af29cd8356c68c12ae86e4c57227ef39f1530(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377b1b89c2f72acb0197a87e4d3bf40f8c31ed833bd2f0148083219129fa76cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4d1bff03de2814b5b3b44bef162d1e67264571143c9895043a3ea84378c922(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8248c610ec65d53cca61d1add17a6c83d59144cac9c86c8383dda4c20003d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c65916750d987ea4f56d203697e5ed5f468991ca0f39501ce62791161607187(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ce7abf569057bcd2164c1401cab38aade9cfc63793c77ec2fb174027ad9903(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__437c03be55facee004c35bc1be8eb80424a0d6334bb85e83d46e449ad7cc7fca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa90b1056f3a04e4671955d8dd1edeb1cbabd4af7247d24fc56797c5a0e7a7b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df93e71961e9340705038c685a863eadf7fcc8d907fa90e2921da5120813a33(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0ba366900ccfb2b98b1589721b784dbef224a64c292f966af00b9607636a0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea636facdb5b9e0b30ccb11186a943bbc4b4dab5660c233cfd88883bd99e4745(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66df67b0fbb2c9ccf35f2f4f4155831d9963b895a914c942dca8615a7233608(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b12ecec24e0f07db79afdee1b52fc57292df77190caf3e19d2cf00778a18b92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f50cd51cd5a37fb6625ec1c26b05646bd2c39005ee1d94e5ec1ec7c5a85ae7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e51bfa3caf9b148534cc106ec4b07c99c5834527cf11fcb5b59e400a22f29e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50a092576849d75b1879063f625146355100be4316d56b82478763f32974933(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f14b144aec0f393369b17068d73643505cf948f613973a1732eef1ade2125ed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280667437d298e05eb4825cbbae64bf572baee3a9708d66f496d444c6085afce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8ca44ebdf06b22477809d1e552b9a447ce1ec4626851fe7e8c61412e6c67c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d694a9b674331e8ca2c10978861591632314c51333c81f8ec4ff67384cbba72(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c413055e19dc61ab739af9efe0a2b5268c6d83d59882c1febd22f86e6ed09e40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dda2e3f4b249918f2ba0454a335163811a09b5a8218ab81c9fef22299b93138(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4029c9f9073e59cf548ff5d3f748a20c0e6dd083b2c50dfe5cc28a08ff9373e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5c25c64d34a65a5f4e41d0e128a852e13e373be743fb357debf517fbc2b537(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e964a7d9b75b6feebc236efa96931c4da16fbf64b7d876c422dd9a4ce6f9d611(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12374394a8de8e1c58817789510faf703956b5a98c787bf1a999e5dd6368c975(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dcab603c20eb03afee3250f4db58fb58bad3743a8763ea14d21737f5103cdb6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4df65c988ee2060c02bbb1e70792c59e8a53126854f039fee578ef9a2d230a6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8550b4a17b146e3c3e7a57645cd4f7e4e34257ba8249697ccad601992f2eeb8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b05f374e86374162b08e589618404ded74821b90fc56c9a44e05c5925c00e8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b243f5a2f2ff0d00467f54b1ebb00e88274d29fbbd5aaf738ddb800e1e6328e2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1295d2bc87cbc21154cd41f470ad1eb36c18db6638fca819ce6fc47151cda82c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cf8366c25ffe123ef047ab5933376865d52d4c9a6f608e7318b3e447bbc1c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4f9e7648e349b8787f8e49c53ad453e9a81935191c824a5a917e795b5d31d6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08dca83ec295f8dec28f2841f48dfbe54706378807057be1de49c834da97b1a2(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc81c254001bdfd439f0351302d837352bdb645679c41e0b6c4cce5ea3ba601(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e7e3858fbb837afca49a46d8dbd3b8d83f290ccc14e65d49d49c1dfd7e0bae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88fd1971723d2b230c7a07fa6d371b48f31e3a27f0bc7843f34b5c6d9c330d8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0191c096f38b30edcc38262ac79f04847ea360236ce18aa35c1481e35fbdb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec69bafaace5260a2337cd6a8c57eeacd3b22ce51d4bad31f8e96fbfc71ff41e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2cac68c7b06ac8d882475eacd66a1c99afdf53a3daacd91abf5bd446af3693a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a9a3dd788c8b3955cadee232ce9ef5e9b4db9fea143659fb29404434f7bacd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50826adb042bd39c29d41cd6143bee6526ffeae462271ddb30af376124e55be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c78422db57392440bf1254955e0ab7dab0790c408f7da73986fee96630883ddf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4618e28eb84a20ff81f3dde9f1dbe6ef4d4391141cbb773df86569c9e68f4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e39094e14544db4b879cf0df22dad1e7041796c0d4c403fee073cb45bd2f0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109bdc10caec0b039deddb97dfd793886e007bd4cc70cfbcf3aea86737980396(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102d4c921b5f2866fc228bdb78ee7fe6d3bcdeb4d18e6de447345ac27fb56b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84112f0cbb3df8b3bec12eeb7633f9ad4c399d36858c08cdc5694a332f24ff89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7a52a3efd1e03e35d72bb3f08d9882caf3fa057b58b7c23e945b009b83c2b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3efd462b01575d24fbc49ec9053b46d4fc2b08c8e3eec08970eeed617a6e8474(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969ac0f427043a607c96de8c9f83d76e65d5bbef078f05be96175af74e0073c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12107750c43a876978e11c84ddb4957938321774b63ce0c1375f71ab7f0af10c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590066f16b9d916513f2f04f23d7628b4a2744b9e171a4ccfc4d2d8be3d4305d(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c217c3ebd2db97c90964a3cec13297739bc5f21ad3e45ece274af6865c8ce410(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81654c112c8dc83049cf58fada8ddf61073e408eb207cebbb5a419324c78021c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e373f6ee28acbc42a4fcf732c8580ca0d55f8de72d8ab71a2338776ac8e1670c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd637ac77a6a7fcd5da7394690ad6e466ea5ad7572df4c1071585205a29621c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c63d8c280f4368341c579d1af1c0444e6d75805cd8e547d335d2693cf90090(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7de6c439864407f1994c99f1e85061ca1f6599cd5ac57baa27d6f943ae674c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d892407c90a9cfc2ca0f1e75b6226f1ee52f5d379fc37fd5ee32569204cbbaab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe41602e8252fc645675ea6d26c01e490ffbd01bb97b4a615b8c0373b79f5ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb287d4ab41b488f6f04db977e27c0b3db0c53b1e88e6682a3d4fe8680bbe61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbe2c6af50245d811798e63475ccb83e88fecd93ff564bab75ab278ce455d05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1235f8622811aa3b6f07b333ffb0c78157e6596cb17c09d9fd255f0f524245e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406dac3b8af8e7d4ca9b2a1e17f963dca325e4a957da59d1dfd3746fa6fdb0c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f3d31ab90f4e8c46ef57af8c6191c385b339a480fade9f6f8819dea66038fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c727dad628deaa261fb74fe5700c7939a12a4c248453e74cb68ce5c51283dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d3a4bd52118d3046ac44a8f2ed9f27e346f5f8c3cbdde1260cf07b811810e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6a67d635ef909582130979bdd15f7991f6d831cf36657d1c380880a6828c89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75f0708352211a93a2e9f04ace9017f8fe3e466e5a65a08fc94e467294840297(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc1fe99dc01fb7311a2d5331d61a0be407d168b4cdbcb2d378fc7595cf0a8fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d738ac7397349dd87d105061c7276c9d1d8cc42f5c6c7780b83bfa65b63d5a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783be84e35f3eb1095989076ebfbc71bcbac44095818e2eb47e784e16583da97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd6072bb9365cd75525f2773663dfacb9a7c250e1c74419c422d3996635510fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6389a2fd16f1f4f7ca60e3fc4da163ec0797f34211d2d3ef2d83fb6319a2f491(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1813c1f96b3b15f0a9637b82de2bc335cb602a0e4b36cb8f0322c71ef098996e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f5bb5402d6642e4f7147269f2c91143a37e7450e8f0dd41cf00ac4de5d9309(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a6a6dde6ffdc743e8dd4051b2d1a67536e8d808cebafcd2ff78103e2abdf4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5820406da304c5cc96d4479249dd0a247e3435acab3cf86e665707d5862df6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87499fe432478e986045f06d4f8fa923081c954b0f339606982b36f262cbd82b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06b8701024217ccd781adb199eccbbcff36763f53fe9b0e3f225536c7e4cc3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c87a8cf78b5a5e2a9865ec2eecb6a384b285009b927fe4e241a4bc4bf27e37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a7e0475e874c0172aafdd605930452a35bdcdc372aa10820e3a44e78cb281e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d3acdad82441e19b2a78e8e779e18a1e07fa73997373f62eacc8ff573812b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95fa6cbe6d3874f1f9acf1ddfa1535ac6ccfa0edb5e62c2083965ceb43114717(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61b7cb9a2f5b6f903795e2e2795bced15d868bdb826f0dbe4f2238a37257fe6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ce66917d5d823d8296c036ff91a2abe0983901f99267ec1cd05abb85b857fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d93a4f7801d67e453c99b7c0ff4b77780dfb4c7b5e9361cb43673e89fee9a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af80ae5cd1b02347b9e7e7003384ad7ec1d378f969e38eac76fcf8a76deef1a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a7d441f786a8697faa692815426bbde6c8f5185e1fc7a6034ea4f5fe2808ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e79054d95b97fa8af5be802a4744e1ed41a0bf316301cc1819c84634f4be3a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a118acda5bacb649d63416f301f55f1ac76a676cfab75ff78dca55ce9f8d1bf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265bd80a8e84a42ba1782c7994416e19f7a12786953c2cdda3369b417b3c3aa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93acc9d0e14bad4b0bf5eacfd1142829ce58dd3651caaf9ceb83d9f2f4f6ffdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516acc8d359c91fdb7f4a25602626748819fa19ef6a02f3cf9ed8114a0cf35aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f9eb3ebc2f664979fb03995c408441b48d5344025e09bb0870f12d7da667b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572bc128d40ea134bacf0924b44ad8b2ccbb14852d4157825ce58d29fd195989(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe70d00218be8433b1ccd24a6791253bb22a46d9bfefdd1d1c0882dbe8048d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__205c24cad888c1987c607d1c497b60697eab9e096a53f3ff1120778a2e5b4655(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed8acbf96a3140ccd5fb8eb9baafd2b0c8cbfa91ceb7d50f3e531c222869df9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb5838a1ced82d558a337f37fd4b6517a406587d8b6bf3e0529f098c80b0022(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc20a6413efa434d412c1974647c4c008122f812b96a9b3801ced4ccd869f096(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5961649cf6f73aaa8c6adc7aa2ac9f04355ff93a1528d9e22e845df21d9d25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31de38d6b44cd31c3b9c2159534ca164f54308d636258d11a3a042c79887fa9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3b6c3166351df24eecb67806a81b1fe87fb48254e0b55d5310347ecb7ae0e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b81bd91eb0383762a4e983c09f48a0d154cb20609359c0d6fcac7076181317(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8bbc52e88ca72e2be1bfc5608391e6494c76f1bbf8a0b524dcd2040d022ecd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620339f8b35b346d4b9bbc0dd1fa36f2ac342619166059ed0b756650ce0a6189(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e03d2ca7993d95e4a0c396728c4e794af90a1bebf40156de3e4c9be7daabb25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c7b4aede4303467ef6dfb0e9d3ef556454b6b86ab990a4ecac2dca4e8a40b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e353a7968701844e695d3610e71c5582e80c17f7bd7f95cd611f31bf38d965c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c54112b4414996727a3f72ce2b24e8181157646cf592ca8004ad59f3d52a23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f560f2c93b43181ad4800eaa832534e8a5a2860eb92b6b3840c86bd5927f589e(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9900163d9091f6a69e5db2a5d694b138a6e7b5eb1c1b46f32d5d60a503a485(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d368d1206c8e089ee7d8adfc70c7ecd3ef9c0000383fe7879c0d46da2df471(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa7e8b4abd1b2bc5790eec2aac369f4064e9c01acac43c234d65265105d1a69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0453757969b1429a1b49e7195fd9fba2d52d3eff0919a58743cb25b60ac9da17(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e0e958bb3b45806beefd5e76e1df6ad36aef698bb6f0f50fc935c596d4266c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e46cb3b48fa190be4a5f1c41022acd6f58a627e0ea2dd5128a3976b7b6da87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4bc1e036c0a58149024ee56e34521830c2492d31fd868404cf6e3ef706248c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9025da19b8e92944717ae674a3ed8f616d8df4c0c4052b21638d7423a3ff12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e47283a53107ff5aad466ae8d201dd7d060469f3b8ff5a782b7b81d4ad098ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c2ca0abab62c926f9fdd2723f3d62a02a7cdc2cdd21be6fda71873c0094cf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d954c82b923312974e5b9c650a06b1f378128d2eb019bd6e169ee06e2f804c38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995132cfc63ce12afd6cccf1940bacc5a4b1866d50e4a02a750dbf55e1297a65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4978e9075d059443c55cb27378c8c3e688ba4c1c464b36fe79b8405990ca3ab(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7d6f44a42f7da1f4da9f09e2064dc1767c36a00b3b53f87739d8e127f1b648(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34574c829436dd0825f15300cfa7327503e3477bd935b3dabf17276b26f2bd6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1888c78f9965dd8e0d5bd1189a3281bb5bced849004961ac1a6811280e1b3021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9f7ae796586ad9a0e49c0071c5e323c065b9861997a22217e291fda1b44762(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48849f916ca828593a8299811d969310aeb4fc29d9a3fe8a7fa74dbdeead2ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c739b037c801a0c517a6586eaf5d1b697a9f560c499e68aeb38f74a4004c0783(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57d951d7e0db50c52de7702b77bae1dca1991ed97f9a97b1d129b1a081b83d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbec60af68ac435a56147855ebf7881bfaf667dc5b97f3970cf94d9351f6e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ceca01adb261b59c46eacb344db9f3718e038588e0e4f2351ed3e699cd30524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491fb46c14187fa8d3aee84c4c386e57a223f16f4de09718c34e025e0147b155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71b441c842e2890086e750107a7661bd2d48591e52a7bf0d95827b213a3bca9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03093e920f982c771941188711f76540a2e9704b0b97a59017c919b85b21ce53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17a919a592a91973849c36fe9429cbf4f2e58b0910fc74da2ab66e475384da5(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225900d0b3fa6d6c743657058778d62efa50f3edb479763d558aaaa579b3055b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc91714f52155d6a609a08f9428a2bc44c4df0f18b72eb8d03b7b5e9daaf2f7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15be2f5594d47e9de8bccc86bebe30c83df42661f3f0c0ab61c686ddb59065da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278b46d9250c8c20ab13e50b97312d6541ec1f14edab6c76da049c945da67a22(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1de510565c803e8d2dfdf4e8e1b364ea7d52cc56fef89a4bb0c42e0c28adca1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72544d7365dd2ecea6155b67279d08b230f0b6baebdeb71802aeab8dceac7e74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59356952bcfc6a76f502ec7dcb629afd8be283036e8a449cab8fc272a8c3e956(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2313e0e745ab3b5fb223b6a968e65ab57af1fa62687eff2bf884338c7f0dced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9774a5bfd9148990028db2a5f049117660c245e38a62c3465846f013ca448488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd2fe85ba56972522e64aceb4c3fef94b88a76ddbbe94ae8a36157294fc8631(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca4f6247375d6301ce99f6450f5e069a5323da8a3380cf0b71b835c503a44f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd281c0f7d4695db44044ef36dba39d0e16c34a2de2ffe5923b6659a78c787ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13e88e8ac5a4a06145d9f070f599a27da01ea7c63c60319f9983ac108f96185(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123d720cdf697d888c47b1e6891da4f897701de5e1c838236dc38a089d8be087(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1668fbab407ef38752b0a7573629a8a27e497827681787cff0339697302166(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa4cc61e6c76685d5ef8440443058ca0aca04fa4b5091b23d2104f2c6f5886a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2dac529c1dbc0fdfdb45a17b98094df3b99a81504fba810218b5ef514e0dd56(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95c1623ab4ade697638d62fe4585e517659ed24e07e67a5bc0084ee890052bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb5408437439e8182f7d7a3950ffef722cafd8c8e462c4249b32f41b4e57623(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aebf49b4785ce6bf491550ba90605596939db55ae643b97d50b2619fc3c1ff9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b0759649febd3ba4ec589efc4cab8c92d08532ef12f784a29d72058e4644a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56ea4c20c7452a6cfb98f087dafb22eb2a67d22a6bbc3370f5d10a0a58958fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f617147efb11d4f2bff1c152af3e6f977552a561d99559d2014eae5c5d380211(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c64aa4e471a41457265504c3cb505cfc81565b75b5b3aa94e24edeeaa4c89c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8744e6a58d720d0552dfdf5c166c54fcaabd67391cebe911858c8357a737d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666cb62d72dbe46c198acdf6d3f9d479093751c428c2143c052be5d1922450cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbf82d8660a49442ce5225178d1903e7d6545fea5eec2d49aee7e2c73fc301f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0620949ce3a0d4aa2623077d691763523371c7d684f5cfc00cc5f4acddc390fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74cc305e371148f606a8a9ac1c6178d83b66a54b8328dd95dfa2afafe1017162(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1579b6d1af0a2ae4adcd304c4678b0dc127002e68a221af48a72ec9795e8ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e84f8eabd472d126e12a3d161c4185cbe7c514c749f095a36508f9e688de1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67138e9e10f5afa60078e28639b250c0073f65d0d8f2c6f2fc91c1f5ca49885b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85328930cce8695d3ddb801bc14d952cfade4a7445c112a02857dd3d415fc324(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9321040fb6ced1698a9f8e5451fd082294d3e6c8c74bd69d11b63c10f2ba6fcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a16e67ff1d4ba4be9e658f8b7b9246ddd62531d9f1bc749a3c106d43a9f604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278c35d65945948a89eb8268a131077f0aa99360e1ad8788a3486e605cb11fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55646112dcae1aafe2f03b5d4f56d3e378f9a9d3de5d043efa1c6d33cdffbd6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c040e956b5468b9ef9f1e6d29aaf612db87ea1eafc48eb5f6954cae011a1b348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7542cd2ccb20e2da9ca55ca20b5498a5845c06860c8cc0d7c1c5d75c2012f3fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a2cfeb35de82b60af1d02b170657ca53cca2c7ca9f9c491089c8453ba07bd7(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b18f977a735db5716769ed758549a23c433d26f2e6beeb9ee86a0a016f59b9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3c356d026bd8ea533ea167740614fa00a603b78b4f23de43934ea2f3410a9f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3581aac4381a3d1b9d508509504b23ffa287553e067af335b565aac1742d09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225789bc1635644d24d2840bc0e3fd3a77c0c5eb166dd7bdff98b27700673205(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ec7e296fd5518a651a43cb8615fda484f7109d4a2219f148deec1739fd8d29(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc6dd74f9a86c7dab59bf966fce1a90c18909959154e31dadb5afa802cb7ff4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9ac061ea061943014408f6c2f53a952d515e8c29c92cb6af2bd0a3d451b4ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da358f01840dfdda09e516f4c7279eed2783928d2ba1b4c0e88b8779a6e9224f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046eab22872888373b9f0d6a82bd5e00ffbfa08d8d9130c41424757d036634f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52111f78df0acf398845dc033e660f03364672b63948e8249cbddba872e515a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5edf14dd1d0910864f1daae33ceb11892a6de1c737e05736a3bb4f44ff39c68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e438d840ece9a58415867785973ec591d3f67582fc540b6c4ff5a95156990d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b166e748393bddfbd76a3b7fb4b1d26053395bf8a93bef9efbd26a9152a2b6a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e470c3ca31de100e2cf1389f7b2f793c61d456bae031c153c3c48caf30ebc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a443b381898bec9cb1a776bfee4144e058e33d0aeecad500fd63e79c3f20753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0256d79acb4f612a8da0fca96610499cd2a59c51ef8435414eb8ffb53d886a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aadc2f5097125a6d2921c5d0f996ae201673af22c19376015df5a375b3673f6(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc309ce90cd4d617bf1e94da25d8a2b9b1183de5c9ef3e3a5d4004cb74f9d6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f6b1454daedc07c7a8c307869e3a5de24bb6032f786c0666e0280e612bee4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa8648618e33032d02b2b910d5de7219bdc092a01b60e859ef080ea335c5973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765ac6551bd29a09f55beb82c31573eb06a297b459472e37e6bd580df86d3ab7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b810db8bdd8cecd5548d56ffbeb1990d8e659d40e753ef94651e414a294a7fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c56d0bf87c841a69c0f0506d1d2e47c039ca53f3d331ed3fa538902f90b9a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6622e28da6994cb53117cde77c99d6b5ea7d9c255d77acf6b6ac59d79da3e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba696a54dd8a82102aa913ae2886f597da98e44fe73c545dc7afccf91b9d8a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a737fe6dab202b42f8734c1a0a6c1df5864a889742392f334680a8c044f96d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf203e8397caebd3d9b9219709da9c6971670ba7725f520b8d51c6019ce0f11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a87be3d926c8ba0a058f5f8fd49bc1a9bbfc7fc46ae69251e0c34364f5ac47(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f6d1159d38e820ab81bbc73077866b3c013e9b1fdc60071fc9c7de3aceaf29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3349ee404f6791ff202956979283e24472a5bdfc44d31ad18a7311ac24ba722(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319bff8e09799d582a28fbb666ba358882a009226dcc2b83fdb393cc02b03e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac539df1fd8388675d0631e57fca17db84a6fcb2ae11464a3e5713d29038b00a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d31f9ccfbb1cf0e406f6464265d061106bafe9159b8a45dcadcb1a6ee25901(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38360b1b7441b126c6907bbfbaf54affe44f1b2eee886c2f2c5bff280dec8fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d71af0d6ac37838a476ec1da1cb2f9327dbcaf2d3f5e7dbc3c3888a184df82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6aaba06c4ed1bcc6a1838d8f2a291308301ab8a3fb4b205b2f02616ef544b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e1bc6cf706ea44b8d924dde0538a7466db0dc6d921d74abb389054ec82e84b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba11b66adab5f6f5412d5d797805c68ef806267995d57ebc6485dc116b02f8ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c808609c7e27e887f8ee325b83238a1060f15380b2db541267f8fa2189cc5f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7821b80d2a719d890d81d748af6a3f5ecc4972081312fa30e5e362518fe6ffbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba34c466dd97f868869243379fa426b79aa653475dd0d9e66dfe4ce9df98697d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e6193b5002e1de2404a6d5f9d70b22924f2a97b525b631ccc6360d2aa0e0e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d403b4bf8465b37e7d4c55390b339d2a9241d2e4196d206febfaa82753ac042(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f3248b83931e6bae1ad362c4ca76b90ea0ba210f63fba30ad29608a089daa0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131f617e10b13c1871da6e5f725c170671148202c141c2bd13d2d31696cdbb1a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3fc52baa64c3c6bd3c548f74d379650091825e6f045daad1ab9b1df2f7e966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b9fe7d5055eb8167328187aefde8803bf38c3f9c012fbf4f77fa422483295a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493b0b3ef149ea8c09be8e1481726b07cf42d24d122a6b3604f14712b081f26c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87fdb17ab645d1707dc1a968dea123cdad275803ce4e108390f5fea0c8e665c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d26515059a4de50ad745699a9ebac84390275db2493fe57e46db150f5e5605(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026657d89745afe0f3ca5d324476fb72e6b3f3bf3f89f277e620ffc3995c8682(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d02908a5e8159962a443f3610033079a9a13286dc2befc003877f254734a59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f2dedca00ceb5b234b9ff04deaf7d6e69780a42a2384dd8eb4a304593ad974(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f90a096cf461e9c5478c5da9c89b9db7317d9afd159e00bc52e3b3af123729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67833f106cb0d613e9b895d89edef8262260712c8bfa412c5e461db7cf52c8f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170864e9657802c5c35a53e90bfe850c74ec93b880eed95a7461b3e032c56623(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469ebfae364d17f70f46e0bc4e204b1e83135ad477cfa3082b75c1bbce82d8e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a618d7e8272268d506d685d5fbec723c3fc7229d47cbd0ef8311e987b80ea73(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d5d71a8754a3b85c4489730da4c47eb05f5c3d7f1c27d27eef09db97b4df86(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e7283381e862091e55d51629c6fed874f1dc2266b212c325cbca8369094e49(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f80ecf11f4aea282115fc71cd8c7a329d2b9d45e6e8a3162395a2d8ed9fe841(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cdaad8755b60c38c7efba3e5d30c300859d3306fae9672dd63228c0cccd852c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b0677f36d8f09304b81a0e6c9c4a92d706c950febbb3c44b66c0c591e96b1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546edc4e2a84b7ed34d631923093e88532426dc5b605ecbbb8b84131bf0caf46(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbe8dd96b9ed6d760083e9660bb99014b7d9f2716321985124b271198434fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d840611b50cbc231fc85b088ee4d0341e421f1e18d06b00854a712da5c95a0cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df66bfbcfda149fe4ba965232af0455e89e0689d521116d088dd092b7341e791(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8158d3cbd9b970bd2a0e69e97d44a11becba060a92e0b862488e08a67f134b0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32f0cc2242c4b433461bc6917a94256f84364997315ecce289e631a234fa8da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5da5d742694f3bfe02291c0190208f51e2c72bfd86ca2558ebf5ef6cd83136(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07765fc1cbad5c41c5c7c01e945455a61eb155e45716bc1ea742280579dfdee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384da401d7e75fac48a8eacb0b0c9094611cedbef733aace1e1026a7bb5ac9e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0bff60474012731bd2bd11c2196822a851cab3c051892298693bbfdae13aec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8237d1aaa55464c0d75e63c920ed301cd66835510786b48172a24adb4f5f2619(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312919ff52b5a851e0007be704a56ae188f036013a1f74c9890bf884e673bfae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01cda44ca23bb699141c1dfece3535bbd4418a7b07d56ef7274213082a29f9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7947e070c977d833b34edac6ae5b95bb2aa6acab0e3c7aa3d3115be0442bb1(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c4af3b76d6d65d525a0e1506d24e28d0c62078ab580ed096c84780beb281944(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d3533095442bfdce86da4e012221292f283de082bc6d3e1d896e30b16b3cad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd9fa1f22f24438c0649a79baf9b217215e1a4d222d282db0405c39d90bf462(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a0391a8aea9c03e29fc9c7839dae01f62fc9c67cfb66202d983bf2b362da6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98489218175f43de879d2d50e43382554e64057215283e1023da749017256e4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30f28216e293db26011376877307755939723a44a6b84af22e62fc77663e186(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc753dd5a1ef8c33a95bd0e290c5977029c8d6610e505af5dfc8319581ab233(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a4adf69613e347747a7f2ab8f20cc4ae2a55cab0cd1c7baefea33e3fe93ae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34494fd12bc8f874f257e4dbb7995fef1dcf37b076604e64d48f539f337ac439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465d924c150182ba41b1bfdcf9a04f86282835e90b60f8405b80e3af479c7776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8e9fd246c79e3b6308f7468193930a3b15e1a82952dde9a984c617dd6cd731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26b4d67ef64547c0e65e64eb51376632b681e2a74b291ad4b3f80c36e68870c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca72451a4086f81611386cf18b41939ffd530a366f075f81f607e5f25c029e00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1e9ba8212f47d5d70238ef3460aac9d8b77080f8d4cc11f549167b4c56e27f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef47182de643d47f266d5803eca202fce080a61df7e2957f4d41948c231b345a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436a4526efbfbbb13a3d77f077eb4a99e21bdaa7cbc98ae2dc749279785870b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91782fcfbb6a5390b196e0d549d570ce84332f109cbd9508f2b272c0326b8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077f26cca7bcd5e58616486ee041c182f62b721c070484611490eb70704bf2ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5abc47ea946ce09e7f3e265f9cb8a350ff75f0390c551f5a267abc7fb2929c0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27672f3000c4c2f631c159dbafbde7a4d129936205c343b5f1487f6ea1623673(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a870fdf67c15f801a8f62cbcef6a24670813eb9d5b513c6731e0206357e057ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453756c6abda0a8a508e711cbf3819fdb491a9b5c27855c2c78bcf5b7d814881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e9c177c5f1fc51c05b13f0b20f54ae12befd75dbaf5ffd4dd84d5ef14a7805(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed0fec5cf224600ff1edd1ff17731a9bdcaa5c5c95af4f375777e88f4d7a2fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3a2af9e33d1f7ae9638bb92170743a413f6d3d828c095899d7965d7e2e6d38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da38eccdff8618e1ee48f1f6ca554502923be8e9f763c20fb1f19aa99717c372(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55bbbd1a29cddc074a4ce7ece24bd53cd9c58b2872343ca189653e511db800cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91fb8acfa13ac02e81dc8dc7edd330590032448bcadd7a2a3de73c339bb8067f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f862e6b0648c7ff23bbc0ba8d907f4e864a2a7758d3c429e4bc10d215f19be4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed4abe8f2e3cd17acbf0a3e7dc2a3089c1f246fb4f2974e8ff32d5c9dd8110e(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa97886f8f466f18eb34e2d9759a0dbd98d20e11cd02968f2f449bf3a9c389d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c10649fae8f23962da35d7ac7f482b4b75f2388bd02058df6e1da2284cca84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d288101fad12492cf804acba0730cac26a16609a9a31778c275ef9696c75dab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dfde29b176a911699f54cc03868c14ba9db7af0d90c9e968168c9b1e95a6228(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b52705c048475c8f3cec6562f720fc214831f4dd13ba1d8993697550a9b6ed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf364387001257d4242d72cb51b24164ca6e100180fe2586c9f13bf05b12c8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97c7b2b582ecc3388be236e9b1dde0f38e901dfc2dff21a1f52c11dc00ca156(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108c3b5d4f8387b3588f927033485567c1d1b8d927b66f0936beef11134515af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a46f5c1f17ea6f269a57ab9b036be0d313293bd4a9f1c81ca574f938c76b1b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86541674be93b0e0ab39d5a858247fd6603a98f9a21c485a0320dea350844c4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19c2e2a3cee02bd57ab95ee5bcdadb2ecadd9019374eb48c0b3a0a878af12e17(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca28e6946db9ada1133dfdc35e1d45e286d24922f46615809a1dc502c29e83a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333bed6d19577f76a8cf558d1f7f3b81f53f9623197f9bd94b791970aec2a1e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcac7bbc87cfbaa0adc30d446ccd5e26a453093866e99ad5beb89eccc96fc351(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d386c1392206bf1d3919096b0838eb3e624a314b75316db4861a36de28fb12(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6a585b4a46f7ce7080ee33e538bb43d2a94ec600a79dca587ef8b7cb59583a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c790d4a43d180d721ebb3d2aaee3a61f4c40e17eea764f75cf592d40936f1c1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d18b5d2da3d82abe3b2065503a4e17bb3bfa89ef162e70ba2dcd9219b6f1ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0e716d740e57418d905c4c50c768a73660950d19a98e1068a544ae81dde108(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc85c968915bd1ae87a9a03f927ccf95405baca77efb4ebc4f25bcc8c5333e99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10188f6283f909e2764c9707b7fb6b142f009d7d6b20e05fe69cb6cfa29c19c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d38b4025395608f06c79adfa71c56ef985718bcf4b512bd9725c6614321626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae523faa46314c161976431cea4016d9975732dab53f5c94c98d50be2cbfb43c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf160b5667951b5d80d4efc4bd2cd3035707e5931341b424d7ed2f48edbd176(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8362aaa08a4c34d22a85608e600f9856a19efb74bbd14774f80f8446a4e1b650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc3c5ffd87d7f2039800a28be35b8b2af200a8b4d7d6b4464403bb670a1950f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dff29f7ea3f8b99aba62c7e4f8b85f3950d69653a16a7a411871ab053a9c233b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0eab05384e0f4e1c86b00a2c4b6e7094ed92f4c37fca0d13c5b136c0f9e2d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6baa1095b9e797546ce18627e2bf0971c5c3e992e364d194229be5e612643b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17d515108e86940304cb16abf813c68738d8472e62432f42bc008a037c93352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8decd74d4faa01dcc09c23a6acca9c7de2dcb00044a38adf4e73005254ee9c73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1ed7658d61f9beff5aab0652295aca887fdd800946ae2f456d3c3d34738fc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df3a370a932a1a3babc607e7b87153879077587312fcf4b9d619a8f0c5823a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5588cfe8cf6edd8855e5c2b921068ddfaf8da9eefe481bcdcafb246495573ae(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1fec1d5c31c8af06314838addf15e99c77fbc9b224ace7fc68d2e286d795525(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b05a162ce6da4bdcc07b511f52684aa804d07ded1cbfdd09b4c34ed304bd56(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af66073ed8923dfab322a7efaa78d8699adb760053efa58b3f544e862a1c7871(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12c7f14cff11aa830ab779ac8e3e9f6569e680c229699fa2863baa64af608e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cacd9b6b4c79b28e50eff7ecb8624c86f58784b37941397569e9b9b3b590f041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c722177b8f2411886ad4c7c121ed32b9d41219adc6d12d4e039aa27fc11496(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ce828ccbd0f69a61dc9c126edcbaf4b3c2826e42466bc7eef53292433c4edc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0fe7cf3e4aa2f2d15635ec71701569b473f625c11fdc16817752e56982289f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4496561792aaebce36057a0e397666c06a96aa452085f9a600c15bf8a6673202(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa7565531dc0ad25bb9e0c97a1232f2e821746b606d1b3f52336f5dc04fe496(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5781e908eb0d8efe37247c98544f8f477e0df6d66d4a85ecc385a11ce1fc66bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58adcdd42f42d1085fba778d942f622ca25003c9afd83fb7fbcb2762d0ff95f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33292aca4c181bb1ba15211d986972eb659661eb9dd5df7f5f7851ddd1889472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46ab66a585d24bdda1a5e017acd5daf99f44001784c28d6021bf5bb68da4824(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944ab18ecd8ee9310273259f2aa795ddaac5b805a4f2d384b3b3de1f5a6e6651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47852495dd1aa40435b8240f7f6cc9031b1943ad0d1f9f051bae4a7a0e459cec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd62d6be3576cc9b581fefcb84fef7947dda303fdc77312a3d2eca2dc2678104(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a49c22bb0734185fcf9edd2f0f49e63ae4b5b62fd739f76a178d7964755f22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e57b1380231f785d3dd0c8785105e03fd987100559132d9105e3e082b5220a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac059da2d3949a27a6c834747bdafd6f01642d9ed72a5c2dc33ddff55c0a0f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d485ad7250a1c73b47bb1b4664343b2f88fdd727825a43fe05888631193dce42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47262c077ba5c5710ab92ff34415ca0cf083c0d8f76e4d1a9d011c41018fc23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a19dd8633fb834c5604b810a36d52529d957fa952159cc3f605a3bd46bbbfb(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2d5177781cfa70d71873f37245e0dbf5dd492a03ab91fd70741e9f3e1efc3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087112c4dcb096432cebf90eb09198162ce788a5ca1a3007b7cdb2603b5effeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2812fbe1060f7c19d04cae0f05a3430228773fa115a89d9db166c89959ffe2b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa0bfdc65f89901e4d604a51fa5c735f054ad36d1f33f5b3ca4157b3380e2ce4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fbbbec218c5a26c08ebc9500f6af16ad726066138f5b8653d60b88cd7aaaac5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409312009d96be6872c1baa8e351591c05b3f8be13cb877dbd5ab22df879ef44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf22496a43ce47319b60de228fd2a52d3c5f2f33d7dc18c848d28af3dbd18332(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cbc3fbd202911b9a6a4431a533f792e8004b4ef4b4733158be13b7864da3de2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f275572d081a59b013410a998966a54ac16f61d101b550b602c337733d977f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cced54b842c56103d23f628fde2098da4c0c621d9c0b12accdab1d917edc418f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd86895f325a67bd26bd2e9f3b8910951dd819f4718384fdb78ec95b8c83959(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e193d70250e49c25713dfb381a9464b09c529e0777cb2c3ed39e289986d4542(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3332ca4194bc3012ba27bfc1d2e552225b5c65149f4a1b1dd4f1ce74926268c2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a6d885898404ff5bc644d74a0e4b1e9f7049314ab8a75d8e8ab1477a5b01ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddbb2a2b69ace4da54416e9d98f578174d2b0b0a5c1cbf35bad036dd9d77703(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d1894e13a5441f0b043ddb3d3c805484c1d70a3b370960b8fbbb528c28d06f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae294845ac4a6003e6c24aeb6e93e431a55fd169c64b34c033b71e8604ccb77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e53f3ee5afe839612dd327291dc7e57b521f3f6cb319789d06e543c27367adc(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28dad02503da87e0d13e97a97ec4ae5b0adc7ce8a50ed30753edeee854005fe4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9519ad9a18149dd3b8a901e7ce11d8c602b62d6cd965f04fe5b0dab8dcf4e8a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45b155e49e9a49368d6ddbcd41f44551935db4b0179a23cb7fafa63ccf7b1a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ead1b029e32876da1ea67ab6100b88f75d468b91362fe21a71e6c8e2398316a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2fdc7e1acfa43550df2f1c1cbf69b3e5b3c76c7024ca618a5a1271a03632731(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9a6e89b343ae7f662175e4ceae30873db93cfb47a1f965cb7beb25a44722eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f82db855c14deedde66a6372917a91e8447dec34f64cc08202183fa0f5350c76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2273c647608893177c662f3fd435c40ab47106d38b0f0764c14abe404235000c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d040a3010e6193323cce279b300b31017252865e4e2ee2faffbca24defd686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6225532ddc0edbe1f767ed3aa7a8e956da2cc1f35509bc762d21a6742df60d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a898a9b01f0f0606fcbee24b2546d837c3140477bdc6fad634de8d5043cac929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e725dfe4c6843133b549b175641309217bf0e6b507155b0bea4abba5bd5f402(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f052ffe931ca93fb33b43b2e19b61742e36e9364db232fc0cdfa5a6917aae4e(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891659b9ec4a1933fe64348daacaf89bf4dcff4ca05ada57f089ea08f4c1fa1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bc1ba860d4cafbcf319cb367ae5f7a1ccdd03492960f133af25d280baa225b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa6e3ae9c3efe93540de29ac504c2217c425af434e0ac6f6ea60c35faa87144e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a6db71f54250163222330aaf1671da8c6bd365b017fe25ad8085bffdcfdb6ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07dcd6606878ebaf608c6bee05984e312a616a44f20eb3cb1759b684799e20c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03dbc00ef0f0ff986d5b0bcc48e1d1c66aa58ad8853b19305f65900a9f6313d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2342e75392b403724ebc5a49a1a553d9c5a13c9f2f42beff94c410e9037d5e7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca375769d345d8b625eda1752a0ac46dc94c4fa932621427db20b6f41c73429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e0f1b9a70d584d5f8555827ee3249cc4c879b9af0409a62744a4c2f09cabd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__399c5bc1df3709638898ae0bbfb4ca8ea4babb4f6291c009b8eaf8fdc342279d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08202637a4c2a70578f63ffd43910a1395a2b9a5d80ac08e301b69790012f82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee8defc6cc3508894ad176146ca499ecc78eacb967d34f2d9a54013967c53aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bfea5cf1dddb59428ca304bf131098c66b5e35afa1064372f0548783a760d05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2375dbc1abcb294bccd7273cd811c591bc815bcc020839786235b087f7a13d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f68ea067729e1e3118590d95e69682f4c3587e72c6a1b0f2907e3f532c0c095(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620fbc06c855b4bc3976f79eabd7b724a9bc9026d502bdf4f7df6dc05a54ee73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed579c1a56a464488fd95ab212ea7b2ef32d72e8d3a97df45b43ed180732ad83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67bc3cabcee134be2cfe7507e0b8e147682adeaea0942427a2aba873f538ed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2ecabefd38d32a79f63e5cdf91dfb8319aa325067e2fc42c50bf42db48cd57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da30913bf32755c42216fbea39022f97da1abc42c407feb6427c335bb45e8aac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33b63a973bb7ffa315f86110b7f208fbb8540a2ee9343392d88ffb6423c1b35(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7341fd54b16741689431187d39a490a10ea861758b9ee02ae6b2fc39e5b373(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73dd3b5a16c53a9f4469a142bb95b1eab5528daf805a85e55a11861e88e09bb6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f259eccb19c846f9222ecf896c27b70eb848de7c74c0752d26767cc2379465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bcb88c5e4a2025112cadb91d76344ccc5a06bc2b09a7c6ed817d618ae29956f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a98ed73f45ae835a2d0d80a94ca99c97d59196503f849b7b7650b3a1863e26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb3323419a476d401c864b109067e03ad0523c57ff88f79f284374e61f50fee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc56696d7df3b570d87db5fb9319443034f04e31d047c090ea5d7e300eeccfa9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b733f5e8b1c5dc668bb2f879126501cbe1e10e4fc422b75f78688d6fbc332d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd42c815d47e2899fa478bf4e7ad508ba288e6017b97f25109f640105d37057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0210b29d47bf718c75c413862b4dfdd32d71615df2b1b835ced9b460551161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fd9af90077a903484ac80232bbaa62ec9368ea17a71998848dacef4f69627e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fd39f6dd8fd07dc74b085697dd1ae0335097d949a8ccb1e6ec08e1454b4b09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__308a8381dda264120b83112398c07a03804960c7579af9495e8df53ed73bf323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15dc4364de9c6f1cc6e53d04300b6778d0ac05b2de963aa6986813d8072d6b60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ab24d724081c7f5446f69117b401d92299d141ffd92ef747835a6aeee60681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04c6f10bc5fb42de9b75520dda962c525350b3da4dd9f92b523c18f2fa19723(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec5dbd8495704c75cb3ae20e19c67c6b6e74858bc92a75b2704b8fba87b789d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13854919271c2a5d2966f4d45ff18632d163879e0fbca93a502d01b738b31244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4db9cd27577db32e393876f99ac69add99dc6540f55072568513b06631d9f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde9c32d4f69682c9c2adae2e7d30f0349f1504635f00937d69ab7daf57a46e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454b4574746842474412cf6f44ec1ee3a74d6f80f482ed1989179f3ed1091388(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a0962109e83edd48fba6f6f1f5af323140ef0e8c7da9adcad1242472d6618de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd13dd244bbf81675e88d38e6c915867077a2223b36395f58d7318dcee3c5d9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5440d7e500a1b8da715d3c2b16bd19d92b4ff85f224485074c12d6e3bd5f04ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c04464fafd2a4729cd171e42d180ea7313753ced14f5e249fa29fa75de6f86e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b11a745c64cafcaaf802f1154585fa9221e23988d0a2dffc4f751bf266f46f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261ecbd169fdf27b49ceb725fb78dbf9e6cdf19f2fc672a49705ff8a5e33d440(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a098532ebd1862fce74c156057bbfa43d2c40fd3cfa9c571a48979e52b75e124(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f929a4280741c699eda38c467e648ee5849484375c7659a42b77db96573ee600(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b98bac1efd3032b491e9ee914c8ae9a0bbd7ab4c5e8008cf455d9506a0ce423(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcf567ec15feb3106ccd4f9d9bc24a0aafa8378d738f45a199abbec03eef602(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5557f6975cfd01e750127818ec9737ea3bbacace1deed288ce40ccd2d839a6fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c76afe0e34833e897850cfda135cccc56a8a9aa0def53e911c53d81c4ef2f67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dffa68a62ca30b010812330c6b4560aebcaf9004f64ffb76505a4bb8ef024739(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa97026f56d6bbae0b7206f822beee8cd142e60834469e9c05cb6b9a9c4c2c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52becfcd189edf7a2f9ad61f33c475f56541852ba4a01c37520f4668a763065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32aecac4ba726477154fe8b234f22d83d598f0123edc373fd8cd5380abd60a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f3b5cab457416869fb234e2d00b674c5758c046a42d39434acb0bb01a6429c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8467db88fd43e3d3daef2f7c941353d839f97cf2d800a4c670b6dc9dab60da9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0d5cac4c8c540374c61044a24fb0ee15d354e82422ce61b890835fd5ef21ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b598a6f21232d2d04b564291eea91effa2c270e0e19272b7830c7cdfbbff08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d5bf0afa1fbb0ddaed65b1cc0f7832ab7eeeb260de7738bad912ed38400405(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801485eccfeda105cfc3605b9d1d51efb7c327b0b5dbee941a55b6fbd6e8bacd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044c76690d89d162f4c2bccf7f5c6876e58dd7d586af8451bbe9265184134fb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__977cf8dc691943f43f2b06c6017b750c643af08b85da20653080ad3bc3aeffc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d832d3bd72acebc4d074f55e4c00a73f5c71c5ca246d9b3063a728bd348b4e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124f770e388cd8cae1ae399fe50a8ca02c09fd6e75907f630810d86c2409aab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d3687f7e2fd0dd637049973e79e45bbec44b7caba3bfcca2344aacf04e780b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d54220b8d786660cf529191663e2e2b773ff51fcd012475191c52e78c4e616(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ecd63d74dc3f765224892f896f2519c03a28f5a2fbd3a2b0b7661d9489a1c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be92343f7fc80278f642a735dec88d015026cc326da60de7d77c2622575da19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b79f8eded01cb6e7e80b194efee26b90ef341b82d5915419349c841efba6cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e38e4af8ba8c837061e7e35100ae336339357f97be17963f6d5184566d5e79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29253c40992dd49d3a6107a43524df647e3530d8c14068932878137e97b60ca1(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeba1854336fdd075ea283680f2e43263e720e120e339aa7fb6c9dff78b5da7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa07b3ad8a0644b2bed667656058ff464f86d8ef458dd4348ce8ff0a37e084f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd7346616d6c45e6fb0ffe7ca4636d992f9198b96f665089b61f74b1bc01b72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b2414c897c13fd3fcb614962f242fcd2a92b7d541f067af1d3798aa3396414(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4597bb482560abba344f9e1e42e3eecf316a266f621201353658ec223df84f0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70531646bbaec86233eb32c5693426cd76dcc41cc15deb0e66e076e33d02ef1e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dd29c9e3685363b729361187288659f82820549d1a054cb4bc4c542c5fe3d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be31b233e6ac40b8cc6bb7762eb47b8eed056a8423b0c1db857e2d07703402c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83988c336795d87f718617277a938ee7770eb19f95c3ecd98aa9aed952945c89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f67c6555bb1d7b7f537e9554537c6b04982bbfe9b9ef6ae49069a48d4b1d360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152903726bd98952cc763e9d8c430954294633bcadeb94164c3c42af4dee2617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76b044f73b2a37df8953bc4aa667982bab4add9ad76f757462d175be7d27b45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8378bfc79bcb2234e2d5d20cb6f8085a6efe3be14dd7bce32726a05a33da5c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6fb932994be91e6a81c45f03c7ef2d91b7aa48d37d9fd7069336d41473b71f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c252c0dc7feebfa4f402fd424aac435c1dfceff8edefd6748c673843253966(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273e5ed8e85d3f393c61bc9f4955f4c020aba22b2e4fec4f59ede7384125fefd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1869d3e44eca10913d61e2c55d303d19617139935d654928e5e30b9f79dac66(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c0ad2d21f95a497bfccc9b0d6878f1290bb42ef1eab6999b05def2c40d7708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f135f0e6a758f9a1852c5e66329313c3c141f8ddffd0b2268564294861d59306(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67349df44ddf650aebad418920c6f9f4168239190e4f87f840705d7f2466939c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d6b2431c173e7045b837b20dd87596ebc081f75754b6f757f38ea49d45dc3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4740b25628dc11bafcabf255ba168a2dd7fef9b6bc26c23d594f23054f873006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde143715459f22043b64820aec750972854c4745f25eca189b220d5be181049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18dec71137f6a38610666e102795f1f39a68f531f6245366347e0a5e199f0457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6170e2316334d2fbb48dcf11e1d69a17d42b2d5abee48cbd980feca73ce1c565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799ab3bf5f908b631ace3a64e13748a011361cbe8d7dd82aa0e2351ddc552946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce217a9efc2ef576a08e864f32d1ef4b342a0b0b3f19d2095433d1dd226eac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b15ba2a9ebc90d0802e471d3ab9815d02de137891f21ce2368ede4214dbf4ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055b2edee4b9c161006e392d80fa9c3714473b590c76acf98a7ebc294cbd82c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7261b2130090500691e681adf3f015039ef8f94d5f1809d53a951c1b3c8a2ffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e69dba40d950172d5b91d7da611eb70e5ffda7aff6f7dfbd08f8177a5f208e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e18a7108c3c03e78da4763db38ab8ca8206411caa9f1c69d7f041d361dad69(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f002ef32d4c4b824e53fecad42ba25954c66293e6407a3d120ee42ce9c6a5752(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9cc50cb28e6505d3b4483ccb739d8a6a1a8eb18312122e32c578874fea688f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f67f3dec23a48485119f284e3e220cac8d6b832f9c123fcf9b403cecd73fcbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b50cf223f6d70835c943f64b1ec9763ba919fdc4cc2c759e18a9420b3936b08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcf38f614467f28205b1b9c1dabfaad7ed48c2c0d85c620a0a6aa54d17cf430(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7e78bbc6e81001296c421e9d03ae5f26a92bdf40ae2de9ce811b78368bb103(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d5102228104f3e1cd567ff1b63d8565f0e3388d713f1d1ba88b3ba6a1e1739(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df2cdd37186dd50fbb31ad18c9ecdec3f12e2f07abbbfdec1ba64e1bdb280c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e273808a7748db027a1ad1ee8cded19d13755ee17d2fa9740f4a7a77515a79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0601ff5b185235f73bb11c5104e4eabee0ef2c289c8b68bc429ed65efee4101(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58499da248ae86e1a89bbb7380f193a8b3a49355c76f22e499b5935568134c0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1e1d2dc9c8e9eea61db8dd25f8cbc84a24d851048cc5a51b6ce39d43b2ad5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e91f8065724272d9a9abeaaba509f25ae5b602a2886a1f6a4633412cdef9c2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b620205b8cf37ff96696ced7243a9cebcc2e4320cebd26f311915b319009f77d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906c695117e5c52b5704af02bdfcc0c2e6099c90593e6f4008fcf825e21b60ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b57c9707dc34b4251e74526d53ede7bc53eedcdf289c506f2ee3a56a4e87aa9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6d9d631311f62585b59d78d553646f38ccc101ed665185489a890f7c54f17b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568bc9010cda8babde5befba0f73428b4fc0cc4fd775db635b2b14ce54d4bb70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60def31950561cf1aef12ca7986524c3f3867bcace7c904c33bdb42957568a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b1cafadb8f554d633728c9028f2bbda6cb9f4bf02d24c2a37f9bb4857c6dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93aa9728099fee2ae1270f818aa8043a864f3b7bf518bc2b0696e8aad9032612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430ff470e17858a9a81af1d2003f40de0d1660cf6be3c3615a8b48fb9e0c1750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6b0580f5bc36a41cddd5527255a6f94bcb319c751cb791e18349fa11d3d17db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43356567f185b949f54966c0056c5e6549d6fba6c1544537551cc590e2352b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8cfc7950cf3682bfe2cfaff4d07c8e6af1476c1b53de95eceff1cead3d5c24e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d2a5afa71881d47bf7f0b501da0ee9c84b478796d58a45b254b97a3e4af6174(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912ce36b1534981f17122445bdb9e2ad9b6509130f2e2bcc80303cb85ab54aa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e374c6684957e744732963e9da1c6ab6c68687780789e7a1e3a8ef092a34731a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cb7659dc045c2c420e8d0b325b5a878c351ddd2176128c4657e3300a895e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d11f8e2102a85eb2ba71e8d4ce445ffe0be55c310a5eb04f9dae75c1c29d014(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfd9dcae2c57d04d9c351369f9f5b06c5f00f026468992b68d24a5f41ba255be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cd13a3dc57df9959f59a87c15d4637d0dc15a45d952b9cd945ad7ac4b50be3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f479ee7e54f49634023ed8fd0c5e800068b8954c26a4fc4817319d250ca51b6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4caa08cc0a097914382f6a0ea07dd9fbd75a1d0057d2b0ca57c9546aeac32010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5d790544fc9bdcc2bc776a040d43a4e293f60355ba370a275b869f3bd3a63b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b6f2369efff415b7d9c14e3a48e064f4d4ea4ae3d6e3572becf9f7c9b0c66c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fbe051236551fe65c20ea2ee03f5b8985eb55827d151e117bef86712307a06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8ccc7d06497a6ae2b10dbd8f6c9665da94cc096df6c2e79f9ee92545eb5c19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dcaa36493f4a924e1ffaa8771bd19c896cdc8485ba5c346935330eb978efd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6fe2eb311e5f7dce718673b400ec22fc4198fa0acfd9cea3617b39f35dae09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece5c28956ec2fcafeae3079409d365303b85da096128040addcd7e74e0ad520(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b09193adbf68b6ab884e95ff879534e30a54c10936c99955ba5a3208622cb2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7def33ee1d55c1a6cf910ddfb9c8489d3973fe55584475334be3d19aff73d3c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0382b82c571d6e3cb82bc80c27a1a04d50d5fa6b9a006558b1d33e779ef40af6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04782993ec3f87278f4ce76addfa495984ca01f162859298397cc872c7dbd65b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c1aabf0850104d8a194ffd1f84aee779f1cf3aa76e7f3e4d0cde3a1a69f2bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3dbb26105e533e4133c95425728e50a086691f497cecf7664ac1bec1d10ba84(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849e1cf18ed0fb49873684423b6f51e902714b403625c87eb1a63f51fdeee213(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91483facb7f5cc3f4cbffcf6f60eb4ca9feb4fcddb19920bdd2daa7142e8bfa4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c388a14b5b3fbea3f2067185301b5654de11ebc5e4e3db54e9ae2a33538393d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d637f1a2f90beeedfd0d94f2c79cfc691271072c74ce3a4e9e3b0ac69718f5e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c00f904ba71c4594cc532e0866fb644773411805c12b64669671998a8439dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511c01ee0626deae08261b373485fef46cd936bee52b305662ad2f9e9a9d726f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8728e7d24a77f37118d94aa483127273869b69ad23b1078ed8f791a12ca80f05(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b3d4ef86d89423ab7251c9143eabf5001c5f54bbd7cd6931cd10f1c9b8e54b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b7b18500f3ca1daca1fb3232d2ac9db4686313d5b2fd9a101b00e75aab3339(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583da33fabe0793b6a6bb2343e90005f6f7b0fb0680961c67956193ddc985cb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__165306ed26e9795ca3066b8fa556767ed99069e8b9d5c8ff378727fc3293daff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc63524e2ac9db178bb6aff6e5c457ac1d8035cb0b69017d38c2b1899bc23c4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e84a14a0c22fd0ec020c6375998305ad42694a3f14dad00f80cdf7aac2d343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3208f24882396ee7ed9b5d9aa6161675ae31590b1f454cee2af109386d6415(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66cddcc170cd5d5b0c4e770af9b4976c9ec5726175d3e13a7448cfa7f1bab5c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8831a41984059ef81c2a405cc22bf81544d3b8457487bc0f158738bc4b49cf0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cbc665c30a0f117531814c954d3ff92fe04e328ea35dbac743fe632c1f6735(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df68d8123a96a3e5fd4864c93a83d071db376f53c869b083cc08fb9d94979da1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bb49db75a3b041c387a9ade2d972c481c4161e1a6a1f7f76d83092d614be8d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f96cf876ef1b06ec860cf3aa4997a16cdb1037120056892d30bb79a254c5391(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b80df736c1dbb318a64dcab29e0a03c2ed16339c2971f2870a4824b1331ff31(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ed1e82ce6faed0557ab2b0306935abe475f6cf65bd824b3ee295c1fb4a5dfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea25668102d390122e7791d74091243c456b1e920f3a3ec1ae6426de50d43d7f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaab604b73c0f0dcb50f072ccd28bef8baf876ec1516b180f90f50cb4795926d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba8ebf961f5d190926d13020f5ce28c5de74f16c50ef04ca9fb12d34a01e19b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce960e637584f14d48996abb37f10103a2ea319e6926f9aba1228159c45bef71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08efa36d4ed1b8dda8039f52e0a7c48e85d7812487bd468ae48cdbe4f0757717(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dca517abc6c36cab101e6a295487775a9b367569e710a27bc1e90def5759552(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc4c61d02e8dcf463d8c0ab3b6d94ecc1395162a6ff62d330e48d0524b3ec56(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d15ec7b53c2714aa3fa1859e3d9db29bed84d8a17d7d4e8a1791f8941676cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81e148f59cedaeeb584ccd50311e5293e67dfcf9b082cea4a9a1416647b9dafd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6172b1ab778f545deed578a699eff819c8ad9afac70f33a339fc364280153de8(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05398f0988d26fc4dbc9835604955377839593fc49f3540a78927abd3d7beddf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ba09293387edb8a2667380dfce01f8cd3832707d31c957d8d919bb38924d00(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a839a8449cf08e0a9cf10e9d596084addc30ac3a441aa10282f71c1683a693f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2f67d8a4277e24dbae2c2206482b750d0b260c0704cd525637fdbe65845d73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efaf84d9c30f19f47a014ac7556c44f1e9886369a204bee016b7f28d9b6b305(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc063b34b5db15996b32a5e4114d6680d15acd67c2a8d760543bafec9e095b9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948ce60f711663a10a7e8a8370290aad00cdd47cdc6bed0023a98231306cf059(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ea8ceca9fd521f645e7193724e18349b1d258dbf79c7d18c678358eeccc98d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccebd45b8ec745ec228b38a1761b9bfe5fe30ae49d586edefe7a271e7a01cf0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71f0293df2e8089ad394181706478165b69a048e3adbb91761b426cd074c332(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53e616c772a0f231c9724c394741bae8a61c1ab5a04a16931e9da32ced367f4(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af787441dad27a771506e366a90e70bb9c6415545ccb9211f8848f36ac3817bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9f0ebc25f27d44a816d07a3c9c5dec6c65d225b0c38f2b50a9bcf2e05573a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d810c65c63e623e3f78b177a1ec8cca390b8a3b9d332a4b28f554b0218e345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff471cbe3529ab940c57711d072b59e9e01b3b30c343eda926cf66a4747d7a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41ee1d73677381308120c6f4b85c166c70f4e3961632d45acf3039fcecda544(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e8fefcc84b1ba4d56e3f51ed17347889446ce3e77e2d64c8d781d5b8229912(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653c84ddf6f27698fa312b36e01c28c9aa7a38a9d771e1490e7036a35f0cb97d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83763497cd206e37348ad8420ec1e2999fce8405e2e98a0e7a06b9a4a03f9059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77aacbde2eeaa5b882c0102b9a17c56ee75ca528e86611862f944f1e1be42a2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e543539bd4c5537efdf8fdc61ab98a97b30b38fc927a81980ea3c288a450c16e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112894a0a3f3fe3dc6b8a181fe878bb1ebda3016fdfdc997350006440d3fdbb9(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10ef815bce28b8cd1cb59d9172e50d8fca6ba45c706f4e9057ddaf27dd60582(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d319837f541a8aed0856b2126c7b69292bd5da323e669d9df0e680d2a4a6848f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3be8e1078abcdc9f5a1725a5f62cef6655a59431cd35e2d740661ab27144982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7096dcb57865da0e3239cfe9f055c9770e9f15f657b6dc832cca9983f1e8ffc4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__447466217e4bc59b2ea4e29557dff82e641f75ef6cfb5c8a9069e3e1310534a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7908aa4380b9e28ef6629b1555958766c4eabed5f2e939e5b969e62a6428e3b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907a3284699cbe47dabf2c0a6655844d33bfcc69e43deb88942df52fc0fa08f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f29052d0a0a632f1bd1098a582d162b3582bb120815bfe709f8a81c5c97bee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d80041e91850b6f0c71e01cb67313b9c5e2e8a3336a9afdaec919b7cdb41060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5776746a8fec0a6fb834bf39d3760d5bec537019997f3646aa8d34da43151ae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db2beb33088ca29be0da3aaf6dccec8ac444ccec771573fd1abeec020997554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fd9d30d7d8e2856a94a0d4c04d648e507ecabebddd512c21f3e5e948a1646c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7347fa8863d5f224e0160abc90b0c13b8c35a736921de49d0cd593c366a2c8c8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c799196f17d6548ff17f1bb5fec338fcf550dc1b11c2d8e4616bd7911bc66591(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f7436a20179fd4274f7c42c27528ac79dc6745c029d6cfd0f368fb427f67a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b751600bd246b842e04d51199fb87adc27a560a64ffc40b403c10278873d9ff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444e973d30289ce47e61d103c3c1a667c4e8a5dfc3ebbc24a073db1bfb68d7e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2404f816bce698b86cfb841d6d56c170fc58247d72265c7ee17b97e6279edb3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec8b6cdcb19ad9111f06508dbed0dd830b13a6753b14210becd900f362b65eee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a50ef431a8acf24a3da258060d5ff430bb25f576b942937824a1886408db38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8eaf8bcbade5c5117072f39217aab0120bdd8afb6b5f9720a43182b43a632fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e04fcff391ed07d3fb2104c91cfda8876d170ffd5f41697d60a42204e2f1c3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bfd845fb15df89dc694e6bbbf92f130ae607c9761f18cef42446fbace517ed1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40e4ab22cf7c97eb76439fe306f90d9b01b0a279e486b611c090d59cf652dd5(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c57bd35a4236f6d0f020669118129544710c7a59d5b80c7e88ceaa8d5864ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99155c1ebfcad885ce9edeacf3483772834497c1a7571834f6f21df4cc09172b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa6eb7812f48a742b7e1913b36b2a98fca49b1c2af95a77b3f6dd2864f9b751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6c053f2a67f3adf2de247aeef08014a979371aa2622be280f645c1d5d4cefc5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc4fa97389e742f1556f56909f196f750ecd013a41a0313148c15391d4807ae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6e76c8fabccd6011ca9705cfa60ba305c6521bc5f7f1541b59ed950d177432(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fba455fc1c1dc47948199a5d36d872971cc48e4a1f8e1689024306a5aba5bd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f6ed3e7d8ab4558318d44cf8fdd3bef73b12b745e1f168fe552eacfbdfd3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3381cdd1fa7bac98d84ce32c4a754420e57452cda8c56e046e34f2da9c078cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9cbe1b79138ce11e23419d163765681f282c8c7ad8aa799410590f98659f3b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6176e1097143def891406a8a6317b59a2bcc8f4be4129c53b4ba4c9a747bb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7a5fc8261d2ad42c627b3e881900df80d6ab158cc262a499057242610de8b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc099b4e4cdcc1ec174b6e4187dc0e443f8545a7db066cf612ba79b9f1f0516e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e7f5757769a2a6e28ffc786f1c095be5c810146a1348ede91511dad8edcfd0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a4f525606830b32e3e7a9ac532ea9128d59e3a35f19e5067a3872bdc0567459(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c625c04b0fdaaa6e970e2ef6e724c7e0b3798ce0ca37f7a9f26bca1fcbea85e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428400109b983ebeeeb2626792a3411d1a91fef7e8b43a5445fc39dfc1e9a52a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12ba62e1d011315efdba2549abd8b68f3126b0bbfa4987075fc7dc7363fcfde(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f167c8cc83ac1753696ac33c22fb7a3162a0b9a5e3d3233d931559500196bf9b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fba9be449c5cba70bc0a50ee59ecd70d01602dca2fda7496d2cb51f11ab38e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b735f904e4a98586223af34d51f8e1747b72e0fa29c62d7698df6e8d3f25bc37(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3506d3dcd08413ef1bf5cb382745395e5965c409c9cd95fba0c24ee08862d337(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c2c08fef63cdd784b6d06e564b7c39036172b185a4fa5057d50d03a23cc427(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519deec959ef26c63de399f8eaf4a7276abf6b5e37029686ef3f3b0208be1700(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8340a75d97bb18e09a75b7bc5ec4fabba69ce6832c18a4064fba493a08d97bcf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__481e1229eaead4400aa213e8ab51147e50fbf1d1674faee2ede12051a1993dc8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8399063a598c7e458bfa1294a1805a2c00362378aee71324286818bd56d48a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de668f64d758c646b882244eae372881e19189002cb3e16ceee73e415d6bb1e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8574b5dff81ae9b1899f9f4b447d7c7065ff9e46ec18696dac31cfcfc9570268(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4310718454c3ca724d120cc1c59e3f72fbd7f58a6f5af379e47bf340298a01(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14809759725207fd54c239fcaaf0622e5def640f01b5cbfbe60256b32b3a345c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21545951ae8b62ff53a6e240ee40c15477ebe9a85a7abf6b99f2fad0dc2578a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3c15ba9f68dd191d5eaf32ec14778f7290ae1261e68b1c920c2f0f2cfcc2d9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75db1b7049f68764ddea4aafbc93820dc72058f223470e8e9458df3e6b49f04f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e7b67f9f144d72e5739961c7267823c69a4d5e33122f160f8412afdb9c0b901(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e04a70d3571a1f5f8df37982a245283034c4cca195a4061048f93d962c745e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab2f63bb6d2c712e2e2109cf9c662a7a6edb38154e0a9c08519cdc48d22ddc5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de22d484e506e74ec99f5c722b9c13dfb37c5079aec9bf952be7b353e9988565(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f3a5739470b1cd33e9fb8858c058a028ff97d2df0fcc2b77f4abe82d9f01ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd7f255a1314671b53d37f73dd71968551fa105304c9327d75bc0c27b41f9eb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f684776c081b29613085b0c163b7710b4a94d933efbe17510495709f1ae376b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d88392416035a754d35cf649a42b69ee1d3f5a95c8d00b2874e230584718033(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d72e0dcda3dc137b589d4232b1ccc321ebf66976d69cff96a3bd252787a70a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2217d94cb82de56ac216a51b484878c42e5aa3ed7f2bd91144c58d7f4de6ea11(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c290ed1ab1424731f72e0388627e07bc116b14290b4ebc1e0d9e4bc4428dcea(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b685e1fe18ca729faed6bcb78a4d0a4a7c2823fb1b50b5c0f6774b4371321209(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e9b9e41c403341b6f9b7e6113d616d3b46ec83d6a580f7a96adc13d719e040(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19d4bbe25fa528488e42bec9f9e5e390f085af90e296565b18331141b29540c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e4c161cd98f62409613266463691e604acc8fadb27e184f49145f845dd2df2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be069d092901fadd085312bef520e44e6750fcf96bcddd9f59c869f9f762db23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8cc34b0f63b86ef149c6ad43f6559c0261adc04e23533f953458f2fcde58215(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5d538b50bd0c8c95dccda5228a47054ec130a7978b185f618d35a87af1af30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3739fd42224e148e32c2561f7617c0c55138fd13c7658bc1ea1e313a597e993f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e3fee7fa82e8cc7a5c4a00b0463569a7695277fd83bbdacfd05a6e4a187e069(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69076b5d5c94baff0a5d3dd843dc6ca3a72a4cf1580a5aa45109f5b726d2075e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b8bc7c0fa759c2b41102e40aba175533cac0d228132ed64c3d9bf60eac2226(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b133e967647cddf00fc5b4377de40b1cd22b7d68712acce128930b37d69b95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aeba087cd0b17db16443bf2d11772c1b38ad901c661f746e87d2cd81f3ece9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81e0c99598018954ee44373504b5d9729f0672a78046225b99f5c7a568ea14f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948151d319faf9306a6d235ed3fe7af33a2fff319479b3b2c94231ec0acc08e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709ec323556db1d590cb1cee5fe47b6b4b162e080f6588d8aa1bffc1ad792f59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81956ff451e6bc164a3f0be3eb186f6735006db7c0a2eafbb515865f23da9b3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f859736a4d5c1fad87dd257e6778e4ce405ac8aa1e39eafa200ca047af05c0ee(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed1b54a7ee6a4e941a3bdac190ca9d89f98704d2f8250b19b7453f8d5c48e45(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ad04df58c9df6dc84166aa96e0ac4b8f299dbc30f398f90445f70e78afa130(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9239b33a0ac3ee494f10e0bb39cecfa215693fc122e576d60e9189057c3d7261(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934d4143df79e1a8620fe12ff33ef83eff6e5ff49a9f4bc1431c49be206ca0d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046440c04da5efa471e34b1675a28934dc3f368d787660172ed7f1041469d611(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088089882b6c4d366de1f2a3ec55697ad5302d7d6773350ffe0890eb9eacf51c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6263dd2af3ceb616efb28ba1135a650c64abc5fae1d7ff4b616b3a9a3951c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270237c2118002dc91cd495d031e116813cb9978cd748c2b2140503da67211d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea790bc1c961d6a48ef60f2318c75934d9eba03160e496de6a40c10ecab00f7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abec31b52fdb97625b6f68a07d0b7a91e94cbf5f6fb21f6db17f0e7011301740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74098f7c34c92a422261530dd40fd387d34e5b784fe19223193d615dea7399c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ba6219b78908139bfce40d58867bf7d70c037e60cf9ea98ea3c0880651f84b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99998c236226718034fedab80efd2dc5e57b02fff789f663cf3560cff39463da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dcb0e3225c5ad8c6c2d549b258b94aa9471b562fcb89d895b9d0e4dba8fd945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a6c11ec6131248969556fced2f641fd401452f8bb9267b2dd611e1350aaec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa39951bda996523c11cbc97ee46e259fd695eb9e99a9dd26e5eafb6a238e464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9290e20051218e6ce20b2099f0b461facbc620cfd1ecfce0d07e6bd9cd0a40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d007f07c32db62e781315efeedf5b47a35b91f7ff80da2e916f5e234b35e60e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f38b9673c06a4b288c44ca20935136cdb2cd1dc04d2d8532f25e3e5aa71227(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a0fcc5a12ae46301dc3602588ec24f552ae4f858103b4260d634ca95d60ca96(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dee4a91848dbca39bf3e8b128a0f73790c37997304a0c65090968a8e1c1afb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7682357291b5fb2e758f86593292b9006c89c5adcc751133971fa2d4b73e80ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae0a8d9eab045441e706b9edeed6218406acaf87653900c29d7d8c1e10710c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912050674631ce40f26e4b63b81aed157bba0c35305f735f31b8481cb3e7bc2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e264ba637342aab4402990b89342c4a963c268ffe2b4955b969475fcb4aa5629(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98b0b2ea12ff95752cdacca503288017c13171565cec3ad53d2785e276a93f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4d26132acc8a66f2134585829d6cbc9f0c62bd6518aaa647b17a5b812d698a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f112102c3d9691a9e9cf4bdbda2eae5aa73de74fd554617fcc9fee59b8f6d96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0006d9b25025fd8b2fe9864bb566fc944c61f98af7026a01c20120911b08cd22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abce91cbbbc3c610dd83ebaac5f4043600ea9c83e69b225edaae03ab3b5f6b43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa28d4d79f264474cbe762b730b4813ecfbe16a2baa9223969cdf766367e0543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e4b5b849e2b7a53d7e442bd5ec2362adaf15415c26964828888ea3def6089c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c3d5caa261c7fb43024a871f1f30d14868908c7fb16b0a98acfe02c34fb77a(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d4559fec583c3f3651c9a3826cd496d2b274e9cf243ddf223158a83ff942fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068b0fc9e0d2cefdbbc8493bcf97cb5fd21891322a93f52b111b5c6f5a30b9fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c335df3a265f1d993805a63354fe83c1b00c436de9a424ada04010a414f49f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1061182bc007b34a573cf1d25356c254d5f539a6e5dc1c901f7e0a1675ef7e51(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9451206c74fb31a5583df4418ddb0e41d6f12747d5c27a1610d0910a10d5d08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b930ab63c6f8e53c75bc0a80672e6571f77fbf9880d961be411fd76ea65d7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a42caf81f97c5554e29eb405b9fd1f2323cc8f908a0d0d4adf983bfcebabd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9df1ad63edd14c8cb562c0a6b0b4343c476d56522cc1c4efcbe0c19b8e3abf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c4d7c6fbba31b207c32bbe05c99f821a640a903034154c528424ad62a440112(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db101da05453d30a91e2725771225e3dabb14166dffd8fe561e87a16f5d5860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3257375cfb62a58d9e3b4228671a1acb893e4d29887863c7f584faa000fe9b18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebc2774d4f5a83e6efd66ae1ffadd28c170be840e8ed88970c07b9545bb54f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd370d9e418c034d3c5636549de1d0e3cac3acc35c40fd75bc55547f972c183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f187cd7e022e2719afe50b8e33c2062206f4baaad20ca5f3c711621590ec69c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881d6a3307eae7a2f896270e2b036f537f01053a3da96ce71745ba1bea12c58c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5c7903c24eb9ea07d6829ea5234576de36a58f186f06a9489d85190682afa2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135dbc29326ef219c6b0e37871f835d5588a4b904cd47fb04a3a51221c4e9613(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2a2987dcc3aaeeab01943fd56ac7e6163b4290d2f86744992d14dafd7b4c4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5c53659c52adc65321560c94f9f900a89d033b8d3c55995ed932d9a3e542f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2bc92f4567bc1b07fe574b7669a2acf40ac08b58f0b7aaf96cf9c86e535654(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a85aa79a737c0f20943cdccf71180166dc7a9e2e21d4dba61a179d5b53c827(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81bad3ea9c97cc308496a32719d23f02dbc527b2d5287f2e6fc2875522265bb0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e783ebbd815ea6918312a7b57bd522394833666f70b4757a893a186bacca56d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195fdc8816a4dafba20c0937dda055890e8577483b3122d982e2a88cf32e1276(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58083d6aa4a7968bef3d8f21dcaa70d872a65f40948eb5f8c54a5884d4e05748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abc77e14c60a2e21905788423d101a7b891b9fb1865457b50959f61dfa4a2b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe8ef5497b9ab5aa6cc46cedba8737e9b4520c3b7a1c74d3a4aac1417f73fd2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7312700a26a1c31e183a58b576045c0268518c03f4f2ae664fb4738c0c0d2e83(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2cfbf607e33c377ddd1f3a386251767596b64ba44ea76373d40e9b9f9cf0d36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625267fce86881d124ba33c3da8a17580b065b4c16dd4e8f524ae435b9aece49(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa183c379ee1387b7ed1d82a8812991cc33593164a0c38aaa2f36f83602c6412(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8793ce5712593aaa5d54bdbbcb6a1053dcb47fe9747465d809c4a2191565b9c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8cce0a3d0d51da529ff9d0999d491e6f37d38da751d96f5956984d158aeb3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71137812bad5909fa40a8206b8b34f668dce69d35eab3ef3df92643aa6ffe357(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed3d5dac865759ee5aae9d134540f7f7f876125e7245befc76da92b8c8af406(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49d0b8c4f08dee1752ec480b3ad9eb1842471893ae3425467648d5524381c63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584df2d61d9c26d76dfd42d09705054e09162734d343469003030e3f0af378e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7dc0720ff3abacdb28f66c72c263ca5f5d87f6bec764ef15e0ea20f831019b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aaef137a059ea9d891e26828776e07619def40866665c75643e9fd821080f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__100f4e93b89de9ad149eb6a5b3471a401f404da2293563dd730770ac42a141c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73014ca4a44903d043f4561e9c8181d5b9da0c8796d6fe407e27ec5856fa3fe9(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4781f0328763c5877f082065cb2d21c7cb44d46a301b813ec89f1505066c74bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67340e91731b7252f4138118262fdd8fd52f20727add6e2e5ef9e18f3da62a2e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a308ef0a1926904f4386c256e59f5e8b91ddd21a494dc97d644151dc250f12c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f72279b3299e81940c4b7e655eefdca3073b1d70e92a5a61fe93b98d97d7ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e072dcf258836b733071f2ac21d9889b1b1bef765d8e913d2bb95d5419fac59(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c906259b23e07d11f3e923569cdb9b39b640250f8de9c5f64c3118fbd95b09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f43eb03bc0705ad7da6955aec1e314426df69eefd15c00f356d7332b85ec2653(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970e2335ac9f913ccde7b40a128501ac03e7d031814722b11a29b0e815fba4e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98801ff70909b3b258aa19d7be87045d72206ceaa986ee7e70ecc06e64eb9670(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f96065bc0eac9d81b8e63f1ba837df365a42cd328e4f1959d31cda0c79cd27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be657d306e20708a7e905d61ffa36d080e853695931e3152f8d202954ba465ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8770485e4f804c023bfd04674f08928640107dac43f495cf6022b23705fa5f09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d6ed06aed734d1a759f0660ab13c9f5695d06433dddc06da9386b50668c0be(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927fcfa7fb76a4780145aba39fe41565e13befe6102fa32bd09617d34ced007c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b706c8151e01cf55e82b0e11decb9255a9bdc328db80de97bb68775841ddc8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b777a43b394fe4823926cbc681b27c8696f4a866b3696c4190d320885e250c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ad3a16cc06435337f030b92e4a21cb3e0adefbdd0f9f422c9b6732d7dc859f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe54b9c54f5d55103e0ccf2d1dd5e53b0dbc4be55a5da71b94286263036a7dfb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba91787f441de2c10ddbccc76ac0dd58735421c364889b6d8155b1a656352755(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dcf867f481d5c34aa37446da8cc90aeb67ffcc35bcf8ee0a14802246e82665f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610d13927346463701df27b7d7dcbb55bdba6cdf0cf405b2410e9e717ecd24c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2477b323eb816ee56b9b418c7a89c0536bde36295c35964e7b832569aedc47e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866b544f61263d9b5d019deeedaf0c7ff1d51f5253eb9898e15d564888388d5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93bbbf8db044f051f54e002fc7d2546fb6c7789a7a84e2a2cf7e40d16d4e0476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c5331470570898c6d7d7fbaf75a246a80b7cb4e0f08aad92319e2107baf447(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8054a9e6306ae1d9144f9086b079ee9873bc98c30803828ac2900b427c5f0a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36296ec9ff3bbff189ee849afdba81fce5f3e37025423a4fee6e98f5a89a2be2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf765c5d0ee8feef255fb868b838fc07c08f2226cbef3d66e85986e8d94a606(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d930053a586819b8f6017218f757ace8934d4286cef7d359aecdf4ab818c4aae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a7de16bb470ee0645ebeaabb599a98d1eea5c40ccaeeb062213f62d37c5c5d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f09fc980f68bdbf8304c9c7d53aec3bae6d138e3a284f883ead42a92060ee2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95aca04a4aa793295334dc52cba03dbd113319a6dace416a3b777b60385b8265(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aca5999fdbb90701b461f28ab74796ceed931efd3f86168bce884480aa87f24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58106834a17cff3e599673eeb6c0c1563c22c08a6b734b70e25b882caafa39d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272ef568630240925fb5d0665cf068d1e425b40be160038d95b1e3f7d42a691f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81450867a8fff1d088c5bb4cf80e43a7bd1ea9b280ae5c9d81beeb4fc4fd3f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c850f5ec7edf7ecc00c1d075a8c93ab9b6e01ac13c5b27c15479099ee2f8fc9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e6678f5cc040898a6e1d3ebe3e2d40f2514e6fa72d29e57a209cc8ed452bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2bd83eb76f4e3e0c4ee4e3ad0ede1f4273b4feec96fa4b14e7c195956b47a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa17646e26dae431002b903f99389397f307187342996b60ce6ca665297dd97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7fd8d02c256549a1fc7d168b7dd165e53379af0f41ea07d24c9e5d996f8b1f(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61751cf885b88e6b39029871fca80e11c8659c62f44d3912d506cc0a89f1fea6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e1066481400c787e989615f6f1ed1c4f04fa2f4283719fb1bbad60bce52ca9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7b058cc5f93235fbc67b6091f954119bb1873340704c21e39e2f9b4c2167a3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e8526511f3724beb79631dead26b061095178950a277e3951145f697e4b192(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c53c2d735c0646d58de2f0879c878451541e00e3c7116ee927b5b70972cc5e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e159e40e16dc209fef6265c78f3975f68ff21bec503b0e13518aa7f0cbac41a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66be26d68d78d3f33dc11430103c5653ce17e8e9a59c7c77eff08dab77b05d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f7498e8f30519b58ea097f705fa214f396bc945ed6c0ec36a58381d1a09fdd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51fcb94346564121f9e0342f0c11787069a40ee6f53c5e04e260d3caf3012bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__153794407fc8be9617fa28ae764c606f66c73b2d610f59603e34001c918b2bf1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51040d82eff60b9a9d430d32d81a7ae82b71d367ebe27f6a0f239a94a0ccfe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d23fe3b84bbee91ceda5e5f4a8282469a694957659f62dfe46066c9fc632c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f02557f7374a51d956c1ebb3bbb09fea6629d8272709d69af2d518a3782001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0432ffc21baf8741159781ada42bec15f5df4aa02327234f2d3a376813d40d99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656970042e06fd7e7524cf04159ddda3ea9d2872902a642ec9d35ff11b7e7e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2e034b657d2db7afc7f22b4e0bc6aa9fc86b7018ceeef7ec3cf77cdad52ee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04685955ab2a0a990c638f97efa50b1ce4899d5fd88d90d93f302dc9c5988676(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5461a44ca66d56bfdf80a9c3b1041fdb5e45c3846f7ecd9fa9fb106e13eb43f3(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed923ae0c93fc95c42618261724e3d4af2d98f6a9094ce9cc43d81c95571d22a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b900c8d8306bd9a86e48751cb5e685b05ee4c7633e748b33ee1d17f3a72a72(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd32147dca117055ca7c4959e56b17e14f2375f2df9e2bcc83009786ffba571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e3eeafde5cd88061aed9dbc45e538f24ef6099317cca36cdd506b303977599(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd7c115c4a00501e33232250b212946cbb20d5fd22cd0bbe23f3e0fabc75c93b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed0a902748b2377ea8385d49bc5c1b06cb2a52c20f15da1e29e207240c9e898(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d5475d01eff8d82db896952b8303ee419ef1ade895bb619f9c20110a035999(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe439babff21c16e78b09e300a77852593c118e5cd51a1a630958e07a60c12b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5aaac73852bb65710fe41a39720d100b2871c8ec7000b322b9350c5b448d779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b009edd8366fc6fbd99f954fe3ddeb1e29e1dbdf10692abaa5d15d8f36b8e2cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3dad3949e19b18a16c5647c9a4f19c15a4aa64900949fa9c4daaaf626711eed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b33aa2a5804edba3015aceefb66aa5ba912519815d4e8e1af4baed7b0328010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ab8d624279181b8a85de764d3a2425d923012e1c26b5c5d1068c5c3ad0764b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1fb48f9859a9daa1e01eb12722c7c4ec85bc4587ff049b4b60f7565f2e92e1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbef85b5180aff3ff8c11a8c2ce96664778c6c482232b5a22f4b22a70a638f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9a7b1f522823777e4331d046ab5ed4ea4633580c524405d8434fece3ae06cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ae3a7785befb9b6b92ba5be12fe8b26e47aa7e01eac789ad3de3b1c5a2a943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f096e8ba4ea28fe4478ee70a65e38ec79211c859140a7ce8789d0a4a0b8d19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad27ba6f80a1c8d975dfb46558717d7da28c31cde47c82f311391d8bfa474b7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160eb40d0f941ed95d86ad8576a32de6d458c983227683ce36cf2f81c9d34985(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d25530bf50e1d8da51dcd31702de9dbbab24e1a4cfdede9327ce6493eb2767b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15e3e0864b1623cff1e442cde02e00b4c538f54791e8359721bb0c9743bd79f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ef262826ba823cf9cafdf29b04c9cb444508e5fec912f3343135f45e2eb471(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9999121d514cdf8963a08faa6c55e83114b77c942ff9b8e1257820989e6fbe9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee9e5537a1597710089338eef64592e4aa247c32e0e24d77a08783870108ef76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d8b529808e6c797c16f8bad76e2e1805d3169e8257161dd52d8fa47097f052(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a6a50a2089116431e6d9350313261a459ec1711b659adea936182705f3858bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b740f024315ceea6ef9025225cd31cffffb2e29030cdac8ad6735df98376ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d6ad1a65ddc365c87d402220e73a5525792b633d85629c395a795b2c5383a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e62df943705da01302a38dd0a6ccfae78c2b802269ca50f62def6bf9edaae38(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fed8722d12d0977889c9c150d2361fd211ec6a01bd02e73baaf4fec47af2480(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71c6c44bbdd508ac50e1e17c080dee0fbaf7f8b8035a42fd4d7cb263db768e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9294062590d26f8d19e70f9b03af6de5fceeeccc788f97cd0df0677aa05fcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c08559a22c0cc2f98d3075fe61581b4641413d744a1cedbf7ccdfb40a8e8b2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280bd00cb3068dbd90705ca09fc10458590ba889247eeffc6d51d89d4f555c2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45238f95ab2d1e721a1b7ac3329c70aa5d1f0987c5f2917f5b7a464bad512cde(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336671b6dd340497007fac416befbf52d7da74f834774ac83236b3074b0106dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78cabbbc8ff216f86fc7951556c2befaae294a5b93b67656e96dcc0388a05c16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897fb855acea87a1fc219355d840e21fd4d0571f0fc450c60ab71db790654e53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04dce9d7c8d00e37cee53dcdcb2a29f3c3ddea4d67162ca0f5926ad549c411be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961ff049d0e8c4874826749037904b51b5bdac1e288f3f0d35bd797b6de251f0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6083fe8ac6f6b48662e395bdb0af7ad2bc0ad41b46c809f2069092a603e796ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747fe8bb16e634021ec34ff82d4bbdac518cdf4b40c935d1f6f6742103318615(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05b22f22682cd84686f9afea4d5231309545189a653c5a3dd85f3340906b025(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8988fae8b9d70c6eb74863fc28df45e15d812f553b4bd4662c7d4c54cc7843(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656664b35ea500828abebad5813f1ccddddbfd658a63b7b750fc7509ee29e0e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2d09731224a01842a356d6eeeda1b6c7a73a47003be7d9b37b3dee0672266a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b623659784b76dee6408f191e72b696e7a24f368df2ab481a427256ad405fca6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca83b7e26ce42b9e8923aec85b480b8ffcddb3a2a11ce358de9f6dbc61409a18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1821e0a033a19c0b9bc70ed5b99c814a863571c2772985f074bb18473673b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4208307ba9df74c46f140ff4b7ff1ea85af68984a0c5cd31adc8a1f94c7d9f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8598ed13dc187492039914e636dc1c1912f7f7b14e99812c6945463747c7a14d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49e30bbd40fe1e217b100a2a970f6a84956160dad33c7862d6e9898130f58a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e874e86edecdcd0c939389cb55b6ef073e9f0d90320948c760e4cde3ae5a56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e35df02a26f5ce18d03f74fa703d649ca367406001a17670b39abcd7b950c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92fbdb8ddb7923946475e252a18177699289493236636f9197b6b75af2964d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3bf53ac373a9b7a3b5076fa4a7f8fa90b5ace87011b9acf0ed8d0e6bdafb83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6f5a4320174f8cb42e023e8779e56f322c4b55ac96e5acaff056e59bb49774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae07e64c91c82185c7e6e404807c608bbc9ea73bb02bd7a6a125c1ba897ca5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2fa2667d8c2641c4267c89e5a43af320d0ecc14d5c8ccd2ae8eb1217b214c61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3601a5469f9002eb221be1770ad84fd4b4183b75c9562841c8b9e7c4795a96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456cbfe1cc580a9c9a12953ca98741f87bdc7bd30a025d44e18fe2b6ef143ada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__917267d79763b60cfd46713a19ba26e778fba1f1a9b165e2b499f26eb40cbfb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0e28f01a75d68d1e753e3be904bef93f4bb5fb6ec5c6102abc6233e1acabef(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b24520936861ee93360406f454b35c32b3cb0dcfb40df2b919566a782ffde3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc4dc19b2c94152304afb45b252b8197ae5993874e3bae847c919ac7a965c9b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c52315f14456bf43d81453726f467425e0a828cc870b6ce48f492a71f94834fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34bf986ef8a60fa92b70651716619fd89a08b685d63f4f53bfa94bf623c7d416(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3b4668b4f9c69ae192ee053fd37b55ad95440cfdc45428b8089de7eb8474f5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dce6c6b0ee2465600c5f18b7d63b35a53fa601b6bea9a411e374bc4d9d075e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae012693840f3e7939b92587fb9d35b976d4208055f393d1a7aa7bf2bc3f8bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f26e80f0f4e3f6cbf081d11be9b3fbdc99551cc4ecb6735f806e4176219361(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98f3c4cc1164b80fae0b5a920e575526a1040ccfbddbd119f1752f69196d8a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4655618e1c2d32029975c4638703991f10784232d25a9b200f2a2ffdf18ae133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab969c5f346310e150f30de14464fba99859fc2daa5f80a747ee023861d4867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2dbbc847871478a70233bf5780057255c635b94f8f3244ba59db80fdc2ca12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5718245a9d60d94b2adbfaf5ce5825c0307441d58dfeb4eb52e655f9ee2fd0b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e77fde7ebf2ade9272095d64b6fd736227d3a7a7b89813c8e8182881572bbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3246f05875619576e6cc6c8fe4ed7d8f9aa8e957bef980544980c1d09e8104ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7788917b66d46a5c114fb4ee70d0e649b8c96024a86912e837f68ec1be835cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80cabc3441b8e653f36d4024653b19e854b4ab5ac3dfa0fbe6ebea17ac3bbf51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b2c2a7225cd5507566be4082365ed754da4ff149c62d16c252b1edb04c104d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02120def2a1698f0f35be25c1fbcacf899cc9cad28aed9c3388c56f3af0a643c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3476c4038d49285465a0dc0e6eafe843d2c78d60ddb2753a390077e1aaa3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760517a4696f87200636db420bc83a02a4a35b52901def4dba67dee9b216221d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed627723d08f9562936d22eadfe5c29840e33b4c9d976d69ad8668e77c40cb1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b033d9066c744c4ef0f0e92403724409363dd1edb0d3bbd753d2d6dfedfc2e67(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc09548141dcc68fe58b98ceaa5684dc03a920a1008fbba6bd720c1f0757fed5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1820d39f454c90598f4beffe18705569d81def79bc1057daefd7e938209e22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0832e89b355be60dcb23daeaf3b9a6472aed92c5654fa0c3a1d7bbe7bc6ada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79623db50be96901d0e87d8586bdef8a4dcbef5531eed8eb2119286cf54ad6b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf4bfca6b398a5d4f4bc2e28c1307a706b22903c7a39b08e93825a3e60a39ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f7eb87309069a1ed8424324a8d5d363f2f7aebef9d22d115453a32bc85e8fcb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80377fd8e69696dd01c4e24fb3f00adaae16e8a63cb974255798096b2f530dd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b77d5a92c835fd3f642e25982777caa121747ee13b5685c52f61f35fb347a5d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7aec1b11288021bb86f95343d596d230236d1223ec2ecbee5001fab1ed60cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04e85cc6fc0056a1c19d24893494498ae80448ab9342e8a91c98787e66d0dfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9ae17e6de65ae2c8e82da8323cb2a4bf81e7ee8e28a6d05f62cd37f08d7d67(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000ffad4a4f7668c684c482b60f25dc92a5abb8cafd512b8dcf0bec76843b899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530de03ddea6e716daba4590d32987711a77c51ae3c2c63999b290165789ed03(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2386501edd5f618972544e11aa16e02e12028ef0f37141e9f6e0f5effbdb67(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33cb7b61ebd2dd3d969fe3ddbe93a2f839906526c9706a26eff6990e119cb7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c510928fe669a7bdcca3fc670553a34c3e1e67d660d4675edd54a8aed9cd5602(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3cacfb6e4386d141dece3e456b7df135ac702da1b3ab2cfcae517d36217218(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b3fdd5c2bc17cd29c208d3d6e04ca9642f68e45f1352b6efb21cbd90dfc2a3(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3098229a2569d114cca9a573f050d77c9a22901cd4c725fe8582bd6e0cd980d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7dea9ad26021373d334e9da2b3ce84c885dd8c06c0fb472426647116f11c01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba4d79cedf551a6aef13804048a53f6d29392b4566b747337a4d41a55172021c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054eaa4748e1fcb9db5a4fcecb27254f901f4d6e4644014edf56d033f0d2d147(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2caaa3e8f78108c97bfbeea15cb34428bcb9f4f96701b98df634b70166921bbf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5307587420a203392faa24e3507ed8eeaf8ca1434f8251039edc6df34503ab84(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ca125ce30fd2a46e799630a05a324084f7b2ab4711c502ea860fbd2a5352a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6539a254e0f51bbde33dde6114a4c57af730bc1a4911b3ee2a9ede92997e59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2a84eef1f48cff085c7b2c6e83e47cfb98a3b10949e20a942274ff6264d650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edbfabb779cb60b27627642d1b6bac693a169c837d39f6d2c3d5b09c1a678be5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b81424cfcce3c6f5a488caee9f76893d6bdbf5bcb749183124f3bdb3a7a4ef4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4df19b96fab5df189c58e15644a82839ea3c6e6c6f62843e675d3eb54ad3b65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c56a18fdec0d86640dc4f18635aebf6c84ce86f2a8c8d926caedaa6ebb1c7b9(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957114655d566d8dcb1c1ece56d81fcd66a565e6ac635831fe9903597c1ddb04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad4d200a8501ddda3ea7dc69290e22e295d33a950ceb736bb95e5edb00f07515(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__146c599573c80af446465298e3644db5932f6ee8bee80d3a28c35e84d1540796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e571d88b26786bd088fcc41cffcb83bbc18d9cdc2c810f3c1187c342b0f505(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f41205e274a56ced79b087e31b8c296eebd7d27f79005570b855d4b6271e2bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1534f44507d9eb1e11ea66247de2389e2368e877c10ce35a322358826ea0f65e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81760ce8f9dc2d1b7102cc92bd62d8bb47dc47c3387e61b632ef1fdacfa7730f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8090aa48f8c7fc4539bd8ccc816a215e813014a762bc3658d45dc41a9edeb5c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cacce2c756ba7082a3c0ae4c82a37277f41a0aac6f8ef7135edbd5462b5e8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5060e355163df77cd65d3e9faa416251a2248071352624c1a453fb73bc7023e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f0eb5b0be6ee45a9532078262698f92d4c916db38edb2b2a4c452a738c491f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f2b55222e73c3b175ddf1e03ca3a3c9f978eab2e8b048742faf5dedddf02a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d8d691ad42d18a5f8a3b900526acf2f1b1d8a15ba55853da90749d2fe56be3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8b1bcce855fed90eac8e35b126b558f9b6ed3b2f54f1ab6495d592bd030b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f235351db2277b2271adf63aac95baaf86e7e44489e6a8034438e14ca2e11c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c951d4c21162e2b8800ef8b971aff9f682bb7f134098f3ebf537a778a4fab1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be1b8b412ec9bd3e6c2ddd2223f3b39592d73886e72613f83f7a198f5ed4962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d562bcbbbeb5a654c550c01e3b57b94ebf9301f31bde61dd78771da08234d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456b4fb86a233bc2e952eab67a898459569e296e84f4e572246a8da6e462f734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd71088c338458cd79acc377bcc6f788c1f8e8b3834c2387f1279e516388135(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46cde272e51b3b9039d092458bae4bc5d65eb5659ca2f1a06d8c072cb7ccff9(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b2bb7e6a3b8b5fa088e43b8b66ed838f894fe1983d41132aa88cef4e42b8c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aaa320e176059119cf30f890788f9d1ebd3ea045230b05b2b873c6b64044dbf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c1e793f6bbd4f769bbe9cd70f24b3e71fcbe6a1e1cf41421a567578da6ea77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d9c85b0e6601814285db3eea049a3cfe9b14f8510bdd1062c61f19dc80ad8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605d23b8b7f8a23e30b0c0b7a90f3e3610ed44dc13c1bf0bb246e2ac4dec177c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c2fa841773a0ee8ea4cc7e2e0ad2bc69ac31372b5501f7bf9cb9eda37bc80c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad566c5263ad64ede1ad3debb2a52721e7500121ed7bd3cc2e47b52e5920642(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270ab6327a5409e766ad5e3dbc25522f80c8d12e70633df2675264d48ae73726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207d34b900205c60a275f664052fcf7b92a476c9958a54af927b840b995f0450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e2fc1f46538386b70d716fd29f88aafe3fa306b9e404ed11c2952badc532ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082fd205fcf521df586d25eb9795d9b3c89e3b024de292a57732c5a9c87e5e96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4297480413b7b72bf713c45000d6fa65134ec6725981792efd08654d34d07f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1ee6be20df895b55aeaffd4fddaf5f791411e73014262b1b7d3bae1546ca51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__005bc1d4791319edb24f9ecb6c1ca4e8bc6d359ecfd69884c1f74c734bf56af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02342f9c7016f60f28a465a6949b1811ba2db69f9f4a5df08747bfe067b485e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131df25e1900f98ea7d482bcc0d8767ebd5d3ed41fa6b54e316de93f5667ab60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15cd103ea9cff556e3f2e46a95258c4b14a6b7f644e544b70a802ee77bc90f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4abc54f9bb1a5e5960b5114b295fb7567d07c72418010896d3e2298fc6edfaa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a19184255a2697bdc43aa610ac28dd426faee4208ffe6fd6d4ab9bac54f0f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3813b427bf0121c89540fb39f7bd7430017d76ed089040c466cf1bb671a0416(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6be838aff0c29b6e4e090f5ce7767729ff0846115eb786e7d6d8a5e462b9c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fe9a8429d78a41009d5d9ff4c46ba8df11ffef0bd227fb21dc948c4b7061a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db6a14697d7336ceb43bf04b9de56220930e4b402a767618f363f646e77399d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64d09e254b43dd6d51cf78070de9819048627a3336dd60e82133245b31e8481(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e75bbdea6f278bb55eb1d0b0f33f45c41003343413263bb035c8bd30f9ce488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1221bc6b94839655c3584687a6cc4b4071ec86709674bb2767943c47e6cec3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88bd3c2d45e012607b518bb962210750321339b1d9f63a44161e86e715406a20(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba073eaeb8eaac082d36370380a3460403d50be82b8535543fb21a94e473b74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8800ce8aad66084b2dee9dcc58c877b8cb64b84909383dd7480a5d58576e81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c06d9cc0ef82c7b58661fe0643c2872f87f8c75e956bdfe3c0b41b62931747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b83adb8b6a57873d15244c309382de4c325dcf8d7b31aba2477049ef613350(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__670e8a672b1538e4473db57933de3d3c895f6c55711256da48a7df49ce942b63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9d2ba47a9b9e4403212c6e55a7ce0adbe4093e5222791a53efa22f8d582933(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5f296c4188b256c1336c9c0fe5c5c4706d90d644e2facdd30ecf2d75670f4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ea5633516325ed06d1fe51fde25e07b812d094eb3a171874858c810c40cdcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f463588fe52eb2206b3eb08b68a3129b068c2f176df5e7eef3cde6dd3f29f25b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27a7fe8c2c98f6012cc2491674932c9e0e8765b0f315565d4f19315d8fefcf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa29d624d4f37657e406c2d26a0fa76078d6dd335b5dce043089b07bd5ea240e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890b4d3e2e0f563cc05188ae44160d98d06a1b31132a535cf691302a30aa0e24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a005b6abe2941340987c58feb67bbbfd089d6c41fa9ceca8cd4543f4e01c9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af9fa8b2ba0f3a2652196c340c49ac59a6724e7bdc5db6b752eee2b78ca3c45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fa30b504a142b6c70eb0897c480c8ea7e384239bbf21cbfd286cf69f744695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ade6ec68219ac99d0802f412620d2b4ef0d6f9afad75cad5329abdf458ba37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145ac3801dcd94b53bf94926bc365c890fae81ed2732b9e51986f16a474b6153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0e6560115b951717b5b77e3f8f3f63b03b281062f12bf296888d19a627e648(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe30e290792316892438337228e79d2138c1986b8517bfb73385d401b816ef18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4fe7636d5d97d7c62cb598fc154a008e920e2235427c606849e543e9f0d87ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e7a6ae4c2684ee99fe25f620c0174fe1538fa30b1781d6f785a10317e72593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f466f77343d9d2946206f62f7b109c1d334382ec4d4878856dcb0cbc3cb9822b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8af2cdb9675a3b9c9e81acce922e16ef56b9064767ecdc2f93e7d0ba4ce4b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c78cb0839226249290f29d59deafb0e574639ee15f571f3fa770cca6d48bb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464b538a3dd026a6968add89f41189ca49544eb8cef267ee00d90251cf9df041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2e88e4d5ec9e8c612a3c8f5e8bc549912738574441a6c36cccefae81c098e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd0a5eddb771ebe5a75a7f8ffcf09b5f762c65a8af2537a6e43fe9a3c730cd8(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7bb9a5c0445493d03cca90611e7f0e249d3c449bb06be13817dcccb4307dc97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f90b32c277f4f61e2604b9a5cd6a266ff6e385129168c3f409b4c652f1263e9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6270e68fd012f24fe23460d3cebbfb473f6abc25641376df3a9112cef06980c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412f826d3ee416c57e61abb318345ab2c6b7d4c7e90d9e21ecc9f42a759b73a5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28e846a0df636e99a998c33bcf6b68047a747d0d7df73fa8e93f678d01bae18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841d2be1db3291cc74b73780aa39b5ef19b5c8579c3a4bdd440613e8d3dca006(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f7ba17050bbe5b60fd541f3d1be2a5995cc395b8a9b1a35c14b5159053d67b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e973a991256d53f22c2c7c61a4720f99bf5bf66e73a71d325299a5e4efcf68f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cfaf27dc24faad405ca7340989df8f06645f06fee9bc1a25a1d71a7cf9d14dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae632d18c67b3ea7855b52af225abd0d13f3745696b81d480bbbd34868d5a55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b4acd2f5807d014eb34f7581f40da8c9dfbfcea88a6c1d57369835de045b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8fda031561c75ca91a1b30c51155fe415176477dac9c0a4e95abf5ce36ea3e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84588eefd36ebeeb5b059376f16b2018525d48f13d5409e19661d7e5d60f8416(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573ba8f4cf8b1aa95bff812ca266d603d9fda5b2966effd7fde829c2c86c8608(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98994db3acc03fc7c46be2921fd058b1a8857f70aaa6ed2e82ae7138a4cc8a3(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0eea9bf82be6b9789a42f1ae79966f38dd8b9554975888ee2a50f2172570bd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1b6514780c9bd13b18adf840710e4a6f7df1cb577fe21b4d89cce5b0bb8802b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147041f3c71a88b7aaa6f5f67316fd89cffb677c4e015f1945b4bd92dc14d730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d60398764334bea4a231c8c0b191e1c33c65a612fcb9acbbc04dd2636ac52da(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f201ae57646709100c567d99dc1567a80774133c6961dbb5fcde1157112d8fd0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77f1a187ad801e5a73600fe1157b3e7c040c9e01db2a91956d9d1eaf007f8cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f39b3b066c5a19dc2b7112a1943bf8f34da66886056a4d8d4cc73e4211a7211(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76a180c197c05eef6d557984752d42bc88de82ab454c8d12d4bcb9ba4d297d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626e04a51dd4f2acf908a0ddd439ff28fc4c79b9319647a0c90bc3f8bf390b00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442afc8697ea4b020524232426738ab89028f5cdc2c1084bbde464393f52f5c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c869a1694ff0cc3fe915cece99327a13590134f23545e4e1ac28bebf4ce4c8d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc68eb50d399bbdbf6995c9750fe2507d1b7b5d1424959005b2314a4899d7e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df79aadbefa6ce91f2acf70a1f778b2ffaee92355feeeb33a5a5118dc64997d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcc1bead79b19bcece694ffd7e5004e3e58b6053b60da347fbadae97d4da5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae085c2078b0af21fdb072f64c8840241bb0c5e3bfe7b321196dc8e74395cdbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6891b69e14f9d34151d6d6d8d6382f2899ad1ff59a0260d794cfda5ee50f84(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f16bfd29620d3020d492bfbafd881847a7fbc9458067698a58dbfe053b51bb(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea3f918a02211a1e0a939763e6ff69161699bb7099a8be31f4f14f6aa089893(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4074221a3f381813fa48e12ee82099f114891494c37d2009786a0cb2bf58007b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__457dc6df7d7222ded1dd6d394c9c14f716b620de723fe0882982136fc37c6280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4499504ace72baaa0714fc44da5eabf06077065da421fed3dac94706f0c275(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5e9f4a54bee46a623ee693166996b5a4166f5a583eba173756cd6ce5583bfe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b012aa26b165d38f4fb5df1c669e286d5487fa565620adc5afee8be2611ea330(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ced125177a0953009a170599f7ce1dd91f0d783092bb37dadd0b96fdf0776b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5144fa194dde0f00a8818cc39d032a3c8fe94f19a0125743f2917d12883e520b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f624d0f930cc7d8260aac6b49169c240fd5bd1a195cf2e2b60140a7a38fbdad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fdb9d38e5232375ce9dee6909d6e01f6ed30d06abc59b9bf468ab55a324f2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66515866039fc94be133ad7cb97a434246c670c3aa7880144c9b051c8fea3d6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9bd5095b1f9bfcd7d7c531857e9163b56357d0288aeb1730035da4c9f01ea2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f6b767fd170dfddbff9eb454c61c4b94ebdf8c9723bc2355c52b8f48af30f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5524b4f0604ed8a0f2ec8d1a9834ff69e5c449b44a4f5e87859e493b33d105f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4b370913f07da5902364565f7a12e980fc44f5926a437d30ae5ef2b2609c1b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22a5a92c68b2f92565a509dbfba7e8632f49c51e551973140e845fbd855ce65(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f958dd58143bdf7b62585702cf1a6fa8301aefc9f5fd6deb880d6d80e001d1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897b5ec06c6ea8ef3d587c0dad2a4c427aeedf8652b621069988aa2a6d6d8f40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b1b35edfc004c6f3fe2787834ec05956e9ffb74c1e33114bbd5d2649d576e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f7dd71837c626d87d318782a2599b22cfe3b573f76ebcb62d007e92945b29d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f2ed99469b8852214907d97ae223b476ef9bb5419fb41cd22b296e0d4fd1ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edeb1448046b6d99883a65e7aca4cfd3275282d0560a8adff58bd6e4e7bbc479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936bf862e872868001b26b8a568bf65e156271567cd6b2e79dbe34472441a478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ecb27fb0734df61e3972af6097f58d23fe4b5f333fb384cf8b3cf81be2416c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976726973b2efa97773f0aba76b493d05c4a75ad985bde087a332c5ebf1fc1a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489f6f10e0a187cf035cb72c8c4516d3ede64c3e06ca6f1093f6816b16fd0ead(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97ea29fb1372533333a3040cd609c27d4f82ab14c095670775e0f92d1873533(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70871bd7b8234b485a2e8ad0968a0fcf6fefbfde2b82b726c2ade2ba39a4d5e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263c3286cba3d11f4f8f3fcdb5945042b6ec8333f9b1a2301f3464d648cdfbeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdfdf765eedc071d85b5563c044f3558b166385afa2351cee54fca65ace9df5a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff038f70d5c79ee72c92115c83dd20836f8c31e01ed8a96b1875e335b536f52f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c3c9fdf3124182d6a1b51700479994a9f9f8c5a7c5a01ca327d8251061bfce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79bb42c3d54fa94577b4071df271b9e4ca403e2470d38b67b66f5141c29625a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bc24b6ad185f964f10539edc36f7f4832612631507f591d205304785916417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746863ab3fc0f89f6da2a420e3e0d72a0e2170555b4c8bcbcf5c63acbd182fc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ef5b7c0652516acd9553e03b0712ccb5d4e5e5960028a612a0f79e72617208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162ceafe1ab29f5ca89be9871283e305537c952596d9fbf0d44f8b25fa29fc74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2444b3f64d7529130b2bcea08185a447f784a762853d0f7ec4d6a9006376e0c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c49abc7a8d09371e2cfc8f7d18f83ab12c94750f5aecfdcb3aed637d498c0a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b99e6df6417bf7ca2323cb27d18b9b9e1a195cf5017abdd3b9ffec9228df9d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb06446c40f37668def278f7e9b8959052688921a1b45cbccb61fd4f8422078(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1aaf51635f038144a044e85d8eba927010f2b1eb223485bd07b3ced2b0e0ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96366c15fdc679184041ee747d4b07d73e7588c32e5e386c2c80197780b2b396(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e262497be7dada5e87a0955b3e2c55dc4812acb84b2072e860b63b39a971f331(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1198e7d3bd381a722e150d958beef6fae4c7ba6d86e4d5de9be69e3528cd5b58(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88466cac7f5128a46741a2d6701eaab00e79e4a1787ea12f9b6334633ebdd28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abdd1700b455ea207c9b9ead5ee541eb103b027ba6352815cf5cfa9e91b31ad7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab06412ba907ae172bcfcaa9438f1edd45c55861ed48111536fc161ba89227f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2134422bd7ac6dad19d9cf67a96ae76a9cd14814af2f397b5dc20543bb7ac392(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a99b5813203203a6c72c6985fb19236c35beaa62a74c7e153d14489e8b353d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739715ffd9729ffb9a5ac50b56a0f9aff40891141223246d4319313797eef813(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87519af00fba25103366c211a805a37b71fc64207e0e5290fe0460332bd0c71c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f59fb36259a34f2e695d9fbd923c1932f8f3f0db96006e5d0f189e1eb714ce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef1d3509cad2febdff704575f86cc509a725f2610336a7deffe4553577cce90(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6c71bddaa0c7d38b480986734984573e64b9b262a6a2b0ccda39cee74beae4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475678c28f9e102d9d63f6b7719ea6249ae25695d0665d35bcb5395ddf4f8066(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5c6d50122be15db3b33936357b7be8a45eec6bcaf41de81f423f6b839c571a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc810517542e23b3b56f629bb030a782b96ddec300ff2d25cbf1333e7a25486f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f2d20f4f167157d81d69a7f4097dd0e3d529d7fcb10d94f7b7c27f64aa4293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c251072a7cd34531c9cf51231e02130a7fe7a9dcff03db9982a242af552bed59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a065b58f639f45231401980f6ebfe5f4cbb5e1046abf4fead7f8e0768cc49dba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14168c50af37807951a7848209a289a09f93b74ba53dc8cfae302ca1a9214c03(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0268399938d8a7d594ca6336212ed6ab1e48cdaddf9bd8458fda1f8c11f2829(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0965d623e74308210f27ef8d41679a580aabd25042cad13281b6602844f0f2f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7f729b11b752c6b4c662bfb608c82af8cdb8d35756c63a3aeb3453b64cb3bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa76f8d7b1f4fbf720afca2172b479c3b69347b722bf2479eb74975c7edad88(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa354c8c5cf95adbcf934f623dc54b7b4eb5f4e5fbfae8ee1b626a304153409(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2398b4175c2359c2bbf508d2d9d9ebd05995d33c514f6cf58bd9cc783997dce1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fdb6be488392c4b60157224a748d22687679a4f62482016ad57e98c5a1b2984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f577962c2c84e46a773235f9daba1835897599bfaef1d6c4d667ee747f4d054(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39fcd1d2e47bf0f162f2cba9011b3f10cde7685fe6f0db59ba928035849a40b8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47f30ea130183df52eadec6d7e9688027724defac86ae69de1b6d85d0b50bcb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91561f71c17fde7c02b045606553f0a9e527ce16e762273880d0fd3f8f134f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b10dedf1d969082562f2a9157c3e70f75af1aa6a5aa4fa6e8ada5381e7dcdf9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1708d657c2322511d61e572682ad3e81fdc1bc01e079afd2f08df4272fd76fb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0615e2a9b4cbd938e0f793d57b768adb309f3122f557757897320993a095de61(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f172da1c86a5238c4ae5786f0a6f67bdcb73b164fee7f6a9df72ebfd19848b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0aecea22b41f2971b9f494f61177f0fcfce00e951870197da21d68fbbe8b7c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9839e3ce1c30bd1806186bee7384264dbfc762472e23216641f720af389a670f(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d205b71792a3b60017da305554e74e9b79dad68a4ae33bfc3ee44201c622db5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc75bb2a12e070c69520db5e669a313b1355fb37d7cc9c1cb7a5c31cbaddb58(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adea483170f89907f970535e45c324c00d8b8cecbec70bc591e068b59d7c6707(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e12f9c38de1e3ea6a980bc969bdde7c4db9c2c324572a28f56f3ca64cc094fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080ff770ece9bde6cd26127ee9a0a0446e851eb76d51d15987d88b3704e8c629(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c92f0b96658f444d3d1ce8519f03726f05b49b57b16185151ac9c3f59af853a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b585b807b58bee638158501b90644d8305c71417e48dd92236b451de13cfb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4fe08044c4a86225c618731081ff4a2025b2c5cde1efa797e7498265f7d47d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7677559929224d9d09a668342913d2fc71659225e203c866291fdcaf32f7e1c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__315399c0c271a11e81fb918c952c67437cb283ca3c73ec5bc7eabd7d016ac001(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55fd8903a86200a47a84f3067b91fa771415228c05483168690e98900f92948b(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2335f41395ecc88da49b043b30330bd3757368c3395037efece8d640175cfce3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3640666d054147584a5b890e5c9e70c6e0bf1f09ab440ad220b4180ba0974125(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498f2c2efcd46170e10681a39350f6f90caaa637441dff0f684ad3f9313b909f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada67f647a59e68ea090c35a9514d8e55086521f92b0d226343026d784ebac09(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4747563daedc68d66902c012240dcd5c2189e89526a538436264aa7430e95a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34be9be7d6b8be3a7204afd9c5d63c3df705c1a84fbcdc093f64e36b5906ecb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a4c480a802e73d403d117d5b180d5e8f65fe24eca3c8903e5cb07386ad9817(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92b3b4eb3e0f639c890b4afb7317dcb478e0c117c01a24ece4448ce8eb0e7a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1996483a79c7faec7240ae1dd252ef81cd5a7d9d78fabc3678f306f9085739d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd76518a48f4e770e5d19b3401b8483e0418a073700c2e03159953d2eb553c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b290998076eb52ffb0b4abf40e874f3e9081ae7e6fb48694faa72a1a80634fac(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4f8e1cdbbb71cc6100348e283734c370d12efd4f5d1fc2390d31c6766fd7e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4c97ec6e1da125b910228460b825b600afdb1f3394d7e7509cb0d2797d2ea6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f15940908c036bff848e8ee56d97ffc1e7ac4cb9b31522b1fb041f1e3be4a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cbec152ce79223c003d31f883ea8ce91b70668bff662bdd145c9d425b3ee397(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb62763be5efbe27c3f3f510f52473541e5d998ae0da86e642dc6de5789881a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e45ee01d4c0a6d90093ad12586db8ea78100dc58a3d6e3532be2c0f36f433e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb96b4c536fc733025f8eb15cf41b76420390a12bceb4c7464398b1f08a78a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d71cad27dec51ea3af15aa67e3597f83e1b85d4ed55ddbab5d4e64d7288f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fabcfceb3667d59cf6bf1a994c0c1794496107ccf6fb3b9f87c6fd2ab57e40a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51041442dc14497f6bbec0f6074e4ac9bf9324982977a90c5913272e0894016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4af1dd75933c9d2eaf3fb84235b52280a39de8ab224d47ee1a38f4c631b3186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8d9b5fb6a56522fb2003c2689b349a693a74ec12331b6c028909b1d5020ef8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1efb1ad3622413f2bd4584a8a0ddb41775cfddb1d5ce3fa03b8d50c7a18ac90(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c7363cfb83a9d7e90c0196ab46b577afab8505ac42bd1d77e20dfbce821581(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c637a8b9e961a165ad4229c54475fcd025ea734237ea57a3c5e88b310f91695(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056186a20eeb847fc8dd8a57e82ae42c24e84b0b51904af0b9b669f447221532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a716897358b1d3f9bd06d1cf94d2cc52225e673a8e61d1d11e7282b9fd2d6c35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da28fc5f034b90ea836205c98fe3b7f521a508d25f654c54a7dbfc01259b85d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525d2fb3581bb662d404347fe15888614d6fc22f0d98038b0ab96278b6af8715(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d81af029f78fd0b25377869d977426b8334b8a73e283b7d37f07e0b5aad7751(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925a2850bfe2cf358827ff50e16bf25fb77cd785298fbf5ff8919f921392a18f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea8b3254996b9371fd3fd3250b01ad48fa52772477b59f76fccfad064b60dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b9a3b487040868ff75ae50409787c06540c627b5a18d2df86153f3ae2bab40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493bda1dc749d1dabeceff7083c440d8e7fbf8ce33e294f5e0d3465524cb04c3(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6635552a1f7c87c66e74d2cd85757a48e3ea4a2120403c803751f9de932f6855(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baac1d0cbfc0d82322edb78a85793e755403d80ee43bb98cade2efc2dd3370ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71d231f83a01142e0487f2ed19c3cbbfeed31b85021afc367dfb9954f82d522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581e9bf258c70d79c2fce636939930793c60220c43232dae041b6003d5fa33a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ec7333c20f252ded2577ac9a409603330ba60c806b61e3b9757cf6a808e724(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c75447ffd81b57a6d1dc8b028e54485b6516eb2b2c637da61301dcef0bb4818(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e4eb2e9ba8164dd0f7740d04f1fa1b1fd5cf66b5d940d3f82e2789cf0cedc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d326869dfb3cf24c28dd2e33958a460ddf1c0dd3382670ca9c799b64b4fb3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1988e807636957f143d2a765ae65eb671693e6796cef5f75a872ee4538596182(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454dc976721598caf0276a8cb19edb61902ab939a3f84ba8abf2fa0cb9887638(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c033ce66b01ee119270fe831b998fb6f40e8900eaf5c2fd263aca6b8007edb8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac2107daa8efe60915d944d67e0d05ffea08878082cf862b559084c22a6035a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257f58c117a04fe38a00f1958f8c7ddd66f7512ccfd7161e56c8b0d910681b81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838b039e485f62e2d63285aac4845db7c5e1434939995d345f99559521723d6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad109d9898845c662b5a6d3181edc84c1dc76c526093fb05ce2b2f0999aae1d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba87980902479c2ba142117d52965d4e74ecd7a814dc359f81a999e1f564d43(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbaabbfca9e8fc0f9ac3add55c39297b63e31ad9afba1bc806fda729861f68f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6745b00479fc4b3770e92f418aa32b2ac0720bc2d988de6e51e05288c5414a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63d7578242a44f8705f090a9e5c199468b2ded2813d5c6dbad501f3550c5fc81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70061f4f73fae2b8f4ae83ead793da03376a67c63d223749d4d23dfbcea2d7d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64fc4624abcb524217735bb53d4d2c3148ec509074ee67c54a9702834334b72b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4b35a79ffe7e8d7e23e809ce4127d3ca49687a5e1b84e9ed0a509151f38b24(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f2869738cac66d12b454130af0074ae0e8b5555f935116247c0ab673c0d435(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a161cbc9a133940d55fabe9ab1e7db7ef9d74cc9d6a758dd0d6fc3ac21ebe2d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28ea0961287260b93e4519d5bde032593af6e9fa9da51b6d77f7c7fea308432(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d40de4afc8cc7fd532ec8b3ff1a394a306852f2e0a0c61d5770f3cd621bd4f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034b25d7f2eb74f6b80f8524bfb61f6eb8489acc93e0fdbdca74e6137837ac9a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9094dd8980daad43cc29042458209c01d8ae7327614fad1f04a074277764c8f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58901b47b8c37b5da8dff849bbf476dd37e2b8c24fb7a8e4e5540baf972a6d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591518aaf8ee4093f6b7320ed1d2b1eb37ee33e5a66df244529305b4251f1eeb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181de4bbc5fe0961efb0f274fad3c7fbeb5aca5fa56b93e317b84109137be047(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526e3aa9f99b8b0e4fe4a579458051ae80a4d63648c0d81e2c7b5310b06ad3ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70b9e448f3841ea02657eeb6f208b9d71d9d09eefc447aad72710bc1266907d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d04d2b1cded80f237baaed7775681263de5aed8a8a4a22dd2a1e1b5bdab08a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90709eab428edb062f35083ffdba264f550d5fc4ec6d30e174cb2df6c9d43f01(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c950dc464bc56534e436923e7c1be7bd5658851fa846270cfcd0c030193b0c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a55fc7438bd7a587f178e8937d842a533f1dc1289fe23039fb2c59b86790576(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88352b9e9b62a454802930bcaa6c757bf718662fa6f937b2343ff3f45433c434(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23e3019b253b6650a04899a95aa2b8fab628ff14e83ebd6bdab505914885e61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39995a500704bc2d3ae1305a0b4f38563ab56a4035dd1f59abf4a906ec3d6ccf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b717fb3fa682d97b2ab79f09cc41780432566fc6ee8bc2915a91a059ca6cd10c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9ae376f64cf85eb7fbae9fd4ac5535f510b274fd957da84cbc7762791d238a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c0c9a74207ce12581052f7dff49b1c46f62073d43e851443f9b526d2fde1b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e675708aac6b1a642e7dbf8a9c2066855cc46419600cbaad5694f3442e8f48(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b8ec82b3c8828566338d8c5737b69fa7552d7f3b7b465b12a3b543d30e819a(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923e37fbba92a242b2f95dfe9b006c3b6ac03449ef2d876ad714fcb110d8d50f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f361275f86deeee6cff0dcd192c3cd598cebe196dca0e04b7777c603dc9f1631(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7ea7be9fdae2e9aff20dd3967e753ee97f09d3910c3f0da82a5b2f2926f182(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f0a8ee889e740d5b7c1d9dc793496e4221d33324690ae2dd19bede59e8b414(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379b1fb1e2177fc7807e83c8f09868f55bcb240a512f5bf10d59b847d9c7aa59(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58893dfc3c91d5fae1c8512168b008dd69ce42be46d50ffe70de144e4ec4c3a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6f38d0b19a42558cb53c9a331c3e07a9471c0466aa901e32c70b19e5fc867f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd89a14f7b1941485cdc3024d7cb84f32a12c88547bd69e9ea5d9c4919f189a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf6c03cd14234d05d1be71478f2aeb164dd8a24ece0566b03217afa515242e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a54428fc114aa0d8292e06e21d0d8ab2477c61d1b99e5f3f39460aae37d6686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b23298e74afec981dfb510e3dca6e71d80b31970746ce5116c4225bb9685aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec7086f784112cb9c2d42178de1aabe660a9c236909d364017a47be36a0ec062(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c5dea1b54d3c6473016fab6bd9bae748d42f66c1f810325e05d169008236cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fe3509c22f5e020095b22f825fbe3975ce28443f8b3804caa331df29bdbaea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e029029d4a9d07a632e6dd32f02ad5c3f3eb3667629ebdc3ca9b0e73a779e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68ee0fbf3172aa01dd598e9cf05090c84aef2d38d4612d1e9fd292eab139190(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddb680d16645565e5f34d56a1ef47aa711c0d77e4cd066727c2941a722f0a4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea42621995a096c34b34d593899775af12617483cf618dfb00bb29464a754db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ec0508ea6fc98e6eb15c712036fc03a03b4c278d72ee5abaefd7af9deac47d(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d655f96d896122a8391a3cafd4b56c1b6bd6161e6638697ac44bdf0968ee434b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3f12fec9f0fffbf7428d2e62e9d2feb29c1b1ed1c8ebab95640b791fc4e13b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd084477518f1932e37ef5940fc87c2dd06b6c1eb791c0150da64cc89381166b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e85a69110178ed142fdbb7a9f7230e8fb448132031edb65d091b20cba936515(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e259242e0f2cd7e8dc4d176a1aa9ca774bd437a72e019000936d5323960944(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4554e695cd99db7f8bbd9b739dff12825808531fd017aa336c792843042d5be3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1bc21835bbcedf5b8ad0f3ab5906513e08c905ac8b6307c3bc66f88d2dd609(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6132ffa46ae357ab1e0e85d40236aeb3e32a250270a023fa5d2744473d07e817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3917b5b4b1bd1e99ba0a75a32a68979e100c269e4b68505e77a770988228e8dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557e7d040c44b4ff7be1568cbc2dad8daf307e4f6c66e4bd219a6d00f8645795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2c0f8f2650a1e5a94310c4250b8cfb0eeb44e54c8ae4ee01c32c3f0b176be1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba55d4689a8b16c5b921f46af6bc5cf967ed617c39897f96b13d4ce01232f094(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f85bd75b7ed93f4efed34e21e6e7858d74074886387487cfa3944bb31e951d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d839194b340d1c9488144755a09299f7e65364f357c0348c396128081d4813(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a78ba24cc384f4551f5105d4174d089f77e4995c97270b08ec23a60bf6d10886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a25f2597cd4bc8689756724180bdb4589c279779eeae5db8e1572a3e509a7ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b534f0a8ee3c4b6c50b64d398cafb9feb5c3a4048062d124bf4e101606f419(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22321e7af129ab1ff3cce926e11fc18bbd6f2d6c444a9d77303c54bfdb10dab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1e3601ff9047f738b44d569e2bc2e8d76cdd9030eaf82a20e758c904ee008a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ecc91ba6d4b21aacfa12505597d88f5b2eb6dd6d8663685d8638c850c579ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14becb7a712be534efd5cdac2c86a053c571abb61faab9d9f44b554471f55cdb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6886cc37a247414379c8391e7c1b4385d5c23a50a93330b1ea7169e50402d02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c53c28858ad058a41aba5db7a1cf0418f27f88825522b0a2ae47219803a53fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068788b6b56ee5140c0fcd2ed94a3347a65a11411b25eaceb64c3dbc53ef8cec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec2e195482cead0153e9ec795e0d06acc1cf0f8967aebb350a917496cba0282e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c7e9fca3cbb3cc2a681c743bf014b2d6d419d4cae9bfcf37f76673f0522399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f84f2c38b73ab87bc0b06dbd8eca4161e3fcdd35778f7149926d5752195877d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40dfaabe97596fb9b2a67073dbd7763c09470d12b77e7439f5a511748f97ec20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2142872800f467268ba8d6a4e58de7b54daa574a001bcc9a7f6c4c69b570c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fb8cce1b670ecb470d716b38295bb96347a8785b586f5602d2aec5620e0409(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac3914f6df9dd0e041b628f3fb4c9d80a3bf624b5ae5417d7932731e063d35a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e40832ac6682a8e30c535d5ca3d4780aa621ae935cc81ecb20dde2d36cbb87(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__806201270f896a4de635072f73edd681f68fcef8ed626b64a881f99e3aa6bc35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c285d156d4509967983cb31b270559e752320f9cc3d0c8af521a362f875c2fbc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1bf93b3293c42d1f53fa32d4d2add0f07eef00557872d360a75fc69f25ebfa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f255b791bface77ca36a96a1f94c469b9ad8d73e8d5f5f07f16ea1e5d3356da2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065a1c72a39c41ec40411f3db153c47f519cccd33adfe045ef05b9ea5c2b4bfe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4c793de4f7cda89e17edaed53d1332e17ee085c2927d17ccf82f613b94e72d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdbfb5b913f81219a8d8357f28176c89f0ced455d858133694910d093d8ca7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718515a115959ccb8f5900db7a0bad3b2baa5974cca84b05274e12d578787ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd26c61128dee2af5f0b2209586bda17aac8f79830fbcfc72c05542532e2aa37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587c7bce40b3278860d0fe701ea2826a52d112faacc68876e42c17c3807db8f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efda1d9744e9f2f33fed1f3d9827432eeba18d62f0c8791d5c53c52a8ed604e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae38b024597b1654287f1efffe22c0c316d852f2048e5654e7f6b201b7be4f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2d31ca0c890b0142b69bdcf49d8b6f7b4df988dee1e137957f066add1d092c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b11f132f7a7b6577c15cf539d781ba5047adc618411270f7ef2f61cf75bee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c4f0fac3b4a95488bb4b8f2ab75de83337e77913a7249e03fa6a4d9e2c36a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4118d89bc4ac0a0b9339d6fd97d71f702a04ad4df8fa2b919369a74e465161d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32841d0e98c5f39ab6e304f60f672ffe779c9179de151464fbb6400cbd5653f1(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0869756ed57b0be26910f95df8b50e360fd43c783966d65a47bce226b62164ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbac936ded78dc5652b008da8714b0001e1ad03c7d1aa3ddc57ef13f0d47e23d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1973d9e531b87b35ad4728a421b211e04e17429293fd2b04e32438930901b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612b1c6b71bdf6d58df0e4fe8be803b3411cbf7f375f179cdd1755c5a1fac847(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e9a0b3ac91a470a1685eaf005647878580106a205778685adfda64b3e60bcc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508d10feabecc5c24fbc35f52d1a4834ff563b65c106a44f41b51c3852cec413(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224a6fcf320b077c2b85d124f36d20757c0db40507b685342164f1067fb7a717(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c43f6aeb56009952463c2cbd5f8604da37d60d362b34840cb3670c6c48d93f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5bba98cc4d97097e1c72662cfc5597cecfa905808851b6a380f582f4ad30b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632d7da450365964c3b0ba37315ca359e0c9c07d85fb532a11487a67ab552124(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5e3506009dac8bfca65e68fc9a85b2de55aa85c74b828f31cf7d20ce2ec734(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddfcd46fb06d6ee53c75ba4a795a89f46995b836ab0090834cf93c74acc39bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad39ac5b97e3acb82eddf7f6227ebb448bfdacdb51a780cb2efcd4efc2e3255(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d416a608a76a2a4380566d5d65d8cd7b342d244c278361d50356ac89d4b9663a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34038e0c2231b62bd9ed8294b5547ef02173dd525fe7c066d6365c9352869371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe863d4274f8fe185c46fafae67e5527d02ad7478d7107329510d714fb2b5f2c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7812a4535b4351650430c4f403118dbfb4d7a9a9c8356a369315d3c046b36d86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f827290528c459ad741b63a0560f58d342ba466404aef94e6589cf5af787d96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53ef474e3885b33dbd092a1c198c371c94f3b2953725bf1114c06f08d9d1de4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c9512c7205a86a653d813954887238f58f10adf8e310a235c40935847ab948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ebd88e263c7e6f0584986d24d4aef4f6f1c574c36e0d01424fd31235b4505b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8011c21621fab43ba9e35ff8ff51e03b8842c2f5b4a675fa9b72e440047e419e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38b9e67ce0aafbb289a7b855dce0a28e3302582b377b3914e9584d1740cc4a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6793f930a3e5fad565f3898e22ac98211ec60b9bed8818a7d5a1b84d3d26a1(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7221e2cece3c7374f29692e2c342fd53bb1d2366526119d1f72ff91b87aad4c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95ce7c3eb640bd3fb1c8a0262436ed9d76e39f8507182d8ed052be03dd76d38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8600250202108cbb8dafc5e3e7f950e38c0990f0941cab5d7d8024297c1d0c6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6add3e6027aefd4283f45712fc8f0d4d4c0cc50b803b733946e1a24e2df852(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f3fca900ee6acaed296a4b8081f298987215f62d67004ffdc263dc9693ba87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105c42c7daadcf8290e1a7eea08d852b4cf778e7fc97a71dbe7d66bd14c92ab1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f983c62fe535e3c5d13d383d1330741746e22b70969c3d5d5adddb53a4377281(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325a8f395ceaf12d109636ad968aa83459e82484b717bf920e990a67c95c42a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ed821eb361413929085e81c38caaa0c7a8630da019d612dbd3bcdd1a782b73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1f72a077ff98966c71061e52de0fcaea1fdc125ff9c2510d24c64695f872aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7258887b08f9b4c989773a27b19f8e6e53ff30d36a565bb4a210c9e5886432dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419f82487947b27eab076e3d44c49c7d88773463ae14db8d9a0897ebcb625698(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d493c7a0652318785c328bf0e3756ab49ecdca73c1ec45f277a2b968b48e5670(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ea7dcb1adf4edf1be58f02e44865893abf3d5f4341c0fa63528a7e8034d72c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3907be40b7daf1cd5056e06052dc8b60a4c32652b8e48c8f264d1e696d3197e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6959ce99c752019a865b2c2de98211318216d42dadebea14d4f0b9ef29c3c8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474361083372a4e684f36092d7e445bc306061984ba4f998613935df1b1f39c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb63fd096ad03563f77701e831089144c02624261b7dd9fdd141b198f53cbf03(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a7c787c97a6844e5db82d82487b9b0f14b5ec5683f22c410f543a37c6e6b22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3676582676bcc1c6e3408829573f1b9f3830756b6a4329f7dc6ca5d6b1618f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52f6ebd7a72a26fced9519ad05a7071de4e1a9b4f761d54845f8c32130b1678(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fae95313df8e24c36b615a4729c888e1ce858e8ba9e1a1204c8bac23911c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5393af8e0d5a27db259272a06dc05c62c4eb459431ba7d4f855645404f8b20c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ca9fd28322637eceac9c1c87d29fa749e65c092b6199cd7f736048c81a0d17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38a582e3bb2c063ec81c8be1781403d090a617cdd69dcc227b09578bf98a313(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d869bc1105cbbea013aad09b42a23fa545e7dabddd9bfa9e3f4bec5c8eff16e0(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef34e92a2bc2ad224a338e9d7a68bcd6d954c7989207e883abf1e2cbe505fa0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e90c6705021b2bbfe291cbf2abe91e1761b5bd28d47cb1bfbad6a78a0c308a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5578a1d3d375b3dd8f62f47e4d0b30976feaea3691c5b64945281c27112385de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a128702189d6f633133c4b22bd433c7496c3885186f45d4968eaa7fa262c624a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13918c832db5b60c8aaf52993660efc5103b0dad3a83c14059d0bf66625ca395(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffeb2593d96200f81adc1ef2380baedb206ca966046ab77e4e2d77ef7d1eba82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137ed6b03be9cd89e8937166a1b13bd0d597160e8ad137bd1fda58466b27eebb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb21855ef6cc6f57a41db21fa73b74bb3a7cdcd6d2a3383ffc2f3b1bc273090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d7f65c63e71799b2da5b6f91daa361ae0e60c8618d22eafa9676891b4c015e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f056c84aa118a989d558eb269e404c5e5373b80e22900c7c2b7cda15f54efd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e358f092d3ae746ddcf07a3a9d374fef1bf801cc235f1a051e03d432800b0f4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76676adfc0ec721dd831ceaa08d002639b62488ff577732db9ebf46d3496aa91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee05aad5bc778648fd16b04b343e6079c26ffe86f14626e8dd8a72e3b0dd849c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b012d7eee0e9538ba65a3e7f3bd408402935889ac3feed8cb0625ffbe206d73f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81754f7d5945a30fde628aadfa5f60e21cda524deacd97777deac039dc65b560(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d28df60d5782c41038b78ac9ca82708520b43b368ab66bd4e8c551a5611827e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91fb00963332df2ce55d600e0775430d08cae6a0a13fb0072a6c1a1bf82d8fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9839fa1ee117759f8d158f8b4445c4d7e0d86ea754bd4847de488f3a6e8c51(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b9ece4ab2358ea980cb0232cc9003aa4586b2781a0efaf6e734e83788e6f2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48fb692fc4266ad7186c43da4232cad1dc8cfd70ea7302278c27e6f08ad1ad68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c62ffc6872abe11a556f0920905ae90aa013c739a5871dd8935f9058b2e7e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f063cf0cc19a2b47792d304f3797dc208099ac9ecd5839928bb85e33e62fd57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581c483c816b789e3fdb2b4096cb73a69931a1f99874e5f7216e80a2bf34a3bf(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf28e681e9445235e01ed43e83e2433a91419dbc0a930a56e955c4de7f2d26f9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaa0171f5b99d09083d50ebb52e369424564c256ade16113c32a8beb5f8df68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea20eca181b2c2552160a6f5d249b57290982df1f9eff5a751de268eab3c633(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca1334fe566d6267bfc961c33f1681d20b0d2be8b57ae558239666210f1a3113(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e0ac34e2cacc6aceeb1ebd207d732c3b796200916eece1ea9f041b9119796d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de89aecebb697fb532f24675e159daefdaf9c01dd1f210db4342957633c67716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9713657a7b7cd8f6c60917c9cdeaa104825a8b7eecea96021d8105ac659630(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8006d457be04d21be0e076a689e725a1b4f53ba95df62fc432e0387def2e3a97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99de87b79d0bda1741b529544e75bafb965d4b9bec7745ce8d43ffccf07f135e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132634380302f43ec3ddf64b43dc81b09baee9db7b5d75b6d894deda402575be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff9ae9468d8547ba9bdce4c623d24616cca62b5c673382156b72e19b26be58b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52c6db5572129dad41cbaeca1cf2f7160376c348dc10f9639f46a058b40d548a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f8f4c92259d6d4c945209037e3e83f814af1d65e5ab8ba9020307e3c303c12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160a57ec69cbeb6f172a88a45a148c9ac69196f1449ea50f922fc82ab7743e7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1da45c833c92c74622bbc22759eecee40db2fe95530e4efd276502346a40b69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3587d562c4730b6203f044c07133ce7692b74594ca43918941dbf3bcae46f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0e9138a5f756d4eb223b38c944fd7cce76439ab5b1c94a384f8dbd4508a1a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ef738724da83a126d97668bda2d3038600d954db7489218502e02cc47b54ed(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f97e2642dbb580fa2914e94c9d5c3c658913ec84e265baaad04b7d012b07e9e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74db363c3e05f87191411769b056c9ac04eb69a66b282872f51dbf7b09625fcb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c2b082d4400364616b77baeaba01be58b043caf32172f07e7b54b251a17529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0dc020924c1686c5d69e6f87372cb15c87603445e94ed26170eb5583ef1338(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67190a4744fce13e7124a9a13e031687778e463405c339e9e22cf069ba663f6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5976248045ce013bf968a09307139a4dade339f7ac51c2df274f81b9bff2c70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb2f87956482969d75d035756e3f018e5fab4a0f11d5063782041c1786ed622(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29759e7745d6efae9160779e01ad8fe3bea340045386df85ba0e780c59d388ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5efe00d6cc6d3c546a3b28615bcb36b5508882fbca8e3e03e4885ef219c8fd80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228748197c8e6b13d5cabc1c3f4cf525ecb8e729c270d5ab9ebf363f2652e238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3af9400dea6c90841216e38db41ff0cbeda1b2bd84f0057fc7af10a0a75745(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1ac74e579e25ac3bfec8f355613544f10288151cf27e1b7ebe56f13af52442(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7adc99de65c2a3c1961991af022ecf672e0afb4d82ea3d3334e6596fb98d6d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda023b558119421365f031b00fa3e3cb06be376870c0a60c07806a6386dd3f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bef5f7a3912a99698f6a23d917830d4dcc1e39163989f7d32fe5d8172c48e4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a213480a8a372d522e48c64e5b904aef59865136827cbc6bd3c14557ce7943e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb767d32b10dbb36420a103a8e040da754c21a6bc659c0830cd00c15f9d2f35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49060308cd36c58305f8118adef9d2c4c355a7872c7ea4231836d125c92f28bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b37131b4ddb1ac9020ebe11ec0cbcd84de73e51dbb2a8cd28941827ec023f05(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ffb355ab8271395a6d145fc6dd3e3dd84019dd08322b2b283cc13cd2c9447b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ac6b8becd9a6c2ead7a1442195be33b149a44884a0b8638fa14a530da65c29(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1db6d5d276ccf588c0e52a4bd84fb66d4358882dd29a2f4164a527e5031568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcf1a856c65deadbf7e180859dfe0e860a7f9da45e74dd73d31ff893867946e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92844b8247dfdcd0293696b3a8132cd7b1cae158aadc742f2e8fd1af4a15d5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c542e1f895d9ba992c32c3203b48f06f4451eaabe1c12b3aac97a1d1ade931ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c758386a16939969e058ac5b9682d03af49fe63b8785b58c56d1ff61fe2f6f6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b163af455d12fa24125eec8a876d00ef15be1364f918d795c44636c7bd1aa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b9ed7955b699d30d4b0c6d259db65c23cd6da481f4500ae9aec25fb1a19a1e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50cc8d14a42fceaf926c47c118b68f8ca4e9afdc1dd34b2e72c666c7c94643aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a98d1fbb21377d7ab8fb5345df32cd67e1210d92b60d3d97287146cca30d631(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b4d731a00176dc9c5edccaa8698b3d4f5bf77a4bf2d41cda992781abf81869(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca2433a3afccd6987d815f0b5d9a59fc498c737c6ee0b705388a8fff1c0a1a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcfe70a0bb52317dbfd3136525dc9c041cedd90112125b7f5a1264d5d8eb706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4842cb7d8cb6de5941c33e9a2edeb8c9cb6cc1835001cec2ab9aa28717e7dcc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__852c3b20578d85b63ad43066dc8b8f4c32a00844fdaea9f65ffa42280fe282ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c4bced5ecfb8003a19df2334f2196b97dc3dd40029a2fe63e2b12d6f95055d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7484984bb5a4cd88424e86bb718b52bcd67b8b092a4daffdbd80ed911b8a982c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3516a37d721886700271ced2c3f39d9d7d3723dd0b3ae0b1750ecbd76e3505f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab751020cd9484a438d840ca9caf673da8c749a0bc3674bd84860e29a83cd04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012a9b4a25f84cd6a9d67f7af2f8186085f7a40db57bd371bd90acb148a4aa98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f59b98d3eee5dce7f7fa3a7dd6cddfa155209a8c07064dcb9044dd6a51c9941(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5c29ccc028c2883c88ac852729f2b8cb2f7b4c34de753faa54734f5543e46e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b56bd02b96f3eee75c544f7cf2f7b1322b946c084e45c032e07e93558654bef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e797e06d5d31336106bf693143a772df40d5fd2cf5ae7c7c10c4e03dec31ad6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b623566b51b51b38419c4cabe5a2e4dcbc073c90430e8f70456c7d400f55d49(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35d384b8caee24b65a793a46b121cfe7059e97398b7d68941fb515a2e7a4ffb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52491e5f2a53d37182c1aa9113c8a1eb141368994d097be60f40fdf901b27ff3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b393ff6d3b7d076b377864fb9d97079faf455bcd181c95df5b629bcf21f95765(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b60998bc674c3278b2ed51528553d10baddd9917ab1d39b02c89f4cbbaee30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2f35a3e294f0e373db566299379087b5c02667e0b0b2014dba160f42fa7265(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57849d5bd21a11958a8dba94dcb6f85e56753747e0fad1d99b9198fd0bb2fb16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec3483a8ec652ce2d0ac0a1e4d92b83c920c2fd022a96c70e7218af508ad53c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__432c783c31ab56096dc3682773ea7332b2d2aaad235c9aa7a84b33ea00a1791c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c833b030c5cf3a6c9689a4b2c2f275879343c5029e53ff194d028313354d5080(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fc41b837eca99617385e6c3191f015ce2b135b57bacba5d3c7584834ff849e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8247fdc6462d0f36142912de84b734df6b840d00e8915eb566850b2936c7e25e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ae964bbd7365605eb9ad035c5f0afa8523540edec57bce2c2d4c274cabfde8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e1be4247d0fc1e55749cdcfe14d9b96ac544f275e50b845af5cb8aa1dd3721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26976213bf77f4b18a2fbbd6554e0d70e57234f657bdda533f3a3a7fbd9d0430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44e797de7d26367b49c5169379f3d5241893b5b3f1e893e390a1b89a0000f19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75f9fd4f85018267359244e1d6c9f9223174df13854aa2835ab7f287e2a23e07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584b2e2a4610a56fa3a9c33ddc45e5b6d8a370918b82875e1c603071dd5183ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e08bb85f04e343179ad56031d00fa7c3e31fd4f27ab9e55138837762145210f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa39f223742be4df8f6abf1cef4be82e4238cd8be6ff5f4512582d0b6c5c28f3(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c61a04b2180d16262341dc9a04da5f3d5f6644efcd79c3007c8afc494d774c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__670bfc821c538f2b270be834ac6edb678ae10c5782aa042059d1f4503ab5e8ae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0d975dda36c13cec164c5e87fdead2fe4a40ce16a65d7255436be232f195fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea07bd3a395d0d78a1e6c108da22a88b0639912908deb91f9dd139d8b9182a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0653bf22182b690afe858123eb2ada5a34a67ff55336fbfbd8de36f2a714dc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65127ee2db1c6a622d66e3fec86e3b7384d68ff2dbc1e8165d13ba5efc14293(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84463990c6f76d1f1d768f9aa6d05f4ca7181091d6e9058006665490997d8bd8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe71579337142f28d4d2f5a8bf6cc5632aa46dbdb8226ddf3d317a66a3f2bfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0c8ccad9b68b75b21535977b0b8efd6cf16086f4e5fda4d949f37ac20bdb54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c2874709046324824b27de03d2427f1320d97cb414f47f879f37e39cdbdd43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d36247f9cbd0864651a8a51445b61ad74e4e870aefb1cbe6bf7192e217fbe9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca270467baf2c9a5ee45904bbd7a3ccc0c79abd047d2f8c3806c0b5b5f1a967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22b14fa5ba18e555b6e049ea7cb7d9753aa037ae1f58343d7d28fcdd73e0411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dfebe7a56a41428dff183744524082b7a48ee3ad63e89eb551be4536fa54ba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c805ac28f78e8bb9ea0225d8e575c2fcb2e2b92576d54f85c1aa9b3b8f2100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd554eaf65ff94f38e9871755f88caf9a84e0faf4b2e4d1ba2e532886cefc541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4e352d8cbabee6452efac5b985fe495ec7116b81fe5dac71ffc3996b3d37b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95362065cc7464bec5d6958327c46eeb134dcd0a79e53e68cfaa2692bb8f17c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96681d5d7d0b01513f8d55c15049114edadbca55c750dc2b56120d78ab9eb2f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421d5108926d408c6170565e863b5e25ac786a854bb1f35f96d06a5024d94b42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d434ad484ca31c58f9954ae152da4011c275caa36c2e4bddede89576699d51a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93a8de5b94e724c7812e3b788d10fff293b74b5a9a32aaddac57af520959660(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547b837f88ae1f70cc82f3959edce2cb1d5c068e714ad98140210e67119ecb1d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc364c988ba8b490e155c7e8ed55bfb90c9636aa2e4a30920d1929fbe7aae4ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83808e5a579d89cf77dcc7e691d81216781835bd66424ea77060b82a5864cbab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e2e9dd38cbff0cc2292136065ef457fa9d69e26e441000439ce1c9a5a4a17c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2212571ea5112a603f77686dcf6ca84f8779ddb8a7bb3d6fe52e0e1869c57e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec28e940a3196966bfcd834ddd18144855679a59d884fcd68dff92250c62014(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88307322581d5aea754b59fa96a55b38750e640cfcbb17be6a7cbfb43b5891f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90393130778d00b563a8076f09d30c37d0dfa6a70c7d8bbbf57f846d75bff15a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a2811310414e02ae6584f2824c4e95cd525dd8797a3a1e8c7e39761188bdbc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce6c307056df409c8633d008d64dcd1f296f782ea1264ab1884f10f4128fac2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f3f62fbaaff1b761181bdee77321abc30838fe0f9b0912ea4f5d645c7e0daa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a48fa43d201a422c542bda92742a2f19b5cae1fd4db0792997386c7bcba5113(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae02ef54296c99baeaef8cafc4cdaa01675d3fd08f4d43b933c673458be6ab6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51297319239efe515d3677dae184ca111ff2fee8530546e941d998774e0cc0e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__401be7a14cd54934b1857564bc9a15fd1f6031dcad62a59e0c117cabac1415ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4711ae70758e2b9ae7f28cf31465a94800c657630dcc0f34ba7588dcdd384bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7202340935311232cd4095d6cba99d852778beb235a529ed6c2de15711f14246(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54fb86980451bf307bc147cdb55c214d58beaa2a614b364e6cf7071e3f12c290(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5758b4d12d5b82ad4c04774e087186ee2fd5e7919502ca1ef83ca2141c10e1(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ce73352402b2725f5c35a14ca569765f5537986bc37b93ad352e1b71a62aed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221fd42b5532fe4483578c31013880232f28b64839aa2c123cb528abea85cc7d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6842277b54b3fc2d4553c0c9ed6094c91c4825d3b07662a213ef4fd0ed49bbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906139c57e2590bb41d0a45405141a66e430e2644b1a3f116fc0abf892f84d4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be75908691618c4c06a9eeca7db38cba5d74c066d8f52f70d7edd912716c0955(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4222114067fb0f5b7a3482a2dc969ea99b8dc9023f38b736879abf9f66f82d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2538b1845a10237d5db7124280b86ca51c0c8839166af9a810d0398c13727a33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3b6c2abffbb715462aeb20a9b70568912f950c5b7c48c3941a7a52886861ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e048fb2ca206cf691f4aefed348657b6a4285471b746a40fcf236cc66eb125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ddeca35731172ba8d98a8d1a7921a471b7e491d7529421103517884741363c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e2a6ebbb66c029a869c7381099ae9af763138d91f3f21548fcfec687c60867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8191eefdf4abc4d88ed39b0d62a612368635dcd8b4c5dd2fd2caeffb30f4d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d03a6ce6e4875c42c9736f6595e73aa10519915dd13181e97957124749cc54c(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927e3cc34ba845b3c8873f81f75997d24c2c650444c92db175b05896990cf453(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f83f3a717a2eff3b4d2811d07ef62a6c8793333b736fb4d0241815c4075deec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49052d23c6f79f9775050ac18ac416eb77dfdcd9367fb803cef8114f36288d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e016be0bb8c66f845f4a9e680a19aa0cd470b9aa80ce1ae6a5a8c9ca751e4eb9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da86d39fca5cbb489a0b2ad27cf672a7a9574883e8c33fab16b114eef85385c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd502fd2a051d34ba821c91f319ea37d7a1585d3046f5e674ee66f15fe96a54d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f07f9b656279db28f544de73fecadc634f15e1e8d1c2b84661d67a2c361ae54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b87a46db95abbc6a2065a0476e9fbb42762743f4fb7f3fcae98042a8c416b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728188f84ddca7a5d4dbf15c63df44312a88e0ce0bef3383b147d8a9152f8800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895a4ab1379cf340d22a09ed07e954807e1c4219c0ded8b014ca90a3c05a7e2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915b05ee059c761133e733ca06b438394588100cc25e22dd5114ffdbc4565e80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1acce7d3c92ebfe5015e08a9ddb07e76c9c70749f4bbe270cc6ef9f6981a543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a4af97d794aace579f90c84fcb69f393aca719d03ffc0a1fcf00fd9eb3b278(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a91573afb3024dee6442162e34e3b7ebd6f73884692b4f56fe781a979fef048(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08cb053322fdeaa458e22da120f4510f42dd5245c62dda007d54fa59595b5d3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec236abcf7f1433f3cd7ba76b895d0b3573aa2413756c95187fd848869b7d4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728e2c23163c5ee6536982dfc252dc0d1b28a8bc0b5c263ee56f1fc2faa0e98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d3906dadddfd3d1d75260715f224122143b0362eaa0bf6bee6ceef185d1c64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ebde096a31df4e68fb8742d2c03c2b21cf27f0bd581fcb2a56e11f4fbf71ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5212f79e3775f13dadb4e115af89178f6642d078de1e35d2be19e3b23d4b8001(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acdfad7eedbdaff2d6ec57c888d033c9e7d1f0fe2268912dbbfbb44b27543c77(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9affa7f9e72ed40388ba3f6963e8a74fef81d4def46331ca52e1549264376f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2577015949a8bee99f93063c58f72a3c6b97671c9e649f7bb6b08d41057cf5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544d793b2d05560407da0694d3b244c6f3386af65fe5adddd0d55853f079d6a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc2405d13ccef68f2f7425c4c48e1b431a552e9423a8872fe9c604e23b6b9df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afcbfd31370325cb695a1468691819967fe4bd7262fa151988aa78c370c5fcc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a1b5196a3cb1b8e0005e81462b63ff78080fa407df32a7b395ad0389a7902e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c52ca72d5108b7965695e9844c2c8268d195e5462e2ed5c9587f2393cff91a6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__299ee3e8c00313d4947c966fe5014b9acc889bc3255c1fe7d1a35dab45775848(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ffd753185011b3200dc529921bc02fbf9ec2e2f15e8a177b95743c3136dea4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643c0291aac40506646f1db745cbe273390638490e599b647941f8bd37f73c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce6be80768cc02be868b65f2832d503ed710846b6d866e88bc4f496e3c92ddf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbd1080b83eb0163678521fad33f80fb36946fdb0c10e5a59254cd3532bae5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b2000a05a62a5b7aded2ffbf55a0d66df296db92799e735bff589e5b2c5841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab793b4053b7948ce51fce961320f5e51b327e658cc479f016b94bf3dc48198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746f554e7868e383ea4aa38442662f705b399d63aae45be8e21129d9e9e87ac1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49da6272f619be4d271b36e7e52c592c889640254973e84b562001dc32afa2bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce8285fcf59fd9502eb682ef8081288d9a01faf09702e62beb38398cb24dd97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a589697bccae143bc62ed1b2f73b5075a85ab7e0aaecc44680e1fe4afaa64a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e256fca1862697d5996d360ad8d350d39a0089bd8a3931694622cb98c12297b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928986a41fe85b938705217cbcd16f95e65fdbbab6c10745419fafab4281d56e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27638fc4d1f1aa0eb4dc9a080e6232421f1361f635fab7feaa5384a1730ecfcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eaab4793af598eb0ba333dcffffc525c291a4332cb18d33f056e98b76df156b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf076fa20bfa1e06030f1442f9bb9254e1b2b51eb7f9610ff939569e2c9ab3dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d59fa7a04476bfd948c9cd2759fd6e8701b742b01816393445613074c0f02bd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08daf6297aba04c46a0a87e0e92f5e9e0d7b4ec72368fd5e76bcf1c751b0c2d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6fe789973bbff8e0fa6b636b78f2e3c15685d421be8f96f47e56eeb0401439(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd96ec8b35e1972f20069c8983cdd327035142d8c26635af2b0e242299fb44fb(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4cd1dbe1b1e8f999d54567070066dd4a040812fc8cce6e7115b91c7147d8a3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569bbdd9eb5fbf1fb17df3563afc8b13a8d46c4aa3cdf402ffcb502e4e81d6e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__506f4915d7d8636fd6d90d8f1e6f7b12b46446aa64422b0e31be59409beaedc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2fdf8022e4a1a5939f1bab86f2c92fcf92608913662fdb45a2137b85b0e225(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf51bada14770b4b5d773e94e323547ce6befe905fb65afee6986c8f070b6bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07ef579b9c8b163b0bf0af435918c5b46d7338377f0d52713cd2f289e9cbc70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78eafcbc7351c1f8ed33548940f0ba58108c8416316a75f60c52744f1ea13e31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe13d0669ec6cb0c760b39fa1680a6ab4ce587ed0cdf8a6201862a80e2d804d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1bd09fd24746bb9475173ff6ac728619372fe42b54c4e8fdfc85924bc25610(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e40f31c42cbcb8d1991be000545c2d78657fb36433cc177102c78f86630072(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56d52bfea50c6464e39fd3f700f8ff2553fb689645a1f588194c6ca57b0f524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4533cfd1c00f4cc34c1eeca5931bf09a88446a70be3a91788c9c1b1081c7118f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42eb0833239a63493d15791fc7b639eb86625728a5fc31b4de8ad801ab7c2702(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9c1ec27e903b3f6c370a1412115164ab56776054b11acb37c6648a0297fe05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66093405f88d43767ab4d099d3c276afcc9e8679b54311edf99cfd7ac6bd1460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2a46002d8462f54d43913eb64535ce53644abf2c5f5c18e7ca340de71b265b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331355d5c7aa1ae1143cd4178768b08b735d684c508d358e366960ec0245e5a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff52a27e5e9b60cc87c6bee00e682878067e2df3ff02204a30c7aeebf6efcaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa13ea66ee7a3778b8b08e45c39295e25fbfb16481aae7673e5d94d594cfe47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4bdca9005a5cea247036f2aaeb198ecdc19a0765016f055509840d19fdc3f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__befd9a8146fd9d38ed3bcfe56fe0a119048895b5e72cb855b54d39e395abac87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804609545110ca02402d075a6e74612167f0b31dc505984982f352bbbdcc3697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b929f90e74fa3af0c7cc8a79b20fb2bc3a288db6116e0f90d7eaf40d90a39a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ccd2f31fccd057c246b62344ea5275f9ed7cf8877329ff6de8880616341da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__575789b37ed73e293a8c07b3a7c87a82bd9fab5365d45968e14b81fa4b159621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e062c9b7848a51833134d6a3b287b04cb7b4e7ae1511393d3755ccbef024b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0715606b9bb8e62f27f8e9f22b8ca76c28eddead3cc986b3356eee38bed3a877(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0e76437960aefcbe5814c5380c704448900f3ab402f7742e713d29e028617f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc632981808cd8ee8914016fe4b9364c15a7a65916c14f32470469b5425ec421(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b008898784128e62801e9ab582455c67ca4bd0b39ff375d2e966abc587d3e144(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c643da0150e42e7498ccabb3ac41fbf014eb75483bc810b3c8f168dcb96828f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aade0a0d1849842f31cb67d95a1dee839c054c913940f2b91e0f982898c05b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19141f63ef003ca13bdd9d53e2965a7eb1d25338a644d7a23a6e03bb5b34427(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199885d2528c541b55b9c0b16b27a7f7cba2b13655e33a7b6ba722fb6d31b7d7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45d0c4c866ffd2119dfa9bbb5b1f911b1b9f110f5be85bb57b6509c583c00a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84b393fb2f0d36afdade5a034e8fff19d0ef1b83093320800150b5177473b38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42220afd885dbcd21eec516e3201947894757722c40c1aa06ce96819bc0b958d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae5f6c831fb46c3ae72e2425ba691fb31210777f9d4b4cc3b1d86ac065bc0ccd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a672014abd11951e92f931b475767deb8c826423084503ddcd744b9af5515c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07fa8fe4c32912f05254aeeefc237d917e9671bbd82a950b30879250309b666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84d37593956e095515add874e408e8cbd611510a8efddbbe0741356e2c1f42b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f86978589547f9c1ba0cc71289a93d612edc6b61046caa18a135343f793059(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b408946c27b25465636553c6905c628c78dba3626ec6efb93b6bcdaeb818fc74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9968b81d5d04aebccaffa996b062ed3070926d98cb99ff3c3ae8f5c6af9ef5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54ba82496f3c4a663515dece05983b39a241e0e2425e484b78d9d96f77f2c36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2744771fb2f8bf2d2b1b3b0de86daa562cdd00e8ae1b3be60799520cd9608ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2bf8a16cfe4928dc348002188d41057dff24263ea9f0d11b843b84398f0e8c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d628c6791d37400745cea8c21b37b1b4e2201a29c2713e2bc7780b51f9914ef6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ed3948f163c5dbf87ab06adb3202b3fa8c1ef975cd5e3a41bee0a38d060aaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec893f596a5975f31b6a8d9d92749ecaf3680ea0b3c2e18298d269a3f8921dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2946add7e39698e063f9c06793a18455f85b85653190c3c25096be6d692122bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ea3c205629a7ef5f16839f797cb1d3ffad35f22e03a24692a1c9373faa9044(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b8cb1aa9fe474ee6e50b0ade5d3b870ef171bcc79096a5fb52010864407472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c534d9bb0f80739ab99026f52cab5f2428bc76be0110ccae3c65f94cf839bc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b3632049986ad956794a4f7e2923302f8d9e69718225313f5570288123f804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe76b8b987a475cfce68211c09c4c06dcf60ce9466f4261414b3d2c9a7031ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857bc5dbb9c4efc58e7199362750ac175c74363ba596515ad23f382c15fe3e9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9aceb7c1f03d1a31159e9808f7505062f3a585f780fa1be1eacb47f35df85b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9da6ef4c7d53a6a1feb7abfb161b0919057665661184f1cea228c785c02dd6(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c33d3c286492b6c0362f7f5dc67b14e2f196c8dc9066d4e1d6f96320058c01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae733e67abbb33c41e59792f0a9baf2e8662ac3df52a132afcc43d0289edbf0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6142a270282b2ea34f05c7f236d7ceef9cd17c99a9286ba15b4c0edbe03bbbfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f2d0e0b6086393eb3607f81c98c70f2a2964af248cade7bc1e9c841ce08282f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdde1593c09273af2eb14c4d565cf1e5f6f9cbaa200b4cc921fb394c74326b1d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d60ad391bc6223a4e82e46a4f64bba3c804e8f9b492fdf75911a644e8c29a48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10185c4eeadd146cdb63a187ce5a9f8008999e65f75cdc47143f17371c5ab40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e60786e22cd8baf3a3001a5efe4d41e847f6e82dccba821899d2a00b176392b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0debf47ec893b7af1b7a61f34a1575c0ac87b4f215c7186e280dac687bbd8801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd8e48a4eb7d0ae9407cd8e0bb197f7c2d266dc2a9b94e5a078f6721af33533(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f455c9e12dba001706ec8ba95e35596ea4186219e5c85117e70b8086de62a55(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aca0d4fa2c0774e6ba173b82ef294df08ca494f293b6ad882fdb60ea27fa1b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34ad8bb1cc36d8c8fcade819d38a226cb6f29f6a3c12aaf21460ec63ef197321(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ace28e14a3159e819df8df19922ed1d7e7a40d03a1af06d33e54ab666f4f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b9a315a0084bc07af6b82a29dfd59048e277265ee97bb151c16b7bb9b9b4cf3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34a4235c073caa985a21ce40898f92f61cb7c53d6bd8d470de514d7cb7289d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f1519e987efc12b6d1cdc796a6a425b82133b60660464c08f5cdbc4ac87f71(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25b2cb2b1c04782e4d65666bd319e47ac63f7c2bc3f3f33dea4cf3fa2d0a831(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd102afe3c3ecdf7e4129d1ed91124ac3e481de542f2e6593879a21ccfc154c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59440bdcdb6a39c1cb6f7704d31e946f7adce45051962feb88d29f9f76dbf9db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4e11ece86a05e6e1017c8652d5dd1f8aab9c665260f5cb6c54a6532abab153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f39135d3764785c17830aee8c79820c0feb51fe9be35af63cf5d18bf9240072f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d46850fb0f34eea552e39d25964232869ed34282321944c5c9ea84ea857c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bb939f5f39387c302e4edc0a002d01fb0228684c5d1e7f76b25827e1285056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bbfdcf0009ec3a485cfdeaea19c1021ac721a3928ae22e488897c2ce494b972(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803232ae624975a6b0b3ce6a34cff714f58f1a33b0b7c4ed748375ffd59a65d0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e33c2f9d688f551482d32defd8cae9d7c312de291819cc6487145eb76cb367(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b487dad2025814da090dd395c626a19eb3ed6f4018b0a47f2cd6f45fa7938c63(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850e9445ad26a3bfee354e447e9a957a3e3313f6b2dcdbf86f4da075249bd41e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3362a38875208bfcae1cb961b1d51af3909b51867f5293a7c467ea2db65d0d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4bb2c4d2d77620bd813137ece8dc3dbee21e9fe0a7f7962ba11949194c62eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55fa765a24fabd1eb4721bc8f3673681fa861ca741e4afdeeb1ffc7a3d3176dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ab08c02383a895bbb9985a0b8c92d530772db7e2ecac5200e66b0e3383be67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554e421a7c111df63a6be6a09351f643ec93760a5a069df4d43038ef8224ef5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88facdc28e84c7ea79b2163929ed5ace66e6ae12d358733f3e07d0988ab6b241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4f0a532ad2e5db6eb70824c62859f4a8800a62564602d2cd415515d737c550(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38fff16e6a5eb72f967c448209033f9f907927f393649fcb3372b3406804b33d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76cf5c969705dca7816f88700a154c10d358ae4a9905fa9bc6a8c646f90cf39a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a902adaabf5b15d31db7da8fff9131caa5271dd24420e1343c63f86b6cadddf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3e939d988517df33049afaa9b76703c1a52dac2c98e5183cfd9e11e8a7c6df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4f17fb60e886fbb1993d1a18423c880a597fdbae3200c27093a5b513ec2c2f(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4034d4fa1e593f5ac704e8c8d53ccef7afff3b969087128e22cbb6337158a770(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2215623b90e287f0f7a604613c2dbb4a4eb635dea419ec139b43917c5353f035(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70c69701c0ccc253dfe42e03360582e36e78c1f2772e1721f7cb77ba105ccd1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c06fc8eec84771cddd7ea720723ab8f1fd00875254f592285235749a86b74e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e9507b7c39a4811f3db9e7e6570b665b522aef9f463b76c139440d3a5a15b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f592e428bef5b3a13f4d03ad7f9998a11c7b4870aee71abe59a23cd422e1f626(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76baaa6ed2d0f53ecbe1144d7f945fca1940cab77f1b19a2b8e9784baf2cea6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b1f88f1356bb4294daa07c266d67d2e83c5845611a04afbbe5ec81f67f793a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d8b3ff55866289cdc24bac147ceac922f293abb4a984eb1bc697034089597a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afbb1734d3435425f2ba29d6a63e9d49d61bab4708afaf7f19b97667f8a477e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ec28982bb0f109554c633c986c47d5e8d7f78299928134a8011bb319883ede(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ff95385a59380f88e8458a45321bb88d63e6ea815054c20de8e320ba1451b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f753f2b61c2994e2635961dcba6514f1705368571a1fb8e03ec9d17c05aece7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b839c8665b80264fa0606896365ae0cb9c799becc735808c7592844b767db2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4a0a5d3c39b55ac09332574f912e15d05087ea271dc56af5946765fdc9a3a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59042385cd74174b6b06d0ac005c1b5e2437b9fe576d7b69cdcd079ba3fe12e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff30b9c6128115a7b5a0594cbe57dc5f6e48cbc675a898d5dbf32ff11912aaa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e3b2c31950528f5264b89dbd8accfcac2d88f2c272a6c25583211c09f8457c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3998c4ea5688620fecf87fb302ea84b1b6076266fd2bfbd3793b1a74537587d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9da738f5d883ef4f67ad3166287e9f68b1e22f2d65fc844a1668ff4cdc003e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a8de517cc01a635ac1918b384c3219d990d1ed0272577931ccd8034ba2dbb7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72343d961a3975a00d29396f01dd035b8a6c7ed8570ff8a00719fb1faf947c0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84862faff7ca7fbfcd86ad9f40f0c8cd7f5603c2681ac41f6f1067072a12ab32(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7235e65ea5e60d848c4308c87096902e7d05c3a257e5e80894fb6e26e5b0c12a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526777c0dc8a71fd9d19d1108872b71a10ed615eff4aac79d32d38f48ff6101f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc752883a874f589a50a3a43be05aff7adbc891914bdf54a5c2f11025798ce77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__005df9ded6694f69db751f7cd766f03eaed09a9b4bb0e72cd51cd0576a4f101a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7d655e6b019b5a478eb1f171199cd5818f7d665e302ce1a2e2089630f0e734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9aa02521f39817d257e16ba780f6cdfde37c077c17ffe0e967f0c5d8f405ad8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0755f38b4bf4a19434e4e6b08ffb6c2d0986d084c2f3eb50e1e433783d7281(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490ef402f7317c57e63a986115d1c6be4307eda7e904bf9744aef2ccf1665d7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d71193584476f242c7be210e50d0df7609c61f6b9eead42f3a654e64a65e39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a93b31560407d23b4f8049a6e4f77fb9c1a8b479e30236e38e9db4d7afdc68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab94eefaf0cb6eae794107c8b5e67b247cb44acee5b4053f824e8cda8281723d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47eb8a4dcb2762f16cbf499176fca9795e733c826cc884281325b61c26fb01f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f56990a7f58c3b6897b6969cffa4cc64df9e7b2e286ded9f086889f68c6f31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea7c6929271c7c800994c600fc6d1c595e2cff48ef503853fd3e49ebf543b83(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bd47b6b03630ca980fd4e9d3dfe28842cd9c25473ddb0e8a6abfbbe0484f34(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f062c74adb01c389a78a07d6590b5341427ec3413e48fd7a77dcc8899a57f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c338221f6db00cad61ef49f6c2116a658a0a8295f69f81388a27294bab41dd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da38c8155d78951c3144876438957ac6fddb34f6197d3aad15342c681f813384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__176248ede06fc38f23e4ae600d0443038e240d3b53fd8e88b7077c5046133a90(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c08ce561400208763862dbb77ca9b3155d2bd4c78dc732240ecd0de3bf1cdc3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab7ab198542f16868ed9c23dce92e66ca865a9089aa8dd61aafcd3863b4b9ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4158dda7863dc3c5c175a2bdf0fb94ceeb51ea54e953a1c2dca09785ccc01675(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4aeaeebd3d67b4bbf389bd4de7fdefd2da16248b6bafa4a721c08608657e058(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5dad7996dbed59bf18fccac1f10aec31222d0170f70472c1471ad2b7acc019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f285a43177e74cc19c0ed4d02790986a75143c21fde3d0e26efbfda101e42be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7806045196029619f61821f06534c2786698489daf34c90bcb8dbe62fb0ede(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023079d517ed2db0e5269bc14b8822f4736974961ee1b94f91fcb1505e44eb3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d246394a5d4abc084fe7ac56d6a0e3de7d2a3b293d305eedef0595492ef68d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a630e0879c1706d5d6d0fd99f04fbd40f78e8dda66d6d19a0a4c88ea518074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acdd2b03e8f1ce0034c5521e4833a9e86bbce6719541446839f5651b091f5cb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3913cc837ef371d3d48d0cccceed7ef90e4bea365d33984b05752dd03b3951a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d042b019443fad7faf8e78a173b72cf601d3dcc9d60dcd057c0f3e364b8d22a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e237a5d04fb8b7c0ba24a7a8ab8a9b4424a773dbcbeea0d97a80807d9c5365(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dcd081f09f4adec367fc88c9ae9eda1162b9b7759ccaa3f0ed6d5edbff64f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4390be820d1af29a6cc09abef216766c976b466ed11e8025fafbdc8950f45ff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e819bf3b0d6d07d419e6e9a741a8316e8244d7576ea1679a24c38378bec5111(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__570a5de552af53c202d32a1806404711b3d601b04a4e331ded61805d43151ab0(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb341bf81fd9ab3b4d4f1b2f510431ceb8264657d28dc4cc9d63223b44be1176(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3eba197beff9f56c308f11da3301713f28b64a9c64641063633e4b89bf9e68b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b125aa67a907ac41ed1459fb23c60fdbff2db1f95afd26b642d868f4829beb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59f85aef02ece1217da3ab3fe93b1bf9ede82caa2141b80afa8590e64e618a9a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3718c421873ae5715e66d11594ba7ffaa35636b2ce2e6f2a7d9eb17bfe2a24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e3ade37b1501b8da9f0d3b9972f6c8c564a39568aa431e9fc95408d5d1b5d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b88d91dce046e98f8f51a19bf3dca42805fc50efd0dd54e88d9b64f12c4e5fa9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1e6f5a2866d439084616f2250c1139201444c862047523322876390d3a6a41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f051ef3064e9aaaf7272e02c28b07e3133fcfaa7a650245ac4d0b13cc02d3ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4af4362fc58baa7f8120fe4d0d08e15613a12c672cf4703b09f19fd3f9b4eda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26fcaa0c2a02ac03ef21104e9dd2907d2d8a15f18db5868d7bb413a476a8b521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdde4aaf83af10d2a57bc87fb874149c735e17f69182ef3af15a432542cc5044(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1a6191b89679f814b99abe732d2188646a7c10bc1cfca2c3223f05a350bd79(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31282eea8bbd0822af2fe28bc6569439d271da38752ea7dfcf4a28e9929e6908(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de1b25d632ae3b93072a2951e9016977983ecab5d773dae095b1f2d7363ea5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b414c437a6ac695bb919b9e42c9dc0e8b9b79a1c70586908a3d4f7eaa2bcb264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a201a3e539877c291d1050242ee4fcb37140edf08368143841ee31d4b5c270(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7da7628e5dbdbec674cd42f7dd5aacc5f9489a960a6bdaf646ba27cfc542cd15(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e6bc5a6c97d22b6ea6a2c45ddf0164978d29133dd175f31d000e8332c34bc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daab92f9e966d34344d7c970543be2451ea1a0deb360f4ef1962f5eab9bd4109(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1932e428214e3eceb930da7db3afae90546f3a75963de7dc1978a3161a6ce9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb336dc3eda100e459a6d0dae4abfb69572c4028f86086206c787e33d0ac5b6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__badaf237d114d03b253475e44b9232fe93af895c335ed0ce66f5409a6d531494(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969f12162f82bc8e690703d94ad360f1e4006b43444a4a108394dfd94c6c743d(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac09297e80275566738c5585ad5fbc271fc7b793f993b1cba1c7da43854c0da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b00dc3428cf2aa37060c5dd229ac1b5af02ffa7d147c181c0054bd3727087d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615e6966053acc1a601c7c4a5845912700d2ad48d843df2e2e10573c2b191458(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0e281e71dbd14dcfd91d90dfd0db4667589fbf45212c4a37cd3dc18d3f5bbe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5567300d8d9f50c116c7257a91c2cdb27699752572e2c9cd5bb8a20911b51557(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60e7c0b02e801996e0ac3525154b36cd03c8d39433a0a131ba4ca60e24212d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed84e9ee606373060fa814a89d3eee184ce6c5e761e036d2bb34b7dc24542b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9399cb0d57599480233f306fa7c98548cb6f96af67822e6f8bc85acfdb678c28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b99ba96650f7f89641204e07d7a102e4c91a756b994ff2422cec92790f62abe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9272a0ee2d037981b078064a2062ecac16d30e9a4539c3b65452ef65b8c00827(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783fc92c0f2c37bbcffb810f41e6cdf428ac17337f7daa986227921d62b35672(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d807b206d046796569d6fc469a5a44381c6d48061bb8ea98208314b00d932d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c26a83f7509a6a6135d3cf18dc56dddffdd04cc275d320cf753ad1e6c401fb8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c00dc13fd98f0f67a980315f130980319a70860f91553439ddaf900670fc03(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e441af9f39e36010a484277bb3f8a1199e8cfbfdc73399bdc20cb6cead4a8336(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__016014b921d07248a1a298f86c5a570fb2ba7da2bd8bce01e02f0949b12aa6dd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58bb160dca25df04c082401dbdef84f99af2a2c626719facc5ba3dae5103fb4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4092009504da9d9d2a7565bcbcc63defcbbd6d423c7828939ae18b78ac84ff7f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da905cda11a2aab9aee33f88f0bc64d0c0f7648a69e66c5bfdf39360d4a2dc92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26caf8186918202f34162f41d6d82a6f977126b8033c74602e42c767a725a1f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7706f44effc55a3cafa02613308c14c5a2398e6142b221eda86ac46c8c3ab15(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e49250c22bf8fbcc1c419a016d277733b4ce56735f417a80e2ba3c0d630b5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f5187d12bf5edf6613105b140e201256b140e9a6f59b99db16fdba3ae6e068(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722e18c605e51c9674e29243cb2d394481af226abb519fb736b3ee2aa64fce06(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ed5d2afb8321990518dd917926ed5443100180a8ec53fde29d1526024b796a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78306cbd4c1702fbc2937482e830f4a000e160c62159fb5f2e0fb1e04fb01293(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58bc3b19a0b070d3d5cbfbbb3f1bb91a800326fecfce4233d5ab83a1db9aa02d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fb6c785c558ad9a6a01d140deb0c8dc338338346f5c0fa04221b06c748987f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e0f25a7a445663618065a94a757c833231ec9dc0f36c10fad2e49b0fe76406(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02165d0b6e0411436dff914950bb5b056215ef4b2157951136463698a7eb33dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2e5bb186913ea6ebfbc290a65ca112c2e9bfd674b42ae7e6ecd022c12dd1b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6cf91dd2e7982daf45d563c4f44176b9c8e3eb3cbc3cbcee224251dd359630(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bba76c960145afe8eea2eca438c2ed8b88e2cfed02469702c17411fc8d751c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6177039df5dee773f992aa393d88689691b39086db8bd6655a504cbddf8cb52c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__945b23839b4cb0ff3cc1742255081cf256c422604b34f2dffa14e0db16367d29(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845b41daea4c41e6a0d363f1501aa59627381c63689485752b39fcecec92b0d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a8019bb61014315ff7462c8f906c8fe6003b72207348f7e137a10d34b0c047(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129bd5ab4aa65c85f12ded356453d1a4af5b623bb0aaebbb1964d727e01bea92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90dae658a3378e1424e33b43236d831cf4905126c60042a07197e9d8f6b978b9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83085e7eceef76da550bf93edd26c7e3a22ec489533c67ddea64f8a00ef5df3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9decb74731587a618cd985d78e339d57b229ea9b6bb024d97db73f7bd5e74b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc5e1bde11bfdf900dbbec2763515876df72cae7c05e24a46ef28c24db271cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a4934213d4e4434cf3f94548f6d3f05b3b99286c6f706becb1bcdfd8cd54ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50eaa5ad2383276b024b1feed276cf9ffe9a62d6e2f21a7f2b1528250103fd7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee06c232b97d9077dbeacac601313f4a0a1fbfbbe732f4b2a08928924cc9f280(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbf81c42f5c67bf4e20615f3fb362ce9eadbcd3d8cfe637dad28efb34520f3ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44877a83f680c964ecd41bc6973f633dfd6bd7fd6279254745d6cb65099b2a38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a289aa4bf6a6236097b5522d2253a0ddd3bf384f177cc5f3b3ce72447c9ad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c3391682e7aae1b69519fdfc748c404464ee50bd21d938b468587785ae64d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcbfda124f31f35f11eae93d310ddd86a2ba2b1e6bc70a894c7d6eb02c233a02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59faf5a7eb8e203059843dd5f024c69f2370b3ef064ebcee082d9d2231b9d6f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488e12946a58f8aeb0749730dfc96f08fbc185f6df9956de4d03a2b9ce0eef0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d103046ec14b2bce0f9504e5856903d465c85af9b4d527ac4268193501a87c68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493d8fe4d0a0f3c18370c5e1ec607b207e363f824c069b36b99ca18ac0f023aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0b432f3dd5e7af6358e5af104a91dd9c8dc3f8b0782178ca523ee159c83643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c002c9f1104ed1b0def1e3754b1370cd25c0682758c975931dffe9c762de7a9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36769bda8a146d8815ad48270f9ba18b39126c4919576a2d80bc4923828a068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf66062a8748be21cb6a325319a6783099c79328ab8b02a7bccbedef64956354(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcee0c459679e13e75df0da14c649a3d208b3f383c7f1750dbe4d5a608a1ee80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5d2193a23fdeabf2cd36508790e6789db6f4dd085994ce16d2bc66b7e677e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__194f1f80b6f65fc7bea57271351b120db3072ef64d034e9ff9bf4ebffb4532eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec7a09d1498dc725e4366879a8207db5f6104db01f3a4b57214bde67c8b49ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d2b0e69b8e72fca486ea6563c05626b941034322089b958fbfd8d636f3124e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7261efb8bfb0258f2a3fbc390ec7729110a1b15ccd82f4134a0314f382b640f7(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba07921f57d7b8f3a5310889e746cb2633b82d1ac86a5b9cac1b6006074a549(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb4eed9401c0dcb047c8c66dd951f5bf888360f1598fe9c97aa840b1937a291(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e9b646a1d6d32ca87f13b376dc8efd8c75ecce74192af5094841bf9359ac4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377bc3f9fb69876bf2bc8ab013dd6c5ac66a1b71901fc2d22e3f74eb670f60ba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d38154f77c8af9caa0265bf2fce01773e994523257237cdf843b7b030dc5bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f582884a72cd68a94f757bb31a85b885f8c8b8a43769b6e4f7e913c0651ce4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9802908726e986ce3bc271b273d7ac339c9950ff7d85a288b99393aaf606c25a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58e5192ba049183013e24d38f226751f92306ba691cf6a03ed0a40be0cfe28c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14c8c509ce5fe831d685a1df292818ab0fd9388c3d1372280888abdbb68b8dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8da8ddcb57f16deea7d0b7eed08451e654c0f33158b325527787b20871aa5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4544d5eb0ca5dffb745ffce163c26d42d25477ea1eb2180423b51b66f4fb2800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f6ecbe474012d6b7cc1747aa18523caada0307d80975f8c914eebbcf5afbf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d4d972eb1073adc43e5649cc85db5e652f7e3b48545ec88bb61acdd0e8fc8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6063841afaf296d0c0d547fb85da56a9cf1d94c9d63a9ca3e500442323d3832c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d4a82226d1959fcfa2c48c86675eab51b3b4375330a7f9d311fe1b191de2fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcb41e7e8be4cca9504754fdef9ef54a28b57cfcffe05a6fd2ffcc467d1daf9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a071aec918e9e0925b7d9c6a343575a8c33d2ee8e1a9c62136d1439df09571(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75aa66ec2d471fce89b55a533f9f9f717935aa082189e227dc05ff0b46deb340(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50571e852f46b20f46ed440b9c9e1c8a4d15d72ce3754843f1396a23ec77bed7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9981481e17e0f0f25dfc09123a33b805f443b1e9ed1a4c8e35756d1f1be2f3e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabc873c1d88c1e5c9d23c38a44928b5941156ea77654ebe4439b6af9cd6788d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50f6aef31e98a62c28191dfb4c6f32bd3a22551313c30ea57aea7bf084f93d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ca257a26f2abaea8b1dfee6ec392ce1ca3fcf4d3a8bb39fa4e8a6fd896bcea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa69762cd7f6e8e51dc46e05b3e06a4b0afa2d92d8f20cfbccd44ff3ef49ea5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ef0ea20a8489b0935c363a368525032dc3d9865583ed806997e6f04592b2ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5775a3b75fc70434cd916f2ae45efec1151c26cdbfc82f10f9e2c4581c700db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f899b5f5b26c74e3137458c153fa7bab15a9863c95eacfc8e5f7a8b923cfc342(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7827b42c35b53e1980c4fbd3eddf24e3eb40884be55f384aad607fc0a50f2770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d040c51b37c57c497675485ac2777271bf4fa1fd40429f4ad1e801b7bb1d6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9a45381f9bb3e7ec1d848a4fab54f408fbe30377015b3cf74ec4d2d2e718ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72eadcef666a0df2a35f7cc92546e0f66dda21bb7a81b497007cb33617385879(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1e663bbb39d6a0724baacd4772ac1d48e13b7a3d1f1e7691ab176da899d8b0(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe43e2098b5aef6d4ab56c367ee206dabe2dfe09792ae8a2f07a28233bf3c14e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c27ae516ed5f47717c787f4771ccb3130dc7f5c3512b60b63fa26d801cae1fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__317c7b35d8526f61d9464e74c42ff140ea8a20b5678df3d3c06541faf5a8dba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4166d1f14e42dad9616425bbdfdae78810e5f713fc7d0ac0fa1fd785e0c09b35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbd598376c7c9b5af52128d3e64353727c7e38e0e8fbd13ce68ca4b77edc0b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422e66aea0ca43c5140c9136fc5c3e4c50a032a7b3af5f96a58469a43385a68f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51926c299c90167184c7d15ff2494ee1ff4af0f00a5d7310e76abce40435e6b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93dedd8d5086b3b1d99ff3bb30af095f9136cc576f8abae6343a1f39428f2fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3501fe459d8ed3532c599b26c40493022e281fb008750a1bdb1d151612129e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f4acc431e867d82d7acf470387a1d86283022f474a39881a4b33c464c89da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d809eb76640b938586e940f397b9480b8197892bcd24937667200dc8fc9692b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5059ebff707cb4f6e705cacd9addf00a67b5d8828827913b3ca3313eee6a733b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683dab9361a74d43d5ecbb1f8e5865006990ee7dcc2eb6c7d922cad6916c058d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4511f026712b0847fd5f7648488b59f846aab04035a070b84b2afe36f45e0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22009b96fdc081e7d344c85b9629d714a3cc54aa59b089ba1dd765d5d38f889(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b098d375d023b2d58e587c70f1eccc08b891fa37a0255f474ab4219e5f8c355(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91aeee15b8427f01209532a515bf972a598f41006c5c9bfd2a05ae03f8b06f7b(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ba8c453553f7eda5404a89e3268de09edf2768176bea7198793ed2f44506aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef0ee4f9f4de0a450a7eabea95ca68c63d070a2e6c4daa27f267c90f732353d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a15433a9d9c54c2b5b12a32188e8f24250e5609e82f8aba13d4c47cf53b7387(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec97b1670a7ee69da86b6d27e47a1630aac7dcdbecfe934997a515cbeafbbe8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0124340ab6179043459dd8830fbb4c4aec908f8c0271e52ccb15f4ee1686844c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0247f4f4446ac3baf2f35658953c8093a2d894f3c4390ca2e5535e9d62744ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc4b6a2b4f00bd85cbc9144804ee138f60f44d68563e6f5f0dfec038eb863b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd24f0d79b243ac12a61049d3b9896ab45f9b61344aad102240421777623e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad275efa7fe6f949c357d6f35d0a4f836ca7031cc69f8752c3ecfbea93b32d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0318dcfe0af0ede691281e7e161a10db1fc6f81b82d4c38c45d1896d8d0a7fe6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d075f3855e686573075a7909ea9edfbf67061a89b735a67db3ee90c5f85aae(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30850251b2dc8e24c6abd95ad7f3d9c2519cb66e7c8551a431dc29391d6d0cf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f3773eeb2c00e39d4a05d0326e2ab37e7a7ee2ab0bb4cb02249f3eb59c61a5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8954f25488cb7f82841c06641b310a9858274fd7d1803261e9a456706e063e24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a7c890586f32e893630140a3bb11200f733c3c05d56cc920981bf108ecd539(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81e60bd0ab70dc0c1fe0f77cc947f011ec02d75045e87440e5e4a82b811e01f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb35c5c019dc5cd8da86ef96001e138a0bc29df7c8f8e8d70c21059c2c63450(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94eeb567073de03211e0747331b94378883d91d4cd4c371891d4df581e70220c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bcfc901ee7ddaed205aad1c4fb2beeff95b30ef52131541f083103eee77ebcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e9139f2a8e975aab139452e21ef4b94701ca0cff3557da256c72c764b45ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ab2c7ae8798b9b3d0808daa5c25af0627d6b7378be7bbc0e92960cda2388a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333b0c6d1343d3c7e933f2737a10cf16fb58831eb08a7ce2ab3875fb78081f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf016ef0c6a7b5cad380b7f24f15c9949188cc169b46f50c8eb391fa39691b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2d892043363b79238c4d687cc684b7f329cec358c4714e260fc4c22ae6298d(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1132d6d6d111550cf54ba5a930cd72d336fc0da2adb220c8b612facaa33b98a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a4a7f1b9ddca74f23aa3f82f37cfc480a019681c6ae2faa33852f9c5b769a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70752ac7ef266da78303cd0c92f27690cdd1f3f502c205ab452ee5472c07c7c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fbe81587940127d765e8f3e1f30868efd98915e58c1be75818663aa2eabf115(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d65ae5269531cb030ffc0faabecb064ab34572e17729d294493ba4f3ef8781(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a3ad58b55579be8957ebc497499f664ca9b71f5f3d889e287bf678442d9899(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854e625b3d4fc5d78f1aff00f84be00d38e69d55d2a0758dc1678da15b880ad6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9588a3782c9d9a2433f92b78c1e8e62cf4a154c9f097a09e11227936d229699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef967bd011fff7fccc41cccf07036abbed2eef1a2921be0b791c96b7bd164a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad2752d5e12f3408210e4c350bafd535981b82c65ecbea43ec013e6f0461813b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba573b4ba7798b090b509991997c11513e77d7e7802e08c5b7ed1938ea98635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f472b34d5be5ef054f3018b3c4865581f159fc179bf429ca52cf06b34202f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f35236fa5add893f41c4545adf5b5e22e76e8b188fe0429588b770146f9da6(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c0ec93b313f9205a22cfebea7f84388c33c626c4be4b2c4ee542990073b103(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__205c4063d0d83249c19e02fb9172f1e61d22d7de0525ab937376866d46a9da3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ff9c8c080df2b95e5a37a4ea8fd62814fff6a3e00126c9d72aab20b3b450b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5e6e41d7f7e86fc89d55d891991a7f474db544a737686ce45719987079185b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f4ac6d90484fa1d5fd603fe8b6159e155e7c68922924ba9e38a899d62e8fd7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b015b807b6e45de3705be3da1507a39e3ca46a20ad9fa0cdfd68d6ecacb5426(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fc1231a7e819526fad50651128250c660f2d19828a2b8786bd979ca340d824(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4f211efeee01c2adcaa42e400a2b9c2d5fef3a6414f46087d044f73d23a8b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f863dd8512b0feb768ab893f5d7f3f5d2802bda001a727bd19a73b4c8f95a9f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ee503ab34851273437856dae4c518925df47e2fdf01a7efa26fcd2ea7a0738(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4882490a680ec26359c13a510b4e91d91a54e5eb4e5bc3588dbcc2fc7bc26b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67aac24f6f758706fe6d26dba4ffcf6331e6a5068712e91733ec9450efdc404d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95961547e54a8892c37df456168435fc92f06fc7066f5758ae5cc526df0b09fb(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__796c0048c22504a936dd19deceb3e5c5a154c6cce8e0f3c5e1cee0714cdf9ee3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2412cd590916a68036b795498392e61c9b8712e5d9237a5d6e91ba3e66e5cb2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f86fd750bb27b390366655f3cc364ef33d137de84f4d91cbd42d12281d8cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f746129753ea29985f333582853e8c1088ca459be03aa46bed41bf67f3e3c61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a4a2d78b2fa6d130cfb4c60d254cbf99d11e67b135e6925e7c601004f140d9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7728fe050ee11a75c4db92283c5a3c35305a45e0875327f04abcd1344edc004c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa30540ec0ab1031288c2dfae3e0145b2b6773804691dff0be290464f6071aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe1f50397c04c1c2ee76d3f73e8d18ffab2d98a89fd9158fca3d0f0a745a3f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d694d5772b61e383bbf28de4c8402ccf4749cad314fd06697ee0a34d775617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0480607dc8dd35c4cb9254df373b5a38494f5aa9ec5ebaf1213449eb4070a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270d024f92a887a2d4e4bdd68e827812bca55eb5664669c63e4fb8f7b4a773af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50825751761b4da32f0fbeccaa3bee323cc9860996edd85c3aa4a6992c18cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00f13021ea6cee7103fa552712b9eafad7d50a8f7af9c00204c90f09f3619ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a4ee829c354bb9f81e435b40a9c9fe3a3a3002e97b425bb4104dbea40d032d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1838eede7e270c91029971dd30a69df26771ac6446641dde0b49d529b99bcf37(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f60332b9b78816fa5245e8410c0da7520b22d5e40d4c7fb3a3f662008178c9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306cbccc8f8b88390ff5d4cbc86f489b85b7ae27c8cd1a27a7c8af2a1e8cfc17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9410434b04098d081d8fd97a5bc7b84ab84ef459721e73f0112ffb4740a4cf6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6262faf5623e9a96d2e7d18281a5009f13fd95e87ea64140fdefea6966d95db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a085ac02fa0ef85c6d24d3f3a353e3b9301040209bc595a641729682dd445276(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6ac708712cf4dfe7c3962fe639137c400b2b7dbd7c2b24e8d915a32a0571f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6f7b7bac80ac7831868437b60d85306cbbb7d2b1003c52f082b76888e7bdc0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc040a92c013344dfe80fb8000af018bbffa3063b5d52f331d7bc17e01265090(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e420b780fdff2037ac9f170c29653cf6b295a73d7c3cb615b6fdcaffa4d07940(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1e7170e87663d9676ca2dce7b1e07f7cb6aad3d199184c64afaadde0630a67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__166fa14d83441747d140b0bd9be32dd0e1f4730d89a5e1dc28ac7c1bcc1f0393(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ad76bc78686cb43ae88f739b87c17ece0f29aebb01505b2fecc3c90feb5d0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087f5e9ee7fc9bda7697835e1b216e9d82f4b3e23f302ab6814a3d7a0b03770a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36978b3e934a435b756a0d54dba8670f60bfb63885a87a297579b5910b2da910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0af7b42759cd7ef939ab99b79c593316f8bb07e130c522ad9a6cbc200e4d57b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b7d6afa553a361060511b0417939696d12c16e5b7d4d1d1a919cc4eae83fbf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ef30d729e6a667d8ba5e63874d6ed4b9f027d0c20f728e5d0a4ace97446a05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8515621d8d8e12a0455f20b74f46dfa0783938a21c61a7dd1731d7c78da7a0(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f638ded61eb481e984e831c0569b9b28de72fabf4c58bb2f983ea9ce358ee662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6212c3df2e2adacb76cf58145102c7e24fb0ebc0fc89b490b0a2f363d7ede7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d69da3586c1d5297a82fd8c0e54d92edfa5c8e66e79ce6a0337100128d3e55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f5a9a60330089b774e1204c72dc2525735f1a7bfdcbeb7a6f742ab60f0632e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479425c0e37ccdd43c7a225a89c711b638b2fab334e961ffc910a883c6a489fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fbff06afdc4e61caf1ef9808cad2cf094679cdafc4f20515f0c20704c640376(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f87dcb47c4dc137b3f44edb8bf01539b3398e02a528e9f0f45a312c5a1a714(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9236f8224fade5dc7e13dc1f8dc95ba702988d0966cc63234e584c2e59e4827d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5e8f8873450bfa2cd8b8282909c976108fec64c01f9d891d0f8fb4c89d8a92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4416d05080df18769b534544636d0767c0eaa62a6967e93a0a624ec258b6e7d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf2a27d5dd7a338d6e894730afa6768516def2ca168bdf10c25be86df4bd347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335133fabf2b3684da3da827a5126dba498442e1ecdfd3d6e7293b6ee86ee4fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec533a6bd00219ed54baa64806844d036a864238548a8e058cf47f3babb0ae61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e635c71d02c7a02116a2789ac6a0b4552c8449bc1f5764fdfed638ff11a5f9fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d98880b9268ddb9fe5cb9fb298792ff54875e4600f4cf26377073de397bb7ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6b955b2e8f79e4e0065bc3c6faf5714946994459782c7735eea6c396671507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa877899c3f54b98af0c6bea77e9e4c0429eb2e7f33d2ce83e043c2d52cb0e69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d40dcc5a747ffeaf7739016bb0bedbb762d408b4896f1155e2008ea165dc40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb3d9110d97f4a0a413c59fe925c49de757a6573b8cb046adeeaf9b8a4797d8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f91b75a8aab13934d655c51813e15eb6ff2e226c207b1ee3523a6de989e3ff65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d633ad6d44a464c0bc20b9f61de05ffcf9b19eb7b3b428a73622b39b9b7f12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745b9c7529d29fa893ab5580f64307fe19e2e67bec13cec43ea2918e751e52c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2c3f33a338bffdbf1c61f511d269a0af1f6d7a6d4e384183f6b7779817e75e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2af25ed6f0adf40a1faacecbdd6fe2a0958df533e935ac688a596ea05aa348(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__827c7527030cfe43fba6afe97d5997996b093216cf6f2bba6d2d92ec400e44f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ecc9825b7957f8b1be3919ba23558095fbd9179e92dfc15fd6de6396aa95a8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9f7fec18452cc39e6c2a591b2ece07670fab12ec4af22bd207d5a15150fe2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd9f26ccc343b35e3d648fc46c0425754013723687992180ef0124afb78b590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5be84fba7bff17f2ce339b0f4e31fcdcc5d9f042b9c43100cb975a0422d5a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903189e974791c345022c2a65d9f36437673a8581f8aa33934e800687b9e984b(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b320400b401320f65a76fb434139fc6fd67fe71161cb4e1f6fd054caac3c2a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c9febbc0ec73f513bb3c8ea37368163a0438aad2a1119bd37c0487915cdac2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b71a529e6cc1afede850ab286fb1556411566f3dee546cfa5c535d3ad5407f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d313aa0db73cd0ac6ad64d98044b7a1079d8763765084843d1a7e7ccf50c9f31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c0d7c2ee470171ff3436f0bac05d7677f2dc8516fde03cc7edac7520d78757(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86aa6beaf9dedec8c926312f8c6ea730d268d4727ab00c561ba27542570c33a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7888085ba876a8423490792797efe75a483f273ea94d3ff78f2b261f9ca33966(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dbb638d23e5d499e511d7e394a2c38aaac0d1d6d51a9fd8d71efbb5e8e4af4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20cb67017c66de39efd9904f8b9c646e24a8095168093ddcab6d91d47b8d33e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c2dbfb58066b35fc63d63e6f81bb5a38f4efc4115644f71e59a60349aadb1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4264b3a88ee243b31ecc0ff59748be8e822449c254dc2ffa546d8e95d6812823(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__494c725af647fee358f282e009ed38650d0e2b1997cb971350c8311e81b07990(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f08bd185d1c10404cf8ab31ee45ca2b6be13b6b3fc63059a09837edb6bdcdabd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f6ab321451271cca35970d13f9858b3b0d79347a58bf52cefc56209accad2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d90e7f35f6ec22ae97bf584e9c529ba5ff6e6e7971abd116c68422c86060d3cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6fdcf739d8ab2c6a833a41b3ab496f7b8a12cc33bf53da081e1ff2197d3f3b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2121debf7edd6ec48d191db8b77efc64876b0d166c520c5ae8e4c03f484f094(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0275cb2511969e3e0fa5803d4f0fb99b5f81745224e6fc0671972aec7b77698f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13059e9c6b3a8113f17daab015a62f8a8fecb9e607c8bbbbab9fd767347280bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a503e1bdbdc7f93c17638523e868b88435a032763bbe886ab04b26d1fda3ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13efea33be1539009353165db7cb86913f0a0c18e5f8811e64d87f6f8ffce1d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d9cff27a3bb0a5d4ad2f3499b12a8b3bc9417f170490fde5aa459e04a1d5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ab777745d1c247f24d338b8d2dabeee0ba7737392952a4c74a31195bc9ee30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb1f96ac00cca46134325691b058816e800a9528131f2eccad08a339a9f8f9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__672cb339fd0aab33090b190d3d134918b39eaf8e1911fcbaecb5ba1e9ae61531(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ab3b886ec06f6db2ed2b8e48bc3d277c7067400f816c4024b8e2276a2aa1ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0fbb084124b706b611606836748b1fe6955dd6f255bb1b1d83ad944b57b730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85aff56dffeb67cda2b201fec0cdf9b139612d09a58466c9b5110beb776e573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9e2e2f19e9a80251399c5b96849ecdeb4bd074422744d134d591a704568e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0e662715867cbea58a64264af8aadb43f35ed73742de985d3f65f3848ca996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f46af579221548852d4d319d2b6f9fba2b26ec3dc18885ef6d621a2e6459e480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae41c10ead469bfcb50a8963496f6be92d753afe28dead4ec8ee63df41a3995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b483defb7952bd83f677f1cf919d5c77ab395334f17a16e9cbb100b2ba78aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a60a9eb9b7e4c4dffa3fd332a19e35404c7233a99970398fd4f7afdc9e0f45c(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8698abbd28e19f8e029f67141cf0cfd824a969eedb118ebc880029a438ead58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da347eb976083f8ed3fd99b926bec93c8ca1fdd63061e97ba50058a3f5f8cae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5195d8c9906094d192bd3b41813a560af97699d2e14ccbb4fb90a1738d3175(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162f56097f0c3b49de06bfb7016af9961ccc6707dae31b09698f5f9259d741e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__004322b768eee5e9e6fbd2dc0ff3a2adc64924a67b56a5ffeeaea80bfbe4b0c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3431225b2792c45265826a91c8c4f7d66c41f1c3543b057fcfd8f44f28518210(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__543e850f3216e0b22384e60974c323e1381d8e57c762fc95f429c31a21d2abe0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dafc644e14e7eeae021094a0554f90aa2f4fce47c034e648d842856d195097fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463ebac8373c64b83998691c12e5498b6ba85587956d754bed5aaf5ffea5bc40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75be4e2a1cb2861ea0414d89301b0cf5194d57ca4e1723c64d1e4267a5d6bea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999b799cd02eee253e8115f29bbdba04a128dff9a38c862d235e895c1b101aad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29f8e0f906befcad143d8ae47151d1772019b95b97ffac4d7f875ac49419fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0bd1f4217341faec5843a914f320d0244868492fc6463def4f2455d2cb6db6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1797bfe012df95985c0c2eb8864c84f32a8c70d7f6fed6d9fbce60297d1e33c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace63100dcb5209841fba1c5425e68fae00967603a4eb9ff46dc11df75042234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1736d898bffe3a1abd7a9143715768d113ad6d96aaa83fe596d304af64c711(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d67e602c3f8ccf3bde1bd88daee5300d6ce55a8907dffc4db4d954782d82bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288567d749898a73044305e32cd64f875a7d82e0bd867549a643e7070fe964c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac253a757f815ddaa59df3cc76d4bb7d0b39ff98b332e78f39d6b2eb307e384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e59eecaa60c131ad2eab59de8c326119b97870f555ddf6b45de91eced6dfda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d4711f2c7517eade6b9b999a30275786f60cfc719c6da6b9e6941bc020bcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328f398519a674f1b1e3398c914fdfb84ec6aedbaf0920ac2e9dca74825f22bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93495432d716a7f8a81364505935db9a34507185ed5e312a57724acaa599042(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf680c5bad912c006e7026d1cd013a0cfd47a2188dafb0c65e5334c50ed0e118(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5c9c2b0ff947c5c2b4785b109e9a1a948b2382574e6d0f321adc4736b29957(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27d31d604a1d3c6face0bc38e78d652518e1c43dbad97da03755d7ac73ca161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c18892cb737257e7740b401cab2173f84b5d858f291adc55816c0e869adf14d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e87b13278edf8abfe86b23452eaabdca4b550edf5c1be00580f08784f73fd7c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b32fafaa2cf9996eaa7f93de0bdf6df8cd8e1366b6bdc3693712d212125957(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c124b3ca2e95afb20e1b92995b7edac5df9924405d4567809c0f3a9e8773cb12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112ceae291bcbd5538fe62851c06d410e1d82b8bee7e54e2df13c9a792d09f0b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b77121f09ebf3168798c3e462986ded13c524fc94de0478ef1f505c1eeb37ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866f427dee67450015dd15a4de1881d4408ba2bed6aac257d7878c305553889d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66ed20d4441e36dce17110e83aa32c059998b34716c9d44ecce6a3e67809e2a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51a7dd8a6ce8c2f979658f67f16748379f19fe1c412ebd3a7a3287646ced597(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5f153af76b633364d920ce95df58ce2bde34e65dd5c28d5d81c301d8a3596f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644fa599af7f031303da87f619a4588f7c1ad8749e3f6c1a8421434ee477e428(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c7a1f4550e4e7e9d8a5ec7277341addc54aa16100137abb5b8c4519a1b6d65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4969bdea464f20eaf25b6a671b4c7a611df4c76d48ffecba2649c7cacfb23466(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e604278fef9fe837ed134c7c22623271e2276badd19d489c0610a8a42394deb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ad3321d736d2844fa941eae3075faa68eed39072ab650cf97e1d12c9585640(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260c6acd1270e2ddad0ce12a73cea85bccb664786d31fb6582451e5a0d851b33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d3747296274df3039ceb2f0f26ef6ae89fbf1faf023fde20d3fdabbaca3328(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ab73e9f012c5dcba4b10426b7ad0b209053812a7c9c5ca5e79ff3a5766cee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad2f002e8e04c2e20444319bd8d908cd8173cde3679ce82895318fe39ba946e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab12eb928e60054ba84bee4498732ecbcbf5c83b101d5242a7af8609cf1930a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea9f380522de30b391edfad0540361938633630dd614a008d93d9750621bc01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9803ff48dfb1463952f6292c0785d354253af2be2f0f544eda72adb7617a3762(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5761dbe2a7773c7b998f4a144cc6e37d5678585b88c084d20553a4754283fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b7953524911ef1a45786450ba379e3ca69d283609d021bdcc41d6ff1810d2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__481b3525c61ffad442d22c919913b238161e62f8c2193012bb4754244131c041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6abe32b75adf8163ca81fc868dbe53c7b43a999373203ad0393b2e0eca81ec0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3bc02d26dfc2b2e05a70cfbd5fea26a2a865f6e4123d1064a629db3d2fc8786(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4667173288f5da5cc7b94f8b88096ce61755640278207a42cf60eeb4cbc467(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc1e6ec8f441f0e17bc0b6376ba0d18688c9ccb292c43a701a44dad3f546895(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18e8e6fb9bd6a9a49f3b4170464c30416d923a39062350d0c7bfa728051c33b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4540979a7270526be257b66b73fcafff0d6ee441b665a5b963060a68348af60d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9256a92a3270a74f1bf57cf025a9b8599e53018040fd6e780bfd41ac281aae68(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d289c5229b6a0d195efa28f06ea73b5599e3c869985ec08bd7521898bd1a1951(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7186b2a616bb3635c8ed65b62a8deb45bf4a6e2bc3611ae45494d96bd7d3daf9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29059cda5f434195633bb60a391513aeec60050e05e6a5835ffdde00da5af1f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c259b82ab5b88e981ccbe71632260f8086e5c4f5920959b18b4c7f23915248(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd82a6fb00c22f79e814e7f9eed5b9716054274719560307ee3ea2c26c7554a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c660b85cce91187b49acfdb12c5a3615d2fe34f2ec5c9b49398e14275f9c85d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77024307e312ff17750944201a8334ba094db7a5a41088653d0bda44bf2cb611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe3faebf2b67381c7c5850c6941b97942150806703d579868c72bee9e261120(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c730e2ed27b1216d0c0762f8a6f7a13bc67c94a4ca1394075cd2a31e727759(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75af24f7c51214ded8086abd199e6e2db13d1e4e59c53b0b7df0a1e33d72eec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4febf50f2db20da645ab9395d69e1a8dc2bdf322406ffef2137f20237a7874bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef9ce03cb772e62f7639b24abacd16b0e8fe584f6bc7096b7467b391cd0dd6df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9f1ed2c73dd2a870156d2a56f4fce71199be830dd75142de41db40c89572a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0ef742ee94cf88499eafddf0fcbd69e3b794267e2e60ff5bca4a276301e629(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5812b9de612c06588a83aa05e343bfc0d71d76dcf20c1d7275752c793e25149(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b79e224d40ddf8a4cf7ceef75e0435e8c89d6e45f1a319356462fac3d4ff5593(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0640a5ea13314984f1925eb35e2ab3fd14ecff4d32c985d011c5a7ed5a69026(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eeb5f2cd7cc81874db6feaa880d1e1d26c054c3dfdbcd4c34777e177b49d6ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca0d18772690834e3790e9304e1263daf5b76a56fa53d2a3a70ac69723064dd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890ef161671dab1d2276d5cc72c4cab5fc1761946966343ec648724eb58785a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13dee6e1e636b3a155deddaa2f4c29482986531f4b789cd46caaf2179f8dd471(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__027fcdc9b6a9c8ea8e798d6501e676b32fcdbf66c9537d22a550eb6e1c20dfa7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10413e4363da4d2820643a76b5340f0b29dacd9922824ccc3cd8a0583054280c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8820abd331e659801f1486608f775bb0c924255e49198605a1082d2825a04927(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__353880c44a49507f62902e9d46e0e226769896c38130e49397944d5eca658f1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d5c6a84a657f181d251728a099b337b0f9281061cd4198b8b5be971d7e45a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b4d472f9f96bdc636db4a6eb75e70c2d80071c7ac01c738aee1eb4e7e83b05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e3bf038d3bb407b4463d9f35650191cbd1fe3ae04b6d605a81a307accefbf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d071ad52f5d352ad23d69967409c851bda70abaf7793668a0bba6e1975598b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd68b90e57236d5035e73938a6aec962f9d294d809fcbbdd40494eb250a4c91a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894ec54a87bdf3408c0b069ce505049f88177296d25a6b2fc5afc7e10ab544c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a5c2898f2c7a7d3ba6172fb6caee208f8f135c1e3a875fe05c7aff1f3150ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294039c7821fdfb2104662cc0efb8a88573e2a73319eff1f409b54d3b804a3c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e8fc9d5884a24b255ef94c33e498d3bca027f52f8e7f65694e72cf75221e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b7944c3bcffc322c64966717ea8ecbec9ec9e945d7f6c8cc7c58f6144d28f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1e58d8b8a3bfe08c7c90cebfeb3f993f871ea5a21e9bf402dea85634cc3391(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e783cf721e71230b1eb1f101285355e7eb9e8f274af4bd161bdbd6d1f7a9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7100456f0e8c4e3bd7e54705ac5bf96dd1d76c9489b7d40c9d931795036150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de13284bbe1f5a75a87709db91a4762ed67ff38444ff7b4223e828f1fda8ea5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bfa48b3d5f055c0c120e3160e8feb2420baaa4b2660f8113aaeae6c5ac9388(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3b8674301449d33d497cf4214ab72ab646e2f592798e2eb8620f837da965d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb39ae9f85df74e362d27297db18d6efaf2c9d5d73bcd1660eb7fa55584baec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c458113b56e361220bcdc934b2ea89845f863b39351fcc72f09fce344b20bfd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675ccc036b8ad299c2c7652176788ccb828d71f4f08fc5869e5a8aa78bf70e2f(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa9899fc11b41de925af9b7ab2e18a07f4eb7fd82ba64bcd420e184e0feb05d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb186533bb675f25b74efcc1843bf559a37c226b4e49a7d122b7ee5056991e60(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bd08977243c67c1fb5e23bc5f664441189e37d674084a252c69f6905ea1305(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d021924b70f2e08782fb1921e49bd402855dad136b07714bbf90169413d59ff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d15031e0666560ddaf09fa749120d3ad6db411aaa3c58dc82780932e22a5f9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddfc18174b2e505b819e3fe9a9cb806c65ae3310cf0d246da6459a5aab10c2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9694528d6e7f08343ddf7d11bebba24eebc61a7061fb2a6a65d5dd791876de32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59773781f85e12b0b8242db529374a9cb45376aae64496ba389706083f4337d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a778bd98202c7c77c35da905a9235221ed57aa8d892609c0f36d107070deb454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__608fd81a14304f5a72f9f894f409439b9a3aec73d762bfbf98775d866a700788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47e9eef1d9f439414d142d30964530abd844c43bdbc635f2157e855877602d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9870e8ab74e68bf1ce046aff37605841bfc50fadf14203639dc658689a438bfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1fd5c966e9f6e59d212bd4f2346d80b20c0d18f97f75d92086094c026f77d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b09903523a2a366af0180a36d6382480d6597d6500ed2e9e89981b542e613d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d755a5ed81c87ef1140d3e03d754109d60389f016f99d0e5fd14ee8e469c5dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e81fe6e5179071f5eb9fb9cb2cb3b290d7ae6c242ecf8d75e5ed4466065650d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1032bcf5601b6b47bf3272be9139348c357c1d1ec6354fe01d3111ca026505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978d1bba7f0292319f799fb9b2520a12f391d2fec08e4789682e8841bcdf49dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18620fa477ff3a8f2969724b5b863a422de8dbbfadf1a3b24e7c1b9fb970bdd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f2d651887bc7f4198c6ed566bff0f68573ab5bddf22c36eeabaab85b71330f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba96db08a096b8b73328e9925afc12849a85261c3f237831dae4c92a2c51278(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c81bdc7d83f4038d54b5be9ecc94a51a0fa96878ff0a847d072e8419a54471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f02f4b22bc708cb8f46b4c982658f91206e5bbd259e0065f39777e41dceba63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8ab16e8d4961c03bc92e79210417d01aae910af763d3bd2d070a062ae9b79c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57b78b6c57a635153a527a6b44449f1d558d0ddc392c9d130f6ac63eb869d80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f8f47fc5f4d95a0357823adf13e64adfba546e0888eeac52866306e979cd0c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65076807fdde9381fd978f56d11e0cf5cbc87e2a40d349eaf02036d12c5ce8ad(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f19f0a9abb43152bdb525258a588b702f7fa27e1a820e7db83e5568d03993c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b206850ceaf0e262688d7d6a62d22353968d3a21ecc8ea3b61d325716eaeae5f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b87b32418d747b492b6759411e531e35526e9ce71500e0d353d93576402f1e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343f776bd9a3553e336bfa57fc1f0841ea2e90aab25d43899492bcf27e031e94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ccc405d61c83b78de172b7a065b5d878a1da30b5607001a0ec34b2edbb12a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90e8f44630189e64bee9acc12840e2f7d679d722ba6831e7ff401c65d38ec886(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f377c3268b982e8547a1df2d100a010d5b7d967b1cce3ae8a6b7d12ebf21c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5722b178a67b663cacaee66b961fb73cabb16b05f6a4c5a62c0861475ff77db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885222e201adca3f4d42c62337d410ce44d79a2e105cda9acd1149a376c05ca6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f1fe0f8ee46aa04b50953cecd486a8772353b963c848805bfe25f3f5ba4c75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cecd70a17aec31fe1d77c544e0f2a9d064f1e31b46928cc1df7659c78c764a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff423acbf4e1a6c04ceded69a1e2b099725ee93ae8140aad883d4f4cd0afda0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9a2482883c841e228c324df1d667b28787b7af8cdf8474e8c10f03572831d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4cc4fb65d429449f4f39df2ad21893a7bf2c94e532889e912e20d09944b193(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ba7f57457274b04dcd78e7eb34daa9ebbea8265be876fb092c72eda73ada86(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957da100fd76b2b7a735b4e42da560dccb3b0e4d67267a27b90932f8b76a26ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0129d7bd0b60746976431bbb90db4dba16ecf26117b9759ebd8bc7292a3abb0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc5566a3aaf1803a573a5b6ea1523ce82310bd2eb0756eb318bc2b880c7aa3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9053e794a1e6df022aa0b9035831ea733ad82f6f20b9da98ae9d079665ca6d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884d44266779b4d9ced505868b8b75c7cfe963689351c641b21d813594dfb885(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c58c2bce2898f0fbbb8d4e35c3bdb0c6072fce85aa498470f051d7c30b3bd31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3887b58d4375b882b6f041877e68c5ac47319d4cf0d537c3ca769c23041b93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24992ffb029ee61db2a86ed1924afe9a31efd8530ad76e06424bea9f2c7c24f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df5f3e5f6cccab00eb0a4b4b3a5b68e0fe5befe26610dbae5e13659aef7ddfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2872b6a251fde4f5cadcfc78bf65474685d5d301fd723ea3f79f478ccde3f34d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06da20569dd02eadfa11971d902e5888d85fa1233ad2d97c7cea7989239304a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923516ff935f2089c2c395a71276b03e8c0743305e46eac3720f894cd4da4515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654acaa29c40b5cad8c7f6a21d0c9941eb9ca4cef6813f21036f946be6b648ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da891c350dbb468858b5234f33cb891cf89ec3d812ee42e689f96ce63d5a930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0455077f6a7631d7e9ea3dfec5fe3f173492ca722a68a87f0237d6e4914987b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889c4039b1da9d186e370509c6ceecfaf9339b07aa34e26f9c0bea272ed0b45e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb498f3ee7d83bb2bddba867c047e18ee950096ca25afc16a56216662877928(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b6edce50b7ee7c63e10eeef7fe30336d014ac85a668d6148d991704cd4f122(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b10c6a6abae7dff582f202334d7f3ce1f399b511d9df6872561e9c871ce961(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019e2df045c3f5d6b7b6bd181a7a4f7699320df1a458628b71ccd41b136b77bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae91d16466d1a57c0a4a5537a46422d025fcfd15260d070a1b9e14f64ea920d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4cd1d1cd611b237faa38c434b7a94b2af270ca0b098873e047cc444ea46afe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9924f89e662c0e0c23674120291a83ee4e4496bd53535aafab1d645e029adf66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8e409d8c5af2f57d3c7624620bbc0e83967caf4e884bd8f962b926e99e37f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71776b3e5d06a764396a377f72bec7c11e37604a779375f5fefe6b54ebe4fb28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b13bb8d7e5f4a8d507efd3ffb429583da919fa462fb3e184362ec37791ec3fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d92eb673dcefac3d3a27691bfc610d8ca4a2d7f634775d4b9ef295cd5c19766(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769c7e9e107b6d2af2c977143c3d7d7e2a580c24874fc6a88d1732715ac69e73(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9fb7115fca8fa1d7609399112422e48310334dede836aa5bdaa4bfffd7fd6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358b5ed5a945a892aaf0702a020ef9897f564903d0d94a9c549c89d7e4a71359(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669be711a2c613927943777a1e31ac511e90eb6ed9def66427758ab74013ca54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab917d3191c111a0387436e238e020fa8c764cde64583487e9ae59bf3f41543(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e4a463e10298bd7cc582e358d19e886e76b53946d0c69bcdeaa0e51e27038f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b87227944a848c6ba1d47d4b6e0cdd77ad3aaf21fe3b094decf84647a9dc890(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8646cf2624d98e82f049839a7dbf258efe2f3fb1dcdf74f302a5a06c567ecb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7277afbd3c6c9ff2572457552726e40120f2ddbaa814c59781a2aebb297ce303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cdd9b2ce3ef2c4bd6a21ef0773246b277a570b0108a74eb5b4267b8a4b528ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acf793811b6cb2ebb8b7f0b833cff6f4f143fcae38316ba4610c4d0a7fca9c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e66ccfd6b8943388dacdace3db23a0d1e390cc2a479ad10777ba26daa77586d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b5a9a887772d014e09546b0159aeac61c9e22af687271e2e4a99b73dc33cd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ccdcffa64324d8dc6aac522108221d9c3ded83bcc7f6fd721b4c832256a355(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd37ef49922f352abc2ea3102d0c36060ba4f7637a8a924d1cd1cc6f8528a17(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38da0499c23853a2ba8f741e661c8b088665f5999907fcaa1bd60f86665ee6c3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf95bea8669f2e7bdf49f519feb37e37edc21f9c0b7c6702b102f41a7754d4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a885422f563900ef0445d1bc0e89bc78e551edba7cceeca7dde3e2203150cd98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17847003b61ca584ca24e898791888caffac05c70c55c5bd915bf2ed904d652b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3f5c552c5975c58fb5c5248fffb71403ffd071fc3e8c277e1ca7a9a9f93caf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eede8698dd1a68ba7272dc6e95bc3719a3c59002974244fc489db18515540376(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6aa200890ec9baec734b3d10c86319b23bdec846a82d2bd6ddcf1fb5e02bb57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f90305eb91597fdbd97c96a4cf8cab520776de7249317a0ba4c1e9350e55f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b4ff0d43df4192d3e18acf875b0587cb2709e1e2bb8b86d90c1d344d30a2c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb42c7bc29c0b111de5e73b5e97baa0355b35f47959c9594d5029f5ea91565e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108f54336e6d64a4869d40b06024dd1cbc367bb3a37b7aa2c6f682df323875bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bc4c680d22f456ea6da561c398a631a6e3d065ef87db350b91f3097b203734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ca732a6ef48a617abc164ce657398e3ad605fdc7a0f0c0f6dbe3c206380bdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ea593112c4f421e30dc299357aaecc5c331ed3eeaee26ed0479bf833172b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e44c25519c9fda82c0553878b7ad0e9a662acdea6ecbecdd79843dd8ba844ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee6f5eb3f2b3bb27249c5d04120682c6d896d828be97947c63a85c31ea2c447(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efc4fdd297c36c7b66d247f7da9a4c0fbd00512a241d003f6136fd7f86582f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8207bc3924e5fd826cf820b84fc21c1ae4286519d0be87bbff0355ffd3cf9b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49b058ca0127d80fabbb6c6e6dee68e51df02e5efafa72c2d3b9cf1c108e615(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815700a974b7bf09f846bbdb275dd50113b15ae12d8007b3c2cc252704ebdbef(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__638d32b39094adea3a04bbc58ab9c84518c68e7ceb72c4d0d001248dd6594655(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f8c89fbf6dffa6cdd7902106060f54026ea7f069fb8b578313b06c20012fa6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c2f12cde5ef7bbfb847245c9920485167e12a5fed548de08ed61c9afef99ab1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59a42d32ace5e257bba707e71af772d1103b822e4bf8954dbadefaed4aa5149(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f07e01a15b8d638e890492492293e87001c6df554643f177c74261aab1ef33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642ca7136492217b0f337d9ac0e13890f75c4ce53588b26caa104909e1811e01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f195bf9f16f2ac1ae28af985a1c86dad5138e040fe09b35dc0700c837fff08b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f312be2bc2ad99ad880eab15d0980eae78dd62346619725cc17261d48c7830ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b845defb5f21799fdec3cec6070108f0b145c4cf5271fdfe4901729b6b54936e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fc0d7afbb3d5e3f1d827c632c980b634fd70336b16ed4812a44a34d97beb55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d8b9fdbbb0f6027b54b6b9e28e6a120265eda0e754664349eecd0309b84ead(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6eb90210031075cd70ccb11b4a9800265065413dc7ff723e2ccbd1b27f4e846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6b38cda69b97518bac9972d0b3ab98269afda8160df05df33ce1d25bd3ac5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b84e5ed13a9b3579fadc83f92deed87c764119040b70161bf3f43e2c1bad67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b752137f955292189f5a12305553e4cf226661c9407f5863117db44cbbf0c633(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c57b87241ec848dc29b93a6909125d971e59a123cd20145fab7f6e0c40faa41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f0c9d122d91a6ff939607f30168ee1d6977505b0c9bd3332b4d9bc08e96d5ab(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80a59836f5813524dd90cb9651a7300efb241faa3a5c062034f89d711275a28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7df7959a7eb3c7347f69967b9daa305cfa9a9e211c3b46b85cb07d44361ef4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0c7af368db48c2d3bb3d8810867b65c0c389edca117c228b5ae08140a07266(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358c6790cb17e5551400996a0f4c9b9391db77cbd7a364a03302f5d6d7a3b7f3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6897021c3f5fedcaba959c36dfc8ec90a74df36ea1831fd5f41234992c1d0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a9a3c87f6b3c99293e51e1e075a042447a7ecd14a14de25a6640bf24f5d58e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ac8bcee347c95785b45cf10011368877fa3e0f6a4d2f3bcc8f66a0366ffd56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb35a3754b587bae8c1ff895d99f46a4ded2a320d7307c5565d4996b06a9ac39(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3babd2fada60de9dfb9c39c54d7d78e0a33f9a88a3b34278bafe664dc8deda57(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e16b5de1883727cf01611f9ed6a61d0784b3f21b41f7ad00273f1343c46c30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555b43beb38977bea7e3c0da85231badca65deae0a61d30e2c60e147195ef397(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cdb7938695f7871ed11fc6dfeef5314cacb63915c4ca6451ecd5d4df0b17938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040b5a42dd02005e8ebf8773e3bbd3f819373cedc4e88e05f530df7d77094b34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f621dd0fa616ab9b284603093a6296916ce4fe834ae348003b8b075fdc2f410(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c14ade32091de7c1e55fd332ebc7bce2ac23c93ab6cd5a70da401c6bc324dde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bce29481f31d7eb7235af03b71134fe7365698e2c1ba3bbbcc23d0b65d34b5a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d47a96360b8356fbe095584b0289951161dbbc4ba06aa5cd2e555506b24719(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf36d5f61dd3985fb09147f33257f478e71966b289f7ab5d70e66c4b49347f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f63733a9bf92cbc546df29245ffe189f062db65858478a0b2d753d0a2c69b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8a13ddfd6869cad53da7821f47cefe688ed1a3b3ff745278361c2f1e964a4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b0e8bd619a53a646987a81eb244c1bd0e8c41463c20a6704c3160f3587c15f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af57c62c6b09ce17c708300a03497b3cbf9a3226ebcbc6e72d11b34f2dab6ddd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c109972fe18dbf2ce8a849e1d177ea5dd9911018f0fad5e64c000cc88cb34a43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7548cbd4bd37662d164f94194193ae6876f99a6e0446cf9079555d33fdee9ff5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23beb2910c4f63d07233b6e8780b6ae437c7474608758f624355cc525ec6309a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7994f31ec617f60b336d87fa10898f80400627294d5e941008651b282792d5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e6d37fc6f42b743ee22240d4c3a8938450f1c9b729a13b54f62a6750f57210(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcddf0dcbd2bc0828e4ac939771bd8b80525a46f36bf332128ec1a1a7e6d7621(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e9d1375d0bab312ac7966ca7c1dd73815cd13124f1848265e943163f182c3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed73407f7012262f210e765ca934feffcae324be26ff53f764ef2aa0856aa040(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37fa1c9bff44cf2eadbf5cce25099314fdb14da9f594d4bf35e23a6444cf0189(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e05cc16d5d863b25aa6592aeb21e328807792fd75e3fb7f5d05c31013d553c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6563f2340f60b42f3eaa0916100b238476d2a4295675cd981661714dd3450924(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a66b8d5a30482accad9f107c3bc9e394f605a6aa84b36d0dcc2079f865271e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a392a8a0a101728294c1df703f54a45052a8e6eafa47f114df74298d9625cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86f300201ee75917b1e1f36d0b7d012aa1c2dadc927abb24e2292e415284325(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4bada1d052fe69374f0edee2301e4cd214c8e93bec2d1efdd2adc55f328972(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b49a0637e684ac8af81580b1d5b00f25944792fe3280e1741a84a88bfb4a52e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a8c1d99fbbc02e500e503175dcb14dffac7e5bb693ee4cf48a7406941b5727(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3beeddf857817240dcec4379a8848e5da927e6b289a63d87a159b1bdfc591723(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35d59581b6238728378d535f1fc02279f0b36b6e7e3d2af3b2a0c9b7c422cf7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd888f53ac77cfd8f434cd2ffefb86069f2c97fdea267388f8d354c4a051019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4d871cd123ed047451c9cade109d72b286435446dd693292bd40be66b59ca7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5521666ed9974b1a2898dff1e1d6e0088acb2a41b6590f94156845aed17bb197(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0924522e236b215b71f2253808bc4ac553c782058ddd72468934b5f1d1f742e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ad273af26be725f5e103590b3acfea3a8628e2ea36184cfed4ac5c8a7b1eba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90e7ae3435e14d942345618e329cd1861acd181824bfa5c7f8da04356c4924a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ec83ce3c4d89f5958cfa58de821442c67925cfd7b42530018f8ef76366dcb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08b34437f83cd36a0b1410bdf8ef4787ef8a70dc86e1ddf7cc77ed75435fab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05567166c88c769217f5c6f54c40556a5ff9c1edbcd2c52329e94f2b6d46c317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eebecbc1dfb38d6513a587d9a02d357c25018a153d20c0aee6c71c9f79ad255d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7951ea3123347710f2bc5b35ce0d70821e759e3162aea851aac976501c3400e0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d8a699cbb63d5940367a5f1d368c7fa972bc9c333a099236ebcc24af64d5fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2689ee56a6677e06885ee55b349d8314c4c542d2a39647fbbe808177829308e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10106b8bb1a66cc209c368859c103edfe4e7ee17dc8efbe52b3d7044d82e6511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d4a18bb7f90310e0e26a38e754f8543a3e893745271a6c058051d996d186be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee13388af9cee6dcce077df3ca7168d05199bd8740415eb816f2e6ee2d7a828(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e25d9a0a6e43eed7e3a82ecbf7325b81f01b3ba90c11d763edefa2030ed6d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6554caad0005ec1e77ca3aa2288e1a13fd60ce5341fea518d3480421b8d6e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db04a9343e174575a020561078fa04c2a6d82897ed5a9851a770327d9d1c97e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3036f9690604223c1d280cf7bb70493d52689a212afe518daa5ffb011ccdce4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f2c3f14f312a8556dec6f321d6a19faee4cc645e1f63999caf1f094e52f0ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8bcdecab8315c14c61491448d33ac524a3059e498567c7ed16d0cae0e93cdb9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8cdf98f5a83c3450e6cfb0de0fa48557a393f419191146821f955ac2cb1ffbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855afa47872861bb467e937ec069957304ba23ef42708abcd84e3e416da3e427(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb9e3b19ebcb62160295f242a91de147021341aeedf22027507d1bad1c99cbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c655c31670d3440204824fd705181a719b18328d083419fb0aba245b12b96a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc68b7f0e308f6d85d95e30689031bc80e4c37124d6e3638d1c73e3d86eb9564(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0df500edabddb76269946517bab277badd2c9a7c737258929246683e9986160(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe12729900c823da1639d7ccb072da2b92153e07e79cad0d0622c216567295e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32240a8f3c998f822c3d9459e8fa86e9d922ab72e5adfc436818f15d38f9fd40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abd203d5319866edc0f219ab8acc02784ac878d70c46615973b8b86b882693fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7803b673c93f73d18b6da5836edd10a28781600c01a15dac770fbe5a303a0bd8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2bdc4145cddcd5e10a256fbb96839b0b0c124aaa8141b4152fd65215d654a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f47d4d7180994a67f901516050acec7bbf902ec4e441187066ce221289e562f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e2b9ee9c9d17ae53995a425148295ea914b447025aa04328abec82fb91c609(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7b0c8046d85b535ff6850e7408638f8472051c9f679c838d90b09250b0781c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e80d3533efe80aeacacdf4fd612e5b66beb5e7e7d1e17eb9d888c454f1eb84(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3df6383fd96d123659a34cb59f1da78e4a59922f336c1fd927d53bf9f29f86(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65098b9c56cab24eb318e34d62f23706e437e062146abbf75bd9f8477c6a53d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17e58bc0030de4a5d2e0104647f252ed98a155de82f8aa0ae9cdd5caef10c87(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871ce9373c720264ef98ed1141dc8c17aa38210b219b5e3f3515d15a8c08eba4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e216afaff58c678765b9d50795524717392c245dbc90e65ac135a54d88b6d798(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d43ebf556973d31baf71cf7317a99228bd02dda59eee58e6cec5b3d46e6a41d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e44e4681136abc990b8499a0f186c8c74d38407d200297cc9ee362bdf4e1a75(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93f3927f49c95e4179ba73312a2bc8d9ea5b1256c2a4e8e66b0c2f821f0121c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181740d58fc1e50d974b1cdcb64325b56476181449d7b5eac401018218a7c118(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3bf9109d6e7952758d1f4f8cde107b18a307b96f6e0731e5046605284b96b9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf4f7a9645bc519e99a36f4bb38eebbd3ac436c55e3a0379da633d179815862(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f5063a4a6a6f108a89e8ef4b45efdd240b4b0843f391bc3aa16e6f43509f29(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c272f476fbdedd7e2fe7130efc9e30ca1724100956c84d979ed0fe1af8ed29d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90bc1c545abd319b89a0cabdcaa14f2da14418cc47f617fab69c7558176edc18(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012cbb2381f5db5af6a2bead786ec6431f8ebc394200ab6e854e3cefa464122c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800a9695ae7da23844a03c9e690a5d317809ea90c7d59b14610003a0b3db7619(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f013517dac55f0a8df40e3473b07779302e4264c6a9a2f7a9cdcabbc8d37df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141ec74ed71d04dff1406e9dd3f57aed540f5d9b4d5ac357ba8a23b12bcccc2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7479b864a6e4d9c418b5cef43b2d9c4790b5cfca89605537ea728bd82cb648da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f5904fd51f61d893e3a4365868f0cbf382a62e202f69ab898f26ac634773dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279a2d0144203dd6ef0e5a0afc48a930ce62612556133099625a9907e553c176(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05a3901bce1bb38406614a00e14aea080856f98500a571294e7d97625a17918(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00eeb29516fb8a638af8f7ece4763e7f1e82afd906d298c24fa0b14b403a7f29(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a1d735281a3c6f132788a26f7f23f0f90041228bd4b64c6a6a491016ff9d07(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d9cea98f58a9bb308eb636b92a1635589a994d09b7663fd6f10b5bbf4621db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08e975a1e7f2e929102c733a16d766ba5c88b7a0f68a6300c7840b37db4b5f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974cd3ed8dc1648035bdcccef005cd0a1afe915d5e9e2ac5b0cf88d2598eff87(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdba9c940b20104eb756dfd3bf8cb485c36c9ca027a40a66d8eaea2b16c2eef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711862abab1ab80f0b4d250cd0b6f7db9ba05394bd9cd1e258afd1ab0959cdaa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7691d1b519c22d732987a397153a7b52f999f9fb8d9876960f3edf71748fed4(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9373732cc1910c3abe845091e0191325037b89ee9cd7e88ab285c28a5d59dbdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2901dc9035c0b06d4192c332bdb0a668790dd941d86bd627d3b4be1af05558cd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351a4a7e2a33e08150d8efbe7521ce4593878cc9e2c3c4b90353712506b94fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9383b43cbc3e54d2c1f6ad2de5567a4be68a5a3ee68f9d56cbf8bdf414cebca8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67879de032b568534055b7b29e7605c9c4bfa166ee319568f6a3dae14d4f33be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271f9b076668a70489fcb0a25aadc0c331effb01ffe1fa560afb7217006f2c43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bed9e744ef08a218ed23889bf61463887e387cba0d7ac03718d54b40caf5a33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22a48f407af871acc45c91b58eda96ef2b238be77e86658010a420653bf872ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e12f0bbc0b68f1229b4ae69f3f378d22161613a3a789cddcc4bf174426f424d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5839becdb1999436ad185580bd09f4f14cca556c4097ca2a9e27ee1ced7bcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f734424260a7729e8fde4082decf4fb456809374cd93cb46ebd508c65c8e04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd31847a3ba858bbe304c000d65d7e92cb0fc5855cffa310bcd48ad5844ebac4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a687b833a8f2e48f3c4181546a300b90b9e566e1da589208c2f8a17d22c8a788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec3a7764b6bc897a9473dd66c4bcf8e09bab40f8596736e9b0d233a2a5ac1af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba820e77cee569994dcfd4f0673462de86cf9cf2a564ae62aae11b8258bc15c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac417f0c82c5377ee20645feba63f9a9a98904aa2cecf443478a48f7cf713784(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874244e238aae7f9f43ccc665a88930e384348fb2aeaba1f7396a14db4365d1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e97005febbb8ebfc09f815bf8c973115f7f350559b56817cf3f670bb530a106(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8ab8976591100e53e6ee621ab40c6c6dd00bc19f34c5055acb7aa0d07b02c7c(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1fe439e8b7840d9df5089a886bd69e814d4d7e6a6b3f6b369b19063fd8b2b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb55e5a87f5c5d190159b32727a0518870a8226df29b2a1b6f8c02decdf63ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de30aa426b72928e2f0731930772a8fa186e73fc029b1db7727ae8e15aeedec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e98ecb41864ecab1414d04b89ef33368f1ea5a905124213d5fc9f0c93f136c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bea19795b85a2343f871b04a6f5b2c8932864fb0bbc67073c581564addf527(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98740c1640546132e9003d71b9ccc5a709fec198a205cd05b7b3c8acd43deb81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970e880c2c869e7ba1102003c48d722f75dcd143b3490ec09ad16902ade82408(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7852167b4e590c395cb9fdd986ca664f68655fd26ce40d7fc19bc4f22305a97f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b924471a75fc3ad529c6446742a0d005dedbaa0d8f391e821f0a6a746ffdc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6eb5e3ecd5aae98119ee1cb2e27eb5bd35ca66f1a509079bf9258452c40c73f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c367a28fc058c69c4174293a45cdf7a988ceaefbf0c897203d29621cbe4d58e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c417390d249e88ac9707b33cc407ceb121f90702b40d051888c9919cce7642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab36bc4c91b443911f07fae0994da52b4dba816b092bdc052b288cde183b9bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9593c331c27f6ad1d687fc0fefe093a712d0a2031356ba548b0ed9242c4c2c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68594d2ee4907e8e5e901a9e058f8af82d6cd2e5ec3a3f09d75bf280965117a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a66f11007716e371a534f6489243df728f6e2dff9f061e6290d4f29e4a28c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e0f4cadc4e06959e5cd1a0f9961c2da4d30709c7428e4e22a2bd32d1ea7c233(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad80a89809534a515d3c4a9fa9a908e2267dc49860e0fc7613a955752cddf035(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204485192a44ec25d73548a77febbd51d555893ae9fbb3ffc588c9a3cec475e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694eb9c5d0f06aa1f91a12c07b91a0aa9fe4e0b6d46d186e33504687c022693b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9ee76e27a217f60a084d3591f61473b37d11f0eb0c38534601e91692f7f538(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b873cecf6a075d4fefdaaf6359aba8b9f3cb651d03852c278f86e85167159809(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6587e7ca2fd37a4428e22b2c0ef007d916a3af07aa76f1c62bf9ede172b36b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9890727cafceb5638ca2e5866be1ccb1a80834bdd096e0091d99995c9cff0ee2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7299e213b269e46841db0b27b6bb55830dcfff22b6f1f50643ea0da0d5f0116a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970bed297f11a713cb5c29ac8047626cf891682ed58555abecc68a052342e4f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebc5a402fd146ac7e50c221a4bcefdd996bac4b3e33ef31a5f066ab7dfc5a5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8ac22cc7e740ba39b42dafd216e25eab708ad80310aabced546b0f63073fc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c93f979e1c1aa2ded6668dca44c8ef0706f775d695b738effff997d05928e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60be1521ece58f995496ab48c58ca037fc76066d779679e3d397ffc0fd3a798b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cd4cc592af9df95601af7da240234f2e9c33fc3d5163747265d7421e023f2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a58290f38b6a6cd6ee30548c91eaa987e3fec7e3f788b117b806d1fcb4f3575(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcba1c29bc508fb8b8cf540966ef2138dc90231471416b7856e2b675d232b1d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e920b65114739cf43e409cb95090b76a42bbbfb378e1231e3382e81cd71426f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029af152b7520daac9fe3706c4a46082d97092b9206280979740a8bee6c93cd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06784ffb36adcd035e7c092ddd0b0b329e82ff58505da79ba479a78fc30bba3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4de2111303660f73bdb3f88a45fe673820f17ca1b96007584184a34a3f337b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a5f3419922f9bb553778e3d56ed39c3b8d8d66d16e3caed09b2e0f9c71d009(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be7d0ecfb40844b344b710afcf605678a807ab5c2550e574af79b0c990acd717(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5cd2170bb68442b9d29dcb7747afc7f91907d54c57dc4cdd4b9c1c53b37518f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f19579970ee31f6da53df1762efc4c08ea42368d026c3e2c565ddf3cc92b788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fbf2ef374632cc9927ea1aa182c91887fa4dc18617d847d4fac4bd4b11e5f3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9dc1e97a6235e772898a4a27646d07396e68b4fc21f74a3b6bbd2903b0f809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfabbae8c4afe62d98ccee1f54b45697f36b1a766d1631cda14d32eb6cf35e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68958b526109cd4ada84faaf54ef8b35abbf53ca06f5b838eb8c01e52b6da903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbaabed79f90e776333208a9fd35c904f2ff29aa7433040a47a0371563454a41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8206dc080adf0d4f4a86a12dc2b7f37b48798948bdf67079b69d1a1050d86722(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc533681cddff983da7c464e3425a804a6bd6467fe0147991023cd8c352a269f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acca0dfd9a8270371bef5454821a182197a13cad8e18a38e48d64a72a652f2ab(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ae553bc926523f8768fc3b96b5cf8071644b3e6ff47c450ca6be5b27ba80d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3967244de7f6418d4b89ce5343b8e2936c7a3372017062767007b057592d085(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ba6bf9759ac55586620a95d9ca949eaf4d6c21799a1d5f9501b7430a486fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f277ffe81b92fc35779fdd702e9ef137a40b73b357ffed656e677e30de11efe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2aad9ac3d9d380468395b59234aa02f184de32603f61308cfdc8e8743d69d99(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03e361a1a3d781e15a771f5ef33aea2345864fb884aa88ada3ebeca3e7cdf22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9bf16b44630abaf2ff5f66738b778cd2ae79b589c2b5198ef49e50a00cb2744(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a348d08907c3c9c74a90dfa44082b19fd681942717a822190ca94140609e9664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9261946ee3cf4195a15bb667a33fc44675e10d3494bdec093ffb8eeba00b9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808620f5c01180c204035a0f6502ae614e34000fbe65356b79c2e2a1e18a2e56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02213b372f4b7831e51677cd9e3d1b70760ddf6e038e742d6bb2a0beece98e4(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338b91dc1c190fc5d830a81a29ee846a21c1f0279cfc3f7250a3cecbabfa7f91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d43e41e9116776ba9b872b3dd2f81270c651cd0018fefc44167ed902f936a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561d8760470370d0c4bc75febd538b4256b6c3c209bb76f6cdef7e72767ef172(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107bfa893e2e171b248e40da19effbd439f141a2c2180a330dc60e9b51250bd1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e6f466a85cd6a3d728c62fd2c80bee2cba06ac09411fcd0ebb2d129bfb2de7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50dfeb59c1cc1de39d0860dfe18134401b7e6c537afd2e8dee4e4f0b232e0aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6b379a26d4ca4fc24444b76defe7028ff872f1418a50341a34b7e818140538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41121642b606f07639a7feae37c672cf1219ffffb6dd173d1f74028896b9b772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1d2a1ec6acf4fc966f38bac354526ccc09c2ba594f8c535128708760d00914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8733aa6ac0e98e20ffa35d7f9317f06ea6c29a87d955ef48e96af4821157be7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8a988d5b61e976834293aaecd7e1db8614dd9824dc6e9675d6d98d8d2c1f39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270eecb28b404057ab8458a1ee075addb2802f099b489d17ee7cad61febf9811(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348f03d3add342b70701d15d8812d84a816240632959e2499bca5d5d401eb605(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64d4a5f6c2683b57f4651cc90c623e6967a57085b74b1b5685e8eaed0cd81c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e388f08ce847f3fb8e0abd41c7159dc64e418ae16d7d793ccb91a3d5bf6eec9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b311d70025154b7290a781bf9bf0eeb93f5df9ffe359def3e287e373abfd52b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b0918dafd11002c1b7dc979e7508d8b58168f94f6808f1fb8a89f90df3a224(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6921c3690da90fa7ea77924790af184a18b04538c0d41fb5366626b746cb037(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de714a78d6b26d7c80ae068be36464a62e4c870da0810006948b0ca859f9c05d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6737f6db0170975bc2b5d996234dbfccb410ca6b12b0bc3922413ef1c3a59358(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3edc6631e0eea749fc223a9692378aaf8c79db8758a7829bf9036c09f4761253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e241398a792562e6e3e4e50dd193772a7ad089f62f41ac01d9fe41a77f77ff43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7049a37c94ec1e6a88a17ce118049faa026933d65f458ed8f6a27b346d04f88c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2079728811dd42b2f6105ed80f7848e80d1d6c2d34306c0dbe2e0895f94fa6ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0741929caae962ef0cf309fd2e37fd37dc7bdde1f0759665cfe95b969829a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055c0431b4a634be8d9b98f333449a7f5fa738b6090af44f48f85cd35ebc2904(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e897a7bdf63d66dfed78f0c8962a2e60f3bcbda493178e3dfe69a9d8e97016(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c149ca569300eecf96127c66de31b93ddba208e21bebed727d0162381c390fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f481cb206cac9642d4c4468b48e7dff323e013a217d7bc7fa320e11500cf475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8556cd577b8aef9ec8b2932ceb87e22a147ce5ebecff8ae128d51d56d9ce72e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b2a87708e02471a8b708ea0741b8bb1725e6d809c9cd1b1598d3b7bb58d9f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f59e6f979c351a63951b66e250d0b1833c54fe9765270e65f8772d7952c4f38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee54d2128806da4a0edd2973e26384485852858bbfac731bf570c66206f4b8be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9478f86cb71b1a0c3c7ff27dc642245211e841163944fdf4990bd0f1a7aaff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfd0c34867a74a4f08f4247d5a478cd49bbdb016a827e37a3688498e52ba646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26bf1ea727018a6e1ad2aaee849497f9e9f0fc9ffe68dbbb0922b3ffded6c4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bfc07222ceafa960b30764be2dc9debcc4a424205fc9c64f8269a159e8eac9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d19a517dba5923938c2dcc756a9ce683cb71cc47e2325ed486d99ce8c6e0e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c87dfa5c36ac686bb1e613bac7a3ce37c7683d6f425b696eef75e134d3c5c1(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84848bff30a8041c1e118bfa070d64d3c8fbf2439df21a1682d37cd4ac4e77b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56eac269248a5eb97cc535a07087219c29260ef1c9b75377b2603a5cf85cf835(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b70932afba3119fd1b517f9316c350b7b292090120f584ec3d9291d6d47b005(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f864d4a1e664e63a1d2b7df49f2a12008358bb136dcd064e7ec2409e0b39ca26(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f585f8033f12c3cc499cb14e60a47908d578344ad715d8375e8a2419bace840c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a37e45ef667dc43a98befc22488816e36bf9054ed8f53fc3d9cca8baf656865(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78a4c726237e956fec13a6e86eccd86f8237fb8e47b822efb498c96e9b55f18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7814b69a1ecd89f067e9ee5e98c2f4b680ffce867a8c28cb519596ffee274cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3192726687adc09d45a338d68c2f65b0668971636a64df83f9439e672c9c6d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302eb32c2828a22c946c7a27672792a0ebb6bdae078bff507152e2bd7d7026de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba6107f9fbf60381aadd460acce546ee27df48716d235c596b72ae9dbf9a4c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5a11f3177e6adac4cf70b8fd0eba791e16195380a4dc32a7911ccc2db0439d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da72c91b4f0a9724b610f65cc1521272d35df1244137c9a0084fc3e462e16f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221baee7b8ddd84765041d13eb78d71443b41648998bb7368cc39ee1f4d7b0bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27df9d17d7b5bb21b2b9cd8370d5ba370cae6b35edbbc6217b64d5a195da9a13(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47431f7326e444f114d89fcddf4a7283df16f27c955e1fd520795f4c6a07ea2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca3880b47c72ac2147e2d4aace942d238274cb1a12ce63adcd9aa584b534f94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd755f5af7eda6e9ef6cbbde6770d0e06e13ad5771fe0e9c79721c09ee91ac70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc5129cc389e0526694f8e501b3f5ec829e9220d7a6010970f42f62954ae8f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732b5264f44aed90b9d4b91488ea40ed380defeaca318f505d2ac08d5ddfc2fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44139b9a7c50308f1877425af6f059571a0fd304bbe4b6861f929f885674a7a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec8d19587cee4f1c892ece3c724e439032ff8f0c09176418f78a89aa5e12bd48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2e76e536aaaeca7041faebfb6c8428ad0206a6cdc0c221eb466d3d8b51df83(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e06a557c677df661a62f0786e98fb9ff1e08ee158a09ec928bb55b666464f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acf66bf8e11e20a7a66f740ad1350a40803ae3192257b3c5b34ac2181381a99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1d33d16067f101c5790b93df8367871b3d940a8f9b3d5b41eee8679b566437(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8bd48b54426ff09e8412f189dae7435115ee566a73c07b6c6d8489b2aecfb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607a99e85e3c723d8a2b46b9ab36a9d3ee8f7badbaa25998f0027e8c8b85774e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0b6bf8439c8e294f97e187f28f613397f3e59cf4de994816458562d50c993f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db6ad4a1d7ce54c0bbee9ce39cdf2212c36ed6cb072aefa4415f735dfc1e3e07(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab5fc52535e15914449a4a79b2f09e7dcb459bf041fc60c29767c0c1f63eae3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f7004d5de067f66c21a0670cbbeb5c2644eeaad4636fb8b992bd310c1db0be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7e5e2ec61abeacc4d3d5e68146baaf2913c4ac657618506d1960b3e514e2ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a930150c666789304b2dd91ce005ea14f54f8c0da2dcd88a1b02e4dbddde9f0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28345fc0ef18274ab3bc8f6fc2fcfc6ced86e54e99302ad77ca4e14fcd39e6ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87943979c65ecb658fd8a4fd0c87cbfd8ce001d8941a4607ae3393c6587388bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200307cef3f1477e9b69e3f0da42ab4b92efb2b5cb20a22f2b95387d1498c3ed(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a9ed69dbef3e39bda576c99ad8b0650b6b6ff4417dc701ed5df4dfa11b21a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9cb6d3f92ff066c7a31f7094188dfbbb41198496c986b055907c4a97eaf21f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f31f40a41f717a8211e1e169bc9efdf2d9dd73ca37f6fdaeecf4d269be6d4141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0064e001f8525dd889a4a34b90ac725e1098daca52f5ef304151e9ad62d7a961(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e84a092131afa98567e59229e3289175e44bfc29797a19f17982ddb387d2f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f8384737018178a32b9f365a82f4bb17c5963cc7623f89c10139ff183fb284(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d45a789c33e2e5521babc05186307cfbdf3072bea66afa0e184ccb94712e04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c15760bab83ec74b4df663bb1d51a52b4a8a2b09b019775eb071fbd29ee732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abff007efacb1c515535ee037eb4e06b81d7da15ab68f3bae82a39859ee44c04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4333e65d5d6985e0a69acf140a12434feeb0fa1c6de68552f82040f346ca9413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924bf94b00dba68fe31e81b667e5ba9124c070d098979faad190426590b0e7db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4d8659907f5baabcf8f26e8caac601ffddbe1df49590c6127afab87ea7e748(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c64757cfed73be4717ff738e2222ed84e51290f0b7fb336735b82b40714a3a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4caefbead836d4e3e358bd8f7d75143afb4f33e9345aaf7bec096ab9cb8dd12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faefacca505d40c2ae59aa27d75f920aa7f91418aae06c613e38e7fb45d4b42f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9254f1c1b8f487e84ef7f54440c1eb8252d14915cfca133dd3e252f5f47dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90acb729641eb328354ec04bab88de09704ad415ce44407ede21f7dfe8d5b007(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26be2fb36ba053508562fc63c3c66dd19c8cdec714fe396f138bb861488f5a33(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2dfb9ead40b7df6de9671232518edc6f71c7c5c86704b2a8c35278e8e0cc6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__009262d722f128585ae9c2c4c5840240633a14eaadce2d88b1e9c1122c4ccd5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__437d52cbae5a149a1902930fc1012637a468da966d9189520ca58d29c3b55aca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__538227276d9b3caf4ef97522742111cc3cb33bec8dc9504992ae7ece8baad907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5beeeb358a56db377bdf2dcb8c21807d8165d0be873044d7e627c14922f3808d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e62b2c263b951e14e48eef301d0f3cfb836f8e78beae3d9d55942ed47eb7a8f9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826c59eb67afa8d17414efa32910f55c68267517a6a9632cc37b8ff013ccbaf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa116c91aa1e01b5c2cb304757d65c2088eea30d11e2b06c176b64dfbe71938d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6652245d519ca2210e9b4ef1d061968c184a400dd7be89bf45e5207a98f394c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d747a4abb005ce97fbeb1a2a66390dc6d153bc6ac6f26efecc3d05d28f1ef5d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910db550efbc528209f69497c753d8673de793887da329d69f1d60dee93f6ce6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1540cfa4bcd73ca736106824a56b1521e8e8dcc7a5f5aa8939f81c4ec291ad0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2759571ddf3ff86b8cd9fc28cc11237ecfad5c449d1ce892e5933eff09f36b4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587b6d6d17f899522c815a869a0f9cfffa18b5a8e664a6d24c423d4c8d4fc37b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2d9b8ca71e13ccf4368e5055a40de40ab4a1bb575ad6f7916dc53de687c060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf7961f46ce4a5c8a836a3f39ae915eb0a29b4d3a31991bda7fa3ae116b2cd0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd16bc63285eb3662b9619f8e266fa82761fc811607b1b10e7bc372955f10b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3299b1cedf2cb95114dac6bbd1fba38b75a29de8ea274440833c83f24ed0bdb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb0fef59cdebb71edfae5aaca8a41a19f98a5491f933524e8f17b35df568535(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb955321fcc47edc92832ce514ce865f0639259cefee8303db22d5511cd543a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4253e73eafe38cdb6e8e41efbd6053bb6e83f0451f7b78368f8b3849fc47316(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8512b1873d2f266e6a6e2675fc51ce582d9f24a23183bd9f659f79f630e257(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85349a9774decafa598841cb4fe4b897c0d1254b98de69a307bd985fb96cb399(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60fe71aec5593fb4925502c57cd26731a15d310bd1d6aa366232c149af55db6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181ed0d72b45b23e877f76c905dee4ff3bfe9ab508c3233e80cf0388d91dfcc3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52541016561fd4a6daa3902c58aede1e7a8c973d437dd1b64df1d8d151020bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708738907954c12fcc59612d4207cb7f3c867eecec4ea65c83b47d4dc12ecc2e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfcf48ae332d0ec321409041314cc78f145eea4c657ba0fca7d2185f1937923(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dbb7af584a9f6b2a2bb0d880c59a691e7508df736711654a1146dc285ba1cf7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0d9cb8c60d75eb63c7f381622cf535debe7597ca3fb0605121f851a989b482e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c126639eddc95a1a5b451c3ac312e82bb1b4362877fc158f615757a8e395bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0322dcc262c7e0c162c2d6cd1dab33081b0d853ed7567cd4aa44bec512dd325(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603b6f6ec40eff7f69e70a0ed8614f3573637d4da3e6ae2eee5cc1f7f8a248d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241040ec4da82919dc6755ce0e859977a19663f5a513169a0ecffe1e13707d6e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dbd9a2127215b651bc8b8705704d6d9ababe6d5d6d45ddc6d091b6e55eae27a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0eb608a9cbd2a3865b203f28f78358e46ade35338f6f567722e75cb155a344(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea517fbe634de265ae668c844a8ff94be5a32936d72fa3565499a689ce85b6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be95a4427c1b67df00cbea4cf0f2440bbccba705b113c937d267208893cc1a36(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932a442dd5590be6cad9397e2d7df3a3ee79f68e5b123a8860dbd9fbb65037a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376db59ecd8e77c937489beeafeff9bb436e94fe12313b0e104acf5a020d7f3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355b7b237f6af0f64bd57d45cb01367c09f1ce2556cf9f422a4dad69edc654d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7691be4e7c5ef04adf64ad6e9b1ccaf14c3a3617d3fa1811fdf8b14ff6c4e804(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c5c47d97dc562c3409b2c184e16b08e393fa29cc7d6ac82337bcc13c42c14e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9061cda6780b4c38f5cfb092ab6b28420ddc283579820963949f5235c545396f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9d799871eca086e042d99b1bf1fd770955abf5384354f52e21fbc73724a756(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c603861bc2052ab363aa34e6befc56c22906963165fb4f555c4d9674f36052b9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de75c5d80a437a2b329c49192b4bf02f6089bbff255108f2164a0c466f1ee754(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2968e54fbcae45fc3f77923408f2d04b034889ef642d7c799ba55524a47dbde(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a6cc6950f34efd9989cad9c341999b313c00cdc8331820bdaf63b2571cdbac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f5c4091344468238920196c2f831905de5adaddf022da217351000760f0cf3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5053b688169839460f7e4a546d7b2aba6f6ffe2e5e008e8b70a85fb93bd74c54(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c9145aad579ced1b66b996cfb58d94655b0bdaaed9c6d03b4e1bc1388a8745(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9d574403885e49be6e06d2ff294a40f8bd8c890b8e739d9e7912fb48b70f4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6df840adbb68f2885acc507d14a59fd537661bae04ae7dd5f2b74bb54cfab5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4271fa1c6abfeea539267e2168a98defcd2075c73df962a06af48da24a690fb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478face309bf21fee84b714ca179b5dc052d65c00591229125aaf72d2913aaee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9baf2f2af1f58b33abd316fd6f0baa7647e4fdda88a5548605965e04d0447426(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e708aac1025fbf33c40927cf6acbbb2206bb673954c8f2f25586f35a46c4e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63242a57ed95f7c432c1c4a32c4da861f7a938a6c854f260c1adac8275dbf6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b57fa4b86c943c27ce9f491d6efc9ab2264a56f878c6d4c014c1056642695c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc83e43347db71a4acd52bab9f0aa17175346cce226a198067285248fcc53db3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8b943ff22f6b1137bbc9c078a1184a5640070c3ead3bba3000642bf48bda06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__066b766bde160431a5a8628af290c788ea8f8622ec1d6560e313ab56ac26375a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865d0db1828ab1f5bd8c917f877701000d4600b727f178305dd8669f3d8773fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab3b440f071e3c4401995cdf8444721f5560f8fb06f120a055227d47f140341(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21712924f3c950c203b0ed941daa31694ba95d227817a6a011cc2c25e57e14c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83999d122bcb8c444724d936d944e7c995aa5c212e9da8b2abfd7f5ddc6c382(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab226e3ef70b1f7413335700ffd1805466f2d982e4599265276312291f095cd(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc193d644fab2a89feb99191ccf2812cb06bf6d55f2c3d8848fd4827829f84e(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a22da91ade073ec55d4bc82f89fa56d14796a048999328f97b5140645222e69(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa182c6e442aa65b757eeb2e7f64e29cb184a514d484d2108f77ba207995961(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6dcc90da29ee23702df4c51f4d744d4ef59fbdc9fac076d95ccaeb6b875e7b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4802837b7215c189c733819977e3070b5aa7c83642665155db13023f275dee3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df56f24ea5ffd7675281cb0d305824924077dfd34adc68e62d4364bc0ada1e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862b20938a31fec5f069c115203976abb29ae37a3b529644466a2585b1cbe2e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae17c064ef6ac0e2c4306e5a670ac2fb36ce334af18155eaa3943c3c6528428(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1622a1f619332c4008c98022331a0fa4beb29969bdbda3463d90679869ac99cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc64a7dbba03f3de0a43bb1e827ec18bb585c2f165c82e043acb550956f60ee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884fb78f5bf49808c09c7dfc1a8797bc79a4423444d7f52b56752c819c9ed161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71f0ecf70a1ec963bc6172eb730f18cdfeb1e6edec7148fac3886b81d43e1fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0daca25f7137dd1cbc400135e58871856cf04f9d8a0b301be577448986121e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384329ebd85a2dd9ebd70f17f38b5e4dd34cb0a707ceaa470c31679985149f96(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17703ed471734f3deb66352711cb40a78323ebefa5953f36aa89f6ca0cb6fbbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29367a716469bb906db38a757a8a8c0267e0ec6d2ca0228a690cbaa6f07c15ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055f028747188dea4817a0142ee74a9d271d0de15a8638f8c2bb7384a6c0b1a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd266b8462be37c17d37a13026f941917c9e182be8c647021d26fd6994f81212(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471277c62e6a8fc721fac65d8a22e28803f75e1f56fdf3192605ecd61bb036ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578d555cf5cef78032d176529850b7b2539d7c9ad54278a75b28c8db00eaa3ef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eae7f3d0c3258d1b8b465a4bf2bcfd6213c3d4f1e48e6a640956faf30b9ee47(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49daf412d38f371d4bd5c2c759b78a73cf0660a3a39b06140e40e35bc754bd49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d160a6d4be46d7e0754d0baf513a78b8ef2d65e25dc458cef4fa30aa949286e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545d39ff85520c8bc2c664114e12572ef2ab90625698d17316652935ec61bef4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3fda68f88435efd85501f5b855857c433dfe44504d3d449696db934e469f95b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb32e00791bcd54417d144ff0c483c47f5e2d7ca8c10045d8de59654d0e4107(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64d714859a25a25a78f2ad73141cc37cdb152f9ce3f327e6bc527970c8403dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ced08f2f952f180c6135f1769ca9e7587f17b7a361e732c493e4964f12a876f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e529e8823e70c49a9282c4b64175c2416c647f049f84a0cb5acc96e20caac3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0567c4ae111f854264507e2e115ff9904a7bce9784fd0ec34c5f41d721ea9e20(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4f0c6e80450a002e762785242a3b3dfa32a3725a9501eecd8144eaf5e0bb98(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023092c1b3997e737c7c2e09ffb5e12c4ea16ba24eda1a841c4a726990fa32ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13acd4be1d63a1645b6987faa43e05ab27fd62b233d31a44625b40e27b02a3ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4762adb462ae41b14282ce64513c4436fbbe497b51ed327b6a3166be8acd5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110ecb363837bc9a77d1effe6d916dd3197c23a356ba16cf1be4155935833a8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e8704893df0331733461ef227c9329c72b268038445266ef0530b1aa1bf2618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c860172652f4ee6049c570e437062a75ca93033dc314e9df6157360e2c97ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b747f377c7cf4b3dd4ab7227250b8b9cdea2a529ec9c13b310e2e8535384e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2591dbef82a5e9e261479e241266e94fb15b19c2941afc320afea836c3b560dc(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b88752e4d35db46d36a14e0fe3978638388955793886e5e72d082d2c95557a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef98b9d5dff32cdb45d007284054f393435d4d9a6c4fd0c6bbc41dcd49cbd2d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b688ff98ede8f7411856ffce2ac0c4e09ff5fd79e441100abb588f05f7f759d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b556524816cf83adb38f68879d88e3c85dc336db5e1839dbbcc317d0980a9cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13dfe268927b9e1b4d3e4cd81d5c0830508d038761e34b800296c557ee8604f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9df0149add867dcc426f7cca125ccd3f540039163258f912afc37ce0ad9b80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3b175a75cb593554e7fd26a74999f14ef540f3836864a8f2ae95f8951765be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c301c8d9d6097e4795141b2592aa55a8eed091d8a0da2567595073dfaf701c9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9779d56a97dc7963904cbb007c455d4bc6efe870cc7baa38447df0fa1f11aa85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5535041faa9c79bc9e13d27810cd090442f87bb04fc9c411d836e7822f1614f8(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef5a31486ce91278e2dba5c58303bbbfe0da6e6cedb82ce21fab5a0985241b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__206cf36d934023a0a3336ea11e35e07daff1c15ef41c4472e5438420d749f526(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f4b26c2f391f82f0e048d756893f6ea49d8343c2da023fd1e2669387c4ffe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca8a4c8a2d98bb3d7afff4511e59fb623139512f96878be6e760750dc316d95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c394c908118b1d2fc5e302e524a9ea04348f2a7821985062f0221564afea29(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b42d827cd44861f527e0544e674a92582eec213c98223ec7af3f001dbbbbb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e655eac63b25c03d2d796f532a3a4178bd68f8efcf742cd50d522ef37ed46a38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabb962141501ce65c04a3c00c837d1f1c746a5d12683cd7880807397f9fc2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652fac6d219bfa4950130bb3760dc81b25b76d4040d46f6a8270611ec4317b1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cdd3fad1db65c29100d0566a9ba73eb7ed1492eefd242ce9795f1ce60371e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59494807f297f42742e3f156bc6488d7e8b041a6767897bb5de2f64d81bd0e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732eb12e27a6dcc3734c0bb5e649b486bdd1a2973234f589b4b3033badddbe5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9651ef50c5eba547235a6835cad2f2451f10f8a2ae6e8ee6e7ec145a2d6c98(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9880bd2bc36cad47173e0da94e1ad624ac35e4d724072aaee3d18184ec3d1588(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13757e6ee3b199e8bd269c1240416f56334e7f734d61c9c796e83a93bb3b0e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58613c27de30bba7907314ecbfa2d406893b15f15befbddda4a14fb72220dbf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b934ea64176831f3acdd1438c23e3e012e9c91924cf4ced0477bfeb547e377(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93dcabe34f16cace89d5f7b66d4c2b54f6080e936fc0756a7041e91114726b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0197d7210570bea2692b8712e2ad73b531a9c6edbc3b8233fb23c3f0f9e095db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c577435c1af32a8b1d1c59d6dfd87b472a0f02894878097bdb411d21fa5a27(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ace7f7d4129798750eb49836fa5ce6f9aa1a62472c8e931e9f00b810a67857(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b6060efb74c106d2d6cb91cfb9a7e56e11a5a4e25497cc3935383704a0185f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb62a1df929d1cb9b30d6e81c9445d46ef8a67f309b5e56e4a28f86242d6d074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5400468e5568a6b233c8528023a48b42c725524c3eccf2062e8714de7f6a7bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583ac6e262d0a7cce39f46a2613ed9a23636bf7aa698c0591bafc6f2099a8e8d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d524139a60eb50abee579d8f0becf93bbe73ead48167c4400534409b00f31525(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b6cb3a0505104ad259229aba99acd20b8e392b4e7d92b6b078b773e5458ab4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d2360fe314b2b92f4ccfd79fcc7ef3c709c520f3000a9b8dd80a023829e24e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87683863cab5a913801cb73da742ededba317d12af1fab2bcd68a6e9456617b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6257a5fc387fee4c8bc0a96da883feb5fa981ce0e30cf1938554cf5569cdb17d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e783c2fd9eb7b19159ce5acd1785d5c8487899792d9d7f24ea0a3987486d5081(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc6ff5d913e6a180ca4537ebad786d73fda9b68b4dd04747c0cf4ca0045e200(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52e9f16a41dcea63918292bba7a4be135c834b474649cfcb551ab79c2f17c0d(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dcd33015057ae22f46cbbaccb9f6534cfc09f846fe47a5c09df84e03423186(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3826d899b7ef71859f15dee8b159cc6fefe35ad3152e86ca38466ea1b9ad26ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3044cd3c461476b53a435b12acc0f9f086ba22cd71340ada03dcf839862a423e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e67673297d84cc48dd2fc6d7d1546ffa6a526b2cc8cd1c52d7c68694b31e6f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15e27a0d9a7d3f680547ab49b3b0b165f2b79e1b77e8fe5ab6e68ddcc6e652c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7435862c8477e1eb57f7f0188004f37f2e657d460218670eb0c3d69c1a01772(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b1055e660120b182f78794ecf2494ebefc92aadd3bde704c61b329e9ee9653(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5f56c13b1d8d49581e9f419191417a63ad6715f5038881f1aa35ee9c6543d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4aa08d5d0e1d24a3ced54b0bd8c4d111c5a0cbb28be281d4b820c1296dcd1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0e76b7b9b1b1704343058052fce03030a0b77bc83463304fc40a987f99dd14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3de3a563fe7aaeabaff9956f77b94a952b719d0ac3628ef49b009a47150ff5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1168595dc8eaa2ce842638cdab8a2ca062a89060dbaf9b2306cafcd22d77847e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210eb1d46d36eceedbefa21444fb0717bebceb35a571e9a093bc829df8059c59(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd43b6503b921b7ef73054779b750885e86c173ca303f9fe07f73abeefa22fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6dd03a06c4b89b3b25426b32757da281ca371b4bda50cf00db32b82d0c3455e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df43643cddda3105b0697b1210118016ce727b07521b9d3f1ec91f28c4925d26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58480221f625549f4dae3289a9586ddcd6fab5a016a2294bf027fdc5e6ef792(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e27645765a147a93f34a2829baa3848c10b5d08abb9167fe19838d0e3eb2f7(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2976a46347b4f352622cad89828bab63866b3b2388698cff505cc883cb240e17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf79a30dd4b6f578a8e82a8c05e2c40c0830317cffaa857d0398a6ff8724e7ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6fa8247f8fffabb2fa2f211a4817c567981e7b4cf2c098c9d0d355a9dd2e1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ce541944a949a17323113ddb72658b9ae533f454fb842cd37641be864f3031(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e437d15b909e0d144ac28b002068f21a6199f03eac19296a6f5d96b731d02f02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40eabf43f4a10ea9461d2a5930f947720b47fc56d147699c4dd90900ddc8a354(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631f8f372fda5641e3fb615599c4dcc2aca0a57ce200649da1d653349e94b689(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e66f3a7b3f8391522179360c22a66f8900f1ddafb970a780a4582c0de5f990(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e801c3edd907ef885aed5f3435c0ed3c6f933bbd6d4dcb90aac81c4f4f4c341a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4984f92bd2cc8928052e9b859892a24cbca72f4ddb11abf81fc5d00a733b71c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cdb9aa95e5c46b9271d1153533fdb0e8a835be6e4725b1d49ecdaf8bd32f316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4fd157d03c9ecd0b69317a307a17f16b841a49102999711b47a20ec79e14a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7523453e7812573d6ab0b89be5757e24ae8400eb11950bdc41720839d2c7e915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95be404b94bac341d472f4bfed8df000001ab1cedaf310067a5d5298bda4d0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4df28367f1b8cb458d4379acc4617e5ca5ba23b65a42e9161c3af0376ff9c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4eaa501b879ad2c4851d5b8ba29ed3cb219f740c009eedf61823b78dfb47e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3509900248263df0449fe7d1f31ce4b38f2494a51d4c46adce21fd8fb789062a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c7d43790931e2344a636e1a892b34f122b9130b96ed1e5fea6de5ec1e477ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29cf1bffe81209e36d078929044ab34cb1a8279caa1a64f242c3902208679a77(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abff425ab953c6fe24a4d2ddbee2cc22e52ddbda6f3759e389b7b7f201b705f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b742be93c31bb8dd40a232d25eec71ab4b19b08e4d9b0526f67c22835f08de76(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c47b939686a3a886b56bf3e7773992fee93d98c62b46fa5bf6181473edbf976(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2147570e86a39b213d8f50dc49f7295cd8453f13e750ed8abbad16bb6f2a50ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a51b12311401785fb4218e7b50f0f6a304643f7c6fb209e502d60abc5d4d49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f600d009ed6b7acb169673b614b7e9edb948305b38fa4126241b7ba3b544b439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7592f6a115b5d48ef2aaa3be3fc2444b84f224b2e496b28360fd69e528b797(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142e6613a6c2489791ab39eac42341f8bac2353621fdf9d09e70760c096a4dcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba0098ae82af40fa16c808cd15290f5da07a38755c7b3fba7c648cddfd89dec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a00e74b801979d2ab9164518eb3fa43a9c32861cda125be90760c1afb0110c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03b6acd51c2d181c391fad5f09fdd1a4b8d96a3f79c4ee061d3028e05a8def2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2436fd15661530a42171d9295a5c939656371a804d3d2fd27806d99eddcc8c10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5eed8babb6897f0272d2d994f007fe1dd9c20726005d06ecd9f2c850136ed41(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747d35228560aaa8fa267d98cefa4754b8b2d1092cc9fcb63bc67ce8f796e635(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf0400db45bbe154563498f46aa2d17a5fedeff2df944b75918192afad84f70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35256a953ba2795100bafdffc2958e68fe1270a3c17d1ebb4a6efe064034c3aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85dbe782348f41fd51440e29caecb9431df270b9ea667dfeea2acf0ccd76648f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ba15beac9b0357703348e1684e03c7a511b855732b3b0ab1f570f860353e70(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d17cc45ea73be2329fefa5d5772c6d657ffd4626f7dd69ac2f8bdfbbca73951(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__633450c159e6ee86b0125765df869082a5d0d26152929915e59018ab6afed300(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15df86a7142df62e43172cfe65619a9197721a2322b55425b5db3127d82a13c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fabda686bd77cb4739a7c38103160cedc730639ac596af6308a088eb5915379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2bc98c14891a8ec86fb6fc7a450e3227dc28adfa421d6a626cf22c9ffcd759(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e0d78b1b25458bf76821c4f56d9bc3f1109864986d6a21536aede80f574b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d36bcfe56bac2384b798ddf57ec242eed6b54ad3464263a57684cbbd7f6b76a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed47f7620c06ea9c38c7d6904be78932239a688550327858a034461e03dda37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f40dbcda83f3811afb6d6c9617d865a6080176234c888f0e44d827c66d696e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e61ca6ae49f34351f5e78ddf75918d490dc718d3faf41a91d806ecb0a8d6f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6832c14d775855a75c1b0e546d55a331090217a796fb4c3b88218c3b2db9773(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723051fcde47bd3969d3779172a3fc2e9f479690b44eb10c21d17bb460c3859f(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bde8ca1462efd44e3f25dc92d1fcad7fabf6e6a75d408a24e1a6a8340536e07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1dfcae39a1d7813bbe3b8ee73abf90956ca1011df1a38ca52c35901d42834fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40274a55fd7b28e3f8c89e6fe0a8cc6f07f2f63153d4f5cf8e215d680f3d913c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b740428bd578eb034192e09413ad864c50cb2ac55136e878a28bb1be8e6f85(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c4cb23419acd622ad45102dfca4e7b7258ac454619fc63ae4c43ab0df9b091(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec604ed031bea29ed05ed21a82730487054f4926e89942d1b5f038879b804aaa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571aaa3b235139749d6b19ae8320e54ea8e6678bece9f31c07ccd754fb34d8fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__266800432fe09f25696690bb6fc2f5f4127a1a66eb87cab94b3a5f2c135be6cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e37ec6389b5a6dcded569a747360a8f2fc54295dd75b22fc02e9bd7a0a1e63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df670f2d81d7f874d2084cff6882b4ad12674807169a2a162dc796fc83dd1372(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b20f47caa94cae9aacb548eee4768656282cc939f2756ade123339f6a99b268(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469852d7a5f6d298bdae036e08f61765b3fdaf9c5b77a4c1a9452c2668e2208f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0849a1672274d9946234da8ea4222f2fc320785454a35546f449f2cfa8bd81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea9be63fd8a3a0a4510bcead10cdb9a753749138464bf586025eedaf259c20ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83927d211b0d946d3b91b534105237524863c395e6c0f97677714a0e197c19cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb2c3d8fe52b1e937af911929a036589e200f6e19482a7d359d99874ac14626(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a201a68ae830914145687981bf094dd456ad0ed64fb9ced591c4b405893fd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d95e57fe17e3740dad04c019dbffc88ea5cabd36fcef74b4d222e87300977c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0928638aa443245404a32eee76434883396fa33a9c5a745399407b58a3c12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7dca4bf2a20c3e57601f102627129c20e605ff0cda44807926742f9669d60cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c437118606ed6b51c3317b29c04401192b78f9ddb1dfeb62ac0f912f38c161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71696659ea35493e0e2d463718f627526f5c4e57f3bebbdf3cc1fcd703837ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3a223291a5176934c3315c5c9e3f3307b7c9f3c2e777511db3c951238ba5b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c16f907779dc1d7642c664d7eb359e4a77519ec5d0523ad9c3076c91b2a704(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75018a7a9084afd7c2ac9dae4271f66b9c98c8dbacd5da9bf785ca0a1800cdc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b349a7937be5dc16069a8fdf105ce788a5f2378a6998c3100e64463a32d0b765(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e439b94165b8ff7760e76917261aa338617c711fd4c9be80f9fb325b43937e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830aaf8914cb7f9a2e32086fef3d5871252ca41a46dbc16223cd22501ef2d2ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f43c485ee7d04f7f87cd8541638bd691839cb6dc4662ad1f960e4f570a15ba4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67b2b3053b375432ee3819ad83c0fe57d294f6c29aa204b2698a365f8724b0d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659295ba1fadec747316955f7e57699d68c7c291d34c2220c218a8ed1e5f3327(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7305b67fc40ef0c804da33751d0f6b248e3fe8531cb00d3fa69cf72ccab7fc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797706485cc8403a7fb92402231362431732d8a7884878a73fc0f4d29091b095(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a5fdf6fa6bd460845321562a0cdca1a4aff9c66a6e466ac605fa72db1d6705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519b7de24dba8fceb414ad3a340efba9da6ef48e8a0af4338a2f2b944d1cbd1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9da20287473dfff2ff1215a3b08095526001d00736bef1e96b912de96ebf76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1391689438f1d509deef77e0093df93f4154f58f544889846c63dc359f6522(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7550a1bd7fc8a212ff8460b201d8b71aa5c4428396a14712213674e8eae3dc75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5c44846c2b0aa214073427af75ef2e43ce7f306137c22859ce0b237abb0580(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b67249b54971de80da7d3049eae139f02d5fd3c5fbb8d1bd34a9d3e103ca2b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__462c463d6de8f6c745316357a0a8da220301e2dea8e84229e92907a76cf1d0a3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__392e86cea747a106d6a3e2c2460abd1a5f64bd694bb82b63e30345d949c785dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44f212ccdb416d6be155e3969f2f524282c5b01f6ec443683580e43c222b360(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8ac8c236e7351e8fff018fad0be2c4c6beeae7e5bbb33997afcdd133b18538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6759e7dd7738feab091a3498cde41d9f6b4dcf233fabad6864f735861b9d89ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca2c59999ae8b8dea4a1d8dd49994c3a20df1a6c09d6a7be2a73780106ed0a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ef9e04d0bf2278257ae14056ae7a7789f36577d383e017efbd81f0c5488dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdb0ddd7268485985442a9dc96d661fb6288c2176f00928b9760f3afeb45672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304fe5af74c63d394eedd97d6f6d0d75fddc2b0e62b5f9d538a8ebc250db1ebc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf1dde1aa3098cdf8c405ee449a37e56897956bf53f2d86a66a44bac46aee8d(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d5f7e6d09b69678148aa0f61e16f6aea5c80767c9487a54bf68396962bc1f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d0e3028cda5381a9c10a534c94b6e36c278c41a8d8c9f40500f3500fa539b5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438752f94f6dd2b2439ea565d57b5300cd49c84b7a52461f3d06cbeaa8018e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6cf57bb3e457ee5d861ef9619b0b1ca77226ef519095fd5f285842dceffeee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90892a85c04d8029795089ffbfa5d68e62492871e77c7be71369cc1346fdd3ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26d70168c34dac69329e1373bf1c7f6d7cc6d5fe1ea79f000722bcd911b5bb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aea717f0397c4b78c719cd0994dc9991b7e5223a54321dec29e0919e30d9d25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783dc182d123361cf560c8255d868757ea7b6097d906ad1820cd1221aa67b260(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28392617a439caaffc81ff1f6ff895b8b1d205c960d8079f7168382a6a9ac0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae83ae93db78819dd3d2e5ab6ba043e8cd13d12d84ca1da0f82aa3ae8ca4555f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94c6d1bf5a7ecfb1c739b9888be38873f843cf4fdef28a1ae16a4a4afa4d2dce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95140c97174970ebdd42eda880b60b6653a67dd0fc731511e31e1be9d9c44c6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4f9e142618275b99e0c91399a5361155eb066965fcb92aac58acfbe2d07e95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b3f1d3e3da0e6b447e696dbca2c05d4633a7fba337f848eb68e28a78f85f9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ca27d67229dc10c6841248f8a66d4fac945614854abfc4fc5df0e11bc6b3ba(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15de0b041dbbc2eaf4d5a9001013de10802c1dd96e2311d47c9cd227b073db4(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9807f3644210d493de311acdfb041bd543525d56875cf1801f9ffde570d1787(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37008486f7d50fa42b3c01d73fb25821c5b231d3cf07fa0e667bfc2d8229909e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1988ae55de84aaa29acb3f377ddd9ed0005f3655d774f7742cb016c4b7bfc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665aca8a729498f8dcde3f9c7213b484cdd4cd82ae97eea44d1301e07a0d0a48(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d887249ff5a54e48e6637d3a994febccd64fc42d26c5e2880f1deca80bf47552(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cef6d57faa63ece0b7da8b9bd0b945c9e607c073330a49d5fdc9329762e858(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf87695d9f899c35998db0d09f7a5128d8c6593519a4ebba9b0d3274d8780a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7552682082020a009311be2a4a15f44228bf871f5b181a8c253b59ecc5c78c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7d23ac6b9e63891f6ba4af5410d3b0c0dec84d62c3b7014c142c7f3ee32caf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec10237633bf0c6bca8a25fb1eeb177a9c609d50da5c6737ca3116a173cf24be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b8086d550be93b979d6b2ab369f2c057479eb59a8aab11b2996a1a3c65a379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5f9a3cff198223d92812e3e665f8a55bdb89d67d3b8b176c65b4d3fc6749ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24880531f8ab68ff0c9f524d8aa86ce5578383b961898aceeff4c75ef0828a72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a093555302d6544c305b84b887cd27d9e186c764aeb969205ecd4a488b2e82a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5037275cd20a208bacde4824934114728e22802222746241fef75befa981de5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0154bcef91b78916e901c5cb132cc812b3b855f6d15353b32e970f56e17afeba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692090e75eca3d04519c07ba9191a09e0748b756971ea690abe94015cd32e3de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4ab1bee32196994b905ab67b610c3486c1ddc3114faeedf2bd585256c000fd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765639eed9a84fe3bed7023f1a38ff17433989fa4bcd6b499a3248b05f5cfa6a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ecfd8b3cfb8dfcafa2a168c749f00f6c7e871ff06b9e6dce23fe38a8da47c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b03385006958c1da5f395c189a4b195d90e1e8c24dd2f666ec1ac8b09441a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f89864f39bf30fbfc21efdab2e4a34d7ed1b46ad30ae8686e4a009ffe58288b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c9f947f5d89e7203995e2d34be56eb917b1522b15a690b20b582299d92bddc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c070d68a6d873e0cf4bd4a61499f73f4bfdc49aef48f69c767c3f4c55de93585(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adad60a0a05868010d2872682ac590e24f7d1336ea88c44ad4f7b34a286874ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a728221e1b94a8edb213ac97edabae8f652bb4d27fbb867b9cb05d367064b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2499acee1d49d764fec6ce717b8a53767bff80ea306aeacb20eb65bca326a60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f5c247723f7994ff3794b0629929a67c60d36414f8e546a940acfaae7c7a41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34bd4415ba5924fc763e259f13b0a2044fe691e782884c76e54b4e2c81ed4fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b627c9a2fe01d4ff25faa2a6565685824f65c5c5f654353a80b1b670f3fdf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfe93bef93a9e895a4522493a541d86f1e69a9730010bec17f08be5d655405d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1beed3db9cdcf8a61a5025e6ac699f4989b996c8a300bfc92fa8a4a02b1bed44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9cd8c75d80e7d26ee97cacd2195b719eedb2cdf982752b93f2dec2915045ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b5de7f39c72e14b1dea3fce82ae5a7bf22737e56f8efb945f5865d61645a03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4d581de1d48a999f82d895b32fa6677532b8f75f86b1f8abf08f22fd6fdc4e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a863aff3d3204a1c860748e7b1f6da4cd2ac90596219155a5133b34c21d0a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9593d40af5d1e143168b8042aa54699f371fbcad02623c36335ae8b605de008(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc0a2a52ad1732d2ec9c0277dfcaa4559a970188b541a99e3b47750580ac147(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e52e4188d14a3e7b8b500f7758df17695d45dfdc76a393f51646f40b279fd5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e03d065172c16e011ccfd3637653fb8f909943b88cc0be5cdad594e43e530b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1305881de05ce5ea13b80233287eff7e26e70e876f2ce5b8bc548b3478690c8d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548eda18db6a2b5cfdcca36548ad32f39be677baa6a58cfc8470a5e13e13e977(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024290f5fe0a4b211f04e30105f6545691597ea420d711ecb824b3f48c2800b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de19bcf5d265f6c461770bdee1e457400a30439dd2ae56e55b4f50eaa1dc8b00(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55bab8498a6570d27046665fe68fc10a67bb280f50337044646b502f1ce8c1c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23cf0649f458508bbab47cee91a8572f0c56d2ba5b53fa641d733849af0524e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4383df23eadd6e83a0996f70c40b3251ceee396d4744ab6038b532efa295286f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3513a4764c9e46ff09e9403a88d79cee0dbdd94cc0420aeecfefcb511dfa9b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9b7bd12cc5e986297f29aea8d175809330bf5d67b6e2954cbaf2088b53ed8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9933ff16b752e16f843a889a4c2c246e68518fefc6fcbd3a7dc9d2154609f07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865de5e276a8976d4cbeff965a0bd984bc659c72b68f9667889e7ff24509c0e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48194d42ec16d490302fe0d16d1cdcdd7ef5f8b5669a7bf0ddce5a0d517e9b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3dbab889dd371e570ec88da4ed6ab687fe196c3f7907d071e68d221c1c419a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a865bca92275b3b4da1df43c671723a4bf08987fa5bb84482e9e87fc19718b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dce2281119ad50602ba07e0e8bdf9213963ce71269714022255b77c047dc5f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5ec43ee26ff24d15402b6cf536583305eb6b48c9e3e288bebde0f01a48dd0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565145d179c277eb9ca4ed00568b8fdfb35d7034a48d344892b581db5ffd2325(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c628feeeed0cc9c67df00a30c2844513f6a6d88f702ff93d400d2cfa7dd09077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b95fba50804b0edfac28dc523e78400fef4789081fcbc614501ff51714d1153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__decbfc27e7ea9b72de27ac2a742108285f244c0d8075dc24b7ed95d0ecc84905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ae33dca63de9987037d1cdbb21fbf84fe4238e899939200193c80d727597fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2568f6e19514f72e25d861c379a98f5f87e475670d236e938e1df4161c249d63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac6a8639ec4041d66eb37c57528898651bc966f215c0aa7d3b689b3a7f589a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__959a674735e71964f79fcfa20131c68b9b7eab5bfe8921efc3900a108ff1dbc0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e143abb3310040296d911e8b7308be80bff989aebaa9969bea0a3e7e55fec60(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c921ce24ad99b7330053c870ed712927fd997abc978ead5625168a1621f31592(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3835585d9f2c79a448b6578601a208e46414e1838fc53c1865c62318c82cb317(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb654422c456872bcb5e12e13c05a0cfafa833b290fc4b03e614f81c7ed313d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22fd8604a7ff0070adb08cec5cfd5d6ab73d3a076df057212ded746507d488a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2ff910e57c27951e2642a73b9318931c9f5f2ce5435c978977199151b0632a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f5c70cfccc3008439d0bd06caa172540369ba12ba833a8c9bdfdd238d26a82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a5790b9947db73ff64c590973d9c3db5fb46b73e3c1bc04a5627b908d5a13a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb18187881a00b0f49e8527015e03c3694578c86fec4cd00dab52ce56f8eb289(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68edae1fec545006e019e223ee46c612f687ac4e00bed102fd2aca03668a8eb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4816cf57fe94f5fb0dcb16efdf06b444b8b9245ea646bc5f83fe316f7ef8abd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a634e6b7abe2e006cbef4dd720fc25d9af05428351ba24662b496c9187bfed0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26f183407831fc75da825a77eebb1cd6514582800628c37691cfa46b3178cb1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3a1a0eca5a6fc65185ac0f8ba1ec80533cfe56a4189b238ca17d23f574cd24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ebcf8a782702e488b65b4732302fad2ce1edb8d30b1aeb89a98b4fa4cc772cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c72afdea11bf04adf120d1e29bda682a887fc05871ce348a65e7a8367ee774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01064c1152ebdf38a4de1e9f30f66b5fab380eba1f3ac68a807edee035d58321(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8695a1f7d81565fbf1d3cfe4a6d68f4b7e85ef0de574d6bc40af97b6f337c81a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ca267cb754a628a1b83735f5ce24b126b0e32c465b6452a90bb0f36eed89ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406f0c1911748a93805b2dd4344a1f86d5f38c15856fb606b7dd873b8726751f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ce85bb2b336b2bdea3ca08bf0ce3caf465028afe62ee676832aaf68ddbd8e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa126486cc066eef6306a7f07372b1954f947947c1725e5e2edbd9eed5dc08b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e56c993608348540627c7a07fbd4a8b680a4ac9b5c77d48c3fa473e3b8283dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f47e9c85de0c7c946b864daaf4fd6fc7ce547e801af00aca2450d9d59b293e29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c374ec8ef1166423608218a835e6dc8c7cfd29ac72d947eabb1450e5e1130aa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4558224a4b9dca37eae88b3db96bddbf9b32944c62787ad85237596602746236(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0450c8f4db73f1da0e39c96f75b5beba3d0f1170deb21a4616a44c8bcb808260(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1641145ae6d3c01e52f7a7455f9a3951217267160b54629bbdc48d3e9f5f54(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f2ff8d46bd5d256cfd48669b3f57278cb0f73deb7db713b20bb88eb61340602(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b0b6a37be37a6de4d8176c35df0c64a63ac7a46b87d79c83f7cc2b282f1dd5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b726637a7183319baeff81fa31acb4ea66fc894623491575723e385aaca8b92b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b120db5999de437702a44f5d09fc8ca5632325d759d7247f40ef608176b9a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0341aac9b898616f7ec807bfd6210e64b47194857f63984676101063484ce01f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc69386dc6e4a954de6f736aff9410ed66194ecabcfab837862db43448bc1fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ca583a0e6c0197d094e3a218662e9af82cbd274de0fa76ca1d10b2dc2f414c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b313c42c48c45202a4c9759e5cfb1bb08b320857c97707d947667f3e28f9d5cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19437905eec5251bd051450f9236cffed91752b4b759b3815066b7b502b6ad3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367c812c73d6ffad2735a5ac0cce4c3597d2563ad14485c83d89378d62f6da25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a1b9cc6bb609cfdc1382f6bd3393031471cb9ffe4596d35858e7141022eb9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce209d026931e69c01ad02bb826b6d8e0d163cca5b4aebb319f989d7aecd1a73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb16fd08a3fe7019e6df4160576d9cd4583d585f9b2371dd997f5ae9b02ed9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2c7f404fa63401ff000099e49d3eb0e64e2a0c16311eb7f1d49c6b1d9caa2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523b27594a8d553fa33c1e3d80b58641c35ab3c6840cd8d4a9d7597d03875a55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25e5317630909b4f073b13e63a01676bb9a55707d009c49c79759faaa902740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d305396b5bc4ec4bf7bf65635001898958bb4acc1a72ec4a369667cf7ae1dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afd62731111d1b35ddbe3bd645537bfbd2a933ffc5507ed358563f4c8adb6e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5220f8f5a87f74446e618e66e5bf7e3dcd3dc35acf6511433f442f87ad78dd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c160d568c3be330fc77d209b9cfdc852d9824610c414e8d97aedaadef1346bcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc3aef9eeec4d9c0edb40dbbf24297de360e681288b2123c105f53ab4607fd1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9cd5356be79da9eb23be57e51c49dfa02a4e697c0c649d48f28bb4364c122cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17df4917955afc0f4377fa7389e3e98bc5fb8ae70e8a0d0dfbb7faa88f1d414a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2586d8590568fd9691ba5290c980dba5cd18580e5458fac878ab6e2649ec0479(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b8a9823daac5422dde4db296d2170250f13aac5dfdca17e05915144c3f24e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535751434410f3d3f8ac0bc83daac10e38e07107d43b8fc5f4e992ab3af86cb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec71ecf107059a93fb62ba51304cb1fb83b09ce0fd5efb15df86faa1ac8197d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d82ece0f1367c6bbde66d7e0519a4abec79a7e13cc3b2a860aba4de3aaec9ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3e7a4609a0198da289a765b1942db6b797759eb509e4a08d45580c8b058cf7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5d0d636aeb3e89337dba3b6c9eb6e9c4553ae6639754578e18da2fbf383a17(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7fca2af34b38a65754b8405db7a32708ec51f49809f97445288ae962d7109bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59af16936352f5c73a5b9ff633a7d50f123a697045508af1fdd2a3ee53c02beb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a20345b30ca9b7c2b1998e163a51950bef1f51f1d76f056c7b60538dd88ce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1aec9ba265809d58a8f8517effda993920015bca6a2549d2adf7b429e168591(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6e22cdef2f7c892d9cbed4f2e93ca9743e1d0ad198ea34621ba2a5a7c426c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07940286353e3e947dd037b10d19cba95575bd7f95acdc1633ebcb131b549e2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05f71a56e948075e09b2f42830086842564cefcaf679d4dff743f7e06e29cda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3828bcb510ae5b9acfd0bd8c759760089da219a93897b8b2c0f561a1f9da6ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2971cb9f8d0c0ad2c6039a32fc2adea0209ee559b1970713179c92c61ac79751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd606259b5e2db40bb14b2f4c16297fd207858ca8c639922459654beea01742d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f191cd0e7ccd57c4fcda3d752967afdb2196d89294c7bc7cbcefdbafde642cb5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff1c847d8f3f3e94295003409738592c3380b47605e300511e2379626b55ab1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d02c2137449ed1e286fca1a57016d7de02193ed80b8d9aea8c1458d341c39d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee96541ba332b6d4a074f91aacb9418ee6b86d147967678bf390e75c5c0d46a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182c1532318e98034c60398e698e4e5691676251ce0c1d70f9cd55935e258b60(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2d1a2570c21de703fc5fae52274d2c4b1295625f30d34b54230f3a71987b3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ca17165e891e0335fb239a6fbcff5ee700f556a50d02e522f996077926370d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb49bc9f5fd9d8258e56a55b68cd4d693b5d125cf928fffde9d4895fdc0284d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b13e88e5f8256c2cd6467939848d35200792631032e40f072ee844aad335590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f23296d16ab4ac6f0fb4e7cabff523a658b0e5dff1e6de45da5b5be5c8552f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47144dfcb7620d82251885565360453705721c0d2162f07f0a34b6620a30300a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17166b7674a4f6a6295eb6a68ca7d26d9889701b31b24d2c9e531835306f476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b022855ab0758ad6d0616708d532f364595b21537f9fc39e1af792dd63909876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00e6552e1702dbc246e6bb8ddeaee04978688f58ed0e00f4674d3b761bdf50c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdafa9e7c923a75550c67e20a71752fc969ba4784b4af5fa144919781e31acc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265b96478d33a4f9fb9778a7c9f485e8d95ba6043c69c72e3f72cee0cc6d0c8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150982d66f4a92622d02ecb66cc06ceaa5c7803901fa3f7bd46f60f09a19989f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534125a88f4a809024956f3ed6d570cc55be8303f47e2f597cd674b976d53a1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419d3cf5bce2d0fc7b90d0c2e1a49034b6b16184d6fb0393a63439d47204250e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c736dda65af18f3e489c199674e26d4cb409b3d546cf0b40842d3fb9da5642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc9c7eec84f587206ae6477c1dcb816a7b52aded05ea3bcda729b26080d10c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e43b509d8e546948035f40e322c77a813da33dee634dc7357307609135006c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1d8d5c6b996d0625eb47741069918094b345e4c4e45ef457defafbfb18a9f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4359f2e7dc21e49cfda5d79382c74ebde23e44b9d928a8f9cda5a57b9d133d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f2b164e52b57aca61636487bc211810c00a3475cf7033c369e9fff0cb7784a(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708c7648916704b416593f3917b681d95ef93836a3bc0385801422b8dbaed122(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be450d5a39d73cab765040d75835fcfc3999219e050675ab87dacb0dd6b528ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5154baa87fc3074fa45efa27b0015cf2bafda8b8951dd58b28118f776512cb21(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51204877ad733890dcae74bd3476e6b1f12acb8ec2f45c7168a2171f161d00e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d9584f944f50a0e6b469d05e29339e253840e144ba2117b4e7f446b3cf7fe8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6061192e57230b05b8ff4ac792bcfcab218ed43eec31577aa9ac0b889a25cb8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b37877c55ec4d614fcdeb2aece7fbf77913c8ccd9fce43c78ceb1810c449c32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a866fa719ebdbefbc0d241e63d83ae47236edfa6fc7d15a12a033fe87289b821(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9a78191bfad61e2a1f7f2f96e5cfe5d23df008636cf4bd5e177ca425434d5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5324e02124ea678d05db33a4569b2319792b2ca08ad71592ff56a7fa460e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8800f4d2e31cb30fc5f05bb97e05b63f7bd534b79674cf69594b90aaf204d450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49007cb06b3efe0b31d8dac9bce05c726df3981d83cf8ae014983becef309c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c1dbca85e4f88d8d18145ecd1b9dd371c354dde4d69ae562e64c4f641cebe9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8de9f03d7db0e95c1c9ce974515dc0118bb11dfa1ded09e854c8df0e7afb91a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83506883aac164a134cdcc30ed54446040b07c945171bd713929da9d80f7051(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e4ce528dd667cab4117bd8fc45c08effbfb0f42f9be8147337fbbe3ba83ea5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__114f424ec902ba066ad4c29a7c40327235db12c63b93e6eda2d09cb70899209c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb28228b423c92c7cdd927031a3f5149574cc7772d4da733d32f70548734f742(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cb7a9b6195ec03ff62911f0dca82cb7c6930089775961cdb7909f22a086880(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a48b879378e814eec7c95ad996792fb60f9c5fd9f0a091ecfec6732367e348(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a282959bd57a5a35d2bf48b9a8dc7be4398a0917f1feade13269ebfaa8b39f6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2722af0c46079d65f54ddcac512eb9aebe8a0428a40dd6ee2e71f8a7332cd5cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4e015b316581124e910cfc45473113ae869f72a6c7383e2bcf3e91ab943aa8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1339ca2c61cb2322ba6953e9cb907d133c0eb1a0d75178deccd005b249ddfff2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b963fedb47b0c7ad99e3175c8a538d483138871dedd87f9e5d2d39d55f500c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0acd794c6837f45ee039b854ae5ebc0d4904b99d08a6c15e927941453810cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b61be95e2de9f61cb2a4472ba776ce51ff0c724ba378aae76b7eb793865277(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8973e0418bb0ad3dddda4128555d52dbafe6c8126466d1ca5e4f522e267d871(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ffeb33da56c4bc140c2ce6c6ae914a01549417ad3ff75508846c29fac0fcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8e6611476b50e1b8f147540b491e97571124444313717477d25c527be7e226(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9bb1f2085716c4cbe337f5646d0c9c99c1a3d159c6f6bc18726f3ef443c42d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab858f5db9a6863aa87ba9115459f26908a55ae9342adf9e84822675a4aa775(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae042bd0257649debd211f75ebd30bbe3be95a4233e0768db9c3c78e74f8bfcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9b54e6a050b41cbda8224a63b156484bab397e98ee7b8b08d8c56c4f49aea2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffeb25db26f0a88d75e9c22499e44b031c664a6407ca720c33c37b325b9df09b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69fb3ca594ba41a2f37a59122b363b511411dc005f69e9df02e371afa820ac8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd38f7551778fd5abe578c8fd37f5ab43ca0773796ae2f33cb0edab1b151b389(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfda79255f347f6b00f3cb46e29eedacba2016770a405081ef59cc64a2047af2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f60ea93890eb5fa0e769e866fa5db348f9b4a8154ad25ff225de804e5f4d40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f487485cae3d06fa12b310a6dc7344f7275b6f2251489bbd5a87b2ab5011152e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70adbe1e0b02bb1a5740a501618d384a4230f0d9013ef9f6c97642797acdac19(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7dffd5678af4a135c1fc5c0a175c9ca9eaabfd73f067ec1b672b9d33efc7fd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdf66ee992b474a5b18230a18aa8cb222ea92075ee655045cc9bbb604214d38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9abb1d685f0f8bd6077d89ad5d7bfaf30de4a1b6e38e6783540963d590969adc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b89197a2c01554a008c7e45557d87285496b68c16cb5a810f1ce7415b28d324(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b43ca20c9dd6526e6acaff5a135d0c9ea3370511b0a59fc46a995dfc9df01d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a88c9835f7ee5632b6b0352ea817b3db21b5e6c08d79df24e4665c70043e405(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f33bdc93ebdea7a22d103c1e6dc4dfaa6bb870762fec198ee53808edc33361(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883ad2ee0f21cde8a8bf8d69f4a4e900a718025b16adce942273485a4aefb933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8227341c028f16b51814ac23ba3a7ec25a67d1168a9b3c5257e46d3d7fa7464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebae613e4ed9c8d6b47a508470e2655f2d6ebdcbc36dfb96f5b71aab0f208360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b56d1fe8b6d42685352bab09aad1961e4e40d0a5a9522e9ddf54fc1f0778941e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef7329f38e51602d3a93e81ae49bf34a6908faf0a238bc3efb690759a3f346f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc063f9b00899ed133c278ed87115e130a2781900aca4c1599144f7e474f191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0848051a411c36f3ae9cb3a388879efcec4eb6347d82cbb8fc1f90522b7ff1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783086068957b377dfca1f18e1841f789ae8b935f916e2d8236dc9d3f05c78e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a146be55ddd36f40845e05176b230e81a7b3a68305006a4dfd9d635e49e5cad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61aca6f32d36f7c29a11910f9bec3e35023a18a76ec29aa5c88434a2eb57baa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57ae897f09ac17fc067e23f2a67d8b4ecbfa6a137290cff0d5834fdd3b99ca2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f73f8ebc155974d7bd080cb3dd13f5c588514883a1852dffd87690fde0d1db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd28006b550b6bce371fce9d0f0ea6d985c21137ce967c065000fc377c26112(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28abbe9f246a1c7dd1ee2f68eb168bec416e26dc0bd9abbbbc4b8a298a9fddac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5f455ec70090a21cfc8520b5829889c5101dd52616395125e3e904b931e26e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae49f95aacd3a88f175664441d85955f778422c2c470c1326079906e9f55383f(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a29f8b696b96b7442de51a13b3bc0ab71d8f2d9c5c77210c5913375843da0c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328a947c23a6abec72c74a3a63da80aaf008bb79f60da999a0d7494209d1cbe0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a699e9b3633cd4c0960d817e8e49e89c235dda1ca2d321c62af2e5ff1182c266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff59cee7fb95228eded72a9018fc0eaa896db4b68587bbd78c4026c37af7e340(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a3b07238f056316a375388a1e2ba3186404951e437818cab116ba72c7533de8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5c28b7684ec515f50456eefe376bd61d9ab44a4c77aafa0444b96fbc97540a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3587c674068cdd12e6d57502630af23b8df4617fc7761966a859ff4f87a63556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5539c0f67411cb0e7d6deaf1a8bb34befbd4c08c4c16ebd802eb6e3990be25c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb054f11d39be06b5006967e36fc641de707fd87e8ea2dbd09177c1afe85553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50257dc7666424b7861fbca54feb1390f7babfad68510262408dea1224320434(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__349b807053faac359cc3ef3254831677f5488398b788b4fe84b607b4a7575300(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13498266731e5ec3a88ab335cfed559658839b3c11bb9e14db72e653eeb1bffd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe23c81d2baf6a4b3971020cb268ba6efb5dd998f9359bd0abe200d145aee04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1de8bb5421a77bbe96884368291e7e026a85e16f0fff3e892d6c2173f41035(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c2ef2c2db7b65688a86070f86677584e037ba3780a40c011c1dcbd2bcd415c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2590c5bb491d39d6e8b80f2f03e5f9f589a5e3be421122c73694726ac4f86951(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ce01dc2ad3b3aefd2f16492f1c3aa791134aaca7f00369883c7592d167d387(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7f24f7cfe6d43ef5275021fe7c767c906ddab2abcf898db3375fc42963fb36(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0986065363b0e397cba7dbe8f47f280e3f74a7a602718994aa6dabcb4c9ea92f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9d3145d47bb1f1810468323c5db53532ebd56849f47e50f4e22bbcb5b25e54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51ce90c5501813d038a4d9e26cd92bbe494a3ebc2e45a1464916b825de7c39a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__953f57d334303c28496ff4a24297d8ba6205df5d965beaead2a751968a4cd2d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e23ffdc4203a3d600ab2f7066a321817a751763d5b86882bca10d1a668ef4f44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dbd639b5ca709a0fc077d5d605d320df7d62a44fec4b780b2d8ff4f4bd1c50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7271d7277872497bb8d37d45d72a58bb6d66853058323e246baf870ec796e396(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b3451a23d7d7b022db0b63c0b981620399820ffa50554b4be1d9b37c1f8258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4355edbb4693e1d5c573e20e916fe40e00023dfdbdcc743888f3b634a5d2f5b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446a5538e060d9decd39d4cf28c0e95204b44ab33d13cefc3784e71af83324c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f23e443b7113b292e35e0ae02a9e1632e27dc60e940f42fabdd5a8c338e5ea2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60958a63dc85cf5ba30a4cd94188ac8ba37f8188072fe2d62bcd0a16f5cd1306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af72a12882fb95b36352073df4302fde63a5c365c21790431d06087aa711aebd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f091ef382c5f6de60ef0273ebe771dc7f6e58a5e4704f858a9bbad926b6cf69(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a667a53ede10fced0e39e61013b8bddfefda118dc08271812c9189f7e62e2f1a(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2c9ac218ad079e7e272b99a1ead15cc8d102497cc33231f2a81f009445f16c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95532ae492f9be44f694737d82c51995619a9f1dd5516b5acb11db61af388237(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c7d267b8857a5dd0d097d67bdf8f948e334e5d613e400d68f038125787a55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6c6a2b29fa9964b3986bcaf03c1fece1ea0c6b4ead30f16d8a95cba0eeaf700(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75fe3fc79c9013f81e2c4debb4e76eae15170429460e274a3ff49ca87c9fc33(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b82b9e17e0807e8fc80ecaf7638e31760dca00ca97fe4f3a4c3f3c6d3779db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19605a3ec57f4c883a20b266dfdad7e27be0e7c7ae9c31e5615458ee85fa6993(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052822070febe65f4bc16b7c91b2c85cc5a2695a254f4bc4ff9c0812208813db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcb23989c42bd3108a9d25b6604bf2186938d381d7534d3ca259ffa53da8556(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b924168d3b1b5085f3ac207bd438d07cd1739a4ca375f30b2073938c6762a1df(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338cd012a1ecdd9ffc698095d2130e7694fea3c38e80be72e8f0a3eb0aaeb6bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73daf55d03d6be72e2b261f3d8ad0f5ea902b67543f4f17b0d3984ad4356ceb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8e07df2977592f37e9c59246ac8d7745bf3cf0f7dbf3dd3fcdaa1fa3197fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c63429a3fc11a1808c8e24df58c52c1b50c2c9fd933ff90749da25ee89c8793(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665c0fe86eb40e07e01894f8102c6ec5fd87060450970ca502f3cfea70db955d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae501965a8136121a673af385d1c83915c9cfc927966ab42daa0008525131575(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f3b05bafa74c521e836ba2adf6a187926e7abf0aa45a624eaf5aec184ab5508(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe3d3e5fbcde97f01e91e01465bbcfec1c805bad5c1acebf859306bff39b4a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0c634469e6bad38f36e2ef4ebd617c2f945646fb25f6e963478f4e9bedb7d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d851f0708505658fc049c4688c784e375e821546b4f6194962b97c8eea7bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b30e291e1efb5d14c79b195f45f5468d8ddb86027b498fa84e127b5d0a4ee56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d7f76a1f6d3c469637e1bad4f9e20c510018191af2b79994a324d52456c51e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee81197b4ade093b13ac9b1c1c94d03de5a6485d8afd9666340f3dfd78de34cb(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__166f67e4da6558fb65df92822bb2f38ced4e2a4dbc610befabbca6fd11c26cec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db6c0d063a512c85a2da5757ccd2274f2f78bd9dc52667622e7920c36e6fa95(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f044e8cd153e334ccfa767d1a423057b4da646ecd2285a155051f4c352075a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68bc73404d40e9a26f2aa37fe1e330912fa745dfe1c6a8607a2e54db060f2594(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86ab5efd8d68b71e44d190cf41c01b5059e22d8a31043d6cdb48fc5590c7cbf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b519fc6cb244b21ec65d91c68c14612e1c683b6fa48d1f13e7083f66e5cecf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35ad99d2564da5474ca21affdad8ce13fa96913ca7232fb8dc74f13a51163d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d521cb4eb82a1b7d95d4a4d78f79f971b52bbc44cc88593f5dee201a51a3d509(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86db7b307732227c7a2139d7d7ddcfffe4257c5fc1940ad6df661f63d8705190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f196d06ea99f197239ddc9a0cbbd10688067db0bfc13a4bcf2c8cee9996428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605dc8be8d3c0aec187ee40fe7a78dd55ed9c2ebfbf85934d1f1171f4e33f29e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2831912997876c2f812a917483a82e3fb7ee5cae360a411a5ec662c431379d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3eb5985cc676cf58e383a6a80369298799f98b857db1deb562c21fa03516dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150195a20bdfeb6ccf7fde8c6c0756f4d2356634b9f036bfb79a1fbcde6bf28e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfde54b75a7a0fa7e2d0edab100086dfd738c448a25c0d7a2c8a657bb621f5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e3f1f86f873811f5c010b466a54b4c015850e13f9c1cc04212cfb6af08de3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07abcfde32d1d5f633e70faa9ed1087b0c8c23f13a97714c78d258530c736052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb45a818bab8725345d72ed091e2ec7344ddf7c8a56df6f8cd7daa5f101acf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50474598b988bfb7942aab20ce5861b735534402df8c4da11b86c9c69f3567c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377025778f23778a55a51157821480d7231650c7b992cc20b6cf2c1f28227d4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2966cb2ff8511e5e741a5ec21669f153c94bd6271c55029c667cc03d13f964ea(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e0b1b344d2483e656220126ef865ab11d4bac082a511aa0729083ea3525718(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0011c8a566c7a3e1449afcd94174301ac55b9d5c3be7aa0dcd897efbfd9dd9a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7a2bb20b29f02e51056caaff8065d79361df4b215c8596684519ada936f9b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822c68c2481254395e9a4157440ade4aa7182b6b9a158f683a9804fd23ee7333(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034573c17fd5502461b399f9be2bcba951e069d638b0d59ba0de0c741eba9532(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4a60597530c6e68b1c91330cb4ecbb7bc1e85bef0678641e90c0a35be50df9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3712393ea4f45ba69dd391ef937b9cf047d4b995f07f2d66cc016dfb273fea9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e992f09d79ca9bef2c0e3be872b4969b2228f06e830a4965a3953b139666a5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc6ceb99fbb1a483338094bf907c825d54c22274bf7a3b791756c793743bc01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da3d31898861590b7240a39641800363109b0806f41f2895e08fdeab2f8c0af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b81da2ea26735826aaea220ac69f3d6d18be175f0c7627c7bfa879609a025206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a487f43fe5b4daa721af5f4209cc1a7728b0c04db61956cbdda21779d55a72aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbbed07dca8e34b92ff56233b5fa44931572fe2d3f164cca8def9c347061545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa427498f38412201f7f9426963b773743ef33aa5aa13c89f7a05f78bf8db3da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f58a993b90192dc7fb78447950fe5244fb82fc3e20956b24d8dc5d225564df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64893807597d1b42dec2169355f8d9a372d49e8bfe6f5c63cc8ae784e7486658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84dcf3eb00e93fde64851eb4eb21e15b01f4bc39d689f73ad48808ebefc97b13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f277d0f450effaf0cdcc217a967839c60fc409ca40773f58d146cd2f2f21a1c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b373ae86c8d0b307cc393df3e43c542f2686d35ce44af9bf1ef8e927932d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb817b558dbabc4b066cc0cd0e0281aa30f6e0b125516eafbd248b9f8f5d962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57896376b4b53283bdd43ff208e550846b49b91ec7095e223d7d2af54629ed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4012bf0554c3870289f217784927e9f6352a4fe957a62b71b036253f8adc9d34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111106860ccd277752d4df4a714985dc9c95df25836ea205f49cd01315a23375(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba2f235b20a0120d45e2ec7dde3abd2b49e1f8e5c306d2852f5d45300445f5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f980a8dd5667fb1023c40f7675c63db3830a0b74450eba1585b00883df5da2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d400dd960bd892dd642c37f429ee155836b6713e41e3066eeefae75646c08b3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31df24fac4aaefb43e549643bfe414df656c354632a05291989180ba7c79dc7(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29216e42c8477f6557161f448ff2fe7c67a9199e5df1a5d1076aa5104edf1cbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17542c96e75c30e8101825a60386acf1236279f5b09801b531b67613043579c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fa0dc37c82edb9c709ec17cec515f5193406f436e9f2a8f6777a3789728c81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaf9d9d22053ea3bd003cc69a8e205242afea1e53b38bf9d489b09c9107c895(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e165b2df8a62bfd4806f434c7b958e695fa15e427adc3eaecd69a92ba52940df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2ba0538347ae614fbe7ff8ad2877e3f7e35cc6ab03030b5186b4306a6f8920(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13866cc70e5df7e48661825032c1be5b65a06dba46325f616dfffc8163b30f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7260265af031b6ef3ffd20fe9a4ca00c73a158d5082d07acffe399c9f82de9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d2412c8d984c0c4b9c39d49bc392388c3c9f1c0a3ca75071b55396a5c94f8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453fdd6192f0414f8729e8b42e98a3bed0cff751b77d6b06ea84de75c9f1b675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40542994811c5fb809586c9baf153f9bacf3337a7600eaecf3bd6e2f88b242b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53e359759dc9901cbfdc15f826a327d045729dca533b13b99c634e510a086a37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536af20d1425f1869324ebc830de4fb640953ba2567f64215c96ecded61ab7a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f697017c009f0b4466af030b4386303cf323321596cfdbd3b911edb6bad340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__434990be3ce8968f9581d1014e1ea80e72515b0398f9b6f9eb4fbff095b02a34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5910089d355990ce4faa11e13611fb4c94e7a35ec19a4bd7cd0e4efc1a5905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8458bd2936796bf0fc06172d6173eb24076acee8c88c8b01c08fd5e9ae034b05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8906eff308e6b33885282c13d9375fccd0dc10cfd3ca8e3cdce1555e81c36c3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54cacca4d1001a80a4be6854be7c2658e92c63c4ef17c7347674071c796219aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6bccb203c268d29bc8e202266146aee2f149b303e1c1758923f285329ec681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c422ccca640e0de50316bcf3da5a037eb6b396be53e64e53de44395143feb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f366f3cebb51dd34d8baf90c47cc61ed39c4ccdc8308209594e8f0165f3cc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03658aa847587d6afe3507f5c70d6f37e5c9d154d0c6aee184d0b3ee1c4a2292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba46c93fd6048e8267cf8d999d1d4a26d2a88490c63ad381f05bca935d8d1516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d600c86e32213ca5bde347b488084972f8ba7eedd6e35d98537e939f65d2c4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16d401a6ab917d3737bed37be4ff05fb5e10482666071105aa626fa4c533ba8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7972e588a247bd4d7fd6c251132d189f822b05451bd02116648a94aeb97c7389(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a64d6fd9c50b513a516e278e74adbd52b6f64e618623c4850302b2f13f97dd(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9777d9d2537e65c2b9858f7445c87d60a1264a5844b69560bd10827270db18a5(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cef9a0e4f8115978f0f3e94ad59b6f02a4548cc16b7b2d22a5c7f29a12639b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fcb1b16eceb713a94f63514a2f8cb20811c845eef1cea89741ec69272ca3ec6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889bb5b77b64a906bb69fe35307d673ee49b7a407917e0aae0e7ef55fb9a97cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b8275da14c5182ccaec37091f1baaec5b159c9f0926759a2aa2f69f0289978(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd930a0fd6adacd23aa65a618e30dda56c68ba532e62d86a8d99fbd07d21683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7ea0e5f465312815706e7d78134157421c62d6dc0da2c8bd992dfdabe14a02(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9248066303231c1c1afcc4e8a77c34c31d4714cba7759ef71b6281ce39c33c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458e5b6169c21cf23c5b0c418209b051389f91af4fbd84414805b3a1362dcd1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5395680acb437aa5bd05333d6c57b3955dc1483f555d4997f38838306fd32db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c17a30baaaf255a2e36e70927d3e875166263bb676a8a01d88364d62c72568b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f299401390895e296fce64d5abffb0aa26b70d3db3b1713d2744560a7168132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e6cfeb1a94bb71008204b0c85489f11e46f451cbac2cd68809b76e8108bd38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3671a65b58fe53e147fefef01774624c6e71c5a1caa000252d1f76ccbf81d38f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad8d8ee6094b5b7d77b848a1dbb15432609b9f7f6a331e69d2b57a3c1efa81d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca8489d19700ec973b8dd0b2c88b36f53b2da49d4103cd995b5b02aaca5c1ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9275481c826a80fe4b59e01f3f6e261439ec7f8ddbee3b4ba30790b9793e03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e226072d5dbc69b917b0eae757f74b75f655942866f36995c812660a1d4ca750(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29bd055f6b411af80e1d28b2503c4c1073d811a15407e03b4ca066ca4bbc7480(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea368e0609d82843bbf03cbd3740d5a9906fda06edd89352cfebda1f1ac57846(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e154038aed22af4b6ac040c8066f7dfc0bb735ce683d85433f1f71b5b8e6254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a639b302f076a3f7ce6c68adfe5e01f604685582be200b7c5fe28e54c219ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12895c7c37f30c05ff75b6d92585a54276f7ea88b35da0cb75ffd53d3ec0dbe4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d96038c484ad704f539812f92ee78b560939f67931b83dc294d299f2309a6e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2979348625a1f0b0aa6239e169e65d5d789a3b4ecd93eb98d27b5842ad01ccd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797760189cc43db78812116fbadad48956b6f84dc6b0e019cccd30b8b1f1b46d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e05cd10abd3d1db319e350360b779a6aa3d10a2677f24eb9acdf52428b7322f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae2875bc57f4665cc6dc15278e5a2288427ee9570c9a5a553d8d192a49bf97d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b591d49de92bc438825aabf4845003f6bb24cf8ad75fad21fdcf417183a71d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1592d26ce7ddb719897cb783fe5137b88fe83b7c6cec7abdb289d2b2745a70d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64b1dcf1763e0ced0ecb72a46f110e6a7ea62bd4a5f878558568ccdfb6f1f30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2eddffb1f64cb71fe3e52da1be75c9b82f0d36214fc7d3de13746034b68808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4026e3c7b4ebd2145830dddbe9546ec16b13cc00209bc8049f8cd2b676f0fec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c235f53f18b335cff0313962b60df831230da472de82ce11f563f03e038695c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2839152bf9634a1c63f1be883fe66ff921dcc36c9b2233b11750a9106824a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701fab5d8e49403a263dbeebc289757498dea5e1ab8d8e947d6f7fbe08e37686(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65986ce228593adcea9b188aef56c1fec8441c0cbe11e527d40508f3af67d286(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea7962cebceea822698fe6b7e00f1eb78b63e33b6ede7b0019d20f6cdd21a8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f1dd0429c3642719da9e5f0fdd805ae850937155fae9bd5d97e56be0a9f244(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a12e66ffbc7d2d6e5c48524b2a810f69abe07eef56f36f47349ef2327afb15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55657280e75814112d084c353e5640cb6bac456314763a08b8dbac6e3fc08f73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b629a917eefd75f8bd3bcb68f672a96b6d10d1031594d3fc8794a28abe9ee82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__977ac74510107e3a2403420e0eee47068ef05572ae1b0035d0ea88c1b612e885(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caea199a9e58cec324e129bc51ac3906265e0a3311cdd6a21a1fbaf0f98c92be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a20655b646d359d301ffe074133c353e8274c327a443c51f0f7b179c63307840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06164b1f6b7c12c7714b9b9977a9dc7600c0e827c0894968d10998ae24b5549(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fb24b03028c49bd14527b3c9d5b443c96e4aba212bddaec7cee724cd7efef7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6f2f0996b3278cdbe025681e3cf72290bc8345185c097f8bb098db0f490f8f(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706e993fe90cb13b95a192c80aeb24990e21328c478dd8365cdd2059e27f850e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18205f01cb5c9bcdda6b0f68d8fe5980a327ccd93be9096d221409a968154a5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740958b5368aceb0e52fe37eaec7c3998d2bb0dce87f01dcf6d5c1ee27b15fd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c1c7c1b412345a20ba53a63a9211625f4b35890f83fd3cd2890713dc363786(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f47b3c6679d4b25b897db7fe960ee83d111dea9080e2cd0bfdab38dc6cf99e8b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8302644780365aa9a69202e26494c85c0488b6fe13ed972786500ecb346d5ebf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bafafef79081ad00897f9a890aac3132e3e8977c275a517c566d178eecbe50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3bdde5dc68eca9b4862624aac0fc3e15cc7c6b340b5de6b1849137603806e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef76865e6c7907dc2f490bb37528dbcfe53e8dfac5ca0f18e495525f85246fb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb270ac6d5a3bf2cddf866311e9d82d195d378293a3bf5b1c13df7cf0cdc3118(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffb87b02f3a247107271d073a5186aa9790194f92bada8f51f142d9eab10bbf(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47e768a98e68799ac3da54076f818ef97da7893c49633015b3456135bb2e892(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef8d0672242f9e73731fd1d9c356d784ce6d0f542bc42348079a4db7a29c9f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef9feea5cd31fd468e14cbcb14fb9230381c6ff129db1875d51505a80c883a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744131f196e7f66a9fa2e043cab0f1d9a3fd216d70c7dd81a4b5d441d417d520(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5656c6c08e563fab1ced11b089da2ae7b2e77f0341c91e8b89196aa908f95d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8acb4d48eba05d1a70cdb157ba483e008c393cd89b70325a6c655796cf98380(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97b8fdc0d9c778f1933ca126fb4972ffd4421623668a139e591a59f762bfa0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc97a11783f9fd20d5d40d0a0d960be7dc709d406d4bbffb96dd1085c60dc81a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d872cb66795ea1039f772775f1b43dcbee848058b216e81139ed409a97aa165(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfc85dcfc70f2de6c3851759f84a852fe98810e9d8116f47f5889fa11d47464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a4b4c8409c7d6caf124302c223e55082fae771f4d7e26310f11a527310b3ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94da47fff30c665f9721a53384d2febfedff6992e4e1abb6909b7738febeae89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ec321dfd1b1592328e6a8a28bc05f119380cba145f641936b540537ee84d90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598d3f2a3c907afe216cb9592a4cd0a71b52a28224d2fd0a4c9c94b50dd0f628(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb507ab2c5ea2b9e959e8295c9d004017679e64af2cc059d2f5ab7c9c6555e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56d8ff5f33cac3339c138894c1cb40c174842040c55a33270589edc1179ffc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bd8e4f7a3710cdc3bf429e6d2b08a7ac498af442fa4d4b47481a0d8deda42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c587420b2fa5cedb74882f365eb3e8cbef3ce0782895ad2de6f8ecb9141c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9401438ecda754d31aec8a149e9e701981fde25519c79e0f9dbe613646c0b9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98dbf4662c9bdd23de416b0891287e954981cbe0e12ab74f5e7fde670d1fadd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c7bc4350241319451f5538e35c672cc133c64b9cde811a4a68bc1957b1ccaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41cc8acefff90b4d4b859fc62ce080c0d2a8a981cdb00afe17b5ff087166549c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__231b9eaa053c23dc009b0f4dba0d2942946210db02dceee01bf76092804350eb(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fee3c9a9a8335169fc704052909390b8332c167df0692e3f845342c0301f0f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bd3b891c8b405c40e0458bb15f86fa08240f07ba22fb84d1a3aa5f2f5f8106(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8d7aa656e114101483fac0ea62feae00d31aa7e127f2f053b6cd6f154503e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9056c0952e1f79bb0fe2ff47adec0f4b2d304283c5dca78704b013c109dae33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3738dbddbc77394a878c3a3547b2560bbb246e0cc6da384fc297e8e2ae48e82b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacf35cf91c8ccca8de82b1b33e8f7176856a68033b8bcf2d583fa50d580dd87(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882e6a00bd2eae31e44c8e91ea1607784f89728eb8e55e5ca81dbf5c3274b67c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ca6b5ad49195c7a1f1e0c5cf95981a1e5b774912f21a12202bd97ad8e59ea8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023effec17aac4322972f9352a709a35d946ec0a7105ef29ba43caf697cb6738(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd7b1947b14a2e8ee55f220ebc56fa58225aad0061b6d7e8e0879275c25939c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca85d89fa54e220a2e52ce0b57667fd24e07fd15250e113197e2e7e3d215291f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff0825d9008225a09ce9801c6e5611fede943161808fd22e9acc6e41d0dbde4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c923d8a68641ead9cdea3aad5281e385b51e18fabec961efa3f54c26a7bf510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5efceaa04418c82654423858febd1f1b4061ab65ef24fbc81ceaac676a510f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20036e061a97f94189f6f6958c2d2470d2bc6b882d943373aef6d9e0cf3e01f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2c0adc004239f60d0e1fc739daa33df5ff98bc71a22bf862e206b411a81143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b21ee0f8926884461353ec4ad9ac0e58965813ec9d573dda9de1aedccec07619(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed91f2716c093e1bc92cd321adcc21b409a1fab0919cecd0d472949cd93e6fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8a49342049805a0410f69414da2ac5075cea031d0c49b57e82819dad3fed72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53cd71233ed4c29cc95d6389b08e8bc2e666615269af3c2ab4cd51e6f3b76052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01c25b15d023ac618b369fd9375d20507adc5469334e81e7079a7b769ba2333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8900d5f437219fab5cda506d4d3539a354771be7ae0892871ec94e9fbcce18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9503a3b4547ee5ea3f9e4eb0ff7b993b9d87daf5736ad3a046e104dc981cd673(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac97a4437fab92b10c9ad9d244c628925cef84f8c1f649f9e4d891067d50e6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__480f976d13a9c1cc6a541ed24f52be897a6977a1672019e26ea2647ddf349b35(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfbfda7e15a0670063bdc98e0d95c0e146616e16f5c0542a8e0088aab41f8c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b613182404b80c6c537c3ed35539e133da024db1dc282fd09c16373a08d26f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e564bd33ce58b1f4673d7863bcbde5519ca90e67205cb6d28d4fd4f6cbecdada(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b1dfe1b940c9aa624a30440a355ddacd931b46d84ca4ba82a75fde41d685cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06780dc7d6b653b5ca7f8c0fd289975f529a22f5d9f20ba8de399b62ba42a914(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4bf7710ca7845dd4840cc976288f786dcea1001f83d048ae57ff40b93a9a0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8305183101be1f86c39e6ef2e73de100ce92249b87e156027139839d40885c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3aa08d9eec78fdb83971b4ae880ef3b37d49b320dba95d555f678ca1f6c2ee9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15776b7a01f2d867cf506dfdbedd5463587942ae7be683358faf79c3dbb085f3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b4aa1a65df1c125778ddc3c1ca8099dded21623a0dba7a7de163ee360cb073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f32806bc2e73310350874175cd71847289eecc4ef98516633a4b4646e54292f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a174bb4a67c26704443633bb0a35a22388e7a9fac9e2009befbf175963bcac0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2106f5201809d74b696d4a59082234107c0767a344859da82447a34fedaafa1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42006bba97154880d81ffc294cc117f680088c7ef4350f0f685de49c11be554(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0779c19c10276cfee91ac842a1706a23c6aef5f0f3a41149df3189bc694f7a38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b196c79f63bf80131aea2f039c8ba9a2abe707ca8ee4a46ea47b2d1ab44092(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e134a1b3ffe8107aab331bd6f22071333929c2d242d5442c66631aa509880c7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908578eabff1dfb1879d0215030a5e576f2cb31ae2f89625e942ff3d19687558(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44545202277daed969eb1bb607064680420fac9ffd684483af19849733da2d08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c226c753d6da903c4813c563427b99706c924ddf6f9426d1f47e98e4c49199(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cfaf967deca97705f053dd90579786af7061d4e1b8adc0eeb1f26d46917faae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb2851aec0f1362cdee049d69d96b02aa99cf09f7771bba1693ce858d6082c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b34aa0662d831b462451064d9b8a56f48a583aded73a535ca6b864d7664cfb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a2382a12cb873cc8ea746b4c1cda584ed2f45ad1262ca850dfdb2e6be525812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d440b15e6ca38a800da1d536935fe331673906d44c35f82b905e3cb34407936e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b8e52ac4615eaf8ebfd74d38599b982686a6cffa1fde341eabbfacf06fb85c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59a330a67cb282e02762fabe4f676efb8395da071e037f99d50c7d23d3f2cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17702db20c64d0e9b4f4e0333b835149585331ab24524c0d9511e6fb0c44477b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3628ad8dfbd3c3e6610041e6b0d2dca3ef3cf5abc1054893e3ccd565635087e(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22f1eeb242cb727e66171d4df0759dba30d0813ed1a7ecd995b17a7f33ebdd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b960000ea6412900fb9aa70336f8b3e3ee7dfa2c3368d1db966af8ddc39c2578(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269631b95239a6622e2080545b7c885961f969b28e9f0dfb24c72760b83b3eb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d3b5bf49c63a5d5fed9bf39b69302ac66d1216d4955151cf561084e23ff1b1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6afad9ca717a6b4036c1b7a21e39edc6025efc74b31a97650e74ca52d38ef26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9a96788a65e72e66eb4c0607ade6d0db81d38dd9c8dab3a8acf1ed72379771(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__846290406abc9ca05f7f84ce4bd2f7c9e9e86d5d3036bcd5d4d63a158abb1408(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ef91e2beba8d74e844c498b9972e95785cb267f3f64ec308eb5f368941d297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5054e330910965a4fc7bdc9ba3ddb6d26419302656eef95c00e2d140242b5638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f06be1942df7f68e7a6976ebd5099d1dd935c2edd08e5237171578b93a8b65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2173a1f83d52b79e802006f7b1e753836f9028b27555514bc5110fb53c560449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc9da4e9ecae4c9cb81606a9fe424940f0b0bdb554c4145e586453c4d54b8be1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2656c1f6ebda48075d104e0bb99239a711b4efdcb63ab9260770396b085660d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220b58c21e7868e4618eec9937a3f7b3032dbd81c9ca4d9df6f4ea153ae8547f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94f05a7e504d7d3ca70fc7eec54761925d7b9d13707c6d51be779deef7166fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4f533d78b472001020050213c071d8c02513f33bd859e3b19cbcffebf57cd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f0a5341026f5ba20c01d904860c97228cb675333a7a55ec211592dc970c853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce60354028095c03a3d1389b8fb17038ce7fc5593e7108c194630feb6188ab63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54d3e463c7794591725b86c5365f35ba327fdd804180cc6d72809924ad9351d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519520db29d248998d6c6d0b3b65b485918c26fa998baae0377b5b97a4c23de5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0d0bf7e128c0d30a4dcbd294847feec87254fbc80a74c1303c07cb8131a3e9(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93dca81857adeacf84921c8130c201c76ea968efb7fa005a7e1d7b26ffdafad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d8e0b46eb2e8f49afe27054f5809f03122f1e83d11a01b5ce526008ba5d761(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a1cdc1c366ddecf23197d08e03528695bf3b81f6bf91b5f3114dc03cd9cefd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a172249c04e5a4ebf6d1f76fa3fb166b6672cec176b51cd167a8c01f50a6385(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0500afd024aeef9a3065800bc42eb2ef6c0237052a69a9e0c58f15c67e34abf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b9696fd54e49c9e8efbb7c93167237e72c7d217fe4cf1cf484903915f0740d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7123d39ed3996de69761b570f4a6116cd09671d1d092f184cce2e45b6bf1af7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc3935ecc7ec5521771fb0d0917fe0a7ea4922f6a66f2cc5568d0a6a8c51ab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3bbc61cdc0cb04cc6e9541af59f8b8158f0360fec583c54eab1d31cab724045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052ffb58bf8b5ad2a462087f9cf3ca30a735285022271f03cf1d63359e5e593d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e3d8ed8e9540f5c5dafefe35d4c0c4157ed56072eda42461327a85a7f3ff384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d02cc4ecf2a2553e624b1f4f7ea0e40abd663ffe692be4e7a7aea6863ae1d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad8608914bf5e43a0132354dbc1a30e46d8560edc96a4308f3dce2fa41eab0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808ef14169cc21d4c4f7a86aae838bfad600bd25b400476fc1de7ff3efc71170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d8e6ae76fd75cd201b174c10e3829baf3c2dce2f8a74c5cdccdcd331f81817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c485a691d89c61325febbc16a32b26d27d4c4c3f53fe033b0ce8c69e0939111a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c88c82caf74eef969a67b0eaa2eafde315943a0ba470407b7a6bf87048ee8ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a97a57ab4913132b0e8318c3f71e898ce8730317c22ffd6a668505d6fca051(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470b9776b7699e5c08f6933d935c21f593a2057c49b3140421008538fe7e14c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c43a329b001a100abdc407e7736d375d2b3507721d682dedbce07a559626657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__008f75e46cc90f484616467756a40ea22f582dfef9ce089336978853e995446a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf7fe6cbc7fa12072b6beedcb19209a9ad464d99389292af3fc41a110104aba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e9b8783d4090409d59db5d0d1b349f58b81b1b284be472803bbc21dbb0fb673(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1934c51cee8f53263242fcb02d4bc5cfacb30012468a7b74d03fd8cdf7526bfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2709bf165cdc8bcee476cb7e2169e5605e2a21bcaec54b78786fb8dcf0927d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ea66f3d648249c88071dbf6b431fe3f1c9f06044d19398f65276f5c660b534(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4177368de1abdeefd5d5bf3fc7b3e6dea5d3be9f0ae44005cfa6b9350ffe5a6(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d944bf74f4fc88dde408c58db93223fff1820bb368da8581046282225682c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d850bb70f368c45a3776773c571c70f80238dcfd864ac4a3b13cb8a4f77d3f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa9a8777b558d8544aa381f9e3e775eed48e7a393403623aa7d605065545e9ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73719819c4f600699451dcb6b445b57e72471369640c927170f1b27a744ef3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028b3487fcba03de203a8a2fc3089d5f032e8e962997a0d04a2e83ff55dc9be3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a564ec80eb64e02c37b513ade247522eb77d31ff9846f2c06653be2acd08c7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9066fd9264da4a1ea6671e7c19bfba2d1a6c32366d4fc75646c0c0ad8c98f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eac129c59bb9cd7be4a3557395e09221308b99897ef822f21dd49275262aafa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35edb366470207dff397d05ab599906957509faa1e1b653330fa4e56919c6873(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bbed6be0586dfdd9bce52f935e621d81342ddf2b6a2b5eac18e5c858e5cd7c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2406c098da679b5ff7d1d81f69324ebccb1b49b67e4488c73785229dfc39bfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee9dfce857bd3cad4ac4bdadf06d8a36d0b64404094d43b5f51f90c916a79e78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9197fc3ea9117937bd320c045bf31038d155aaccffc63369bde6892f87db1501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e68085d7a061d522cf8b8d1d0943e0c79fae7b4041c43df6b5e255c50fae92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f35b6e70b43ad86343aa815f67c6660eedfa488b87ce71e2a1ef07b0de20acb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7156076d8991137e686ac2a243b2701b41ca7c2c3444db5fd9fdaab438938a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ccd8761bc696a2770e2c0096367e4ba40d35da6da6257da29a263d5ab1bdec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d564900a3ee5768e39b558c826db6f52aaa3ce243ca8ee80df150766e1f062(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f127bd234563e5ef4c754f62cb6a8106332d8e22f25fd698866441f5d1f14e25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca022ff2da9947bb3008561b2996059809588c1de13d139d4d9781f11a7f45b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7480b6d06b8673722b218f897335b25c17bdc5420f8beb794195a71cca893c69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985a36b572b827c7336c05929cdef719873d9719f4d5ed7eb6e975a117db6a43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc00fe4504e45050f24b51d4337eab120519f654824876a03536cb755658355(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e10c8431b019a4c5732ee43d62ac9615e631d40baea1f2c93ff2ef241368dea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace7e9526a06a0fc2aa261622bdaacdaff5b40e73f84726fe25943b3cc30a2ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b35cfcfa06c7570612f5bd4af22fcacb17e3e470fd51266ea5241255708f33a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b19686a3d230adb6cff92c7205489a84e2d476acb32d008e457a79a73788f5d(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7106e766d400c9b52395b6c49f08bffb643f53c47d4d61ee5d0617a5c67e21dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f654565cc729dbd22e6f964d5ea3973f429b78ae82520134332542c74821d2b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce0dda1aba923e5c01dbedc685b9ca983beb5bcdab36bf7c0d2fadadd4f8e39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14caafdc3e17b4f153ddcbb2adfa773d0a2cd2ab354aa82058457e97777a869(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5e330465764beb40198c3aba3aecbdc55310632472249bd89b0dc9d27078d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48715bd34ec16c92b6cd1119de7fc9494c7c38716d1769f6492494245fd3c2d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01ec2b3139f5d917f9d8f659f140c7915d90e51a598531a118627e1e663930c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca6a16a865269cc403a3d90378c741ee820f8067aae426478c3a461b6087bef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b716e5c2d4265ffaa7e0f197426e609ceb2bf6c927550ff21b04628025d06b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f116162c59dbb41f4493e23752ab65ecc09c8df0825beb3d179e0493cc9e133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d9000c8b9e93c0d2080c06659cd8d51d75c9743ac23d542d39463a55387762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d28b6958482df79a25e26da4bf4ce2179d2e5bb6ec8fdb53d2ad05f43b68909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c1a8010fa3b52d202ac723848df4c107670571ed9080d80c13ae17cce45568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1bcf3364d6706332d7cb9bf5a74e82ea23111c7c28162003d206f567c35fa5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326ee12f831079005a917a5f63619fb3018a56f43630e7da089285d1a74fac0e(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f2cdb1b1463e222825d0593e86722e389a930f0439256369a2c3d1e294dd3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855bb48871326d66d9958e4106e40aa665c77f81ae0fd6fa9bb8dc03d6f43778(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f85a0de7fa8b304fed1b3904d0bbe68b4a998f1031cc2ced3e5c92b082ed7c3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f821293fd56788083d7cbe82ffc8e801e3a9b69e1191b0cbf7581aa4976fc37d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e4fcef63ba078b2205eddd67808764a169891a4c380321d04c6dbc0351397f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf48d968dbfa05a9f23ab8e049d44ba81367bf0fdf4daa5d86ad799297a14a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b9dfe226469a7d3c80de34cd338a578d4f65834ba02a04d3db489ba9626bfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb14fca0975943badaaf0b16a9fc2d06d7c3f97eeb096be2f2ad50e78c075cb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c1a2b1a8ddf3d7a656ab0a67c3a11225e63d00e7e837a5d8cb335c69946a30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c013ac013369062fef7e9918e025db6485e03d5236c4fe9e6afa9ac222420de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__754e0b27df5c641740b9bde91675c0a6d67636a457d0ae4b86fb50b1e55dedc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95507e2c3e86d410322c3c68aa93b5600604d992185f6763a8672cfc5e0a4fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a367bfc02cdef5e626c89ed9df3899ba0d819ec800c9f98a2e7b5d707d3386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4257fffbf8b4b5bee3c75407fb15841e77f9233a56866a3a134d0d02d5c9baa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5812ed77b2ece2dd43095357e79f0bfb0a777e17fb64d224965f8c7f5af17628(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e629c7f0c4f79db28e43412e3f2b9e0cfb4abb73941ee85b51e81323eeedc528(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff542d095f9f800a8f7c5c4c22001a3fffd1db23736754b488da81715124ee76(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5884cb00f0bbb5d4d6506986b1b63fdb61a9855a9618f40eb583fc0215eafd0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3559ed8be9c3d49a745d85db4a87a4c5fd8742b24db5dedcd4f7dcebeead0c9b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f0b06e0f938811b8af79e2809ddcbcc6c7e87321b3b9ff45e861a0050ae2e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28641004d235dcd41c3ebed5d29f654419acc7b7bda46846811936fc146f354e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27701729d39b0aa7bfcc662c4ebc9f25be472a467e9a84d4ba3febfe7cb4e11(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c928fdefafe76c62a1a4f43abd1ee479fb169dccc4d270db4cf008a6a6e7cc06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8e18f71373e155b3215ae4d34734bdc5d3406ced522052e03cabdf881d0cd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebca6b35c92ba3c0c103c1eccc6988b8d84ee26e2ba2f4ea58e9a3ebd1c4d87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9381d60a1cafa0f0a3bb03eee2c77b2ff9487e705b5b9ec2c782b505b0dc1f15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__324c1ce034aad98c86710cc8f563255025392f7eaf9497f6775dd1f3f973a027(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124c203f73170d057bea5ff792db3fb9d99816bb10879e23bcd2568a71d33b48(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e7e4978380efcb0035b82c8532078f1f19a0cb558c6fe0e25ac0d0a20c5368(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1639d0d358ed0e00c0c8eb462b59237453ad8aff4d9c0cfd8d88273198c2ac7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a184ab11a87f647e6cfc560012ef1f52268ad33748dc8e7450dfef1ceffc79ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1138b0c6b03a16923567708c89ed81ea00be43cf826cb32cbff0ddb20f47fd72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95138a3591e260551196d8df58eaf10440b5652084446f3f5e15434ac9874044(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02cd01a26b261361e1ed312882f3677826a898ee6fc1d0ead470084b467b1081(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4df095c921659ef51b62810339ccb438734bf42d83c08b44e986658be0256c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f8f652a297a08480a61a18d96cb378705d4bab305663e127a75ddc3c566f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08217b7497faaa73255c9be284f84c61e16761f53020d24186107b2cae7a4750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32f386f89e632c08cfdff4321fc436d90bef5cbe5b35aa5946e9935c417003d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9175143d5cf5796ba70c8006be26fa6964b88e84b655a2fd582403bd90ee88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e459d43730b4136d9d0dbe7e449bc04edd7f03b5ed4a631a6c6d241bd0e77c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63a5eae389f8760e35e6c478a5ab6f3a553e438c60cacfdfad36247ac95b5fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530bfea7fc7eb83f7036800712a8e95fa3b94b70370676c0884aa6a2bed45bff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88861665a19e53645ba9d41ce6abd1acabb5b5b938d367734d52d4d177e165f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d874c2a3aa1c7d56225d80091ca9ef63b0c9cac9d90109e196b2545900b46da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d110fe8f146757b134d88cea6a7c687c7f36052647ea3770cc3501bd707f37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02cedc613fdbc7287edb72c4b4ad0cd1b0dfc4db63b56ed3c096f4dcba805dc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae0c2e97426cfc0a5f05be48db2d74b2a7f1fa7e065bb624cdad1e0d5f073a6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f85935b393b6749dadae3fe08ed779397974b2e5df4ca5b06653e81eb08e63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740e57c30b158fb53062878f6f568d309c62afd218d7e81d890789c41b80ccfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1722e249faf4b1e9610afdba917aa8241b9abae107d6cdf9f1e2841f57bf084(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dabab972e3c55e65ad650e8f13d411dffe0a51c46e4cebb7fe5c21d1a519026a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200baebc4ee1d9c202687500592a17dddc699fc08c81e45a9a1d3aae6f68c0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d02d462556275ebb7b8072eee8179f0b38389c10c2b4358ad358f713f5175a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af54c855adb69e64d1f0f9629428982d2481b523d6eeb562c5e95ca638cd284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34de48a6ddeb72a296435a3aaebcf76a2203e1a2c1270be397b5f1ed1d8821f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f933e8b06ff893e29e6f464e6d14775f96a124756d77fd15d2f7de1fe0f48345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d03438b631a26dee068e7b0cb0128b60313a4446681e10bd62f3e63b7db6e05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a74daf4c499d37f2c052dd84e43ec834a900005a52fe4814fd633295f556bba(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b189c31c362f4819e08c8e97f674e46f6e332fc4a26a9b96861f444971645a40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80ba3a079b1bc84c0a54c2585bb479da6539a1f1dbdc14bfc4c63e89b1fb7b4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0259dbac1b457b3235054fe3d59e95d9d61ea527fc7b30a74e76eaeb482edd2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54868a0afdd517019414820d7127da8469d75cf6c66897db941c4135d537f45(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc3b866fe9791950d17ee1860df3e23e38a7f984ad0958aa7662dfb9676cf61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eea212ea479fbee791d69c368e54c998e383475652f892c654d936490d5fdee(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e45af4331987e8b1cb3fcfa736e743bd32ae5d899911bdbf7b65e3bbb69cbad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2874327acba489539cc0c528e7655b3e5a2b27ee042feb8edf3bebeafe1c44d0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934e48b10947ad489f2b8faedd9c6ae9447125550e4068fa7ad0ea5cc9ed5187(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868b22854d59f10f2a069025e7968ffb1d344ddce0e2df9c907736cc74cb95af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db820d146801ac67b57ac67094bac12c65e95ec78083218276f9ad1c619ed2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a98a5ed096400916e63b02ed045cecbd3921edd42f0ccb9c6b7b2e8371e118(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34482feb338c2037ad96b04bc9a590c03edb1ad809cd75e4a1b5470d10c008e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79674984fbd6298029e3ef55adb6447bfbefdce01cdfbcb5cd391609f9965707(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__563f7dd4490ad07511d2ad77c7aa44d475569908b095c65737028cb21a3d8621(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c01e865ceb65292a472dd9e8258ad5dc837b024ec5da6f88497da7abffbc4e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdcaba227e148fd5c28bc365b51ad523e2e80362afc0f619ad0ff951cd671473(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af69e6d8b610ff36f3e28227c49c95f93e9094eacb6d41eb1f5e3a0f36a3d34d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b51c57086224790ab8fe94733bd61c934b4a0ea6c48c50fff0a54d4784dcf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048c6ff5fb6a3e3fd623870646e307502dfb9b427bd0752e8f1f584c1c81c234(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85c76bc38955189a5c932da3638aec0e161224ffe6345d98fb34acdf305d5aa(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aaf512be3855e525338d98f42a151a269fd6282a725ddd22f20cbe382408730(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d7a90cce831f67803e50b43abf551eb2b54b5fc78c04474425808a41b4767f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acb91f1b713fd51bf0fb2518c404f3ff900c334a1b12df292d113ed9cc59cde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5eb336caf479fc093556b4e57fef349418163b5e0dad5792dce47c0e25e146d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6212c4eadf5068a0f4d460e6961a32a28bdb9e98c97addd856e7336756ec6e03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271edd7b64769022cf4fcc161228a3cfbd47e472fdaa4d0d02a59bf5b651e346(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d22ec06e0b7402907f6734b54bc2f5fa8c600aa99bda2e740adde8807b41337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ec6b7e9acc0bafee08bb8633a7145ee135c5f9f76bc2df96aa24825552c282(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b833a5d17d500d62611044e7c8519b83798b8e2b1094a545b242a9ff3d422e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47e35eed9c8f3b2b821f583eda2bbc4773f71d5f2b5802ee61d5c76c61b67ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb35e6e2a2c33a87c6a77a84a3be0ef67a13e7de27011bb8aa15d6ac745d752a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e49751c5e9639a0f6f0990e60a1445e7f91e9bdd8cecfe4361c232aeaa0b24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34be92edb7fde3484d5ff9198ac75d21c57a0180734865db292b2288bbc1e648(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfdf2b312f873122de9e3cff7ccf68f1cf25c2b98baf844b343f2b3cfd0c848(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035f40839cdf830d51a2f290740bbd6669bdff05ea40347d7ed7710cbf4da0a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a0970f431c26396ff55969b65d84afe112f758bcc62889de6c14cca879c499(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3e6d6ab16a413fff10c064eb240b1c7704d03fda0edb51437e06ad0d94450e(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29a1cec1141179982ab300db20f5f1eeb6088c44a5f789d90ee5853b3b125e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c921029493c88e639c060d895e0700b15217f9eaa77bb195d6e8556cceb7c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd14a0ea159a576cb6a8535215c6b1bb9b670379e12b96c69f8a53ff33f2ebb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ffadd6b7c7299203429de15239928bdda386041e7b6608d356383bcc7d61e15(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6872170d300917889aa543e84ca21f71654605c6b14959bef512808687f43ecd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8804ddb0038b3022444f4e6fa1f3506175b15c5bf547a02e901bd64bdbe008b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2ce34503ee9bbcf6a8dfeba74867056deb7daba8b0d84112038d0f49b5dc09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e0be5c8da59ef0ff1bb8b8a9fccc851eb35a50b5b3464adcc84015654ef6b3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b14a146fa2c1a94ba4a8f33c947cc31d54cb06b8850ec4520a35840fa0a304(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33755416fd5def4764e4c69d697782bd6fe32062d43e94e8fc8b73f137429f7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41049fbba1fc4de52882ba6c559571a2381872e1b3f7540029b10003d3de82d(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10be27d2ab45b4db76f028570ef27634e7ed249c35bdf37357c6bee2a760a9e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5561efb357ae6c34daf4de7ffdda6a86d9cb28b8c21efa57a858a03afabf8d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c9349f944e6eb5cd07b24d4831d074171ab5b5fc5ba151de5981587a8df3fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5fca52a6f7e58fdaff8c368ff5219604060d4777aca46fa340637c32b923440(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8beb90f86860f0a3d0a5f1cfa7255c1b424a5a3a0e96929ea090ad9066e349b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd556827344face610ffb567b3ef549c67e8eb365a1169fd453d04d5b404337b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a67f17bf3f18a3d8ff129a354e4579b09ac6c99625f6c0dcaf6baecbdb23eb6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75a7a8b91d107113a830d64f38450d9c8b954b8e68d3f2ed2386093cdf594f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453cd674c168bd8e6ec3f3a80ac88622f4dadc00d297c3a594e5a27a72f9cab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81e243438cc5ec5594ce88131be0b80d11f158513d8bfbef03e853981615d3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce086f5122c6e9a7dd3327e8338f5a9d7dbbff6aa3c24f4c9defa8aeaef67b1c(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa65fca98eda6958a8b1759b5779faae8d250e0e98ed3f0500e334b0838b0b76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281c1606225e2f80b058c4a765b0f400849b682d722fc4b459a731c0d1dac047(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef7ee297b9c1629be38f4278d3a49f37e602bb25dcb8714c20a53379213cdf46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10061c9ba7cef213ec9b33b9216078e133811462a8995821b62bc77efd0c1392(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__918501fefb3890c50d5781906710df7f7ed67bc8ee8ff9c782234cff64b4cdaa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5c45ff2fa54073505c291f9ad220004235c2ff9d6e50700c308371d5b037aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d762216c784f39b446a3b963171ae8bdadaaa8a21fa55e5c500d19a97817b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b127c3f7c821a00a23fc5e38b3a780253bb32ff3b9edac7d2964f511d7886f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32dc8d887c8ae0626d0c5e0ddc4d5c15f7504be34db84218ca99f8188f34031c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e71cfed0389419c54b7c22609fb9dcb396860c5dede4ca1ea50f69f9699783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__896eabbc03965c507baef086cfbdbb5e8a0b013213bf9f94803b84c65149cc1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd794bbf594481c7f65765685c6f4c95bbe41415e1c38af28b7f9f7cb811b79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b4952547e37af2d658d871acb2da61ad3340f52062f0b6ed0804ef79b50682(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53a97be6e08d64b4c1724af9d0fa2722f6783d6811781ec4d2ba19797d56dfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff25f4d684f001c493748f2becc6b33fb086ab567f1f153a85ab04ed549e074(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__846521ab1991cf7050fb8324e8e85c33da323e9cc2d91087f59c0d675b776cc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c41c4f690ab53124c791b8b432b3c8df7faeb9be223049c4db0107813aad3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04179aa32a9be957f3f9f976ac394923a3095243d5957f955353baaf20c9bd97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58ebe65872103649c4e595c310cce23c09c2475c743ea61cc95276412249705(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c18912f579eb1fae43c7f137d7276160576cf69cf95427987897301fdfd014(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e650527c49894f42a14537b45440d0da05b2508ad9227e9eaf2d614e0309becb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0ae19bdf23a5346a6ebcde8d3383a060bf70d4febb5ccf4a2ca8956045ec9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8e3cb715929a42a2da42f4b36e9b64decf2c88d518c87117e85409219f3c1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a23966b80b8180ccbdccc87f921f4b58ec6f5ee4d001ece2c63bcb1b151b6b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2f0f68dd0eac6a7b03470de8ebcd4a9f75611d4fcdf8cb546d5d1a928f9401(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71baaf886b23cf917f7b19bec2292f3b0ef67df277d9d683ff91db5d23d517d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a293060e506b27e80b603b3af2faa32b8861ca0e9028cbea0270d48e703e634f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94e82b936f8060aa4ee459286e4fd526513a27a39a4cf913b686367cca86db75(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8e9f8cb1a35e5e34261e2af849d7ba155c9a9d2786464e8d1be78e7ad06db4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc99781b6a5331060267abd3290588961b400e094661701c7e6ecea0d421eeac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f439d83caaee08dd0c7cec3bb41f9927bb0ec6e74bb80f3ef36f61f7476173(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__315c973bddd1e52d36a4298ef2abd6eaa46e16b5e4ebe65884aad2200af5152b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338f4e65bfb5fdbc153184c649f376565a2ce3c841de9948faf1b06a73c853a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c796f33b719847260d0e7e9372f813d5e6f195d6923b534e343e73d329c58080(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5cfc2c8222294366a707d1d9f7d9320101e187d8f269f74a200397021d84f95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c0f53f9fa37d37ee3446af4f656924799ef52736b49dbb98e4e7fbd0c79d77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030f3dbe7ed1449a955ef0b50408dc5f745b1bb46fb6d971358947684d6096d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d2c70de8aa70f5fc8e1532f41d9718333ea817625e2b8e4db739f747aa2344(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fda9aa611c0fff84909a7766a4bed4f51491353159ae355e4161f733c0de6d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70c59a3dc03c1c31a1ed38f9dc4221a2c56546f1ceaaf88c3fc7416b22471ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e5650d7d8117ebb98b11d980d84859872f7d41a88cd0cf59e692ae632acbd1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02260706cf75c42bd23882c21c6d5547cf2070157dcae18d1af9d0067cb5dde9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125c8dcf004db0b208e7aa20ebf684bad99de8290a94997b1f4a14b7040a25a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379617f4fb8c4972c6dff3200ef7ccafa900d1e736b1a2540a81a8e71eb0c3ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087fb336e644b341a13d17628e61c318d1b430191f42d9e7d7e2f21e85fa95f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda1877fb9f1929ba4734863e43ddea2f3e493888aa4edc18db1ac8a99ae00ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b076ab486b43d44a19659a6bb66701cd23e277bb0eb93b35a15a2cf0f4e77c91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ae0c62cf49ed7c33a902a4ff556df3e0297f203aac79874403ce4840f9cde0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b698cf1427ab831aabc162cb993c0f322ad0f562b3866d4aca02347442618ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe47ea9e7e643da2e42f49547e0dda95ee06552e9608f979a38b8a200f2e7337(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311179e2de5b758beebfbdbcb36b302a2878bf54469e3b8f684bbb0c27d53450(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378c28a4f0485e435a3ac91b2245b1126966b67781a902ec00ffe8c9ea82f804(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c79eff71b9683628d7bd580ae63334e57a6852774dc3dc6581b159e6388f14b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07cfbade3b18aa89453ab62be6b937cf353c27b73deabb951fa8c4d59ac2b77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4400a30721b6f2b248b46ac1af744bfdc3a56a2d07085f66775cf983d85a3149(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f5439f3672212a5964b615d427635282996d16ac599ea789917caa755067a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40722432ab5a1ec058337d23621893d02a28a09bd71bb2b62ae09a5f8b205cb8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8b3e13836f343bad33903850f751ebf5f16794bed74fb2aa15632f46337a4c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccbbbbc735ec900c45b1557c229c2aab9772903d89b28d34b3b944cb0c6f518(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c00e6fa6c4d9217286414facb737d5822e021d0f300ee253bbe2961e388034e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__058170b9a119e80ac9c6e45b6e1399203eea25cd630fedf8f1f792ab9ede33ab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472b2c9285d56e58157192b01a34064ff0e14e89fc94583c87adb11d7ecbdcf5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddd686c4feb7471c19f3aba0001ffea629cf8d82fcc4152abe794971a9cd223(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a46068fc720c345f58a352c7288231c4355b3c8766c0394150dd24bfe382652(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e0bb42a3e5851f8c6f14ad2f70c376022df49cf0ad814a86d9e9f7db08965d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e6c546301bb7a98b3717efaab280481296fcc591901b0e69feb789c475eb14(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55fd0bddac7d96e6fe561b60c94344c482617768f3b6f03fa927b2892cf518b0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e0d79c9342bdb8650694c527b08c951a0f11d20b4e017dc6188f02cf1b689d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141679664895e26d5c9add8b1c029fececdc32dea5e363e4e18f53a4eecf9436(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69566693420ba75fda45398dc60c669a31092b3afc5dfa680238020679cdb489(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6512ac041d23568e6861566ee4da4641772ae4aa67c811c3a52944398a217c20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cd73f1ac003e3e6eef3c3e097be4b17efabf3e3c811b324e96f0e53ec32207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d38460d6fe8abfcddaed599cb6892becc887763c450fa309f5f448e0d2679ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7687c5c2c1cc8d1a5f7cdbd026b4c25506c987c1731440498ba953c29f71a993(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e5842c58d03a4922bafcc9b53ed4ddba7f6447e8a9bc1012e44f7810efa7d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72d04aa288e52c72c0991beaf58c014aeef0f8ef2a45185e9d5cc7668e86548(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a26ffb838ed34d6b1e790556528387036c1a5331caa3447f333047e75493855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6772321a26722ea0133401d7a8388f881068754d10992b24599ce211e9288963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729f2360c755cb374691ac88d2a6ac7f032706a1ba39146df07420864f8a539a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d7878c3a2907c6b7a27a30f8d0ec2e12381ffbc41711a6f7fe58c73172ac08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095696d6041f62650f678a08a300acc15c0769376a8ca10bcb389e3206565737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55937594c972b503bdf9df570b0a5a1d6c13571bc9935d561e6116e2f131607(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92d4efe340451c1ed1a338b05fc9c437bd039afbfb98caffebc6343e8bdd59b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241a678fba34f747d71ec2e642dff239b1282f2093c51dc6809bf4354aa7c674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa06d315810daf7bc5f736c808f1e46e413e7fea56b9b70d4d32355f7cd9514a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60beb85583435371687d48c9d7293a8f4ae3622ba93c3f034e3f150110331cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c727cfde2d49d74a7092cfe26ea7d029960ac9ffa8c9f3f9ef5a71dd3281ca89(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc43c2586f021d0f36b09a063072550fcc581d7e6fa25b7306272370eab3c683(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8797b6b44ab913ae7719f4f7258aa10a09c9f76066086619a9ec5b81d89c9fcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90018c0b205f0972f04b1859b5a127588f301358af66432c0abd836b11d1595d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e93d8e7777456a741446d36281b23c359adbb50c2cbc1275023a7ce4c8e53f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa09d83e691b35ec14de4d79bbade95dbece54ea64432e3ac44bb8e5e1045ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf022e69306a3d4b8bcd7c391eb6312ed95ae7a1371d25f2ae7c87e682141ac1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c7ecee0188d328a424214be792aeb44ff584bce226671361a6bcda09663121(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ddbb17e26ce211712a8dd5c95ac98c142e20aef4cbc34d0e42d388b24c6f528(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a9d3473ec9202b85d56ae6e2075415b51f263a3d00533235cee28ee03553ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a52c0bd7229f5624bc8b3651eeb6f0fa7e6a7c95aa79e83587e9e1d1d9b8f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdbc7d88650987f93a046a5bc4899157c61034c5c19d05fdb9db1423d82704cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3693bbc772d731aace5b12914935c01a36f895bc2a960cf55220e7c3a8e14747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c642cf6f28ad73d5a91d823cdffc1366b54cf6a8762cf027e04bb12456794f17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffa8771ab2336ef631dbb7bb8cf23cf3d2f9dc83295c7bd70aea75c240bf10d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa50a7d2d8f6c903adab0de55f79977255d9f41d63c05abf9af85c5b3f528b26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61934cbf0fda634288f342c8c9269c9441edd1954b1cdfcb798afe6a3c033347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c32ca70377760ab826e298977170db8999e9112c7c45627390a3efd9cc57dcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a958ecd0c670ba223e85e21351122f69a3055c8909991a8678f455b3b5760642(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3701bf21441805ea335a0659089695109c2c3b80a87f76a77fb4918e84a4d9e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410312cea45eb2f9015808334770e748a7b280d808a1670b25825b237a00259f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889f26e4aa79f567696cf8eb8da32ce45d45f1e239d0cdeaa5f9466311f33c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd40ef1cd7a9e741361b11929720ae3b0681dad18890b57fba88a41a1e7994e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33183f84b3ff5e6b8da338041d97ee71f214159e7b615e1ec5e4b86f40a2ae02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efebc5a32e2957d6af5af9ea5cfe618e4a81e3a94b851e0fe28801c4659c2081(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801033da0fbd4b24ccbcbd36290b5101c58339b8508862bb47384b5b2780cc89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70765d55c6ab58fc9a88bee3955b6c7d59d133e872a472ca541389d746b3a6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0168317da7eb18c59d658f13dc144066ea98320694eaedd634ce149a6e89299d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2204bc9989af902907a742c6eeb498724c49d792c7aafb1d30a1381ab72fac7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988b19d1f12eab1093d3b84798af21b066d50f83fa634d6c0a7d91cea5fc05c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817d997e3e3a8332e8dd728719a6eabcf9da20dfae68bb1d962cc1476ce61ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a7ab23a26226fc0e114f6f725d1e88044a02b3db7b205dbda4745324c5e457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4cf4678d882604e9d96068eb763503308f80595c39d2bb3a7addf51f3b0fd34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13decac0c94c240854e61a2eb6df4dfd81129358bf5e9a89e36cf374f53e26ff(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86740805050e665a0bd82ac75e14b6b5c3b14bbce5a987b56b8292884e8f41cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0716ba8e051eed46434a22aaf8170f1457587e75074b16187ffd938a89437103(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9773a534dd75eae0e6152c2b1a178e5b7805f1aa99c80818f274f825ffdf7e65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2edba4f9efc014f4adf5c4ee6753fecb82126cf6633ab4e5b01bc3021b918b23(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ee4a9c5c06f233bdcff7a1bbaed714c1c26ec4caef570bf8f9764acad97569(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa70b91706a1ac730d9b291faf1fb0cdae228e7425bdc0e6c12514c255790100(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a63ebc4dbd92c1ce6a8c4dd7ad87f343b69ddb7292c0e01e52398d1818e0a01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2202d07996fdbeb31e5e9b8da8ca48c64c13da770a832a1839ab58678fa1c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea8c0b77850ebc59862c977aa0b8b7bcfd7023e5dfc635391dd42c39f629dbb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387d9b1fd5b402b73aa57083051fad1a6b9f6dec9362cd79b7d1b17353020cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d43be975642f018af00219048a6cdbeec004dfd55744f16cc9b0cb471ea4b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c03bb3c76af43dd34c7bfbccbcde38e3f84713f46dbd274372644fd35dc5a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625c34765c94152e68f6457d8e6ceaa16455d5b5446a66a5fd0178e84ae30712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba5300889866983571c7b4bdb2aada922cbf1760fc1f002c2bc19495a7c4806(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f990bdf0a390132e4e3d4c2972fb3f95daf9448ec7811c7046187859631451d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__309d176dbe8563031e3ce940cf343880b545113dbc4a3201c39f3c5adb0824da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae58fb438fda1b9afaa277e95cddb0e18d5f5e95df6e39ca3343c3ea21d7031(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224f87a76f89415b031130d119cc3ce055d0777d3a53a7959d139bd7ff16062b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046af13c282e654d2e605aa5f582d6aac85ce0af6e845afe55a5b178bc6ee4d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a51d9577ecee9f62465783060cea161b1984ac0a548039c728b7d096f619db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c548decc39711b565a3c5b37ef41a4d7ab9136bf02ab04ed1e2061d3d4ded1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af76ea6056a3e66d3440ee684df74541ff4b07b9a7890e9057e8bbb9d6c660fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2c2e94bdd9fccb67e1c1e23256fef139745ae2034582d55209da994ad3740f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a78052d96158927a66a03219dfa28907c4b192f9a2813dee0b2d33d5dea1577d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0731bda8c9e61e39e7fbad1641f7a6560dab84064979725f37a7c65b36aff23d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ae997ada829eb04ea72557369f1dff2692462ddd6def0217261bb0d0826b74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101bfaebffff71267b4cc4054ffb42d8b40f34f279df293d224a7fd394099e90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dbd30b70ee3dda8d1149848189e723e71366e230603013cac5e4daf56254fe7(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dced703ae699e715a4c6fed55574aa64d1ed94f14efd2bd85fa8f34813a2470(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa535533cdf2d2505fbe0323d2eb1d3d6c83ef0efe1267e454f8abe7a72fbf6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9692a2a39c83d9cb4641047d2af66806a9056b334aa0dce9fe580bd5c70980f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e04327b7cf7722088c5639fa814f907ccb4b67025e3424dda6896711fd876df3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba7ba4b07bc34409910625df21cb0c8ef0a92161992334a6ebe255991c30765(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4738f874b33f6d48a7579f7c784011bd6c122301f678c3adf7c0c16e7b463da5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3f1e8482b566dbee8472b7ad4121c0bc912422100f26114a85e39685a5bcdc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8af2954d9b6f661f42e86693e6a313f6494dbd028761b7c072996428a3ef796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984d090b4b909ec7ea80269e27a29865fe6f57abe9e7ca4c1c952d09879a5b19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc456c83986a5f3aa608fc4eadc60ac6618d7d0c1f402287485f1cf9fa20d962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2527775cd3952afbe9f2d247469d4c94dd07879243b5e13766b78af504685e13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e895f858b63ff11145644bf9170b1d698e906388463fe24928384e0e794005f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd946810bfabe4df59755e2bc816826ea586439f892e296a49e1291875131ee9(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41275420cf348befdaaab80e3aff81e13ed1c455d9d1b36249f09ce93616019a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4370905c6f24aa78635bd99ecc2a37eba0fde37dca1d3daac82663cb0c647ec7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c1bdb781e8b5c96a01080bdc1c6abe913e19af333d6bdda069362d39d5408d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77e29791fd5b8d3ca045e11b719ae56a431fc9e7ae56902822abe8a24d8e81f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b93d36a7410a299480c9fe8eeb39d461ebfaad4703b31ac32677898e8d70b1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7fde82cafc0d814faa51964c44059b6199e72d1ce263859978a56a4e144c617(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fa5bb58c4c29c2520aafd6d11b6b9edc4949ef60e4b5dffb86e5cc727c5067(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3694da84bb44d748562cd9d1047da4451cf0c9140ac20798bc3f7c5f55efc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71399019a07ae24f5a9d0aa075642109c2a5d62dda411a4cffb12ee3031a8271(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69cbcaae9032a82ed300dca0fa5276b18ad142cff7ca56e0316d07cfab52513(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4b6bc3a5452c60d8ad706d07f8771f538fcbdddd844ffdc7ff0f80ab9b51eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55816ebae7a13bd3320f53f4c49f76416a2acfab0f49551b7ddbf73d232d1583(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e0e405f42cc5febfadfc89073f742882cdf8132cd02306c09a49ee3b3e60cac(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5908487151a2883e92cc1660f26bf0fe4b515c31e97fbdaaf5fb3b53c7c5fdb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a90995dbbcef22b9247a10bb163150946be78701ead30c0f7ef56e4b40bbae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6274a67b79ead082e418b61db937b68bff99af1d5461d07087f24290edaa99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cdd24a634dfe602cc8d50a024adcdc17f40c07cce77c48a50ccd57c6ee1a50a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d51f007202399780836c54bb161b88c3104c76d76cdb752a8f71be6d06a433(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4df345a99abcb8994a8e420b0fe0714ece332d6f4b813baed31c298a16f0ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bb1844cf776e4db6a0c134d340dc3d6f865f203531beb1f5dbc99de9202ddd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523ed0256f24a9b01e6bd268cc518ba003290a3d42ad14c0b33569ef720fc4b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd2dd67986ac901d2948ff1a4ab28051ffe6f8974f9b9d2d9e0a5b308333b61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a3c2f46e57de3c56d43c844bf43b6278cdab8f41cb4a89ff0a3c2aa1a4b7699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb18a2e81d95a5bfc5363ab2199ee62d72241752b0730e2a31ad568bfa1821cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1a5fe62503aa4f5b066dfa69375f2db1d747d14b03e350f2e62ed3863b8112(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22665cba862e78538fb62e6809bddc10ef1ee1da39dfa21b54e844dc36531d20(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55d6911c401b8c6c26a916540f293e6eef39e2aab0307f5aba5021385d81410(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33db31ed18850f28b634491254b52e6b39a7969d1e2671a123d5d58c395de709(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5677247006f89418420d74536db954d91cdbc6586cf5f119f78131b8578ddc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306ec1901690c8afb03f7d36f20226963db22018b7876d973b7266cf7261996b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191869563db9dc043eaecd53bce2bdecbc9f080d82c5e3570fe72849ac9a1996(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7b5730d2aadf3e5228902e5a8e0e42ff78382426fca510eb1fb148ff18df9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afd89d3c93a6d41679e4ba945632eb18b5b28f39142a8ac9f8151c004832dd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05710d6021382ea09c6040e9d4065e99bc6d50e4cf2e53ff4557f3d76dfde72f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b3a91defc5a52feb691d36326e2c88074646773c21733997813fc589bff3ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a48a491b6de5a66ba33f914aac05e0f17782b050c65d9f98c24204266cca38f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a679aff951a170eb4e86fc29a4e95f54683fba2b94a514ddafb6d4720e3786(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25c55bdf5912baadec34140eabb0e64113f9a2cd7bb4a31735166e84b2d7064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc66f68570f3bf3271291a1fb4ea1a46381611700d3120f78b870a5a0b0daf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08ab4664752c581631baecc1f895b6b8abfde4b7da4dc9bf2cd9cf9dfbe47c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8a460aeb59dbf183e33d868ff06cf80c77952d26fd07e3e9f3c9753f4d5b09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aeb3e5250496928d40f726c2a25e291c71ef1052b9b1318899de74d2012c2d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99ad15e243401056002c64845832c48685ee13ce1e85b501ac1e27ecb8fe52c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d980970348f9ce18bd3aa55b7de180ea67fa1b7944eaf3f6c0027bb282e0ef7d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007a102c97fa8ab1fe6b6002df3d73978aa02484c9f18d3ccd9b7071b4dbea20(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dfc6fb56293cddacb4bdb632009b3dff1e8a7611e3ae14178e524a73081f1b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0307c4a027cece168f7d148a7b79554d6fc8eff44e2ebe0f6b08b9e893a8d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88297e655ccbd3163076efed071f467735778b220c739c07923a6b5b60c4d0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c690cbfddb70de29fc0e26333e8102f0261d832d3c1017ff62a3a946aba757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e3c9a784507035fddbd88633620dd065b3c874a0d4e87c4f2dfcda2e50f1ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb47fa4fcff0fc80f1d6d35931abdc47062462220be730865757b26a132418f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd1f4dbeb9fb7e0ae1c3dd6be85c27fb90b4a47d6de597745b8796f9056a25c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346ffc789752570602c38fe6760eae3252465d53dcb94782bc2a105e018552e1(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37caf54c7e9f8a9fcb550e57ef1062760043aa1b2126edfa576d4b8c3b626279(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc09b387e66a2138753af6197a6dd5050d2772fb164009ce04262b120600bc73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fd575b138761be4d4713ea665bcfc42b2fb5dbe05b1b70d3ccea3458b6743f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030ec5aee6bb6a53b3730f56a044f7cce5385363a1303c9d77834c7acab98c99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4845dcf861d92827e369c1efa55dce270a159c874b799b783c5189b7d90146(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be93d0ccde877aa50822bc225f22a8d142a1a2695691317e1c3a5618c00dbbd0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbd9f962eb35685d7d6d172c8f87d3fa3e62a7040029d7004a7d9043220bf257(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f291527df8c9edcdfd5d6c3e52bcf35014c3132038aa91e7cae5f985bcdb31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3f0afa23dfef1329b8e65b16d11cf38991f865ffc2ecab14dacb358bd04200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d284fd546be527452e0127899b7c22f79138289da0e1c81441fa351e031dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec8c3aee3884660b57eedd83538af288bfc21e42906bafe7afe11b14379e8de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da223f970626194ec419e1d2806795c89154df4acd8e17ed94a0103fc70b2fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f2e2e98e5131847a0f29f48d73199d5b9aa4682e6e6a796eb39532b4f572f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e7119619f7e776f23313b1692f3d584d450425d66ad0a94345283be82e3dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d34c17094e1052095802cfd393233e3cc70eabca19da72e9d3fd52b34af5272(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9d727ac732ce9a1155c98eef9b78e354965e27e07d0fea9829e5f90dffc802(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f3a61907fb87a9867b8f3749650a40cb6d8e7b42ef74b9764a3eac815fe5f7(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd66ed8717977c8381fb99d3baeced500b4847b0ba605c1ae6a65248fdcfb03e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be45adcf41b3b0043a713b676c9616487ebc55b65e9034c2161e729ffd7117a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb05ed929f927eb5a3f1461eaba07cd6f52a5d5115a28ccc5c9ce09175f6a13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d686671a1d18032b47b71dae2f1ee4fab5c61ad0d7dc0fe54ed2de51585dd8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75a3d122abedbbebe0e7c9ff39d71bbc31ab4925fbebf80e497ea862fcfeaf1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725f8d46b764f5f24e9bbaf760d9020757c112f1050c1288472134cad56808ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19544e4784968c04c50cc17c0bb5a4cf476e97d6e84333e4d80a9639654a7ceb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68745e9033605fde6bca6c56a0abbd077221a29009cae25e0b32f94b988ca968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c49cc5a23c70e169091e40cb06cb89222709efb7ce54299dc719eec0c91f045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2e4b4267e382515e18f7113f1de2bd2a612a5aee9ebe6d183bcd2e43eb363a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0bba8142da0516c56e645e685890e27c83f9e2c0cc70581520d21fb0142483(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d9f334c7782887c9ef253c482ed51ed0e2534842d9aae28108297967328498(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd136ab95c29cd96c5f7c492ec016fc7c1054280a6c922b03a673e1d875405c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed30a469af62ab8f06b428d6f0720ecca9ad594f424e5feea2aa5d4bc0dded8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e8d20a7a3b31d7aad47504a7cd8db31cfcab23274993979d46801012607513(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037921f43d1f194962a58affb109660f885ec3bc836dd18209de422d73bd62ed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835f5633bce237ba284aa965d061d439dd6262622c262897ca8b18ab0a3bafb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150398e21c379fe7d4705f85891335cc51365153a6793d2864b4050ed16dff8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a3128ddcaab5533f4558cab777db7b81ffee9bccaa373059f3f6d36682e3966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e27ebcb6a4b43458f438763b7f8b686f8041007200f548dec45f54116fa44ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__009db36769e028647f920f0ab4cfb0e502d79500c1962acd0a18af28793661da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66f0386864fab88136597a4d4ae094cb86831a17cd5debdbe0234b91375f41c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc46a2bddc0561214c004f569c43fa5ffd3fcf4fc1d8ff490b4048298b374d68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57472fe164e762b21d7b44767ef5b613d23fb1a1edd3fe0059c05e7a498267e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac73b1b35645fb8550010741d072cfc95e053a2e1b3736db3bcdf9a4dbe2e4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97317dfab16e3e8e6130a531a51a32c4c989533d5d9a803b340bcaff4c872489(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bca61df58a086f7f869978b1bfa1cd94eb42b010ce1f785ff51cb8f88981c09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06b248f44323188609d4d80f06583c89743eb69706d50c407aba692b4935c1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c4d032a29a4514733df4711a48f74d344dddc37be18aad383a09ecd629871e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f56b4661ec64fe73281b987787f5285c63a231ab3385bd020c1937e4e040a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed6492c9c75ac89eff92ea976b891b9521621394499d8a2d5f6104695745c52(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f07babd06d289d0b186fcc78052d73a98ad320a40d3ff74f89b4249c6ad95c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87945433b5519597cea76fba5ca4016a2381952de52adedfb81c4d6eadc8cf47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3366425ed57be06a08b84c2b7c657680d186b1212179b9fb24cc854a41a6beba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a957a69c1c596702176c778ed81a937cecd3746de406813a4c6a4f1339830468(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28bc20a599fd65f1641748fa20c8f9b63d1edf8bed3919efa4a171a0e4fa4364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25d9015a07bf1cb8ac4d1772a0696fa0030239ac72dc31be46c6dd7303b4566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dbd09a3d3ae44a7435310fa58889cba3ce2d41e36d455601a78c64541143851(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef8e4ef0389c069cdbfac8ef8c9c3c4c2da87c57b94e49e1ac365b7cb5667a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84060c322c758c435fe1e362c5fa6e546dce61f28727b90e18b4a563eee751bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29248726801396265947010bd667e8a64b6c84cb614dc69dbe459cc9da825e5(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb3834bca27908676a1a57850e9b29cf946c1a43d2a531b9fdbc8f2bfa41c359(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0ad88de6d499dd1d5abc5b2be97768c4f708c9dd6d116e68c6afc0b87e9d30(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41e084d95a28c5aa306791b145fd52a3d3ab9fea1fa7c16e813dc049173ab19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3acdb2db679d6ee2d9b897d56e32bd59b1fa2ab81c099ebf052dae4e916f4641(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75994cd8cae8463efc6bcfc2301bc0ad3991873af970867ddd9b5a7cc928ca6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeee4809836c3de6d8195bf0f3215ec499b3f80e507b6a28a1605d6963a83bb4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907b90b76595ce71030a0d2c6efbc122425ffc0e5a5b3f38043edbfbd82d3525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c0529972cd79cbb704ec1c02b77f6a51af160e2e9e9e64ffbaf7b75257cb0c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec080980ea8fe230b431a06677962c9382330b088b35a4fd6d1fadc6153ff48(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164025edd67719ec818a5e8103e68b8ac8eb5c0142ef2e083425103b7d68fd52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0371c14fa0d36c53123f79c151eb77f6280278be1b23ab04146ce3c04add2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf069abee4b94e2e3da45e2166d0c192512086d69adf0c7e2d093a8e065a049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb85734cc236122942dede263945fbcfa7504bfbfcff298edf77e6f31e3a43b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbfbab4fc363a1623ebc924a1e41a9d3420bd9fc7dc9e8b9a7d34298d75cf39b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835903219980e61a9011f05d9caded1a602c09b4ffda184cbd1fdc9493f3bc92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4945deca5c3c3282527073858e74a4e252b7825647c4b8a96fa9ff64a4c2e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a7420ddc25484583e2a7b9e56ba3ff46a63682b26a6034205809c07100acfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ffbe1bd86ccaa7ddd653d2e2e028a6332b7b39f12adef3c8d08dd247010d5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a150045a8f9e02d14665217e040a8a46aacf3ff2b59204259de04de280978bb5(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d5ca9166d403665d45e5344ffbebf1e801885259a7d677f29e89ce6a7acde8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd93185ed7da65664f2c8b3c1dc7eba9a6f9a00f661429b382c456954aa04954(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cbf402e26de094ef0308196301672c4a82c491353ee64cebdb2e63b6a80acb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ca88fb5308e3ac4352c1484bd628cc15c4a3cec141ecdc482c8a1f3500ee93(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9133f6484369d17a05a727330c31a2759a3d0af472af24220c5a16446228b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b34ac1200c76379a6c5dbf6d5c1099808cfa10421afb4c663f76aa09a82986(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4759305a98dfbf24d420bfa865aebea5e7953fb171514a5350b7bf842d759d86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff362158dc0dfd870803f430db4077cc58865ae7832d95f0f04b0f688cc88ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5ae52ac802a7473a0685a2cb3a53cf5009a2ff50cbe512fca39adaf6d050b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d0a69b0821017ae5985fa55f72d620811b71ff688d71bc07c4cb6f7d615995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3dd378a5b890ddb17c8be690987877e87932a1f088ad2b493f15a9c91898cb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0fa4e44ea2c5a21cb0b1de444c470a4d875e61776952f3238bd4fe088ae03e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836f4bc9756a3711149bfa20e026d4de7af6de703751c8ddd43e41faf87d914d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d92e86d1741adad918a232bb4664f0b5e4f64ea2d43ccfa7583ac42814a87ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1b59d321030f7f73106831c2b5d4d198a699bc604b119acb7198c8f759da22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64dfdcc57120540b904f85d5bb96197093d502b91243d3cf22eafd30ef2dbf08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a7690d85e5d2e8b53365245df154abad01dd349cc7de62e9cacce76c6cab66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ee5a16203eeb44b994083a9be9397cc2b4bc88ba82357d3740ecfedd3a9744(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330482b280e57e3ed5f564f1b54482220cd9d4496063f832ae38cb2f28413da4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ddf1e8c9e5abad6239e56805ec7d57030b63d21d1afc23e43defe60575274a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7f943437faa38c8ff2241e1469c345fda18c5193d1dcef3c0f526e1fa2649e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d86fcc2633ae0901e27dcf45800db305060d709c7a8156ca2a268a31582c7ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3feaa380975b1b85598f5c4bec2edc7ba174cc0176815c43c7ac6020af4222(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56050047a8bc4b35512d1722eb5f3d7f7d5006588f2134d3d85d19206deb6849(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50ba396b05c34a4d3455f4a27637b797a7fae9cae4d310fa820c135d97cc12d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939a5ea1b14333b32051e3e090434dc88d6ffe329565412b2e90a950ec00ffa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d87a4979cfe7047860e83aeffebf3d79ab70b95b926053fb60f7450824d7956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d7a5bd7ff2c444b7cbb559ee3b057f424b88e400fda220fd24d1d717fe2102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50a9ff8787eb74286a816c57481c100bb67721c88ad7634ad7e21f1ebc87c92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f042bd957196a2960a2b1fbedc5f974d95594f3cb347e737044b9e07e4f6d338(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d467a1720f034a3ecb2773dc28699cf0a4baaceac0df8bf58c14bcb4bc2b4e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02cdd21ba86ef904179502624160640ab3072e21182775abf589d436203b2436(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60793714e725650ae37085eb8ca9c1b54b9e045b4df691e728051e33cbf1d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6664f31859ff3353bc2e50b26ef425a53d9288f6cd7167a3e0fcde0c8294767b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad77d7e3cf62f8179d62245df6f84e532ffe436a1652806ce3fdb7e104a3ac39(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689fdf8f60239693560b9747bd5ea9d7a729e81640785048813c580cdfbe6864(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a7aecddb6169a5dd69c6a4a2da48b6dfa6a58817bb89adf5da7df2e9522712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d987013f31ccf4fa10fb12fb16d78ebed4749fe253de8eebd6f65e7877aa86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916510355ca6be2fe8f223820dba773be34330d8a3076a89ef7ea04483b70f92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63982f77ea794daa7d16fdc34343a7dc3e13a5b29270e22015703759d7c18cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5855f841ed1533e45732bae1145d5c314b47d35d3e887d8b947329ad94521e3f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b43c43fa9174e23fcd96a1fa7e407af0d0347d75465ef796056a923f4641da13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ead8f9660b25538a28222a96614aa316c604a5142955e6ca222e20f58c734d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4540662117572312efcfd992bcc1ea12bfd19a206dacdf17b6bf63337b2c0ef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63f302a4c6d43cd29f53977190fc28bb53e6928cdab670740eeb06201356530(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ed96eab15721cd8a0819ac905463750cd3cab4d94d21e6353506cfbd5dfdba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14595f06756fcc7e13066b1278e3ed3c3711d55bc54e4f4420a84de65fff8bfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1681044069c6681f3d3b273c545e1837246c5c767539bd7ffb7244778df3b58a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a990d453e1500939ef9a35a7908283912904c0da444f8bd61cd80f6a61c8877f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__434f8aeeb3070df504fdd12c4eb6072fb7e8a512fc52a754b6c98696946dfec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b33a33a7d33d9980043e7a27a249ccfcf481153bf0d6f497949e793ee16b22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c48bf323eba60366610382cb3fac57a65b392312491a8b355ca919e079afa34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8930c31a074e584f84c9d0b4f21dc13877a4d19bae8c0fac629022000f6028d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684f50c048a18437c95644782f695043683cf590fb7657ea14359c6c3092aa8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90bf6fb4447e29acce93af2a95fe0315da4ccf3688b0f458d0e862e2d8f1c76f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf3ae934e1997a2eb997c9ef5232be08b25d3865749a2ee279c4ef20a912c90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f7611fd6511553baf61e248d513cb495738b61e1626fd49875bbccd3c2bfba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b56d668ebc512f8c998b48ab24f2f7716bdcc0aa7cab57ca77a87aabe0fa2e27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d30ba0fd31024b7e93ecb863d105eca72389b5509f95cb60fdb4eaada624e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aecbf57860e1b7341db92ec70f1b9de89c9281997e95094f2121f4b878a3a8ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c0ed2ed8c7209c948e0f7a8e1b1b3c7bf21aa30ad92eebd939c60990401a65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35788c33769c15f1965acbb3d2ffd5ded828bd21af7c7b9f4c6d7adef37125e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77f382008cf18f23527580bf828f3c0b3c72640c9fac7c00d954cd6b4955115(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e149f81cfbde3203d34f521cfae6dab959c51b3d6ed0d5e7416c9a60c4cf2a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4479a7aa044717a05a9ee17d38324daa8b350b66143f9152a60317a1a9c5ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea0ae2f329dcc33107f28958ea7f09163db263b5274d131c64bdc67b9b84562(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34c6072f33598859d0ad8b6bdfe1c0b0065d89feb26c2bebddc52a5dc3e3526(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce069063ea79f374c13bc113ebba0618d32a5b3e4048ac144335716f23cf4062(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d75e0d9383f12d20aa3379a252e792b9d9ae242a231fd1a40f985384ce5280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4ea65342415b5c52455d3799b083cec1fd4e40f1b925e658cef84a8b205f6b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebd155434cae380cbb11761cc27596f6846cf2914e62727af89f56f4c2bfa2b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d051ab95bb4ba3f8a7f6d869e2f090979c0d2fc5516545028df32fa68cc6a02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d64d63f79b68c7bd1faa0f0b30813cfd74c2110367e5afa643c25f1225fcd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8133dcd4b6044d7c87b55cc3bda13418b82e09e16a46e4f52e585cc9cdf891b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b7897490aaca046cf82bc0de0567ecd3b24dd15e4aadcb79ff01ed4893ec14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1401f1a45145017446b37fe435f99a1f5a73855d88ebfaaa2d3c07fc4c9b3d06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1b9aa0ad09b83ed528263a543d7ade350b32c22d1a6c5201659ad5de6265cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae0480a5aec434bef1dfdb6b87721527b575be7f5fb14c0f3390adf2fb7355a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f0cc7f169fb5e7733b9c61523c3e65009bb1f1d12921a3d9c764b9ae25e39f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342979d9426877f32420ec5a7912ea933806a57b7d0bf3898d905c7ed1e6f896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ea8d2a89e35a0ff59a468a523bd0bccea36bf5fe7a9b832ef80aa1707fd73e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a49da3d1e77c834a5e6b05bed4141ed44bcde254b3f23e30113327fef77de3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92110f82b09f44b8598f647c36133ca779fb7a51138065cd92331b74475aa16a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e164ff4e8967be5ab518380d25e0245b84db739bc7005e51872a3b35ccb6daf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4bff3200bf2ad4d1dd48f1d826575d68eeeae06024eca432ad09a56719ee73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7024f09a7668968338f57668769e2c6c63ca31d0aeb96b9bdd258ac682d4363e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd75385789c21447f15343651850f85bf1a43905d423e620c7630e4cd66dd85(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6957d5c136c1d5e60493b101c04909e2bcf4b2a3e3466004953e7ce8bde012bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078e811962f384d3033a120af6630896ed510c6912e20af2ff56efc4a5109dbe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1321544fbc2733df9f7980c1b3a0922f43995516dddd3d7b3c9b277709b19c55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab3506ee487e6b644f8446c6aecb934baa2eeddc2e9fadba6e993bb6d8dcf3a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71feda8adac30d19c6e6bc60a5b6044ecfd6e694f13b4081ae89c599cfb4e6bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9df9099925839203d3b2ee066177391a2e54968fd9003bd6c2c6d6568dfbbd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3102afbcc95a50dcf6532f67378bb4898350b534498181543e89711725266010(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c009a9ba1a92eb34c06a23d3153a6cca198b619653b3155d91475b29399d8450(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02252783a486b7a45cb01c5d604ec981d2c8b793ef4610fef7975e82d4998f93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30b74f2df61fe51b49ea4cddc5e9454d9074b16335338e558a3b85dbe268910(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4793b99850a1b20c03a419fdc2715bb5a786f088ca9216e668bc6919f788a8ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e46cf954eecb1e23a52e398f1075a4bd2c0f223dd09ed0d864f02459a93e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b96136cd8057434573d2e3cd0664c0c121ced18b85f564f10e8c0abbdf27418(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485d428c60ccefa36376ae5d52cc2508ec8f17ca38074e4a4754ab33e0d2d9ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17a09e99c471f4d3e3e9507de7b1a061fc1a645dbeb73e814f82a1220061921(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e2329b64526696b3d082034592ea3ca52282c3ed5291111849060b944265ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6ef0757c7029092165bb88e83205097dc3d1d5a42d24e77b7eec2951e84cbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62da7f918057c24961825a5e385a9fcc88fa4d22929eb1e449ea159ed744be0c(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e67bb21776815c8b8f7ce8458c9dbc9e4d7b0e676cc4a445ff776b3da1dc55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a8c4c467b2c3091c265e58368e703f7d5c19006b2aebc373643dda111e8b49(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b068164df8540523f4d60f61000bfdf1cb771491239040aa01c0b40916a8e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12dc9ed218b1d34b50551f1689a35abe493205daf4551cb6cfce70155c51803(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361a20bb84a7a617577a1e985887d0dfe1d142e6f51e2c9f7a2c74c0f329db89(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4901d0a46acc14b0cf401fbaf30fb95d7d8d1f77bf4f50b0154985f9d05204(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ab2074d080e4453170b73a5a451d4227659ad36e904ced86c37ca1cd4c6319(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7cc460f9ad9631b6de9c458fd478bda5b2b06349dc1808493efe5e93c9926e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7790079f0298b4e594700b1920fb14b2b95af56bbdfbe861409dc05a67b037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bede8e0e1a6673cf3ebf4a19b82802dee3c8cec05c639e31b8318435d2c81564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2e0430bb49832a5a16ab5e17da314ba8c5ccdacb20badf46c712b570537428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b984a8699c2c419d0ec0c221a05dcf2ee71430337463c651212d8ae66e3f297(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0195231af6cc367561ad4461344645b0b7bfe8c5496fbcdab655274c3dd6e3(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7435e40a1063c1db9c60bb2b6c3fb63120d865bf477b01bb70db3e5e14fd955(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaa09d9523f895fcf6e95e08a9e5435b35cb0c53bdec69c044cc6532c530030(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3215ba93ff87f3a2d06994e062ad3e5f755cddd05f31af18fcce8879f9984088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58c22e2309f0191588d3abbf8a67e1c74dd2984355918dd274e87add61fa5bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e146bbcc9129ba09c9e4bcb593b5a817cb740acc9f15496d791481c107b107c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25e256f11f677fb4665fcd155e2e5f507ce6f89c04e9cc65161281cca727f7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9e5cf573ac051bd83ee1cbe016546caa02652c749102245d74c15abb90f90e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4344b414db08869efd70cb4ea039835da14d73d01ec261ea782beee0b17c50cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7070b69beb5fe39a37355472aa54ae3d957f77c8f835d9a9a8cd66224fc1cc96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc22faaf9bc62d45f1f066ede99f9427804d942cbc868e216edb9bbf62e75328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01ac1b1eb1632fe4b37929f6731b7296b60b27058625795a281502ff64e0fb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb39d7af0f041b77cd68a761dc41c1fb9824f6bdaa5687447bdf3a86f689d53d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60c54ab942fd91b52e769bb1779b257fa50a8842c4e381de11ac995ecfe430f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d00ed9baf1aca9f51c87f40f5e092693d322adfa7136b28ec1b487ced463171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe766da4ba9b82c9a699e118f333d2d0669504c785486d8c410f8fe98eff77b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b6325cfcb04e320752d113edcdfde0b4408b3879aedecc84a3269c292a945d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835a0c24e31903b0bb1574e5535469a9443ab54e2a57588c563ca6798a30ff7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1017e358db16aaf915905390a11b61624d022f991fb5848c5f9d4df860158c03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0af46731c9f13b8ee4feab0d441ec7bc99abcee8bb1cb8c21ae8b06ff9dd919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617c83ee350eb3f65f7aca14c8f2533f3c64cce4083a6c8fedf73c819867f40d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416d1fff8f4c3ead858f3472f07b9a8bdfd68398aa2fc9cc5f15d976735b1cdd(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50838588643af85a9b52e4e99d3dc376af49d9a2116ea9fb76b45ac3e27362a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad4458c110661e7d038d85915f54b143802145e675b0062d0adebcec0e49021(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411a951fd9b938ea45e4ef4629477f11ed5fd08577b683c960a358b11f228781(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ca728803d64a99b20f9b028e4298e515812d5bd48dccf06224995dfa958373(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a0491be21986d4569bd492f4542f53a4bea3e3d53d6fecd1781fe48a7c4279(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b68887f3d0b4321d9909b462a86ffcb80b66a2868e072675c3cfd5efd9503c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2539b7acc0e2bd5f809759037952fc0cbc3567da8a8e82fa044f1e8a9b87fa21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0577bc9e48cf154f13a42155bb2548ee17f51de0eb01d3f725919d068655163c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__594427f3572a5b4ccebba356717f3014f53f6bd98b5c369baed7bc7d6adff1a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e03f020df779480eb95d776bc4fd2ba53ffa037f33341a01c309296913c8b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bb00f37c09d4ced1c04045d07165a6cf583a54a42c2a536aabab625fdf10c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25e1bdc360477f3a05300989ed29d9080e9a2ca00ce14be692431f05b49e303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ffea67a94cfa2564629ef43e57d66b7536a1908a38fc8ed8a85be5923cd29e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac011a942b41e4db5add3064af3a2e4ec20b29c004c49da5f5a74783503278b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c9890dc2f8b54ec17a5531938e0ca1d1d8fa038b156d7d47dd5695f860c909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469b1687957d95b59af4e67ecc6f17afefe6fbbbfdf9777d8f8729406881ff30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780b74ffbd7b85895672574e2b3395771c18df0d96d4a90092e0bfc7791f4e8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d974345f4c10a1250aa5b6725b00b4e0204bfffd17a9b2703d30160996d68b78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a54b8c30b654868fa6f3b8cd433924e1daddd8c87e2c5ac40adeb9755d841b24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac8658b114f5bfa292bc91e97c95c8bf87cc4d345a1ddf4456ca2eb9405cdd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f9c82f2f7fc7ae70e8ff6bec3faa043a233318c7d38e15c1bc9c0b8f5b6a7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12e2a7cfaf30e0b1aa0b240d7eea2cd9dc267037a892c5eccc10d0b05be8367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f231a5e64d01ed23c55e7a88d865dcb4d40bc597bc8f20b36f6e00d979447e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602df44cdf155b9ce7d23fb59394642e70debcd612d91c976adabc572272a408(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11fd412043a45f292c123c05ea3e7046b83634d45f94293ea372086b361a8d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069429a09c4d71a77b973e282ddf24fdb5772acddf258f9367377066bde229aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd3915174ae5accaf03044cf4c9e6f8a37f3a0a26ca018411db3da086b515b7e(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d970042aaf5b3cffd9f2b85900943eb1794130c01f5c100788035ea9403af2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__856dc1cfce2e1a9cffeb2439949d308737bd1246a1ff4128830297bd0d142d82(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d0828f2d2b035127c8108595d3c4b500ef3b7d7d36230349b0060b11e8db30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46d0dfff7e58eb008f56facc78bf28d31313c00082291f88e45a7e128b368e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d072ea2cf4054a14d967611c001e3b3683e3ccb5b1938b6c095adb8c88b1c660(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db8f88b3fb8e7decc7fb142e2734cf4d95e383dd582e3651470ae05e40d26fc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7c180d7583bbc7ab3ae57c47136f82a54a922c6700e91f89dc516d1449a7cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f063ddab8ada145c59a8a3168e3c28a1af2ede45c79e6476d760d7dbd80234b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ee6e6350675f09711173b67ae5551553c7de4de3fd88cf3df2753cb469957f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d1d2a11dd5b0c0f3a2b61c005e385a43fe75b39a82eab8481741b1a2adb6b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b25a5001064d4f05264627a23c48d98b24b2272e528328d3beba2dcd79f683e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5d4be3c65e1ddf576751735f4a7029b500513f5fdc0e598e3e634a6cc37f62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b2f3aa3bf5217adfbad48c53dc638f494d7ce6bc04263a0e706c3f7e90ae74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d140d63c6b23357326171ab242dea0cb1f2a22f6b571c58947c69abaeb878e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97c778b71bfbbddb0a7f81695a6f01f60a476a2f4dc04526f707a13669fed83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3c3f360abedfd6c32daa54d69e28037cd6f9f25f7ef9318478855a4b66f83f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2068e79c86d7c771504f800021b0da794a3f4b6d9376712472aff5feeb677a88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f64b1350c8ec92aac1fb8b7850e8be94b2ad3fb230812f5cdb855ec42b4245(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d5b9bd8b9caafce77f2b6381e0c28ca7a44041b6209b256c5554840c33113a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e59a9dbceddb2d3c201ed1ce3552df5c4852dde073b21f3e05ccc32618fbb44e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2c31652a593496c1af692b3a333243cca94f8029556574ad58bd5d46e62cdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb0799af27492bb36709f8cc28a2c68c7f12eca5753f8061112d345cc3df3f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6667f439ea274ec3ad7333514965477025345ea998d52d681141180d797407f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8150af825ab6a0a59fff66f6f307c86c41652c114cbe66af25ed469a1083a4e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e8915a52283fa5b3b39f15cb01ee0fab32e55d2b9ce14794347806011b9a66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cfad2977ad9a0196e81c03ee10666d49ff1583c0bf651b763e153c42be41814(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa86df8b155db1f007d7924004556f92b775b5826b79e31ba702e3f3f3e7e0c(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbb9e53761b2abee0fa7d50716ef70813e7f51cc8ea38ce0cd2c348da254ade(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe51ba3064de0a6a2e37505eabc1a571035a2f72833901ce003ac552b0229c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8974d4d1d0caabc7233e08a5d4e6c4cc231570a655852d3c5c5444ead2ad3240(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508a92e68bdbf9537735febacf173b622530612dce6a3be8164060c062573157(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3765d492777dc765344554771746c3c360a42a3d5baeb2d95a596a8e29dae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920694c497922c0855afddde6978ec9fec995fbcc712d33303628a11c8569ca2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2bed57c83eed5c792b997d8a1317f03769dce03756c23a30d012e286577981(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e03db08f939e2d10852728b673ac515e47da5e5eb5ed6eb8bfecb206f51bc15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7467578c7b9ac1548d74edd21f0e714fbcb717cf75c110376884f38092f0b48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406f66ac423827fe56f9986948fdf3b7626653fe391f0d5bae73574e37eab14f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0c0b3acfb0c1c2cf6d30732e5f2916231522d0c19d66d0e17847354ea259be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a816646d4944cdf2e2ee941f645d1f102dba0ad48a81fef6a84022ad486e00f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08eea7611b1ba1551ea27ca6857b780960c6d01119b212afa32403e732635911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8811b9ddf7fa1733978294b0f72168969a6753e385bbc034fd41acc30c47c7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0adfede6438db7afca88d448f5a1d3f5be756262ee3b6278c4481e7d44abc92(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7786430715e644a17a6c688c99c707e635d169679151a6e135ad887ad7fb390e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b6c485cd78f75f69a551e5360f9258ca5a42bb0dd810fbd52e18cff9ad98a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8efa4fb2229676dc2a5e8d38a9a2611cc084ef870890178607b55f60af3204c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68035c5abde498153392989af40834378c1b6eff6dd09ccdde36fb93dc0e5b5a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b053531abc882f5be310006514f7362762e22797b13ae397620a97f58b3ee61(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e756495bddc40e749b792a1a73e26c3a9687ec7f8f1c374b48c02166c6a72ecd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904fb04911c21e58a06d0a5c3ab7eee4c249b369c97241e9a3ff73fb711e44cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c9eb4611b93d2e893f78774b94acc21f51c5e4b56cc34deaeebdb01f0c5038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96db71f55736b88b8e953d67b5bc7cafa17cca08a85a36517c757c92c3220026(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db846afe0f9285b75e6a161fe2fa0e0398696e6e0df176bb5b73bac3e22f76c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e770a883b8140bb59a133f5e8eb62d7e60aacd889b0609ab1b0d7b3a189b05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac276a0b4a4236f1b59a62a9a03b136bc0c37c84eb625135b5e7adbd7552507d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9321f0bbd283886ed5513717e094c1c6f840eef057366c306aa4e7fa01c6a66a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463e33902b12a756c0c85210ef3874d4a8f6365217c56ebb51aa9fe0a4eab99d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8b3776560975c0a01b353bab8157a57469b3d63ad5688e13702c1cb0258bc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34cf45d08b5cff00614323baefc41e5c6d17fb464bd941d0cf6adc544a2b4fc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a4c518b8c620ba12b1cf5729bce68eabad10453190892890c6487deccadcae(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aece8ea76ae6ef99871b03e74afcc279f2523a08b3d24966ecc19928f5274d5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67e93a0fbcabce5142910e69fb92d7ebaf7c71c7bbe91de8ae6849639251f12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561847ae3ffe0543e1c13ee7267becc46fbd2525e28acea5101f17a333b89d3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ec2450ae324fd4363f6f8dacc85ab2d1fa52d4f49f4358d1f766e7e44b8645(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2628e3bd3c86dd29826d71731904b53cdd9f91b7a5f773cf04bbd5521d01a2d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932989ccaa87219c1ff4bc5102c90047664ecee280d4112f4c22fd017d21c05a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496e8e528275328d59d0dffff40662bcfa07e9571ba620b16eacac3d3b6a02c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c2cceac8fb75d9e5885207794a1da1160e437dbac52d3ff67c437b3154e743(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87016e534d4ac9e39be75938a45997e05816f5e9c48fd72118d4101f01d8e27c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed36341dbac8c47f44fdf8a9c3e9fc0d27c1d654b135334b3e1a2e1f691cd51d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e47a07811655b389d019fde5f7ff787e08a1b2d6778deef6d175f26ac42f02(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbac36cf9404d904544f66f1e7e80f684a79b78e7539c13ba04951f1ac1749ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181ebc5ba0a3308ff4766f5eda8a0f38c588e5d2906686a94da3ff21556519b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a99d5e8f288b11f9324cf16b84d3f15ef678cb80593d64ed42d6db4529b4ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c99d289cb5e16a250586af95823b90e7d8cc3c9d0f06bd6cafcedf789f6211(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfccdea8e85c35069791c4dc4850ed2caf655ea99af930076d792d695e1071c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a365e577d239f9aa8f4d3e9aa95f803f303223855892d06081c42f810cd19b41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91830b9591f8801bb720523e217a48389814351a5988f0e120d13f2d8f761ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d59d50a12973d289c2504615f0428206e592f24a75afde1134e111e19acfda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744822b6c995a329f50bb5462771a315e2bebc63244810d664a2d24d4b3f844a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc46776da863a3ccf179340e840f700bffb400b16acf8e3234561c7205bfbb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ae0fbc264e65835e1ffa767eedad0e9ba96431a6d2d1533efdd3b7cc80a12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1498b1a020a5f3e6160901e873d6d4e49d872c23eae404097d9d00826ba91876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ec04aa98c03b754ff83bc7021cec0131be9f03e3e2c69cdcd6d759aa0abba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4778c0500a2918a3666fdaf44bfeca6e75ca56abacdf6e7b31e11b5f3c4a38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402e01c1e85f9d5075928ea7986486e9d8d939be2e8f4ba3e9e09ca12c445e06(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56dd05e7a4c08065ad0c4f77c71e1e378c0f9990e043e484d2536548560d5c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbb7d34a0648be5c577558a480280ed2cd3d8c2c1a0fd8c6503556a78cf4fc5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53df3362dba8ce7bab8170fc2a3c64c23b077e79ea99cd92be7c0d2a58a03ec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793215d3c3e801e8f0f0a34279803c4d965d4a4cad28a1fd235e1660b32889d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b4be958d933ca18aac230644c8c28d9b6d2b25a06738d7b2a95534c1c8ec31(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67413ddf96a9be7e931bde7a1e3509fc9055af285fb6135ade24b4e40d5fc761(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9975328e8db9b97b535a882e799ccfa17e0c9f4bb3a548b919956d647a40dfbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7813dd55d5f1d3238a010ea1a20e553a0b464db210ffa7b1c237f8078f77e33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe05e44b7682dbec505ec2b72f6efa8b4b3ebfd271f20ab2d8beca89fd31ac07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abdd8c9c78aca936924b12c64bada7560f40ef994209ad8ca7cc37391ac8b5b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba45a450b41089ed323ce05420e5ac5cbdcdb58c1314aea38f203daf6ec8b61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c785c4b4d7f0d89e07139f7cb928ccf473c378851bf10bac16350d7910527b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d9f6dfd7f9dd2579ab375dffe098b6788f7504337cf1ff0cf831aa949260380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91202daee275f5f778b8ff91f1c57db7a68496e129375341d686c7b2b1bc7b29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e200b3fb523bbf172c934a24885425eef3b69fd872000c431fb6ab04672baa2a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e94cac72dca02986dfa5d9c90bec7359da32dd0226df3cf9d7bf3c6ac566de7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ce8e9b8df0710b74cc5dbcf608a4c11475cf720f0bccb6af91033105ad7b67(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd28a8427399b09fb25938e69a94599ffb1a629f8c661f2df96c6472553a8bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61719e9ce598faeb8395fddeac9c25b4bc0f6fce807b81944049f5d7e08b209c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746d6e8254126df17019d5b56d42e42f2ef51d8070ab5b7d0f097ec35dc6f9aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55348c35988bcffea7fa6ccefecc499d562af5523643e55e74090da2f57bea76(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617ee04736a405d0fe3d11cde34509664b314e6dda3c3b11c4980175e645d198(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128f66ca5dc66465d153bea1121500a3e4bb6d0bd8858e1672dbcf91ef08a550(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea58209ffcc3a85680a0e78923bbc4abed733da701724e220ecbb16a0be4e34c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9ce6eb6bb2befe9f7d5df6e1578d49d9656f74d0624408d78aa2c5724b19de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db2d1a3da0e7818a3946a44fa83d1cb145d4d27a5952f357b9b72dd11ec8310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715ae33d6e4eed34a0732ba1eb77ca8b9d4ed82ece060e4d430f5fceb9c90634(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63ab775dd6e1b234ba378b6714fa4ad3d1a7f460a5d13ecacff009381fc4aa6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a10a141c0bbd47775a06e81851eb2d952821ad08e84b9d03d15045de25937e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c7361ff5515eed89e521590e1030d4a7bb60430d66880a42dcf27ed523d0ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89747f970896673201f3e4dcdb43549eeb830ae6925b3f47ea74e7d5162862c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5cf4151defe90ef722e19ce04c53e792a2d9c9f765d0593a45adf14bc3bac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06671902dd210a5de4e86a3a4407c078a69848a20fd3709d1d0dcc58a03c6679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd7846db4889900761d08a3204551b1c7e7fb6e27147b39e0a74a18008ccc68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__638ef0cbd7c4295af747d37cc6bdc1b3df4fbecfffe659bb5eca32fa309b0f80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9547d44623d9d9d0c87f5a3fb321100cc3228b8dcf32e8ea575c59bf2107252e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb06c98f6d3cb01a988d2b3566e40ec953336ef9a13a50378756b1eb67c3b98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b53d0055ca19b56990e890b0e1b2a14a4bd484f1c05538206195b79e7b28bd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ce42cb77ad8181082ea24876d001dbafca188dbc93d2bfb73d8ac4ade0fcee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380af500b5006e0be0cb812d59dd53541f63fe542f839c4033ef6a2ae898b8b9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56eb691022a5f9225f85668d5c398b3138c4b12c7b3ece29b24873f4e3fcd6af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1627051c0558da7b84a58abce273c25eb4b8acfe524bf1fe33f92c18fa8b191a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072918b1acc015361e3fc98795d2bb2c8860bd468517e6c71aa8869517968d2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8434b58b46acaccaa9499dc1e4d313d2e7f3bdb5b462a03997332650a7062e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0c5c1277ea4c4b09c56c867032e0831bf5397101906dd733d6a40186a07478(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c9886f9fcb1d8911555d7be3c36aee115e49c2ae159f7a4670c1269391e7ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c49f95fdcdbcd56c5faf1f849d8e88e285004a0dc3886dc452bf08c1d314b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cadd098198cb56e0c265629184fd48169476f17db010b51ef712b2e1c3c48f19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215d568aaeb355c47dfabea84901d4792848e4d99ac0ce1a275bee2ab7814943(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1c3ba928a78b6def357f797fb0bf7a1bfd8c3f23464ac299b96da4b12962de(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38460106a3c44a3a5a1ef28a909bb0bbb19c45d5484f37d6f84761497407c4ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3364e891d8d31bb010d4a660fee13149169cdd5e735d1e29ebb5bf140806e93(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6126452ef2445288f4581c80512cc004726514f37e44f879a968886d5013620c(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a181dd8dbd81f872224ab98251e4a2337fef538dc58dcfeee18709e9f0a118(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6764cc8019ce789c40887db774ef0e4e05a7d3e90e1826613956670d4b9e709b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067586ba4a936bee8da4c0a5096f873dad837459e0c609b4d634a65ea453e414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ded7d4fa16105cd99d53cdea3b1aa6b6148f1b89256cbc557a2b29e35739607(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a82ac498c898f4b7c71cac51931b604fa9b6695c154a84ad2732de5aeb06ce3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cd799ade09a6bb78941b094ed33ef551e00ac1912f17bf4477e9b27515feb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20703fb7762b9d519f88f8d7b190aed76f5a129da180d325f83ffebe56c04c87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290d60ec64fa390166593b80720a1d7c012ee06913f33a84c231748417b91df4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__235151b1dd2cc9a078b90ddecc00eb3aa863d79d23171152ad279ef0b5e6aae9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9394237cf4c37d76a3f8f49f7734022bea895bb416712e8053aecdcd9d77cc3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7a9695e7f88ac066e7261552267c913b20dc0dc623d91a87999f6340caabca(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1fae49a7f79f93b2caceb8ddd97b8863c71ad94057a4e9c82f33e75a49c03e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af732c1ac75f70826d6150d73ec77490134e99fe4ac6fc89711719cc0d9b0d5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730b1f5d52545f17cd8c73ad382a19e251d5df1f864a73ad41b38521a5716515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f972afeb030e6de11f1622eba32a40a34228ffbfd2f5bb4b35900c259eda47ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a893eb3b044c1d4cdee87d65d1f07a7733e12b93c2e65ddfd4d1e62e53f8f40(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3b0ac5426009b5ca34a144108b188eb518fb373cf7aad7dddec8c8cbc9ac981(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd3b3771cfc636ddbddf92890c129204bb40769ebc1258372785e9b63a1f02f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b807048ce756a251380fb5c22d94093c6a84c29f9363bf6b73c98148e9cb344d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90337644c1d6f4867af781c6ebb9f63a8df506b9126e42c3789c7898c602d4bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ab84e4b35553abaaa83a97c0b903403cf16d39c1e61a9798dc28d0eec3156d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b850558b22acef60e1bb15e9ce6a52ab820de26e6b101d62a11ba40b723187d(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53f668aab2ea34b1ba88279c06e94d833462c83807efcdb2db1f2def3a86c1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2aec368dcc05fb37df9dca61687634c171214d3e25fa418a40ee2f97526673(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def67ca60117ce51e58bd52b61fcae57f90e6e285560bf12f7e758b36ef36e35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149f7694a6183b0eb124b279fd4bb147631d4a2e78259368253753a1f2c7fe28(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193c0722ef04a4213eddd574e399e9eb5e4982abe635ceb690bdab6390b613c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__636aee2f45ece933c30257718e694533798b15afc387e4852028e83b5d189992(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3a5fd6b06b8d4abf936df214c21e988af8de565348861611a0219b11c94fed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51738e78a309debaac8873c7c0b60eac5e3b7ca9aad1abb4fc840a13ab9154a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1026b18c36ab3f8e24cd2413a55b5fc7fdf32fe491712ae8fe89bd786c66eb7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e33e7faa8be7a33935c8d3ce277e5b611f4b1a19a9ea6f52f35b78488bc7a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76295d7588ec4d99a983e7fe22a929bb2531fab04787dc3f510f92e7877172f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27f02f3ab60b961165458f8217dae1bf6175c841f84249082af64bcd6c48b62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ceed56378391c6bf1a593333aab4ff6d8f4428aca86c229ccdf7f3da56c28c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d23359330fe81fff07a17421fc911e59213d886f37ad8f257e9b88dbd05c057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f0bbc19547fcc61447b8d27d2699e2d359e4462cb1d7a5abf59e04f618d509(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80f5128613dc9060e3742661999cf43c503eb31a22dc49ffca89e5a3f39e1db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4560a325c6bd0f431dd8e553b45b46f06fdb1a1edbd90509406f116d14a4a04a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dd0e27f20014d9f9c71bb8dcac9a0ab3497c0530fd614bb5d9df36199f9f51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5add8b571fe2eb6cc7c7d8469a54eb56bc8d2b6b0352f897b5b05e5ecfc978(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e76cd828e8eb7c59daa239b356a8acb1c6d399951bad547d5d547dd75d978b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11ab05d176f4725c3d6ee1bd8b625c9c910096fa24cf2417c1a158fafa75666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4afaed2bf3616d5c62e74429bef830ddfb6a2d7118fea37c0cbe12afa3dd8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9618a027805027b04b5a0b643a28342f385ec22944db90725c2e2fdc8e437b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e809c0dae073bbdeb4f0b478b20b6cd6debc49ae3194a2297adc930cbb2c521f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39281b07f55818c4bceb98da41dd89c83000aebeab84a91360cd36866985ad8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc9cfa03551d028ad6f9327589e95064bdb2a12d3609b129e7dd9fc6fb958bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a922c530eff5d9a4b88dbbd76d198fb6a7419cdae6c3304937ae8fad505e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77629c82df09ec0113e9e536c1c9b0a7160c24bf6871eaefcf24c29bedf30aec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a203eefd28a64104c294557c0664469da291f891d9610e82bf6571c0ba7192e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1845ee75df192944bd2046832979e818c37546b1d85ae55f14b2b8e0b03faeb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526e5f4a6ca9dea751bf65fcb42c1aff0bbf2c58fa7686de596911eaa2ffab99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583f7d7fcef27a1243e30733c787084ad6f9a1e10263f201bbca3d179b9da520(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c588781f1803388edb235d16c80d2794476a02aed1df204e249c09751ffe81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbca410a3a50c0d07fe987496df4689084743b1a66a0965530e204c765587e8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3796d8a99191ab15e9e1b6f6a7ec904dd3fdd09d5c61757073baa4459bad9a2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c2bb0ec19bc9cb78f75d415e3d26d8727f0bdcc881f0de27ab0aada9bcb8ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1474d9aecb40825eacb54dbf8d9f82435c93b10be56f1fe604e93bff0551e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732fb6b70786bafc3bcb39cee325ba2a8d358ca483120b947c30cc656b5b72c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e88d704f3087ee3e2db3f74c65c3a994538a1df77cb7921794b1bf6c409b1cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f38f2b51c2011c3b031bb10ed08718ec9b31692877b94c7848980d8eded411(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47083c253cdcbf234a3262c44b1f57e2a588d9eb2c36ad6ea306aeed5c789e11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7851ef0dc3766b960135c6f2a488e06fb88577b16339fa874c7f13ac11a0d1c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2db16022dc0769653b45588e80323104e1cb15e2d0b46c2315ec1316139b2af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfda5b4a23a06d003575e5d40a133f7c8110e253da2a01eece7d9e776bc63f1c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ce5b756da36804060337e6d292b53f655166a6ddf511be00570129c3d52f7a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df7399143f1459d6b67d50d035a05d9aeb29a84700c439f209477cd031c0094(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccbcac490bcfae08cf1344d7c4d3260367e4a6d04d891fe7250a7f14b85c5b31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70cb1413815c1ac797972d8521cf9d7a2c29c2eb87b3b455dfc8110d75b07e7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3247c4437ec05ef7a0652dd4f3ddd1cc9391d3a4341672c1963cd06e61d9c798(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5746b7f692ba7db088039605f1511c04c7739fabcb26b29b03824cea9dae17b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de18b9e13b2e82207bd94d7938aac2bffefd153718a8afbbaf517f4b9635ac6d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8deb3f67e07035a1b999171a33e7b10a08315d49868855d37052ce75d81d2c58(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68369c9527d777f775781c5ccfd6cc42f107766a9aa74b2b8e648851d854e21c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95cd19e52933eabffc6757adc839d1da5178959242c21eb41d3f952559f30c14(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12aa3398a330462dad69a371b4cbb376775d357688c5a6ea34b79d68ad89eb68(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7a7ed9ca99f2796da70038fa6f82bc8e9edd105a92972da0dc3230f0d32bfe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9662f95c53ada5822e562daab0abe32cfb59c1eab7c76ff5bce67d3343e584f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4659e905ab3d66566324cc8f7d6cceebf81bee63f16f21aaf42e6aa9a1bd3008(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a097ee6b4be8cbed5831f19cc60fd8896099ac2088c3403979d42cd13e71713f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13fb2658c8c2994fbf27565cdcb1ef8ea61317691f42a5c8e1ac16c3c0ed69c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f6b616a27a024b009385bcb5e3cae73b237ecde288589b3bc93d5e90cb4c61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a88c62ba80ba56e3e0d78266e5862e4b8f60915f1a71a3ad774423ab9cea87(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d388b18cdbc8db3d32bfc943604c473d9c334e188d22932bea83a4329de58f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5551b7bb804b346af052f982f21b69be0e8cdda81cc2db2d8f495d13de3a83aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2821754db7c8624c3c75e24640f72b666715e8fb53c9dd12dcd3e31dd029738(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80ef10bf2d39d63e0668214fe35080a54f9fb50e6c4e6127c9ad25d599cd7e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5284536c785cb452b1065198e7080b19d5bc0bc3d855839b3acbaea408ef2ae3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452741125e2b4767f2c6cc4e52d1293d3ce183a6af56b1f49c1022f5956dd50d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a615b8f93fc23b3258985cb0f1daa77c83b22f33eaf044ddcb172e16655a1fc(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c10708c725324b40beb44ba1b1af8ad90038387cd925483ae71d82dee741e46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b586cc9cfec36a0baa41c80a28edb748bfdbb4800c293ea0458d1a75e490d0c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ade57322b33958966cef91473be1def4384ad81408a7a059d98c7d2d7b48ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c4d172c4dfd68a76f676a5987d00e35c85884f2b76663b12533d1fd3b8a3fa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85065ba83b207c00a99cce2cd869c0f8eadc1cf7643d35f63300be7c30115be5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89fc8741dfa7627cd02da6fab6853e80133d20c58c2c9519e540dadb327f1a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ee1e7137575a87bf735164ba68224907b465afba676d81013dc8aa728ae6f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__becaff26aa2cdbaf884ac51ef59e8bdfb44d61b2294aa6292d3caf2d6643a747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed022076d75092f41054b389a6d2b14a2de5d13bb8d971411ca533f2614f386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1177ce8e095ac9a83bcfda1fcba4aded8a6495459d28de688e36c0842176673b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b544c4fd63828fc697ce2c0076262c6b8376d6030a7e64b45b16153fd697e48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98518bea98b67f6cf62a7894774d80658e506723ed56ff9a3fb1dec748c50d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33c8eaf7d0061cb32081a2c6674a692b0d0e3f97caabd78e637e3b9292bbc26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb2053eb08d299463c129c13f617b687abfb8051ad7883bade10371c2415689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20cd436d6645658bc110ed4ae0730c941dc00f482a5faf2bd8eb7a4627d1cfaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9283b915825573ab734b089657454d124ab47299dc524795e2f36ec1769e6102(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c197a495f00a320d788d7a3c1a4ac714373c46dd977dd4d2ab6cdd58d3bac25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8801b42aca3a7c51af5af767cf98d002e9263a1e6a63a25a7ca5c0dd662808(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8551527af7bfea9a8da469732bd2efe063cdea6e42dd1a84c2af1c86d2ffb7a(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c87df38adcf8a8d2a7521923a2f79325ddee72e1a6eca0a4497fa325926502(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40dec161aea8d5bdc89a598c888fd0f9287d0203f861d9aad4f960db1f8e1d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece83672389a7a8a98720dd7b0918496f01e4d6b7e1f054ab591853c5ad8ef88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3255785cfe2aa421e560a541bc5e3225fd3296acdd21f6d05096caa201536083(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1deff14191ffc691d0304dce408bb3cacbbec1bc96c61e003396eb929c74de(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7364d94c432c447cfda285f80a4c7cb26360eb47c4ac5cd5a81c20def4c5b7d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8e612a22bfd305ce0d19a17aa7b488356c6ced26725830756ca2ce9739a508(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cbaa6023ec9c716dfa01ab1dc7f10cd133b408cd0f719d18227b0dbd6318e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486f8e468cfea16aaa878d1a343def612535720786f06b6395a0419543f47d07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083ab7939959e924e01d52026546e991f1b3dc30a0efff8dbe564aebd415839f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e140c5079add2d21ab0a6fecbf2c86629c1eeee39543d4d1943bd23d9b5a6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1eedcaacd7c2dad4b9856a1e07b1decf0b0e6bb99535b233ddde7f2c0cc1db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a93b941c3211e9cf179a19a0c2ac35a645307091285d3b5a35f6d7867708ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd7e352709e56a0b9584545156577eb4605fbb540c685fc129e3a0aa1f708f6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb68ec3235d78a3d6d4ae16b5e9460bb71ccb435e2187ba105c744f9b5b68b24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3915531f109dca9fba410b696824621a031651cd5e2f79e217f12d16a9ac36(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2892206ff695fa8155d8fa9237488ec7350ea32ed3ee1201e03ea550b09b6f62(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b50bf57a173bf6d907d8a7b98b96c122b6297e2ac693fd4156b827049692872(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d2ed45ce1d8db0f80429a754fcae93d9537bf3da93b1cb6c9ae1b2157286d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f52a642a1e3340a59bd342535cb4d8c608abac8ec2a8e4ac65b66d58b96661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b41d55f6910e469cebde39faf10b916f4337f4fd4350937977016f681a813f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f85888d775453523a0b08ac7fc9269e0d7d8173ea26725d27cfca8cfd6eec6ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1218c27b95b77b0deee5370158ee320c59ab0e90ad53e6c2f95cf5b682d5d5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a1c8608b2efb38d07e00bb534fb91458a119beffd3b08b64f19438ace63ce9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c2db0ea98edb5d89e584a3817544e453afb5164cbef44312a3b1ac7c7f8c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7ad64e74d404d415112121520e12a04f43c0ec8b41b4c2bd0f26c2c5535124(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894cfaefe182e3732e117460f4f642f488dc3cd216d53d3d32ad938efa0ab987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a78a7dbe6a3247ef66053ce762fd8b5de832c4ab4c5a292d6924627a830698(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1011aff06e69fda94dd01c180b6caaeb6b6a063494312f2969ffbef534dc77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06ecc570690b93de64c1917a9901be299c1ebdd14265cccbde8e2a684ed511b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c48d8b068600b63c4f7d362675fe7928553c8457075feabcfdac40a6227055(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ac959e0c6953290fa6367ce231342205fd72cbd78305beebd887c609be55a2(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccc210e331bb60758b0d123715741b8bd14b625bbd88a486e0b65090f6e61ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec7690c504becf94517187cc860d8d0a8659d16a47f785cb00453c7d79d9778d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4efdfa8914d5f3a1ede8832bf3e15dd0015e31722ea1026125822f9a2f48bbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48cb6f8fed59021bddb6c02139c0e932397a6b5de4724b99a65d7b62c7b82cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dea8d0caf0a88caf8df9686a49b0b0d8a19f9305f8c662af71ce52fd7659d88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05080afcfdb4f9bd4f9c408dbb0d47174763134bf31e9f53a01165bbc73d85ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ced36b74f11d3416daf3c69e6dde25001969776aa1d8763f23501bc8d4675d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b742e75b3a48f966dd5cedbfe118de75e883eccfcc849c4b6a48e86bee14f55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dfbfad8e9d0733073f2f2b180dedd465f4d78ab02d182a534ce8707faf0ffdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f45407d14ad173039db308e54a2f4b97d2b065ecee828e0f6e7757e8d6dc10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc84efab6561392d2b7bb8e360301e38742481869d12f171ba1f24d8d781b98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e81207e3be2547be6f1872634614697feebd10f546e27f72dcc1e117b0a857e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9388308706f48dd61a29f9f833ea51f9458e7d97b8c7e5639b9e6fd851040057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526568cd75813141f1859e8b55c7e8b24bbfc5286ba222754169476802b32cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7b565a9cb31ae8091025398231b999e498e3f7682fe30aa111e82b97692b8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee176b72a58925358e69b389b2709e4ed011e80a7f2c39dc3ebd4a05a045754f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c3bd08d877e0b56703ffa8186c77746d071817d0ef903cc6368d462f3365e03(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2fe12ed3e4914f3d19b40977d37528e26ac58e1c1cd66a700d2b75146040a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f2ba45433e01be7b47403fd5115c36fffeed312257e8bcf9577491a92304b9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b6ed19121088bf1394c4123f904279224fa7bd84489def73b319430fabaca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68629db9dde8998f24fbbf201d660c2334257bf18fb9b17c7fb75d7dca5363e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de503670c3259f887d2f7ce753555b17113978df1114dcb6a643553d2e8e5d82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c0289242cb56423aa8904d0c4ddeedaa2b434e7796aece6c1b290a4f81e5a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc9684f32ba6fa443bef76b92400d7a38fd7ea96b029b3f85a97bd07b685f8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a11856fe78b0dfd462ef2e7092b75a527c87bf1e1d98304e01efd9590048a6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e6ccfae53bbd771092409ee8265dc372cb5be3c366246a08fe876a6f0ae2e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a47fe6b89650b6c123e933e554ac070ddcf4118f3a768fb16c594296fe0b78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6c55bee8603ba2adf2cf6d6886f17a3049dd57713de0001dc7d36d3433dee5(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56869558d836fcc3b19f925c58508f6f787551ee411de9dbdf91443a955ad634(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d306b357aa290c5ecdf2dd2dbf9b4441410380e44680ea3465a6c1dfa3da605c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab50ed2dc22ab69b244d5813f5ad6160b9c5abf17469102f58fa2ff15b6ea49e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a467f43d51f190f29ccf6f6449f0420044a7fe2f24bc018ad68350978c2188f0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb96aad02e91184ab573a7855703b24b789aaffe83e24b9c83b91b044bb357e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7918820e1087b3e2d5b2781610535985a0151b51ac6ec2cd21ced9197727392(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a94d90f709b4394f4d8bd23ca9ab448ee6a67e633cfeac0fed1bfedad06d2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227aa05fe084e7b541a4d084805fa288d351bbc24f54f33e117c3e869c65df18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fadf23d74702d06626803108e0e08db9ceeb37a04c2582c0fb87ecda9cd463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96939b6f55917f35f61bcd006f6834736b5e8bc69d13195fc97528289bea8285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3de79cfde4f1840a8415b971a8f9d5dcb6f2b652f76178b79805d8b9c3f9f03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db75b4986224c6d0f1b46212cb50f824fe4834f037d0bab373dbd81d7b9e682(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6df20e171924480096a5a0c8a2cc41b1756bf1d418ed0f5d84c26bfe8b927b(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0846f504e3e69393064dc7ea064f087f6ab76d00027534bbff3177a93870355(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82519363c9024c5c52c56b646d57465f493258c2d12e632c1937ad41fc8108c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4754b65b0c9b8eb84407cc39455f1ad383c58e08c4a00fe00d707c50bfc078e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9d28fe9771bfeb0c72f2df1cbc8bf2a96a3c82f9fee83f4d0a95c0f5a15410(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a6273c743c8fcefe2d4bf4dab072471cb97ba26b46d6e64f2f648877094113(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91dc4f27553c468fa7b6c3a9188e4e9eee5a8d10e1afccb85257610a4bd8bf3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f016e60a9f20f6ac414b093725f0d5349bd58ec5a6c82b415fa9ee10f01ada08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b8d5a46a1b89e653984abd1b2a59b74da3d574769710c99013da70eba36eee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd68156e53c2a3d50007070afdc4519cdf2d0f765eff22ef257ab7d86f0ab6df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159215add0aa00152efb4ff1fcad573f27bc5eabcc7eec7a0601792319de8e92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1426852d004842ad8327533247401e8bcd4befec3495d2eebfc48e4c6033c80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac3bc7244c61f0beb5264741983f3a6d471ed485b13c23c44e1f5ef5f570995(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35749cac25a9bb3e3233bb3d21dc400319c83aa9e8a29e22472abcb14643c638(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297f4c07c2f076c5d9877e34ac71d5eb31059bb8ffe3454cfcff151f8fb7cdac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56fa134a5b3d3c00998be94ad8535af7c60273346fa35f2e9179a5e8acc17b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1351222772f225e55fa51294b934a5a65c617ba6f00cd92d9f926e0793c2fee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a311aa9c81c69bd50e99aca76f126a2a8a44fe4d63ee4fd27f8cbd2ff4855067(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b47cebbe6569a0aa06c14ef87a34e41b6d19a0b5163200a7f072bddd893f4ae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6aa23371b40ee058c8302500afcf86912049591bc60015f2209729d4e01284(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e540719a90df810bf053f2a3e48818a030102f41d9ae7f6efe99880e7631539e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df35c31ae87c2212ea4789e9ea0d839f30665fdae90545273ae871fadf2688f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4d36f99219470f4d80fb6f8d40251f3a211ef75a26ade4c7570d3f1a5834c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229147dbf4715f97cde3dcf0a0f4363549d1cfd9384c6c27a8b902a832cc982b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b6cab3ef0d6f6f8a460a7573506c092c73858699877d7b2cc227d8b1ddfcdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc9a22b9993c7f048f6c6439e55f4e4b21f175a84a07d7b1c6bce0a06b87947(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e8a48f139c2265e5557de2464929c8aa20671378981cf0e8e84ad74c9a5722(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2771e505ad05aa9d61cdbe077085f84cdd7a5c6c223db9911e0546c16915519b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7226f7fcf9de6a829d8e498916dc4b6e06f05fb4cd9b6a1d8036af23c59864(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb41cda6d99645dc856d87b592db12d9a6c210ee7f69251ad58357cbabc7d5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0619ed06d54aa9e8426f296b31d04bacc34f9fda5d7705a7516c3ebca7b2a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9dde09fb2197153ebb46f876d2b083edda822d1046819bdd089e46fe8392d8d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8656586f073d065b1d3c44c4e00c38c26dd2eaa224f43fcde209f80e47b6a8ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed439133edcb413f9471e0086f5037fbf2bc3911bfbbc69ec62adbfc532bc6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16c6c62491db9ab6b459f961af559ae1a5e28349fffbe1d7ae01068d34f2bb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c744c8ad08b0aad77577f1e3ed7161bca57b62802d173842ae5a58a46359af76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40b24beeef5c5c56d5ddfef2539d2ce1efa58bb4069aef8a819ffb296537df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5ed41839aa1c27c9f10cfdd48ab974e9f17ea8ace4a4631017af3aabad40bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87b8c7317480e08d860e3e8852ffdd42b4f50ce731737c81c07051b6aea21de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fdfe4b319824204c3768a838eba70f19b9b6a79e588727411b5c5de1e70148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd1960a2148b81b0327bfb27fd81b645500e54b2cff3e967b4258f5152f0453(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d482a9e527f319c7d7f2635f67182908f70417b03a7272e8d8e1d6319073f8(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff01becfe372e9ad39682c01c9d154788adc9e6adb53eec3ef760b67c78d8528(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be84c2b737d44b8009b48311162253b130545b76afd98c00632e8ce0f707ac8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__941dba240a9d060d08a2ad1a35fe70b3add407d66c1e2456a05573fe0b2f6035(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5ef2bc078f36243d97127e82ff5d6c5f581b96eaeebf858181e2b6a04063d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400801af964b4de37701b2c50b97f02d6aee90303627a7a1c0cd870e7ffa3e83(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c76672cf727b4105c13842f7cba0072f9ffabd50bfeca37bc6706c6c2f2328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f35fd0b37cf84df11884ac9d21928a797d0e3b22805be6a940f3c1b6db7d43(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b8c6d416ff66f2b150044114d7c9480ff5efae3e7cbe5f5d0a46761c4adf4f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7c89b1aff0d09ce71216389544580d004b7851b67e88bb7db5843c6bd420db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360e4e677270140f6e3791da0b3b92d7148ce787034ddbdb13aa38f44655211e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce8dd68cfd3db3b1bdcddb6d7d14b4613d52924389d8ae6cb06173d59de28dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d35f74b655d1031ef357d6b1ab80935951bf8f4de5ff3a4c55008b54645f36d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98dd98f6ca5b9241357c65bf1f0271e6536a9a7c9308b3e3ca3a6b5cda819bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625eea764617209a3551769b1c27a31cc99ddb0b8cdb5e277b1f28c24cce1f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d44c024ff9119cba7b593f32e911b316a7bca2ccd459a8b8b837071887acf538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98e4f80b390eebcfbd61738f50686ae7eb008eb670f542c0cbae8434ec48a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981540215bc44095afe2cab38a4dacb3be6726e27e33c318ef23042b6931f66d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e996735a809f0604401634b31a3f08885b7b0e3fc86a495cbd6ae3e39c8823a(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96b41e771094fc386f3371abd3d2a45f4d8dfa3ab83a7ab30a6e8c7633afab7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9d5d910f3191665d519854f13f2585a0a1891a61544f029a96b2d022c4e069(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef90ecaccfe09a818f37f0b1bcb08caafcb4ffe0f9208bb3fed4c053a26e090d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62acca526ee45726b85f4b75ce638defcf3a92772806a4ad92e8a64f408f53e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e67af641049041129864b6eb4a01ff02f3bc341dd43988fb96ab019d3334f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07db199e297a175283bcf57aad8178558cb802fff2833ef9fa26a35ad2551bcd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac05f33440fda83df7052dde3842e6fe02a2b9420b80c7d3ec68dca04c6f91f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0a605505b7441b657cae3de64902d22994e9dfddac44815846e4f5d15eecdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf52bc4fb5deedff1bd199e490a1e2a768af046ebb24771475173e972849498b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20e8c9015eabf8b8261f53df05ac661d8e324e248e50254eef4b74909479f2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580d337ecc3cfb93abc95ac176de987b9e1363ed419f251df03c437129cb3ea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90875a1931484cacd7d176fd36b439a4f3a7ae69ddee34717794a9a8974ad55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893dfd93d47c0197ec644b3bf8da85b5c242b54016235061a037317d98446efd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0edebc6dc839c5e72dda03258ccee24c8f20f667ce92d756756f35772d81a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213def0034af30c184d2e9d2c6e46d7066decfba8b56ac4746116e755b308c26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436ca8d1c8a85ae2a7dfe7b2c5c68ae5e28a717026a9e9026d58e4a229180f64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__051ab1bed0ed1153f09fc09f31079f759512bd0a616c69de7fc292ef319ffe8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01d53c778c0ab899e8367a33458a01712538d4d248e7e48fb2cac2d20f9f1fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a60c161a5dcbb42b824004ab1d183262f999298c224b173cf2edbd03fc45e2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98b85a880d767892338f17cd4d9472409a3c61b630566fe86d6597ccd280c88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a874d2564551ddd41b85ade2b2a8df7a98ad5ef5505e722785d049230be5830b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73cdffdcbadcd131f0bd510fdf60f9ee3b40fa87c1da8b1434c5fa63e5cf112(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807db3ce998cc0b7e47bbfefcc445e9f86f3ad0b314963ac476e694a1a9dfde6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fa6588ea27f4427f59e554555c896005335bfbacb2d021369ec2bad775d946(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064b859d7dce48ccbd7ee404b687aaf42dedd702f838e2c6c5c6106694712656(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4def8898ac2ad99dbcb623541dc7ec27c1c3685116c270397c14c2cb37521326(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__156c67ea9b3a156780babc9e6b2f68650f0ae01de7d16c8e72ad91e3e0738af7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e103ca59cadee38a893af1410f5366bf28c9940ba75cd2f9b7642045ab99932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ef9c3a5cfbe7873576ed89ef40b3cc7f2c83442810d6477d721def5c3a916d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c9ff42cccdf0c15fb78b65859dddb4b18adde21fd0e81bd7ae462bff9220f8(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e3be37ee89b7b5622e064fc1309faae6fbe9e6ef53bca0b844f320f394fc14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__562af4a2201945c46a5ddf4a499499689d519cf289d88e0b56a859cae877ca20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de8f36f9ade97bba64bc9ff3e58aec24080f1d884e257660f79cc761019f21a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25e82c9c306fadc63209dc267eb14e749e05ac4e09f84605d9d8bf54efd72df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d972e0a1a138e864844491d1ab6dab040cce49bfce6f49dab090746dc5fa831(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7dab2c19cf530a0f7a58d645dc4e54c4104d94c159f0a64ff299596f9abec4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f330a96ca3796fcf0fd8c13247478b7006c7ab8e036f7df8a9e9e8f9528d499(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94601bfa00737f11a615265d9ad3409cb9877c8d4db11d08ba182c9b3bb02aa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dadd628316a34539d5b0577a43096b42f97eca9cb8d3537d747c50211aa438de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13e5abf545fa374cc4226ebc7fb0ccb955934ceef73fad3e5ef6cf0955509a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7060d3fbf3adced13609e3fb0d6477794c9636572455cbcaca2705dd4df8cc0f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ef04abc03b3f61204dd75de5504b8e01c607f44c3d070615582051b716179d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157d4cc837ca57320964b761afcb5a7573b91b5f0774317d359667890f1cfd12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd37c381a03ba1c5c6649dff1310c40c431252d394c489acea44d20f718dd618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2364e769fade333b5c3f020a4827108ce1982bc59fd046fe595d37e400e960(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cfc03d1650142598ce0ceeaa940a21a77f0adb7198264f5d7e7d25a271687c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea3922cd0901c6078e7c250cb599f3f12a973339178ea3a116b684b3a0babc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd08e800137e5ffb1caa31d25ba9cce13ecf0100e952772e74b94562d80ddf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b36f3b6e9a2090b7f00d4fcfedd8a9004b33c14a0aa8d64560108b48ec785e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a77b14bb44d7d532cd762f041bf8b99dce462be4680e96c3002f0908a3e1ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107389576d16d60dee2083a8e89dd8c0b9cd6a7f69c5c7e855222c79b49bcb7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3214755db52ba4155ce98100db8d32817b918396bbeef398d7def6900eb492e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12da1b311238239b09fc8e01205eacb3fdff8fabdab95d077b821c8ac5655acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260943ec119a23a950de8cddb5765c9ed4ad66b7952dad8a5312d1f6cb76d59f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b558066b9876c3a9bc61c3af1fd16ce78ad46838fb1ecfb8dbdf0833581a747b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c18b934b40759ae697910f24c82d90787a4656c77e73141dc1a25c917ccf734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1a192085fcf01a91eb1b63d6f4c57ab66d9682d30795940348dbceb871e1f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac629b893124bfba38ed164fb72a2b09be7ce2ca5979d4672229a1c4791a06a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d896cc239284f7c95fbb3cfaf9aad04e604356ea9bd07e82d6661590f22f5e0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7752b7742d4d1837ddf64e01647c805fe20a8eeacfc31f24ac19dc9e424466ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429ad6587c735ea8194a1851f64ba1eaaf21beee08d5dcec13a0868806e0648b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd99cd8a7fada08b91e155633e24b2f3dbc465fb3cb23a2bb6ce32e3b9edc36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ffd80ec5f92e8dd6c1aec29c1a4019392dc3de9a3815cc90533d32a1e70e2eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fde5dd901c3e269fbc86c441b8e53600f41799f20910a7afaf1690a3f2e3b80(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0160359aa9135f2b4154f464d266f7cb31ff570f6eaa08441edbefe9cff303(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaee5d922c8d0f6f5a0ee0a032a8d133b51af49f8ddd03ab35711d222869dcf9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517118858a7630eba53ccf63198b658359569ce084ab26b8e9486fa7747dac0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f31476a8d7087dcb4f4a075855bd012758b2c8afe600eb29218566e9268dcae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca1985a6591531a35fe8aebde0085de3248f28c8ed47b362d6ee47cdc41f178(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b22fe09275f02afedb1c1a952e20d549ef35d31d54a83e1c2f663d1ae570273(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe416db46a2793eb598b3207b0a059fa926aebab88693a9b1b4f97e04711571(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2414978bf6fd7a08d08374e79ad840a8b70b943c6269f2ede3b41ce915aa5b6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7922b73fbf9523a257e47b0525fdad51c02f00dad97179eb2a42e4eaef94e97c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47dda376bc1a23ce43c2aa4843b1871ce43acdd9b083e5b3cba865179c8608e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eeebbb003ff4cd9a6fbbb73dacea10c28de3d64dc8b9eac3b20bdbd53b8e77e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cf81de6cf011b90f89dd681e7c30e777432910381f79726d08fa2c282065f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5dc7b15cb821d05d54a4bf9142a3194cd2bc709d10cf7f2fcb518685e44dc79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976cb61fecda5cf4897d35ee69e7a007f857b7196ba989826bac655f7780ae2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9b232d43a5b641d0e73ecbb70193d9499117df6f3c9274d866db6f3de53f59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87633327b08266f9df37ff5d98e4868eeb76b4516af19c3b89288d7762839911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a6dc38080efcbbfcd44237f120e27ba34f325394ed45e735e7ff63f95db69a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28f6416d1f870ebd8466a2366d328f9ea13f76391573c3bb57a100512116c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b15d96100354abe0c135f82385fbca8f8d4daaa0eaa1f582eb5b25ae1763957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f815f36ab0962c6f4efe6ececa7442140e4e4ec06e36c044dec2e25d7195a02f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11641f78ab61c6e6c67c01449d5fd016461f20530c3908d42ccf5bcac3c1d1c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1152abf3f75635abe1708a53faa071ca76892717f5f221be8bcbf262cb6b515d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7575dc1702c71673b4a62876f235632b02d5607db8a594b19840d37a58b23858(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95134e557e69edd1195d0b48c35e6eb362b06eb2943fa0e48762716b09bad526(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97fc0c2dcd4434c9677baa38552af40e834fc293bbfc7e05b77bbf6420fee59d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6478d8dfa5b37dec6028d75839dc5965880e796e7ef2ff613ed3d1f2cd65a5e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a224266191e37a248a5e63495fe0334478d0a08240dfccef7432429a1169e9b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b432b1b3436a9016cca37f920f55fc0b6eb2c0b070d42a80b857f7fe2373af7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052e6381ca2787a042cae447c99b3ebfcc8c15078378d14778ba8c471fc02456(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dede7f24bb1c4d0e68127f80e7ffe4cbaec4741d37010f41e422ee4238d3e1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1495cdce21a174d695ffbe67a42491fbde3fe6fe32a1bd02e504bcf45dbef1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6a47da05427f5e935f7b9e4f7db09a8a0118de61dd8d2fa43f56f1a81139a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4ae988504f85b00dcc4cdccc58a143b4ee9dfebebdc068af7f4609c401ba01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d776cc5cb37053533ef425c8d02c7af1a8a4521bb4b7c55a41a626cb98bb72(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c50728a26179d39cde0a99fa1303a7ac819c853113ecc156545cebd084b6f44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81568720fc880b410ad5b94d7af1ba95298aa75610ce5ec2ab20d6ab60f1b9be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38576450c847bf01c2a08faa38e5ab9386eb642a9dddac7703ef98110a517bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79aa9d4f79dac148cd084da7f44a3e2196999d892c35a3983637bb3e0dda3d82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38022468de80b84e70f2cc0b493583cac9c1c091819c3a0a1c74e8d4dfb55ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0f4d4a5078c5e7c8d67bfc946c28b388e66410c2fdc80604e38eff98f93c42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7613814b2bc8c6a8bfa941f2804d3ec5c7f61dbc5bccbfeba95a59862c6876d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15326b8e494f862cd2e43b0fa6aad9a06caaa2738f850ea6207e082c95506ddf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab2e7e5f1624faceaf1cff0b2a6287d88d807642c1f7efe72b6fe6d323d40fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efdae06c917b3fd3bb13fa60db84cb7971f3562e2677fd7e7dab765481da8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27bd40a6c2b3d718545bc28d4b37f7b49bc71d7f5ee41d514d67091f50f06c5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd5bc980fc9941ff5cd87393c5056ffc70decdd8a00f4114a6675e00d5b4f399(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9956db1e996c4705f2e7494d4ff2300fafead8cd1b3953427176126ce896cde6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4977118608ed254d1db70ba127f2517563842ee93391f64101cb8f2d07b62ef9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__341683765f9a94c1a0e817603064026ab51483723f57b4a4042d6e219a4e0381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d135aefee29d4ef1a83f7cb6d91ceb1fe64a85c86881061ad521828d471899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418f02179ac9a949cd83c5799359414122327caa7ba54c7ab5515e3ff858f950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617b33ad7b16e6d5623392618c93e233c6fc63a4ffd4052e855159042b1993cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508b0b73406caedf88fb57ba2a2d4c1c3ae816e63b6543b5ed218498bff97f20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c9a288173fd5b95d83c4848d359e2c8b62f0f4d95f298ab03feb3670c4d2dd(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566b63c28fe3c0aaf59dae02f5c5ebfe8b6296bf9b6f8c4d8073ca4ceff5d6a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b50ad40a17d1240c69987765b012c53ef53885310b38d5d8f5b833b31b4a26e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c18a6412a246b27ebfdc40c6a9a0c3a338a61b259eeaa099b64d5771dd4a9b6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff39528735b27ea6524a3cdbd7cd4eeb980854ffc843ca665982a461a480b43(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec5f88c1e2b45abf1fe21e0f299ca68dd6353336bc4a977afd1ac670ec72c80(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b1b4b889bec62ee4f6e4925bb978fe06d6c5d95f9989bd870e20037b76b034d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1293e3f82cff6b574ede4472e3cbe2ba66ccdd63f7d648614bb28b7f065a014(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb9a3e1ece6ff5cff310375e2bd929ee7bc634e420ff7f61061c5dd5bd077d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87be9e9ddda37fdd4b4193338a7821d36bfe96f9961f7234b6864919035cbc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1c2e1158a06569bd5da07e393977348a57d76eb0302303ec7a1e59bdccc19d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d37d86e46232763e44915ab09acaa59df2e35b04879e1159436da3c9308ea67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88da8f0a7fd268b3dc82b0cdf8fbfe2361937143e86032abac271cc35ad8132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8022fcacb81edf5a6f381b658657d385ccd5884304128e62e60216e0c80041c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87260fae7fec88c169db029e058ac00b2712ab5b0d2b02f4df702a868afe9e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed4a6e5cd7e9ef166a9c8a167adb949f4bff6a91c0d37fd9b7d5e444ec9ef02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ea75c030fd9241d46752e9935d762ec2eacac5efc5f5f66850ae7395f1d6b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3f64f9e01e10d38bf9d30b9bcfdce1de89cbce6e844fbd6facf4f8f21262dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e294aacc4b2906b9202562a5842afdf600db1181ff92a2e636adea08cfcb903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd66fbe5a67c7ba0b1b6fe0015efacb9d7d3591448f22cbb2258142b7dafdd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eee6fa80be3b0cd1a6ebba90f0c662b2903d8c65ca3e90b0b821a8cc7193d8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02dba86b539bba88369de3b8f03361a4feeb335c30ed9013a2ba44f1b2638690(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6dc17bae427b90bbd9c4539f629f0268738f31c0150de1fa05e622e8a7ac54f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24bf27ea764f7ab23285b28c8004bdd195f1bfefe955c31edc4bbdb5f7e6147(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50aff8c0d3fc79cbffef401514911a5636b52fcbd899b10fb6a1107e3cfcc05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efcd641a0a536f57bcf898fa91879275b4a28c679032c2f918497af1b537ee9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e195d6f744b455399be14809460974e6beaa3f3eec0c94b65cbd783f9849cf9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd1ab6404789c21f37fc91a8de149f42cc9c048481dda83d1270489d92571ebb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1f0b185d57fc428015487af4478170a7ebd913a3eccc4d6906a420f23a68e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e001367bf6b87850d187d85372995e10ed25fc13bb73c8b1d7d70617d14162ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94145848c59ac2fd96db41f661be0cc9415d2b74acdabce62d426dc3cba8938d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f5a66c62d1e6f33f409822219294daf2c5d660ea72694178e41a3cc6ba3064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869c36e53596597c815a873188673c60cceb0eccce8fb1c1e6759df7b83f3989(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a3145bad3f69499d30f60f9957e1fcd2f2583e1507c3f164247768b74431bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74a0274935e9324d159be42667e99c5a26d347cde3b81c33c14aa8536aa8f9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb4bf261b453c68c9b046586eb054a451c8f67729f6def4a758744a9fc6ca62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5624f9429a8bc2115d346945370d09fb996583c6fbce21c5d4e0485cc480d6c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f724bb504a00377c54512b2c9f20810a347b775676ffb53aa9cbb531ebeccf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8d5cc5281ef7f4a65e6356933cec07656ff31572ce51f87eaf491e17df735b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9b4e7cf0b682a52211f19558bd58f721f38cfb4c9868edf391070540c13838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b6841070f855bbf5780acec405236a4a48d2a5287d20b27a83fdb53a0561ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a0ad248f0d563ae326bd7a6ed13f2cd6064a0912e73a327153b3b8387fdc0ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a404b333cdc937b23a68cd0295acfd7781809a9596be2bebc445f7428388b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__146ce369417321c6f7a8c33e5adcf799415e0e8e87575a8cf6b02cad20428a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7cef8edaedf5e124db6406e00a3290b689cb64e30c0128667cb256d72a90b4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81a2a90f946bffc7bf0ec54f4c97247c9dad7530c5dd9fec61d7f1ae34842c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd47f7c55d5423dab5b4d4a536d6da90afc20c7ed0965eb8107768c756e293a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba0132167d0785376c8dcf71be097a6eef3784c65dde53dbd36caceb22531bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8369dbf0d8a095861e3b449cc78c4c4b6ef4923ed87030a47654f353c6cf47(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__796b1e16c90363ed6b302818b3e516b25e3b7dd0dddfadc4d88df800b5735cfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228edb0a9e6870fe76b0d00ae09ba144a4b2dc2683e4fa3d01cb0b34f37155f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bae6ea6eef1d5e5f6618129d1e7cde4b35ef6b54374a1958e89a1e423004a7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f436dac2789020ca462ceee4e9d0b9bff44d38676b67ddbb2fa6a37cdd115f7d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a638a42c831c19c81e7150de9e3a092aa26d6a5c85f5d7ec88ab72494001cad6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b93477f7bfe78f74625e1888f92bef70dccdd18f15dca206442c303666f15bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201fa171ccaa7dbf6e0f0c7678cab72199bbe63bb93259cb1c24dc4da501837c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f50806cb787a5c5b8a9018830a3bf1543c8289fa25e5e092d1795750114e433(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85850860480800a4e62736106a1ec3f99a529021aaf7294c86776504ecf65902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9be990feb122d7e9bcc0184e0adb78788d755387d42a7a334fa2d75e0cf7e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3283768c85ae5dc1ac98ae82525def8a4ad4fa3fc7daac162da0a182448b535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea62084207520fcc0186bb51e0c5c9956af7e8c3226546058d1ca1fed8b6380e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce182744eba3c8cb7aed87662ae125e766d8de69cd0601f00e7299e954949f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__369bc96eb75118fa1ebbeabe2aef269f62b2173a622f74437b3b9589a79cf440(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6e5326c4f00c900890e8fe085001e4199af07c3e705b0285e626c6367d7fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__945ab6418f4b1161a16cec14480454b813faf0c517419d9589c51dacd3065962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1aba658d16fc30b4ad86e41cf52e1d10a4babade8dd4a8fd5491538f53035d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b389e5cdf8e53be730ef89b372d3ce79f21baa01083167ec41f8524307b8c3c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d444d5124c03f4f4b53eeba10bb1cb6315471ebb47b2f26b670d731c1ac1ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6428ac5e2713197d2c7689535acae68cb07e7cf8b1775019085448905f6d2c84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f753641d6f2592bcdbe9429fdfbd6e7097ee67c7aacac8e96cd58a005b2d882(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e587ac47248ed46eb110a8328add915b45fe924c10be7a88fb4e6912959c411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3671c864031f00ba78e48b62c975ee4be323194de00d9e9bd311592d4979cc19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8158bb08b582c981aa6ceec4dc2ce1b791b3c5ed2e12696c6f39b4cbfda10c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468a92edf7104de899b4878abb9a47ce954aa77360d2924a36dc42802264b1c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a51a1242c077288e64a618b7ccb86ea318a89ff50ebe4be71c77162df1bd6a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b74e0f072985b8929f1b76d8e035e5ca0cb906fadd6fe8719d97e0d7bed613b(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1643d833d524f7174fe93a308f92034d3f943c52d9c0cac0fb95d5dd6beef7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19493cb2ee8309aed8c359e0549c269a1b43254e71c3a75b9a961d3bab1d4b33(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30710c8696c18aa0e1266fd3f7e457e18bf7f116e1259d3dfc0e9b00c0a2b5fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d420719524c1987ad3ced09d47c82cab85f24c38be30c56dea5b9513ee9571f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a952586a95aa7041627854a0ad3b8b0af4b5948e681f3ea20f9f451dcdc180a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab645cfe9f66a5d4158397b681dcc5ed99330aa06e133868e40751dfe4684285(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4c7d174084b47726d87d55d8201c45bf091d8f082f05bd624b040cc28592a6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1614e0c8cc640b8550fc96b20974906e3ab7277328b79746f44eb52474a1eb76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef17ec45a1f399b260ab41fc35f5594568fedd44ca2716a4ff49edaf0b0ecc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b290b3915bc7ec24bcd3d2a8d61fc82941f3d2ac56ea0c692ab885c496aeec1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25ab4323b37291148c66bb3a9483277ff2a867e669d39fa065d431572a9c5ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c4b59c6141bd5eaddff479deeb9bd86c669ec6aa3b201eb9f42e4af56e667b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273b4a2dc0b9271b9aff2d950f465b45008813721f582c2445384ab9c16e66f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730c2ca872b33b00a9af7d0219d25718551375d20bd1a851ecff40fb02a4fcee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93d74f40bd7f3e0d368b742a4b2c4d6b5662a80f7c0e3435475508e8a629ac38(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2796634ac1d799fe06295b6be92b84c71227923528706cf4c5662735e2e742(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ffa43b85ca1291e8e47097aa0fb6f11ee1770f48055cd96e3b55b72839ae49(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706163ede5d48524afff4d1e5f45854b72e5428cd9100c95ffc6c2913ea15e69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0674192c075d6e6dced1ed6e3dc364270f1a64563581a99d21909b856b2bee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa353db20f11b60175b6ee2b2d7d5fa944ae624066f8960a8712db3736b56c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b274b31f222b410dad801239229e9868cbf707b9bfd9c48928ed2fc068b18dfb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df656a621f5ab83f5c2870f13c49760892a1467d39894e083862243361d32e98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e392d866a5735783ce6fb15b04673cc0528a6dd2c2e8c6c44004bbbd70624832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7e7a35164b26d80429a75270f193ffb8d40ec17ab2b1def439b68959ecf140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf3a74e799040d4023764f6572875fbee55578395b462f98f9b4fd93ad6b714(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f817394bdca67aa16f2581e4a2ecc013cb015d563201812509944fa0b52f3029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf189bdf0f947061e407d8bc8406a068110f5be4a821af144d01f7ef0bd99f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5595d3819c86fdaebc0c321e0096a338cde316d571e09eac8ba243072c965a96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c4d6b5e15f9a3d7a1c9d21f83ca04c07a1830750d5de81792caeb5e05be540(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef99c8939a80f02856859dff80ca4149e3d323790403eda13d3f9371941ec9ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15672be63a8fe8b73957d0e4838c75120aa5b8980b1592ccbab430f55cdb6dcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffedacb3dc4451c9511931dc9ea71e4d53c1917ee5dda97b05c74174184001dc(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a89ab5db56f1639fe66e4129e8edf95d8db750689eb311824589277b81895f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a927bce86658dd024fa5fb0aa773570eec19e1521fcf4c52770343787e9ad3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7f76539731fc93b83d98c3d951220f3b79168a27d869fcfd9956f5088eaee8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fa31825fc81b9ca85ec3e5a78fee41636626f9792449db761f28677b82878b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b48d053c2612af4adf12fba4b76d6f259fed9b7aa6a92495bba73fe82a03cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f901e74a3ba3bb5cb82ed063a681d1623a88adf17677402ea5f3b3082081e82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161f95df54483c0b33619b1e6120c123c14a111c052471980a0a85db6542e758(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86cd9840ee8c4f2a7ae7da84858ed1b2a6e3134eef76297dc67207eefb0e402a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1e7c075a6d625697f882c95c4f628059b0a43ec8505857f5b780d41b8abe3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d81738cb6b0630aa7eb21b9774f33a5160d1a10ab4021a8f47b6dc0608324f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8915710c6ebee524b3f218a09d45dbfa822e951e4aa5893316497f31b47b7de0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b0e594d0a5bb34366802058f06df0a08766a64215dffa199e7c2e138980d0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e920a4fc64b259e57ec9fd8999e5ade1bc9ddd8d31c0601ca4be501ac7cebe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2dcc5c09d7fcc34bc526ff3cdf9baf1d95593f96e359c606499eaad9398ad6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f821c2e4c1f012b92c1719a1d7b7401720a63c4fd25a079921425149f0cfa7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a77fe4ba9577ec80227a2bd83199dc884a1358bf4e1da1917c1231aa24cde4d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7c9fe8616a67fb7b527fe71aac5ca456cfbdfd32636e33874a62101e26f9df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa910af0e0cb6404d69a65733735b9c73b5170d87ada92fe6ecd41437cd2e67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d708e3657f94ba271160761d02e5eec0a75aac80ec7380bf53750074004185f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e66bd092099275767c8f86fc1ca64dad4f60d84e5b75347d4fac2f65501d85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9794df067d5b909e75e62e905db154e5dbb8cfb03861936befd4b28122d45648(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997143a50ae807cd2c27d0eddb8470062ab7c41aef59905e578d16787bba68f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5806f3f40286558ad4018a86f2f308f7d16307ebcd1a105b23763c3ad95b9578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2ab1a74abc082cf1eed8b6fb9ace2f6161eef3988a1c875c2b65ec9e9e21f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7fa349fb5cc5856668dd4332b019d1122c7b2712196fb745dfe38fbb88df48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e91725fa775f1ff3152a79f799bcbaa6f6a1b4ef54cdfe9d4de067fbf32b13b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb34e2cf9c11d43cca9228aab7aecf00ac2ad896e8250fe04fc1d200715a3ea5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56708dac25ba24e72ca5e1839830bd575776a123fb0421bc376588da33c31c18(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef45a1e16942fe658af24d87ffa7f1b6d19960c133097d3f1e2e1e8ecd9d5ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c92b4a71c8ebca3229f569f7a8e961c7c4dfa3a96455f36f48a00d907324ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa780966dad2894b26b2399196475fa3afca2f3bf22c5f09cd5285e38889a580(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2aa5e9ef76e29ec1d0cd30f51ffd7d0f743822a99aee64375081407dd20ab0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60b19a268e7e106774fda300949fd4c9122ff3ef1801967cbf69e1197643c9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00512ba0a46a19752396e2e065cd0e3aa463109606681325fbe0c0ed8856971b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad39a00c0946ac71e33f6b7171fcc0296fea57dca4bfa03d8b58c5c660cd4306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6271efb1dc62e5f7518bc6a65e771e7eed2f6124ba9369e4b98ca3849e8edc02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58e46f31fed228ade6101af08fa907dc120dee00557c18b678178c7577fe014(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1324119b6f0d81b0cb0ee7c940e9326fb794d6fc23bfdf775fdb9efa336b0bbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e34402a52f577b1d9898a77679a79fd0402f0109a2eacd97f28a8c8a98ad0b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2722ca71391ca97c5105f9e1d487bbb764ef902e7bdedc1bd408f6847fe93a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6542953453cf0b3334b02e47be9d3fbb2f918b2b1bd209ecd6f08b2951a54cf(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676810e597d0a07c3aff5f021211ad3f8dfa74bde43440b36df614f108f37ac4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7402dc6d64bdbbbf99b40d327fa37b1589508f4eb3480595c9ada70042244e2c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b6273b67bba11ce0ac68bca5f70c8a986094818988bb68a85dcdee3e5e1d7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15257c96d4495d0fbb581c1cb0c5e3ec7a91ece88ff671396d8a3369b1b40be7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__366be2b40407b74532a607d234a7e98dae417c145ffb8d97414378af71eb0061(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be87272d8a8c14db57b400d5af2e60279d13bc40471f287061e1ac0641c162b0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6753b53917933749623dcb9c2618ccd52d805c71f4909f2e66b76d1fd33c260b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f042d605deba748ba4a16ae70ae1a765f3f4b4ed04da7e356dfa8cc51ce028(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4385a0aed635a93f028648b3a41d2f7062903f5398d6c07076df3dff2666b1b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97b143b876b806ddf91c93688634e352f5ef1bc91ab318c0140b9013bdab90b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0654a1438b07a745b356bc784be6485839d7726027ba615308b871850c392e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c3c612dd7deb90da695cc6fded770391fe5f1e20b5974353b1fd097d262bb0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0584e60245332cf25f2c33c1742b9209aca300153712b29af066325f1e7f947(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afaa3bc084fad8ae7126cb1202765df7e165358e291f988d0d97b0a5db022e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c52e23d09eec8923fd608ef72cb3b54676f0605791bab7983e3a53d0a8dabc50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87833af735620bcf9886db25b73417a2567cb4e73fac16b12ec90f961a7808db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8e5e8577fdb3d94f57e24d0a282ef6c0b422c0b2dec76b547ec8fde964cbb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb777b668cdf3f71ac632c610e73bb5b8a79a3e29b03ea010186258069d8570(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23eb64945e432e0b043ac4124f0ed682f3bf047662caf511b6e7e05dcfa26bf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d020a6bbde77c88741f49f1137a73d0b1649c39d4fdfe18f167e546e521b3b42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72703c488f1891c4f6018e5efcdf0fb334feb4e6addf3b115156830caf0d41c0(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125f3362fd25b3c8301c111507847a1c4d120107b744f693ec29df8033337cc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77eef30bd1cec7c5edcd5cc90d30e0e6e4ed3d8b669175e75c40d03f0bd8158(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cead8ff10a517e9bb8c0eb2a0f543497f6aa9726c2c89cd9b934a8d2f45470b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8b0358b25fa64ebf753ed25b846ea52812f864a18c87a2d8dd5406c52780df(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384c4a87f7fb1859afdbe7a15be26b7ef9c88846821c6e82ece48dac9c0551f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6764722acddae3b22f10f76a2b74abb7fa77a8626d251aec443ebfdd36b7810f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9494a3ae3b9bc2af205f77205df6fe1c181222fdfdd49f8880bfc63a3bcffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333d2c2f4e983be84667cb8531bbde5f63a4027c67889ffafac1714f93312230(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b037734feb0fa2d754ad0b7b7e7d5699b1bee93d24cbebbd3588b5cbaa0456f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06957facfd0873af3cccadaa2700117bc7da2426c054dcda62e489d0fc3ab819(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b15d7a1d1f4774602661b390c5a5cd38a5ef1a7cb4a0cbe172bf201dc3fd2ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599d6b9b22fdbfca32dbbe01717cdbd69ebe13bb51e23f87cf3cf04b54e57fe0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7825d65a31f220102b7e5e8b5812900e3f9ac956297f85a1f295c3071559f166(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccda5fbf558d073dc51febacc26f2f4093afd821bc185e0503ac7ea9872aa01f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf142d92223495085b0e7df80e8759aabdf6424f255c7c164f0c691c87d226de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3756ff5cc67c63b84cdd160ebb303f9907dc7c08dce40eeea5a0fb6630e67f86(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede01f3963b6faf82d6ef40baba8c8c37c245871a1a6aa4a49ac8fcd10419a4f(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d5dfbdad3eb00f19e17edcd7de410059253705f2a58573abe16bef9601f7bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11696605ce4f33f73970b21c17f2221ff122cfb09d8ac0bbfe6256eee4ebe6b1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf06c3fabbe91c8c28610affb70797d8cc4ab9f4c74b89d41e3022ceb2ddeb2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05e96412c495fc400562c2a368a48f5ef6d186c616b033255adf47a9ea8a49f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678c67bc208f38d5a3e763e28356857bb5ca70f56281e9d7e5c77046947497c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b1e6afb64e6f6defaadc58007c5703a4fb0ff4bdd0fab039a80022836164c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54574b591e3725218101923348a480916eb4850efee50c9f7bf1c1c893e8f90f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915c2e9eb28f7a0f1dbb09fc552ac6bcf17affc0571f909c4ebaf590697d9494(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__846f222322ce4094e3bb7b12408aabc59803ba90570097390b24a26126b9e44f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac9b137fb0a55de63506b4a3294c6470d2eb4be27c45d49e94a905c3804f6ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da87048191ac876e11c25158563224befd6502314d419c788593d1cda6cd8162(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db9aa82c508796b9a98a25c1bcb8e6c95e0c40bc646e4c85cf30f0693042504(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09b6d8a00f8d621e3a652869b5c2009eb73d3a9e656bd39a7802165b2818ec9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c827745dc380e13d0657257c3c866bbd0c3a614cad35f2a6cb99e85fab823aeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8e7062bd5fe3ebd1f36467fd68c59b394cf93a093a752440c0d7fdddb98bc8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3bb190fa67975f376b2ffd5c9c4676a0a9f91088fbf6a63f897c42fcbff4df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcbdcc65a948009be3ecf9af7db8c11d0f92f9923a235ce54d278903d77d3137(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793384dc6b90909251e8d0ea87017729d1ab90be92919bf5722786f3980c98c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8caaf8ca0afa3444fcb6bbf4d3a86cb48516adb694578dedfd81576fae82ab0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa13a1d1d83ac3e32a0118bc88ccddad55ecafee7aa3ceb6b6aee65f5fbfc67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef57e0bb2a0c133ba53e35648a1c82efaddeddbf98096ede4e053d423a17433e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1449fd830b8e25fbcab25e140794750cc136b63a92378699b19912552e2de14(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d65eb2280bffd545ed0038036f742534bda5b5697ddd3c27309765428989aa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b0da8d0e1a56148aa1015aba2e484eb9173d578197a3a43f321b7dc2a1e93e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03e1f177301cf526176a103b9ba50ee8d50531084d71312594b6bed65c9a420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dcd3269873e3ed34d997e358b3c019f45f8a6f48698d5d2b464edfcf13465e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0790a1db5faa1116fcf1315dcfdf86ad91b5ea3ae6584bbae1f53f63d539d7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a659b05c880481b42698ff4d77d89f87f2997440f463630df166dce2f2492c4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf010b3157759a6523110f3e613416d0c75381df4a7c8ddc45d940571d8b5112(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4462dd3bedda9c0c2806af0f069fb0072f6bab50f68216bb65f89b4d303f667a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eac925e6140345d6bfafb6060a828edd3635cf332d08cb128b6ce874c38abd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc21f957883933aa93b761cc288d4b5147e08890cb1af8f6689689e9340f541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b2a849940aafc625cd16875aa967ae1c5d5e40c0f3083093d25fbb82980f5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe7e4845c40e313372f429380e43065bb17183648cd21de26fe9fa92a8e8c52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47200544d2643fbefc731ba950f2feb43e9c621840dc9de7cc330d1b177ceed(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7fbf506767c78f11a46314d6881e6beb11c8abfee75263cf788d18b596f321b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6b8f97a7d3434420cb0fb6186f172c0a63d39778f17628083eb55625ee7354(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e381274ec20b2e557b8a25623527ee5a320318b9dfd22c74300e2515663fea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dec2cdbc66f616a9b50414389e121a1b5aebaf421fc65b8c83a81c81b783db9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b1e7a3dced1a9745d67d3b0c592f279a1ec0d7565c7f0ff45dde36f982f6d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6ed49c5de4e63f4c7a8c68aee0a3620669b0509719053c6957e11720970b4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56484e2a6d975edfd14b05c92fb88edb32deb29c6ad8a814c3bf4e35aab329e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca047c2bd65ebe07d3d771bbedb6f2014aba0ac354428d855eff113a5f544e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9f1ce276314b340c0dc935d2fb05bce48d5ee82de43b42b25293d6168676d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e782184a3c1c9f6aa1a211860c04e23606f3ffec24f6872f02c0181c97dec930(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60ca4d7c08195bdefd5be810c436c0329ba2b51e40ddff790cdadf7b82b3e3a(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec1b2a36b7097d4ef4b3d791260dae0c3d858c5a6ca90b350dffe959d592ae6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86a85e8f094b4164e5848523ea04127fb42479564bc0a1e96482760768d9818(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9994a6846e5373354161b26353fb08e26291f20f3e42f9621b60205945439dd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2bdc0e22b8f1ea543f68ab36e7d210752f36351b980d6bde8efe9c49ca50d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f2332a95cbd2210a6542a52ac2226925f5e0472d95e56cf85880e973eecfd8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a66b39d8d6a74e6d0f3ceb7de92e0957dba37c499ff5ee63e126aaae8fa3734(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2375b99458bccbe5e158e0e00635e6a9195add4e2e4fc0904666ec276794c5dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b49e1e808a7afa1a9faa794ac839635e8e1c845329159fc33f7f1bca680250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108bf2b13bb23543b4f4e02c7f925973dcf1677655809786638c6ad1525739cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c65955fb34e2933be1dd770ee28cfebc7b52a84d04839d74f8f939e92ff2839(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d874f8ddc8b5137be93313b4878abb6a0ef5ebab9f0d77fb66f098f41f2eff5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a2cd4bc0ffd48857cd7b9c7d5071222ce398e88b3a37fc21f5e76139aee4b9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3ad5a1dcab4377c9fc182fc45d6d7d9381df9c980cb19deed104e36909e2b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aacb542c93b7a723e092d58e648c291913a07ec2e52dc3f23003c1a7e6ce17a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9beb37ada74a95d53a04f9f0010cae12c5b80d8c266cb78c1ab6a24e5f3332(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19997a9ef9c1a2e123725ae52ed475ba6e161c88bcc9299cdb03a5b6d81b29ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413f2057bdcb1b1269c2cbd83c136156352e2240f7dbe5bced5f24b7917918c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8088a82caffdf9f68b8a1c4b71beffacb26f11783c59948d5cd87892209ad371(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a2ebeaec725a9dbe6e3a28814c28ed034f6b8ced08f420e9958fc1101bf44c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8fd570a7b913fd73b7248b8f6c97eb764a3148f1bf6c6b596c1b24c730c49de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6311fee09858beb4897d3846281b3e452672f7eefc7bdaefd4256b9d67f48c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef26b088c38b8fc523a5138f415d0623ca0a818342a72a06d799338f41f471f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32afda9aed8663c21fcdbedaddbea87f0d5c37bcd78f5f34c24a16e68b3577f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb61b3f12fc8e91a4c705df7aaad5f827f18f9b9a0f0ea8dbced69e362a249ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a103a81cf3e4b655f5b8ff5fa55f3880d5b9bd878157afc34e4d4159c9a863a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__395821951dd177bb2455fc296c9de8b3e689bd06c4336689836aa3dcc89edf3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2564671534d2a2c12b13342c38f2fdb6a71745a40687c2044d8964a574af160(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688fb7783d4d5bed468791db9971691b3b9194790e04d0b9ba0489aa6d6d94b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944e94cddddbe3bdb37132e39fd7573b0c92669d405b7dfbbad9f4570d14c082(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd02b3104b967e057d9e3a7e60e4d4fefe153ab6b7d9eed6a5a72960be3d3e23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b0211971cf682bf6a70f54ced0f35429e6af869f12caf4b806c457b2b1a99f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810192d9f33cf538da6030dd1bb8820e456da8609ab0dc6c110bfc785a744165(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee0bafaba45b21e72bb39c7adc7216eec8381d12390c8f2b948bc6474936a2f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb366017964067437e979635fc2867456525267b6ce6fe2f9d50798257cce44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e03e8a382b7b40b8d5410e3a8c8dabb99c3cac3dd8980e273c7f08b4f7f30d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e49700f5ada4ee6fe43afff8b0c0cc7ef6d99cc1ae48c1f9c3531b698cb3cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0457a180f277365cc901501e5615872009c54b746660a1bc1c7ac0edf0e58d1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a06aa3fa88008d314a59730a22e8f779e719c9c68f505f6fa20180b8c24c825(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76f2be15ade453c729e1ffa414296a164ecf9fc4f6d0970c8ecea3dab9ca2b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c6ac6625f8fb5f572d0240034a915af842a2064ff8a4c0e6b49abbd1da4c98(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a819066b656298f114a2ee2ab46fcfa977b72b28eab1f0771cae026deec7e740(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a383cbd16229475148d1a8f5dc0fd183ea38be1db6b9fdd7288d9fbe34832f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fdbf969cba5675ca0c8c3b0ba6b89df73e6340a56c9384ae7f6b91eaafb83b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d291ed7a78e7333ab84c6d6d1187839c31fb0bd0c55f6a2d027a720232c0c17a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19b313729c7106fb62fccf0de4c989bcd8c99bb75f904559eab2f1048148e49(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e439214769976fda73953f3301dcea3d3765412a0ef7666f45fad2c0bcb4ff1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f21aa0a482bf490f14db1938aca4f24969589145cfe20ca1d54e87243bb6ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e8b0add0acbf5c332fe70a8d378a6797b55a062a99be700606a973e9e28b0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc58340484251ee9f8211158d8ffa648b43465eda5944c2b779fe319b6ee31c2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0fcc7b5ce0d872a060bcb96df82f64d3f4ba991234637a5a8207d059e791b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac1bfbc7819bbbe40028ed6a27b1d06c22e95c14a26ff6080343df12d84e991(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03eb19a972a14091bbf9853d09fcb2be188efff7aab7bbe389f553cc4f4d51d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e9611877300bb8f03bf368f0cb7ed4a8bab633d4d9a71cbff3cc9f5d2544e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aba9df3cb96b2e6acdeced9c15996407c2baafcb837267a67e6b353b76fa47b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37d95169a7a16fa5de9cdc41d09be70f7137df9f11d79926834f89e80585fcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8459071a5c5d39cecd4503520a179f692b23195c3ca2217c8f16b05f1387e139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed4338a5c0f3bf70f598d09e2637451db461121e1faa3af499cb93868e0d891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b46cb60528de43c7383c9dba466b441781118b655460e97b2fa2d95068bf6ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e66b909a0a17d72e75b67bc422f830bbcfc3dcbb1f1c07857a980550d5234b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__951ce39c25e5a89ca0939befde515abdf08ef24d3cc999d7b8cde934e0fb619f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c348d36f558845cea28736dc547626ced178335fb3d8ae28f6f5f372826051(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876c9f45e3759808012eb611a38b6c89b51f6321f92a88e048a1697ac80da105(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dae68ece16834a0cd32e1f31ea2f26d21a78fb7fcd82db3e96fc7242e689a93(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b48e9f91026bd50dd7e12f9f3b29c3b4da420ccd7126e8514760564b0007c7(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424b4a172385b6cdd57c87b549ca237687f23784f198d56529ebec9c32152e29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b38365b17c6ae883fb64dd5c62b19d77c9c1db8dffcfb522f9bc3267438892(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93e309305f9944756b245042592a88cf53909cc6d74814d6181ceca5026d250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89b5570f582fa7cb098f3bdd51241f57f4ecba925d31afdfd651bde6fff0832(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e89234d9040c0a8958967686dcac1ce9f8b0e5b12e3ef1d887cae23d8f4da9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ba78c65a87043adac01c8b59cf76bdddbbaaf798f3a2da0a5350c2e3fd61ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7889a26a129ee2a400f28febacdc773124c04e2d9276a452e47608effec98d03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3bf31a1e10786460b4ae882054edd49d89db5d3141fa8c06b7ec95df1fb5620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813b18776886e12aaf59609e140a7c2881c5c0afda42e103961ddd610691d1f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4e1e85a70e1834c490c1104b3e693b497bcf9e3c87a9919c78efaee2a05336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847dd962926f25bed1afb9d8a44fb25353aa2e6fc2e726aef9be4e8a76b5eee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9a23b62497d1ccaecce09f75bb6ec10b7a7a0069d197d9b4033c8700bed1cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30425674e8efe1ad5da496ec0e87ed20bf4c61c6346eaa80a5ab0da223debb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e559759ad07a86d604977eb0d74ced3ea11b4655aa90788a3ddb1c65091a100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e5da182ac56c596f0f338dc83139f0006f6b9b81c61aa34eb5b5c0e6e29c44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9353deecc3c58c84c5734eaf06ecec0080133c3433b776ef2a23f44ba335694(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b16b64339d1fdddc4ce4947b9d8c361758ebddaa24b0f60a76e0949fa2604de(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec0ebd337e7c2ca8d917f3792a241e5117e99e14b9367d0156ecc7bf4369c7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6457614579da312b1ba8494e50289642c456617d81361aa7d35ecab181980e98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d9f85875bece3b8559bbc4e71f62eb6ea5d22b991b1acd75ded2409632dcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f74c95e2b3f376c1f82f374eff87600247daf6ebbcb943d2a5a648ae74b99da(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4280755a6d85b6aded7050e3b5d0e5199f99eaa1a02b6c6f451e771a139ea11(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340a27fdd9ff74cf1e4a85aa48e5585f18243b10897683f0684571fc570cbe58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1bc000d3560ff0367cf40f063796647390c436653ea3d11a4bb151958a5fc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ad6403b18d1c33d15ed35e121f42191c406d123dea76309434457e95e01c16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4064e6572665f124aa33e560b42714c7826903ee5224b1d8f23291c0fb5a117(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60698623c1dffd3ec50fea41a5fea6f1678c73e8647f7064dda7bacd5669a4dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96febee67471235adf6d1181310df424c11af0a560f4e6c6d971f30e340c578b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc74ca015c1e35fa2427b18a23f72e698f9028e6e7f5f5d7249ce16eb1171bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c1572c1a9a74711c3ab2a31ac33aa59540c5d673c0b53db4e2f673138c6ce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a276b3ece32a0f78eee548bff469bc74af9cc26ec24927b23fbf9b5e3a5334(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d371afc26fdc80a23f4ba7993b15cb21449c6ac246a5e9c92e90da8463eefae6(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45c39da2689f3e80fc6e408f4725e84b0f91deef6d0782b17808e0f95c48d66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c30a3ac397534d746b3f9f9739cbabf23ae114e5e7b10bee7abf25eb82e49ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724d27ded03c8e6681f38f17695f0d4b737b9dce76f0c6dfad9ea6ec47216cb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2e5bb43dc1c8b23615f6d7b690df8b4cd9cccb4da0ea0ae3bef257dfe53a6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c4740c37940df1fcd930d62094c1cfde7c44527a825ed104f5fe6e5315fdf4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032b2b20140d79f55ac24eae24fb306813ed66771b4dd322717e7ea3e02ca10a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5491392ca859e16f0b2db95968706a5c3c7c79f2d274323e501b3cb2f1960bac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f01162e672ebf51c1b576ed5fffe864b7fa24e8cbff3014d0daafeaa2c5290(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404598c9ca3ff207effbe79f04cda28e1557a5016f33cb0eef2c2643efa92c06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9285966f43277a1c3e1287ab788ecd702790c4d7b8e4e3c9532749f878737f63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e3a21fdef6324196ae4b2fae397eecaa20dc02713c34621bbf6651814c5fbec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d98a65d224f499457302c6058464ad5a7145795513c765b13ad4f9a84382f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070277b4469eabebfa4a55f425056875b60cd6578ba2d27589780a1aeba7e4be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f431bd450c75cf7c36ea016f45d4d97c91422d408107e6e29bab9f09bf5cc311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f93f6120da5231ae64363fe1d2feda250f726e0031d6dc0756d7274b8757dac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e4aee2f85d7ff0196b42dc8e524ed5e5a68b77cc0dacdb490b08c8f73a45d64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d6c58b243c15cce5a80d048af5b74f627aa81856cfd75c4ae286fabcc7a5d1(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b520fd95dec2af9b11fb435a2abf9ca4ed6a5ff3c89346be24e9b5f2e8ed717(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4caf7cb8055a4d31ec4c17338eb56194f51b7d790bc3e5b0ca2297581662262b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599e36e52528e549f1de322a4b05f5c037bcc6b10360cf52f063aae59d972f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876220f8ee4911ae2b5fc8a5ae2bb12e2734f6cbc41fd3ecd89f59848507f62f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833fcd30a8f2675016395d7581e4e9fb2f4b368fde444abe58f939ebbc181cf2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab02928c32adc3f2b96d9674b45d1454c3dab6163e0d159968395563a1e7e6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb9ea3ed019d844652b433f1e3e365f49c2ae8bee8cc15686c800e45c247a4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf91d585add5bc143576715a922165368918be7bb3c5fc2447216965f583c6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea889c3fa336863c074f39860bd7717d984318ec0daf4cd3a7a3ae3ddcdf1bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d50e1f1aeb52363732dadb5c3cee3542e3c65baed28a3b8eaf84596d77e635(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db525cf1ab92653bb9b406f75ac9b09224edfa174a562b3602ead5621a77d17f(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32683bfd1e5b4f3ec4530672a095c713d532b382bebfd55fe14182b2ce5fd12d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28cddaefadb14e77bc3fece8f73c6bebac0da060e637c7f1e133c92cb1a56ec8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887f345d1a6c1676fff305fba5ff2455c96902b99b9e75cdd25025426f5b788d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d7c9679f7e31b32ba74c4727c5761f2e5dde957436cfc32ceb8a2c664bf267c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ffe0b733c27b28e4fc4aa157e2a9bb0f26a2e58be0338bc0e74b036dfc91afa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20fe6133ad5a73479c0e406bdc573f717999799d5fc538086a624c12f179bfd2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30bfdda5677ff042531b8d76e875f3977cb8785210303118f1f787f42a8530a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888b12349a37a447b4ba151c2fbaa2ab0e2bcb6444fc465b2208aa932be52360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6ef5491b24f8cee405033f94084025fdf5ddb2a434b3168c91ad27623f3452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__433fc6aa165f4064c50a65af5728f396e79879f62a917464c25b42a746fbcaab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a237e0521b7d35a631038870a4ac2a8fe90aa82d949493a31e78e02bfe3c0dbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3faef926b5f4203d03fa4ccf7247aff2792593fd92678958ef111a1a58fc60c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6646f32a74ad11e390df8d6f792eefe5d43190e1af555f702dbcba6de9e600b3(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f421c61ad23e9802c81db80234d9ae6541473d0472e89c7244c3f73ceb618b42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c6bd955730dbbea8dbc6702fb77ee4a15778d05341c785e5d47d3b2aab0d02(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd11af24aa45cfc6240e449ed8cb480e2baef9470bd1643eadcb1a923365002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff69df0d609ca342d818f97a745fdcd22a13f2cb45fd0cf0fea22183012f0785(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9987dc3b86d64028bb4e14ca774537a28edf5fb6f389ddabec9b4677e8fac99c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c6c5ada54c7229835fe312b5a61767faa171cee3914c5ac1ae7e203c85b2eac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8f76d000ac21d6751106b547069e641f44cb2e998ad4695f62c1f92b06d617(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43219a8b83b893bb4b1d26f331c5ef3bdff459b1d3b69f68a20dd5613a5e459c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581c303a63ca72b17b734eb52c438d5437a4f05b5b7673bc28d820df5abae11b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e27edea8adc5c3ed828b303c75af9bc9a86fef7ff44c841e5a4dbeca16c562c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91580b17e73716eb5a233defc7d508ffd0a57a08b99eaad86bdc516600eb079a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3dfaf0ca6addd5d4a60c65f3d51690fe042ccf047a98d63f44a421122ddaa5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487d2506244a38abb9be0703218899f8baad950bb51e2c5200d66de4339da30a(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0301e15f6155cc1cbf52241a27314cfc8dfdd175fbf6795dabd99691d41df6ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c8a1e4833ba35437c93b7ac722abf0f861a7bc7e9c7c654434173a9f6846b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550c3962d70fc3a2ef098e9267e5731111079483dfe7a9cd1316558edd57082f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f039c55be0853fa4fdb95df9591a625da0969353dc199d2a1718002989c8b2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f64a9566d685a33dc79704e6b13ec2647833db3115bd5d3140cef19731fe63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d0f9622c942f32c0c56ce2eee3c1623fee608f04cf858b7dc29cacb6642e42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd8fbc5dfac450008adc5a84905c9266de7dbf864e9844d93baea460084a9ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f010a27d95e2fcf4be1a96eb0775a045ba301bed5ad18bb2b37f122ca2c6ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65d4f90a6fb5c651e2e582aef96580aeb033bb5ea03f9427cd9bbf99a78b251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a30e7521a4d7caf1f8205c96de304a0a1ea25b197eb5522e23036bcdb7bdb95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fccdfc078ecd766bd7dc326140d6c0e3736ed2b70bcfb5bae094cd0bacf00324(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7531010d1c32b72b21e9ccee4451e045f2ac05a6e142f5d46e45c5292280a17(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94047b6fd5332a6be91069a48f74475dd1e5c8f3eb4b489ba8d1a8e8f8ed62ec(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912ebd51e05a33fa4d34946ebd4578334d0a91ae013ca6018845d602450be5be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de9a660cb1e0d2ef522eb33b97851ab3c546d39244efdc569a58d08b40a4d8f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529196f05959a93373321c60ac1f9d73b6ef386180f18096cbfc51ce4c689209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05048b59c87bb522ff3828fa2460854d79dd75d1e9a088f09ef32dd1e8cd842(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb9bdb2c2bf065cc30c307163236bbcecce07c8ac60f497e0ab8334936d9bdb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251fee15e4f2120da2b2ed39eda0f31792a4a8c27e329bdbcf4d9d3231b93915(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68353786b7006f42bf8d6f086761762504434f47a52d1e8524017438e44fc248(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b373e2160580bd200c27503068be69357667c41a581864a905285fd0b416c6b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1619d815618255e9649538b65f585ed10acb827ef335cb5b74b8f04acbddc5a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f846201ba4d621033747b74999577b4e46470c5fc8141c886d9c5985afc37a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2c53e2b07d3848dd3baed6d676712aba65d146b65c8209abc5b6e8ae415a9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4baf0706174fe96c20231ae581745697e18a780c8b3ca0ef2c810b4c94309d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff1a667366cf1fcbd75f06d3a2eacb7558d5a8a81a4fff2aa285f73eaa2c451c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800cada0d6952754a7f779d0c89c6b9e3a3518d77d4f053498435dcc84857b6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db55b7dc2f7f4335ba250bb27749526513b9145aafc7f15c749c4733f74db324(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54df2cab5ef352a1d48ab13a7b5e708f0d3939ec96d063dc91b5dcefb944c560(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2a9110d522c4db4d5e39186f2804cf6b32bf8e06b5f55374eeb6888b659e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e047e868010723cacf5d69f1f731e0d38cc83e340a832ffdbdf1bfedf1f78de(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422e27f74a2b96cc2cbd00705535269d606ecea3c16df61e1b698d3a7d0a3c42(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bee49c387a5e5ed2ab6cb6c952d1d4a7c5a035850ad427172b22f8190b5efea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4bda6a7d6a34a01f08275169cf882cdec1bde00f4f29a3bbc32b6bfdf5f88a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d899e267dd0f288522914558d857ecef750dcb68704275d5165b4f35fa2c7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd96070ffc5e5977c32500b45ff9e2de2f4c535e86abb3a8453755f0d978193(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825eaee6572291b4ce45d272e39e64f8ecf3606af9c9842311f5996730076da1(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c3ed2c0b9da7b5bcdb0d0c9719cd7504d5f5464481919aba99a77ed5ac3f6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6e43e312b2ca9075a6e2d3b6a284615a8b06c972aab655ed9c52b4a01a1c78(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6d5f54caacd5f6215bba93b9ef37e9791c97753a10cdd6c26b50fa246b125b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fdcc832b8b5d78299c90d081d83ec5f577fd4954aa9fb80720fc9c9ebe73732(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f7faaa53d413f9749d79e123861b6976564033bab6a62d7df4f0af11d4e5fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60029ee096a16b9f620d73ab077af2a1a43682ce72a1a03f9d4f80104668112e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b19b60598311d8554dd3c8bee502b08a9ea38c282b510172373f8ea18e9f6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64a02068133855bb049ff31569a4aeb9f806677c94b6f14ea4698990296d20e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5d73e2aa178b3559e6b33c13bf7076b38825c3dc47edfbc9eecc48e9a1962d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3dfdeca13ea3ac80d79897bcfc6dd44b1440d37bd05f50862571456c67dba67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95ee0e5145ce088caaa8e7aed2b8f5e02be33dafa18dad9f36b10ea5d994e48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89259be9764446d3478325e0858a0a25825c3056d3c5245daf220a5b1318c68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c435920e61fa159021f61e80fe19f6ad4ade36f6ef14ed81ad1061701f6c687(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16243a9fb0f62ec59de488078e439bd259c66beed61118f8044d162ef4dfced5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32813c8fe32a1812fb15ea15684351252ca0924f851d7c21b3dcd2ff9481218b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85a566bc11dab92ba859b60c43e3a193831806098773184e6ad50e7f59e94d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af3a6f3ae3970099031da1facf7a8dcf9ccfda7f35f6656d520e52faef1a43f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04a59f20560339fd407425613dc970c85969ca59e06d97d3ff6eb9c299e0486(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4230cdbc8b6b820bbbceb3ac89faeeab4c9d353667cddc90098f6b06e6725133(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf2d3607cf0be94f993e2c247575a16abf316838f536c923e9aa950ffbfeb50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120ef0736e5df187b950ab259b23050654f45dc5240696c3060b534ca7d55937(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffd30c3d80c5554d02c961d82313107759481d0d8c6ade31ba7cd1e4219d45f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4687052f3b3fdd35ea5c338fc6d5e6c84f36837dab0230f3b3e3fe5d78e3bb7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3d6fb7623006f4b5a833c018ae3e2da71bdfc135fa8b3298da77e5d4ed3c10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67dc74ea8db878b69b33f2afbd15f42834bbc459b480c0e52a49f9e8e98de8f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04e2ce8c4734fc78a54de451f549762cc042f441d9ba665d8596f6fc81a4554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71b6aa9b83d468c766c32b944d5f51e7fe85d394ed6390b7fa1e03a4fc1a9b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842d0c2cfa15b6dcb07edeaa25f063d06f980ac1a73b132a15b8304579cceb0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b605e3593cd3d3837799c695f5ed574c739b2fc0eb18ff315f2d7a0421f1122c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce497f84c9018e1be04452659eb9c5c8c2d20a0f8364da3bd9a6105ee692545c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571d840ba993b9e6eda6246d354d063a0ef5f2408bf7da2a73741761b490f117(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ff1e63d31b60adf50780ca479972298e07b6d99731c0781d502a42bb60db54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d37bac45f8ce0f9869c5b80ec27fa2af6f501230b0b48561c8e5acb70dacac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81b2b50c973d2be3e61c3f1040e3bcbbeb2ecf6b7515fb0f3d3c0da9a2e6b32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5797761bcf18047f97fb06ee668a6d99d86e78130d7daa9814e65f9df935dee1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837659faede5e441d0c61f53198b259caf954e955dc1acfdebec370c4ec1c67b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0489f23188e806fbcece0bb23d33a7ca71d9b75a69c25c9be49408004b322af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a10d8b7dc918edd00198a775e5dc55a5e6491094da6919be72308cd6ea6ebf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd35ff8725dc30884969232b628d563ee223047d8a7c24ddb466172876ad24e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f341f01ce622a0ad081add998b56633cb41c30404d45625bdeca314f6e3f8b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9759698a7ce0ba2f2d4ddd682a8dfab9e82826e40d8059f2053fc36c7ea9daf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbfcd33091a58740e35d6da8a56eb3f7520990694eeb45c41bf991f659bc8f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6244d5858eabb89357b3f074074a428d20eb89729c09c52d21f4a2bf64d645f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36542cb654a6edad32433402ef62cc8836045f5f989f5e06c5b93f77d7eefb61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfa43d9e1ad8ee9b18ea6d1ef849863b0ca496aa49c64f30e69d80a75d00e31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bd726d6547c56977aed2fea4405d6fd4babaa199279a030673d23d2157f647(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd68fa517539bcc2b39fd87ca6d128200d57e36898cf109635b98fabcf57f908(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4398d4cd232bbe87a0569ef50a8e91ceb84f5e09ae0645eb3880caa829894c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836c6f6943925096c1beb1a308357e213e24721a14dd442c3ebe169813a702f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b65c117a3cef807d6d96a356686f253e74f260d7cdaa5cbba3df35c0d45bc90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9eb7803645b8c776927709df01f6e4332567d22896db7ec31453df31922066d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657755acf55a80f651e6ebda64f89f2e430e888964bed10d3ee9dad0fd9de71d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7abb73457dbe157ba60497c60800c314025dbd521ced10507529904ae6b73b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb99e1a985873183a546a98cd4bdce1be3bf1cefbe7992b077c34507d092ef7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a5c5de53b30770f5a8d8c448d5be8921a3ed89c76442114ee3705d4d9e76ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad0ea89ed8f86126be6a111a51021c415b6c3fa98a33d8c25067f2f853c4270(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ea9f2984a6fc3b685653d9310a46339dc2f4d8765d0be3f2b02a302b18ba3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17be235def210e8e7c3f2f4b9c4d28191ea97a06eb74293531d32df8083c99d6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d6ca985dbb92df7ff16c9f6d28a33917ec236ed760ba11c0c1548757ae3686(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d23ceb69333f136c83ce56567d33e9982620b97b185bc1bdceeb787859c73b9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90bb405944e411eabfce00e18dee9eeaf9cbb1596aa248163615b400d0a69a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d4affad6fa0e83a95fef89f55131da102659a1de53b9fed4cf48e1b07a299e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ee185c91fb36f5eb2df7f62d7eaffe4588fbe7ff07c8500f701af0a0ad585c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7855b810d5814e7d6dfd1ba54c36a2c5652361799ddeacb3820a4ec5c75d0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4171738427823f26b0a5cf769b1b49b10be3c82cc22662c6260dbabc630b072(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1c8cdeb2ab57982bcc58f9aadac36b8c1046c7d542b12228c91eb8b78c87b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65363e9feb6a2dc7d712b106298da2c909abe51cd26e1f835cdb3a3e70045c4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__237a72c35db7b9e445cffd8ad09c489db4abcc87a5e383ed1cfceec5f94304cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dba8c2f151b78065e64bc0eac056c976979ef9edb32bec3464228c2ed3610e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f18725bc494c12b11702f006d06055ce9688323f7c5d5091126deb585cef9ecd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e2989370e881519341b92cf512c17bbbc4049d7d97ff1dbfbfc5ee771a6aba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f443846e102e289acddd7d464591ec44fd91ad0a6ee54ffdc63db43cb758a7ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaab71d2e2083cd8c384b98a980009e4bbb9204dd7534c7273b9e0d8e26fc538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80086c0fa05b40361e7202f802a1672314db71a999e5ff2380e61cb48b9a17cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2513d04ad6dc3760454b16727430bebcf5a9818dca109cb75eae9387cd954783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3635181dcaa0d4596c020cf2944885be3a366db579302c86968c190f8e596254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d86b5dcb88e2bb0f3442098797355d5400a9637e68ee673a912b16ec5e00f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b716c6144ade0f44ac19fa2ae9049683b46bd5782f7dff44ba1247bd3fe58c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d2073eaca9b1a4270a4de495704ecd0d8c6d8614d0248d19ac98b40cfb8676(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0cf62105e4a85fc3f70bd72141b024cd4f584ce0ab459de4b7fae1ddd12003(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd960c6b3be2fe66729fbc379f09cce635e9ff50001dc10ee2d6521df8699256(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9875a56c18dfa4dc74d8f8e437123c493c52be2186c1c4c3f200257532997a38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aade5c77fc798155da4f2ae1b03faa8f599a3a4530953f18acd216768abbf09(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b8d25ea222b8691d5a633cda2d54b42036dfcd7a3bd83b45368c5fd90d7b612(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6679a4cd4f25cc17edeece872d9bde1a7abdd296dcb92a7965237a242bb1c729(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b65a58ca08075b96fe3d4681cb0a4e94b82adbe2520efc341a2604e1ebfdd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8006f696b75f46f5d27c2d2050e6f58ad876fc6be8a3f6a1c0730b8585d5243e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a86b950de3281cd8b655dfa6d0bb89edee7b3bb0f477621d334d21eca04e215(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733624ee221ebf6a61b31faba5b232e6e7943ad42c1901ee1fe7da847f8d5258(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4ca2f2fdbd24653894050217f3b026de453080a63d425c83e5e5c19e84139a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1f4ff5dcd431bf45ea0a71e7056fd3cb833500bdac23053e09f60c2854430a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001d5b5ed054fe661e593ad8c8775a7aab644b79bc58563523ab502d60f730bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec3cbff131c6ae200ed795e63d0317b2cf74a3384b9b83f474872373b573a8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eaabf1caebb9352cc89ed8ed253631c8da883c243d1fce808d46e963fa7e67a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937ebad510ceee549902dc5fd8ba2fbb4895ef88eceff4eeba6d9ec5c121bab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44dbe0fcaef8f58c648bc5ad6cc7d4bc81337635c64909cf3e180a160ae0036(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a92100a96f7df36af8d6e64b124707612713cb1e4d0c0453b0e4c0cba9214fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b20d55568b6f577a2a377d9fff1fdf2d6d55a3f087ec96822f18ccb124d2d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f196489b53cbd98027b62cba7956878b5f70868f3045f11224a87c1e669f6b67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64463cf43c242600697637b21e08ae94d6e794f7a5926fe85c97af2b68d8e49d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6bce3d9232f535ce18be189578969d13119ed10cecddb1dcb3f518dfbcd9a8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67747306b59fb017f891b59bf8ba78faae3eb4bfbeed6ba2f6d2bc5b462978e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601b637b6ea63f62b4dcdd262d7b39f826a36d62938966f679e98af8292c4f16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6ed90d96966e669eea9c879d77152b002861f7a54254eeaf049ec71d024fdb(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6063ad23f19baddb6453d05051fb35ce8627c20faf96539000325a69dac85ded(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad01334ad3b674a01d2c483166b7943622969216f7ed2c55c3b7eecfc6db3b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4b8ff2d74eb3f5535ff63a24ee05f32d0d3acc9e394319a7df132a901106fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581599e1d4471e9000055fc43b59f2aaaaf6bd8fe16a644fa218a116c9241d21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1762f429615700482df2eb191ec2e473c0da90b25e338bdda17c724e1d77eea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4beb47f87fc288014c3da11ed3865c3f2b5f9810e7cf06b4b598d373e55aa6f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3b51938ec0cab57f21088f1ded25486f8a82a60f9e16e09f52137ca545f891(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a6b43881dab68eefefe96a627a5bef1aaf662ac8df7214cdc3228c6045b823(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a7dcc8dad0b118e8b8628821ac092ab35342fb6442978630c26b960e3762fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd2b936d2578a64fd9239a491e2710ca15dc95b1dd0049a9446874a1a2e5cda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50adf53b3f2b19b96d18b3f597a777d2f63fda3131d7d9730685acd14551d6b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce5f0b9421759afa5aa14246fc1c49891236cc9c8cd46002c8fa51f370caf14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae312c5d98c1a43f9b0729958dadef74e6533730e374dc3be61f70d3174fffe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__461caae6d771a0740014fbc41e1638169b96d1997893165ea05c4d9365ce736f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d174d3f4d34811dace28271217dd90f58ef882ede0448ba4006dd638f393f3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c2b2a74fb9c178884f3279684321368277ccf84215ba75ecc2a22fc1654fd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ec433d63058fb13ca8fcb667432308520e67738b4d9a60153f906b61c96c77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc7b469aee2d27e82cf8359fd927eb01245078a7cbfc19e4de51c4cf1c454c2(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c3ac2d0e5857349e1ce1296f94c138f8a219c52f4e19b1e6dedb6bf045efde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5c286255caa75509ebf459e02f6244544e5459b3f4c630c3d80bfa584c576c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed69b21356620b6fee94c4b24cdee8e8026d9366b27f110167559ce5da48d972(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa09637fc1133c0b943a53de0d8e8cdf0fc04042280481af51895fc87097384(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b5d004c29b631b634a793ceb84db81ffc305c524069edbcb1040806e7baab0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a646d39a992b13ff9ae3ec69121e60d9d9c6be50892a28bf07e00335d205d4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7159b61c2ce64a5a65e55ad9745a3eebd332c56d8be47ddb9d7ef8622a13fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034fae1779caa75c4d6710532b7b16e25765e82c48769a2bb9f48de47de93cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e717ffb2d5b6ca12794b86d2b40b644bb8d7a1ebbc51576839863a26eaeda7b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6dfdab6a5d9035cec4913306af2027117683f8bbb87a4ebee8367f3b5405266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578cf866c77945900c867f78ad4ed48709e9eb151ba153bbe149c62221ed1593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf67115c5831580db58ea54e9b9122f2c0ece4376bfb50565be4500249a4020(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0c5c2bf1b74c5101ab7b77ebfc366e1b222e9f827862ad2f7850391b8a98f0(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58101533c9db65adf1d816ec72675b1d5c9324d61413fe66850ef08beeb3ce77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4732c5e645227b2d0f30d7f05396bce972a8d526bf102cbc14ee7f74c8c49c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5935cd51a55b2924573856499f490af7e52ae21b179d541ed791e56ebe724709(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab8e94c50305ffe9cc6757fd28b330cdc98f89fe6d5192c4f61accc877df1ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10332e0daa6b2d2ff921dbae49fa6958af8f79ed9b7d685838819008bb761295(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2e11b61c299d516f4589d81f2f1eac8767143c3ad9c78cc4facb0cb088dd98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2e908bbbcca12d7914f790e65b2a6c82ccab066f86e25e450e225e5aecf518(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d7b838fa421e5fa6b1938d5e7042c830ecb39dda35f6953eb8d4446e770c642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5776c36893fe981414ae65b9c36700fefcab451148c2cbce01aa135015cd7493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f97c962e297d4da6ff76a950819b28d552d3e430debb6322ebb970c6de4791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b7604b3e81b0fa053387a2647a44f837fd705333c33f7129416b6ac7384af5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00beb7be6c5fe92c2d7683426ccd1f83f00683e9a305fc0d549ee644bab2632(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06466c1317ea8cca2a8a8ae774c50e564ba7113f34f10762aaa37a4a3ec56f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa85c3c4d238dc6c1073bcade5c83ec703b34592212981e3302e8586941a88c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0ebf72dce0b92d79cb044a971223c6c230fe57b0e4487b054fe84f14622c0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b35c30276ca41611de662f7f5a3dc0b090ebb22ae07e17991ec51fe7bd90de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5778832ead3625b8a43179920242c909c5214d39147fc0c0b496d53347cf5d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958c643c06a4869c3cee009199846b1e3ec2a6df04034280aaf2b09c0b3eb560(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99ee2035cfe20aa683bc8351bcc811e1d74abb93e02cf73de4b3ef7d90e1513(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab6b99a210163c80eda3eb605e976202780f1020f03cb1ffcf9618f9b1b0286(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1213584f83a5a2d58a4ca5d8a2f51482e9802c38898382ea2ba06f39a6b616a2(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5c48299b60e20325767f2a775884eda6e9333f626b60eaa9f8146c600cdbf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e17b56c43e72113b9dfc3aec07116ef90ba93a96d7aad40d5481a774cc80acc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e4e764cc583c654c4f4cb1a74599ebe0b3319a65a43ff3d8fbb83f90d9b076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675c6aec71c21da7b7958949826551e251cc0cff16b3e132d07ab3b93473bad9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d11c3b26f94bb7ea52023e8a079959e82e67237e72bfa6cf46b67eaecc349a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2122dd5f0625c39abfbab7131444025c997ac72e863175cb847f2263d8d7d66c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc330a8e2729949a7a2576e4ae4a883b065b2af43975aad293116b5d26d40f5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f03ac16fe549f34edfce768bfb5926081294e7e1a41459a2b3ce90cad1610c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a56ebf1e88a613a82bdb144cc9c3b11128340ac05022f751342b87f02b2bd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a202159f6390aeb772f5adbf1e6ee66de6ca1eba159fea9e4646493465b76f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843302a2411824dc8183ec7b9c81647d583eb6a9fecfba198cfb6a98622a3222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afef5b60f2c6f6d0b16d2d1eebbc912cb1849201ac512c5e207c4344fca5427b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74cbe153dabdf110b8b0a29cb34a444a0cfc15436a75c39d41b0b3541298a180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b008e53dddc1e3f1b42adcd5594901ab1b88fe49d91c54614df9305ccb078ca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88670fc1bfb9f9fffe0c592545a54e7c014fc34e54a00441311e76f9fbdbb48b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ae9f79a1fb64d6223218494b407a3b27543be7424c2b7804cb4e10cbcfaeb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ae719bb3fc2daa4ebf9442a9c111b9186f80d398fbaa93b628c322bbbc5c36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c28ff79c24462ad766cbf7f80f8fe1bc15d212d02c2a134043ba1cc960e62e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be76f1e0b06090d3396fa37319999c5f906aa91fde35f3794f1512c72c676c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3236e5d62e560015b9c23f3ec80f292fbf6c70bc780e2582fa534327161c6c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d25530598c99bf42207d8c3c905a79e285aa9e36f9de3e49ee394e0d787623(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9eb1398e5ca5fa45bd3a302a6f352fd2bc9e6f7c2306273fff1325b00890a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7653362a56aefd47ab28cd24fb6880bba14c68019d2b34a0ba3fc68a1333e76c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db72e8b2d06755eb4816fd3f377e3b5a0cf8ffc9f79c60b087fdcb3c704cd50f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc4a4a367d5e25342a0471fb07f11abd7f6c1c87d34bc61b8a30b70b96b7031(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2f3b550c70d115e949be96469839400aa6080e50a6bc15e24893409e92a4cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63243070147b4496f02879bd8e19eefff6bb27d6f3d0f80e04bebf006854c82e(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b5786d7eaf9951d8b6b4df1f6a41adff716825bd65e6315dc49f514f9a76e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cb15d6fe28d7705cfaf7b3009d70366c3f1c5133def3b8a98eccbd3acc6c503(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7dd8e91f8a05563bc261cad72863f04ac9feacf16f017776f25cf893df024e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34676098c2fd0bd95f1838b8dacf819c8688a98b6ab7640fed1c7f0b421f02a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2964a5fbab7badb0f2a70e6f07149d50f2619cc1844d84ba3470589c0450e599(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9def685b0336f93840a5403c5b117c397fa808ca31166062d4c49555be84d328(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff91f827c130596ef28d1ce776f8a6c6dc55a78b1385e7d6aa66902f82ab082(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384766af04f8c2c574f6a870c95f2cd44cdfe5d31d003ecb42a7e49e2dbba735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb813f7dccd76db30c47dcfa8c0282ef43c6c0454f77a767e85768a9d801e79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae0e2e2fd4e4c4bb0983a02cfce50a8afa1bc1c3e9087c2c66dbee29b55d93e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__321ca2650f96b5d214658213f10190d1586cbd33cd53c1133b56c48365306d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b750ca8d377366d66b268363e8091222ca8114fe968f3cf9c12bae25cba471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b137079b869148d57872612260f3d37f2bfd5f14a4dc4cf0abf5f93536c016a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3dfcf72f7b1a089c12364ac29362636428e02fef1aed50270010d2dec316d8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afd94e9a714ebb60cad4008bd8dce8cc24e4327209476aaf3a3288125610311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8301ae086ae97bcae4e58c4c2bf84797ed4468ed26e4915d597903736f1215(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37bca5aa585e6e8c4a45d7e2120ddff9cd320f01fb10c0f26f73a6e1cdfe133d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba33e94a09e1ffa9920db1ccbdbccea1034b6f49e7767f3310da1b9074ce4e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__194c19479e28a2b9c37c5798306a10235ad38e7a430714be0bd595c5dc6caf87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c61509fc1ab97688f68373f7c55a35ab19ffa9fe8bc660a35c08fe6e0d15c86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310a3bebbef38483705cd5c1a6223cd6bde999b1a0aa60dea38b79920fe100c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f675d9ab062e170365df0b394ffaedfe2f3e04ea70c1a3b5e4391c3b8fd3e593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33221a4cf1a57bb058f50b46aac1f7970c7345afb303abb1b0a48ad2f3609ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da060f1712052eeed88a60c810a3e04db6fd03967d01b191e07927a4d39f21ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724c117ddd9523af2560258e1b91f2d4ff808ef992e2bf60af1616d46144d3a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8949f6a70747e195e1600b3cb45b67599c77910d53a0afdf4bd8c8a404bdc6fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d82465299f19a489b09d4a024f01183084664c6ac10451ac4643648dc34dc98a(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee856e988862b62aa91ab8ba41c413fd5a27a398e2e451c19f46de9f88223470(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892709c07458e319f9c29cf50e7582248902e58fb63dd48980bd1351511fb183(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa30b1c570da1ff8265c6c0fc65a0cf53baf9c775a2738960081b4683d537d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c656211e89e2862cf95c277defd04c2c65696e991992c4301e7e81763452de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec7f05f0e0f161dd1e7cf4b335ad19586c05072eed47b7404075c45b21b32510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03da463f579a19c20004abfd06d22fe22f21baec5718bd94d216a0a0ba15ac11(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5aaeeffa88ffef87b441f609be0fb134f67f76bbf458fc5cf32a0af1d12783(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f279110f3ac1b573e88dcd03c9705ef896dc75a4daf17c5cdd2f2abaa66213dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cda095d26f5cc6d63ae38766fa2e6fa52d5fa439e7a67e3834f34d366bf70e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ec148b24bd13f7e5835d70a49d62ef6159fd47286d035dd86e7763fa30fbbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11362a18e8fdf5245422ea6d14567e6f043fddcbcc76682c97be263f4a21c956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9ca1c70439f2cb704e571d87ae1f64d2169cef38a9a3f198fe2d191eab0b739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a056bcc88863060e384838f5d91312e283a5f62d265b8a76877b0f8f6859f6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aca5f1cf4519550b8edcd01cf4b9567c59e7bcd05760ea6aeb19d6c1e3e5226(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f2a1e56ee5886dd872ccde8619f27cab371544eceeea9a06b27cf74a576e4e(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bb267c6eb440a61c3f05c50b974b49a6e11d8083e6d1821b8cd536c3e31148(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a1d2b7e8a52fd24397adc9b16f42f800bc2e878aed04051c1b1b0e69fc38f4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5334583c82b3a66a2cfe1a81da448f5f92ef446a55d4459bfac8e51e72efacce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4537a7781134041809c05c49158ee9e05ca8e003edde30d14ba35b1df069c09c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174b3d31b64009c5f311179ed7fe535d7a8aba0330c29850f03a1798e5bc3584(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0385ec67e80f5d16dc60725d7949a55447049e5a6220bda5b70421686cd42e0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302a115e075bf5b0538a002335d6b63d9c17a8a40bab6f56944f8f27ccec15e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b36d2d5ee908245cbd7de06efb67fc91b5c82d32482b6d527fa74122df287a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86b74ddc664ce8dcad89860abaa97158beb29f24ed3ae59cef9c4aae2d05431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa82949739ca8ccd87fe5fa97b76a93351c9e15957472db115d1625acda0cef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b7e1bf1a038a42b489f56ee061da71cc250a3014147beffd80fe932ac21d18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc94ed10e706cadad0e855d3ddc54e55fc72155a4752867b9f31edb8131ac39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f27c8930d8584617027e1ac63c60cedca5e12d2dc427b910cfa7940eef82e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb4935056532195b4752528814479d6549ca08167e10e1e1a42c5cf2d13ba83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b736c5db74bcd5c24c5ad08325273880f91372860fe11121b0c1ac2e742e86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4a496c8d1311979e5abe8070fcf9fb14bac30def27d279c73111c81da8a2c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37387604415e9a83c7fced7e050e1baa3105d3ff815982399d26c990ab155c23(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a100013eefe407965dddc108c47b8fabd7e427259a45de36b6f0d922ee58ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7080f92a921784ee9bc7fd75e2a49918edd2566d94d2f6a64525b2de009423c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d85fb3d42643268bbefb2829978bde9af683f914c821c6639e43473ff6d283e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0857edd38c95f099644524731557d335ff653f501dedf9969af19d7502b85182(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e7c07647963ee3bad42e5e23763ab46a3152c5ca08e9dda5ba486091a9a4484(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8a4428facb8d463144aa194ac37ce0f0bc506f54bebe6745706e37f8d6c74e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b1c91ad00370c0c71c212819d46eea951f10e7564d6d76fcc2ea0dc68e6648(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c561e8137c9f0cda4c6f5e2310892bdffbe6246f3fa91b2e1608612ef97cef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928527e91e64f57a950ae37fde1876807fd71e8c3314631f9b2a7e18e2c8e231(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de378b51417027c05e7a2eb15f82dbe8ac2ad3bde2c800c0d7af9213628aa6d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db655bcc140333ff9614bd2477f433bd113dc1d57f30d196732c58352fe530e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07b86a5bdcc29528c94a9bdf268124c13c0468a87120541121cfa7d0865c063(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbeed5a896a5c4135918cd8c3e28fea21c3af1d8ef54656c6d83e012978f5fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8483c97cb25f3b2fea4497f79c6d9de86ee9a64261a71691c1ffbf2cc0b196a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373783d0a19b41f1dd772a5b83495b1326f1fb3fc5c90fa3b8c39feca1b0caeb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588abf953fe213774f93b22c300fa3a42074f09bbfc2fdf67692338864f745a6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f23ab41d6289a5d9e9c8aea8da985f28f888cffbfb8a88f8f86ce8d4a3f3ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05dafd236aa1773e3ed406c79c94ebe67179e2ddf5dcad6c63634ea510baa04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94aad7930af1258b43239b5e5c954c0d70a36c7bfcd3fe2bb64aba9966135e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10fa65849077609bb3ca4c8ed7d23301985f02722f13af881fd68bd3e38b07e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6492f124a05115b84220016555ebe9942d039ce114414c6df2902a27956f33ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c242b2d224e1d7eadb9a8257d73472abb4b179ec5d10f1b8b39597b0d9b3b0cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491c3929d1579c3f729841636e0526802c86d8ccaa4b1a6a3b997e4c4a714737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79aef1adeace03167a6a1104d9c93ba98ccb4f78e3258d1681d486fa6942d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db4affb4332428795b358354b552fc99c8bc226d235e3086c00e87471e103ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0aefbb004158ae20d23674ffd38f79d8e78d2f55a7a311d8fc7ef8900ef42c5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b8b310eef828b0b18cf677a071b83af5e21dd89a75830cfd2265213aab2f36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f132626c9870b8cbce2dcce584685293f1a1bc28ff1f3f2611f41464c9d9a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a90db2dd998d0978f11e8ac2786d39ba5075e9d20e3f72a299a6fdd3b3bbab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea71b0fbb1bac6fb7035999a7fc64a21db5815b0063ac8d55247b3547a0da72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1df57c37e5f4e905786a6f5f40878a0876d303bcba9e606b888b641d91a9fb7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58deb1d0fdc5f585965f50d147e19f3d76dd58f4e1ee1f627bbfd953291fe387(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344bb0beb169e2c3f40dfe8736694c675a78fce1a1505684a20c91bc28d4768f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf43bf0b9dc4e04bd1d8f298f1464a52f03689b0a54e7be9fdfaae6d9b22803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ef1c77bb1720588451c53af1160cd6eac249f82d0e167a051bd6c54dc9e948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857f4208efe234a35a2218ca36643552e47e1c205d4da292ae2f124334719c3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076dd896a3d09ac5974aecceaa37e6a156105107bc5dea3e3283b35890ee0785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f73b4481ae6f42655afd495199724afdfb0c472b97d240da8d246730ac89df5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1151a01dd305096c7e04539519add2229f302faff662ef78cef759dd4b7145a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949dc49bddc42fa117072f53d3ec0d021ec88c80e8cc3f2b55f827f1bc800460(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc0d54f8082c451256bda4bc6f87445975afb67a4ccc6eb9fdbb1293b09f9cf(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4879113ea868ade23b76672803189019c7fd8b588a83a040c0222d6f3bbac85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56c6235065d28361cbb51a0847abe4c1f638fbee51249e3af03d7bd581eb150(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__483c72642b862d72a1a7bafb00257d9da1ab1affdd93ebb5abee3372ae665356(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc1b3589d19da4a3dbe3d226c011ef06c9ae8ca739b12407b2f605c32e92d80(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce19920186696a4692015ebd9e133ab10dc492904c039cc92639ed67bf5ab99b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71bc2fe84066c89b0397f8c3c0e264e4339c833a930ed04d878b28c012994f1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43bfda6f8d23d6d06fe44f33fa85c1b5123c10f3008d602cf699e147b9ccff4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9771ee907a80f2100e36cb882a0eadc8f31cc9100131eba8c58589fef4c0e419(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0c2c2535735ff2012af6770ce36d1fd38cf195282472f9741d868fbeebab2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd81653851a076c991bf5c4995814f555bd89c9a8939be3b690da72d6de7e67(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__156e2e5af50cb7a7828b073147801e683c9ab2beab3bc56d64a6656bda6dd6d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9deea0a0a633f803778d5e02b6d7e1dfd98943d96702850f170aa39d63ef6a64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470b42864d5af150f6fbbc3b670db6dc1fdae6c6ec0f24631143de80d4b4f5dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10d4ff9423afb9d51c574ba605822e47934acaa42169c65f4a3956908d5b712(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a255720763a5c16be407ad1a82b37fa1e3526bc47e10f3da1df5acca8e40cb2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80957e27e962ac9f7cbd3b7b6781f91ac68f12e8d1ec5088865a8f53760be1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d81e56e5871d37ca8b42a41471540140324deec2c5e19ed19cc8a7294dee0de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331f5cecac369a57c3ff8864c6fc0ca05c9189241fb208daa6dd2bc50aef13fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d0b490b0a3afbae5e64f3713afcb8b70fe926c3c01500575d6e27311aaacfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c59ea2ad328b6763fea4b5ca0521abdd0c3a567c152c4b77f1c5a69b2c4b9e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0266282da21b866731a16437ed11e8e5f6a84f74a8d554080435c41f2ab58bb(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36bcb1dbe7275406c44a1585e471843981f14c003cf97c36a16912336e5d2e07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25329074f3acf5542868f2cc985b2f8cf65fb756915f202b2ca95eb4887a7d1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4eec947cd1f1d0e021e4da9e3f0d8e1c734706833996db2edaeb416226e882(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e9da4a256c2f2a3ddc8879431597c6a67d1b26505064d97775a72903cd46c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92dd3cfae4594f1a639078cb8ddb3ade95ae9ae200552bd8ba7baae9493eb30b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b962d6a84720ffffc7ae1d1db704c06aafa53a69134c497b407a526a9bc1f0d5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14432bfc3747aace0054bd9f6d09272bb1b7e9be561b552cac43288592d1d727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b303d783c468328d0d7f00391974683284ceb50cf1938c4893bac8b6fe639d98(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9251cdddb89f66b19749d7b9d290668c177efc6b9255a7a3cb3c1d358c3e6d3d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69b84a89bce4993e05383bd1edf63ab179508c456e3d64f73b26bb489f8cb3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161c60bad9805396229d623b77d4d9b95e1e649d0a4df3ba2c0caed4a16a37d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f2ab8ad8837e9d7d259763a6fe6347e4c77809d86a1aa4ccdd352855ea1481c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d808f83a6b668f59475deebb41806f9dec3416cb57a7dbfec58af3a4387a852(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30bc4f11469221a73eadb31e9c14dd0c023aa92a9e274370791219a525ca488(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c0298d4ff0802b2d9da4b22d80c0b9ddfec60b70f82671d4ae99604a890413(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fcb145a18fe9a20c066e3a5a1f23182a351a1b574522a6347d50bc3b96d24e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19303307638404e66adb3299f0f77918e1390b0233ea625034a53394ed5f396(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ed2b08ab5a6d2898571e9bb6c56cb09cebc0b8627b1ff15bc4a7b9ce396a2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daebf8609c8ba78c49409939acc172bf6bc71bc25f6f9b21890189a22ad68968(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a1edac09ac5569346481285eaa942fb0cc5102377d88712fa71a42eac40e8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17698d3d2fef10efeb756a50b175faa560fefcb74627530125514814a98d594(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1477244e823ed2df53745507ab3f3e7b1216c27478e528e7c075d82814c9683d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f1dd3ac1d27d4c9bdc90d8314427f8ef3e504e8a4643c415fe8b2e1a9a7614(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd7798844feb409d5f5503cd535ac93798fdafda072139fe2531664cb0b8622a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e2b096bc337af6f7bfc2e2f8be33e370108a49e76af0d4df892156f048728f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6baf2fcd618ae9e442e0cc8cc1cae7a9e4a5017fc72e59a165e78769c0790f53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4b56f7fec5a6eabff0b6fffdf688bc2004d32df616ea09aea1fd44c748a310(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9eecf97cf04a6dbea92a49d9792bfbdf98c01c03b3d709336c393436458a92(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4242ec6014bdbcbf6eae8f8c8139dffb3d3ce8ad09490735239aeab3cd73520d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34bbc8c08f4eb615063eee9af7edc8edd6ccaccc3a0d35fb3c8c246e93c8b2a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b6b02f355bc4dfd82ad48a4b43689e98d10f15026c7548d592b5b9eec40801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257a5398c3be5e441b47a57d1f654ad6f9d4e4900519de9a55dcbce28c1648ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98530ab6d037412b020f21b76e60943a1d1edb4e91449d4d8db3521ccecf7fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d701602b91e13040d8f1e2b16fcc50f59b30cb364af768946b97c05f8b9541d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d43fc80daca2c9a3b7b5f0e637740dd58a30d10306c28d4bcbc53c0f3f70be2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9057ed934d6786ddc2709be726451f404c9adb5a0913fffa44b8d981b7628588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850cbca3c2fa3054f69a206813fbc017f7a1d3448694b49468bdca0451f48852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3155136ed7ef805c126967039fd6074b0d38f08199dcdcb8a23294c82464d31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75553d24d803ef05aae062edb594044c91d0770d5555837501dc131fb3078fb7(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d00771cf16e6b97a6150007e6d1dc678c509540ae903010ea27b20bb069d514(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1902af6be03d46ee211646eabb9d6544c3579f48e145a30034bcd593e74430d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d67137fbfa864d928e800f87c95fc3f9c2cd1a9374dc9e4b300a95952f37e57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e252afe5d4398b1848111f932b0343015c6620c5609234afc405820213b15f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9479448be9eb8ef47fca2b99da0753273081f081121441232729a348eba7f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2463171ea68b5d4bb46e2af91880aac486f81e5d7ee7d5305e9da01ab35586c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f832e8d2ddfdf04a9a9c2b1f71fbd09f9c21184489747824a83e771ebf3c946(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54f9fa0b9807fc3ff69b48124cc9d18e5a0bca76ee63451eb454f230eb7db49e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110e562b0f224238c8d49d1b220aa8b5ff6163c5b60f0d7ea75c491be90f92cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ab9a48499cc6a9086c208b337424e243bfb79c8af689a7b08d61407c42a244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42018b03365229cd5e03289683a60666fd3ce10839839273bdf2232ea6529ba6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aabc9802e6df1201de89ab659938984e64933cfc93f0904868a89565fdb24bfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd782c5a933dce59f35877d78d6baf255ffa464f0efc877f42d49de115487ac(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb80d0dabce6aef4bb1a136b0270e0ffa71679a0ace6698fbf55cb862d249f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a41579b7f903b3d1d6f2553662da29a3de913c7766e826164218eca286fa07(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58cd63a158464930d1367ccf553495d1fd21caeb05d860b49ac07b3df173644e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e9f68666c874b35101c65435dfaf0cd3e7c385db56419ed966478f6adb3131(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0266b72e836ca98de690d40785e4ab9cbd582c7a5d0a0747b99b37da6416cea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9adeacbe2f7b69f12ab5a9d7d7a85af710ee4f1ff6eb9e4252f5db59a8fd69e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a4fe54d2ff3751729de26a081833426df1bf75c188d1788c992ea91bcc3a61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b247e1954f5ba0e3fe425e1ad2ec535b90cd55b2bae5ec9739d81ae181ae1914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8702aec26311e57edd62968a0bf424303243b3f8e2e3fd9bfd060a735475d3c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5124dc810287d01363d5467ba0b929b80c9fd69a68de49411288cbf93c413c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f043cb31c4d235321cdd0117e44ca6aab36baa6c3943ca8fe382dbec74c75fe9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec586c438967a353b48c783c1ab7e15215dcf402d579000c4490eb38a4eab6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8eec5939db861f58e8731d1ea24d9b8c5e528a1c4db6dcf3a666f32626520e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147df632acbfab7a22c823cf5d476ca8f135d25d6411b3f596e9afaf7b70639f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e967d5299c9f5d7e4e4f4d8b179c66377ba9b658774b62c7d968de469d460a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1578c5d9e9fb6fccb23be1371851a1e223337d4d0aeffd71fb14863711816035(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc9388836133bbd79450f075dca0f409114c52e27f555337982faf7bd0094b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43932880c08c8aa7229a4b6c61f878123b96306eb802b3484af890b772f0253a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9b7c62129ec1d9f07417c6726044f291eef75b6c58224968cf8894c0a2fbc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63f3f9db2423961c57594d2eaab2b0c4cbe10cf90ce3813d68b0af18155fe5e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1a8eefa59851cd8841be2a432ce664003e43babf6e6f03ef1059cf741c76b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9ca0df5392c0ab47673a6f5973813f627ddb8230d3589389496a3cfb8fab6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d642f5241dc15c02a394bc3eaa9d8f40d3a95dfadc00cf974de8150db60bf98(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc34c5159680a4557df3396a3f047fac436d83825b3c64ead6137601a6b223e2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fd8a4695f0dd9d4271ca123e666842023dba3ddd7db64196ae8e9d21c9cfdb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c9c0dcecdc761a1ce85863efdfc999cfa967202c2619eee770b49ab83baaa3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f8063ad75aff07e8861aa40084427c456da947cf983821f8799b10bed8e08a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f975c485cd5da9f2c227c72bbffaef22782694435f400e3e822802c5d5966e11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90813a8b99cc078af85c2f4866bfdb922b329c00472666f1766b8f0af8a3593(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f20ee6190bf5c7ce729764315d22b440c9fc66463e690b5ecebe2c7f941c39(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efb1eb30dba847c650d080b7c909cb341f517db81a0fd76fd0d806b745cd76b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea55416bf50a49f886fc75613fa32dd99f05eb0de2c996aaaf74ac4947fd83de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f17e46e3023f1c43a01c6b571a1abeada2b4bebd515e65d031df6ad5384ea74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51ba58df89c59e86dea3b64758e7b26685e5e289ade81e81bcbf062ee317f84(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90361f0294eb236e581d2da86f1166ab558f1b242f2adaa9dc020a1aaa019784(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da7e50115d573a0ecd639cb33488aee3e10d38c37eb7e05eeacf2cdc89859a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8865cba369e860ec53596fd377731413a4e6fc3e83c1cd2c1e285e3ea91824e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9157a865cd7354b83f277def5e64c42e4f31b189b1387c32c1e13fdad3bddfd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e047290696585b29009fdbe30925207135d1d5a765600ca5bc02432680ded7b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c21dbc1c6e300a703212ec9bda0ae0e2d181e7622a8fcd2b4c979c5a66e556(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730851556cd424dedb83ddbbe0fea584824e9feb42214b5cc9d3e99617f0a9fe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a8b149f2722e952ec2f8733d8e145472e4f50c96f189b6a708d098352396a7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d985eb2bd089986efad25b053659a8d691d616be5ea931d9e644234878da1320(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e660c595d52a104853a9aaacb3f5d6558d0a3b8d76f56045a14b0f194f4f19(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ab01fa8e0c6b28efb88689b3c69a7d9dd6c01e59a92bca12488004e0bbb53d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55f971d80ff20579a64b907390acfe329f028e3964c9d2865816638e2fa3a81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb36a400b872cb6b7a70082c92b81b3b95a89af028ea2211c8ef39fa9530d9d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3070fc8934d67935ad96916b5d8d8cc1bd0848bfda51452082ae0ecb543386d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a744244196222ae1d8fd3d1f923ce30c56465417bf936b71a8c0b7a2f107f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95426e477d38668e3b24eb4b499a7e2004b0e6b34b657848775d657e52ab85a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c473037d8a1cba4018d00618ff72f50df559e8f4b53d7971cfccf4e1e06b5913(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6537911f53901e211358bb109803da88e5476bce3a6bd16f42284c321a77cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99f8490eb694e087d2e03973b630450835b1249bd77395a05503efe274d380f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14556d45e2ff617f1d9e85fd297a29b82407efdfa06275777f46e6e1e3e6f87c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80defba839c828a27a4dbd819884794d1e6eaefdc2dd3d2bcdbdc2ab9f24cc2f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025ec5b34ecb65a799f6c46337621d7f9ea77d7513aa62da3ea7607085648761(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9dd41225483a5b1cea49186283490c5f13495dbfd57441d5c1911a8def9c3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5f3ca3e2e0ac650fd361bfd4e22d6d17db7df1ab032ed0f71dcce3a9796675(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10757d4c2b9d904287fc58c5be9a4519d0795837a16f56b6b81698e10d0b6aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325ed05a9136c052291d99f994a46d201dbbf1d89fc5ab931870cd5d074f9fd6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be029b564843d83489bc4f3dc631956f0c691515e7e6a4c3aebcbef1d2a052db(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5d0fcf81f023a81cad40e3ce6c1aa4cb362d4df4e33de0dbd2d0891392cc7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d2bd8ae4a6db395dcfecd2208e19ab6fd9cd0b027c34ac26b53cabb4e011ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df44d79b6fc7bbd4e22cf393bc66cfa156ea68009ebceac6185c7092cc0fad60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3303b7ada9f57fab0c994c57e7f6bdbc1570cbe77a06a5f77c8ab23b6dd8c4f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce8b3d847bebe4fdb98debc53c2db753165fd58973fc95b09a9892605a2e425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8938141d972f9baf80f64f7162485e2d522770c795ce826c93c043446ab2da4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00ef72e692f7b3b6306dc23f36860d95770bc8de8dc984039902ac8546d9b32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04b85f5a23e074956fdeb3874c00400b88a692daf7f98187c9dd71feb289780(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1031dbf5aa1e861e291fdaf7d48ed8d566b3f93038353a7ab62fd8874b17cb74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527eaafc13404a0cb84333f8e937d952354c265f3a54c826d3c015579d12a715(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18cd0d7800ef6e575d679db311d4cf061676e3c6d30e96a8dd82b09f7edb2228(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588cccb546a2ee22ea2194e614ee57251b5cf80da080446595e01ff93061a18c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5dc50c4fffa41edc2fb4bda56c6685fce3ad4a8f3a0c08ea16b6d941170938(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139903a553cbff8babe5a859c6e1e61d571dd78a0bbd4e89e46460cbff965912(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2a734c29caac34b8c10becd57d2ce9252200f0730a489e66f136aec0eccfe8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786b41b389f8dc8d5d325bd9d21cb45a6ffc9b9fd291a7de6b39bf6ef0f20b0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53080616eb861329a97235ff522b5d980ff24ffd9c3dbe788c3ddac3225d8033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11afa09462140a42d21561e6339ad9391226c23cf2b52857873439b86cc713ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5b47d12279bd6e4cd10eb163ab7caab8b48f86c5a20a0362486e1333861097(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51123ad68aa0590b8449f03269dc8a3157d7cef4ff7d48a0309249e90dc4e36(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af8df254a37052c4e4955b18e9c3b757263fe91313259a23e0c6da82fd0bddf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14bfed75e3c1afe9bcd76fc03fae79857a843ea367f5016548ef7540281c3e95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa7ce7e070274ba0d581c3a782224da4ded3d882ce0581958cad9650d8ecd51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71cec283a83834f00419ca329531d660449a289759ecb2070cca6843f6d6e27a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5462a58f314d099711c6fa4a2cf329bdd20db8bd9dc5de2bd431442552383d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b49c452b49d343938aeead6b1fbecb1fb82ad749c92ff069159636d6f51375(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e02f570cbf04320f62b77ccb3f813dd8908d8fde2fd08cbecb7e17a865e429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a369418b4a3ed6bdaf08b7e5e7a74e07d02e37c124bdd0b5abfe4bf39d1191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6251d0bd143720d8e280fbcaec12ad1da54604e5aaa7b9ee1996272ebfa4210(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e261a47afc72c270374b7df0791c11ba193f67c39cdef792f684b7d5a9b19ec6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f881f25ba99982ad60d4af8bad14d344b602f56f89eb042843d142c0cc4bd3a5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6312351280a5a9ea4d9c948e1a389c8f04d24583455078eebc3e3da168cff63f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45e3fac457fc9112025ed3169e2553805edf5796d25aa3ab0c83da40d3d1d3aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357efd963efd1e476433fbac9e38e18943c92402bc604ca5e8d655560c741e2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab523452ec017a57b59154021202722af860bf1b5f3e2cd623acceee9c45f1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643763bac4f5944864edb368af70b3b2753df3103f07cc2c39333376c124aa88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b79d492ca7b912652d913eb3ee127a487f2a34046be8d7a31f7400ac1e8633(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b66c6581072735c0ee2a76f53a006e500f08073a84676e56bcf8b7d1b6bf03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a813943bf06bd01c6034df320b698027f8e2bc18a3a2fc86a1877a02efd0a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c91525d17bddf721cfe72a7604bca58248c6f20593e717755e4404a019cd02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37f236d02748ffd6f1ea21c310536369814d5b1a7548735312bdedd3969eac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669472894c3eb43897ff3aa9e57ba5f79b04fce724c81017f0e36f7e8831b975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5accf02a820b4d9510f6106139b3013d0004646c249b3a1b2287132f55746b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2474c6bfc6ce18fef8a1a60ec9e5275b673b889fdf7ab85dfde707cb9ec834(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75305fc30bd90694238abbf41ef50e7be93c2d92a245c751e159185890182ed7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee35ce07f29f76581c094ccd53d94b3650f0be369d60c8a8b71b2aac2ca5f667(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbeb758fcb0beb851284a684c2d828520279913a5b06abf6ddb28de1815fb2ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fe0edb9c60d23c4ace8da922909f229d1fcb8e1073fb88cc1ef98c6984d7b5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43971bd5e4f4d4d7335ae6f3732521415d157f6b328c2599981e341aa6790bf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cbb9ebdc6c988158faf36362f3ea6f9a32850b0b376381aa8a59e56110d55b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d30af6b4d7c52fed92c511a7c245c4326ee8d54b921837d2dbd2b738dad9bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c49d3f8e0388240f2c9dd9ffd16137c1369de873abad939789a358502a870d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a4c432c4d5e99f2688dd6621462640eda23cf178178076e0c9279317e2fce4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31931b8ee05352680ff18219f8c267a4a1a7ce4dc24f3c17c0a9a678576d30c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcab01ef38309b60e01adad52442c3f920b0a54053d68fbfb175b94be0445a23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e2aff9aaddcbf363035480b1b81ae61ef6c24fd60dfce2dd58892ff482c5703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d5555036882751fc2afbe1874be3b3705dec2406ef5b43e97f9697c2ec6eac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d682aea1ef7ad19f08b38f2edeb7fc93adb6e39abca779396c953efa54b48a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842c8e06599681d2f4612b1a875dd2131dbc04b1ec08f1ea88a10ab27ed50a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438e15b9459bc628f2efac8aed7a38a1e56f388962642dbc541cd086141a9479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474f625044563bb47a7fc35eebdf6bad320661eab208be57f286070785dfce08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84ace7eafe8d3d2ba8efae7997013469d07e3c517fcc6bba8b3a43b6b76afd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d889760d1877790269df37e9d55633a467bcfdeb354f7fae38d760888e412f7(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef468b595ee6b08e80f953d4ae2c69faf09bd168a690b91e7aa69214814f8dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799f4b52e3b1415fa396aa80aae336d53ad8c980492d6c922cd64f9e4ab1f25a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32fd1d60b4cd53e462c36db655e12acda9b60db66ce129e42d6077e30a0b1e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d1d02f4e324d58df27b2bacf167506f83321a5a11c519b90d13c08d5d629c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f45f7c93d9360667c924fc34c58a39f200547f82fa9bb8a1ed5d9450045561f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181e3fe05433940933bb48cd81f4eef4ec75d02a6bef3ac2f4139eefbe214a11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404d74cf5c62d60a515031e6cfab57db75edcbc914c296cf405a13c3c66d0ff2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d80fac3f13af9135fd91ce911021dee7e6f61acef566f9aa3e8097efc6aab2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087a5f0c59e9b8f648237bf6d77ea14ab3cc351d69e564d2506742c64a1529c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d59fdfacfa52ab60198bcd8dcad1447912b8ac0855fc683c823722afaf54613(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f96a7141b793580307a2d1d0efe420bc600e8c8106297788b500fd3645723cf(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0134e63b9cb2a1b60aacb44b6715e96cd067054cd0495114857c7f309dbf62e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d5ab34dcecc18696ec1619c0f54b404f4f22b0197477bdcb502b069f9f9da9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed433f83c66a579dcfb234939bee2552b30019bd0ba4d0e73e3f20b43f870c31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddbfe2d6e23884c25500a417c7d9184d3c082418fd6736ac44aca8773ac8acf1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf14183de52d6939d0e766d8ffc342424bed244f6de5924fedb2db47d0408b6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2661c7f96d44461904665a9f3ffc8b869b2b8938876d1fc77e9af703453e9ce7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0574f5200458d38c4a01b21dea8e7ccc19713e4d1b8517eb91f6912418418c53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350f8888c1da09e69fde87dd0f9dd33333f4ee097ca6085847cb31bc116dcc85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec936a978e6d1a1bdd342a082b7b3f021f52964f8f6563761ccfbdf08835ad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f67db6c2f4e9b5c5bc503b905ac8f00cf386f1a9d4194172b14f8dfb0e1c45b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61459a70da23ee36c98c071863e267f751c5c600b3e135b3dd22fe74c3f99d3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c1d5df553213519e5bded7247faae6b8962ad0f38bef7d5f097c32d000632e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58aafeaaaa0fa0f91a9b22cc21167317d7d51bbe8c30d36d9d241fb47b4e4e9(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e1341824d6109d8a17330266dd36811128bc8b23bad7472853dec3bd14d9cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cd5f8d4135af815bfaa8c0b93f1499e149d2508c5a8164eaea7ef3839557a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef6dfc48b2c7332ad6e71e97a0358eec074a5f09057d4c748810c68aee60bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6f111acc2de878d1b4549c66d919d05bef619c9bf8c851a58e36829ce95663(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6942b44e127979f0e4585f1064ef13b51e2ae76543fbae3acbbaa92819a7182d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596a571e47cc6bb3d5470bcbe02b206d1b870c783e28c17130932954add45eb4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f2da08866e012e0d3b49ff507dee5709c8c0c37d2cc575222efbb74b36c28f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42c3b6cc5a53f07c42572af8873168af31dbcf1f70495fd16ae8b55562ec05d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1974d1638ecc178f5a62436ebc27b249025aba4ad8aa558f52c5214bd8d8f68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad9bdb11c13c8a0e6bda443e50b5919fe98f258a8d82b87e8ce813af05ccc87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b8e0b64f5c5137f25e2b1102340b45e481b855016b61a3cefe3e9fc3f5216b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9bed4d344fdf51fd49ba343107056c19851283d22ac1074d9a8167e4861e5d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d80f4d72f41e8fedf1e6a0b86ff6aa1891b965a4081c2e2ce9141bab2e30ed2(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a24b54d6adaf5b9f61420fd0b5e77f35cb6c6dfecca5008e711d4daadd6f187(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7fe895553ea19ed87a6a828bbd7455830349e423eb5a298a094f640dbef4b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f5ebdf2e76d5de9452bc934bf8f06d7bfb16bd2b0fa70eec448880f97d1bfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85a5872df89e488c13d7a2fe42c70ab5b88494f4315069216733abe688b368f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236c9a9863b74b3d341d3a93aab06ce32b77abbb9fcd394c99323893730fcdc2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830530bce68acf08e5584a340441f68a1436e700cc47059ea3c8a13693136238(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b88c28e301e530266c6914f799e3d4fc85a3fedf2c17970ea7e1ddde3955cea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14507c264dcdc63449f51a0baea1fbd44be9220229095b7aad398d755a4b017f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678797ea2d67b29478bbc6523907b364faf269f2a3c8fd9ee69c06b72d21eab4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2651d9037a48169ce893f0408e7e3570a686d0975ef9b1f8e08f3a6f22f563bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661e126e7619e157b919e8c2ef9e8543f955890a3eb378a02f3dc4849e00ce3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c608a9d043bc5bfe6527dfbcbb7ab3232ec37f543b0dde895f7c0d06ad4de827(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1e3f55f54c14bd4197b9fee27789676170b29dedd4fde6138718e5c23f8802(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f76e3e39ffbf20e453cc5e0b70df7dea997e7f65ea4a4e60f90ed086834408d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106079c635c9486e809ef6e1b9710e6fb57e50a5036210c65aa9c269706e9aa4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ebbbf74bc335a431815475c2ea19b717dc75aa268239ea80c47709c960c5e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9631e04f221ad0f817f9ab0e74e289814a2a3d787ed232e417efd5f0552839(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59f90b62734d1bd86fb53e60d19f2e2abd540f84451060e116c1e77d2606240(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e642cf9a7034c0920fddae10650e160d5ae01f0284e736e2e21e846afed026(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d9daf99cc8817cee97f7907775bbec7118d2839885c6823e85b85df170d38f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06072c06a4e6c12b0def102b35303fd319f95bf908c7717aec5cd39e737008af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088c5e5aa639773a00c35a9f8c78d8c8de8aab073e35edb3fdfd24afc6f8524f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13542aec2fb15caafc7becd06301052161d108800b1101f73944dd90e2ddab89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d8f070517d996f5f7793a00ce1eb21cf6db1449df91ac2a74812d5e94be63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5b8acc12b04ad0dd2853d5ab6ea42d0c94ea9dbf772eb5fae3ff04054cde6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f5f5dce80307aa6c5a0115cfd8c6a75a262cc7b604cda7db03f5afdf8b6329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3348ef5720637c0da3ecff139b3f257d83e4f5c6aaeac60dbd97c8addd0082a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d07fa171fa2a82fc355b27beaf3653223e459849553f4765e34aa16645426b(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1a93e2a5563a1fe4f9c0edc794bfaa85fc15236355a3134e56d57915057bc5(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__058e0471bf8ef700ff737e1cefd9fd708d4fa028ffdeb82626bb1f702a17fe89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888d573cf46004f8519878bdaec82df6cf4259bebce87c926cd2cdd4ba8c61a6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9c53d0c33fecf8ab10d33325d5a1cf9aebcd812f7ae69aaeb9c1e3afd95035(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c420c94cead23d1f1f9a0b81b219efc13cb954b367ba91eb3f1ae5d7c92d6d83(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__624f43121aaba21b8b01a4ca60b271634f2d7bcb2c0e6ba336f4dbb7f4e46b9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc0418fb481bcc1ec5fdb8e7769b2cd9d40170b5f52fab909e2ae3e9817d987(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f45fcb43cf0f61d67e7ffe6ac534bac72ccdbf540e0cdb127e67b6837de9997(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7013f508cae769a06657b80eebdf6d74f6868e63a93139b78a0e540fea35dc4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24abf36d444da0c7cc058d400558930808029c816d23ad074ee16389230150cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082de37d42d849094c9532233ae5d39a01e6e32d81f12aff0bd0f5b96509bad8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bc9d4416ef676a19bf23a1378a8ce46ee13eaee4fae5fa1c1361a4351f65a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fcd0ae15eab94feee37afda9eb67540ea6b89bf139e94db83100c39bf3135da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ae4a7b36e4e920c22a88f4fc8f17ac8200ec40a9f97bd415607a15793b5a61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1630d60607c726c8d7462bb73b8e2f8a8c2f8ac56900e459131228ed13f9262(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd522904343dc1baea95349e817a45e553abc46ff299ad8f978fa96ed1b35432(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4828357411f3605f156f43cf90f0f24751386efd8ba604d45d635c53b5ae66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5825af4271e9aed7f380e0dd9d7830980ed54db9f56ba61b7bacd4cc677d5d8b(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7defc05765a2cab951df12dcf8e630ebae0606440a1d7e3e53b01b3facfc32c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebacae8398b804a371a586ef2a5397c643dee66ca6fce3d4b656c3f1916f3cee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__755d040f2deb1f7670b889f285aba144f111bc61dd9919cc19200c79f2e42c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e75dd84552028e62edcc23f5a60b62af3b75b554741f985a11919ee3e9b6a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190666876d0955c0a4b6eb80caeeb5dfcde9e7ffb37a57af128065b5377270ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac94b36b7470c438691ea6fb0846d1edcaaac14c917c54c9da9241cea795b6cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5cff50f12353cab49c19a857ffe3c5d10fc06d4a7a8f18061cd3820f6ac4e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d5a62568a768d48af8752e2866789109d421e6bf55ee573213c4176b8a47ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f35cdb4878c93d3e9037eab2ee8e9a5e38dc07a783b19d9690cca7a755f812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e528c434fbbd079cb9b2cefc668e7ea70fed6be00359dd2954d0855044cc0fa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5e12d2f40198e345de4213efc24ba31d8ad25f31ef690e6df89188d1af82bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4412416fc5f46f88c8e17363809c3028cf94ac79218463fd3e4039058996945b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5238e1a6906743e39cff3e3f388cd0821dd3d473c019fb8a1de054491e9e9bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30f150693898c2990a3af4c93d086353b3de0cade7674aea813815153f2a050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cae0df8210f5d7931f5d7f4a6e39cedfb454fe3344648de86338df30db61317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ade9d121a5559e49dfe221c49d77a7b6c5b1db905b33e6502ead1a2425ca94c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4657fbbb89881716e30e14795d321d3c7d69c3e8b187c4863e9bf6e8406adc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15b1bfdcabcf9b0ce921a39ec7b45ff821a99bc6fce5ddc487786b2638ee7e5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26f8b4e6aad64cfabe9156e82b85a294f4150eaee1ae61ab536bf072cbec99c2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810b93c76f5aec4bc4edccd48206e8f46e1fd60184061cc33ad9dd37bffbb805(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9e0180ffea15e3e9c50916259bfd45f03c56ec0b580dea93ecc4af524abaa6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2abd164169dd263176289ee28c47f9e556dcd451c53458d43798c6982d35153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba50c683d7e5a2dd08b34aff17b43bb7ad53527011cf1e5e13a4b4a212f96aa7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410caac34282f948dc9e3e507a8ca24af2d33cdd937b5bacd777cdccb7a2174f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1f0a4769d2bf4cf71a96d45330191811219c3fc06946c867f6c142039b5c13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5d1975feea98fe77895c29b3519b99f5b7b5b2c95d6720a254ad1c7728aea7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b485e2a5edb62a4da226773679b1d1ab1fec3f1c353c4c958146ee3b9f4285ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e771ba547e03a730acd80a391406c196ea9a4fc55ec040f475b481201bdf51d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa097e10a93803447a58ae6ce9d52b920c564e02ebefb16a1074ebf7f22b89ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ecc97b5b3e3f4fe8edd073f12f866459ea1c73241721857d8a9aec0201012b(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53bca8a73e99337e6cf7523d72819bf0f0eabef328329396bd2b904e152e2ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5738539efbf6582eb7074299b83fffec5019433019b54f0c7a884cb6a0a682f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdd67eab4452a20268e6b06b11f02591fd05ed601f32ef693775eeb1b6eacfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d1fe12d7963a9b5db85ac36221162970edbbf628d3b6255a11fd7cd7911dd5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43948f9afd9c2b9570001533409e23a0faffe758d6f70dd43b3b4f348ebf402d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8bad657f97d2669cb11eac7631c262182054cd46905530b04bd01277f401aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c23f6209aa20e5deee675351ce85a963b0bfb86c58b8cf7a819aecdf4b8685(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5563dc301f3fa927beb619447e979cd10d1a0729ade93fee7b911d3799d2a2d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f02c0e47e4af0b082a483ef9a207e9a2d0827d67f9db57854dbfd539ce38d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47904fc5327ef76882b4cb959dd6f0cdd1f30ce158620a69edce11910197b075(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba2e011d88876bb24ab40fb9da2dddc70b57e48173344bc31deda979ffada91(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535d0609e3eed6baf2491e677877a9984beee275d12326b28e37da78a2bc8fa0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f72665ab351dc77c58d2a337d4bbb3a57593d605f8f97233b1fc710e45e8cc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__839f889bde8de9e4d91a58e6b79dd9528eaa1517cda8e34287c57e811d1cf70d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f7b9c239aea981a65878585b8b83bda988eb063e5a52eb6199de9af758b4f25(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3caa417accbf6a364da29ccaf7caa48fc340cad5ddcd19c0c4f81756b93c3abe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2251479d4d841409a018ce1a0e9767db65c95756dbb6b8e48592762b40da3eff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a71b0b090c2b266ec5e97a092a9647c9ca91a66238e2ddfbc4624176d097857(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed19502226409672942e7eaf5b4358234212566c9de4d5350297f28daa816de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7a4ce8912863818e223d6b6e0b699929bed826d346a090223983b644758e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe4b75675a01e593309ed13206f06baeb7cb96cafb22356022bc5a855221757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db831d6ae88d9d7136ecde168f566192b65a6f3439df8d6de3b67c45dc213f6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa81a02129bc70f5a7107a510aa609d47a6b9664701462163f26cd0626e59cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ad38b682ac1e21f2c5e82a54cf61f2d8048ad5cfde42eb10ed6c6708708053(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a30c5d045edf76c1bd53464838d35e4e199f7171719949336f0a89cfbcea59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb50068d1acaf224c2c7819af0bfb4094df4d89fcffdf3f9d1efdd1c0e5c9161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b467bb2c430087490c1d666c2dc36400bd9a781223779429dbce7a84b4b2e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab3ebad8dc0b3632b04261aecd88557c3e7e8c6d0a838870b60e4178ef8606a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2548ab5d8f60a82d19d9da662ae6c9e40a510c8668a5746ce3ec29aad6e02ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f200b58a46ed50ac41de9571f09d5237a131a37659feec0078cdfe2bb2ebafe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec3721be699652cda86c7e33523c012601d8e27b4d94efb9a0d0a004284b0a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1f3e8f604d58d7dd3152045d986665148530e4527d1901104f1541a22c54d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42354fd08fa921fb75863260ed53a0c1fd0b2a6a4826b3ab9d700ccab9566f95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbdabb9649bca4efe21ef8db5e903f5810908466a580fce1ef9ed7cbdaf5a83e(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f57904c92bcbb5af943c65914b861d8b796e5bcf5f6295ba4f4b907fff07a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9b263b4b7ecd8c187fdc7c9acb44b4445b53653d518c5b445b877c9cb2aa0a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8a5b1ac2e4d1fda4a2ea57c1381c75beda1bc39c9bfe39962fe8b40570358e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd29a7d1f4a36540f60dde2a1882516d3692f5c46fa128e968bd3260843f6d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b28bad3dd958b40e9a3de2c08c8be4472792dd4bad62b4c81168080291994ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c84511cdfa824e8168fe5d9aa978f78afc6aa11eb7f75140835246ed22d516f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f43c5f4f696907ccf6ee54d323b54045c4e13f6eef8f335c814fad53889aca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9e7dd4e1b213f478cd9d4ffd5fae8a4a7fad1e51ec36b7e331bb6b88110a42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb563cc0405c2c7efaaea69c5da98440b77af2aa0f762e07a1e0cf5c58ee986(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__727f9d7615d0d3ee8fe77722d1a504a81bd5f278af3b9c6fb6ab7d67d86d698b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1feef7eda31f881473d12d4aaa26cd8c5ed000f0aa2f76b7a014a59025d6c9e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b08fd514c8ada32e3c8390b5f7fa0361f051864a6ad53793c69e244161c145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823dd8cc6a00d54fcd082029cf9786338ac753aa5f9f445f33f7c883f802016d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48cbcc3e633540774a3cc7a3cbb3f3de6f9f7f5957c2cd664ac30b4b57d66b32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c4b7f857848573d0b5e91b80982af45d9355ded87a03adec54aeb7b2da70ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93362b46e96e8dc4a45517f80657e77f1393b38e14e9b2a1256788d631d52af4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77db55aa2cceeca81d4107f2b50125c27b166fa1be991ed80c69541e480da80f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed21b694af2c2853022c7d3941ed49d9754b487026e44bb39f50a5e51a615121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04e209cb6761d2b5e1017cb484ed7f7a14247caf22639f8cd0d9293332854ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0a6d6b3be2f35e03683e9f64810fe087aa4ecb593760810e7874eba29496ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ce80439ff5597345e138bca61f6fe9a3681c53258f3234c7aebedc9f6f09b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185d8d87780dd48e85638c8f9a1e4a34bb7e21333742b57f32114c9b1a9e73cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f2b2a69ee03b21638d4c04b1bf73fb45c65d9984274a13de537811e3a84281(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193a0d0c33cf1b53c1312ba0003466a300bcf631215a0cd96db88cf0d83939f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc8a55a527c40b4f2b9f794b0246ba91fc5f8f76ffcf59838ebb0d6cd5e217c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e7441ba70152d9d56f90bf73220a4b600fb385c6f4946c5fe45624a7c4af62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa93d19b89effdfc08e2b260eead52ecacf15d76ab81682f97d4c9204b658dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c40b83c49ac93c2b180eb7b64f1e5d52302a227dde39cada60cf15a356ef43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9ef8ca715212c9d5c1cf69bfe0d5500665a6451959297afe4e39e1ecae75bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__130f639420fd43e0a555927117a0a2fd66d5e47105e2fbc8589dc7638db61813(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac1f00e4ae9740023bd96a3bec9590add9dec70173f5d542eaa341f601597d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0492cdfcd0c1790a9bde36e1df4f7a606b25ebc20890cc3b45c9f8d7483314b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3e9f511be5332b6cc7d07d460427431f3ddcb219139b2f0e06a275589f27e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbeaa89f887d5675e88b84aa951017d999c5671ba3965b425845e6b8803cbcae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc23e4b04cd5b4305fd6b4c320909898ff18c1a677bcf87c808e4c7e82637fc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3a9c537431ef315623039ca71a7603031797b8d0d91107094dee2677f75327(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e89f568086f660d8b68e5f7de83f0d3a27f5dc0a1891d0c229c44f86a592ef6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1939fbe119674ddc2667d57a8782088b2583797fe4c69dc5b4ed9be6d89888(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944830a3988b4ed9a54c65b3b9411ffdba97be73be808cb6a6d25cadf109dd0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74311b0327617e28f4c88edd3aa350a85a2ac4a7fc51c4a8520ab8c246ffff12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81696e9c50ed76b2c1143afbb3fa33228ec79996f408077ba3c940a9f783e9b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd700a60184dd92bbbe02ea8077d19660d31413e2e1201e5663ff7e560d6c91e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b98aebc337657bb1d31df010c8b3b25bcc5f19499aae725a42ff9d8cb93f034(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc19dd0e94dab2b5e91aefbf1e536cfb353e1906c15cd33d25d690888b10ad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9046a899d7bfc17e08e9148cb78e1788d8f572375d85f2bab0347f63f58ad21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2eecccd577c47dde1f80416b2ff4fe5b2c64956fcb6a08da16614f82ae39bd8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605935a3e3e988653f15f347e3fa61d8609f228154e01b9e6e57029e02ace15f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731b014ef78b5d3a430317685105e8cda20d5785089c89439d5126fda0a86b23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e4199c09bc2f9fda927fe2fae6d1909d4983bbbf302e61d4e009852852c2ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc40fc723cca759ac3f390a9d8315456e2080d0a6c8909331c1284319555ed7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__316d95b5f1438657f1627a78ff4d216453416e82aa931062774b3cd36a0859d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ab652836c9fc2641e23a30b0fdf154137c39bcfc552e699bd151798b1d2435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623dcb2891b723cc467ffda0dde46e3486108c2eaa847c91e5dd322c4ac07246(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1cb0d2266ec4728861941e6e1d99bc171024230c60c812915595d4ec3743489(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d958f614d81184839e0d76f45a9dbe2ef9d971447fb6cac54fecb5edb7df9b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf2bd7aff4d4d0f8a04bfdf46025e78668b23279d63958091c0f5f1a593138c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32338d5037559043a537d4988d5ef9071794ede22652e72df8671f6c87c8c098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5add3d2c317b6a27c27e66b330f2bb9d299134091df5b8fac1312adee5d2545(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209c9fba7308e54cc2674ca269d8446594d692d0a725e7731db0260463aaf83f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a23f71a4e525e9429185432e33f5de8be299539e9b636ca4282ae0aa09d9fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7762099ee3713b4a8102335ca41ee0e0a6dac2e3e4f357c3fc8e73543d7fd24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bada41c8665f36c7c0f9e1d3fb89f370a4caa56e46c6e6b1ac2f4e6eb01465dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77cf5b02e1a4b98171d4e08017d73829013b504ea3690b593b4f817bc4451ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd377b803bad01e97a8ab5e725ad8047641f7ef5be3444aef6cbe5e2679ca1b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ebece1bb0b66c771db1515722510a55d4f12b7f37007ca8c155a93ff7424fdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7f0972afe889d4b88a0f9cd5f48d782e6c90bdaafd9be5bde1dbaf86f9d866(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03bee96093ad60fd2914dad7223cb782abc66f376e79b353e2aeb1d8298cf2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7b380f9b676aa159ded1bedd3ae4593ccd05b381f3d38b09e1aa2af3a784f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6010a126a437a2c0663bdfb683af725e087fac5dfa16233882d16ab37582d7ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4cac717c0c3afc028663a1ac850e4c6bd603cec8dda351841a2c82fc985ad89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c5161bfaac081caa2512bd8dd7817befd4dd98b3e9672f0e51c849fb1e9f54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c427a5e60e81d447195e49bb78633e219654863db12a381e5e608ba73263e054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7c5b83bbbf809cef4e458feff46cdee38c331d3d66849dd81601d01829bcb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45aca262f102aadfe5c17adb0282ef80f29d7f4db611869ef8c33ea151966dea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09daa0deb77b86ab38e8ca6f8771b52a45b423cc43bf3beb92773c29c7f6629(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8aec6a01b458689ed1d6057c027ab32914a4552d9bbd72518bc5b5cab27eb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4913a67c07c92d4089acde45b4c389154bba218f6ae8c4f663d8c4308d6fba2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9a2ad4beb8188aeaf228b041d3247126fd8985a521a66d65761805b598db3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc28ad7de6dc3ab989defcef50db3e9ea8cb85fc30fb3057d4e6c3418413a719(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c8410f9b15c04c9d2a3f9933526497790d7d7c9c59a257d703dbf4a33ae1e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef0ffdfeb9f63d87907b620efdf9cc6a063d6f00e5204f48d3ef664adc7dede(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0363bc2d029b8910b6bb3e939724747f45b2b97fc7421812bed4e381cbb9500d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a14b369632064c6b87e7588f991a1cbc8faed683285e021cf223f8b9fd7f27af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af7b7cb277cad3a1d5a18b30014ad4e1b496a0911a297c9f05120200ac7baaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1647c45749cde6c667735322beb2ce37b2437d967b6701bb7f182bcc22a8dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d79a8ebcdda2726ac99717b2c42a14b36a65fa3a1523ae05002c80c1139340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8f4f8fffc8b8fd96b58dbc85365d7f34207c92ced6ae66dace25132b54768a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea493b759506f2fad004e7938cd31d5199646dd48db1dfcc6e8ffff6e0628ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f43bef5922364f3eeda045f7f8f595c230c0954caa69005621a15928ed63ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4625af7606d8615eb90fe58793c44d6b324afa69095db92bca4b2b02358bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1c100c651ee53f42ccd66a51a9c4bb6815710d7d2eb9d3d5d2ff2069524a7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1840f81660e86b5ddea39b58ce5b52329b5c1bd9038af11a3644839962b3e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45e3dde12c6de3492ad8769b6ddcad0e93daf82fdce36e4c4788a5f4ae96c4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782edef1045c4c064b1e6fe3c2859110072047b5dd638e57afa6500ec94dff34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6fb1fc307209ade54016f4893a3999499d91aded3545996a3a97fe1c42aacd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff4e017179752ae3820ff9d9266c2ff73350342715c6aa3aeff17363fdb6ea4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e6e1cd97d8b521f73d613f524710dfd32a4be4fcf51695d70db5f7109f94c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4229367685e0daed826b0991d63947e076fa56129488bb831934a946a7885c7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e81f895c0f8cf5a2b8ef43599269068766d64d01f9c7e0262feb21ca53284a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984cedcfe7bd3c9ca355cfea900afc4b82c9c67c44412221905271440a9a7d4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00abd42e2d9ce1002af99cc5288cbcffdd01849284cead74216f0c27fd43b0ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926ea0328b109d56b0086aad1d3d28b8cc729a064da8c31aa7358fc80d55b1d4(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19d4770af57f53af202b0cad67d9ea51dbc5998d018cc8c143f26f76dc31626(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4880880ecdd20610f39267c9d8a12e72bfc3da3892f33a513cd97eee030eaed7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d817b2e459f52dac4cd02340571c941a295bad32c0e47f5a1071dc629fac35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df31360d5c3cc6213eb624001c62f14b40aa373aa87a65342bd31f66d8695317(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefda0cc8f89c0097fbf49f7115ba26ae5b04ebd7f9d1eab33c6bbdd514fe698(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c327596d3078de89d07751b751e5ce8df95e4c36b50f92fb1a1599167361fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e753c8e1f3908b07ac8bead598c35c32f432b4d8ae4a493066d407ed347f26f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ed55f4d908ded2f2f985fe6c84f3eb55f787049604627b259efe8f1ab5057b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a9e173c03419930e7bf74cc9d57fc12ffdd1234985a01ce484752cebdedd7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eaad5532553cced41eca0a8e67ef17b615a7d43046503dbab17306f959fb855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b59bb7e3f1d5cd0518c5c0714e4ac55bef37e6c4ded8be18d2364992e523ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58cbf8980e4ffbae3f47878c4a2a0b9f509338ddda825a34b8e6915486d3614(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a79b30e59397b1c0467efde189c7f546957ac46b8110288d3ac90e44a5fe0ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b21fa90961dbd4d482664836a98f3f36884b1262a96519345358b0416d2c39f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e0bc67b9d2edd7c8ce92d1456011d5477008e13becb74e880c0e15568c53ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b8470d04f591e1c4c3da9f53a923cf7b7aa5f52d8330020a722e9a3a3bf3cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c50947d80cfb4ebe459827cd09c17697c4368c48b7d59149a3fda63b0be0453(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c08161d4fdddceed68e0ab2e5c8e22e0b9cd0bfdca4b331db708e3552eeaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6b0bfd71daebb9fc32760b69ab8470b8020107be8b94c298be4228f00e868a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec187370666ded322f431ab260665309792c03553550e0ccb36771657a63976(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b63f04f22934079b76d7baafbc0bed07818ab8b48295000121d93515662680(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be3e32af505d2fecdcc1c11a27188dca1a8d140d94c5b38ff8c016f18706255(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e6caab74b8ae2c6f3f10dd112b9eb21bbfe2336d4adef4dd828b2ae851adb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b875bff9198071038d2d37d33e6efc91b8606d457a14174ba1f0743b36d4b4a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2faf0ae44dffb90f5f1bb39dec669319500a6bc72752dabe726c99fbde3d9364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5512dc71b382ec0f93ff2b0c11d1ce783bf9666240edbc3b6115c1977cf53cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba08d416d342e911d7c7f48565f6b4dc300f6e863165bc7e613156b60cc13a1(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99b63bdf559a242602c03854cb7adcd28bb6c58bf40eab221f63f526bf329ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce96fd11c34d209c6dd1c49261b8d2885f09886ca2be8e1fa621dc42f2004b72(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcab56e542efa7544fec8eb8b23ea2df0cf51387b14a76f529d5d4a979649b71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f84745a242ab7e2773a37ac97888981604abcff3fec023762221d3283e005ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cdc912f55191b46bfbf97b5f604097b15c73dd0180ea1f42613abb47804d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd9601963b8747d45f7199696343bad9a8d006d4cde823780147dc3865ac513(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac9a42d37591a1190fe965667a41736a9845ce3b19419125b9c164bd229e218(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2142415d0478483e923f45dc8bc87e3208e93b03e1e585d46d35b6471e380dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0b327a10af48b132b3a056d02c5594b482f35bca8f8b0c5207a5c9a6ea9d45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dff430060a8c0b14fdf03fdb00af4db430cedd115a6a20e8ef5fe20c58bafc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3197842f8fafe8531bda8628e46db8bf65989c1217445d560fe0d8a02d36327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9293d96f111c04b1d5e59ff02feb2fbeea21acacdac814433eab1cc03fe5b3b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa74aee0964e69e583bf78f4770384064d975431fd6079becc6f4254acd65d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cb16bbd979af06a6573798ce862ea79e5c7e24751d18ddafccfb6042d2d8c05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0134a60f84b2c910a507e47a14c3b5b3ddb89b241e4185ede273f83974599dc8(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02bcdd0936cf2a726fa55b13a910a0800662a1fc2004241b3f27518ebaea56d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35e6cf96fc5303152a3d278265533d53d416a40e478b6dc4dc20e0541f02e35(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8e6a98b6b3947292f4c18f9414abe99cab3b82c63f2a349e774594c60e24af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c39d01c5d0836d96b464df1cbd1ef928d67d851871dceb74f28906c34dff6b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b442d1d9abebdad22395dbe449048dd0d97e143c8da75f738c2ae62d76c61e2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149c210638b0fa5aceb01bd02526df5c9bb5d9f9df6c5d217781180a24379fa5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3547f1781f2c2eac2d0e9d1013f10c5ef7e8a121ed3bba5a4bdbc5e4685f94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d029c939571299b7d34df42ae9e762381962ae98d2e736cbb55c46bc7612e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab224d5d0b344dfd412aae1fe884a577d3e469548e9214e9da0621ef2a08a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2506dc49c4356893e28747c36ab2482e512c9d100d21d4e17df1f136a36dda86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ce0858039c038aef722cc943876205737d86e51f4ebcffedcaa786c08af51b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6613c4f79860ac6fc2c99389cd6e660b72745e894aa1c6f917144bbcf3aca3e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed65833537e7f034c6b86a133c3fe9f09a7bdff28b42b38c7d40e0e4ef5d952b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e8293064c05f293ca85b2561b47e45b6d9e9ab45a963c7a68dbe84ad131cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15d9f453b702c13e319555b5847b0e155912a240debcacb05f6850863c9ac6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3102e862b50b8ca4ec60696e71cd68065422b317c746e8d68935875990b1c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b79047d0a704a3a5f4bfae7fac49bb140316f4d62f4a78bd88d3423de0afdf6b(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d16d9476ba1819b7d4015f1d2c4732ac2f7e66149e9cc07a8a17e0a6e6b74f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e9c7251e0846f2e72194437355bfda086fd87d0585c0964a2249cc4e959ec33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948ec6a9269d963b5a2b5259a1de9e911d27296f02ad06842c5b0528dee7d977(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571e16256d1a8878d272d42152832defb6fc4687a6230147c7cbc368539ef091(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d91e6181158597327871c2cb3c83ee74e49b544444a0b4ee4232c13ce466f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d119a5dcac08cae5edcc774cc20840dd17281a58d549ae0fc9dfc80da19910(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da7863ab055f05055f83d85f2cb9dc5a4773a5596607b7778742ed2032d3f97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac9841840ee62d795357b943f0e39948dcdb59740793a0a2a32140619c03e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa90c2a8bfadb4872c76380160c4a8e4a3d06902ccda4209d9f064a90ea608ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9afd5a26b871a6ae575e0c9d3e9c997da44f121f3881ca143031abee66b9f5f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2f1077d33460358dc66029b0dbf20730b36f607e667e15d8d9c7f4f7e25b31(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52ecd512323b34141661a7b9dbefe1d6dd5e6b9eacbb239b8cbb639b444e669(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd06ffb59dd73c132473232c353fdb6f62e021fa8ca2bc9001479f0734a37d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1405640738538bf0a509a0ce8146e38bf7a4ef78913f6d17b90fd8e9e2f250b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7693c08ad1df9cec0833fc413ad9cf711a3a69aa1f5366569a220f285d9c0a2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd585301f4275bb1390a9c9aa7c8be3aabfad19bda8fb8766579c4e8379a7ed6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8efbad76bea331e6e8f4b6414bf0949cdd22d845b3b2d7373e4695abc21e93f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c90fd03203a6e5025772c754b74a82298bdf91ce8552c3ac0287b7614fa054(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba1b61761f540636f79a2f4b9430e2c0bc909e2e81daf7a824af94cd682ae8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860c0ea09e1b300bf3e5c377fbc4a2bb4455e4a01811d60b03584e5f24711a84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7671f25aa74f7ff80a658f36e8d4a6165c0d03e9477bfd24b7ce5b9c06bec86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49f812e989d651cbff162830ecbe5c14bb2fa6ced84d40d248429ebddfbebf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fb5d7ee07198aa55cc7a4e3f215033bb93e7197495106c0f7c9284c4cf6fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833534374d3df6a47eeb8d181a5eb8e847770d144cdd6de23a35bccb78a7e148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3684cd0b1a34d2b51f9a1147e4b4eb72dae0610277acc11e38fc53ce9ca6ed60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5cfe4633f63d36d2e4fbf96616e77890a93fb7ccad8959789df224871361ca(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0761e5b312fa9ca33f2341815fe14eb4b001e068b4a15121fbee311074b06a60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45623c19fe8d2f45ca243618427b5916fcc27a5ef5ef8a81dd8968a7b268dde(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473dcb067f2c527d0e30f5eb20aea19975ed1981caaed3d849f3b24f2fcb9c30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc45e1ae5e716dd6f327c1808c625fbca5b1b0e8e65ef92ab072e782a06dbbc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbda2ee9ea986d38c6ec229eaac2683bba1a6695f0c7ed253b77641c9f223eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a77df836f16c252d41c91c15cacee79b8998acf95f5484fdca4901ea17780f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f922af895d02ae4d3897f5c386fda894e288ba75ad129faeeac0e352bcb140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aafba36bd46293acb17993ca43bd9a7324a3cdae98899d18df0f0f6e907abac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7bb225e1bb16a238a622827f6723fd31bcab8438e5614b6d8c491149f6ae40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d1a36317a4053ef7f997a2ec4f011f69cd58a0201da81fab610794e113aa2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690436f27b460c377c2a22a0020032850bd3b9ec3f9427e435123c3611084a04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26cdc869d039d5896f9ca58f3c1b456e4eb0800df22a25f085556b4aabec7562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23da5acb4c28d10fb8a4a02cb4c7cdf99eff9db198bd024eb1a1e63303419562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eec2bf6cf1c951d639532eb511630695cfd1ef0ad9830d4d942b35d549c3f2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21dce23f094ebcde4408b635f5ffb65103472e2c77138533a88a538672e75305(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe397513695c4a0d19a1d05dc857565499e2a01ca776f01c9fa30a6bab69cbd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bdf7203a21af3f1b6b8a78a4994c3816af839e04d04e9b0f0a9a0f33363bab(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b418e412f53cf0ef9f30c3d7cbd9f2c1c4464a7e5c6122ffa3325e1e2fff066(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beac378e279837a3a37b1cedfd74c4f6641a3e7c564e80bbf483aa3d43f40590(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd86b1e74b4937d81ea47d8beb8fc9442578094155e7f5b166a3bfd32c25305(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a64abcc4f7c75550149e70cf857f92f022744d726f02403f525770462fa566(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e0ae43ce4acfe9bc338e277ea03f41a39ca0537f53c9267bca2837d9365524(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123e22e77bf2e2bb9eb97e9860e2506e7fa3dbebee2d7ab2f18e23ae8466e797(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382b7935bb813f4207deea537373eb1259373560cd2d32bd73b8dc67d879dc0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928b62d5467d209bf196d39dd4b2cd583008a9349fde529268880e916a5f7efd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3077ed586054013ec3a1549f2882203fcedd9b0a3c692a114435ef373007dfba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c8b6814bed6ffedb78e32e0965b197a0bdd0371099c4e3171b33916649d42c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0b2b28e066b43184f657a743297c5c1df94aa5f7ee400b383b64459267a4ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2eb269b3b211ebdf0bb2b7fabac73031cd4edeb457ea0f7cdafbefc5d100b79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d28db5d88c2e3542c8e7540274ab1c0c7a1da40af71c22a33d8cec4581852f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a242a443848fd0a402b3f6af4e6e1cc092a03512b8c5737e36464696f2a3e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e59ecc9ff5fd58ccbb3be961eacde118fa99c9298bc6fd350154e4a40446fec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879bb8829dcffdceec393aacce11fd49257288a4c92365ee3f1d0ef9737c00d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3dac84f0c2194c882ca7f172d0464d293d7c7ba730759c13909f44afcf13287(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902a49acc880085bbb1ff684b204e5ce1c2b6b026746fdc6be4de676c1898740(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35bfa4a716a7af2fab808dc0ef0bf71bdc2f40d590d41570db30d1d0190559dc(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7b249f9458f3850b99ec89a87e2cfb9350b16a9462f926c589a48287ac1af1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67757766e2066add1d993ba633e71abf14e0f3357eda3f795b9c1d47328701c5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd7c8877fd91bbcec1a0d6b0c180aa8e8c344f11271e761fe6d3d90a908a3f88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1537a385f276ac8bd0960ed6ec30b80d32f44625b36da4a993fbcf5f5f8bb4db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9856237b62a09cbe3bae50a35a82690eeb5533e771a0ba58b18275fa5997c574(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6664b35445bc9ca0e746c98946d2a4f730701f3c60f8ceb56f73a37c71066e6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c3abd9e9e74bae56030ade6fdd079222f7aea5d24893872a76da557fc19669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6729e39860e4c9cc3869f576da76b19595dcb2c2c3559c2998622cd567068b2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1ed55a24a99dbe3d4b5a62cd997d176d0409bf3119ec7a7351ded33c2f3ae6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23721e3d737b6106f4ba64334594d67480603c21c1e61408d908e4189b9c2351(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c89357b3fa3e6c95fe4bf19d1f025d18485d1750b7d0d2db3efa40bf714ff29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151eed844e0357af2ac552937aebc7b83799bcbe1b6ceeb2fd82d9d8590b274d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1abd73480599e14f6f40118ee4784a3a9440847b07f92ab3d11e9f769b48c57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398d0b5957e472a7acb98808a863ac44afd244d60c17c0e0a15ff569864bbdc7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f0968078116aeb3192aa6c09e7996faab55a6bfb9a1c57df84a4440d60626d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b450fdcceadeb9e52db6ba1c223a49ef22aec730fa7843850065dbd7bfcf75(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d006aa1804c7bda610bc639783038b6b0bb0a47e7a1b053d75148fd7344e82(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ce4a57a374446c88e5d808cb0e25ed9ef0b0003d36ebecdace9feb5e142ab1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4243f4da027a146928a40d1d2e43597014c68356b257ffa904546bd60c445f0e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff72610e3feb15cc744f8b6d71d374cd2741e3ec0cfa788ba44ad57aebcd12b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2d51004dbee160795cb909b6b8e1a01b37d910176a2441ebd73d551b865613(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a94bf5af36462a56b522c5e1cefe21dab10403b148bef3dad3a53349873ec2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60545c0d1d17d914cdf01751b7891d1129533ae4b5f552259c24694e068196d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0c3b41f8dd1df0fc72a5d1ff5f2e2484ca89b13a6ce65b0880471a70b8780c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903bb61b0d25d25c87269bbbbb72b020436d8af2cb98eebe931eb55a485b47b6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43ce54cbd89b64860c4ca905b24926384a0577137a0ca8b3386a554ad8cf771c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7625252de4736c4a7d4ff19f3b8774173f147981ff4d9d199b8a78ab019b5528(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f00bbe7b3e359bde5fd078b833a4a823124c2990a7f437603c824842ef157f6(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c709b27ef3dcbb902b59537803d46ef80651577e88d1ace037508f572ad77b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0102212a11bb6fe1984ec6ae6d895d88d6a05e454ad04ffcae599ba1cc3c69(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7839f6949a47a18cd0f2838c10502640afbbc1f5d4885374434871c04962019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06cb45aa98aa3bc4e89c31db7b92fcdbd8a978809b335e29a06acf170ee69d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6066cbc8b07b609f33eba3bbe6d3252ce811b5ed1f71d8ba8519686907ed243f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2b7810587e9e5140e1e1cfe641c2b076ff4b25a4ae2fa8305b17338c9e951e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415a68fb01c29dcaa58de1308cf116c521c77272664455dec410fed20fd229bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41629485bc0bd0a0ee2003d4bad8e41ce10aa8b9d8ad33b7807751b7ee60ebb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c5d4711be4597b1b5f0f54d62b004842a919def9a187c643244872b748f119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dafcb22f726b4fd656b2bbb0f59dfa0e4a623e03478df042f79a636f54e3415(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f87eec6f5538c3a83a9ffc30fb2670cc2a012838fcf8f5be3ca8cf2a67041f3(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826c099da80c9039d9ebe5e6c0c2bcefbc309d17d9c6097dc75ad6821a04283e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4454b26876246cd1bf521618f82e9d814b9c1c6cef11cef26f60ec76573486(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3424ea7c4d2b59715ccbd600cfeae48fa4fe4f6663e7a536a97e0546c0e06e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd09bbd7dc2ad89c70995724b2655564e274dceb57ec4b5aec2b16d21eafc3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a48a6802da1a24adad948d352f64d1726f7e9955d97e0a7f64b7f9880256b9f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41e89b05c23fdd43fb87a8e0c215f7bc8d032beee87affc730215e39b83649f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fa6ceacc7eb0ae533653b7d8759d0d4a2caa1684c38e32df0d660baeb0796e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380d9371fa1e1da28ee21e33d3dcb1df89943391bc6536642fe1c70cbad785d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82cab287ce30e97b89fc3cc1394ca42963b0dc03d08d874deddfa207f2d857c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3cd578441e65076184d1a661247903b484532924ccdc3712e6eef730f1955b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09102234299de33f2f19827c1350db3676861475cb2d4f155ffe4aa7f2e14e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c336d896c1438360b0b0c86d22463a4c6ff84bcd27dfd8e724a7de08e10bb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a3e5d4cd7308a0ffde4090f6067719d7a5416e194b27d1d3e460054acaa6cb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0472de4ccad14687e5d3026981c77b290d7bd6f34f243007718cbd0855cdb978(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952ea353036f9609bbb89c37069b3d9a96f8f899b1d2609196e0c4c53fb8abe8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23593ae3ea3582cb1d54e815622a684229c1dd9c4ceac3ade91936f6de772b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a96f61d7d6e8f58122c3091c5a927650f066b321b651594cda75780487c238d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64a661c1915bff668bfab2932a0dacd9d603820cbcb8d025a7b128b3bc0c041(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbe90a636f9e881c8672752d164f0d6e5b5bd0f568fe47af5296ad68bd65203(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c1abdd2f1499fbc26556b709f08826d87d353eacb2be9fde05570dc8e7a662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b847372234cd05f5e2c1a4b6b703c0a09c4a5e8d49e175230486d2e8ee69ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b065e01e27b24475c5daf579daed239068ea7ca94b104adcc563f8b4fec548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06763adb1cb12cc3eb0c42300b2d1dd00a84d85cc911d747530deddd54edbaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193d8ab497cd30196a3d891147bb4ec98edde82201161b035d4de2e758b8b8f5(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c60605d86fc4be07107578664b40790089a0475dca79a842c83c09f87671d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76156b2dae59aa71da20a930d93646236a029bc5e581a6343b5972b9dd0d4107(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3889d1820f6e1a29d688425367a1b45e409a6c8e94e1d6b29348001c447b38e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f362a4d20c58b61042f68017f572561afd12ee04d2875ae16c35c87356294b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf90688d66ca9e0a81f0d73c4a47252723d26b18c43a6d6e83d9c40aaeb060a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442ec6dc8fa4f8642f8d753c0b13bf581979ab5ac1671bb8cefe428176292f3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87349a0d6a1aa7870aeb40c5de1d84820142b7a8552efdbc156f549820e7ca97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84aafbfd8fff736d7b2c6f4a3a92f92eefeed51061b6af91f894868e36480f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f19faaeb72cd41be209bbdb0e210a0c5a38f012189a97789d87ca03b7530ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3d078c81ddf726f4dd0ccb15480365dbfa3941c44748f84bb26514df08c4e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311597d187767cf75594f1a3b6cd2c60d2f5c832a9ba97642c41640787ba2163(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2f49f389e59ba29de022fed9acbc71507c5e86981923da28f6d79711c02722(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ed4165e0152d91084a033369413051a14ed20cc5ff6ddd489c0c4de1798bf6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb0fc5925b2f26478c1f0c68a43591555d6aeb88db71eaeafccf983471dd060(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae25c43dfe3adc172d6947f9eff870c3b8a8a143cf0a4b9c3255c65b5fc219fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d3fe171ba425f3c81784552bddc3236815465ae3c3b0b9d5d01768a0d1193a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05be48155fcfee9e6016f75551f490f8756a2e3c2eac32dcf4e6c19100c88865(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce6c57f2d321f1cc1f5189285e712577c7e52067040cece05dd8c10e50e90b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c4b82cd38ebc17bcb6dd851e5fc37be748f1b008a70fbc7b27fcb3bca250c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca90a9c990f69d188adcbd9b695eb2d15865b5a6250b69fb444513ebdacbd495(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bffd6a623c437cc87a917e9996dffafae8c270a195ab66a1994f34cee853c141(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae95aa745497b4282e1f86e115d0569f621e79817d4a3569d3e9499b276e0520(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0f92b9cae48651f4e016541d83c21a24927e57ded653757ed6da5fd5e366d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eadb8a2a3cbd7999da1877f82070c9a7641fa2fe35043328ef3a474506860f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88bbc7200f4afd0bf208810cf06358392197578c39b569ccf6094993323f681(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47dcbf1e84509b67297142fa09deff4377fb76098eac206bc3e10f604575f6cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7f78ae5386c776e622fc07db5415c4713435dce1fa6194f6c765eb8457cba8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__585469d11bcf0b564a017a033cf84f746fc04c477e6f6c1abb908b9081e6c1de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c88e0c4ded7a89416620552c5067f34146757f758055950c995e6e27f0ccdc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ad2b8fa076be4b06f97cafd0fa7c82a54b98e01efff8c0058bca2314c5255f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288ee8f5168f2262b0a652f17aabb0787b07e3e7d63a56cb2809215d29c4465c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0749fab3e2ba86302d068a11c9c82eea01b3ddda3b6e5c069f3a8b67845305c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9626cd79a0056fb1fda4978d2d1dfe3b70762c7f50f633bf9e65429c4ac1d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a3c7a427142f5e077721563974054da786eaa94a41835877c3f65d58bf4a91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e18383aadae943785dec21095273a77df46d04b55588fad79b56bf8c779d28(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29c7c4a023364000a00e0700f113d827d2507a4b3549bf8de2424a2c4019785(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74556363f5b64e2f067ab2fbf54f68d66c1529b8b4fef45e2f448beedef051fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163d799daebfd5b8d5876a7c47ac6948ef8002350e15f30469250d35e83f942f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b33cd50ea9bc34a4d9c1c8a5c29cd0a52f88c00f2fb1d39d8ed7def23a27d95(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706716f44695b57ae6707e07cdefb48f8bb707c2db95f8894a5e65e5c9f6a890(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9656ec47206e98966aab8a4428ba9d2e13c8b20329ea577581c1d9709e69ab65(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4896232bcf4222db177eea758524676014890b2d00c0b407bc48532735860c9c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d140623d5d284e43a2b91f4ad8f335021ee9a067ba986fe505b1ce7883bb159(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a1fb92d09328844a744413fe57d8a18aced11b46ff8bee50a694cbe1c550e9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24fb38b3f8830b5f0141ef1f36f85575667aaa07da4fd54801c31f25c5a8dbbe(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e81a65e64eb44b1b5096c8a6caa887ca4984c1542717c90b90ff740ef28432(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026c38491437ab7d09ea4163ad061e2d6238eb31c2bd41e198ff279a1cf71cf4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc9548eefee6be58e395bfcf7495ba1f09841dd0db5c48002cb4228a2b608f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd1e9ebe4c62d3da1a50531931fcbd18f9b9537235449c230b45e78040dcc963(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efd5ac344533dbaf47dc29a9f65c0b84d00750d8abd867607ba91ef1cb443cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcba580c49a3d207767eb934722d270ef0c84c0ada38c3183b5b8c23a2f3e2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a373d4f5543ae391dbe70c8583003a74341d8b3daeef86a54440dbf507a4e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad337cfc7d47719e33820be1a800f8c63caca7ac27c9e6bf3053cf0f6895da1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43ddaa9ee101a7b3db1f5f58b26382118b3c7e0335aff998618b06081b25acf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c81f0e1f9a34b4fed9cce66a0224c4c52dd3a5aed5d363b2c1ad440dfb94ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b8d67685b3f2a01ab4e61e958b8a4d2347fe00b1fb5f8cc784cdc9fca390851(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecced1954045eeaf9ed1d861f3b044e366ed7192f55e26321cda791431bf4878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c1214d7311fe65db77ee244027e9010b43fa41e463aae401acf5b3fc8d9a1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ab0fd6e8365d109eb908065f485531f577c83a6dd70171bff8386e8eced2ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06953a73d011ad9067d7c10b0ba6252706b9eeb12e7d48880a8a2f768a33199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0327077f99fa101a280166e0edb2bd6e7f41373b868d8d36e81e0889b4373324(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3854cc55aef637d84d952d9755e7e6b45384ed8e1a4014ba61b4f91b1c8e1687(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d169d1445afb6a6ac1b4009ec8aae9eca1f84aaad9a729000abdead4a6f60b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09214f50ea7d7b145e839f2e8973c1f90dbcabf04656424fb3fc51b4dd2da805(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1eb430f31a205e591552cf97efaa5644b0a8221ad45957906c53fe4cfe3cf08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7c70bb6cd7a6904967982ab80396b0cc95a4062de6aee2aed399869b47d4fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb21b9918bbb0e939e65d3e13bb700229174f2d6e3f5e2cdf5df0f66427092d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a2fbf0a6407127adabf2cdc1a0ad4a288d4f1853a4ca16e2ecb41324905303(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73deb140416e79890343f14ed377254bc9caa0ac6235873849d1394cbb968239(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b7ae6e5d1a5d3bd3d8fb8c955ccf57e147ea9d9c452d71a6341d5d2ae84796(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d8afa199f0bf61cbafbb998b51b577897edd9c8c9e23b8bb1981e428e2de0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdef3c27d4a95a13853036deb8d8d777a5f76e45d8aa9cca2f8b5d0a8f03689b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f62162aab46663ae4f15183d832d4f103c76c5120dc632348552b9c486eb4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b104d46d70fcbf87511e2dbc9371a180c9f29fff279c0d1c151652ea83334ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb84032f42f9915e940b731dcce70d4c7e764ad60cbec3397453fbccc27e783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8387a0a82c39a1a883886f8498f701b769ce78229bc1c47dd68f6ac6a9b4236e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51033a692a34494ea160fe89fdbd508aa3021d4b083090f536c55dc9344f1b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01106f4e401510c2f97b4ecc95dc64864ce09c2b3d466f19c85c148503248aa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3736b635bb71e52a4d5a66c5d0f92a92f63f4675cae7f34183540d54de4735e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e224bb6a2c70e6807f5197b9a11463a71a452b942ca2866c1f9faf91576c4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c777d7cec6e18316cb62c0da37f789315986cdafa67675d30ba2a895e02c5dd9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7381ed0e94999d27968a32ad93099c840afa323e189c0e08f96145c13758ebb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5a3240fa18b6f6c0c5a18c4a1b05d3e6232d04d31d4503362281c92ba27ce0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42db017a2058bc4992729ff776a402680d9d4e443b8f9db571b77de99dc91f80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af98d9717a4e2f69c22d375f827c9548b4e85550d8ee2be4acf14ed15c5fe09(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8097a0b69922f1941c5d5bdcd2f98e74567409d9fde0eb2128a79fa6fa6a06c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7a26390903d8ea3b47f0f3800aa61a49596ff46fa939662caeb254562afdcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cf778482f30688e050e0aa1af69abb7abd4473d5a9ec687d85687180425dfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5106c011b58fc970a7b668c2991891b96644340467974ee874c53a45a70ca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1139b814feb2321afae4331e31fe2c7074df04996bf78f8d970578c5719d09c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fdb88ff3ade2401dddba60e85448ab6e25e88d7c1ea7e03951d21d9d1da2355(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d68f435c74a8e3b9a537f39eaa3abec036fc1875f1c0b37f573e138a396290(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386fc789132f8023a862d278b65bd2116a26a4cc52ade3a5f6b2d83faae32c6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f49b41603b790f1f78aa0d68114841d2c35c5bb91fc2c7713003a1d7998a13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5673c7776d669632448aaa878f6aaf6e291fc03b693f6729c9ce97ebedb30f8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f807fc13b83d5376666f82791a068198eb7978b8168a07e6f0287845edc74198(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c10bf8996a8cfd101f97d78967b88ee25c58c9faa928c0ebdafec85370af36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af4d7d475d9b5143a559259c697ccab9af0b6f0e32c7fc7a3a89a51261a2bd1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455bb5a333619dfba69b384e6e98744ec86e4cb9dd0722840b6e6fe1e259e18d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c39b6e032651a91d087be29a857c507acae0c36c6bd19f04526cfef9e8d1119e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdfe6301f65881ca3594fd825b7087b5637276dda8e56a7526cacbbc3e88c523(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90e452493c35cae341c36920b33a006d2918fdad16e3f58adffdd9bb14cd745b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420a8277e50e2a477783bca9de9c78f5c9e0935914eac2851ee11388ad5f0d69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221b0da6972467afc57f63e8eb0ebbca705809465f37153fcc877c6d33509834(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8727e23a3bcaf28aedcb3f7b5279b9d01fcb588253d472e817700afc17efdd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920032ea036f9261cb9c231fc9e87d794d335d6097aa833a512db2231e8e3768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8c36c6c01480d2c2922f4d298f19a50c4bc103b7a98b3f6bcfba70a620c1ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777db85fd76a0d4feceaa43bddfe7ba059923a12ae1782ab507efb147254bbad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccb0512204ff1a92f2d3717329b6461ae7de36959eecbaee2c0a148284a0456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4535ce4ec844006a702bfa6ddd814e3ae67cd5b0dda89a769f869585f13b8be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7578dc7b8a40f1b171a55c4bd61c11fc671166f128b5ffee58e3630545269345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d703c196d21e916c5f362162fe740fad55d24340580b7763d610bcddc94c41de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42dda532fff06bfc4ec33c8ffcf69901b370978581499d28c84dc4f869aee30f(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b965a597c5ae70546adfd2f8439a37d81cab9b2a83a9724b398beb03ce6c61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9a15ff2c7a2530d1605c5fb8686c1cafe64e2d047a1a4aebb93007d2ea4283(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85eddbec546c782c08c1cec9eeb5b3780f5f03c8f939a29088c2fdac044f9fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b563ebb20aee2226889da74993187191267b9ba81d5d70b047c93c4792ba7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80215c1e4aa15523e3242f020648657098a63900beb12880d3e440da20b8016e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b74114de0f5dab40a81701925a70c85dbed559a22e9f781fc360b73879a1ce1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950dc6551306c6a5352872cdecea479385c1614ada3ad69d306eb604df3448e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce76550ae06fcb82dd9fe006dc103c335dc907647ca764d5a5d499c87feb5ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f01e8808648821caa3a156074e005ce35be2c8a16f27f8e919f6366e900068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c82afc4980f71136967f7df40bc144e6d9aea440a0b1ef22bbcb7690d2d43b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791665ae80dc50762358add4e3cfd3d2ae25ec6729c0fbef83a5ae60a9c239eb(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5341704788b566806099d1fac5889f4165db57e4055cde3c5c53dae703dca59c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda4421cfba6c568c759c4d821a047ee3c17114060d1e6a06769f5991ea1ffed(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e73697db91b2c1e1e3c163ff6e7112879ce45e635c633bf51a0186bae46570(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f07929cc756d29d3fd1ce654a2f4c9379d58ed9eef77522d9b432e7f93845c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf7e48486192a42bc9d8d484e793ef05b72ec631623e498e13328eefc1c96d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143007e66970f21a581ba66b22370b274b82f8e4c6b4e10a8b0591c047213344(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76585a3d9d8f86f360a6c82472c954c1cd54c174953a7292b0350a82ec978274(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f88b6a14fea507968f7ba109a9831430bf720384c9d4d9ea6ae87f1b693669f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42794e1d6ab910af397c7d80aee764adcafde1d00dfd5d85bd961e80ad634d66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__856275299d0d63340079b70a9ff2181da3c59944dfb07e6b6e5970e8e045b894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24fc75dfa0757292aaa8dd6458da6c2179be6c8e1aea1e9002b609d544b8e37a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02af3967f37929e8b7507bd387413e449f98585f35af86b83e2d2cf301ee6792(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9ceb193c715d551a4d901433181e6f5e6fd77a4df2cdfe0d6ded2344b9df5e(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6015bbb096e6e60205997cc933c49e12081a37051b2a580359db7c97b31c5bfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069f1f07422af6e69c5b7426fae2caf54b2c0e0693840818d66657a7f7d9b649(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d91843436b8b91b3c41d7d537288419bc5d2196da02820bb02e83972dc3d15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08bac2d2ad2b6bd1b9866de6b25c083fa89428c74cb7a5efb569a04b6207834(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f54dafb02b09063b1f3d045bddf6b4c06148d45e768bb556a82758e4ce95525(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f4967cf472055ea2fea81fd15e9b4e747b75ece80d1d4f86afcadb5b19baaa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e8a56e995b57b4186952bcbf99281c18efd889e62eeffe0ec63d2655352362(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f633156499005f7b3e2c3dfe0cc157bc0a4c0cf32a0be0ca7d63f2c0ace83df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72fe6ac764a44ba90f26ffdc6978db5438497812776f81baeda97ae417ea057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2b878891fb7c1d172a40aa778c13144af7d6ee0e1c264f14ccbd3dfdf88587(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255aba0b2ea39b91a97ca6ef5260bbb31207662580045563e1f39f676a7e7547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65bd001d4d3a3f3a4bfb4e8d59d870d1bb7be214b0cbbec42198a040b9753cce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbe173d2e832d3b75398c4d015ef5daa81f8a4107a1cdf1b6d7b3617c7020a2(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31eeb9570f1fa0007663aac7a692d974624a5f743340912d981f8fefa6c06a19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c43950e73dc88368f634d5ce01e950d1f4baac650b01631e35f4c0bdd5d8a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6d3160dd2fec19723dfff51400d40933250ac5f320734f16f71a79f39793e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d34445e916540194184e3711e7804a8930dea245b22ac5d2e75f2f623b9521(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe9b28d2097fa0c4dba5160ccca8d89bdee64452065ac592e0c1f7083065f77(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd87342f44ff945d65fbef2029cb491832bce7d3ed6bf15418669f6727641eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c936fc9508a778443f6408accbc0c68d1fb719515afb3f0c8dc52a0d1e82c68b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b71101a953f800cc6b7ab491cba4213acb34427eec52794125f6b0bbd777a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c3e3385f05b215640336f75ced63f7232bcde7cc876e48bc0bbfcdfe80755c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2eb16bb723e7dbdbd104eecdb4486a34f9ee7c198c3062cf2625117d0cdd8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75540a11aef1fd4d3de447368a6bed87a667a93fe9a554b9805bdc53bf01e6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbaae8c27552a215674c65a19ba81b174b76407dedc78d4ff8ddab36ece95f64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ebff34ed9761110ddbd5665a5baeea4ee7b72325e5cbefae0b479a6d8ecf5c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e63523beceaea2b1c25134c3c39c18fc322878d1580e84c47137cfbf0bb09a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f12e081a84c9e1f6e9b5b113cdc9850747fb414355168ed504cd562d839643b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6574924b371278b84eaf9beedd89b248b5436765de368cca28f2d1c75cb7f2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5fb2b066b93c088a853a2ff33f4179a928cdcd2614efaa582e03ef187437ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5f6b4f545555c2fed7e64e2f47fa361a6fe125bfecf0d808ea7b7af7fd177e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9554041d830ed79fe7deba0bd682dd57287b828a597939f74f08a37cd57cb50a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167d39cb6e1e2431ad04f4cf00a7e6b1ef41efca26898fd5b9593f655ba6993a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b68c26432c271f3d01f4b52d475c3a2eec9788aeff9921cb1df0d744e036bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a980e18fc9124cffe52d5fff93c265d4e386b0808f098811a1140791db78ffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24eedfb4f7674887e147570338ddb60c5ece5b40615d3907e50477c527b901e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2cff4529b182eb384a6c049570077226fedf4f23e5997b401458b8e8ec3ff30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6274c24085f8db9a0f40a8457f323b9b92d0011bac680f7c99b1c7ccb447c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6591f94093025e9e4fb4b9b2ffc48118a5defbd1b418d2d606efea57dfd3d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fc9b885e620f5d8ee7daf7c6748578c6d644fb28a3ed86c26706630686d66b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29dc36ba5447f3dcad023d34186526920dc6e2bb562ad3b2fe5ad8145c93d33c(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c100b4d6f8bf75f46c7fe9a5a0be52ca3c18126dded5cb52a63240c47652af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04060df682932e22ed6b2e6fc1d101a79defec923787a539daf58c8509a40e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f38bc84b757100652b2b3ccede88e57152cd5e3a117eadc05ee7b588457d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b21f3d0993580241cec5da44f9cb066b2dbca7274de797087adf0f86aef31c5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe935b89c58c3acdec956b856a95c64d446cbd65f90de8a3889ce942119b4751(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be64ba972e15ee7a39217fd4f841af64335cba98a5e9f72f87c137b33c58e65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55698f9296141a5bfc0aa43fd0e422e4ac109f95730dbb63ef69e94ec247f40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b59257f4ab3ceeee3a1840b8abf19d927752bfe43e80bd58027cfc462a9e40(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365c54634a2b83c20900f3ab44284fa2a7bd129beb6a696f7a3f9996ef3be474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1803104c0ff1fd1ccc22609f7d571a557d668cdd38e29ae828fb033622da062f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8c73c42a02f5e53498a6d3e5af28033773772fe449ccea786d0a6251c579a7(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0dbc801bc0ec76fcb738c474a317ee77fd312ceb3d60a75311126940a13840(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd474f3bc7c3aec4703e25ee07f7f831982884db1b89b0ef0e37bf2d2fe94e38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e5e933a515f25ef0c7cefcf3f8db3480a60872882adbedbe5ae2c57dd69789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f2a7e20d0c5538f871b9af1b116fb4cb699f68eeb79f860ce704abced5188f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9779f5384b602239245669c4ef8375285db4d16ca85dae32ccd9a539bfea8718(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36da28f4b8e2a60683a16f315b7470f73895f953f898505d4215c8e550cd5e90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55898952aad3eba341227fc1906317a987b79999918d92e7c183e3cbe578ee6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a4ae0a07c992f78bc77aa97e47bee3e7f8a8d0a83c76afaf9d12b97d05c2c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210dd40c81c2f9455711cd51a6f6d4b6605d64eda730367df9bfb8051e7c8c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0330c62ba5bb19de217ac8c6e05c91d8c7f65c2e59fe84264b1cfe4bea27f28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3001177f1218d2082624a6df85f537fc904d00cdc96742dc68bccd0e787726(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eebf0cd6603ab6ce92372a23ed900d49965a0b7c732c2e2d874f41df430aca66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd0bf9d200ced9c51762c4c41e630a5a1cee18f9886300620428a4c7c813645(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5438eaec35c30bc6d879c4086be3014dda4bcaae8ef2576ce3a8cf745df6309(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d98392e94313d9165140c8de861f88ff7ed2538637af81eb13b73237d681d5c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e82a936f8eda2379d3ba8e4738cfb9a8c48211da28f843744a4d49a18a3667(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c1cc3cee1d5c5d42c9286143d6fdc572ec8c9f4aca4a689383a3a92f658ed4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f2cecccc181dcd99e47640fd0c552379096ddd76dabd608f3cdec5d30ead35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4a9302b75e970806d6bf4ee99cd50a98eef5f13342caab636c71ff1f459032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af1ae26c90dac972c3b80a5bf64b56bd61a49787c6f0b8a6f81a6a79e3e6d8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662e3222753dfb903268f17f5fcdeae868b210174f6591d0fdcf46fa243c9bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984d257dd3fbaae3683464f70c45724837bff4b8ad3c25ba081b93678a0f4fc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d7539ab2f73a6ed2ef4f4b230b261e550237d25ad9015262c40c8bd81b436f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8fdaf46db7620ccc1bf03ec04ada5a74c36d32c893b8fb31689aec3bfd8988(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb87af2cc8d9879a679e54c322d3a1072eb7ea2e8c56e37345f2bc954869aa2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e999a98b9bc17630e98685f5b740ae3345b83170a3cee2ce7967200100b6f97(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bf6b8e8e825b51cfb22fe394ad340a69a2203029e5d1631496c30c60c49497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012d4273c956a6d03046e0616592a8c8315b631b6f52e33288f5a9982499b3d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9957f8bd2d55dffc58a5f11b61cc8ffef8cc42ace7db45e913a22ad4dab013(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c90390c5123267690c9f88ae2c4861084d11515823231d621c9e83ad750ea60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba41c1848c3587861f664caf31ec7df53a36b9d37303ae0ea200a5f2f72acc8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a8ebb753783d3546457f3cd765058b8d59e467f625b9b6c49a9adcad9062d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39ff1874976c18f10ac95e9afe95aa3943d8f0cc01c60660c65380c3089c5aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5556458a0054830db367d4d553b6b44ce397ad9f3816d23063168ad502d8287(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17dc869292e1fc958ee25c37b0d181ea3c0645cfbde33a1b10ba7ef2985b2da(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8862af0d826db83c8c1730c15a9391d9016639614299a3f25bba13be23632e5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5cc1958ca955b9be92aab51a67fe1469f09445eaa1be369d71a77a6e313915(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d347af537d5f1c45dd12c9d7da8bf5f776889a68660a30306f3ca76e5c6f5779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91347545cada30c627eea4bde304228c79928ad0ee4e63fbdec0380ce3ffa796(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c18213335c9aab7bfd902db11af5ae61cbcb4bd628cd75af07171f0b8c9e2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a65fb28e3ccf6725dccbbdb0faf0e7d3b665f8df173405c8fe14b7f563d499b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466d0fcf0cfacff06a24c94d3acfd34c9438a941445c55f8d5120d35cb86b52f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__528f6550632591d54304234775025e7a5b0c2269b2230971d727089e05b5b7c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb331c0c0a68fda1d0318ae00ce397035b68245d2672893958fbd9819073b80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1e7b300ab556a3efd676004455b0e95d6767130560e2afd4951bd984fe9569(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9416b799f5784185287d078b810ca7aca213c33482e6ab3892b83ae3592728e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53e19ed85597a9d5cf3eb99eb9b13b5920f06594e2216050aa1e39ac20b5af0f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e7a573be2b763cd9f3b46b0fd2ff30235878af6cdd2bbfaffa692baac3ee83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41666b4cb1469282d09215586a7d0ee8d923619b198f3ab7a596ddf75638ad23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1776573be70c62c55d1ba1ca185ce5802e6220f5337bb6ef3861fd9fdd24a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__405c84a30bad054771b8271e25baa55cc112dfa1f8afe8a70b758f51ea22b586(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc7d38540ace8185850bb62695528c0fb416a78d89d2f402793a98625514da5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257e6def7e0c3b4bd543df427d45e7df495ed6c2b2d5e94633e9ff6b21693b73(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010fdd334d904067cd7fb5ec8f1c4e679b454b977d655e9685528b6b7b092ca1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807b4802b215e1023b3d13f9b436369889432765b9997a7163b0415b951713b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7262216cf1bfb17258cd608f426e4b78b5d5238f9033bd69174a248cacee1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898c23e76ef0ce8a65e32d407051a215db13fa9a6531849069c6c0cd95004e83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8ba0ac1ba6ef5caf6c7a618fd05e213951c53c42dd1aaaf11fe8ed1f53d6cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a3edfeebdf76b5234ab2f7a3b285660389e8a59fabec21fe992fb88ad12f49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43edfb72422da7d71b057f85b38b905c524ed5968d4b52a7729c3978458ff027(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090dd3570a6aba739e24c7a6c515fbf79941a15433dc91a117c093f58b6bb98c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32e0f6e7b040ef646248f6762479465457a8f1d95afd1b3face3cede5d5911c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987d72a11fc11d6c64de617ee79f24148360b33ab5a8fdd5908451970c2ba41d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b976e4cec442ef987bb53a2fc5ecb00283b92aa6481a7c696ccd5b1edd3292cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c8932e3246895d75d77cf8c46a9eec4cddf40491c5513f2ac001f1e38024cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4cf7c57ff062727f66f833555c91984420f6da6bc8a13789d1141af5db522b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fea1f8699fddede77f7715eb3275a63262459fc8daac103755910f6f6789d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db9f872d3e1d6cd0bb9adab7dfec903c3a677f2f2986e9631380e531ac67fa1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5cf01262c4c74964e16e9b76efe4003cfe8c672db75e1e74092979387c0a03a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f57fa7d7ba6659e2c2727fe808e60baa4c48a6d12ff5f6bde1b2480906f4f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26051145278dc600eed3cab130dc9e2162489117d65f8a5f76be433a83368b1e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af066d792e37a27e071b7167e85225e3b07685b64aafb66041d8fea2c336a522(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4656ede6cdf5218d94b4f4baa006ba4809077304026037393285bfb56c9b3e82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64cedba4890f672e16ffff56cb1c74b0b40f4dc05971c2b12dcd55918909c67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ef04d2bf68a5db8f48df0e948dd7f56d2923ed6c2254db50f64fd8b90348bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd2b6f2b23c694ddc05f313fc3b4f9cd10861721d641b40fd9f4b67de862e57(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960386ff968f6775f6c413c4035642734f2b225c7e24aa5d96d3925e49fa2e81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663a29897646273297073a53467b44fd3f936e6b2909eeed1662714833f804d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777a2dcdd74e55957b3e17ffca9f4c641e3a1761480b42e7c981ebe35f63ea6a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa8d706f28e368b9d04e6e4cd63a32d3034bb345563abc26f8ec129e70ca392(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987f488b46d66800b730255dbe5bc7cdee55a45f7977038caba1678e4484f0ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dd8ecd8ebf54f88b6c895d002070edc1e274e3c671ea4ba8f766a2711ac2fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f09b131178df35c1f90c08db9d74086996b33829a276724b8aea11db3f6d72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce2461f90456e5fbda248615b88aa1c061aa223b0e3bfa045bd83b8c3a8ddcc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2292f19f52498c29ace2cda04554280b1ac21ee992bf0eb6304313c22fb68989(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac2c6a7ea249b3e32755817c2adc9ff0a1840064839ecdf176dd9367e2a7cbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3284f615affb54bc68469b150e80825ba1b7c16d1af6116baf2c38aea3ff8fc1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900b82f1ceaa7242fa69ef664d8d4e1184fe5c1e5e85237a57249b161f4613b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2af2de867286010be9e32521cc164f0a9fc2ce4f9f0e9613004e47e99b168dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b7b72c1fc0fea5852944b6c689d1905e18e7db16339429fd70499acf2eb2be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1caa83d46b95bdddfb7782e9175af08d8c5f178e6f408bd3d13be87f11062f49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f4d2564f7e869c0939666d2bc8cd3c8af59002932cb437baef7ea6e6be2ca3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5b5fcb0f06ca4f99596770c0a223ef748e14e77b6121199d248942a8995136(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fedc3db0a0ce25279241d47fbd772b7969e427d036b3ed94ffe337139f265a0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322cab7e0c6cc49ab907fdce96351b74f1bd8d33330c865a428a4d53cf059c51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a1e4efd50356384f8d6d4c2377b2383843e2dc09497aa398ad558140deeef1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a4ec76820717ffe4af4da5da55d0c2a79eb3cb22f9e5dd0c29464658b9a553(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ba6885d2e2f0efb4c2965b568e3448cd40816184bc953af8aa403741a31bbb(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0059a4f9153870b0eb0c331bc77c623d2c9d1635f923ed6ece9a432c118875(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af15633527a17ed6b751f81f0107815ec461e72e370ae14e2d0fbbdc2fc4fe2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91dbc07a42bc441255ca19367172653d17df61f06765a576fdd81668b243acac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93299e24b532bf3c570f85057f71e2c0a81bd0d1f60f238c2d9e14ad601faa07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a22e19857409acdffd7245ec440646be730c1cfcfc6d1ba84a1d814892d56e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20325253333ca9e1347738feae8740170d8571a3405382b2995e43f5c353ed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5f05346c879aae12034aea15dd1dfb15a29cea265d92649554040deb1c8f1b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886ba98911df00a6d282fdcaa1973e9fd037b7d347eabe6d6ed43422a2d04626(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fec2a30b481a6577d217d5aa09e32cf5a8dbed6d86d795bc54d338d39dad682(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a768d7519253af2aae19d291f3a49ce7c7bee908fed728545ed373f6f325da8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d763b1fef952b509259d17510b314911b194ad2d981870b6bb66f3aecd80140c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e57985a764472656967a664d74fc58edc4fbbd53a850cb43491fd5846639c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55687b06ae2bd1dcab22022f451ad9d5ce6db51e2ea2e1bd4254ea64e031c5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c910112eb4983b7e18a784c6124e51004c6f0a54dac01e26e63089b3cf82467c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de3b4f0f3bc06f946f11f9924d952bb270bc8c1794d2d472f53da585b25b029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5aa707826ca4fa623ec21ba442e97d7e491554e5180212a3eb78344e533b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7723c278dbee09fea6499d434dd83834238cb798c5998c70869b93dbc9237038(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5c53bda7935108e1a5eea6a4dff3ab76f3db6458e256d8d703d9bceeb9c685(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c2af2a3a8b8fba718a99808247c6adfbeab23c2266c71cad3f83bac25d4633(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e4781b28bb863c47e577baf77e11c4fe14e5ed53cc2da54cd3c49c7988416e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201a416d1dbbc87da8571d95423a3dbef1045496600d4837049f9bea2380793a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1ef3c981979a2ec9765435c220250abf211fcc82fd48f06fbb7b871d7bef93(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14cd1568f91264a66eb8cb51062d4f48044e78a4cf98da01f341add56dc45c88(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1f7bd42ec3bf11dfe112206bebb5815abd14ca3811f3d3da22f57fb3b0d973(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84abcf42c4516b37de0ae636ea15393d5890b9fef629a3d03743e409b734666(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549de011571865e3bd0a1a29594830cbac98ae42b5c5159816b00ed4a47575b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14163d5fafb01767cf2349de8aa435d881617be9af2fe173decb8e9fd18e29cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696f37dc0d111a7e9761dafba4d13ed589558d031920ed6ae70bbbaf8ca2a304(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a58f5a15e4ac49ed70f341d7e798a0ea316a785d6218998bd172d3e711cea0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdf307520c6558621ee817ab246e0b47762d925996bf7781fc7991c3abee510(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e4fe207367b83aec9c24dd48a6066a9a7c89bbb1a35a9b47c2f465adbb8633(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19c7de7967e465e59f3ec1c78fa07448c475802297e3a2af41127501ccc31a46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78cf7808fa43f16010e978412db70db2c36f8a1242872e606b47f5ab7621a94c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e42928bfac9bd89008b7d54704f86bf5814c89d271802691f95cdd46d7cf38b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7223f182e02f4f79222b536da87cb5018ab0a96cead6f3b654a7e62749774909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d2e46ebc59a5cd263b01a7499f6fbb2e90710ee8bb7ed103c48e04dd4539b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a63c70345e772ca5983181ef27cc6d1761853904261036f5beaf3beb0d6df97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc50df8eaaa3a6cba41b3f1d856be793b3b51fa982f71ea6a6d50207ac54db87(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2bd7adf741202f464bab3d16cc88613ebbe80f796d78884d01877e325ddf08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186583e35038528cda993ed103099a71a1188d824fb1568fb9b647b8d5ce3705(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc7336938700cea7f877c983d775142bed5303106e2b117668d51bbf9a87b84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5701bfcad8517674e3da6275042e944739f133d438d4f0eb1a19be6ea2ffe6de(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c024ba803946c7975f4a04283063e937c2ef837fc0c72e6a814337386f89f04(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1dfdf78ab8642952bb7d364ace03d97da9d05bbf2935e1452bbd90a8f339cb0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f27bb3d8298eb69f65e8575730e443a485e287efe6e5b509743d0c2bd2d9b93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b09bdc9c3498d390baea2e7ad3a9531faec038113c54c036945bc4a42c10e2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f2c1cec8d4619ccef4c4b47455edce6d4f38f1838cbccdc29742684ff90014(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4bfe29b5741c721e50095afd5f37008d330c9525d4f6445f5fe9d44f8b72b5(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc042ae3110c4db15bcc8ba9144a05b824987cffcc79a7a031988a80b41b8b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22087838c73303908e1045fff0897713c929f843f625cb8e48f09b2fd38d0ffc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e026c99ea41ea9e562e26e29959b71ec1ffb7eaa98d46dd9f700cbca8535019c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c205b61d92fbeab5019711bcb6afd9378320653dbb74a80dad97e00d4200483(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__284e9fffa3a696f968cae12bd6ebda088ce90df74696924f162b83d27df1b538(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7185b66f563b0d43fe385e9480dae1a4a7ceb2c542e804911365c1f770073a8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbda4eafdcaf70fddd108e26fe3fcfa7185d044821d02e8d8a0cfbb359209759(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97661d93340f88426a2dcc69641fbb633d381cd2161a2e372ce88e6fdfb8971(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f7a6efe8beea8718d23c8c4f8a8260e4987b88a04a3c0f400e8775907baf4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac346083cdef474e5d4c24bea1311454c84e291f4458cf7af7399bb17d69050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29f0982bee7a7ca336c321b40059c782f028e0b9aed7b82b431cd7492022d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7303a7fc74fba538b6893c16891a7d1894d8e1b4ead70ba157618d86c228312e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed82a5a32906b12d9da8118c9dda2a9c713ed038a2232ed79407d3eb82462cd5(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c139b7b02008ebefb62815b0daa0457012edc5b3ae755c11b324e462d9c134(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f45cc6df0ff21984bfff9b92b0a11810ce06577c028fa794a29f2c4e8f58d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955de3fe5ba21c6127824c4bbf54f5b17e1a113065fb2021c5e33bb2ae8f16fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488f8301cca734fe0e6071272460d2e2e75a86eca89015c2b02e5dae5e0fe920(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b653b4513983db032874bf21ca1cff330e0204e3543908827091ea7d81d04d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f17c6ad8751ad0c519bf66af423dea3556868c744dffa29a404c84d0f44d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb42c2632bba8f0a249a6e3dac01b24b9a31b5e211dd456a8c753cbeffda6a7f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c610b2315fa961a948b7f815684466474914ddacd46c17eba3d856c68e2c677(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6959915349be75687e105bbe90afe60f28d740777bbe84165746eb54d3084ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda7b911aa29521893907abd3b95577ead2c4444bc77dccd61bacf8ac5c13ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed652e7c6e176a3e71ccd181122654b87ccf58e63e63ee12d6e40515b482601(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560d3c53fdf1f9c70d7f5cf8d90d36ab2da390d7c357ae8e50e6392b52d4c83c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e5e86ca09bf2c1912c0e956956a12f378f4b5c5df70183a0fa4daca8d6feda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00aee23e6744af412ea917852bcd14955185bd4a125f54df2723542d1744eefe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eaa95c5ca6cef31f0e003818ea31eac55011cb24addbd4eb87af8c1ef69c5a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa9f4250c8e67dbf694dda220705ae1ed7b9f71cee1fee1e5b3925d84bcc662(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27c077b2ddb35acb8d18f29298877a1c14a38f211cd5a82536650f3e7d545b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b61c8dd5715d1c6d5e4ec15ae0ebd205b2d9d54147ce5a3eb5c9f42bae4767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0d09c4ca918c5a92e10cca17d825f37657cb2fde2693271c81dd92cfe9a35e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb1d775c102f48932cf497b2aa581bfaa70bbdcb7e731ff137d7b5430dcc3bc(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0970208e9feafb9427ba1d79a2870e86ea9de3dcdbc8971bee4083ede764ca3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621da87c837936ddf0ba02afdd5a6c75570a7b3733783d2d289459e8376ddea6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c64e0b3f98835e452f483de0fd92f166533db02f2ab147bff4e663b5efdaa50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d3b741108e88f8e200758347c7297b1e1bda78fa03e1cee877a2bbe7666ed2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04cfc72f580098b1923af2f95262afdc5a67116adaef15fa293afa212a9a2f9f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1dfbd7cef41135b3495580550ac9b64d1fc1d99256b9c102528348aa1615f98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885b088ad086f4c37ec92a8cfe54b8fb99fee01279f77564d1e8e66545a79aba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e3af11533d522233203a797d14da44c979f09c91f317a796655126b123e53b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c3abf02a1808b6770320b93391c10a5737e45de6776fa2e38c50150690a51f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad1465595de7be85c1c937c59cae3403b8a5052859a8380b70462d931ff9d0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555e26cc0c85fd3131176482504d7eaee4fdebdd6048a7f004063d22dd50f137(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c99ff04f940fd268355d5cb960def9e86430dd697a846a9fee03116578f640(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854f8f8bf472619fd91561ced49784d0539980392e5fde1b5d25ee8d7291d9ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f08d4d60faa896bad9754e36a9cfa957ecdad42a94cd7e894d586b58c28abfdd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b4720a6f047ef8a0e8d3063abad59e933198bccb6d4f5060c9a3c22020ff7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135d13f15e991bf35a0d2d5268f68d1c1ca27a68aeac0410d9d761f4b76b984a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6260ca7a61c8b05b86bd0be9762c9f1fb915e4f9dec6a2c333e52da3d4bb8f93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabd5d34460cc3e24e39a74423725b3dcf26b12c08fee16b8f91f0dc027114d4(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74862048b1a9b251ac541b4e9fcd88c74d7300ce5be57eaaf4db814f4a593fd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca25dfa6cc8af3fbad183dd159623f7ab6725a4350e2bea7234aec014d6fbe61(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928be2a6dce864e0b0d430bacc153314c13b5230d5fb89c0a1e08dc8a76f37cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b628b4d0a191a0291cce7a52121bf32f9022a85628c0cfccbc4acc8724e280e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbfb0d5f1dec0d94bb1ced523f134deba82ebcb518c9d8b20ad949ee1b69832d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa705c7769912e3728c3387bc4a098ff081dfeaf465150f1df26d251b809e4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f715aec2fdf6279bdd65fb6f9e9943713c6da7d2c45b975e9b9bb8c2b1fc3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599a30dfd1de97256ea83a0c7181b558cd08e4bbdba2761e2582d4f04e7b23f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773d1bcdc75534e6673a5969080b31eb1fdd05f0ab9991f3e83aa5527b50344e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5a095dee3ceedfb39832f78fe8005e5e4759553e7d12b9186fb682ff23aa9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9820cb5ba36ffb879c6870f74e00bd17f8e175d00b8a7b77884893de3b06e7ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944f2a143926b2e7af42164380480a6e3f68fbdc38ad21a6bd11db767f8f487c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a6e48d8f90f33eeab37df7c100e2d488606d211b46007ccbe2072ac741bd31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f47cf67da1c9e3b34959df3b678f9f7ffd5b19c49b269a9871bc1263737a8c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1d1d87d872e0f6d3fd4b1ac5131e9518f46b62c090a468ed54bfd50bde42a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90640298fdbf66e8e166022740079265bd138824adce501453c80d9a6588f084(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1545c624ba8e69b517286582c9db36a693f538fea26778c4c775333deb583c30(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e19ac195754c75d7374675212c57e11208fbbe8efae95e94dbc288e65be9d7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c077d4d930e1f1592363ff45b79b1317321a87b392d6efb40f6bc8f83b621a21(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3043330152d11fc071dfce32020a80d8c38383ff767c0c467b89173ab8e85b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010bf0adff401a03b6b92180d3cd7f118f8eef77d4bd431359b714de60dd8d61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5d340c6de31a4b37267f8b443eea8f1cc03c939838b6dc79309ba576419681(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8acd07fa418be45538da7f7ebfdf6d861d7e5cab322db89fbf24472e2b42b53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3c7c8d2e4fa8965b5387121b9c682c18428bd46804dfcf171175591ac388a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec58071c4c9d75cc17a89afcf4d5b7117703809d2f21a5a7b6b5181b8faf3be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b918cabab6b67a381d04b5d10afb931dc925c529a1031e10808870e0ebf3de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7408f395285ae983873b8a74f6305333593b550eed877258a66e6e6f4181bd35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c21509d449db35ed1ad901f231fc41e310674af26b0e9ecb590cd31cb50146(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ba94d59b4c90ebe42d49d106ed057158837e8647626ec12025873a8199eb09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef89ed7e5b8de01e5dd0c8de6199d4775bf6312210028e842390459e75d741a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__addf4234f915d44d2bb661383665c4e6b1a57f6ea9f66d310654898547cf943a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571ad5e9e213deda4195471c7800b318023274741db17356359587b3fe88b06d(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7321d2fd2373f278c8f7d1165e5a86329210e556a794dc327d1e805ff3c963f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8845fb7a1b0936fd6d57817db6ffe247b980276a5ece2dfb8b046f35c4f8749(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7a51660d0270e3a6099d72b6ad9625512f6ff5fd5dd7acf436dc5a1cf5647a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df64d4a666cdff8f27a6781da1a77a533bc2909bff985fb5eaa90019896bbf1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c64f637fe011b41aebac99cd2b3e1de5578fc019c79181ced2a209216ce82ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d36750400dbfbb77d7c2b993eb2f566632957bab66a804d0b7b4da716dcc08f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b500f43730fd6f2308504f4464b94f66ab58409f08fde8b6f41f4f90e5461ac0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__798766f3b213a11a9e74cc9582207447fb10f3e3048fe8dac660ce87e9f3f740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41205e654c7210b5ebafd9096f98dba6cc9931709b6eda58ad3aaab6ad5dc60b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed67c9197a3ea9715785365aff959c4e1449a3fd497a545035d7fa17269a6a95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a089f21012b775a7d0522b20074205daab9559085326748015992a8fb310f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9e2784680bbf46a636f36240f0327c494a1664169a11a1270600e05acdb5cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7887f61775a45a321af6345c6d77b2f5a5d96b7777d954c08ccd11d213b858(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448a8524e19a9ffa94842daa24e539766df0eaa552d06c39a49b5ed9d14b6d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4c758592751f866c1d97c4278068cae07a1c4b49c81a399552a647ed225257(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25454365c1f5649e2aef80fcbd6ad7d27e38a2724fb1c1c9cc3ebb8b33ec1e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2ab90bebd370b0d1165b722f17afc62429f693f45c3c4f9c76cba057ea7514(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c87830e4f1cde0dc653b12afc67d51c34343f0828619481b6479de6afa5a9fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b2a96320f26a63ccbebd004907ebe5c26adbb5327d45b123d4b39129ce717d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7218a67913cd1ea1434e4de2f7591b264b17f3dbcf3a8406f2fac903d387856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7f4a962f908d8a1675ebae9c80129c81eada9096ce45de33922b9f72a909e2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7473f41eed83f53ac1a3ee08798cae4a10d21cbd1b42c6030e27d8b093b114(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22a6ebdeb49ad4f2b329dd08f41b7cdfbcf551cafda0deec9fe6bae0e3fec4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd9e85bfc33b43c844be5f494a4fbbe5ebfa9bbe99422128719dc444b7916cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d473b96d9862795daa9cb731e66df0e448916b46db6177846511d6b7941f679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35dc5e33cdb1c759c60205e5ec117835436a4970fe93879da8087b78924fbdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe41b4104e7a70a051f4de01762e6081d3678b80b20d94d8aed3df0d3f561d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87465a456379cb81faa8488c4c0c9825a2b664bbd18a8e5f40c44a4cbd4dc05(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3cfec96b1ea161dcd333d1d3864fc571f0d5ba43bb652f502591c62c3252bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25b44e1b0e1a8217573fee883e7b96b45b3dbb0c93d91ed4e7c8f5ea8d87ee56(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270ea01315f409caeea7843db686206650a14499ab8debed73546d2ffc47b660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f3422a042c11faea4803772fdf0ba45446758fd66e73e46011c6376d4b450b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1318c88da4237549aadf91bb52bf6a1afe9e4c4d04e383f32ee05bf2107fcab7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c2ae7d28cb97b60e631fd8872d9aa0f37cced86daf50e0d4eedd4d2afaad027(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505a003e9181d8052ac3848252374b60317d0e086c995fc2df7a02ead2b32ffe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f53eae3ec9705c1520f0b4e34edf0f675c0e55b62d0ee89d5edd6b32076665(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54eb85aa86d77e288cb43ef05add56dea53e08c98d98e992027c29805115aa90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1ca702e9ba48e9c1211a094d3022638e362a7cdd33fead6e2317b8ff9bc95b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8f430ad1437b06fd4148023a0d6b3ee4c84eeb1851d44b6f8ce08514d7695a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c9d02c12b60ba0af6249ce90b2ab048f75bb4fe4e2bc9b53b66cb458b7fbff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f90f301c0a528fc85f44df06f901332ef01673f45c53c9a81427605e7dc6e1(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dad6962927da96ed789ee4a97526e7451dfe21fe606efe8a94dd08ab0f21260(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab53b55d7207659528488cf476daf2fc426388f42108e0e4ce12a2dcbaa0440e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f5e0a9c48f1171bfb9892bf79ebb883f08a67a510f1f9b9437ad18a0e712da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fa7f8fa41c346e28f13d5d8d4a306b2f3d03b96bdec75aa8f824cb829df5a4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__820e8a79435d0ce4602cc388e726961e505c8db4a90d48903cd481e9be598786(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a458a93f5f2d4ebca9b043a528fa8d2193261f16b8db7c16924a7acc1f960dc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301d85601d7365f5a8cee7c95b7f7b899015f625eaf92b3d84ed85da8e1ee76f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca06f61d47e18fa62fef298b2945de4a5b1968c1d20188579d47d044557d77b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1231e73482d81a48020def0d5cee9e4f8b1848d8618d80313181567dd3c50a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6014dd61eb8e6e5cbfc49448c18e4599ca910bd3fd0e2c98f7831700d31bf97e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab36f0c3eb811c94792119c9b7714551a4c0fff9269c0b21c26463708ea363e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb86817814453a4c9a520e93f671d650867513c8bea8f14f745cbef5742f767a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d88fdc604ea5add0886a2ad6f0b50fa5ca72deff1ac0552802bc2d001f14d39(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dcac4a0cbb004162836ff458626466400e82e1c3f6ab171e728b2287556b15d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c20ebd098e6587aa82ce2742a14ae815bc164e2ea90701208a07849faf65c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1236167d7d35cfea8f9f26c64c2bf397cb420b34895da57c046cc4af0a0eee7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cbdba98dbb00366a51e0198add3865c5a2689180213fe3e961f664be6bfc150(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5963365380e1e39169014d605c95fd279c880af03f16cb7d65b68127160e46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3562fe4b94e3fd1e9178596d81a96ac569e1facf3d4f2abac936bd779984cc67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96164d7b295aa27743eb4cbe6d7ae1bf9b136a283a6415d0f9590e2394bcec44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e3fe6f06f75b83bf3709eb5248de3e4e793bd13012c0a4e79824faf4b5fcb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c7b8e525f126abea59e94ff8e4f4bb0b6d257b0dbab3e2caf659a8caebcbe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b5ca3688796eb062dff64a66bb02a2bfa63fc36825420921afd79c7ce1e196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f458bd34bf7664d3f7d109e0ec0c379a4f4a2ac98c74308d28b7eb0af852edf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8841eefdd3d1c9bd1689de21202cad1a7d05f4cbd0054126f942b332c64998b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997153cbcb879401defa8ac07be9a9651839f11827ce1366be68d3205adb794a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68cef7cbb8824c94f80d47409ad47dc03c5612dea4db6a689191c5c94fdee381(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b50a2783f5b78a6ab68793c36545f8ae2f8541feceef3e452ee2c7f396eb41f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b616d4a1a6a7fc024b1f365467a316beb05bd24cec34143fab532bfde738bce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003d9a9d5b8bd0ae7c7831807531c3835fe64891d156c45f3f701bd4837ab5d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607ce1aabd44c4e2acc8f72546242168e00a54d626dcdaa7da209b6da24598c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47e99a32226ac73339f79e4fb9817fc1a0a1208feb74590aedad0da22943af4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af89995afc6135d744c94bf6cb06beb3b43547b456afbf23118fc4626af2deb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80555cf9df9018baf281e379be07905c7c86c3ac7c1052b166c1e1c1df0040b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc2bbaf7b6c8c3a55037bbc5ff13c14612aa86aadf0ea8a0dd24b64a182e0e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b14709e6e5ebb264c8461858352e5f75994750b7a55e6af23d382e6de8f2594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642212ff8249185343f03ea852a20bf1a361a908576868c1aabb3d8ba8d79984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b185e0fc8856fc6db9de53c78c0507958d96685546b7c41cbbd66b69113c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f535d1a86b9c642b44951e3ba8cae53a08b214e31d4e6fddd3ebd8bad4d0b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26bcefc79978bb00f5524ef6f023c20a213c9e8bd5a7e3a168225a42f6e44c98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c342980778dbd6c9710f8628d1a480613846bc87e0b589ae1da552fb2920748e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e628f60190f38c0bbe25dc9466bc689a4433e7be6bec058832dc98db62f4e0e6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d502dff037c981d52d818c5817b6078ed8013de8f30d529b8586cc10d502f25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44f85755873924ee37bb0a7e4e4d5705b11f4fe93d2c2e16c2d998b96ac14bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921822b0cfa20447d35cf6486335849b8dfa557df222557353c0c6bc9c5dd1ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b0640b205ce78045b883a74b056cb75c7213f05386faa81405000f9433fc74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de51f4cfc987e4584ae0883f1f4237367043126e91394fc43d411c66836092df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a1eeda09bc13eeba03878d9cfe0de05508159e1be99c8dcd696448c38153ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9051fa9401e8e441d2d1165431fdac37a6afd9d328263ceb5ee945a600880d98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db07881d044dfa622e1573de8cc215b826d303ceaffcb7b7f50165c7571c925(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1e71c3c8811b42408bc918f83a1dca9c096f4f5faf781d3eae9530d32a01e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e485f6db59164cf3deea813981b1344d5b2b796ab29f856a2264192defd72880(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fd777829d0449e19955f8002167982b4f02923d1fb675f762131b3bb3fa0db(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d065a9463c60fe14ce0f03182533bb4cd0fffa0444189f14b9f8559be8efd9e5(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b8d68ceae0e2c7aa3d5066b2f851177722de1d39190573aa5c9c550084d5d6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485649bf59bd1911b53543c70afe73eb859457b8121c8e0db53d0b54318568b9(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867e848258ee775928727567d80022bd7d1042443dd6f159f1af258df67da060(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0b85b12ae022477c98fd0c0b3a38abb992820391481071c2d6850ab49e8215(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b2d086ec829d455440a04e1a5974f5bbdee9fb48ea8a283362e79bcba010cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508d10e912b01ca344175f4ee997fe23049a008a941c2c22c9db9d25d8cf729f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__372e1651bcb25be943bc6b75c63537411621a49bb445b5b879eedf87a29eab71(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7a71dfd573b0dd535f97280ddf8c19f5f7c901a0b04caf1b4c41d724394fd27(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1e7eb114584ed3344a69a3b88769b56cfa9b0736c279e5ed979ec65300b5fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063189bb0b1cf7583d72d1d2103ddaa0db84d80598a52ef4eff7e0e8704f5dd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9b7f857d26cdb5328251f3a0ce2e793c74c2c5aefd484310e14d2fae2abb08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97baebd78341a63e4dbd9099cc3bc2a6304c13faeb2fd77bf91311205ac62102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1375890627c00fc77a6e96f36693221d63d325434991648058df1d267ec4947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4a7ac20ff9524e33a95d6c5185125fc02098acd1826e058cea85ea7d7c6929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674ac92722895eb101eb4b318e76e4bdbe9e64dc63f30f62234932e813e3ceda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c895526ec697f38a66465458f1535d2758ac625e9707659a46b82e6596d86cc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773a9da8daf5b317cfde80e4c9df562911a05956476b628d50aaf08aa58ef4b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af2be35cb6a7c60bbd964e230b0b2f78725a852f52c28b35941a2d5c53207bc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1072e2d0077fc4282add2d05bad3fae10d6cc483437f82d57a3ef3d77b6b7ab2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91480f35601beaf983e38ae064366e5a251188ed88b4b8d218a307869db9bbd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f1681d740505c5013377f1a46631b9bf685861409f39647cde4216d3bfead7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0369bb25838af1abec991a010810aaf06d124aec152a01fc7fa40c0492446628(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b377764b1965f360b0bfa6da7768e86208a0ab5e01b7ab29be3245d222a10dac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee9dd3039939996ec987535e3bd427882840368dacff771e434b45b21d34c5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8820fb9e1cd89a05ef77918cbdc1274aae975f06cf52235240a20897289092f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e61a7a660d243f603a87a727fddcde9209ec44c1dccb2e3669cd79b484a0f9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c045a9b176a92c27b698abb618479956cf8d6e1a27dda89e860f7ba863a98618(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4bb5dfdcc5bdfc1ee835c560897028d462b08596d0fcf61b6c52e07365a7bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d4a5b6330ff3dfde189d6c194f9a9ace30f6b6e44dfa24a7c132df9b861310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b401766e25bdc220f369e9470d78a68ec113e64c1ac11339b67dc4804de4670e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af9fa2bafa9ee38cca9645336770cb18a4bda354520e6a3b462747b2f210da5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596ab5f6afaea19dc8d84fae53439e126bfde5ed4d15e24239035bd6dff3f3db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8a168ed9ce61597f519460268ff7bc4c13adabc3bfa9b49714121f85a769eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d2e42918715e3d67d95af8b94175a864a597be6d87fa2fe20426a60f1556816(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c523868bf7db6ba069a94460ac4b6af67fc10a6162f40d97504ae40386449f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3080c460cdd0d0690a66c62a3c0b3733d7d3457567956b2d29262e877960cf0d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f4238689530b95c606bc0f103312d322aa98a8152bc5921cc5adfe5b40acc1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d56d97e0fa38425a4a49d5dd2320d1e530e5d87a30aa9bc626176a82f7f695d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07fe99bd2a3704b179c8b20ef2a02d79f7390c8c7e7b945f7f1f9d52b8403c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f30e0ce9a78a5bdf41a3fb97f99c8061529f63af951107dba30190004f66bc6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b564b38951ddfa296ec53fd981e4fef4a3943bd9d4bfe47447a8fa96f8b99ff1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0150553f83799616d5ea2a75e19cf08306f10c959b5120aacc09146289ec2078(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e5131e73964cd8979fbb4fc4f8accd851c7408cabb5bcd1a9a2877af8c72d7(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05866aae17b851cbb61956f480b564ea7e201d257f9d7d0a6918a3baebd1e24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18b45b8b68958f9237ce6c24cd933ccda2b55498290a869c36356b4a8365345(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbfbb8acc2fcf65ec1d2849acd6eec7003c15eec00b74fbbcb7f46f46fbf2da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ec047b8f0442d4f0c354119dc0cb0faaf43939698ad82a4758547fad060ca0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67862584b83ddbbc0b4958829108cc632435fbb727da80da8cecd8c29eed698b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f7b6a07306f5a90fde274114f471bb3b8f5efcc960df0f00b0a4b70bd55388(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3ae81b5800bab7f7f0332b1fd32edcd4862ffe340ea7e3280ad2977f24da0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c6157083a481865b42e90b139a1ccf74f83f8553a3ab178d0cb4a920ad5856f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512982faaf3940593abe36616be789777dcca0becaa6a51fc610460c50d2595a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92625abae591b29b4a43fedcbac4557ecb02c4ab8f36ab6ed2dd106587ba62b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b31da39248a40117c2c9b15a8758eabf0e5a0753bce4e7fc517421e1a2d746f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac653d29788bc8242fe94cf3244df4bae882d829a03e4836e8837e2a08b7d30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56da251d969ee7510a43e1b0a1c45d14493d80b253839168a7cd676fec6c4db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84a08e21c0c2be6eb62df6b81ef428f66ea71baa1c5fcc16a9ae286c2b1ed05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bdde6a5ed5618b81c2ed31ade5c2102d928a04a30feaf68c7879fc978f5f870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4af25e46bbe518b46748b8e9737cd51321f1b30038c75275c3db8e82cc5898(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e704c06b1646f4bcb76cc8bf1d82d76db0c83a8bcbb8eade7709c16c5ed3ef54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6881979f0974d54f495199589b4519532e9bf3fd31b77d396def59c5cb652604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07ac0351d2baa6733084b83793db2e5327a1b462996c10cfdef5c81255983df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65488662abe871bf996f0e948133986ac43e7dbb5e453c133c1cfa33b0506d65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f586cef21b0fc93b1fbbe93960d4fe46105f38ec17848b3700a0536d9687302(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cd02e28366b52b2b156730217a1a129eb029cfc099cf93e40ae1b403b4bd53(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c1822d900d0a636ff3a46462480554573c8953eacf4f51a3cca9fb3128764a(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f13da10b86fe8dc2087322fd593be602bb58a4f203a684b7dd8da8194a87ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f093916a8de9a702825e7aa6f9d38b28a753ede139ca37b33eabccdeb30fc546(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167077b8ff8aeefba1d36bf9528ec1be9a2fe453b496c878fe6fea65e98d02f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cced31cf7dc66321b56ee3baff433adf2381e4f84f666f9f53e704de3f0833e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf1839a0ad4f61dda892eca594acd0ea154abc3cdfb26a7f2ffabd919b423ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6380984965b1bd555d5d2a684799f383dabe0935bf7e49f174176bcdab923a15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53ed0bfc3144daadabe4c9c38133c221a16e9257a3a2baafadf96465afd8b901(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fd9eaa00958ed25d27637b9e1b2f42e20e59045a91e2ed50846a6ff3d7723e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd78f0971306df501b8241a952ea2fa1523ea88f23f5cced69c4469ba2fb63b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb740755739e369a1d539863f248877c2a23c529986e68d97865fae49b206d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555039e91cfa42c1ff61cf3ac23101a4dd5b8066de2d19e63c66238cf357753b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f223e52d67c3d61ebf15257d5719d46a9bc86c38be12d2cc71b15a3feaa21980(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b604154ae3985819f21cac506efefddf9164795b2bc3891c3283bd76af69a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3240bff910ea9c65ecf40136daecf69f21e3c9cab8d408bcd3056289a7411bc3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6ba871da9d5b232e3aeab7289e73d4fb5c6636055c2d40e7b9fb630cd356fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd00c271a6294f9d313615308bf73380bef9aa7b9ec7fc87fa3a85c121fbf3c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e281041eda6d60db902bb54f3f7a31a3a80f16115a1a56880d366522853a18a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a621af861cda8cf2f751aa1c7ae09532e380e90e336b388acb937e9bda0951(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fd0813b6e979c76e3b9c214b444a4cc4e3c3bf175025c33048746854fa6067(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b2d5aff2c0000d2453dec76d6f767f9a5b59ef4526639844ee58c4fb5d6e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d7fd055d72f992b1c02b57a3b897bd0b96b9fdca2d3c0b1c4fceef8150420b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4518b00d266d1f2959ea4d6a1ef36a1bce1edac9d69f24162f2ab047ab58e134(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c98c2852868e999d955a0ed39b2acb62216860446bf701beb14d35befb3380b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b7ab7de1884708bf37c0208c72c17778c38c0568dcd6e83a76df798487577c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfec35aa73fd5dc2acb8790688d2d5a66b6802339cd1cbfed72ad7b2fbf3b387(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471c9caf845a8261aeea90466b77729de174d7cfcce85ffe9c6393367471dc42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8c5d0d2ada91699070c52ba092675dcbe6ce24ae6398a7acfc61bb4b70c5bc(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868caa5a324cbc0c174519275b73f51a32cb20939e071fc48d61deb6b545740d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d2fb9174179836bf88a202e4ba8ca911870b5901b289a440f59a10a9a4291e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de24584e15df8153cae0075a8d09571dd42bb75bd4712f7a57ee56370df3bf1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77343bcb9baf0f2821c4686b0a37b243a5cc99cd42088e3c8345f8b2ab90385a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e2e842a51e48984cdd3ab3a5cc0f85e86b77505bf2ada93e47c43841d9d1ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271d20b08f5cd300501a6ef7768d96ef083ed0247cd7cce162a955b6596a8936(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a3f1f2d7d52c0def405a3225c0ddf0857ec38e28b0639a41b9b2c7c26925ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110c9d6abcb2a40767ceb4313e9609777d97d1aeb2a27ce1dbe52444bb194a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac13a5832a1f4abfcf1cc7d3c4ad2719ad816bbedcfb8738e4e3268c0847bf03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32844407a515202b734de6c9827039fe2df35880d10ccb08b6489d98c4e7f52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc35436f95c4712b5845f31b7c3ded7b1bf3b19db3fb4b11608083234c67787(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa27ecc6f9d4c6da73be9ed341fca089e76eee0cfa2aebb9d50cc17977d88ff3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af075e557042189c39def23893df1b171030d383c6700cc1b4a908bf3175a989(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63412c91e9df840f610c72292d6805d6b129c08f879aab1720da6553b4627efb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12161ee77a96ee5f948ae608c0c611a23a7b74a03f58f2643219806b781e6466(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133c92930fad5e4722ac042f215293ba4be1195fbe837091948822ceecea09c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f492a28a8148571fcd65dddc1f57e67b82381a3f77c6aa7f1323ff015e5fcee8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8355d3de896b963421fc6788b6f552ddd89efe4ece303422afe9cc714a4211ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a344d93aab526a779c089e2fd5debcc3fcad2af873fcedd19db6346cf452835(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08cfdd99c4001fd75a98bda67400e00e9bf39eef057dd464449154a01dcfe24d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b540181187bc11a44cf083643de4c11021e58c1deaba08cd60b96b3ea479ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e24ce531a78ec572f2aea80a7d565d164a41de272ccb21f1c19348263fcf1e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e62f80919ac5cc08e0e7723032ce4197468698df1b3a7be889a9a21d858684(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6825a041fcc5e1d8a48e3873ab0b427113240e0caf95553f805811b1118541ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3ba2da7d38182ef7cd5a86e74ec5b00055c13ff6771b792dfc7e2a53ae1a62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6204e2d533ed73a06dc51adc6c94c3a082d20a5e7153424328b95ee585559d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9705bd0a09f2eec10bb6aba6e78804afab73de52b622b73e2b43ab174e6d9097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354673e429d2dc9b29ad2b5fcb1d959635ab6850458a9129bb5ded9fbb654f3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d796b38cbf821133bdcb2be021dc69cb36c68df1c118b653476aa80e208e1c76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96281f592b2421fd8174ac8ca0ffcdbef4d3ea4572e08baa00c0d2330333e1c3(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb75a5d4a0fabda40cc855e194128f1382a2345a035b62b73ff75b41a418e871(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b948ed31c01dab403274631b2b45086b600fee367d537db49924e4e5d8094b52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9d0b80a70cc17f27423e6cb9116474e3c0da580c11af87e7cc41a273291df8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__673e75d7472aa2b89bddea8fc3fd619cf0fd1b960e2e1e3bd10bee996f5060fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062cbb6749e2946919e4f5b531bd2f3fed6b2793e8470e49aedb978ac3c098b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece0abfe320f14fb9ced03cb1ddbbece1b4046bd06f27b4e904dff457eeecdc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f50c6b5ec4a3009a76efc2ed9896c4827eb1a2babf50de8ede18e97ece6df15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc79c1e2b99b50fdea5b499f752eb2a8aabba483b099df293003437a019f0fca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8005af9a09677b1d0bbb7a44838514790d60e7cc280569e30ca32cba194e1ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5aaf9e55dc1746af0b606fae6608ffbefd75266eba03279b8fb3c0f9c27ed5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9207fdbfe9d57521d09d922cc84bfa00ba9d84e41346119a9e6ddbe2adf9aed(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9e61398ae349cbf0c64186a2ee3730afece8eb960b4763ba71f1738274a121(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c09254ae5de76a7af740dcb97ae717b4e00b064000c467c04ee377415c80ed9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f110c738143ff5e5f8d638b7a6fe15c4fc719bea2dda8949031e2b8d21564592(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd6971fb5296e4b4948be2aed6c384b091b4eaa593f4e75c933db0e9526d8d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0dd39145b507404eda2084b954abc47e49e15643a328f61f8cac72b260a2d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9981fdc5c8ddb830df50d2c1be2e4b5ba43b0d4d4683036210d50a1a74444e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acc7a0e257abd9d9499754377dfef8d686df4288cd6b14b3de1e6765b29161c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c8dd20b6e5d2780525ebd2e4ee8b6f170b55e52aa6d8e8dab01f27baf090ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea39248ac8e02203d58197319ce268fd79624f666e308a61dd215192d2de2a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f07cd9ece8b4ae4db8995042c78d666508479452bb6d24af5e65d627832f48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9466a572cf747649d50c884a8ce538ac08314de24ae3dbe0f3dc134e161cccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88677b5ee952dc5130f7b6fabb0d3047e687a35fb9eb9687d6386ee23195feb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d144a7204559fcd867504eeaf675af55878e8b0df0336e06deb027b710b6673b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2d83a14568ede867753a88dbcd4af74e3982035b7f88885a68dba63f51e7d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2a4c055960d6418fe060cfa11372b9edf54c794599323ea17baa665ded4876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54be8886afed7630ae4767d776db0427cbbb69b96a17a280dc7f5a1b2f751828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce13628ef34f861a820ef2b6c5b6478988f895a356668a279243e0da2865681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2184b4e79d2452871385f8b3240010c95190d5b1d9e3b3a3b45b009e5b0b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c231ad3a75a2b8b4e74a608451a27c7f22368914e2462abee8acdaef106bbdb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89411b37604a00aefbf4c46327aee07bce9f74a5bb66f44c1ec9675f36783429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75accd146405d4b3dcb7b358bbb45853812e858f35f8fa2bec21b65c415a688a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3136ecbaf4f2382d9d5bfefed4ff7fd1a596752efe6572bfec4d1b46115a576f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b121bb89ee564604f9ad8bb0df393692d344cb4d7efe6848ad57e63b393cc5(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e49b7a919a74d63bbb358ba960fcb49cb05493464c190463115c1b7a786e2a(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0471f097a26856e49bb132e774ed041e8b65a49eab4be23d5334d12a278c9d5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c8798cbaee8c680b49ad92f271f0f5af4510ace93bbce652d64508151e5e70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4eff886245cf576d9e7daafb1db7ad1d5ce8495ee64c31bfe8f97f754ef72be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678d98873896f5d9c913f2ceaababae303a0f9ccd223f0ee3d2bc29f6e57a0c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de56f8583c4a77d85b4bc75a51d66c584a56362a40f11ec61d9fc56ca459b41(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f506c9b593d6c0025b90ad11dfb9489175939824ff165e48965a8d399252f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dceb6ae6fce5ac4260563d9210281f86786e999c4c96603108705025a6c71c51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28a9e86bfc3ac5adf5c4758191c7f0f00dec9aa1964e9bd713ab3633f935bd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb38b68e5e3b07d2fda7388190dc1cecd69e69d3832adb1420160b364286d1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ca81523c4418e0af5041b2243fe349bffc2b20ecc5e4897dc8fb714cfbdb81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35518b8e8e7a4c2fd1e7f7a0add3e491d1936692692928198793ee39cd0c736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e06adc237509d54ed8f9b1099562f3274979b4d2d7780c87de7995337f2346a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9482c601eeb0dee1ee92cf9707ef5ad2bd5a5df6b4a0fe8f7c8e59d808b8587(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef4e3e96f7e4d0c2585e7d00f37ea2d9fe758167a77fdf05a7a2cf613cf3e52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6cab00d0436645a17be8af45377119f6912a3987147f82eb69e7640c297b1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22e44583bc06bbd98968bf8a3f56621b99b61d45bcdf6425af44b0b1ea3033d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7f84ba917a99eb861800f1430524327f20f9a4d8110ef52cfb67f25c7ddf7c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb876d2c50e9cfbb132d83dc2008c874ea7e81714bc7b95a854c195366aa154(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3718eef9faf23e2e8738976313365b823bab56fecf460864e1976d293c87eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb38a59f094828eb106346480f0a31d2402c12059f5d3163d06463d58171cdf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e122fd0c70bd30b04d1711e56fd099f7a518931f9e6eef80f30acadf805f381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76382d8ef343a98c9be9ebb1d9307f80abc45bba772bff6c37804e5b9ea71268(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e2a9813df89c11961cbaf520e260c4ea8d58685f2d90fb90217684fbcdc354f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4847f73f7bdb6bedc1044a70039f4f403eac5de4a2c8b947020ef3f4a8215e72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cec26377ced672c7e66ef0403996748695ac961ad5d249db6f4cc36bbd56d45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c49c4e1d7568c137f9bea729d497034e1219176101e52e9cd19e177f6d555f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762488e36918497ad3c6cbda175c5060eb82438ae1911efb96c73b1392bc7fa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e963ada675ae2c4318bbf7c9446555d4e3a0e5d52428ac5bd3a53dd135c2acc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e164d09f210465fa5bcee4795b401ac2055cfd91a19bd71069271752c3b4ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71064dadc1ecab31c38870d3e3a19c34f2113f7e9056ba56b9a4389c4f1dd5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7ffca4b6ce3baebf8198323e19ee5b4f33e336a3fc85bb706072e2fcff5af2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138d5b73623b055511ae4ee48f8b20f2bed62b3e5b04bb89cb28d71a792a4a8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d51ff5b736fdf8a84725899d5757b12d0a6d32ae7ea24b9a806a30cfaf181de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac0e8401e4132e5c5dfc4ab3916a7d3aa514affc623b467c357e5a0dc717071(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db6b832565bd72a4e4651061812a5fc7a7d59731a18bd2834596ae126f8f90a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a4e7965db444a120051af520877986499b7d225260f76eed5051bb09cc7a1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43011235bc0b400e7776b3cac9ba28eec0f483fd0e0c26aee95347974d5f93ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c6af80190b36d82eb5e6e91a2e911a12e206b3e46bb74092e9d3ee81fcbbdc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b6657cc0e0cdba13789b1d747ccdce4ef51e0779ccf4e037534a039790ceea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25123d4b4c0a3e3fa1c1e675a400a38db85bb0b612270f223ae1d79ab334f2e8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37341e9b21a40a4025ad23ceb2967bd191f045ceb629b3128874409bc23e884(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5c5d47fb736abb527dbc829817557c2bd9822fbd953b6bdf318ed28882f29c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73742de9f64dc71d718cd7facc7fcc6f659bfcf00f8a88fd2e3e1972da7a82e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4b1356f72f85d7703d17ee9fd64c45432317ea9bce6ed688288fd8de91570e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70163febcc00b4e52c9977e40886afa33086bfcc8b35e10c5f484b00262d371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9800838f1f6f9dab04ba59fa448efc114c54c33e349f49c423758e527b1bc3d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0110e6b664ed4a656c22174443a745187b4743bf9110fc3d5b74d964b6fbb230(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22a3cfb4f3ffb6575ff8453bd8ef0d306c9b78a4aa8ff237ccfd9ba0ea82e2e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0664d25f9a7c52e630da552efdef8dcf9e557a604e1c0bd8ae005fcd703d3cf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd1ceef0f8147d1c8487ab1efe523f79e4eb0326670237e117c2bee7b3622690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1207b3a5e2b30d0051c1eee6d613f9c442aa4649564a255969130ba9d1e8c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52ceabd375211d68ee423d4255f21e0627f2ddcc460dfaae031782e06bdd44c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516a9f263e70f2464414d85b2f973ef744407c5fcde365a264460be8c326aa8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9118a38df77d11ca5cbb0d3295fc9083885fcce74073eedb03116da15589afd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f82b064fd31b6ba5ad778b399e28a5779ad693b8775a22f194f1d800bc9ed86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496ea46b949726cf790292962338cc4dcb982aa730450b7a6eae9914e43f6c2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6be2ed90a9aac273b9e6574dab2d7fb98795cc6ad0eee8dfa91107e2c75d0fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92441dc73c719b29a3d2daefd028f6626f77d4ef8432e38b8013e0bc3c3aadb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561bb0e1f8200c0de0c7ec306abc0a1a8f3d62a225fef0b5e7bba1a31acf34aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9fb4c9764cfc71b6d5246b9929853b1f9a36a29c913c46f60666d949b2c6e24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa412da968ba5c0b8719af6b48f3c29b4351ef71079460d4d245b403e532e0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741d50ec97403566c90938d16f65c0dee122a48922295fd2445016c31ad50f7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74535fcc25eb4814f3eda67947aa17d1d6f359b47c4cc2ace1ac27327ae6c42(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508d7ad811d30371b401164153e03dbf7e42b6285a40efbebc1896f73c973fbe(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2f34e7034c9117d1b1929c22101302dc0a0ef2c162eff846cce5b8848f8bd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5133ef9ec2303bdba0dc52dccea8f01bbf770abab4ca4e7a4b3fe80e5e511111(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e2516dca7ef7ade218398b4bd72882a5d183472bc51114820f1000f56c8f95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709c9ee620775260a111812939d28ff82d528511be71624596b6771f8a1ee3e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0053e3a65142e1f520e7291babc63a69c9f982d76349e8b0a15c05c09954b405(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ee06b8429a9039e83f35555ce287ad9516cdc8c16fdc9f33dc82d8e0be94d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e15d8a7ada71d252b6b4aed91a08e60b5dc4e032af2e67502027db2e1447fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fcf2091cf78f0436d063de0d07d104e49349ebf70d2ac93c0a2e2609995b295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403dc96beac1d74735560c6a6ccff4c5481d8e720413c333be59faa5101f9185(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9e4daefbfea1e672dd656e12d513f727484b36ce61c3303f5c676e6fa36891(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e099429fe2bd4159929de6ffd9e457f14e44785054fa3955711c8eb7ad3cdfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e85a7211ae65478932a581d95c03beda20ae55a24bf450a263d3dec198d26b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e753bc234795c769429f9fab8d83fb18f1afad7a4ef2288b0a0db68a364b78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26ef51e95f6a6dfeb6cab721ac9797741991c7792008e84ebe46a437e1862c0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c95902cdad16f6e962fd022a7c81122c14cc7d5b7f0f3ace706c1f4aca618e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361de6648c470a4169f3ccd41edf925c1a3427aa6ac813907d27e5c729832000(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce75b12ae4010ade7510eb3713359509750ce5f8de66a5e1d6c26e46317fd2a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c789edded22f8b1d8f340057bbffd5223209a0876b9cc301c7a8b412cd07f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5d806a545b6f1f1cea57f1426634178736daa6809af89a977702dd814b027b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b12120816ea7440446af855072c074f8d49a612147d61f2643c261bbf8e7c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccefae8c8849e9582c7c65deb0d646921548a451e074b452871654a41235ec4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e9740a130cbad09789cc60bcd14c947d92870dc15ae34b2b031d827221b04d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9d15b7fdece5b0736a846fc044ae862de6f00607adcbfdce569da3bb23baf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d426a938b61a62ff99432a46658797e18c3f966abe791f6af3feceb580e4cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d76a35f659a6d96396060954fcfe691b98a9be51c1cae4eef89089ad39c9b9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a296e55769437f88966323230d2ee74da2552accbd50447fcf61b4fe9f125c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f71fe0908f88283d4c1f6fcd0fc9391610c0cdfcd8db0b2fc1243f3147aacd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3541b2b767e44cdfab247c5db51ffb5494ced85667d48e67b649bc431d4bbd14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a5f1c4c5f797c28077f31ffdf8b82fb29084bbf87026f9439a1523b7506445e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb77fa83f3a2eafeae7da67ef30cf88728a475e13644b88dd8d48070db80068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f89d57e0b6b4c98ff25fbc157673f6ea18a878e3caa16cffea1880d39a17e40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f553ba1799ace935f3ded47989e3ca77640bdb22374e79ce95fd59cbd127642(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0959c4edef2265eda310e94073d59c5935bdfcdca486d4ce9d2190e8ed6866bf(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f16f6766b22cb9260773393cf7635ce59de3bd5bb4daf9abdc2ec68c12720d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e8855828daa5dc1922fe6d0caa16d4fa41450163d4e37de1dd7f9ea43aaafb5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a1fc6b7e5337352b5ba1f50a05c9c2de28fdf793b1e3b359312c22cee77220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ab643bde66f765f3b660be0cc9168eb4625e420b9e4d0b689063724274b459(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c9280fd6474d3cb48ef0e22810f827a4d4446482cb672520d22e65580fbdaa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b714d8dd06f10571819bf29392c18d66f8704b9e442bad637f9f8a3d201b1775(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c907debf08de640424733b5c328c7d4993a15b673d85cee157ed4ed891196f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2548d4899e980e4813bd7744d51fd2c1e355be491cd139904b29ab873cdf3b76(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0568e5e28116eae377c079357c17069e72a4bcc355a2547d9d3004904a592a8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12dd4cc4ff8583e23be8f877fce1ee2437cb592b53582b713aae8e8e7296589(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1152c65387a7e268dc9f45b5f07512a3d57b112defe58f71c1dfa4b90ce84745(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174412e3555b1176771f150baf31f403252b356fd483b86726f277f2c26e2ffc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44a013ed4525418c11eb948ad34808720ff1033f20f0bd57fb75eb3a691df26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41cae4253608764b647a62ebb94031243d91e046680ccab561650479a855766(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7bf18665df14eeff20bee0a807f337d42cba1c5b94443a39b538fcc0f8d5bff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafef35facd0174a23081724cf91c601d8aa0fd0377f3c3ad8652069ba6241d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d0318943da5983e9615c630ccc520f04eb3d614ddb89ac435768c85572209f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709e487d8a9e98efa15fade2cb86b60dd4cb72a1a40834cc2d54bd374c1b3fb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273c36235d5cabffb0b73c9021837f46c604a34626f7fd1be5f9601f56213e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a6666fe5072457e8dd51bba67db23d1cc13dae0ed233f1e1274db91dd559ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b5b099b2209a35725f086e03f251619286bccc77f76c078c1353f04d9ca29c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9640304606064583990c2b071572d2d6a2b0dbd69e6f61036b0f85e15fd4f9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5069472a1e6bb388fba6255bce579cf4bd5491b4402d4c2a3d3a213d984757d(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fbd30797bcc478af8a061e6254f81ba06ed9201a56825ce337b065e1df1b321(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6c02721a6e25d2c2300921be0b17c2668246edb14275a44427fc27ba6b1f8d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822185c0b234758bee19fe38e1b7e8413cd7d0ee310efd17dae659ee47fb87f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5785f3fcb57567ced8db89ae292a23aaa61b0cd127abd11a8eb97ae441235011(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df639977eb44cf1b4b03e1b1fd0f1aa98aa91e4d4c710f469694f8349b8594fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ec15ea959cac0794caa19a515956cdc740e398d131c933dde71f8388a8e22b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e828548db49dcec74e6dc1cddfc75753dbec0b7cbb3de4714ce3b83b218ec556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cce40bded062e12650e54207f9c39dd67b543b4fee607542f2ffe1c9f033258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4a43552574f74e657efc1b3282376bbbac5d5bfc682060b3d7d3163fc4f60f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d80f3929ade457b0362241eed8700d12a7ee01c7ad63c54088ca25d866c0e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c39dcc6067c7072b96d316a815447160ff412953e545533d6f01cccd7079e283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cd023620018c5d96bf0778f0c6b7dd88f2f6c61e2481ed146e8eff30a495f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__812c61a995ba9ad7b61a5bd2db2c67bac2834c0821bd0ca9cd53642bc5de911f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3711e16cd7ef908ba72cb167cac7139b7e4eb20a70ee435e834bea65409be9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fd2a04c3889f9b2dcab315cc102ab3000ece057e59d8d6f2d7701054d272f66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c711712ff71fefa055f02b7dda139bcb60e1ad0627467f0d73f78e83cfff07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5ac820463ebca3f56cabe571194d0ac1e707081b2def3ca9161bc5443e90e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ceeb21a2a75d38d87b4f6d195eda668f06ce26a2cb8591cc7d8b9f2e092b3e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94dbc8c2880100d7bb6dbedc39473e032019f5506f25743967f074d12daec4b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d6e37c1514f8e2745edc341e9c96d81cb4463591081bdf7a7d45f470ac6e7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92630dc30eb5629174d45ddd391a37233f600cc70b1c29b96bf1882d6764fea4(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5a0fb3cf8c09d6d8df8382416e003c76e408faae210599e4de409b83e9f491(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025ee506f1c269c657151870dc48cd8e2464ef65c8b53f08724bade7b6f42fe2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8440c24e608c0ad7eecb4a6c7cd4034eab3186c171f9950c21deb5c74196873(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a11d4a7add0e51b2e9f6e53999df54d45110614b102978c4994d1ffa309d49(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662077df276baa03e3bf123110278a89d76570772d80825faec9bbe7c8ab9afd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b94cf1aabb7d839c01a1c681574aa5c6d4b15ce3f713985c4ee2a2df685f138(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73adcd14b6c749a4659fbd745d1238bfaaf0a2cca9b7886f7d0d1164ddf415dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3e2157532f7f698c8610f38b72d5020e32eca8681a9559a97948d0c70b988e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7cf06f05d6efe791a17d71aa0d2d2c16e1328f6266e592e58d1a241d9d420e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af08ff43a530a1a66ffcc00132aac30e27bb4d96e2dab895d8985b8492e66534(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb940557d7993ff51e0b9c23cdda7f97f9a580d9e358705660a2357ef1ee502c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e1f7d29997ba5bf9a2fe6ff40d3322289956c7589cb15b665e42ae1848d2b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc59d857769540b1056e12b33600fd63ca3a4f12013355063e3a6ace434ef4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70192c254a76c9f9a8b0d8303b1c116ed096ca43a223d90f72b759af054e1a5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f745c836966dd2c2eccc89411281f36b7e4fa4a487ed9509e565f64f03602fe3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a0a3daa6b84556012d127463759c983fd4d01cca35757131d398d7395b18d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e42f7e858163cb80d1b9d2425cfbfa54696c2f50c265582de252d674b2bb274e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20234ce1068319bfd1c36c013c16bea9bf93e581174872875bf352043110151a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c3653c3e46d653786339e6a43238a69eb8cea588c77011d7ffcf84c6d0fd8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2b703ef99309d6ee4734ee48ced0441c3c97e95cec173a15a275ddfeaf19900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c53ca2da9bed135aaaae8fb03de40ac9f8015b805602336f351508605a9392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158ee9f2dacae777a7760d07b0f4ed01dd7c2dc5bf9de6cab7b2df83d901642d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b015ae0fa0c1971519d3ae3082d7fcbb5bea800d00a00da6503d24eae29fd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c179c24bd336fb74a2c1ea7400871c5604b41430c0b98838b0c032047885485e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3432f5d591b5baa5fc15d1beffc8d494c1dec660ee14f129b6b6167fcdf118a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9bc4721679446c3693644e3979e1ce4bb39933723ad1069b1f63c9339794b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96221b2ddf4e95cd70b1d6d520250be309d5046578573f084d5975b39792572(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c3793820c7692a4d9ccb5ff817dbac74d1347412db8084ca6ea4e3b4e543fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc3c48bfdbd5c66543000503e521469217ed0447a6d5f37ce6e164a27f23b19b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7186407da0ed72525fa26494a5aa4eef36bbe9ade27e2f5c9c7913b4e490d340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7056e4dd45d05bf05f6d2a41da737d83f8d8b70492fb341ad94b628b01bdd447(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c73858a53c910da406d6d827f731641940da3822a031d42511c98fc3eab46ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae9399ca66a6604466d9b8f3f3b3922b5d94bcc63398b02b870c50e3d4508886(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13d1ca7568379beb3307377c0c9efafa588837636d94978d14d891f69f82a67e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b160eeadae9d519230ad73e46a70e08c1957cca7597a25e1930ca24623a933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478c5e886e566d5ba88a60d1fca26e19ff25b5478844ec226d46bf748a78ea66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5cb1bbeb05731956062bc5c289383f98b7672d2fdc28edc30b917b11fe115ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26434c7505a77782eb1e44838c8656a2a7004a70bb2aa710f2612904156494d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295729232680c47acafacaaa0544b2f95f81fc261af011fcaa0e4111b70ad324(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414cae6faf403add51dff093bcd9abbaaa6a41d547da24179ba2763c6c526c9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5069d9d8885ebec910335a4af8a4115e186831c7fc7ec2bed70b480a56236093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b99e77a280a8461072a81e4f13089d2f48da64d3c13635841effc9a9c1a5d4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbb795b1cba8d019a4e60d0c111212338f6b2ca4d2b6084010c9b6dbe030cc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd71badc13a2638bc68d1a5bbd302d35056a6425e66a7cddc97f44de33e6c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c9f54d605b76d2cae3c18f20dc2037b69dca962519fba7a2dc80438a8f7676(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66268b3e3a62e8fb4e8401b3d2fbe232955ddb1f5bd71ef22cc5e30f7e429fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98dd3eb056dcf8ff24dad0b9fca2865bdc4fa05dbf47e8c30f907b4e187e71e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809c72119f258256ea1585217ce37fec6fb316eefcfd90fa3ed4afd94576e315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844c244fe7ef568d7a4832603a161f66c87139da307b5250f62034e62c63a9d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a6175c85261b9c7cb57c7ca82ad4a5b661d8f230ccef8078add96ca6d92c89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58771d829319c30a4ee62c4153e2f11fa13ad7b3481f2ecbfdb5a9a85edb31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51d6914459a9006dc174dbfb47a9bc8f233a7fc49bbba8ae6e8f23cbc2f198d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23949b15c857282382391ac8264ed9d3c306a19910630ffc4157834717a1729c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fc45264cdccc405cf6b33e00d6667a3f808612bb202bf3a847d3757f7943ce(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef4d6def8b6a6f5ef81424eac417fec82c4c6c46e26eab3c86c28f6dc0468ed(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca27d8768d8e66fee35a0bc25cc7c9831de094b6f730d72eb896f486e01cdc7(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30c92f19e6513270e61160fb3a8bdd564323fd1324059a46c8b3fa22f421c5a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05dd5710b878b7f6cce913966dbee77b7c1800b186037a943cdc3168d29a6ac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6400609d54c77541bfc722b0951988aebefd10c133f72002fa21f55b9d54e112(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13135d8aba204809bbda63c5c0d66611750ab8b883f2fbb268bf3248443481cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32a967e780079908c1f02ea04fb5fecd94a920b5b96a2ed64209336c07fffff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fa20cefe2c894ed166366c9ade0e674c269a956f84616748a05ed365bfd5be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb08c0d5713095b029b5bb8ce8e645908376244db83f9abaad39bfcc768e3682(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4a86cbd564b05d60cb150d6a8d7e06bc7c5256cfd2c8cbd45774ae0d205122f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3db10d7c2d7cb477ea28f6be00a74144652ef17df08b20c0e7dc119a33966b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0a9f77a5869953702c91c390774062a0aedf058f072540fba73abfaead7fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8669783d3027835789bf279c9bd07d39c76d9132700a625137eb565b601390fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a84838b694ffe8e65a6caf3e8bd6768be3f0449fb36cbc2daff8e7cc26c5bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3d1fd03788beb4d663278c17c4ff9dc6e56a2d7865a4e37884a01847d98092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648e80bc202704890c81b43e72f87118b75838618ab15a9ae70b61da3802e878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55cfb799dd0ce1c7672a674f74455a392774a4e7b0ff68862e06d86a199e0a85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f89ebda3b9d5d5a4258a3cabaa34096c29c6de31616866674b046ddf59c3ffa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67125bcafb9d8deefd693fcfb3a059972aa289c53ce34c8316c2f4b460a05fc(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c798748227da8159db0799ca0d8f3e526f360d8ecfba97abf77fe7cc7878629(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f60798798538e64d34f9621148f9886ea8026dc507a863bf1b94d27cc215055(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e5d040f9a21b7cbcf80e41379751a537cd34f44197cb4474fb772d442c3092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548672d7416f7c5b6433516618b4dad1f45a5e1d41bf122f478a212c1333386e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7197617ef24531dab9937fc9103c878c2d1b5bd892ab4fa04fa285f348f662(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f94decca908f207bbd8d213b7f434e258a5efac114cc9c1a414a3c320ce2bee3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a84e39b81bf838ac9becbbafc960507d50ee395927071aaddf2c40965e9422f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90b2581c214b91affb4de17c5b23bf3bf0520f2c5e97f52dfc2cd82f872c203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__371134fa7912984d6b9675c98c78240e3fd5e2b59acda015e3547fff1a94fbf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d19159036bad8dc9496e197570215abf79636aede8727042381c841983bd99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5d166bb6b218fbbeac3b903ecac51d97579155de11e73a5222020d5ed95d98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0083bce46c7d64fb4d66d5c44978db1f6ce84c87c133c7cb265b378acaff6e2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786f105622a6cd61b5d344b64ea98280271954adff641a9eba7e3fa63abfb230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27944b9669d7972e922f9b1503a8069b0e8cfe77d2dae4b5456f386df9c81534(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a54cb2da53d68419ac1bce644e6c580e684c472102fc171f04a7f58a4242528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf6016ad8e56451b12753a1cacee4e990cd28e50f02e8263eb6e80c7cb8ca3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6c01a061881632e0c1134abf78de08e8bf203cab67ecb68a8395daa48035b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b1b1bfd3d867a4e264c114fbf494309b732387545eb051a7eec4fd832249094(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3433c67072d63c17cd690b5be94c3e4ae94e8bb6dd0e2493b537dad862b997(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65dcaa785155823ca45a0bf5654e35566e6753e5f7e9296f391652ea01e6f662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85cdc64a47be91ac697fe5d26e5ec3167b30be937b011c99c5ba758c142d9dda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b3f348db8c2e0b056ba316a63a4b3764b052d7ba0672c1e03219db73568c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ed464b3249f879836f415b9321e7014922ad3c1a9f51891a7a9e7527479eae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e8e00ca09ace2c1f28957282ec7abafbab947fa3feb861254f68095e80f03c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3609072836f1405714452f12d6a3e198fc647ff94fd5efcfff6bb46a84c544e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe167bd0b1a8c6d11234aec8672fa3d640d9f19620ccd370fce6b36bd0f2ded5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3aec684fb532dbb1339227d31e92c8c214ae072f1a0965be23b1a0b95c1fa70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9f3281aeb5a171bb4dafa680ce6104c904e1985b3a18c3c1a06a250fa1c10f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9cb348ce67ae6e0b891eec5e8828da67d3d99ae40f35daaafe02bac033c98c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88eca306f127e5751379de8b31e76e4807033117a9559ab6734afcc53bf23d56(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9891f52365e48ca6fff5c4b7e20281686f3e13972c435de073341a44a463b9bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6868c1690d7d4d755bd325448da5a2f44eb320188eb0ca48f2202c9185de4619(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36715be9ad939f856289025328523f1435dd43b2869e61c08610e1f1d3bed6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891a8cad8fe5cfb7c266780ef78140028691b43b9d4f0236592cd9dd387cf37e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f481be2de0dd93b42b91a62aaacc366f4c4d71129e6ef3b8f3c4c01945636b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c0fe173f38a8355c05f6355a2807a66ac01076e58f18657c264c6c2e26153e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8c6969810963c3f9140734f53f9568d5552bc9df2fb42e96c003e9a40be6f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28f55364be7ff044aa4f505aa8c3a84c9247b54cdab9e5d1474fff7438f5914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7865ed029cc90d4a62d6c62d1a132a7b67901cfe50a779203a2c4ec76bf6961(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb66fe69a5a5662484e849612787328214e5b29c1a20c92ca6c8a3fde8581c6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a442d1c38e08bfbd6bc63a8cd786b9af593f51707590545e80fe8e1285bb1b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38617b01278d50e7723dd957ff2e78cde9f9681c5040f50fa6fd0d7158ef8798(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ee240e47d3cd9f628cb009f47a30bfad866eb344577d244900f45d263f1dbc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c89bea9809e2f7c81a4193a65511ac54127d23439e9dcae330212f8875f2fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a803bdcd286f84d9953117cb42122c171587ca600c252b9326cc790c9058c0f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab20e0357335826f351b80784d531b46cb41a4daa39cb954709731b804c87dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53817c8ccebe620ae7518c695857dd4b30190ebfceb8805dd915a14a428256f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a034e2f7c5bdd989ad98e9f2fa502ebc4cf039db42adac1a004ba9f61258ea2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad02eb06c511b7092127414752abaf31448d9a6bc4f5ccd177bf50841b35294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669a3346ca4fe03000aead4267fdaf4b533812f2a5994bd77dfc71be41eb0184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6530be3b0b59d05fa210cdf2590e0544c02ee1feb14ed194a89452860a53b7aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5e5a5ff7664232f2576b552845bc566673a8bf70a9045b633bda8cd0c6339a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ace11900273ffbde701725661fdd3e2d5b7714350354cc3d21cea7c9f994590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19517d29782b4b97e1c713a07acbbad58ed1a0bd75f6a64f1274d97247ee5549(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce5c115fe3034dc0da33be0f68a36df3166b0608b7862e0387aea9157c854ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e378014fcfd1a634d272629a31244030635c53ed49cbb39a42dcd3388e11ec10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730a592b7ac9020f46908fa69e75cd180871d9c586972a352b995f0fc1b76bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7a9a6094602a2e8d8cfa6584dc93e3099e84ee30bbab535bc0fc11378af335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdd211bbd5bfed879d0272f39dccfa3d90e0d50af0710db56745db28a3268467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f4d6234163b6c2a9693dd45bfc46c68f5d90edeffe35348c23c2ed93b8c7e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0fc198c63298df35640d607a069fdc623b02e120f610d395256f63a443ff313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__445a0d5852884591e7dc53e251b57eefa0e143979bfaa1c109fbec9794f1fa2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f5b946db5e59d2e490d1cbeada1712faec0cf3c1a439dbd2c8f7125a1318be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d82874694244a300126d9861ff844720dd00b0e9cda5a5203bc302879644ecf(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6aab16b85b5916f44c37fdc12c1c071f7bfc5ae191da985988cdb186c0af0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb0d445e77b354053df5810a4a81f1e93b93d976b62cfa1eab3c5e1663a4e78(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607216669f58a7fd09309a855ee4088b9fe92833f8874b362569f67888c4a8b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719da351bb7d38aec11d32538854293eb53471773368e172a29b7b28a39a7d5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd87665541c2bbb61288f8d18d56bbfe3b77bca59a7a834cc84e26fba21e1e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227ce7eea00b8a3773226edd4f4dc4a5d211a93df1809daefbd1d0253672b007(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589221dd7a2ffc1468421f482e76346cbceec5cab77d38d5ee612c6b6bb19d0e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564dc9c77786123e9e5de1f11050bc0cd90a1108c0373f25831df062292edff8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd36e3a5358f3b0f2927067366b3407621f0dbbf00c90a21a393e02db7961ac5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2128d09a89c2f56a6f36799085b2527c5d74451194989487c06fe0750bade740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe3273bbeb758af9a690064ea5c979c3dc82cf3e2c4aec8254d146447bbdb133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fe394286a4080d3d85dd18d11e191a9cbcdeee036107468abd3f1657e884bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893a45523f019eb39c3dc86de5dd98497cb39dfb23f171080d4ba45bf8389c09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c55852cfb458380a79c27d2c99ccb0633bf4d37f31c2d19f95ca06f500554a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d131cd73398017051979a51bbb6b75fc574c3ab3aeeae1e1eb0542b76142de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83f4e336ebbbaab918cb9fa934129afe6bf2c232b425d08fa6546353418a8f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b0645a31877ddbf58b14bace694553f2a0c4d304bb3d1eb7c7ecf66052dced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15498965b3d6ff57801965e2f9b28423469dbd9270d7d56e9329e3c22c088a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91aeeecd763081b794f1e3a82368a90d1f146dc0f9735b90941a3dcbc7dacd14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba133994bfe822b4ac7f70818522d8452aa58cfef6693d22f9304469ee44f25d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a454c028eb54c9557435825500eb4ad91cf53ba8ae4f3d6a67e89a8253eed7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eeca2e47461df7925f930eb3a1cb30832c428b4ff62fb2d2947b1dbae62fcda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d1f2298a32aad5989b003b50f50c974fbf14f9ca80b9f5688009452df127ad(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e4d30cb0bb926dcdb883366997352d6ac511f94c235faeadd4371b7f00da57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf6af5d97edb0eef55d9f3a302bd2772fa1bde864efea27218f2a170a44476b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88716f3692a90181e5c038f2062cc460a3f3b8603b3cf70154e71855266320f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a600b482bde75c1e0cfcd92de649e787f4702c304aef6642929e893f25e70f57(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80401637dfe37ed654b4bf261815c9d642f551c0a592092b8ae65bd40d1780d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af5cc01fc250b48f897f156de6e162a850ef57e9862b827d9c7c22b2d648fbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c721c53ce648207efa0646ba05dc4c09968896fa8af01a8a26f92ca88d3620(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0512f9419689b99425912e91ed74e87ea659e1acc402081f5ba810e3b55def7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ed7909d7b0081e2ae62e293001c268fd29d2a5091f21d4af8259bd5e653a20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3e1431ae8feedcbc5cd0699b1be637aa12c85ec31f9bf9014d45d505e7f312(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd33e3143f64d2582bc0fe3a9398b018c150a452464cb85abd4f9d109ae2d33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc1211ae7bcb68f766217be5117af555c43797e3064756f698efba08ed03003(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a2d278c568469061b5e7bec4e5682ee1c710ef3c0f83a393c00e85a2647035(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce1cdb3b941f128628d396a52df4bfc903220b13218f9a5b84d869a17787f14(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a823fba7aa6bdf7d299e0527716b328ecbad91cf47fed3aa52ac8edad66a20c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52db3870fcf906b691ffdfac32aac07a03043c306a4fb65c86d3ac3a51316964(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab5772b253d3c38b8c3854091e8938e1d92025d929e4e9e059042446c6ba54e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12df38ebcf38ae15843070954470e4144de95323d5aa4a0742c5ab6795698b4e(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928566c583ab40cbb52a4f673f8f6f698a1d7177041c56ba91a96927906391ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18c6cec3e7dceab6e192192bd7533ff855702b0293ae9edd345d994f1481df6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3557bec93ec4dc62e2c871d8e2664a63ca2f417a30e43a3611c181fd4d3eb44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa543ad48ac769ca95940ee20335b7877963f9294b41384abeb1c93cfeb515d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88c007631b9286bbefc86d8ba7fd5f3238da5dfea5f6c170121b4b1ae9c2308(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96596e2d9dafc550fdbeb402c414c502a5abc03239eb6feae858e4ced96a94d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0296668f0de35151668d75cdb77a576b701ccc99a9bb2f7950feaef606a9db12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb569cd4b95fdb7c5a731954c51d8a5f13e98e51479acf64a226182dbbb60a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c62ee340fb54e1cd8ec28b09c381355c6e447e369d69715df79310f5d0ae22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0814ebc4d4abd9952d8dc374e05f4f86ea3192da51eefb762dc56bc5a805af7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7169fd0c461b07c9a376b1c70a5cc755bea8d96579d3932550aeaa9815d9467d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14389f8b3164813bbb843a7101029136c8b54ae840488adb54a90c578a0d53d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c951d2146257cc5cf712bbfd6b4e3bb9d131aca8d2a0d89fc95bef3322bf6d(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d098a75e5ff4bd39bf6bb1acf53dcab4a7e2967bab9d7fbf91f8dca2a95fde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fe6fa6d0362daafc56fc0a86432af5d8ba212db798afa2bd8728ca0c6da57e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8271b5c0afcd7bb5e0ed9df91755bef5f664aea9488fb788ec83e76408420d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2499168cd210feca94dd7dc9f84cf05d014a9d57f893ca5246e2fd8972782182(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bcbf64b78c770875df2cb4c99420542d68bc4ae210f629ef444a250ae92dc30(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81e74c75c57b34d64de1ecc2dbbcaa8475a0c56f3fefd7f214e5e9d2cb67d24a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e22c2fe4708323a5c8f27d7e197f580db3f349a7210c19ac8edf3b6697b9de5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02549a95f2f830919bb90c9caf135c4ee7b34fe56d757900ef89b665ceb5cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0993447a675b9ea95e57edee40d59607852ca9cc755023d044d171e178238af5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d1a963662ac2de424c2f17d1512450f0798d750d6837ecc8f9604e05d4f97a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89d6cd7056f0f3f6bc98e954b5066cb846cb970f8a8c845794e9d4e1b79c02f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d89e8f5e95411ba28a98359ae7d20a01ecb99ce08d5cbccfa0719a1dc34684(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c45375c87e0315740f4d8b5104bae471c94bf8c44b41b184ff175cae633ab2bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd8eb3816966730f57bc9c450cac286cf85780d92589e0c78088b62192c0f03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a94c8bff70ce03b56048ddefbfbfa83c3c433617c3e92c39b932d446c48ca7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f7ddffb796f8704c86c7f3f19742c0009fd4ead3f3c8d9579e0c26261e49e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b93f5721ad0e4c03c7f2e868dc9c710fa59baff239dfa15887bcac448eb3277(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28e5b3b871f52e053c2439385626abacda3057ac8066044664c2b67e8498634(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5a23697458be1ad632487d255fa2c20890e0d8b1c6ee840593b7352344299c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b1961a4626400ff577cea7dd66dc22ea5f333d021cd599d73130deebbc0ff91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda4409e0bf93518e452d7090ad5c4a17ff09246f886d07188015d14dbcc3a87(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295fb93e790599c137a6d99fe948b556b4ac181400a7a397c1b7458ef889665a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380a655c734e00502fd75ce3a727e02d6dee40808c3799cdb0f0d9c67ac6253d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7eccae1187a7c1d2085ce0416a0a95c29e0eb9f75aebb90b8d33f3d8c883966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d1497958c220390e60763408f4a3fbde3001d0cb278b279c24bc0b9e7cb71b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dae1f70980ccfcbdbe40de1219e26d65b40be1e88c63c885c3717f43a7bfd7a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1459eb8df3f2f1b0fdcd26dfacb0505f4414874d451ec7cc59e5c3c3be6ecc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f323aa86dff2f856739ba628d73927cc0e0ccc5fef183927170e6f26e4a526bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e719c4c7178b2c5ae98b2b44145e4c035770cbb788dda2309ce993fdd052dfe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abdc458406d5a3e40fe05cd00b8968a94f91e5c00bbde085730fdbf782cc56b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa28b25139ac7828bc574c3ab653eead13f6f0688e1721a25c1a9f75f556d13c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0503dbac3b5dafe73f35174c196e39b3216ea1897d4b9b7e6a6aba616df684da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b5ee34195fc2999e8f21f1408c5bbd54a2c5e4d556124746a6026cb7e93068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff4eb009d4dcca92768ce6104756dcbeb37107a10ba9b2158bcc2041ab328ff9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a72bcf908d7b084a3932f19499cdaf351086b025a41422208b8c0fd216c3e04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5679d938691a39641a556444bdfaf35fd7c958c3c2e186e4809eba7e73981e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead662b498a82860b2ba6a31a9bf0f075978526a02f50d87ecda536c644475b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb5321498e5fa5b7d284b8319e6f806690b125c93f469323513d1726e193d43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162bdc3234b3c076098b791f294ec6543c1a9d016e12cc4a599575e165b855b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739bb31d88c99b263a543d8c30ad0a8c65554419d1e76d0f09516c07b6c15742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e86541d78a1d4e4045e03283b4407472aba02b03f726eba321ff7dcf11fdf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac9235e879137bad105eb4ec440636e90797465dbcabaef0a340d20260aa1de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__314e7382896754bef037fb90e8bf959b800be1f787105a8bc1d78bb0507176b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411f2329c618d11b8729fb9cdfd6a19b288c3763a686646040db3532ee9a6424(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85802681cc6eaac4eb059119b8d0ac605ccf04923c9e6431dbb752ca7eca811b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad3fc1237fff3e083b32838fa737179888b35adaec28691c4a577316d6cca05b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e9b3d19149ef7703bd4c976354d9c1fb1157ae1f2da0c2b583fbb684b2ae5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb06197d065465e82f5b55d776997b47018e66d3d9eff61cd948e63021b2d744(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa099cc87d780efb297e06b82ee911cf4f3b7b293a1656f45d7cf03ec2bb449(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe6a2f9698f33c49f8828ac3206bee405ee2d88e8c79ae64622d542bfc18080(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e6dac4e17a8e9526dba417bbde7b5e82c340414e791358affe10ec0515f9e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__140d112197a9540a0edd7b4ad42b710f8d0741669ae6c13064ac99ffa713f6df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b258dc5cadbeb0115ce57a76b813a31c753e4684eeb46c1aa0aa3204261b803(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2cfec875a8fa5040fbecfcf034896fe87074575aa4a5af47a75fd6d6600eaa6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428af7b6cc361cd124742c03d5ef1880310a478052de9e7611b49a321f66bac3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7731b397a63e4421d59080ccbcce1cf7a872f9712913707fc8ef971f1772fc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6cdc31c7200dcc24ab5dd769c59b9618432ed378f760a7bbfa90cd7cb7db82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae6d2bd47da123edbf9118a8597121f335e7b7e80a3ad29d2509626e24d4926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6153e268c7373769ec9e30f292d10ed5270b81093a4a3c91289ad5c80f4dfd01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5660b0fee3cff7807bb47fcba5d12eadf8ac09809a9b1259d20ad7f81ec7dfc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02320d14817267d58800b39042adff2ae46eeccbd5e34823ea6f589079287538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51765abb59ab9dd6ce09bd45eb02291c18959d370587e780df9a3b29a262715b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af44cd422baa84a811eea81d1d6478830d6f8ee371c1d270236040680b9e4208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072c7f0b9a9e7e2b52acfc543f68516e9c3d4d3005fb0419f66d65b583805706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1717937a1e6f07c333f5d4660233fc0c39661fc6e82de4a5bd78e870931518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61046f408dbcf13a58ab0f7e0bed0b66bc43ee67bfdeca3854b26c4b2860f723(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4dc1d559a280a428d0d1783dbf28a73748015bb705d02d5b6252ec18761157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740ef65c08da66ed4c39821c91cc3cbb379362bfc54d904fd1c4f4c298201761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dee2b471f45ae838b7bba46f8e0b40f6eed1f04d48f3d40c6eea4db383e1cd6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bc9fe8319a8dcc3f55f54a39a8c95fbed0d19010ea9810cdbdb5455018c9ca4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83cdb1484cb95b18b47f8e134fa88df51207382e8f37f8ee54151e4ec619e233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6659f4f4cc0e661b3a36bb62dcfa5275d444af940406c7e59a80a40494b014ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f85244a68c102be16a629b9cda14d97adca1d979eb640d8c164e194641c38c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc98befcd78ca0e306fd2bd13c8b4934df45d0ef4b7f5e653d493536c5c8df9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6345259a647f51f62e906d2aab10017d4226aa90d8aeddd42b6ef28aeb5cd0aa(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc63d37c6bc5a523b61e128eb26e7aa61177e88a61345e36924f651d2283a584(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7070ba76830bf897f9e54915e9b27219ef7813797f62b9991f0164f524f07326(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e8c7b368595478f54194fb352000be1853aa45c9b542b721655e62733f08ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43ec639002a693e2713a987546c4bc5ef4d30f64f5dbcd9e3fd5bc90bb952a1f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6321361b8ecfbb5f16f736cb71cfd07a2ef69bd721f91130f1351cf0d45ded8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6810a4fed3051c9b7e02e3c78bbc777f56d257e0fc9f350bd12abdae90e435b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82738c2512912936838f6abf980f863836a5e3eb9a5cc1bd40a2e81b63010ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4edfe58dc4fab136a5d140f4704ecb9c09f80ee13827673489e8c92e50cce4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c3dcbebb887853d4a48934904d9c49249283893468b4d9b8d32379224a4b06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f1ab7e9420a222ffbd5086f6eb40f5d4ddd634c10d6b7c609d5c61b469636b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4a9561c7f4bb85d05761e8262df561bd97e90682cc44cc9264352e447ae583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b84bfbd7c44729b270309e4981b355f15379a5d93ae7d73dadbfe3ad5c16dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beecfcb1a0bac5471ea8af68415c5170383b1489f11cb8db0e2493ba534481be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361b5a52b9b517bd934c9058e4e5cf543737f255cd803bf6a1faa053a73d99de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f143f4f6a01aaf04d4c78f76d20e9e5b446be783a49f1dd89406055d728472b1(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cef692757bee2b4cd1f6c224dc8f64e1adca8ee4a95a0a76f9957c4c1285805(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaafad3712ff2d6677d1bcb05800ad2c721e6d0f88aef2323d1e1e46e4b506e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52b636bd0848fb3fe96c706a583f6e4974f9125288727f49eea91784e9ee851(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64a0d248b81f3280e1e7936f0d1cc6fc18c6e1b338499755b9c540f260f3c7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8fd2c9b8f054f79e2f0dd612d2377e5e84ddd74779b38087000a56d62d11568(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda6800262027924714f4d72002778a7e11420fa6dc1b3d334985c50708a53f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebaeb2f33a6892ca61e6669be07b668416c13c61f22b27632ae3d93754468c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d5bc909e0b75f52d5b9641e974ed1c100b50beca66a68ee95cb08c5878083a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84cbcce25971afc312315722a1294517cbdd3f3896ee86f9709ef83e62a50009(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee601e14a01a2f92447203504fb66803ea3c5347f5995d7b290e79fdec0321c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd30f9fce850021be298e246788ecfd98714523697adf32db4a416b7d1a6b76d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf80b5f090f6c5ede704d4de1b308800065ba3395246b445d48f90d092fe76d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6423b5d8ead7995402b87270b97eb09b182175b549e7843b6c972e676ba3a776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f25af921185540a05af994fd67f032b7ed7e5977ad1c7a42ef0636417a76796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a879d4dddd6bf1e95742fbdac3011ad006aa47bb4c872e6ce4efc5f7b2bf53eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c2504b644de98f96beb4668a1d66a5c497af67ee1aa8b2459d64f9fd26b5d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf3d9cde18b6a92670dc7f48a8a0df6220baef313acc8b9e3676b948f880771(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0e1840a742a7c0ccc23638dc84e4e381fef857cc004b0d08c01479455e3f5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58c482a1b864921611c2a4d2ad94c95d61f7514b6f39dcb1db24cb48984611f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28ee838b7d00d070a91e4d9d2acbad572348dfb7cd22db4c9dac0a3193f4535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97a17f0a14530c7975f2dc00debbb3f5657ff052b1d57cde2613fd42ee92b1db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aac2c464b9b9500b45894e94f8566e9e9d27918e2b2fcaa5d894d347f230dfc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e232020debe7b9db04c17798f67782d9b47f750627823df544dc130756d8e99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad7df69cdf67ad53098a5fad17bc30a566c6a901ab92488b4ddbf7241e3cd16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e23ce80bae6e45066f66565cfa553a912edbc79900b103c23013f30d31ba614b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c0476f71c01463a7bba3c2121a27553194665cc2c5cb22446edc19564ca50b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83093d474f5d4751b92144809c5af1453d0d60ee2e7cf4a05be339e3bd0bd6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9fa6144e6ff57615139fe2c8d9cdccf4c6bfb53f3da194c005656f035886aa(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f72b0e833d885df17ccff92989f23c306ceb43e406c4011f765d4d6d9ee5ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1268e500585af8a9ef8be446da8c48350f2c48d4724de3cb7c8337dd89b1ff5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__372b5bf0d09d9d1c5359bc41e301cb5ee3e2ec19bd1e8d94bced05ee5140d99e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea536a1dea3f5e237e4134f8babec804f8a2064c4634d96ff8f6f6a53a0540af(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63cf47004310c7e82eb9bc107d58fc25a2e65039b1d87a8ca26a81322292fab3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d544cd46cee0d272dda550eb1553339b3ffb40f2f5a1f4f1849e4311433312(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cfdaf9bd65fde4bc54876693767a115810043cbf8e7459742e68be158664ae3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c006670cbfedf5d09a32d67e8ae48cb95f367ec084f64be41c024d1e6002207e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e92a243ade6a61182ba1a5dd5b6a23de97bed750ba6aeac8e0615f58c11b9b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2385b369094ad0d48402e10f6e9fe34d11ebf0c63727096abc26652441745e54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68653a7cbebd5fe41bb4c07c1f8ab4ffff5402a524923da424c235918aaa9c8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d61ebe52849af9b45f095f72d999a3e74f380bde97095b023021674e9792b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507e06d34432a42032196d8316ad9b34c36c4c8c9a2b556a6c2177ab338c7b43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c6173b55bc8dbe974cf8af817d4ac43a233c91052f564146c3287a0275dd23a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ed61c6b40cdd035159912f3096aa7d5d23cce55668d8ab03b9784de26be4e8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3e3a0559e721b569b64f8c4f8cf9d3f5947ca194b62460147326811e5bbcd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1aef373e1216370b94d875c9cbcfec8a489b85dc662c1d062945cc3c87ba19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a777b766dc10dcbfa1acac5dab456bee5f9a403d9e0c5f6dd02f4db8d689a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642f7df336e43a7bfd611b3e5bf1f929c2c9ef920c1d3ecfd4df2e615cc603b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ef7948e697acd8189d11e213996702c9b9624c1fa60940d77f27e591952fe1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3c73a215f14908b784db02f6c124acb188ffa480e717e6368d81be21a92637(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8247e18684ecab05e0123240cfeba078e4f92beed04d348943cefdd6ba086fbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa69771f71474f3e1df4ea6f4d353a4c28b338d010b15e4b1a15bd4b82239f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20513e3e4b2e04183ddaae2e76d5e475fa429fb60bcba3421e14cdefd391d30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180f3d90ef2b2dce9158292568adaa283feaf2f376e7e8d8f998e559ab22f0a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6790de8b878b5c246731cda22cf9ed4d4354f6f0edc45cf581ffb516a0b4b730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da79aa8ab880ba6c64605465a1a351c12a2c9a76a2a11856ac9ef964958f2fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ffe47d377de607fe0221d34f7900946d98b0f9a4c694d4bab4ba1ac900ea3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91230d6628310ca3604127978cda77827093d1492af8f1d66f7568318b93db80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063b70650bf2af06f92dbf909109919b54e04f696a0519adbd4a2c0633477315(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35d062d3657dad8af44f310c6f1adf97d77924dbcdd28caf390192f3a2612dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a9919a7300711e45d27a8a2c78348c17fbdf5d134bd97f68b5618e54fb91b6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de324d0604bb04515478daf94ef789f2ae2ee6ab2641ac8ca1452810f1440aad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d006811b56c025d08ed9d85154d81fe7fb606b25590f22b0e228779558230e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb7fa2ab499480865b8d381d34183afb63182c24054a0ff3190b00f1af6abf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d842beb87894efbd4ed81e9038bcecad84778c595cc62161a97559d1f3439b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__308da57216e2239ae08c81d7f590867b0e15c541ac0109f00c71991d1c8351e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ce9cccc5b72b084a4229663c71d988970491d1eb99af54a0b5085ca8ddfbb1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4291abf0b63a0263600424531c8b672a623cb066f17de42a9ab5c348c9855a30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5789d8a2bc4b72a79d9c87f555eb2b7ebfc52c344eaf71d6f4a176bbbd92b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa0c9f9fadf82dcef41ab31c84a3e1273caecd778d4ad1b1c955a880782cd6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125dc3f5302027cc0638016f2a4af939387483f70059d77f7d9c59f937dd1c3b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc2e0906ce0715a5cefaa39e7a8eb43391a54d102fef47d6342aebed438585c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faf384aa45849a7d9246edb02fc3d5d6ef726a677dd42687a6d4c92f0788dc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f33d93ef763533eda2214eb48edab9553b800adb1e2d1df12fcb3ac4404c0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65168f3d58f0eed9106857b594246f68e1d3fc08e5751ab4e3aed3127171ff5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8321396eedf90200129dee0a074bb4fee37c493b1a19dbb5dc315d12d4de75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e64ebc17c4539c6a0fccfc17afb30e12cd99b926717c4c7e986edb0816d3601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bb0165f0f7722ca9ab221ba807881ce7b096dc5a893767118f53f348ee4337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c31dc682e7a0c4845eafa57c2ee557817cbe56e63c2c52827da5e73ae0d477(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e646d32144f70fca5132092eeac203460de7851695327cddfaee6d7b3781239(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca4ee2d7c9b40366f0f0caced0025f9605d9bbc45fbecab5ba74d8e892e7718(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec4c2aa1898c01d035b289bea6ccaff437ff5083dc577dd29fb0f7281d1c50d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb740e831679cd376124d2c9c120cb07c01c45f6627ed90e3423e3a4af35c89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff08660544f952ba0372c1127e40a5c63386e71eda84fe23016e48a0ed47dd80(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e54711ab0c816238053959e6d2b7add0f566a3998fcbfdf5caecc308c4fc50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb460b1cbd0a37c57bf266898235f6f2ba47646bcd4422305e11cd9dd193426(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b83d2a21fd454da03d4ed82b95a6b171810e2a82223033a62b71ec510b2846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bae094e9205a2a0acd89107b3d68c8fec8dc49af2836a077a258fbb0d2caba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f914ca24ae54f0b3b785000046bfe2ef898a8224e46dc26c461f0b062fe9bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda6dc4e5a98318ce9a6b547720fd2faf2699b27daa2b633d23dc31d3bf3a438(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5879152e41e298610d11b14b42165751d96dcba22ea22961390f55bc2cffbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07c0e3eaac2efa61d1be7622ba41f083c0e9849e1fe00477ae876af56c49a39(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a303a0b7c60bebb05958d959888444379c07765e428538b632697b1587cfeb8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e7228ff0b3db393687e5ca2766bedee7ba4d1be2e3f4c0028441d4cbdc4c71(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446fc3625ea411d792d7ae395c836b6334c7519f16c60f0658d40510ede48e3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3784ea72b610529396d00cadf02e99843064a967ea93dab912c06de5b37c4f5e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d266fdbf9c6cde82469cdc368c45004a56f4ee0f2680fbd0b9e7d5c4d7558424(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef3c498d89b0630f2123bad14f0d84180bc18f2de093538b20e71339e63169d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169f9dfbe3e977fb4b38c2da05c81d10800d5fea92d1655cb98494e96e0b09e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0588fb736ed4a99a176436af4b42f4c3d97338873aceeb81031e6b2a4d947a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e603f3bad41bae26a1104448fac4edf1b64fd0c3cc4e383c4826c0de05ec6eae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d27173e55240fae82f7257904cb89a470f197a62c3d21fc43891fbc5e3e7f0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3447e35c7d4014c0cdf28881dd3a7ad2467fa57db71ebd5871233e79272e03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1cd225936cf27aa24d023652757f7e14a8bfaa78aad58b6e6455e58c4a9706(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8d7ac487ce79ac3c8804c4cfe6cc2d2602129e0c248e7708838c72e682c69d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835a8d6475487b0b216c97ced9947ef2682cb248d9bd81edfb236b971ec6a6ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4710da2126279202dcbe9a1c8a766227590db04aa5beb0d60bb8bc4c1e16491(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de927aa7c6d444c61b19679b7816432be61c2aedf526e41ff6150354bcb7e13(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7555a81cc09fc34acaa279d4721842076f94548898389bfda49b74f1562ce29c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2aeac0354fff2b759d26982c79651d1450e5a88e87349766e569225b4ac6f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c1354e13c94fc2c041db356d19c980601a268a6bc5464f2a4b1380bd8a1cca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7719802e1e7cda762a7602de58e50c3a0ddcce36bc5b81173460cf019042405(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b6bf3c1af96168204355185975c5b0effcf8be00bab1afb5834e667b3e90c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be38511cfbbaed979d00f2d5f6c411a15f4bd78b81ccbada93d48d5b1ed982b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b906d62725adabe4ab192fb64f325d98929ae19624580b644f8adc2266c8019a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159e6bcb8b9c7a60fe86e64f854c81f9225fe49ede3186d32f4699ac13ea4d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d54e95f172a0d54c227e7c3110dbf24d25c4e8d9d6e967f2e032a5007a32ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0246d900dccb0b8335a7c70dcab34f78ee8f73756c68aa43b637f34b942f42d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc3616c4e4b68cd15665c746edbb616d2103eddd69d77b4e695ea8e67ac1d90(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6680ddd1ef8515862b586517b943694f86892c86d045542b24ae5ef1525625(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70417aba3f31221b56ce0fc662313e6d9339809dabacf709770f18de7f485436(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b319a7c8cf1f2e11969da24539c0a9d0655c161483d5082cfb4543a7e04f0ff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070f53c58a3ffab9163a427b201016cd8d2acb31a928cc5cf2953ed45d4d59ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e1c1971a18a1c11c2d23d0d1036644851a73c04837a11b01bebfc7da35426c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e6b54fbdd5e4b80ac99d263ee6ab25e22daf7fb236e7791c15e47e338600d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60aec8f2ab864c5f1508032397ca33d08395c0ae85e122333257cbf8fa332560(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7c7c666301e148be3c82c0a31b930b0b5b3fe7e7a93226bf6d493964d798b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec10531800c145a3893c92ecc14a0195f3834265c6a47340ae75142e963488c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5142880c543a70d1bcde68595943d5ce4a2412fd2cac6f1bbe4a447508a3837d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7818d8f8d02e96f03cbca044fa47f71e9d095998dbb467ce5cba83c8cd120308(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a6a58b466889c2c4b48501748739a89628979455aac2ace08b4412e30a0ec2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310815b323f089e3656b10dd59c02b7ee5f31c19f41e64c770e7797961914d1d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c747aca73028f818738536647e2cdde74deb4a297efb15ec40cea4e527b72b38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31814ef29fa29fcd5bb5703240853166415136d9d326ee4088a1a7d671fde305(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921a7d861250c5d886f94d73a9a2c4a6c5dea4c6e809cff812d961e44f5108e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ade078668de6a1bd8c7527eb58da2c68494bef422c4603f5a54e3a73e2d868b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329103296f94cfb2dea8d9146c567669089d3f1006ee3f135473e2360f52dea9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf0e7a94d3ddd3da70e5125470d6ea7c0af9d463a546af50f707b8802204c13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fa2867059b6477995dd422d7228c7c92a8d2c6f3c2911c276df287a5d3ad17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc690221803b6f98989cef07fc7a8d402332903fe2182e72afe1bb24470459b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb62c8bd68e3b42dd35d97057936df5f400e205e85206b7d8795d35ee923c35c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c0efde290d0cae91d99288712d1ee90a2ff94cda216560d9dc02f8da69808e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55b089cf359e50e30e6f911c793ddd75f64bb212c6a26b80e4f547193bd9e2b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0aed013539d4a6d0e87f5600b4e42a49916508d33d2917f4fd810c682f084a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51cdb42c3454334f3f056b42fb054a1481edcac096ec97469284fe8832bb7e67(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eda1b6cb66e6740d8622a0d31ae5b7f3b86faa26118a6e48d547c611b71247b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e284ec368516cac0fe8608e9dd427e044bf04723041d10b386a0648b71142b2e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e08e475152ad13b3c94581f1adc7f179f1785daeaefa53cbda862f7dfca8738(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a2d83b94240a8034b99546847aa43fc73a086a68f54dcc6f662a3099f2a1a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e0309ccedfbc1fc49c000585019bee42c5bd0f0a8577881de192565e39b77b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f125d21047d808b1a24d348722f8d44eb4ab18f7de02603f11274115a6c12946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905985175ea9843ef4ca2e5113740121b2d39caaba8e48cd2276ce61a6b26376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6905aa5760e1bf5583ef13274e4c7f11a5e85243d09663a40c56fad463338673(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1614f522e1633d086c498f077b3e7ebbc7690231b95619ec9ad5b9929039e962(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3975f030f6e615bfcb5b52e6c31d337e3ee69166921f6eb15b21a66d0e673bf0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dfccfe4712cf3a25be6626a009cfca8c0e4dd3e73d2ab378d9a57312f73cf9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9067e71e816b4f69651fdb6e9d12d131d2bb04219559474bfdc8b218c0a085d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d55a59ceb5beba3f990f45aea450f7417b98d2a90f8ecc4dce7ce40c5a354ce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1245a56a370ce2eceffb922cd6599be1ed6d59c434d64906206666d7d1df4972(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14acac0b16f2fc71c02fc0d7e6b2312cf7bb1f1e268f1e80ea0d0822bb6fe9e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64aa6f51a7b5c71ba48cde08198abb4efbc44a69c7cebf451fba2e45468ff490(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842a5aca9cf6b265b2ef05fcdb7f7b3e6ea622b8d19cbe9b8dd2305cbfd825be(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dfbb41b3b146f68244f5e447e6f2a4386b555a3c675c15a3d26874c17fdfacf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de20bcf04ada1b1673c74d24f623debdb554ddff7c2e3d2b6794d991963b0fe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2c71b9b765ebc93bb506a2ffc91a3a27b7a6181f892b4e582bf5b2622c9b96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa109edd33ace4b8711e422f81485fa14de91301ea51c05ae51180112c06e79(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07da6745b54025e6061e2f54735a43e83bfe10ee9df9717131e57746fe2314ab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__391437e337c7be89846540137e7f2d4911d1110cfb9c0b5430dd8d170694503c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__918ea183c9e4d3fdb2e6b6d6bf6a8d54dbbe25f2ce75e86f48c63464acf522dd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4228ec19a7a508fce2e55ef35253ef9be5adfcdd1b5ee14563c0cd3187b4d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e124881217f5cf703afa9bc9601ad5a7385b380a174fc54ecabc33218baafe7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb492c3395c1cad1e48bc59574fb7fa32db90a90e5baa337092ae8597064446(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d94905f9f612ed8e71c5387ce88697c2ea634be91c910e5b43f86144bfb3be6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8cf6d640da4c4e31daf788c12d80327461adb4c5b073895891c0825f082fbe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2071b9f5ba34bcf2616583ab66f842088a3c0773b22d2e2a29259922571b65(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab515adff441e84255375f69644b7c086ca976a5b323caddbe7a07805d837686(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34474b8fdf640ca1f6e5d0119c957dcb525ea3e8d91f1a68fd595004fd0ca1db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f82f98e71007181ed50e9e9522ea7b724bc697b064b16ec75ae11ee505c18db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1e767d7a917af2aadd476f48c4edc4fcd009e25ffafcb72c9ef0a0be43a468(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ac4f60a5b0bf8ccae1a2488418c78dafe8e82862e894a4473fc8634192f56a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269574320c3de0cfe5ca2584d9534aa8328c0718905a98897c0f93746355097b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ef445639ed334c1a55c967a9b7dbea1418a614c00cfc133d3973d6c2196cfc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5069d11bf523e618f25f79e97eea4436d3aa665657c7235ee15db2558c77a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec86d6d2681ac9edcdc0270eac8aecd13e6f0db4ec7ebfd59c75fa460290c3ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99046a71f54d22d22b81ccbe8ec5b8d3804e03a95ac53cb44f2859162ba3ef71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d09094420f28533bc01da2d38ea58193034d565f1a82e21fb27003586493a72(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1034067a47cd5958a3d77f46fb7379a47349408a9d22548ea32aa4dc98fe49cb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa62cdd77eab2d7872d1643088691d8aa24326230fd4dcd561a9e861c5e8fdc9(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649cf2f3b6da3eebe2a4a980e93f968bc58926ea234c1f67659956bb24573392(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa87d0643afe313036db09ac1fc36fc3a86ccd25aadfb5dcd8646069f0bd8f8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6421b24b55ad48376294378516a3a2b040509d7e2bac6178b76fe93242bf7c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de5c853f41591edb544c379a93442b9373bdbd3e77df79dcabbd624fc26d973c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078aa99eafb2a0bb2e7c6d37edd9d0c48feec282308b191c8ad12cb6a8fcae5f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4357616eb1d1b19452fc08d748746623f37cfbc89cd48df43335d733313d97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e38f9301bb95d8cbe0d759af1c7ec6938fb423b51d7ee0193e6d7e39d8cdc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e090eeacff1a714d06567c249169a857a604a94d582b41296579215d3a74ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef094650c2fd880110d358184350550d93310127964569e386af5107fe46b391(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c44f20317e423534215e1b252c3da22e7f0d95235e9f268efce60fc463efb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca0015c1b83e155b3147fe3cca6fd4b66bcd044fc9a660ce1652fc0dcac4010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d066c176d5cfae1735f572d99df47735f3d827011a50fbdf0ac90ccbac4a9d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9aab27efe2e534f1ebbf351325bdaae4ad221842367b13fec148ac09db4e9d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d71db536939d4ab3dbc7d437605b11659649620f91dc382bda86c5bb2959ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f194e8c86cae0ac8ac6818dea2ee2de815cd6a05ef1bffed0ebb39657635194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb7e19772e4e6e9b74f5dadf659c3e83e03bcfade8a695fa07f8bee30069602(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25429ec36ff7265b782edc382414459e4ea7db2260ad118d73e2c85e8ced6126(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223781d124294673e2db1c4f36752037b290c7c4846d3689a055eaf6a03a686c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b598c450bd8c584fbcb96c435f63d2bd7271e1bc0671ff400a8882eed4a0f3fd(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045a507a45584773083ec4e4c07d6c6fcb3b44312990a3076931b11e826b00dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47692a1f3c95d7077a2fda2d2ca5ecf9881d2cdd0c57770921d3f50eeb3e0599(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b41ca5463bf92c5bc211119231b44c516255620eb47445e4d8c12a68be47b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9296696f2351a797667e339b020d22f04530a279b76f8b2c8c1ceb7069caec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c312cdcb641b25f93b4d17439b6f174cc3a623876054cbf6538d2a8108673b08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a07bb83e608fa0a83db8629c19d5903afa74bc7235ced0ca051adf09604323(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef1fd6d18f1972b8a6b9a620708ea80744441deae8c438fddcfe3bbb98aded7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247937f36d03a10c2c1d8694c2c8f04e32c1a45b1fbcd6a1683f7eb87735eb26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d2b02db50afb8381ad0e8ffc9850c8455874eda3b1550ae2cfcd6bf2137df0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c302418f7b5d908f9a07dd134745531d7a7d1b490784704e79f71bb7da1be26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f709318290b82c3d0420a6c5ffedc16c04f081bb80ffcbc9ef0b6bb31024052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d001862c22463529182f8991b7cde80dc4d29e8de412faaa7776bb9b8fee43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec8019f576e3a9c13ff2d21ca9444aa63f7376ff962b6ca623c923b37cfd2fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6bfd7813d36285fefb7cd01c83c18647bca3afbc96f412aa5a984492c355bba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3373bbbda5d9599e9e4114bc8576ee19542b4b7c14010071dcec18861ba840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0fa0c6b32e0fb4dd2fcdee8485648d2e85ab776a6c24ee07a166ec9cbec243(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4407ccca39da027c94a72b0637b0158b61e07efec719a46e370c65df14e86c51(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15610cd90eb9881a77c33ebacac217fc3e2b0103d15fcc46b51f3716f277af78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ae125fcd444c9d148c554d54341ce0016ab035151cd2b11cc7733b333d827a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109d9d4ea4a6e6c16535d7a01170cd4c51b21bb75ed246f98571d653d8c3d8fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f87c5777a705ecfa1ec18762183583d46638cde24d3a3fb01a89c12c78ee32(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385ec00c5b3d5f2dada54b86e47530015dd9dd06a2310221536500d6aaa5d5eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6390f94f7b1329da533917211e3370de84bd544a8f366f5eb4268f1d4835514(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207dd3f7ce889393039a96877aa7356a62c4de2094dc104ae2b6061c8bd5cf1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea9ef7d94f29bd6c8cd7de4c6ce904c5c26980331e53cff74c27aba70ce882c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8880aff40acbc4c75674e90b6f6546368f7b059efb2a9bd96855628074e8c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8cf53b0050b5d01bd6ef3d97ab40eff8b0e2f17c9593794f59e7f69c1209b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcabb9b2e2f74f025bf831758e2ab3b0b3d68ce4c65f0ef1bc9db7e1da8ec661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f53ad08be62d5cfe766f298e7a08cecae343b7d49e59ab506e4da51d80f3bd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08bceae15810928ad7b0f312fcc7e3a3d19466b8bed27f436d9301337d5f87ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf42ab73091df7ac822f6dce88df028fc908a3a51bb97a334c0ba6fd4a1f67e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__392a72503c68e4b1520d810824cd2f727f5c0b5f39cac53975c0a8d731060ce9(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b2b5bc673967b6e5b63618203fbfa6b33550dec1b064e44ad806d4738aa91a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028b053bd240faba894dd9af2509c95c0745bc00524e64816a84b62a211d6863(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4770935d33a8ecadb424e8cfeac92dcb0add7a10b2aa4872a38d87f0b1500df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b967aa2524c56ca8c364a6bc748d2da48fbe1913494bae7ea426fedbebdebe2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab7b93ba3f7a9d26f0fc930297a68ea2cdf3fc9a0bc8c8a2f45fd2a17d13622(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afdb3412a6cbb0f2da07ad36f443f463c16c3a1f1e6c4fc0f104e1184091e19c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d439cd0bf4080e7a1ef1304ed517f6a265ddb57511815530bac3750590e97cf2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750fded5322c9eca7cdca862b766277d31d261edb0f94ada88e2f437f36954a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3605ff717ba88d7eeb644f96fe98bdf7d8ea7aa70194f2202690b1de6d10c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d563cfaa15b55ef91269f2a8e23b069b96a34cdd139d1e3ae960d74d04f7b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da4eb0a8a3be645efb103a4506301d8106554d543d0b445ae09f52926127c575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__953044a093ecf0e6c08ca278a2179067539aa21bf5013e1ef7742100d38148af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f159ddf63b462a52dd664f1b851c9175483cb37e3ca064a7aededbd2bc1c8838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb65100f19b9cd79a1820f97b5d5aea5dc2c217de25aed429eec9674371ed729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7497eaacc002dc1653c537227bf786854dfb3e16af8eccf8686309d8921a9dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c1e004bbaaf33a6a3333108e29cc1a106279270a15d9d942b7d664693368f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6732cb0a96803e91de293712350a539dfd871898dd050e67e3979c8a554f0c(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2372b0ce8ad1eb9448cb20b14ec5a3236d6488bac7c8f6f77a3c987fb2bafaef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d050f401dc67944d4e277d16610045022c50542286580d92f12a6a3f5d020c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6867f2134556aa982ea21c51719effff3cd892d00f1d868f8dc105a1126eea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b45bbea199499f93627fea385e2f60e29595cb744769c70d41a9389268bde8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909f165699ee1778c657b5e20b142094c08c18e75602e0c8722c2ae47ee22e3d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabd600cab129c3d2f256391a21867624e8a85ebf0f77c61cf5f12823b35571a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__309ba4b3ad0e0e60a69671305d1cc8a079eea15bdc1c96e02f3fe49d092a0ba9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d4bb72a51c413ab719f519e241776c225dad9acbf114fe1c78bb0aba69756f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5370c1335ea69d961d2e0315cb91c3be4cecb14998f9b3f3aa998a35e8a349e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d90ed89bbf6f56324a769785af5e5cee7919c3392fa2a6e588b9f4fe5441c88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3381704e57e830be7ee9778a82d0683daaf05ae3d4b0ca967bfcdd028584ed85(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61239b00b874f580368bbd0db83249ef9308ee886ac33467f469739c373a1049(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c74804438de00967345e8c89ccab4ed1f5f9470a348c02256b7e8c998f5a268(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c683bbf8c15e0d3d50901e1ef359672456cd9d7f09c2eb68396b10334eadb432(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0eb7137ac8c691838cd28fec5b66440097950e5ba2d50b1beff60cc556a4b31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540f25c925067a21dd27a809153f9a028ec601b97a8952c0fbe70fe05d2965b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40b7b089962c7a3ba5cab0d35ca57d143ed6ec782af5edc7f5ead0e1b1d0a4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9cbdb5c949ee0ba5605ef93fea70be86a775eb66af83cdd0d89b98aaa66d9a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f47a0c8ba5b6eb0492f1a836cd3c7f2ae440abf82722da2728b6686704d6356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd13b3483b127863e7f897edccf26975926828c2f7a9d8038a62c2e57535382(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d016ff16660508363566d42ab262816228234c0cd9c9fc91b4af9bfcb2ffbede(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac6182bbdbbd0727c52a86673699527be51fefb8bf6e447ab790ec6f7cc631a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee20f27ea3c949bf98b52417a5a648932da6e466c99dec3f34081293d88ab248(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02ad13a64bc477ed553b601e7d6a25e0c728a3bd15e0475c86822c114d30574(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b73f1cc966dec28593e4928f40718fc11fd14abbc07116fa0a08d1030a51615a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b43677c25b34ca6706913e554e80f512b333626f16a8e6314044805891f2a78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__875ff3a1c517ba7aff8d5dc2d62bb0ab24b25ce1e599bb7bb25fd02445febc7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541900a6825f9a6c121b691c08b7db35a1309432fb29207b889bfd2665e9edb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8abd0f47f07b41fbc24c89c5a7e9d03d97e1dc7c3b2bcefe19be1a560cde113(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a57dbce64de02d47c535bfe2807a52e0126d714155ea2e98f2b82ea943aaf9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6668c225b18d028ee1b0363f3e720e07872f53bee801876e5b1d5fc581b53649(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f757f75c99f1f4df4d15e506fe01cd2559eb5128afe272211c925f0aed81a96d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28abbccf18e3787e390e48c3092f87529057974443cab5b4b575c5cbea0e640(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27eb774d090ad6357ef133723e2221227eaddf4e0d4e65dd58827a5040d2851c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__286743c966f89ecdf0ef134235161448699590a5de650b37fa90dd338501fca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c5668304dc209019e39ff4d3b72bf047988c42a1502e20d990bb4ce84bff2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3faa512cb7c1c2cef7fbfce547f1f9d6049dfb241d2e52dc42ca6c0f7943713(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867341506dd4af07b7845b00f8c3bf2cc7ca4cd266c8531d4446eaa9729d5a41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2244fec3efccabe17212b3636d9bdd944ac1d945bd36152f0c20c07c8f8624e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6d83b659b47f82a4e82eac934cea0abbdb1328e16f01731ee7a41b0576c296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7425a77799f4cc5486ed3a8fccd5c0165bc3da1eba2d437e3fe237e97cba9731(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a6b747c4844e4941fd4ef968c90e04b3a14323cad8bf5adc823ddf895438128(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fda9da8cd2fbae1e7bdbc06d072b3a87f25fdf77f3f39e44871e2254487c7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f78fc1a05ebe82d8e0614de95d8b0a4e6ef92f48a6787e5adcacd3a8a9ecc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921375c720400748003905ce7889a5951d2c23c540b1f1c7ae5af2c0bc0e87f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbba21170e39a34e4412cbb27eb8c721d728c57767504531d308ae05f3c1ec5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a021a7e73cc41a4d6c5fc74b977893905bbb1bf46af2afa58eebf73298d4c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da77ebcfc70007d6364c42370f8e0a161d3f6d8971f99a28dfa66fd4f651742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a8fdcaaad2e9c4629df1c7781bbb63115d870f1d8df23924711285cd5ab7b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c24d0a5f4488596e4bda502e22eb1932123cec411a3830779af08a113ddf15a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4778b1a96301df5db5981f78621f0d454c91fc9090df4dbe974d7509d848a9bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd048dabee61ac6babe40fb4addb9f99547b51aeabfb4e4ad132698cd10760f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d6b3c5d35e93a03b41ad9b5867fe87cbbe658e77d086b9e914818ae5f83a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7cdaf008184f771f813560b71e32f0d1a5ddbc8af8c248d28a7f5fbfa60780(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07388add1cd06061af560487760375e7e3a46eef001ff2d7419ea1ecacf92955(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f4c5a868343b5d94ab2762baa7c14728a25ccf1d877b362503ac1d427dd3b91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ca2034c27589f284ee80452ec831de8e80675b1da728a0596071a00f227456(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37445717a84f4763a8b940020f00afac05e318c012347d238469195960ca9932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b81d0989bc785abed89c2c7e1ca10477b8c8e1a6c5322d6b8e6faa4ea5d85d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02ea2131b5d1924fa9cec18ef15f920bbe7dd6418c84269adc4287fdacf98ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5897e0e8319b077812acd496118aa7272471bf07a205159a988f32059018ab06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea1c8995503569098d0c5b6d763a1513ff2e42feb86238d61fdbbf32e6d3727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c27a27297e7063757f788dcca3494f8fc10b96e718ac01e540a553237a62c5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e801de9f4ff07c0559e5d88233cacc08752a5fa4fc7dd3dcf1142cfc048c94a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e04d0bb9f9c858f100683c4ecc044f9d2c7f187b861584a3f100cbb5d9a53a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59dfaa151012f3d7f8e8d2ec4876884244f381aea97f1a0ee5dca12b6c423f3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd76edab97b59be8bbb2f630ea1473eb2fa0bbd2ccd69f493bb8f80c7a6031d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b0f4f9db0bb619deb33c745143aa87eb781ee2e6e93fecdb033528b4ee17a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43bfe9a91162bfd6d3c7e773e4d601d2f2ce7effcfa3bcf01826da85f034d35(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dbc4bc5cafd9f3504c880ed06bb777d2822ce3fe3f83e9f42fddbb78ae706f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4d653eedfb6447da5051d33c54df37ea6fc1205d325f06b14a9d49a5fca0e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71517f7b83b8f7195f90a5e6ee6667beafd7172207b45c3121be6c133b57be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc0ec6e24254857091930f224262e9b4deab128834a6a29f7758f4bc0bb7cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a1126bc140a930d3f1d74346eb63cda9fef6e45fc5512223c01c690c898779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41928a6e3775e8d7c59f6ff5d5e59b4823de9da8ee7cd2786768e51d6a7aa54c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83652ba233fe078bb92636b702f5cb3413cc982938ca8201b81e8429e566e0d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca50491c818f8dcd736d194839b4f73c1eaec06daaf2c3f477fa1564dd3cd0f(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f4df024e452803bbfb1c53b1e0b4e518d6ff30afffb51f93712f0348d7cb67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf7c0e6714588a4011a5c170e0441fbc8bfcef6cd472a7c18ad53a2d78eb7de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492d2fd371026aaf4dd25c572ee44a058b4223c8dd9f7314f0783e41a9e3886f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b53fd9f6b55bd7d163334dfef494aeec54fd1ca499225a975cf103960cbecc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb352745f8cacfd6940da5aa6b1276c54e61db1653bb1cd5f6084a13f5122811(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f489d0cc825e4a275d522a6c6d415c29a8abc65942c4f8932d2334775ebd5bc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cfe4f2f0ad28a02526c257dca9d07fbbebdf013781fede45567b4da4b107c34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6044d3f0834551a9cf3c523b363b32c9b8b4ed377123b902b58f19d88ebeac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f74dcf622ddda131a4ae9975e3aa406a997aeba134124f022eb14f63377f998(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45808d45099794d23f5496657308e4f625aae75046fe9e3f5471ffc0a49097c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50e504bcf6b89ab71108b69a72e7f4d457dfd89b1ef47d11afc29dbeb796c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9067f0b79480cea07b7557ecc9003713a1ec14ba621688b968ce62974f3dd238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888f36cd490c2a4120065e28a864da55768f04078074c7aceaa258b403b5486b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c0930939f2b0131a2513cf802d13f17984deb4c2daea0c26390dbb9cefffc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78cca253a97d345819253b9c17f87ab3576c18f21a04a91fd732c321d6ed015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afc758b32488e0d720b4db09f19d473f65a5862178414b692d5f2971a88bfb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f4af5e0c50591fb828d83243fdf35dfebda65ed6b9396159f4c2b493fdc359(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521c473303a34985eee782061d6e5b595180fa0d12629ef04571e0b1b1019f54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1389e98a5fba9ddf7ee56cd831b5770a2e3b786b9f7616ff9d31081161bdc326(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f981763a326b4780e2adaea0697416b35d7575ad41f942fea9937d00020f80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450768aa262b46b174d2a15624097d22d353575368bc37ff31f3c515dcb50913(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__756624238c633c516ed388206a69bf405de5bbb57755d34896e7ede2336bfd76(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467c0313bac9d2dfef5a836b62f62a5bcde63a5848cc47cecbcaa8b8607f6aad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8908b60a8bb6d8a3e0744ead192f089af357a154ee614dcd690ab5d740a1f84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e4abe3bdddcc6f6b3a506a476b8061b8ee27d624b9a1eee86e45a916e61f17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0da14867cefa0036f603627ed65574828430af68c7099ab5eeee48a467d302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937561af44d0d6a6d0e09f494161caa2ec5f075423af82fc3099ee11d5f88c75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87c56388cb20d60c10a0aeb2f7ad2ddfbdef6d2413ec97dead4a8f76f36d495(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8311ffd966305cd87d1b76bd801395e466244e4f0cbd6c419f0cbc5624bae966(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c986ee5efb29ed23fcb20ecedff6e56c05af70d7d1c1e31b57d3034dc016b101(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2b7ca8c638406b5d09c4cd12f5518800d8d76a4c61ce7ec12de9e68bab466a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84275501cc81843f2e6c23ae07cf231a13376e2fc96a3a5ebc82c452ce4430e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea62a661aff2a6192bd2900c2623572cf8331f09a2235ab9bc895a5a03e85c4e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da4dd9f00081a6f38b3c4d866ab84516136392024a15501546501620bf5f783c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b38a53f093788a88fd2045ce19d73533589796a0a9e7f04024ac73ef06c37b9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e144df10c8c6fe7736ab78c26e791032a534ea02aa6c84eef5e5e4b61b64e86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad8116c62676986cbe2c34f5b48f0187ec68ae4b78ba5b3b2d76312d408149a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765e31dd608d53e3806085d1fbbd098f405903f72d30ccb8700a646b4db5e09c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcb10a056a915402f61b7aeff570752e8505dd7b6a322ee763b3fc83a7448b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb704a4e7df798b311a8edda050ac064fe53ff6777b990733bab3c3255849de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbcb04c75fd6a3866a8a9669366be9d318983147116988262f9cc5bf728950c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4112e360a7549c4862a21fc07cd992455fb453d54400eb461fd11f939b744c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01467b5009cb606bc2c14b4d7d5b558248bff543b815f0eb91a32adfd12f7ae8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e093486cec633611f81b5e353f90f6b52cf2c1b0839c7dd829bb6320f58e0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25af9605092e129b7256c8e4dfb57d224e000e1dbcba458657706c8bfafaf073(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0733be5eb8cdbfd0ca35e1d719403640195c686c2867618ad1ed92596e346ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2a934ce264c01762db1d260a58f7ff0c90b0ffabd5fbdeefc6c6954e1ebbeb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba10685610c6c68992bccd9916b3dec9f41b8f938004c108e6d68e8bcf9b111(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef4bd2e598dbe088e1e80de6da1cf6a0b2df46b654597468ac716c72bbb8e06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47de0517187912237558419d09bf7c89ca0ddf4e7e280584b24fa93938425599(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd011f90a6df4b727b0053ab7d3eec2b12045f674f1583c68842e2f22aef64e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d2cf1366bd638a22032d67e8bb1192e99254ae5132e9123225a3a2ddd7964f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd6494ef5aec3d6e942014e94fd1d96ebe5b07293c193189fc4ad0bf0bb8a586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c189d0d93dbec7af48f49daa7c6c9a779d5398f6ff4e20df5965975de86267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49ccf01c4d8c22cc3888081c8a4335c0935b47387a5a34a11333ec049917555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed031f4242f5f181e9b1f8c9f7e888e6c7479c68be35c29bcd89189d66e32ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a862378938e8ce619040d7d7b4fe64feb3fb07f8352063a44a3c71076c77955(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89ce6dc97f1069235e5c7e0f353a092a77aaa5efce8dbaeda71a878201dace8(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33af459ec804194378bce40da9503708c69180c3989a1c9fc750d23892dcdb73(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3ae053353b71f91f3fe7c5534b2bad52fb5526bd599fd7a0959913123a505a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db5ef7d5099bce32f33ca529cab41830eefbd1ce417ccd09e60a2f6fb0c0707(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711ba361843f83c3cba7f0915ba704e848963be6b929bebe1f2a29d3f2fefe97(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da99d97141aba7055337b1a5dad0c6de72af6fffa0dc62711083eca27b1bab9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e63129ae5c5c0fd717d7d009080d157054d8054e5f117c17ebdd423b7ef09d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204e089c2734ba7390c813e0091061b5cf0c6c44492ba67353efe23a90df700b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1fde5f046759813f5c8c3a0e18d85cf28d11565539fd4dd2c955c59ca8c5f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08804662d52a9f237af2da2c5928aa8123d122eb0ae8f934de643b54680cd846(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ad2e5aa830c0cb4574d0504a2af83fe769c9d83b505fdd94a773f73aa0ea4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aacca43e1d4e7737e69e039386f769411336b8a99402550cd33ecfb560082ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0329cc7b56cf5425415d05d788e95ba47d3b64fff252f98b7f1cae4c409a97f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e36c8a9ef0e7d19ab2074c363a4d245e8a604343870449a230957f0ebf475ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbf7d6e6cd9989a1fb90d21f286bd697501e8e0c4417fec1b7e3422a89d9e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50218a86fac527e8a78ebb9929b0b73185b4ef43540d72385ab1e506d19540ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a56749fba2608bf921c0cf85f0f7ff4e0942b88471a3a18a4e373a9aaf6561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91b0a3d1840bd31df230061ca07a5c87dff2b5afe1c78d257b450e5f4c78a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb815167a13923a613e9b57073bbdd32af81697942cf27b03de2ede77e2f7ac9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d6de784de48aa9e9a5a402ef8b4635d489e118302681ebc038913be82e3add(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b7b58c8f0bd98100b643e71cc7008476dc9df8432c2bd8af4431403f7dd99a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e6974a5411ae26cd06aa96f6f0c046e4c7e01ec79b0071101a796d17360f8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec510c1d3859cfe0bf25bf61f4a41328f81a66524b310213251bea3b0100353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467e624132ec811a0c967aae67d5a64f694e8ea3a47b8c3f343a0cad194031a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78cef18c6fa9a070dac3e6610d41c221e0159cd2a17bc0dfd9b8aa958ed97bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49df900387b935fd956f2a3737ca5faad5ec4baed908794c83d2cbb5ed77d61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf94aff384c619cec02d7b2e63b9c361cffd06924c46292a13d5eade5dbd66fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0907d30082e0592d251d00f041a944c6fcf735f4a6f80a096d0d2da32dff4a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4950c8871a6203fc9bce0a5f51aaa854cbd8a0d6efc53b368925edc0d7ac381b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52181450f4b60ca33e45e62fe0d697d2fe8b6cfc80663b4b016a316100ba13ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db4857dd4f8cc5e1f0663be508698b4d1795ec9422783540073fe3b94d8e19b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6febc198f1cd768ab24f8e240597562620bb70e42dab8c5750c503d61a52aa84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cf1b65a579b96e17de6986e8bf5dd287cedcd71a771c1791606e47cfe0858f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__863a1b02c3ac555868917452824cba655dd5a8405cd2e23a397c4b9f0402d2e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b66fac8ca1736b55cdea5411e769e76e2fd7c29ed81e080e35c3421784ed12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb309d5a3cba3f60da60ed65ae83d7b7138f7035a866d666707ff53ca7e9687(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8155ba239a0b289b463b244af20e9292cde65750bbc2bc0f4b8c12c2341404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e66760c362394deb6c390a9b23ae1e3664a31917bacb8a5589b4e6c2b3d2b00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e319784383d25811128f42974559e1ffa2d358a8f11c4bad1e670ad647a2d352(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c9f0ec4434666991e3d97344970987f1bf33abfc1859045a89553bca3418bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca347711a8e25b55bb4e2482943b7e3517a2e2bbbdddadd98ec720c65274d5e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0a74d51062400c862872489b0ad2c930ca0e83a47a49f3c9b0f07f60b17b93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbcc81c56df4c52e1589eff9c9211c7b57d301fe2b00ee68cb4682ef5c8f6b51(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de0e15301e8df8f860eb7d19a3796679084cf3efe01c748d17252ffd4b1febc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79d3413dedb05922c5c46187cba4c6a0674dba25503c5982a0273ac3e018174(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f2b468717ac51a578614e5d06ec3078b370f39720408028ddeba4c1e72fa9f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95276e32493a348a74df99dbaaa19ec9f5ea0a534325c9733eb84db09650a86f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6deac07bc99057a9acfd0cf65aa811d388b77f834f97766b5304ca7f057bc842(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b813b48c22ff77981f136c37cb821085eec5055d2c76518fae0765953a7d5faf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e677dba8e90254f68c8bdc8557d88595584d4c2b07d80182edff7159f733e19(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93264bc440c9befbfb500ef9430187b75d5be7a4416cb96504eccd94a8954cfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f180fbfca7d42aba8def455567bbb2c2f3afdbf64323005d549e7b7f87a03b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ccd64d59c5ac662c5d5f681897548c1e44665c7cd669be58ec8644e6e85c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d938149f58109c12dcd163deee513eb213613a35ae8f705fae1773763c8eed6d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7dc4c253b634cc5b9244a8649a8bb9956acc889acf7cf63066a12fbc0caeca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba32845d74f7ccaf694dd93d34569bdc8321b6c4a361a551b63397b8ae18e72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca3dfbde7eb35e08c5ae31b858836defd7bc7e5cc5126932454def0fd2f518d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8607651bbe418f1289abb73eca9b4525c6f9a1491241b2b1ba1e57abc77cf79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06df82dcc574f4da250f4362cbc6901e49541f2e27c3cff44f26b97bda894334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5083ae2ea8734a8080af2aec3ed348bc97204dba0b0f5b2fc1acf611eb2da5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab094b01e5c0696b9d58868a6a3c9b441f56e28b3b18d4b123e7a7eaaaa0e9d6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c70c5b98fedc325c746a1d672ae6303b2fe470ed3af2b49ad424213081685a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4af3ccd5e858761ca75809d22852125461b7dc0d1482fb4cc09e173a1b2716d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d16b99ad795ae4fe0c1f76988f7946315d2a3b34ea23feab9c215583155f9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee84c9d32f57c06b3041f6e7168b0a29b66b5f640f065eb1457fb0651724ca1e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1ddfffdace415b699b3ee61d5e02062dfeedf4b9bba25f415381e56c7ee86d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4775c3ff995232aef6901b955e4e38ecf51f0eb542a4fc8b32c8f85f7747e0a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f36332b57c092f6fb2d7848b78f0c1f387d16a3a16cf014f83a9718265a32e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4735d44f33170b982200bb1af9b42d73834148b0599d9b8c5ec7aa8e01df2dbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874967ce6d31175f1c66a612ac08aec57230e3f3cce3ea5e5f397c7884927baf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c358d25cbe3141cb6d7914d5c30ba26a481615594a3a336c0da316f7649048bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b59bd857d5239dd6c9ea3a84434cd31751141a30926479313410c78079b028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee9f12186396d976479969613ad3ba0ed60914fd4429fad8f4096f14cbb0934(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dede8e5375029e65653dc1d9be56fcc060bd49ab5c236f06aeb13af68aa1c100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4259e1f6fbf7c1cdb6b82f7afb3b1cdbb88bbd941d575d3c7dc76066d6c57bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5ede70cdb61f1a75b85aa274cefd9eb0744067522c719c1c5e9adac39dd591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b52c66f4eb5a029a66ca3cbfa536307ccde519370162090d8da696a99562b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d2ef0f252adaab8e592d79c5ab70157a9c0e45b1351f070e648248ae4f6e30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc067de5b791089043fce4e53cf73942f5984eb67d1deb99efdffe3d7a377937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f222ad6fa933951a6360604632302df2f4ad7f62b0a82db7a8a32cdd90c456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a70a58f2e81d9c93314aa3056028579b77f216d916170f7b44c6389ab5f906fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5c65c53cf13a6f85898aea7ad3b82167535133049037f2aad9474b5205e157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7fab6b4af3b050009f04057082a238ab39e2ffa4f231ca2cce5c67c8809f21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0576d6677d759a45138eb09529142403e40c4d5f10f4bb864b2a40bc969345af(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92a1b69ebf193160c3b7faa3de357ea5edf52e78edda423dfe1954b29b236bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84da9e2f7f6dea53c55920e88569eb00e163a3d4e5355e18df13e29f18ba0151(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7ff0ca432a06524f456d89cab739dc9ea7071130c00a69d3c41385f95fe9d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b2afed1d17dc9f44e6276e8a2380e5afe38b145c1cec3cd9c40e3ff64be5a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22765aeaf8e0ad343a3898644e8c91130ef4cf2fbd78281bf1940c565cfab6e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94df929ab93a692c89ac9757837297b3f52f298843a7fde1c70bea641be8744d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c039ebb3dde0c554ba9074350c0fe003c31d56c0ea623d073c832a41d1a1ca7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__637adb533084eba6a5c08af8ab54e5dc1b138c415710767e356e187ce671e594(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e565a5c5b4a5fec50e065c0627f5c983b6c4f2530ce998488274830cc3f070fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26ef5479ea85a9f6548a636c30e37dc87642756a17163e6c2222f92fafe9e1d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76d1b4be9317600a1cf6c24509dbb716a65e58673d0df3ef722ad4fd54a6599(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af99e5f153db6abb535d1c7cf14591536c1450b8c07d919e63ff4784126d48c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d24761d38e81a403d1973b2dc3ac23f566d65f0d6f5cfc7f4f7e8c266cee8e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38bf09ecd3cbc0a65f93415b36b51961c396a37c59b3c76e9b90f2d26f729da6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ca9734bddf37b5255a5835171b51209523f2c7d90d169b976efffc4e029847(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883c5eac16159dc65dfa89b17db7342762c11ec1e046cc1adec869d4e0912431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85491606524d4b380b253c76036bb02cab746b5883a8c62cb624145e653b96ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee015a16198b67f880e9820ec9801933fe4fbf02a54ebe2ee7b944c7cd3fbc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025cf0d3f12004e40ce5a227974bd13d5b954b2e8c450dc0c6383716926fb7e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb288d60937efcf7424bf7e27debf0c158d272dfbe7244054a22f64b794b04e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9287aa61c4e05d1f5485bc5872316f997f00bda12f6d179fdd51bf597753c615(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c3e37fa804c99ea3d70a5da2e64bffcfc7c14fc218b3ff3fb66d346d5fb882(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bcab30afaec0408b2795097d5825d74d74b5de55804225bf97fac677dfe369d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b8174be20cb93762f83fbe5bbf373eb76e5d542c7afbc3add650d8c441622b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036d6429ea95763e23d57e22460ecef15e79b103686fcdb3216a2e5835ae27b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04a6a91b345414a5c1405127dcf83525f9b8b908f2c88bbcc7eb78a1ba84e2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fea41ab63038f0f06cd1eefea341380c4cf8a21e88e6b0267eaac93063c7a29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a225af31e41743f2a13f95a4b0b90d9d76cbffde7e20e3f26ac392e47596e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc5cb5b5dfa50b13769a0cc8eec24e5ec31b50301c2603d429d582603f95528(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f6c8907475a580bd224ff56731ef93ca8fd93621cf5e908a736ce957c46e2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b33807d6c94ac0e1c2ae34b1930d2364ed834d632ef9bfa76e3c5b0b718ad309(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d78ac6c2ab01aafcbec0c94af52e9772781e7b3cc746648a014c5f8fe745fd3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58288d22fbc670189bd3fb0d7ad5150cb65deb0026431969e7fbe780373aeac6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3b8a69b7210874d37541514433557180d2adb473aa8644f096538687168fc9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799004f1d8d405e7b4e45e74a641676c3ae7d40f440551de0aaae4840ff8d6e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e7fd2fcd63bb1c4ec88557b861b66e0b897c6c4dc55cfb644cd6069a63a969(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cfe69485a238c8dc8c28e93e73496ec07a2f8641f2bd10930f93dcc20d73f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbd84175ca9e6a42f66a2c3be739a8f3bb57d04e72f291586a79806ff326275f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd6c4d519bcb44d80f6271ff0de8c404ab514448bcbb16785ac93dac033ca98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32194b37810957a89aa9d7e5a1db61011694a24050850b3b68244b6098cda88c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9648b9039fcf994da1ae7f05c0e06069c78b139dc0f0e2e6dca98124e1f57770(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0661b432cb71263badca0b16a5fe4f09868a0ebf521ab4efcce0b3c33bbc10b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27254e9a7c6f17959795832dc43a3f4fe856072720534d73db54ff2abc34f905(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c971b43e7583ce32a641b3c59eed6ca8acdacaab6f3b5b9c46cabbcfb0edcbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822e5f09c55ce1b682dcc999a7dd56c5e979a80391a6d24e6415203c2e2060d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7f8c05f922f772e11952afb388790923be60340c505076eb4b2ec5b0d14087(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c5a6e30ae7fd06586ec582bdbe239ba065b7ad4b996bda604971d4f273ef54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0a37d1c26d3f865b6fa5dd0d913afd3b689d01bcd5f309f57047e24287cfec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bfb2771461151de7245c762695e6f1e950de4b660cfa0e9c3c154be1e96b8bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3884a3ff5ca6edb34ec71cb98d79692fb5518770113057b92b464ea4a190d0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7026e528a445831b3f8ddc3438632d06840de44c64a8753f7dd02b33178e138b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f616e1ea016bcace0828f656a67a017112cf5a8b000d4556327a4b1d39d77a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4676f9865f2f55e631d2b4b29c70f8a8cee67d9509152f2ec28bff5e9787af7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7481a15d09571058e180ad475a87692fe88da3828f5ed9d4dccdb6e668111ca(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30fda12cd09d5d8a20f5d89b04da4a3a9a05e79ffa444cd953373d3d0dcb8137(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0467cb2cd5b126d7efa1523821e2d9e2994b2132b4e2d61b41d64bda5e697963(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d9ac52b1498d321aa2db03f955e450c4829a36c8207aa144916e81a2677634(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4abfbde0865ff6c8947770a844388ab3e210815de8ca6d77ed3f829ce11384(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4fe4265092fea6001584d027d67011dbe112b80ade93388c7e2d69bf66b936(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ffe2dcc6b70dd088587af2bb224d859c79fb50e2fbeefbea3af875c9f890c6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__931554e42b8df0dfd37e7083f3439cda248339bb3a73e52167935dd3b0a8d9bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1472f6e8364a44fa2be78c7c65ee93b7e1098273c6ebe545ac73718928c3c698(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7463a36760cb2b75a66c27933ff230b4c3785157a7ce1f73e4360884f6e28cb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4706d503c671248f9c5258be3cafc91ec6e9fd38dc3ec9f733a8a0b8f48e2aa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baab86847f536c7f31861de92ecbb306a60fcbff049d9538cb3ebb18b10a02c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb92d36532ba7f701f8ce0eb4d68a73acf965673091f30fadacfe06c5edd955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02478b15c90f030f77d8299e7f41aa6fdd3c361e8f27c9ef57f506a351aa7fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc17e6937b806b3ecae6f95fee6f18ffa7f2d324641316ff04c1779a0cf9acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89794df9fcd6adb5c1025128b0fb36b47ba4ce8386a69e5993127307add35546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cfef1b0152ad8aa868633e97c6e569a2e7c3149ce113b33a0cf81956b810bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc90ff92ca9d71ccd262eb6ea4982aa1ed0be0b47820f02c54a2e9c574017cee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532c396386b900db4512df229a34e169fd6c7afab803089b8b102a3388ea6bfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771fddf92c132594143838a2ad072d1cf98ee6bd70cff13f37779e51ca94595e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a954b7d3ad91b80d8b0c295f452901a1402a214687e8a8e6cf518cd67e968692(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946b8d89ecc5627aedcb12863de6c225a5b376180d68cc06b04cf77153e99c22(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381e7f94bd398a6362e3f8c6a75f46c0afdd1dbf9c7c9420d2f70ee1aace6c50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffee8d3dfb2b4df7a34d59ace63a873c50de0bf0d4fc2d2a3914e4571e9dc4b5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522be3da2f0e56af09bbfd5ffeb9369067cda506cd61c2c7e16bd248471025cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b292251f28d6d36fb7c0954cf77d16fe60d573bc9828a8f96a8e06227645ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a28ac1c9a6c0f8817fcb0ce21c4a5aed30b599cc3dac681f176f80c5b470a14(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0e841beebf488c614e5ba1630b1eee301f1526c35c5d19809f2d62b6bef7d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e490e5ab2cbe3392971e9f1de31b5f6bba83a5262b626f8471aba0f32f9aea35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9bee470f6e053d8dc54a653bf94ec67b75f552e9278fc0ee76a51dd58c2c723(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c6980fa75666309a2d914486ab3a0a23c60aef5f5017296eedc319e37d40bbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b705409df4e508318f94247c684f010866186356f2ff6c67436c303dbadd45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f22bd03d76d73aecf3b8864d58796fd1eb664cc764d471b5102a19800692c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5656893e8c74094c1a4248c930f52f460feed3b54f0111eb7020a60a6ec376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6733896b1d9b8eb02167e10a54f6d1b0b10ac32705faddabc37649fa1d4fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86bb468fc5f7fbfedebe507e61b615fedf91ed4a5eb594a18870ba7578d56c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17effee62cf0625149533dc55f94962764034dd08d3a8d369007770ad4cf6731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056e9b02bddb7c78d7d8aee2619c5b61610117b1e703bf502843800dc57c62af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c141f9121e9d5afe624838270f0af5ddb5f7688d19c8771fb9f47287a7def5b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98224ae3f94ad6c0e6150833698aa2c2b483132b62a435c81e91448d3526516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee004ce2a2b0a53dc3a310a2215ec9b9b90f71b00135ffb673c38be0c029b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5fabdaeb1b25ea5b53942ed7ef8b4eb791754e7390c8ac11cf9e758b3b1824(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ce6209c6ef4ab5e590940d707e8b47582bfb03d4bf871f8da2363e6af92a65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54908b3bd071e2de9b175a9a5a877495f6684744f5490199f77d66186fe1ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36eb837aa2f8f2383a05b6b3a25bb80cbed82bedd605472e0d9245550e0ef046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b2f6d534367b2b6628974da02418dadc4884b5f596a0bf17e9ae2f5e3ea19a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e30846be5c3267c82d585ea4b244d5faa6aa0bb2679a825a333697dc8b79437(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd817c034a2b4c7b0a691111cb0aeb07a375b5efe237a69ef3ac1ff7f7055bc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12dca8aef8d0a93f7687323e23696bc16b214a5bdd8c83e8be09805fb14a77a6(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890f6e4ead0dbcbf5a051a42fc563b7816e521a42ae1015195dabfae494d3f54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97257a124d87f194b3ddd11efaa4c456e7bff8472be83dd872f024e4e22ac176(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45d5466c414517bc8b1ad56466e4318ffca6ea9cd963dc953df4387221c8444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbff536b603de2aea765b95d6611e3830d0c2ec73ad1cc629d8d38feca377cce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13197949e2546e4dba50a4bc5c69dd6d8350965a4615af1877586a8ceaafd2d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c146fddb6b388e811c307f4cdaa7aa49f826c15c41189cf13a0cf51ab3c3f408(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169e049eacec4a28b726c5f5802eec9d028979b6bc74a888f815f2b7fd71a559(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4686e06da31261a3884aaf8e21483b5826cf70c229f7f4d527552f8610d56a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8298c5c6bad6f19a4dd404c5727b0c306ca59e3fea4407fd4942564881e8cfc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7db42a0d79569f64cebc8a982de74bd82e98e139d1ca34096b6ea94cd696bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6f5eb9cff5050e9638bdefeef4b0f7198049de15e10afc65e697eeef272692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7893aa3d9b6d0443262d3b2821e0c460c6ef070e01df1ef76e21c0005255b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1375bda7c294ebc3456c88d69bf6c790834cf463345404eb3f2cc3f7199625a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca21806d30e8adb1b82604f8580b4231d10409e18867b2dbb85c797cdb642faf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf3446ae9806fc56f73c340656172ed631c416fad517df8d7124ad4651a4793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfef93649f13e8848700dc0ce0972f3ddd8bc8a1842bb0d5bac63401c3d7f5e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f4664d1a6ab2e55c2b3bf0b37f81ea5aca2290b237e71797ba7668a6bdd08d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9cf17d7f425503fc4c5af35b73ae070c4126f5e04d7fec2844747f1705b054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df7cbc1672ea4b0bb6e45733524603001ebb7a527e7cd6ac0101e4993ea7ad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825b6264748ea7efca2960976459b4933605306fc41edf0d5f281506f2f6ad35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a7556086f2e152bbaae4dfa0257ae41907faba186ed81b7fa86e371fd1f359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735e023236b0406e3a31abc34959f10499b283bf9113f68605ee102f9de5d418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e0ef1c4f166170966d4aa2fa56fea6b74379d6f9f6b69497a7726851fb4df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe34fdc791c71c1eed95b0b57d8cd3576bc56e937a6c3f0c0ce6f475ad53ae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2990e84848d53a105638b41c58f0282e5ceefda40d4402cf2b5ec5a7aebec787(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab964e398cd7ac5d6dbb00a00ab4fddee2bdade0206103d6bf974bd6b51104d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce766e65e1a4dcf8946bfd0c53134ea112c3c3a5ed372028e107b50f60ca29b(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0300df5ae22a994bccb1c9a1d5965844b0b48749da7cfc58ccd7cb8723b24319(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133ec91843d5cbca7db8ca409b2c112fa0352ecce582002521c92c290d26b460(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f1b0cd92d9467f8d57f37fff69ac9aba04a149b41ec202502dbe4d2638524e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3692d18361125e955077417d50f6092c3654bc9929106904387a36e1c2b56291(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__624521e8a406f9bf262485e36b2516d046f98d938e1e53b26b9ba2356f10cc1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcd816ba5c51ee6dd8f0b7b940952da523d4c2acee0293b971d42b6ec400971(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafd3a604061b6b5eb0e6e773ad87d7b0809eec526b1618afaca6d7186b83628(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18191b3c3bfae5a1f814e6112bf0d02245633f4a1b972c1947387e905d6ace25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda73e05ed7fe2d65b90630fcbeb3a8cb6ee6bad6f07d11a9aab230852fa7249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6afab1086aca3fb99ac6253b65e114e38b9f6d223c74eb8e17ee6a82fcee568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e01ad3000f1c360994c7ae2f252cfcc24ac6ab3ad3d9e77db29eb7bcc49c55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab23ab9f7c0ade115ee377ac1ce0271cd6d7ae1a0fdcb38e68b96462b96d051c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63de707ae3540cd2d6bbc69865107d29e2e9d31aaf4925ddcad0aae68a5f19db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729de2f6bf346c773648b087fb7922321703729edf6c02174337c51be660a2e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1de2307452672ad3f6f7f8a51c577f77a67bf3c283ec73ef09fcffb3e10d9a(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0d7d2ad142c1066622f82c4a62dcdac2673e1d1f98b60640be6b9694cd0827(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628969c490766c6d9fa0b18bbf2ac3c8f5e228cb9e22e57e7f9e7370cddf1c35(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82c60aa36afeb6b58ac60ebe5e5a0a97aac33524cd7da3a20bf9cc30ab4d767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47db2a04eb2bc1faee767e9c912ffa3ff9dd69a2172b901e3ab0580d023eff8f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46a7e3b9274202e5410f2e3b76f8ce31976017ee0f7cf53f6da697750e84ab8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61672be948cafc3d114ae444b05b4a87a2955d32eadcf8495dd95765a9d210fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21a7a2d429cdf55d4d41c363263009e45de98b293f930d5217ab1c76955aafa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e951779d59b3c11453e080cfc9dc153ff4b294ec1096b22f3ca3ffb58e2d0a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfed32f575478aee0b62e0a42fb14dc6d3b75a67382f8cd830fe200a2b7c768f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__395da5d84730c2ad91e0096dacdec655b1ff448ad9708846f6eeb8aa13232f45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c4704aad540ffae5c301c9f6689c5ba0827440e0dfd1a7d1a45b1045caa329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4754e9f8819d4b5b87ec470252e5adc70f777e11d62c53f777a7be8ffd51380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc4f0bfd33158e7272aa5f1c5dc4cbed17a7170fa89c51a35465f58dc79894e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6102c4d088d3bcca4c955a8da4930c01afd77a7294b90148b8be6c4f200171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efda4bf15703ba4856e341c5ac449672689d6d86e3d0d58a62f709350c80167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__805ff426ce103f103eb10182e0aed2c46548609d503ee05f33f42fcf52de425a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb68e2b021159b43d76c6a84398ddea3598993c98b0e5e28b3cd77c4994e028(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58b3c69da7a2ae0d428da8fc16fdd3a6b5d88b015563f52256763e70df9b9e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7afb431dd439aceb00b9798e8e1e7077dc23cb9d93e3c85e32948bbf91ca6e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae547eaaa2525a8a3639aff819c94c8daf339602b2125f91a922f3adb98062e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eabbbe4ff438140dfbee1a2c6363953791e6b4d6bf8074d3826ad68bdb1a9ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d5fa874983e8460bd8d93513a39ba7544bf780f225189a8cf321d680d1c947(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e8891dd68a592f2b8b583195cdb0b9c16fd1d41419de7cffb4bd01cc1577ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269e55e61a6b3ecc04a549cbe7e51d95a998867f9543178c557014632fcae32f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc475ba9920efa914298d371d03557d9c2de07d170b62eb7a51c0f6ea8995042(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50dc614b8f849500bf33ad62e00b13dce3da50e91d78ad1243fbdbec1e8c12fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf93f65e4e3cc7ec78d665d3b53c1f80817cfa69db4dee9591de5b3c600d55b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2703d954cc34e9b0aa4ef21291252f8422be4780609ce2308e1a9e7adfa7c7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f43d7840ae1c08a69581d8df4b3a693d3186ba35fd711a2a5fb78b9b8287268(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f34f82ee633cecec3a30c3058dd658eef9327a2d2be363edbae866b76316c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869e7668f43d58cf7a3fa3d3f48b5d166e137003f30b0bb016e5e6ceeef13d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f369765193742c43aba42bd29fe12df39e8b3429e181532eef77e1cf80d744(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ca897b5835dfea32ef019e3f92e0162ad0745f8410534eec558dea653bc51e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf59468c2f8940dd3f69481ad777c5ad26a5dfcb61dc07ca24071a8a3663004(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cade1faf01af3708a24ea232c68316dc3bc7003b1e040967663b1d966fbd7106(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86df0e6890450af1728771c36a79e851879f7c239135724834f764cb64705064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ab7d3abf5aaa47c93dcdfe5ba7e9060cbe30c23c60e3300e6917a5b64ad4da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2eda72e33bdfc5f73ba1b18106fe4d1c517b12e8c181b88bed7948d81094860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e207a4f29e446a939147c41370ed4cff41a45890369cd4c3e2c8cf01b48cab6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__296188425126d3412ca5e17bde0772449ef9de02d709b0dc15fd0ed413e26c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc3da01771faa60f1ba77cbf7e3246fe1ec23e6d2d70bcda42eb7b7c89f1699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d5f49799db22c65c3cebcbaf510ec88ff26209f7d5acad7983bbd5440deda6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b523ab066a494a16a34c0b0652606101ddff0f7687c3c44da2b51cae56f2c4bc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12ef2ede1f13657a42b2744303d06e6ae94049d6318db93e53436d92ac68279(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5721d0ec7c92ac25027ced821b6d627445264372db1294342852c39724ada208(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2696080891e2a5559697c20d8f1a92ab3170d573ffbb7068ef5d44d87fea6629(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65dc6e91a69f90fe4d9bbadf6f3b2c321c3bcb3c43f5521128544bdea9ddebae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c4520b3a2e5457a37da0ebd677f5483c9b0fe88b2f85977b9883c97a66a566(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad2c478ba11e4f89a2dee993c1c29e662aa365e8cb41965894c44350ce9355a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b778299da2227bb77ebb9bf4d5c82245f34c1bc393d606ef36419a48ebfcb982(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2fd8c523568740f62f3a0174dac824a8055bceaa060179ffeef64b346d5b597(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__451184f0c32d63ea2f98eee5ff2e23fcbf0a3d7345906c3b8c2a7e864fc360f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96b9cb299e6f47cf10320435e5d3a7d2a1f79c9a2cf5d7ed681f0b8d9af4a54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b8fb9cdc14b7299a717461cbb95e6c9427a90b4bc605c3a5aec449d09d712d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1fa4eb016e4384f5720068d789664bd72abd483305e05a4f1101a9f66483a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d885e2c73ac2eb156122e3868453b2928cb9c22ab65ec757a7cc046a3ae02b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830ac777100bba4c4f7d888d8282cc700bd621f3f2ff34a6b514153b4028b684(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34dc0e25270a747138637641dddddd30923fa5a893a6bc6d00299d88cf89b961(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc09856835900e37a408262181568126ce35f471b92a6141d1ef3dff21af03c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95737e0a9118b52f670f0479c743ea14123dcbb5392c83a908699905ebef4b6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02383ff240d855adc4ca517dfb55341d2e8b0a70bc6272880d42044c4afe56f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be64b1f700b09a9451eb053514aec3019652022f54a570a16b1ab665b2cafc78(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3832a79673c8a446ff64d025c55e744e6cc36f38f6cba8702db282bc2013073(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025dcd1a76e875a6f422f17cad74be14e18a9535f9854587ec4927332715a254(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b94e34d7f9d1eb7f7314eb331ffc72c44349f75b552fc9393349db68d90285f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2efc62f64f026dfac4be13e7a992b05fcca468081ae103cd1e7eb350c2f020(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e5a80a41229a380a5e3070a7d7706da2ad0186a9e31c21acb74bf46440f897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468b19e809b62af056bbf0e716d9e27a519747c348c45f3a5d4e6dca32d99402(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd82319909fdb5b0dfc06abffff786784349f595d84256552a87134e53ae5cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8aec8c2fecff0e4b8007e20dde75edf44be0e4c260a25bbf30ff1b8c76c8cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e40a4d2829216b293f76bb7e843ce4f369a220a6b83eb2ca58f2a8c00c7793(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd38d451baf714fea50c920488fac6a28cd81225f1bf0b8a2d0d109249189db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c99aa1e2713fcd86e4cb68011fe818113bdb36e15cad8f8143391bb669fa83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d904082d54060fda683b3bd30996694887b7c5e58bfcc1da0a0b4c66fedeeba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1307536e65b4d8298ba95cedb6599e0c1974f969a19b64e322eeaa9dfa760f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f753763881fc1b0e7638b7226616326d05b6fab8c137eeb9e09aa98b32fda9ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110560bd0b4dde83b0e421dee75973373b6c76cbcb63496698973ea7a12a5fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3d11ca0db6cd35f282c77da7de897f5086b061a1ea10b97da2a8a471eff9af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939581f3e2f951df9803e7f2fd85c9496cf199585e24138baab49e7823cc0cbb(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed99de404abd1b0d97af31bd183101cbc8376abccee11af70300b67fc4e4d716(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__609a4a13b66a8a4197a461bb846fd1c7e147e81f349c241deb4e850ce39e8000(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__592550cfae8b0342dda2770073c81aa8c9fc4cc638c8af89bb81850ccfdad089(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79395d5a775a5dea093f6e0594034ed05de69471a01eaf1ddbf6181765c662f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5c86f3a5e9dbab3924f7ba6b3b6ca728dfe360342f9e0d458fabfd7a6a7dbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877f3791c6994a6bddb726e4423e179c809c5b01508f15be523a3e5b6999a795(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44da169f1578b0ceffb5bf2630b6ebb164cebe19d8539851dfd7e854ae1510cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d664c347a9983c49e0f8c4ebc67cb61f20d7cc024f2fe55e825b6ae70d71838(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b3152d2872a23e5f4eba6922a31b6528c180fd415ea17876ce00d88db44978(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baea373d4d5c856a288f953fec57d9690ee7df1bda8b7f8312f7b5c837a67a61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46368327bb824b552796bbdb8136d363983e2848ae55f6a5098986db2a961921(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecafaeb7fbe2cf887037ee82cd615ac0ac4c103a6dd787284ecd6d60bb2484e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87015c934ddab471fedd429fa19ac7811e813b8f257f24ec97630564a6e09f64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a624d007c33faa66da2db978c9bb5c2d01bef846c09921db688b7d8bd27a9dac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39efdce86e0d966bbf895b5f8c95dee02e6f7cc18d56b06e1bf7847a2286ae58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357432ca5f969ad048a880f85a2bd3c2f89ff5e7eb0531e1f5428c7de600fe61(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f7d00203c9e97c5a6b10f6a19574b8ba1bdaf5fc665e5685f5c911bd303bc7(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd0e8b63de202c2a2a90c9e9774056a3933607843b913a99db87bb53ef6f0dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80434e28118e63db4f7da63164bb74608a172d09e72d2f40d6b46bdd9a7c3af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27d99049d2e97278280ff363ca8d7ad5bd9054a0055f3c6e503a7ee0e955026(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f45d5a9ee72c379ed0d9ae1d5c88bacb4b2a1d8cb235a2fde34e5bbc19af5d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee81d9e509b5196127fe4bb54d3ed0bdc7a6067abd116eff5eede627a9b43415(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0adcb9452f9cfd1edeef3e5a8aa6e935ad6b4b575a2562ea93ef0745d1ede2ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a812c62ef8e4481e6392e28f7e855fafd64a2d3890ee3bec9f3bbbb35c8208(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee0d64bbad46b2d2c6186014a897156d4a815af7670a9692de9041f4891b178(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d78f49c2a0c6746b74a96e94f3de3ab9c55dc1c292c32aaf5a8584cf6311600(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96028f8854624f844027e8c64146e5523cf0167c9050f078617d5530035d6ea0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a262d8304a82dc0ba1bf7c78dcd420c7eda4ccc7537aecc9250b07911699c9(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5724cf9d958d52b09f89139ceeb6ff43795bd06c510cf038513e32afa27c7a61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469f7f0536ff3edf6d1c549d44ff854e358f925075b0b2490e5a33ea3657c699(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98f372b9ce366d556cd0cc07736e83971662a249d3daa9e186a14bd4a6c1332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f3b4fc7446939a90edb42d9715132cf8e69c7da45b7b51b78576af554a5d17(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b402d79567b4caf0edecd4493ee28740828cff0ed35e2c9eb05a50f8d10624b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1095dced9cd62b54184f2df81e1b76440d82b4b1deb85d3f68e036fc981deb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e8991fdd317d7da68546e8a1a395e72f4f6fcae1018b6a15b9b402bd3622ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f68a5b3aa09fe82b18f899a80abd7660df2ab0046bde95f84ab542954a2ff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98becb2623f2ece77171c906948124630672c41387cab6e03ff4e16d3cf05ad6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160882eacc29e7c12277086f752a11c2e8e6bef367a9e2246fad4e728ea30d7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6d2c2c5097187f1715c83d6c4b802c1a3f8fe6f73284378d7e1a9e6fd2b654(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ab2fa88c99cfda1494f48d4d68a6a53562ed0bc39c16472390e44b9596c15b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5fff246dab1980a2facb98a6fe15c7c1c3b2f673638530cf2dea97a16cabb6c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcf64624a2ea729a3a92d1ea0a86589d669bf99902c83348e33c30f6b59b653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4984a2386fc360eb92fc161ae5c46a90a814d0c5d840e07d1b3b5dcdfbbf3a0a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8523a6e0907d4f193e5660f19f096a74e216e6a0aed2b7e53317ea1a543dc9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e073bb44865b99b8ba5ff9c935407ee719a4725441d7ffd332a27c67d862076(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a63b7371814e44d406c90fa319b2ef8de4795ec6758c16979bf4c54733e9db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1264df8e00322d7f8feb1de950068125502604bb99f6f41082217008e732e52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3bd4fbff3571769de8272ce61de76bf9930686b22713e1d4c8222f2f490050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebd967b51bfec95b118ffce768f6674120eda9f828294cef46657dc20fb9712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32587431093d96c732951d195c4c47e53c5a99a7e0061cc9a51e59ee834bbd57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76884f2f52c3093dd279417c5790b9d1b0ae8ccfb7d7aaadceba6937256f2711(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197749df0edf3bf4d1277a627639a0bcbad991a72798222d634a2bbcf5f9305c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5954fbac6c7e266f9d4bf3c51d2242e30bc48d063a8b9849d7db425d65626e45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0656423e3e1360827cb67de5771a0492a92567055278aabc020a313064f750a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70902b0c9daf90d3e1b07b9725e3ad349623b35daf17cc5004677abd6e4eda3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce48c2ae54dcb46fa22101c6a87d534761a66b2d3bedf4483a6d16a281be2b15(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f612da743db71576b143afd5f9f58ff3eeb7a85e05237b5d617a00dc8ed26d38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62eb83f4503eac205b4a4ab0ce2bc09cc13e76f030dd0cc85b4bfac7b80e96f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb57d735cff17bd2fac188a8d321fd06554045bd63d8c832c87825c5a6a1816(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacae530e8f2b35c8b95b38721d589ab0d3451a24dc8eb9655a0cd890392ad14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b052880a1e98df5c71b731218a66fb7f9c76129ba545612e68015a94d23df21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__767238ad237dac6146ac3b2a268ba8d66438d3fcd33734892d375e99c881cc38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e42075b69af8f7e84c6ac11f625b6d89484218431171d00344dfbd13f0a1698(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65c4cfcde9a6c8639cadc34e23ade764678389102a5d8af7d21c11bc640f0f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e2a0fb34ba93d10e19e9e2a931937fd06503bb22192547d94a53c858c8c9f7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68cb9b00278ef9116f31353c172a1d8d094bc0f28bc8fddf4209da257316d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dda96e5e0520a0b4e994c950351aae4eff251f1be9c499743aaf39cf4f1593(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed7c9212e1661ce03c145a198ad149969ec1263aac11a385b558e1dd3272abb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45b95f875361739c5416f4bd68128ddcfc2d58ab21af61fc734014a89454ad8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__687c754650d1ead6d6d40ca85fd3806cb9fa8ed80d0c112178b7aeec1aebeb8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b77a68cf477c4f5319f35411bfdaf5f1a3cad0f41522d24d843382f057c498e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30c766b4c5af6018ac0dc738b646840c3f7ae67af6ed6980affb338e1859646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba2ad41f2ce4f73d64d393383f86458c7f9973240b7798ce58308f78d3325cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__947c7c72490f2e6e691720a2794bd3c8cfd5985cc847f9cb1c2dbcb3e05193b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e00f375c6a28cf7efc1de27d1e41677a141f5d89bd0437abb6f95c391b5108c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea9d0b0b03840c51d55c55c7f2400d8137439dd76908250af8fa497bc9ff1259(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a5b1f1572b1fa67b286ae7cdfb1ca20ce8c72f39fe101635f7bc535df5b3b4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6b7fec39e8f1636218e758fb122f791e395fc568397b88eabc49109d5ab1b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96245b5bf6fe371b8b1942a614dd201ce9f52a502a0cf594ce3e27585d13f2f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76692e699eed03708520385f4f89f9fd0ace1bb8ea9fc6337e87e85dd03a94d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e7f81dd56f5b8cb43796ffb507a2a8266c810aa6381d9d2588812812e9b5df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a5d6d4d4af88c5e8cf05da66bdb79bfdd2f93e8b1a4b6d88ab9b5edd13a6df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f8e471c06b8a022decd68098f9ab61d1a892f3a224375805605e341c41d4796(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a43e98b21a97d28e51715cc21f9e9b14ce119d4111a005518295a8f48fffd2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c014a76abbb68d71a3cdaa60d73ff1b8654123731287a1bb528eb523803c814(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023d9de287f4c717a644c77e67c9bbe5af3947fd1d00053b863adcce1cc649fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1373332044ad3c617da39ac63f3783788fe373bc5ba626fca128b2fb47ee3bf9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288bcd431ee8d22c2910a8f256a84b60284c93e30e9cdddaf4274d712b71e45a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b3abe76e268c2d5b70d564d7315496a73af925ae347c69c280da31dd8c164c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f3c14c9c558df2b25b117d7386cdd9c58af7750f3087082dc8822568097e6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9310369f5b9ca3978e68c60ddd09b6d6b71693c4ac5843f01d82f8ec646f7faa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55263b052e52141ab056ed4e524b19116dc675dfb7496bcb522d1a1ed42233b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a0fe4e08b04c04eeae4c2dfcd01aa2708b0bf534517d43a23a8d71c3dc780c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24211910b4ca0afe0c131e2b4c14eff24abe42119529a97129d28981374c087b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78231dbdbf7cf38ee5fbb6e75cbb8513f7ba8025a949c0f4e947a630bdbcb73f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da8421dbf0950e79abe09d023ff18f03a07aacd39402f3e734d73a5ca2c7b77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d607130d92204fd5174ddb5baec9ef7d6768f221cc5d6481110e6a99da1ce436(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca43f77e5188343eeb237400e681793e67c377158834280cb3e6eb1c8ea8e0f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210dec21d79cda41f5631c43aa8f297a36063995c1c45305278e24a07957d75c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff69fa88b05fa86967d8c6dc82dff3a65a94bfd6d16dc467fa10c6216105452(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133b5c61e4eb98cf88eed67ff9cc4149cbf6c12464f08e775ee57bb95e598e35(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed975329dc3590680e9a0cb348ff3717e8507c028000cc22c2d050f154b8438(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892ff28f547f10001d64566c0075ad44f7e18466b1376f36fef249d4f3cd52b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45dcfd4eaed5299997d7d0f8ccbdba4ed7dd1ac1c8756ee8eb5d2ee6578ca71b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0152b8475eff6fc00648c9062586fa025bfdcdfba4bdb3fda03f8119704a1953(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93790f5258d4b08a115b386c00c6ae042ec7cd3db1b5e106c3b856dfa07c7967(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9f4fbc0ea133d883d4d93330aa6139f5a5776b61b2b6a555cbf9015b346e8c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c737c4334bf6537d22ba715ceac35b0a7e0ab05902a9af79b473d2e9024258bc(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61da0f36cd13d0e569732fc6edf695245a8f621a7e8338295fca75aa29838fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43deea58ca5fbde320239ff96ae56f3791c21d9894221573fcc55f4a60f2da75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9374481091bb1ee2ab09f0ffe09a59d91200ac950cb1925bcf3731ce7bd6fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c487682bad9e59262aec9c3eb84d53a9397b0f1cf0915a7d9afd35731276c91a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f1a4f9c28275c667cdd8800302cb7883cd5e62d88a56a7f5bfb90adcbba5dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea9f2895adaaed7d6c7eae498c1e10e38a494e534c186f22ed13ab303bac49a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5f83866c9600b1760781cb81982facde6beeca683497f60030cf01c558f94a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e0434438991eb759f3221d92d7f103331df829f394cd2f3dae3b7259b1ee76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99a0921257cbfe774d8b02e77642d726605a3f2f1fa3e2c7c8f64c05705f916c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bae63fb0a36b2355efffefd5e11c6a6fa9fa2fdc72b8bb82389065bfdbd2965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569ffc1d54a36242c6ccd14a7c4cf559f23cb54b4ec80bbe93529c1ba26e557d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c45d7a16286071e7dc2b9cc2176199f02bf472a2e5280f7b69995d48072f9ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c729cd513869e7bb32a104b8c850424db5cd60059cf3984397e770ceb6e6ba69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4bdde50a36d092536ba64124488c4856bab4d007ace77c54dcdcd19fc89e1f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3ca742ffd58a8fb2967271a7ad2b59a6075f6baf3f7fb40ccb31a13d7aed3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5414376330465c86c1239772f52295a51d083132fb883a2669362e43b0c6b273(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd211a154296666addbf0f0957a3230e8ef25e9cfa4f642d8f0cf9aa902c10a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474ec2554cb2f09a78bd32047dcbd3e6ce0039e757db08f865bfbe9d70a4ee46(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6549a382bdfc9e7f223fa8a23bc02476bb32e82259f1ac71fcb8005820c3997(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415fcd473bb1a8cbfa35193ca635538d1b4915771b6e5e68a97546693ca3ac28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907b64cc7c05783777f62422ac2a7ebfa2a8d113694fe6bf48174de9e1c3f274(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1f9dea802f04a042718e6fc94c6a7b4ae1d7ad6afad090b7fe2e6154abd285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69c0d1aecf531114fd55eba92beef8e8eba9faa0258177a6444be06dbb61db7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c99415f703efb4db7561c6b143df6ae9baa3a6e07482370de58dea65cdd5f95(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960bfa3dd3dae3aab9ebaad17d640271112eed500f44f950ac5b78c83940b071(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c6c75cbaaf0a1ffe69d6b052a174569fe45a3688a01289a24a3eb5212d3473(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40429fe45e68c317025e431d2ebf2563911d074e529f472e1a255e949cf1f92e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c870f694f14215f07b36e3ff54458357a788c48607e0d38ad5708ad041fb14f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a89cdc30e3cdb482ed7f3fc00d4573aa6fa0d5faa4c0a01761cd743d58b46d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9050d9f2255befd3f19c4bc1c90d61762faae5adc34a851f039ea3106ee21bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf56b03ebe06562853788a67fc51bf05792f4a39e53c6a2c05e322e95f8b5b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd25e9443394b419835cd7185309640bd85f19888f5411b39db8e48621c8d8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d7839f23f44f82aed853edb5d9d7fb8f9032d532ecefcc58de9d6a97e295f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a580fbf4836540d12d23400060a248458ebefb8e564837be5480ec98a8f1f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfc45c093d1aedc47543926bd6a904a6c9ec5ceee5344c584ef57dd2968e000(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46cd2d62fd1123dee181a459c4d0598390501c455bc3ad0db722f478ab28ad7f(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83957a939c64b2f716349023496c087742cde96c9d654519c1384a51d8836d73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c37a2dc087e6f677f9e0e83a9d2af9f841b5f4af9d36194146756040d8f5e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__500298a13ecaa74a96dadfe02fef2972fc3b06b6458ab0d982f0698f7d76dc68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0799a3ff231c156535d014670c0b3882bf4c76295786de24b72999759898d1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcfd17f03ac0601b95130d54bd716736fde3b7b47fb89a2ec1fc390f28d84ca6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f98df9d1cb6320cf189f1b066062dd92b8b87985e4fd95c312ef041d32a94196(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0f5c8d9431ab7994f917263363b5b4f2c5c61c3cbc26eaa2f7125514b77d4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b880aeb675421c862c793c8c769a491f7e506ee81733c8cecb86daa71c6bc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf26d780d93a9ace8fabad5347eb837572806c04ce169378206f1532f9690fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a10a315898c9c44b8fea02504b0d7da8276611932f9a4bfe729f67c884cfec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfaf632ad35b20bae0d5dc4c1d4408d58d68e67854d6aa95285eb59e46f1f53e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2569d3eaee64de48580e229c3cb525b9e6641b336357fba2de4e9525192f8316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0ed9e1a9756e717688d4424be320731a98a5eb588d40d6b60eafc87d337395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c50fcd97302ceeda639bb11847894b2666b6bf4561c0c8455b2ff2e1baef9d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab53e29fd7be3f8d85ec1f0de2f6771580b8440c807615fee6135aea8dc7df75(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f78bd4f4eacf7071908c25e0eeb469651adb422ad94ed345de4360217a61d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28bad7e58578fca1f329f776c36f63f7af9d543325be7200d6931e77660a7831(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4875b8e216ffd65274141b7e86afa4207148a079502f367907808d961f382d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cbf09f842859cd977f4224110d32966b97a290a043470288f1ac5bcad0f6688(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b6b52e84b38b1d66f74205a95b8996e20f74e0d936c717065cfff4fbdfe21e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9a51c4d6da3ae478c81d3793adaa78f020f44a7fb61909ae9e57f90f26edc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f7c422078f1e04ab705ec94f4f8cc6c3352aed572f88abbc6b710e91b9b7c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c13b33254da071d0e14a5319cb876a6f7ac8e6884a5522d0fffba182b6eed4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54b250d603a2078e8f21c8804f316cdf6f4b0442f5ea77deb1f059bf6996485(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9ca5f9731738cbb8e2602cdb4cd64f1d0971114ababbf8e999b7e2af4ece41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2886a486fc08501c9f41e6d03292370a3db54cc7fd25abc24bce63e2393957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5d82f9bbfd86291078aea86fbd0ae25b3187e4e62d50051aea23c27f2379c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6105f976c06ea3f2a0c2c6e391b67669a8f3215a43f1fb9f3beade6d6f9ab22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404ff1af5471ab1365bae0a8cc652c14cd4e415e05c1867dd6884bc9858581ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18daa1a2823ca93c8c762db86075689431e7ad040af79554e37e144d4fbffc1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de6a7a6c3c316655e6a8b714423add32e1fa41cee22d04d23061f4f326799fbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afefa96650be8f2a2f70956c12838dee9a3b66953d83b43527e0ca02ab8eda1(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11313f798ecf6b5ff02aa2e15a07ce0ee9bebc04ebcf4b5c5be3615aecf0ab9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5746d4ad8a000464d63fe3324320972f7fcbf1ae54ddcdd8ea9efdfa5bbd31(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec0269851251e318e5f43c71ee37a7b5960b6937e34f625be6c91acc9f5aa395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613ae38443d22fa9933f8db111f6236c64d2edce585a062114418fafe8f76d1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ea7253ae7a533f9962f16a948e8bd229b5385a2e135155a15038a958663016(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9afb14f739ad06229f9e102c3019b869c2cbefb18c63c441445427991566a47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca5d0848a6d9bed7e0eb0251cda1ff806794ad5ab9a4e80515ed33749dfcc58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af686b20316befb956d857f49449f1551830b06e6cb26b6f905627209fc5d927(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a9a0dce2c6af47245f627b47e9732bb34e85b94c1712b2c6a499ed3c45b8f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85c805e58763b494925dc2cf8d9596bc6720fae19c5f0a1b33de2d101fa9d54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37759fc7756320533af5edaff5161614f54763ee5ea3a3156acc04d3274ab8a0(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd01d6f373325fbaa3c4e7d7be53181d34669c5ae51d8f3c47e939d08c15bdf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb14f8178266d441b8543617ff66a8ecf8c1326ba8164a29719c8c04b2c48b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07ec4d96e26c84b605c4ef0fd80b6e71118ef28effbf97f820f25c15fc70e05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d6732b5947233082ca529835aaaf93412d370cbd7f0d5aa696f47115ce4007(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f39c26026ee8412fc5eb47715daf2816580a39d9c616d1ee6c73da305dc24228(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e415c65360c5425b899c10fc210f8a7285ce2ef31014ba74ee1849420855eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__563bd08ffe6aadcaf9e5718be4849589117d6c9394f145496c0f30c75039afee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ae1a2c0fe61383e9bf54b42f6e070480b49be50a1202becd9f0f14ef0eb21c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9df3dd102af20edb2724acc1d26efcee1a4058b5c815d9b213babd105aad62d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69eb4df080850268cdbc4375e76b2a0a1ce1c3695bede4b506a3dbbc9626c064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136a0c0e1d274dbf84a246bfcaf04a4bf81e4a3ca0b27b379ac5b04afb90be62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72a212b98770fb0567df30c1f1cd0cb34685ef62768f13c0f2ee87b1bbc6143(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ea4f5a7fbeb919443ccf5764231a9b03f8842ac1c1cad7f045a8ff78a6ec6b(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a631d58113888a162832dddb6c0533edd76ac3f29e4e8be095f7032f0dd788ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5896c53807180e7e148e989e42c2b65735499b4ae23f238fd924d7fd9933a7d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e25cb71de62d480e49df5d6a5adeef7bbaa5c1247b2a33feab580205672f30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff2724f2dcb5b050b24bc2fd3e3d3c4270f0b20cb9e8c3d7d0544d568ade653(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832e84715d24670c5f7ed232487df546923598c7b4b35e4531cec0cef0211980(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd4d18a3efd8d86250badb58d6531cc879e30b6fb9e330388ee784c2525da6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57209e447f5b25965ec1d1351dc3486140a143b72017fcee58de4323797a1007(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e957bea3163d7c361461a4a7c277ee9316edbf88b9e483b6b0bb6b53a420d13a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849c1d46c61f2da61255f249c8052d40414cd6bf7dc1d4d5c1bceec049c4a453(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65fed47e8a19be336f30ce571f66bc7c08cfedd13efb9393748a6b08a9bd92f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3231a0c6b200464364330aa11aef5467f2034ad75b8c2004c50d85fa464d4a84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b14d950d0a38eed198e4ff3cb1ddf66293f4722c75267875339c64e145136f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28166d905582924764adddcf82da4f31597fb0d114c9c0d6e8fc435b79cf37a7(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb7c87e8a563d225e4917537bfa13dafc92bcb8c590c8a7d6bebe5737eee37e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__880fb326d129e945ed6f6a6f94d492d1065cbbf38eac7cd13888634d29ab2845(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6b5e5b3fe5bf86897705cfeee6c450e660ee781e77f233aacf924dd916e54c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5229140443ddb027649d2448d4f56fb555f04f34873ab956f5aafaef582817(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f2e8c27c500710ecae0546d73cc011f3ea20770b422839560b29f5d8e0eadf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02626a0d05d7676ccd29104361cef1c94ef4a0d231dc0495c5e145d60024de59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49aec4d7236076a8e5bf0f16b2733e668a4562c79f8008d4fce6ce5bfbaf824(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f00ac13db8874a9e33b01d9c0b73f3d7b1e206fb307fe6abd01dfd6bb357398f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7a41f12b07b9367ee79c2d0e147e3837c674562ce7257c9893b5d60fb8ce5ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3722a0751da385a6d1f6b5770a7744cfd62465f591fe4178beea08f21f9e34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d01627bf02bce609b54e9b512eee3c5d46f584229994880b00f7fb4f8a2b0d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b616b478ca345c6f06273075ed8841949466c59b05d517bfcca88a908fdda664(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6f3eef6f629e8162b44e1ed99dbce9c31ad2ccf96e0c0fb8233ae861382218(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0a5d004c87459fe00b4429572b207a3a4e328ffac5d906092c1a06e1a2b5e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815d623b8f21b368c749ad0b967ad067ab58619954eeaa547f0ca5f709ee4de2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676062a69d7c9c401f68cecbd80899dd8c9d7a00f17ead0dbd83dd634f1c1b21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7ad84ea014533fdcf81e9200f54aa507f84ae3aaf621e5b3e71129e95d55ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78c80cce26d66ef5fea32a36737f8a16881fb148063ccdd9650eb3af4f7b3a5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c13f52abe1377fd6d55717e67a0397f988fdf2d90cf848bab0fac86984d72fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3906992880d0e6482b45b83371cf573a674593acd24404c9fc66ca12827fb604(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf89761faff1a469794dfdd1f971f8129e9ee7f32be30a7c792ea56c8fcf4c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f5dbfc9e552fb1ebd49ef5d0943b7b6a0f3258b208d8a0176fd43757c6be53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f1ee640d603922116105bb5301938a7725cc196f0efdf090abc434726b5cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f70ab3fdc8aca44d376b84853e065f0da19c04123666f3a70132bdf4f972ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a5fcf462730b2782d22c7b28be17e3b76bd0216133642fdf37f1ef06812e03a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf365f8e057d69f4aa1fa1cb1feb0c36c183348eec236b25e84aa88c8f4f5b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13d891fe2263f72f6daeb2eebf9724ec4960bf347e8e0c1b91d3280332cac8f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ac5e999d9a47352a900b51e03abbd053b774096c0b6659e3dbf4bc06311b73(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb80d97906bb2f2040869e6531ca774c4a33c6ff9f393d3a403444639bf3697d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5315a2039af813aab762d2e867f116315ff0315654749589536a256bec48b89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91fbb93c347dad80f1b5d56676c6ab5d9e3a2b075650cd5937d1d5ebd75f1227(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ac4939f02e8f4627ada2e6ce6eec3312efa906ce36496f2fd8925c031614d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c737238d5fe34234abe057dbc62159ed6967ecdb408e986bed66ab80a075d6d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0979d2d663a2d478e07dbdc10427397a5a7a920e78420854f152bf64a4227f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0c34a7c395ea0d65b539c0f5708fdfc82420046f5155ffe38286ba38d22102(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816bc4c0c46baa4a8d3432196e676d55edd6a0661f1a11a41ba9d9fe434f5344(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33e5e071f2a0962552e3f72fb9ec655d35d2271e5f1e4c2b97e63aae1e74792(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7e5873abbbd1742677ebbe3fed01d86f1c07ec9eaf6107af216b039efd828e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8b54dc7a69d9eb840262bb5085d68d8329323c5e1aca12809ed3663e536761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51d29072090411057467c4d64eb65cc0ea7b29c7043822b877d599cb718e1e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7d55d1802982aef7dc027b9e078128e2c0167be4785a76a5fd057398d82e87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415991b2d77b6a73da671621c3c5b29cf2a8ab531dee8775784481fa0f440857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe800f042161afecebe2b0f03990ac2690b6e864c63f4ce830ed142aedb27f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c4a0f97fe87320985f95f9f96e573ac2b55a9e317e0159eb96831158427ac39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6c910a5f6a71982be430ba19a9d623950899e76c96b0368038d3ef3ce4bea2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41c636f895939c22d97522a636a3cca941cda01c69a38e96fd68c7dc47d9a5d(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ad1cbf6d03c59738d0f211b27b6a4cb0f4a0fb939ce97435dc3aa8d9086ff6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9dc8a847fcb3ce84cbf21cca3303084bdc19e60316922445b9a994990b0d058(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e3fa0177c5785532a08ff2b42ed6c9df37e41872981876fe4ea78ad6e498bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26aabea78020d89735f4d687b6251af93705ff356929b7ac7367edea0ee00528(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d9037039afb953d29a6371c56f56c7cdf40237ecba361183d4e7bceda6ee200(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede34826be6e9ba3977bf493936758dd0b42b57c534de1195a50fd923d7536a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf26ecdcce88e18bbbb5d0a02903aebf5c715f1de89b88df97d0cf104a376a6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bd13adc739957bf916f4e8c640e62898b0c6730fa6115c17b829390d385a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643fa1cb59873b45e16e7815330dbfcf44b12425a649d71d39e89ecd4c00927d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3039fcbea11a46b1119930fd3876c1a6f03ef08d1cf117fd5be6044557afa58c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81590eec40b0cb8cee08d98dcb8961263e3d707f44e21d9b93515d07bbbc27ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2b8913523d78a8758cd8be94baeb52893c1f90e86af9f8e542059e5f725f39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511276667ee40aabb58397f830b1b67a86037836b01979a5cd96bdaedede5479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebf2989182573d1e2e9aec7795b075ead7ddceef06e4ff5a0eec285183b4a3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410509a1b0f945790fe70300b5781f05ecbb434eddebe354ed9c1246305720b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b197309991dab812a89cd7d6b881372c4afbecbb25de9f4caeaa982a2ddd93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f4ff701aa457c334caef18dc1703ed3b7ef30908d0ccc9817a48ce9f41700d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ba0795ad00a083a6000fbe10bb5e6f1096c2a36ecf262831459d8ce260596c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef22a8aa13e09136bc86d48cc710b1ab13243728a4ecb8913f34c42bb515634(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d013ea2b149ade2ccb08b84f58458190ad1264e6043611848d3c403339fb9cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e99ec14642f3c61fb013db47f6841b3c29bdb3e43b907ef3ef6dc3a29a1890(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec55815c60a7bbd463a0af00152f318ffdce227b2529b14207b71cc2da2473f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313777e4bf05c8531c7216678d64bd9f4f3859bf40f891e47714fcedfb81841a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1cd5b976aa13e40220466202fe5a3ad1a723d3585f0f47c4a83285ec892a7e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f98adb1f6626773cad7801fead82afec8a8ab9155ebbb8ebc5e285253aecd7f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__debf0bd29bfd0ce381e7dcf4156094af35a3a590b1e01b279ff4eb3b4995d6a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45eb8e28d2889cce547a3c7037f73cd8b30d697def7a687192b3721842962ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4def1cf5109f948f1fa91331b080ce55343ede60aac5a91344dd05f95858463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984a6151c9fc0eb37828653f97124084eea42be1390f3a347e5c8b5e65fba05e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5426ddfc889b671004c8a3c3cf4367cead5f1c4ae4294a60fc691e6df26a1e98(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9620dc845a27c36e00ed2e31d9b4ea3ecb3e1bcdb05ca93bb8ef2772c7e4b5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b17f5de548d45882f3dfda8a036b96f52fbe341a60ee05ebff07f4726912d39(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659a381deae46fc72ed8af1d3bc5e2f5e7bc6251794dd1eb67334a249f20be38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d46064cb51bd2396076a08ec20909d3a7d8b0646300fcdc426ec3ce0dbbabc1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0777f4e6c01a17dd858dab5860621c66f519a09aa5532dcdf2d24a049c8b74cc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1390fdc1dc21b86413ebe8fa13d57c15d16a4f589248c7895e176a24d1ed7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f7ee577a2935f6ce5a957e712d7a9b42c1532e48588969b0bd2e250518740b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b0ea0c75801a6c566e7f09ba156b5b90ffe4eaf0ff8e57ffe9470bb13384f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e3cf995ad2f90220a3b6969f78f15b02c8b0f7c6115b307014e8fe4830ca5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5e15993a69b54aabd776b1a85be2220d3ee77941196bc682df24adadcbcace(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3467b4addb07bad8a050b07811e2ab17cddba97580605f101cd1f25a4ff1b203(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7fc18666145f3396a2a480e21687734b6bdf0a0f4adcbc0361f41ce27e0d897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e05b8a502feab186c62b1b9a54b30985355fc70db4757af2cf431f02a9bed28(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149a52d904d974ea1cac7cd97677efa6e6e45906b169bd53f7f8895d2e5e1848(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ae69077b1f6e75a07c78c64451d8f951b544a845080de9ad9f53a5a5c73321(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b3427387ed930b6b91ee0abd2f40d2d0cc73ebf865c26a17fe9a18718b341d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5412a774cd0fb633406c39e20165e6fcdf43ced2aa9a5855e8d4fd2f4d22d861(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c512f8650e005b5d0c9b001777428b29aad5054deacc57ef5d17c66e421ca21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e71a8b3d85d9b7484e76fd1387ff1aebc24fb6a05aa70f394b60266f2daef5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcc52c9c0c867cad16141b7d9dee72e052155c8e578f655dc11f1139180e4d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe114b95ef133949c1a31f169d5c46dcc6fa618686dd3c4f8ae3ee39cb161f55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1abf13044d2455f8060ba7a2503e6a58649027fb192621e2b08b024bc1b718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2485e268addc128c15fe5d20af62d1a83fee9c90a7792167282689040e0d4b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036e0e779aa9d4eaff2c75a5c937ad7f39db7b2871e8bf66790f7c585e7ed1ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8ddda59d08e6f4aec0058bd2e35385f3157fc116145f74c735614a8ea43907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c3aff36d633f2e03e0fe48c463944a47a6ecf24ea3ada8e33a1019ddddc965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf2c368f909e68e9a84d6d7bc0962cf3270dba1894c6108814c42c3dfb665dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__222bec223dd01074b97e6acd317f5fab2818d9d79f6847af28678df9752cb750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b7d1dfeda09fdb8f09ea15180b372150653a51470153af1c8073b2481a8e80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035baba163519d566c1d4220739a61ef6df432c452b8382d7521d9e04eb33af0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff36c84a24d61223905d71e215dc0bba19f5e8c61bb9261cdff9b571ef7a417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5260d653c298611cbaaa9c9677ec56c8e23347350c633bc0a33b8a9abf04f950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93311ee4e541b935a6c49d7ddd3ee775b8f9988f3d600e96f5fdbf4c24fecba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da44ae5c8a1c283ac7bd297ada40b1d156830d54fed70cc83436a0566a015ac1(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f204ade8b37e71763705cd7cd5a12cef6311f8f9322a8c99630f3787b108f8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74bb3f5aa5c28dcbdbf033ed55a52f0783df0a6f24004d4d76d6803f200cf530(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d89fcd0e45e804f173cd370428f96c774e3e62620564a5b2e1a1befaad20fbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed61a9158496cebbd7a639588e6f58cd95b6d2ac30eb5a5ff97fcc5a17f5f73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f198d86b361c545227661c24bb3ab10c46b2484bb828f5c716b901f9bc824321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218293be1005fdf1ebb5c6ba179fbd0bb5f419661ae76a932eed5464cb2ca8c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702392f70cea6af4bbfaeccd17243195a3e4f39fa55c573f6167cf0f878aefd0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0ada1e9ebf2ce66cf204741e52d28c7224dcbc6d501b49d83f09593eeb482b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229ade5fe06cd1bf0aa0860f3c271befc56309ace2bb8c13a4719c7618f24046(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d4a6858fe5b2ae94567721739655ecb00dbf586343fbd3bebb135f71988390(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22dbddebcf3f84f9242eaed66b9f6d25789b655e49863c64ff386bd68c6541f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf4420b3def86f4b90dd0548fad5092f7a019f6ac8f54d0f66496cd0e3cbf98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215881249e2a78e1483a5cbec1ed67853dbe55452d705ef0748e608a3bde771c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf6a39e812a69ae40c5a8a313d32c12b2739d985785734087502e76b6624f54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a03890230d01c37f6758bc79b7105a462346faee51a341ddb015ad854b6e5b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1498b64bf20bbf8f1d9a1a1a6431665c79b466bca53efb323a5747d9e8063e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88167b76f2014712e64bc20a8d24cbedcc47ed56b4ae132a1c34434fee2508d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70383cf9b4145f1ccb27b460dd72b4b3b852c0db37e2b6f2ae9b9afb6e3943d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf48f2f41c63c6591874bc63744ed07b37207cc8d3ed3bbddc8786ba08aac87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f4145c25813bc3b14f922d4d83eed2fd337f08750324ed0436634186bd4f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975150e445ea2558d7908f4c419db19598599783f95f511d7f392c05c2750ab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29393eb9ec7c7f76f7d08b7fc7af47e607661c831d1e22a59f4d8f38606026c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8c01512c746d40ed01c26b794863ec3e1bd8b3b30cbebb773f2b02b0f9f92c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99a47e00726a8cd5db0ac24448382fc21a706b0b7a1af04946d8171281c21a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f4ce01b95b612563c89b1dad9c84cecb5aa7f5e23e2947849610d5624573f2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c01054fdc6afcc92994acdc204fe91bdb5c644baf7ece009b628b4a83539f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b983ee6da5777a4076d50472333aacc44f993f73e22540ab046036544f2c145c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1447e2b4c412b574a37bfff85247a949e895f6a625da855f8a3a6db927dfc6d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b3457366e31318fb7701bb56c53c5749a8c731e68583d16267eb19fe0ce5f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf312d47bda72a1fdf358b29a1e158381c001ece23202a3706962cf7df503498(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d136deca0eebf236c337c1bd705e8f47676228bc2bb4c727c5b8fc30c6117eca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2154763641d4efca3962c402436baae824e13ef0daf9bb9e24a43b2aad3a612e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba82d06888c5287c5e7b5630f1e23411a3b1f9052b8baf1f08ac6872e0b72aae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a42379d801ca888cf735eb555e8203ed29908c89814b0537bc98607472270c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b64e282d97c975932fd97aa05b548d94c4edf5997491b722b8cafcbf968733a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca5ddebad150199befc3c1b31fe175f9899dc259eb73e93574580b2aac0d3e2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9dc2703d44c06cf9a72b53c94b4ce0934b9cc001914fbe908ed1a0fc90a8e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8d3864cdae75fe232663ccffec628705671b4f27ce87d8359cdf9349b865b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e37b3c5b7792eb5d11068c9994a7fdc5fbd57e35801681465f729f31ced960(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25637efa0d3dd9656e2b6a2f5dc382b9a57b978f403a5d963d5d99783a1000dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca8ff9724c9a54cd5c0a6878f1c62a1c26a472cabc9d5202e50eafc9b0e89f5(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9722929ae97ad26841601011d020fc88894067105209d915c97b203f597bb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4175af0cffc3f46a3bb9e3ef297639e517981b4dc9c52d89d0b3f92bdb4bad4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9cd01e9a22dcc5a8b2e55ebe6fa749e9ed62fe69674dd242cd54deef51d517b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ac13439aabc5606f1ccb69f31afe0c0edbfe60c38b180ee481d854ee1b761f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3ba0bd6547f9f6ff9b576d81ef251efbc585da2aec6e7600874814859750ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db6603789fd9e4ae0c15788e010189057321b84ebdbc1b1b97b1ac130ac886a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77002381d657bfca98bd9d8dc47daf23dc0167576b0925342a3c50ed8bb842c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3900116393ece3f119627236a59cd2913e09ec44e76ec4be983a4d286bc724(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9be37594de155a8d0513f75f6165dcfe58379a8287165c4aa6deb336c0706c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2673d645c15f8f10c1eb8af4cea86a32a32c19fd8a158debace17ba27055cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df3ad7919197ea486491572789b1f6c6fd7664edf7bb796d35ada37b9d0d23a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012d5e8acbdb8595ad92d6c72a185aaeb7e564bba46d2054e6434c7e4ca7c85b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36bf1265f73c627cddc24caa8803a5f33a9c743ff1aaca6644fa9d6b2cf034f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d14635314f88de13fdba616a32589816bfc1502ff1428c4c8b66bd9214a1b58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8040fb0769d9aafa9a2dc3d24b2ecf6d1d809bd7322ed5c4057cf86da1cc4818(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077afd6e41504bb50cd98eb7ba35590457272ef4c2deecdf9bae366e982e50bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255cad0d02232693b066c0426f674959a77924cf7b0e77c24691d7ac412e0f91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7633c9ad2996c2c17b6c2e90328ac1174132fbecbb52d9eb6f941c9d119b913(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36216fcb021b66e556f3766d560a96318e83c3e7bde6cdbc9af028624dc8a4ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b998f14b6c61295853f006af6775b3c5d468820ef3a8c458df934770cdb3cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8860af0698f6094849499bb35ac537a0cb952b4762c6f5636d935d4fa0b12adf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d26cc5a6d9ab4c296502e34ea251ffb6f142126d048042e50860b49be320ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1d57287e8628c3e1e5e767c7ecfaefdd4d8494d2c6d8a8225f52b2447c92d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141b9bc07eaa87d2c44afb94bca2e6706802868e134993b6c322f6dc73e1aab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80d8cca0dc52170f24062450892b8be3ade25fb32cf9a9c640e048b722bf282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b003b68ba4ed0e60ea1c2ca9b21fd747f9d694923938d803c5ac4ddc43514a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff5ab34edf5b3c17a06c0d3d0a6ef373c460dc32d0b4f144ffe206d48fd3e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9576bc094f10719ae95f93dee339aab07ed1e8a3935330e04a953ef34d5bc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf91b7102a860f981307bc72fbd1083ab32c422f1c8a311d4aedc05d5f8f2a21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c13d4833a8926fdd681ed0d75bf4c78bffac0265b9f1f089d215ddb57146e00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0eab0ada0d85e475397a91c230cdc720836e967092c26ea2fa776ff948c60a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4035a58a4c6635f78465cca662892c92b77e03c6fa7d9d853d9676b184714ac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408d06a3634a59adc9dbb49a4344fffcd07432d3bf95cdcc393b83096a447b80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af088cdfd596685ab52703f912aa06808683c124f90864f2bef0363ba1dc2892(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff71cbb7edd1a404806709a45c4d86c58103d5e0631e3feffe23719687d91bb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc38d74b54f4848e45c7c47a3093a7323b3be2fb5579425abbbb4d402490362(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b597a19046987ab2c80c2c9fdb7e741ed8f13b42be101c913b13f852a6ff0ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162733a27eefa3d0a6a046d26086f0c737ba11318a946dd2fa27f06919a2454b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903035a335883ba89c69f369b38764b2e89661b34da591fb709a08271a716e32(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377f0ee7f3f76da2361241d9f4b71427ba8c6f45dcab7bf643705bad74a39d82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a442bd6c49c3f0ccc7f1f70b663745f541a8e484c606458c273ed7d6175a42e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8725cc6166d3bf1ef85fc2c0e7526e7b483401d95cba2bd3b61be04f5e982af0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e312696fccdc2462da79fef5e18d8b92fecff6ca24c028bc75b76bed080cb72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f55f53be313f3bccab71a82190c72bdef946d718f829a8813d7bd5925d3e22b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f103c4f1679c902dd99cf6e6d55308cae086dcef749d558b5923560e1b01c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cfa8d7102808786b9305411aa2377984878208c6c5942d7d07230f5ccdd6f4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3896707780f230c903427bef5bec45c6c5453d3bbc151330644ebd0789a123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c95ae0f4749a8df2a16c08a58b4eaab6813f4a1b122ea0e529699045492f66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a1c766dbc7f069e4ee1d5194d666811dbcdd2f36eaa773f632af2db89df97a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce779c14222c65ab2520b7d752fa0f56afbfd685611f829bb30a7540266d6cf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280acc59da78673fe0ccb995f34c640158a69a4408bdd2a0211d627868395b0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0fdfb37cdb6108d0b16949ec9902d566d1cc3a99220877430b32d6b21eb2e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a8462050ccb035cfcf2b9c74ea5e99b25db3c2f549f2a5119be63f3c8bd725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a39960ed8db2b981dff6a587c9863176287893c42d2e7b87f3d15eade856d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c51895d07f76bf90bc120db257d672d37567bee2f30445c014b3931efaebd48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867a9749be4ee7df58bb75e1614bd1b6ddf183844bf18853474b791444d9cbf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408558fa0ec02d51e63589f09539831ab9dbdc0f63b980a698bf83e38ec57970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310570f7383c31a25352c2ab244ced5d94aff68bf13667eac51eed79784bf9d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca76af575ac19e778b1d71d8d3cf1955260680c1ba25df1b97a6543ceef2529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd278b5257e505ac6e8b52ac2ea90df34b5c612522c7a8cb7d685b9d9370761(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f63abce03d6b8de46fc173041f1c7f67834ffc0b60dff657671421e4908995(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4c51ca984e0a7c713ea24c3585b66022da1db1525ea688296ac4f5df4f9d83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d546b494b7b5364d6f2204b1a98be89b75780b889c61116e4dc9a48a2d61d791(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21f120b7e846131d0d842d88b20ec3de72e82add51c18e9fc66d7d805b8e8cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04e42771612f67ffe8af6b1f2177efdd987b67ece572668ddcb80056c4ef81ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d05d88fb6717791a2e8e478a967d0a4571a56cd4a33916c71551ccb1267b3a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f328d9affba24a6763ba66f3d49c27acfc92b7037b90eb5cfd4fdb375d5bee50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9489a4ecbaad59f7a21317a2db7d8a9e82395e51a9bf7d9c732f4e97aa526f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd4c10d4b1a0944e970b6e2ba607b1783128f39830742d739ecaaa22b32b43e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998ded4ea9f97a78a2ab851dde92c427bc165defb913f19dc7c3070551fabefb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0323a446afd5c2322c62c322f3cd48122868b65fce6a77a718a688a32a78855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88bc631a2b04bc51197a97c2703bdb9e011d35dff4648f6d379325f98eaf5029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcec227037c8c553b44f74bf1264d7b92c52e2eee09d74a81497443637e57cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982b0b46da092493b854cfc269262e547f77ad4a5f49df9e59a9ef7cf38f2bec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728d271a02c470266a9c5a6c6ab992bb993cbe0284b4ba3884771d2ccef3e44e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ae50fc63565bdcb384e21032412645f5bce938da71b865f70ba478203e7927(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ab4362e06d4178e978de9b5c45d38c28f7667f997154818423eea6ae9d9f8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9b8cd4ab5cef5f0777ae0d470828692abce860aa691daa64c5a700c2c35582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76477f2d96b4a823642fd9ba0df9bb41b3e7e9e68ee7a01e5a382e78cfc6c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de37378fda43ae6c5f7404bc7f076fba517f8d8d0da6ab6d5d0fe3bd3de09a7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f124e611c4a424d0a34183ae7ca06210b25cb8d10ee80f4187c838f5aa482590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0e60bf0a31feda43a11b0c8f886efbcac28a218a8ec6611f0346aa24471f7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716a70d5b52732ebbb6071c96d4cf23f75a5599895b315afb421404613268e2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c593ab3784b2c415aa3530d9a8470b8cb2294548a265396ebec52f622e08ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2798026c5a86613f510f40f9bb950aea3f2df8657b1d4fd4d30e26e141a97a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a4ad75868e5dab4e1aae6d95ab08a08924fb25a084c07f2594b65aab11cbfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900cef3b71980cbc5ff6abf70f50cdb660d26577d642126d036ae62706118cf0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac134dd81c5c0f2ae3b4f05d8e5e820ad752a379cd333aeaae2efa7184ac293a(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0beee10a29f9277d0188ad2107e902e6c9facf755e20b4df4b837be0b3abd1f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9be605112845108d2c9c4c1542e275eb31dd38c6e1d8a204b067a914b6bc558(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60321b96bf4829e30b0de4b848481fd9e6b015f6bcd34b4386898a2b0b6210a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2490a885c07e1a68dedc87683edc8885f30241b55b256d22fe31da8573a2f90(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1381f5552e96b00d51ee9724ad30cc739dbebdc7bb1c3dbcd450467eeab0cd9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e068d362d14287553a7bbc824f9023d6070bb48a6f08c7dd2b9816625e604d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe9f430d116dd7229b1e91ee7b9c47e42fe98df973f3acddff1479f6af15a74(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fae174a04a652151e10188a436c4da5c045e3e1edcc3bd8b39b6ffe804d7e4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fcade27de9e70dc03ef02051b9c3c2d7d7275cf92c63644d3e15a668357bce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14e5e8b6215d8b2636d4d07932b10f57654c10db17a788a4770991c42e5afc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8be6252078af0384eabbb92325c867cad0f78e3ad5072b123b9686cfca8e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70452798793d8f2be4d763fa468401b2e64ce730c96403cdaa8c642b0e94f936(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08570382f36c33cef71a652772e05b3aed21b6c044842688a72529ee3efe6f10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f68db25f8a486b592de857e56fa660b2355c1adb4bb3d59463ab1a2951f85e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66646da57447ce369d7c9a4872f913631670dbbff12500da01a8108df320016(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5fc14f60fca5a060cabbd2aa11e6ccc1ca34a236b1244cec71d2922d18a5b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f35f25012c0cb2ed74c7fdcfaf679076f5a7d5fc3bbdcd3f6c0d0b46b3140c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006cf1880f459ad475e0d8725b4320562b3072abcfdc6de1a85b03a3ad581611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1228083c8c41ecc980e72d498d6930167225dbda731ecb4194baf5dc197fde(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505a52a5c4a88d69de2f1cdb767c7d23a14ab5908044f45ade504b7b29101ad6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1eaf56438a58dab57db8d9a6e6133d8c3fe89a3aad1d47769f096bc9c3ff73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64d492732a75a6715c8d2bbbecb73c7fd92c3dd68ca9fbdd4efba9c67856a083(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a61bb3dac06b8c5ab6a6d21293f65233326817726a33ed9b28a57aea649a25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a119ae5dc4869988f1a8c81ef80e9b2a5013759800e19e35df7f0f7781619070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d646485aa0674dcd103a08c62012d3b7b65eecc97130a1ee4cca43775826a294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d51ee8d241d5955fb72a96e58d814c4aed5787aabd53d977277afb208ee4789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d201054c7c17b33596ee13bca439bb80bce96375aea1b0bf244e413d7261cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c839b2ee6c2b146cf133f4257d423d2d688814183c5d4f1d185c34d6a68a23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c9a46d1e09036ced03a51f1784a6635f9b1c098190b57a6a7c303f46167608d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9355d19a59ee72f3545804133b3c2e657888311296967b526ddf360f35c48b36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdd696442790048002ef89e02c160203278f4caf28f11246d0634cfa4a80c32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c608e604a6d072df4914fdb0369b065560fdf0f0b9feb4b50773051caff7a9(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc360d82c2e7663cb7130d7027bd4c689ad3dcc42e689c3d50575e35227b963(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b293a904dc120ddaa5156753e44b2ffdd620b43310bcdc47f032e3e9522819c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b1729969d7c87b9073668a4d7c29ef4fbcfb1f7748c0923ba739b3e9bc6a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6826278b743ff9865e1fac1424e15a7b1588e1bd470ad7b24fafabd856e04a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32760fc7a3f66b237f126c0c24e1f28b3dba7bd9189ba73387a447cef58fdd42(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99641246a8a1fa8990005251f7e374dbb92900b6866e4b2d4dc5197868a1619(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c5ca7cb5704cd5e080768daeb19e6fdb8d401470b07eb2d7047b2d0a6149a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e111af595a1acc0b6dabcd15fe0bf1591e5805e33931c0cd9d4120f2a00d9f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab899971cd5b7f78544155703b8163935e68f69896c23542bcd3eb18127c47b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e18bdee3d808c53ed8b7e5ae4d3642a5e9410685b68d4c82e1a887b4cef2c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ef3776ecd02fde81f630bca7b537f264d342df1e0079127dd1d8ba141bf97a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653d4b9fdb3eb498a54076ffd676c9a261f69c929e54c55e1fb4fecf1a10d384(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7d9bbd487dd773034c5280bca279ca574fbd845f22e233e0b305e1c83214c3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24bade351d68d9b81cd5e7268a8c0c3085180872c721b32412b4ea1ad8f6ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb52dcfbf876588df669c5af4631ad8235e3d823dc3090e36d51fc9be919c012(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46a869f2f483af3b5ee3b2701250b37a69a194180ee98573447437983069b738(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4feef101ad8f62e5c8f4c46f29fea37bed5814985408cba3b2aedff46f22d1a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af812701b9da41935b5b54467471cc8233023a0aebbf00f9142cdcba2e8b398(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620c00fded33d34daacfbbb6209c04043bda3c1f05d62c983b894eb5a2653a8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee5831580f400c85a05e830939f4e72b5f99d6863cc42ffd4f4b7489487429b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb91215eac605626d1ac912c66c3b9fb3f8a047ed41c8650bb3c513620e3291c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a42ea4ad368f113e1b9a0d0b0f66f070c6100d6b3c95e656f19ea5537f0ff9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4e313621236657d035d41f654e7d5e3ec097739920136e3812416a20144046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80cd3ded4f00cc56bb12c7943ef2a36c4e35f6a541af82db9d18613781c74be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a893ff3438b06dfb734c3d2607f527fb1c2353c1126d2cea980d4554ffe8f24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66298976f09f79db832c6ecd1ef7d20039b4dc036e8a9b55ef2d4bed711cf6c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89357340bfcf34a109195712aed32710378c72eb50db446450cda0cd74c9bbdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30bb484aae9a1430bfef44ed14dbea5e6ad723b85d6e9ec11779770b06178ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155c19d8726421bf33443b0761c3fc9cf698c63eeab72e649776314c717b3763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910590f1e42ef2f77da087b8b45d6e98a7df48a902dcd00c36aad0d45900b578(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beff01555530fda9ea275e58617717646ccbd1f148e18a2904d88596a1b78384(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f4653e665f64afe5828cf85f86c7bf30c4548e4ef7533844f91fc314dd2f51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71f8287efb3dcfaa6dbd769f159ba6287ff8844855021ff73dfaa37dceb0f2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca954c94226f7a0b0d1daf639126f79ccd9c425e9ecf6aa02a66344be1467d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8bbb9cd29cdae42ddd8d30e328f10a567345529edca01d73072305ee3932757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b7bb37af6a7848db93509b03d82d41a6b4dc5b0c2c336cf38e43fe822ad44f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03088f69779eeb0a1f9c0be7d167af69ea08a611062ea4a9f10c232f52e02843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069d6b5f2e43917290ac1f5b5a1784ff036a3fccd78ef9bc05258effe1e9b9a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ebed6bb96e87129a19c6c7511bd9251453ffc1ed8621f40afb0a7ce875508b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb2eb430092617c5329214cc0147af35e636d2b49f607c7f6c91148dc4153a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7cec99ec555373b9272783ec0d1ec23ad05a040615d1e267d30ae0c03a8c34(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d916420542b8e47dc34c15a7ea3eb6e65113d096d358bc8bd1c69efbb41557a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__babd3b0eacc1ba76a9411a43ae0f93530207aafc549201c4312b7876cb520545(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978b95f43df5ae22f04aa61f4bcbfb0b3cd55f91fdfbf8aff71480015c9dc633(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb2d12eb1bad2593aa069a78fa597ff6ded85fa4e0cadcb07af5ebe582d0b86(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66df83a06635d9258788e9a313c4ba0fc0d22112cd25f1ac571fe4e4314251a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f20da7e229472f1cb40298ad87ca977a72ddd0d4b099c08448d85307b87a17(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3829c53160770751ef848ef53aeb602b03d8ac86a28c90a9e1374ae904947549(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d659cba7b0ccef138e9a61d6e238f869594348b80fe80e60c2aaa8fbb82ef2ff(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1cf66d731075c78ba895bfb127cc4562722c14fecd0b25dd9218f9b8c19c2b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d6e606bcad592892fbce84031954958dd2d9c64f28b9b50f8e25a2d54b1781(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02044a1eadae616afd6f6f817f8b4fc772803def3f3d8f071acc0aa7034e292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc765b5e875a0a79ed32b3be08d5164872a70a6eaeaf0aae7bf20d2649df639e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db285669511a749a82f983bd551ceb5ea181eccb4b948f19a35084e9d1a8897(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b97c263a087d050615d06033dbffd557bacbf314b2d3fb03be4976e2552607a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f15643ba90ff4e3ddb6f063770c39ae77c2c23c5d5eaa1008aded597f1f1f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c798baf6bf17cb29b9942df14bbdf2318cc9ac64e4f884a596506af40af2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f0a8e04adb3bca21b243b5e92350a72031d15320f03f556804ae460b39ba77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec5ab7443c5be65a1d09b639cddfb5876ec65c0b17e02263f2ebf56f6a18190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7028e00f8e9d11353e77beec154db57b808ab22dfd0488ef63231456c5c32b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313961869b45dfc23cdfc917b460630e3397dc840c851304cabebb2e5c168b96(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11b2c2a9fc198233f2a91c5b57d10d37365d244441c0d131ae3b71f9b61d6f6(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce429ca7d848300ec1bc88833d335b5da9693201a83efc7007118e9c0534dd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e05e8658a891e5707ad5a8cd866045131d9209ebe642f0694db523732d97c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92cf08420f4f9d04f8ef09c6d92344581e41faef90fd845f51bc070d1f379a00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06fe251e68082b1939b98e099c935471d670002faf73e1df943ee9d26fe170d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a05aac33c1657eb92bd8d6732286a7e2bb6dee5690992432ca674668e07d099(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58eb164096e7a0c01d7a7823f7713394015a0d88ff8664f5b8c39273c1ca60b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599954ed7244b1a1989425e6a6eaab87bccd6b46611e2fd7e76e0ad3e4e037c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0843284cce9ef809ab061c7bf90023cd9dad0b96970573a531528e999314dcfe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd236e952cd65f0e3bdea906d045451813905b2bcabfc6061c58156ebfa3233(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193737dcbb10458a58ac9111ad58a28cffa2a4c72f06bcdc3da26173733d6297(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75299f57986368db71db74a5a87eabfe377a917784c93cd346134e82b59bea26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ffc357de8a0f08842d97340904816351a92153ebd7d5d2178ef9e39fec9fcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bcb08dd8325af741d4b98011057a23978c8c90170fa84b2a59add6ec0b65d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b857dee9e366f4c5ea72ddade733322e829d5c6a25b9b28f86d29f83d1bb9fd6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f01275c7d33755e8c68a81fdee339752d3b2a2ed343134bde760530ff8d3587(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3540aa669eaf71b946f6cb22903edd3226366335f6076528b30f10225942f2c9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87767ed93ec81a0cd28c8829f11eda404b10ac92cf54745f9ea19e9400234316(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e4339518a2b67fb1ef56015d78cf7081dda99a0fc702226c7f9a6ad5d1da8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7838ec826f4beddfb4c8c21595d953a2587d7422d09b960a500cb153bf9d24e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1238a134904821153fc161d95d9bafe24d72be2204367115d333379b5abe86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f74ecd67ee2c5a2aec3881100c3605332ec42ee4c076ce05c648591de0b09c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20267d2446d86a954e39afada279eea907fe8fc448a0d3a7792c67497f0ec9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d22012f6f7d1b08d7049177af2f5430967a068c6577a9910d3342134d824eb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa2911c397e0f237474e613b3caa1b00a1802cbe5b6e6737c518de785aad42f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4157c8742a33ef51acfef9ede53ebda474ca745ea9540ebc3fe73bc81cb8f53(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adfc557b0ad8b773b588cb37c32e4af339f49d1e55b3b04f0f9b5c2561a4d352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2b4c70624101d63f804ffbf465b05e937ae8c19cac018656763ac58cc481dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5d654b89205f04d43fe44f1b137d814af47548a88ba4ea7e0a271e87c61217(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c29edee6294340e5431f3900325c87907e6100aa2a13ee33f06357bc8a22708(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8c1a0c3a3f405e61ee9acf08b3deb888d2dbf5e3b187d6333b6e2dca0abf7a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e45c4b31a7353d6a49d9c1f9b3e7453c58a9f63f219dc4c461f0989734417a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8e0ca9e41e3143e8eb10874f10f4368b22778d20dd77fd41bc0e6095d41e73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea103672acf53906c00e7eeafea7b776d8b9aad46871280323c8fc3c5557512(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3468f1cf823b8344b0a3177381a370875da5851bba9cc8db7de07256290c9c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4012e347fe35bd3532e5aa346b9ae1395a661b8dd5000213a0f74edb3f6f1161(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c4124d9717b3e086cfd9857270e193398021ec2f58b4f9220841c93418664e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9225e02a1853f83334792a535faa2beb3399fcad53d3dab0b2d21d55e9ff46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24a2335e37089e4aa78067fa7c2492fdd9ac7c737e9110a6bf5fefc21498461(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34cc903ccda66d0c3d7c4cd8aec083aae5d968b8e81ae1f8667ceffc4765644(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2423314fe3dec471cec4ac68b23b1ff7780fd53440c93ec7fe1c2e46f84237(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2154baf50fae1147b26492584fd91538da8445adaff9ee96a6db712d6673b03e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f0d66d5065f84a393d9919dc77305136dcae2ca7ee51a36f80105eaedf02e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9168d220c3a08c8e310d8955392676524a664a836c26bba1dfb90d34569f849d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d397419e712c31a2ed194707db6b667696e623ee049757f5ae071c7de7350bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86adc6902f79dfc98c944236b8b110dea1b64173fd4beb3911cf13c1c749caf7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55ca6006975e92e86fecb403a6b3920512b55adcef72f29d3808a88128267d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612aa993622141e72a31d2afb481e7fcea76cc5f532e4b5a2f14317f753548f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e46492a2e33c9f5dc1a0459cc7050e77e397ddaeaa035ff19366fe010f5d80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2744551f880de4e677aae420071b8da2a4e08ddf36f4f2544a8d492dbec90031(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048a1e07e71abc7a28a6a7182bde7a87a44c6c20e10ee6f4910b4f51907ca5ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201153b9ef53c83e96a1a26c5b09b2020cf8cb9d99c323ce7b730d205a3f2bd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d1964c43b396dbca41faaeadc1cbf7a062b37aabd6b7c63922afc083d38ff0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5befc0212198de273319314925fd99c5019d1538b4de534b00a4108131d3c89e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3260a8c103dd2cae545f33f822cc855e950efa5edc65206ec58e093ac7fb736a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4bc3a235ea647b3a628677409dce8c2340ef385f31b81c3b769deabf610df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2415825bf68cac76051b95018393114af18da3e083a41b6572da6c1c295d9931(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b86c7f4cd9c0e94446db9679af44f67beb8742df3e4b367f07b87eb03a3094(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f30f46879831c37efced176dc6b81d1df10472337751c990dd4ac54abb8709(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24c973be026b2edd2516783efcbe648ed482c4309fa27fe82b541629404c493(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea7d12e809701c4f2c7c00ba0ec1d68a8a1ee581961063a845684b41456e903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2baff6f9e2ac102b6c824e1457bec4afb6954205fa3e0edb8c50051c3ea98ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182994359720fa2899bf21d56f748e207b7db65a265925b65d86055461dd30d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d739f930886a8556397d7013297fc2c30ab19aa6ef8953fd48b1c49cc2a93a7(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e92000cdfa2dddec741b7535a5c2609ad56938e22e22f84efcba4103bbaab2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e77a331612d828f25c2c07fab59c3913d059f0bedeec1b63a760772c5b232c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a383c22e7347f8f450c266723aeb341034d62663dcc1939c011311c6cf9b2927(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aaffe3938d3d20d02ff8816e940f3ac5bdbbff68bd1237415c66330fb059d90(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15b46b324120388a37cc845e743dd26f179617da38750bf2a54dd0b17cfa9904(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19af99f9bd728579624dfd620da29a8893e73ec3b574503ef6b6895c46706454(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f41ac9c55e192a72fb749a2678f3f70eed0d4d9b4d1500e88f23a5e728ca96ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c14b79c17ce17de01ef927d5ff383f2daf398ef91c152590754ec2315cefee46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3470d025c28a332615956d23306a695ba20a5c0a696015bd2027f8cb9324fa9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87620fa6893d3ba926882e50e3e97904904840bae5f930602c3750d80b9f275(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d83e6bd5c008f2680fc4e04a2ebb8926209662508589d42f976037957c56a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b446e16977c86ab81628517839411386820aa17e409f59ae6f1ba3726a6d455(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a13a8e5221e9b719c38c4a29f0a27c117d61237678d0b8e7e6e7ff8503b894(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ffb0a7896b18362e8a1f5b103af6b622de550bc7539f23d2d59364cc09d079(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fbb3b4668775c8c2098946ef2b91a237fb983e769efafec97a0dc6d45e692f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71197d26fc7b0a1f54b5eede1944a37dea19f545a47c0e4c5d61afeca924e7d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c565e1d8804dcd19ee26d71343f344a38b070cfa91a7b5fd96a8041d22950f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b18efd51c3df88910dda86ea4a086ddd9477f6c29ed52c03c75ba3e626a5e74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333c5c2f4ceb6ba0e9ee3fcf5ec72ab38fe17839dedffd8b8b65d8f37706d123(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8f8899cdf253f8cbab53c777fbf8d7e70ee236b16553f1e5c034a487b24904(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659c2c85a8af3c5b49aa6b09f364abf59330d521015472a4a2ba2d8f730c97b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b67bbd880cbf0809be0871dc436ef6e5b7c15f55da56cabe8bd5eef3db7ee1a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b765793992a63cb58ee10b4c5098a62b76a79f3be4b381af4aabfd8f877197c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192f3a75b5a7b3b48734ef70b16bbe70bc1ec886849b4c07f1cb71fe33fca523(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84f952e3ac530a688a98f0a07f27d9a8e0f9a5f77de3841e90e368ca99d2327(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd80f5dd6d1fc276b3f85682813a47df8d1d32c8ba58fbe6ff5dd1b6b4228514(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2044cea3ed383c4959374c32af91bab071cc188c99f041e4bfb1583a45ecf37f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69d8ea7d5e4173f668432a887865f8dd2db19c23acd88320f494b6a3c93804c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fedbd798a9ecca629660467662b7bfe71168115360008daadf33b0f3dce2dc9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017301af56ad452bbc32c7feaca8545ef7b1a8fe923d5e7af976ba98aede4441(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ebc7f5b92c09fd70be50f645020125eaeb7150cc21bd3f4c90d167096c8145(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9890869e137c7037fe0006b87845eda94390b4889e92f3c934dc30ac8322d33a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ce9e196a7dcb751d8cd4d3d971f36d9e618be2c13fca702a2f88db35146780(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b1c34bbfe24d8ed82d7539d88c3dc505fff14fcad522cffe71357c32557543(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ad5c5d39785ba283239ccbf4a06ea2281c745feb8bfaf3ea3d3c3f58634537(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c196b1b03423c63fa656293df57f2d78d1003c9213c0d0d19c1a3d94705765a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2bd8a985395b6face41fa884d28b4e83b22401c443e3be9b797e5c80e46472(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3245d2bcd5808ac0b4c4b341e777e6f3949b3163ed2fbde8e2e3dc96092c60(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d4ff61553dcbef243de8507b5d57b43f6203786acff26fd7d38d7f4de2fd65(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9a4f47dffeae143a279329360335bf6f04dc673e4a7c88bd267a7e36203e2f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac253050f5f9a6d336dc8013f2e10917c057cf8a4d5e87657dd074c7275b1c27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dce8d697687e393004f12451d8d7b5f33152651556179f487f09107287fa642(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2645b7056ca92b8cff5e3b5f2c99cddac797f2c19cb2eba1cf6a1b740e391ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3669f82812485ab56a81c6e3d91aad76f6b86d4a191b3f6819000b5e915e49e7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0317a11a97ff293242de88363885ef3d63970d4a8307981980fd63e00099507(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0701a4cd6c1903f95222c97c934182da2c5a4705072305feec569b6217343aed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5c984c73ace35e8a01b8b925048e6fe1b766ab304dc50561e055c1446e13c9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c1985376727a98d0cd763fcf88732a063d578c16651713c8a7c269857e1d9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d7e3accae0f60c00b38bf876325d89ee20ce403280e6f398fdc1fc2a9bdb4f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a13f60ec985fa5dc7cef2b8bdc2b36f016c1115655f3774ebc18a75f035f833(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949940a79391ead5f08629deafb3530c76168dcfb140cf72b671c6b3d7675a9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1e5e36be54f9cad51e3819abcf166ebd794d18b17a231c3f67a402a71a0981(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb931501b6b40dd7c4269d1a0b1da14069337270d90c108a6de28131bef642d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a56b0ac22a996c90efd510963c49166a8b53290ff452f22f2915336eb5ae762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__324fba164969d2dbf2fff962b28f00ee0b60576f96288029ab0c5c00f503a36b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d94c0ba5d3568aa33eabf6e2313b5b54afdc620dc8141e06489dd0c022a0930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d976d2d4ead70654f8c4f178e69f59d862809218a1f62e21c7cca123c9767d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ede2d2556b423fbbba480e6d41fc78428cfc382e93533e1b998cd7b83c9b51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347ca6801eca6f09a67baf5a9f2542a93cc8f191679efd2dfd1ef4982531c3f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c523fa9c784d49263c817085b1988e907234bac8451781b2dd5122608d66c97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348b7740a17c104d11d818b411755f5714ca4f1f4db7b9488216f93168bcfab6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214a1f55451edd88a96adaa2101163e7ffa11c7e57b227385cf7455c2962d7c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b74d811fc88458f4a717001a15e29a436f9ed5d0d9c1d0d508fd2f93b61c69(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acad3b342f7e5d0e268ba2738cd23cc1d3341ea354524d4037932a8bfa74bd46(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60c0b28d25536148c1837d0e7c670899eb50378ec0464c54b5e40f4c353ac2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c645149cef70851ba4fd0e0b089d48d130aeefea22da4b5cd0ca93f2e85e11(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8496cf7159287e1bec12e815a0bf54ce2f4a6b7477c035bbf64b64b377e77d36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019c48034c5d4c6025a0c53425d5ae2906426fd64b1e5949bdc564a6931b7556(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062138285967ff38e202baa2e0344c48f365aa7f7f0f3eb936c808ed523ea2f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba2e15d1b8fa9663c22898f7cbd7f88493a546900643a5293636d58adf405bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255767ccb8cc37c2a4ad66d1c073d5c92d10efb501e3ca865e071485304c6910(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e7cb17336fa6cdca5e9290388f099538fe7119821549ece26d2a5d4578cc0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7634e6c79a27d6d06014415f98dcec0374ff8e2272b68d55b40581cb0365139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102d6be5b9bc061d994f52cabca5e8a89c846209b059f9bc456423d8fc5eb046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9af2ef11da1db17278cd18762d1d630908ddb616c86ef64023bddc3e565bcf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd45d1750008aa4fa5f852617b6adbfe7f7a9ab5f51dac2d82726ae423e8050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8430c98b18ca4c3789a41355a12fd96170425efa1b6ea7fe4584780dae8b2228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3321509a870dfafba69c030730912ba3d3335e2b8c25750dffad8e50163ca78f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40a88302e89f325f575f5382f85f1a76aeb8d25ecaff7f6e590392316b32d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9903304ca91347ac0ef73a40e351722e8c99e9460d8e2c74d80932cba0cc6882(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be94b57f4c774af08b9c137e35e9a16867239c6b5f2bbd36b079db1ce0a53c5c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddb2fcd607fcc88dc99103e9be8284f931cf8492e7bcd8c47ee562d4e267d1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad7d20d180f631538d0f201be47cfde1cf7496a551e832161003d82f03848fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb63a8d3743499efabaeebb9b8e5854f648bf6f67a084522a79d8daecc6ebb2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10bfa0c4e4a5859e374c3f576760c300df0a2b1003b9b59d1495db9ce7477bef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800ad0e5d9c975b40e65b40770e3b12846431bec27a5326d2ace1a32528c4d7e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101c6f36361de14c1f0b086a190567d5f0d8265e9cef0545972e1dacada9ea55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff98292b5986a6c258a81bf6cb3e9b3b6202f0aba60fc7d69bc3f82a90234100(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc12590e84c96962741d7a841c0945ff6d8ed5b2d1262b54cd86d3c85265cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fcc3b09669bfb70a5a0a8186c2aedcc71d32f0dcfd9163a34aea0e9eaa0cb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66000410e79c85460e04e2763de3444bb4201b255a6cf69d74a20276b924626a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108d819a743fe64eeec41217df44ff06017719788f128fec0c8be4472c620aae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bde779f0a951902932355dacbba51f1004949e8dee43feebed672af6c030dff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1b967403e731e69305fd2fff74f62471d345718fefee4aeeeedaebdd9a629b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cbdb369baac5b46fcc657cf1cf6b8a6a6d1ee2040d7daaa53b4c7e384f78038(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd01d98fe02a1d97f8c831439e4fae1855aabdf15856a04a0b9bbb09b01741a(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d960ee8bafe713ddcc55b8731d8b5549edb72f0f59cac82dde92464b804d93a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f1b791a2b3cebc84c6b1080e69deeaef8b8746336b69ff48bda3dd8b972b5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db6e2eadfb4ae8077a6134928299d06ed3bf3eadc2681a7d28bb21fe97f3692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b4cc14c294ec29ebb2ed3ef58f6f6e8190ccdce10ccde49e71769ba81208bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9ed38b8b580ee3f4d5ac0891da219e61aa7959ebc30ea3488f2081abae9cb5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4602ab9fbc19b8937c15f0300ae86a50afa85126bde848617804ba8908e063d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd204fcef96aa599fde4a411909cfbfb78ed7d34d078949c882b59af306c3c0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c17bc3a1b392a49d5a2bf03805dca56e00bb1d74fb848b3394584383cc2386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c005f90c4ea03035c068344dab2e761245d763f6cb5deba7caada8fa79d944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a1bee5cd84d5f93483b71fffa70cbe08b4315200f0ad6dff5207c63eed2522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f36059aebe1d592d869553fe4ac60fb394d7d4132a191fbd5d2ceb829e8bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__badde2deb316d1c53fee3110425cb6182399714f0eae6ac47d4a800f6309643b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4965ac3e31218d857a99071964506db37efc1e4bac4fae3f7f288ef29899c858(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6687ab3e01c0beb1b554274c3b3a4fc33491b7f4d4cacef6734a570795dd64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79acbba57a2cef807039b640c738a4612a680f3034b51fe08861b5d59c7f919c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247ba5bd56b2976840ba622929ba388f28ceb28c9cac234637e7ce443530878f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e819d68c3cfc64248f0b328713c3433e1ec17145e70edd61bfdcc94aac02f787(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4337d1840d6600cffbc1c35cad497cf6a8205fbb3702f3154eeac944da8a4a21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6e33bcd2b49fcbf3ea15619b8923e94b2cb324b59a1d35a6e0ac7175fc1623(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a78f9bff7e2603bb21190b4a500af19861b9af1c34524f4291e42d33577315b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2cf1a52c41d884eb1105e01fe37aaa0305aa9a80d17d10bed4591b7d2dc459(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741708271ad28af9978aed807438901461505af761fc5d34e0b13230fa5ed8e4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2415556734efe8201be83d1b2de0882b03427553daffd32d06e165521c24aad9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82bcf738e1b3ed0655f6f4c1631575ff455c8ae2c2d0e06e85bf2bcf08e3f8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db28b4f17f17ea4c7166461e561926521df47ce78e8b2630fbd4dea3e483893a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b61b3787e8a53ac153064a6aaa14dabf59e00b87ae7f4d1aec1a5e73a930ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca7be71b85a58a29022be9e1d23f30fc799bcce7b656ad2a9a086a2f115b2664(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8358470e97e40ea66957495d0a4928987ed8b64040b88010eebceffd640f8a4(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5302f2c2fae51249b70f8de7ee3c87b68fdbd87457f8dfcbdfc45aa7c6e5b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af41f17edbc37cc0b6a1821c522880ea368d6c1f672083e99f60ea3dff8eefbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f70941a4aa2dc9cbdb9b2f00660736b89edb6820e17c37799efc1bd369eac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b3ca836b282765a20285b416cb2a34f7620f58e2ad8ba23a4039e76db2c15b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9364fc542d059349545bdf3504507c2663294e3c37bec537fa301e31baca7e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f27f4c047c318fc0d466d9c1124f2d884516ca5b706079db47ada2bdcac259(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a3b09df8ea54de89a0db5d0f1f1d3f2db8d6a42066d74ddcfc514ebb375e01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83eda73619778ff0fdab3593f29ee9408571d2a8a7e0975dc0f43ec181b0f0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce5d5131789528004911311ca997c5a79bc55640dd75777bf1d361195900c05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb183fefc0fe9c79a1650910220c4660f17b5ad354ca88e98bfd74edba8e9f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b120dfaf83448d33aa3206239cefa761914f7dc96728796a564fe8a88f5e16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb5e6e0f006ed2e93c04094d7065a213092e70b288afe495f7938ca9a5e6c95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a9f667a5fdcd2901dde60bf83ab155b33ef2850f715a3e15ad7f5681b0a9dc(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a13a67817d06350ac06a173ed051b9af532b051f04fea945cedd1b389f0a4b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9600b97d090dfd472fab0530a63be33d1d155af0fa7b5dd673d49de4a1c294b9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eed0c7e704f446604e99916e9be5082ae768d89a91da1725aeac63f76330682(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131bd9b46c9c8f7e591b1448f7fd4dcd7b1f89193abec80d00320fa4b14d61b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9d067b1e3965559985ae782cc7f704a18da0a91e4876db70425f1c125c3d0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54a6bbb03b8c351b729a900a8892a846a65571fa22d27aa11d1bfc8010b6fee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa11773879740a8c73ec93e7d9a3c1ab0a5bdaf3b01f42eceba4b11b4b98daa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c2e9f72fccdb73f27687d7429ad7aa1b8c472467696dfad3b6fdf4cacea9a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8c388479fb6c9cbd119144dc631932c3a9532f2208d10fc8a4873df3f5c306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b8efb46499440fef080e85029afcdc8c206106a1f387bc909d6ebe76c9712f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c6a6fef7cc794be3ee1fce6a0c1904e54b1a25f14b43d240b2cf8bb6791ecc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19fd800a84899284f65c7c788d1e442e6dbc81cf0f7ed79c5023a1bd5ae5eef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d417b20ce75e94d695469ae8cbfc194dcb9c488f541a0247d76781600f1075b(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2d1e97d445d074eecdcb259a526f52dd4351ed2426f8a8befd2deb2e077703(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4b2f45d85149bab9ca6efc91ed92adce0612c0be504d5e683a785749e0b8d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c4700d25fabeb9280f13ad8e7e071ebfaf38853ca2c974a467cd188b23f4f8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b86627aeae6c1e96717db9af421bff54734ee61dce725ea430b15af5cd98b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fbbbd7edc69f55627cb7f5960ab0f09bb57bbb6d936ddc7dc65ef01a59b0987(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9690be42f59b313438d1ab1e0fb4309962202de685ca5d7495b36c0d94b719(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0618a106cd99f17e2e2055c865391ef85182346a213c55346f20247f73f3c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f60e59c1de4ec63ecafad1b19ee8d99bdba762292b07c2ced0772b5d4ffec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd1d0d0f050d5dc36abb00350bac7f64f2259ec9705d379c950860f836b6dd42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3431f848ab55e5662bbc79f7a1db5514b2e217970be07a2a4334d1b5a47becc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee92f117850f7028ee104f3c49290204d3804961775d103a06427af6c00ade3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077e44ee2024416728ee2e81c49bac855632d8d71480878418bfdb381c23d737(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d47ee71e745cb249f99be3cea28b3ff5f0667ccd4a8315c4fcbeb8ff8f68be4b(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ccf75116573735dccbdb50b5aef9f601d4e5878980402ef72d1beafdf3f0f48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a41395d0753cc907c699062fc2b9494f03a941af49c5f88c5eb50979dcca51(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68993fc182e7ec5bbff8e4ed2894750fd0124b14b867d7c0570ef4040a29e32c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3971259e0bbb0c7e230506385108b70e85358186d1eb6f9749e4a7f0b2beb35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2594b75f7204ba59d809c947234f817b42110d4d9727db48cf60bb6342516007(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__020a4f4389047c9152d203dd6472d910bfe552fa0ab010b6bb5247ea8f1598fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09cc9554883865cee99b0013fc0835e5809b3fcf6e2d706a1be2dfb607b83a1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ac987932977833b735d317f506b3e4aac6e8cf21c7858f5ef4c1a2a6730637(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce037ff7858dbea38212c874697e915b3cf7fa89bd4b992208c62ede2e878c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd05039c799042e080588ddf7975c8ac2861975fcc5eadbe08b8bd925031d4b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332eeeebdcba1dc8384cbea7c4e821e4c472d81b064acc784863844da695a96a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead5471a6fb1c1bb6e51f10d973959eb188dd953199fd74fcce60dc827d273cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8abeaae2c3f450b6b41620a414a2bdeb53ea63f283e728aaa78657e2958a5f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d45c642c5430ad6cff0329046344be53b6cd0f7d5f9030654d6da7b99e8e40a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f91d790b78a9938ad792ba7bc4d8d18e3cfa92f366e1ab4a50669db603f24b(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421fc0e00f0f96fba5c06293658314b8da342a32239cb82752d9586b11877a3b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2179cd03550a384ab0589707dad1588b88e35ec13a9c2dd423cb1d67e7db63e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cea033f22c14e069e59fcf1e89166b3a23b66e166102056da6c8072d9aedd1f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b1f329502b854db4fd156ebc2f701445e428ff27d30c229babf83aacf3a665(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8710829de35447f1698eaba1104259859c069deb8d6769965dcd77a2a59bd73c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03af0330f9c1d6e969e1ce0de1d13d86dc52e51ec8115dc4fb48c0d83766939d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb93459114e3ef138af218fcdd1e1f43da1a0c41a293e6ed73fccc61f7071f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1748c1d310a5332108f0215ae15bc925034ed44413031c24da17c421a64b13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c627e02d35b3509db8e2824d3e09f9ea5ad38766c096ad7a820513e3f87be0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22d04119da61feeb8cc57035464ef8522019714957e58f507933b65cb726cce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2d2427e03a6b28333148b2ffaa4411edb5a6fd42635d2b3f01a55f63bb13c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df1c4bf0c28204f8121ca2894d7b1fea71c92398aea9ad67bce7367927cde58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bbf6e7eb310e374383678cf9a8fe3ec146ec97b1258a258b8429c28cda124b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a37d4b2e20c2810def8b4f26c2b71a671b90eb9e0325d6f97cf4159b5f926a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8207db6b1dd3ec330b44da8e0258628e03afe2f8d06de130c08c9c5432ce3de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768113e539a83066ec54c4f076c75e79a6823b43b8ff560b1eafa8f51838844d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd397f9bea773ec72dc419a57933c36a6bf6541be33dbb19de3b276719dd048(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c102de7c560badb466050df9249ae8af01c3c3430a32ab4922867b5f32d875(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515166ad7c47abc634fe1c2674328b5c2c1e6c98eec40622a04db067cf90a699(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27124a6f9d75ea935622111362438f4199f3c16d020b6fd73b9a0a4fbc1d5d5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c9d08e4fab54ed945ef2f48dc53a9043701248d330301fd3476d70f737de4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c2ab972d8f52f02e80b3f8439abcf4e3afbdbfee675766d8081f60ade3e465(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987437193c08895f401881466d59c06a02268feb8719771d3422bb8b7d864d48(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba74ce87712f9cd80594cc3d9a9473232ddd241f1162bc0d091c1eba67979e4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1d66eaf3995d36cb4d5a3e3e3bcb95910d3fe5d31b04478143d50d61b676d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead2be744ffdb09462ed930cc751297d8cb41460d9afedf23baf4cbd6c0359f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e649d0426dc9f2322cfc3bd4368407fcb128ec34a6838c6edcebd6d3d31472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6949f5014e546a0edd52f83d69a78912ef1bdcabb7774a01d87f5e4504bae651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ca1ed4fbd429caea5898ff3cf8a9ab2fa191a1a19b1380b4a599dfb39e833b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28744fbf1bef8058d7aa7abb451a9fc963de88ff95926c17f1490ee3b7fb2734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f4ad22e80d8ee5e7a90ce3f60ae216dcacb37f476bf2825d19bb75220ffe09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98cd17df027e9d2fe84154ba822c446c5f89bc8df3e7d6cbd99cef7f258dcd72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0161d5e44ff3c7e870f43f082097495ab420ddd67a36d849f745cce3ed2bc82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b334dce5cac7e5e7f08dd4c30d28716e0e977aeed9c248f5c8359586c50b882(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023124732951fca602631bb0aef6666c0e1e390757ee9f2d917135426ca76d3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c4c381723a7a0b22217e3bf4336bf4d19ee4544e00129453cacd77fb3949f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4c172db1eb57861600c5fe6892eca8284d32e51eb52b7b280418fc2dd9047e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113a80aca18b3a264bb31590d6cf7531e180d23477ad467b081198297c7ba28d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2172d99aec54d7a009880be45f7d872c21a89b1164d0f28b85f4c0df25c5b0a4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d20278a5b4d4e4d47570eae4a146140264ba79bdf9ce0b68e58be4a88a96ed3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b1e7fe454bed803b2516fdfdb753a6a9112c3118af50c1d0fd3f3391131902(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba4afbe50aa2ac63a63f46ca624b18f21d411dd023025b82677ffaffd05f907(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cec40b465d990ba03fa19a93c40b40d511e40915ea7a792aa2f10002623aec6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__875bf651526417a4ab96b6e60c223b782bc10a7814d50a8d2d75b8575611cbe5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4101e9f41131dfe0851e93579a53e7939fdff212295f3afdce3e6b43b6962a79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead22fb8ac031e3bf36a98bac8588e284c49234780b173575db268d679cc6a70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab1fe6f2bc99311d0bb855acd5ef7f158e23fccd90d24214b2a61f3c4c4f3d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73559cd1c830f3254ff912f77cdfa88eb732a59f89cdbbd5058ff47047f2d47(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63582afbb8b7a979afed724e0457fd0e722590db6baee10e87aa1d46835fd6be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7876889f863b0cac784c938df474bda404ac1218e2b6071f76ea5f4df0f04221(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0851abeab8236e04c3d4c7e1a3be3b794d1a57c9ac29ab09d61aa5b939be6b04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332523cd94758de32cdeb20847fb9304fa5bd48ade061271a8953d6d67a22ca6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c977dcf35d51060b9d5289279b00b1e24c0515ef899b80dabcab0662152dc50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27516726244a96b931a8598e96c5140b55b81c4484fa17626725b8ae2683d497(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd700a30fc82243c41b9d073b4dea6490f5a808f7ebdb18490a3831ed1558dfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845a1c2dfe5d6ffa77515e57b59a4eb59c6be5a28272b4a991d351b6aaac59b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ec6f09ed99a6bd482cacc2e3f7e8715aff72252e6077fb20c3d170a08a1203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a883782eed253ac4570c2f1c1fb4ee1e4def6652fe54956df425b03400fa080d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca45c3f16f305c4267c7561ad545772d67e80aae83e5fc0a0d73e88c9c7dd8e8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4f6f73ae92ecad9c1b5861c87449a95da26c0f9b240369c00ffbdc1688f793(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6440434a956cbd0a69b70699088ff09caa693ccb5e7dbe9b8a8d4dac42159329(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac076d48fa8362788991b915bdd593a268e2f942ee66e78d27de94848a4035a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50bd42863aa1062b3bfbef80fb1dcd0c7860f61934963909f36b210b8e763aeb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba65f4059cd4ae3659eab5613995bb2d26fc6cd35f796df20a6149c92bcfaeec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23553e7f5e0c18e4117208241644d039f825fb8b7f92d804c5a64403882dd65f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40e5eb1886995c007a3d34b0c797dba38ce4c98b9a71059168cd998a6399c82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3557f97f9a24cbde628f1b10aa6ab5cdea78964fedac9b06bea8e1422a5182c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a48af198220116329ac97d69dc74a25a59e3fab95c7eb92996cc4a157144a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64cb926afa9c9f02c3be72c41ee0a9351cd54906046f23f945a4f4cac7b2ee0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68969668d06c6025305341f7e7a30d8f6bd04aa886c671e746c080fc7d7ffe7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9078151307e3ea841a6e1879f35a00a9d17b2304a124fdf84f5d619f9b5d1a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc3447287bfb57f0a17075f6d42cf9ed79c3eadbb049de23d3108c3e71147d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a8592108ed0e000e016c447af96571f80f571130bfe19591a26972441c6adb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1597c0a7d2dc0b800967241f56759ed25211cf640ea57d2bb11122d0da6fe42f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a78c7ec973d1800edd7d727ddc0b1a342f02a1259a67946727a3d383b0b58890(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa0a05d456fc8bf4d96b1f4cde86664ba3d5933727710af75b0170e9fa948ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a63c9a27d04acd31d7d2f75c938c6244b52e3fe6a69b7d2e0f79ae117e0e56b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb634d557be1f9fd88f8ce597cd0dae903b83695d9a98a0b590f6aaf2d232284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba63bd98f6c355eb26d607d3c3f1380f12d5b7db8782bfe3b2927ab79b7c550(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce6afbcdcb59dfc705ffc582a8a10195bde1022d8988fab1fa67574e8363d5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__119e8912ffb7c163f69caf540e735e0ad8fe645b2cb52240eb7ba6236866038b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19336eb70a2ad43cbbbceb97c4d679c30e806d51c6a3959fa71783572d118997(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c26c00d8f9fad4230a663a3d7f58cc73343fe238b546d9c281c7f04d207d892c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8f3a97918b657048c31d2a176b7d51566cef3073049bef4f193df437c03e4d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84755dc4339504d39773ebbba43f6f89ba296ad2def95960b2cb82349afc1ccc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110de76179e10a95c3d964b7648519a55f9d30d92e657687184f5254fe07b493(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039a29eb25a79fe6a872f4791ccfdc60cda86a7c18377ece81eb24a8a5b825e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5144d22c726fdab51b4ce8053ead37fdbe9a391cd689f9dd3e2dc76a1e1619(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ee5dc6c2808bf809ed44f52f2c5bca0d817029fe70bcdaafd3357b08ca31d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607bdd6975f4ddd5be3dc7d2c7dbdb84eaab7e2b57f5663a234ef6a15d365c82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1845a4bda9b317e81096b3f26feaed819cf4beb0eb013a5e770dea5b190b759(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64627cb9037477dec5c871f5f200f87cee58f3b8df174152d032b3c9492a9a51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5158565c8d200ecb8d4710c1473ba755f9b15a62ba0f430b719338edfe3b610b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7aa6d7f22fdb9d928ceb91431dbd63fbaf3c13ebec119f5be752be5c2ffe3d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c7e415af94fba941968b417cbde22ba4163f9b67b8208dc611a1ee58218e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb297f125beccf7387eb0e6370b317290bdf9b83df743ccde82a9c0e5e8ef21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8ee043406a9d045f3f4cc87ad8d8808f885d0d7f540905fc2c93a01d8bedef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72eb0a5e6df826ed0f1a8f37ba2fe8ac7e342ca7f0ca000ea7d69688b888c6f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fef08df87ae1a56ce793efd9470e842e128bbc939c8e68dfcc3ac482509b4a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0fc8ae78490bfcfc1f98fa88686f1e8b272bd61511b715aa4f5fbf924c1532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c44777256307e16033535b4f72850f914713aeca5bb49ce8d748edce8973cfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76773450c5612feca18c7b71c5d73c9c154f60cb14d20e848a110b3f9993b86b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472e6f7046d42c614ce249fcdcf0b8268f58b227f75f119b3d0ffe2f60cea167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86010e9d865dc2746bdb95a1c2776967cc2640af40a3ee1b5b23d9e1623684d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2d0073f4b23844e1c4ea7536dcce5b93cedee9f0ef32730c34550976ad7d4d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbd2937c616ec0dee9cdfc483f0c2268384cbeda987e5702c8feac3a3d173bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ae4c704443bd26273c88aff0e696a797aa90a2a825fe6dd320dfe28d2c7acb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa5a5c4339d64cfb88780e7e60c0ec876f0b5a0ab6401723cb2cf955e12a7cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c769567ff2b05b88b3a2784336b1cf620e5b3e06ef3b34b5575c7b09d9e8dcc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f825b4f56fdd849c9899120284cf85de8e105fe7ffdee1ba41f8b2aa2ba7b0bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa454719dd057a0b2a35b5a9258b59af12e92113073e7c07133524b2b41603f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c839d25f7a02dfa2b3daf420d6596533b3b5ae7e40b10081d7463a7a957595(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__231d7ef38f52d4c21edbb0e3d80d40839a8bde67321b5ead066a99f0ca14cb69(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336216b7e3c38822f7dcb8b775b1327cb7a2556dd87a1766bfdce25dc6f19db5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3c3a36ff64fe1bfb301645da4371557d74b4b7ec756ccd283f40df1ed16bae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71497abdee9bed09224684dbb9cbdd5dd2ec5d97c262876817d0398053bfb514(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd5c26e30e032bfd6b9b95b868171a7f2b6b44db54c62a5b888e4cb0bdbe1fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4561b2ac916126a21375bacbb5bf161c72a2279d74024054e496c3942bc1056c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5fd8cb6fb369de3a2c1f78b0df4fa94829af977ac2bf41f5fe2875a55666bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fece84d7ee2286ac2956186bbc5f54c432cde39f1128c70355de35fe9af29499(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1cac0e3a3ccce95a1e4542d905e8cc9beaba9a789691157136972a69e4edcdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115afe171c2de01168003a1871f04df54ad6e032e56b0a0f7304a48f25910f50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9437db7237b5406bec0d2cd33b1fbcb3dfff7a84f3b7c5caeba8c7f9a454aabc(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6881b081abef48e14db8ddfaf8f70113c1ef7351725a7b142fbdc2ef4bcbe49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450f3bf492b644d9c8b8e6f0b1ce9d4a1e232007b0375d0549b0e7a9d8344e4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd906684a5fe5f69c2e7d2ef99feb27fea9d7743ecd241dd44202e64663bcb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e9de702af0ea09d89cbfe5c8f06912545f13e75ba8ea6d4575b3fd448ce99e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a220da33105692bbf2540cc29b6eac9902afd995e7b5a93b5b5532205d87e3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f73fe37b31f8e794c53b7cac289ada4487bcf940a5b02eabba51ce04695fc8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b33c1ab90d4cebd5ae136c8f84b7ebbcaffc9e363febe20b291bc2eb158dde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87807764f7fa68fb8f6f8eecd640c5e1f7fa7c0ed6254661c2de1e1cc8fac1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0e4e51e2534675a081771bbbe1e3c9987046294107b6a4f54330269857fc1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f504c944b60623db6a32d1d39e72e6c081a38e11e9dffd8bc9028e120188fb31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc98655373aab540893af7fb7778ab71aa83dc86f6def1380f654f3dd688480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c6e399c33ca79e78bd6e42e3dbe617bd91b830a9e9fd9072a735cc327ee6b37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143484a2dab280c78bf7779b5caadc607bc7cf46fcf8566a8316a3d3067f244b(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15714fc6879864fbd976d51119a18f71f2b1ca17641df37622b8081b2f74775(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec74872c670e68c4b49308e7babaca15adf29568d1fa7036e16a95a13d809c3b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3269eabcbadebc3eff96a3955f301d1d191d8650a3502e4548e3f2905ee4f4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66e4493ec783a3add27aa7adca07a402d87dffb5e4a53d44b25f0ebf8e664d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edec1f5cc6f66b84f2e85eab634d6b082358f842a0f9d24335a9c13bf87cccec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc4936ceda0e830f3abb418d1a4b1eb8f0d7ab9f9d7331575d8beb6ff500de7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0784445dcb7de63c2ff9af5b08099c0c818f35d7e46781600035697000ae50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd9fe72782ea7b814268e70ef3bd5044187e3c149bd553004b1d3ce30b40622(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1bcf6058bfacab8ca3e4c94da5f0f90b34633812f522002cc7decaa70a91f80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e9771419afbb4e638ab16e4577e41fb73fc0ed1ee715ea477f397a005c015b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e24e331502d64aeef5db38feed37d7ba36a045e25f8f471daed93f6dcc269f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4a925c413ff9c857c64ff0e6f255255a9547263dd0dfb0983793f054665d18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a954db8c1318010a8c0b1eda795f8b2723f82ca06a1ef9e47e237f0653ddd38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02cb7162d094fbefb5a80a940e5dc2637e6e60374accd6f514b8fbbb062663e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92de6b831316754012faf0cb858c8c1c099105ab3dd8b2d01e85426a2bf489d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4ad86bccbd614319da2b859c8110e54eb901256bce006db76c2138c6747e8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2433bf0ae60fdb93a3a50176a07526831b3437aeeee597cf8671f8dc0a65e0e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f79e638093a226d37b5787b5911f841219b4ae6b8927127d4e96b01a363545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694cceb406abd17cabbe267bcd7b37943cf8498527f75352c4ab370acc7b3b02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d52a912e08e3114ec09843ad086e56d1c831f16f96ec1e2c52841118171ed3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0897898a43e430867d4b62e816be28679a68c86897105511f0e1f9ff57b477(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0b82d46083dd3e27f92a167f72d3c2ad77fa1d4e763cbe36b574cb207bb930(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e058601f3640e27c6f01628d2a37359080819733531775f908f5a3981e7387df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969c2c45c1a7ed32b806c08cc2e037a9748710e4fa1064b6acd10e361e140f30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffd2636d3686dcf17093c58e1279e20f5626b9c2758e448ec9241b852b518d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3419b33e0d677133abdd457563ca3d0ff2f5b87df12dddb98bd7c0ba7ad06fcc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7cd6e426f4dd57c191aa901c8794139f70b0f2aed6ca631d0672779cf706ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e788961e3d65baa627859d028f82b136f95177cb3b2eee73795a22d57096cf0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a668059d392d06a3b379e172817e0ae0a15909c18918e6a733ea88f4b9ef8e15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7da89de49707a540cf5143ed7237908367a90b7450f47dc1530eab4f12aac4eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e0ec71f580441e96f923fbc4ebd8aca7b635e80d55ea03036b886ba5750b54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca3f72ac85a1c7bf6cb4b62c830f12d05c71b639fe1949ce1046408e90eaa31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3773e7453ef88c552a37523fb1c86465f35dfc2c9b7433518d56a0a71ed1254f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e5d86def3d8600fbb1c73123f67c03b8c442d43f346951610a3b38182d98da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791e1743e85fa43d55351930589ed93ff8828c350b944fd1c927671773767ed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c090fc4e053376ce1a6045cf5272ffc32843568995bd7a8bca94862a73102c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9294c6cca21c8e9368622db90b5034166415731d650ec60ceef7d08eab8c2f86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bd0974374323630a32e185bc707fcd1fc22833a5f4dbaf2d3390886e9bb1ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de47197628e379f5fd525a0810bfff21c9796c9c7af6147546cd3b1229fca11d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__018d5da3722c81d59d954e0f05517aba80c8e88014cd505aef700de3f754bb04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a52aa8f3be8c2d96609e5dd7a01e9cfb6afeef0729ccb5497734fe9bce9beb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__687cbbc25134066ca527fd39589319b68deb789cea9ec507cd3de4be17e83c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f433347b18920090a99694d3aba2e2fb7797227ca9075d570a7c163559140274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e88544e824531a080d175680bee3083c5b374a89bb300ccd308fbb089f233c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81242a317ebccd9d611b17d8e07fb21898aee947d2c417026b4b8945cc4dcba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287b20ec150751bb4abeaf8936628e298408c3e535ef1a90ba99262b7208c19d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d9d7d6b8023b49c8f3a07e3ca56b340cce8b80ca93ab65a34ca9da0cb9b02e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e64d2eac7b46e96231b0c41eb8d2d0ecd147becf9cbd584032f25f67666d42(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a141110860d29e850aee40305b94f7990bda80c445b9244727af02244f1e1e88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2bd194a05d53cb6f9c98cf81e33b20bc33f4f027440a8c440bce9976cb59117(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6390075f74b8823ec338353e48c49f3052643081181f8273d4086a5c6024c095(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28cfdf9ee0766591b6b798c5c947ec3a4d88b0ff2d73e0647970bcdf21badd58(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc44707daf1fb81b3335335b91e6a354506f36221cbc10c6d1c445bde7108d2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d284b51f3323b1056036d98dd0cc6d1e27437e697522e1c9806384a125b35685(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22c5cf2ca9b6fdb886fef9c01deca21770e377b5070c7a29ffe6826ce122aab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67d5eb9876d84d185a0e23cb3b295d4633e437d39d0ac417f23eef0aa2bd8e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc4122a6c1ee5f7a659fdad9bb14ec3ab8244156915504dc2844b4b9cbf3cfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6df78443de80145cde0aec33cd1db53e58763571c1848620e4e118d1446afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf4aabc26bef0c12154632de2498b081518c1b7215ac429e60313a38f88a517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e38c2a8c431645de74c3c0a8e717df5d09382e510219fd9aa0aee2d9b5db178(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3bc402c8b141e89f8539cefb9f9851e3eb4c637808328ebc9432eeb230d4de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26bd59940605874133c7e75ffb2e56f34403204a4715fba5b6f0fb87a613a71d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca5d4291e797075b54eee74dfbd50e5b5d4e3f0bab3a44871b03743272fa2f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d6948e9dd70e9ffba862236cccef55a686d38cb9eef3c21911f3ae53fe7d71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8cb503f8b53d1ff5e650114549129a95fd1785f0de73dedc411fdbf0f78424(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0351d10e8096dcb4713f70ff28bf36a69567332b1fd45a8cd536aec7fff6cd45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c3181e203816845109c1aaa2a1bbcd49d7f105eabadbde21a51611eec93623(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9453c6ef573619493017c5c6dd3ba4a5097338cebce3ec194e144f802ccf4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36bc9c54b483bc7927c3d1beff340c9d70f7dac3f3d322f0dabf74237dbc3524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217be86fc4159aee86f572cff58119cd0fdbdbcd70fb6ac063e7fab378d41240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f0f06c598b68f8e6d438fdba299691f2f24475de20f82100c8d78e21e8f7f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639a052d3b3ff97e39b3c1e267bad0649ec38c2b5c8de7d69f8efcc423821ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8725c03a52d191c13b48547c2b9750684afb2a4f4a106c543f26576d93a3ed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c271474f43c4eeb8f989c5a03a90a5829e7d4152abecaa8d025963ef81b17a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ea1811a2696ea92c488a415ed12c38fb3b9f3b0907d15eec0db301453aa438(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62847c5182860f42d5355eaaa35ea36c227dd745d4d015a01952cc2bceb3bc8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50412b5d167239adc7b4f65a7674a9b572f42df9e03d7f2064b393b8a8b993cc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b34d40e360bdc42f051f8663c0cd4251f12cf1fceaa7b6a65ecbe500ece37d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8f18e477eb7c28d1af3b42bf574d7235d2e7a74b879db5326e7627e370618a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc426f6688947d4a75eebd2a7d952b73ce7bc71527dc2ff5eab71fc3b2c10f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae9f0ba67e7a3efe556a52027ffefe349ba842da4e3d10dfed96839f9439a295(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1eb26af1eb462fecaee5c067f1f87f0dc4d74dfcff2033c4b1965d96876e5a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a59de5b352c9a67442f7708390a1d0eb515fffaf5e64c8206fccc22000b385(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a1930b818054584936f673324bd9f2beeb04a915c0ddd96283939cc00a260a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5ebba771abdb78bb425ffde6e621891f162f46ea8dd3f1bf5a3ab75a021d7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27af54cc61620ec7aa4041628a7c4914704d939f1cc94107de4328e5efe60514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d53a066b6c49350898cb02c1e439e5d75c6cfa07c60d3bb8634f220b11d31fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845f6ea251cab14d5860d75b58244d20db6d358890b279edc146bb921b1ff170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e70c23b255807cd1b3cbfe723fbbe97971c6b798055b0c09a11e5f4c6d9e0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f4258e8c56d31bcaecd162fc445df8beb367a90462cf3305774e6f3ffa834fc(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf680c2f8db592f377329f01380a06ea4280438e20bc8348bc530c246e4e0d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28e7ca6cf3f2d05d82c202ef8a1bb3372379d1f2508bdaca887443996a3c863(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad4944299141ecf54ea81aedc69058496da6431fbf19b58aa2da7b673c5aa475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5c5802cedc5839d0135ff3239e706cd255e27d8295d40f463306f52c6c3cdb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a772955589be29b64086192a9cf03ff34dc343beb9218e8f617dee9f1ebed6bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4745c11e327f018c6b593047ce1584a60e7bd1489f99e34797d15aa3fbfcdc14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51fa60ee70e106c4304aadb160984596796c8a95c237b094b7d19fdef4650d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdcebf9e5989bb0fbe6848a395de53a6921cda1253b7b75d3495a03bed38859b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ae2bd18653561d5b30c0bac659d337baa47d88489d407c9d138e3ad9c10f49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9591dd1abec9f1e60d37d31c057543a311c68f71f1fd0a1d5687c64f99e286(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35eba1f8f0f047de6da73bc4f9b3b2ed0806be0581ddabec7928a95634b44d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ad34033557868b951de2692eff59493b4f49c7926c4c670599974531fa8939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ee62bfb5539c0bd5469d876bd8c6357f2b1e80c019bd4095c1107a15898a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dff063310ab1ce598e300bd8ac06cb3f81beb5a58c9851895c315c7ac712f1e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a36868f1b24d5996c6a255a30f7da6b1b3fb7593990dae51b5ee9b8e4a6626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34b0f6e234503aad4b50a9fd9f819d114396ac9c9626dbb3590121eb45a7f2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a1d4a4dd7919a3d8504663625b1842b06b0a9ebabd33e6c217d92c898b0410(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0438a001a427fbddd91581b777aaa951308a7538cb846d3e299727516fe83fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcf06c3642e90d0cdf3809060ee93633e113594f6762caf2550920b4a6d1f14(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1f39f32d04f7457558d4403907c1f5536ff5b61f5bf517df3282f9962c7770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f76e56c1be8b18f9b78cc95a1020b0793692d558a37b2c7cd1045c6968e646(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5c027f545a9c5789b280e3e2a909da8866c1b9d295f068a58f6c974c737eaa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7b34b1319cd8ca110c456bbf45682d5c04a5dca01912c03260c7c93b7aca04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a9807f75f971f5d1cb79b28bd73dbc0f45dca066826f02710ca586429f6ad7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a447e99e633fef7f1feaadede96af60661bf4ef64b2e1b1dbd73d6d1bea81f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d0bd4f217d7a53b5ed4af0fdca3fe81a2f99547191ef2dff21b21e670a36a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddaa85b00b5f9213e8c28352452ecfda5ad2def7153871c73a3a5418b6d9d63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c299f2ea2383252edca965acac6df54830587c69b103caf329150797eaaa0e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118bd444505c8db08cd3bd7b916e6600a1d4349901e8f6f20220e66d110e56b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7857553a488780898b973b59c2c0aa478679227ff4deabfefb0701fc3f10ed1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f70bcf9465e4f59a33bb82bfb240340a9dd8583fedb0bd3b54e39c07e33683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f96c2f32a05d1cec7a1831089e2cc4b7a8e2babac18d33cfb0bb40c8cfdcb53(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326edf1603e2e8940ecee72da140b85563aa02c2b0fef151b8a69cb12492f616(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd85530c4d4abbe1920370762b17e1bd75f8974f83ff2ce6fb74babc704327b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1364ec796ee600d5da9fc37575e9c360dbee09efa178816a96b77641cf2d182(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a74ab62e42b08792038eed4efce9eaec2ebdd16f056d1639c7f96c160bbf19b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2326cec0c473e9652cf027137805e8030c2d17dc2f8a173ca160c6432e9c00a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebbf3995f20fffccf71210487da5fcc67afb5ce075b1dd62ef46c924e2f180c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039403b43ecf27165b0f012ecf62e761e1ce9057b55e8d6c3639b1fa81bdbe3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1677c87fd240905904c92669fcca32d5310322ae9f220577dbe93083507ddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd02dd555008dcb03f67a4c3e06b46c664eeed413d3ffe00d5ce657fbb8f772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a46f0514aea901434f3f70f238f1d325ad64f5083027f5f30ff31e37b8ace3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c75d491d87bf89e8626e8366dae2ef99e5e497508740a6a59fdd79eadbbe0b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b03999dc49f01e1d4c6161f54e292c87063276e0f70f54427a1671a7ccc220(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6488e8d7c83bcb6a31a0f025abb3b26487f6b47e90933e70646eab7b2f00d982(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f46dce10c14008483a7348bd624636e3b89468a0ee32dde307c5882d83213867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__637a2d738928d84bb8ed230c615dc306e0d85ee2aff34f2c13669639e488aef7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360a9382163666b120cba3b8a90c0f0b2884cf7b63d3f2313f81ae7ea3633586(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02c13a824dc20ff69d52c386e3cb58ea9e85c5ee9ba4e8676f49d2b5411b02c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c736b306377212acd720b57670b07471e69b52b8c41142d3b02efbfaede08194(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cc0d5a2f4fd53d053ec813ad26383ba94cec36f4ef0badb8bd0913d7acc671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda8433a00b3d8259ddf157a0950b18f33fef32841dcedec94fec79895480da9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd7ffa7a7923495421fe0182844585d7c2375fd942aed1354b305adb901d76e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae26fdd6f41de2255fc4f9948017b7b1918077c7d7b8ac056848da64ef8e4f7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1f1bc308cb66ed14b6944a77760404401f39b38be597f0bd446fa1c05dadf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e887fd927c386f87322ec0ccb5c15372681bc3918fbbfe85d43a04a68696d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c96d90d79e80f28348edd81757832bcf9e40545ee2f56e35f3aa3a66c75da2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e97c15d756c9dc1f9a719d397ba4ba5271671430d5e218f8d8d466029a21e2(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4132236ec8021ae075e81bd53588d31a381af873b1b47a33f28715a2082842(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f89cff60e7b3135a301973c4ec20f09930632122b3c579f5a85de66b8ca465(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d31191453e73659ad5c9165a44be5a6bf07c27b9b226ab70f205fcbfc0f6082(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91328589e64f5d6fe5c1a8a5c194c6a3b23bee2e610579774a67c88d75edba63(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc875728300c289188023888da01aaa819059bcd92c736c1b07e59692164fce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bddad28fe4bfe0862795d46602dca16032b71ab1df8cfa6bb8a3babc3cfee3c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92a64b79a2029c6771fdd24bb9b6d98866513e6090d79264652d9f0e5377584(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821e9778883a2ca3424383461bf6725513cfeb095a9a26babfaa380653964b18(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20747d3e84149c7ecb16788d694554288c51908d24db4284b865a1216a49f7d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48e13710f5bdc9249952da1c8c84f53a36508a95470a6689728eb6ec86182d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981409a6d0e2fdbd229eb321a9d22865d8da26579f7003948a5bba81fc20875c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6375792d98a976907b9edfe2cdb43a77e460a68618cbde449a01b24293e14902(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ee67d1ac928ba9b654d060f953568f59446a2bb50705cb3ae62046428bc153(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed73bd60938bb9517e2aa986de89cde1047bb60312fb6f5c46d86e84b98830d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dac666dd083ea610e8e1179ad01369de9a8ac0712f345f1a67dd1ed418c431e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__316b15922ed1645ae6ccdd8b9c70403896aa8484b991ae2e80c589703ba6a779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57d74a8b89b948666f60df8ac1f5a4a3da072ce9febdc83fa7883fea75c34d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec189757796e35469fc6cb470b3772dac6cc1730d5dd81ead1879dee52bc9ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3831b5b48902411bd45aaee21a8151dde272f0ebbba7ab39b8486af3236736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1882e16e60c417f036f5a37d3a3fd5d1abf55666ddf9e08d19c5eb4bec5d8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02685605acc891e8cb2f56e2a3f0aceafa2fc168b0c56c2034ea3298b7ac66d0(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1a2d7a14b9de076f73a218b4a3ec92ce6445f077c2774b38612509f97ab2a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716db8737b0dfb196d224d06b53a59ce35abede667968a8e7e7ffe2333108617(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b4fd3da5c71afb72c6399cda3c6cb9868d16d5658371abd51ab3556018ce0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc3f4245a4849858a90357f2c9d5753cae705540d860b625c190509d981fe44(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d2d47838f9820d5660a72be086c6e6ee618bc49d41625b485bbeae5ebc4dd14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab211fb6a6f3dfd99d70b4d31d34f4eeb45a937b3ccd267a7a9dc7d8758bbe1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6b25e17652bbbfad298d3c8600f8ad1059495109cb60131d755c6153830ebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f85e3cb9e9fe2c08248a5222ce4cd6a5cd8a48af8b1046aafc369d8cbca4d23(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e2365b1b222835fcbdac2c527405c8a0069d78d2bd9095ad4bc1c47b5bf008(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b4249795a3fefcf92db05c09351974314d17b2e98e7b195eb255a644bf13e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7293b21f8f3c7334c98d52de99eb2c246517dd6961e2b002ee29b55e998676(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3657383989294b26b4eb338f519418867e5188f024baa682f88de71e8c325b00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487c81ea66437593864621cf51822363e62b1853a65ac6e05545fbb606c53937(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3113064702c86993835e39609995e20ac604cc7882c3b495eb99bdab3bb72312(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9515824c3c20e38194b3067c40b681fe663140bdd1f814b8bdcc7ebd1403fc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c935d542ad7afe0a0f9d94b45fd487b8243bb9ee9e93f4a940827b130db559e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791364a4f8601481265ba64f0f97afd153c5c7fd13a67719080f973c5ee35f32(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b5614af595fc1ae990ae2508b89d973564f63667f6b1a06efc3721ad6b83849(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__756881915e12d0867c7b328ea1b9505752d69d82270cfc7d4c4ab4c7220758b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e1d418deca77c20de9671876bb3229a0d2bfa7d92d34443a59ea9d135e51a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8afd4ef66d75c0c26a3b574731ea46f8605d7fe2472ea65bc469c0566428cc3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3c1680e2a1ed58f2dc2797978bb106fe782d4696ebb8165f0f9c1ff1917c35(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d7b4bbfc614e015c77f1e6f094518ac1dc71caead724278823a3aad9854a6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c60c6d4673c3f2de283bd27768b1c1042ded7eb4681ef36caf44851572e871(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d914abad2ce0a08dfd2379ef4fd7d2e6372a7519242c7d059868c76515cc26(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86059611d2df92091abccea8a68812611463f4e8d60ceabc6ef236945e397115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3397cd9cfb6ef734ea6a72ca3faa6eb137643d781bbf47e52128b021b11f9060(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a320a4a76f31daa7796d3a0dd0a5b6001892e80515810e35775d75ef3473c1d(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3edb865f58fde4d95aed5b97529e714897df21ba66b350e59ba1420bc74e00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be663b20eeae7dd917a098ee9785da94dec465f56b3de3d84a7d618ffff45386(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135f8ac0320dba8f92ca314b0a33998e7f347eaf53e135c3231d6491ef038edb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61963a009157f289d199825bbcf05eec61f1c00bd2736b3e37eb10963a4931b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102f62c5b1d6403070f71c0a0692d7de2102e3067dc17897ea478d7743d64981(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5396b49a404d68fe0786f9c10d84da33c1fc58f9e0a5d0e2fde04eb3d02b5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607b1b49dde4d872a13ea938aea71b2eb6ec412efd2155e73cf1718d9857e595(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8198a70fd42ee066bdb1406875d2cc401cd6532f5880ec6623ea83dfda3bbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aed7beb116e9bb2d35a85db29a64d5c812c8c0190236037758aedd5ec111f21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c6bbe952961812edf8ed353b8f7aa10358e6ac5eb11763152cded3fe9d2c12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ff611591d6d25ce3d34feaf622475fe6c39f2eaf1a26684d589af558af670f(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716779fc807199d04a242ecfa97ab39bb3d1e5f23276a182cd1e0d0af08107ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a28efe2136b8f596f4904d2e8c380a42bd6d75a96b4924a40f2680b0975e23(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e962ef79e28faf1743f42ea09bd6efc8597e4aa9945c9dadb2cfb36d16cac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d43179c28446036ea5814a84b6612481efba4c5122a95fc6738e7bfb0ac4bd0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c864da4fafbb0d960519afcd617c9f0d112f1e0248708154b50fd18c49979ed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7b398d7cbc0365c385ae1c779767a898de77b0c6d774e8fefa3a19abd8ede4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43dc5e9b131f43489bdc4aa53356b4b4dc90d8cf55371ae5a0ebf9bde3f5ca51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a40dccdc5ac2b14216ff3f3554f80e462cde5d438ea78608aa09fcc7a278b4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c3b094147a07899d6b96b7896370909ff3b54a8ab4e283f92846681e6bc5d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032b1a95ff8bb08374bdb77d884f1744687381d982dfaa8491d4dbb901f9e772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d07736e3f96e88331a89fb4ccdbab382b6158590ffa5372a6d71041bf4acb2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e4652ee499e6bd8d698ed1e221bfcf1ac1417618d88ec1e2123a129def19e10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e9b45088cf31c8c3b4670be85e3d0fd7227653fc038b7c9558f6db466d1a100(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15d9da4f208c16e7215a23cfd91c4501ca721173ceaf2960af4d088d991c0df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3b3e913e4a93457d69f8159c88462035b51a5126ab2bad4633bdb21bcf8495(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a865ab04c18c8c594112ef6343ec62e011695b09c23f8bee431099e692a44f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1fb40ebf9c6f2cf2207fe719d3890d713252769349ae74f86c789de456dfa60(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16fe0b2bbf8a415c3040690522f4bff5c1a93db0a703c22acea8f6e140286f52(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039415590999c37aa00a59a47ce6cba6992914dab59e5cd7733ea02841f1b394(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b52841b03dfa51ac2b11770f817c41a7d9c35e48bc2b746ac6b938bd4f1f591(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330f4df8f24523f568e6f31ca18eacf7c6a20a1068094881739f198c72729323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b20ffa7edad5e4cd582c56efc0374617ead8058a9346d153ca46c5611d2b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28793bdcd317645afbbf25e1a1dc615fbc4dfe7ed32bc3e5c3da22a619d7d704(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d280803d48d82212394e834e9c93b53f9d66eb8e064a992dda2eaa3f64d242(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fe210198934b8adcc5f00aa6a78292df6ac49b16dc4c9d0e718422254aa02c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665479508ca41ba408b5f3e325b72e29c981af40d40c4f79e5e3fe2264559ccd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de4f141043b5f59b59cf90e67e2509a3aba36cceca28fe1262bb5077e745323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66587541b38f5e4287daceb45e45e41a32a927d28b8b0a2b3af717448f58a74(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab86b7f694aa6316082989c3b0bc18bd0b0f46a7acf7af376b6c032bb54bebd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065ea64b08dd3be823c80fb419308e6c78236efb1f5e5bbd69dfa752e6083cee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4664f4f497f3948dde2ab6ad66805560e43239917dd727667581f4991b992b3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d44182c5f473f8f9f77b607cc2b059c604a10b0df53bf3470fc4a3cac35a599(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3260e02146b8fe360480645eb5a61f83f6d02b176a6dc7c17aa4cf805ec2d046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d8b0fc127c802b9e609b0edb2af491ac4d45a02721992b4d5428e477eba6fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48df0fcf987e438fa174b53dc24fc7659d4b4347f4b4787eda0ca24fad497743(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f02bc7e561fcbd247ee6437543cd92ce0e4846e7c075711cdcd291d2c7ca7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b59a351e3d938343d90a8464d5ea69a6194907df4ef2ec44059df85386f3a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f0691f2004976e4e16cda9b9cbe7d77ed8bb5f7b44a1cae5777bf3d3ed53a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cfa25f04de6b33d7c4114060299ba1231d81e65ddfdc4a33d45c9405d01e75e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb63367f12ff028bedfa2251b2aa7e8ce9d5a28938ec4c906cb0a940b9d36347(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2f066f1d81c09a037b3bafeac10fbca5e39ea9bb82b59685a4e81974c8c0b0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d214bfe14edfb50f969db5cc326bcfc3f98b47dd9147f34ffd338ebf47f48825(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1330a81f860488da6d27c683d0db4dc87499922ca0315e5112352f2a8807923(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d859ce0cad1a7caa87fb4e3e5d22d88286598f72216b987b1d8312f077f0dc3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8888f518489b8ffddd28575ea2c90e540a7c6f31ecb5f198df167ef512ae01b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9290a6b79dbd94d4dfab9d64c988661e1865a875a199553aeba8a1035f26ab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619557934d18f9f6b1316940ddfac1d59022242c19efc669858b087bf8997ebf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf13cff9da5bbdcc48481f0899669bd1e93ca1b08553a226257c0d9e9fa485ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab973293e7ccdb500119c3dfac9cdd9edd9a4a231b8b6fa49374af8966a70bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3b45a4b752674bc296ccbf1c8cf7b0953117063d906d39e888ed6a63b2748e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__222e0839c306f86b022a32e67dcef10f3888a173bcbe2e80476a55a472c6488b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d9432d79c1547c9ab7635e4a60acb8a1403a7ca3cba020bb7a6bf151ab365c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7551a65d4ad379f1e0710bed54afb348b20cd20d30751ae596cd60afff821062(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b65020988610986ff41dbec34b2e3e0b16d2a641d14cd48e9d170a4f798eee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c21ac48c075892deb7ad3a06d4ceba01b3b0a54044912c098845b198869a12(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b91a359d29a1d924ffbb8f9ca855434a41df894ce90e06b75b34ad2cb804a73f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9789a58a1aab77ecf0daa803beffce0e9d9ea565bb1c0c1b86fedc88253e58(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6daa6e40e42e7856d1c7351ce927b9cca7565a656558afd0538cbe2b6d9503(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9583c02a7cbd14db527e1f99e556f6c1874946f96a6cfc055cc61c7915f129(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bf08567f2037002d1fa2ebf9b23278fb94b16affa9ee665e7b6885e7172e88(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acad82e9f490534d8f65ef6dab719ca605168e3de45721ffd000c3afdfbeec14(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7064c1c1d268f0cea4d316f584764df60337977d70535418fdbd97123b0ae2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f74da4217700f17845cc3c3d304e5f45f3f6fc3cbd69f88809c8873d78b1b3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fd374b51aa17e00778ce34e29a067deb821a96f02627ac8083479f1d1c178c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ccba77ffe8f8632f6dedbb365d46137719f33ff151699b7787345e03d0291b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe987eccda79dbf30bb57f9dc5f74a12d7aa762fbf70df3378d82f0e234b3022(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09759d0288db6dae8c21b9a1c747b4116fd820b30e0eb97831df2f0684bb76d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8cd38d614f3ef6f186bb1b02bb60bd418e3bf9d9358df185a81e6cd66ee297(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e28f38f8482f46b0bad15e6046ad784259be09512f5943a6b34d7e01cad5ad(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14bf1a168e87e29c2cbea8285b325822eb0f776713b33707d5f1e4019a94f57e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d70fb31d2ab7603853fb62dcede9aa3d922dfd958d00ece4a2d2423b9a9f83(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcde3c7c212bc4f15f2db8bffd9b21a4796c6aea99e97d0d589dc6d5e564be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabd73e417344877aa95caf700639487299104c1f4d8d69af12cd9aa07dd7aa0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a7f96f060014bd8609e8fec9ad3fdb96d5693fa3326698a676d95aefcb20dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05bcaca709eaf0ae54872903b8f92012171c4ac882118547d739f7345a5e72c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dff1376f5bfdb3876f37174caf1a779738318290f416ab94276adc41a0f1f34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589864e208b876141e87390e245f5550b3e926ab2d5ccf60bb39c410edb0c675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8969549fc2d6b85f633844f9b53ad7d8bd68cdbe524b1a08249fff4c89e7435a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ebce5cfed0caafc70b207516332aceb9d954ee930a0c4bdb32a9b27995021d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf667e8172cf0874991e691d99e55a147baa899f8aa67175ca39bc1ae04e01c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938935626d5c7043dcc328aaec5d47c43984dd6dc7a4066d05cf47eb2601e9c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c8b7cc8a6a46d33fc10c50aa38da4aa8c909b8630f0004a00415617782aa82d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1d16bd2a05cfe2f05424bd7c34e47cb316657905820c7d3f701faacef38ff1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f411c37a2c1c8fda77473e66c3485029cf1e68ac8e120cd1571f789750aacea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631fdbb015ea01d47ecaebb372e37098ed42dde2d4adc17c414448dba4161ed6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1be3762e5e52ae63f2cefd61c2d1392ff329b730ec4bd5560501f816141132(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6e7611d0bf29403410870a5163776682671b1a11b2833a20ecf4883a8a33e6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffd7b9baf25b9965be7475c509bc2590110d1a997deffa1fe2684ad71e3fa17(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c19e45463b55ef5dc04fe0edf3d6747a2f3bb42d75702932522b5c9f618bd86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__016b0077428c181e9937289b721d25a87bdc63b436eb94c6dbbd7c76306e1e29(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb8331dfc7bccc1a78ec706956dd1456b44041a3158612ed6690a4568c76098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b5fb524b181719790234eed2d670397f40e4eebbe36bc9fa7613dc826a1d5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef92c9e4f954eb153f853d6c3e951e50e943746f278871acbc9bb0ae9d366366(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998e50493b59fa6c68c3d85cbb40d56697cbb33335bcfb4402460e1222cc8d8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17c92d014d3affc87818e8fa9a6d62a6cae551bfb31310b45f24382b21fcf306(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4964d2801a5c453e7fb53748d8b8ae32b2f1acb8b6681c68f4a7890135f7465b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c9595b7c2af05a9f4a0c7f395176ec68e7e3847bec732c1a0f8343edf16703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17bf81df1a64b766763e0530f2f66fdc4e65eb376de1fdda01406e73a89f490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a2e3f338a03d70f53f2388ebb3051b94e9d377035eee8e38069d935d80e595(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b825fac47cd9e8880dbbe6166fe8b2fef3f09239a4234149d6f4b55e87a714(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6317e35a72beb1b6d419797fc4787e611acf9ce8f3d15d602e893061bd4520bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b529980d960b688a5f6ea6e2bff74dcf24b72443d62cb64b31c06bb8c281da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aff793c60c5974e5a92aac007888d6bac2c2a9e1773de12d422aa7801e019e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d72b56b0d1dbfa9b643140cc6d793f02f3a5188138c970f57e4c36abc2ad570(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9481d8dfb562d66c9feaa33252846970c9d8f6b94220beb1af32f8a7651365(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47898ec9c8d5a6e1c56f7488f29a753748ab620d9cc8220d0719faaeec0ec2bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c64d0fce9cf03f708273e95eb7782da01f7e152c33c67f330771eedc372762(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4de338b3a7eadfee53ff0467bcc6ad720a4adceab12f2d7c6acf6fd6b0c057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2694248fdf531c37418114e9687a44b55f0023fb02ae0525a0c0dacd6842c918(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d89eca4bdbe1ebf540f4a381d9f280d74207accca5148128dcbd37c07316429(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185cda3c3220353d9d3242c61323ced014087f373d8d7b4af82f4ae4722b57e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44374e6df552e574476d31a678b65bb94a37b9f3b74a31d36f3263955be8cecb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a768b48bf8890962028e02ff6f2f0d1cbb01538a1b5485c5e7c5a5bdb8d34d37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e874260feedda8f37fd38cb4718ffee4c2c0997a4a7045c3d4d84ffcec3fb16f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3db0029aaeb843da1219dfe5de1ebd2b812a6d4612c1e87ef10a966005f9d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a02e0b9f8fc199a1c31d3c7d8dfd3b1c638e503a799b5bd186c6a0137e7bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f45dea66900d3377c3ae8e9ee0c6d8fa896cfb36f94668e5fdd3d06e18dcec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d553746ace42ae6252d0d157cfeee78504598c37e9058e2c489e77b476e2f5bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4adb8163ad326f261f96562c481578463762f87063ecc7638ec66f382aa293dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8990bfa3cceac7295be6100400dc355faa25683a1bf227914a4cd44b08abbedf(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c0f1a01f00fd702454af70e4e47e5494c85f5d68a1feaa558353554a8d2f1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b725ec12dbb95bfa0faa3b34f3177cb7a4b1c61e3f797c8077af3214b70ce5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d340f49b15c200f4035cbbb8d21c967d09a18ae038182b70e937b453a170644(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d98a13dec1151a177fb7a304379cfbf5b4a20c9447590d215f5f334857b1e6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02886803b752e181d869afbfe4e7236878f5b56aab4062e7922e731e3dc21670(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8077e6cc428671eec3ff2894f577e853183b98295907d4b50e4206971a0ae702(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1abca284cd77fe1b08ffc17b6c630eec217151b5508465d3b524d120c946935(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a1a45fd2945953f32349611300f1a5449c0310194d62ed32885c5582830a70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36fc3916f6dc8c4b80a7a227d41119d137ddee2f0fd2a5ca08dd7cfd39edbb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd9553449a0673671452223d915db745b7f6a7c2acf45d1841386627560fa71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eda6655649f8c4a982538547236730f00139a3522b9f10108147d7313580565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2911a6c16d8bfbedf17ae871a7c11c981cf333b30c6bb7789cd1a1712ae678(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a997dc39a6510cf55f9fd3eb86ff60c42c9a4668496e927c60555cc0512f9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae4ef10bf37b3f2cdc7dca84015f63b7606225c83b103b6f8fefd52bf70f385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a322e265c1fb3e18c9f2eff2b930114b57bdd1ccaacf16e0fe7ad93c8773f1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f825764250de8af43dbfe87d6d1dcc2627ae1e755d8d5f1528715bedebd77b05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29506c208dc70fa5e3265ed161e87306a353e4eae7b98bd418a4c99324d5fa51(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f8d496bedca5e8d73ce96d3d9007e9967ed9a266bc160fe7c575c766d654a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0df962718c79accd8667faab460793787a772b0606b14c097e498b53f0c17c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eaac367cf61aa8b828929ef67d870b9c30a8b62e654ba52daf89eddd3925d1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5832ae1e3b0c25f15cb4dd49a48226a36f7bb1234bf5fc5e5f810b4452a1c9f2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ed01e8248f19951b551bcc468117df9250ac30dec70ceba0c4b7a3bd69caac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f9ff3e5d2053c25e4164842a968fb442ec7854cbd7c8cdc7569efeb0ca0808(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a3504bdb0c0a550f5b5250bf4b824dc70a83cd423da1d6233ccf15ca640290(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89c39169eef452298e723afd39a5718e9e80fa0173445bb07bc052f4c790c3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d636075628dea42b8725c4d2d1183e89e546ab831a71e4335086e17ed098de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c84f595b9122f3e522e78351ff41809c9ffb804e8cced0f16a707868a6be1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab97c776b5b991948e819c3acfe37f2c4e974f2153e6654443e38c64db2b622(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c832ec3f91ac0c76e69d8ff2b4bef1a1870dfe5f909eb452a14900d4451a99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03dae2307acec346df6609bbeef078140014441a08f128b3530b0a2fa49c9fd1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24be8ed7609b6ee1d1dc3815aac0ca49db2cd07cab6510f97668c9179172f1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54a11e2fcce42392f727dde2ed528441b017efca680a838c47073e0616e62be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8918116fc95941c63b5606f69ed648cb5d397daf7472e338cc37a245237811a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11089c42be933e552c5bb4e86b60a33ad71e99249d9f5fc49380012c12d62b34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65459e9e9c7a20532db38d50692a1424742522a05b40faddeed8270956689b12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6b2dfe831f820fe6e37eadc91ff6ca4bcf4877a5b07910993f58545346a434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b73a2741b3f4d67e2ade559abe0849a75d60ee8d2ee53e3b7c7a15faad10ca53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ba0d407321f9b0e61f6d1d28cf3707cecdd24ff59367f235ffc28fdbd1070d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89c3cd1246bbed3e69a9ad1a15114a2406396ff9db1fb69dd51c01d6f45aae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e784b91d4fcabdaa5eac6917240821818d9f9ebeb06a4f6036c16c0c72e29c14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb6cd4b5c467bd4c76d0695c2ff529ff7fb001fc254b2789a4f7aab05d20a57b(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76379ea590a351fa8c1d33a5c06f46f34504c6ff80d5c99caeddc8016b0e17d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef5723d57a44194fb0294c108baa9c5e63caedbb6c22c64031175d3f3934d40(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c354dfd752ed41f04737d2471d2f845c2d92392cae26bf3c7a31976eebcd0f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162d49a700f554944469ed46fc285d9151cb481c86d16374af84188f9a740473(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5efa2144ac03659c199520034756ad290a916879db924a3bc8e54e335e4401(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c9dce2c9cf2a6bab6ffee76a575fad424cad3d6404ce9997c4041414f9aaca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a202175966739dee4b84a16fcadbbfe55e8d86fdb1e1650d940da6be066db223(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a865d548b5863f2b96fec1a13f94a88a7870b370832e0ca8874ecb2386347b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f80827e8f41ebddff6d2d4183a589e738467c89e4d8bf5a7454b41d9a15454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df74c710216a22220a1b3e4165cf7a2a333f4d3becb2df7006e6bad6f0b4ca34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842499ef1cf42a730914964eea70e8f53befacfd6de1faee6d8be9ef34a9f862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422a8b95dd8f1bb7b3192d211cdd216a374e46e5b0a34a480f8c370055875ac1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9eee1942a2673e651870834550d87a699221853ca75db7539d51880df3306ee(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44de1a3f8bc651d19bfa3683cef63e9588c29a0a35ec179397c9b7b5984475d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63cf0ed2b3090fbc24876f25a7d8ee572cfb893af96bad61d2d9464da43cc0ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16b83d1402b2123cba5003c4d6943e1442eb94987fa1c5f55c6970549038157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82d8cf8abe1145fa1e30918618a96185a96f9ae7292e02e40def24f012e02c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc8fdfd0d2627fe46d29eccc6668d1b7f38d84174c82836cf14fc124234db07(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484b833f8b21dde87c9e9a54145b201accb2e01a5b9c94aed8f78adcb3272f1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327f9f13cc69fcf2afd2670e3b4d9c2204d2977e8277ffe80ad36cc1ef50edba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5ee5e646ae77fbff8292e8e3efa4bf2405bbdf1f1a793b67ecf06c6221766e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e244c1ac00e9be86e71ba888b61703d6cf60923ddcb405ed3b0da0407f5df28a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de7237d73afd512ff47354097b4bf8d80faa07196b5a975a0dcbb15b58eab4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72791e78cd2b4d38bf57616aa9f6969cecc7641c94e9b69fba43e378bc22bb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d719d8eb5df7e40aec6003ac842a84244be80f8ad945650117b216cb2b9cd48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec8ceb17979ad784cb9556bebd0eef0c45113da7eaaaa8d3ffdb06248a32225(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d04274d8fb03efa2eafd75896d28ae64563d67411e765fac1605a450eeb077b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8e8d910730d760f7481a080f316ded93d5a47b5175491fdfdd5611c258495a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__407631ddaae9004feaab3ed6a9370384df871ee4f18c51350ebc96d8d939feef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df24433913d4e9469e6a669ce1a329f346fd1cc939799bb3f2763ca12be7d928(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448b100e43d55f8ef54ac959f3b5e23a1888fc796f8b47ed380cd499b75b2423(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73c4bae227edf96f752bfda0eae00541b01d6226f0acc0d00c9ba6b0d40f5ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936ea00db4b8e6e6fdcecbbc8d4fa27bd11e73f41a9491642d890d8b3ff833c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ad8f79ce5c5fb8b3ccfce914b4caac6ccc58ef890fdf05365caa1a80407467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8877307e78aec3088507456f266230609c13a231dc657a7bd5fb37b2b5ad55d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06da939ce8de83eaa5caebc49aa0793c92fbd2372d92d0dfec29f318ed6cf4ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f672bf8b7a1663c87089ff566da0b699827b6b38f44ffb1a6d899d5db7bcc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef7eff019b51b9f7a24b04859bfcefa8466079ecb280b3ce499bb0aaf520497a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa6c472be5c74c264649554512f8cc8562825e4df4d00e9937b502a4939534c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec85905b11c9af691e3d67ceaaf2878b4bf18850a4030a146f5fd17e5a3b088(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e00fbf4b3bd5f8bf8c80b1c770442e18cc12cf3f81d73687f62ad9239f9b31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2246557c2cac40cee83f0f1dcc337d118c9c2ba6aaf03b218b40c80055a3e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94724700d1e2ba7a62b5bbda68e3b2c0507c99ea43f001456a9e99aa6d981571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169ff1885a07f17766d196254e3070c42690970024fd6e19825d02f02826e905(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988c1656fa7670b5d8f351ada4754f3ec6e8313909658ebe2587fe513d5bc265(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816abe51425a77e327b6222d52084e8479f1e813243a91dab6357184845df1a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ace2ecd31dd905c2b4c43d178bda245b5141f52995a6489cb9acc35350727c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b26fef01d1adf9af2a06cca96b6d822602c8c6b15e4330861c1947c2d82d65d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260ff008bf3e2852a58416c914c2e8d2c36d6eaf8c7b02d753b84fce2a468755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d165b303901f68e9f58f839d961d9059b0da0795111f5e15d71a6415d3da4c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c99bc7149e1d7242af12613fe9108ea0af83ce9ba7116b0468880b5bd232d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff995e3e0571a8a6411ac0d932af7288f4a7566d43582945727163165cd0611(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc4034e356cd58b665859f900ea3887334fa4a32ef9b1e862dc3b3a9e33107f(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b30373dc9c11d2d2cffa40e005727e0c6b16c55590707f63c6b1fd96b45fbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa8bb6b44f37d65222e3f0da59f10aaa4811d90e4d559d6f7cc9f5d51a5ad81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2d49e7733f1d9f1f5629b6ffa7be657f308472f390816d52833ed5d9ebab47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d003026075aa1c93f8eaad2adf4ab03abc469c6a9889e72e4847f1c2f4e49083(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5a215443de1ac588da24ca09ad1224e8b0a4c47360c5cb865beaf5aafcfd2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6641fd59e5653dfeb20d2a104e7cdff55ed2eff45a757964b12d085bff7d3f62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e556b6c135ec5023f6308f42c9cb693817dca4bca54399d5e5d821f4b5fa21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b696be15f61f16021580c30fa55cefd216d1ba8ae7b0f0968330992b6090daa8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904f5566fc048c663430b5d4bc84a33af78cde094b1eb79ca7aa3bb676f2fbf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25cf0202cf85fbc82c50d634ebb017cb3d34560eb3d5b0e07ea89554a1136cc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ebdb21ce1247cb7af31a556257bc4b8553c39578243a190dd380305513ef6e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f34a42d952a5de5a160a6996879a566a30b6495c3ad3cd2be94302d2a5d72c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cead1e6b36cbb6de9b9faf372d47a8fdf836fad98803f356ee799b61258821b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06034ed34aa9e45ea20078c5c5ee7e301da62e115482b6b90c26275d82256c2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87404038ebd01230802b5c16b3a0e0ae072a8f31dc12c5cbe8392820ba540eca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27215f6167458e5a8215749c3910a406018988f0e357dafad812df0068af9ae8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84120c40929b0698e3fd0f51c9582681024eaf6e095367b8ff996b160accf90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e7b909440364e97dbd38409d0fe1e6baf0d8ebf81488a89a243fe2c487b77c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7450e19182905d85e13156e55ec7209fe63aca4a0622431f3859104b7826b1cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f0abfd5cd8d59e1f053750f35e25fb6d430686d9e3842534af264676950ebc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab14cb96701e2c1c1b275301207e8bb96d07ecfaca854ba44bb02ba15e2850a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15630eac0dfa36b744a86cdced6bd40e180125dc687b3ec5c1449bf5abe80de(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a535b460103e14dc0b1e96fbc70302c703c8b7556ccf0cff2066eaeafe6e90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbf72c2e0a3bf0bc1ee6666918344bd5eb0291d8ada458798c570bfa036899e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a624fe964750559e3b1a63f42f6f393f8dd9f125f873deb6122ef0a5049fe70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3e1842b482609251b31307286964efad36c9ff7e84fb5f0b02fd55c20e300b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f830c76b934c9e8cbb321b34ffff6d194d3cf434e2c3db165b1ce2fe6ef34b0c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3f39bb5d0ff54a06e03d88d14941087d24be12800bb5f8c7e2adacabdadff0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8a77773cecad65d255445ce45343319d2ceccab518eabd0a1b044a7bfa39cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7eadff284b6e9d3555a5a51c599cc59978c0963c7aadfd1cf5bbdd2d18805c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c3d75b6a06cda9c2d408857ba0e6fc2dbe370826aa968d82305042216f0356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac09a1d7e901dacae5a15e242a967707aaea1462fa0ddd17e70ddaa48306a8c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0dc44e56796417ee54392830e7174c54b443a516d19ab18fb4c8901a5657c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3adc05c3ea41db72d769fd31fe18578f9f6b3b66f8a1589d32834ba58753ad3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fd453fd2627705701bb9a7dca46389daca9bc5711013fe043c4d59bf7ed5b2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa829a7022dc810a21a8494f6df66e3118fe1d8e614af8b077016db2d9c99682(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe189923c890a4cdc152394521d64c664e3c3b6d020ca2734d45fdd0a7a4e472(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7d133cef46f01e3ea53a6308ecd012557344d710d6c525c775d3f8248a8a08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9378eb54bfcc0a1873cc8ceb7ee8aef9fc03b3ade9f6158a9031e9b3f09ed9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba1f3249976a7207cab2588909c9cf26f8459f78ea95398e4a00c8c14890322(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cdedfae87847254f4955abf16c6f6e17da15c0b8cfc76474d040f828a8b9163(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d030ca96c30b6e291663760eb34ae0d71e492ace74987c17903e8615960182(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5960163e206e31cd20e32631839e6b74eea7ef787496fcf887c473a31a9f2ec1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3eae159c8bd238c5427f2057556a3eb8d02d52d44d78e64f61f9b74fc205448(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b9627985890c6e6a89b35073ac20987549973217b447b22cc01731746a875d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c100a4917b28ebeacc4040ee9a40567379eca7a73fb8cd38dca518b57c6039(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63945eee0b4e46fd2de00df7c25ca193e6ecf2a340709a05e21eefaa93651570(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453bb147f4db4a31181108d1c12067a14bb6ea4390ed823d8f7048eee2c6f231(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604b3bcbca6115bcca8a8bd6c6caabd92601ab8168988cff5c65a0f7d01397ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f44e840d501e3ac255d51fddb54fdaef2b5d0a07f5e8764af5939dde2ce7c1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f829764c7ab232227e281538e1bb4f652142c466218a87eb12ee95cd400a5f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff2a87e95113d4824a1c43b12930b1a4337d3fcc3303f3f5857e8ff5780e1fe9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379c0c2b8e4271fa84c2bcd20ed62ae5a698af3e278c24209fa00b5f5597f0e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d7816b16c9d09a159c321553ab678aff70b02f8052768cdff2715ff5d137c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d15207207039aa0716d59f2a44b19441da4ce729c2ac294d328d3b7e2d7cff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f81362451902a3e6689bd0d78557e63cc0a89204e2f14eea9b94483434f1081(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56eba93aa97ec2afb3b86ce7106cfa7669e0eecb52dc9e1b34eb325cfcbf4d93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5756940b458d96d18b22722a1e9d59f6d0ecc1d6af070f59dc6f70fd02042cf6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9301ff0071c33b3aaed60f806a12e0ec2048df0dc3f1023d43cbbfa95f44391(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee68df212b37c4c03e8c845c4de7f4a9457f221c36240d22350a657ccc1d539(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd013a1b1eb077d598bfea870c3003884f9837375c36c5e37ed5591b78e6810(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7427504a071d4eaa4dbb4a1e00db9ec1a50f7fd8149c999aff98db1f57d9f294(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53753df4c6a2ab2dbd5d6f9f9169363043613e109fd2e03ff3bd63754d935df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db148fe48f72677cf24285655bf9d9ceaa1f40e811e68fe7388a31b143e7700e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a721620f7addbc9ff517e83d532716e0d4757c059dbbf5a7e95e7e8147e65d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efda1a4d1a0af22fbbd9d496e02051135cb9473608ea883e2dea1dc5d02ba0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29727760a652eeb89afc2fbda1de9b8074676376f3f69ba41ba6c0e7b2282e0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e3ff44c98aff183fc412e2705a9829e687c9bbd92c1662d902c2d240bac2c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10d852196df03b6f97b0d952b11961ec9b9efc073b1334940578e2da1c6c0c5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e63d513091fc8590482801bd0a58af760945fd1d2d06e71f714a8ffa91475ff9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e750550e15a1f77f25988eb922dd7f7bfbf59a4dc6dc9fb5c1032834b0823b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f42fa73f716a9f717a2b2a040215021f979cdebba2360129135f826db101e88(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09111cf44b205328bae8b3185919f0abd4fb9b66f3aee1782713c8ccd7b1319(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c0b6c552832d534f984a762e109680d989f38b04b33e6370b4d8c1e6ace021d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f197eb21953bc36ea900615bd7deaaaa99f91032538af0b38d6fddb52d53f08(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c51e8becb96cf4ddb2950f23301ede035245e0a9ccdeba8ec2e681a13b06a40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061c7dbf189d299589844c2522268c7a80c84b53ee0b7446ca48db5953c2752d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02537ee809c9f469bdda73e5152f32376a7097713b00fffc5e423e3add798d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e093bd6fb996543022837e4eb5c0574484ba9b6e82dec4be5776756d7a274fbb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5224fd32b17b35ab6d0f67a57de12b638f56c7d52307250e0db858dc22275f15(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154e4a9a123021e088ae41f543b0763a52e13ff89ac0c3062fe1f73f4b8f19e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2b12739f6c9905e9d2fe60bad2f5e32852b0f46f3b1d67649e3e8e7a02f87a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96d9c641f2bc1804c3489f06af65c7c9633f7273c9ef5d7dd30b951169e1152(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9afe775f681bb9ca322042c452d2022040afb89d89a19025de1a6b34c59181(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7a931f986b19db6a78f5bf263082643f22833f3890e8976574cc576483b5a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84db3eb6bc43b27aa007aed09f7a3c9cba668a8571f3998aaea2d6d866ec5171(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eab9daf191ccc088c913eeef7111ab3cf02c2a0c1cd333213770e7834547565(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b78a2e60c34443195cb5c42b68906fa86e31283b2cb47713c91cc32fe5c0e6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3c8e6e780e52466d4e05313db12fee177ba7375a4e931cae8a185367a66d55(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6774f5d6d6100cd638acd2c3b1b18a768dd15a71cbf58d862fcd36fd7a11605e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f760e3d8b54cc5bf4be81f413334af154946e921d39e0725d15d300be8099bb(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f505c959c419643dd2fa196aa991a826c313e99a4dfa56e0d249f92a6a53bcf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51665e6407ef39f544efbea813a06c821cf2b20e7a69b113a3f221b4d4bf2acc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8ca41f4a57c0d4e6cf4634c6445854433ea8fda40564344274ee24f22046c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef2e28c3aadcfbdb6174426cab9e12ddff49c976d524f1ce8e6ad73013204d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215546ec5455ffe8ae4e86feed6fb73eca775ce9a043bee6a793346c37cbb514(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1ab5de5f98695c1c49f2b242e6e0dd455c01a49877ed492cce7935ef19ff1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785592a26d1f13f4e099502391d592173254bad91b03e9eba6cfdc07f8c82b16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d7010f8878b15fd158aa17cd34ba51e32cfb8049657dbdfe3a17e90eda8442(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7a816b4b3c3db63e985d633ad1f4385cede0e9feee19cd53bf9c9993256ec1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330903e2c82d5eebbaa76f218807543b70a387b8e322f76bf7ccae663ee10e98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1894f78e7b84d8a5d117a749445304cbcce7ed2bed9cba632d195600a144d518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ea12a3e61371f4dcd86277b8a41cbd6ebe654748db2dea8b5858590f27b82b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbab95abbb295786aad1797a4d34714cba5594453b5e5bc4d756acfa0a96414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3276ff329ac1004b90b57d77f750b8bb6bdee855cfed2b7e81412249e6b234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01d792c74669fbf4d010ed53c1f41ec5eb77d5675c3a1f7e8fd8895858da5a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ede58a53c06a799112b5a686c1cdae6025d1e124060808a6f7b125d3e45d928(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4dddc77dd2fc86628c177653f864e830ec2441467232e5bcc5b7bf50009a099(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fddadc9e0aa00a7aafc8cbd138506ba99da1ae5deac9c6e4614ed91986b6803(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf8d9b14acf3912d42e2aea14a420e2c961711b844c67961ab6580b7a075562(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c5ff70b6204fc64b0170c1c8937fe263b0bebb1f22a3b38cdda8a654db2eba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e591400688c489369eb60a92a541ff0b57c29e84d55eef5cc73c334f52b51f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e986e05d1a9e19336932cbcd7f7f18020cf4d44389f523ae3a3c69eb55324da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b316ef4dfdc8e3877ef560443ba503f3bc1f5789898201d9669b6e6e51b425f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__116c2d4d8bb6c3758056ed52d3a10fe8475a0edb6d1239a6b40a9425abfe61ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__146fbd382881beb9004676a20a26d1314e2bfe09a733cfc3071aff03dd7d9269(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d577ad0f8705c01b57a41b11472fab5d446ddee32778c5465a8c059ee6c80448(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e814ea2e5453905287c77191d32ba7434212bf403d6a0f67ff93ed63526a4e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375a337394d16a25c2ee12c61e72ed35dc71a4a9607439b633bda47fc005d8fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb31350038fe076ce9db4f722995ee28157b3d4664e11aca68f65bc496ab0d34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ceeea2a1b3bc7137a1f10512342cdee947cf4d50e701557f4cc16a337725540(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b75af677b633fa7cafc3681a84f1ec534e503aeb1087e9d376851a2316a9c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3087bfe84b4058b8897c4454dbb16acfc535ab272fe55d4266773ae55122f5be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64860d3d199c922886ddcbc39452ae8fa72191f73f18a220ef3c3f241019d460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679a276aa77f58de7f1003c71700310a0453891ac745705d9669251d1c31c1d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99d02a31a7b9391dcabaabba2d94d340f75e452e094c56b97dd3b8eca790303(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345085f74a19a19e540d23f566e9135bbc83da3dc7d87b6b646e668e7777c20a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4f17a43098d4cccfd181deca0885a6e01e57089bda08281a3497b6dab1dd87(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484733ae8a15b0b57111e806a3c29a87672f015ea3a00a57b1f9e9c0bbcb21c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a5e5417aa5dd5f95cb2dd133d89857f6b3239b4ef28141f66d7daf7e05777f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697f52cbbc38a2f90cdca301b3aea97b1a4735e7113bb9af4cde041cef15a5c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b4774c184ace0c68f41a5fcefd3fee82d9b779ffe5ae379298afaafe2e6a96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea4ca7557507beb0a7218670f978f3ca44dea6a542d6f13feb130ffa1b53bb9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae26a46285247a399534f7aa97868b6ae7bcacb0abb3138577636791c8f22ca(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bb7bc5700b6addad0ee54647d2dfef33fe8e2ca91239b865fabb6ea977142d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6bb22177c9a35cbce92863eeca00474344cb7bd75a165e857b58e30f88ed71(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a063274104d2e0ed873358db10c8769a6ea58ddad7f3b724f9f836af6b3e8629(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc08d14eb22434b8556ac87fdc0cd7f675ea657d629e784afcba8eab858ce56f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b380a9af71c254d99609cf469e290c77c58f72f5d52803806513f721e16392(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efdab680dcef8e37357c4856e06bb0223ba2d74249a4baf019641c9478efa0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d2341532c7238895d4eec72a1585c7a7dcb5590c2363613226a406129288c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879b8d0032cb771a3277dc9270e645f6cc749a562599e5238ca2835efb8833de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4283b13e7aa4a16a57792d6e1177149df4cec89b5d0350daf5e45b6ce90987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa36a8b668f99565fb6a755bfb752dc301e767a85e54cecd82abcf71ce16a16a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e690fe75b12fe6f9115e35319ff5b3451ca343170a46b89dd48e9d86267b4726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7260a075ebfa827df52e8ad9c3adc9f8da84f9e6a26874a19d950bd8881d0ccc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93634d59d2ee344184b569aaa720354dfeadd243cb1648004a75c39286292f93(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beaa6aed757d24768507a6f6aa2c653c65847eb705ec2e4344bf399865a04035(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d947e9f398d0335ae00e713f2e0d0bcc5d2a602e0ed1b1bd35bb3891330dbfb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca8ac877e30801fedbbe422a4786d61f6438c74ecd71bc3896d3fb0bc1e4529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93965184a9e410f329492d0adb23b4fd71cd331caaa4521e7bc961b44b8213fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280b712969c2d823e7e551397329c865e6231b64345b126df1b516e21538aed7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721015222f0e7acc19543d73994f9d9bf49e5793a9da7b31dc739efceb2279ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7745a6a2f6f087fd2d37ae41c1e42c28e42455061e0494a748561469bb3e0a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__990f2d4a76e98fda5b6fea7f0dbde85f99d2da8fc652191e08f032a22d284525(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a54262d7d4c6e123f99f6c48c9d6fe28fbd9bdf98dab01b84d4c95d114d19f29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4327a069337ade9b3d6049aaa0ef200b5592ee04058687f25a4b470648074c(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfeae411540eb19c4ecb5fc1398287ba6caeb4dc83f0653d30b7c4a2fa566b8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1246b818bbef01e7f449ebc97880aeaf783c96364aae7d93509b32fd620f309(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ee322eaa38fcd4357ee3bfffe573e8e6875ff020d369185f4321c4f0229e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4380d7187bd8ecd07371b165d83652db854777495746df0f6c553753a2aec749(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d801c52f5835e73a5feedbe8831629faeed9e0ed042034553c06dd9811d5a732(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee09cca48455bbe95688c61b2ce684c0266bdd11ae42d4eef74d6a1f26169b72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a022233ceb804b6f245ddffdf94d8afd23feb5a96ce05dd06480f16ba2fb69c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7050d8136df8178233d25daa1e04af020772b8beccf678eee98e03963c4e8914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bcf3c02a385dfb80a58de337a9264f57ba7a82f42a871f1d93a07c4eed19bc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be5fc549f350162728248ac23bf78fa6486159d776716fb800a47661c540548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a580c7fd6df8f0046c61608c6af709679cbfb8e9528a6f91eec3134adfa90415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e2f42938bb07e7710c0be92eaf1aa218b49a04f5b438c2e39cdfd4ec3cc340(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e6f6d362b148eebe5a174765858afc564b4640e56be1f4baa5dbebe114443c(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd187953302af98b086d240442114e7a11fe57a588c58ddda9f47bc3bd3eef8e(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62deebb6f496ae51280ef723c8e0fb6682508ddb57e602e7119eec23f36d57b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832442c901ec5562d1a8c46a58ec010bf6659990f8a9638d539fddf0cfd90bab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8eeb79351ba6ff15fc53690972880b03f790f4539a24da2081907e585407a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd090227ba9ce54513528e576138c787cf105a272ff2edcd160657c12eece59b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8747adab2956244eac6a25e21be309937b25065dce187319b1a8e35a054c8617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ab8a1f3f634b41db3f54593c721092904c5f24956d4f3785037e090509b3a0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1691f5c972531866079caa4706b014ec7228c9503ec14a9d2908c181cf7188e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344d323be215f2d486dff902606d04f2a07636bf13c50df173a45ce1c6ea3a59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7fc0913156d165a0e73d73e0e9633f83a8ad17d57e06e99e8c58a2c9b656bd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89f18a12a0e5bbb9e5cd8451684348d466ed5a4321284e893305430be26a356(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817cda64b74588098bdb7b8c3fc003b28df8b0a69bfb60fdc2d50eb79dd56ea2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92db64106b89f0145541615e1d18a4fe763337bb926c7ffb9760148ad9b606dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0576eb60c637330c77721127f455fd3f2890fb3feaa8839a174e7e18471d3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4305c13077713be8288eab8e4816e09f0ec2cc9f87b844a490c39f438ec3922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92891bbae509901b1071af18b2943d13c1335cb3cbe21d1bda84c2e96e257c43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3547416a86ad475bab1927ba13c6a1ea63cdcf97a8df68b0dd0e2ff08c1e6d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd366a9acc646f1fae09fac5d4553a7456ae2b615d3320217db8f4e8191caf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc4c715427dff25c26dbef369298ca5c4cdca2b692b9cbce217eec84c9c8649(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98ac0266ce105c21e363f75a63daf2f4226033c11f12fc006d8d3cb6ab05939(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1e246a455a721b06445fb501b85692e5ee84f5813fd5e5843b7f001d6676e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaad41aa9d627b7c769d34162f8ee87ab59f87507241faffeb8951ea57b5b07c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65451f62d87438cd9814dc813188e3cc5eb2d4de3a8dca48b04e6c535908e563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e9180206fcd77170126b9cb177e5528dffb0a0e0eeed9bfe2e613dcaf0930a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c859719c0bd4e6da9174b6cde749bbf3d8174ad72932d99aa804143777467816(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8779a8b28c55b5f8eb619fe0b9734646c54a171d873b0844d64a6d38792c51c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7fe5e6e413e26a808c5c5ad1dab69c7fe17c0e5f3a075cac8ed84c59e1fce6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ff0cb6ae54c1fb2306009e8de8c2683a1656fd5a47a6119f9852093eaa265f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e762cdc05e94da75c49464ff907ec4142ad27a28919a9546f0a984a4cf7ccd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214d7021ff41b8d6f01b9e126b1074e886d4c3d86bae41f332a1cfed184e4623(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce3be4994abc9ebdf35685c262dd59c8c53145dae6a986376f3d7e2ef7deaca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fe975a90a2e1a116b3e42e504aded99671b292d4d185343f19865325b3e37d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc643afc3a86a6c9c0659e011db179908234ee707d8ca07c7fa4d02fc7807ade(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ce5cdb1c5185c5afba8c9ea5af5bf0e00100678522f87cc4643452ef536a99(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12bf32fea45b4f8a33aa60884dee641b1941c52a6885db7dbea3a30c21af9bde(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db57c12b1773f46bc8ce03ba72d1abf321962e96e0268842210d89af838c1b15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb0946a599a4aa19a7399a687aac5cda6305eac81db7a5e8649ad32b423767f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2ee164f6062d65ff3160abfafaea905241f8b7d20e15a794b14a37798de8a4(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478d19acd1d8d9e2a5cb565285b37ff9a54bf9e600395e0ac6fc40fba1a60457(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8474c930f6ba757a4f33aeaf386adf3f15441d2244c2655401ee4a00cb1a37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e77508ea6ca415cfc9eccfe13dad698c01c1d2e8bc30e60c1fb8d14f69922ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef7de1219b5424893564282450d02eb7bd2bb956ef0915ab5aa0a72b04142c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d413c94a05ba5fe2893e7f3010e365ec47d9b5868269a38102f3e4f271fb4e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f960261dbfd492cea0156a31c256eda83af89f5ccd5d39a02f43007717c1ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__500c492833e069f2bed61ca800186d7333fa25dfa830ebadd671a482b2e79c76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f469e97c6a8d40907202bd83f6889900408e7a68c983be140509d37d5bbec420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c610764fe39c9480743bc19cd8e2452736922068ebfe78f877843c8984547f87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88889ec9c27f9e361227ade439ace23b9e1a98dd5f6206c499ec41279dea1c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691f6b00ad4eb6b596683b89bda795deb0ef5f1b3c4abc64334831f5c2f4093d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975a02907c022548b33be78f6780cc6c1f8114a080c33b9534530885ffed7f1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae22361522f0b6912d91fa805f8ca94bdbb787907b87ce97f6d44b2faff5a505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c73c5a099b5e0777131b7c11de4432349f5871a7278b3a6e091ff7c2a6dabd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49156fe88c949da9554269c81abfd2957952e313706bfc616171e1618a05927d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95eb5637f17186b8bbadc73a16c80c40251cc4aa3b280272735890f50d6e3912(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b384430779697eb1676fabb4e8c9c5bd5b65d0e00af89c701e3ac3f16083db16(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebafe08ee9c0e42af8181be057ebc3e3d8f549ee8432dbc971c909b432205d4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4174b4155334d083f9407e52b143ee9ae4b168febe8f4dab8139d5be25562e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5791ceea7af19fa289b6d9217dffacf804cccbb0f6978dcfd251ba51fd9f76da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdcec6c9e8b771cc7cb3655ce8d66876354769a89b2373a9d5d656e2d1c17d29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944a9b1770e5d78b6d4ae903ad296f1b08c5090a2d33b0b2b7d3f7f0a8d2096d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f94b02300ff80e0a106ac05a17b2faf646074a7dcb0c0eaedc929b5e4173426(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cf3a1987114072f1101cf7c4be708e97544fec3082ec5ffbf48a2d8ccc59c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87403dbbbd57d75c3feb29e060f008e31eebcca8d1bd81c73de1f8b8f03f7cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea057225137fa6fe2914da4d8f9880a8c50f887699b11c8aa8546d01956964ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26def1b475e39276b2ed3edd83486c503e94b3b9470c82af25f7a8593d4f6bce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426ad7e5914a1e886b53e28ba4ca18d90af87f50aa4011897e5642b5dc1460be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3294d4c6e53075e904f09da96820eecc935cb8ccc9fee24682c827f53e34547e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e9b5649f3002a1b981dafac03b3a40c7ce752caee538e393ddfada5ee1c623d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d1d7e380d0dd181adb22c62675634d6fadb30ba7ecf068035efc1899e5a553(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8b64fca741f64b1384749609632ee18f43fdc98818c82ffa70739af3f2d95f(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb014d1838839bdb19de58a6c0d8775af2c9e01e3050af01517d7924954d787c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd51dc7304cb7e9142f3fa6d6e97440f81a83632348854dabfc8acbefe1d944(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0982dfbd79e0d0e6c3dbcd9886f14c53ff2a09981d1c95c4f0b84e85f35f937a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede6030b77014dc40ad1697292da2a316b2d138a6a356ccd647ac5b3475f9745(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae5bb7501c4c6cabc471c6e745b436ab1b1d58c2da5de53e5c9a7930ae11b5b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de696de49b2c92fe228e72ca3f5112fe50a9625e6620be74c439ea7fe99d37c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd007786bdf6aef5b8925a7a994291a21efaff82906a05fbec0b649353c5a9e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba052963617fbba29bab5d63bea4589f9265f31e23b0326811284c385fbe11b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4052b643b2796fa531e6efe8a333acf1347a0f27373c4234a7199fbdba978bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204f2a5afd18510c097672487af5e8f9980e3d3a26f13f7d9a8da258a254ab6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ded04dcb180ee592d229428a39c50eb5b7ce6f74d8cfc1964d255e215ba256f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364b1d0ad6091cb6feb4a43f9a2ea78819d0d6cf98bff491b122829628afb504(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0428b31a9eb456f55ab254fb44274aae6dcf22f8c8b9a7397bd887d1ec0652ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044509477d1119ba7c5f64a07da29b049ac3301433fd46eacbed2ef7cabb04b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d0b397cece354414961ae4379c51368f354e6feed8ffdc36fc4bfba76defa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d678bf7ab67d2a80a1a1cc756871d7104e604bad419d54695e28ae3338bb4259(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17c287ff929c4bfb53dd27efbc582e4712c71267bea13f4a9bf9e70c004ed31(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8f4e3a832df6c7fd6f522a06c8fb54b365d62995c0f84372d2fca1eaed43fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f4156e7c1b4f5d9cc434aa6ad8e6d2c4652dbb1ff309a7b16aa47a9829eee1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10a72c31f339355b8542b12103e61358df3fa8391777271efdecca094347587(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8002ada5c9fd3e256292cb853d7d720fa1d92aa4f749210d00747cee7757961(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22806718c2308f5934d1bfc3aebbc5a7a03fc0132b7c1eb6f96c709aca55450a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee56d47046163efd7e17c7cbe563ac4ccbcdc445918799a90d8d01372b9c844d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d758e2fea2e841b2fee30baee919b019d23ed53a9923b5fb2624ce52a18fa0f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a96681423724175320f6e09b896ef737020911c60f8180538c6711fd20d9a4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9620ad16295414e2182cd60d26eab017bafc04c772b637f0517d1a96e7ccf1fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__363fe1c869311e996793019f3387907ab24d9275058001a0aeb967255f23af11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c196c373836988ce84f70667e70418b72208b5ae3087613b5c2bf614cd2ea8(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f276d6e6bf149d85422ec2e2028d8620a139cca5926dd4a3961eb0c2c68e5238(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442e445b4e61b45c955e48105eba62d69732a3a5cb00bd059cdd4e30c7a7a9d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6a1256c899526472caba3b802410b2165aac6928e90e4685d2198522a33d96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afb05cbd2ad728ccf31f3d1e36ae7a54f8d5b11828c9094b5c176559bcb05f0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d3a17b2d465c80c506c0e226e29e441b4a41a3e947899f5f2ec7dd7cca4a43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a82193805d6e555a69d38c61190c0a45ff6eda2988968bf0a7a21b9ef72e9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5419a787ea232b1bdfef078390c580a8916e8a2083ce362fcd88e8fcf9676a04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8664acf4491a639ce26d442fefb503bdfdecffeb29cfa524b645f961880bc218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f4278a028d369ab49638ed887504b07c9f1d9e4699598be4d222d2fe4e75b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396e7bc4d37f0e25152baf9e078f719730ca0941d04e97b891d2b1def3cf1b7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01395730d1ae57b7b299f77cbad2a0fcf9ac7d88fb4c96c44b0c77336ecbe56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64f260844636bd886637401a8f326bef640b40ed4e48a1a41b2bc8dcc54d8c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed9be389b087ca01fd6317e13e47b2120848fb70075c7e7d32bdb32f798853a(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f08ff0314c2319379ce33af0a4957d346af676aeec433392ea3e18a6480d4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c447cb9ccf1cef4febfada315d7f4ec5f08c4b2f06c7f44dbbd81524fa58bea4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8d4b1611fd020ed519a5a0e75c5c1696c666abdce3e10eb261477fb37e1c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad6c6d15b003f9f2d61951c7fa3b371083c801261465d99ce3d700dfc80b66b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40aa8f0f9d927ab1fd8d40a5c662a0e9bad8848aff0e942c21e0948dca47ecad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f8e8d2e7dd2a69710411dfd762437301696395459753c078c1b7c7f75e7c1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455c1226c34cafdb57300028003c5e4c4c05f35af46d1c8e9acb35310519c685(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4495606931ed56dca9331100325fe83605d670e069d7fe752e0d0ef670e72c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0281fd5dc3635b2415bafd9d4e89c041f0f5d7b188f49b68803e3b447260a0a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17ca18df97e76b0dddb6142af36e8082a19029284a37e0c4592d449dbbcfc47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1398c493da1779667c5b6cbcea73d84df08f76c044f9e13ec924fd70f86b5ca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bcd57a8072270da6669bf538c528db37bdb3df357e8831aada4b8b166975a9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0e85e509b48354dc6ba00e9f66998b83a3ee947bd3fbf8dee7209b5701be96(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a62d90858eecaafde05c25199f8a4ccc8d4e9e40830c7eb6e968571136e11c58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad62a004803f07efd5f41d0bff14478a43bba8b6020a6fdafdf7a592b849c5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711ce4f3971df5efddf12b6bb092796b653911d15a8a9e21650301c1ce83680c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4940a0bcfb9f51ef7df736c8134efd42547d5b167c19dc0ba787c8618a7f559(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea4a0823736d629f67e7181639bf1358aeaf3069aa48b1aa0b21d027cdd3244(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6035e99cad1485b5c45db0372b1fcd376b5705310027d13fb6daa1445d2b67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ad91929435a1b50a739eb583fa9ecb2a6d9b46876e92a145cc12187a735958(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44d9ed4b3b95f1b0490bf81bfb9e1b1963967722ff5fe9e319af977ae1a53a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19095fd3b62bfbbd4aa1df0130d42ef741ff651ffd6276e5f90d577aa1973db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a130a2ed77ccf584ed47dbb519574f7e472337f930e9d0980c1e66de4481d34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f6e0aab5d5c1e5550f4d7e6c458671710acd8d2f40d5f8c414eae00e864320(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3743e77901d8852c130acf8be5580fa432cd014ba77c7c089c664c717e59e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30273d26b87c52886a1d054cb82b1f86a8f27542b46e6a8534acbc1aa2b0a73(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1e4f84bcdb86377df2cf2824a120b102ab50850ce097d1d198322fd31a88f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb1576e505767ee56ad5876061154413073421e367403f8833e07a46665ec52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0eab2ae383c57c592f2c05fccb0f5f68f7310e5626e6b7e7339b78273911ac7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d2b80f882bda1f836d59143501cde3baac80b981c64e49f82d1fde5f6eaa61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f450665a1509f312ced16b17a1defe1340c2725611ebb00df9e1bf3c20fc65(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed12a34254dbc38e510e4a949bfc62308f02b25114e80f30e1e75b5da04b0abf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f6eb0c79c93829000724caef77a9e54c7f3d95d22c1ea157f86b1092f4dc8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31aa50287e586f61f805e00648498503ebb465a95da6d1e9e934f3e89bbd8665(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef530c3e845b88c29281e4e4d1d9d71936e35d3e8f55c950d67abd33d3707b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c650e55335ed007283305e2bbae2deb7136dde047096b232019f8122c1884f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bee169209e66adae64943bcce6bb768f3acf0326d5eed1a87cad722f2970ace(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3047f32cb1e227cd5cce4fd4261ecef489f2d61e3298d0dc7cc95179ec6c5da5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d4b439b95db6d61a6e1d6e27b57a5f96e813280635e826d23fef0752a5984a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76797bb16d2c5fa1cd931f7b118263d66f0ee7e02c61f6cb6f6a4505d09209d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c789e8d3960e7772d852aaff1d2ecd7af25e4609b5d4a3a9880e2f0cdaed7ee2(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c3c21db7f0fb94e19bf546c2f3a484869c7b533b1be1f212875ea3fb856a7d0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138d7cae731a7ca1c530e523c406dd8b0bbdd3b612414175a2e7126737b4abbe(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e317de903a2045af8d0386e4daf1a1f837b6156f6adc2e5531bd4c432a75a18b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4a746c10405c6568022d5d7bb89f20aefbb9c3673d5c6bb4e4886b8c887768(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1117185aa751130cee61935a22d0ef880157a6b5e6c2e9f68b3b0ca0df24d25a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8417251b2a6f2de77e1f7bd786ec29572ffb04dffd17fb97554accec141b1ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e89711ade664770318e3515a4503da3371d7ae6342da130513cc96b813d161b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e8645778a91d5425c475a88b96faa87521cf617194234c85c2682bc0a25ef3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4457fe5e5dfe54f459d796f5be64f13ca240af533e574b5f2c19498d6075ebd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9300912d1de5eeb073991c804d3ff4f48016c8a535f1445cfee5b35aabb0a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f99afd7ac2b6e973da60d3e3775c6aeeb4b5af0d6529b003045292487e9f1831(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b75522db10fe519db4a426c3e25c707b2195bc49c89a6ce4ddd9f0a5e0230f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65c8aa5ed1e84814d282456482f388054df9eaf364689eed71e404ba3a429fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e102d8daf46b96e5b57546c46e7ebc49ebb649484cfea2772232178fa2a9020(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55779cbb696aba4c7f403ea02d13cf0da28da58cfb0f8168db6da515adfa2aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7ca934878397a31f18c580ca4f40c3cfbc34d71d10fdf1c745093eae26e5a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fce3515faedba2d6e6de9b128ffd68d837603104f7711f4189f0606092d76bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529043b8f2484282df1d43a510b63308002de4e019b59a99f09e5ead05fdcbf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96d08f4bf62088d5d126399bb645a151c5b3171ce32d0c052102a879122a1b2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211dbbf5d9dbc1f430ed43cea894a0239c0b4794abcc90a33097e2bc565a63a0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1658a85b677fd2e8c21e5ea6efd3155795da83fc1f486463c375ea5881a84a0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a8f131db3affa896bac41c99e5fd5213fa363cbff6ecee04328c989c3120b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb2e20a679566d6df99c85ccecac88de910bd6ad31f92543b595422675df458(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b261ed0105bea07c843d09a8684ed5f6a32018a1d216548ef58168d4b5a5de5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915810c0cde4fd662673edba5dd5804a182dec72a1f417bff6e77490545b5dce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe5f1bdfb41c4f7b8f4d80a9417ca64b5e82134c7f0045875dbadf78af10914(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b170408e258b8f27d93f912fd12755c82ac9e973948f2e08479628f0944efdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b790e0627ea008f0361357f6bad0bd0b288fd5eba8cee6d4406f8d329c2b75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ef31f0d5e20c7313d4a85f166e9c5f14eb4748845e5227f0209acfdf45b6b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a8e84ba3465954c1f415c80609971910038ab6515ae6d2e879968ba0775be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ea492ba1d2d5e27caf8e4d390f2a09b3863b026901b87acc619ef4000f6c7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e950ddb6eea8f3743ebd246ad53825644f02a108f5ddb109901a07227431694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2991638da70bf6ce776a91745e8dc3b3605d261b56c438ce2763c82bc2f113(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22afee6de61ebf46cc7edb9fc838e55dfdb21df7b85bb977707df775d03bb4dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7227cce100f11d9060a33415c8e00157b8325c8b84f3b4d3b7e9aa3c8a26f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ea794892197600077ccf60d3e42ecfc9091dc4241171725a8b40e536e175c2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ef68122b883dd3900a1dadf5dbc2e5119821b286b33cd64ad74c5bd3cd45da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768a90499d8466556654707d5a0a8d701f7f16fb272c4b1df241ba1168158a6d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabbf37fc746d13f1873faf4bac19f0a5a0ec369d3d351091a9dd2ba79d0d273(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ad0214662727653db0fc488a2bfbbaaee364e71d35a72b339404585ca3ce6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1081d7fc2f4f4e062f3acf2b62a467ee4ddcf4fba8b8e98b1e819e3d85f7d443(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1ebe06ea82b1d7510ba2ddd9874754fab7b583b8187435c4e08546c977e1c4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd801fe133137d862e621be8fde303f52d71f66256febcb71d242b7808ec6ce7(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717953a89ec7d70cc6ef67c64aa64f2882726ff50c8ec741c504b34e0cd99825(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b7cd649b8668126d166ac65c02c25046d548b086ea19f393eb25e1dbd53f2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007cd8ebe0c39afc05651488dd1df3f32198bede22754d18a23eb26295f1e725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2bacb0b85f510812e6536dea772125cf2b435e82a99583f0dc45d014084ac34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507c5146721772bd0086dc4de0a9b0fa40d2a9512fa10d3fc9a00998c999f46c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c676e199cdac5a7eee7af50473e64863e0b8b252273c22cc40c4902d2201c122(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e2d54afdc2ab6433bb765ea3d8999d483f8c8438efd2ed422089d44e918fc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04877b204125cd508cf06608f28cc6a7b372e919b3f0f3eea2a8739611534d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a3015fdbb61323697b6664b43548f19113911ed94d8af565f8bc281baeda1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7628eaa8e2b2a569c56e1d273949a95ff3805023b8825a5dee316fc6e3540056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6e5da695ff2455444269b5c5b1d6dd9278c27ee8a83dc079d33b4abc40efd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98384c72914dc5ef67d6af6d3aaf4c91e102f8c0ea5d3d3b08b5cba0195bacd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe60bc2b6039fa21012f39d5f9cac789c385b7ea8ee49de0a1a7e7f791437abf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90723d46e5ac8847b9e9a1c1dbde514e1e381ef62436054c58a36fde22a63a1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ac2c12ca99f467dfb8ca8d0455adb90c78452cfa32366da17344d2869836ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7bf17e66534e3f7f3a25523cd3b3d18bc5ffb93cbbb405f88fcaa162430406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53581ee1e8e3636f4599d6ca26d66dcf6d71ead37ea6556cf34df37d925475b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e12731f90de41a216615931aaa9656aebf4dc41df729dbf296e980dc8d7baade(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb13f4f6753853f2b321661b00ba292896abce6f99a9a8ce84fbe023f2b1df5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29280966d38924804ba4cfd21022b16ddfe8248f1e8886e640c7eaedcbe8d9a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44635caeeda840eb4dcae441bc393744db571c13112e9d9d17db7fde726ff1ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e248b03ebc2483c899beb66d36994f16100bd2b0b96a2131a29002fa02ab948(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305b74d34a7a4c175f7b79feae90f041226a5b18908e740bfdba70f9e0022d9c(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7edac14ae97f3621e72ee73f74e16adcaf1743d54459d021723a30bbb7fb9ea5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c10e21822bfe4aaaef3514aaad4256888a78030cbf496dc0accb86d270338ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6505390b82b81b719bf45ed4cabd9abd23246616ceeb69ca9d8434664d7434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e705e949fd2851ed7713a60588740c66e2ec5f612da594db03cfc6f2efc21b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__321777786853f4dcdd221b86b7443790090280759654e853bda456607e6e7da0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c591ee057657f84415527263f4494efed16a28298be23538f46b8328c0c045(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059e5f3e7e792f4ccab15e080f2cf1fd27fa374322ade4c4b0058ac4b63b8d47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9726a27a9b5f24206ea1a0c0503d2d4708e5868db14704e59c2a6813d16016f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e1e409d100887dd4426e9edf3dcad07d8035605eb4711c0e355e8f0ad578ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb320934af56ee8f7b4aca76ca072eb4d17c028057b36ab21b1ffc7735fdc3bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb7ebaf91b65b4805f8b72c62108707f25d96b290e0fbba594fb036a8232189(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe16e836d6f6ef3e1d1ac9878ab1a460c1181ac242091a7e954158218cd19026(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a145f9cdfe1775916735fb341b431e0e5581e446b70c6de214516f01b8eef2a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be208cd999864a3a979aeb0785b027a111d1f48e51326e32277bf6db61267b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b5f2e5d73f84c8d00041da7f094ef4f5d3a5d18264f0e0f47b9b7342fa33801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8091e3164ee4ab1ff5eb77cdcffc2279c37c33d2f4fc6628b4559269cb3798(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7d4d735a04cb777b9e3c7aa181556b5aea382914a0f6235160a076a8ae0654(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e4bf87fe5aea1a1fbbfed6e604b20791590d67bda10b33ca8542a8307f23bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948b77b5ab8f8a6bdbbb11ff22bcb1c54bdb3554fc9ab5744c4a9a7ec89bc99a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da100d9871ebac1e761c3221ae6ed8e2924bbacd71ad1e4b3eb7c8880c7a90b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbaafded85b9de8d78d10f27f80f9462ab3d2459a76baa3d822f7d46df2315e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4181971938be1646c668c06bf02a899dc662808335d87aa9b17fef089bc4d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6397316421e73fe67bbff260be5dc5993452f0b1b4385b5c43ac1f6cab2ec5bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20d2792542e27a485b6e0d35cdf646b5ced19c53402ad3043a1cb4043f89e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ea90ad41f56fb91ff13566ded23d0210e9d13ce77eafeb2efcb516a32e821d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12b8556e1ac8b2a119098a4d851f13b5f64fd1a7808646148049fbfd8c12da5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa9c77821efba2deea7968e24e910747b30949c1c3c6128232020594197d1e0(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40688d8cdaac7143644ab8a87e7e19d714ffed65c492ab7b3a3a33ee19ae6e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545118fb1c2b184a71a66540cae6885ddb80aad4279e657de0fc0da1cc46fb6f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53697166a46714b5a2967886e437761cd686181dd08bbea934dcc46d9ce7bdbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4620f8b2ec13514d48ae8212a9501689094a15ccc8add366227bcc7de3fd7dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72bb5b2463639766d4c9da32ee430c08031a6edc7e3b7d306a7db17af5b656c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83349da6a0942acdee018505d3908da2d14bcccc6e6304e029818168a900b858(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240b8bfffb145937b3e90ca4e3713cc5f90deb1ff4b59bef7b09f28d689f96b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19a9bcd7a65f64d07cae63a6ac474f6099230f8d631abbbc33463c4603b578a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abd37b2cf21405471e1a03d783a1265fe2747ea553982de6541b374cad6daf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1887e55dda13515c60e77b49bd13f5d8d95c89382d1b66840829badcce717b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e857f903e5ce28fb63e41e1fa6e4d3c50fc0a7572804e94114aac20292aa48d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7d21d5fa6510847fb80776a8a00df90708235bd20a41f815218dc50015f1eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7512e22de8a0a83d9a5626b79e2b9e9c4582243d494b8bf54f04bfef25a42c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b547124869b77399d0beaa0027f2f1e376e3c764a9a50437d09965bca05052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2977639a39722e0b97f2879ee7bd48e67448d06604557707a0ac4b048ad0c508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f97dd57f85089cd4078eb6c09c62b10636b488d1ffa45dd2b5cbf4e2240d9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4febac126a870f5eac4a1a861392434fd5e9d8925f43fc6021999a984020219a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d253d92bf1edbbd0b0a1906ed64c50c469458c54c9563944f9c1c5ad548947cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4445a5b41ec3b9c39dbbf9075614c878708d808103634c6e00a1464c9e1e2ed1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc343ba06f455a7ba05f5e482706e6e6dc7793047cd67224a1190266b0afb574(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1b63c827f85de218d0ef371b0fb638401e7ee136be8f0705c1763478d5b84e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8d1b5288a90653efc88e5fe1fc3fa1521530fc021180a78f4838d60606e054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bee0d4b0cf9e300161c96331ce0fead283a1e00e9e560c457fbd8803e957cc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3e00fb6d291028f040d9249a54d1fbf16ebe7febf79b144d2494ab2c92b1d9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aef126749268c7eb37f7a57c19c4f75859e253cd4fb0bd6192b19e6e8884dbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d26ce59afb25434f7c0391c97766833cd68561e0c7347091d449a71de35471(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5921310dbb1e8503fe938af4ad4e64581e92e3068b58e2bb25da50413ec8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f082c3d88b79c03128de7894e325e3a4156c12f83021c474c7927ce68efaa8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30574c7fb98a3c66a8be6da850ccf068b6390970862b850437230f9e140422d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c31b66d70d80dde4dd45414fd72473875569aab49cdd9d6803c40e140eec64(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a1a16f12aed0f896cdd4d1d90c15209e248fd24bae575833aca084f53106db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2d8cf22d8ae42056808ad3999acbc5649b74ebff6ab28507ab431723bad078(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5681e3218e5ee13b605aa4adf610a8827bb0a61c422f3c5f1d254d33251264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9138f68a8b1a63656f62899c1672264e66ae8e989a7e6e88655ddd3e1bca2ed8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1814450cf00579ddb0ebf23c2e72823bf8a9c309b63c2b6d8d6a77c546dc8c32(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f955cc811d15e2d0e5f8cf65b35a0f8283ad36248430f15db699a137677ec7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0218546fc752cf383d88af31c6ef7e518feac3e5744ec0ca066c2912ff0b56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34055bb8799e55603f9765f44fe36f62ba594140e13d387f47640371b78157a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edcad0e0d608aeb16d18746d587f63d951c092641494bb77d58faeaf0ba8c59b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9cd1384c746826a6f399fe611ef1a2ef76de047615ef11947055b87b281872(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf32c94a5638bdb7dea2e6baff1c70059ad4e247948ce470df56658b74916cc7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a733381e689278f8c6572b2586549367659d1324bae4691e683a09a7318e714d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f64acb267e79632329dc7bb72063e1ee677033abb4ec8fa72780d500c0537e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e6048f3a53760230e895997593ddb3402f821dc005b94a746b0775c8592b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6421f9f98f28b2ce0ccb5cabdeb8d62158d70fac01da21dbecf479f4831dd3c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd470396bdc110edee487f5edd9cea30511d54bb402061886dbbbfcb7fca471d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f304440facd5148bfdaf98d613245759dd46fa4e5abffa452c8c7ae84b045b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0311471503f3a56ab9b65d63b1e743f2b0e8e5dd9449bb33c0931e0338169df2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49671c4656d91adb8528e28faf1fa242e7bb225fc3c38c7dcb5f696765182dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055a1e47b87fa02195b30a76f13809974e035858764461bc010a08d49c5cfe42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ec72950414a1e2d51f1f97389a20d05ad78915657bd65927c5008fe3233661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfcf099b56527c9cb72b99e029599cebb78f2976884be325a6e24b6a0846b110(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f185e8ee2f3f999731c438ea677de8bd6f24f71e909111df3fa59c1d5d0a211(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0782e427ce9bcd54f81d41f8c2bc7a5db62b04153bcf3b57d4ae179fc5b850ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e59207d49339ca0ca2c486138db85955fa848a26b54816a2596342ab2b9144cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658e15c613db523ac260dcc6b4f4a0c7f365ef054648abc0de03896a62a0990c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2506e98fd88767e30c221452d8ee2f9852c21b9b2332ce8fb78778ad9ba38874(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f34cf9872d5a646ab2375f9a3d5c4638a483bd7f1fbeeccbcce39cae9c90ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2fe5c7da08fb17fd6fb6284aec666c83c4e4b9305ffc3780a4fcc9212b3203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc49940bc0a33d5e474033b85f6625b65620c420e5343d87d97a014805c572fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71eff7ac07fc122cede19e021ecb54dd13f36c98c123af286cfca30ec42ae1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afac040bb70494c2bb82c3e24018dd19d87fc3a85a7382f2a226647ee71cc30c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcf83bc83aadb6ee236221355dd0dc6d0d5274f953605127518d757539faadc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c270d53f0868f100cb45c92ad68f7dbf70e890367bef53743e4e63a49b9d0878(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b659221b733eadc78f01ee0da7d8893e7db19b08e2ac4116f595ba0811335836(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71dedafba9c5b47fd9eba623e2d7976134f396a3984d04f14137e8edef8a550c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7791a5d00d13c96ba8bbb8ad939dfd864cb3427b2e549d18bf373eb6b3bf2d97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1326836e024ad3fead55846359f3ceeb0b0d4fad5b94a482afa3e4e68bd92e5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10db5f0f470016475aa1eaa4896dadcd680de0597651a1c8f92fa47fe73598dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8038e305661dce266551f00343d4ca8d7f3ccdedf39302a877af6ffd94f8ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e2aae20f293d4d897b4e20910f6e000f5fd29e4f66bbe5fd047c5bd8c79f4c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c90411abc4791b12a56d1f914d6b630dc6fa846f0472a9ea8cf1e5ca0b945c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec476633822d3cf245b03348df1929f1828248cc1740419fd08736795dcfc43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56068a7fef8268d2daffea3abb94672c6bc0d1ac8255746913e90bb106f06e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ee6802c827aa59314e929492840b58ea1bbef4984d31a6fc624994224f21ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3f4c623eb55c0c801984a3f932dc58d452c821c3c9e37399560a0b172955e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__286d58cb77ed094928288dd830e6f3d5850325cc8f1d85b7036b82406d2ef840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fedfee659297697fee72fbbfc1ba2c5599b1062853e8b2dc11257351c90f94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__447ddbae711dffd0fa84761dc010b0a825f194f29e0667177d0f4f3e9959e93e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f6bbcdb9485bd2818b46200cd414e2d140bc2179a9c1e4daaf0f1c166965ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777011a7d78e6d15befb793d717ce612e548148edd4bd2f46a69edb28901c2be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5684e40ad025556c392f508d461ba1333e8e17fba0917f9815cf9243a6ed3d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba036943a1c2a51a339715c49fd934fd6bc94f1512567794eccbc8ad0b2f8f7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2f42a1aceea9ebc6b3d721eb9e3e7b4d6b573919c2936fc1cea5c9f794fc73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50139f7e6e8f07e82ef98520d32148c15f8711b38ac47af5e488aa023792ee04(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2edd601759c6b0d4176fe72de439c99f2ed91b0853ab736e8507f5e63968a48e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994152d284d6137a005f3824c7ed4edf7193bdafa4f3c1fc9e215ed6f6b25e7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7112a0d01c6f07e1ea0e6b6f14a2125408d17064ea52957e613f14018e7c7d75(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c6365df8a6e1d1cd0541ba6495e667cbea06c9276544dc2e61ec750a8578ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a9c298961810f5a8aebcfafd9668e74274c75c849abc18e379285fbae9d56c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe0e1b6665c9ca2d5bd5141aec128c0ab80d87c245d8faef83ea90d96b1cd13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06efc05a848b537613b8beb04590466a36a2936ef0724d49369fd93e36f808a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898cdf0d0fc47ff0d5d6b6b13098788d4190ce5c960207b16b8003ce6917e1d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c7ff12f65a3c1213ea673825b6d75b03d60508d9ee4595c3bec46782274d97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa714696fc986ed7ed1ddb7e3ddac2923e6bd7430b5f6bf24d04bb1d435ba4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e147a765cd86850ef232c49e27c83131015f02f94c1171aa0de8667778fe27e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67f1fa4f5128dbaed66e70771a3deb16d70df8b50087861619941b7f733e634(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354c90a890a27a730b1a69c4689eda3d9a36c070594c45f37aaaef84ae26e25c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784898b8bb766d1eaca12b95ed68b6d8dbed31ceff120da579df78c9d55d7dba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e169e3f34626c6971a54196b3b5785f0434ca51d7c18750d3db63845b8325583(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7650ff6a7e4f03996cb2cc50406cca3d00e5bc029cd3a1c211e70ddfe912a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__795061f34690aa32b1701de8acb5de7cfba3cb3b527edbd6a785bf0b6b0563b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d0543f8f8eb4c9f9d06fb415ce83c9b78b170e855cf596638478303a4143a63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d21f837eba1432cf708495a99144d2a1fdc066a8a814482e3f3622526f2060(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88174996ae5050c47902282d78e057ae6119a504b5413adfba4798d470db6570(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b3ab3bd49f5c24830d9409e19ba6476cfc7570d1fa2095099413bf25385a10(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d597dfc98ddaf2380a5ed439954f40193c22995e125dcfd196685a7b108b97a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd182291084d9488084ae427f5266c61bbe44cb1a228b653b3c347c618ab56a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e962eaf7c833cdfbbf4000607685418811f9bf048eb8a5a65fc856ae521c3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03eeb3c2000dedebeefa985f3d9f58e4f76c67e4595af8a566bd177f3ca09b39(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5752b53df1232fe40d504325ebb6c0b5fc2862ce7ff01605c1a9999039fa14e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64870d0e3d8f876caa9e094609a6d0785ecb6c775ec77c6c7dd66e5fd00341a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5bcb1418abf26354cf8e51312402fcec3b92c862b7fa92cc28e3910b7de12d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5755a80246d6bc548e66f6104e8cf506714ae77bbff5ee752e14ed631c7c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f660f302e3929444aa523d94a340e85805a14e243f6fb42b6f944b6d77cf1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90398af8773879248a2743183b671e78583b85c8d6dd3146a8e3f0802538b959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06ecea74c5a8e5fa02bd793bdade0f0b61b08403fba0824624b80934baaea503(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643605d3a1e7a928a36118275defd4c1bf7dd8af66044c6a6d96e784adec2e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbf6e36bc8c0cb72303378ea94b7b87eac2b51d7405880fbbef83d1188ed8c9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfcd0aea79ba92e3489ce542111d0557c6dcf0a7b4a61b4f340d249a9628b118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3531ef96bc3a379856028251ca3992320cc0d8281cf6116bc0050ea293b668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d107e5f23f8f86e835fb308ae9b7320295529c71490483a0f36b7f967e5a2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7acee9e261a3e043e1a4d2bfa3b8fd195bb3cb5e5816c7602726c1d47d8e28e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb772291f262fffa3ea1645e1f5b03dff07dbe815692e46e31d046df5412b677(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3db787835ca660ad4929681365fbd3c7c48b86633de57a1a4ba894d368a21d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2e3a3b147f56dc455df0d67036089e0c786a5a26a8908f69e4a661456e95c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc1537ab4e0f90ae760f3449bf4d9073d08fc380e31697d803be8226cb31988(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90952c7bd1cf040d1c4c2e2f9e56fe8465d4c0eb5168eddd2c00f2805093c977(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ccf85fd4cc66b61bd6b1cc5a355338304659b5aba92e38be93a98e770af4932(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85037f1531e0a2ede0c9ba0bed8db60f6ae0d31b1c126077faae3029aee1e4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d89210f44c724f248702bdafe72838f4b2f05ce200bb28cadc7de1cf0edb67(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9795272b759bd565261a103f26bdadab2d9dce9a7a3b441e1d8ce4d97eec9af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed22cbdc00123b4aee053b15383758bf72587eff07c421e47d0d93ce7066cb3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__660f6d7130126b25c23994aa1163ddfbd186b2524d71930d5e49e39f04110c11(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c662d504575f247e045d4ef3a678d2a696593e9920f2e3053b864eb688126c16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d69cdc82a57b6f9a1631af674ee8b790328dca30b969ab04d0aeec8904c560(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89b36d22436aaf66c898093e1516cfcc1a08cc9a23b1c1e93ffe8b373e481767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eda8d6f4587f2130e2b316d4d485f5e45929802d3a859c5e9e8c2d6420360d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d82bdbc5f9b38d6436f6d3010831b2f8dada6ac001414aa6506a53fb550b604(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d40b266577b312b3ab81a27a123e40823aa665fca1bde6b0ea7061a6198d43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe999c891c04ec39787e63ef1fa1e0181faee189236590b9f198bad4b200eedc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bb9cd948b41da10659fb643786c27f3780967ddfbebba4b3d16a92f5f1b5eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7614229c1dcee83228cf75c2f1513cb465770553074ed905839755bab5a45076(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12ae54a82022577ad342b7e8d46113aa7d975fcf435977c388ed5778ea4314e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2460ab4fce854c14e4a51ba928ae69ab495cb26846480755a91aed3c1be2f3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41cdc1a4ccf581902ca7f3586c69627f659337c971f84fb938fef7959572d02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89daa7bd40c8aedff3ab883556d7780216cdc9caf32721a062777b5e07b6dc9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52c02bb6555495f9b52e7f344ea8642fb01f0cd770a1cf93bba8d5e475681e1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548b7e750991123c29c3b5a8768ffeed993e6f26153738522573adfc71f8cdcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf704f951b87855cd5165cb15ffd525bdff98116e997678430413d280a163a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a787b6b17e2e371ec6e4f7e5cf9ef535911146b007deaaec5dbcd80d0a47da41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c43a56bdfcf18b27e3eb549589d992d2e0a5b8eb07d18ee382ab96a6821a704(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d26847662775dddf6f0e76f6a23f877306e557e1fce5bc615048d723f1ccff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0175157f214db7636e72973e2690f32de244ea59621a87a7d7285d238eed7604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecde6206272349d5f4f52166609a8eb3588940295308c3ee696dd28357cb2c17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b63267d67573eecc3588b67e24fc5931f74372dd9104cb5225647a4638040e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e198832ba8f468e5b368554f97938056783eb36d4b2ca682c07437a31e8a8b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb257ae4e8e128ff431d3d1d7f8dd4cc3d68cda0679f1b25539132f065c11a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ef13f998556e1c4ec33b29aec6b2ebde21a9a68b4e56506df18c6ffd0e263f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2030780cae5d28d9ee243c287f74b3e0bc6613b5349fa8c94efc1f069b3773be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1023b0ebd6d0a7f084f1c73699786241bdf2ad67a47708163c86d6f7ce08c60d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5022599a275018422f49d11ff91a6be0af4719ef6f729249ab71153eb89708ae(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0ebb57a341e72179c2d6069ffd9017d23156e69ae5992c750836540f83ad85b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f992252c79c0ef6dbc935a6fc9feff7e04b0dfb17b7567edd0ed90743aa128ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e240c957625178c2534e353f3f03eed4baa179b3ffcbf11996b90976d1284e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf618b5fa71cd5b8ff3ef4b940daa859d75ce776425497777f4ba5fd24c7da3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1ba8aa1d2b463e6b49d32756197641023ebc338de1306f1c3770b5ab8af251(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268618992c46db6943a4abb37220e9530490184bc8b77d5e02e67ed790fc8b8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3f0678504caa815f2827f71b007362f9bc849b6797e8a991834cdc4dafc16c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74a8e42beba6829c68bbeadd3e997fd586a917e00c5063559ada7126290a77c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3996b259ec53dea32b9e5ad90f155a9bfc2c57c27a3cf2753063b33bf9c4f56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d4b7ef206004a6a3e73f9e2e1dde31bbf340cbaa71941e13ed04f49b7f1baf(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34b651ae7d5019bc28c876219da0e45c47971430931af97dc2b19cf7d5bf826(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46d765e6bff28f4c8f9a931a15854200d8c260f36b5f9b8bf522589051d0cda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3ee5791aca5fa79ca8f0d248a09d1296329b123f1fcf89d18c8b0bb5c74a39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b90e7b57451d690271f657ba2ebca4e83506c536ed6c8ff265465ccbe697b41(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84586a73d46645d4f2aff8b4677a25a6cc7cb9c3032a0faba3ba2e31ef1ed04(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188974b45b4a55f7f3ae2e0da4cd18e0bd7b7c73268a86be62568845e174caf0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d03d2394ac6194e7d1bb06f042c1746784ee921952398fe76cddf8cf23448de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f245ac192a309fffec0f0e186b276adc4b6ae0d238df1513674fe129d102b11e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5df5b2a7c4d46bdb912578e28a14ec33c7929f4f9d29da77a423281435ed426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bed25f0ffee318e48299af8745ab721efbb6d3891bf2580d42cb0478fd1ef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02113cb1c4acf34d1ff0a56e62ef00db83e1cb3256f91998093cbfddcb5ae25c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06288db82333209243e3910f01ef99d063e6f9a0c0638cb3383a488c7e360f6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e5ee21c61729664f47729989c4c92583f237899f5622a7a06883a8972322b9(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39bcb5eac1edf558c44fea1050ef59dded4ae794d65906fc6032a458abbd8ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8ce4422424006016caad1b68ea91da47d25964eb2eb5139f3ec2933ae618ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f31d9bc0723a545fb63de53750885030e1d6ab345341e551a652ea15eccaa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352a3384b2dd245a07cee87ff39fb3775c7caccf28c913474a177e0c433dd055(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80cf8325144fead7db907e5a0dc02d2d7bd91d4d8cf7becd4788aad7dd58894f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762c7e897de7e064801a03db88e407830e9dc1d1b00dfc1494c7587f49df9c95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7892402db7e5398ead3bad3042a523e20743aead1464ecb8d7a7757bcf72f97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7931a972488da7b7d55d0675aae9dd2239cb7ebfb6cc8d8e0f035152ef5ca521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03f6b2fe46a58d86a605f3f472e26887752947acf49aecf8fead6a2e9e1ef67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc7a08013aec71b8fb5449cf8de72744a01974ed22ea5011d7946d790eca656(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a736144e80df4b4efc1984c14b254c19c75c5cfd8951bedc43146e23c217943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a8094a1c4dbcde9e0f9e3464d8d313ff750d56fbf5ba0c196e64546fa91f2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c88177a8e87bcee893bf874df5404323b0f1b120a92e20f0611ed2b5b269fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b361c561d89f16400d51c17d5432551565279a5abdec5b9ef4cd4bb3b650567(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147a0a3b1307efe696d91f7b8a5f41be5a79724fb7e44f30bfb9eb2341f435e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce87bf6866db6eeb5695062b2a96ed50941e8476dcb1b75c6bab9f5971377e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea853c18c8a1961fdf5648d00cc8cb46fae3847dc35019ec768d647544427e6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fa28ba3192213f192bf9585aba6d0f3ec4b17862c26765518adabeb247ad60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__979f37450afb1b9923146f54ecec9ccea092a7667fdc8df7dcd5cba8a85157fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56381aa2fdf98e50da6636eafc5769c8453f1432968cdddbd12103342d93d243(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efeeadcece06c6295bffe95207d831a073af79d738aad38c4b3366746eccaa59(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba59a4e00a263047e2d5b282551d1adb42229b8a572aea19ab0c1cf59052ece1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70ffd88cd9ac731d7b1986fa9229ef0a5ed46bbb5cd5e7b922183c80364ee09f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ddb463a1b44b393ffe8ebd9fce5e954ef22e3621261f438081cb6f62b1ce785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1f4e5b95e23ddef47f5a8b9f5f654cc03e8320f05c85b74bcd5d08e3774b2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6aef54e7637ab6710ba0ccc63faf9062b4e143375241247e3952990f7f1646(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf766801bf9b42835d238e997d1524260fcb62c3ac8336e1ed2e0d700ce30a0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7924d05f6c87f3a4e6fceee9a0a8ee9c95e3068d255b1ece26f2d51c10d9f2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6572a2d22a2fa6a66d4db4d20566f0bf5c26b4294744f5eaa71f87ded7325b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928775aaf586eed1f29b46b554245afd1d525e0a869c091bbc5756ec1c7762e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__356cfc85a9fa8be72105fcc906e585c41aa3ef37a76b29b47802a151c347a366(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc6a5746a1cadd92aa631c52d7e913e5fa4ef5a586c4d011f0cc4ea9cc4db1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c78f0830716acc54d96c3742b5886b0a7949dd32d27a0b650a8b296fcc091c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebd7da8162cd101b22fa1856eb06cffab78efb77f15193adad72143f51839af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05395bd7449c74a4854bb8806e27712e920722d30d56d1bde428b007daf89882(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5838a3c41568fd083f35396aa946251986ef2ffa9fbce67b2a8bc949baebe3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2121f58f6faec72c9c2832215b338eddfd13a1abca7a0a8192e62ffc73706a41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da36c33c6c899b221f506ac2c79d7d8f8f531a755c885f8689e8e32e0848f788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a12718447893dae223f3b33920d2b289a3dddeb9ba92ab45bbefae7ab5b549d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8a331e25392dfa52af2aca4959989b1dbfec78a19ad8873d17855e0859de8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df3bad9dba909320a7fc539910c8b83dbf06ec7843191759ae2877e1d90c3fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a9cec555d04524099c54f573f806aa488aed4a3f3b81bc716c7b75564b095b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a017714dfedd7ed2992d139486c98e6205281a5f76d6a228af888c442eeed61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a43bcd1bf2d5248229ddba9b1397aa9cc287ea82818512fc99e2212713fe1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c342f65b3bf735daf7b6661cf051207665a59038d8e47201310f6c9e65b5ae86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3decfb050b5e3450959932af1ffabb7ae48942098f240322b8b110b4b95c94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d68275e91300c2d60d455dcbd44e8e7759972985d74c11d65c82e2636f5ecc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d30af5034f5375bd22e1754e1646510e5dcbfc8232e7ee51ce943f8e99c93bc(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129a0cc51ae67af8d5c2566656ba320cfafd1d48ff64546fe33460411695739c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f4f9b14f8dc20841c6e2fb399a56ec1c4b25a56d0f3db3310261b40847bf08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703fcc7ddf94233e65697d7e95c6aa9cdeeeabcc6221cff1b039c28272c2b420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc6dceca9a5ed53d19f90db80a5ae05f46c7211a37d9fb4a906a36e855a5224(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43435163e22ffa7a7a472b94e1ac46196c46c17fd59563d303bae5dbfd790210(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b81d8ef786739298ab5dce238186d4bd413d620e5449bf3ee260f9f5c82365c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1df20dd311ecd09bacb4849807fc446ab5262773ea93b69c31c55f7a90d4ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2ee0534579cd79d33bd098b22287825d541ea2b3686e156e0dfac981660230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d81ae023d2830cec076c3b65e1e6706bcf6c040c511cbe160f1eff354a33a656(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee705a92e4ccb21cb3c3a5118bb925e6b076490cb9c671840319abf50bcbf200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420f5d470cd1f44b796bc9e6716cc18ef52e9331ceb23592278b0ecddb87d537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f9795da44603d0e4f40ac1f7272a5adc468e2d909e6bab9d85181ff763ddc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67652a5d123aed7a69a5dc9f239fd67558d8b6c4c08fb94cd8087af9889fce6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e51a3c07bc5df15fa3b414624940fba9720dc5f24677dc1a83012c5cac2db0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b11d4a43169eb964b3f37a1dc7fff15218930ea88261875773669d8ad2d56f9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fe9c1c14e7dae1a6608ec3b7acac503f2db9780ded7414d337e833dacafb2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b111dc1c61002c52d38aa418cf926fd0c3a9f77f7a738f4601a4f4593d35c9f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27089a0535ba74a72ae9e7211c0a36de10b5d8e2bc673d1b201cd57da5f967e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e837d680492fb0deee3d1bf8146783ec0eb52c8e44f8b4021c5eb49fbf1ee1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7b0add31db1f477666a70d9ea293ed73ab5daf192b7a1f971f7930e1b20ead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fa2e9ed3425bd28bb619f7a7b5a4317f84be465a35046d7499150926a62e27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dbcbcde22651d8eaf2e5022743465d2de8a0e469aa0ac4ff3a4ee3f71f74b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9df7eb8567f208ca7cda940e4a9a31ebe408dad3bd294f087fa7aa28e81da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bc415e15315dd089bcf80cf482d2a1966e8de2cc0829ec4764ee89a643b305(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ba770ac33f725db169e4195e725a5ca4fd4dfbb06e0758dadfdc9f262ba5c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c586b878d987e9920c13e18b16a00433ad9c4a2306d658839bd3be0bfc8a989(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278d39d332ee2aac2ac31bc90693246c2b2dc08061fffa217e7da22c40e98f2a(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692c06a1460c765a47b33eafcee729a9dec2479a6719fd1369400563b3210608(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98271854a1087eae226680b9f16200df448c48260f6ce47a265670c1589f633(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4088ca3ca7b632549aa28594193fe3d436f3d7666b703543fc381bd93d71f6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fbf27e858e7c425801b4e1c60fe579517f2e80a453bfa7458d42e539efee6f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c231a94920a5042bbd74c9dd0fb3a33d2043adfdfeae5bf5de05458600cb73a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8813f20ed8acd1e0d8282d7f66ef6566ebc0d075b725af89b920c322ceeedf3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc53848029a664f052aed1a23fbf9674f022e7a0e1f97848c8cbe6eaf16e6a6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30709edb39e3013683d257ad1ef17b4f7fc9d3e2c2cf4db37181764dc2072788(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d7cdcd1c8cfb63f04d730e3524bb179ac7b0c05859327f22c4a8ff2945106a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec90e97e391314d499cb02fb1d1310dbc1142b273a44b8b39e1f000a3504807e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde996f5a2d3e6891d1aef66c1ac7e6203d124876b467079c521a0371e002955(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9504aae7e2b294d0bb50767f169a46331b5c3bb7b6093c293da359ba8b4c1ce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f425a174184521428ef46f1f242ce5466e2180edb9401f0b30af40b44588bb5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4ae628cad6c219b8a72c0072af6c7c1a35d7712ff8e4b7baf63014bf940cf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33c25cbef998ae2ea6b19729eac6e165f3488ea10c86c5471b6be0e09da0811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e44d3dd5acb6e6ac288cad97f73eb69f9e1cc6e2d0a21a284adb326d0d22af00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7269efeb85a7c54f807623500269ceee8fe1f23ae75ad698f4b414f49c288b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34dd3e29a0ee79d698f53ff2db418f6029f4989747610382e6f83531eaa084ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c252570ba4a99e0b52ef7a29fcd64dd5536b1b56a1c7cfa141c8ca435562d97f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e602c786c680ba48d352ff5198c078a45c2021737c016e7489db5b434355b8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a43f4b5da5aeb77f46d28a364306df870340e157c07fc8571b2c84d0c55233a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e3b4e9b906b37f6be1b39ba14f40ad82825295f34b837069360ad9af13a9566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1de9ee3013141cfd00ccf1f4850b148971e31973bc12e5da1f7de8d1a10e06(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc8059989dbdf3a3f529dce629d4f7112e4222cb748aee06f7c644e447cd9eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6b7bfe2afe54156cb2fe0b268fe00be2c9c311e170ca861a89cfc500ae62e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c644a7f36ac8c08ea188d92cd9dbeb38b2df5f049cf1199662dec105b8fe6e12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60b6fdbf551e3f63c31ad5a6779e2ec5ddaa6b1c442ce2bff4907f63500e2dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a11631d999f184d93878e4751cae72cb373f9eba7e62336af3b383c1671380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b456b490a59dd0645bbb8b8cd4fce64456183b674a116ac45a3dafc8b6e744b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6a7ecfe6a41d322e0b9adf19b4e50684efd2fe9e566bb4ccb144d3e8474ce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98fd8f5b1bbaaba1a89f4016045e5fbe7ee6df640eadc1788d36627cf5c9d4ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e36ced39c18b494e07013d751292c5379adf56ffbf68977ab00d1cbecf95e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca05c522533818c76b626640657ac8e727e06d4815c519971f3716e261ec4656(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee9026f6fd3e30da79756fd0db6c51bde43ece7ca79e676383b229e16c1d145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1791570a282ff5c425aba826c6b6f67e05546311134ea5f4fe72f54958102e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aac031cbe36b1fb50955099299e1502ba2fba728e145aa1f4433fb844ac630d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d2a15b901d32da23eb819f3172179a4f4995206c8d05a01a37c80a8b49b5ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16226827cfaccc423b87e33d39c1af1f5d91e4cc6257fc5278d0d8699ba20482(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46865a261806070bbf7b83584c22ca30abf5db9422aa160b6efed9b111a71d3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a03c0f9d8294f18d1efc65e8233de752c04c5705abbe21a4aafc134727443bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da179cbb9eaf0a03fcc6104212dcb29e299b69e270a63dc59c0b05a864e4a49c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e150c8b87f34e169a91436dce631303ade96dc78258ce644b36281ba58fdd7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76df48f247278e5d3e3c22165afcb4c901ae21539894fdf3d2b078a52c93f1b1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6293b6c399a8cebb8fbf7e27dc0133834e22fb17f6475a36472358aadda9129f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e761d7a7cc803654bf76693c9c6a0efda7c4726648d6b07c4785b751be4b50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6386e26860554ac67788dd331da50f65488197fe46959f7805411e67ea6b1e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15857fbf1b56eee0915d4dd7f9daefdf18c39c22be28d4da2fabd0275c2408e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251c39465e923c1c9c1bd6385b1d0d32d9d32ff176e8dc0f6f23e3b5e63c4180(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701c0d5bd4cb10a0a4909d06b7a20bc04b717e52c19151e245bf15e2acc700c8(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e151fd67750782a1cb18ef4ec2fd531532f17cebf7da185f836ca60d5029f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba567becc579926feb6134b45d6862a28b44a26d69979d37e5a6eef314b800d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f427be7c2bdc6144f61fc3500d5ab6e44a154f1d51ef55277f37ef81cd0ff72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42cbdcd364d5c7a022d0565290077151825fa42fcecb3487b83dc6b10437db6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47653a638b48195df200f76bc094986b38938783509683e849c69e18783c6629(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8a3f375eefdce5391b14a5f5e78c9fb83a5a87f492416926ec66c0ad70286b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6236e4bd4fc608b75e2d339b340657b5a80a2f7139892b61c9ae3896af859613(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3c85159afcd0ba7ee0c86c034cb8011654606dd5f245682d528412089fd2fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a75e6704e671f4cbd2b77f15c6a9e0c808beef0d59089416d5d1a8c710f947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e05bf498af4f922ae9a87831b86e1694c861b3d7a9565277217629b95b6225c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9bdd4f4a6402fb643b69e392965f5120be2bc5787d749e00c4e5ec0f9d5865(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd4182083ccf7474112a8f84a9cd4e040b8da20dd5d9c21193a19c880e0473a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b535d8ac7ebf914514bec8971981aef4bf5eaf80194216c6e63105935f39e99f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f826da330ec1d25ebc72b2267645d0d2f36ed7daff6e6bf93a99f907226a0a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b249ba5924229af00992c2756bb8e48346525c7a7e51e38f375469a565e771(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2d19312598266c628562575a35bc49ae9cd416945f55be5f5c6606d2b0d27d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd264330d41387401a01a5369a0a27101b6974ffd405b6f085877723c44ba99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ff1f33ff483dfe12fe7ae9193548cb71ba359f1108f7804ef86573741f7029(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e39fdbbb080eaf07f0ebf25858926d744382c95db0985eaa5a87f283df33ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7f2ef822e7cef3a483fecf554f737f950ceff77bf4aec3aecd4a79f6ae04c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3acd49c07fb6114000cff48ba16f6a2b97a406a382e980bef396eaa2504050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f993dbcd00f2ea7766a8b5692a8d4a98a3f7b7ac5cc4ed2d4373cdbc5460a94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff4471ed9b21e07d89d86a240a0cc7a00560c26b41e158545f0ca56300b0aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cbf6bf25b1374684ffb3c108342974fa3b9e07cf2278f2b2cf19ff0f94af3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b91dc2d22230c0cb3edd6e81b59f581b1ca75f06288e0f94a9f5fd801e751e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c2554dab3c5b8d3df1a1cd1c2e450459c56586491afd9d2d6559c039882b4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97bab305d4a780dddf6bc3e188db732164fd56f184fe4ec533e2b53ae2913c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d10085226827436b9f3e5745e223ebf4702e30ace7c1ced09ade9a47ee7b361(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17e91ad64a4bd3448641dbe8fed7ce8b2155bc65603fed9d74a18de02dc8d20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd5cca9eb37c5e57ca32cb908b6bd8f98ebcc7a49e335f237044d834dc633db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__092a66d1b0256a2bca6cb1eb84e6948313520912a96efc7592434082bf55b4f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c524a1d215eee3383e257617dd8d14dc453846113813f38dfa403b52e9269e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478e91cb06ebff918a5094e88a545402c06e615aeb397080c31f0ba5b8753a2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b5de646cb20c95e499cf503db3ca6c449f223b9322e62367a4688f12cc11e7(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2835cb33ef130af592d7528f387148787eac75e5dee6b97ae1a497a075163aa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900fb515ce3f7ec0572be3bde22870c974914e0c88e5301f235f849d3c61a262(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc078a575a988b92eb31bc7dd9ec37d5c7c397571e9a45127d23edd856e5a69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c369bd71cee0d29beb7778c14b66408c325b38052cca0c00bcd1755a80b948(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fec5ce6d19aebf206248e9e88e9fc0bb23ee9c5e130db0bee59981777c839e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9e6a12762ba818ef0d5c55630d754159a880dad116241c8cecc08adb33bbc9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a5ba72f71f191a7f194e2282173acd28099dbcae3d487d8247fa797a758882(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f7425d1a93060123162845213a221879271e23d8dc5abc8eb1f1e3e02716a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7179ca65e397a557f5fdf8a772af70b3d9b2569e4606b8a54d701416fc75f754(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2fdd1a905e5060c2d5bd2004832affc1101130c109906a0b2bd6c53cd59c06f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e070243030c3e417d21a24b91d445d688ec0bee9c05d6d4e6a843e9f7f339fdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ce910310ab736733068f854c0c067f982ff7b97d6609fb215127df41a4e71d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef07264d0b3c6d94ddf84a706450050d7e1856603122f7c9043e5147e6df42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e383c9d64318341fe18e6050b17573f8db630fba06e82e9fbe74423cddee2d8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15af78e8618423d83d8b48786cf6661f5be6f4b6d39d853ec2df648c2d1157d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981cb57d8aa81951522f2f49601add52b85601f30e7ffa9d99eb453fb683298e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9480d7c751ad9fe053aa0e6ff283a5a27fd4005130e652ac3720b1d352047eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba456eab0b31377b3caa0068753dc74ce1360cabe4a1cbdd40d20f645f6b2778(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ab8aa465b50da4e92e08faf69df90afae97cd9bbed51e7504bfe3dabb09b55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8009695b6100b0045a52d540870ca223e73d065c580285a632e8ef8d245c8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f94b6eac514a7b3da08b6c6c08f45f96f24eb7aaffa5e2b38bb59ceb4b83bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2f8b0aa04dd98fc810e5033f68b3d680a935a2ab573026c8f2711b0f81a7ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11cf0f215bdb360fd1166dd841baceaf4059e6ee6552961a0046dd2ec480598(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ffba19236a2d069b2bd8b1d68e04e8283bc52ca2f3c1cc54c35b73772bfff6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e7cfab01e65d12edccfeb8f1551237ee5cb56328c99a114e532f762098579c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94daa6435fb0cdc838ec85d7945e70c95589abeb1e91c75cc61418cdb7aa6fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4dc2c4769f018599df6e0b4e53dc4f40072e5dc81acc62664ab8a30c8308b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb8aeb09b6296ec14704b4286761500fe42217f4817e8bd64c005c15c5880c4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bdae18390716cd15f53a5e7534107810edbbebf483de652cfd00a4101db332(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e23c3ee8fd7009ac0faf750a33ab617e430f614911507371df0a195248e96d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b00f9233e9fe572ad26cc5351f494e5740818ddb78598d408c8e1ad50a792f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a16935e4aa3c1763c283fe8f9b131ea8b2e57fd986e53a87db3bf56673423df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56cf33705b1c020300d4445b9b78ef4b637d445c58861fc10b7f77cbab53ce88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__795eb894d8aae007687a38422ad9e7cacf4a7c744ab1e68d0c842c32838ffac2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d485b70dfa305ab09154357dc8f655f5b26ce51989e17372a6c1e8205467b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02048c25eea9736e6fc2e2e1b534593979aedc815f7fe08855222b89a2a5c8fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1cfaae297b74d33f30ae2ff27db0495c5537aa68673a9afb0943463e70a355f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d73ba9f7c43c8c86cdf6f409ea9d9fd3a9f6792602329716b3bb8cb1118b3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f88ed9f566d9af35153f36e27d755b23e34310a1c63fe61222cc96faab3f50f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec43c5e2d0556f842100aec7a7de8a4513503ecb4ed8bf5fe9f36a3bebf1755f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a767cfd951e7d337389a6150cef65ef3956866b6ae9282a4b93c2fde0a2d53e(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526a23b95e99c29c28e25d7a8a9ee0613f86ebe4bab1a270b59a063b5addf353(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05265f04e06f81cb01bcec6ff99b04eb235e4dd6717bbeb0f8cb40bc6f7ee23e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee802d1121c081db1c0bd53ef499defcd63f4c51c373bffd030fb908af4a1660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2881cc0714c7ab98d9d83723e04abe4e0edac86695c61c0287c45c2c701fdd0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__953198da7042b639392c7308c7840028a5f5e2c1fc1046d6c75e5311f1f784b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77f22d523455412084deba5e7acd417e8a59449545ccd8569e21758fbd4c0aa3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f544c1a8e400cbb2c1b6267b659cf0418e56ec3e689f7b25c5129fd84c2cc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050982edcb8c4a373c3aa2e7b2cf646deb796060f5714d061374a20d80df2518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a71433ba02d62ab0f99617f3cd907617473a5088a4f2c8880ecb7c8549d087d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4379409f246c4c53e7f3a5e05a1186a82a9c5de068827f6d764e9605be06e3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c037cd8e17b784c8baa4309e98d7ddec362940556ab6a7922dab4f6720ddf55f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ece11dbf993952d6a487219f8afba94598e93556f3e3393fd52ac0436c048e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ac9b89c2f6840890e3d71e13812634d4796780811951315e7efb40c1205754(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706fd56a9acf6557501cfc834451b577a3e16e62f52757a2bac015596331cdd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c1e08e7a69bbe3a03c8b4dc10e9ac3ab23c43050148d55811686bac8ed7ff5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fefb40270fbfc7db28d3ad0f9643c4578f64c598e679869ab98d7da9a74a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6bea646e6af224474a887f0db823379b79eb1cefb33b61bab77a6c5d2e1a14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199fff057d371fadce3b055d1b28474a079031617f9ddda4c5702c374aa009e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5dbbbeb2bd63d19a8d29a68c377597707b236ca47985cb68d2d5dc77ab190cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad0eba3a20bad8704a1f6abb64e1db66fa9adc2bd567aea6ce0d7d69b74746a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d809bd62455442d1bcf9f7d3d5bcbeb610e735765878b4ffb3cb71012844949d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af289a7602e7602e929b19a1ce4cd38b713032b9b5b4dbdd770b99415125aaf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8210333772b8b802557fb66ab7960533f25d84c1ab3305f683195f42d1738ea4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54cc042f42b758f774ecbf6653884f43bc7d1ec5dcd303cd8e141b5ef7ee15a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06e2d2d342119e2e9fceeb1188703658f0d6960fc7afac6cbb5e028c5f64cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7570242b6c2438289a92ab7d149e7495cb5e8096a4c9d1232b85e898753a53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f36f5cb21180fde7432b7b7b3fbc440508dd72ccf080cdc18df6189c6142f01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa33fbc476b0b592d6e88d01cb99a4915b75604d04e5e15e54befcd12fa75f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0621af6b460105ceefc8eddd7b7598a89042cdaf653e66d12042e093a58b15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b515cd5270bff2a456f485ef17e171d3bc28caf085c7ecad77b1bcfe2015ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0755efba9f0e5d31f1ad76ef51c7c28006e642c8bd8f000f87aad073a0bed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e0a59d0439794740a35ffb87af3c5de8d165b7f653a1351fc7e8bb39a9cca7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de601002aff75dc00c209a7d90ce3214a23f990d508de5c8dcb53431353ed027(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5292f465c0e8ba01ed1a8ce9c31833a15846ddd7d58f8db504ca36b905aff7c(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c69e964f7e6d3b9788eebb6cbeef71a36bda39c178e9d01e9a84783f06fa930(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16205dd5857c1f4169502aee8ee6d4f914ff01e523f765f7cd14c5087f78f04b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb047f466928c33b1d414cba6cf94dc2fc6149bac7c5499a6b4fbae2c9dd76d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c7f866399a3158ab258384d44c7e26a2c33cfc78d588876cc186762ab2499b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2845ca9f41b7b4e09683a8646803f3c38d2ea877a7f26bbe1bb1ba278c8d82e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c652c05c57d7c3c7d668d4a667e7c92f626db0b4c489225bb74c9b5b6c3c2da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f3d7d17709093da27888e2aad89f646fcbf077ff303783504ca94ab818b099(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f26e21d4f82cc70ee768554f204ac04737df087ae5ada97cdca887c813d99b93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dab16f470ba216cc1b4ae7f039788fa6b63dc47abb1d553f1c4498b65668328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f99efe55a1fc2b7a143c688879893089e736f7b8f12fa35bd9290721f30a24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb670e6de9e34f76964f2cdc8b32d78ba2e3a06df59348726644cbbfee0de34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e55a473d86e4a3c028832d4206b32128d3bf24e8d33acdee51d16911c2fa790(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368610ce8633bdae4b4826034c81bc282ee5d7d80544ec5c5c2b7bd2972f33d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ad68d5d4415319c884491b93ae06539e61a94182836ee819cad0fa21a3d9fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3287d31f9a845f6ad31884a762750ce27e44e000bab1d288693fd845b1afca96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76311398a830bd23375987c5474b6d29b2224fe70aaebbd68cb03c21e756a216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190e0822679aeb3a491914d1571101931d43c6b541a374361104f73fb67dac8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d623cdc7646d140f444359f3caf921ba4fa4ddb58bece6a621a1019678f8395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7fc19f80a5a78d0c4dc6ede63e25c7b12e3e9298cfebbd7c953c84a4706323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ed442ce046c1712d6a18d6c804ac0954ad6d8c2d6414c12dfdb482bd3bf4f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b1be40d3392108a3eaeed5627dc2a8961181b7cc6375ef8b7dcb95cf266dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501e096dd302c243354699bf66f8762c629a85e77567f293ef59855b2b960c69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac663e79cba5618b21121f0f4a5dfb9eee41ecc550ce38ee213bfaf2795b0b26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5efaec5123a8652b5c66f75102f2b80d1e1c8546be3cf8d3e25586a1b957b5c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190732c9e59744096124665210c16dc85468e20e650c88669c99b66ace2b84f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2d0f126b8bf54745a2f2e4d9c8971f97f838ed26f6076911443bde00e388da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ae04cf7b5f64f556f6781b708aecf1ef6759b4d7136978ff94f3c4f176b1e7(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa223e136b8503df00e142a26ce79554bd17ff8fe32d31d502bd5de46d7ebbb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3146cfaebf4b29173b7d7f389d8c837d7bf6959119fbadd18674f1aee9be70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03cb9a806c56073d661e3eb81ee1978539546d274f2b20dd98758c9641aec982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0ecba38cd3b8e0380ac91bf0c7d7d9b7c9f0e986dc35d982dcae50058538df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad48e4baae7f871ac8684089da16ca582ee7104e08d0fb26cf0a7d1a71cfe4f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18415842ef36631f602dabbc9d85910874729679fe1f7708b9e1608268df3b01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fbdea4338f0a39cf11ec3b79b530849cc1b91e01416657690d88ed977e0146(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9046874a6cb11210204ab786b5787270b3e43b07c93300e5cba6bde3d5fee017(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ff7d159964eddeb7b1aea27c3dd7d5ab610e1cee1db692bd291af3771bc36f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa80b9d8a6a23e50b7911229237d214557a1a2d162ac1d403f42ffa431e4da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30414c2d152e2798c1ea6a4225f99f49189cc48fd7c3a809c02bb9160b9e02e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e8344bb53839a86e397cf3f08e2a792f3c3c99efd74b0c24570e50ae6a191f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1461a365ed95053284b791d1add7a5ad206340e651add24ed28000fafc2049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f0356771d5433069e25dd12bc3f6a157245ba8ffddb4336b0adb8262df5c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e65e07a2003a15aea5c2eaf962ee4b243c5354527a180727526b36068c0a96f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137ad7de66c8b0b48469630c17ca9b0f6d3c80a16792135cbfcf83863add01e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86ff243de079c76aaacecfc57800fc1e8aeaf3e57c1fda416856c3817e5baa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be0060ba4805730e0b784d2abfdbe8ddfe594876216a99b7669f94c43f184b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6269024d1e2d0670ff5a0b868aac5d64866f6d4f6be4ed52fee2bbae9029201b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e269b6e389734ae810be94e9b965a7b6546fc944aa1d2c5af46a83d0d9b84d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b142222d4b959a0b3a1fa183a297bfd0894a35056e37e677494cdf8ef89c7dbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca91790e98ca27be0daf24a13a2a9a337a8d9667f740519f9c08a6be69d5eeba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ce7406e268a885ae17cbadb22386007e288b225edd52d3c9fd9837fbcb0084(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec803b61243a6f04b1788e3306d23636b01d107a1eb32b62eedca384f751efde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5843fa0394d865a87391df7da2ff5eb6c97f57ccd3d3b6a0986386f769dc0e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a0aa8dba60e5797413c29cf4eb66899dbbb780c223b1ac78ad1b4788e40ccd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5509c1892b3bbb15d5118286f283839a44c34af9417cbf440c53e7b6af030850(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49562c834ec4b78289a68682d0f42d5597b29d98fcc7c94752aff4e136974c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0cc740a5c2aa29b03321ddf9cd01098bcdfb6bcd9a64c00b09ea05970633e0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544c85f41fa0a6557efaa71512eb5a856a75f9e9dbd45783bab3c3d2d9c901b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b54c70ee3d90ac08e0c0d5e845b1319c52bb2a415fb4045781f7ae4cc35b33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05de25853b2f27e8143c8f4c66ac1e75274c32237fcc0158c2470091ce1e6f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523bc58af61e47b568fbd9e4c2c44e765f0dd5e8ec19aee5010d8817538bdec5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78caa1c6a2d03e8cf5fa45a3681f10760ee75384736fe5098776888138cd88e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a064b57aa78397cd7974a3148464208624ba088373fe1f949e0573be3329a71a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f64b2c2ad93ab19bfdc6e3512a0d3449578c2bd9853515d31e98ffb316d4a50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba278c4229158225982d3b874c0e0879722590d51a869784589d6bd3b2db09e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c326199c2c5f1ee8f0eb76c9677adab488609ed917ecf16c2e29f9fccf8568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a04d10fe49b29566978b5e17f4ab8533121d44370276592ba5039ce2e31a555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c601d89829fa453bbb7fad761af2d531f046b77139ad9cdfe21ce5ae89619f03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17eae66930836d0efd3950a21e0f80b80e4905770747b4937e5a622353d724c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc42b7178286688525a25e571cba0db6c59c01a95047bbf2262cb796f15e2f62(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9c04cacb2e36d15a304967c9636a8b56f367f8a34975f38d582dbb4c591d93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f058e08cc30a89ec4f531a41cac695997714bf27a6f6acd24ae8d8e6fe2fb94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6926f226e843f671ae4be3d34fae2282407ee5417931ef6b4afd3bd2569c970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2559f5e53a1607f4d18e1c913f3b2fc2b67a3b3a28a6f0fb4f0c6392414a746d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3459d6262bc1907b3b0402db72eed6eac7523b7b639c14c8fb1ad7ef44d4121e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36dd3d0a6c714f94742bf8967bc77904730bd486c8aef331055820835f5a13b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b91f3e6c83227ba3e6fd0459cfa051dc020812d5635b10e3f7b74e153c45bbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fbca9639479c3623294fd4c6efa6689845ccf02abb0eb55ea5341d3661b130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d11e9907bde56118333b41a4e20c0d379e7d4825eac88afb5fb220193c562e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f832c57cee52b232c26540daa2e60d5ad528df951b3bcc642deaa404987c76f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3bd66c5cad4096cc384d2b2a897be0fb7fb57ab43fd78115c14143a895ada5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac540b2ed4eb41ed28b34764ce20af32476e37fb63b28a5a001619c9e28bb2c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208812f33611856fdb86b7ac287e7d88b02ccc79bb662066a30dbec41768f898(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9351c80dc0fe7cb706d32f70987f9ed2d472c8b422a8274d0e6e7064224a5f4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e61684d3af11031b3065889d07587d8a7181c48f99872ced64d3eb0202c5a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb06c15804595ff578c2b3b2593bafb9e337006047685c200b295ae1f65eb8f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2e2ba010e5ebcbc59a7cc79575f0f0ac2fa69a0759cd407b8c67785ed0ec4e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__646a02820029306eb3f5854cded57eb7524dd72c66470c357c60f426c0fb0c53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75197fcdc74335034f8f73d81766c3c765615b6ab420939afc7db42dd9156baf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a60a0d2e7159c416ac038345618f9422458922b1b67cffc3d2456b36844e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af763954c9ebbd5a9e8877932d9591a09d2028962cc83a73dc5103b82f5650b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca5a95e322f65ac9cf27efe80c88eb2269985a772ac0fee06e12bfa1721fc0c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bccfc35e5b618c1d90908a54cd30559ecfaef72954db9167e5278633ed8793(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e094923fc261051a1ce0546178725b778095cc767700bad92804bd5036d0ad53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bec26b1176775f9e72e3d5b6e4c41cb71d876c196b55f556f08bd11a9874ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c87ac46e8ee32c9dc0d16290391f7b6683d27be42067d39f6bdf08b52db4ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9b5dfbde8bcb5a2c93a6d17aace81644bdfc64b6916cb0da8e882c03088df1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c455529f840073204dfc62f78b3b7e845b0bc471dce6e6f698f7331b1a4a30(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa08e9fb83e2d95673514a032303e25722cd004b6b789722e96d2fe19fbd39f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3acd535b4ebf3189c5ef95e8946b1a3f6756878210779fae21033488c63e60(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0902a24826801c9ac5ea1b8c10f99b3b06850d5efffdc262b0dc248f49b552(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a5a471e7518a1ce895584adc54fa1b9b3dcb65d68972bc4d679c24222866d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52072666866530394aff9b5fe2926f2a72215abcdf6d106d8013877bb5197a8d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8735de1951b1dab34bbb3229b0918603de5c28cb35c6dff7b6f6653b14dbc201(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7310b8c2d998cdb4e6967c8c48d646b0a50df371e635ae2037aa47a1346e8a78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d593e5c5b47dee4fa5c670f5134bd8798b34927749c92fb39bb8045f69286b61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afb8e51556a16bfc65476fff952a1abc0ef7798cf382c1794398f2a84c8f6e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aadb2378b7ee0a42cb161898cb738af118f577b0fe2dc7d3ba8f30ea797d6643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8b30db8abb138cdb328ca39327289e7bc392d5b4067e4c44149ea01d8f5f8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4febbec846cec1eb39e61f3a4667a5eb855fce582d41dc9cbd3eb4ee54cf8a60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ce64053db7a0de30cee9582d7b143a0d75cf5c6e8eb043a506450d2c21d572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ab81b167ffc1ed4f655af9fab7df2f02fb4d0e5db0ffa2c4fc4e97e8b9c15b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1bb842cdf10cff41c6b820e9127673c0ba69a61fd7d3ea9b43f38a254533c91(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24961516fcda437886d612900a7d37efa365f424af39ad9e2801c72e655c063(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467354c30d954d185b140f3c6fbcb5505307be831701764523b4d3d040239e9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d138ed74096a15e4ff19269d356359109cee5ac3329d8fc1a691164580c8c34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719dcca4cb4916152e1fdbfb5ef677071489b860b38b872da9f7b4943e8c3a71(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__682bbd4796d20143752ff6c25f6d883b89af405e89f1671a340d25ba5c9b7723(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff643bad4340b524fe10aee6f9077c81232889b4147f84b916bf32603bca70f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30516c09cbeb6878b3ef41e8c52ddc055be99ab4536c29798a93fdbd7608e831(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1d3841cf7031ca33262033168ab6a594470c757bd0356e0290d32e370b8612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa0c4895be4d2c0e0edff89476dc92e9372e46adc0b3f005b717e8c55a36d9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd2095cb1b7e11f978355af6ef5ca78570813ecf6dfd6495b4d6ee3ee17e982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e41ae2ec2204f37d3e7aada4c314361ce7743adc56e188a420c97885fb2bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82da30249579f5926285327b4ac2221dff4dbaa3161ceda3409b5751c45c26d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be72f72d375ef4e4a1315f6f819454d384fd52b0a9ef7062f6b543dd3e806d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75f5b84db3834ef03196c17eb580ebb11d9c4717e39095769a4184fb2945b41b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3e094ab7160435f2fef1347e54184845f82e050b7be3d9b3cd37853cf05a91(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1695e8a0dc9c4e685221e65299eb860fa82511acf4aee1f4611cb49b01e3ca04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e046110969d2772991d7c13c256c983bf21bc6952d14cf3c98bdf2a09991a0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ed4de4dad8772743b9b79294068895d580dcdc160b42638467f55133e76751(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b48a58a9e07ad932c0e14af8a56a8307a15ab7bbc873d7d259e895320d568f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06ff4c035d4f65900e85fc696e5f31c2c4629e283538ba2c1b5d9df31d92b228(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909e1edabd9d4fc7b0bc166f26c11ad5bb9aca0c78406aa1a3f471d2ffb318d7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eebd88ca5ffa1556dbdb16c1d4ed6651e791549466071ee52137e32f9dd22193(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7dfc1a15533268016b8f00abb5f7e9f1068ab75ad4d0d1031a816bc3ca177c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193eb677ad80210be7ab885b97535e5a37d0945420c046140cf0baccd06d1a3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2508dc79fa22e2f647dbe21386044c61d15a611dfff5cd73211262bbbd3e6c3f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__effcf802f0780d2a42d41060e7138cfb62015c78692e432bf4ada664edc2da76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc05fc6d1c900c642660b2cb67f68ce2017baf614fb50b6a1f1942ab8013d36b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895d2a3e04c71523bd665c4d6616cd6b72d836ac28670fdcc04702810b2d178e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc97f2e890f7c64a7c8de52054938bd174a645c1d4b9fad69ddcca732f68d535(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0eac5472e3a20b869087e41be5d0b5644719c06f225f049c6be52285aa1c68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d1474168a5feebf236de5cbadb44e25a14de2269cbc934a5e6983f7e16fe26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d2a4b6e9c1c8f4c831552183426f56e05c08045fd481cf4a3c31154e7a9d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337d5f0598b3d14f7c5b506fcfee9ff1e498dea6439e864210ce69fb2f7d52d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f7afa86b6247d9ccab567f0fb10ff4a51f68b0d3e6d26f75f61e0cd6f90790(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c16ba369629bcf37397891bf12074970fb9efdc936883794e4a2925fd625a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f984bfa9ff5613981fb5592aad304e37dd519a5c0a31330fb4991387602eb7f5(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f1071124da723ff47ffbc6488b4e780b463014b834e1fa001c18016b7cc32c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505049babe08942c5894a5095e9cdb081aecbf9716eb191a0b27c72f2825ee4c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce544554ba9a18b8e1dd11e5e5b3bbea7825ec046592f4e1ef05e28d090f9bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f2688c4224694cfb24519d8f138023b0017dcac2c966b1656009ea6f9a91af(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9c281d509f3de8e2c613a6c645a7cce33486b1ece1f060c9d8e8ffde0725ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fdc0d10b4ac27c16295678db005ed8ed0689b5f7db7dd54c238c2887f55f372(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2770831e31e011b9e0baadb91c37b253a3bd135a250dca7bf28a50c395880a5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81ddd8c79020223d1fb19d01d33d6775d8a21f1a00899fb03ad03f4dec3e5b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b9ecab61c09a44d46a07b1ef10963361e7372c0da7ee87300e8471f3ac9ffd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f938680bf8dfec907aba14e025ce379d35ea99893064e9d82365ff042d6e2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e1c44d3cce0f77b4c06b0d04a9651b9a199dc8d8383956ffb792e2da04ec0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6169e9a1d3a7b2dd04041214ffe9d45e61dc38f6d6d8458b78dfd20200afffb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d244d3e0195c74668f2e0aa949e91d04ea5056ccfb65a1734267ea20b104c0b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47278c866dde4b84bd0d2519ece15067c0fc0490299278f75cc43a6125bc9d3e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d31515636c65af6ea970eabe8bd3f21220ccb52d3de5a03ba1e4582bbafea0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02272a0aaf0e77619697d83122540d85fe361674e1ecffd88c78ac141cad84f6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e36dc83f2a6211527b625f76d25e3e2bb4158926b0818dbd2d5b067421f764(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fefe9d6c6efdae9d00f00c253e7b57440bdc0c87f25dddc6524616ef135f753c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078ca7c32cefed03f078ab05dc377b677f40b54a2ac770d972789b709c7bc3ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823ec6afc6085be711db5473cac4fff4cae36c6b5ca6cce56b61dee81ebe4e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696f5408a6ef476b93cc21a0dcab813ff59b6908740052a22738a699888d01b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c662778960bc0ffc91770c6cbf52e09c8a65b2c2ad8315f4e3b101c1beade01(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff0b810d9490db197a51a0838dc34e4464fabcc06a9cc4573197b95e369ccfe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aaa2a93057cbd30320e0c135482b1b738433f72f89f9e1f530d5506428f35a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf887571d6b91160e7c9e00246e9d90f0f8c87a8fde58c1d69193ead9112494(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b80d3d7d45c6d427e626577ce61427e6b5dbd5655f684cc0d419ab833c2a1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb9874e8e2e0c29f44df592ef425569c0c7b18607796376e5a1e5075117e7a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19865360ee47b222e9947d31f0d9dd5c01e402fcabc3bc28c020c86382c4846(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac96346ae75291801dff0d046c34859a616a050e478f6f6741ae967237d0624(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2761edccd82d44370a416524a4fbd7ffe108709cfe852b0fa9f8162a48345d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c531771334bffa714caf220e8cfaed61b1e3bf2283af980631821af0124c5d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04dc905310df91de95afeb23a6ccf77d3482d40e4ad69b64c7c455ef6ed2209a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0082092847ec7d0eca2d5dca6b5fcdefb49a63aa07fd2ee35c2909a6c313afe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a220fa2a44e79be66544556c166a19a8bcc79ea4dd8c732a8368a8356bd7be7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a97e4265a09346f569345b30958150871e75a5edb0af325614f9485724a5308(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97142677d199d250bbffb05debda7b9cba8aaffd57d678f00b52c5369503268d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea36b09147efac8d41ad352e9436303b65679fdf03770c9d64edcdbc83698343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16d0880fdcc5fcbb503f44b27dd1f6bde4866f487c61849be87cff3ffbcd0a7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740df00e408d6daa17b96f4b19373721ae1f161bf47ec80b8f144901d609edd5(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c479ff1df8dd338f75edc901a977846bb827a575414f3ffb78238885cf5973(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb07f4d17ddcf8e686f670938ff64cd48e4395e012fe7dfce52265b54cd869f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf543648c9a08cb50f64f9fbf6bdb8b0419420fa4d6ea77b8352466c8c26742f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223a0710e4095ecef9d64c0ae73990295ca808d858e8d5a85950ba4ed8e0567d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d537ffde89eebe8d8c84e603f590b2e451173e5448e995a2d39155180a824d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea7fc57e9bc37551ad1ae32d7bbb4c6cc7d83d1371720589b0c42386a416e53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1231913f774442b0d036ff694be595c235d2972b1a9c630788ae4bbcf226020(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b1ebfa8e1707a6321308b034c4f11d2228b7dca0aa2e792a32ece097fdecbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b1531f2ac517a5b65984d9bb839f64e8314c1b2f71a34945fadc9903c597c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0232d767e8e9ce92f60032efe0115734a90561e127ba3f3262b057d1530518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c7ab66f3b7390c1e5500238f05329c702f2db66cdb581b51e359355fc8577d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974a4de758e54f0b8cb07ffd941346bd943b835dacd01585f78ed08cce33e238(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c804fa5cf509b6a8381dad75ebed85a05d88ecd0cab54d22c41b10894d1e9e56(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d47670c8758eabfd00407b7c9bfeb47e21dfe3bc07fa1339fa81008cf7ecc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30baf74e4c914a9f51d27c41147f3311d308b651ab10a3332dc8c16f961d1177(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f6c1cb65a1121d6ecd6822b84252eb4872c8d9a64bffe3ba1b952c88eab716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a1e6e893fae8b2cd011e5a800d318620ac1969a1259302a9e4e2a294768571(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780cfcedc6731cad0cdef8f6091b90c595eb495a0848db43daeaf297ce957389(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e8c3e3ade0c928e3d7c7b113b7dae95881841734ad03e01790a34983b13d92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a78dce828d38c6c039c3405f68b1f4f420c38ab4a4101204fb7605304c8185(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960cec6db6a13467aea175176b7441238dae36814f44dfa68eb325ee23753875(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c883e90a514a28407d84932e045de415d6477a8033b4e4b07b5dbb26bbe7d0fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2774cb66a65ea0f4636dbcd3e763644308883119fe23a1a34e13043afba56ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615f44ddd553c14004627374fea250290c10e4cb850d4560f09905824b0a737f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582f93db2006f4818498e107cfce807f865b97d798e2950c30bcd0a48238b195(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10664065449246900b0f1d27c4397116130a145bc146e16d93df7bf4002b08e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d6367c0b1e44dede77b6eeb6c70239c776019157e3ece5650b43b15d464b305(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89fe16f2531f76cd4e8501082089c854807dc215502739ab496ad30ac03bd9a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb32f0bab0e2a9550572d27b56744be03b93490800441c3d3a4c12f38f85ea82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0593c582013b6983a67c8e3c5b7654baf9f67f71a80a7694b7cc0fd3a3294ed7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d04d2c3325a6129a970abbb04773efab1189f4857114643fd4a4f66ad2607e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4471f3d3e674fa92672c90ad63d119458c715caa3ab6342a105e51c08701228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289e202a43c64a8feae14a2eedf17cf37a1f17a312b4e97eec08ac181948ad98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79430d615fb025539b30b567bfc0ae1674f0ecf268e2a8d4f4b02d468fa2fe62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a5e279a4f80e6bce0ae546f8254adb048248736271e083cf024bad2971571e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387a9d0532e9fb14d7299d1ed8e9fce08fd71a607b08aa4b1be8107599ff89f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0c58c3935a2abb6346c125168b8722858cecee408097e8196610fecebefa43(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c6858573451379f8cb3805abda6ebd53a1c5f92afa2e2e7463ede0b9d34fb0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54843a58bdb976ab3574b95d931065180f3777871191720343ae8f50ba536a1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d037dbad36a432abc0522d1b6a52ed2837097fb4924d8117d10265ca58bb38(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22498983e3578f88f42a6dc6582333a82c854e6db61257153fd5156240d12526(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__880368031566aeb5e841aa990d047a86401970e415d644f1490246242291c5c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2e082b936ed4dd6ffef93e803dd6a61adbf0aa6f8ea8ed8c386c69632b1858(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df764f826c8ea5a83bccdad9776eeb1f00da5a0c23d0b524296dcb0e2f39492(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1bfe7c1457951e2130c77e7d683b476e8b6883ac96a4ef22222765155205990(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9e89902058f5bf2313456937c4070ac81f3a4086f1af0193067c265407adc02(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc867bfcce68e6ecdd0d26fe9e9f1b08fa2adabd62c903682f782296ee2cb253(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__437d8d717343c535aadd87b726aed22690c4c94c4ff01bc870528a8aa667dbac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3563e979562ed51eacd3dc7a66963c3f2271ad891b927f11a4867bdc5318fa0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9765d8315203e952463b3ae8c0b24cdb50971b89464b410f0afd1cadc0f311c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2467a8631bb176db9ae7273ed5ca6c13a741f50fd71f17094a7d9ed497154d33(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd3564b31bf2b08e7b56e3ce0b7ece429bc89dce0e1a0f2fff8034a1b2d5678(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711bd2052b157af47ff61e5693eac85101ca1806a99dd250199d14ddab6cd4f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3409631b6d51043cd663fa8ec4db28b3e67f4208619639387f53d709051fc528(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc5ed0558af9eedd8b51b5110829cfc4ff2d755927157bf53fe8dfd6406ab3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4780e37c0d94e6c5e835edf72d542bb866e640a44ec80f3ec2b298f2cd29e526(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7139b30461226335c2bd5e798e4bfae7fa0ad7a01a0a5f2d0e18c1d5f198254a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c299c0c246303d6acc2eba3f3f4d089de801aa50b991ce583e7dbc2ad36ad1a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75cecf4d979d9b7fa90fc3b3ebfd536e9d339a39ffe85131e7172570a5a7abe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62564f57ff4fdf18546703da10e50b13c70d927fe45e3b3d9bdfb118e020e9d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c3ec636ee87c052149361e4b483d319c02c4aac898802ec11002da4e2c0517(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a83933e57549000460d350a8117ebce190ce6c1e88f607a54efa6237a77fdffc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba18edd9db246f5c05a94ee38aa68f7f41c1707c705fa1fe1a192288ca2203f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9eaf08964d1ab43139c7586c782ca1df5f1ad566f32113eaca56948b981a33a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e66193d72a7876e98f3fe5fb504829ec4a8c03924d52f8ee995651dbc8130e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8491e7ea5aff2cbdb7f9bbac9fbd50d8c29c574b0e8446fc665028b4e02325a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0c59545d2e7508f025504aa62e9af6c604b5581580013456931bcfa48e78d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51161a8bc01fcab25cedf694c1a51170cc234b4db98224c127ad11c68c47ad97(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a2739cf0b0ad7b6a6c75023c4ff84d05def753d2a4807c14837092ed62d67c(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb7c87aacdf6e0cf158a523714471aa519237f8e037a8c34e1cc1087d6585fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994c7608e591a6fac3210c75c2aca646710b386f31280da6f4ab1c8f81515353(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120b49dd6a210f98fefe3ce7168959bf84e9a30845febb020410f78178e10fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f1f69d20a3ae91bb348d1992ee2208301ac19cd7f2c4f711c47a30a5a7369a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db1251867eac77d3bf2d812cd73e9b8ca84d69500a7e44a00dd4fb0304bec8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2b61826f25fdcdd8d8aa87d10d63cf48aef656dbed64e05b4c39da13404966(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e0bb617e29608de4c865db684796852c806c587d98cca9f9138e5d106ecce0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27de2ea1867004514273de53d0a7bd429a3dbee91ea9f334f5502ede1069a3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238e718327ac1861f1435b4cfffa7d4e25526923af8a648f9c87da7d54f4feb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe90b70b4a087a6c2ffc7051d45e567b803f19761fee789ca961d643b3d3b40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e745026e7b4c369c298d39ba7de06fca0c55bc7451c8a739f06965086118cbd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f073314769a22da6a114454ab40d38a5d7834ae52d7ceb44bf23beeb82b941e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20de8e3458b3eb7c790d166eb448e9d20c33ce18a47cf373fd03abffc4545e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3489486149c59f7f0c33cf3c32cec2424a1ea4eb269be60626e7054cea11e37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32e4b59bf0589fce2d60bcc43b6f6b94f7c04f4bb0742aced97ab7beeaaa1af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935944ed0735c3f1696aba9ab11405fc1a7ed639784bdb46ef82d5b0384296ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5727fdf684806a0e5393633b90c0061f1f92c6107bdd5df74565b756a29b0236(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f69e46931fec65207682389869eb8d0a0619039c25aedb1234d09d15f4944c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33924f75ac9bff26a0a84d7af926077641796e42b43a9c5e2bd6bce0142060e3(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed827636a0ba2f4a3229b25c01b2ad6618c5357481dd7232f1a3522c054b9490(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198e3388843cc7d55de13f46d982010d1645b1a1cb6cb9f1099765435086271a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b27b55830daf7981b41a3aaa8bfa08d73e8115da96a7c19518a3ac142e8bf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aae4c9625a9ef57b6d1adec5640cc61ef1347077ad91c82c71225679c1d03ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ac886917e67b0854e285fd28101199f1385b1244cc676f75eaf9e761070225(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b531f558dd65212194933c8838ea5f0683823b7a0723ea060b2ecfd1931f239d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__990898938b5a79403c3a1ad6b394ef790f0328f01683add9dcd19e7dd156f32e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e2951ed560657f021ad8f4e69a7ebd14e5e5b4657b47c65e5a7f0cc7385e60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca29a3066bfe4774068412eed97d9444379072f8c920a9690587226a365ad396(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8caa56c2c8115178e8a848e8a1aa6d62beb09775cd764ba1bb41979582bcb037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a19532221286c9379d3e446022956807a9d9cd1fc290583f34c39642201bed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69c3d9aec22667c88fc9bdce8a07c035ee04152122f7d7f07818fc33dbe6b25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545cef8272be90ce3078d14432fae90af37b51940ecaa79eb508ef5ef72cb772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3530abe8c20977e6273678e29569d6d3b6aba46b12a05d72052a0c1f6ac6fc39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb0166366e3ab05d152a0ffc8ed0fb9e54c968e69f3c7400c8a8de4364b5dce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc9dedded0342682c60b034aba42852e65a23e396e9abd143f95061944d7534(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598e8a365bf3eb13ecff7018093ddb2d148205f6c9963ad4ff48bb799c88bb6b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9043ae880a14904411630c898ee4a602fe07988a49e7475782cd6c69d43ef330(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22908dba3ab2517de22cb41c239a35c034699f0336655453251cec79059d1e53(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebfb721d0812e69dee7176e6406b42df3e06beb8f85302ca95c7de3c4b16fca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb9e28c4ee0a3254066210c2ec7de8b1e9f9e3c981613f9cef0dede9e508201(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f22400e9d8f2b5ebcd8f8a2c0c5f06fbad43021c8f797b9d51276bade4d75ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd969979a28cb14cf9685edfc7ef46a87ab80b9dde0df2bae36a1cd06a73196(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb12b3d320b02bc4e0c25702e99d2f050c3bc3d29cec6f64aa9da8c2eb72e8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d92e2d809b38e5c00ddfe2c951fdfcf5592b2f50149b270e8c5a8bcb7836192(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a3fbb6d7fa59d38e31003c4db29b40da9734d02b4eb970b4961a647e5a9f7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e503e9d65bccb958da2906d3a92fc046f387686b41f990c6a61cf4fdfdb2a18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e777112ab9c7129ff3736695f77fbba53f3942e3e454b150d33705a04a5b913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ebaef286438762338d938821aee3ba1fdb741f26cec09fd27340704e1cedbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad1a9268a310559aedbde583fd0faa3ec2a140f6025aceb4ab12ad4ff0bae7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ab895d75f2a3253936d839f5becdea9d2fdd7cc0a0708a9ab6cd4736176db0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af760938fecaf35b95610383a63b6a507e23e1e65e8985c2255301d93b21acb(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0522fb08aa32698d9a5f07b28d6c47efe6a54498a6ab23e292328d7f103bc93c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59cb5ff0aea2bbe8c27d1de2cfff8c996a5e9b01c568355838a5090a4ccd3da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed89ad550d1b92b13d99911832df6ed37fc44a80427677a8f474dcd1f4c3db45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af422a89782a042dd839e525f2b109fc23280e0dcf69d0550bb8dbca73b63b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9a280343b61c764ef9569cca531efd0bd9bdcd56499d6665816764ab698767(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef645e328611e3aee93699055df0991350a1e0cb02f5218bf0bc444b84dd2856(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db2d6094f22af29a54eb07f1cf1cd4222befbe03989cd4295d62aeb94609f17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc88b4fa4f5dcdd027f4d724b04475c554015a306e6b7f195e03ef19f62b32e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6734b9024f1f07c44e70535399cae3fca34c32c9a326e752dcc7cf3bbeeefcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4da01ae08351dc7ca094977ec458ea802c89b4370ba08ab0250402c5cd72aeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652ec74498f9d16a859ce64ea0a6dfe0652b10e1da556ff184948f7f8e3032e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2c5232e2700a09491aacd1f9d5bd611214b6855c91a5fbdbabc525c10dbee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ba3df9d5f61c30dd1d6b5a001c8920175023f4abcf54a49ab93eb0f16252d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fd958053a09e511ca0f7c90d4f20fbe1d1018d983e80ff02d1ce85776937e35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709c1da4cf0a2780fc953f7fc4ad6ff74bb75dca2a5221a9287d7b217bd93c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d7f5e9cc6ac942c1e1c074412037a4f9f9c17b52062c8832e83a89485ad4ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653040577070f939531e9827a4149d7395403535fdae7ffd276f2145eece9a58(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e582006784489d6215ad6cf65833fceb7ac8f95f3c1758f5d7cab6aa747e368a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bf13272e2edbf8a4520bd307904491db4c58f58fca40fa63bb052acee91e12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa0bce3f75e31fed3ca1d623b62f5f869e83c2903fcbb2e17f9841476068650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1cf2ffba0dec419f4069bf47389b7ecf89cd8c1ecb70e28a006a1fecc472225(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5045c95fccaa8ece63ad48c2f4fbe7f2835375138a97d6770b985d13234933a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2788886856ac5d093a15fd8f1a3878c03bbc5f3ee475a7a5a8bfad9f9bb431e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d359f1b84c5c26ccad493f1583450b7377fd551ac421cde141dcf29f39e1d2bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcc22562736ebdc4d17b39f558e3f27a2e055bcec34cee13cbface2d3a00572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd424a0489c3a047ecf04cc184f9a114359e6084c250fc5955cf64c995ea513e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ee744a08b63c5ed2261dcf40723575b1d64cf42aea3bb3cd9c9cc5a5bf6734(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c224859f2aa7d6ed39dbaa48a4c1a7fd0b19b4ac4333f29727bdb644b03b5b(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c7da4b884b5904a81b4e326afa8df0776a00adfbc0bc5bda55394797a19733(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec6ba134b1cc98c8d933e8fdc7ffe0b8bddaa1b05d0ae07fc6b6584c8e266dd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c560010a6168cfaf9592873056cb95890ed4dba491bed21eba432509164c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfab1d1db4b3df6608d76ae7d641f54d2a220d1518ec4be5da83a54b112e172(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c8b70ebda439a0236b8327ccfcb93377e271396fef91e1c56ede908ae6c0a60(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1dd7f9df26bdc19f82385dda1862d0087e9caad007a4bbb20dc649f4c1f1d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f817dc2bc7bd3cc5b81d08f9ff492f0a3100d857a50575ac11bd971763da0bb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513ab919b70a31bc033afa35837d691e09005a3b673345f9a7cd9b88326b16e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340dc7dab4a95bb940aaa67f4e779022d7e3a38cb05be550545fbca1bd029785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d1e116868ed1fd2f61c22822faa8a165e7c572d5cd2f46c37fe1e850f079b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de19ae79267adc7e430a8c6f5ddb3cd989db6599071a410a069ea4a46ef8d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381b9516967069cb9d3c32d409d71bc01e386a828a827dfb6f5f3051003a82fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b7867afaf2c1ead3cb6acd97c2c22d5ba4e043a3b21617f4e396ce4d6403604(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1876065f0ad735cbc7be9bc8d28c21a23814b5d8f40302074c3f1785c169ea50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80fe9dcca77972536b445355818ecfd5e4950e7435a0fe0a2a87c6d52bc3090(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b602d16526f0b66155c2107814bea02062ee05e191ce9acabb5a9a169192f343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__407c758ae48f3614e6ce78e58e2e57236a7da90e582685ac1b3fab29e2b3bc31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9e3f431d01637714553bc39a61fbdb1df78725af68b9a68ac15909c624d4f66(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3398b42240b2a42a4809b538d95775b499a0a99e0324d9189a251f25ab3bfdc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f460162324c9e700fa04eaa5579ca61d5129680b3be2595a686895a9d5f38457(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a92d0892313197cd4cd0cc790035e4feaf3d32141afbbcafa517aaa9ed97cd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7171893302a39448697d84c750de629669bb5953ee19794af0de031aed1c36c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe23c46efb7701227a52bc455700fe1a7e43dcc7394365a12420fcff1765d98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f8fc97aa29ead53511864a1650d7f124427f453be6d146491b4ede0db91150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a801f3261076d86dddb2b9ef86119d6d548902c56f7b7034a2d74cb75f5b2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d777ad431a4de9fb6d9947408c0337339b1cf8e9858316e3101a56bb9f2a93f5(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d228fe2fe89e0eb05a6a69786afbfdd37084ecfc5e9fc191b039eefc907905(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee23e7d40d9a021b48b54ad20a82562334ab9239c78e8ce1f895924ebca102ed(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4c912bbfb94f1c1b17863b2f524a72268a0347d107d25b8c80799a897212db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c98919fb92aae3caeb150476ad50df0c86df351e747a0b4c5527a92d79c798(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fbd5397eeeacc6d05447824f5ebf099d4446141cdf3f63ae9604f8399f666e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035cb8b17d182f2dccd858a6e882d57f01e0aa99e6283bac94405a993d8629ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b36b599ef0d9f30bb2d9b4f43c695648bc4dc38c21d52a9b1008b0e9c5445c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50be40d3d3bc202b94359a3148d552f75401a96c24c2e3fd843377053f3e3a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b729344ca3f99c4d0b08bbc8c3bd12df5bd05dc5c5bddf34b177e04f7884e5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc2ee6042e15c085468aa919d40a5e678c538d8dc2a95035eca0c1733162d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8cd53175b114b54c20a82ffa9777863c334a27593491a7fe815ceeee52a8fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea1a1ca7cd0d74bac3ce2a9bfff4cdc65814d9c64dc7db95933b99eb9ab6575(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb85e442395c6e4ee8d78f8c6a5037548de4c78e24910acbb42061ea020033c0(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8518725be245b4fe02b9bfbba794bfd3a3fec3def4f36fb50ae5ddd59764575a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824b2beb59aae37c60f589e6f956db252d55f64d503db208add22e3a9fa182c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6079738df140ba9aaf651b20ea591c7918e58684880828abc42e3d20dd82cff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7d489dea6c742917ab362d425519828c3b8211345f4f6d22b80b9502ccc061(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b44831e8af8ef35c3955b2e747ee12bb32b38cf37c9f0c0ce63dab49a0a0f9a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4227befcf4755668ae9690c8ab55c0107b2a15148d084a332802e86d89ce4424(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a5a53b681bb62c4a01aed3f0694ab97a00eda78a2283172254481993cf75e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162f4314ba7ea2691dd1279c63bea72a8fc56bf7af1c5b01906ea007384cbe8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f8a69c6b9ae8dbf29c21db8982a1f46ff3c6829ffa5b7098344df0e9c4ddf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208a7e3fe271c52a2a6f49fa69b574b15264e2dc13f19398e95e3e35af19a81f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8de63a8c557d633d24a8241631b7e5c2eac2c77e72d707909ce5eeee4d8665c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b802924afdc07a1e49fc71262200f73ceb3c8361ecdda18953179f84d8a8368(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb92c9a06d3e5d434dfb718e2125b53567876aadc97edb306a251b751360fc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d36380eb42e8ea5a94d62d29c0c2e64d1ce66fc0cb74a7770929ce8f0d6414(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28eda456e8d6d73bd440c7330abb9e117cb378f9fb5612ffdced717a06d05620(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f760c019fbe0496a45a70e4b5ad0b3a7e6becfc9a6e85dbc111154f0bb50635(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98660f5cb5a16872130420d9f73f7a55603f30992a9b4ff56d038509006f8f6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04251d5082ad60df9954535d690624b3bae21ceddc5e741afc0f1bd5ba047daa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cdba1c27b6efd41bf836397645ec5495aaee892af143bb8580d2be9ace81538(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e4a9394d697dd913f5f2cc7dcbe68dcf2a7b3de16476b12865eb29f52ac38f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5bc46b49d3d90a53515cc545fb9418448922994a59de8ed03b49eadb107c203(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49f8d25d9aaf67e9f8ac4562ed77a04260c76b23d2c52ac4e00f0dfcf19f186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cfb2d2752bff87ea187c2b203089dc85d5d470221a05028521ffb01db5b3a24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975cadb012b037f3abab01406f9d3a4967054c31e2313ad1fa2445c38291d708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1065fb8d54a4afc039f616577ceebb0e6478e8d7b2788c833de95f04e8e69ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f417aeb31bf33c90801fa3dc84c4bcde6a5d1ac24213db7ead96a8f2db72675e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361e124e3af5cb3316a44a3aca0ae03e389ab409b53470038e675cfd9b755156(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9876809fba4858a359a260de86d8ab8d499cbec64f5f83a455e7c1066f83e80f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71774ed15bd27dbfc5d2920b3c23b99248d35efc7fa5c70715103eba8aa90008(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4338b49e25c9617c958b5a80b7bc5897cfa9bbf086e12948972331d941b13356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8267b34ee2427606691fec26c19a0536d243e9b332956c06d3f29969f195097(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66fb5b8a05460229d90ea6a0076ebfb646f452003f6c040d4e3a2145a61bc283(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba3329e9ca29d258258f0ba87c43f3e5e45f55dc769b2f66e5546e67da4e7ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438558568cc6cad3c93d05f291b3be3c29dc7c553b93ee2739ab3f866c79a9bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29c1c16fb9a098cf913a076a0db6bf4fd9e52dcdd0d41a856a0540c88927568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90eb3e66559df6f20da068c21228aebc3f0d3d4e7eb836d91cbfa1d440e9f938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16179ffe6f8eecc540bdd7e677266ea5973df577917b9bed3fbc030641e74f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bceddf6f891da482ee883d230f2326b5cefc203310b2c76ddc429ebf4dce770a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d83931d546c872fa199c26d21fa200a2606cac68cf9f55e97bbf79557989a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47001fa6a3b24187f35734d94f3a37049eab2e7934bf79926a0a2e7b65c4c7e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53cee59200e0eadc0d7547d6d80f92bf7ef1950cbb924426b5d056619577c73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217335da1fa53dbe1babb16d3a21559fd15956462c5cd88cd0bc3735db9b0d4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f4fb6d51c410d357a61dcea122f8c361e91707ffb42ddf8387b1d8835669c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393e29f04c49c230689a365b6721b8ada846119b54b8189996a9511ee58c56eb(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b69bc79be9e650a04ca4024424de7a2ab038d90d0139d5f50daaa27dcd37f29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834ffe69b49998fb3fc32636ecb7bd4209fc366f3860a744eafd0efba90c82d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c60145641ca9b5fb15f8fcbaa32422d61cd8891f92cdd961c7181d5f3e0063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27fe660e141c553df1fdc7146eaa95876521852008a1ed3d0d4948d8c6e0cdbb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d488dbf92e8cefd57bc92322ed5abe3e6ad2d54c66cd559472c2c73b3e1d97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1902298ca5183b02112f385cc79babb39e415e6379ef1b65c238322b078d1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c112fcabd5b9922b08a3e21e65d9a1d60479a4ec2eae294ccdbfa6a0993fd561(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfda121bd962e32a7986a3e748a4f22b524b9d6afc6d313d31a5074a59e9a65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4081592f4c919c10dfd6f7b9c0fd08eec2d6cbe0f2ca558a7bc222335801322e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a042833393438bfa78e44a43f705a09789a7058f1c5ddb456077e1469d3ffbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71325f6601991847482119ae2a960f674e9534d93f8db6337a55fa0cecc032f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ea983b3e5a293bfc31511ee0dc169270fd8988fd7c9b0773627fcaf7422c7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339483f59b72564dedae20c7a4896494ee055c3f59e09c35102b6ebfeaca126a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52232c055b19beda46569ca27809c28045107c5440759ca5fd0c0b39eba087e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd937d1d78230c232b2f9bd8ac90f4bf3167db8db3756739b46ec2ec9a9432e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376aee33799d576b596dffc672d68184ef96068c9bda726a080585e23c045219(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e998cc7e39c564017edda1ce337c836fb845cc9c99cfab22554b8378ef5c9dab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afd51f31e49ac901b64f542d213fa858ac17fdf57ab23a51abb790a0a3d6c87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c932cd14b01d2a71dc6910434fa92c969cb39bcce94143c1f498c8f8f2d4576e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4411e09d799ee71236464ee80ff394ffa41a5ac9c9fff75ce5a96c63917fba81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5c54a79a0eb7ea2fdff10e7521feca52fcc67eec6600bbeb79e21563e50dff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1775b5c21267cbaca887cb955572b23b73812ba82549e6c770550d54e4b5fd5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a2d0973c095da481267359d76914f7b863f0fd4035fb69202433e65117a0d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2b665acb8801a64ef7bc2af93aec5a0c3bd598f048b4d548741b380bda7d06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b89fa36563f969f252e95d70f726dab34beda9fb783afb9b5147154a3dc95f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9bdee8161a670e5aa39b24753f21b241f3f6648374723702bba89129b5aae67(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0581fb07c8783ef89175b94b7724c819b409e48ead5b2342db4b78cec658419b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a741198baf64c977a3edccc23bdedbf3e1edc1724f886fd0b82efb95b108922(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5c048e76d6cc40363c9dbf725c0ee4e76d72c4b8defe377ed9e43c7c23573b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac782774bdfa91ff8d87b00ec22525999643a7dc8176cb39ba8c2fa40d9722c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac413d51d4b7512cb588d2761bdb472c8689169de3013b1993b4c370cc0c86d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c1ddcb28954a75708c1ca27e59ea081f787e83d4b5da73624a1e568f2c5ee3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e30f56510d689a94226c11899ad7c0cd2e3632d5d393f6ba6569fa43722e30b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4311d9f5bc5985ce5a2fecee9d58e0b26eba070146301957d23c31102d6ab9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0401167bc0ae0e3fc1e5aadc347373549f72b4c0ec9c51642779908debde28a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7afee1b9a3dc46384cf93f7517001a71f96651a80823715c78e1fe91fba2b2da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f83df03b828bd7c5d17891b0e5962d87f53143c4f7fde67cd46f406b395e5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d310f3bde69149baeebc2d8342a6d2c95f6e38c4361735087d7919ec377fc1ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1066227f02693c0a21725ba2106d60b9bd94b732276501197dbfcf4e99f16956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd324ba7cdeb29f254a3ba2abd98c60e0ca3fe8be5c6d248b0f807c47f241043(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760da82b64ed2f9dc1d8b827f3e469c45d42eed9115468f6c5b2a43b1ce7f967(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da5edb8cda18b7cc6a9e4ea2bf0f55375688ddd572c8effec15ae0e86ec7faa(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e24415166b45d16b02ad391715bed61d04d171b16c2931dda0e10659915b3583(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9df30420666ccff3fbc8e7585bf6333afbe8ecafe51f205b8b12e74df13a57b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422d540a0fb84fb38af2daf201f2d8fcc90df3fbb53b87f80bee007b6fa924f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a153893876acbb29d1b198d7667c604a43efa0948f1e0139e0cf1bb81ec6df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad5ad533c90319e700d6c5868218064dca219ccaa0f5c20953a29ee16605c0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71494a60bbf84d6ffb04dd1249bf06471165c4697a4b3b8007490287119e9508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f69cc523b5d6725b2854495c3845ce1d389c99219bf0e4615934b0411036faf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0046637766713534b2ab2f3553c052ef6fb795e548ffb8ddaae631a505bc8eb4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56b68ddae5d4a2cb6b81ffd3cdf2952aa6cc8b83d233bd3e8c0356c4a583186(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248e623c4073321a7c0aac41124e53db2dc0b5bb12f49d8f659dedb8f2aad5a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbb7096a56797e18141fd828514005c9a6b38384efa425a6315acc795213f0dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4ac36f6b4e4a44bf9e4defff8340b93120776238a2c7594e985a5c54607b2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf43d4a56abc3f30fc0c0cc1791437f6debdf79e08ede026257876393948375(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e23a181f430839d42ebb6e59859ca9395efe19e35b83cf4cb07281c84d38f1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70442da4135fba536ff57f5bf4e7f417049da64deef88384f3e5c999e202535a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d440a0b9318c3e4c5104ed02d3bf4be2cde8a1b78b50e74c3f10d0d72aeae2f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9bad56eb3991842ef5f898862b91eade980005c310030600a692fe5ec96fc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d56b49eb4dcf6c2c40162250d7e43479800812454cfd9f1c766a7d42ee30522(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665c686279ced5a0d15f64eca26044a65d8fed1fcc3ede4084d4671164861b75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ef4d997e09c326e8571e8e50388b44b53c046337623caf22a57be066e74f19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfbea17da6078f0a55a8d1577c108c71093135f1ff440a1d7940a6024a879087(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a23de240aabae2d27664aef59692c547fbb2398963cd31b5f850a2f7998fe1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f699a3f1a3f59ff7136df8313c398132cf73c0d9f4abd9774f9aedb8ae13dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5988594ae3b43f65dd28601cca28911de998d7f3db454c61c9c2f70a8455a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d091f647e2594aa18483c522f92b05e6ba5165d546ba53ff7c941b32d246f4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab33b03d0018b51defcf7bc89f825a362d6852dd551538490908cfbec9e479a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a7b509cc69752cb69e8e465dd167e488b13c5d509f6a7b827a8fac451a7216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730c87f098a08c6308c6007e3e0a7038572531f38bddd73f62e9c5077bf827bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66021133ca05ac3b3083c62427b7e17001f24aca7156f485b921bc34753c6e3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb095bfb1306b30fdf73682552f34388b68846e1f0dff3aaa824873f5f1838d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4bc3f06ad5624f715dbafa8e5e16b5c1c124038cf85553620b9917d69b80f67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a10847fdf717a6719216cb1afaa24a342aada1256bde26fdde13cd594ef148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa4b2c7a6184528f80b31bb1135f1dd9b08636028904220e13b1206e4b7dcca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3548e44a7e58302c5b1b4d7e710b6b152b66ea899ce18c0570ecfc698ea6553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6478793fe391b38c516944946ad7b3d90dd7e9ee5fcb93d7c690c6dae0c704b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7bdd0c4bf52fca07999411a235d541fb064a8637385b9895c6635d5a9443f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d84384ed11edc3753a9bc626ab9baa31ff37a03e55653c73986c7c99500218(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc95c79981b383c1c537a571ec26addd347b2a9bd9145f32d3d0022ada3ee61a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6cffecb3bdfa9d607b343899fe4b20116a3fe33e7e016c423811cc26e777ca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b74839674074dfdc1935a44f0dd16db64eaae5eafaa34a9503587dab0592e6aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33c49c839b54733a1a75fae23f4269cf4cfebf3eb00343d78335d4891b572c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8268666673fe79197d83bf729f08e0e3613435ba259e68671e31f3ec7d700e7a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a69a193649b02c6e43999a82167c344e2173ab56d738a86f8babc000abaaf7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c74c401205cb8f1b8b547c9116ad8164c351bd57e8ca72a7dff78e6c7c9ae743(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bdb73ab8e0fcc4c52637f107c0a060dd710493064539244950ecadc58c93ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76034c9b2547154b4ba035cfd3f7cd545033ba90e8bd61cf6d143ccf85f15424(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f603bc8d28c72536202214484e7fd3def96a63f6c746a8cf46603b1fa56727(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71875715c314aa6cc26b8cb88230bdcf13c0ed882311352d92dc4397ae0287f(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10257335c3c04c1c929012f69d82400518186d14f928ec54ddfba1ad832820c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1158124e8546d56ca428c405c57fee8c06888881292cd98b28657f4747220e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2474d87a43cd5dbe7ed285feb8bda4973f4d5339dcd206b296678079b6eb4650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8793a71442cbc1bb0daf93fd9fba8660f4263032ad3ec9fd1c8890aab837f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d40b55b6c5a5232cb8fb24ceea8c2619e30499edc28508129df7df8597276d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e177ced32ee8f69523cb1bcdd6331aab619d499dd13d7cfe14dd0e00f6cabde5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28510704b45d3aa872c67413590c61c96d2ef093b66af40ba43e80a736525d6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f97eaf5633a93d0568b3ca886235a7f8c9f9ad9fa03b69244af7062fd039fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f61a00886cad8ebbab52fd56ddaca9b96d11bf0e35d56619be2fc2de7f0ab2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d89af12637a964eb79212af2c223df6261aeaf7030f50aa9b79dcfd3a7d216(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa12900220c59ea3e0bfa79c6406ffe9bd82e030741e1f1fb0922db272ea003(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc43b6ee1ecfef75785e5c7481ebe1594cc069cd5b14314b749c994440766612(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2f4d0b9b942b091da99993be663663a6f68c321fafafd664c3edc47c92a634(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505722e1aa131b66fd0de93c82176aafc03c1a657466a275d92430e94214183a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f4f96bec6f0a3c0aa65d6664d7f097d39255d098f23a2e6b505b9f3c1ac271(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a4b1be3e442ae590c89257c88292bd6df366d42f6cec138c63e63887bd6ee55(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cbd81d238a9d4f05dbd4313f723e20716adcc4791f2dde1a5e70c6ac447220f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373f8e7c91d001ea52d90cb588d4e727f4ad4e8025710785958a03c3aaf6f3b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f98d3a543ca094a77127bc7ddf2743d06254e77790744eeb5dce775da6606a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7cb0c27a5fa14fd903792bd02fe26501a9acb15f3a5ed7e169831b7ce512ed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c63ef69e76469243d6f9a1070bb5f2ae81aaa6c1845a397242b806febd65d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcdeee5a4ee70cc5a28f7659e22490a2e87b2eb503fd0ba14472bbb507682c12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e9e24a6d8abefe0e11bd00f19e2a981b699404b196f54f8dd5735a5409fdd93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e230e874740c7ca79f19a7e49bbfc7c3270fdde7fa7db1d0a059782fa25c015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a41d2e1467cefcf812cce2acec739ccbd8e8eafa76d8fef02fdfe8a5e4a53a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f1da873e6f7d05f66bbd033a1a191d2f7bdca6b153317d9afa0e823afa0061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abff7bd17074a0694c95739b0106533641542c94d0925d730a361da36ba40b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e09675849966ae3696426ba8deb49af9325db2f97bfd70dff49b23b702c931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4462cba455bbba4eb52adc1779397aedccb81e22649f126744f812b77714ceb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8aa4eda60d97754cca86d5820bf51a9bbc63670dbdaa4273c0655dfaaeda4b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2295268262b95d185809586549e79a7b3214d0f09f484ba8b1487ccaf79831a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0295cdd5c25410c4f3528434bb735ad38de17eb7f1609d83b079ff4e25964c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b124b28f3e60c9c9440a57ffd42e2203056da0cc0f9c3593a0c113855062a9e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e3dc8ef0d7b59e34ef701974ef8f62919ca113b9c7124384d6eb4133110e378(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f81e6b4c911fe57bc7c70b52ca95f35e8fdceaf03f7da6c1d8b7d4724a254a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946c9b9b51a25a9e95ff6affe226b18c1e9fd7decd30962490311f358824e698(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7796e6dd1977e6bd115aea74b17eac6369d45824608ca6355691e07f15c7764d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4683d6da6594ec5b7e5e62d10e83c4bb26c4ab1126a1fdcef1dd657a7869aea9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c169e6bdb1936b8e10337eb54da05ebcd1b8055222375336bade79dbded067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aede1ed5e555e1d5fc2e06b1fea40b6cd64ca4b01a3da1e8f118dca09eb661ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5441334df47872068f26791e08e7b6fe7b775e0d453c77866e13a25ef9099496(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946465b5bf075162779645cd29cf5c0913e89d70b1a8ebb7b3aa73856100396a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c860ae1fc9373fd4a3e9326b64910808b8843b96ee5b1cc637ddef65473f5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c650c6a4db6a2caed06c8a1de46755340b358648ec8f3ab8a3a93772b403a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__066f5bccf8c23adba17f761457a506a81349bdd331617d8f9b74b7d8722141ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2566d6dc0499560a00cc5a8ee912c5399cf6a1ceabcbd9ba1e1c252b8751bc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93596e4014c2b72e8d39b39e64024f5003756a4e11b4a5285e8fad0066e7b9d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935200e1bdc19838bbc8dae4fa4fa103c8e3079ec3503382802773313bd7af31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c017eea8ad845e68a9e61ef20913f4fc34df80cf48a50c2c5acbe5b104c7b97f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa89ffab67a6c3ad63af19f8c38fb48a307f0fd2d204e8f872f2db11c34a1fc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea3f171440ff854963fba57700050da9b8f973d73313c4a809705dd6e835462(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfdf9b2f4ec122996ed07679973c8612d4948195fa42ca40b028b87c48166a74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e516c629efd4677850681ea6ddf4927576ed6eedaf34151206a82499e8b43e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9a229f9e95f96bff61bdaa70973b4ed0caddd5c51fd933429fbc270622072f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d6c86d41b9ced249f11402dead6680cd520422ed42b640d3b1d398e5efcfac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cf0fb5726ea389b5ac4de10f45e93b3b1e84ef542596e6900713301376b20e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61b079db3445a8327cdcf32f4f1311207f5bc3535fa44fad3193bc8e40a61ca(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4478ed71d4f25571b68d0d0b55423715b9986b5a3a7f58233906a66b28b99f95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d91b9ffb117d61f8370b7cee19018d2b07fe6a53da49226fe5160177b350090(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e065dde0b0f69ccdb1dbc93fe88b5dbd27876dccde3789215857f4cec9f7157d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35613f16983734498fcf14ea2c250182a4581b171d77f05bdf3120be4b47c75b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5144641dd9a42879f6f69cdbe408bd4d535bf85d6ceebd37683744afdb72a960(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5066c447ca03390480345f221618f42c208cfdcf44e9e437842edf24720c4784(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75d724ec5a2032eef35359826a3d1e9420c1f373acbf175f967a0527917ec69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6505762686a53718863279427dcc32572bc27e88a46b01978223f2105c3b231(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d10212e849c530ccb86ca61fed785c03b3177ecd0674a0d60bb037d9126e89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3776eeff2cf80fe8895a0d0fb182ead34c8f86f5eb996e91e37d7802bb5d70c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0716c14439dad2e549d4a26239d50c3a5c7cd6989784d04969f2dc0144ce7856(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b98346a074dbbc1aac361446fbe9594b71f0a1c0f65e61a958cffb6134f339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757b717f9327fd9dbab8bd98d8fa5f05c87f4d2ff9a8c131ed5005f4834c6102(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b271ab102222e755f4e5391b0408ec17a1191b91261bceccc272e8f26cb71782(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5cc0616150a295f5c652843bed3c23fc00d94ad81dcee63cdb705a2a6e7702(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ef953fce1476db57c8eccdb654e42a16b7e5245a4e1f93fb32af2d40336084(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7da7b17f0e5686dd7b89e4bb13be724d642d4e662038a20eacfdba9d871b61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e9491b7bf74f78b990184babbeae5c6f105f9c20c99adc22653a894cbcbe4b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c70ef42fabe8aa010a63d7d30067c2394f7eb97faa39226209782ecf4806d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b485bd61e69460187a8063e7bbe141ea32b228c56b71d142829b3bc2236b604(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe288ba0723e0817a519443e804adc3f502517d38820098c35702b64ca36719(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5c67572dca82353b8163a2b66eedbd2bb885416f70ad07eb631bdedbeca6c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcdd3e8997e7575bfbe5bea19228fd8caa061029999204566258c44f17ea2bbb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564ba9a59c3483c5593dd94aebdd120c6b87d9ff8d5dc8bcd09954a96ec5b9d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec093ac74f6358ce30caa3485f06ae336c715021a844d8e2799dec9743591b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb93858370585e92b7febf18ee0bda0920e2386f0a9a4225813b24e946ea4547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5a1eb8f34f3936e1b50e93cada078fbc9a4b96777b2149813dcb91a83892cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5712a8ea11c3e1802a27356eca83aa0bf36856c79ac0d83d3ebb361daf04ed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec87728c0ea721d646f2b705c7268d0290b1db2a35dff212163eaa57f1162364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0304b9d49a3478d9b5fd944019593932182f94e2165eb51f465b472614e4fa1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec912eb0c894330c1977108a0cf161674abed696ae884cc88f2296b05fe7946b(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c077cee0d466cea2271eb08c94a7a945c9772f4b60024eb92306c6705c8b7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02438fae7ff5693a64afc24b762a2b12eefbb38c6a4826bd978eb2a13736c4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a551434b43f0699f3a83208aea2712eac2d2a9083d218062d2a8e57a1b7c15a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327c122609f184151d6747fd056b3445bee741f0e0caa9dfaa7933cb125223ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61d2a6505cf9be114315e8c27923b0ae1d003a809e861fdb13c917af4b72ad6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fafd001fc6b5038e9e88e2f18643f9788f60454c1a64ba3086013cc9c8bd50a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1122ac33460db648fd8151f679a87acb38226f7a20d8c81775c74eae6f5fcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05c0b5cde69fbfe1beb249eac11d8f585588a1093b82ad416c03fffc517f909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2fc4fbfbaf95cb37a8e99d251bdc55867d767e3cc94e0702e59d7ea79acdf73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bafc96ff5a5241af481d22444ca5c57ed9478075ef95f2520004b677a2d882d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca65562f2ba459e0c6e5ef6368d8c1a35b3186fd1199545ca08239e3392280e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac24c746ba4b457f38e9d9d7f506cb2153a4ce99d4085e159800d5e0c250687(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51c644fb6104071154abc3663db6ded9d91ce77e58c44b77fca00b39657ccd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74d75392ddc22ccf5644efcf472956d3e69ac4c789054020538958aa9ca07e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52112b24b2ce5bd1073eb506225b3ebf24ed66899447e2059b8c105c62d81059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5022c095cc62d0aa435e5a4db2e8eb11b0819ddd292eff60b0f16913e37fa25e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063149f18a83302d29e92d2e527356ac4fb25e5541b5bb1cd1a597ca2356fd0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5faa3d80890a7a7f351147b7314e17538be70e1ebcb6f0bd454386808d8cedb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1726cbe713b0bd411dbdd6bf8f33aa67951d457f4c4507e8d85fe1c136c0b11e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece0d6229b1e3dba7658f836db751aa1192d44b5b1a20d026d6a6d04422179dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e4c39c2bc80496e3525858a86151c4dc0052de278dd8b72bcca5b69accdf38(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e877c71c93a7a4112c7d1ee504eee24410f750cd2be17765ed4ba05a4ab7135a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f216b8070835767ed8650b5472dcb1ae14b430282d008d370405d950a574fa1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29959f264ae3aad992ba79331218cda6d967f7d50971ec13c3eb931b48011c91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__606eaa20a3b3164e8031f618450f8204602283d664642bd2c69eab71c674ba37(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d5d2eb5860342f73ed3dfafc58c09a29c2dbe88a260e5a18571a41dff62588(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4137fb43ac0f991f5e1dd52a17c22b10f3776a1e9b326dfa397423dcded068b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fcdb7c445d5e8a3b57512a82f57a7b8d3220075e802884ed3b54055a39e4f69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d041cc8d074ef77a705b82d0af864ae21536a8b1ba406a60d1c5d72f526f50ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5bb352f7a8466522caf06d81804cd5a0461be47f956cc45313553257f87198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f116c547fbbae423ef1ac999b73cc4cdbe4eba1e1cd6a058d5bc5eda9e8ead3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0411d2fc89237d5917e8c299c66a061ee71d73021b3f3887697b44fa80dbc143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80ad6533f687eb6c5a66df8051a3c0d6e2c699cfef0cbf5f7bab99d7c434ab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2db1bb91cf86a57cb63e8dace0a27f5fc7207aebb3ce414a1f8087d1a79ad3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd4adb6e960eab5c14446db97d129590d04bf492e260c4860038c0012106fe8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10374b32da6a79ee0e8c3a489a7d3cd4740b0636f026c80f3a5ef654c2d2270c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93e1718f3a6c85615065e78c69c139afadce355c3ed3b689655362c59baa2c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3dfd7dae7f95fd9af3af9be2ff1622e3ba010f28bd28f42212f4df57b51212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f97961fb443fb09d370464a89cdcf522795160e0e051d1f6dece1e91355f16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba8993465dbfd9bad316f51e52972a5f466c4a22c581e35a4dac7baee6840fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c37c099602db9558ee2d490075dfbc1def7c1f25df4f40bfec04f41d7ef0ce6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb38536eac62d0e15019ffce9adf8a6e569b465b4baf51781f3f3d06ccd08fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0002edd538700350be36a864060656db060fe9dfc916d58d8c56818ee0bbdb84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f1fac3c14aca7c64191f914bdd236b24f1cd10a93b9d8c641a2d095dc7c764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc58fdaeea8c879f62e5d13d63ebbadc7c827cd334bda4ac9eb4efe56aeb1279(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061634290d021d95f2030a9a655bad5a33039bc11521976776852ac489f0936f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e637e3c685d128e8c2ad10baec6d826a5467ae4aee67c54cb92d328498eaca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a72cc9e2a10c3aeb54ed5646a69308feb76a436b321d62cfe55a885471d470e(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca675066d7a8f2ea674a3e3601a49dc12ac0178b6dcf141bd006dfc3f461084(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af6bc780ff8c46931aec09331aeb8ac4ccedc1ea16512dbd01ad60b3c7544df5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209b54251119aa6dada09f128889c6846dea9f5d9adfba45d9942b97d1a064ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5684e1f253d21859f6219a63d9c1439821aaf5719d679daac8c1a84d2f603b0b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223fc97ffec6bf19f43c02905a04879a22e229d4144455f7957b992cd48f2861(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54e3b25a44e84ce4e06483e68e7524b302c84a2963071cc2878ee46470c6d88d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4570a3a7d5ff15b8d678f862e696f7cadd357d8485ac9bf582ca67ea47b31b50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1f48eb4ee624d9339eeae503758da36c5b7f2fa79769e572d2e1a5c4d87b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef10eab1897f8578ec3875737fa719d737e0b8a60dc01ed43d638575253f716e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55bfdbd8664810b1598877590c9a9fd39d8e81e9c63a81498338f47651e9e3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ee025fc49a45b0a8bd0273cb6c49e46c1c16c57c9e3c5cfa9e068973cabe3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1dc833301876eb7805d9cc6d8d2673de13cf68f4851337befdefc4d5b37dea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aedc104140b9432c754f45205b15dc36c921644e25d030641c3056a61f330b6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b9c5f0e091d7f98dd5629df50e1664d2453f38e5ce5a76d37bf58b3ea26de1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94aa2fa2aaaf9c1a04cb28f16a060c8fe83083f4fdb985dba8f0547ebf0dddd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c66bc645fac71f8450ec071b81ba24baf598144e46e3845e56afa80c5f94376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52dd4d9b47d9de2a7cd76059ca94b12c7567ffdebfed5a81f173a0fde4623afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06055b847c075c422c9574fd8b65fa86b98bddb3e8bb14e4cd3c7a3e7c169a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17652aa6522aead12ea0d3e00baf30ce24abfc48e95154c20be519b785c96e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e6f78a2449b7cd2204c94ba5da7fdfa2b4ac42cc8a00faa0a9fc865d40c5e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd4eff6a2393d05b9f4b5173003a796e8f967b6ead825742dda6b62b947024e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46c9030f159e46682cd426e516c78f288d401bdae69a3560cafb78fa7343b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__712f1b82e15db2ff0068b24339ec808e092a568e03b92758d0f73fed344d5163(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6101a196934d07af69cabd906e071264422b9c17d65fcab1805e3fe8dd3f9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8d86de36f64d887da8ea93ddc3339792911a7063f794ef32e0a29ed5bd065f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cfa8057230710ea9f6ee206133d9b3d8cb4b54919c938ed76cc039a72ec9b8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03d009b2d55134e8e91d2676772edddb877827ff29aa7ee33cbcd7773938624(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c36cf1b30c55a4ea44d272ef89cca6c3606ed6a40ab287118f3c37a1ba090c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfe925cf87999fc52efaf1ff49dd6fb78859b1bd44dc4c8b3c2091be35b4dc2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d072ab5ec207199c9874e2c08b03107aebc32ef059dea062ed7721b99311e19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e385357a03dfdcfba6dade814da6f62861b1d5e61099138a3cc9a4dd3d54f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8a39b0f377124c82baf50f4649aecf2b6922c52998660a1b0d47f6e8096f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49f9c2fefacc424446d815409adc1d94bcd14c67cb4a74252b063e79e009e3e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c2a5b4e10223aa90714fb1680f4b7a379e2e3f02abb34f7f1c3963472c05cf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc274e002e52efcf5701423e7eecf9de54429f421ce167a67f2b0e82a168c5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605a68a6ee388de726d40a215d7027b2d67afb919b425e80975dd8e7610f94b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3644f28d9aca73f9c2bad1485081de9e38cc01b9ef4b88efd73c6f7117fc68ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d237fa5c2d9222ebe2d48e7870b5fdc8e4555414269d6b9d2e68b28e14c2cde2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a235d89aea545c49591a463d47efe601882594178e39f2e595700e2b0cde502(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d5143e7044932ed9f589f34290cf6bc2408e6b9f02b2d0de1efca5129d14cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c27279c6a0a3d226f121710e2c40e32224070307950c99d9ae85355db0a4f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9131b6308eabaa4efe184defbd59dead986e8a70736c4c35641cc0c07c998b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa3ea6a391e588dea53bbeeec4c8537ba4feb71976ef5b97c679ad854d951c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5c65d6373f9690fbf066dc9db1ac3a2bd3abe4ef254ead63ca374762d983ee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14b04100b509fef7ccc1750690d031d25e73e423f5c01f669db836054c9d93e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a9f6ba0916af36a41a2b9c5c98266854814cbeeb5a2233ebc6db0821ea7458(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d5126913205fafd39ae33b26ec6cf62e62a9d7f7bd953253d4a4185d573139(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6914cbb53f626fd0f12c1a1e4e1e78cc5908a590b7d487c27728babb06ae40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2da0c724e0753f2f89eec949e15f28e5f6d00d26b47a0a64bc1d53b74fbd65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1569d22a5e085ff296e6a34b123a45f373423353fbd02e8cee2cd2107a7f61be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1101926d35fee0f33c4b29b01e39ef41ac6bc2f6f9f09dbfafcedb5117aa65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d227329833b49b6619173e606f3f6c48efaad9f94d399faf73196ab574d8d1e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c4586cb15147ff546012d160e2317f3b30e3bb584bff057c896f2c2c09f264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d049bcbc02c7183087addf11d99bc04391f94c3066fa3d58f6616986dbcfaf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62725d57a8753805fea19b511a216ea988e9a4a9edd9ae87b91ba247b81e43e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e2f40e39e768b5a22ae8b7c92d19030976c2009ef05ec6d46afae3dfabcdea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7ebca49e17bce5e48bc44920e4921fe92d26e6ee675247068af7de2393a886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6368b8b6166683cb57d6c4dbc9edd782d96325c47d6aee9ee7455104541bcb26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29edce05350d7d67b6dc10dfb98fc7496317e875c796b5af7992d298cf0fe243(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282fe64c74d17e66a2aed36aad3de040ce779fcb3983a0b613d8994a978198a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4efc2d5d86e9d1580362bc83e120199ab28f65f0bca4f1589ae8729aa53514(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f05b8c539ca4e1ab2cd5794dcccc2a6bb9f100f79f05e5dae48692c419c991b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0aa54a1727d1840b4dbeed31d9141fa234eb70b4f48da2173326113ea05e8e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bedfde93bbeb87b2caf49c4899ff01452f9ea5c93c8394416706f6ad429c3d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af3f9d04927e7133a6b8bd33f403a4f426a948e1bdfdfd6fa4f5610fd095819(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f26add08918be28761d66dc087d05aaef9ff35e5792073f7270d39d2207902(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6fa08c4e1e37c4d85b74f8490e19ac7f1ef80705f1f1ab3dc0683da07ea588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05eed565fd0ae138d9266e98e04a455fb8e4af07b4c8e91b2e1abcf208ae9271(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c05eca535373c301b50ad7d583ce89e4cee64624ff300b59bb5c3dabc12ce1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302415bb0ce04a3e33b84676ac1ac9ad691af1dc014579b69ef36056d6c3f346(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1c413cabc8cc51538166dea2d9cb48c68ca9c1fb7b7d372eba31860ab92d47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a311e92ff71bfb4c765de44089df8314778df62e52cc1703f6390e7d67250e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197d2a8dcaa1350e653e3811b7a7aa332c0a8f541122fd790a3a91e9d8984310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c2d24a28665072187bfeb2c1d21b60490de479298ce7c91c7e0ea1eeafa3a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4f1974d1487316018a81da2d9fc155623d8b58550ab59677ef6fa5c87e0d76(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c229582ded5d5011a91fb76cc514aec7774559d0431d0d2765d8e43ccb334b75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad40fa63f45b458d7fa0766d7f8e4eb791cd4aa4b8480a2f3d914396ccbb433(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4cab5274b845639243b173de31a2f8ed5783943ce5be2920924484d2d76fa9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd24dbce7962c3f91fb65f9882aff4b464224e8a7a9c6d823ca4ffd8d1d92ad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8e05a96a74399ca21bbaea81a533b0500f60991c7ef1cd309c2f1d9135fbe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__941db332b6e98c0243f05c679ddace1f505003084e13ed8bfde70711eef7ccf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b504becb3a9378dc341579d607e2243c16ed41bee31ac5795c22a39eaa12f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b041d56d5c69af6236ddfcae112ba93b94dfc14301a5be77a8242c9c628bf0db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9ee6cf9973363eda4330203baad05ba7655c935ac390d78e9474c060212b2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b251fee153e48265ffa5df6e1a45a131bffc4efcf88ffe09cbbe23690be835(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1c56e98f20dc37765b0753842ca84c22be3611cc3c10a8603021a817c71984(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45813dfce5338556d21e66a3fd18e84e9be1d365fa52cf362034efd1640fb517(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c5060a5cd910bb966656b962ec19154056ed5d98684a25a4f4f0d3cf79548a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e4ab0ffcdb3994bb8e6dfb5287931f3d736d69e424f4fe95357e14567d9922(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a048d5fbf74268d2a4428c1f76f8dbd3929c315add73a6d3d7069e8f4a07cae5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36891ff95ad46df089f7da8353057b063d9e077dad9bc6482b8e3ba9e23e0bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f49fa9f918368fbf81ae7800962e20e3f636b8ef2be7cd2a475243ea1efbfc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e817eb445c2b26a26244f005b04b418be9480eaeceaa7477c8ef56b3e5581f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf37f257dfa266ac6b8da67700a4d9b43e16ed0deecd25d051ab0c823402bda4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2140ef64a24341839f0b60ec40cfd51d76e960ecb36097f054bdd503a7ff3787(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd37218c77ad30b9f250398d44f5b9ab5c13357960b597cd34fe93da4244eda8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1934fefcc5f06dc69c6e16a049c28a8274f5ec0bbd684074fd50938f3c6afa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf5515a50b2ad76731453798cdb6ce4927e922b17a19b09f4c96b720f0ddbeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__decdbb00c6c34d40e84640657e8d63ca5a2c3f4ce26be544741839821fdd75b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6487ce862bbd19c258c6becbb645427a1415fa8571728baa7af5081c3f9ae1(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd5ffaa4c1d32805f5b525f1e748f9c69697e26e7aaa6c0fc1f54e095489b17f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0a83606ccf6f8cfd7267c44568419105cc6df6e9eb2869cc9f5a025fd57ccc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89c730f1fbe4f23c38989fbaaac255fd4e16454c52384c0818b1afd7ba6f1bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2135b915dfef4572110fd38b696d40f4469df0547d7a8f6e8c3fe65ee43d3f3b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb77719653215ee27bcc5eeb95f1b77a80ae4db965279541ea261de43541026c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173cc76b12eea5eb56968a957f855356cca92bb0cc512a10d3dcec23653304b5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce4b35294913c37834572a46348ae94fa741dc156a0997ee9253cd09b62435ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e8d21af7c5418f27844e7111d5e74d1254aec468282a4dad3711b4e1c1e7fa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45b678871c820587092bb56ac999bfcff64042bb30b41251274e6aec57b734b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4978bfdd2463fcd394bd60651855846fcba7bddcdf4175f3e66058807521427(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275cba8d019c9f6acb10b99bd25b8b705e5ed23ed367d40f3e7156a5dfcb3dc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e633f1431434e0b9062c40cf67f943cfc3c36f50bd98f0429389ef06d9a12c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c41fcb41e9e062b01f6ff679dee5ea41dd5ed46319f6345a8353a07563c01fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8a3931570b3e5934b8a4fa5fe84f6ffb92c5ddf109679c0a85e2f423e33be4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2bb121f0c0cefd06140b4c66cacb78727fc399e287c2294034d1fb75b419982(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5b40e18458e4f879c15c55234c76bf25167e3471118d2ed326cf551b60cee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674d92496929a73f63d3fb17f198f12850a21fb6d4ae1b6d323e6c00aefb60cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d3fae5eefbbc1e3a0ed8ee37513a48063233c5d821e82c157641997754377d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576c1fd8e8a9838a3773bd2b1653bcc403d6df3453296963d6704c3cd8a1e888(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bac1a6d1cc105ab16e8f72351545f17a1018b712c5598f5789f7ea1db7f7244(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c24ccf10dc38a86276ab0605417781a9e98794226427815a7e5ab876657aab9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4175896eff41410337d77f421f6dfdc5ce399051c1232db3f5223188b7fe0262(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e67a034f3fd1d9eb273f11be92038179b2f84331b566d6ff3a6fd3355dd2c58(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6b0fabd4c2ed64c1cabb44814ae1719bdfba1388ced71db0ab7b54dd3598e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__551a5643b94b53471052fe7c9de02bd8fbb7c976ce67f9ba84265a5cb16175df(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831e26e7b9278c142e2ba3a1d84f6b70694f7f327d02687dd2d2485a0a145779(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6106450c9959d8491b1159e0d372943b973f206e80fc59bc669e7951c2b6d34(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0937d9463a5f19e0d5e1eb5e106f87c2ac90f2acdb96b24fe2182f0f6d6767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d4cc3d7e9df23b1151df580cf7ac7bdc3373e19cae3c4f0b2cf56e01c6d1bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eddd4fa2f5c8f3b80c33b5cae76c36b4c2f92b0e3b9daa89d78027f539ac2e4e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406afd476763876e538d8aa46e8dd893f5d48b6ad6c5516287b319ea85c584fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a28ffdbbaafdca5f445b2af1c01e568fdef9e0a4ac36f5521da9d4338ca2c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f81ecb7b29d7866c6022f2b00eeab66b317463645d0f877cd1d27c32917cc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7fe725db5d1e4439084dec62e52871dc867bac83402d68d0416e7f44a7ad039(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42af8e9aa31d351907d5dd4aaeb85cc4553aa1d6f32376628cf710b09e512a4f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65edc1af5ea7dea3a89f18c8ee603726a6d06832667314f947b16bd70e0d973a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f34d8173fde8ada8285cf7407df5ed5820d4ff97ea87121212be9ac3e6b304(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8755d50c853f5b952fd83b5403e4ada18bf017dfd47a9a18c7cd6157402a1868(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d1531aab1cdd782ebb85c52afda046ae8dd69dbb99a0f163d42fbdab18d70b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214228b1339946621ace7cd3403f82d85c677bf7c2d0691a19845e83332cb25a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b078e8bcc0362131373170de1ba1c912845125690027d1295e347c3993d4e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d10e89a0299363f7612ba82bdb04ff9323d127572c43b699a6c106a7042dc13e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a4f7ed5aa568fb838205f59f35910fe4972cb831adf71fdfcb9b0c260b52c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708dceae7aa14b823e32da5fd82e7b2a0b2f2800956137863ca12177a285e0a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c310f64185161140415bd806d98ef0ff742d8d23e1cb05352d0fc7d89885c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da637b42733f9acbb782d948f5ffbc8b609d13d8e126dc1556e678011757f74d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647f8d2e9a6af5da645786d92dc9338b142df5f0ce7025eab422c752e6e8e820(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2622a76df8f88b3b6459c19073930acd091405791a3ac79b07f6eb37a9e51001(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6f99a9cc4d8c756808e75803e329a568e425242a73c3cc215348165319616e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e527fdacf2ce4798f16989d0551c99cdacf83fc71d2bfb3ba470ad3bd2725b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bbeaaa0aec092a5a074aa192fcf849ee759a1af21d37223f19350eaae30bef8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f93046644b19098206a256bf336455220810a413b2cd97dec184ee49a922207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed5d0f70104ff88e0c94aa849694c5fd4f0b5d02c59cd05e324ffe479602376(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049c672e327c0d5f61ec856b6de84f7ef7dcdadd3be57efa062483db191437db(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abb7db32d40154347f5358f297d95f9252d5137d8cc7c5853beab13409b4fd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473ab3b60b49a257fc7a788a0890b78661f7207020786ad3cdf615f7f9bdf4c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1e79558c0b8980da75a0183ea448606db4752820b2795fb2ec84c5399fe007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16401bbc7c20eaf4df240448a49d621cfa1dd7e2bc77b25e136bd526b92b16f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9172fc1e9fc2b820346b60b0fcc2bc3d307290da6a8a3daf6c54bc61b398cd6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1fd64a2fa5bcd7c27348588e822d1822c1f80b772ab9a2b5869ba85aa0805c(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cb25c0f8613e0c9ea62437e1e92afa77d1839dc8386938a52c20d5bc7d355a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7386cc574b610e68ed4b8af37dd4b15e2186eab5c0fe93b0e4ddd0b75ef1a329(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9bf6a1e120b408179dd2485f2028dd776778faf495441fe250755a7af0edab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325a3af13e36cc0c58c67782cabca3b14f3496428642e822eac14a514183ff70(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f548b7f53c68f1878bc88974ed3e49bbc1408ffa500f6c7ca9a3eef5f107844(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601b3125b81886a73f47e2ef7e9bfd48d1b8f6a090249d1cc1fc40bfaf01d3ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1888405c0ce6d3d1ff64125e8fbdf5ddf61a7432b210ffd5553ec9ed2374b60e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76fd625e18623de2fcc9fcbd49b0a13860f669ed3596f046ec0ca2299244e1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f710d4fc92b4c4822207631eda78d2b11b8e12e34551b79776db0109aa01ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203ba0851eed6cae28fdf4d9e5746c8504d239371844c25ec21e7c57fd7fff25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a149a198ff3909c616df79ee3b5456e7fed9c8c1ebb05b6363baceebea8ab6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0782614cb7002e2257d76731301b690684bae9dff665842fb9f8364600f2d3f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830a27838c71f7edac3714137c47358038866888516acb7c86d26badd74e7aea(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9436bef05fcd3bc7b8ab6b1d04eb6ad29ef9e89e407dfa7886154ef5aa0ac7c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__814faccc53b36bc4a03fcbbb321d83b2c3f9a0ee3e883ebb962712fa81f78c27(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44307cf164a2a549028c638c2daa0f8ff5fe75244f734decc8f08fb6b48d21f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312861dcd837e14cfab636e63df36def89b4e96ac243436e83fd4b2bd4d3caad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9927ef1b1fc50b9ab38d6709d3410210661e06ee2f5d170b001a65bff3dcdab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9b8f72b6cefe9b6c4483c3eb25fe3ed4ebfd8c0e0b4818fbf97ade4b0eff79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d8be1ceafa95605fbebb3f0a074d9de32045052e7d861f4df38f4a0814577a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da1e9509344928d95914edbcb182f79258c50b46ebb43493bd688c3ce1dab53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac786c1efa14ac13dae2cf4f1e393a147ae82ef984ecaccf5713269de4964a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db375be75d45482d783517329788e3b7180278d576ee818562aad0a615305dcd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc119bc2c48264db1a88c01d9bfe5e6dbc0322ae32014a9d52de053a2b670fb4(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42359f026e04760a7b7236b45846bcb5808b3b62020317ef45b398f884cc10cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241b25a03d46c34fbe3cf3971bb969d9dd4e2b92407465e387128da00adc7614(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419288ddef1e2f6c6dc8f4a5e5d669d9bf04d558ed6ac9e8dbafa7a112e0080e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffac7f16534109f7edb3e2efff2c89bfcd9350a10cf8bd980890a206e19772ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46676bd499664c7ce061b875d7a0e06199346b5f7837fa31d1ef7b6be9dc7fbb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438330fb4c486d015d3046da7f7224f701ac0c447e444719e475b42d577bc34f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4ee927ead8bb5ff01819d81ae73d21e7501112e4d66adb6cf2ebcc47d431fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28ec25ce1fb8b92ba6fcaa2e1c80f8acabbf3a6cc6e936c64ec513fc94e836d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f859da519e9b91e7bc57f102d600309b79892967a5724299d29910f96952c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fb011ca06305901eca00ed2d6eeb5a744a59952e03028a3f1e2b34865f6a53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893a4197615c74accdbde134092256a15753089715e17d66429c587736e06de3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17672a71fcaabd1d6447c18611920547457e8bf14fda840c672475b1deb4e83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc487b96268b2eb32be4c82492b70bc2ca926f8a0d686cd5453fea6870db319(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b4ab85cc3fc2e8e40b1e80154bbfdb2025faff5bb03d91acc5ef089527e113(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a11b910ad26b86803f76630324e6c0a0a35910fbd50082196ed12d05eb753d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0288daecca3db9a7874c74f3f1d633d5adcc369f2fca0086b967ca8cace341(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893d8af11016dc16297e530e1e540e90d8c78988c632cb857915fe6e47a98c46(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afe3e24280cdebdf7812f0894bfb050f37be1501e1cea212a32d061e94d5ca5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a52d2bd0a3e1bbc20d11e59333bc3ca81b87801b632c46ed774957fc89e3521(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a9a472fbee34aa6f2e61e8989b66b495f72adba8c592227ceb55bda29658e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c2613e5924d25b672d541522239d0806b083eaa5a2325f6f80f816b7a57276(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc65286d29f472b16774bb0bed64cc9dad4d49e2fb3d6f389947f506c8ef7f6b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f900ea439e777e0d9ed71473c3d1c54505510be546f11a5b420de5f8dcc93314(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ebfa4cc4d95b8f21b3da3356332fa0d0ad98f54b66d13681b8eca45683357ce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2be84ebf0ebefa7f5ee309ea5f0395f3e7d2b8ffd2cf218bc310fc50491c0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29c9e9de77a0d62f40bd6b4d9ac2f018b5dd44e9cc68fcd6fc12cd279b967b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b4782ac3eb1382ba32f5eff4c9b5a6acf0ee7e80d7a591191154b4d88e8a05(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbebe462ab43d25ebe5ea5e4a15e3b2db8e0a9c8ee4c5b607d4a644e47103f27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c956798c50e015a4f8980fd996c06881f2f553c2fa308e5f1bd58c037b95bb05(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9644fe9b0c926980f0600854aaf29fe9fc5b4fb18a8ec36ddbd15e17033a156(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ab83fd655c2aaf99cc10f80f66825985620caa252c78e286a5cfb481891e91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de09bc61647d4cf10d2d020516272bb2c9291918a175e6290adeb3b6a17c792(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f0a0810129f1290196a9916b48176bdb681c3a84c9957950fb353fe4f3daeb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f478b80abe1f3243da61a1ad2cf7efcd552192c61d94faf05cf5e59dde03b922(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab28dd730740c1444fa6bd267c2dfb76a6b4c43b90329653cce7876611b87671(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a917d8a6230c68a2f2317ff97070936a1ee466a176c30f39ee4d96e00a0d4ebd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdfc5a5d616b09c7302dc39fa581d329174338b44efb7393be5aece4d92ba14(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b090dc5fed38c1c49cd19cbf2de1be009d1f6e809100995a9b3d4745a210ce4c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f258140c3149a58e402c894aeaae771a40d8ef8e017e1720a6460bd65a211a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c7a9c89d8d5d0adb2f51e9be2861bcdf516ec59afee71cf1b80d92b6304ea4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56bfb93bbd8fb05031ef6b3792efcaacae344b76f86f34283f88168b4ee9dc77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999661e5d29e5eba5107ee41e23de23071a5a4afebd584360769e404b3ef1ee3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc796741ddd1356d874d47cd51440169e5639a5d3319740e7dd797cdd6a50e32(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330209aa8e20ab3550addb0a239befe76a34df39976f75ac69f83d53c3c05261(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d77bd4e3906b1b809b81f52667b46b4d7c9bc3456b19da8245a0ee8daac8801(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f681b7ba14a9b95b6e614981391f877b6b3cef9fe3ea53ca5f1f374686712fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddecc14242bfbe700a0413a7dd29b99d4bfe35adc379226d83b2c7330b9e71b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc22b8a3a3e15b9e8704086d7673aa3b3755c73725778b55488db4f2da78295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75cee3c5b0d34ae3632f2edd2b2c672e2f291bdf181560fb9fb9c812a2accc3e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7187ae10a7da3bcec5495bc5a79a05ad1f700ad9458f5696be91d9f6c57079f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb51ab61664f9b1dab3fdc1c4f28a3ea84180b6fec6313bbee95e13ff8dea9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a156d79c2f48ff0fdaebeec43cd797e89c4d48d28cb959caeee6f4598aea0a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac078922004f6a81c4d2c16ee69626d3cda8d2a5dd71777bacf72707fc6017dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69490047c38a6ce54d5c6fe3b3b40d7b9f8b0268c78f3a8bf98778c2fa1595cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b344a38ffbcd32fef54bc7eef7127f289d939c7aa43f6a48e35c04ae4cd712c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbb5cbb01cfae32a41b64759e41cc874ab99dbbb5c54d6ba470572b3bccc8a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea79511a89825135a3aad611da80cbe177d212811ed5bb35fb18ff75ba3f7d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4be0e0ece9a98a2c9f81ecbe3e98148842f47e2a8c10682c059390304e32c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0433291b3fa2ee92232af940d03be212302a97ce6df0b986ee370291d7481ad8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60370bb18b71035e147bdd8e21ec5f6f733b9926ba8980d2c0be36b42f21a521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283328e2a437f2e697323f497be964c5350977ec32fd0c59afe3fa8d5ff87625(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2d6c3f80d29504a5a1896b00ba33611abce71d4dc5224cadf27c4003590fe1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d7ae17a22bcb04fccea2cf14a292c3186166270be7b7cac60da4dcb72db5ff(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a0003db5aac8ee19b2b0c78ee0b40444751b35e404a208047f746c78836494(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff15787931ae1c298427f1f6383a17c0e72dd54bc7b1731cb06881e8b7c6cbd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279907c72d52ec4a0e63b2fa33cc9dc033e21447774849574c4682eb71679a1d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c3821d343c0e221efb570219a19837d43936c019f587355ad74b36facc6fbc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17f57c7ddfdc275f3cb47736cddcd52c02f264d07f4b33241d1d98f03df743e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aabcaa77c2e8199d155a9adb30da92522cf4742f78bd425438f645e330e1340(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2986d85850e781708e57b01b0785ab2e0bc916a50bb0fcbbf0f626050bc790fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15189306ae820f17bbeafdf47227c8db86d68f0ba581d8bce1aab04656224fef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8622cbce0d91c74bf510c183b079247c94ab31bc4b743ee851376e48899c80ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce058992d324d5e36fba6779b12d8a43dd242e4e12602791a8da6067de0edc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1e1a335f4383c7fe76f8bc5adf06679a743bb5159a9ac196063bb21ebaca2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b2e80dc9a4fab90f9ad0f6111fe60612c4de4bc5f3024ec9c1584a2ddb5ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__875e5e704c735716535e78c17b77c09433de5b660178111766c8727599c61bfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58050a4f689ee21707064b273769f2bebfdccda289c595ec9a47ef26d4f7d5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c655ace4a9c0b192dc0eb3e8efe78a355d467bbe41f0d438cf43ca6a8612b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d235fc6d2cf1efbfc267f800407969f4a9102c3f7feb18fd837f5f016ce90c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6665233aea9adf758faf25f40391067a6a01425a65b831cc4635582cc1b6f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86fa97e804690d4c8b08bcbaca1cbbf61718e4067ee96f6b02482efbae1491ef(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3831e0ff472105ea5fbea630b83eedbd92e85d5a18caf85ce7a2cd0c63192f5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fdc5190fd1d3a878a29d7954082153ae22ccd40dea32148a07c9ac79db7888e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f359d0459b5641b41c567570d10d2abe2381167cc77d3706ac3001b9509f0fe3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__317d86bb4920e15e573dcf028e86f8c6d40aae61a54189514bd3bbe99a008770(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce3558316131244fd3846e0f5e6a2133c0cc9c322995d603833b994d94de9df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00e56b9eaae6279402b055e7a309363e80a3182bc085bc3cdca3fb330a8510c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c320d65a39f9150ef1333fb5c55b9c26035dbaf57afab9dfa79c5a146eb73897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd27be184c1627d41c64434677feb49a9abfeb6d3be180fcbc744779d861e1bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649e560179d115422bdb74065106fbf4edd7ae1cc2d05a908a390a4cc0435ec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9321c51b1058dfc7c3b4ce11feaf60fda7cf6bf2931de95caba542111774e212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22657a8ff3115f1784506dbc08e5f86861c9a94daa1276ae0dbf22bd1b072399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14377699befb02f6969dc72e7665daad9efd32a444b897de4ae00c82c4ca9931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c9ec666cf9ea4308251817ff8cfdbe13148d76c60e98dfe48cc4365626ae1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3688c3cef9e00642236725a247ed14e0b5b70314bc810fa4b3eab6b6a4a28cd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af00159db0ad7d3bd30a80155b273667762ee7e5a203c33ff53c4414f00946c7(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59aa0506a739de1f6fb4c818d988f3edbec1749ae1016feea623b34f59c88a04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a587b8573ddf3aa0e31b0e38406f4c1674cbd4bf8d0691f47e737f3f08c4c9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6b35ff14fea653ebfc4568c42b28a5f8da3f8334b34e5f733a500c8095e710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3112155420d7c93369ff94b20c0b49520596825e774bdef91b2c0032cc9637(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a931c012473736c75362dc15548157d9039ef2d34126a48c7d8c5be9fdbf68(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950872a2bd51a5edd4981ff90f2643a0f48e6b58e80a409b49df4d7ea905df22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3878485a90f6106ee7bfb5f241ae82f2e30e23ed837d3ee0789b306074919ee4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b725d75ebaf28f56ec11613af2d7d4ca21fa12da7dd954b0b2ea16e80b3a4e68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecedddcb9fba344d8ad46b51da280297a5cd56150f7f7b119e8e50af0e2894b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de3061ab7a2464e2b77dec1450d6a68aefe3034d4743dc6014accc661db112d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2df5fe82a8227372c8e3474545e19f7a10a454bdac469f895bedf5b39eccbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1128b68fed5ffb06aad752c161c91af08e34dee483394b08a79a6ef749d232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443073f2c13707921d704d96e312ba26b0e209bbf474685bb0433c5b5fb8eb59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed7b8f60902625abc3afbc5eee6e060f2b5ffdd1593f1759cdfdaacb5c5784b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0471fd233606d3712756bef60e7757fe9210fa5197c4c74c36c0224233e069(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eff0e5945a688f06121e868893c4e40b2c6f2376f9bcc6400495177e73012fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5f92f0a64be10d6f53ff57b724dddf6410a318b94704169b51509955df2788(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f015e6811de0a43cc7be8311573b160b85e7b3f0bc5a2a3aa239a78b7b29d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d14f48d8c7fe65054cc1340b0518113afe89f8e9744b641c7e580a47a0e64e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb7b89f9dfdafc6ebe0582359973521f6a408a29b74ddfbccd00742978d0996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf22ec498af851d898bd7c81a0693c46ffd7b9ec84e54a922c2e4928f8163c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b67109c47eb4fdaf200ef6b27014eaaeb47f6115ba1905b7cca8dd61b1b2965(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60810eae70227eb9e32a6cc7d076418acde89e5c15859d3a5ea95f5fdcc814b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ba67e3e56de27e1b596b21cf2bf74dd0c16510eaabadb8c4a936b74172c313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2372a635ffaf3ddc81c6fe60d6613d87a5aad784a038647b257821eca03792fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531af07620967d0b1104a331d145bcbbded78edd440d5003fca24331652aad9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076790bf7910cfa61c7831b32487b85a871fb1a8f73e5882f2b7ed8ce312bc68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de5e35c3e1a33c15674305409096adf8ffaa2bc6a0853c22444f386d749d3db3(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3e3e718ab02c104ced4e88ced64d9d0455531002c51b76ffdd7b7bbee8760d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf50371e1bc8bf90083fc1b0e4fc881c8ffff66c143a7fa19c1323a3cb801c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4adb2eee036782d7c0548855e03ff32fd3aad986613a5fa26c4b61437f525e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a0b072989fe931678275138114b93df89edc17e97882e29b2be6032019e2a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8172ef21f2902db37531c2e9e35439d080ce8b24982e898a7ae5330e7883ef69(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2f72462d002bc99f8f7b8d0078f642dafd2db742edb47d71c40449ec7b2fc7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dca04e535fa13aa8959d8a9478b5ddaef8971624a4589d0b853fe0bf834f3056(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf61d881e86283fad0ef0814aadc584836231ab332415ef7494bae640c741be0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fdde5fb8b065d3af165d19c85f205d523c0f276a36d09f6af2b4046306e9a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f848397d74db7f74065b922587677ec994607187ce4024aa07b0fd3c4dbffd32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260d3b7f3eb39ed3ad673a00ad9b1f8ba445f8313025c3cd2673df5a55ced955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eedef18c30a6a3543f20a3979de8e1c7fe4477a70da1a2a5bbebf4694dcea44d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6edc2fc904c9bcac2a515fddc96d786c354709c6ca459b99f4c0d34d0fbab8(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33294a6c77edc0a044e83a97f6c105f7de1025795aca62f0518b8aa1cc4d4b12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df12a90272c98c7e3c6f631963a142aabb2e15a84b55683c55218745db190e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ed00876ce1546be86d26514f698ddb0a5fc73a1ecd8d06d55ca9132853865b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af82aab5fd93ef9cd2bd9980bafa784567cc5ef7d90361b94371f5afa981a8f2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69eedce31fd5df5ddd7e33be6548f7c334a63c83810bd1a3acbcac321c93e653(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9c0710052dd51ec687c1f730282e4fa76de9836f671bac46ebcae4a5774323(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b7ea4fd374fb0c1d01d8a772cb98acdf3c13ca89022ada2ee09917398422140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64987313ab782b4f6934524f8bd3049ad72ad15dfa964cca5fc5e13c57ee16a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c3faaa7c4293fd3f3d2f2ef24053a23fa5aadc89963798e13d6a9215308a3a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2add1022551c845864cf3df66870c7db058da64c9484407888013a5a347a3fc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad5f592ce0c5a82e81dfa843139a269d193fc63f83f6441080f38d2e9f9b0aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5953df70859de8e67232b8ff6ca9a435fc85d26b0466d6ba9087bfbf2790bd86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5d26be2bf1600110c68f443d552d3207cbf3664b71013c23ad4f8d62b2ba82(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4afe3231c7443c524de6c9915f38bf91d7fae3ce09763155330f2e036d76f1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__483741aecb7349f0b97311374493ff8451fc4da482c06a93a5cc07b3c0bd1270(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f505f588398e246a3757ba8d10cfea8ec622ee81ff76160633488b9eae9ceb48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dec1ba66933920b79dd5e15069e5b667aa47dcecdf0fb324aaabd430705813c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81aa16ed0df8ead77ab5e218edb57c8852d220bc75639a2e1634891b551750e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ceadc1a57df66081790302c6da45261288ace46eafaba156c5c12afe591a13c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a373ab5bd6d19c14ba7aba301567629513400657a51afb30bd8bc989b0a18f3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075c4c9c176bb7306a9bf02f44faa296a12a72b222c3ee13365f455ca0b2f0a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120fe96f93e4bfc6e3cbf4cbce7509ed65c6277372112cf1aa3b12f9d0e7f430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1f72bd4e6fdf01bf60faa9e7557945b035fc8027f0d4f5865d095dec851e6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765a563fbe71edb5819f8104061d0b4f5cafa80a615d93fbf423bd2b72c44cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30954ad3eef341c589e3ab0bd02116945b2f7f5ba3b084bf632b18110a838c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf69a0cb695d47e01e5d054d6084ec39db75e770366d972d92d1f2f197248bb(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c270c517c8fa679da0808d25f47da17e4e6ff0d7efdab81757da8f270b1770(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9184404a41767e02c329a23ed38832562b8810f99344a108d74f3786a0d72b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8280b63a23318507b2aa4c05e1244802421e60b2e6a05b30d566e7d486ba1803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d97b284427ffecd873230759508a6f2d4e3def921cdd49cf8e8df2e93c2c91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03748d8f6004b6cedaa8f31735edc872978aa218e4cb403c925896dc063944d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9f5fa18d497e93a8507ccae88c666986eb34f480d1d4b668e0a2f5bfc4ed08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec4a213bf72d8605772343a4303b1cbe9e8ee5fe1b0b9b557d4802e68dda64d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04bd1a2b36910a72bb6fc2b57cf262df24470f7c6af774451758972ff7c74429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca445651d3a5b702793077907c3a024ace3f628b17bb0a152ab989d41dd67a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2f9c5bd842af6b5f5c1d49a636a25d6de5fa2edf6b6643a68d19f7b37afef47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7f833b7a26420f244ac25aa1eda90ad48eebfef6e395d3f6d71ebe80cbf8a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ac4b4bc2e75912384ab0d06d550850122d9b663c1d932b0111719863f0e84f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15202d0e1b21ebf484d6618947f7222bc67f331ea38afe199a8b7a70c97c5d7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacb76fdd5e7640f8f00ecf466e91c98bb9e1dc61f7b37fc60c47839afcb4d9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__896acbaac17a1d6319d2aeb48c7d7de779ea9726dd690c39d9af1b17b36368f0(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99002a1a86e1b14e9956368854af7bb52f19cf6aec24c7a9eb6074e2051f1ae(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0a0502cfd09703b69441df3e1243a45d00a722ba45a799b5b427d05bfd39f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fcc1d738dd9f763ed978555a60665e5a2c796e849053bd88ff5369c264e55b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31a99e5bb8fb39292787f3ac1b5b2336dd1dea494f8eb784b204cc3149463db3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8b431d5f9b6188e3b1996cb7cc00cf5db0dde0f91bfb0c83bcf70ee007089e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b30afefad3d9b6d6a5796f62ef8494de9d7890a164be4d1cc4e2c3751dfaa47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512759423a1bfcc9a36f45125c04a4b0b7016a7b5bf7a79dd21e17443a17372a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__451065a716767b29a792c5f02b2c16736245c9217879aa3561107fecb780977a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef53913c7da88d61071a698caf6e8965585ae5af264e4d900cf0dd6f553b77a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7eaad37ca011f16587e63634ab02bf8eb9f54ec8cc99638ff769f43866795a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5993afb13b04d338d70b08cdec84be5fd4e5141cbda016c906c17ea8ef4c0968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7590d633504a6bb8b032c4b9cf8c35dba789f927e1097080ecc06936a04617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b65d5f769632c7b5112ede38c9bf7538ec7e220b5be4f8cb2e2969407fbf5e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb94f1b9c82a091f2d001e49f965421e47fdbfe1254adf4a51bbf40ae53fe0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3cd84ded6220fc5404635674155dec272cff649943b0b7e61979931cd555a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed50d8e69989f2a25b706bac87c19b5c8c356b4776e95422ecc3f344361b189a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53cc501fa9f26fa744ea440c64f9645325cfa78fcb60e623628f2f4d5e705ea9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64fb42abc5230b0f6e9fb169dee08ab8cf1b26f8242b377886fbd146e09db10f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb41d1e87a21007d637f4a2b6bf9bd543447bf65d5546ef1302e75e55fd53710(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c3b5966963e7d6074edfc62fd60f394aadee2c939640e785902de4744040c9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdafe1e36829f2572288f6a9edea2117e5e9073edfcea96e447b023ca92262eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2510751ac8f727f356287040fb5aebe1cb41ea49a38e011a07a661d77584f70b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc84918b47cce479aaedb22121320dac75446139327baae8703f82eb199a7fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cedcff973e0ecb3bc0029bc87cf8b7bffdeb07dbf0f055b32dd60132ba68f83f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cea9ec484f435b285a999a3c83a32453ae8be4fa6de4ab7e2b415d74ce49299(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b195a9420d6d63f5acda865dcafa12c2e3fb875634829074e3d7431630f1bb07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60171638e71a021495eff6019e42c5eb5bfe838d1878335fc3f248969e478f3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023889e9cb99d9ef58ba2de1ccd265a2e8432e5c698dac43b6a68b732225c6bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c325c79412430e9e20569e97890804c60fecd751ce346ee586148077a5096fb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af8793ccdc1b4c4a00d7c3df12fdd162bd4183255c5008d86ab36da1a9861365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5950a1adab972cc9848bae1d0c7ec820b0f9c178aaa4aa2b5195b6954d58e151(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__918e2e4fb36cbcf8cea73173a53b1463bda44377de68181644504f2d643980aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b3baa1133c1243f4a0c85a0ba95422963df2d2d3f58580face8a9c22a15e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d425e987fd65f853ac0845a13363630e26f430a6a68890722ccce95b8395523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11cf126a50f6b300f34d0a1a9637142aeecca56c61eca28ff67967140a433ae9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b86dcfff988a9fc370016f21c82c5fc141143501a01f3ddc1f2c2059fe7a12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db05dd254e5653447f969fa3ec78d6ddb64cb47d89494bd1c21cfde61faaa2a5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0b45267adc54fd69049c701087bf8e491890ed2bf9f31401f3c20f4f08585a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb41de051b0660f65dea905958e32b03f9d4ba1fc83e5973c44ea8853ca378fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39617ffed87ec12087b9cd05081cd32b578abda650262963126c34568c5d1f06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76db98bd0a04c4fc788aef0f68665d439fb226f1a781eb761552ae1bb281ff29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780b7b7e0b7156074c8c893a79633b6aa93a466b090453acca4641bc851b4566(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64772ce2018f1c72ad016d90b3095a05f8d1d130202869e19a942cedf3eb2550(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0523558e0537a8dacd2c77a26b38281e4f8f704db60e62fc1ec70bcfe3e877a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9d9d8e0d469bd0c25764a58aa897f5b898f265080e4d554bdb33874bb5bfb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90e1ede13ccba9f52207a8e14d1d48ea9ff241332554880b1264f8be90a0c47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf80f48488653d74387f659aa2c774e1d2612f7cfe5225f547a2d281c60a3f98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa23fd924d16e127572e069b487f4a6f8d6b9578027b172e5c421ed37f613e7(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420f0179e4d8b06542db43e7969fd178607c8446d5743b9cf7626df7bb90d3b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b540918b647bfa05c65d7c16baec61134b89aa9fc69a71e92c215c3cfa25c744(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d092f650d38dda28df8a64784cfebc9856709e40d344e8761fd93e3b74d57253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b8fcde1d0d70edc9abf741d64381b33af7609a45f4f423be7ee2e12c785a937(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ced7d066508b973f2b32a7a304f7d37491ac3d0f496f7cf3608f28003638bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e511daefefd6741932af06709a36ce952deaa3ba2cbaecbb767c7b346bed8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27ca03b84c58a0b39612394eb0d62a3ce5b07d09bcfd69f7801344aa28548ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce31d1bb3457cc0ecfc76bb88483d435d447e7a138b8d86de9786d3469ab1c9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3dd813fa14d12ee0b4f443acd83aebbb547baf7d6dd2b0e8a3784eaeb7ef664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__820fe4b04f217ea083a3e62b6223e110d9f1f8e62393995704a43f988c20e0a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7725dadd90ad8a6195fa35c1e3a5992c447806b248f966ff6c7416bb748c8dd0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0652dfda7db16fbf52a6a3b6e3fe678bfbc8958fd77ced8aee62cb96026356(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d89a66707a011c1d49907d7ad846997c14f7fa3116d63b193d32a5a18332d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30682470f9050892f0323d01a4e8a0acf13c765b4745f5e3c7370e7f36f5fa9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3beb810a0568f3109be7a7f069d2608684730162b9da2c22c44482ecc29ca35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7fe6c03a7e760784b9472caaf950d1183a0a581983b39db41d02fb534447591(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f87dfebdc014aaed2b79dc624f48e713ce536f22af9466f57329a1f6d5d5938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3974c5d652380030a870ba925fc8e318d6fd0c1da7747de46656d3d0c7162a3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63a3059246f93cb695f25495a899d7c34d1fecbf3bed356bb5b8015594f096e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c03e983a558fc5079b883bf8f5eddcebed88c5a3cfe80dd576dc5da49d50fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee7a8b9a32ed86c072d8233e5cf16f7b6fec56185edac1bc305d000bd369809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc95f820469320fce5234888e92639f59a2d9af5db4c86a4ce2bb4fdbdce7fad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133360321bdd1b57f84f52bd44143525c52c3cb34aead3ba3b5b4da9a6f62b8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beec198d1934fc81f60f9cbb61262a411bf55de737c8eca8d9ff5a2f3ee0aa9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ff389002668d6288d51b3af1a5d69c098769c57056d4ad6e324e47cf0ddef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537a05ab9fd29476c4049d2c71b7573be58b1d6bcd83b26d654ba0a40c3b21f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1923e850bc5fad04ef15e7b8d93b9dc23ee491f4cf71ff6047a3dae2df268cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6258c6aa838c84c8ca990efa0bb66d13a54e62c5c526fbc782fe40be98defe86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817711b956e4e9c096a89b356e0136518e81d20352c0b1674197c5ef8ebd49ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3474db205ff03ed8f040ed2688da297fe2bff3af1ac391879aee1b28242b756e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398f0113654d9329ec685588420875168581afcecdad37e5272c6e41efa44ca3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a421221b5598f3038ff78d65fc4c3a56ef93e54e7bc2d84de6e877ca2b5b9f19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce76d20a60147ece096a15372f5975ad1da39a71ed935461f0ff03aaad375ef1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504c0c950e4b4379695d782e16ccfbe0f36907d8d30bd6e9cda34f8d0fdee376(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b38c757a6dc4619d472d809bc9009a998986cdd638261f373cb37f316603e046(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed50286f9b76cb267a5d8668823f26bf381556ac63005538293732704d85cac4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884dfc458cead6368c0d3295c28772ff5cf61dde0cf5b5af3229e29941e1751d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb1fa4aa3e7fb6bc8989fd60c541fe0826ad898621e5feaa6770256b045865e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02846aa03fe1f7ea2f033394f59484566271fe43a5d4ab6005a43e03265743c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27760722cb3aef917ed758c10a8d131382333327bb1cbfd7089bdf5a8de5b2cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef069ddb8d7a3715299fc3ca5461d6982ba769e577bf976dcc8ab2c1c207ea3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93298db41df07b102e99b8617af87e579dd34c0ffe8655a5dd7d36f15ccf81b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b029f10412d432c6ec31f0a522b0225c45b0b9a671c7f61088e31c36cd3199(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6694859a08439663a129fac0816b4c048a4fefac288c2438c41fd8e566c4b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e8f55f8d9d6f567d91a1014a1b70bc4f990fec1b9d2240fbf31e5c474f12d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3dc41050d04c96fc07c9970ade3522a07b9262ff8a7f29a63dd17bc0c2f855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a86fea719a780c06fc3105d23bdc29d3d65c7c2d698f8fbb7a5ea2e65a07bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71ed66bfd290cf90292413757cd7c6e86902b91946516ba7df57c8f0ed98367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10586a148b7c53e6e12ba562ba9b6dcea96c40e41c840ccad3aef329f5151dc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d9a4fc9c010b27cb8df42bcad10c758ce8872c0dd981f1201ab86456ef2893(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75413ce5f027e3d3cf9ab43e48702f47bd37758f02c801bb4314a7215ede209a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95cf7ca4719161f1823f2103d559537e1a5cb2f09783d782a30b16a8047ad80c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882c4bfaf376e41aa525d343ce825ddfba20f3e50e11140ad117c77c1f2c2725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4869aff12459ad66ac899abfb2eda31eb13247e4ef485176594db05493866ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017af668fd329921f33914432a8da6a90bccebee01bd1cb46275506acc4e4f36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b91055eeca7a1c357e32408f94f196482ffc9c5b307c5bc10f76069543d61c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6fc6444e51a41637dd516adab4ca518c2c11378b3398d42acf6d0075edf0da3(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa0301080d2e2016382b1d12041e4286e5121129bdd64b55044abf742b50cee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33d3d6f18392765e60c203b0d0fc96750a7e5e0ebf3dc3972758882fc521e6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029ef8bf813b8cac894e12c0e164e66aee0f89ad9067268db83416d0459fee3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20143dacd8bdfbd04c82fc2c13f579f900322f0b4f18b5844c24ba5a4859e621(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f441956c4037b2c588ee94669b03bc37e927e76e300e92a82ada51d5589c0e8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62bb4357a4a291b8c3cbcd82fc36506aba95bbf8bbe7bf2bb0483aa5e2c2b9e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee59d83fe2673b5743eefaa6691f6e7814f714561d01b90c064875c2f657ea0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb00dcd4c1635fbc339b567a039ab6f0c82ac69a72b3eea63bf95ff7f5dd26c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386837ffdffa798a5066d995e1eadf2306b9e81f655d9671318bbfb4e35fbde7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac7e898f71db0a68528d1900165ea45a75b3ab30fb4a22d26b333ca6faec48e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ec826909bb81f99131702bfa93a23afd692a5fde3ad4d45581bbf310025bcd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8b227515d1253d1531e2dab991060bd7f6c80efa85eb34bce7380855267e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a3c36d9bab92337b8a99ca3b6acd0c05ad7157a82e3f426ccb22a9c4355cdf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603597283f5e08f31c278d49af8b83d8e331c30cdc02094427e9302bdbaf2780(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b85fc69b17e629bfa4542f7db60376e6204cf35ec2a2e5bf028e36be90f730(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c59ad070326af3ba3fba5ff934d20fef9b4c709a1ef13dbbdee1b5fc429b397(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe724eaa950117f14e201b909e41a54a6a1da226277943d9d069cc483accd09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0657400718ae053660d513ba4f6a779d085e74d3fe26045791ab502b64ab2b46(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc866ae6cee126475e27df74ea02aa20b134a148fc0a43ade306c07b0a85cb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd58c6a245636df398489572e9456b6841cf3f892ae10d3967f49ded7388fb5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7491777962e60b74d09335f15a1bdbff5f8cffc50f6aaeeb6adde3cdde3097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2867ff1ab65497aa846f41c7be012b48ed5dfa650efc3c183254e3926466835(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5785b89459e3910dcc9b5748f2c43a7a7d29c7b8f1c8547a4613b928d767a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8947337432732497c7c15a82028dabe17e67315713facffb1c0b7d0e0a41acd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a760fdd64a58ba7d1eabc547e1e2ce2be2967320a999e88a89a42ede86c3ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dad63779cbf8cc2c252b310b4349070e2052f902b31e878304a3eb30dd489dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11204f919111e303dbbf366376d14fc044100e63ee71a3760369e1f34a7d370(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a5ff3d0c6e64f3ab572b44f9f726416b9902cbc159dcc674c4236ef128826b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64fe47a7408bc82dc2b41c9a91d1576d99bec7443d013b91c6d2db29e80491ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e000b334841225758dda2dfa276074b34c1c42ff2f54b6da90c01a52a466f20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b101ea9274b414c864fd8e711d04c42f3ea8ee9367e4e8baa0e8134cb8f69e9d(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dbe9b6160ec357048bb53d61a74811eb9c6244b2639955d63f8dce74ba2f5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff51ce524b7f3b717979f7e69bd7b909afa1af864a167c504085dfaeadf6cca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04efd5155cdf5482fda3fd0e829d91bc93c66d007f592b0b962f7282351d1c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41be9fe8bba1f316b2a87db1235a645995554d825979b6e97e85d74e63c10550(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193c066870123bd3699d72141e8eea1a1dbc3d29c0ae7f9ba11c1eed3f7df416(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b49dea8a020ddb714154535b52ea5e4e136313134c198a40bf87abc3c77850(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99319306827fd69b19340b09041df4f057facf9f467093dea9733d642d80918(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aabb4da866bf7ab3ca07653e5e64261105d2b671eff01d74ab7979a1e85a7a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c9f523dd9af868000c9d187347dde4b2b35162541aa46bbce2ed2eec9cb4fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da013f8774dd937cd5d72927acb8b72e17a551c1a7acfab56ef1d63447f770c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c12fa7b85444e9e90aa24040e5a2588fa11e6850acb0b2d2c4937755f7ce073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08fd594a5f800b48835f5d6ceeebfa1cf987bd79d499346853e7335cb0b30de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e344177f7237246874c7f47272beb834cd2d22d89d00cacacd63e9783c80adcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e2109678bd14ce5e3e0614338885be6c2668f9c50f19bdd83d09fa7f8e6f3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e4a0c10d3d916c148405f03dc6f1cb3fca0ae29e5d69e1d1a5a0e419401b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a1316448b16b6057faaf2091845226dd51ca0a2dd056d75fcc7c03541d1c26b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc578b402fef1b3b20da8e49135af3d1597ad7f892de4eb69d9eb3aa3b51f5e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71880ea7ed48267c12eea49b7dd88a2f4f2100534123dfde5b2d063892fc3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28bd35cdebf6650c4a4c3a4ed91fa890ef2a5725ed4fd04a5193042917b99bcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082965841fc795867462b4d403e2acc020aeb9d34c0424029104d6bdeba929aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913429a05fe7f7d2ff4c1ff5ebe63b2864020fc1429d59e7a00b60ed9089c2a1(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c588bbe65024642868a15a509a184005ac034a68d2293da5f6c0c71e7511d9f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea70b8a2c3ccea53a229eb947ec945ff012fde7be0ad75983349d480572379b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295ba740e60087e4ec9ad8dd60472885856931ca868921452e06aac890c9a36c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3de24a296e8bb9be08b3b22615dd9217f5c0523bcd367300005b75f368f999c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccec7e0d657c19ac2a27be9718a897c1c06ea5d83ae8dcb86104ca5c143e95c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b217390fc34ccc1308e95350e752043626f4a7dee2b563a3047222c22d2051(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0e43997aded465e00beb098748c37835da7cea613ebca2fd7b0f2dca76754d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad63fb6895d447b36eb1a2bcc10ed7bc5f08597db81d842676dc5b5f721fc00f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb9c780a6bbe7c7c3b95bc2be11761bc0cc9f829b92846122aeeb90c0191ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64bb27de8f56e845a8ca410d5ac8e8a6a5acea62e6d5089c3d7f7671dc2321b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e040f772a31be836f5114c4f366c4998a34df7c2fddc34f112f6126821f9c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523989044a2eb31c23ea0ad069c712a080fab159e97c1abbf544dcec947be50f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba1fee9b363e71e652a070dbb4bd81cf63a9e6238d1cdc99b61db95b678a988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ece9f511c970a104b7bf6ae101db82060e9956e3b2b7e4e9030c70849fcdcfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb5e2b1ff3e373cdc92ed5d088e136831057326db1443dde9e0a2a4d8bad0cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42ed26ec0840b39f616bdbb27bc71dd8135b1841ee7321c0c84ccf98247dbf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2528f7185e2b81766329357a301c865d88b8f3e091d911b35a69eaae41a428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14620255319b1741e467f6e6879ba1275ebbf693731f9b3c8fa139715100b716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9387c1e4a46b749262a325e33899530b45dc9c61030ce83d58997bb046feb87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeaa4e73f59df9f0704c216233d390cfd0acf2ed84b03248ce332ea048341c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614843cf6588c92ea8f757e530e1e873905ffa677ba282c66eb79c9ec8afd9a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a6e0870d1e8b95604a01d15ff6439b1c2f30e4274b7fbc8a9a2382ea26c413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab4014d16eb77213610694b0a1088c321212adcb7577d9b6cab900ea5244a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e8bd223964e87b525e25b9d1d947afd05f92d3d97f8820d57948d266c69ffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd36b74cd1d147f5dad45116849362a2a293e9d2ba8373c7a4c3d7b3619bfa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab24950bd8bb2e66fa1cf2dfe3136ac1ab8249621ac55e406324f8be8174faff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac432d43e8c4ffdcbd54ca4956a644446a7539c4cefcb0f1bbaf83f769f6bcc(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac62d1321e4a9d9dcc858d706ee6b883ba04b902d3f1156ed0c424204b201db0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__092f65170fcd327c0cd05230fcce507b1a6b6bf5cd929d9d5d62f5b8c344223f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__172e66b1c578b95611835850134cac49ecf27b64c89acf7eedf7163b531dbe92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c245da6993f0b60d3b52e6ca6afbba26d0812af9266bd65bfce01d70f15090d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca53644d95ebfd0532f221c77dc69f66c5db63e7ec37624db8d2ad6250d021f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af91941a1d062f11e976f7f5e07714025b50e61b94ef99a68cb917be23b5459d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4d0ebf307d83537efdb0eab804534ac06f473bfcd8536585802e8dfbf59eb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fca1134eab43d61988c2bc4630eb1ae139f5eb9531b2fbccc3b85cc0e5183b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d86c5a5d49e29aeca39e44ae8db57bc9623cefedd7d237d40226f7b703f5ae2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94eae676bde88c27cd6aa9b5e40d0ad710d902a1fd8862ed88123f8cb5498528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30704495f8692afd5760cb661b251ac0db027051594ce55754f3a7560a809d60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9823bcb619409cf6016eb40e31d96772de2438903999ae0ad0f1493f6c22ab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e8f07b1c4436aacb94f9c8d3a1c35cd72106b0c6d89b18329ec09049ab55fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d740c1172ef83b4635afb1bb9bbfd431f14267ab00bc77ccbe86b9647083a9d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e4ccce970f4f5bcbc08d3d87f7b4fbafc8bcc344ffbd521bb734f16088ae91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37e24dd85f3ce66efed62776ab98b50ab973c1992c4b2d961afacd64da6d260(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef2812bd2b150b6f07d1bca1135c441f0dbb8190dff8a1df6f3e3d93695b91b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be32d450b3de1dcbc7e8deee03aae7d9da83ba3010b905a77e83228eb4af8ae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f9c24a54960c5d37a4fb94b5a5211407ff96ce0aa9ff131b9041728c0969fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33862e075713324e229a9f062b9e986e90fc555e331685e2472aede72694dee8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6c927ec47d9aa78bb50cbba14d7a3dccce9663cba12b817f525902b0bee63e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a03e0a7a0c1ab0e8d7bd9533057f7253f3efd99b059fa711bb5d529e9d35c57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9be60d0707203f63e6f384f2f923c7674b51863bab01911aa85e7e85af24a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954a8a598de54a83cf88b5bf07db3000b1ad8c80d62f3e7519eb0ebdd7bdeaa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a2d9b9faadf19615be3bad1305eaa98273777963f0099af4c7ffc40110c336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d608bcd469eeb8bf56944bbfdebd86c543724c28be666e8f7806fc6805626d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d74ab87fdac53a60cccf278aeb52c482f2a1005031a64f53b543ab9865795e(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c2b7e46a4c0091d8b5b3e27f3ada364cdf603bac2a7fd25a1ed7bd40321224(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74bea156973eb3bd724deea0615d49ef9855ebdd6b4ab4ec06d07abc5ef9bf41(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c633d30613e9ed8226feef4940ba520775be15fbe10d5d35b60fe3c92154079a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fa49a382a12e366a981296455e95b290e9298ae879cbfa849b0be721b1af11(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61148d2c9e32d4c633afcafaf858a8ed99968b64a9eb0410cf7eb82480ecb2c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c38cb32851abb4a763160857e24550e4e5c8bb8718ec95038c61e79bbc6391e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5eac248e21ed4dbe69287a8c1f06a933ebb6df1a14cd7aad566e6c9decd43dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc759e327deebe82f1e2399d10d77e3a3de12b4095ef2498740cf49f5c524dba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4589349279b5f4bcac5c1176d2c95e36049b5902d38794f659eadcb784d90ed8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6de729243cc95387bf7deef52b1636dab7ba2e34258bc306fb19772b4e9e15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e53ddd94157bd026e04e05e73b3889f9cb46ac70095b1bed2e62a87489ddb660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d97017cc2de5be4380a3e180cf53366b91f4af83023409f4c65d182c29a1e1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a924fa82d28cd5ab1f06f9874c49ee33339974ee55e9da8e6832ee1709cfd079(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5cc42902f476291962f05e08b022bd690032e710245f4fd27897c1c984f0ba6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f614eff8842d2ce1b1417609853e08538600d32edbdb9f45e9b7c468a21e240(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40d8ab48eb484bdc3497ef99d40e7720bcbd6856bb0d44dece0be73e339e886(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b05107731b39f744fbdef71e961d2dc4657920175bce02b5a735178b0b27f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acb5cf78978131c09f2feffc9abee4a7067d2efc9e97deb8d22bd10db62782a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfda43af128731f6ad2ec899a866aa0e813e02b0c84772d08cedd87f2918d66(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b323c47bd388237be4854b5d8d4a2d22c136f95961c47888ef135d4d0f10b1a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431dc82bdbe7243eaa88aeecf1765380c096b16709ae82db5e1b4baa37c5d1e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6d405c717cf59ce0a3d59e8a4b920a80c081c4f3a343819ec1d06d1b8e990a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a65ee2a83ed4b431b4541bf99aa8a33b3782a2e186d4231df6a35709e087f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe66465abb362f8ac3ff62449c214eeb0b742725ad1b561a064a82e3abd0a1c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e223257207ab9919d6ca3d65339c5502def75f4db21185f8e60dc45e53cc8aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3901747e87fce7271419d42ab138ba8908de39f2490ba9cb071554972aaf318b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15c61ec718977f527a4ad6e26fae631b9fbb35ffb10742a53bf40a30d0efab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b0ae5e3363a09b66952cd34d7834ab46003f2a8b95c6934fdd4140a43f18b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8185b3efbbe62a8cafa374a35b03bad6b4a86429bd41601c929979c9b03d80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa80603583a52487c066d7a3048431865bfc961ac6b3dea284fc25344271dce9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46786b28766173a898ca35f94e62798337e41b1b487e159af51fd60f3128150d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34fcfe621b8ede713b8b30beb275c3c8b4feea9e9fc9668c58e9ae079499245(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00735450cbf8d8875b7efceed8195ae6f5181b520b997fb12d4458c2fce00c38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f06fc2980e462abe41f4782a02acb755d132a54df49f4b1697e5b895efcc37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f74cb3ba90dfe9bdaac2bc01b7fce63e28a7f909d228657a55a55424d85950e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f122bdeeadbc7057046cb0721bc1d5340f95b7863cf5d8ef7ae50b0db4d3d6f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a6e299eca28702c79e9dd4eb038ce59cb3e47c1ab5ecdc8647ddc081101bc8b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58625344d9a342e4c964c0a455219dc6db9a867612bdbca536bcf5c52acdfb86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d41aa8d9860d2a02e3130d5bfc195f5cdc8d7c816935c2eb1a10237d8f1b4a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f318a06f45009659f1c1266f9d99c46f7aad01b73741e2a051dc5d621587356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04089243bb4d1576e5d4b9d461b17ab57ac0d199ceb0c6262472bc5a4f22b38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4333cb74fcbc31ca829856032914199440878cdff7115bea7512289d8d1786bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbfae6daad9f328c5194de4b1f3cae78d4674c4b432e7828a3b17f45509708e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257c9566dd8ebaa9fdf80d5710e4467c67a66488584d247c2bad552563f2fbed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3418dc824034c084fc6844684eb947bf909932bfe8e55d9f34a4dfa97a87b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ee06a575e506865d31a90068e8f108865612da30aec2f08ea05174a65fd608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892f8a12e64c870ed5806b0beb6690daae4eddbfc1f336ebfb9f47b5c5941384(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602ad1ea5890cc6c054e4024a78e277d86c01038ac5fc98f57fdbc84e732d039(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11693f9b9cf2bcdaa5e4ffb692387058d60ff192fbfc7431eec973a61085ebf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cd16c4d0e156c03c0643d4ad966dac92b3d2130a918bd1e81948aec91457a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78041b25aff184382264d4ba38fd9fa0a11596179709752a05fa8e8a726c7a34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d4fda29dfa89bff9fd6a23cea23ea2f31b43c0e6ba710ad194b69829b01f64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fac27093d8c2b626b727dc47a9a3518beae5ae1557c6197f9e3c13cd6e532a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a757e8f9195d1162917b58bc292d8c82b391debf130f7729fe4c0ea78fb8d61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19223c9cfec1158bbf7ee72eba584a5c2459eaa67e0493c5f3285c6fcd1d7fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927be7a5de6fc60c448caa655e4e8bc1eb93b3f3938516d7e688bd1807143481(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0036f37e4da711ebaae42e5afa6e24cc03c2c686799f04df0ce6b9fb6036f77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43dcceb022ecc0e3220ac4300b636f7975a654d202506366982d4dd8779336b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c859b14f9296c049b7d077bb8ba8248d3f29f92ad5ca52643a4f304c4e2304d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97471137c796afce0717d1604672209db4bb1763a685b6a93e2e342b56652524(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__447e466b2ad19e38e7a09b8597e8a521d2967e1d67e473881d3bed0baae4b683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9442a21c74c24f5d6fcf643ce36de7349e339ffe13d763b0462732226a18d05d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbfd210005f561e4c59a872a30d5b5960ab946ad1acfd2487c54c67c4cbb620(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8247d4b185239c597dccf2d42ba3e2a6285fc24b6253c8c772b392c1b90b986d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f3153a442cd944cc1c7eca4b10903c6199d712ba5fe1a2a0ebe7dbb15b9b56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb0e4f748e892f67a6bb799185f1e00346d82b480141e6094cefa36b74d1bde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d1d22e596a3a6e14f04c332f10e01e5713702f6519741e9ddae1728e35540a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45efe3fa99ad9cae199969cc56c4dfbaa0cab4614fea161d4b513d4b217d80cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff8dfd6d200eea76b4e4b6792deb715d3e7b80e0d4e03b5905c8c84b716dafd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7572ab4325128044c440f05aed6e6c8d5b5cc2e90c0b890b2db785450188a0f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414f2098545842af79cbb87be50c79718d9595f30d32cc93d3b37097076dc695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e3fa90ceab2a51324a24e29a21722277bdc9a69268f7add5184105a18228f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e65459ea32ba420773e5bf611b939d246a1342f64b624143159fbb64dc31c1d4(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b86d18903a8ef64be20c88e5e110cac128f3576d1fdd0be56d437869ee26d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b53efd31c81053d55e4e8d0863b1d803ca0dd57ccb61fa0584884f8963865c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa73177aaedbc48555f0a010899c3074d0d0598e7fcf21ecff537f88c7a2f82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264336f1276d47928a14c58d9c1fa5b10fa05b739a6f353c90430755ab62a457(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac278e46280b98ea8ce7a04963de10e52c847d651d58714b7d8d11ecba73e26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00f882a370321149cedc2288de55a72dfa2384acdc7f8529380fbaeeda7aee6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6404fc40b90d4b39a3176f2f8e08e4f76a0650533ade25b36534648275e700(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106a4ff967a4c4c259789263f4792a7843a18fd42b327ffaa0a94092067e63d4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a808448383938f494e708bdd9606717690aeb4ecd11ae38bf97442983f03bf38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5805f79dc96303e70ce8de1a0952bb61d350fcb1660f000edcf6a7f4ba8b439(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dea6640ed563d23bedf413699f392ff11ecdbdc3548f3e364e4ccbba030a0b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4961f72953e25b679c1853076fd16a6491e2f0f710f9c52c0457c8cede3853a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26fa9a22d90cc4a4147a946ab8c52208bdfc4de7f64c6ddbae225d6a6c5a1d00(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacff1d121c0279338ac2c07a45c0f0f82747095bff2c95da90889c2d197b7bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1817d9c29e10977d3ea97dd4d523e3a037935ba294d5982654f5891d505bccb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f41860a0d9a031965ff93124b3be37cfe93d7f719efb7112fd0e6a88efd90bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ea79bf701ec3dc36b19a600dd7ef92f69acc869d0c5e2016d34d3c74a26f1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca296f943c02bce1cf6bae2c7c1c1560f93842ed23f2bd62db8ecb221d7ad7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b8ab3291421edc8efc3143c61d54fc0393365a01edabf0489ec9d41aa17a266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2e3024125979b2b2b2f1b9cfb877a21477c7a1c584e7699403d3fd8e9d2a4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0776259e92548d80ac79b93502dc3b17428cb33610b881314b489f43202ef6c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb223b555cb2228c5a3e27332560e827c38dce16fb0b4d9650fe5db86d82ef3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d51b8973e35cfc3ce3ed7d1bc857c9802b764c474602e9191ebe3939405c1c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ef2a23dee0e12af07ac2209db3219ea1aaff596127cdf4743a0db02ef545ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54db1c9619ecd838cce007931bfe5eca31c79d96ddb7db041e86cf9ba75b178(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fafa081704c88a7ff526d03df5123cb09264e8ff9b81b175a04425c97c1adfce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bad2eb1cc1e9e0889fe02d9720ff9889d469c60357399c90af637909317e5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64732f108e1f62d33ceabdef57f58ebb2b2fe155f59d6aade35b8d14969b2d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881725b2dfea53e88a452ea02f6e8cee9b845057eee84568b41e09ae6a8c7da5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7dbac51b434ab2cf97941c6019b291969bd657b728f3f25d4f2e2f454b9257e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10b3d0666e90c78b9cc2d6c8dddbbe0f021f2136cc31e5221ce62f00f395c8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc981f6acdec296e5d2b4e3a4625054cac691aa9ab8c2feec10526cb3965b64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06d49e95cb2aad65eb66056b752d072a801142cdad1c41bc853670a91a41af9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a40d560cc7d37bdc3d7de0292b862c5b938d9bb231151158f745072a61ffcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e53f826867ee16548f24ab7c5cd37c9cec0002fb2118d036bbdc209e6fadd19(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd847abd58055b8667baadaf93d787fc26b04415f5fa0de624d4bf08d238c26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86619ddc45b8c9d2b8efdfff7c6e038506263ebf11960d1deb3eabbc7d00402(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b9b7451f53402b2cc3a820eaa4555da390f7f051a4265228d61fbe0a668a64(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1c2bd517715e735a62e892f57527a7c10a5d71d227b2e4c4b012039c70e96a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65152a1d4ae7771ed55f2d68fa576fb70bf4289efb46c4eb255d841193dc8b61(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070d94e7128ceec1131f3631e28ddbbf74ec634b5766567268b3019af71febad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b87178a07f5b07c2214426c1accf35b3fc83180a0f2d0a146d8afc40596467(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382f8149f3a2cb572fa588b7aee4051b87cb2229729c884358ef792e0a0f002d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0c380c1a29dee3233170e7efd4fee3ff6bae8e8c9ce0e281fa7a3ef2772cb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f322b57a2705fc37a22adb108497dd933aca34dbd0e83c46f04740fc55e910(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757c3d4ab1e26b3f7e8ae5586c1d1562f1027011c16cb12f734b9e0d474f3919(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201bd8fb0c01197c3920408389e0c9e658c617d7714de5d709fb0bcdb5fe0ff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f6a7e010f26e4be2378171950db1159feeb9fb4ca69f91d88ea287305c4764(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24d40aa1b4b0b1458edf1617468e993712baa32956954ab9721f3038a8ef9ed(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b4b27a3388e1b981e994d3c8c9de77032ff70b92ef7ecc00143272708db720(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72425e0c3c12cadf93e2dd2e32fb3a60fedf9cf8a68557fdafa8c5e02eb6acde(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78acf79deeec6e67c020015cfa1a8c8d76fc96850211cf3f725b17ea871a2943(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3946b4ed6be224137a9528429282759717bc481ce65856de6d65d8d1532f1c29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1de8528ccc7aa4f18c2f08a942a522abb9caf723df4f244754b870b0231c63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcdbea235bb20cfb986ed964571661e89fc9a54044a1e537fc898090c7723a8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb69389916fb090f23961171637d063c2bd337195fea6fb61f0e60230037a28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53c781bd24440711a26419297ec7a29f29b93a4c8896026debd62921efe0ed4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7660c769bdaf7156a29a7ea3874d4303f6dbd0c793c20699fbd0093de7eb00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d805c5ad81f78442ffa1b63f3b71d6c236d2dd0fecc8a5e9f11103f40d51df6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec6f957e3fefe188175bb9078b4f95d7e21648bc9f148718aae0e32e66fc5a2(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02918fdc69e68f4bc06c55337e2da9faf3e9521309bc66633ca6871b0e4c9490(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41aad57ce339d0f8359b15d3c2dc01bad6ee9f0ca5b06df970693063c37d9b95(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0062b9874416c545ba338010262ca44cd319480be698c49d387f94a8e23ee142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546d775639ad805c8031c7c24f0bf2909557818af62f25078520b039591d12ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1121302b988b038008f00f4c65aac491884a18e67e064d6f8a0917838096946(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f828a948e5cae110c4af20c5da252fb4ed4a86e9ff5abadd96f29dedec4e20f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4448131987987609f8d4c6af27c3e27ddd0a41227bf1cc3dba4d5e07bec98f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39e7dd84f41e2afc7447d358413fd50bd7cd60f6a4d88c6170bd641978be150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da6e9a08b378ffcd86c03131ffc76134ee8f963a0aabf5772601190e37f6ffb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385bc584aabc3d8279e267c0e6c784de8cac8ce9c0d6cf202d8f5ae40f8aa535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad8ff24d59ecf295459ded8aec7d6805df8df40c033aa89c0b445162e12fc4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf7e966d68b6a170b08dbcf3521710373c67aed1ba43a50f71e581abd3d77e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02742b553efa9cdc5f662b7c2ccda68bc4e30b8b1a0c0215091f0db9eaa8f317(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042563087b55e3750f9b19f3bfce4f6551e59e2caa15db9dd25d1916f689ea1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__681e96d28c70ad2573a86750ea7ec79b172b266607459ce6c59c03ff61368be8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00dfc11ff9821d94b851d9181d0fd38038f5b4e78a2371e2c3e3fc974f6b8c96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85306b0cd940711fad5821a0e36e628a569705d4d8f38fff811cc3375494b23(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105646ef3af15d2e1554e381e305387c37da0fe93c8c54433a1dafc2b0b5ebd8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b41c7f4ec0e1828be119779e53ae8b5b24131dedc80fbdfb307687f50b55b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd5152aca49e1cf9d5e8c3f56cbb29bb627d36ce25823dda31cf483ee701687(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749626dd396fa897a01c2c4caa376ef9b24ef03194127d88dc720aff5070aaec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6bb00ab29d5b5e62359ce5ad523e4600fc6e6552b7bb2b3286abab7d85dded(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab8b679a08358d95c7e8657cf523fcc1643df4eb49b1dc10379bdfa95dc9f04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0baa10bc65c662bdbe33db14c1bcaeabdcde27a2765ef2d0dad302bd83b718b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a4ac49b87bee8b76ea06c4f908c95c67b7d6c5eb4ca2f361a8d160a946a646(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d09e1dd63405145710189ad4bf25517b1e3bd18dbcae6051c0419a452f250aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abac1b8f6bc5b87c7a605fcad53db97a7e25a6b98783c5abad1df74537c654f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad684f2fcebdc402df32218fff7df79467ad5eb2e1f4b0be6ad1187cbf4d327b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8271b4bfe2eee213877f5340753997715e907131ef424d9891f8679b36674c84(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632a319f3552f364a2a654aab80a13edf2f1ed7ba3f420d3ccf58fa52559bfcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc31a536605e6e9dd6eaa02d81b8bad44e9ed56849170213238757994864029d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db17205869d9763c0806e33369f5f7b379ca8f2eba30b236c16bae4392e5c12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cff6b89364e969cc4028b1b8df9f5503469a480b7c7b9f5360fcfef908ad313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1520e836e0bad54cd065ef54dd6e21ba4c8e1a24cd3ce8ae33317f0af12ab7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb581cc1dec203e334a9e11313a8fa040776a3a2147653ce230cc7bb8af8e798(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee059c3ba3bd910d68f8e1198ceabd3db5bf2a0bfca41685e2a118bb7a4e9bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c5e845e3b9d421d9a3723138d58ddf7b91809c5c45d1693b3fe1740c62aa9a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964f987b1a5aed930f7f88c90e30dbdd304ac1c7c90f47ba2d66ebc867c85860(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30527d820ab2ce866328b121a960c1f9531864bc82b3f9ae70de4b85d6ac2213(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c7dc62fc07927f535c1c5856f03e6827cec52ec61011eda21ecac9f399eace6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801d201feaf5fb543fa66dbc1e63b39fe4c4c719c1639e8e4e7b9a6af0039285(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685ef8fa90a8b1ed4eb7556ba1eed951dbd99c8cfb5cea1d2f991b143c2019d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2431a1587315e2d31baf4dfdbd9b08df1b03ca5a6ca12c692d63835b07049cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826bc515973d783521de00bb8f557538ada2ca1c2b36e88bad0d3a46f01be51f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b6fc924d62b3d87217f7d458d47846e63ad97f4c7ee2bc66bc875f2bca9b30c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90d5f4a826879fa6899b37fde73f863c6fd9364755030db756815294d2ee202(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec0e991264ad6de9d6473b4eb47cba3d37726cfb9261ae53ca82eb619321b3f0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d42a41b49eea9d17b0a7765b6b8d65e2e98c26e2a9208a38ebbc0989e9167f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e40e9a9c9da426ec647bdb605410ec4b91389db19e4fce116f657afefd4a2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a073984861cb7c586c9f599012515f0b92f353c958ecba8ac71b4327bcfee28d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4926e8c9cfba4bf955ba7accbe4a4e309ebd7cfeda34a52f4c79658c9b3f06f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f1f86432e0d7b2f83a8773ad7b04a3381439d378f30f04c639859c3fb4df84(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c6f4da98cb2ccf7d56f91115d3eb067b2ffa879b9e03cce45d825a69413896(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057994b3d3b3c4aacbc19cade73b8dc9dc02b857ff25946e3127069248566b28(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b0c524e69f18d612aa30b31800c0291dd75baf1e0e51fb77f28daefbaccf4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2afc576be5b6015d7e12c5d014224f2c8d8d5d20eab8ea4aafa4cb7ad3fb47b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb0deb686470ea2c72f454394a269a33294a9d43609eec55710e7b435ae7465(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab032c1a8a1b24dcdd5be7ff02fc3f9c2e9c2115dfda016f7ad44d53d496408(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4beac110adb1046105fa0e3b6ef8e724c6f1a9c5c3d01c407b4da3cdde0ab6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb379d099aae867d06ca4f4bff269bd9fe8f0dc15e9b7cc49207e3d8b06fbb23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc097084828fb38b2921e629592b9d184b45f8e9d4efd33eb23e18138a4715cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc9726b8e1bdcef7e893707e2cb946517fbed7fc641780bed0faeea43121e91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b93943ea33451f8ddab917168287206728bb86958e81b89317ab64ec1f01400(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884e416d5ccae99cae0d376e41ac22ad9a8a6d72b9ee3ca970509086e8c76a67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e9d01472c7aa289e92255fd7a71193b2056971d8c6147df537af3b19fe6555(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f80e54974c08d0462f9f68e6638713a4d96e086653fe5df7bb40e3451269e23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5634dd6fa6fa5e52a5197b312e8fda3629c738e6d962cc281137219b8969aa67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8760d9e8733b954e8ce67c66c03468745d14ad57e058eb1364111b304a881853(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85421fa94398d983320d3b6ed1b6912faeab22bad313237d92bd15c808f3cf0(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003b517fc8b44ffd7e8e9c915377349d1d67ba889d0559610e8ce76de5d86c79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28faf30a718c5379c487221e0c26cfdc9bb27be8ef87073b81226a3efaaadb3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7cc83fd84e18608e1ec72d4aa377418b3eb19c93912fd710b65419512af677(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1946e60807a6b5fadbfb140b1a578ce68a320153dc0f49333602907d065e2d12(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6196a3671c094a34c6d0be463cb2e36c7ffc73c1058504f28ff1e21ce2717d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949b295ced84874a66775638e28dc03dd638df71d25decba1fdf87d49ff056c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afec68c2cfb45d1e789137f529ed5ef6aecbaa7fed7b184d91e1750a525b9829(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df70b700c264e4e376f434a08a8863ca9a0fc6eed69497660a05f91c23d94f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fcbe3049e0a26420ad29dcd5090688de274ce86ca0ae43b4c3247f2c717e12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0185291d986656c2688b98632a2bdd87236f89d97ba063b741adcf5d0dc1c419(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53dd2d59ee0f48d33beae9bf1d9b019628fdf2914463d7ac3e53b09c4fd6153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7551444a868d25405e7a53c970ed856ce3352690180feb08cb986ad52cf43f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c40c902f551293bae91d3577b0a3ea404ab3c6f76bdadebd9c821cff58430c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb20d9859cc139847f85aee6f548af40413b8b8e07247b72c984fc08c7fe57ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bfafde838841a34e140f5e5531d33274902d2de76bf2d97fb3fd064f3cfce48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148c47f37e982b2e32acfead59c88b482ff2d810776fbb9d369e77bc43dde28e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59662e8205bee603b280cd78c750d4335eff0a5caa278a8c2e7b7308a7ed9a3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26a45dfbff32f55051f8219f1707998f67d6b05e431e771d1590511e07d973b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6dfdc407aed4fbabe181062079feda1e9ba4131d4d69885fdad6d9e226657f0(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809045b429efe5bda2cb1bea2548cd2564c46bd57f852d1615d348f89b79099a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d689a6f627612a38b0821c298c87eeaa5ae9b1178e368a7baf10723f807c79cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34fc0811aaa599fda2f91a6b82ed2b2c14e6b5d76ba6637c26961608a43074e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb657fad8c026ff56acc2b8eec3aad87bcf6286e854262be3ae361d4ca52e64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9845d483caf15f3ca1a92eeacb959138ae21aa0a3a16565b58fff1045780d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559954f7795fea66fca35fe037890b8a99840d1b386b08e56c95edce66a29b1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485bf41447e2cae16f6256fd17457d0838387dbc20905e34a15b87eb6c1b2455(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444dae43fdf5e1ac813fda820d9e1f1ad4bc9e16ecc5d067927868b5c5ccf2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f1e7cb693fb17ea8073fb0302344d3e78293ff037ea2cd57206032d6d228e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096ab6ed1e2026d3faecd68755a7e4edbaaace4c9dc63939485fa9c4f52a24b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac1e3eeecdb1a3a3bbbe358995833bb85fe4b8548cafa46c1621588d6ec6f07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cece6006ba791c367b902ada41b18749fd646c67687ea00571ba40fb4fc7b2fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c483eb9fcca9960b6263572284dc3fb4605a7cf7bbe6be2f104cbc5b90670eb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9f1034278740c6b339d7716579ce3d2806161ac940834716c35e6994603da9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f972489ec137547ace4e5e5bddf89704d6ccc5d1dc5320ead32acc118cb35f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a685d60111d6afd26ddce6061cdb864ab15f7d8bd2eb2779d82aa790d1622c53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25a47225d62594387aac3fb23fc5553d45fd35c657fc93dd7e88a5ba9244f4ce(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072feeb00e4863c8122b9a196dd5de816694b03e8952f40546f95234ed9f1399(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__539827b7ecc0bd82ddd7144c7f693a7e3f06eaa5b1494cdc100192aa81419654(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63323ae34d525e4449f36d1582d5f9be3288df16fd4cf34733df703492f4be08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4eb98ccb82f8f577472b4294e43aeaf316461e7452257eb49048b82f911ef99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a5e9d34edbc2bdf47ab060fc38ec2b8b4368dd528f3e943c08eb813e56aba0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76bc9c5996b1575f70a0e6fe2633eb619eb23f0e9a71408d8b15439a555b1d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe870a59d0d0d3e70fdf8421e6e689b7715ddb753383e7b07b8470ea3464622(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bbf1962da14be9fb63ebd8a0b4ce366dbf21d9f3c4dc15d8c6e09346ccbd031(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec96c888f009e4bb9c479214485d999f8650cec341095dcee16b2939316b83da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe4c9b33a1ab147d701542a28b2b3f436190360400309f4827acb0679f9db87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c617bd98a3165e8e921e2346ed7eeff44790d8462fbe345c2ee6cd3e165dc356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199a7936ef0929879500e201cc5b2f6d8daeebcc7141d121d1b3be6078df9ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972bd8e331acf7bb0251b28a6bc4a247eef858aec31d9020d7db836d40a10ea7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136b5f37ae352f46038d84c2d42b43314eed8a825586b6fca4e65c8d48aeb9b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4d9e2ab47f6722cc777946ace81495bb2d1de926d05f6ec8ceb8e394aa24fc(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d908f289fcc20f954115fe4ea279ff0c405b1d57254ff47f038f68dbf6de9b66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7b7747fc4c583a32dd46a6216615f700531b030e53e72aa9c53f5bf39d5b3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c792c1bce879c657286fbda0d492e3b94aa5b24fec3d931cf237117755809132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77000ed3289e0554ad672caf49fcf09e98744abd0d051fb1a59fdc5dc23faa2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c7c682f82a7504428c0c4718ab9f04d9fc3276aed2a214c1aae1d52c87aab3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647d8145b7d1d8472c02cae2cbda485b2864080215af932c2a244956fec88212(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1573320bb8bf6d02de186363aa9a88ffe0ede524ef1fdba4bc996e8c58f4db97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b9d514a02f32f9af711e5e04e762b142dc06660ac3479d12d1aff8617b70fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1d3752272b45016e87764798e9a65839adffe01299da1192343bab4afcca909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0f0da81e5f042d558802df029aba7e4c5cfc791bffaa645367ebf2188de51a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6407e446737ce197fd69bbef4029ec9a5a6dca189c8994bccc8f674b40d576dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24eb034af6609a33908349e335a63808089e6ad01a40967dc09578b149e83bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d607a10ff2b30272d301e746bd794da5f7f8d0a395650b8724a62caddb45f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c14da8da42bda7104151d332e54897a984e5a0910897b99aef5cd02de2474f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c8019b33383adf24084311012e027796327b5c11346ed534800e2aef89fa191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cee79b11649bd6db5e099fb8fcf48f6034a6ca43411bb705cbdbb1d8fbb3c37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54293c1693575b281fd7d3eb415420ac385543fe4e83db34c81dd92a89c02b1a(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2654b8b19387d7e83273b7063163b47039526951407942070ebbd2b037b5261c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6fb11737e142ad3f64b36064eccb4960f431ce898f5fef0d4a8154150e6ffb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e812a73d82b5a76f0f024ceac23d9eb31e77b4254c6db8c9043ab44707299b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597c9e7bdbc348bc9eaeb9fd8d34a3543da04755533e6360c1f73b7729bb3f94(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea8689d5896c2e906472a24ed6230c77d9ff73f452e5ccc015dac07cc85d9152(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98631e654decb11d1e210289347019a4702ac8aa56baffdd0db7101262280a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41afe6e938be36aab755ec3001a550ea0a3b0ecb00313db2bcfb70d07cd8a65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6b88a9df6f5a27a1820bcfea4bbac29449b86f0bd82a90544de2048bdbe63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff2ecd0b1e660c9c4213aa2a7055fd8cc87d49a3366e7132384dfdfaa1718322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53050dda0ace72170920d2b674dff4cc6ec89a7498a6f941579be67d642cdbaa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7858f74fb428f54f4e1b0409d50766512e7e23333b7200038c293f79ef2d649f(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c378e80dd8fdc5a595d36b0bc3a886fd0307e5eb294a78eaccb09093d2ada2e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b809dae8008735779ed86a86a547f85516687fe563ecd14eaa7a42fb1e13b04(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50dc94a874a45d51f7afcd9e0d0e1ce7382b19f569c918b45e47678ae2d8880b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee3043d83989923495a6ea4aa7ba55af2fcb1decc0c2e521fdac10e6f1b154d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea88ebc1a11b42b3a852c4ee7284fb951b809af2497dd55604e758ffe445acae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71645baccc504d2694942d3acbd75d85e47319cb457bc7223e0fb621d8715474(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f658f0c19c016ddc95a0361d11d5fae91fe62f018f2aba1df5abac99ba0b9322(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0987d4380c7ce49dc72112e217db6effdf5c6cd694e44ebe18421208ce9428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea22882c88ebf2103fbefeefd8fe65d527b8973aae77ee2a3aa74c180a0da2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1119f20d79db95c79975afebca1c8bd496a540f6d2f6e5a547e4486bb890664f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7857dddc42ca3c2dae4e0aa12dec9bd21436b9f46666fe7b3f552b47b15ff2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd3c33723d431ca30ac908fa0b2332c9d84a64178a7c33b6745fa220ee70d00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d5a707236943d4533cdc195f63553725214609a2487bab204b6b264b8e5425(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66264d96f3b3fd3c61003257fb4b5fb874921b2e56952a6725a89d2b4de42249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84090657121726f232e81795463032d5c32dad897f27ee615e9af7b0a56a8d98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca25edc5adeec3d47e115f3926675a4375935d4b635f59e96334bd6bb57318f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343e672430f50a0e49463b2aeb34f50663c5f5257c156c2c181fbd2a78f9e2b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fba43e2a13b728b7ca6f1cdad75a08033a24a96b5bccc5c02438fa343499568(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313a4d28d6ec5dbd334544f730d4d0c2880a7654fdf7f38ff14580cc5937ce47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1cb86ecc18543525fb68fb6a1ff99f9a79c43e8cdf8ceacb93610328446b83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c72d7fb2013fdf8c4bcd3cf1fc98677256c659f43680391063dcb9ff2638e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d8686791a5bce94e60b5c2d0a8148b73c799a627bf0a80bd45d0156d924f52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c508fc0a27523f383450e627278686fee91dd088bad42f28edf557e7b38e5efa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0486cd3c6c7528f8857a1858bdc080837693f868399358afe0b771900c786a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1b73bc5949f7a189056ebf9b8be6af6edb92a3b615359fa7faaa24249c58721(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4d444b4a1e30a4a1c4ad884a6e80c3142f25bb84db82b64d08b39665325170(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89790a159287e423cdba1f3fa04b75ae309c98f27120a662580dcf398d4c8b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2842d1ad3bd7e03f08061eb7613eefcae67a602819b52b529ca2a15685957cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e75af1b454d3608770d5b3ae50a31fe567eea7c39a032598c9d5a27405fb68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e72137fa152154068f37bb1904349eeaa04b13e2cc1627f3ec14fe3ff5fe60a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2849a91792e7f5a919c7b6ae951c38fef40e37f9855bc8cad2561d8d50ca4e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de592cc1a45160b776ab12ed4b7995c0a3ee95d235fddc1007ca710c360bca8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6d004652ae0c3d80e39177e5db6e5110ee00a324ccc9616efe8d5225d517b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66756101024501b9098f88d26216d2e65d5d79d1618b047abddf98f77041f6c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f03b16091537722871483e6b4d14b5d8bf1ca5c382430250dc6ec64caa23110(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2233c79b85f3254e252b0809dd84499a9b934e17c6929ac6b3baa4eaa993ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057fae40e4a52d0a1182b30a52df064db67c7bd5174aae5b7ae190d34170b989(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a2049ba666f36c066249f0e4319ee95b6204ef1e3dce1951460917d176a69a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2bdced9787f61a1aadb12ea24212b0b68ecf571e318effe8d38be0b833c8415(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a534521b10ddfc874d24ec5767eeb4791f3f2cfe6bc164d7bb975dac27771cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6482ad352372319a5a6593e9d8439fa538adf6b946afb3ed33685a2f0c714535(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a564274f58bd1746fca3dce958c237680c677d3a56a279b09c7873e0635854(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31ed05c4f9e3931580ac8f5d37970b9f876f0c2df1b378fe488f27ba76ee041(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64d553105843ac7975e60ee06990357ed99f92e546d1b11dfa344dc4347260f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f3f9fe05a7fca62b37fbde2df62062217bb94ad80d3b03776be9435a421a40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4edf8be591fb0fc9793b28e68c3ba55ab7ccda619418661396967b434fe7f101(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda65ea8124c7aff17bd4c8c4e20f5cf9b764fe4544bb24873c06649ee280b01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d4a9d3cc5312d7c975758ad9e3562417d95627126dec81dbd03d14000db316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2695085e0a9a8a7e00756782ebd09561ba4eaf4e10f30a12c7471bfaa219fb04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f428a1cea5a75dab79e22d3edd678e66079a93c0ae088292b0bc265622084204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f951e6d095199523fbd6b2ca2206c43af56086af37249b7a5f2bad743cfed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d30199be54fbea3f2cec418edf28f5c10feb723dee2d64c6b074e3c59fc4ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff30c334b2944a1a85e15235ea59e9ef9497b635cddeb049c85beda2a84dfb6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f7c322578a73b7c27cc79e06f0b33465020c3b9504f7ad9dba68b95779bab6(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac295f3e1b065c47b4f39484a7dc1247bfb31d7166b5f406fbbae3e5a5aec5a7(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8c504eca4126b52b6b20fced054ce642352185ccd8a268635142a5d0bf1ed1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc8a51a7cd67083393c2a3ccea7e4c148b319c1430020819412e4d63bff0b8f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49babbf5b4b0190acf2bf633de4cfb1a05c48b0547de79dd3290dafb888873a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b737eb50669c67886cf767ea03b63de5a23f344a07fe5a9574ba55afa864550d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d842e49eb00784234c40886a854f44043b1a181c934a669968c7a9cf124175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c37fc8ea6a787c1c69a47ec6f4fcfdec169abcaafd71972a9d89687e512df85(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf43c43e878d00b7ff192e06ec7780b547b8c27b53bb63cb4c7883150ed7f16(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d23a2e325b21d29a88f0d0ac805935992f92281d19e351519daa147f5b8b287(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6881e22bcc5341633e137a6a3c3c2ea01e3eafc402557ccb42521987038bdaaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8596efad5556180beba6feec547dcfb4b6431ca68e0beeab56563b009cd3c20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca9fbfe9bf272aeebaef52e254f1569d42daf10fbb4516d4a81fd67cd81eb0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c4c34899ea568531908171d1cef3a9ebd2209425ce2af650f09ec3f53bf7201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73751336b04091f5cef74b24bef8ec1de917c8715d0721df71820ab4c4e34ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd5a12cad4197872391ea017e957e0037110852cfaea00530f92a39dd8e43e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f364de457d0e13dc885cc2f8a2ea7cf2c6d22afa117abe1c59e042f7b4431058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e9e71c3dc466a1b77e2cbfb5ef1820dd655e56441ab8b198a232385a04d8a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9af00ffc80707376aa67b2340a01b1e4c63ff29497208b4e96a453990681e7(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb43b065a8957ab7477f9c7bb56d9f10edc3aefaaefcfacee37ab96578bfe98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc40fe1ecc2bde3f544f1b62c8f628828f3c10a596c577e1ead3e6c77f2c2e0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20b6cd0b05e9354845049a8513c52f94593eb8eccb405f0c128c09734cb7863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9587094b96487e70b65317a092bc5622bf58d3f8a771ccf8ac8918faa845c92c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f693d4c14d18e2d57c37b91a2102b35474d3c2e2fc2cca6c6a443cba68d3221e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e01c0c4fb34f2b1c7a1fa6bfaa8fccac6799ab74431077357f7e64469a789f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3116457729123c9d7b02a1e3f7b0c2d32a353b63a96073732c8e70eef5fc06c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74328b6b5b0623cc4c01f3535c7ea96bc3e08e835373342011846e25d2481826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e11c597de42771c0f3cbe93753fef16c945dbe0a7196d529c7c162661fbdcdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897f03445ae863f161647dbe86fe07895d34db8e0bc296e292cae8eb6ef12623(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c3c8d1baf4f48c871c39d82a2b35622a97f91ed924a87994b58452caa0da5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b566c5565d8b8f39e418d7c791d4ef6f03466a50a37231ce08916b895e51daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508b02d9de46f3882813cdfabf809bf541a8e2e563a3f3c897e96751806a964e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e21bb72c8dd94afe59ea99ee4dcecb43b2e2806ca5495f88762681d18487d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064388c01b0f9ab1979344cb17e54895b3fe3d270fa9a8ff3d14d3311b4e262a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2381c7c74015516b469d8210201c61da0674a5aff4cbcc36d6f7a482ea874c27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4acc8a4389edf149b60249d561421d963b3a91d753dc1c122d05cc205262faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d21c6ce64b88e2c66e00d991592ecd30a23aee419146becd7a67a2abf035328(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47efde38404d3c381dbb2e147883a76501b251f5761497cb25f818c498b152ae(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8214c44e889ddb3d801e7cc6a364c852467c4dea427a609901f27e3b068e32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5eb6f1ff4ec1fa1a0a05d7d81ae68beed39c72eb662662a676bb352dd367ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b4d5a6524c6a082b1dab0ca41868fb102acc2c05231e691b698c8f093b9683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916d0071328d809eed4ecbda37ad2c19a4c2fd9318631afc557128975559e2da(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abd472f4d814c7b060acaa78b2a500b4b1e83c57448f7da36f9de0137f53338a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40eb124cc343a4c98311ba32b6cc230cf1a77914ca5e8307d7db659bd19cb38c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53305de4f6162e74cee62c5ce34ee6256058be70372efba6c3074e8643040c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e39d2f049d20cc294d8570a5383a78bb4bca71a9031011ff4e7f5eff1248415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72aaed0393e9975ccf3f5c67b34a550fd07533c4e6ca29a5d279c3a8395fe880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847c16a4c1d28db2cd754c5463921dcb0142e1b70e31397e9095a94751f816da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceec65761b1a855076ac5806439c77c8c61edd6fdf9d6b29f3cf3ade336c7412(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb1c80316f31c139bd51b652b86ba439c429b7bfe82200d31cd5aab6785d9efe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d677f81384633cbc5050bf1c2e2979fc941b11bf607c45159a50dd5926132c20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1f94643d75acdd2b6b7475a642651c7b5fb80ab75ec269ebf82c65a0015af4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d18366e5b9b9a10d311b525669d4604761858dbc426e59a5f7c66a0436611c98(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263d7f8ecd86451b5fa4ad3cdd7faad9399011acb7262ca3e23c1cb86b27c5da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca4ca6211132b3029956c4f3eb38671c54d117b932ba3853ece356ee9226a99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f282300be3f16236b0deb46d2235ed8e4c14a1f9a8d1ffe3ed4392652ee79b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafad2b44364f8cecbac1ddc7e83349932a6512569c534ae6082f823e02509e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1513c0dd144326aeca616e4fadfbce2075ed2bacebe9b78a44f6f5cbc1b9516c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f005551175afb4827a63679dd461c250a680139dcff60c1ca1647efc1b148782(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c506888b1f1433f6286fbd956c82d591c80d7e4209798a2da54d0a79c8bff89c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6491c05f42a25fdf81a63b236c8676a2a1d99da224113b21e65cdd9c0b6691d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__827ffbd2a4a839d819962d789c611e8e252fa24aac708d9a425d82047ae0e6e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bdba22468cd996f580c93677d2fcb7f2169be3be99a81ada528f398a1c0469(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a300d604b35676d4b6bb2b4fc3f04d01a4780a49f694e3aa2475021d4b0a30f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450be5a4622c2a34007f7b1000d5af8b7085ca7e7313ac166f0dba363d3b9d9e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd1b68492415f3fff0122615cd01817fa7ade417cb1be0fffb2a383997cbbd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111f01a9fb07904bd452aa3157d7426da5d49b9f9e3595b7a6ec63f2a1e9f915(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad6c89cfff8f8ba8ea5c7d23caf4610f9ea3ea37f124a85f3164c5f9de0dfc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a1c58300d7fc28a30cadb097c12fa601ffa37b2cb96843c223d0938858c015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9d602389360b244cbfe570f1b09ab3c926fd296dd5662dca0b8a7f0769b2f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265a99fb2b7d03cd4e3cce49dfdb493c0a4d77e017da68de6881744bee7fc092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f89acd2c6de036b302398d53cc4b226c944fb858cffaf3ff0bdd1187a3fa6c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7ca29121a720d5f1efe85b60119a7984f99d1591e6a00d90a63abc4a0e23b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e16d60189344df3d51a0796aae249556a8ddfda66a49441ce679aa464db67eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddbb636d00bad578d599b278437119f0b420c6003a64c3c802523f6eff6234f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b914bcbb462b2048e547c629c7023b324a4c1675ff748531e37c1abe4cee70ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404ec2d7de3cd56c1d80ea70677941f3cb7aa0cafa7593df3bf817d251f10aaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30eae86fd3be86bfd4e6ebe2e19c3e62cf9b199296ef1c45c043cd2d51a9d594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dfc7bee3f43cb40ae7ddd30f457e02dd44850764026c5ab1a3043bd1743821b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f1a29057a9ab4a6eb512dd26c64567825a2a336553596276dfe831a02dd3d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa189c1e01db028cf5f7b983ce161fa8e5a1d4a71e50d31fe6142d5d87cf5a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3e3cf798bcbe06fae71d436e97916e4ad4a3d27cbf7c5451337ef751919a38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3a5adaa9ec0a9b86a5d35c74fe6d3e2abecbaf3f68359f791a92fe7a9d5acb(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14596e1c65ddf802881d7bc4adae0bdd97a9f218c4b844576197d7b44378013(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0aeba68ac0774751b95e325bca913af41ad501fc4f36282d0423749e6aa76a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0e99c9ecd5d5e256b1616300850346a30ae2ac38b2d108bfe8ca05db57d964(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8c8b9d68d9907d455b427fcd88bfebf2c9ff5a54cba5d7b27cda20aaef7eca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ebb27fb058468ac6c5e77e8462b9a48e0ffd88de3ceffbe8feaa3349c8a7727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a332585d33c455e6b1dd7bf8a4d144321f09f729e72c2082aff1bf420748753(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea009b1b035f7c4af066b53a48ef4662c55eb36e1e07f7234763c229f226b5ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362ad8ebbc9b4294e6582ade96d326d7f58b58ec2080840f3d5c1e20339b85a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf1708e49d26d23bc83fc66d5242ee3092475f04f1fabfa9a1ca4bb07d33f54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6a5e7bc085b8bf60bfe65622db5ebd55abb2aebc3e55c7eac4f88572763d46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af6f1873184215224d5e9a6dd74700acdd25488aef6bde6b4801bb5464676e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa5f908b447f268971e78d909dfa54cf1b9e39fede5c7d98cfd8339d75d3878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1570ca956b81b1b05fe5b6af10951c8ba385757a63ce22d7d47c3a6e74d60f9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192a7e08f478f311976171f953e1ac1fe5f6b7cf72cd8b343f7b8fda89e3b9cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039bb6406234e65c2b50d9806674ab222e2125a68e9f7e3ffff874df5f784183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dad50e8868bbe62d59865ac2a3e401b0edd708792fb2b2cafa2625ec06c2d6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1220d1f4e0b48b267638aa9170aa9009306045a4ca161f32445c79fb0afb7957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239bcfa325011b0b0e2b65840985a50f1fcec6326f6cf0744e4d047f2ed9f3a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d147a312b78e6d30c91b00bf86c1fc5233d48aa09ec6601c24a14cafd62d14ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36d861983c14a57b472c18cc6f02a8d439f43d567a641daddce1e72fd4c4d69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__372407e9732d24d6a57268ea196087976f5ebb7568a4410ff055c9e6730ad8fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f2abb7a967eabd5a2a8717e863d3e767647625ab7c47243615b9c1c62f3b1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca37f7ffae53369c61cff6e3635646955e8253ee540717a3dafe9529729d912(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da8603cc141e578f3d216d51bae3185176f6d65387549307eec111fc4a31ae5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5829331387f39f08d84f67bc9e1c8527686929492d1ceb18b94ecb3b5211912(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573c348b7391928508d506b61cb430197934068761f9ea6d77c9a60f67a1baf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9288cd56b781d221cd0a4cd8c489460bbaf2609a261e52d27673b80d9b479a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a101db5835acb49777cf7ae97fa9f9232098b38b29f5c062a3a05476e6bdc569(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0d145131bbb0a03caf8352bd264c822da34fc2aee482672c141f20f2565af9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9838be647589c059d83c252349e4e4fb850f98499db6ec884d7a001c9eeeb3d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91490c51b4636d4cfdb1028c49503c1978edc4f51c1037e154ede132f897d7a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c918add0504af971472bb4945344fb25fe94b028d1f2c347f99c8a70cb0173(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1091664ed842d0d1562c9984d06b7d5e71f5f0538bac65ef381e40c619bb8742(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fbad5a033e9c4ef0a333a9aa85d9b75a9c536d18962d923b72225cace8579d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95965bf8a29dd0caf940fcf4c458d5391fb76058571f7c1d9571d22b7862f13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd40a3fc908c94ac136b6a1e505518e87a2f399e57a798b0c7308e655886879(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a447e4c1cd74ae424841a25728e984e54901e6c44a52ef52e38ccc9efdc17fa0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e053ab26207fa2bf6c914dc27847fdbe119ccc58da649bf97fe0f98ee0d765a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa999f33e998afd4e1bbc2df5f6e41854dfbe4b242226bd6280aa29e787e2fec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e6f7fc46d9a15cc12499fe5473cf9c7f7c8e93dfdeee003ff9fbd4454b772b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b4575bff57aac8e68be51a18f978d6831369d0183a6778cc87f4af91c90381(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e373328a6f3548a704e0769fbb7585eb2a045f29f6c08686b321ac63de730912(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c167976b20f39ea7e9cd40ca493ddf2cfc471aabee67fc6c174821619fc95b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0ece2c90ded991e2b59d61329e6cd00d1ad02551dce3c22b16012c7b612c54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8f36eecaccc18e496a2ae2bed575066fdc26175b518b93ff3da55c98a460de(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3bf2103ac4cd0bf395df3b28d4cd8407a9c92d80d5df9f144b61db5c37a7d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64329e49dda770c90cef43b10d3c9115ccfdb14e80c2605cf77cc93fc9e32412(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4752e97a902584d0d86d7379071b3ead2cb691a4acecdfa7bffbccfe87248cea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e640e8cbf82677aa2037c7bfe40bbc42ea8210b6ecb1cddd4c0b7a2aeaa95cc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca19a04a4201e5df06aa6ca1b9cf3fda7e019fbf35858e5590b2c58ed2f7a26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac951f8e8b012a3807772d664bec54ef702d0c95b61a396064ccdb77dd51243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfa7c204e3472d5840338d18ae7bbe691453d32bf83a2771993344af9dff78c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8612e694df6b0b6f76b27888805a603a8ad644e0efae23ded58e38f6d70e72db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0755ca76daa7e589d8964c5b0e3e12d2b7f2f513a3c79bbaf7dd4938ea1466b1(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__299e615397e48b136a2d13efd8f6bf30369a9126b2b52041050641cda56d6d4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e3f5354dd5c106660e74434194271929237819b2a7f26004086aafadeca57f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa26b57e4f28736f8146f178947a0cdd93b84d1cfc7609c971786bc6491a78b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3253669e121b77663a99ba7bbc7487f524b7d7a13b1fed56cec52d9f8aa9bda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e736b7685468b5a17fdeb1f9de737d1accf27458fbf302e581fdebf0cd08e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089a179380445b49b2df4f444960c8fde5d573f9722cb10c042b515abf827bcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a632f48fd12e2bb6116302d0be2b20423fe07f62b04ab8723ed3140daf01b63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c39e6634de35a37efb7978bed9eb806939e60a76e8c4398cf0b101b7c4d4df3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72938fc174873577ecec2277e8511284b6fbc23cffff7686dabe7212807be6de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9b553e45ef20de176c0be90f535d16a4d590aa0a14eaf9a9a0d04b540d11a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef503dc71eaef217d4095b7a2a36f5ae25fea1248e6d219b615887c106b6c5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769f2a241176db5fc380313780d89ca3e8f9b21e5402fbd28acd00b735509831(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc477c83f2d04aed00304a8ad8e0f2f4ae7b936b0d8d6f0c60634abe2fd51d9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af37198bd77442dd8c61c3c5a73fb06c6e4963d4549c1d16e030d59019d9d91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd17861fb96795a9d7c33d2df46251257c4537086158307f89f5c026b687a3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a54c8b8b73f71e5338900c9b68d0af7e5732b3f6605100b4470e451882b72fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6508b15e577e2c3847a2b6f667287d98931941f557aa156ebfbf6837035442ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44fe8825feece745251963dd60f3740401013b24a847b7a39b6c5974f205493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e555b6ba7e82ee5c48b958385611d79ef82d4cd15975e60a1f96a9aa7e6b555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e24c972049fa198758446a3132442fbc24ac625a3293afcfc95dc841c930cab2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa2ee0144b641f29a8e43abb453b45399106015a7750fab2887f54d8fa344ca(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a1ec4d3a2d06a7ba3e6875504411749784584ce93476d9540d59fb18484754d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6b4c4d370852e1fd9c7dc563555923cc9c5a7f168225beea60fcc3756bbb35(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54fb694c44f8c4795205b3c873582dfeabf38c821bc72660b2bdc7d03d58e73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0192b9c75d96c6e44cd136ff9df122530b78d3603354c3b22218b8a93525f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__641eec2648d3197f2142d226ff43fa801cdb1020bc36e06d74a2f6f08238a449(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee989d65f6b1aad968146bb0ee7b7acddb1a9321517aeaf1249c2199b43824e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb21b6baf8518390091906cd57f2c2ed027e7b215ed9c298ad59e47f202325f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f23de75ee23a54520db9f975fbe36b1f3cd210788d910f4c3fdab4e135cf19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3dea8876cf29cb82e37e99db51eb267035482510f1feeb0ca12d9216cd871b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5321e7b625b87f1e98ee0c1a5cb767b83363e8d86e019f37fd57306a244084e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a03ee1921ced9fcb9559df65be6568237997232f6f90ad6e27c06a5a5a01bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0461d4f9e6530b2b0d7178da09de71ad5a94b1b2db02fc1f5653abf2e0859906(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad4a0138879686d5f2a2a695ccb20e82f10b42165dff74f2e342ce4f23492bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3551b1f8d7c999a1c989afb9253f0492b42034ac304bb55a61099b75aec9b9a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038f768fb7c5084fcb3fdb7a25561b86ffe75dd5656c0f56b70fb24c15b8ba5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2cd30344bd1c7db025adb2fc996fb16b772a6db8a24f6c7bd711c339bf7d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0c2ce287100041a5c1afa99135ac7f34d7f176b69282196fedc2a4b413151e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9fc3321b2eeab88cd3a9b24205db817c9ee5b66c19e36d23f009a0771411ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4934c4b55585324fd893c699c6b55d7ad1b900a3f9db576e5ceadf443ef13c9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2887bbf5618a65a10fd5b1ce3478e8fe4217dbb36aca95e18c4b1eaa705e5b6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e54abe1b038d6cd8c4f590451ba7ac52a32e028c386584fc68f4ed7c9e1438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a94539c7194b1b7b14c93420e9a9da6dc84a723d0b4a5dfe27ef8d581bfcf6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d4d5a266a0dc598dc917ecd692600547e90a0afeeb5954a242dfb3ea72ca13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622507b2ca38b248d0054a7b734e2bb38bfeec72e6a19cc58b31908da5ab8fae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d464e2ef1574c170d4b5740c28f48c4714ba1fcd3a0618b2358440ecf2bab53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02f58ff3a19c6f94e68f44559f6e6a1e26f52adb0d49872c26b8f16a72691d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1d761fd960bdc38e368d1e9cf0ec8d720d80b90617ebc444a085c1a7c4fd5d(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ec07b142ab1063df08af7975b986a70fb9a18923d1b5d1eb3a3ebf1111c424(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae64bf1690f9177ed95262c57c59383fae519c7eb2598fdcbb70cd4fd0e0f510(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7fc3e967da7f638784e4733be2dfd26038f47eb15cbcf6f600fdfa84e245f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3567d09dce7e31b086fb923c4a4c11d4e07fda725c1ffa412300de1b51546fa5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c139067dbae1dbbbe31dcb0fe92ed31c3afe72f3c103b805935f8151c19b14f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9c9c8f7294fa01cafe257626618c949270815f164427b7476ae639db16a2f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35c93511e69489444f4e662b2bb44b8262fefec35bad885109fa60685c85be4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89906d2284a66fd7818dde620605c60c0e2e5234c5090bd28ce44cb0623fe80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30ccd6c455afa003be65f416ed014547722a548dfc6c8f86ed03a1c5a9082a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bf8158d55337e1cf58daf80aa04ba3d58cb0ce6d4db9082e1e42300e402fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1764fe92440dddcbe466f219b79cc7b1f4df757641fdb61221c8c0fb0cb42ad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a22efc81478b6b482f34190a3dca36a4267df0686747bfacd23222f47fd4fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c56e96f989c12c00df24935911b2c6503af407fb6226ded4e3578b3239e47a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228a108f40e93fa1bec0dca7714e3743187cc437779a3ef9583c5b5d03a13f6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9087b68b1814182fc669157a7c4c403147e42a074d2a62adf5249a3ead8fef8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1bada8b8af10d11487a2657ed5848c791b86ae264ad8b454941fdc0e9d8e03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6932a54f0dbe01e7f4fcef5d9ea63fb90a5fcefdc08f3bd45a79b1c872491190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22c5d5693046a3b3f6bc084f13e26c079ac70e56bb516e182f2c739b645a172(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111bce30bb3e6cb6142f70f191e245c2e82a8bc1af9fd99e00d1b5348fb2bb3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab61b5cbe049c71afa1b9ca592f010ffa68d2a440819fe7cf8707adaf3c55220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408ef2c213b672e30a4d1d2dc3d1ff59ee5fc3e22486c22d55a888830b230a45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93045ba6a8d5925527545904c1100391205ea5483e8209e9b99ab05b4d48a55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7407b0b3aa8e8dcbca4f7c27fe09a65737bb9c6137837dc8bd11e226542968d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c376444b02abd8b7568b763cd34c96255284539dd2c6aaf12c22cde74019b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6933f2eaee3177dd5a00164aff2155996852ccd70a750eda59fdac63bd5e4224(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9791c5fc0d3378b085259657ea4a4847a289e38429feb4dfbad1a4eda1cb0fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da111157af06ab91c377a1810f7936606ac7f0fd0e54c5a9e9e41aa901a08bb(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4b137431ac6a8a6eb6ac24c3bb5066b3ec89414dcc8e1928c8346201836a8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac4f2515b563d48a86880768b282ae8c2af4a4d18f46be9be6ad96e178f2ae3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54724af77812b7314619d319798d31bb7fcfdb957a413e91fead433f5a604adc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0481ece2052eb8e4caccc85f0e1d18b14c436a88a690013331fc45fd5d959e7b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc9a79f94aaa6698e0d1eb5d13e738f710a8f65475c475621eb3060379993f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c44078e04b9317b77cd41e8404e2d1ecb3563316faf3d91165ff5b59d19a6e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33656c750447429d3ecaced97b528fed1eba68caa2601d1b0b59b20fe743f83e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9622021aaa942aeaa3a1ad57198afda9a207c42f0983ba12afa5eb9af3baf3b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__018ae9a10c561d88a64c5ffa2c37923165072ea06fda862a121c66860121fc8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e081bf5b8291f28e8d49f4ac8f8bc8a6841f47ee353258e9a1ef80d82f319cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6086edb80fdb1ebe4173ba594315c7c86541b0875d70f819a7929f845dda6dc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8d3fd2de73261d3002b1cc4c90adbc8c4e387c0049aaf457a55cd16630d95a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87afc16b9a734f7642e8cff682f11df74118eeb4085064c1557fd409131c6ac3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ee8840e28d22160c501db35fb1e3d0d58944e3a83fd5006e07f9af586b2b16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2e6e30d59da953eceef2814b2b6c2c4812d9abdd387ea9953e5eb288cdc208(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4149ef526c9c301ddfb1d8d4e61054cc997bc9987e075a69c34334a100e56f56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a79a5ab653f7c0d11a663c61a67a58354c7021761834c38ab411db530e314bac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e24ccac50ae5085cc33121499d10f4a626ba5b7acf084af52f8dc487d8d66185(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c1ac0ee7ea277618b6f77dff4f954a6640bd31da74708a6225da9f31c6ed00(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca1d28cb4b882f76454354b9c78cd69c7daf7b4b34162b715331bbaa5647fb7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a271018f5bad74c443fa3c8c00608f9581b63fe9e67ef507007c8764aa1b1cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36a68b18726de19cc3fbeeb9af97dcf415af6b3d5e9d4a66305fc0b23a0d246(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__538247d40f9fbd35940df742eb8aeb317c1b215352c8ddeb1098fd729425f54b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb345d95e1a4b32d5c7369b2a266a600642c62adad8366bdf61a5648c40cd42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c99acb3b0a20910b196ea300f3bc40061fac56863df759c61c599c363bcc17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83da3c4adaf0e4de94f3d8ce282147d214c91ea242a77585448919098ea39982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93db98d73e51ef5fa8ef76a1a432c75882fd5d57e4e0e6c3d88022c7d0b0da9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75110daa58ec01538c0f4e86534255ceb7f8c7bad39edcacb79485acba11953a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d5275119217c0cfc7d48c8f469ed201881e3a6aa9f951d8496b75307ef2775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289b417ba7843c197603d0d5febbbc37a25c398558905df4be61f4d1321192bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9f6f78f0fda1c68a3ab85e1a0b447b3950208826a0bff84598cb0bf1cc7d12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__859e005a2e4f276a099c0fef237a57f9184343e10e411ee9aff6264dbe9172cb(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493da320f403e6f2625ac81ad3a0fbefdb144e6d35c78ca858c9b51580d624af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d2743ad178c6cd64abf302a8e1611fc6e0a41a204a8768f8f495dd5339365c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b5c40182eda2b9e810265bc6b5a0b6579e7d7f7f979ba3c6856f5a689d7956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ac1da4483b40f8922701836dadef35816463ceadf8d57d88c1f572fe3d47c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd389bb49abfc6507259ba09b28b2ab80c58c2920722a5e369c605ca39f8833(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ce5cb86b989316348c5d04456aeaffb15b771cc1d741073fb278c984d6a47b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__863b776fd9e0448259bd20ac3140a761e456b61a6075b177928b10b710633e8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3457146cb5ad0c2de87ad29441e11461e297a190c3af200dd2c5975d332d1768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea89b30ac158cb10dd977bc5a68722edec623de8cf59fafc8adc47387c4703e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525ef5f9a29f1d944918cc3f5fa389191806a9ee1a837ab349caaa98ae6aba71(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1dc175b9a55aecfb27aeecf31f05fc1955901619192a8fdca73609e1d385785(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6af9188bbcee899fd1b6bb12417feda057c2038412aabe5dadf7f3abc571a8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d21684a54f43348ea7a228255651d35923d1f9c6b86f0460b1776aadb1d5b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3514ec49141980f499fa7fe2b887213b3f4f88341d6584339f70aab1e6f99aa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38929b92befba458371fe44c8f1d88062b022f4b86284ab2ad439358d98f5b62(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b20405263c4a107478289e78f599784343cab56848a828044592b6ce5039b14(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe9c331945ad958d9f0800b32efd7f5b25762747817513d524206cce0b3722a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b41871c31a406f7e287f1e0a668e0931a26afdd71488760471949ca8b0cbca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8e650e1d3299aa709221d4c31104c9400ec14c404e03255fb524d4dc2cd088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1458828e0465b9e7232232cf3fd377f2d94e85df9de618ea0f079e042d7877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0304c90cc68a86a566226497eb019985ba0e7b136210d3ad275008202d0fd39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa18998a79026f1c273b6621be0e7fed8d106ff7c4a654fe18a29022d5755863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d83af28627d656c40748ffb6eb959a80de9e9c28e3f7120c6964c1344228ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8929db8cc6ec2bd1587ab441972e300010cc94a179deb7af342a6a1b12a12b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e169d9419809897cdd5cf8157212310000972118e95c564d020181c1d200fe3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd9f94ba7f61215e83f13e5873a1126f2213705a2b97b860fb42c41100e2355(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c414eaf8d81a4160d3021adc9980288e1b420fb8068c6389ab90e736d2f15cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e2e49d80be6a4bbebbc9ee33a229053730ab79fe088d2c52151d07a6f3e5d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a231644e5b1bd328608c77416639ed6a24fc0ecf79aeb48d7bc0d2d28469ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acdf6584ef227b654af86adaf21b2b4e89c6c135b8f5631b215472599b8de791(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da599f31417e19fc7190fadfbef94523cd6eda523c12d6fbbbc5c1747ffcc156(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae94d5cd948805cd54bb3013bf418b6bc5e2b552b512697d0c8d8420c7961888(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d62b296f2eb1b276f435f4675e2f8b53e30f6b11836af83f08e1d7d040a511(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746b15522cdbb2cffa7063f2f47f2b5b2588b26199c2d732416cbde14edcacdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398db44e9eb4d3deb23e8d25a9fd4df2906f0ae53677a974259c33195c92c7ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8eec055c75297652f7e8fc1c1189fbc6ee8d1e30ca76a10f218de0090a4fc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a572ffb2a039015872f668e59848e4144d952812716130ef9f59a74e03cb4e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f108d37c551c15511d818a2ef07ebb6da5f053e19a2b1367f66c8fab64b7eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6f7eb20147634eb5f3e83d2a1a0efcd7dca3add9915729bc11ad927f17a0d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db127f50891b8aaf11deb89a1762367891fda79a3891c5dae947a7f6e58e4cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59327faa965260e92a2a7d8f6f876aeb53c6aaaa171c053f770192c5bfc3ccc2(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ae8e4899d03ebc17cbb2b9671270506d6dace8e7b271a377398e77e78cb367(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0600ea1aba19a2b9d05080fe04cc9ed79ba9d092837a88e46acc1d505e311646(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9627acdcb36c45810bdffa36e5b4a18b2d22dd7eee7c7630e153393a62118a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c49131d46de1bf2933c3804547403f0c20e54d3c098214a4ce8a51d628fe48(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f275e78e4e8dc8385ae715e44366ea9fddc6abccf267fd1629c825647451669(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6d3af6442647aacfa6c806fe5c4f74aef86e2e2c70d9139bd0a225956eabd5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f2d81039b31c7549c2ed62144d8b0a7b5bc0fd0535aa3f1fc4d6df8fc29459(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2423c83bd667886dd054fbc50070e37ce48297cd1f2aa6f01a26a03938b3d1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c96643030f4cbacbb7ce926d800f0e6305df8bae5b4f3a3acabe8368fe9bd5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54aefc2d5a29503015fe52a121cbbe2143f6abe0d16f97afa0e1449dac2adf8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7bdd3f3f3706dab17c7adecd224fef9d372c348b8415871fdc1967766265b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51668cd9682c7d454ac5dab5654d4e1f1f167a81fe96d41a7bee2d8400788d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f414118ad35263fc5ec98c3362fa9e32ee00602255dc66da8ccca45e4dcb4860(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ffcae3f47bcef27589744935a3cdc8e8d3e12abd4898220d6ac31022613070(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e53731ea76ca6109f7a05c51673f05f41c9a7e0d4a8b07448fd3504ad20ac7db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5beccdcbe550e4350c6789fcd117cbcc473ff792b1682919247c1cef27061835(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb5890e16e868fd8be3d44e2e7613b10b3644063ecc2be9ce5d756d8ef5aa0e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b635c78cd17c2a90ff62798ec816e1539c28983fa1d69310ad448147626a650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f521b0a8bebdf96346501dde4feb134c23ed24015b9391c8551f8227c687f928(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b0597e3181ac99c240433ee1f9e4693a02c03aea4c382b73af178898ea01bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eed34490df5540b9b59a2b101cb7ee61395c0c1da6aee75273b2f61fa94d4e0(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a7765867d5261e19280acca74e91b2190e8d3cab9fa45ce7d3991f2cde00df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05da4c6706542a6405d40f617ef085c07039c62392b3f23813ae5ebcf5207879(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252c90fa566b139e4241879b15f0d76ee282c1071e63a1a66f4e64cb6fb0d8cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a30bb99052f0300ad2cf7f06cfce672a63d27564a88843411c5d211f4e7442(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888c68dff814756fca19c0d4bdf79308f0b6044cd9d3e2fc8565308f3c8d3b2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7895da964a694f478093076fdecb9d39d2e380923f3370bd35cbac15371c5185(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c2084a43243c125e52036f2f2323b3a895d955071479ed6f34a72487e0aa76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232af27652698e320107fc9f0070e9addf1bc177692046f706d7299d4adaf112(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7156d8d865cc64bb1afb159228cb91f43d8df10d5a5b4f77ba94128a30d6f26f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c8762124e3a97130df4b787c86ca70b5ab6c9ae8d915d9e9b2d48eb02eef5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a51405c62dbd7a4d8e996e2c9f88d86d742845e0d811b850b374ca998daa8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c0f35e59c357951472e4b36ea1cdd5440ccddd6d7951f0b5b3ec3dcf8af329(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a427a580d836b7f19721ea1cbdd790193ffa22c8153502e3d5e1a537f4e7b94a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e03fd7d7bb891507b168d615be2a7e4c6dae63d38db1cbff239a390332371e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e294049ddbdc9ca0bf3ab7677b13637d476b5712aaf2fc3feb0a883c910de6fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565fc56fc655c8e40c8e376a163af78888101c434e01e4f1cdfd0da1f9309cc1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af1e31441f0665baf614e6cb26a548b785c43f9b30c16da7744cffb1d464e20(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841cd3bbfe59d7686d390feb353d01c40534f5c4fa635db051cd2147d13b4ae3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3821b5cab55cd171afacde65205e1dc77d231b62eb34362f16bc52af731988e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5438f7c602e2e0f7401e3408eea921785188d67f5cbfb7df037b0da120920852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc4e7184c6b896ed43eec882e81485705eb003cd86e96a0830838aebe586f92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe8a0456296cb530a545c6f832204fd2545e845ab319a06677db27158a6d90e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65557a7c83ba26e6b334a2989823e488d6f38bfaa7a2057ee6cb719f9f51bf8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf356a9df19d75ee67535339155cea5577cedca56c2b3b81265951ee3180f39c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1142a4487b085970cac4446e2ca76e97b6f7096ccb67a7d79984146bb2738abf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4c5d98806d63efcb8b0ecb13d7b880613783f70e184f308a6ab9ef4ad853a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487103b59902f8cff5fee50437b791cceb0d8c2df5632d9879ce1ae743ac64ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d36aae16eb076631f13ff4da2cf109e455e4247a00b95b3d0efa50141ae596(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd937f520fc46478e676d7cb3c5dc294c231e45bc1c7374a2d0b5f5091f2ceb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef1db9e9449b1f232f64fed7a1891d0d4606f6fd8bcb50411a30a8b5f689b89(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c090d8c01c368e2d6c6c3cb5e07ee20971fcca046084fb7e8805b887b1d75706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e84ebb272429fa8d01c3c6977854e14eaf3885f4246fc915320426f306130ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__366ad2b90443df8cb3b8e646320cba8c7b875154cee8a8f60b2f15be46addb54(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537742178a64a0c54d9445ffeaaf196ce7c3bd788a57f032a4aa2126dd82b7c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbca6ab83f34219d19b56177b1b0db20efea9ebe8a140fe7f52c92a761c8af4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f26dcdcc3141e19a56bf8a0fbd88083e64adc6de2f684e16aa523b94c58cfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10fafab6891f574eb35ad70e65ee74e582a54725efcfaec896c1d18118e102b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2093fb2331bdc48c4bce1afad00d78a04461fcac3f3f8e5b82c24056447386ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed371a787ccaf2561574752570a1ccec74ae78be33dd986a3be41dc495336041(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f833abb6b5aa28917e44bbf73ee0c175e37da0ac89b077a4b39e8f300dd748(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0bd2261aa781dbea31c041f8dfa2fce49f62f49f10fc4f447967d7529e278f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0cf4e377573474c44dbc8b1a3c5e4342b5f2598dd12f7f20967048ea07c218d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7427ea8e308b34f9b03265ceee7944a5c7af4e127a149614f9e495b2167ca144(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d86c6ce2ce7427516af7c9bacf09a4992131c42eeb7723197a8b304e95b7ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3fcd3291aac42c57f68b6de9eddd88ca66eaeef796d6a6c7303f094055e1749(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52693129cd0142800dbba56db4508dd99a6df547a9159b145928dac0fe8c97c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9527267b4e5a38e64ab466d3344a6582615865b290a5cd2b72e168d95e11225f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e5f8f92d4e62ea8c58456c406699467369235b05d2a3a3f433b1abc1d265757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ee61740f7798e01fcd51b5c620159ef9bf972f9a568b762df95728ad8cb2d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d2cceb1729c0121a81d58721b86efe26a9e12a92cfbc6f8d273c6737ba81fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9508839e3d51f531a83e5705217df6a64c6e06f2c8c08ee6393f8e784c4ced94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3919499dd51e042aed161baaffff32ab38120ead252d0dd827381dd34a27b246(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51bf78a81de319974a734b21a5f3187b6f64addc39ff8c91d7262b8de2ec1ca6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f89ad867eeaa74c22a481bb1bae85dbf92332f808a9a21c0c6abff444252dbe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019848b27b32df3e0836b9a07e97dcff7e9356ff88b326b22b7b9a8a1f5ed964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e88b0fc3b7f3548382bb064f18dfcdb4be499a044ce2ef2f1509592a00c682a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01f55c6102b3de3679551e7a414a566aa0e91f4cf77bfc888790dedc4a66658(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f12a0913648bdc202e01ed35ca0a39610abf31f61fc16d352090478010a917(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25fa63922d884bec571c6acf1f6fdc52620584cfca8f043e3414ef6ddf026140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb293255feef649cde1b60ec1f2e530ae7043b44060f47328bf00e0fee7db6ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c385303a38bd59f83572500da45f54ea5725f325c9163361187b1f891fc1f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__856f46bb01f2c929e5da7ad442e749dfff85539f0fd383d644b629f3c75343d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1bf1daeabb6a3fe01a751213512994fe36b51909af1b3257a2645b896a9bab(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfca91ea1616584c6af7e54c791547fcf24974eb805f3f940a85937d138a353(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2039c1892959eabe5d1e8170afd727381eb48c511d74e7a0db2cd8408aa6f257(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed908e7c2e35a6c7866053d41b90cdb98f923dea6fd237b771a58a4d3dad9cca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b6e13225c2a1d323f5a0c61de13e218b36c6e2b8ab54efff5c899c8c329640(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b370d79b89edc778b97ac9ac35f9093a57a6946f62f4643f73659cb99deec80(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9119c69b7ba59b4204d33e403fcf76f0cd51e8fdc42bc91b9665347318b94d21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99a7e7cfd0a0b6c89050343a6cc2771bbac87abb9ff7ee22c84ab141de3b4d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6191b4e43a3da42885d5ec457a1622508c57037a4feac442a899f3440f132233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2033f06478eac03f5bc35d7e7bdbd4d2b381ebdd5a1f7823a678eeaee7c820bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4bd2e6b2703578c878cfb28daff5fa0b8c10ffe978670625350d0032c4345e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caafbd89e69ffaa3b5d5d23aea8a0173c70947aa9fea3a7025a20ad870072f46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ffce10a7f807e5717d8b57821a5cb35e9df50b254d35dd0c7932f2ed4d44eca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eacee1c33b9858c9cfa1c4134fa8100350ff4dd397dfc19b3797fe6cb796f07(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3ac4f981087c839eb1eeb15df6487000b6cf820274bb87d4ac2df8fbb96ebd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653fae656f1ab019d4ad2885ddb80d736d4ffebab8baac89e8cba2fc15cf6908(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0864b1e20680723ee80fade0421afa86d95b91ec51f151f42496af6a15f63afd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88498c351d5d86782b051d38aad8b88f334eb8e8f6cc12ddcdd041e5b5772fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58eb11a6b946148a692a1dbb3a84814ae9f92e7f9adf32b6c6a35b9b7c0bb14f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fffb06ab37bc57a2f3086820327d445d43b8a40bd1144f2f1ce6026591936b31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f306c0234c8bf22e3e6d1f8e9573455f8b28c8e847ece127a0234cdd9bbe3cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d681981636f4a037239db52c6cdfa20f3d8b3eaa186ac921a6863ccc74a93cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf3f9177aa2936586f48d938d30bcf562bb2911572a13b7696d136b149f3e71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cfe3ee5a0b37b2eafef728118935119cb0dcb064bee20806bc3039911115767(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc02049aa6209082f8adf5a1512c0865f4b63483142caaa9fc499d42d767de1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9beb3412604a281f554968606334b5b18e5be1b1b1a090fd9d645e182d0a8fee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75186ec970d40d0f489376e420a52e7d8f2edb10bb97036a2efceb3f51d83e30(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c144bd9a4c532e9623422280d11bef77741e5ca0e9cf2d6208bb5d3fc722daa2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf78d301bfd46959d9efca2938ea0533a72b5dea17c4fd69645d3e26c8b6f5f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71a971c698eefa6e460e0c5a8a849b96787ca620cb59945cc7026d56138f6d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde13db3ba9c393b6e8e882212184e10cc6d00d82c421b27b67618ae86947038(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2304a8f9aa256f20b9fce4f36d4761c9be95e98c56d032efb74d8d2abd0cd2b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e2cfc1028f6766c394020b1d99a0383133d08729ac5fdfe67f5aa47f22f22a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81cd669d7ca5a7b7cecaa5c7de57b3b4e328ec19c898c11b1e66b717358eaf7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703e6cb32ce51b2584d2ab8066b0c52776e7d07943311b5e52af67a633223265(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9459eef80b9ca0d6e4be8610c08c468f008ffbd8af5c20daf5eb10937383fe0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93909a891faf3df70bda5ef1d84cb6efe2858df81f9e664e1fb69bce929d86e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb37ae8e377048e484b3b84102f0128e814d07364f58e5b964946791d7cdfbf2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a6b934f88483fab9dcbc46fc41820650409b9778836b7d311859177feadba6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a5f7a5d1882156f9b5a3c64cfac3cf47add89da6d2e77082de113d9d84a98a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa02d05f86d5515e5392e88a2b417c5d2c7e1126cb21e4cf80d1316e08c548e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e779f5716a096dc22db6c4f24f4b7639c2e294de0942d57a4572d4bc42d56bcd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8cb8645c96bfad34f6e97e3a57b4109aecc23d6c8c9b23f100bdbc0084dc7a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc48f5e2f0a823411ad0e28fb08b63e486b0afd91fbbc0332b802e1a902fb22(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faf6cc8ef359f419f031bef180013fccbb8ab8faff3c194b9002d4c584247f5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc986a4dbf0ab924986b4cb5cc83b09fcc02ce4b1cad80fe5014041f8c3e248a(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816d02c21a4516ed827807fa2dfee7ac86b3fba3ac337bd04b2035456dad0efa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f182b5f0cdb31bd20e1a428dd1b61eaa0b092bf6d634e5938960a9805351cd90(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dcab713c1b6754928f544e698fd08e90adf4c6649e08b86658b69c3238a29c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f773504e7f187858c2ce473066dcbf119b4530f231b0e44305879747c5528312(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f924da116ebbded354c108f1f163bd37db7a33b89b1dfcdaa3171c120455a2c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7244f4638ed16704e07cfb4395d84fb5fce1c17cefaa8cafac9da4e4d81c0c26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33fe4e463fddf9266f8cc05a1821d0ac5c9205c9b4667c20f5ffa7d173d75c29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1119170c719b0df747b791dd974bc669560982a45af14c71a2d7fee23f47d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f4cb20b7fb8e660f64377b38e6fe5409377c1f01069358a01e2ff1fc748395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec991886b0dcd6a57147eedf440ce09e9a455e51fdee686b30e43faccd4487c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3715cf93573277b26a69850f7dbffce9ee8959f0fba9662355681430cfc67a8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107f208b551f707f07a4b768a4b085015c217f2617a4725eb85f660831d2f6cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42e12049a2cab92f4af136bb51a40c5c3f423d1c359ee7664b60984dcf50390(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94aa86cc893878ad4613f9025addbd8211c1f01b70e3ed8fb94af7d14b5d14b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f58431ae67c8fb76b3202cb66e6f7187cbafd9a9f7783f0120eb0d25e989a5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd51a691434e6e2db2a5e3c6bf803ec8b0bda3b017619bf3c4dcb5535c2d7019(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025ff8f1cbca61ed6d62807d4372123053eaaba155444a280862d8d4bcc84150(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ba8c30e87a27109de166965ae55b8efce42bc08cd336cd83680c42937d0536(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65ef6f5590bf7c241c573c476b2073d437efbd326516bf94c5cc7a320533c7c(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c4581fe60c4be1cbe78a7664d370996199dfabbcafbfc37efe5c00a108c8f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1e69911b8761fe2fe617fa30e49b8d6d9d3210fe3193de6f666d4a20830423(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccf54111138e34203974cb0c12ec60f63d93f4f85af28e2ba77cef9e489d230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1973e1feabebe6f24e259cf731bdcb9cc30697ca17110eb49c43900bdcb6ba85(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396e72ac50c171c09981cd0dd84f821768ec29a3d1fb3c647d199ef4a173a633(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c5bbbb811b222514f8153d741d02e1c5cc43eda83570a49b346a8e2515612d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c63f0a2c7a9a9195b2dbab281168704c9c8a5d13db13d612a2215d01f5dc17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d009f988a23a39cc51f5ea5f53c5f4ff59711dc1343a34f9b097bf536d65f11b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a751b7447ac6bb0d6e2e5ab669ba61bb98e57a77cd032b7d3009844c4e17f563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9822150619b5c42920c54f6ee19c2fbec0020e6445925fead40d7d7e431562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9241f8991ac3681f1a0023f34563d6a68e6461d33f64f333bfa18383896e94dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf01a8f441ccbfe78df0ae1902e24ad87fd274ca59f696106737367c762a11a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98cea97cf4d4c90926e7a0838964849c2675d0ab26bc3c2b8c81885c4dfdef4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980448668703183050c5db9f063fecad3a83fe835520591d5b8da786741d169c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00b3accc5208f23345b52d3b52ac7f5b1a5e22419f65b310e8c87d6970c7434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7339bb2a02bff2f726134982d377beadfd164a4281c0862ec95e4c81b63970ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc4118fb00b308edcef80464974ca7c4ee50959629198eb780e5ab641d82fc5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea34766552c97e35d0b8688cf661eb3d230087a5e9c6e9378740e5622892c5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6498ca30c2810d4a0a8a3247135f87108db94e0c46f9243674288ca11f7a49(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b7f9cab022ecf86f23b930005bae6a1f1d13fc57f7fbee2f1ba0687c6e049d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53e633a956b470fab4669b1ce0dbc3d3aa4b5a89024e13dc659e5cd310aeea5e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6483a8a753e2b01d449cfa50623fa3b315e8fb3c3f7006a5d70c051c2599d2a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5088e9882cf6bdb493ef1148b9d838bd6180dce3a27040e2c730ff12fc243b42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3465c7acb44c0d7f0f0f8f927099118f8bf73e2356f5dd44940fe7edd01576(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92fa34f8c3054b4c4bfb607ea6775d1b1d6597d47dbf93a4b3fee5b80615d55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b80fb9a6eef7597eb912e4c0b6747c857f2705449610fa9285f7b52be8d0ce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd577450cef55212c602d7ac9cd150352f66bd6d4d5a4bf42e19345eecda869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09516ab9bd4380b1d6d10eafbf950f14497a3f0c857d031fa1f9e0a3d75143d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c56c7eace245746b0d87999f17ce148efdcc0d3622097d1dbeee0a104ec661e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa5fcdad9239074e01f3fc14bd69c0ca5b62a378f2ff1df74854579a4eb3bb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f98c8158926d996a0e4c2dee2ecb5da3a868bd735f948b842e598a40a28dec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e3e9dbe79ec719e5455e35efa40dd1a32bb58850c7f644c73269a5c6e9dda3(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf78e48ccc8632096079fb71c770c59eb78923ef8ff8a7e519b4cd5410a8ad3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea465fcb7a7d83c54b0cfc31a9fa7e478046076ed386cf510a6b308fd19a6e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44508c8bfcb7744c569695dbeac1c0cc3328370a484739a42741767a2ad1442e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e2498dd77279b6614051f569214f9d35dbb6c43b3df8388447ce5b407ff898(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb1a407dda1b9d89657db3d325064a13068cd7e8e091aa90a860318bd5a2965(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe8922423b6ccd9f22ff786d67a92a93091158ed61d0833b5c531d8dcb85137(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7a9d302435013174fc5e4fd076823e0b32387d03e1ab7de7f9d4cb5e62f65a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21206a1f156544ff2dd6bdb72f3c9896b8895c105ad936731f67121278ce8ada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02587a9e55c1fe28a4cb15a51dfc8083d7743b2c507bd600feb33a5a96f8516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593f44e3af11694923acb1234127958ceaa8c00b97c5f7ba270f37fdf0765dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc567ba3cee534c80ca9fb1e08676b50e8c5519bbd0494c7505f5d7ee301fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7807d0e35b3e64225373e964ef88f5ad0e25116b1dbc5d44da99eb055e51d4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d569bf13b659ea8ba21cc305c8fd3c0b1efe87779e563c476c4f6789061dd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c814bce5d9ef747ce35dc78e82378f54a59e88ac960397b74a75e8a4e93e763a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9477432419ad87e19b5d4d4d0cd45a692b5e773e65eefe0cf416753c1ecf43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ea02c95b004cb12d41337641f7bbccdc317ec20c9d024113052ce0104b0476(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18198b0d67aa12b1584a1ea367f4a4edd9b018709c968cb507a34bef07dddb51(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3108cfe1a66b3c290f575ab602f5c10febd6c072181fdda69a017646b24648bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8154e1ac52e7e24d456ee0f96f61150c09fc86d1cc253fd466f43eee50c532d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da748700da9e0ea58a0f7a6f072cbae2d1066c692a54b5a2aac65ca4d575fd5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17000bb10e30d91188b2add7654bf8af80e67a917d3d91adbcf6067ea559b04(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3784010f2c8332ebc5e79cb8a5b0404d0c2d6575d85cf38110c867fe559dbb90(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a244389006d4619e73ddfff003ec0242b711df265a6c49bfd0a00d37d1665f3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d40d8e6f9d95763da2338f2f9ca91fc6f92f995f3361cf6765f73aabe4393a54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03644de2ad59109db399e945351e04903c4142af55784d1d6bf498465947e36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0117b699f1391b195da45b326471a485bb323b292828c416728fead6d57fcc24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc6b65058391276db6292d3d5619ccb142b803caa0908c5801b087aa5270082(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414b91c6b20a11f49c2faa33cfebb0db2503392c5e87ef71a23acd80512d3773(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8505a8de304ba523d38b57897637962d7fc45bf6135616eb94d3ef4ceaccb9d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb0f408ad5a04cb39a4c10a5c4e2e2c259d994c8a15e0410059735dde2a7533(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca6c6e14de029093d7f75a7f08c317c2ac141dc64d462d7b088b7b647ffef05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76364c307923ad91a8375a6fce9802df497ac2136116a19f2b219da1adc61890(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663a5d9ecae7b1610ce8ef5b2be4a3d2883bc48bd841bce23daf7963b410bb21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb797957e1c8d8344a3dc96018f2feef7cae38d5ce6a6d195231f61eee5102a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddfa4706298a51499e6efc51e2cfb16a6f90201c21a39dad2b454fe936b1440(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b81cd128a5d49a32b9d47771c9db008dd1a9fd127ef906367d7e39fea811f98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8cbd40d2f0bd1aa0bc81f62bc485fcaf15e0d75829325ce4462b6eef4033be9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__664cf0d13ae4714dd956b7c68d91731624a97bf2af80e2df0dee91b8b44cacd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7e2b3cbd3cb67cd098f223507c0fa0457a917e1e7fb811e8d7700c1dbd271d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bad020d4923300537b92c4c913e0a9504246e5264b7177dd935ad3f1c0acdfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01eac30623891a1a869a2f44899365e0ada2b9b0c42577273eefd7e116756e55(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b9396845fcf200b7cc36e559ee975559aedd7b8d717e9f7cd4219a4db06b56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abcc7c43f4298f059a0671bf542daf6722ee288838587274c9b255f322a4c59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e39a3d42ae5a9c52ecdb67e2442dc4eb377f89865a3f73c56a5a86c88249aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de670934bfa6dbe72c7b46a5793d2f37fa73a21bff9c0058c9000e3e7dc0e4b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f667e2b3a1a000cf0229f50c785acc16d3b08c77e0f9ec56c1a661da5dd350a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0773955d7e19c9575e8a1009d7eb124e4239a224a34fa715c0b7369bd45f0bb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb455c3f491a4bf252eadefeff0a122820a3e46fb7e9dfaaca44e97640d4d626(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55eb3b337e77703add877688da64150779d00c7af5e30f19e2ef9235adc3ffa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfc1e761369bc901d750127ee2511b78e03406d8c41a95c4a0b387612fdf761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378082281e2f312985c6ece0b1d4e944a51710d5bfecc6cf1f51e274cc360292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59251dc699d7433ee84e3e15c8c8fa64e766e03dd3f0f246a4408ecdcb792a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76faf462faa61536479bc8e5697d4bb2bd3d1f53cfe76dc5f28b2208c458758f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339024a6f532bdabe824d829997224c376d07feac439e2a527847d00835c0132(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427b6b0265e13b263154822f84536087b203cce241f914caf78669b2f1a5ee5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7de82a220216e068c57b4b11c6dcb5030ab0d76a0e7cf39e8b628cd2ef594e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11addc5ba6c809506b1265de827342588f7ef06083b3702c4fb576ecf67de8bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb65997481200ca69dab54ad735e13d58a4ce4481b26e568fa11dde9f5db325(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61bc887f1e20b50cf6e91f8c86355c0d9a1a95a378dc37000d972510872286a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec1ce621c3262f09ed67a498d1ea588c3124b8aa64d94281cae091e32b4bd2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e17e06cfb0f0459ebb7e7990d2d76bf00b51907e3d9b32d278bc3e68ff28a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61056b7699f97688951c0eb6ac91d37f6cf4f63af4b53e9ba67d2680c75cc3b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1b7e6f801834a001b9940d90276b3a6a44fc75ef8c088436576c88b118ee21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0050898f864926930bb2df05d2acf8358ec5645770ddc587ba1b85dc4d066355(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444c159f6da9e18b6944aa4d8102682808f64b59d33460bb7580d0d5bffc4302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5188ce0b28e93aac252b4d7bd615f349592c1f1973865b7f76799ae06506704f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a714c2d19d2a8264f0f248d351e75763fe04be345cb2fc53648cbc24795f5cc(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7655b95867157dd83131c19f24ef125ba4be38319b518d7bc85f6166beeaa081(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7acb8c59da251e84ec0474613c8ec41b6f1faaf98a6be3c50e4484e2dcce4b4a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f640092379d5811d69f63457ff360ffd1f1e44ae1701ab7b1d44bc4bde7218c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be813ac136d4a6f5585215dd99f7befe64112a92369ea6dbf5521ed220373b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d262aa37a3833c072aafd359322cc920af47c3c7908ff72d5e7fd445162af3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d7a12cee7eeb1f70faf521bc3858decdbd30e5ccf55673dffc45ce18bfd9be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5dfc7ab4d377e2f9ce92bacf55d0d0be59981f3da196a76a08d3aa604799929(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c9bd148df0817925b5d8812cf4d343af5287d68aa8a11ff1cabb60c960b2c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e326adc639d547e919aaa2688612631578cd90c8c38ca193e49859c08f2b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a703554da6a3432b02033edcf234ac1b5e2ac1b60cf9b0572f18af4cf28dc631(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6129400c60bd8a4aed1b7931c274e87cd9ed13623144dedd502c933083756d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5673af764e2a0bd651e60f15ea090df89bef83760e5751b6ddc2fc9399e24ad4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1686a5375ef580d88818f44e271e0b4c8b893c7e336557b36da42389c4da09bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6804d17a48ea96ecad997aa201740d35d3b3bf6f831917024073da2408e2f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b6b724372b7315faf8576e575635077b56eea060930073fafc8fb82f8cfeac2(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0529bd2ac1efdf4c0644d5fa581bbc040c5b3a4821a5cb278535d3e9467de54(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b5c9b4398c4535737103ab9ebb9f7c2950cecb45f8a93bf6309fb7f28b1b1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9654c6e4e0ee37990cbb264d3fcd230d790eec57930a5584dd7dfae2612fc0b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e115213b9ea18db04b9131a0b1a63d013b4a20a63e528f7bf7e7e81eb263dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835d869b942f0adfd23a4f497c658c68b3e301e1d9da1ef869d1f665c80d3179(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0308647608d51c74e907b18c46714cb81d2957f742c207076c6141f5122cc006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a80cf1e843b6c294cc0adcfc6664103506aae22e76adb86a4de6a25404f4487(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9898fb5aea30cf5229dec8e858aed89d9d69dbdf541d7960234d58725b64ad80(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48fe93687a85af8455e5f9db3fc2475d05e0e8f742240889f145660f341cb40e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca08247896cb4754aa2459705f7b3e79d711e3d1bfa4cb2fae24e9a71ef6c290(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03fe6d838d67338de1d3afe672983746bb53418039a71e6736d1f9cb17568bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045d1993a6ed1c5c2fb726981cafa59280eb3676779906648e4c405e3728f9cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155ffac8b8644edb526d0d23387ba06ba70c2190e344da02f67909c0d012f07c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c409ea66dd729ddcab996271ca7feef5a49ca29109b31a58d5b409513e634a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2604b5f93d3c28fd9e302f368b4c7693c96ec457c498c39c8bb2b829ae19328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7cc4442004ecb26ca8db97b81e04293dd8ab0ea7983043773da6e057030476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38d01eb4d217f2932f1e54c3358283c1941daa071dbe0304872bcf4311fd98a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774f424cab3e0843c5320855dd8a75846e1232b1ca8cb36e744a27a669bfa4c9(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a259dfec6f12153ea482a22b0ecd821c7fe50ea026f9fe68d6d085d75129a5a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf57f8f33581de351aa0e891ec406f6033f87ad13ef071cb00d9c904ae5b2e2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea69f57b45075c37878b026fdb530d70d7f40cd0095844cd9633272fcaa4c49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44239932506e7f011e6ff57323e871cd8e6284bbd6e81e34cbb6d33b3244cd66(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba6678759e179c18cbb750eda7e960f2a54d15ced4e458320f0cf6278db0825(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac090c06e95d85088eda9d5da33ea6b9d07c11b5f999f0d85be794bbf5caedc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845c0473dc39ade4f00129089d5492073c63070f7b978e95018c9a18c1cbcebb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e740f93906f37448da4d4fef2cd41d2fa16c2d94643877886da4e12b4c63bb93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8456cd947c70bd6e56cf98d3e2a24ab963b110c3c3e9372e74d8dc155c60de8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7263013279b26ccab7171b774a78618c4136c6221af2da56a5a00da7ada9ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cce2a23ac75a1f971113cffcdb2e44c80843c9c5c094c81e8dd7f56a89bdc2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea84dd49cd6e0a2528abf7f275c856ded2167eb20a8f3afb348c3aa5dda1038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ffbbbc3d6ab4b262536c2574ecbae2c75fb9fe5f5617c5448559879427fb1f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2fb3ea2a87f1868e6c0993188eaa254c583288d3f5c8ce2a33f3c76203f77b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46746295493e668201be0c4fa13b353ad58e1268d4e0e0fcf1a586719bb13d82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__314502fe6fd61826019452f59a04bd4222166277b4bd4725cc662c6f121387eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd531e74f0e1b714cec82cb8c4255bdd048a59265489ede4c5c9a56414fd98f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3120473ee6af33f3948d929feea8cf1c979984d94812edc8388bc46be3591900(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7c3f8c8bfc7d35f64478983006c5e8da8ef6fce54468b2bef3d7273418e3fb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ead3e5068262da60c6eeff22b6e4b712bd10dd068a5840051d36a3712e847c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dad543fa4a7997cf64e926fdc92439928fad366c5d8746cc1f55c90f5ddae37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b846ff8f68d63c95dcc3c196ed71c5211c99f5fa5f9695e09bd4bcf19ee7546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bcb2491309b175c68d9777eadc135cea42baca2c7b545d63daa77235a8e829(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10740092a71511fbf1e985ef6d84dca8cf9c86942323adf1c18f73d97906cc5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8a01270227d62f041c441a271106f5c694c26a1d2837ce55f09f1eaf81687f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff94d356a91afb627a9ace4f9853dee71d4faa06ba1cec233d6140da9f580b80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebd68a08980f6ebc58c6b3201f09c355a733d10b11c7882b801f870ece6cd59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4444cf5ce02646d0b1851651400ec4de78269ace9930d9fd9dd9375494d2b0c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5feca942145a6d0d978656775c09c4a18c984fb5ee790322959ec6c5f116de7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958e2324dcc485ec7f98aafc9b7f5475826d8b95bc65607184dc4f1e1ff58932(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6a4f997b887d2b0b4cdca81c71d9f8388581f400b25b72e284487acc8456cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b917662e82b0ffc48bd970b2636cbb7fdfb0e335cc6037d2aa363e66379d89a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89eac3fc0f636bcef4e37711bf8b5cad184a024f8d954b4ca140d347eaa388a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb80e11f7572c99460f87a9c339313f78254f21fffbc9d9a7af80bf9923e31c2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df1d96ea8181311e2f908e52ac69340004a50633cbe43110c573539a2e1d0fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7144d6b02dfc669d4d3265657e124026a78623a402f0deb580916b7cded449(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c6d6d811863c0f431c9f46525922729c5462c4466b6e27b87a9fd826d28066(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f034409798b9feb8d41095b2f4a220f34d9986180c44047a420ad3e47329feb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24ba9806c92e31d8682770664d790a64a1477a5b2d2f829cf3fb979836fd55b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9d5021f0fc7c183a547c3ff7559f765750c64465fd3fc1c91b149b2069a0e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d316c0294fd1f907eb0ebaa73dacb3f4f942ef58594b5668d8075e11d1b53c49(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a279b91fbe772c228b46e0d4e56c4715182dd944f323789fb1459db23878a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133269471f09ad994de529ce1a4cb1c259aac69dfe30d3887973078054bf13eb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f624b3c9cbcc349ad5acd4a00702577f1fbeb3dadc21ad7b9aa1b43207b93ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6671b6c52eea298cdc84c32f6e9c9a2a17d1a4ed7043252282dab721523d8a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5a0742231df5da1eeb672ad1a27a5b1dd0cf88a8b447ed7b4e0ed8dba4dbe6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afec55aa50fe4fa19579e196b94c72979b71091627be6479ff5a195b8f9715a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c90aa4c982a78a4a57f3425ee41844f78ae8c65d9a9bcefc05ad4369c469f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e29f75686875788377b20758bc806a901c579eed72649617cc11e39029cd4b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429efd1a2737e2d32ed03f7a84940ebf60ed0ec8f5011fe6b921b8eb2d9adc0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b932691491842d5b6fe3ff28b787b30c8de563919a797b5650fafb9d5eef689a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bad9764ff6bd1d307980958bc067ef5cbea8b735101473378225f86e2dcbc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd14960e5a240602755938f8ea0108d98f8521478f03390388bbad9b15da3e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f44d5694a3dbfe006704f64fb8de913a22cf43981c1db2a9e622dbb2789bb7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12079d530f9b080d994b7cf9629d52b8e0871be99c87a5a1efb73a50aaaf620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558c69812862dea770458092a081166146ba7ff6c8f60e8d5caea898f83e12b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970f59084cb7b0bc21e114c7cfd7762e1bca94482c6eb517b08c57c8cdc34d3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03600ad45b047ddd52d1dd1d236e68d99306c5ffc1c8c5043a7436240024abd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a71a33671c3a7e423413504e1c324fb8e991bcf4d92c0c5ebf994f86e59aafc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bbbf230f78c28d105dda66218c7c83947df4a10a8f494aaf467677d4bcf1c8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db0f4110d1f5529d8e8598bd22e1ec05052127b59b60edc48c0f839c6dbcb0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f4478a57427121cb3d9801b402523a749dd579fa90c33fb8392ecd380ac0d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ae401d4ab815910a375adb0cefb56b109de7adc85979a23ff055d85ae935ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8ad2df589c3c9e480af3552e2f63900346a129220fafcc3816ef87e75988df(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a04d2df68fdaeaf80a3307f3b2b489d2324209995f2597c49af1d313fac762b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3450c20fcf422c059473580c9d9682761b5f9d40ee7acd344cfcd60004863589(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d907be745d9eb993885b42296472d7023dfad5051f1f2314ae7707a73b807c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2003cc41312bce9179489de93acd562627a94f687d57fb8c224622f0e1c0b8bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce303ff5eebb30f9fa040135807e4d1f6a850b3997ae1c03878f8e44d8a27092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4f9e9eb6cf9cb6f0b8a08c633df2077830e21682c15f05a2e4cae34d1eaff7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83b09c2183ecfa7c81f075028a101efb26e41912d9434a3b07a59becba03101(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684ca8e2f430ce8c6817d7f99ead19d1d8764b1ccb7eb871b4a627153f055822(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef73f1c8e531d3a229de7c4c9e63daff310e42e23a5acd60e2101fcf726e62f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115fa99fa0252f00cd39d3597f6f7899554175b3aa5ce8f42349b94fa21d8078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9336116985b06af7131306fa165bf7faa89aadee974e615af42a2dd8d86cde7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d490a618c3a39c913f955ebdfe529042f94c15f820e1ae441b1ae86892ad889(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19feef45bc5302d68edbbd44509281184e683f6198dd505a35e7b8008ff35f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bd62df5808de0d2df251b4e00c9622e2de7f3d5ad8031ab0f427d3169c07d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6296a34176d61cfe0c81fddb6481d0b5ebd65a0c9f93860d7de73590046a680d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821725068da91f3752205402f0ca873cc062b287940e08f77fb6b50845669dc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c059354cc0649f2fa01e34c3ca15455e1f1abaedba4b68ec8ed55c5457cb01d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef2db8de286873603da01d6af729d0f014fcc250327d05ada42c5fe3f273c5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd024459463bbb99a6419586950ca00a1cbc80edbcdf4768a8526fb2fde300c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde29b2d4caee60e9e6f9f42f07a3046b0a927b7798d227a38ab07308f102047(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6636bfce2b5a70c379a5298578b36ca2a53de9e749dbfead0e0a5f9c7438e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b2116d188cbad585ced20089d7d468b0a9524c4f2d56d6d8ffa4de5148ef2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238495b04a8f8303be527f188bd6b833fd34123a599c887da9049fdaef15bfec(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1529a1cface0253d383d5cc41ec8107dae5359584b5d065b08fd9e8bd629ab89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0552e806327ce5afb1db7f73f11af14c49f718dd4e25ca52d67685f6da2cdf8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7edf126f56b1c8130ac34f05c08811ae7a3cf60e6d50984d6c3b44c260fdc8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce10b247411568556e85f5b32ef36585b871f35325a78936009008fad6d08013(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974575af38ea3d2e7681ccaa514d1cc959308bca653facf033ca189d418a0cfb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c795a0b965790fc5aec98295c0c40fa03611824735538dbe51bad92abdd00ced(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ef08035168481b989c5b230ba0aee5b3ca7325b29629bcb6addd3266d8db58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2030bc80fd4abae01d58d6a3fbbf44ba258ec08eec28d681d92731662893b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43019f488a54dd6a110885ff8003ea211ba7415c01d69f434705f72cbb6ed9a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0d39360f12e1c6f752daf59b90ce61c4a79b2a315aaa0edf26d8f686c64caa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0997e089367875fbecdd63d4e97c8b9f399b37ee760091ea84cb9b41b4e54d5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb446f0e1882056f5f424832aa7a4e72263d2d5b70114276aa76cfedd578486(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c37231232c03c92f3affcbb46528ef0851cf6aab80bd39c2ae36bef1a1779f0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6bba85e4738490f8cacbc79eb937aef9989d4c50c1bdea85578f40dd4ef9ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f46125f620a2380c050a4b873f8cc310baf326b0f9907ac7a4594197ecc4939(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d857bb9ce5e116e16697a21e44458db9dcb17993e2b179679290bfde32751b33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764f69bd099ebbe624790ca4bcef0db2a9a67e226e930df4a13b356d77fcf7e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7fd1507fc8502d6d05b1af73b46f104fcff72c8c01464e9250086f5576b37b1(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da8747de766bb7ef30bbc874611e2f56198fae275f86204619ab413c8bfeef1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f6cdd7ae447837b088b39c0b9e0b3764de6a52d0ae8745454570efa9b87cf5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd394242c8919a388ba675f649af6f846d15fbf2da2f08d57cb311c94b722ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34dd11b1ec3eb58db8507f8abf94fb4fdf9bbdb93e2fc6ef06c58b62dcbedde(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65979fd5e0c927c726a0edad3f69199c22e3d354c64eb1d3bda9e67d7b74f9a8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7a0f80611140746f2f394ed239efc2feb86d5b758cc1f739bf82e7e59e2097(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127a0d3d2276fd5976737b051226050b3def232af7b6ef3536fb54f27a3c592f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdaaa49e9258434b8bd631b45d27cd053d07d2519616ebffd68b2d5c5bd7833(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b17fdfe73884e58783d38cf3f52bed597f7846422cbff1538025da8e90a4f70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f70e874e8bc1b922c001e306fdd1ae009938203f5ceb4375ea4cb5b0605f37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f7e64b305681a3e96bdcd3ab86f6a42b996b2198e7beeb2c0b561963477c0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1fa9b3c57c20ab86ac3fa440a4ab0902055ea1ed5d91d70c006c20edd88d93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc42a60fe06870c9246ed5e6a550ffea0493e59f8d81af186324ca9c2310ee4(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9803cf97db93c9f06022406eb5e64a1f57ba640e0481ffd807863782a25ae7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48bd57648fdbd980f7764ad49e35dc3ee9be502c145e73fb466bba58a9d12f1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e0f5f76380ee675854b7fdf0c5b7fcd136342345619311ebdbdfeef458995d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c0f699de70a0aca8333b48f7d5e2fa8e64ce5d6540d82f0e9b4bea6e6b8962(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e3614fe44561090e3063e7a14b8d743f5d4964e1963b34d2ed57dfefe7b411(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b906ce4e91eed4147d3e063fa32c6f663544b1bdb1aba6cd662a7317d664d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5832d09ba288ef52afc8262e2d69b5c221166508dd6be39689e72aac97cf84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132be510eed46153649a2bec03f59ffc6b85fca9df90ea8f4c502f9c6e9110e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a8da753464af34912131489361f3e72c997c05456e10c8be7fa4700d3e447f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c9eab9e32417139d119df7650c6450da3f7c11248343d4f222c0d9e24bac657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67705a4b915e1949d1ed649b97d65d1949807a0f301289aae3f89ebdfac215b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb64d73ca37b01b967926a9ff5e6aa30e047203a1e5417c781be99eb6db8776c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a565508833c5a97ca87bdb73d0fb68a890dc1422a67e1b4f5ab861e90d0bae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1673927669dc7a31af072eb092721759dccf34a25597095d76a1b1001d64c3ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e40fd1a0827546e6643404ac5409341c821483a95e9caa6ba121a2df960a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b57464fe233ee274ad9bfc997786afb1913b0dcaea2dc6232553b5e78b28b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2267b61ab02d63268817d01aca326a48cf1b0c6911c5e5544131a0992bf1734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a640e6061ac04a94a36139b482e58bf08894acb0fc64e4b9344b9c002ac811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bd74f276abaeeea0c6dbfd77b05e2927044f9b0af6874883ae1a7a9b0b929c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5a946c3f4c9af6c6b1b45d4c8b9fa8c9376f24c81a169d9abed5c89e01444c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a1178bc9d56dc5027320215b93dcd4252b1ce851aef4c23c7aa35756f13470(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4017694418c10fc72956c9b74cdb341f5a8dff6bcde3f0c9d052a0ae77301d95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b428764f224d466907b0507e03aa3a8138114b6c71227dd099447a59c8cab8ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20bbf6e57f64336d5a47329fefd678afbc2b132dd355d1d982da59c8f39a3665(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0fbbc9acb6b13172b50ec323b83848289b87c9ea40c490cff7368fae31375f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80920fc71249b9bc7135f65a587ebba46a57abbcbb93d2fc988d485a89816b08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81fab5cb695f6cd376ab7bc1227079dc6e0dfdda0078385c04f4e7ed2303096(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e7e82ace88df8f5221fb013b221a28e7b3f43cc6b0648c9c46dd8c61045c73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded0d1dfb0454e52e73e965b0cd0e8d17728a9782d43799974f8ee93459f6c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc25b4cebeffb2330e7b70417ab312450e74a43c30ae6ad1ea1f69d66d91db2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c96c34e68f71a7ccdd0b847fc1ac2dd6fe898bfca769217d93b7bbe2ee6a32d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5e4b48de215eb72ae89721ced65eb4f872d189fb9104c163f7ca5af91d7508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c66fbb8fe8c3d40bb3a09cf16e40edcafc46dd7ee84995196ad822bf3468452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9321950812a485b9af268cfc3dd8aeedcd2b3c864a401aadb61bf8fe28dfde29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663958387ac891ac1c0bfb802dc6217964d323cbfc1da49b59ca7845c490dcec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12dead64fa311c38e073b7bcb3336d0c82c617f2a08e8fafd6da928e2c2c91d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ef29963e73fd3d8c7bc2144bcfc13a9a5992b47ccd24fba1b43d67176a4d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b935fa897d5f1f4c1c6b9f2679686e4b847dd1f104859714a480aa69d873b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc7859daef2a4351561798e498078ebaf46e5620fda468b3711c8ff9d65dd03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d92a021ce619a9781de58b7be31a60c807b8cc017e167771bd7bc01210e4da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56a10a432ef4887753a5901731beb39030256bfe07ed7d69e12a3f196382f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08bf41f7cf885510b09155763914edf74fa22660e49f89788e5d72831263f51c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523bab9ae03544d8557f2c845c3d3294bccf060a5c2fc969f2c0181af625308c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad1804a95111a2468d8dcb4e84fb47235b30ee193459629aa27f12a5513625a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f466df3f4e5698100d6b10f3a235700f5499b5910eb47a46e3090fa7c114262(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0193fbedcf78177b22610b6b16fd67b390e88ccbee4d88e931f576fe531753f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee0e4fe25e2ea29760d88e828f66b1635dbf5dc277ad0b0e828b965f466e011(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1688744c32ad3d7b680a02d73a7c139ae4c26e654119f10faaded221edd9df(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3e2570efcb72754b6258010ae83abdc45087840d4b02ec620680a152616382(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b93c5b545529496ae798728789651ac0407a472af9ea5fb1bb9f93a2410bba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df658480efb2be23171c50daaea14cce2b4a2017a01eba4aa306555dfe146f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc64106534d2ca0a885e9901e1854a638f67b7c705f240463f264f1aa519d63(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafe1b16a0be4ec45052ea0edf57cf73e20937aa0e6ecec2c7da159e7c8dd24e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbbbe8409a30fa8b3dcb1cfdcd30341d2a5e4e53c61e6c0d3a20f67afa0cd857(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f0f983d98c66beb28b0af8817f4e7c3fad4830fd4462f5719ac9faec772fde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4535356f67f8505d546c3d4335bc5e82abd9fdf3060ffe2d39427faeae4667e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a816d51ba9772d192a37e5a8196c7b83e4c19996fdba5e24857b65942c6c3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f32dfb0242eb72b49be66cddb4317dcb54b867d621966c95979726f4dc377b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b9dc82329499464fe302b91e892f82d088cf9abf6ccf86ded5fafad19d02a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a9dd92b1988861aae42d8d6fbde8e2670ffef5d6f3b81ab93ec8dbf528a1be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38711158b10cf87ae5b6ab361f07732098d67047c9504d9592bb02f965e60519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06ca2c6a1e144de40056e2aa156203d516813465fdcbe9bc0e704786130d47f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec272d7068666545b259acb463ed2ba906f1263326fd43cb4631687cbbd9f7a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c379d89e474445b7f58f486b2f78a6e7847ab27177a4b856017683f72a60988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ca666d9ac30fffd9562b1927f4628a0ee2fd1805934d45648a72f80d202145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f46a0d6f16e934e2f3fa33b7414291509351305a4bc9c89398a1b17c331e99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ea3036608db25d1a71143dd4f1663e524b7cb98e877008757ffaaf64fca53e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cdf449c280747f39700d880369de0d182a82aad2c4cc6135b0959bd3ef67b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e999e9b17adca328fde3ac234903dbdc792fc4ae237708e6aab7043f9fe203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec523d7d1776cf32237be3ea3f9ea6c05d8fcd9d4d37df96d3a3dc7690803c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c5d58798d00ac7cedd551dc6ec61b55cacddbd8e53498282d91d8b6d070bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9bc6834e487c373b0e9efccdbbc29bb1d5beddc284dc26341f36560d875c26b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3da6b1bebecfeecdd192c7941238bfca60951fa694d871ffc84dbb35291d5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2346dad6741f8fa1eae24d32f56e8effeb0052e2dcdff92c0834719dbfba45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983b7aa4f723b8c91c4cec291ad27a577301a82713f7d5acb6bd05c1e26222d6(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365e558033fff06b75541782918dce2273aaa25e9f6416e1c5ee768a83b1a62a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc713775498a1425fa89e07641da22ffc48c5f9ca9e7ab3c58f053ce56721b7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab26bff4ceda1fba7d95cb80d0352dfbe552157a171aa789cb28c0d531c3517c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eda11c09a03e80858f9c056d69bc60e0b11f28d22ee5c7ebb0b5fba96f4aeaf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293190615b86cf2b66dcf63132078584805cd839f7fa53b8f614d17a1a21f569(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147a5f8816894d2cdbc8aaceb59a8d466461c684131e85b0a89832ac50a42b74(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b9a7bea321fc078815ee4705143fc812dd5088909d64568191b3d8c73c8589(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c414720869b7d7dee34d5bab79e4beb571c4d8049e1dcdc4452b088d3829f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d9192007ec1b8cd8ebeb628ee140806219064ec6258dea64c1f2bfcde7ae71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c919f486e82dcee9d14ec97a1de8107cc7360d02fe8759c856cda5da983ed4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27fc5856f07dc6b7c63a57b519e72cad34eef14d0467061cdbf3b87f3ee4d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7f54c40068cf55d96ed9f3db310bec4ac3e14bc46159cae422ae64fbf33218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df193d2fa15d11832f3e8f084fba2968296ee47c6e1855e7261ad98a888839e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b53d0c96f7cd12349fd3e54e2a15746e0b37f247d2e5af8eac52877542d7ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fe3324db31a88792d00c68454cc2e28385b960d59d1f3b823c50e27b9aaabd7(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1481f65a852ce9947163359cd3060501107539e66b0cd87152dd471e39361c31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e5e6540dccdcd59ea9f70068df3186da02522738e5da9c49f71a99bc248d10(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fe3afa010571043ac0e02f78e5221fbff108bf405998e014db2733d7c1e15d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3d01da2641a3c7793b8547173cbb21c465ab745647941fac1e42610206d826(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f82b12f9ea1f98e0580b9eb28edf927045316031390537131e4fd6198c334036(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ddd2c83286dd9694b38428d5d9e3b223a5cf34b776d9a88083318fc8df59912(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d624301bfa3c6320bc1e4d612386003bdd9a48dab943814eb001cb764855f1aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa052e3fcbcb99471edbefca05061543909906e6b758f070254e1a7d0b2aefe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43bd53848ebbb3b66dbf14a6c6199cbecb8aceff120a477655b665afff4231a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa3f3fd038ad048cb684a26d0f7b4fa1aac7ec139273b8407f860b2149ff26f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c642fe6bb63614f5cc444a855c19b832975b39365db2b9b4bf73201e71b45294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6996b3cece66006848bf2195f1727a698407a94211ccfb42a4742456961c0fca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8cafe3522cb97dab49b4660c75f7446ec30f842f538154e07ddbafdbde344f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658be11a227496adc27b79a2a0ab9d258b0a157664c61c63dca18c069caf126f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__008cac81182098b147228120a5e5acaafb09ce07c01163181afe7550b3cb1ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1bb90e84b986f8236e338fa6798960fea962775d7740e5d480c6e810853591(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6050f82a77b6c879861271ebc0b656aed846c3c12831fe61dd679b9ac0c46f4(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffcb6497981692e23ce025b126841ef09077a58f01f7e323434681fa456219fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c3d2d747325c510e3c6464c5389b52186fab9ac5f2b45b50f83630550558ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__315a17d1a45fd10c634d05da31107b45812ebc792a3ffae1b6c793fcd6f176fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9c486a3fbab70f5ab2ddfc612a3c1f7713dd3983a398bc42c3c8d29358fefd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf796e883a4dab6bff752077365559e037bd0577274aab99fc3769a2c038e160(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83a2e65fa3907f62f7fcd4069d3200d7d758b990a1c6a43cafb35f36a1bba8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85801151719521a02f733bc980000861f5a86d0318f27d00e82976da38ca81a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770e67ba2bcef5c2f4f67549bc4b0a56975b1e1a746166ee7f0e72799bac71f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b55bcd2015105e7466c361275e35ab25c14b5b47486209864004245cf3c832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151b750644d010d5fc4381a6e1731b9f369e5b2627d3a923f1158a3c665efc38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a1981d3500242d327f49075d39413ba1b25ff10bf690458d85b002962b3145(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b657e308bd06784569f0139e362bcccf7184069d7a3e602990a384508f37ec8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36df53ddae759bf9d053d72cf17c845ac6b750f9b5a1265968932780aa355096(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67568b662efc1a9e90dbdf5c1f1dffdb20afc9acbe19db75ff88e49f2d833099(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bf7c51acf9509d424f835df7542013b5df9b11e11eec35c093973cd537ddada(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aec5f70ab07d82ec41f1df36208a630e903cd7250f4b2a2a3439be4571f2485(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e27e6d0549cf200df2cb534d74dc43f90f5704235b8395ea3872942d4caa68e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762a155c3cc96c5f67fd5ae14cc60e8c9ae1df4c165776806649788c5dc63681(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a07f5392ceb4077c3d1a982c74401b6bf897b83a456b2029a47411c5d4e1df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5854199f30a813527cd0407c21f31a661a9b5b2c884285782a251ebe9bfef9b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b02f3527982bc8d2e5fd8062edc88d00b45e0240f1e563c74f78947ebc242b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__449172553fd3b56067de478f23f10b3203ee5b19053ce2b1dacf0be6ae187449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a71f73a7f21e8635f07fb63f2cd50b1cc841aa04cf991da7ef71e263dc647c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8927114d1554c07af086107d594de17eb43fe430653e97e000af4837ae25a398(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4500dd4cd4f72d169b7ef6648d5d4b6f44679c1f81b8a80cd02b2810263e6030(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995fa6930d268e835a1c0af761bdc077bae50b277800dd66b1b3cbea5f68ba42(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b738ad421fd9be886f766ed6da2fe1ac54f82a5baa3402460dac2f193b4044a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dfb3bbae331e6b6cd9f3993a0e5e4d65bc41f0c4dd9e1364f2f454941082047(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4534add46aa2a576561cc16c3cf262813c75f941e9c3f348c117d56e821c16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43aca8e85a058d8f0e3c4ab74c6d4c67979804d37c566bc1f9e56abceb916fa9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c179742704dab54c1bc4d061ff1b51aa0485962e2ec71d0b0572ba161608d715(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9518f0d0ea360fec391ace3ae02dfee2cb964c3f0bd53ec5538e3a66b02d6ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9daba8d433b08d2f6d7f1751ce172e90aa512ad53d8353af03f6f1d86c897707(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d869b9396edfae7b80d112db743589e8fc108302e44c0758a5b9bb122ae107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96cc133988afcdc06028891bee4897ba74570af6f8315675cafb79492e8f814b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3aa71a48aa97fa09c5253dce2e274ea7c1996e14d13464dfd07142f2cce832a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f2ba13bae2c0465d40ef653e6fee7686d3e9819970f9f2427445d64184233e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f733ac989ac8cff0c396b6f240292286fa0d99a3fe52b471ac5c48046dd4a84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05920f75d7b700be75adca7b435766c2a1d0d7e77394b753c5b30e627da3499e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882a1aade3c559b72795cbff86d35f6f58a72729908aff461b876d209afb3a32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa5620d7a9428ef14e2cd25419d052c92d093734c2894780229a0516ccd9a97(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2328eda9f32537064f94a4dde58634988df979b3dabec526adb6984bde2b1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d677f0432c4d7a51b2d356338b85a0a5bad2a1790e56f86e95be52bf4a10a7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7070c5919da7e8ea1d5e2298397451c1235afaa90371629da6547288828e1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb69a904b37774022b2f738c2847da07af872c9329131507bf71d6a46309a55(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__004f8e9c71ffdbfc6b3387c7a18e062dff1d5756896ad78c9698173fae8b0d75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab41197c61657a01252d92fe5950eca95516c0696bded1dbd491c5a810b43f06(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfa6dbeafe35a52a596d0006f9f2793d7a07641a5b2d508055b3b87adb677ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e06c2617116212979385e118fced8c236915a786a9fd5f9c68ae3ee284b1430(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad97897e6fe846d70a6035976d1ee9e81349fa446851cb056a0d6f938b958ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118e5836bdddf63f40ccb6a368dfd47427dbec2f541809aa00358f129ffded58(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d40202ed90e7e9ebe179ac776bbeb3d66355de9cd1daaef74d54357db12997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2019ff6f2af3e4d092ef1591274bbaf5f7fa28388735ca5bf68ccc4929c62b76(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddfe2929e25c84848b4786bd7eccd09e1e0458e16a0e3cd16e4e53420392f1c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63a640ed7bdcabc5940cf4ef17ea380879a5e073f3c45acb174ff5c3f2872fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5354f0232477fb468197b5b2431f086ba169495b0cab27e1f1d42111c02a95b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3fa7d9718e7a771076a8032de3f647b189c64ba070e75b2e57ffab0259c328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef2a1212646146e41302ccc677941baf7c1c3a4b7e72529606677f0b3b85dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d55482b96e4c42f949fa4468178420d979699722b82ec5cb1822b5b7ec56ad7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834ea0976c6c550ed4668141a5c09ef39ca2b89c7b677034147c7391ce040637(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c89fdbe64e8c511eaa93d3a8ade2480ea9ea2e05ef8e4199342e12c0860d3d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a00d59acaf8603669b52ce0fd8acff86482823c45c2a255ff70648bbeb14da(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__146ad96a52ed7058aabd1b1ce10e4c3bc5e4bc2514ac34bfaec7705e6c193fae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5ff8025c356c98e0a521972ec961bdbe1767c0ca1194573d652bd64372df06(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f094d74419dfe6f43d81e460bce51a435e832917302841f910e5b23e44aefc8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ea93ead7969dc81ea1e3df34d23db5b6f4e48e309a3dbe6ae3cbab4684b9a8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24eb14ec88ae739c7b6f25aeacac9d25531965a07873040f78b779bfdbda1ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e44e735bcd0fa3d37e47d12d2a0e885527a4902e482edaab21e2b97f4ce4ca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5f24987c2d5bdfae6e04d6cdb44b05d1f814f67549eed5b5dd23b9f46faea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c92d16eb824f7bd3747cf84e85ad5fd36c929a37cc40438a831b6ff33acd3b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b0de6553d8a09bcfbb956e1fbc0a631adda403809145d5e7597794b6237581(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170752faf8462083ecc9da25e1f0e2af40c79bebc0b88eff846b8fff6132ae9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7d49e623b04377220e7497420683f7721e2ecd132d5a8eaebdbc4cd96af5a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44afb53915c45d806c6091e3510e7f310e266cab84aea3817cc01991cbc46ae4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955a452ee1d1f52ae31d9a23d9458dd651dd832efa938676cbcdf506e8196f19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd142b39c9a81b35f3ab93145a7d62043011d65d1918a7d3c96094d9db13b68e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e1c7c83cb4278aba9510078c92dc81fc8662ed3657ea4310d4dfa928f1eb57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64275b2376ae2136f80df3aa9f9354402c95961f4b9ecbb6f5f15943a6c78a60(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__341563970763ebedab7e50be1403a69190763ab2fdcf58563955a704619a1716(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f12144126f351386a5b5497655c19b93e562da243f389dde43a290dde667f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cad77ccd3ad9c8e01fa39576010cfdf4b7a3784829854be17d83cd8ac092d74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5495e3ebde351d37dec485c2513b96c02dc5229dec7edfa226f2ca2c7e9fd68a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad826bd126783caa52f9328e1e712bc5ed038e72923730cd991d1688ef95aea5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9360e737b38775d51049102365c5f76116518c301f5179edfa23b57ab9a6557(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0894f3f18b8c9984de7e431fda942a5a3ebab48da8a29866dd3354a77630ec1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290ace199be97e64bfa33c3bb0392ffa2ba34ce6968f9d96c445cadc7e6aa807(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ddc3795d5e8ab97cb690cb58d09c55706905344015333b7ca77b73f880c971(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b97a7ff2946efe95e1cece08c5c5cda8209ea5b3f3e38920f70883cdbe02f6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9950bf833ec99a94c940e7fbaaa55505e23137592a99601c92779ca2dae02b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f889f25b6a75e05ef4815954f86918dfc8b16a97cfb7b5da940483bb42f5fdf(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfa8f5a7126a5f7751ba58534ee6d0c74a2bb8359f37c43d880760b04542415(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1293701ba50f016d7486b4d08696b9e696ea6b9e65b233c4c37cf4844a01b1d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0d59a4626f07a26fdb02b079e3d0df15ee6a9882f5d7552a25e20ff4460082(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a851ea7ea6e984be238c8bb18aa9036e8887c0b2b47659f65f54a755d7c50b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b63f2d4b3925b4680a26672f0ddc69bd7d52194854c94a2471319e692830a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8b6bbd231a85a2e25f2d630719e05e2ddbea4fc877e83d7244231f25b74173(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a4d6384e6ac7e0b3af01e165c7c24828a23d2334da7aff9aa25980e35a06c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b0db445a408eade68a03b758909aa0d1402865989a0ca101ecf7844a5b20b99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e773b5e2c0a668414eebdcd394c70e6ade7b233fae8427e5ae4ba2a7f4bc1485(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d94d5859dced80e77207d523f0fa71d591a6507bc8f3655259134cae871ffd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753d6f80e251ea761f2fa5262055a8f402aea31bba10b8471e3521170431d3dd(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d9ce71838ba811575dae073d03039193d493217a852da6d692e20b28b6f6fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a291f9868fc7e0dc160191a39b963fbf4cad05d71b58d5f52effeb65e4ae9261(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e65a4038cc34e6bb317f7a5f8c2096a4723e6093d4079754674a5b220952130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271fffbea2d5dea038ab4fed9d83da2c950df685b5e2a38ea3ded701e8dba51c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9ce35cb50dc9a7e781c515ca0680523180a3eff1649e48b540930de77e8ed1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb9374fc00d519a9a2cf8a713cc817444869dd112903d5a045b68179b4806a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84298d369f21868532ae60b1cd2b59a62d97107c3a5384bcbb52855115cffcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c82f1bb00b0ec280f7add9e605cacf1b352cf5e385e25fafa8e3bcc033a49b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbaf6f3c57968c5f46cccc60b40a18d91632e8378f52fe204d1f58b31142971(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993fc90e19e2ef94b1c953ca026df56fea8864d7f7e4ad8b729bb40e5af5e303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b670cf9c509960a90443d8058d1f7131fc7b1b3d2741d54b839ff5b32fe12c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca29f582c64a3e78f79453c4a0c74cd9950abc1030e60eb6daf407b142946bed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be69ef89972c98468daa2f26118bda804ac16e48e13ffc87701fe0b10c19478(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6899d1201684116935f3fd16171dc8e806b8649776cd4f158d8f87c6416573e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e20e8b2e9166460e4b310585a18ccaf5181dd835cb7fe14c2a0dc817517bcd0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b604dbda5ac18781ae73fb49ad117d7c5d1e15481328684e80c392e1531f54c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab6624d787453be7ce317661b646af83dc81f4626adadcd7ac5b7d8d04662e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af06b259e651e0e7443fe5cfd29f034574f4357e900ada170dab8c7b62089890(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511c3e881b4bd63a2e889415677036bd4dffacba12bc01fdf1de3082067a6ca0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9b5ea855d1dc7b1b0814d0fd16ddc25d7f713555f07df646b65096870e79ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11cc5b96a9d0948d97e8604af580c0725578878135ec1b38a1d1ce83cb1098e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147ca8df970850dd47d7e27a8ab312949ed29b9fc41271954d6714adeecbec45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1959e659acd857fbd44dbf0fe555b65905f729abf9cb9d90e2864484d392cca4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b30227fa98d2d35f06a29ccb2a901783d08844f1bb8642e4ab9e3fff4e0e5cc(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58caeca59dbc65dd2ae7c402cc051aa0328a59d413f13cc610bceef6e58a01e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b19099a21bad3dcc9ae43235bb56197ee8f78968bfd297d7d245e54a7c82a84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c086257b8b2ec3290ee898c9a360e2b8bba8b3eb0a3774bd29c4a8b2e5f8e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346b67a2aefbdb847052f51a561e51293095782ae18b2955157b6abf81722347(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5384d9fea65cc218fdef488fa198607966c55c5c6f355578ce0212f6a2f67530(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46963d9472b0a55c318415a197fa11b3afcc027311c15301b0c6793d26136c4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a471bd3d84eec9dcfb21b0b56ba193278220fdeb18891bbdee81538d04145c8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9aa9bc6502845abbb9f01498a5dd107fb1671bc39409a0da5d61c38047f55c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1c57c5a8129b63b704a5e141c793627e40e6a30feef8f61483511a6f374d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89fef8f1498f2eedadd921661e522d660d285f282aba779b55fb5953f9f92631(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5031c803cc1bf89f71fb14531c2f8b31e27f621f8cc6cd62a6a5e72dad38586c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790e444b8f88641bff7c59e139c132dd640a888a20bd006d24dd61e5ca73f833(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40424133f60e50770f4e55757052079df6c31b841dd6f5929e02ed70a724eff4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc110618f6898c24ce1d4959513219dacac63cfaf7295b5446421f73d80d933(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7786b4549b0546d75053d277f5ee6b93b9b3901a4e2ac2cd2711f333cf298899(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c0173f2cdb067cc10561dd7083615c14761b7ef8e055a4db12503823b0c081(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f277ae7b36184d28a2e9fe5d84a1bb0950be9488f488bc27c273f4ad4be898bd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b561cb3e511340f3701ac5e0816994c2db6505cabb0bbe7ca2700a7638de1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de2f033c50416429c145350e714e3e0eca55c23e86726980b151d0d915c57f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b88baec4d6481e79d470a2301908d57e6517294304ed9b0625f08d9f26d25d57(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bd90b7a123990e91e5dc7e686b5373fb42298f17a0fea507e3c366c373832b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0718013fa9ee4b09c7b26988d379156fe3b0f05ef8c76bfbad5763adf416c7f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f3c39a1bea26eb0bb7ac0903ebafe104f3485f8d21e6b38f5dca8d302d8a8b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2134c42c3aa4ea087c99695450649148f8efeac87da0f5d4ae912e8d3f452fa6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3cc573e6413a39d0e7b7a43f80230801ea840d09cbc54fc54f803bb9705dc55(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3c753ed06ff8ce1ca052fc27030f2b3cca165695d8d6c40ac6c4ad82570985(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d43740dcaaacb62ea72863cfef974a5b4850190da3a21cd4242a1b753d48232(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c530f7fdaf26d8d089558c52f58f8045e34b553fb1ec799529a8a58c3ab7d8f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492099b1693f351ae7d413ff96627567f17554920cf23d290bf3ce3beb836e44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86620685be116c0aa5c98f16ceb61b4057df5923ec101695da0fccb091450d51(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f17ccc40c6cae2b268eb2561588aefbf51cd7b62c1926c6207a314c4bece1ce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef30b9736d5ec138d2fcbcaf8e6904b7720d086f1003b2ecf1f1d0cdbd7c0c9d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae92d1a543ce908d7f6ccd37a785e0327b3514664d7b1ecdfa6576a080d79d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8dbaa28c2eb33f8fab1b2bb81cdc06c2c32a2b09703132e8c034f537c2ec03(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab5249e1a056c1a9c54977a262685807160636e6c4141bfef58d205c81c14ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df5d6b81cdcc859680c8801eaef0e4582d7d7ab45921673102a56c73edd32d9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d0b83df68b22511bfdafdc1108346999d650a03935dc43f2529bab8048ebc2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bcee46615910be01dfdc1125de5cb16299d1dc9602ac5879cc3a2f925349eb7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02dc24106a76726ecd9e37439a6ee99257b2bcdb6865ae7e271bee569053c37(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17c0d05fae179e867936cbd91fe68b65644f358ecc8767187d91ec06af45511(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e911b4940c50e5917ba9c5b34d0c43d447638401a5d11a72d6b5a8c148667d47(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6bff755bdd549fd2b43808991a482e730a4251ba022b84e539844f2ca59db81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9ba4db362043fc8fdc4f16130592f6f03018a50389ce27fe5a2abc2e3d4332(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90342fdf71587e30af416464c265f57dc5de23b9237c46ce9e36f358a9c36e01(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112fe2f1a57cf016fc6999b7004c088902420bab46eaba1f8eeadf54c72dd4b7(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd4e4bf11615ffa1e65e4fed9b0b81a5916b4b3e2ee76b7bdbaec8a52949fcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120d2dd102d9c563dc5197cfda71c4327bd7ef1fd76aa5a8548c2d9a905064d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8cf9b1d9a81c7907bca8ebd1797fa0a057c8596ef1a7d8e5815aa2d78318c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9dc515ec9e8e3dc4b10ba657230e827b5c9a220ce71abde9ce989fa3da7ae7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2793948fa739566813bb42ffe1b7cd6c043a9a69b71880162124e7997a59bdcc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5b371280f72156d3799f2fc43c409e7cb4ca3a62ca57dbaadba6d366a10dfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edcc65c3d930f2e42167b783a872517cf75e3ba995d885a980475ccc29e029db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b032ed2a76c53430e104cc9fde4fd74924ceae3fe9a735dffb219057620fbdaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6ac5be47fa39649a9b570510abe1c5dc3539ad7a453ac4d2b70749f2ff4e08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abd1bef88d4a2fa8e67530dafda01c457d71e9c8136534a0a30967866c5a4c00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f5f20f835706519a7fd0e3e0d4ba72db41c0b4382d7c39a17c4728a785e102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a44ac10240508bc63c286f607df22a8149201e2a96b2c899885135b0b727c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7de1813c2acc27eaa79a0c12a332901cfbba6a9e49cee75ee74c0ddcaf9f2ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__231843bd07dc089d21d99be343be8c6ae6da6028f79f529467ae2e3729b11547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83499f520ad63a44e617785b4a8a8a75a9ee9805e6213349ba7bc409d45c45e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6048ce4f591cb510b140218c5d5653b634a408134cd4d933e25e9333ad3ae00b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec90342f9654ec9f3d38d57be41bd43fce3e5336a57c49ee49d23e301458e54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b3eb96ab67ff930d56a1bc4942cbee791d456405d65fe9d8ee6392987d880a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33756a471a5d58227a927e599b6343a89529e8459a55d380d920979b77cf274(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83ed5d81240e7e8144f7ccaa92f3cffb4089511448870a3910af205fb93ccd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cad93a9f9380d7cf98c244dba74776ac6ac310c123c52e1cb1770668e06d9e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113f59c0f816b89c98c643f397300dd0b1d0490743d569b235856e2337ecf209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5684e813cd012b67ae8507ff2d6db11d6cad791d5869281ea21678cc7af88d92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8cd87e4b595069630d7c86f166251a18fd7ed3024ff46a3a51de791307884f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708cec71edecb55e48110d7470e0bd1a57eae456812a194a9ac250891dddbc49(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b9054c20cabb6ab9e8a16918f1847044a0b059e45a118864bb9b70f4bb4e3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa25109dd3fd27f443a77194db8be54e89747c98d3e3966d8775a94d63a6992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b44d1a416b3da364ecbbceda2abceb7f5abccb8c11519a204e0d537847ae6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38edc64cd66ae9794b635b632fb63360bba979e0ac93ea13b0fdf089759218a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bda69fe6b1bb047ee7ad1d24b68f7b9a19162882bfb5aff81f2b3216dce2d26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb8cae39503881a89dfa5363d3bbfa532e513f986a7be32dd693f9846d0aa01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df45286b9c5b6fda3f74edcd9cc8465cc783d8c176aaaaaf18ae425da41da7f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c003e3eeb21ba15be85f17229e01d2f21227ea4a79f0660b8f2913d4e025b55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcea3d26a59a3ae2595f28015950c69249fb86d86dc5c00be98e3960145cac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898a04b479a2e39e56eab9c9e69059b0edeeb4b00afe940fb30dee9d0edac296(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bc2ea7da49144ef5b6b75635032909ead8e4ba4fcb9386fcce573c1d07f797e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd81d9416a2ded861cf8139d52244fbc6dc4ed047938cefd201de361b980f8d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af6d269421d0a8148cec07ece0817a024c851568521f58fe8f4261eadf7ae7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234d0d33caeea5c9148699fc3cf719d73af5a0b2f02e10acddaafc780e850959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5a52cd15cf50da9d35f799dd1a7be42d209310cfe7ea506f9aa81bbc5b471a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21323fd544c85db1d34ac10cce48eb6f16afb8db27c2ffa20cb1fcc6f679897c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec85d7e17f997c114d842ed5582bda622c70b1b0f7a149385fe84759fb305931(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cfce94b1ac0baffdc018f5dbb03622490a86b0078fc8bb55cfac59103fb90c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3342c198e8bab9b763560dbd140827c7416c97b4028a230b2419cbfb2c445b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c393c9ceeb9ca0b2fcb63a0871a7100222f97e8dd84d8fa409d889d04b8864f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af4f73fcbc48a1841069b58f5c6d2dd6404b6136d6cdd0118ec8af5ef649466(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03a2a0619531288f54ef44a8c69b7aca0f47c738714333c2b081d6758925460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaed0771b6614564c572a36c56de3f86b6c4d95e35676eeac75397f576c8fa57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa808b8d32a380e96af2f52390715afffe3e5b0800f6eb75a5662f89e7fe49bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582759e385c99daa22ab55e7ac0b51923a32e3694555658f82e4317d12f364a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac0511d8aae8de96dce9d56a4b524b967914a741916df0e6e84531dcdbd4fa3(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb79dbd1e9d23b38cffce53348eccb848a9621e72d7883ff64615b5e86535d97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fc784fc2ad2bf811d15f97bddf661bf6aaccb8be672fda505713e72a478db5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c44db54b2bb9e564fd5cb60578511c0ae99f611a79857e3da0e099bbd29a07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c202e4b05f1ec85d64285900919225cffa227177fd5a0c923da36604f18898d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee339f38bcc186df3975e1621a5d67336b5cff1f688720c9bfb5ef76618cd87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9981bf8bc603546102fbbb8fedae96e9b69ea2a8a5089333da4ec9ee8053c2c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe86e6a6ea7e692fd95d387c78fe71202d37d89c5b1343dbb391f8087c1ffeb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc83e4bbc14391152e183e9812b3d2bd2febed59252511c3b11e7c8c40ba0056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c232dcb4dc231356ea64f03038637e10f5d8b37ea5aa4a1bf4156dfa5fda824(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ef90d35e4b63ecbc35c26c6e660ce30daa2ee458736b38fd451c916a4f6cb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1945e0203eff1d7d793082b96dedf18bd10836078e1cf362de5b2b1bf661d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4569ec5a396e54775cf6c854a73781337b1e2f8d1409c945a1d63072e54d72a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ba317f75f9544c058a912082cfc746614fe10c837b7794bc32e5f68c0ad1d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd4ad79a0c21d231d3b99ff9f060d0c17079e021a56038fbcae202bba3d746c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811cc2ab605adc05736300cf6676cf386a9e4b49efbbdc04f40b3cdaf2186e7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be10d20b4f504d6f72c2b562fdb30f6109dff5e9acbda46f9514f268a63f4a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5439423a6313e1e07de48662ee287bbe58d0115f0d1d31fcafeef359fb7327de(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d14fce64a5d2e7a60aa6253967d33aa810c4aa12e68d944518f596cf53fe0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8764f5bd2ce381f0029cb908376700bd463225a7a20f42ca615a9898ddeb6c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9550878e4af4a86e7e95c16de9a99d3370dfe4a0999e9322928404793beb23fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8dc105f74621042745f8f822ad4e8aefa6bbba40d2d5e4606c57f81054aa9b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94bd377ced12018742d6019c374ad734b513b79cce36400af3c15e03c2faf74e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9dd9303a394e9aeafef1e9bc95e4eed594c5d0f995bc69dd3aa2fedf9e9acc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da66bfe4426f71409c129fcf6cc3c1b093057f1166e7865b603eac22c45e32e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb0e2f91573c67a2f61ac623877590ed987ddce184f9401e26a21a9bd391c8b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a681127ca5dd17554f6173c7984328031196ecad77dee5a31ac1b992da56ae65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ec509a5c05bd2a63ab3701eb47503f96adf245aed6734eadb29cb4d86d7728(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6451a773c61f208d1478c774d4248630f2af57dcf419f367613e04abb9b04e(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec96f644f92deaaeaca324cd15378a345ff8f3de837ac3a1c65a3e0f103d4ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b36469360447d6d33d495ca10736a56a75a46d6f898b0ed0fe42cc64551f445(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f950f12fccfdda39c4219f217c14af4f97df164189cc21c0887edc7986af6627(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398610db9360450f4a29019e969c027ef5643cc354dbc93d949558eaa599ca8b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997c342fa73ec94d1a4f250c8d4e160d2efd350d3758c87d83070d703fd955bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037e809c7a7d7ea40e3bdb5eff26f2653c6719cf24a8522cd19647e85ae1bc2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c666cf58f2d47d6f039c9be98ef4a547a51a3a5b9e0376ef321a8a75dd36d9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379977c1007eea9b5a639243d360a54b120854b7ee82ca4271d1fc6cd51c43bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d16f07eab29a1356ff1917c673ec7576cf4d72acfd6ae945039dd4b303e3f2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13cdea1f0c23b6cc2c9dbc55a369c38a374f6ebcfeed66bcf7fea6da1ea3ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96cccfa44bfa6de31b8538362b84115dfc27df86fd70e6237e6a5a64b3a94cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d577e8dbba7fa8895fc7073541f98ac67c8d0ed9b7832943e4e0e4f9a8a12386(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790e376e55f21874b7279459a35ee0b311254373422adfe8fc7731559825a816(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61581365d9b407a102e46b917512194f63093ad6267cc7e85b634cc24504615(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04e8cca49a3838bb9e9e00b19a361d299dbeb676690d549bf873fdedccc54928(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492b32b62a3cb4ed2ce0b134b694ea9461c221e270118e0b5788302c27ed5b4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbed2a64892b36d452e98c84fb519e23769bdc90957a2c7a68779709401dd3e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c77bb017d78e60e3e260fa9586a2b80d84cf51ea14c4efb73844f8fd506f6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1d1fb5c4828034fd0812130310e248b2a7f44fe54c932faa30642194b3ee21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6092a482f97383a94abdc6b5b67d8f0c12e4c4f8c88947b487d090160d127ade(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aabc2fbb3af7dd361169c446e0bfc09958ed8ba309e34b758546e21832e8d7de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16d849c53469cc07a5e47db8b5760866e6a6b207d45d2203ede1f31154cb43e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da9e05164fcd110e6c0e1cea7422e35a865e94d941e7a152ee1bcde97ec693b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed7aae7d233789a0619813ec92fbbf66fe35233a4f505f1a2e459b77647925d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae08e84d33d91d70fe8dff5ccb23107ec2765d3af95ee4325c97c8fae9284d27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91488b165d6791bd9c5f58a0489221bbd476853895c9e4c26c723c7ff050b575(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1910f3c6940adba3e7c9b4cd1e7d63edca25ce639b0b3ffd167b3cc25cd0881c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f276fd8f67852fe067b99e51415bcfff23dbf78474a05d77d1df6b83d78a89f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c647c671d5330051700a6f16ce78c1ba01896f04d642637aa7f8a235dc13cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2939a6232178ecd1d7ad1e4e132a3934bce6343d71f1a449bb15af24de835240(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8112cb7255a8c719c6809a325cf6adcd9d247e854d94712cda3b4d84c4f8ca32(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199faa788cf7c34216e2a424e0e56a71b7673d822b8ecc0b72c9c86043be1533(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963d5f778f1c77ef402fa0322fe7b328d170be19b55c8864483d41a00066ec44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195bc367655eed0de85316fb8a093a013836f5c0a667619103452826de3de741(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c81633bce2e179b0d818c686eb09d29deb9a82c48391afbf7222c70a72968a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8531bb8d756c3f903f109602a54b28d1a4b2b00d96d6c5ea8cfc30afedca87a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd75007a8a838c31e25d4ef168f502fd08aa056192815915577bd77a5ea7536(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497722f8d6b0d34f477c140ac3b6cd143472fd47d3f5f15157d60c8417de5786(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34729cb02733946c6f344714462848f82e456b05f3bbde2d78a915dccdf2c55c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a403b0bcddaca83e73b41b73d7171e536da7b789da59f9e23057640904a335f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1b41559ba398227622d7f703a35f62c7def6c0623ac1f61cce81df33b44a75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6aa6ae9d8ec75a197612c3b31d96d582bc00e788d12adc8254bb045669dbb3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd17e1d05e359fe89f27c4603ee71081315ce1230862914267154acaba4c0a20(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725185bb0059bfbf2a70e71b05ed992732e8094dec3183ad0e431c858f37fccb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb529bfb584ccf943ccbb5b62c351043fb316b83875ecb87734271a69d69e738(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8f0ecce0466f4358c516a6800e8ecac3ded87af3a41db21fb7a59d59bc595a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3316681491b4da8aa483f00e0691bcd10d625f70c47d4c72105afe6cec6012f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a896d18ff21ecd57bcd6f8e0a01dddca5eeb4969eee2806cf75c1f2e8266ea32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b752de2e352dbdf3aee8f171797e9dcf1059899969c47eb7d6b81047a1ab03f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf2410c96e92fe2f69790d9323dad1536e7b43dfbdb2c63ac2edb1dd545e0b48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782533f6d01ef1d69f59c7584cf3ab133855e394065603cb78b505eb1d0a55c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bec97ee9bcaa26775252bc27bfd50c75bec7d32abf556a065fbd4459718fdb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a091474dcdef4b2a901d12bf46a3edbee9f522df009e702ddd008feed15a57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f53736e660f5f24b574b1ae31e026d0592dad07e9d3acb607797136f19c05e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3b0a8eeceba48ed74ffcfbefa0990534b7e130d9110a13510409b2da459a5e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6560b4043d8763aabb1b28070efbbe6f29aefb58302439248e32f25516184db5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f48d8ae401f5a053be242d1965619cc023ab216e1563d59891e355601345d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db97b3accc35e21d068142fe9ed39fdef162ca21d4da6700c731eb32b52b250d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ffd89966101ec8d623269f05d5f4caf4931936abc7d1220bdd890ed018ca7d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88a8da00056f82497031ccb696ed7ed62103bcd375393daa16e9fb2baa13c5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf67c770d5197ffc9cf055226317396f8a71e558c4d976fbdc205a5e8ee2da2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d10ffc86df6894527a1b56bf898b279b3d02cfc6d0c4055e63795191bf63ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6c13a137e1c48cd943e59213c81bfd4ee568d46306a42741c2f6a0cf7b7b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572258bc7559313307e8bc575fddeafc9fd518f226338efadb5fa9e8f602216f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2897a3dd89c663575b5bd2f69c1e752d3aac34d754c20ee7f74207e11ba4414(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f415f041048e6b5b2b518a549e970b4c8bb03f0f253c4088b9d1796dfdf2a38(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f04cd23dde606242eda1be425b28bcc4bfaaae280fe5fa85ec0cdfbc984f25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b205c27dbbaa9103a491187ed566db4754ff4dbb3c5ed94e4849ca90c9e4bee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d583288e3087acb31e51ad38e6e8401c811b71296d8a7cbcfe7fc5f687c7ff79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89daefa61d35a722c8e04b86180698ac265dd6169ceb4f8260bf543e7297d5c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c08b2d08e80d621bb3fb28bc7ef1f46e78e9fba92bfc823e275efc3a979118b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61b05a14aaad261c1f1b7d5ee50cb5bb68c16d0b33030fd600578f5003a9d26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ad68e0d1a25b44f57e18b3475007bf954ef0a31277581fbf0f8d1835d98c49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0af7ea833e691a83a54e7d39c211a0eeef897c1ef88e80604e515dcba1db5c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff81a0f22030649c26592067d65911108c9c9c92d971ffd3c32ae0b9139d5ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50342dd5bcb0e4eadc1e742b5727a53582cb821ab1ee465e21000b893a006972(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51796c18b70afc166121de7074440fc51267efd9779443133628326e33acd5c(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac16aaf9760f0c07cb237494ab716a2fa326d29c99de128b5e58f7053e7f58d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980b5ce765c629dadfd9fbffebad930c0bf1657c2e6f884c8061da60f2251bf2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e73f9061d3e803aee27fe6d25c1b9652ea2546bd70f49caa88a75832491398(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5d35869e4a49cc339cadf2bee5b99c286a75167cf5f1c5a1792aa2e05fbfba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2eb5e0dde5d96c3551ae24d4ec2e8874774d42fdb4277b4d43ed5aab35449d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1f1c1bad4650d71cc1592557a6c50e25444a62694108b3c1218d84c8dc93b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32bd582176f7ec72e3f4c7cdf7166a3074b9df0fb463366b2646dc1199e55aa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a40a0ca0fe8aa4709327120e5b8b658020682950de7acc03985fd637736e7a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5afdd038d4dac99fc00bd693d2b11451c7c3168175461b16503a0cdd077700(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301d008b83b327621de341f1f434f7618b618dc0d7475d952ad3bd586904fb21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd59fa5533003511a28f4f912d8c40570d5e18947b20aa0a44dfb8242cd9217(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2edd5d2ebf299ee6fb1847bb444f8732fcc1617d02d14a305887a2b7110aad4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6ba0872041be30c6bb81f676490c30bab133b222e4cd853619204b98c48e03(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0600adad89a168c83edc93049b495bda11fdb643fc0b8c06213a2b7252b293f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1268145f1ed46662a28ff37acd0ecdc9053f0af2fdad627d12481d5a1727feb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ea8bd33f333b8d42758ce854a7cf2e89f1026adcf2eebf52db96f665007e11(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf3d28245b2187e679c2256ee4d69ff2ad6203b26148c522cc98541b6dd1f99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c16a62e3a7c6b7bb7f033f33d5eb661ee918bf3f52ca2bf82ea428f152cdd3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc751bf668b9b6f1b22c0991fe2fd771868989e181a3d3f06af921575f80f31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4dcb466dd9622c622fe712e2b9f5bbc5ec1fda8a30c2fba0682f58b62405ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d7cda5a57ba07cb8b351c8f70e1dfbf3c1aaeb80ebd5de63887c079393b5e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2e09e704d4d29e8fa9befba3e7a2f946fa8239072f1de48c9d86534f667c05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3416e5a73b8eb1d2d571ff4624f66f1c0c061cd1cf4fa335be5c84390f10fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef30ebd450d34a29664167da920ed97bf33bc7f1e7cc14fd218a24f5ba59584(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d009388168220141f178aa5288b0c33deb663f5027dd1362bc9da64187b8fc84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5610a5102afe13c370b589e8f8cd0c1639cb7b18fa9fb58d6d75715baae22c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf78790c309810a4729a22bf0544e5fa63b579b56ccdf9c0a11b82d82cdf049a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41be4f7cad203c6df9fc9b76faa4f7ce956d4f3a2d89c536e39336c9b48ada26(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a383f05d635857bb7db17ebc390fa25c3a2dd93e76b307ce70d07916f81f099(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0c14f337ca5e482e44385d9e7a798221fa5f278ddff8d3d3d9f445f8d1e414(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226f45444ebd2f8200fad59752df1c1776148f74a6c84fd8b4303a33195bf184(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4576b5b35f552828cef880bcf583ec5923adff62a7d4c79687fef8662a1aaa4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd93a9a3bd04f0ef462f3e9d93497d3d33a272b44d3b7d0fb13afe8affff85c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f11768013ecce076539ceb31b18bbb1ca9772fb684b4b4c1908ad92c80e06e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d3af527612ed1b038ab100efa79cd0591c69b1369a6234ae69e7d4ef070ff0(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5345248ee6b30e28c4fd4241b2659545a147584afb9a24de6c66b9e1b05d47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760baa55f209a0e901042adca91028bbe98faf4147c53e1a1425d0307cfe33d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2b35c393de2437f76f6bc9f57d799181f43a1ad23b22b728e5b0d6b42523a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a29a698ccc356b48d45265d675ed32994f390e1d32f30066318916a0bf1fed2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0166754703faddb3dc17ba8ef11e45d898002e4425a2f9c999b2f9bbdd3161b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af542a6c1acf417cb7da17d79bac36fe6c1268edea9f371b5fe6311b6e850777(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4803b7a315e719725b506030aeb706dc035a857933c25665f594d1a59bc662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39413c74c27434d7df61b3e9815f4d34df89a1ebb2fb32e628a010a9f5c274b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c9f488235d6116bb298accb384c728d677f202b6d571a7d64c72dcc0eef576(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453f151deacc28ab43b56a7258eb8501bd006684084708ec35fb19cbc973a09c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b302cc872fca26411b44157aae80320760e3c22757b22613ce9b80203b97dcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128430f26a6e6429155a605a364c41e8b632da2fc54dfdb6050be8198f4bf46e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7956ff23a1039a6af147e2098f641ff23eb1c85e9758499aacdfb7690f117b39(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6268f6a33900a359cb7de9e282a4d12b5c7de2e9b50599584235ef0589e5ece2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29aa661667d7a65bd704f31f346997a92309d77f0c4857c698658927b673b40e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189201c35aac031e666a7c71fdf5d190f4c753d82b210c4c54133abb3ca99b50(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64b6c4ad7ca708264b87cd9d82761d07b53316909a67825ced8da3b61305b7b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05a2c155263b6ca4e66c81fd2e6066360564aa85ab6b00ddc947c1d623f59b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21618b789d6255222aa4a504089d2c25d07736583fb5e47fc5c1163b040ac4c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef16d20cca2edf1851ac52e317d7dc835bfe5349d9a79b4cc254ca2039999f50(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d94877e6c9c358e8d54d61b0c0f30f1827b3b4937ba08e98cd14226055ce26(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b1af3f0297a7d7c7fedba51c83c5eaa576e8210bfb36ff9d706873b982340b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae16b6dbd88f0f1d99d2f25154bd9e02e85a2eebc8740aa95ba80a5752a29032(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6eb2c2fe7949978d2584b3567a581f3a960938d0c6964b445f4d54053cb5d78(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0153f0d54fea8946f12ad0162487b78a583506b060f0a7b75f878505326968e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4b4570cfaf0e4a875cb7ea56d59c073c053054f99471849016172b8d422b47(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818e115aa67a2ae1d7542a4b9817c7c41aa8da72d9867befc81fc533fa773fee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d67a67d5b75c7273617517b26c2be78f3e4d1e0a353c053f5dd5ddeb67f7df1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab19b2719458465c9e9e5f97d01902d560cb2efc57f31685f85bab71f1ee89cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ac5fab241dcdfb7c9959553deb11fa9a4e689b8eea783dee9b40fe6173b100(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e03406cd1b83f3e42b25df2b50a04b75e7004600c5d635942e95aa1d18bed43(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab1a27c1434066d9198da23d8c294cd1bd5241833bfc108b159beed2a2c1152(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227ff7adc15c5bc61b0eea74e1723514dc247493a2dd37c3370a8b36e47fe0f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b9783d847a895216406c13b5eed45e108408f25d76bff70c16ec9e0373a424(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6031d29700d529472004924659f155b0a09d70905b2d025f425b6394142a538e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a7e99ac832a75971d79822aa0f14315abfa3ffd684606aa41364dfe0349cdd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5458f12f1bfc0971c28a35385ac0ba80e5db8e130f79616437ea5c5c7bee3380(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7483e6efc6206687e57fa47529d1d7cd3dfed6d043a8d7b933011c9a274287d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78884975b6c5b4aad3df944fa302ccb9e6bc00561bfd544feca5238f1f8cda8e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ce895b7b824e538a4d6061b63e43faf4a673cfd8d61c8daba3154093293b23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4062b9075254556aaad46e4b23207249197dc4ae83fcd7afb4f77510fee2909f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7998793fde77bfa6b7d1f07ce0ff5d08c98b47f8a6ee1937a3166443218d08(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1237ab2037978984becd22873a43651c26f086674551e88c10045ff1e5031a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9686a83ac851e3589bb3075ce1a4f7714c1a97c7432a1f2fd575c3619639de6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53b730267f5c27c7e75cac2267dedd2e6750eaf41d0941be07daa7b37fafc42(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f63eb335a9b445dc466324e4e9337996ba15d303eca30eb7262e6d9d87a6a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555429dd1b95ad1da9ab2dbce3c89342c4f3c1a3f6d5f0337febe3fc59cec26b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d7b194a2a1de634ce89ca511cc7b1cda5b53bd6956413462cc4035dcf75302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13cf18f070fdf08f5aa026cd5994e9c2093f42d4b65073f6d0f57aa41a30899e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893e9e8545e10662e8959f33e66a2efb89ebc27039e7af8e5be3c559121514e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd19d61937296b94e16be0826af8471bfe6e2cf7e378c3293f443644dc667c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dfbed782a1d9ccf10e44f42cd61fddc383bcc9886134ae6f55b9eea2d8c6cad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edbb358e0d598a5d079ea2a0c0c4773991dcd7655c7d96fccb1259d6f4944eea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db098dd95aa94d73b13aca1af5a2100fc34fee9115fe3c59ccde5c68f73ee3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9ba2ea6af43abc6463982088099d31810911ed5c13fc6fc400592f89506b32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89391082dc97f228344ade111c9d07be1d4f884af3afac2e35f680bfbcdbda6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a6b9f80c0fe363dfe8d977206d9299b56cca197ce860cb5d4d7fd01488741b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c94f75636303a6c3d7263ccd9f377b999f5b6679866d966c004ca0ee1d9704(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b349cbbd24d40a1a05863364f16480afa03e467a61afc0912852563e95a9b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20203f8fe5cc2d5f50716754bb248c20acbde0107e8762f5279977225d6c4979(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87649769592377476fe6a2cb664d6e7065883b2c638e11ebf7015b0c6cf030fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca534218b2b0ab2cba2999e49a4346f639eaaebbddd5016667292242cd25cf82(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b64bac235db1c9c0a7f1475364d6f02a9e27fe630987ae099189bd8a0d9e72(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b565f1f96019052c2f90a43b318e6631a71494b84a203b43763434f56d2622c4(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a90d75f672c27aa459bac4c48f5210d3efed7dd0ee4085aa04ac5c3005fcc78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f542e8eb3c6e3345ff82faeb2baceda72e737599a0fa43281ff01a82e41fd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64ca88e7b55c0b47bd6d4596629b385e00865f5d3af9ecf050e8ec88178570f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7604998be42a8be17fcda7eed63448e128cbccb2a2a92274723f0535f59cc5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc852c6edcd403252e8f1a7099ecd5b6c34243af256e729dfba66825aa15e5fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67214c6f45665f279321ca5c0b45f20d5f641834b4aa5bce5d120da082d0e657(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc143ce7f1321750fa18bf727dd06cae81351bde2e7f221a45accd2d595a25b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1d8ca5c861f3a73500791226ee2fadc9a332893afa895a9c09a5c20f518349(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e27447c5afa9c76bc666484a83da7ad565577486163497c3c2af8bd69d27a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5f37960a90c7c619c32262bd785e7ceb57afe91838a19c073f53e9823bd096(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b7bfb88747065c97af2b29ddc562574b1babef9c11cd409bcb98e2852d6c19(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1321deb68539344cdf50dc4a5e4b8869e842a637810dc8e39f16431ee29999(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bc2a219ab5f4a08ecc19caeb8fd2577314db15d8ccd4ba82c0ab5018613120(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14192d3aa537beaeb10a6a0bf7a4dd498096866fbd0d168ea3ab89d08656f55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c370f787dc466930a317c5ac206608a8f419faea0b682ea2c6b887c209aaf10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb1eed0018deaf3d58e3af8523fab57acd320b0d1b8157e1af8c617185cb573(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee9a123872bbc4105c34875d0cdbe7c9e8600946358dd13ff60be2db93c004af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35ee61ba7bcc16edf242d10a3555bcedeeaeddfa565e1894e696fd2e50bb252(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed6d9857b8229555573c5d8865c5f5533b171afbe14489bba616a858b90ea3b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e70d2cb74f58f25878c59110ba43df2a7500c4626da0bae5eba22b555e2a7f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690dc760264919a0f62fd0984502db6af560e023f0cea45d06b1975649d888c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240d92cee9e357a0f9175008709671df3d0b5f9f78394e1723e7ee429f1c3598(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccce24d6d5307ca714fad6a8d86c3c99fd24ce7d7c02029830ce8a4692192745(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32301f6567fdf3c6991a9f3d8e2c1559e62073fc2c59bbc101f768f86bc3128c(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662a3fd4eb0ebf518cca6f3e9d6c98c8d9586ad4128b76543e985a3e8a1a7052(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abeaf3d4889687d0bf2e4738fa77b92a6914cda657ea17587544e55aa3f46368(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea32aab99a4f546253dad990f5a422c3baec079286cf085e3c657b9ebaf2464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8021436848edc1b1234a2c4f79ed73626511899183a2dff248446ad87713c01(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c862aaa676363b8567aa1955615bf159297b34a408371369ff77ca92c2c27c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ba9da9c808fd9df34f8e6067346f319c150c9b44ec4ce7dfac0c32b5d44ecb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7fa5045e755614c94e5b61fecbefe52361f8e2fd41d84c21ec3bf78ff9db3fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84d07e08603a4bb167caf4eaa8aa08e620d1c30661526227127b9bb0cf5d0fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6a58d4eb821d4bc5b4b4c85647fa61cf44ce6e718193850e2f0a377a353577(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d835d121e0dbfe95fdf3c73168daf23b9810f919498e9bc5aabe0a79b3a26883(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760641b57fe8ab3ce954fa5dca8260879dbbe14624d3f3889ec5e52aa6b202d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e3fee64372f48c5dc57f9257d037ec85e49883c518064647726468bb11b274(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbd4449e7fa56996b3f1e671807e4434c23cf6670140bdd508769a5a8929d503(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e0a78e0a47a88c8b91cee7287964d2b814260604f1da445215f3925460c542(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8271340332012c59cb4e2cef90c3e9830dc057c4ba3fcb3cb0e05b5adfafa184(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa009802c7868570f53c9be1dae07430f0a8876cfc6b9bf471618de616417da2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__130afcc86ada340b9f684d3d1b596b01368bd7ea5342ab8c2b43d15ef9838349(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19d9c4b37ab95b8d6235fd0a0c9a6db53c846a188b2310713e9ab2a60589378(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b2d74cf7568042f263d5955f506dc2567b339e42f08373a942aba31d23ca07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e3c2f2462a2a43de8e66616460f30fedff5b27fac609d523a0e06268830f8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d36a70e3560adfe1a6095ae475bf8be443c8a5b4ba4dd098578b2e8f0262291(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10fe190a63142d1d8f9560cd3d4e8476ae6d191b4ea6f9241868d72e7d69f55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d60cf813de6924c9926bb0a4258bd09dcb07f9af38eb5dfa4af33ba9791e52(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36249b2bcb714669c9f2c8bd3d5c8e7a140338855e92cd99d1d5c334b1d9018e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4778d4f619bf63ca7ab8511a7cded1ef7dd731bf52c7021d9681d94ab2794e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f6af38e0c50dfd21b3bd052fbda5186c9dc9e1cca71fdfd6b0dfabd758be60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90f8dd7f48d6b9c009a666f20b1778d90ef35b7d743b042f051ba504245afd2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea1223dd17e10638cf0ffabad074ce8b500360fd9593555bcf2e9a7d6bf64f1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f2ffe182a67cfb66d77f30a4a2cd977c7eb870335607a38d50c48febc1f29b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a665990b2ada36f73fc880732f326c3a48f72e128e834391920bb5c778c40c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095ac57c17af74f53f37fb725097f356cfe01c7bd2598aa8536ba91c06d83f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59b0ad5275eb0ac159a3fabbfce702a169f8d488b9c072481449432dd69900d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e251e39ba3b4fb6f79fce178dcefb87dc19d9cbef153ff15bf95a4694a2bef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee1ee84b607ba9e5ed691481386c09719da19bd148c5c4cf3acf480fd040097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65716cbfbe41495e9dcc959bfb2e1e54e47f184c3bc3490c5f7c6d8ca1fa7341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc296c506f3a4af2d2be2e57f7d81346843ca67de032f6cddf980545694798f(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bdcbffbadff950bf3004b832cd903dbe1b29e745cd598a608c1b9b0586b4661(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4052c732cdb02b3368dc041a8866a0c647e163878bb07c44a2a8d3c9c1ddddc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f2e6071156654065f6353e0ede83b50f79ee8348d0acdbdfa1014c1bc92e28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e285ca6ffccc04933785599e628dda6b3f43766d31ec4acc0ed874f7fff06f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d5d3fe112c017584ca078fad1fc3ce5601be99b5dc2951ca006b03939c66db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7af1c68bf2645cda3f4192ff23f1a20b7802a937c98637e712afcca7f612769(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c08069e788ce1cd15013a5cd11aceedc70a7324f569d6d525a8db93d591b4df(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c885052149c00f73f7c95a5d63f204516035b143b6744e638c20ffc25f09149(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1c0566e8d767780a495ab083c94df34f6bba4b7e4e8dcf6dd584afd33ba052(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076fa3f7e930e9374f230735101ef54b41a9d283353af439dca6b07a7ba62cf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce06e6c0b83beb05a10fd80770739e3e707cd9244b8984a12d0bccff8f32e693(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463e172d1b3c18d123f0e17c641b79cb06b00efec1494dfa2f2af773b5265ac7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200f6de323acdf70fa7cb1e08e871089a13838ff2e3f85c3e5aa4885d16a0e12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8ddb6d7fca5518297110c8abc1541e3a8e0be060142afa32b08fab395368f09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a99e98550c40d8b7efb6947a34eea21df3c36064a65164d85cf9966e299f0b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be3a15f35d786b8c7ab61cc305b466a77a0eb2d9bbeb3e96adb0bc5226fd52e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b02937e54a816d164e23c2de13213f3241f3c7007736bcadc41b3417d437a0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c78e9e742c75e8543369df5f930bfa3b45b21fd2f884080e5462a78fc273d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61561e43362a1c3d6e15a9feb84d1a095e5ffc4d5abe636db21ad7171da19652(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef704029a34c3a8826856021893636e6fcfeb8acc982db8bca2dda664a7c2cd3(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411f1bb8132b6dfec0ab6620b0a7d6c1302f9108773959de56da7995ffb39f3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e7373d466576ca9e6bfa18e6380a9f01bb555d74e395a32023fb8994929ef21(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee5195a0615db86da2e3706733b644e48e7d62cec85023dfedc375205035b84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808ddf6d34d4895671d51e80789a1dcc2a87411f6182e23a63d1801fe5ad569e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151becb4edbdd293fe2e474c92aee24d83a1f8d0811498c3cde12d16b2400800(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5397c586f958afffba101a5b60371f680cb7b4a1a31ff2d3de7d3b1693532b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4f58dfe7f30a268c5c9009078d8b609e8a0cdfe7f1794a9457ac74ae28d833(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc753d82c4de531bef4db5b0551e25f3ba1393d7cd9e6d5eb20469899f4f8e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b44777f4595952763a933d0f219fec98fed7584565920a00abfd9f92f27401(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0266a80e77367e1963dcddfa9220861f50427a9d0cf40bd915e98c9568190efc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be8aad9c834096db4dd77611ee17326006d0799f927f824e7723ff2d0dc3a7f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8345d6e1d7c36d0c1b825243982632e3438a19a851156b1f4020f6e16c2cdfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c6ed0335395c9ffac1ebecd796a9421f31549c7ae219db158fb27a3892aaeac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7476a9a08af04e7b9b896592f204a3aa4b22ef180b1fd6afe5401b6f81a00ba2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da91e5cda8dc3b65f601af5fd2ebd3b3fadc6b5943045a4f237bfa75fbf473d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7465022523b37acfd655346f20ce264f3b13d08b24c844205215a6213ee0d47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba92f877461ab9073bade99501c5f445843e4060b38f54ebbb6d0c5a3bf4e01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84d0b1af8a468f4836bdf76b7752c2e86c14c92e0f6289b9a805761ac25177f(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578e79a6a38373ca089587826ce2b7f10e212476b779a6b344c6d7639d895d23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c867e7a378a9d57bbc5f525aaaad1faca21c4a698a15c21e590d6ecb28bc9961(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f627e4defe252b50c3935abd88404a5711961aaf29918cd17af9a3972a99bdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48845415c5e390680080870be45b058838178f7d20f78e9bd6a2caf16e951d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554ffc430d8bbb0cec678518f96928c8b3304b6845a55d616bb31626eb6d6fe0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ece8ddf6d77fe9837813048f29a78dfb3a7f657965bdc5833b554235fbca7b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fea192cc584a51e3b1bf9679a3360dc9085e9e9a35b612211053243c44c1a19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cc6de82ec3c0cb1502e7b6ad218e846e7c6ea55de6e607dd100f71940c6554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906dafc1fc5bd04c847fbcd1a841c3fd9d38c90691594be9f3c7b81168eaa47c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524728413039a8c15ad7119a17330021c4fd90a6c589ce61929a8618cc88329f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b314deae1671b4b9667fe00b88f0c2637b5b44cf01439ec19a529f1f947956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ea6e976399363b0c9b2975b6819bb9d8885c2c3891bd9da448360d323d7db1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76e418bd80eba18d8a514065cbb4b95a172fdcdfac37bb438d75ea9eef02642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da0ec4a4b6379ae599bf42d1a5dff9da3191168f74b1302f5abce2e55638710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0066e94713cdf7324bf6fcdc3e44786c051ac94acb213501fd15034f4cc2f15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28528aad30d9e574356f4c7cca3fceca67abd8ffc193a3c881d76d82ec8e36df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee141f5d80aab3c445417e243c2609802928cec43c1b4832a99c25f6bf12b65(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454a67aa9f5abc1d5da0d00ad04a94213372e2c1aadcbf29f428d6dddc38d8dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79cf3afa9a88b676a5006c23d1bb102510ca1bfd60670b1bbfdb12b469ab6d1a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f426d1eb04411ffc746ecccb11b539dbcbf44e907c89211d34b415ea554f5909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff48c132ff4daf46421f3211db62d0d14c701d54928739b324aef768be7b2b4f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1240625da5f88628dba68e225f8d0a050bb9b3b7a2be928ffa4d5878e1c44b17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdeae8f83136a33f9ab2c5fadb72efd03d7bd17d509916e03e5cb19b83c47530(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5719424c44539df84e21a31bfce8ea5fc8bd9a4cb9cef2be9bc1ed20ad60b0f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe05f5abfb6e923af3ee1bea557de6ccb5fde9f49a6a645d15122e079ed037a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc82a1f967c7f69f75ed60429ff3ba9b6dca242082060a5e7d8f184325360788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8cf14d794ae514118e95b7d53937456a8cf8ba6a3ca3c78c94413d4691ac21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a096eac0af916928cdebf6f7a515031d36e595abf0f1c6508ba05d5bdee1f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__441d6d40fa4015bfef0e9efc0762d56db4f3169b9b0fdfd9817d7f8616fa6ba4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b6c11ac9b0e8e3af491912a8fa33477d39075aaf053734d023b418ffeb1d55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d16265e5705b6efcfd8b9bc2b61dd9071373bfdbbe7bb8e8aebc481ab459da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e490dd30101ea2bdf4dbbb5e5e65acee9444d42994ea3ff7f2b9e743a337e5a0(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de35fc469c8861afb0aa53145e6a2fe6948c886f27295f608bfb431837c749b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf940fcc26342fca651aa87ea58d5f24efe374ff6e012e4ae8fd3b84a103c50(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e9c764f057b937b8d3c9826fc25a6e6f3dd531f5b516498e946d1903d37240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2ee74acb026b55fcb35b2822efa933be5ba085d21afffe39e9f9598745ce62(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46750af60e77289ef57127c84b54d84fe5a199aaa96f5b7a3c0f8e36ed88ae7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6df3b34f627dee2e0fc18cecb2a022716896027fef873fa27c403b16491eac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd3ed97729d2ce08db5947c668273af51d44f68f0de8ec8c5bf35c0651fee7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a90f27eb837f9facf12bbc86b9af22b0af8f33866a6c6c53e30fa8c24e70cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1386977736432d756c2213f5e7c2f2904d76079c8b67fe37130540d6327e84b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa7fc5704d5a152d254d947e357047d63e70ae3eafa096e615d3196bc9b02d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb9883ad44d9545d1f3ebec632b2dddeecb4a8f00ba229d9550fb1238ed7ec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9512f12e4af42631b4d18edd0c6ea2dad792fc683a29b99d9e4af4009a75f90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b176e58e99cf198a8838c1d41709d80f7486ad8df6c7d519733e81831e6243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3dde60d42a1d43199f1a3be762ae36f40dbda81c5c1152ef9638fb92ef4fcb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d89e9bf1634404c004e9e5d324bce0d9f17ef0c11770841fd7399fd43da990(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239795c2aa79927ccc663c27f49e0315279553b1fc207f8fbd425b3cf83ec647(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828f747d710ac0e4b87d31021dc54238137fbcea2aec2f77d624a126f8b7e108(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060b3f2db3ecebb9f89bb885e7c8c96fdbb03abd5c8f59aa8a38027a21163144(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb65fe62e5e89ef0ebfc52bb0fde0370db3c5c1abb5d6b37cf79c1cd0ce935c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea54d4658879649d8d6943704e8711fd2ffb81250fcfed9203589b7848f62ed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd46f957d4e5dc4c51f8703b35101baa55648e175bf9779fc2200d53090ad78(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc6501fa3b23285b4de9e2cb42bea6dfaa4d69f9acddbb2547fc673d1a7ef5e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2e5ebdc3ddfe9980f107271036e3cd101cfd4162b9d7abc3de742f565238e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ef47c6a84edd0b8ed9a6aa93f4d02e4514d5cb866da571fd972d921329dba8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7f1d2a226a4521f13c3e4dc43bfcffb228117d0ce38d57777baa59b896eb12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f289b39c88af1f6f84ddbf914f6b6847faaff3b0bb8f2c2f1eaaebbf88ffff45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c53c8c464bc40d505d9089c2f5307c1ba92dfdcdf9e1f222a0db40b1ecea7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22cb5a98ca853aae5138c8b8577390ea035412e68e65bb2cc292483a71030cf0(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9191b4832d8a5fc0cb69297d00071992f7b05cc49e53eee2def3b7af6a098fc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99630ced9607d3ac6eb675769d3bf2a84fe2a20bd2d06eeb221510b1c1804bc8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd16b994e665dae674af39880e4adef4c4954292eac7ca9b1a8dbdaf0121b9fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fcd70538da0c28b12fada917668712ef12c2e156e6c7f7804a312967d73595c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc2dd81fe57802c747eea630fcc4a67cd628bf4e1fa8011c1ef20f5511c3a8e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6896d613c550c71f05770e4955f719ec917b43243292c3f92a615993b7f5743(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1f9ca44feddb39f59edd0924fb0658dedc4e6730f4a6d3e8b6c898c93dd07e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06633a293c89f04d86e303af2a78a9d115c326a3ca8c87e75395d41dd193688(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb6e8c9e6b7b0d6e6db8e86a77eacddd67fd1f7707d23b9f0b930e4cc6b8809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3437b623fee09746ac7adf9990acacc53bacf54a87e86e598803d8dd3280f794(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1947be176fab503c6768df5d99e7bf2de663d5141965e7229c0cd48bcf82fe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6482356a08bc5eecc22d296063f1a938487d78b47d5b2f910358caa99b85ebe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e51c560fbf9790dece201bf2ccd5dd11af7199a76b0944f46520df83905757(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f57e13783fcaadd2b9d6dc6577629c31e935d5fefe5bae1293492fef87adc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f438cbcf0c2a44aaa003a6c74f14409c534ce91bbbf0aa74092ab857e5be51e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede77e96cf58bcbe827721e12b35f4507760c39236e5d52c25cf109143fe3e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2bce8c2157c923d6d2ad3d1ee8be1e997c57041ee56e6dd9890d187b49fad5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d6d96c1aaf1d157f1ca8a31eef6062e5645fee5b59a13b567a67f7505947f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c3109966dd986671509e9ec9a66444a27c62b04eec8c49b4bcb1d382a1868e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a40ad68592042daf158dfd32a9a42e264ab08518840b94005ce7b81fcd0149c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b001f40e5a5571d9bbddec97d7551906a9f9be3ddbbe0d39c124005f4350911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8bebdf4d0caea74cdcd3ed22a8e5f0240ffc8334af4c2cb240428b3208d5b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3896837289cb135ab74d71f8eee55046d9b324ac3cbbe7c2c475af6ed34bd8ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd3d254cd95910eb963cadbab28f778721140a5f5a0551891832bd647ae0604e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f129fa225b98eceea272b3cb899be14bbb6e8b87770bbafd33b8e5c4cfe06e78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9991f8ae3cef51456ef7a5dd7c779ebd2429f0aa885a573a5e8418a54a703b2f(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ceaee74deffd73e251a6b52c5123439e1e95d17d2e76894c34a23917d88ab5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb17aafb8a84d54cce78898ca605853cee07c3e5ddb31ec0f41a4e61fcbcee66(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af12ffc49e6cee1ae16e65533d92b2de5f5e8b351b6c27fd7207bedd11c3b8ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234591fc442f248639aad3791af80e951032dd2f3844221b0448c8cae56759ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd3ddbb539afc5a7b970672d62c15cc070673a76174c1e53111079bffd7cc97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa959b756853f8509cb08a8f0c19090a43891d3a3b75168299fc99a2f1a1c822(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19bc2a28b2dfc517ce928f34d71b91c12161c06a686c56846e8c6c04e5a0b3e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ac7bc3e0a206704a09930841f6f22f6a7276eabcac61ecd9e39341c90841a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2cae5249b434edfc096114c9197895d1eb2d3708651df59d2b99faa407bc09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7048a3956c38bcf9810938198806b9612de5de0667e00acd277e45a66b695cb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df14a9406dd834440529c60dfc46a46badf3b472e6cc1410d69d9000af216066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28791a9a47e885bfa27905e4a82cbf9f7c9d0b8c6eb344322010ad87380bd6c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45bf18363eb3425ad2336c18654adaade8ee88c2f35770614eb127247fb56bc(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5790d09904ac2cdd1c11fe00a8f1d166971df0bf3774f1a2cfaec2113e27e904(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761d82845d1f84f14aec12f5c3192f4361c050d6a4ed3f7a8adcec71f06db8e6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498deed130f42564c924f051e745224325dac7d211df26264c64b764e9823e36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5185172fed23d8bffb9727f725146f97a93f38340e57bc6feef9413df02c0fef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c39e97d5d7b33c1b4a17111623fbaa4d2859bee4b56f441b47e429ac86e5d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f7ea2990307d887e91349adec4ff992d55eacb8c9bb145ac903fd642f0749e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ed0ec744ce6f9f9b9dbfcc58eb96b07b7082430689313973013cd3d075fb7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19d0b5762ef10d0a3b959aad4bb95f456f0f9e0f49371307796242c715f9a8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cca2cea884afdd1bb6420ff542b8c0fdf53293a150b4f3225e9d249dd242776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff1f27a485b7bee232b18e5283766c96856ff359a7a0c46bcebf337b6fc6ae4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9fb6244d920318e1e33093f37fec0d6f3742c6823541e1fd7673a364eacbec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c85d0dfc3f6f6cdd8db6c6eda3193afd38280a7a90e27c7beb13520cc57c36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db82488da60a42f05a7ded38d60074dbb9dfca8570b184203f0369a825a1ecda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221fcffb54c8c88a257d75c8407eb065fd3dc7815926daeef61f3858f5d3aeba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c328c2dac820b09a1326d3f918dc59f40caef950c6c2125d1e6f08fbb45d8d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0b2a61b575117e979719d7ee2f7c33f52ff749d636b2919e1646d682732f9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba9e870efb9c993182fdd0fc3c6f9eb5a0f020c9447ba509e1b6bc90cb60956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1c44a3f7033de1eb4a6f7a002f7c2046d470f18186e39e6b668f581135b904(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9760bf417c48e6e8f2eced4052a08a9a9cc6d1e20690514969ff1005c874d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26ff159ea3dd89983a723aadaec51cdcaca73242788e77b109d9b9da13b56526(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030a320ea60d0008df0a477ed3c719e86fbd854ba7e265804a897286eabe4389(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a8f823b4c5a7733752c66f9062e8ccc17f3f08575479738ae11cb79a43c83f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0217708f21a5f8ef0254c33c5d86bdf30dae56a1ddf618313f36db4e8d340b7(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9046e539d3296384a498d8a44eced2a888aea0b929db39981a611d7dc311f0e0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9302e8375269b5ea80799a12bfca97043ab6bf39edbcc4f72ae739e5809df5c2(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086797e724079ab07b34817bd4f2139a0d7619a13946212ff1cae5f2353043b6(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b6c71e8334d74b334d06c95bd84bd397b6cc37604bce2da6d9cfb4f6febd2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad242b35ce070e527febcafb7239c065fb701e789797c1681995789afe5422b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8caa2a9819e49385527c6b3ec7acdf77b5469e03487c7f15fcc926d57d131de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be5970358fe46b110d9582d1ec5c1740d7215e65fc7e49c2d2aad76a12935be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b98d4ac09034695350d3f324e198a2b34846f31d8fd01e39af50ff598df5fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53201602a04c155b20a32b9ff268478fef40b1a6764b1b4c8444654d28611d37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99968210b4bc518358707966413f44fa8704aa0c1862cd7116af53e11217c348(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b0a265717289f8382330a98088eddf8362a81c54d0f3937027f5e4a9a0edd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97251e6e2ed1dbe1d59d1b5990d260d2ec1d7b169662aa5cefac7689a7d5a94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f54728e078f314a75fc45910d155a9b8df9b5e0707e171f6e7d74303f034956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e479a61160cd6ab7e1a1443d240f655f49b9915c4105fe588f76e37c17dff5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0c9c20084a2bfda6462f90c366b2e48e0d7f3f6b1fc1b1956053618a0aa74b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85fee67c0b08c4dee84161fb39d0c7988c0e548ef001d44de9e94a5d679ae2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f557cd2b6d1b6eb39aff127cfef885507e73eae3c49c8e247aa494680f2f6811(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db737fc28f3c0dc3325790d956e8025fde4c939132668a5d409cb5caab63125e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0cecb6cb15343b5097cce12addcaf56f27d2261dde57d1d35550a70094df5db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5084a6aa8c6c66c079a6d1b475632e3d7bf83044d4c7ef4341d0fa2ce1af6e4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952f4c22f5cd87b8357facf912455bf2275ec9bf7d0b1d671b044712680e1d02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c358c7bf60fd414b89b8f5ed3d70965db36a1b4c0c8bc1b6c35fbee9bf635f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f5c73b7633088892a8e807433fdae895f65eea460bf8462ca5a9cf146c6281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be92debccb11d044eae4bc38fcbd3d71c41936fa5ce7707c2a7616fcb3bf37f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b50cd1121c715ee9c4b5fea13e8c9e34bee616651fd0f9f24598c62fc6ed53f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1746b08f5a0add3328b97e6bc5fc7c697287298acedaadbb8177746d67d7ad74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc3ee39594504fb0ab4afcef08ecacde5efc2ca0a7be4dbbe79faee3769153f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1856b325db7cf9b32a8b4b3cb5e3917372e13e00c6a8fa3c5b00c40adacefe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad8317d8639c0f9146666ad14de5000e9925a736ef2ef5a3a02969bda1623ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52b18dec51a211c64f0c23bc46eb72e280b4aa418c801ee838f1e4337aa9d93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__439dc1b1b7eb619ac94e6e0ed9d6040107a230f020a7d31e12dfa904aff7f490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7944a0c458cfa92c9a2ee054b498a05ff270ceeab1e314d0cb6e8b7c675111(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecdd97b9e51555401fcd0a97fb08439df0a97d2c0e20e2e752ad4e551bd0bdb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e801207ae3fd98223eb85245697def43e917f280eccca5e526aabd9be743d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2082b379cd6b5452f41cbb72571e3364c90543399c08369af218885cc9f70df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31899acf10757044b44ccf4fc15a39399b8d11da79741241b84ee660cf1aaa88(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af2a81ceb6f2033bd9d8ea7e37ba1ed943f784d99067be22064a7e952a257d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__829dab17f3592a76bc1fe2c6ba83f689b06147f8d7e723ffb35cd0cb8c2ae587(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dba988098f1cd9cdc1cdd6b074f4890ffe099250f1555f68ed0ba6e90dc69e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6336268d3ce5e7ff1de61bb2d89210fa6288585f531c418e2ed920b31c3fca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419be713c1b869fc6c274f45230eb11ec102f978b8fd647b0e409e25a6c5b3e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c1fc65da1834ce48d3f0919762fdad91ef0f8961169a37c3b342f645229bc0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0121f80f12efc377ea664c7f2a310955dc499d5210491bf45751099c0862686c(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bc722470cfca80eb719002fe5d9c64cbe6ff2394923aea0145e2c2f59b883a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f420c0e01b467a7fab31e84d53b9f5ce863952c662f53f4421a027ba769e1b25(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d755d0ed069e7dac78f0c6d8ed043aa9c3448a5d06bc3f151c78b37237f96537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce23036bc9dcc50ebd6505c740e8563c48d0f52cbd076d244b8c9ce11fb94c1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597ab0bd71c9c0bfa3b94e46bbbe470b34ba174a86f900c5a5ad0f5469b6ac50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb40dc592e7142a4ca5524ee48c6055c8caedbe9cc60310c8dbcb3917858435(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e81957b2ee3fc69c70cea6a1f536195afc4b352c7c8a2aebfcfc1230a7df522e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a160c34ecdaf70fdc750f9a841f19efef1169ec63bb943c3648fd0a1bd5d11ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc40646bfdeedde6cee6495415e6b96b98a68a2663c3c2d475e751d0a333edb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b63c113eeaad1a2522f431f35fe74d9f15c7c0d11ae5bc9b42f36854a58afc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d4f947e0f687f3fa49c1837804ecadf796cca54c9e1a47f8543d6df7c4b804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5364bcdf07cbc36c6a1dc79d27e12a8e5faa28653e79186522936755f55cf9ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d240e854c1d8bbf34d8f72896f0d7add0ddd083eba24bcb542224e3b3a4ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25f7a7a96408f7f581fc3054817f441e3d0e7b961f089ce9c26bc7e63cc6ec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e40a42025a9135d7b835a205646c851ea3fd8844a96af5115043eb257b07fd30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53c850bae75adb8d941a77148b2729443299f81ed8809ec3ac65d0c7fc8712e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9952450fc1f48b1b71510e42cc69d8206a6b17ba0b40f0a7b54dd0c7dbc4e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132b8b2bf997bcb3da7e1dabec44de478d25ff243e81d24ba251146ac52ed962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1d9d41dc6482a7e53e12e489175f208a4f70c04bf0a0e5e8998e1ad6a600a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8e5ea2df26923af8d20e6bdf754691a0cb5d8b6d6cffaf3ae8773926f5f504(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610fa56e383441f33cfa59e9ac16db9d0d2c029ced0d4a228b209be3706b908e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228969ffbb8253dc6a481167e2088570f8dff1ed5d4d891d0f274351b6235841(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e48e234b9c3f4944a53820d92caf9eb060f1618d5a88ec7a1112f96ca86c017(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f390a51674166272c1eb553d473ca39c7cacfcb4f1b2d7d9187695e9607d577(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a47a784bc6123af8bb97c69fd373521ec83520b4b13161dcf7233f28dbbbeef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb90913f40bb9a490b41e33e29614a16ecd07584e0a7c5dd770c3c1dad7a9343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bac0cbea7c69a8d42ddf1e85e717df7696a2e5a8e74e03e22cf99fa7f9fe3cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d856fc8ff6f8605ff8095f545142b7c04d05794750a5fe8ce782578b5840ddf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e9483bb0067d46dbdfc53f2e17d79db6e1280f1f5adc61387dad44206f9d1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577fa3a43cf67b4cb0292929ed44ecbe2d0ea4fc9c2d6cdc60f2e48a9d695147(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a1b45486d30c65a06c3c6036919125611fc1d822adfb537898eacba259874f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137ebc7c824c9564e190188f45314b300350e3e7a8f7510b03ff479918770737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2635d501d67916b99e6f135cc3a28a8f6317b876351ace7a1ef6e332b1b91a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed97e11ef527dfc766a45c6c78d43513856f94fc8154a44e2e6f4d6bb2a205f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c11c3864031c970c7a7c1624164187206ca7470612a5f187ac0c2fe7fec9104(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db124ffaa5febaba56a3520cbbd8a2f06e72346fdec3d69f83bedef326151d37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0874f0fca4a1b9ad4a6e5698336fcf21fd968cccd51e0954ccf689d2644553d7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0751e99df96cb122f51e1662388c35cc4c842bd9e9d75c044f7d35adc44daaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596af7501bfb7ba8f700b98e0d167873e53c5e240f67463a663eab443cc5ad59(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f43bf2629f73915ff7889e926dc03ab44ff21df973cef1469054678b9cdeec1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0a2cc4bf88acc451084372aab9c07636f8bbccb30a80c33da31e9212f7b7e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4fc57dd69b5bf51ba84cb36ba82ed87fb8a42795751754241096abfb70f6c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95e19754dfdc103f133426ebe17b3eb29c099024af459e2292ad5b77ab69e05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2599993406c9e5aafba713dc72400e196b60759bbca30439d8693e436a9ff7a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d6d5f8fd423882b576e228688bb61529b09a154b29cac45fdd5a28bbc546c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5772659fac2e15c850da269e5f93266092c0f616ec98f976054ea6061fac1be1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e2c8eb3599629cab888e941e3e9c39e3cb8ee17d9da35f0e50c0b593a37ccba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac49886390861d35c84837463210555443f3409babc79b5bf412bdc050cd8561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c576284713a570b7c69703e51ff163d2ed4d58f75951be612661c6b15ccef8ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15258aba1345328c9cf99ab269309a4906d16ce9f4c36a7aa1ee1c125edf0d9b(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926f630143ff5e875423521ec90c06e1098315c8b1eef8ed7f46632c6d62253a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8b165d0c03f4577eceda4b4f63fadc22786a329a24354211af55c21e19d59f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847560856a799cc7496e0373b6485d2f33d3963d1b2e069aec4ff9cf6129ea20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0068a5a6f659bbdbd43044eb9b058ec6d7ff72ab8095022131bf1e92b3039d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5bd6b047855ea3e43c28641ef7e2488d08904ef7033ba94ca2e88f8e4463d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513a4c4b0fbcb9ce7abd120cab608a86c81b7b8f26dbd391887d9202d2f4990d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8bf2aad5cd7491635214781bc42c28d0006477e16e11627a8e1ea69527c4bec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b115fed1e7e38543c252d7264f009830c7af1a8029f44f5149e91a6c30d981f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25331e1a44a71382947876c1a3f2eef58952ee8a50283f0e7032e4ed65c0de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8645d1f8a8fb7c07bb7f6fb4a295a5f1c662911513b31b20a887f986c3585602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a9e943a1770f0493754ce1915ddf025d03604ca3f1af0156bcba29cee1ff2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63fc064d97782889367294942bac6c6d7afa8cb977368c08867932f2e0c513e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf32d4df16868a7fb5c1d42bf51b6bab975a6bece71994a1c0c1a9700dba084(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eeffe202b03e1dc5d5b69443ac018eebf5ea16b3ee15d97b09909c4149d363f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512ddb9f248c06efd268eafe534e5a3682fe7cd1a64ba4aa64ded527e2776981(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fffecc08f0c33cc8389046be110e86fe85264e7d00f6fe2d8f82eeb66235efec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97f995c033efe1bb847fd69659c619fee3f872d3c524ec2e7308637480fae20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03675cd212614de663f50185d67de8f7fc6ba48e8c3fd84d85f93a3947294b24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486aae863acbba1cc3877ed00397363820a9afe02a3a4344d0b29568003f3aaa(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cc974d576f2b444d7fa45f0704af4e634ba238a95e67b6409c5e851fbaa12e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1fa57ddb385f2a0e5767ebb61512460c81e7c0e779c75b1af181a581d68608(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1208acc7c0863df92c191ec75130f02a4a297c6c2a37a10e33858aa6668557bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d44ea81650bcf4154daca10d6fd8acbe5a02ba9c74c33634b0c42736e27eace7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfde58fdbb8e382ca45e1f08c040e6c12ea36daab3309385ab05e1422250068e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b684314e990fc1ac77793a74e62a28f5a50660c8b760145a2b17cc46f03b573c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b17eac164cf8bd0f224d6b7d9515ac1e3938061cbb0629ba3ef942e41bedf4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__177afc7082ea5d12ddeb1bbeb7e2a02dc51ebe0f1274c1c75666688dca364270(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f1d43c9635b044ded0db18d88c451855ea9ca04e1ecb224dc81a11491012d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0cd4987d2092a66415b4c7ac2926de2540a9f6fe1576e0aee4b4b0542ddfd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350555065edabd094fcc576cce0ec350726e6891ce93994ef98503fad757e063(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d27c44ac181cf28a3a4a813c27725a52eb685916d0868a04bdbab18824b356(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c6011420d824fa1358905d5c393e86c8d0480fc680960ed9581a7e08ea22ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cd4747a239d28647bdb349d92fd8a23d31e108d0023f568d7be40a861a76c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f68721ec40c21d2ee6feb978e7fbf0e274dd96f2e61087d960b7af6e29ec7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e6decb210c27cb75fdd3bb0571073563675f86cdbe576be25c444bb22eea9f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b1c5a794fade1a40ab38611b9c5f0a18d511003602f61459a6741dbbbca58b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abcf96ac168e0443a7ff648cde5e15e780da7ab9445c1aa507082156ee7962d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b9ad2a5a4cdd7af36a277eadf60bb4ce9d7b2fda65c3d6cdd3f6621860533a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6cc918d1c217f0b85bdb1822a684267102e6c7d281755583d30b8b2580dacd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__482cb87b8195b60d660a6aa872b74472c7c27b8fc99805f93f72ceb6d758e797(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d991f473f46347083ed8e70ca1b327cf7eca6f132bfe6657244b882a67f07d18(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb025d40d79d0cc4efc783aee0e7b6c042bd741e3deefddbcbee578be414f22(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade38d414fd9e32dd6a3661f62602a29d141a27f94ef69280144444998de239a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__defdf0491338863de55b15926461a0611543b46cc1e7c04594798bd48b59aeb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a292115aab1571f728ef734eac6f4e45b4fdc4f953208fa9c7947c442466f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e18c83c538f93dd7c42bf744ae57f6c76a4872aee82fc69c4649809748c35231(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cf83002f05c1169ad49c4811ff5fb2f6587137887e655500883dff2f357f5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f2f361e3df0a288e58b04c359da9b89f4083fab8bb768a07987730a24de9a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a31b3e17b62d6176af3a228f154569eab6aab9d1932d027ddf29750f22e727f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8585d67a31589141a44fbb22d25422c5f0fb47311dd69ab66d369aae20560ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f98ef4f63c9e1f01c1744167bb73f081983d0e961283f47d17c2ec2e328e08e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04748bdc3f7893eaa61ba3fd710b09b1d640a0b1b3348db8190b24c2576476f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3563782bb2255011152d60896a4d9c76c4815a638ca60bbb916485004daa5d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16810f15669ff0f53018230f12c9daa03684d96723a00a4f21b67b1403fdb011(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7387f0f4aad7d53ed644eabf37f5f23e9edd0070c34e77b5ce5782eff1e822(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81d8eaf025d6720136b42694c39ca0c6d81c1caf80a520af7201e552e1f0691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876f33e39037ec9628e69449158db5ba4b34ecec4e6bf6ca8501b1a9c34db9af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a4bcb6dc4d6b98d325e8cde1703ca5fc905ca0ecad4bc7a954935117aa2036(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec13e7a27681abd8f7cac6c169f856e61fdcc1a46771d22ee48c390795c738c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984ffe81a16bad0256759baab2cad8fbb63114cd9ae25903cc25cb9efca5ca97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af2699808e31032dedf973d957dd214dc1ac3020de948398f4e7932f0f3da56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a814a49e8923dda2db1cbfc900af5dafa11481013af0bbeb16f68554d43fa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601b38f75575f6dfac363168554fbab0574cb684473120be0f055c0901178039(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c208c342733e5a289f886d8e9fad3e3e377b5390c69e92eb8525da33e2ebf8d6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae468f6855e0d9e115517644e856859b6408c05d84c77222c64c2109817f785(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5300404b256dfbba4c40e2ae1631b7acc14cb497951dcad90e6f06a9df810d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fbd9be1e347b8d919f1ad89e8be0388c8005eb7f3f4074ad2d6faf0a0fa5ea0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6ff46c96ecb37d26f310434c445df696ff607d09244207101ee2d2384f493d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dee489306a666cd1f938120636f624b4eeeb6778e8425b557a29196562fe76c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c0536cdd337c35827b7e40fb24595b7c4b0a47a789000d0bc03f56349c8cab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed53f67786c97330b6ad36cd5c5da927d400ee775266ee20a51c89b724c8234e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99bc146c8fdb9cdc2c1f6f9ba84e4f92bef8c45ef2269cd39992dc301543432a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91354b3a4c59ccf398ce8437692a0a98621c2e08fdefc296f572bd85ef7ebd88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edbe0d22ed27234dc56b2d8357d646bd09a280451f49975779bb99e6e4b611e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81306b385ecc2c4025925c8d239e50a918881f6e3c75bbb4826240fcf6134e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdaa20591fdd4bc0c645b84d98b4a439293d8dcfb73b0b2d6c498f315ad21e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3065f3824c3a4601fcb0a3cf521e8de8ca3faa22443e635c35032e23bd423afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc0f34f7a075393e732618263a8af74a92f615905710a9c367b318bcf97df1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329caa263abffe9458f8145c8910864c4cc9a65c608f636212d9cee69eb30768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605253723e1552fee22d727d9c7332106fd7e85a835eb98e4c2eccda153f0115(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8d3ed6c17c7d31cfba7976ff085f746bcb6c20ce373ccfdd1fcfe6915c34f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5f02b733c696cb3167d7148268fb8d5f0e434a55cd4655cbf8ab709e7823e6f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139782fb9457dc6623ea442d23f8ceb90701804b944624e4491c705e891ac2ed(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ee3d03742d6e84f5648f2bd26e60fdff61c6c01c21b26f9719248717cd77df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b03a2fdd020dab5c4b9dcd2e7716f6568b1dfefcd82536568fd5df245df11f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f67d030c2cae4af4bf20c277ddbaf336d2a6c99669825966ba2abd116246bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb0c3299280febcc84173e893c0a2d61df652a649f8505ca47d94f04b8b8755(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a24069aa82296946a4faed2d2af1cd01959a8b1f6296b7c4d550658a203f91d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fcd0f15b2cf96e7cc291dd5792dc1b7ad4022c9b0b0d0732780709151404fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae538aa41169b00828c92bafe2018b939f63ad4d21871fd4157461a5dcb0417(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f207df9a2434155f54bd9c30c0cb550852176184f1762abedfb9392479396a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f4130124748cf9c13dcebc3dfff893d0e787c5a41c142ac322801bb0ed2000(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e050d2fad0c41529b7dc767103e9ad271639c1002de77881ed350edc2d97662c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf86ccbc93dff1d65a4793a674147c4232e0b5295f2f1d4f3be3ae1ae6cc2081(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2005699a0c0645813b0d78c32a164bafb1ba74431e2022cc188d49bf8a7ff71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4551f547991d7c2019c4539cdc520066bad1e5a15bc5333be881d3541f9c5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1b3a260e35b5e2ededa15a8ccd988d70902d4c714199d4063842eda80760aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901ee316cf390bd0ee8695fcf79841e7e613635f6d992c0a68a4765a71588008(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513522b4a16644a5370b80823f04bc8f1c2f0b2c7247b07c219e3088a0225aec(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5262a484303b3178dcf1fffc48c843a7803461f5216ed6dbab524af749b576(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d45948da3cf5b11c1a324ca17b95f11d12032bb4bd8589d4557b0b8c497096f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f29c141525389d2e1f5798cfaca4b76f3c9cbbc927d5e4344ac8cd402a93d5e6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ce746cb0f84e3b92ccc22e7ccbb9b339c7802ee2d4ffa334f9f49aeb091e9b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34cacba3756354450c41a158ddaeb1ebdb7cb4c8734864e13de19ae2eecac230(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa928fbe6cbbd963f27b33a49e977badb8131fff3d0a31b1e56fef29f98bec38(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93963496418b3a6ba7cf1c10a7882d133c7349dee867d0248eded527693397e(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5efd9b9cb0af9da2287f0409036d22c9047e75a083013edeb64488225e1e2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037b8cfc1eae87a9ffc974b005e9ac82d1a0d63b0bdadf144d4b79c753d00d9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769b207ae6ddd459d58152167fcf408d17c54ffa1298eb332943387f2e0761a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5165085460e583ea2ce958dd9edd839431d3b1057235d82138c7c6776e751c21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d98ab163bd233a13966f57143e2827f274abffe251b7eb850dd74ace097a20(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520159d02de6cf738469672ebe9b066900a00d78fb83e911fffd9191465bee89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a5b5231211911d5182ea61745cb09656207c196f3b687cd24e5560e8c14d3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09185d4dff0170a07865daea5ce2ba6999c9716eae242afbf27c176a73afb2d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e4318be6103943ab7a535a35199fa9dc9719444c795b440e4c21df5465ddab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61819320ad9d363fdee8ec2f06af49f8e77f42a3337afbfacfdca486e6fbdec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__168ef68498f39f0c573e5ae3550ada8876389e2bb9fb2e50b647d98711d39da6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dfccfae626fc6033c878f9542358ff8932b48558ae02487c1cf6541bb5820b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57acaa0ebbede33f19090274ad73f039d3ef26ba4b3af43db5e5ba00bb156133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19312cc5d419b871649dc7303b3f9a761ec526383c65b7f60de977230dd2e407(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a689b76eeb30b0dc637aa0f451e113b90e071168b4ef60875db6f973b92fc06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f0ba08da3b14245966783a041b301bb5cac0c79b8d2c4d6e6d82bfdcf06344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770de44850441ea0a124629ea2a18fe2b1a873bdd6b30dec1d3acef89e09e43c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd793c8ac6758b484ffb43f9995767c7028cb7710ea9b02640b199c15770391a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d016c65fd0975f442471fdc37bae4e7c39f6e42ab3d8995eb81ec686d13f1f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ddae606cd5a709e9c6a487e577c0efceb10429cbb473754e49bce4bf1b2b0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72188821b1cb38edb47c900c0095d24d1b8159c271d6b931b3afbd44e9d44acf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b13e07a7bbbce90157c7bc808288b4e2b1f37f70f7974c183c7d618e9c2483(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2310ea5a0c60990e410a290eaffe3f964aa4658bf1871e1a57e17bacf234e5aa(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d469ee4db88c6480fe20ee43909f7cfcb7398f901f217a8cd1f91a4a39721d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6406df4e41217dc59ca440ccae1fdeb433f9554958a5bbb4bd61993ec31067(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7dbad0b338499608faca3f8290a7536b84bb6ff418c6349ed73f13e0cecef86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb9f6f57a399bdd3dbdc3a6bb79fdf904288e7126fa6af1357d03c125315c2b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dafb50ebcb6a962ad743c3b4992998d92fb33420b40631da6beeef6af097f35d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8334ede5cb701b9b9f237d82315964d9bad995f12945e427fcf7f4c94c82bdd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6385512a843a185d1732ce923802f6a36eed84f2149c33020f07aa0f762d764(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5916c4ec1f36435f4830b0542cf8f212ea5c246be8ea12ea174d05000a7ea6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e702782c09116b4472d8bc4019b541512b7a0bd9a297516892afdb5589c727be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532da7cc039853ecf27e4b2d0e45982525f104dc2c79f96ea442269f3ef6b7bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4af43b9d04899ad45cb770600b7931e4d6608782c584fed893dd4b838d975f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c7911359860cc07ebf6d67009d1c9cb06d09aa1917383ce8d41702bf07adbf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325f55de4bb88fb9382efc6797aaa6838d4981ff64143d0ad49b85da1f3d4f89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2ee83785787c9d1ea702aed95a4124120f327f53c1f7d5e715253375250712(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa2713a831e40d31cb26813adc878f147b33384d657ea428f1ece3e995d74e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3beb5428bef954fe65dd1466bdb4092f0c1dfb1068f22fd26d0cfe203623c677(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac01aba7083e26ce13d7d14fe800aaede740881ff18754dd1c93f886dd69a7da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a23ca5d0559e4eafd7a88691657e29c5663220e5734e76ee06cd4e66da7cf77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78a5c8e3358d0788ae76d001fc6d5deb72ba2c798a895bae7dac7796ba712c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec96a4e106d2820af128adceef91302ea423fc0d2bf2345d6ec1b1ac730789fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a98a2f2bb12073a0bc9ec8abc004a8b75edf41df99c155ff9bededfe52c6c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba5de4bbedf2f31a1914a5d1e547dc0d7a379d72a63e1824b9b70a020f59950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021e161b0bdc0fa61d4b990c69acd8a248e7dd5f2d84de440128f7145c821838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e366ae794a01f8173c66c85e4ca07b7428c696f109c9841964987cafa03d0f75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c05ff5f0c9b6f49484aaed4c5ee384e47a9327a9b52313d896d071743f9776ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fff74ff94965a8a18bdb61c0a5f28471254bb423a1dea6c5d1ad4ba24209b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec1894df694bd3bf9c565d053a7aa728bf072abd860b04e13a92a93986dd3c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bcd63fb5e1c62afa2cf0e886aa99ad9f3b8176cbdf2d56725b97760172f1a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ebf8168c64ef39336f1781881f13da7c22bf60f741c85095c5e36fda940d044(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106161ca987eb6eb462d2c0b1926e2d3cf7dd9da6285326afa7afbd96945d2dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ddff2ebb3c03f48d727d022271de6a14564710ee2f91fc0f6ef254072c181eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b5cf609e4340c34ea7b6be26ef27fddb27c1992546db4a7b133dd2e2b47338(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a53988cf59d191b534d0d1e6b8bde5258eccb46c71fa6c3e705535a50efa3c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e2af028e39a1895df148219d7ee516179576ed2d5d7f0171ae36807256c1e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd0c9b3e733d31b696e2f14ec05d4e2f26045edb986a41c234f369b82e319aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c6c04b2e7f17a30a25baf452c38535514ada612b416b6f48a634f38aaefba80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ce6d90674c886d4c8c50550ec41c2c247926af0634aecabe67d539e425c529(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a8f23d781158eb2e4fb901826d36d4460dfdb9e43a2c7122f24751c7b4ef7b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e92f2de9419d9871780e599ce8b246b7a8cd588c5072dd6f7ca759988b94b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3324d615ab5ad4523f63dbbb8f3c835d8306c476f946dafd8664ecb6aedc55d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ebfdcc1a269153da736bdcf6f5d50a277d60aa542b22f0681f7bd8c7ae6fe6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2c09c66db68092b39049c29cc1d55b072fcf6bcc802f40e6a3a62daac2af7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c476811cfb9cc4c110afa83ba8635a37df12f6011e83d0c3f83e15b07572f97d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11354ee48104b97be8257274d34723bec422063b8dc831a560b76b98af2f9690(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d9f703ded65ef2dc41a9489c88621d017bccd116dfb8ad7885fbec26080764(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f43b0ef0613759e19af5ff0838e6f24b0a0b2d1d8f86cfdfa237a6d3216ebde2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac649bfc80e420e15403f4c2b3e7f011ee9c19d6110da126b33da827e0343b6c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91fe9578d3a0172200114ffaf0d8b03a05760b327ec6d1a06eb6cc20102b9cab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078dac95354d608a9ca044ea548f40372c7e06b2b298b67eea9949b99f77963e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea0a2049de4c3c34b649f67e43c0b4be66c77979d8cf10bae3a4b0987efdf05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1569184fb280ee52c50976792a7ce1e334518031d698b2bbcd0b69bd8b66d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c55075763836d3e4ca58ce282a7e8d2df6c857a76ef8584fd5f48036c4e49ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50c7b08a19af1c8807116499aa66d169b652b4c2947b4e4392bae8bc69ae2ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c4adfe5f5b8b1832e10a496776f2f9853fc1a9f662db84582ae1ebe32308dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db2653dccec174f6c216e530d9b00acaa23eae2e6f21eb73fdd4e1e09855e59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6099121f422a4bc44b0dc254a19e7a82f579c058a561f5af99f4e94463a8f16(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db115a4c716b3565521375b9c82a0b34d8c78a41a7ed460d20c348189dd7cfa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a024b9c8f6c09bc7c89ac717808ed02ec390a89563d265780140adc41f30e896(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8a92c99c7496369e4f80d90de14c2a016da0dba90dde34bbe9c11b37899f21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302d9134742b391cb76e69c10aed835a8b75c87632b7719905980adf55be54e5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4720b0d3d1ae6abbb6fce46078f30b3ec96a0b49558898d6458de494a1c3142b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fe3db35af465e28b568c3a613adc61b64e8d6b81147193f9147a8f0152376f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95331adeb88ed08e511644270c12785d903a293aac3fcbe1e4a6ce8fb9fcc10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5443e7f651ca2cf356139a3ce1b99fc3861c371b590d72a1a482c14ad057d520(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd884ccd1403a5a32a0ade4a88bed9f91b67d8918e5d57f244f39a61e45f7d80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0561ca47fac35eb464addcb1759140600249277df21cd04bc0f427a97ca5b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034827bac6cf8a0ab2014522fff4c4f8c004bdfd1b2dcc1629ea3e02728b3eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38a4af4c5b436c455769a28c5b08dd2917d7c1be29841d5230be69792a54d1e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c14f851e98dfc1540bc277e9a4386656a428ba9ab52b1bf8a7f17f5d760c2a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02559c43c856f96f5c0ddfe61f6d8647e5eff280101ae4e2838bd0257a09585e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8a280b31c0c0715f7583aef5bc43697b4b940e4b8c6508cabb5cf3876cf2aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41442b6e2b9d6991cd9e18524746e0dce34bb5d8cfb72cc37f5f4a4e0c418fe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006d8b332776f0be85e64b4ce15629be9314470317f41e9775a0af9b697977d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6452302cf72225ad3c9235207e29f22189df901ec1afeee5daba18000f2215ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75013927f376617f2d6ab37fd10cf83e715db3424d38bc0f70eec7159fe5b081(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13e30142e6ddefa71712c04e19ff9209743fcb438f2fa02c0ab7f1a1765ca8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0502dd7176c6bc8f44049ed0b70c153a7fe4db479d17fc5e3cc60cd6a10ae048(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304df565835b67a7ff38f999b62ec6547477a1ffb81b39a7ee50a9123e468d14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2493cb33bed5c16a1c4c54f8803a7369519c9e4a4d4a5bc257e663104851eb58(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__205c31914977a7b8d7c17da05795d8a15dfed31d9d4880a4f17c3a62ba705334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19124c6c1c795c9c9793b8e484dcfb802816df67a355b3c84dbde79645f1a256(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24aed51088a5d81a8bf0143044df9335f00f486499c574aea2a6e6e6b9499a75(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5044b09cae933e70e1f928f59acafefc735fc490dbe1386a69893711fc8298(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5101f9f60952dbd05bdf51cc09e125bee50396cd41e6cf35f94ced1e9f28175c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42db22a9655c77983fd3f3b99cc353ff851ded63cbf0afb6eddbbf7644ed722f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b893c48d8cf61cba23dbaa0acc64274fee2c72497a6f3e0103a4158f8cb41bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00be01b0f3f949639f1892d307c56d1e7bb49b038b9c05a8919a0537d039af4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a282ccdf03aa31939b74183f0ab17348b17b93567de8bc29b6ae80688952907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7627eaf765a522faa8900cb38e9b7b8267cb1bdefd3c3cb5f87a3bd6453e283c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1de046ac8589656a7d87afa175e34f1835fbc5cd0c946501da576f7717fddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc64e7b64cee858bf6418d52647e3bbfd52702412ae4956fb785198f12adb5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56332e98d6314d757ea08d2b3848375c22c7cfcd50fc01f7c59c3c13d1187a2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f72f8e7f166be2484e7d4cc0c01e4a64be0f04119078135462470429722da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bce54e093a5f2cee58c4efeec871c2b092bc13d224ca869925cc6059d2dc887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d57b2d68b687b84c4f70b75901a2990ee65de96434d73fb84bd445e50c30459(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90eb45c78f092409c41cf5559ea1af61301cec95f3b07e94de67f16cb7513bea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43b81e3d115082fbe7e13bfc9134bc8100d4603e2e4089e857725430a9435219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc955fcf6dbf2f18d5ff78a6a7ff48d4105fc24f2b41529d72ff58d24b702607(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691f934a159a4c1f197e1b002e0b53e4ccb88f029a58484458c9ae646d45a0ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76846dfb1a413110cf8b510058e317878db081064f3d38a7676297a9f44801ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df379b685422781f4293747ca083b00196de694d17b2665816c555c9856a58ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e203cb8526061eaeb6965a603b1e012c3e4d03fe9f3d9fda75029407b4291b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0116eb49277747b915189fa7d9f42bc103e1eb48bf11c23ec6f94c0957137cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4b2ab0706e689018dab6d31431e901286a64aff0038fd3fe884a25a1e0333f(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a1e44da05a27c134a7aba9618fd825ae7116ac7b0753bdb39271c2eb9abc5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c108aa493f42630902748fe31b4850e3fc59f60d58a4bb942e64ce99b4e82636(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdcaf2adbad247849ae66743004a7d47f948477c37a56bc29ee4ec1fa41b86ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79580b2c27ea44b3aec03aaa0191a6bf3208b8277853c624cf8de97ec2fdfdc9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8aa17c1d2fbe03ac3e5ca38c043e21d80e2040801ac3cb1c5269b009b4f4e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af8dbb2b8465e26a864a90206f3522390655a52f0979b9d628c95a98a13a5648(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af120950a850a8032f696bb44a4b58b54f46e321a711b3674214bec5228ddf73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b372b3834c13848aa1dfc2ac0660502ddf487e049058ebad3cfe9924ec0108d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b1aaa222a82143bc48a5954d20d91f87a798685c095f6e8ccb21706ce2d39e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea56e96b6ef6fad17fd7a4bc785c044d6bd3ccf161ffa07e73d7c04db92c6699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2f2c44c2a520c5febaa2f171ad49be2dcce9f6a523eb6cff7e66180e0e603e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a1d58b1f1c1dfd0aae39b0777e76eee09e5fcd16d42256f03348ee44d91573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a769442aeaec12ed12dc754c76f8a7a44e798eee2ec7c7a15f49b584286212a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a159cd5d1f27b2576c1d1d1f7b59c3398416ec6666c863a72b7e030eb57f48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080b7b1d099bf648b63296b533f88ac0ac38a5cd4c36de9ee4b900677433dc63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af2fa91ce27c896245d93275fe77a53c9ddba4bf50013df5de941cb99e33f33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28012b5ab64a34e4287641dccaa08880bc1f0ca1c88770db5d5a1ad8ee4edbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f63061e4dbd57b306c006d9bb73cd329be32502e5d2e6ba922ac5618f6127d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c2535da44898e0c29d7735c79b2faddb5d1c6b225ee5836123166cabbb80ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e170f1fd556f8db686645c66730c8b4bb459067e97ff2339b448fac1bd2b0daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c49e5bf0a03dff8102ba44dc062957b8b377dbd4eb3d1da4c729d4213a20fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc2141dcd64b38a6730f96e427c7045d10155fc2918ae889c7442b5d51fbc7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1851f40f18a2381a6cc30048894a63c2957e716ab54494e1d65e0fa9b6903b79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df688bd1e0768c1a051a2c0197986f6f86a50d1c2062eae3e107147b5a6cec88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6bca368a99dab78e367aef3fa9508700c6f5754d5655f0ef79b26505bbce48d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0076db3906362720142791469c20f67ed4ce32fd65d318203e9bab4c63aa610e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fd283b5671e4c79a49538a6644e92529da8f92122cbd387699c4dfa3ecae72(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92a0ddc1befeac1c66bd1314877bb63878daec54b4f1c66a218efa9dbc77a96(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13d6b8e49d95423a9b7b18fef4625165b088a3dee3fa81c15ee7abfb6c15b7f1(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e9aae0406a78843f1929cf0fbfa1df7848614144d1be571bcc4fd6942f6e06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d217a56a28dc03810bbe400f7a50f6c0afcef681882896b2e723528a93d39cc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35f8fedb4b91e00f36cde31454e700c8e7ef430ab65513391011dbb103a3271(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c0af2fc6779386021a2c419a8ffaccf90b0649f0f00e84db22f694561658654(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17d70b06cd451890f4872869ef71b55e64a4c9514a412163aaa4c79c3151e01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c573867a3a15214009a083d1ab2a91def085813725c24194e812480fda741f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f43ea57f956621a92ab540ba581a6efcd31ab62922de5505b464d8291a66ea80(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3cb9ede2d175ad42cd428ad18ff5288adf0fa32c5a3b14cac1b4a9577692890(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b9b6f5db93200825aaddb5671399ce2a4276c935ed472024a49b54db6c263a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56dd8201fec35ddd31ac692160b0a0a0716c28526fca0aa23d08217724ec29b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430e3145d3407825aa685633ae4832b2ec0df673328c7cacc66092c400206287(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84886a063d17453a9017f467c29e7f58c7f0dc4c40feb0f7f840b2c73c91c6c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1023a1da997dd9f33a1a4f710cfc37820d8faca73f5ccb5c628cac07956a1ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f4b2cf6c2c27053628ddd92eab8018c9dae384f95ce73cdb09ae0ed29936ff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c8e1a1f5f4c497aeea5fd7a9c50f42aa10fedcc2424c27b442b7a8f643e02ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d19e174a7696a6aa28e310442b8a308d93a694e28158258109336b893d0d45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64279504cc573198cc13653d98d437b6343e40a93cd792aad70e68a892910f6e(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced43c9a19568f8bc953ca0069f5cff74d88d8e3a62a0642a7ef64e58c345830(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc73df650cbf41bad721d33c31335b8bc9fbe4e5529a6b45ac46975a1fe556d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce461080e65019be3f8f4bc102f09b7e2a171b70512138a8f8a4c23b9db1531d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4bb4aa87a134f805bcf038e8d062cc98e870e8b2401b2f36c5349163e268198(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3753d5f5e1d5091081262e2d062f531eafdb0afa615fd2511b0a00977e010227(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555ab21cdc88bd551a844795f1fed3c01e85802b8288a80a226418ee81310525(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd798701cd70692bff92ae3d0e1b220c34e0951084f28df73766f38072c3baa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae5e1c6ef3ecf81151ba31680731b6b5181aa12529b28854659c0c6b24bdec6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68cb80c03f3049e517d9962a416168da4e0dbf5f34ad08f5af847be7721dcb40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba786a1036dd291855306b8609c29517123475c54d46dfed98f1867ee5b99e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a46ddb68824f421cd19f32968879e6bcf8ef5f984116770206bf4e70b6c02e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd172096a82324689d0fd7e0153d143768dd439caa305762b34174c75cb63dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f8f16e5b9bf11dd3c9777e533eaec5a061939e1b8357a81156ed508da2e766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3947e99e340b7eb07b8420f7efcc9047a94865b98bcbd22811edbee870bb186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a3ef36419c766a0294d1e22b2c222cbde0f9900ba6f5537222c767466c922d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216403ef5a2da722bf04b1f0c051c84bf4fdc97df499bc1d643d91c6b6c0a8d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908dde7094efb451d670885b84cf42cf1b946f27651839311efd11c73bbd94b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8dce54adea4775e1c42a9ba8caa0efe2f8af438cc598f02d1b0be9e0ef70eb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05de8069ca5f3cff374bc787323c9782e5b41bed102a519f1aa4eed0da46e04d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a185f759b7cdb5f714edb857a0e1241b1d1164f2129e4998363ae96995210f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e442e48f5cdad9eef42b5a51666b6fe3472ed10fa9d0043d7df0bdeb6bab44dd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98e2c973eda0929ffec27c555b0dc2c23e993ce35824c07ad005e18c15d4060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f853908ac6eefab5881cbc67dd0703ceca059c94101c79b407d74a954308c757(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5215057bf1c3f1a455c97d4e54428a9910e0b6d9d592a1f5492aea42f13f7616(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70787e942652a72f29d77c88ebd89078a3cc900a8ea9ea4523cfcad4830f7e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7499974cd23e03b601c3dd86df3045814efdfbff35e9e06451ef161956886f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252776bb8915575bbe803a1fae16ff880df968b80eaa1302edd519f91e94740d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6bdc2bf8d3716e117164a24f4f44de0731bb9804b853d4f9871aaab1a2b47a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831824f9b96902f4d1ffff5d468c451c31c0cbdd568d230552126e14078dcaf7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f821acb2a4039f313a9235adf55ab65d7fce32f2a7c5154e19ba24d049bda559(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45df656bc3ac12814a901fa66bdeccebe70b9c21d87f06a9a2f7013e8408dde2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f154a6c5c0879a3cf2d6029f7bc73e7021f916f0bf8ac66b1d555630bd0f0c91(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9572e36a1eb9a7794714c113d8c952936d47d325b682893b054323190a0d5ace(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70831b16942d602f4e9e2d4b26c39a1a384d2b86e90c76b58770b35a8feee783(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ab9f15a734d0c600ec8a5c28fe00d6977f27fb55b9d8544ead5dc076a3c9c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf3cc4e9237fc1812a80421092a1e50990f15f77b1c85122f585370e8753285(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfb9bcbdecab9951906ac9af7503960d5350d5f20b69c7739f8937c845a9f4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9d6a72948296280ae8cda6ae1fa14575489aad4eb60ef0661c4e6f313cee1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc73362091e6ea03a43c23935cbb3ca1db971a6f690b07348660ed240933954(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b825f2af2e627efc4a053b8fb10534e9e093fc454c414946b6be8fe831feb512(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc81393e6ba4c15dae8c1f4fd87274739023406abb490a5a46f272a099460bc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45889b0e93c3c231fb0bddabd877e9c0a1b43ea67c5a12a4560b614e6178e381(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc918499f0d9175b26ef4b44928b815d929790de42040f0f35c1cdcdf4a5ff12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c5c2d9c8e77e40e167c689404bf91f832fe8294141d5f76da3b07c375024fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68fd15db3b023a650f2864c93d09a07ccf3263c2c35f45703443adba6a673d06(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ddc97c8d641e346f430ac049aeefc6ef1f370bc8b5df32151baf5b7d8f6a1e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cf447d54d69cedb4443b14378dc1b60be217bfc524559b44fee9df7ab86f12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37e3f41c8595c13b1c342aed0bb9142917ebb412dfbcdfa325a6bf483ea4c09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43766f832ae737e9c509dd0dbc12851153aa45e97ea3b99f4a72511128706800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2164eec13fd6cfdb7f1be5c8d8029415484caafe6a5f8249b711ab0afe74e6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f653ff2eed73a585248852f588ac3285a330823bc3877aab48b59c40a82f7e6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797696345f715af7a60dc99cbf9474211976ad554602d71dc93f5b1740b0647d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1b7efc41a58893192af6710104dd10312da30c1fd74986a0c186f6ccb422d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53c32d90daa427dd7562f82be13c60ac220b769f446329cd3fa1e3a956046b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2ef3dd61fb68bb22674e565dac861ae4369fa9c70f66e68d14878d0ba19e73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36dc0bde23bb82e2dedd4ecd1eece4f5df94b3e09691e7eed01cb48d607041b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc1499a68290deec61836bc1fb1c0240b9d440b2bf87453b916622d366285e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5ed794fbc2c14816e1b340dcf292bbe35fd3d9afe7fed31b92738115c6c294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5063f8438d155111a55f8bc3ea0aa5089a4a89ccb298074d152fb19e43ed94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5285fa19d6e5de011b94073617fa5e704e5113d1b595aa867de9117bdedd81e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2996fba0d8c43c300c6081a8cfef2c9f10c0526fe31cd91b73505bdd25d45c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2a02cdcd62fd675f02a9f5aefdf938e92491830b0a7bcea918873d1f5bada9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d041c0d54b6a760e058b9c90d9a89ff9f4d77801b1ca4c2f0072c92ecb840752(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97fc326d9abe1b32c6f729803522d698b640e3f8c3b6327fab103aeffaef4794(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e437901aa86c14202b7a645dfb645ba069728cc04104691a03177381bfb5c77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36816ecc9a0ae8dc28b48ff4bed62701a3b2dbe73733a0d5fb8671af450d9f56(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df40b6096a83d7d94973509284700b90f2947fd858572fb21dccc340231dd557(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659e88212a8812f1e076f98e2dff9592215fb05ef3de4256986191f53073c9b1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c6e666cd0cda9576f0c0b5c346bd8e43f8c580c41e014dbcfd0a091969e282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861a6c406ad806f5a6af0affd220c1d5354cda343152656b33b0c90cf073c18a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3784df3a260a24b1f1f57f24f3337fea1b78929fc8a0b0ed9c3f4f0b6862d985(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11e69cbd869b9b96fe141130745cb5cc7e8bc443929b96eead1d0adfde3ac4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb1e2416e9e5fed72a8ad2f31d8a2ccde213a0a765ede8317c9313d8c646c92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265de9a5fabb98f4dfffaf27541cbe0049bf229ec9ad8181782893797ed2d73b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb999ceaf1f44079c3c8a53071e8f2bfe3ccaab6fa1041954699ea593034bc4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c182b32486d97715187cc04d7e78b71dcca3a7fe6d1b82e9b9a87aa4027a6ff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca95ef39ff3209deb6bc6230b97c14515c673c6bf5ba6f9403bf7e8b52bc43d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b81a6a55d494d52a8f658234ebeab9cd195a4c88e5f20ff3204520c6a87dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c3ff1a139a2ddf08333a89a8d295a7ca38b2aeded86087021ae1a01c342335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__673111f4a3531c2214b35365f52e72f608478f0d94d5ab309aac5c4913af49b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b833e8736ce0f2425a774bae924fef8054d03ee3d562c70b6654faf744720bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec748cb8edfe41e58c5e4ea39ff06755ec1388b425b79cb3e869fe62c618ae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__637603f040ae1c92f6517e7959f0f71c5d5b48798d00b00384fc392042fef3e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46553bb8651e282edf14356960ad075ee91dd7a87ed79336ed3e425e0d4afb42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc577c27f5d803d5b3c079641d3f5de1fc32be66993d258be6e56fa6e196a92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d44c88d61c2ced3ea060a000af823f422eb9dba867b80c24484f06bbc9e4afae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c24107bc41f29fd8e0783a526d9b6f9be70a61a33a9e3721697237afe51c957(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2cade5b007794fc83c49c0ad03c2db3aaa3933f417e72bff665af7aa2f33c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a5010fbd41daf194f88a86ca5c2c87d9d4bfcc9077edcbba0b53efec40d243(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2216ee140443c2ec64131c56d2fa100d7b2228cc039ddee09f0cda8e88b8cf29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b66ecf7d5dbbd9851d3f38ed42a9fed5bf803cdaf1fc110063e0d0a07d9697(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df65c1a527334257af2907518745ba27cd911eceea703b24aa3460e4b5a7bf9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea0172acce385f96e259bd9df7abaab5c253302a80927d52f1dbe3b350c3c5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3020a5e66a22c11d8963c2d8a8d28a29d613d68ce350a95417156836d27b55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4f5bcec369920ca94f09e9323900f3b227a5eaa2f2605fdb7cab29803b6a56(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e2d5b8ff76dbceaa5fe4f43760332c72eba7260e817e9ed7d3d014b825aaf4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c276c6387345cb8825fe6a608ebc366d6ba5cc432ab0e774c8a0b61ebf2478b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f69210b3a71a1844f049408d8373992e35f9496a77b2352f42ede0bae7729fda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e71eedf031ca5dea49e25b9e99f15d3f3b300002cbe953bfdb853603477374a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa30783e98c35eaac0eacb3577aab38508c1edde59e5a4057c441d87ec89c92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05f9bcea69648177133ae71418d5c38f04da50c255596f8ec143f90bbd825a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6c8ec265313be30b45894c4f7416cff417bdd5687d4bbb09cb0c325a453d77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4abffd888c7b3b2783759d376359d0646f508ba4421391eafbcb8cfa3cf15fa2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bbd21a0fd0aa41ac89150a524027326b67e4c0944b5843a48a261f72e921fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74c8d8914bb06e650b4dec03ef46d7e92a3b54ced1cc8f679ed22bb92dc7746(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50f27c1184a4cd2174d74195902ff5e62445b0b3a007e57be2bed8f381596a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412480c02441f044704d28c4e06fb08d00263cbacc65d3881b6fc25d95ecac9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c9291decb5783dbf96c91cad3bd3fb31fa1cca61d9a5d4e8f1c3626e43dbd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444520ec329052286f94d3dc46bc79bbc69cd7ae06176f8ec62ab394e9d75d68(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7212609da6a43ee049e447f2dd7db2a470c9a80b4e04fb27f045f2a64551a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47f8a4ae59c254e2e3b6d0297b843b3a7f25d3e14cc9d49e9a84bc95dd567b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd35e206166f4c4da108f0fa9e1d343704610b299df247dbdb897ac7f1c75ddd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc41caef0ae3bef7ac43addacea441f5b6ad879bb3f520ee23abc2a45079d857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf1d831024bd9733571456fcd542b23799c078b50dd5743ad2910be3969123e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c825b876e3fb590fceadb8e5a174d01e15994ed98fde1a63bce3073734d8aa41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972e3cc7682de856c782ae108476b6be3a194a529218609618cafb64bb3a3386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4274e2297171f94194f0c223659d681b0a38dc2c67aaf612b0b780643d699b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2184413a82624025721ee2313146ce187fbe7c0895a43d8504e9b9f2423591(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4951e5638123187ca7c92f226ba16352c2d9c1a4b38db247ec7f1c3eefddfefd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a603ae0689de1b900973881cbade85c64ef6b617e4938ae42d89007ca87099e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7f898157db2d84cb3d40a2c01ed25f9fdc6dcb37b1da02dd679ab2fa78098e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878d4519d9a11a0adea4d3fa245244ec54bd22fe642afdfaab977bd1da58182d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c944293d6e84ce8eb49418d77b63b4dbc68c36cabb72ec5dd35a75e6992402(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f66042e56f9aa3c8aacf771c50e515535b2c7c170c39e4b78510222575982f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47448464c1a3bb2af3e373d6b0667619d260e3e30bde5b11af32b86c96c2253f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16eaea5c93a313218b546a9ade7aa7ee03b74c7388c51ba2020c6254d0beb6e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ecf269223b8ec8aa5e6b722fc0c5bba3fd3df3f4fd63e1f1df9442b0edfe4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e5fe207d0320cab18b0c00748eeb085755f4874a27857603aaa32fde6d060f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff1ae2d5be306dfb721dd8fbf6b59104331071a289e2f2b98740958247f4dee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edd761b73a371358a19d8c237637a734c2e77d7644c9469560dbca305c16892(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ee0485c3a36660e485cd1e3b06d3cffb7a37fe04982c26aabd6e20ed48af8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a3095005e4ff90e93289957cd3b9b446e8e9db3c90022177b0986109b707a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fea377d40c658b71774db93a87cf0f0d410d5f64b77f1cb8470a16fba52cc0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45b7f6420e11d8d5419a75bea486ddc9671a9662b69dfcc2d7007b9f44067ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab811511f80ec9a972c47461babdedf1da4f99e3392de4d53ff1a1557e65e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a8b753182654f441158483a2a3c03a5746ad2b56f8dcc33781f3cf40c8d212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768265f20e83917f3413cb978e5433bb4ad9d67a5da2bbd6357a64a2c3d4b83c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc1637ee024e598ffbc652264605bf6bb71cead1602c8dd71ea53ef8a21b051(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f507165ef2dfb32a36bb993127c7dec3dab2a36e820fb55f277d74741a8c06f4(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4596cdfa7086f018df18997d98524f1e5dd49ffde11e88c3359947025d2e8eeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c89c96865d53ccb48ef3a726200ab5e127b62d156065842ea88cd8f1cbd091(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aedd77d13bc3a06dcbdf2bdc2ebe477007a18860bfa41b8b30378d5623706022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b568719baed356ea19e6c40e5476b24da83815f95ed145af58504fd2db3b4021(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d679103c59cf97158ce4cfa9c43cacea07c59b3b92b22c3bda751122fabb9353(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c04be2cc89566f453bee4cd17dd4f536d37d22286f6a0fe82111e2b0efe4919(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab7dbfb09dd6f54dfe23e3ef8ce6d0fc62474c2475b37351fbeaaa7c89fdd21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2233f441d98067f24c824f76f243f1955824f66f876a513d380d8c19b8f0295e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de2cea332bae71250699c39246fa31ace223f2d7079ba4a7018863669da262d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd28010b6a80c37baed21f3722b93ae222cbd7a4722aef89d48965867767719(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fa67a40eaa09c2a8ebd9452ace7db1932d93f89e3f45af1d2fd891a938db37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08784166621c51b03e74ae822167122950b6a0bc84f61d622473a73dabf655ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631c9d182218a5aa65a77c7ba212e565e235dde84a0de8084b14cf99eb446336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5fec617c1c3c72c41debff0ce072a8abee4bc10b9ae202e172f6492a7ef19a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a66ce1e92dff5f79f8d29c921689cb747af1d2b5f4848e5e437aac5121a7533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e428c5859593002d8ff612c9ec4cf96855297c5fffd5ad26ff36df507857e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550602ebb28cef282a9feac6be297964805bdf889bfa7109cbdb2b307e516996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d994a85013f3b6668911780f5ea802b112072627862333577dc9ffb6a2f477e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece5a5c8f578fd09e3edfc982d39e53dacb60acdfcb6d3de95041efa9e1ae25a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3598ee4c3e9a399f98fe36b55fb15801a8efce56b07ee626b5a4fbbad9a27c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c81d79329141dde7b62d5a9fc866defaa60fd7a525395128f179a5a71f07fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bc774463d573ec9a16bbcdc0c683d00639a6843e1c8cb99e713310b86b85a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7c8ad44d4abc9fdc3ab8e66f5f43c468bdb438ec3a4eac458c02a9ca4f211c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a6206940085eedc293b7e461379ed5ca02adac9e3c132f0f2009a2ea89e0b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__752e4cb8697911aaa38f8602f6444086e98f5f3f38c31aed6b03f0809faf1e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec487a082cdb3d9a5884931b712c719539f551ff251a7cf13f8684145e60a07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a8fcf6ce05dd7bef8de912e41358bd7d7ea5c7085f77dbe2b8db069f5b1c1b(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a3fcf50cfa8ba935858f4bd34608130091a078a2fed3461fef96ea422e74e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5904991d46a6939db66bce5c8902cbf00c49f34993233e2ae0977fce16a3325e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966a14d630b59f95090eb0da5ca8788be126f0edf47c6089d13c17cab53eef7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecde6dc86613a23657b10d8b3e66df4b0a3fe9f80637c92e5b4d8b9851c7416(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2cdf96e1943672b7deb8dce50869c9b538fbca3888ece53a2690f38795bbc7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240378d7c2783a937ebc9ee001dc828ff3a89226c235f9db05bda1a669b35bd2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c6ef53a1470031758efeb8ef508a48c8a1e8b309fabb511c2e8c1495db205c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4e426886614090efaf1773d9a245aa752caeb4bf8eae94816eba5e3ff2f457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc0f0b6edb6d981631f28b73d93f765e918001482a0e57ae304b4047660163f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb007b499eca84961775b8d57e8f07c2e35f868ffe1f73022adcb28f9410d9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c2c01dce9d1e913d668e3a520b5416df23203f13393c66d7e25b998e54d0a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb511ca31724bdbff9fd1df79023af1414c775d4d26790bdbb3627a563232694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350778a5400dc072bc89aede989fa11b3af6f0d34eed34d05fc29470cbdb1228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82762ddcfb82821b73254567a76410f0739218576dc2a671b22672e38fbf7528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2dc0888fc849128a50fc68d1ef07313fccd2b08b2c167a7920b2de15d3cf924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0e2a58c7e1f2a17d475ab466d9d518da5679b5a740375c84dde9965040831c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ce25cb888eb4f393bfef0853fc32b5396abad56f86a0f16235b4d7ed15ff21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f55f44fd897c37fde9df69933e9f078aa32aeee59d8c79f04afff414e42b090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a76d3fdcdc0c20a5d876b1337d2be2943a544b625c7dadc048bfc8478285b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68764395d3b1bca4e7db95d0361b45c3b7ba439b6cae2e307ddca7f06e005031(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__317e10114744985eb0a16d60f8c786d3fdaedab06ceba401ded4e1fc57a4d23a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8392478c63336e2f2c3dcc24945f6b64d1f98c87b121503906885428f6d53f92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8933c9154df68f3dd2f76adf9140332b07a507bb560ece485395a43ae4570e50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e543484d136c0cc45eabfb2f68473b91152cb5d7bfbb601a2d1674b580689fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a13f8bd86716a75feb065830d961f4ff2161ad8e4c204e163c4146746ab0dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1e00f8a335a08b7796d4b7e1771321a124380f72348fcbea7c52e61cea1714(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f7a6166f95ddb5a29e5de379ff424c4ba882994f54c6d7efd3faf6ab0e5364(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376e1ea6a7d78316fba01701dfb2a78d7a168e88ae829d1da87bb9a1dace8339(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f308b95612cf0e5be90cb1da4b832dda6956394946e2be990aed2ab9c7a54b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7f6af19f35ef6093c4cd981a4c8f8605e9b17d5ec9d54852d9a42401d0cdfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b24771a4ef3a8a26b44dc68c16c08e22486346800ccf5b0e08de54f05c723a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71cdaf9ab66da7bef0e799a0b66e3e913ec304f9403f57a150ca04a2d84a8e5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3010054749e064c6518a5e1b6f97598f72c0d7951c1d922c6b20ece713cd351e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50afbae4455106ed2cb0dd4e9afd82cfa5c6aedfac4e4c39934affd86adfa2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055b8a35950bf0e668563f94553782aa61ce9533263b878c086bb69aca2ffa7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64a9c0e6c96b162c44975d4381cbc81c14e3fb703909903ba5f4e4e71849acc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb1a566b68c5f4ba7f7f643fcce6ba8b97c225f185fbbbb5b7c7fedb22a9066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d301c30ce94331f9f5cd08eb7f92e20ed9252ab60b206af4c71a456023e4e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6df7c9e6807bc309859c90aa2df7953cb30fcce76e210d5ee3ce0cfb19f606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38834b7d5a4efed958326e4cc29ab8044e31863d695944cbbecf86f8719faa7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1c5d65956da2b2d481fefe1be3f8091cb87f6efcb159144fd3cf546ddb1dcc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a90fac0e26e6bb23db9c8f21d8e627b3a318a528c9456883963039f80b3e5b7(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9410fd7f105a19ce2916fb1ac89090cffb8a1976eda9b2d5e9029282e97cf317(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c94989d3669c7d78b285596fd2196d16572f2c0b36281f44a69d5f17d39db6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238ae21d99b81046ad495d00b168cb9fb6d3919f997360a3d3d61d78e4bcd160(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952d4cb7dc5535e74d58df97835fc0e641d77e1595e40cab1f5e691c3f890d89(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14cc53df0ae4e0a509728bef9ece88a0c67edfc4035d92461df43367515a8c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a62e275f6f117608a9b2f814ce125b7b57eee07116b5b33f18c490e84a66b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4645fab14b0c8b62c58a8627e52b023458960b4f8e072f30bd27add151b8b65f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11aca7067ca0b1f0d2aa487f3d819a88e7310b14d61aa9c2621b5dbfb9ae6f5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f112ca27947dbd709f04cb321ccf1dc446865566d133b75f026144ecb365c6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065f5340af429e1e31c7759308a8f8b0c907ce8878368eb67b600a121a48f436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8d16d378c753ad8b7684b9d46027c49ba77dbba90d497dbb2be7817c4a1ba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ec0a173e1f3352ddc030ee0c765b4c0046ab79e860fbbe0f062feb70eda26c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca81b48d4fdd1222221407c889ea06d61309b03850699f9bc90dfefcc72116ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740a16c815082a6af553567aa943eaf74fbbd33d4149115ff0b30c19675fccd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee9e1068dceca43d4591f0f49073573d106f72fc4f55adc4c26c5f66aea88cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515c5a1237e01ed2692218b30d5bc488496a16a207e61d9921c87993a89d87fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13804a8113145c97fc1ae4f05c1477b09f6e426ba8db0d16207aea81c1aeae50(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b52c679080eb0096f75eef35787017ff14fcb28ccc6b6f5cdae62b700f3ef4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404a7ba2c013b8a8c39c52a856eb92b0bf9ae097481b3f0408471b23483a786e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e854093438b30dceae629c8390c403d0e1d1d096b78797a148d3a90015b18406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a51a3b13c5c37d45ba9a89c214a1bdc17954d42db0453d5891c868917c5f82f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4eb5d552203eafa9642b3b86323488766ab769d7d8d243ae945b814df6aaa9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcacde2a7c40cb39afe06ae250644e430cab27c7874e089b88cf1cdd51d5b8c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac332d18a2aeaa1e88fa2985f76837da148cc839d3b6d2bf10a84ab3465c9c51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f9e3440cf25b04e0c95dab31061b19a8f6f2d5ff4a8d795f5cdcdca5d78142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d9909d5001d3a143292fb0e3d8b98b119cb51ed43fb1d5cfdecd3c3ca0713f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbdf0f299fcb19f84c8334c560b053e044fc7173d691800ce34a42c1f2c8f2a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7060a8110c191a95556624c863a0c084ef9759be25ca90ab61f0c44cdf29030a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2a5fcf68e3da5e5188d4ddc1bcd34aa1ccf408912dede1fe17206f55ffb127(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4b77d537037a558760c271f6092eee21a3587246fd82da024c4bf2c8e01477(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd9465d81dad1ab3c0c4f16203e81bdb30680e208cca3ae188bf3d14f8cff3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a4a75171218b14b9fa3fb8d12d5d5affffd46c00d55e7839ffe1014989ca67(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656bc493e00b43a33a4658548ad75dc570eb1d287278a0ede56d052fce5e75db(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a33549ff200beb7c172525d7c30da4e9d6cfb61d9e43ae289d45694262198f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__814366b9ea38252d489b18675513320e9a173e6427474e308af65806e9eaffcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888f558e6e58785bdf671b57f1b8c65c2ad2b40000b0a2090bbfa6b365b258c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd809c44487eab5f97475f8f822f524948011911009dc2d8e162f8eb164a29a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775d307675d9281a8b4d4687afd0ae475ec2bad8a492e2aa2ced2cfc122162ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14218c3da1bfae8e840ce2363384d20e734213fa77c37d5a2e18851265b2f474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0289480fd058d7aea095ad2ffb02650435f16a5425e7084c5812f5083201783f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3d851daa5bd23b06c1ed3e530f159294e0ad60e5b851aef60418303d495cfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78c45426811a941f05845007747e5e473ac23c94fe0b45123eb8779fefe9866(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5110f92ca4cbc79ae0019c32788d2b40b404f562e738fe4acf3bc2f04cd7c7fd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d14e3d5cac50b18485666e484c5b5e6bd7b18b1708fa79d0624ebd472ed4f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3fdc0f8fd67680d9498597fb2da79ccbc890f2f5c6d81b113d03eb9bddbabe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9355e55b78dce0430d1a07347ea545160eb2210024ba5e313b449de86a6e72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c23a9e4cd12849a540e9d1c1636a474f62c9eee58251cbe7a31f1a9d5e5341(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc3e4d5af72506465cc14687c0f6d0930005df9cd22b21fd31aabbc7fd9b80c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7407de63791043ae53ecf6ea97e8a98eabade5167048be975c2742b053e3eee2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0aa84c6192e77d81c830de61313c6c8fc3ca3887e2214af863478d10f78b33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e092d1c11788d06656af4fdd473bd09cc5e94a6bf752d35419bacd1791b4dfb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32fa8dd4ddeef9660982ea35f8dc09efebf69bce84d99dd7fcd8b8b88145746c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ec97269a7078fd7777a10565676ac749e52114c4d45338488b1790e4b00657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d8539b55e2eb2172158c00588479299ed1138be056e3acd7aa16b7f9851742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd7466ad9ff7c2784400bf956cccc852774dca9ea00ee46f004aaf2d6d12356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644e872a6e95abe5ec999dc3cfa0ba2049c2e1c97f750dfb1a5506f1cc0d5c1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b77c1c5b37732ead34c8001315609437e5c6f34bb6fc67372ab39713c48d595(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830a491ffc495a1332362dabcc14668535a96371298c685c71c03000f3a586e5(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4548babda11be5b8ea1e2219b0884066ead968a33ea60c1dcf2a52cf5cde0bdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1c21ba4400c2ad63d3dfd1805acb3f7c232bdfd48f741d332f90da42c45e54(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28918ca947ae6249a19bc6edefb492b5ad4968552b80944824b726375add85bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0298556a3b0d85e2868180e0a725331b9e963496844b9da88e4d774cbaf65d6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3268a75f5409d5f393d596da290c10ac8335577d34bf6deffded16d60f1a78e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0878fb1c140b728ec7d9fb35cc556be915987f7027210e44e377c87eaf780bc0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05150f48ea122f0c678824a996ed96cb974b20dd5f61aa48c50a546b60502468(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03abf3f99c5f4831e79841d66bc33993cb3f83567c3e489691040202996191eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091b9988ce3a7489d6170dc47cca3372b6f323e9ae011e4671ec24f50430ef2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515afe234165addb25260e35bf3fa0e99ffff38f5e5a15488b9cc15c23da526b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9304efc9baf2093ca4807ddee111ae18314e74291be4055451d5084bac1324f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6938a752093ee6e1440c5ad13eb8c5c40447006eb00e366dd04262045cd5b38c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e7feeec16d23b0edf44656c0b1fc92c1ed87936e8b4ee159d3b297e98f7a9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01294a5ea8d80afde0f6cb9802e479eb4a9655c32be78195448c86bff036d05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b4cbce66af2e27716b0d9484fa1806dbbbcecbdab6cb4271a459b2c86d4bf1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0b132b0d0aba3227a160ebde55fe3ce4de2fe8dcb79142c0041a46f2173fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774db5acbc31a93c0e8b885c950cc711b972e0f9d8c0411b94960e6f6ade1035(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9cf3aa6c81823c9b330b5929f86625e2c01ca548bc4eaa29d1d232f8cf9d7c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1507d5bc73dc561392a90bd89afaa2801fb306b1dcbb89360be94142f4525c61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0164c8010da8fd4e009703aede0a961a08bac3ffe87e4becf28066d3ca3d5e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722a2ece06450695fe8835af3a073884886d1e5cafd4cf54d6167b824d84f429(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac60053a4875287d158eb5d71aa1c60f8c46eba2011a0423284fb5e56e25ef4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad58541ba198db5246be1c938c53afd6328049f6900ffc5baf681f4392970dc6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8385a7c88b308c1505f07c840fdbf64317bce0c52a7076f455ef9c731b60ec0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcb3f529c6629eeec2215257f0df5cb80cbde2419c5184cab892db2547478cc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087c22320abe3ecf913059280f644044ac853e9f09d66d43265ab3d338fad440(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f345fd3f116505922d9b014c70137af33504d149f136c1fb14c4e12668bbfff8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb66455b5671eddbdea40ec07e3f6a9364836b8848a09a4a80aefb177fb3825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e238dc5ec022a33f370453845980070efaf6e9876a425275b268881f18113990(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2be1b44e3324c73ce54cb5b9ee5c50713f086417dcdb63a6e4d5f0fd25374cf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec785674cc42cf0ec0ad3de139f36f46e674d37594243b47c6a4727b1abe5578(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94b45fa4e62d994e19e66a5e6ef961483a19313007f256800d4690993f2b662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce02254c67d1edbabcb0802d192f56b7e191f3ff6e4aa456dd364d27aa84a88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0174025988b4107e63216f954380c2731003d0f4f8f28c190a7a092ffedee1ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9ae7f565178903b6771bb3018feccf5eca6beff4ec74462ed57a1fa6e32b64(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72245c4790898af8187e0cb6d89ed16b0620af00bdf60c26e99f433d99869780(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2418c779779950e9da894aa980ca0abd03cc459321b519b420175685623a71c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b343094396601428252a7ad9d7dfc7c44cfb3b787bb69cc86ab75045824e4de6(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88fcfd48e6ae5f8df70558b7b406ed0a67750aeb1d96ce1f2687933943c12744(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee315addb1dad35da76f04336ba2e7121326605cd4aa952853033362943210c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893b7e897b09fd887cc6f2f82345d1fa84a7d95a04e0db603e94f086019a8eeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf00a59c1aa6682a838bdca2e500b9fa5057d44797f91c3e604dc6102e4aca38(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a1e5435a9e8d5930998a02222f9162144a0efeaeed758390716b41eb32796a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec64055aa371c7fee3fecfb7d06b5b8ff52bfa6b8ac8a7be5ebb95482c57151(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d61ab8d8dea5093db7a19ed537cdf48ff4619e64269458aee8c83a8bbf5c993(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4b67bbd635277ea4264b45ae0adb310772a1feb561cc9cc3ff27276216e210(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6bd734357c62616f8b5c2a556f1899182b3d6b3e4be01f247dc132a50298bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d90d73994bbaf09ae4402a182e2dccdfcb8d0d8246c636afb328cd3ec837ad2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c556a65e3473cdb88e81ff52f2c96d0ed108ce03d1c6789226472519ce9190(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9dc47b757b8529184fd5ca6bd9de31fe897ae565de28efb1c0af299992517a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675403a9b827dc36e09e8efd8822779a68a6a5853e7d8b0f8a1d6b740a20277d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd59b2307fc9aa1ce3e0a0144f88a2ce27a942da0b9c55f61b1d53ee2602838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b1e3fea93e3d1415e4d8760b0354a9a67e4efb12adab5f3e89a2a83af9c9d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768ba7079e1b0ff7f1732d275b5a2f75a632d1cde2407854a45c510b06550169(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfbe7e4a50b51ba6b60af96d91eac6f7df534686d94603ffed1493718e48d440(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def7d9651d90f2f1812b1b6d9d2ad1a9bcf7da8eeb5265380e2c95088ea180f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc830786d3ba55b73a822c8046ce1dc76980e1d303fcdd5429f8732b5960ec65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f90abd5fb69721aae17a671cb2eb2d40b5eff88839bb1320c5c657842066296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5b10e3bccf387236f0669b870400cff5cecbf15a68bfc6e1ffb591768d8b72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7eabea1f0a7b9e445b86087fb5f11f5d667a47aed0e9e393b5d2652790d678(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__307914cd08901bee0e8717647e138b33e71ed32e07369ba0d8993ec170695f1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ce77019106616019dde438a8ac0353ee7e16bd0baaec433b40221d6f6e38b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8e5d4be0bd9bfa081211270d28a872ef46a6264f93fbda1d7de14b7b233dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37076df538a2e848fcc24aaff98c875d56297d18a53dcebd932ba0cf809cb9dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c7ebf03463386737efac2c29b294b9e63e09cdf47bb8b60f2def5aaab941c0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c962baf203dc8a943e71e485591031c4b236123fee5fcee7296fca259a8e28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c8b0c3e27fc3ddbf4eabf84324e7e3a704de19798702892baa2cdec119b96c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ddc164d7655a13dc10693a7b943e9b636e981f9bb7aa3f0698701b1f179ae01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d8b1b0c3684738b5a381b09fa658e404c8d1a375312281174806144b7debaf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b111d000b55dafb61b2527badf94d078b66945fde5b8fdff8878e46b4553e98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__296d38adb8d2968dc0859a0a5d641b4bc0736cdf76f1ab4a179d39b768e579c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__931ac24ffbf75f15ce3ff3003d22eebf97ce8879f3e1ab2cee44468280f164a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8605871df816bd29ec9a54881737aa2bc81dc0ccffe4b691408c6b5e0d6c409f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e91940dc6a18a17779976984a8b146c63a1c05a0d34f9a1c889e76de583c433(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33dfc037cd4bcef062d2c30bf71d0c098c27d744a5f2ef9f0ebe52ddb0c30135(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9248dcd6259eb3348454913df554ec82c9eb9dc378c79568471ad8016b05c5fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df66903d64771caf1d772a91de0ccd6bfa6e3171db2e20cf857b2403e6ab8019(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91db1090bb5d53b253a0a2e38d010e1dc402c3be6fa17ac499fe6e5ba25f25c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31738d8e5a0776325b200289a2f5cd9df39b1486741c350cdc057d4a5479b29f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381ab0065a24a2a75f998f1c6df4f2349f04101fd7313cfd25dd1985f197f36f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea81452e823439d2e52a768d8e2e94d19132f27f7118e81b741a62539048449e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7621a630a886ff256105fefc77fbc8fa23da93e7276ad354adc3a7b293e418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af49f9fc3b315ad4939c037a91d76cf857aa7b57182d140efddca951ed029ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277faa6df91610b0dbbfaa133cfe4e38de2b6780c04ec459472cd7b3f5bb51c9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb38f667bbd367c53bd60c88bcc8ef33713ace7082b4108292a525f66141059(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c67dbf1f17fbd0c84de159766c6071a2185cb8431ae2afd88627c4b3f3b7c8d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f91c25880de6443b2dcc0c89bf1f000dce009050783cd15ddd8146f197c384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8bdd8d3dc7312db08ff1f3eba69b2edd430f30412413e829891df0714bc555(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3621a1c90cd68a484cf453c1a4afafaa979496a963b3a29925dd8acda24d9d86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10aa0debc5a44c64faa6511a9434a5103d29d67460543f46752fed5e85176ee1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd39d1777c1be5680931fb2f88a69e21c8e20569fb3944db2b130a54067bc590(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f65794a86fac0713d5b2d3edbcfc0ea598f0a3892f38631d924486185cd508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d961729ff4b15b7ab92456f60ab785474897deac36dba0763f8dd095156e750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a61bd34d6380aa58ff0c805f113d697a2e30e60353d2965af0802ad6168a58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27462e703ab0ab4613d60ad8e1f6740ffed5ba6477c194aaeae8099a6f6b00da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e361dec3988eebb70803bbdda25d4a663b2c5a6d9096edc819f048850e686a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da4d8575c396825dde9bb3a004f76e7349570a166ad04f2fa0c4463ff4802705(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0ec9b10621cfdb93385439869c6b9de9b86d66f92546e4a90ce4732e3c956a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4793e2b0e9db5c2073b853fad4acdd7d4d1106f202cf9bc01a0a020831d9689(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a6d589443aecdceae9e5aa22640242511649f17982def159712a2b37bc2a6cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e9e50324636ac31a1c79ee9ab6004bfecc55d8ea801beb6a4939c5540e0241b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef638457e632dc3ee8e8635c066ab57d52f162deb9597f4207a3395dd484a25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649b1e38252630edeb0dfc3d84ac271fc932380abef3f4a6d8666463fe23b76d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72db974f3523ad0675f6ffeaf8749f14ba2b8c5c37d4235cfa78bb9fab874371(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938be56c2193bb269ee75c68d96c241e187bcda6b68eff2e379d0f30914608d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06200438acacf915c7fe8e648f9f024cefb2ed2f9587dc63a6f53bb852cfc3c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2105883f50aaf397400bd5af5e607ddd83c98618ed2ae5584994dcee71eef92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac5edc55bf615e71fda5b8353ff53d3c3862ab12c7f23fe3262eb6b04588a1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0442cd7b143c92b627d9e7b8d7714f0fd7d4045fdfc67a7a2656285bd75f0f49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a7b10b885868d48b68d89a9630224c4928cc1872f8df6733878445daed843d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d8985d54ec2b9d6ce1884c951135a18ad0e631684bd17ce0730bc4a8b0dc6d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167399258dedb2a107342151da1bd7f650aa737ce09f39d3f58966349fce7223(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2abc3867ae859c65349ba00b26e5de148ce0148cb61601456fe43b4595e5717(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92148be23510f3f08dda7b1636bf402da44e2c5c25aa229041bcbb75daaa979(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7cc3946728ba0827e1fccaf714dfb51c6a019f5a4f3096123cc8358452fe073(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8ad4a764a6c24c962c8cba608b03b1d6b520929e0a57ea9ab2db63ebc39ef4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bbed7684ac204c676809adb59cc6183da88b71240a620977e331be01d1b24f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb11c047addfd0838f1bc0d41e1d2970868ab0fe2eaf8595a1762edd032afde(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f9a9dc96b47ad0ef854dcb507998a04247f6a1557df571d9895241c2c937c7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2151977ca24f336d2ef84e8e6b07f9bf643eb819ef2d05fe65b0fe6a4400979d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc44d4fd1099eb97b315868e1d5f697a87669e257e86302c0a4286a664c13aec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115f17c6cf2ebba7eed714664e4648226453ed26c4662a544695c3a5fee2290c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb26f120a55cebb66f4a591bf64240d5b4ea905190a24a3d558c5acba64dc510(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3820c4a44ae69603aa0f384fb301cef42aeb6dfb0ab4327eb7a30229f14be5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a034540779bd13e7247ceeeb5eefbc84700028a81f0bc50c88306f298dcea4b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85683d73f3cf4447dd5420da946ec72b9bd6f13d4806fea0a7119a7ab73a6b2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e853d212d175852bda7d4c2fb8e4e55ddbf527b81c282d00e22686e8313620(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec53f222e9283fdff22ce70ed25ea8850f8dfc5dc9ee71fd2f170dbc6177c6e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d327e677669da33445fd903814bdd3530cc7c19de1f489d7b1669929388f45bb(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd2aadc244eaed3617ebd4f3949de4d41aa2820e6d09954b35bf1c786291f4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cd958517ee7ac36475d13ec2c34b4c555fb7fb51c16037e50124c7bd5ed932(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188b76b799a332721dd2fb615fea7b636721f72cd50c0d94cd9c2ee0a2567c4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73b307c0bb31f1ed933f8b09fb2aef379356eaba746d805bdfdcd471f538b7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1cb5eb00c051781e10f017b9004ebc0a121997b96eed41bdcdc8350871ee19(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af907a8ddaf001336fa47aa3ea53fa2644a9f057ce9fc99564872a2059852560(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0dfbabe22b5342defab95f5399f8d3e386e9462b400598abb8731979dc38d88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c653c949b9619cb1aafe57035309772a666a8c832a12539e90cf6096e5d55e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0dfe1652f25b260907aa08091ed7ecaca3dcae3ff95111b88184f43ba7f84a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278812f0b526b2e9948ba1413f7112847ee62e2beaee9d3123989eb3e34cfc13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf27b0a71da71ffd153ffd0f59215d82fccc7ed18ad84234564ec334f50f987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a766c6b02589c769695c77a10dbf09f20b7e84f4ebf06c5d0fd2b798552206d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a569f19bfd9483b114d1843087c654fe97b8e498aa7ab0cec97726b50ff05f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0611bdd0eba39bc8167567a8a56965a850a2173e83486a7b735f1460e2d397f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70715ed83d03101c1c25e5f19c137aa0a1fa945fba15ed1baea56691cf799d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd97e4d0c475a730c9cf868201a72466fdd514cbebd002546bf56d624109d6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ae7a91cbd0b429be0b320e14dbd9981e34491e9f92439fc18f39d867c77341(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1228c95db08234419caeb2bd3c262cfb7eee243f5001d428e7f3a1260b5aa6db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1969d13fd64bbb8c022020a279b6725bc5cfc22403b079f5abc023d46ecb4ee7(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e886522b783aa45b9946c77053abe2799072bf70a334c30dc1997b7a04733d8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5108ca022433d7968e6ef8eead024d091a8540cdcce58640342a809d150b597e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc93e0575c1c9028b3bdc9748b6c856141c51a5ffc6d6196922bab7df18b5ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd98d53a815d8da441e99aa44a18e0d9be45e7da422a001ca8c36c2bbad745d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023169f419c9bb2e8a20e39848db0ec90895cfe7dffb41887f31b00922194bdc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff57d6b76a880d0d6724205e8b0736ebca20864e0dc1040ed6eb36fe2b80cc84(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28557c3db6aa7bae47f84633b2c7fac2eabb091c272d0441ce3eae094d102cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989f0afd36746134caca1963bec889575550a2fd91f494c081d8016fd8dce411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a2b59059188c40e8dbc05af83cc9690db23702d2d03e78a21f592b2c23e4a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e199b03626d79f34d4616d5b0c5abf0bc1756f742f60d79a44d9a2d6609bee0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07c650a3c88e2c550137512384575897de0e58df952218ddaae96aa588a1de8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ddd3c59ef0d39fcf3bfde70674acb9131e7ff4f732c02e8049b882f17dd841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417cea497a67a37c4db062c6f78ae7e73b4249cb40433c5378480c64d59e2cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c321541677974f603311c8c4228a329e199975d74d3a635525943104990541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fc0dd18462fcf440c3f19bbafa358367543c67fa5a14ec70e643eb60fbf058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5908120ded42c19814ee5f5fbca974a587b645e862f6d27e2fadb7eca027684(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca52e19b662e814eacaced192ab98904bc97412f25cdea81f458b1561b9762d0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd56257e42c0b9a4b86c516ad58f3ae4cc429bae2277244f35a8f510afb97d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74f7fa9afe1a8b40e339ba11ee432390c8c18e91febb4ff753c3c93113ea7bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4efee9782cf806cd390ad0d852338777769a4b82738e258ccb46b3ad93a5578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__789091ca13e6cbc0c2e09cb1e2cf86302103042934b158cdd171a950337fb968(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67c8d6c4bc500861fd58474c05524dbb09fa80b34edbdec6d5361c870abf83e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__971885ee753799c89927a43211e4eddfe7de6b03173b85f7c164ef4f2d2fcd16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63c8f3009bd4e43955504a1c35acef0386eb0519f335cda3894ccbb005a9d8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0d2cad8c7d03744ec0c65d9ac19cb86f1937201548a7da82329f3cfce95292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14ea8d92e7dc54164d8f5274b09da975caea109e00f40aadc31724b144c94b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026973d2772ffb966f180dd1c0fb50a99c649f4fac467d9a9839c0be0f77730f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb0e3f14eb99f247091820df7e8bfe9bf32f5aed465c6d039fa6d3ffa66c1b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dce977a5c25f7e6be5e90b40d2ee1a873db5dd624c0a80870531d68e0b156c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4630708ac9b162f5a8408bb57d48a990e22cb29320f42d27fd56146aa7b7e527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62525513a8a41eb7790719be056d23b9d2401095bf5a24d98f756f8418fb5932(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6de2672901b98fa372cf6a8ad95a8325adf206e35d0d21b1b83271dcde6643(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f5b43294ba8fa58facc750a2020037bc9c1bacde2fd372e2e54c6dd66ba250(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d6e8bb67676a6b0edb473ab7f7cc8bfe7495476d4e4b99830167d5f01cee9f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e97e6c637cc7131f2b76d3f30cbad0fb07bd0a042e3a07bacf602e0bd560049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f5f424ced6fbe0fb09f9129b4648a23893b9b749bbe4f4f8109dbc757e2746(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facf67a7747d8ba835f0186c0bafc01d74843b04dd006e746688134b205da191(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02ac96bf7c3cbd7f7b99942e4c66ec18366a27619dbe570aadacb58ba6b8780(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a6278e8b92c9b5376ed4e8810f06fba36231f0c4017c86198b5da2a2c065de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ffb54044def6c067c762a9d2dfb74346866ea25a9417ef69b656e84dc69fe79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e0ca4a7b3bd516f948d2a97321ebadaa3225588af7b34ad38f53a745b8ea2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc1b78752ceeae2725a1fa82d61e6a2418e0d7970d4efc731148d5350f10957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20310ad3a797b5de7cc5b98322c1f5ef9cfdd93a33684ff8bad2cb1057456d55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba64f0f2dd1a353eb97f4e04b11ebdfc221ed5e8f3c4a6e6d09c581873857a91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912bc63b53c70c72bf2b633c36e9323c0ca9e85ac01fb354b00cde0c531ef83a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68605b3f4455ef2544102dcd509326a9e507ddb805f64eda9d7f60828d0e47dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__575e2594e61e7f10b88169ae738c5c6fbd0e06b99191b5853b6fc01611ac06d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07499489ae5ad5f620ac861a1397ef2ac900be5a625ae004c39b60b7b271780(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af49830ae65312e41f1c16121281dc9d370b68c10eb356c81afba583d6d519e(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46be3592e099f481140fbbe5ad5801522f2322f730c58ce51a48c10334ace844(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9171ae75b6a0258dfca90d4c915f862205fa2bfa82d6fc62869417d9242c4d11(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ee4c0134fd3dfe2e6cf9eea5b94a98d98008f495d46d4514a129207b3cd837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec15553836406ef851e872d606a7712d4165e6010e2b6b5238adf88d585af9c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a905554392a3daaee6066f304a4b5db8c42b2c4c5948cd95252f12b704a909(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a78bfe4902ce8177c344bfaaa34acc2910416ca0c049843e343e516e2484df2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fe371f6e863809db20d5392b2ccab8ab7e0b0df064eab0a741cdfb335292a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7369c90abf6d71f6ba736fb99d0e0823886f4a5159f35c640af340fc5fc69f10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd48266035b4365b84dd8c2b2d4a1c82c889f058001072213f6c6dc7bd55ace5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d702db53f261c7ef0413111e9c4492d554391f740e35491792f37aa7c96530(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4a07e2bda3d5d4637dfb1c871e9290a6f16d3542b5b1836b014324e43d0dbe(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232569b5240553b6f106b1dda435def22a236acfda683a369c376fd2363f6223(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd79f0eb35c021d26f66c0ba2e435bd4ba5d9d4f4acda747ebc924cde6a16bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcbb00cbd693df10506cfceac161808585e6ec613fc846358cc20c20ef63435d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7c588ccfba9daa11e5db119f0a93b748f1c77ab9eb878048ce68c61dd3e543(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032ec086c832bd89098264241a931b6934a8f127b6c787d2a0ae97058fac17ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1592172277168648ca81ba8ecc51f56697c8bf2b094cf3717f4797bd6d62e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2213b8c5978f25e5ad7080aafb9c7d4008564ada16dd6f32616507a28e237a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3450b32548f268053ca0ff579a081bcba869681a93ecebb26948abab1d3b0d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69aaf74bb564f623246264f1deb92a8f23284c81b3b53549b386210b9e2b79c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4ddfb36fe9bd1941ae1c05d26b2e2a100857c3f8dbc330a5cd8da1a84dfb58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e264a9483ecb0fd709462c0c3f71383d07842ed167becee214e5fe0cddadf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c582e54a0a648036a7cedb372f8c05e30884e1a9da59da2156ae54fefeb86a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f97a52054963d76a11bea3eafa1a00953b3216e642e644080e77981f71f727(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9caaf12103dd21abc28653509d0e9913c95d23f8f79246ba07301c5aa1ce78c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6750f739d09483e19682b858865831d9fd77da36b87821c6267bd6766153667d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0bb39cb6bf4d670ac8872836fc48a9202143c5da35bcb95ec6db1c2227db9da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e3227ebb33107ff2a98efd29b491f26d6ea90a0afb5f5290f99979e0896f2e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e67d11a9245ada45a89c231e2050b248377d5450cf80f59120992db1c799e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf38959acddd443a194f2fdb51c27829e7623db5fb68a9f857c3aba867b4f7a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b9679031256a67e2e8302ecd860a9d35895bb264ddb6d3af6fc457f5059740(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320815d177b5eb595721ab8163b295ed462b7f760d6aa92ac98d23271576fa86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b97a2336a14ab31d9d40677bb3be35ce3ce90cb24baaac1bfec29b6926344b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93769219be996fed81986f7cb6e00a6b7dcfae6a64adb39c3b1405bc3762aba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d8d56858bf670eec794e1b9eb629120ccc450ffb7e8899a0d1227518e30a1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f14a4647671b84e42f7070ac323d5d42f0a156c76571f951eba5bd1547bc139(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee699895a15e0cda6730ca5b83ae4b2040839488568192f1a545b7e94163657d(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88d7209b6028447a0a4a38059101ec048401033a2c95ba1e99b2d97281e1937(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2044c4b1947354f55e990cafb0ec07b960fa2f8514afce2cb8c7fa01e5076917(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443b96e594dc993e1b2b23a8e438712fcc4cbbfab503bfe045fe371cec20d412(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23637054fb904d23cf85db282d92125de1bf840885aa2f24d1832a6153a08048(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f88f843f9cfa669dbc9ecca3cdb67e5790ca9ba9479ddbc35f03d96ae5001594(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090f84d387b8017768aabdacb6feb39f2a83c40efd184ab2caf38b7ef60048e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88867f140d7f4ba83ea1d4be5c10f379a4668593ba82d31acb65d765a4afae3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23046336eb33e7b62f58e657236290b5837a88ce6fa28b85971927e152221d54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33461aa4848165564cf53cb86d1518b5decac181b0f3372dd0ae2557597b5782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6877269068d3a5da6d363451c6afe4f1a7efc2e056b158ab6044704318e690a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__457768eba25b82c044cd870ac13fd4b4fe77cdf4ef4a9349ebb0e71701602e3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65dd1c7b252477d56a1091f102213842dc6548fff89af543a952ba575f02b0a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df32db1ca49941fce5ba8af914e4e69af9e45c7a2b138172bf1a513225876e3(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e10d1cb54cda9529099b70a260b581e21b594100a478bc518ae234c994e867f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1c8fd8490da3b283dd79c2ed5ab2de99f0ca7663abfd67152f554bcf6092ca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c4e7e8306478707fb12f5a969b980a7a825bd7d60e009780e03160c81aec5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed38bff9e289f78afb0d7b29e646dd4eb5e1f5ce252d03143daeed0a5d6ca73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c0fc9ba6b66c02438e6ed0f0e67fd5b78a01b3cb96fd0068a5c391b52a3bcb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90d30a7684893bf6e5304cfb44d5917702b95d2b6980df8a751a3e491e6178b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841995af72e4ae4a186bd7de4aaf9273528a4acc352bbbeb51789e6d6b842375(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c85fe8c050d145c7c4f1abc855e16021ce9cd395c8dcc1b9e3b02f3d63ad92f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8476a246fc4ae3f7beea3dd5bf06b39ac4be813321d949a56e833a99beab7779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0e1a9f13b1d8767819654624fba3793c86502d961bbaa7d7ec7d7011200939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__318ccc84d5fdff34dbf8e17d1066a77dfb00916c731160cc3a148966a02f4b59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c7908543f520a1738499610ecc11f4dd852969078367adee9baf7035357906(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3cc5b686d95098683d32086a6d71d9722c2fb6874c34555e46124feac02010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__100b830868e97f531b53e3c3d769418d00eb1762ca3eea871a0b290c4bb7b7fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa9b59f9059bbe6fc7e53f078fb452118d88a0de7fbb653136d557fab54d79a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d6c02b2fa5ee7ddbf0aef4295345f22f57ff1589b1ff146ff96a39369f8108(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26066815583e5c00d45aaaf78f0e2d0b791abf85438ac31a75ff23f0fa8b5dc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4521466c56e6a6dcdae5e18a29de75d7a4d4dc531abca7d427be1c03830a4e2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d0474f273e03a550ac8d4251e168d31ce3b38fb5958a4f85881474cd16d240c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f88fe592b52802a978a32635cfa3632c817905afe91a51f601738bab2055628(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd17704ed834a18ba99563ce675a5a578714cc666db57f747e43d77171971b13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb8eee707733e1e286cb21f3d5ea3c62cd729ab8e8fb6c2f6dd368a784ece1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd7700c67e029f253f8ce391d344e64cf9d138516cdbd0105453451451e92791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d49919c3705347b0d34523ccd307a37cd2f181b2630caff8536c80094d6692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8d611b3e4ac76030c06ff285e35bf5794cb5ed760bbe4d6199761367d29da3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ca6d7e197511829e5ac583b4a860f94f92bad75dba59b003d2cd636e1565e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__802eebf776cef30d5c64b4dedbadb385ce619ebb04248a7a736196ffc42608c5(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1f87650842b54523bdca799e2430a99395b0e3bf6b96a8596b65f2b2b6d789(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ef1628e2ca72f315c2353d8a506d224ff7f58ad97d68aa12e1d7cccf8f2a4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7672b69930f4effd3bf5b86afe5a8bf326800014c4d05c9f10f5009765c23109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8afd94bac75ab475243278c386334978578a2c5e906c59ff0797c7e8ab8ac8e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a36d7c1247f7e69969ede938be807cd2f2c8d01973b5019969bcaf3975de1a5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaaae2de84da841de28c3bde533c00852f9afaa93e4ee0132646636962eea3de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245c8f336ae676a65459d7a633c93687b69d63f31bb6d8c7cf4b70425b5a2d1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb193e2c1dfe102ebce2ca73cd8a616afb5b75c389515a255c534fcbc0eb8ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2386e0cd274dae23f9034c3bdb4c3ff6546285cf7bb225b1a9299c973e241c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b304e531b46f19c6039f2dd777e2534da73324ba40883370325431e9d39cbe3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe51f4086a9532476b400ed78690d089af7be2428d04ba6f3a0505cc56d18f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597f47a6e69a7f26abd91b99f7a0ce4140158ba0a0b405b286a4d1654794ecb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a8325f32206ff1612a6fe3928767f787df51ea31c67e82aa949a98ef8e801e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f317678d9bc0c387cd1bc75d11fbf3f93afde60aa9d6de245acc66140d859e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f1546145078a3f602b9626590ece8f26c13770ac684509dc7c00c09cc66b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f4fc659723ce2c1818e13666bdee8996ac3d16d45db77e17877da6b41b2447(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33640f9e68e30787f9b375b3a5f654ff08949c1e3be72ba6ec9db140ae7981de(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f977bfe732b191f3084e76f5d515ebf474d17ef05735ac668f9fd9d3a2fd01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2048bdfab36adf18f588adc1095fd4dd925d4281d8ad4a73fbf7328100132c81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df0e3ca06c42c85547df93e4491b12f491c9d9d0ab2c52198b059419a24cd96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e38e1842167911361dc189a2af36ba6d65aff63ab0340d4598a8293932728230(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd86a06c70565dfd08d28570cc87aa61168148fbf039b728d7f822f528dea38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4ca2bb2337313435e5f6c6e3499d4a858f9b32f081d00c0f03b55d06e1d5af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8861ece979cc24b4540115a95a256d680eb63362dc8a8f7a3ffbc40a0bd0e9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e6c713afe494a0a599367b2a96a7538e9c9a762ed23ddbbe94ee8140255b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253f7dfc37b648402d16c482fb4d5389ffff04d68e284aac9666eedcc4169153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc852130a4a43a3371d67a334d453caa3f9015d475915b53cc3461f02fdd0cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90715de453de20b1d9851eba907c543d05b26f88b935b762bd91b0a63f7ae297(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c978361ae640207142ae2f2f0d987b182d82ce8ed2b01fc80840e951da26c70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1be7d832fc7394d85c7a1432a5c3bb10d6ad76a9fa0986d81a3c171ad59149(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78228aeab7f1eff6c72a1fdb45c2dbe283b31abc126af1398c854aebfac68985(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9c542eed56d30c358ffb8dd74c7c991e9c3361ddf961945a0fc44457b40adb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e97abaa1d61ddd33a8b980f60c24c04eaa3f75d523cfb30b1910bb326a9822f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd8c7d382a26e6df2c5b27c237305dd0b9c2a33c332d8e04b5432bb3cf4039d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d31f9a9d8f546716300758c0aa65297a761591203954361aa5e3d95b7e733587(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4987ce95f81873d0a9c245c3d2bdd6a1a849f1162b5bcabb3109c94ace6d3d33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8eb347ab17ff42521cf2886507d8de457544f1585c963f6a77f897e76b5324(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c0cc4226dd09d31af4a7c34c795d3565ba1215f33cdebdd4bf02a7d3bc1a9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e34b67db0bf907e9621d3a2e5615cf3791dba061ab90beb05c2775fb1635a1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b119ec13a042257aca7aef7e3bd5b1fbb24170493754ab3bbb033df11833a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b829e027c67b7023957e7eed1664c7cd4223f2e684e85ad719576b132cc580(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e44e373cc2f42f7698ccfa20e95037dc2c4c9e19f075484fd39c5742e1adc086(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f72fdc4eb62ec302ba5f737ffa9453670aa647d383ff7d14aca6d68be27200b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458446052805dc83a8934fac9c502bf638a255abdd569963aabc9371ec2c9c94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40575d2db031fba9dc92270281061da7b74fbaaf3cd2749519c4d21a5f124bcf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dcc798bed5afc908fd7091c0928dcae7868c1c8ff32c36d374a5085abeffed3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541e47588e05bcbecdd14f3ace203ecb135fb64d29d3ff4c7e60cea251117887(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d6224eed6367c2210e52d647130f1c8293ef1e13dabf3aa5c9ba08e06fc6a47(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325e59feb7bd4cae2663e71a0be6b1bc7d78780fc09e771d07f230b3be79cc53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62484bf3a4ba5224101049d601a9af00613f9d7913ec6b16d8e3d1aaa35dc0d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a93bf4fdd71f49c994056a0b9d39e9fc079c84b5b37943e471f2a10dd00c689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b697a86585c1c47ccaf6689de4ba50cdfa073e3cf4506ed020aaa9f52ef557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdba456e71da2b564e9ba6d150942f2683adf3b40dc77ad80fbaee27e92a7d85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0021e05b6b2e6efd51f0998665208fe04cd5822abbe64b8b40797bd7e89111(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fb9bcfdcc50ba34b8a376111a98fb914844ca195ecf42bae24a98b0358aff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fbef0be92918c27f6450c77b32c112bf6b2496bae2b07f8fbf7336a418e2d5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1aef9ec91cdbb636d4b1b1cfb7121ac2d0af23b69ebe51de05115096846faa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d7700b9b64321ff7ea9cdc6123cc75f82f80bed3782276bbb74469fec2b4c1(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1263f872530e7e440c019f619574cc2c68517dbefdc7dc3a473168b77af0f059(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d217c866cd45a0c0ed7308478761e54f94910e4b9a32a75f57d7c34fb886fa(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726fc4c519c27fdd6d0bf9dc0c4cf4f926c6a9b6992ad4f550558a14b35fe2f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2934c777fbceba03334e741c8688db67735680c1f40db8f5ab3661a2f94749d0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfa8d0266e7570ae831b8cc92098de899f3ec983c81822cb6dafff85d57952c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b8e51d0fb78391bc04d76da8e65c002489ab5e9fe35c5d90a13eb741395362(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5b0c0b73869547049dc15bc3ff4a34be8a38aa126aa0dd327643c408eda493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__922fc8e83c86ece53de442cc1cda41317288ab93fd69b3f05245f4555b07bd3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5390c64d6bb810bc197a068ea89368b478bffc474ace510d8089b46dafe88b9d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d77ab686e46b1d9a89b8c440b869258ffdf6734b67c031090a78aa597dd3ee8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceb1c0e84b7dad811e4daeaf24c887a098fe8e28d3b86ef9df7add52eda36d26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a2ca23962cc22dcb4f879cf0d283ce60f34db45bb40574163763cebedf8192(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238414cc15c5317207eb35a3a874a342e6625d89bf1b0db07ce14c32ff3e8c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899587ab1514c0fb22460c1ea57cf9d3dd967f15854548d98556fa16059ea4d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c6ed2694f89623ac81aec166b08635be065000114f0898f404bcae45d4b8a0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecee88be38930571adfa242cd9ff7fbed116a82ae64d962ae0e84a605979b4eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9e850891eee8eaebb7e28184d2e78892e7023695777cd30846b0641baa6e2dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce9511b1e14dfa12ad7d19cf70bb87644d3c2c0b607c695d0cb0326665f693d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9b269407a10a6621077311a74ae385340c572203f05d2440a143d378742e52(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef946c0058867cc393e75c77509dbda90d7254d5daa36fb302c69a36e683922(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9e987dbc3c047407637d7d7227198c3916e08ef8b67cb8be7542fdb1153707(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d4ec8eacd6acdf4a4874791441134433a31e532345594a2b32366e93d88047(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c603b85ff0044ee9c279f9c655abe193307013b965c4de9e4a405d5deb109ca1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1990d9ac694c6fcd20b7db9e09c7699225e52eab337f6df405e97a74eeb3e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a178181f5465bbbbfd976e9fbb86d6870eb97f990f8bc5bf4dc6b6868ae985d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72f7ed4d64826b6a162adadd9ce3ee304c5cc2d9956c4c90bb014d03347213a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e0672a56e0e4dd820b314e469d4b35454364f70308f7a66d4e49f2cc634ddb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1995fb43d87feaa9e9244ae9c61cb78333abf16050cd8feef1a58cf85a3fe50a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35dbbd3f4210f40baf7f82cb48b6147d538d92eaa5f8cab61e4b18f6f5708f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0f9bc2963948f318a86d2d4560f84139fb6491a58347cc305d90a47bfcfa23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de33a989daa7a6e3ecbfd1a735ae689be80d683a4629d7022c487e3f4b85ed9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d691a419c59372401219dbc04e619cd812a607672364ff0b92fc3e88a3a185cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f4c410a096f374f67dc16a00838123f08adc18c93b9aa9936ea0d6028d24cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e34f2eec7cdf745230adda70eeb90ac5094a78272cea614b4e685214d0b4b99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d29a9f178890721d3c383dd30028d7f90bef445aaef1316acaf3dbf4960a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b80750595298897a3ae25755d9d0237f24849af87fa0b948e8f226451bd4aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e3a84f14a0bf361877ad83ce3673743bca84ed527651bc4021575384764f3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd3d60f1f574d640b52d48e92178d9f769281deb45bd57df52c0d69d4b1cde3(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e3e008654d8fa83d13cbcd28393a5f16f3d540d84eb7e77a55f02b3b9f61a95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b81d6b6b615cfe50d2ccb46320e3afe61cced62b3091e35afa7a7d5b0058092(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e072a43cba239731b77e07b7fdec3af6bc3f188019288d63b89bd422982a482(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43ba28c0cb1b6447d61917fa3e369c72897fef28852430129cc9e63fba4bab7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6495565e83216aa3a0362875b0823f2ec4c22f2aaadaa6896016414b1e250efb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4192fe2a347a977666d4566c2fa769cd9654580c8cc6e14315a25fe3a17d553(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1542e90536e7efce436cdd6591512e439dd5ccce25add232bb4b09e33cb4d82f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40a247c590c3379bcf4487fe994f5135679ccc73581df7c22e2aa9548fb8ccc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3823ae3d3ecc96ea05b0ff9c9a6b18c0a57e7b9114e89b93e65bf5b80becd896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de2141014e6eaf3373d42608aec13abb6360d529432795d9e75d9fce1b680a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62fb8fbc8f2e64039432490f8c64faab18b5f3de3d34634ac8994d06712215c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50041ed43b5a6722d5d301530dbea6db057408ecb57fb09733d09012b824d6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bf0550aa02b30e50ab7241b7547a98ce4405fdbec56c8dcc31dc03679c42aac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45882d2085ccaf4d21d92a5a3b45527b7111e43aa38e27624260bc5f729b72fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3af3fef54fd3d215d28f0dfdc0489606f03843a4f546f233933c0ff853dcf2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260119bb052b27b0ecdde1d954a3a143f6e8111491ac36c9f255c3ca30ef45f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e029138fb2ff0a9ee757610c4d33cd2edbc3a3105e3f5b36bb8d51f97b076d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946891b6cc4feea0cf2555e1151a0e33c76500dde23a500b3d86840f4c8b7811(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0d5e9d106203adbdaa63893955a19d76b5dc8daa28cf172b77ddb05ee3eead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b1ef942100718e935ecc71c2d585e56629dff47ace84ec6c644f15357231d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e41c5541d7a226533eb73bc9242de4e4ca1d5204c8f64aaf393aa251b480bed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae96c2078cdeee9eb0b960fc1f37b3d44a553b216c6f9294cdfe02d02e80da7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeeb2d559191002f9d6460247f93ff1c793271f89d96065530e099f0293f3976(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08acd902c65501ad6dc5d5d4a0939a0b82c3ff938ff9b22523ad31e0cc7e1c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab94f39dbeedc1684a4ccb9bcc94bbc02be1c6f487ba12ecdf9951fe20dac8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8318369fd63e0441d85afdf32626ac7a17d1a168492b8098e03dcd999b8408(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91cc0fd9a40188fe41e18b8373627825483fae97063178f6359fa0470af4c65(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d55ee42112036afcfe6c5fea8ffa29b61920be331958d7bcac69ade0451da83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93e3f27261ab26459b14d6f481a1ef2de65d756c64b10237e04f8e74a783e77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e3350239d3e0a6e467298186b2cb42ff6e84963e5b21c40c268c88767e4796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e4f994020a7778c2e3ccf4e4da01d54e7b658905a6172d3db877f52bd84b5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da02f56884aad708789c194b8eb0493ba3795878066691844b923fb555c73ad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336c2b8efff4b6aec28b56dc3920ef0b46e5b12f5363e2206c0822b6b190d5ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b3fa8dbe1a88c79d77d6966189dfb27b38246bfd9c19a6d52d61b43aeb49ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f23f2fc70a4376e71256b3ea88b2ce7a37ac45cb255562021d363d0befaa0be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723de178ac53bad9babfbe735c6ce925523503e1ef1f68f26e605c03893f127e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e5652c47ed4ec0d953e00faa483ec0c248e6480caefdb9a10c1d123bf3bf39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7598aa09924a66f458c63423088d24802a132019c1870479fb937bcf5c1010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b1b35aa4b28c74c8723381345b3d4e03c0bc4abafc651749240f6dd022e3b98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6619d01714999fac802f9d985261619a6df6c6bd4a862a61dfdc22ecd49e3642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc320b0bc68038e7525e7a2e7533c338fb117173f2651f9b17e8b1dd720860b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19c4e9c25cac98b287803f14cff23284ea4b76b84e84588e088dbdc5423123b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e26958f1e72fca7b2217bffb795176fedd97d7ede0cd718db031326cc657df5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04aa886a0b55b210f4d906795c7988d511a973a2bb9ab477d413eba2cce2645f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__233aacb24ca19ef88ee2307b75ab1478b894bf8ee36f03fb50a0976dbd46c5a6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26709074b9f05af384ff3bdb2594f22ed4383f9144d7290ffb6b216872ab0cb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ec6b44ad4b75c43bb5c49b2402295bf5417fefbb86863c7121494b763c60ce(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c20487ecfdebc885bef47e02c18bee8261b22df5ac883aac30c7ba1db44ad78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddc68e74ae07c0281a3299d1276150bcf00b083bd0d0e55ab3d29e44731f6de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32790f7d8a809f375ad2efc8708f9a685216bd11bcd31ccfe7674e4f41438fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb1259a10108ad56aadd7d12c2dd7a43cc9d6c7e67fff1954c0ef4d009e7201(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33fe2e94cae44e8947cd32d887fd4df4c0770dedac8ccc629658a8e626ac76f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5238f9f786d3626ffe36279a4b1f9cdcfc93e32df17fdbaa0ca5a857c88f668b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7676390dd6af9e5a226d734599d023be75e40cccb4541569e99f1cd881893104(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b81854219fefdff0bae0fbc574915d55ea44693aeb53a4d2c2d8da96bd260f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70820f5a7ae0dbe71dd68305f61bbccccd4c0099dbd2adde85024888accb8e11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6811f5273fdfb6d59dc6aaddd9f295535a4221622d1bb4f044005228c6bde2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a519deedeb1d3980f5f05b5681f07a1d1128d65f71dc35d7c76d863d8716b18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0733df05189c346d41d8342af4904320ec88936bc8aab84bd05d055078771ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05361a76eb3778b407adc97cf39f4db7c1abaccec903b2f66746713b4852c083(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa594999e81a704bf1170ca0ed18817aaad421643bb18482b82fc5b4a06ff25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753408a2a91b21e878ca755c5b8b141ea7603bbc119fa93c1400c6fd754bc2d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46475251af4b119ee20c3c231cfad7de5627d82f1a904fbf1ecbc1edfc4e26d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7fc29496c39d5b895f4bdd35b56316449582109337703b6387c3a95e0b2a51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ba0b587e9c76b22dd1b2c3dc48c78b77d3a8da9ca3ea7861ae9d981f96e59d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53051af5478f2474de67eeef21c4ff12d5bb03fd93bc838d82f48ab87a6e6240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9201c14c3fe74a3c2e33ae8ba79796fe4d554358936a3aa384cdd7b6f2e5f379(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acde1ab4b67ba060711df2c26c1ec6464ec11f42fffa6788098441eb07638fe(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c093d256489bd57b09b1c7a5952763338af62b6abbaee717311b07bf191b1ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac79cd2e5b1d27efbea67479caaa5ab7905611ffa6ed595a851a85aaabadd04(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0702a6055612fd23a7056490eb9a89b8a123a7404cd4fc8e7ec1387596da89d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c28e05a8e060077276b1db6432098770c5124a2b55d23a6a11df5c9400d56ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acfd7957a7472f5d3bc44356b0c346e99bf968c5df789117e3b7c21a354a959(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd29c8e25eb68471ec7d92d5a850a178c15b6997d22eda2e48e292870f8e9ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e4ceffd8aa319296c2000133362b5efc13241b68af34115d9487e3bdc91ddf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f7466b964985dc2e2b98dde5426d853b74c6964002f0df7a578320dc76be6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc79a7630d735ddec127b06d8d26433b3b2f0ee5faf7b45552225daa0a891de6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c24887ef7be7447c9a262104cb531bea47410e1a6aad6a589becd12e735c5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc81335e596d057e1e423acc7dac899cf1f849de1afbd05dc41b293d3e6d6c43(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27aade4770f2a7262be013b896f69f2fe733a52e8285c2444b66e2de69613c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700ba1ff28198fb4de84967e73c38af0a4750f174bc935f6443da0cbb11209a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6531b685985c2f8ea584707f61b254e292cd49bf3f525febb3c7f82d054724e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c3382e9c4503737008972ee0e37eb87943660525985e20e56e2ea7a0884bf9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b655bc08f6c7d4f385df923b005842ffc099f4090368449125c6197e56e83da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485731565b98033a4e1bdecdbcda48bba1ca761115a02c0fe0072d0cfdf30389(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54f5e09d4c91c155c74d76cd9197ee67ec61b8bb4eacf558e0fb40c21237012d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60098e12c52f3d1a063de466c29a42d66f384ef2f0b26058bbd30ba30915e8b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3981bf4e80a52232c379b7ae879260c700763d476cb191fa407a2e2d9c966e44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff1fe8300338bf67352af0f715be971c1c56c68b1e8ccc0383578c98669e6db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13eab5f7ff3b26f9dade9a337be7eda79e8d46916a951f8b66181693090d288(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f83ff9a331d49f8d1d76efcd8a6a0cc7b943b889dc30bc6a3d7f73e287f19255(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556344f29a83fcb077dc19572a39b97359063eae2f8900a96e0ef4d9dd24e89a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93b9242a4389c06f280272b630574dd959f5b0e662c4568d88c2fa532d1961e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddf5cb3b328e5305727fe937a27d482377a53bb158cea895a6d7d01a8febc7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b152c57e916ecf7f283680fbfdbd3490e9a246ba4662765dcf0ed86c4f693f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5152c4f60d25074d10efae7a9154cc07f4ea914b2dca2c39500e5ba68e3b6b59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3085f62db2b1fc0182ab43f7047e1e7a4b9c61c13ee9d906be1352e0ed2d80b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcab59cd3d00ab58b92b3477ab26916431c64dec99082aff9d31a5974fba9f47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9002e182bb43888e6636033bc1a788ee14cec472bf77622ee7731570a02053(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1902d264d2c0a9a8e33ecbcf5611926d76a12d3eccb3ebec20a11dd210fc2556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a956391992d346b55307f1f1cd9a3ed62cbbeffa595bf171f3aef1680b3a440a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3108277a1fb890b978ec73f1594a326f3b1df4c596ad2aa1067bbf2580547612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e87384876e2f74d12623a489e7275ec6988e506f414aeaefd905f5689a6004(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b38ee34fae66b8c12a1a7474298baeac12b267b2537a758ee46764ac1a0df3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0deffc195b2d17a6c4512e0f850169cd01dff6ee576c82baed541b6530d1c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2c0cffbd46eee0c7d0c3c6ee477cb13ce391aac4410da9a246a84ccae82356(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fc60729f00de9cb4e739fb9a9456c9b0d169b149914474ea628b90b5313cb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8f31e81b69a11d81ddc2ac5b68cf4fb113d14310e2da2ab1134f6f9beb213c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1bc1e2e7d3f4006b98fc49085aeb647345b94947538c847b8e2b81a5274dc02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c9a2e56c67affda25d77a0eba9b6e7c28b8259b36231329f966f91142e7f2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbdd428004ba8118c6344497960eddfb158ffef6029c995b96521ece19c92ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc671de2595efb74f7965e2d251dad0d55ac363555e328c205e87ce7178227c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35b11b7cb77c6a17c9c551750b5d5587eeeda17d28fb9fe0a34920bbc61bb4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aaa8ff2659c5d13b7aa03b687e86912300afbfecccd771cfc45728659b8b28e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d283b7f6b16bb7870dcf55d320d4c9f47e0f9849aa0ace666caff7ce1338c425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328e1fb2a160b02d95fbc9b38e0d7cc9012bf439fe375939b0de11804c3b6833(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d308aa335681090bc3b3a871aa12fe0d311a9c8452789b4b0a352fe05279d2ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce929a00f23a0ba1ad0de1fdf25add60f8a577e9df44f88d28e0ec05a7c2f402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d87a1ba52098b0d0d1767b72e7482d1260d4b4706c049694b7c944fdb6051cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fddc320f9e3ca6f239bc5512d6ce8d66d07b1a2703ca0e87fc33fbd861977ae(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16231f4a2fb6c96a97b4dbc50f6573fc0161c0c79cb26c9989f1c82902feea0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98f28c61baae76686d5dacc63660754c4aa230001829d70d837f1d14323f428(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1de4e756860ee79990353a21f0160ef2219c2d496ba3ade9da19975d1e22be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb001c4e4c9d4fed8987c53619241064b7c764fa5bc17f081331a2b9307968e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6954334911daf92db20895addde081b1068ae63a124271349617669f9c4e821(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aff1721a9c2e8011427656751bef6d2d9da2b8cbd014a2520e26cf8004a8bf4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162a6df9eb32b7c4b5f136096a12ddd0ed13d0075dd41fc1730c94eb3b29d0e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36330cea25ea8de74ce3b561b175a63f5b4236f95b1d06615c585a6ff49b6717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db717c6b8ed3083b734d51f36f2a0d4922b6fe34f5a08be132c2c762bf7853b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d3bb261967a1ec3822356faf5f5373958b995b0146a09dc808906facda6819(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaa1090426e61c11235808f4e164066115b956d2561d6ccaf31d76e950c8469(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ac26f7c5a5dc177ca83e36bdc477c148d82327f8ce4e5b0206dbc662b2c4f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f23fb6f774d67c2138da1c6dacde24d114b01083151bb6b44b5b5c8004091e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b291fdf18e6ebd90e91051148bbcb1dcfa18d76ac56272c83db03aa5862ab6f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88f87992e0a11338f2f539f760d30cfdd4d7f42b1d6c3ecadcc6dfe1e992466(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdebe5e63dba6256f978ad8b5c6c0082b2e1a0729b3a0996416c4f94dbc9ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7575345fefb355bb21867d168f222968b4877bb5a56f280a02e065011de939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d218523d3330bcb974ec6df84fbd10a94de5cb7a1a9f606f5adeb0f010b37d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80970fef85d3c53ff5c92c54c6b3322bd94e206cf7bba41c9e8269fb3e628c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1d42b44e6d0aa476adf6449d42b04678901d32c9d8bd5e46c3ca5c65ff0d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f4a3fd8e797db94167e4e65a725346c28dbea0073904ed93e1e6f881009da4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e707fb201d2c819b5c7630b7295e3d14eced2a2dc219b67debd6b8aae5c0a9ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90aa8a4b3e1994714ea78712bffaf37d3450bf21bdff6bedf03e336d6bc0a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1412f190b4f468892756e839873f664df03e3aef22e2a2c997290378bd9423af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39039c2d0e408f28c1b490073c6ea3ab5dab470f5ec6f9335958bffe5f5df7a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df83e4a0c2bc3e9820b87b281904474f1b1dfdb0b15c97e3dd96eb77a04b799f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace86bfc407e9d0a7cee953373f4ae1a0159d11386ffd2f812329ab870f7183a(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb37bd98395b60e6440b0c0b497b59b7899f233fcc2e78127c02edb0e5ddff6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71147285e4de4cc083381aa0966f54a9e6d85c6c93d4cb23e1eed9def4ecf31(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc7f5949a2903659f4c18cfa180cba083399b059d247673d1222fc22016d046a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8c719a74cb242d71042798ec301a0853aa5436e58174d6b294670ba96daef2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36fd0e0b05a02aa6dcdb159937653a23454e1271e9e601b0735a2176c141253(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120b70e7772da4c324653773ea99aa3ef4dd2a8ad716886487fe3f473a6e56b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf532ea89ac0ec4da246afa18aa22b0d9214ba5f5a5705668896d3da1394aa2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f3e45bf9063d012e0d708cd45d44f8dc65adde5248845d9200d48a7c982a038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41f8594c6238a5746e0817d16bbcfb46938f940d60693f561e04cc539e41455(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a63e10229cd4de7b878098b14c8ba8060e1ff8e8f1d30416833cdc82a0f3675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d060482cefb1e0bb35add431efeee44d09cacc6f20f3426b26f73cf98841da3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aabea596b27ad1c0ebd558b362c43d81f1b2d0e1363d51aad1bb92493b7ed2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b753c348ffcd2867542f7b65203f3f925d572e48b7dca4c1b630859135036b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4faab0fe8e53ecc44bef8277efcd5adb46f6b4f3d3f1c44d9e4da91fcea5227d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81ed55f720ce9742cd9011f66173aa347da31dd19fd8fa35a2a2f0a180c47ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a110ef517b2fde4623dd0bf50d63efd5bba893ce2a9dcb713a3fc5090b603f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e35a7a8d7edb8e36bd02c9a2e922b62dbe2060a3b80b6aec47b1c941ff7c5f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b769918c2b6ba4ae7eb5c056fc410a803050254c3131f72b94ae25969fa39a1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21657636637a81db1893bd80c060d53d11eb625bc004d6e5946da70d2df39faf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67aaba687b2410589fde44a234dd5840352aedacc178ac0039b5363b77c2986b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a04b077e356ebd25c547867033d52c9c4094bfafd8db74167320a7096778f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ae72e4cf6d34f659b506ab4530e9341e4020427aa693a96207c2940e703740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb50f33259ffc186e54ce15835340db19b3dffbcac743bd4bb0eb0d0322f965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad07a16f03726b3997b43401b6637a7424fba59942cd8a3f4ce0eb258cf93a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c6816fb7b9cf11be983716708df3f31af1317b3166ed35365bea273585c773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e90539319ed410ea072d72cd632011fb36d6072d4fd29f8f6611d65e22835a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dced1267807b8882d9621f52e2e669f807f281871157c67c682b551c99829d61(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8cf0695537d0c5bc87c0c6ba576098e3513e4ffdf60ad57d21f35e89abc361(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5b3f0b7fbf85b7777d9837c92689fb7ba2724b85b042497a35334349a2adb8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66641a593e94b1513136ac39ef72d8baafa340a92e83883c4b957b12b19961e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d86137544d80ea93b6bd28be903e61eaa25346ae83718550aea73d3c3a586b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60b1f5c0455878012c9ff41cfe759e2c5ba22da41707fd8bf01adf96ff238ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05840dbb0a2c12ec2eb03764f80106ffa5367594057961f9ebb1d7fa859f2de(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c7e8c75efb50595627ea26544315fe0ffe1be0330c1aa1532d51d793e7eefe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ebe2a777bc43233915b62b593fc3d428631f40fffd97fabee577dd8ab72f8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828b2d076c72677faf52cca1956d509551dbd410862a814295212e5ae8e472ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9270931a3d3f237b6f2f0809d312b2ffd3038ae899ffa7f7b5eb4a462183e4f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0b0f9258155121f098b813fefee7786e7579e7046c7101790e93e16067fb37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7a6d897f4d1d412e77da98e6d4cacd17bc3f4eff2f123a528c8be23f1d8ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d779002a92685a1a2d1f8e46153f1b336f9d57c5c456ac678b5378006a4a68a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca47af2489727a69b9421453de384744e9850fe5db7589e10c20d79652a62e94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867459ab42fd85d79305ef55124a9b684ea706261d458242c5841e94da360961(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5552b0a4edd347195f0d532cf5bf7ccc37aa6b213f959efe1db020c072407a69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac61c864d59d8492f7c58cf4a369eba3cd5af41e5049b946dddd27de5c3eee8c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70b498faf7f7275ccd2240e3f7e86200e2749b6732abf74531f3825fc75ad99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df2d64b3c385923e7e88ae6b0597cd84603be732cd5120c16d9604c362dcd63(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9768e228d31f5716703d12cc19c3f66ff40fe6e9a1c472e2692f881365b79d6e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e7cd4be1013929b50b529e94aa675ac7d1625eea335b8007fdacea5f9cc8f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bfcf169cea7edcd44cb4fbe2fe206152596c0353106f4091fbf4f459b7a2494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a816f0a98cf33bb10c7cf5002ba60df43bb65a293a5a443b7d71345431746a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd17daf240dc38c55d7ce6506e085ea1b80eb0b91a74b1e896ed1e038959d3dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a9bd926a8e387af93f8fff27d8788c57f66fc7d74c2416fb1b103ca4e33859(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107a1fcd496ab802721f5fc7a719a920c42d29880995e765bdb42c85bd0c3b32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0adcbd17f937a6963c5345187ee8cf6964a9f9ab86d48c1421ff58318cbf567(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb1de145913a817a31fdc6bc84d6692c5171a2bc60a1b9820761e78b63a7eb71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11816f7e968c4eaa06dbc8a7f3607dd6820da4da2c289c92a8ed0a8a3debc2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc27bbe9f3f95bf8fc10cf4f6a38cbf8f93c245c88c8da3b40f92168d49a526b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b448770f299d0e82eae579a44eb54b04f8d93d561bc41c3f2cba5e7866c48753(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c49c048bd4c185f7a57eb646da1a04761713dd9dcd9a73e3f6459c77b91676(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca17946341a742765edb9e2074a93314d45a44c8ae2bc8bd1b0f3c2033ee0a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ad4502abf0bffae889d14720674032a973967190ac466eadca4eeaf17e2a42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9dbdbbd48866d6c29d713dfb4c28e2ded7550429cccdb7878a1ddb90bc861d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c2161590718a74f4b194c30395a0e18593f292983868e5a726793144850aa9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19b02bc1c4d857413075d613fd3aa8812d9ac24b3487c93429d4d8805b12c4e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3b36ae74acbda6c723b1633bd97a5c2f35ff08647c58228ec5aeeef392f26a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e3a580a9d9eca0765a2ffc42223585adeab83c1305d4616a6c0f9a458b49b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6512eccef7cb714ef55ee902005e73019f358de9d70a501becb2249bfe6796b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a7d5fd34c508f734f977511fc3da06ca456724358e907b1fb9306fb80f74cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abcba1954a4856feff2a09b5563395cb910227677a58dd1d6b503075826ae274(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883b8fce6e33bc637ab9688ac2e45a1548c05e3f1e408cc9a753c8630ef66a37(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc83cb4a15330bfc4d5bd68723a260616c837c491e1cd5a41e5c8406f28e01e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e27cdab5d25c455fc8ce571e1864f9aa41cd174c3e7accbd687615f64f3a8cc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17fd073658de09fa574f9cb31692e4ab39cad734c6b7f956ffc7334b25ae2c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe87cb1fabc26cb5e1fc17a755f2b4cfe1f605c620930d43392cdc792b603ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e30fffda31a55b11a0d5e58c7fd55c23160baecaf2fce644cb2933c52c01e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e840ca16c08e49e7847f080a01e648231195f9fc84d6ef402c4254ba9a98c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89c03afaf2a9d98bc0cd012f65e0cdecd4448c745b75c7a90f479a295e6d79d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dd6389eafdfe1ffd42cd1d62357fab9c4ef75cc66c53a10c44dd9866bbe8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c058ca376635fea5d05683cc4e7eaebb3e78d995b5ffcdc06b958e58e0cec01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbb08e24e36d74dae9db5412513b519182cee0a964518ba0f0fde9197acc3b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa195dc7c8b4a94fd791e8eba8341934bfe46961e1a9a264927ea6aa88e9c03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ac24035df3a38352dbc8ccaa339908b3f1bc22d0d2d7901031da981ae2b9f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc53bfa352aa9988e69f16cd6462952b75e25d8b96a49ca802478037fb943071(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065a12e8e7c18f2055b45383dcebcc4fb0b736750dde0b26475a351f452a0230(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f12b9891874a0f47fb7c40261129e08363e12fb22ed838c2502dec430354ce(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0220776437c0fe8516cae2f4abc22437b7ff9e76bb354174d9d55976933c04ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d6cbcf2942610e11ce2711374eb049c11ec64f11c42bf956b29f479416d65f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b968b7dfcb90012969ce0b393c85b4b2bf553c8bba567736b337e356c2e4873c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298daeb76572247e0881d8b29d61c2202510098fc8f368d8b83c576205112974(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18774512168c31741ddff796d84041852ff708cb158dd75bf08a7e10b0359f28(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5c179a5063a8d6cecd2d553e899ccdb2dc7ddf0043f31f14bb5763a86780d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7d072b5d4ab40c17487edb69f7618b5bce99a1fcb781b41520e5e8e45c5abc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53ccbf69960644db4b3fdf3aa36fc0d8b8dac31f9f8446d557834414a1f4ff1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e320ed50939d1ea1c21ea94095f76af6bec8260f83eed1fc8cdcfd97e093f25f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2256bd0e0c5b246967dc83082c7e2457f1f749686f2642a919926ea843e31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459fadb776fb1a5094560589a4dad5d67a9c82d663a0420b5800cfa0ff9e7fbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed4f6534b1dbd89a716d0573c0df0701d35299a20c68303773bb20178aaafdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d23be72e92b715f40d7256518d1a8465c8d0b8b69483fb4243c48c41293a3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291db8242e58af893886aab7e5ed6d03565929b8abdb4f59d27510d513251d8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c81d10c7cf7c129a6de824ee1e6d2a8c05161b1c6520f05a7970e405020e59(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5219cb34ace675d929997763a581c817fd984ff05888cbe14ad29257b2cec33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd09d02b708aa602b368c76208b5ce33242d59892b5bf93b227d909302cf85ce(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5bbb055dbec6f446bc8ce38416cc7add652b02e4e8872dc8eeee0eead1d2c00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724055dcbdf1f27d13592bb64ce7782bd06ed27285939c3345b794f8f16f6e0c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715c51c4ace2200445fa6718f21e21b442c408c1a2b41328c6eae198070226d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafb5e8338fd49a2ee4c4d4a6cdb0331fb7355691305385e752ac20f28457876(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1098481db307437707c941ea29e7d07a430689384604159122abd4de30e514(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2547471b28d81d1599ff218337f0f2719992d828c2f248344934f2898021d818(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf81afbdec6cdbadf294c94e82c26b3ecb7fea6f80a93cfc9456f7072c279cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8f5452ad253fdec6439a4cf9f94a41d0953a188fc38ee542d70e2a1996d9e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95631384765bf907f97519ecdbe181aa4a9985725db85226062888ef978ef007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0728eea6c6d70e556ed5995e32005c93b23cc40d80dff582bea43bbf1c7db4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c0e7a3e2a52006fe77895199255dcb7bf5d52e56280402cbbbea917fd6d11b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1566ca65791ac01fdef753fe836654111f4d3d61da49909ee3b050daec2dd8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7730d32338fbc4a2cea1e3bb70657d8bc4688f13e7c69af398c5249813a87ffa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127dc3f71bb887debfdeb2446be42399d6d0066d1a257897367fddc8a8b5a715(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebbe9d847cebd21438d743229bf9483bda0f58a110ce2fed6861d3395e145204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f672d2b05e9a0e8cda4207a72cb24f6150df20b14fd198d1891f430d860e7c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4409a46fd1479c0ade0ff93178ef533796b8aa0af94ee419a97cc00fe4e316bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957014a93945f03341cfbc86f01e7c38418cb0dfe5638fdfe6a9f952398867fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8ef69acd1a48bc2b3a94f94c166a3636141fb0e222b5cb0b9a39bc531f1489(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488269e2c6aa7a003b43dc472a11cc6cecf4749e890e17455b9951766fef9cdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee5bce788e8914a74a1c5a381b467bd8e709b969ddc4823b77b9fec7caf9cd0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44355f9c08a3940ddc22d825ec4fe070b7a9f219bee827676cd384adb4f8f891(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505d1557049648b4594252774d22800b16f13e767601bb1c59f3b8fc6a68fb91(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8585c1d20de16b1fd602a7b7f34856f7122dc515521e1b3f4e6d84809c79abe8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c0a0f665c97bffaf2df036dbeafdcb97c5b28115bb0266c3838a3371ab1f039(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4de557ac6c5baf9a7f648fe873be1926f37e50f0796a5edd087a46aeccea62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219ff76953ceabd403f26db300b35b76afd4d5c26c7b42f2de7ca6acb8d774f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9b5d42b084219e433c0a4aba972c9f38f200920519de77d3cb054cbb5845f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311f87e0b08639d3a392a8b934b2ba6caa1b43d4f7ea433ee9b036c18bd22761(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d80cd058a112a1e8a3b4d4101442b40310a76ad8427e4ea87f9d6c65b727ab1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d9674abaec19531bd410b5cf1745d013b372923f48b9e7d465160af03df46e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f46b4b323a3b321a244df48e0dbfc3e391736d63fb0e1eecdc39156f38ab3e88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba11b1d25c3558ade55bbc82d3d96efea48d271b0dadf2809457b1d5870259b2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965c7040833b56ec56a03cd048d96d461256a742f18feb709ad61c9a2044d5d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8cd2da8dbff3e0a87aea3e6010dbdab2f8464b0f2e4c386646e39f52bc0ee5b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04690a43bba53c844ff54bcecaa745a0b1f8952b195d7d32ff8201b43550f229(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bbe109354a3e95ab462ca04dbbc464ddb26417a6b6951b753e6ed892f1092f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f102655941c493131270ae92f43961b9373206db0952edd327449683930b2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2adf11f920cd2807b3399aa744eb67ab36cf5b1fa51a8afed72feb47a4e5e80f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ada6f8581adfed78bcb396a7935b246cc53cd846f47412069796886e7f92ea4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8576ef734156c2a7850d398f9365255a15b7f10611576559df77f71df3698748(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c666ba877e14397ff703fb08f61e07fcb6212e701856c99681f504aa5946f9fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807dddc670398dc844e31cd3743a89f3af4030398aa0b86db90503181b046000(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2d78cb1e86a6a68f56fb1b7a7b85a167b6c371f8504c259b482ccdeb42af35(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b9adc0221beb1cac6d660c6d3a01930165c978e14091118ebd9a7d4ce17f85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942f357184a76281e0f10b740b7f38ab1b73f09e98c72d499b632b335079ee2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f44ad4958be2e1d6d0dee64adb715354f21ad2ba879f86f8bb2d9c033654aa(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e5c85a246f1b21b901d24ff21ed8ac7670f134681e238d8c9d46662176939a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f7327cee15c1bf1f794f6625982a1dbf9a554b88bb43017ddd506d048d005f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7e9c4bea51f4287e85c32ff606d0e111576eb1707cd90b03c99a9f858d9bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e4fb805da65fd28c9d33ceb7f8f435082a7f913dfd36838fe6c5cbaa1e35ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48959892f946ed804015ad4176ea72b8b7889ec5bddb3da998d11d71441e8b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8320b06aba20840014e34f1f2816a12a417b79886517edebf6fa83cb04dbc997(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8857c6b501b513fb733dd0346dd265d816a6ac708c805f48f11355e541204298(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb114dfe62b946ead19ea131147eaf7fe239f2bdcb8b4d3e75dccc2b63a633a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d985f0e3d11d3b8f28185accc0fc5ab517ed73ec64d5ee11ed3c1df399d750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de81d6e2316ea6682a24182afa51e952ed46badb9ee8c9df5a0469ad5452d225(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54f3c4c9c12dc802f70ead424e1dd869ba09d816fcdf984e44eb31232d46b662(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5046cca5d17dcc91e1d676071b16e1b6e11840967d3f72826e891d40af847e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ded112a93e5d783c4b095f2dcb9597ce27b38f97244bb3388a6748f0d56647(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb5cd9111faf5e3b1050205a1d99cd897a9828e7d4da2c7e57fadfbfa6a571ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232d9e39e739b648bef31d90dcca82a0b0dfcda972bec80653e24db27ac1af8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55a10520d926908537dd3e17bc68161c1686cdcab2156af394e5d88b0fb7d13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8034ea1c3c94e5d907a1ab868777321d745325b3a9da87eb1d26c891e7b3bbfb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__506776f6c4e0df4b2963a594347e5df3f3680912242c16d83cacc2daa1a4a1de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b04760fe162e767d7d1700b4a53bec3c67f11696b7f6db6240079ec2efbcab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5df654830eb9adf1c82686bbd3fbb0f2a907a1599b11678bc9c18f084d8aa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884c24c8757d54d322721650606ea6477037bd6b4e45da14a4c3d9feabea73f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e7f1f9411b59e646c1e30d44fe99273b8bd015336d58db3455d301ba77abc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de67bbdecae1af399b7491db2193c013878caf4f1fccb4946b10587e06c13ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a21b57dbe2c0b429e8b88506a6c571dc1f70b4112b2e86272117cb602da66f5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d643ad7bbc1a8cd2acd3a0e00db277a6b3ee4b96c8ff901f4176dab7842340d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de88f4821bb6f4a7d6102b5294d2bcea87d65d712bd9008094429f6a3eece05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15da06a48a2df78c2b5840f7177524933d123bc897a964fd638008870a14e82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafe8895eecdbca8ef65dcaa5fedf3eecb7305d9c6647d4bf06bc79f0124387a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83fcd8619e537649429fd7bf221110cd55fd2b75c3a9a152a743c61e1d14e22e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbdc6b35ae9c78ff8cd936487994845769c84309baf496f4f959cb85cf8c68e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc1ebfcb2eba71bf979acb8fe4ba5c1bf2f187351e8f0a4bad4b6e7475713a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9642ef836714a2b32a1b2e8649c7ef5b084d2cb79c4dff5c20973afd4c4b9fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ca418dfa4596daa4effadb5a9297c82b44a44da5564ccc6a4fc73d1be93406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada08fdb2215430a40cb48b9ecf439eec0e0b8fa918da01b3fe563c5c998501f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a4adcc1b1253269074feb3c094de6cc4fc339fdf231c55a001a2c3db1c79bf(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__575ade7cb01792a20b4402fc9c11672c8de48131bd2372f1e3c89e79d46203e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e01909ce74e8b9ef897cdcaea1e288a74395754ec88682b2d60411aebbc9ed(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060024fbb5574807d39348f4f8d4b0775c25df531438357f7e6a66ef337972d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b50724a4639448df8dd09936ff1371c156f87a990d65456800ad000660fe93(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fffec9b9c2080d0a92bda216c89783124e1c490745c4ac8acc4599aacde1495a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecad1fa21084504c4c93308de3cda08145be5f3c0c69d9253f5ece2ad5ba1478(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a343d92baf1cfe53966f24341f15be13b39304bf0d11f9ebe777b3874486fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace8c45fd364fd81934fecac0a44fa581211ba2db9104315cbd8d321b0718ce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06611acaad815941c1f456dbd9a8c2baaabe868aaec39d5062618343e595c8ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c87689dd7bb29ca6e2f8cade14839ab5b4544ef17c6d51158013c15e764b159(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef94b7ab4e6a8c7e006d3670e5c1b8bbb6739b7b534a1a470bd56b23f0a3a605(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0cae9a16fa915b9bfcf113159202436c5dc7767c3884238623844cb04efd126(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303e86344eec6465ddb908c462a2fcc87cf456dfec0d2d054cfb6f67748f3529(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00a700d5a1a38d1255666fe4a49c62f31044f1122eb87ab3de8d5ac80a9ce67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e5fb0daf6d1d5aa55d9387e19f83b6b7bcf7b1fb3022c2a8a82ed6e7b734de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0b0ac29846a17a9dbc953a41b45758093697d3af055069c941153c5e3a67da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a9d95ce9008759b9886523b42160162a966ee30fcd5ca8daeb87554f58ee31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a758e61c4c24e9104a98151600a495f97bbd50efdf46555a9f0b8b10521405a7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__febf1ca2713ebaad198172a5a4f03368d8fe1d982e69e81061ead99b4810069c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c322558b3b5cb73ae05fa01a1875f0914c45777d1efdaba77038ef2e6b185f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__812df52d38627fd25d171e53e9a8c5788f597d6313f6d0462478ac4f56db92e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714186488ac3fc1890cbd3af9f5157b51845b4d91d63b9baf5e392aea0fc78fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b974808d8c277ee96d99181bffbf2eca190bc7f179a2cf83c58efdfe199a1357(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1c4bb30539aa9236aba8c2ec3abf9de074792fb08b9d02883652091b40b3cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f432c58dfe70f29a44e37d58061721051b8f188fe5711f396a2e024ab0e5f1b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ad5e2ba0efce7ba799bd0a43c2c99da639c0e5862f56451e6bcb95141ff64d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fbce39d78cc713eced9b624de1f438110469be51a5997579d0a57645b224ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d369ab4006f28dcbe5d96e87be31553d42ab3fa6ec4ee0a33964cc241f7719ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2147f9a9a7ed14eb65e174d9191f55892cfca0d56cd8bd0070243fa610e2633(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca94e18fcebff746ca104b5658296b8ad1781f6ff29cba552d971eebf991b4b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d470d24042c6938cf1a02ec033819b7e32c983de3a0e800c5257d8a2d1b10c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6ff7ae723af56ce14fb4d58ac65dda51d16d90716bd5111e22e76a6b9ab002(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96452ac968b67d07182bf3f613cc7bbf333074b11c506e28bfe7e1105918f788(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c803c993a01c1a77d91ccac11f337fe76391581c286ae08daace01479bcc82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac6647eb90c5c068859e396ad75d5708b2016f0566d916b87bf8b80f972404d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51fc6cb333816cd4617929d6f2baffa91297e03da412d3a32ca78d8049b059db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d15d8d84ba0cfecdda9e31748a992aa4fd6186f32f10ed2da1e59d9f813feed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc50d7e6328d5c5e257600840c0c171e9c5d3691b4522c160fb45228c5c3608(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea3228f4900848f13b5dd2abb3cd033293f44516f4d5eaaf06d58d8f53781ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a40c4e1d1f33b66193f538a0cd82e65e19185b8301e640911a5cae3c239e98(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a328047fb2a2913e14668b5a1cd3e4adbd74e465e991a675121974e55f159cf2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c673ecdf8ca439666ca51393af0ea7d1968b982329004c3b1aeccc695c9b4997(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a4e530ca1f1a2e600f729c905afc067c048ec792ae0c478066204f9183789d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e309f1b4228ddbdc9014b6adbc3050364847f27e8ebb5a6e70cfdf993fc39fbc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d669b8e22c513bd02db0466b32fff940fdfa93daa9fc52e8669fe2b15f88d7(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d076746aa9f76e32d4c8959c97efe8e3f80c8f5b5beff9a075ff2984f3d0813f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5c597d29d581088050983a2618bdb57c01f8d8f6efd21c84707986d0858ac7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c50ff4d3dbf848390072748e251a4ac820684b7b392f3d60ba33600dd9a0751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab55e968cb9174792e2f95aed8f3729375c53f5a476c1751bd0b7d9013c395d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaec7002ba1d7ca2a9227f8b6d2f904f54ac5d9aec93fcf9f49be65da1d1a0b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a960fdf45ecd2b98007dced0c280bbf22f6cb56c9b475a6a0ef8da799f49d603(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ab21424ade9e6c1cdd08e725d82c0e22e166a578e99d2f0d0241fd494adcf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd92195103ac80034ea0812815633883a9934dd43a57b1b2a80b8dcd4a84cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baacf6425b018ca1641d3ec84bf8519795d99b73780c93ddaffd37635f402839(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f25fa3fb5da3a0a16a7d0b009740a4d48fc14f20d21d338cdd2a67ce79f3e2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f8b996952e9d63a00c82d7402ad84ae684038c2ff7871baabdba9c72ede4a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9045dcb8c4b68cdac3be1aab45c2dd689cb3bcd1d524d4ef3b0a064ce2455ef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb00e4efb1bdaf5ab9fd689b6a63b13e65555465cd58eb4eba1fb0b95a27d68b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13dd6b6d43a68c063e6c0a62358c422b0587e722b1f23fbfb1a34923732f16f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cdfc84783fe81e40dc5b340929e066ee9a658c8d3934f9c739f81cd701de501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d769dfba5d5146b6e579ae3970e3790b7dbc040bb2dbd5075ac2477032ca3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5618e950db7b84dc5a44457199bb1d936b7764cf43e9cb9a4239ca81b4969c96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6abfc8b9894ef9b3a7685f3f7762a9dd879899bec54c58fc8aae1b443d5747e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9a77343be90d5de9847da21405948055f9df9d296cacb58cfc2b4512bf5cc88(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00981469e63972ba19484d15edc0666f7f1f535292c1da3de8e202abf3ff3965(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa8ef764849af3a527ae7e12ce5d39a614f7322978359bbead2129274e95e42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4646efa6cfbb393179823797c1f6c1b2dc38235b0b7914fab11a0248a46c08a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3774c98aa5f4cd74000a67c7e3d36935a7ba4c8a4f5842b46bf2777bbcfb2a13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be862c8097cb75c27353d8038e5f54de1d569def66afa086cc46efe1af0ecdef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d18e2201b6ace557698b073804972e0ba713ea2faeca3c609b17085faa37f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cdc4f4eed20456fbad066bf993b9107ff27a34e807b5b50f5967ebdbfb01b73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e9f695e2995c6e336fd463d39727a68ca709bc114b2959ede125d25bdc07c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8fec9557d58eb598e372938751a7613f02f51f04946227a0ec0067d7eea2d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05472c481474464cfac16eabcc7a7e2d733cdc90dae033988c24667f76759c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8484ccdc39c6e03b81f978d840a2d981121e05c13ba3bab1f183a91c6c3905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5647c6fd03da05ee422b643bd7883bffc28bf9ece1ea42b622bfc286e2147b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61054d48c8e2bcdb941ece21cb20c8cbf6298f47d17fb5d7d6bffe86677025f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78990d24b2852ce48c1f3a5fc7a6d40b093b4e48eaa80b206e35a02f632d96fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7585b3ca7f73714e69fe17d8796ecadd897af82a0752a365377bf948e921a61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99951a601a51204e821a1c2571d854b14301fefcce4302524b3dcd62019901a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddef1617e77ac207b73c8bf03ba96679355fc6dcdf7cd69c7a646a014bd251e7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b8f9ec3a67f4d4a496168f77ea02d897b7a13407b580739642c54a76d4a3e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246a8ca3d6871bebbc104ba97f9d0a0d8645f7bdeda5edd792ce50fb527d55ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3878d10b12816511b3b614c9a718561b9749e2002ff9c60b93665071ac9ee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43a5ce13ea5aadd1cc5ec556407daf7fd8459d17a4e6dbf37daa92f86f37c68(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e97e121cee123f98132e61dd75c0ee9d9514afd345c55ff9cfd91d1511df8c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dce384e633f2ea71c0b03a21b9a117dce1ec2e53744c94d897d8f42ade7b308(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f178c6d3a104894ad6b9bad055f30eac7a950dc6613cae8e0b706891d053d39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac86001bef5c86f18b4aea6afda6d291675c830dbf8c2b5e472eb985805f30f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9761a544643751b69e0e5da5eb25b5204a46a0ba741e5cbd7faef35de343a803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a023dbbb659b29d203cf14b627d8877bcdea6c979038c21d32c5024b9dcb9fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed276d83c82446fc18c63aa67e81ed5de10af45d712ac85909468ddf39b41957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8df22faad25db05a1cd916fa130e1a88e493b8f903ba7b4d6b641df0fa10fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f30bf2aec575ddd4909cc94b985102f075bef6139d8fa8d639e53a3660c9ba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36920f88fac510fa7579db7b8cc9f368b668b61c51ed796937a5d3afb3ae822(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3666a852986cc01f19ac73d61c2292d0e625c498890bf5d10849c8403f1f3b05(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107af9431f34c167df24886b39819e364418b725bc561d95367124d72d784126(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc1c29e37b4dd76a0377794ea635e1409569e190eb12bc78d75d1997f12a084(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da773b8913a5f1bb80ae105942b2fa4da33169fa96433502fadbcb0e20928f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6effe5df3a9102f8caaaa4035356dba681a90d8bdcbd50e6d5ab04b0e5684d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1699268b5f5c1548308c6daac8b2c288085fb41aadce87b97ca75cfbb7048b4d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518648ba23e06aafca55eac4ea49eb4ac865e71709474c9b88206bcac1bb4987(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3059acc15061119e02ea17c10c95450454d2a122f79c72c83f7a2662d0168c38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907fc419dd0f33d0914425bbb8e15f516e94bfab7da19a7170d901eeefff423a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bfe4ec4aa109c0cbadf2141e9ce8e724e6509d23ac76af7e95dd84e97793616(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7d5b87f75ed14146cc60a9a6fd133f53429071c97350b4a5ea87e0251593d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ee9d4e4d305e07e282384697a2fa67888a01c8fd872dd8ba49340c1cbee36f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec08e7b45277bce79ec5401f05caf1a7b6c7ed07845e5e01c0f26ce2b83eeca4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f997d088e2f9ff1f4d85d36e5fa2765e562c537574d66e49560b1cb5d4ed0ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce68776113318505f1394f044d1ad13dbc029fdcffec74c7f82d3cc0a75029a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0340f2613bc7d3da413c412ee6fd277205d945553a429a7191d651f40b2b6c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464311b5d77e4371a8a129cd547c2d670a0b89d636a39536964be470c20bcba1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1122eebcf7edd90adbeb836a8d4abe9f6261fc3d974919759be03ff61fe88969(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3112534451b035560f4c235cc07990f7ca9324fe21ee4ce92ee2a715baf8ec5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb59827e002a6ce2a719f6731c2a5e1516bb52ad9509d5ee24fbbf4d7e1ee1c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6330f7f4ae67950d4ae14e8cab492a53d8b519630aefc482a7ab4f62dbf7bc23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e920236e1ce8ca402bc6056625fdbb231ec39f2fd53dcccd8fbd192ffc1270f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82972b4e10b82522390ae32c0a72e53199d73e4a9c13f0ba15616ad1f00174d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f626c1fecbe8235cfb150f4cf4f2d6398ef299029e2b0914253587b452f45deb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe80bf06c02e253ee35ac02b80629b261d089ae33fa29ad962e296c0e2da6d0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8904a596e18d9e87769360bddc79cd0ea6d263adf202815fb90a627ac9989014(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eabeb1f31e55c36beced855f0c3bb072f0b94c6fe98b774c8373cddb14e754ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c47e00485dcd2d5757b74a1f1c319da85f75362e2748437c2ff79c2ddeb07c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eddbaa11ee059b55a9c9ba787aa4d8c10fabc41fcf9d236209ba1242f188b7d(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a436048e4174f1a70c24bb9608729348808849ba52618ce5936a35a9db60d42e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18eedba28b3d5fa0a04a46d3cd74368e7b969bdf0bd490ce6f66517b1be0e2b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7935f00b5bb3dffdff650bb6b1fb03168e33e163b0c1ecab845b02721104b92e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4bc456d4d6daef7297b98c5ace5108db22c7041eda38c4fc1405d3f0d7f302(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbb4b74e344be5eb50e55f1de1f7da88d6e8d83d8ff0f1dddd5e80d3e1154a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d751c14feda0d800028fc1924c753051d2f3cba26c76d9fc6000e2eb3029192(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c57fb16b3d4b4a088e159b3a8707affdbc55a48d8507108c9aea3120a018ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b7a444ebeb413164853a8a18e547b3e79d508be0008a28f0a4a0c4af6f1f6c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b345bed49ddf971b0b1b9f2c6fdc5b783b1f097df1af72c9552a069a261e7742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d2e5ac4047ca411c0bb007eb80232dfc7401510a2cc1ef4e8774f69e0bc99a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de8c8709fd92f0b95e2cf06d569ac84febfe8ceea0c1609b370fc8c00703415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9721f86ce794a04a9c8c6b5af1195c6b7e1e6422dcedc319ee10ff1f629d2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6615ad0c6951d3af96b5709caf9010a07c48eaff2142a8586f4e99ac5f21cb(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bc15c1bf64872419c216219780bf40da789447efd562a9dcbe40820395ecf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec734798f6ffa8660082a50433a6292d0165d8f43d6b52b4216f04e659c7d828(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403b45c0ec2daa516ae57dc65de926484022b966b54d01c39b07a8532eaae510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc3fb13c227c7d4a433c7c328ff450d7167003e2ddeb82b959a883cdf983493(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be708980a3d0eab2447b444b61c8f7af9802d1cd30d34acc3d0723b2e511f7a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335d6716ba6e7133351940ffd14e78276a254928e10f2263c8b1b74d18046789(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4dd83a40137efbd058654435d87dad36e13322acfd1c9b485df485dd0cff9d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0457bbffc809d0fe845d14825803a906f4e3fd7576588293eeecba1bc0ab6cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548f8634736f593b13b07cf25c8ca49dfed87ca6171bb1a8906562dcd6d1a720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f260f6d86b68150cd6ab3d562fef46b1576e2fbd41c5339c24aa0d51d4874965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89856f8bc7bf628fd122adc461f667f1f70d74fb0143e5d08b939744f70290ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f821bab7c351d08982f9f9dd77ef1157d2143302d7f1ab6edfc54a60c448c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e82c1a00f2a2843fbfe0162bc71fcc00327f2ea8eeef9528275675d6df3976(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70ffb4678465b49dd25a7ead7af1b02ef506c51f88de7f943046bd251a25ead7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b11bb2a16a10fb84c721504e924d5c6d4d1e538d4931eddd57db27ae140be3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31cb9ca4c04d7cc558fab6532c15bafe0339064f1cf8fda33f85ef5e230fb937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b11d383ed0d19ae704875ba1f6c0ed6cbcade4b0c612258b717d9b31337ff6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6539839a91a105288352274cae4b2ae86291e598811341e3dad01dc6c5fcb696(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955e73bec0f3181869abac7f4aea19426ca1d3c8d67bbd680c0284d877ccbb51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3d5fd7e3f6d648cdbb6862b78d75028ca7d30b24206b6ae8a12a367f693ea1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebdfb7c784b2a6cb688d1591e43f9a88f48f204dfc7bb65a924ec6b60f8be887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3589471f5c577b48bcddda378cb2f3e2e909d9f1075f62d467ae0e1d2495c9b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e5c6ecb8f425812618afe050d1baf0aff9c57c1fabc5a7e83123142658689d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55516cb41b0a26afbe2aff68895dc5490bb3a2d66c37736000288a84c40dad7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e756b67594b7f560bedbe82626e01f48e6b2dd2365d59793dbbf166c0b3e13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0ceaa243146c50fa100ea1164f2c941cef3ed29789b0fbd6fe32d72091d4d1(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412de6a5cdc2b0143af7c54d2c3fe2a9e60c3c498baebaf43fb114e34da19e71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ec2a2f4ccc3fdf575469cacf267ce07e173873bb4142c007e1198d204c5243(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e7e7724ef17634fc50ee3f337975421b7b7c337af794a528bd08208e9b2035(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba14cc3c1bd917e75d117c358a396da63be394a18400047422c7fe64dacacc68(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b42c68acb4a396215c71a01906479cb03b107b3c9e32e2e013d491e74ebe02da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc3c720e885f3d89425d3843933c2054c2279cd6deb0a14811254a6398b13e1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef9024a7f29f7dbdda67a3df7faaecc6079c53efd1a43ac79c4901721dae2e32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6b7dadf308af9e6e1a206f068ca06b9333c15e932c0ada136f5cd26e862846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463300d15d980c381399d0c8adc3711461ceecb2fd3a3749b9a9cd7e2eb23bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82613b28fb32ac995d619abbb60de911eb90f8699d5cdf7b30045968fa422183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99dd5b54c858afa4ce52ee8c5aba32586ef7f780612cbc191303079d5527e073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6832f0663b6be1bac4b8089e15f1a6cb340a25cdc97b2f6645203128810e7c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c304cc4e0a78469852e84dad2cb28baeec57dd2d6443f93644558dc659d13cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a1996dfc3feac31927e652c221372d721c435f6e9ba5889855cf342b2e0df9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e9742dabf9329a8de667ed03e6280bc598bda8d6f7ffc2193d5f0eadd263591(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c9880897029b93160347e0bd95990151a1474d8411f2590736f772d5e74340(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed3f3c5a3629553f498ff5eef4b370b562a18b13f7e59eb78d80a6171954712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efd3511086dc4dc1fbed7a6921a9151829e32dc0fedade763a994bdd83c8a1b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2628543ad3760bdb5f13807a6313ecf4c2a3ccbce7d5ac1c4fe1e864fa30078(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__316fc47e42eb9a8a0632f21659a300e7e531a4b489317257f14ef2a1e6b1dd92(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67ad56306f8ad0a5870929709ddcb6cf07e4f242d572a4c3afa6d2bc7c7cfac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0ea210158c8ca00108b570c36782c8719f4949f2126d58072022b1e0c4f299(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8856834916ddfe1cdebd3d7b4d1da6fe70c52278a5c1a378869f31ad205b7f84(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da335d0a15840f11e2e07e048c3e66239f34216fb6e8e6e157d239336411914c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3114fcc6cf431a7a89e93c1dda5916006dbf824e94262e78b2afb3b5f8049769(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a24303edc72e8a2d9b08215223ef860f02d41967c4ae42b303d5912292579d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2f5b3b856562f9e8633956ee1d24eb7e57a7ac3f5b0e8dafebe21e6d08fa2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb0a7adc30596d15c8f89a247ee14e9066acf447e67f178207d61a17684904a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54dee00252476ad64d63285e3ab592bc24ee17b5dd48c95427ba45fbbdb02d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0438e2ac257df1598510602c8578acad773db245fb72e3e08fc95a24869fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc606c86c9ead19ac134e599924f828c081a79d4c0042bd1deb3d645eaa2db0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1eda32d835b2b4a31720f02e6a86a686b21edc5a281f17521613fda0c3ec03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3357aa2b5817521eaa325aaba656742d98574580d6c0c35dd7fa48e6edb8fa4(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb64d7ef3b31d46d6f070816718c372d91617ed3beacde5d082537508c35e1be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e282fd45effe9fecf2f8227adc530790169fea2b3139de6bcaf28ef642afdbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c36ff1472d7d15a29b799e9a1a00d51defca2685de36c169a7e8d2ccb0da8f55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13514d1f27ef1b1d7d522af7a35a3e096c9544455f571ba06263a924b093dc16(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a5319c2e8e969181e85acdb6002d3515dd618a5db508b08a255320edd11d2b0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1701d26cd8bd44fc4c1732a0a25629605f400d190a5b2dd3d1391ab5dc9e50c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b875a15ed71f57e00069874cfb7edce79f0bb509d925c8c00eb04ebd7266c03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__307b19743960cb9b704115fd64379b089bc635f1b9434608fd3c4569120f40d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df69f43fc8cf99b3a1ae188135ee18d90c5b6ad306630fbace04f50167d3de8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09b7e7c05360d3a9ce63b668036f9113a7e37fec6f62265071a1ba869fae66c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b3c2a2daddbf518e0fd70798b99fe615afe9931e0bb92fb71910baef5573d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253cbd22b963f1ef7e45761152029d911fb27e76c5a60c16295a490224ce61da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5147f6a5810744f5130bada563e25eadf850e05476540f3c07b2ba4119d55c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10caeff6be03f3a67565ad8f8f1b8295d872c9944eb5faf6304754c99200ba05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e7bdc1ac88a827419ebd4bd34b5520bcd3080989136c156d7e121a39f512ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426350020ab6e58e78cc4ed97f7d9c24eac45ee8962de0512b978e8a4cb681ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9599422ad9a87d6efff5eb19166b42a7542faf2dfe3eac805c4984e1f485d02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb777efbef34fdd3925e2d4db9e831737df307686e97e6c50f59b45b896d462(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4351780741a04a0017ef04b196edcbb7a5967309ebfd237f9c57785838ff280a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f388d66f970e4dce8217f00efde14a15559f9bf5bb1220fb8e9f15964f1f0a3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7aa380ae8412dd25959250f03c3770079fe9237bed1b1df2e99f6f1352a864(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987653ee7889498fae855c481efa79bdf8f04bf81b6240df6c22b966867dd336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55a66df5ce64bc5ca286a64b910713ec03fb681e57d3f5c16e937f27c74a528(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74638dab20f73de3747af993c5cbba81a63d03c6d3fed6180deadad939087057(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f2e13dde2d146ef8289a1cbca1e793535e63cc8f1a0d194f4b3e4b110b5d37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010d81fb92524c9aaec230c180c38cd1e5e5f950d4ec7be6fcc845afa9770f88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42b251617717a21fdf8c849a14a224ce64d756261bc7103c1731aef2710c1d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72e4abd9907c86310bcfa225dbfc16e2ba38d3db92d417457a8814a6a4e3155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e44fc727101e11619a7a481729161e3feac547adff2ce0e87f23a6c1c156c9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f728a39872967cfa7b2b23bcb405fb80d46e2add2454c025339dc0e14e4825a(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c1e6f3ed8cf0e0866e629022a597777381b2818b0873fde2d4e4e03c87b40a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f326b1d7cd8337baf41209057cfd412e5830989efcafacfd99b1d9d9315e4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444c4442340dfe559a57c6ccbc38b38c7edfd403aafca72c5e13134c0529143c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc10cfa266521d2026e5fcec7646e8e60fe102e8c3dccd2d650ebd34bd757270(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0f68d50c144d27d51d6dc06b0ca58020379ef68c976f1d9473f2d5ff6f3f49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de13d69ec85d44ce0f917826f8415214ce68ea9f032331d370e814feae1b1372(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf832c3ec1ed41a2beb0799f422cbf3dbf7cf235527193a94acf19fd0178a19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4dcf52edbb2a9af851f18159824f539f74dc08b83a842f6a4b50d4072ee894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef10f1ed41429960453bc465558eb868ed093125035e2a69b190c2ae575da53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd742c25239b6efcd40064b1077fb46cbfbfc4144df9b7e94850c96c741f050(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce538ef3cc50adb934bf5064c8e4c126445eed4a3cc68f53080cdee0a67ba599(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb209d13c0ffe5ca7eb0b8b734f894a72811cc5c2b7c72b8e9bea54cb07d7a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63e59034c2355e5adf21617a2669dde7c7474f1ca4e2e940c2657894f6abf0c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fba4342913c66355e3ac23031d20e406bd7e78376baa2e1bd58f4e05ddb4fe8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0c9899531ac2a62e022cc7422335ab5b48e23fe552afb1f589cfdf7c6b985c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e332d6c35b638e90284030482c68f7913dd816db7a4d9d63447471ead0a45d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee007e4a8d1834dbd3add809777416a5c0be43a5639e003d1c12fa66073744c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f106a055771e11be976ee4d350e43ea7a2262faf9bfd6b81d0fb68c921c2246(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06de32486d0a2dbb60e6e31cf1a04d43470bd3e58cbdffa67e1878099a5a2eea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2413bef5f7e53ac38bdfde6604d4f6261b9575312c4f6a0f74ba719406171247(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411d7d0d88941d619b2275a06a419a4977127ad798f5ebd583c345a95404e737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c62a4cc8e7af4852e0e49f8778d6f548deb0e04b8ff7b9080d709ff55e1755d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2440f37b0b028d9dc9f7f7b8383c03dd54ceb0a8bbd9c0cf0f666bafa5845f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639827437d7029b7d317286477e18540c6c40284ebd1914a2fcc6d26cc57e0d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6163d3c24f4b376b9e353fc04c3e17c619180578083790e7193bb143aa0e414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c434ff328264b379cdce02fc76584a931babc4eb98613b18172f83ecd4f466e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bb045c4073e20b7745c3d0bb68ae4d51ef879ce5776ae6341c2dd12f0d1c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f955d04b08aaccfbf56647eebb1510c9e63d6ae396bc199ee7a2f41746ef3640(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db2e789c90231844ce80a3c5d1a16ed0ff67f7add23a063f5da9a7e0961c550(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0b7d4278d43b669d804776dc79bc6f3e7a6176544fb5611e17592347094810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a35455974d1d7762df981072e2e2d88b921c74a8bda1d07a7baddf64b30b88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1070ecf29e9280d7c8c775a96eb0ee3ddb5ad8e82b9419c76b62c8c7534f28e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b7c47026790a61c1a151789cab11a9b3377e7f25721276fcc7558fa769c2ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b766b973c30960da3bfaaf2513c304cb96074e5e1e9e9f51a9eab39bf51ba56(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a61d26067a34c21870bc200e3e72e874b2b5ff1db3fc3f6029e8607afc8caa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8952fe3a92df71288aef9c8fadea964b08d49d4f20fa9655915ce08e322ee554(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d9560c5dd8acb76d76bd8b203875b58dfc1d291ae760a6683dbc5833406f914(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31789a7218ab298627224e11e778b1df3a845294053b7d24ed68dd1f627e86e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60fd0fcf334fc60bbd4d8b32aebbe25044fb2638444d195366abc4b543be09e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5412b036c365d8d74c9d48e5a83a87dd9aef24ce4aee4a7aff6b4d9be8dbdc8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abdafd27d6b2ddf034ab68c08e2d30941c72608ad34afa4aa85f274db062c489(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a13afd2eea9d00775897c37938d28e0bc9d4a1fd0a350a1b0d45fa641bc4d4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d41fe1e150f0e02de7e183ae2da622092b502b2a3348d70b2580c9f4d12318b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115251e88793d5115bfb03bc0a85ea731a2bb367164550d5afb5681ca89c8a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb4a1d023f8a7fc3fdc6f072ee9e27ec386e980bb9ed0a7a292ca6339c7103e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f776ea8b7d247bb6b668ada2babb95c7b77bd35cdc0a20100782f4e3a14c93f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdb31259e3e4e89ba247fb2eb6c13f95d68651a1eed26860ac0e66365c81df6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb44dcac72d0cae9045b3a8e32748ece9105e1619e4f9d29bf9436af7613568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04062c65364b7e86c2f1071a29d498dc324ce6ed34816f12c41958c79fef2b8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5562caed9c2fc81d2f076dae8e21b0c9e545e7d25701f184cf16246d8f11e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aeeaacc6b110e2e695046011edf7820b563d157512ee9c5fc1bdc189d841a2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27f2579fd931d79d1b0bcaab9975f3437a889af102f172d0adbd5d001b9f608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a540bfe5301c081b19826642c9d54df159ea5e0f60e2819914df7eed68007c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c57ff10b16667f6faf3b4e1e61b183919d70647b26d93a277d1b53b697cb8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0541ab6569dc38583d60cf39f00361c799b7db6c30a207cef1e7bc8401450692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5d6d5cfcbd4fac2e762673ba8325b953e3042b3b22b65138e9b35537bc5dea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80e64a7660fbf829e0d4abcd31f7a9ff106a8ce62ad505b61e87bd0afd6be0b(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282c34dbfea4d80ab3af6162d563b5ff8f616a82264a05a68a57d2ed8f86bbd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f223296dfa1aff0fe2a3397b07e4a2ec7c65371f95ffa0c3e045b810a49178c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e93fc9d59068e5e14fc5b191500d519b6cf7350dacc395ac2c1fd29654017500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6799e6faee4643f5412f6e263a570c8175cb56415283b54215c9767c1ff3942c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8c55f2d903baab23a4ecca3004cdf01e8f5d6b124334ac7e727052af6c6e68(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ae73c93837de3935c67efe544432c1261d20dcb6dd87485aab7461be1b20fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08e83a2bddb1b606dc3e919e7b0b71f75a63601f5d74ec116ff3437fa6cca90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fcf54bd1dd30cb655ac5f98e8b9a705fb69971525fb03c8f1723c88f04f5eb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__391161fb7a575e00133b838da0fe99c401d9e052c70e74bd2590706096415e9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042cbfcf238390a54079006dc9efbf25502c3f4f0bd1e4c80e02b1843c286435(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56c537038d80408291edef5cc794e14a0464450f3e6a838665c65eeafd53c59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e969c7d43a6027e20da9b91b1ff81fca9e1a8b3f74423023be1593c7b4d96830(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e1ee8520615644425a5a3be725550e5630757c8877d4fe1ebfca4a0b4bb2f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80710fe87124f78eff7e715b45628cfdb4d53f54cafa8c9db26c71c54f5dd005(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b84776f0391fbf14e7db8c4c1a5e11773c53a918a9704bd5a6d00dd262881b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a47945a0ca2d8a7e86afb87c69179795cde42a4f6e6edc2657869c78641b1a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271d59e6f92e1e9572bf71b4bf577b1eaf209400507af48099b605702d360a89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54f3a4ae68308842183bff16e970df6dc2ae061dde4256f2ec3dceb93fd0b00(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659c6577175df3c579e216d675af1ecc676ff938db8caa2a786fcd8af1ea2cf4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075941c324a26b0dac2fafb64b12176a2eae1e4af825949ee899d8f8c0a51079(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8923bb53584b32088a1f687a4e76b9c003a433e545fde48d0b1998783f0d87cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de2bc446fda271a2fa5c9b327ddb87edab9198a96ca13d3495485f8be01039b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a16a1c4824b5c8b19be3717e0bea67a2da4fa42eb9f22572e79783ebc2461f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20876ac4c7d3f45f375037424ba2bb7d1402886e425e53f0d928bcff7c7dd7f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0bfdf166b2f9f39caade2d74a285db22b018184912f0cd5d9c20136e730e295(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc0d8f690d4141453201c49070e191c5659fca42c1b956532b18b563f7adaf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__945134c3143d074b5109fa780af34be648502234690d0f165ce5a4a5d27bdec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab618008eaa307e95fefe52272480b13d8429fea505fb731cb92c7652d86d6f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4a532139f1070ed78048da9feed1609c8bc65b8f3926eb47b1c5d2b6504043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1622eb488908ec86cfd58c25645be1782a149b21389ab78d65c43192b78b5e0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba8762ae1af3230499228143261ed5b5bbff46f0c693706a537fc35bcb0e1f9(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2784c4700fa9ea27906f9fe9f24fd6164c56a15af85f48aaece6ef4ee217eebe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a243fb0b13202c3b429ed853177447a4a693077fd315ea21d0afb9e1a185fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c77963ad7d45475897aacd9766f0af05cdf17f8c5111475a4b74096a014e7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779cfc074245b7eee1f56951cc6cb2d94e4857ffcf653b34ffd0bbe4111d59ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599931f79546019b46015fe99d083f4bac03824defd6bde071112005a1cd927a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ecb1410e75619a855af605bda840f6483d691b72303b6dce38b5dd2253861c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c378e46dd176e6c02e540af906d4e8148fc193e4d7b95f49936da84f261459(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee81bf4e23794f66815e114e059ecddc81d5eda361ca96ae8135945d0beba4bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c567baa83b39e7e6297f0a7fbcbcc8363f3e9b0920c2225e29899928efd2cd11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca8410b8a850905fbf5e783144ca1185e897d7c7001e604eb9e74ada6097d75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4798b0552a4e63d39b813c5529a36584b754b82ed1b0cc5e7b021e6b9b01ec5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__066ddec2e620c480e342bac2bd837e68582594f64c02cfd83f96925eb486b755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce01ddb5042776f6bc4e614f756c7d8a7109202a90cde3e1c763a30ae182a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84dcbaf181b965a55a5629f1f0c3bb135e54d91eded6ed381d4e3399b134aec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ad8af573bf95b5fcfe78474eb26c449d49bae4390710e8e6e2b38ee8e5563d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2234e67ae4fe0869e6944dfb84c7b9c4d5f7373e1530b0a91fe128e6a0812e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__574ae636ec797637c7ee7a8f42f0a2c3aca7d4f716d4523b9df0c81dbeecdb07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048bb49a36cd388f4aab747ebd17f0686173c3c05acc8f70f53d133b70f23352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67915ba03b70d86f99d8b4a49d67ce1f46f49d363db2a7af2efbba49ce89e803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f26e79df265c54b07938fad92e413a8372a7327f9016d1930da64f9c887e489b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718b1c34aa41be6fa40d691edeea5cf003a040b590d42e09dabb0646df5b1e24(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4009bac51b0959da295c1f2866e26fd65e02d393e80f9598a7b188f039e474f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14719f17b0cbc222d0a918487cecc765c138c3cdab544bbc0c5080ac94264ee9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c2b25f30ef5f22567313faafb849063a39e517843a0e196c594a4d4c808241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad2244305d531af4173a132b16f1f7b2aee6b3fab47405dece7f502b87edc6ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__008d88f32fc66c411d4651bdb925eddbcfdc111331708630b6736f4583307a10(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe1929fe7853dc72ba7dd26bdebbf3f1f2cff6a356b7331e703c0586e02ebe6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e757c922c2ee237005f874824944ca3a6ee5af114a1c78f9c57b1ab071019062(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82db712a3d57bbf287c9729844dc2841d76e0a3ca05c696d1d60fdf2f13a1c27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c13e894e355c14cec814c2a636fe5cd8320083b0a5c4213c93985405d75462(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3868c5b6eb58a3b066b03d04f12804eae64c5d0a7de1cbf5760d815f4efe56aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749f343bf239fdfe1911a309235c999377cadc0c390773b587333c0802d9fa63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8594259c5c225398905f7887d9601408ed0a57881d2698b596bc5e87958e43cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba3d52c5c128ad67838036483ed5159843d9de7d59865cb70c6bb063d40584a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0804985950537db2c5deb2476f7c20b517d876c198fa97500cae77e75382b3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f4af1ada08c2e2793d6ff872ad15854fccf75b079eb403acbaafa2758fa31c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046ca9ed640d1b30a196212d4b3ab7da2aad1100bd18ae875b2f96a8bd546669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b402fb0336eee4b7f61bc5c9bccbc40afa42778813ebe3131bd257a15a4ab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26368b61edb59479c280034c5f9a1cd3cfbc15f2c88ad16879204f4313174906(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d9575013a2bb56951c3c727e9acba5918d296892b9a51ec38b1eae2572efa51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a97d53431c544091d4c13b226a4cfb0199bf7fdd7f206dbbf04248669d2c7d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f27eda746bac78f8d9e0d56cee4621c61fb4ab1789e0b4d69954238db6ad4ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3489d98f1cdee6568de9cc0af008af85dd97e29f0e213e402742282e55d28e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bfd69549f4344b3af3ce0b24824a2145af0b9d98fcf1ac7ab3b6b46d6d27a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54756692325eca60952519d406a80b081b3211f6b3e344e002d48ea0a09b083d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a60a4e1997f63aea4faa4a3a40a0b6e02eddb0677b519368814376e4be070b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0abb3cf69d119ea5f9da2bfefe3d0c87b2fff409b1446299ffb04268e87289a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60015f9b265b006697e641107fac82ff485ce4b0f1d87027ea0ccbaa5135e315(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fdf0d18a5d96fa33f69974a845fd358a03ad570072c20686be3a6528b117885(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2cd022c8b8c7177fe3a3997247468798631eaf1c9d1f76f237538b2f3400f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71799c34e7e3b3517133e2189549c9be05c25def14ad0ddf72938fc65dd48f22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6ff648afd583114549461b052d7f8793cfc094ae75dd0c68cea3bc8485ca2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c668f4bd536693116ae7bfab92514c8fe1b6793fa9b0e6ccaa993eb58d5fcec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b8c7392a7a9bf5f7dcdb84fca093f2bdbc5d2063a90bf89ef490236515e663(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98065c9c1527a080f2131e8547f824ead5b74bf6437489348268384d3da86e7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622896cb6496f9f0879d3a3241e171184e17044d5d0770057d6f0e038cecd268(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c05d2525757afd35b9a61e0d3cb0c24326ef35f2a3a2510b74ba1425a23194a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db0e78a694a4eb6afab74a143fc47a20a2d3c12266f76af47c9aa3dccc28b9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7badd843b09af70988ce282738d9162b1320de0582601c28658bb2046446ef5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77cae3725d9266ea73e488b52d6cf5440dd279fd9a2a739ab269936b9fcd0a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea92a8b9fa7b7eef393094575d8be413edfa632f8b26ea8594dbb1f660571bc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3265372ffd3622460d9bce8b155008b29f3d6b5d8947842fbe153befac17a75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499c3b95cfa1a5f50170602336ce43960dddc236b2947b646edc45c740a5efdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf0e271b8b52cb37b012129ad0278594fd30be355cd7c362da96f206cc13a00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367607ca55668c0165a83be7df98b357be1dd8a82557af3a51be77a7293ec94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fd2ac1bde92a8fa4222140111cc4ae66d629e53b169469fafc90866b2479089(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9d3c0e9aed74fb8e90f9ba9c9760cddc17ec7f54e626d56ec63bf1a8328e05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa74925755da8cdb1f5c830711e14abe0eeaa56a7feb0c204282128b9b1600b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47449137f4a44e1cb7352c1d5441a6650eea7307607c723415dc77f0afcf9d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db336c4cb82d2b43927896bcf292f569b057612e377cff67b0afb4566287cddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c16938c841e07130be81d221d82cbdf7c9560a382d1717fcb5e6c5f329d42be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582469815020e0d7d8a89f734a32b91d9d4e370aea0681ff8eec6dde2a40a998(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b6e7add5bc1dc672207dd67974c6dc5966b3821e8eb82f688e0987c8fc9bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c6e896a0387cdc0a40c9807d6da93facd3f6b2eb4f1fc2e9e55145073d2208(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955a38fd1f405a2c7254ccb26cd9cc09aaaeea3fa583e9c8a7a5d435c0f794a9(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81266f0f9e14b36293ece4f5755228d1fba9620009281b6f152a39f00dfd276(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659471c25a622dc2ddb7def8e02c962761874e759222c4d911b0cb43f9c32b08(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455241ff20bd48ad764c3ebab056ae0e6cff4d14cefdb02f2094c6bbfe282b7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06537be3bf678cc96e0bb6c73415d6d24f75349241711033773bcc9f6aac8f84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f9d25b8e0d1b60e683f16ab79419a925228ecfe7e8e371c2772bb6bfca53ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac59e24a829321c4e7e458d7d1f46a316cf18fbfdd1e863163e0e8b914c120f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed409baa9c4a25fb4e11ed0613c529b3b6af58c27a68d8c148c92f8a75be2549(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc66bb4b2eba692862d2ec549e42441f1c64e5ff629e7bdfb85dcf010644d641(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925f8be703def33dfc269664d7d07b44a87eb91ba25bb269e24695a5d9d0a8ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2879d85a2663e3e7a5810768cb31ef93a89c435d3b3ba7fee738245f41162321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fce499340dfaf16749891db53f86662d832c117f69caf0c074ca3dfa0d4124d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2e3c084d8c86f3d6206ebd5603e02366b8d16ee1ad624e24370bc4386f20f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b873ae3d7352e04bcad8d11bb67b235c7c157a3ce8428832e8906510d30023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4184579eb90f4c6c8fb2757a29299a8a8aade0aec08dc46a5920e2af213540b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a4a92139b1f06cd591a7da9e1b2de65144edfe1db5cd5b766d2fe5b8a91152(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfdbbdb3c572bd55d344216cf51e80fbd8848b77976c57b222741b27df97325b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bea1b4b9876074c00b05b09f8464d818299e31f221e8668371583e26d2fd007(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e17aed746d9b7cefa0043371051394e42aba7d9610f0a620d173c6ef3334c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c3677deda7e173034a2a64d466cf05a1b1473316f898aa941646cb17fe1e44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83cf192b1ddb9857b7f5d3594918595fd644ee8c695e4cae5a44300255335205(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8171def5334ad8aaf3871599ec968ec83e3d3441c75365771f565e7d04ea10f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4e94c46d79d6b785684d67ae11b1221b25dc81bd89c0a634b1b44ce021c140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288f09930d486d30c847b29e5ab4516b86d5a303d3ac94022cfdb0f91d249634(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5fa865e62a0f8059d7b633a9a62d2adbe89de779945e2464477d212bac8265(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7da2b87df9c4edd65f73656d8d08806146db4f5e056ae61e3b28bbe4bd2b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc858d5415ead4aeba0de2ac7e74e8994116c0316bf3484fc53f63ae8a2f1c96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6572023794cb996625f0f8b5d589d7fb1399d44d01f2338e4a84691f9d326a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e537e3d66f8c9105fe272c18b512bdf3f2ea4b0c408353d997c3d5f85fede127(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf2bc80c132262d21c0f96d5e9629e8259f4aebc614137360cdf043353f4675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db70135f12a3ab5babd48d58b072f9d17fe5fa6ce3ef5ea7f21f959427bf0532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d6b5d2e550cee1b1377b21c6309f575d5f901ff3db3f57d5fdf2c69ee085bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a42c5d0ea4fa6cddcd6d149ffcd0f09e9717f81173b8c3ff03bac608d281264c(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49afd11ad5fa0d4bbc43bd0042d26584eb29066b9bdc1b88878131911d6868ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fcbb31957d1782c8b58496c0c8a641ef9c151a09640a864c4c5132a0cd30d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcb491d36ad6143c4273424f530d1aac41bc8924ba7650c52ae6c344181676d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227b5c7bdccfb75192b248b92076faa7b9d2409dcddaa1fd4eb2fecf4537ae2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f256ac6bc6da12481efe8b6df68800698dca1e2322256568504cfa327709f9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42be188cb8d9c8684cd4be24eb839f125e9708d46d6c65a2812304136866902f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee8ce7de654b86860dddd004cfeed93f58d21f33bf4ba230ff51ca21f5fe6cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acee4bf545589552e8ae27071cee6bf7ef56855cedf2045f2155ff5efb102809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48bdafdc6babf9a7a2999c89082ba2c9f3f85f4772dea918a921738c2957d34e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e87fb8b4bf0b43e2f6f1d2354eaf35525ac430046937a98834779a71f3868db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b07247e5fe8bed72ed97d95be46361472605636472b147d9c26bf2a22a17d548(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173d4d9d593995f9d2f8e23d39d8955894bb3b90236b68057ea365f6b3a3ff0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0abb80bbae75da1770e82c757790a19550f164aca83f9132fc40810e2a5251aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d617027ae08b3d4f62c229d400952c5125735cf823f5e0cb38582a4c0af463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e6288cd3c2fee57b4fe249f689e4098ca9b632438e62f705a5f2e3b5edb722(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791e065c202b15bff3d4c4c979f2d63f8805391ad8163be30103ac297139c51f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5da0c7faad54481704e64d75fae2cb733705c69ce4fe7b925956deb93b4c41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b54cff537a2239e8998f0c367e5630561a1e5eaa509eb739cba4a59b41072a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc728f48cae0969945ab4687d96dc03f1f5b8bcf24db99f340a471d9d492d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00d23cfe69317def683f6700c384a25b26a891b94dee332a9f56333b00b68e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79d1efa2158a4a87fc5a3491d466a9e17a3fc77ada40d5c691c93cc3a2949fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede4584cb43eeb7ce6de7949b07c63dc9ffbb18f30382c00b15ed9a8b05fa955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43729ad5d32576ab21ffd43d6c00571d51a2d961bf149f8e2a95163d2b81766f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae19440865ac8f3f8540612397e61b709fc7ae358b5e51cdffbff0016d2833b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc8cf68bb28fa56224161ac694d66a39636bb79373e6795ecc591badb3dcb80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__243a2933f84eda951d6c2c9a43c97e9410f39fdd481bee60aec155bcba77ea26(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865d1186995577f9ac20d6cdf69624451a1ab655e766e75daf3d821fd174fd9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2c495ca75f967eee77f69dad3972ef47ddcae5a8c7494bd4a9d8634838981b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a085e59b14f7d4551cbf8f10b34413274a13989517d006fdedbc4c82dd3d73c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1060c0c370b7a803bfee6e85e024c38b3056eef682e0f1fc73662ecc07780e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a03f11572474c917bed040bc9cbf9cac72bf2863a30d677dabd1ef698b269f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__641e6ed272c682a927f2abe3228c84d46cdfd12b47cccc3553510a2e5d2b193e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c642709e8914600825e889ff735bcec56924ca0673d407800f97ae9f666c766(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca7a4727422f26f4a6b4b3531f486965458ef5734a9d7622fac98cce979d51d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d86b414ccf669dbffa2f75060cf6f72540df01ecf1b9575215dbb10af2ce17d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a578b69ef38557c29bc600a9ae98842132a9c31e2889ff634e912612b4f098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e00072c48f6deb1127060a20b1e3970c0bc4e9e8c9e794bbbf026fa17378b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b457868f25128dd337a15b31cebcd64b2176d6f4a1943b181e7f01bf35ff9bb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0623548f77c71ec1b0c0a2d66651659ac48392441dcd2ed61d00467bc97643a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00052b0aeb94229986419949f29f9dcf6bad4abcd13f7acbe921238fcaf928d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05aee40beb963aa36a7fce50dbc9b11f477fd1740f9d40578623e306f67504e9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d347df2afe2c641bce4416f85de3c31c06d429dbcd33d0b5bb15ecb9374ab9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b75439ae855a000a5a8af0444f9ef43cc2180786e2eb9670e5b0b6d76bdeea(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe28d89323105995aa57e3b17aa85f707df709a5c1009a53a274db0fdffa2781(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d162b8f0d270906a23d7643008b6c299c411158146bfb19a2c0c76072e241d2a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379cad54da513eca9631821fc511f105274389ca33c906607ce16469a0cbf08a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae3048703952c3fa19778ac47cc8bdbdcc8417a2dc7dfd2769fa91d025964be(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ec839ebd16016bb775730472cfe97c3b8cb0d7749c6779e32d8827a6c51564(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ed0c3a4983c15d5f0e423c772bcae79ed0cffce6d9b385c33fd9a6d0e98f5b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c36323ef91054378b826be3eb80cab6e522257d392471980fc12a21950eaed9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__356f5b9707d9173fa2344fefb24b55594ffc41939961a8da499d743491dda80a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59d079e7a760a8fb10fb6e70d72ed8e2e7a8424b84a49e4198c76fd0a7ab08d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3a8a6964ce9e7d78d9d184450e5fbca33c3fbefdf0809211022f9f85ccad8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84338282934f8d43d15d2f63f9424659d7edb411ffcf75d81537b07b10e065ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc5daf49535c2202fb75971a85a1ae90184b4d345d1a027cac0483df03d5a80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f634c09f0723fa65d0a7f350b9e91b56e086b66f84c7c4ce339b046b11be62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c12768a2517d98d074b7604b71fdae3053f9c1f994f3489f4ea52c7d46d1296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d590bc213debe85ae5635878b4d720215e6ad5b0929770d98d2d2b2925dfc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43591c0c511e2880eae0d2925f2d5c37cb69367d94e98f1e8fd41c8c7f2823c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000967f3cb7f616c4c7492f3519eb543751cba796c2149047079d128169cdf5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2991e7a051cf01cb13335f4ae82ba0c0d52f7c08dcb8c90b9617d6f5fe055ed1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4035cd8a3e350fa76482ad7760817d27e6cd9aa4cfbc11d9bf34c8f669f63996(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd06074a504877c1d1228bd08988583952a98e2dd054aaa0a42b7e8b193375c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d98b3498474ec60154f77271a580d3101cd4a151307da649c0e2899e84703f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c837b710190bdc1e8282c5a90549b7e1f34790155e259bed8c2fa256b46203e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932fa7acc22b1eba778aff71d2a4dae1b4f645a3d1217dc953b45f57fd516388(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93faa34beb217152da08d09937255bce03b2333926af7ff294b11236bb5eaba5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a1f603ef6de50c5fbabc9c1bd0b7c9d7194202c08bcc7bd9f7ff7ee429bfe6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7d31a1a8e37e732c6c3cf2b0ae6a26c38e46ba672406744a67fc77709d599f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ae60647e50fe54210488c67e431e95fbce6802704f2858eaa7c391f4bb56f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e92dcdfc750898f84dd719124b6cfd29a43c68695e18cfa2545b02727da2f9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d16e7a7e364ca73b7621db09aaa10cc947875196d3ac692b8941aa11a13fd623(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8da00bd316e23ae34ff618dc1bba4335eecdbfecf7624910f1da5adfd7bc14e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145596fdd3ec49287f89b4ec178f70d996ec5e5b46cd03a7646f0d696b18bc72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c601aaca79c7454eacf58d3dd8d24388f04eb1e175d7df842d5f8c8be8504b43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db09417a8e9e3ab0cf02fc71ba8430ee8e644ccee4727a793c7c80d34baf76b8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88c3ed09a4544ceec29c20652e64496b2c131c08d36b230d5416993b95d32a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c264a1bea1a113a13dbb6101476b75cc974caad85ce0b2ec785a2258da4765(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5047e1cbf65b6cfc5f272b6d23636300e2c8617deae81f9ccaf634d5f8d28499(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c266e451d935664ea8058fe16702275075e847f02258f475f9874a6caf9f69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220d724b5fb3d705e703ae83631e054c9dfe5db211f24d231f1f28a0f9cd4535(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de067ab1ffe21022cac9c9b9e2494e44e0c9375a9d4ca49747e550de9d681352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb0e940efb47fed954721e5feb20478c3547b19eb5eccc6c02fb42ea84274107(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4cb68a4efea240bca049a9bdea8d75ff76f651da965610f0cc04a6c6dea29c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db95d3642dd08253a9cc38b1840d3a1eb522447d2b452fa165d7af525576d57e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba036fd61d3add09428eff09b587b3c88f7baced40c61dc0eeb35f692715943c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949afb1d874cabeaaf7c45213c4b4b0e08137475713628e59d3112639ef53e47(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6308be15e1d40b7ac7385b1c4edafcecbc96c503b0e824188945db9b7a909e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc45b02348681417f7bb73a9d43db017e07f9ba81f1d7ee3c6e6784d03ad973(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2679989018527a0a15f8ef62d760d7ee0855a0aa2d4a2c6a494fbb32a96aa17(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6713b550d29f2bd3ec33f7518698dbd0f026eef9d078056be260632ded7be3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7ea5c6a5052118b199b70d9741c867d364d0fe6ab8831a89184332f42f2e21(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f3f2f3f64d3c98e9396a7c5bf8fd856e1e80cb7a27882e96b7b1983056ee0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__314022ba5c334772ed981dd324988c5d4a226e4b9fa133cc70c7875d5208eaa6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a4d125b1ec86e96732a19695c1d65e5671ad4561c107d7857dbb88f3a69605(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__321bf4736515b2412463c4078f1e6d17227cc8eb884e2dd2da1b9f1cac8cb9a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eddd5fafa8d3525b15a3482bc3c663ac3892b651886f0ce661517b3be27dfda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf5e47c15a801222d1dcffd464795beba6d30840a62e04665a7068a50411bfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5f0732d6761855c2a7e1e6fd4d1eafdd8af94c511b7666f9cd2900d8230c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b3ddb9df2900fa276c3c1c7021e489092b08c7a59bd07623dc99d3f361e121(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb6f1da1ca326892e8b04ed195da28a3b083b53a39326e3c794494579f54dfb(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ac4ad37f54108f06ee08bd75d092a04b511e56928f35349a415ab81efcd8433(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efcfa00706ed6b06a1df799e9b3ef94160f69ddc77a7bfb772a88bc90bbb911e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139ef24c2f2d0000023b8dd876fed5044818271b53e6c1936e2635b3f18ac088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4c54d518cd73fe0380cc7f6744d32595a8ee98933e2819a6f54090325a2fd6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416430bda1b96ab50a268c437d76f489bf5550153b05b5b852d29eea90a839b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__812feed1ee7194715a0ba00db660cb24fae185099d738391d581a8ec2647dd44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__286fa0ae2ac2d42c815a9e0a1485c20bd482cee822882c05aa2b0140f818f5af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881e0c7e6bed61da594618d32a8296d62b8ed41e2e6f4afb60a713d41697af3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd80086cbad6dc12a563c8c4ab864729a174148e5cc3d9b8decc0a99997967a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1521aec5fc222c940cd80b0084961bbbad8e5537c5bd81a73128f9cdeebc32f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__116f16230bca951ed1694c3a61014e169c0aaba79461c4f420c19a1fe5e73cb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e44ffbe17b333f2af547f095cdb0b0a7bb4e3f31902a79f98cd657ea86b911b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__022afe606753ab5923f2e25ebcd704511540182280914f425167fa5322cbc970(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102415b9aa7ccade7c48e3011c6cb153dc8ffe48d079635ab3b211229f36e6b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590dd35c770639959fff60f58f5d8edeaf4a205661187894649fb9895daec2bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48b3f8df912d1e2c28dbfb8e0c1074a8a28d70aff52f9e9ec66615cc9d4f9ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb4f46ed7010c48c0f7fd669e9988b17c2dee2cb7b131156265842297026d3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7330f3049f7c06f568013f6cb144f47cd327379c2c9951119e09d1277848d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b060f0cab44389b5705b55a9ee12230213aba1b8d8e76fd80dde5509799f138d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4273633d62070a4368f6f9de37ba7ef8094ac5c442a9630db82ea1dd786b6c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfbde13478f5c12d92b56a6f6c2b8bf049dc1a506feca9475973abf795ffe364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__462116b067d222c7b2f1705f29efce392e88d9eedc1ab228dfdd92535e822bde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d10599dfa1ef76f697c21e2f1d0df63f8d36f79784b55433e49c7bcfe90a36e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b10e7daee264cae2d3ab19788b5bccaff9146b9f7c677a20fa33c501146a68(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a568a32ad2d2a090f94e14bee7436499142856e7d070bc99cce0f864a56d9df1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742910497111c93aa4061453ce4e19d64ab551c624103d96ef9e332cdb368564(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f091b0000cc6545f419828cd2ec70c694f82614a41ef38dbed756080df3054b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82451f237264604d6e0e4d0f4408ea10141ded876f8abc11dda15231964f0397(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ddf1efd594a393ccc702be62e7cec7f424cd160f6ae206f07c213426637d00(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a97e35dee3b4aedd514f916058d484f0a2107f8855b50e9bb439d2eda0ed5ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd89ba536f3424ad825a6c3d90794b0f5ca729ec66271f80003c0200f5b23a12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae85a1fb67fb9a53ff324a84057b53a28385cb47fad54e3c9d5aacf79b25897(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdea2e61273451f192a8aefccaab573f5672c2a649933faff065b5b99f19c500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc7ef452bb17c230a319171bab2d9b260d6560473952925f31d1132de425e17(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dfd3f3a33f19684cb37f621dba81603a8626dfeedf5fed506d30ae52eee30fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0bc203694b9667ff0ef6afc72417ba4f78f14db9b5fd8e43d41963a9286dccd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7d752d3b0d951a7e642c5cefe4247d37a8f949da9ee9009d55fee314d6768a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47408e463e940582c256d4a9e935f74dc8ec45ae626fb2402c5c401b5bb3513f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0831ceff120804665907955dc2ab7b5a96a747c301a09f9f327a7b7cebabbae8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88531fcbdc8d92ad57ba1b73caf862179b991b5117d45075a2e364d438281d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe4e0f36669cc7cb3a3c9a5c6ffe309a6672c328ea3380231ccd9d8ea8fe6d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f60f1c9eb9b2491eaa2163d8d5208bee5566dc23247040a72a8aeb8784fba8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca044e5a7ff66fcf2b291da2d5a8019a25cb8011f89e8c6f8734772910474cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5923841eaa7b2bf709822ec909fac956e0e15476e0e53fc6475ea46dff866ace(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720d8d490ab885e10e56edfd6a036c0d818ef47aba237b2beff12541ff13de75(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23d19927cedc8858f86138da9477efb6178bd6e83d328106005af68df4d64be(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8906d58e8f705a5493753a1fb92e5b93b573dba06674482c35673dae5f0e33bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53915876c749ceb46c93db5e5164d53fccd9b916eac1e4a99ba6ec2755e4f3a7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53734ed81fe2a13c060d172352278b3068e8142cee5228b456d1b2d1fded2da7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89c2b0f1f7fb09caa1791e72ff4a13da40cba6d42b990ebe97431fe1967454d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b205c77e59388ca42992ec375fef14bb64413a0abda43b5e4674fb039c8780d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5311d352975f07498a5a4d4855bf2759ec76cce71b03bc3e9111b874a668c0ed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd179f2b9e27548962fc38b2d75b07a7074f7499df9150ff63f1fb590ac58a63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb49c8d1c4cbba55cb40fb2d77c5edebfb53e3d4e2c0e7120197ceb1e6a1fcd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af41a9119611c0bd947e30225a079b912139effeb77a18f7b282f0d40cb9715a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46990ed2e36073dddd2408917b4f555f647bb5649c88fca54ac5db6da884f3e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c2c2bdf6313866ad71c93136208bbcd5a8b47266c2f5537e88c63556513ecb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf50862ad23e1468631f29cb617f9f61a7ffca85d242ceb4efd894067cdb516(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50cfc77bb068d9a14815381cf8466e384bac1a02bf4cd8ca6325222e106ce88b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520e5d90acfb49c01224c709d18aa544fdee9aa64f1f216d8f9906b6d234a1a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c20f9f3ff933f23ba2cee7ad0a4f6bc566174457873e9b1efdf97759e417317(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94b123f7cac5980af5742e61ef4fdc991af89024a134660a63489810858ae2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31cfc45c408b54b37f27a386650710ba0ca463b092531eb5b2ed36d0975f911(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfdc93b7bb0b2af4e36f7cec998e5607b3906a59cc5732c7a233c2254e839902(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240ce7b00d284ad691dfbfb4d7c56e279404c84bbf6956f46b4aaf3bea99ade3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd6f949f60de0f3f34a54698c676b73bec6cb7162cda959e17adcc30e9b92f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81df0267c706c1dd4d711abf27539df2f3c2a78dcfbf770ca5c39c7b11336089(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd35647c81e23b86cca35170f442db8cbf188f01cba99e2c2b3cf5075b801305(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d76dfbeb29fd5b81efc657deb1e6548f4ce85db7aee032b1b12bbe093af709d1(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ee1959dbb1ee39f7199852eb84b66985f6918faa1b14282a7499f67d4d5072(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6cf6b5e0d1615417faf836749c3539126298825cb31736f52b75c98c97c493c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b295e9b5a05ca79a853ec9514c6e83158c0f8f90c1222e74a211923ba5b89cea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0812f1a460cf35c75fc0293874211af07a349eccdfaf7dbede02ec71a6c9ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88ba109cb2dcce289f11536a70713f9f35570377c28b7ef767a3f80f65cbf78(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a8956841a25c105eec1e55daa2bac8d6cd24ff05a7322e270f350bf3516da6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8d31c8ed577bef01b04abdf192f461e53895935e38e3b1b8991abaa6545894(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdcc22102709a568f0c6096a8d07453e29353360765542dde56b213bd57a908a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca7e3c73fdbb9de4d7d5878e87bdd96bf82520d8c5efe09fac72622000e1bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6db652f1545ef808f5749add55e6417ae31155e2fdd71ff2d050d35db0fb3e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac5c63ec77de74336fc0a92363b01a3b966133177eb5db169cb5a2faacf2b73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b2f439ba96e2cb09032c3bce1d077c419ec6e304c0ddf1142589830ea8bd4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ef1197adacfbdfb1a32c1c3c88875766e56d0fa8d535fcbc086b764a98227c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834d6a8e5e4b2210e458aa134e02272e7c81bcd3d644153288fd209ed5244b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e77f4de2c1f12d4ad8fde102532d503df95df798090407eceb7b80c7cdb77c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167843ca1f01c8e1ad9b84aa8e034043f2f80c3bc1a453e924af1c794d575cc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af09c24e4ba72b111905b7f2e28b4a7b457068fd51c451ed008b144242c5b8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3032d081ce683dfc256731e9bc238c9dc09d79df91a164f6c6ee494c11f977(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98ad59d6f7c0d6e430f6d93a27bdc81de89b578e2e538a320ff83c5b5c84bbe(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b0948e7d54bfde228916568190ae06fb10569d26514393898bbe880389415c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c879ae5de1d2614ebd782aa333085858cc4cf78c4bbf4209c9058b80f3f1f705(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600aec221240e50755a638a2284431a08782c23f3be15154121947f91c664705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3445471d2500fb3e95c4315497e0e9465119009ea7f54fb9a6dc8fe00bbe0e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840e1bda0d8998d53c387b917fec74d481a493de9df415839c61b5cced012f20(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed2ee439d86188c1e56302d60572dcd044702f1aa8a9c13d85f6e071375686c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa777c8d505403357554f26c948acf7f12696ceb4b9b139523dcd48d49b05f8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1453f51c0422652fe9b9c0ceeecbe8515836c9afd00a10c7300564f1052ea87f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9b8d9871d8afa1b3b8bc22238234833fb38a897553ba189a1c9773883ef128(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddefeff67a3537016f62db9d9c40a2d7c86ec91da83c6afb70ef8a776f6a663f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17c84d0fd1310257b3ad01ed402eceda47cf1c9fa4f4ea19d3c74b24249c46f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d0bd34513d1dcde9a465258d5777e0f669b14edd0603620a7b9a8994e5d4e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7bec1134abcbed3663645fa58bd3d261221e4e5879f71582634fdc5134343b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8a0a5ca93e8f82946394acf28c8131960a27fdd703bd56c0275e4b4469f39c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc4019509f81f2120d2b1691af1b0baa11b78ba285790721ac5fc1165fb9b1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__359881af250f0b1701b66bf1be940cc18d233ad41e8f05b17938465e3c03b700(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1397df8fe58f0a43d10e9efcee320e6d11198aade3a822673b2d23a4467fc0c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc8a8c3ce5dbfeceb89ef03fbddd3a3bac94e083c9912c00cf694c770d01b1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc8bdd38c154506e4768afa18486ac2b635732f9f9db3323af8e5f169007620(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54422189162bb2f532d6dffcf3550a884549039aeb25cd43b5a3966bf830dbcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf6bd14bca5f03afb643ed3d2796b6dc9b0e5a8e9f1dba4724f3af9be098fbf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6293b9356397eac37e588416b45e55c059b787c841b7da06ff2af67bd6538dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b14fc15873a935d3f8f4a140292e925c67dd307ccd717b93f0dd69276fbedb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72a9637e5ef9242453825acb6cfb8b4ad5a95b4ced1229c6d6453c5c168d544(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1881443a710c1abdfbd786d7597ec818411f6d18eb711938655bb7e49045ec1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8073897a7187cdaf66e035533f0851ad026fb857fd20d7e870703ff3d43f800d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa25f5905de1fbba916042b5291dcf9fc718132feeed2316bcca11971e16862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9287d6eb408dbbf280b5a97a5ed187edb4c848da8f589de42d59580efcf862ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca1b9eafbfde421083d7e58e15e23a576199404e7252f21377ecba22e912b36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee606ae629dae08df5ba975e57002dff0847c8247c88d98c065fc391d0d1c842(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0594ccceedf841baccc656506e02eba55baf582a424559d6dc87951a1b8b0b7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7afb7c42098a07b545920201e7c35470cc6252abc5f8ce5cbd7ba7d39f7dd5(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9982704bd91e17535d0695f882f89762783880cfa6cf1fbe45f862f781875356(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4541153047193357c636056e9fa1e7f5eae5f5467986bdfbb05dc2602dc08a47(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23a69fa60b61d7e8921883037f5be195ccc96ff302e4c867bb25588cbd7de91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07e03e2d2ec2f48a6b085b6fba537ab2815bbcda96245e9078473e4ecc86e44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21971e6a813a071ea8ef7a375a0788e882020186db6f9f26e2d1be30884ba64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb1692afe41bed8659512f348a8bd43300f5141eb18d5130c394eff98fa0cc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddeb8b416e9523d6ee0cd919f34b405202dce08d3a5cd2763c73574ed8c7b193(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce943ba9192f997e4cf0b1f5b0174827563d59e411d0706630f17482479b534e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f859df2d5407fad910f2c24ed048188db22ca12c7facfaf8ea91bb378b4c988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a134f51785f57ed91b4659947f5b908994a73f6e219e2a589fb071931507b7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733eed5ac23394bc49e1a1bcb9f59186fd53cf789a94bb3e229608f4d361eaf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88c436825a734b758c8452efaa22cad32687e63109801d1585e6801bc5151ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7faca622c4fd9c20c941857cc211db659d64e0a20f72586e01490d68418056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__172ec983bc2cdd0893dc3c6e25e454f6da67ae8b99dbfdcf35a2dc5932d480ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad302fe8a78ea8e79425955fbd4c267f98d1a1f73d68aab68a3d0ee088978c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee97c285909ca2b7d400b98e07b9533dd66a0494688b29eb40ad5525469fe25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ff0c0ae74d48f61354c226dda095a71ad7635611af8f7c35f131cb697d898a(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8522b0f26984a077318b9692bab7235e99e5543ab59bff96431bb64bd718b554(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98afbb0795d00830abf228da07f277560acd2b2e72881a85a3489184022fedc7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfea885a8af3447338f3ee3938f201f2e3de7674d86d0861ee43de13ad1f30f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05f2191186fcdbba0d681d56cf99a3382e6de9dac3bbd2880f89ac5f7a0cca6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c0a4bdf3b656327ea942a6da2550d44300ecc4f268ccb1b469cdda73c1a969(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9bed713fc284a907e222d949da201ffefc65c8616f37afbc49b38580e7781c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59ae7fa79e2fe42e3c9872cc2d69530d52246f348f80fa3751ab772b572f002(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15ba31b752d5c05d06c1f2757dad8bddcba4e1ceae7b394496b9ee69b912a1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c005321376c281fa139f66f5a461b597824b5888fbe409b8b26ab219d75ed99a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb36fe43ae986b07274cf6c366bd4f07838c976cc81325810a3fc13fa0dcf411(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c04c1cb1b16d6db8f5ea652f0030ea9bcdecff17c5518df0b38a19cefacdaab(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2874ef3b40d27809b07df94b18540a8ad1f7a8ba110a5c75967bebce7a0e647a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fb54436b241de2d1b3f32a0dbef353003b0517672e24ae1b0f295e0068dd9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4882650f26bbcae264a90e03d53184026b2eef134a647f32b64c9a8ff63fe3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f539d50d2bfd4e18455a070d23ce59be0331b081c1e3b87076c8038bcaa82ff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b548fed0df3f471f936577aee5b6baf11869f9267584e8ab430c5501a6ef48(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3be29934540da6d3ab24ce6ed0d6b27f959236baea94fcbfe752ac436b967a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a0eba657803869988dd6e3d30e19ee89cfd835c48c5c8bea9712fe31fb02ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd875f773338f82b41f8c51015d88f2a9e2aece8d4c44fca504a5aaddcf382b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ee4311407756de69b8ee240b50b95adcbde677a4f0c09f9ab590abdbfb8dbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185f1df7e59e81d67873817416e8381b2e4433778ded4aa7b036ea54578b8cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed92580c3b1a3dfa8d024b43f138a1f0c8d1f2c5921d76bb0f496c6f0c39fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80eac0b721844c0af5ac5640164122202fe7d6c485a8ab3a447866c025deea3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0615d37cd6ed73f4de61e294966ea2e0c13e3fab63ccdc146a7d66a068163da7(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe632f568a3591b74d7c7132f74217557a91d4dc37d5687506f0773280b4f5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc18dc8f80e2bbea26003f1fac9006bc04470904a6dd56b72f39cdcb96ee5ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e3485c1cc39f505f4362be1642b371b255aeb6f897f2d0304e7aebbbdbce06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e6810c3e3d5b4426dc6adc622077e9b915661a6699637069f4ba0314fcac97(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1b6cdeabb7f0fc998ad970ab370db26909a0b9c881bfc05ef56ff593a8f564(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9246aaa96f00b81e318596cf4971e8ef547f6a51e1e5abb1ce397b15eeb64ea7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5c356fdd2c11561cbbd822a9080e4c381d944626978a5d2deac088c0eba2cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d8fd9fd74560a33b86071895fb122a72bef165339d42477168d0bbb84951d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4994fb771a552f9306dee96ed0ecdb0b89d9e082c7f10b6a1d2dcf275aaeca62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75bf97270742e1740d437fc0da112b3765acf5178cc33805fec2c4b02f65b0af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a74cc32104ab376cdeb421ff2c5f574bd03b8f3225f62618ff3e60717de9a44c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006dcd814a176dec8c3b2ce58aa6786cdb9a8f1b49ccec64da538d0f6e154be8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81cef071d1a1c2f4dfcc3f4c9041fef08ed83322a3451590ed0c02b8add6f718(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c05070efe056c1e69f5722ee81cc3998cbd3d60a337554a1b780082d8415cf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efe365aace428f5544cf37388e6d36e031a0f43e6347583b39b586e63366c06(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2dc10270045efd708c846fafbef081503485bc775b49ef92269af7bfda6fec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b255344166ee474e8411f29ea0a698d526955f9c7873471761fe5074a29b5d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063101cdca53abafb4ed5dffd921ad61eb0067ccce3bef060ee285852feab6ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee81bf979bc8bfc423948e87dddc3047793bbc1ce4d23547f464a1ef854ac4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090b50aa78d9a6eb0cda151a6f39c0286ef3ad845c06cb15b6b131a704f90d6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ac5937777f90f575c28ae69067c6d4c5e939e583f943697c98198fa368934c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b41fd8a7696610e51884a5ede20956a932748954e068a88db74f152a84762a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d891d314716e5f08d09737839e0434800d3e7e6dbf165df254c5017f248072db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060c5b963d3e4f1c6f012df8f63932503191ce0e84650a4df31628d732eb42c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3fedd5f124fe901919e0273d3774b0f182c0e69e25f670b7835aadbe491fa1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e979c96a54edda20ccd8ce0b83778d847d2437d19fcfd1e71f6943befd2369(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a34b3bd95c274a15ad24644a5c6dc9d84e7da34c9614da0604f253156ba7d72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3510f9bd289c28a1caa7719af61f42131c50a6d8b9150858b98895c6be5e7f01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de5efec400f49ed7058714cd242ae2bdabbd4bb58b39c1af37fdf55c33ccaa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3916d8b1cd4c3f807e87174e691a52b1d1a773fbc1d9e0134e43b84797f673e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f9d664a51d5927428d83f087ba84401a8e74bc372d3badb8e4c9775d6cecc7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f963c1e247d96a2118ca7c103783e4af0a1b4ce434942f7f4a6184f963010ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b99b123d8f41713900742b1bb541578d33c895f1a7f4b2fff26eda0dc15586a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c70102a4c0ac80afc39384ca88da732a9950c10c0856ea3f711036504364f45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1f06b986d68c8d28612df2eaef452eca369de0c56760da7b4fccb514db039a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd79794988893dce74ef74337c81c44f742fdcd5b139119015361973cd32053e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__645fb605b969f0ee53e72a7aa180d3fe12632ee652623100a547d84defd0314a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b8af8141af5e10f4f03e35c86c3eda28fd56ad0e61b78771f91ca736751efb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec6c5e4a219310e230103787545721641a7bf11b307f396b104dde6f0f66146(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e48258bcc134b236db71992e3f8f611061c5376d3f651f8e0c6e9cdc55203a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd6dfd038f9ed8f2edb29ce3d0f9581ea429c66a966d51ef32c7ca71f8d483d(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a3bba8791218e4882ea9bd9f1342f7e124a42762a8821c3816fcfe1f751cb9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757c2dee352eb3b8ff323e87bc7a466e0bedf11013c455b3b7a43a76fd348ce2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1088c6af4697a484a76a97c2fe1bdfcb2ba10ee5c4133b9acd29a49da22be7a6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2a0c015b66b1450993bccbc4f41e0270c141f77c000966d87eca38e40cbc6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__369c21939312c6ea0daf7bd312f59204054fb0bc899509f401b58cb835e11a9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890488b748d0891ee92deaaac8befc7678f17846c68e24b135fa14d5731f1862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b6523d8d68eb908b6888d64713701c6ede4137b9948999dd1400804e15b9e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f2d2f0207663fcee0fc02ce21ac6e18a6491f15ce6a374c445b9ad68626ec6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da42cb5cd3c374780d3b269995185117ddd3af9c476fe3e357ba43d633a58bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a651fde50e9783e0987f091a99de994e10373d4ff1b564d8422fe08e1d486733(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b17e85c77995949fdd54140f490ffaad5432b50df2c077fcf106b8e386ff39c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7eeff0baf1bbf2c02c675e276cd055bf08215a720e15326954a1dc3b55c6ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2527e61a4007e434902c6578edd511e2232f396a826f7b942822803d792a286(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3cf0f29f06c2bd6f1c0219feb26651de312ee24f98d8cb75e7a458889d8096(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58bd11b263420977cfb330e74dc0dbf4b996120a142749bad05e0a504d1a3cea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3df79d4f2d0af5d69364fb84aac19891d914718f32fd87f44964bad4998e39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964675493e81712f6a524b75a6480a73507e10e1a884a38881bebcb69a3b9e7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9659a97a34cda4d03d574bf120d3f6b8a81c3c77336f1f44de732d9ad1b85e99(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd30f4c0fcac4d4b8ed84d152cb395622337caa4029f84880462db8a7a8f4b57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb39aa182ed2e9d8d548a9ce3996438e68dc90223956502c4be103a1f9a1aac0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877a2a7de7862d307c809fcf78fd209d34c361fb07758394e4681cc67717dc7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e23f1a112e848b3eee5572c8e7df363f91308625c8343b74b92fef20c2973c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77390c2b27a1c14bcebeef093b100e266b1da306605f4e6a58c6efb40837067c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb2833011b9ae6cd047d64d5e85af65a3454b7c491d7b3192d1ea24493691f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce83f15fb1551aa1f67c09bd77430a109d3206f3af8a74f276215780e986f4b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d5764f02a9e19da46c2f23658e3129373f3315c40e2ef68c5d2c5873296ea6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942ed1fa3d09e0f3e01ca5091ede1c17742aeb3ac8801282f9e431ae3c562c31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c3139f6118e236eb590817c1bf3e3284154235902d34ab236372a1bf2055ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de109b153a36200afeca71fca6411e38d7af14f69370399ce195cb8fc151cdbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995ec40b3da64bab7dd9b7885870ac06e8ce77834710f4567c9e2eed5f6c0f07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9370fcdf332c16c09ef177db06459fd01c95b0df67b297ed15a3b9d45b06d024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d11b5a531cdc4502a6733485c1542eb3c00af8e25918058e0142ef9e240516c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad1dfeb0f139874e01827972e71873b9ff8ebc2b0a2ab5add8eabf5b6d27e8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c04f8a10451b21d2b7ee39dec544b855d9cd33532ea7b9e5d4a3046214b8fb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea79854e17a21784eb7ca1ed4f52f08c9fd45cd07858a75ea85426a8b2f071e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a39db112767c8eeb817858e06fcb42a20ee216bfd30a356e9012e11dd2f7b58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e463188d6bbb8fc0bb2a7044cde5cff712e6785307f9c7a960509a100b821c22(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf9cdc4b2abc89133f1f3193e3bdab8e3907b4b0035d1e116ceebe59054acb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21498f153f6088e8771b9173a5150dcecc75e671988c3ba0fb0c4809e63e26e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d9011558cade372300cf8fe73d7977dde0644175360681d2c8c482c7a149a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7409d3ee60a55318c116b70ccc9d4a4abc36ed8c7775948507adda43ae0feaa5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b44953cd84a8e9045c14ce02904cfad37259f68768d72dc93586bab9e5072ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08b7114de66b06c944d8ffbe89b6aeae97f769070031e3df87e6f77ebc54024(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fa0ac548f8e83f8412a32eae88a9d1bcd5af2d235f608342d40bcf4b78c0b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078124d19b3c0b842d237125afe49a7b3563a9efacf8633fef17b13215756aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab8ea431bd050d25aba6cf1ba1a626372df71a3742c1b12bb9d547b7a9431ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cba79ab1a86026cda76f697c892761a7b0847aa42cc14c6a93d9723a2d0457d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__defd574deb7b9b04790a0d0a80bc845d076e109dfdaa2078e2aad501cb879d18(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf963b168c1d77b49dab7353268bcc2a0100d4866aca6d20dbdcda489219a04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc33e896d5d82244efcc69090e7c6e61c1484d05172e1f92f00f5d5aa0401a7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb6e997aad70e95493d755257919708d9b24505f0baef5d02242bf6f2fc555c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5709d8290f468b26bc0cf4f7ef4be2654aeb2cc1703219f1e086ac7e1c36d45e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26cba16f1af1bcae6aad73d2e5f36f71c54256960c4c2fff1d5082934139050d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8f32acfe3368b8314c277530f1df2697a061f6251d8692448d68837ed16b66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b33f77fe529d0fab3febffaa2cfee431a073bfad0c1e2cad27d7f13cb819db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff8ac3310717c49e187d3cfc0abd80dbfcbd5db30fcdf45d881da490ab24877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb48f202c9a1f536c40d6fa176afe244f06fcac8fa8cb2ff3a7fb12a45af4f6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f84a5a4e1df37c8fec31bfc7c545ddcdcc3711fdf118b79fefe0b46d55424b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b950b02f029485c663ed3edd01adae75acbf2e62888b467049471442aa360347(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a902faee694f108f522c51eb064d8533817fa46955bb1f376c430b11d3793e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1516b9f6eb63b9ed98314516926bd50aa47e4695ae2bffb0fe2965fbed360bc5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d5d2430fe10ed1e2b8e6ea4e611ac43dd630a16cc8146f0fb1bdabcfc48f61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18de02cfb70c6f0fb030cee696eb1f7e0c37fa9ce0d16b27c6e0007eed22c519(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__299320d2973d911aa7bb5a9fbb4e4004ee4151456e4edb71229849b4dd3f9250(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429d7d3a9e2e23ce3c49ad5f8eec54d3d158597b2705588e998c2e2b26081bc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e19b865adb8d89f5af3fe19b1c6c00dcc7ffaa8cbc5137b25ecd3fd989760f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224470d5eed758ed2309551f150110269309cb350841911ce8a8473d5da11b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5526a6a6a27616dc1f6c2cdba25f687ff9d8b1ff32cf8443a8cb35f102a679ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8568a8f77b74391377e5865bec145312b3fec830992322214f13ad03cfccab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be107f3488bffcb8ca8a36f530fb791d33acb0e44c655d2fe128ae3003ffa2ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe0b12164c796ed884f522a2dd8cb84e78f0ea63aca072f22599e7428a5f232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4260b4a5d48e8ad8b8e40d5072d79c0433507dd273d6f9216bcb41eae8c11586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c105d249fb0a503c1d5eb43cdb8e3c977530ac5db8f0aa16d4d025c7850b9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6802c334f4d4bcf4f5a269d2e8810d37ba10e17c6b1830aec4c53b32a003d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b319018945e2c06462bb0f3227e4b15d0964cc2e4c941b67df38fd569cacfed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3e8e1ad4c759634f12c360eedad095671ac897e12abfc007bf062ebb485716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded853b2aad89cd76a06d8f6bcdf8be85ddc5f5953d795197ea8c3271bae880e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffecaccc57cb6b8bd74cba3d581e04ef573f57acd7a3f2135995d48b9326fb2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49401c34c368078c08f1283b547ed35eaf840d888afc2490870423e5383a4af3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c0ff81caebc2f447a409a136605a0ea2376c50cabaaa7657b07aa5e82fc3f87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0426f2d49d2bf34fcbc856005c16807978e7779ead4ed87a7442d285f2366c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c470c5068a35c99a345a91556d04146fba8fea83a9952c033a821a2f6f8a0763(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7b0b9d992bc973159b83f50fb7b3f53ba5322a7a1b27b1a500b90cdc30b5f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25974e6139848defbdf3e99e69d54482ee5b2e1e1bcdda99834c58694e0fa84(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99daed3a3bc6c2cd219f1eb80539de15cefe54a883ecf399ee1f6f2a0fe98c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1726cbce459b2ad7a928a9b574f29094b5075926dba59f75533aa3a071ce5c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0172df8905236c8445c2293195e492c275a6e7681d57159510e8e495ec7ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3ec5d35152bbc8d27c026fc5b845098110f757d03e42c06c960688193c9e1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94861ac825d716aadc18a9c689e4ef5a8bb68f49081321c77c23e343c8c4763(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba86d0479e48546a166c8177221b1897735013d8fabd3791017cb0b5160dfd83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89b4aafe1d22a231538a04d6147482200ea976a8048b09f827abd3339f57124(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f75e34a3e89333999db8e7617277f24a9533b0d08b2406339c359007335c9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fdf2ad62eeb3a03136740022c5668d22c99f159a509502b49ff2a41cb1f691f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8ee49250e1f91b58bcbcd495b49e831d399ef62abaf6e9d7358008e4b10165(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3599af27e7bb49a530b3c4bb0535265c5799f435cf27bc854e15e4a1f0359b1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a64fcd08a4c14e287cc6a367cd8a21cbf9a48334ae22af29e2b67ece4046d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f95b8df32bc2dbac0082f243fcbf7577c999d10d2fd62ea56578f911306a200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf1019a8a632c46e2d32035ef5e2745a5b4dab4ba150ad0d718e4c5ecc0a30a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531764d74f55f40ee862940fa6d43fd32a88408d5cc83d8ee7ad35350ab53405(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e58925bf75ebcbea88c65135d7154c5f22100bac536fc9195a8c6a341913f60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801f9c7198615ad1f842af41fbfc26d7962550cc7bafe6bcd93b1c9e4ce6ecdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466b26dc8cd016402b1201ce5c82695e16f5c9106fc9fce66b300b4dbcb53d5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c4b300a1cdc4aeb90ad8673c2ddd0d709fc1c9d8cba5ed18444cb749704fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec6624bccc0766e8ceeb792f77aae6f020cd74c4579e2f5959207571bf29510(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a9b662c80dcf28f7750fa378b8f807dd65fbb25a6756e287e71ce4f726e3f5(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13130f6fae9cb123849d2d7ceac62aa40295e95cb804ca98da89fc4ffaaecd8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__266e6809fb0d25659b9ab3d8bacaec96fc694331f313233542dcc3d6ac32a498(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644c00ebbaa761890d22c5ffe474798c8c2bcc7031a2dbd2b26fe05a70511b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108c5df7b8ad490df078010f8715cfafd72fc9e43095d1d6a8b4fdc6c23032b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86c0e56ea6b06953106e32a4193732937f3012d6cd58350f752bb10f2957975(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e223085b03c29ed939256a634edb44868148284494427e9e0054a8f77ad11fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517cc6047336cf872b854c32323ae82750c4b38e07a41252f4812cc840981801(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef02d75ccfb6f39240bd6cdfdcf432240499b74146759f21436871f39e82df8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207f4fa36152d30bef457a84cf7db48eaa03277a27099d664e08ab88bd66f4a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f152a40df789944fc6f1f0c4c8de5d3fb99b2f2a96d2b176671df47843fe0cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8020ba895efe2daac926171427b9397abec4f38032b9f31cae4771f6615219c8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5cfd9c5cb998b545d743e5a50a08e5d507c29a6716a70966fe209bb4ebf003(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12ec464bf2a877e9704041d672cd2192884189e8764dbde6133f8425f9cd71a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436adea8bae7856a2584d5d40f86ff231bbd6ea4f830dfeec2a9dce0fb4e76f2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79488c4b8b668e4efe7dc82951570eba6141a2438463db2b4b2f2bdf33e5b7a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7571f4d33d85ef9eeb82c189c3ccba77545737fe490c5df6118d2df888fb68b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c0cf9a278b42d5832a03bf0624bd6e03969527d8826ed35cbb547bd7eded5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ab0148bf4ca5c860304f06f5f41e06d5affc115c28264d9bbf4ed7ac5bf44e(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a080cf49b869ab55ce5bec4adcc1e5d7e0e5fbe1d64df9bfc37b8e982c2a58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41978f7a7cd188e386aa8f75b3f1cdc797c249246936e5240bf6557449184cd5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e4abee961b3a0a6372984e1cacb4dd481034904e9f6b7475561147314ca6a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b33e4d1c1157da580dcc71d01a51179d8c17b3c9dfa1507ef654a3c0b9b5a520(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8e931666ce7b38cce8c5cd50aa466e9c1b2ff88dffc811238fd7ef81a96989(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b9e0bb8e4c1923a8483803a38409acbce7f48c42c1da0a85cca0bdcaacd0f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e39e7f2dacdede6a41060eb6812de15eecbaab6cc4cd3f50c8e2c8b7c7ece5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86ccd203e9920f65609451b1c6de2cc465e2216e6b5cbd5a39a2a8217f3c78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c851d8de339fa472c09eb28cf8fa555640833ddf3ee81fd91fb78b6ebbf06c77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b13206d99c77b0e2c1bf23af82b14e1615c349438c9aa63cfe3819b1a8bc28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9deaba1a2184655c3ac1155ba2a8f0796ec530fcae0c509f92aac2303d4b64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e58d60a5607c92a466c3693a0a9a0813c80e1502f6d3323f4d2dcc3d8dbb95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__992b5904e053e5cd8043776f38735785794fc0cee0a586950e0bf10e5460d9cf(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48283e7dcfe69a45d7e132b3d58408be62075f4185285bbda48bb0489cb6f9ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3150c9ae3a60916c3ec5ec9d506cf03cd4f2ef62d347dd96787831b54e2376f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e535e7cfd15319cb801ce99ca83f89d3368d493f24f8a307e5db91352a8f09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79260c53288016f2f14667979185ff76426879d1c554c46f74feedd1b12574e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285f59fff3f1090b3cdc945e4e595197404aec43b937884bfbfa8325dcd64ad8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f6de3aebcf8e31bcfe00a1682755d731abc3218863de9a181336c45553e4ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1131f761211154b0e4179f3d1c4ade20b7c9421157e3d3f3a3b26712d17009f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d4808fd16ed9e64b3dc7d86bdff0f32160af33f34948c72b48646feaa34678(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a78b6e851ff726fefcfe958c7d3f5ecc39ad236a54450aa89a245e36b742f9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cb9efe1c50fdf7f875ac9509c671ecbefadf6ee3ac066b30f1b6c4a6432be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2131252d5170becd2cb976d855556587c31bd694a0fc116c742cca7e034de227(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f03cfc324ecb9dac9f7d4611b446b6ab3763b1263f6640796a599e7bee81e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e00cf213940016ec5c4e965d3040b323a9ebac94a6549b38de2986381c97e8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab52042a06bf9b70ab8e74bc28b2a0f8d26d5f1444342de7d25f524ee5eeb498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__814c4f27dfb76fcf9245d271997010d6ca74459597c1af528ec76d97fee8a3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac2664bdc78c99b70b1577fd9805b34038e74ec1b0d74a1222e4abc0588352c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__391fabd1e43990feae230aed1a303c0b5ba496e8818a390f1276372b5dea4e1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d346a6bd20c8494c124ad841b18b72aa24dbf1c360c305ac1a06cac9eb8522b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c838860878d43fab1406a249b6ae0dbed23515811596199f7a8d8c58512cba3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb519629afc0e9764a04d96383a0b705c21a9c15cfa0331f2e872261e36ba6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3310387e083f76d79af1044dab658d8f9fd5432060ce4e38b1112ba1b6729dde(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e480ef0fc56d547afd9c247468742f6dd469207b82ae55bdc89ef449e2acd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63a7cacd1f3ad02021df3b9e76de16a2056b89bf8f8d7c431313adce3f7bc52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66eb2bcd6a3e5efb75d9cf93e93165f2ed282fff754c1181799be30f5eb33da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1f5f1bf5747968c9d4b97ccc45ec12953247a5d4c2f977f99c3c0e39d3ae0f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe674ba1fbca2c47ae19b1b8af515f5d6515ccb55563f12c57f8fa123576208(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c7dbb42bc5cdd1b3fbab46c27f838f7487318ce58dd91e656c7d648e2462b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397f8bccd7c140651e1214275bcdd08df4407a34cc2a2dee5281b5142abe6618(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e700eed3f8b4cb17b3b2cea7b6ba634a22335f294e7687da53f8179ec4b828d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f38c36b0be1dfaf757371e58c6cfebd010cc60736f3ae8dfb74800361262373(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac95e2fe69a44260ae4577a8f40da568359be2fb0c34f685d7c7705d176d96bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21100bfa2877a0245913dbca2b369958e1d53be18049bcef6c2d91cd68cdf8b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49d31fd724bf5d9b9b926fb9a6fa0c69cf485187a4710c503cd1a7a6c78c27f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7caa0c3d3f68ad0e6994e6067387df50ee17416e6ee6cfa052bfa88d6d208206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daaa0bf97325ada2749f87fee62b0a6eadff5db0aef303a6f8dd3645b630337c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8786b7382141a7e646294b40a6d47fda2f46a5cf41a170fe47a22b2d7b8bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f98f3a76ab345b3de7fcf86a4a9a113cda742093c188c54e3ff7c67ac3d18f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9e1c9242a83d537928170e60aa6747e992d1c4bfbdd92af88b0ff5aa6df3e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df863f510e787c4eb159f543b5317cd37874023d0bfd4a505b994942d6ba79d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b061d74ddabf503d5b63c9ffd6e46638db5f314860886c6cb7a091a53eefca8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68ef2a27bdd3bc1ebe4f572b8b8784da84c07d9594a4bb23d0b06311a5733d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38c44de125ff7a79a669240a139cb3d65f116e44edefb3bce313c4235d58582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47efe135998219610ec2bd55352beddd6822e9bb1667936f84b86aedc57c44ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ec0d589b3f8edd98fdd928b17b3a819a2a7659932e1aa9ae8c7877acbecb07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34ae8b4fcee6191261cb3b9f226cfe3f7adbb175abf50b704ef54ea26db2d7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b69607262f74aa87eacc3611afe8af6a7f803d1ac4299705ecbadbead98912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__594fdb51c083ed521491554c468ebcf3f29cdb871a6d5bc9cd88732d5bff1605(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a57c242f795c5ff5e4e62f7c9da9283a31bf8d686eacb6f3b871f6779d187c3(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec21eaffaabdf21b3b76133f4b32f993708279f89f81d8afd7627f990d419c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4ed4e5eea60741bb1629285a7d849a8063b6cb85a8996c0245178f1dec9761(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db4e06451e4f02d79fdf06be6e7b78e510afed220749ca477b7f17275a3dd3e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862d7175c4cca10906f5ad42c82c3b0920549741cc6876b2f24d84a2a9df12bf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86e90f1377b33b5a7baa8f14d1f16b1bbf85ce587955682530583cb9829be11(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b5327f45e1f7599893cb9ce2f197c307919651acc9f1e2f871bab9f7e4aa14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59ae6ed739a7fa30c1878d420fb46ba7e35f31ea382b172a938ce0b519e4421(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91755d0608163eeff5c1abffd77599e22146c630d78f97c47c085c1dc7dd19be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595ea53e1b320d3a03c9d00822491956bc248a733a4d44bc25b7c71b2a1b85ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8426fe02590bf86563dbcbbbd6a6c583b9e3bcfc20e62f826d360862a406a803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdaad36a740e7346f81d15ca497960fc350b82ea90461db2571771838618deab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275ff5026a670ac74f19fc993fb111681a146118fb3ef6ff7a9b658bc6ce22c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60114388d8986b8aca7b683c8f8e5dcfef31cd88fc144db79ca1c6f72665e691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6c53dd213cc03dceb3bbcd654268595f0e2e8635304974d277be0b92ec319c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2aced69abefd40658c08459080c262098815b82775052d8ca4121e225a4a869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6013de94ef9c208beffebc41442173439ecc0f457f4f309802325621e689eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7022bb2968edbc9f624ad5b3f6dbc0f6969dd1b358b2871edd8210d4634ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9b81ceb68973d770301dce2153b4c23f6fc67536297619469c3aec1ed4f27d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05974a9493cc696cc0b2ad849247c71c624869accc761e592f5ba51e4bec886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9b7eb695e8321d6c4252375be4a101f798bff61851f091c8713854e78f4365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7124049ff0733bf0198de4699beb1d5f14caa3562a13a784e49668cb08432ad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ae92f4d4bc88bd14ba88c1cc54f660b410481187b97a6a98c172410bab26dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669bfe324a198cdf5289c9bc300cebb640409c7d9245758de239641a089bb606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1ed2abfbc663e8724d065e7af9d5f455e5b82ed74b45115071a42c5c255b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6ae0c104a1e2e65e46e18619643c32f729156b1f02d24687bd74aad824f674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382f1d30600d88d0ec74dbd55b94ae9c1b066003c2ced8be010b716e121ab08c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd16fff9ce23cb5486dd4051186dd92c62d9bdcbe80119280bac865ac052c557(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101f61639b7563d7c75987ec3da5705080f21a45efd613a6bb9dae7e6bebda6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e1ac2dddc4df82dc4fd59306387cd9697d86e82d2b25714bfb02dde41e23bad(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acdc37fba56050a08d56ea5793a354d3e62920a1ee11148dabd8e8b2289db6b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b773bcbd72204ee52516b0ecef372cb75e435cdc02119041a641ebf6d990c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599221f2e55f7b1e660db0d9970ec4d8282c1ff0f8f31fcfa23b7b21842a553b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154a756b1279d79497cc786dc04d541ade52832f91cc652e0c1615415d63b36b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d784dd54c5ca1c81f0d7d1040dfcd902a055b651c54532b9f75a80b54ab08c6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a2260e8634745d39edd3df7467a78e1eb9548e32701b7608c6fe4d30521ee2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748d48b30400c00d6a9a5b4f3b2add62317965574eb1a1fd474553667c437f33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf0905b6c4bc1425a8ddb366de7f42b8906afde9bf325399ff8197705d355f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77710cdb38ebc414ea206dc197957c70a6d8d438c31717089907659b550d42d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eabde89f0c25cbe776e78e9019218c10a9fbf47c05500e2919c8543125acaddf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad32b3079a8ebc23bcc16297be01a2c227b008b1478cc62670b32a27a91ee4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fe241d4dc04696dfd982e6f465ece9d6fb4f1f000f65a163d07e12242800372(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b172d2dc14b8bd964ff74984c22fcff95a269aba7eb86d9d84a4c0fc95c915e4(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b79b659bfcce6ea18707fa0b8bb236324e60471b588a425f2cc080ff85784b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c058ae3b8b84a959845d7b504efe87353782d551df4804539e51631d26d890ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63d56fc413407e9920876c125b065ec79da0a9e190dec23fa92793ebfc0aa38d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39cbca890eb555fbcbfb78c8094e470563e8f267fa61e9241517156e33f11106(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc929ca2583dfd45c791f0870593fe0c3ce7431c877fb260b957525d34a6cf8f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35306871231f56072ef9d53cffdac4df52f355db8083ba7d09acdc49d7cb0dc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242b8ac4c17a7c08472e421797b1be03c05a6823b43e2f64ec05f862f3524556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df56efadf8e8e005db5e37fc1dc44a47a277aa518168d4ddccfbd8d80d41651d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70ad796954d155f2ea91758f8c623bc4cf9ec77a3d8b59316dcf0a9b70a4ebd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e413ebb701bb0c9a36d667a78a83b5faa6cd2ad4b503a26e53bbbfb8d51be0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a16b1e2d36e051d5283a885688f645b4fe108fe8566683a7beb962854b8256(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5403d159d11a25c9826d0615f3214d9270afe38d84344af568963909e488c98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0aa240e374b5c71384dac0c4c9e443b5857633e12b9528959d90404308775c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__712ce61630d246c1f5f2a37ec4644bad63b6156eb9ab0d3a35485b45e0c8d47b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd58d88f8eb29a95b20103e5725ad04a82924a5f4b06515a15c0dc246f799a85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf9a9fd29c060867eacc7438dd6967b95197a14a7b50fd8970abfd1ee6396ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ca3ceced7ee9a8290489ac4c04630c9089cfe58733fdf67c526dee8c919dad(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb03a25639c3c50f09eb4a09e56c7e8448ba92c25255371904517ce6d17c8638(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b68a5f6ae67e3716c07122e370f1f6323efc944515e34ebdf19b4155157207(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67101b6d88bc42f7d7de1e81d3f94ca7987541b28a7e07904d4f54d936e27441(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe919b952927ca45475124d68b6e69031257799c6ea9207de7a0b16f708295b2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28aec4f527c7b58be0209d5bba3f09d7b35a16faa21819129aa2b75b742799b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bffbd265764f577768833952c6712618263ff302311f178d8fe9623d1983b43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7c9ac3d3759851730e04900f57af0c0ef8b9a5dd1465f42220c5545333f051(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e979e9b863fd8074a508372929f533b640ff73a5d220eef410ec5eeabe992888(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ea5a7621db0b8f55f3b0f950f186aa4876e5c0041032c6b20a878fdf13d0be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a29bd12e204f6ea2fcfec8b48ae8217eb6fb3b930f1f63cc3cc48dcc6c9b4c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcf09d810476a047e8e89e8bba8c3fb202a3a911feda89b8f59f370ac2a296b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bc4000fe636edbda52efe29472d8834e1687fa15e6374d99fa03bd377dbb03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9952896d45cb1905950f18c2858fb113314232814ff937ca04ad4282cd6abd3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c6b1f30439a6653ffb163b6ced467f2aac4d16f683ee914a90de0d1867db906(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7919e40b004544e9e3e7f58217b96135aefd3e24c28d486d091f2800c06c2351(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf1ccc895486deaa93fa8d0939a9378b27cc4b80fd3a3c81580291dfc9c230c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b3cd334b0009aa9a6a2cc6a4fda81c9736a8aadfc1e744cdbb61cf9da99a23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a064096ba15afbde16fc1da48e53b38443faa4a14ee9050a9a44d630af1d443(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f96dfd9f231ced03a343a59731e9ca6f537e3c8c883c9fe1375b4038ace1a23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30895a49670d615183428cfb8b7a27a3293125c1e3a437db0b4fb2172cbab24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccb1d398081a1297162bd50f3c9be2289a15c6b399ff5c754d0c01b5f0a89a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec874551c11142dcbd9c947d14c85bbbacd6b731387f21b19b32af2a4cf0f04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd411137b911f89294340eeeeced41d2f5641e3a4f306c28dd422b8559053422(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746c2a36a5f69af63befe1b58811363ef3f27abfe1631e2f2d41768fed3f6f9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2c98999962f2642361d85709a33854bfe79884cc10146817078e989660309c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3701b68095eeee58386b22e5754215c5086cfada89b7ad037944dd3380c6aa(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9831078130c3dd700c463e72c33c98ef723d60effe795bd756b965b6230e1cda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aafa89b73ddefcba8286021b863b7ba80eb1917c8d13a032ed7aad0d9932eda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb9be11b7b78e418ae9285b785c700f605b52091fd904ece4ada727b4417236(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8909b9dd78217fc0e98fbade41b945f5b990c4df0d6855f61268292985b9f8f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef83c345eca4e184f7a2b162dbbaf2694f3d14dd74b8fef2c20a669d9066b57d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78243a538f6035db383dda2265dd095074b791d3ff3cf1cd70a01691a46c7974(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7456a7aa1a378840c22b2690e5e71822c1cef66e5f7e856c7b8b64e3c222c57a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__542d34c1c5fc98127da4d4fe707c418605fc528a8bbce05b86ef381660f2980d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6673c7ee72cddec8ee3ba98f89ad8f4f2ecef79be267188e07b2c3b0b76a3c95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684384df9c33cdf487e08a9b199d434e7179ea78bdcec9048327d61d9fcb4df9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d6f63cebc06b47cfa53190dc4a515312c342b3d846dce7307387c7694afa19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5699f6ddde83bca44e5b835ebee266ed7c4f2ce34d9dac29d48fbb18d51dc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5dd712bea2532682a50d1c0e9df122cafa5126b47a7a28b5676d25e9a78c26f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1921ba8daa138bea83bba22390af6e131f3df7d375c3172e73e06d9ff82242a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7064fbd5776ce0803686b61581bbc65506d09934b58a39095ee60077f89dec1b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03213c7a8ef656db96465fc1b9519983f7d7909f9ae79572c01dcf88e0723ccf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573061c3a4a23cceb91528ae23bcd1957fffe7fa9d6c97b5f4981f01e70b6426(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf5723273ad8460e49d91a51a8fc94084f2563ee83cc29ad4e8eae0de2a46a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c584d4865f63b13fcb429bb8ea88e4da9cc8a259e06040db151c474aa23bbee2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac578bc45a5abd4a0ab985af9a98e7ef85706bd9a00a8c88c134d1b7398fecf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__480f49179b4c93c187183c722ef00912282da9de9e1c8008e46db9519ef57cec(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bfb8bc332226fa985dba809b6a8db4b23a7dae8d8c70849f318b32f49852762(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ec4925e7b6fe9dff271f92412e10aeabbd30e9c3d49f70988dc1fd1ab503bd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64c6ebb446305d42e7a693fc89454513affb86e3a6f476866384b467ab0e3ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b8ac3cf8b65572aca0887a47e49e249469bd905036d9c537dd3a7d946b26a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2b227cd0a79313872f4a243a1f4ee97d19ad6054a9ca9176085179a101f7f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9ebb66a580324ae9da47a64df9a27965e669b9b0ad9afa305aa98826370941(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa3616b6e0411d3d1bf46608d9cc92e3cf56c8b86bb9491afbecc67e47cbce5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcbaca071694af7120ce8007b816c6b308e470701a770cddd6419fd2d1f7a9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b5129d24856d304281da641fde4f49fe2394421a51866f9ee98c9f410dfd9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6bada9ddac11813008cdc77ca5f587d9c4d16329a848ab556794b57011e68b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419ce132ba1ad7b8c580d9a97ae61aebfc771496b7cff11dcb360ba7edcbdf23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0823edb312e9cce1ea1cf1638271e86b18b9a22e73dcc8b94210d650cb66bebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657e0049ca1e4ef1aeccc1b486a84d305c06989622c869c59879b0a44f576323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6508dba7c186f414312ce40d0912640a35e98fc3cbb47bc62451425bf866cd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2099fbdd69142bfcdc2cb53b574eb783c0809127ba72a1d146686dc4b5067954(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c909568b3c3174fd6511f8b550159d6ddac0f9c1ebd204ae5ff7cc68e791ebc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df303d38352bca34de1cdc01d75eea85191caab52a445fe3391424c3a30908f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d39ec83ab5b35e399a211d1a326d2315a50a0a2c550c515ddf75b67c6a876b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff7e53a9d075090851810f4e1c30d1b791199bbbd9e64892ea69cba355459cf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f495cb1abbc372fe13508dbde7b136a806cf11452a075cbb4e24e0b10533ff17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9499f53eb8570aa5ee94ad0e74d32f5c5c563ebdb3c4f5e4bef3fc846d224804(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6c8e05877034dceaa05b8a27ab544ca3685ee7afb8dfd2be457196eaf63618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f6f48e61c61b73fe6484e0b950794eddb2fa5abae87fa7c973bd192153d4a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce4d0a95d2ae537a48f9227225171593dd84a623b6a6c1ef2054607031994a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a816ac36e91cb60bfddd3a6da00d95a9bc2989d73676b33c9e4cc007f014427(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eaf750755b60796b243f127fc252e52c90ae47ce86c3434fb8558216e55d422(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9e6da6ef071f28f94697019c84033a22610be4dc61ca5dcd6c0357d1e1f3379(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0da2386172e45256b55685976293869ed58e2c0ed6e8c9b0554dd0d5d7a86b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50de0cf583a39f50fdb8ca7bad83311292a776951d31d37b1a9c359bbbdf71ed(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3bb0b584fbf3a3ec9f26c3f6f437018d55d72e815d9e9e5fd2b9a558bc49d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059b6d51c9c32805df1d7efeb700b9782d3c7fa7a0840d29749944284539f7f0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d6cc4e578702a9bbb5d7c401d583d2d0935b84affa8d93ecceab42a85d9a34(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85fa188d283d3479666ad5f1dab31176e81d8567f4fd5fd3198db0c84c16ebd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905cf7a2e87aff236899bb7a6b5d1578378c61e73559598553240e96acefd99e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a44d43957db1045c56287f082c97adc2bf96e3bb24f309ce9272b81ea2b7d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745e95e9022a1536954ea4b35e67b2dbe667d3c3decb49c6fb6db436fff31297(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccac70e20d3c2e3783498ecabea437d9814ecd96c835f7c7e901f269df56101e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d159fc89e2a16310ed688592fee39f78efee8b3bcdf12de0e02980303e9652(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d622d82c3e374c439fdd9844e3e8889f8de6ffd1be2aac6a99da456f5d428d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f28263133cd6e1515ae654d47c8436b492d7fc5904b82faae13a635fd1f2a9f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0498479b1ab4b09e74c27903ad6a9229443d7d2e2362f23b76f037657e447170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f8cbefe237eafa77a665bd36350fd7d846f4131eba6e5eb664a9751e75c662(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804e5a6bde7db558b8be28a702a07e61b42b8803599c18ff552b3f53a3abb588(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cddcd2be561cc27d5460b10045dc918f1f46a01db173d6d67bbe39c30645d3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8f9966f17118470775cd5ebda9d2df2c8fe84d52d9ba89f1d4414ce0fc2b98(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f70e4df98a1886999725b7a7f1845c2697445f3c1b7bf55dd14faa19478f72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f450f87e29da0436ba1a064c1196eafee45f65f4d64b62daf82391e2293b910(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147446dce50489c811992eaf61a8ffaa04c6a8b9696d3fd2c01124fa2953aecd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f569247d1c9912f68caabfb2d66286be16f8eea555a6cf8d521daf32c9ba351(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb630027deb00db26a1c7ab9efe7ccda574976bdd4bef7ed1a7cd9c49bbd65a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b588c31d46065e855101024fa54b1282ed130f2539eea5a23ea6dc69fcb7430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53cfdbbcd2b492b007460a9523fce6728bdf5327b3f3aa8f6daab767b3dd011b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ded0b3191d96d7787d646f463934f70354f12ade5d9dc2f927e671c646502f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddca5996ed4074a6264df130766d3a15909b17a36204314dddee3b9bd859ec05(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6398356fc8cfabdf0dac3ca4c5b0aa738bfd33c90e9bfa249c3edc2212bff53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa24f6e6ac0af12a0f8a71a9606e9b9d1e4ba8b189eba36d6bc7d797980cd4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b7a0727bbf52ff642954b2b5ac05be30854e9d405054efe8026b0e5317ba8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64042955ae0b81b3ec11928e2a4d38f6d34663aab73b0bb916a52bc1354ffda9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3bd7002b6be680008638367faea1ab0b026704f3b426aee0443e07f9ff495eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50bad75ecf1feda02056345bc862190bdbc72ad714cba268de6886904e97560(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0528b61785ae7a40dfbb007c4085ff7900d16be84060596dada0aacdc760eee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1fd829ba46f23508a00d7063f9838d7b2aa772c22e61be5568c2f6a2ba7d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__586ebaba938d61e4218e506743b6bb2084d3582845747262b9c18c1cd3cf5ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055545eeed02187ec3440a56f2587f0d802a20464349dae717d778a93430968f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486aab051d63c27c85e6c44efb76cc897b7b3d8090860cf6744f337e61e3f982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1219e33b8ae2eef0c19c841ac5705c28910922b0001744dd3dcc1e95f6ddfeb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c8c4098030f0bb681c6f7127b6128022cdaeb3c8161200fe5fcda902adeb6f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f516a919c3f4f2ac1da158150f79eda530b22b8b21e4afd081fcba6a1a1a806(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2543de4945bcc37b918be08173b95a90a3ea7b6d42846cb2955b4ac0d7c99ae9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f56933657ded35d80a94d49d328b75b3ea92ceb61cf214569158dd225b0033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e0498e5c6f3b345c9a357b7d5b7a5fac2acb6fdfa329a20acd53321573db2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5393fb35794093187f2bf9181699e602c62d91efdb4cc0a8f4e2da0bb716e2a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5f776d0746bd2dc31591cf893c78c6368d46d6956ea7709aa9e7823a7ebebf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8168198bf526058ce41700b34a64f0861d4b8085e546e96b582816da2395828b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c36852d73974bac035e00af923525a4928561b7fa98a67acaf9571e90bc632(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78bd63b2a62110f889d6bef9655df525c47a259b0578471c8da218e43272d2a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb6ebfef7fb3d56936e0ec6f6b930106c4f7fcc92882100b3be4b7e37e8ca6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63b2d37454c0438115e8cf966c1213a2580e89a77219da7febb8e83f04de7cc(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d34ce562395aed98436511619878931f26b0d6f4c74b437d73c93886b55e7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d23e5c35b895a137e20d39fd14ab31bba69b517151eec805cfdc0533126212(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9529ae0badb654017c79b4814b2122562dc55322099d5100428ad9397e9a47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa07a5871bfb98c248aa58f19e32cc905d1cc081d6a529f43d4e47c16b52819(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338f7b7614d54e76f18eb937d95ae7545ebb3d800f981207e052c1d1331ef7b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e55be3fc6ac0fd0d36ff8996d3ec81720891cc503e5bfb4426ece42f854c96c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c5c59ee42d9ae74a99138252e2b24d494b453493ccaaa9707aa9345ab096de4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7230bd1fc6ab37dbc5838ee43158866e77854e11986b8ac353d16c281e8adb85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17639f631593afd24e9ea563ba6f62bc321125f4e587621d9382a0b8de932a03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e4a976a783c044fabeaad283fdcc089f96fe5f921a92cdb8e055e88338e73f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b16a0774d5dd760256ace8280b85e175038f0d20ef6acd8bd27e0ae39b6eef0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be53e767feeac9acdd01ba3ff30db119dc593825f711c733fe48b7a3e27f0099(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a35631cf6160dde7ac2ab4f32125ab6a2cb436fcf82c3b5501b441acddb0aca9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1758b91bbbe1f5139ade1f92136c140a584685681f50ec5eb82cea163cc928f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1467370dd895f2790bee8d9d1a156184a8e2de487b5f8f30e843a32f093e2de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3542f4da19249137147858ed657f6f768164200c0d03b34f24d31460e5662190(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e791a1334b35a4cb00ca89cd3783e489fc31fec16b947a492bd9a8867134f85(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df11f140c521fb769bc3a8734664c277df5d67c36ae3d6932870e21b41b81cb0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d40b1ab5692cd3b7b84f7ab0fdcabe49d74e02cffd6de2108dce49166a278b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5ad200b93011b14895e3c51a47401e0250f9a655c7ff9f6102d3abf5709034(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1599c0aafb93dd27bef0b01d9606b074bef28e7942968d17649120a360a962(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff0e5de2bcb7889f5812a9b4861a9ddb8f80217cedfbf9e995ded94288755a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0e69ab6b936c90866596f5c6df0490649d82071637cfd352de742f97e359d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a148f64ebaddbab785ea7c5ceb92a51d06280bc24529de25a630473cb6196f0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe142b5eab7184d5502681f57c18d12427ceecb9b884457da5138f585c98014(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41859ca55d0e545ce5910b36cfb8776dda8ff2aa48d41865fbc2af19f8e3b36d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e579de2d7fb783e276e269fc13933d812ae0a42e0d5f3b36596e009b88d26c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f1c8acd75e5ce9b80f300a07814cf6bb4f7bcdef5bd848f17171d92e3299f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511c135054e2a1e078a18a82c239a7693f876622ee5319f1bfb54bbb8f0242f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a5b538714cbdc6db6bb90983509975fad4c9f738f497ef5d20f5d3f66465900(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdd4648019224deb8684cf83c9f8af49d67e569fafcfae4704ef1211157bb7f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec901ff75a692f349865f02946c982a44c4b48b815c13087dba5b6e4833ed1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535018c1e687186734852fd1e9a3679a82d1957c91095e1cfc0825a24f7fab8f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f514481edbf25e385b8eaa72b8fb282ab6f3b3dc171d588bb4c7b60a9483710(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47423106bd5c57fbecc1106b03ee66929f2e88e22df70e90efc68bcdfd7c0aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ece44121da9264bab0e4d755f024c25bc3734ad73a5206f827542758193d95(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0e4153c2addde23d28e9a63a8f1a51be7c36cb1cf20456aa3862fe689d24bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4c3ed5e2ecd24167cdbc2d195f0884d463066743ddab24b0c4e0fd99e0f977(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c72f58d973f5901f26d01dcad8f77e8aac597df52e1737e19efea602c2bfac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8123c1eb5dd0fc4a4a68f7d1dfabc82951fbb56d268b8c3a9268f471473d1fe5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91560aecdbde15fd04803e2221d2f3cfde68f7d9864baace2f926a8000715ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e74238343bf7a2bce94d6e53ad254a0199a53f29667d3379ca3443ff759a8b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab25b2288c37312f8670d678c872c3feb9a615b5da6853bf7ebc1feeb01557f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51902252b572af911bfb669260662aa3adac8e3cc718e6f5f194810e27f221db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa2732cc17cd92467e5a2b9948b4054da6f00ef13e73697b36ec2e1636276cf(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1ddf6408a84fb95687207949235eee7789254afec28abe3f201e500cde43c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc5618db07e4738b2d36c61db5997d2be0d58c2e474e4b096b8613e75d2d285(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa2562df4169d7e54ffaf4a9004b6dc3effc55fc822bddecd5bfb9ad4ed949c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127464c249079f0bcc4e98ea4b9af1889dc9b41eaed0299e205896385fcbf266(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8378423334b821e7ab61175b8670e7c282c9f0fe0b7a7f52ffa342f072e6092(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35e3efe38e63b34daa10fbe7ac44513e2b95b76bb82cb79ef89d3bba613cdf5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5068e73ff401095b85d6d043595f40f880cc53e8e3db0aebeacdafa378a911c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7ea5cba4bc8cd0a8837b329f90a0087b054cd907fe8ad283c9ca61b02f300b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16038516c13ce97dfa385152f569e521ca232b83da394168cf6adb67476de25c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c477023a7cdf2558032d5ec0140215d1c0252e2e6c0e322a21c1265429567022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac2c21bccc6fea15d52fa1d3f8c3688a64b9141fe0debffdddab5c897c32938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17f16393ca9e2c05c887ef9c3f34e86b32660e002a7f21cb2480564eef914921(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5497ee6cda192d64d350989d6c55bfca3de91b0aa80f0304345245323a9d679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d433ea008f912e11a4079708bd672605270de59ace9d1ba88685d604649b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304e7ff087a87624d45a903c885352488878e9edcbd67b346e30015219240ed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a716934d5de356fc2a70883652acad21b7458b9c1decc3df3827b7f03e18d67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3efc92f880a931805b369f1c00c308915e54cc889515a584165fcdb172e1cd5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb46ab68f98567d21d07eba1bf761cec69b5f117494144369899dc9716c91e7f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7abe68a1a9411be91682bed324ae69b5fe7acb45f3348ad94a3fe7851fb1c34(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da24ef3a80b62a0819a4421b306673da82dda10b2a3d2a9484b28e78de1c3fc1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268130c3cb0855dc1f5f7b5ecd6f1ca86e0f598cae0d9ee51bd2f8901b5d14bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef12e6b19fe77157aeba15da432868dc7694988279f6760645ca29256d14942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60156c372f59408241eef8eabf1d1d4d5eb19a22679c128e94b34fed05bfde8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02fecad9b8afa330af3086dca22ce7ade751983d127e3f7d760e7cb88f15d049(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8641759db74edfa16611a15ded6f9dde3dba398bbe19448d4d5adc87481a567b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1197699db10409eeebff49a3b23f2d25631911601de8de50abb3e534fac72a06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4653209c5c516249853b7f40042b05b57ee68686cd5d78eecea4fbf083678a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6efacf45d77cf1dc1cffc92a753e444e510944c68cc9bb317532cb3dd167e7de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03d20b0b2e93a40801892ca1cf1af66b413b562454ca8ca557ac40e603a835d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3424c002bf9cc1c1d7c104c72cc9a921e39dbd0f8901e34152e2d917a07a15e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdbef618fc5f32c6432fbadb0beec2f05c8e070afcce0b1bb95f4eb6c5cc634d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60e832bbde9bb7c95f0310867c8033b9111c944195add0c9f84e33e2672a8d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b28ab845ebba3b31628f7934f127d07ba78a81b051d8e6b4ff400b82d77cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee896ceaf5d00de3a678e961b2eb52cd9450c14917153145a673588ffddec63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e995bdaade7eb75ba20fad217e3604cad6ac760e4c2b5ae50bee1b68ce5259e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52407b32cea78e505c7694f64c2567d4e72d09d83e64380ca0c08e016ed2ee1d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148098fc03d1c58ae78a66d6e4396c0be0c92c5af15464a37098b250908b70b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdd1607f582a707c7aaad42d5c05aa34c63c791552bb65a3ec03c348d0edabbf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcdda326978ea9c688af74e1d54e97aa2bbfdc2437fd5d6f4a175cfe645ec048(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cecc3d1f56ab5809ae3e43b152f5280aa9c6d710bacd5ca7468e02ef0139d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af2c7cf49b6e6a4c093a12b8c08b01894f09310ce6d80be0e60eacaf9c0f11eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d72150770ec46423bc76238321854b73f775d3ed1581129a61f4a529da64ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17c941a06635485547e8af792f0b8bbfb1346e8fb514c98d94a1051547ce353(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2a7e66a07b7603225e64c58cdd3b36f9221efb2445874109c6081634a89365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303052c4596ebf47c18a2bc50db25af652060e89af5a534190b64f4d8ada07ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b619f58f9da16cb869d967612de71d5edb4174e10f5d66fbe521c4aec5d46a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5994729869eb023942422d379af6d60731ce77087bfd1acecacc978f6f9e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf92e23cfcb04f9bd5263ff06843be70434d9f9097aa889edbd0fcccf88ab35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ffee7ebd839a856e2913f8f20a9d8e8b9bbfef4e6b3f587212f652e22c8e40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a104bc5221c3cb7770750feb4a171af0aa3a25f6625d74045c09eaec998d26c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18364188f8f2c58e406a02e1157dcdd16c4e3187ea434b24afeea7adf7145059(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1094a2d8e1d793d88388c75ac4357e62a37e710d30ad469c5ea4144bbb2ff75b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a60d59a32a05ae772f290ed27be3bf8615933dc83634a87c56ddcff04bc155(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a967bb964c3c0343386d5b219e94c4647b24452377566f7fc30f4bfcecfa90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a714463f68cb21d83b1c54f5e54f8f295d248220f96c5800a21ecdffd52a55(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960192171da5d87d7471352ba8a472fd0cae6ee740c20696ac09e88da2a3cf7c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b7370b359c497a9e9f97ecf7b357b715c81c2cea0f420d9ffc03115ef6dd3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4be8144af95b6ae602ccb485b587ec1515b4247407ac365392f38340dece3c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4b22f00bd29c8cf4d5c06515ff3f05fe84a447fd24508efe3ae64536e61092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af697abbbe830306849090bb52eff72935abf426c0b7685fa6e6c9842ea4108b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360a8010a07b461dff686dff09f7bddd9b257a180ce6a44cd45dbe47081d8c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e295c52a8866fdfe46018895d3d718ecd00948c24e038142f19ddd75c60a7ad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0bb724cecc3cc6c1f0d20eccaaa156eb45da8c135af82522a345a8a68cd7371(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67786406ad0599bd3797ffe1cf95d315ef8ecf44c8951e37d3f01d105050a631(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c6a24fccc667aaeab344881680b99d0c2ae550054e48eb3ec2bdd967f27295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8873565389c749747632306cb9afc07ba26e7004851b55327ffcb8f15304db15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47df1908159a9901b9468629e8375eb0d26037f0fcdd9b55178db085da57062e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed71cd854fc6506d674727ce0366c5b8d3623ce7d674b4c153db77d77081997(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45834533e2b822b1864bfc021edef690ffa7d746e9083d569a9ea412b193b315(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18c1a6015a1e948962160b2912dae753e96549b8134025a5c917d309c5bc177(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d21713ab4ca3bfc70ce9991a499b30ecc217bab778098f89dbb8ed700d478b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea4ed70844acfa5c06ae7ed7dbd6cbdf688c312e93d9700177a36b3a89c445c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e0c58553a5f284c08498f383adc45a566872e2a0e75bed53dc786cafb640b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28762542b6343ccf11df92bf68f60640babc2790128172cb723afda687fa6a27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b21e75fe7fe97d7b38fe4fe207fdfccf612a2ab64352aa3cfc167705310f7f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e5a29eddfd38f62e5001b90eaf045ceb41768fae331c50112af5493a95bf69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12957c538f5a6ec0af065b93abbecf51cac99b574792e38236f1713091cd80c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b752c83d061a8adbf15f797831efd72bc920faff8d597e85875780bc2ffa4419(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e37f03a1035d3d2d209b9bdd49929db4738e935abd53fabc8ed1918c4f46aae(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4992cb6119fb0a7b45f2feccc082d241622aa9d06c3676c412c624eeed00e9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7ba35cf4cb407cf298e34781a91ae9aa9d1740e8dd08a47a8c4f8b5e631980(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03cacc9d7dea8beed867edf160723358dc6d4aff011f9b6ccb4b74921a06f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199b9fec843e14609d6e7db3072e079fc3cb2e74b7a85cdddd766ae67afe557e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d6d0477808b96f215217f65a347b663d005be94591835f7e21de2bbc96ebc9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd782558d0f5df26c3f669cddd3bfe1c106198b1867655f8513f2c8fcdfbeb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3748ad868c11afbd032f35623f39a39ad9ea7abe7fe8d9b69d42da354065edb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91882defc7125a29573ae4c138e94e5c2f645ae61393800b509bd9c8c900ff77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe6d582d293c4b96d710d1dbbe8b4c52c6807a5466f3632d96e7d0d77d0edbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6b31df61a8d215483625553c9eaba49934d719e68af38ba4f1c59b38e6d160(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e768cf5ffbaf417038e9ef63df091b6d54b949d693dfb3b26d2687e32a42e421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab19965fc7f8dba33e43c89e4c02336cfc2a22a01dbd3236c74ba1042873c393(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e00e1b8a43c553870f7e6fe8ab49925c0d67648545a86f099f6a43af993414c3(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a87d47aecb0c5df02b9da173b5949228932a5b845e303b13ecd5c6c7697afa7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af7ba3a913c97fd7ae933620c3fdd8aeb4774b55e5a8131e055dcb8d1a1a61c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db7bcfa0b2d55b0875dafca8520ec71ac8ebcc6b0030c26355f7ce1452ddd56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fc8a7ba2f3d6c04dc9ec0d4f3212febfa21a2df794702f658b2759d684f218(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b4c09ffae89af9311f8c1b47c7875208a1bb2c4e99b2b8873be11306fcbe02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecce47a1070104a0d7ec1aa9b323651e44fe861d24440972c8569b730d47051(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961cd795ace1489ddec86b5f7feb72263961a0be034e0b38210b96c9a89d5429(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc658301998d0b19933013a828813444c137bc53f306180486e59640c428872e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6df239fc1045a33241674ed634cd55d5d2eee15fbffb21bf7daa979b176e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4888220fdead292006d316ff7a1ce9f4f1cbe0fc4c30594edeb8d58fec3bdfb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e966764ec9f1443cf1f399d5dfc932d17390ade7d34b8352cfa927dc48fdf5d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__802c75cb27dd391b13a6931fb470646d99ff5c2289da04bb3cc2b11d687f0cd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7945ea5b915a4c9e0e1e61bfa0f2274f934ae64b84ea53866605eebf3dd7501e(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3532dfceb31b8cee1754b1fe244b46762c0f63932aa72591842ae67ad364c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbebc6be70fe5fb1f239f09c71c16a97842f7af51719e5357ecdcf613acfc919(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74df041b6602c6b6189cb573692898c894c6667a963ab125ae437b1861877aac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3592e1bb8667626fcfe6e8223a6233c8dd42274e43aa494feeee39ab0f372f38(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e065d8d89eb2451451ac74870de2e6018f6fe3a1810b870573014a00599d4116(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d37ce24fec7048602065d1591688b89269ef78ceb13a79800312637e6e0fee5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ec962741df543f56085682abab770c3d17552794301f9bee5435f998cbdfe4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67efe3bfd76f5ce6de5edfd84ad01ec0732a1d296e660690b37f7460b54d7062(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33d78e0c4c585466ee45aaa13379c3343cbd2082743752e81b75f3041711387(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c88f9a3baf33179aa5dd69710973c1caca37ca478d21b4146b7920a27f61c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf22ae32343937e02c1fae84622c683935f3440b8f2b28d1e9c9b06aec73e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4063bac3f10c68442cf2ee58e08875c9e458074784dc5b444a79b2802ef904fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80803a55dad04195ebe2348f691643a416b0dbf1f4b15f750e7dd15ca74a8a1c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b899d8fa71c792486235ebafaa1b86cee5cbadba0aa01cf3629ea2aac6e9ff3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961aac6147535c9e1d6da05ddf98bfd794bbee2c61d0a334e8efc436f9aedd59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f46924e9c22bc934fd5eed8e622d536320789c141f6d56c00fd8a9dd9512471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4aa682b2074be4615038218938e7751b05931ffe994058a9ac40cd3104fa35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce50ed0f5e8188acdebc3039935321dd4ea8b7d79e82ef47266f62af752c4d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ca5ff1ecf39f0b6e3e56153ff909052ba2983debb5bd07e1451d140f54bdd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b9ab7cac9cad177d3a044bb527ac3853228b224865adf37662761c4e8154b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd70fe2c1afaa27c52b3ac510022f71735b29a4aaf14602c8f2e32098c65673(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf0110b0ecc4a97da25a69fa9a62054d2e8dc68d1f96f71c9253a55027de935(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18fd682c7c4490b332903f80a2ac35d1fb78a08434a277922b3f5f08be721cd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de5a9c857e80d677d2fd93157ad2e0425ec34fdf955d72e6a877c037fe4458f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1869a9851ee9dc24e3e37ed796546933ff32bb79f2a5ec55b7ca6af958faba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d030f46f34520c35fbea69789a0b1f0741392f6cf7936bce0afd8cdf611518c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5181e973fbaf9b3637d1beb56bb3dcc86dafaf2b7bb0f0b100a664e2c1b75cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f89d84b8024014905dc9bebd8435ee33187e552f62f088bc4e318cb12cbf90c(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20defad745f52cddee6daac2415a5a4b08b6e36d02b6d88ba4570f938d63e48(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f2b29e1c2829108dc90b2fe31657069d56112c52cce0efc399f4eda3d82097d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c524c34432cb1c1db169d6907bed067c693ac72b2a935e9f8e4454d9d50e4628(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a1b4ad85041f98ae24ea4ab4b916c41913ea13486082142d98d75e4efcefd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ff85ff383b4f97eb352ea42087e75cb40d7302cd5bb7023125787a915fed9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f30186d5dcf0f2f4357f89ab7de8e5e7c62d1ade9b237ec0d43ae8a536f2d96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d80dedcefb33e877527715d620fc52afd3cc8e0c6c2dea81ac6c0ed47fe64de(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910115754fa6b71a69069fc45ce4e094cd9bb3ffbc3a97abeac646babb7506b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d063165b824354e7837e442a16e17db0ab5878b42fe61436dd0530e339f3f63c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff17c2f8442642da4c0c193e9602aa44a0704dd7c7cff0dd9c0cd6a77c3e24d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3dc5b6f339170127dbb138c4c6a3103cb46da8f0d54c5837ac67f09dca28de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dde91f1a9bac6be17e1b5212136f36d00802af159e46586bc710a170c2b8306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fd3a8c3764cd9eb09704acd1002e3fc6530e4a66df05423b5f7bdd02d25423(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6576e0a5344a6d29044a6ff60201b42d251e5f30e80dcaf14df4cfbc0cfaaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__363488d61a0ba3357dc30633dd8d47704b1d33eb7c513a737a52a2ba89e08247(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f702ff4ef5180aa0742a74ee3449f9647e05d8e463cf0edc5aa592772deac98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efcc3dfde548f12fccd1a413b4b44669469e19c2a9e254e901362c4278512f04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7104a6bf56fe932f1894ac4ae80b3654b23f1dafcd8d6ae4ad769678c5a6bd65(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3866474b5beeae5074429909a179e9d536ccee9bf9fd7ff6db4655ed80821d9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7e6a34c9015b41f19a1bb6bb40ee0e63ec2f4e39e9e1d06085731b8cd5a4f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322c72aab4abf6ba5aaddb8ae9ab97f5f83f0826d1368db4ccfb88defc85ca2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8712d8bbadbe3969d13cf298db377d0f11859b53108d18320328fc1cdfc4a65(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d796ff662fbe05d3e5492bd4bcda44112f5a3c1e3b87ce974318f5f7e59c001(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8322372623d797a03ce677557381e9f571bcf373dbe3493778997a6add7c5d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1190b9335dc05a0fc6dc79fb24be3d0e81e8efc57905e5bd5bdbdef719db24d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3858cda41fb37b22d176e618c9029f556ebc3f870986731d00cd64f4f2fd322e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bdd079999d2e18ca80bdd182133a4568440317dda59ed16da9a37d31ddb456a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e002de07210e1a3e15b361c2daec3e05463197f46674d73725314a5fea61171d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d192369c9b97e3bde17696039d13eafcdcef2a271e75a60011934de2313790(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef6231bd90b5830abff830953f9bb14eef8e874740ebdd436a3f9c95eccccdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dff91a12034206a6cea51ad3779e8c8a4bc6027dc4b6a0d42fb95787b33089fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8451b168f6d0e2f2f15c18e1cb6a0561a14a3aa7abc07ff0c3bcd7ea4499855d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67157c0af8c9c928be8978a063db47ef1a3bc2eda67482521ea5938cd3dae680(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133d8cac195d5da9ed34ec65143f6d67456baec8a57cd01c5973d7b9ef48b783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74b37d0fb7ca77ed19bdb717212091b10b5534a143158077b8215f326c4e75b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee85a8f32997e240c415b5eb83e3a22f02b777b5d0fd148f194fecd9ae0c7376(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564a196b878ee7c9c4c07f672e867262ad0687fec091856cb2293de974434dc8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92b88a1398a3bd630516a1b1108b9dae04e4dc3e70785728974689980b5bd0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df97b3e113bebfb73fd3090604221b4adb4ddcb1c536a353ab75e2ec6c71fc8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2971b2dfd0cf618774b4a263936a979c9e9818b84f9c38b3c5daaeac2c690580(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24baf910e15ecdb75378d31138c8d90aa72d993330e10bc04250e6eb1051ef72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af3e8138f0c57438f199280ee48928a95b3fdb4ea69d42ddff05923fdabdbab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8187f4a476f1316d6639e3238836f357e453b66534992370457b71a9d8d6341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f7c55fc7982e084616a84f5c34026f49d518717613307e9f73b94e05f06771(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c720b292bb0bb75197ddfe3a3edc4361ee940e828713a91d726943967187e67c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee2fbc3411af9d22013fc3c9821a7b4b38e5a4d127c32958b298fbddb8e068b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8cc0ff9be6d4c74400f3731cbe5c4ee5ba3c46d89e642012fe8d7e06ba2288(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e70cf5b98918cf21cc579ac2b864a41f5649720747e59ba69677cdc591d734(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__870dde7d5e9c9dfaae574d110cf6b92c831176f9a10947400a7a73f65276787c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32bf60bc01f0f36ce3171644ddefd0a56b7e21ca0ba5363cc813444be797474(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09b87b2f14b9ba6cc949a048b3bb3206ef57f060c234ef78d8fba6cdc3a0e8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a780e260e32bd33cbbbb0c5442f759ae221b0cbc145eae649c631822e7067e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59805dc6eda3fa38e441c79eabd4d0297c1d8592eac47c89cd95f141b5ca1552(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49eb88759e2fe0c5cce3e3ab9844f7c1e2616b9f1120638ea2eb0d6be839fb81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c10ae76b01f0154a7a8b215c9b64bd7b3d7afc503352940b72564c31ab1734(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc8e7118fe784305c15164da3dd654e33a8ba9b02e03889473f564d0004a1d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647139ceed12f31aaa0a99dab056faa7dab82673181139802384c6c583b38f36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b190a6fe59dfec60b7c03c56e25d951ac4606da95f1f32b2c39816127770ae3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da5322c8c2e43d027b9a40e7819ade2684c20d93f44144d3337ad8d41807159(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090e90119d224ef364615644c8cd9686dc21c7da21e4ddc0322f9fab8d3fc02e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e2148e2cf834a2ada933de66a886816246d00f0e7a4139ac8233625305ef84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379a63fb6150916dfed15a5fd1c265778f397d86855294cce47d46e717f8c2b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7351a9051bc7f36da776c869b0207016a7b2f8cbd6858fc591cf04af06a710c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9892d551ad1c539d8dae0413f1a510f6835a5fff25ce59ae09b4edb42989c175(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b377e5612866e9ac81bafec5cbdb63527f41e834291714f64b89690d8306b962(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b069d7076007842263af071aaf346c73c9409a29c6e3499f181de8397fe75917(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35dd74b27f89fbc649fed7d8fd8228874ddbfda376d532b2e86ee8597622e85b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2347a3cc5faa2d66bef0b4c53129dd9f0074a0d44bd1f4beb6daf7ab5e5895e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b673bc7d635795c89813e94b6303bc9a1758ba5b9b365ad392b237a67193aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a3d9b9054e848d664ba26cfa95260cbbd085e2ed240df7cfd8b1c0a218d603(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e1c7e0333d31f0323197888c48f125b809a8c53753f1099aab7ab029bc58fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686722ad5c63535793c30b8f758a3fd3b27331957be78d495693f239de96bdb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d759659643e001e59ed119b0b3f0509dfc36940fb206bb83268b9a2820fe023b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b97ee5b0ba894fe8591bd8aa05d0a4ff9962199d83dbd1a7e37203b804e369b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d169ee15aa7126321c8ffc14ed172a54a402d441861b84402c1b07d77c2a840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5345d05b4b910f4a0ac9fb4f34eacd80acabd0d49316f3a896367fb33399fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02bbf7d23698105007e4db6b8a229c90494fe3d7519568a0c46dd2d2012c78bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c243645e28230e2d1966c0b25fc87a8a88c4ea07372fbdb451b35f29db715266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd08e5b29313cc14b5c6876b7a9c828d4c5f625ed82e5da0e8ac5684fe4e979(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581ea5e4c8823fa07cd8e3f98f8bde88b23408d508e625e94a1db575fd52d6f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ebd3ebd57f92ae8922017577fee40e131ac1fff1834bfcdfefa95355a5d2f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d2c9f81c5e447631a9c68214f8ef1e26a75455ff7f4ef13d24966c3d89c4ed(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710cb76efd5a67b09ee06b8230f1e7d79ec4cf9b34a103cec4dfc73892dc024e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4db96696c68c1ded53c15619b103098de7abe5d4766252bdc1f1d6f8488e00(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1718421703f17b2ad2830c717b103dbf50ada9403237cae9ead5c05fe48e73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c98985d5b556dbf4caadc2f1f64ee9ca3f7f7286040ef1e61f4e00e11269af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5388dfc45d6a09b58f015831fdd68377c000b120637db8fa584214e43ad10e13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb08473a22c76159938a5897227edb3bac499cbc542dde353cd3827e60e055b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521e3937655df4e5a0697f673e1871f8d9acdd14d7535c90251d75c63f3e0d3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99894a4008427b82d3f38329947baea40918db76db9878740eeaa75987cb67d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5f5ee891f34233bce5a95af3ccfa348a46fc53cfad1b22e9cd6306d7bc70a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375a8b6999a252914067281ff797b5015b96eaec7345c7f9e2f40c1dbac2b1eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e0cf96e2575a0edf9c92560c8a49ed6cd023a925b8be90d798d1ee5c89086f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14114ca1e471802bc08d3281a672837db48898d8a773ff2d7d08033a1f71ed8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f834a93cfcba905bc673094e8fae1f49425afff5b6f9d15a90fe6473141312e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d560e2afd33a954da6b4ebcea882ec0df534902ed4eb364e02878783055ed21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9b53c6fccf436b2fde73585085880c76e5fbdb792785cc0ed0d95d055a77b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90529d830a2f559d8a7f120eef42b6c3dc28e1b779c58adc5f19324ddda245e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bd7e3c6318671b9a4e2189e42fe2dc1116da2ec0b1220fba32206427a1c75a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3914a8f3af2c0108dc0bc2917caec5ff447979793da9d69b7f7b9b5401dcbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5ccf19d7814d38b94cb29d4753b4c29d6ecb6d8f8cbeb907016f776182af738(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d55e48d786620fa2e38fc1e0fc82602ff99c88d7b40cda6266e3f94124359b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4fde770fc6ac842f7ca9465b381a0c9220e2d9af016bd02e0bebbafa2a60b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929f7107a963ff81bc79effde9de0c303c2301a322fde01243302e7029af1c2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902d90a7765b5ae6de9ce68ff6d2ad098dd2cf1e758fb6aa9c69b9f7aa540a13(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c925e8c4eb6a12ccbcfa54184849fc0a4c42973402ece04782900d4faa23b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7467881d43f9ae8d329d863c9c47624cc2b14c9bf6a066c4cb8fdbd20126c43(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dba8960e535edf7faf16c8aa71740416104f4dda5c72e0d2a521ffd42d68f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7484b4856a8dfdd160c402caa3ec80eca50658cacee78e1cc93bce6e7219c8b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6895c8ce7ca0cad7913fff8591f2b87cf23afa7ffe674222af7d7b034d7f2565(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aec3e6b568a6576ccfd82f8a43e2eb5e46e41081ccd79c0a2e9e67bfb6c966f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68517998618a88b17b5dba8304e88cdb14b38ccdcbec30fcf62c0f198b9d3dfb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7d89df5ee575503ba3c864a3c2630cae17b4df82d8e8afdaabe3a4f2cea90d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8753cd46a84e84bdeca0677cc967186ff79db4587bde6e3df601ff4cc89ab640(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2bbf2123ecc5049d1ce2f7a17a6b25578bbdf2cdf5839777883b1aab2b8fac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e49630ad5d4c65a9ac85240ced7e37ee61a84f81c180344774875f60ec47cc3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d725f80db2b41570023abd23989e2e6e3dc71e71fd9a39fef23441229ab1d125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a896e37eb33b241994f3ddbe16a016988f84a56ab8b00b02684865a7b2bc0b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978e0a7d4d2a88c379337050a58b6942aabb661038050d989da62c8ad8a99b3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85dad25f18d2790bcd0d9703a2ef1e41d6573b5439e9d8209c5684cdfb9af876(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8feda665e2ff99edc77b0b6d6d818cd70c8fd0530c0d0e5b6196f0094e164328(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db03b8c6d4a739f45c7c1f0299245d13c2e98154eaa5b3aa66f62a520018125(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e608866331790e8ef854096e842140de73a35057570e8cb0176676d77bdbf38a(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc284fa410c35796be9e150bf5557e2951932e2ab5fdd12d360e1a9c8943a65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__931a33a763abe42aa76742da2c10602b147021de07570a9c57ea10d9a07ad455(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e0ff78b2f232bf8404f8378aa812eca92a7f440e0653e0f2277149c6c3516f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e39dd0df71862cb00c687aed0f8aae1e6c5713b0ec9d48fc9cb889b04dd581(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124d055d3f9c461a57a3f51fca7e4b3eb75e4b751929827f4d9138ac6aff9780(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53ae66b10431147094926be721664c9d62a153660d73f268339b2783c13ae3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a1b20fe33d0b5bf37a25ef9ccb3f4cc7759ac66a7bebc2d6a1b6b4f88219814(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc8d4fad10610f60dc8411ff9d5547d9b016e0adb03b78b139cf5a977ab834b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f763bc5f34e33df283951c53b6a911a057beb554ce865a6a6ace8abc7b579564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f892f0a4f6e5920b8b9768effc93e0aa868b1345df183c364d431757023147(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd8f0bf5289282e647dad286283fe9590a4811281708b6bf163d65871a6738b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb13f9fcb1446b460f00a4d1bc0ca0fec153823db50ac7528e61dc52f17560fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13f59b2a3a0cbd9f0150b085c20ef05a56ff88384c55e4c8d672a48644fe339(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc64db9d9610b01fc34110f37ba3546f04e70ddf5662281e5f1e3c55ef2ef36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f87f2c7e9ac69bc6d5fbbf18e8795a65bf6a07d9d0c30635d67479b60c269f5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218c7e93d4ba6f15ba3f38e40c58fca455e13c61665fe758bf830d57a6eb4c6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cab487688439721c28802f47d8d503aea0a32548e033fd1f0b8904c0ba6fb8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f989fb3c6a1c6ee12695997f3bba181971c8ee18dc09da14f83d1ddf68317e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb483364a53ffea2394b576542a37b9bcd7ad579ac3dd7e17a22cbd8f27dc1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83627e2cc3f5a2f2ec8b995751755d1550e46e5521c5c7722c7581c79cd6bef8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b559a653e002ea7f548ae90a34bb12e680baa3bfe074e324976ab448caa98fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95da2467506e9d0d71e1ff3b759fb7d9b5b7dec1ed0d71ed157daf66acf7cc06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1601cfb1340a0e008bf527fcca48a6039a3d8ff3c52a836a41ad2ddffb484ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b47c6a89999ffefd7de8fc0d935718015457015e7ea887d73d7ae00d9ac5bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cfd0b94ca79440cac4c889dec096ab112453d851f75b8c25a394ef3b0ff9440(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28174b236d7a58d3ca9b3c71984ea94df3e302f6f91f3460164d7c612b517f48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d489ac9c5d65e924ac705e4cb9385cb01b1f71b61310a46cf0aa6d6ded990611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968e421e919719286c785f418e65153e1c68c02e71a8afb281b7589c2a835c2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00217cbf77e584eb3407bd0ee59112308cdf3221089dfcf741404400f5b1e2df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84dd3f1d18edc2d81836f3f7f2dfec835c827b2c5777f89c5fa9f1f2e707e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7673d5b78f6f944fcda1251072f62049f703a0b8e5c6c0680c2307cfb57137dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e907991cecf373a3527289bb775541a72c9e3487ea77e2292dc5be58097099f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0816a2eac0e8143d06623c6593e175a41355597829c56d931ed81d2825b77e8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba747847262b6aac996c7bb88861ea0481c60158e5b9629857b372b1ffdabe94(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afa70d330360834d612e054c56031dcefbc7f48378787ba4d1077cae005b1d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5affd1779d24b74dff2e73daa31cbcd14b4e365a4b1fa643ebfbee9dd941ef2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e347556f99d194b1d82c202e94c7c67fedcbee0e3012bd932cd8aa5c6339cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6f38ce5add5189970b791a5c19917a957c32721937c8dd53a265779f6fd04a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e7a49825b313d9b79fbe80c780c839965d3e478a1d7e9b7173b4ae705c6c8e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac632d13f0687bdff6e039c30db8e3fc762d9f37c3d857f0d98c00586cabf1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0edf621b1c13e2f33681b38cc98b9915a5f82ceb89d3536eb6daedf15504f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d8adc8535494c99c17689773b16bbe47432297708a092c70878f1de01d7ada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05ff6cc18a4aa2d84a658b72421ac409e21943686d496c69980aa04a208f6c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c55a5006e0a1a233d425bce0b70e795144d0dce3fca700053108fa38a09a11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763d3a78f8edd2d2fc146284f05724586acb1349d267087630c59232e8b66621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556abb7565f4de938d33a28c52b9da4442721bc6df044116e247a1b45bfa6c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e914e71474d0f4749df40f60fa45a3fc83251458e37440069d7a4598f7590949(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4616977955d1feb42bdb4a9129384f200720ccf3a69e87118e49c58edb715104(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcac86c8c41a98a78f2668177fa366009ce69d87355502f745bd279ad009bed4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a59d6fb8075348e70d1b172d1b0ecc34be5be9bee091abd7d34741cff7ecb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a5b1cccfc403340351fd642a2da1a12b12533961c884a0d14bd1b43790bb00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4d186dad4c24ccdf194040e605fdabf811b94d933eaab19956f6eb4c633c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad4d8b498decc27e8816be7dc290aeea404044999898980d42840fa5938e716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd83f1ad8d54422a1ccb78fb08a8f4345602e82f2ece970ece22da2c8d77b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af06806575d139fccb1e1f7ffe0946ee1ec4e232fae4d1b76d7f810585c75872(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84410335b1c32163452532e511747ed1a6254dd4541b6eb1c419395a8a01a1b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1845b263559ed886b4d023b880c448d6038eaaca01975b6a36e613d096ff823e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0013b40f88892f6c9bbdce20ddb66668cf04731bf883dea3a3743c8f0d8ee9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e240c8ca87c6fc5cb1a24301c15edf019e14ca289f47c7bb9156c1d24455c98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de9f37e220414f9010712ca304253d83a5c27c77c2e9ab2f68bb48946b87520b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6042f3b95dcac6b3bd318dc049051fb115a3d2ec402cb71a279ce49ad089eb(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958f3d73db0d53e0a5a733f7a25e1ac315277de5ec372d1f6b6951db86cf235f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bef7da61b02f6ce4c9c7abff5d9813261dc70df9867c89716e2a5df2053009b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd441a2d86f752929a99e12bb8337f33a1c3b316c28858871d76c5699689fead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147ab99dfc6846df925a27d12f754a186fcfebce89542dd28873d0d020844fa5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873a8a89f13b24737390868590164a1fb94b4cbbcbe4614ebf826b5ae5011356(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b983e0e5137fb55e82689c2c448ecbcfaeffce3dfea04e2febe808bb639ad7b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe430035f6144ad2d6e585e27f3bae3a1063ea028f795f5b9569cf9d8be2c0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8fc0379ebf8854a549e7fa254807da0efb34266f669109f15d92e3da7b3cb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd6c54542750b8743e246da1b83e712ec0efeb78debc535d2717d797cacc3f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28bf421c23844c3f0ac21594e2f4a82990a6c18f0f707475fb67a2b9accc10ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423aaa4c429481a1f7cbaf6e40a0f46eb10ce4fa1091d443d051cdd991cee38a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a729ae49a486f8f978fc6215bee2bfef72bea2d353aa193cab2623f7e4ee7f35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386a0fc14f2354043ec8d0f371449614f6da771af398ac90f89f270f83c64293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbcaa4b73b2d1f556f085529c34fe37b8edc63f781efd84e758381963e80d21a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35d3a1aac7c15ddbbe9005daf174a708d4a15f3313ffe336f7ecf616df21a3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88cb61583e494508712c83924d9a0ba98ae872cc0218d55fcd771f655151dbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c195d122e4e5d6c8178c4fff1dddee7aef1bb61b74b94747f815fef28e4b6a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644b8197f1f5b23126629a0636e5c1282d6415290d82b13de5be1a13b25adb83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff52320ee8f01d47ff32c54fe9b622ff3a01013e315881e6a435d529018e5b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2ed2d4b4cea1023d8a2a176041ea940c5a17d950b6795aad6c4c4fcebd2735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c492aeb8ec7dd5a7880c6e45c3e909cce081c222b832728d6ef7615298d263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b9858b736a7b50f96c5e78cbc34ec9895f921d6492f3f30433ec6f0d768f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a54d4886cc2d2daf3dc120a0867f0f808d5ad7b0127b0b35fd271b28b7030b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__391358493483322f2f9cb2bb947db71a6c1d3f415d9dda043c3dd52e2365c1ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002af9ef07832e0da23d3feab4f94f979a6e020d1b96dfc5731333d94f3c8580(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3395699aeab27565386131047ae752aea5d1bcb7a166cbed1295f48e607ec9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb9d9d4b769b155af66fa74b8d22e0678d3014d7746aeaba54e81de908a2904(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c2b6e52691f5571e09624c2d8332e5625fd4c5cf3113f025714c8b8ba15037(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79b0d39a3f30381acf72e8b186c52e88a59746493886f5317f689c8b41ddda3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1d9d92b578177d698adeb4e8126cd9c650a92ec433479ba4268fec433a4a50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38385e9e9d883d82d37e0dbe698c572b2a8541f4ec2a328372e39311a7e28f9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de09a665938ec30dcad22c7cb5f769fc7f1f70b7abc75a07044ba3853869ff7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f023ae980ffc83c91e2a5da0b2ae488f74b2a39443f2d9013df1b7cca6e15987(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb413bb94b136910a247938c081cca8a7734b0d31ea997bf889a14c21f78054(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4938be3e1a135188eaf6b785b000378fec28e692b99e50c4675402dfaf48377f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1da756ca71d306a50ad112b63a8a1af62db9d6096cadbf470381135fbb3a4b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee38aae033528d61e03e46fc37ff91aa5738ec8facb27ca60063bfe5a6bd0e53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3198ad3cc8d7d29605557ca5dc2645b5d8bc05435edc8cb78b52c2486abe76ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be79ef5a2a5f86e72cb4cabd5f4555c1a3478d305513caee448124bf0bc67adc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79286581b5388136ef2e5e5521e98ac92999f03f50fb39e9cba66eebb2f21237(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306bcd8b37d625c0b69413bcc8f6eb692b4a0f2a9cb19bd2bb98c62cc4544d69(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7af60a0647e1fd5826fe6c12c379c5b6ff39f9a16155abfd84d48f1e1fbe9e1(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eed8c7f9dabee888cd52f6b785ab5f07df81826d1547fdb73b410416560f0cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023976a901bb4c0fdc53fcf44a140ebc69128f374eb4195d3faadfbfff5fa77b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413e34327b0978e0201ca0ec0903d894333b655bad33c7b689fd95f7eae7db13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484abb169e3389d14b80ffe8c2dd10a613470a2f3cfcb0f0989bb37222b22c50(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c3cdf8ac9ab905a73697918296a7614373d465ff22f9d8f575c8d4cf68a153(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0326b2115d2c02d4e3421f020c1b585c3e3c2e84bdf4a3b15434a661e105b471(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9ced78f260dabbbd483a886f6a6a561a7a9a69d1ec2b08d501c68199d0bda3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed955cd9af18509dac9ba3ad3b2437130bf1847f07e86193fe3748364f475de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4930e68cc3eb30f13747d8824b0bef611c80ef5db17bdd12fc6ef6abc5702d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70aedaa9a647118c9c935cd637a7e280a411a1474b736bc6931335b752f911f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a897736fe25d8aa1c15984dff25fbb4be350f14224160281276236b6d5d115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47374996304ddf653a87dc03af3f39d4e386afa6b274531a8ba543e15c024e41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc90ce21aba99c49dfa3f06a4b775815ae06a7e37ce63d4e1bded4dd22d1db3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0269b2c41be8f0a5fecb7456fc866db8714b43d5ae38326d8a3e0fad7308a47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f14901048ac26022fa0ac5c8a62b82e77bfd1491e8350116755532a4725cff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b918600d035cf7288ba44b4d893a712054b51280329233d9b8ccd55039503dcb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f08a3bb662e341b4a0169540595c2fd0871f0ff453c91b2305aba5a77f0e6ec8(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12894eaa1fcff8bcd5caf7f937eb086c11860aeb7c588e81d17a3eb64493766e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27cd23a35378477c082f5dbccd3046644ff77e5269d6427a6d89c17d6371d252(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824b100f015d98e41d57ca5d6f317da70c7e4b51b30bf0d40c95d7c5e5a38095(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f0accf5dbe2237f35ee897b127643b48ff682f0f005c1a78613c61c40c09d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1364f4ba720d2a85ebf74f7329c68038956e6d7d0e306cd918bb9ba55eee864(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a8b07f3e9b1f52287bb5184d672ad7c7e10657ff902dd9147438d7c8902819(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465f31043dc2d2870a2cc6f5025be91e300fd5730289b77f37e1d3fedbcb453b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75342534d9b7dc68cba71155cbd8b1f81f7bf05dbf604d0018712fc6c0ff1c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68c8bfc8ec3d603fe29582bbff8a9afa6c27e6ef8539fb1f14ee2ec7882aa0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b83311f9912e4c37c14b995844194ecab4497f2eff4b8e9e43b3d927bd6e6fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501168213e4677c534a3c0645f722c5b14507057d1059216f8a9d2cdcd9204c2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21bc9fc52b1356e45ba34e1fe80a264d046e939e315861008ba53fe4c714e69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff4301e435176ccf23d8202c960267ac4947f0bdca14f334d44d0c889f360e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df09a7215813e6a72977782341d3cf6b78b9b4a041a64d72ba8f8dd4bc029141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52797854c98a752a6fcb115813de785e04455a8cde737868e40beb846665d041(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04112930979681940168d89950775179f68d63ace0d86c40c29bdbdba7196c69(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef657fa8550d0a4c1d427abf12c92c54ae640ca000bbb0973941280f44447ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dffc5d82d806a347595bda45fc7aec8c4c889c590e4f25aac41f6bab91ac623(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9aaf18bfe9dbf2648a853326834a7f12acb4cb83e8b1415394bd65620825e91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49d25e9e6c5087c33fb8f7afe0745746da8c7a36d396ca901007f32fb5ae0fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a905efaeff67a7c3a2049682ccb68ce1589cf3bf60bc27b3310dc706f2875c0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924d61f5cd04814341502549472b66c531d52592c0d117deebb74b9fe45c6cc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9fe2ee51062a65ee6d1d4b32d52f73869222be164bd9349213e7aa248262a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24b984895bfc45d60f2d9278cf5081a720e2909d8971eb0fffe496589722803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57fa627faddb90fcda0e67b997933b17c4af7979313fe478fd42eb6d7f06df0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357184a284e2f2a2b53340f9b04ebde1300d4af5d54e856e81075751d04eddf5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e65c44cf6e633dc32badc4baad5375e8d64043690ebb11a59e77bb7f08cd9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499f7b130383703479eaa3d44ef07486f178770f929ccf78a938f72f18bb830f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939f73f6d13480b987971f89c930fa209cd55f62010c0defd451feb03f02f1c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39c3f6597e167bcc12e230bff2ac7dd7494a3f5bcbe985e652f27928087244b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e93cb312f2568b6978036ee55f790f71a36c4ccc98c3482de44d34ed62787eba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ba7eddd268c2df266e623c9d316dc67c06c8a9f30960479b3cf3684a8166e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd4551469cfe548b2c5a88d4689bdd27f25d7d70fc8a1b827abdf889f5cebab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb2e443c439fba86a30fe3bd53453827af61d840db192559b79cad844896ef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd68c06bf1cfd624a56e6ccf9c69f70ee72519065260d2490a503e00eb7286d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126ea91b635b51665506c02ef6dbd75dbbf51762904e46c0b4344aa25d49f3c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12f12a76167ec44cc973ac4032cbbdd90c44c3ca4f8061665e850e5c150e321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370f62e8c98e25002735aaae3f23242b3fbc3f15e18bb157e50108a22045532b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63bbb0e40dea4c5a8e382493473b84df08a62d9fa3304e780de3da2e79ee4cc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a537296b36169afbaff2c13f0c0fe5c33517a431cc772a18b17ec9a0b55b091f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91cf2cf46aeea29c5c0712d10da32e504e46c26059c96188782ff4e9e0af9fd7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b2653cba777a314f42c1a151872d43e280223fe081e1e22fecae7735e016be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7071843cb46d0af97f5b01b07f2cf6dedf7696ec6503d22d5391bce5dab6efd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b8ba669e2ecaa551f361263a673dad09a5409377f6bbf1c0763144b5356f8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d5d463a6bb05eb89538ede1ebc4efa4ea73e50c51a0d36f9d5e33eec0d254b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b88a6c39760e6e50ff31e2522ae1d4202b307a6041c828ea715dcc8bc293eee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f946252f34ac10f6c857bde163c7dc1342976a320607fd878faec3514ac6f20a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8361f2bc1955c4fd8e36b49183dbaa4f4df81b81f5000fa4cb1e40ffbedcafcf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dec243283f711f5c80dec024f15f379eb8f3aac3678319bf051729501097cab(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f111348e47fa4138c57a3082cc3001f055976ffb522faeeff5f1245e4f11442d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4219866b824f61c0eb8405c0ea15fd3caa5c1098b769f2f702fdf6c03606f859(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378ed9ec15fdd8853267d9e561ac941b85eca82c896c494e94554ef8ca888a9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4edf46d8801ec6bb8c7c210cb5d051df0acf8a1d71116bba27a72f61224cf7cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d26994a6544aea917da53a7a672467568d29cc710227297203b884415cad04a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a1ec49cadf7c7ff76bce083f2fd588efc2d3167f42b27134aa1a36eb67f875(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7635aa8e8138cb259a09d4decf9fe3291c36fd622d79216a5bfc99b8bd2584(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ad06fd35748c826d10bb28cbce4bb0eff23846ccb620e5207e05f716843e7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e88a883f1407840246780e26e5b71bca1680cba053076721c6de2d8d106c66c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33eee5e8da77b56a58b6e32732367a98e5e36d75bf90c4d64b0d050566ac4d54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a42c1b2d7b46f0605bdb807c537989872cd8d27206607f28cb5d22286d9b309(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1175fdc810c6569b0b153d1bec599fba61b90a7a46cf0bb646753121e7399883(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519ddeb26f95bb7f4a587facd5a1db9143426652963a076d4357dc80ab79a8bf(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19269c4ae85cb132f9578580be40aadeba1ba2003113354f156869a1b8ae6b5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd5b2fa605f849742bc495ed6959234d8dc10588c23da341f89f363f9bfb76a4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03ad70de6f39beff23ee5d681b0a36f0702cbfeda307d2d3356c41cb5382f52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcf3189971d44bc513c56be48c453ec83c1834cca2904edb796bd1673d793a9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8008e9bbbaa7c7111a96fd74f234eb68f96d16567ac4e372d2e8bd0912de225(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea207f23bce7fd775485f69f4fb1dec6e236be653c5e5379ef8322a1c6b7f55(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e63e8b8d34a52346e580fd11a6e716ba3ba65708ad5f945f1f4ea361fa51d4b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29729b84081c32cdfb02a15fdf991f79b81549ce8ef59b1b68626be0d85cc201(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ceb96359f042c768f7a6fb968325a8028351b7bdfd59db87ede6890aeee9fd4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b673899aa008792f5e7a9f630337a433d4d931a1db8f2a55db94a8de6db4a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5968ae3f2d9f1f1500aa5d2141b44352e9f1611ad382c1074ab0fe60c4285ea9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac0152e805c85a86b3649fca412ea8f2ee2b676e298ff88792c472dd760ebba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1abdec01ed57a6600dc0d6a01b3146c46ee71aaded1a0ab53d4eacf80e0e27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24931438fec3ae6c2fa7749361880408adc3cf9308e92615bdcd62ca9423d746(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409164884b8485eac37e25da0ef5b647102490c006f1b364ae60ed95bc3d78e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bfd709a64ce69490e30dcf803d1b765d023a64afc3014be6e9257f847167683(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2590020bca609e1d7b4b1e309b88a3945857d9d27616b6deb6dcd0ecac4ad5ce(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece13b025fc81e5f6accc4716d0734f84c4419faff95967aa596e68736ba4d79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdf19ad1c68a1cd12cc1558e0614ba797847d473cb8287f025905bf4a15f382(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd54c222c9a4cbfe1a3065e4e1c894937c17275073f108acf9b9950fb33acbe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b57122e2553144141461aa85770cf4c6e1a566b8b92a6b45038bd87d83b0be4a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ea4c949a3b810a836844e4baa257c2214e551d4f940393d4e3af14cb3673ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb9aa084f1b26deb3b4a7bd71d49f59c193316df7f8fbe89ceadfa3bd0cffa7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b278d9294ecb1344a47ba07642c430b34d3fdd1a8207f33b275e391d5af6791b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a329fb913c7b6c0a1d9f72e5578d5dab2292e8f1e03b3cfb48d9a8e868a4d4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9132c42d60309e8d2fe29b431b526b45a8796391db1d40d2efe0ddfd6ba7034(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6902d9a76ef89f782241ae26ce3d9a76892ba4cdde67955539b487d394b819da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51d2e1d72465561ad10f58bac3342598a98e14b5c6808bebad8cb89f6c48734(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d62e0e3a717b6a58a108d9bc782488b48cc3ba03123e273a4d5e9e81df5e7a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505ddf6b060ee2552fa577d55a19840c4cd15e3e1e5c843dc96cc3d333b007ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64d01331efaa5ce7bd803ccc5aedfd6bc779bf27e5225c6bc64616b9accc2183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd2b7f53d9a6fcc41d6d944f1befa69fc6621073b01e3faf72e976fdaf5512ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00da3bccef80fc68fb75955b4f2cc99d9412d28553a3a024307e6c1f5f46a235(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a77617cc103a30be18bfbd1813c187bcbff82fcc015e10b85708e3a90ea079(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d0ecc3cabc422a19696562ba125b9427f8a0d1e3dcc1920ebb3d80cb84ad63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19eb2e79bb94c428a03f670a1f9957e9b3569577d54fe4cf4c6eb115efd5c9b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40af08849fcbc98f44cc57184be5e11b4896df7ef12fc2701da97115921a38c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60819b8655e184bb8e87eed3d2f816cd89dfa91dbd5abe759cb345f17b183f92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6420b80c5f0702b548f76721aef2081e8e1bc573c75312635508759a7329517(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27472f2f9f60ef74c9997ea32692a81c854e2bab8050a295a5f93ed2a3c84e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c114094cb758c489bb37fa39b2a0dd875d62d54ea7386c72ac908bcc24378d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff4b40d358bf976b735c79f17ad7901d8a47336a211f95f05dca07f05817082a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7fce5bcba2c00cdcca3c250246f20565f1599c4fe0f220f17752df14e27aea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cea2e42b85f9a6398101cee57bcd9192f50facf96338064657712d8cce8167(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf073b2dbec2e6c34154c08726f94200b08d414d7d29e71a208c864ca2fcfe3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbd53a2002b8965abb5d6ce8aa66f5950914394ec27dd3b82b03854af25c0ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a68783a6611f5ea5b5da66476377715dbd6b62b174f5c20c877dd2b63ca98c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a568f41f7ab09e1537a22565651b29c3414591ad3b6f07d59b05a515921dcd46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332f91e828722331d7342e3339fd6935c719b4af2c6c7f929c5a07531dd8c13e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28148339f0b71ca23637e4296ae69708007eacf0d6800eec80a0eb0bbd0d39b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e388f623f133bf486bdc50e9c313a508a6d8f0d0d977ebc4ffb57e3ca94d06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__563c16daee8afe5b5fc3e810b1586acda85c03c30d3d8576ff1f3cdc0c393d7f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8293dc08d98f96819593ba90cab4f3e9c81dbb1a5228a7a93110e95de6ea72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ce6892636de07c696e1e5e63cbc530c8d38927d556bf474619b93a916d013f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591c7296d73a27eb7503019db95c777ee03bb5a341ea06b70ec4c75dea4bc9d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d44f5c8234f8f62beb807ba7f91477ac8ab42c4a8f6f3da2afa7ccf5cff478b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e5424d31e4374f61f00060f9cd45fb6e7661c3fba5458c02e9d2c6e21edfe7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6509a08bb415c76332e48452a40900cd945a3ff576c8a97992c8eb65b552c5b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913479e5d4b39a03f65930426a60a43f20bc44934452860bdea52f95c2a54816(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90d8ff9d6c1c9a8be3ae88b9eefab91a927d1d4d6a03bfeeb78fbbe2f478563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a67222ef45f169c0a690ba372887369f920fad777a72e6f9e296f331bde43f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51bb3bc8389ee136dccf48a5851c78c24e08955410f9db9529d92a0ae7b0a7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6811e8da771f15b45deb474444c15e38736ddd9cd5ce88974633c9d7887151f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d8b4cf1289d6551dfe7105287dc481820a339449b07aa618f45f064b6e182e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c157fd9f0cc101b1c8f4671891b6c5bb6c45250f61c9426acdfc84141b1c4962(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb399ebdfff1ca5193fd9260938668f1352c14f6833eb7086e54f3627817692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b465122224aa1fad4d9ef2ab1524bb9d91a81808d617b9dbbacadf8167474197(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__651dd29c87d976c158249beeea436be4d6ee502d15ca5bef1f88b289c990be5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f583eec40d4b5e4fdcae8ad5e0c0677464d2685b21413f6484625f57b837b66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d800611d4e0cda1e3a48ad421d2e355a19c57365eb553b02c7a6947283d65e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8feca6e4dcd31774fa8f79e631921d07c6489ba65ad65de96b66b18bdd39d93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a75fa9b9bcf71f39d7a5d68a37bdf0ee411a263cdad8dab24b5c77a8eb95a4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f5032ece2581c804a4fa22ee2c32887d731c2da4a4848dab785e1f678db20d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8973a71ea69c016db32b35c3dbc1e6adae9170496d10c65be978a7fffaea3806(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a521d9cfe6cf6c15db0240aad9ebd3692f4fd0031a2157be680fcc56ec11c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0951f2582b1f3d69e1afc9e79f77f02112f260a74ce71565cbe89ff85c81285a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7329dfd722db9c3c267d69edbd3bb11755ec3f031f6d1f3ef9553ef54d29c3f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7179caaba922372193d18ede2ea9597ee7ef205f7315a07390edf6838f54367d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d5262ebfc65b19b4acd43fec53d98dec21adb3e7950a0c9faded316b6bfdb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a29d2d6b7e0718ec6c7e4f260d81f7dd8930c3ed9a13a1631c3099d413593c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47394d5ea0f205c7856f286a940bf70efc50142a9ce5872e6f71ad328aa013cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739a2c54c531bd76514474efa019be4ae14fe73b99a3da640c0ace28d1b2a6de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c771785233593d0e4223caa161540710ee6db1e92d477309b5477558e16de172(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9c8467d0d4652c620ce4cb64e85584615976c531f2d3af28b9a17ede01f233(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67b8d24f8adac2457324be5244ec90376a41238c23040275ecf649fd3542290(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4026e49442400a8a69dbcb5f2357c165e80163e2b9bca14a89fdb31ad14a246f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c389a9fec63a3a67504975758fa4354d60957b3ad744d740251e24120f1bd3e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__104829e75796fc65dd82e8514b17a4616eb6672adeeb7eebd5bb7c11bd9406a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2ed944bd331026a7a00baf68eafb69cb7cd5108142be0d1087db57587e60da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99c14280309f8334dae45ab4385ec1a828da50e80a8e8bcd36f9fd403461884(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0148c737077589241144b50d84745d6bd2a15b9ad1281bbdcce4901bb078bd6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c086c77c0cb73047b9bedc46a4742e92f4faf80c439dabf607d855b9039f25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00ebbb8024f071b07e6f0d49b3ebe8a18efdef9c9ff395c2255e915e8a1e375(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5a95bc609d3b1ec8d9dee1503ddac9bc6ce2f3a99405fdf117ff54aedccf3b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343367b5b10f9b2fa5bc83dc96026182208707d3c3103e6a0c5cbaf9148f1129(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf078f8d7c1862290dba5de7d2a1505bfa5692d67691a3b30879ac459db61c0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52714cf234b2c8b9fbd86cc5e1fa491a892738bbbbf25dcedbb81dec3fa473d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4a04afc3fea548cce105d7b891c3f6ae4f9b976ba40de7011ed713af3fed42(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd7887e0892614b1561bcbc3a5a0bbf4ddb8ae2d100f85c21d3edf84445b5d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80950da5d3678cd181bf8dcb784642bdde6a48ebb5fe5dc11859214689a91e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0241fa6d466a50824eaab3080ad7e47feca712d3cd1828a7b26345fe2cf4317(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077531c37e619bb85e89f8ca256145141ffa3098c7cc77f5df71907373aacfa8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4018205bcdf11cff0124ee32941577e728554acd9df75f713efebe05d9e3162(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a49f47357412107470049794d4480cb865a94cc53ba31f5060591ce321dc11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b39d6dd0e33e7f8ed3793b051282754e494a376f8fab9cff6b0cc3a6d9b3ea0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b965a417577dbb2f2ef60b7f78e957993d4cd462f6af549ce818ac072ab92268(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8a71e48af035f66981ff74ca00c5e3dc8e0e0233b6f30c348a41b7a6ca3295(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33bdc2e3297560252f64de097da6900be4d00f78137f2ce65ddae73efb602196(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b4f1294d8a0542344ea210f82b50c9e8ffc250a6e1797fe623ffe386667503(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e94a332e7ae0b4c3951807c8ed790cec7c10c47a0d1bf320821827883cd122(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e488a085f67395c2b7c5e8d4a100c486fed8a964f35b4f9010fcf1aaa0730788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e784986c45c7df53b613ba115a7064d5c1ded1493c1fc20790a46222a2c495(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac878be25d194d64e1942ecbbabb9244c9dbc141c1359138669b23ec440ac83a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ae5f89bec3b53307f405c09bd0dff5aa57d37bd8ee76697d43e6731c13837e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8675fc611d959e4b6ef27f31de7629c090dce976d4d3cf1d43f0bc62ba47b458(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2416a67dfbcaef0155e81bda936abcf11b4ec4b1fb71252efc6d4cda52f2dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49c8a2865306494869e1d3f8c90acf0741520588d3fddbc5619c4bf336f4344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473617858d797055446455bed4cb0d741de2ae232ccdd6d1ab8433d8451c2443(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644ee8d74f7dc20ef8545611fedfe997bf13672da386c354524fbf810c1479c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a7bff27b70655ec4343127e6a1103c15677a4fa9c3a4da0b3b34aaf2881201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6273a2a80e00ea14a0269eed460b6104dc49ac6b38cde4f622384225165254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189c51d6e704f027539f0ac89f12514b4aea847cc9de2cee9df1d5af28bcee81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c12f3c3aec4bb3d38e84731b84d99ec30f93a93dff9d77a0eb40530ea62e67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd9eeda0ecd7152037973c07eb79e42b5c10234eb185474c93e62d17461f3e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c10e0d5d8851ca6566034e34bdfea7b55df2bc26a61f2fcea3256640f143a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea030dea2997f62acb836657f4ffe5732a77305345f20bdf485c71776c13339(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ab3e94cda97ad4eb63e42077615d097998d032ba2fa56d4bb60c3de4217554(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361ec076f6e3e8684d54974d29b98603f153b9dd56db5dba3b7bbb177497cea9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed62862cb0809549f21f7397f7e9d004265dcd9a64a9c5cf9cda2f77962bce74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3565751d8f34496226a88887dab347c1ba4b2ec7880afc3023cedc4066ae9115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d72b82c739227cda60d48ff8243aad84ef8c75b742626160cf43b2335e3fe0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87124133211d0f43a16286f223958ba6ba4503fd8f6bd9208678411bedd7a25e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933573a92c6b1246a73c26f680bfb1afd083d8f46d44b19bfa4b993bdc35e7e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8132dcded76612fda334b00951276333430324b2c18b31757203b9eaf93f21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661524ef3d9400179f14a42c5c30c69698e30496cc0f677e1d6032fc5821f4d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a39ab85f180e406d67d6ac75011d027a392bfdb9fe1f4cd2c457f25ab032c31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a536b9a184fb74f878f0c64b2c30330ad124745722a0dd91aff38a8a0493ae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0905df4ba57f08663a55c27d4859ea6026f50b2aad1f38aaa0b67da7d71ac1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02612a5112b2f300641d279e1c14dc7317383e8f783761b06507beff2cfe4288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e004186896e58cbee0969146df128bbde8b7050ddd720db42c0136592c634bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7327640050af5f615ac90da4a959a76023ed0fb78f8a26a5363971078d12dc23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8457ab470f42dfee8e410228e9dc7e4126c2b6ec212c97c75616f86716e6e07b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e474744f731befa09e823936708c43fca2f184709a5c3524a6f45327f0fb3cbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273c3ef95c7f3f759630b589f618a781da372b976635646e714eacb0bf88d243(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eed44728f24ebf8da1dd1f4be948c3265f789d82b1dd56e9e0477fda9b62357(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5c6258d4283f4a19f95e5019075866830a2102397eb2a532a8b498ca527dc7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c766b3a2ffdbf7f2f217dc1148b659b7a68d27efd4fb823a4a3dcc520d1dcf27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb9a1ac748a7be31cb35d4fe67019189394d8399c675511e112e5886dddaebc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b305c8313e170ef31a22330ba03d1dda86be4b47c4a11ea15d3ad70912f99a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cdb57d061d85db4494c2aced92f8c9819ad0c77da3541f6d09781e88367962a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f31cbfe269288005dc55ec0f109ef823cda4d0f0a8f34179e8d336c0b96cb0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70410b2bc4941becc46ffc2af63fe3875a4339acac68cd191fc3a0b4e361a4d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea29d00aec4f046b589621f980c0d0c6b00bd9e4fec3db373bf7c4af1fe7d82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4336d3f3b7975e9949c83f3e876558f499a62f9596c3e4983c643007d907c02f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__244147b98ea5cc497bac545b6889e2582bc3a0e11a52db92a62f1fe4a2aa7273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff141be84cd11c5041e127341528833179bf87c3db36e4bd924b9eaf8ae9693(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81b85af744bef7cc5ff20b68d148c13d8a61b3ada1d2006562cf633bb01fec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d3c7a6192f65f066bf3c89d2265bd3055b255cc7eb7cfae97db25377251730(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dffec3762c260370db254c179af423dc89fc6a7648d2a312b93c9caa6ea4e9bf(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1e4877266517056efec8c5597b0814f489fc8c22625f79c1a79a797b030af0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619631bc2b92a1e8ed5154970fe462974c01e5b5a3e6c9880fc7863111bb5e0f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34efeef7864bd3ed8fd5ad1ce766be05bfa11b058bc32a285970b6901cf54df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a495f01f10f64e33a09db61b93e3ba2478ffaeb3f3f15f2a3c00bfaa88bd21fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf473e232ed62283d95b04000c0a969051eef0ffaa7f6a08405a851731c7fb8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34fe0616e322a1fa08134fc7922106a68ff766c868abfb940d9f2a89675d146b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2ce5a2b46bba505ee350b26068b27870d7cd09de025347acb9dbf058145e17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921d9426ab419bd4b8177f003652573671f1e6f6b51dce2cb0d6cd8b16a293eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a66839bc97462f03a4f05fc5bc93b5c935a09e1e87a6435bbcbcd0b8b8d748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75993ada51cec1b2564607b3bd3f81ad0289ae6e6b8ed293d80f1a0697bb286f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532d4ea096305596a2ff530742be496071f0545d559b9d983066d92d06ca6a9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cace56141f0949936c9c814c34e344e9b060e1e07ef08406a3e908eacac9e068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc0676289bb472adfbdff37c265c427eb9490102f12a6b519201cbbba59944d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b127974f61ef895434b6cf11935709e573ec3cc3cdf8dcd1f0780e01bcf7171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d572e1506eb09dd65354d7d5c3b5715909f469f1c3022664523a07cb04b91e8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa2dd96ee0f435de58c6008fb8bd22af9b7159e701e6c37dba65758816b4d5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b478b56c858422119aa3ed1df26669ebf39f8af01a2180a50e4541e1486729(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2110d05a6ae08ef6522b7206f885fe066870f6988a13bfdeea76acab9d9d391(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28279d4b4e2aecbb0509d70472521bbb8b0adab327057a5b0491c2bbb5276f5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfef957c899d2baf8970cbefb00747b437d6e6c940a68652da8b11d362bd5f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ee94d523dfa21d31856373564968da7fde4fb2e538813a685e1470ce92b2e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4463500f1bbbf25064cc8cb6d2fe406ae1e74b4bd64dac7df2784cc722d43974(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823f8bfe93e38a9b0964d771b2c0de0983ef8deaf27e2ee4c9726de3090091c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7835113469ff88005459f5a1a51ec4148de4a3039933a29659a3344d8fe4c43a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473f9fb241b28f8b49503240359c87a9ec873d98d5b6f34f6d2434d0a0b6e4a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0fd0a30b6b56d2411b121cfaa7c2c9323bf6f8c462cebaae57b79b975d057e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e530417df375bb4ba9ae5545f9f0f57da7b1e44132045baf5789313ebb6db5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079c25dc3405f0a10b3c040e50c0046a6de8865ba2090dc1f1e8223f4a917811(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4ddd004312307cb715bfc9fa35f158195c1a651ca4eb22576d8fbf5f8d2886(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91c88a889f720dd6e017273c62d877681dd0cf3c07388cbfb2c95ddf38b5a01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92189ca6cf047daac9b9a753d424f72359ed61169f3ed091c348329c9d9495fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b77bccb0b779dac45a886c77b900db3d2403bbf53b419213a1f2f4ddb10ebf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a412b97350f733dda216b1f169d9c219c7124abbd99089ab5f8a4620b44294ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8c52a8021036c49b3a221c298bbb22860bac60b238ee90e727879532dd6191(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e032f8a4bf539a83a5e074141bb6a66c755179cecd75e524b3aa329accb0287e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd67bca828a59aeb72d67fa856021847595218954f7ebd996fc789e75339991(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1406bfce50796efcdbbdc000859ffb1e340c85ab48875686e36a6b136358066a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e614454423b40b1a89c97b524fe9434c2e591711fa981c0ccf1e563b7e18c1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8960a09ccaff754202813b3801888a290e23670e0f0fd05527ba7cb13546c1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e0f79ddbfb09decff2114136a02c3d14db788dea1e4f987421c99d4a386198(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ab6a13564f876980c05f9c4f955daaee588a28782bfa7d602be7528e0042cc(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1008950be71ddcf3c4264affa3d0d514610c76731ccae1a4e0856874093525f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b3275c14e8a99d51dbd1ba13b095e785c5a1bbf6a20c3e5de507b2841422cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7259e4057affb654913f91b22c854b17583cab9f1ce31539e7871ed9f071f05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc49f8567bfc59e5b13382a9c1d63dbd01051a863f156c87b5af6632be5280d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__085376039b5605a7e849f74c906ce4c2379dfeae8c601d67a1d04586ba907a79(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2e58015ef9148075428f37aa7827f9248b38ffd588514e3466d11d41946ddd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a10198b9123ee2f1bae158a8cf88091c0d0b6a5a09bf3c8a4b5cd6f67549da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e7c5b32cd0a78b1ba5606003d3b660eec2f3e04a9ffa29812dbab618071b79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__058b842449192055c88f37c1a0ab6e5211332d4983fba18d35571899fe32c4c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701023c95c5046df7b3f52bf1eea37b76b8b6f2f7cf4b7de2db3fc92b344c9f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e23e95e2d977a5cebfc56f4fe3ff2a5e41444b3ae5d2613da9233433a111a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc9b6fd10ea1afaa28ac8e871d10b989e1e1910da22227544f69d2040cae883(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a93ccdf9704af653da6277c6d8ff3214149f756409d96a59a8d8f2729032336(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00bc4bdd6ed8233f1cd07a4758eb8c807486461448839f8196b6dc56af67b830(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa274f71cbd039ac45e2e737dfa098b5327cf217a8808c9ca321cb41d544ab3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c3a4816c8a0ffdbff0f9c7f5a02d24621926a2386033ed3a5612f5fbdb9617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26655089ef277cc5655eccbdb5729347f2c31d1501ca74613956399e8d1c3570(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46143ebdbf8068f4157bc4131dbb2b077300064b99ab89468495bc3422030aef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed4895fce4e3338d748d46637b563e0eedf43ae076fcc22114412747efa7145(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127931603bfca7e2f51cb0390dbaf156f4f9d6281ce02c1e714d72c90c780fa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd538f4d065f685b78e505d285cc24812996a210f86ce541fba05a8eed7421d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0ee60708fa8bb7678f65082fe0943f3a99e9da6afa7879b6014f266cdc6c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102692259261ac722543d0f51e75346807a0633f47f19a4dd6bb998675227b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0208ad241b7be102a90043f682c33e285b9c8c8939a2d39f69974ea9c7662c6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce80715fec7e81b66e354df73e1b1271f20670fcdb7b360951af589f2cb9905(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea6b03988f1b144d6dfb83fcb360f0d3e666557f310f5c60d84164274473470(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa4b87a3695646ce4597534b0449d136be699ca86aa89178195db6f89f927f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175c2fc800c78304773e4160b0c777451ce1ea168525ef03c4e8256ad6d3c634(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa5a173edaebcc9aa3cae723fa1e7fc12d0e486900ac3044b409d4f7e4962a5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a552754685e949e5133a24eb6affd0b0f2aa5d5928bf91b1dd0a3a8aec1be64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e6df7b9fea52624187ad39e594ee6044870d1e894662a0be3377f201cb369f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9806a449abfc9af7247143f42e650ec1f6944480fefda7ea5f2be8c4d8c4ecb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe17dcd88e5c3622d95d7d2d7bb6291611d10a68d7f337968efa0132757a1f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de47355cba13f9667e7f2e4414ea5adc33b784ae400cc6b32543911ccacd6fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20628f9d3f840e6bd65d7024c2095a0a332f6bb04228f461ec013faa98f46db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335c86a9611ebf3268812f481fb99b2eb22262362c2396f6351163a19eab23d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc2f1468f5786166ccc9cb57b1a0e126b37a466734985c8762250cf98158030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32e8bcbf80586c06eab5cb0fb6c784c80c84cd8998e2c235f6eb51811ce6f7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1725810d9aa02d0dcdefd52b84654eb42b64dea121bdd109a123399d14888170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2049c97ee6bc487af278b9098903abef4dba4b0677d0d039fb953f1ca95c7e49(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__755ffb59665528998b455b91db64a4efce228191bd4a6bc3b96068411634df85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8223432caf97ed0c9228fe59400d5b865c726043b51ea2ddacb9f2b70b6f4a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63299e0222639196416b8fdf7eea0fbb8d97e83de7b54ca809dee42f5479c553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2623d7abb942f320968b29dd7abe323fd551d3c999ccc7f5559075cbf828f36(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3963e79f59247f2875b43f941295ede1a15cf06aad5a1cc9236a2017566b62(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc91d10af86d5f01b2c1bca6cd1943da4807492145dde7ef715241b953d57d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fd43b1ad191202b4b1fa335bdcc6dedc93fd8ed60db9a9b593d7d946ca0ed3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6106b45a5801fe2b2960841cba50834835a78a7ea9deb92fc327d1c3a45666da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c73420ef320971653163f913f00305a4159354e46fc33b02e957bf8aadf7b76c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5621141cfc839ae40278b5f8fba98caf84bc4a4dd61a2e6d0204a80bc5f6b3e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a56c73eb2623f28c0f818186749246b4e66b4861d73e4654489cda3f64c6de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe70f3d0a3d5e2dd0c1ac929cfc589948e085efb3a9c130fbb9693a0320be322(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8d9e4341b30f44db0f59485ad52e94e6123dac467ff383c57bd511d30abe15(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35007d11b3a050a43c076f035ec97ba5251453a5f34d559b6d4814f380f9e326(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c839a927451470729e9fc17eacf2db3c2e60f26c9cdd73e170b3df4a932c9eb3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0446090f67d35f0b03724c32f638e94a930504db37c8d83840658e00fa70817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1275d901e53d4ca02a48233126902c26a6094a018d2fa024e024ffff69b12832(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda9613131f1706e83c7a4e7e89fd0fe7e8da3df30b692f88fbb2c3a37629c3a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cae9172127dab6ef5fab2c205bcb656ea041095f1963718178f29863a96425d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01f41c99484418dd9d37b847cf60b18075a71eac8b5d9e17abe1b17c89615b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f518f9d7a20f1f79e460f0fdaefa9db05ccf1f8faba1c9580e2805183763def(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37eed1a9ecce79cd0f63a06c751d4002a1958af7d06a82c6928247063103253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29634b88a445b57abf5fbc8ecf48fa4ec8857080a53f34b58a529468386af9ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a301afa10f1a0e7bc38b4deb411f1a1f22f1451ac443fa5036be056eb3551d1e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd25141d6efb59a40f7dc5a7898344ce6e7f9500e5e661953a96a6dcd950875(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c8f276c2652a9b93c0df3095720c2cdbff274492d0a1e1528a4fcea8d5daada(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40bc8c149a8caf49f77608fa2f662ec6d30d68b52d28fa4514350029ecfe4cd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a79752fd8f226007818df59b5c7466665cc0cc2370eda55dc98750a01e4405(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff73485f8ef9b63a16829c05a275f0420ae9f817ba588b1903b58f30c7188d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f9fcd35a2165055042d77dd0263a87e745b02e8d82627217cc9cd48cef878a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535ad115cd1c47aac17c33b55f853c11ce12ae71dbb1894c569cfebf138d0e2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac09ae6fb0498bb4da6f08bf83ce11e63b51a13a6b7d9e6a83600c6a36ef871c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa4921a489c4511b6b3bcff8987d487513688f24fc10bdff8f06bf861d4c42f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9ecbe030c69f112f123f20a22220773f6f386df88cf198f74cf1c727a922217(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9813e60096a7c7cdb183f2df0322c3cfe1fc6807aa2f484ae5846cf4f3ec36c1(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa1f86eff141002dd6ed237f40d05b45a3cd09bb92488db84a08a85cd543816(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4483f859016185aa33381e8fd757540337ecfd48ea25c2f0c7d948d9634e72a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f4c4e1b049ca7d8619ec0548ab5198d5b6934faf0c72f567bc17943860e3f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d3f3cc6171cce5fc735661d019c1b39aabfc217675f639046a3b028fa205db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809e67714e92433b70dca302198b4871d914136d602278fb3192a63c03eedd54(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f78fdf467842299bdb57349cf9c2f022458e79333eff5d24e85e1f9b96430b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9589c59c3df202fb0228f8f10e69a90f91a5127b65dea1c5857a7f7f92afcee4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0275e07120e3bcb5c1a547b89cb15122f951806e560d0ed8dcf4e1306d355283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e60aff92e4d651d2c7ad4919ee0d9067ab86bcc775f7e74c63f686b80cc6b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2dd267a6dc1f6d5537b4a024f76f3c28cf6a7c9be652a8ba1692b3890912b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5699f5f96b448197069bdbd098fbaf11e4b782ea389dcf2a9fa94ff00be3ea89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739da48ccc9f887f70ec75095643a5650529bb616be4f325ca012e02857e1ff1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1fd31b0d3c6b377a227f2bf0727bdf06f7ab6f2002f26d0f1d2d8bb795cea4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad058b744edc08b54adec8096cd7772c0c37572f716c55466c83eec1503910a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3505a2bc93119c88beab417ead19e6cb14b383caecadeccb276c674412f5dba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1bdd587cc20ada53407798c2b12b982e0bd645d12e53d0cbc830841929b2157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a3da14738e07d53bc5ef62920219cb9fa4f963edadc2506545214a9f0ee077(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9a36d0c787b4ad44b27934bbc59679b7884ebe0085a3206cfaca7033cf766f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627d3672e68e2321841f8109998d62f0e5fe18652d39bcdd65f7565c0f6592a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6bb0f259afd8406fee57e743ee0102e86d673639b608eabb4bd1c2436ca0cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5cdeb1e204e2d3f6d9c7eed1912c5927b81a1c989b61d4b9b2e85607f0a42b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730819a5421a00c4a0c761ef65e09c2432462b82fcedb3a36bf3fc6d1f6a8b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d61aaa52bc4132e520c6cc98d0182626c2cdae3eae2befb27fdab72bd5e1f2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ca6a25b86032700a959af9c9132106477f75c73955cd92fd29d9768bd0ae1f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c274c363d109445245ce3747ae28c3b49a0fb38f5baa7dd0288732f1115018ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1b645d6855a7850be89c02c77282e4f3fb7ba8d4d5353867bcf3053e7662d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278d2b6fa97c6cb717f0bb70b617bc36e890214dd080784fa323866377c1e486(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b3ea5b6e3dce44772aef5bf2f7e672703caf7b77c4f4b2eaf81598184c2350(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897a4fac71f0d3ee38e7256a1800db3d87d0feb63a9d53abd73281257a4a36b0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614ef0ca9f710ddf7358a61cf43e74898c62f8713eeff15d46d4773b50e2aaf5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deee2a652087550e60e938f5fe277f1353b94b432032a33b2893381a4864b0f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1a9d08d6f4b4cac732073c034791ce55ed48416d721d2e2a968fc0ce69e13f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319f1414014b5183d584c76fbf1ff63988e99c2485d9862c62553c0e8c26f575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb760543bf8f4d82c43936f5b3bcb3bad0314b1c49737d6b53363354f07f9bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117d1a16ad15219b75582eae91b47885f9cda7e8f900b79b9d07b9a5b4d9f3ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3013e38bb41f3dce91e0190e7f2c26b6ddefa99c18d58afb927518949b5ad67c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f62306f1f880ba50e44a12c5902ad314d6007818091144a34dc14cc60f9b49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75a09cf527f4d11474cd7f4e6a9c43d1c3c7d42e62ef99c45c7ae9d82223964(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a725a70efa0acc9fb08708f5b9f7ae7cb0e87b556640a827ad9fee038a4165(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e3795ceb1ec93c2cb059e1fb2e86814c393ab67288dc435cc754d8213a5efe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea0e98a1a08ac64891d82806b2972b69f53963c77142013aaec1292475bab87(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd7167e06087a949b24b69e0c41dabcf1dcc17dc9fe11205b192307b0b40e67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7eeeb37475ec0ccd0d7ef3cffcc9cb6aeea00ecf1f84fec2cf825064152906d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a74e13a513632f636f039e59b7d178848afdf0a30ddb31cf8ca5a2c465f36a1a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4a4595d190146715d5633323e9246d83808971dbe8e0bdf64cc5c356c75b58(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44bfa8a22fe5ead2e87aa4691eb65ad98a0decded12531d61d616bb5e20eeb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613b923d76019b3f578f8dbab249e124385b92563d92439370ee98a1f03562d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d864093f8647c6d3bb6b0f62a6446e9ba727c3ab4460b68d0c6983c424a400c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0e210cdb41dcb5714d13538cf4a0f97f286cf443b04f1917c5c7b210fcfb54(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2ffe61728f0b73fbec8398f8bf0a2950ecc5e3558cbbb8f3f231b3d6b4f694(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fde1248db5e29785da7723d9d4c7bbe8000bfc308c93472118d222b0131aaf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4981d5e227403e9564c3a830c772a1e58801f44bf0bc34270ab299ea66df10(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3261e45806cf71434a7532347f7c4f86949522475d1977ae8a20c56234477d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db788d1d1d4cf3253cfa0086169d4cf791dab50c8d4fcf706d21f49521064ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c576ac89e4ed868461e91fd983edccc233f5612e22bc4781928247c01745cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91191d74b4c2f4f6163660a4108db41fce9f881abcc7f721f665353512cc989(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5b126dfbfbef6c56cf57e26f1238861ef38057e88d0a90afce9b49e639eb39(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50883701ee25e0d5ceb46886893462d6426ab45280a117aad020e1e988aa6878(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f91b503c1852c8a56c111e998ea1ee6f4e74c65d600823081a03834b89323f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27426a7b23472accbd28051a0e8290b6b5643c11491adff74d23458d8a681d40(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6134c0a8e6ecde770d81d85d0b2d14593264f29e71844d0ce6e8da2b9e97c77b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0495a1e46a637b7a1161ce9f676081afb31d0f8bd9d9071948462a38626f2b0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6392ab12774aa42968d39852d873b8b2268029647b6de18ae94c18a53eca56a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6e52f76eb0f6d30d387b6f6a6f6331d7cc725a58c91d972b2a92c33769c656(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9bd25b1761dbf93ab271608a3aca17c175ac1ea6eb450c5100b82bbb303b7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269b4d928f39fe176d6985995415e80f4e27ed89544fbdd9531ccec79b940e4f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45efe98620ebff6e8021d758db2f2f041a9cae9f2f9da4748016d255b948ceab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de35b7898e53e1d99aeb6d4cd09c80e440149fd2e0b19f4e97e9df340cb72d6e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1edcc674d427331180328751c491e68a77cddb49abe533488a3f3281e328236f(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1987887530bfd05096df5f73533daac539e67b12526b1752b279fff3262f5181(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f70f8d07dae0dd73194edb92268af22ed5dbf6f49f29cf09b97bd338f5b5b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c89c1e0b164a115b54b86c1a5c0978656fdcbadec702452d3cf2822e773fc829(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242cc1cde590c11c9fe55fe1eb6ff2e99d64e4504f36f8884b9a85d79d29a83f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdf8d922c2783383bdd0d4298995f1793dd11610052d18cc46d48ff77e48c81(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a452dfadb597ff060605d375cba7a168a7bd55a4324193916e4fb0c7fe3edd25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9c4049792cc460b15761e6731d1dbf3ca2477433185838b35440dc0f899188(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a26ee0f25613a140da1f477e190eaafa0c6b920cbce1af2f3b25b5386daca99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c18e0f531b63f0894752aade79294dcc469ba98772d35b46d629136514d095ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f84c28a3bc20ebf808086bc9d438e73904859826866f5de58dddb444bd83679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c6cba081aae7bbdf8ce5135e23509398c4aefc8020c7bb4cbde89fd30140ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__727e29fad17ab44ad2d1ba40a070d48d5d3bf1e97a7936637d745bee7f0ffbfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e196812b77bdfefcbb2e98f71cd17aed1ef71766b53a1d2d91a945973dffd21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42911f58354542e3ff1632228ef5a76a2c8215365592200b4c890a91c0e6040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a012c53daba3ff3fac5a7cea8c2e4bc5304974228fefc199104fe4bfd8bbcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b0fb4b73d171c3b510551613bfffde24d6950e88c734e79a1c236c02946d06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5112cabbcf1dcf2c93b527040fde8f60c8e6107d235e73fef4cc31820af01671(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e251d7a121789788774c18b38bded51bb56116d6ac949cd1c531b0523b9861(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93145c1857c161a9df3fea39aae865a2f2ef729f0b8d33a0c7a07d2344afb753(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7581b56468af770408a97f28116c232f8b3394253392d257861e9f52676b10cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4431eba3d3fd680b72ff5b918d008e6c0dcba970d3178418ec9b6064e53f6935(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03701480c59c6e12e84743c53640b852842a44f2f2c161f251b0d923bc3e7cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8988064b0b492e9c71e9dd96c2687f4b7236ab17543fc5d23baa987ce616fe32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d136ec2cb0d29fe2c0341486ec17b3016274973c087b54437849872a739c849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d66122dedf9a85cffcc565e76475b3c18a7f1a478ad24d8e9f50956f230e9f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2be058714ecb25da877d78352f8d73340a9ae52cd227e319d51a9d383a779a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c16f4ba3c35142dc0288c0afad96ce6e3428a738c32554affbdaa39d85d535(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd442fce42a7f5150eb5dbc43edf35250275d6441525b924e38341a16632e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8e49b7a83cc74a5fffccc70615603e2b2c7ccb338f616562b4bc3c5eb0745a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1189173dafcdfb7cc6b9c648898ba8474e1a9de5bccda622da65a2b7015d91dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362e3a15a8ab758b118ab3f5e40204897ddd5b48974d0216ba2ab371cb2a9a18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3d71dfafa241a5a1c5f5bdd907e558f3c521f305a57dbfc806620005fc36bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb5c4595eef714c5af3dd9daa9f9250a9f140bd47acc8232a055bf49e5a9f8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d2ca0e8d536aa0bbff51ca1343401755b811dd9b42b9e189919fa00fb21c36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6538eb7f0700719b726cb192971d9706842cca2fcf1b709ac2237ae5b14ce34d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2e4e8717f99ed2dfc72a95605eb6771d07c0e878835a9a63d33a719094b51f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf195b961460a9183249cc78e49e151097a154a421ee405332b70aa082a9fe3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38397026d0225e746531e28c5362bf6715ed494766252f62ca890df342fc0d70(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7153f04b87ce4ee8233cb85d4cbe6b01ce6b34f087909d2375da12c274619ad9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507811c8180a6083b7de57bed3263692e52381e0b5866cc990c13cf0c6ee9c96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb1ebbed46102e7bb11a6a02dd9aaeb9eb58fcda7e843b0a5e9ec7add1e6085(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d61785af05e403b176cbc4f08ee85d0f9ecc5a8d1ed7aed36ab14685c53729d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ebef4d676090bb7e47ee021e59ea3a4d056ce447c20d068f9471bf580d8a2b(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00f4f25de9083d8e6a90766a9dee54d3a7063d481d3d9fab87100d6da03c8c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991839df94857b362414eab3a7af4c1f9be45fa8d507f2a70d94fbbd8fafa2a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86441aaac50c66ba593fcc25a16291f66064f473655d00afac958d598fbcf166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6e118bfefd06b6f1f42b9de05f28e207f38a00256cde3607009426ce857eaf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49fbef9b85a1cb2e3317fe94babece024ffef1f2b73d1088d9695872c43e9311(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b35f65baf69f90efb96f1a065876d1bc35fded20e84d762d45c059e72797357(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c0fc832050ef19231613e4bee7c72f6b1152aa8bc5aff78dbaf4e1929ec1f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d099cfc05774a7f4b5f2dc28781c22a2e847a2b50e5c35115d3ea954d46ebb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c463f49e20a20042810c4bd76a62997123731ff707411ed0e2ffe59488015421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b33abd8a6a1ca2f963cb38d2fa16cd89c48719c556792995f17bc353226af92b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__022bb022394ac99158e07fb2f21d5d6c2eb03a7ae549802047ffec8f54f32f5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e28101304d8caa1dcda7dfa88e06e6a65f3b2d2cca23531e5d8351272b2cfb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e21f812c98f7b27fa343682d599d911a5580b6d063bd8a4d7ee08fa8fad9d80(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__366a177ca5c246535f14579b97eade09f0036d0aa4224a4039fd0a62953ed0d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46436eca1807dcfb92c060005bf30cdc0144ab43ad33080bb604b18eaed589a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c3a12e5824419d2cd3861a29e809bc42d136e17d45fa42f24a92b3dbc827b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240dc76038303e81251754c3f0410118b2abfb12afbc56bfb86ca5223088b333(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__687f5300cc6f2fc5168ccbbcec6d95237b8a380a6a84322fe6893c09c5937441(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d0bb2ff97bb54d5dd4d399930b34f5c482b1f5f80acaa938f795c424b8e6c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87745312ecd0d1a17344dedf0da2ae25f0051a0f1aab8b375c0736ddad972e40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db238625b023c70d929f8c42532265ee4066dee0f1e201449f306cc841ad481e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4554ca1c431447642ac3d15386a6dcfe670de983af7834874c1a68946d752e50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b102f70bdece8468706826d855f9b8c8116885b4069b678e5ae0921a02e58d0b(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91151e1b5f8eaab01173b112087ebd288f433d5859424c4f1fcdf4f9fee77a27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f338c1ac19fe3880406f78491649a047cd6de29d85c37697436e232ac35b6101(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a1b0bda931914eb2bd658b67fd580a3a21c3e5b3317a9cdbac183f0db3e670(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9aed584ec06e3eccb5ec7b0bbb54a6ac2a9142e1dfefb5f1b660f2929e9a1e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e2a2347b68a7e155269af2d67812c22682f34756f031152480e4493b6c4ff5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8a7ffb88d1db0b80bc046bb4f3789a56e2ee5d6ca489f33af2d08742d4855d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d0284cd1383f69e885e8eeae2a75c5f97aa8f6af813895c422cebbb66aecb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87893bce609a90dfb26b4831be679a33c299452686b0261e9deba214a2aed0e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d97fe9bba5155dc927a94053c7853dd9f5100d9d703b7e80654c5666e51b69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3739ce86ef0e68861a7ca0d3ab9641b473088102e17c788f55ae2cb4cfee14a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e9b4d8f73e6b8592b1347b5761af58e7f0d26c37c0a3f91b405458714302e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d031a2a4ab6c0036a2c50c89a39cb13505f838602192e96e0e9dc13eb89cc6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb32da1897476853a7caa563b6da2b5f4b6003e5bf7d1fce0e78f683c6ecd7d(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1541b3ab565af0b1e14b79ce177e5c6d59fa0995fa6f1254b60f2438ebc5a3(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89c2ef47b90a8f45a2944e0702873960efb849b2fe3e98adeefa600ae6ba40f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba8d890055201357f2e2072dc11785fc9a2f3040be14e34dcde3fd8a83f5527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7709768b9cbe5afb272e71d3882e7d38c1a5295517f2d2aa8423ea2bceade1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def7ba697bdceb80d6ac00d3b8bf6c57af5fda912fff4be542112ff126bdf33a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a836476c784bf3911f4d18664ef65806a650572c7441a56b995e8a1224d316e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28adbe65d9944146ae310e2ae5cb142f2d32148b33ae02c3134a45d53950f7e6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4751e545157261db3706ca9e4ef0b9dc4637c2057c5c7fe072e9b61d7946aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bb0f8d11b08eb63297e4604ac7c75675f5be921b7b869f706c65d74f35dc37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25fc8089e1812e5c432af3e21cb20c93f219dde13cccf237681d039feb853e22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5bf0dc36b49f48ac143208a147b5524e991de8e6be012b462d03ffbb21d856(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f529ccc667b62f8ca9f3475dff0a5005924e6f3686a87939280ff9841254bc4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b94d2d51d516abe397a34d30f148b9b8bf1610beca24966f91fd7228c9a1aca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fc59091196d553bb405fdc640a6f823fb0a1bcbfaa71940aceac6d7b5a9c26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613687fada091d2eb23dec14d38153edbe9e9d22fd1d3916d21a6e54e71a701d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cd34659d1b0cab96d6e0b46b0fa490d6558ccc83bba01c283b69fb6c2af858(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8811e397f7097393e6135286e278860487d31d82f6e07bdffd4ed73787111fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd68e741fcd3af0f80859e7fb8b62d0e9ef854b1831ebf212b28654c1d0cb147(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d69812fd47baf802b3e64c60408f12799d4da5d21740bc13660c8ffbff8b09aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc4a1156d6b0028b3a90673463a39c9cd031e136fe6cf31de31c63af7074686(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06421288a6ba3e078c97d432caf0527884718f01bcaae02cfbce7270d34fd8f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f318ad7222ebc314ae919afb5f6d85e406e740dfea4d8072867633ee796f4a22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7212b1aea61c90fca3f18cfee01838fd8e53ee89dee8295a9b9db8107e53365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c92498b77a1d65ca9df5f1df7ae604f4bd890d8545b11f41ef820f82493fa6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32dcf16a4251c61e7299cad556a68076e0d3bbab2f46fa94eba89ccfc7a1851(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381175ad7e74865ea0ccf959503da70207a5c4df7ca5ab6000d7a00e21f5040a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc74cb7f45dd9626d0799f2fbfb4de92f7d3f9990e3761d45982f78867a61eca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c489ca947ab3c85f574d1b32becce495edf53b5ba5a6053e7eba8837efe6ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750b497930149eeb81b607bf45001d8c6f00c59dfcdb2c23b86dd0ad54d92f9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba72020e8602703521f44c1d6236fdd73576b9caa0a742391f20c9d5a612cd65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b97e97cb8048e879f056f73d796506689b0279b0bb858f243438866a30a011d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089371c57260a0e60cb34b0634d49b9b356df4c98311947244491ec069c9e45f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1c18c2a9fbd87c776f2cf99d332a07a72d9adfde6cabc6948fce167166b82a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcefd7e4464ad6c5646e9b6f51fd515fcb86636ef6186035bba2040525e46d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5f119be1e8a61255966ed4875b2d6ed4eec89b635bf9ea9dd61ce0b6d237d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83d34d9b0afe3babba5ec33b8c84d9d42064c80a5a45790a1c0dfeaa53028ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b326c262fc3564b829fe4f63e539c45c956860413dd23a566f4d48888bdfcfd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20999be9a8e4f16de0d0257507d29ec701f396340013266ecd5f3607213eb341(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb4522e91ff5c97a1de8ab960449c22372d16e8dc1c41a48745c6e64b7cfee7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6322b67909983aca9c095c0ecb72a759a8473131042535d5ee73b556ae64e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd92fc6ba8a7c5c0e64b9c03ad3b8e73b3dacbe81acb21b109ac65f79e7e981(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13422a2ed06a03ac86725a7abf677a04dd70d05efa2a6b138859920f99d72a4d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f054087aec53dc4d565e7238c1e6c32a5489c782b4c5df804b25d788af5553c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__736235f2fe2287f437068d398cb0ddc6d071cd0c5a1e5202ecdeccfdc3a31451(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dabfb8f0ddda62919635675fd0756d5dc7706dd96bb7029691c4a7d23f0c3f19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67541bad4020c8f6a3af73f1f4544c277480287f03910fc8c4d60b85d59bd96e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66fc74728f299c091f41e6152d21c54c9a60e6e2749a27b3b7e1df462987f29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b9c625f6854a3daa7027dd1bfd3a7daba32a78b18c0949eacb68bd83a7babf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6f2b83c1e5e7681d500c627df49928d6188b217f654901c2eade401721bdf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329f8c9aa560ee2ba28e32d69095f532a3b03b7d9cf33104acdf9d8065f91a17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c5d576140b4110cd5c68ac04fa58f0304a60d701f4fed91f7b00e46df4af47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666a2e269ece99fb8d75e5e26a765877b6afb7369d1d1422043e9cdd3c0f9ead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f891470e1fead7d5decad4328724fe66fae9f3c95f91c7b4ecd90c760d544d0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1a51c4d6be8baedec6b7cecc0e1f9df3b8edae242fe12b573374851d1bd86f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6628d7d8b9c478c1788a7b491c02acdc653f39a2a9f9268e3839b37871b8bff7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403c4beaae8744f5419a5b5bf5817e533c661beb091b4c37b26bd5593f95539e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85a07ea6179bddfa79121edbef07d86e20610172f17d649456c6b48c56bceeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8ce794b2cb88bb3b25e3f74639e4e930fe59d3ef845ff801910198bef52f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8ae5029551b0795250849dab5e84e9fbb8aa6c8c448ea0aeaa5aedc4d8d657(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d086a906c868009669cfd7aae8649f424b2b5f422bd4452e1fa08fa3a0b0588(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac1b8ad975f6b632ac4ccc86dbbbb81ff26d0329146fdd173a641c99036b047(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c66cceae8760cd0d3efffa0ef4b4f638aa79572f4cd1aa746ba34887b7d784(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907d3e15582cfdd83860efda578e59f33effd6a251445d70cdaac0a72de50d8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f99c928a91c2c3f253d40de8e96939d8f124225bf15a70995b262250fe36ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463c0052a2133d20edc95282cd5e78d7932ed1c16658d322dd4994820214ac40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c377a26508b7b1ea9c295424fb323ad23eb29519ce648c29ced7d3c54419bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf6aa2da3281b2521523fb6be32c2290d29b296e0c6b064ecd31e866dcc8558(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11fded7bce307376d5b4a31fc03f51dabab45bc62cd466e6dadb580a258a4fae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30d1065827c0c6afd07f80d08df5c39b1a424eb0bfbbc938a60311dda15ae636(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eaf02079b26b23e02d66a62390f0bdec983f280b92d1fce24aea373019eb1e8(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4caef534684f713439f17407b61937bde015ca76637077b337abdbb85a4cde53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de29bd5fff3ac8536d1dc716aa4977142659a413908a6d3db18eb5946a9e654c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0b4df5eda44f8af541963c5fc47af8810ec937d20038e9f28afa7840e8ed5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6217163a9225dcdd00a56cf8dce3a5cba1666e9afcd075eb5fba7349631494(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87df160fce847d04d27446fa58f7cd89fca1092f791cef14f88ba432625fa110(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2147cb6d83da5455028524e9c36a8b6fdbef89aa676e639dbf15cdab03cadf2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c09a1abd4800c848c438f22ccd5a989d828ed49a2b75cf96cc6302bfa997a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc80c70c3995aecf3678cde3c9affecab6acab3a66db69ee3a37d2d083294bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d162d5cfab01487981b7334b95052add7cc28c7d2ec70de2d6d7d1c46b748f48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305f2a296e1046aaeedec1afb69c3b609d453040a07eadc8a78c1dea89528e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e12134be9828a92af3a2ffba4c1b8fc5630858eadf7ef4c19a8501b4afe6fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19da0681affda6e716d9308a52d6e6275afa03b5e2eb225df7e917d7bc4d284b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09b7545689803bc0da4c575fee14f07ed6c358396779b11fdd8a7d1f781d49f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c720e05326fdc7b1f6cd629006eaf957ca06cf5e6641acc1b40683e35db3012e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c4d8482825c6061148a9f79ef7e47b0040118f1172bce5a88ee4718aeff3e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0eda8a9eede77dd8fa1f58ea2fb941207a7fc1e14f8836eb1319dc9111afee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8cb662c5ec01ce4b364ec1220a251c9370c239c6cc86d61ca53a3d8a25fc2a(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c39d0bb462e926f1d3a8358251ffbd15611c387b854edcadae9ad6b6a74630a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0ae49c303253aeaf4fcd7fb3b655336101982fbf3d6eda403e2a3bab6c420f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63edd5b5c2b8ada5a5f70ff6d02b0e05db882c80c7738d529758cd2df30d90a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7c6db95f225119c5d379d028298971a5bbcd7300a4cd2c0cdadc8714c96c3f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80327b417c4e55f0cac253618f6e5caf2848ceabe12e9116712d05ac6518b2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260d4105eae8b08fada6748d31457b37858071a855de379bf9abb0c3d605dd82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f648b92b08ac386a939d181357c468dd6d68f087e0b0f3c717af9129066ea88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac57b774ad731bb7840f062764e2f600fa9a49a5e19e3d38161ee34255f25b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e492f11a85179fcc1cbf94e4404341e86494630e5a536e898573d80458f9e89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec60464f5c244b2b07df3572e7691a087d2159e923d0233048cd808b0600421(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d32bebf0308ee217d863d9ef2be9f96a886dc4b180ef3db53927e8471e7cb87(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077644e0d435098af12bf3612f74497a7693b951ce7a6546561624698537ea88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d76aab9c3847a0e58003c080faccca880bdbb40fa7c61254239a3041463286(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f40db820776409b357ca272a2d143751296598f61bf490bff78113a64de266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b0e5c8362b212f8d487ed8a0dac8d8024475e9afa92e4e0db31debacc7fc06(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d59e8f6b77065c0aba26c885cdbb652fc3a233ed3606fd60d1ac59d9e262ebc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89be9cf12d207f37a4001f2645b530ed640be134eddaee52716e3032ae3bb6f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__005330d087e31d4cb459c649b647e36dce245e95eea488af82fd8653bfd2f9cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2538c86cc09158072919a9e90d142c50ba9bef4dc585c291b2f994c66e472812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46be09a03a053d878bff273cfcb90f8c4a641a26ddff08c0be9471c7d2ff0d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd757726c1492e81f7434f6a798c6e05f81f02815ccead165278f0bd81e2b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfe95f084704aeb32df6e5be3df10903a0e7eee0e58457729fcc10b7620237b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1792d1b12acc1e114a732efbbf44b51ddef6922cb78603efd3df055cb5e5b938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a20d6d8de52cb73307e71a806a2d348c3e2581bf68c04b42dd23b3695f2412(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e425495d53d1882195b3c3dc7cb86888517eb4d4edf3cc02e736f31bd00ef9fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8849c3fdf7b60cd0d573a88059d056e72b6dad5de0b572571fddcaa023dffd70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06376796d2d34884dae7306e4d9e1300654698fba99a1eaaf3eb62f00da76356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e226d4e0ca103914180009081af4149a8ed6fcb47e21fdd924a5fa658673ca01(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5a6ccf6adfca0d193a6a9a5e09cea0e26a6f50ffa144ac9b0cb9e287d5747d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5bb055134387b603dcf3b740db653223aeaa45a2b900e53568e1b1e7e259b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff62354718cd87d08c9635546df90a33f37b84c565f39cac4603e793293dea7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f46a463dc1cb8309dd4bd03fc9f8dd00d6c581d52518b8d176aff36b86d4f27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e395ae008b4d9ffe9f5ad4e04dacc5a2172fae1b8246e457d4e86532ef4ac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7744af10bacdefae598a73892be49628ced11281f244a4061dc91e7a32f4abe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe11fc24334d02b0f759eccce93235d207d581ded6b352adf1e1756e727892e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148a5047b080c6c06d4dbbeb535a0dd54a8243b293ba5a5424ca1a024d1663d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6c2c48c29be91f6f6096ee7ff915eb94c4e295ac443b6b489d0985885c6314(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5052d3e88855e4c3713537ab124f083bb75aa0025fdba424036583f5dbaa2e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bdf3a0596767a23b609d68094cbab96d62a924e4be381cd55159f01d242c304(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9ba8cde42555eec904ff5d9160f15b8f19bc301167850ca84e8134993d2451b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ad087e7922b729f22d5cc2d25a191261f305c490f6b9fb80502f1573bbfcb5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7379353329fd73aec78e9341aa45682114697e0004bf552ad0045f91cb141d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536c76ecd8d94bd7e11087d9c0ad8faadd149ecb1fecfb7b28d828450e81f4f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1005bc347c479459974df17f32ad2292e71f35b8c36fa0afd6eefdd329ef25f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da431543ba60dee54631dbc5bbfdb8663131b77c568afb0a024c418f50d89ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0635543ab4ac4ae3ffe31f67897d73921856abecc0efe87cb19d148f13cfd213(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a619402b6c7e9b123461021b44f073d3cc65442d026dcdf3056e3820f44c5140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51bd0d75f5efa63b24f7787f5fc2e832911689026a51d9b85f60b7db14ac78ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6801462dff985b45abe4e9782be9727cab9b5b648d8bc9200900f9e3ee9c0624(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b4f36a05750a9ccaf9f3f2e3599037de00ad61a45d4ee3ef27fa41ef189eca(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16de13c5b7c4267ee66b20b9695526f0a6799c4b2476da5c89f20a65f1e3a161(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4024100466d4295cf8d787a0681b2a8b155ff1ec086446c12e74d65e55395feb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc6da990a34625f3beb3257afe376a9d3ecc1fb58b88101200baffccac27063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87328927571426c7fa6e1f29b67f827fd0c56a52f61f45d45272897e1ed38166(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bcb4ec35a2fb9d7190e5936fa1366fbe8dc9414f9e400ab276f91eab3f2dd81(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052722e66b433b5d96e25770274bc86c3634e8fd56b7affaf82b82e239e678f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361cc8168db787dfbc65249c157810f4c8e76e208a83e26fedbf4b6be0b9a734(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4abd2bfd4b10425cf9ce52b654255d5f222c592c11c8d448f37b40bc57424a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8203ad66c2a13aaf3373bc5f437f19046536dd48f3ca819e7a269290ae98ccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f9c138fd49d64384bb8efd2cfcf543f0afc86ab037d4603132fd7baaf9767d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6959701e1584322f8768b8b35a94c9196483a71238f676d9f1cf8d813ef50bb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3648e94858f2c713c75176e3de11853d8db2f395bcbfecfdbd65571483c519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d06c7e0506ca99eead3b7730e37c61155946b7302a9700ea71db301f31eca94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdbc1820ccff4f7358b75caa6fcc67cc7b7440e3baf89d9fcc9e0d59f43d6adb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993c793d5c3e239961b91c70259f1180f43f1e551306e81380c4f6a51988f26d(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba4e058b85e3109ad9d10b368e4d71cd13ca6fb58a690e9b852e0e4585d17ac(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1724f44e96fdb524033b693498dc9392c37f34db27f2076deabdc43acb72ac(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7ea9f3e03390871f735cba519aabcb8d1e4f62e88863155ff7f3fa503ef597(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__624c667636cdeb5ae38c0fba558e22da2ea69cabb03a37d0426ff0a3d5561a47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab1a227167710740c653b1e9789cc37dc183e89b0bcdde8b94df7e86150d2a8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2e676870386318cd84ee13ceca90166b2356b7bcf2bb017ce0ac37e97f6616(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a58b75a2af8e30a7356d65d576454ef2a2fab3b1083d8b834c1685d85b28371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ba2f6ff7dc686bc3bc7f93e738e303a167299297f16ff1bdf054e70a95f3cb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095586c23b05847678ad9655d5b5b89a093789e2b1585775cd95ece5824d5592(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef0980b550bfe9c9c733fe9c3073bde4e39b4616dca8d018b6f68606e205ef7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67a1c959c0b50d26b845794320ff76105e7eff2193c4269bb4a561acd69f3e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8b03db97506086d26b82635313b49aeb5d506fea86482a3a6c2e1aa65fbb45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1b4a26a2ddab6c3b4eb413e2fabd5c8d9cfe86eeffa4c590b1390d7dcbfb68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c6cf6a1928a61ff3b06abcf086527e8f4385bafb46c38b7853b2e4aab4093c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b991fd9a58005d2af6cea87217bd75cefa82a3069b5a861feb0f28c7dafc1f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f061f55b7f6fb04780aa866f94c9724a67a382481844686da156878a9e699755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14761a8300a11627007fd54904a9a836db5c3432283eadd95905506790bd4914(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ade5351787107421078c87e8fcc271111afa6f844d9a319456c8edb748dab0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a136bd49b33b06fffe16576f89fffe9dfbad5eb03dd3100d99a1a0214301f58d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cddfdc4b9a0290230818ff1518ea0585db09a69b06ca1cec5838540657356db(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b79a8ef1f2a740627a73bc58fd5ef3ab29cad6075c3e25f03ccfc2ca8a277ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e703d15f4a653546df42683e14c0a2401961db6fa4179de625e5b14abd4744b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683d788dff32fe85e9d2e4b6fef9b9f2132255cfd9698249921078f6ade2dcad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6edb2ee506e14d07e6e285eb8663a58262f7b2f33cf797577d53f29f6f594095(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8491e02933405601b3de566bb47f2a5dc549a38f6f93f49a272974464547fd59(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f7e312c77b0bb3dc57bcb56e9b9f431d6a6f1dcca61d626fb0b26ed933d9db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0219a7182d87b8d8311a49db68a7c04a022b4bf0f1dfd7f2ce90e0b41d69bdd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eba7fd320e31bdf78815258ebb0c4ad3b44e7d780ff6e3c69f3385bc511be8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5f30e2c10a6f212fdab170d629bfb8e00bb5c52696f1727186fa41f38a7caa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21917c1eb4726dcf16c32d586e9bc241974373dba264430c66cc9ef72de3e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ba19299f8cf4a1607bb219708a3cbdb16ada3f30899371e04da355a790bd1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192502ef776c5501d1cf5355d4708222d526d42f1f7eba110b339745899a37f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49554166a0abf4be10766d29c83850941d2c3ee0c7082b66b2a2183ef9412acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7ac0ff98512001a8179d72385f3575d62b4ef360a31bc0eec3c8282bd24905(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380fec27c27f47fdac4487ec16156ff5517cefda1963eccae5146ca10507ff97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ffbc1af9d5482aeca28206e42f5fdc46323b0b649751e12470dbff20f14e0c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f374717010db1e16a46683c799a48f80bf10b84fa07602c8c4a3ccccfe969160(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fa0fec7173486968c5e9bbfec81b627e747de62cae618b6bd54cccd44cb7b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12fb3bb2944322e5b73bf4b7b52ea68574e630c97485a94587fd3a22d4bd8f33(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56379672857bca164754211e8e3ca54be974098fa0e49b1a97c2bfe9fec512b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d5d367ceff7a80ba2407ff92f0311c5cdc1049c04c531bb916a7b399796a5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72de26956d52236f33014b8618ecef80cdd05711f061dd46bc98e1c0131b4947(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e73261acff7898994d639fab118e667d899912ec9ee11adaba648740371656(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85641a5ad650bef375dc05874f51b969cfa039bb219b3d92b5a99aa942c20658(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62480f2a273905cdc58157e19ff62acecb01229c26a78cd9f113d6c798d45bda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897b1c95fddc8946ce8bb958a7bff203c04ae5b0fa4025e1e6ede13045abc7b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7f78b1cd070bf8b94917e8092819772c82d8a7ef863f899180283e09fd51a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce48b74d04fc747abc0307743bea66877182e1f5410a91c7e83dbd440a97427(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589a641e0fcbcb8e12924a4f5bb086c4111bbc04198ffbf9902bb826e66c3c06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446c7f348f99f25e4d0231f0d56d1356bbd36693bffec17b81209b3ec182179f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99a522b3ae915d6e37be075c681c3f618d67e3104956414474ddc86b63effcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c4cc4a959bde1245db96f49c24b27cd34b36096d2a42a9d8b39466694da1bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1b465bce59ac823e3202656da31f7f5e04a91f92f8bc3b0799d00ed8d6bb16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412adef70f494eadaffaa34fda6d2df60b86544d899bf913fb5a630a3660ed71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca1ecf7e3d52b10cad22b19c6327aeecf3e62403fbc38943c8c16ebe0491b7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c052f5f38bbdcc8549954f5a05dc057bb2ad0be73c160341f7aced97b9dbebfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8315b074d2b8f755bcc173bc43a53bcec16c6871ec235ebfe2c9df6ff1f188dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d7507a42e3eda315e46f5c8b7bf097564009ea13529f8f769e9dfdebb0549b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb57ccf3ae91413a308a5efc8a39f48a7c6c981af9cd69412fc45ea5299b6d28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaff2ad1b58ce373617f984340e91444a2c8f5b704b884391b4beb1b088db6d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67363992f9cb8b388d1dd40aae09e404d71b0cfff6d5e4702f71f1e4ffcf404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de18d57fecd39c0e3acff62131143b782570b2cac911251c7e72dfde395114d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f5b4085d10d6e19fe43fbbcab1d356f5af032bf5ba37b0205cc750ace3cb66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdfc9cee815d58a37e7b1207535b1d4282fad69c90e95fdd0ec53a28520a72f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844d5903aaa85850f978bec64b0fef8af8ee4d1fb22c974295f2f961e98b7811(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e9b9348d1433ebe08b8afb1c8596ba99e0aed5cdcbd4cfef9343f6db9b2ac2(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e891b401a5255c036ac2a51fb99ef0d956d175c938b646ad9ff2f5a6aeee6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6684038c67cf361bbf14439f503d66653b97e9e1a412edd132796666c708c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0973e35a8879c5d5cd7d22f92513161fe95d12213c23e28e185abbf17c1015f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416cc8a966ec0c0694ca4a118a8f2b3aae0da047283ee85cad82d52e90c61b0c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564a11a9fb139fa6b6ce6627c7979416852e583ff8f4d4ef581fbdd8c7611eac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860e93e2423971c2912a7697e875675664c39b2f30ede99606d731a9bfbdb3d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e5e1d09b132dc4b142dd10278ac0eefc4308f1e49aefdce9dabd1825288a0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666966c8a063e82468144ce849725855f27b1fc4d4b16a85f087786adcbf47c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84610994dcb47506ec9a8e32c135065c896fb7a95a70d94f4312251fdd726aec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34dbfe45e049ff8b940542dc222c6a5087a0c8cecc208b131a7de549ba5bad35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50bb9942282dd7f6ce17b67c8f6d2922ca0d247296bfe304b3c46942299aec21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea40f376b8e157ae9b06270e7d75f29cabafabdfc11ffad41e06780ab2ef033(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1daf303e27a7afb97c6d2cd5d8f9464abc5228da0c63ecf2506b040977b186b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74727195774c311c8f70e57a07d79174b511c214c3abb116731d238af9417c0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f976fe50ff2cea350205cc8b151614536e72c73667be823a86cbf34588a48b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf722e5b4b70df938a5ef12a1150927851740cdda227a2c4ac1d607ceb1af2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2c06cdde2a8239de3f2ad5c2361c43b0e5dac0d06b5d63d1e6c93d4842d757(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bee6f3fa42eccd1f14a0d0a5c9f96ab8714cf41d064793a146b5258fc716dc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0c95950363b7e1358bbe4d675d2cddaa02ee4d79d9b17ab91b3c32484606ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688bd47011a8b6c24f7f1387663b277e822ae40954b3912de960fa454a3b4919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a6cb64616f8ce6903e76709b07c119c3992118cad142fb5b2d6ad4e2065c5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e71d1cb2a90b3ba6f61dc1a92a81a39db5a32c529a0dcae1a83d8a98fc8bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca32b87d5cf6c3406515872ac946fc2cfae83654fabd3ecbcc1dcc3069b2486c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c6fe1d6a5110a869298bb2472095076ef70cf751ab5657d46769df1e2d7697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007daf5b9c4088f00d3360c1e9b5d091783a38b1a9f6f473f1669ffdc071db25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ea7044a9d68e5ee130c7b0934e13580363de46ac686258284cc69a55eb8fc7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d96d0e4b106ee3e54d6f13c336eeac8351c3e41ea2e4874144ff6a38869805a(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d81e7fd553fbe42d10d6d44db96b1fe6330c0f5702a9189dbaba086b7cbeb8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23dfab02b9ef0da35cd551afbfe9c60e7012d617fe8f8a88e8f16342f67015ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d54f76071f15b251ebc630f124564251fb75bf2706f7aa232d5ef7556bf0a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c799f506993254be6952e9b4e6ce135bfc2a2daaef90846167eaa4ea470b7d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56736581016e09021e2655c090568d11fbc9b5d8440e3ec7aceae879392f3c23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb5178944eff3d72d824632c6ed7e44227d7a42b93422fc6b8f7b11fb283609(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f55f02a69af2fd6e7c95afa7fdd56a555cefb9df6d4c936b003af6167be6ff4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f923772eb735bd6f4caca3a3781f540a98334872de0ee4392702d604dec6ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a918ace7ffc3aa1a1425cd0121dd89c605a312ddaef062436f702e65c7511cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5339db441a23a974de17021327c7efc4d53f4673cc942533641a94dbc4fcbfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e098551bf86fd930993192f7b3dfc0f0c8c3b6e2ca87bea11f1f979030502ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1209869d8246e7ed1f7f1c70903f1e5438decc3aed34be667175d7254b24877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacf8f00ec2dc3fb74307e4d3ce6359a1d135dd0a2ac5f67e0f54421cdf33c81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5319a1b03d74ea46918d237a89d1c421127fc062da9aaa5d9657aabe498880b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1ee5446324dce8d69bc22620abb233885655bdf2a69aad4d716a46e3c714a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147c599d1b6d8f1cc22489497f99f1ba4b20190e7c5e891ea25ea5de94d38283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5cf91bf8cda82d844f0b671f0e26f5e1ac0b950ce243c6f0d263a60b8a4bfa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df3dd0aad17402198287546a771d7baadd4e70d1762314e5f8229233a99b54f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dad1fffe85ae37b4b17f6a75a22fe6aef40c3e1c1bcfeb4bf712872ea9d7874(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210117cc3569de7cc7ec4897781953db7de5e2a6caa7ef94543da48da5d8c84e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d963e894b5541f2f68132af58dfb2e5a7705088c49e20c0a8fd3fc99eeb924(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c9cfd418db6f5ec93307db9210509c189c34311cc234cc77a35398c32cdabe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26327a389ca585d4c8d4953ec79f985aba9cbf38426fedfea9d7fd5146f5de62(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2adad84d2fb48ce1072fdce5214a80720b9f75bf179476d85e63524e423bf2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff537e42c22cd1e0f7e07470f7e0db0dbf2bfe0159e95712e28507e4fe90b36(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99cb152fd5c07c77ca2110275401b71260d209818c5efe62e9aad33d2e22271(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159f349038eee89e6adf9d6dedfd79d6bb00e5a6e9f40f889962bf5ac6aaebd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e278bd36e257880a21117bee9a0fa3635954e82a2ddbfddf1f07d808e8fcd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69cfbd591c715d12f8f3aaafc97ddf5f7f1d9f4754bb9e9c697d38327307308(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65f56658e22eef9b632730fc075d0ef0a688cb1ea49994607bb34f7b1eb3d12(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c545b9015eb09ebacce713b2574c48bd10b2c25a42714a2f8ad153cf160639(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8bf8775873e48d81770a44ddb959913a3d2206b893a9b07d71390633776cb4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb748484962a450244b03c2a7ac093b579cafbd98445be7158b9adff1c85612b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3f5dd2799281f626551f6c8dccfa9cb5c1bb23c5548f8f3cff09dca6a70351(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2037ce57f1bfa9418f90db03bffa3f2a08e5a4eda76e6094cada71a56e56fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f62fee977b30e09d6a358e5f56e253d25f32b3c61c4ee83a7c88cae294cc753(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad14b67475122a6a12d78f1dd59630def7bae6fea53b7068ccac98cbf272569(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28998d6c58b108d2f4d2802c86889652a85a440a46755f7a004c6918498ebfc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08fed26625ba83ccb896065a2919d1296a0aba81b03ee3a02d3bc504de7be5bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163a8ec1d8df63fc0ee5778b902f0557fa34ba18e171f0cadea7e8022483ce4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3feaa6b0d709fa4c8d13d7d1733b2dbf69eee720e83980acac17cdee56f462a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45cc42c2fafffd209ada305028357ca6c819bd82a851cff00b57224ea9866f8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3911574df0c66ff1d3970282a03d71a296e0d757991d9b19f725e2c09e398898(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b00a210754bf9f4699aeb693cbda294ff694dc19b81581e4c317d828724e80e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9341e9b15cb0dd0d950f05a830bb1ef51a64c0f0bbe1e26ac99f3b2aa98bf06d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dccf4519dbb1da3b37da04b182bd5eff1fadbe84ef13d5d41428175fddb98fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30846600ae1a58f714f52e76d2519bd9ecc38c3cc101714ec7f3905c4354a56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3730f1ef287bea56d836dbf57a78208429d4049c89f224a2c97df3edafa4167e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07acb034120544a7f95f98ec2dc8f10b08d2ef24aa2947c56ab4599bdf22a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1282e47a32132516d6798c58183283ed70cb6a93f46e4e463ccbdb10fd4474b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838e35b86599508646c3bf675888a623d67e0ba3194949f8a326f5467306f0a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e8fbda80a8e8b7212c4a24255504636f058bc3b65687003c8ccd6f7575f57d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b19b32292099116af704abe538faaf33b6564daf12d8c1e32c772a4241676f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7508a4fdbde40aaa0163ae9d5c398f351da870e146b5fd8d67d6e33f8bac2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c46512cc116152788ef2d1bbdf173055c168a78627d224c755cab49c91f1a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e0e0f806d5ca9de0cfb7a678f66e973e903e93b0552601bf1fd6b7cc2feb04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1e823ee8564d4a946b17dba62ed3efe9bb4f4e3a99a9466fc541e7c0b4ec72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf4030ddd09ca19a4ef22f887c9320a9a38e1f71b5a5fa90edb8d69e44da99f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08bddc518a7a405035b0ec0604a3e7dff26bcb2656fad3418a952884d5add66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12932435cd0467e4694f1e961bcd5d8aacbbb4ca2d129ae0e5025d773041395a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b66daef30aa5548bee47e1f4244f9ea9f24dd2722e55ae15cca90d5fb46e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0817cd1f8b28dd8f8308ffa3a9b2b4d78cb1739d634ac413736a9d43a1513fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338b37d5c88b5a4cb5b4671a9f5dd314377480be289aedaa175ffbd0d2653c07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a1b0b34fe9aa2440b2a69f958e615151b964ce4ff8e2f39bb9f95850a432a9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd32fdfc84633eb7658077b51c8c0cdda827ecf598bb8572da748adb178ad5f7(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6f285de431735dcdfe50c7ceac54d9646d0679bee7e93c78eee25ad930b728(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9dfa77bc094017391528bd0a53d83791de442970a63bdc3da63a6291ea2c20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f68241993096e11f7e9d6eeab439265040c4c3f1b734710ec49ac59618be8f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19939e9eab911d6fe0df30e330ca456581a746685160ae73f493ac0a1a17b7eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88e8e086a5720a8d7ce26a6968c7d4e7467f3618dab863057bc561e85cb058e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fc52c4333625281419503208b20caef9ae6a88027450337278a1ec2b66f016(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb297e097b1d8a902330e668195085f82afc2eac53fbbc51c4e5dab71972674(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ed50d2b2756fecbe52290c708438ee2afb9d8c4f17a96b1a7f01b30edbc808(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a807d8b75c1a957e995c9dc79bffa29b67f9a2e35f4ead570d79182c1b9d22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9639490c521fdce5e0544a39909cb0f1c854f99c1bbe7163c0421e882937caa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4168bd9f21387f9994a34f102fdf7cce233293d3ad7a51f6ec0e81bbda06c9d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab6f30315ad1b97398b1edfb1ce37e0d201aa7073e0b28dd5ca3183c23fb9ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d685eb8b402275597d7ff5a511abd3f179b7dfe2df90dd8e0e424fe67735805c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5ef58e098d97abc11aa1868ff1ee20506a513cad5bdbdf4bf3c256e5856ac9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6490df8ce887e6d8f05c50e838f809fe30ca40fdfdff95b6b000abbddedca3ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac2fc59853b8e9569229538eb2bda1a543b7f709459daf43773a487241440c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb026abbb9466f89446f5669ee79d35dec6486bf9178ac90eeb3641d30d2ca5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b9ffaefcd5e0cb820a5d1175fa9c35c072212d1a0fc6c0b958169ddb95c548(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2c821ff5b70c580daab50a8408491df998057dd57d9e26fd7a754611afe6f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192a92873ae97e54a62dbec078b2546d85cc416ccfb02ac5b93033e000db23d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e17ca084ba4b8fccfc03bac8fc55bf0d3f58614c074b09aa3926dd25f3ee9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd62cee7f4edba391d20969d30f38a8b8ccbd143754abf8ab8590621bbde4a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ca69feb9ce1c31eaa069a3c3d88e21d9f658f0f2796108a69af0a9573f7458(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea440b1d35bfd484824cbfbbd2e1f128a6c63242e05b5e618d35856e99434dbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ec40324de8cb09fd8529568f9eba60a97c35814068d8a6b44e50df322c9da84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb05aac6a1225270374a1d5a4620b25d989e6a0a17abe33559b4c979866a5ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374b3a76e5e5f3c2c976bc8462974ddb2cc21a6eb366b5b6adb55d10adc8bd2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__172642304ef19104ad9a12c02fcd255e3932dbcec666bec658311ae47c53a8a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26f6eca577cc9bf1a07c4ccd4d1b513e247f87b861f26d08131c54f0a6a7e9e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6dfa9eb40a3002c0b8acd4f7cfc4c801dd05116d02f3f88cb783f170902b35e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a24ac70aa315aec7f8fc587bb7924bf390a41044cd6e171686687e0015b2c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c497249c6de4b483d9ebcdd3566dd177bc04f06fc9fc014671668fadb67a4aa5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8fb9b87f3bca68ec99ff0ab2fc8b43a2f0b6125c173986b57d825d1374a0722(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a68bd7e26edd6da4c6b21a7008be075d3ade0a8ee7ecc2c4bc424e077b31a1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2808be132094089b2128dfd7d8a702475e4cdec9661680226cdb9da23285ca9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d504a27623b166313a06ba81421ee65da67a09f77eb6ddafb8f7e259d3c82fe0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d1a0dcfeece0fadbd2bae7445db310daf4434159510a100f29782f74163607(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96c0410581abaa7c2548efd991543d9479efc6e58bc70ea384b02cfb7b146620(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67777b14e9b95803b3de3d493d40ef67756b634127b541f1eb1d552a10617da7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f3eab9bb27b54ecf497439734cfc4a4fb3e60a777d3643563b22b7f6ee7440(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be8639728c600db64bc87c64f163d98bdc1539c1e3c2724421235e09de40a6a(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eefbfbc3e1b2f79f915d3fba669ff7e9fa0b1adcc3405a3ed6a3dc60d5c80df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60fa8a5281f5b00ad8d4c11d17716490fb13259ede0846c40123264b9ca34b91(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c03033401ff2accc97ca5e7ccf8d46b8a7f4fe0dafb86846f10e7e651467b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb218a695e3fcb4245a07371b4941f533f476ed7d6f7a40b5e452316555d7fce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535179eed05d12a31d8da92996809f73ce384f7476a3e163e4d507daef122e5b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f441e03fabdb404e3407593a6fe587e587f22352d507ae72f75946ade8eb4ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c7e3b9dbcce47fb76e808bd31735dd0b70fc606d989bfecd4dc3695efea2129(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7be84dccfe3427c59e63684bedce28a83a9eb36e37e27a6e0e035ee6f703a38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c2860aa15ab21658d6c3055c271ad216e81c3a7e97742d3b8f545d0922e690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04e6281a927bb11bec94d733fa43f042060ef2ccd0183e7acdd92d1092d93d6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2736bf47d447037577763f94bb14461eb463264ea96e63c957f1a4026c102211(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff51f96d404b350156273a4260ab76d5adaf0a062ff17e3064f568104c55bbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7e3ec68ba38497fa7bf2ac1d1f8c2aa89c5a8e88c2b2fa9addb2d3e73906ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99a9a6cf54b6f6d4eeca223e93d2724a8b8a8709a341f45ea92c68682afe3c90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2794b920e92da09de3c89596dbc3e7cfb78bed9beec71c8497d25a45ec45749a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6510fdcc3c9b25d3588e078f568218c38602e57211ee0ed91be65c820ef168f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3004238d87f0dfd7f6f3bb05efe23c1a837985df9573508b87424fefe9d857a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4998479b8259846582e051de991553443abfa9f9243cf5b365bb0559e41199ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__947ad83174284bef5065b1db5643e83b4a0dafea34a24ea1b4d1eb0da0297c78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e39b712e25177696479f1ea6d32a7476c626229d66b5d3de367ce0b2fd735e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9635414ebff9e37d4c28d181080dd0f35bc64be39ed2154d01846ac522a585c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8716181127046e9c56f83958120dd1ff0296e78c41737f9abb1cbef34903430(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c151525b6ca632af1832f46244128fb17656594938551010eb96acfb48e43b4(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5f6f09104c5f1ff4518a3a8ac78ffebaadd8da71e2f1106d8d8c43384f3d7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d664bb7a72adaac5cd7216313c378c0493d5a4f346365f82fdd06bb83d779944(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c327f6c8c817fdad7cfb14c45c17f550e54f5348b3ea3b173863d767c2194d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b7bf6667909cee4bab3162f231a77fc3b910d410dcd8b48ce7f80233079904(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e1eb69bdbe3eca265a9ed76e5047b45c877ef459d37f4acac926c5effc57ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f404246cb79b42463aa390e8a344e57d7eb8674b3d94e4e3fa52b1cf6015f9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e9af4a3cf315084ad683767e1d289f3ceb8c3aceefb615d4cf82e4c5834cfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71dfff733c457c43ae4b802ebf46708af744271ccf9eeb3c1e3bd32f43504a7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a39ec7bb18caedcd6f89b71eebad9f0286055c1c72aef6f44b6e36e042dc63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d5b3df693ef999e68832b574360ef8fd7baa3900f02921fc81e418f1560a96(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49da2f6d64c87d5a5835caddf554c7be49adede7b436e788196a7ad500f41e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e2f4267366898bbdb44dd43ffee8a0075e0513cb471ba9170a33f0cfbd14f5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a82665c284c8ad8c9792a73f0f73984d337a6fceb2ee1f7285e5051871881d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b2f2f525a8fc06f81431b6c1d092fcdc30d735ae6833439b7ee1c0367e6589(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c31d87e6d616f44d31577ed1454477aca753c8fd593a4a693bb98f343fd316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dddb10f52ce88271b4288a6d13d5b26fbfad2e56510849f09a1cb6da2317d41(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9440501419515dc4123508b1f681a488d5e5ebdf8811a9d6273bc35b9f97ec26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b67f6d8d8a2280369c1df5375d31328cc3f15b0a1438aff97d0575b9a716061(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f968981ec2043d67b8205560d1ca8d6fb04d3148ac0c9bb6cfc52091ddd8607(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c8b8326c98cde831f8b0e0cf3c4fa85e5f2fc1a9e8b15593c092b7d1bbcadc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be59012a395bfb0dda582d5af639f088e1dfe6a9da13ea15083f28b58f8007a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc23800ab86d761234bf92ad6b31ad494c42bd964544d4bd5fd64099a035666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26430126d782e30b9f42acc104272b54832951d19ffdd632a5635860cf17588d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad9494f49b06c7cff555f7d7903d4ed72dcf337cd3df42943076b946cb35d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a09e4308a33964bd944fdf56163f7cf811d9cb3570f09b504231638540b8ed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764382aab036275605ea78fa875f33174dea08a02df53d144b858f569e9f5196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea9045c5e69d64782fd281d20150ff7019992ce1520d875e3af10165904ff183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd78245f5cf9b65b4f532d7b9467a7feaafc66b62852ff61eb18ce067f524628(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7a1214e0833a679e5b1551f6208fe54c34cd0a8884488e229f94b31c5147cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ee0a13cd59b39bc5a35aa05c6c5c5191742cb9842a83b456c289d64df3744e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff39d7fb446b715d3d56eb6e030981c136f0cf6a61198ab0dc838fa02a65de55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87c88b4aa1c82003165df494dc38f8b10a85236009df0f8e5b295b0377e5f63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9d735a313604c3a1ab1e3ac3f74d98b3817ef940bec0032c8282655a4dc6e5(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef6f8209a86877e4017e3a11fed2f61484c982486ba0bb6ee28ffd2e11ba893(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63aab50861780ec862c5fe2e37c184d2241929bfee79475fead10f7770749f90(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783fc3e9dd4299c47b25689004f9268acfcca5ceaae60a0d46b64b969e45d0fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7dd770f9b42cf141fad4acc3597d6ca471ee4a62ebad73e7d0e2dd9cd9c6f8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b36ae45f498c6e05e0aecb66839b3be5308a5243c87d68b90d48dc02996bd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745659030fbb0343bcb421292f3206e404d6a8d909591af214d244401673e0dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43a7724e30d62492f07dee7fefdad52f30d9d4773bec931238b3108bd7c5ad6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f8c146f033b1d0ff87ea1a2ce07e3a9126de70587e66339dace847469c36a6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8805fa104116980d3e84dc5290746ede6bca43cb2364726eb5509d0613fa167f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae78180fe1a50d99572bb4dabedd37ec83909eeea25a3e1937194862364e90f(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325cffc9d8c678e099e19095397f6b7a8cc66c307673b30bd6fd542e59020971(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719e6cb44cc6afd71d6c6ef7b53d61437390c6aca56904ade2c00b381814c6b9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aecb5bfa97b729a512a3a355c57911825859b37fc693376b110f50b0663cc8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0844ec89f78fa03dc431fee52310f3dc783041e1d1c321ecce50d4cc8ab1380e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228c39f436c38cf87c24c767d7b5bc772e69f101a5f804d548bdd9c91807ae8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b3bb23d33187e2321d8ac7f635eed6ecb93c07751d858ffe80e433fb1a1be4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8a684776b72e86fa1f538fdbb65ea85d7cacf56ff368c9cddc922dafecc9f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39e3c880d5d74bf1821d56f0159a8c67d08226dfc7b4cff6c0b444936c8c11f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a3596191b846bafbc59b9cb685a932d83ae62ea2bdd01302be1374e9747601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5206379a9ef78fc1c92035367452f517d8ca1e65143fcc50ceb95e3f11a4adaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2cebeac4c29dbe85735fc952cac81a7b07ca0aeb446fcd1333ec63ede87560(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e85365536109d4547c5637a55b28d9d3c22b988ac8df1d5442495857b4aa7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c52c08670fe3e871bdd512d1a0573c8a694d50572111b5c49f534c597a3f40(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a2bc24c0893a72a9562b7e869e6e7aa34ef067283680971a2e9c0024abb660(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23fbdbd07cc94b3d045148ca21e2848831cd8d0e4080733da50c2b2fa82f4e65(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f728db00303f0a48760077e9db411351062538b32c2147c36d761a830a47fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cabb9b984eda3e01d9f03cfb3cd6bbb5d1b09cb8155a09a9d1159703877b02e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0543b278179dd1794dabcccf5ea23927f054b96e3e962216ee52833ceca7d34c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3ef4b1a8f1cbd56a7cc3144f8bc8559eb9b068fb3017ff34e5d387318c6f9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270fc7de9f26f3cf537a1a00ed7d00a683a3012d597df9195593fd9916be0900(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea57cb851b255fef9da77815cf2b1727fabdd9fca2348f0c501ad6c6f8ab651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2390c2daa1fc1306bc829d857172869ff8b951f33af24a6544f98595e2a20b24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39aec45753b17505b949f0d8b43a4b6a1297fcb3a551b3f80201d02933c04dd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfccf68094a2ce9c9fda00c65ec1c8a48832eba025240fb134ef63a663244064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c601bafdbb1c66719e7d715ad1b1f30492fff91a6f7c7dd3f8b8bb16940891e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e2f5705be338036e007f95da57a006a2050010eae6597cebc186c997e8c4f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c29e44adc838f007cd619a6a3e2b18984d81715a28a526f694c1b669d8b3dc67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1434ab546c3864b92a144de0aa8ce9112b9ca9d063627cae12b24c82b0dcde43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469f68cc7bda9b5bd5753bf1b74e8da60c3d7e1cc08dfd605290d1945b641fe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cf965fba9e684650118fa90621c1b5538fa34106b12c585e920455f4b67175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b8899ef80bf3669f92464f66988ae854e1520eeb7b3663171acca2ad6935da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afaa5a9f58cce97a58cd61b3ce556c5cda284f06b1a9a8705f9f9f931278ec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d74660b83806006c5ff7e8f41cd768de998b7e5cc134ebec63e7cb6e4495cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060a0a8e3c8fe9e43d74bcce495c743d32a6cc03cac33b708a8dbf1dc902648e(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de451c71a04f9a7eb19152fb05aad447f3a05e9ec1b5852f34c6cc4bb953b3f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81531d8c3ad4083bafbfdf53193ceb627ccaaf9c2334c2e8bee445ee859dd44e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418ecbf99fa86e91faa304fa32f13b5a1f43d2511f973e8ddd4fd419049c09c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c88eb0a7135bfab18ed514b02319bd1911cc3e8687be12c800816770b373f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd714a2b2f9d8f0b7f010d38ca474ea9457683c09a497dd9e84624872b59aa4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a68c4a8c1415e22b0d5b89b316bba4eb56f32dfa4d281330dd96e1cbd52c06a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199b9e1a7b8e0d86727a8802f2ea6761111a54fb674d746135550b0dd0840955(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c60245c088ea265d02feb34e4fedd1b346a2a1f37b7d52ade57eaa4d4bd6ad3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b1d0a9d0717497a6d87b5a548a27f668a9f0e0ba69ad563a4fb5d5905261c06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454bb4ebb1086a332959fcc4a8e6083b18a4ca70b4b6c141927a85bb68876ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1717921f25f3295d6b7037f50305c4c9624c0b496bc958b29809b688a425d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ecd637bab1ac592b7376f6b52b3bde458d7870b492bc822a0e1e9c464e6a773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e94f6631c4be7c5348b4a1a2430f7c4cdf4af45ff8f4b4e4d34bffed3a348cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa07fdaf9b5b746796c5f2bedb4463f34a0969c3814fac001608c510c77e07bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51040f36f4af5e7a8c30dcd965fa7ae6ee8213a6b4d6da8da936b40c4e0277b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0dfbfd03ce68f71d73af83e277035cbdb4d1fe2776d5459948aea42b078189f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda9c1ae86f773a37b9d0707ae64d37f0a4b99e5c5246c6ff2de665654c0b718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac20f7b81517e930252f9e78d5a63d8909b454fafe57dba639d7f95fbb7f2de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e5f3720876edb41baa1d750ae1d989289bcb3d335532f9b6fee044f02d93bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcfbaf2102cf4ccdfebce2657d8ec62f8173a8fcb680f87a1e23f8e2ae38427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e5167cbab9891cc3f961590d48a03ba9b537f292bb1f46c1b880eb780388143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba388ed744ceeafc15c3b5711cde8ad8fe394fae1c7d9bc9a713312cf5c280ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49bef26ebfb8fb83e35c513672b48ffc5e12cbc06e7cfbd7d993cb6da199f77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841fe049bfa3969563ccf1832a5dc4ea1ba1cb391eb963b43d7a442c70e2a3f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62ecee9b827af911c5c494dfd0b8b8bfb177597d121997818a23a37e8361045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e856b575f85dcbaff12ad911826dcb2784b2cfa00722442b49c36b93fbae7df6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9853904d39a0bf032f22ed9ae3e28de19e53fc08bbf77f66b2d4fd8b660fa5d7(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bda6c407fbb236faa6d0b5e881fd76cace84f18dbe591bebd51924b97319506(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94dea2a5b9679dd8637f35d195feffac9f389ca4e3c57c7346311e062668dfec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006a7cd8ad36419860ef5b18c21fc6516f0e648df18e7680b74cb26fcd0c6ffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ccab063f15888d08e63f6d5be942d1b4568541807477ccab8063b808b7a940(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d383075b8b3bf96048409b451d1b43ad5c5bdb36d9599e926fc2b22ce8b7541(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97de55788241845ba9a39904442b73e63026748c0e439d1956e8eafb337aee0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ce00c3de81c38752e42788dea466baf371bcf7d7b05faedc535d2186ec8e57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1814b6e4812e701278dd3fb4efeecac6a826fd24483ed0dfc2fccae7b302a8ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2f0ea7f214eec908332162020b83798df5afab2cb39301a6622d5ef849642b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7fe7547056855d44038bd9ef3d1dd21cbcf3085d05635be97c96d56dd4f2e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abf450a3a1138b4843d45789336d3f15ffb7494aae06811f82d00fd1fd74fbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae993c5fef1b7da4188fdc368367b26f148eb2e962bc365d0fe2bd25b93a6be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d842a47a281fefc276e991def4d702c741e622a863643fe2d70872819730b063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50367d49a2f8ef525477a7382d91b894faeed6db61357e10900d1970985b00d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5982869827b01451d8e382b9f84024f8170aa2fb31a3c9f50e35aa921cd54ae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8f6c1f534a8989fb818cba04def531a32f70449040615fd8371259bef99a79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e4d04d6a4c697f094916da8ee552b6e13f73d554d3b9b83fdea5c59fe367e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e510cb8a1cc7aa6179cf676870b43b7bebfcc2aa1e0d6d81f0db0cf92cc6d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32b9b73e3cc5fdc99e43c1e3582132980e903d7f9e896bdf96f2c8eaeb217a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b262dc4129aacb951b1feba5b8a1a99e6440feee2e80d99df9ae296052d46c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d312c386a57f236da4cf02af8ff4f5a20ef38680ae7773c4d0d82f71418de7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92692ff353dd06561c1694282874ef2e790d198038aafde40356e82433cf90a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a70d4bafef6bff1a386158ff8cc46a5d5305d3c6c32c8a92ff1346b5bf8a9de7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e016386be4571151b4f43342a2270ead6df67bde3affb53faccafbc9dc88c31b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ad5b71171346eb875656d6895ce50c6b62111c960c9b186a226af2d44d0716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1014a1ebc53e387c4ce26dd3575d1775750eb9ffbd4df55b9f2f360cd236759b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d5e7211a0bd4fabc1de81181e16ba8c818d418a1c9767f2b440369b2ed8d28(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34dc2809f2ca63c9df9377f0ffc70c5539ff4c34423eea2865839b1234d698dd(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a089c5011abed56e674b26e3f2b79327992cdd2f35eb3b4daadb4eb983a295(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6d236871655d156589064b356228d7145799b6de5625c4070e37d50a70f320(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e69d294e2b8d3106b964ab771ec3edad918c7f3aa52df8568a57d5fe03c25ba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c49a657c83f88ab442f92ada2f3e12ab51eb897ddce1e6b5dc3c272b88d3ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3763319634098201a2ba5f915e77716cd3ac0c5c1d90b4ab4dedca85af791a8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f261daf1b8677b5efbb2623fee330907980dba0cc02cf7d12132611a16fefa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd694cd952758def08dfdfcf0b52e2722c5388f769dd1b177ddfad4b869f09d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a4b1041551b349cb60dc6c56769657a3bf9db466419d2592d1b67d11cdc5d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857acaa1cd26a6b144e7457baed2f4c07bef3dc7252f0f5c293f708b51f87d18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8bb548f80a44c317275f77745e7ef1ced81748880562a22cdca05b32ad1a9ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3843b60fec85698541857384a8274624e4b2a018c0dda5b717aab710e5f36332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3547160d7c5c765df11796471aa6da8840bde1cab36b977cffa2c3ec481e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6d965499568033d834eaaeec9c9c8eb2ad6d901b5b634c6b9ad8e9c2de2c75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8901c0c69f7e9537f3cb1e5eecc64b628fa79e81838d09a0b62c94b8e31182b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65944b16bfc8996f03a9620790e84a4a8c8f58fd1dc9d0174471b62fb188c199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08db53c8c58ad24fc664871850cffdd5b87af10809ba513944ee1e28b566672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bb102ee60d06f3339d5caa566f0bc24533824d8cc391043f3890de0c21509e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb173acbd4329a81c79a0eeaed7718fcb4ad7c7c4a0f9115312314be8ff54b7(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c3024a4872dc58ce23ae90f9a6ff651079ccbe5a9bffc0034b85400a5b27b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa38823926afd2cf09376e072dfa9574f5c7220725c427f51f5b00515875e4df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce940c7b9b3f87081e1f85a66a3fd8b0f2e5a1807e3f2e8eea0cc1a982f48f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6b17593e3f0f09824c1d93d1e56b9eb20fa8e5232f57aa92309c1d5b0a2a47(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238709c42c490cc31bcfdb569e5b3954b38ec71f064a2809683ad37e8296356d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e8b4ceeb001f7669c630a805e7955160b5bb60cd78be563a836e447066497c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891c83ec10f8df9d393599527787f59feb0e0d8d8f19fd8a9b0a6e277eb7cace(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbcac27bffbb2516eef595be6c309c3ff4a49da4a87b78ca22cd4e149820ee13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d33ceed5c15e1b82b7fa4d8c8432d5f24697140e18541107a169e8ca8ee474c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__366c9923027409f2db94beef4c011af2e9dc343072c70834d2f4313a6307b09e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251441abfdca13d7ce420911d7380c9dec704e2a8f70ba09e421ddc6f6fa1221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0c4d6456362bd04511f0762bead03ab890f1c5f338412308f4c9f1066e50b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547bc21b918b4166f0831bb9236917617261b5bec5d1cf0157b221a296f2befb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883d045a7d1678e4077d24f5cf2f2aae020ddffefb484d3bb6067c81133286ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937f0f41c2206743c81b259f7cdb0f0e07988b73fa17d25f680fdc30d6e81afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1600e260b4861f91adc8a4dbe99d93120a32a9f7748074755d61a54c058c88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ae084273685165a5866cbd697a226220ee8fc775c38fc9c553edd13d0b8b2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c114cae78f99b2c49cf6062aa319dab694179c7bd28dbd66e940da1b6439acd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d211376f2ebe760afabe4a6dd48021bb924b8db21627d2b8d78c491f6415d4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01eac3179fb775a73b7ff65b6754c3cbe6e101102b8ebf8327bcb8b7e86ba12e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc65f77b96fc73765b47902f61059f161fc8bd276de8f1fc40ca8b9a7aff5f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4d121e75fe1a092968637e64f94e348a5141bb16a7cf1244825852b2192830(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aba197cf4e649aecbdf6601e1950ceda3bfc852e44c4ac8734c796f6a569286(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d3a2d44dceeddf80b4279387314cef67dfdda33b61451d929c9478e30c064d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d049636121157e8262f551bbe69a118d7c8204fff56861a7019e745c9fd68a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba7adfeccf28c6f56add70db8445076681086822701ed9a046180f7249f99b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac7a3a4caa4eca06c64efaa4d0222d7541086e3f1d877340d36e67f23f9f2cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b46e9f29cae041f20bc927f7b9b66c36c2131aad52bb02dac07641e1df322f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06557c35724ef109f4600d99a4d496db3ddb84a616bd972254abd9afa9ca9472(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0f737fecea9ac4868cbfc2c501860dbb0248bcb2248f44113ad4b760bc699c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fccb5a59eac006347f03e9c7a350ccba10f1c47aa0c04935e6ee2d49b43ee867(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fc636e9651566974b16be20880ec7f4b44d7ea0ec0ca5920a9fdce8eb9c618(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef240a7abf207b51c59c18ad16b0f61ced0fb3c40afc0cbf412df77f0b2bdcbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a46b1382804e217e5b338508846a7f8d59853abcc9b384e8e927e67e6759150(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1bfc5bde489b3ca9ef76c7c1f1ade6820e41a3b7cb199fa4152b1056083cdf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73be0566682ef5bede11b4e8a0c3b3f5f1723e4db99cce659c4ac6b09669060f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f383d5817a629b6011290869c4416c0e88613ebc4407aa64d409abce05e41d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81bf70912d703f024fc0a2988c6a534ac72eaa9600d20ca0ef94e7032d87a779(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02744c89b3faa46b0aa1f8291c66bf03e4574e5c25e36e3af42422d37bea2b0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123a5556f212df07ae89d134ee8fe79f8cc409a363e971c517b4d0abbe43c35c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617bc4824033f2e648d7947cc0fa1b92695b157c19492197a8514185891f5c74(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246ed7b5052e2b7138f3b9a96a66d3e746d16065f7cef7fd211e6a59c34a8cc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85041e4d8e574db17c4c05ad7bc550cf970757d5432337b62701269374e20d3f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7574c383a6a462e21c855e2f1aad2d663cd99e34bff39764da21c7ba20d4936b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6024a2a899367a831482cd4e9c8054b2413621a3cfaa6ea1c545bfbb082c4652(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aef23b0140f145b3cc7d76362822a653a99f873fe13e17a6aa0363243babdf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa566b5061adeaa9c92c894ed0baa2c25efd901526a5946bf5a733da35bad47a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99398d35cb4be8ac227ca6a37e16c45971ac94b474a7ad3688f3471fa752828b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379987a4f8a8a5bd408895445ce22dbc000210cb9e017c47d2a273ca6d206429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db6f09572cd34e07729a6560ac5704cba9652e9dd37b147b3155e472d583d37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebac7416363193c810f829344df0e7f7924bb655b0116deb2dae934888f3c053(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31f11eec7ce378a9c4d25817c9b43cb4de15e183360e864f4b9d9f3e4f64be6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840688c057dc1e726dd9729d01556c871ca63358f4f16afda1956bd851be0c7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1511a6bde58cc42eaef59960dc3a3f48cac2184e381cf2bd609c35fcac3e23b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109acd179277696172825f8a2e833394115f6502cda51c7a47f7f626719c1993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f3e165246213a5706f75878e9661f518db82a064ee18fdbdf423b1edd539b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2092fb3eb27fb995d4533a72abd16f6e0c4035333b61aaf4785c175bd4b801a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68fd3ec007906c3a94240accf5f5b59962409d052513c2a0d62fed6facd8340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec0d74d8beda358e68b93a67d37b1b6537870b51268f59fae8aca32d408f3e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572d5ff5f4d6ff864d6b29266a1360488d6b8ef62989bd656117997e05d31da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7faba46582b8744319761244946604bff967048fab38fdeadedbc7d08dcebe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d76742fb1f960e0b37e20c8c8ef6d320ab49c078abf88747f43ab87b8a6fa7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff7132269643cfd2bd6e133c099374f9434cb3a3780390d4bdaabc5eec3ed32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa461d3569abb90a9cfb672a3a739a97be5505595ac08c7e4461326aa94ad50(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afdc220d3c03cd75511c96545117f185423d94249b0cda659d97ea1a17f3247(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d7b8bb0a1c4c775c2106ecdde9ed8ee4f1c2b1f2639b502b18a56d925cc1f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc4cb3236ef09ad09ed2ccf69841ed1bac0d1fa7cbe1cf91950778cf32ad657(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce46bed7bc2285bfe4c85317bb132a4d847254366309bef000473fa15972871(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f869e5655b16acc4a581ab995db80cd58056c2c5bc6e4d67cafea30e81e21744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47164493216b5b055e7d091ae12209e9264defeae335ffc399498a7ec08a3db5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc4b0469190072351989aaaeb32436829b4d96dbe9fc4a574ac4f3acbc64bbf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042b27f4ed26a93611ada4eed2ea3546550373fc1f100d848bb0f39ce1185903(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76c8d202bb8584c26df5672215f5080e36994687890131d65f109099dadaf94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c38564a7deefcff4deb76034e33d559d2bcadd06d5b545146f6fdb1cfa9b3f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f6c55e2a730c3779055a7af9cb01f8ff0b44071b2d983fbf603bfe80ce5396(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa2e711a0898b791bb8a9103d9b73fb60d734b3abe2ba7b6110a596b9429578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744df71c6b58cf87438dc79aefd603fd5fcdb5ae043453f8c5e4b9defe6ff12b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2beaa659582702bf9c979328f2737b4106547f996b707364205539acaf367d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ba687c38c7d6d17825f42a1795bda5f7801b1fc3ea42306810df88438ce288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2cc8a3ceadcae98970fa6f6ebf9e7747e0d5567e7a33c21b827994d6114eab8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001f9d094719532df6da1641f284d04ed3a072b5aa351d1b42b5a90b97da4dab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890788448b40b46832ac8a9dd97267bded65d415274ffebd803b4e1b0680c09c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda015a5de0f296dae455d3bc7abe4b950bcd0ce4d883174e47ef9428c6bf29f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67bf1bd6d6bc09c7a1660c4450b0e6506807f8d8ada6e5fffd1fba3052671b7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e260281d0a1c72ffea9949d54032db87df9fc091697e55bd15e90cd1c40124e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8b01b824f90bc937743d6e5a5ee15dad51e1c29c966d6f7db59bec542a5a4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f66272c8eee629b5c0563be4acbfe216b5d00ce39ce4583d79c26caf9c6e5f5(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e7ec6a372acbe96b86eb0c3da42b36d94dae4f118f3b8e5de8daa46a794423(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b529a1068913e7f9afd02a40732377fa11fd285c93af7977f00a92c8b35803(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1d8038a44e5c649fab5a0a76904aad25b833567f64cda8a88a4b00389bb0332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7ef9b246049318ff32eaab01595b767545b08db38ebac55d978623d3faa687(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4340c274e48f50369bb1522a01b779cdcc55654b113abeefbc4008fae03554f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8637799008ec6fca1dec2d598ee539c0a66ce9c9edac7d28d5f6e564b19afc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d0b89defe6d9d7da25022f04eed984a589a2a8ce6e82d921e15a3e8ec1d3d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e15f118f4692ffcf54ca3ff657c3fe35d8e2b1aca96985a602bd728fe0937d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d18aaf47db7d0bfd577f2cd2e1c92a7f7e30277aae5b2fbc5fc3843a75fef27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2079a454c28adba95d34bad8b49a58ff9b8104fe3632228f7d6e2169fcd12b2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732757e28245626e4c3f43e4539ff44b42ce278bc52671983384c53e9cea0ca2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ac1ae16213a21eccdf64153f31eb54d2cdb6cd19edf6500d1b55f17c76db70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb81add9f3f564ba9e1911d71354316296cc81561c493bff86464303f1730289(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc24614ca357ab6eb96f43db2a092c32bfc2be73893e5de217d77468a0634dad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1753c2078e7bb1f8359ce8561493ff674e45f4e3126ab42e309e0939dc1820e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d4d89cbe1876cf5d50a218527564d11f2032460655580c3a9e96c4478dfd1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a025311b96bd6cc5bf81cdc818a4c271cfd983d22c8622a3d919f45c6bb7102(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11373f93fd42c1894cc0acdbb24c6b28f36d9a4adc60de018391974e94e564d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c029fa8bfd29a4ce029c81590e7d799dd355e298e923789ef714281d65998f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110dca09cab33504088d8289ab9172e5fa40d555bf00802b15554b1f125737fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b13779a8035a362ca6f5f38d2cdaf33a9c48bf7743877c8d853f18c5679419d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5638b955e820ff7bc6ab27d5e03cacd7f56305a7d77c979c01c316b8be09163(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eee89236fb45721efd5090416da1b9d0cbaa0510e77ad77f13a71ac99fdbf87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdddbb01063297c93cafaddc3a5673259850717f6478f145404aaeedc2029513(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf2571cbfaee943141c8709a75c85ca3bdfde05d32e8eaf3ef5ba85722f900f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36675c1f75ab5bde509730cbfd9b06e4572c2f3e16e5a86f56a460f5a1d47d4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__767fbf2bad86a0d7678855e571ec251a713848ca728d195fcccc69a155f14078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f79f27a4336e8a4c1846c9a8b89d96dc5d5b84e9d82e8a2206d84f8f4113de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5421d0661472b6f354741e6d3ae359092646b6984ce4b37bd4d5a8e29b2911b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115696d086686b8fc2bcedbb1a74f79d77f7dc37ba98f5c225e7258f0a819bf0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380d5ede4e93b66d5138bd5305ba2351d14b06e81c9fc08d742d33e99ee35c2f(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ae6084cd813fc80db696b98951cfdcb7a95955fe19af5fda5bbb11f30bdefb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295bdc8a7391664dee7c7da765346c3df73755d6b729ef990ac6771c4500e945(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73825eacd84a83dfd2fbf81d98fcb560c07b668d271b9879782184273251bbcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7986114306200e3b96ef51f7a3f931c7577f9277108ca09772a9870c9edd08ba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48895edd78c62e7d492c830b5e368604cd6acbd2892778724b73e52d5488fa6d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f265c8eba3b65f5efe5a412466328bc37b14998345249d736d3e0aff27f6e8aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad4106b7e7451a0d0bd817ac1cca46252a14557443b2561f4fc9b209acb9ac8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4959934d6f1c1028c441a0bb202d79d0fba3905ca9c228efba977a32cce838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c795e5438b17692ecca7b384f7f7927b8bfee7f51d9b99a20ea8aaba8d4d7872(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042ac43ef5be6ba1e5a27a7f50923ad0f7104e537b3c868538df6324de1f2baa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71cd6e9d3782fb9250b2351004f9367e7512532ec0ed9ef17e620b0df1d6c7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9139089979529925fa20543c6bf0bb9fd92768c72f749c2b90f1448b80710f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4e199580c58d00704dad7e7fc1e348c880c8f7f00ed006a53e1ebdc08f18cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ffb6240c278a70fb8f5439c17fffcdcd04c6932b1292fc209b8a180effc94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea69570bb014e7e391aa78085babad0c9ebc7e473f4980d0877ee6f1dfa5b72c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ff5fefa940483dd38bd6bb79200044912402e3d5c9b546456f6ad008f1cca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08de0d6b68447322613bf18e3184374f16a171cf95f87f2e5996ba9a41340e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14c674122aeec080a52abf793d5b7b292ce092177bc6408cfa8013cd44dc16b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07dd737560936efbe91a289006948f5450ffd6914fa73292dc688d071f788817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1967e72047bbb58954bc41610934749eb663ad0a3619d8dcf486b33fc2efbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38dd494a9f4407fdfb83bcb366ad121435c410deacb13a8c7a5846eb3f34c952(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e696249311f491e968f1550280b9a1fa3c29df6c8d1a25ee15988459f630f661(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c39fe0e117730759ebcff7c82063c5caa8e28c4f8deef74cfec67af2c5890f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33164c1e53dc894663422129ff2bc0dd47f3f954040fd92dff226700be56add(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077d36cc4c49161a1a8b52e6f547d5d1cd197aecc695833a9b536b7af694f51c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b0276fbe7501e85016d8f986103109c1941e9cca2714430d7c48e13315030a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bde84a207de3fdee6ada9b48032cb18db1468786aac36c08d82ede0cdf269ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__651b4b961421e51ea251dc436130e5eb00ee19765710e2d4d33c6dd59d5fccda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77632071ae7f862cc8da60930f802eae376f2cc628e72a66a8ebad5ec7935713(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dce71111cd708a6c4aa3604fefd1292fd6d9f14dfb052d727d3b7d228f4c5b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__481b0f00707737ef17b55525e885a87676ce294d20cbc4ef12ae686e0de8110f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5d823788060b107342e951b2d1f9b86322f5fbca23c17ea2d9db5075430042(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0370e6f945fa703618c8a597d4868ba425f94f13d2030f1d1209bb30c57e1736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64cf559cdefb6cd697080628fb02358be3482c2f9604892e20120d188b3bb50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452655f6c0cb946f1376ff2a787f81a413deab5733dee4724f5d6e4cea97e84c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787cb85144caa49fcb1e4a6738e904e57afd9d1471f65518e7aa64293e79f66d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c916bd97ba0c788c03f8d84faa1bb3327744f378e1c5abf1a852c7886b1236(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59685f47f3041ed5b12bb7e2b8628b9c592167b8dbf8837349affce3cf893c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b200a4a00024d6f126ec53ce953a371f31d7c87ef06e1f822a91953bb1d44977(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e84644d3533cbabf2e7fb8a00910e5fc95fb21495ca9eb937917d965c21357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9e33007ba8c26d9f826748bf8ed52a4f67a73dbe03fbfef0b51d599419b8af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060295a933ca121340ff3e58644c806d77e13317cfa0230b557fbc2d852e49da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7a839d92f5e9fd3a682ab0510bd3a79b3b48710589a5e470f61d065ae50922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__266aa6bb0eea399e5ac92ec5625baaf0418d74355e5644b2c6ff7cc4dfd44342(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc936df4b6b4a22105b7b25bb04e7c115aeb30e7f87f7ef79d5bd438ba6ba480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d9900971c0a1b52581b24c1c71111807dfafeeda99250fade794ca299389e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3107c1b217ec0e09a7e56d40c239fee171870562f867d387e4841a0ffc0c652(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4460701d1d2a68021d1b87c2144caac5fef23249bbcfa63a80d842a0059de958(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80addd63acab5c86e8eca2068cda85e2f14d0bd3319bd002f954d439aae59bcf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed40c57d75b3bfe83ccb9709da37aa7d50848d264c92a8eb4e63d79175623efc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189981a596909c88f89731b6452f54ecd83404b3e972e2422c3ec31aacacbf7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79cdd21ced580496879a9e1e7420d1329929b9aa3f97f371b192da36198dfd64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ba74e64e0abdcac946f74fb8c37b7da6f9f3314fc0a27e703125a1686c0d19(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3709444ccca752e7a81c927e3b504087db0c2164a1e70da8c0590e4961212017(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff67f1af45fbccbc97b069a8b49606c5e6cd55e881340a24ac3d18225da4c3c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9072bc872ddd97987a4195543bf61f797d8f62dd4a5b5a2c4c1381115345f4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74746763ab285a235edde3fb39449b0ea9bdf7b1cf6952a2483ef18e54f55f9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7ef25156583e1e531a3d48f6c10381fefbbf9fea84415b3a2ae8833d9a5d54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__318b876b20e5e366c6b2d076cca1fcb6e7e42d0b3bb7f90d12533e39779a2dc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5777f3d1e1caf84b0d35d73ab394435af920ef634a696768b5638b548c14f455(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f434b333aaf493ebd8f65b0b1042849d79048ba459c209b72512d3a737f671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9822657bef5800f62e0ede779ad78b6daeb51212af3e767071c04381cc71a6ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b787142ecdc5ac638b4416312112aa42dfe4121baf19555f7c183a5dbecc75ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f880aa8e841c59721c5c69319767cb1695eb457a2b62b4351a65eeb75fef024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab70a4772a2d5ae6d04838389cbd0df476ca92d3dafa06000ecbec909697038b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e717c0b6956df031e9b99ca0ecb09aba81c2b538c9598594e8f1de083658fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c987d67f383bd8dd9b409f63449a56382354b085add7c050b876e953d8ecf14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbdd5de29c66fb136a9396e56ae599a8ec0aec07f774ea2500fdf6175578618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d30513bcc711aa79ca191fe0f686b746ea06cab1984cef313f5da1b884e607(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc196601bab38b31ed390245ccb9c6260dbaa94152952f716fe144a97121c426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb98f856be317f7320b510cb6b79c5e3143720d82dd12a5bedbcc18b42c6588f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3499f001a500a36b2d0f4860245ae311aea3f933e924733893d791e110c8d0c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9c554c9052d8aaa77777d6f5f47274855de1a130fa83fadd016fe86df21a29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe02650dec92c7633067682b996bcc9b2789c9a93f296bd50a8a0f3e035145e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7742aae8502c27b8017fa7ff7b3de84d6ee493f94d83f25a98b5849f8d5067c9(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cb6b4e16acb53b82ab8c865eed78aceb972bdd100ae6f1ab288e8c793cd9a9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e74f3d7a59baca13453fff9d593fea0fa39df8c0e439e1340938569f5c154d9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e88a737df8b2b6874f24fea4fdc43262fa8a5856e0c5a98c3fbeedb707f3e07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e75b16c8322208b1194207a718168ba74f2e5aae04e0fac0c10e79d4201fb85(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__074ebb8f30302c4374d4c686f1f60384295b2c81afe5e6e75a7bfd31b4bbed64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ddd0c1d9c8207ecc678e062ca6bcd093c8c82f5dc1d502ffd860b59cb3073e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ddd03aa42cedb4795371f732f57f809ee56233b70124d246b599352613d646(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__633193dc55f848c1cfae2680e1f9b8eb9e1632187c59c4bc07978dbb1f5c7653(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcffd964336cf5833a8b15ed0e75c30227cd195177941e109d8fc42f29643b2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68862c6e4c75be564b4cacb202ff3b99991448e8603b55435547aa78f798d19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872a34b3800c3e9d672cd1117427c0a013e4fb2cbe292dbaae7974ea1f26f78c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd3ae135841ab9cfc8c956dcc1b5644ad4c9fd56dd13dfec6051e6f7155ce68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c808d239b8d5959931aabd7ae45cc343bc3aa68271f67cfe6a4d5e474c408df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__943458cb7e134b38c7364b2ecb7b7954e75ac8db116fd80b9498a583daf12184(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e738ba37e53089353881a3e3aa42369a920717c6d28caf7654c05e6583922a8(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f605bb83cee8ae69389d1ae96cd5dd1fd3c82c09b5da6aa998cc77bb588df7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef51e4335198b2d1aa8f4dbd5680508db579c1eeefbe31d2fbd7f7a43a36bf2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8c7c19a7ba2a7b9e1d8f0ba97103bdc134ba40d897d5821109479bf93beec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c2bbaa6e5612d60bfb5d52b824dccf03ca4433796c81d18cbb1147941de443(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efab45ab1a367deaca8f3083b2ba7026a577d2e6a60d835aae0d4f7917b770c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7fb800aa353994513aec4c98c41ec251765a25169ebf7bf33cbc55d0f8b9316(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63bcc3c1146eb82db9ca9cf7378a6605e4e68a4b59fd40412de37fa4ed3d043d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49d6ea079fbe4132b82cedeb2b072f0d530feae68ee8b8e0aac7cb215786cf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80d3941750884003ad6f9f7a2da4aff8fa192ae9b3daa6c1022db9c69bebed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c06a5451ecd3eac4fa227f34c1c0ee911a11537621537ed1ac64f178d2f0aa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0109e9ff1b0344fa0bf8ba471876f2204fb5eea73bed95bfb25f91f28b5a49aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f044f3dad52d7c6757ab89efb526ce2e8203080fc17ee5981269112385ddca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1b46fdc3bc3592a7e267c1d01c9be1207de786ac8dde8040149a809bcda74af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4a4995e07baf83caead6a8fabfb749f2c52a8f31283975b007eb6dd0ba87f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f051360fcf1ede7783a7e6365c66b2c4ef525dbf5fa4971ee1ca6ace025114f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b528b3b68d85f057b0c9bd832ffed0b85e713f01267ea6f9cefea65f21e7964c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85bbb72d6d1ff155f6cea37fcde1bc4c4de14d25e34030ac98b00fc306dd70a(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0c473867994f7ada9acdd40a02332dea93a2b091e6e5bf7aee3fbefd74da3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13116f6968f893ae41e81de74f15a743e12622b3ade416965b54a3ecc4b3355c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ceca74bd98da59b80285c6cb04e211fe5fb55d4b9a74b077fcb18d85e32d56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66394e48eeadbb1e11ae67b31e048fee7979075b07e067646a691e3f1a4a9def(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9163aa16f7d200d3ef5cb79eef164b116136a5a53ca28f55363e7febbfbc70df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b1170464964713051909971026fea7d0173d77031496182512b09e055f24e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4a901a2a6c5e755fceb4bb5490ce6e400d8663dbffc6d4b46b1b3157673fa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319093f28e68b4a746f4471b7bf01507b9f7445b4483558534aba101e1d19988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844348523ce104d29e47f81ca71fdfa46fed7ac73d2e97177751e7ca7b309c2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5133b86145c6d147340dc1c4e57090d2349c80afd0c9ef7893ab744ee959eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca98c624bfc0617294c69acc61c09c97d4db49730bb4a41c15cd7e0709d4a6c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb654feebb203fa950a0f9b055fa20878c72f8af3f3237c061b44bf27026f80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f16224f10fdb3e87881b12d51fb5233a9029ca3e78f51dfcc393770ac157e769(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaecff9b4fad95bf48f91ebbfef1fb3e7eac9aa5c43171b41c8a04f521456f0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa6d7fbd55554fe73d682f70c49426366042defb104f3417e0ddf7cc55e4e69(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98a5193d0ee227cd0e506cce3f3d5703a78f0161c3da609855101becde1a69b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eba064a98443bf324383abb4a8459a2a5814ee43800c4ddde25b6e98aaee76e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf8c25e90c326402746919d02d014ff359d40c1177811cd707673b9e3f21d09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b33e023f5c8d4998eb9defa56bccd1253b73b8e3afa7aa1e3b98a4c73f604580(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e372907b631fed624a62df14bd00e01dbda8e9c9eab67ac945260cb3d7107b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98fedcef382a3966cd4cf6560c125681dbb31baa6f70e2b0fcf7e185b4c7b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebabefa0b26e8431bb410f572f4de92fafa1aa9fd2192c257a715e865b6336f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e8b703d10f188c5221650b350cdfa8ba19ea7efef313524cfdfc8ba14e5373(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435043bc3e563022cffdd3136a20ead5e70611e70e8f9f20cc8c2a9d77ad2a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5f0aef2403787a95681b121f1b7c9203412aedcb1f2431f0da209c93a0ee96(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f7974b80f202f24aa302eb500d0b87a6843d0794205419f8e1c021ef61c6b8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e70fddc41b8e45149d9749d2d382d38661b813bb13787b8fa16c57f0cd9180d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9f706c74a6eb67fefd77e7ff90d6f04a0e36d4a5a89e15cc6af0b62e5ee618(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae1e7490be3c83287e95d1d7c0f497265352392d0e63a3338a6a3c29edb4949(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d0eed7b8f816d4bdd98572a56fb38b4a2be0a54baf3062cabbc2aed61e7521(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7802e7f22168329bf3b99b8310961906de8cb1fce4a36b81c9b8062a6b6ec7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63d0959d455aca090ad54003e0e2516376b1a11a2dfac3c17bd7ad724e67114e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f9c8be0d041a66d4395a37e5016b22fefe2906ca3fb5d64ea3f9be209b978da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee6e07b3f435afd172d2d3f87c2f45d092fe91b9b0c782abb4f02f95301e047(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da309f3ac2727666cfc42aa73db7f88f906fc3126e245818212e96d78de3494a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9d9ba755a46a75a878cc803894253f5b3d081ef491a2e62907cf13fb089cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d997eed3d29564b7118a39ea876dfa83655a20174e8307810f965b3943dbaa8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24dab5d203927ea5dce19a849fd5bbf20584d075634d69f16698c75c96faae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c143c56266cbd86ad08a05d69a350d6af1b8d257d46b1fa0ac048e767de0465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17331cde8156b64e78d09b3b6679fb8a15c749b6841e4d99e97007cd541580c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3174fb21a8e02cda5fa54c3e632c62d5c78600b7fe714e3beb00e6c7d7dfd9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b705021c7163085bb84a6fcbc640e3479dc6e838dfce860d5a0f391c4136e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0721f5718267961fa1a1f24fba441df40b43e7d0a2f20892a6a0eb0be8113fc0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fc5f11756e73f9ab837c1139f04742943f8070fde3c0b80c69e93a8f9681c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991e6a6edbdc5758000a87ca29bf624048d84282b3971244fa3526c2a2037466(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862b6b74313deb04554b412b10289af8615545586263f3381ec0c3977743d640(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ea4616ec9c763da6e26920a352eadc611b30b5eab2403253877a63942d1cfd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f90cb188c2dd6ee53caf0d6b4bcce5c37dabcdde52a1c78239dd4c86e06073(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df8be85f3c68a715c2bbcf78c5393c1d1706d5661bbfc09a772e3da445d541a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d41438438a6bbd8c2620304dcaa61c7aad18f112a9575c246f86e8ccd00f285(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe945581d765ebc254f241c63b1b603c0017903876d059d2c75efacffb10393e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0961f5739f43ed7b35aeda6aba6c0326f3329bc70fd928e2a841e906e636ae43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68decbbb382b0e6eed1ecb8c1fe2716d7512e4bebd2ce1da493867ba2cbd886f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54bcf03f6263e654b3d8ac2f4b1b0016804afda5ff55a43aa71989b1a753bdb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2dd511aa2074391166ddc92004f3ea8d3c058a494b06603ef9ff0c209eb6957(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f293728427c42e1e6b9d95689606d3a01e7e1004a9ed51dfc746c468d88809f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da64ee0093e9aa30897984a04d3a996dae10f8ab29a4f047d3e7b9dedef58d72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9fb9fdd9c9ad80614b089272b5b090b8925e6430598b201009be8a018588189(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e514da8dabd2b9b4b1cf938c7af5b4996bcff64a801702195174867e379729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a6c52a211e7797ea444bcf711e28cc9cbe9c494f498a5f9b243c91796db02c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9546b132df504e3c0d90cdb72612db4b43e36a57a638fd75980d4a09e703eadd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c81f7b6a81444d9a66745463094656582c3d119f2078e40c04d0c2638e507ba(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c699f6c7c754589debfb6cf4ab1166087841758f2f6bdb19ab9e75db4d7d4a82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad6caa1d80f7430c779e910ba38ee81b5de9eb7961fe23a80b5feb0890eacf5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69eab947e8d607b9622ca2691323b1954815b794bdd579497f6790fdeabc8a4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ab7009548f9238d6a19ac8bb12b1217461a5990584e4ee0120bc583ec702d2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a690c3e9cfa1ec7fb2ec324da0ce2b907b1cccf6158b4d58d7ff1bc2e5a9adbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a565b1c2850c46c8077bff52a1d5eddd166f9e82aad65061a4b89810bc66c4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5cea23542a4af085a112c13acebc03389fd6d1f20139a7b309dec070e873672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37787e539b7ad4fefce15e279c3e20975194c56bf6f307f774d5efab6f3c3e6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a9cc90548661730e1977642678dceee1ee65ff31b63874a9a1089f274eb907(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9b596e77ed26d8fa9465effea91500cd97fc147bd09a7dae6c876b371d95fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb08a8462f00181977184a3d6ec6cdc30e86d9a59f07c2e1b7f1ca215f45386c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f3d120e11b8282b840d2481a10b2de32163d994de5ad58db06f9674b95fe92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d84dda43d1e7d202356afd014edafd2bff8909f1999385cdfaaa313603fdc9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ef5525526d5103e4986bb0777e8862a189ad20fd681dbd9dda8f80735a62da(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906d62cb3f9bf9f8bd1a37a92ceda8d1b28cd92e02674b6aad975f510b0193b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e8ea5a9d7a0fb3a931af5f7a7299fd507bfab5e4b06e5664ab4a353f88ae8ca(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9aacf005b63a6a1bed65f8538a66a92dd131f4c2fcdd8222f478ba2da15992(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8e0ca5ae3f98ab2ff385302f6b0d652233f60da38e0ab620b221463e211222(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4695ade7c92d2a1cf887fd36595ea5ead351ef70e68ca3f1097d3a6ef240ecb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a70b4aa4544e4fe432d8a2011d972caa73b850696c9b77180feee0e1e2de44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986bf154522a94485dfa81b5106caeca55fb3c50ffe610768b20908bb0d301dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54817498f8a950ace791960dc0df7afcc829f0209a24b34d4fc9cfa42adea089(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b889cb1ee75eb5e7a4bc114179928150e303404a981900a9f8936a17b5517d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3629a006628c9abd7cada9f8adea54f037cd72abcc6ac8865c73509fc6e5ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824f6a8f2f797c2159d70aa43f54402591249685239748ac657de5878140f69b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379feb4479304272ceed2ae8f2ae06fc916d8cdd103af67ac035d76b57b5335d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da03ee9cb4bbb13ce2870fb224a7e072f85721c10b4ab53e78286277b22ee4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118c1e33d93bd086ea6f5f70aea5419639a528d84c82b67f48e7f99d31b62d92(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6865fb1b94b416abf676e7127c699b5ff1599b0d64bf2ebbf2e901e8d56376b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d607b2ca29cd8bb7322ff7384beb2f43f3ef750548e2177c2160e6a90adecd2d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b218e13170839a99e7ef0cc42ec1abc2dcaa45cad44ae82fad123ed788457e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2414905a8783efe7e284f2e737479c344ad442bf571d545ead07649b34702729(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e9d572a94dfa1ea3e9e9524239a6fb11522d6f9795f9c7b0781dd97b2cb6ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8da15c2824ab0c418abd213e681aa0b96294d613398921003ceb7e7af7f56e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3db9ffe28e73f7626922dd098c692066fc35a102e5e3754dc486d2a02fa5244(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e857abf5809eb1ed2a8551f520deabfeed53a480c2981fd6e8507aed9e04f7d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbdbe7cb52c9a4a95e035b1f8d9e72911d871b13cb851b38c6fc3a887450cc3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4c4c9bf46b41b362f7df1a83f59f83b62f23cfd9c659ce5ed56a0f8e106f8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f022519ae1f520c1300979d93483da801f172a5324b3f87768873d41627b2bac(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e021d978bdabf42438413ee628b1593dd343325466e45c89af914aea6ba88d30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f9f0514673f5f6e035f149ca36ec8d589ac18cd7b1016f9689057436ac1b2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d44e27359c343c9e611c6b267bf0e8ea798c13010ec1687c4457124bd40a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa95a0a80783d9457bcbe5408e28ebe1dfeccfec0c58f02f9d67a0e74a17decd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e9a5a0951f1699493550a1c898e8dd7b6a7863dcd8f29460bbcafc25ba51e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2150808405a88fee136182f260c8cd21e923a9375f724e177c1c6281d7136067(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbe2960b598163caa2836c55637052a8f445c1025c3aa723b52866ae4a64921(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e483005e6fc24a58f4c680cda02091654329d9a065ae9b66f25090ea2509b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b11e5f28577c37de40cfbacdde89b1034b92c870e5d532181a318ba8bbb98c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07aaf958eb0a25aa604295bbdec71a10bf4d834d7be926939b4f47c069258cb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb0e712d611084daf5535c54765789befe58e4767b3b9847624336dc700e1f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98999a9be638ba901d265dcce9c4bc0b3a446bac5be849fc03e2f2911cfe061d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02dd6024d928106c327f37cafab60a17394a420db08f7ffce12c0469510357a7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88e35a2c8bcf342f1c934f417491a5d0408a81fa3e309c7182f27354f360939(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e451868881002dc0e417a3a8ffb44e6867606894c1e62ea74134ffed500453a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073e5625077373a6d25563ec36380a8b8dc3fdc3fc2d45ebda3b827bcd05e92f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f248b42cb47fa89825c6aa8ddf6bf6b7562a511d64bc64534d7a61171e259e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a66268adb64b4d857ac8993fd94e5645e5ea642c02028f763fc74ac44a54fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddcdb4c2426deaef7550a916ffe010015d388c51d0681442176b9b9cd8146030(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9161397e146efaf2fa0624f9c19b87f83bf950cc54a0d0ee38c9f76020217bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f646ae152d474fcd466f93fc1ead91e44361948c9630cea54f7a17ff926a7a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deaad98568acf2882b508db00a07a9edff4261bb1850a541f2213a4d4f7bfaba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c360d29cbc677f7e759281614c60590aed7f399e729d440f72b0e91022390e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6961f2200be57ad661d7332e67af87c1d64ec46a96b292cd5c5a9a058b84cfe1(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__face8192a1aa933f9c3f708e1f7b778cc0d898648368aabbd0ee6289bcff63d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55dc88bb41b7835e49cbfb1b7d2628e4929bbb138fcf6a223d2942094b583c4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa603b19de70ff3637a8d109c517e7152da6c1f6be264bd9bfc33c36a39a898a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568f90506e39fe0e10198a8f4bcb87016727c4458cc8fe9da3be331ba94d2603(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97dab4cb2ef23f0af7e3af323910b1f0fd59906ac64d118e3efff4f295e1699(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe4babf353762f9c309fefe33b58cc252904743c7fd000b1b2678c83dccd7f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d6a95043010da8b209ddddd0118a9da89ce40e88c5853ee5b8d41e8faaf13bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336c18584d52c53389f156a3a405083bb84ab750278e6beaee065df4811743d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5e6dee758c087d4abafef9678f13c5444764e3ed3945cf9c29b05cd65b3922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c088989e2b91110c74b35cea2650a54641c3e5343362bdf146f1e53bbee22b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5ca16486ae4f8312bbefbab725a0e95d2ac5b80d283c636b9567f91f7ea4da8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48717d06d14071e5588a2faff21c9ef295ca3d7e8babcb2eabab3b3481dd97d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7efc73beb2516b4908e41d97389c74eec7f76549384357ec44c2c156289070(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dbe4b748e52e5a66e03aa2c06cb34120589881a9374613ae1af382f43ea7a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce2cba7569b626e31e6a186e0677043df4f59613145480b7c61406c31de5b29(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0e0473a8f61a79ae8901674692f821d8e8d7dad4d1fb9f67ee1c5d5dcae279(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8337d745e21a44d4dc66bd743780db40ecb04705640848395c08ae88d5d58c5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17bdb7d7b8bde77e5cadb145e62d7af9ca9cfdf01810db12ecdda57d9f702ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9593bbcd2efc252700a4b41fc35e1712a2c7dadace7048a8f148a0f53a00e2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ebe0c5ba27ba1151c07fbdbc0f46dc68b4fd3d34bc12dca3d2bf3531ec0b206(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2040d801a97de9b1b08a9b0739af2454f687ae4ac1c2188dcd1f3fd472e746(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e3c6cc9bb55069ced84f60854fc2002c8089b9080da5a57c482510f97adede(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ba27cea199b3c325cc0b994121ea9bfbc2e03db168167b775468cd256f55f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c842d39487e73330f8b14b1e9ca06e851deb687b67b13d6e6a34df3328e9ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5d4458923042f93c859ba661b6603626346779e35da0febe24f36ec494fd4d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6b62286b93b5bd442b5d78370efb187050a522b2f81942c24f9a7a97b486bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f91ccc6c75c73aa4c704812465ed1c3db88a0604dd698c47ed246fff57466e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f025beaebf441d37ecac62ca8989105652134bb6d185f1d177074b7d7cdec65(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2cff388adda7bdba9e248d3ca966625eac3dff6d48c57257e1eacbaa8db96b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a03bcba1bb494974bd31bf337fb393de9327c509376d6258e68fe4dd094881(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93df7fa42bc5efc94dcb3cab6cb406c9d3cdd7a707fbf48950a6faad038d44c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999d1a2b3fd238b761d83f8e873b773507f5509463ca07322b21aa2e495e3ac8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc412d0f425c2e22ed63190811ce0b8b8201e43618d44f08fb84206c0c418b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbde86b1814ce533f8db2ae0ae07410e4eeb7c5a4b75ff3fda0980466585f16(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828320ed854d0583c6e3ffb9b9de8970b10dec96a31094d57aaf12990e0779a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09716bbb946036fe5280ade2947492317a8cd9c623a1cc0e05f9b6d0e42aaa3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe3468316191521c823ac181865759e0b74e7daef54af89b3befe27b20bf410(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9a7c50c3e283207b1646043af65577d9793aea95c137cc9785d0f378b58c11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de5654d25554d1a2d93853b378392eaa3b0a0669ceb0c7001018661515578f74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639c8d881a9f1e73a92bd97558bc83964f2297a2b39cd6bd1be51619f7016352(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520a435e62d389630fd290140362c006cd240513af932f3621799b9358d2c5ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ddd145036a0af91ed11da4b4dfba0cd7221fa3bce98c79ef069e97a4454f74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f12e619fa5c948befc3cc12b0171bb3eecaa2e95cccba87c94301fbc5b5edc9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46a69984bff7a103a995ba4671aac041002b36f3c550efb69749993509cc93b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c32fa87ccb4ad7318edf940eb0fb72147576c0e968af5af18fe622607f08c101(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600677ed480ca79232deaf895cd0b8abeeb18776380e8c2499a48b24d2720ad0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b585ecac6ed8a67e1d4a3f0a892923e52a89692f1a250720318782d832c0e5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6caa6ee64d97a53929c0d25fbc31caf2d744a59504c82a79589b51eaac725d85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd65e0893dbe89147a32145887f51a4b313b7400480653f78da2fc693dfcfca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f9a9af6361ecc13e645b340820e2663df566ecf01c74629c6240b8a96b75b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744f798025ee615e290385c56f05c468d5fbe1b9c4d2d239eb6299d4907a725e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3539747ca5853b1f215e7ed6c66bddd40bf3197d8a05b8cbacf45e58b88e4b5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed705da38f3b3db06b754ebb7b58c11752a7b70ade4188fe49e0628ac1bd520e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c44bc3a2eefc50ddbc74ddececbfb814f98bbd36ea88b1373529ba7c688056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01002805f6b5e657b898b767f59bcfec4aab2a7ed1cf8cdb937841854fc76f89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1438b3aae457d71fcf71566a20680bd7dcc3077ef697fe90195dba0fc7bddc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47bfd7d88d067a7b1436c3574200fb7ec1e577c3194b9e43f913e50cfe4dcf06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1889edc0c4468eeb0483ce45666dae3a065a7e69cb7aefd6d1498155e020e81c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12caf2dd453d0945d3af26bd32a64c38836650eef4fbed8425c7a590525bfdd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44eaedee8bb37555c23a487ca7ea8c292e0cf5aad87ee5bde800870bde6374ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4536c4b8204c1d17e0b19a53e0ec9a93cf47ee328e7ecef091d05ea227abbd80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49072826ef1ef7e3097b5c03c9a9955811bd5ef71747cb59ca955cefae6d45b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10fe40b1d2d585e88e7489fcd9d97c02fce273d52072620b33cdee3c5c7ec10e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8edc817108d912907bcfd1f760f5a62567e4f2017c6bbd8f04d31260c2aebdf(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33da63ba94bc0ae0d78ca2c472c2f3b2a8259a65a6657dfb51ad696f7dffef53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be37a8324ceffa9b92a8ba43806f470615e967e4621a163df3d36e5f7fedca70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1331b903795d30d3a6cc8ce1eef37c69a5f9479e25961230fd6ec77317a2bd7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9e9d5acd964fbcac31ff64943684d6d62d6a515917456cbd2bd6280ae2af03(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7560421952ea39876cfebd59e0dcef4a71ab028290ce5ac8706feef8a2a71319(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f9868b34abeb445527668a2bf5bc5f45d53e8fa2430a2a6551071cfe72f7e92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b262ada254ebf72219279a373f2db06d806d650d82ef591187a57a29478356a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1682c612b48e308081a6d9eb419f82b72e97977951e994f1c034e46ead89f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64f39e8cd89883cdf2893466aaa76479a4b15617bcda4ab5651723b958403c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f256d9e99bfb70653170daa4c4362b07eee3bc49abe1bc83d907b5ef193e0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__943d5681aa5672869fe60df777049aea6ee16e8f0a7db386fb5fc09bd3c7b5df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e24b28836300db1cf47819ac2ab5c992ac1f18d7610d5fa990e2715ebdeab29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167c5441637cf8b03686f35d66914a50315cd2e5a9e3c8371cb514343a3a598c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d99a76faafcb6bdc3582080e6cea423c3253252bd2147315ae657b9cd8670f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd7e0b3e0a56fa1583703ccd11d5a68190e29868d7a3e76b537e1af216dd7e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c1884978bc09b9294f615461bc066d4d1b307f02dd500829bc05884bd8dcc2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ed62dc6f69742a674626e75c4e04f11fb16740c54c26cf4f47f4289722e659(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d858214d58f285cf9159988aed3ab160bb97584bb35e5288e0939c7937f92603(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35895697dafc960629c730e34605a1c28bcd0208d0921472b78575ebf294c83f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b6c522beacf4af24d30a13baa89ff70d9815a49dd973f6b099aa9d2dc8b6966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ae6663683184cac7d60e72644eeb96d5e4ed45920517650fcd964bce78094d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10da259843362520a8293d068b9ef215c20ce19b9d4951270a1ed058f34b6a68(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a04d352c9dccf485a472b03405c2410a04fbc8eac505524ad7c757bb4f5416(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa58d77ae5b33c098e84d85b55fe327e66ede6d0f46ade874ad13c491ca5938(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da1d80f465aa2392a18eece275fb84eaa67682ed308688e9c436fb38eaaa1c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a249e677d40a086b945c27a3799e32a17945e8d7be92a2aa81afa905ff1a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f2be9c02e54076cf52bb21d9ef992ff40040bbd2ee9c8cf3512379895ae13a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1562d3e8abbaaa5501e55e97f0c0a7d6e69b4b70140e6a1795fc6e705f0b9bef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c05d208760211424efc6a601ea12f247e85cc0386b93fd1c1c0697d9cc12a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36bb653eea151189e6fdb402b8d2acef5ff3075090f13a99ff7a2665b3c46c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c41812bde6eb904c276725ba389add6452724a814046de0222b33c75e377fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427f263c84568543482e9620d2a0440343f7fa0bff2325ec283e405f1a51dcbf(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793062359fa58232e5528383a265bf748c9a893bd6d176adecfa67daa4ebb659(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f278cc8f583150e2cd9beb14daf0c0848dbd50bf59b6b4f18524e04a9aec879(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1448b1362f7013ca96be02f670ba097d7cec4799df6eeba714c0be3021bbc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21eed6b8a5263bf10ceaec00f3113450317ff7e2e6a45ab4b19aff0931ef52b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__187caf0101566e2fd18ccfa0202008dbf14d00ac3263597f0bbfd45212c78d36(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13899ab3958ec81cc2bf1d82259a47cee0f9dc34bb268bc47343a1f36ccb7c0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7f371f7722857b21d12d255dc0379d4e24ca84fd6ce0677270c766a637c276(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d10323b417a89dbf29fd15fa0358e54ad671dd5704a6359d20a85445155436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9690477fa62656aed7ad2f6e3d565e4abd9731a18ca8910c83712c9764e47d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40353008eb1c42b9bc545641be09e48d3c4db8cef9d1967fffb4e42cc4cf0864(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19697bd3728937f0c52f63d9afaecc9c38aad5afbc08a7b4eec7af006833b91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84cd92b720113fa9e247d12b233cf4f058f4ecc750c7cbbbd22fd3d394265e8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7fbf2ef96cd8c53976ed34c1e1f95a053d591dbdc848b49d6556fa9b995e40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d6a3855f521affeb321d2e2f5be85efed80ec075eed9ce0d5ce7d3596913d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e975313603eb44cd3c724230babf8bd171b7c7b1a0a727cf7b221166042520a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e91fd8d4b619a5737b068708485beaf764a51fe47ee35bb17170751fe9cc2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6375c1ec0f14458eed06dc70c3961afa0ff258f358056910722089a5a96524a(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dfa3e260176f94d281d57a8d7ac01ac0b5eda2342ce1030f8d94d4872930eee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669e5f9ce90a83167b8ab492c7d89a5b72bdf8b3c4a52ffd8b00ddefdfe011e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5efad07108ef49c7eac1c77f89a8d9b38ccbb8444d49ab329d15c807e0f009e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9accc192d0c08737c563619c9524b9d005a16a16a3ea11f72153d7d2b59157(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0446cf654194afa5459d7c890b19542533c1a194f86e6d72725fbffd4f282655(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845ccd96e12edd4dfdc0b6ea1322a5a55eb74aab38e09710617455f2db90f148(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc2329f66898e88c93eb5cfae97bf637ff3f38204cc5af68e117c5532d739ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0fd4e74ffed3546753da01556eb75440c02a61b13ca7ffc5860acf4398cea4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d4bb741dde11fdc28d52517a81789df4d4516b59c73a5be37cd095cc3e6a2ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50906b19d9598c20586d6a6325fbdbe5dec8f426adafa557f992323341a9b59d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558ec8d11139944707614f0d421cb6a358a389e78e3e7abdcfcde1b472116b1f(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb06fbbeedb7f449d92220bdf404f743469d6a86a6fd5ecc96fdd2c7a74ac3b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9322b8739a2550812a80327fe15fdca99ace2a2e6f7d90a8e81e0c103e27a044(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98e183d9aa10dd83bcb529e56947d27a5e3a24124816fbbcb8185334f9e5a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ae5b1a093334c7e14978e0bc897e9a452f9677c262ccc71994aa9b0ff70c89(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2346cc2182a3b0bc160e02d783c84afcadfe7fc60d6ad4a5c331900ae6a07fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bee97ef8cd9dffbaacd052d94a55b3f99c51f581947ca84a5689cae893777f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6edcbfb5dcd1614e70add4f989e66dccaf4a3e767491d4e7c33bf0f82b5a7be4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ba80e95ae9b7dafb3f852646d5f228c14fdbb3e734894b1698ae36408c191d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492e7a18cdc2eea3e6f82e6e893a39d5fb6cdda9193398402d99499374b699a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dfa2462299dccf15ce562e5e29baa12408a0fc106eb403f99523b209592cef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c141018fd13afd51c2984ba2f6b6be2762113d8341d3ea53e7ca24f7c4352171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc11f72515c019d83f26e243e3683c88604a7ce43eca6690bb49c4ffa83de12d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e29dfbe6e8caf5c8b6e8e071c83b32a70da7952b17c23a30016344b6aac2a8c(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaeaa0e48714e017d3742b861048060d1b9051d37fe9d92eeee5e79c4eee3604(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e17e0943e9467567d20dd667fdda861073885fd986ff51a8e82f5f080a3d58(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67c4a599e75ab05b1f1d87776a1201b9df97cd9f587752b6fd6ae2a75e50225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974a779f3dbcdb5208828fe5b7e0fb482e8faaa3335cee8cb480af64f11df4b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002fc05244f34f43d28331e6230d04c0ebd92ab7430dad395396f074e80d7196(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d146e5cf2ed9b0f8d92675482fa6ce47b6dad064a9a9c180ac5f4db3860eb863(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd833f6e7c8809d89fdc8fc3508945e2327b343268bbe240f7422db25bb07a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a910e5a7b023742bca8c8d360a5789068163329ebda76d7606a18df104fe9b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d03885fc297a0066ee256b761733dbb29ec585641231dc18bc752c2843a542(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63bf81c1ad5a55a5c72bba283ef62f625af90161c788eb7a018009746aaa4ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec276bfb0dfad3622955955b221bb21995f03d3556fa314072883c6411c93cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8618f18c6f4dc939693c7ad171f89d4394fb052b57f8ca6c04703bafd85d8536(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260e3530af2dde18519b6a271e8abd9b35b2d1f75fa35c8d3264ab36555c1296(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125a79424e958ade931ba523b5e645c97d11d94bce612871e9549349513e3527(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec0ca8f1f1d6972f17384a17785d8ef6435da6ca0d6cac91ff4e45dc142fa17(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5c839ec93eaad23bec5df7016c6bbdb16aff62f5144755fa52f7d0a375768a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc60837997805083ae1f36c336f7ddfedd2bf06f13235666c4b51fd1223c620(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271729cb19bae581e15bc7767faf83446d85356102fe93876303021828f955e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147dd86b48117c872d5f99ae1fdc21e927f3fb5b0a424384ceb52becd4066bfb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da87d4ab55cc9a8b9d1ee0a7b29d154c48289bc7f6dc9abae8a4934518f3a03f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5424accc34367c8338dc15992a2f45d2c3fee7539800d5cec795abe0ba0de8ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605ec43c23f222622d7f683404583fc2c312c3b5beffe3121f0e35226953734a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b47653ccb38e446d1af22293fa484898283daacdebbd380b79fa78b76b0e235(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbdd6ff2537cb32aa2c29fcecf3f45537cb3e359d4d26d7a46715fdd6661d3bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef00d6fcbb1ae8bb1b0080f1a2df38fad950996b71c5cc13853cc8523dfdcfdb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14168477bec10136a9242b665efa8d11f4730f39a4bd197ffa33584b9b54a5f(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1afad1cad94a25243ae9fda08b85ec26b0e40c7c79b5e2dbd4f4b81de7cc24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ab610db228c17501fadef006e9e0f1df25db8d5f33c04f85aa52b695d886be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d880ea758c7bbdeea29d5133a417a918671e233cb7f401933f979a78e28ed55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b29c10d59535ca22ceccd9c59b4d0b5e94e2ac0ba8b8df917d543428d59fcb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29fe1f18bb318ea362619e3b602fde32a2160da3b51df9f351df85750eb08874(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__751bb9342a551248021159ce4f7ffdf515f30c283bf7a564b31151f60566990a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27c51fd39a8563712b94726d99b60fcf24c62ecb8355a4385d62ce83abf7d4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b6109f0bf011972f6712ee4c795d916f2602233cdf9be9afe845a42c41dafdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ccc1753ecf7c3c46ceda46f9bb87195671b1e8cf7fd6ada75b6a04aa790cbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da63adab31fdacab2a36f00280967d901670596c96040e244e9dd9b5594030b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed5a3a77b43e73f4502e6ee0f43875f6b318e849f5c018aac132c0aebb79fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a2033d808b301deedfdb3135cef98f9c34b47373127fe781c11eeddc097b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e4fd208bff1ac05bea2dfb21b83ccff05a01b7372708d7b26424adde83f576(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc3ddf41fd958189c1f754557668e6ea51e66439df6113d8f40494df29ed1ad4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4299d540c22dedb18d8bca0450b23f3fd29cff3224d3027e4c0b16f3226efcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a020bd5d4c0007e55cba1b72e23c41bc74a730963a9bdbd343536b83b8b097b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53859681d914a97aa6e500f26563da3cbe59916a1128963241f2c39a9df9655f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea8873bb666ff8f20a8ddce987e5958115a520545580a81552541b988b6e2fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e6990e9d8a205eb5d34819dfdd18abfb78ad50ccc0f97e1c02cafb10b5db8e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a441c33537a1387da8eb59fd319db0b5196ea216bada63e81e06152d62e6ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c385f618de8acf7f6cb8370ef1ab96f326abfd34c1078dd489b91bb3f00bf531(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b98dc430e31831c7e8994a4b36ee7b11f1a89d2ae66534182f86eb6640c387e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d4e703985e35c27ac937fbb560a2aafcf56b8af088c66dcfe05d61b47513e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5efc1a51cf70971debd995d8b9432bba8227535c62fdf9c32476a5832247aa6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137ee936943384f74fb6d255a2a96e0939e0930a3801b6b9da090c2aa1a88eb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d85f510407d3d1a0979f3d7f447932c8bc1f79dbe51eaf8ac0da0e698f5f28f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34fb29c473b24606a7dca5203d8d0fa390d1d5d99f3e08c38e9823cc7100e654(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c92dca9f5ac5292c44be70db795c213fa9b25b94c8f37b603e7ce376f60512b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95efc5c3c0ba03b7edc31e37274ddf68505dfacf01d5309a79288b66e02377be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4347d7e9e6947b673bb5b624e89e909fa9124e43f753448b3b23eea6e24250a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cde4cb039543e457f539362da0dbfc0fcb3cb2f0512ceaca25d3bcd427fbd31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edaa63c88544ac4ecff8fa561da8530cf02bc460e034fc69ae409425f69a3f2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33812682d03fc39b38998f430165aa9b72f83f000822cfee226abed7c6da231(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea0cd5017d5565aff5f57bf77ebd067bc93ef7c25e84fe57698e08dc7c2442f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b50c91bf00384db6b43e0bba0571fceefd5670704cf05fa6f7cc9b906527b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854c42e6201fcc9afe8699e66df7f09743e4a1c34d5db41ee405d0dff940b96c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e67da75fb67d2301d7a426ddf0b3f06c37546d3977ae0c0315f9861417e73fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22609be26ce89a8c209dfb6def3625c56520e63df568dc8b8105ce4be7b3123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec0ba734bbf9c7aefaf800f44fbd725d633d0c137f915ab046c990aefb3bff12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b19e2ec8ba9e1234b25dd9fea1502a339ffe6303872c6d0ba43e0da901af31c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27db9e40c6607b457dda5b7091a1c45ebf2e9b4dc69d55470d7a3d054d7dc8ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2662948fae6711a6ff5555452edf00612355921583ebfe8d512a1d079a032c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8c9dcc6ae0b7e2bc9534801ec0847168b7e06fe8f8abd4e7677cb81ba3171f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79872335b53707678c254160d17a283aa61c03ecebbe81778151f8ac6c64a463(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d078b2ce2bccdad2e134ce4fa85573bf51c06bcef4060be8f242d99341e30db1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b721fc151aacfbfbf8d59348d927207416f2bd7f24aa2f8aca12a6dd8acab9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe0b15fe106fb9fa0ec7ee5d8ba110dd8b52fa4d1e2ef5cf9b07596e2494333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381a7e2a5fc7e9423db019dea3dbcee97f24097dd2512db9174520eb93f4f181(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569d81571df0fd2f1bd1bce713d78e510b1048bf62bae92525361ead7813e3c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1ab90bfcebc29ae560c8e233fac7b6426838fbda205624ed6ade78b54621ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f957392396f3f9d3fefaae25d7076889c6bb97772ff3a769db9bc886264c9639(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a665d82046ea3aaef85f9f28beb0e0d0ff9bab2203003e6125accce26354c466(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc1105dc20567daa4c95701ed8004b86461a06535523c8873d3488cd48f96c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff9aac0ebd10492bca7a60e039c2b460bf08287bacf6e30e651a2e02618ef3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efeabbfc7aca7d6362319c07a53d6195c0dd7bed29072d7ae98ea3d0b5014380(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a13e73c79448fbcf459ac093c251f037c352e06a9a7ab07c215e141538f3b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab208f69bdae7e66b040eaed3520f62b5fe5ea40a35eefdcd562e96acb9c15fd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c9629652430140992a544a2a01557988da12409ff6ee105ddcf090849861f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ab631c263f30c006717235f77c5ec9bd9e5c29ea31da94e462624e35bf21b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13fedd1e8607f59f51cad00c8ba6f811c5980856a69eee50c4e53c05eecef115(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298197f26e5efad660f07eb6baafa17a6e396deeab922429144e881c62bf1783(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c397a521012b5d0c45eb07024de29caabce8bb3b971ca1094938bbc02d300f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d870f6f4b8f0c15e21f867751a21c20616772a13f13c149917f2a929e5d4ab1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3938e717cb97647b9726453dad1c28ed2693875f92cbdb89deee9d531774bc08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b22305f91cbe35505b02a47766c9a31fd934f716b4f05e8e04d33fc967493f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9896ce1353a9a2b8b55867745bf10df2d5d59c3eed6fc87fc0dc9df3e8870405(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45bfc447c0981749aa0e28f655e0d91ea15421a03939b543a4dfffe7ad07bbc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4766a49d53c1b3ee7d1545e599cbb1dc8fd2b199395ada290ad609a67f24002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da6047d5dfce43208878e176435859ac71534ecd1a959df008c67d7831cbb3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7f0c56348ae8dd3e65b85f793d6979f79b3c6f992ddcc6c0072ba7785dcdb6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0d4f557193285f37ee9b89ffa573ddeba256d5e76611da06abc59a1543355c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2e8ae002e99b731c3189f604acdfdf52960f1b509711f6ea5631500de007da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca78843699083d265335e07d3d11a47c376dda6d688e6c6dfa280eb5d241e500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c36c841765c83082917bb5c9551070071e567e29487b25c1cb4b308c6341fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7950baaa0bad1e3594bb4f4f0cc1b644b6db4833114d6a66388c587003e0a90(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c521f7b169345c0b678877ff7fecd8cde4f9d77d5b8b2d706c6cabfa9c01f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aec172ea7ea687a1950affd4c26faad823ac80f79b24ae199478298f104297c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4720844e83bbfbc1db0fe0d795deda541a78fddf50738c6a049de880abe0f93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aad4387c0a2aa7dfd0d3ed7d536bcdaae98042048264ef39dd481e5d594a402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c49850ae7d8be928ea1cf43c28dce13e81eadd0883cd11d42b2f0c042841816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a84ec4a2e761e289f56ea137aad47f7c8b732547f0dee514e0f862fb6e680ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc4a3b6e2e268070631343606f084a07811ef064a9ac4de09981366bdde84131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9671d7df7b2df8f9648ef110a5fde5884ee55f6d6d0f42311e86e74e637d677(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241bbf7bcb6fe9c0738af6993b57b90201c408135ec9e64b7393679d4aa5d133(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1819ffbd583bbaeb01ca466f7925cb1d5ee636dd998cacf346e37c473b4edf4c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e577ee19f41b8ce5fe09a394bac0f3c9cd7e8b655e744b1dcdb51482405220a4(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__194c9414d4e2f37b80f3ccf3bde6bb4f318fe0bc1620de522f71b4c280aca9d9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd08dd7a45f0673efd3a51596f12b5a6dbd659c314d79fd5b6536ee7a2067a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ca220900cc1a820aaf5b87b8486a1c0f60ee6446403a15e1a423db018bf653(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b6a4c043902adf4b65ef3465625de04e3bf3064964ae7759f3f9035d56fce9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df104e44979dabcfabb7b10677b254247b8e3e12d047719ed10b18d88caba1f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d7b25fb93c57c85b59d3125c5fe7f6f9614a9464fefcc562e0b590ae8953e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dca52d0b3c7c8e594627434f4c98acdba6a3cf84207214c5d68ef84ed1bf0c96(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3448c99ebd303e4d5fa26f60eebbd4ede80d7d993a15749f3c3153a495a1da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe430681e72879618fbb8b6aab6f1663360577d4d55b27325a658bb46e992be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc58a56e5130034b0155cc9347dcf77ef1b536c3bf467ecb405b29ea4289919(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe84f892db1af551d00306a4422cdb5cd8b2f759b02965d6074c75b2867c185(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07e30ac9d66511bfacf9a1782053e57321a86e0c3a0b21857229ad62c7983f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05263fc2b465220d840492b80a6029183f3a45e82d58540978502c8e6070da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39e153a708fa0f9185561c3e14bb649af2bf49ac8746e7f78d05656d646c9bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552c87ae30cb5176eb68d6f5778a467fe5bceaf6ceecb3b9fbf507c608fc9b76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b56453631430710ac3ff6ecbc9759a29b673f9dc8cd41d57f3d5644999b5ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0bc2fc52555b56b1aec290b135e21e628febce6b8e0773764a397fae385ff6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029560b8ea1e87bdfa9eb2958fbb71ea73782989e547504557b78c6ef617e685(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__727d2e823d415c7e95e1ab8f1765c512a8ed9e0544424f806eb60f64c8bd0139(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b79a602848b8c2f3a02c6a21033e31cd9aa0996c3f175aa2afd05a29da95dc0d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c67fe7a7f9835dfd29aa513f9736ce9e5f2f1ccf5675105b487a79eecb43270(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f38114695cebcee50163c5469cc79a40544571783d416073e75a03f51dc7a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c540ce869afa699f55ad696574fa3ddd79fc9cadd435fa5a83752abf3c50a26c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0d0098e91b69b793b8279d0401310f6ba97f91292ba818cd6a4a75fb4c03be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b1969761f06dd593ecdf1976a0976be35816ad8c5b0d7b930323a0039cee6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be181d4d8342a17d04f8245a7b3c1f89351d92358ffd06cdab041d7d6bbb124(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644e833308693ecfbca54bfdfcf8cae7c6f75240d2355a7f4a36b8e879c08c8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7148608f63fba174b0a45d68bc76e17fc87243300c10c4002a6a0df4a3458d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0e13d1575c0042ec1d463c6de86ad10da9352d6e016815feb9c814d95f140e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0094aa3882002d6a276bdd2d15d61e482cf5a71894a633964d3d8377e634419e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ebfeb5709ff1ad2ca36e18cc1dd4bddf2e7b1526576e246427e37a4a9209e6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e99ac99f176aefe50e95f80adedc6adce13fc258971a1f03efea3a8bd0fed5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed608e0cacc43c7327a9979c069552e39ec7909c2d5904d88a9de3ca1dbb23f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0efe704b18fdea08ec53a6251780b3802ba682e6ac5988410171aea9a5874a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d6d234b23ccebc73bb650bf12aa97636bcacc9738cb132075c1dc4072508bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a225393a80c1d14642d4eaa54057056e9783289f8b50e57778e96e776ba088f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7167392c0318343fbb4c5c04ef3bd937fdb57536ad4e3479229d782f50e29fb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25acc02959cddfa868d7a2bfdb35c1113a2e5a73517556fbac7ba63b425615b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b613e5ff684777e847fdc9424621a23290e83d2b001fab8c2373a725136d794(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81842f387257f9fa39d0415c29cb88a6ac3b8a3819abfe9e8887de62c40b1394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec52542946497d4da30b9348b0fbec641247ec458a65942eeba32b12e56df4b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbe5572675b4da35f918c27a0e621e9d2731c57959911b811c16578c3fb081c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720a16cfb3f6c7c9422e1d8765e9374514e4fbf6e9cc6935045dde4022cce964(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1435999329aa93fc3202a718cc3c1e7b435dbaf82585fde3f772da441ca48d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557deee56400b13f553da84a878cb1bf91f553ec6aac2b548ebb778361045f01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19907c194f86c3794d7a774eb991f8bde541417637494b785513210d1d597dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2f5e5558afba1ca4ec5a2b8db2b782927d946c8d348478dcc3903afbfcd831(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c183e5e4094cfb767ddd6f44fb6bbd93796ca1694acc17f77a19979a8061584(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29461679c938937f4792da07327e74f473e2daac4690cae1874b348aabff35cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d266d41acab49d4a5665b916282cc93c87d2f7e3b998dfe66cdb83ae4b378a79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30307ce6ee8e606cc073c9203ce6fb68b09ef92c1844b8732e3979f7c06d2f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45006c0c93ba62231bf2b4882ea61befa3523111d71227f575c304442b3b9712(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f43c8602bdad634ca26d52b7cc8fa2c7b6f56fb8f40cbd4e7322df45368847(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a593122b1d95ad55d27f72e49d22948704fed72e6a0d4e5451e0002eb459bb10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7226ac1c5d79f36536d247a9d3c70f7e68bf1ba7341871fed762593800b97ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37902f7f89b6a85eb8e78899235b8a2d571a60d4db32fe7a674ec9a0a21b05e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe57f6898360239d41a844600a3c1a976fd573da8e55f84ec680cd3715d02bee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13a154c65376c16d18eb21d3bcc0df39428b9136f9072f2c3641a1b64e27419(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9ad2d44c01882d96db99341bbfd479a4d4364eb6b7ebf06c9b23b68584f8b8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba33123dff0cac4955aa882a1ef864244ee156be83b9e246b3d7a422f80c2505(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03f9c3e256e524e0e74e0613298bef8eaf5edb621ceadd0fa549b893d1df845(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2268630e34b4c0e63234ef8e770f544b1e03dc84cbad4b608f106bcc3204030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52adc612350df64bfb1cdaff3487051bb43826912c18ecf5238f9c0f03714dcf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59384acfd85e1b782b6f43667acbf90c81a427ecacc3b42fd56aead29f15850(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ecb60a5ce255fcd80c194b50e28a9e3199603b08e1cc164f2848cd896bfc288(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f504e2499d71e49ef6ea94576403dd87b15a0aa968bf8e63ead17ed62b34eecc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ca4c0498a50ce111bc1348f54f1cbb5e821637cf4e91bbce3d3fc050f22e3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2eeca2325f1e783cc0e757c5b4445b3ce0f7542a34ff0bbb32078d219b1d1ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3c0835139fb8a98f8f17bc0a45156c1a5fecbf290ce5cdf1a17ebcf38cd02f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436aa8de1cf4b7d629abab95fa1c52bc9a1fa389703ebe887a610b4a39560078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa6a7835c03e6c23d59e46fc0a2f2407ea682fa622819bc9d35ac36c3f641f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2942a2300c5055ca236171176f1c9b4b7a2dffec61a91898d0bee06fea5ff78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc428ae4063faa7a08f9417429ecb549b60791e4bf38a5d0aa22cc2145ad2267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41094cbe1946719755900c230c9a09e7ceea30888ebe7192c35697f9dfc2336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773f8d606cebf6a4b033d9905e8df0d26bc6c0fcec2e4be7fc839cf16ff46852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eceed25ae8525243d3c4a3872f36ea30a0e1f3ecfd473dbc8ea29a16bb727ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a9a843dcdb70ec5f45e17c7c8006d96204ced72e8da73cc761308a04d4dd91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f49d5818f251e072aa6e0fe9168430679232595c991908edf8900ec8e1f6a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229f921c91d72637a777fb9a3fec525a21ea3665862bd37cb214287b16ee43e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd1e05b77f80890f6c80af07f5bb8a55c881fc558c04001a5022522f5d18cfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf4bcbcbf96455f40b9a00f731bf4baf9e63f2c553913769edce7f931a00278(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b38c333c02fa37871147c6294f8cfa53c8fcf781783d0d676b2d68fce9e6953b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05992c58de18b1978bb567c3955ab4b94f87ca3cb159796866f9e1d329a6a134(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813f3243623c5c17b0d43a99b75700a8626719e0519f0bf44bc146e6dda02ffb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af5a06d9747f9369b94a43838cbbb127ad921e0f5e918c0626786c5dac1be3e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db8be0822837530b39b38dc3c06e7f634bef29d5e79df7db181337168cf62703(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b8807b16a08c97d0ee82d393baba3fb1850513e00820ffc18c6a0a1498a8a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952ec94125c99c478243b00d2c68bb5b1e2be2d8830048eb317969ec621a446e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cb212e3556dca0d5670943e6bb47ec05ce9309424e9d2c057aeb3e7a4b4682(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa1fff09fa2caef9012c0f4aa8b7a17d32334e6bb80875e9db884b2e184de6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180a847c4ca571eb02af12b588be819924315cf3a64145345bdbad0d13ac6911(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca05bb5f9597c4bb38df980cff0c11e2db884498edcfb9582999a2a920bdcee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f7902eade8c385d11c994351b70983964b40ef2b74719de782d948c77d8b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9376ae96e409806fb2f1c48ee344460fbdd060d14aa9fb1ca887ca970563808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2483b6385c910064963fd3b69005f79abede81e4504343e01ff77c95e583c0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff6e00b8ba0260ac09fecd661cbccc63794b9934c14fd44242ad1927a7f1da60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dfb61f9c9b8b81826f5338f1627077af10916f2fe72d64687ce8d993e2daf30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b3685353e3db3f39b9f25655336c1f230b7b965c27255f58d424278a599e94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e3c8a9c02bfef22f191d71e945c19559a09d41458ec324e70c9b3711bd4a11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825fe38e302b4514588965cf0feb8c9ec9a8efcede6efd2d7971f94e81818072(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4c159395083c4bff083f2bce569d2a8478c3569922f40fe7c94d831e37cf01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb425c30639070e9299cfee39265a9e638f47862100903a5154fa7a929471f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca44308113b81d41358396fe35a2f4e2321b74b20cc3f6668456d4d257d129f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569104dd4f6efe9e9fa71c05c2fcb8e34f2ddf2e90a3961926acfe5af357bfe4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ec94e6255f4eaab31fc8189fcc3f9f83b83aa5f4a7348206cfbc8459b89298(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef3c1ca3d82450691c06b3bc006c585fa0f2dbb1cc60e3496cf68a7073812cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550c22b42a7650a28db1853e37f4fd2d24fc129fb715ee526b8c97bdcec59064(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a9d03bcd1b83337347efaed51c59022cd7f2cd4f2843d17d2bb8f0ec4d523e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a834fec00fc03233265091e8065fb9d1bd5f007735e58b6841256494d40ebe5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c35d214e6bcfa33c5b489d622ef2c71522944a2ee316b51af543e05e346e4a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__962163069e0244c6c69cf2125f78761e5819159e63c55284d5e05c452a03a0be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1a19eaea9e4ac00f7d0f57b24eb70ccfe9ffa4cb8294e4e67cc2b87d208275(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff3a97b5494243d237097844b1b6d4bce874547be270ed882b5fdedf4cdcaec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249384db9455e2a0a0f9e6b8ed7a6ad5298f3787333f3f32413a9a4bd7977692(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6c6109502724e0b0eb2b3320680a6057856aac6940a2fbf8e1061edc8957ac5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33674ec54d27722a4b3697957bc56b22f39ffdd585878025aec842c1e55c796b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40cafe326bce65e2b4dacbe7d2ea0eb251d44af3439b7e04ec20f3ded6116b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1156cc14d1034ca1645db9fa345d0b38d1def20a12ce738d29c686fcf72720af(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711ca9e82f51e63af9c74712b74604d8379b59c2f7469d70a93accbe0188e4ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30eba9dcadfd93fd1a56d4cb876503287354e71b02f20a57a5374fd4dd93528e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516a0340bb76af6c2715351347a7a3843c0ae68810e4359c5baad4baa9f3ec36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304c3a2f75a1b76777e87971637e4ed104cdf3dc241956d10367636da4561c8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c04497f64ab1497168d1f0394589bc26a57e1014e274300a7b9650c6d09e249(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1270e0086b92bf325f0d7e5c5af639de62aa3176663b140ed06099e0b41e33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a93d4befb1265c6ba2850ed4c3f812ec0b3f0036380bd45ebf7ffd30511ebc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f482333094580aa317c37e68d51c6ebdb1f30ec8b489e0c22a311a9e4de941f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555cd04c140a9c457b6ad7ced7e98af7503c238d1f11d7bb0971f51e1bd412b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c55eedb4f42d6e99a1885177be8d09f8a76f9244ba8e454a8cc077bff452e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5170c5795b61481b9901be641631a2af37244a4a18815badfb9cf303929b26d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a625826f47d1f1582d0c39239fdce816c1c771bf5e97c557a4d264e84159c1b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278d6178322057d3edd61061d605a077a3426362eabc790ba7768100065dc3fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c3e2d0bed226b6d7289e680b58a7605cf0262b7b8213b5af6e0bbbbaef5cc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93af62ce9eed6fcb292ef921a418751864fc9b5ef12da5e7fc0c7c67d2d0a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0950dad86f18b02f1520c48f064f54e7582d1e54c7b65cc2f0e6fa2164b26969(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414b740ce1f93efef22a5e9e31b87d8248167734a07ac382dbcd250cf313eae6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec1340c41890711b9d5d4a801ac0d88d0783fe155eaad63ac1d22ed86b8debed(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9187fb6d7cc080d10bf78d565d0147d86387851aafdb7d6b2432cde887753d8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c339b02052ba6e2c41b27dd79f7be58c711b37a91d233be172cd3cd27d689970(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725777e6b60c68675982b82a74e61b86b7f43b817a6321d71ac9ef0376b59bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589df2ff03236dbfdf0e63f8b78fc4a0c5983ddf74b0f7d47d2376a7777089eb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e0815de3ac9da72e34fe878ab2be3f7db011a27de8e12b5e97c01aaad1aaa2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4c827e4bbe1f32194165f3021dc04baa407296a900b999fec1da0008fda8fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e32574dbe2866030355af08f591478c1d5435773c7eb3fa4cc4567fad9efdb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e4a04360ddea4da706f14c2cffe12047de682e2275461c3053767baf535143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45afc3fe1f8fe30ad982f8fb9ffe6f6fd823dd77cd9bf8d9eea6663ed2352c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9fd6d27d4a4dcdf3bd599c162b99553c8630f19efc2532e53ae36caf054aaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb320945da1be36e9a147dff7af6653de1935c759c4b1cbc95792f79d08e74e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50c412f9604589ea48c6a91b8ebf3fb60341444563ad0811fa0f99e756ee4fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a771f906830d7bc2125292c31c4d630c92b0d3dc73863d44a80c622b5e2b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb81530eeca0933b4edc130236f31ebf74bb544ef2f989ecb4d08d794cc57bde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4252610969a06cefea863b98b407b37d07f4c34af69b5ce5567888924031a8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c1fc54000c5c1677ee9a80437413b138d735c03a7e818a33dd1281a654f44d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7995f028396f1d064900b7d07aa76460bd1f4a7ae021c75ac044aa0109cc06e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6966ae4f621cda7ca064a77ff46b1303923b013c4c53295bd35f594751f2b0c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed85dd8b352f57f8fb0eb96f81d5831216434b293f818e06bba737227ee3bd41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590258071c769a4f7a9518c99458f637f0f2a91f24109782a5e11c9e264b8c45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444378c4f3bdf31af287463353892e6a7c4997ba2061a48fe53d8bc3bc8ee6fc(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29475a10b41d1ad278c1c9acfaa246ddc4266bf3b1888521d332689662cfc44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddca097194fb1c36bb441a1b18f19e681d8d73d93186d4cf15d5acf2ef55a8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d96e1a32deb3c5494d01e8ca7d5563b5aeae16235345841a69089c4598e81d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c2558cf671f2e38cc011970ee5dd689c095df2208f86be3868afba0b9f7575(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a991e661767bc0f55e36d1c368fec5effc272083f7234afdc40c157df14e93b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a13f93b861bf2f9e68515cb83b013d01e300c25ed6b9ff13aeb814fefd055c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cadbe29d8f16c5133d429980c64570c8576de67180c1d927f81bbf6cdc05110(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2429f8a8029471866551cb8be4c03955a1945d2878170b728c934f31b03fbcdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5ff147b34a94fc11dfad945d3e7abf42fae1660f6850bb364ee68e8e965b83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24350f4b36ba260aebcf0e0c779061c50269e0e3b053acffb7a81fe30367d42c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151119f3ae108e238f71b9a216b5ec4d65bfaf1e89a7325f29aa0b31e8d550fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c216597a7845dce14977df384e2a6cb655fa021b9aa677f761bf049de129595b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd56c187ceb328b11cb26ed360aa1ac4ff4850e3f458dc30c2250e69f630a820(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bed224eed4d3467608ee4feaad624f141581e6c999c95b448f47f272a3afcea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed81a619c01f0374ab74914fb7e417cae1e94901b29672641031500be3e9061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbdcfac34ce8dabc119bdc8f1280309e52ea810e12daf65134ad2d07a903750b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__356c006a73daaa5508b10879c287eb5817aec3d7c24ffe99d62aeaefc3b686b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89b8a7443f13e320e8c64317014c181a8ea360c0fee4c5eff3b4c29b1cb70ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9dc60ec26e5769c245a7c3f727e606bdd47a70b67866c86b44c7709035a4f03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8fdbc903edebfe789832a6438312a8fcde4f3f51ce754df3ca4c59cd9c8eae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2174b7e6ceb7d1a7bfa3ee883e899bccf781b0bfeec6b2c8f4b0a4124f3bdbc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64785482522bd4785542de3c117f8db435919f991cddc74dda1f99b50396beac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f26f5875ebe0793a050f8983c49184a361ef9bcb16f1faca44b7ea234f78919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df11b1860415635cdb404d400de90047bab36226b7234349277ca45dee0e30f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b0d2564c5a0e113351b049031d76c3d66fb4d198ecf2a0bcf8478ad37dac03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefc6c08ebf87010ebed9c14275b3df0b052784126d1952c9406e6e77e3c518c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2a8e8d17b8b26e6adeb83fae49b933f4b7908a707e83ea6e277fcae272ae89(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182b8ba23e51f4964fb71811b0d5f4bc429d4b4375c39c7c6acbdefa95c711dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735d809fb86ab614898fe73a9128967e4d8a1e43e33c2f020b65462fa4e62d8f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1925e6e28cb22e59b20746a8e8997bf59a93f798c21fb0f31668ba6998e750bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0fa25823b44ca06a63a481a584dc9459853b202e9dadfd79a103145cd5b27e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c55086b51cfb74b7f6eb5596c688a7cb32752ef4f32dfd74dcf475fae6df5e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f2007dc05fabf91feb1c8ae7247d1a23d69c70390edb2b5dbf0966238bad67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee3b8c9b1912abef44917881730fae83bae6362c9fe0a6d5547fb3d56781de4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b185986c3adb3ae4c446440c0eb8398e5860014fddf91d84d18072eaf7e3db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bd55fd9367d3f29515b8814ab31c7d679106ef3fd7d0d63448176e1f1e5c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f978aaf108046fddfe57048cfd8cf0bc4e56384898bc5ea9a3dd3585f7e7b879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__570a811ac685cf26b7a049203f32f25fca1cae19c1a93d7e2d4f478ba8e2e0aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4474763c0f044278e065b7166cfc43a3e500ac8d80066544a65bb6945319eb09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b51ed7a83485cb5a27f97a864ee9d416f6e6cab5501525ec682c28f49609e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3bc0f20decbe63a95e514de10fb7eeccb4365e068c15b070f214239442492f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49dcddde2d6b60e7cf1685c37423a3dc304746022a99ab006c5592406293e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e193b72e803c6469848f227eb53ba6c7d351251ccac0cfdde3bc9315cd810bb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ceb775c2418c75cf37affdb818827f728aaf2c47cbb22e6853511608c4cd74c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d750fccfa280ab3ac46d6b53b76599cdace205b12fd33737513c5e3a95734904(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5459403f7969fde526e731be39243244c29d726511124f5915cca41a50109a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9846463233fafbb4babe4968e759796a334311a2023c2c7f218ea0503dddc8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3af2483a62a85d405fcaa39ebe008d3cc8b881c42ae5aeee5e6b769394d6b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9571c7da09b3d5832ae61075d803ec688e58ae7bdf484dcf30fd676ccc5ee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876b99c9ce7fa04d1ab448add781afa9cba29eed0531e0e8e54654db3823c13c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ba7420a5b2f8b3247d0c7e22f3d38abd5c5e9f4e9109bc73b78c6bd78d6227(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd975eeabde185a96de6480931a6532d27f77575d7ab2d84a667b11559d6c95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52e7dd4b48f5e9a90945498976284f3e09db0bef605610af35e90ad6dedfb85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10c4cee3bf437d7062f53a9187a3d2d5ea5b7a1afedae97156ccffca5164d95(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c0c6f45af7863f485485061679dbd099e791cd90484d702632c243d9dddc71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab98d5e355a70a6d983024affbf1539f6f4a5756856a7f6d6cc83ccfdbb2994(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4972dc7fe859f6f75e7474ee602f70e78f895fab96a9ff992ac872006caf26cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9d0b9cb95bfa85663b69c6f7900688783892b8d4776bbb6329337e1c702e86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b690231ad3c63e76c36fba34ce575b4461583666030a901fea74a06c6eb4534b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f7c3e83604d223beeabcb0e2c881c92c1e633e01f9ac3320ea8862d2d14175(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce76370f5426938b1326933900f2b4a8d0d37a2f966fc84055f3d238433a67c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdbd85c2139ce111253e908bed36c68d8f9468bf4128b325f9eba7ee63f83b4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1909cc74d84f4d4afaef1f8aa228cf94baee010dc20d816aa1a79d59177459(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8079dd39fcf2b72b58a1a79c6920c2afd5b562076ea274befa76063c4f4e5e72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf65570cb9dd0a8557a3e3446afef0c85cc9b3dc68564ce417cee19e05f1d6ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08d0a33708e49e3fbbfe287d817a985248a16afcbbc08f3174e1f2a402bc0aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6edc6505ef001d15804c42dc6d6655a758713e99b41c075980c946c51b0cb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5ea5b4fa0ccafef8823d8abb13551656e7beb42d5f40ce19dedec293309cca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30e3e52c59023010b2297b188312826244cfe1fea385c5240eed5cdbe2ae70f(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5fe65d8e3348d4489eca8cf7a7114fae833c4ac7438d8fcb4bb0801861484f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd99eb3c418d36e63466bae355b3daf40fcca92484f3fa3b8bb73985afeb97d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dac62993595971a3a199496dc1d73a968efb93a0391cfaf49b58ab50141f046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525a4c2b29068708f0a9af6be7c57879c7debddc985bb3dd4168685b635ffdf4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22dd84769fe2fda032453c67815c420d60ebbefe0f413889861f1a6f73f55963(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164521a1919516c785af1274eceada8214141922b837223f4e7894913388c770(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f74a139d3febca77154c1a5e743a960b8d30fa4074ea43cdfdabd2d10b05e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c36e8629a25a25eb99ebf8d70b68123cfc035a9bb1368396120d922c34fe10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460015a33422ea0c53e841d4dde0d6dd423868e0fcc35bea88b5d3d9b0a37e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d49a49a6b208bb43278fec6b42576247c325d5a4f15e011dfeb3f19859e874(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f09c6ecac7f4fc184488019588de387b908d98db110bae987a5e781807ee97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd4fa380b3a2a03f4fab3eacebd520a50255a266fe9af7e5cf045822a4f47747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f831c1b4a25abfb6dcaea97ba1eedb0a8ac7167a598228bd23b1c70454517b8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97019dfdbe8e77ae4f6b8f3c27797c55e7847eebfbf8ff67ce29ed8819eeff2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52dd060fa4d6b85348ba9a25d536a992e553fd0c4988b566662418408081913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8555b29e74c690e658bb85a4ad8151c37a7c16226f1146a825ac2e5b3668ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf82984903c06af45aa9d1f521ea33f572615d1c1aa9432480aa0f73ad4ae2e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b50d4960bffd04b07fd86dbe789427ad4a19a5a123587b0990b9a3df766879(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b78015dfc2cc6c69e217cacbe304ef585b3e8e2e846e3aab302ab7a5f85d5b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__259b781ddc56eebbe056cdf9a8632965732707c2bbdb4ee5aefbc51679264315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66eae480f34166e8ae2d176983fb0e9e430fccd37ccc55755f1c341c483e90d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be56d772be76d3c3c982823fd325aaf19475bf06cf4cd6f5f45dbf55c556595(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd2d32f533f41e51c90bc2854691d7e85d79b4c381e5be0d874fd13b2de0f06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0975172fe2d874c322a298ad253470cd9e045f85ab6a8b84b4a311a4677a05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0683be390bb0603eeae32855938f831855bcd9731e1ee7aeb63eb9e6b093bda9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81bd7541a04a06baa1bfcc1bed9be40e1fdc3eae6068b4f54613233de90db222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa9eba2c5d94af46b7a6cf282a5f153b8a73a3f18acfc1d6274055da2a22987(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0beb4599e5a1e173b91de74c796466be3c27c76bf091eb051c5027457e5c788(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4f5bafa1ae20579c41b8c7c8883747d19d4e1e01e1ce3bdd86d50e7e9803a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8eb33a55c613f0bc85443375a082dbb84028ffe2ea3da492282b49edd5bbc81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a157f6a696ec1dd4bc1d737fe4fecedc8c1adca71ce3231bd5e78e2465439396(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebad15043604645bb7abf78945b7cdcf195d1b84cb786446abf3723b101a8b2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51fdb0aee06e1da82769af0a86403906e71a2550d8ac5aa912b263cc41f96b8c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1025a79fb032ed334f9d72d8970fcc9f0c4749d214f7563c7e05453616e13646(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a84477c1ec0fd1f036c62b6b769066db7709a654c6fa58d89695c4880af9a45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1badb2e0bec5a8425c0875e23d4375aa9b341baaf3119c93104bab9d4b5f3879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed83f9df7f15ba1d820911823e9f410e8e116c76e9dce7d8c3ee739f8a0d39e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc230d5862fc0558dbe323c5dbf5e53d66ef0b7a2f49fce35995650f863e866(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093272db22703b3a15f6b66ffd480220037936ced3eb02a8ef3b49e116533339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9783637db1271d32cadf76ca4f7a2bdd5ef838040afd8c74f812c1038242a1ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904688b0143bf83d6737faa029ec2cd7c68555310b5c46a218d3fe7d34d2f892(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd737d9969e43bbe977d8d588af87c0672daabcc73b5ce1431bb4b339767962f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2762b20e6b25a31bba67c5adedc5b74a41f7e62f6639a97ff7afea13cde090b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac26996813a0ebe2656189771b58a84231011eedbe653be2b8d1d2b7f00e991e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea11a1ba1e805eddf89c93758e7b7b04ec9b565db37575c4ef8c560cc9ee727(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd56e4debd6a1657cbb79aca434d304e4ce8296d5fa92b7b219da2c782a44fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ce0b3702f6661f4722506146de04206a00630128616785e68bd9f1b540f01d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540f5f64465f4c2a497a06b458156702dd372a2d689c9b977e47de44a7711252(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa51af8612e9211f2b885e11a7131227775e9c97818c04c949b425ba5ef392fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0210fa9e95e0098bfddfdfe5bbda4320db3078a2bf13d7f99444f6624559cd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2528c3368ba47305f1312554ed81a23f7977eb63fb1861cfb990f09e92d58e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679b9d1e92b494718aa5fe6d50a334b4b578cf1b3a68947d9b677ca3eabd6cd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e8fbaf3281be135b6aa9a1656f3ff19ed781cf08bed03e8c232c1853179c97e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471e84fd8ed5c936fc47253e6b3637f5a2ab28f81e6f279e1fefaecbb9c09444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02db0b8237a52ba3b8fa2b99c2fdcba8df5a5ee81d5e20c4e01493308c9651d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e8bb996af54cda73c2f3fd0cfb420a44ce51a5326dc7a0dcb4b78bda09b731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e2a91ecfb9880e6f610adf139f0e3580cdcc2a3b8ae749e3f4aa227bc777f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbdf7cf0c3d4945a5d6c1b4b40d28b26f74cbb90ed090fcc33c69c2cc8b77246(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa50ed4910b72a724e08934bb0389841a3c662946f9cd0e8cbdc6c86272b881(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ce72ff3d9a2703a7e47434dd17404abe00e4cc8d43e04b26a074bb50f881ab(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b7d3f28a890252df6ac626542bc1c262bfd9ac63872178178107cd1b176ac9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae38796c4438c774ea3620857671246dc79acdd9882060456b3aa033aec953c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a2e1d9032c066259ec75eb00f7134e6f54239fffc5e7b0c3cb977866e38135(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae5c09b6ae45bd0e44723d5f8e26996f39880ede5539539d8ed5fe006ea7d26b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e079ea412defcaa6917a5c8b274a1fba652bd12c50a78f7ebdb56bacd8214064(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1abb82b168b4132ed16b9c827ec45b07f378e52fc7fd11cc3c62c777c5367e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d25e86d5f7124c8705790316f075a3ffeaab7d29c6af65746187923a1792d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ca6f393156b804a3c1abff62f2395dec0ac4a1ab8261102a2525977b8f06cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1987e94f1d9453485cb6fa8e0235d7194cf33f6d2bda089318fec188b31f5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4320a6c654c854ba3d7de5ff8a39a283bb90dc3bd17ff9ed810e3f260819e99e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5b5b1078eb35d5a356bb6b2493f106c37df300afa5b15998d573f3b17fa660(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27cae2108f636afdc7fe6889cf90f8fa0c50bc7131214d4f41933a2e1804d76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ec28b02c79ae259b08837a602c926f290021d905339de84c50ab0d3d19ae67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f278f10f16fb1aa545463a8e8d41492250fa11070d5d8e21bd0836a31bd42b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e1ca7fb0b4ee15385453448f262c340cffba15a8643945adbd4f0a53ee451d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc33aaf5bc70c56131f26e3c930d32f8286add9db1bee9b84cfad3febb93218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61656ecec82e54a3d4238b725a03757944e63c9706a4065486f500028f5b05c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eae1f5b426c36692ddf63ea333e886ada5e507ba60ca709daf569d80e5620ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3980db62a71b0f5dd6f6b543d55675d09fe15698a9e022e58af0aad6e012142(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850377aba1ed36b5a80536e9b39f41ed129985aa15412cd30833aa42b384fd66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739a3ea245791f90c9c05fb33ac906c707ca20383898354cd6cae5b7aa9bb31d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca0ac85b27b41296a5f227131a57e0a8e86b54d752be0a936c2168718e44362(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef196bdef871e8919b6efe356d16d036f26769a9b1c62343e7a8f185dc59518(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26639d9d02a49f923377c911dd7cd3e722876501f5f856ad99fd2c2ab84c2bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f027eabe6b34aa34f4a287ecf9d959b6733534c377b55f81c9be1c0d143646(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72bac1ce984bfdb83c8d88051336681f3f059d75b2a80615dca18181d6e43fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae01105ca2c967cd58af1e68abb64b26d3a69ff543df2c1920dbed6168e102b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9475c9849044d27da58888bc2ce243169eb8049523366725086bcc1705195ad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f482b51361e96e98505093d2f9246d9d68bdf1aaea4a9894d162161229c06ac8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815cf5a3f84dae48f01bd1a1f39ffc00f224b238a61925791f17cd61ab60869c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e631af7afedaac55f9ef71f0eae12948322470097a5eb157ac5f871014984024(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8af83e45900f9e6f9ac8f3a12379680705d89ab321df6e25235393bb66369d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d49aee230aca26f21d25d9ce8ae08c22d58cfedddec9e0bf955c7e6b44d04e7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c46ef2bbb9859833ca6319d0cd71b4da310c879f400814f8e5f61703a1631f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3294dcbb813f79120ed2ba5d9e35fb3db6c472bf0dfa775c6ba60a1e01074c94(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48faf5dcb5069fdd35cfb7b1895da0c794aa460d8c3edca7f38bb2155c9b3f7d(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e6ddfd22b91fab44c1851fc1100540a1aa1d6c3b0ebfa9c95430c40c456edb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558c18790756a30ec42abca303ffdc51a17a0848d64a933ccd04e07b13df792c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e2fc4156f200db6c6be8445f5d253520b8bedc63cb59eae4d58534076a3a141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96e2753778f660008842245a70a41cef1d7a7ac0beb9bd514f8aa07d72a7556(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd59375cc60f48592d73f9757b9113341a17a4f3399ff7650b76cd81e13a3ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f961db30654a9b9ac71745ad23ac6417bf6b536804681985796ee74378d54b09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0feeed0f6fba71f546227b4119abd4b0d9075aef49c59232d65af1008ce5a46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc9c28f4dab19cc32e17bcbb084b62a09b12c98ae64ac70a1cfc11e6311df42(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1624e1a8992e993b09c649c4bf468a1ac30f6fcc042f898db189c768b6ec347e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903044201a8b50f6c8928b7ac51cb8f20ecfa5d2e6fd9c5aebcb28450a1c0480(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587b34aa22f2a2c8bb889e0856a3a2b6650aff7b73f81baf6eb73bb73eaee356(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e660f8273517295d2e57ffc708d4fea38e6f151d2344d1c02c8ef3a372c7cebe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f33b8450f5c70b73b42757d030d3e6bb3a1a222d4c41b2ada7343d367838f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67b2ca43d175368b2429160575787a37f0333ebd4c858d8f96e5fab2f7a0c44a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef4af94b55679a826d0279bdad3bf35384c322f3b1f80de899d892ca6ec6fa1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e786f63ed1e1399a0f08cbaf0e91304024e764f336e2773f4371acd5ed292a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02823035a332c2082cb8ebfc4e253ff12362921fd3ae52786a4f66c04f8a7f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b3bf062d60a8c64328e86b2f25f5f796d1e6b0e7e5eff93742bf23a4612f8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c3c7f782207751ec5e29e2e84c31202220e1ab26b02a76b708d131c75691f61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec7eb81c0064a3bf1f2a4bdf9c074610cbec428915696769e981076490e8d1b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388c6ac80137194e7666274d89d987f6132e544e9ba4343e1d17efbd0a95fc65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abf4f7effcbbef8882c55c165ee35c752434a7c1b923812c3bd09234554db80(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33bc26ad65db1cb60a38aed1ab327da55bbe296b7fe448c3d408f38668800b96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8262cfb06c9a66dbecbad706fa5522ce45f69274e8ce7fc62c03a770547313e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2740c08fcdd9b4c6f330db2a40d3d2203599f3a1655b9977fdf792fd1693855f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9b77f8a727aa73b03fe29baf46c33a3726640cba83e52b23ab95b3b2c71ad3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9f6a15c664ebac842d51971de6a8664b9a63a0f08d71f29b24b9265f2cf728(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263793fdf137e780a2bbb5e8db07c79b064feceb1cecd728df9067e4def8b510(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14daba4d2e169619bbe03c4b30900bf8867666f2d6694ae9b8e9229cc8c3a9f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee96df8a19d8ed1fab6a2eeff641faffd47f3db9aa47f39f5738d0b850b229ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f539a6e3e110fb1a28558ff0e5ff59d0e4dface8ba14abf7bb4ad0ba714adaa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__967a783205b4bbbb968d7eb4ee81712cb2f196f0faa7abc44bd78c5f43d7689d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fafb50efa46b38a0e43773101299558172da055a3ecea7f632e8d9704416da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55446020547f99b3f164e31becd21710c2098236fbdf2228056218e6d33e2ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2cd4d01bbff009c38859e78263e88a15f2fbb1812c39d44efa1a19abf4998e6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a491601ce398146b9308a86d8735766e4a897a9f59f5feaebd2320a180cbb28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265b23dffba9d987cad165c33ae597b818314c8f57908cc55d21af80716a5199(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893d0028bae586d644dbdefd10cd4c5544c2e569ff01bd6d326ff9a4aa7d0c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89e3dadfe1c36f2af292f80aa6d47ee1e99e2e48403b1ea425d4391d4b6ce3a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804f9d65b0d761a744ebd460716b98bb6e308b710da6db28c60e232518988510(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa79d3c16cf37e06d677722a2c9192880a39d3630fba9a202f1f32471244d2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa7d49a332416641ce14b504fd21fe95a7660bf5ad1ce2bef1e9741747149bd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29ccc117807d5f918c625062e6384622d1e605f78ef41a04f2184ac6d052b95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d87ccf570dcd55f13df4aed549e3391891bfa0e9bcb6cb1df2622a8aed191c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4072ee920a7e8d78a7c396862edbcede2274e4f515f49ae89807289bad3ee7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577920a34ee654cd225061aeabad32ec5c57372f695ec270b91b9e62ec6bf349(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99f355919144826c60cafebd86563cdd90b3a664ac38ba2f456cc9a1326fcf15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fef8295eb92aa0e27590b1a6b4791ad99175f825158a527f72b44e6f5354d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b0e3f974361181f5511b09e92546f14aed0577c0746572a394d190d736db28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7f0a69a6f15d4403fccc8455a32dfaaa1f71490525901ab4b6a090f610d76b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b183c9057531c7f97bb1732ae7abb98937f96066e83731f9276d57778ad1dd64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b56a79292634505af44d23f4a08757235dd064b14b9786f569acfcb2d304b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f27f999f1e5f790110ed89b1b496c84e567df5c4876d4b2674b08ff6ad9efe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58dd44cf391fdc908870763b3c2d783b520054b4b829ccc8b6f186a67baa65ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7185f6cfc2aa4e814978c2c9cc64a6970f14f2e6c4215a1e1250978abcdf3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa4cde12bc4392ed7c18327e136d7129d34a420c89eb3b9656f448dabd1eceb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c427a56d71755925ac720b12471fe2ab5615213f4c7461be89a5d430b797a0e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e094b64b42338df6f511f72b9d0fbc0d856ac4788c29a745b02c63929289f0e6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458bd9607c30db97ad77208b41cd8c4d9ef5cbd3dcabf0a2b5445312f052d52d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8bb08bdc86e088a4b037042b7cb9dc332b922b3d3b9276322b27d85d99f2f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edac6f1e7238f84a1cc578abf17bf0a9281a6f2cf104a34f5b2953e07c38fcb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d858c27e9452bd2808f71eaa07c478aa20c1c47660479a57dd85d51dfc7b5826(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98fe7224d2ce87fff13aa545b2f470093ca380e7b8ec2b87ade71c240e393356(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb7385b818aceec6d92c54b35edac0f7c1f4e5eff395a3702c203588b757141(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3125f0a2af02a3998494a51af590bf0fbfbc0be63892aba7a58bd927e7e4d7fe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a5b901195cc9120fd71eed58362dae615d786e114e3b966fd397055e9a1499(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d2d7b4846649eeb3b6208df88ab315271979646505bdaeb2c92f8dcd021ab6e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305fe647e1471c7e773d5ec2dfe4f81ffefdc019d42cb60cea1beb3425fff23d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c01c99c8af83668384e3d87b5e17e4eb898b4d18b23eeb399c195c73b824e53(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d508ba113569183fb98f4e4e0f277411b5406c26228dbe66f3758955bfc8057b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83db96f3da729d261ee5ecf46af9e9dda5e9215d20a80072fa728456cfb6ee41(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835e8032b0d547b0b7294b60d95e4c651bdb84b8825fab99ce0ff2e96213ffce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b12f886ec6fa1c56b81d029916339fb66eadda8b42db134a3b068083ef19ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef776352b09701e5102240a2b21e70881391a1c0c9172d29e70cef81b9e9fc37(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb0cf452742664e5f3831806115bff6239dd72bbddf41db809ec6138747a4d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca1158020acb6ad136be7d45e95270e78b2ea90e1c36f42a45337e05b16a270(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84dfb10ac7ec61155b092a627362201df62fbff7294ae46fe5cbd6fe69a534fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b10069a6de90595fbfb50c3b7117182b1f7b0094d3af380ece2a5bd3b5b8b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838e839118de0637f153570ade500ea628782fcdc7d17505ee50a1db3010019e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a949e581b0c1a757819fdda228fab6c446389d8789146e1a62c5afb5f1f25ac3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e794c9b23245c8f182b8db3722a1bbd22e1e26ff6a7756c8a1e685be989dbde(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2facc8fc1b3edb3fdc3be1f5cf8aafca71793e3848827d03e8697998d70ac90d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de71eb9bdadcf9eb8000b36dbece64e479fc947201d13fa7b38828502d1ae5a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5ca93e9753a66bb562e371ef9612a2f02934e3969cef1d61ec28f3dbadedf8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2987cb90fc9c9dcecf9f4a209c47d972b700b933c0337402cc0f3694974a142(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad724bd3f52e718f4864c27f9e327d50adae68139b0db7e0879df873205728a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8be509c02d2ef7fadac4801ed87ceb71155553959b14a99d459d12451fa8d1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ba9f540dcaa5d05b37f64f68d59bb696c2336fd19e9896e75f72dddb8e5b96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f2fe953fa40dc49c12ca34fbd836e92ce38086897649fc1b6f189b645a74ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9306efc7fc737bad4307aa04849a8f13e9d426dc0b0f88ba4c3829bb4bf6667d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73edb4eb3065736b4bd7cb4dabf596a3b24b706aa904060251d9db43b514ddb2(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7c119c9b2b5ae5d097d6b878bd57444315e4bf8ab6a2aa69d320d548ae4745(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f658da4d449bfcec835c06da619e1142404701b33de89b55ef55773adc5dc1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7ea9d7cdd84922d1c0e38a855c02deb3fd3bb8af98989345dfd2281f5fd06c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3a23c2c7a803d81633fae4cc0aa5c3ddf73eb991695d7405c83c4e0ee1ec0b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ddf055b5876c486502067e6aef572e0f845f3d13b0a5b6d11d4f2c3787a3b05(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46fac3ebe459e2025bde347bf1aba7efdd15495232affad7a64b9731394d60d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258d309f5634d0ceb71e5d52f0ad5f0fea8ab17edcc59b921a3b1b6bf8963a79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750aff8e498faccee7ea3dbf7c87f6655ad4b5164a1c5feb305440702062c6df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b720544fd3d5f02266ecc966c077d1e9ac9899cf850531ac4e0d94afab726f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc69a5a78828489b17c34cb127329e616bb056f54edc660a16e29fb8304a5fa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c37aa9035e804b01a63a7253841af2f51eda99452f5657819fd728a625c7d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1464bd20f3487c14cc1e03d4bc64552bbf911b1b0cdb8aa46a5a8a0b2f3c42bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbbdb03c392edc0c8b780b00c45dfe6c92b2f3bd6438e3a1102c778686df698(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d817b11b5274b0b291416b0d760576ad45c306b558dc0ba2ffa440724c66b478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8efbc5438d87cc381719f463aa010e3639714e29c9910793e2e6ff952219573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014160ccd82fe65f30d4402ce1955a32ac381ad4a9a4830639ee13c6140ca060(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764604ed249f609f2ff2d6fa6ea08e29578518c831744d1700ae85c4bccf0bba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f37485035ce36f6dc1fb675e7910b1de0e6f4913031793498bec2bb67e6ba80(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50e38185f4e8cf7ba78e9ea2647b37f6722b8ce7425e7645dc7b5b5af706a03(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661036f399b522c789f34d941c96f49fe22426f061ecaf1dff0918235679cdc8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46a79840b9124f6bb9720200311c241b0c461c46c315d4f28b777522a5033cec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00996f6c28e5d30c4f06c3e29eeb465825b2e429bd95c67b11bfaea0e528372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb76c4e547897288f2da565b6ad77968f49f39aa68a901d1c35a119b584b6930(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98734545e601b3087c71ecd0a3783c166c9709546bf1f0b09c7398e79621ec1b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7bc91adbc00abdae81afe9e5e92503994b4d3131f90eff991b2517edc203aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08cc81efa5246b14c2480e25e17650f6bb54e5c1c28096897eed95cb4513f156(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88dab37671e93af2fc85120e1451426bf5d63718efc27b2e733b03198218030c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33153cc79380b53f1502abd9b92d28781a2fbc0d8444636361c158a93c5d4e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef85e8b63979b60aca889da7014c825e497624f04911263265b0677d77c7133d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5fcdb52ad4e452aaede10ac0cfb4ac58f0f92e6e1fb1e1ffbc92df60f07908(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2bea06c3259047518e2cdd3d10cb21d516446fa993dcaf3b8f41a46e1f18399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8fbfc36a36fa9f114c34ac3acf1535122e5a168682dbfb9bda86cb3c3b9d2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d51b0c77a94779970db5fddef79503fe7ed95d2548e0df85dce46628be1ad32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d1e827c9930377e2dcf7e25803633f113441d1bfb3cc49c6121efc9932bbfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02bc2960c738ca9e2f52b12667e08a18294806d963060b2e10be10f960af8e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff90d35eefd0cbc95d9e1cdaaccae3efc5682833fbd8bfe69c413508c72d688(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dcb0be43478af03a5b0da9fe79952671b6c48ef74f39eb1dde44fc547c4005c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b5db311bf6d33c0fe69a8db3bf94995422d00fa767851ac9072235ab6ac517(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43b4a5ca758e7ed65525fd8c619981d89196c893a1edb65ba96120b98e0c505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c610a50cfd7529381b52bd097fa8afe4695d52ba10208d5dd24ff0ab61b4e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b66c65091374e7840c058c3aec9e60af526b46458134c7243d583e900e372b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3bf44e359a2ea60fa473b7e97b29981189520d9c16ecd231e132f899ac33ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b004bcfc1913f681cd1a80a76ee601e02e29bb1e6e3a252b2115f4259a542583(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36960863c9d299e6269fdf15f6f81dcabed9d9cb34563e6e98b83c75c655283e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca8746b3155e4182ce94a34dfaece38b42c873c60d9d62b876981eff46a5fab9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b4c584035b3fb2dd8aef29330ef6a044542676eb11fa8f28f66518467e6449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44ca01042b9b4c1ff86f482943cdedcea9b19acb502ef6e974b0d9eaf4c24cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d00dd458fe9e7d4f581c5d56e07b4ed5585ed423e7b884757f5f2139210e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5a0e6aafc853664e50b2217eea975ce61025d774c73b3d3bb79b6a82c507a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111a3707707b590c627c3156471d095431b2cd7299461b2459fe77f3e56508e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8580ffa731db0b4db58e8d09b87cfb9985d2f3e32873bd53c01e6dd4ebef2f40(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38112cdfd26ecd84996b993334ab97a202731c21969607414ecd630c0c6b6cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb95b69e8f6772a5c5bb7bf48feb10d587448820d649b82d8e46c6210989bf8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec46239a7f5b04a49e31ef90e635f108eb7c06037bb8946598dd2b801c0cf18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3729497f7af15bdc9bc04821ee520f90f023de39ba86c910e07d27509ffb0f5b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e1a6f12a32dc13ddfb932150bba8cdeea7902ed6fac39cc5fb758cdfbe18ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5cf46ebe35373a9146aae5d0240de089549ee5a3a3082dc40b05ce2c9e9f64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abf25ae43647ac249fc9c576687360cca9f0423463ebeb69335351b30c5a6c7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec1118e162e03dba283da3a3ef26a4a5741539052255bbf9796ac2f6b12a848(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b910689fd3d7ae0bd19202952dd83cc0d520b621e8cd1b80e75b10c7122644c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f290482ebac34379593f8d0a7478a45725f1d68d8848deac44ad4f1899c9a114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d80e70c38b38b234bf93b3a4f306410588f363f34f77448d11fcb518f53cea9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4506578b62ebdab1921a10fb79025a96fc26c93d93ce7408e399e70fde9c72dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c494d5942c37b2fbe40e0e8d501b4557c8c400e1bdce42d3ec4de2fd5090cafd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721a4a0f8ee7da737328ccd93829636da64ce782107ecd101a766fd8895330d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0f2e4ae8b95a734c8775b1a3540f9c8c66e61f49303f911a643a6ecb3ba18a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51fe85729d3511417325aaf85e165e8e8df28c65449511b49a548fcb12d18d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63856cb6f65a036aebc7e326cada02320482b78459361dcd6b380c8b4b5ce29f(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac07855cccfc0f22a6c49b3c702fcde0ecf1adba5b7558a9f7e2ee05969ac2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__314ca85b8f3f212fc61796013f67a90b242a860ac15500509032681b0851a9da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a259338b75ef229affb7793805c847a090410f14596e9ecc16e69523067a42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b364816949120d753d9672d71efb70491da8fb8b232fae71ff8a63d0e1ecd664(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea91b3665c9ba888358b600fec76e87be9df42cb5279803e475d8bf3858a749b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ec5e47658bdbc80b866effb1fed056ebe7b23b819917f23acbe3fced0dfc30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d355275b5a7f026538e847fa1c134ded9c636f25d7d9d483c240e83bebc202a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446021511af5725066374b9bedaa7fd8d7f4a3bbf33c96546e84d7cdd398375e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b16faec677d80a2ae470204d6b487fcc79df640d92b57acc7ab0eff3d11cb2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa0a447d0569e0e2347d08502843d07eae9bd21d2af8076fe5a33eec086d38f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc911677e8dda343fed5d530a80cb93f1f16286316da6763ec8d0fe604fe9654(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e9df8b99a6c7a337cc6a440dc61ef25512e6d66ec7ad498a4800eb796f3df6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8fd4418bb3a6ff24ddbd9aba3d7e83de590618307e3dbd21ba3fef9edc97a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c4daea007dab9a02b9101d2ffed9ad434fcb126337dea207c44f3c8f4fb6eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d5687b33104c3b77d418956cb40f476720911116a91a96db25ab9109acfa07(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e52e3dfda53637e35f8b26e9f0b1e9ed19f99d2c62e5ff8cd866aaa451953d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677b40136dd3bcd47e20b988171cb45223ac3fbf030a09f6169226d1918881d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7171d6472f4c1b3d6c7c64c9106b77384103ddb3eecc4897a4952d117d92c0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e771a0a6abc3a4abf2cf5e4bca85e656d1f0e6191327782dcd909c07a4f4df44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c5a49d8a995ffc59a1aaed56d9eab46299434941fcbe2ce3455e64c69d86edd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94d29282c7f53a2afbc47528e20b43880c20e20ca7f9d1caeba2d470d6d301f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a7d140ed38d8ebad762ccdd5eb0d6529399ed6b61747b42e4ae95402b4b2b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05be615b5e0864a6cfda88c170a418d8b1700c1fe878fcc4d9eacf13de512c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e838c170005f5dd521bffc5e15a09adc497a9f1e2f5b6d2e727993b17774a9(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3607e6610e38f492b2b6a452a993637d58e296eb1dade72bd14609a0fe2ae3ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0125035a56addfa5b70cb77b2ce9e9ede8220465607f2c089e86e814a5e8ff6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b6a58ceeccc04619c78f11079a461f9879e622c6073f12ab55065c61b555318(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e62c25c6257f06138c210293696e5dc3139e18431238ba60782a4fbeed7acb3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1f586a72e0c65023f53655cf21b6c7f9cd306b1f885380ed9a512c1d6c366e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf9b25d60923cd398d64cd00dbce0ddda0b91c06d558a69b4d7259f42b096e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c3307ee19db7763b4fe7be21803e2a3b9187c9b564c9a0e7ee3334f0721c58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9537d91dbb3ea4d9f0824e96fcb6cad599597f0b13b2379f15167f56d903acc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f15bcd998c153127a770834a38d7a15e7c4be17490ab7a5f623ca4b4fac7653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd71b5c7746431871a0da300523e25f8add973fec02e222932eb9f9dafe0a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f964232957690af1bd2abe89028dac66aabbd99fa79367a484738bea80b7477(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749a718d668f54a952f1fa63fe1b0612b6cdd9dd76153c1b01be7de9106b1904(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b7dfe7881244062b2b14c21bd8bf41a1f02c95fd6093b652d4b86ddf7ef5d1(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__668ac9c0fcbe2d730f8927fa013f236ce7452e8561eb960ef6e5a78b579d74b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355183e941629b2dc8be6a3157cffefddf3e86b70115b3b58da2782d02f68641(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af01249a96fadf48d50cfee13270011f57ce88e5b1f4ff3ca8d9a09534a5232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936b0777bc0de8831534392da54518854a92163b89a02d97c50387e3d02a35f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1556b1f552777f1e8d3b40ebaf9680d5feeadafab252d91894ef918952094fe4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9a957949047994a5039ada1b06f7f033b0fccc8ba8decfba003f5364c18c62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94218dd8c54de2e70a1b85a6a1b3103a6c2bd9651990ee02abd2ba94754e00c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2fddc6177ee6a5da9e4b09abd7935f4ec56739208a167018d0a5e781d976d6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f122c5c001d8f0f8ce1af8f158ef0e840f3420a8ad7b047d3d8cf3c6a5214a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145ce504573c81e44dd204a4a01adb43d744a4eb4623ced34f7b0072271d3546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e0dada7e89775091915330f5248079d3ef5aa823f644b631e3599d5667152e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041d4ea0298df323e1eb1c4c59af39f457b6a8e2765bf715f97a87b5427b8cca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0abfcc2ce717b66835d1ff07b9b97a2331003bf6fe353e8a2cfa43e4490cb4c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__641dc53d3e06c006dbc4bc7c350595f647b1211c3ee0bd46fee16dcb7093399d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c43cfd410d08fa68b7a90be26399721b949364a6bc2130868a062242db49d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee754d3aacaf0aa0c23e0dc0925e5c9802bf6b8bb363e0094998efa654cd93d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f0b8e5d1877e12aea676ead2824a696611f197a526e876f41e2280d30b571f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f08bf03f16ba9d4c1fff247eacb3dcd459b7ea333da7e3452db50dbfb19a4d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9179c8e944b2708d80bdf1dbce43d2e50a6d1fe5ffbfaf612f6491872049727c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c16418f8e07fd1aef13110eceda9d892e00816d31eb2e09e20db1376c22050f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84948324689e8ff7e6a4f53986fc43d502b0e40f63919d232dd3276704c1ed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46cbc0c736c7b0ee792cdc491d0dfcd56a5c86ca57bc285d1f6885d971c753a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050f0d080a4c65960484d329d795bb392b36484fc5b47ebaa97c06fa1f5a512e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb55cb80884f1e7e6ead1b9649e27be0a1fcc8bb38e403264eacb4e9bbb7e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baac8163f4bdaf572ee8e9272e6d21fcd41526e842fb1f67a60460dffe4e4bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871fe16ffe126aa56e405e121eaa8681a3c3b9e7a521f6af3339b7fe70dd129b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2abf4983e98124554f786171a30a5702827f4893d9df3ce2a2c1d32d459ff51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1b894d51fd9a6f1064b10b2a75d3074f2170f9020bd30a24feb78dd5bff171(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__349d9d703adcab4218daa8bab91f47619d0dca49f27e40d66e3c4d5f6f8215af(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb9447162504350035e7499f3c9dc397c62c76297b8d79c29cb3142cb0dc176(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56154ecbd724e721b883c887c408b45550d9f9094d683916fc090b93a590956a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af6a9087a07eadb7ecb04fcc8c46e80898e5de8ff1afcc34e396c3576a460962(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc3c16a45958bf8ca9365a6840b6083814a074ed58bf43825295cd479ad8853(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb48ecb0d184840bb99deef978dd299d135d0cd868b0382be19c1047c4cf411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f50439bd3ba725b0394583fb118e539b82b54eb91d6cc54465aad613f6bced(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b38daa917eb3230b6dfaaf607ad10594e4e41c028987795e8703a5feacd09f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01517631ac9b74c5971e63c18eac310e035b72dd285a3f0076bf79f4a10372dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb40b853318c04b62a9c5ca4d02f386e297a1a8d14c55fbf09adc0eadcec230(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ee135cfcaa7216438d2f33aab38541aeebf3fc56d048c4597855b06dd322ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8598bcefa1578a09808b6749e035aceef96fd75f3a4b48850f6ed5181523333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d424ef47e38b76d66f0687db7b4bdc477ee4aa89dec6914530d55211612f04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c184f95f0c869c040df684c279d81fba224d80177550a3029234aecd7500ca16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5d720eb2774538e05b44453a195c16807fd1dce9aa2faf2216dc3420a7168d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c32129690d34b2456268cffc75ff1d297d0e6fb5ebb74ff0644d22c21c7a068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f228af7d7655926e575dc8e179855324358806d2e7c37c28fb27ac56621ac0b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f37e040ba6aa0c684e02a9433c649f52dcb0f65841c10df3d48c3605de8de6(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6febb6637577d2e295a2ec8e39959f04acff6997fffc766b729c1b9337030ca9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71824b1583753ff56474ca9dc06c4c188faf08eff15a03e79456e74d6d65283a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84045afb898ab213ffcabcb13703c19ba292b8f485b1f2fefe3dddbd6008bb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac75ba74d5db95ddde70963f521486ee5519dd15bf7e66aca9e7b076133e815(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af138da74a503d9795f52c2d3caa56fd9c6f81b6047634f28b5f85406a8da446(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b7ce64d2180a4b36b0993da54d1237004ab0beaaaf60b555a86426032536608(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2001dc3a3c7edaa944927c0529993de7561a5009f6f09fc132874163ecc99df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76621e38a0ec13235ae996c80f4a4524ca179854837591b0a91da5a08b494826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118c74507f30ae60bf3c02de170fd6cf873745211ecd97b694a3d681059e46c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54e9f3cfb4a304fb4418f13a249ea95beb4937b13b0187f2ef35bf6996c814b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ea7f258ed992803ccefdf290b31aa7e704360f68d2a97aa6271ee3d426f7d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378b3e765171de2608451b4b1732f80d196c13aeea8104587a162d290639129e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f2825be9b8c0cf411b5a6030441c43c9a38067abaeb3aefd623c4f956863d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897980bc83188e27d8d911ae75b386d800607e36aec3a541e7b9b0128566d2e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90673c99b073ea7473817c61e2af7c1ff6435a4ab7c5c9f7b716113c27dbdce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9744de641189b0e2a817f104d773b4710bb04311ee056c199422601d15d4d5c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d8a00414231ab94d63ed32b47c0b21c35d0f6c3a89088c1ded66f8cb156476b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c89d4655e3e23c070f5281671e7d6961acb04a3f7525baf378b1f606d2011375(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c29bf9700f389381d093c70296f71a0fa1a99b14c2f3721d6222afa3064fc9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623fb4ba17537eb43c8a7bd770d24030b586d62eebc3b0720ba290719eb5ad20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303b21a77e3521844ad14783c4448fa1c4ea5a3b7da84b91ec0f0e1efc3fafc0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3f14b3e3f536406d6da08dce0dc2fa1d031a601b8b4e3e1fb3cd3ee1261bfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b52393106e4925c08eb5c811397f0a86229cba5fd0cd7a7b992fab1f557fa3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1bccf747f5edb57aa4d770423e65249fd45c3b4e3636c0b02484418ff31dee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b064a703ec0fa0a4a8ffd315d1d5d6319d1b5405c8df7e106cafb4070ca3c9d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68779c0c08a5f754a0a11e3748bb5df6903b7877173e449bf7cf1f888d89e5c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc40c9171737bb72d3b800f9bd33edbb4d295d5b3ee0136512149fde64047ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea797b46e9e9a5c8ebd45f458afd277ae820453dd0f31042eec81faee5ddd2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c983e9a2d7af686f3ed3d4cb6b905e597ccbc35be2c8d6bc6dac26c2cdd8eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8d56026d23e2d24a7b5928bc39b5f75c0d4bdba6f2f662a0c09b1bf07255be(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb1ae6e1eb22603d824c38cc281f1813130d527b1e6ceb5cac742e3c45c2f46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97e64d25b0298a2d7017db2c7b5456e3096ea102cebb43e6e18b66a6801e7bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff46aaf03ac1f5a9a185c1b3859952e049b839130b80c129a9d0764429923d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d879bd64d48b469c7a9b966b6671c6149e8a3dacd5b9d9141cced9293b826107(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b3a72559b414a2426f1164b50455d0aeaa118e26b3cacb518e90402fd33e12(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa5da4a3581f3fc92e9f1a59ff7b0ad9ef4fb63b9d01e229eedb96252fcf8f99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efec8c18ef92a3ab6f27cd175b8c6b82851368c83f2ffbadc4d8c5aa9e7a822(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec27ce40b05ce4bfaf300fe15488a695dba2adaf64c29f310b6f2a423be08561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e944ab7ed625e47511f815b917d7a1dfc983da5a13a2b03a90c11cad82c8ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29edcb09f308069447973de8aaf0dc0ed08ee65cf117850887ff26d8d1da9d46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30361e351bd103e4c3adb80a7fd061c6aeccf291a2f160658eadb3520899536(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ad209ef3506300013878107d26432e3324465f5beeea23d2796a420a60fb77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e35f5ee8c7f1de377475c1464dee874e9657000db53e58a5b00d6f66c6c28f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d216526796f6cf1b7794fbf97bc7fe5d51eefc2f6e933a27da479a7dac6f1572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d735710720bf3258e3ad5f670948801c119aba4cfc4360863c612ac6601e8b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b138eac3d7d4f4e2186e98d9ff4fe1de9a6a2ae4df902aff376385149a9c4b1d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d9dd028d800222df898395038d7450643e97ae1e7a94b29fffad1be99b544b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd13b2a03aa426e8d1920c6895eda0df5eb2b40fdd5b9c9d88575fab78275817(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c41b72ee6f62ad02c3bfd28f4b4c03b227207bbb9b849830d308fe041226ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb4faf038c5aea0b241c81bebf62952fc5f6b783dab8162f1f57249bc3f92c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a287651b6c926d7a1c81f7ecba2067b3abb922dd49967e8cc7ba3538d25181(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd9d4768e7795d121fbbe6fc6bcb60a10819b1ae32cf31a5f6bd0dca56dec68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625e97d4a33c17095f457bab9d1749537ed252871f2ed51773f25eaf935ab5d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ef806a1ca86573e2f2926cfdd6d3fdc78ca75149d211282f6a4c9aa5f3944a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163a4fb56f3375dc65ce825f31db61aee3f0c4c5a255e1fd603726af799d8027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43a5ef5bfecea058302c9c6ebe2dbe1de7d44a15d96d47c5df2d55949f121ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7dadbced295bd48dfdb3e77d840e9f8f614c808f8078ad309a115f9ee78ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c2979a08bdefddead69bb3629fb00d18ef71e9616c78c904309ff781838edf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b2d808cb7bd091932fc7e9442da717659289d42ae6b26e8b966ae95abb9180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab74d6fe36e9f97c6d1beb7b6695f44db478fc295a6fd67faa49a4f2e39c671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7ce049b8de72047d0315400746bb04d317c78852a3b1cfecdce6f745b146ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88ec69fa03a2d070a9bccc826a21d1ecf07f0e6e8d23dc98bc42b8ce6426a10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e46e2d26d8a2a01b30ff6259c37f291e6607780b47f3e912555c790add103e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904d6c3b6a6fb89d0e6ea76a56bacad419c836d2ddbd0136f40fb618c9a1c50f(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1ae2d478b5d62ec5460763a62b737fa26c7f91b54b74e655c79b0331f6b5ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985b1215b220393b3abfb23d34ffcf18209af4c59ae824a1aa3bcac6670cc44e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__798f3f04df25250690ae6700a6ab14432e21c31fe4e5b3196a300976e9ddb75f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88d39cec6cb43ae7a7cb789fcd74111ec30c07d3f0ef6189a8d18a6f654c131(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e432c5c374b6d9e14b34469ee492cde6bed2cb4dca682aabfed960bfe36d6d48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe33f1eb9dbf2ef870635b7effb04dbee63a630d4ab1a75149d1d2b1b07d3fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5e077a44adc80aa208728e74aee0ef9a7eda11a9f54a6022af9c584b55e492(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af7ab81f1a1ccb435b7681f5452ac8086fad67df94b87d72869ac89f682adc7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749892954b4c1233f5ba4f83170ebd76331171faa96e633a225e784ec1b43e5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b96370137a59380e14cf6d719067cf82edfa994d9640ccad4990a2b3966ed2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf9769670ccddb5f1554c7b71fabc6a6a624bfebd223a600f7b488be0badece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68aa8e90c6af33e631b9e650fd7e176a4ec8cf4bae377eb74dd383e96529f3e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9131e86afa8adb6be50573b938ad5d044985f9fc47a0f304fcca49d8122e57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c998bd6e3d86e9022e84c4e52714f12729c28f3c14c30bb65ed7c54068a065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3fa7cd7a9fda50287c13f029e2c7a2f82b0cd4788136d5e135055e0a704260d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a4350b0aa6bc5dee0b9731e929f4ae770f5bbf2517d12e46c0c4e68bc20da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9cb5f89887607598084898dfabc1c73b5db17ecb8b58553ffd804d279f31054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e746206efdb97fc8d24d02ccd7b901213d2bea83e0b003b358454b33d02b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170b032d70dc6279cbc542874d481e0b9a6afc9a1315d920558f771a8fcce715(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b36ded035c9fa1b549ce58a6e9c897e2e6a98d7ee564bf81c40f992267a90bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7360a731906a41a756ad8d5791329a7092f055d6a313c649e6ca395e6b88fdaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f6fc3bf5427090dc9c761bd4edf902679c872ab5eca0838b9269880f7fddf8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e321e12f5be7fb1228c09f53c48ba6f1005e7f25ae9c239f699a82a469a19d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a14b0d186dd992aad6468643539b246acb7a3d768c38c1c9582a521c0c71043b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6a6b0a5e9c21c33992eb88552b99f628b845702dbebf2f47df52446c8a48e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bca1aec467f609e8345eb0b9012d8a740f0d25c13994695762e217a14fb9622(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d38c42ce99f6457575fc9225a14bb6db0c423a768a3818e72a90f0ba36e862(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b6ab1ec766baf18602598c77eb9f373dc3391f5d4800d4d1ce71e8b220cd3d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb186fe48636d076efc126e9af392cdb1666940fa60173471e9c133e855baeb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f85b6982509e16fc574bd76e4cc8d14d798fd78b2a2a3aa839730d1e948d8915(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1f1506325a9a730b8f715e2bcb5e13c2da38ad10f0d2fc792318a79e0dea97(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ddb27d50ac9f103aa096b83f14a02e3f8c7ff096dc378a5b08df9d0f465f94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d50aa079ec40af534ebcd35ea415a5eb46f8ded13aef0a61a658408962b0ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131117adc4a1c4d5fd485e858e6d4b4578d1f800ad061589c91892e8980df286(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c723de3206a5846f8b03db336fe11470c44889bf35fec282f0c03cda5a37bec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a1e4765738c38608e265dfa971d85c88b893d54d952c1982fa944a78f8c440(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf16852d7ef792b9a3e099c904b17d6eb0d77329ab348904b75a5cdf952d1a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6963052e57ae218b8850501e26473e60c809becbe10489e317e2c8b0d61dc740(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13baa64ab92060544e96ac25255c09481541feb6c841ec88c5d875aeff12bf09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d0e74ebb7b12ab25aa960921b2abf489fe4a901d30f92100573335e94abb6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67639a3a1411f354789fcfc6c68800dfa2dc44d74d6b7d3e75c6362e14ecb947(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b016357a063809c38377acf2334aa8a792d160d6b1add16b29836988b66440bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb881fa6862d1c323d02d7449d37108ee8f496f4d5e7388e7d4968ea737b01f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd652cd01b3437cc8fad3dcc589ab672cf545abf303cf84395ddb1aa83ee8cac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7f39f1688f8406656bfd208d9767f9754bdc7cf3a45b8c960c428183b457e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38633c4026cd3d258b7322ad363dc48453f85cf8be96cae7b1699b673fd2c09b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f776b2e8ba6ad35f5608cddc7369b7e7930eccdbfd690bceb7dc152d4f8728(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294c55bba246f5a307ea15ddf0df5a2d77716a73a97226e5febd040790dbb511(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e35aabd2285bb4d7d797cfde89e3f0ae8cb1208567a0ee8afb90c5637979066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__165d03ab4bf96d440e0388d6a83632609b9ff269f39108227dd1ec349df29ca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99fff2be6f5a4d9568d3cb613358ee1a521c6aabdb884b272ad6ee7474873268(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535992be2013cf77de8f0778fb491929d473ddeb47038ddad02428cd24e8cde8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5260874d58c0b2d4b5dd9bce30c5f58921c45264686b0293251fd815c16d9ebd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8853b26f3559c444e58a890cf224c641cef094a0ebcd913d483a31215e179601(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d9d0c4305f58aeb42ca872fe38ca488e602bbdc7bf31b4d3af5d29f687282f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d20f057c895aa6b8666f3b90ca00983300a1b4f8926b1bdba942b75497171df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a0d1cdd80651588fdea147255c3f4590f6ecb5a1c0c0274aa16d137062bf87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ad9a0755c199b92e0c730204c75ff613f24e13b086e420eb13851751e2422c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88cebe7a34cccd247d04beedb4a763e3998b5546a5f571923111a5d461d37cf0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b2ceb9c6895553d29804fe7037e69fde88e8fc732bd787c025e29471c0fd31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45654ea86dce70ed83ebad1a880ad9513cd5bcedc97513b31ad9ed9c14d3a955(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbaeb9f4bde06690602f9a91b50e84a39f02307ea17004b34e2b064a59dc6e1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28a17f8b71edf046e2f546fb1538fb26105c5d3ff97fb2a73f5733fcded6b6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1be3c4d2440e6ec2aeb2a7ad206d967c916e357742075362bcd7db29d57a2ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c029aafcc179694564db801d78c02f719c7682edfe7d40e0fcbc1e5c78106eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe8b74288dd0175ab3fcf39988cd614c4b02588a54c8377b428d64d194d4639(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb10d64c654622078f49155177414b825fc27179feca49b3267816d1e026676b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a4bc31b9f1766867c8a15dfbcdeec351180fde9f2b5e156ff63388374f5d47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23903f55c2f9aa487097ae6e995262717cbba8be35ba84d5519bdec44db88598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e87f36efb196898519d2261ae946a8a5013993b92fefa45c81b0241e34db173(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8a9ac12dcf620bec50db6efd74dda5ced8f075c346f2759a359a7144eff139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716338747344f6b174aba859d6fb3a31da3a565eac50acc854a8cc6667209ff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3239acb5aef6203226809d249150da186f2d4120a85bd2c59f504cd21f055d4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff409a43465496358512a0df41c6cd50122fecfb6c67d5c91b239aea1ee5745(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af983ffae1ba515fe5c7eba40328e9f1d41cf7b8ddbf45682a8c98073ef638f4(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60f1e421347eba0f96db292cbfe47af2396d4312265beb6e5a15cf350a99922(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935a4ba2bcc7c7ed1b8409a79d92ed5110bf4d506cab3e1f3b5a6720d3d2d14f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d21fc1b2e6b690118979a49348b81abf0a92520f0eb24686ab20dafeedaee63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c8866b0c0aa73b2a9f4a3539cbff71c80abc48c753c2cf00586ca3149d83b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f0277eb10f29c44701aeb2f1e4259472c749fb57bf93c588e872eb0e3ff0be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93b7f59dc098f14915ec0941483655d87fa979a735ba1695b9513bf558fc6f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15cb085d01e7617d60cf4521b9e2d1f47ce46ae088f8398e64bdd79ed8edc663(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9da1a2f056600aa218c4e630fb584d4d83efa2901085721ccafa9553086ca85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00e30cbac6abcfbabd9a36d3e0149ca6e82294bd32e5ebb2f075ba555ec4982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809469d3e7f7b29ba224ff2df33dd9f3aebb27ec1dd84e63c59ff0a054611ac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8168fb6326f92a8cced8f5092886bd1e7bc4404247c4deedab5f22af56caf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd624744fde03c9b45825e872e846157618d92b5384ec5c4efaf3d125e1badb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71c8e772e0083ea9db27f511b1fd66f871e65e0ad663fd4803d07a86d109582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0291fc6fcb93661cdbf9979ce7d5bd7877bddd718358d5cd204eae8054571078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3e3e2caf32f4b67d0dc45992ffcfd4fffd574710a64a9e132db8b47881ecf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329410b5b3f10b9980ace5a598ebfda99fb5a37e1220b2361facab5a5163b04d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ca406ea9458dc4c6dd7b3c2ab022126f03a62fdf8b31549c228590cd467097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8faf59130200552d5685a779c62289f674d0aca08d5130ffed99c44b2eab238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2da8d59f0a4ee421c614ed3fd18e8c560a900ed6dfa757d94c70822ce8e8af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac932b38cf160f1be32385269f31e94246d15d3ef1db3a95ee77916e80a5ffb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932c2c7fe7fe55c13a1fb23724712f14c442d067a8c2ce1132c902f56554c8a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ead687fb38b0c04d7fa0eb46017483c9d0ba433cd493abb13f28d0798a9c6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6b152c8e80275b395a13dca4b22686980e04aad8d63bce5b17b91c9a044008(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af9a31de32c0ab9668a8cdfee97544237cb791dbff0dd6460d1a320f27003da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9018afd478672f83dd71d0ffdf41e4becb261e38e472d96b6ddaf93aca29d846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5323997ddc6e86155d5bd983a21440f1022ca7329eb09181ca2104a48e3f5816(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7fcf181e36462f1d710838ceb9f52a49d8fcd34061c3362805e0a17ee06eac9(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07be05010a5c4f5610a516d99707fb376c5ff281ccd7210d061eb9489673a81d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1096dee7ae131be79fc9367ec3b442ac12bc2a5e44e5c13cdae88d4826435726(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239aa425705e58ea3d8c022f946f78939de44463588717e1c52a64a64cffc7d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbb76d2f3051ce2ec4e666dc913a1c969826b87d976828f7ca31372edf8cd14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824b00a69e05808516a9914a0ff4f9723604dd5e3a21292e2ae5a9e28cd23126(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94023643247bfe74924eeeaffe114834c76e16e4fb1467c9cfd660ffbb7f0d73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8df67b7f3e852cf52e47351d7e2d00ad3450c8cb782ee031ff0b3e7747ab639(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b5fa058569bd6a14bbee4483159980e757582b17d5a2f7863b16f930f59437(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff5463dd7c2d1929d2f5de1fe1432511f304bed43dd5f209d4ff7404be91515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fbc7bbead0ff801303a601664b5a074c84f37b1e4bac1bdfc1a6c6ca8a26753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d37846994c97c14992d8237de743c31e6a379c2d532e730c2f687b4fc6131f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f426f9a881b733d3ccbe52ac6d05d31997bddf50bad069a882fe3b0ca6c9ec8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b127982b8acd163b6b1bbd745ae3f4d18fcb6c655b07941d8ad6b5729b93db8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bae3c5c6ed3fad41d6a4dae2c70e3736de85876f964443edc1e534e22f76f99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1ce6f94624a5754bb6ca4b92a5f27ad4620d95d751cbbcca6114720f2c6930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1a46b4191500f86c90f6e91146be9b3bc730c487b9cda12ef9d10818923284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807d096abada4e1659563d369cecb695bc55a66823fcffd528438e59c25dbaec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6b8004b0e3cb83358b1eeb6a20b2eaa34c3ec9e0b44f4e9c88a6dce9ec0db6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083fb8062712498dfe1f3334713fd290fef137ac0643ba7602625cec1d5d51a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04fe4a35f865fdd133970ed7b0bc895bb9ed3b19ec851243b97c89107e586867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19796ddded3edd669242be3c903e53510703144890453fb6bfa0fc70df1c40cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591fb18c9e617dd8216b20fc75a27f51beff4c7e51a8222abf17222c0a1e38af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d14893f1c2ea2cfe83b027ca2f04ba3dd304dfe523864a8e0209bbd0dea4e21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d80f52f9198739ab36a7dc7bb39f896e08c9aa734ba21566c4461387c1b672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dec6db1b245f4b17f39a88c4ec2d26a965979c9dca3a7e7eee6ad251320f4d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90093821668b6dad47a737ed4e1689ad776618004f328b609e36dfb96e4316ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f9e632c1050c4e6317d6e9789768d3c68f276e70bd2a1a112d02acd6e6b7de1(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038a7c40f3f4a018fa714ec29a5dbc27a69a2acb37f2368122cb0e569e6e038d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15f048896d6403c17067bfc7267c58e1efc735a1068a8b35bc3efb312d45b03(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f005895aa8ba3070bf427a2d3061f74e3196c92bee02e2ca48bd89208134c6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f730de3f44280e1a8c959946edbcede9a5ad6b1e21858e8dddd054cfbbbd8530(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa96f8fc2153290cf6a71e091bb73bc8af03e87cef82c17ae99365d54b1d5ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6bd5eb7e89d3eea545b4434615a7ccd30ad9a7293ce662b89bcfcd4ff84e4fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d94bf3ab7c594bf6d5b25fb3bbcdfc036051a89eca39812d5db023333ffee60(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454ed91f6c3f796937ac470a0f4a0f925442d2de6bcd06b5c8f5e0ac068e83fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c83962c1ec31a15918fa316c33c2c6abfba5367f27472254cc9b3eb3b79b292f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e102b835b977821eee040cda106803e27b97095bea83d02d8e0d74f252d734(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a656e1ae4a02c2950e9f3e0153ec549a5cf54141c0bb350d9b0aea54ac78dd78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f768930ee73d9b1856d973fcd18fc5a75208c097e68992715b4c16ea1c09fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f606c51e7cd4cd790c6c23e82f7198d3a565ad204b5ff5094e662d50252d595e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55e6b3a42127cf277cb4528adcd447858535c1cbc0a6dd2808fa2aed33ce8d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639988ea26f5a6319a4a235d190ef9ef823e2d09142f0e956b8fd2f2bb61ad47(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a3fa05e218e72414ba0edcb46ae007481f679f57b95efe7ba212f5614d22af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef02abdd6afc1d35a75e0a92c00587fd3e0b497e3ee37ecd163ef27d04f61ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd05524372982cf85d27f1a94165d086ab13b50b0895bec63d171581de8d8f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0198962658810b5062f911b3c97869a37bf9c5631256ce4afc44b96c956d0322(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a7c7a231050b10253cbd377561f36b7bc1e3cb4d2d1ce8489bc0b324a8d3e9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff25cae762a45bfc385618b6e21d66d7726bbfe958c5f13de33920e11b92017(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e987658b1bea06c12a4ba17615bf2d6476513768991a3c583c7318b54f6692(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2a0a4fe2d1bf3708e4288a530d34eb103a9c9c5ce1a50fcad89c6dcbcd997a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4678870e58fc66e9b5a63fabf4cc2e2603fe90988a7637a1ad6773a601da0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0211d8ad7cf764a6ce2f586226f0b15817815d142bf198099d1051fd73f49a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43040e1f6bcdd968aca46a7f570d74c44907810aef584bcefdc4fd96d73c389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf2d33587d83bda46eb839acd40526e9ce4feb68646f817d118c476d47608ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3fdbf3fbff1885a8dcbb53bcbc250253b5cd308f347a45362dbeba366716289(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0f4492b8430605b02a11c00a85c589d53a1cddfb96f0bed0bccacdadd55a77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf36470130c32803c244bf93d9e484966247ed2a7d8d31000892079bd0f3a63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6382bbeec564562dedb2baa03abf635e551c059fc282e0a9c816840bf5052d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d466bb4f0b5383e351f81c30afd420a40bbd85a742c781669e6493ec7598bf5(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037da08402134660a26a307fd51d10152125f403248ee4777f6ca7e2ca606f5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7547f0b8cff0b74334fbaff9a29f92a7b9e6a4f9604c7d5920631b8f4089b184(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246f9aea0862e43af31805856ad3711ab0f4c93db8d5ab9042aff2e0974b4fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06acc1c5b35b481decb2ab584e9e3c04990051699109b0581715f7efc0823639(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d809b053b9c25c349ec35eeaeb2395a659ac1954e6c3b3ab291cd863b432a2b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430966297a64203e2ef432f2c04c0461f774ab5b8b6088291b15afe68f55e795(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0592c21adb48dde4fe7d3b154f240a3eaa38669b39bb2fd34259f7389d0a4200(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a9eb3c2d9c2377332db00c2c51d363ffb5d773538189c6956700dcc30ab7a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8ec540680ea1b0dac38b274c3dd264027993334e4cc477ec54c1332fcf5891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9876df15eaa99643e14852152330749edfe9eb386f808c7107b3fe8ae47d1d27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78678e34c828734879e2644f53611b67d91d6d123173ae1e6d766c0e1ea9a9d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00151cf53a1ea8ab4ad8493a08681142c9f303dd31870523462fc9047c91ed99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3790ffdc54f50cebf1e71e1075611cdd73c022cb14d5ace650e42c522edce16(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2156090989277fb23a8d2480989d59a64ca0c856a8578038b3714b812072042d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d09502a6897fd2a8823d3a0c3ec7e4c14ee855b5114d493fc7396502f8cdb2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54aafafd14348213c322e9fe713c1b8ae5f240d430b3178c133a72035abd31a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd2a303e04247e7eef9ff391820fafcbce8ff6994ec1e1f130050b8f2af1ae6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd002a0f00f0ed70c18a576e8a77bdc4b9860d434f9f7d2243130e64ac34ba3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda1bdf6f99a863ea73a24a02dbf506025234d0e90ba7648a4c928a8f6251471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219b0fb96993061107b316b233bfa80c59a7aa886ff60a86ae53a91c3e6b6207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b76a3830be1c62c4098abb96404a37687a3a90fc6d72196798382cbb70fa73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59f840903d58dc8d3f4b075f126bfc6cf9ed5d35bdc055044b429e33a4f91f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e0cb0043a417fe8e45f70529cd718d30c174774620a2be1e25674568abc074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf8eba200361d268b0ee8c0fa4bd698188c77b27667adbceec9e75037b8c098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a10a4d82f3cb5098f370745076fc604266eeeea5b2e78c6de758f032e83e1ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f12ad6f175dc8bee79003e940b85159e801e7ed5e9a9e7124a096bfc7666811(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a289d8135295b4d1187f755434cc940a9fbe99d573451e772a68ceab24cee79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44031b17b429c8063930315dc3b1298390e7f3f7c5d1a6dec7edc2bb6dbc6a2c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2c39b049328200756b92e8399df3571080f47d8ac2c629d6451b64e0be49b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc870362d0ff713dc22c23211c63fb675edfb1950412e19d4763c1d801ef812c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70385f11dd7ae092f09dc80032458bdc0fe2b99fbde6dc4d0b02b846531bdc18(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4713b2335d57a3685fd6a58cc71ca94ed9e38cf9eef30ac191ffcc1bd430c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e642967dffdc27e47c153ed4e81dcc068a268e1a72e25f402bbda37d149fc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03942811bab81243b1b9372d14c700bf529c466fe0eb063d71e8a06c3f27802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6924412a88dc37a97b5794f69a63d94d3392fccc60d17cdefd244aba70c3356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb1f37fe99fdcdd06f44f87664a45c24dee6c67df5c23c2b5fe250c14fb7206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad37e1aae2e076c9d91dfdce940d1d9af3fdff5e550537736b6b98a927f65d08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72cad5e3c7d749a6c34d1cd44129b63b54b127b6d122c911ccdf64d946a2ab90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c74beb66de02ffc65aba2de8e1ecd3dbd108183d8f2b80566cba96099f19f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774507f04bb5809e92d256eb5638ce2601abe432e8768fe1ee65899ba450878f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81837f0c59ecdefa117631fbd1ffb9916fb8dd14ac895add712bc862a34cc65(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10201d51425d59ace7fd8f97233d22a14f8a01b0a7294047540d2626072519a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20460ecb98cb20109ae7aa004514c8d2719984e6ec57c0c11c2e05689d9fcb38(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3987073b35804dda6e00fd83937cbfbaebf7fb62bf8c56548fd1bbc3a3c37fbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99e7e9b7affba62ec1a514dccccce8a9129ff18009b07ef06fbe06aa2ceb5fd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4a7e0ecf3c298b5dfd03424aa828cd08533a7e00803c1646f115ee466dad60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2c1bd094ce88592c294d9966335171154618e8f06c690d63884ca37d13efc7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d479e3b73e9366b134d9d3394cc030731d5a7482c0036ee12144aa5182b87a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3e8fdd79c4964899c056d53cdf5edefc06dd6cf0891aa0b4e1448eb7c42bf08(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2755397bf6e8ba56170664a74cd117b53f4d5c60d60ca40503ff2727a57df3e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef9a740dcf3c9d5ff753da100184665d07c39b2229feacb6ec48d05c6e2095f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f51f51ac42a8a27d5eb26e83564658d2d1e1ea99aa7e74c750e5ebf15981891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34b9484c1e5e9a494fde48e039b5a26be228cc1c4ad48dab38492b9e851a3d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9157377de61060d243da28dd52f2d3429dae42f192625bd20534099fa0d5ce28(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60e8cb45a070c940b4096f95ed2615c75a95919b2b296b75978ec9bee4c7b75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2ff2c0e4b4af9df93cf03a62869dfdde12b6ab0edcae0d4acffb59314523b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe1089038e6341e25996e621e9d3e836ce56521c18f412ace5b21049c3fa89e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1133f8b6b7b556d0833f03afb55fd66b02d22826d2d103eeb136bd4350674395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16798c661cae4aa4d5b17cfab34469b1ca7e74fa84160689d9bcb2887b4803cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d9defc946896af2a5fc5fa99b439d1f2b6a32f68859500fe466f7ca45bdc7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8514d3eea818bb8e88b686f45611d40de3eb7d6d3f7b1b99dd44615d530d8b6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d89deb5b69a94fc265363ef121a5105fe47831c2e66628691e9d93c53b28cb(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ee959be12ec3374f6f7bffc658ef09aa5924d5f47b765dbbd4906dd2361e10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac499c0527c7977cbd455429e17e6dbdf23ed0432f8c06837e848eebc4332f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e35b25435f2a4cf0919c3c294677e8f3f04dbe76482de0987667cf795dbaf19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d275aedcea1a94673fe8d487a23ab8b8b82e845a24b54a51a198e0e0aaa06138(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ea98780b56d4cc79cfdcc48df30aa197d31ade7b545758d4470e226a8598e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28457e9c1aba25e928c084ea4e3591ea384ae5e56bc039ce9b62fe8241a6d22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5288d85784166a4c81f208c0e9fda0383fa7cd4138a52b4b23233e5a585699b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db33dab77392866e602ad80fd6ae15232736b8d0782b1d5875307f43c8207db4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf05196ccef25c3315a2fda36ac5b3859d9d4fbe9c2e860b7398696cb5896ab2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eac5aa964389a4a109f5e8650244b68fc9394cf10e6afa7f0e84d2faaef2199(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baaa4fc1d69a76187852f8689626433c544d26261c736234bd48179435aba659(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d032d208fb156276d9cd4d72a45419b721c26aed3e9a7d3b5372d9c71c1b5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5691310e3ab7b3fd262aad285262658d3e8cedb297c61df18734a295cf47b284(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d3219e4b1654f203e4feaa278822a569c0d630482805eedd58a49e1514a1ba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278935e53c47cf283ece629cdeee1dff0babcbc317d0d2278a3d8bc81a370a19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c800b1a88b084f0be5e0ca7fa091c7c95392a84042147dcc56e7ba7615512169(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a92e52e86c3737bc814d65712c11f27bb00c52b2d9d8ae33b3d3aacea948330(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5eebb8d5cd7baa508a08ff0ee8bd4fed3ff53a1bb8043b8a8cfb9dfa32f2e2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384042ef7fa652818407612dbf803251c3c1e788d489bb206df72d2085cb3531(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701eb35d27f5dea2b283b9eecc0a457e310f7c787b7fbd2d572d0c8d091784ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448afd56e87a6954dcc35f266768d4d1a7f7dd92d5159e74b99f63a4fa2a0728(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7485d950543356b33998b82eacd1f88b3d97cb2688e186371db5e23e2a44fc63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f399a2ca5809ec05f6862957138fcb6a3926cf6c461b00aa78957b23774b0bb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d10ac8b0a61189540f6eaf5c9a7a6c16e8c24b32560126a85a9397d3190d915(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecfce2c3f704494b0bdc4daa9e727501955c2598c67d287b6de123a5dd71347f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d20aad221c615c7d960a8f7acb902c012c32c18d8150c1771b7a7162bba653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035cae23e7e9771003929414434cccd24d2ec2319f98252c0ad8b40dcd0240c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1b8ed54a8f001bb3962bf78ce4eed844a6edc06a94ccd5b00f158082ce919e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541569d9e1ae4acfcf001b6288789d65bcfa34459417fe963c28bf6d9c8a160f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47964692294e02bcb8e07b447acd548437b48f90e57ec05984d8b74b0417828(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b87b7df90854a883026798a5281350828d86905edd8fd75ec0e7360a24e03c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa7702ab6649c11f0b18b5d6dda6424a8801986e0e452f3f8694e8b0329521d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edaab3dad441fae0b34ca5f9b6f4f8b03f1fa135bdc58ab07d47e04748d13a8b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78d087ce9f6bc32f7c347669a2867150a7e3dd18f894a900c3da44c2bd117d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec0bb4c67665397950f5dbed6431b18cdfbb955b51c44c328447ae0c69954e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d45b75037e5f05ddaaeb8c5f8cfb6177e34668bd53a6232cdbb6527cdc0aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b408ef622a23cb4ced17963ec06c84c3688aff0d921742b114d144cce235594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0226229e193d507c52c2a81ff9387f4f9816f6baefb57306420b24ba5e6987(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1556baa15363eb20876e9cc0fb336819154d69317a1fa4c5f3d03762503ca1(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d450daa4467b0ebe597e95fedbda5e5020ddc99c0f84c8dfe22a513b100311(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0c8c5f74433631cf6a071ebbd371df3748635ccd57e3e783edb590ff5ac590(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa11baa1ba615db03f1d846a95fb13b6bb9d241ca97e9c561e7d41216c969f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1deb2f7f5a9e78fb4feaeacd1edcebc4cb18050e8ea5ef467d8992205e57c2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c66f2d203b269650d49444138c8373611a739726bc8067908cb04322f2e80a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac5f9a9f31399dd37f199fd7ed051e79cb9dfe5a3ee16aeaa0f5c7476f71369(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a369f99cbe1e56f501e1d1161aeb9e42b9195f4c9048bbdeb9b27d81ddd53e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1f47d7026659b6184d08f1aa42399d670572a81d99dc72b34b078f1a435b81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e768b15b69f7cb7f766557b8b2f181a4fa4faee3738b5412530a2e0a6930be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64205384a678e5c228a877b72620abf92e1d218c5aead9fb9a21ae2d9cc0c1b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8bacf0616a13f3e65f476a5668cdb69abc24136ea5bccb6c9db1973e03e6a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f8eaea620318d6503a1806ea266bfc033fb7f0931fc9a75c801d9ea02fe23c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f9a569d1fba17c62e2f25db762017c6feb2fefff18b554961c2758627da8fd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04510583cb6df9332fa2ec84d47123aaf1e1e45d56579445955bb3f82c588712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce62cc5cdbce9499e5cb0b150e4c05e121933b808bfaad2db25349db08b4780(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e7ad647015fc9200f79088fb0a74f6a26e77d393b71fa9d5f63118ddccab1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8836c3f8be9e59e943d0ce4fa4b833a4c9085437f2e4115b5ce0d79fb08079(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6817974540df036895477ca068b4480f3bd61c7c6d8cf3ceea2300c4c70d6bdc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f637d9ff0ca2ff2b6d7836df157310e43f81390bf8e1f863445508c99685d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659ca0a1065bcb4486d65c537ea794aee9d07f240efe7728bdb45e10ee5394dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd13cda480375690ce1b1073bb880c509bb51e98c5a999e9e8bcb4cf6bb0c37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b170e2f5ce9253b0d61f7c4d4ea5ecc8a9bd666983654c818a97bb29caff2739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86c4271f8921d873d7d17d424512189a87a5d75b0eef3fba18e55b99195aa0c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd4f532d36ff439fd0a365b22b47785e95c226f91d8c9463229fa14a700b04b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ee738b8d4d9fc23937a7cec3f5ac6ddaf6ba5add2d484037ca578f08e11e57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8016b1bbbd43179910d0ed5e166a79725562c39193959a33fbff5ece70030f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cfcbcd8cbefb3c5c5631802ed0045521ef902a8742d1d1c9be49776fff52b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e510006af18164fcf4651f81f0f05ebc9bad5a772297f52f223d2087ee0e0b44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cedb4999ea8e3775f7afdfc0a1bf1f2be279bf75844fcdf10ff11fb64304f554(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b458db824c85bc21ff9ceebb272669b4238507e5ec8201ba02f2b6ce10c68dde(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6868c94c681ac8b61ea3167b214455bae8cc6be7685070a29624f34bb8d7e22b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4d28a9af3b111c57bb71bda8c1274fb5254d0ace693eb93c70577b8b2c90c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5209f562e5dce6a9310e1a42f382b05ae745daa4cae0d55a60ce5284f629a258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0212ff232619d826aafdbb0d5d37cf6c7aa9d37fbd047df31f5a347be1dcf207(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2561cf8dac2ffae50a78e4fb34f6c6b4b2c69ad6e03af5163c26d94ab0c0e95b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8a11027b715648f2bc9f3f2bab0557643befaed85b6ab75a668e8942845543(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f34d1c2fb26853600df91dc1827be57c0658974ea293b6998d16f1481c7cf2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__461e550a4898e0733863ab2f7bae2216ef768f4fc6ef2724885d247f83c9b3f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ff8bd4e90a51fb4297e5842e5db69806fff0de1163c1601afc85ac9f7c79fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d00d7cb68bedd1356513a89e180de2473ec3f3100ad9e1f9349c70efb4cb544(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74803d5f469e1ef2136adb26f44c14b220a4d102b7c79237c020758ff4c9a9da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52306391b2623f197e5e9f7d565b2378175e5f587cc301f766583743c44ff3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c84a15d648037356676f243c5e5061134ee115b946ee434b73ff5e9cb8f254(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1505c74372da4d25571940c59f8de2f8a2a9bf03c97755e0395e6aa8fab682e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1764d0d066b6e9567d72f7d3642998cf89836a5e1dcc4a63a71cae1cbd7f9b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab96a236e183818dafacb3e3798bb90cf3f36b1f6348422064a4d479a426f513(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa10232e751f0e279505055850074d5fa8dc10924f82a13bb92dc134c28ce1e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c219a4a8396c365b92685e5abe8d2c274b5c44f4a3e1ba5f5b22fc2354abab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a95644ab577f49b5608274581d6b208a07e6e65648ed55f42342d425c16b772(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969ce2e29ffdc6563f05e2f9e6a2b63d00c1098ed285a7b0eec26d4f2ba069a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5583144e90c0e02ce7132cb014852d98ecfef6945b7d7b49979051cdd276d081(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a228c270b473088b77cdfd55597ba4d84b9c2077bf04c78e0e0ebfd3029f2b9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e617bc5b8d7e7f3b563971fd7f654263d0fb97f0d7e3c0c6c93ab7a1e54f4597(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d6f6d4c0cb70af0b3784fc41c1881d48e6adf755d7f0cc7f2707747ebf9abd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b78ae9810af3c6735c1434901a25cc5134b9230f50a0290dc9ee494a967a3e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ff9d1368707f0ebbd3c808ad48821978002d45239efbb4b9e5cb34ec450c3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30174be602786ccf62091f1118af45b0f5ec7f45a3e11018394f44d12ae951d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca233aa391a03e05b984fefac7f93e9266d522ab7368d3d3d8f3bb2df57bdc0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe75686ac5b1aeec993022ada4add46ec7d1fe23a7634d44c37950bbb838bcf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2192167bb3e6609f047ccbbd593f2b94e02df7aa4bfb6a6a0f2e1c9e61456785(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f1bcf7796fffe8633a1c8b9737e78f5f512de4cd7b5ea9ed861fee568c5195(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc085c3289525da032ad0d143c7bd54020bd05a013daea86fbbb88000bf88357(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e65e6942e0ae2d07830dd9fcb0ec0e32b09f23a487169cbc6f1e435e2ed8f91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb2e509a8f59708974ab95f9b5af8cdc724f5a0c404a3ad23aa3478f48768a6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291b8ee308e7af06ea751708ff97b1adfa44bc7f54e0fa5f3865c3cd0d641b4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c31b3877fa5314247cadbf90c3b1989868b740ff2be61b446d9cb6cb47ac4c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032387fb3fbe097767e1db1ab160e2d3139db7ea2382004a404054b0a9cfded1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c83c0f478a53e1749a961fbf4852cd4e2a647ddb72833c3de0feeee7bec9c5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5ac97dc9022f8b192b56a91a8b04488be94b81786e716ac29f88532629d963(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373a91b7efea2b8a40cb586fb2eee037107df6d6b36a049e4e49618335b4ccd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fddb254ca7c7aee44b5581c08cd1db4a06da122f0339721ae7cdfe948ac7e5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a0ff6e5a4c7bd32b880eb9c3396bc84f755914389b5e5ee58c61a678f72ca2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c3047ccfcb33bc1c62138a30df4aa5a1fb9dbea099a328026b1b8c1207e1d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e6ee99708ea464b7fc1749d26e904741175349001cfecdd06e2a464e126f3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76eb6fc712f6fddf91bd2f53791ab438743a14d9528418dcf5fd9f18daca08f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7640cf87b9887f1ef4d94bffdbe346314ecc55e2b072bd5db4a1d28076936387(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1cb3122e56f6b2dd33fd7722989c85e7c73553d7b31cdfd36233049c236132e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e9c2e6ab2a1a6276ec0b81dfdb9ef1f6d53c605a86e87c4651ad011bf8677f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1804c0a5fad7683888408003f29ca5ca5b521cd8790c955c67d7a46e5b1e576a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f82d3d0e3c9f74b885e4297f532320ff5816b10e218db418e12e8505d3930c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8355fe60dc0278990c830d22e27d38c7db650c53c0f799bebac0bb85e4f40a7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8965fd901932c598bc1ee9f4bb1f6449188d13a88c49657dcb822b4b1ee95a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909689263d81e4b085ca47164151c7e0f5be6aff252a3668ac9127350fba4cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c010e3b4f60d0f77a5a37806f60da00db46184bc98525615aa56755ba82908d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e0c750417a138dc6197b2269cd2d5262ccea3c63586ed3628098b677bb268d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397a70e6efa12783b5e4db70f84f8cadb9f68820278c5b5e3a7be16880a9cc1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b6718f5da21a2d9601a110169848a36b644bef292b2faf9915f85aa4606007(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832f8433293f229f0597c8b8ca6eca348debaa9ff84a7f73962c1311654d5e24(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865cce1a44b43ae32428c837f820a3d1fb06cf1530f3f9b08233abadec09e2a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1340dd225b2bcd6e347fac88be6096220dc948425d6f3ea42b76b72e1c1e1c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3a168f69092cc865c956debc451b1228823ab5f17fd72de28db13d05b0370e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccae5bd89bc15fbb75aa71f707e6f17cc0be1ae883e0c42704e3b2505437d928(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d80900b690929102d0ebbdc76994fa67e76d507bd5b3b3e056fb7c38406c2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac11c7bb70e5f54744c4dda402c395519ba5ef124f9869d29e03fdaca79d384(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c78c39bff0338abad4363258874d3ee025581348badaef82e9504b9e24487f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a3c8b9e811b2e1606160493330f37317e884a2cc94a9a8ade8275096a49c7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b219f5f48e4642d38edb3f653a25e211a4e5a8487b8e73a0e13dfbcd11df6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69034379a5d42f4201895b2695cc28a5704bf8ffa78b5828c15ddac2c95d65ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e8fbf437df7f0e83a9674f8c7dd0d0c8372dab63a07e19019222586c6aa4ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__016cc5cc1ed74a1eecff7e2159bb3bd7e72c6a6eea0ca2d6590d0e4bc07956f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973047561ad52065e603600812329b42b815d546a8727eda4d2a310ed6a0f74c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__140154728c4de9e6f97f507604f25341f8a12193530a306389d71b71205b6252(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f258877032ade59f6ee10ad387683620fcbbf905d1ad8bcbe9cdc82c8ee884f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17761b53fe6300856ee2ecac81f945db033d0ed9deebd1050681621a2e7515f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5998a4839fbac414b287f4d3e75a3bca6ab3e8ed07650be1153018f08c8354(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e170ce5add6f89c4024fbaa21e8488fd521495c46021bcbe4a0e247eb1548ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c556ad177baec0a0da8762e55174e04b54b512066729bb9cc267735176f5f238(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0246d692b5d26d23b961329434adc8e6019445d9146361f2df82bf96feb090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5993bcea4fe727b82a56b8c3a668ff8347cdb06a0e9471c8aceebe4f58d61c97(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1f6633efedbee3b5aafcd1072e276d85a60713f18184ddd141fa2085b55bf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0fdb20a14a7f4cda25aaeb78cb49e1734049a711eee48c1d3acd0760262839(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__011158daf05d0a8eb1a4a39fa54ea0a48cef049f92c1d687325a39bdbf7d105a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2707e9a783623cc9689fd2c8fbc1bfbf5fe16e1b39294f22d836f8c1470288a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca9f164e847996d18a551c8755c3e3898b21945c34274b306040ac2a37e0d66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504c2df247dafaae26ff5573fcf05c38c043bb66e880386a38c53a75de859b36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c926fac702655b46e8a06b4a4604eef61472686b37023cdf7aad95dd17b16c45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe60f45e88312b065e4115b007c9c333c150da129e9545c39dd035c0789f4567(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475a3202dcdb567cd74007b736673b73d9dd3cd4485cd005acaf514f5fdf5eb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d512d2588682d214f17c6bf620be83be708601634d6b33c3501f5b5752de4fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33bb03e0d6c2bcb7f5266f579d0a6863ade3dacb461c482762e7197fefcc6ee6(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549f5d43b0d7ca7a4792b922b721dc503115e4e723c57e43dd34aa2828739579(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7230fbc8293c1a4f2eef4ed560f190672e32f6c229c461a9ea182356678d2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2354cf12008486f00d4d9c72fcc75bcc396aa24e83cccf47f3cc54f5c1ff2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193d939584737500fb6ac04169c26acca9d99ac6cedf61c4f3f2b135ec15c911(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62bbb992cc7f5a1211c34fafd21cf6c784c02252fcdfee09cc238617bb4090fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80d2c2fafd0fea520880ba9d6969e5d3149d3e655b7ced1abd7ad8be057dd0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48de73c5f2efe05b62a2f691d3ca772568f2ab6467adc2042bfc7ec662fc0acf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3def353a31cd754de5bcfcda2856e55a70ee27b2ab534e815ae01154fdddd0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f05c3ef3fc87589189ea1cfbc46e0b7cbd9510ee2dcad6f9e7a4279b00d3900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b02d72fdb2dc6d5f262a0884717c70ddb668f033a6983fb7f189d9105ad19cb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8cdff8aad5a0dc1b345ca40adce0c8996e11953d0535557c0f73ed707d7f3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8ad70b4bc15c6e62e419bba99fc51a3d871901dca12d263368f4001223aa44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf0407c6b0d586f715dbff131ec506e9e9e6bdefdd03805f8ff7844e4f7c7d9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbffa305df875c87e10571bcd724877c9c1c2adbe415c1d2ea53a5045bf03e1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15226bf133ccafe44c217796191d770dbe7bc1992855de472bfa4e50c27ab421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e92c317512fb87dc1c59be6574a609b3d60b4cd82787849446adee9b3a086f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa121f5ef9178c8b7217832df5a17b4493708e456a6e5f1ec4f33f3937085da(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225411eae24ee67f5d0523bf918e0fccc8dafc1f6f58b4c7940c5c4c9df11c73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448e3cf795e34b8cc7ea83545635336e6b1ea38808f815af55c28ee88be85324(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6438468d88e992a8b97949f253872cac120a9c56d6f6f49fd72211152b48f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db608bc03e929dda0a2af0ecd559459d6b72963fa3897f0f105938307982f72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__829c72763d22176764b9c7e54da074aeff4c0928fc74ea665c78ae7dcb1b4190(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3789c2a58da9f7e8c4e49b5f3b92fa0531aa15e298b22f9eb94d16fabf6e29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3edfefc6d0645be255152e33b02b53ad027574be3e2ebb18fd9cc0f2a4f5ab2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a527d8833cc9f81efbbc8ef03e0ecdf1aef05c3076cd6a2906191e5ef6fed1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ef96fc217d3a044c830f13b39fb93dae970d97ae3956f6f5c2f7ee47c56019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19b435159a61c59faff35bd4379f4ca6abcaa6c6bf581075b0adccced672a08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966c16fd82d8384bc82bbd843536052c81f3c1b794813c2bb102629ceefe0755(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e0bce03451e0170437bb5407edf8d804bdf65206ceaddb2229b3e28a9831ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40fa12c9d7c746af8a3196832b6de1dc59cf891ed115672bef720f0f8f5fd81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33b3a36ffe82e62a3e8536561ee0ccb2672c2e75a23c6685a83a138930d7f64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188a2f624c6ce9526781a19f22f4c340adb5b074138e577af64c7f6082c3b5d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bc82eecc5aa39148a63468dc53aecfe651a5449bb6fa21aabcd4f60508d60c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4614ced7385e922a3e11995e68d8572fcdf52c45f22de6cbe35fc63e3dffea4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec133f01e483cf45d176ebd2e1c09f94d278a15d7a3535837184ffb9c9cb28b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd907bac4d038bdef1a67dd8e4510e0987ab71050f5b5233fd2b276c859b7c27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baeb276ee7348c3327e315d44a6dd2f478ad94d5b3fa2cb415d868c11bf96d3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d9d28a73c1c21a7c68be63164aaef51e2a44d27138d8aeaabebee0456803ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628316c9e99af5ab250e768c1f6946858b6de4e8cfb9965ad8ce7b06e5a594fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a520e1d2577b3ca8db3de9d799ace3e896ed008695dd7fdd1f508cad596b65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0805b775d19925560962c93d290f53ced0d48b16f8c23f7ca2fc021af1a853d3(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36518abf518abdf27d5b63af960cdfc00a3a29f1f8225ccca042760033c34e33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11338d4d5a9ce268ef0d68a401434713c122a449dc531d7222ffb15ebdf2aa2c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8a67a337c64f3233a0e3ec78bb6a8d2601e131da2dc0652b3ae774d7cbd354(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33546d41899dd565092857f382992d9ec7e24160233da8fff9440b771b90347(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec81b59d57710f97bb46197b90047439e60f38aae3b0a71028379481bf34af5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79175ebc5287270a533602ed8d6eb48cba63ed90bcc07bc39f8a3fdec02bb194(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de019f5d5a99a186e366eb90f8547b738328021471e29d733f45ddee4d65837(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb63f0cb6031331c6ff82865dec371d37514928e0958bc623a2f229c0965c01e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90967e192179ece939ecb6eef6cef928abaa926c9ffe32c83a4e2ea3df3c4dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463e6b75147e97a1e0cccaea7a5da6b38363648092d99af7ee09bb535096a458(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af2b737b2f29c6a58aa3eb9d8353519f69684ae95136c3f0ae65243cf3780346(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a9be9fd9c7b6bb946c34ac9610066746b5f9c4c783e0f5f5f5ed6c2bc18ad0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd288bf224231de5f04eb9e6c168b301334a5544a7bc3322f8b4250db7bcb3a(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adaa0a468fef33b0a9a347ecd9179547a6dd64ff6820861121f3037c4bac3a91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d079e0fa9615ed628f4d3206a6ca8500f40578822bac6d3c7990a2a3ccca2bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6eec3aefc4984a0dd3c87120442677b7d0d9a5f7f4836f34560f4e9f2568376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6490718589eaefde5c5b09a505a1cbb4d28ca49795597035b9e2d049df917de6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb7abef2f3d70972d347fb09b02b79ba3145f4491e8be4ed04578ea4105cc04(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01542495f2534b573c019bd7119d17fa22f7fe781e71b790ff37947511602c3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817fa60cb968c675f0b64fa943a49fba5cf9c95e01cbcae9637cf210fdc4736e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6102634446d209a05758849df204b2436574d8430a758f945b299bd118756e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b67dae0fe758f2cf7413f08e9b756e08334721e2c5e9dd0740b0051ae543048(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bef3eaf99b6ae321c2c8625b0bcbabb6f1d9f648433e5b3e5ec79f5dc0729bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d807e61172d57073c27fe1e757f7bdcce88dcf8c5e71190dee4837814f8e472e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3429e2798b7d7fd7cf127ab3d829d06f80f829a7beeac63dc02c42bbffb17754(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b26374399e989105bbd670bbc87ff5f15ec41e4f3a3bab54c032d69b7e70886(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50171f9fbd8f9d337ac2da32e667e8ab4b1c6ce19ee6655be6d2f45d88d05176(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6880934aaca5a453e0a6bc38e43b92c5f461ae19d7731930aab02f84031f91b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9f64fc9ae5ca1ec8d3dcbd6539bb17dddbcbd219c2ab2cecafab9a895dce19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb987c41c37f9dc58bb5265e33c9cb13755bb50525ba9c77271096431475654(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e367d00efa7662d3ca8d214d7f1faaba0d0ee285f6116900697e3dc002759740(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d8e8dc41f8e1266d1fa5aa6a165c4dc446248b02f763397e0e115fa9b560af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe17e30c5f4716470dc7fd67fbcdc231f311b097c531457f0a19bdfbfb753c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1876e17b356acabedc13506730941835ba986a64bf0df952d486efe1b5c6718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b321f21b0a7fab65fc08051725ed28c745331fbc8cc793b88d5209cc0aa60b2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46feae34692b0b5a206cc1a09eb20ec5a38bdfab901e4d900a6eb381d56ae74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb976912d960382ef8261e8767732343b09192a0f789b0b97e71b59c615ab467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32519cb11f148f67da32ae2b22cfe35bd81d23efa59f0f86dda323513e64f19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fb6e025995b550b644d3890730df7d87e741d8f73e18ea7f2d2b491bfb9ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb40b0eefb5ef8279e49a9168884c26c29c78ab289fdd3c806758bbf108f419(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8b8d3b1957aa2311a26b45ae4f03cf3dd94c6f1ef6c5e38598e678ef588a57(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf65b1ce2927b9cfbd591ee37d136c9f2c15f6a6a6e7d115ce84e0e3d3673b34(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e376e32c8ec0badcda041aa1d22acfd3704e35e49f1a58016a06b36747be679(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1706cefc9f87d15bd9328f1e4b6f9dd4af522a4d46cad9b3636a45a392478999(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5154de1d577e49cb309e00143695816d7513306de034d88fa4dbbe9b6aeca02c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc0a0a561827dd1c4f8cebdd6476289ceb7953f1281903c24967111aff1e709f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__defd1876ea39114c2b1bc01b1e1cac87206eb9042f1035ae45718edc5e12a318(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a339b058394b546ab98b006d2ee5b9cd446ad5caeeecd4f1e3b9b6df1de6f043(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354172a00692c231cdceadd474a5f505a58781f23d047ffa288896f8b3a2a322(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a282b3944cb82712bcf436e756bf31cbf5ea4141a8571b6d9827168065436a73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c2c32b30c85de02fedb1f6d74bbd7e68b8621fdd3241e07c83c473a9a122cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9697bdf05da1689fdecfe980605d2ca77582aeaabcca7fe0a0a6e56871078ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5e92a6a0fcc15e2a07facec5278d108d1f146502b8e5f27ba804d071664767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acdde2ae6125b242b4266a2064e2b14e3db06df3e302bdef31638bdc9591b360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af2c53f40a21884c91fbd47a2cd7b7d7d53f22a3ebd0d73f37f99c0c6f0c040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4f41a903b61bb7744c50d6776a1a17ca0eb57f4297d49905119219649f56a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f42ec836108f177a0f6a8d7b1787ad24d11043c6a9756615078c9ce4e2febf6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d86251d8a25ae31fc6785bef0067ba2d5160a593c5e0aa40bd7fbca9266221(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4ee8da701d585f1295732cfceec014784d60ba4d0b7c8e814a1b6be4530f8e(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61910ccffe65b3b48c5053322c42d7cde8f548cb5736fac8bdc09f141b8dbdc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59209539d2583f395c3023bca53579f811bfb5da5e4ceec68e9f2a9a0edb017e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea341dd0f0fafec2d5e4828014cd3c16556ff002c85f9d4e862fdc4584217bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5512f1aa61f4c9a9dc96fa1b06a1a00a127c1bf700b8de1c7c3bc7709fcb8d33(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a3c28b72edbe51cdb7b53cd662dcfb16cf25b316f308f6cdbee9211d53759c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792ed481657a9ae1833ba775a71297053da322729e2ceb32135175113d78ca1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785e55df4e5a4bc856f1ff69e486cf099c173f98a525f502ba751a541f61f46c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97dc9b5afdde58f6ae2249306d7b956bb22a63393d43fa4bf47dabd6f5442bc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f813f32cf96b32bf922208fef740fd7d066ebdf0e48379cac0866336fc2020b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0566f7a7fdcb527abf922d8b6403c9414e8e0367b668f66cc549503e07a2f338(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89824f4f5e5c0099491ad52cc9a794647a6d02c60c5ad11c68bfdbf7b4a52e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779a48f607758935fbad0068c4405eff40216f0513d4fd9c731df4e1df9b406b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db71976b10fdfa02d8eb1de6cad984d7b0558e0d451035e2f94b91b32df4d6b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a90dc79b3357f68898bccc91e36d0593c3766b7aca7016fce0d00cb6c84721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5e8ab02a05d7ff1332de53899477aa448825f05dab9a082cefb4392856cf60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef18d30291908c39460b956df1424bec5e06193ad67cc2e246d8bc5e34764e0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6bc14d49c5b3d6fa4cfa74b37e625374a22f13a69f15ebdf73f8e31373a288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c741a040e3511d9995eb1ae0c404c34125e17d08faa4bb5513d83a4f646558b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12a07042f6d0ccb5a49ce895cc8a564a5e135eb6f6a382ea4faa46158afb9c1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b3ef8293ab146190a815a6a75ed3a3aab7765801aba3871046c6add7a63690(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3892a296a17f905fe13d773bcd230ce9cb2a262d66bce121edabe49a6c6841fd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__389a2078460160d4e9f237ff1e38f408cba73a58f71998f0b61edac4af539714(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a100930f49928f28e4298fc06a8fcf58f190fb3512b8a852ab1a600bcec92c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28524850d33fdcd2fb4033fbbff4b3e2de391e78f08f07723b8ffb991f9b5a83(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9907de70dd58f24fa0c1ce463b89470ae2de0aabd3c393e8057b2b7a0bf1e5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dbcd44b3ab1c091c83357daeceb28e4af7f3d11e87e427d293ee81a0a4a203e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f486ad82d783f871dc6d0d3f9a302b18b7e69a72f296fcbe485a27d837927e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d13bce9f19edf44c55f1a0fd22ef4cb8099c0cf6cf7ffe191d5ed279382bf81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd4484623eb08905f5426977e5dc5dc5c41087c237d4dbd93ec351f0a996335(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09ac50fc61d9ef3705eb2f8ed4dce746b68dcceb477eba86a6d75c82907434a(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddeb6ca7180a58f2fc3b784658e7e729ab43b5482524d92620b3d1e8af55f503(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740a8e4da27f9f9ca6fbf38e207d5c86b7f2e6f357ef1a9368d6e603675d29d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4340b9f332069809c2f9a710d8d86a8563f404bc3fc713916bb2cbd7494ad224(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4bfaedc609d0179cbb181b597d6980ca4c07ac60de243afa310add19d7458d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7707819bff95463688aa3be1b8817c1c53fe040bf8b22df8d22564cc8fd4faca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84316c7d90b1613861bf4a68e8b0691cdb9797e8e74f59e1f2797ba2bccfaa26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6b724b2c58113d1160f65f4834a1825f267072e59ac1ccad75d02682e205b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cadc4cb3013687787d8cf34f6602dc510ad59e2b9397460ee26664f43b26ac13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b448757cded122373b514a3c59f0788f63bb6cf80095eb32d1220d7a844e15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02a4ea6b954f0af7db2452f2501b04b90b3ca5244b932b3e3bb7ddc4f6a854a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__235779d74ba05104a162b416ca2ae66d36b7284cc59d8ee97cb03dc8594dd556(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63fe95aed68f307675a97b9136e8f5f72f119f8dce9901ae43621d6ee00a640(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd08321cae00a1b0c7c229da8acc0cf54a8b7ae1fa45808b0e15cf6171414228(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0250b904f56442d3a9947e952edd5920d98d7799b531d6c146551b38874180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149f24b5b522280907e55e4786f4940d7ab08858bc32f3cb9d1ff8bf9642fb02(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4700a1bcdc0a8b67de71e63b6e83be258b3addb0f93e28db8fbfdf829575b8bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8a5e969585105dde038d380b75b7f9d57fa313817c6590cfa02d9a22953eb4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a85e0923877ab07537d41dd145c537033a96ab162febad181873af17c7699c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d2976465f3f434b1e12b3eb8b64b5892f0696f25854a0347d2af6e7bee68ef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a607fa5ccca3584d22fbb461973ace0677494671d3fa3dd5d0a3db64cca5cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495fc5f728ed0f02d0226885fdae6dafdbbefed0ec30dcaf6e1dab4196f3003c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87019476142a2ca1d1f4aedc385fa982c18b2beddf5c6050aaee23d3eaa2f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546dc79c9b14d2dcf42ec8cf5f2902c66fb9a0d202eadb270049f3a77068eebf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ebd50ce7611d9935bb077aad86a9c1f573fd80d381fb661dbb5d749e5b0410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7729b1069aca4c4c38a42adac6f24bc9df10cd8fbb229918e219b7542b270e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f274f0a74f21a6f54c583b90f0b59b38dd1e15b2b1831d922016ca16a38aa70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505f970c5eaa0d65daa41eba0a911e2a542ce4c029a41a63e16bee28bab1b283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374d62bc668ba759fdb559af54733eb4c07bf5ffdd78ecb0ac26d66aaa7d4a36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e52036281b722385d5cb45e26d231ac96af73b419fd2133329bbdaf19bf701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06546b6b303414632d9111db2f7ff7b693bbdfc628a0689e1a1996d00c7c692c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14a5521edc2c81dc5ff3b0c59a1e4ed5a3953b49a40ca864b3f95945ea80105(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef90bff6b2c30d0829f700f7f51b70fbc042f57ec606478071dafecf2444620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca32b1a059ca2fe5d45d1650fc861a577ec00709de8d21c0cc5499ba4e08ee1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d074566ddbda07f1ef02a2c37528285fb79fb1bb1ab04f1873f4661c6e32f892(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137cfd4a6fa2cc1b40027a7d212e65496fc11365b1e342f7572c410a36f0b436(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09fbec41028a488c1030522b34301068f371e3bc37136c7d98f80af12ede9bcc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e853f712c57866b275f9d15f825bb93325458d97b481cefd37a61447d34c14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ee1ed281a2cf314a60e79093f9684845e9d5094a0b6c6d23c43ef803e805cc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6112c6d8958c93908d7cc0276202fa562c6ce327c98cebf84514e388bb95c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3eb664f441885f603906317c9a72aae42adbc0362dab94209657c13cc4f21d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607d9be580ee95a0acc3c1c62f52bc221750a7b1ac4c23f639d90ba7497e8a49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19850b4c26edc0e53fa1d20c5be50d0e72e2123850c2b2fd9a4a8c3fb0211b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e02a96a6a91d386b02a27dc3c96d58fa61bb1a96c48d18d3cb42afeb406be9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aaa030b46c982f1aba6f8d0c561c6e153202ce3851a17dfed0d2b2c20107183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e5ecee237ecdf2d69740ad7a533b0d16ac8be9ed9c0cc64ff3bb532a03f5d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7895503a697445d581c1fd514c5796c39e476296da85a5319c70ecd043c0f54d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7e8bdda860c92254fda93fe78ad42d9217251b0ad641938074ec2294858cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1eb3499b95513137389da5a9a1f813e7542b47f229239c034a4b2db969c6c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09220b38c86e93fd99e4e379ae3805e51a5b5341c14aa912c956e0b23134e12c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b887ed05240552342737e69418e8a8234438298dc7d94a66be4803e5146e24c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b46f847461ba459756bad91b88613531460fee1fb1e08cc1cfa25c3b3ccc6dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5868a83f972179917034b2b7c10532644da930b52fb0537e2ebd67535a3e2f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c3c56e4522ccaa7550d6c199086303b923e89057f52548663534b762feb206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef138749ad6ffeeeed72c1faa1c864d0274d9721552d57088edd8ad11b1e557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9889d587be4b5d3e33893dddc0205de9aad40cd2a828867ee85f1afdb673a020(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8629962ee6252ed16eff503dc4c63b1667230df81aa52e9d09eb2345d437165a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b823844dc7da4ea90b6bbb6b3395c071b91c91258d26e5e927f272d939379fc1(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98e77e52908ee0f39ad3b110baab96d06a9f9e8872a6496645b5428bf138791(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70034c93a4a2dfd5a86e6647328663fc4b6cd2c1eb9eaa32c75a7f80e9803b33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6040cc2440ed2b99aa0d345386a7e3ec32baab694890ebe14afcea283eac3fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b7b5fd61443bfafdddd6b07c6c89cee25905538c51b80be117ac99aa33ee78(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e59594e3462b6666a8b661b88be9098f3d35e8b826e4d7b1635e7e4b517005(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7161399b7891b11bbadac72d6104e74bef1c9c67b7ea4648377ab221f6e6230b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc45b01b7d661cdc5527c3fcdbe24d2d99660e64a09e55e0d60feaecdc4f90aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27639c51642625aae24d8590809cd550ce7f2437e1aa953193892dbec63cb99d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bee80686c48ea474a095aed35ba94b68d4d6ff2091cc096daa5564cd7982c05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cac961d009585da91bba5064d7bbae092c11493a6ea56bfdf5775c20eb1d781(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1632c95412f5025d978fc9ebfe0569c2f952c50d7d9dde6c8631df6b9f286161(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd9c142c4efec412c3eb353b7e85707ed337bda6e244a90584a5b3918caa501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249000dbebfcc7663966f5ed25e905f2a3e2764c91a22c47e71c4ca21e49c80f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f1d040a6f5b194fe4dcc2543cb49f02df01cd10731a3d3ecfc1520af0e53af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d202e7aff99c91c531f297ad37f11a950cebfe369a2b8af14aaac944b99645f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b6d29c2497ac1cd8ef9cd8fc9677ddab2455e62364ecab3dbbdb99fcd3bb13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d05a2d27ebf6f3e3d9a0f9192139f007d1b10b74f10ed266db29fb832d88a03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e768068461651cb8989687d6aaa3280fcd84e525c5a94e239fb37a6b3b4ceea(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2065e4a819fc37519f4c12f283f7189d9cb0c1ca10f69464e25203fd828e2e69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459b526b705b2930586bb4869d771c23bad41658d5b66459932256d5a8421d68(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daccbc22faed7e8c00374e61bfb27e6102401ad33f7425317c898014a69a4d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de44f8c18acaecfd31a963ec5441b86ccb3ffef739cda70400321e331df2c4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84129fa46473894a61710960ec5c200e46f70a750cf9045aa170dbace4b4113(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a81035748bcc0cdce72ec6e6bd54e0585925c5babb78a557bb1293d6d46076(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfe506270ab3ba67a64a9cb51e3ff2434271b354b6be766ed6c8e1add052024(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5772ce3069510127af97ac3cdefc8c79802c14ce7814d9b0e96299251969ef3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af63a1b109f0d5ff00f52c80e763521b509fe8708be9eef57796d2c3b307f55d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54cb236f62d5e97e9240470754db35e5ddc49ffdbba1054bba1d50869112e7d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5352b6d6722c575ef3f0870addabc2e4cc5816abf6f41c043d070aced6e775fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5264abf91ed922728f96038f32ed14a03f0befc6fe280c5f79d6ab3e31b2bbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09fba282c9c0edd5584c1a5f8e06a8c765f492f6c2ba660b6c325c59d6dfa791(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52c9d728adc654b37117a573edb5e4d1a2b5ec90ff17c98737faa36759c5f03a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f44d8078e428ecab9884e7eccfec59b1c9eef89fcb14ec774c3fc273b268b0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d66089acde2aff17bfb3cf5e31a14673115be4240cbd97215c3461a1729eb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595dead67256b11ed2aa5f2f8f0ddf1ec3471570ce01c9d80363328a4b60e396(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a76ef3f5e47ce22f406d7ae8037ee83392b6a52ae85cea85751cd5bf710b0de(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79195da272bd1bc87f0de58abc4d16717d016bebc1b3f5bb44e7830c60e07906(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b1dc8183fabf628f216df6d13f63e0c2cd0b2c4313be16137728a5ac8aeb681(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bfd975ce29c3da5a5595578d32ac76eaa924fae407ecdc7b1bd212eb7f9870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab74e24426936c9349337b5c1a3b765bd55dc5b255d8bbb1b0b217011ec4db7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161c04f386d77632d7cb558fd30de3d2b91b2db6a1ab60275f57aa2e1747e945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc18f7ab4cbe26407e8039fd9a8b351f7b2b5e793a2571cbcd8ff0fabfbafdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cf42b56175fa836713da6037a955510e46d6196484b065c04920c5c2a57ace(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9acdf4cbe45612b6a2bd7b0fd92a8f6e95d7429210a77171fc9881d66ee4d4a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6b1d1526fac3cdbadb8d3d12f36a559b5b4a8795990e6f1eb1b187726aa9b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559bddd0c58a8bba6566e2c855f299a6c23ed8897fdb7e96350e1605f0edd50d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df35c8accdd6c445fd03e6e2ba169cbafe48ca62dd60ae84429ad3ee25d6c7fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689e7a9ffba682cecdda25313991d4da5e5f2ee77921af71c95ecb14835a145b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30666e8ce8ca5386381d1300d1bf3a5029f0a9abbd333ff6d87e0167e364e89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1301ff57fdbcb4eee33f1250779611aa65c7c82fb2d81be38df5a4d3692ac484(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a061a9586776a33c6668b0416eee494dc2f3c0cd86c03ed4b892ad2263f43663(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ab9aa7c7325032aef07d7716fb776c381b85bd7349e94ccd609c857e8e0bfd(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1ac7accd1cf1f5b1d206d5ddc0d4244d32bb8815fae8dda47c51daeba54921(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d2dd12436133279c3cc6a5b30aacc28a369a1d75aa3dec488fb07c1abca4879(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc90e529cb5a8ffa01244001483f2ae84b40cd160021511c493ed40f6243fcec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010bb9c534c55a305a25881d400310bbbee3a5e7329e03f61ee17df804a5875a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7d72e53a528eaac3202bee3bbad7d56d1a95b25059bad54998867a8b8bad38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c67a0fd14d66604f321cb4275b121a723d600e81e900103544c76dc03efa05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614e9381cb2ca64ae31d7d0c10fe3460211d6ca2a6bc9d7cdc45745475d19c3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e751dfe070090089d4f46b0a91a3bf94f33418828948349c8fdc863c1da638d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d40747b337e5f5a706cba8c7e504838c8c492d39554cc8fa3e52b2f395ccd276(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96a200f3bcb53cc07123fb38220b04dafc4f901754c9cab23bef6aa18288d5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39971f70d7900731b6bbf440c585df6dc4a2e90fc67cf1f8d740b022da5a970c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f34e4a1a39ae70736b1145db0314acbff1873b519f78965001719756c24c9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4beff4e511235da87368c5090db937503b904ca48651675b6ede6b747a14e669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b851801020a96162bf79954249393aa3637ab27fd5d57953868e35e3b62336d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c6bb97bbd6d8712939494bf450ed882c92d81a0778f28057b3d73c8c12810f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86082a74da06fbcb5d023ab053735998462c87ac4a0f79acfe3c2fae762e14c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f98e79dd8225190fa6b9b9a6c7fb71072155ab75959464a3be415752576e0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70346748a6f93f354688b7aa12a2bbd4dd829bbf2e925c857845499df0ae587(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ecfbed066f19b921f1a46469ff8986502575ce94b76ffb5edfef657e9917ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7f0f522be40bdef08102f81c5a7da6e4a87eae074e593ed53787f014a75990(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76fa63cec338b345dedb5d029c382ffbfe47f09c5a7396112f436ec036cb96d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6497004f3363817d72f7c2df213081b9349b0603b90e3b84752de7f187c64df5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5dfe2474481b85c963f0963462bd2ba4178e1aa74d5fad7e6742cf67eead02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822836acb86a7cfc517ee11ace0f41b6a8361509644941af50395caa5ded7769(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__027cfe103f3ee618bf4e83c86e9cd942d5f679a7a8d859a5cf0410af2a33551f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__284c684551dd6003fddaeadc31116e0cb7596eb746dac455101da3bf8faa9936(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e065089cbd49e480e19a0fa44644ca163f90492a7e0c0dcc7d0195c8b38b84d2(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6644319513e2f90234620ea60c374c57208b17bdad86d87d2382e8e366a6bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37707c61163e35d41f1e2584257e57731478db984ac904e0c71ffcc59473d14(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010090f1134a1c4a5038d76bc106d1b42ae23fae604771d30f12a3587bbc0d8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bde8d388cbb96a717af0f8cd5e3cf608ac8441b4d36d525a71f51caa55bd9c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94efad3775d50775ad5f27cf41af55d408acd7840e2a31d57bd2936a2b1e833e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d296a3cc220e26f5c1addc5513f0fc7995e1ec62c595ae37a43835be8063f68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51b3aeb59d853a3a1576b414ef9baaa79ae9f51921493f5275c323e48733ed5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95665bdd0ec4abb18aea2407318b17c2367d3d47d2bdd96ef23266ebba2e793e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98b1f270bc346ed4355cf5f2f9d963b956018f0c4fe0e294bb8f1a49bed422f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc6c79507425e25f52fb16fa70c2c4f4fc40c28a3f5bdc0cd0ec9c4452fb1fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4253df53584d31568afd739d6c34e0abb412f9d65553dd3f3c4efb9b536c7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad55dbcc1bbab410205bb127118825da380dbe12bcc88aa4c993ba97acebf413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b769129b6657cf2208915e7efe3c4cf7e1b60b21c5c4d40f14e8b2aa2424926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce795898e139c0343f4ec9368530052eeccadaebae392829e7f6ba86d963f9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93eb616b2d9e94df8d551743a6ddf8e0dd31fa6ba7e3e72721971f7a7601b01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046abef66676de4add5031d535ab1c84b4f85c4195f293411bc9dc9ffe6bfdff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787937c7a07029aa90bb19246e962b5210a96dce774fdbb62ad83925807a55c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60a56597b3d5253535f733b8d349f7ffc2d4a8ecd40eff3bb157bf58546cd2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23e7f1deae568a7cf5717ab1e76635d8483663d672ecaa7b8c4cb28c296c419(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6d7186aad8fb43f2f59159abf99370eda82c7e3005376d85277853f8c8e007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28214947b3aee227b02e68aa91b62f3f336b206cfbe43c0538117f8b38857d3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256f5aebfe1cf29d4aaff1683219943bfa0115e4fba914834c407d7d5d3fe69b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e818865511c588075bd19c66625ff3f4e06c90465a30270250432015cdafeb8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17487ed1c38727a65caf08b1304384ca07ffaf95f3b011f1a561cf8b338d2eb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4804fe4b7472854bdba96ba007538863f6dff3e061670e83f2735cd7403d1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d5fe4ad7e0e668977e9bc9117f4fdbfd9c6b6cec90b61556c6ce535469564a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bebce284efb0cf2f65af90b58d206ffe9115fa1aa748dfff3691e8bf71941c2(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd53bd8b48abff26b49fbd492ca54c66d379419817a2692e68990cc479615854(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91edfd3411dab86631a66777b580e1228bff268ce3851d074333ecf3dcae5a67(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec6f8c8f8114c2eb6860816bc6dd790445a19111e7a2a006542477ec608ddfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0618d0517238a138c6d917dedd0cfc1ffac5204e13517d04ffc58ee23a73d623(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbede664b0fefc9f6e175f31332e186830e5a48d82ac86dad3d248c4d0dc965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16eb4984b38cbf8f56a93a6b222f064eea4b05704dce81308c2f3caadc8b18f8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a7ec99b8f8d6f60fca94ac4e6be48c7c98a8ae1ab1622b487e95cae5e01db0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0370a3a242b94e448b7d0ffe2a50cbca42ce6b331efb20d718b7e71a2375a924(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca13e3dff4923da32e16489b6d5b58f95d52f80f5cc9245a3e9f4aef759c10c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5826ac08b6b52a8b1677468f7a20a43c930ff3e46273d1534e3ba16b8e785a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ef705365721942d4f2dc2543cc8b2e244cbd0d089feea8454f40a99f0d82c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7839eca006885ee2f7820ab3d42e32edf07cf9745768201398a99ac621ea613d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91605e02e3524365e1b33585345e6c84af8db6a6925d02ecd135257ca029d049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df29191484c16df2a6210fe24ece6fd403f0004cc7ff4ea7cc7b9761b8cdfd75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c7055f70973bb08ade9f00570bcc0012c2067166f62c4d78810f78cf1d2d4a(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5cf7adcc7213aadb28625edbf08d425219f0def67614f444f6d24c0560d883(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21784abef0be0b0cce622d8a0b512b287f6483e760beedfbdfa1a9390a2564e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ef9fdbb0c8bd196c7c22aa350d6415d5b55ac0b7cbab609321094b5f0da5d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0dc8ff3bde3858d3303f434b47a0f10a2f8d31d1d80f3260b077c694c724e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a91786889ddb6c834afdbe303180352177c90c8a3ce28fa61b04cf5cf37e38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88cd833880c91d59075a381051b6b04a8bf8095d68b8d9328734e4d3f226c1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2bb15eb2f02c5b07aaff78575491483e0f92b7cbfa6c7b2299d8928c4a0ebf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8578965530ab36471ef6852200a5b74410ff642f5308cdce2d059d2c5f5e26a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9498783f055894b77734cf99bd029b900cc0ee70884c59ab1da96f30a131d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c352705e648b9ee01bd0bdae5a4ff070cae222df8b0de8d3720d085d625acaf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da438d67374c24038c72cf2540b59c00ce1b6e5ea61ad37387084663e13e241b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3dacc9416f779e5762dcb80b4b7c06a1d13213ba06b0e32189d1cbe31ae1825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e2f79edb52bbef1537b66142611fad11b4aafa8c285412c0934c3e99f17148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03670d1812fd7ac066da673c022aa4ab926db2d9062f740b69ae25fc9f808ab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d78835d6ab3a84ddcc1fd364c38eecd6dcd61ad01c0cafb9c9aed5a913573cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5663b47cb8c553515a764cd22c90b602722faac691240156f182dd3a5519dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a3745a5ff8f4525b10fadfad7145ff0ae53661e25e2afd2de12c4a4599ef36(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b14d65e8269fab8cd3bcee73d96b56b5193022857d4017c05069f8e0bf1345(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4647f8095889d570f5a2a90b1ce1683d3e09312ac72cff53d5c154995d878ffb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7df6d9b0ab12a64f2f5011b2d58c7c97da71853d9891cdd99af17daf5f734a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0995ef42625fcf4d31ad3327a819de4e6cd700d73e37b6bce179e217fcdabc94(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3cbcf3b5fb4d552d3e99c06c5de5370647d3a75a48e237f69a3eb55106a674(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4702eb128d5b57a315631e869c9a005fccdbc0e9c2aee11fd39a5f5f896190(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718f3051d5b307377e2e8ba12d843181f202d55a16d46b781927f62072f3f12d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8999b1c60f7a9833fe6c8c7eb474621da50711e4296489fc1c1a55271c36eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073eb34c18394336be0ad229e02632725e9ee2511611d44f680687a161d106e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800defec664fa72d83f94e2bb475ba800fcb714532dfd9da0e3ddaea814a25d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71230722e31c939b4deacf937bdb96eae95f756c92a2fd459b7d3b73c1e9ba98(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b11823f6396662319e99a4c5e7cbb774d99debcc552871e91477ff040c90dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf7a5148ca8d6c7ba908145ca61c4ce47a1bfee3f5e7b0b4f798c649c67b589(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847caee70a4381c0f1b12ff42302421efb99b42bcb2e515d5a38b10498fa485f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86740d7bb41609bdecfa7ffd614b96f9d4d0513bbb9d26ce97049b8ab727c7f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c138a6b6fa4e1c04781b0092e60a7c8684feb2b1f3e9c67d1272ba99918449e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df36326966afade54bfb0624a99ba06e4766c0be95dbdc9480fb8797ab992361(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cecc7c1fb56b64e3eea7a757b364a8fdfe0a3d66b678440d2fc8439c7fb12c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdb722e92eff0136e5ecf5181ebb7f471f745917a7042018e71972d06448c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb527d3f798341d42c5dbc2785198148620b6e2858050e3ec0c770a771cd949(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeca946e2a599980215d6691e5646ab419dfbc18748cc693e4ce3a02f07261ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0d67eb2678dd981823fe7edf9b5179b70ee852ba55988965d5fd96e3bc0746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2ddb1f7885fdbf8f9a935fde8d8c89f34309a31a3deb74d5272cb0756adb4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8ee42993510703318808cab4fe274cc6f0348fc8084798a39d31be97f32c38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec64c9f31c63a60aa96e9e5e8aeb77efacb56d95db211219f3c8b3fb5d79c53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd28f9ac0ffa0547f9b4c4177845a48c5c51212c4d3bdad8566007bae5b0196(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f31d563eda5a4d4d0d53f5444c67ce6d75214261837a61c3929bedf8b2b85f28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__880e397c5578b214f4e33bcd904b5e326cc77d666e0732c7634e64010ed817fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e45a6759051f8223f5608cf5439b835947cd9bff4dfc9c46256260711b16b9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8fd20dcf128d9a5222253bc46837627d6c82e94b0c044d95664a2f73cae5c2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d10e829eba9326bd177a8de5abca5e4f1e1b1145a8cc2c7099b9abc37e38f8a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f48170519e10fe8ed52b604f29281c97510e1169a86fce823baeebbbb6fc54a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d6132f8080bdc49db724c4eb3a8af91f261428fbe58e1644411554a4fac1be2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab50954c96c49824ad09288f24db00daa131babbac0422524f6e0d3b86516703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ff362efe59d23305638dbadf69e72e03dcce38b3379cecddebce06ba09b186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fd34424eb1d740fc9c065fa4b8b90578c6743cef6d9249560efb04e3d1e69c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78a13faf002cdd95989a180a4f0495b41a61cb54d5dba1e0d4cd211f7154adb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa0d58300696c63b865c7da07cb48b2488da9d8598997c580af42f8eeb1c4c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facc5b813b1f0e13223056d7ede8126e8f2ec812cc96d049584311250d08a3d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2120d6a37527e8f7bac626b72580b802b9d52649ac25e97886bec165866e649(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c643102d25a29cf49e4894a42c96e0b5dbf57e6cbd90592a86c1b9b52eae9c5b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__941505d8c61250146ebcebcb6465c9a357f40e418e772c69542add4a05824df1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd947ea50565602e81745d8a6b0f4f8086a98f123ea5fc8519a2325e8f03251b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8c5c75952edad3a74d271655d26867c4ee12d93629199d2e78a59138572718(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37de267da463aee0f6805204a80ffd676e90653d8b4598b6aa2cff959d9c3bf4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51c5a70083d7a986ef600b8fd295a75a1fb7a007adc0d3df708589af3c6bb87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997ed51758e9e8ef29e1ce22c9a06aa7c6758cf06be5db15fa691608bba33fe3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e659221de4b89b06d7a270cd3e89f91549e4004a3bab6a6c0e5494e735aa4a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b154610b8a8ddebd27506b7d6a3380d702a094091e0a3e7cea9971075f99422(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ada009f54fa9c99705499ab23047bf45a4bbd07a48c5d5f13419a24f2fa177(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90b440a8a8b3df0a6f31a4945a7089259389b88bd352946a4e1db9c7145a692(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99bbce56b35cf0046d6cbbc5b08875d32df1f7e3d4adaa345d7698713ac4e331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68db3fd0914f7de51ccff178c23106b3e7fdc794853e542a8bdc9654d827cb1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be9874615b4e5dbaef68cbda0ea9a3f80a73a0472e74662cac73203db24a8a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4e11a18e6c44d7f45dcd67064c3860e414664aa2cc52c7ba1651cfe0c389ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438c7670968626c5693d653da8c773efd159711c1bc7d6e2b4e64268c1e9d9f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d0e07c80a13383b78ce4416fe42f26f47782f93dc487cb3d6d2b3e5ddd1e7af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e204e69385bc2d1214c6e86abf30eacaa46e969bef58d3000457c083cc4556a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8416afd1440d7ce1d31705532b9dfbaa990400b6c09491accf5213204f02893a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c93d857ba80701573334d5c4f9e5b69d732ee9daeea3f8411c78f399db65c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc4bcc445b4cd2abc9a436f2a852bf55dc362cfc3dfec8b270ac664e23294bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15006f40e0d584deca271f8646a7a524fb7fb65a5d415462a4d2783ba50e8e7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e765e931bb3d84fcfea9ae7ffc8bf79c93bc81885feaa969943eef9e43dc070(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def074f42bb0007c3f3f529b396638818d40d58a252a22c0fe4a2a31bb5b1841(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92cc029dc52c3c47d63295929b9b8d85287f27c18edcda501a9b2a548e50e568(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f9ca5174d698a87906d1aa1ed32faf65b81d9a2e1f717dfd275315afdfd65f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692e67fbe2ac94ace3ce4848eacaee85fe22e7aab36edce983c25850a8ab93eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8e30ba6a20f23410f1fa9c2065cb2963b97f6cd7590742a3486c7f827ff63a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0712df6f04b7ee788188b8bf804abc09a235bdf7c5c6b2002d2e29295e600ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c417da9ae1941c8e5f425b458d4fc6c7dca885fd583519f3996149c55f3156b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b0a1d5c65043b7c2e97634a16498f15f3bbf3665bb66e49cf6b02c7c5e9a7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731d71a2e72e7195cbe086cd01c41fae8ec631d21ec0e3bc85acdf4a10706164(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429530c2166fef18da338092c76430ad0c9fbad4ff7aa74b437f87e3e89ff8ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a09d6fba79dc9e75dee68b640081fb41b5269550180bcf3345b953d2ae3dcb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0bbfea1a7de801e2d506d65f050e2f03688271bee0208e45d8ed2641b0f98bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b664e4d0cfd4db933dc24bc6d33bf9187873250c0aa748d001c7bc7ffaddd18(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e63728c05b12ff6f03bf1af038327c986520ab8b3dee956223d1344092d780(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36fc645b1c989a4fd123291e45fc419205eb323f47ce6e0342c951b0839ea022(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c8d41d60385c4f06e70e65de19024982090019e9cb0f7996a118130c94dbb7(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f350d47967994d1d30db4a42aca701ba6b7ec5f1a4ee58d2f0570e31430fa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347810b47ec8f910c85451c6a9f28111df67e6e6f463f7dbb3b5482ed903a43b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f3989819edbbfcc78c754ece386595ee320c0d10d659ed397e05ced901d279(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dffb184d107aeb12b1c49b49c38b3417112de70060ca0924777b0b6a3b79c729(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6329f5f9520de8f03dc5c1f59e8256ae420e883452fd6bac168b8ccccee01cca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24aa50d4c60abf6b583148b5b335ba68b74b376c8e178f48dbb2fc22817f84d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e9624e1eccb9034f8181e7f0f37d1bff6ff3dc7d73fb3ca7ea1af175553e05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527a1be36ee2dcd17ab6e5cd5151f22317933d3eaa5f8b2299a923ae5f35a9ee(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a881a677e952ed1220ba285113286b8d10ebc8222b74e4a996087e5cf9ab59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3390ef38f52ff2ecd7138eabe90b503dee28bcc3f6c9d50c5d069b3b95f6988(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ed7042f33be238781858d2278382e4b090518e5fb3dbc36d74409220b80edb(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f3daa9b0843de936e271ccaafd237ee87dbc42e4ffa7da5fd970300a3b0094(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872964d38fd03a792dd0332e18603ab24067cb9b6dc4b322f37f8a242e17f1e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234390c42cc92047028e80a677c2d38d3254ebf1a0c249c2b420ed418b2d7880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34eb838bdcc840d7219e57f4c41e218dba02a537da2d6f957c85d7d237c1bfa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c886ba512db6b9964345d271086e8dc2fd6e6a164c82fd15a1170c7ef8d489d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64a23f1a2d90b769cf03711869454fb5ccae9ff48c8944838bee2ab70bb2a96(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9b35c055c9c7289dd7a185db9d3d44a72dbecd30978f82a1323965b6539d60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed81b31b9124fea96687d5b959416b3e37d8cf6b24003cbe4c829fed791f698b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1965af36d80ae30033b3ffb46ea58b22c08eebdb05c0e592cfcb771c726750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cce6e1a978abfde59f1f63835eea41fd02db129ff93512717f67469d56fcc16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6c767925cf74b9f0a26bf941ebcde2e73d7e3c16980fc4a368588a95271b31(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa1ffe7b7092428de27d9e48f6f76cb848ebafbae62ac882918b344059891a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53abd3a78123a99fbf9843fd3e0edffcd7d662d82649d7c17f9277a113cfed4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720c35fb209d452424848abf09aa7a2b0afaa908dfa8eb00b4c41b5119b3bd03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4946bf8ea7d4279651aefa9c9224328161b71164205c6f0516b1d419486b8ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16481b7839701e8996d4fd85b03f891b39209785d6cea9abd3dae0b0f303129(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb4adaf1bbe54da96086542a05fb075b6c3cfba206047de7a84bb0578f52e4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe73fa98d26701aa0a9b137e1933589541558339786c854d0e285f5623df22f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63ceae050b86f1b4fd7fe2cb28f43596043ed8a57da4ecf86921ed3db7d16d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca04632f6f4eb668fd0c34c9351b836af658e626bcb2950d7fc3316381271268(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97395cee7b76688e02d39fe47a54a92c2660539aa943400b345f4695fa92d780(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5def3b9d760ae763270b395d18ff6677dbe9e6e9a53d283fd90d137c066a12a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd686ba218a7e73ae07805f28df95b62935dc92f3cd2b814a481ac7215cb7ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70b22c709f88b7bc38077ecdcff7baded6ff46defedbb2b851357ae91386edc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242a7b1f844afe9d1bf8b29e337b88a2df1b1ee81e61f894381ce17e2192d878(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3689b42369b3b11f0e9a284f0e73c3ea46ec24500d5a55052c7d13d99a2417f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4951c5d0e12d2458da348904072c803c5145b26cfdbb22fb69918d5a4f943be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf1ec11f42992e550104b04cdb26f6d6cd41ba33b4e59f09b38499555ce93ff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3910f2b77ead774eb1379a89dc7319379fa7435d93c545bf5d4189f098d2284d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30280c9f241938548f6cbbdf971b08d242f6c8ca24b68d439f0f511ad99af0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c044a7de3f8b343a9f9f6d22ce475e2cbe9f5f7c8e12b9e7991af47ba0eb56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5324f4b7302022c5a32687214879e608d5a68fbdc957c4cd169eaa0f06182bdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdd64adda75565b74c7e3259cc747d7017aa0f6877c0035a58a9caca0a7dbe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff10dcd57451654d55f23c16339d8df6bf560c2196b5a866dd03076518da3f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8deac2a309cc8db539f7137deb054308ffc0140986a0b2dac72bd551d52564ba(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3fd25faaa01a3616f29d79b22e09d27045dbc30410d5e8a9f850fb485648c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56e15477d1d8b34938e3cf71bd88fcd7f1cb2b1bda852207be2e1ba7b1542e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a66ad3344c5989d7da7fd169fad26302ee58c353d086101050c9f3ed4ac0b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66914066d22ca98495d60f80eb14c42228227792a051e6bfc5ba071a34b4e88b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e45628400700d41efe5af722c2874d9ed5c47a42fcf87b9dc1c9331eda12a23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4debf45591d71e9ee497c43e4fe0d657307917c6dbefc9f9c333236121f0f47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bc710289e1625a6818e6555b867544a8605cccb282320d9bfe01dfefd7ad87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1568b06c3ce32904b223c4a44ff189d280c45cd3fcc2082b3947f1e5beeac9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abded29739ba231d9ab31754956a69a12a250ab4437d34aca4054b7fb82c9532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b5a8196b91602d948d2ecb4050c6143e9cc129cee55e0a928b8fbcb7df6b52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d30c59803850691b8e52fe9bbae39b684da3d3708ab25433956d2c2077f19a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57e5c5b2897355d2c150aeec00580ef3cbb056fbe483deba3b7ab8c3890ba72(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a6e472162401f4c2b38c4f702fe9d3c475b3380903edeef207749e7664112e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c04838dd32aeac778d802403a0b9cc030d2f80354428b42557a3eaafc79a8b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f128242a90a4f61501fdbe8b532749d863b8239fa895599d17329e17bd35bb36(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3eddde881307c9963ba303a7678a3b27e265dd95d9f92fee2a94e5de5f71a69(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f53e89cc63ccd6c8fbf6da1ab7bc2b11cf7788d68b6fc762179f8c8209bb6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e7bda5718c7991d930662a5040a5dd5125232bf60734e964ecfbf50e14fcd59(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4bd779b7dafcd3d118b18180871bba41d17e82c11b10d2ce7fc8bce72ef9fb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83ebb48207c13e6b8d5af46a490dfe2e1d9cee845e78ffcb9ec721da308869e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15603cedd8cf544241af96fb631648b60224b8b4d8ff7fa08f75ccdbe05cdeb7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d2945816ac5b172dba3aeb568c62ba8a27f6d2cda09727131c900e5b1a39678(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59fa796e768fb6f9960030a4767a14ce90b40bd7c479cab1ac9a44e6ba2e6f26(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a192d938b550174b9e3062268cf365783e0319f41a6cc274c32308f2ee8f68(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db003e48face3ad79702f8d2c91e20d96dc3ec75b6fd5cb68e5afda21a270c17(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929ec8d26edccf8cb6465942d4f42e519af50dda21a4977d76399c6fc2b153c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe9f0abddf5ab75eb920f2b6e7925125e3a7a996f573efe7b3652ff5ba40dc1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36762b474bc504a7e017b63251621e82fe3af9ee2227d9075cdf2d7e3223e8d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a5ffe2bd7ac413b7bfbfda8d82042c178fdd08920bb0efe7478c822d127084(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4dcaf0cf07f7da825cbaa8fd335dba46896b03c4a9fbf7d59120ace2d6541e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6b3764105853f78d3ea658502876425be679c0ed15a79edf129d22d8747ee7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1026bf4e6223cad8607cc9165b4b3be60e935cb9368c20df7b6dc03dbe9e5dce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f574a6c828dd11019e6f99538b15a9ac0c1014c9890864c8027751b203cde15(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd6dc9225b179e2f94fefa23778485567f8dee788fb5cd7fddc2e6bd60f07a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732c76e99266d29e77bc67704267338d5899f08257bb86d3b7231497b4cdf7c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdce86f8c83d8f5edffd44d1fd1f0df1007141f302a3f59c871dce153c96ebed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd81264985f1edb66bf72d13ae86803239ca2cfa75b655f95b4da4449f2a2227(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9adb1a819ad37e5f223aca36c0b8ec1a2770ffc08b1dcdfe61e18ad9af6dd8a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67349bbb3336fe5514681faae0b0caab1957d84f100407c96aa4abbffd8d91c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f5d00514fb054e4218e368f017de9832c9f8af6322840b50fa3586a6ed58fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f58dd77532b66c57ecc916f5a9206001cd220bf2de6223a47e2147ddd1341db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b521b1b8d7e3495c6fcff5548657e663af754f846f593060dc6ddc753746eaf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe8b13ef1e0509c6f03d02204b7f3f58cd8cf37a70cd8f9acb7b098beb9d9a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8bb4da006eda882abb6de292c059d09a83b692d14dcdf87de5c33c5a132aa5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c904349a0422cc7b2d0fd19f899c60e990aedd0681b1217cddeb37e546f21bc(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d2b9c41fc7c0ec0b99696b708f55d1c5f0be0e6fd128de7ae936314e6541ecb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9522e94e2816a32a7a06a9c17d3ea908753ebeffdcf3724730ae02aca19143(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ec6fbf917ea1fc455a060342f9e4be6e70ca17676c05ea8d5b662ffbe85c2fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c05c18af9c9330bb154720c468d6103ff3a01770cf5e0d033fe14a26a75fb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a48750f26df3f65d28793502ad8367c29c28fc9f75cedc8ad2952bab9c9950(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefa096eeb9c2f62afe5ff52db3498d3f5212c68d6d276df0d3564f0caf4a811(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd6107d1fa6386a933da5da86c700bf403faa3089653414365719d7b6f68458(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8973f7640a3f45f383be94741288247724f043da1672ae41dabbcac3ad4efe7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf401e0b1a25e15c6164082995e32b39fc6082598ce1c26a6991a4f39265509(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a411051b667f08bc217f1f51b1eec02e64656eee8662edfd507aa88e85b19dba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337a89707ba5e2f73221ddb9f24a6db60f86a8dd7916bcc722b09db30b30be45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ba5bde7d1dc6930db46e221151d670b8372aac41ae1adaaf0754bf1c9117e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a61aa05ce464e62e45aeb6ca47ed21f384926e458442edc19bf8e7ceba889245(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541e32e482f6c317bf3e262f8fff57e5d92856420ae9f90390cbe4a8d4847ac3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7317058c704ceee2aec447158296095448c31f12c4f911a3e6727d152e77444b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__670d25422a5fbd49a8f2b7231a6429f6f708257ffab3aa2f964f2b58545d018c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d8766aeeac9df43eccd5f67a89fda429825de9470317b2b15ebeab98cd5a5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055bb97c54ac7177056da93b43a57c9bb32f5859280c3d440d14da31de21c2a1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03724ff939a370abcc342516e9259b3714e0a9c386ade57d79c407db74be69d3(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1815c5e8dad0f2bb5e8a02aa0c5d640c5e6676ee8e0e70c74029c9917663020(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61dbb85b69fd45baaa312d1838a568d64cd77eb77c52f601ffa6208d8109cf8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bf816fa7d3fdd68f23db2241fb65b7245011c5ed6c0a8e0b200b1aeae19a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59298539d8c8802082c9b99dd997927cf68442ff6acdd953c666527ae3a31ea5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d2e9d40ab8a2916032bb56f4ecb7d3af587ee0d00ac87906095a97e1e53b36(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc8f14893e7187ce993b6f8ff1f530e3cbf0d1cc1a4d2c3289fccfc6e0fd8f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e667a2a7594abbaa2e02f242f4f118bf14625e9092cf3cc65ac3e363045e7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad77d6e892c63cddf76327542bd13b17051c8881f264179471cc2c32087ef04a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc9bacdcaa6859e09f044de0ce94c89bf072cca5a0f4d75f19e2a3b05827725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867c3ea886db0fd17fa3a9eefdac7b2623adc6ca0570f97cc08ed523d7313a08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e3e66ab4a160c30ccc4604cb2f992110ffdcc0a450e54061297e9d8bcb33d1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d154e1f18e50d184c7ee2e732cb7a7e6887f80d6ec677a4a9e87660602076c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb3769e363623aca3a86357eba84cbb7abcd7de1ad7db09cec33de5d3384f6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111305d790c6467731a17e3cf91d5fe93298a98d0b2b838bbfe45947ee0c12fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180e76401a001f18d506d23a2ff527b0cad07b4abd8ffb19cd2152931f387c46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f086ed3808eecff0d3e55f686fa9b1f858dfe40ef38c60128979e0da0479ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f34096369dab43d871cb640ec1455c19e438445fecd7078a16893dc32522bba(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e639b260a2ddb8c6efc3ce52dc4a110c31f94d345a67fcab75d4131b605f8580(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6126ef31d7af3c69689448a4232c662422d8d2a6c56f5da0acabc9ece3e2dec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cabe6723fa174e4add627f260221aa0af6e321fe0fe46a4240af1ca1a16a4d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa9ff42be266d207c8596a1cdb8ad43ca4ac18535b59c04296d3dde478aaae6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9724c3e3b499835ebce8c31f33c0685792d3f998fd150a4a7367fad04c9fef93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f8de2320fc225a4b6d8632af1a932d569b40185798e1f3ef621b5f2e5ceaff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea32e2f000a3a4b00e3adcce06ab7185b4d32eb8c9b18a138e90264172f306e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8646342d815b4e64256eaad898d4b09ad2933bbeb8c458fc8f420f08d163de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015cc76a70c1c85167e0a5b1981e49a61c8033f73eb1fb0be8737fc35a04491c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44474270d24c75618cd36b527fd96115d94a62aeb64c9b47a14485fd4d3178e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143c6de46582d72cfd8362736f37a3b07e06c1be5be173bfb22de0cf94c1c503(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75dfe1d7fb4c191a0dbeea4f3f3e9dfcf43c72b4e16700e95112430b7a17f384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a81ff76c24f12cc521421ad326cea592f2a51b394da1400b20cc01af36bd711(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1f464aef313757691b67df39a768dee33c03aaf047b8078f16bd310f5cd393(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5760541bbdc61255f9fcf796b29e08e3a94731973a281c5f84bc21d6bd86d772(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975aff52431946df171f00ba8dc4781930f68137ac6d7a3cdd7ecd86b84280ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71cffc16fb6151513d2c4f0cc5cf0ffae52ab4aaeeb8160391c558ee02a38f59(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fbe74977f3dfbf0c5e685d4153ac4d27fc4066e6db8fbb42ded6066d673bde6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040b985216f06f7214e078da6444d0a6ab01c874d6facd9caa251b3a06660e28(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18dfed2ce6af14512f4ef1cb30f68a91f8c0733706a3ca355603b296f34d2255(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd33c93b4728356632acf18b4cc9885df35a9ab4a6a575659488e42357adde3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e40e8e786619bfa5c3e8432655cef6de8f8efd22bb60f618c7ec05e8d94e81a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58f02fe8e48734f3ccd52813e703993f833b2894106e37cc5f5fc17ba84cfc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d473357288b784f3bc66e385658f85d5da0479d6522ac496ad4b8d79bcf91e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526fac7190e804fc3e7120ff7140271d8d40cabd78e530cab57c6124c6f3751e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab88803b309c1f148bb18730592456641e873e6625fce007f28a9913cf06a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc2edae570034c118786ff39ba94b469a93bd92d78627ad8f75657236780c2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf9e157c3c07bc8192baef754cd5ee5a1891f1535211389226b6f47aec4e969(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3ffaaf5c2fb6bd0c5281ab21df8052f61e3c89716c794ae0e2e21bd5e116a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50bf211ff54fb684c1f3351f1f9e3894d08243a5ba189378c8f49c47e690db49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd6b18b8aa33c257c258e9de3980c70c687f3287beb64f8a57105caf23418c7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64040f0a9620ae12f1966cd5c9265311760e194e01411f673c8992f3386c0048(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acffa4f1dcbc7de96f4d054ee6990febf8c23024c04345e0c31de97619535b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f0227b663f6d19abc97b47084c21286f96e91e033a3fd7ec191948d254cddc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8554c6b9e3e27cd8032416beb439c9c86dba311382d404002edfbf4300c02574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d2b68d445222f33e8647b8631b31a409807d36e07b428f52180bd5fe6e7c3b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56af6d76ee340fe33a5e6d17c9c87db201fdc0dbc1e7b5f1b526179e9d9dcac8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ffecf3e0d9c8c92a463d22e09e7b55fc7182323e5cf57e3c9979a51df03982a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331da0892699a7a7eb7539710e93ae671de2f561b4f54048e973a2f2f7709bad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8576335f7b821291a8d7b19cc3bbb3ad1cee3efa530c95e35b1a6d778536c67f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c175bc87c432524646afcf969b674c1f1befbf27949003e6e9b0300138ed5933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7788919e8094264f92924a3ac32840b9152fd89f03eab0761edfbd8dc82f0262(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801c2b92b21cbc3428d861109b749d7e7b2126b68afe5fee5460ebfa5a7162fd(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c43215fcc284a73279944fccd31f4c5ed8fac0a767fafc213a04370b791ae87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45037077dadc86ae4481bc4b401c6bdfce9fea0771fb91af302123808a5c19c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c712ba9209fad119c5e798dc80fcac2da96eaae1e00afc36ca530e8692922e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed81fd75ca219c876b5e793126e74bca7123876439c0d845d5862025083f3c8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a48c2c105adbeb91da74be4d3bc7f69839f3a6a255a271c925f1856a62c2c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27534c203e6acf4737fe15cab33950718985ab88ba01ec8dfdfa21a81b374aa4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f51d3ebf557ef97e08fe868598337a4ea9df9204603fed50991def8eea756c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2528f0006766bfc0bc5bbb8d93c96704a0e8c1310efc686df6e47b9881ac710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2a44033ffd92f6054e6e3a480d7538956de3c56d4bdabea6910f314d280f1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402db28e832876f5d4f7f5b0be482ac2ca71416e6d077535930031fadb59a4fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d67b65a950aed6826d8cb73602a874a4d8b805915256edaf83d56b083854bd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40365aaa70645e89973149666dd2e9d67e3cf57921fbdc4ce5326f3bf2cf5d98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2008592e2c6000a954203c5418bc1800f0706ff086712426c7621ad3b9490744(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0011ad8f6fff9734be756ccb942e1b594b4890367edbb4dbf123b3aca5bc2f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1239bb8d556ee5442b10f07e85f4432c0807049a4658e6f0fe0ad609ef95c8c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0a06c955f3c0bc3b4a29c5e1ad8ad734e593618d8c0797c9bdbe6fbe373397(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37c65f27d787ecb34863060564d65a0426b7ef2246bdc3558c10a340b149b9f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eadcff0c9675802ea324b3c842897b2029fdd8fa71ebddf46b17053111b337f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d785b1c1cc11da59dc0bb1275a4b3899774308d6f8efb497576503e38afd8c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57e8aa02a9dd253dec776d7a20ba7689c0ea4afd153008235ce4e4051dfa078(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e026b0e5bba5bbd586640e8f2230b7d9040ab64635bded07eb7ae33cd9ac8ec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f12e6c0ff4b95378fc95131fb22b62c5e4a7bb8be881bef2171aa37a4971f858(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509c74794f0fbafb26ed1044315f2b90c565d374403f37277c2f3b1f14cdb6c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81bd32f50617730e1d29eef761410970b00c50963074e11a18552765aaaaed6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5c0d2b2c180b8941c61a4cbc5d04296205e848075a03a7f08440121458973a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f865de3a83ed31f4c9a690bdbc4ce24e43f2b2737242e86f3c8f2b09d9ad70(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13ee7ea995b791de498bdf9fa13cf2d04efd7035795b1c697d4d20f3cc4ee40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11aef1e51349c403f452686b8f67d124eca351f6e71ca91786b2bdeaf04a4bc6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815f0c64df302799c8ff6b02b1f24e9e9837665bb6df3491dc6005f94a7f6274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425e3357832a0e8416f99470e7a5bbd16981179240914e19c816b943b726882c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e489e0fd9760305e3d1685007aef125314c113e4b608db72964d529c1c07ca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f987dd8f41880f5139863db88eecc7c74637357a06765f0c495c82c48570c86b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3e9da2e4226b298d17fa590db92f108a9e1556c67c7719955f87e2de3aa851(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0b162ae2c6d1ec45eb94dfa09b933ffd5edd92b770b29f64d26d0c68c12d20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c552eedf0754a939106ffb089da66c7b001fca30b90219207c1af394ad585ee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2136d1c9c7fb36bfcc4a93e929ab82c3ccce5e2962199e45a46cb64ddf0556c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b92d9603ae8a9dd0f180d1844f21f87c9de5cdd41738f641ad8e71384569adb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0e61adffbf53508acdcfb2c15454e97a4ae8c7cfc17306c0a71df1740b24746(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcae54d0d9b8330f21c89fc8fb7977fdcd445f7a25924c5ebde952b4be3e51f5(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d48c2dc35ba7736d0d8aa3f3cb1c967654eaa270586331d7065a35bc62f9bd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b89713591730b3bd297357c17a9723b469208697b024217a039b424bfeb2c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dd86a305467795131747761555bbf46e21690e8b3f79e5bd06d207e78237c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c6dc65930f45d00cfb29752f83a50877d02e61d83d70d7960b3bed8afe3241(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92230caab96ec9f35b157c95921fb0403a570ee0dde6edbe9896c0aeeb5bd638(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb947360da4251beae5ff0be682de52010d80dbc213fda0f354af4d858f2306(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed6029977c2c59a63d4161799a901c9753bf65d308362c9aae9acbb3f010ebb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d63cd267f1c9eb007634130e52f5821075dab70f662907fe14faabf2853b92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a4c3a0b09ccfdf0b463f8ab627e2f5141efb3be8448748b98d49f1c9d4fe9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab30173802397aa272bb8a7843161f172f9b66b01a23c9d9fd1dfe22c123ed3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4279a1a081fe9d10397923c406e7aa2184ec1891821903ba11f2eddb64896f4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd78cecf93be0852fef70fb899cc253d67847f9c27218420c6b6e75012d2b56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e796906c1dbb7b2f54395fc79f19f423e7a96cf6669d280763f93a5ce87746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d7059f60cac9d898ce20db3122bdb6aa92d17f84f66a2fb9394655f34d07d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf732182872dea3f3878f6f1a98b994df8f1bb88c2ee6eb6b32470518adc9867(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd23e59e1f0110c5f332edb98c2ce9735f00cb71ef52aa41a452bfe0dfc09eda(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015eee4319f29d49a8ef844bb0479501f9a4ee217fcf59406ab5bf33f481d36a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2759e16aaa0bb2fdf294fc914910e93c9af854eccfd20da97960d90bd0a290(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932bf341e4562b559727de231b2c0f324ee4f1c6ef27776739b7726e1ba75814(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff464ae8d987f9057a4f9127d8665a13a341bc2b845026365414ceea481a5e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fbd253bcce69c1ee7cf5428b35e7ffe670384c02cd87d9ce27c63c893f4b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03fa8f7cbca984b489ec289d25d044d84a7a6a90d9d30cc0e4254451a88d43b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b21e75e9748d3a22c60d9f66d4e3c6a2973879c4fab24e3c4fa5c049291f8fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4919d6d634ffe0835a9373bc82d2643d2ac254d6af67415aba724d885e6b700(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b4cd8c04fb61de39e6d822f53165ed9baa46169e3c4f759925c6e01bbc8a62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c0ad8501a6c1425f4c2d03e8e2244c23de2cb727173b3c4728d881e26cc2f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f36e43f63d961c99bf93dbd7ab72b1a770fdfa808e98dc67194afdae1c9457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b01a7ccc37559e24c0f71caf66ec2ccafb5300579afb5e66dee7b499deda31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__addcfcb271d59a5998fdad950e6c1ba8d4498328c2d473fdd6f7822934af0573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7042572088941d35bbd1e90a4893fd28740eddf033ae1f1f7a7600f6823fe26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f227f822efba04ae854400d03437360f40d90735691aa0c16043f5fb3d70733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c149906c666af43361f9ae854ecdf645d8157c163d807a37872dc86b9d5dd25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1834b6c6dd59bb1fe73e318270f7507fa0ed4228765b22e91b24c98b0c4ff6(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6eba68bdc175389c87a388ac02a9354e55c16043dcd3f3884cdff52c6096d9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09eac71dc29ab66ebcbad403d894b7e07fafc9d575f6a557e7d059e2c295577f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f782e9122b2fe592763cc5771bf8fa07dee7fb93c89076b4a45fd678b1481172(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36cba6e3dd5535356b8870d42e9758831312590219e94f190298a300db54c95f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b52417dde97149ca971a51023a1fda22fa0e7429dca5664e74186fdee43d8c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8e61860b1adf2eadfbc34a43559383e54a95fbb67426b6279917a57a1faa35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607d408ecb5d7b196dbccd1edb4af700d4cb1b347c64ba11842035cd7197a1ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8a38f1c06dd715d94b08ef2d28de1ed2b62bb675b500fdf24861cb5784df94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba3cd3a2e7debd53797664052c0fdcda1514ad351ff58fb380d2897aeab7af49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9efaf73e27e4d1b1ac5bafdc0f6942d6fbb5c59340b29e824d51252d90a5731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba4da23434b63de84204512671944ae29c5b48c5e792ef758c22070fcd18ccc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5e3171836fe5df54c68fbcdb2ed025b04fb615c619fe1aa11caf0a7615a7c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10639bd069e0f585eb1f112b6be4148a5fc3f4d2a198ace95f796abbf321e2db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0602ce6024ec2f37f1ce8f9781f5400aa18c4e947b52ef8aacb871c4ade741b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce737c29bbc33b3ffccbf77ab5456d0e7a7d6b1846b95ea808a2d8ccd654c4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2767e616c94605d33ebe82838a0859df8796370f4ce0f5aae2bee31778b51e9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc724e08c8d25f4667390bfb52064227b202bb8664150c0fd487fcbc2573c9dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0566d46bb9a4c502c78493b1d77a0878ba0db2d8cd47fcc947d4b44a8f272bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0af45ea467ea61117560b52ba74ae4d9d9af0139c2721c94dde722108fab733(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4a5109ca297d9bfad22249eafe2fdc32de4e978ca87ae179bc56f3126d58b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91c4e9c3df0370f41dae946db92b173618d76ea8e7af0559506602f65603eac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d433c790289508a83428f026371ceb542c3a16530403acfeb07e5d0d77b4635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f115dcaca4bb8d1567a07254ae7f8540ee3ccab34f0cf34fcfadd5f0989a914(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29cd4fc9b237b97f3cc815366559fe4dfe677a6beba095c288cf3647b65c60d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e227c041b40058c2fa1b25af245e163a6d69dd30e4e14c2b143ff59361bf25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1e74a7ae00062a52b197b588cdbc40cb30a3db1ed80c3f037cfd5078325d89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe50bb1e964abcb947bf4b6084c3f2c5a2e9d7b12a24b12502c50578a1a5c727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d12ee97e7936cfdd199ebf05c55f966e0413f92e60428caa276e9b18d6e20bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e26ba29261b64b79148ccfd539400e08abfc375c95f5574de2291d209884706(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e2ee49bb304869e8cabc0cf34c8866604ba9de4fa72c03b92fbcff931ddbb17(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6beeb29c92f74f5bf4d107888efc3a50d80fd5a4b8bc296ed65ded43fda0b3eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921f73fd03e0c8c4f58f46445a3f12d674a5777a3bb741db8b52e12a3d020d93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1615a798281b99f03b3ff18c511d77c023c767fdbd2f30b6f5b4534b7f6d9679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8922ba4fc2a088d7530997eb3dc85af419e07f2d8378d5a39862121a02c4f4d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c81ae3737e130e0b35b7f76c6daf382787ee78aa725a3283883b318b6c2be69(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed1a6eaf358f577a7340036778fbafe987482ad83aaa4473fe521d378e3eb3f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d754c405a034042b35ea28a9761e6b8cfb6b03d383c89ecb3220f6087931e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e7310932e0cf88b255c7d3a14177cd5ac735feb60e808dd03422ef03bbd210(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c1bc41c62d861f3efd77b53724489114fc7da60359226b482518480e92d501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a960065a2417718f8f85958ff584a0fc70540b50b799fca84e63cd8831faff9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0284294bd7a48474e26fa378916d8f612659462652cbc2c2a8160f5f25aa9f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b56c0ea29e502c376c9e1c9128ef217293f8a26f0f1389347b3352510f81c49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05eda0fb2693aa3ea5cd5fc93c711b5be4879a64d4a5cb8dcedc81d22a45eccc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746fa4bfceee461e779bc3a78a0af7a27bcbfc985e2eaee111cf36eaea9332f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68b2b505d32eae5cdcd6560144731efa3390c0cb50adc8a65231c6ac9794979(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2810b97d8d6e4ac6d812bfa7ea10ad8431a5e7f22745cfc3fa1cc7adea51a240(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a6dffa091ee53566225614a55c2ce7bca0bdd03b11973ed63b0a0375a80410(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923e6ae20d747424b27dfc9559546954b6b0107c7ebb3f25469ad672fa31b38a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb86481b63dc61472264a30364099bde44cec6ac0e3c7846d1abc2665d3fe2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffe660538fc9241143b5ef188e65b4afc9cd09ed51e44827e5c1a7ad75dd2dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610bb969071ded2266dd908fd30e7300b423d838fd80679ee2057101b54bbe48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85c87459f19ce01bb3cb746d2d34b97eb1985d9149afe0d5b56d419757cb720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec574dd0ddf481f173764ab1d20b589828c9b2994f4b08b96e78e4dd8a2ba6ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0b87cd8dee3bc71c0ad42e358960d13ec2bcdf81a78714d573b29f72cceaee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0338d57188635dfecf51daa7978faf98df2edf4cf10b67efae9e58a2bb5621bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52fc767c7c20274ff5b6693afa55e201e8a50bb5e118a4867e16ecead131d0e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7f301562c1fb9cfac7db41fdc1a2f156d2c67195d81196b36161e3d5051a18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed099d0f92d5f250fdebd3e1de0f92b36b4598c29cd4ad1a45b6aaf6a4509243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5c2d11ca8a5b71c723e7ab3ee32c1ae14a7857b8a5b7290a70d977239c588d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d983200c2b35a6f265883a4fb278ad6de8d1a4aec7525ebf51f3f1c6056afa34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd0dacde3579190b30aeff6e717bd1ce94321bcb1c7aacf2f16f87d271cc797(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f347de0d69027ce683829cb17f767d5ef98034e66cf4b3faff82975eb223243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09358d033f84569fa3317dfd19f14eb0e92a51de4dad30b968e7cfeeeb3b4769(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7200337fdda17b980e8fb71fa318486f59a8e0cce325d00c51ce056991753d43(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad04e0af8ee040f9dd754902cadcde64e98e1fe97d3939322fd1d14690bd5b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd01453c29bb1aead28e5d9adffdec8eb2c06fb1c0b56b90f0501bb49a15eb5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25c019cbb511bdb542939ec3beabe9dca2ec3469904f650b03d35c8f9df6988(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aafe148f01d648147a2404d586ebbe6d918a6e5a7781f83a6ca6ad33fdeaa54d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9cc0f5c13e451bd664c8a32cb6c9e24dade7a08a60ff1c39fa203530c66b8cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d2e21f7424c8f65992b6fd6af70edbb299db10b572f4d9700ad78726c5b923(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326a71802d5b164c01882bcbd0393708dc22d0d000ea022356d3967332454678(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90985ec797d9c40adb624ceb6ee11b76825650453805c2c921c4d1706fe74bbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5efde369ed43da764c66118819ed87f05d10635eed800cd1d661df57df9dfb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58180cf262383b009a99c54b8dd532b327ad30e40ddfe5020b5edbe9535c6961(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d23495667171c705a2dce039d0205047a3b7d7603b5bf958aad16f1450f14e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236db6c83813c56647f65c0a1b0f3f5023ad39d7474767885db4c29e81142ccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287c417093f70fa6939e426c2b0cc71edfc3d438546489bb68744fb0944ba9b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7122fca07ea881361931f4d1c633955b6b81e77975bca3bb868b8c565da1c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da387b33c6798b99c3c7b8248f06f66284398dd4a619591e38b1722021ca3bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e99eafe0f4410d6cbe84907b14360f86a913b2c47f81e5e38a717380e0631f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21285ff083b34e83b3fcb95cb5a414896ebbf4d87f46de889f1c96f9d866cbf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab06d1d1dbbcf15c4d09001805603eda9df1a9d3371cffad6514ff681ae2e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821782504a99b684d76ff8617291a0e31df3f792d132f332ab282541893ca77d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0437212adf7b1a7d287213e3500e7bdf64002ca327c288a874167313b92e6d2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a75d63655b71ffdd68ba129175feccecbde163484557e9680fb104a3fe6c388(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9cf6e7ecf7cf0c8bea00d94196aa1011bf0140a7920679a33c4cb7563f05f66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__168abed2dca5d46574c71787d5001c5bddec8fd5c8a93e68c4f5be1aa378133f(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ea1aeae92c7c802bbbab046b97a3ab97ba4aaf522b89afbd969f2c3736b9dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928e791da7ba424e8a3514266e4d0db164f0f718a489c47a635e4c847dfbcb3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97336606265238ff4a494699d7bc7c826cef5b36cf73eedbc1b5f06dc57b9a87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab948a4df800e1a3984afd77ca8bdfcdfe52895c3313292553482db0c5bbc3f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45aff22c665d2e742c02803c565be5c9f3957ca8c7f99ddfe787e4fa486f4c39(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc2e0ce711a2b1aa653f9a31b826daea249acb751a07e97aedcfc398b2e3dbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8523b9bdd7575620b00dac6a29cc22a1a02c699cabffd0862169b8c7c86bcb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b3169631c6a9687a86b39e006ad440aab2ae5e5b977ffc06b1a83d1dabd128(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e9c7b37719e48b5facf48ba40526a5bce7f831ba1d955e50ddc13a605b11df7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90ad5548823659b8b0e0340ed51834774a3251bb44b6e636ce864a98158d266(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a109ede6b32c5231b737a0dab2e86e0e48d09888fefa8e2748e6ff7c860fefe8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd95746055bfcf979b59182f0e0e6e58c33b6ac56c3f5a6b836fdefa62c450ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e7a58c54aa518a0f2bd692a50ca97fa0a38a8cb58d79d27032333a13dc9b4e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982f7760157f208b09ee57fd71222563834be2dcd30d942bb9d2a0de5d6370f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11cf42530e9c18f684d29f294d3be1200849176e03b8ef1ec31cf1f8a8cf282b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63635c8444b4ae62dc5a28247b65ef0cbaa25c5f589f5cea1bdcddb1543d1a25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd5f55a8cf4223cbdb2e1136658e9e6030e7d4832b54c929e3e9cf3af670149(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70ccd976388c6491a96868542d8c48b35247ec7104bb8a0067037f67f6dfe1b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fba62e764f7e467dcd9777a76c5ab675890fbacce3943f026469585bc6ce5ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f82e02e3fd8a24c2a2d8acfb51ffb0b38f28fa601d671fe33246ffcf401fee5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b757616387ffe89d809d4d1675bb26e4d1d03672d11a85ed3ce1a09db26e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002517ec829ce9c7c7791e124fc3938b0fc3fa19fa673deae5b6ef8ec1c6f3df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32de93d61f6c3376b1838a8fbb977efb8b0a745af4cf780c3f23e79375d1b0f9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893fe3a173244db07e7abdeea05cdf16555f2025958010c5e7f9045a944af88d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb5e9a137d6a377d8b3d22dbb1583b7f59e747ef59603b256a8f21580d18518(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d7af5c5cc7a4c1eef460180cd36ac0440b9ce17c1f7190205e9be6fa540afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03daf42190607178faefe2468334bd1525439df33429cc6a34cd678855c3ea9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce63c38b5d81c9c84bc0afae0c692232fdd13c5afb715666c3bf14cefb094d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f7fbebe61d482071da583f282f06791eabeb43938ed3465dca0d87817d995f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce5efe09fe6f31b199846d73d0bee15b8a08c8d5c25539b6f2a835d8a297129(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ccb046735e9227d072bb661584fe4576057dc071655c396d846e0556d3724bd(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196b44322d566872819c7c50275e850c4e4b603b90e3cdff376fc7c86a75f233(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dde5e41afdb62e234682bcf0f3694f195ff88247f9259aa73243d31c685e3c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52b2692dee66cd40df9c68117391aea36a5305e4c19cc5d300d786f58d8f0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4339e21008a46169de0d9aba6f55291f47fe5931ceb0d8f01c1be5f68102f30f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3f2b291a022e25ac7852c67a8d01f2d7aa94c1acb2b2e07c69f7f713a6b6d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ace52347e1eb9e3673aadebf91b5a0dc1522f6ec8b49b600f92c22710fa6862(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5d1b242195f05172d6d1e9bbf723d780700227397f37980c58788294276eed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368d53eb5effe5d761213f6658ba3de717dd0169082f68b9174bc10e2fee2826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b06038b32fe2cb88dc3385bd9282adec3a19241611eff794268cf5909578b52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75a48fa1773f172366831e80a91721a63adf1bf0bff0bdd72da5ced55fe1859(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d069c6632318337d9330d84d5a392223a9a087098c4f97190a6df8d9aa4e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28533f2fc44a9d1df68f04cfd544a15278d56fbfb50e9c5f24e483b4e28ef7db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9b56a12c52d4cf5eab946c94191937abca6a3d3203f75b8ec433b3a171f364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed7492828ddef261cf8f82f6e83a42c2328d94a4db5e5f3f4ff4ee328981303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b39e2fd64916b9d461e3fa3e5d90405222c78d6602d90ad187f961ec14daea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8390784c8c65eed42b65a6ac9944b71556e7e7d516f6ec428ba81af29e47bb43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e35db87b93f6be316767f16f6597a2801dbe8d7c030edbe56861a884eb66aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc54fd82a6127e7dc810ce3629ee6c1c29bdb8393e131d51b4f647a4cab9c5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb4b1be4466fb27711b8ea428a444df64b2b8b976cbb69173870f9c4c0483166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3432cfd6f191c4d5604dc50c693446fac1fb501fbc3e03ab4ebd13030806530(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8fa54c24d1ca3ea6e2bbcbc3c37149aeda908d1536fb6a858090f4508550754(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32bf776b550db80767e76286bfb632d560003ad9daa761ed32202dd4f2e00562(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dee546ecada9e5cb18f852eb81142bb31502cc7cb8e64a9d34a8f75fbef9949c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707c83189bfd70f9e14a3b2e70ff711b577abc46a793e88a61057e66bb05e3fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa389489e30ed1f01db799e389afce46477ce1baacc3cee357a8e200922d7c91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517aa089c74d3aa1f75b68fbb8d94658d1d896a89311c8e48fb370f7d2a3b4d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e687ec689ef588910a4c78102482fa5d1b6371a9b015b4af6d9f6222f651044f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277ca2b683fde30679b53ae0d9d7c9cf515fc567fc538dbf50b2e070e15b2183(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b50ea44041ce45116eb262490cbfa53900ffcc317f43748f0e937cd042d9c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9776d82582f22739ee0e8f6c1ba22017a93b0f11f53bfd7d2d6e064060157b11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92579216994571d1131d545b03c741a1143ee70d85028b54a4274bffc032c4f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4cb8c67c477ee2e1b2f19fcf3f051fca657e97c04c37ee319088d59e739dec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57eaeb42e229b204e1ccafe206153159ae8551b492af8584afd033d8b8a6ba3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d2ac31e8d934ce47bd2561bc4f06bdb479cf97d85ad03b0b90b2bacba2966fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de17a9c2c1a75510231e43e751120d74d867d27dcc31c5a760d5eb4979d2b50e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__570074c096461805953924abd2d50e30b2823f7039d72ec1f37f76ad1c742421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2e94e9dc0f9385eeffaa5df57a1dc0d3482af328d098c234541636ff0b2717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__586799076ad2d60c7e89981cbd19501f83b56f5c9135dd8a1b586e650924cf05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8aa6e22f549bc69c9bf406521014e128e4cb7e8f8fbd1d2de3e4834934c523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3803706f7e6751a2666738b67d7320e7be1271a9ebd0f3210dddac1401ef9a06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a0f6dd2eb6efdd1d7281ca5bed34ce036b121b524dc6d03924368a1490caa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99592b01b37d30e0a2f81d5c16c7a4a6c9168716836174b6cbdf291f17dd0dd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280f75da82f89c8a3792959070b35c3007d9c188bb2404eb49a21d503c390511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93dded5ecfd34302bcfa3a7e06ed08a37822acf580a8c3e5d505139702af61b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2710a39844766e11a363ee64fedd4ab36de4a9f4e4bc61c89a9cf6160292d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc94a4dcebcf9b93288e581b966fdb287ca0bb83dc938fea4c4ba41323322cb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bae00f0e5658c1c45a63d8a7a382be2380ab6c98dcef4d265af71154d63b5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e41d12bc861ba57be47d4918126d1aa38dc671579e2825e6945352d5a34d83f(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f2e417089b91211397cc41e5bedf8acfbf458b1d778a82f7783aefe223d7fd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b298a519862a424675eb5d08dfb04fa9f6ede40740178af6354f4bc8c59765b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bad6a09d20685407a0d40305b51256ef257b33dc4827f978861ddb46134c00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff503ec39a27ca6b851e74c3a78627af8db5a2c1dee8943aebd8153b15fb39d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcdbbee2827a9ff910d42bddc5916e8f586ffb1fd3260fdc300eb450303fbed6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f9eb1ed4c885d3b4a8df5ce6dc9825192543eec2e133be5f11ae2cf5fc26ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79725360c16cffb64417ca363a3fe63d640a8f970f27f436d862417e71a4bb84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d2c41389e16b97914cfd082e5329718be8ddd61f774a6895c6e912327178b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e15ef44d852f4996db703bb8f046c7f6ea6fd8710a179097cee976d361a7ac9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cdff836143f827ae1bc38ffe806d97b772a91f6131de237929253e6b0918165(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f253ecc8392985aa960f8bd94f1aacdc0aaadbff39dd5b79ec62c64773af7767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d5f0ad41bf03f6651806b4a3de0ea8ce43ed805aef3eec65da95d2cebc13f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33e8385c8edfcfa21de65d6bdc23d8ba1133d969b4be87ced6ee1a83935d6a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0383e0aee78ca3901815da48ccc2513982a2fff1303f540fc05c88397fc40a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8752b33e559f404a820bec2f8e10691be753ab998e0cb528660770db9cf0170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24187d2b03ae6ea95fc7890f029406b4c5ae2f31432b589007cb82f342502ab4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9547ba7b9ea31caeb0144338e20c28b8255ab1e587d81ee5eec1bdf66a30d425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc9b7a3b616f1c38d9e00ea985956391b0ed4c0db88fbf55b44b4e3dec06bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8f304410ac79e4e27fa14f69b9098883e3ba91683c1c7ad0b148e589607bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3f49f6addbad3362d25fb1f9c37b5f5665504e6a76599a76fc26220f9f845f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14643f2a525771460850fa336dc9fdd2329f2f40c540ae66e48b3c3ad3e42bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62db95e769c23608ee773539587465f03c9501d513326397dd6d2ebc4f6ad75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fffb6d953f3c006d047d831b0e5e82a5af2b2650ed2be3831f66ccc94429c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5dba2197b823519dddf1e7a7f85a72b48b36575a2f891e27af838d0419a096d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c729fa342f13fb564a9bb017601d8e4ba21108bbc268708eaafa30fd73651302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628089053dd7ab43ae787c1797118c401898228ec09c5945a33869d93de887c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23798f6cc2ccaeced3147d82ee7ca1c3d171b0302f0cf6aa66f060d48559418(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1c6607c6c9e71a2e0d18731f1eab38813348221cc321e267abfeef4f5b70db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e31cf185f5a54de2ed584e925ce0c8ff0b1ab97052ec36157eac30d1fe183d74(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd870c7bb0501b28d7d03af589c336696098f8fe4c0dc9e9df955890345d4dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155d1ee2e5e0e8a616cdf68bcd1580c03aa610c887ea18daa2d3effdeb8649ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc2c6d6b767e862e6df3c79b2675480c5356303cc2c7b3993b38c493a6ca653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b61f76acd73bcbee294081dd7d750e95193a6502e1d620a080c1e73e8e1e8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e723a897de324b63098edb46afd8af57fcc8e845a08ef47658727d47990138a8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b784951a188e4a5fcad0c8114f3f5bc700e3bd6909328e03a7294092ce7a4c05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38ad02421742e5e5f46161e6c3614f54f1c33fffececcb5952ed29a839aed28c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f41a91982b32a2eaaeb1577c1c8386f3d56c91f01f9181c29845f203f29916(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c593b4f88d37b742fc3556a9d69d3ec78ed3e898c4653fa8cf1c562800119610(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e67d3f7645aae98c36c09387d58eea12816cc59df0d08b5335eabd179c06a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d68d82810a38a0f0961997f122f38e5e6b0888fbeec3ecd816f53fc1702bc30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1816b019da746d6e9612feb3199955d12f9368abf6178f36422e28484e92008c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5441d628c97d1eb942d7b7c0aae3cf041cabcb4faae4e2ce993e368a6c035670(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad4ff6a3fcabe6df43ffbe39e821fff24836aeeb20eb5ee835eb9bbd60bac83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9102510f2d7389d2805b53b71e820dc23b88ebe27656de269b2b11d09e4f4d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be40ef7e2b306cbdf4853305077858db417e96f04c7d9b8b2a981c797b559b0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6766da50650a2babaf862664c935dab35d11701924768b9d2bb87167ea79ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd69f86cc565fd39bbd1b99c06753b92884801bd69862153d91d2e6ccfe56d9a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2581ed6b4ba571d283d2f396fbb12877c62b1343824a687f6a3a8097335bf2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b42516cf71c40ac013d0379a0f75289c31d6f6cb0ff37f1b925cfcdb981c1275(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da923a8092f1848728004912476a6451a0934fe4b384a2fa87775b2779c581b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2e557487921a42f147bf9945b20e5f67c806184c4c7f072a4dcecd166a9039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5341471bb8ea5bf19fc67775c865015302eb9422993ec5638fc7176247472a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a5e5996efc83666a03855fb5ba218b3c252bb9d162de09a03ade8e21997636(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe98bd0c046c0e7aa8f3fdc84b34618bc7e91cc3af1e9d361ec0785c139653bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5706bcc404cc52c84ac500638cebacae4d034f836b7863a77e4229ca42f91f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9be3791667728c75d5f6e6c715908d2201103b87387f6514d3548c46f066763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40691ee3fed5d7122feeaf49eff814cee3300f59bbdccae933ffe7fab5b5a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b86ff50d66e9b5e2e355280f916bc0868d93e3d799ca44634a2c5153d681cda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64f258c99dcdb2d5e200e4cbc548a9a51417fb8ed32ec8d3d3a2ae2a307c9c2(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7de3d869f98877b31f8e5c25eb80e6650d6fd091795e82fe0e695413132887(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279f38fa0dd12bb056f54d8c9ff1d34415c22eee2723fef47cc7e4b31c5e745d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fd5a8ccd5c97b72007f0348e06cf2272a49470bd274df67a13fd5bf4f7f753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4375ab72092e295a47d3a076c10580874ea666174d2933e55625202eb4dcaf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726b1be0cdc18c1184532ae1c0bd63d830c19ed1c76a97d5b9087ad33fe16968(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588c1881503813065a618a43a0c72c0da805af0cd2017823b278924f20c903a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d486bbef446b35b0333feb5a4508c8963de27c1e525815805ce0490dcd218e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e44a77406332cfeb0e427de04ede2dbd9f85ecf7f6bd26eadcac2deb5d4cca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c08d02ce40ee4307b118bc8270d5a5ea391e754b30987a2349ba0e19ddd2dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a61478f195f71c4a17efab3315be1fbfc8dd526c7691f8fa3a73cab678b0f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2549cd0e21d657502e8d0bf44b38f647acf40b2948e3ac10c51e9f28b0499c8b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc3b94367a8581d455000122e846c76e3c6c67d186da5c79865508965636fa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0deab0dd57cbaf9a4c58c9660cbd093dc6b740d6ddf5cb42975feeb50448e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9c6f528b7a6c19594a588bd2d597279262ee02443cfa69abd85485e451c782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b050ab6a286c9d0bb9acb3e351c5adaee098fea4a9e4b5977341563369e82aa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c5d6211b2b3039ccbf8c9e2eb664c61bd9a6c9fe54dcf91865f17af5209815(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7089c00e14672d0847884eac62d3f7c683ac2da3b4b16e751ef25733e967e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7684249ccf9385eb0a904a23b39a92fa31b85e18f9b9ce2c6e2e3471ab132bb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7aeb2955d91e06c43c796d954ab8f0e7add50f26f2a3bfe9e9d4d242dc50ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639b7debeb0bcf66d1db812acf3f05c7f1dd88ed77a66307effe6d19c828ab2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e3aee16b2f3f5bbc56e804785d8537009e84d62f0fe17d37930d25f0fe4d90a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7eb318e11479bc09478f12b249b096fc4bb0d63beaeace462b96bcf4b929800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b07e68cafc236813e585bac2f36c8f21ff5b9b47fec2fd82f1f59d0b2281ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c640ba8c2c24ae6cd43665a7ff4f6dc43c19fbbcefb0af94b370bf22091ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731951cc61bc2037703c8c6c7eef94566ebee4295bf150d6c9bbddb485fd5d3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19836768698c256a4bbbaa97ff0ef3b6e5830c32ea169ced48c1da1fd41fc2c7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53ae16a5e7c382034eb6901ebc4eafa4023708b1a0d88aece4a24a5f7d17b56d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2342dec42edefb8779bb257a7f1909edd1fc44678eee771be85b7c909e87b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6de8ed829798fb52759ebeae20311f37c23267d01e482960987721274be11a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44029c7cce2cc461408eb9c0206a38f8b8c1bc967d10b03446ecdd6f66931b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c4110668aa5a4ea1a4b2bad0a2a5fd60e1c692bf57bce442f44a22132ad8fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac181b30d9261288b5b9d24be3413228c495a91af2579823fb21636736d97c09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323bc9612cf32ef571976e008f537c7e82db06828d7941ce67e039c236e99cc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0286d03812bbe1e2b5609fb46a300e96c84bcd624ddb12b2a1dece3b0a61af48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823b1b0ad0cb93e31da9fa9029b7e18f08285e3320fe8b487304499ad07ede78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc8b18fe50355fc8cb39bc52b5e3acca1728dbf6498f8b2a642b332ccccc123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f56211941540f063ff7a9976b9b19c46ecf04803cf8c7f25fadda58be3516c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d071fccfc6e5f45b250e62801be539d8cffa57e24387bb733426718415803414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54257faa73f801e2e8343763b0ce2da782dad7224890b28e7ca1fde3106a5f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375c83dfbaf1d38c3ced452e3d33164a6df102b98b916cd4ddefad386a532ded(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d129c913fe053a044d1006a4858ae45c6fefde045ea28ea46c219b734238f2(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c0f2cb6eb99263bc928801cec0c2e92318dba3f5e05dfeb0ecdc4c809f8d10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224f36cbac10b8775c694f5e3b351c3bb50d29c5fb4fdb2485b674a63077d68b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b023327e65d343b776574bbddf02a8a87b52ea2795814ae0a3aa15b5f7596d37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cac9affd0b94d0c39f5a6a2f50efe91ecaae9d380c38285849022f3bb02082a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8617b2571faab62ce7878fb6904b8c14763b9247479dc5ad9385c2ea9d4f7ffb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b7882469e0c2b114e32da0128bc935cc8765905dea4d61d6cf466db62ecd26(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048ca11eb02511a39a6291ccadc2e4cf9a8ef2c7f98bf8ae5ccaad41239f8320(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddb8a11cb3b23cfc0325663dd549549ec6f5e07cef5a86b9553d7f49596ac28(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b9d54e1e30fc09243ff809e781ea901a5aa04c1c7301e34db6de5c5f989d20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b9b2f2abefb3c413a5820fe3869d802ecc6434386f6d458ecf0cbf3f3b6434(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9de379e84492df9d2b166c97d1bc540a139dac4da8b144ffa0e0df9beb84ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6617825307e214d07519c2484faf6ff6dc0949cb8f4300d6580b7b2edd3e6c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933028075bb7130f500afb0d79da4b1f30f77b97ec0f124113b314c8f5f27c4d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94873a5a8df2c34086386fc472ac418eaa2f71940ea4728f074a3157b3281d82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54a7148a45224df802c7197db0d832a7404e93c87e2fdb90fef8b93c25357bd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a096b7f0fd15cc2b383ccb3239ac75a48509a376d062110e27042e6558ff2a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e92b4d9175d21bb247e69b7eee7199e541db195a2d6a7a1a1fa14755f408727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4638347e02b984c60fede605850750ae91dd12cf455b37db8099aed98727c4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c7960affa0e3dd635da33dbe348981d93a546b0f580c65babfafa0f136fea5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf259eb0adcc1490e78cf7979ab1781b78df87d8e2bfebd337222d89c02fe91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35e512ec55ee449c6e0b630e2cc4ab7e15c1934219c114bda816ca221544798(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fa163fe9b5d1cc8906b321a4efeb9db215bff9e775f96962d0a5e9dd05fca3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868806ff37276d1b575fc729092b770f7fe5b2f18af3e55bd1bb2d0e3f22b81b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1e3d95c2951a3f811b4227ce1ae4536716058c2577ef34600f7ff7b5e804d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc48dd9ed9ca9c318321b5108d4c9f0981d9d12784b3b6d80cdf4d15b7561c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c130bd69bf1514337470c3ce290c365419156836964d3c874c1642a06df298(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37631619e3c246492924e9f6845ee071adb01bcdc7593abe2dd61a682a5425f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edd0f8bb5272ed90d0281930ef355b38b4f8c21f887f6bed054d12d018d4cde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18b221a9b8c70207eedffb44d680f20210e2158738bd83f78aa55964fbc8c4d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d9db3a66ebbe94d1281351b0259158833b7ff61fca6ceb823f8a508034e584(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667a0569356e8c28cafb52442a9080b990513c08af26cb9ad3623da4a471a0b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6904e17c5c6d3c86abaa416bc507a9bd544a3f6f5b07e67b3dfc066ed7e6c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55106d3d675d2a5cfb206e3902f27e9e01b7fa779c0efc021d30e30683e6d45f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1313b41239f7941cf5ded5a885e03f3cc131170cfc8df208cf0d18a2a69f3f69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e20dc2e58feace8a603ff96b66bdc5d758e4e0d82ec8c9f8d170295dce3b5a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef1f1e8a3f23a68273d14326476f7aa4f2aa60b93c0d113fb0a6424acb5b020(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e315e3211dca9b6269e566012f7720c9be38760ed65286c412e30086bde3048(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23bd17808449125dcd8603ca46e1a26638b98a910a7183dadd915263184a1659(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248050f82a6b2a8deea410ff053df4f99df91cbb5757b622f1a1c2de39967c74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc343125048431e4831a79523b0424b2984bf86d7ff040224a6539d9f5715a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524fbeb7b4e74ab92ba1ae55a0dac794f8038f76b43b1b3cf8fde9d3e6bd9b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aac64e976a9460097c76b2c432e70af92308409b3ceb4e19f9b3d661fcd5798(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1042d982dfba2f8063c54d235c0593b198074604cfde942198e3f56c1c2918(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdd8c20bc4e3237f7d4532c44b513b19ff60a0cb6a54fffd0d2dc66221e546c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c025d82d1969a24a435bf3b01690270841f750d8c01baaf7bb06ee623e7d056e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ec90f2b8202e5072f4c7eea0f59d2992c671ca8434fd5d04decd04f2cdfebb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a32181a681ba98cfa9451ad161e71e1b2e889dd6416c953ee345957e650bfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07126174cd7b6af25d93a44126aae7d74f386b2f7512051e613a90daab0dc0eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4064ba2a1e2cf062eb7dc62100aa77f8e1c1087ce6f152a367bbcf8b082e7807(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1cda5c72b6ec451143e0344ee2c8aab41d0d44d2347ab53c33d9bc3890d8321(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062e2928f5967fa2efc9b4af0026384a2a28c4d68b7ea4ba95a867d9b3db4930(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eae7998c86141be239bb0990ba7393ac4bb762280f110c066cc48fa1e3e0973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ba4ac811462f3d095cffcce2b416d3ec375f7ec39e89dcf5abd6d3adefdf5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23e0edb9df42e8537b3a996668f5b06fa7236702867ee621a8401689279f9e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dace6f16dd3eddba01c10a5f69d2911b14b63f91a6cb2e50585b9ce0cd324bdb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7918b7c4e75e50fcdc74e68f220c2e2fcac68dd6255fe6591e9c0c834dc223b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee69c43bcd353b81e24cf3b5e6915484ff78d218948064621ef8aec48e7e67e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe29d10f4cabeb75f088bd8284abce5efb12def41d2b94fd2a53cddf4a2d933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd31854410e698d71092a242778c5a712a1222d3916c2639f3e911a22c63494(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782545bf2e2d2a3449f0f4d275c999a11139478452ff361d9501a23747c05a49(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__542eb409ae693ce3543c4edeca0aa26e7fc164505d4669469187014409c380a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0b43c42eadbc34eea65949749050575899055eeccc0a9fa81a83e6e0367d2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50cc60f4cc94c6f3a8eb972ca6eb7acba9696835725cf37cd16fd20c0732954a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58cd572bb9cee3df82defc998b05af9e6c0d40fe728dd138031308588903f7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e921e9de73aebb0d3a827e32fa8160a2d2f7fa9e0825d892b0243a8a7360880e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7813d8c7a5425eb93b5301ebfa698aaf225a0cede68ba5c8279d498d144f414b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb88beced0d59f69c1ed6cffda193ca5661c41ffe6074867ff25ca973dac44ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890784e7236213ef74ad1328474cee7af32fb34712940a73fed15b27de7d7b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5763d02da73919cbaa17af84541f08c5f25b74c557deea4a7f5734cdb7e40c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df6c11a7115de813ed3f010388cb9752d4085033ca6da2a10920077f1d7e480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2262ec1ac1b0ead227818622f44b06ecee929d72ece9497015671c0a52f6ddbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6361384ece32b86c93cf205c216c6a7e2854efe9c5b1b1e3d8883091f17ef73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c07702b0ae1140b73dbd1fafd67e3878b28d825fca3c7d278f7c15b3328c57(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96692df872a45c7e815e83155abbceada3fc8e0b456534fd8fd30eaf60036d9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3e4d72b5d92dd0467c6a438318a286b6e2a4a8e5da0d0f288cde39fd83461b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67f135138303b8b1f141af8fa81a2407c0e9e0c25193df30709dbfab74af156(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b89606af7b1927e2b75adf57b55662ba5ef757685c09a9fea0e6bb248c939e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ccb2ed168ddfe0d358967dc21bb5c2fae125c19b52850130e10b2a65bfa3af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c98fac17de350767b79a196b6da96386886aac774439e67b70631ee7e1c88b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f29c9e0d43f6b64d246235eb49ced6884f8b245d983f542fd7a33d26226861(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41241bfe881fdc0339bac9017078c924ed078b598d405fbdeff6b7d93180c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b7ff8eedf9eddf70e13dcba68a04a52c33c115d00ceac0a1d896814a5d26f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb57f49c2417e9ee5068f490c5fc638935a6232ea1999bf46a9836105be312e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c826ddd1fb8c43a05f43e2f1e801f4f2388fc3e7b4113d18f1e23779602bb1d(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fdb1b565c5f67dd09d68d57f978658866c3a7025e051bdb1d6d076595220ee9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af80e6e91877a9ec576538adcb20e4cf43e50a4e92d5389754e7a6d26b69be7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51389e3d4257b058b616b736edfa063c901f59115dc6d81dca0fce62ea9e0139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782872678dbcd4080572ff36fcb76f3793956b58d292be8b7055f01984705709(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e89369ff5ef83498355e5a3a2802e736f97b04fd0b5e3821eca4d30a73f5797(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f49c2c91f3d33aba1c57a4967c2745a7b3dfcecd76ebee3c49639324a60db5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f0864cb56f5272fd4bcb6d3061961bee2594df72cef1eb0b522e788457df24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b108ceaf34a1c936a483fdd16b7d1cd8bc6a8e5c99dfbe694fa9688a9945042(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d697c57ffa3db8dff63ebf6303032956deff1db844773f1e59d09ec87681d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cb3585c64a892c35b2888476b8ccc695b59bcddc0ef252563d39df440bd3c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed3a907edce4c39b980aba4cef4a962f64d09ad55f8630c5f767d436747bd1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d3be9c5787f7d40db22705d57b6a36c713205320da08ea066a2feef6682e55(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69933350fd4337744ba75a9328930dc40bb06ecaeb8321a9177652c579192fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cfc3e314231b7371d728c1baf337d34c3d6d0e171cfd1658d15bd1a570515aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5120373b10fff2699850e3bdfe5db33f988d9da246b62e676ac78ddb7b4a22(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f30d0c0393ebfb282c59668f2d9916f0596462f994fd6242c638a6a8940db31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51eee7bcb634cadce8acd6d27d2873edb8a60b2c9498197ff54355368c60c5dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0243fb2600ace2b0e91b6150dfc3cd18188149fedbf63e7e3cdfa3e22abd31f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0932e18230fa1df54d501f075d0d4de8e5b56ee09a2442a2648742d24af6fbe2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb83aca763399595bcfaab9087a59f4dbd39f5f60232a36da114c9973ae441d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85227ec8e0114da221f5cf4958b29b9dc0a4e474ed460fd107f62659dc480cf2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ccfbd123679ff4b4a817e804ea9b8a43437f9bd2d0404ff63e28bd8ed33636(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63bdab6b1bb6d603cc88cdd350dea529dafb3ffb24f9ebbfd14778844567051(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2b4f0472fbea51e9f09d6a9126fa196d28478103c1babef3658a3d3a3889a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd7890eb9424b1e2774bbe8e087bfdf13338dc5d82942dc0236d61bdeeb33ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c825598c53db7137068f388ba2c66698351bef6c3f2071d9c3984763556e4fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534cc2c6de8a8622e6dd6ee72ed70e0224b488f5cf77988f3bec788b1b6f5230(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d930b72245d6f8373d53ccfbd2ee20be8e7cd1b24e07c2fcf57b02e1770a899(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e328f2a50c13544a038aae99a5b5dc6003a5d26f4ed535f291ca6cf5639a42(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7cc7bcc8cb45394cafb96518148f6f773efabb85f7d7a3b2e5e5f3d0e75235(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75ae8907ad75ce7d55d343001bd999002e674d7cf9f096e2170cbfcf096b09c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d216b61ad47374d16f283e7a9f942c15116683c768a3b4185c9815c5ab8be1d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa0168f3badcec9e977444319750fd84469e99d1ec47055dfd90990f3212051(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3585ad3ec33ec68ae51e326757b8aa52d0c139e0496688c54774ff4b062e90d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8b4b08f3a7ce3a26bdc89630d5428da4ceededffda8e05293803beba02e7b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd14cb39259b600634c35d24548b550a095ccd811f95e37abe88b1f6b911b4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6e172be28d95f416bfc0ebcb6b0ec0a33de92744d669bb16ff95b504aa1327(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24ca5c15818faa6fe9adb5a56fd0eb9fb7d19e7ad24ed7365e8792a3fa6857b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39021ab3e53fc8954691e6295eff468450d8885c7d9c3f0a8925547e465af2e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b85161f92cafc2725e10ca738f11b75b9f4827d80bf7eaf172a8b54948fe050(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5e9d263fdb2825b2c411ea8ad1a119f2042682ee1c80f2612c8a19af4a1ee4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f5652912a43865099e6be08bf805462c54ceec731f4781a33ca029dba9a6e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccec55b99db96021df4312fa3cf881a5dd897ba835e8f06941931a803a879e1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e9a2265e6f0d88a6da385ca4afc604137af113ecc991cb939b08ae61fe7400c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cde74ec1a5d398643f09c9fef26cce8b4b4204cdd2798e6e6e4368f76879bc9(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8485fed9c0114fb735484624b471f30c920eeee3b766dfa72fdfb73af53d2000(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ccd02340b4457a42c791e9ab528ba96e0d9b53ad47b905d8f6a916c68c4db93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b300b6f724d59f81dfd1fc720bcc4c2b3f4c41441074d04a35f67712e56ca3f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf4b1acb37bd5f9286b57929e16cda483c18d38d5fcf36082e430ae2e8dbf40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e77a3b6ee74037d07cb3766537fcba4c0862e4d3814f4036d4dd9cc6b6ff99(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc6578dcf1f122714901424d5799b89cc98a054bb9f3cdfd3516d6c04c43a35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6d50287199ff588cbf00c191f1de068eb47c2f0bdde79cfde610dfe4e2807e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd78fffbe609ad8c5558ca2561b013011169da38ecce327df2e224ff4e77ee1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8879bf6a38b9cb2f1482ea95adc5dca6b9504cd1ba23e035efde6058b503c7d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11298c513966ac59bfe0190acf38865239ab7afb7c1de2f18fdea564ae6c1dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2430e0edc495735670e955114ef2f555691714b256361d2f79ad1df8c406ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90f000fff464f6cae64b9f907c224e6b4025a0d1fb17cccda5fde4adb483da0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c2c69660d5a1ac731a5d930810abc54b87e0fb1030bac12e40d78bd49b1c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f967768ad21dfd94a078967d96a65b2adac83730cb17ef3c9fc6286a022238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5caf8507a7d038a0bb10b9f7e66e92ca807f50af694bf0d7d421406d6fda7f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c8b6eb1a13b390f6bbc391bc4ed6e5d30c921909d3ef44fdf84f8dac5c9f86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622e891d924d8c1757d00d739d910dc367f42473e80d6ccf15878a2954c6e584(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061ca97a03fca1ede3265ed63232866f8ceda20e694202bcc781742baac7328e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757d9714c7e4dda3ce4511b04db29f2f8c0c949d8b94d6bf72e6dcc590541b62(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a936732a8ece21a6d1e07a6727bc428ed7fc6625af5f79f85b1ab864eff05b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728abd727a37f0032e267accbed8f10e58ea0664fc8fe33b4b811c7bbadb31db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192cd3c9d4bd4b4276780dc2bdec1f28f371fd6fa20ece9cdfb003f5d05bf022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ef3a1c1feb442d75fd65ed827a81ba781bf24665fb5c136f24d1a7861909c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e802ce1274737539e3b8f4ae13ff85e63a1e3083e33b4080226deb319fea7eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7e6df3dc0e158a82ff100ebb001f9bc08205485e23e52342d9687159ca616c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc2365a54c00d86af1e4083400494a976efaa362b5f2a9ea82596f439754bd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94580559ae5afd9a4bbb082cc7279c89f9da93993aca0a7ea8bc204b1d104658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13d4b6ab657e87494855c4c530406f903b285666c296a3ad59a116682dce6810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70dd6ba9355b95f5d59b00b39bf4317a146b5f81dbf0fc36036710d1f1b4bb81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd4be37e7367b1c35dd5f600d3b989455922cc65251e5d30fb4ce8de94148de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3726e07437da153acbb54b12db44203e78426fe3d46bb4b732516f74d7566bab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256b782259c6ce8e8f2cfa7d8e9d26e24b40dc2c6cb6c01ca2b9dc4f44b9b302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f39b854846f53b793e9671b0c6917e1512da869b66755e5b0988d10a4d49af1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e01e7a6a16c31af4056398f194daaca50b14b60efc9d7e7d1bb45c812a1c8793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31838d1d62182ebe69ac014a8893a736ad41239c15f34fc2f3b1b74f095d50c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960c0a517a96a3dbe9b95480dc533334d57bc0052ff8d0cbbd9ec57be92d73be(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c694ae9ac171ce9787002ba0db67ab5f0d5f3d9ffe363da79b80eed497e914(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e9b729432ce8d8cf5d5d8c78af51af1d71f557b22c9031e11f5e3d915307d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d54830d697efd6c08f7292e66ce8aa6620306537b5dadba3364ac2e43dbd14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215476a216495e4af596ae1a2be9cda778361950de5e384737a1836eefc54ffe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0482ec2972733bba96c787f835cfc230f780df806f30c4280e7252e275a088(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832f072c45901856c567ab7ab419f43adaada03f7ef3c1ea1698484e65fb25d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55a36c1adb625fba013cb0ccbdfe24cd882ca35a9c6cd5b277152fdb6cb5ff2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818cbe93d7f5cc09bbbfbab63b8c21cdbf32e15b3b5ae3d8019de69d485fa404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a602dc0a6aecc75eb2d8b7d2d6731cb92cd2384176ab4907cf7f9181ecf2c4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18c4ff69e743e8a36810eeedbbba2d56ef02eac53410a9c4bb80a3cd0939814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01342aa145f31de75b2d22739f1931c86b12a364dbf984f1f2e6d1a3dd5b716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ddf4dc9ec977dc849682580ded7b2040ed47b514c98ef0160d06f17d93c3d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2487119ed9fa160f1849c57eaa3c85b26b3cef5a2c40b5398b622070017e660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca440a41cd3c31323ba6fa33b96d68b6768c4d29871e2928f2ebf6fd776f868(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68821b0b2b8db4739c8fe0c66dcb564315531db343704bbd94c6b45d1aa03814(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e9ba2ee752e817c28cb66e89f664559ac9626470414a99592bdf60e74db93f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fddd5f4fed7872584712eb2d4cecdd0099134711b4d650c45663912b4be64e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f8bbd9bcea66fda55a39b2f3986c9cc3f6b8f5db4f2b07ff1159eb369f2c77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6412d4a193a337046ddbbc6114dbd91ce5a49623b00adcd6e2123233bfa802(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9a7a229a4bd47e123ba04ec17aaf5ceb0344da094ea74daac4d8f8ed44c8e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf787eadc93a66c241b4448ac0cd33420825dfc124946cce4e51b46ec343614f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f251b2ae04eb5caf11475db11d048154f81602dfaafd6fde1d0ca092bed0858(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f287d2ef9de95d0995ddd3122737e69723d7091985a15833cbe24c025ad8978f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1358d34c51c9a46ce613166acc4c8e331436d792e20e1a1f3f7fabc958677e86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6dcb556a3399493bbeb5017785a4bb76a23b0abf180f1b405d81f4ba953987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94b99ae39e4a7f61bd20daea07e242bb2cb7296279608e636da554660ecbf06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cc7301d711540fbb506ec3264503ca1c04541801e6ae674fea06e23c52f3af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776565b546344be6a90f17c77168d1ebad7e18673511298713bf79677ec909fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b57fc52738792c6e7236231af679499a99439ad52bf64854b5c7293eca2222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba579b78ba41dd33a7e965660691a1c5b26b0692db41cdca2acdb27df3fae425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8dee1155e9b639d00887c2e99230a6a7f2a73bd9b6075a80a79e9ee5a2dba47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bdd74c99ff46c47376a5db1646adcbffa4ebcba7ee25d8bc7b9c76c089bc43b(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8696dc6b99cf707aed6047202661f92d67d28c5c891b9c8b419864cb1a767c03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801e51fd79a56f6622216c51f137cee8b03e364e722f32049fe83c0f96fa3fe6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff5c79d47a0b54519efa07faa11b962e8f651d68fabf3625b2380c14cedb076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f1327ed9a49baa68bb1d30d1cad713ce71ff57d79b17dbea0505b34979a3a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d48490dc0e36d87ea505cd5a12dc0a5d6c21fcdd647d550eafdac2ed4a6c5b1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a554a28b6d0e4b20237f680ffde798cafa9773ad54083339e02ddc81d9762aaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e910f66efb719f4590368794115aa6fc309a77ee7a5ab2f6c7d80c9151f196(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b10b10e921d8795bbe65c338277d557a1dd73a2180e26fa4d725c9ee4c41d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ba2984267a776e65045b7717fc4b6c4515eb4f5dd2807d9ce8eee39aee87f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dcdf88161749b1f53734e00caaa97220fb96e77492888541fcba1f9ed13f1b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163fc4fc76181135b0fa7ffb4bed0df3ae534ccdc55eae099828f13f43c33125(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a318e87c6ba86f2763741662b5633b90f4e41ed626ffd609e8e203256fa0fa65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866c5950edda7f5433f6694bac66e5e70d2e6b3e9dc1002921a7bd00f5a190ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d8c757858ef6f8244972e8d7cc9a287051d88fb24fcada7ab6bf9b17f2dfa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e078c4380fd1a02954b7e9282a37008e73a9a3eb3e61d8519ed9c8201c811fb0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f76eaa2a8d6b788cfcd1949111b1101b86319ded9403bbbd2c8688e90b3fcb2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facaa311a9e4449656525ce019c6336e4dbae3996a535a2767411ae6f485d010(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec405c701be738f72effe32503e537ef35cd4fb48f97de513812e623060dc28a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2240420df20dcc2caf20e289b95c7a7bbd4b31beafbe2381699121059a31e291(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f333e33c09ff27bd62b4b7081616e7ef7687c83a2b8e5b6bd653548f235e7cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca087952ecb7c157444cb9371dda08965262773d048b9bad64216080f2a59f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a7f58f0da20dfb450f06212c75b89c2399a43398a7a7ecd842ee6f3a58c478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5951fc2442644d671ecee0251fbb2bf6f192b1c79fb8e2034b5b56236ebfb4bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1a66aedd839c75749c0252135ec0770e4b236b9e5546e935b6c2e6e50ffbc4(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e42b6cbb4d541b5e21e29f79d0e4ab78caa1b51239b8a6b4d009147d5a19c9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f610a6de9b6951bcdd682ddb69283f77627ebf08e1cc4c563112998f6e590db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8a36ac5a900d2002f791a31bacd48c41009b9f4801d18a65c3ee8db5ac9d76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbba7a3579e0930e276aab45408a848c155d2dcca4a7304f827fafa7d306281(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb8e83c196027d05ab6dc7c55ef66cefe84da1d0bc53af8d209f97daf11f505(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da91a928ca199890493d0939ea31125b96c980fb9cce248fdbf40bf18c7c71f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a70084a913a11d87b084b18e2420f0a7c74f06db895779bf5cfb624b1d99ed7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c049c2519bc6ada06efd07bd712a61c3d3175dfc5dd02fd35444a6dbeb5c926d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5937da89f07f7ed9784fa82014ac23d535ea0ccb1d9af14a9b9149eb4893b635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d9e6e51bb99d327480e17cc3fe77fe41e388acaedfa9af66be046fe80bc77c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81097c60d0a9fd5cf73a1a58b90fb71939d3b8a53c90b8db8420fb71b7f4d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef228e408498c8184c3bb1487baea0ca3647699411e67dbb078f76bac8d0478(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e75f67ec2dded60e38f20fb3b01af4e69ccae3aaff47f8624baf9dffc198db0(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc548a60ef2f375ae037b69e8032ed713af304e44dfa57aa8c33efa673e910d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54305efc6ed070877544a62abe53c36478e957fc648b515b9782cc1a9dcba39a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f74b395805ab0576852893cac4740d90b4d89f343571a94169f57046488fe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927a022e19fd6f6aa6d487fd72f35acee91490adf464d70cc21e9f2f804a2055(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd9752d40c92a1ff7e93557683679683018d513277fc31bb0722def27dc6576(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd94720af1550f3df85710e4c1163bc65c071262797628382bd5587b8a6c294(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec53c1ebc6bb08bf6c9b9e523da590c83b11ae1e44e468740958b845f5bc645(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb34a0f09643439ff741e3bb2c94cda7646ae82683bc7c77d4c98675a57b0d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5dac62282a45e99cec7794bd5eaf290a2425feb2c165eb9c7b9c79f6e9dcf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44acf24f6f5b2b461cc8614738929584d2ba14548a5560b0da542d3552b3714(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412febe6f6edf6232152f4b59636eb9d497a55b4775809a6a9b96f87d4b1cf59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3c6b70d28c5e47f75eccc60e3f683ce6c28e3f96033dd7bd6e706352f0608d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0d0aa4160a70b6062754999f9b9794fd4e513a08969aed2ce858fb49aa1599(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2528c065148766fe25fabc7681e06958592b3279d760edff63cad2718fbfea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0496dbae86c805b560a99ceedad0f777426647116faab341559bcf020605b994(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f1cd6564d7916173b3fc680e4ea63edf2908298722185a80bb5f9a6f66d7f1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56cd6b4d8d47583bb25aa528b19f92d08f16983d8c41d8c67f453e8ecc9e8c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df266d8e41f9d72282c1a52bd26fd186587f995929cb5ead5751949f6083e09(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338511c8adca0d20e5372f332b99d7ca4054291fe230f09c8a10a2b63eace97e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77485c15414243e89b862f5d0c97ce4a4e53df982f42ae3cf638135a57ae4249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f931f70c9b42996c6cac7892b57291ef7eef787dfb41e8e1c19f4191faffdba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d7213633f223f2ab1ea303b6622a9316774f2f57ff99db327a23d6d4d67a3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde2969df6032bf92a0860a98068951a572e07bb71781bb8f9dfd21f83b0ddeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926ae219469200ba36625891dd654287a4f40932b7a98db6188e9442625d0f53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc6f6df6708d616943ab3dc5a292375afb4870cf0688172ac4d4de5363b0b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384700da1a406300c62130275a9eb818eee9f81dbd4e07a408542ed17ba6ec57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af3070bcd1468863d6db5ef6f4853965a41016f6433f871789e28a0d2f391a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db8a563a4172c391f6fbcaa19e550bc674a285a371e4e743be1c129e2c859ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03dedc09893fdf81f6a05f4ca0d59ce739aacf0f018b6745118e3d43db47ade0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a35e3a7e78830ffc9b2dc4b43118b745308808824b23d8b0f2760732f7345b31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e00c94ee31303ad528cb5ac9890ec68cda0560bab0b4a74f527389f6a20addd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f8aac04776855b150cae0d80d92b52929dee875c3b586bffb3296d849980f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688caf5e011330d36c8bda606748adbcf56389e3c15cc908c4c8c063c05f372c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c698e0cea5c49fbcabc961469f7c6fc6d322de6621b51ecf5fa50fbc666f7af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8af88b312ab4adaba8d6e1f3d9aa7bca3aaef66a4dcf472df3c95d902d23ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2be676fb2b8bb021f592fde90f714250462c3fdddf16aa8030b7b94ce0945e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e885be887a7ebfe05c204d169345fb74b165689c9c9eaaa558d1349832bb810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0357c908e9b309afaed095d656b95ebc73f8613fc303876c19c27faecd85cd99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d81a6a2fb39340e2907d7302a40e3fd1a4fb7f7ec4ce747a4321255092aaea1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7532b86e8df769c783fc2d1edcc2505e9dc68ca46471a4d64f8d4ceb5bc458(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d4ecd915c1d63d16224d59ce420744ad5e8f6f28ff4589191d11f74871a96f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b426061b4355ad82eb9498b053431a6217c67b22bb129a3131667f4e030e604(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7887676c410ecb9bac1a6df3614c604705a448b072a36e609485630ae810073a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15e8e961b08f47a759260479a6e1fd6727eacd50c9f7fe0fe0a8b43382af4cc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07392add6d456f789774a6c84f94fe058bcbf089536f65ac8370f3b8e39bec3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ec70b58def03bed0fb6da7a3afedd305f1a90f42ca3cc373d93b3866e6a3ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f8bea830c771a4f593b4d799d59d457e48f04fe4641ca0feab8613db8edcd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6d8dd7eee688a2ace7ff06a302a528815b9c44d4cfa9f81c15ab9e13f8f7ad(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b5f5142b9f3e0b8f5fcfc4a183d1e2e5bc2ab1ed27c22c621e624c00494413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c06bbcbafb622fadf8fce3bcb8887bc93a37b6dbcd0ed9f61cd749f86a03a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83964ec11737cb224b261599a69fc6efc48241090c4dd39f1c69c9878102071(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e25fdacfa9c8fb9ff90d3d91f4836d79aaef5395ce61d456378f39c4639b5d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92683a0934d87f4518d837f53111b3d333f2f91606dd114ea7196164c86ca1c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e068c2f0e9da279f916d2da46debb2fff1cfb7136bbdf5f4edbd64a08401e21d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec77d9d33474e7c09a29624646f08f685fa2b40e96b34767a906e0a11e159fb3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d59014bde96437fb85a02ae0c57865ca2a1b67c03090341e0f509dae66cdf9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee716276994f30d8cd5d811419bd5ad890c18a9ab91510ce5e23d98d166f2582(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7b9c05a3349806285cdbaef60433456f6f41cfafe74c828e1ddcdd5c0c3057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b784c5f25eaee8544244c096c1ede8f21f84613827a40661124aed836db5de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a75b36746b56665a7c88481a3c32143367f690078f4a6bd650a1b229eca341(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761244ec9b66bd851c42e1844e8089e82b0616599852f1ce8954d901ff13e918(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311fdcb29a30c20a37c9fe1b1e2df1fdde2897b9e4f1cfa9e7ff8e05bc44751b(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a0b664e623c2c1e7a08b8a391c9c973f10cc2fe67de7706a6434189baf2f31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c700a682116c6cb7179e189a9fc3ab84f70e000d4f64935386e2d633eacaaa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2623b41165b5f3885894c70b44f904225f83f4946dc36b211e28fe971e332767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace98817fef3e6bdca6e1424f50a78af0ec52ebd0798702b6116b59e80b6c464(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc6bb44fae5b96683691f55a2b5ed5dc7c2b68a83c4733f0cbec8b15be09750(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e7da7be36d30f6c92e9eb0c5b926b428f99a3c561f12eb96ee6e0bf8578920(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a96268d06d60a8fc3ebf8e4278a1256f03229fe70c9cf2a8103a6a553d9d751(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03be98990ae777e8261b1c841766e96145fd01d38d6e0c1373d7e3d74acbb5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6a92237600c79afc5d6f94f8464c035acc6ee6aa669353dc86900c3923c392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad12273d1880a54bcc5c5684054fd807539eb8a8e4e31fd5608b8d187a9ba22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5387ac79bdaee0604fb966a4a26ec436ff24ad21f203aafe85337465cf057ee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f450d845b8f501fc9c93ede76c0f0cbe54a9ef8c7497695aa4f35e8d1b5210(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876c688f50e7cef7dae63b7dada4442ff580d1f0bd58788e8a36580207d8f4b1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5c5db035c20db6f10a407cf0bc3558303184bc48a03714b965a5db82af463d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8f9b165025f414034093a03783d39888c8ea0e5179e171bbd8e833b395a4c2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddbb5d7fdafe10f9c5f843efff8812ff1abad49fe5fd39cc0bed477a9d21e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc70f9c9c0f21618be105dbe394baf6bbd442b45ccbeb4fdebdc3ae030af7a7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c324234a2fa8822c99a505b99e67ad9bb242459e579a1ca05e975d661b1ab4a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470af8cdca476d014a0e6b99994e6e237c098776137d667a125a2b2a530b3917(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e190fe3e250ce56b4fc7f9f0a001d31b6e1c7cca1c210bfd33e9fce206c62c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b2d236b458a900177d46f1405723f443d2c2f009b1b7bcf10f3c444e8ad69b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a89b3c25059bf63352b6a742bef0b31ed64d8324f29bc4508469c3a1be6fb30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ae239699789e33ac2f9a62c4b0120080556c1a36b16dec2737ece78c69db0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad494b64663350f371d602bb3d7a9d44b0155a63e57a6116d2c3a07d9fad251(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a0ec63b32546cbec0944afff4e607a3a7a7106a121a3e98fc9e17fe01fa9c41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0b8abed3effe6f12c354f655a4efce53224c63153a4a01228ba354006f4c45(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2100e496b8ac107471fe9a83847a2337f99d21f3706edcab7e4a0f68ee1fa775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fe81691fe69cbeb863526cbe4328557f4099ccde72ed74ee372608bfe4eae4b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17208095698450a44f1a2ef20a11256cae50613333b92dced41da411b51279d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0b7b8dda66011313a5e4ac8305ed9709c4754cb36bd7b0a69cc4d1118bd1ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9754110fd550f8e72ed87b4502eb738aeef470f774d7974d3695f293d75d5cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bff7f6ba865ec9e8f38422e2bf54b2eaf865cf74021332b54aa7d689d1acd56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7a9ae501402369ce4d7cbea39f40d22134acbad642b92c1422bb9715757417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8f2c92d35b19a4888f33772229de370ee1d0936091cc73627376ebdd0b7958(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175feb8804bdc128ec3650a2d3e82147f536c87682d201f24409e80c812c3c82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8564e939d1ecab59a72344da5e0963af0f24489cdf91c5a91f12fb7627bec1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6104bc9f84dbaf0dc71efc7d67f6345bf4a0820b443373527d1405ddba26a987(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50a848a5b1b0e6e4c818e1ecfd4415eba6c0d27b4c1c593d28eef408c8e903e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb1670b6a65547ddbf3257646b2006aabf92eff51cd0a1ae063db16cd0ea2f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11b7ee558a72719532374a0d6f16df8ec866cf735c868e0c2fb29f2eb427dbc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4f409fc70c1a1ce1fe40a1f5d529deb5fdcb0bdc6c99c3daafecc9f37a73ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f8f8628507ecd791def9a8bf6eccc83c80c86fff11dbbb03c8b23575d32dd1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddf4b56b5a3455e178f44cdfeb7f27c7cd7b2ec9bbac16c15daf267fe78ac95(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c40025ce864c5b6d098f4bf235cbbfd766d909e9ca7bb0b1ae8c93383729fa6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075e133fdbde3c824da18ec527b54b762652aa5e710040b8326279d59c965f74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d503b14da308ff8e1ebbec33058a439a0aa6cc54c1272889822f081b0cc3b06f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6fd674d37496fb7e13925c7edd8fffd9c34281ffaacccb41059c54b383a5e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b4bdbaed1c0148878257749d89a9065c10d761e917aed565f75a31598c73ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a4f13772134f9ddd4fea10e4f37d35d3402047106252bc26f3e69d1425895c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def1438a56c87ccc4b900ffc637464bb33332ff564e90b1ab5ba6e5239d4a002(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e721ade666de49282544e2ba9634004ccef54560780e13065be5570582e5f7e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a8243adc99991898e7332bb402d5834a3744caf1a642f8dfa1bd087d25e6b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b94dc53e545f039a9acce665c2b488a6dffd79ee8ed53c310237d572ec8a1ab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045ff03dba607408c08831f1dca77f1c4d6949e71dab3240495f326362c89d44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b16ccf429226acb860e0e4d1b30396056700c8c395fc8a488ef742b7a561ee9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa9a6ce59409413bed19b50b1dd0e4ba70d983f049529ddf3f3d5254b2f274e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a54f5a603b6950c83fb48511284fc0dee154a8861bf6bc9e5a4ede1e10cec7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfdebf566aa6fa9c4bda9c42f1f90bebb5e6659457730651dcfcfbb113ad91bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__013b20e11d7a91a72ffee7d4207af441a0e117831263d6b7a60c997dfc5aae2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07de685c568f291f44f64459cb85c9b00ca9036cafd658a1c67fb64ab276fe1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2c4dfb3293ff40111976fd268d2db964c32a4a422e7b60403238018dc69030(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5deee080bddf8a7d34b8969c08ad09a2dc7a1fc27790505e4576e4b261530ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d75a6b413fda17b52ab1e45f8aee0972ee12a8cd3f747661a509d0af83443ddb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1764908a6e7a40860a4c170a65822f91195f8b4fe163b0219acec80df10b3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989290586ef6d4fdcca162c4826230bd08a3c493281a16d360296305fc3289b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e9ac70fb4ccc416a06bee44b4430bc6b63fdf83da800ee8f2085a97acf9ca3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbe90e0ab40fa53e932ccd70db85ee0184a0490340c051ee13be8817be3c175(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccb10ed354cc9f6699099897fc5f4639d994d3930b70af4f95c4b73369eb9fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b270fd38dff49ab7c007117d50c03b358b41f37f1c1f40e3615d2a66d4fcb7(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45aab9005d41a41af86ce5a8edbfc789aa481ff12740f3d4160c88dbf801c6d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bb24ecfc967a0ce71a2fe0c37bb74c372e3bd40d387bb05d4f093e93bb23ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3837c923875a60564fedfcb4a9873b56e02e2aa6fa5fdb3322f662d1f2ad26db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b37d686d7350656926de5e1d3a3fa82f8834b0a484a1766fe22d6b13347659(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef557e12b352a4b115b3f0fee3b160818433159e1c75dcbebe4e1404f22789d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f0489d31e4e9e5061ad8573178afd12e6006d658ad09ecc4d1976ef12be396(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbedb7be616a4db0a960d25a4b5b8caa1eb1a075caaba01a7ef3ce89dddb4cf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d169248dbcae75ff59076dac5e9af95b4e0b4b56dc78598c9dd44d3d031151b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9fb34e0c5cd8abc0e8f858fc6b640cae6a468b2c81991a518b22f87625b47a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eef1449faec3dc0a91b7553ec25f9cfbee055198c205c2005876499da004aaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a31c45648258f9c260f22aa3555ecc7b29d304f3b8174d106c26da12e749eeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e754ceb9959ba3a36c44fa89e2d90681bb13f6aabb1b41bb9b5c0a120a11051e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4aa4b439eb199b1de6c5795ac17aec1e0792432f86b642b8bcd7dbdf72db6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03db6c3158b0d0743b4b096376c891478ab88c8b17e4c994b3ec6e41948f11f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d070d89b12806d65e2dd231bd232dc3f352c0853e5b710c3c7168d4754a9d87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf0cd6484b7110b108fc03b5e88124f1de49b304d29cd2203794597e9c3f0b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d7c4026ae1f48a0a1104111d6c3a2127ef9253c84338aa2b5885f71e4e62ce(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7599ed7ac8cbd12e6c6ab837cc201c520982c56d181842673ffe65fb997c7436(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a168d732d93563939de15e7e0fae38c627422ec61f6a695c790e89d54647ca(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50fa0b7adbb9779f2be243a157736ead0538a01cb92d99929858c79ba9bc4cae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8710ad8a317128f8f8c1f34c62bf06e9bdcd355966ae084350b8ff531e11501d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d863b608fc881b2ab07664f394553065b17783b19e703d4b5e9639359db0c059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf9f03cf08b4fa640a83498d9644ff177881621b0afe2e49cfdc30a1301749c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e7f4a698e68e97d0c4eebd2e45740bbfc62900d58976394fd66044e7fafd65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0d6ac759bcb556724c9605396141d4b225d0c4c3c753212b88201cb68ee136(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f2df78405b4c5f4a7193bca45fd707ebc6287c39c1901d9167e3737b0d223c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d369b667b6c8553b76216dc4fb5ed21ca6331faee1b1dc86913ea5ff3b54e398(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19c9a65cfdbf2045d683317c21f037faa5c28eb0680996b05f938e5818582319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e01f7276d98bc06fa9ba30160cf876eb08cdf96c74569392ebf84a62ed1ddc7d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe38ef42c4ab0a083504a59a5c768e8f765c0851b684beb3b8d1cf233889cb0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c1e52bbc3e7f1887211c2caf302c68b33309df139d7489d9cec7ed13903b90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3543f83394c7a08eefe4cf659628f71f8466e1460960860f27ff7747bb09a8dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f8cbd213af2b5774df20fb7484bedb9fcc9fdcec614aad6cbaa429b5647f3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff3e41253ee807b8b1b9c73a731e874f99e820634ed97ff71940238a7a98a03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864a4ff7c5f6fb1bf89448cbc8782c9923218e625ffc429d2b40bc297ea2641a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2971dbdf0a59265c08c530b419a6c35fe7be2c73c28a49d3d60dda32d0b0c4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a65385567790fc73b6a72a19547647bc73b0ea593be60147013523e326b4aeb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d0fa880068109c5cb583b09772c1b93ab8da3c6a6e0690c1b73f6f816f368e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e193aa9d24c8919eb5c05001bffd8c76a5e71bbccb92e9b62ef37ac24ce9c2e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50938739b072727c58dae02b1e233151843e7572b383636342dbc2a83d4f04cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f6d1c3db1c96096e2d0af67d5c8e693c02569f91aa8f465c7dd44ad0dab825(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76c6fd53ac63e5a871afa5507227b38c0922af6c6b7f4841b81416bb055c086(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a211d3b0ba8fc96396e75701edbe8bb15c27f70ae91ddd71c5a599873fb31643(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82674bf9aecfd814af44b660a31d2ebff442d18fa076206cc6116df6189d2e90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b324d213091929035a07ded61ecf3025726a677f5c0bc3481f7a9ef9ff182c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35aaf6b62dfd895f0fc3055db299a27d01d6c185b591d0b59cf6e84a5cfae867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a454996f19c09f6fd4460d4647438fd1e057bf8dfe7150486a81ca6f1ad4f0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea778dcac7789b5eccff48b9ce9ba8c1596ece381d080205cadce2b2bbd53b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1652d495daa4c3d263b416705874576dfd3edcec1e3cd602772a89ed76415a8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83991f546a967b8dbc1b17848571ca22337319e8f0a9980316b34ea0d29f2910(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3993ea0adbae5345bd63081f2443f1886e51a2ab41792cff68232a12ba93b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e95e2ec00d89739eb2aedb71a881feac42d29e0d4a80e76e927eb77d97f9ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68b928c7b1b4c60967ebfc4fcf895f27c7594699a95f05cbf69e483466cae2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fcd6b2a5004501a5bf537c0204b629b65fde0fe909f4515be9f249efd05ad27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fafb4e730daedeae3b81890ffd88586166c2dce1f1aa330728a83cf08b614008(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a667902e6b3c3461996a3050d4b08f8e4311d4e54eff7c8dbecb0caeb5c6658(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad4e5a6338622b8daeebf317b2277ebc1961e42f12c0e819221cb984982dd26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03230a51dd9b210a510e75b94e5c3cebfedebb8156c14b7275137745d407a78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9b8241f7d49b12a133dd0ffddad6a450060e2a647e2468609a17748a363ba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be2043f94749460b966f6ade9e94c39c06cc753c624a7a40dea19e26f6c3b28(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd5aa766c9683effb6edc31cca6f108e287860d33b47a747918bd56dde8f48b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6bd97005f3b33282678b5d812f671c0320e75bb382694f97509aa9451750c7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291666172b4263dca918bd2239ec3870977747f94b95e0c098ba355be68ddf81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3582f50cb0f68a901f809a16203523604f0eaaa0696e502130e9693535b960cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee98d445371292a28946e0c592cad83d0ab7f3c179c6b9349eae28f87be906d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47650cf3c57dbec88c527b53e60ff07d372b7a11fc222f96066b8f695bea4f08(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1f19c6f1853f3251cf83bc213d743aaf6ad4dee3583453ed17077f7b607f0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a95475a23537f2ba94bc8ff588c8d305099a42544ffbb13636ec7c12d9c325(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43d4142c8f007cd7684ca13f7101859dea9f33f758fb111d868158be4cc722f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012026711353c92cf17bd608885f4959860294b347dbe1c19ea53158fefddaaf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1331bde7a4d3b49c9cbc3fa68f4e44d9f97dbc2c062fe76b1b90b9fe5ea8dd92(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c658e18c84b03a2a60a300a409655e8f2572363592b0bfadee9480f1a70e8da4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d19dd1b1a2cad01e2e79d4c5f8ccddadf31eb47bd2034c917eafd8fed4501f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981e63dd15035d1831f23d03de843ad526166648a81960d0e2cf323142a0bada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4848e7f271ae275ced2d7802e38e79c53b917280f5b1bd2f51fa83aa472ce108(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf35052885ca27f880c6885eca3b605adb8d97c0db821e9bc80b3a778e9e11e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7365ff531c2a33498479f45c896856d0e889a9831ad92ba83f295b54343729f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5813d2eb701a68d2a0766ba8f1f1822ee7dd0a5886d6df84ac96b9c8ed09599b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b18aac7a0aa86ba606193a21c776fe51c128ad729649730833ca741d498138(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9d55617207ab374dbff96a92da77ba483637200550a82c5f23ea2de472dc5e(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f28044f50f8e682ba32c156a15ee98c900a65c1694f29a3f9f1a744aee5dd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5d043fb81430ae00e2cdf0186c8044ad6199ddf9848e4367c4f69de61b4152(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97776d11b9d8887a21792f05c1ab689b127b9ab49b81f800c4ff85d1ec25888a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc01f6a1705a85c29c3782c66a671dbb963c0426ef8df6a4466acb7968dbd721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816b1028148d9d542e2648fab59634861a31965d43d0b9ca33c3142e8ff2a477(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1350a07e57a1696595df69a04d8381ebb4d7bc2d1f61fea6ce50243282c385(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d275a1d22241664cd06f7c7039f6a07dbb14986d68c3570403fa8df3e907a26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5105ad538f9987501e0012133b21d33561bf83335fbd76ba9b0564931e557d85(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cddb8b12bf273789415fdebba0e3773ff78972c2b8311a8cfcf32b268941493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef19304633fef6c13567ab322e80e109ee2fba48f4a368ebda7f75e2a782b011(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52468892730fb0c87e878e4138a5410948b520d680d45487bb4535b9e4ed8513(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4549cf0d8067ee8c2432854fde766ff6df36f18092aa33ab56a15e8d5f1ea087(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de199bb7dfd44fd3fd13291d69e4a00e93400a1ad5c00ce6dd3d3098303753fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fdaf4572a09af3d154dd69997996a4b46d93f6d7d37ec69b0bf338365b40656(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ab821278737f8f17b9d99590ad5b6ca29ba39083563667268bf8d4db03ede7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d8175cde67d614245f6883b41295b730be83d1c57837f7c1ddb8be16f2ff6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60bc282b0cb7e2f750285bb3dfc89047d4c46a6024a4c8912a8507dce586f626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7612e5ed466e2ae1483355e45f82abb26deab4d14acac202248dc1f4dc8aa5bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9227e1b915e1b63598ad51e299062bf480b7e1d8ada3d1162e52a5309892b375(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a15a721aff528383fdc8338bc6e9ff4740b224e53c5c9a673f4baa6e681f6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08a5d1421e839809fc060a741be76dc808278c1b10dc2f0f21e089ee3f7f4ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a61532aa7efc8d02c4be525d63485f994703fcef171cb8c9f5f8e7b378dccd16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__244c9309ec256ba2d3ea2d9796b54484f4cfb436712335b3c0e911c3fdf91477(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d7aef172a4b54175477fe1aca881f4d94d540c72495ed50d4d534e5d59736a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23027f29fe3342a7481c81e82e72a2497ce8931a945f9a69b52e938a351c1eb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb447ab50913530873a50d68d8b1c2589914e4d644ac88d5fa24e6dad9b3f21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb22efcab7ef8aa30ec6c6a606778cf66288ed5c55bd16cb6d4b4740adef755(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7bf9109b5adf275bdb8a6fa53b91d185c5e3844d6d404e5c002a219e39a56a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e263347e314d7cd2276512dc6a81aa4d4be89cc5878a8ba16291da47a534c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e45cbb83cb3f494427026c652e1fc4055d0c71fe4f5bf01d001692ed175cca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c595e68b0f802a263742f6f5e8ffc49784fcfe8095bfbc13eb814f8085918f19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c40a676aea95dcbb87f862a14eadc6cc46f0249e5b32dd38ef7aff34ba118f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b27e5416cf1ce495909136c4720470e274547c719405af7cf02e4c436b7882(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b1dd3f8f64f3fc40d1a38409392401c4a629ba4a1961633533c2fe4e531b3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ebbc38f99de203bc8b22e24d27c1600b5135237bea9518c0567b259b644fbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed51ffd25ee613cb76b5da1074fa1c411d341a5e5fdd65ac5cfbe26322f2b4fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5a3b5bcddb2ef9a94fdd3744124621f49e37752fdce4cd6e66e5284f39015e(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d777342506186489615b78997542a2eebdcee182bf54b66d38071c72cdb198af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ea0f52f3f91de1cad09e9e218f4a31463d010a7ceb36e435692ddf63a4779f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f3a4c57cea5f2fc6053a3997d3734aa85db451ad4e892fd9352b8bf5a9ffa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c630cf274438ed8d1696f2f1eac9bfa151688e621b2795cafdc1abc66ef886(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2badb2db0b8bf881d9d791c001554fa854ebe2c24bd764087799f11e92776010(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffac406d2924dbf6d71f191f6ff90f9f23275291440ed5efa830cda6d9cfe679(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f9919aae3f79f5de1c691bc163cd749546dfe09c425065d206dd2637880d0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__445180286a006b459185778fbe1f402685d5df50e3049239eabfd922189272f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa85b6daed1966c09f8690a63cb57c0c01b871faf3914fa0d3d0e30146f0f11b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab009aafe92be846befff9cc0075646cf0b896173e41cf349f78a555c6b55765(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6067fe89045a2fe3261036872e343e1b5a5e968a1de5c9b30546dcb7bf202877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ddae1d22eee83a2345ffc3f4939f75480fa8870ef41e14237d0ce5f215f5f38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338ad747439fa3f2d3a1c271e4aff2c009eb9f47c3a6fa7c5fbbdf4ed6d9ce5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b6ef418790b5d12745a93903c5ec448a8cfb6bd216e6e293b3db31b49d92d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549cd05d1939e18f3de83a3e264faa7932a2317baffae2d1f9d080768c924dbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e88420d5547a2f2338c18c490c7a437f4f07f6f805e3253804ae6f44e66c4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f50b7997c229390040b5ea65160ff3711aa98c0e851f2cb6a18de6d99163e8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b089832ba10f32e204e2a93fd13894af922e611b380486a9cb862b42799900(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b78817f409bb3cd44f96f27720595ab6011e53663aab462a0c8b8a7a00a78b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b831ea04d9151ca467daee6fb59ecd4ecdae76293aadb3a0c5371b99460f503d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa5ca684ed24f9d0d896cab1980282390978b885debf30a8824fd874aa97ce55(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eeb4c199afde74932c2bdcd9f849140ea8ccddc7a1f8e136007025886233c78(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a472def690b260b79c9faf98cfa584821a0c75d1788ffa946d6132e4b26f858(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936ccb5cc4beb9924dee2aa4d0ecd7250f96b5652718b888e0c41b2528f449fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bf77e5761f45612292ea225871df2fe34ce383f65f465f934f8533bc06af13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8ef7ada66d760828a4886704f453bcac10d72976f15e8d4d64a60ce6c48153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d5ef7cab508899daec6adf09877d1027652811544cfdd714b5115194e8de16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26779e4b7ab6faa2f6cc78cbe6610c3d53913f7ca5bd4422714171c7d4329d03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b3c1154049647f2967f2ce4ff3061a05490fd794cf0aa7ec8149235ec0f4a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db916946dad9d2a3d97f02d3ab3653b6a14429caa574daf70f578f8d83d41bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e61c7c92b491a57c2862846f30078389d0abf149ff766f3f2aeb1134a7ccc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0935cea73ec607d244919b1c6d147f0e6b7f3f1378c0e84cbe247b04cd631bff(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485c04c7e75cb2a3bc2768823fe883128a29b5ba23238e9de389fc6384e051f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032ce0e5b42b9909fef2695386dce787fe60baa82aeea3bb1470bdb244eaa9b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a415424a494ebafa2403cbc07ae55ecd4631ec63a42f9244e8c2e5a959b555(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f588dadf5939a7df1e7d8ee61e2b819c24332e428662c2dd8f2ac6e568ffa5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1539dd6cd16fb0274ed7dec9dd3b73306aec61fb05181662cc29505dcfc968ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db6a03bccee55805e6fe63780ba9e86b5013b1a13706399facb08a710685b42e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a1f468a9097e52aa0e0c9aba43e65d9c010ba4120872b66bc301e946f953dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d53506e3607e155e7e2214c46a8c41a6c7ab6e0f2bea1c365dcc42431e98cf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eeecede5ce23ecfb3753c44d69bc47847bf934a27ba701a69053295e6f9f058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5cb70dbc4760ce59cf0126dc17b42fe8795dc20aa43d500a940a29012733a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4046b51d1378eef5dd86efd1690d46ccbd6cbfc9054826d6671fd19f289e49ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff36a185f206781dca1a0ec7a37120d8e77ae0217b8009ed690714893213570(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43bff4498304f97d00bc6211b802c1463ad4cc18a96d6de51ae72c30307c6fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8c1e7cd943dc1065779ec1dd9d4f797a1e2c8061cf666f4049e6624929ca6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49bf8837c6d75dbefabd3c6aaacef991a90107008167807447849e0aa36745ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d91c7c0c8728191203a34caabb69eaf8a13c9234caf9f5942d165cdf2b68efb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490fe241235e8436b2ddd7e4011e49522494399ca088f6e242c7782bccffecd2(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e20c995dc2a9aa7eff80089cd3df86684af432562ed0e718ef5e0d2b5f0ec8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bd18876e61cda7dfd4ade0d8149c7cba096e70fc98a63f2dc08dc49280f894(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52732ccc62c22a5840e126bbf7229dde9ed00bd125a21499bc6de31330c3aff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11ba7d19c9327365e8987698b49633b8ed7cb223bc1dd0e346399481631e1f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d3157c3bcce8289d8dd2cb39bf7dcc11312179f2152b73679814d23800552b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835ca21320ba8eb8ebf7744fa9d2a593fc02001149b793d851aa971c558738b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27323e564ab3a04138cf5f3b35ad2f7b2b58b1428198c21bff5acf0024a5d897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702e0ad74be1e13606a54115b956f0f578949b4ea78fc174f1f58f938ba01f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc4a51d86e80e2640c2df9dc20c6a4628711788c4bd4d1864e79dd4a1b9cd4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd759372b9a1a7e75a094fdaa52797af4953b94f48cb6cc7a0f6ec48ced97b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56350ad2902e3610415eeb2cea8b9bca3e2006c014f7dfe5db80b157e426d95d(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91083da90216212da3ce91bd11799dea197d58fca5ce4f9d65435eeb45a44313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50a8e41f5949be402d5e6e96ecb49045d2fc461f605e041b7fd26769789a965(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c99fd73625652fe78933cc30e04946f1c6e7ecc15dfdd797046154d1d47169a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f124e1748ee53d82f9f785500ca2e7c1ce2c3a333ee2daf5a98e99f4608ccf44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15faa0f34b4eb198c777b27b315bbb10b79e9441d4b070c7a05d07ff3e8d55c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a798d282f0960c9d91e0d2aa8aa8f25502e06bd3079bb90033745e021c608da7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d84de07988b59b34afb6db5e646b4f4bb34851e0f2a9c6b3036ef2e59faf530(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ac5bc781d12cb0cce447480990540781c7a3a655d1fd80da5afa5c6b515d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dbef6e8609b3e31894072614f0d22e2fed1ec3fbc24412e2b93c0d5fbcd5a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8e923a92f75fd771b60deed93429d219a6437324194b81262e6875df0d48ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cdb30bab8fa8824ea872fd1342b5b11391039047d4e9e3bc445e962c3202d0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf26ac006869c6a04a16894dfa58b34835041825a395a648a01c4e5853262d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8506ba815e6e19d76003c94179ebc088432bb77860f5eaaab8f236947e5cf66e(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b02a569dfd782a9c27039a77e6468fe7f64ffb994877fd9d825b690ad6873832(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97f87fa8fc561365eaab5eac471ba7517419995e0ae3e9ad18c74a80bce09ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6beaedf2345bf393e083c557621acec8439c7af1bce06cbb08507140f58b6015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8578a818d5848f284713ce0684a1622a718c47ab45f93a4119b63472bfe28c56(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0616ea83e7709215e2be417d9371152ed7c2e8b40331a47d67bf272a5c858813(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4549a43bfef4d638374d1f208a328c784e00102a1e572a6c464ec890554ea9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19028514661e3930b9cad9c7294642b55b909e2164138cf025b44895bd7c2b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1e257eac9c941e11e6aeefaba77ce6f2998fa44c766ecf6678551f009fce22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7484162658816bf0f0970ee92d5c1c8c12615da904d30660bc31d4bf4ebb7e75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba047996d23d1f894f6ad7752462a4c02b82e92b0dde6cfadf4df781978f5846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764653f3586fe8772dc6f5d81463b8bbbf13f3c348f6eccc48a0a78771308ba4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1499495133e05bc74e0fb7872e6188dfbf093040ea9c7607da0fe9c61532cb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf52c3ebe58c873434e0b791233f16ef6912cd20cf10d40f6d575763ca247e0(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e394c12fc251902456820507908529f14ed367be0b63a6f052b7bc4e539c59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476470725fc0f05ac3014c6c18d5561b6db3e5acbcb5d857549033d7044709f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950a9bf239d0d5ff238c59202bc80429d1cae4ad03ed640c1a3ec73d7ba57f1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__754a8e58dad4dd5055a0755cc3a08dc3b9c268639d04e31a15172848b22e2dcc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e5f453ce38e264c4b022dcc8344dbaa040d86ffd1fd7653527c1d4d8274c9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c4598e8cf9e44d6f438ef02a70d88d66ec978b15e61c94c9ce70a917341621c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db67c8b02d8977ccdbc4394e8b5d9ecb342afcad736310940ec2c3dbde68797(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ede33fe522b1e586f0a7a1884050ed55194a09ead6c8b18c42a454acc9b79c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de848a9fd0451b2b3de13029ae0d8df6b4719ffec21bbf889b186e4dc386807(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__917bf228a1894d62494c4b1b2fabb3cdd998a49a84ee0d0d962ee84fd7b66d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b3e1d313e5839ff543de1baa6d7d3e7e8794f60a16af2f7289cac5423f4238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c596e07a732d2e759bf652623c72368d7b09bbfb2be501bde44ea837df7c6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ecb851d93f4d6a112140c90ecf5ae93e4983fb10ecfe99adcf4d4cfedcecd6(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c9444b7cef8026648023d03b3037bd72adfb6d110ba893dec7c1c5c1412c797(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c8b6606067820ff3a524583a88c36f4e57ffc007e21edd46b10a241848ba1a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d5e70a276d8ebc69c0beb9a2990fb6828955ab87839f452c0ff2c520d9e337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beee976d53e379ec1eb9ebe7b1911ca89da3ce815ba5e42c9956123ec7633ae4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3dbc765916541d763e4f942bc2e13327f9ad9bba9ef3d845a69d4b058194e9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c143943c09930797e04cafb19fc629432ae8cd6b30a8e7f703785ac5dbd831ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3378ef3b8558fb85c37dfd3e00487f2fe610e4595bf6a4c307b74426ca00bed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa6bba1a3af4703fe4183479b39342ce68dbf9ccb85aa4d175dca7c01e922bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc42ae89002d21d3106eeff7d9e42f751edba983cec0bd9eecc603224f9dd92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e782f841a63133f97bcf6391f23e6f4785299728a6ff38c9de3849728d40fc53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad04996e40b72affb7114561b107071387598eab8d5dfd8dfd1fcb5627003fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6489ad56011dd5cb0832a78a3813d762e045e5ea2f3ea27eb8cb2b1d0d166d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edeb3fdb0858a7141ea7e4319830e6741e9b93718e7f3bbcb1780bc3afc54a9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f48a2ddf5a3757d046b4982e3a1d8a0fffd571a319e73d8c89321eae16b9ec76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aac8d30ab6e91d7c53aa966d226c8d069eecdc1491d2068f110c49d19d37844(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f4277ad571134eba56df2b556c7f668fc883c12425594ad4a37c6661078a90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6160ceb4407a7fa11bcac96fce033119259ca1576aec3e339ea51a47ee2d5462(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8d6ab9990fd3946838589e33dca047e2a4fad895bd79a8bae1b02a78e27e94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__917dea640acbf03578a14013f0d3da8e25f550ab42c30c2e144519c508dd4379(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876abbc913e0cca6c365f833d704ace09a49bf0b55fe9dc23e7b726407e2c424(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fa0f7d5f6971f40bebf41a38737b06fcb9e5bf6a34e2736fc5ac09d1164232(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7aead91c1f80f722bcc8e920119ca3e434fa0cada5e547e9ae3140436c9433(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59cba24fcfde9a97f7d375f46c5b34a0a377769e66f7b7cda80c9c0e32cd83aa(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc281a5c3633ad5da2d457528258b3705b3d9b3eb29c86a225f2e764df0f3403(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9be9df8b9e71d9fd07205545cd59e28b4c4505e0c21d829f0764bc428f73dc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f97848704b548c629048ed10db2150114e6042e071412c1ca454dcc194cbba7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c455d74167d0cfa8b22d57930c9485cde6460ca240ef7935b03121190e669f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0c9a586592863794d0871342d06192d8202436aafb891124e1e5bfd79372a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d97720645b1f7215c10ba2e64e95cc73873518df6812af419705676aae5d250(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__553a7167fbd812c41084b53a143df341a39535ebc37cf8781fd67091fa5ec843(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215075f55328e0ab10be3724c84ab6b5db21285cb62841910c98146e47b50e7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463a42741b00d4bd47b418ada9946c3c1839f57edba79970a059e92cd72fd8e5(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9044d059f56949ca234cc94c6ece4befdb20ef82359ad788a17fa40327533dbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61558af0df35a38c0c0e41e54cb6c05cb78cca83ed02d59a7f90fff5c941fbc3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1912cdb02442b98c90319a475acfc21f20b32e0a515f6a3dd1d9757c0c8e6aa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39841fbe4e8b2b9fcfc91a0d6d02c7e24559004caabc209a39971f1a18badffe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf630be8c18b940e7c922964225590aa6ea4fd868102cdca58c8693ff25d93e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85344d41cfc28a5be62f8ac2852b0b5879f0ec062a9fa0f62c5cfbad45c30d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6b4c0c3acf321d1cfe74870caccc733fcf3e084bfe4fc424713541d70d5c87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6981e782582a3e3094454dd4391acb40bb455ac2b30946fdd751336abed681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ec9d3dbb5c6274da35d90f5287802a676c127b4f4eb352ca98814a893b5607(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10de39a9040e36f54b41bde6848b16c48d7492e947eaa667fee01620b49134cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5422cca463be1ccef96fd0c578130f4da460f88b7d78d37190272b34d3a6d2e1(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84deea7159074a2b6070777df676111d03cc83b58f0460594fa25e8d4638631d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50341caf5f47b96757d175d86565c27812b58cc2c680aa5c8df1e4e1eb8c5a5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a682850866cee46c3b1ad9c4e61e4413df8c5e711497a6a170b4e30fbed81f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a7d8ea663c67ce865584e9a06b28f6303307ab5ad75ccfbc194db57061ecad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ee30d45489a2d3700d737bbe2b74d1886fbf8e02c0c49dc5f9100296980414(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1530352b5d9f0212c543413715269b76cd39f3eb78adc58ef35fb377aa242039(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a99f2192c72677f5ec860ccad2220ae4a264a097352f5d4766cf653cfadfc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6096236110857e4816277fe477f037ff2c3014e40e72bd7f5dd7fa610cc4679a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1475fec58af67fc0cbdea95c59e4e4fb32ea3fb4c57ba5f10214f7bce0589909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766ad9c7c910560270d4779e735e28b1d894c21be24dfbb09e11e62051ef7426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5365b4a44c60ddff3f3b583c332dc60f3b0ed78aae300f348cc92be1c1835791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b339b91235872b00487d06b3c4e27d39f77f551f318ed733ff2b9463d10c98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a434879ded1c642c0f5d216a14b9c6833a1f8102b577f9f03cef5c895e513126(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41633f69a8a49c1ce4fc76cfff44f952cfb7cf7e3dc683e5811bcbd0f53e2ed1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344c29f9bdd1b224d3a0e7878458b3dc376bbb1283139a757e89beed8c0e1c3c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df8428342686916cf5befe1ccb234ba96f5a83e23882e6b5099826aff4e1131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b472892062c73fe48e8dcf7b953e7e28dd0d2e4b6e63bd36b00c5d69d31ab6b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9ff33b6600dbe25477880ef63e4847504548fd5e113b56e678cc6d634bf0cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833047dfbf0a6e9ac5d9965eb73ed6300a7a6b243e5b8f2ce2c54c1d85483561(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be44d11050db0c004cbb2af859a7b95e4ea9d36fac99a48c4833860a66a7ed90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8fb4851a6a392f2308943940af180f9018d176ad8d2ef5c157474b04e1a8c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53234ca190c04ff42a835cdfabc837bf71dc03a8d074b182cee7c82fd14c234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6b4e9c999f76b2af74036f26748a8b69f6939ff19b6953ec45eddacc7ef0c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85d24bdc280038ffbe67970f665ec080ee7e7718b9233b3ee94384743811dd1(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c374d96ab5832ce9cb48d228e1414983242077dd15389a52f30ee2308858e3d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06c85dfa3a482329ae011ac0b6af162ca6f6151b0229a8d0d075d35fafe3ca0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3cbca4408c29256ed421c41ffe87b6a761706203b4078b123d65191c27c689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a71c670f6722657af6c2619d410cb81d190af605117ee2a4c4924e88977c08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f6209188fe1e9ddf002d31d2596a3dad554d6cb166b668c57cd3d81b58b85f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cfbc793fe294336f6bb0c2e18fd77a6b1b0beea1e78e987eb2b1e4cb7436ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e992e767134d7fc9599ed36fd6aaf12f10273095d70ff3a4227e1411599b5c85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3d1469788de962a4c7a2e7574f7a66522477adb3a6588adfc0c6a267e7be7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a08a6a8da41f9a6147c5a2d0f4f8916105411d5e9ae61644e4100e3db600d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7399403b38ebe3649c3144248b8419788df6ddc4f6290a20ed8e93753293790(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a1a4d220d1358c0bd8f92b8b19c0e057590b9ce565d70dbf6fcb0effa67736(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd8ade1e87c5c4540287ce65c073b306a4fc93c7a876832719e0e312c898c0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bff1e1d17fa795c37128a2b604fcceb47cfc5b8c363101fd888f42597d1aef9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80d1b0c650f9cf14cc4d8ca47b2504c6b1fbd1f9bf14a36e79169f410ed36ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eff815fbb35c954dec497f6c1df6e3ce018d1c79def6aeb3dd161253b50efb1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702dd316d224ac9cb7ec9b80bb24a5e9ac11b8e80f52ee79b65748d0a9b2bf39(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8701b87bc20ac85e798e6547fbeff73e2cc9cd3f9f65b47819b5db8e370895(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e80953c634210b0444ae804c10bacd2dfd62134157e73cfa5df76d2fbe728b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab06ac29ddeef0f0f959f998aba9f600bca3906f006a556091e2741f0b262f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c26ee3cad0e1f6658a23024d7b0a876146a491b8ade373ac8849ab031c7606d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0093b9751dbec5a45cc4de2e718be6fbaa9568f6596bccb1341174af097a1fe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebdf97b3ec3e58fd077c19ed55cbd504651a0eb03a6a6b46779005441675e69(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f68eb8808aeb051bde1cfea4f648cf04130653c32fb4ad8e2ee9b234cc7659(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fe02f41a6f102b417b3f1f9575a0cc93745e5724e57ddbb74f32042113e27b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37086956fd511d745b000fb802df85ae445590b9053d179015c3d4ca083661ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7905f54b28dceeb764a477a3e8cbca082773f5c4a9f86d4253a58d2c121735f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39599bd47660a9b1531c53e0888f48f9118ab75c2d3e0b1b5326ca5a71360f83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44375104d2580bdb6d264fd8008d56a83aa3de0fb50241118a5d502b52adca92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b588e3dcd00b68e97d3be3f0be0474db3564333957a67fe195ebb300249d8e0b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b9191ed996d9e308b33b6c5dd713e4a63de0961bf4f5ea44cf59df67020f99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3953424cf442d630a08c44f5511d470641880094817d87bc1b3e75d2a7f62c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec10298ffb708e4533c48a47c4da7458538c1123d8d2f5f1ab47855aab0cf67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b1e12ade469375737a901b070e2f44cf38f19e024a294a2a553f3ce84ee2ad0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3067fb9a5035db808eb131d0ad2d818d4e9e5673b319a7754f504fe121f4850(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf363cd26034d21d77bcafdfe29b2653413347f0af1698fd81f8454c22670c6c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e3d6276a34a149f52d5b6298bc607e631cd95dc11b4da2ca0f61b895e9f37f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729c16d19f64adc5b79433f74dd577927ba84de8bcf71648f7987e60795c0fcc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998893e8083cab251177e8fe961ec89f5f47456eb77571eec72dfea2718d822a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0361c23611648f70b6d55d08de2cac02a3d1b431d6f5fc85a900e8d1022be3c4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c211cc140f4f2a52a6f9367317f00c4ba82e0f94131a23efc1029375ad06ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7d0028407e5a37bf6332866dfeac14d99e1f63e796bc830150977952c6eb99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc01b9bbfc200e00e4e6d0439468757b17e718442a3e79f09c3cb2278463c74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19b7afddebcba07971902064ecf95e983c27eae86011ed656017feba95b843b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0995034942ce324440a551a301c078e9b4469853b5e400a721e6b1c473f25df6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5faf86b5f3db9a9f69e73c8abb5e9482d83f5e90b958d318005a5a2f4265cde(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30273dc06893bde73b4626172bf1f5fd6fa78ca02f903a65916ee1e07227552(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c975aaab791ccb25de394cc70dd55ae002f603c978cbcd1e7e24b5c4362cb918(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40121c1b05f23d4f1151e0c2c65cfc874e12d371143e06757ced30cff4d35f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd82e301ea0e8fc394f9ee5ae57b8d6610d68d414a12320f977184219352cbcb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2fb987b5981c788b82816dbbfc4382a9874396f1caaae89698c67eb72a45432(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed5d22667f974c2cf44ba427dae18ce7278bbeae27d38b40044be21f0f345fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d4b1f7de728ea22fec6f959ce9cb66075496aba696048cfbd97742a2a38946(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b08db21fcb21df29a6005adc319ab5afd1d6acc2c3be8dcc918543880bcb90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d226e16e4c8d4c13879dca0a8eb981ad2c7eab521e490dfc2702ebebca6993d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afbd4c4c564289f76dd7e7499b1345b2aa3010145ad535f0fa08b033036b2eb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0e99bf4a9734b828ff324c85ced3b00623abddf4e64e5be18c96a8f05799d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ac6e3ca492489feb63bc6aa4b22b4974d1373b3186c5c59e35a91271f50ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514502d293866e04e64d33aadc22e449e44101c996128c6c46b8f245d3b94076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382ae79f1c0f94ed7b8267af2146bd0662ca426fc18a09174ba9f9c5c698952c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3438da76347594331d775dc71fe47f071f6601217549000a6abbe9b5e2d0db5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55dcfdb8d7aae6eaa257cc91307f2b2c0805ea1fb98048552b992c75cbc7239a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281529c4e30100cbb08dad72de0cdcc11a52ff9d36b402183ea6c635012d7fbb(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96fdcc2febc6f893bc25d3520c1c16f6d6e101c9c1452798be0d38d14b80dc1d(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d44b4138006578ffd72fc3721a16058a5d6926b5adeb04691ec659acbf8cdfc(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128504add62a28b89be7e598c6dba791819cf735b40c3295186c17b62fa8abd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cd1a34b4e22dfb72834c9dc425195119936f4a392dae92a57d6ef5e8fc8e5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbaa4786b2d6066ed7d7997b627410c8c0ff473e7cba5e4db5f0cff4d6ee1c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab22ed65e5577b11ede2dcefcf30ac59d701cee20c255d0f98aec43678ac05f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eebc0ec1721681b304d2940f284e02067f00f1fbf41ef009c8292a85904eb8a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e25a19c785147401bb4d7716d0c77d48c5af94871e4de8236f404d046c3bd3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2cb5f3eb2e4f335a7202944a85aa1b3a9866e73bb7cd207f7610f55393e1d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee9241628279eafc34b7ea91dea4f4f48f15bb1e47ebead21190344113e50010(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e12db5efd6817388d3427161a6356f58d1198006fc3baa549455651479f589(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0d4259052673ed2d124e5a21d47bd17aac4f51334ac5a619d6d37a4d2a4420(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7a86decd0b07b5673f9b365d344b3a63940cc3792adf72a0fe342f2bc38341(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89117a8f6228b8c1a9fc23cdde1a54b89d0288089a9d52e5c48680771d9ed4c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ccf057d59e875ebfc1f8f87c0a384b871c80a052f5120d18ec842268aa0c0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fcc989dde6f5e6c211d2cf64c5fe190db2d64ba66800d445acfe40eea7ccff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93abe5fdf8d1f314491be5e039ccf75e1bf3f6a23d1508e08f425ef870d2d185(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bf010b4d3096f4d578d22f67b2a257334533705498379f6499c9168e703583(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea6440d6a122b17544a8e3355bb7137e865c95f0bc50435ea7b9dd4b2f46bac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a252352c60398b4ec4ef8d613d51b95ec2b040a91e438f7734e764a5d4a03dfb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70d60633a1fbbfb1009f7098ae7050a96dc059ccf4eba96367aeaba3c106a0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14b297a09bbd0d187a24cfcef5ad7e8dba254ba5f63101774be8dfbd1aaa990f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec0aa004a5b55a7412d40873ed440b659bf88f143e8ecd518e554e19c1be11c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588f5d11859a7aab27d36b7c45e5dac75ac656f11d983d760dd6ee9aa9d3d232(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2095c8a4e0996d652a83aab6432d6c47768af782457971ddb163de0e55c0d41a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7b81c35dc19c721a73bf995112d5518c6bddc25199457867251379f95baced(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c42e6e46b70ed9aa7158168184bfaaf51e790b187583c99c7bf95bcd2a0a97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b4a077c3431ece2dc3f46474290ad951c6779c0140aafb3c6fe02cc231f2c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec43169c0672d825fc37c28108db5a1ece52598af6a1e3e9651972bdbe1a2478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253a950828d2c9acebebd15dd815e3aa96bc53978a3538e46db15471418395fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92341fbb19b437df6f0f6c07f3b4ce064454be6c0c58752a2b3d87aea2b51c88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6950e614b360a71a90a4cde9f410f2632ef370d7a4d0f108091b15e47d297af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaca75503c2a924e025351e09451df87d77d29f1a4382b8a30f36c9648ccc9d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd62b5def0c9c228277cc7788ff69c47b88c47b50fefcff8aa01ed9e4ce4e39f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f8d536c216559c5067e9ad6359b4bd09030eaf857d7a582bc7dfecda709fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045e864e23255bc8118d54d5a5dc48ef7be0b6a290c3ae41bbe5fffde165921b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f4b81af90bfcde5ed9931f0a976e9aaa6b7bf6548567c0fe809229fa67de34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568f55b91961405c466328212266f9b299733e221d359eb11b54b5aec9076063(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49b2818a1892437476abfdf3bf6eca249372d740a5efce8e4d547aea814d6c3(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a1c860d162450b34bd6e0b1db5eda9bcf933e828c0e1f425e3994b31c8e1f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1b000fa32b6361d44baa9c63db8fcb752d443269daa65cea45c5ca2d87727ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a594fcfd235a2032e948972f2c8e6d05e612a770d4d1feba0200a33255eae360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa0f6a0642041dc0e52f712a5b9bfda9829b438e3e2eaf6315190c00191ef49(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6f86ddd80cf8c6f7fbc8bde92d04694a52a9f8a8e8c08d4b1d7dd58f8c9259(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898f45a8175eed1e1ad83e673b065a5cd55909efb7e614613f169e8b79170b7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2294fa24e1c34dbe26db07044782686d57b81f317cd990c54bb5389d712232(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__259c6b73144a1f39c0b9f9b3b06bbd9803d095c4186cc00c9f96bdc82136fd19(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c841bc94dd9a8e0eba43f72ae679ab969f333dfdaa98e309963e5445b62d25d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d678bd113359f3d5820a0a67a14edf88cf88ed3fc3079ca7fe9de76c3b4c2d(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7c2bc9d98b014c7db63cfe2bd1a35615a6c8e779014c8a004612600085b1ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023ceb4007b98799a378749d59a8b340b548c6682911c4fcd023acab556841c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a06eb4d531158004d3f332eed793b0748e620d53d3dfaab16a601946061753f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51edf1e4763af80b6047b48da0d2db3cf8ab4a7f1615ddbe6261a31e53639b1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad417e62672ff4b8377df15ec8546e348c5fcdaf78395955aa430e3ee1bca1cf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__462b358fbebcc065d52a96d374783c0da42bb6032271fc88e51cee6de493680e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1df922ca9708ded12f357cfc0de941b86a6706750166885b20ec7eb6d2c0960(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f8a357f11617cb8fe2ce39983cf7534c065a899744d40b2cb0570affbce71a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4455d826e6fa173405b81f1ef6f6df123a5ddc6153e60f1d4b481e746a16686f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5291861d03c7b20bb5135c914ddd8f2f606c4c94e7e68920a3e226c3c60c3091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada5e3033936e436358a983c55059f99c1c3e2f411d24b354f2d6dda48d7bd12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30f91af5c9e0ff35de2967054091271a0ffcbf0e117ac9cc0910141f6625f7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c58b0ebb2048a4c9991b89e1c8ea4f6d64a9cdc21588d5815719a7f44b32ad(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b0a028b5a1ae0d23b5399e6fbd32e08e2776b4cd097bd63ea4daa0b8d55a17(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f7d29a60c1d4e5d2a6cbebe3ead09fc4cd67ec6066275b704377537533bd726(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e50cca99063d996f7cf97b126b142c0ddab6863c5dd7e9f2572d27e023510f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65974dc013e59113513d2ae774694380255d38632090cf1fe5bceac0cbe4aa6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99bfd7562a5b14a022c37b91da882a31f4b609c54e1d87f7055ab901b2a60b7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b267462decf048ab5e7f2073afd06e7731ff4b1e4cc9d62f162b79693291dc60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0b4292a3833bd6b7d34e0ae39677967584fc9ad265dda6d66b8b3e77a9a418(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__483ee486b5ff1f899dd5f2131cd5d0909acb611745feb8f02f0dc213617e2b0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac124091df390016a2c32bc4bd3b99d5828d5d922e16eb8d98aada52f8fee3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed1a008b50b7011cd051f5ab6b59008f836b6fa10e91b46ba7a2a8a199a5349(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51c53c910684a0c49c0da83c76bc403de081d5faf594516fe6a9dcf25d94cd0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881b7d6c7de65ebe6ff02224084ce0c6d3f63b0cdeef522e1e6a9366e0d7385c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d113aa6d34dad46c6a2f8ec4ff2a9b96cdee56b92a888745bfcb0c65bc0ef7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7feee3042f48968a6821d59ff3fc231219232cf05b375724b199cb2ece1786a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45014e105cbd314c494f0b3e6c8ff69268c32996f51cbfd7af52fb270d325f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ca95d56ab374586bbe82e642d933ebb9cde9433d37f236883338a66afe28f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45bb57488df937144310927fc37d9a5b9600c45de6fe1192fc84148b79e65530(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5028e70721f791f63f374a83dc45fdaf3ba08ea0547e112722253ad898c68f38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33728d37c3e5d81a5790919a3f3ae29cb9e3fe6ab79086dafe2f9fc7c7d7b670(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710a8763394a0c1e9f30957c739ce2e2df35c548917141f577b79b4bf7af5e06(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9befc9027ea441d5823bd7aca0a69b6f0a2ffcc04d9cd9ad525cb402fac7a07c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cafa49696ae96932a992a972833a6206e1e76baa244ef0fc41986fd223fa17b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc043524e8bb781717f86887d743cc0cf188c7ddd7c5aee64a58af29cdbbaec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05dfef1a40eeba8563d5b5844d89039be24f67f24689dfb947fa19249c59b528(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83265f66156bd4c86e50949c0d4ef923f8f9b2b6a964e6ca19ac5fbb3c114b5b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83efa3045c162f32d50fdae749d68ffe8678ce6ebc390594aed3e1f9fd23533b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06eb6436545d384db3c3071a8bdaee7bdd407272c8f64a945635ad85474d1006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ed9e64e80217ef6541b9264352331ff9b8ceec5efcb6ccdf089f270244d42c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7735c2c9e86f2ee2c5b11d232277a3180a40068437ccccc8f534389d9a89c6ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95f469f7fe0d57431837834ce07c239ed41116f0850f8a1deaff4a8a5639fd1(
    *,
    circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
    union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7302f403465da47e3d91f9c79986a2661b3059e5233099e357b727cbae23e963(
    *,
    center: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter, typing.Dict[builtins.str, typing.Any]],
    radius: typing.Optional[builtins.str] = None,
    radius_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4263de66591d3a88a85b13a841355a347e389606a61a5ce9257a4100d47c24(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04e1ddbd60845243aa04e35bfc19b2201ece3a95f45d52b7f096d1bf6bc0e5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f0d17980cc4ea840a1513aaa7bc2df2d45e02b6829688aee35a185f3d63c2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075cb47e95dd485f05ada464257205b03da850200ba936c60b761ec3d77b47a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c32c3862f370315b5f03a9b6fc151409fbbdc37ab1d7a16cea3452367284f6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93792fbe6db30884b2bf8ddab71c86163e0597461e9e38bff74c85a29db27bad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a35394f955f191275a1f3cba479e6a9d6b8729164a2a9b0df596cb6473d65b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a1b8f4cfb53bedf8b624693ced09e289a6950a1a3910c6c9552af93d2015a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab54c245bf4761510dd94eb506a0d620128bb07433c540abad7aa01d0258721(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5351e4223af23ea60e4b4be556a0d57c3b7ed5736806acf4349ada233728911a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa75aaae51a506ed4c6ebac27490081d6384968261ed68ed142be654c15c086(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc805d0cb89654dde5c621f4062548256d3991209af46b01b398291df217c7f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10b8c1e8a51454cf72d3c8ec589e2f4a5c4dc3d6833de784e88663127232364(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9285df640c778ad4100ce68814a74fbe6f89b50a43fb9c316dac339d7d7ec803(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91016ca5409c86607b06ab027ac981d762b576de4fd281a1fef0e226de5e4fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976a63d451519cb0f8f29543158411b627418325d4288fe408099bb681c47a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b48b42081a79b486b9f95ccae25fd1d3926de9e2b8a2223520c6545f9dcc24d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c47f612685a33459cd15c24822a3aca12af145740fc993ed359c864234bec2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02adc51eb5c93d2fb58f3c7132f41ebe89866a5d21f04a31ef999b2e5599885a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41cfafddca97dbaac33dc98f89bba506328e3563005ce648b8559b54b01689da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b106b0c2a35ea03de5282825c7e9bd19e70d137d0e1fefca9743deb70538570(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1377befbaed5f4cd8359bdb835a8fda054487b0a8c53910f9eec2aa05ac496(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c08631b801c78256f4ae683371d00edcb59a50aad90812a21356adfda9d240c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04cf1a1544c36ef184cca6b8b21d062ddfc14ad98bc07c710e54d377dc206fb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7432a6cb09564bfdde9eae03c5ba763466719bdf4bf86c7164ed7906f31b9950(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af14cd79b34f7091a9012b4a55c0f24f5f49f272391e91dfe721590bb873a0f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70d2768d579c8fa6402e833cb5d4b38312abc2848da5aa7fd07ea444880ec0f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feae94da58e1d81f10e1f7dd57f12d33d9f02b78ebd73831ce182ea092eb1442(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0777ed7a5125d9d479f371991e33662b7f153dc5d0a2af1036e81b2d5bc93641(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89da7ba53abe3ced8d03ad1e6bf84d266297e206c33f593dfb85dcfa99971859(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e615da7c01a4cc473861d9917565cb444b1ec11509e3e306876a19a0d69304(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c4c1bd46d622b7cb201b8df63bd450a3a30b4f72534633be769d70b1860764(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40a589fe5669ac3186312ae7bf0d85cc4e7cd21552b9fd43fdd08d1d2762180(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5e86e1799333c928726d312f87beebdce13abaf966f96b9b60cbdcb4791ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec857cedd32c037e19619576a8ea9500ed6237b8c17b9ebf7b275c7200ec2ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577873e0c0330779d58c21779ebb4b24f7396613057085ef61d992b024615a0f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bb19bab114e5a6fdea00ff56a96241808cb330e7e74b8a9c5222e16e2ccb8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52c14afbb00d5502412a7eb65e2ce2be4041a88a9230002b406b349d8fc408d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa6eb6a39c7b39db67fb897490c454d50b7e6ff749dbb0edb13ba330a8fd826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4140449d8de027f06b2347f29b4752316f25503f1f2d2a3be92fc6a33096f1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3931c46e47f7aaf1b916afe7c3deb74bcae39314b5b5ffae3a61b24c4ad76d55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c0289e5ee828a869f149eb05b7bbf218b9dd9ca04727a77369a2a7882b950e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4728e6b252a63e179b571e425b8df5030cbb0b375910c0144c37761e1e637ca1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be290c1fef5319c7e8e4cd1d8671007d0e4fe7f571ea98fe1c9add0b6ce98a6(
    *,
    points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fd9dfab75c42b1286276450bdfacf54fd10d585ac71f5d8e8ddc16d84769e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0edaf95ce342ced957a384db0c680c8ba0a1263566423f62b76b501b1fc5fdf2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb371255734877a53b5acc9c0cb6e712584ac202961876507f99be72fd61707(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a417a4725a960ededd51849ecffbcb90b81f7231f898b73983b5f45999b4071(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec73b23ac194c128a071994184e3b7250c78ca08efc6f6b6863ffc87134bbbe4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bb8e69016b7d3b3b283a1d784111f3e4b2777169c5f588c2b9aac40b03d757c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd64a4077893d04a3cce6928cb60da1d25cf6c89d3281fcdacfe39c030bc81f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75fc092941b2d2866f34bc2a41798456924ed7f9b79eee944adc074d963e4393(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11855f55cccf7adc3ec9e31f5cae6a98f33131e4a0ccea09e2b1f05f5435e78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9287d825a00beb6e67adc28352e424d428b70ba7b6cd51307e3b3adeb43da143(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b7ce5ca2072320145ee011b75f692fbf59a0288119fd99c35955a83dfb877cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6219bdac4b07d9e6fc21c686db6ec6231757b3cce8172d4fe703b57c3c752c97(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca456d90a85e07024f812ae2180987255824dfc69beaf02965070a5601567492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__796dfb9c8804781ccc2b7041a72d415c2fa4e76e55f9e5338c06f861485bc718(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c214cf386f77d1b7e402f313c3922c24abd730cd7ecb06ebd3b62e32bb9ff4e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34bd196685d31d198f338357b56a2e874f3e6318d2e21f60e97c53c5b191489f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5ec11d729a67805e4cdf94a98e4c463de5cdd297af19be021fd6c91392f4fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df38978e88034a570e784dde6d44d2d1d4fc7d86fade4d15e0085c19764b63e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b843de2f2e0e25f51cc39e468db31ec0d2d4ac3e9fc6d592c65aa356a5a4dd06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19cda8205b4458da649fa6b410f3a7477bcf99bffc80a37f4899f3de4669670f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102f4b45e65fc9ecea712071a8521f9dae42f47148e965dc2c955cebd8b2063b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d064f425ddc414af1dbf926d83ab2ddb535a34b94165d74d467fd7a4be23f07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e52b5343447d0c87dbf1a4479790e4ea74c2d1c0274679a1b222157372d6bbe(
    *,
    anchor: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor, typing.Dict[builtins.str, typing.Any]],
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be9c5ad9a0d14115d0a4577538e85404312d9f3823bc931e661ff60dc1a417f(
    *,
    x: typing.Optional[builtins.str] = None,
    x_var: typing.Optional[builtins.str] = None,
    y: typing.Optional[builtins.str] = None,
    y_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__682df7af1de20945da0a662305e77d4e26d37b13dc5439877a754acf1766914c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223aeb665ee9cf64d969f138decda7e35fd82a129285f38a2a7e2349c62c9856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763b7c394bdc88e20d16de9ec3a38c8e05879c49c59317c94719f3f2ab5bce1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09b218652ba5c5c2b78cd359d69122ebfd9553e162be29437258eb8e410920bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9afac9cdd280d77f60f2fb81592a2d95ac1ceead3e2ec5792832e9151ad777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d78d2f1ca7757e20223c272b27102c2703150118da7d61088e3be4c0ed8cd33(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0016c99da4ab158c98a15f2d7b7dcadbf782f9392169dd7d9a37e2d123083a00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e5d49de262d368d53fe053ef83e58ccf4887b6224f8c2b905d6272650b21a42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d404183983ce4649c1d1394f958c2be7d3461272a04014a4de52f4bff145a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f87546a8d0327c83bbe9842180d985f6c51214bb5550968a322744e97de3844c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95b7b113cd643f3418f285a15db8f136af84ff434e186593cb6ac3c334a2522(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a292a9929a2540f9d12e471f1336b1f7faf787a10dfbaee5fd5ae7a99488c256(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05611bd1678d84bf4a26c0b8cea316bf86250fd6028d880e27e27db2829dcd7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a32532a328bb45e3ecda7a748c42e3f8c951717e83ef1a53f25afac7ab39a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120d4db379df39653771f333c0205d29d70a73a7a63a83b953accc1e4b968ff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6300086d9d2d978e645fcf6c4082549f97a603527ddd77b63a2be60e8ef8cc27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33912cc3ac60b2287ff57c67a206950e03a1b399cb0f516e6bd1f549b96ce29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8392157b343159aee4efe671ae1ed804b35cc4a013ea713da94cbd87276980d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c03bdf0f9a2c728e1650c730cb258b46d9c84d48f3ac32cdd8824f1ec0f6da0(
    *,
    shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac01b17d800ccce295accf5bbbfd1d458e9b84d0b336a2b1c205be2c869c0c77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453adfe65f2f86b36834bf508b61d94a947d3750a63ed9770c4e85bcbd6caff8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be29612fa3e6a4e73d975a3bac8b9e8f91ba860f50ca9469859e101b865ea74e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089a1ed4e527c643e99acc5852c2c53e21ff8f2a1bf7ebc01ab1a3f8ba213670(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719fec3e2d6834d009c5299985a09ed810301ab349d2ebf5c6c8be16b65fec23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a79c4d3b7f3dcf73afebc0311f3ecc200db8962d2f947e5d24e183780efd5023(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__940fcb74d8d17716e3bba341f3c4f789683bbe34484d03f655b866bb841d4c43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06605d22cb4d1c294f70b93deb7d1951eaa486aa9462ddf7f62671e116da7644(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf7e37119f428ff7cde4c49ab76bb890bd9be95ae0f881cbf7e9bd526b316bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__005256edc4f641260ad935b5f10041fdb931a8736bc24a4e9c7f69b1b42812b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d5051aa2a5f910a4c5e6f126cc34bf08e79adc76b39cdcadb6b287044ce817(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aedc7113e3eb4945e7746848bc84aa127116a7f4c3dc4a4f8dfe39d3472c033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a41a4843965d289f4dac2485e3bbd9f8643d85c834c0f5c7b31d85733c624ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c91235e3e81472696df9f4119ea7050941c657dbf91215bfa7bb699a3abc224(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10bac6862dbc584ef84c353b9e569a660b36ecedc0402ff55f8f2ed0bf9b2a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2181e96c9507982144bfd34756caf21f21dad44efd19b79804f9eae5b62fb50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5e32f69fe0e6c788daf04eb8c0cfbd4044b17d9178a1e13422156b6abd7d41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7e47957ee8eefaeb96c4ad851c00ee4c1cf92ec09a80210da0f641f237655b(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3e0f35ae24812c538432aa426cd8656a7a5c07766c262290121537376cf349(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13086844d8a4761451b2bb44e173b044263aa792c790e1ea21c48c85e59d031(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c96d2f8863795d516a04158054d8e60ab556b2c23140c7c9dbbecead3d3375e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40cb2f5af6e0a6eb4fb2861930269d9d5914bdf8edaecec4f58deca85b28c5c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29108f5dd986d2df91af93c53fa2ae24e89cdd7647b7205cf507dd73c316f51f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ee3dc617243ba43068c205f3ae058a6f83c3ceedec593cca4d15e7cb3121b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e46acdce16d737aea3a1e51dfc150c57362cc9f100be2b5591605460fd1ddd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df06301e212884515625d66875e7536fa0d7232b5d3f8d2e8bca3e99ecfcf964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a28adb51dcbb69e6340d184e0c804a08a36f880100191820493a81bc7cb0949(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ed8cb8d7e132982712f63cb4e2abc1a29018a8c83be6d44bc3000ea9c4a6c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6d6385bc4cac1d2395bdd344a541718222a93960d80dcbc297b175de1048c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed4edf8931efe62d25936c23e0be89becb0fd2ab6d7112fccc6296b1e75c915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912165329def9684cbfc8aea3eda71933dca2959bf4b4ecde4dfd8fc51d67464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf976aa551e0d730ff376a73777faa5ca7cab6ff9fb1dbc26b3a1d1b455138ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab411c29ecb23fb7070542deb52e112695fcac68aa653c59a24645c80dc7593e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d46e33107cc358542afbff701308411b3414402d67c72197c33cbac670a705(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10143cc4749f3c1ecea820a6f930f0e7d6733fa86295c08fbe8834aaa51f8a56(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ee2a5f33d181952ae1c6067cbbf441c95d10520977c1e5f2ac7b91a8ded197(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbcd8786cd5a537532e2ab7b658670dc017d6349f723c7afe6c7de8c6bf89d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b3bf5904f2f08433b533b3f993710dc389b8f38cbfef229abd7ff8432f9f33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5288dce7f0e4951a340fe187986f5b4e6a364612aeedbd10ff2f29013947808(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014ef7c2508307e90fc2f305d0218eb72cf635d626807ffb8088e7b3018fc9a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426ea3b44ac6fa55499bd17f1634609e996cb68f41706bd1e6e62c100efb634e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e480e549690a21f11edb4f7425e7bf8522631eab1e0bafc2cf22ae35d1b72b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11436940a5630142eba1e3a635beeafc270b53479045eec4a56bc78b867df18d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ee8e769e0d79be6526e6dc714ddb565433e776e605c4a2e4ab633f732b958f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd5d8c51abaf53e63fe681e195fc07f176c4e86531abc5fd584d48e06bf5d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79cdd3a8444187c48232f1af38572fa379b20bbb879ae5396e3e9e5519401225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91be373548e25d1a472a4a2a992f94b4d5657dcbd3f16485d796b687344f15a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e33988177fb8106c6eb1f93c9d759ad269040f632c88fa57c7354de953cf397(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89499fcc6c319dc908c4043fdb8056e0d3cb3c180e03aca81a0ab3e6ff5f9376(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf28727fa0a2fa107176746bcb1ce7baf7ca50aafa76c03bb83ac05b172e8b3(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d7408aa807b76416031566ff70663c363c3407fd232f02720f863523233fbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f132156ccabbae2eb180d0750dd86d32b609b459f323ccc48277ded972e553e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02cd2db0f254a0a00b0541d0c141a762321bc717496fe03f5db9bafc410f245(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c0cf4d07b2f89aca65da3d87d2aa0bb0c3e5b119b866001c7fefd4498b28af(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821e4c0ea419483ba23d7b42e65c0879ad2be4d5f0b0d3409738e9cfa0571430(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3d94071a19062f4199a961a3ce2c4f30ebaeee95e8fa063a86daafd5804692(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd76206015bfe94fa7ab14d9e2f9dd9d7e4b2d56f4779ac3f6661faa2201dd53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3191b96de6ee27329253151625d566c862bb442240d75f6aa6911728f9b4b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd3a9c8fa3cfb6b080d07b66083a3491751d867f54ddda8d8a489497bf93106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9751d9ce27b9d5e13079e91c74273ab11b9148a422c8a8cd728c05caa6a82e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fe8a83cd2d1314dbba9ada09fdfdcb20826ed162095e4580e9e5c487eeb902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915ccc0e6b95c3f178779cf31d202a4a4de98142aeed9d77913139c417902374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737f56d9c0017e2f25a3c03f1df780371d07c00c7ed5a7cd7f5aba3386e11eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3367ee52d0153a81c9b48db8ff57e75048f924854addb0639da28252683d7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7816e3262e7bdd46ea72cf5c0b4000834ea50ab81a603ab33ab31eca95277d37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12cf4e253e012a96e41c78aa63e9595e9a1613c56e72571d1c13cc1150ae520d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93ac540e891a8630059632fb81b81367b3ce5dc058afaa8d53f688082f0b3a3(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b8736db9d48ec6e5b150b17d987bd6812ec3abbea713803e64010167a4b2bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370084025443e2a59f8565d7da764558cb7f0ec3f1e0333e7f4c9abdd60807d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90996d3c5328c1b7bb59a425977c2e7c63cb64f21eb22bc2e3470a9bc2ebc49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0eed55232c9d405a579aa371bbb4867cfaadcd75367263b91e2431c538212fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2adc8db86f866be241fad66deb475e4f73f47bad1ccbcb4e45ae0578c6c75d5e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae8297e54309d390da719042f98711c540af7e632bbf8c799c84464b0057e1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df35629ca223b6f17131afacf70e7a6318dbfdc779127d675d0654305064a7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddbfb8cff28de9b6fdf3ba74c8160879c7d43e3443488224c5b9d0619006e680(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d1f54f748a55488a8ab305c931c3bbae85a8f31df3dd474d576e88a32044e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b5ba404eeb9ac2e2db4d00c9b7eac30eb54b6a0ddb4bcbba148cde84ba67ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef7c0d59cac147e10369ea8f6e6b0a411dad6d2b2be218eb3ff9043f7efd51e(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__decdb06d962f7943d8e8151ce4cf50e807cc65bdcfa284fd77c15e841ac1665b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f2985fb91f134666e1e31f9c9b5e16cd5e10d7d9a6c3b221e06ee68cd9577c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b57f024fc00e8c5b1d40fa8fdcf99e1e79003b12b728993afa7cfa295f4112f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22870bebbb323eec5f15fa2575570dae7c09ff3eb6afef635732bff4ae860b87(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b04844515954a473782fb2ef5fe778576bede8ec21bc78583e0e2854f65d26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ed08a568047d8d74085775b7e2535198e2ae13fd2756abe086cab1dfe8f8fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0484ecf42f5a6ec9d95c18361f4e0e74947b56fdbc5bea17239c8016057f8f11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84319c4e6fd17b03108f1dae95ab22fc5952618f23d8d3da2568c4e21c48704d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224f1c9a574da114c0aab0867ebf58755cde59c3714c50777a9fec4aa3554510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ef58714a15aa84ebdab532b112600a5cace8feb772d56e6d92932eb9bcd3c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a04b81fc6edcf3bcd6af26ce296d8f972d60579c8483da5c12c5ddc9c3c6873(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69b5a6cb96deda7940ecb8b9d748d762b10c6a566774f9b71c93141916cc76e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7154d289a8b6e5bfd300a2b8bc5c85013d4c92af234080f4afae285bec2cdf(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3657f2f5112d5385b5004f1231b0eaebbc7be55707aca7a3ade850986c7164(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacbead6639cc9d818334e0ee1c3ab499001d72f30054193de5a0d5c71cdf836(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5dedf1d722f9eddcafe9777115f5b0ae1a3308c3ba2f0a6b43a399ad01dcf1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d22a80a0470bffe33eecae67448ab1a6e10347bf8f4033e973453bac867cb0e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e944a5b636a5348a8a73034db1377b5defe6c923817b9eddb82aa83dc9f64928(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c160ab06561206929d2639f6d787fec013cccc8a7a5c7a514fbf307297d825e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7dc6a0ca3a74f4ab44555118905486c53a42a89888c640a70514fcbc6cf08e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431bf6fa679a9004df4fe4e74b9c6f3d271e00e953433219c53271a92bcd120c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913a5b44857240b3d401ed8011f6a8337b7889fba2bd60663f1804eb4b112d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12213c6f10b3208b8b34b55f8e600bd6982ec25058603f1f2f0a835c9a962027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3596545ede68bce94da607278210453f8aa7cb76d335a22572a4b894cc6bf838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc0971b62382e07c1a75d5505151757b4e2e6d3b5f90b7cd58bb1d7bf95339c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37259416347b90203c3e23a777282298b1a4137c9c1ad3d077a5353719092cc(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d505d4e1aa8e0bbae95e4414dc2c4d8d64ef823b393866406685f99574e3d2db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67d0e57cce559fd780b6b446b632bccb2d8d7cd2dae386aa2e020bc24807ed8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e4f48ff6dd91d9d04f35b15317cf1dd390cb2e59930b8b6aff6da79c04ebbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d4d75b3132f2ed46303f82b9dd6c6c89b42c58e72a222c351b6c1775a388a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0fdb38f4495f32ba30877cb247bef169b90e0a7df2880139daabf4a83e0c5d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf1a0274b9e8562210aa7acee303edb9dd2890be9ab4c684b9bc44cc7ba78e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981a077fd8adccc1d5f56781845edf3d95549a7118425a9473d16eafc64faf8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae1248f4f8f7364e9eb5b7961ce6a5f499f08679971fe58d13cca62c86f59b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4ef6807ab41bf9a8abb903b2bc9938270f27f578cf7892afba027eb9eba070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5cc21fe58510031ca975d4244e8f74ae35762a0ea3d68c9e536177b866d82d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd6a85e4493be42df92c1ee4100834cf41e0aa9691094d96654ad5ed3030dab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4567d71fc6ea4ef3352d661cb71bc0631ffb15abf88b9447371abaaf4d944ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eadca9e361a87b7aeaa7f87892bde54979af50e4bd87901a29d47a7e6e1bd0c5(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ebc0c4b9a492467ccc083e8b07042c092ab68cf9709e1b85b6a4f41aed25e63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865bb719c53aa99cfa85cc554505fd2b199bdf49072eb204683bb1752c912929(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a97f735e248e25c51bde70cd502f509964f5ff6bcb50a9e4459d6a0e71c5ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087d6ef699f4cc1057830c757a41ffb5214c3d8a5300dc8d28c6fa24b659fd51(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555b9ae4bd8cca5612025f7783189bff1f727a83fd8fd6d5945a7b391b73c1c4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2281c563f4ec9014ae8b6a4ac90f9a3fea04cacd19034483019a5d880b7a5593(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fd03d4eb4aaf3829a29af1b1c892f80f2468a40db7241284745a6bf9547b0ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241730431135e9211e5be73ec2e73ce8a8e73dcece3b026160e7cb0dd32c46db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e861a489107fb16737b6177a039e9c1cb6ab489bc5949de4ec69f0786f808233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49184cba0560c45b8e3bbc91bd168b7384b66390434c569d4142a4f45f6e8cb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b7540be9b390c8e1648734217866bd21cf25b29249258800047fd4d7f261d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c681abd05bab1bcbbb91f6dcba7d9ee4852cb87f47028d30bd70c6f495d39b82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2672dbc301519f6ff858b3e28737cb2516e1f03dd272620efb021bb0c28f12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63da1f8e5cd0aec5c8769483a15598073ee39400370c7f3d3d26d7b1d07882be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d7afb562856107540b81d7d43b9abd0c335a873e21ae39df47db3714c69954(
    *,
    default_value: builtins.str,
    name: builtins.str,
    type: builtins.str,
    enum_options: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions, typing.Dict[builtins.str, typing.Any]]]]] = None,
    postfix: typing.Optional[builtins.str] = None,
    prefix: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0000964f95ec6d851b64605e2562e52f9e11b393ef55285a75c2f90cf3f12bf(
    *,
    id: builtins.str,
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0a2231b27dff1c3c4d5604f25463322c92629eacc3e04dac2efa3a63599f16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ecf11df8f8924b47f153906bac77b22e6036b69cf18858122b86c3707027a2a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deea1f48891f4547300746a4687e5160a09dfa87c13697b59db396c2bbab1c35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b80cbfc229030657a9affcea79be3f596becc333583812ec1f94d69ca38a7da(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5381e46824ac67cfa62a3c643cc25f0cd9771218d0673b3d8647af7fc6839ce5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5206dc968ec67d27f5dfb9c2295dbcdf81753e34783e6ee767b9f4571a18eb92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a498e23f32932db7ff62d07450fd6c05900656247da3d944b6c517ebd1d0bf49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a02dbce9c6f5d8495edcd87240738d0947fab03046bbb89cf17b5b1a7e5fc97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a44bb0f3129791186a953ac5b4aeddcbc7cbd2bed049b25ea321787703c6ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c879aa13fe225524aee165dc7b3de464ef162d0ed6c214222c4f83113875189a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9893ae11638a9234239e6c03d014b4a805f9b3fb3c557e96fa99c35a7dbe1a29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d49607a09de8c428d566f066837d57a536be4507a70353e1420f0df94a52970(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fc61df8bc654f83b0bbbbcd424bf3b3179419a665379311880722a3f7a8d54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d53185411b65e3bd2cb0aaf3305336af634fd65ea8205d6b24c163325c24ca0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934abfc00ea03d7181ed9ca0c2270ba901b4daee5ba9fe35da4ab79d344aaa38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d21ff75834fde4aff85580702b8c85a5600e90c45f328ab0ca49e9cd89718b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariables]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f1651cc3a62bccec55384fa6aaebd3a74940aba765a74082623d9977cdc7e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d0ae73cdc54a0fb06ea166c0f139cc6eb8f70049df078d17c4ce0863cd6e77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e2d102a72f6e6dbce89f5b2c827ac83595db366ae9fbb8afeb6e9a49a4a73e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396dfabf2cd9185dfa1a13f2c5fea57072b965faa94831b26e2c8b2981e0c38b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22085b60bc5264850d9f5e955e3d35dc44fb5a74089229b9e36ba55ec404de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d29b7a2cb44b3303b33a3711828662ccd36dfcaeb3055864bda8fe7f0c5db9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508d1ce808884f3e565d336d9b9083f2b1e300c0898daf543f6b9f6269fe2b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3268085c2ae9aca47d5f7712d9eaf3069f8daa661eb23434e466cbe5ea21349d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariables]],
) -> None:
    """Type checking stubs"""
    pass
